/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* Global Instruction Selector for the AArch64 target                         *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

#ifdef GET_GLOBALISEL_PREDICATE_BITSET
const unsigned MAX_SUBTARGET_PREDICATES = 97;
using PredicateBitset = llvm::Bitset<MAX_SUBTARGET_PREDICATES>;
#endif // ifdef GET_GLOBALISEL_PREDICATE_BITSET

#ifdef GET_GLOBALISEL_TEMPORARIES_DECL
  mutable MatcherState State;
  typedef ComplexRendererFns(AArch64InstructionSelector::*ComplexMatcherMemFn)(MachineOperand &) const;
  typedef void(AArch64InstructionSelector::*CustomRendererFn)(MachineInstrBuilder &, const MachineInstr &, int) const;
  const ExecInfoTy<PredicateBitset, ComplexMatcherMemFn, CustomRendererFn> ExecInfo;
  static AArch64InstructionSelector::ComplexMatcherMemFn ComplexPredicateFns[];
  static AArch64InstructionSelector::CustomRendererFn CustomRenderers[];
  bool testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const override;
  bool testImmPredicate_APInt(unsigned PredicateID, const APInt &Imm) const override;
  bool testImmPredicate_APFloat(unsigned PredicateID, const APFloat &Imm) const override;
  const uint8_t *getMatchTable() const override;
  bool testMIPredicate_MI(unsigned PredicateID, const MachineInstr &MI, const MatcherState &State) const override;
  bool testMOPredicate_MO(unsigned PredicateID, const MachineOperand &MO, const MatcherState &State) const override;
  bool testSimplePredicate(unsigned PredicateID) const override;
  bool runCustomAction(unsigned FnID, const MatcherState &State, NewMIVector &OutMIs) const override;
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_DECL

#ifdef GET_GLOBALISEL_TEMPORARIES_INIT
, State(2),
ExecInfo(TypeObjects, NumTypeObjects, FeatureBitsets, ComplexPredicateFns, CustomRenderers)
#endif // ifdef GET_GLOBALISEL_TEMPORARIES_INIT

#ifdef GET_GLOBALISEL_IMPL
// LLT Objects.
enum {
  GILLT_s8,
  GILLT_s16,
  GILLT_s32,
  GILLT_s64,
  GILLT_s128,
  GILLT_v2s32,
  GILLT_v2s64,
  GILLT_v4s16,
  GILLT_v4s32,
  GILLT_v8s8,
  GILLT_v8s16,
  GILLT_v16s8,
  GILLT_nxv1s1,
  GILLT_nxv2s1,
  GILLT_nxv2s16,
  GILLT_nxv2s32,
  GILLT_nxv2s64,
  GILLT_nxv4s1,
  GILLT_nxv4s16,
  GILLT_nxv4s32,
  GILLT_nxv8s1,
  GILLT_nxv8s16,
  GILLT_nxv16s1,
  GILLT_nxv16s8,
};
const static size_t NumTypeObjects = 24;
const static LLT TypeObjects[] = {
  LLT::scalar(8),
  LLT::scalar(16),
  LLT::scalar(32),
  LLT::scalar(64),
  LLT::scalar(128),
  LLT::vector(ElementCount::getFixed(2), 32),
  LLT::vector(ElementCount::getFixed(2), 64),
  LLT::vector(ElementCount::getFixed(4), 16),
  LLT::vector(ElementCount::getFixed(4), 32),
  LLT::vector(ElementCount::getFixed(8), 8),
  LLT::vector(ElementCount::getFixed(8), 16),
  LLT::vector(ElementCount::getFixed(16), 8),
  LLT::vector(ElementCount::getScalable(1), 1),
  LLT::vector(ElementCount::getScalable(2), 1),
  LLT::vector(ElementCount::getScalable(2), 16),
  LLT::vector(ElementCount::getScalable(2), 32),
  LLT::vector(ElementCount::getScalable(2), 64),
  LLT::vector(ElementCount::getScalable(4), 1),
  LLT::vector(ElementCount::getScalable(4), 16),
  LLT::vector(ElementCount::getScalable(4), 32),
  LLT::vector(ElementCount::getScalable(8), 1),
  LLT::vector(ElementCount::getScalable(8), 16),
  LLT::vector(ElementCount::getScalable(16), 1),
  LLT::vector(ElementCount::getScalable(16), 8),
};

// Bits for subtarget features that participate in instruction matching.
enum SubtargetFeatureBits : uint8_t {
  Feature_HasPAuthBit = 6,
  Feature_HasJSBit = 8,
  Feature_HasComplxNumBit = 68,
  Feature_HasRCPC_IMMOBit = 88,
  Feature_HasFPARMv8Bit = 7,
  Feature_HasNEONBit = 5,
  Feature_HasSM4Bit = 67,
  Feature_HasSHA3Bit = 66,
  Feature_HasSHA2Bit = 19,
  Feature_HasAESBit = 18,
  Feature_HasDotProdBit = 2,
  Feature_HasCRCBit = 10,
  Feature_HasCSSCBit = 20,
  Feature_HasNoCSSCBit = 32,
  Feature_HasLSEBit = 33,
  Feature_HasNoLSEBit = 96,
  Feature_HasRDMBit = 16,
  Feature_HasFullFP16Bit = 13,
  Feature_HasNoFullFP16Bit = 85,
  Feature_HasFP16FMLBit = 4,
  Feature_HasFuseAESBit = 79,
  Feature_HasSVEBit = 26,
  Feature_HasSVE2Bit = 27,
  Feature_HasSVE2p1Bit = 45,
  Feature_HasSVEAESBit = 29,
  Feature_HasSVE2SM4Bit = 30,
  Feature_HasSVE2SHA3Bit = 95,
  Feature_HasSVEBitPermBit = 40,
  Feature_HasSMEandIsNonStreamingSafeBit = 58,
  Feature_HasSMEBit = 51,
  Feature_HasSMEF64F64Bit = 53,
  Feature_HasSMEF16F16Bit = 61,
  Feature_HasSMEI16I64Bit = 56,
  Feature_HasSME2andIsNonStreamingSafeBit = 63,
  Feature_HasSME2Bit = 60,
  Feature_HasSME2p1Bit = 65,
  Feature_HasFP8Bit = 21,
  Feature_HasFAMINMAXBit = 22,
  Feature_HasFP8FMABit = 23,
  Feature_HasSSVE_FP8FMABit = 48,
  Feature_HasFP8DOT2Bit = 24,
  Feature_HasSSVE_FP8DOT2Bit = 43,
  Feature_HasFP8DOT4Bit = 25,
  Feature_HasSSVE_FP8DOT4Bit = 49,
  Feature_HasLUTBit = 50,
  Feature_HasSME_LUTv2Bit = 64,
  Feature_HasSMEF8F16Bit = 54,
  Feature_HasSMEF8F32Bit = 52,
  Feature_HasSME_MOP4Bit = 57,
  Feature_HasSME_TMOPBit = 62,
  Feature_HasCMPBRBit = 86,
  Feature_HasFPRCVTBit = 14,
  Feature_HasLSFEBit = 34,
  Feature_HasSVE_or_SMEBit = 0,
  Feature_HasNonStreamingSVE_or_SME2p2Bit = 41,
  Feature_HasSVE2_or_SMEBit = 36,
  Feature_HasSVE2_or_SME2Bit = 47,
  Feature_HasNonStreamingSVE2_or_SSVE_AESBit = 28,
  Feature_HasSVE2p1_or_SMEBit = 59,
  Feature_HasSVE2p1_or_SME2Bit = 31,
  Feature_HasSVE2p1_or_SME2p1Bit = 46,
  Feature_HasSVE2p2_or_SME2p2Bit = 35,
  Feature_HasSMEF16F16_or_SMEF8F16Bit = 55,
  Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit = 39,
  Feature_HasNonStreamingSVE_or_SSVE_FEXPABit = 42,
  Feature_HasNEONandIsStreamingSafeBit = 17,
  Feature_HasNEONandIsSME2p2StreamingSafeBit = 76,
  Feature_HasRCPCBit = 87,
  Feature_HasFRInt3264Bit = 15,
  Feature_HasMTEBit = 11,
  Feature_HasTMEBit = 9,
  Feature_HasMatMulInt8Bit = 3,
  Feature_HasMatMulFP32Bit = 94,
  Feature_HasMatMulFP64Bit = 44,
  Feature_HasLS64Bit = 83,
  Feature_HasHBCBit = 12,
  Feature_HasRCPC3Bit = 84,
  Feature_HasGCSBit = 1,
  Feature_IsLEBit = 74,
  Feature_IsBEBit = 80,
  Feature_UseExperimentalZeroingPseudosBit = 38,
  Feature_UseAlternateSExtLoadCVTF32Bit = 78,
  Feature_UseScalarIncVLBit = 37,
  Feature_NoUseScalarIncVLBit = 91,
  Feature_HasFastIncVLBit = 92,
  Feature_UseSVEFPLD1RBit = 90,
  Feature_UseLDAPURBit = 89,
  Feature_AllowMisalignedMemAccessesBit = 93,
  Feature_NotForCodeSizeBit = 77,
  Feature_UseSTRQroBit = 75,
  Feature_TailCallX16X17Bit = 70,
  Feature_TailCallX17Bit = 81,
  Feature_TailCallNotX16Bit = 82,
  Feature_TailCallAnyBit = 69,
  Feature_SLSBLRMitigationBit = 73,
  Feature_NoSLSBLRMitigationBit = 72,
  Feature_OptimizedGISelOrOtherSelectorBit = 71,
};

PredicateBitset AArch64InstructionSelector::
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const {
  PredicateBitset Features{};
  if (Subtarget->hasPAuth())
    Features.set(Feature_HasPAuthBit);
  if (Subtarget->hasJS())
    Features.set(Feature_HasJSBit);
  if (Subtarget->hasComplxNum())
    Features.set(Feature_HasComplxNumBit);
  if (Subtarget->hasRCPC_IMMO())
    Features.set(Feature_HasRCPC_IMMOBit);
  if (Subtarget->hasFPARMv8())
    Features.set(Feature_HasFPARMv8Bit);
  if (Subtarget->isNeonAvailable())
    Features.set(Feature_HasNEONBit);
  if (Subtarget->hasSM4())
    Features.set(Feature_HasSM4Bit);
  if (Subtarget->hasSHA3())
    Features.set(Feature_HasSHA3Bit);
  if (Subtarget->hasSHA2())
    Features.set(Feature_HasSHA2Bit);
  if (Subtarget->hasAES())
    Features.set(Feature_HasAESBit);
  if (Subtarget->hasDotProd())
    Features.set(Feature_HasDotProdBit);
  if (Subtarget->hasCRC())
    Features.set(Feature_HasCRCBit);
  if (Subtarget->hasCSSC())
    Features.set(Feature_HasCSSCBit);
  if (!Subtarget->hasCSSC())
    Features.set(Feature_HasNoCSSCBit);
  if (Subtarget->hasLSE())
    Features.set(Feature_HasLSEBit);
  if (!Subtarget->hasLSE())
    Features.set(Feature_HasNoLSEBit);
  if (Subtarget->hasRDM())
    Features.set(Feature_HasRDMBit);
  if (Subtarget->hasFullFP16())
    Features.set(Feature_HasFullFP16Bit);
  if (!Subtarget->hasFullFP16())
    Features.set(Feature_HasNoFullFP16Bit);
  if (Subtarget->hasFP16FML())
    Features.set(Feature_HasFP16FMLBit);
  if (Subtarget->hasFuseAES())
    Features.set(Feature_HasFuseAESBit);
  if (Subtarget->isSVEAvailable())
    Features.set(Feature_HasSVEBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2())
    Features.set(Feature_HasSVE2Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2p1())
    Features.set(Feature_HasSVE2p1Bit);
  if (Subtarget->hasSVEAES())
    Features.set(Feature_HasSVEAESBit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SM4())
    Features.set(Feature_HasSVE2SM4Bit);
  if (Subtarget->isSVEAvailable() && Subtarget->hasSVE2SHA3())
    Features.set(Feature_HasSVE2SHA3Bit);
  if (Subtarget->hasSVEBitPerm())
    Features.set(Feature_HasSVEBitPermBit);
  if (Subtarget->hasSME())
    Features.set(Feature_HasSMEandIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME())
    Features.set(Feature_HasSMEBit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF64F64())
    Features.set(Feature_HasSMEF64F64Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF16F16())
    Features.set(Feature_HasSMEF16F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEI16I64())
    Features.set(Feature_HasSMEI16I64Bit);
  if (Subtarget->hasSME2())
    Features.set(Feature_HasSME2andIsNonStreamingSafeBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2())
    Features.set(Feature_HasSME2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSME2p1())
    Features.set(Feature_HasSME2p1Bit);
  if (Subtarget->hasFP8())
    Features.set(Feature_HasFP8Bit);
  if (Subtarget->hasFAMINMAX())
    Features.set(Feature_HasFAMINMAXBit);
  if (Subtarget->hasFP8FMA())
    Features.set(Feature_HasFP8FMABit);
  if (Subtarget->hasSSVE_FP8FMA() || (Subtarget->hasSVE2() && Subtarget->hasFP8FMA()))
    Features.set(Feature_HasSSVE_FP8FMABit);
  if (Subtarget->hasFP8DOT2())
    Features.set(Feature_HasFP8DOT2Bit);
  if (Subtarget->hasSSVE_FP8DOT2() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT2()))
    Features.set(Feature_HasSSVE_FP8DOT2Bit);
  if (Subtarget->hasFP8DOT4())
    Features.set(Feature_HasFP8DOT4Bit);
  if (Subtarget->hasSSVE_FP8DOT4() || (Subtarget->hasSVE2() && Subtarget->hasFP8DOT4()))
    Features.set(Feature_HasSSVE_FP8DOT4Bit);
  if (Subtarget->hasLUT())
    Features.set(Feature_HasLUTBit);
  if (Subtarget->isStreaming() && Subtarget->hasSME_LUTv2())
    Features.set(Feature_HasSME_LUTv2Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F16())
    Features.set(Feature_HasSMEF8F16Bit);
  if (Subtarget->isStreaming() && Subtarget->hasSMEF8F32())
    Features.set(Feature_HasSMEF8F32Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_MOP4()))
    Features.set(Feature_HasSME_MOP4Bit);
  if ((Subtarget->isStreaming() && Subtarget->hasSME_TMOP()))
    Features.set(Feature_HasSME_TMOPBit);
  if (Subtarget->hasCMPBR())
    Features.set(Feature_HasCMPBRBit);
  if (Subtarget->hasFPRCVT())
    Features.set(Feature_HasFPRCVTBit);
  if (Subtarget->hasLSFE())
    Features.set(Feature_HasLSFEBit);
  if (Subtarget->hasSVE() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE_or_SMEBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNonStreamingSVE_or_SME2p2Bit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2_or_SMEBit);
  if (Subtarget->hasSVE2() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2_or_SME2Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_AES()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_AESBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME()))
    Features.set(Feature_HasSVE2p1_or_SMEBit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2()))
    Features.set(Feature_HasSVE2p1_or_SME2Bit);
  if (Subtarget->hasSVE2p1() || (Subtarget->isStreaming() && Subtarget->hasSME2p1()))
    Features.set(Feature_HasSVE2p1_or_SME2p1Bit);
  if (Subtarget->isSVEorStreamingSVEAvailable() && (Subtarget->hasSVE2p2() || Subtarget->hasSME2p2()))
    Features.set(Feature_HasSVE2p2_or_SME2p2Bit);
  if (Subtarget->isStreaming() && (Subtarget->hasSMEF16F16() || Subtarget->hasSMEF8F16()))
    Features.set(Feature_HasSMEF16F16_or_SMEF8F16Bit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE2()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_BitPerm()))
    Features.set(Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit);
  if ((Subtarget->isSVEAvailable() && Subtarget->hasSVE()) ||(Subtarget->isSVEorStreamingSVEAvailable() && Subtarget->hasSSVE_FEXPA()))
    Features.set(Feature_HasNonStreamingSVE_or_SSVE_FEXPABit);
  if (Subtarget->hasNEON())
    Features.set(Feature_HasNEONandIsStreamingSafeBit);
  if (Subtarget->isNeonAvailable() || (Subtarget->hasNEON() && Subtarget->hasSME2p2()))
    Features.set(Feature_HasNEONandIsSME2p2StreamingSafeBit);
  if (Subtarget->hasRCPC())
    Features.set(Feature_HasRCPCBit);
  if (Subtarget->hasFRInt3264())
    Features.set(Feature_HasFRInt3264Bit);
  if (Subtarget->hasMTE())
    Features.set(Feature_HasMTEBit);
  if (Subtarget->hasTME())
    Features.set(Feature_HasTMEBit);
  if (Subtarget->hasMatMulInt8())
    Features.set(Feature_HasMatMulInt8Bit);
  if (Subtarget->hasMatMulFP32())
    Features.set(Feature_HasMatMulFP32Bit);
  if (Subtarget->hasMatMulFP64())
    Features.set(Feature_HasMatMulFP64Bit);
  if (Subtarget->hasLS64())
    Features.set(Feature_HasLS64Bit);
  if (Subtarget->hasHBC())
    Features.set(Feature_HasHBCBit);
  if (Subtarget->hasRCPC3())
    Features.set(Feature_HasRCPC3Bit);
  if (Subtarget->hasGCS())
    Features.set(Feature_HasGCSBit);
  if (Subtarget->isLittleEndian())
    Features.set(Feature_IsLEBit);
  if (!Subtarget->isLittleEndian())
    Features.set(Feature_IsBEBit);
  if (Subtarget->useExperimentalZeroingPseudos())
    Features.set(Feature_UseExperimentalZeroingPseudosBit);
  if (Subtarget->useAlternateSExtLoadCVTF32Pattern())
    Features.set(Feature_UseAlternateSExtLoadCVTF32Bit);
  if (Subtarget->useScalarIncVL())
    Features.set(Feature_UseScalarIncVLBit);
  if (!Subtarget->useScalarIncVL())
    Features.set(Feature_NoUseScalarIncVLBit);
  if (!Subtarget->hasDisableFastIncVL())
    Features.set(Feature_HasFastIncVLBit);
  if (!Subtarget->noSVEFPLD1R())
    Features.set(Feature_UseSVEFPLD1RBit);
  if (!Subtarget->avoidLDAPUR())
    Features.set(Feature_UseLDAPURBit);
  if (!Subtarget->requiresStrictAlign())
    Features.set(Feature_AllowMisalignedMemAccessesBit);
  return Features;
}

void AArch64InstructionSelector::setupGeneratedPerFunctionState(MachineFunction &MF) {
  AvailableFunctionFeatures = computeAvailableFunctionFeatures((const AArch64Subtarget *)&MF.getSubtarget(), &MF);
}
PredicateBitset AArch64InstructionSelector::
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget, const MachineFunction *MF) const {
  PredicateBitset Features{};
  if (!shouldOptForSize(MF))
    Features.set(Feature_NotForCodeSizeBit);
  if (!Subtarget->isSTRQroSlow() || shouldOptForSize(MF))
    Features.set(Feature_UseSTRQroBit);
  if (  MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX16X17Bit);
  if ( MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallX17Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallNotX16Bit);
  if ( !MF->getInfo<AArch64FunctionInfo>()->branchTargetEnforcement() && !MF->getInfo<AArch64FunctionInfo>()->branchProtectionPAuthLR() )
    Features.set(Feature_TailCallAnyBit);
  if ( MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_SLSBLRMitigationBit);
  if ( !MF->getSubtarget<AArch64Subtarget>().hardenSlsBlr() )
    Features.set(Feature_NoSLSBLRMitigationBit);
  if (!MF->getFunction().hasOptNone() || MF->getProperties().hasFailedISel() || !MF->getProperties().hasLegalized())
    Features.set(Feature_OptimizedGISelOrOtherSelectorBit);
  return Features;
}

// Feature bitsets.
enum {
  GIFBS_Invalid,
  GIFBS_HasAES,
  GIFBS_HasCRC,
  GIFBS_HasCSSC,
  GIFBS_HasDotProd,
  GIFBS_HasFP8,
  GIFBS_HasFP8DOT2,
  GIFBS_HasFP8DOT4,
  GIFBS_HasFP8FMA,
  GIFBS_HasFPARMv8,
  GIFBS_HasFRInt3264,
  GIFBS_HasFullFP16,
  GIFBS_HasFuseAES,
  GIFBS_HasGCS,
  GIFBS_HasLSE,
  GIFBS_HasLSFE,
  GIFBS_HasLUT,
  GIFBS_HasMTE,
  GIFBS_HasMatMulInt8,
  GIFBS_HasNEON,
  GIFBS_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasNEONandIsStreamingSafe,
  GIFBS_HasNoCSSC,
  GIFBS_HasNoFullFP16,
  GIFBS_HasNoLSE,
  GIFBS_HasNonStreamingSVE_or_SME2p2,
  GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA,
  GIFBS_HasPAuth,
  GIFBS_HasRCPC,
  GIFBS_HasRCPC_IMMO,
  GIFBS_HasRDM,
  GIFBS_HasSHA2,
  GIFBS_HasSHA3,
  GIFBS_HasSM4,
  GIFBS_HasSME,
  GIFBS_HasSME2,
  GIFBS_HasSMEF16F16_or_SMEF8F16,
  GIFBS_HasSMEF64F64,
  GIFBS_HasSMEF8F16,
  GIFBS_HasSMEF8F32,
  GIFBS_HasSMEI16I64,
  GIFBS_HasSME_MOP4,
  GIFBS_HasSMEandIsNonStreamingSafe,
  GIFBS_HasSSVE_FP8DOT2,
  GIFBS_HasSSVE_FP8DOT4,
  GIFBS_HasSSVE_FP8FMA,
  GIFBS_HasSVE,
  GIFBS_HasSVE2,
  GIFBS_HasSVE2SHA3,
  GIFBS_HasSVE2SM4,
  GIFBS_HasSVE2_or_SME,
  GIFBS_HasSVE2p1_or_SME,
  GIFBS_HasSVE2p1_or_SME2,
  GIFBS_HasSVE2p1_or_SME2p1,
  GIFBS_HasSVE_or_SME,
  GIFBS_HasTME,
  GIFBS_IsBE,
  GIFBS_IsLE,
  GIFBS_OptimizedGISelOrOtherSelector,
  GIFBS_UseSTRQro,
  GIFBS_HasComplxNum_HasNEON,
  GIFBS_HasFAMINMAX_HasNEON,
  GIFBS_HasFAMINMAX_HasSVE2_or_SME2,
  GIFBS_HasFP16FML_HasNEON,
  GIFBS_HasFP8_HasSVE2_or_SME2,
  GIFBS_HasFPARMv8_HasJS,
  GIFBS_HasFPRCVT_HasNEON,
  GIFBS_HasFullFP16_HasNEON,
  GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe,
  GIFBS_HasFullFP16_HasNEONandIsStreamingSafe,
  GIFBS_HasLUT_HasSVE2_or_SME2,
  GIFBS_HasMatMulFP32_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE,
  GIFBS_HasMatMulFP64_HasSVE_or_SME,
  GIFBS_HasMatMulInt8_HasSVE,
  GIFBS_HasMatMulInt8_HasSVE_or_SME,
  GIFBS_HasNEON_HasRCPC3,
  GIFBS_HasNEON_HasRDM,
  GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES,
  GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm,
  GIFBS_HasRCPC_IMMO_UseLDAPUR,
  GIFBS_HasSMEF16F16_HasSME_MOP4,
  GIFBS_HasSMEF64F64_HasSME_MOP4,
  GIFBS_HasSMEF8F16_HasSME_MOP4,
  GIFBS_HasSMEF8F32_HasSME_MOP4,
  GIFBS_HasSMEI16I64_HasSME_MOP4,
  GIFBS_HasSVE_or_SME_IsLE,
  GIFBS_HasSVE_or_SME_UseScalarIncVL,
  GIFBS_IsLE_UseSTRQro,
  GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE,
  GIFBS_HasComplxNum_HasFullFP16_HasNEON,
  GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32,
};
constexpr static PredicateBitset FeatureBitsets[] {
  {}, // GIFBS_Invalid
  {Feature_HasAESBit, },
  {Feature_HasCRCBit, },
  {Feature_HasCSSCBit, },
  {Feature_HasDotProdBit, },
  {Feature_HasFP8Bit, },
  {Feature_HasFP8DOT2Bit, },
  {Feature_HasFP8DOT4Bit, },
  {Feature_HasFP8FMABit, },
  {Feature_HasFPARMv8Bit, },
  {Feature_HasFRInt3264Bit, },
  {Feature_HasFullFP16Bit, },
  {Feature_HasFuseAESBit, },
  {Feature_HasGCSBit, },
  {Feature_HasLSEBit, },
  {Feature_HasLSFEBit, },
  {Feature_HasLUTBit, },
  {Feature_HasMTEBit, },
  {Feature_HasMatMulInt8Bit, },
  {Feature_HasNEONBit, },
  {Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasNoCSSCBit, },
  {Feature_HasNoFullFP16Bit, },
  {Feature_HasNoLSEBit, },
  {Feature_HasNonStreamingSVE_or_SME2p2Bit, },
  {Feature_HasNonStreamingSVE_or_SSVE_FEXPABit, },
  {Feature_HasPAuthBit, },
  {Feature_HasRCPCBit, },
  {Feature_HasRCPC_IMMOBit, },
  {Feature_HasRDMBit, },
  {Feature_HasSHA2Bit, },
  {Feature_HasSHA3Bit, },
  {Feature_HasSM4Bit, },
  {Feature_HasSMEBit, },
  {Feature_HasSME2Bit, },
  {Feature_HasSMEF16F16_or_SMEF8F16Bit, },
  {Feature_HasSMEF64F64Bit, },
  {Feature_HasSMEF8F16Bit, },
  {Feature_HasSMEF8F32Bit, },
  {Feature_HasSMEI16I64Bit, },
  {Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEandIsNonStreamingSafeBit, },
  {Feature_HasSSVE_FP8DOT2Bit, },
  {Feature_HasSSVE_FP8DOT4Bit, },
  {Feature_HasSSVE_FP8FMABit, },
  {Feature_HasSVEBit, },
  {Feature_HasSVE2Bit, },
  {Feature_HasSVE2SHA3Bit, },
  {Feature_HasSVE2SM4Bit, },
  {Feature_HasSVE2_or_SMEBit, },
  {Feature_HasSVE2p1_or_SMEBit, },
  {Feature_HasSVE2p1_or_SME2Bit, },
  {Feature_HasSVE2p1_or_SME2p1Bit, },
  {Feature_HasSVE_or_SMEBit, },
  {Feature_HasTMEBit, },
  {Feature_IsBEBit, },
  {Feature_IsLEBit, },
  {Feature_OptimizedGISelOrOtherSelectorBit, },
  {Feature_UseSTRQroBit, },
  {Feature_HasComplxNumBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasNEONBit, },
  {Feature_HasFAMINMAXBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFP16FMLBit, Feature_HasNEONBit, },
  {Feature_HasFP8Bit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasFPARMv8Bit, Feature_HasJSBit, },
  {Feature_HasFPRCVTBit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsSME2p2StreamingSafeBit, },
  {Feature_HasFullFP16Bit, Feature_HasNEONandIsStreamingSafeBit, },
  {Feature_HasLUTBit, Feature_HasSVE2_or_SME2Bit, },
  {Feature_HasMatMulFP32Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulFP64Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVEBit, },
  {Feature_HasMatMulInt8Bit, Feature_HasSVE_or_SMEBit, },
  {Feature_HasNEONBit, Feature_HasRCPC3Bit, },
  {Feature_HasNEONBit, Feature_HasRDMBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_AESBit, Feature_HasSVEAESBit, },
  {Feature_HasNonStreamingSVE2_or_SSVE_BitPermBit, Feature_HasSVEBitPermBit, },
  {Feature_HasRCPC_IMMOBit, Feature_UseLDAPURBit, },
  {Feature_HasSMEF16F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF64F64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F16Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEF8F32Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSMEI16I64Bit, Feature_HasSME_MOP4Bit, },
  {Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasSVE_or_SMEBit, Feature_UseScalarIncVLBit, },
  {Feature_IsLEBit, Feature_UseSTRQroBit, },
  {Feature_AllowMisalignedMemAccessesBit, Feature_HasSVE_or_SMEBit, Feature_IsLEBit, },
  {Feature_HasComplxNumBit, Feature_HasFullFP16Bit, Feature_HasNEONBit, },
  {Feature_HasNEONBit, Feature_NotForCodeSizeBit, Feature_UseAlternateSExtLoadCVTF32Bit, },
};

// ComplexPattern predicates.
enum {
  GICP_Invalid,
  GICP_gi_addsub_shifted_imm32,
  GICP_gi_addsub_shifted_imm64,
  GICP_gi_am_indexed128,
  GICP_gi_am_indexed16,
  GICP_gi_am_indexed32,
  GICP_gi_am_indexed64,
  GICP_gi_am_indexed8,
  GICP_gi_am_unscaled128,
  GICP_gi_am_unscaled16,
  GICP_gi_am_unscaled32,
  GICP_gi_am_unscaled64,
  GICP_gi_am_unscaled8,
  GICP_gi_arith_extended_reg32_i32,
  GICP_gi_arith_extended_reg32_i64,
  GICP_gi_arith_extended_reg32to64_i64,
  GICP_gi_arith_shifted_reg32,
  GICP_gi_arith_shifted_reg64,
  GICP_gi_extract_high_v16i8,
  GICP_gi_extract_high_v4f32,
  GICP_gi_extract_high_v4i32,
  GICP_gi_extract_high_v8f16,
  GICP_gi_extract_high_v8i16,
  GICP_gi_logical_shifted_reg32,
  GICP_gi_logical_shifted_reg64,
  GICP_gi_neg_addsub_shifted_imm32,
  GICP_gi_neg_addsub_shifted_imm64,
  GICP_gi_ro_Windexed128,
  GICP_gi_ro_Windexed16,
  GICP_gi_ro_Windexed32,
  GICP_gi_ro_Windexed64,
  GICP_gi_ro_Windexed8,
  GICP_gi_ro_Xindexed128,
  GICP_gi_ro_Xindexed16,
  GICP_gi_ro_Xindexed32,
  GICP_gi_ro_Xindexed64,
  GICP_gi_ro_Xindexed8,
};
// See constructor for table contents

AArch64InstructionSelector::ComplexMatcherMemFn
AArch64InstructionSelector::ComplexPredicateFns[] = {
  nullptr, // GICP_Invalid
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm32
  &AArch64InstructionSelector::selectArithImmed, // gi_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeIndexed<128>, // gi_am_indexed128
  &AArch64InstructionSelector::selectAddrModeIndexed<16>, // gi_am_indexed16
  &AArch64InstructionSelector::selectAddrModeIndexed<32>, // gi_am_indexed32
  &AArch64InstructionSelector::selectAddrModeIndexed<64>, // gi_am_indexed64
  &AArch64InstructionSelector::selectAddrModeIndexed<8>, // gi_am_indexed8
  &AArch64InstructionSelector::selectAddrModeUnscaled128, // gi_am_unscaled128
  &AArch64InstructionSelector::selectAddrModeUnscaled16, // gi_am_unscaled16
  &AArch64InstructionSelector::selectAddrModeUnscaled32, // gi_am_unscaled32
  &AArch64InstructionSelector::selectAddrModeUnscaled64, // gi_am_unscaled64
  &AArch64InstructionSelector::selectAddrModeUnscaled8, // gi_am_unscaled8
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i32
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32_i64
  &AArch64InstructionSelector::selectArithExtendedRegister, // gi_arith_extended_reg32to64_i64
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg32
  &AArch64InstructionSelector::selectArithShiftedRegister, // gi_arith_shifted_reg64
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v16i8
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4f32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v4i32
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8f16
  &AArch64InstructionSelector::selectExtractHigh, // gi_extract_high_v8i16
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg32
  &AArch64InstructionSelector::selectLogicalShiftedRegister, // gi_logical_shifted_reg64
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm32
  &AArch64InstructionSelector::selectNegArithImmed, // gi_neg_addsub_shifted_imm64
  &AArch64InstructionSelector::selectAddrModeWRO<128>, // gi_ro_Windexed128
  &AArch64InstructionSelector::selectAddrModeWRO<16>, // gi_ro_Windexed16
  &AArch64InstructionSelector::selectAddrModeWRO<32>, // gi_ro_Windexed32
  &AArch64InstructionSelector::selectAddrModeWRO<64>, // gi_ro_Windexed64
  &AArch64InstructionSelector::selectAddrModeWRO<8>, // gi_ro_Windexed8
  &AArch64InstructionSelector::selectAddrModeXRO<128>, // gi_ro_Xindexed128
  &AArch64InstructionSelector::selectAddrModeXRO<16>, // gi_ro_Xindexed16
  &AArch64InstructionSelector::selectAddrModeXRO<32>, // gi_ro_Xindexed32
  &AArch64InstructionSelector::selectAddrModeXRO<64>, // gi_ro_Xindexed64
  &AArch64InstructionSelector::selectAddrModeXRO<8>, // gi_ro_Xindexed8
};

// PatFrag predicates.
enum {
  GICXXPred_MI_Predicate_add_and_or_is_add = GICXXPred_Invalid + 1,
  GICXXPred_MI_Predicate_ldaxr_1,
  GICXXPred_MI_Predicate_ldaxr_2,
  GICXXPred_MI_Predicate_ldaxr_4,
  GICXXPred_MI_Predicate_ldaxr_8,
  GICXXPred_MI_Predicate_ldxr_1,
  GICXXPred_MI_Predicate_ldxr_2,
  GICXXPred_MI_Predicate_ldxr_4,
  GICXXPred_MI_Predicate_ldxr_8,
  GICXXPred_MI_Predicate_stlxr_1,
  GICXXPred_MI_Predicate_stlxr_2,
  GICXXPred_MI_Predicate_stlxr_4,
  GICXXPred_MI_Predicate_stlxr_8,
  GICXXPred_MI_Predicate_stxr_1,
  GICXXPred_MI_Predicate_stxr_2,
  GICXXPred_MI_Predicate_stxr_4,
  GICXXPred_MI_Predicate_stxr_8,
};
bool AArch64InstructionSelector::testMIPredicate_MI(unsigned PredicateID, const MachineInstr & MI, const MatcherState &State) const {
  const MachineFunction &MF = *MI.getParent()->getParent();
  const MachineRegisterInfo &MRI = MF.getRegInfo();
  const auto &Operands = State.RecordedOperands;
  (void)Operands;
  (void)MRI;
  switch (PredicateID) {
  case GICXXPred_MI_Predicate_add_and_or_is_add: {
    
         return mi_match(MI, MRI, m_GAddLike(m_Reg(), m_Reg()));
      
  }
  case GICXXPred_MI_Predicate_ldaxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldaxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldaxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldaxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_ldxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_ldxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_ldxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_ldxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stlxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stlxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stlxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stlxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  case GICXXPred_MI_Predicate_stxr_1: {
     return isLoadStoreOfNumBytes(MI, 1); 
  }
  case GICXXPred_MI_Predicate_stxr_2: {
     return isLoadStoreOfNumBytes(MI, 2); 
  }
  case GICXXPred_MI_Predicate_stxr_4: {
     return isLoadStoreOfNumBytes(MI, 4); 
  }
  case GICXXPred_MI_Predicate_stxr_8: {
     return isLoadStoreOfNumBytes(MI, 8); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_MO_Predicate_top16Zero = GICXXPred_Invalid + 1,
  GICXXPred_MO_Predicate_top32Zero,
  GICXXPred_MO_Predicate_topbitsallzero32,
  GICXXPred_MO_Predicate_topbitsallzero64,
};
bool AArch64InstructionSelector::testMOPredicate_MO(unsigned PredicateID, const MachineOperand & MO, const MatcherState &State) const {
  const auto &Operands = State.RecordedOperands;
  Register Reg = MO.getReg();
  (void)Operands;
  (void)Reg;
  switch (PredicateID) {
  case GICXXPred_MO_Predicate_top16Zero: {
    
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 16)); 
  }
  case GICXXPred_MO_Predicate_top32Zero: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 32)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero32: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(32, 31)); 
  }
  case GICXXPred_MO_Predicate_topbitsallzero64: {
     
        return VT && VT->maskedValueIsZero(Reg, APInt::getHighBitsSet(64, 63)); 
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_I64_Predicate_VectorIndex0 = GICXXPred_Invalid + 1,
  GICXXPred_I64_Predicate_VectorIndex0_timm,
  GICXXPred_I64_Predicate_VectorIndex1,
  GICXXPred_I64_Predicate_VectorIndex1_timm,
  GICXXPred_I64_Predicate_VectorIndex032b,
  GICXXPred_I64_Predicate_VectorIndex032b_timm,
  GICXXPred_I64_Predicate_VectorIndex132b,
  GICXXPred_I64_Predicate_VectorIndex132b_timm,
  GICXXPred_I64_Predicate_VectorIndexB,
  GICXXPred_I64_Predicate_VectorIndexB32b,
  GICXXPred_I64_Predicate_VectorIndexB32b_timm,
  GICXXPred_I64_Predicate_VectorIndexB_timm,
  GICXXPred_I64_Predicate_VectorIndexD,
  GICXXPred_I64_Predicate_VectorIndexD32b,
  GICXXPred_I64_Predicate_VectorIndexD32b_timm,
  GICXXPred_I64_Predicate_VectorIndexD_timm,
  GICXXPred_I64_Predicate_VectorIndexH,
  GICXXPred_I64_Predicate_VectorIndexH32b,
  GICXXPred_I64_Predicate_VectorIndexH32b_timm,
  GICXXPred_I64_Predicate_VectorIndexH_timm,
  GICXXPred_I64_Predicate_VectorIndexS,
  GICXXPred_I64_Predicate_VectorIndexS32b,
  GICXXPred_I64_Predicate_VectorIndexS32b_timm,
  GICXXPred_I64_Predicate_VectorIndexS_timm,
  GICXXPred_I64_Predicate_complexrotateop,
  GICXXPred_I64_Predicate_complexrotateopodd,
  GICXXPred_I64_Predicate_extq_timm32_0_1m8,
  GICXXPred_I64_Predicate_extq_timm32_0_3m4,
  GICXXPred_I64_Predicate_extq_timm32_0_7m2,
  GICXXPred_I64_Predicate_i64imm_32bit,
  GICXXPred_I64_Predicate_i64imm_32bit_tgt,
  GICXXPred_I64_Predicate_imm0_1,
  GICXXPred_I64_Predicate_imm0_3,
  GICXXPred_I64_Predicate_imm0_7,
  GICXXPred_I64_Predicate_imm0_15,
  GICXXPred_I64_Predicate_imm0_31,
  GICXXPred_I64_Predicate_imm0_63,
  GICXXPred_I64_Predicate_imm0_127,
  GICXXPred_I64_Predicate_imm0_127_64b,
  GICXXPred_I64_Predicate_imm0_255,
  GICXXPred_I64_Predicate_imm32_0_7,
  GICXXPred_I64_Predicate_imm32_0_15,
  GICXXPred_I64_Predicate_imm32_0_31,
  GICXXPred_I64_Predicate_imm64_0_65535,
  GICXXPred_I64_Predicate_maski8_or_more,
  GICXXPred_I64_Predicate_maski16_or_more,
  GICXXPred_I64_Predicate_rprfop,
  GICXXPred_I64_Predicate_s64imm_32bit,
  GICXXPred_I64_Predicate_simm4s1,
  GICXXPred_I64_Predicate_simm4s2,
  GICXXPred_I64_Predicate_simm4s3,
  GICXXPred_I64_Predicate_simm4s4,
  GICXXPred_I64_Predicate_simm4s16,
  GICXXPred_I64_Predicate_simm4s32,
  GICXXPred_I64_Predicate_simm5_8b,
  GICXXPred_I64_Predicate_simm5_8b_tgt,
  GICXXPred_I64_Predicate_simm5_16b,
  GICXXPred_I64_Predicate_simm5_16b_tgt,
  GICXXPred_I64_Predicate_simm5_32b,
  GICXXPred_I64_Predicate_simm5_32b_tgt,
  GICXXPred_I64_Predicate_simm5_64b,
  GICXXPred_I64_Predicate_simm5_64b_tgt,
  GICXXPred_I64_Predicate_simm6_32b,
  GICXXPred_I64_Predicate_simm6s1,
  GICXXPred_I64_Predicate_simm8_32b,
  GICXXPred_I64_Predicate_simm8_64b,
  GICXXPred_I64_Predicate_simm9,
  GICXXPred_I64_Predicate_sme_elm_idx0_0,
  GICXXPred_I64_Predicate_sme_elm_idx0_1,
  GICXXPred_I64_Predicate_sme_elm_idx0_3,
  GICXXPred_I64_Predicate_sme_elm_idx0_7,
  GICXXPred_I64_Predicate_sme_elm_idx0_15,
  GICXXPred_I64_Predicate_svcr_op,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s,
  GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm,
  GICXXPred_I64_Predicate_sve_incdec_imm,
  GICXXPred_I64_Predicate_sve_pred_enum,
  GICXXPred_I64_Predicate_sve_prfop,
  GICXXPred_I64_Predicate_sve_vec_len_specifier_enum,
  GICXXPred_I64_Predicate_tbz_imm0_31_diag,
  GICXXPred_I64_Predicate_tbz_imm0_31_nodiag,
  GICXXPred_I64_Predicate_tbz_imm32_63,
  GICXXPred_I64_Predicate_timm0_1,
  GICXXPred_I64_Predicate_timm0_31,
  GICXXPred_I64_Predicate_timm0_63,
  GICXXPred_I64_Predicate_timm32_0_0,
  GICXXPred_I64_Predicate_timm32_0_1,
  GICXXPred_I64_Predicate_timm32_0_3,
  GICXXPred_I64_Predicate_timm32_0_7,
  GICXXPred_I64_Predicate_timm32_0_15,
  GICXXPred_I64_Predicate_timm32_0_31,
  GICXXPred_I64_Predicate_timm32_0_255,
  GICXXPred_I64_Predicate_timm32_0_65535,
  GICXXPred_I64_Predicate_timm32_1_1,
  GICXXPred_I64_Predicate_timm32_1_3,
  GICXXPred_I64_Predicate_timm32_1_7,
  GICXXPred_I64_Predicate_timm64_0_65535,
  GICXXPred_I64_Predicate_tuimm5s2,
  GICXXPred_I64_Predicate_tuimm5s4,
  GICXXPred_I64_Predicate_tuimm5s8,
  GICXXPred_I64_Predicate_tvecshiftL8,
  GICXXPred_I64_Predicate_tvecshiftL16,
  GICXXPred_I64_Predicate_tvecshiftL32,
  GICXXPred_I64_Predicate_tvecshiftL64,
  GICXXPred_I64_Predicate_tvecshiftR8,
  GICXXPred_I64_Predicate_tvecshiftR16,
  GICXXPred_I64_Predicate_tvecshiftR32,
  GICXXPred_I64_Predicate_tvecshiftR64,
  GICXXPred_I64_Predicate_ubsan_trap_imm,
  GICXXPred_I64_Predicate_uimm0s2range,
  GICXXPred_I64_Predicate_uimm0s4range,
  GICXXPred_I64_Predicate_uimm1s2range,
  GICXXPred_I64_Predicate_uimm1s4range,
  GICXXPred_I64_Predicate_uimm2s2range,
  GICXXPred_I64_Predicate_uimm2s4range,
  GICXXPred_I64_Predicate_uimm3s2range,
  GICXXPred_I64_Predicate_uimm3s8,
  GICXXPred_I64_Predicate_uimm5s2,
  GICXXPred_I64_Predicate_uimm5s4,
  GICXXPred_I64_Predicate_uimm5s8,
  GICXXPred_I64_Predicate_uimm6,
  GICXXPred_I64_Predicate_uimm6_32b,
  GICXXPred_I64_Predicate_uimm6_64b,
  GICXXPred_I64_Predicate_uimm6s1,
  GICXXPred_I64_Predicate_uimm6s2,
  GICXXPred_I64_Predicate_uimm6s4,
  GICXXPred_I64_Predicate_uimm6s8,
  GICXXPred_I64_Predicate_uimm6s16,
  GICXXPred_I64_Predicate_uimm8_32b,
  GICXXPred_I64_Predicate_uimm8_64b,
  GICXXPred_I64_Predicate_uimm16,
  GICXXPred_I64_Predicate_vecshiftL8,
  GICXXPred_I64_Predicate_vecshiftL16,
  GICXXPred_I64_Predicate_vecshiftL32,
  GICXXPred_I64_Predicate_vecshiftL64,
  GICXXPred_I64_Predicate_vecshiftR8,
  GICXXPred_I64_Predicate_vecshiftR16,
  GICXXPred_I64_Predicate_vecshiftR16Narrow,
  GICXXPred_I64_Predicate_vecshiftR32,
  GICXXPred_I64_Predicate_vecshiftR32Narrow,
  GICXXPred_I64_Predicate_vecshiftR64,
  GICXXPred_I64_Predicate_vecshiftR64Narrow,
};
bool AArch64InstructionSelector::testImmPredicate_I64(unsigned PredicateID, int64_t Imm) const {
  switch (PredicateID) {
  case GICXXPred_I64_Predicate_VectorIndex0: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex0_timm: {
     return ((uint64_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex1_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex032b_timm: {
     return ((uint32_t)Imm) == 0; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndex132b_timm: {
     return ((uint64_t)Imm) == 1; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB32b_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexB_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD32b_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexD_timm: {
     return ((uint64_t)Imm) < 2; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH32b_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexH_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS32b_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_VectorIndexS_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_complexrotateop: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_complexrotateopodd: {
     return Imm >= 0 && Imm <= 270;  
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_1m8: {
    
      return ((uint32_t)Imm) < 2;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_3m4: {
    
      return ((uint32_t)Imm) < 4;
  }
  case GICXXPred_I64_Predicate_extq_timm32_0_7m2: {
    
      return ((uint32_t)Imm) < 8;
  }
  case GICXXPred_I64_Predicate_i64imm_32bit: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_i64imm_32bit_tgt: {
    
      return (Imm & 0xffffffffULL) == static_cast<uint64_t>(Imm);
    
  }
  case GICXXPred_I64_Predicate_imm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_imm0_3: {
    
      return ((uint64_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_imm0_7: {
    
      return ((uint64_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm0_15: {
    
      return ((uint64_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_imm0_127: {
    
      return ((uint32_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_127_64b: {
    
      return ((uint64_t)Imm) < 128;
    
  }
  case GICXXPred_I64_Predicate_imm0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_imm32_0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_imm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_maski8_or_more: {
     return (Imm & 0xff) == 0xff; 
  }
  case GICXXPred_I64_Predicate_maski16_or_more: {
     return (Imm & 0xffff) == 0xffff; 
  }
  case GICXXPred_I64_Predicate_rprfop: {
    
        return (((uint32_t)Imm) <= 63);
      
  }
  case GICXXPred_I64_Predicate_s64imm_32bit: {
    
      int64_t Imm64 = static_cast<int64_t>(Imm);
      return Imm64 >= std::numeric_limits<int32_t>::min() &&
             Imm64 <= std::numeric_limits<int32_t>::max();
    
    llvm_unreachable("s64imm_32bit should have returned");
  }
  case GICXXPred_I64_Predicate_simm4s1: {
     return Imm >=-8  && Imm <= 7; 
  }
  case GICXXPred_I64_Predicate_simm4s2: {
     return Imm >=-16  && Imm <= 14 && (Imm % 2) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s3: {
     return Imm >=-24  && Imm <= 21 && (Imm % 3) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s4: {
     return Imm >=-32  && Imm <= 28 && (Imm % 4) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s16: {
     return Imm >=-128  && Imm <= 112 && (Imm % 16) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm4s32: {
     return Imm >=-256  && Imm <= 224 && (Imm % 32) == 0x0; 
  }
  case GICXXPred_I64_Predicate_simm5_8b: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_8b_tgt: {
     return (int8_t)Imm >= -16 && (int8_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_16b_tgt: {
     return (int16_t)Imm >= -16 && (int16_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_32b_tgt: {
     return (int32_t)Imm >= -16 && (int32_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b: {
     return Imm >= -16 && Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm5_64b_tgt: {
     return (int64_t)Imm >= -16 && (int64_t)Imm < 16; 
  }
  case GICXXPred_I64_Predicate_simm6_32b: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm6s1: {
     return Imm >= -32 && Imm < 32; 
  }
  case GICXXPred_I64_Predicate_simm8_32b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm8_64b: {
     return Imm >= -128 && Imm < 128; 
  }
  case GICXXPred_I64_Predicate_simm9: {
     return Imm >= -256 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_1: {
    
      return ((uint32_t)Imm) <= 1;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_3: {
    
      return ((uint32_t)Imm) <= 3;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_7: {
    
      return ((uint32_t)Imm) <= 7;
    
  }
  case GICXXPred_I64_Predicate_sme_elm_idx0_15: {
    
      return ((uint32_t)Imm) <= 15;
    
  }
  case GICXXPred_I64_Predicate_svcr_op: {
    
        return AArch64SVCR::lookupSVCRByEncoding(Imm) != nullptr;
      
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_b_timm: {
     return ((uint64_t)Imm) < 64; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_d_timm: {
     return ((uint64_t)Imm) < 8; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_h_timm: {
     return ((uint64_t)Imm) < 32; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_q_timm: {
     return ((uint64_t)Imm) < 4; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_elm_idx_extdup_s_timm: {
     return ((uint64_t)Imm) < 16; 
  }
  case GICXXPred_I64_Predicate_sve_incdec_imm: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_sve_pred_enum: {
    
      return (((uint32_t)Imm) < 32);
      
  }
  case GICXXPred_I64_Predicate_sve_prfop: {
    
        return (((uint32_t)Imm) <= 15);
      
  }
  case GICXXPred_I64_Predicate_sve_vec_len_specifier_enum: {
    
      return (((uint32_t)Imm) < 2);
      
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_diag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm0_31_nodiag: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tbz_imm32_63: {
    
      return (((uint32_t)Imm) > 31) && (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_timm0_1: {
    
      return ((uint64_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm0_31: {
    
      return ((uint64_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm0_63: {
    
      return ((uint64_t)Imm) < 64;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_0: {
    
      return ((uint32_t)Imm) == 0;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_1: {
    
      return ((uint32_t)Imm) < 2;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_3: {
    
      return ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_7: {
    
      return ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_15: {
    
      return ((uint32_t)Imm) < 16;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_31: {
    
      return ((uint32_t)Imm) < 32;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_255: {
    
      return ((uint32_t)Imm) < 256;
    
  }
  case GICXXPred_I64_Predicate_timm32_0_65535: {
    
      return ((uint32_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_1: {
    
        return ((uint32_t)Imm) == 1;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_3: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 4;
    
  }
  case GICXXPred_I64_Predicate_timm32_1_7: {
    
      return ((uint32_t)Imm) > 0 && ((uint32_t)Imm) < 8;
    
  }
  case GICXXPred_I64_Predicate_timm64_0_65535: {
    
      return ((uint64_t)Imm) < 65536;
    
  }
  case GICXXPred_I64_Predicate_tuimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_tuimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_tvecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_tvecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_ubsan_trap_imm: {
    
      return isUInt<8>(Imm);
    
  }
  case GICXXPred_I64_Predicate_uimm0s2range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm0s4range: {
     return Imm == 0; 
  }
  case GICXXPred_I64_Predicate_uimm1s2range: {
     return Imm >= 0 && Imm <= 2 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm1s4range: {
     return Imm >= 0 && Imm <= 4 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s2range: {
     return Imm >= 0 && Imm <= 6 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm2s4range: {
     return Imm >= 0 && Imm <= 12 && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s2range: {
     return Imm >= 0 && Imm <= 14 && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm3s8: {
     return Imm >= 0 && Imm <= 56 && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s2: {
     return Imm >= 0 && Imm < (32*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s4: {
     return Imm >= 0 && Imm < (32*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm5s8: {
     return Imm >= 0 && Imm < (32*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_32b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6_64b: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s1: {
     return Imm >= 0 && Imm < 64; 
  }
  case GICXXPred_I64_Predicate_uimm6s2: {
     return Imm >= 0 && Imm < (64*2) && ((Imm % 2) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s4: {
     return Imm >= 0 && Imm < (64*4) && ((Imm % 4) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s8: {
     return Imm >= 0 && Imm < (64*8) && ((Imm % 8) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm6s16: {
     return Imm >= 0 && Imm < (64*16) && ((Imm % 16) == 0); 
  }
  case GICXXPred_I64_Predicate_uimm8_32b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm8_64b: {
     return Imm >= 0 && Imm < 256; 
  }
  case GICXXPred_I64_Predicate_uimm16: {
    return Imm >= 0 && Imm < 65536;
  }
  case GICXXPred_I64_Predicate_vecshiftL8: {
    
      return (((uint32_t)Imm) < 8);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL16: {
    
      return (((uint32_t)Imm) < 16);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL32: {
    
      return (((uint32_t)Imm) < 32);
    
  }
  case GICXXPred_I64_Predicate_vecshiftL64: {
    
      return (((uint32_t)Imm) < 64);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR8: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR16Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 9);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR32Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 17);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 65);
    
  }
  case GICXXPred_I64_Predicate_vecshiftR64Narrow: {
    
      return (((uint32_t)Imm) > 0) && (((uint32_t)Imm) < 33);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APFloat_Predicate_fpimm0 = GICXXPred_Invalid + 1,
  GICXXPred_APFloat_Predicate_fpimm16,
  GICXXPred_APFloat_Predicate_fpimm32,
  GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4,
  GICXXPred_APFloat_Predicate_fpimm64,
  GICXXPred_APFloat_Predicate_fpimm_half,
  GICXXPred_APFloat_Predicate_fpimm_minus0,
  GICXXPred_APFloat_Predicate_fpimm_one,
  GICXXPred_APFloat_Predicate_fpimm_two,
  GICXXPred_APFloat_Predicate_fpimmbf16,
  GICXXPred_APFloat_Predicate_simdimmtype10,
};
bool AArch64InstructionSelector::testImmPredicate_APFloat(unsigned PredicateID, const APFloat & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APFloat_Predicate_fpimm0: {
    
      return Imm.isExactlyValue(+0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32: {
    
          return AArch64_AM::getFP32Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4: {
    
          uint64_t Enc = Imm.bitcastToAPInt().getZExtValue();
          return Enc != 0 && AArch64_AM::isAdvSIMDModImmType4(Enc << 32 | Enc);
        
    llvm_unreachable("fpimm32SIMDModImmType4 should have returned");
  }
  case GICXXPred_APFloat_Predicate_fpimm64: {
    
          return AArch64_AM::getFP64Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_fpimm_half: {
    
      return Imm.isExactlyValue(+0.5);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_minus0: {
    
      return Imm.isExactlyValue(-0.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_one: {
    
      return Imm.isExactlyValue(+1.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimm_two: {
    
      return Imm.isExactlyValue(+2.0);
    
  }
  case GICXXPred_APFloat_Predicate_fpimmbf16: {
    
          return AArch64_AM::getFP16Imm(Imm) != -1;
        
  }
  case GICXXPred_APFloat_Predicate_simdimmtype10: {
    
          return AArch64_AM::isAdvSIMDModImmType10(
                     Imm.bitcastToAPInt().getZExtValue());
        
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
// PatFrag predicates.
enum {
  GICXXPred_APInt_Predicate_logical_imm32 = GICXXPred_Invalid + 1,
  GICXXPred_APInt_Predicate_logical_imm64,
};
bool AArch64InstructionSelector::testImmPredicate_APInt(unsigned PredicateID, const APInt & Imm) const {
  switch (PredicateID) {
  case GICXXPred_APInt_Predicate_logical_imm32: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 32);
    
  }
  case GICXXPred_APInt_Predicate_logical_imm64: {
    
      return AArch64_AM::isLogicalImmediate(Imm.getZExtValue(), 64);
    
  }
  }
  llvm_unreachable("Unknown predicate");
  return false;
}
bool AArch64InstructionSelector::testSimplePredicate(unsigned) const {
    llvm_unreachable("AArch64InstructionSelector does not support simple predicates!");
  return false;
}
// Custom renderers.
enum {
  GICR_Invalid,
  GICR_renderFPImm16,
  GICR_renderFPImm32,
  GICR_renderFPImm32SIMDModImmType4,
  GICR_renderFPImm64,
  GICR_renderLogicalImm32,
  GICR_renderLogicalImm64,
  GICR_renderTruncImm,
  GICR_renderUbsanTrap,
};
AArch64InstructionSelector::CustomRendererFn
AArch64InstructionSelector::CustomRenderers[] = {
  nullptr, // GICR_Invalid
  &AArch64InstructionSelector::renderFPImm16,
  &AArch64InstructionSelector::renderFPImm32,
  &AArch64InstructionSelector::renderFPImm32SIMDModImmType4,
  &AArch64InstructionSelector::renderFPImm64,
  &AArch64InstructionSelector::renderLogicalImm32,
  &AArch64InstructionSelector::renderLogicalImm64,
  &AArch64InstructionSelector::renderTruncImm,
  &AArch64InstructionSelector::renderUbsanTrap,
};

bool AArch64InstructionSelector::selectImpl(MachineInstr &I, CodeGenCoverage &CoverageInfo) const {
  const PredicateBitset AvailableFeatures = getAvailableFeatures();
  MachineIRBuilder B(I);
  State.MIs.clear();
  State.MIs.push_back(&I);

  if (executeMatchTable(*this, State, ExecInfo, B, getMatchTable(), TII, MF->getRegInfo(), TRI, RBI, AvailableFeatures, &CoverageInfo)) {
    return true;
  }

  return false;
}

bool AArch64InstructionSelector::runCustomAction(unsigned, const MatcherState&, NewMIVector &) const {
    llvm_unreachable("AArch64InstructionSelector does not support custom C++ actions!");
}
#if __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
#define GIMT_Encode2(Val) uint8_t(Val), uint8_t((uint16_t)Val >> 8)
#define GIMT_Encode4(Val) uint8_t(Val), uint8_t((uint32_t)Val >> 8), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 24)
#define GIMT_Encode8(Val) uint8_t(Val), uint8_t((uint64_t)Val >> 8), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 24),  uint8_t((uint64_t)Val >> 32), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 56)
#else
#define GIMT_Encode2(Val) uint8_t((uint16_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode4(Val) uint8_t((uint32_t)Val >> 24), uint8_t((uint32_t)Val >> 16), uint8_t((uint32_t)Val >> 8), uint8_t(Val)
#define GIMT_Encode8(Val) uint8_t((uint64_t)Val >> 56), uint8_t((uint64_t)Val >> 48), uint8_t((uint64_t)Val >> 40), uint8_t((uint64_t)Val >> 32),  uint8_t((uint64_t)Val >> 24), uint8_t((uint64_t)Val >> 16), uint8_t((uint64_t)Val >> 8), uint8_t(Val)
#endif
const uint8_t *AArch64InstructionSelector::getMatchTable() const {
  constexpr static uint8_t MatchTable0[] = {
     /*      0 */ GIM_SwitchOpcode, /*MI*/0, /*[*/GIMT_Encode2(53), GIMT_Encode2(903), /*)*//*default:*//*Label 154*/ GIMT_Encode4(440476),
     /*     10 */ /*TargetOpcode::G_ADD*//*Label 0*/ GIMT_Encode4(3410),
     /*     14 */ /*TargetOpcode::G_SUB*//*Label 1*/ GIMT_Encode4(37017),
     /*     18 */ /*TargetOpcode::G_MUL*//*Label 2*/ GIMT_Encode4(51869),
     /*     22 */ /*TargetOpcode::G_SDIV*//*Label 3*/ GIMT_Encode4(54634),
     /*     26 */ /*TargetOpcode::G_UDIV*//*Label 4*/ GIMT_Encode4(54716), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*     46 */ /*TargetOpcode::G_AND*//*Label 5*/ GIMT_Encode4(54798),
     /*     50 */ /*TargetOpcode::G_OR*//*Label 6*/ GIMT_Encode4(62544),
     /*     54 */ /*TargetOpcode::G_XOR*//*Label 7*/ GIMT_Encode4(87659), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    114 */ /*TargetOpcode::G_CONCAT_VECTORS*//*Label 8*/ GIMT_Encode4(98627), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    126 */ /*TargetOpcode::G_BITCAST*//*Label 9*/ GIMT_Encode4(106151), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    142 */ /*TargetOpcode::G_INTRINSIC_TRUNC*//*Label 10*/ GIMT_Encode4(116233),
     /*    146 */ /*TargetOpcode::G_INTRINSIC_ROUND*//*Label 11*/ GIMT_Encode4(116724),
     /*    150 */ /*TargetOpcode::G_INTRINSIC_LRINT*//*Label 12*/ GIMT_Encode4(117215),
     /*    154 */ /*TargetOpcode::G_INTRINSIC_LLRINT*//*Label 13*/ GIMT_Encode4(117483),
     /*    158 */ /*TargetOpcode::G_INTRINSIC_ROUNDEVEN*//*Label 14*/ GIMT_Encode4(117633),
     /*    162 */ /*TargetOpcode::G_READCYCLECOUNTER*//*Label 15*/ GIMT_Encode4(118124), GIMT_Encode4(0),
     /*    170 */ /*TargetOpcode::G_LOAD*//*Label 16*/ GIMT_Encode4(118157),
     /*    174 */ /*TargetOpcode::G_SEXTLOAD*//*Label 17*/ GIMT_Encode4(127095),
     /*    178 */ /*TargetOpcode::G_ZEXTLOAD*//*Label 18*/ GIMT_Encode4(128145), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    194 */ /*TargetOpcode::G_STORE*//*Label 19*/ GIMT_Encode4(131194), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    206 */ /*TargetOpcode::G_ATOMIC_CMPXCHG*//*Label 20*/ GIMT_Encode4(144720),
     /*    210 */ /*TargetOpcode::G_ATOMICRMW_XCHG*//*Label 21*/ GIMT_Encode4(146071),
     /*    214 */ /*TargetOpcode::G_ATOMICRMW_ADD*//*Label 22*/ GIMT_Encode4(147063),
     /*    218 */ /*TargetOpcode::G_ATOMICRMW_SUB*//*Label 23*/ GIMT_Encode4(148055),
     /*    222 */ /*TargetOpcode::G_ATOMICRMW_AND*//*Label 24*/ GIMT_Encode4(149547), GIMT_Encode4(0),
     /*    230 */ /*TargetOpcode::G_ATOMICRMW_OR*//*Label 25*/ GIMT_Encode4(151039),
     /*    234 */ /*TargetOpcode::G_ATOMICRMW_XOR*//*Label 26*/ GIMT_Encode4(152031),
     /*    238 */ /*TargetOpcode::G_ATOMICRMW_MAX*//*Label 27*/ GIMT_Encode4(153023),
     /*    242 */ /*TargetOpcode::G_ATOMICRMW_MIN*//*Label 28*/ GIMT_Encode4(154015),
     /*    246 */ /*TargetOpcode::G_ATOMICRMW_UMAX*//*Label 29*/ GIMT_Encode4(155007),
     /*    250 */ /*TargetOpcode::G_ATOMICRMW_UMIN*//*Label 30*/ GIMT_Encode4(155999),
     /*    254 */ /*TargetOpcode::G_ATOMICRMW_FADD*//*Label 31*/ GIMT_Encode4(156991), GIMT_Encode4(0),
     /*    262 */ /*TargetOpcode::G_ATOMICRMW_FMAX*//*Label 32*/ GIMT_Encode4(157696),
     /*    266 */ /*TargetOpcode::G_ATOMICRMW_FMIN*//*Label 33*/ GIMT_Encode4(158401),
     /*    270 */ /*TargetOpcode::G_ATOMICRMW_FMAXIMUM*//*Label 34*/ GIMT_Encode4(159106),
     /*    274 */ /*TargetOpcode::G_ATOMICRMW_FMINIMUM*//*Label 35*/ GIMT_Encode4(159811), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    294 */ /*TargetOpcode::G_FENCE*//*Label 36*/ GIMT_Encode4(160516), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    314 */ /*TargetOpcode::G_INTRINSIC*//*Label 37*/ GIMT_Encode4(160567),
     /*    318 */ /*TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS*//*Label 38*/ GIMT_Encode4(265643), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    330 */ /*TargetOpcode::G_ANYEXT*//*Label 39*/ GIMT_Encode4(277159),
     /*    334 */ /*TargetOpcode::G_TRUNC*//*Label 40*/ GIMT_Encode4(277449),
     /*    338 */ /*TargetOpcode::G_CONSTANT*//*Label 41*/ GIMT_Encode4(278886),
     /*    342 */ /*TargetOpcode::G_FCONSTANT*//*Label 42*/ GIMT_Encode4(279006), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    354 */ /*TargetOpcode::G_SEXT*//*Label 43*/ GIMT_Encode4(279247),
     /*    358 */ /*TargetOpcode::G_SEXT_INREG*//*Label 44*/ GIMT_Encode4(281145),
     /*    362 */ /*TargetOpcode::G_ZEXT*//*Label 45*/ GIMT_Encode4(282799),
     /*    366 */ /*TargetOpcode::G_SHL*//*Label 46*/ GIMT_Encode4(285578),
     /*    370 */ /*TargetOpcode::G_LSHR*//*Label 47*/ GIMT_Encode4(286403),
     /*    374 */ /*TargetOpcode::G_ASHR*//*Label 48*/ GIMT_Encode4(286947), GIMT_Encode4(0),
     /*    382 */ /*TargetOpcode::G_FSHR*//*Label 49*/ GIMT_Encode4(287772),
     /*    386 */ /*TargetOpcode::G_ROTR*//*Label 50*/ GIMT_Encode4(287902), GIMT_Encode4(0),
     /*    394 */ /*TargetOpcode::G_ICMP*//*Label 51*/ GIMT_Encode4(288444), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    410 */ /*TargetOpcode::G_SELECT*//*Label 52*/ GIMT_Encode4(296221), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    454 */ /*TargetOpcode::G_UMULH*//*Label 53*/ GIMT_Encode4(297266),
     /*    458 */ /*TargetOpcode::G_SMULH*//*Label 54*/ GIMT_Encode4(297750),
     /*    462 */ /*TargetOpcode::G_UADDSAT*//*Label 55*/ GIMT_Encode4(298234),
     /*    466 */ /*TargetOpcode::G_SADDSAT*//*Label 56*/ GIMT_Encode4(298706),
     /*    470 */ /*TargetOpcode::G_USUBSAT*//*Label 57*/ GIMT_Encode4(301082),
     /*    474 */ /*TargetOpcode::G_SSUBSAT*//*Label 58*/ GIMT_Encode4(301554), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    518 */ /*TargetOpcode::G_FADD*//*Label 59*/ GIMT_Encode4(302944),
     /*    522 */ /*TargetOpcode::G_FSUB*//*Label 60*/ GIMT_Encode4(304742),
     /*    526 */ /*TargetOpcode::G_FMUL*//*Label 61*/ GIMT_Encode4(305480),
     /*    530 */ /*TargetOpcode::G_FMA*//*Label 62*/ GIMT_Encode4(309576), GIMT_Encode4(0),
     /*    538 */ /*TargetOpcode::G_FDIV*//*Label 63*/ GIMT_Encode4(325849), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    586 */ /*TargetOpcode::G_FNEG*//*Label 64*/ GIMT_Encode4(326465),
     /*    590 */ /*TargetOpcode::G_FPEXT*//*Label 65*/ GIMT_Encode4(329972),
     /*    594 */ /*TargetOpcode::G_FPTRUNC*//*Label 66*/ GIMT_Encode4(330220),
     /*    598 */ /*TargetOpcode::G_FPTOSI*//*Label 67*/ GIMT_Encode4(330408),
     /*    602 */ /*TargetOpcode::G_FPTOUI*//*Label 68*/ GIMT_Encode4(331385),
     /*    606 */ /*TargetOpcode::G_SITOFP*//*Label 69*/ GIMT_Encode4(332362),
     /*    610 */ /*TargetOpcode::G_UITOFP*//*Label 70*/ GIMT_Encode4(336990),
     /*    614 */ /*TargetOpcode::G_FPTOSI_SAT*//*Label 71*/ GIMT_Encode4(340996),
     /*    618 */ /*TargetOpcode::G_FPTOUI_SAT*//*Label 72*/ GIMT_Encode4(341316),
     /*    622 */ /*TargetOpcode::G_FABS*//*Label 73*/ GIMT_Encode4(341636), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    634 */ /*TargetOpcode::G_FCANONICALIZE*//*Label 74*/ GIMT_Encode4(342493),
     /*    638 */ /*TargetOpcode::G_FMINNUM*//*Label 75*/ GIMT_Encode4(342775),
     /*    642 */ /*TargetOpcode::G_FMAXNUM*//*Label 76*/ GIMT_Encode4(343153),
     /*    646 */ /*TargetOpcode::G_FMINNUM_IEEE*//*Label 77*/ GIMT_Encode4(343531),
     /*    650 */ /*TargetOpcode::G_FMAXNUM_IEEE*//*Label 78*/ GIMT_Encode4(343881),
     /*    654 */ /*TargetOpcode::G_FMINIMUM*//*Label 79*/ GIMT_Encode4(344231),
     /*    658 */ /*TargetOpcode::G_FMAXIMUM*//*Label 80*/ GIMT_Encode4(344934), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    702 */ /*TargetOpcode::G_SMIN*//*Label 81*/ GIMT_Encode4(345637),
     /*    706 */ /*TargetOpcode::G_SMAX*//*Label 82*/ GIMT_Encode4(346041),
     /*    710 */ /*TargetOpcode::G_UMIN*//*Label 83*/ GIMT_Encode4(346445),
     /*    714 */ /*TargetOpcode::G_UMAX*//*Label 84*/ GIMT_Encode4(346849),
     /*    718 */ /*TargetOpcode::G_ABS*//*Label 85*/ GIMT_Encode4(347253),
     /*    722 */ /*TargetOpcode::G_LROUND*//*Label 86*/ GIMT_Encode4(348068),
     /*    726 */ /*TargetOpcode::G_LLROUND*//*Label 87*/ GIMT_Encode4(348234),
     /*    730 */ /*TargetOpcode::G_BR*//*Label 88*/ GIMT_Encode4(348333), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    746 */ /*TargetOpcode::G_EXTRACT_SUBVECTOR*//*Label 89*/ GIMT_Encode4(348349),
     /*    750 */ /*TargetOpcode::G_INSERT_VECTOR_ELT*//*Label 90*/ GIMT_Encode4(353721),
     /*    754 */ /*TargetOpcode::G_EXTRACT_VECTOR_ELT*//*Label 91*/ GIMT_Encode4(386643), GIMT_Encode4(0),
     /*    762 */ /*TargetOpcode::G_SPLAT_VECTOR*//*Label 92*/ GIMT_Encode4(389561), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    774 */ /*TargetOpcode::G_CTTZ*//*Label 93*/ GIMT_Encode4(391881), GIMT_Encode4(0),
     /*    782 */ /*TargetOpcode::G_CTLZ*//*Label 94*/ GIMT_Encode4(392033), GIMT_Encode4(0),
     /*    790 */ /*TargetOpcode::G_CTPOP*//*Label 95*/ GIMT_Encode4(392707),
     /*    794 */ /*TargetOpcode::G_BSWAP*//*Label 96*/ GIMT_Encode4(392867),
     /*    798 */ /*TargetOpcode::G_BITREVERSE*//*Label 97*/ GIMT_Encode4(393181),
     /*    802 */ /*TargetOpcode::G_FCEIL*//*Label 98*/ GIMT_Encode4(393335), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    850 */ /*TargetOpcode::G_FSQRT*//*Label 99*/ GIMT_Encode4(393826),
     /*    854 */ /*TargetOpcode::G_FFLOOR*//*Label 100*/ GIMT_Encode4(394126),
     /*    858 */ /*TargetOpcode::G_FRINT*//*Label 101*/ GIMT_Encode4(394617),
     /*    862 */ /*TargetOpcode::G_FNEARBYINT*//*Label 102*/ GIMT_Encode4(395108), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    890 */ /*TargetOpcode::G_STRICT_FADD*//*Label 103*/ GIMT_Encode4(395599),
     /*    894 */ /*TargetOpcode::G_STRICT_FSUB*//*Label 104*/ GIMT_Encode4(396725),
     /*    898 */ /*TargetOpcode::G_STRICT_FMUL*//*Label 105*/ GIMT_Encode4(397341),
     /*    902 */ /*TargetOpcode::G_STRICT_FDIV*//*Label 106*/ GIMT_Encode4(401063), GIMT_Encode4(0),
     /*    910 */ /*TargetOpcode::G_STRICT_FMA*//*Label 107*/ GIMT_Encode4(401679),
     /*    914 */ /*TargetOpcode::G_STRICT_FSQRT*//*Label 108*/ GIMT_Encode4(417286), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    950 */ /*TargetOpcode::G_TRAP*//*Label 109*/ GIMT_Encode4(417586),
     /*    954 */ /*TargetOpcode::G_DEBUGTRAP*//*Label 110*/ GIMT_Encode4(417600),
     /*    958 */ /*TargetOpcode::G_UBSANTRAP*//*Label 111*/ GIMT_Encode4(417621), GIMT_Encode4(0), GIMT_Encode4(0),
     /*    970 */ /*TargetOpcode::G_VECREDUCE_FADD*//*Label 112*/ GIMT_Encode4(417646), GIMT_Encode4(0),
     /*    978 */ /*TargetOpcode::G_VECREDUCE_FMAX*//*Label 113*/ GIMT_Encode4(417956),
     /*    982 */ /*TargetOpcode::G_VECREDUCE_FMIN*//*Label 114*/ GIMT_Encode4(418127),
     /*    986 */ /*TargetOpcode::G_VECREDUCE_FMAXIMUM*//*Label 115*/ GIMT_Encode4(418298),
     /*    990 */ /*TargetOpcode::G_VECREDUCE_FMINIMUM*//*Label 116*/ GIMT_Encode4(418469),
     /*    994 */ /*TargetOpcode::G_VECREDUCE_ADD*//*Label 117*/ GIMT_Encode4(418640), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   1014 */ /*TargetOpcode::G_VECREDUCE_SMAX*//*Label 118*/ GIMT_Encode4(419769),
     /*   1018 */ /*TargetOpcode::G_VECREDUCE_SMIN*//*Label 119*/ GIMT_Encode4(419972),
     /*   1022 */ /*TargetOpcode::G_VECREDUCE_UMAX*//*Label 120*/ GIMT_Encode4(420175),
     /*   1026 */ /*TargetOpcode::G_VECREDUCE_UMIN*//*Label 121*/ GIMT_Encode4(420378), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3278 */ /*AArch64::G_AARCH64_PREFETCH*//*Label 122*/ GIMT_Encode4(420581), GIMT_Encode4(0),
     /*   3286 */ /*AArch64::G_BSP*//*Label 123*/ GIMT_Encode4(420721),
     /*   3290 */ /*AArch64::G_DUP*//*Label 124*/ GIMT_Encode4(421709),
     /*   3294 */ /*AArch64::G_DUPLANE16*//*Label 125*/ GIMT_Encode4(423692),
     /*   3298 */ /*AArch64::G_DUPLANE32*//*Label 126*/ GIMT_Encode4(423947),
     /*   3302 */ /*AArch64::G_DUPLANE64*//*Label 127*/ GIMT_Encode4(424202),
     /*   3306 */ /*AArch64::G_DUPLANE8*//*Label 128*/ GIMT_Encode4(424348),
     /*   3310 */ /*AArch64::G_EXT*//*Label 129*/ GIMT_Encode4(424527),
     /*   3314 */ /*AArch64::G_FCMEQ*//*Label 130*/ GIMT_Encode4(426177),
     /*   3318 */ /*AArch64::G_FCMGE*//*Label 131*/ GIMT_Encode4(426736),
     /*   3322 */ /*AArch64::G_FCMGT*//*Label 132*/ GIMT_Encode4(427828),
     /*   3326 */ /*AArch64::G_REV16*//*Label 133*/ GIMT_Encode4(428920),
     /*   3330 */ /*AArch64::G_REV32*//*Label 134*/ GIMT_Encode4(429074),
     /*   3334 */ /*AArch64::G_REV64*//*Label 135*/ GIMT_Encode4(429250),
     /*   3338 */ /*AArch64::G_SADDLP*//*Label 136*/ GIMT_Encode4(429524),
     /*   3342 */ /*AArch64::G_SADDLV*//*Label 137*/ GIMT_Encode4(429730),
     /*   3346 */ /*AArch64::G_SDOT*//*Label 138*/ GIMT_Encode4(430129),
     /*   3350 */ /*AArch64::G_SITOF*//*Label 139*/ GIMT_Encode4(430499),
     /*   3354 */ /*AArch64::G_SMULL*//*Label 140*/ GIMT_Encode4(430616),
     /*   3358 */ /*AArch64::G_TRN1*//*Label 141*/ GIMT_Encode4(431849),
     /*   3362 */ /*AArch64::G_TRN2*//*Label 142*/ GIMT_Encode4(432629),
     /*   3366 */ /*AArch64::G_UADDLP*//*Label 143*/ GIMT_Encode4(433409),
     /*   3370 */ /*AArch64::G_UADDLV*//*Label 144*/ GIMT_Encode4(433615),
     /*   3374 */ /*AArch64::G_UDOT*//*Label 145*/ GIMT_Encode4(434482),
     /*   3378 */ /*AArch64::G_UITOF*//*Label 146*/ GIMT_Encode4(434852),
     /*   3382 */ /*AArch64::G_UMULL*//*Label 147*/ GIMT_Encode4(434969),
     /*   3386 */ /*AArch64::G_UZP1*//*Label 148*/ GIMT_Encode4(436202),
     /*   3390 */ /*AArch64::G_UZP2*//*Label 149*/ GIMT_Encode4(436982),
     /*   3394 */ /*AArch64::G_VASHR*//*Label 150*/ GIMT_Encode4(437762),
     /*   3398 */ /*AArch64::G_VLSHR*//*Label 151*/ GIMT_Encode4(438460),
     /*   3402 */ /*AArch64::G_ZIP1*//*Label 152*/ GIMT_Encode4(438916),
     /*   3406 */ /*AArch64::G_ZIP2*//*Label 153*/ GIMT_Encode4(439696),
     /*   3410 */ // Label 0: @3410
     /*   3410 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 168*/ GIMT_Encode4(37016),
     /*   3421 */ /*GILLT_s32*//*Label 155*/ GIMT_Encode4(3509),
     /*   3425 */ /*GILLT_s64*//*Label 156*/ GIMT_Encode4(6288), GIMT_Encode4(0),
     /*   3433 */ /*GILLT_v2s32*//*Label 157*/ GIMT_Encode4(12228),
     /*   3437 */ /*GILLT_v2s64*//*Label 158*/ GIMT_Encode4(15836),
     /*   3441 */ /*GILLT_v4s16*//*Label 159*/ GIMT_Encode4(21738),
     /*   3445 */ /*GILLT_v4s32*//*Label 160*/ GIMT_Encode4(25236),
     /*   3449 */ /*GILLT_v8s8*//*Label 161*/ GIMT_Encode4(31414),
     /*   3453 */ /*GILLT_v8s16*//*Label 162*/ GIMT_Encode4(32264),
     /*   3457 */ /*GILLT_v16s8*//*Label 163*/ GIMT_Encode4(35842), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3477 */ /*GILLT_nxv2s64*//*Label 164*/ GIMT_Encode4(36566), GIMT_Encode4(0), GIMT_Encode4(0),
     /*   3489 */ /*GILLT_nxv4s32*//*Label 165*/ GIMT_Encode4(36938), GIMT_Encode4(0),
     /*   3497 */ /*GILLT_nxv8s16*//*Label 166*/ GIMT_Encode4(36964), GIMT_Encode4(0),
     /*   3505 */ /*GILLT_nxv16s8*//*Label 167*/ GIMT_Encode4(36990),
     /*   3509 */ // Label 155: @3509
     /*   3509 */ GIM_Try, /*On fail goto*//*Label 169*/ GIMT_Encode4(6287),
     /*   3514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*   3517 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*   3520 */   GIM_Try, /*On fail goto*//*Label 170*/ GIMT_Encode4(3553), // Rule ID 13279 //
     /*   3525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   3533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   3540 */     // (add:{ *:[i32] } addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   3540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   3543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   3545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   3547 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   3551 */     GIR_RootConstrainSelectedInstOperands,
     /*   3552 */     // GIR_Coverage, 13279,
     /*   3552 */     GIR_EraseRootFromParent_Done,
     /*   3553 */   // Label 170: @3553
     /*   3553 */   GIM_Try, /*On fail goto*//*Label 171*/ GIMT_Encode4(3705), // Rule ID 13716 //
     /*   3558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3561 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3585 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3588 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   3593 */     // MIs[2] pattern
     /*   3593 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3596 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3607 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3607 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3610 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3614 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3619 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3621 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3624 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3628 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3633 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3636 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3640 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3653 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   3665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3670 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3687 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3694 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3699 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3704 */     // GIR_Coverage, 13716,
     /*   3704 */     GIR_EraseRootFromParent_Done,
     /*   3705 */   // Label 171: @3705
     /*   3705 */   GIM_Try, /*On fail goto*//*Label 172*/ GIMT_Encode4(3857), // Rule ID 15570 //
     /*   3710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3737 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3740 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   3745 */     // MIs[2] pattern
     /*   3745 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3748 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3759 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   3817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3829 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3832 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3839 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   3856 */     // GIR_Coverage, 15570,
     /*   3856 */     GIR_EraseRootFromParent_Done,
     /*   3857 */   // Label 172: @3857
     /*   3857 */   GIM_Try, /*On fail goto*//*Label 173*/ GIMT_Encode4(4009), // Rule ID 15582 //
     /*   3862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   3865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   3873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   3877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   3881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   3885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   3889 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   3892 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   3897 */     // MIs[2] pattern
     /*   3897 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   3900 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   3905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   3911 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   3911 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   3914 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   3918 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3923 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   3925 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   3928 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   3932 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3937 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   3940 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   3944 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   3947 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3952 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   3957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   3962 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   3965 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   3969 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   3974 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   3977 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   3981 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   3984 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   3986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   3989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   3991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   3998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4008 */     // GIR_Coverage, 15582,
     /*   4008 */     GIR_EraseRootFromParent_Done,
     /*   4009 */   // Label 173: @4009
     /*   4009 */   GIM_Try, /*On fail goto*//*Label 174*/ GIMT_Encode4(4161), // Rule ID 15594 //
     /*   4014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4037 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4041 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4044 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4049 */     // MIs[2] pattern
     /*   4049 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4052 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4057 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4061 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4063 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)), GPR32:{ *:[i32] }:$Rdn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4063 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4066 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4070 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4075 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4077 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4080 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4084 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4089 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4092 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rdn
     /*   4096 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4099 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4104 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4109 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4126 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4129 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4133 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4136 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4143 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4150 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4155 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4160 */     // GIR_Coverage, 15594,
     /*   4160 */     GIR_EraseRootFromParent_Done,
     /*   4161 */   // Label 174: @4161
     /*   4161 */   GIM_Try, /*On fail goto*//*Label 175*/ GIMT_Encode4(4194), // Rule ID 91 //
     /*   4166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4170 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   4174 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*   4181 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   4181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*   4184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   4186 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   4188 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   4192 */     GIR_RootConstrainSelectedInstOperands,
     /*   4193 */     // GIR_Coverage, 91,
     /*   4193 */     GIR_EraseRootFromParent_Done,
     /*   4194 */   // Label 175: @4194
     /*   4194 */   GIM_Try, /*On fail goto*//*Label 176*/ GIMT_Encode4(4346), // Rule ID 2652 //
     /*   4199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4218 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4222 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4226 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4230 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4233 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   4238 */     // MIs[2] pattern
     /*   4238 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4241 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4246 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4248 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4248 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4251 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4255 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4260 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4262 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4265 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4269 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4274 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4277 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4281 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4284 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4289 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4294 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   4306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4311 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4314 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4318 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4321 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4328 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4340 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4345 */     // GIR_Coverage, 2652,
     /*   4345 */     GIR_EraseRootFromParent_Done,
     /*   4346 */   // Label 176: @4346
     /*   4346 */   GIM_Try, /*On fail goto*//*Label 177*/ GIMT_Encode4(4498), // Rule ID 9995 //
     /*   4351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4382 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4385 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   4390 */     // MIs[2] pattern
     /*   4390 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4393 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4400 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4400 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4403 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4407 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4414 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4417 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4421 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4426 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4429 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4433 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4436 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4441 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4446 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   4458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4463 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4473 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4480 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4487 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4492 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4497 */     // GIR_Coverage, 9995,
     /*   4497 */     GIR_EraseRootFromParent_Done,
     /*   4498 */   // Label 177: @4498
     /*   4498 */   GIM_Try, /*On fail goto*//*Label 178*/ GIMT_Encode4(4650), // Rule ID 10007 //
     /*   4503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4510 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4534 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4537 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   4542 */     // MIs[2] pattern
     /*   4542 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4545 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4552 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4552 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4555 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4559 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4564 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4566 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4569 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4573 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4578 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4581 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4585 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4588 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4593 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4598 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4603 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4606 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   4610 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4622 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4632 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4649 */     // GIR_Coverage, 10007,
     /*   4649 */     GIR_EraseRootFromParent_Done,
     /*   4650 */   // Label 178: @4650
     /*   4650 */   GIM_Try, /*On fail goto*//*Label 179*/ GIMT_Encode4(4802), // Rule ID 10019 //
     /*   4655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   4658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   4670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4686 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*   4689 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   4694 */     // MIs[2] pattern
     /*   4694 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*   4697 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   4702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4704 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*   4704 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4707 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4711 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4716 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4718 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4721 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4725 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4730 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4733 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*   4737 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4750 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   4762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*   4774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*   4777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4784 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4801 */     // GIR_Coverage, 10019,
     /*   4801 */     GIR_EraseRootFromParent_Done,
     /*   4802 */   // Label 179: @4802
     /*   4802 */   GIM_Try, /*On fail goto*//*Label 180*/ GIMT_Encode4(4959), // Rule ID 15613 //
     /*   4807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4834 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4837 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   4846 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   4848 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   4853 */     // MIs[2] pred
     /*   4853 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   4858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   4864 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   4864 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   4867 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   4871 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   4878 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   4881 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   4885 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4890 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   4893 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   4897 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   4900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   4910 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4915 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   4918 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   4922 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   4927 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   4931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   4934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   4936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   4939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   4941 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   4948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   4958 */     // GIR_Coverage, 15613,
     /*   4958 */     GIR_EraseRootFromParent_Done,
     /*   4959 */   // Label 180: @4959
     /*   4959 */   GIM_Try, /*On fail goto*//*Label 181*/ GIMT_Encode4(5116), // Rule ID 15614 //
     /*   4964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   4967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   4971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   4975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   4979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   4983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   4987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   4991 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   4994 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   4999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5003 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5005 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5010 */     // MIs[2] pred
     /*   5010 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5021 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5021 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5024 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5028 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5035 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5038 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5042 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5047 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5050 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5054 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5067 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5084 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5091 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5098 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5115 */     // GIR_Coverage, 15614,
     /*   5115 */     GIR_EraseRootFromParent_Done,
     /*   5116 */   // Label 181: @5116
     /*   5116 */   GIM_Try, /*On fail goto*//*Label 182*/ GIMT_Encode4(5273), // Rule ID 15615 //
     /*   5121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5148 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5151 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5156 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5160 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5162 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5167 */     // MIs[2] pred
     /*   5167 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5178 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5178 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5181 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5185 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5190 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5192 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5195 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5199 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5204 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5207 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5211 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5224 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5241 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5245 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5248 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5255 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5272 */     // GIR_Coverage, 15615,
     /*   5272 */     GIR_EraseRootFromParent_Done,
     /*   5273 */   // Label 182: @5273
     /*   5273 */   GIM_Try, /*On fail goto*//*Label 183*/ GIMT_Encode4(5430), // Rule ID 15616 //
     /*   5278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   5289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5305 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5308 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5313 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5317 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5319 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5324 */     // MIs[2] pred
     /*   5324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5335 */     // (add:{ *:[i32] } (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>), GPR32:{ *:[i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5335 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5338 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5342 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5347 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5349 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5352 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5356 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5361 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5364 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   5368 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5381 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   5393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5402 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5412 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5429 */     // GIR_Coverage, 15616,
     /*   5429 */     GIR_EraseRootFromParent_Done,
     /*   5430 */   // Label 183: @5430
     /*   5430 */   GIM_Try, /*On fail goto*//*Label 184*/ GIMT_Encode4(5587), // Rule ID 10111 //
     /*   5435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5466 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5469 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*   5478 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5480 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5485 */     // MIs[2] pred
     /*   5485 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5492 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5492 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5495 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5499 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5506 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5509 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5513 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5518 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5521 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5525 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5528 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5533 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5538 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5543 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5546 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*   5550 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5555 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5569 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5586 */     // GIR_Coverage, 10111,
     /*   5586 */     GIR_EraseRootFromParent_Done,
     /*   5587 */   // Label 184: @5587
     /*   5587 */   GIM_Try, /*On fail goto*//*Label 185*/ GIMT_Encode4(5744), // Rule ID 10112 //
     /*   5592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5623 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5626 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*   5635 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5637 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5642 */     // MIs[2] pred
     /*   5642 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5647 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5649 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5649 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5652 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5656 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5663 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5666 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5670 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5675 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5678 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5682 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5685 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5690 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*   5707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5719 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5726 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5733 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5738 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5743 */     // GIR_Coverage, 10112,
     /*   5743 */     GIR_EraseRootFromParent_Done,
     /*   5744 */   // Label 185: @5744
     /*   5744 */   GIM_Try, /*On fail goto*//*Label 186*/ GIMT_Encode4(5901), // Rule ID 10113 //
     /*   5749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5780 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5783 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5788 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*   5792 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5794 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5799 */     // MIs[2] pred
     /*   5799 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5806 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5806 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5809 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5813 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5820 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5823 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5827 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5832 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5835 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5839 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5842 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   5852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   5860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*   5864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5869 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   5873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   5876 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   5878 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   5881 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   5883 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   5890 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5895 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   5900 */     // GIR_Coverage, 10113,
     /*   5900 */     GIR_EraseRootFromParent_Done,
     /*   5901 */   // Label 186: @5901
     /*   5901 */   GIM_Try, /*On fail goto*//*Label 187*/ GIMT_Encode4(6058), // Rule ID 10114 //
     /*   5906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*   5909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   5917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   5921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*   5925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   5929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   5933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   5937 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*   5940 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*   5945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*   5949 */     GIM_CheckHasOneUse, /*MI*/2,
     /*   5951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*   5956 */     // MIs[2] pred
     /*   5956 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*   5961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   5963 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*   5963 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*   5966 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   5970 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5975 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   5977 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*   5980 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   5984 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   5989 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   5992 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*   5996 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*   5999 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6004 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*   6009 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*   6017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*   6021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*   6030 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   6033 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6040 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*   6047 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6052 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   6057 */     // GIR_Coverage, 10114,
     /*   6057 */     GIR_EraseRootFromParent_Done,
     /*   6058 */   // Label 187: @6058
     /*   6058 */   GIM_Try, /*On fail goto*//*Label 188*/ GIMT_Encode4(6091), // Rule ID 13283 //
     /*   6063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6067 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6078 */     // (add:{ *:[i32] } arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend, GPR32sp:{ *:[i32] }:$Rn)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6085 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6089 */     GIR_RootConstrainSelectedInstOperands,
     /*   6090 */     // GIR_Coverage, 13283,
     /*   6090 */     GIR_EraseRootFromParent_Done,
     /*   6091 */   // Label 188: @6091
     /*   6091 */   GIM_Try, /*On fail goto*//*Label 189*/ GIMT_Encode4(6127), // Rule ID 13856 //
     /*   6096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6104 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6111 */     // (add:{ *:[i32] } neg_addsub_shifted_imm32:{ *:[i32] }:$imm, GPR32:{ *:[i32] }:$Rn)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6118 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6122 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6125 */     GIR_RootConstrainSelectedInstOperands,
     /*   6126 */     // GIR_Coverage, 13856,
     /*   6126 */     GIR_EraseRootFromParent_Done,
     /*   6127 */   // Label 189: @6127
     /*   6127 */   GIM_Try, /*On fail goto*//*Label 190*/ GIMT_Encode4(6160), // Rule ID 97 //
     /*   6132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6136 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*   6140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*   6147 */     // (add:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)  =>  (ADDWrx:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, arith_extended_reg32_i32:{ *:[i32] }:$Rm_and_extend)
     /*   6147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrx),
     /*   6150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6154 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*   6158 */     GIR_RootConstrainSelectedInstOperands,
     /*   6159 */     // GIR_Coverage, 97,
     /*   6159 */     GIR_EraseRootFromParent_Done,
     /*   6160 */   // Label 190: @6160
     /*   6160 */   GIM_Try, /*On fail goto*//*Label 191*/ GIMT_Encode4(6196), // Rule ID 3920 //
     /*   6165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*   6180 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*   6180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*   6183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6187 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   6191 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*   6194 */     GIR_RootConstrainSelectedInstOperands,
     /*   6195 */     // GIR_Coverage, 3920,
     /*   6195 */     GIR_EraseRootFromParent_Done,
     /*   6196 */   // Label 191: @6196
     /*   6196 */   GIM_Try, /*On fail goto*//*Label 192*/ GIMT_Encode4(6229), // Rule ID 13281 //
     /*   6201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6209 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6216 */     // (add:{ *:[i32] } arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   6223 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6227 */     GIR_RootConstrainSelectedInstOperands,
     /*   6228 */     // GIR_Coverage, 13281,
     /*   6228 */     GIR_EraseRootFromParent_Done,
     /*   6229 */   // Label 192: @6229
     /*   6229 */   GIM_Try, /*On fail goto*//*Label 193*/ GIMT_Encode4(6262), // Rule ID 95 //
     /*   6234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6238 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6242 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*   6249 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ADDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*   6249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWrs),
     /*   6252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   6254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   6256 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*   6260 */     GIR_RootConstrainSelectedInstOperands,
     /*   6261 */     // GIR_Coverage, 95,
     /*   6261 */     GIR_EraseRootFromParent_Done,
     /*   6262 */   // Label 193: @6262
     /*   6262 */   GIM_Try, /*On fail goto*//*Label 194*/ GIMT_Encode4(6286), // Rule ID 93 //
     /*   6267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   6279 */     // (add:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ADDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*   6279 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDWrr),
     /*   6284 */     GIR_RootConstrainSelectedInstOperands,
     /*   6285 */     // GIR_Coverage, 93,
     /*   6285 */     GIR_Done,
     /*   6286 */   // Label 194: @6286
     /*   6286 */   GIM_Reject,
     /*   6287 */ // Label 169: @6287
     /*   6287 */ GIM_Reject,
     /*   6288 */ // Label 156: @6288
     /*   6288 */ GIM_Try, /*On fail goto*//*Label 195*/ GIMT_Encode4(12227),
     /*   6293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*   6296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*   6299 */   GIM_Try, /*On fail goto*//*Label 196*/ GIMT_Encode4(6435), // Rule ID 5391 //
     /*   6304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6308 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6312 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6316 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6320 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6324 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6328 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6337 */     // MIs[1] Operand 2
     /*   6337 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6348 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6352 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6356 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6360 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6364 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6368 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6372 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6377 */     // MIs[3] Operand 2
     /*   6377 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6388 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6390 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6406 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6417 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6424 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6429 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6434 */     // GIR_Coverage, 5391,
     /*   6434 */     GIR_EraseRootFromParent_Done,
     /*   6435 */   // Label 196: @6435
     /*   6435 */   GIM_Try, /*On fail goto*//*Label 197*/ GIMT_Encode4(6571), // Rule ID 5390 //
     /*   6440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6452 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6468 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6473 */     // MIs[1] Operand 2
     /*   6473 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6484 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6488 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6492 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6500 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6504 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6508 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6513 */     // MIs[3] Operand 2
     /*   6513 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6524 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6526 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6542 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6546 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6553 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6560 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6565 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6570 */     // GIR_Coverage, 5390,
     /*   6570 */     GIR_EraseRootFromParent_Done,
     /*   6571 */   // Label 197: @6571
     /*   6571 */   GIM_Try, /*On fail goto*//*Label 198*/ GIMT_Encode4(6707), // Rule ID 5400 //
     /*   6576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6609 */     // MIs[1] Operand 2
     /*   6609 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6628 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6632 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6636 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   6640 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6644 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6649 */     // MIs[3] Operand 2
     /*   6649 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6660 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6662 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6662 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6665 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*   6669 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6674 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6678 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6682 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6706 */     // GIR_Coverage, 5400,
     /*   6706 */     GIR_EraseRootFromParent_Done,
     /*   6707 */   // Label 198: @6707
     /*   6707 */   GIM_Try, /*On fail goto*//*Label 199*/ GIMT_Encode4(6843), // Rule ID 5389 //
     /*   6712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6724 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6745 */     // MIs[1] Operand 2
     /*   6745 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6768 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6772 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   6776 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6780 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6785 */     // MIs[3] Operand 2
     /*   6785 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6796 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6798 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6798 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6801 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6805 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6810 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6814 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6818 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6825 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6842 */     // GIR_Coverage, 5389,
     /*   6842 */     GIR_EraseRootFromParent_Done,
     /*   6843 */   // Label 199: @6843
     /*   6843 */   GIM_Try, /*On fail goto*//*Label 200*/ GIMT_Encode4(6979), // Rule ID 5388 //
     /*   6848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   6868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6872 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6876 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6881 */     // MIs[1] Operand 2
     /*   6881 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   6892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*   6896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   6900 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   6904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*   6908 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   6912 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   6916 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6921 */     // MIs[3] Operand 2
     /*   6921 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*   6932 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*   6934 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   6934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   6937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*   6941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   6946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   6950 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*   6954 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   6956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   6959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   6961 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   6968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6973 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   6978 */     // GIR_Coverage, 5388,
     /*   6978 */     GIR_EraseRootFromParent_Done,
     /*   6979 */   // Label 200: @6979
     /*   6979 */   GIM_Try, /*On fail goto*//*Label 201*/ GIMT_Encode4(7047), // Rule ID 6947 //
     /*   6984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   6988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   6992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   6996 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7000 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7004 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7009 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /*   7013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7021 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7025 */     // MIs[2] Rn
     /*   7025 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7030 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /*   7034 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7036 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7045 */     GIR_RootConstrainSelectedInstOperands,
     /*   7046 */     // GIR_Coverage, 6947,
     /*   7046 */     GIR_EraseRootFromParent_Done,
     /*   7047 */   // Label 201: @7047
     /*   7047 */   GIM_Try, /*On fail goto*//*Label 202*/ GIMT_Encode4(7115), // Rule ID 14014 //
     /*   7052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   7056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   7068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   7077 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /*   7081 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*   7085 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*   7089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*   7093 */     // MIs[2] Rn
     /*   7093 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*   7098 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /*   7102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   7104 */     // (add:{ *:[i64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (ADDPv2i64p:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn)
     /*   7104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /*   7107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*   7113 */     GIR_RootConstrainSelectedInstOperands,
     /*   7114 */     // GIR_Coverage, 14014,
     /*   7114 */     GIR_EraseRootFromParent_Done,
     /*   7115 */   // Label 202: @7115
     /*   7115 */   GIM_Try, /*On fail goto*//*Label 203*/ GIMT_Encode4(7148), // Rule ID 13280 //
     /*   7120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7128 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7135 */     // (add:{ *:[i64] } addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*   7142 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7146 */     GIR_RootConstrainSelectedInstOperands,
     /*   7147 */     // GIR_Coverage, 13280,
     /*   7147 */     GIR_EraseRootFromParent_Done,
     /*   7148 */   // Label 203: @7148
     /*   7148 */   GIM_Try, /*On fail goto*//*Label 204*/ GIMT_Encode4(7281), // Rule ID 3972 //
     /*   7153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7190 */     // MIs[2] Operand 2
     /*   7190 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7201 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7205 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7209 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7213 */     // MIs[3] Operand 1
     /*   7213 */     // No operand predicates
     /*   7213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7219 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7231 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7238 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7241 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7245 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7250 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7256 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7261 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7271 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7279 */     GIR_RootConstrainSelectedInstOperands,
     /*   7280 */     // GIR_Coverage, 3972,
     /*   7280 */     GIR_EraseRootFromParent_Done,
     /*   7281 */   // Label 204: @7281
     /*   7281 */   GIM_Try, /*On fail goto*//*Label 205*/ GIMT_Encode4(7376), // Rule ID 3970 //
     /*   7286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7302 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7306 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7310 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7314 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7323 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7327 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7331 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7335 */     // MIs[3] Operand 1
     /*   7335 */     // No operand predicates
     /*   7335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7339 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7341 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7341 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7344 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7348 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7353 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7358 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7369 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7374 */     GIR_RootConstrainSelectedInstOperands,
     /*   7375 */     // GIR_Coverage, 3970,
     /*   7375 */     GIR_EraseRootFromParent_Done,
     /*   7376 */   // Label 205: @7376
     /*   7376 */   GIM_Try, /*On fail goto*//*Label 206*/ GIMT_Encode4(7471), // Rule ID 3971 //
     /*   7381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7430 */     // MIs[3] Operand 1
     /*   7430 */     // No operand predicates
     /*   7430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7436 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7436 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7439 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7443 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7448 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7469 */     GIR_RootConstrainSelectedInstOperands,
     /*   7470 */     // GIR_Coverage, 3971,
     /*   7470 */     GIR_EraseRootFromParent_Done,
     /*   7471 */   // Label 206: @7471
     /*   7471 */   GIM_Try, /*On fail goto*//*Label 207*/ GIMT_Encode4(7504), // Rule ID 92 //
     /*   7476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*   7484 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*   7491 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*   7491 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*   7494 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7496 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*   7498 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*   7502 */     GIR_RootConstrainSelectedInstOperands,
     /*   7503 */     // GIR_Coverage, 92,
     /*   7503 */     GIR_EraseRootFromParent_Done,
     /*   7504 */   // Label 207: @7504
     /*   7504 */   GIM_Try, /*On fail goto*//*Label 208*/ GIMT_Encode4(7637), // Rule ID 13866 //
     /*   7509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7513 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*   7541 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*   7545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7550 */     // MIs[2] Operand 2
     /*   7550 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*   7561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7569 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7573 */     // MIs[3] Operand 1
     /*   7573 */     // No operand predicates
     /*   7573 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7575 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7575 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*   7578 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7582 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7587 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*   7594 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7597 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   7601 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7606 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   7612 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7617 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7627 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*   7633 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7635 */     GIR_RootConstrainSelectedInstOperands,
     /*   7636 */     // GIR_Coverage, 13866,
     /*   7636 */     GIR_EraseRootFromParent_Done,
     /*   7637 */   // Label 208: @7637
     /*   7637 */   GIM_Try, /*On fail goto*//*Label 209*/ GIMT_Encode4(7732), // Rule ID 13864 //
     /*   7642 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7646 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7678 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7691 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*   7695 */     // MIs[3] Operand 1
     /*   7695 */     // No operand predicates
     /*   7695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7697 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7709 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7730 */     GIR_RootConstrainSelectedInstOperands,
     /*   7731 */     // GIR_Coverage, 13864,
     /*   7731 */     GIR_EraseRootFromParent_Done,
     /*   7732 */   // Label 209: @7732
     /*   7732 */   GIM_Try, /*On fail goto*//*Label 210*/ GIMT_Encode4(7827), // Rule ID 13865 //
     /*   7737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7741 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   7749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7757 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7778 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7782 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*   7786 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*   7790 */     // MIs[3] Operand 1
     /*   7790 */     // No operand predicates
     /*   7790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7792 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*   7792 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   7795 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*   7799 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   7804 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*   7809 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   7811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7820 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   7823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   7825 */     GIR_RootConstrainSelectedInstOperands,
     /*   7826 */     // GIR_Coverage, 13865,
     /*   7826 */     GIR_EraseRootFromParent_Done,
     /*   7827 */   // Label 210: @7827
     /*   7827 */   GIM_Try, /*On fail goto*//*Label 211*/ GIMT_Encode4(7909), // Rule ID 13291 //
     /*   7832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7869 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7873 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   7877 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7881 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7892 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   7895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7907 */     GIR_RootConstrainSelectedInstOperands,
     /*   7908 */     // GIR_Coverage, 13291,
     /*   7908 */     GIR_EraseRootFromParent_Done,
     /*   7909 */   // Label 211: @7909
     /*   7909 */   GIM_Try, /*On fail goto*//*Label 212*/ GIMT_Encode4(7991), // Rule ID 13292 //
     /*   7914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   7922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   7926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   7930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   7934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   7938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   7946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   7955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   7959 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   7963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   7968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   7972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   7974 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   7974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   7977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   7979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   7983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   7987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   7989 */     GIR_RootConstrainSelectedInstOperands,
     /*   7990 */     // GIR_Coverage, 13292,
     /*   7990 */     GIR_EraseRootFromParent_Done,
     /*   7991 */   // Label 212: @7991
     /*   7991 */   GIM_Try, /*On fail goto*//*Label 213*/ GIMT_Encode4(8073), // Rule ID 123 //
     /*   7996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8000 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8032 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8037 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8041 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   8045 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8049 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8054 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8056 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*   8059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8069 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8071 */     GIR_RootConstrainSelectedInstOperands,
     /*   8072 */     // GIR_Coverage, 123,
     /*   8072 */     GIR_EraseRootFromParent_Done,
     /*   8073 */   // Label 213: @8073
     /*   8073 */   GIM_Try, /*On fail goto*//*Label 214*/ GIMT_Encode4(8155), // Rule ID 125 //
     /*   8078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8082 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8102 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8106 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8110 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8114 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*   8123 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8127 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*   8131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8136 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*   8138 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   8147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*   8151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8153 */     GIR_RootConstrainSelectedInstOperands,
     /*   8154 */     // GIR_Coverage, 125,
     /*   8154 */     GIR_EraseRootFromParent_Done,
     /*   8155 */   // Label 214: @8155
     /*   8155 */   GIM_Try, /*On fail goto*//*Label 215*/ GIMT_Encode4(8213), // Rule ID 13711 //
     /*   8160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8175 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8178 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8183 */     // MIs[1] pattern
     /*   8183 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8186 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8195 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8197 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8204 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8211 */     GIR_RootConstrainSelectedInstOperands,
     /*   8212 */     // GIR_Coverage, 13711,
     /*   8212 */     GIR_EraseRootFromParent_Done,
     /*   8213 */   // Label 215: @8213
     /*   8213 */   GIM_Try, /*On fail goto*//*Label 216*/ GIMT_Encode4(8271), // Rule ID 15565 //
     /*   8218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8233 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8236 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8241 */     // MIs[1] pattern
     /*   8241 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8244 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8255 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8262 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8269 */     GIR_RootConstrainSelectedInstOperands,
     /*   8270 */     // GIR_Coverage, 15565,
     /*   8270 */     GIR_EraseRootFromParent_Done,
     /*   8271 */   // Label 216: @8271
     /*   8271 */   GIM_Try, /*On fail goto*//*Label 217*/ GIMT_Encode4(8329), // Rule ID 15577 //
     /*   8276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8291 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8294 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8299 */     // MIs[1] pattern
     /*   8299 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8302 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8313 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8324 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8327 */     GIR_RootConstrainSelectedInstOperands,
     /*   8328 */     // GIR_Coverage, 15577,
     /*   8328 */     GIR_EraseRootFromParent_Done,
     /*   8329 */   // Label 217: @8329
     /*   8329 */   GIM_Try, /*On fail goto*//*Label 218*/ GIMT_Encode4(8387), // Rule ID 15589 //
     /*   8334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8349 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8352 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8357 */     // MIs[1] pattern
     /*   8357 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8360 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8371 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern), GPR64:{ *:[i64] }:$Rdn)  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rdn
     /*   8378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8385 */     GIR_RootConstrainSelectedInstOperands,
     /*   8386 */     // GIR_Coverage, 15589,
     /*   8386 */     GIR_EraseRootFromParent_Done,
     /*   8387 */   // Label 218: @8387
     /*   8387 */   GIM_Try, /*On fail goto*//*Label 219*/ GIMT_Encode4(8484), // Rule ID 3987 //
     /*   8392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8412 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8429 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8440 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8452 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8463 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8473 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8476 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8482 */     GIR_RootConstrainSelectedInstOperands,
     /*   8483 */     // GIR_Coverage, 3987,
     /*   8483 */     GIR_EraseRootFromParent_Done,
     /*   8484 */   // Label 219: @8484
     /*   8484 */   GIM_Try, /*On fail goto*//*Label 220*/ GIMT_Encode4(8581), // Rule ID 13876 //
     /*   8489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   8497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8526 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8531 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8535 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8537 */     // (add:{ *:[i64] } (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8537 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8540 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8544 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8549 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8570 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*   8579 */     GIR_RootConstrainSelectedInstOperands,
     /*   8580 */     // GIR_Coverage, 13876,
     /*   8580 */     GIR_EraseRootFromParent_Done,
     /*   8581 */   // Label 220: @8581
     /*   8581 */   GIM_Try, /*On fail goto*//*Label 221*/ GIMT_Encode4(8639), // Rule ID 2649 //
     /*   8586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8605 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8608 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*   8613 */     // MIs[1] pattern
     /*   8613 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8616 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8621 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8623 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCB_XPiI),
     /*   8626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8630 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8637 */     GIR_RootConstrainSelectedInstOperands,
     /*   8638 */     // GIR_Coverage, 2649,
     /*   8638 */     GIR_EraseRootFromParent_Done,
     /*   8639 */   // Label 221: @8639
     /*   8639 */   GIM_Try, /*On fail goto*//*Label 222*/ GIMT_Encode4(8697), // Rule ID 9992 //
     /*   8644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8651 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8663 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8666 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*   8671 */     // MIs[1] pattern
     /*   8671 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8674 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8681 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCH_XPiI),
     /*   8684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8695 */     GIR_RootConstrainSelectedInstOperands,
     /*   8696 */     // GIR_Coverage, 9992,
     /*   8696 */     GIR_EraseRootFromParent_Done,
     /*   8697 */   // Label 222: @8697
     /*   8697 */   GIM_Try, /*On fail goto*//*Label 223*/ GIMT_Encode4(8755), // Rule ID 10004 //
     /*   8702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8709 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8721 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8724 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*   8729 */     // MIs[1] pattern
     /*   8729 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8732 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8739 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCW_XPiI),
     /*   8742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8750 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8753 */     GIR_RootConstrainSelectedInstOperands,
     /*   8754 */     // GIR_Coverage, 10004,
     /*   8754 */     GIR_EraseRootFromParent_Done,
     /*   8755 */   // Label 223: @8755
     /*   8755 */   GIM_Try, /*On fail goto*//*Label 224*/ GIMT_Encode4(8813), // Rule ID 10016 //
     /*   8760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*   8763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8767 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*   8779 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*   8782 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*   8787 */     // MIs[1] pattern
     /*   8787 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*   8790 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*   8795 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*   8797 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (INCD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*   8797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCD_XPiI),
     /*   8800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*   8802 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*   8804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*   8808 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*   8811 */     GIR_RootConstrainSelectedInstOperands,
     /*   8812 */     // GIR_Coverage, 10016,
     /*   8812 */     GIR_EraseRootFromParent_Done,
     /*   8813 */   // Label 224: @8813
     /*   8813 */   GIM_Try, /*On fail goto*//*Label 225*/ GIMT_Encode4(8910), // Rule ID 13877 //
     /*   8818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8838 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8842 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8847 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*   8851 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8855 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8859 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8864 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8866 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8866 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8869 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8873 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8878 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8884 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   8906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   8908 */     GIR_RootConstrainSelectedInstOperands,
     /*   8909 */     // GIR_Coverage, 13877,
     /*   8909 */     GIR_EraseRootFromParent_Done,
     /*   8910 */   // Label 225: @8910
     /*   8910 */   GIM_Try, /*On fail goto*//*Label 226*/ GIMT_Encode4(9007), // Rule ID 13878 //
     /*   8915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   8927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*   8931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*   8935 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*   8939 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   8943 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   8947 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*   8951 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8956 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*   8961 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   8963 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*   8963 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*   8966 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   8970 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   8975 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*   8981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*   8986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*   8991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*   8994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*   8996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*   8999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*   9005 */     GIR_RootConstrainSelectedInstOperands,
     /*   9006 */     // GIR_Coverage, 13878,
     /*   9006 */     GIR_EraseRootFromParent_Done,
     /*   9007 */   // Label 226: @9007
     /*   9007 */   GIM_Try, /*On fail goto*//*Label 227*/ GIMT_Encode4(9170), // Rule ID 13986 //
     /*   9012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9024 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9036 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9040 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9044 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9049 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9054 */     // MIs[1] Operand 2
     /*   9054 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9069 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9071 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9071 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9074 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9078 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9083 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9085 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9088 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9092 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9097 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9100 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9104 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9107 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9122 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9125 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9129 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9134 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9137 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9145 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9152 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9169 */     // GIR_Coverage, 13986,
     /*   9169 */     GIR_EraseRootFromParent_Done,
     /*   9170 */   // Label 227: @9170
     /*   9170 */   GIM_Try, /*On fail goto*//*Label 228*/ GIMT_Encode4(9333), // Rule ID 13983 //
     /*   9175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9199 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9203 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9207 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9212 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9217 */     // MIs[1] Operand 2
     /*   9217 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9234 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9234 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9237 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9241 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9246 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9248 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9251 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9255 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9260 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9263 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*   9267 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9270 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9285 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9288 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*   9292 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9304 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9315 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9332 */     // GIR_Coverage, 13983,
     /*   9332 */     GIR_EraseRootFromParent_Done,
     /*   9333 */   // Label 228: @9333
     /*   9333 */   GIM_Try, /*On fail goto*//*Label 229*/ GIMT_Encode4(9483), // Rule ID 13992 //
     /*   9338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*   9362 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9366 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9371 */     // MIs[1] Operand 2
     /*   9371 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9386 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9388 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9388 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9391 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9395 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9402 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9405 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9409 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9414 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9417 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9421 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9424 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9429 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9451 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9458 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9465 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9472 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9482 */     // GIR_Coverage, 13992,
     /*   9482 */     GIR_EraseRootFromParent_Done,
     /*   9483 */   // Label 229: @9483
     /*   9483 */   GIM_Try, /*On fail goto*//*Label 230*/ GIMT_Encode4(9633), // Rule ID 13995 //
     /*   9488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*   9512 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9516 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9521 */     // MIs[1] Operand 2
     /*   9521 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9538 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9538 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9541 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9545 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9550 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9552 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9555 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9559 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9564 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9567 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9571 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9574 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9579 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*   9596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9601 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9608 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9615 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9632 */     // GIR_Coverage, 13995,
     /*   9632 */     GIR_EraseRootFromParent_Done,
     /*   9633 */   // Label 230: @9633
     /*   9633 */   GIM_Try, /*On fail goto*//*Label 231*/ GIMT_Encode4(9783), // Rule ID 13991 //
     /*   9638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*   9646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*   9662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9671 */     // MIs[1] Operand 2
     /*   9671 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9688 */     // (add:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v1i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9688 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9691 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9695 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9714 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9717 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*   9721 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9724 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9729 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9739 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9742 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*   9746 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9751 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*   9758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9782 */     // GIR_Coverage, 13991,
     /*   9782 */     GIR_EraseRootFromParent_Done,
     /*   9783 */   // Label 231: @9783
     /*   9783 */   GIM_Try, /*On fail goto*//*Label 232*/ GIMT_Encode4(9946), // Rule ID 5373 //
     /*   9788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9792 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9796 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9800 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9804 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*   9816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9834 */     // MIs[1] Operand 2
     /*   9834 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*   9845 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*   9847 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*   9847 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*   9850 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*   9854 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*   9861 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*   9864 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*   9868 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9873 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*   9876 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*   9880 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*   9883 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*   9901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*   9905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*   9910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*   9913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*   9917 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*   9921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*   9923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*   9926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*   9928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*   9935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*   9945 */     // GIR_Coverage, 5373,
     /*   9945 */     GIR_EraseRootFromParent_Done,
     /*   9946 */   // Label 232: @9946
     /*   9946 */   GIM_Try, /*On fail goto*//*Label 233*/ GIMT_Encode4(10109), // Rule ID 5370 //
     /*   9951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*   9963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*   9967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*   9971 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*   9975 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*   9979 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*   9983 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*   9987 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9992 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*   9997 */     // MIs[1] Operand 2
     /*   9997 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10008 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10010 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLALv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10010 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10013 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10017 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10024 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10027 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10031 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10036 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10039 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  10043 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10051 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10056 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  10068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10073 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10076 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  10080 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  10084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10091 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10103 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10108 */     // GIR_Coverage, 5370,
     /*  10108 */     GIR_EraseRootFromParent_Done,
     /*  10109 */   // Label 233: @10109
     /*  10109 */   GIM_Try, /*On fail goto*//*Label 234*/ GIMT_Encode4(10259), // Rule ID 5397 //
     /*  10114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  10142 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10151 */     // MIs[1] Operand 2
     /*  10151 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10164 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10164 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10167 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10171 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10176 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10178 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10181 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10185 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10190 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10193 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10197 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10205 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10210 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10215 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10218 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10222 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10230 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10241 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10248 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10258 */     // GIR_Coverage, 5397,
     /*  10258 */     GIR_EraseRootFromParent_Done,
     /*  10259 */   // Label 234: @10259
     /*  10259 */   GIM_Try, /*On fail goto*//*Label 235*/ GIMT_Encode4(10409), // Rule ID 5403 //
     /*  10264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10284 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10288 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  10292 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10296 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10301 */     // MIs[1] Operand 2
     /*  10301 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10314 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10314 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10317 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10321 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10328 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10331 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10335 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10340 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10343 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10350 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10355 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10360 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10365 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10368 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  10372 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10377 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10380 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10384 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10391 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10398 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10403 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10408 */     // GIR_Coverage, 5403,
     /*  10408 */     GIR_EraseRootFromParent_Done,
     /*  10409 */   // Label 235: @10409
     /*  10409 */   GIM_Try, /*On fail goto*//*Label 236*/ GIMT_Encode4(10559), // Rule ID 5396 //
     /*  10414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  10430 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  10434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  10438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  10442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  10446 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10451 */     // MIs[1] Operand 2
     /*  10451 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  10462 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  10464 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UADDWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  10464 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  10467 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  10471 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10476 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  10478 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  10481 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  10485 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10490 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  10493 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  10497 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  10500 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10505 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10510 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10515 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  10518 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  10522 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10527 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  10530 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  10534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  10536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  10541 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  10548 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  10553 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  10558 */     // GIR_Coverage, 5396,
     /*  10558 */     GIR_EraseRootFromParent_Done,
     /*  10559 */   // Label 236: @10559
     /*  10559 */   GIM_Try, /*On fail goto*//*Label 237*/ GIMT_Encode4(10592), // Rule ID 13284 //
     /*  10564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10572 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10579 */     // (add:{ *:[i64] } arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend, GPR64sp:{ *:[i64] }:$Rn)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10586 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10590 */     GIR_RootConstrainSelectedInstOperands,
     /*  10591 */     // GIR_Coverage, 13284,
     /*  10591 */     GIR_EraseRootFromParent_Done,
     /*  10592 */   // Label 237: @10592
     /*  10592 */   GIM_Try, /*On fail goto*//*Label 238*/ GIMT_Encode4(10628), // Rule ID 13857 //
     /*  10597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10605 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10612 */     // (add:{ *:[i64] } neg_addsub_shifted_imm64:{ *:[i64] }:$imm, GPR64:{ *:[i64] }:$Rn)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10619 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10623 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10626 */     GIR_RootConstrainSelectedInstOperands,
     /*  10627 */     // GIR_Coverage, 13857,
     /*  10627 */     GIR_EraseRootFromParent_Done,
     /*  10628 */   // Label 238: @10628
     /*  10628 */   GIM_Try, /*On fail goto*//*Label 239*/ GIMT_Encode4(10740), // Rule ID 3986 //
     /*  10633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10653 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10658 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10669 */     // (add:{ *:[i64] } (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm), GPR64:{ *:[i64] }:$Ra)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10669 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10672 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10676 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10681 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10692 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10709 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ra
     /*  10738 */     GIR_RootConstrainSelectedInstOperands,
     /*  10739 */     // GIR_Coverage, 3986,
     /*  10739 */     GIR_EraseRootFromParent_Done,
     /*  10740 */   // Label 239: @10740
     /*  10740 */   GIM_Try, /*On fail goto*//*Label 240*/ GIMT_Encode4(10773), // Rule ID 98 //
     /*  10745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  10753 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  10760 */     // (add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)  =>  (ADDXrx:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, arith_extended_reg32to64_i64:{ *:[i64] }:$Rm_and_extend)
     /*  10760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrx),
     /*  10763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10767 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_extend
     /*  10771 */     GIR_RootConstrainSelectedInstOperands,
     /*  10772 */     // GIR_Coverage, 98,
     /*  10772 */     GIR_EraseRootFromParent_Done,
     /*  10773 */   // Label 240: @10773
     /*  10773 */   GIM_Try, /*On fail goto*//*Label 241*/ GIMT_Encode4(10809), // Rule ID 3921 //
     /*  10778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10786 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  10793 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  10793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  10796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  10800 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  10804 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  10807 */     GIR_RootConstrainSelectedInstOperands,
     /*  10808 */     // GIR_Coverage, 3921,
     /*  10808 */     GIR_EraseRootFromParent_Done,
     /*  10809 */   // Label 241: @10809
     /*  10809 */   GIM_Try, /*On fail goto*//*Label 242*/ GIMT_Encode4(10921), // Rule ID 13875 //
     /*  10814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10818 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  10826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  10830 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  10834 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  10838 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10843 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  10848 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  10850 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  10850 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  10853 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10857 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10862 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  10868 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10873 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10878 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  10881 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  10885 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  10890 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  10896 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  10901 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  10909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10911 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  10914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  10917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  10919 */     GIR_RootConstrainSelectedInstOperands,
     /*  10920 */     // GIR_Coverage, 13875,
     /*  10920 */     GIR_EraseRootFromParent_Done,
     /*  10921 */   // Label 242: @10921
     /*  10921 */   GIM_Try, /*On fail goto*//*Label 243*/ GIMT_Encode4(10954), // Rule ID 13282 //
     /*  10926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10934 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  10941 */     // (add:{ *:[i64] } arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  10941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  10944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  10946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  10948 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  10952 */     GIR_RootConstrainSelectedInstOperands,
     /*  10953 */     // GIR_Coverage, 13282,
     /*  10953 */     GIR_EraseRootFromParent_Done,
     /*  10954 */   // Label 243: @10954
     /*  10954 */   GIM_Try, /*On fail goto*//*Label 244*/ GIMT_Encode4(11017), // Rule ID 15605 //
     /*  10959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  10962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  10966 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  10970 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  10974 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  10977 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  10982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  10986 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  10988 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  10993 */     // MIs[1] pred
     /*  10993 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  10998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11002 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11004 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11015 */     GIR_RootConstrainSelectedInstOperands,
     /*  11016 */     // GIR_Coverage, 15605,
     /*  11016 */     GIR_EraseRootFromParent_Done,
     /*  11017 */   // Label 244: @11017
     /*  11017 */   GIM_Try, /*On fail goto*//*Label 245*/ GIMT_Encode4(11080), // Rule ID 15606 //
     /*  11022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11037 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11040 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11049 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11056 */     // MIs[1] pred
     /*  11056 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11067 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11072 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11078 */     GIR_RootConstrainSelectedInstOperands,
     /*  11079 */     // GIR_Coverage, 15606,
     /*  11079 */     GIR_EraseRootFromParent_Done,
     /*  11080 */   // Label 245: @11080
     /*  11080 */   GIM_Try, /*On fail goto*//*Label 246*/ GIMT_Encode4(11143), // Rule ID 15607 //
     /*  11085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11092 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11096 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11100 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11103 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11112 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11119 */     // MIs[1] pred
     /*  11119 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11128 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11130 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11141 */     GIR_RootConstrainSelectedInstOperands,
     /*  11142 */     // GIR_Coverage, 15607,
     /*  11142 */     GIR_EraseRootFromParent_Done,
     /*  11143 */   // Label 246: @11143
     /*  11143 */   GIM_Try, /*On fail goto*//*Label 247*/ GIMT_Encode4(11206), // Rule ID 15608 //
     /*  11148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11163 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11166 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11171 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11175 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11182 */     // MIs[1] pred
     /*  11182 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11187 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11193 */     // (add:{ *:[i64] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>, GPR64:{ *:[i64] }:$Rn)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11198 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  11204 */     GIR_RootConstrainSelectedInstOperands,
     /*  11205 */     // GIR_Coverage, 15608,
     /*  11205 */     GIR_EraseRootFromParent_Done,
     /*  11206 */   // Label 247: @11206
     /*  11206 */   GIM_Try, /*On fail goto*//*Label 248*/ GIMT_Encode4(11239), // Rule ID 96 //
     /*  11211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11219 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  11226 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ADDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  11226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXrs),
     /*  11229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  11231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11233 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  11237 */     GIR_RootConstrainSelectedInstOperands,
     /*  11238 */     // GIR_Coverage, 96,
     /*  11238 */     GIR_EraseRootFromParent_Done,
     /*  11239 */   // Label 248: @11239
     /*  11239 */   GIM_Try, /*On fail goto*//*Label 249*/ GIMT_Encode4(11302), // Rule ID 10103 //
     /*  11244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11259 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11263 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11266 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  11275 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11277 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11282 */     // MIs[1] pred
     /*  11282 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11289 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_B),
     /*  11292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11300 */     GIR_RootConstrainSelectedInstOperands,
     /*  11301 */     // GIR_Coverage, 10103,
     /*  11301 */     GIR_EraseRootFromParent_Done,
     /*  11302 */   // Label 249: @11302
     /*  11302 */   GIM_Try, /*On fail goto*//*Label 250*/ GIMT_Encode4(11365), // Rule ID 10104 //
     /*  11307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11314 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11326 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11329 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  11338 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11345 */     // MIs[1] pred
     /*  11345 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11352 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_H),
     /*  11355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11363 */     GIR_RootConstrainSelectedInstOperands,
     /*  11364 */     // GIR_Coverage, 10104,
     /*  11364 */     GIR_EraseRootFromParent_Done,
     /*  11365 */   // Label 250: @11365
     /*  11365 */   GIM_Try, /*On fail goto*//*Label 251*/ GIMT_Encode4(11428), // Rule ID 10105 //
     /*  11370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11389 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11392 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  11401 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11408 */     // MIs[1] pred
     /*  11408 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11413 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11415 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_S),
     /*  11418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11426 */     GIR_RootConstrainSelectedInstOperands,
     /*  11427 */     // GIR_Coverage, 10105,
     /*  11427 */     GIR_EraseRootFromParent_Done,
     /*  11428 */   // Label 251: @11428
     /*  11428 */   GIM_Try, /*On fail goto*//*Label 252*/ GIMT_Encode4(11491), // Rule ID 10106 //
     /*  11433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  11436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11440 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  11444 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11448 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11452 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  11455 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  11460 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  11464 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  11466 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  11471 */     // MIs[1] pred
     /*  11471 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  11476 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11478 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (INCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  11478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INCP_XP_D),
     /*  11481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  11483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  11487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  11489 */     GIR_RootConstrainSelectedInstOperands,
     /*  11490 */     // GIR_Coverage, 10106,
     /*  11490 */     GIR_EraseRootFromParent_Done,
     /*  11491 */   // Label 252: @11491
     /*  11491 */   GIM_Try, /*On fail goto*//*Label 253*/ GIMT_Encode4(11547), // Rule ID 13390 //
     /*  11496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11511 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11514 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11519 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11523 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11528 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11534 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11545 */     GIR_RootConstrainSelectedInstOperands,
     /*  11546 */     // GIR_Coverage, 13390,
     /*  11546 */     GIR_EraseRootFromParent_Done,
     /*  11547 */   // Label 253: @11547
     /*  11547 */   GIM_Try, /*On fail goto*//*Label 254*/ GIMT_Encode4(11603), // Rule ID 13402 //
     /*  11552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11567 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11570 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11590 */     // (add:{ *:[v1i64] } (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11601 */     GIR_RootConstrainSelectedInstOperands,
     /*  11602 */     // GIR_Coverage, 13402,
     /*  11602 */     GIR_EraseRootFromParent_Done,
     /*  11603 */   // Label 254: @11603
     /*  11603 */   GIM_Try, /*On fail goto*//*Label 255*/ GIMT_Encode4(11670), // Rule ID 13618 //
     /*  11608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11632 */     // MIs[1] imm
     /*  11632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11640 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11644 */     // MIs[2] Operand 1
     /*  11644 */     // No operand predicates
     /*  11644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11648 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11654 */     // (add:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11668 */     GIR_RootConstrainSelectedInstOperands,
     /*  11669 */     // GIR_Coverage, 13618,
     /*  11669 */     GIR_EraseRootFromParent_Done,
     /*  11670 */   // Label 255: @11670
     /*  11670 */   GIM_Try, /*On fail goto*//*Label 256*/ GIMT_Encode4(11737), // Rule ID 13621 //
     /*  11675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11699 */     // MIs[1] imm
     /*  11699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11707 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11711 */     // MIs[2] Operand 1
     /*  11711 */     // No operand predicates
     /*  11711 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11715 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11721 */     // (add:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  11728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11732 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11735 */     GIR_RootConstrainSelectedInstOperands,
     /*  11736 */     // GIR_Coverage, 13621,
     /*  11736 */     GIR_EraseRootFromParent_Done,
     /*  11737 */   // Label 256: @11737
     /*  11737 */   GIM_Try, /*On fail goto*//*Label 257*/ GIMT_Encode4(11793), // Rule ID 997 //
     /*  11742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11761 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11764 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  11769 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11773 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11778 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11780 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  11783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11787 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11791 */     GIR_RootConstrainSelectedInstOperands,
     /*  11792 */     // GIR_Coverage, 997,
     /*  11792 */     GIR_EraseRootFromParent_Done,
     /*  11793 */   // Label 257: @11793
     /*  11793 */   GIM_Try, /*On fail goto*//*Label 258*/ GIMT_Encode4(11849), // Rule ID 1058 //
     /*  11798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  11817 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  11820 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  11825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  11829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11834 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  11836 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  11836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  11839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  11847 */     GIR_RootConstrainSelectedInstOperands,
     /*  11848 */     // GIR_Coverage, 1058,
     /*  11848 */     GIR_EraseRootFromParent_Done,
     /*  11849 */   // Label 258: @11849
     /*  11849 */   GIM_Try, /*On fail goto*//*Label 259*/ GIMT_Encode4(11916), // Rule ID 2121 //
     /*  11854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  11873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11882 */     // MIs[1] imm
     /*  11882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11890 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11894 */     // MIs[2] Operand 1
     /*  11894 */     // No operand predicates
     /*  11894 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11898 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11900 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  11903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11905 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11911 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11914 */     GIR_RootConstrainSelectedInstOperands,
     /*  11915 */     // GIR_Coverage, 2121,
     /*  11915 */     GIR_EraseRootFromParent_Done,
     /*  11916 */   // Label 259: @11916
     /*  11916 */   GIM_Try, /*On fail goto*//*Label 260*/ GIMT_Encode4(11983), // Rule ID 2130 //
     /*  11921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11928 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11932 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  11936 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  11940 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  11944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11949 */     // MIs[1] imm
     /*  11949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  11953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  11957 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  11961 */     // MIs[2] Operand 1
     /*  11961 */     // No operand predicates
     /*  11961 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  11965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  11967 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  11967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  11970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  11972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  11974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  11978 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  11981 */     GIR_RootConstrainSelectedInstOperands,
     /*  11982 */     // GIR_Coverage, 2130,
     /*  11982 */     GIR_EraseRootFromParent_Done,
     /*  11983 */   // Label 260: @11983
     /*  11983 */   GIM_Try, /*On fail goto*//*Label 261*/ GIMT_Encode4(12031), // Rule ID 13389 //
     /*  11988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  11991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  11995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  11999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12018 */     // (add:{ *:[v1i64] } (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12029 */     GIR_RootConstrainSelectedInstOperands,
     /*  12030 */     // GIR_Coverage, 13389,
     /*  12030 */     GIR_EraseRootFromParent_Done,
     /*  12031 */   // Label 261: @12031
     /*  12031 */   GIM_Try, /*On fail goto*//*Label 262*/ GIMT_Encode4(12079), // Rule ID 13401 //
     /*  12036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12060 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12066 */     // (add:{ *:[v1i64] } (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn), V64:{ *:[v1i64] }:$Rd)  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  12073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12077 */     GIR_RootConstrainSelectedInstOperands,
     /*  12078 */     // GIR_Coverage, 13401,
     /*  12078 */     GIR_EraseRootFromParent_Done,
     /*  12079 */   // Label 262: @12079
     /*  12079 */   GIM_Try, /*On fail goto*//*Label 263*/ GIMT_Encode4(12127), // Rule ID 996 //
     /*  12084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  12103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12114 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (SADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv2i32_v1i64),
     /*  12117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12119 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12125 */     GIR_RootConstrainSelectedInstOperands,
     /*  12126 */     // GIR_Coverage, 996,
     /*  12126 */     GIR_EraseRootFromParent_Done,
     /*  12127 */   // Label 263: @12127
     /*  12127 */   GIM_Try, /*On fail goto*//*Label 264*/ GIMT_Encode4(12175), // Rule ID 1057 //
     /*  12132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  12147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  12151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12155 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  12162 */     // (add:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn))  =>  (UADALPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /*  12162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv2i32_v1i64),
     /*  12165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12167 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  12169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  12173 */     GIR_RootConstrainSelectedInstOperands,
     /*  12174 */     // GIR_Coverage, 1057,
     /*  12174 */     GIR_EraseRootFromParent_Done,
     /*  12175 */   // Label 264: @12175
     /*  12175 */   GIM_Try, /*On fail goto*//*Label 265*/ GIMT_Encode4(12199), // Rule ID 94 //
     /*  12180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  12192 */     // (add:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ADDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  12192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDXrr),
     /*  12197 */     GIR_RootConstrainSelectedInstOperands,
     /*  12198 */     // GIR_Coverage, 94,
     /*  12198 */     GIR_Done,
     /*  12199 */   // Label 265: @12199
     /*  12199 */   GIM_Try, /*On fail goto*//*Label 266*/ GIMT_Encode4(12226), // Rule ID 1607 //
     /*  12204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  12207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12211 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12215 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12219 */     // (add:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (ADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  12219 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv1i64),
     /*  12224 */     GIR_RootConstrainSelectedInstOperands,
     /*  12225 */     // GIR_Coverage, 1607,
     /*  12225 */     GIR_Done,
     /*  12226 */   // Label 266: @12226
     /*  12226 */   GIM_Reject,
     /*  12227 */ // Label 195: @12227
     /*  12227 */ GIM_Reject,
     /*  12228 */ // Label 157: @12228
     /*  12228 */ GIM_Try, /*On fail goto*//*Label 267*/ GIMT_Encode4(15835),
     /*  12233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12236 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12239 */   GIM_Try, /*On fail goto*//*Label 268*/ GIMT_Encode4(12427), // Rule ID 6968 //
     /*  12244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12281 */     // MIs[2] Operand 2
     /*  12281 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12292 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12296 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12300 */     // MIs[3] Rn
     /*  12300 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12305 */     // MIs[3] Operand 2
     /*  12305 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12320 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12324 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12332 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12336 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12340 */     // MIs[5] Rn
     /*  12340 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12345 */     // MIs[5] Operand 2
     /*  12345 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12356 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12360 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12364 */     // MIs[6] Rn
     /*  12364 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12369 */     // MIs[6] Operand 2
     /*  12369 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12380 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12382 */     // (add:{ *:[v2i32] } (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12382 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12385 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12389 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12394 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12398 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12402 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12409 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12416 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12426 */     // GIR_Coverage, 6968,
     /*  12426 */     GIR_EraseRootFromParent_Done,
     /*  12427 */   // Label 268: @12427
     /*  12427 */   GIM_Try, /*On fail goto*//*Label 269*/ GIMT_Encode4(12615), // Rule ID 14025 //
     /*  12432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  12444 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12448 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12452 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12456 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12460 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12464 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12469 */     // MIs[2] Operand 2
     /*  12469 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  12480 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  12484 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12488 */     // MIs[3] Rn
     /*  12488 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12493 */     // MIs[3] Operand 2
     /*  12493 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(2),
     /*  12504 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  12508 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_ZIP1),
     /*  12512 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  12516 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  12520 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  12524 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12528 */     // MIs[5] Rn
     /*  12528 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12533 */     // MIs[5] Operand 2
     /*  12533 */     GIM_CheckLiteralInt, /*MI*/5, /*Op*/2, GIMT_Encode8(0),
     /*  12544 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/4, /*OpIdx*/2, // MIs[6]
     /*  12548 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12552 */     // MIs[6] Rn
     /*  12552 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  12557 */     // MIs[6] Operand 2
     /*  12557 */     GIM_CheckLiteralInt, /*MI*/6, /*Op*/2, GIMT_Encode8(2),
     /*  12568 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  12570 */     // (add:{ *:[v2i32] } (AArch64zip2:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })), (AArch64zip1:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /*  12570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  12573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  12577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12582 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12590 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12597 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12609 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12614 */     // GIR_Coverage, 14025,
     /*  12614 */     GIR_EraseRootFromParent_Done,
     /*  12615 */   // Label 269: @12615
     /*  12615 */   GIM_Try, /*On fail goto*//*Label 270*/ GIMT_Encode4(12751), // Rule ID 5387 //
     /*  12620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12624 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12628 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12632 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12644 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12648 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12653 */     // MIs[1] Operand 2
     /*  12653 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12664 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12668 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12672 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12680 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12684 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12688 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12693 */     // MIs[3] Operand 2
     /*  12693 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12704 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12706 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12718 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12722 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12726 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12733 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12750 */     // GIR_Coverage, 5387,
     /*  12750 */     GIR_EraseRootFromParent_Done,
     /*  12751 */   // Label 270: @12751
     /*  12751 */   GIM_Try, /*On fail goto*//*Label 271*/ GIMT_Encode4(12887), // Rule ID 5386 //
     /*  12756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  12780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12784 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12789 */     // MIs[1] Operand 2
     /*  12789 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12800 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12804 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12808 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12812 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12816 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  12820 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12824 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12829 */     // MIs[3] Operand 2
     /*  12829 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12840 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12842 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  12849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12854 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12858 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12862 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  12864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  12867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  12869 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  12876 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12881 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  12886 */     // GIR_Coverage, 5386,
     /*  12886 */     GIR_EraseRootFromParent_Done,
     /*  12887 */   // Label 271: @12887
     /*  12887 */   GIM_Try, /*On fail goto*//*Label 272*/ GIMT_Encode4(13023), // Rule ID 5399 //
     /*  12892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  12900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  12912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12925 */     // MIs[1] Operand 2
     /*  12925 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  12936 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  12940 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  12944 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  12948 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  12952 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  12956 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  12960 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  12965 */     // MIs[3] Operand 2
     /*  12965 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  12976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  12978 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  12978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  12981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  12985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  12990 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  12994 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  12998 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13005 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13017 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13022 */     // GIR_Coverage, 5399,
     /*  13022 */     GIR_EraseRootFromParent_Done,
     /*  13023 */   // Label 272: @13023
     /*  13023 */   GIM_Try, /*On fail goto*//*Label 273*/ GIMT_Encode4(13159), // Rule ID 5385 //
     /*  13028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13061 */     // MIs[1] Operand 2
     /*  13061 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13072 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13076 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13080 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13092 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13096 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13101 */     // MIs[3] Operand 2
     /*  13101 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13112 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13114 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13126 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13130 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13134 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13141 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13148 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13153 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13158 */     // GIR_Coverage, 5385,
     /*  13158 */     GIR_EraseRootFromParent_Done,
     /*  13159 */   // Label 273: @13159
     /*  13159 */   GIM_Try, /*On fail goto*//*Label 274*/ GIMT_Encode4(13295), // Rule ID 5384 //
     /*  13164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13197 */     // MIs[1] Operand 2
     /*  13197 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13208 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  13212 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13216 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13220 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  13224 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13228 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13232 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13237 */     // MIs[3] Operand 2
     /*  13237 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  13248 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  13250 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13250 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13253 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  13257 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13262 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13266 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  13270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13277 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13294 */     // GIR_Coverage, 5384,
     /*  13294 */     GIR_EraseRootFromParent_Done,
     /*  13295 */   // Label 274: @13295
     /*  13295 */   GIM_Try, /*On fail goto*//*Label 275*/ GIMT_Encode4(13458), // Rule ID 13985 //
     /*  13300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  13324 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13328 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13332 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13337 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13342 */     // MIs[1] Operand 2
     /*  13342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13357 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13359 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13359 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13362 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13366 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13371 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13373 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13376 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13380 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13385 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13388 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13392 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13400 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13405 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  13417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13422 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13425 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13429 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13433 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13440 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13457 */     // GIR_Coverage, 13985,
     /*  13457 */     GIR_EraseRootFromParent_Done,
     /*  13458 */   // Label 275: @13458
     /*  13458 */   GIM_Try, /*On fail goto*//*Label 276*/ GIMT_Encode4(13621), // Rule ID 13982 //
     /*  13463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  13487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  13495 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13505 */     // MIs[1] Operand 2
     /*  13505 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13522 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13548 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13551 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  13555 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13558 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13563 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13568 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  13580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13585 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  13592 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  13596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13603 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13620 */     // GIR_Coverage, 13982,
     /*  13620 */     GIR_EraseRootFromParent_Done,
     /*  13621 */   // Label 276: @13621
     /*  13621 */   GIM_Try, /*On fail goto*//*Label 277*/ GIMT_Encode4(13771), // Rule ID 13990 //
     /*  13626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  13650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13659 */     // MIs[1] Operand 2
     /*  13659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13670 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13674 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13676 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13676 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13679 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13683 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13688 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13690 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13693 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13697 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13702 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13705 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13709 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13712 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13717 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13722 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  13734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13739 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13742 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13746 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13753 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13760 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13765 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13770 */     // GIR_Coverage, 13990,
     /*  13770 */     GIR_EraseRootFromParent_Done,
     /*  13771 */   // Label 277: @13771
     /*  13771 */   GIM_Try, /*On fail goto*//*Label 278*/ GIMT_Encode4(13921), // Rule ID 13994 //
     /*  13776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  13800 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13804 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13809 */     // MIs[1] Operand 2
     /*  13809 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13826 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13826 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13829 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13833 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13838 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13840 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13843 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13847 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13852 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  13855 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  13859 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  13862 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13867 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13872 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13877 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  13880 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  13884 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13889 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  13892 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  13896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  13898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  13901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  13903 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  13910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13915 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  13920 */     // GIR_Coverage, 13994,
     /*  13920 */     GIR_EraseRootFromParent_Done,
     /*  13921 */   // Label 278: @13921
     /*  13921 */   GIM_Try, /*On fail goto*//*Label 279*/ GIMT_Encode4(14071), // Rule ID 13989 //
     /*  13926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  13934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  13938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  13942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  13946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  13950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  13954 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13959 */     // MIs[1] Operand 2
     /*  13959 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  13970 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  13974 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  13976 */     // (add:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  13976 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  13979 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  13983 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  13988 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  13990 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  13993 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  13997 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14002 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14005 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  14009 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14012 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14017 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14022 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14027 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14030 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14034 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14039 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14042 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14046 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14053 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14060 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14070 */     // GIR_Coverage, 13989,
     /*  14070 */     GIR_EraseRootFromParent_Done,
     /*  14071 */   // Label 279: @14071
     /*  14071 */   GIM_Try, /*On fail goto*//*Label 280*/ GIMT_Encode4(14234), // Rule ID 5372 //
     /*  14076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  14104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14108 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14112 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14117 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14122 */     // MIs[1] Operand 2
     /*  14122 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14135 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14135 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14138 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14142 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14161 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14164 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14168 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14171 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14176 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14186 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14189 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  14193 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14198 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14233 */     // GIR_Coverage, 5372,
     /*  14233 */     GIR_EraseRootFromParent_Done,
     /*  14234 */   // Label 280: @14234
     /*  14234 */   GIM_Try, /*On fail goto*//*Label 281*/ GIMT_Encode4(14397), // Rule ID 5369 //
     /*  14239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14259 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14263 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  14267 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14271 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  14275 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14285 */     // MIs[1] Operand 2
     /*  14285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14298 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLALv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14298 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14301 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14305 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14310 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14312 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14315 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14319 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14324 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14327 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  14331 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14334 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14339 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14344 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14349 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14352 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  14356 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14361 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14364 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  14368 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  14372 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14379 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14396 */     // GIR_Coverage, 5369,
     /*  14396 */     GIR_EraseRootFromParent_Done,
     /*  14397 */   // Label 281: @14397
     /*  14397 */   GIM_Try, /*On fail goto*//*Label 282*/ GIMT_Encode4(14547), // Rule ID 5395 //
     /*  14402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14410 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14414 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14418 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14422 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14426 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  14430 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14434 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14439 */     // MIs[1] Operand 2
     /*  14439 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14452 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14452 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14455 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14459 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14478 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14481 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14485 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14488 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14493 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14498 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14515 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14522 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14529 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14546 */     // GIR_Coverage, 5395,
     /*  14546 */     GIR_EraseRootFromParent_Done,
     /*  14547 */   // Label 282: @14547
     /*  14547 */   GIM_Try, /*On fail goto*//*Label 283*/ GIMT_Encode4(14697), // Rule ID 5402 //
     /*  14552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  14580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14589 */     // MIs[1] Operand 2
     /*  14589 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14600 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14602 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14602 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14605 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14609 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14614 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14616 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14619 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14623 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14628 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14631 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14635 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14638 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14643 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14648 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  14660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14665 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14668 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14672 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14679 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14691 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14696 */     // GIR_Coverage, 5402,
     /*  14696 */     GIR_EraseRootFromParent_Done,
     /*  14697 */   // Label 283: @14697
     /*  14697 */   GIM_Try, /*On fail goto*//*Label 284*/ GIMT_Encode4(14847), // Rule ID 5394 //
     /*  14702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14710 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  14714 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  14718 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  14722 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  14726 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  14730 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  14734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14739 */     // MIs[1] Operand 2
     /*  14739 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  14750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  14752 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UADDWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  14752 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  14755 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  14759 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  14766 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  14769 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  14773 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14778 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  14781 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  14785 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  14788 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14793 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14803 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  14806 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  14810 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  14815 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  14818 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  14822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  14824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  14827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14829 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  14836 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14841 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  14846 */     // GIR_Coverage, 5394,
     /*  14846 */     GIR_EraseRootFromParent_Done,
     /*  14847 */   // Label 284: @14847
     /*  14847 */   GIM_Try, /*On fail goto*//*Label 285*/ GIMT_Encode4(14916), // Rule ID 13424 //
     /*  14852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14867 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14870 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  14875 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14879 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14897 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14899 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  14902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14906 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14914 */     GIR_RootConstrainSelectedInstOperands,
     /*  14915 */     // GIR_Coverage, 13424,
     /*  14915 */     GIR_EraseRootFromParent_Done,
     /*  14916 */   // Label 285: @14916
     /*  14916 */   GIM_Try, /*On fail goto*//*Label 286*/ GIMT_Encode4(14985), // Rule ID 13436 //
     /*  14921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  14932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  14936 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  14939 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  14944 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  14948 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  14952 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  14968 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V64:{ *:[v2i32] }:$Rd)  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  14968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  14971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  14973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  14975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  14979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  14983 */     GIR_RootConstrainSelectedInstOperands,
     /*  14984 */     // GIR_Coverage, 13436,
     /*  14984 */     GIR_EraseRootFromParent_Done,
     /*  14985 */   // Label 286: @14985
     /*  14985 */   GIM_Try, /*On fail goto*//*Label 287*/ GIMT_Encode4(15041), // Rule ID 13386 //
     /*  14990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  14993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  14997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15005 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15008 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15013 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15028 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15039 */     GIR_RootConstrainSelectedInstOperands,
     /*  15040 */     // GIR_Coverage, 13386,
     /*  15040 */     GIR_EraseRootFromParent_Done,
     /*  15041 */   // Label 287: @15041
     /*  15041 */   GIM_Try, /*On fail goto*//*Label 288*/ GIMT_Encode4(15097), // Rule ID 13398 //
     /*  15046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15061 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15064 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15078 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15084 */     // (add:{ *:[v2i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15095 */     GIR_RootConstrainSelectedInstOperands,
     /*  15096 */     // GIR_Coverage, 13398,
     /*  15096 */     GIR_EraseRootFromParent_Done,
     /*  15097 */   // Label 288: @15097
     /*  15097 */   GIM_Try, /*On fail goto*//*Label 289*/ GIMT_Encode4(15164), // Rule ID 13638 //
     /*  15102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15126 */     // MIs[1] imm
     /*  15126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15138 */     // MIs[2] Operand 1
     /*  15138 */     // No operand predicates
     /*  15138 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15142 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15146 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15148 */     // (add:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15162 */     GIR_RootConstrainSelectedInstOperands,
     /*  15163 */     // GIR_Coverage, 13638,
     /*  15163 */     GIR_EraseRootFromParent_Done,
     /*  15164 */   // Label 289: @15164
     /*  15164 */   GIM_Try, /*On fail goto*//*Label 290*/ GIMT_Encode4(15231), // Rule ID 13659 //
     /*  15169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15188 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15193 */     // MIs[1] imm
     /*  15193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15201 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15205 */     // MIs[2] Operand 1
     /*  15205 */     // No operand predicates
     /*  15205 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15209 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15213 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15215 */     // (add:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15226 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15229 */     GIR_RootConstrainSelectedInstOperands,
     /*  15230 */     // GIR_Coverage, 13659,
     /*  15230 */     GIR_EraseRootFromParent_Done,
     /*  15231 */   // Label 290: @15231
     /*  15231 */   GIM_Try, /*On fail goto*//*Label 291*/ GIMT_Encode4(15300), // Rule ID 1365 //
     /*  15236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15255 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15258 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  15263 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15267 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15276 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15283 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv2i32),
     /*  15286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15288 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15298 */     GIR_RootConstrainSelectedInstOperands,
     /*  15299 */     // GIR_Coverage, 1365,
     /*  15299 */     GIR_EraseRootFromParent_Done,
     /*  15300 */   // Label 291: @15300
     /*  15300 */   GIM_Try, /*On fail goto*//*Label 292*/ GIMT_Encode4(15369), // Rule ID 1488 //
     /*  15305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15324 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  15327 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  15332 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15336 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  15340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15352 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABAv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv2i32),
     /*  15355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15357 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  15367 */     GIR_RootConstrainSelectedInstOperands,
     /*  15368 */     // GIR_Coverage, 1488,
     /*  15368 */     GIR_EraseRootFromParent_Done,
     /*  15369 */   // Label 292: @15369
     /*  15369 */   GIM_Try, /*On fail goto*//*Label 293*/ GIMT_Encode4(15425), // Rule ID 993 //
     /*  15374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15393 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15396 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  15401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15410 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15412 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15417 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15423 */     GIR_RootConstrainSelectedInstOperands,
     /*  15424 */     // GIR_Coverage, 993,
     /*  15424 */     GIR_EraseRootFromParent_Done,
     /*  15425 */   // Label 293: @15425
     /*  15425 */   GIM_Try, /*On fail goto*//*Label 294*/ GIMT_Encode4(15481), // Rule ID 1054 //
     /*  15430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  15449 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  15452 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  15457 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  15461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15466 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15468 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  15479 */     GIR_RootConstrainSelectedInstOperands,
     /*  15480 */     // GIR_Coverage, 1054,
     /*  15480 */     GIR_EraseRootFromParent_Done,
     /*  15481 */   // Label 294: @15481
     /*  15481 */   GIM_Try, /*On fail goto*//*Label 295*/ GIMT_Encode4(15548), // Rule ID 2238 //
     /*  15486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15501 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  15505 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15514 */     // MIs[1] imm
     /*  15514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15526 */     // MIs[2] Operand 1
     /*  15526 */     // No operand predicates
     /*  15526 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15532 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  15535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15537 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15546 */     GIR_RootConstrainSelectedInstOperands,
     /*  15547 */     // GIR_Coverage, 2238,
     /*  15547 */     GIR_EraseRootFromParent_Done,
     /*  15548 */   // Label 295: @15548
     /*  15548 */   GIM_Try, /*On fail goto*//*Label 296*/ GIMT_Encode4(15615), // Rule ID 2297 //
     /*  15553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  15572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15581 */     // MIs[1] imm
     /*  15581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  15593 */     // MIs[2] Operand 1
     /*  15593 */     // No operand predicates
     /*  15593 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  15597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  15599 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  15599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  15602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15604 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  15613 */     GIR_RootConstrainSelectedInstOperands,
     /*  15614 */     // GIR_Coverage, 2297,
     /*  15614 */     GIR_EraseRootFromParent_Done,
     /*  15615 */   // Label 296: @15615
     /*  15615 */   GIM_Try, /*On fail goto*//*Label 297*/ GIMT_Encode4(15663), // Rule ID 13385 //
     /*  15620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15650 */     // (add:{ *:[v2i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15661 */     GIR_RootConstrainSelectedInstOperands,
     /*  15662 */     // GIR_Coverage, 13385,
     /*  15662 */     GIR_EraseRootFromParent_Done,
     /*  15663 */   // Label 297: @15663
     /*  15663 */   GIM_Try, /*On fail goto*//*Label 298*/ GIMT_Encode4(15711), // Rule ID 13397 //
     /*  15668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15698 */     // (add:{ *:[v2i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn), V64:{ *:[v2i32] }:$Rd)  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15709 */     GIR_RootConstrainSelectedInstOperands,
     /*  15710 */     // GIR_Coverage, 13397,
     /*  15710 */     GIR_EraseRootFromParent_Done,
     /*  15711 */   // Label 298: @15711
     /*  15711 */   GIM_Try, /*On fail goto*//*Label 299*/ GIMT_Encode4(15759), // Rule ID 992 //
     /*  15716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  15735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15739 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15744 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15746 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i16_v2i32),
     /*  15749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15757 */     GIR_RootConstrainSelectedInstOperands,
     /*  15758 */     // GIR_Coverage, 992,
     /*  15758 */     GIR_EraseRootFromParent_Done,
     /*  15759 */   // Label 299: @15759
     /*  15759 */   GIM_Try, /*On fail goto*//*Label 300*/ GIMT_Encode4(15807), // Rule ID 1053 //
     /*  15764 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  15779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  15783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  15787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  15794 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADALPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /*  15794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i16_v2i32),
     /*  15797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15799 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  15801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  15805 */     GIR_RootConstrainSelectedInstOperands,
     /*  15806 */     // GIR_Coverage, 1053,
     /*  15806 */     GIR_EraseRootFromParent_Done,
     /*  15807 */   // Label 300: @15807
     /*  15807 */   GIM_Try, /*On fail goto*//*Label 301*/ GIMT_Encode4(15834), // Rule ID 1104 //
     /*  15812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15819 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  15827 */     // (add:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  15827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i32),
     /*  15832 */     GIR_RootConstrainSelectedInstOperands,
     /*  15833 */     // GIR_Coverage, 1104,
     /*  15833 */     GIR_Done,
     /*  15834 */   // Label 301: @15834
     /*  15834 */   GIM_Reject,
     /*  15835 */ // Label 267: @15835
     /*  15835 */ GIM_Reject,
     /*  15836 */ // Label 158: @15836
     /*  15836 */ GIM_Try, /*On fail goto*//*Label 302*/ GIMT_Encode4(21737),
     /*  15841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  15844 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  15847 */   GIM_Try, /*On fail goto*//*Label 303*/ GIMT_Encode4(15965), // Rule ID 13567 //
     /*  15852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  15879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  15883 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  15891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  15895 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  15899 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  15903 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15908 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  15912 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  15916 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  15920 */     // MIs[4] Operand 1
     /*  15920 */     // No operand predicates
     /*  15920 */     // MIs[2] Operand 2
     /*  15920 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  15931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15935 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  15937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  15944 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  15944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  15947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  15949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  15951 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  15956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  15960 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  15963 */     GIR_RootConstrainSelectedInstOperands,
     /*  15964 */     // GIR_Coverage, 13567,
     /*  15964 */     GIR_EraseRootFromParent_Done,
     /*  15965 */   // Label 303: @15965
     /*  15965 */   GIM_Try, /*On fail goto*//*Label 304*/ GIMT_Encode4(16083), // Rule ID 13568 //
     /*  15970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  15973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  15977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  15981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  15985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  15989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  15993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  15997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16001 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16021 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16026 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16030 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16034 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16038 */     // MIs[4] Operand 1
     /*  16038 */     // No operand predicates
     /*  16038 */     // MIs[2] Operand 2
     /*  16038 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16055 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16062 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16069 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16078 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16081 */     GIR_RootConstrainSelectedInstOperands,
     /*  16082 */     // GIR_Coverage, 13568,
     /*  16082 */     GIR_EraseRootFromParent_Done,
     /*  16083 */   // Label 304: @16083
     /*  16083 */   GIM_Try, /*On fail goto*//*Label 305*/ GIMT_Encode4(16201), // Rule ID 13603 //
     /*  16088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16107 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16119 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16139 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16144 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16148 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16152 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16156 */     // MIs[4] Operand 1
     /*  16156 */     // No operand predicates
     /*  16156 */     // MIs[2] Operand 2
     /*  16156 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16173 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16180 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16187 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16192 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16196 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16199 */     GIR_RootConstrainSelectedInstOperands,
     /*  16200 */     // GIR_Coverage, 13603,
     /*  16200 */     GIR_EraseRootFromParent_Done,
     /*  16201 */   // Label 305: @16201
     /*  16201 */   GIM_Try, /*On fail goto*//*Label 306*/ GIMT_Encode4(16319), // Rule ID 13604 //
     /*  16206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16245 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16249 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16253 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16257 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16262 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16266 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16270 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16274 */     // MIs[4] Operand 1
     /*  16274 */     // No operand predicates
     /*  16274 */     // MIs[2] Operand 2
     /*  16274 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16285 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16289 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16291 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16298 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16314 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16317 */     GIR_RootConstrainSelectedInstOperands,
     /*  16318 */     // GIR_Coverage, 13604,
     /*  16318 */     GIR_EraseRootFromParent_Done,
     /*  16319 */   // Label 306: @16319
     /*  16319 */   GIM_Try, /*On fail goto*//*Label 307*/ GIMT_Encode4(16437), // Rule ID 2042 //
     /*  16324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16343 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16347 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16359 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16375 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16379 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16384 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16388 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16392 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16396 */     // MIs[4] Operand 1
     /*  16396 */     // No operand predicates
     /*  16396 */     // MIs[2] Operand 2
     /*  16396 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16407 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16409 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16416 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16423 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16432 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16435 */     GIR_RootConstrainSelectedInstOperands,
     /*  16436 */     // GIR_Coverage, 2042,
     /*  16436 */     GIR_EraseRootFromParent_Done,
     /*  16437 */   // Label 307: @16437
     /*  16437 */   GIM_Try, /*On fail goto*//*Label 308*/ GIMT_Encode4(16555), // Rule ID 13566 //
     /*  16442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16449 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  16461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16489 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16493 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16497 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16502 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16506 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16510 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16514 */     // MIs[4] Operand 1
     /*  16514 */     // No operand predicates
     /*  16514 */     // MIs[2] Operand 2
     /*  16514 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16525 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16527 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16534 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_indexed),
     /*  16537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16539 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16541 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16550 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16553 */     GIR_RootConstrainSelectedInstOperands,
     /*  16554 */     // GIR_Coverage, 13566,
     /*  16554 */     GIR_EraseRootFromParent_Done,
     /*  16555 */   // Label 308: @16555
     /*  16555 */   GIM_Try, /*On fail goto*//*Label 309*/ GIMT_Encode4(16673), // Rule ID 2094 //
     /*  16560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16567 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  16591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16599 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16603 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16607 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16611 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16615 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16620 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16624 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16628 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16632 */     // MIs[4] Operand 1
     /*  16632 */     // No operand predicates
     /*  16632 */     // MIs[2] Operand 2
     /*  16632 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16643 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16645 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16652 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16671 */     GIR_RootConstrainSelectedInstOperands,
     /*  16672 */     // GIR_Coverage, 2094,
     /*  16672 */     GIR_EraseRootFromParent_Done,
     /*  16673 */   // Label 309: @16673
     /*  16673 */   GIM_Try, /*On fail goto*//*Label 310*/ GIMT_Encode4(16791), // Rule ID 13602 //
     /*  16678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  16697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  16713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  16721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  16725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  16729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  16733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16738 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  16742 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  16746 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  16750 */     // MIs[4] Operand 1
     /*  16750 */     // No operand predicates
     /*  16750 */     // MIs[2] Operand 2
     /*  16750 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  16761 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  16763 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16770 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  16770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_indexed),
     /*  16773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16775 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  16777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  16786 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  16789 */     GIR_RootConstrainSelectedInstOperands,
     /*  16790 */     // GIR_Coverage, 13602,
     /*  16790 */     GIR_EraseRootFromParent_Done,
     /*  16791 */   // Label 310: @16791
     /*  16791 */   GIM_Try, /*On fail goto*//*Label 311*/ GIMT_Encode4(16878), // Rule ID 13468 //
     /*  16796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16823 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16826 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  16831 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16835 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16845 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16852 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16859 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  16862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16864 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16871 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16876 */     GIR_RootConstrainSelectedInstOperands,
     /*  16877 */     // GIR_Coverage, 13468,
     /*  16877 */     GIR_EraseRootFromParent_Done,
     /*  16878 */   // Label 311: @16878
     /*  16878 */   GIM_Try, /*On fail goto*//*Label 312*/ GIMT_Encode4(16965), // Rule ID 13496 //
     /*  16883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  16894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  16910 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  16913 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  16918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  16922 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  16926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  16932 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16939 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  16946 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  16946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  16949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  16951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  16953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  16958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  16963 */     GIR_RootConstrainSelectedInstOperands,
     /*  16964 */     // GIR_Coverage, 13496,
     /*  16964 */     GIR_EraseRootFromParent_Done,
     /*  16965 */   // Label 312: @16965
     /*  16965 */   GIM_Try, /*On fail goto*//*Label 313*/ GIMT_Encode4(17052), // Rule ID 1699 //
     /*  16970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  16973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  16981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  16985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  16989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  16993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  16997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17001 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17004 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  17009 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17013 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17019 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17026 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17033 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (SABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i32_v2i64),
     /*  17036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17038 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17040 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17050 */     GIR_RootConstrainSelectedInstOperands,
     /*  17051 */     // GIR_Coverage, 1699,
     /*  17051 */     GIR_EraseRootFromParent_Done,
     /*  17052 */   // Label 313: @17052
     /*  17052 */   GIM_Try, /*On fail goto*//*Label 314*/ GIMT_Encode4(17139), // Rule ID 1777 //
     /*  17057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17080 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17084 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  17088 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  17091 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  17096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17100 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  17104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17106 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17120 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))))  =>  (UABALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i32_v2i64),
     /*  17123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17125 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  17127 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17137 */     GIR_RootConstrainSelectedInstOperands,
     /*  17138 */     // GIR_Coverage, 1777,
     /*  17138 */     GIR_EraseRootFromParent_Done,
     /*  17139 */   // Label 314: @17139
     /*  17139 */   GIM_Try, /*On fail goto*//*Label 315*/ GIMT_Encode4(17254), // Rule ID 13562 //
     /*  17144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17187 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17191 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17195 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17200 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17204 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17208 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17212 */     // MIs[4] Operand 1
     /*  17212 */     // No operand predicates
     /*  17212 */     // MIs[2] Operand 2
     /*  17212 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17223 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17232 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17234 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17249 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17252 */     GIR_RootConstrainSelectedInstOperands,
     /*  17253 */     // GIR_Coverage, 13562,
     /*  17253 */     GIR_EraseRootFromParent_Done,
     /*  17254 */   // Label 315: @17254
     /*  17254 */   GIM_Try, /*On fail goto*//*Label 316*/ GIMT_Encode4(17369), // Rule ID 13561 //
     /*  17259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17287 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17291 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17295 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17307 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17311 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17315 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17328 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17332 */     // MIs[4] Operand 1
     /*  17332 */     // No operand predicates
     /*  17332 */     // MIs[2] Operand 2
     /*  17332 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17347 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17349 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  17352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17364 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17367 */     GIR_RootConstrainSelectedInstOperands,
     /*  17368 */     // GIR_Coverage, 13561,
     /*  17368 */     GIR_EraseRootFromParent_Done,
     /*  17369 */   // Label 316: @17369
     /*  17369 */   GIM_Try, /*On fail goto*//*Label 317*/ GIMT_Encode4(17484), // Rule ID 13598 //
     /*  17374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17409 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17413 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17417 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17421 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17425 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17430 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17434 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17438 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17442 */     // MIs[4] Operand 1
     /*  17442 */     // No operand predicates
     /*  17442 */     // MIs[2] Operand 2
     /*  17442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17458 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17462 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17464 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  17475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17479 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17482 */     GIR_RootConstrainSelectedInstOperands,
     /*  17483 */     // GIR_Coverage, 13598,
     /*  17483 */     GIR_EraseRootFromParent_Done,
     /*  17484 */   // Label 317: @17484
     /*  17484 */   GIM_Try, /*On fail goto*//*Label 318*/ GIMT_Encode4(17599), // Rule ID 13597 //
     /*  17489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17496 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17500 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  17504 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17508 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  17517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  17521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17529 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17533 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17537 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17541 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  17545 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17550 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  17554 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  17558 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  17562 */     // MIs[4] Operand 1
     /*  17562 */     // No operand predicates
     /*  17562 */     // MIs[2] Operand 2
     /*  17562 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  17573 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17577 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  17579 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  17579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  17582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  17584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  17586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  17590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  17594 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  17597 */     GIR_RootConstrainSelectedInstOperands,
     /*  17598 */     // GIR_Coverage, 13597,
     /*  17598 */     GIR_EraseRootFromParent_Done,
     /*  17599 */   // Label 318: @17599
     /*  17599 */   GIM_Try, /*On fail goto*//*Label 319*/ GIMT_Encode4(17668), // Rule ID 1801 //
     /*  17604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17637 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17644 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17651 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17656 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17661 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17666 */     GIR_RootConstrainSelectedInstOperands,
     /*  17667 */     // GIR_Coverage, 1801,
     /*  17667 */     GIR_EraseRootFromParent_Done,
     /*  17668 */   // Label 319: @17668
     /*  17668 */   GIM_Try, /*On fail goto*//*Label 320*/ GIMT_Encode4(17737), // Rule ID 1800 //
     /*  17673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17692 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17696 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17700 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17704 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17706 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17713 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17720 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17735 */     GIR_RootConstrainSelectedInstOperands,
     /*  17736 */     // GIR_Coverage, 1800,
     /*  17736 */     GIR_EraseRootFromParent_Done,
     /*  17737 */   // Label 320: @17737
     /*  17737 */   GIM_Try, /*On fail goto*//*Label 321*/ GIMT_Encode4(17806), // Rule ID 1717 //
     /*  17742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  17769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17773 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17775 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17782 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17789 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i32_v2i64),
     /*  17792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17799 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17804 */     GIR_RootConstrainSelectedInstOperands,
     /*  17805 */     // GIR_Coverage, 1717,
     /*  17805 */     GIR_EraseRootFromParent_Done,
     /*  17806 */   // Label 321: @17806
     /*  17806 */   GIM_Try, /*On fail goto*//*Label 322*/ GIMT_Encode4(17875), // Rule ID 1799 //
     /*  17811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  17838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17844 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17858 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17873 */     GIR_RootConstrainSelectedInstOperands,
     /*  17874 */     // GIR_Coverage, 1799,
     /*  17874 */     GIR_EraseRootFromParent_Done,
     /*  17875 */   // Label 322: @17875
     /*  17875 */   GIM_Try, /*On fail goto*//*Label 323*/ GIMT_Encode4(17944), // Rule ID 1798 //
     /*  17880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  17891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  17903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  17907 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  17913 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17920 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  17927 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  17927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i32_v2i64),
     /*  17930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  17932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  17937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  17942 */     GIR_RootConstrainSelectedInstOperands,
     /*  17943 */     // GIR_Coverage, 1798,
     /*  17943 */     GIR_EraseRootFromParent_Done,
     /*  17944 */   // Label 323: @17944
     /*  17944 */   GIM_Try, /*On fail goto*//*Label 324*/ GIMT_Encode4(18059), // Rule ID 13560 //
     /*  17949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  17952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  17960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  17964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  17968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  17972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  17976 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  17980 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  17984 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  17988 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  17992 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  17996 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18000 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18004 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18009 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18013 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18017 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18021 */     // MIs[4] Operand 1
     /*  18021 */     // No operand predicates
     /*  18021 */     // MIs[2] Operand 2
     /*  18021 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18032 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18037 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18039 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18057 */     GIR_RootConstrainSelectedInstOperands,
     /*  18058 */     // GIR_Coverage, 13560,
     /*  18058 */     GIR_EraseRootFromParent_Done,
     /*  18059 */   // Label 324: @18059
     /*  18059 */   GIM_Try, /*On fail goto*//*Label 325*/ GIMT_Encode4(18174), // Rule ID 2040 //
     /*  18064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18091 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18104 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18108 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18112 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18116 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18120 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18124 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18129 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18133 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18137 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18141 */     // MIs[4] Operand 1
     /*  18141 */     // No operand predicates
     /*  18141 */     // MIs[2] Operand 2
     /*  18141 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18152 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18154 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  18157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18159 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18169 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18172 */     GIR_RootConstrainSelectedInstOperands,
     /*  18173 */     // GIR_Coverage, 2040,
     /*  18173 */     GIR_EraseRootFromParent_Done,
     /*  18174 */   // Label 325: @18174
     /*  18174 */   GIM_Try, /*On fail goto*//*Label 326*/ GIMT_Encode4(18289), // Rule ID 13596 //
     /*  18179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18186 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18190 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18194 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18198 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18202 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18222 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18226 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18230 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18234 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18239 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18243 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18247 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18251 */     // MIs[4] Operand 1
     /*  18251 */     // No operand predicates
     /*  18251 */     // MIs[2] Operand 2
     /*  18251 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18267 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18269 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  18280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18287 */     GIR_RootConstrainSelectedInstOperands,
     /*  18288 */     // GIR_Coverage, 13596,
     /*  18288 */     GIR_EraseRootFromParent_Done,
     /*  18289 */   // Label 326: @18289
     /*  18289 */   GIM_Try, /*On fail goto*//*Label 327*/ GIMT_Encode4(18404), // Rule ID 2092 //
     /*  18294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18317 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18326 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  18330 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  18334 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18338 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  18342 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  18346 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  18350 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  18354 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18359 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  18363 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  18367 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  18371 */     // MIs[4] Operand 1
     /*  18371 */     // No operand predicates
     /*  18371 */     // MIs[2] Operand 2
     /*  18371 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  18382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  18384 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  18384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  18387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18389 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  18395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  18399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  18402 */     GIR_RootConstrainSelectedInstOperands,
     /*  18403 */     // GIR_Coverage, 2092,
     /*  18403 */     GIR_EraseRootFromParent_Done,
     /*  18404 */   // Label 327: @18404
     /*  18404 */   GIM_Try, /*On fail goto*//*Label 328*/ GIMT_Encode4(18471), // Rule ID 13480 //
     /*  18409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18445 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18452 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18464 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18469 */     GIR_RootConstrainSelectedInstOperands,
     /*  18470 */     // GIR_Coverage, 13480,
     /*  18470 */     GIR_EraseRootFromParent_Done,
     /*  18471 */   // Label 328: @18471
     /*  18471 */   GIM_Try, /*On fail goto*//*Label 329*/ GIMT_Encode4(18538), // Rule ID 13514 //
     /*  18476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18503 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18505 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18512 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18519 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18536 */     GIR_RootConstrainSelectedInstOperands,
     /*  18537 */     // GIR_Coverage, 13514,
     /*  18537 */     GIR_EraseRootFromParent_Done,
     /*  18538 */   // Label 329: @18538
     /*  18538 */   GIM_Try, /*On fail goto*//*Label 330*/ GIMT_Encode4(18605), // Rule ID 1729 //
     /*  18543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18546 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  18562 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18566 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18570 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18572 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18579 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18586 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i32_v2i64),
     /*  18589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18593 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18603 */     GIR_RootConstrainSelectedInstOperands,
     /*  18604 */     // GIR_Coverage, 1729,
     /*  18604 */     GIR_EraseRootFromParent_Done,
     /*  18605 */   // Label 330: @18605
     /*  18605 */   GIM_Try, /*On fail goto*//*Label 331*/ GIMT_Encode4(18672), // Rule ID 1819 //
     /*  18610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  18629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18637 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  18639 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  18653 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  18653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i32_v2i64),
     /*  18656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18660 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  18665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  18670 */     GIR_RootConstrainSelectedInstOperands,
     /*  18671 */     // GIR_Coverage, 1819,
     /*  18671 */     GIR_EraseRootFromParent_Done,
     /*  18672 */   // Label 331: @18672
     /*  18672 */   GIM_Try, /*On fail goto*//*Label 332*/ GIMT_Encode4(18753), // Rule ID 13466 //
     /*  18677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18696 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18700 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18704 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18707 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18712 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18716 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18734 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18736 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18743 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18747 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18751 */     GIR_RootConstrainSelectedInstOperands,
     /*  18752 */     // GIR_Coverage, 13466,
     /*  18752 */     GIR_EraseRootFromParent_Done,
     /*  18753 */   // Label 332: @18753
     /*  18753 */   GIM_Try, /*On fail goto*//*Label 333*/ GIMT_Encode4(18834), // Rule ID 13494 //
     /*  18758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  18769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18773 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18785 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18788 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18797 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18806 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18817 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  18824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18832 */     GIR_RootConstrainSelectedInstOperands,
     /*  18833 */     // GIR_Coverage, 13494,
     /*  18833 */     GIR_EraseRootFromParent_Done,
     /*  18834 */   // Label 333: @18834
     /*  18834 */   GIM_Try, /*On fail goto*//*Label 334*/ GIMT_Encode4(18915), // Rule ID 1697 //
     /*  18839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18870 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18873 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  18878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18882 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18898 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (SABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv2i32_v2i64),
     /*  18901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18903 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18905 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18909 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18913 */     GIR_RootConstrainSelectedInstOperands,
     /*  18914 */     // GIR_Coverage, 1697,
     /*  18914 */     GIR_EraseRootFromParent_Done,
     /*  18915 */   // Label 334: @18915
     /*  18915 */   GIM_Try, /*On fail goto*//*Label 335*/ GIMT_Encode4(18996), // Rule ID 1775 //
     /*  18920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  18923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18927 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  18931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  18935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  18939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  18943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  18947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  18951 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  18954 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  18959 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  18963 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  18967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  18977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  18979 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)))  =>  (UABALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  18979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv2i32_v2i64),
     /*  18982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  18984 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  18986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  18990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  18994 */     GIR_RootConstrainSelectedInstOperands,
     /*  18995 */     // GIR_Coverage, 1775,
     /*  18995 */     GIR_EraseRootFromParent_Done,
     /*  18996 */   // Label 335: @18996
     /*  18996 */   GIM_Try, /*On fail goto*//*Label 336*/ GIMT_Encode4(19088), // Rule ID 13565 //
     /*  19001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19020 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19024 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19028 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19032 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19036 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19040 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19045 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19049 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19053 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19057 */     // MIs[3] Operand 1
     /*  19057 */     // No operand predicates
     /*  19057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19062 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19066 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19068 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19086 */     GIR_RootConstrainSelectedInstOperands,
     /*  19087 */     // GIR_Coverage, 13565,
     /*  19087 */     GIR_EraseRootFromParent_Done,
     /*  19088 */   // Label 336: @19088
     /*  19088 */   GIM_Try, /*On fail goto*//*Label 337*/ GIMT_Encode4(19180), // Rule ID 13564 //
     /*  19093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19146 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19150 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19154 */     // MIs[3] Operand 1
     /*  19154 */     // No operand predicates
     /*  19154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19158 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19160 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19178 */     GIR_RootConstrainSelectedInstOperands,
     /*  19179 */     // GIR_Coverage, 13564,
     /*  19179 */     GIR_EraseRootFromParent_Done,
     /*  19180 */   // Label 337: @19180
     /*  19180 */   GIM_Try, /*On fail goto*//*Label 338*/ GIMT_Encode4(19272), // Rule ID 13601 //
     /*  19185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19220 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19224 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19237 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19241 */     // MIs[3] Operand 1
     /*  19241 */     // No operand predicates
     /*  19241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19252 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19270 */     GIR_RootConstrainSelectedInstOperands,
     /*  19271 */     // GIR_Coverage, 13601,
     /*  19271 */     GIR_EraseRootFromParent_Done,
     /*  19272 */   // Label 338: @19272
     /*  19272 */   GIM_Try, /*On fail goto*//*Label 339*/ GIMT_Encode4(19364), // Rule ID 13600 //
     /*  19277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19321 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19326 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19330 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19334 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19338 */     // MIs[3] Operand 1
     /*  19338 */     // No operand predicates
     /*  19338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19342 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19344 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  19351 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19359 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19362 */     GIR_RootConstrainSelectedInstOperands,
     /*  19363 */     // GIR_Coverage, 13600,
     /*  19363 */     GIR_EraseRootFromParent_Done,
     /*  19364 */   // Label 339: @19364
     /*  19364 */   GIM_Try, /*On fail goto*//*Label 340*/ GIMT_Encode4(19456), // Rule ID 13563 //
     /*  19369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19376 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19421 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19425 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19429 */     // MIs[3] Operand 1
     /*  19429 */     // No operand predicates
     /*  19429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19436 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19441 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19451 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19454 */     GIR_RootConstrainSelectedInstOperands,
     /*  19455 */     // GIR_Coverage, 13563,
     /*  19455 */     GIR_EraseRootFromParent_Done,
     /*  19456 */   // Label 340: @19456
     /*  19456 */   GIM_Try, /*On fail goto*//*Label 341*/ GIMT_Encode4(19548), // Rule ID 2041 //
     /*  19461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19472 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19476 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  19480 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19484 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19514 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19518 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19522 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19526 */     // MIs[3] Operand 1
     /*  19526 */     // No operand predicates
     /*  19526 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19528 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_indexed),
     /*  19531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19546 */     GIR_RootConstrainSelectedInstOperands,
     /*  19547 */     // GIR_Coverage, 2041,
     /*  19547 */     GIR_EraseRootFromParent_Done,
     /*  19548 */   // Label 341: @19548
     /*  19548 */   GIM_Try, /*On fail goto*//*Label 342*/ GIMT_Encode4(19640), // Rule ID 13599 //
     /*  19553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  19584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19596 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19609 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19613 */     // MIs[3] Operand 1
     /*  19613 */     // No operand predicates
     /*  19613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19618 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19620 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19625 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  19631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19635 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19638 */     GIR_RootConstrainSelectedInstOperands,
     /*  19639 */     // GIR_Coverage, 13599,
     /*  19639 */     GIR_EraseRootFromParent_Done,
     /*  19640 */   // Label 342: @19640
     /*  19640 */   GIM_Try, /*On fail goto*//*Label 343*/ GIMT_Encode4(19732), // Rule ID 2093 //
     /*  19645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19652 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  19664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19668 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  19672 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  19677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  19681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  19685 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  19689 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  19693 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19698 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  19702 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  19706 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  19710 */     // MIs[3] Operand 1
     /*  19710 */     // No operand predicates
     /*  19710 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  19712 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  19712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_indexed),
     /*  19715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  19717 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  19719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  19723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  19727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  19730 */     GIR_RootConstrainSelectedInstOperands,
     /*  19731 */     // GIR_Coverage, 2093,
     /*  19731 */     GIR_EraseRootFromParent_Done,
     /*  19732 */   // Label 343: @19732
     /*  19732 */   GIM_Try, /*On fail goto*//*Label 344*/ GIMT_Encode4(19783), // Rule ID 13508 //
     /*  19737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19752 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19760 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19762 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19769 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19776 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19781 */     GIR_RootConstrainSelectedInstOperands,
     /*  19782 */     // GIR_Coverage, 13508,
     /*  19782 */     GIR_EraseRootFromParent_Done,
     /*  19783 */   // Label 344: @19783
     /*  19783 */   GIM_Try, /*On fail goto*//*Label 345*/ GIMT_Encode4(19834), // Rule ID 13474 //
     /*  19788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19813 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19820 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19820 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19823 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19825 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19832 */     GIR_RootConstrainSelectedInstOperands,
     /*  19833 */     // GIR_Coverage, 13474,
     /*  19833 */     GIR_EraseRootFromParent_Done,
     /*  19834 */   // Label 345: @19834
     /*  19834 */   GIM_Try, /*On fail goto*//*Label 346*/ GIMT_Encode4(19885), // Rule ID 13507 //
     /*  19839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  19850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  19854 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19862 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19864 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19871 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  19878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19883 */     GIR_RootConstrainSelectedInstOperands,
     /*  19884 */     // GIR_Coverage, 13507,
     /*  19884 */     GIR_EraseRootFromParent_Done,
     /*  19885 */   // Label 346: @19885
     /*  19885 */   GIM_Try, /*On fail goto*//*Label 347*/ GIMT_Encode4(19936), // Rule ID 1813 //
     /*  19890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  19909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19913 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19915 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19922 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  19925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19929 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19934 */     GIR_RootConstrainSelectedInstOperands,
     /*  19935 */     // GIR_Coverage, 1813,
     /*  19935 */     GIR_EraseRootFromParent_Done,
     /*  19936 */   // Label 347: @19936
     /*  19936 */   GIM_Try, /*On fail goto*//*Label 348*/ GIMT_Encode4(19987), // Rule ID 1723 //
     /*  19941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19948 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  19956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  19960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  19964 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  19966 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  19973 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  19973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i32_v2i64),
     /*  19976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  19978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  19980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  19985 */     GIR_RootConstrainSelectedInstOperands,
     /*  19986 */     // GIR_Coverage, 1723,
     /*  19986 */     GIR_EraseRootFromParent_Done,
     /*  19987 */   // Label 348: @19987
     /*  19987 */   GIM_Try, /*On fail goto*//*Label 349*/ GIMT_Encode4(20038), // Rule ID 1812 //
     /*  19992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  19995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  19999 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20017 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  20024 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UADDWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  20024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i32_v2i64),
     /*  20027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  20031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  20036 */     GIR_RootConstrainSelectedInstOperands,
     /*  20037 */     // GIR_Coverage, 1812,
     /*  20037 */     GIR_EraseRootFromParent_Done,
     /*  20038 */   // Label 349: @20038
     /*  20038 */   GIM_Try, /*On fail goto*//*Label 350*/ GIMT_Encode4(20094), // Rule ID 13392 //
     /*  20043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20058 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20061 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20066 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20081 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20092 */     GIR_RootConstrainSelectedInstOperands,
     /*  20093 */     // GIR_Coverage, 13392,
     /*  20093 */     GIR_EraseRootFromParent_Done,
     /*  20094 */   // Label 350: @20094
     /*  20094 */   GIM_Try, /*On fail goto*//*Label 351*/ GIMT_Encode4(20150), // Rule ID 13404 //
     /*  20099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20114 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20117 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20137 */     // (add:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20148 */     GIR_RootConstrainSelectedInstOperands,
     /*  20149 */     // GIR_Coverage, 13404,
     /*  20149 */     GIR_EraseRootFromParent_Done,
     /*  20150 */   // Label 351: @20150
     /*  20150 */   GIM_Try, /*On fail goto*//*Label 352*/ GIMT_Encode4(20217), // Rule ID 13642 //
     /*  20155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20179 */     // MIs[1] imm
     /*  20179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20187 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20191 */     // MIs[2] Operand 1
     /*  20191 */     // No operand predicates
     /*  20191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20195 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20199 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20201 */     // (add:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20208 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20212 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20215 */     GIR_RootConstrainSelectedInstOperands,
     /*  20216 */     // GIR_Coverage, 13642,
     /*  20216 */     GIR_EraseRootFromParent_Done,
     /*  20217 */   // Label 352: @20217
     /*  20217 */   GIM_Try, /*On fail goto*//*Label 353*/ GIMT_Encode4(20284), // Rule ID 13663 //
     /*  20222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20233 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20237 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20241 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20246 */     // MIs[1] imm
     /*  20246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20254 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20258 */     // MIs[2] Operand 1
     /*  20258 */     // No operand predicates
     /*  20258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20262 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20266 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20268 */     // (add:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  20275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20279 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20282 */     GIR_RootConstrainSelectedInstOperands,
     /*  20283 */     // GIR_Coverage, 13663,
     /*  20283 */     GIR_EraseRootFromParent_Done,
     /*  20284 */   // Label 353: @20284
     /*  20284 */   GIM_Try, /*On fail goto*//*Label 354*/ GIMT_Encode4(20340), // Rule ID 999 //
     /*  20289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20296 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20308 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20311 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  20316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20327 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  20330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20334 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20338 */     GIR_RootConstrainSelectedInstOperands,
     /*  20339 */     // GIR_Coverage, 999,
     /*  20339 */     GIR_EraseRootFromParent_Done,
     /*  20340 */   // Label 354: @20340
     /*  20340 */   GIM_Try, /*On fail goto*//*Label 355*/ GIMT_Encode4(20396), // Rule ID 1060 //
     /*  20345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20352 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  20364 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  20367 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  20372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  20376 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  20383 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  20383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  20386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20388 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  20394 */     GIR_RootConstrainSelectedInstOperands,
     /*  20395 */     // GIR_Coverage, 1060,
     /*  20395 */     GIR_EraseRootFromParent_Done,
     /*  20396 */   // Label 355: @20396
     /*  20396 */   GIM_Try, /*On fail goto*//*Label 356*/ GIMT_Encode4(20463), // Rule ID 2242 //
     /*  20401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  20420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20429 */     // MIs[1] imm
     /*  20429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20437 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20441 */     // MIs[2] Operand 1
     /*  20441 */     // No operand predicates
     /*  20441 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20447 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  20450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20452 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20454 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20458 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20461 */     GIR_RootConstrainSelectedInstOperands,
     /*  20462 */     // GIR_Coverage, 2242,
     /*  20462 */     GIR_EraseRootFromParent_Done,
     /*  20463 */   // Label 356: @20463
     /*  20463 */   GIM_Try, /*On fail goto*//*Label 357*/ GIMT_Encode4(20530), // Rule ID 2301 //
     /*  20468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20475 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  20483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  20487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20496 */     // MIs[1] imm
     /*  20496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  20500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  20504 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  20508 */     // MIs[2] Operand 1
     /*  20508 */     // No operand predicates
     /*  20508 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  20512 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20514 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  20514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  20517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  20519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  20521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20525 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  20528 */     GIR_RootConstrainSelectedInstOperands,
     /*  20529 */     // GIR_Coverage, 2301,
     /*  20529 */     GIR_EraseRootFromParent_Done,
     /*  20530 */   // Label 357: @20530
     /*  20530 */   GIM_Try, /*On fail goto*//*Label 358*/ GIMT_Encode4(20600), // Rule ID 6964 //
     /*  20535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20551 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20555 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20573 */     // MIs[2] Rn
     /*  20573 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20578 */     // MIs[2] Rm
     /*  20578 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20585 */     // (add:{ *:[v2i64] } (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20598 */     GIR_RootConstrainSelectedInstOperands,
     /*  20599 */     // GIR_Coverage, 6964,
     /*  20599 */     GIR_EraseRootFromParent_Done,
     /*  20600 */   // Label 358: @20600
     /*  20600 */   GIM_Try, /*On fail goto*//*Label 359*/ GIMT_Encode4(20670), // Rule ID 14021 //
     /*  20605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20609 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20613 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /*  20617 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  20621 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  20625 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /*  20643 */     // MIs[2] Rn
     /*  20643 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  20648 */     // MIs[2] Rm
     /*  20648 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  20653 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20655 */     // (add:{ *:[v2i64] } (AArch64zip2:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm), (AArch64zip1:{ *:[v2i64] } FPR128:{ *:[v2i64] }:$Rn, FPR128:{ *:[v2i64] }:$Rm))  =>  (ADDPv2i64:{ *:[v2i64] } ?:{ *:[v2i64] }:$Rn, ?:{ *:[v2i64] }:$Rm)
     /*  20655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /*  20658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  20668 */     GIR_RootConstrainSelectedInstOperands,
     /*  20669 */     // GIR_Coverage, 14021,
     /*  20669 */     GIR_EraseRootFromParent_Done,
     /*  20670 */   // Label 359: @20670
     /*  20670 */   GIM_Try, /*On fail goto*//*Label 360*/ GIMT_Encode4(20733), // Rule ID 1797 //
     /*  20675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20699 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20703 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20707 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20711 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20718 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20731 */     GIR_RootConstrainSelectedInstOperands,
     /*  20732 */     // GIR_Coverage, 1797,
     /*  20732 */     GIR_EraseRootFromParent_Done,
     /*  20733 */   // Label 360: @20733
     /*  20733 */   GIM_Try, /*On fail goto*//*Label 361*/ GIMT_Encode4(20796), // Rule ID 1796 //
     /*  20738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20745 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20749 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20753 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20762 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20766 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20770 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20774 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20781 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20794 */     GIR_RootConstrainSelectedInstOperands,
     /*  20795 */     // GIR_Coverage, 1796,
     /*  20795 */     GIR_EraseRootFromParent_Done,
     /*  20796 */   // Label 361: @20796
     /*  20796 */   GIM_Try, /*On fail goto*//*Label 362*/ GIMT_Encode4(20859), // Rule ID 1716 //
     /*  20801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20816 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20820 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  20833 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20837 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20842 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20844 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv2i32_v2i64),
     /*  20847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20849 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20857 */     GIR_RootConstrainSelectedInstOperands,
     /*  20858 */     // GIR_Coverage, 1716,
     /*  20858 */     GIR_EraseRootFromParent_Done,
     /*  20859 */   // Label 362: @20859
     /*  20859 */   GIM_Try, /*On fail goto*//*Label 363*/ GIMT_Encode4(20922), // Rule ID 1795 //
     /*  20864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  20896 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20905 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20907 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20920 */     GIR_RootConstrainSelectedInstOperands,
     /*  20921 */     // GIR_Coverage, 1795,
     /*  20921 */     GIR_EraseRootFromParent_Done,
     /*  20922 */   // Label 363: @20922
     /*  20922 */   GIM_Try, /*On fail goto*//*Label 364*/ GIMT_Encode4(20985), // Rule ID 1794 //
     /*  20927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  20938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20942 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  20955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  20959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  20963 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  20968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  20970 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  20970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv2i32_v2i64),
     /*  20973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  20975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  20979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  20983 */     GIR_RootConstrainSelectedInstOperands,
     /*  20984 */     // GIR_Coverage, 1794,
     /*  20984 */     GIR_EraseRootFromParent_Done,
     /*  20985 */   // Label 364: @20985
     /*  20985 */   GIM_Try, /*On fail goto*//*Label 365*/ GIMT_Encode4(21046), // Rule ID 13479 //
     /*  20990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  20993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  20997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21018 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21027 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21029 */     // (add:{ *:[v2i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21040 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21044 */     GIR_RootConstrainSelectedInstOperands,
     /*  21045 */     // GIR_Coverage, 13479,
     /*  21045 */     GIR_EraseRootFromParent_Done,
     /*  21046 */   // Label 365: @21046
     /*  21046 */   GIM_Try, /*On fail goto*//*Label 366*/ GIMT_Encode4(21107), // Rule ID 13513 //
     /*  21051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21066 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21070 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21090 */     // (add:{ *:[v2i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21105 */     GIR_RootConstrainSelectedInstOperands,
     /*  21106 */     // GIR_Coverage, 13513,
     /*  21106 */     GIR_EraseRootFromParent_Done,
     /*  21107 */   // Label 366: @21107
     /*  21107 */   GIM_Try, /*On fail goto*//*Label 367*/ GIMT_Encode4(21155), // Rule ID 13506 //
     /*  21112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21140 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21142 */     // (add:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21153 */     GIR_RootConstrainSelectedInstOperands,
     /*  21154 */     // GIR_Coverage, 13506,
     /*  21154 */     GIR_EraseRootFromParent_Done,
     /*  21155 */   // Label 367: @21155
     /*  21155 */   GIM_Try, /*On fail goto*//*Label 368*/ GIMT_Encode4(21203), // Rule ID 13391 //
     /*  21160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21188 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21190 */     // (add:{ *:[v2i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21201 */     GIR_RootConstrainSelectedInstOperands,
     /*  21202 */     // GIR_Coverage, 13391,
     /*  21202 */     GIR_EraseRootFromParent_Done,
     /*  21203 */   // Label 368: @21203
     /*  21203 */   GIM_Try, /*On fail goto*//*Label 369*/ GIMT_Encode4(21251), // Rule ID 13473 //
     /*  21208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21227 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21236 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21238 */     // (add:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21249 */     GIR_RootConstrainSelectedInstOperands,
     /*  21250 */     // GIR_Coverage, 13473,
     /*  21250 */     GIR_EraseRootFromParent_Done,
     /*  21251 */   // Label 369: @21251
     /*  21251 */   GIM_Try, /*On fail goto*//*Label 370*/ GIMT_Encode4(21299), // Rule ID 13403 //
     /*  21256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21275 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21286 */     // (add:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn), V128:{ *:[v2i64] }:$Rd)  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  21293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21297 */     GIR_RootConstrainSelectedInstOperands,
     /*  21298 */     // GIR_Coverage, 13403,
     /*  21298 */     GIR_EraseRootFromParent_Done,
     /*  21299 */   // Label 370: @21299
     /*  21299 */   GIM_Try, /*On fail goto*//*Label 371*/ GIMT_Encode4(21347), // Rule ID 13505 //
     /*  21304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21323 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21332 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21334 */     // (add:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rn)  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  21341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21345 */     GIR_RootConstrainSelectedInstOperands,
     /*  21346 */     // GIR_Coverage, 13505,
     /*  21346 */     GIR_EraseRootFromParent_Done,
     /*  21347 */   // Label 371: @21347
     /*  21347 */   GIM_Try, /*On fail goto*//*Label 372*/ GIMT_Encode4(21408), // Rule ID 1728 //
     /*  21352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  21371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21384 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21389 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21391 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv2i32_v2i64),
     /*  21394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21396 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21406 */     GIR_RootConstrainSelectedInstOperands,
     /*  21407 */     // GIR_Coverage, 1728,
     /*  21407 */     GIR_EraseRootFromParent_Done,
     /*  21408 */   // Label 372: @21408
     /*  21408 */   GIM_Try, /*On fail goto*//*Label 373*/ GIMT_Encode4(21469), // Rule ID 1818 //
     /*  21413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21420 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  21432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  21440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21452 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv2i32_v2i64),
     /*  21455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  21467 */     GIR_RootConstrainSelectedInstOperands,
     /*  21468 */     // GIR_Coverage, 1818,
     /*  21468 */     GIR_EraseRootFromParent_Done,
     /*  21469 */   // Label 373: @21469
     /*  21469 */   GIM_Try, /*On fail goto*//*Label 374*/ GIMT_Encode4(21517), // Rule ID 1811 //
     /*  21474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21504 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21509 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21515 */     GIR_RootConstrainSelectedInstOperands,
     /*  21516 */     // GIR_Coverage, 1811,
     /*  21516 */     GIR_EraseRootFromParent_Done,
     /*  21517 */   // Label 374: @21517
     /*  21517 */   GIM_Try, /*On fail goto*//*Label 375*/ GIMT_Encode4(21565), // Rule ID 998 //
     /*  21522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21529 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  21541 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21545 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21550 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21552 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv4i32_v2i64),
     /*  21555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21563 */     GIR_RootConstrainSelectedInstOperands,
     /*  21564 */     // GIR_Coverage, 998,
     /*  21564 */     GIR_EraseRootFromParent_Done,
     /*  21565 */   // Label 375: @21565
     /*  21565 */   GIM_Try, /*On fail goto*//*Label 376*/ GIMT_Encode4(21613), // Rule ID 1722 //
     /*  21570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  21589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21593 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21600 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv2i32_v2i64),
     /*  21603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21607 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21611 */     GIR_RootConstrainSelectedInstOperands,
     /*  21612 */     // GIR_Coverage, 1722,
     /*  21612 */     GIR_EraseRootFromParent_Done,
     /*  21613 */   // Label 376: @21613
     /*  21613 */   GIM_Try, /*On fail goto*//*Label 377*/ GIMT_Encode4(21661), // Rule ID 1059 //
     /*  21618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  21637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  21641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21646 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21648 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADALPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /*  21648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv4i32_v2i64),
     /*  21651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  21655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  21659 */     GIR_RootConstrainSelectedInstOperands,
     /*  21660 */     // GIR_Coverage, 1059,
     /*  21660 */     GIR_EraseRootFromParent_Done,
     /*  21661 */   // Label 377: @21661
     /*  21661 */   GIM_Try, /*On fail goto*//*Label 378*/ GIMT_Encode4(21709), // Rule ID 1810 //
     /*  21666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21673 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  21681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  21689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21694 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  21696 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (UADDWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  21696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv2i32_v2i64),
     /*  21699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  21701 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  21703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  21707 */     GIR_RootConstrainSelectedInstOperands,
     /*  21708 */     // GIR_Coverage, 1810,
     /*  21708 */     GIR_EraseRootFromParent_Done,
     /*  21709 */   // Label 378: @21709
     /*  21709 */   GIM_Try, /*On fail goto*//*Label 379*/ GIMT_Encode4(21736), // Rule ID 1106 //
     /*  21714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  21717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21729 */     // (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  21729 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv2i64),
     /*  21734 */     GIR_RootConstrainSelectedInstOperands,
     /*  21735 */     // GIR_Coverage, 1106,
     /*  21735 */     GIR_Done,
     /*  21736 */   // Label 379: @21736
     /*  21736 */   GIM_Reject,
     /*  21737 */ // Label 302: @21737
     /*  21737 */ GIM_Reject,
     /*  21738 */ // Label 159: @21738
     /*  21738 */ GIM_Try, /*On fail goto*//*Label 380*/ GIMT_Encode4(25235),
     /*  21743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  21746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  21749 */   GIM_Try, /*On fail goto*//*Label 381*/ GIMT_Encode4(21885), // Rule ID 5383 //
     /*  21754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21787 */     // MIs[1] Operand 2
     /*  21787 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21798 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21802 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21806 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21810 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21814 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21818 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21822 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21827 */     // MIs[3] Operand 2
     /*  21827 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21838 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21840 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21856 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21860 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  21865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  21867 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  21874 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21879 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  21884 */     // GIR_Coverage, 5383,
     /*  21884 */     GIR_EraseRootFromParent_Done,
     /*  21885 */   // Label 381: @21885
     /*  21885 */   GIM_Try, /*On fail goto*//*Label 382*/ GIMT_Encode4(22021), // Rule ID 5382 //
     /*  21890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  21898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  21910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  21914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21918 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21923 */     // MIs[1] Operand 2
     /*  21923 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  21934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  21938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  21942 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  21946 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  21950 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  21954 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  21958 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  21963 */     // MIs[3] Operand 2
     /*  21963 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  21974 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  21976 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  21976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  21979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  21983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  21988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  21992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  21996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  21998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22020 */     // GIR_Coverage, 5382,
     /*  22020 */     GIR_EraseRootFromParent_Done,
     /*  22021 */   // Label 382: @22021
     /*  22021 */   GIM_Try, /*On fail goto*//*Label 383*/ GIMT_Encode4(22157), // Rule ID 5398 //
     /*  22026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22059 */     // MIs[1] Operand 2
     /*  22059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22070 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22074 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22078 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22082 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22086 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  22090 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22094 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22099 */     // MIs[3] Operand 2
     /*  22099 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22112 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22112 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22115 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  22119 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22128 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22132 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22139 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22146 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22151 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22156 */     // GIR_Coverage, 5398,
     /*  22156 */     GIR_EraseRootFromParent_Done,
     /*  22157 */   // Label 383: @22157
     /*  22157 */   GIM_Try, /*On fail goto*//*Label 384*/ GIMT_Encode4(22293), // Rule ID 5381 //
     /*  22162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22190 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22195 */     // MIs[1] Operand 2
     /*  22195 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22206 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22210 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22214 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  22226 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22230 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22235 */     // MIs[3] Operand 2
     /*  22235 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22246 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22248 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22264 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22275 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22292 */     // GIR_Coverage, 5381,
     /*  22292 */     GIR_EraseRootFromParent_Done,
     /*  22293 */   // Label 384: @22293
     /*  22293 */   GIM_Try, /*On fail goto*//*Label 385*/ GIMT_Encode4(22429), // Rule ID 5380 //
     /*  22298 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22331 */     // MIs[1] Operand 2
     /*  22331 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22342 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22346 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22350 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22354 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22358 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  22362 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22366 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22371 */     // MIs[3] Operand 2
     /*  22371 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22382 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  22384 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  22391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22396 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22400 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  22404 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22411 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22418 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22423 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22428 */     // GIR_Coverage, 5380,
     /*  22428 */     GIR_EraseRootFromParent_Done,
     /*  22429 */   // Label 385: @22429
     /*  22429 */   GIM_Try, /*On fail goto*//*Label 386*/ GIMT_Encode4(22562), // Rule ID 14026 //
     /*  22434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22438 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22442 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22446 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22450 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22454 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  22458 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22462 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22466 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  22475 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22479 */     // MIs[1] Operand 2
     /*  22479 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22490 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  22494 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22498 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22502 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  22506 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22510 */     // MIs[5] Rn
     /*  22510 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22515 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22517 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }), (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22533 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22537 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22544 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22561 */     // GIR_Coverage, 14026,
     /*  22561 */     GIR_EraseRootFromParent_Done,
     /*  22562 */   // Label 386: @22562
     /*  22562 */   GIM_Try, /*On fail goto*//*Label 387*/ GIMT_Encode4(22695), // Rule ID 6969 //
     /*  22567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  22579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  22583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  22591 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22595 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22600 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  22604 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22608 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  22616 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  22620 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  22624 */     // MIs[4] Rn
     /*  22624 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  22629 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  22633 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  22637 */     // MIs[3] Operand 2
     /*  22637 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  22648 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  22650 */     // (add:{ *:[v4i16] } (trunc:{ *:[v4i16] } (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$Rn)), (extract_subvector:{ *:[v4i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, (undef:{ *:[v8i16] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /*  22650 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  22653 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  22657 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22666 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22677 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22684 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22689 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22694 */     // GIR_Coverage, 6969,
     /*  22694 */     GIR_EraseRootFromParent_Done,
     /*  22695 */   // Label 387: @22695
     /*  22695 */   GIM_Try, /*On fail goto*//*Label 388*/ GIMT_Encode4(22858), // Rule ID 13984 //
     /*  22700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  22724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22728 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22732 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22737 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22742 */     // MIs[1] Operand 2
     /*  22742 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22759 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22759 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22762 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22766 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22771 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22773 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22776 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22780 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22785 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22788 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22792 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22795 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22800 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22805 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  22817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22822 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22825 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22829 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  22838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  22840 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  22847 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22852 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22857 */     // GIR_Coverage, 13984,
     /*  22857 */     GIR_EraseRootFromParent_Done,
     /*  22858 */   // Label 388: @22858
     /*  22858 */   GIM_Try, /*On fail goto*//*Label 389*/ GIMT_Encode4(23021), // Rule ID 13981 //
     /*  22863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  22871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  22875 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  22879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  22883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  22887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  22891 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  22895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22905 */     // MIs[1] Operand 2
     /*  22905 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  22916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22920 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  22922 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Ra)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  22922 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  22925 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  22929 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  22936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  22939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  22943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22948 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  22951 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Ra
     /*  22955 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  22958 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22963 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  22968 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  22973 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  22976 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  22980 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  22985 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  22988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  22992 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  22996 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  22998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23003 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23015 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23020 */     // GIR_Coverage, 13981,
     /*  23020 */     GIR_EraseRootFromParent_Done,
     /*  23021 */   // Label 389: @23021
     /*  23021 */   GIM_Try, /*On fail goto*//*Label 390*/ GIMT_Encode4(23171), // Rule ID 13988 //
     /*  23026 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23054 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23059 */     // MIs[1] Operand 2
     /*  23059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23074 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23076 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23090 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23093 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23097 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23102 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23105 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23109 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23112 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23117 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23122 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23153 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23160 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23165 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23170 */     // GIR_Coverage, 13988,
     /*  23170 */     GIR_EraseRootFromParent_Done,
     /*  23171 */   // Label 390: @23171
     /*  23171 */   GIM_Try, /*On fail goto*//*Label 391*/ GIMT_Encode4(23321), // Rule ID 13993 //
     /*  23176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23180 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23184 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23188 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23192 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23196 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23200 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23204 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23209 */     // MIs[1] Operand 2
     /*  23209 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23226 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23226 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23229 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23233 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23238 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23240 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23243 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23247 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23252 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23255 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23259 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23262 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23267 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23272 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23277 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23280 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  23284 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23289 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23303 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23310 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23315 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23320 */     // GIR_Coverage, 13993,
     /*  23320 */     GIR_EraseRootFromParent_Done,
     /*  23321 */   // Label 391: @23321
     /*  23321 */   GIM_Try, /*On fail goto*//*Label 392*/ GIMT_Encode4(23471), // Rule ID 13987 //
     /*  23326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  23334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  23350 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23354 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23359 */     // MIs[1] Operand 2
     /*  23359 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23376 */     // (add:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23376 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23379 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23383 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23388 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23390 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23393 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23397 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23402 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23405 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  23409 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23412 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23417 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23422 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23439 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23442 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23470 */     // GIR_Coverage, 13987,
     /*  23470 */     GIR_EraseRootFromParent_Done,
     /*  23471 */   // Label 392: @23471
     /*  23471 */   GIM_Try, /*On fail goto*//*Label 393*/ GIMT_Encode4(23634), // Rule ID 5371 //
     /*  23476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23480 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  23504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23512 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23517 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23522 */     // MIs[1] Operand 2
     /*  23522 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23535 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23535 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23538 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23542 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23549 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23552 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23556 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23561 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23564 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23568 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23571 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  23593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23601 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23605 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23609 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23616 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23628 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23633 */     // GIR_Coverage, 5371,
     /*  23633 */     GIR_EraseRootFromParent_Done,
     /*  23634 */   // Label 393: @23634
     /*  23634 */   GIM_Try, /*On fail goto*//*Label 394*/ GIMT_Encode4(23797), // Rule ID 5368 //
     /*  23639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  23667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  23675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23685 */     // MIs[1] Operand 2
     /*  23685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23698 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLALv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23698 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23701 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23705 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23712 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23715 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23719 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23724 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  23731 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23734 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23739 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23749 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23752 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  23756 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23761 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23764 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  23768 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  23772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23779 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23786 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23796 */     // GIR_Coverage, 5368,
     /*  23796 */     GIR_EraseRootFromParent_Done,
     /*  23797 */   // Label 394: @23797
     /*  23797 */   GIM_Try, /*On fail goto*//*Label 395*/ GIMT_Encode4(23947), // Rule ID 5393 //
     /*  23802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23826 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  23830 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23834 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23839 */     // MIs[1] Operand 2
     /*  23839 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  23850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  23852 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  23852 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  23855 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  23859 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23864 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  23866 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  23869 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  23873 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23878 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  23881 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  23885 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  23888 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  23906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  23910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  23915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  23918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  23922 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  23924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  23927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  23929 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  23936 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23941 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  23946 */     // GIR_Coverage, 5393,
     /*  23946 */     GIR_EraseRootFromParent_Done,
     /*  23947 */   // Label 395: @23947
     /*  23947 */   GIM_Try, /*On fail goto*//*Label 396*/ GIMT_Encode4(24097), // Rule ID 5401 //
     /*  23952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23956 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  23964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  23968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  23972 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  23976 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  23980 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  23984 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  23989 */     // MIs[1] Operand 2
     /*  23989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24000 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24002 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24002 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24005 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24009 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24014 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24016 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24019 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24023 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24028 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24031 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24035 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24038 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24043 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24048 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24053 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24056 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  24060 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24065 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24068 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24079 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24091 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24096 */     // GIR_Coverage, 5401,
     /*  24096 */     GIR_EraseRootFromParent_Done,
     /*  24097 */   // Label 396: @24097
     /*  24097 */   GIM_Try, /*On fail goto*//*Label 397*/ GIMT_Encode4(24247), // Rule ID 5392 //
     /*  24102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  24118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  24122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  24126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  24130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  24134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24139 */     // MIs[1] Operand 2
     /*  24139 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  24150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24152 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UADDWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  24152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  24155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  24159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  24166 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  24169 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  24173 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24178 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  24181 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  24185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  24188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24198 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  24206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  24210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  24215 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  24218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  24222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  24224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  24227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24229 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  24236 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  24246 */     // GIR_Coverage, 5392,
     /*  24246 */     GIR_EraseRootFromParent_Done,
     /*  24247 */   // Label 397: @24247
     /*  24247 */   GIM_Try, /*On fail goto*//*Label 398*/ GIMT_Encode4(24316), // Rule ID 13420 //
     /*  24252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24267 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24270 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24299 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24314 */     GIR_RootConstrainSelectedInstOperands,
     /*  24315 */     // GIR_Coverage, 13420,
     /*  24315 */     GIR_EraseRootFromParent_Done,
     /*  24316 */   // Label 398: @24316
     /*  24316 */   GIM_Try, /*On fail goto*//*Label 399*/ GIMT_Encode4(24385), // Rule ID 13432 //
     /*  24321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24336 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24339 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24344 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24348 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24352 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24357 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24368 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V64:{ *:[v4i16] }:$Rd)  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24383 */     GIR_RootConstrainSelectedInstOperands,
     /*  24384 */     // GIR_Coverage, 13432,
     /*  24384 */     GIR_EraseRootFromParent_Done,
     /*  24385 */   // Label 399: @24385
     /*  24385 */   GIM_Try, /*On fail goto*//*Label 400*/ GIMT_Encode4(24441), // Rule ID 13382 //
     /*  24390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24405 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24408 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24426 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24428 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24435 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24439 */     GIR_RootConstrainSelectedInstOperands,
     /*  24440 */     // GIR_Coverage, 13382,
     /*  24440 */     GIR_EraseRootFromParent_Done,
     /*  24441 */   // Label 400: @24441
     /*  24441 */   GIM_Try, /*On fail goto*//*Label 401*/ GIMT_Encode4(24497), // Rule ID 13394 //
     /*  24446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24461 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24464 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24484 */     // (add:{ *:[v4i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24495 */     GIR_RootConstrainSelectedInstOperands,
     /*  24496 */     // GIR_Coverage, 13394,
     /*  24496 */     GIR_EraseRootFromParent_Done,
     /*  24497 */   // Label 401: @24497
     /*  24497 */   GIM_Try, /*On fail goto*//*Label 402*/ GIMT_Encode4(24564), // Rule ID 13634 //
     /*  24502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24513 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24517 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24521 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24526 */     // MIs[1] imm
     /*  24526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24534 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24538 */     // MIs[2] Operand 1
     /*  24538 */     // No operand predicates
     /*  24538 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24542 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24548 */     // (add:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24562 */     GIR_RootConstrainSelectedInstOperands,
     /*  24563 */     // GIR_Coverage, 13634,
     /*  24563 */     GIR_EraseRootFromParent_Done,
     /*  24564 */   // Label 402: @24564
     /*  24564 */   GIM_Try, /*On fail goto*//*Label 403*/ GIMT_Encode4(24631), // Rule ID 13655 //
     /*  24569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  24580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24584 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24588 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24593 */     // MIs[1] imm
     /*  24593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24605 */     // MIs[2] Operand 1
     /*  24605 */     // No operand predicates
     /*  24605 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24609 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24613 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24615 */     // (add:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  24618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  24622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24629 */     GIR_RootConstrainSelectedInstOperands,
     /*  24630 */     // GIR_Coverage, 13655,
     /*  24630 */     GIR_EraseRootFromParent_Done,
     /*  24631 */   // Label 403: @24631
     /*  24631 */   GIM_Try, /*On fail goto*//*Label 404*/ GIMT_Encode4(24700), // Rule ID 1361 //
     /*  24636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24655 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24658 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  24663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24667 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24671 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24681 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24683 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i16),
     /*  24686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24688 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24690 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24698 */     GIR_RootConstrainSelectedInstOperands,
     /*  24699 */     // GIR_Coverage, 1361,
     /*  24699 */     GIR_EraseRootFromParent_Done,
     /*  24700 */   // Label 404: @24700
     /*  24700 */   GIM_Try, /*On fail goto*//*Label 405*/ GIMT_Encode4(24769), // Rule ID 1484 //
     /*  24705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24716 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24720 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24724 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  24727 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  24732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  24736 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  24740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24752 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABAv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  24752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i16),
     /*  24755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  24767 */     GIR_RootConstrainSelectedInstOperands,
     /*  24768 */     // GIR_Coverage, 1484,
     /*  24768 */     GIR_EraseRootFromParent_Done,
     /*  24769 */   // Label 405: @24769
     /*  24769 */   GIM_Try, /*On fail goto*//*Label 406*/ GIMT_Encode4(24825), // Rule ID 989 //
     /*  24774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24781 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24793 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24796 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  24801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24812 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  24815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24823 */     GIR_RootConstrainSelectedInstOperands,
     /*  24824 */     // GIR_Coverage, 989,
     /*  24824 */     GIR_EraseRootFromParent_Done,
     /*  24825 */   // Label 406: @24825
     /*  24825 */   GIM_Try, /*On fail goto*//*Label 407*/ GIMT_Encode4(24881), // Rule ID 1050 //
     /*  24830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  24849 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  24852 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  24857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  24861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24866 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  24868 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  24868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  24871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  24879 */     GIR_RootConstrainSelectedInstOperands,
     /*  24880 */     // GIR_Coverage, 1050,
     /*  24880 */     GIR_EraseRootFromParent_Done,
     /*  24881 */   // Label 407: @24881
     /*  24881 */   GIM_Try, /*On fail goto*//*Label 408*/ GIMT_Encode4(24948), // Rule ID 2234 //
     /*  24886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24893 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  24905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24909 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24914 */     // MIs[1] imm
     /*  24914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24922 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24926 */     // MIs[2] Operand 1
     /*  24926 */     // No operand predicates
     /*  24926 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24930 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24932 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  24935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  24937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  24939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  24943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  24946 */     GIR_RootConstrainSelectedInstOperands,
     /*  24947 */     // GIR_Coverage, 2234,
     /*  24947 */     GIR_EraseRootFromParent_Done,
     /*  24948 */   // Label 408: @24948
     /*  24948 */   GIM_Try, /*On fail goto*//*Label 409*/ GIMT_Encode4(25015), // Rule ID 2293 //
     /*  24953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  24956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  24968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  24972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  24976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  24981 */     // MIs[1] imm
     /*  24981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  24985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  24989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  24993 */     // MIs[2] Operand 1
     /*  24993 */     // No operand predicates
     /*  24993 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  24997 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  24999 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  24999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  25002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  25013 */     GIR_RootConstrainSelectedInstOperands,
     /*  25014 */     // GIR_Coverage, 2293,
     /*  25014 */     GIR_EraseRootFromParent_Done,
     /*  25015 */   // Label 409: @25015
     /*  25015 */   GIM_Try, /*On fail goto*//*Label 410*/ GIMT_Encode4(25063), // Rule ID 13381 //
     /*  25020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25039 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25050 */     // (add:{ *:[v4i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25061 */     GIR_RootConstrainSelectedInstOperands,
     /*  25062 */     // GIR_Coverage, 13381,
     /*  25062 */     GIR_EraseRootFromParent_Done,
     /*  25063 */   // Label 410: @25063
     /*  25063 */   GIM_Try, /*On fail goto*//*Label 411*/ GIMT_Encode4(25111), // Rule ID 13393 //
     /*  25068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25098 */     // (add:{ *:[v4i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn), V64:{ *:[v4i16] }:$Rd)  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25109 */     GIR_RootConstrainSelectedInstOperands,
     /*  25110 */     // GIR_Coverage, 13393,
     /*  25110 */     GIR_EraseRootFromParent_Done,
     /*  25111 */   // Label 411: @25111
     /*  25111 */   GIM_Try, /*On fail goto*//*Label 412*/ GIMT_Encode4(25159), // Rule ID 988 //
     /*  25116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  25135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25139 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25144 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25146 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i8_v4i16),
     /*  25149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25151 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25157 */     GIR_RootConstrainSelectedInstOperands,
     /*  25158 */     // GIR_Coverage, 988,
     /*  25158 */     GIR_EraseRootFromParent_Done,
     /*  25159 */   // Label 412: @25159
     /*  25159 */   GIM_Try, /*On fail goto*//*Label 413*/ GIMT_Encode4(25207), // Rule ID 1049 //
     /*  25164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  25183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  25187 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  25194 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADALPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /*  25194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i8_v4i16),
     /*  25197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25199 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  25205 */     GIR_RootConstrainSelectedInstOperands,
     /*  25206 */     // GIR_Coverage, 1049,
     /*  25206 */     GIR_EraseRootFromParent_Done,
     /*  25207 */   // Label 413: @25207
     /*  25207 */   GIM_Try, /*On fail goto*//*Label 414*/ GIMT_Encode4(25234), // Rule ID 1102 //
     /*  25212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25219 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  25227 */     // (add:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  25227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i16),
     /*  25232 */     GIR_RootConstrainSelectedInstOperands,
     /*  25233 */     // GIR_Coverage, 1102,
     /*  25233 */     GIR_Done,
     /*  25234 */   // Label 414: @25234
     /*  25234 */   GIM_Reject,
     /*  25235 */ // Label 380: @25235
     /*  25235 */ GIM_Reject,
     /*  25236 */ // Label 160: @25236
     /*  25236 */ GIM_Try, /*On fail goto*//*Label 415*/ GIMT_Encode4(31413),
     /*  25241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  25244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  25247 */   GIM_Try, /*On fail goto*//*Label 416*/ GIMT_Encode4(25365), // Rule ID 13558 //
     /*  25252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25287 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25291 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25295 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25299 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25303 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25308 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25312 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25316 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25320 */     // MIs[4] Operand 1
     /*  25320 */     // No operand predicates
     /*  25320 */     // MIs[2] Operand 2
     /*  25320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25335 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25337 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25344 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25351 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25356 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25360 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25363 */     GIR_RootConstrainSelectedInstOperands,
     /*  25364 */     // GIR_Coverage, 13558,
     /*  25364 */     GIR_EraseRootFromParent_Done,
     /*  25365 */   // Label 416: @25365
     /*  25365 */   GIM_Try, /*On fail goto*//*Label 417*/ GIMT_Encode4(25483), // Rule ID 13559 //
     /*  25370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25381 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25385 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25389 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25401 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25405 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25409 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25413 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25417 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25421 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25426 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25430 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25434 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25438 */     // MIs[4] Operand 1
     /*  25438 */     // No operand predicates
     /*  25438 */     // MIs[2] Operand 2
     /*  25438 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25453 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25455 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25462 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25474 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25481 */     GIR_RootConstrainSelectedInstOperands,
     /*  25482 */     // GIR_Coverage, 13559,
     /*  25482 */     GIR_EraseRootFromParent_Done,
     /*  25483 */   // Label 417: @25483
     /*  25483 */   GIM_Try, /*On fail goto*//*Label 418*/ GIMT_Encode4(25601), // Rule ID 13594 //
     /*  25488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25507 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25531 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25535 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25539 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25544 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25548 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25552 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25556 */     // MIs[4] Operand 1
     /*  25556 */     // No operand predicates
     /*  25556 */     // MIs[2] Operand 2
     /*  25556 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25567 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25571 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25573 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25580 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25587 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25599 */     GIR_RootConstrainSelectedInstOperands,
     /*  25600 */     // GIR_Coverage, 13594,
     /*  25600 */     GIR_EraseRootFromParent_Done,
     /*  25601 */   // Label 418: @25601
     /*  25601 */   GIM_Try, /*On fail goto*//*Label 419*/ GIMT_Encode4(25719), // Rule ID 13595 //
     /*  25606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  25617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25621 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25625 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25637 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25649 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25653 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25657 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25662 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25666 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25670 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25674 */     // MIs[4] Operand 1
     /*  25674 */     // No operand predicates
     /*  25674 */     // MIs[2] Operand 2
     /*  25674 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25689 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25691 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25698 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  25701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  25705 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25714 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25717 */     GIR_RootConstrainSelectedInstOperands,
     /*  25718 */     // GIR_Coverage, 13595,
     /*  25718 */     GIR_EraseRootFromParent_Done,
     /*  25719 */   // Label 419: @25719
     /*  25719 */   GIM_Try, /*On fail goto*//*Label 420*/ GIMT_Encode4(25837), // Rule ID 2039 //
     /*  25724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25763 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25767 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25771 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25775 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25779 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25784 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25788 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25792 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25796 */     // MIs[4] Operand 1
     /*  25796 */     // No operand predicates
     /*  25796 */     // MIs[2] Operand 2
     /*  25796 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25807 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25809 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25816 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25832 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25835 */     GIR_RootConstrainSelectedInstOperands,
     /*  25836 */     // GIR_Coverage, 2039,
     /*  25836 */     GIR_EraseRootFromParent_Done,
     /*  25837 */   // Label 420: @25837
     /*  25837 */   GIM_Try, /*On fail goto*//*Label 421*/ GIMT_Encode4(25955), // Rule ID 13557 //
     /*  25842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  25861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  25873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25881 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  25885 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  25889 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25893 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  25897 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  25902 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  25906 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  25910 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  25914 */     // MIs[4] Operand 1
     /*  25914 */     // No operand predicates
     /*  25914 */     // MIs[2] Operand 2
     /*  25914 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  25925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  25927 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  25934 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  25934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_indexed),
     /*  25937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  25939 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  25941 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  25946 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  25950 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  25953 */     GIR_RootConstrainSelectedInstOperands,
     /*  25954 */     // GIR_Coverage, 13557,
     /*  25954 */     GIR_EraseRootFromParent_Done,
     /*  25955 */   // Label 421: @25955
     /*  25955 */   GIM_Try, /*On fail goto*//*Label 422*/ GIMT_Encode4(26073), // Rule ID 2091 //
     /*  25960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  25963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  25971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  25975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  25979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  25983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  25987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  25991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  25995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  25999 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26003 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26007 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26011 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26015 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26020 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26024 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26028 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26032 */     // MIs[4] Operand 1
     /*  26032 */     // No operand predicates
     /*  26032 */     // MIs[2] Operand 2
     /*  26032 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26043 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26045 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26052 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26057 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26068 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26071 */     GIR_RootConstrainSelectedInstOperands,
     /*  26072 */     // GIR_Coverage, 2091,
     /*  26072 */     GIR_EraseRootFromParent_Done,
     /*  26073 */   // Label 422: @26073
     /*  26073 */   GIM_Try, /*On fail goto*//*Label 423*/ GIMT_Encode4(26191), // Rule ID 13593 //
     /*  26078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26085 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26117 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26121 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26125 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26129 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26133 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26142 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26146 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26150 */     // MIs[4] Operand 1
     /*  26150 */     // No operand predicates
     /*  26150 */     // MIs[2] Operand 2
     /*  26150 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  26161 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26163 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26170 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_indexed),
     /*  26173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26175 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26177 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26186 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26189 */     GIR_RootConstrainSelectedInstOperands,
     /*  26190 */     // GIR_Coverage, 13593,
     /*  26190 */     GIR_EraseRootFromParent_Done,
     /*  26191 */   // Label 423: @26191
     /*  26191 */   GIM_Try, /*On fail goto*//*Label 424*/ GIMT_Encode4(26278), // Rule ID 13464 //
     /*  26196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26223 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26226 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26235 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26245 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26252 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26259 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26271 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26276 */     GIR_RootConstrainSelectedInstOperands,
     /*  26277 */     // GIR_Coverage, 13464,
     /*  26277 */     GIR_EraseRootFromParent_Done,
     /*  26278 */   // Label 424: @26278
     /*  26278 */   GIM_Try, /*On fail goto*//*Label 425*/ GIMT_Encode4(26365), // Rule ID 13492 //
     /*  26283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26310 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26313 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26322 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26330 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26332 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26339 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26346 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26358 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26363 */     GIR_RootConstrainSelectedInstOperands,
     /*  26364 */     // GIR_Coverage, 13492,
     /*  26364 */     GIR_EraseRootFromParent_Done,
     /*  26365 */   // Label 425: @26365
     /*  26365 */   GIM_Try, /*On fail goto*//*Label 426*/ GIMT_Encode4(26452), // Rule ID 1695 //
     /*  26370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26377 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26401 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26404 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  26409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26413 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26419 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26426 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26433 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (SABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i16_v4i32),
     /*  26436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26438 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26450 */     GIR_RootConstrainSelectedInstOperands,
     /*  26451 */     // GIR_Coverage, 1695,
     /*  26451 */     GIR_EraseRootFromParent_Done,
     /*  26452 */   // Label 426: @26452
     /*  26452 */   GIM_Try, /*On fail goto*//*Label 427*/ GIMT_Encode4(26539), // Rule ID 1773 //
     /*  26457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  26472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  26476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  26488 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  26491 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  26496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26500 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  26504 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  26506 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26513 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  26520 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))))  =>  (UABALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  26520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i16_v4i32),
     /*  26523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  26527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  26532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  26537 */     GIR_RootConstrainSelectedInstOperands,
     /*  26538 */     // GIR_Coverage, 1773,
     /*  26538 */     GIR_EraseRootFromParent_Done,
     /*  26539 */   // Label 427: @26539
     /*  26539 */   GIM_Try, /*On fail goto*//*Label 428*/ GIMT_Encode4(26654), // Rule ID 13553 //
     /*  26544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26579 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26583 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26587 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26595 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26604 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26608 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26612 */     // MIs[4] Operand 1
     /*  26612 */     // No operand predicates
     /*  26612 */     // MIs[2] Operand 2
     /*  26612 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26632 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26634 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26652 */     GIR_RootConstrainSelectedInstOperands,
     /*  26653 */     // GIR_Coverage, 13553,
     /*  26653 */     GIR_EraseRootFromParent_Done,
     /*  26654 */   // Label 428: @26654
     /*  26654 */   GIM_Try, /*On fail goto*//*Label 429*/ GIMT_Encode4(26769), // Rule ID 13552 //
     /*  26659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  26674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26699 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26703 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26707 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26711 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26720 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26724 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26728 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26732 */     // MIs[4] Operand 1
     /*  26732 */     // No operand predicates
     /*  26732 */     // MIs[2] Operand 2
     /*  26732 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26747 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26749 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  26752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26764 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26767 */     GIR_RootConstrainSelectedInstOperands,
     /*  26768 */     // GIR_Coverage, 13552,
     /*  26768 */     GIR_EraseRootFromParent_Done,
     /*  26769 */   // Label 429: @26769
     /*  26769 */   GIM_Try, /*On fail goto*//*Label 430*/ GIMT_Encode4(26884), // Rule ID 13589 //
     /*  26774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  26801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26817 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26821 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26825 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26830 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26834 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26838 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26842 */     // MIs[4] Operand 1
     /*  26842 */     // No operand predicates
     /*  26842 */     // MIs[2] Operand 2
     /*  26842 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26862 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26864 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  26875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26882 */     GIR_RootConstrainSelectedInstOperands,
     /*  26883 */     // GIR_Coverage, 13589,
     /*  26883 */     GIR_EraseRootFromParent_Done,
     /*  26884 */   // Label 430: @26884
     /*  26884 */   GIM_Try, /*On fail goto*//*Label 431*/ GIMT_Encode4(26999), // Rule ID 13588 //
     /*  26889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  26892 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  26900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  26904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  26908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  26912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  26917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  26921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  26925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  26933 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  26937 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  26941 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  26945 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  26950 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  26954 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  26958 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  26962 */     // MIs[4] Operand 1
     /*  26962 */     // No operand predicates
     /*  26962 */     // MIs[2] Operand 2
     /*  26962 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  26973 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  26977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  26979 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  26979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  26982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  26984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  26986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  26990 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  26994 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  26997 */     GIR_RootConstrainSelectedInstOperands,
     /*  26998 */     // GIR_Coverage, 13588,
     /*  26998 */     GIR_EraseRootFromParent_Done,
     /*  26999 */   // Label 431: @26999
     /*  26999 */   GIM_Try, /*On fail goto*//*Label 432*/ GIMT_Encode4(27068), // Rule ID 1793 //
     /*  27004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27037 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27051 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27056 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27066 */     GIR_RootConstrainSelectedInstOperands,
     /*  27067 */     // GIR_Coverage, 1793,
     /*  27067 */     GIR_EraseRootFromParent_Done,
     /*  27068 */   // Label 432: @27068
     /*  27068 */   GIM_Try, /*On fail goto*//*Label 433*/ GIMT_Encode4(27137), // Rule ID 1792 //
     /*  27073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27088 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27100 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27104 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27106 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27113 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27120 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27130 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27135 */     GIR_RootConstrainSelectedInstOperands,
     /*  27136 */     // GIR_Coverage, 1792,
     /*  27136 */     GIR_EraseRootFromParent_Done,
     /*  27137 */   // Label 433: @27137
     /*  27137 */   GIM_Try, /*On fail goto*//*Label 434*/ GIMT_Encode4(27206), // Rule ID 1715 //
     /*  27142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  27169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27175 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27182 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27189 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i16_v4i32),
     /*  27192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27194 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27199 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27204 */     GIR_RootConstrainSelectedInstOperands,
     /*  27205 */     // GIR_Coverage, 1715,
     /*  27205 */     GIR_EraseRootFromParent_Done,
     /*  27206 */   // Label 434: @27206
     /*  27206 */   GIM_Try, /*On fail goto*//*Label 435*/ GIMT_Encode4(27275), // Rule ID 1791 //
     /*  27211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27222 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27226 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27230 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27234 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  27238 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27242 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27244 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27251 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27258 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27268 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27273 */     GIR_RootConstrainSelectedInstOperands,
     /*  27274 */     // GIR_Coverage, 1791,
     /*  27274 */     GIR_EraseRootFromParent_Done,
     /*  27275 */   // Label 435: @27275
     /*  27275 */   GIM_Try, /*On fail goto*//*Label 436*/ GIMT_Encode4(27344), // Rule ID 1790 //
     /*  27280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  27303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  27307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  27313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27327 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i16_v4i32),
     /*  27330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  27332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27342 */     GIR_RootConstrainSelectedInstOperands,
     /*  27343 */     // GIR_Coverage, 1790,
     /*  27343 */     GIR_EraseRootFromParent_Done,
     /*  27344 */   // Label 436: @27344
     /*  27344 */   GIM_Try, /*On fail goto*//*Label 437*/ GIMT_Encode4(27459), // Rule ID 13551 //
     /*  27349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27352 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27356 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27396 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27400 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27404 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27409 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27413 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27417 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27421 */     // MIs[4] Operand 1
     /*  27421 */     // No operand predicates
     /*  27421 */     // MIs[2] Operand 2
     /*  27421 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27432 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27439 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27457 */     GIR_RootConstrainSelectedInstOperands,
     /*  27458 */     // GIR_Coverage, 13551,
     /*  27458 */     GIR_EraseRootFromParent_Done,
     /*  27459 */   // Label 437: @27459
     /*  27459 */   GIM_Try, /*On fail goto*//*Label 438*/ GIMT_Encode4(27574), // Rule ID 2037 //
     /*  27464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27508 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27512 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27516 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27524 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27533 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27537 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27541 */     // MIs[4] Operand 1
     /*  27541 */     // No operand predicates
     /*  27541 */     // MIs[2] Operand 2
     /*  27541 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27552 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27554 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  27557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27572 */     GIR_RootConstrainSelectedInstOperands,
     /*  27573 */     // GIR_Coverage, 2037,
     /*  27573 */     GIR_EraseRootFromParent_Done,
     /*  27574 */   // Label 438: @27574
     /*  27574 */   GIM_Try, /*On fail goto*//*Label 439*/ GIMT_Encode4(27689), // Rule ID 13587 //
     /*  27579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27582 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27602 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27606 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  27610 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27614 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27618 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27622 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27626 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27630 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27634 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27647 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27651 */     // MIs[4] Operand 1
     /*  27651 */     // No operand predicates
     /*  27651 */     // MIs[2] Operand 2
     /*  27651 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27669 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  27680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27684 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27687 */     GIR_RootConstrainSelectedInstOperands,
     /*  27688 */     // GIR_Coverage, 13587,
     /*  27688 */     GIR_EraseRootFromParent_Done,
     /*  27689 */   // Label 439: @27689
     /*  27689 */   GIM_Try, /*On fail goto*//*Label 440*/ GIMT_Encode4(27804), // Rule ID 2089 //
     /*  27694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27717 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27721 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  27726 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  27730 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  27734 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27738 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  27742 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  27746 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  27750 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  27754 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  27759 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  27763 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  27767 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  27771 */     // MIs[4] Operand 1
     /*  27771 */     // No operand predicates
     /*  27771 */     // MIs[2] Operand 2
     /*  27771 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  27782 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  27784 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  27784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  27787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27789 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  27795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  27799 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  27802 */     GIR_RootConstrainSelectedInstOperands,
     /*  27803 */     // GIR_Coverage, 2089,
     /*  27803 */     GIR_EraseRootFromParent_Done,
     /*  27804 */   // Label 440: @27804
     /*  27804 */   GIM_Try, /*On fail goto*//*Label 441*/ GIMT_Encode4(27871), // Rule ID 13478 //
     /*  27809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27838 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27852 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27869 */     GIR_RootConstrainSelectedInstOperands,
     /*  27870 */     // GIR_Coverage, 13478,
     /*  27870 */     GIR_EraseRootFromParent_Done,
     /*  27871 */   // Label 441: @27871
     /*  27871 */   GIM_Try, /*On fail goto*//*Label 442*/ GIMT_Encode4(27938), // Rule ID 13512 //
     /*  27876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  27887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  27891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27905 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27912 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27919 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  27922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  27926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  27936 */     GIR_RootConstrainSelectedInstOperands,
     /*  27937 */     // GIR_Coverage, 13512,
     /*  27937 */     GIR_EraseRootFromParent_Done,
     /*  27938 */   // Label 442: @27938
     /*  27938 */   GIM_Try, /*On fail goto*//*Label 443*/ GIMT_Encode4(28005), // Rule ID 1727 //
     /*  27943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  27946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27950 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  27954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  27958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  27962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  27966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  27970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  27972 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27979 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  27986 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  27986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i16_v4i32),
     /*  27989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  27991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  27993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  27998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28003 */     GIR_RootConstrainSelectedInstOperands,
     /*  28004 */     // GIR_Coverage, 1727,
     /*  28004 */     GIR_EraseRootFromParent_Done,
     /*  28005 */   // Label 443: @28005
     /*  28005 */   GIM_Try, /*On fail goto*//*Label 444*/ GIMT_Encode4(28072), // Rule ID 1817 //
     /*  28010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  28039 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28046 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  28053 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  28053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i16_v4i32),
     /*  28056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28058 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28060 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  28065 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  28070 */     GIR_RootConstrainSelectedInstOperands,
     /*  28071 */     // GIR_Coverage, 1817,
     /*  28071 */     GIR_EraseRootFromParent_Done,
     /*  28072 */   // Label 444: @28072
     /*  28072 */   GIM_Try, /*On fail goto*//*Label 445*/ GIMT_Encode4(28153), // Rule ID 13462 //
     /*  28077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28084 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28088 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28092 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28096 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28100 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28104 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28107 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28116 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28120 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28134 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28136 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28136 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28139 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28151 */     GIR_RootConstrainSelectedInstOperands,
     /*  28152 */     // GIR_Coverage, 13462,
     /*  28152 */     GIR_EraseRootFromParent_Done,
     /*  28153 */   // Label 445: @28153
     /*  28153 */   GIM_Try, /*On fail goto*//*Label 446*/ GIMT_Encode4(28234), // Rule ID 13490 //
     /*  28158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28185 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28188 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28197 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28206 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28215 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28217 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28232 */     GIR_RootConstrainSelectedInstOperands,
     /*  28233 */     // GIR_Coverage, 13490,
     /*  28233 */     GIR_EraseRootFromParent_Done,
     /*  28234 */   // Label 446: @28234
     /*  28234 */   GIM_Try, /*On fail goto*//*Label 447*/ GIMT_Encode4(28315), // Rule ID 1693 //
     /*  28239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28270 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28273 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  28278 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28282 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28291 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28296 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28298 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (SABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv4i16_v4i32),
     /*  28301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28313 */     GIR_RootConstrainSelectedInstOperands,
     /*  28314 */     // GIR_Coverage, 1693,
     /*  28314 */     GIR_EraseRootFromParent_Done,
     /*  28315 */   // Label 447: @28315
     /*  28315 */   GIM_Try, /*On fail goto*//*Label 448*/ GIMT_Encode4(28396), // Rule ID 1771 //
     /*  28320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28327 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  28339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28343 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28347 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  28351 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  28354 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  28359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28363 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  28367 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28377 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  28379 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)))  =>  (UABALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  28379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv4i16_v4i32),
     /*  28382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  28390 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  28394 */     GIR_RootConstrainSelectedInstOperands,
     /*  28395 */     // GIR_Coverage, 1771,
     /*  28395 */     GIR_EraseRootFromParent_Done,
     /*  28396 */   // Label 448: @28396
     /*  28396 */   GIM_Try, /*On fail goto*//*Label 449*/ GIMT_Encode4(28488), // Rule ID 13556 //
     /*  28401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28408 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28412 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28416 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28436 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28440 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28445 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28449 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28453 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28457 */     // MIs[3] Operand 1
     /*  28457 */     // No operand predicates
     /*  28457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28468 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28486 */     GIR_RootConstrainSelectedInstOperands,
     /*  28487 */     // GIR_Coverage, 13556,
     /*  28487 */     GIR_EraseRootFromParent_Done,
     /*  28488 */   // Label 449: @28488
     /*  28488 */   GIM_Try, /*On fail goto*//*Label 450*/ GIMT_Encode4(28580), // Rule ID 13555 //
     /*  28493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28537 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28542 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28546 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28550 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28554 */     // MIs[3] Operand 1
     /*  28554 */     // No operand predicates
     /*  28554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28558 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28560 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28578 */     GIR_RootConstrainSelectedInstOperands,
     /*  28579 */     // GIR_Coverage, 13555,
     /*  28579 */     GIR_EraseRootFromParent_Done,
     /*  28580 */   // Label 450: @28580
     /*  28580 */   GIM_Try, /*On fail goto*//*Label 451*/ GIMT_Encode4(28672), // Rule ID 13592 //
     /*  28585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28608 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28612 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28616 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28620 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28624 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28629 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28633 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28637 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28641 */     // MIs[3] Operand 1
     /*  28641 */     // No operand predicates
     /*  28641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28650 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28652 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28667 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28670 */     GIR_RootConstrainSelectedInstOperands,
     /*  28671 */     // GIR_Coverage, 13592,
     /*  28671 */     GIR_EraseRootFromParent_Done,
     /*  28672 */   // Label 451: @28672
     /*  28672 */   GIM_Try, /*On fail goto*//*Label 452*/ GIMT_Encode4(28764), // Rule ID 13591 //
     /*  28677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28684 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  28688 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28692 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28696 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28700 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28717 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28721 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28726 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28730 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28734 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28738 */     // MIs[3] Operand 1
     /*  28738 */     // No operand predicates
     /*  28738 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28742 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28744 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  28747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  28751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28759 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28762 */     GIR_RootConstrainSelectedInstOperands,
     /*  28763 */     // GIR_Coverage, 13591,
     /*  28763 */     GIR_EraseRootFromParent_Done,
     /*  28764 */   // Label 452: @28764
     /*  28764 */   GIM_Try, /*On fail goto*//*Label 453*/ GIMT_Encode4(28856), // Rule ID 13554 //
     /*  28769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28792 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28796 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28800 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28804 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28808 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28825 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28829 */     // MIs[3] Operand 1
     /*  28829 */     // No operand predicates
     /*  28829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28834 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28836 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28841 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  28847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28851 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28854 */     GIR_RootConstrainSelectedInstOperands,
     /*  28855 */     // GIR_Coverage, 13554,
     /*  28855 */     GIR_EraseRootFromParent_Done,
     /*  28856 */   // Label 453: @28856
     /*  28856 */   GIM_Try, /*On fail goto*//*Label 454*/ GIMT_Encode4(28948), // Rule ID 2038 //
     /*  28861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  28880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28884 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28888 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  28893 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  28897 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28901 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28905 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28909 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  28914 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  28918 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  28922 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  28926 */     // MIs[3] Operand 1
     /*  28926 */     // No operand predicates
     /*  28926 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  28928 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  28928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_indexed),
     /*  28931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  28933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  28935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  28939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  28943 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  28946 */     GIR_RootConstrainSelectedInstOperands,
     /*  28947 */     // GIR_Coverage, 2038,
     /*  28947 */     GIR_EraseRootFromParent_Done,
     /*  28948 */   // Label 454: @28948
     /*  28948 */   GIM_Try, /*On fail goto*//*Label 455*/ GIMT_Encode4(29040), // Rule ID 13590 //
     /*  28953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  28956 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28960 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  28964 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  28968 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  28972 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  28976 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  28980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  28984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  28988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  28992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  28996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29013 */     // MIs[3] Operand 1
     /*  29013 */     // No operand predicates
     /*  29013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29020 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29025 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29035 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29038 */     GIR_RootConstrainSelectedInstOperands,
     /*  29039 */     // GIR_Coverage, 13590,
     /*  29039 */     GIR_EraseRootFromParent_Done,
     /*  29040 */   // Label 455: @29040
     /*  29040 */   GIM_Try, /*On fail goto*//*Label 456*/ GIMT_Encode4(29132), // Rule ID 2090 //
     /*  29045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29060 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  29064 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29068 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  29072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  29077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  29085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  29089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  29093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  29098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  29102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  29110 */     // MIs[3] Operand 1
     /*  29110 */     // No operand predicates
     /*  29110 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  29112 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  29112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_indexed),
     /*  29115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29117 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  29127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  29130 */     GIR_RootConstrainSelectedInstOperands,
     /*  29131 */     // GIR_Coverage, 2090,
     /*  29131 */     GIR_EraseRootFromParent_Done,
     /*  29132 */   // Label 456: @29132
     /*  29132 */   GIM_Try, /*On fail goto*//*Label 457*/ GIMT_Encode4(29183), // Rule ID 13504 //
     /*  29137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29162 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29169 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29181 */     GIR_RootConstrainSelectedInstOperands,
     /*  29182 */     // GIR_Coverage, 13504,
     /*  29182 */     GIR_EraseRootFromParent_Done,
     /*  29183 */   // Label 457: @29183
     /*  29183 */   GIM_Try, /*On fail goto*//*Label 458*/ GIMT_Encode4(29234), // Rule ID 13472 //
     /*  29188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29211 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29213 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29220 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29232 */     GIR_RootConstrainSelectedInstOperands,
     /*  29233 */     // GIR_Coverage, 13472,
     /*  29233 */     GIR_EraseRootFromParent_Done,
     /*  29234 */   // Label 458: @29234
     /*  29234 */   GIM_Try, /*On fail goto*//*Label 459*/ GIMT_Encode4(29285), // Rule ID 13503 //
     /*  29239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29258 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29264 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29271 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  29278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29283 */     GIR_RootConstrainSelectedInstOperands,
     /*  29284 */     // GIR_Coverage, 13503,
     /*  29284 */     GIR_EraseRootFromParent_Done,
     /*  29285 */   // Label 459: @29285
     /*  29285 */   GIM_Try, /*On fail goto*//*Label 460*/ GIMT_Encode4(29336), // Rule ID 1809 //
     /*  29290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  29309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29315 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29322 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29334 */     GIR_RootConstrainSelectedInstOperands,
     /*  29335 */     // GIR_Coverage, 1809,
     /*  29335 */     GIR_EraseRootFromParent_Done,
     /*  29336 */   // Label 460: @29336
     /*  29336 */   GIM_Try, /*On fail goto*//*Label 461*/ GIMT_Encode4(29387), // Rule ID 1721 //
     /*  29341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29344 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29348 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  29360 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29364 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29366 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29373 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i16_v4i32),
     /*  29376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29385 */     GIR_RootConstrainSelectedInstOperands,
     /*  29386 */     // GIR_Coverage, 1721,
     /*  29386 */     GIR_EraseRootFromParent_Done,
     /*  29387 */   // Label 461: @29387
     /*  29387 */   GIM_Try, /*On fail goto*//*Label 462*/ GIMT_Encode4(29438), // Rule ID 1808 //
     /*  29392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29399 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  29411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  29415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29417 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  29424 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UADDWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  29424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i16_v4i32),
     /*  29427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  29429 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  29431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  29436 */     GIR_RootConstrainSelectedInstOperands,
     /*  29437 */     // GIR_Coverage, 1808,
     /*  29437 */     GIR_EraseRootFromParent_Done,
     /*  29438 */   // Label 462: @29438
     /*  29438 */   GIM_Try, /*On fail goto*//*Label 463*/ GIMT_Encode4(29507), // Rule ID 13426 //
     /*  29443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29458 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29461 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29470 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29488 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29490 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29495 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29505 */     GIR_RootConstrainSelectedInstOperands,
     /*  29506 */     // GIR_Coverage, 13426,
     /*  29506 */     GIR_EraseRootFromParent_Done,
     /*  29507 */   // Label 463: @29507
     /*  29507 */   GIM_Try, /*On fail goto*//*Label 464*/ GIMT_Encode4(29576), // Rule ID 13438 //
     /*  29512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29527 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29530 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29539 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29559 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29574 */     GIR_RootConstrainSelectedInstOperands,
     /*  29575 */     // GIR_Coverage, 13438,
     /*  29575 */     GIR_EraseRootFromParent_Done,
     /*  29576 */   // Label 464: @29576
     /*  29576 */   GIM_Try, /*On fail goto*//*Label 465*/ GIMT_Encode4(29632), // Rule ID 13388 //
     /*  29581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29596 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29599 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29619 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  29622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29626 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29630 */     GIR_RootConstrainSelectedInstOperands,
     /*  29631 */     // GIR_Coverage, 13388,
     /*  29631 */     GIR_EraseRootFromParent_Done,
     /*  29632 */   // Label 465: @29632
     /*  29632 */   GIM_Try, /*On fail goto*//*Label 466*/ GIMT_Encode4(29688), // Rule ID 13400 //
     /*  29637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29644 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29648 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29652 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29655 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  29660 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29673 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29675 */     // (add:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  29675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  29678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29686 */     GIR_RootConstrainSelectedInstOperands,
     /*  29687 */     // GIR_Coverage, 13400,
     /*  29687 */     GIR_EraseRootFromParent_Done,
     /*  29688 */   // Label 466: @29688
     /*  29688 */   GIM_Try, /*On fail goto*//*Label 467*/ GIMT_Encode4(29755), // Rule ID 13640 //
     /*  29693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29704 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  29708 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29717 */     // MIs[1] imm
     /*  29717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29729 */     // MIs[2] Operand 1
     /*  29729 */     // No operand predicates
     /*  29729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29733 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29737 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29739 */     // (add:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  29742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29746 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29750 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29753 */     GIR_RootConstrainSelectedInstOperands,
     /*  29754 */     // GIR_Coverage, 13640,
     /*  29754 */     GIR_EraseRootFromParent_Done,
     /*  29755 */   // Label 467: @29755
     /*  29755 */   GIM_Try, /*On fail goto*//*Label 468*/ GIMT_Encode4(29822), // Rule ID 13661 //
     /*  29760 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  29771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  29775 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  29779 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29784 */     // MIs[1] imm
     /*  29784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  29788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  29792 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  29796 */     // MIs[2] Operand 1
     /*  29796 */     // No operand predicates
     /*  29796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29800 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  29804 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  29806 */     // (add:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  29806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  29809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  29813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  29817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  29820 */     GIR_RootConstrainSelectedInstOperands,
     /*  29821 */     // GIR_Coverage, 13661,
     /*  29821 */     GIR_EraseRootFromParent_Done,
     /*  29822 */   // Label 468: @29822
     /*  29822 */   GIM_Try, /*On fail goto*//*Label 469*/ GIMT_Encode4(29891), // Rule ID 1367 //
     /*  29827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29834 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29846 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29849 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  29854 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29858 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29872 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29874 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv4i32),
     /*  29877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29889 */     GIR_RootConstrainSelectedInstOperands,
     /*  29890 */     // GIR_Coverage, 1367,
     /*  29890 */     GIR_EraseRootFromParent_Done,
     /*  29891 */   // Label 469: @29891
     /*  29891 */   GIM_Try, /*On fail goto*//*Label 470*/ GIMT_Encode4(29960), // Rule ID 1490 //
     /*  29896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29915 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  29918 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  29923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  29927 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  29931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  29943 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (UABAv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  29943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv4i32),
     /*  29946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  29948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  29950 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  29954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  29958 */     GIR_RootConstrainSelectedInstOperands,
     /*  29959 */     // GIR_Coverage, 1490,
     /*  29959 */     GIR_EraseRootFromParent_Done,
     /*  29960 */   // Label 470: @29960
     /*  29960 */   GIM_Try, /*On fail goto*//*Label 471*/ GIMT_Encode4(30016), // Rule ID 995 //
     /*  29965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  29968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  29976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  29980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  29984 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  29987 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  29992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  29996 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30003 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30014 */     GIR_RootConstrainSelectedInstOperands,
     /*  30015 */     // GIR_Coverage, 995,
     /*  30015 */     GIR_EraseRootFromParent_Done,
     /*  30016 */   // Label 471: @30016
     /*  30016 */   GIM_Try, /*On fail goto*//*Label 472*/ GIMT_Encode4(30072), // Rule ID 1056 //
     /*  30021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30028 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  30040 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  30043 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  30048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  30052 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30057 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30059 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30064 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  30070 */     GIR_RootConstrainSelectedInstOperands,
     /*  30071 */     // GIR_Coverage, 1056,
     /*  30071 */     GIR_EraseRootFromParent_Done,
     /*  30072 */   // Label 472: @30072
     /*  30072 */   GIM_Try, /*On fail goto*//*Label 473*/ GIMT_Encode4(30139), // Rule ID 2240 //
     /*  30077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  30096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30100 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30105 */     // MIs[1] imm
     /*  30105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30113 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30117 */     // MIs[2] Operand 1
     /*  30117 */     // No operand predicates
     /*  30117 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30123 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  30126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30137 */     GIR_RootConstrainSelectedInstOperands,
     /*  30138 */     // GIR_Coverage, 2240,
     /*  30138 */     GIR_EraseRootFromParent_Done,
     /*  30139 */   // Label 473: @30139
     /*  30139 */   GIM_Try, /*On fail goto*//*Label 474*/ GIMT_Encode4(30206), // Rule ID 2299 //
     /*  30144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  30159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  30163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30172 */     // MIs[1] imm
     /*  30172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  30176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  30180 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  30184 */     // MIs[2] Operand 1
     /*  30184 */     // No operand predicates
     /*  30184 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  30188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30190 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  30190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  30193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  30197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  30204 */     GIR_RootConstrainSelectedInstOperands,
     /*  30205 */     // GIR_Coverage, 2299,
     /*  30205 */     GIR_EraseRootFromParent_Done,
     /*  30206 */   // Label 474: @30206
     /*  30206 */   GIM_Try, /*On fail goto*//*Label 475*/ GIMT_Encode4(30276), // Rule ID 6965 //
     /*  30211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  30223 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30227 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  30249 */     // MIs[2] Rn
     /*  30249 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30254 */     // MIs[2] Rm
     /*  30254 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30261 */     // (add:{ *:[v4i32] } (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30266 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30274 */     GIR_RootConstrainSelectedInstOperands,
     /*  30275 */     // GIR_Coverage, 6965,
     /*  30275 */     GIR_EraseRootFromParent_Done,
     /*  30276 */   // Label 475: @30276
     /*  30276 */   GIM_Try, /*On fail goto*//*Label 476*/ GIMT_Encode4(30346), // Rule ID 14022 //
     /*  30281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  30293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  30297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  30301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  30319 */     // MIs[2] Rn
     /*  30319 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  30324 */     // MIs[2] Rm
     /*  30324 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  30329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30331 */     // (add:{ *:[v4i32] } (AArch64uzp2:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm), (AArch64uzp1:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rn, FPR128:{ *:[v4i32] }:$Rm))  =>  (ADDPv4i32:{ *:[v4i32] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rm)
     /*  30331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /*  30334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30344 */     GIR_RootConstrainSelectedInstOperands,
     /*  30345 */     // GIR_Coverage, 14022,
     /*  30345 */     GIR_EraseRootFromParent_Done,
     /*  30346 */   // Label 476: @30346
     /*  30346 */   GIM_Try, /*On fail goto*//*Label 477*/ GIMT_Encode4(30409), // Rule ID 1789 //
     /*  30351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30394 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30407 */     GIR_RootConstrainSelectedInstOperands,
     /*  30408 */     // GIR_Coverage, 1789,
     /*  30408 */     GIR_EraseRootFromParent_Done,
     /*  30409 */   // Label 477: @30409
     /*  30409 */   GIM_Try, /*On fail goto*//*Label 478*/ GIMT_Encode4(30472), // Rule ID 1788 //
     /*  30414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30429 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30433 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30438 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30442 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30446 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30457 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30470 */     GIR_RootConstrainSelectedInstOperands,
     /*  30471 */     // GIR_Coverage, 1788,
     /*  30471 */     GIR_EraseRootFromParent_Done,
     /*  30472 */   // Label 478: @30472
     /*  30472 */   GIM_Try, /*On fail goto*//*Label 479*/ GIMT_Encode4(30535), // Rule ID 1714 //
     /*  30477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30513 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30520 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv4i16_v4i32),
     /*  30523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30525 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30533 */     GIR_RootConstrainSelectedInstOperands,
     /*  30534 */     // GIR_Coverage, 1714,
     /*  30534 */     GIR_EraseRootFromParent_Done,
     /*  30535 */   // Label 479: @30535
     /*  30535 */   GIM_Try, /*On fail goto*//*Label 480*/ GIMT_Encode4(30598), // Rule ID 1787 //
     /*  30540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30581 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30583 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30588 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30596 */     GIR_RootConstrainSelectedInstOperands,
     /*  30597 */     // GIR_Coverage, 1787,
     /*  30597 */     GIR_EraseRootFromParent_Done,
     /*  30598 */   // Label 480: @30598
     /*  30598 */   GIM_Try, /*On fail goto*//*Label 481*/ GIMT_Encode4(30661), // Rule ID 1786 //
     /*  30603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  30631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  30646 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30646 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv4i16_v4i32),
     /*  30649 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  30659 */     GIR_RootConstrainSelectedInstOperands,
     /*  30660 */     // GIR_Coverage, 1786,
     /*  30660 */     GIR_EraseRootFromParent_Done,
     /*  30661 */   // Label 481: @30661
     /*  30661 */   GIM_Try, /*On fail goto*//*Label 482*/ GIMT_Encode4(30722), // Rule ID 13477 //
     /*  30666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  30681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30705 */     // (add:{ *:[v4i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  30708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30716 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30720 */     GIR_RootConstrainSelectedInstOperands,
     /*  30721 */     // GIR_Coverage, 13477,
     /*  30721 */     GIR_EraseRootFromParent_Done,
     /*  30722 */   // Label 482: @30722
     /*  30722 */   GIM_Try, /*On fail goto*//*Label 483*/ GIMT_Encode4(30783), // Rule ID 13511 //
     /*  30727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  30742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30746 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  30750 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30764 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30766 */     // (add:{ *:[v4i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  30769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30777 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  30781 */     GIR_RootConstrainSelectedInstOperands,
     /*  30782 */     // GIR_Coverage, 13511,
     /*  30782 */     GIR_EraseRootFromParent_Done,
     /*  30783 */   // Label 483: @30783
     /*  30783 */   GIM_Try, /*On fail goto*//*Label 484*/ GIMT_Encode4(30831), // Rule ID 13502 //
     /*  30788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  30803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30818 */     // (add:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  30821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30829 */     GIR_RootConstrainSelectedInstOperands,
     /*  30830 */     // GIR_Coverage, 13502,
     /*  30830 */     GIR_EraseRootFromParent_Done,
     /*  30831 */   // Label 484: @30831
     /*  30831 */   GIM_Try, /*On fail goto*//*Label 485*/ GIMT_Encode4(30879), // Rule ID 13387 //
     /*  30836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  30851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30855 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30864 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30866 */     // (add:{ *:[v4i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  30869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30877 */     GIR_RootConstrainSelectedInstOperands,
     /*  30878 */     // GIR_Coverage, 13387,
     /*  30878 */     GIR_EraseRootFromParent_Done,
     /*  30879 */   // Label 485: @30879
     /*  30879 */   GIM_Try, /*On fail goto*//*Label 486*/ GIMT_Encode4(30927), // Rule ID 13471 //
     /*  30884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  30899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  30908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30914 */     // (add:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  30914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  30917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  30919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  30921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  30925 */     GIR_RootConstrainSelectedInstOperands,
     /*  30926 */     // GIR_Coverage, 13471,
     /*  30926 */     GIR_EraseRootFromParent_Done,
     /*  30927 */   // Label 486: @30927
     /*  30927 */   GIM_Try, /*On fail goto*//*Label 487*/ GIMT_Encode4(30975), // Rule ID 13399 //
     /*  30932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  30947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  30951 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30960 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  30962 */     // (add:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn), V128:{ *:[v4i32] }:$Rd)  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  30962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  30965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  30967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  30969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  30973 */     GIR_RootConstrainSelectedInstOperands,
     /*  30974 */     // GIR_Coverage, 13399,
     /*  30974 */     GIR_EraseRootFromParent_Done,
     /*  30975 */   // Label 487: @30975
     /*  30975 */   GIM_Try, /*On fail goto*//*Label 488*/ GIMT_Encode4(31023), // Rule ID 13501 //
     /*  30980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  30983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  30987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  30991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  30995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  30999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31008 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31010 */     // (add:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rn)  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  31017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31021 */     GIR_RootConstrainSelectedInstOperands,
     /*  31022 */     // GIR_Coverage, 13501,
     /*  31022 */     GIR_EraseRootFromParent_Done,
     /*  31023 */   // Label 488: @31023
     /*  31023 */   GIM_Try, /*On fail goto*//*Label 489*/ GIMT_Encode4(31084), // Rule ID 1726 //
     /*  31028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  31047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31060 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31067 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv4i16_v4i32),
     /*  31070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31082 */     GIR_RootConstrainSelectedInstOperands,
     /*  31083 */     // GIR_Coverage, 1726,
     /*  31083 */     GIR_EraseRootFromParent_Done,
     /*  31084 */   // Label 489: @31084
     /*  31084 */   GIM_Try, /*On fail goto*//*Label 490*/ GIMT_Encode4(31145), // Rule ID 1816 //
     /*  31089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31096 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  31108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  31116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31126 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31128 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv4i16_v4i32),
     /*  31131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31133 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  31143 */     GIR_RootConstrainSelectedInstOperands,
     /*  31144 */     // GIR_Coverage, 1816,
     /*  31144 */     GIR_EraseRootFromParent_Done,
     /*  31145 */   // Label 490: @31145
     /*  31145 */   GIM_Try, /*On fail goto*//*Label 491*/ GIMT_Encode4(31193), // Rule ID 1807 //
     /*  31150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  31169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31180 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31185 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31191 */     GIR_RootConstrainSelectedInstOperands,
     /*  31192 */     // GIR_Coverage, 1807,
     /*  31192 */     GIR_EraseRootFromParent_Done,
     /*  31193 */   // Label 491: @31193
     /*  31193 */   GIM_Try, /*On fail goto*//*Label 492*/ GIMT_Encode4(31241), // Rule ID 994 //
     /*  31198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  31217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31221 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31226 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31228 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv8i16_v4i32),
     /*  31231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31239 */     GIR_RootConstrainSelectedInstOperands,
     /*  31240 */     // GIR_Coverage, 994,
     /*  31240 */     GIR_EraseRootFromParent_Done,
     /*  31241 */   // Label 492: @31241
     /*  31241 */   GIM_Try, /*On fail goto*//*Label 493*/ GIMT_Encode4(31289), // Rule ID 1720 //
     /*  31246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  31265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31276 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv4i16_v4i32),
     /*  31279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31281 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31287 */     GIR_RootConstrainSelectedInstOperands,
     /*  31288 */     // GIR_Coverage, 1720,
     /*  31288 */     GIR_EraseRootFromParent_Done,
     /*  31289 */   // Label 493: @31289
     /*  31289 */   GIM_Try, /*On fail goto*//*Label 494*/ GIMT_Encode4(31337), // Rule ID 1055 //
     /*  31294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  31313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31324 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADALPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /*  31324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv8i16_v4i32),
     /*  31327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  31331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31335 */     GIR_RootConstrainSelectedInstOperands,
     /*  31336 */     // GIR_Coverage, 1055,
     /*  31336 */     GIR_EraseRootFromParent_Done,
     /*  31337 */   // Label 494: @31337
     /*  31337 */   GIM_Try, /*On fail goto*//*Label 495*/ GIMT_Encode4(31385), // Rule ID 1806 //
     /*  31342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31349 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  31361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  31365 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31372 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (UADDWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  31372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv4i16_v4i32),
     /*  31375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  31377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  31379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  31383 */     GIR_RootConstrainSelectedInstOperands,
     /*  31384 */     // GIR_Coverage, 1806,
     /*  31384 */     GIR_EraseRootFromParent_Done,
     /*  31385 */   // Label 495: @31385
     /*  31385 */   GIM_Try, /*On fail goto*//*Label 496*/ GIMT_Encode4(31412), // Rule ID 1105 //
     /*  31390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31405 */     // (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  31405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv4i32),
     /*  31410 */     GIR_RootConstrainSelectedInstOperands,
     /*  31411 */     // GIR_Coverage, 1105,
     /*  31411 */     GIR_Done,
     /*  31412 */   // Label 496: @31412
     /*  31412 */   GIM_Reject,
     /*  31413 */ // Label 415: @31413
     /*  31413 */ GIM_Reject,
     /*  31414 */ // Label 161: @31414
     /*  31414 */ GIM_Try, /*On fail goto*//*Label 497*/ GIMT_Encode4(32263),
     /*  31419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31425 */   GIM_Try, /*On fail goto*//*Label 498*/ GIMT_Encode4(31558), // Rule ID 14027 //
     /*  31430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31442 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31446 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31450 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  31454 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31458 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31462 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31467 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  31471 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31475 */     // MIs[1] Operand 2
     /*  31475 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  31486 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  31490 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31494 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31498 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  31502 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31506 */     // MIs[5] Rn
     /*  31506 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31511 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31513 */     // (add:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }), (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31513 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31516 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31520 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31525 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31533 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31540 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31557 */     // GIR_Coverage, 14027,
     /*  31557 */     GIR_EraseRootFromParent_Done,
     /*  31558 */   // Label 498: @31558
     /*  31558 */   GIM_Try, /*On fail goto*//*Label 499*/ GIMT_Encode4(31691), // Rule ID 6970 //
     /*  31563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31571 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  31575 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  31579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  31583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /*  31587 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31591 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  31600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  31604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  31608 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  31612 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_UZP2),
     /*  31616 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  31620 */     // MIs[4] Rn
     /*  31620 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  31625 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  31629 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  31633 */     // MIs[3] Operand 2
     /*  31633 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  31644 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /*  31646 */     // (add:{ *:[v8i8] } (trunc:{ *:[v8i8] } (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$Rn)), (extract_subvector:{ *:[v8i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, (undef:{ *:[v16i8] })), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /*  31646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  31649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  31653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  31658 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  31666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  31668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  31671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31673 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  31680 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  31690 */     // GIR_Coverage, 6970,
     /*  31690 */     GIR_EraseRootFromParent_Done,
     /*  31691 */   // Label 499: @31691
     /*  31691 */   GIM_Try, /*On fail goto*//*Label 500*/ GIMT_Encode4(31760), // Rule ID 13416 //
     /*  31696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31711 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31714 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31723 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31743 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  31746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31750 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31758 */     GIR_RootConstrainSelectedInstOperands,
     /*  31759 */     // GIR_Coverage, 13416,
     /*  31759 */     GIR_EraseRootFromParent_Done,
     /*  31760 */   // Label 500: @31760
     /*  31760 */   GIM_Try, /*On fail goto*//*Label 501*/ GIMT_Encode4(31829), // Rule ID 13428 //
     /*  31765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31780 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31783 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  31788 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31792 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  31796 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31810 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  31812 */     // (add:{ *:[v8i8] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V64:{ *:[v8i8] }:$Rd)  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  31812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  31815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31819 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  31823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  31827 */     GIR_RootConstrainSelectedInstOperands,
     /*  31828 */     // GIR_Coverage, 13428,
     /*  31828 */     GIR_EraseRootFromParent_Done,
     /*  31829 */   // Label 501: @31829
     /*  31829 */   GIM_Try, /*On fail goto*//*Label 502*/ GIMT_Encode4(31896), // Rule ID 13630 //
     /*  31834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  31849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31853 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31858 */     // MIs[1] imm
     /*  31858 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31862 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31866 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31870 */     // MIs[2] Operand 1
     /*  31870 */     // No operand predicates
     /*  31870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31874 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31880 */     // (add:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  31883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31894 */     GIR_RootConstrainSelectedInstOperands,
     /*  31895 */     // GIR_Coverage, 13630,
     /*  31895 */     GIR_EraseRootFromParent_Done,
     /*  31896 */   // Label 502: @31896
     /*  31896 */   GIM_Try, /*On fail goto*//*Label 503*/ GIMT_Encode4(31963), // Rule ID 13651 //
     /*  31901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  31912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  31916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  31920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31925 */     // MIs[1] imm
     /*  31925 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  31929 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  31933 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  31937 */     // MIs[2] Operand 1
     /*  31937 */     // No operand predicates
     /*  31937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31941 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  31945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  31947 */     // (add:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  31947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  31950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  31952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  31954 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  31958 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  31961 */     GIR_RootConstrainSelectedInstOperands,
     /*  31962 */     // GIR_Coverage, 13651,
     /*  31962 */     GIR_EraseRootFromParent_Done,
     /*  31963 */   // Label 503: @31963
     /*  31963 */   GIM_Try, /*On fail goto*//*Label 504*/ GIMT_Encode4(32032), // Rule ID 1357 //
     /*  31968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  31971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31975 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  31979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  31983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  31987 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  31990 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  31995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  31999 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32008 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32015 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i8),
     /*  32018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32030 */     GIR_RootConstrainSelectedInstOperands,
     /*  32031 */     // GIR_Coverage, 1357,
     /*  32031 */     GIR_EraseRootFromParent_Done,
     /*  32032 */   // Label 504: @32032
     /*  32032 */   GIM_Try, /*On fail goto*//*Label 505*/ GIMT_Encode4(32101), // Rule ID 1480 //
     /*  32037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  32059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32064 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32068 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  32084 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABAv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i8),
     /*  32087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  32095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  32099 */     GIR_RootConstrainSelectedInstOperands,
     /*  32100 */     // GIR_Coverage, 1480,
     /*  32100 */     GIR_EraseRootFromParent_Done,
     /*  32101 */   // Label 505: @32101
     /*  32101 */   GIM_Try, /*On fail goto*//*Label 506*/ GIMT_Encode4(32168), // Rule ID 2230 //
     /*  32106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32113 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  32125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32129 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32134 */     // MIs[1] imm
     /*  32134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32142 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32146 */     // MIs[2] Operand 1
     /*  32146 */     // No operand predicates
     /*  32146 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32152 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  32155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32163 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32166 */     GIR_RootConstrainSelectedInstOperands,
     /*  32167 */     // GIR_Coverage, 2230,
     /*  32167 */     GIR_EraseRootFromParent_Done,
     /*  32168 */   // Label 506: @32168
     /*  32168 */   GIM_Try, /*On fail goto*//*Label 507*/ GIMT_Encode4(32235), // Rule ID 2289 //
     /*  32173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32180 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  32192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32196 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32201 */     // MIs[1] imm
     /*  32201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  32205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  32209 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  32213 */     // MIs[2] Operand 1
     /*  32213 */     // No operand predicates
     /*  32213 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  32217 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32219 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  32219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  32222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  32230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  32233 */     GIR_RootConstrainSelectedInstOperands,
     /*  32234 */     // GIR_Coverage, 2289,
     /*  32234 */     GIR_EraseRootFromParent_Done,
     /*  32235 */   // Label 507: @32235
     /*  32235 */   GIM_Try, /*On fail goto*//*Label 508*/ GIMT_Encode4(32262), // Rule ID 1100 //
     /*  32240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32243 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  32255 */     // (add:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  32255 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i8),
     /*  32260 */     GIR_RootConstrainSelectedInstOperands,
     /*  32261 */     // GIR_Coverage, 1100,
     /*  32261 */     GIR_Done,
     /*  32262 */   // Label 508: @32262
     /*  32262 */   GIM_Reject,
     /*  32263 */ // Label 497: @32263
     /*  32263 */ GIM_Reject,
     /*  32264 */ // Label 162: @32264
     /*  32264 */ GIM_Try, /*On fail goto*//*Label 509*/ GIMT_Encode4(35841),
     /*  32269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  32272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  32275 */   GIM_Try, /*On fail goto*//*Label 510*/ GIMT_Encode4(32362), // Rule ID 13460 //
     /*  32280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32295 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32307 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32310 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32315 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32319 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32336 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32343 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32360 */     GIR_RootConstrainSelectedInstOperands,
     /*  32361 */     // GIR_Coverage, 13460,
     /*  32361 */     GIR_EraseRootFromParent_Done,
     /*  32362 */   // Label 510: @32362
     /*  32362 */   GIM_Try, /*On fail goto*//*Label 511*/ GIMT_Encode4(32449), // Rule ID 13488 //
     /*  32367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32390 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32394 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32397 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32402 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32406 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32414 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32416 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32423 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32430 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  32437 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32442 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32447 */     GIR_RootConstrainSelectedInstOperands,
     /*  32448 */     // GIR_Coverage, 13488,
     /*  32448 */     GIR_EraseRootFromParent_Done,
     /*  32449 */   // Label 511: @32449
     /*  32449 */   GIM_Try, /*On fail goto*//*Label 512*/ GIMT_Encode4(32536), // Rule ID 1691 //
     /*  32454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32485 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32488 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  32493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32497 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32503 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32510 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32517 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (SABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv16i8_v8i16),
     /*  32520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32534 */     GIR_RootConstrainSelectedInstOperands,
     /*  32535 */     // GIR_Coverage, 1691,
     /*  32535 */     GIR_EraseRootFromParent_Done,
     /*  32536 */   // Label 512: @32536
     /*  32536 */   GIM_Try, /*On fail goto*//*Label 513*/ GIMT_Encode4(32623), // Rule ID 1769 //
     /*  32541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32548 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  32556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  32568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  32572 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  32575 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  32580 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32584 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  32588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32590 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32597 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32604 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))))  =>  (UABALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv16i8_v8i16),
     /*  32607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  32609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  32611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32616 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32621 */     GIR_RootConstrainSelectedInstOperands,
     /*  32622 */     // GIR_Coverage, 1769,
     /*  32622 */     GIR_EraseRootFromParent_Done,
     /*  32623 */   // Label 513: @32623
     /*  32623 */   GIM_Try, /*On fail goto*//*Label 514*/ GIMT_Encode4(32692), // Rule ID 1785 //
     /*  32628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32635 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32639 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32643 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32655 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32659 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32661 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32668 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32675 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32680 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32685 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32690 */     GIR_RootConstrainSelectedInstOperands,
     /*  32691 */     // GIR_Coverage, 1785,
     /*  32691 */     GIR_EraseRootFromParent_Done,
     /*  32692 */   // Label 514: @32692
     /*  32692 */   GIM_Try, /*On fail goto*//*Label 515*/ GIMT_Encode4(32761), // Rule ID 1784 //
     /*  32697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32724 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32728 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32730 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32737 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32744 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32754 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32759 */     GIR_RootConstrainSelectedInstOperands,
     /*  32760 */     // GIR_Coverage, 1784,
     /*  32760 */     GIR_EraseRootFromParent_Done,
     /*  32761 */   // Label 515: @32761
     /*  32761 */   GIM_Try, /*On fail goto*//*Label 516*/ GIMT_Encode4(32830), // Rule ID 1713 //
     /*  32766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  32793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32799 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32806 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32813 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv16i8_v8i16),
     /*  32816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32828 */     GIR_RootConstrainSelectedInstOperands,
     /*  32829 */     // GIR_Coverage, 1713,
     /*  32829 */     GIR_EraseRootFromParent_Done,
     /*  32830 */   // Label 516: @32830
     /*  32830 */   GIM_Try, /*On fail goto*//*Label 517*/ GIMT_Encode4(32899), // Rule ID 1783 //
     /*  32835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32842 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32846 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32850 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  32862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32868 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32875 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32882 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32897 */     GIR_RootConstrainSelectedInstOperands,
     /*  32898 */     // GIR_Coverage, 1783,
     /*  32898 */     GIR_EraseRootFromParent_Done,
     /*  32899 */   // Label 517: @32899
     /*  32899 */   GIM_Try, /*On fail goto*//*Label 518*/ GIMT_Encode4(32968), // Rule ID 1782 //
     /*  32904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32907 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  32927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  32931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32935 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  32937 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32944 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  32951 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  32951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv16i8_v8i16),
     /*  32954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  32956 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  32961 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  32966 */     GIR_RootConstrainSelectedInstOperands,
     /*  32967 */     // GIR_Coverage, 1782,
     /*  32967 */     GIR_EraseRootFromParent_Done,
     /*  32968 */   // Label 518: @32968
     /*  32968 */   GIM_Try, /*On fail goto*//*Label 519*/ GIMT_Encode4(33035), // Rule ID 13476 //
     /*  32973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  32976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  32980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  32984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  32988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  32992 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  32996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33000 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33002 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33009 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33016 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33023 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33033 */     GIR_RootConstrainSelectedInstOperands,
     /*  33034 */     // GIR_Coverage, 13476,
     /*  33034 */     GIR_EraseRootFromParent_Done,
     /*  33035 */   // Label 519: @33035
     /*  33035 */   GIM_Try, /*On fail goto*//*Label 520*/ GIMT_Encode4(33102), // Rule ID 13510 //
     /*  33040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33067 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33069 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33076 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33083 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33100 */     GIR_RootConstrainSelectedInstOperands,
     /*  33101 */     // GIR_Coverage, 13510,
     /*  33101 */     GIR_EraseRootFromParent_Done,
     /*  33102 */   // Label 520: @33102
     /*  33102 */   GIM_Try, /*On fail goto*//*Label 521*/ GIMT_Encode4(33169), // Rule ID 1725 //
     /*  33107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  33126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33130 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33134 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33136 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33143 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33150 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv16i8_v8i16),
     /*  33153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33155 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33167 */     GIR_RootConstrainSelectedInstOperands,
     /*  33168 */     // GIR_Coverage, 1725,
     /*  33168 */     GIR_EraseRootFromParent_Done,
     /*  33169 */   // Label 521: @33169
     /*  33169 */   GIM_Try, /*On fail goto*//*Label 522*/ GIMT_Encode4(33236), // Rule ID 1815 //
     /*  33174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33181 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  33193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33203 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33217 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLALv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv16i8_v8i16),
     /*  33220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  33229 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  33234 */     GIR_RootConstrainSelectedInstOperands,
     /*  33235 */     // GIR_Coverage, 1815,
     /*  33235 */     GIR_EraseRootFromParent_Done,
     /*  33236 */   // Label 522: @33236
     /*  33236 */   GIM_Try, /*On fail goto*//*Label 523*/ GIMT_Encode4(33317), // Rule ID 13458 //
     /*  33241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33268 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33271 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33276 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33280 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33284 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33300 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33315 */     GIR_RootConstrainSelectedInstOperands,
     /*  33316 */     // GIR_Coverage, 13458,
     /*  33316 */     GIR_EraseRootFromParent_Done,
     /*  33317 */   // Label 523: @33317
     /*  33317 */   GIM_Try, /*On fail goto*//*Label 524*/ GIMT_Encode4(33398), // Rule ID 13486 //
     /*  33322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33349 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33352 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33357 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33361 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33370 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33381 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)), V128:{ *:[v8i16] }:$Rd)  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33386 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33392 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33396 */     GIR_RootConstrainSelectedInstOperands,
     /*  33397 */     // GIR_Coverage, 13486,
     /*  33397 */     GIR_EraseRootFromParent_Done,
     /*  33398 */   // Label 524: @33398
     /*  33398 */   GIM_Try, /*On fail goto*//*Label 525*/ GIMT_Encode4(33479), // Rule ID 1689 //
     /*  33403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33434 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33437 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33446 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33455 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33460 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33462 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (SABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALv8i8_v8i16),
     /*  33465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33477 */     GIR_RootConstrainSelectedInstOperands,
     /*  33478 */     // GIR_Coverage, 1689,
     /*  33478 */     GIR_EraseRootFromParent_Done,
     /*  33479 */   // Label 525: @33479
     /*  33479 */   GIM_Try, /*On fail goto*//*Label 526*/ GIMT_Encode4(33560), // Rule ID 1767 //
     /*  33484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  33511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33515 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  33518 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  33527 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  33531 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33536 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  33541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  33543 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)))  =>  (UABALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  33543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALv8i8_v8i16),
     /*  33546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  33550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rn
     /*  33554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /*  33558 */     GIR_RootConstrainSelectedInstOperands,
     /*  33559 */     // GIR_Coverage, 1767,
     /*  33559 */     GIR_EraseRootFromParent_Done,
     /*  33560 */   // Label 526: @33560
     /*  33560 */   GIM_Try, /*On fail goto*//*Label 527*/ GIMT_Encode4(33611), // Rule ID 13500 //
     /*  33565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33576 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33580 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33590 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33597 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33609 */     GIR_RootConstrainSelectedInstOperands,
     /*  33610 */     // GIR_Coverage, 13500,
     /*  33610 */     GIR_EraseRootFromParent_Done,
     /*  33611 */   // Label 527: @33611
     /*  33611 */   GIM_Try, /*On fail goto*//*Label 528*/ GIMT_Encode4(33662), // Rule ID 13470 //
     /*  33616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33641 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33648 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33660 */     GIR_RootConstrainSelectedInstOperands,
     /*  33661 */     // GIR_Coverage, 13470,
     /*  33661 */     GIR_EraseRootFromParent_Done,
     /*  33662 */   // Label 528: @33662
     /*  33662 */   GIM_Try, /*On fail goto*//*Label 529*/ GIMT_Encode4(33713), // Rule ID 13499 //
     /*  33667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33692 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33699 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  33706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33711 */     GIR_RootConstrainSelectedInstOperands,
     /*  33712 */     // GIR_Coverage, 13499,
     /*  33712 */     GIR_EraseRootFromParent_Done,
     /*  33713 */   // Label 529: @33713
     /*  33713 */   GIM_Try, /*On fail goto*//*Label 530*/ GIMT_Encode4(33764), // Rule ID 1805 //
     /*  33718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  33737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33743 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33750 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33755 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33762 */     GIR_RootConstrainSelectedInstOperands,
     /*  33763 */     // GIR_Coverage, 1805,
     /*  33763 */     GIR_EraseRootFromParent_Done,
     /*  33764 */   // Label 530: @33764
     /*  33764 */   GIM_Try, /*On fail goto*//*Label 531*/ GIMT_Encode4(33815), // Rule ID 1719 //
     /*  33769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33784 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  33788 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33792 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33794 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33801 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv16i8_v8i16),
     /*  33804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33806 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33813 */     GIR_RootConstrainSelectedInstOperands,
     /*  33814 */     // GIR_Coverage, 1719,
     /*  33814 */     GIR_EraseRootFromParent_Done,
     /*  33815 */   // Label 531: @33815
     /*  33815 */   GIM_Try, /*On fail goto*//*Label 532*/ GIMT_Encode4(33866), // Rule ID 1804 //
     /*  33820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33827 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  33835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  33839 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  33843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33845 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  33852 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UADDWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  33852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv16i8_v8i16),
     /*  33855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  33857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  33859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  33864 */     GIR_RootConstrainSelectedInstOperands,
     /*  33865 */     // GIR_Coverage, 1804,
     /*  33865 */     GIR_EraseRootFromParent_Done,
     /*  33866 */   // Label 532: @33866
     /*  33866 */   GIM_Try, /*On fail goto*//*Label 533*/ GIMT_Encode4(33935), // Rule ID 13422 //
     /*  33871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33886 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33889 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  33894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33898 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33918 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  33921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  33933 */     GIR_RootConstrainSelectedInstOperands,
     /*  33934 */     // GIR_Coverage, 13422,
     /*  33934 */     GIR_EraseRootFromParent_Done,
     /*  33935 */   // Label 533: @33935
     /*  33935 */   GIM_Try, /*On fail goto*//*Label 534*/ GIMT_Encode4(34004), // Rule ID 13434 //
     /*  33940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  33943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  33951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  33955 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  33958 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  33963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  33967 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  33971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33981 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  33985 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  33987 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  33987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  33990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  33992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  33994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  33998 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34002 */     GIR_RootConstrainSelectedInstOperands,
     /*  34003 */     // GIR_Coverage, 13434,
     /*  34003 */     GIR_EraseRootFromParent_Done,
     /*  34004 */   // Label 534: @34004
     /*  34004 */   GIM_Try, /*On fail goto*//*Label 535*/ GIMT_Encode4(34060), // Rule ID 13384 //
     /*  34009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34016 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34020 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34024 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34027 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34045 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34047 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34058 */     GIR_RootConstrainSelectedInstOperands,
     /*  34059 */     // GIR_Coverage, 13384,
     /*  34059 */     GIR_EraseRootFromParent_Done,
     /*  34060 */   // Label 535: @34060
     /*  34060 */   GIM_Try, /*On fail goto*//*Label 536*/ GIMT_Encode4(34116), // Rule ID 13396 //
     /*  34065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34080 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34083 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34088 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34092 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34097 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34103 */     // (add:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34114 */     GIR_RootConstrainSelectedInstOperands,
     /*  34115 */     // GIR_Coverage, 13396,
     /*  34115 */     GIR_EraseRootFromParent_Done,
     /*  34116 */   // Label 536: @34116
     /*  34116 */   GIM_Try, /*On fail goto*//*Label 537*/ GIMT_Encode4(34183), // Rule ID 13636 //
     /*  34121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34145 */     // MIs[1] imm
     /*  34145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34157 */     // MIs[2] Operand 1
     /*  34157 */     // No operand predicates
     /*  34157 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34161 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34167 */     // (add:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34181 */     GIR_RootConstrainSelectedInstOperands,
     /*  34182 */     // GIR_Coverage, 13636,
     /*  34182 */     GIR_EraseRootFromParent_Done,
     /*  34183 */   // Label 537: @34183
     /*  34183 */   GIM_Try, /*On fail goto*//*Label 538*/ GIMT_Encode4(34250), // Rule ID 13657 //
     /*  34188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34212 */     // MIs[1] imm
     /*  34212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34224 */     // MIs[2] Operand 1
     /*  34224 */     // No operand predicates
     /*  34224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34228 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34234 */     // (add:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  34241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34245 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34248 */     GIR_RootConstrainSelectedInstOperands,
     /*  34249 */     // GIR_Coverage, 13657,
     /*  34249 */     GIR_EraseRootFromParent_Done,
     /*  34250 */   // Label 538: @34250
     /*  34250 */   GIM_Try, /*On fail goto*//*Label 539*/ GIMT_Encode4(34319), // Rule ID 1363 //
     /*  34255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34262 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34274 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34277 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  34282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34286 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34290 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34295 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34302 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv8i16),
     /*  34305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34317 */     GIR_RootConstrainSelectedInstOperands,
     /*  34318 */     // GIR_Coverage, 1363,
     /*  34318 */     GIR_EraseRootFromParent_Done,
     /*  34319 */   // Label 539: @34319
     /*  34319 */   GIM_Try, /*On fail goto*//*Label 540*/ GIMT_Encode4(34388), // Rule ID 1486 //
     /*  34324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34335 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34339 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34343 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  34346 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  34351 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34355 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  34359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34364 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34371 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (UABAv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  34371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv8i16),
     /*  34374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34378 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  34386 */     GIR_RootConstrainSelectedInstOperands,
     /*  34387 */     // GIR_Coverage, 1486,
     /*  34387 */     GIR_EraseRootFromParent_Done,
     /*  34388 */   // Label 540: @34388
     /*  34388 */   GIM_Try, /*On fail goto*//*Label 541*/ GIMT_Encode4(34444), // Rule ID 991 //
     /*  34393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34400 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34412 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34415 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /*  34420 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34424 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34429 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34431 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  34434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34436 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34438 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34442 */     GIR_RootConstrainSelectedInstOperands,
     /*  34443 */     // GIR_Coverage, 991,
     /*  34443 */     GIR_EraseRootFromParent_Done,
     /*  34444 */   // Label 541: @34444
     /*  34444 */   GIM_Try, /*On fail goto*//*Label 542*/ GIMT_Encode4(34500), // Rule ID 1052 //
     /*  34449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  34468 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  34471 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /*  34476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  34480 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34485 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  34487 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  34487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  34490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  34498 */     GIR_RootConstrainSelectedInstOperands,
     /*  34499 */     // GIR_Coverage, 1052,
     /*  34499 */     GIR_EraseRootFromParent_Done,
     /*  34500 */   // Label 542: @34500
     /*  34500 */   GIM_Try, /*On fail goto*//*Label 543*/ GIMT_Encode4(34567), // Rule ID 2236 //
     /*  34505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  34524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34533 */     // MIs[1] imm
     /*  34533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34545 */     // MIs[2] Operand 1
     /*  34545 */     // No operand predicates
     /*  34545 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34551 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  34554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34562 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34565 */     GIR_RootConstrainSelectedInstOperands,
     /*  34566 */     // GIR_Coverage, 2236,
     /*  34566 */     GIR_EraseRootFromParent_Done,
     /*  34567 */   // Label 543: @34567
     /*  34567 */   GIM_Try, /*On fail goto*//*Label 544*/ GIMT_Encode4(34634), // Rule ID 2295 //
     /*  34572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  34587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  34591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34600 */     // MIs[1] imm
     /*  34600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  34604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  34608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  34612 */     // MIs[2] Operand 1
     /*  34612 */     // No operand predicates
     /*  34612 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  34616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34618 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  34618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  34621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  34623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  34625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  34632 */     GIR_RootConstrainSelectedInstOperands,
     /*  34633 */     // GIR_Coverage, 2295,
     /*  34633 */     GIR_EraseRootFromParent_Done,
     /*  34634 */   // Label 544: @34634
     /*  34634 */   GIM_Try, /*On fail goto*//*Label 545*/ GIMT_Encode4(34704), // Rule ID 6966 //
     /*  34639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  34651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34669 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34673 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  34677 */     // MIs[2] Rn
     /*  34677 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34682 */     // MIs[2] Rm
     /*  34682 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34689 */     // (add:{ *:[v8i16] } (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34702 */     GIR_RootConstrainSelectedInstOperands,
     /*  34703 */     // GIR_Coverage, 6966,
     /*  34703 */     GIR_EraseRootFromParent_Done,
     /*  34704 */   // Label 545: @34704
     /*  34704 */   GIM_Try, /*On fail goto*//*Label 546*/ GIMT_Encode4(34774), // Rule ID 14023 //
     /*  34709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  34721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  34725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  34729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34734 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  34747 */     // MIs[2] Rn
     /*  34747 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  34752 */     // MIs[2] Rm
     /*  34752 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  34757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34759 */     // (add:{ *:[v8i16] } (AArch64uzp2:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm), (AArch64uzp1:{ *:[v8i16] } FPR128:{ *:[v8i16] }:$Rn, FPR128:{ *:[v8i16] }:$Rm))  =>  (ADDPv8i16:{ *:[v8i16] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rm)
     /*  34759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /*  34762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34764 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34768 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  34772 */     GIR_RootConstrainSelectedInstOperands,
     /*  34773 */     // GIR_Coverage, 14023,
     /*  34773 */     GIR_EraseRootFromParent_Done,
     /*  34774 */   // Label 546: @34774
     /*  34774 */   GIM_Try, /*On fail goto*//*Label 547*/ GIMT_Encode4(34837), // Rule ID 1781 //
     /*  34779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34803 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34807 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34811 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34815 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34820 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34822 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34827 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34835 */     GIR_RootConstrainSelectedInstOperands,
     /*  34836 */     // GIR_Coverage, 1781,
     /*  34836 */     GIR_EraseRootFromParent_Done,
     /*  34837 */   // Label 547: @34837
     /*  34837 */   GIM_Try, /*On fail goto*//*Label 548*/ GIMT_Encode4(34900), // Rule ID 1780 //
     /*  34842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  34857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34878 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34885 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  34888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34890 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34898 */     GIR_RootConstrainSelectedInstOperands,
     /*  34899 */     // GIR_Coverage, 1780,
     /*  34899 */     GIR_EraseRootFromParent_Done,
     /*  34900 */   // Label 548: @34900
     /*  34900 */   GIM_Try, /*On fail goto*//*Label 549*/ GIMT_Encode4(34963), // Rule ID 1712 //
     /*  34905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34920 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  34937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  34948 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  34948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLv8i8_v8i16),
     /*  34951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  34953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  34957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  34961 */     GIR_RootConstrainSelectedInstOperands,
     /*  34962 */     // GIR_Coverage, 1712,
     /*  34962 */     GIR_EraseRootFromParent_Done,
     /*  34963 */   // Label 549: @34963
     /*  34963 */   GIM_Try, /*On fail goto*//*Label 550*/ GIMT_Encode4(35026), // Rule ID 1779 //
     /*  34968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  34971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  34975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  34979 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  34983 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  34987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  34992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  34996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35009 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35011 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35011 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35014 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35020 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35024 */     GIR_RootConstrainSelectedInstOperands,
     /*  35025 */     // GIR_Coverage, 1779,
     /*  35025 */     GIR_EraseRootFromParent_Done,
     /*  35026 */   // Label 550: @35026
     /*  35026 */   GIM_Try, /*On fail goto*//*Label 551*/ GIMT_Encode4(35089), // Rule ID 1778 //
     /*  35031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35046 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  35059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35067 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  35074 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLv8i8_v8i16),
     /*  35077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  35087 */     GIR_RootConstrainSelectedInstOperands,
     /*  35088 */     // GIR_Coverage, 1778,
     /*  35088 */     GIR_EraseRootFromParent_Done,
     /*  35089 */   // Label 551: @35089
     /*  35089 */   GIM_Try, /*On fail goto*//*Label 552*/ GIMT_Encode4(35150), // Rule ID 13475 //
     /*  35094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35122 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35133 */     // (add:{ *:[v8i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35144 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35148 */     GIR_RootConstrainSelectedInstOperands,
     /*  35149 */     // GIR_Coverage, 13475,
     /*  35149 */     GIR_EraseRootFromParent_Done,
     /*  35150 */   // Label 552: @35150
     /*  35150 */   GIM_Try, /*On fail goto*//*Label 553*/ GIMT_Encode4(35211), // Rule ID 13509 //
     /*  35155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35192 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35194 */     // (add:{ *:[v8i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rd)  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35209 */     GIR_RootConstrainSelectedInstOperands,
     /*  35210 */     // GIR_Coverage, 13509,
     /*  35210 */     GIR_EraseRootFromParent_Done,
     /*  35211 */   // Label 553: @35211
     /*  35211 */   GIM_Try, /*On fail goto*//*Label 554*/ GIMT_Encode4(35259), // Rule ID 13498 //
     /*  35216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35223 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35227 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35231 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35240 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35246 */     // (add:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35251 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35257 */     GIR_RootConstrainSelectedInstOperands,
     /*  35258 */     // GIR_Coverage, 13498,
     /*  35258 */     GIR_EraseRootFromParent_Done,
     /*  35259 */   // Label 554: @35259
     /*  35259 */   GIM_Try, /*On fail goto*//*Label 555*/ GIMT_Encode4(35307), // Rule ID 13383 //
     /*  35264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35279 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35294 */     // (add:{ *:[v8i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35305 */     GIR_RootConstrainSelectedInstOperands,
     /*  35306 */     // GIR_Coverage, 13383,
     /*  35306 */     GIR_EraseRootFromParent_Done,
     /*  35307 */   // Label 555: @35307
     /*  35307 */   GIM_Try, /*On fail goto*//*Label 556*/ GIMT_Encode4(35355), // Rule ID 13469 //
     /*  35312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35327 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35340 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35342 */     // (add:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35353 */     GIR_RootConstrainSelectedInstOperands,
     /*  35354 */     // GIR_Coverage, 13469,
     /*  35354 */     GIR_EraseRootFromParent_Done,
     /*  35355 */   // Label 556: @35355
     /*  35355 */   GIM_Try, /*On fail goto*//*Label 557*/ GIMT_Encode4(35403), // Rule ID 13395 //
     /*  35360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35388 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35390 */     // (add:{ *:[v8i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn), V128:{ *:[v8i16] }:$Rd)  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35401 */     GIR_RootConstrainSelectedInstOperands,
     /*  35402 */     // GIR_Coverage, 13395,
     /*  35402 */     GIR_EraseRootFromParent_Done,
     /*  35403 */   // Label 557: @35403
     /*  35403 */   GIM_Try, /*On fail goto*//*Label 558*/ GIMT_Encode4(35451), // Rule ID 13497 //
     /*  35408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35436 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35438 */     // (add:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), V128:{ *:[v8i16] }:$Rn)  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  35445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35449 */     GIR_RootConstrainSelectedInstOperands,
     /*  35450 */     // GIR_Coverage, 13497,
     /*  35450 */     GIR_EraseRootFromParent_Done,
     /*  35451 */   // Label 558: @35451
     /*  35451 */   GIM_Try, /*On fail goto*//*Label 559*/ GIMT_Encode4(35512), // Rule ID 1724 //
     /*  35456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35463 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35467 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35471 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  35475 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35479 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35483 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35495 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALv8i8_v8i16),
     /*  35498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35500 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35510 */     GIR_RootConstrainSelectedInstOperands,
     /*  35511 */     // GIR_Coverage, 1724,
     /*  35511 */     GIR_EraseRootFromParent_Done,
     /*  35512 */   // Label 559: @35512
     /*  35512 */   GIM_Try, /*On fail goto*//*Label 560*/ GIMT_Encode4(35573), // Rule ID 1814 //
     /*  35517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35524 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  35536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  35544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35554 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35556 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLALv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALv8i8_v8i16),
     /*  35559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  35571 */     GIR_RootConstrainSelectedInstOperands,
     /*  35572 */     // GIR_Coverage, 1814,
     /*  35572 */     GIR_EraseRootFromParent_Done,
     /*  35573 */   // Label 560: @35573
     /*  35573 */   GIM_Try, /*On fail goto*//*Label 561*/ GIMT_Encode4(35621), // Rule ID 1803 //
     /*  35578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  35597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35601 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35606 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35608 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35613 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35619 */     GIR_RootConstrainSelectedInstOperands,
     /*  35620 */     // GIR_Coverage, 1803,
     /*  35620 */     GIR_EraseRootFromParent_Done,
     /*  35621 */   // Label 561: @35621
     /*  35621 */   GIM_Try, /*On fail goto*//*Label 562*/ GIMT_Encode4(35669), // Rule ID 990 //
     /*  35626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /*  35645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35656 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALPv16i8_v8i16),
     /*  35659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35661 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35667 */     GIR_RootConstrainSelectedInstOperands,
     /*  35668 */     // GIR_Coverage, 990,
     /*  35668 */     GIR_EraseRootFromParent_Done,
     /*  35669 */   // Label 562: @35669
     /*  35669 */   GIM_Try, /*On fail goto*//*Label 563*/ GIMT_Encode4(35717), // Rule ID 1718 //
     /*  35674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  35693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35704 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDWv8i8_v8i16),
     /*  35707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35709 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35715 */     GIR_RootConstrainSelectedInstOperands,
     /*  35716 */     // GIR_Coverage, 1718,
     /*  35716 */     GIR_EraseRootFromParent_Done,
     /*  35717 */   // Label 563: @35717
     /*  35717 */   GIM_Try, /*On fail goto*//*Label 564*/ GIMT_Encode4(35765), // Rule ID 1051 //
     /*  35722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /*  35741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35750 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35752 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADALPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /*  35752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALPv16i8_v8i16),
     /*  35755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35757 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  35759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  35763 */     GIR_RootConstrainSelectedInstOperands,
     /*  35764 */     // GIR_Coverage, 1051,
     /*  35764 */     GIR_EraseRootFromParent_Done,
     /*  35765 */   // Label 564: @35765
     /*  35765 */   GIM_Try, /*On fail goto*//*Label 565*/ GIMT_Encode4(35813), // Rule ID 1802 //
     /*  35770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35777 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  35785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  35789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  35793 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  35798 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35800 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (UADDWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  35800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDWv8i8_v8i16),
     /*  35803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  35805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  35807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  35811 */     GIR_RootConstrainSelectedInstOperands,
     /*  35812 */     // GIR_Coverage, 1802,
     /*  35812 */     GIR_EraseRootFromParent_Done,
     /*  35813 */   // Label 565: @35813
     /*  35813 */   GIM_Try, /*On fail goto*//*Label 566*/ GIMT_Encode4(35840), // Rule ID 1103 //
     /*  35818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35833 */     // (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  35833 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv8i16),
     /*  35838 */     GIR_RootConstrainSelectedInstOperands,
     /*  35839 */     // GIR_Coverage, 1103,
     /*  35839 */     GIR_Done,
     /*  35840 */   // Label 566: @35840
     /*  35840 */   GIM_Reject,
     /*  35841 */ // Label 509: @35841
     /*  35841 */ GIM_Reject,
     /*  35842 */ // Label 163: @35842
     /*  35842 */ GIM_Try, /*On fail goto*//*Label 567*/ GIMT_Encode4(36565),
     /*  35847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  35850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35853 */   GIM_Try, /*On fail goto*//*Label 568*/ GIMT_Encode4(35922), // Rule ID 13418 //
     /*  35858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35873 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35876 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  35881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35885 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35894 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35903 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35905 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  35908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35916 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35920 */     GIR_RootConstrainSelectedInstOperands,
     /*  35921 */     // GIR_Coverage, 13418,
     /*  35921 */     GIR_EraseRootFromParent_Done,
     /*  35922 */   // Label 568: @35922
     /*  35922 */   GIM_Try, /*On fail goto*//*Label 569*/ GIMT_Encode4(35991), // Rule ID 13430 //
     /*  35927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  35938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  35942 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  35945 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  35950 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  35954 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  35958 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  35972 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  35974 */     // (add:{ *:[v16i8] } (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), V128:{ *:[v16i8] }:$Rd)  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  35974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  35977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  35979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  35981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  35985 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  35989 */     GIR_RootConstrainSelectedInstOperands,
     /*  35990 */     // GIR_Coverage, 13430,
     /*  35990 */     GIR_EraseRootFromParent_Done,
     /*  35991 */   // Label 569: @35991
     /*  35991 */   GIM_Try, /*On fail goto*//*Label 570*/ GIMT_Encode4(36058), // Rule ID 13632 //
     /*  35996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  35999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36015 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36020 */     // MIs[1] imm
     /*  36020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36028 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36032 */     // MIs[2] Operand 1
     /*  36032 */     // No operand predicates
     /*  36032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36036 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36042 */     // (add:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36056 */     GIR_RootConstrainSelectedInstOperands,
     /*  36057 */     // GIR_Coverage, 13632,
     /*  36057 */     GIR_EraseRootFromParent_Done,
     /*  36058 */   // Label 570: @36058
     /*  36058 */   GIM_Try, /*On fail goto*//*Label 571*/ GIMT_Encode4(36125), // Rule ID 13653 //
     /*  36063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36074 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36078 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36082 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36087 */     // MIs[1] imm
     /*  36087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36095 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36099 */     // MIs[2] Operand 1
     /*  36099 */     // No operand predicates
     /*  36099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36103 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36109 */     // (add:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  36116 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36120 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36123 */     GIR_RootConstrainSelectedInstOperands,
     /*  36124 */     // GIR_Coverage, 13653,
     /*  36124 */     GIR_EraseRootFromParent_Done,
     /*  36125 */   // Label 571: @36125
     /*  36125 */   GIM_Try, /*On fail goto*//*Label 572*/ GIMT_Encode4(36194), // Rule ID 1359 //
     /*  36130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36141 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36145 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36149 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36152 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /*  36157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36161 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36177 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (SABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABAv16i8),
     /*  36180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36192 */     GIR_RootConstrainSelectedInstOperands,
     /*  36193 */     // GIR_Coverage, 1359,
     /*  36193 */     GIR_EraseRootFromParent_Done,
     /*  36194 */   // Label 572: @36194
     /*  36194 */   GIM_Try, /*On fail goto*//*Label 573*/ GIMT_Encode4(36263), // Rule ID 1482 //
     /*  36199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  36218 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  36221 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /*  36226 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36230 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  36234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36239 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36244 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36246 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))  =>  (UABAv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABAv16i8),
     /*  36249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36251 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  36257 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /*  36261 */     GIR_RootConstrainSelectedInstOperands,
     /*  36262 */     // GIR_Coverage, 1482,
     /*  36262 */     GIR_EraseRootFromParent_Done,
     /*  36263 */   // Label 573: @36263
     /*  36263 */   GIM_Try, /*On fail goto*//*Label 574*/ GIMT_Encode4(36330), // Rule ID 2232 //
     /*  36268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  36287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36296 */     // MIs[1] imm
     /*  36296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36304 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36308 */     // MIs[2] Operand 1
     /*  36308 */     // No operand predicates
     /*  36308 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36312 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36314 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  36317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36319 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36328 */     GIR_RootConstrainSelectedInstOperands,
     /*  36329 */     // GIR_Coverage, 2232,
     /*  36329 */     GIR_EraseRootFromParent_Done,
     /*  36330 */   // Label 574: @36330
     /*  36330 */   GIM_Try, /*On fail goto*//*Label 575*/ GIMT_Encode4(36397), // Rule ID 2291 //
     /*  36335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36342 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  36354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36358 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36363 */     // MIs[1] imm
     /*  36363 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36367 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  36371 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  36375 */     // MIs[2] Operand 1
     /*  36375 */     // No operand predicates
     /*  36375 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  36379 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36381 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  36381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  36384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  36386 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  36388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  36395 */     GIR_RootConstrainSelectedInstOperands,
     /*  36396 */     // GIR_Coverage, 2291,
     /*  36396 */     GIR_EraseRootFromParent_Done,
     /*  36397 */   // Label 575: @36397
     /*  36397 */   GIM_Try, /*On fail goto*//*Label 576*/ GIMT_Encode4(36467), // Rule ID 6967 //
     /*  36402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /*  36414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36418 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /*  36440 */     // MIs[2] Rn
     /*  36440 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36445 */     // MIs[2] Rm
     /*  36445 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36452 */     // (add:{ *:[v16i8] } (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36465 */     GIR_RootConstrainSelectedInstOperands,
     /*  36466 */     // GIR_Coverage, 6967,
     /*  36466 */     GIR_EraseRootFromParent_Done,
     /*  36467 */   // Label 576: @36467
     /*  36467 */   GIM_Try, /*On fail goto*//*Label 577*/ GIMT_Encode4(36537), // Rule ID 14024 //
     /*  36472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /*  36484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  36488 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  36492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36497 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  36506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /*  36510 */     // MIs[2] Rn
     /*  36510 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  36515 */     // MIs[2] Rm
     /*  36515 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  36520 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36522 */     // (add:{ *:[v16i8] } (AArch64uzp2:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm), (AArch64uzp1:{ *:[v16i8] } FPR128:{ *:[v16i8] }:$Rn, FPR128:{ *:[v16i8] }:$Rm))  =>  (ADDPv16i8:{ *:[v16i8] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm)
     /*  36522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /*  36525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  36527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  36531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  36535 */     GIR_RootConstrainSelectedInstOperands,
     /*  36536 */     // GIR_Coverage, 14024,
     /*  36536 */     GIR_EraseRootFromParent_Done,
     /*  36537 */   // Label 577: @36537
     /*  36537 */   GIM_Try, /*On fail goto*//*Label 578*/ GIMT_Encode4(36564), // Rule ID 1101 //
     /*  36542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  36545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36549 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36553 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  36557 */     // (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  36557 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDv16i8),
     /*  36562 */     GIR_RootConstrainSelectedInstOperands,
     /*  36563 */     // GIR_Coverage, 1101,
     /*  36563 */     GIR_Done,
     /*  36564 */   // Label 578: @36564
     /*  36564 */   GIM_Reject,
     /*  36565 */ // Label 567: @36565
     /*  36565 */ GIM_Reject,
     /*  36566 */ // Label 164: @36566
     /*  36566 */ GIM_Try, /*On fail goto*//*Label 579*/ GIMT_Encode4(36937),
     /*  36571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36581 */   GIM_Try, /*On fail goto*//*Label 580*/ GIMT_Encode4(36643), // Rule ID 15208 //
     /*  36586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36617 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36630 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36641 */     GIR_RootConstrainSelectedInstOperands,
     /*  36642 */     // GIR_Coverage, 15208,
     /*  36642 */     GIR_EraseRootFromParent_Done,
     /*  36643 */   // Label 580: @36643
     /*  36643 */   GIM_Try, /*On fail goto*//*Label 581*/ GIMT_Encode4(36705), // Rule ID 15207 //
     /*  36648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36651 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36655 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36659 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36663 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36667 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36671 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36675 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36679 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36692 */     // (add:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36703 */     GIR_RootConstrainSelectedInstOperands,
     /*  36704 */     // GIR_Coverage, 15207,
     /*  36704 */     GIR_EraseRootFromParent_Done,
     /*  36705 */   // Label 581: @36705
     /*  36705 */   GIM_Try, /*On fail goto*//*Label 582*/ GIMT_Encode4(36767), // Rule ID 15206 //
     /*  36710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36713 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36717 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36721 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36725 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  36733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36737 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36741 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36754 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  36765 */     GIR_RootConstrainSelectedInstOperands,
     /*  36766 */     // GIR_Coverage, 15206,
     /*  36766 */     GIR_EraseRootFromParent_Done,
     /*  36767 */   // Label 582: @36767
     /*  36767 */   GIM_Try, /*On fail goto*//*Label 583*/ GIMT_Encode4(36829), // Rule ID 8942 //
     /*  36772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  36783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  36791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  36795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  36799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  36803 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/1, GIMT_Encode8(4294967295),
     /*  36814 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  36816 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } 4294967295:{ *:[i64] })))  =>  (ADR_UXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_UXTW_ZZZ_D_0),
     /*  36819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36821 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36823 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36827 */     GIR_RootConstrainSelectedInstOperands,
     /*  36828 */     // GIR_Coverage, 8942,
     /*  36828 */     GIR_EraseRootFromParent_Done,
     /*  36829 */   // Label 583: @36829
     /*  36829 */   GIM_Try, /*On fail goto*//*Label 584*/ GIMT_Encode4(36875), // Rule ID 15209 //
     /*  36834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36837 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  36841 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36845 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36849 */     // MIs[1] Operand 2
     /*  36849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36862 */     // (add:{ *:[nxv2i64] } (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  36869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36873 */     GIR_RootConstrainSelectedInstOperands,
     /*  36874 */     // GIR_Coverage, 15209,
     /*  36874 */     GIR_EraseRootFromParent_Done,
     /*  36875 */   // Label 584: @36875
     /*  36875 */   GIM_Try, /*On fail goto*//*Label 585*/ GIMT_Encode4(36921), // Rule ID 8943 //
     /*  36880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /*  36883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  36887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  36891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  36895 */     // MIs[1] Operand 2
     /*  36895 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  36906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  36908 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i32:{ *:[Other] }))  =>  (ADR_SXTW_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_SXTW_ZZZ_D_0),
     /*  36911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  36913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  36915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  36919 */     GIR_RootConstrainSelectedInstOperands,
     /*  36920 */     // GIR_Coverage, 8943,
     /*  36920 */     GIR_EraseRootFromParent_Done,
     /*  36921 */   // Label 585: @36921
     /*  36921 */   GIM_Try, /*On fail goto*//*Label 586*/ GIMT_Encode4(36936), // Rule ID 2776 //
     /*  36926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36929 */     // (add:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  36929 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_D),
     /*  36934 */     GIR_RootConstrainSelectedInstOperands,
     /*  36935 */     // GIR_Coverage, 2776,
     /*  36935 */     GIR_Done,
     /*  36936 */   // Label 586: @36936
     /*  36936 */   GIM_Reject,
     /*  36937 */ // Label 579: @36937
     /*  36937 */ GIM_Reject,
     /*  36938 */ // Label 165: @36938
     /*  36938 */ GIM_Try, /*On fail goto*//*Label 587*/ GIMT_Encode4(36963), // Rule ID 2775 //
     /*  36943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  36949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  36952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36956 */   // (add:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  36956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_S),
     /*  36961 */   GIR_RootConstrainSelectedInstOperands,
     /*  36962 */   // GIR_Coverage, 2775,
     /*  36962 */   GIR_Done,
     /*  36963 */ // Label 587: @36963
     /*  36963 */ GIM_Reject,
     /*  36964 */ // Label 166: @36964
     /*  36964 */ GIM_Try, /*On fail goto*//*Label 588*/ GIMT_Encode4(36989), // Rule ID 2774 //
     /*  36969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  36975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  36978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  36982 */   // (add:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  36982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_H),
     /*  36987 */   GIR_RootConstrainSelectedInstOperands,
     /*  36988 */   // GIR_Coverage, 2774,
     /*  36988 */   GIR_Done,
     /*  36989 */ // Label 588: @36989
     /*  36989 */ GIM_Reject,
     /*  36990 */ // Label 167: @36990
     /*  36990 */ GIM_Try, /*On fail goto*//*Label 589*/ GIMT_Encode4(37015), // Rule ID 2773 //
     /*  36995 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  36998 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  37001 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  37004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  37008 */   // (add:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  37008 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADD_ZZZ_B),
     /*  37013 */   GIR_RootConstrainSelectedInstOperands,
     /*  37014 */   // GIR_Coverage, 2773,
     /*  37014 */   GIR_Done,
     /*  37015 */ // Label 589: @37015
     /*  37015 */ GIM_Reject,
     /*  37016 */ // Label 168: @37016
     /*  37016 */ GIM_Reject,
     /*  37017 */ // Label 1: @37017
     /*  37017 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 603*/ GIMT_Encode4(51868),
     /*  37028 */ /*GILLT_s32*//*Label 590*/ GIMT_Encode4(37116),
     /*  37032 */ /*GILLT_s64*//*Label 591*/ GIMT_Encode4(38598), GIMT_Encode4(0),
     /*  37040 */ /*GILLT_v2s32*//*Label 592*/ GIMT_Encode4(42504),
     /*  37044 */ /*GILLT_v2s64*//*Label 593*/ GIMT_Encode4(43995),
     /*  37048 */ /*GILLT_v4s16*//*Label 594*/ GIMT_Encode4(46455),
     /*  37052 */ /*GILLT_v4s32*//*Label 595*/ GIMT_Encode4(47946),
     /*  37056 */ /*GILLT_v8s8*//*Label 596*/ GIMT_Encode4(50406),
     /*  37060 */ /*GILLT_v8s16*//*Label 597*/ GIMT_Encode4(50481),
     /*  37064 */ /*GILLT_v16s8*//*Label 598*/ GIMT_Encode4(51689), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37084 */ /*GILLT_nxv2s64*//*Label 599*/ GIMT_Encode4(51764), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  37096 */ /*GILLT_nxv4s32*//*Label 600*/ GIMT_Encode4(51790), GIMT_Encode4(0),
     /*  37104 */ /*GILLT_nxv8s16*//*Label 601*/ GIMT_Encode4(51816), GIMT_Encode4(0),
     /*  37112 */ /*GILLT_nxv16s8*//*Label 602*/ GIMT_Encode4(51842),
     /*  37116 */ // Label 590: @37116
     /*  37116 */ GIM_Try, /*On fail goto*//*Label 604*/ GIMT_Encode4(38597),
     /*  37121 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  37124 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  37127 */   GIM_Try, /*On fail goto*//*Label 605*/ GIMT_Encode4(37279), // Rule ID 9989 //
     /*  37132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37139 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37163 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37166 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  37171 */     // MIs[2] pattern
     /*  37171 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37174 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37181 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECB_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37181 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37184 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37188 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37207 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37210 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37214 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37217 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37222 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37227 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37232 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37235 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  37239 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37244 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37247 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37251 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37254 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37261 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37268 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37273 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37278 */     // GIR_Coverage, 9989,
     /*  37278 */     GIR_EraseRootFromParent_Done,
     /*  37279 */   // Label 605: @37279
     /*  37279 */   GIM_Try, /*On fail goto*//*Label 606*/ GIMT_Encode4(37431), // Rule ID 10001 //
     /*  37284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37315 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37318 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  37323 */     // MIs[2] pattern
     /*  37323 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37326 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37333 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECH_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37333 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37336 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37340 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37347 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37350 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37354 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37359 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37362 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37366 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37369 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  37391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37399 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37403 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37413 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37420 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37425 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37430 */     // GIR_Coverage, 10001,
     /*  37430 */     GIR_EraseRootFromParent_Done,
     /*  37431 */   // Label 606: @37431
     /*  37431 */   GIM_Try, /*On fail goto*//*Label 607*/ GIMT_Encode4(37583), // Rule ID 10013 //
     /*  37436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37467 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37470 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  37475 */     // MIs[2] pattern
     /*  37475 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37478 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37485 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECW_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37485 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37488 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37492 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37499 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37502 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37506 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37511 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37514 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37518 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37521 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  37543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37551 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37555 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37565 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37572 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37582 */     // GIR_Coverage, 10013,
     /*  37582 */     GIR_EraseRootFromParent_Done,
     /*  37583 */   // Label 607: @37583
     /*  37583 */   GIM_Try, /*On fail goto*//*Label 608*/ GIMT_Encode4(37735), // Rule ID 10025 //
     /*  37588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  37591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37595 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37619 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/3,
     /*  37622 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  37627 */     // MIs[2] pattern
     /*  37627 */     GIM_CheckIsImm, /*MI*/2, /*Op*/2,
     /*  37630 */     GIM_CheckImmOperandPredicate, /*MI*/2, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  37635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37637 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rdn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECD_XPiI:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rdn, sub_32:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] }), sub_32:{ *:[i32] })
     /*  37637 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37640 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37644 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37651 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37654 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37658 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37663 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37666 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rdn
     /*  37670 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37673 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37678 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37683 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37688 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37691 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  37695 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37700 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37703 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pattern
     /*  37707 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /*  37710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37717 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37724 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37734 */     // GIR_Coverage, 10025,
     /*  37734 */     GIR_EraseRootFromParent_Done,
     /*  37735 */   // Label 608: @37735
     /*  37735 */   GIM_Try, /*On fail goto*//*Label 609*/ GIMT_Encode4(37797), // Rule ID 3952 //
     /*  37740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  37748 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37752 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  37756 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  37760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  37764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37774 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  37776 */     // (sub:{ *:[i32] } 0:{ *:[i32] }, (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  37776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  37779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  37781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  37785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  37789 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  37795 */     GIR_RootConstrainSelectedInstOperands,
     /*  37796 */     // GIR_Coverage, 3952,
     /*  37796 */     GIR_EraseRootFromParent_Done,
     /*  37797 */   // Label 609: @37797
     /*  37797 */   GIM_Try, /*On fail goto*//*Label 610*/ GIMT_Encode4(37954), // Rule ID 10127 //
     /*  37802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37833 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37836 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37841 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  37845 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  37847 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  37852 */     // MIs[2] pred
     /*  37852 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  37857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  37859 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  37859 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  37862 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  37866 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37871 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  37873 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  37876 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  37880 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37885 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  37888 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  37892 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  37895 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  37905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  37913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  37917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  37922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  37926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  37929 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  37931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  37934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  37936 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  37943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  37953 */     // GIR_Coverage, 10127,
     /*  37953 */     GIR_EraseRootFromParent_Done,
     /*  37954 */   // Label 610: @37954
     /*  37954 */   GIM_Try, /*On fail goto*//*Label 611*/ GIMT_Encode4(38111), // Rule ID 10128 //
     /*  37959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  37962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  37970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  37974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  37978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  37982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  37986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  37990 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  37993 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  37998 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  38002 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38009 */     // MIs[2] pred
     /*  38009 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38016 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38016 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38019 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38023 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38028 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38030 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38033 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38037 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38042 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38045 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38049 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38052 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  38074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38079 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38083 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38086 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38093 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38110 */     // GIR_Coverage, 10128,
     /*  38110 */     GIR_EraseRootFromParent_Done,
     /*  38111 */   // Label 611: @38111
     /*  38111 */   GIM_Try, /*On fail goto*//*Label 612*/ GIMT_Encode4(38268), // Rule ID 10129 //
     /*  38116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38147 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38150 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  38159 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38166 */     // MIs[2] pred
     /*  38166 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38171 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38173 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38173 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38176 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38180 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38185 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38187 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38190 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38194 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38199 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38202 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38206 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38209 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38214 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38219 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38224 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38227 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  38231 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38240 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38250 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38257 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38262 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38267 */     // GIR_Coverage, 10129,
     /*  38267 */     GIR_EraseRootFromParent_Done,
     /*  38268 */   // Label 612: @38268
     /*  38268 */   GIM_Try, /*On fail goto*//*Label 613*/ GIMT_Encode4(38425), // Rule ID 10130 //
     /*  38273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  38276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  38288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  38292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  38296 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38300 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  38304 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /*  38307 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  38312 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  38316 */     GIM_CheckHasOneUse, /*MI*/2,
     /*  38318 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  38323 */     // MIs[2] pred
     /*  38323 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/3, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  38328 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  38330 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (trunc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>))  =>  (EXTRACT_SUBREG:{ *:[i32] } (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  38330 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /*  38333 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  38337 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38342 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  38344 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /*  38347 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  38351 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38356 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  38359 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  38363 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/20,
     /*  38366 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38371 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  38376 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38381 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  38384 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  38388 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38393 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // pred
     /*  38397 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  38400 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38407 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /*  38414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38419 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  38424 */     // GIR_Coverage, 10130,
     /*  38424 */     GIR_EraseRootFromParent_Done,
     /*  38425 */   // Label 613: @38425
     /*  38425 */   GIM_Try, /*On fail goto*//*Label 614*/ GIMT_Encode4(38461), // Rule ID 3917 //
     /*  38430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38434 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38438 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32_i32),
     /*  38445 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)  =>  (SUBSWrx:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$R2, arith_extended_reg32_i32:{ *:[i32] }:$R3)
     /*  38445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrx),
     /*  38448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38450 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  38452 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  38456 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38459 */     GIR_RootConstrainSelectedInstOperands,
     /*  38460 */     // GIR_Coverage, 3917,
     /*  38460 */     GIR_EraseRootFromParent_Done,
     /*  38461 */   // Label 614: @38461
     /*  38461 */   GIM_Try, /*On fail goto*//*Label 615*/ GIMT_Encode4(38494), // Rule ID 3922 //
     /*  38466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38474 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm32),
     /*  38481 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (ADDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, neg_addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDWri),
     /*  38484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38486 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38488 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38492 */     GIR_RootConstrainSelectedInstOperands,
     /*  38493 */     // GIR_Coverage, 3922,
     /*  38493 */     GIR_EraseRootFromParent_Done,
     /*  38494 */   // Label 615: @38494
     /*  38494 */   GIM_Try, /*On fail goto*//*Label 616*/ GIMT_Encode4(38530), // Rule ID 3911 //
     /*  38499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38503 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  38507 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm32),
     /*  38514 */     // (sub:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)  =>  (SUBSWri:{ *:[i32] }:{ *:[i32] } GPR32sp:{ *:[i32] }:$Rn, addsub_shifted_imm32:{ *:[i32] }:$imm)
     /*  38514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWri),
     /*  38517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38519 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38521 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  38525 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38528 */     GIR_RootConstrainSelectedInstOperands,
     /*  38529 */     // GIR_Coverage, 3911,
     /*  38529 */     GIR_EraseRootFromParent_Done,
     /*  38530 */   // Label 616: @38530
     /*  38530 */   GIM_Try, /*On fail goto*//*Label 617*/ GIMT_Encode4(38566), // Rule ID 3915 //
     /*  38535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38543 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg32),
     /*  38550 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)  =>  (SUBSWrs:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, arith_shifted_reg32:{ *:[i32] }:$Rm)
     /*  38550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrs),
     /*  38553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  38555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  38557 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  38561 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  38564 */     GIR_RootConstrainSelectedInstOperands,
     /*  38565 */     // GIR_Coverage, 3915,
     /*  38565 */     GIR_EraseRootFromParent_Done,
     /*  38566 */   // Label 617: @38566
     /*  38566 */   GIM_Try, /*On fail goto*//*Label 618*/ GIMT_Encode4(38596), // Rule ID 3913 //
     /*  38571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38575 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  38583 */     // (sub:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SUBSWrr:{ *:[i32] }:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  38583 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSWrr),
     /*  38588 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  38594 */     GIR_RootConstrainSelectedInstOperands,
     /*  38595 */     // GIR_Coverage, 3913,
     /*  38595 */     GIR_Done,
     /*  38596 */   // Label 618: @38596
     /*  38596 */   GIM_Reject,
     /*  38597 */ // Label 604: @38597
     /*  38597 */ GIM_Reject,
     /*  38598 */ // Label 591: @38598
     /*  38598 */ GIM_Try, /*On fail goto*//*Label 619*/ GIMT_Encode4(42503),
     /*  38603 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  38606 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  38609 */   GIM_Try, /*On fail goto*//*Label 620*/ GIMT_Encode4(38745), // Rule ID 5415 //
     /*  38614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38630 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38634 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38638 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38642 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38647 */     // MIs[1] Operand 2
     /*  38647 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38658 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38662 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38666 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38670 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38674 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38678 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38682 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38687 */     // MIs[3] Operand 2
     /*  38687 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38698 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38700 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38712 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38744 */     // GIR_Coverage, 5415,
     /*  38744 */     GIR_EraseRootFromParent_Done,
     /*  38745 */   // Label 620: @38745
     /*  38745 */   GIM_Try, /*On fail goto*//*Label 621*/ GIMT_Encode4(38881), // Rule ID 5414 //
     /*  38750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  38774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38778 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38783 */     // MIs[1] Operand 2
     /*  38783 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38806 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38810 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  38814 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38818 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38823 */     // MIs[3] Operand 2
     /*  38823 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38834 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38836 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38836 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38839 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  38843 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38852 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  38870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  38880 */     // GIR_Coverage, 5414,
     /*  38880 */     GIR_EraseRootFromParent_Done,
     /*  38881 */   // Label 621: @38881
     /*  38881 */   GIM_Try, /*On fail goto*//*Label 622*/ GIMT_Encode4(39017), // Rule ID 5424 //
     /*  38886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38890 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  38894 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38898 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  38906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38919 */     // MIs[1] Operand 2
     /*  38919 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  38930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  38934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  38938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  38942 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  38946 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  38950 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  38954 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  38959 */     // MIs[3] Operand 2
     /*  38959 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  38970 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  38972 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  38972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  38975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  38979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  38984 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  38988 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  38992 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  38994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  38997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  38999 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39006 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39011 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39016 */     // GIR_Coverage, 5424,
     /*  39016 */     GIR_EraseRootFromParent_Done,
     /*  39017 */   // Label 622: @39017
     /*  39017 */   GIM_Try, /*On fail goto*//*Label 623*/ GIMT_Encode4(39153), // Rule ID 5413 //
     /*  39022 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39055 */     // MIs[1] Operand 2
     /*  39055 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39066 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39070 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39074 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39078 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39082 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  39086 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39090 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39095 */     // MIs[3] Operand 2
     /*  39095 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39106 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39108 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39108 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39111 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39115 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39120 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39124 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39135 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39142 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39147 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39152 */     // GIR_Coverage, 5413,
     /*  39152 */     GIR_EraseRootFromParent_Done,
     /*  39153 */   // Label 623: @39153
     /*  39153 */   GIM_Try, /*On fail goto*//*Label 624*/ GIMT_Encode4(39289), // Rule ID 5412 //
     /*  39158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  39166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39174 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39178 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39182 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39186 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39191 */     // MIs[1] Operand 2
     /*  39191 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  39202 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  39206 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  39210 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  39214 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  39218 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39222 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  39226 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39231 */     // MIs[3] Operand 2
     /*  39231 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  39242 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  39244 */     // (sub:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  39244 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  39247 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  39251 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  39264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  39271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  39278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  39283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  39288 */     // GIR_Coverage, 5412,
     /*  39288 */     GIR_EraseRootFromParent_Done,
     /*  39289 */   // Label 624: @39289
     /*  39289 */   GIM_Try, /*On fail goto*//*Label 625*/ GIMT_Encode4(39426), // Rule ID 3969 //
     /*  39294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39298 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39314 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39322 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  39326 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  39330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39335 */     // MIs[2] Operand 2
     /*  39335 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  39346 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39350 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39354 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39358 */     // MIs[3] Operand 1
     /*  39358 */     // No operand predicates
     /*  39358 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39360 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39360 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  39363 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39367 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39372 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39377 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  39379 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39382 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39386 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39391 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39397 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39402 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39412 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  39418 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39424 */     GIR_RootConstrainSelectedInstOperands,
     /*  39425 */     // GIR_Coverage, 3969,
     /*  39425 */     GIR_EraseRootFromParent_Done,
     /*  39426 */   // Label 625: @39426
     /*  39426 */   GIM_Try, /*On fail goto*//*Label 626*/ GIMT_Encode4(39525), // Rule ID 3967 //
     /*  39431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39435 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39467 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39472 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39476 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39480 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  39484 */     // MIs[3] Operand 1
     /*  39484 */     // No operand predicates
     /*  39484 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39486 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39498 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39503 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39523 */     GIR_RootConstrainSelectedInstOperands,
     /*  39524 */     // GIR_Coverage, 3967,
     /*  39524 */     GIR_EraseRootFromParent_Done,
     /*  39525 */   // Label 626: @39525
     /*  39525 */   GIM_Try, /*On fail goto*//*Label 627*/ GIMT_Encode4(39624), // Rule ID 3968 //
     /*  39530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39534 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39538 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39542 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39546 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39550 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39554 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39558 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39562 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39566 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39571 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39575 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  39579 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  39583 */     // MIs[3] Operand 1
     /*  39583 */     // No operand predicates
     /*  39583 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39585 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  39585 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39588 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  39592 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39597 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  39602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  39604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39613 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39616 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39622 */     GIR_RootConstrainSelectedInstOperands,
     /*  39623 */     // GIR_Coverage, 3968,
     /*  39623 */     GIR_EraseRootFromParent_Done,
     /*  39624 */   // Label 627: @39624
     /*  39624 */   GIM_Try, /*On fail goto*//*Label 628*/ GIMT_Encode4(39710), // Rule ID 3962 //
     /*  39629 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39633 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39665 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39670 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39674 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  39678 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39682 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39689 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  39692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39698 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39702 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39708 */     GIR_RootConstrainSelectedInstOperands,
     /*  39709 */     // GIR_Coverage, 3962,
     /*  39709 */     GIR_EraseRootFromParent_Done,
     /*  39710 */   // Label 628: @39710
     /*  39710 */   GIM_Try, /*On fail goto*//*Label 629*/ GIMT_Encode4(39796), // Rule ID 3963 //
     /*  39715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39719 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  39760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39764 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  39768 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  39775 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  39784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  39788 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39794 */     GIR_RootConstrainSelectedInstOperands,
     /*  39795 */     // GIR_Coverage, 3963,
     /*  39795 */     GIR_EraseRootFromParent_Done,
     /*  39796 */   // Label 629: @39796
     /*  39796 */   GIM_Try, /*On fail goto*//*Label 630*/ GIMT_Encode4(39897), // Rule ID 3989 //
     /*  39801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39805 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39825 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  39834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39849 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39889 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39895 */     GIR_RootConstrainSelectedInstOperands,
     /*  39896 */     // GIR_Coverage, 3989,
     /*  39896 */     GIR_EraseRootFromParent_Done,
     /*  39897 */   // Label 630: @39897
     /*  39897 */   GIM_Try, /*On fail goto*//*Label 631*/ GIMT_Encode4(39998), // Rule ID 13879 //
     /*  39902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  39910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  39914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  39918 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  39922 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  39926 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  39930 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  39934 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  39938 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39943 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  39948 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  39950 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  39950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  39953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  39957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  39962 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  39968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  39973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  39978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  39981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  39983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  39986 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  39990 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  39996 */     GIR_RootConstrainSelectedInstOperands,
     /*  39997 */     // GIR_Coverage, 13879,
     /*  39997 */     GIR_EraseRootFromParent_Done,
     /*  39998 */   // Label 631: @39998
     /*  39998 */   GIM_Try, /*On fail goto*//*Label 632*/ GIMT_Encode4(40114), // Rule ID 3988 //
     /*  40003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40007 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40023 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40027 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40032 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40037 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40039 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  40039 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40042 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40046 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40051 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  40057 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40062 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40067 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40070 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40074 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40079 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40085 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40103 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40106 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40112 */     GIR_RootConstrainSelectedInstOperands,
     /*  40113 */     // GIR_Coverage, 3988,
     /*  40113 */     GIR_EraseRootFromParent_Done,
     /*  40114 */   // Label 632: @40114
     /*  40114 */   GIM_Try, /*On fail goto*//*Label 633*/ GIMT_Encode4(40247), // Rule ID 3975 //
     /*  40119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40123 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  40151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  40155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40160 */     // MIs[2] Operand 2
     /*  40160 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  40171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40179 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40183 */     // MIs[3] Operand 1
     /*  40183 */     // No operand predicates
     /*  40183 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40185 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40185 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  40188 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40192 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40197 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  40204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40216 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40227 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40237 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40240 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  40243 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40245 */     GIR_RootConstrainSelectedInstOperands,
     /*  40246 */     // GIR_Coverage, 3975,
     /*  40246 */     GIR_EraseRootFromParent_Done,
     /*  40247 */   // Label 633: @40247
     /*  40247 */   GIM_Try, /*On fail goto*//*Label 634*/ GIMT_Encode4(40342), // Rule ID 3973 //
     /*  40252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40272 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40276 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40280 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40284 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40288 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40301 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  40305 */     // MIs[3] Operand 1
     /*  40305 */     // No operand predicates
     /*  40305 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40307 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40319 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40324 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40335 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40340 */     GIR_RootConstrainSelectedInstOperands,
     /*  40341 */     // GIR_Coverage, 3973,
     /*  40341 */     GIR_EraseRootFromParent_Done,
     /*  40342 */   // Label 634: @40342
     /*  40342 */   GIM_Try, /*On fail goto*//*Label 635*/ GIMT_Encode4(40437), // Rule ID 3974 //
     /*  40347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40355 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40359 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40363 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40367 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40383 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40388 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40392 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  40396 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  40400 */     // MIs[3] Operand 1
     /*  40400 */     // No operand predicates
     /*  40400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40402 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), GPR64:{ *:[i64] }:$Ra)
     /*  40402 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40405 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  40409 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40414 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  40419 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  40421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40435 */     GIR_RootConstrainSelectedInstOperands,
     /*  40436 */     // GIR_Coverage, 3974,
     /*  40436 */     GIR_EraseRootFromParent_Done,
     /*  40437 */   // Label 635: @40437
     /*  40437 */   GIM_Try, /*On fail goto*//*Label 636*/ GIMT_Encode4(40519), // Rule ID 124 //
     /*  40442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40446 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40450 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40454 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40458 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40462 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40483 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40487 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  40491 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40495 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40502 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (SMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMSUBLrrr),
     /*  40505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40517 */     GIR_RootConstrainSelectedInstOperands,
     /*  40518 */     // GIR_Coverage, 124,
     /*  40518 */     GIR_EraseRootFromParent_Done,
     /*  40519 */   // Label 636: @40519
     /*  40519 */   GIM_Try, /*On fail goto*//*Label 637*/ GIMT_Encode4(40601), // Rule ID 126 //
     /*  40524 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40528 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  40552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  40569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /*  40577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  40584 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  40593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  40597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40599 */     GIR_RootConstrainSelectedInstOperands,
     /*  40600 */     // GIR_Coverage, 126,
     /*  40600 */     GIR_EraseRootFromParent_Done,
     /*  40601 */   // Label 637: @40601
     /*  40601 */   GIM_Try, /*On fail goto*//*Label 638*/ GIMT_Encode4(40663), // Rule ID 3953 //
     /*  40606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40610 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /*  40614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40626 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40635 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40640 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40642 */     // (sub:{ *:[i64] } 0:{ *:[i64] }, (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  40642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  40645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  40651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  40655 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  40661 */     GIR_RootConstrainSelectedInstOperands,
     /*  40662 */     // GIR_Coverage, 3953,
     /*  40662 */     GIR_EraseRootFromParent_Done,
     /*  40663 */   // Label 638: @40663
     /*  40663 */   GIM_Try, /*On fail goto*//*Label 639*/ GIMT_Encode4(40721), // Rule ID 9986 //
     /*  40668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40671 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40687 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40690 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /*  40695 */     // MIs[1] pattern
     /*  40695 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40698 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40705 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECB_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECB_XPiI),
     /*  40708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40716 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40719 */     GIR_RootConstrainSelectedInstOperands,
     /*  40720 */     // GIR_Coverage, 9986,
     /*  40720 */     GIR_EraseRootFromParent_Done,
     /*  40721 */   // Label 639: @40721
     /*  40721 */   GIM_Try, /*On fail goto*//*Label 640*/ GIMT_Encode4(40779), // Rule ID 9998 //
     /*  40726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40745 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40748 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /*  40753 */     // MIs[1] pattern
     /*  40753 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40756 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40761 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40763 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECH_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECH_XPiI),
     /*  40766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40774 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40777 */     GIR_RootConstrainSelectedInstOperands,
     /*  40778 */     // GIR_Coverage, 9998,
     /*  40778 */     GIR_EraseRootFromParent_Done,
     /*  40779 */   // Label 640: @40779
     /*  40779 */   GIM_Try, /*On fail goto*//*Label 641*/ GIMT_Encode4(40837), // Rule ID 10010 //
     /*  40784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40803 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40806 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /*  40811 */     // MIs[1] pattern
     /*  40811 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40814 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40819 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40821 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECW_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECW_XPiI),
     /*  40824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40828 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40832 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40835 */     GIR_RootConstrainSelectedInstOperands,
     /*  40836 */     // GIR_Coverage, 10010,
     /*  40836 */     GIR_EraseRootFromParent_Done,
     /*  40837 */   // Label 641: @40837
     /*  40837 */   GIM_Try, /*On fail goto*//*Label 642*/ GIMT_Encode4(40895), // Rule ID 10022 //
     /*  40842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_UseScalarIncVL),
     /*  40845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40849 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  40861 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  40864 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /*  40869 */     // MIs[1] pattern
     /*  40869 */     GIM_CheckIsImm, /*MI*/1, /*Op*/2,
     /*  40872 */     GIM_CheckImmOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /*  40877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  40879 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern))  =>  (DECD_XPiI:{ *:[i64] } GPR64:{ *:[i64] }:$Rdn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /*  40879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECD_XPiI),
     /*  40882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  40884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rdn
     /*  40886 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pattern
     /*  40890 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  40893 */     GIR_RootConstrainSelectedInstOperands,
     /*  40894 */     // GIR_Coverage, 10022,
     /*  40894 */     GIR_EraseRootFromParent_Done,
     /*  40895 */   // Label 642: @40895
     /*  40895 */   GIM_Try, /*On fail goto*//*Label 643*/ GIMT_Encode4(40992), // Rule ID 3991 //
     /*  40900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40904 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  40912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  40916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  40920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  40924 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  40929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  40933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  40937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  40941 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40946 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  40948 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm)))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  40948 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  40951 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  40955 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  40960 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  40966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  40971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  40976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  40979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  40981 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  40984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  40988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  40990 */     GIR_RootConstrainSelectedInstOperands,
     /*  40991 */     // GIR_Coverage, 3991,
     /*  40991 */     GIR_EraseRootFromParent_Done,
     /*  40992 */   // Label 643: @40992
     /*  40992 */   GIM_Try, /*On fail goto*//*Label 644*/ GIMT_Encode4(41089), // Rule ID 13880 //
     /*  40997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41001 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41005 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41009 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41013 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41017 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41029 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  41033 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41038 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41043 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41045 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, GPR64:{ *:[i64] }:$Ra)
     /*  41045 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  41048 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41052 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41057 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  41063 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  41076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41078 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  41081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41085 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  41087 */     GIR_RootConstrainSelectedInstOperands,
     /*  41088 */     // GIR_Coverage, 13880,
     /*  41088 */     GIR_EraseRootFromParent_Done,
     /*  41089 */   // Label 644: @41089
     /*  41089 */   GIM_Try, /*On fail goto*//*Label 645*/ GIMT_Encode4(41252), // Rule ID 5379 //
     /*  41094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41098 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  41122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41140 */     // MIs[1] Operand 2
     /*  41140 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41151 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41153 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41153 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41156 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41160 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41165 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41167 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41170 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41174 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41179 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41182 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41186 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41189 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41194 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41199 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41204 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41207 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  41211 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41216 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41219 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41227 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41234 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41251 */     // GIR_Coverage, 5379,
     /*  41251 */     GIR_EraseRootFromParent_Done,
     /*  41252 */   // Label 645: @41252
     /*  41252 */   GIM_Try, /*On fail goto*//*Label 646*/ GIMT_Encode4(41415), // Rule ID 5376 //
     /*  41257 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41261 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  41285 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41289 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  41293 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41303 */     // MIs[1] Operand 2
     /*  41303 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41316 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Ra, (extract_subvector:{ *:[v1i64] } (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (UMLSLv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41316 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41319 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41323 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41330 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41333 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41337 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41342 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41345 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  41349 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41352 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  41374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41382 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  41386 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  41390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41397 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41404 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41414 */     // GIR_Coverage, 5376,
     /*  41414 */     GIR_EraseRootFromParent_Done,
     /*  41415 */   // Label 646: @41415
     /*  41415 */   GIM_Try, /*On fail goto*//*Label 647*/ GIMT_Encode4(41565), // Rule ID 5421 //
     /*  41420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  41448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41457 */     // MIs[1] Operand 2
     /*  41457 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41470 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41470 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41473 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41477 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41482 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41496 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41503 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41516 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41533 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41547 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41554 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41559 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41564 */     // GIR_Coverage, 5421,
     /*  41564 */     GIR_EraseRootFromParent_Done,
     /*  41565 */   // Label 647: @41565
     /*  41565 */   GIM_Try, /*On fail goto*//*Label 648*/ GIMT_Encode4(41715), // Rule ID 5427 //
     /*  41570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  41598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41602 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41607 */     // MIs[1] Operand 2
     /*  41607 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41620 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (SSUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41620 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41623 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41627 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41646 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41649 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41653 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41656 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41661 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41666 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41671 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41674 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  41678 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41683 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41697 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41714 */     // GIR_Coverage, 5427,
     /*  41714 */     GIR_EraseRootFromParent_Done,
     /*  41715 */   // Label 648: @41715
     /*  41715 */   GIM_Try, /*On fail goto*//*Label 649*/ GIMT_Encode4(41865), // Rule ID 5420 //
     /*  41720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  41736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  41740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  41744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  41748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  41752 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41757 */     // MIs[1] Operand 2
     /*  41757 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  41768 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  41770 */     // (sub:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, (extract_subvector:{ *:[v1i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (USUBWv2i32_v2i64:{ *:[v2i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v2i32] }:$Rm), dsub:{ *:[i32] })
     /*  41770 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  41773 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  41777 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41782 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  41784 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /*  41787 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  41791 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41796 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  41799 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  41803 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  41806 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41811 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41816 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  41824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  41828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41833 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  41836 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  41840 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  41842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  41847 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  41854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  41859 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  41864 */     // GIR_Coverage, 5420,
     /*  41864 */     GIR_EraseRootFromParent_Done,
     /*  41865 */   // Label 649: @41865
     /*  41865 */   GIM_Try, /*On fail goto*//*Label 650*/ GIMT_Encode4(41901), // Rule ID 3918 //
     /*  41870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41878 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_extended_reg32to64_i64),
     /*  41885 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)  =>  (SUBSXrx:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$R2, arith_extended_reg32to64_i64:{ *:[i64] }:$R3)
     /*  41885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrx),
     /*  41888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41890 */     GIR_RootToRootCopy, /*OpIdx*/1, // R2
     /*  41892 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // R3
     /*  41896 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  41899 */     GIR_RootConstrainSelectedInstOperands,
     /*  41900 */     // GIR_Coverage, 3918,
     /*  41900 */     GIR_EraseRootFromParent_Done,
     /*  41901 */   // Label 650: @41901
     /*  41901 */   GIM_Try, /*On fail goto*//*Label 651*/ GIMT_Encode4(41934), // Rule ID 3923 //
     /*  41906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  41910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_neg_addsub_shifted_imm64),
     /*  41921 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (ADDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, neg_addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  41921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDXri),
     /*  41924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  41926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  41928 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  41932 */     GIR_RootConstrainSelectedInstOperands,
     /*  41933 */     // GIR_Coverage, 3923,
     /*  41933 */     GIR_EraseRootFromParent_Done,
     /*  41934 */   // Label 651: @41934
     /*  41934 */   GIM_Try, /*On fail goto*//*Label 652*/ GIMT_Encode4(42046), // Rule ID 3990 //
     /*  41939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41943 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  41947 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  41951 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_MUL),
     /*  41955 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  41959 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  41963 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41968 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  41973 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  41975 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Ra, (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm))  =>  (UMSUBLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), GPR64:{ *:[i64] }:$Ra)
     /*  41975 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  41978 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  41982 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  41987 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/1, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  41993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  41998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42003 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  42006 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42010 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42015 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  42021 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  42026 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMSUBLrrr),
     /*  42034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  42039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  42042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ra
     /*  42044 */     GIR_RootConstrainSelectedInstOperands,
     /*  42045 */     // GIR_Coverage, 3990,
     /*  42045 */     GIR_EraseRootFromParent_Done,
     /*  42046 */   // Label 652: @42046
     /*  42046 */   GIM_Try, /*On fail goto*//*Label 653*/ GIMT_Encode4(42082), // Rule ID 3912 //
     /*  42051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  42059 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_addsub_shifted_imm64),
     /*  42066 */     // (sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)  =>  (SUBSXri:{ *:[i64] }:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, addsub_shifted_imm64:{ *:[i64] }:$imm)
     /*  42066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXri),
     /*  42069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42073 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // imm
     /*  42077 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42080 */     GIR_RootConstrainSelectedInstOperands,
     /*  42081 */     // GIR_Coverage, 3912,
     /*  42081 */     GIR_EraseRootFromParent_Done,
     /*  42082 */   // Label 653: @42082
     /*  42082 */   GIM_Try, /*On fail goto*//*Label 654*/ GIMT_Encode4(42118), // Rule ID 3916 //
     /*  42087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_arith_shifted_reg64),
     /*  42102 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)  =>  (SUBSXrs:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, arith_shifted_reg64:{ *:[i64] }:$Rm)
     /*  42102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrs),
     /*  42105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42109 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm
     /*  42113 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /*  42116 */     GIR_RootConstrainSelectedInstOperands,
     /*  42117 */     // GIR_Coverage, 3916,
     /*  42117 */     GIR_EraseRootFromParent_Done,
     /*  42118 */   // Label 654: @42118
     /*  42118 */   GIM_Try, /*On fail goto*//*Label 655*/ GIMT_Encode4(42181), // Rule ID 10119 //
     /*  42123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42142 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42145 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42150 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  42154 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42161 */     // MIs[1] pred
     /*  42161 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42168 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$pred, PPRAny:{ *:[nxv16i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_B),
     /*  42171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42179 */     GIR_RootConstrainSelectedInstOperands,
     /*  42180 */     // GIR_Coverage, 10119,
     /*  42180 */     GIR_EraseRootFromParent_Done,
     /*  42181 */   // Label 655: @42181
     /*  42181 */   GIM_Try, /*On fail goto*//*Label 656*/ GIMT_Encode4(42244), // Rule ID 10120 //
     /*  42186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42205 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42208 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  42217 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42219 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42224 */     // MIs[1] pred
     /*  42224 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42229 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42231 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv8i1] }:$pred, PPRAny:{ *:[nxv8i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_H),
     /*  42234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42242 */     GIR_RootConstrainSelectedInstOperands,
     /*  42243 */     // GIR_Coverage, 10120,
     /*  42243 */     GIR_EraseRootFromParent_Done,
     /*  42244 */   // Label 656: @42244
     /*  42244 */   GIM_Try, /*On fail goto*//*Label 657*/ GIMT_Encode4(42307), // Rule ID 10121 //
     /*  42249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42268 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42271 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  42280 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42287 */     // MIs[1] pred
     /*  42287 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42292 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42294 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv4i1] }:$pred, PPRAny:{ *:[nxv4i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_S),
     /*  42297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42305 */     GIR_RootConstrainSelectedInstOperands,
     /*  42306 */     // GIR_Coverage, 10121,
     /*  42306 */     GIR_EraseRootFromParent_Done,
     /*  42307 */   // Label 657: @42307
     /*  42307 */   GIM_Try, /*On fail goto*//*Label 658*/ GIMT_Encode4(42370), // Rule ID 10122 //
     /*  42312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  42315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  42327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  42331 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  42334 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /*  42339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  42343 */     GIM_CheckHasOneUse, /*MI*/1,
     /*  42345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  42350 */     // MIs[1] pred
     /*  42350 */     GIM_CheckIsSameOperand, /*MI*/1, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  42355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42357 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, PPRAny:{ *:[nxv2i1] }:$pred, PPRAny:{ *:[nxv2i1] }:$pred)<<P:Predicate_int_aarch64_sve_cntp_oneuse>>)  =>  (DECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$pred, ?:{ *:[i64] }:$Rn)
     /*  42357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DECP_XP_D),
     /*  42360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /*  42362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // pred
     /*  42366 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  42368 */     GIR_RootConstrainSelectedInstOperands,
     /*  42369 */     // GIR_Coverage, 10122,
     /*  42369 */     GIR_EraseRootFromParent_Done,
     /*  42370 */   // Label 658: @42370
     /*  42370 */   GIM_Try, /*On fail goto*//*Label 659*/ GIMT_Encode4(42409), // Rule ID 1655 //
     /*  42375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42382 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42386 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42392 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42400 */     // (sub:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (NEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /*  42400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42407 */     GIR_RootConstrainSelectedInstOperands,
     /*  42408 */     // GIR_Coverage, 1655,
     /*  42408 */     GIR_EraseRootFromParent_Done,
     /*  42409 */   // Label 659: @42409
     /*  42409 */   GIM_Try, /*On fail goto*//*Label 660*/ GIMT_Encode4(42445), // Rule ID 5262 //
     /*  42414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42422 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  42428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  42430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42434 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  42436 */     // (sub:{ *:[i64] } immAllZerosV:{ *:[i64] }, FPR64:{ *:[i64] }:$Rn)  =>  (NEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /*  42436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv1i64),
     /*  42439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  42441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  42443 */     GIR_RootConstrainSelectedInstOperands,
     /*  42444 */     // GIR_Coverage, 5262,
     /*  42444 */     GIR_EraseRootFromParent_Done,
     /*  42445 */   // Label 660: @42445
     /*  42445 */   GIM_Try, /*On fail goto*//*Label 661*/ GIMT_Encode4(42472), // Rule ID 1644 //
     /*  42450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  42453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42461 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42465 */     // (sub:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  42465 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv1i64),
     /*  42470 */     GIR_RootConstrainSelectedInstOperands,
     /*  42471 */     // GIR_Coverage, 1644,
     /*  42471 */     GIR_Done,
     /*  42472 */   // Label 661: @42472
     /*  42472 */   GIM_Try, /*On fail goto*//*Label 662*/ GIMT_Encode4(42502), // Rule ID 3914 //
     /*  42477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  42489 */     // (sub:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SUBSXrr:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  42489 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBSXrr),
     /*  42494 */     GIR_AddImplicitDef, /*InsnID*/0, GIMT_Encode2(AArch64::NZCV), GIMT_Encode2(RegState::Dead),
     /*  42500 */     GIR_RootConstrainSelectedInstOperands,
     /*  42501 */     // GIR_Coverage, 3914,
     /*  42501 */     GIR_Done,
     /*  42502 */   // Label 662: @42502
     /*  42502 */   GIM_Reject,
     /*  42503 */ // Label 619: @42503
     /*  42503 */ GIM_Reject,
     /*  42504 */ // Label 592: @42504
     /*  42504 */ GIM_Try, /*On fail goto*//*Label 663*/ GIMT_Encode4(43994),
     /*  42509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  42512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  42515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42519 */   GIM_Try, /*On fail goto*//*Label 664*/ GIMT_Encode4(42651), // Rule ID 5411 //
     /*  42524 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42528 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42532 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42536 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42540 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42544 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42548 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42553 */     // MIs[1] Operand 2
     /*  42553 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42564 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42568 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42572 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42576 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42580 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42584 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42588 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42593 */     // MIs[3] Operand 2
     /*  42593 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42604 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42606 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42618 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42622 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42633 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42650 */     // GIR_Coverage, 5411,
     /*  42650 */     GIR_EraseRootFromParent_Done,
     /*  42651 */   // Label 664: @42651
     /*  42651 */   GIM_Try, /*On fail goto*//*Label 665*/ GIMT_Encode4(42783), // Rule ID 5410 //
     /*  42656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42685 */     // MIs[1] Operand 2
     /*  42685 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42696 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42700 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42704 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42712 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42716 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42720 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42725 */     // MIs[3] Operand 2
     /*  42725 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42736 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42738 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  42745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42750 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42754 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42765 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42777 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42782 */     // GIR_Coverage, 5410,
     /*  42782 */     GIR_EraseRootFromParent_Done,
     /*  42783 */   // Label 665: @42783
     /*  42783 */   GIM_Try, /*On fail goto*//*Label 666*/ GIMT_Encode4(42915), // Rule ID 5423 //
     /*  42788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42808 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42812 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42817 */     // MIs[1] Operand 2
     /*  42817 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42828 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42832 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42836 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42840 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42844 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  42848 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42852 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42857 */     // MIs[3] Operand 2
     /*  42857 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  42868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  42870 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  42870 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  42873 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  42877 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  42882 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  42886 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  42890 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  42892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  42895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  42897 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  42904 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42909 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  42914 */     // GIR_Coverage, 5423,
     /*  42914 */     GIR_EraseRootFromParent_Done,
     /*  42915 */   // Label 666: @42915
     /*  42915 */   GIM_Try, /*On fail goto*//*Label 667*/ GIMT_Encode4(43047), // Rule ID 5409 //
     /*  42920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  42924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42932 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  42936 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  42940 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42944 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42949 */     // MIs[1] Operand 2
     /*  42949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  42960 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  42964 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  42968 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  42972 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  42976 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  42980 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  42984 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  42989 */     // MIs[3] Operand 2
     /*  42989 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43000 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43002 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43018 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43029 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43046 */     // GIR_Coverage, 5409,
     /*  43046 */     GIR_EraseRootFromParent_Done,
     /*  43047 */   // Label 667: @43047
     /*  43047 */   GIM_Try, /*On fail goto*//*Label 668*/ GIMT_Encode4(43179), // Rule ID 5408 //
     /*  43052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43060 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43064 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43068 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43072 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43081 */     // MIs[1] Operand 2
     /*  43081 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43092 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  43096 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43100 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  43108 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43112 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43116 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43121 */     // MIs[3] Operand 2
     /*  43121 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  43132 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  43134 */     // (sub:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  43141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43146 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  43154 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43161 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43178 */     // GIR_Coverage, 5408,
     /*  43178 */     GIR_EraseRootFromParent_Done,
     /*  43179 */   // Label 668: @43179
     /*  43179 */   GIM_Try, /*On fail goto*//*Label 669*/ GIMT_Encode4(43338), // Rule ID 5378 //
     /*  43184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43196 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43200 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43204 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  43208 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43212 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43216 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43221 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43226 */     // MIs[1] Operand 2
     /*  43226 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43239 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43239 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43242 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43246 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43253 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43256 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43260 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43265 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43268 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43272 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43275 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43280 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43285 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43290 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43293 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  43297 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43302 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43305 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43309 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43320 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43327 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43332 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43337 */     // GIR_Coverage, 5378,
     /*  43337 */     GIR_EraseRootFromParent_Done,
     /*  43338 */   // Label 669: @43338
     /*  43338 */   GIM_Try, /*On fail goto*//*Label 670*/ GIMT_Encode4(43497), // Rule ID 5375 //
     /*  43343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  43367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  43375 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43385 */     // MIs[1] Operand 2
     /*  43385 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43398 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Ra, (extract_subvector:{ *:[v2i32] } (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (UMLSLv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43398 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43401 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43405 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43412 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43415 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43419 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43424 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43427 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  43431 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43434 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43439 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43444 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  43456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43464 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  43468 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  43472 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43479 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43496 */     // GIR_Coverage, 5375,
     /*  43496 */     GIR_EraseRootFromParent_Done,
     /*  43497 */   // Label 670: @43497
     /*  43497 */   GIM_Try, /*On fail goto*//*Label 671*/ GIMT_Encode4(43643), // Rule ID 5419 //
     /*  43502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43506 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43510 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43514 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  43526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43535 */     // MIs[1] Operand 2
     /*  43535 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43548 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43548 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43551 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43555 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43562 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43565 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43569 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43574 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43577 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43581 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43584 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43589 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43594 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43599 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43602 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43606 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43611 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43625 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43632 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43637 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43642 */     // GIR_Coverage, 5419,
     /*  43642 */     GIR_EraseRootFromParent_Done,
     /*  43643 */   // Label 671: @43643
     /*  43643 */   GIM_Try, /*On fail goto*//*Label 672*/ GIMT_Encode4(43789), // Rule ID 5426 //
     /*  43648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  43672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43681 */     // MIs[1] Operand 2
     /*  43681 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43692 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43694 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (SSUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43694 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43697 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43701 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43708 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43711 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43715 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43720 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43723 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43727 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43730 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43735 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  43752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43757 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43760 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43771 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43778 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43783 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43788 */     // GIR_Coverage, 5426,
     /*  43788 */     GIR_EraseRootFromParent_Done,
     /*  43789 */   // Label 672: @43789
     /*  43789 */   GIM_Try, /*On fail goto*//*Label 673*/ GIMT_Encode4(43935), // Rule ID 5418 //
     /*  43794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  43802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  43806 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  43810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  43814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  43818 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  43822 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43827 */     // MIs[1] Operand 2
     /*  43827 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  43838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  43840 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (USUBWv4i16_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v4i16] }:$Rm), dsub:{ *:[i32] })
     /*  43840 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /*  43843 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  43847 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  43854 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /*  43857 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  43861 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43866 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  43869 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  43873 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  43876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43881 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43886 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43891 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /*  43894 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  43898 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  43903 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  43906 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  43910 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  43912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  43915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  43917 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  43924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  43934 */     // GIR_Coverage, 5418,
     /*  43934 */     GIR_EraseRootFromParent_Done,
     /*  43935 */   // Label 673: @43935
     /*  43935 */   GIM_Try, /*On fail goto*//*Label 674*/ GIMT_Encode4(43970), // Rule ID 969 //
     /*  43940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  43947 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  43953 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  43955 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  43961 */     // (sub:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn)  =>  (NEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  43961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i32),
     /*  43964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  43966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  43968 */     GIR_RootConstrainSelectedInstOperands,
     /*  43969 */     // GIR_Coverage, 969,
     /*  43969 */     GIR_EraseRootFromParent_Done,
     /*  43970 */   // Label 674: @43970
     /*  43970 */   GIM_Try, /*On fail goto*//*Label 675*/ GIMT_Encode4(43993), // Rule ID 1476 //
     /*  43975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  43978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43982 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  43986 */     // (sub:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  43986 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i32),
     /*  43991 */     GIR_RootConstrainSelectedInstOperands,
     /*  43992 */     // GIR_Coverage, 1476,
     /*  43992 */     GIR_Done,
     /*  43993 */   // Label 675: @43993
     /*  43993 */   GIM_Reject,
     /*  43994 */ // Label 663: @43994
     /*  43994 */ GIM_Reject,
     /*  43995 */ // Label 593: @43995
     /*  43995 */ GIM_Try, /*On fail goto*//*Label 676*/ GIMT_Encode4(46454),
     /*  44000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  44003 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  44006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44010 */   GIM_Try, /*On fail goto*//*Label 677*/ GIMT_Encode4(44124), // Rule ID 2048 //
     /*  44015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44018 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44038 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44042 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44046 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44050 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44054 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44058 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44062 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44066 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44071 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44075 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44079 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44083 */     // MIs[4] Operand 1
     /*  44083 */     // No operand predicates
     /*  44083 */     // MIs[2] Operand 2
     /*  44083 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44096 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44103 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44108 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44110 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44122 */     GIR_RootConstrainSelectedInstOperands,
     /*  44123 */     // GIR_Coverage, 2048,
     /*  44123 */     GIR_EraseRootFromParent_Done,
     /*  44124 */   // Label 677: @44124
     /*  44124 */   GIM_Try, /*On fail goto*//*Label 678*/ GIMT_Encode4(44238), // Rule ID 13574 //
     /*  44129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44164 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44168 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44172 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44176 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44180 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44185 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44189 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44193 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44197 */     // MIs[4] Operand 1
     /*  44197 */     // No operand predicates
     /*  44197 */     // MIs[2] Operand 2
     /*  44197 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44208 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44210 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44217 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (SMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_indexed),
     /*  44220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44224 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44229 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44233 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44236 */     GIR_RootConstrainSelectedInstOperands,
     /*  44237 */     // GIR_Coverage, 13574,
     /*  44237 */     GIR_EraseRootFromParent_Done,
     /*  44238 */   // Label 678: @44238
     /*  44238 */   GIM_Try, /*On fail goto*//*Label 679*/ GIMT_Encode4(44352), // Rule ID 2100 //
     /*  44243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44246 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44270 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44274 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44282 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44286 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44290 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44294 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44299 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44303 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44307 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44311 */     // MIs[4] Operand 1
     /*  44311 */     // No operand predicates
     /*  44311 */     // MIs[2] Operand 2
     /*  44311 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44322 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44324 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44331 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44338 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44347 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44350 */     GIR_RootConstrainSelectedInstOperands,
     /*  44351 */     // GIR_Coverage, 2100,
     /*  44351 */     GIR_EraseRootFromParent_Done,
     /*  44352 */   // Label 679: @44352
     /*  44352 */   GIM_Try, /*On fail goto*//*Label 680*/ GIMT_Encode4(44466), // Rule ID 13610 //
     /*  44357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44360 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  44372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44376 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44388 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44408 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44413 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44417 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44421 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44425 */     // MIs[4] Operand 1
     /*  44425 */     // No operand predicates
     /*  44425 */     // MIs[2] Operand 2
     /*  44425 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /*  44436 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44438 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44445 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)))  =>  (UMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_indexed),
     /*  44448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44464 */     GIR_RootConstrainSelectedInstOperands,
     /*  44465 */     // GIR_Coverage, 13610,
     /*  44465 */     GIR_EraseRootFromParent_Done,
     /*  44466 */   // Label 680: @44466
     /*  44466 */   GIM_Try, /*On fail goto*//*Label 681*/ GIMT_Encode4(44531), // Rule ID 1855 //
     /*  44471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44494 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44500 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44507 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44514 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44517 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44529 */     GIR_RootConstrainSelectedInstOperands,
     /*  44530 */     // GIR_Coverage, 1855,
     /*  44530 */     GIR_EraseRootFromParent_Done,
     /*  44531 */   // Label 681: @44531
     /*  44531 */   GIM_Try, /*On fail goto*//*Label 682*/ GIMT_Encode4(44596), // Rule ID 1854 //
     /*  44536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44547 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44559 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44563 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44565 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44572 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44579 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44584 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44594 */     GIR_RootConstrainSelectedInstOperands,
     /*  44595 */     // GIR_Coverage, 1854,
     /*  44595 */     GIR_EraseRootFromParent_Done,
     /*  44596 */   // Label 682: @44596
     /*  44596 */   GIM_Try, /*On fail goto*//*Label 683*/ GIMT_Encode4(44661), // Rule ID 1759 //
     /*  44601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44608 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44612 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  44624 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44628 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44630 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44637 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44644 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i32_v2i64),
     /*  44647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44659 */     GIR_RootConstrainSelectedInstOperands,
     /*  44660 */     // GIR_Coverage, 1759,
     /*  44660 */     GIR_EraseRootFromParent_Done,
     /*  44661 */   // Label 683: @44661
     /*  44661 */   GIM_Try, /*On fail goto*//*Label 684*/ GIMT_Encode4(44726), // Rule ID 1853 //
     /*  44666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  44689 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44695 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44702 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44709 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44724 */     GIR_RootConstrainSelectedInstOperands,
     /*  44725 */     // GIR_Coverage, 1853,
     /*  44725 */     GIR_EraseRootFromParent_Done,
     /*  44726 */   // Label 684: @44726
     /*  44726 */   GIM_Try, /*On fail goto*//*Label 685*/ GIMT_Encode4(44791), // Rule ID 1852 //
     /*  44731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  44738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44742 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44746 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  44750 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  44754 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  44760 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44767 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  44774 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  44774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i32_v2i64),
     /*  44777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  44779 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  44784 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  44789 */     GIR_RootConstrainSelectedInstOperands,
     /*  44790 */     // GIR_Coverage, 1852,
     /*  44790 */     GIR_EraseRootFromParent_Done,
     /*  44791 */   // Label 685: @44791
     /*  44791 */   GIM_Try, /*On fail goto*//*Label 686*/ GIMT_Encode4(44902), // Rule ID 13572 //
     /*  44796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44799 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  44823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44827 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44831 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44835 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44839 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44843 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44847 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44852 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44856 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44860 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44864 */     // MIs[4] Operand 1
     /*  44864 */     // No operand predicates
     /*  44864 */     // MIs[2] Operand 2
     /*  44864 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44880 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44882 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44887 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  44889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  44893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  44897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  44900 */     GIR_RootConstrainSelectedInstOperands,
     /*  44901 */     // GIR_Coverage, 13572,
     /*  44901 */     GIR_EraseRootFromParent_Done,
     /*  44902 */   // Label 686: @44902
     /*  44902 */   GIM_Try, /*On fail goto*//*Label 687*/ GIMT_Encode4(45013), // Rule ID 2046 //
     /*  44907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  44910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  44918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  44922 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  44926 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  44930 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  44935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  44939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  44943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  44951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  44955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  44959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  44963 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  44968 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  44972 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  44976 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  44980 */     // MIs[4] Operand 1
     /*  44980 */     // No operand predicates
     /*  44980 */     // MIs[2] Operand 2
     /*  44980 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  44991 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  44993 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  44993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  44996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  44998 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45000 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45011 */     GIR_RootConstrainSelectedInstOperands,
     /*  45012 */     // GIR_Coverage, 2046,
     /*  45012 */     GIR_EraseRootFromParent_Done,
     /*  45013 */   // Label 687: @45013
     /*  45013 */   GIM_Try, /*On fail goto*//*Label 688*/ GIMT_Encode4(45124), // Rule ID 13608 //
     /*  45018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45069 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45074 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45078 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45082 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45086 */     // MIs[4] Operand 1
     /*  45086 */     // No operand predicates
     /*  45086 */     // MIs[2] Operand 2
     /*  45086 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45102 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45104 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45109 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45122 */     GIR_RootConstrainSelectedInstOperands,
     /*  45123 */     // GIR_Coverage, 13608,
     /*  45123 */     GIR_EraseRootFromParent_Done,
     /*  45124 */   // Label 688: @45124
     /*  45124 */   GIM_Try, /*On fail goto*//*Label 689*/ GIMT_Encode4(45235), // Rule ID 2098 //
     /*  45129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  45165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  45173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45177 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45181 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  45185 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45190 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  45194 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45198 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45202 */     // MIs[4] Operand 1
     /*  45202 */     // No operand predicates
     /*  45202 */     // MIs[2] Operand 2
     /*  45202 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  45213 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  45215 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45222 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  45230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  45233 */     GIR_RootConstrainSelectedInstOperands,
     /*  45234 */     // GIR_Coverage, 2098,
     /*  45234 */     GIR_EraseRootFromParent_Done,
     /*  45235 */   // Label 689: @45235
     /*  45235 */   GIM_Try, /*On fail goto*//*Label 690*/ GIMT_Encode4(45298), // Rule ID 1735 //
     /*  45240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45243 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45259 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45263 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45265 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45272 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45279 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i32_v2i64),
     /*  45282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45284 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45296 */     GIR_RootConstrainSelectedInstOperands,
     /*  45297 */     // GIR_Coverage, 1735,
     /*  45297 */     GIR_EraseRootFromParent_Done,
     /*  45298 */   // Label 690: @45298
     /*  45298 */   GIM_Try, /*On fail goto*//*Label 691*/ GIMT_Encode4(45361), // Rule ID 1825 //
     /*  45303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45322 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45328 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45335 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45342 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i32_v2i64),
     /*  45345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  45354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  45359 */     GIR_RootConstrainSelectedInstOperands,
     /*  45360 */     // GIR_Coverage, 1825,
     /*  45360 */     GIR_EraseRootFromParent_Done,
     /*  45361 */   // Label 691: @45361
     /*  45361 */   GIM_Try, /*On fail goto*//*Label 692*/ GIMT_Encode4(45449), // Rule ID 13573 //
     /*  45366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45397 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45401 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45405 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45410 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45414 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45418 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45422 */     // MIs[3] Operand 1
     /*  45422 */     // No operand predicates
     /*  45422 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45429 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45447 */     GIR_RootConstrainSelectedInstOperands,
     /*  45448 */     // GIR_Coverage, 13573,
     /*  45448 */     GIR_EraseRootFromParent_Done,
     /*  45449 */   // Label 692: @45449
     /*  45449 */   GIM_Try, /*On fail goto*//*Label 693*/ GIMT_Encode4(45537), // Rule ID 2047 //
     /*  45454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  45469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45477 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45494 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45498 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45503 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45507 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45511 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45515 */     // MIs[3] Operand 1
     /*  45515 */     // No operand predicates
     /*  45515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45517 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_indexed),
     /*  45520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45522 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45524 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45532 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45535 */     GIR_RootConstrainSelectedInstOperands,
     /*  45536 */     // GIR_Coverage, 2047,
     /*  45536 */     GIR_EraseRootFromParent_Done,
     /*  45537 */   // Label 693: @45537
     /*  45537 */   GIM_Try, /*On fail goto*//*Label 694*/ GIMT_Encode4(45625), // Rule ID 13609 //
     /*  45542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45557 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45561 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  45569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45598 */     // MIs[3] Operand 1
     /*  45598 */     // No operand predicates
     /*  45598 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45603 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45605 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45610 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  45616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45623 */     GIR_RootConstrainSelectedInstOperands,
     /*  45624 */     // GIR_Coverage, 13609,
     /*  45624 */     GIR_EraseRootFromParent_Done,
     /*  45625 */   // Label 694: @45625
     /*  45625 */   GIM_Try, /*On fail goto*//*Label 695*/ GIMT_Encode4(45713), // Rule ID 2099 //
     /*  45630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  45645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  45653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  45662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  45666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  45670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  45674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  45683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  45687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  45691 */     // MIs[3] Operand 1
     /*  45691 */     // No operand predicates
     /*  45691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  45693 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  45693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_indexed),
     /*  45696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  45698 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  45700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  45711 */     GIR_RootConstrainSelectedInstOperands,
     /*  45712 */     // GIR_Coverage, 2099,
     /*  45712 */     GIR_EraseRootFromParent_Done,
     /*  45713 */   // Label 695: @45713
     /*  45713 */   GIM_Try, /*On fail goto*//*Label 696*/ GIMT_Encode4(45760), // Rule ID 1867 //
     /*  45718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45733 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45739 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45746 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45751 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45758 */     GIR_RootConstrainSelectedInstOperands,
     /*  45759 */     // GIR_Coverage, 1867,
     /*  45759 */     GIR_EraseRootFromParent_Done,
     /*  45760 */   // Label 696: @45760
     /*  45760 */   GIM_Try, /*On fail goto*//*Label 697*/ GIMT_Encode4(45807), // Rule ID 1765 //
     /*  45765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45768 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45772 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45776 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45780 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45784 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45786 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45793 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SSUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i32_v2i64),
     /*  45796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45798 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45805 */     GIR_RootConstrainSelectedInstOperands,
     /*  45806 */     // GIR_Coverage, 1765,
     /*  45806 */     GIR_EraseRootFromParent_Done,
     /*  45807 */   // Label 697: @45807
     /*  45807 */   GIM_Try, /*On fail goto*//*Label 698*/ GIMT_Encode4(45854), // Rule ID 1866 //
     /*  45812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  45819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  45823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  45833 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  45840 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (USUBWv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  45840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i32_v2i64),
     /*  45843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  45847 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  45852 */     GIR_RootConstrainSelectedInstOperands,
     /*  45853 */     // GIR_Coverage, 1866,
     /*  45853 */     GIR_EraseRootFromParent_Done,
     /*  45854 */   // Label 698: @45854
     /*  45854 */   GIM_Try, /*On fail goto*//*Label 699*/ GIMT_Encode4(45913), // Rule ID 1851 //
     /*  45859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45874 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45887 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45891 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45896 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45898 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45911 */     GIR_RootConstrainSelectedInstOperands,
     /*  45912 */     // GIR_Coverage, 1851,
     /*  45912 */     GIR_EraseRootFromParent_Done,
     /*  45913 */   // Label 699: @45913
     /*  45913 */   GIM_Try, /*On fail goto*//*Label 700*/ GIMT_Encode4(45972), // Rule ID 1850 //
     /*  45918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  45929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  45942 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  45946 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45950 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45955 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  45957 */     // (sub:{ *:[v2i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  45957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  45960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  45962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  45966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  45970 */     GIR_RootConstrainSelectedInstOperands,
     /*  45971 */     // GIR_Coverage, 1850,
     /*  45971 */     GIR_EraseRootFromParent_Done,
     /*  45972 */   // Label 700: @45972
     /*  45972 */   GIM_Try, /*On fail goto*//*Label 701*/ GIMT_Encode4(46031), // Rule ID 1758 //
     /*  45977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  45980 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  45984 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  45988 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  45992 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  45997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46005 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46009 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46016 */     // (sub:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv2i32_v2i64),
     /*  46019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46021 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46029 */     GIR_RootConstrainSelectedInstOperands,
     /*  46030 */     // GIR_Coverage, 1758,
     /*  46030 */     GIR_EraseRootFromParent_Done,
     /*  46031 */   // Label 701: @46031
     /*  46031 */   GIM_Try, /*On fail goto*//*Label 702*/ GIMT_Encode4(46090), // Rule ID 1849 //
     /*  46036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46064 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46068 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46073 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46075 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46084 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46088 */     GIR_RootConstrainSelectedInstOperands,
     /*  46089 */     // GIR_Coverage, 1849,
     /*  46089 */     GIR_EraseRootFromParent_Done,
     /*  46090 */   // Label 702: @46090
     /*  46090 */   GIM_Try, /*On fail goto*//*Label 703*/ GIMT_Encode4(46149), // Rule ID 1848 //
     /*  46095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  46119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46127 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  46134 */     // (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv2i32_v2i64),
     /*  46137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  46147 */     GIR_RootConstrainSelectedInstOperands,
     /*  46148 */     // GIR_Coverage, 1848,
     /*  46148 */     GIR_EraseRootFromParent_Done,
     /*  46149 */   // Label 703: @46149
     /*  46149 */   GIM_Try, /*On fail goto*//*Label 704*/ GIMT_Encode4(46184), // Rule ID 971 //
     /*  46154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46161 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  46167 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  46169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46175 */     // (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn)  =>  (NEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  46175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv2i64),
     /*  46178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  46182 */     GIR_RootConstrainSelectedInstOperands,
     /*  46183 */     // GIR_Coverage, 971,
     /*  46183 */     GIR_EraseRootFromParent_Done,
     /*  46184 */   // Label 704: @46184
     /*  46184 */   GIM_Try, /*On fail goto*//*Label 705*/ GIMT_Encode4(46241), // Rule ID 1734 //
     /*  46189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  46204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46217 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46224 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv2i32_v2i64),
     /*  46227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46239 */     GIR_RootConstrainSelectedInstOperands,
     /*  46240 */     // GIR_Coverage, 1734,
     /*  46240 */     GIR_EraseRootFromParent_Done,
     /*  46241 */   // Label 705: @46241
     /*  46241 */   GIM_Try, /*On fail goto*//*Label 706*/ GIMT_Encode4(46298), // Rule ID 1824 //
     /*  46246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  46261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  46269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46274 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46279 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46281 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv2i32_v2i64),
     /*  46284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  46288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  46292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  46296 */     GIR_RootConstrainSelectedInstOperands,
     /*  46297 */     // GIR_Coverage, 1824,
     /*  46297 */     GIR_EraseRootFromParent_Done,
     /*  46298 */   // Label 706: @46298
     /*  46298 */   GIM_Try, /*On fail goto*//*Label 707*/ GIMT_Encode4(46342), // Rule ID 1865 //
     /*  46303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46327 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46329 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46340 */     GIR_RootConstrainSelectedInstOperands,
     /*  46341 */     // GIR_Coverage, 1865,
     /*  46341 */     GIR_EraseRootFromParent_Done,
     /*  46342 */   // Label 707: @46342
     /*  46342 */   GIM_Try, /*On fail goto*//*Label 708*/ GIMT_Encode4(46386), // Rule ID 1764 //
     /*  46347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46366 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46371 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46373 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (SSUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv2i32_v2i64),
     /*  46376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46384 */     GIR_RootConstrainSelectedInstOperands,
     /*  46385 */     // GIR_Coverage, 1764,
     /*  46385 */     GIR_EraseRootFromParent_Done,
     /*  46386 */   // Label 708: @46386
     /*  46386 */   GIM_Try, /*On fail goto*//*Label 709*/ GIMT_Encode4(46430), // Rule ID 1864 //
     /*  46391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  46402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  46410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46415 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  46417 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm))  =>  (USUBWv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  46417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv2i32_v2i64),
     /*  46420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  46422 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  46424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  46428 */     GIR_RootConstrainSelectedInstOperands,
     /*  46429 */     // GIR_Coverage, 1864,
     /*  46429 */     GIR_EraseRootFromParent_Done,
     /*  46430 */   // Label 709: @46430
     /*  46430 */   GIM_Try, /*On fail goto*//*Label 710*/ GIMT_Encode4(46453), // Rule ID 1478 //
     /*  46435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  46438 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46446 */     // (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  46446 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv2i64),
     /*  46451 */     GIR_RootConstrainSelectedInstOperands,
     /*  46452 */     // GIR_Coverage, 1478,
     /*  46452 */     GIR_Done,
     /*  46453 */   // Label 710: @46453
     /*  46453 */   GIM_Reject,
     /*  46454 */ // Label 676: @46454
     /*  46454 */ GIM_Reject,
     /*  46455 */ // Label 594: @46455
     /*  46455 */ GIM_Try, /*On fail goto*//*Label 711*/ GIMT_Encode4(47945),
     /*  46460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  46463 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  46466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46470 */   GIM_Try, /*On fail goto*//*Label 712*/ GIMT_Encode4(46602), // Rule ID 5407 //
     /*  46475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46504 */     // MIs[1] Operand 2
     /*  46504 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46523 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46527 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46531 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46535 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46539 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46544 */     // MIs[3] Operand 2
     /*  46544 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46555 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46557 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46573 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46584 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46601 */     // GIR_Coverage, 5407,
     /*  46601 */     GIR_EraseRootFromParent_Done,
     /*  46602 */   // Label 712: @46602
     /*  46602 */   GIM_Try, /*On fail goto*//*Label 713*/ GIMT_Encode4(46734), // Rule ID 5406 //
     /*  46607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46615 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46631 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46636 */     // MIs[1] Operand 2
     /*  46636 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46667 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46671 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46676 */     // MIs[3] Operand 2
     /*  46676 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46687 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46689 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46689 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46692 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46696 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46701 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46705 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46716 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46733 */     // GIR_Coverage, 5406,
     /*  46733 */     GIR_EraseRootFromParent_Done,
     /*  46734 */   // Label 713: @46734
     /*  46734 */   GIM_Try, /*On fail goto*//*Label 714*/ GIMT_Encode4(46866), // Rule ID 5422 //
     /*  46739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46768 */     // MIs[1] Operand 2
     /*  46768 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46791 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46795 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  46799 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46803 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46808 */     // MIs[3] Operand 2
     /*  46808 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46819 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46821 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46821 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46824 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  46828 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46833 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46837 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46841 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46848 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46865 */     // GIR_Coverage, 5422,
     /*  46865 */     GIR_EraseRootFromParent_Done,
     /*  46866 */   // Label 714: @46866
     /*  46866 */   GIM_Try, /*On fail goto*//*Label 715*/ GIMT_Encode4(46998), // Rule ID 5405 //
     /*  46871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  46875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46883 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  46887 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  46891 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46895 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46900 */     // MIs[1] Operand 2
     /*  46900 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  46911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  46915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  46919 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  46923 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  46927 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  46931 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  46935 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46940 */     // MIs[3] Operand 2
     /*  46940 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  46951 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  46953 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  46953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  46956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  46960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  46965 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  46969 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  46973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  46975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  46978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  46980 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  46987 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  46992 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  46997 */     // GIR_Coverage, 5405,
     /*  46997 */     GIR_EraseRootFromParent_Done,
     /*  46998 */   // Label 715: @46998
     /*  46998 */   GIM_Try, /*On fail goto*//*Label 716*/ GIMT_Encode4(47130), // Rule ID 5404 //
     /*  47003 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47007 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47011 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47015 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47019 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47023 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47027 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47032 */     // MIs[1] Operand 2
     /*  47032 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  47047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47051 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47055 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  47059 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47063 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47067 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47072 */     // MIs[3] Operand 2
     /*  47072 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /*  47083 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  47085 */     // (sub:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47085 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47088 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  47092 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47097 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /*  47105 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47112 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47129 */     // GIR_Coverage, 5404,
     /*  47129 */     GIR_EraseRootFromParent_Done,
     /*  47130 */   // Label 716: @47130
     /*  47130 */   GIM_Try, /*On fail goto*//*Label 717*/ GIMT_Encode4(47289), // Rule ID 5377 //
     /*  47135 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47151 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47155 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_SMULL),
     /*  47159 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47163 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47167 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47177 */     // MIs[1] Operand 2
     /*  47177 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47190 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47190 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47193 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47197 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47202 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47204 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47207 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47211 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47216 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47223 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47226 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47231 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47236 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  47248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47264 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47271 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47278 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47283 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47288 */     // GIR_Coverage, 5377,
     /*  47288 */     GIR_EraseRootFromParent_Done,
     /*  47289 */   // Label 717: @47289
     /*  47289 */   GIM_Try, /*On fail goto*//*Label 718*/ GIMT_Encode4(47448), // Rule ID 5374 //
     /*  47294 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47302 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47306 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UMULL),
     /*  47318 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47322 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  47326 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47336 */     // MIs[1] Operand 2
     /*  47336 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47349 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Ra, (extract_subvector:{ *:[v4i16] } (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (UMLSLv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Ra, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47349 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47352 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47356 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47363 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47366 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47370 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47375 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47378 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ra
     /*  47382 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47385 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47390 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47395 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47400 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47403 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  47407 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47412 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47415 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  47419 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  47423 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47430 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47447 */     // GIR_Coverage, 5374,
     /*  47447 */     GIR_EraseRootFromParent_Done,
     /*  47448 */   // Label 718: @47448
     /*  47448 */   GIM_Try, /*On fail goto*//*Label 719*/ GIMT_Encode4(47594), // Rule ID 5417 //
     /*  47453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  47477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47481 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47486 */     // MIs[1] Operand 2
     /*  47486 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47497 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47499 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47499 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47502 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47506 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47511 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47513 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47516 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47520 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47525 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47528 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47532 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47535 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47540 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47545 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47565 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47569 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47576 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47583 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47588 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47593 */     // GIR_Coverage, 5417,
     /*  47593 */     GIR_EraseRootFromParent_Done,
     /*  47594 */   // Label 719: @47594
     /*  47594 */   GIM_Try, /*On fail goto*//*Label 720*/ GIMT_Encode4(47740), // Rule ID 5425 //
     /*  47599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47603 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47607 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47611 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  47623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47627 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47632 */     // MIs[1] Operand 2
     /*  47632 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47643 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47645 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (SSUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47645 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47648 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47652 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47671 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47674 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47681 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47686 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47691 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  47703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47708 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47711 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47722 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47739 */     // GIR_Coverage, 5425,
     /*  47739 */     GIR_EraseRootFromParent_Done,
     /*  47740 */   // Label 720: @47740
     /*  47740 */   GIM_Try, /*On fail goto*//*Label 721*/ GIMT_Encode4(47886), // Rule ID 5416 //
     /*  47745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  47761 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  47765 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  47769 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  47773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47778 */     // MIs[1] Operand 2
     /*  47778 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  47789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  47791 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (USUBWv8i8_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V64:{ *:[v8i8] }:$Rm), dsub:{ *:[i32] })
     /*  47791 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /*  47794 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  47798 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47803 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  47805 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /*  47808 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  47812 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47817 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /*  47820 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  47824 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /*  47827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47832 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47837 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47842 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /*  47845 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  47849 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  47854 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  47857 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  47861 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  47863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  47866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  47868 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /*  47875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47885 */     // GIR_Coverage, 5416,
     /*  47885 */     GIR_EraseRootFromParent_Done,
     /*  47886 */   // Label 721: @47886
     /*  47886 */   GIM_Try, /*On fail goto*//*Label 722*/ GIMT_Encode4(47921), // Rule ID 967 //
     /*  47891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  47898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  47904 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  47906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  47912 */     // (sub:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn)  =>  (NEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  47912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i16),
     /*  47915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  47917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  47919 */     GIR_RootConstrainSelectedInstOperands,
     /*  47920 */     // GIR_Coverage, 967,
     /*  47920 */     GIR_EraseRootFromParent_Done,
     /*  47921 */   // Label 722: @47921
     /*  47921 */   GIM_Try, /*On fail goto*//*Label 723*/ GIMT_Encode4(47944), // Rule ID 1474 //
     /*  47926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  47937 */     // (sub:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  47937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i16),
     /*  47942 */     GIR_RootConstrainSelectedInstOperands,
     /*  47943 */     // GIR_Coverage, 1474,
     /*  47943 */     GIR_Done,
     /*  47944 */   // Label 723: @47944
     /*  47944 */   GIM_Reject,
     /*  47945 */ // Label 711: @47945
     /*  47945 */ GIM_Reject,
     /*  47946 */ // Label 595: @47946
     /*  47946 */ GIM_Try, /*On fail goto*//*Label 724*/ GIMT_Encode4(50405),
     /*  47951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  47954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  47957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47961 */   GIM_Try, /*On fail goto*//*Label 725*/ GIMT_Encode4(48075), // Rule ID 2045 //
     /*  47966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  47969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  47973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  47977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  47981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  47985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  47989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  47993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  47997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48009 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48013 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48017 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48022 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48026 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48030 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48034 */     // MIs[4] Operand 1
     /*  48034 */     // No operand predicates
     /*  48034 */     // MIs[2] Operand 2
     /*  48034 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48045 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48047 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48054 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48061 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48073 */     GIR_RootConstrainSelectedInstOperands,
     /*  48074 */     // GIR_Coverage, 2045,
     /*  48074 */     GIR_EraseRootFromParent_Done,
     /*  48075 */   // Label 725: @48075
     /*  48075 */   GIM_Try, /*On fail goto*//*Label 726*/ GIMT_Encode4(48189), // Rule ID 13571 //
     /*  48080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48136 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48140 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48144 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48148 */     // MIs[4] Operand 1
     /*  48148 */     // No operand predicates
     /*  48148 */     // MIs[2] Operand 2
     /*  48148 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48159 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48161 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48168 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (SMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_indexed),
     /*  48171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48184 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48187 */     GIR_RootConstrainSelectedInstOperands,
     /*  48188 */     // GIR_Coverage, 13571,
     /*  48188 */     GIR_EraseRootFromParent_Done,
     /*  48189 */   // Label 726: @48189
     /*  48189 */   GIM_Try, /*On fail goto*//*Label 727*/ GIMT_Encode4(48303), // Rule ID 2097 //
     /*  48194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48197 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48229 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48233 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48237 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48241 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48245 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48250 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48254 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48258 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48262 */     // MIs[4] Operand 1
     /*  48262 */     // No operand predicates
     /*  48262 */     // MIs[2] Operand 2
     /*  48262 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48273 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48275 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48282 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48301 */     GIR_RootConstrainSelectedInstOperands,
     /*  48302 */     // GIR_Coverage, 2097,
     /*  48302 */     GIR_EraseRootFromParent_Done,
     /*  48303 */   // Label 727: @48303
     /*  48303 */   GIM_Try, /*On fail goto*//*Label 728*/ GIMT_Encode4(48417), // Rule ID 13607 //
     /*  48308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48343 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48347 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48351 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48355 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48359 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48364 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48368 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48372 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48376 */     // MIs[4] Operand 1
     /*  48376 */     // No operand predicates
     /*  48376 */     // MIs[2] Operand 2
     /*  48376 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /*  48387 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48389 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48396 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)))  =>  (UMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_indexed),
     /*  48399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48408 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48412 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48415 */     GIR_RootConstrainSelectedInstOperands,
     /*  48416 */     // GIR_Coverage, 13607,
     /*  48416 */     GIR_EraseRootFromParent_Done,
     /*  48417 */   // Label 728: @48417
     /*  48417 */   GIM_Try, /*On fail goto*//*Label 729*/ GIMT_Encode4(48482), // Rule ID 1847 //
     /*  48422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48437 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48441 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48445 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48449 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48451 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48458 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48465 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48470 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48475 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48480 */     GIR_RootConstrainSelectedInstOperands,
     /*  48481 */     // GIR_Coverage, 1847,
     /*  48481 */     GIR_EraseRootFromParent_Done,
     /*  48482 */   // Label 729: @48482
     /*  48482 */   GIM_Try, /*On fail goto*//*Label 730*/ GIMT_Encode4(48547), // Rule ID 1846 //
     /*  48487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48514 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48516 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48523 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48530 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48540 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48545 */     GIR_RootConstrainSelectedInstOperands,
     /*  48546 */     // GIR_Coverage, 1846,
     /*  48546 */     GIR_EraseRootFromParent_Done,
     /*  48547 */   // Label 730: @48547
     /*  48547 */   GIM_Try, /*On fail goto*//*Label 731*/ GIMT_Encode4(48612), // Rule ID 1757 //
     /*  48552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48563 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  48575 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48579 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48581 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48588 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48595 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i16_v4i32),
     /*  48598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48600 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48610 */     GIR_RootConstrainSelectedInstOperands,
     /*  48611 */     // GIR_Coverage, 1757,
     /*  48611 */     GIR_EraseRootFromParent_Done,
     /*  48612 */   // Label 731: @48612
     /*  48612 */   GIM_Try, /*On fail goto*//*Label 732*/ GIMT_Encode4(48677), // Rule ID 1845 //
     /*  48617 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48620 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48624 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48628 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48632 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48636 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  48640 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48644 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48646 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48653 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48660 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48665 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48675 */     GIR_RootConstrainSelectedInstOperands,
     /*  48676 */     // GIR_Coverage, 1845,
     /*  48676 */     GIR_EraseRootFromParent_Done,
     /*  48677 */   // Label 732: @48677
     /*  48677 */   GIM_Try, /*On fail goto*//*Label 733*/ GIMT_Encode4(48742), // Rule ID 1844 //
     /*  48682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  48689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  48701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  48705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  48711 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48718 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  48725 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  48725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i16_v4i32),
     /*  48728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  48730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  48735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  48740 */     GIR_RootConstrainSelectedInstOperands,
     /*  48741 */     // GIR_Coverage, 1844,
     /*  48741 */     GIR_EraseRootFromParent_Done,
     /*  48742 */   // Label 733: @48742
     /*  48742 */   GIM_Try, /*On fail goto*//*Label 734*/ GIMT_Encode4(48853), // Rule ID 13569 //
     /*  48747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48750 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48766 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48782 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48786 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48790 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48794 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48798 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48803 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48807 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48811 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48815 */     // MIs[4] Operand 1
     /*  48815 */     // No operand predicates
     /*  48815 */     // MIs[2] Operand 2
     /*  48815 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48831 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48833 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  48844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48848 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48851 */     GIR_RootConstrainSelectedInstOperands,
     /*  48852 */     // GIR_Coverage, 13569,
     /*  48852 */     GIR_EraseRootFromParent_Done,
     /*  48853 */   // Label 734: @48853
     /*  48853 */   GIM_Try, /*On fail goto*//*Label 735*/ GIMT_Encode4(48964), // Rule ID 2043 //
     /*  48858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  48873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48877 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48881 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  48886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  48890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  48894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  48902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  48906 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  48910 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  48914 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  48919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  48923 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  48927 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  48931 */     // MIs[4] Operand 1
     /*  48931 */     // No operand predicates
     /*  48931 */     // MIs[2] Operand 2
     /*  48931 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  48942 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  48944 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  48944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  48947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  48949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  48951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  48955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  48959 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  48962 */     GIR_RootConstrainSelectedInstOperands,
     /*  48963 */     // GIR_Coverage, 2043,
     /*  48963 */     GIR_EraseRootFromParent_Done,
     /*  48964 */   // Label 735: @48964
     /*  48964 */   GIM_Try, /*On fail goto*//*Label 736*/ GIMT_Encode4(49075), // Rule ID 13605 //
     /*  48969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  48972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  48976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  48980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  48984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  48988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  48992 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  48996 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49000 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49004 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49008 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49012 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49016 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49020 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49025 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49029 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49033 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49037 */     // MIs[4] Operand 1
     /*  49037 */     // No operand predicates
     /*  49037 */     // MIs[2] Operand 2
     /*  49037 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49048 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49055 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49060 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49066 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49073 */     GIR_RootConstrainSelectedInstOperands,
     /*  49074 */     // GIR_Coverage, 13605,
     /*  49074 */     GIR_EraseRootFromParent_Done,
     /*  49075 */   // Label 736: @49075
     /*  49075 */   GIM_Try, /*On fail goto*//*Label 737*/ GIMT_Encode4(49186), // Rule ID 2095 //
     /*  49080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49103 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49108 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49112 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  49116 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49120 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  49124 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49128 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49132 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  49136 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49141 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  49145 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49149 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49153 */     // MIs[4] Operand 1
     /*  49153 */     // No operand predicates
     /*  49153 */     // MIs[2] Operand 2
     /*  49153 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /*  49164 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  49166 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49171 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /*  49181 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /*  49184 */     GIR_RootConstrainSelectedInstOperands,
     /*  49185 */     // GIR_Coverage, 2095,
     /*  49185 */     GIR_EraseRootFromParent_Done,
     /*  49186 */   // Label 737: @49186
     /*  49186 */   GIM_Try, /*On fail goto*//*Label 738*/ GIMT_Encode4(49249), // Rule ID 1733 //
     /*  49191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49210 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49216 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49223 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49230 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i16_v4i32),
     /*  49233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49235 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49242 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49247 */     GIR_RootConstrainSelectedInstOperands,
     /*  49248 */     // GIR_Coverage, 1733,
     /*  49248 */     GIR_EraseRootFromParent_Done,
     /*  49249 */   // Label 738: @49249
     /*  49249 */   GIM_Try, /*On fail goto*//*Label 739*/ GIMT_Encode4(49312), // Rule ID 1823 //
     /*  49254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49273 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49277 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49279 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49286 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49293 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i16_v4i32),
     /*  49296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49300 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  49305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  49310 */     GIR_RootConstrainSelectedInstOperands,
     /*  49311 */     // GIR_Coverage, 1823,
     /*  49311 */     GIR_EraseRootFromParent_Done,
     /*  49312 */   // Label 739: @49312
     /*  49312 */   GIM_Try, /*On fail goto*//*Label 740*/ GIMT_Encode4(49400), // Rule ID 13570 //
     /*  49317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49324 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49328 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49332 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49336 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49340 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49344 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49348 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49352 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49369 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49373 */     // MIs[3] Operand 1
     /*  49373 */     // No operand predicates
     /*  49373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49378 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49380 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49398 */     GIR_RootConstrainSelectedInstOperands,
     /*  49399 */     // GIR_Coverage, 13570,
     /*  49399 */     GIR_EraseRootFromParent_Done,
     /*  49400 */   // Label 740: @49400
     /*  49400 */   GIM_Try, /*On fail goto*//*Label 741*/ GIMT_Encode4(49488), // Rule ID 2044 //
     /*  49405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49408 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49416 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  49420 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49424 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49441 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49445 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49449 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49454 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49458 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49462 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49466 */     // MIs[3] Operand 1
     /*  49466 */     // No operand predicates
     /*  49466 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49468 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_indexed),
     /*  49471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49483 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49486 */     GIR_RootConstrainSelectedInstOperands,
     /*  49487 */     // GIR_Coverage, 2044,
     /*  49487 */     GIR_EraseRootFromParent_Done,
     /*  49488 */   // Label 741: @49488
     /*  49488 */   GIM_Try, /*On fail goto*//*Label 742*/ GIMT_Encode4(49576), // Rule ID 13606 //
     /*  49493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  49520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49528 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49532 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49541 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49545 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49549 */     // MIs[3] Operand 1
     /*  49549 */     // No operand predicates
     /*  49549 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49554 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49556 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49561 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  49567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49571 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49574 */     GIR_RootConstrainSelectedInstOperands,
     /*  49575 */     // GIR_Coverage, 13606,
     /*  49575 */     GIR_EraseRootFromParent_Done,
     /*  49576 */   // Label 742: @49576
     /*  49576 */   GIM_Try, /*On fail goto*//*Label 743*/ GIMT_Encode4(49664), // Rule ID 2096 //
     /*  49581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  49596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  49604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  49613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  49617 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  49621 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  49625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  49630 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  49634 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  49638 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  49642 */     // MIs[3] Operand 1
     /*  49642 */     // No operand predicates
     /*  49642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  49644 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (UMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  49644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_indexed),
     /*  49647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  49649 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  49651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  49662 */     GIR_RootConstrainSelectedInstOperands,
     /*  49663 */     // GIR_Coverage, 2096,
     /*  49663 */     GIR_EraseRootFromParent_Done,
     /*  49664 */   // Label 743: @49664
     /*  49664 */   GIM_Try, /*On fail goto*//*Label 744*/ GIMT_Encode4(49711), // Rule ID 1863 //
     /*  49669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49688 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49690 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49697 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49709 */     GIR_RootConstrainSelectedInstOperands,
     /*  49710 */     // GIR_Coverage, 1863,
     /*  49710 */     GIR_EraseRootFromParent_Done,
     /*  49711 */   // Label 744: @49711
     /*  49711 */   GIM_Try, /*On fail goto*//*Label 745*/ GIMT_Encode4(49758), // Rule ID 1763 //
     /*  49716 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49735 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49737 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49744 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SSUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i16_v4i32),
     /*  49747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49749 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49751 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49756 */     GIR_RootConstrainSelectedInstOperands,
     /*  49757 */     // GIR_Coverage, 1763,
     /*  49757 */     GIR_EraseRootFromParent_Done,
     /*  49758 */   // Label 745: @49758
     /*  49758 */   GIM_Try, /*On fail goto*//*Label 746*/ GIMT_Encode4(49805), // Rule ID 1862 //
     /*  49763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49766 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  49770 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  49774 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49778 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49782 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  49784 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /*  49791 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (USUBWv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  49791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i16_v4i32),
     /*  49794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  49798 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  49803 */     GIR_RootConstrainSelectedInstOperands,
     /*  49804 */     // GIR_Coverage, 1862,
     /*  49804 */     GIR_EraseRootFromParent_Done,
     /*  49805 */   // Label 746: @49805
     /*  49805 */   GIM_Try, /*On fail goto*//*Label 747*/ GIMT_Encode4(49864), // Rule ID 1843 //
     /*  49810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49825 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49842 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49849 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49862 */     GIR_RootConstrainSelectedInstOperands,
     /*  49863 */     // GIR_Coverage, 1843,
     /*  49863 */     GIR_EraseRootFromParent_Done,
     /*  49864 */   // Label 747: @49864
     /*  49864 */   GIM_Try, /*On fail goto*//*Label 748*/ GIMT_Encode4(49923), // Rule ID 1842 //
     /*  49869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  49880 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49901 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49908 */     // (sub:{ *:[v4i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  49911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49913 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49921 */     GIR_RootConstrainSelectedInstOperands,
     /*  49922 */     // GIR_Coverage, 1842,
     /*  49922 */     GIR_EraseRootFromParent_Done,
     /*  49923 */   // Label 748: @49923
     /*  49923 */   GIM_Try, /*On fail goto*//*Label 749*/ GIMT_Encode4(49982), // Rule ID 1756 //
     /*  49928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49943 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  49952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  49956 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  49960 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  49965 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  49967 */     // (sub:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  49967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv4i16_v4i32),
     /*  49970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  49972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  49976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  49980 */     GIR_RootConstrainSelectedInstOperands,
     /*  49981 */     // GIR_Coverage, 1756,
     /*  49981 */     GIR_EraseRootFromParent_Done,
     /*  49982 */   // Label 749: @49982
     /*  49982 */   GIM_Try, /*On fail goto*//*Label 750*/ GIMT_Encode4(50041), // Rule ID 1841 //
     /*  49987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  49990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  49994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  49998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50019 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50024 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50026 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50039 */     GIR_RootConstrainSelectedInstOperands,
     /*  50040 */     // GIR_Coverage, 1841,
     /*  50040 */     GIR_EraseRootFromParent_Done,
     /*  50041 */   // Label 750: @50041
     /*  50041 */   GIM_Try, /*On fail goto*//*Label 751*/ GIMT_Encode4(50100), // Rule ID 1840 //
     /*  50046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50061 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50066 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50070 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50074 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50078 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50083 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50085 */     // (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv4i16_v4i32),
     /*  50088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50090 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  50098 */     GIR_RootConstrainSelectedInstOperands,
     /*  50099 */     // GIR_Coverage, 1840,
     /*  50099 */     GIR_EraseRootFromParent_Done,
     /*  50100 */   // Label 751: @50100
     /*  50100 */   GIM_Try, /*On fail goto*//*Label 752*/ GIMT_Encode4(50135), // Rule ID 970 //
     /*  50105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50112 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50118 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50124 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50126 */     // (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn)  =>  (NEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  50126 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv4i32),
     /*  50129 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50131 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50133 */     GIR_RootConstrainSelectedInstOperands,
     /*  50134 */     // GIR_Coverage, 970,
     /*  50134 */     GIR_EraseRootFromParent_Done,
     /*  50135 */   // Label 752: @50135
     /*  50135 */   GIM_Try, /*On fail goto*//*Label 753*/ GIMT_Encode4(50192), // Rule ID 1732 //
     /*  50140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50143 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50163 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50175 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv4i16_v4i32),
     /*  50178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50190 */     GIR_RootConstrainSelectedInstOperands,
     /*  50191 */     // GIR_Coverage, 1732,
     /*  50191 */     GIR_EraseRootFromParent_Done,
     /*  50192 */   // Label 753: @50192
     /*  50192 */   GIM_Try, /*On fail goto*//*Label 754*/ GIMT_Encode4(50249), // Rule ID 1822 //
     /*  50197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50200 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  50220 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50230 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50232 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv4i16_v4i32),
     /*  50235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  50243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  50247 */     GIR_RootConstrainSelectedInstOperands,
     /*  50248 */     // GIR_Coverage, 1822,
     /*  50248 */     GIR_EraseRootFromParent_Done,
     /*  50249 */   // Label 754: @50249
     /*  50249 */   GIM_Try, /*On fail goto*//*Label 755*/ GIMT_Encode4(50293), // Rule ID 1861 //
     /*  50254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50257 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50273 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50280 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50291 */     GIR_RootConstrainSelectedInstOperands,
     /*  50292 */     // GIR_Coverage, 1861,
     /*  50292 */     GIR_EraseRootFromParent_Done,
     /*  50293 */   // Label 755: @50293
     /*  50293 */   GIM_Try, /*On fail goto*//*Label 756*/ GIMT_Encode4(50337), // Rule ID 1762 //
     /*  50298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50317 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50322 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50324 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (SSUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv4i16_v4i32),
     /*  50327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50329 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50335 */     GIR_RootConstrainSelectedInstOperands,
     /*  50336 */     // GIR_Coverage, 1762,
     /*  50336 */     GIR_EraseRootFromParent_Done,
     /*  50337 */   // Label 756: @50337
     /*  50337 */   GIM_Try, /*On fail goto*//*Label 757*/ GIMT_Encode4(50381), // Rule ID 1860 //
     /*  50342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50353 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50357 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  50361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50368 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm))  =>  (USUBWv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  50368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv4i16_v4i32),
     /*  50371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  50379 */     GIR_RootConstrainSelectedInstOperands,
     /*  50380 */     // GIR_Coverage, 1860,
     /*  50380 */     GIR_EraseRootFromParent_Done,
     /*  50381 */   // Label 757: @50381
     /*  50381 */   GIM_Try, /*On fail goto*//*Label 758*/ GIMT_Encode4(50404), // Rule ID 1477 //
     /*  50386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50397 */     // (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  50397 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv4i32),
     /*  50402 */     GIR_RootConstrainSelectedInstOperands,
     /*  50403 */     // GIR_Coverage, 1477,
     /*  50403 */     GIR_Done,
     /*  50404 */   // Label 758: @50404
     /*  50404 */   GIM_Reject,
     /*  50405 */ // Label 724: @50405
     /*  50405 */ GIM_Reject,
     /*  50406 */ // Label 596: @50406
     /*  50406 */ GIM_Try, /*On fail goto*//*Label 759*/ GIMT_Encode4(50480),
     /*  50411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50417 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50421 */   GIM_Try, /*On fail goto*//*Label 760*/ GIMT_Encode4(50456), // Rule ID 965 //
     /*  50426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  50439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  50441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50445 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50447 */     // (sub:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn)  =>  (NEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  50447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i8),
     /*  50450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  50454 */     GIR_RootConstrainSelectedInstOperands,
     /*  50455 */     // GIR_Coverage, 965,
     /*  50455 */     GIR_EraseRootFromParent_Done,
     /*  50456 */   // Label 760: @50456
     /*  50456 */   GIM_Try, /*On fail goto*//*Label 761*/ GIMT_Encode4(50479), // Rule ID 1472 //
     /*  50461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  50472 */     // (sub:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  50472 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i8),
     /*  50477 */     GIR_RootConstrainSelectedInstOperands,
     /*  50478 */     // GIR_Coverage, 1472,
     /*  50478 */     GIR_Done,
     /*  50479 */   // Label 761: @50479
     /*  50479 */   GIM_Reject,
     /*  50480 */ // Label 759: @50480
     /*  50480 */ GIM_Reject,
     /*  50481 */ // Label 597: @50481
     /*  50481 */ GIM_Try, /*On fail goto*//*Label 762*/ GIMT_Encode4(51688),
     /*  50486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  50489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  50492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50496 */   GIM_Try, /*On fail goto*//*Label 763*/ GIMT_Encode4(50561), // Rule ID 1839 //
     /*  50501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50524 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50528 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50537 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50544 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50549 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50559 */     GIR_RootConstrainSelectedInstOperands,
     /*  50560 */     // GIR_Coverage, 1839,
     /*  50560 */     GIR_EraseRootFromParent_Done,
     /*  50561 */   // Label 763: @50561
     /*  50561 */   GIM_Try, /*On fail goto*//*Label 764*/ GIMT_Encode4(50626), // Rule ID 1838 //
     /*  50566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50595 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50602 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50609 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50624 */     GIR_RootConstrainSelectedInstOperands,
     /*  50625 */     // GIR_Coverage, 1838,
     /*  50625 */     GIR_EraseRootFromParent_Done,
     /*  50626 */   // Label 764: @50626
     /*  50626 */   GIM_Try, /*On fail goto*//*Label 765*/ GIMT_Encode4(50691), // Rule ID 1755 //
     /*  50631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50642 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  50654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50660 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50674 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv16i8_v8i16),
     /*  50677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50689 */     GIR_RootConstrainSelectedInstOperands,
     /*  50690 */     // GIR_Coverage, 1755,
     /*  50690 */     GIR_EraseRootFromParent_Done,
     /*  50691 */   // Label 765: @50691
     /*  50691 */   GIM_Try, /*On fail goto*//*Label 766*/ GIMT_Encode4(50756), // Rule ID 1837 //
     /*  50696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50723 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50725 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50732 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50739 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50749 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50754 */     GIR_RootConstrainSelectedInstOperands,
     /*  50755 */     // GIR_Coverage, 1837,
     /*  50755 */     GIR_EraseRootFromParent_Done,
     /*  50756 */   // Label 766: @50756
     /*  50756 */   GIM_Try, /*On fail goto*//*Label 767*/ GIMT_Encode4(50821), // Rule ID 1836 //
     /*  50761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  50768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50776 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  50780 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  50784 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50788 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  50790 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50797 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50804 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv16i8_v8i16),
     /*  50807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50819 */     GIR_RootConstrainSelectedInstOperands,
     /*  50820 */     // GIR_Coverage, 1836,
     /*  50820 */     GIR_EraseRootFromParent_Done,
     /*  50821 */   // Label 767: @50821
     /*  50821 */   GIM_Try, /*On fail goto*//*Label 768*/ GIMT_Encode4(50884), // Rule ID 1731 //
     /*  50826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50833 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50837 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  50841 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50845 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50849 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50851 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50858 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50865 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv16i8_v8i16),
     /*  50868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50882 */     GIR_RootConstrainSelectedInstOperands,
     /*  50883 */     // GIR_Coverage, 1731,
     /*  50883 */     GIR_EraseRootFromParent_Done,
     /*  50884 */   // Label 768: @50884
     /*  50884 */   GIM_Try, /*On fail goto*//*Label 769*/ GIMT_Encode4(50947), // Rule ID 1821 //
     /*  50889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  50904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  50912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50914 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50921 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50928 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UMLSLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv16i8_v8i16),
     /*  50931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  50933 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  50935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  50940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  50945 */     GIR_RootConstrainSelectedInstOperands,
     /*  50946 */     // GIR_Coverage, 1821,
     /*  50946 */     GIR_EraseRootFromParent_Done,
     /*  50947 */   // Label 769: @50947
     /*  50947 */   GIM_Try, /*On fail goto*//*Label 770*/ GIMT_Encode4(50994), // Rule ID 1859 //
     /*  50952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  50955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  50959 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  50963 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  50967 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  50971 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  50973 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  50980 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  50980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  50983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  50985 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  50987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  50992 */     GIR_RootConstrainSelectedInstOperands,
     /*  50993 */     // GIR_Coverage, 1859,
     /*  50993 */     GIR_EraseRootFromParent_Done,
     /*  50994 */   // Label 770: @50994
     /*  50994 */   GIM_Try, /*On fail goto*//*Label 771*/ GIMT_Encode4(51041), // Rule ID 1761 //
     /*  50999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51018 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51020 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51027 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SSUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv16i8_v8i16),
     /*  51030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51034 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51039 */     GIR_RootConstrainSelectedInstOperands,
     /*  51040 */     // GIR_Coverage, 1761,
     /*  51040 */     GIR_EraseRootFromParent_Done,
     /*  51041 */   // Label 771: @51041
     /*  51041 */   GIM_Try, /*On fail goto*//*Label 772*/ GIMT_Encode4(51088), // Rule ID 1858 //
     /*  51046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51049 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51065 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51067 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /*  51074 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (USUBWv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv16i8_v8i16),
     /*  51077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rm
     /*  51086 */     GIR_RootConstrainSelectedInstOperands,
     /*  51087 */     // GIR_Coverage, 1858,
     /*  51087 */     GIR_EraseRootFromParent_Done,
     /*  51088 */   // Label 772: @51088
     /*  51088 */   GIM_Try, /*On fail goto*//*Label 773*/ GIMT_Encode4(51147), // Rule ID 1835 //
     /*  51093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51121 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51125 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51132 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51141 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51145 */     GIR_RootConstrainSelectedInstOperands,
     /*  51146 */     // GIR_Coverage, 1835,
     /*  51146 */     GIR_EraseRootFromParent_Done,
     /*  51147 */   // Label 773: @51147
     /*  51147 */   GIM_Try, /*On fail goto*//*Label 774*/ GIMT_Encode4(51206), // Rule ID 1834 //
     /*  51152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51172 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51176 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51180 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51184 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51189 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51191 */     // (sub:{ *:[v8i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51196 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51200 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51204 */     GIR_RootConstrainSelectedInstOperands,
     /*  51205 */     // GIR_Coverage, 1834,
     /*  51205 */     GIR_EraseRootFromParent_Done,
     /*  51206 */   // Label 774: @51206
     /*  51206 */   GIM_Try, /*On fail goto*//*Label 775*/ GIMT_Encode4(51265), // Rule ID 1754 //
     /*  51211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51222 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51226 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51231 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51235 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51239 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51243 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51250 */     // (sub:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLv8i8_v8i16),
     /*  51253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51263 */     GIR_RootConstrainSelectedInstOperands,
     /*  51264 */     // GIR_Coverage, 1754,
     /*  51264 */     GIR_EraseRootFromParent_Done,
     /*  51265 */   // Label 775: @51265
     /*  51265 */   GIM_Try, /*On fail goto*//*Label 776*/ GIMT_Encode4(51324), // Rule ID 1833 //
     /*  51270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51273 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51277 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51281 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51290 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51294 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51298 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51302 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51309 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51322 */     GIR_RootConstrainSelectedInstOperands,
     /*  51323 */     // GIR_Coverage, 1833,
     /*  51323 */     GIR_EraseRootFromParent_Done,
     /*  51324 */   // Label 776: @51324
     /*  51324 */   GIM_Try, /*On fail goto*//*Label 777*/ GIMT_Encode4(51383), // Rule ID 1832 //
     /*  51329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51332 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51336 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51340 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51344 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  51353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51361 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  51368 */     // (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLv8i8_v8i16),
     /*  51371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  51381 */     GIR_RootConstrainSelectedInstOperands,
     /*  51382 */     // GIR_Coverage, 1832,
     /*  51382 */     GIR_EraseRootFromParent_Done,
     /*  51383 */   // Label 777: @51383
     /*  51383 */   GIM_Try, /*On fail goto*//*Label 778*/ GIMT_Encode4(51418), // Rule ID 968 //
     /*  51388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51391 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51395 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51401 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51403 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51407 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51409 */     // (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn)  =>  (NEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  51409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv8i16),
     /*  51412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51416 */     GIR_RootConstrainSelectedInstOperands,
     /*  51417 */     // GIR_Coverage, 968,
     /*  51417 */     GIR_EraseRootFromParent_Done,
     /*  51418 */   // Label 778: @51418
     /*  51418 */   GIM_Try, /*On fail goto*//*Label 779*/ GIMT_Encode4(51475), // Rule ID 1730 //
     /*  51423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51430 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51434 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SMULL),
     /*  51438 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51442 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51451 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51456 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51458 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLv8i8_v8i16),
     /*  51461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51473 */     GIR_RootConstrainSelectedInstOperands,
     /*  51474 */     // GIR_Coverage, 1730,
     /*  51474 */     GIR_EraseRootFromParent_Done,
     /*  51475 */   // Label 779: @51475
     /*  51475 */   GIM_Try, /*On fail goto*//*Label 780*/ GIMT_Encode4(51532), // Rule ID 1820 //
     /*  51480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UMULL),
     /*  51495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  51503 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51508 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51515 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UMLSLv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLv8i8_v8i16),
     /*  51518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  51520 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  51522 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  51526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  51530 */     GIR_RootConstrainSelectedInstOperands,
     /*  51531 */     // GIR_Coverage, 1820,
     /*  51531 */     GIR_EraseRootFromParent_Done,
     /*  51532 */   // Label 780: @51532
     /*  51532 */   GIM_Try, /*On fail goto*//*Label 781*/ GIMT_Encode4(51576), // Rule ID 1857 //
     /*  51537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51540 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  51552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51563 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51574 */     GIR_RootConstrainSelectedInstOperands,
     /*  51575 */     // GIR_Coverage, 1857,
     /*  51575 */     GIR_EraseRootFromParent_Done,
     /*  51576 */   // Label 781: @51576
     /*  51576 */   GIM_Try, /*On fail goto*//*Label 782*/ GIMT_Encode4(51620), // Rule ID 1760 //
     /*  51581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  51596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51607 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (SSUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWv8i8_v8i16),
     /*  51610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51618 */     GIR_RootConstrainSelectedInstOperands,
     /*  51619 */     // GIR_Coverage, 1760,
     /*  51619 */     GIR_EraseRootFromParent_Done,
     /*  51620 */   // Label 782: @51620
     /*  51620 */   GIM_Try, /*On fail goto*//*Label 783*/ GIMT_Encode4(51664), // Rule ID 1856 //
     /*  51625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  51636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  51640 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  51644 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  51649 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51651 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm))  =>  (USUBWv8i8_v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  51651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWv8i8_v8i16),
     /*  51654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  51658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  51662 */     GIR_RootConstrainSelectedInstOperands,
     /*  51663 */     // GIR_Coverage, 1856,
     /*  51663 */     GIR_EraseRootFromParent_Done,
     /*  51664 */   // Label 783: @51664
     /*  51664 */   GIM_Try, /*On fail goto*//*Label 784*/ GIMT_Encode4(51687), // Rule ID 1475 //
     /*  51669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51680 */     // (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  51680 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv8i16),
     /*  51685 */     GIR_RootConstrainSelectedInstOperands,
     /*  51686 */     // GIR_Coverage, 1475,
     /*  51686 */     GIR_Done,
     /*  51687 */   // Label 784: @51687
     /*  51687 */   GIM_Reject,
     /*  51688 */ // Label 762: @51688
     /*  51688 */ GIM_Reject,
     /*  51689 */ // Label 598: @51689
     /*  51689 */ GIM_Try, /*On fail goto*//*Label 785*/ GIMT_Encode4(51763),
     /*  51694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  51697 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  51700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51704 */   GIM_Try, /*On fail goto*//*Label 786*/ GIMT_Encode4(51739), // Rule ID 966 //
     /*  51709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51716 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  51722 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  51724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51728 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51730 */     // (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn)  =>  (NEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  51730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NEGv16i8),
     /*  51733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  51737 */     GIR_RootConstrainSelectedInstOperands,
     /*  51738 */     // GIR_Coverage, 966,
     /*  51738 */     GIR_EraseRootFromParent_Done,
     /*  51739 */   // Label 786: @51739
     /*  51739 */   GIM_Try, /*On fail goto*//*Label 787*/ GIMT_Encode4(51762), // Rule ID 1473 //
     /*  51744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  51747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  51755 */     // (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  51755 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUBv16i8),
     /*  51760 */     GIR_RootConstrainSelectedInstOperands,
     /*  51761 */     // GIR_Coverage, 1473,
     /*  51761 */     GIR_Done,
     /*  51762 */   // Label 787: @51762
     /*  51762 */   GIM_Reject,
     /*  51763 */ // Label 785: @51763
     /*  51763 */ GIM_Reject,
     /*  51764 */ // Label 599: @51764
     /*  51764 */ GIM_Try, /*On fail goto*//*Label 788*/ GIMT_Encode4(51789), // Rule ID 7489 //
     /*  51769 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51772 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  51775 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  51778 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51782 */   // (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  51782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_D),
     /*  51787 */   GIR_RootConstrainSelectedInstOperands,
     /*  51788 */   // GIR_Coverage, 7489,
     /*  51788 */   GIR_Done,
     /*  51789 */ // Label 788: @51789
     /*  51789 */ GIM_Reject,
     /*  51790 */ // Label 600: @51790
     /*  51790 */ GIM_Try, /*On fail goto*//*Label 789*/ GIMT_Encode4(51815), // Rule ID 7488 //
     /*  51795 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51798 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  51801 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  51804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51808 */   // (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  51808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_S),
     /*  51813 */   GIR_RootConstrainSelectedInstOperands,
     /*  51814 */   // GIR_Coverage, 7488,
     /*  51814 */   GIR_Done,
     /*  51815 */ // Label 789: @51815
     /*  51815 */ GIM_Reject,
     /*  51816 */ // Label 601: @51816
     /*  51816 */ GIM_Try, /*On fail goto*//*Label 790*/ GIMT_Encode4(51841), // Rule ID 7487 //
     /*  51821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  51827 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  51830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51834 */   // (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  51834 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_H),
     /*  51839 */   GIR_RootConstrainSelectedInstOperands,
     /*  51840 */   // GIR_Coverage, 7487,
     /*  51840 */   GIR_Done,
     /*  51841 */ // Label 790: @51841
     /*  51841 */ GIM_Reject,
     /*  51842 */ // Label 602: @51842
     /*  51842 */ GIM_Try, /*On fail goto*//*Label 791*/ GIMT_Encode4(51867), // Rule ID 7486 //
     /*  51847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  51850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  51853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  51856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  51860 */   // (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  51860 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SUB_ZZZ_B),
     /*  51865 */   GIR_RootConstrainSelectedInstOperands,
     /*  51866 */   // GIR_Coverage, 7486,
     /*  51866 */   GIR_Done,
     /*  51867 */ // Label 791: @51867
     /*  51867 */ GIM_Reject,
     /*  51868 */ // Label 603: @51868
     /*  51868 */ GIM_Reject,
     /*  51869 */ // Label 2: @51869
     /*  51869 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 800*/ GIMT_Encode4(54633),
     /*  51880 */ /*GILLT_s32*//*Label 792*/ GIMT_Encode4(51920),
     /*  51884 */ /*GILLT_s64*//*Label 793*/ GIMT_Encode4(52077), GIMT_Encode4(0),
     /*  51892 */ /*GILLT_v2s32*//*Label 794*/ GIMT_Encode4(53557), GIMT_Encode4(0),
     /*  51900 */ /*GILLT_v4s16*//*Label 795*/ GIMT_Encode4(53895),
     /*  51904 */ /*GILLT_v4s32*//*Label 796*/ GIMT_Encode4(54233),
     /*  51908 */ /*GILLT_v8s8*//*Label 797*/ GIMT_Encode4(54399),
     /*  51912 */ /*GILLT_v8s16*//*Label 798*/ GIMT_Encode4(54433),
     /*  51916 */ /*GILLT_v16s8*//*Label 799*/ GIMT_Encode4(54599),
     /*  51920 */ // Label 792: @51920
     /*  51920 */ GIM_Try, /*On fail goto*//*Label 801*/ GIMT_Encode4(52076),
     /*  51925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  51928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  51931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51935 */   GIM_Try, /*On fail goto*//*Label 802*/ GIMT_Encode4(51990), // Rule ID 3954 //
     /*  51940 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  51944 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  51948 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  51952 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  51956 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  51960 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51969 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  51971 */     // (mul:{ *:[i32] } (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn), GPR32:{ *:[i32] }:$Rm)  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  51971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  51974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  51976 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  51980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  51982 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  51988 */     GIR_RootConstrainSelectedInstOperands,
     /*  51989 */     // GIR_Coverage, 3954,
     /*  51989 */     GIR_EraseRootFromParent_Done,
     /*  51990 */   // Label 802: @51990
     /*  51990 */   GIM_Try, /*On fail goto*//*Label 803*/ GIMT_Encode4(52045), // Rule ID 13860 //
     /*  51995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  51999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52011 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  52015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52026 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (sub:{ *:[i32] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rn))  =>  (MSUBWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBWrrr),
     /*  52029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52031 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52037 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52043 */     GIR_RootConstrainSelectedInstOperands,
     /*  52044 */     // GIR_Coverage, 13860,
     /*  52044 */     GIR_EraseRootFromParent_Done,
     /*  52045 */   // Label 803: @52045
     /*  52045 */   GIM_Try, /*On fail goto*//*Label 804*/ GIMT_Encode4(52075), // Rule ID 3950 //
     /*  52050 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52058 */     // (mul:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (MADDWrrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, WZR:{ *:[i32] })
     /*  52058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDWrrr),
     /*  52061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  52065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52067 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52073 */     GIR_RootConstrainSelectedInstOperands,
     /*  52074 */     // GIR_Coverage, 3950,
     /*  52074 */     GIR_EraseRootFromParent_Done,
     /*  52075 */   // Label 804: @52075
     /*  52075 */   GIM_Reject,
     /*  52076 */ // Label 801: @52076
     /*  52076 */ GIM_Reject,
     /*  52077 */ // Label 793: @52077
     /*  52077 */ GIM_Try, /*On fail goto*//*Label 805*/ GIMT_Encode4(53556),
     /*  52082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  52085 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  52088 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52092 */   GIM_Try, /*On fail goto*//*Label 806*/ GIMT_Encode4(52238), // Rule ID 3959 //
     /*  52097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52118 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52145 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52150 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52163 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52163 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52166 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52170 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52175 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52181 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52186 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52203 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52209 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52214 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52230 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52236 */     GIR_RootConstrainSelectedInstOperands,
     /*  52237 */     // GIR_Coverage, 3959,
     /*  52237 */     GIR_EraseRootFromParent_Done,
     /*  52238 */   // Label 806: @52238
     /*  52238 */   GIM_Try, /*On fail goto*//*Label 807*/ GIMT_Encode4(52342), // Rule ID 3960 //
     /*  52243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52255 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52264 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  52287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52294 */     // (mul:{ *:[i64] } (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52330 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  52334 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52340 */     GIR_RootConstrainSelectedInstOperands,
     /*  52341 */     // GIR_Coverage, 3960,
     /*  52341 */     GIR_EraseRootFromParent_Done,
     /*  52342 */   // Label 807: @52342
     /*  52342 */   GIM_Try, /*On fail goto*//*Label 808*/ GIMT_Encode4(52446), // Rule ID 13863 //
     /*  52347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  52372 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52376 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  52380 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52385 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4294967295),
     /*  52396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52398 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] }))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  52398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52410 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  52438 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52444 */     GIR_RootConstrainSelectedInstOperands,
     /*  52445 */     // GIR_Coverage, 13863,
     /*  52445 */     GIR_EraseRootFromParent_Done,
     /*  52446 */   // Label 808: @52446
     /*  52446 */   GIM_Try, /*On fail goto*//*Label 809*/ GIMT_Encode4(52501), // Rule ID 3955 //
     /*  52451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52467 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52471 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52482 */     // (mul:{ *:[i64] } (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn), GPR64:{ *:[i64] }:$Rm)  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52491 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  52493 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52499 */     GIR_RootConstrainSelectedInstOperands,
     /*  52500 */     // GIR_Coverage, 3955,
     /*  52500 */     GIR_EraseRootFromParent_Done,
     /*  52501 */   // Label 809: @52501
     /*  52501 */   GIM_Try, /*On fail goto*//*Label 810*/ GIMT_Encode4(52556), // Rule ID 13861 //
     /*  52506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  52514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  52518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52522 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  52526 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/1, 0,
     /*  52530 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  52537 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (sub:{ *:[i64] } 0:{ *:[i64] }, GPR64:{ *:[i64] }:$Rn))  =>  (MSUBXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  52537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSUBXrrr),
     /*  52540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  52546 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  52548 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52554 */     GIR_RootConstrainSelectedInstOperands,
     /*  52555 */     // GIR_Coverage, 13861,
     /*  52555 */     GIR_EraseRootFromParent_Done,
     /*  52556 */   // Label 810: @52556
     /*  52556 */   GIM_Try, /*On fail goto*//*Label 811*/ GIMT_Encode4(52669), // Rule ID 3966 //
     /*  52561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52578 */     // MIs[1] Operand 2
     /*  52578 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52597 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52601 */     // MIs[2] Operand 1
     /*  52601 */     // No operand predicates
     /*  52601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52603 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52603 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52606 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52610 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52615 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  52622 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52625 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52629 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52634 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52655 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52661 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52667 */     GIR_RootConstrainSelectedInstOperands,
     /*  52668 */     // GIR_Coverage, 3966,
     /*  52668 */     GIR_EraseRootFromParent_Done,
     /*  52669 */   // Label 811: @52669
     /*  52669 */   GIM_Try, /*On fail goto*//*Label 812*/ GIMT_Encode4(52744), // Rule ID 3964 //
     /*  52674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_s64imm_32bit),
     /*  52703 */     // MIs[2] Operand 1
     /*  52703 */     // No operand predicates
     /*  52703 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52705 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_s64imm_32bit>>:$C)  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52717 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52729 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52733 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52736 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52742 */     GIR_RootConstrainSelectedInstOperands,
     /*  52743 */     // GIR_Coverage, 3964,
     /*  52743 */     GIR_EraseRootFromParent_Done,
     /*  52744 */   // Label 812: @52744
     /*  52744 */   GIM_Try, /*On fail goto*//*Label 813*/ GIMT_Encode4(52819), // Rule ID 3965 //
     /*  52749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  52757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  52761 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  52774 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /*  52778 */     // MIs[2] Operand 1
     /*  52778 */     // No operand predicates
     /*  52778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52780 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$C)  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$C)), XZR:{ *:[i64] })
     /*  52780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /*  52787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52792 */     GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // C
     /*  52797 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  52799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  52802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  52808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52811 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52817 */     GIR_RootConstrainSelectedInstOperands,
     /*  52818 */     // GIR_Coverage, 3965,
     /*  52818 */     GIR_EraseRootFromParent_Done,
     /*  52819 */   // Label 813: @52819
     /*  52819 */   GIM_Try, /*On fail goto*//*Label 814*/ GIMT_Encode4(52957), // Rule ID 3956 //
     /*  52824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52841 */     // MIs[1] Operand 2
     /*  52841 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  52864 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52869 */     // MIs[2] Operand 2
     /*  52869 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  52880 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  52882 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  52882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  52885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52894 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  52900 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52905 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52910 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  52913 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  52917 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  52922 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  52928 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  52933 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  52941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  52943 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  52946 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  52949 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  52955 */     GIR_RootConstrainSelectedInstOperands,
     /*  52956 */     // GIR_Coverage, 3956,
     /*  52956 */     GIR_EraseRootFromParent_Done,
     /*  52957 */   // Label 814: @52957
     /*  52957 */   GIM_Try, /*On fail goto*//*Label 815*/ GIMT_Encode4(53057), // Rule ID 3957 //
     /*  52962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  52966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  52970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  52974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  52979 */     // MIs[1] Operand 2
     /*  52979 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /*  52990 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  52994 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  52998 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53002 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53009 */     // (mul:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53009 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53012 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53016 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53021 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53042 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53049 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53055 */     GIR_RootConstrainSelectedInstOperands,
     /*  53056 */     // GIR_Coverage, 3957,
     /*  53056 */     GIR_EraseRootFromParent_Done,
     /*  53057 */   // Label 815: @53057
     /*  53057 */   GIM_Try, /*On fail goto*//*Label 816*/ GIMT_Encode4(53157), // Rule ID 13862 //
     /*  53062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53079 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53083 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /*  53087 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  53091 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53096 */     // MIs[2] Operand 2
     /*  53096 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  53107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53109 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i32:{ *:[Other] }))  =>  (SMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53109 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53112 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53116 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53121 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53127 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53132 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53142 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53149 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53155 */     GIR_RootConstrainSelectedInstOperands,
     /*  53156 */     // GIR_Coverage, 13862,
     /*  53156 */     GIR_EraseRootFromParent_Done,
     /*  53157 */   // Label 816: @53157
     /*  53157 */   GIM_Try, /*On fail goto*//*Label 817*/ GIMT_Encode4(53219), // Rule ID 3958 //
     /*  53162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SEXT),
     /*  53187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53191 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53198 */     // (mul:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (SMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMADDLrrr),
     /*  53201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53211 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53217 */     GIR_RootConstrainSelectedInstOperands,
     /*  53218 */     // GIR_Coverage, 3958,
     /*  53218 */     GIR_EraseRootFromParent_Done,
     /*  53219 */   // Label 817: @53219
     /*  53219 */   GIM_Try, /*On fail goto*//*Label 818*/ GIMT_Encode4(53281), // Rule ID 3961 //
     /*  53224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53232 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53236 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  53245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  53253 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53258 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53260 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  53269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53273 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53279 */     GIR_RootConstrainSelectedInstOperands,
     /*  53280 */     // GIR_Coverage, 3961,
     /*  53280 */     GIR_EraseRootFromParent_Done,
     /*  53281 */   // Label 818: @53281
     /*  53281 */   GIM_Try, /*On fail goto*//*Label 819*/ GIMT_Encode4(53358), // Rule ID 3985 //
     /*  53286 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53310 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53322 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53333 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53350 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53356 */     GIR_RootConstrainSelectedInstOperands,
     /*  53357 */     // GIR_Coverage, 3985,
     /*  53357 */     GIR_EraseRootFromParent_Done,
     /*  53358 */   // Label 819: @53358
     /*  53358 */   GIM_Try, /*On fail goto*//*Label 820*/ GIMT_Encode4(53435), // Rule ID 13874 //
     /*  53363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /*  53371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  53375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53380 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  53387 */     // (mul:{ *:[i64] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm), GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), ?:{ *:[i32] }:$Rm, XZR:{ *:[i64] })
     /*  53387 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53390 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53394 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53399 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53405 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53410 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53423 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53427 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53433 */     GIR_RootConstrainSelectedInstOperands,
     /*  53434 */     // GIR_Coverage, 13874,
     /*  53434 */     GIR_EraseRootFromParent_Done,
     /*  53435 */   // Label 820: @53435
     /*  53435 */   GIM_Try, /*On fail goto*//*Label 821*/ GIMT_Encode4(53525), // Rule ID 3984 //
     /*  53440 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53445 */     GIM_CheckLeafOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /*  53450 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn, GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rm)  =>  (UMADDLrrr:{ *:[i64] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }), XZR:{ *:[i64] })
     /*  53450 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  53453 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53457 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53462 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /*  53468 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53473 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53478 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  53481 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  53485 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  53490 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  53496 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  53501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMADDLrrr),
     /*  53509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  53514 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /*  53517 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53523 */     GIR_RootConstrainSelectedInstOperands,
     /*  53524 */     // GIR_Coverage, 3984,
     /*  53524 */     GIR_EraseRootFromParent_Done,
     /*  53525 */   // Label 821: @53525
     /*  53525 */   GIM_Try, /*On fail goto*//*Label 822*/ GIMT_Encode4(53555), // Rule ID 3951 //
     /*  53530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  53538 */     // (mul:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (MADDXrrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, XZR:{ *:[i64] })
     /*  53538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MADDXrrr),
     /*  53541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53543 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  53547 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  53553 */     GIR_RootConstrainSelectedInstOperands,
     /*  53554 */     // GIR_Coverage, 3951,
     /*  53554 */     GIR_EraseRootFromParent_Done,
     /*  53555 */   // Label 822: @53555
     /*  53555 */   GIM_Reject,
     /*  53556 */ // Label 805: @53556
     /*  53556 */ GIM_Reject,
     /*  53557 */ // Label 794: @53557
     /*  53557 */ GIM_Try, /*On fail goto*//*Label 823*/ GIMT_Encode4(53894),
     /*  53562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  53565 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  53568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53572 */   GIM_Try, /*On fail goto*//*Label 824*/ GIMT_Encode4(53658), // Rule ID 13548 //
     /*  53577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53580 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53584 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53588 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53592 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53596 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53600 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53604 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53608 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53621 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53625 */     // MIs[3] Operand 1
     /*  53625 */     // No operand predicates
     /*  53625 */     // MIs[1] Operand 2
     /*  53625 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53636 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53642 */     // (mul:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53653 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53656 */     GIR_RootConstrainSelectedInstOperands,
     /*  53657 */     // GIR_Coverage, 13548,
     /*  53657 */     GIR_EraseRootFromParent_Done,
     /*  53658 */   // Label 824: @53658
     /*  53658 */   GIM_Try, /*On fail goto*//*Label 825*/ GIMT_Encode4(53744), // Rule ID 2034 //
     /*  53663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53666 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53715 */     // MIs[3] Operand 1
     /*  53715 */     // No operand predicates
     /*  53715 */     // MIs[1] Operand 2
     /*  53715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53728 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53742 */     GIR_RootConstrainSelectedInstOperands,
     /*  53743 */     // GIR_Coverage, 2034,
     /*  53743 */     GIR_EraseRootFromParent_Done,
     /*  53744 */   // Label 825: @53744
     /*  53744 */   GIM_Try, /*On fail goto*//*Label 826*/ GIMT_Encode4(53807), // Rule ID 13549 //
     /*  53749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53785 */     // MIs[2] Operand 1
     /*  53785 */     // No operand predicates
     /*  53785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53789 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53791 */     // (mul:{ *:[v2i32] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53802 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53805 */     GIR_RootConstrainSelectedInstOperands,
     /*  53806 */     // GIR_Coverage, 13549,
     /*  53806 */     GIR_EraseRootFromParent_Done,
     /*  53807 */   // Label 826: @53807
     /*  53807 */   GIM_Try, /*On fail goto*//*Label 827*/ GIMT_Encode4(53870), // Rule ID 2035 //
     /*  53812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53815 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  53823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  53827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  53831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  53835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  53840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  53844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53848 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  53852 */     // MIs[2] Operand 1
     /*  53852 */     // No operand predicates
     /*  53852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  53854 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32_indexed),
     /*  53857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53859 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  53861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  53865 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  53868 */     GIR_RootConstrainSelectedInstOperands,
     /*  53869 */     // GIR_Coverage, 2035,
     /*  53869 */     GIR_EraseRootFromParent_Done,
     /*  53870 */   // Label 827: @53870
     /*  53870 */   GIM_Try, /*On fail goto*//*Label 828*/ GIMT_Encode4(53893), // Rule ID 1352 //
     /*  53875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53886 */     // (mul:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (MULv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  53886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv2i32),
     /*  53891 */     GIR_RootConstrainSelectedInstOperands,
     /*  53892 */     // GIR_Coverage, 1352,
     /*  53892 */     GIR_Done,
     /*  53893 */   // Label 828: @53893
     /*  53893 */   GIM_Reject,
     /*  53894 */ // Label 823: @53894
     /*  53894 */ GIM_Reject,
     /*  53895 */ // Label 795: @53895
     /*  53895 */ GIM_Try, /*On fail goto*//*Label 829*/ GIMT_Encode4(54232),
     /*  53900 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  53903 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  53906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53910 */   GIM_Try, /*On fail goto*//*Label 830*/ GIMT_Encode4(53996), // Rule ID 13545 //
     /*  53915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  53918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  53922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  53926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  53934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  53938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  53942 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  53946 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  53951 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  53955 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  53959 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  53963 */     // MIs[3] Operand 1
     /*  53963 */     // No operand predicates
     /*  53963 */     // MIs[1] Operand 2
     /*  53963 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  53974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  53978 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  53980 */     // (mul:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  53980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  53983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  53985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  53987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  53991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  53994 */     GIR_RootConstrainSelectedInstOperands,
     /*  53995 */     // GIR_Coverage, 13545,
     /*  53995 */     GIR_EraseRootFromParent_Done,
     /*  53996 */   // Label 830: @53996
     /*  53996 */   GIM_Try, /*On fail goto*//*Label 831*/ GIMT_Encode4(54082), // Rule ID 2031 //
     /*  54001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54004 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54012 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /*  54016 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54020 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  54024 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54028 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54032 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  54036 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  54045 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54049 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54053 */     // MIs[3] Operand 1
     /*  54053 */     // No operand predicates
     /*  54053 */     // MIs[1] Operand 2
     /*  54053 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /*  54064 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  54066 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  54077 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /*  54080 */     GIR_RootConstrainSelectedInstOperands,
     /*  54081 */     // GIR_Coverage, 2031,
     /*  54081 */     GIR_EraseRootFromParent_Done,
     /*  54082 */   // Label 831: @54082
     /*  54082 */   GIM_Try, /*On fail goto*//*Label 832*/ GIMT_Encode4(54145), // Rule ID 13546 //
     /*  54087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54098 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54102 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54106 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54111 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54115 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54119 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54123 */     // MIs[2] Operand 1
     /*  54123 */     // No operand predicates
     /*  54123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54127 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54129 */     // (mul:{ *:[v4i16] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54143 */     GIR_RootConstrainSelectedInstOperands,
     /*  54144 */     // GIR_Coverage, 13546,
     /*  54144 */     GIR_EraseRootFromParent_Done,
     /*  54145 */   // Label 832: @54145
     /*  54145 */   GIM_Try, /*On fail goto*//*Label 833*/ GIMT_Encode4(54208), // Rule ID 2032 //
     /*  54150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54153 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54173 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54186 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54190 */     // MIs[2] Operand 1
     /*  54190 */     // No operand predicates
     /*  54190 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54192 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16_indexed),
     /*  54195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54206 */     GIR_RootConstrainSelectedInstOperands,
     /*  54207 */     // GIR_Coverage, 2032,
     /*  54207 */     GIR_EraseRootFromParent_Done,
     /*  54208 */   // Label 833: @54208
     /*  54208 */   GIM_Try, /*On fail goto*//*Label 834*/ GIMT_Encode4(54231), // Rule ID 1350 //
     /*  54213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54224 */     // (mul:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (MULv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  54224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i16),
     /*  54229 */     GIR_RootConstrainSelectedInstOperands,
     /*  54230 */     // GIR_Coverage, 1350,
     /*  54230 */     GIR_Done,
     /*  54231 */   // Label 834: @54231
     /*  54231 */   GIM_Reject,
     /*  54232 */ // Label 829: @54232
     /*  54232 */ GIM_Reject,
     /*  54233 */ // Label 796: @54233
     /*  54233 */ GIM_Try, /*On fail goto*//*Label 835*/ GIMT_Encode4(54398),
     /*  54238 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54241 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  54244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54248 */   GIM_Try, /*On fail goto*//*Label 836*/ GIMT_Encode4(54311), // Rule ID 13550 //
     /*  54253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54260 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54264 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54268 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54272 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54277 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54281 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54285 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54289 */     // MIs[2] Operand 1
     /*  54289 */     // No operand predicates
     /*  54289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54293 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54295 */     // (mul:{ *:[v4i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4i32] }:$Rn)  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54302 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54306 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54309 */     GIR_RootConstrainSelectedInstOperands,
     /*  54310 */     // GIR_Coverage, 13550,
     /*  54310 */     GIR_EraseRootFromParent_Done,
     /*  54311 */   // Label 836: @54311
     /*  54311 */   GIM_Try, /*On fail goto*//*Label 837*/ GIMT_Encode4(54374), // Rule ID 2036 //
     /*  54316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /*  54331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  54335 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54352 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /*  54356 */     // MIs[2] Operand 1
     /*  54356 */     // No operand predicates
     /*  54356 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54358 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (MULv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32_indexed),
     /*  54361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54369 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54372 */     GIR_RootConstrainSelectedInstOperands,
     /*  54373 */     // GIR_Coverage, 2036,
     /*  54373 */     GIR_EraseRootFromParent_Done,
     /*  54374 */   // Label 837: @54374
     /*  54374 */   GIM_Try, /*On fail goto*//*Label 838*/ GIMT_Encode4(54397), // Rule ID 1353 //
     /*  54379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54382 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54390 */     // (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (MULv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  54390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv4i32),
     /*  54395 */     GIR_RootConstrainSelectedInstOperands,
     /*  54396 */     // GIR_Coverage, 1353,
     /*  54396 */     GIR_Done,
     /*  54397 */   // Label 838: @54397
     /*  54397 */   GIM_Reject,
     /*  54398 */ // Label 835: @54398
     /*  54398 */ GIM_Reject,
     /*  54399 */ // Label 797: @54399
     /*  54399 */ GIM_Try, /*On fail goto*//*Label 839*/ GIMT_Encode4(54432), // Rule ID 1348 //
     /*  54404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  54410 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  54413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54417 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54421 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  54425 */   // (mul:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (MULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  54425 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i8),
     /*  54430 */   GIR_RootConstrainSelectedInstOperands,
     /*  54431 */   // GIR_Coverage, 1348,
     /*  54431 */   GIR_Done,
     /*  54432 */ // Label 839: @54432
     /*  54432 */ GIM_Reject,
     /*  54433 */ // Label 798: @54433
     /*  54433 */ GIM_Try, /*On fail goto*//*Label 840*/ GIMT_Encode4(54598),
     /*  54438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  54444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54448 */   GIM_Try, /*On fail goto*//*Label 841*/ GIMT_Encode4(54511), // Rule ID 13547 //
     /*  54453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54456 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54460 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54464 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54468 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54485 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54489 */     // MIs[2] Operand 1
     /*  54489 */     // No operand predicates
     /*  54489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54493 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54495 */     // (mul:{ *:[v8i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8i16] }:$Rn)  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54502 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54509 */     GIR_RootConstrainSelectedInstOperands,
     /*  54510 */     // GIR_Coverage, 13547,
     /*  54510 */     GIR_EraseRootFromParent_Done,
     /*  54511 */   // Label 841: @54511
     /*  54511 */   GIM_Try, /*On fail goto*//*Label 842*/ GIMT_Encode4(54574), // Rule ID 2033 //
     /*  54516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /*  54531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  54535 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  54539 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /*  54544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  54548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  54552 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  54556 */     // MIs[2] Operand 1
     /*  54556 */     // No operand predicates
     /*  54556 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  54558 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (MULv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /*  54558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16_indexed),
     /*  54561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54563 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  54565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  54569 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  54572 */     GIR_RootConstrainSelectedInstOperands,
     /*  54573 */     // GIR_Coverage, 2033,
     /*  54573 */     GIR_EraseRootFromParent_Done,
     /*  54574 */   // Label 842: @54574
     /*  54574 */   GIM_Try, /*On fail goto*//*Label 843*/ GIMT_Encode4(54597), // Rule ID 1351 //
     /*  54579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54590 */     // (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (MULv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  54590 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv8i16),
     /*  54595 */     GIR_RootConstrainSelectedInstOperands,
     /*  54596 */     // GIR_Coverage, 1351,
     /*  54596 */     GIR_Done,
     /*  54597 */   // Label 843: @54597
     /*  54597 */   GIM_Reject,
     /*  54598 */ // Label 840: @54598
     /*  54598 */ GIM_Reject,
     /*  54599 */ // Label 799: @54599
     /*  54599 */ GIM_Try, /*On fail goto*//*Label 844*/ GIMT_Encode4(54632), // Rule ID 1349 //
     /*  54604 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  54607 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  54610 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  54613 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54621 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  54625 */   // (mul:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (MULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  54625 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::MULv16i8),
     /*  54630 */   GIR_RootConstrainSelectedInstOperands,
     /*  54631 */   // GIR_Coverage, 1349,
     /*  54631 */   GIR_Done,
     /*  54632 */ // Label 844: @54632
     /*  54632 */ GIM_Reject,
     /*  54633 */ // Label 800: @54633
     /*  54633 */ GIM_Reject,
     /*  54634 */ // Label 3: @54634
     /*  54634 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 847*/ GIMT_Encode4(54715),
     /*  54645 */ /*GILLT_s32*//*Label 845*/ GIMT_Encode4(54653),
     /*  54649 */ /*GILLT_s64*//*Label 846*/ GIMT_Encode4(54684),
     /*  54653 */ // Label 845: @54653
     /*  54653 */ GIM_Try, /*On fail goto*//*Label 848*/ GIMT_Encode4(54683), // Rule ID 117 //
     /*  54658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54661 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54668 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54672 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54676 */   // (sdiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /*  54681 */   GIR_RootConstrainSelectedInstOperands,
     /*  54682 */   // GIR_Coverage, 117,
     /*  54682 */   GIR_Done,
     /*  54683 */ // Label 848: @54683
     /*  54683 */ GIM_Reject,
     /*  54684 */ // Label 846: @54684
     /*  54684 */ GIM_Try, /*On fail goto*//*Label 849*/ GIMT_Encode4(54714), // Rule ID 118 //
     /*  54689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54692 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54703 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54707 */   // (sdiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /*  54712 */   GIR_RootConstrainSelectedInstOperands,
     /*  54713 */   // GIR_Coverage, 118,
     /*  54713 */   GIR_Done,
     /*  54714 */ // Label 849: @54714
     /*  54714 */ GIM_Reject,
     /*  54715 */ // Label 847: @54715
     /*  54715 */ GIM_Reject,
     /*  54716 */ // Label 4: @54716
     /*  54716 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 852*/ GIMT_Encode4(54797),
     /*  54727 */ /*GILLT_s32*//*Label 850*/ GIMT_Encode4(54735),
     /*  54731 */ /*GILLT_s64*//*Label 851*/ GIMT_Encode4(54766),
     /*  54735 */ // Label 850: @54735
     /*  54735 */ GIM_Try, /*On fail goto*//*Label 853*/ GIMT_Encode4(54765), // Rule ID 115 //
     /*  54740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54743 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54746 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54750 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54754 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54758 */   // (udiv:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  54758 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /*  54763 */   GIR_RootConstrainSelectedInstOperands,
     /*  54764 */   // GIR_Coverage, 115,
     /*  54764 */   GIR_Done,
     /*  54765 */ // Label 853: @54765
     /*  54765 */ GIM_Reject,
     /*  54766 */ // Label 851: @54766
     /*  54766 */ GIM_Try, /*On fail goto*//*Label 854*/ GIMT_Encode4(54796), // Rule ID 116 //
     /*  54771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  54774 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  54777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54781 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54785 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  54789 */   // (udiv:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  54789 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /*  54794 */   GIR_RootConstrainSelectedInstOperands,
     /*  54795 */   // GIR_Coverage, 116,
     /*  54795 */   GIR_Done,
     /*  54796 */ // Label 854: @54796
     /*  54796 */ GIM_Reject,
     /*  54797 */ // Label 852: @54797
     /*  54797 */ GIM_Reject,
     /*  54798 */ // Label 5: @54798
     /*  54798 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 873*/ GIMT_Encode4(62543),
     /*  54809 */ /*GILLT_s32*//*Label 855*/ GIMT_Encode4(54897),
     /*  54813 */ /*GILLT_s64*//*Label 856*/ GIMT_Encode4(55395), GIMT_Encode4(0),
     /*  54821 */ /*GILLT_v2s32*//*Label 857*/ GIMT_Encode4(56830),
     /*  54825 */ /*GILLT_v2s64*//*Label 858*/ GIMT_Encode4(56990),
     /*  54829 */ /*GILLT_v4s16*//*Label 859*/ GIMT_Encode4(57150),
     /*  54833 */ /*GILLT_v4s32*//*Label 860*/ GIMT_Encode4(57310),
     /*  54837 */ /*GILLT_v8s8*//*Label 861*/ GIMT_Encode4(57470),
     /*  54841 */ /*GILLT_v8s16*//*Label 862*/ GIMT_Encode4(57630),
     /*  54845 */ /*GILLT_v16s8*//*Label 863*/ GIMT_Encode4(57790),
     /*  54849 */ /*GILLT_nxv1s1*//*Label 864*/ GIMT_Encode4(57950),
     /*  54853 */ /*GILLT_nxv2s1*//*Label 865*/ GIMT_Encode4(58491), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  54865 */ /*GILLT_nxv2s64*//*Label 866*/ GIMT_Encode4(59032),
     /*  54869 */ /*GILLT_nxv4s1*//*Label 867*/ GIMT_Encode4(59504), GIMT_Encode4(0),
     /*  54877 */ /*GILLT_nxv4s32*//*Label 868*/ GIMT_Encode4(60045),
     /*  54881 */ /*GILLT_nxv8s1*//*Label 869*/ GIMT_Encode4(60517),
     /*  54885 */ /*GILLT_nxv8s16*//*Label 870*/ GIMT_Encode4(61058),
     /*  54889 */ /*GILLT_nxv16s1*//*Label 871*/ GIMT_Encode4(61530),
     /*  54893 */ /*GILLT_nxv16s8*//*Label 872*/ GIMT_Encode4(62071),
     /*  54897 */ // Label 855: @54897
     /*  54897 */ GIM_Try, /*On fail goto*//*Label 874*/ GIMT_Encode4(55394),
     /*  54902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  54905 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  54908 */   GIM_Try, /*On fail goto*//*Label 875*/ GIMT_Encode4(54963), // Rule ID 13303 //
     /*  54913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  54921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54933 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54941 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54943 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  54950 */     // (and:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  54950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  54953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  54955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  54957 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  54961 */     GIR_RootConstrainSelectedInstOperands,
     /*  54962 */     // GIR_Coverage, 13303,
     /*  54962 */     GIR_EraseRootFromParent_Done,
     /*  54963 */   // Label 875: @54963
     /*  54963 */   GIM_Try, /*On fail goto*//*Label 876*/ GIMT_Encode4(55018), // Rule ID 162 //
     /*  54968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54972 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  54976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  54980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  54984 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  54988 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  54992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  54996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  54998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55005 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (BICWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrs),
     /*  55008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55012 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55016 */     GIR_RootConstrainSelectedInstOperands,
     /*  55017 */     // GIR_Coverage, 162,
     /*  55017 */     GIR_EraseRootFromParent_Done,
     /*  55018 */   // Label 876: @55018
     /*  55018 */   GIM_Try, /*On fail goto*//*Label 877*/ GIMT_Encode4(55087), // Rule ID 5676 //
     /*  55023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55060 */     // MIs[2] Operand 1
     /*  55060 */     // No operand predicates
     /*  55060 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55073 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), 255:{ *:[i32] })  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /*  55073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55085 */     GIR_RootConstrainSelectedInstOperands,
     /*  55086 */     // GIR_Coverage, 5676,
     /*  55086 */     GIR_EraseRootFromParent_Done,
     /*  55087 */   // Label 877: @55087
     /*  55087 */   GIM_Try, /*On fail goto*//*Label 878*/ GIMT_Encode4(55156), // Rule ID 5677 //
     /*  55092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55108 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55112 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  55121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55125 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55129 */     // MIs[2] Operand 1
     /*  55129 */     // No operand predicates
     /*  55129 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  55142 */     // (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 65535:{ *:[i32] })  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /*  55142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  55151 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /*  55154 */     GIR_RootConstrainSelectedInstOperands,
     /*  55155 */     // GIR_Coverage, 5677,
     /*  55155 */     GIR_EraseRootFromParent_Done,
     /*  55156 */   // Label 878: @55156
     /*  55156 */   GIM_Try, /*On fail goto*//*Label 879*/ GIMT_Encode4(55209), // Rule ID 13301 //
     /*  55161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55186 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55190 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55194 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55196 */     // (and:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55207 */     GIR_RootConstrainSelectedInstOperands,
     /*  55208 */     // GIR_Coverage, 13301,
     /*  55208 */     GIR_EraseRootFromParent_Done,
     /*  55209 */   // Label 879: @55209
     /*  55209 */   GIM_Try, /*On fail goto*//*Label 880*/ GIMT_Encode4(55262), // Rule ID 160 //
     /*  55214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55218 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  55238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55247 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55249 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (BICWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICWrr),
     /*  55252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55256 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  55260 */     GIR_RootConstrainSelectedInstOperands,
     /*  55261 */     // GIR_Coverage, 160,
     /*  55261 */     GIR_EraseRootFromParent_Done,
     /*  55262 */   // Label 880: @55262
     /*  55262 */   GIM_Try, /*On fail goto*//*Label 881*/ GIMT_Encode4(55303), // Rule ID 142 //
     /*  55267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  55271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55283 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  55287 */     // MIs[1] Operand 1
     /*  55287 */     // No operand predicates
     /*  55287 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55289 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ANDWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  55289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /*  55292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55294 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55296 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  55301 */     GIR_RootConstrainSelectedInstOperands,
     /*  55302 */     // GIR_Coverage, 142,
     /*  55302 */     GIR_EraseRootFromParent_Done,
     /*  55303 */   // Label 881: @55303
     /*  55303 */   GIM_Try, /*On fail goto*//*Label 882*/ GIMT_Encode4(55336), // Rule ID 13299 //
     /*  55308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55316 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55323 */     // (and:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55330 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55334 */     GIR_RootConstrainSelectedInstOperands,
     /*  55335 */     // GIR_Coverage, 13299,
     /*  55335 */     GIR_EraseRootFromParent_Done,
     /*  55336 */   // Label 882: @55336
     /*  55336 */   GIM_Try, /*On fail goto*//*Label 883*/ GIMT_Encode4(55369), // Rule ID 158 //
     /*  55341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55349 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  55356 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ANDWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  55356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDWrs),
     /*  55359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55363 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55367 */     GIR_RootConstrainSelectedInstOperands,
     /*  55368 */     // GIR_Coverage, 158,
     /*  55368 */     GIR_EraseRootFromParent_Done,
     /*  55369 */   // Label 883: @55369
     /*  55369 */   GIM_Try, /*On fail goto*//*Label 884*/ GIMT_Encode4(55393), // Rule ID 156 //
     /*  55374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55386 */     // (and:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ANDWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  55386 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDWrr),
     /*  55391 */     GIR_RootConstrainSelectedInstOperands,
     /*  55392 */     // GIR_Coverage, 156,
     /*  55392 */     GIR_Done,
     /*  55393 */   // Label 884: @55393
     /*  55393 */   GIM_Reject,
     /*  55394 */ // Label 874: @55394
     /*  55394 */ GIM_Reject,
     /*  55395 */ // Label 856: @55395
     /*  55395 */ GIM_Try, /*On fail goto*//*Label 885*/ GIMT_Encode4(56829),
     /*  55400 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  55403 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  55406 */   GIM_Try, /*On fail goto*//*Label 886*/ GIMT_Encode4(55461), // Rule ID 13304 //
     /*  55411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55431 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55441 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55448 */     // (and:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  55455 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55459 */     GIR_RootConstrainSelectedInstOperands,
     /*  55460 */     // GIR_Coverage, 13304,
     /*  55460 */     GIR_EraseRootFromParent_Done,
     /*  55461 */   // Label 886: @55461
     /*  55461 */   GIM_Try, /*On fail goto*//*Label 887*/ GIMT_Encode4(55516), // Rule ID 163 //
     /*  55466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55470 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  55474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  55478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  55482 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  55486 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  55490 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  55494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55496 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  55503 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (BICXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  55503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrs),
     /*  55506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  55508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  55510 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  55514 */     GIR_RootConstrainSelectedInstOperands,
     /*  55515 */     // GIR_Coverage, 163,
     /*  55515 */     GIR_EraseRootFromParent_Done,
     /*  55516 */   // Label 887: @55516
     /*  55516 */   GIM_Try, /*On fail goto*//*Label 888*/ GIMT_Encode4(55629), // Rule ID 5678 //
     /*  55521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55537 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55541 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55545 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  55549 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55553 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55558 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55562 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55566 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /*  55570 */     // MIs[3] Operand 1
     /*  55570 */     // No operand predicates
     /*  55570 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55581 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55583 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), sub_32:{ *:[i32] })
     /*  55583 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55586 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /*  55590 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55602 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55618 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55623 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55628 */     // GIR_Coverage, 5678,
     /*  55628 */     GIR_EraseRootFromParent_Done,
     /*  55629 */   // Label 888: @55629
     /*  55629 */   GIM_Try, /*On fail goto*//*Label 889*/ GIMT_Encode4(55742), // Rule ID 5679 //
     /*  55634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /*  55646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  55650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  55654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /*  55658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  55662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  55666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  55671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  55675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  55679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /*  55683 */     // MIs[3] Operand 1
     /*  55683 */     // No operand predicates
     /*  55683 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55694 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  55696 */     // (and:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), sub_32:{ *:[i32] })
     /*  55696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /*  55703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55708 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  55712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // idx
     /*  55715 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55728 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55731 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55741 */     // GIR_Coverage, 5679,
     /*  55741 */     GIR_EraseRootFromParent_Done,
     /*  55742 */   // Label 889: @55742
     /*  55742 */   GIM_Try, /*On fail goto*//*Label 890*/ GIMT_Encode4(55841), // Rule ID 7138 //
     /*  55747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55759 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55762 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55767 */     // MIs[1] addr
     /*  55767 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55776 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /*  55780 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  55791 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55793 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55793 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55796 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /*  55800 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55805 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55809 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55821 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55827 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55830 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55835 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55840 */     // GIR_Coverage, 7138,
     /*  55840 */     GIR_EraseRootFromParent_Done,
     /*  55841 */   // Label 890: @55841
     /*  55841 */   GIM_Try, /*On fail goto*//*Label 891*/ GIMT_Encode4(55940), // Rule ID 7139 //
     /*  55846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55858 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55861 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55866 */     // MIs[1] addr
     /*  55866 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55875 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /*  55879 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  55890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55892 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55892 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55895 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /*  55899 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  55904 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  55908 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  55913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  55915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  55918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  55920 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  55923 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  55926 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  55929 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55934 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  55939 */     // GIR_Coverage, 7139,
     /*  55939 */     GIR_EraseRootFromParent_Done,
     /*  55940 */   // Label 891: @55940
     /*  55940 */   GIM_Try, /*On fail goto*//*Label 892*/ GIMT_Encode4(56039), // Rule ID 7140 //
     /*  55945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  55949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  55953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  55957 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  55960 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /*  55965 */     // MIs[1] addr
     /*  55965 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  55969 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  55974 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /*  55978 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  55989 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  55991 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  55991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  55994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /*  55998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56003 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56012 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56019 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56022 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56025 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56028 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56033 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56038 */     // GIR_Coverage, 7140,
     /*  56038 */     GIR_EraseRootFromParent_Done,
     /*  56039 */   // Label 892: @56039
     /*  56039 */   GIM_Try, /*On fail goto*//*Label 893*/ GIMT_Encode4(56138), // Rule ID 7145 //
     /*  56044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56052 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56056 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56059 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56064 */     // MIs[1] addr
     /*  56064 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56073 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /*  56077 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(255),
     /*  56088 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56090 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>, 255:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56090 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56093 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /*  56097 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56102 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56106 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56111 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56118 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56121 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56124 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56132 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56137 */     // GIR_Coverage, 7145,
     /*  56137 */     GIR_EraseRootFromParent_Done,
     /*  56138 */   // Label 893: @56138
     /*  56138 */   GIM_Try, /*On fail goto*//*Label 894*/ GIMT_Encode4(56237), // Rule ID 7146 //
     /*  56143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56155 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56158 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56163 */     // MIs[1] addr
     /*  56163 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56167 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56172 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /*  56176 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(65535),
     /*  56187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56189 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>, 65535:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /*  56196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56201 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56205 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56217 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56220 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56226 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56231 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56236 */     // GIR_Coverage, 7146,
     /*  56236 */     GIR_EraseRootFromParent_Done,
     /*  56237 */   // Label 894: @56237
     /*  56237 */   GIM_Try, /*On fail goto*//*Label 895*/ GIMT_Encode4(56336), // Rule ID 7147 //
     /*  56242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_W_SIDE_EFFECTS),
     /*  56254 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /*  56257 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /*  56262 */     // MIs[1] addr
     /*  56262 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/2, /*SizeInBits*/64,
     /*  56266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56271 */     GIM_CheckCxxInsnPredicate, /*MI*/1, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /*  56275 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56288 */     // (and:{ *:[i64] } (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /*  56288 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56291 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /*  56295 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56300 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // addr
     /*  56304 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /*  56309 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56319 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56322 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56335 */     // GIR_Coverage, 7147,
     /*  56335 */     GIR_EraseRootFromParent_Done,
     /*  56336 */   // Label 895: @56336
     /*  56336 */   GIM_Try, /*On fail goto*//*Label 896*/ GIMT_Encode4(56389), // Rule ID 13302 //
     /*  56341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56361 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56366 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56370 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56374 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56376 */     // (and:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56387 */     GIR_RootConstrainSelectedInstOperands,
     /*  56388 */     // GIR_Coverage, 13302,
     /*  56388 */     GIR_EraseRootFromParent_Done,
     /*  56389 */   // Label 896: @56389
     /*  56389 */   GIM_Try, /*On fail goto*//*Label 897*/ GIMT_Encode4(56442), // Rule ID 161 //
     /*  56394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56414 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56423 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  56427 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56429 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (BICXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICXrr),
     /*  56432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56436 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  56440 */     GIR_RootConstrainSelectedInstOperands,
     /*  56441 */     // GIR_Coverage, 161,
     /*  56441 */     GIR_EraseRootFromParent_Done,
     /*  56442 */   // Label 897: @56442
     /*  56442 */   GIM_Try, /*On fail goto*//*Label 898*/ GIMT_Encode4(56542), // Rule ID 4003 //
     /*  56447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56451 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56455 */     GIM_CheckConstantInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4294967295),
     /*  56466 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 4294967295:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (ORRWrr:{ *:[i32] } WZR:{ *:[i32] }, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rn, sub_32:{ *:[i32] })), sub_32:{ *:[i32] })
     /*  56466 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /*  56469 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /*  56473 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56478 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // Rn
     /*  56484 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56489 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /*  56497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  56501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  56506 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  56512 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  56515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  56517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  56520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  56522 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  56525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  56528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /*  56531 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /*  56536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  56541 */     // GIR_Coverage, 4003,
     /*  56541 */     GIR_EraseRootFromParent_Done,
     /*  56542 */   // Label 898: @56542
     /*  56542 */   GIM_Try, /*On fail goto*//*Label 899*/ GIMT_Encode4(56583), // Rule ID 143 //
     /*  56547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  56551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56559 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  56563 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  56567 */     // MIs[1] Operand 1
     /*  56567 */     // No operand predicates
     /*  56567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  56569 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ANDXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  56569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXri),
     /*  56572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56576 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  56581 */     GIR_RootConstrainSelectedInstOperands,
     /*  56582 */     // GIR_Coverage, 143,
     /*  56582 */     GIR_EraseRootFromParent_Done,
     /*  56583 */   // Label 899: @56583
     /*  56583 */   GIM_Try, /*On fail goto*//*Label 900*/ GIMT_Encode4(56616), // Rule ID 13300 //
     /*  56588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56596 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56603 */     // (and:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  56610 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56614 */     GIR_RootConstrainSelectedInstOperands,
     /*  56615 */     // GIR_Coverage, 13300,
     /*  56615 */     GIR_EraseRootFromParent_Done,
     /*  56616 */   // Label 900: @56616
     /*  56616 */   GIM_Try, /*On fail goto*//*Label 901*/ GIMT_Encode4(56649), // Rule ID 159 //
     /*  56621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56625 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56629 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  56636 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ANDXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  56636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDXrs),
     /*  56639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  56643 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  56647 */     GIR_RootConstrainSelectedInstOperands,
     /*  56648 */     // GIR_Coverage, 159,
     /*  56648 */     GIR_EraseRootFromParent_Done,
     /*  56649 */   // Label 901: @56649
     /*  56649 */   GIM_Try, /*On fail goto*//*Label 902*/ GIMT_Encode4(56713), // Rule ID 13968 //
     /*  56654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56677 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56686 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56692 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56698 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56700 */     // (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56705 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56711 */     GIR_RootConstrainSelectedInstOperands,
     /*  56712 */     // GIR_Coverage, 13968,
     /*  56712 */     GIR_EraseRootFromParent_Done,
     /*  56713 */   // Label 902: @56713
     /*  56713 */   GIM_Try, /*On fail goto*//*Label 903*/ GIMT_Encode4(56777), // Rule ID 5058 //
     /*  56718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  56741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  56745 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56750 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56754 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56760 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56762 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56764 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (BICv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56769 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56775 */     GIR_RootConstrainSelectedInstOperands,
     /*  56776 */     // GIR_Coverage, 5058,
     /*  56776 */     GIR_EraseRootFromParent_Done,
     /*  56777 */   // Label 903: @56777
     /*  56777 */   GIM_Try, /*On fail goto*//*Label 904*/ GIMT_Encode4(56801), // Rule ID 157 //
     /*  56782 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56786 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56790 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  56794 */     // (and:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ANDXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  56794 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDXrr),
     /*  56799 */     GIR_RootConstrainSelectedInstOperands,
     /*  56800 */     // GIR_Coverage, 157,
     /*  56800 */     GIR_Done,
     /*  56801 */   // Label 904: @56801
     /*  56801 */   GIM_Try, /*On fail goto*//*Label 905*/ GIMT_Encode4(56828), // Rule ID 2480 //
     /*  56806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56821 */     // (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ANDv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  56821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56826 */     GIR_RootConstrainSelectedInstOperands,
     /*  56827 */     // GIR_Coverage, 2480,
     /*  56827 */     GIR_Done,
     /*  56828 */   // Label 905: @56828
     /*  56828 */   GIM_Reject,
     /*  56829 */ // Label 885: @56829
     /*  56829 */ GIM_Reject,
     /*  56830 */ // Label 857: @56830
     /*  56830 */ GIM_Try, /*On fail goto*//*Label 906*/ GIMT_Encode4(56989),
     /*  56835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56845 */   GIM_Try, /*On fail goto*//*Label 907*/ GIMT_Encode4(56905), // Rule ID 13967 //
     /*  56850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  56857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56869 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56878 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56890 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56892 */     // (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56897 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  56899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56903 */     GIR_RootConstrainSelectedInstOperands,
     /*  56904 */     // GIR_Coverage, 13967,
     /*  56904 */     GIR_EraseRootFromParent_Done,
     /*  56905 */   // Label 907: @56905
     /*  56905 */   GIM_Try, /*On fail goto*//*Label 908*/ GIMT_Encode4(56965), // Rule ID 5057 //
     /*  56910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  56921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  56925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  56929 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  56933 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56938 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  56942 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  56948 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  56950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  56952 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (BICv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  56955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  56957 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  56959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  56963 */     GIR_RootConstrainSelectedInstOperands,
     /*  56964 */     // GIR_Coverage, 5057,
     /*  56964 */     GIR_EraseRootFromParent_Done,
     /*  56965 */   // Label 908: @56965
     /*  56965 */   GIM_Try, /*On fail goto*//*Label 909*/ GIMT_Encode4(56988), // Rule ID 2479 //
     /*  56970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  56973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  56981 */     // (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ANDv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  56981 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  56986 */     GIR_RootConstrainSelectedInstOperands,
     /*  56987 */     // GIR_Coverage, 2479,
     /*  56987 */     GIR_Done,
     /*  56988 */   // Label 909: @56988
     /*  56988 */   GIM_Reject,
     /*  56989 */ // Label 906: @56989
     /*  56989 */ GIM_Reject,
     /*  56990 */ // Label 858: @56990
     /*  56990 */ GIM_Try, /*On fail goto*//*Label 910*/ GIMT_Encode4(57149),
     /*  56995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  56998 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57001 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57005 */   GIM_Try, /*On fail goto*//*Label 911*/ GIMT_Encode4(57065), // Rule ID 13971 //
     /*  57010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57029 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57038 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57044 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57050 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57052 */     // (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57057 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57063 */     GIR_RootConstrainSelectedInstOperands,
     /*  57064 */     // GIR_Coverage, 13971,
     /*  57064 */     GIR_EraseRootFromParent_Done,
     /*  57065 */   // Label 911: @57065
     /*  57065 */   GIM_Try, /*On fail goto*//*Label 912*/ GIMT_Encode4(57125), // Rule ID 5061 //
     /*  57070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57073 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  57089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  57093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57102 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57112 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (BICv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57117 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57123 */     GIR_RootConstrainSelectedInstOperands,
     /*  57124 */     // GIR_Coverage, 5061,
     /*  57124 */     GIR_EraseRootFromParent_Done,
     /*  57125 */   // Label 912: @57125
     /*  57125 */   GIM_Try, /*On fail goto*//*Label 913*/ GIMT_Encode4(57148), // Rule ID 2483 //
     /*  57130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57141 */     // (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ANDv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  57141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57146 */     GIR_RootConstrainSelectedInstOperands,
     /*  57147 */     // GIR_Coverage, 2483,
     /*  57147 */     GIR_Done,
     /*  57148 */   // Label 913: @57148
     /*  57148 */   GIM_Reject,
     /*  57149 */ // Label 910: @57149
     /*  57149 */ GIM_Reject,
     /*  57150 */ // Label 859: @57150
     /*  57150 */ GIM_Try, /*On fail goto*//*Label 914*/ GIMT_Encode4(57309),
     /*  57155 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57158 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57165 */   GIM_Try, /*On fail goto*//*Label 915*/ GIMT_Encode4(57225), // Rule ID 13966 //
     /*  57170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57198 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57212 */     // (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57217 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57223 */     GIR_RootConstrainSelectedInstOperands,
     /*  57224 */     // GIR_Coverage, 13966,
     /*  57224 */     GIR_EraseRootFromParent_Done,
     /*  57225 */   // Label 915: @57225
     /*  57225 */   GIM_Try, /*On fail goto*//*Label 916*/ GIMT_Encode4(57285), // Rule ID 5056 //
     /*  57230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57233 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  57249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  57253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57262 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57268 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57270 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57272 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (BICv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57277 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57283 */     GIR_RootConstrainSelectedInstOperands,
     /*  57284 */     // GIR_Coverage, 5056,
     /*  57284 */     GIR_EraseRootFromParent_Done,
     /*  57285 */   // Label 916: @57285
     /*  57285 */   GIM_Try, /*On fail goto*//*Label 917*/ GIMT_Encode4(57308), // Rule ID 2478 //
     /*  57290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57301 */     // (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ANDv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  57301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57306 */     GIR_RootConstrainSelectedInstOperands,
     /*  57307 */     // GIR_Coverage, 2478,
     /*  57307 */     GIR_Done,
     /*  57308 */   // Label 917: @57308
     /*  57308 */   GIM_Reject,
     /*  57309 */ // Label 914: @57309
     /*  57309 */ GIM_Reject,
     /*  57310 */ // Label 860: @57310
     /*  57310 */ GIM_Try, /*On fail goto*//*Label 918*/ GIMT_Encode4(57469),
     /*  57315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57318 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57321 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57325 */   GIM_Try, /*On fail goto*//*Label 919*/ GIMT_Encode4(57385), // Rule ID 13970 //
     /*  57330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57358 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57370 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57372 */     // (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57377 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57383 */     GIR_RootConstrainSelectedInstOperands,
     /*  57384 */     // GIR_Coverage, 13970,
     /*  57384 */     GIR_EraseRootFromParent_Done,
     /*  57385 */   // Label 919: @57385
     /*  57385 */   GIM_Try, /*On fail goto*//*Label 920*/ GIMT_Encode4(57445), // Rule ID 5060 //
     /*  57390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57393 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  57409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  57413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57428 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57432 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (BICv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57437 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57443 */     GIR_RootConstrainSelectedInstOperands,
     /*  57444 */     // GIR_Coverage, 5060,
     /*  57444 */     GIR_EraseRootFromParent_Done,
     /*  57445 */   // Label 920: @57445
     /*  57445 */   GIM_Try, /*On fail goto*//*Label 921*/ GIMT_Encode4(57468), // Rule ID 2482 //
     /*  57450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57453 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57461 */     // (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ANDv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  57461 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57466 */     GIR_RootConstrainSelectedInstOperands,
     /*  57467 */     // GIR_Coverage, 2482,
     /*  57467 */     GIR_Done,
     /*  57468 */   // Label 921: @57468
     /*  57468 */   GIM_Reject,
     /*  57469 */ // Label 918: @57469
     /*  57469 */ GIM_Reject,
     /*  57470 */ // Label 861: @57470
     /*  57470 */ GIM_Try, /*On fail goto*//*Label 922*/ GIMT_Encode4(57629),
     /*  57475 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57478 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57485 */   GIM_Try, /*On fail goto*//*Label 923*/ GIMT_Encode4(57545), // Rule ID 13439 //
     /*  57490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57518 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57524 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57532 */     // (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57543 */     GIR_RootConstrainSelectedInstOperands,
     /*  57544 */     // GIR_Coverage, 13439,
     /*  57544 */     GIR_EraseRootFromParent_Done,
     /*  57545 */   // Label 923: @57545
     /*  57545 */   GIM_Try, /*On fail goto*//*Label 924*/ GIMT_Encode4(57605), // Rule ID 1597 //
     /*  57550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  57569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  57573 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57578 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57582 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57592 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (BICv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i8),
     /*  57595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57603 */     GIR_RootConstrainSelectedInstOperands,
     /*  57604 */     // GIR_Coverage, 1597,
     /*  57604 */     GIR_EraseRootFromParent_Done,
     /*  57605 */   // Label 924: @57605
     /*  57605 */   GIM_Try, /*On fail goto*//*Label 925*/ GIMT_Encode4(57628), // Rule ID 1595 //
     /*  57610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  57621 */     // (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ANDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  57621 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv8i8),
     /*  57626 */     GIR_RootConstrainSelectedInstOperands,
     /*  57627 */     // GIR_Coverage, 1595,
     /*  57627 */     GIR_Done,
     /*  57628 */   // Label 925: @57628
     /*  57628 */   GIM_Reject,
     /*  57629 */ // Label 922: @57629
     /*  57629 */ GIM_Reject,
     /*  57630 */ // Label 862: @57630
     /*  57630 */ GIM_Try, /*On fail goto*//*Label 926*/ GIMT_Encode4(57789),
     /*  57635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57645 */   GIM_Try, /*On fail goto*//*Label 927*/ GIMT_Encode4(57705), // Rule ID 13969 //
     /*  57650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57678 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57684 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57692 */     // (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57697 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  57699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57703 */     GIR_RootConstrainSelectedInstOperands,
     /*  57704 */     // GIR_Coverage, 13969,
     /*  57704 */     GIR_EraseRootFromParent_Done,
     /*  57705 */   // Label 927: @57705
     /*  57705 */   GIM_Try, /*On fail goto*//*Label 928*/ GIMT_Encode4(57765), // Rule ID 5059 //
     /*  57710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  57729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  57733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57742 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57748 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57750 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57752 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (BICv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57757 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  57759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  57763 */     GIR_RootConstrainSelectedInstOperands,
     /*  57764 */     // GIR_Coverage, 5059,
     /*  57764 */     GIR_EraseRootFromParent_Done,
     /*  57765 */   // Label 928: @57765
     /*  57765 */   GIM_Try, /*On fail goto*//*Label 929*/ GIMT_Encode4(57788), // Rule ID 2481 //
     /*  57770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57777 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57781 */     // (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ANDv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  57781 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57786 */     GIR_RootConstrainSelectedInstOperands,
     /*  57787 */     // GIR_Coverage, 2481,
     /*  57787 */     GIR_Done,
     /*  57788 */   // Label 929: @57788
     /*  57788 */   GIM_Reject,
     /*  57789 */ // Label 926: @57789
     /*  57789 */ GIM_Reject,
     /*  57790 */ // Label 863: @57790
     /*  57790 */ GIM_Try, /*On fail goto*//*Label 930*/ GIMT_Encode4(57949),
     /*  57795 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57798 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57801 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57805 */   GIM_Try, /*On fail goto*//*Label 931*/ GIMT_Encode4(57865), // Rule ID 13440 //
     /*  57810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57813 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57817 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57821 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57825 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57829 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57834 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57838 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57852 */     // (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  57859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57863 */     GIR_RootConstrainSelectedInstOperands,
     /*  57864 */     // GIR_Coverage, 13440,
     /*  57864 */     GIR_EraseRootFromParent_Done,
     /*  57865 */   // Label 931: @57865
     /*  57865 */   GIM_Try, /*On fail goto*//*Label 932*/ GIMT_Encode4(57925), // Rule ID 1598 //
     /*  57870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57873 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  57881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  57889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  57893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  57902 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  57908 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  57910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  57912 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (BICv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv16i8),
     /*  57915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  57917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  57919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  57923 */     GIR_RootConstrainSelectedInstOperands,
     /*  57924 */     // GIR_Coverage, 1598,
     /*  57924 */     GIR_EraseRootFromParent_Done,
     /*  57925 */   // Label 932: @57925
     /*  57925 */   GIM_Try, /*On fail goto*//*Label 933*/ GIMT_Encode4(57948), // Rule ID 1596 //
     /*  57930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  57933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  57941 */     // (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ANDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  57941 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ANDv16i8),
     /*  57946 */     GIR_RootConstrainSelectedInstOperands,
     /*  57947 */     // GIR_Coverage, 1596,
     /*  57947 */     GIR_Done,
     /*  57948 */   // Label 933: @57948
     /*  57948 */   GIM_Reject,
     /*  57949 */ // Label 930: @57949
     /*  57949 */ GIM_Reject,
     /*  57950 */ // Label 864: @57950
     /*  57950 */ GIM_Try, /*On fail goto*//*Label 934*/ GIMT_Encode4(58490),
     /*  57955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57958 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  57965 */   GIM_Try, /*On fail goto*//*Label 935*/ GIMT_Encode4(58022), // Rule ID 15163 //
     /*  57970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  57973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  57977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  57981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  57985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  57989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  57993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  57997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58001 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58005 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58007 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58020 */     GIR_RootConstrainSelectedInstOperands,
     /*  58021 */     // GIR_Coverage, 15163,
     /*  58021 */     GIR_EraseRootFromParent_Done,
     /*  58022 */   // Label 935: @58022
     /*  58022 */   GIM_Try, /*On fail goto*//*Label 936*/ GIMT_Encode4(58079), // Rule ID 15166 //
     /*  58027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58054 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58058 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58062 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58064 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58071 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58077 */     GIR_RootConstrainSelectedInstOperands,
     /*  58078 */     // GIR_Coverage, 15166,
     /*  58078 */     GIR_EraseRootFromParent_Done,
     /*  58079 */   // Label 936: @58079
     /*  58079 */   GIM_Try, /*On fail goto*//*Label 937*/ GIMT_Encode4(58136), // Rule ID 15162 //
     /*  58084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58119 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58121 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58126 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58134 */     GIR_RootConstrainSelectedInstOperands,
     /*  58135 */     // GIR_Coverage, 15162,
     /*  58135 */     GIR_EraseRootFromParent_Done,
     /*  58136 */   // Label 937: @58136
     /*  58136 */   GIM_Try, /*On fail goto*//*Label 938*/ GIMT_Encode4(58193), // Rule ID 15165 //
     /*  58141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58156 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58168 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58172 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58176 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58178 */     // (and:{ *:[nxv1i1] } (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })), nxv1i1:{ *:[nxv1i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58191 */     GIR_RootConstrainSelectedInstOperands,
     /*  58192 */     // GIR_Coverage, 15165,
     /*  58192 */     GIR_EraseRootFromParent_Done,
     /*  58193 */   // Label 938: @58193
     /*  58193 */   GIM_Try, /*On fail goto*//*Label 939*/ GIMT_Encode4(58250), // Rule ID 15161 //
     /*  58198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58229 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58235 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58248 */     GIR_RootConstrainSelectedInstOperands,
     /*  58249 */     // GIR_Coverage, 15161,
     /*  58249 */     GIR_EraseRootFromParent_Done,
     /*  58250 */   // Label 939: @58250
     /*  58250 */   GIM_Try, /*On fail goto*//*Label 940*/ GIMT_Encode4(58307), // Rule ID 15164 //
     /*  58255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58258 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58262 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58266 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58270 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58286 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58290 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58292 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] }), nxv1i1:{ *:[nxv1i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58299 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58305 */     GIR_RootConstrainSelectedInstOperands,
     /*  58306 */     // GIR_Coverage, 15164,
     /*  58306 */     GIR_EraseRootFromParent_Done,
     /*  58307 */   // Label 940: @58307
     /*  58307 */   GIM_Try, /*On fail goto*//*Label 941*/ GIMT_Encode4(58364), // Rule ID 8481 //
     /*  58312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58331 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58335 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58339 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58343 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58347 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58349 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58354 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58362 */     GIR_RootConstrainSelectedInstOperands,
     /*  58363 */     // GIR_Coverage, 8481,
     /*  58363 */     GIR_EraseRootFromParent_Done,
     /*  58364 */   // Label 941: @58364
     /*  58364 */   GIM_Try, /*On fail goto*//*Label 942*/ GIMT_Encode4(58421), // Rule ID 8482 //
     /*  58369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  58384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  58388 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58392 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58396 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58400 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58406 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op2, (splat_vector:{ *:[nxv1i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58413 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58415 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58419 */     GIR_RootConstrainSelectedInstOperands,
     /*  58420 */     // GIR_Coverage, 8482,
     /*  58420 */     GIR_EraseRootFromParent_Done,
     /*  58421 */   // Label 942: @58421
     /*  58421 */   GIM_Try, /*On fail goto*//*Label 943*/ GIMT_Encode4(58468), // Rule ID 10745 //
     /*  58426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58437 */     // (and:{ *:[nxv1i1] } PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv1i1] }:$Ps1, PPR:{ *:[nxv1i1] }:$Ps2)
     /*  58437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58459 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  58462 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  58464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  58466 */     GIR_RootConstrainSelectedInstOperands,
     /*  58467 */     // GIR_Coverage, 10745,
     /*  58467 */     GIR_EraseRootFromParent_Done,
     /*  58468 */   // Label 943: @58468
     /*  58468 */   GIM_Try, /*On fail goto*//*Label 944*/ GIMT_Encode4(58489), // Rule ID 2749 //
     /*  58473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58476 */     // (and:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  58476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  58487 */     GIR_RootConstrainSelectedInstOperands,
     /*  58488 */     // GIR_Coverage, 2749,
     /*  58488 */     GIR_EraseRootFromParent_Done,
     /*  58489 */   // Label 944: @58489
     /*  58489 */   GIM_Reject,
     /*  58490 */ // Label 934: @58490
     /*  58490 */ GIM_Reject,
     /*  58491 */ // Label 865: @58491
     /*  58491 */ GIM_Try, /*On fail goto*//*Label 945*/ GIMT_Encode4(59031),
     /*  58496 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58499 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  58506 */   GIM_Try, /*On fail goto*//*Label 946*/ GIMT_Encode4(58563), // Rule ID 15154 //
     /*  58511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58526 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58530 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58534 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58538 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58542 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58546 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58548 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58561 */     GIR_RootConstrainSelectedInstOperands,
     /*  58562 */     // GIR_Coverage, 15154,
     /*  58562 */     GIR_EraseRootFromParent_Done,
     /*  58563 */   // Label 946: @58563
     /*  58563 */   GIM_Try, /*On fail goto*//*Label 947*/ GIMT_Encode4(58620), // Rule ID 15157 //
     /*  58568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58587 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58591 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58595 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58599 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58603 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58605 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58614 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58618 */     GIR_RootConstrainSelectedInstOperands,
     /*  58619 */     // GIR_Coverage, 15157,
     /*  58619 */     GIR_EraseRootFromParent_Done,
     /*  58620 */   // Label 947: @58620
     /*  58620 */   GIM_Try, /*On fail goto*//*Label 948*/ GIMT_Encode4(58677), // Rule ID 15153 //
     /*  58625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58652 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58656 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58662 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58675 */     GIR_RootConstrainSelectedInstOperands,
     /*  58676 */     // GIR_Coverage, 15153,
     /*  58676 */     GIR_EraseRootFromParent_Done,
     /*  58677 */   // Label 948: @58677
     /*  58677 */   GIM_Try, /*On fail goto*//*Label 949*/ GIMT_Encode4(58734), // Rule ID 15156 //
     /*  58682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  58689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58713 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58717 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58719 */     // (and:{ *:[nxv2i1] } (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })), nxv2i1:{ *:[nxv2i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  58728 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58732 */     GIR_RootConstrainSelectedInstOperands,
     /*  58733 */     // GIR_Coverage, 15156,
     /*  58733 */     GIR_EraseRootFromParent_Done,
     /*  58734 */   // Label 949: @58734
     /*  58734 */   GIM_Try, /*On fail goto*//*Label 950*/ GIMT_Encode4(58791), // Rule ID 15152 //
     /*  58739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58770 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58776 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58789 */     GIR_RootConstrainSelectedInstOperands,
     /*  58790 */     // GIR_Coverage, 15152,
     /*  58790 */     GIR_EraseRootFromParent_Done,
     /*  58791 */   // Label 950: @58791
     /*  58791 */   GIM_Try, /*On fail goto*//*Label 951*/ GIMT_Encode4(58848), // Rule ID 15155 //
     /*  58796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  58819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58823 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58827 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58833 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] }), nxv2i1:{ *:[nxv2i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58840 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  58846 */     GIR_RootConstrainSelectedInstOperands,
     /*  58847 */     // GIR_Coverage, 15155,
     /*  58847 */     GIR_EraseRootFromParent_Done,
     /*  58848 */   // Label 951: @58848
     /*  58848 */   GIM_Try, /*On fail goto*//*Label 952*/ GIMT_Encode4(58905), // Rule ID 8477 //
     /*  58853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58868 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  58884 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58888 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58890 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58897 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58903 */     GIR_RootConstrainSelectedInstOperands,
     /*  58904 */     // GIR_Coverage, 8477,
     /*  58904 */     GIR_EraseRootFromParent_Done,
     /*  58905 */   // Label 952: @58905
     /*  58905 */   GIM_Try, /*On fail goto*//*Label 953*/ GIMT_Encode4(58962), // Rule ID 8478 //
     /*  58910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  58917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  58921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  58925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  58929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  58933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  58937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  58941 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  58945 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  58947 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op2, (splat_vector:{ *:[nxv2i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  58947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  58950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  58952 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  58956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  58960 */     GIR_RootConstrainSelectedInstOperands,
     /*  58961 */     // GIR_Coverage, 8478,
     /*  58961 */     GIR_EraseRootFromParent_Done,
     /*  58962 */   // Label 953: @58962
     /*  58962 */   GIM_Try, /*On fail goto*//*Label 954*/ GIMT_Encode4(59009), // Rule ID 10744 //
     /*  58967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  58970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  58978 */     // (and:{ *:[nxv2i1] } PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv2i1] }:$Ps1, PPR:{ *:[nxv2i1] }:$Ps2)
     /*  58978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  58981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  58985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  58990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  58993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  58995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  58998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  59003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  59005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  59007 */     GIR_RootConstrainSelectedInstOperands,
     /*  59008 */     // GIR_Coverage, 10744,
     /*  59008 */     GIR_EraseRootFromParent_Done,
     /*  59009 */   // Label 954: @59009
     /*  59009 */   GIM_Try, /*On fail goto*//*Label 955*/ GIMT_Encode4(59030), // Rule ID 2748 //
     /*  59014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59017 */     // (and:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  59017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  59020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59024 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  59028 */     GIR_RootConstrainSelectedInstOperands,
     /*  59029 */     // GIR_Coverage, 2748,
     /*  59029 */     GIR_EraseRootFromParent_Done,
     /*  59030 */   // Label 955: @59030
     /*  59030 */   GIM_Reject,
     /*  59031 */ // Label 945: @59031
     /*  59031 */ GIM_Reject,
     /*  59032 */ // Label 866: @59032
     /*  59032 */ GIM_Try, /*On fail goto*//*Label 956*/ GIMT_Encode4(59503),
     /*  59037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  59047 */   GIM_Try, /*On fail goto*//*Label 957*/ GIMT_Encode4(59102), // Rule ID 15094 //
     /*  59052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59083 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59089 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59100 */     GIR_RootConstrainSelectedInstOperands,
     /*  59101 */     // GIR_Coverage, 15094,
     /*  59101 */     GIR_EraseRootFromParent_Done,
     /*  59102 */   // Label 957: @59102
     /*  59102 */   GIM_Try, /*On fail goto*//*Label 958*/ GIMT_Encode4(59157), // Rule ID 15097 //
     /*  59107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59138 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59144 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59155 */     GIR_RootConstrainSelectedInstOperands,
     /*  59156 */     // GIR_Coverage, 15097,
     /*  59156 */     GIR_EraseRootFromParent_Done,
     /*  59157 */   // Label 958: @59157
     /*  59157 */   GIM_Try, /*On fail goto*//*Label 959*/ GIMT_Encode4(59212), // Rule ID 15093 //
     /*  59162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59193 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59197 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59199 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59210 */     GIR_RootConstrainSelectedInstOperands,
     /*  59211 */     // GIR_Coverage, 15093,
     /*  59211 */     GIR_EraseRootFromParent_Done,
     /*  59212 */   // Label 959: @59212
     /*  59212 */   GIM_Try, /*On fail goto*//*Label 960*/ GIMT_Encode4(59267), // Rule ID 15096 //
     /*  59217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59220 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59224 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59228 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59232 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59244 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59248 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59254 */     // (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59265 */     GIR_RootConstrainSelectedInstOperands,
     /*  59266 */     // GIR_Coverage, 15096,
     /*  59266 */     GIR_EraseRootFromParent_Done,
     /*  59267 */   // Label 960: @59267
     /*  59267 */   GIM_Try, /*On fail goto*//*Label 961*/ GIMT_Encode4(59322), // Rule ID 15092 //
     /*  59272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59275 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59279 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59283 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59299 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59303 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59307 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59309 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59320 */     GIR_RootConstrainSelectedInstOperands,
     /*  59321 */     // GIR_Coverage, 15092,
     /*  59321 */     GIR_EraseRootFromParent_Done,
     /*  59322 */   // Label 961: @59322
     /*  59322 */   GIM_Try, /*On fail goto*//*Label 962*/ GIMT_Encode4(59377), // Rule ID 15095 //
     /*  59327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59354 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59358 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59364 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59375 */     GIR_RootConstrainSelectedInstOperands,
     /*  59376 */     // GIR_Coverage, 15095,
     /*  59376 */     GIR_EraseRootFromParent_Done,
     /*  59377 */   // Label 962: @59377
     /*  59377 */   GIM_Try, /*On fail goto*//*Label 963*/ GIMT_Encode4(59432), // Rule ID 7526 //
     /*  59382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59397 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59413 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59417 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59419 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59424 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59426 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59430 */     GIR_RootConstrainSelectedInstOperands,
     /*  59431 */     // GIR_Coverage, 7526,
     /*  59431 */     GIR_EraseRootFromParent_Done,
     /*  59432 */   // Label 963: @59432
     /*  59432 */   GIM_Try, /*On fail goto*//*Label 964*/ GIMT_Encode4(59487), // Rule ID 7527 //
     /*  59437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  59452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  59456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59460 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59464 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59468 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59472 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59474 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (splat_vector:{ *:[nxv2i64] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  59477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  59479 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59485 */     GIR_RootConstrainSelectedInstOperands,
     /*  59486 */     // GIR_Coverage, 7527,
     /*  59486 */     GIR_EraseRootFromParent_Done,
     /*  59487 */   // Label 964: @59487
     /*  59487 */   GIM_Try, /*On fail goto*//*Label 965*/ GIMT_Encode4(59502), // Rule ID 3142 //
     /*  59492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59495 */     // (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  59495 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  59500 */     GIR_RootConstrainSelectedInstOperands,
     /*  59501 */     // GIR_Coverage, 3142,
     /*  59501 */     GIR_Done,
     /*  59502 */   // Label 965: @59502
     /*  59502 */   GIM_Reject,
     /*  59503 */ // Label 956: @59503
     /*  59503 */ GIM_Reject,
     /*  59504 */ // Label 867: @59504
     /*  59504 */ GIM_Try, /*On fail goto*//*Label 966*/ GIMT_Encode4(60044),
     /*  59509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  59519 */   GIM_Try, /*On fail goto*//*Label 967*/ GIMT_Encode4(59576), // Rule ID 15145 //
     /*  59524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59531 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59535 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59539 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59543 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59547 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59551 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59555 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59559 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59561 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59574 */     GIR_RootConstrainSelectedInstOperands,
     /*  59575 */     // GIR_Coverage, 15145,
     /*  59575 */     GIR_EraseRootFromParent_Done,
     /*  59576 */   // Label 967: @59576
     /*  59576 */   GIM_Try, /*On fail goto*//*Label 968*/ GIMT_Encode4(59633), // Rule ID 15148 //
     /*  59581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59596 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59612 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59616 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59618 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59631 */     GIR_RootConstrainSelectedInstOperands,
     /*  59632 */     // GIR_Coverage, 15148,
     /*  59632 */     GIR_EraseRootFromParent_Done,
     /*  59633 */   // Label 968: @59633
     /*  59633 */   GIM_Try, /*On fail goto*//*Label 969*/ GIMT_Encode4(59690), // Rule ID 15144 //
     /*  59638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59665 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59669 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59673 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59675 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59675 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59678 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59680 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59688 */     GIR_RootConstrainSelectedInstOperands,
     /*  59689 */     // GIR_Coverage, 15144,
     /*  59689 */     GIR_EraseRootFromParent_Done,
     /*  59690 */   // Label 969: @59690
     /*  59690 */   GIM_Try, /*On fail goto*//*Label 970*/ GIMT_Encode4(59747), // Rule ID 15147 //
     /*  59695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59698 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  59702 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59706 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59710 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59726 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59730 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59732 */     // (and:{ *:[nxv4i1] } (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })), nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  59741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59745 */     GIR_RootConstrainSelectedInstOperands,
     /*  59746 */     // GIR_Coverage, 15147,
     /*  59746 */     GIR_EraseRootFromParent_Done,
     /*  59747 */   // Label 970: @59747
     /*  59747 */   GIM_Try, /*On fail goto*//*Label 971*/ GIMT_Encode4(59804), // Rule ID 15143 //
     /*  59752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59783 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59789 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59802 */     GIR_RootConstrainSelectedInstOperands,
     /*  59803 */     // GIR_Coverage, 15143,
     /*  59803 */     GIR_EraseRootFromParent_Done,
     /*  59804 */   // Label 971: @59804
     /*  59804 */   GIM_Try, /*On fail goto*//*Label 972*/ GIMT_Encode4(59861), // Rule ID 15146 //
     /*  59809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  59832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59840 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59844 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59846 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] }), nxv4i1:{ *:[nxv4i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59853 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  59859 */     GIR_RootConstrainSelectedInstOperands,
     /*  59860 */     // GIR_Coverage, 15146,
     /*  59860 */     GIR_EraseRootFromParent_Done,
     /*  59861 */   // Label 972: @59861
     /*  59861 */   GIM_Try, /*On fail goto*//*Label 973*/ GIMT_Encode4(59918), // Rule ID 8473 //
     /*  59866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59869 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59873 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59877 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59881 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59885 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59889 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59893 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  59897 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59903 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59908 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59910 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59916 */     GIR_RootConstrainSelectedInstOperands,
     /*  59917 */     // GIR_Coverage, 8473,
     /*  59917 */     GIR_EraseRootFromParent_Done,
     /*  59918 */   // Label 973: @59918
     /*  59918 */   GIM_Try, /*On fail goto*//*Label 974*/ GIMT_Encode4(59975), // Rule ID 8474 //
     /*  59923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  59930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  59934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  59938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  59942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  59946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  59950 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  59954 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  59958 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  59960 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op2, (splat_vector:{ *:[nxv4i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  59960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  59963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  59965 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  59969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  59973 */     GIR_RootConstrainSelectedInstOperands,
     /*  59974 */     // GIR_Coverage, 8474,
     /*  59974 */     GIR_EraseRootFromParent_Done,
     /*  59975 */   // Label 974: @59975
     /*  59975 */   GIM_Try, /*On fail goto*//*Label 975*/ GIMT_Encode4(60022), // Rule ID 10743 //
     /*  59980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  59983 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  59991 */     // (and:{ *:[nxv4i1] } PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv4i1] }:$Ps1, PPR:{ *:[nxv4i1] }:$Ps2)
     /*  59991 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  59994 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  59998 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  60003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  60006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  60008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  60016 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  60018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  60020 */     GIR_RootConstrainSelectedInstOperands,
     /*  60021 */     // GIR_Coverage, 10743,
     /*  60021 */     GIR_EraseRootFromParent_Done,
     /*  60022 */   // Label 975: @60022
     /*  60022 */   GIM_Try, /*On fail goto*//*Label 976*/ GIMT_Encode4(60043), // Rule ID 2747 //
     /*  60027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60030 */     // (and:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  60030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  60033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60035 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  60041 */     GIR_RootConstrainSelectedInstOperands,
     /*  60042 */     // GIR_Coverage, 2747,
     /*  60042 */     GIR_EraseRootFromParent_Done,
     /*  60043 */   // Label 976: @60043
     /*  60043 */   GIM_Reject,
     /*  60044 */ // Label 966: @60044
     /*  60044 */ GIM_Reject,
     /*  60045 */ // Label 868: @60045
     /*  60045 */ GIM_Try, /*On fail goto*//*Label 977*/ GIMT_Encode4(60516),
     /*  60050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60053 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60056 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  60060 */   GIM_Try, /*On fail goto*//*Label 978*/ GIMT_Encode4(60115), // Rule ID 15085 //
     /*  60065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60096 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60100 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60102 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60113 */     GIR_RootConstrainSelectedInstOperands,
     /*  60114 */     // GIR_Coverage, 15085,
     /*  60114 */     GIR_EraseRootFromParent_Done,
     /*  60115 */   // Label 978: @60115
     /*  60115 */   GIM_Try, /*On fail goto*//*Label 979*/ GIMT_Encode4(60170), // Rule ID 15088 //
     /*  60120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60151 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60155 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60157 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60168 */     GIR_RootConstrainSelectedInstOperands,
     /*  60169 */     // GIR_Coverage, 15088,
     /*  60169 */     GIR_EraseRootFromParent_Done,
     /*  60170 */   // Label 979: @60170
     /*  60170 */   GIM_Try, /*On fail goto*//*Label 980*/ GIMT_Encode4(60225), // Rule ID 15084 //
     /*  60175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60178 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60182 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60186 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60190 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60194 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60198 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60202 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60212 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60223 */     GIR_RootConstrainSelectedInstOperands,
     /*  60224 */     // GIR_Coverage, 15084,
     /*  60224 */     GIR_EraseRootFromParent_Done,
     /*  60225 */   // Label 980: @60225
     /*  60225 */   GIM_Try, /*On fail goto*//*Label 981*/ GIMT_Encode4(60280), // Rule ID 15087 //
     /*  60230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60261 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60265 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60267 */     // (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60274 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60278 */     GIR_RootConstrainSelectedInstOperands,
     /*  60279 */     // GIR_Coverage, 15087,
     /*  60279 */     GIR_EraseRootFromParent_Done,
     /*  60280 */   // Label 981: @60280
     /*  60280 */   GIM_Try, /*On fail goto*//*Label 982*/ GIMT_Encode4(60335), // Rule ID 15083 //
     /*  60285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60292 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60296 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60300 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60304 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60308 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60312 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60316 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60322 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60333 */     GIR_RootConstrainSelectedInstOperands,
     /*  60334 */     // GIR_Coverage, 15083,
     /*  60334 */     GIR_EraseRootFromParent_Done,
     /*  60335 */   // Label 982: @60335
     /*  60335 */   GIM_Try, /*On fail goto*//*Label 983*/ GIMT_Encode4(60390), // Rule ID 15086 //
     /*  60340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60371 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60375 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60377 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60382 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60384 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60388 */     GIR_RootConstrainSelectedInstOperands,
     /*  60389 */     // GIR_Coverage, 15086,
     /*  60389 */     GIR_EraseRootFromParent_Done,
     /*  60390 */   // Label 983: @60390
     /*  60390 */   GIM_Try, /*On fail goto*//*Label 984*/ GIMT_Encode4(60445), // Rule ID 7522 //
     /*  60395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60426 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60430 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60432 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60437 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60443 */     GIR_RootConstrainSelectedInstOperands,
     /*  60444 */     // GIR_Coverage, 7522,
     /*  60444 */     GIR_EraseRootFromParent_Done,
     /*  60445 */   // Label 984: @60445
     /*  60445 */   GIM_Try, /*On fail goto*//*Label 985*/ GIMT_Encode4(60500), // Rule ID 7523 //
     /*  60450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  60465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  60469 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60473 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60477 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60485 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60487 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (splat_vector:{ *:[nxv4i32] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  60490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  60492 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60498 */     GIR_RootConstrainSelectedInstOperands,
     /*  60499 */     // GIR_Coverage, 7523,
     /*  60499 */     GIR_EraseRootFromParent_Done,
     /*  60500 */   // Label 985: @60500
     /*  60500 */   GIM_Try, /*On fail goto*//*Label 986*/ GIMT_Encode4(60515), // Rule ID 3141 //
     /*  60505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60508 */     // (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  60508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  60513 */     GIR_RootConstrainSelectedInstOperands,
     /*  60514 */     // GIR_Coverage, 3141,
     /*  60514 */     GIR_Done,
     /*  60515 */   // Label 986: @60515
     /*  60515 */   GIM_Reject,
     /*  60516 */ // Label 977: @60516
     /*  60516 */ GIM_Reject,
     /*  60517 */ // Label 869: @60517
     /*  60517 */ GIM_Try, /*On fail goto*//*Label 987*/ GIMT_Encode4(61057),
     /*  60522 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60525 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60528 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  60532 */   GIM_Try, /*On fail goto*//*Label 988*/ GIMT_Encode4(60589), // Rule ID 15136 //
     /*  60537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60540 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60544 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60548 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60568 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60574 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60587 */     GIR_RootConstrainSelectedInstOperands,
     /*  60588 */     // GIR_Coverage, 15136,
     /*  60588 */     GIR_EraseRootFromParent_Done,
     /*  60589 */   // Label 988: @60589
     /*  60589 */   GIM_Try, /*On fail goto*//*Label 989*/ GIMT_Encode4(60646), // Rule ID 15139 //
     /*  60594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60609 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60625 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60629 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60631 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60644 */     GIR_RootConstrainSelectedInstOperands,
     /*  60645 */     // GIR_Coverage, 15139,
     /*  60645 */     GIR_EraseRootFromParent_Done,
     /*  60646 */   // Label 989: @60646
     /*  60646 */   GIM_Try, /*On fail goto*//*Label 990*/ GIMT_Encode4(60703), // Rule ID 15135 //
     /*  60651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60678 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60682 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60686 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60688 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60701 */     GIR_RootConstrainSelectedInstOperands,
     /*  60702 */     // GIR_Coverage, 15135,
     /*  60702 */     GIR_EraseRootFromParent_Done,
     /*  60703 */   // Label 990: @60703
     /*  60703 */   GIM_Try, /*On fail goto*//*Label 991*/ GIMT_Encode4(60760), // Rule ID 15138 //
     /*  60708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  60715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60735 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60739 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60745 */     // (and:{ *:[nxv8i1] } (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })), nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  60754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60758 */     GIR_RootConstrainSelectedInstOperands,
     /*  60759 */     // GIR_Coverage, 15138,
     /*  60759 */     GIR_EraseRootFromParent_Done,
     /*  60760 */   // Label 991: @60760
     /*  60760 */   GIM_Try, /*On fail goto*//*Label 992*/ GIMT_Encode4(60817), // Rule ID 15134 //
     /*  60765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60780 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60784 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60788 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60792 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60796 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60802 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60807 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60809 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60811 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60815 */     GIR_RootConstrainSelectedInstOperands,
     /*  60816 */     // GIR_Coverage, 15134,
     /*  60816 */     GIR_EraseRootFromParent_Done,
     /*  60817 */   // Label 992: @60817
     /*  60817 */   GIM_Try, /*On fail goto*//*Label 993*/ GIMT_Encode4(60874), // Rule ID 15137 //
     /*  60822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60833 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60837 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60841 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  60845 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60849 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60853 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60857 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60859 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] }), nxv8i1:{ *:[nxv8i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60864 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60866 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  60872 */     GIR_RootConstrainSelectedInstOperands,
     /*  60873 */     // GIR_Coverage, 15137,
     /*  60873 */     GIR_EraseRootFromParent_Done,
     /*  60874 */   // Label 993: @60874
     /*  60874 */   GIM_Try, /*On fail goto*//*Label 994*/ GIMT_Encode4(60931), // Rule ID 8469 //
     /*  60879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  60910 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60914 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60916 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60925 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60929 */     GIR_RootConstrainSelectedInstOperands,
     /*  60930 */     // GIR_Coverage, 8469,
     /*  60930 */     GIR_EraseRootFromParent_Done,
     /*  60931 */   // Label 994: @60931
     /*  60931 */   GIM_Try, /*On fail goto*//*Label 995*/ GIMT_Encode4(60988), // Rule ID 8470 //
     /*  60936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  60943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  60947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  60951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  60955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  60959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  60963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  60967 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  60971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  60973 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op2, (splat_vector:{ *:[nxv8i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  60973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  60976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  60978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  60982 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  60986 */     GIR_RootConstrainSelectedInstOperands,
     /*  60987 */     // GIR_Coverage, 8470,
     /*  60987 */     GIR_EraseRootFromParent_Done,
     /*  60988 */   // Label 995: @60988
     /*  60988 */   GIM_Try, /*On fail goto*//*Label 996*/ GIMT_Encode4(61035), // Rule ID 10742 //
     /*  60993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  60996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  61004 */     // (and:{ *:[nxv8i1] } PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv8i1] }:$Ps1, PPR:{ *:[nxv8i1] }:$Ps2)
     /*  61004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  61007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  61011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  61016 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  61019 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  61021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  61029 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  61031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  61033 */     GIR_RootConstrainSelectedInstOperands,
     /*  61034 */     // GIR_Coverage, 10742,
     /*  61034 */     GIR_EraseRootFromParent_Done,
     /*  61035 */   // Label 996: @61035
     /*  61035 */   GIM_Try, /*On fail goto*//*Label 997*/ GIMT_Encode4(61056), // Rule ID 2746 //
     /*  61040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61043 */     // (and:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  61043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  61046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61048 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61050 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  61054 */     GIR_RootConstrainSelectedInstOperands,
     /*  61055 */     // GIR_Coverage, 2746,
     /*  61055 */     GIR_EraseRootFromParent_Done,
     /*  61056 */   // Label 997: @61056
     /*  61056 */   GIM_Reject,
     /*  61057 */ // Label 987: @61057
     /*  61057 */ GIM_Reject,
     /*  61058 */ // Label 870: @61058
     /*  61058 */ GIM_Try, /*On fail goto*//*Label 998*/ GIMT_Encode4(61529),
     /*  61063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  61073 */   GIM_Try, /*On fail goto*//*Label 999*/ GIMT_Encode4(61128), // Rule ID 15076 //
     /*  61078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61105 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61109 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61113 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61115 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61126 */     GIR_RootConstrainSelectedInstOperands,
     /*  61127 */     // GIR_Coverage, 15076,
     /*  61127 */     GIR_EraseRootFromParent_Done,
     /*  61128 */   // Label 999: @61128
     /*  61128 */   GIM_Try, /*On fail goto*//*Label 1000*/ GIMT_Encode4(61183), // Rule ID 15079 //
     /*  61133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61144 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61148 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61152 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61156 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61160 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61164 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61170 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61175 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61181 */     GIR_RootConstrainSelectedInstOperands,
     /*  61182 */     // GIR_Coverage, 15079,
     /*  61182 */     GIR_EraseRootFromParent_Done,
     /*  61183 */   // Label 1000: @61183
     /*  61183 */   GIM_Try, /*On fail goto*//*Label 1001*/ GIMT_Encode4(61238), // Rule ID 15075 //
     /*  61188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61215 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61219 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61225 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61236 */     GIR_RootConstrainSelectedInstOperands,
     /*  61237 */     // GIR_Coverage, 15075,
     /*  61237 */     GIR_EraseRootFromParent_Done,
     /*  61238 */   // Label 1001: @61238
     /*  61238 */   GIM_Try, /*On fail goto*//*Label 1002*/ GIMT_Encode4(61293), // Rule ID 15078 //
     /*  61243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61274 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61278 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61280 */     // (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61287 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61291 */     GIR_RootConstrainSelectedInstOperands,
     /*  61292 */     // GIR_Coverage, 15078,
     /*  61292 */     GIR_EraseRootFromParent_Done,
     /*  61293 */   // Label 1002: @61293
     /*  61293 */   GIM_Try, /*On fail goto*//*Label 1003*/ GIMT_Encode4(61348), // Rule ID 15074 //
     /*  61298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61305 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61309 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61313 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61317 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61321 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61325 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61335 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61346 */     GIR_RootConstrainSelectedInstOperands,
     /*  61347 */     // GIR_Coverage, 15074,
     /*  61347 */     GIR_EraseRootFromParent_Done,
     /*  61348 */   // Label 1003: @61348
     /*  61348 */   GIM_Try, /*On fail goto*//*Label 1004*/ GIMT_Encode4(61403), // Rule ID 15077 //
     /*  61353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61380 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61384 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61390 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61395 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61401 */     GIR_RootConstrainSelectedInstOperands,
     /*  61402 */     // GIR_Coverage, 15077,
     /*  61402 */     GIR_EraseRootFromParent_Done,
     /*  61403 */   // Label 1004: @61403
     /*  61403 */   GIM_Try, /*On fail goto*//*Label 1005*/ GIMT_Encode4(61458), // Rule ID 7518 //
     /*  61408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61439 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61443 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61445 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61456 */     GIR_RootConstrainSelectedInstOperands,
     /*  61457 */     // GIR_Coverage, 7518,
     /*  61457 */     GIR_EraseRootFromParent_Done,
     /*  61458 */   // Label 1005: @61458
     /*  61458 */   GIM_Try, /*On fail goto*//*Label 1006*/ GIMT_Encode4(61513), // Rule ID 7519 //
     /*  61463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61466 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61470 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61474 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  61478 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  61482 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61486 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61490 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61494 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61500 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (splat_vector:{ *:[nxv8i16] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  61503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  61505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61507 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61511 */     GIR_RootConstrainSelectedInstOperands,
     /*  61512 */     // GIR_Coverage, 7519,
     /*  61512 */     GIR_EraseRootFromParent_Done,
     /*  61513 */   // Label 1006: @61513
     /*  61513 */   GIM_Try, /*On fail goto*//*Label 1007*/ GIMT_Encode4(61528), // Rule ID 3140 //
     /*  61518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61521 */     // (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  61521 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  61526 */     GIR_RootConstrainSelectedInstOperands,
     /*  61527 */     // GIR_Coverage, 3140,
     /*  61527 */     GIR_Done,
     /*  61528 */   // Label 1007: @61528
     /*  61528 */   GIM_Reject,
     /*  61529 */ // Label 998: @61529
     /*  61529 */ GIM_Reject,
     /*  61530 */ // Label 871: @61530
     /*  61530 */ GIM_Try, /*On fail goto*//*Label 1008*/ GIMT_Encode4(62070),
     /*  61535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  61545 */   GIM_Try, /*On fail goto*//*Label 1009*/ GIMT_Encode4(61602), // Rule ID 15127 //
     /*  61550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61581 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61585 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61587 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61600 */     GIR_RootConstrainSelectedInstOperands,
     /*  61601 */     // GIR_Coverage, 15127,
     /*  61601 */     GIR_EraseRootFromParent_Done,
     /*  61602 */   // Label 1009: @61602
     /*  61602 */   GIM_Try, /*On fail goto*//*Label 1010*/ GIMT_Encode4(61659), // Rule ID 15130 //
     /*  61607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61630 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61634 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61638 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61644 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61657 */     GIR_RootConstrainSelectedInstOperands,
     /*  61658 */     // GIR_Coverage, 15130,
     /*  61658 */     GIR_EraseRootFromParent_Done,
     /*  61659 */   // Label 1010: @61659
     /*  61659 */   GIM_Try, /*On fail goto*//*Label 1011*/ GIMT_Encode4(61716), // Rule ID 15126 //
     /*  61664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61675 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61691 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61695 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61701 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61706 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61714 */     GIR_RootConstrainSelectedInstOperands,
     /*  61715 */     // GIR_Coverage, 15126,
     /*  61715 */     GIR_EraseRootFromParent_Done,
     /*  61716 */   // Label 1011: @61716
     /*  61716 */   GIM_Try, /*On fail goto*//*Label 1012*/ GIMT_Encode4(61773), // Rule ID 15129 //
     /*  61721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  61728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61748 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61752 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61756 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61758 */     // (and:{ *:[nxv16i1] } (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })), nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  61767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61771 */     GIR_RootConstrainSelectedInstOperands,
     /*  61772 */     // GIR_Coverage, 15129,
     /*  61772 */     GIR_EraseRootFromParent_Done,
     /*  61773 */   // Label 1012: @61773
     /*  61773 */   GIM_Try, /*On fail goto*//*Label 1013*/ GIMT_Encode4(61830), // Rule ID 15125 //
     /*  61778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61781 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61785 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61789 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61797 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61801 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61805 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61809 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61813 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61815 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61822 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61828 */     GIR_RootConstrainSelectedInstOperands,
     /*  61829 */     // GIR_Coverage, 15125,
     /*  61829 */     GIR_EraseRootFromParent_Done,
     /*  61830 */   // Label 1013: @61830
     /*  61830 */   GIM_Try, /*On fail goto*//*Label 1014*/ GIMT_Encode4(61887), // Rule ID 15128 //
     /*  61835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61838 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61842 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61846 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61850 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61854 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  61858 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61862 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61866 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61870 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61872 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] }), nxv16i1:{ *:[nxv16i1] }:$Op2))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  61885 */     GIR_RootConstrainSelectedInstOperands,
     /*  61886 */     // GIR_Coverage, 15128,
     /*  61886 */     GIR_EraseRootFromParent_Done,
     /*  61887 */   // Label 1014: @61887
     /*  61887 */   GIM_Try, /*On fail goto*//*Label 1015*/ GIMT_Encode4(61944), // Rule ID 8465 //
     /*  61892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61919 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  61923 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61929 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i32] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61934 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61938 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61942 */     GIR_RootConstrainSelectedInstOperands,
     /*  61943 */     // GIR_Coverage, 8465,
     /*  61943 */     GIR_EraseRootFromParent_Done,
     /*  61944 */   // Label 1015: @61944
     /*  61944 */   GIM_Try, /*On fail goto*//*Label 1016*/ GIMT_Encode4(62001), // Rule ID 8466 //
     /*  61949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  61952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  61956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  61960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  61964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  61968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  61972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  61976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  61980 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  61984 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  61986 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op2, (splat_vector:{ *:[nxv16i1] } -1:{ *:[i64] })))  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  61986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /*  61989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  61991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  61995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  61999 */     GIR_RootConstrainSelectedInstOperands,
     /*  62000 */     // GIR_Coverage, 8466,
     /*  62000 */     GIR_EraseRootFromParent_Done,
     /*  62001 */   // Label 1016: @62001
     /*  62001 */   GIM_Try, /*On fail goto*//*Label 1017*/ GIMT_Encode4(62048), // Rule ID 10741 //
     /*  62006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62009 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /*  62017 */     // (and:{ *:[nxv16i1] } PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)  =>  (AND_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), PPR:{ *:[nxv16i1] }:$Ps1, PPR:{ *:[nxv16i1] }:$Ps2)
     /*  62017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  62020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  62024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  62029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  62032 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  62034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62039 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  62042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps1
     /*  62044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ps2
     /*  62046 */     GIR_RootConstrainSelectedInstOperands,
     /*  62047 */     // GIR_Coverage, 10741,
     /*  62047 */     GIR_EraseRootFromParent_Done,
     /*  62048 */   // Label 1017: @62048
     /*  62048 */   GIM_Try, /*On fail goto*//*Label 1018*/ GIMT_Encode4(62069), // Rule ID 2745 //
     /*  62053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62056 */     // (and:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  62056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /*  62059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  62061 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  62067 */     GIR_RootConstrainSelectedInstOperands,
     /*  62068 */     // GIR_Coverage, 2745,
     /*  62068 */     GIR_EraseRootFromParent_Done,
     /*  62069 */   // Label 1018: @62069
     /*  62069 */   GIM_Reject,
     /*  62070 */ // Label 1008: @62070
     /*  62070 */ GIM_Reject,
     /*  62071 */ // Label 872: @62071
     /*  62071 */ GIM_Try, /*On fail goto*//*Label 1019*/ GIMT_Encode4(62542),
     /*  62076 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  62086 */   GIM_Try, /*On fail goto*//*Label 1020*/ GIMT_Encode4(62141), // Rule ID 15067 //
     /*  62091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62110 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62114 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62118 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62122 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62128 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62135 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62139 */     GIR_RootConstrainSelectedInstOperands,
     /*  62140 */     // GIR_Coverage, 15067,
     /*  62140 */     GIR_EraseRootFromParent_Done,
     /*  62141 */   // Label 1020: @62141
     /*  62141 */   GIM_Try, /*On fail goto*//*Label 1021*/ GIMT_Encode4(62196), // Rule ID 15070 //
     /*  62146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62161 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62183 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62194 */     GIR_RootConstrainSelectedInstOperands,
     /*  62195 */     // GIR_Coverage, 15070,
     /*  62195 */     GIR_EraseRootFromParent_Done,
     /*  62196 */   // Label 1021: @62196
     /*  62196 */   GIM_Try, /*On fail goto*//*Label 1022*/ GIMT_Encode4(62251), // Rule ID 15066 //
     /*  62201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62204 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62208 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62212 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62216 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62228 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62232 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62238 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62243 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62249 */     GIR_RootConstrainSelectedInstOperands,
     /*  62250 */     // GIR_Coverage, 15066,
     /*  62250 */     GIR_EraseRootFromParent_Done,
     /*  62251 */   // Label 1022: @62251
     /*  62251 */   GIM_Try, /*On fail goto*//*Label 1023*/ GIMT_Encode4(62306), // Rule ID 15069 //
     /*  62256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62271 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62287 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62293 */     // (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  62300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62304 */     GIR_RootConstrainSelectedInstOperands,
     /*  62305 */     // GIR_Coverage, 15069,
     /*  62305 */     GIR_EraseRootFromParent_Done,
     /*  62306 */   // Label 1023: @62306
     /*  62306 */   GIM_Try, /*On fail goto*//*Label 1024*/ GIMT_Encode4(62361), // Rule ID 15065 //
     /*  62311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62322 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62326 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62342 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62346 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62348 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62359 */     GIR_RootConstrainSelectedInstOperands,
     /*  62360 */     // GIR_Coverage, 15065,
     /*  62360 */     GIR_EraseRootFromParent_Done,
     /*  62361 */   // Label 1024: @62361
     /*  62361 */   GIM_Try, /*On fail goto*//*Label 1025*/ GIMT_Encode4(62416), // Rule ID 15068 //
     /*  62366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62369 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62373 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62377 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62381 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62385 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  62389 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62393 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62397 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62401 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62403 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  62414 */     GIR_RootConstrainSelectedInstOperands,
     /*  62415 */     // GIR_Coverage, 15068,
     /*  62415 */     GIR_EraseRootFromParent_Done,
     /*  62416 */   // Label 1025: @62416
     /*  62416 */   GIM_Try, /*On fail goto*//*Label 1026*/ GIMT_Encode4(62471), // Rule ID 7514 //
     /*  62421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /*  62452 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62456 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62458 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i32] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62469 */     GIR_RootConstrainSelectedInstOperands,
     /*  62470 */     // GIR_Coverage, 7514,
     /*  62470 */     GIR_EraseRootFromParent_Done,
     /*  62471 */   // Label 1026: @62471
     /*  62471 */   GIM_Try, /*On fail goto*//*Label 1027*/ GIMT_Encode4(62526), // Rule ID 7515 //
     /*  62476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  62491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  62495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  62499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /*  62503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  62507 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/1, uint8_t(-1),
     /*  62511 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  62513 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (splat_vector:{ *:[nxv16i8] } -1:{ *:[i64] })))  =>  (BIC_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62513 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZZZ),
     /*  62516 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /*  62518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  62520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  62524 */     GIR_RootConstrainSelectedInstOperands,
     /*  62525 */     // GIR_Coverage, 7515,
     /*  62525 */     GIR_EraseRootFromParent_Done,
     /*  62526 */   // Label 1027: @62526
     /*  62526 */   GIM_Try, /*On fail goto*//*Label 1028*/ GIMT_Encode4(62541), // Rule ID 3139 //
     /*  62531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  62534 */     // (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (AND_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  62534 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::AND_ZZZ),
     /*  62539 */     GIR_RootConstrainSelectedInstOperands,
     /*  62540 */     // GIR_Coverage, 3139,
     /*  62540 */     GIR_Done,
     /*  62541 */   // Label 1028: @62541
     /*  62541 */   GIM_Reject,
     /*  62542 */ // Label 1019: @62542
     /*  62542 */ GIM_Reject,
     /*  62543 */ // Label 873: @62543
     /*  62543 */ GIM_Reject,
     /*  62544 */ // Label 6: @62544
     /*  62544 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1047*/ GIMT_Encode4(87658),
     /*  62555 */ /*GILLT_s32*//*Label 1029*/ GIMT_Encode4(62643),
     /*  62559 */ /*GILLT_s64*//*Label 1030*/ GIMT_Encode4(63003), GIMT_Encode4(0),
     /*  62567 */ /*GILLT_v2s32*//*Label 1031*/ GIMT_Encode4(64902),
     /*  62571 */ /*GILLT_v2s64*//*Label 1032*/ GIMT_Encode4(66210),
     /*  62575 */ /*GILLT_v4s16*//*Label 1033*/ GIMT_Encode4(67518),
     /*  62579 */ /*GILLT_v4s32*//*Label 1034*/ GIMT_Encode4(68826),
     /*  62583 */ /*GILLT_v8s8*//*Label 1035*/ GIMT_Encode4(70134),
     /*  62587 */ /*GILLT_v8s16*//*Label 1036*/ GIMT_Encode4(71442),
     /*  62591 */ /*GILLT_v16s8*//*Label 1037*/ GIMT_Encode4(72750),
     /*  62595 */ /*GILLT_nxv1s1*//*Label 1038*/ GIMT_Encode4(74058),
     /*  62599 */ /*GILLT_nxv2s1*//*Label 1039*/ GIMT_Encode4(74090), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  62611 */ /*GILLT_nxv2s64*//*Label 1040*/ GIMT_Encode4(74122),
     /*  62615 */ /*GILLT_nxv4s1*//*Label 1041*/ GIMT_Encode4(77482), GIMT_Encode4(0),
     /*  62623 */ /*GILLT_nxv4s32*//*Label 1042*/ GIMT_Encode4(77514),
     /*  62627 */ /*GILLT_nxv8s1*//*Label 1043*/ GIMT_Encode4(80874),
     /*  62631 */ /*GILLT_nxv8s16*//*Label 1044*/ GIMT_Encode4(80906),
     /*  62635 */ /*GILLT_nxv16s1*//*Label 1045*/ GIMT_Encode4(84266),
     /*  62639 */ /*GILLT_nxv16s8*//*Label 1046*/ GIMT_Encode4(84298),
     /*  62643 */ // Label 1029: @62643
     /*  62643 */ GIM_Try, /*On fail goto*//*Label 1048*/ GIMT_Encode4(63002),
     /*  62648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  62651 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  62654 */   GIM_Try, /*On fail goto*//*Label 1049*/ GIMT_Encode4(62709), // Rule ID 13323 //
     /*  62659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62679 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62687 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62689 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62696 */     // (or:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62703 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62707 */     GIR_RootConstrainSelectedInstOperands,
     /*  62708 */     // GIR_Coverage, 13323,
     /*  62708 */     GIR_EraseRootFromParent_Done,
     /*  62709 */   // Label 1049: @62709
     /*  62709 */   GIM_Try, /*On fail goto*//*Label 1050*/ GIMT_Encode4(62764), // Rule ID 174 //
     /*  62714 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62734 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62738 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62744 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62751 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (ORNWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrs),
     /*  62754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62756 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62758 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62762 */     GIR_RootConstrainSelectedInstOperands,
     /*  62763 */     // GIR_Coverage, 174,
     /*  62763 */     GIR_EraseRootFromParent_Done,
     /*  62764 */   // Label 1050: @62764
     /*  62764 */   GIM_Try, /*On fail goto*//*Label 1051*/ GIMT_Encode4(62805), // Rule ID 146 //
     /*  62769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  62773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  62785 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  62789 */     // MIs[1] Operand 1
     /*  62789 */     // No operand predicates
     /*  62789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62791 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (ORRWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  62791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWri),
     /*  62794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62798 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  62803 */     GIR_RootConstrainSelectedInstOperands,
     /*  62804 */     // GIR_Coverage, 146,
     /*  62804 */     GIR_EraseRootFromParent_Done,
     /*  62805 */   // Label 1051: @62805
     /*  62805 */   GIM_Try, /*On fail goto*//*Label 1052*/ GIMT_Encode4(62838), // Rule ID 13325 //
     /*  62810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62818 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62825 */     // (or:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62832 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62836 */     GIR_RootConstrainSelectedInstOperands,
     /*  62837 */     // GIR_Coverage, 13325,
     /*  62837 */     GIR_EraseRootFromParent_Done,
     /*  62838 */   // Label 1052: @62838
     /*  62838 */   GIM_Try, /*On fail goto*//*Label 1053*/ GIMT_Encode4(62871), // Rule ID 178 //
     /*  62843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  62858 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (ORRWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  62858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRWrs),
     /*  62861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62865 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  62869 */     GIR_RootConstrainSelectedInstOperands,
     /*  62870 */     // GIR_Coverage, 178,
     /*  62870 */     GIR_EraseRootFromParent_Done,
     /*  62871 */   // Label 1053: @62871
     /*  62871 */   GIM_Try, /*On fail goto*//*Label 1054*/ GIMT_Encode4(62924), // Rule ID 13321 //
     /*  62876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  62884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62888 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62892 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62896 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62901 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62909 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62911 */     // (or:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  62918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62922 */     GIR_RootConstrainSelectedInstOperands,
     /*  62923 */     // GIR_Coverage, 13321,
     /*  62923 */     GIR_EraseRootFromParent_Done,
     /*  62924 */   // Label 1054: @62924
     /*  62924 */   GIM_Try, /*On fail goto*//*Label 1055*/ GIMT_Encode4(62977), // Rule ID 172 //
     /*  62929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62933 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  62941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  62945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  62949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  62953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62958 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  62962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  62964 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, -1:{ *:[i32] }))  =>  (ORNWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  62967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  62969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  62971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  62975 */     GIR_RootConstrainSelectedInstOperands,
     /*  62976 */     // GIR_Coverage, 172,
     /*  62976 */     GIR_EraseRootFromParent_Done,
     /*  62977 */   // Label 1055: @62977
     /*  62977 */   GIM_Try, /*On fail goto*//*Label 1056*/ GIMT_Encode4(63001), // Rule ID 176 //
     /*  62982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  62994 */     // (or:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (ORRWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  62994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRWrr),
     /*  62999 */     GIR_RootConstrainSelectedInstOperands,
     /*  63000 */     // GIR_Coverage, 176,
     /*  63000 */     GIR_Done,
     /*  63001 */   // Label 1056: @63001
     /*  63001 */   GIM_Reject,
     /*  63002 */ // Label 1048: @63002
     /*  63002 */ GIM_Reject,
     /*  63003 */ // Label 1030: @63003
     /*  63003 */ GIM_Try, /*On fail goto*//*Label 1057*/ GIMT_Encode4(64901),
     /*  63008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  63011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  63014 */   GIM_Try, /*On fail goto*//*Label 1058*/ GIMT_Encode4(63136), // Rule ID 4016 //
     /*  63019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63055 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63060 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63064 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63075 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63079 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63083 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63087 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63099 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63103 */     // MIs[4] Rn
     /*  63103 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63108 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63112 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63123 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63125 */     // (or:{ *:[i64] } (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }), (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63134 */     GIR_RootConstrainSelectedInstOperands,
     /*  63135 */     // GIR_Coverage, 4016,
     /*  63135 */     GIR_EraseRootFromParent_Done,
     /*  63136 */   // Label 1058: @63136
     /*  63136 */   GIM_Try, /*On fail goto*//*Label 1059*/ GIMT_Encode4(63258), // Rule ID 13883 //
     /*  63141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /*  63169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63182 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 8,
     /*  63186 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(-71777214294589696),
     /*  63197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  63201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /*  63209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63213 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  63217 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_LSHR),
     /*  63221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63225 */     // MIs[4] Rn
     /*  63225 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63230 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 8,
     /*  63234 */     GIM_CheckConstantInt, /*MI*/3, /*Op*/2, GIMT_Encode8(71777214294589695),
     /*  63245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63247 */     // (or:{ *:[i64] } (and:{ *:[i64] } (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), -71777214294589696:{ *:[i64] }), (and:{ *:[i64] } (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 8:{ *:[i64] }), 71777214294589695:{ *:[i64] }))  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /*  63247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /*  63250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  63256 */     GIR_RootConstrainSelectedInstOperands,
     /*  63257 */     // GIR_Coverage, 13883,
     /*  63257 */     GIR_EraseRootFromParent_Done,
     /*  63258 */   // Label 1059: @63258
     /*  63258 */   GIM_Try, /*On fail goto*//*Label 1060*/ GIMT_Encode4(63313), // Rule ID 13324 //
     /*  63263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63283 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63287 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63291 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63293 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63300 */     // (or:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  63307 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63311 */     GIR_RootConstrainSelectedInstOperands,
     /*  63312 */     // GIR_Coverage, 13324,
     /*  63312 */     GIR_EraseRootFromParent_Done,
     /*  63313 */   // Label 1060: @63313
     /*  63313 */   GIM_Try, /*On fail goto*//*Label 1061*/ GIMT_Encode4(63368), // Rule ID 175 //
     /*  63318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  63326 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  63330 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63334 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63338 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63342 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  63346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  63348 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  63355 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (ORNXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  63355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrs),
     /*  63358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  63360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  63362 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  63366 */     GIR_RootConstrainSelectedInstOperands,
     /*  63367 */     // GIR_Coverage, 175,
     /*  63367 */     GIR_EraseRootFromParent_Done,
     /*  63368 */   // Label 1061: @63368
     /*  63368 */   GIM_Try, /*On fail goto*//*Label 1062*/ GIMT_Encode4(63477), // Rule ID 13683 //
     /*  63373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63434 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63438 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63442 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63446 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63451 */     // MIs[4] LHS
     /*  63451 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63456 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63458 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63475 */     GIR_RootConstrainSelectedInstOperands,
     /*  63476 */     // GIR_Coverage, 13683,
     /*  63476 */     GIR_EraseRootFromParent_Done,
     /*  63477 */   // Label 1062: @63477
     /*  63477 */   GIM_Try, /*On fail goto*//*Label 1063*/ GIMT_Encode4(63586), // Rule ID 13682 //
     /*  63482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  63509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63538 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63551 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63555 */     // MIs[4] LHS
     /*  63555 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63560 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63565 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63567 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63572 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  63584 */     GIR_RootConstrainSelectedInstOperands,
     /*  63585 */     // GIR_Coverage, 13682,
     /*  63585 */     GIR_EraseRootFromParent_Done,
     /*  63586 */   // Label 1063: @63586
     /*  63586 */   GIM_Try, /*On fail goto*//*Label 1064*/ GIMT_Encode4(63695), // Rule ID 13685 //
     /*  63591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63635 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63640 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63644 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63650 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63656 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63660 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /*  63664 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63669 */     // MIs[4] LHS
     /*  63669 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63674 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63676 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63676 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63679 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  63689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63693 */     GIR_RootConstrainSelectedInstOperands,
     /*  63694 */     // GIR_Coverage, 13685,
     /*  63694 */     GIR_EraseRootFromParent_Done,
     /*  63695 */   // Label 1064: @63695
     /*  63695 */   GIM_Try, /*On fail goto*//*Label 1065*/ GIMT_Encode4(63804), // Rule ID 13684 //
     /*  63700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  63732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63744 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  63753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  63761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  63765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /*  63773 */     // MIs[4] LHS
     /*  63773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  63778 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63783 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63785 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  63794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  63798 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  63802 */     GIR_RootConstrainSelectedInstOperands,
     /*  63803 */     // GIR_Coverage, 13684,
     /*  63803 */     GIR_EraseRootFromParent_Done,
     /*  63804 */   // Label 1065: @63804
     /*  63804 */   GIM_Try, /*On fail goto*//*Label 1066*/ GIMT_Encode4(63913), // Rule ID 2474 //
     /*  63809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63828 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63842 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63846 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63850 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63854 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63870 */     // MIs[3] LHS
     /*  63870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  63875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63892 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  63894 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  63894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  63897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  63899 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  63903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  63907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  63911 */     GIR_RootConstrainSelectedInstOperands,
     /*  63912 */     // GIR_Coverage, 2474,
     /*  63912 */     GIR_EraseRootFromParent_Done,
     /*  63913 */   // Label 1066: @63913
     /*  63913 */   GIM_Try, /*On fail goto*//*Label 1067*/ GIMT_Encode4(64022), // Rule ID 13680 //
     /*  63918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  63921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  63929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  63937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  63941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  63951 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  63955 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  63959 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  63963 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  63967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  63971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  63975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  63979 */     // MIs[3] LHS
     /*  63979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  63984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  63988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  63994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  63996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64003 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$RHS))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  64020 */     GIR_RootConstrainSelectedInstOperands,
     /*  64021 */     // GIR_Coverage, 13680,
     /*  64021 */     GIR_EraseRootFromParent_Done,
     /*  64022 */   // Label 1067: @64022
     /*  64022 */   GIM_Try, /*On fail goto*//*Label 1068*/ GIMT_Encode4(64131), // Rule ID 13679 //
     /*  64027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64068 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64072 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64076 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64081 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64085 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64089 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64093 */     // MIs[3] LHS
     /*  64093 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  64098 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64102 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64112 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  64121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  64125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64129 */     GIR_RootConstrainSelectedInstOperands,
     /*  64130 */     // GIR_Coverage, 13679,
     /*  64130 */     GIR_EraseRootFromParent_Done,
     /*  64131 */   // Label 1068: @64131
     /*  64131 */   GIM_Try, /*On fail goto*//*Label 1069*/ GIMT_Encode4(64240), // Rule ID 13681 //
     /*  64136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64164 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64169 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  64173 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64177 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  64181 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  64185 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64190 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64194 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /*  64202 */     // MIs[3] LHS
     /*  64202 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  64207 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  64211 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64217 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  64219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  64221 */     // (or:{ *:[v1i64] } (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$LHS), (and:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, immAllOnesV:{ *:[v1i64] })))  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$MHS, V64:{ *:[v1i64] }:$RHS)
     /*  64221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  64224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  64230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  64234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  64238 */     GIR_RootConstrainSelectedInstOperands,
     /*  64239 */     // GIR_Coverage, 13681,
     /*  64239 */     GIR_EraseRootFromParent_Done,
     /*  64240 */   // Label 1069: @64240
     /*  64240 */   GIM_Try, /*On fail goto*//*Label 1070*/ GIMT_Encode4(64281), // Rule ID 147 //
     /*  64245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  64249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64261 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  64265 */     // MIs[1] Operand 1
     /*  64265 */     // No operand predicates
     /*  64265 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64267 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (ORRXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  64267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXri),
     /*  64270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64274 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  64279 */     GIR_RootConstrainSelectedInstOperands,
     /*  64280 */     // GIR_Coverage, 147,
     /*  64280 */     GIR_EraseRootFromParent_Done,
     /*  64281 */   // Label 1070: @64281
     /*  64281 */   GIM_Try, /*On fail goto*//*Label 1071*/ GIMT_Encode4(64314), // Rule ID 13326 //
     /*  64286 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64290 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64294 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64301 */     // (or:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64308 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64312 */     GIR_RootConstrainSelectedInstOperands,
     /*  64313 */     // GIR_Coverage, 13326,
     /*  64313 */     GIR_EraseRootFromParent_Done,
     /*  64314 */   // Label 1071: @64314
     /*  64314 */   GIM_Try, /*On fail goto*//*Label 1072*/ GIMT_Encode4(64347), // Rule ID 179 //
     /*  64319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64323 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64327 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  64334 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (ORRXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  64334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORRXrs),
     /*  64337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64341 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  64345 */     GIR_RootConstrainSelectedInstOperands,
     /*  64346 */     // GIR_Coverage, 179,
     /*  64346 */     GIR_EraseRootFromParent_Done,
     /*  64347 */   // Label 1072: @64347
     /*  64347 */   GIM_Try, /*On fail goto*//*Label 1073*/ GIMT_Encode4(64414), // Rule ID 13619 //
     /*  64352 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64371 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64376 */     // MIs[1] imm
     /*  64376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64384 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64388 */     // MIs[2] Operand 1
     /*  64388 */     // No operand predicates
     /*  64388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64392 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64398 */     // (or:{ *:[v1i64] } (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64409 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64412 */     GIR_RootConstrainSelectedInstOperands,
     /*  64413 */     // GIR_Coverage, 13619,
     /*  64413 */     GIR_EraseRootFromParent_Done,
     /*  64414 */   // Label 1073: @64414
     /*  64414 */   GIM_Try, /*On fail goto*//*Label 1074*/ GIMT_Encode4(64481), // Rule ID 13622 //
     /*  64419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64426 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64430 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64434 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64438 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64443 */     // MIs[1] imm
     /*  64443 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64447 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64451 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64455 */     // MIs[2] Operand 1
     /*  64455 */     // No operand predicates
     /*  64455 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64459 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64463 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64465 */     // (or:{ *:[v1i64] } (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), FPR64:{ *:[v1i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  64472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64476 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64479 */     GIR_RootConstrainSelectedInstOperands,
     /*  64480 */     // GIR_Coverage, 13622,
     /*  64480 */     GIR_EraseRootFromParent_Done,
     /*  64481 */   // Label 1074: @64481
     /*  64481 */   GIM_Try, /*On fail goto*//*Label 1075*/ GIMT_Encode4(64534), // Rule ID 13322 //
     /*  64486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64502 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64506 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64511 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64521 */     // (or:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  64528 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64532 */     GIR_RootConstrainSelectedInstOperands,
     /*  64533 */     // GIR_Coverage, 13322,
     /*  64533 */     GIR_EraseRootFromParent_Done,
     /*  64534 */   // Label 1075: @64534
     /*  64534 */   GIM_Try, /*On fail goto*//*Label 1076*/ GIMT_Encode4(64601), // Rule ID 2122 //
     /*  64539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64550 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64554 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  64558 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64562 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64567 */     // MIs[1] imm
     /*  64567 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64571 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64575 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64579 */     // MIs[2] Operand 1
     /*  64579 */     // No operand predicates
     /*  64579 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64585 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAd),
     /*  64588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64590 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64596 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64599 */     GIR_RootConstrainSelectedInstOperands,
     /*  64600 */     // GIR_Coverage, 2122,
     /*  64600 */     GIR_EraseRootFromParent_Done,
     /*  64601 */   // Label 1076: @64601
     /*  64601 */   GIM_Try, /*On fail goto*//*Label 1077*/ GIMT_Encode4(64668), // Rule ID 2131 //
     /*  64606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64613 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  64625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64629 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64634 */     // MIs[1] imm
     /*  64634 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64638 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  64642 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  64646 */     // MIs[2] Operand 1
     /*  64646 */     // No operand predicates
     /*  64646 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  64650 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64652 */     // (or:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  64652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAd),
     /*  64655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  64657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  64659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  64663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  64666 */     GIR_RootConstrainSelectedInstOperands,
     /*  64667 */     // GIR_Coverage, 2131,
     /*  64667 */     GIR_EraseRootFromParent_Done,
     /*  64668 */   // Label 1077: @64668
     /*  64668 */   GIM_Try, /*On fail goto*//*Label 1078*/ GIMT_Encode4(64721), // Rule ID 173 //
     /*  64673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64677 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  64706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  64708 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, -1:{ *:[i64] }))  =>  (ORNXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  64711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  64715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  64719 */     GIR_RootConstrainSelectedInstOperands,
     /*  64720 */     // GIR_Coverage, 173,
     /*  64720 */     GIR_EraseRootFromParent_Done,
     /*  64721 */   // Label 1078: @64721
     /*  64721 */   GIM_Try, /*On fail goto*//*Label 1079*/ GIMT_Encode4(64785), // Rule ID 13974 //
     /*  64726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64758 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64764 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64772 */     // (or:{ *:[v1i64] } (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }), V64:{ *:[v1i64] }:$LHS)  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64777 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  64779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64783 */     GIR_RootConstrainSelectedInstOperands,
     /*  64784 */     // GIR_Coverage, 13974,
     /*  64784 */     GIR_EraseRootFromParent_Done,
     /*  64785 */   // Label 1079: @64785
     /*  64785 */   GIM_Try, /*On fail goto*//*Label 1080*/ GIMT_Encode4(64849), // Rule ID 5070 //
     /*  64790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  64805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  64813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  64817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64822 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  64826 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64832 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  64834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  64836 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$RHS, immAllOnesV:{ *:[v1i64] }))  =>  (ORNv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  64839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  64841 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  64843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  64847 */     GIR_RootConstrainSelectedInstOperands,
     /*  64848 */     // GIR_Coverage, 5070,
     /*  64848 */     GIR_EraseRootFromParent_Done,
     /*  64849 */   // Label 1080: @64849
     /*  64849 */   GIM_Try, /*On fail goto*//*Label 1081*/ GIMT_Encode4(64873), // Rule ID 177 //
     /*  64854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  64866 */     // (or:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ORRXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  64866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRXrr),
     /*  64871 */     GIR_RootConstrainSelectedInstOperands,
     /*  64872 */     // GIR_Coverage, 177,
     /*  64872 */     GIR_Done,
     /*  64873 */   // Label 1081: @64873
     /*  64873 */   GIM_Try, /*On fail goto*//*Label 1082*/ GIMT_Encode4(64900), // Rule ID 5076 //
     /*  64878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64893 */     // (or:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (ORRv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  64893 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  64898 */     GIR_RootConstrainSelectedInstOperands,
     /*  64899 */     // GIR_Coverage, 5076,
     /*  64899 */     GIR_Done,
     /*  64900 */   // Label 1082: @64900
     /*  64900 */   GIM_Reject,
     /*  64901 */ // Label 1057: @64901
     /*  64901 */ GIM_Reject,
     /*  64902 */ // Label 1031: @64902
     /*  64902 */ GIM_Try, /*On fail goto*//*Label 1083*/ GIMT_Encode4(66209),
     /*  64907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64913 */   GIM_Try, /*On fail goto*//*Label 1084*/ GIMT_Encode4(65022), // Rule ID 13676 //
     /*  64918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  64921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  64929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  64945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  64949 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64953 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  64957 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64962 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  64966 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  64972 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  64974 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64979 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  64983 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  64987 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  64991 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  64996 */     // MIs[4] LHS
     /*  64996 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65001 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65003 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65016 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65020 */     GIR_RootConstrainSelectedInstOperands,
     /*  65021 */     // GIR_Coverage, 13676,
     /*  65021 */     GIR_EraseRootFromParent_Done,
     /*  65022 */   // Label 1084: @65022
     /*  65022 */   GIM_Try, /*On fail goto*//*Label 1085*/ GIMT_Encode4(65131), // Rule ID 13675 //
     /*  65027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65050 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  65054 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65058 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65062 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65066 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65071 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65075 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65081 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65088 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65092 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65096 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65100 */     // MIs[4] LHS
     /*  65100 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65105 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65110 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65112 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  65129 */     GIR_RootConstrainSelectedInstOperands,
     /*  65130 */     // GIR_Coverage, 13675,
     /*  65130 */     GIR_EraseRootFromParent_Done,
     /*  65131 */   // Label 1085: @65131
     /*  65131 */   GIM_Try, /*On fail goto*//*Label 1086*/ GIMT_Encode4(65240), // Rule ID 13678 //
     /*  65136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65143 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65147 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65151 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65155 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65159 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65164 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65168 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65172 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65176 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65180 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65185 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65189 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65195 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65197 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65201 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65205 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65209 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65214 */     // MIs[4] LHS
     /*  65214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65219 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65221 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65226 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  65234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65238 */     GIR_RootConstrainSelectedInstOperands,
     /*  65239 */     // GIR_Coverage, 13678,
     /*  65239 */     GIR_EraseRootFromParent_Done,
     /*  65240 */   // Label 1086: @65240
     /*  65240 */   GIM_Try, /*On fail goto*//*Label 1087*/ GIMT_Encode4(65349), // Rule ID 13677 //
     /*  65245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65289 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65294 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65298 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65304 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  65306 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  65310 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65314 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65318 */     // MIs[4] LHS
     /*  65318 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  65323 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65330 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  65339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  65343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  65347 */     GIR_RootConstrainSelectedInstOperands,
     /*  65348 */     // GIR_Coverage, 13677,
     /*  65348 */     GIR_EraseRootFromParent_Done,
     /*  65349 */   // Label 1087: @65349
     /*  65349 */   GIM_Try, /*On fail goto*//*Label 1088*/ GIMT_Encode4(65458), // Rule ID 2473 //
     /*  65354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65361 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65365 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65369 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65373 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65377 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65382 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65387 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65391 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65395 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65399 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65403 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65407 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65411 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65415 */     // MIs[3] LHS
     /*  65415 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65420 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65424 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65439 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65444 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65456 */     GIR_RootConstrainSelectedInstOperands,
     /*  65457 */     // GIR_Coverage, 2473,
     /*  65457 */     GIR_EraseRootFromParent_Done,
     /*  65458 */   // Label 1088: @65458
     /*  65458 */   GIM_Try, /*On fail goto*//*Label 1089*/ GIMT_Encode4(65567), // Rule ID 13673 //
     /*  65463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65496 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65500 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65504 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65508 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  65516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65520 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65524 */     // MIs[3] LHS
     /*  65524 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65529 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65533 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65539 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65541 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65546 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65548 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$RHS))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65553 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  65565 */     GIR_RootConstrainSelectedInstOperands,
     /*  65566 */     // GIR_Coverage, 13673,
     /*  65566 */     GIR_EraseRootFromParent_Done,
     /*  65567 */   // Label 1089: @65567
     /*  65567 */   GIM_Try, /*On fail goto*//*Label 1090*/ GIMT_Encode4(65676), // Rule ID 13672 //
     /*  65572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65600 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65634 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65638 */     // MIs[3] LHS
     /*  65638 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  65643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65647 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65653 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65655 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65657 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65662 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  65666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  65670 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65674 */     GIR_RootConstrainSelectedInstOperands,
     /*  65675 */     // GIR_Coverage, 13672,
     /*  65675 */     GIR_EraseRootFromParent_Done,
     /*  65676 */   // Label 1090: @65676
     /*  65676 */   GIM_Try, /*On fail goto*//*Label 1091*/ GIMT_Encode4(65785), // Rule ID 13674 //
     /*  65681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65696 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65700 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65704 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  65718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  65722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65735 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  65739 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  65743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  65747 */     // MIs[3] LHS
     /*  65747 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  65752 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  65756 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  65762 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  65764 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  65766 */     // (or:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$LHS), (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, immAllOnesV:{ *:[v2i32] })))  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$MHS, V64:{ *:[v2i32] }:$RHS)
     /*  65766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  65769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  65775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  65779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  65783 */     GIR_RootConstrainSelectedInstOperands,
     /*  65784 */     // GIR_Coverage, 13674,
     /*  65784 */     GIR_EraseRootFromParent_Done,
     /*  65785 */   // Label 1091: @65785
     /*  65785 */   GIM_Try, /*On fail goto*//*Label 1092*/ GIMT_Encode4(65852), // Rule ID 13639 //
     /*  65790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65809 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65814 */     // MIs[1] imm
     /*  65814 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65818 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65822 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65826 */     // MIs[2] Operand 1
     /*  65826 */     // No operand predicates
     /*  65826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65830 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65834 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65836 */     // (or:{ *:[v2i32] } (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65850 */     GIR_RootConstrainSelectedInstOperands,
     /*  65851 */     // GIR_Coverage, 13639,
     /*  65851 */     GIR_EraseRootFromParent_Done,
     /*  65852 */   // Label 1092: @65852
     /*  65852 */   GIM_Try, /*On fail goto*//*Label 1093*/ GIMT_Encode4(65919), // Rule ID 13660 //
     /*  65857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  65868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  65872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65876 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65881 */     // MIs[1] imm
     /*  65881 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65885 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65889 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65893 */     // MIs[2] Operand 1
     /*  65893 */     // No operand predicates
     /*  65893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65897 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65903 */     // (or:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V64:{ *:[v2i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  65906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  65910 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65914 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65917 */     GIR_RootConstrainSelectedInstOperands,
     /*  65918 */     // GIR_Coverage, 13660,
     /*  65918 */     GIR_EraseRootFromParent_Done,
     /*  65919 */   // Label 1093: @65919
     /*  65919 */   GIM_Try, /*On fail goto*//*Label 1094*/ GIMT_Encode4(65986), // Rule ID 2239 //
     /*  65924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65935 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  65939 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  65943 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  65947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65952 */     // MIs[1] imm
     /*  65952 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  65956 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  65960 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  65964 */     // MIs[2] Operand 1
     /*  65964 */     // No operand predicates
     /*  65964 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  65968 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  65970 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  65970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i32_shift),
     /*  65973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  65975 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  65977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  65981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  65984 */     GIR_RootConstrainSelectedInstOperands,
     /*  65985 */     // GIR_Coverage, 2239,
     /*  65985 */     GIR_EraseRootFromParent_Done,
     /*  65986 */   // Label 1094: @65986
     /*  65986 */   GIM_Try, /*On fail goto*//*Label 1095*/ GIMT_Encode4(66053), // Rule ID 2298 //
     /*  65991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  65994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  65998 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66002 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66006 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  66010 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66019 */     // MIs[1] imm
     /*  66019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  66027 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  66031 */     // MIs[2] Operand 1
     /*  66031 */     // No operand predicates
     /*  66031 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  66035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66037 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  66037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i32_shift),
     /*  66040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  66044 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  66048 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  66051 */     GIR_RootConstrainSelectedInstOperands,
     /*  66052 */     // GIR_Coverage, 2298,
     /*  66052 */     GIR_EraseRootFromParent_Done,
     /*  66053 */   // Label 1095: @66053
     /*  66053 */   GIM_Try, /*On fail goto*//*Label 1096*/ GIMT_Encode4(66117), // Rule ID 13973 //
     /*  66058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66090 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66104 */     // (or:{ *:[v2i32] } (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }), V64:{ *:[v2i32] }:$LHS)  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66109 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  66111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66115 */     GIR_RootConstrainSelectedInstOperands,
     /*  66116 */     // GIR_Coverage, 13973,
     /*  66116 */     GIR_EraseRootFromParent_Done,
     /*  66117 */   // Label 1096: @66117
     /*  66117 */   GIM_Try, /*On fail goto*//*Label 1097*/ GIMT_Encode4(66181), // Rule ID 5069 //
     /*  66122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66129 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  66137 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66141 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  66145 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  66149 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66154 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66158 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66164 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  66166 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  66168 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$RHS, immAllOnesV:{ *:[v2i32] }))  =>  (ORNv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  66171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  66173 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  66175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66179 */     GIR_RootConstrainSelectedInstOperands,
     /*  66180 */     // GIR_Coverage, 5069,
     /*  66180 */     GIR_EraseRootFromParent_Done,
     /*  66181 */   // Label 1097: @66181
     /*  66181 */   GIM_Try, /*On fail goto*//*Label 1098*/ GIMT_Encode4(66208), // Rule ID 5075 //
     /*  66186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  66201 */     // (or:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (ORRv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  66201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  66206 */     GIR_RootConstrainSelectedInstOperands,
     /*  66207 */     // GIR_Coverage, 5075,
     /*  66207 */     GIR_Done,
     /*  66208 */   // Label 1098: @66208
     /*  66208 */   GIM_Reject,
     /*  66209 */ // Label 1083: @66209
     /*  66209 */ GIM_Reject,
     /*  66210 */ // Label 1032: @66210
     /*  66210 */ GIM_Try, /*On fail goto*//*Label 1099*/ GIMT_Encode4(67517),
     /*  66215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66221 */   GIM_Try, /*On fail goto*//*Label 1100*/ GIMT_Encode4(66330), // Rule ID 13704 //
     /*  66226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66241 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66245 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66270 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66274 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66280 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66282 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66291 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66295 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66299 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66304 */     // MIs[4] LHS
     /*  66304 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66309 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66311 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66316 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66324 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66328 */     GIR_RootConstrainSelectedInstOperands,
     /*  66329 */     // GIR_Coverage, 13704,
     /*  66329 */     GIR_EraseRootFromParent_Done,
     /*  66330 */   // Label 1100: @66330
     /*  66330 */   GIM_Try, /*On fail goto*//*Label 1101*/ GIMT_Encode4(66439), // Rule ID 13703 //
     /*  66335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66346 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66350 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66354 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  66362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66379 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66383 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66389 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66396 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66400 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66404 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66408 */     // MIs[4] LHS
     /*  66408 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66413 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66420 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  66437 */     GIR_RootConstrainSelectedInstOperands,
     /*  66438 */     // GIR_Coverage, 13703,
     /*  66438 */     GIR_EraseRootFromParent_Done,
     /*  66439 */   // Label 1101: @66439
     /*  66439 */   GIM_Try, /*On fail goto*//*Label 1102*/ GIMT_Encode4(66548), // Rule ID 13706 //
     /*  66444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66467 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66472 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66476 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66480 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66484 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66488 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66497 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66503 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66505 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66509 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66513 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66517 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66522 */     // MIs[4] LHS
     /*  66522 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66527 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66529 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66534 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  66542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66546 */     GIR_RootConstrainSelectedInstOperands,
     /*  66547 */     // GIR_Coverage, 13706,
     /*  66547 */     GIR_EraseRootFromParent_Done,
     /*  66548 */   // Label 1102: @66548
     /*  66548 */   GIM_Try, /*On fail goto*//*Label 1103*/ GIMT_Encode4(66657), // Rule ID 13705 //
     /*  66553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  66585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66589 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66593 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66597 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66602 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66606 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66612 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  66614 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  66618 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66622 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66626 */     // MIs[4] LHS
     /*  66626 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  66631 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66636 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66638 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66638 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66641 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  66647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  66651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  66655 */     GIR_RootConstrainSelectedInstOperands,
     /*  66656 */     // GIR_Coverage, 13705,
     /*  66656 */     GIR_EraseRootFromParent_Done,
     /*  66657 */   // Label 1103: @66657
     /*  66657 */   GIM_Try, /*On fail goto*//*Label 1104*/ GIMT_Encode4(66766), // Rule ID 2477 //
     /*  66662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66690 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66723 */     // MIs[3] LHS
     /*  66723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66745 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66747 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66760 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66764 */     GIR_RootConstrainSelectedInstOperands,
     /*  66765 */     // GIR_Coverage, 2477,
     /*  66765 */     GIR_EraseRootFromParent_Done,
     /*  66766 */   // Label 1104: @66766
     /*  66766 */   GIM_Try, /*On fail goto*//*Label 1105*/ GIMT_Encode4(66875), // Rule ID 13701 //
     /*  66771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66799 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66804 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66808 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66812 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66816 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66820 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  66824 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66828 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66832 */     // MIs[3] LHS
     /*  66832 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  66837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66841 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66854 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66856 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$RHS))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  66865 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  66869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  66873 */     GIR_RootConstrainSelectedInstOperands,
     /*  66874 */     // GIR_Coverage, 13701,
     /*  66874 */     GIR_EraseRootFromParent_Done,
     /*  66875 */   // Label 1105: @66875
     /*  66875 */   GIM_Try, /*On fail goto*//*Label 1106*/ GIMT_Encode4(66984), // Rule ID 13700 //
     /*  66880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66887 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  66891 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66895 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66899 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  66917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  66921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  66925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66934 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  66938 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  66942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  66946 */     // MIs[3] LHS
     /*  66946 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  66951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  66955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  66961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  66963 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  66965 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  66965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  66968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  66970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  66974 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  66978 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  66982 */     GIR_RootConstrainSelectedInstOperands,
     /*  66983 */     // GIR_Coverage, 13700,
     /*  66983 */     GIR_EraseRootFromParent_Done,
     /*  66984 */   // Label 1106: @66984
     /*  66984 */   GIM_Try, /*On fail goto*//*Label 1107*/ GIMT_Encode4(67093), // Rule ID 13702 //
     /*  66989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  66992 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  66996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67004 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67008 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67012 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67017 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67022 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  67026 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67030 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67034 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67038 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67043 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67047 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67051 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67055 */     // MIs[3] LHS
     /*  67055 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  67060 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  67064 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  67072 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67074 */     // (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$LHS), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, immAllOnesV:{ *:[v2i64] })))  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$MHS, V128:{ *:[v2i64] }:$RHS)
     /*  67074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  67077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  67083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  67087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  67091 */     GIR_RootConstrainSelectedInstOperands,
     /*  67092 */     // GIR_Coverage, 13702,
     /*  67092 */     GIR_EraseRootFromParent_Done,
     /*  67093 */   // Label 1107: @67093
     /*  67093 */   GIM_Try, /*On fail goto*//*Label 1108*/ GIMT_Encode4(67160), // Rule ID 13643 //
     /*  67098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67122 */     // MIs[1] imm
     /*  67122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67130 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67134 */     // MIs[2] Operand 1
     /*  67134 */     // No operand predicates
     /*  67134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67138 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67144 */     // (or:{ *:[v2i64] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67144 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67147 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67155 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67158 */     GIR_RootConstrainSelectedInstOperands,
     /*  67159 */     // GIR_Coverage, 13643,
     /*  67159 */     GIR_EraseRootFromParent_Done,
     /*  67160 */   // Label 1108: @67160
     /*  67160 */   GIM_Try, /*On fail goto*//*Label 1109*/ GIMT_Encode4(67227), // Rule ID 13664 //
     /*  67165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67180 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67184 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67189 */     // MIs[1] imm
     /*  67189 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67193 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67197 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67201 */     // MIs[2] Operand 1
     /*  67201 */     // No operand predicates
     /*  67201 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67205 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67211 */     // (or:{ *:[v2i64] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), V128:{ *:[v2i64] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  67218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67225 */     GIR_RootConstrainSelectedInstOperands,
     /*  67226 */     // GIR_Coverage, 13664,
     /*  67226 */     GIR_EraseRootFromParent_Done,
     /*  67227 */   // Label 1109: @67227
     /*  67227 */   GIM_Try, /*On fail goto*//*Label 1110*/ GIMT_Encode4(67294), // Rule ID 2243 //
     /*  67232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  67251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67260 */     // MIs[1] imm
     /*  67260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67268 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67272 */     // MIs[2] Operand 1
     /*  67272 */     // No operand predicates
     /*  67272 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67276 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67278 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv2i64_shift),
     /*  67281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67289 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67292 */     GIR_RootConstrainSelectedInstOperands,
     /*  67293 */     // GIR_Coverage, 2243,
     /*  67293 */     GIR_EraseRootFromParent_Done,
     /*  67294 */   // Label 1110: @67294
     /*  67294 */   GIM_Try, /*On fail goto*//*Label 1111*/ GIMT_Encode4(67361), // Rule ID 2302 //
     /*  67299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67310 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67314 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  67318 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67322 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67327 */     // MIs[1] imm
     /*  67327 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67331 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  67335 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /*  67339 */     // MIs[2] Operand 1
     /*  67339 */     // No operand predicates
     /*  67339 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  67343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67345 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  67345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv2i64_shift),
     /*  67348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67350 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  67352 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  67356 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  67359 */     GIR_RootConstrainSelectedInstOperands,
     /*  67360 */     // GIR_Coverage, 2302,
     /*  67360 */     GIR_EraseRootFromParent_Done,
     /*  67361 */   // Label 1111: @67361
     /*  67361 */   GIM_Try, /*On fail goto*//*Label 1112*/ GIMT_Encode4(67425), // Rule ID 13977 //
     /*  67366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67369 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67377 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67381 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67385 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67389 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67394 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67398 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67412 */     // (or:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$LHS)  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67417 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  67419 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67423 */     GIR_RootConstrainSelectedInstOperands,
     /*  67424 */     // GIR_Coverage, 13977,
     /*  67424 */     GIR_EraseRootFromParent_Done,
     /*  67425 */   // Label 1112: @67425
     /*  67425 */   GIM_Try, /*On fail goto*//*Label 1113*/ GIMT_Encode4(67489), // Rule ID 5073 //
     /*  67430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67437 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  67445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  67453 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  67457 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67466 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67472 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  67474 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  67476 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$RHS, immAllOnesV:{ *:[v2i64] }))  =>  (ORNv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  67479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  67481 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  67483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67487 */     GIR_RootConstrainSelectedInstOperands,
     /*  67488 */     // GIR_Coverage, 5073,
     /*  67488 */     GIR_EraseRootFromParent_Done,
     /*  67489 */   // Label 1113: @67489
     /*  67489 */   GIM_Try, /*On fail goto*//*Label 1114*/ GIMT_Encode4(67516), // Rule ID 5079 //
     /*  67494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  67509 */     // (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (ORRv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  67509 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  67514 */     GIR_RootConstrainSelectedInstOperands,
     /*  67515 */     // GIR_Coverage, 5079,
     /*  67515 */     GIR_Done,
     /*  67516 */   // Label 1114: @67516
     /*  67516 */   GIM_Reject,
     /*  67517 */ // Label 1099: @67517
     /*  67517 */ GIM_Reject,
     /*  67518 */ // Label 1033: @67518
     /*  67518 */ GIM_Try, /*On fail goto*//*Label 1115*/ GIMT_Encode4(68825),
     /*  67523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67526 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67529 */   GIM_Try, /*On fail goto*//*Label 1116*/ GIMT_Encode4(67638), // Rule ID 13669 //
     /*  67534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67582 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67590 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67595 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67599 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67603 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67607 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67612 */     // MIs[4] LHS
     /*  67612 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67617 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67619 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67632 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67636 */     GIR_RootConstrainSelectedInstOperands,
     /*  67637 */     // GIR_Coverage, 13669,
     /*  67637 */     GIR_EraseRootFromParent_Done,
     /*  67638 */   // Label 1116: @67638
     /*  67638 */   GIM_Try, /*On fail goto*//*Label 1117*/ GIMT_Encode4(67747), // Rule ID 13668 //
     /*  67643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67650 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67654 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67658 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67662 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67666 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  67670 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67674 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67678 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67682 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67704 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67708 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67712 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67716 */     // MIs[4] LHS
     /*  67716 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67721 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67726 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67728 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  67745 */     GIR_RootConstrainSelectedInstOperands,
     /*  67746 */     // GIR_Coverage, 13668,
     /*  67746 */     GIR_EraseRootFromParent_Done,
     /*  67747 */   // Label 1117: @67747
     /*  67747 */   GIM_Try, /*On fail goto*//*Label 1118*/ GIMT_Encode4(67856), // Rule ID 13671 //
     /*  67752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67805 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67811 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67813 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67817 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67821 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67825 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67830 */     // MIs[4] LHS
     /*  67830 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67835 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67837 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67846 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  67850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67854 */     GIR_RootConstrainSelectedInstOperands,
     /*  67855 */     // GIR_Coverage, 13671,
     /*  67855 */     GIR_EraseRootFromParent_Done,
     /*  67856 */   // Label 1118: @67856
     /*  67856 */   GIM_Try, /*On fail goto*//*Label 1119*/ GIMT_Encode4(67965), // Rule ID 13670 //
     /*  67861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67884 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  67893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  67897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67905 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  67914 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  67920 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  67922 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  67926 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67930 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67934 */     // MIs[4] LHS
     /*  67934 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  67939 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67944 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  67946 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  67946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  67949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  67951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  67955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  67959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  67963 */     GIR_RootConstrainSelectedInstOperands,
     /*  67964 */     // GIR_Coverage, 13670,
     /*  67964 */     GIR_EraseRootFromParent_Done,
     /*  67965 */   // Label 1119: @67965
     /*  67965 */   GIM_Try, /*On fail goto*//*Label 1120*/ GIMT_Encode4(68074), // Rule ID 2472 //
     /*  67970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  67973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  67981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  67985 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  67989 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  67993 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  67998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68023 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68027 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68031 */     // MIs[3] LHS
     /*  68031 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68036 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68040 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68046 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68053 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68055 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68064 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68068 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68072 */     GIR_RootConstrainSelectedInstOperands,
     /*  68073 */     // GIR_Coverage, 2472,
     /*  68073 */     GIR_EraseRootFromParent_Done,
     /*  68074 */   // Label 1120: @68074
     /*  68074 */   GIM_Try, /*On fail goto*//*Label 1121*/ GIMT_Encode4(68183), // Rule ID 13666 //
     /*  68079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68098 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68102 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68124 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68128 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  68132 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68136 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68140 */     // MIs[3] LHS
     /*  68140 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68149 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68157 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68162 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68164 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$RHS))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68169 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  68181 */     GIR_RootConstrainSelectedInstOperands,
     /*  68182 */     // GIR_Coverage, 13666,
     /*  68182 */     GIR_EraseRootFromParent_Done,
     /*  68183 */   // Label 1121: @68183
     /*  68183 */   GIM_Try, /*On fail goto*//*Label 1122*/ GIMT_Encode4(68292), // Rule ID 13665 //
     /*  68188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68207 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68211 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68221 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68225 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68229 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68233 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68237 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68242 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68246 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68250 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68254 */     // MIs[3] LHS
     /*  68254 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  68259 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68263 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68271 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68273 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68278 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  68282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  68286 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68290 */     GIR_RootConstrainSelectedInstOperands,
     /*  68291 */     // GIR_Coverage, 13665,
     /*  68291 */     GIR_EraseRootFromParent_Done,
     /*  68292 */   // Label 1122: @68292
     /*  68292 */   GIM_Try, /*On fail goto*//*Label 1123*/ GIMT_Encode4(68401), // Rule ID 13667 //
     /*  68297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  68334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68338 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68342 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68355 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68359 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68363 */     // MIs[3] LHS
     /*  68363 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  68368 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  68372 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68378 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  68380 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68382 */     // (or:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$LHS), (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, immAllOnesV:{ *:[v4i16] })))  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$MHS, V64:{ *:[v4i16] }:$RHS)
     /*  68382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  68385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  68391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  68395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  68399 */     GIR_RootConstrainSelectedInstOperands,
     /*  68400 */     // GIR_Coverage, 13667,
     /*  68400 */     GIR_EraseRootFromParent_Done,
     /*  68401 */   // Label 1123: @68401
     /*  68401 */   GIM_Try, /*On fail goto*//*Label 1124*/ GIMT_Encode4(68468), // Rule ID 13635 //
     /*  68406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68417 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68421 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68430 */     // MIs[1] imm
     /*  68430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68442 */     // MIs[2] Operand 1
     /*  68442 */     // No operand predicates
     /*  68442 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68446 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68450 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68452 */     // (or:{ *:[v4i16] } (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68463 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68466 */     GIR_RootConstrainSelectedInstOperands,
     /*  68467 */     // GIR_Coverage, 13635,
     /*  68467 */     GIR_EraseRootFromParent_Done,
     /*  68468 */   // Label 1124: @68468
     /*  68468 */   GIM_Try, /*On fail goto*//*Label 1125*/ GIMT_Encode4(68535), // Rule ID 13656 //
     /*  68473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68480 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68484 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68488 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68492 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68497 */     // MIs[1] imm
     /*  68497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68505 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68509 */     // MIs[2] Operand 1
     /*  68509 */     // No operand predicates
     /*  68509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68513 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68519 */     // (or:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V64:{ *:[v4i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  68526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68533 */     GIR_RootConstrainSelectedInstOperands,
     /*  68534 */     // GIR_Coverage, 13656,
     /*  68534 */     GIR_EraseRootFromParent_Done,
     /*  68535 */   // Label 1125: @68535
     /*  68535 */   GIM_Try, /*On fail goto*//*Label 1126*/ GIMT_Encode4(68602), // Rule ID 2235 //
     /*  68540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68547 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  68559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68568 */     // MIs[1] imm
     /*  68568 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68572 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68576 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68580 */     // MIs[2] Operand 1
     /*  68580 */     // No operand predicates
     /*  68580 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68586 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i16_shift),
     /*  68589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68600 */     GIR_RootConstrainSelectedInstOperands,
     /*  68601 */     // GIR_Coverage, 2235,
     /*  68601 */     GIR_EraseRootFromParent_Done,
     /*  68602 */   // Label 1126: @68602
     /*  68602 */   GIM_Try, /*On fail goto*//*Label 1127*/ GIMT_Encode4(68669), // Rule ID 2294 //
     /*  68607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  68626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68630 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68635 */     // MIs[1] imm
     /*  68635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  68643 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  68647 */     // MIs[2] Operand 1
     /*  68647 */     // No operand predicates
     /*  68647 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  68651 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68653 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  68653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i16_shift),
     /*  68656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68658 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  68660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  68664 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  68667 */     GIR_RootConstrainSelectedInstOperands,
     /*  68668 */     // GIR_Coverage, 2294,
     /*  68668 */     GIR_EraseRootFromParent_Done,
     /*  68669 */   // Label 1127: @68669
     /*  68669 */   GIM_Try, /*On fail goto*//*Label 1128*/ GIMT_Encode4(68733), // Rule ID 13972 //
     /*  68674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68689 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68693 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68702 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68706 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68712 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68720 */     // (or:{ *:[v4i16] } (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }), V64:{ *:[v4i16] }:$LHS)  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68725 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  68727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68731 */     GIR_RootConstrainSelectedInstOperands,
     /*  68732 */     // GIR_Coverage, 13972,
     /*  68732 */     GIR_EraseRootFromParent_Done,
     /*  68733 */   // Label 1128: @68733
     /*  68733 */   GIM_Try, /*On fail goto*//*Label 1129*/ GIMT_Encode4(68797), // Rule ID 5068 //
     /*  68738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  68753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  68761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  68765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  68774 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68780 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  68782 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  68784 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$RHS, immAllOnesV:{ *:[v4i16] }))  =>  (ORNv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  68787 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  68789 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  68791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  68795 */     GIR_RootConstrainSelectedInstOperands,
     /*  68796 */     // GIR_Coverage, 5068,
     /*  68796 */     GIR_EraseRootFromParent_Done,
     /*  68797 */   // Label 1129: @68797
     /*  68797 */   GIM_Try, /*On fail goto*//*Label 1130*/ GIMT_Encode4(68824), // Rule ID 5074 //
     /*  68802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  68817 */     // (or:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (ORRv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  68817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  68822 */     GIR_RootConstrainSelectedInstOperands,
     /*  68823 */     // GIR_Coverage, 5074,
     /*  68823 */     GIR_Done,
     /*  68824 */   // Label 1130: @68824
     /*  68824 */   GIM_Reject,
     /*  68825 */ // Label 1115: @68825
     /*  68825 */ GIM_Reject,
     /*  68826 */ // Label 1034: @68826
     /*  68826 */ GIM_Try, /*On fail goto*//*Label 1131*/ GIMT_Encode4(70133),
     /*  68831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68837 */   GIM_Try, /*On fail goto*//*Label 1132*/ GIMT_Encode4(68946), // Rule ID 13697 //
     /*  68842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68873 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68877 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68881 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68886 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68890 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  68896 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  68898 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68903 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  68907 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68911 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68915 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68920 */     // MIs[4] LHS
     /*  68920 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  68925 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  68927 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  68927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  68930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  68932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  68936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  68940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  68944 */     GIR_RootConstrainSelectedInstOperands,
     /*  68945 */     // GIR_Coverage, 13697,
     /*  68945 */     GIR_EraseRootFromParent_Done,
     /*  68946 */   // Label 1132: @68946
     /*  68946 */   GIM_Try, /*On fail goto*//*Label 1133*/ GIMT_Encode4(69055), // Rule ID 13696 //
     /*  68951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  68954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68958 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  68962 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  68966 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68970 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68974 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  68978 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  68982 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  68986 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  68990 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  68995 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  68999 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69012 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69016 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69020 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69024 */     // MIs[4] LHS
     /*  69024 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69029 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69034 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69036 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69045 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  69053 */     GIR_RootConstrainSelectedInstOperands,
     /*  69054 */     // GIR_Coverage, 13696,
     /*  69054 */     GIR_EraseRootFromParent_Done,
     /*  69055 */   // Label 1133: @69055
     /*  69055 */   GIM_Try, /*On fail goto*//*Label 1134*/ GIMT_Encode4(69164), // Rule ID 13699 //
     /*  69060 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69067 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69071 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69075 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69079 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69083 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69088 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69092 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69096 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69100 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69133 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69138 */     // MIs[4] LHS
     /*  69138 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69143 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69145 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69150 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69154 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  69158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69162 */     GIR_RootConstrainSelectedInstOperands,
     /*  69163 */     // GIR_Coverage, 13699,
     /*  69163 */     GIR_EraseRootFromParent_Done,
     /*  69164 */   // Label 1134: @69164
     /*  69164 */   GIM_Try, /*On fail goto*//*Label 1135*/ GIMT_Encode4(69273), // Rule ID 13698 //
     /*  69169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69176 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69180 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69184 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69188 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69192 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69205 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69209 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69213 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  69230 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  69234 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69238 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69242 */     // MIs[4] LHS
     /*  69242 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  69247 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69252 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69254 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  69263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  69267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  69271 */     GIR_RootConstrainSelectedInstOperands,
     /*  69272 */     // GIR_Coverage, 13698,
     /*  69272 */     GIR_EraseRootFromParent_Done,
     /*  69273 */   // Label 1135: @69273
     /*  69273 */   GIM_Try, /*On fail goto*//*Label 1136*/ GIMT_Encode4(69382), // Rule ID 2476 //
     /*  69278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69306 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69311 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69315 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69319 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69323 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69327 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69331 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69335 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69339 */     // MIs[3] LHS
     /*  69339 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69344 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69348 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69354 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69361 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69363 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69368 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69380 */     GIR_RootConstrainSelectedInstOperands,
     /*  69381 */     // GIR_Coverage, 2476,
     /*  69381 */     GIR_EraseRootFromParent_Done,
     /*  69382 */   // Label 1136: @69382
     /*  69382 */   GIM_Try, /*On fail goto*//*Label 1137*/ GIMT_Encode4(69491), // Rule ID 13694 //
     /*  69387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69406 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69410 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69432 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  69440 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69444 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69448 */     // MIs[3] LHS
     /*  69448 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69453 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69457 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69465 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69470 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69472 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$RHS))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  69489 */     GIR_RootConstrainSelectedInstOperands,
     /*  69490 */     // GIR_Coverage, 13694,
     /*  69490 */     GIR_EraseRootFromParent_Done,
     /*  69491 */   // Label 1137: @69491
     /*  69491 */   GIM_Try, /*On fail goto*//*Label 1138*/ GIMT_Encode4(69600), // Rule ID 13693 //
     /*  69496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69511 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69515 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69529 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69533 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69537 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69541 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69545 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69550 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69554 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69558 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69562 */     // MIs[3] LHS
     /*  69562 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  69567 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69571 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69577 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69579 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69581 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69586 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  69590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  69594 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69598 */     GIR_RootConstrainSelectedInstOperands,
     /*  69599 */     // GIR_Coverage, 13693,
     /*  69599 */     GIR_EraseRootFromParent_Done,
     /*  69600 */   // Label 1138: @69600
     /*  69600 */   GIM_Try, /*On fail goto*//*Label 1139*/ GIMT_Encode4(69709), // Rule ID 13695 //
     /*  69605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69616 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69620 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69624 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69628 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  69642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  69646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  69663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  69671 */     // MIs[3] LHS
     /*  69671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  69676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  69680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  69686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  69688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  69690 */     // (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$LHS), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, immAllOnesV:{ *:[v4i32] })))  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$MHS, V128:{ *:[v4i32] }:$RHS)
     /*  69690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  69693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  69699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  69703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  69707 */     GIR_RootConstrainSelectedInstOperands,
     /*  69708 */     // GIR_Coverage, 13695,
     /*  69708 */     GIR_EraseRootFromParent_Done,
     /*  69709 */   // Label 1139: @69709
     /*  69709 */   GIM_Try, /*On fail goto*//*Label 1140*/ GIMT_Encode4(69776), // Rule ID 13641 //
     /*  69714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69721 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69725 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69729 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69733 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69738 */     // MIs[1] imm
     /*  69738 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69742 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69746 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69750 */     // MIs[2] Operand 1
     /*  69750 */     // No operand predicates
     /*  69750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69754 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69758 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69760 */     // (or:{ *:[v4i32] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69771 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69774 */     GIR_RootConstrainSelectedInstOperands,
     /*  69775 */     // GIR_Coverage, 13641,
     /*  69775 */     GIR_EraseRootFromParent_Done,
     /*  69776 */   // Label 1140: @69776
     /*  69776 */   GIM_Try, /*On fail goto*//*Label 1141*/ GIMT_Encode4(69843), // Rule ID 13662 //
     /*  69781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69788 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69792 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69796 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69805 */     // MIs[1] imm
     /*  69805 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69809 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69813 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69817 */     // MIs[2] Operand 1
     /*  69817 */     // No operand predicates
     /*  69817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69821 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69827 */     // (or:{ *:[v4i32] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), V128:{ *:[v4i32] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  69834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69841 */     GIR_RootConstrainSelectedInstOperands,
     /*  69842 */     // GIR_Coverage, 13662,
     /*  69842 */     GIR_EraseRootFromParent_Done,
     /*  69843 */   // Label 1141: @69843
     /*  69843 */   GIM_Try, /*On fail goto*//*Label 1142*/ GIMT_Encode4(69910), // Rule ID 2241 //
     /*  69848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  69867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69871 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69876 */     // MIs[1] imm
     /*  69876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69884 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69888 */     // MIs[2] Operand 1
     /*  69888 */     // No operand predicates
     /*  69888 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69894 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv4i32_shift),
     /*  69897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69908 */     GIR_RootConstrainSelectedInstOperands,
     /*  69909 */     // GIR_Coverage, 2241,
     /*  69909 */     GIR_EraseRootFromParent_Done,
     /*  69910 */   // Label 1142: @69910
     /*  69910 */   GIM_Try, /*On fail goto*//*Label 1143*/ GIMT_Encode4(69977), // Rule ID 2300 //
     /*  69915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  69930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  69934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  69938 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69943 */     // MIs[1] imm
     /*  69943 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  69947 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  69951 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /*  69955 */     // MIs[2] Operand 1
     /*  69955 */     // No operand predicates
     /*  69955 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  69959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  69961 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  69961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv4i32_shift),
     /*  69964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  69966 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  69968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  69972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  69975 */     GIR_RootConstrainSelectedInstOperands,
     /*  69976 */     // GIR_Coverage, 2300,
     /*  69976 */     GIR_EraseRootFromParent_Done,
     /*  69977 */   // Label 1143: @69977
     /*  69977 */   GIM_Try, /*On fail goto*//*Label 1144*/ GIMT_Encode4(70041), // Rule ID 13976 //
     /*  69982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  69985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  69989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  69993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  69997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70014 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70020 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70028 */     // (or:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$LHS)  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70033 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  70035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70039 */     GIR_RootConstrainSelectedInstOperands,
     /*  70040 */     // GIR_Coverage, 13976,
     /*  70040 */     GIR_EraseRootFromParent_Done,
     /*  70041 */   // Label 1144: @70041
     /*  70041 */   GIM_Try, /*On fail goto*//*Label 1145*/ GIMT_Encode4(70105), // Rule ID 5072 //
     /*  70046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70049 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70057 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  70061 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70065 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  70069 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  70073 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70082 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70088 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  70090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  70092 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$RHS, immAllOnesV:{ *:[v4i32] }))  =>  (ORNv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  70095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  70097 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  70099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  70103 */     GIR_RootConstrainSelectedInstOperands,
     /*  70104 */     // GIR_Coverage, 5072,
     /*  70104 */     GIR_EraseRootFromParent_Done,
     /*  70105 */   // Label 1145: @70105
     /*  70105 */   GIM_Try, /*On fail goto*//*Label 1146*/ GIMT_Encode4(70132), // Rule ID 5078 //
     /*  70110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  70125 */     // (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (ORRv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  70125 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  70130 */     GIR_RootConstrainSelectedInstOperands,
     /*  70131 */     // GIR_Coverage, 5078,
     /*  70131 */     GIR_Done,
     /*  70132 */   // Label 1146: @70132
     /*  70132 */   GIM_Reject,
     /*  70133 */ // Label 1131: @70133
     /*  70133 */ GIM_Reject,
     /*  70134 */ // Label 1035: @70134
     /*  70134 */ GIM_Try, /*On fail goto*//*Label 1147*/ GIMT_Encode4(71441),
     /*  70139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70142 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70145 */   GIM_Try, /*On fail goto*//*Label 1148*/ GIMT_Encode4(70254), // Rule ID 13447 //
     /*  70150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70169 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70194 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70198 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70206 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70223 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70228 */     // MIs[4] Rd
     /*  70228 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70233 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70235 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70240 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70248 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70252 */     GIR_RootConstrainSelectedInstOperands,
     /*  70253 */     // GIR_Coverage, 13447,
     /*  70253 */     GIR_EraseRootFromParent_Done,
     /*  70254 */   // Label 1148: @70254
     /*  70254 */   GIM_Try, /*On fail goto*//*Label 1149*/ GIMT_Encode4(70363), // Rule ID 13446 //
     /*  70259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70274 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70278 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70282 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  70286 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70290 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70294 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70298 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70303 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70307 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70313 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70320 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70324 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70328 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70332 */     // MIs[4] Rd
     /*  70332 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70337 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70342 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70344 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  70361 */     GIR_RootConstrainSelectedInstOperands,
     /*  70362 */     // GIR_Coverage, 13446,
     /*  70362 */     GIR_EraseRootFromParent_Done,
     /*  70363 */   // Label 1149: @70363
     /*  70363 */   GIM_Try, /*On fail goto*//*Label 1150*/ GIMT_Encode4(70472), // Rule ID 13449 //
     /*  70368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70391 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70396 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70400 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70404 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70408 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70412 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70417 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70421 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70427 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70429 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70433 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70437 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70446 */     // MIs[4] Rd
     /*  70446 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70451 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70453 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  70466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70470 */     GIR_RootConstrainSelectedInstOperands,
     /*  70471 */     // GIR_Coverage, 13449,
     /*  70471 */     GIR_EraseRootFromParent_Done,
     /*  70472 */   // Label 1150: @70472
     /*  70472 */   GIM_Try, /*On fail goto*//*Label 1151*/ GIMT_Encode4(70581), // Rule ID 13448 //
     /*  70477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  70509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70513 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70517 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70521 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70526 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70530 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  70538 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  70542 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70546 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70550 */     // MIs[4] Rd
     /*  70550 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  70555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70560 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70562 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  70571 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  70575 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  70579 */     GIR_RootConstrainSelectedInstOperands,
     /*  70580 */     // GIR_Coverage, 13448,
     /*  70580 */     GIR_EraseRootFromParent_Done,
     /*  70581 */   // Label 1151: @70581
     /*  70581 */   GIM_Try, /*On fail goto*//*Label 1152*/ GIMT_Encode4(70690), // Rule ID 1605 //
     /*  70586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70605 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70619 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70623 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70627 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70631 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70643 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70647 */     // MIs[3] Rd
     /*  70647 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70652 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70656 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70662 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70669 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70671 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70688 */     GIR_RootConstrainSelectedInstOperands,
     /*  70689 */     // GIR_Coverage, 1605,
     /*  70689 */     GIR_EraseRootFromParent_Done,
     /*  70690 */   // Label 1152: @70690
     /*  70690 */   GIM_Try, /*On fail goto*//*Label 1153*/ GIMT_Encode4(70799), // Rule ID 13444 //
     /*  70695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70723 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70736 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70740 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  70748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70752 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70756 */     // MIs[3] Rd
     /*  70756 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70765 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70773 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70780 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rm))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  70789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  70793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  70797 */     GIR_RootConstrainSelectedInstOperands,
     /*  70798 */     // GIR_Coverage, 13444,
     /*  70798 */     GIR_EraseRootFromParent_Done,
     /*  70799 */   // Label 1153: @70799
     /*  70799 */   GIM_Try, /*On fail goto*//*Label 1154*/ GIMT_Encode4(70908), // Rule ID 13443 //
     /*  70804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70823 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70827 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70832 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70837 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70841 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70845 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70849 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70853 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70858 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70862 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70866 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70870 */     // MIs[3] Rd
     /*  70870 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  70875 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70879 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70885 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70887 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70889 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  70892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  70894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  70898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  70902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  70906 */     GIR_RootConstrainSelectedInstOperands,
     /*  70907 */     // GIR_Coverage, 13443,
     /*  70907 */     GIR_EraseRootFromParent_Done,
     /*  70908 */   // Label 1154: @70908
     /*  70908 */   GIM_Try, /*On fail goto*//*Label 1155*/ GIMT_Encode4(71017), // Rule ID 13445 //
     /*  70913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  70916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  70924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70946 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  70950 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  70954 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  70958 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70962 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  70967 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  70971 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  70975 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  70979 */     // MIs[3] Rd
     /*  70979 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  70984 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  70988 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  70994 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  70996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  70998 */     // (or:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rd), (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, immAllOnesV:{ *:[v8i8] })))  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  70998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /*  71001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  71007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  71015 */     GIR_RootConstrainSelectedInstOperands,
     /*  71016 */     // GIR_Coverage, 13445,
     /*  71016 */     GIR_EraseRootFromParent_Done,
     /*  71017 */   // Label 1155: @71017
     /*  71017 */   GIM_Try, /*On fail goto*//*Label 1156*/ GIMT_Encode4(71084), // Rule ID 13631 //
     /*  71022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71046 */     // MIs[1] imm
     /*  71046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71058 */     // MIs[2] Operand 1
     /*  71058 */     // No operand predicates
     /*  71058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71062 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71068 */     // (or:{ *:[v8i8] } (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71079 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71082 */     GIR_RootConstrainSelectedInstOperands,
     /*  71083 */     // GIR_Coverage, 13631,
     /*  71083 */     GIR_EraseRootFromParent_Done,
     /*  71084 */   // Label 1156: @71084
     /*  71084 */   GIM_Try, /*On fail goto*//*Label 1157*/ GIMT_Encode4(71151), // Rule ID 13652 //
     /*  71089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71100 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71104 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71108 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71113 */     // MIs[1] imm
     /*  71113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71121 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71125 */     // MIs[2] Operand 1
     /*  71125 */     // No operand predicates
     /*  71125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71129 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71135 */     // (or:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V64:{ *:[v8i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  71142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71146 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71149 */     GIR_RootConstrainSelectedInstOperands,
     /*  71150 */     // GIR_Coverage, 13652,
     /*  71150 */     GIR_EraseRootFromParent_Done,
     /*  71151 */   // Label 1157: @71151
     /*  71151 */   GIM_Try, /*On fail goto*//*Label 1158*/ GIMT_Encode4(71218), // Rule ID 2231 //
     /*  71156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  71175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71179 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71184 */     // MIs[1] imm
     /*  71184 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71188 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71192 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71196 */     // MIs[2] Operand 1
     /*  71196 */     // No operand predicates
     /*  71196 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71200 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71202 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i8_shift),
     /*  71205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71216 */     GIR_RootConstrainSelectedInstOperands,
     /*  71217 */     // GIR_Coverage, 2231,
     /*  71217 */     GIR_EraseRootFromParent_Done,
     /*  71218 */   // Label 1158: @71218
     /*  71218 */   GIM_Try, /*On fail goto*//*Label 1159*/ GIMT_Encode4(71285), // Rule ID 2290 //
     /*  71223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71226 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  71242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71246 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71251 */     // MIs[1] imm
     /*  71251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  71259 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  71263 */     // MIs[2] Operand 1
     /*  71263 */     // No operand predicates
     /*  71263 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  71267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71269 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  71269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i8_shift),
     /*  71272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71274 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  71276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  71280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  71283 */     GIR_RootConstrainSelectedInstOperands,
     /*  71284 */     // GIR_Coverage, 2290,
     /*  71284 */     GIR_EraseRootFromParent_Done,
     /*  71285 */   // Label 1159: @71285
     /*  71285 */   GIM_Try, /*On fail goto*//*Label 1160*/ GIMT_Encode4(71349), // Rule ID 13441 //
     /*  71290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71309 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71313 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71318 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71322 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71328 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71334 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71336 */     // (or:{ *:[v8i8] } (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }), V64:{ *:[v8i8] }:$Rn)  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  71343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71347 */     GIR_RootConstrainSelectedInstOperands,
     /*  71348 */     // GIR_Coverage, 13441,
     /*  71348 */     GIR_EraseRootFromParent_Done,
     /*  71349 */   // Label 1160: @71349
     /*  71349 */   GIM_Try, /*On fail goto*//*Label 1161*/ GIMT_Encode4(71413), // Rule ID 1601 //
     /*  71354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  71369 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71373 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  71377 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  71381 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71386 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71390 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71396 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  71398 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  71400 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, immAllOnesV:{ *:[v8i8] }))  =>  (ORNv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv8i8),
     /*  71403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  71405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  71407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  71411 */     GIR_RootConstrainSelectedInstOperands,
     /*  71412 */     // GIR_Coverage, 1601,
     /*  71412 */     GIR_EraseRootFromParent_Done,
     /*  71413 */   // Label 1161: @71413
     /*  71413 */   GIM_Try, /*On fail goto*//*Label 1162*/ GIMT_Encode4(71440), // Rule ID 1603 //
     /*  71418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  71433 */     // (or:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ORRv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  71433 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv8i8),
     /*  71438 */     GIR_RootConstrainSelectedInstOperands,
     /*  71439 */     // GIR_Coverage, 1603,
     /*  71439 */     GIR_Done,
     /*  71440 */   // Label 1162: @71440
     /*  71440 */   GIM_Reject,
     /*  71441 */ // Label 1147: @71441
     /*  71441 */ GIM_Reject,
     /*  71442 */ // Label 1036: @71442
     /*  71442 */ GIM_Try, /*On fail goto*//*Label 1163*/ GIMT_Encode4(72749),
     /*  71447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71450 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71453 */   GIM_Try, /*On fail goto*//*Label 1164*/ GIMT_Encode4(71562), // Rule ID 13690 //
     /*  71458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71481 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71485 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71489 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71493 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71497 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71502 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71506 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71512 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71519 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71523 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71527 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71531 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71536 */     // MIs[4] LHS
     /*  71536 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71541 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71543 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71548 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71552 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71556 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71560 */     GIR_RootConstrainSelectedInstOperands,
     /*  71561 */     // GIR_Coverage, 13690,
     /*  71561 */     GIR_EraseRootFromParent_Done,
     /*  71562 */   // Label 1164: @71562
     /*  71562 */   GIM_Try, /*On fail goto*//*Label 1165*/ GIMT_Encode4(71671), // Rule ID 13689 //
     /*  71567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  71594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71615 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71621 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71628 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71632 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71636 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71640 */     // MIs[4] LHS
     /*  71640 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71645 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71650 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71652 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // RHS
     /*  71669 */     GIR_RootConstrainSelectedInstOperands,
     /*  71670 */     // GIR_Coverage, 13689,
     /*  71670 */     GIR_EraseRootFromParent_Done,
     /*  71671 */   // Label 1165: @71671
     /*  71671 */   GIM_Try, /*On fail goto*//*Label 1166*/ GIMT_Encode4(71780), // Rule ID 13692 //
     /*  71676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71712 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71716 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71720 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71725 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71729 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71735 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71737 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71741 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71745 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71749 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71754 */     // MIs[4] LHS
     /*  71754 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71759 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71761 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71766 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71770 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // MHS
     /*  71774 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71778 */     GIR_RootConstrainSelectedInstOperands,
     /*  71779 */     // GIR_Coverage, 13692,
     /*  71779 */     GIR_EraseRootFromParent_Done,
     /*  71780 */   // Label 1166: @71780
     /*  71780 */   GIM_Try, /*On fail goto*//*Label 1167*/ GIMT_Encode4(71889), // Rule ID 13691 //
     /*  71785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  71817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71829 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71834 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  71838 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  71846 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  71850 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71854 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71858 */     // MIs[4] LHS
     /*  71858 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  71863 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71870 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // LHS
     /*  71879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // MHS
     /*  71883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  71887 */     GIR_RootConstrainSelectedInstOperands,
     /*  71888 */     // GIR_Coverage, 13691,
     /*  71888 */     GIR_EraseRootFromParent_Done,
     /*  71889 */   // Label 1167: @71889
     /*  71889 */   GIM_Try, /*On fail goto*//*Label 1168*/ GIMT_Encode4(71998), // Rule ID 2475 //
     /*  71894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  71897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  71905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  71931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  71935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  71939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  71947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  71951 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  71955 */     // MIs[3] LHS
     /*  71955 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  71960 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  71964 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  71970 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  71972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  71977 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  71979 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  71979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  71982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  71984 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  71988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  71992 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  71996 */     GIR_RootConstrainSelectedInstOperands,
     /*  71997 */     // GIR_Coverage, 2475,
     /*  71997 */     GIR_EraseRootFromParent_Done,
     /*  71998 */   // Label 1168: @71998
     /*  71998 */   GIM_Try, /*On fail goto*//*Label 1169*/ GIMT_Encode4(72107), // Rule ID 13687 //
     /*  72003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72006 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72010 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72014 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72018 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72022 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72026 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72031 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72036 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72040 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72044 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72048 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72052 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  72056 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72060 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72064 */     // MIs[3] LHS
     /*  72064 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72086 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72088 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$RHS))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // RHS
     /*  72105 */     GIR_RootConstrainSelectedInstOperands,
     /*  72106 */     // GIR_Coverage, 13687,
     /*  72106 */     GIR_EraseRootFromParent_Done,
     /*  72107 */   // Label 1169: @72107
     /*  72107 */   GIM_Try, /*On fail goto*//*Label 1170*/ GIMT_Encode4(72216), // Rule ID 13686 //
     /*  72112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72153 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72157 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72161 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72166 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72170 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72174 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72178 */     // MIs[3] LHS
     /*  72178 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  72183 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72187 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72193 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72195 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72197 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72202 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // LHS
     /*  72206 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // MHS
     /*  72210 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72214 */     GIR_RootConstrainSelectedInstOperands,
     /*  72215 */     // GIR_Coverage, 13686,
     /*  72215 */     GIR_EraseRootFromParent_Done,
     /*  72216 */   // Label 1170: @72216
     /*  72216 */   GIM_Try, /*On fail goto*//*Label 1171*/ GIMT_Encode4(72325), // Rule ID 13688 //
     /*  72221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  72258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72262 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72266 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72279 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72283 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72287 */     // MIs[3] LHS
     /*  72287 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  72292 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  72296 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72302 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  72304 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72306 */     // (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$LHS), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, immAllOnesV:{ *:[v8i16] })))  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$MHS, V128:{ *:[v8i16] }:$RHS)
     /*  72306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // LHS
     /*  72315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // MHS
     /*  72319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // RHS
     /*  72323 */     GIR_RootConstrainSelectedInstOperands,
     /*  72324 */     // GIR_Coverage, 13688,
     /*  72324 */     GIR_EraseRootFromParent_Done,
     /*  72325 */   // Label 1171: @72325
     /*  72325 */   GIM_Try, /*On fail goto*//*Label 1172*/ GIMT_Encode4(72392), // Rule ID 13637 //
     /*  72330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72354 */     // MIs[1] imm
     /*  72354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72362 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72366 */     // MIs[2] Operand 1
     /*  72366 */     // No operand predicates
     /*  72366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72370 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72376 */     // (or:{ *:[v8i16] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72390 */     GIR_RootConstrainSelectedInstOperands,
     /*  72391 */     // GIR_Coverage, 13637,
     /*  72391 */     GIR_EraseRootFromParent_Done,
     /*  72392 */   // Label 1172: @72392
     /*  72392 */   GIM_Try, /*On fail goto*//*Label 1173*/ GIMT_Encode4(72459), // Rule ID 13658 //
     /*  72397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72421 */     // MIs[1] imm
     /*  72421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72429 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72433 */     // MIs[2] Operand 1
     /*  72433 */     // No operand predicates
     /*  72433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72437 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72443 */     // (or:{ *:[v8i16] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm), V128:{ *:[v8i16] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  72450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72454 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72457 */     GIR_RootConstrainSelectedInstOperands,
     /*  72458 */     // GIR_Coverage, 13658,
     /*  72458 */     GIR_EraseRootFromParent_Done,
     /*  72459 */   // Label 1173: @72459
     /*  72459 */   GIM_Try, /*On fail goto*//*Label 1174*/ GIMT_Encode4(72526), // Rule ID 2237 //
     /*  72464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72471 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  72483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72487 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72492 */     // MIs[1] imm
     /*  72492 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72496 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72500 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72504 */     // MIs[2] Operand 1
     /*  72504 */     // No operand predicates
     /*  72504 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72508 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72510 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv8i16_shift),
     /*  72513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72524 */     GIR_RootConstrainSelectedInstOperands,
     /*  72525 */     // GIR_Coverage, 2237,
     /*  72525 */     GIR_EraseRootFromParent_Done,
     /*  72526 */   // Label 1174: @72526
     /*  72526 */   GIM_Try, /*On fail goto*//*Label 1175*/ GIMT_Encode4(72593), // Rule ID 2296 //
     /*  72531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72538 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72542 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72546 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  72550 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72554 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72559 */     // MIs[1] imm
     /*  72559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  72567 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /*  72571 */     // MIs[2] Operand 1
     /*  72571 */     // No operand predicates
     /*  72571 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  72575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72577 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  72577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv8i16_shift),
     /*  72580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72582 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  72584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  72588 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  72591 */     GIR_RootConstrainSelectedInstOperands,
     /*  72592 */     // GIR_Coverage, 2296,
     /*  72592 */     GIR_EraseRootFromParent_Done,
     /*  72593 */   // Label 1175: @72593
     /*  72593 */   GIM_Try, /*On fail goto*//*Label 1176*/ GIMT_Encode4(72657), // Rule ID 13975 //
     /*  72598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72621 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72626 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72630 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72636 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72642 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72644 */     // (or:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$LHS)  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72649 */     GIR_RootToRootCopy, /*OpIdx*/2, // LHS
     /*  72651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72655 */     GIR_RootConstrainSelectedInstOperands,
     /*  72656 */     // GIR_Coverage, 13975,
     /*  72656 */     GIR_EraseRootFromParent_Done,
     /*  72657 */   // Label 1176: @72657
     /*  72657 */   GIM_Try, /*On fail goto*//*Label 1177*/ GIMT_Encode4(72721), // Rule ID 5071 //
     /*  72662 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72669 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72673 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  72677 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72681 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  72685 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  72689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  72698 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  72706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  72708 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$RHS, immAllOnesV:{ *:[v8i16] }))  =>  (ORNv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  72711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  72713 */     GIR_RootToRootCopy, /*OpIdx*/1, // LHS
     /*  72715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // RHS
     /*  72719 */     GIR_RootConstrainSelectedInstOperands,
     /*  72720 */     // GIR_Coverage, 5071,
     /*  72720 */     GIR_EraseRootFromParent_Done,
     /*  72721 */   // Label 1177: @72721
     /*  72721 */   GIM_Try, /*On fail goto*//*Label 1178*/ GIMT_Encode4(72748), // Rule ID 5077 //
     /*  72726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72733 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72741 */     // (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (ORRv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  72741 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  72746 */     GIR_RootConstrainSelectedInstOperands,
     /*  72747 */     // GIR_Coverage, 5077,
     /*  72747 */     GIR_Done,
     /*  72748 */   // Label 1178: @72748
     /*  72748 */   GIM_Reject,
     /*  72749 */ // Label 1163: @72749
     /*  72749 */ GIM_Reject,
     /*  72750 */ // Label 1037: @72750
     /*  72750 */ GIM_Try, /*On fail goto*//*Label 1179*/ GIMT_Encode4(74057),
     /*  72755 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72758 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72761 */   GIM_Try, /*On fail goto*//*Label 1180*/ GIMT_Encode4(72870), // Rule ID 13454 //
     /*  72766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72805 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72810 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72814 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72820 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72822 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72827 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72831 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72835 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72839 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72844 */     // MIs[4] Rd
     /*  72844 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72849 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72851 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72856 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  72864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72868 */     GIR_RootConstrainSelectedInstOperands,
     /*  72869 */     // GIR_Coverage, 13454,
     /*  72869 */     GIR_EraseRootFromParent_Done,
     /*  72870 */   // Label 1180: @72870
     /*  72870 */   GIM_Try, /*On fail goto*//*Label 1181*/ GIMT_Encode4(72979), // Rule ID 13453 //
     /*  72875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72882 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72886 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72890 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72894 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  72902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  72906 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  72910 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72914 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72919 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  72923 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  72929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  72931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72936 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  72940 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72944 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  72948 */     // MIs[4] Rd
     /*  72948 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  72953 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  72960 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  72960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  72963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  72965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  72969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  72973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  72977 */     GIR_RootConstrainSelectedInstOperands,
     /*  72978 */     // GIR_Coverage, 13453,
     /*  72978 */     GIR_EraseRootFromParent_Done,
     /*  72979 */   // Label 1181: @72979
     /*  72979 */   GIM_Try, /*On fail goto*//*Label 1182*/ GIMT_Encode4(73088), // Rule ID 13456 //
     /*  72984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  72987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  72991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  72995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  72999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73024 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73028 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73033 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73037 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73045 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73049 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73053 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73057 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73062 */     // MIs[4] Rd
     /*  73062 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73067 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73069 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73074 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /*  73082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73086 */     GIR_RootConstrainSelectedInstOperands,
     /*  73087 */     // GIR_Coverage, 13456,
     /*  73087 */     GIR_EraseRootFromParent_Done,
     /*  73088 */   // Label 1182: @73088
     /*  73088 */   GIM_Try, /*On fail goto*//*Label 1183*/ GIMT_Encode4(73197), // Rule ID 13455 //
     /*  73093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73104 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73108 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73112 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73116 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73129 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73133 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73137 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73142 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73146 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73152 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  73154 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  73158 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73166 */     // MIs[4] Rd
     /*  73166 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  73171 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73176 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73178 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rd
     /*  73187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Rn
     /*  73191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73195 */     GIR_RootConstrainSelectedInstOperands,
     /*  73196 */     // GIR_Coverage, 13455,
     /*  73196 */     GIR_EraseRootFromParent_Done,
     /*  73197 */   // Label 1183: @73197
     /*  73197 */   GIM_Try, /*On fail goto*//*Label 1184*/ GIMT_Encode4(73306), // Rule ID 1606 //
     /*  73202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73225 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73230 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73235 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73239 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73243 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73247 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73251 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73255 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73259 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73263 */     // MIs[3] Rd
     /*  73263 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73268 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73272 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73278 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73280 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73285 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73287 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73296 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73304 */     GIR_RootConstrainSelectedInstOperands,
     /*  73305 */     // GIR_Coverage, 1606,
     /*  73305 */     GIR_EraseRootFromParent_Done,
     /*  73306 */   // Label 1184: @73306
     /*  73306 */   GIM_Try, /*On fail goto*//*Label 1185*/ GIMT_Encode4(73415), // Rule ID 13451 //
     /*  73311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73339 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  73364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73368 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73372 */     // MIs[3] Rd
     /*  73372 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73377 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73381 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73387 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73389 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73394 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73396 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rm))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73396 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73399 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73405 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  73413 */     GIR_RootConstrainSelectedInstOperands,
     /*  73414 */     // GIR_Coverage, 13451,
     /*  73414 */     GIR_EraseRootFromParent_Done,
     /*  73415 */   // Label 1185: @73415
     /*  73415 */   GIM_Try, /*On fail goto*//*Label 1186*/ GIMT_Encode4(73524), // Rule ID 13450 //
     /*  73420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73439 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73443 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73474 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73478 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73482 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73486 */     // MIs[3] Rd
     /*  73486 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  73491 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73495 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73501 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73503 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73505 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rd
     /*  73514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  73518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73522 */     GIR_RootConstrainSelectedInstOperands,
     /*  73523 */     // GIR_Coverage, 13450,
     /*  73523 */     GIR_EraseRootFromParent_Done,
     /*  73524 */   // Label 1186: @73524
     /*  73524 */   GIM_Try, /*On fail goto*//*Label 1187*/ GIMT_Encode4(73633), // Rule ID 13452 //
     /*  73529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73552 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73562 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  73566 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  73570 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73574 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73578 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73583 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  73587 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73591 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73595 */     // MIs[3] Rd
     /*  73595 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  73600 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  73604 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73610 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  73612 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  73614 */     // (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rd), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, immAllOnesV:{ *:[v16i8] })))  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /*  73617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rd
     /*  73623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /*  73631 */     GIR_RootConstrainSelectedInstOperands,
     /*  73632 */     // GIR_Coverage, 13452,
     /*  73632 */     GIR_EraseRootFromParent_Done,
     /*  73633 */   // Label 1187: @73633
     /*  73633 */   GIM_Try, /*On fail goto*//*Label 1188*/ GIMT_Encode4(73700), // Rule ID 13633 //
     /*  73638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73662 */     // MIs[1] imm
     /*  73662 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73666 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73670 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73674 */     // MIs[2] Operand 1
     /*  73674 */     // No operand predicates
     /*  73674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73678 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73682 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73684 */     // (or:{ *:[v16i8] } (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73698 */     GIR_RootConstrainSelectedInstOperands,
     /*  73699 */     // GIR_Coverage, 13633,
     /*  73699 */     GIR_EraseRootFromParent_Done,
     /*  73700 */   // Label 1188: @73700
     /*  73700 */   GIM_Try, /*On fail goto*//*Label 1189*/ GIMT_Encode4(73767), // Rule ID 13654 //
     /*  73705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73729 */     // MIs[1] imm
     /*  73729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73737 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73741 */     // MIs[2] Operand 1
     /*  73741 */     // No operand predicates
     /*  73741 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73745 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73751 */     // (or:{ *:[v16i8] } (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm), V128:{ *:[v16i8] }:$Rd)<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /*  73758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73765 */     GIR_RootConstrainSelectedInstOperands,
     /*  73766 */     // GIR_Coverage, 13654,
     /*  73766 */     GIR_EraseRootFromParent_Done,
     /*  73767 */   // Label 1189: @73767
     /*  73767 */   GIM_Try, /*On fail goto*//*Label 1190*/ GIMT_Encode4(73834), // Rule ID 2233 //
     /*  73772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73787 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /*  73791 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73795 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73800 */     // MIs[1] imm
     /*  73800 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73804 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73808 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73812 */     // MIs[2] Operand 1
     /*  73812 */     // No operand predicates
     /*  73812 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73816 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73818 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (SSRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRAv16i8_shift),
     /*  73821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73823 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73832 */     GIR_RootConstrainSelectedInstOperands,
     /*  73833 */     // GIR_Coverage, 2233,
     /*  73833 */     GIR_EraseRootFromParent_Done,
     /*  73834 */   // Label 1190: @73834
     /*  73834 */   GIM_Try, /*On fail goto*//*Label 1191*/ GIMT_Encode4(73901), // Rule ID 2292 //
     /*  73839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73846 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /*  73858 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73862 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73867 */     // MIs[1] imm
     /*  73867 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73871 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  73875 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /*  73879 */     // MIs[2] Operand 1
     /*  73879 */     // No operand predicates
     /*  73879 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_add_and_or_is_add),
     /*  73883 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73885 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm))<<P:Predicate_add_and_or_is_add>>  =>  (USRAv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /*  73885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRAv16i8_shift),
     /*  73888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  73890 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /*  73892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  73896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /*  73899 */     GIR_RootConstrainSelectedInstOperands,
     /*  73900 */     // GIR_Coverage, 2292,
     /*  73900 */     GIR_EraseRootFromParent_Done,
     /*  73901 */   // Label 1191: @73901
     /*  73901 */   GIM_Try, /*On fail goto*//*Label 1192*/ GIMT_Encode4(73965), // Rule ID 13442 //
     /*  73906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73913 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  73917 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73921 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73925 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73929 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  73938 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  73944 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  73946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73950 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  73952 */     // (or:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Rn)  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  73952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  73955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  73957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  73959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  73963 */     GIR_RootConstrainSelectedInstOperands,
     /*  73964 */     // GIR_Coverage, 13442,
     /*  73964 */     GIR_EraseRootFromParent_Done,
     /*  73965 */   // Label 1192: @73965
     /*  73965 */   GIM_Try, /*On fail goto*//*Label 1193*/ GIMT_Encode4(74029), // Rule ID 1602 //
     /*  73970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  73973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73977 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  73981 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  73985 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  73989 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  73993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  73997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  74006 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  74014 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  74016 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, immAllOnesV:{ *:[v16i8] }))  =>  (ORNv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNv16i8),
     /*  74019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  74021 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  74023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /*  74027 */     GIR_RootConstrainSelectedInstOperands,
     /*  74028 */     // GIR_Coverage, 1602,
     /*  74028 */     GIR_EraseRootFromParent_Done,
     /*  74029 */   // Label 1193: @74029
     /*  74029 */   GIM_Try, /*On fail goto*//*Label 1194*/ GIMT_Encode4(74056), // Rule ID 1604 //
     /*  74034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  74037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  74049 */     // (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ORRv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  74049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORRv16i8),
     /*  74054 */     GIR_RootConstrainSelectedInstOperands,
     /*  74055 */     // GIR_Coverage, 1604,
     /*  74055 */     GIR_Done,
     /*  74056 */   // Label 1194: @74056
     /*  74056 */   GIM_Reject,
     /*  74057 */ // Label 1179: @74057
     /*  74057 */ GIM_Reject,
     /*  74058 */ // Label 1038: @74058
     /*  74058 */ GIM_Try, /*On fail goto*//*Label 1195*/ GIMT_Encode4(74089), // Rule ID 8504 //
     /*  74063 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  74069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  74072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74076 */   // (or:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  74076 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74079 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74081 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74083 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74085 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74087 */   GIR_RootConstrainSelectedInstOperands,
     /*  74088 */   // GIR_Coverage, 8504,
     /*  74088 */   GIR_EraseRootFromParent_Done,
     /*  74089 */ // Label 1195: @74089
     /*  74089 */ GIM_Reject,
     /*  74090 */ // Label 1039: @74090
     /*  74090 */ GIM_Try, /*On fail goto*//*Label 1196*/ GIMT_Encode4(74121), // Rule ID 8503 //
     /*  74095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  74098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  74101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  74104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  74108 */   // (or:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  74108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  74111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  74113 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74115 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  74117 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  74119 */   GIR_RootConstrainSelectedInstOperands,
     /*  74120 */   // GIR_Coverage, 8503,
     /*  74120 */   GIR_EraseRootFromParent_Done,
     /*  74121 */ // Label 1196: @74121
     /*  74121 */ GIM_Reject,
     /*  74122 */ // Label 1040: @74122
     /*  74122 */ GIM_Try, /*On fail goto*//*Label 1197*/ GIMT_Encode4(77481),
     /*  74127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  74137 */   GIM_Try, /*On fail goto*//*Label 1198*/ GIMT_Encode4(74255), // Rule ID 15807 //
     /*  74142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74181 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74187 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74205 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74209 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74217 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74221 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74225 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74229 */     // MIs[6] Op3
     /*  74229 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74234 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74236 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74241 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74253 */     GIR_RootConstrainSelectedInstOperands,
     /*  74254 */     // GIR_Coverage, 15807,
     /*  74254 */     GIR_EraseRootFromParent_Done,
     /*  74255 */   // Label 1198: @74255
     /*  74255 */   GIM_Try, /*On fail goto*//*Label 1199*/ GIMT_Encode4(74373), // Rule ID 15809 //
     /*  74260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74287 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74291 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74295 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74299 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74305 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74307 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74311 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74315 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74319 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74323 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74327 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74333 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74335 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74339 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74343 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74347 */     // MIs[6] Op3
     /*  74347 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74352 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74354 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  74363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74371 */     GIR_RootConstrainSelectedInstOperands,
     /*  74372 */     // GIR_Coverage, 15809,
     /*  74372 */     GIR_EraseRootFromParent_Done,
     /*  74373 */   // Label 1199: @74373
     /*  74373 */   GIM_Try, /*On fail goto*//*Label 1200*/ GIMT_Encode4(74491), // Rule ID 15806 //
     /*  74378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74389 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74393 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74417 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74423 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74433 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74437 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74441 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74445 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74451 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74453 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74457 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74461 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74465 */     // MIs[6] Op3
     /*  74465 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  74470 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74472 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  74485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  74489 */     GIR_RootConstrainSelectedInstOperands,
     /*  74490 */     // GIR_Coverage, 15806,
     /*  74490 */     GIR_EraseRootFromParent_Done,
     /*  74491 */   // Label 1200: @74491
     /*  74491 */   GIM_Try, /*On fail goto*//*Label 1201*/ GIMT_Encode4(74609), // Rule ID 15808 //
     /*  74496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74515 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74519 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74523 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74527 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74531 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74535 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74541 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74543 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  74547 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74551 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74555 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74559 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74563 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74569 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  74571 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  74575 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74579 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74583 */     // MIs[6] Op3
     /*  74583 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74588 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74590 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  74593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  74599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  74603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74607 */     GIR_RootConstrainSelectedInstOperands,
     /*  74608 */     // GIR_Coverage, 15808,
     /*  74608 */     GIR_EraseRootFromParent_Done,
     /*  74609 */   // Label 1201: @74609
     /*  74609 */   GIM_Try, /*On fail goto*//*Label 1202*/ GIMT_Encode4(74727), // Rule ID 15754 //
     /*  74614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74633 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74637 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74641 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74645 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74649 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74653 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74659 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74661 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74665 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74669 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74673 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74677 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74681 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74685 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74689 */     // MIs[5] Op3
     /*  74689 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  74694 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74698 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74704 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74706 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74708 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  74717 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  74721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  74725 */     GIR_RootConstrainSelectedInstOperands,
     /*  74726 */     // GIR_Coverage, 15754,
     /*  74726 */     GIR_EraseRootFromParent_Done,
     /*  74727 */   // Label 1202: @74727
     /*  74727 */   GIM_Try, /*On fail goto*//*Label 1203*/ GIMT_Encode4(74845), // Rule ID 15759 //
     /*  74732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74735 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74739 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74743 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74747 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74759 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74763 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74767 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74771 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74777 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74779 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74783 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74787 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74791 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  74795 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74799 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74803 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74807 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74811 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74819 */     // MIs[4] Op3
     /*  74819 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74824 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74826 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74831 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74835 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74843 */     GIR_RootConstrainSelectedInstOperands,
     /*  74844 */     // GIR_Coverage, 15759,
     /*  74844 */     GIR_EraseRootFromParent_Done,
     /*  74845 */   // Label 1203: @74845
     /*  74845 */   GIM_Try, /*On fail goto*//*Label 1204*/ GIMT_Encode4(74963), // Rule ID 15760 //
     /*  74850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74865 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74869 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74873 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74877 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74881 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74885 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  74889 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74895 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  74897 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  74901 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74905 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74909 */     // MIs[4] Op3
     /*  74909 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  74914 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  74918 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74922 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74926 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74930 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  74934 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  74940 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  74942 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  74944 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  74944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  74947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  74949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  74953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  74957 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  74961 */     GIR_RootConstrainSelectedInstOperands,
     /*  74962 */     // GIR_Coverage, 15760,
     /*  74962 */     GIR_EraseRootFromParent_Done,
     /*  74963 */   // Label 1204: @74963
     /*  74963 */   GIM_Try, /*On fail goto*//*Label 1205*/ GIMT_Encode4(75081), // Rule ID 11952 //
     /*  74968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  74971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  74975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  74979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  74987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  74991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  74995 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  74999 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75015 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75019 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75023 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75027 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75031 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75035 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75039 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75043 */     // MIs[5] Op3
     /*  75043 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75048 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75052 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75058 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75060 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75062 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75067 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75071 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75075 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75079 */     GIR_RootConstrainSelectedInstOperands,
     /*  75080 */     // GIR_Coverage, 11952,
     /*  75080 */     GIR_EraseRootFromParent_Done,
     /*  75081 */   // Label 1205: @75081
     /*  75081 */   GIM_Try, /*On fail goto*//*Label 1206*/ GIMT_Encode4(75199), // Rule ID 15756 //
     /*  75086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75097 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75101 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75105 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75109 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75113 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75117 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75121 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75125 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75131 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75133 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75137 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75141 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75145 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75149 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75153 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75157 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75161 */     // MIs[5] Op3
     /*  75161 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75166 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75170 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75176 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75178 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75180 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  75193 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75197 */     GIR_RootConstrainSelectedInstOperands,
     /*  75198 */     // GIR_Coverage, 15756,
     /*  75198 */     GIR_EraseRootFromParent_Done,
     /*  75199 */   // Label 1206: @75199
     /*  75199 */   GIM_Try, /*On fail goto*//*Label 1207*/ GIMT_Encode4(75317), // Rule ID 15757 //
     /*  75204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75219 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75223 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75227 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75231 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75235 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75239 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75243 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75249 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75251 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75255 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75259 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75263 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  75267 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75271 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75275 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75279 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75283 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75291 */     // MIs[4] Op3
     /*  75291 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75296 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75298 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75315 */     GIR_RootConstrainSelectedInstOperands,
     /*  75316 */     // GIR_Coverage, 15757,
     /*  75316 */     GIR_EraseRootFromParent_Done,
     /*  75317 */   // Label 1207: @75317
     /*  75317 */   GIM_Try, /*On fail goto*//*Label 1208*/ GIMT_Encode4(75435), // Rule ID 15758 //
     /*  75322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75361 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75369 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75373 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75381 */     // MIs[4] Op3
     /*  75381 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  75386 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75390 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75394 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75398 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75402 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75406 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75412 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75414 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75416 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  75425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  75429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  75433 */     GIR_RootConstrainSelectedInstOperands,
     /*  75434 */     // GIR_Coverage, 15758,
     /*  75434 */     GIR_EraseRootFromParent_Done,
     /*  75435 */   // Label 1208: @75435
     /*  75435 */   GIM_Try, /*On fail goto*//*Label 1209*/ GIMT_Encode4(75553), // Rule ID 15755 //
     /*  75440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75455 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  75463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75467 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75471 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  75479 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75485 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  75487 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  75491 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75495 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75499 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75503 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  75507 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75511 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75515 */     // MIs[5] Op3
     /*  75515 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75520 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75524 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75530 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75532 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75534 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  75537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  75543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  75547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75551 */     GIR_RootConstrainSelectedInstOperands,
     /*  75552 */     // GIR_Coverage, 15755,
     /*  75552 */     GIR_EraseRootFromParent_Done,
     /*  75553 */   // Label 1209: @75553
     /*  75553 */   GIM_Try, /*On fail goto*//*Label 1210*/ GIMT_Encode4(75671), // Rule ID 15803 //
     /*  75558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75561 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75565 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75569 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75573 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75581 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75585 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75589 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75593 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75597 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75601 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75605 */     // MIs[3] Op3
     /*  75605 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75610 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75614 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75620 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75622 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75626 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75630 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75634 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75638 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75642 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75648 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75650 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75652 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75669 */     GIR_RootConstrainSelectedInstOperands,
     /*  75670 */     // GIR_Coverage, 15803,
     /*  75670 */     GIR_EraseRootFromParent_Done,
     /*  75671 */   // Label 1210: @75671
     /*  75671 */   GIM_Try, /*On fail goto*//*Label 1211*/ GIMT_Encode4(75789), // Rule ID 15805 //
     /*  75676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75703 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75707 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75711 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75715 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75719 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75723 */     // MIs[3] Op3
     /*  75723 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75728 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75732 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75738 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75740 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75744 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75748 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75752 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75756 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75760 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75766 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75768 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75770 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  75779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  75783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  75787 */     GIR_RootConstrainSelectedInstOperands,
     /*  75788 */     // GIR_Coverage, 15805,
     /*  75788 */     GIR_EraseRootFromParent_Done,
     /*  75789 */   // Label 1211: @75789
     /*  75789 */   GIM_Try, /*On fail goto*//*Label 1212*/ GIMT_Encode4(75907), // Rule ID 11963 //
     /*  75794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75821 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75825 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75833 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75837 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75841 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75845 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75849 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75855 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75857 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75861 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75865 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75869 */     // MIs[5] Op3
     /*  75869 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  75874 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75878 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75884 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  75886 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  75888 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  75888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  75891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  75893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  75897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  75901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  75905 */     GIR_RootConstrainSelectedInstOperands,
     /*  75906 */     // GIR_Coverage, 11963,
     /*  75906 */     GIR_EraseRootFromParent_Done,
     /*  75907 */   // Label 1212: @75907
     /*  75907 */   GIM_Try, /*On fail goto*//*Label 1213*/ GIMT_Encode4(76025), // Rule ID 15804 //
     /*  75912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  75915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  75919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  75935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  75939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75943 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75947 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  75951 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75955 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  75959 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75963 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  75967 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  75973 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  75975 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  75979 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  75983 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  75987 */     // MIs[5] Op3
     /*  75987 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  75992 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  75996 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76002 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  76004 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  76006 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }), (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  76019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76023 */     GIR_RootConstrainSelectedInstOperands,
     /*  76024 */     // GIR_Coverage, 15804,
     /*  76024 */     GIR_EraseRootFromParent_Done,
     /*  76025 */   // Label 1213: @76025
     /*  76025 */   GIM_Try, /*On fail goto*//*Label 1214*/ GIMT_Encode4(76115), // Rule ID 15732 //
     /*  76030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76049 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76053 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76057 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76061 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76065 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76069 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76075 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76077 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76081 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76085 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76089 */     // MIs[4] Op3
     /*  76089 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76094 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76096 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76113 */     GIR_RootConstrainSelectedInstOperands,
     /*  76114 */     // GIR_Coverage, 15732,
     /*  76114 */     GIR_EraseRootFromParent_Done,
     /*  76115 */   // Label 1214: @76115
     /*  76115 */   GIM_Try, /*On fail goto*//*Label 1215*/ GIMT_Encode4(76205), // Rule ID 15731 //
     /*  76120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76131 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76135 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  76143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76155 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76159 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76167 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76171 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76175 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76179 */     // MIs[4] Op3
     /*  76179 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76184 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76186 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  76199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76203 */     GIR_RootConstrainSelectedInstOperands,
     /*  76204 */     // GIR_Coverage, 15731,
     /*  76204 */     GIR_EraseRootFromParent_Done,
     /*  76205 */   // Label 1215: @76205
     /*  76205 */   GIM_Try, /*On fail goto*//*Label 1216*/ GIMT_Encode4(76295), // Rule ID 15730 //
     /*  76210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76221 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76225 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76229 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76233 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76237 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76241 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76245 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76249 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76255 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76257 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76261 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76265 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76269 */     // MIs[4] Op3
     /*  76269 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76274 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76276 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  76285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76293 */     GIR_RootConstrainSelectedInstOperands,
     /*  76294 */     // GIR_Coverage, 15730,
     /*  76294 */     GIR_EraseRootFromParent_Done,
     /*  76295 */   // Label 1216: @76295
     /*  76295 */   GIM_Try, /*On fail goto*//*Label 1217*/ GIMT_Encode4(76385), // Rule ID 15729 //
     /*  76300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76307 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76311 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76315 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  76323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76331 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76339 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76345 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  76347 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  76351 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76355 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76359 */     // MIs[4] Op3
     /*  76359 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  76364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76366 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  76375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  76379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  76383 */     GIR_RootConstrainSelectedInstOperands,
     /*  76384 */     // GIR_Coverage, 15729,
     /*  76384 */     GIR_EraseRootFromParent_Done,
     /*  76385 */   // Label 1217: @76385
     /*  76385 */   GIM_Try, /*On fail goto*//*Label 1218*/ GIMT_Encode4(76475), // Rule ID 15726 //
     /*  76390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76397 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76401 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76409 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76413 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76417 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76421 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76433 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76437 */     // MIs[3] Op3
     /*  76437 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76442 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76446 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76452 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76454 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76456 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76469 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76473 */     GIR_RootConstrainSelectedInstOperands,
     /*  76474 */     // GIR_Coverage, 15726,
     /*  76474 */     GIR_EraseRootFromParent_Done,
     /*  76475 */   // Label 1218: @76475
     /*  76475 */   GIM_Try, /*On fail goto*//*Label 1219*/ GIMT_Encode4(76565), // Rule ID 15728 //
     /*  76480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76499 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76503 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76507 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76511 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76515 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76519 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76523 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76527 */     // MIs[3] Op3
     /*  76527 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76532 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76536 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76542 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76544 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76546 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  76559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76563 */     GIR_RootConstrainSelectedInstOperands,
     /*  76564 */     // GIR_Coverage, 15728,
     /*  76564 */     GIR_EraseRootFromParent_Done,
     /*  76565 */   // Label 1219: @76565
     /*  76565 */   GIM_Try, /*On fail goto*//*Label 1220*/ GIMT_Encode4(76655), // Rule ID 11944 //
     /*  76570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76581 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76585 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76589 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76593 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76597 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76601 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76605 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76609 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76613 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76617 */     // MIs[3] Op3
     /*  76617 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76622 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76626 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76632 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76634 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76636 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76649 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76653 */     GIR_RootConstrainSelectedInstOperands,
     /*  76654 */     // GIR_Coverage, 11944,
     /*  76654 */     GIR_EraseRootFromParent_Done,
     /*  76655 */   // Label 1220: @76655
     /*  76655 */   GIM_Try, /*On fail goto*//*Label 1221*/ GIMT_Encode4(76745), // Rule ID 15727 //
     /*  76660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76671 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76675 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76679 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76683 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76687 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76691 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  76699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76703 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76707 */     // MIs[3] Op3
     /*  76707 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76712 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  76716 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76722 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76724 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76726 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  76729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  76739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76743 */     GIR_RootConstrainSelectedInstOperands,
     /*  76744 */     // GIR_Coverage, 15727,
     /*  76744 */     GIR_EraseRootFromParent_Done,
     /*  76745 */   // Label 1221: @76745
     /*  76745 */   GIM_Try, /*On fail goto*//*Label 1222*/ GIMT_Encode4(76835), // Rule ID 15810 //
     /*  76750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76793 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76797 */     // MIs[3] Op3
     /*  76797 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76802 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76806 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76812 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76814 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76816 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  76825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  76833 */     GIR_RootConstrainSelectedInstOperands,
     /*  76834 */     // GIR_Coverage, 15810,
     /*  76834 */     GIR_EraseRootFromParent_Done,
     /*  76835 */   // Label 1222: @76835
     /*  76835 */   GIM_Try, /*On fail goto*//*Label 1223*/ GIMT_Encode4(76925), // Rule ID 15812 //
     /*  76840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76859 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76863 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76867 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76871 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76875 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76879 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76883 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76887 */     // MIs[3] Op3
     /*  76887 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  76892 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76896 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76902 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76904 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76906 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  76911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  76915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  76919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  76923 */     GIR_RootConstrainSelectedInstOperands,
     /*  76924 */     // GIR_Coverage, 15812,
     /*  76924 */     GIR_EraseRootFromParent_Done,
     /*  76925 */   // Label 1223: @76925
     /*  76925 */   GIM_Try, /*On fail goto*//*Label 1224*/ GIMT_Encode4(77015), // Rule ID 11964 //
     /*  76930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  76933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  76937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  76941 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76945 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  76953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  76957 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76961 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  76965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  76969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  76973 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  76977 */     // MIs[3] Op3
     /*  76977 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  76982 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  76986 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  76992 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  76994 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  76996 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  76996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  76999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  77005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  77013 */     GIR_RootConstrainSelectedInstOperands,
     /*  77014 */     // GIR_Coverage, 11964,
     /*  77014 */     GIR_EraseRootFromParent_Done,
     /*  77015 */   // Label 1224: @77015
     /*  77015 */   GIM_Try, /*On fail goto*//*Label 1225*/ GIMT_Encode4(77105), // Rule ID 15811 //
     /*  77020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77035 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77039 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  77043 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77047 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77051 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  77059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77063 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77067 */     // MIs[3] Op3
     /*  77067 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  77072 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  77076 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77082 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  77084 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77086 */     // (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  77095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  77099 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  77103 */     GIR_RootConstrainSelectedInstOperands,
     /*  77104 */     // GIR_Coverage, 15811,
     /*  77104 */     GIR_EraseRootFromParent_Done,
     /*  77105 */   // Label 1225: @77105
     /*  77105 */   GIM_Try, /*On fail goto*//*Label 1226*/ GIMT_Encode4(77195), // Rule ID 15814 //
     /*  77110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77113 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77117 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77121 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77125 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77137 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77141 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77145 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77149 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77157 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77161 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77165 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77169 */     // MIs[4] Op3
     /*  77169 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77174 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77176 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77193 */     GIR_RootConstrainSelectedInstOperands,
     /*  77194 */     // GIR_Coverage, 15814,
     /*  77194 */     GIR_EraseRootFromParent_Done,
     /*  77195 */   // Label 1226: @77195
     /*  77195 */   GIM_Try, /*On fail goto*//*Label 1227*/ GIMT_Encode4(77285), // Rule ID 15816 //
     /*  77200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77235 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77239 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77245 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77247 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77251 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77255 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77259 */     // MIs[4] Op3
     /*  77259 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77264 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77266 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  77275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77279 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77283 */     GIR_RootConstrainSelectedInstOperands,
     /*  77284 */     // GIR_Coverage, 15816,
     /*  77284 */     GIR_EraseRootFromParent_Done,
     /*  77285 */   // Label 1227: @77285
     /*  77285 */   GIM_Try, /*On fail goto*//*Label 1228*/ GIMT_Encode4(77375), // Rule ID 15813 //
     /*  77290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77325 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77329 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77335 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77337 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77341 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77345 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77349 */     // MIs[4] Op3
     /*  77349 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  77354 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77356 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  77373 */     GIR_RootConstrainSelectedInstOperands,
     /*  77374 */     // GIR_Coverage, 15813,
     /*  77374 */     GIR_EraseRootFromParent_Done,
     /*  77375 */   // Label 1228: @77375
     /*  77375 */   GIM_Try, /*On fail goto*//*Label 1229*/ GIMT_Encode4(77465), // Rule ID 15815 //
     /*  77380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  77407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  77415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  77419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  77431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  77439 */     // MIs[4] Op3
     /*  77439 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77444 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  77446 */     // (or:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] }), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  77446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  77455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  77459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77463 */     GIR_RootConstrainSelectedInstOperands,
     /*  77464 */     // GIR_Coverage, 15815,
     /*  77464 */     GIR_EraseRootFromParent_Done,
     /*  77465 */   // Label 1229: @77465
     /*  77465 */   GIM_Try, /*On fail goto*//*Label 1230*/ GIMT_Encode4(77480), // Rule ID 7509 //
     /*  77470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77473 */     // (or:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  77473 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  77478 */     GIR_RootConstrainSelectedInstOperands,
     /*  77479 */     // GIR_Coverage, 7509,
     /*  77479 */     GIR_Done,
     /*  77480 */   // Label 1230: @77480
     /*  77480 */   GIM_Reject,
     /*  77481 */ // Label 1197: @77481
     /*  77481 */ GIM_Reject,
     /*  77482 */ // Label 1041: @77482
     /*  77482 */ GIM_Try, /*On fail goto*//*Label 1231*/ GIMT_Encode4(77513), // Rule ID 8502 //
     /*  77487 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  77490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  77493 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  77496 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  77500 */   // (or:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  77500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  77503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  77505 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77507 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  77509 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  77511 */   GIR_RootConstrainSelectedInstOperands,
     /*  77512 */   // GIR_Coverage, 8502,
     /*  77512 */   GIR_EraseRootFromParent_Done,
     /*  77513 */ // Label 1231: @77513
     /*  77513 */ GIM_Reject,
     /*  77514 */ // Label 1042: @77514
     /*  77514 */ GIM_Try, /*On fail goto*//*Label 1232*/ GIMT_Encode4(80873),
     /*  77519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  77529 */   GIM_Try, /*On fail goto*//*Label 1233*/ GIMT_Encode4(77647), // Rule ID 15793 //
     /*  77534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77573 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77579 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77581 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77585 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77589 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77593 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77597 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77601 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77607 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77609 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77613 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77617 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77621 */     // MIs[6] Op3
     /*  77621 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77626 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77628 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77645 */     GIR_RootConstrainSelectedInstOperands,
     /*  77646 */     // GIR_Coverage, 15793,
     /*  77646 */     GIR_EraseRootFromParent_Done,
     /*  77647 */   // Label 1233: @77647
     /*  77647 */   GIM_Try, /*On fail goto*//*Label 1234*/ GIMT_Encode4(77765), // Rule ID 15795 //
     /*  77652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77667 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77671 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77675 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77679 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77683 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77687 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77691 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77697 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77699 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77703 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77707 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77711 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77715 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77719 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77725 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77727 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77731 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77735 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77739 */     // MIs[6] Op3
     /*  77739 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77744 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77746 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  77755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77763 */     GIR_RootConstrainSelectedInstOperands,
     /*  77764 */     // GIR_Coverage, 15795,
     /*  77764 */     GIR_EraseRootFromParent_Done,
     /*  77765 */   // Label 1234: @77765
     /*  77765 */   GIM_Try, /*On fail goto*//*Label 1235*/ GIMT_Encode4(77883), // Rule ID 15792 //
     /*  77770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77789 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77793 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77797 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77801 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77805 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77809 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77815 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77817 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77821 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77825 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77829 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77833 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77837 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77845 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77849 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77853 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77857 */     // MIs[6] Op3
     /*  77857 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  77862 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77864 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77869 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77873 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  77877 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  77881 */     GIR_RootConstrainSelectedInstOperands,
     /*  77882 */     // GIR_Coverage, 15792,
     /*  77882 */     GIR_EraseRootFromParent_Done,
     /*  77883 */   // Label 1235: @77883
     /*  77883 */   GIM_Try, /*On fail goto*//*Label 1236*/ GIMT_Encode4(78001), // Rule ID 15794 //
     /*  77888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  77891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  77895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  77911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77915 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77919 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77923 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  77927 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77933 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  77935 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  77939 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  77943 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77947 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  77951 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  77955 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  77961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  77963 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  77967 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  77971 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  77975 */     // MIs[6] Op3
     /*  77975 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  77980 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  77982 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  77982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  77985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  77987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  77991 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  77995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  77999 */     GIR_RootConstrainSelectedInstOperands,
     /*  78000 */     // GIR_Coverage, 15794,
     /*  78000 */     GIR_EraseRootFromParent_Done,
     /*  78001 */   // Label 1236: @78001
     /*  78001 */   GIM_Try, /*On fail goto*//*Label 1237*/ GIMT_Encode4(78119), // Rule ID 15747 //
     /*  78006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78021 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78025 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78029 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78033 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78037 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78041 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78045 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78051 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78053 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78057 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78061 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78065 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78069 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78073 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78077 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78081 */     // MIs[5] Op3
     /*  78081 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78086 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78090 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78096 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78098 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78100 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78105 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78117 */     GIR_RootConstrainSelectedInstOperands,
     /*  78118 */     // GIR_Coverage, 15747,
     /*  78118 */     GIR_EraseRootFromParent_Done,
     /*  78119 */   // Label 1237: @78119
     /*  78119 */   GIM_Try, /*On fail goto*//*Label 1238*/ GIMT_Encode4(78237), // Rule ID 15752 //
     /*  78124 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78163 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78169 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78171 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78175 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78179 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78183 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78187 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78191 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78195 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78199 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78203 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78211 */     // MIs[4] Op3
     /*  78211 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78216 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78218 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78235 */     GIR_RootConstrainSelectedInstOperands,
     /*  78236 */     // GIR_Coverage, 15752,
     /*  78236 */     GIR_EraseRootFromParent_Done,
     /*  78237 */   // Label 1238: @78237
     /*  78237 */   GIM_Try, /*On fail goto*//*Label 1239*/ GIMT_Encode4(78355), // Rule ID 15753 //
     /*  78242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78253 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78257 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78277 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78281 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78287 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78289 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78293 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78297 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78301 */     // MIs[4] Op3
     /*  78301 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78306 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78310 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78314 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78318 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78322 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78326 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78334 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78336 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78345 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  78349 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78353 */     GIR_RootConstrainSelectedInstOperands,
     /*  78354 */     // GIR_Coverage, 15753,
     /*  78354 */     GIR_EraseRootFromParent_Done,
     /*  78355 */   // Label 1239: @78355
     /*  78355 */   GIM_Try, /*On fail goto*//*Label 1240*/ GIMT_Encode4(78473), // Rule ID 11950 //
     /*  78360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  78383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78399 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78405 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78407 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78411 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78415 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78419 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78423 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78427 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78431 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78435 */     // MIs[5] Op3
     /*  78435 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  78440 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78444 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78452 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78454 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78459 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78463 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  78471 */     GIR_RootConstrainSelectedInstOperands,
     /*  78472 */     // GIR_Coverage, 11950,
     /*  78472 */     GIR_EraseRootFromParent_Done,
     /*  78473 */   // Label 1240: @78473
     /*  78473 */   GIM_Try, /*On fail goto*//*Label 1241*/ GIMT_Encode4(78591), // Rule ID 15749 //
     /*  78478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78493 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78497 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78501 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78505 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78509 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78513 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78517 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78523 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78525 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78529 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78533 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78537 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78541 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78545 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78549 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78553 */     // MIs[5] Op3
     /*  78553 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78558 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78562 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78570 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78572 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  78585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78589 */     GIR_RootConstrainSelectedInstOperands,
     /*  78590 */     // GIR_Coverage, 15749,
     /*  78590 */     GIR_EraseRootFromParent_Done,
     /*  78591 */   // Label 1241: @78591
     /*  78591 */   GIM_Try, /*On fail goto*//*Label 1242*/ GIMT_Encode4(78709), // Rule ID 15750 //
     /*  78596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78607 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78611 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78623 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78627 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78631 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78635 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78641 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78643 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78647 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78651 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78655 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  78659 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78663 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78667 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78671 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78675 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78681 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78683 */     // MIs[4] Op3
     /*  78683 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78688 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78690 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78707 */     GIR_RootConstrainSelectedInstOperands,
     /*  78708 */     // GIR_Coverage, 15750,
     /*  78708 */     GIR_EraseRootFromParent_Done,
     /*  78709 */   // Label 1242: @78709
     /*  78709 */   GIM_Try, /*On fail goto*//*Label 1243*/ GIMT_Encode4(78827), // Rule ID 15751 //
     /*  78714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78753 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78759 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78761 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78765 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78769 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78773 */     // MIs[4] Op3
     /*  78773 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  78778 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78782 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78786 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78790 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78794 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78798 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78804 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78806 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78808 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  78817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  78821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  78825 */     GIR_RootConstrainSelectedInstOperands,
     /*  78826 */     // GIR_Coverage, 15751,
     /*  78826 */     GIR_EraseRootFromParent_Done,
     /*  78827 */   // Label 1243: @78827
     /*  78827 */   GIM_Try, /*On fail goto*//*Label 1244*/ GIMT_Encode4(78945), // Rule ID 15748 //
     /*  78832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  78855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78859 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78863 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78867 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  78871 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78877 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  78879 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  78883 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78887 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78891 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78895 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  78899 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78903 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78907 */     // MIs[5] Op3
     /*  78907 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  78912 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  78916 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  78922 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  78924 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  78926 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  78926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  78929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  78931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  78935 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  78939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  78943 */     GIR_RootConstrainSelectedInstOperands,
     /*  78944 */     // GIR_Coverage, 15748,
     /*  78944 */     GIR_EraseRootFromParent_Done,
     /*  78945 */   // Label 1244: @78945
     /*  78945 */   GIM_Try, /*On fail goto*//*Label 1245*/ GIMT_Encode4(79063), // Rule ID 15789 //
     /*  78950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  78953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  78957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78965 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78969 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  78973 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  78977 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  78981 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  78989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  78993 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  78997 */     // MIs[3] Op3
     /*  78997 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79002 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79006 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79012 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79014 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79018 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79022 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79026 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79030 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79034 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79040 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79042 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79044 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79061 */     GIR_RootConstrainSelectedInstOperands,
     /*  79062 */     // GIR_Coverage, 15789,
     /*  79062 */     GIR_EraseRootFromParent_Done,
     /*  79063 */   // Label 1245: @79063
     /*  79063 */   GIM_Try, /*On fail goto*//*Label 1246*/ GIMT_Encode4(79181), // Rule ID 15791 //
     /*  79068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79083 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79095 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79099 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79103 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79107 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79111 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79115 */     // MIs[3] Op3
     /*  79115 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79120 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79124 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79130 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79132 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79136 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79140 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79144 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79148 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79152 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79158 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79160 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79162 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  79175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79179 */     GIR_RootConstrainSelectedInstOperands,
     /*  79180 */     // GIR_Coverage, 15791,
     /*  79180 */     GIR_EraseRootFromParent_Done,
     /*  79181 */   // Label 1246: @79181
     /*  79181 */   GIM_Try, /*On fail goto*//*Label 1247*/ GIMT_Encode4(79299), // Rule ID 11960 //
     /*  79186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79201 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79205 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79209 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79213 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79217 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79221 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79225 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79229 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79233 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79237 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79241 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79247 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79249 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79253 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79257 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79261 */     // MIs[5] Op3
     /*  79261 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79266 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79270 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79276 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79278 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79280 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79289 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79297 */     GIR_RootConstrainSelectedInstOperands,
     /*  79298 */     // GIR_Coverage, 11960,
     /*  79298 */     GIR_EraseRootFromParent_Done,
     /*  79299 */   // Label 1247: @79299
     /*  79299 */   GIM_Try, /*On fail goto*//*Label 1248*/ GIMT_Encode4(79417), // Rule ID 15790 //
     /*  79304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79307 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79311 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79315 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79319 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79331 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79335 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79339 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79343 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79347 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79351 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79355 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79359 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79365 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79367 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  79371 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79375 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79379 */     // MIs[5] Op3
     /*  79379 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79384 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  79388 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79394 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  79396 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  79398 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }), (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  79401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79403 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  79411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79415 */     GIR_RootConstrainSelectedInstOperands,
     /*  79416 */     // GIR_Coverage, 15790,
     /*  79416 */     GIR_EraseRootFromParent_Done,
     /*  79417 */   // Label 1248: @79417
     /*  79417 */   GIM_Try, /*On fail goto*//*Label 1249*/ GIMT_Encode4(79507), // Rule ID 15725 //
     /*  79422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79433 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79437 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79449 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79453 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79457 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79461 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79467 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79469 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79473 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79477 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79481 */     // MIs[4] Op3
     /*  79481 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79486 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79488 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79493 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79505 */     GIR_RootConstrainSelectedInstOperands,
     /*  79506 */     // GIR_Coverage, 15725,
     /*  79506 */     GIR_EraseRootFromParent_Done,
     /*  79507 */   // Label 1249: @79507
     /*  79507 */   GIM_Try, /*On fail goto*//*Label 1250*/ GIMT_Encode4(79597), // Rule ID 15724 //
     /*  79512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79515 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79519 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79523 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79527 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79531 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  79535 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79539 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79543 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79547 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79551 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79557 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79559 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79563 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79567 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79571 */     // MIs[4] Op3
     /*  79571 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79576 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79578 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79587 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  79591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79595 */     GIR_RootConstrainSelectedInstOperands,
     /*  79596 */     // GIR_Coverage, 15724,
     /*  79596 */     GIR_EraseRootFromParent_Done,
     /*  79597 */   // Label 1250: @79597
     /*  79597 */   GIM_Try, /*On fail goto*//*Label 1251*/ GIMT_Encode4(79687), // Rule ID 15723 //
     /*  79602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79617 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79621 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79625 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79629 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79633 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79637 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79641 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79647 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79649 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79653 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79657 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79661 */     // MIs[4] Op3
     /*  79661 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79666 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79668 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  79677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79685 */     GIR_RootConstrainSelectedInstOperands,
     /*  79686 */     // GIR_Coverage, 15723,
     /*  79686 */     GIR_EraseRootFromParent_Done,
     /*  79687 */   // Label 1251: @79687
     /*  79687 */   GIM_Try, /*On fail goto*//*Label 1252*/ GIMT_Encode4(79777), // Rule ID 15722 //
     /*  79692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  79715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79723 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79727 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  79731 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79737 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  79739 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  79743 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79747 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79751 */     // MIs[4] Op3
     /*  79751 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  79756 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79758 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  79767 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  79771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  79775 */     GIR_RootConstrainSelectedInstOperands,
     /*  79776 */     // GIR_Coverage, 15722,
     /*  79776 */     GIR_EraseRootFromParent_Done,
     /*  79777 */   // Label 1252: @79777
     /*  79777 */   GIM_Try, /*On fail goto*//*Label 1253*/ GIMT_Encode4(79867), // Rule ID 15719 //
     /*  79782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79825 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79829 */     // MIs[3] Op3
     /*  79829 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  79834 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79838 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79844 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79846 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79848 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  79857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79861 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  79865 */     GIR_RootConstrainSelectedInstOperands,
     /*  79866 */     // GIR_Coverage, 15719,
     /*  79866 */     GIR_EraseRootFromParent_Done,
     /*  79867 */   // Label 1253: @79867
     /*  79867 */   GIM_Try, /*On fail goto*//*Label 1254*/ GIMT_Encode4(79957), // Rule ID 15721 //
     /*  79872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79903 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  79911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  79915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79919 */     // MIs[3] Op3
     /*  79919 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  79924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  79928 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  79934 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  79936 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  79938 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  79938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  79941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  79943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  79947 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  79951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  79955 */     GIR_RootConstrainSelectedInstOperands,
     /*  79956 */     // GIR_Coverage, 15721,
     /*  79956 */     GIR_EraseRootFromParent_Done,
     /*  79957 */   // Label 1254: @79957
     /*  79957 */   GIM_Try, /*On fail goto*//*Label 1255*/ GIMT_Encode4(80047), // Rule ID 11942 //
     /*  79962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  79965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  79969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79977 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  79985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  79989 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  79993 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  79997 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80001 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80005 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80009 */     // MIs[3] Op3
     /*  80009 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80014 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80018 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80024 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80026 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80028 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80037 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80041 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80045 */     GIR_RootConstrainSelectedInstOperands,
     /*  80046 */     // GIR_Coverage, 11942,
     /*  80046 */     GIR_EraseRootFromParent_Done,
     /*  80047 */   // Label 1255: @80047
     /*  80047 */   GIM_Try, /*On fail goto*//*Label 1256*/ GIMT_Encode4(80137), // Rule ID 15720 //
     /*  80052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80071 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80075 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80079 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80083 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80087 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80091 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80095 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80099 */     // MIs[3] Op3
     /*  80099 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80104 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  80108 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80114 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80116 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80118 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  80121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80123 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80127 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80131 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80135 */     GIR_RootConstrainSelectedInstOperands,
     /*  80136 */     // GIR_Coverage, 15720,
     /*  80136 */     GIR_EraseRootFromParent_Done,
     /*  80137 */   // Label 1256: @80137
     /*  80137 */   GIM_Try, /*On fail goto*//*Label 1257*/ GIMT_Encode4(80227), // Rule ID 15796 //
     /*  80142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80185 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80189 */     // MIs[3] Op3
     /*  80189 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80194 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80198 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80204 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80206 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80208 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80225 */     GIR_RootConstrainSelectedInstOperands,
     /*  80226 */     // GIR_Coverage, 15796,
     /*  80226 */     GIR_EraseRootFromParent_Done,
     /*  80227 */   // Label 1257: @80227
     /*  80227 */   GIM_Try, /*On fail goto*//*Label 1258*/ GIMT_Encode4(80317), // Rule ID 15798 //
     /*  80232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80235 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80239 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80243 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80247 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80251 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80255 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80259 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80263 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80275 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80279 */     // MIs[3] Op3
     /*  80279 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80284 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80288 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80294 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80296 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80298 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80303 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80307 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  80311 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80315 */     GIR_RootConstrainSelectedInstOperands,
     /*  80316 */     // GIR_Coverage, 15798,
     /*  80316 */     GIR_EraseRootFromParent_Done,
     /*  80317 */   // Label 1258: @80317
     /*  80317 */   GIM_Try, /*On fail goto*//*Label 1259*/ GIMT_Encode4(80407), // Rule ID 11961 //
     /*  80322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80349 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80353 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80357 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80361 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80365 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80369 */     // MIs[3] Op3
     /*  80369 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  80374 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80378 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80384 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80386 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80388 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  80397 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  80405 */     GIR_RootConstrainSelectedInstOperands,
     /*  80406 */     // GIR_Coverage, 11961,
     /*  80406 */     GIR_EraseRootFromParent_Done,
     /*  80407 */   // Label 1259: @80407
     /*  80407 */   GIM_Try, /*On fail goto*//*Label 1260*/ GIMT_Encode4(80497), // Rule ID 15797 //
     /*  80412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80431 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  80435 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80439 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80443 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80447 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  80451 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80455 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80459 */     // MIs[3] Op3
     /*  80459 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  80464 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  80468 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80474 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  80476 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80478 */     // (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  80487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  80491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  80495 */     GIR_RootConstrainSelectedInstOperands,
     /*  80496 */     // GIR_Coverage, 15797,
     /*  80496 */     GIR_EraseRootFromParent_Done,
     /*  80497 */   // Label 1260: @80497
     /*  80497 */   GIM_Try, /*On fail goto*//*Label 1261*/ GIMT_Encode4(80587), // Rule ID 15800 //
     /*  80502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80517 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80533 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80537 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80541 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80547 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80549 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80553 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80557 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80561 */     // MIs[4] Op3
     /*  80561 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80566 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80568 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80573 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80585 */     GIR_RootConstrainSelectedInstOperands,
     /*  80586 */     // GIR_Coverage, 15800,
     /*  80586 */     GIR_EraseRootFromParent_Done,
     /*  80587 */   // Label 1261: @80587
     /*  80587 */   GIM_Try, /*On fail goto*//*Label 1262*/ GIMT_Encode4(80677), // Rule ID 15802 //
     /*  80592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80611 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80615 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80619 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80623 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80627 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80631 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80637 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80639 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80643 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80647 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80651 */     // MIs[4] Op3
     /*  80651 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80656 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80658 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80663 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  80667 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80671 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80675 */     GIR_RootConstrainSelectedInstOperands,
     /*  80676 */     // GIR_Coverage, 15802,
     /*  80676 */     GIR_EraseRootFromParent_Done,
     /*  80677 */   // Label 1262: @80677
     /*  80677 */   GIM_Try, /*On fail goto*//*Label 1263*/ GIMT_Encode4(80767), // Rule ID 15799 //
     /*  80682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80701 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80705 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80709 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80713 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80721 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80727 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80729 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80733 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80737 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80741 */     // MIs[4] Op3
     /*  80741 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  80746 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80748 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  80761 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  80765 */     GIR_RootConstrainSelectedInstOperands,
     /*  80766 */     // GIR_Coverage, 15799,
     /*  80766 */     GIR_EraseRootFromParent_Done,
     /*  80767 */   // Label 1263: @80767
     /*  80767 */   GIM_Try, /*On fail goto*//*Label 1264*/ GIMT_Encode4(80857), // Rule ID 15801 //
     /*  80772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80787 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  80799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  80807 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  80811 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80817 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80819 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  80823 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80827 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  80831 */     // MIs[4] Op3
     /*  80831 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  80836 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  80838 */     // (or:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] }), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  80838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  80841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  80843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  80847 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  80851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  80855 */     GIR_RootConstrainSelectedInstOperands,
     /*  80856 */     // GIR_Coverage, 15801,
     /*  80856 */     GIR_EraseRootFromParent_Done,
     /*  80857 */   // Label 1264: @80857
     /*  80857 */   GIM_Try, /*On fail goto*//*Label 1265*/ GIMT_Encode4(80872), // Rule ID 7508 //
     /*  80862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80865 */     // (or:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  80865 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  80870 */     GIR_RootConstrainSelectedInstOperands,
     /*  80871 */     // GIR_Coverage, 7508,
     /*  80871 */     GIR_Done,
     /*  80872 */   // Label 1265: @80872
     /*  80872 */   GIM_Reject,
     /*  80873 */ // Label 1232: @80873
     /*  80873 */ GIM_Reject,
     /*  80874 */ // Label 1043: @80874
     /*  80874 */ GIM_Try, /*On fail goto*//*Label 1266*/ GIMT_Encode4(80905), // Rule ID 8501 //
     /*  80879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  80882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  80885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  80888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  80892 */   // (or:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  80892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  80895 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  80897 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80899 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  80901 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  80903 */   GIR_RootConstrainSelectedInstOperands,
     /*  80904 */   // GIR_Coverage, 8501,
     /*  80904 */   GIR_EraseRootFromParent_Done,
     /*  80905 */ // Label 1266: @80905
     /*  80905 */ GIM_Reject,
     /*  80906 */ // Label 1044: @80906
     /*  80906 */ GIM_Try, /*On fail goto*//*Label 1267*/ GIMT_Encode4(84265),
     /*  80911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80914 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  80921 */   GIM_Try, /*On fail goto*//*Label 1268*/ GIMT_Encode4(81039), // Rule ID 15779 //
     /*  80926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  80929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  80933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  80937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  80949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  80965 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80971 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  80973 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  80977 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  80981 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  80985 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  80989 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  80993 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  80999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81001 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81005 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81009 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81013 */     // MIs[6] Op3
     /*  81013 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81018 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81020 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81037 */     GIR_RootConstrainSelectedInstOperands,
     /*  81038 */     // GIR_Coverage, 15779,
     /*  81038 */     GIR_EraseRootFromParent_Done,
     /*  81039 */   // Label 1268: @81039
     /*  81039 */   GIM_Try, /*On fail goto*//*Label 1269*/ GIMT_Encode4(81157), // Rule ID 15781 //
     /*  81044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81047 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81051 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81055 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81059 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81079 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81083 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81089 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81091 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81095 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81099 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81103 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81107 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81111 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81117 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81119 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81123 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81127 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81131 */     // MIs[6] Op3
     /*  81131 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81136 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81138 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  81147 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81151 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81155 */     GIR_RootConstrainSelectedInstOperands,
     /*  81156 */     // GIR_Coverage, 15781,
     /*  81156 */     GIR_EraseRootFromParent_Done,
     /*  81157 */   // Label 1269: @81157
     /*  81157 */   GIM_Try, /*On fail goto*//*Label 1270*/ GIMT_Encode4(81275), // Rule ID 15778 //
     /*  81162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81165 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81169 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81173 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81177 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81181 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81185 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81189 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81193 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81201 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81207 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81209 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81213 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81217 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81221 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81225 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81229 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81235 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81237 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81241 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81245 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81249 */     // MIs[6] Op3
     /*  81249 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  81254 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81256 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81261 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81265 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  81269 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  81273 */     GIR_RootConstrainSelectedInstOperands,
     /*  81274 */     // GIR_Coverage, 15778,
     /*  81274 */     GIR_EraseRootFromParent_Done,
     /*  81275 */   // Label 1270: @81275
     /*  81275 */   GIM_Try, /*On fail goto*//*Label 1271*/ GIMT_Encode4(81393), // Rule ID 15780 //
     /*  81280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81287 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81291 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81307 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81311 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81315 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81319 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81325 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81327 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  81331 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81335 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81339 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81343 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81347 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81353 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  81355 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  81359 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81363 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81367 */     // MIs[6] Op3
     /*  81367 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81372 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81374 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  81377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  81383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81387 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81391 */     GIR_RootConstrainSelectedInstOperands,
     /*  81392 */     // GIR_Coverage, 15780,
     /*  81392 */     GIR_EraseRootFromParent_Done,
     /*  81393 */   // Label 1271: @81393
     /*  81393 */   GIM_Try, /*On fail goto*//*Label 1272*/ GIMT_Encode4(81511), // Rule ID 15740 //
     /*  81398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81413 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81425 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81429 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81433 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81437 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81443 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81445 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81449 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81453 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81457 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81461 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81465 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81469 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81473 */     // MIs[5] Op3
     /*  81473 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81478 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81482 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81488 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81490 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81492 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81501 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81505 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81509 */     GIR_RootConstrainSelectedInstOperands,
     /*  81510 */     // GIR_Coverage, 15740,
     /*  81510 */     GIR_EraseRootFromParent_Done,
     /*  81511 */   // Label 1272: @81511
     /*  81511 */   GIM_Try, /*On fail goto*//*Label 1273*/ GIMT_Encode4(81629), // Rule ID 15745 //
     /*  81516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81527 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81531 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81535 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81539 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81543 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81547 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81551 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81555 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81561 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81563 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81567 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81571 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81575 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81579 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81583 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81587 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81591 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81595 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81603 */     // MIs[4] Op3
     /*  81603 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81608 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81610 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81627 */     GIR_RootConstrainSelectedInstOperands,
     /*  81628 */     // GIR_Coverage, 15745,
     /*  81628 */     GIR_EraseRootFromParent_Done,
     /*  81629 */   // Label 1273: @81629
     /*  81629 */   GIM_Try, /*On fail goto*//*Label 1274*/ GIMT_Encode4(81747), // Rule ID 15746 //
     /*  81634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81649 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81661 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81665 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81673 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81679 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81681 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81685 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81689 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81693 */     // MIs[4] Op3
     /*  81693 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  81698 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81702 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81706 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81710 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81714 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81718 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81724 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81726 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81728 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  81737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  81741 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  81745 */     GIR_RootConstrainSelectedInstOperands,
     /*  81746 */     // GIR_Coverage, 15746,
     /*  81746 */     GIR_EraseRootFromParent_Done,
     /*  81747 */   // Label 1274: @81747
     /*  81747 */   GIM_Try, /*On fail goto*//*Label 1275*/ GIMT_Encode4(81865), // Rule ID 11948 //
     /*  81752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81763 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81767 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81771 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  81775 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81779 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81783 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81791 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81797 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81799 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81803 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81807 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81811 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81815 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  81819 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81823 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81827 */     // MIs[5] Op3
     /*  81827 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  81832 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81836 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81844 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81846 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81855 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  81859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  81863 */     GIR_RootConstrainSelectedInstOperands,
     /*  81864 */     // GIR_Coverage, 11948,
     /*  81864 */     GIR_EraseRootFromParent_Done,
     /*  81865 */   // Label 1275: @81865
     /*  81865 */   GIM_Try, /*On fail goto*//*Label 1276*/ GIMT_Encode4(81983), // Rule ID 15742 //
     /*  81870 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  81893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81897 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81901 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  81909 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81915 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  81917 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  81921 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81925 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  81929 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81933 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  81937 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  81941 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  81945 */     // MIs[5] Op3
     /*  81945 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  81950 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  81954 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  81960 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  81962 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  81964 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  81964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  81967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  81969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  81973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  81977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  81981 */     GIR_RootConstrainSelectedInstOperands,
     /*  81982 */     // GIR_Coverage, 15742,
     /*  81982 */     GIR_EraseRootFromParent_Done,
     /*  81983 */   // Label 1276: @81983
     /*  81983 */   GIM_Try, /*On fail goto*//*Label 1277*/ GIMT_Encode4(82101), // Rule ID 15743 //
     /*  81988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  81991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  81995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  81999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82003 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82007 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82011 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82015 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82019 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82023 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82027 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82033 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82035 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82039 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82043 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82047 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  82051 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82055 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82059 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82063 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82067 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82073 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82075 */     // MIs[4] Op3
     /*  82075 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82080 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82082 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82099 */     GIR_RootConstrainSelectedInstOperands,
     /*  82100 */     // GIR_Coverage, 15743,
     /*  82100 */     GIR_EraseRootFromParent_Done,
     /*  82101 */   // Label 1277: @82101
     /*  82101 */   GIM_Try, /*On fail goto*//*Label 1278*/ GIMT_Encode4(82219), // Rule ID 15744 //
     /*  82106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82145 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82151 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82153 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82157 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82161 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82165 */     // MIs[4] Op3
     /*  82165 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82170 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82174 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82178 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82182 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82186 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82190 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82196 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82198 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82200 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82205 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  82209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  82213 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82217 */     GIR_RootConstrainSelectedInstOperands,
     /*  82218 */     // GIR_Coverage, 15744,
     /*  82218 */     GIR_EraseRootFromParent_Done,
     /*  82219 */   // Label 1278: @82219
     /*  82219 */   GIM_Try, /*On fail goto*//*Label 1279*/ GIMT_Encode4(82337), // Rule ID 15741 //
     /*  82224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  82247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82259 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82263 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82269 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82271 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82275 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82279 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82283 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82287 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  82291 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82295 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82299 */     // MIs[5] Op3
     /*  82299 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82304 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82308 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82316 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82318 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  82321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  82327 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  82331 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82335 */     GIR_RootConstrainSelectedInstOperands,
     /*  82336 */     // GIR_Coverage, 15741,
     /*  82336 */     GIR_EraseRootFromParent_Done,
     /*  82337 */   // Label 1279: @82337
     /*  82337 */   GIM_Try, /*On fail goto*//*Label 1280*/ GIMT_Encode4(82455), // Rule ID 15775 //
     /*  82342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82345 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82349 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82353 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82357 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82369 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82373 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82385 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82389 */     // MIs[3] Op3
     /*  82389 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82394 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82398 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82404 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82406 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82410 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82414 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82418 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82422 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82426 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82432 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82434 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82436 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82441 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82453 */     GIR_RootConstrainSelectedInstOperands,
     /*  82454 */     // GIR_Coverage, 15775,
     /*  82454 */     GIR_EraseRootFromParent_Done,
     /*  82455 */   // Label 1280: @82455
     /*  82455 */   GIM_Try, /*On fail goto*//*Label 1281*/ GIMT_Encode4(82573), // Rule ID 15777 //
     /*  82460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82479 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82483 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82487 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82491 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82503 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82507 */     // MIs[3] Op3
     /*  82507 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82512 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82516 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82522 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82524 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82528 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82532 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82536 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82540 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82544 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82550 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82552 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82554 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82559 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  82567 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82571 */     GIR_RootConstrainSelectedInstOperands,
     /*  82572 */     // GIR_Coverage, 15777,
     /*  82572 */     GIR_EraseRootFromParent_Done,
     /*  82573 */   // Label 1281: @82573
     /*  82573 */   GIM_Try, /*On fail goto*//*Label 1282*/ GIMT_Encode4(82691), // Rule ID 11957 //
     /*  82578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82589 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82593 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82597 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82601 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82605 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82609 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82613 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82617 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82621 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82625 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82629 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82633 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82639 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82641 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82645 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82649 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82653 */     // MIs[5] Op3
     /*  82653 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  82658 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82662 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82668 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82670 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82672 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  82681 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  82689 */     GIR_RootConstrainSelectedInstOperands,
     /*  82690 */     // GIR_Coverage, 11957,
     /*  82690 */     GIR_EraseRootFromParent_Done,
     /*  82691 */   // Label 1282: @82691
     /*  82691 */   GIM_Try, /*On fail goto*//*Label 1283*/ GIMT_Encode4(82809), // Rule ID 15776 //
     /*  82696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82711 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82715 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  82719 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82723 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82727 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82731 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  82735 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82739 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82743 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82747 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  82751 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82757 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  82759 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  82763 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82767 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82771 */     // MIs[5] Op3
     /*  82771 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  82776 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  82780 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82786 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  82788 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  82790 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }), (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  82793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  82799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  82803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  82807 */     GIR_RootConstrainSelectedInstOperands,
     /*  82808 */     // GIR_Coverage, 15776,
     /*  82808 */     GIR_EraseRootFromParent_Done,
     /*  82809 */   // Label 1283: @82809
     /*  82809 */   GIM_Try, /*On fail goto*//*Label 1284*/ GIMT_Encode4(82899), // Rule ID 15718 //
     /*  82814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82825 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82829 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82849 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82853 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82859 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82861 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82865 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82869 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82873 */     // MIs[4] Op3
     /*  82873 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82878 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82880 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  82889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82897 */     GIR_RootConstrainSelectedInstOperands,
     /*  82898 */     // GIR_Coverage, 15718,
     /*  82898 */     GIR_EraseRootFromParent_Done,
     /*  82899 */   // Label 1284: @82899
     /*  82899 */   GIM_Try, /*On fail goto*//*Label 1285*/ GIMT_Encode4(82989), // Rule ID 15717 //
     /*  82904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  82911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82923 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  82927 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  82931 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82935 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  82939 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  82943 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  82949 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  82951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  82955 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  82959 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  82963 */     // MIs[4] Op3
     /*  82963 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  82968 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  82970 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  82970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  82973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  82975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  82979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  82983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  82987 */     GIR_RootConstrainSelectedInstOperands,
     /*  82988 */     // GIR_Coverage, 15717,
     /*  82988 */     GIR_EraseRootFromParent_Done,
     /*  82989 */   // Label 1285: @82989
     /*  82989 */   GIM_Try, /*On fail goto*//*Label 1286*/ GIMT_Encode4(83079), // Rule ID 15716 //
     /*  82994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  82997 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83001 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83005 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83009 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83029 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83033 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83039 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83041 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83045 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83049 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83053 */     // MIs[4] Op3
     /*  83053 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83058 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83060 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83077 */     GIR_RootConstrainSelectedInstOperands,
     /*  83078 */     // GIR_Coverage, 15716,
     /*  83078 */     GIR_EraseRootFromParent_Done,
     /*  83079 */   // Label 1286: @83079
     /*  83079 */   GIM_Try, /*On fail goto*//*Label 1287*/ GIMT_Encode4(83169), // Rule ID 15715 //
     /*  83084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83087 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83091 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83095 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83099 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  83107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83115 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83119 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83123 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83131 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83135 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83139 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83143 */     // MIs[4] Op3
     /*  83143 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  83148 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83150 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83155 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  83159 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  83163 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  83167 */     GIR_RootConstrainSelectedInstOperands,
     /*  83168 */     // GIR_Coverage, 15715,
     /*  83168 */     GIR_EraseRootFromParent_Done,
     /*  83169 */   // Label 1287: @83169
     /*  83169 */   GIM_Try, /*On fail goto*//*Label 1288*/ GIMT_Encode4(83259), // Rule ID 15712 //
     /*  83174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83177 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83181 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83185 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83189 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83197 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83201 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83205 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83209 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83213 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83217 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83221 */     // MIs[3] Op3
     /*  83221 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83226 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83230 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83236 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83238 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83240 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83253 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83257 */     GIR_RootConstrainSelectedInstOperands,
     /*  83258 */     // GIR_Coverage, 15712,
     /*  83258 */     GIR_EraseRootFromParent_Done,
     /*  83259 */   // Label 1288: @83259
     /*  83259 */   GIM_Try, /*On fail goto*//*Label 1289*/ GIMT_Encode4(83349), // Rule ID 15714 //
     /*  83264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83275 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83279 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83283 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83287 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83291 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83295 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83307 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83311 */     // MIs[3] Op3
     /*  83311 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83316 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83320 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83326 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83328 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83330 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  83343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83347 */     GIR_RootConstrainSelectedInstOperands,
     /*  83348 */     // GIR_Coverage, 15714,
     /*  83348 */     GIR_EraseRootFromParent_Done,
     /*  83349 */   // Label 1289: @83349
     /*  83349 */   GIM_Try, /*On fail goto*//*Label 1290*/ GIMT_Encode4(83439), // Rule ID 11940 //
     /*  83354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83361 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83365 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83369 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83373 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83377 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83381 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83385 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83389 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83393 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83397 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83401 */     // MIs[3] Op3
     /*  83401 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83406 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83410 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83416 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83418 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83420 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83433 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83437 */     GIR_RootConstrainSelectedInstOperands,
     /*  83438 */     // GIR_Coverage, 11940,
     /*  83438 */     GIR_EraseRootFromParent_Done,
     /*  83439 */   // Label 1290: @83439
     /*  83439 */   GIM_Try, /*On fail goto*//*Label 1291*/ GIMT_Encode4(83529), // Rule ID 15713 //
     /*  83444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83451 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83455 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83459 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83463 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83467 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83471 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83475 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83479 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  83483 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83487 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83491 */     // MIs[3] Op3
     /*  83491 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83496 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  83500 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83506 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83508 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83510 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  83513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83515 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83519 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83523 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83527 */     GIR_RootConstrainSelectedInstOperands,
     /*  83528 */     // GIR_Coverage, 15713,
     /*  83528 */     GIR_EraseRootFromParent_Done,
     /*  83529 */   // Label 1291: @83529
     /*  83529 */   GIM_Try, /*On fail goto*//*Label 1292*/ GIMT_Encode4(83619), // Rule ID 15782 //
     /*  83534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83541 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83545 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83549 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83553 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83557 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83561 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83565 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83569 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83573 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83577 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83581 */     // MIs[3] Op3
     /*  83581 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83586 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83590 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83598 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83600 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83609 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83617 */     GIR_RootConstrainSelectedInstOperands,
     /*  83618 */     // GIR_Coverage, 15782,
     /*  83618 */     GIR_EraseRootFromParent_Done,
     /*  83619 */   // Label 1292: @83619
     /*  83619 */   GIM_Try, /*On fail goto*//*Label 1293*/ GIMT_Encode4(83709), // Rule ID 15784 //
     /*  83624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83643 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83647 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83651 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83655 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83667 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83671 */     // MIs[3] Op3
     /*  83671 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83676 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83680 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83688 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83690 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83695 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  83703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83707 */     GIR_RootConstrainSelectedInstOperands,
     /*  83708 */     // GIR_Coverage, 15784,
     /*  83708 */     GIR_EraseRootFromParent_Done,
     /*  83709 */   // Label 1293: @83709
     /*  83709 */   GIM_Try, /*On fail goto*//*Label 1294*/ GIMT_Encode4(83799), // Rule ID 11958 //
     /*  83714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83729 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83733 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83737 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83741 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83745 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83761 */     // MIs[3] Op3
     /*  83761 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  83766 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83770 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83776 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83778 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83780 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83785 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  83789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  83797 */     GIR_RootConstrainSelectedInstOperands,
     /*  83798 */     // GIR_Coverage, 11958,
     /*  83798 */     GIR_EraseRootFromParent_Done,
     /*  83799 */   // Label 1294: @83799
     /*  83799 */   GIM_Try, /*On fail goto*//*Label 1295*/ GIMT_Encode4(83889), // Rule ID 15783 //
     /*  83804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  83827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83831 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83835 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83839 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  83843 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83847 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83851 */     // MIs[3] Op3
     /*  83851 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  83856 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  83860 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83866 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  83868 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83870 */     // (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  83879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  83883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  83887 */     GIR_RootConstrainSelectedInstOperands,
     /*  83888 */     // GIR_Coverage, 15783,
     /*  83888 */     GIR_EraseRootFromParent_Done,
     /*  83889 */   // Label 1295: @83889
     /*  83889 */   GIM_Try, /*On fail goto*//*Label 1296*/ GIMT_Encode4(83979), // Rule ID 15786 //
     /*  83894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83905 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83909 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83913 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  83917 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  83921 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83925 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83929 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  83933 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  83939 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  83941 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  83945 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  83949 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  83953 */     // MIs[4] Op3
     /*  83953 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  83958 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  83960 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  83960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  83963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  83965 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  83969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  83973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  83977 */     GIR_RootConstrainSelectedInstOperands,
     /*  83978 */     // GIR_Coverage, 15786,
     /*  83978 */     GIR_EraseRootFromParent_Done,
     /*  83979 */   // Label 1296: @83979
     /*  83979 */   GIM_Try, /*On fail goto*//*Label 1297*/ GIMT_Encode4(84069), // Rule ID 15788 //
     /*  83984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  83987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  83991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  83995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  83999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84011 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84015 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84019 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84023 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84029 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84031 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84035 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84039 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84043 */     // MIs[4] Op3
     /*  84043 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84048 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84050 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84055 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  84059 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84063 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84067 */     GIR_RootConstrainSelectedInstOperands,
     /*  84068 */     // GIR_Coverage, 15788,
     /*  84068 */     GIR_EraseRootFromParent_Done,
     /*  84069 */   // Label 1297: @84069
     /*  84069 */   GIM_Try, /*On fail goto*//*Label 1298*/ GIMT_Encode4(84159), // Rule ID 15785 //
     /*  84074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84089 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84093 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84097 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84101 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84105 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84113 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84119 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84121 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84125 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84129 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84133 */     // MIs[4] Op3
     /*  84133 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  84138 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84140 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84145 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84153 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  84157 */     GIR_RootConstrainSelectedInstOperands,
     /*  84158 */     // GIR_Coverage, 15785,
     /*  84158 */     GIR_EraseRootFromParent_Done,
     /*  84159 */   // Label 1298: @84159
     /*  84159 */   GIM_Try, /*On fail goto*//*Label 1299*/ GIMT_Encode4(84249), // Rule ID 15787 //
     /*  84164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  84191 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84195 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  84199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  84203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84209 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84215 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84219 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  84223 */     // MIs[4] Op3
     /*  84223 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84228 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  84230 */     // (or:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] }), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  84230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  84239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  84243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84247 */     GIR_RootConstrainSelectedInstOperands,
     /*  84248 */     // GIR_Coverage, 15787,
     /*  84248 */     GIR_EraseRootFromParent_Done,
     /*  84249 */   // Label 1299: @84249
     /*  84249 */   GIM_Try, /*On fail goto*//*Label 1300*/ GIMT_Encode4(84264), // Rule ID 7507 //
     /*  84254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84257 */     // (or:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  84257 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  84262 */     GIR_RootConstrainSelectedInstOperands,
     /*  84263 */     // GIR_Coverage, 7507,
     /*  84263 */     GIR_Done,
     /*  84264 */   // Label 1300: @84264
     /*  84264 */   GIM_Reject,
     /*  84265 */ // Label 1267: @84265
     /*  84265 */ GIM_Reject,
     /*  84266 */ // Label 1045: @84266
     /*  84266 */ GIM_Try, /*On fail goto*//*Label 1301*/ GIMT_Encode4(84297), // Rule ID 8500 //
     /*  84271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  84274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  84277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  84280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  84284 */   // (or:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  84284 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /*  84287 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  84289 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84291 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  84293 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  84295 */   GIR_RootConstrainSelectedInstOperands,
     /*  84296 */   // GIR_Coverage, 8500,
     /*  84296 */   GIR_EraseRootFromParent_Done,
     /*  84297 */ // Label 1301: @84297
     /*  84297 */ GIM_Reject,
     /*  84298 */ // Label 1046: @84298
     /*  84298 */ GIM_Try, /*On fail goto*//*Label 1302*/ GIMT_Encode4(87657),
     /*  84303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84306 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  84313 */   GIM_Try, /*On fail goto*//*Label 1303*/ GIMT_Encode4(84431), // Rule ID 15765 //
     /*  84318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84345 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84349 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84357 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84363 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84365 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84369 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84373 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84377 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84381 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84385 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84391 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84393 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84397 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84401 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84405 */     // MIs[6] Op3
     /*  84405 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84410 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84412 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84417 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84421 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84425 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84429 */     GIR_RootConstrainSelectedInstOperands,
     /*  84430 */     // GIR_Coverage, 15765,
     /*  84430 */     GIR_EraseRootFromParent_Done,
     /*  84431 */   // Label 1303: @84431
     /*  84431 */   GIM_Try, /*On fail goto*//*Label 1304*/ GIMT_Encode4(84549), // Rule ID 15767 //
     /*  84436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84455 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84459 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84463 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84467 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84471 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84475 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84481 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84483 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84487 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84491 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84495 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84499 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84503 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84509 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84511 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84515 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84519 */     GIM_CheckType, /*MI*/6, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84523 */     // MIs[6] Op3
     /*  84523 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84528 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84530 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/2, // Op1
     /*  84539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84547 */     GIR_RootConstrainSelectedInstOperands,
     /*  84548 */     // GIR_Coverage, 15767,
     /*  84548 */     GIR_EraseRootFromParent_Done,
     /*  84549 */   // Label 1304: @84549
     /*  84549 */   GIM_Try, /*On fail goto*//*Label 1305*/ GIMT_Encode4(84667), // Rule ID 15764 //
     /*  84554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84569 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84585 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84601 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84605 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84609 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84613 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84617 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84621 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84627 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84629 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84633 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84637 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84641 */     // MIs[6] Op3
     /*  84641 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /*  84646 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84648 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84657 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  84661 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op3
     /*  84665 */     GIR_RootConstrainSelectedInstOperands,
     /*  84666 */     // GIR_Coverage, 15764,
     /*  84666 */     GIR_EraseRootFromParent_Done,
     /*  84667 */   // Label 1305: @84667
     /*  84667 */   GIM_Try, /*On fail goto*//*Label 1306*/ GIMT_Encode4(84785), // Rule ID 15766 //
     /*  84672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84675 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84679 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84683 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84687 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84699 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84711 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84717 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84719 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/1, /*OpIdx*/2, // MIs[4]
     /*  84723 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84727 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84731 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84735 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  84739 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84745 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  84747 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  84751 */     GIM_CheckOpcode, /*MI*/6, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84755 */     GIM_CheckType, /*MI*/6, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84759 */     // MIs[6] Op3
     /*  84759 */     GIM_CheckIsSameOperand, /*MI*/6, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  84764 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84766 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  84769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/6, /*OpIdx*/1, // Op1
     /*  84775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  84779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  84783 */     GIR_RootConstrainSelectedInstOperands,
     /*  84784 */     // GIR_Coverage, 15766,
     /*  84784 */     GIR_EraseRootFromParent_Done,
     /*  84785 */   // Label 1306: @84785
     /*  84785 */   GIM_Try, /*On fail goto*//*Label 1307*/ GIMT_Encode4(84903), // Rule ID 15733 //
     /*  84790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84821 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84825 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84829 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84835 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84837 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84841 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84845 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84849 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84853 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84857 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84861 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84865 */     // MIs[5] Op3
     /*  84865 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  84870 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84874 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84880 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84882 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  84884 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  84884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  84887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  84889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  84893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  84897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  84901 */     GIR_RootConstrainSelectedInstOperands,
     /*  84902 */     // GIR_Coverage, 15733,
     /*  84902 */     GIR_EraseRootFromParent_Done,
     /*  84903 */   // Label 1307: @84903
     /*  84903 */   GIM_Try, /*On fail goto*//*Label 1308*/ GIMT_Encode4(85021), // Rule ID 15738 //
     /*  84908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  84911 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  84915 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84919 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84923 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84927 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  84931 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84935 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84939 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  84947 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84953 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  84955 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  84959 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  84963 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84967 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  84971 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  84975 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  84979 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  84983 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  84987 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  84993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  84995 */     // MIs[4] Op3
     /*  84995 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85000 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85002 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85011 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85015 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85019 */     GIR_RootConstrainSelectedInstOperands,
     /*  85020 */     // GIR_Coverage, 15738,
     /*  85020 */     GIR_EraseRootFromParent_Done,
     /*  85021 */   // Label 1308: @85021
     /*  85021 */   GIM_Try, /*On fail goto*//*Label 1309*/ GIMT_Encode4(85139), // Rule ID 15739 //
     /*  85026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85041 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85045 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85049 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85053 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85057 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85061 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85065 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85071 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85073 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85077 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85081 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85085 */     // MIs[4] Op3
     /*  85085 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85090 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85094 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85098 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85102 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85106 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85110 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85116 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85118 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85120 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  85133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85137 */     GIR_RootConstrainSelectedInstOperands,
     /*  85138 */     // GIR_Coverage, 15739,
     /*  85138 */     GIR_EraseRootFromParent_Done,
     /*  85139 */   // Label 1309: @85139
     /*  85139 */   GIM_Try, /*On fail goto*//*Label 1310*/ GIMT_Encode4(85257), // Rule ID 11946 //
     /*  85144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85147 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85151 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85155 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85159 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85163 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  85167 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85171 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85175 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85183 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85189 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85191 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85195 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85199 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85203 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85207 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85211 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85215 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85219 */     // MIs[5] Op3
     /*  85219 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85224 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85228 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85234 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85236 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85238 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85247 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85255 */     GIR_RootConstrainSelectedInstOperands,
     /*  85256 */     // GIR_Coverage, 11946,
     /*  85256 */     GIR_EraseRootFromParent_Done,
     /*  85257 */   // Label 1310: @85257
     /*  85257 */   GIM_Try, /*On fail goto*//*Label 1311*/ GIMT_Encode4(85375), // Rule ID 15735 //
     /*  85262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85281 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85285 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85289 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85293 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85297 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85301 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85307 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85309 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85313 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85317 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85321 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85325 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85329 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85333 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85337 */     // MIs[5] Op3
     /*  85337 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85342 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85346 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85352 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85354 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85356 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op2
     /*  85369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85373 */     GIR_RootConstrainSelectedInstOperands,
     /*  85374 */     // GIR_Coverage, 15735,
     /*  85374 */     GIR_EraseRootFromParent_Done,
     /*  85375 */   // Label 1311: @85375
     /*  85375 */   GIM_Try, /*On fail goto*//*Label 1312*/ GIMT_Encode4(85493), // Rule ID 15736 //
     /*  85380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85399 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85403 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85407 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85411 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85415 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85419 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85425 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85427 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85431 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85435 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85439 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/1, // MIs[5]
     /*  85443 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85447 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85451 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85455 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85459 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85465 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85467 */     // MIs[4] Op3
     /*  85467 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85472 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85474 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85491 */     GIR_RootConstrainSelectedInstOperands,
     /*  85492 */     // GIR_Coverage, 15736,
     /*  85492 */     GIR_EraseRootFromParent_Done,
     /*  85493 */   // Label 1312: @85493
     /*  85493 */   GIM_Try, /*On fail goto*//*Label 1313*/ GIMT_Encode4(85611), // Rule ID 15737 //
     /*  85498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85537 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85543 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85545 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85549 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85553 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85557 */     // MIs[4] Op3
     /*  85557 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  85562 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85566 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85570 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85574 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85578 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85582 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85588 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85590 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85592 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  85601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  85605 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  85609 */     GIR_RootConstrainSelectedInstOperands,
     /*  85610 */     // GIR_Coverage, 15737,
     /*  85610 */     GIR_EraseRootFromParent_Done,
     /*  85611 */   // Label 1313: @85611
     /*  85611 */   GIM_Try, /*On fail goto*//*Label 1314*/ GIMT_Encode4(85729), // Rule ID 15734 //
     /*  85616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85619 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85623 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85627 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85631 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  85639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85647 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85651 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  85655 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85661 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  85663 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  85667 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85671 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85675 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85679 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  85683 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85687 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85691 */     // MIs[5] Op3
     /*  85691 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85696 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85700 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85706 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85708 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85710 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85710 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /*  85713 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  85719 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op2
     /*  85723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85727 */     GIR_RootConstrainSelectedInstOperands,
     /*  85728 */     // GIR_Coverage, 15734,
     /*  85728 */     GIR_EraseRootFromParent_Done,
     /*  85729 */   // Label 1314: @85729
     /*  85729 */   GIM_Try, /*On fail goto*//*Label 1315*/ GIMT_Encode4(85847), // Rule ID 15761 //
     /*  85734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85765 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85769 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85773 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85777 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85781 */     // MIs[3] Op3
     /*  85781 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  85786 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85790 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85796 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85798 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85802 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85806 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85810 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85814 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85818 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85824 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85826 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85828 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85833 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  85837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85841 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  85845 */     GIR_RootConstrainSelectedInstOperands,
     /*  85846 */     // GIR_Coverage, 15761,
     /*  85846 */     GIR_EraseRootFromParent_Done,
     /*  85847 */   // Label 1315: @85847
     /*  85847 */   GIM_Try, /*On fail goto*//*Label 1316*/ GIMT_Encode4(85965), // Rule ID 15763 //
     /*  85852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85855 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85859 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85863 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85867 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  85891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85895 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85899 */     // MIs[3] Op3
     /*  85899 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  85904 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  85908 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85914 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  85916 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  85920 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  85924 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85928 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85932 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  85936 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  85942 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  85944 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  85946 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  85946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  85949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  85951 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  85955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op2
     /*  85959 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  85963 */     GIR_RootConstrainSelectedInstOperands,
     /*  85964 */     // GIR_Coverage, 15763,
     /*  85964 */     GIR_EraseRootFromParent_Done,
     /*  85965 */   // Label 1316: @85965
     /*  85965 */   GIM_Try, /*On fail goto*//*Label 1317*/ GIMT_Encode4(86083), // Rule ID 11954 //
     /*  85970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  85973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  85977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  85985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  85989 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  85993 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  85997 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86001 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86005 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86009 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86013 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86017 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86021 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86025 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86031 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86033 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86037 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86041 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86045 */     // MIs[5] Op3
     /*  86045 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86050 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86054 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86060 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86062 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86064 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86069 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86073 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86081 */     GIR_RootConstrainSelectedInstOperands,
     /*  86082 */     // GIR_Coverage, 11954,
     /*  86082 */     GIR_EraseRootFromParent_Done,
     /*  86083 */   // Label 1317: @86083
     /*  86083 */   GIM_Try, /*On fail goto*//*Label 1318*/ GIMT_Encode4(86201), // Rule ID 15762 //
     /*  86088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86099 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86103 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86119 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86123 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86127 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86131 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86135 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86139 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86143 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86149 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86151 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/2, /*OpIdx*/2, // MIs[5]
     /*  86155 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86159 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86163 */     // MIs[5] Op3
     /*  86163 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86168 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/5, /*OpIdx*/2, // MIs[6]
     /*  86172 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86178 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  86180 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  86182 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }), (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86191 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  86195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86199 */     GIR_RootConstrainSelectedInstOperands,
     /*  86200 */     // GIR_Coverage, 15762,
     /*  86200 */     GIR_EraseRootFromParent_Done,
     /*  86201 */   // Label 1318: @86201
     /*  86201 */   GIM_Try, /*On fail goto*//*Label 1319*/ GIMT_Encode4(86291), // Rule ID 15711 //
     /*  86206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86209 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86213 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86217 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86221 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86237 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86241 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86245 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86251 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86253 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86257 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86261 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86265 */     // MIs[4] Op3
     /*  86265 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86270 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86272 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86281 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86285 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86289 */     GIR_RootConstrainSelectedInstOperands,
     /*  86290 */     // GIR_Coverage, 15711,
     /*  86290 */     GIR_EraseRootFromParent_Done,
     /*  86291 */   // Label 1319: @86291
     /*  86291 */   GIM_Try, /*On fail goto*//*Label 1320*/ GIMT_Encode4(86381), // Rule ID 15710 //
     /*  86296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86299 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86303 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86307 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86311 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86315 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  86319 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86323 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86327 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86331 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86335 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86341 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86343 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86347 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86351 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86355 */     // MIs[4] Op3
     /*  86355 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86360 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86362 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86367 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86371 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  86375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86379 */     GIR_RootConstrainSelectedInstOperands,
     /*  86380 */     // GIR_Coverage, 15710,
     /*  86380 */     GIR_EraseRootFromParent_Done,
     /*  86381 */   // Label 1320: @86381
     /*  86381 */   GIM_Try, /*On fail goto*//*Label 1321*/ GIMT_Encode4(86471), // Rule ID 15709 //
     /*  86386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86413 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86417 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86425 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86431 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86433 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86437 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86441 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86445 */     // MIs[4] Op3
     /*  86445 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86450 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86452 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  86461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86469 */     GIR_RootConstrainSelectedInstOperands,
     /*  86470 */     // GIR_Coverage, 15709,
     /*  86470 */     GIR_EraseRootFromParent_Done,
     /*  86471 */   // Label 1321: @86471
     /*  86471 */   GIM_Try, /*On fail goto*//*Label 1322*/ GIMT_Encode4(86561), // Rule ID 15708 //
     /*  86476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86479 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86483 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86487 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  86499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86503 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86507 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86515 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86521 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  86523 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  86527 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86531 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86535 */     // MIs[4] Op3
     /*  86535 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  86540 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86542 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  86551 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  86555 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  86559 */     GIR_RootConstrainSelectedInstOperands,
     /*  86560 */     // GIR_Coverage, 15708,
     /*  86560 */     GIR_EraseRootFromParent_Done,
     /*  86561 */   // Label 1322: @86561
     /*  86561 */   GIM_Try, /*On fail goto*//*Label 1323*/ GIMT_Encode4(86651), // Rule ID 15705 //
     /*  86566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86581 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86593 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86597 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86601 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86605 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86609 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86613 */     // MIs[3] Op3
     /*  86613 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86618 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86622 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86628 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86630 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86632 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86649 */     GIR_RootConstrainSelectedInstOperands,
     /*  86650 */     // GIR_Coverage, 15705,
     /*  86650 */     GIR_EraseRootFromParent_Done,
     /*  86651 */   // Label 1323: @86651
     /*  86651 */   GIM_Try, /*On fail goto*//*Label 1324*/ GIMT_Encode4(86741), // Rule ID 15707 //
     /*  86656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86687 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86691 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86695 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86699 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86703 */     // MIs[3] Op3
     /*  86703 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86708 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86712 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86718 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86720 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86722 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86731 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  86735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86739 */     GIR_RootConstrainSelectedInstOperands,
     /*  86740 */     // GIR_Coverage, 15707,
     /*  86740 */     GIR_EraseRootFromParent_Done,
     /*  86741 */   // Label 1324: @86741
     /*  86741 */   GIM_Try, /*On fail goto*//*Label 1325*/ GIMT_Encode4(86831), // Rule ID 11938 //
     /*  86746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86765 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86769 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86773 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86777 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86789 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86793 */     // MIs[3] Op3
     /*  86793 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86798 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86802 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86808 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86810 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86812 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  86821 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  86829 */     GIR_RootConstrainSelectedInstOperands,
     /*  86830 */     // GIR_Coverage, 11938,
     /*  86830 */     GIR_EraseRootFromParent_Done,
     /*  86831 */   // Label 1325: @86831
     /*  86831 */   GIM_Try, /*On fail goto*//*Label 1326*/ GIMT_Encode4(86921), // Rule ID 15706 //
     /*  86836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86839 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86843 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86847 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86851 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86855 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86859 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86863 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86871 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  86875 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86879 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86883 */     // MIs[3] Op3
     /*  86883 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  86888 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  86892 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86898 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86900 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86902 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /*  86905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86907 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  86911 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  86915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  86919 */     GIR_RootConstrainSelectedInstOperands,
     /*  86920 */     // GIR_Coverage, 15706,
     /*  86920 */     GIR_EraseRootFromParent_Done,
     /*  86921 */   // Label 1326: @86921
     /*  86921 */   GIM_Try, /*On fail goto*//*Label 1327*/ GIMT_Encode4(87011), // Rule ID 15768 //
     /*  86926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  86929 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  86933 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  86937 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86941 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86945 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  86949 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  86953 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  86957 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  86965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  86969 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  86973 */     // MIs[3] Op3
     /*  86973 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  86978 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  86982 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  86988 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  86990 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  86992 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  86992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  86995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  86997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87001 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87005 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87009 */     GIR_RootConstrainSelectedInstOperands,
     /*  87010 */     // GIR_Coverage, 15768,
     /*  87010 */     GIR_EraseRootFromParent_Done,
     /*  87011 */   // Label 1327: @87011
     /*  87011 */   GIM_Try, /*On fail goto*//*Label 1328*/ GIMT_Encode4(87101), // Rule ID 15770 //
     /*  87016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87031 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87051 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87055 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87059 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87063 */     // MIs[3] Op3
     /*  87063 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87068 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87072 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87078 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87080 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87082 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  87095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87099 */     GIR_RootConstrainSelectedInstOperands,
     /*  87100 */     // GIR_Coverage, 15770,
     /*  87100 */     GIR_EraseRootFromParent_Done,
     /*  87101 */   // Label 1328: @87101
     /*  87101 */   GIM_Try, /*On fail goto*//*Label 1329*/ GIMT_Encode4(87191), // Rule ID 11955 //
     /*  87106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87121 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87125 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87129 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87133 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87137 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87141 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87145 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87149 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87153 */     // MIs[3] Op3
     /*  87153 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /*  87158 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87162 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87168 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87170 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87172 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87177 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  87181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  87189 */     GIR_RootConstrainSelectedInstOperands,
     /*  87190 */     // GIR_Coverage, 11955,
     /*  87190 */     GIR_EraseRootFromParent_Done,
     /*  87191 */   // Label 1329: @87191
     /*  87191 */   GIM_Try, /*On fail goto*//*Label 1330*/ GIMT_Encode4(87281), // Rule ID 15769 //
     /*  87196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  87219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87223 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87227 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  87235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87239 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87243 */     // MIs[3] Op3
     /*  87243 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/1,
     /*  87248 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/2, /*OpIdx*/2, // MIs[4]
     /*  87252 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87258 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  87260 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87262 */     // (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87267 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  87271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  87275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  87279 */     GIR_RootConstrainSelectedInstOperands,
     /*  87280 */     // GIR_Coverage, 15769,
     /*  87280 */     GIR_EraseRootFromParent_Done,
     /*  87281 */   // Label 1330: @87281
     /*  87281 */   GIM_Try, /*On fail goto*//*Label 1331*/ GIMT_Encode4(87371), // Rule ID 15772 //
     /*  87286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87293 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87297 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87301 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87313 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87317 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87321 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87325 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87331 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87333 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87337 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87341 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87345 */     // MIs[4] Op3
     /*  87345 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87350 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87352 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87369 */     GIR_RootConstrainSelectedInstOperands,
     /*  87370 */     // GIR_Coverage, 15772,
     /*  87370 */     GIR_EraseRootFromParent_Done,
     /*  87371 */   // Label 1331: @87371
     /*  87371 */   GIM_Try, /*On fail goto*//*Label 1332*/ GIMT_Encode4(87461), // Rule ID 15774 //
     /*  87376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87379 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87383 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87387 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87391 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87403 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87407 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87411 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87415 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87421 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87435 */     // MIs[4] Op3
     /*  87435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87440 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87442 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/2, // Op1
     /*  87451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87455 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87459 */     GIR_RootConstrainSelectedInstOperands,
     /*  87460 */     // GIR_Coverage, 15774,
     /*  87460 */     GIR_EraseRootFromParent_Done,
     /*  87461 */   // Label 1332: @87461
     /*  87461 */   GIM_Try, /*On fail goto*//*Label 1333*/ GIMT_Encode4(87551), // Rule ID 15771 //
     /*  87466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87505 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87513 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87517 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87521 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87525 */     // MIs[4] Op3
     /*  87525 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  87530 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87532 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  87545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  87549 */     GIR_RootConstrainSelectedInstOperands,
     /*  87550 */     // GIR_Coverage, 15771,
     /*  87550 */     GIR_EraseRootFromParent_Done,
     /*  87551 */   // Label 1333: @87551
     /*  87551 */   GIM_Try, /*On fail goto*//*Label 1334*/ GIMT_Encode4(87641), // Rule ID 15773 //
     /*  87556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  87559 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87563 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87567 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87571 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87575 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  87579 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_OR),
     /*  87583 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87587 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  87591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  87595 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  87601 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  87603 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  87607 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_AND),
     /*  87611 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  87615 */     // MIs[4] Op3
     /*  87615 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/2, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  87620 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  87622 */     // (or:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] }), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  87622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /*  87625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  87627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Op1
     /*  87631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  87635 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  87639 */     GIR_RootConstrainSelectedInstOperands,
     /*  87640 */     // GIR_Coverage, 15773,
     /*  87640 */     GIR_EraseRootFromParent_Done,
     /*  87641 */   // Label 1334: @87641
     /*  87641 */   GIM_Try, /*On fail goto*//*Label 1335*/ GIMT_Encode4(87656), // Rule ID 7506 //
     /*  87646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  87649 */     // (or:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  87649 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ORR_ZZZ),
     /*  87654 */     GIR_RootConstrainSelectedInstOperands,
     /*  87655 */     // GIR_Coverage, 7506,
     /*  87655 */     GIR_Done,
     /*  87656 */   // Label 1335: @87656
     /*  87656 */   GIM_Reject,
     /*  87657 */ // Label 1302: @87657
     /*  87657 */ GIM_Reject,
     /*  87658 */ // Label 1047: @87658
     /*  87658 */ GIM_Reject,
     /*  87659 */ // Label 7: @87659
     /*  87659 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1354*/ GIMT_Encode4(98626),
     /*  87670 */ /*GILLT_s32*//*Label 1336*/ GIMT_Encode4(87758),
     /*  87674 */ /*GILLT_s64*//*Label 1337*/ GIMT_Encode4(88438), GIMT_Encode4(0),
     /*  87682 */ /*GILLT_v2s32*//*Label 1338*/ GIMT_Encode4(89281),
     /*  87686 */ /*GILLT_v2s64*//*Label 1339*/ GIMT_Encode4(89516),
     /*  87690 */ /*GILLT_v4s16*//*Label 1340*/ GIMT_Encode4(90205),
     /*  87694 */ /*GILLT_v4s32*//*Label 1341*/ GIMT_Encode4(90440),
     /*  87698 */ /*GILLT_v8s8*//*Label 1342*/ GIMT_Encode4(91129),
     /*  87702 */ /*GILLT_v8s16*//*Label 1343*/ GIMT_Encode4(91367),
     /*  87706 */ /*GILLT_v16s8*//*Label 1344*/ GIMT_Encode4(92056),
     /*  87710 */ /*GILLT_nxv1s1*//*Label 1345*/ GIMT_Encode4(92748),
     /*  87714 */ /*GILLT_nxv2s1*//*Label 1346*/ GIMT_Encode4(92798), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  87726 */ /*GILLT_nxv2s64*//*Label 1347*/ GIMT_Encode4(92848),
     /*  87730 */ /*GILLT_nxv4s1*//*Label 1348*/ GIMT_Encode4(94255), GIMT_Encode4(0),
     /*  87738 */ /*GILLT_nxv4s32*//*Label 1349*/ GIMT_Encode4(94305),
     /*  87742 */ /*GILLT_nxv8s1*//*Label 1350*/ GIMT_Encode4(95712),
     /*  87746 */ /*GILLT_nxv8s16*//*Label 1351*/ GIMT_Encode4(95762),
     /*  87750 */ /*GILLT_nxv16s1*//*Label 1352*/ GIMT_Encode4(97169),
     /*  87754 */ /*GILLT_nxv16s8*//*Label 1353*/ GIMT_Encode4(97219),
     /*  87758 */ // Label 1336: @87758
     /*  87758 */ GIM_Try, /*On fail goto*//*Label 1355*/ GIMT_Encode4(88437),
     /*  87763 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /*  87766 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /*  87769 */   GIM_Try, /*On fail goto*//*Label 1356*/ GIMT_Encode4(87827), // Rule ID 13312 //
     /*  87774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87778 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  87782 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87786 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87790 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87794 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87799 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87805 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87812 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87817 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87821 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87825 */     GIR_RootConstrainSelectedInstOperands,
     /*  87826 */     // GIR_Coverage, 13312,
     /*  87826 */     GIR_EraseRootFromParent_Done,
     /*  87827 */   // Label 1356: @87827
     /*  87827 */   GIM_Try, /*On fail goto*//*Label 1357*/ GIMT_Encode4(87882), // Rule ID 13311 //
     /*  87832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87836 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87840 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87844 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87848 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87852 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  87856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87862 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87869 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rn)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  87876 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87880 */     GIR_RootConstrainSelectedInstOperands,
     /*  87881 */     // GIR_Coverage, 13311,
     /*  87881 */     GIR_EraseRootFromParent_Done,
     /*  87882 */   // Label 1357: @87882
     /*  87882 */   GIM_Try, /*On fail goto*//*Label 1358*/ GIMT_Encode4(87940), // Rule ID 13309 //
     /*  87887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87903 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87912 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87918 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87925 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87930 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  87934 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87938 */     GIR_RootConstrainSelectedInstOperands,
     /*  87939 */     // GIR_Coverage, 13309,
     /*  87939 */     GIR_EraseRootFromParent_Done,
     /*  87940 */   // Label 1358: @87940
     /*  87940 */   GIM_Try, /*On fail goto*//*Label 1359*/ GIMT_Encode4(87998), // Rule ID 166 //
     /*  87945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  87953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  87957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  87961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  87965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  87970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  87974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  87976 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  87983 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift), -1:{ *:[i32] })  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  87983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  87986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  87988 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  87992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  87996 */     GIR_RootConstrainSelectedInstOperands,
     /*  87997 */     // GIR_Coverage, 166,
     /*  87997 */     GIR_EraseRootFromParent_Done,
     /*  87998 */   // Label 1359: @87998
     /*  87998 */   GIM_Try, /*On fail goto*//*Label 1360*/ GIMT_Encode4(88056), // Rule ID 13310 //
     /*  88003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88034 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88041 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88050 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88054 */     GIR_RootConstrainSelectedInstOperands,
     /*  88055 */     // GIR_Coverage, 13310,
     /*  88055 */     GIR_EraseRootFromParent_Done,
     /*  88056 */   // Label 1360: @88056
     /*  88056 */   GIM_Try, /*On fail goto*//*Label 1361*/ GIMT_Encode4(88111), // Rule ID 13313 //
     /*  88061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88065 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88069 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88073 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88077 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88081 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88085 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88089 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88091 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88098 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, -1:{ *:[i32] }))  =>  (EONWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrs),
     /*  88101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88103 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88105 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88109 */     GIR_RootConstrainSelectedInstOperands,
     /*  88110 */     // GIR_Coverage, 13313,
     /*  88110 */     GIR_EraseRootFromParent_Done,
     /*  88111 */   // Label 1361: @88111
     /*  88111 */   GIM_Try, /*On fail goto*//*Label 1362*/ GIMT_Encode4(88152), // Rule ID 144 //
     /*  88116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /*  88120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88132 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm32),
     /*  88136 */     // MIs[1] Operand 1
     /*  88136 */     // No operand predicates
     /*  88136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88138 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_logical_imm32>><<X:logical_imm32_XFORM>>:$imm)  =>  (EORWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (logical_imm32_XFORM:{ *:[i32] } (imm:{ *:[i32] }):$imm))
     /*  88138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /*  88141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88143 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88145 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // imm
     /*  88150 */     GIR_RootConstrainSelectedInstOperands,
     /*  88151 */     // GIR_Coverage, 144,
     /*  88151 */     GIR_EraseRootFromParent_Done,
     /*  88152 */   // Label 1362: @88152
     /*  88152 */   GIM_Try, /*On fail goto*//*Label 1363*/ GIMT_Encode4(88185), // Rule ID 13319 //
     /*  88157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88161 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88165 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88172 */     // (xor:{ *:[i32] } logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift, GPR32:{ *:[i32] }:$Rn)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88179 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88183 */     GIR_RootConstrainSelectedInstOperands,
     /*  88184 */     // GIR_Coverage, 13319,
     /*  88184 */     GIR_EraseRootFromParent_Done,
     /*  88185 */   // Label 1363: @88185
     /*  88185 */   GIM_Try, /*On fail goto*//*Label 1364*/ GIMT_Encode4(88218), // Rule ID 170 //
     /*  88190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88198 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg32),
     /*  88205 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)  =>  (EORWrs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, logical_shifted_reg32:{ *:[i32] }:$Rm_and_shift)
     /*  88205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORWrs),
     /*  88208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88210 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88212 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88216 */     GIR_RootConstrainSelectedInstOperands,
     /*  88217 */     // GIR_Coverage, 170,
     /*  88217 */     GIR_EraseRootFromParent_Done,
     /*  88218 */   // Label 1364: @88218
     /*  88218 */   GIM_Try, /*On fail goto*//*Label 1365*/ GIMT_Encode4(88271), // Rule ID 13305 //
     /*  88223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88227 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88231 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88235 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88239 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88243 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88248 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88258 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }), GPR32:{ *:[i32] }:$Rm)  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  88269 */     GIR_RootConstrainSelectedInstOperands,
     /*  88270 */     // GIR_Coverage, 13305,
     /*  88270 */     GIR_EraseRootFromParent_Done,
     /*  88271 */   // Label 1365: @88271
     /*  88271 */   GIM_Try, /*On fail goto*//*Label 1366*/ GIMT_Encode4(88327), // Rule ID 164 //
     /*  88276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88280 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88284 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88288 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88292 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88296 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88306 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88310 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88312 */     // (xor:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm), -1:{ *:[i32] })  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88317 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  88325 */     GIR_RootConstrainSelectedInstOperands,
     /*  88326 */     // GIR_Coverage, 164,
     /*  88326 */     GIR_EraseRootFromParent_Done,
     /*  88327 */   // Label 1366: @88327
     /*  88327 */   GIM_Try, /*On fail goto*//*Label 1367*/ GIMT_Encode4(88380), // Rule ID 13306 //
     /*  88332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88336 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /*  88352 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /*  88356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88361 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88365 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88367 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, -1:{ *:[i32] }))  =>  (EONWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONWrr),
     /*  88370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  88378 */     GIR_RootConstrainSelectedInstOperands,
     /*  88379 */     // GIR_Coverage, 13306,
     /*  88379 */     GIR_EraseRootFromParent_Done,
     /*  88380 */   // Label 1367: @88380
     /*  88380 */   GIM_Try, /*On fail goto*//*Label 1368*/ GIMT_Encode4(88412), // Rule ID 4001 //
     /*  88385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88393 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88397 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Wm, -1:{ *:[i32] })  =>  (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Wm)
     /*  88397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /*  88400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88402 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  88408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Wm
     /*  88410 */     GIR_RootConstrainSelectedInstOperands,
     /*  88411 */     // GIR_Coverage, 4001,
     /*  88411 */     GIR_EraseRootFromParent_Done,
     /*  88412 */   // Label 1368: @88412
     /*  88412 */   GIM_Try, /*On fail goto*//*Label 1369*/ GIMT_Encode4(88436), // Rule ID 168 //
     /*  88417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /*  88429 */     // (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (EORWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /*  88429 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORWrr),
     /*  88434 */     GIR_RootConstrainSelectedInstOperands,
     /*  88435 */     // GIR_Coverage, 168,
     /*  88435 */     GIR_Done,
     /*  88436 */   // Label 1369: @88436
     /*  88436 */   GIM_Reject,
     /*  88437 */ // Label 1355: @88437
     /*  88437 */ GIM_Reject,
     /*  88438 */ // Label 1337: @88438
     /*  88438 */ GIM_Try, /*On fail goto*//*Label 1370*/ GIMT_Encode4(89280),
     /*  88443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  88446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  88449 */   GIM_Try, /*On fail goto*//*Label 1371*/ GIMT_Encode4(88507), // Rule ID 13317 //
     /*  88454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88470 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88474 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88479 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88485 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88492 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88497 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88501 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88505 */     GIR_RootConstrainSelectedInstOperands,
     /*  88506 */     // GIR_Coverage, 13317,
     /*  88506 */     GIR_EraseRootFromParent_Done,
     /*  88507 */   // Label 1371: @88507
     /*  88507 */   GIM_Try, /*On fail goto*//*Label 1372*/ GIMT_Encode4(88562), // Rule ID 13316 //
     /*  88512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88528 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88532 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88536 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88542 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88549 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88556 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88560 */     GIR_RootConstrainSelectedInstOperands,
     /*  88561 */     // GIR_Coverage, 13316,
     /*  88561 */     GIR_EraseRootFromParent_Done,
     /*  88562 */   // Label 1372: @88562
     /*  88562 */   GIM_Try, /*On fail goto*//*Label 1373*/ GIMT_Encode4(88620), // Rule ID 13314 //
     /*  88567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88583 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88587 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88592 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88596 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88598 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88605 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  88614 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88618 */     GIR_RootConstrainSelectedInstOperands,
     /*  88619 */     // GIR_Coverage, 13314,
     /*  88619 */     GIR_EraseRootFromParent_Done,
     /*  88620 */   // Label 1373: @88620
     /*  88620 */   GIM_Try, /*On fail goto*//*Label 1374*/ GIMT_Encode4(88678), // Rule ID 167 //
     /*  88625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88629 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88633 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88637 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88641 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88650 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  88654 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88656 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88663 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift), -1:{ *:[i64] })  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88672 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88676 */     GIR_RootConstrainSelectedInstOperands,
     /*  88677 */     // GIR_Coverage, 167,
     /*  88677 */     GIR_EraseRootFromParent_Done,
     /*  88678 */   // Label 1374: @88678
     /*  88678 */   GIM_Try, /*On fail goto*//*Label 1375*/ GIMT_Encode4(88736), // Rule ID 13315 //
     /*  88683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88695 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88699 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88708 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88714 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88721 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  88730 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88734 */     GIR_RootConstrainSelectedInstOperands,
     /*  88735 */     // GIR_Coverage, 13315,
     /*  88735 */     GIR_EraseRootFromParent_Done,
     /*  88736 */   // Label 1375: @88736
     /*  88736 */   GIM_Try, /*On fail goto*//*Label 1376*/ GIMT_Encode4(88791), // Rule ID 13318 //
     /*  88741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88745 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  88757 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  88761 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88765 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  88769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88771 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88778 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, -1:{ *:[i64] }))  =>  (EONXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrs),
     /*  88781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88783 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88785 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88789 */     GIR_RootConstrainSelectedInstOperands,
     /*  88790 */     // GIR_Coverage, 13318,
     /*  88790 */     GIR_EraseRootFromParent_Done,
     /*  88791 */   // Label 1376: @88791
     /*  88791 */   GIM_Try, /*On fail goto*//*Label 1377*/ GIMT_Encode4(88891), // Rule ID 1613 //
     /*  88796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  88799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  88807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  88811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  88815 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /*  88819 */     // MIs[1] Operand 1
     /*  88819 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  88824 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  88828 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  88832 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /*  88836 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /*  88840 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88845 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  88850 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  88854 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88860 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  88862 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  88866 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  88872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  88874 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  88876 */     // (xor:{ *:[v1i64] } (setcc:{ *:[v1i64] } (and:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm), immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v1i64] })  =>  (CMTSTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /*  88876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv1i64),
     /*  88879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  88885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  88889 */     GIR_RootConstrainSelectedInstOperands,
     /*  88890 */     // GIR_Coverage, 1613,
     /*  88890 */     GIR_EraseRootFromParent_Done,
     /*  88891 */   // Label 1377: @88891
     /*  88891 */   GIM_Try, /*On fail goto*//*Label 1378*/ GIMT_Encode4(88932), // Rule ID 145 //
     /*  88896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /*  88900 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  88908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  88912 */     GIM_CheckAPIntImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APInt_Predicate_logical_imm64),
     /*  88916 */     // MIs[1] Operand 1
     /*  88916 */     // No operand predicates
     /*  88916 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  88918 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_logical_imm64>><<X:logical_imm64_XFORM>>:$imm)  =>  (EORXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (logical_imm64_XFORM:{ *:[i64] } (imm:{ *:[i64] }):$imm))
     /*  88918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXri),
     /*  88921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88923 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88925 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm64), // imm
     /*  88930 */     GIR_RootConstrainSelectedInstOperands,
     /*  88931 */     // GIR_Coverage, 145,
     /*  88931 */     GIR_EraseRootFromParent_Done,
     /*  88932 */   // Label 1378: @88932
     /*  88932 */   GIM_Try, /*On fail goto*//*Label 1379*/ GIMT_Encode4(88965), // Rule ID 13320 //
     /*  88937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88945 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88952 */     // (xor:{ *:[i64] } logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift, GPR64:{ *:[i64] }:$Rn)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /*  88959 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88963 */     GIR_RootConstrainSelectedInstOperands,
     /*  88964 */     // GIR_Coverage, 13320,
     /*  88964 */     GIR_EraseRootFromParent_Done,
     /*  88965 */   // Label 1379: @88965
     /*  88965 */   GIM_Try, /*On fail goto*//*Label 1380*/ GIMT_Encode4(88998), // Rule ID 171 //
     /*  88970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  88978 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_logical_shifted_reg64),
     /*  88985 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)  =>  (EORXrs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, logical_shifted_reg64:{ *:[i64] }:$Rm_and_shift)
     /*  88985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORXrs),
     /*  88988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  88990 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  88992 */     GIR_ComplexRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), // Rm_and_shift
     /*  88996 */     GIR_RootConstrainSelectedInstOperands,
     /*  88997 */     // GIR_Coverage, 171,
     /*  88997 */     GIR_EraseRootFromParent_Done,
     /*  88998 */   // Label 1380: @88998
     /*  88998 */   GIM_Try, /*On fail goto*//*Label 1381*/ GIMT_Encode4(89051), // Rule ID 13307 //
     /*  89003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89032 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89038 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }), GPR64:{ *:[i64] }:$Rm)  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /*  89049 */     GIR_RootConstrainSelectedInstOperands,
     /*  89050 */     // GIR_Coverage, 13307,
     /*  89050 */     GIR_EraseRootFromParent_Done,
     /*  89051 */   // Label 1381: @89051
     /*  89051 */   GIM_Try, /*On fail goto*//*Label 1382*/ GIMT_Encode4(89107), // Rule ID 165 //
     /*  89056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89072 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89076 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89086 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89092 */     // (xor:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm), -1:{ *:[i64] })  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /*  89105 */     GIR_RootConstrainSelectedInstOperands,
     /*  89106 */     // GIR_Coverage, 165,
     /*  89106 */     GIR_EraseRootFromParent_Done,
     /*  89107 */   // Label 1382: @89107
     /*  89107 */   GIM_Try, /*On fail goto*//*Label 1383*/ GIMT_Encode4(89160), // Rule ID 13308 //
     /*  89112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89120 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89124 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89128 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /*  89132 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /*  89136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89141 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, uint8_t(-1),
     /*  89145 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89147 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, -1:{ *:[i64] }))  =>  (EONXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EONXrr),
     /*  89150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /*  89156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /*  89158 */     GIR_RootConstrainSelectedInstOperands,
     /*  89159 */     // GIR_Coverage, 13308,
     /*  89159 */     GIR_EraseRootFromParent_Done,
     /*  89160 */   // Label 1383: @89160
     /*  89160 */   GIM_Try, /*On fail goto*//*Label 1384*/ GIMT_Encode4(89192), // Rule ID 4002 //
     /*  89165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89173 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, uint8_t(-1),
     /*  89177 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Xm, -1:{ *:[i64] })  =>  (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Xm)
     /*  89177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /*  89180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89182 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /*  89188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Xm
     /*  89190 */     GIR_RootConstrainSelectedInstOperands,
     /*  89191 */     // GIR_Coverage, 4002,
     /*  89191 */     GIR_EraseRootFromParent_Done,
     /*  89192 */   // Label 1384: @89192
     /*  89192 */   GIM_Try, /*On fail goto*//*Label 1385*/ GIMT_Encode4(89228), // Rule ID 4986 //
     /*  89197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89201 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89217 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89219 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] })  =>  (NOTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /*  89219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89224 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89226 */     GIR_RootConstrainSelectedInstOperands,
     /*  89227 */     // GIR_Coverage, 4986,
     /*  89227 */     GIR_EraseRootFromParent_Done,
     /*  89228 */   // Label 1385: @89228
     /*  89228 */   GIM_Try, /*On fail goto*//*Label 1386*/ GIMT_Encode4(89252), // Rule ID 169 //
     /*  89233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89237 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /*  89245 */     // (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (EORXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /*  89245 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORXrr),
     /*  89250 */     GIR_RootConstrainSelectedInstOperands,
     /*  89251 */     // GIR_Coverage, 169,
     /*  89251 */     GIR_Done,
     /*  89252 */   // Label 1386: @89252
     /*  89252 */   GIM_Try, /*On fail goto*//*Label 1387*/ GIMT_Encode4(89279), // Rule ID 5064 //
     /*  89257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89272 */     // (xor:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)  =>  (EORv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$LHS, V64:{ *:[v1i64] }:$RHS)
     /*  89272 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89277 */     GIR_RootConstrainSelectedInstOperands,
     /*  89278 */     // GIR_Coverage, 5064,
     /*  89278 */     GIR_Done,
     /*  89279 */   // Label 1387: @89279
     /*  89279 */   GIM_Reject,
     /*  89280 */ // Label 1370: @89280
     /*  89280 */ GIM_Reject,
     /*  89281 */ // Label 1338: @89281
     /*  89281 */ GIM_Try, /*On fail goto*//*Label 1388*/ GIMT_Encode4(89515),
     /*  89286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89289 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89292 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89296 */   GIM_Try, /*On fail goto*//*Label 1389*/ GIMT_Encode4(89392), // Rule ID 1160 //
     /*  89301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89312 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89316 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89320 */     // MIs[1] Operand 1
     /*  89320 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89333 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  89337 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89341 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89346 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89351 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89355 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89363 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89367 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89373 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89375 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89377 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } (and:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /*  89377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89386 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89390 */     GIR_RootConstrainSelectedInstOperands,
     /*  89391 */     // GIR_Coverage, 1160,
     /*  89391 */     GIR_EraseRootFromParent_Done,
     /*  89392 */   // Label 1389: @89392
     /*  89392 */   GIM_Try, /*On fail goto*//*Label 1390*/ GIMT_Encode4(89459), // Rule ID 5033 //
     /*  89397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  89409 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /*  89413 */     // MIs[1] Operand 1
     /*  89413 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89422 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89428 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89434 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89440 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89442 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89444 */     // (xor:{ *:[v2i32] } (setcc:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i32] })  =>  (CMTSTv2i32:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$Rn, v2i32:{ *:[v2i32] }:$Rn)
     /*  89444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i32),
     /*  89447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89457 */     GIR_RootConstrainSelectedInstOperands,
     /*  89458 */     // GIR_Coverage, 5033,
     /*  89458 */     GIR_EraseRootFromParent_Done,
     /*  89459 */   // Label 1390: @89459
     /*  89459 */   GIM_Try, /*On fail goto*//*Label 1391*/ GIMT_Encode4(89491), // Rule ID 4984 //
     /*  89464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89472 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89478 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  89480 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  89482 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] })  =>  (NOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /*  89482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  89485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89487 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  89489 */     GIR_RootConstrainSelectedInstOperands,
     /*  89490 */     // GIR_Coverage, 4984,
     /*  89490 */     GIR_EraseRootFromParent_Done,
     /*  89491 */   // Label 1391: @89491
     /*  89491 */   GIM_Try, /*On fail goto*//*Label 1392*/ GIMT_Encode4(89514), // Rule ID 5063 //
     /*  89496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89499 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  89507 */     // (xor:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)  =>  (EORv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$LHS, V64:{ *:[v2i32] }:$RHS)
     /*  89507 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  89512 */     GIR_RootConstrainSelectedInstOperands,
     /*  89513 */     // GIR_Coverage, 5063,
     /*  89513 */     GIR_Done,
     /*  89514 */   // Label 1392: @89514
     /*  89514 */   GIM_Reject,
     /*  89515 */ // Label 1388: @89515
     /*  89515 */ GIM_Reject,
     /*  89516 */ // Label 1339: @89516
     /*  89516 */ GIM_Try, /*On fail goto*//*Label 1393*/ GIMT_Encode4(90204),
     /*  89521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89524 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89531 */   GIM_Try, /*On fail goto*//*Label 1394*/ GIMT_Encode4(89627), // Rule ID 1162 //
     /*  89536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  89539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89551 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89555 */     // MIs[1] Operand 1
     /*  89555 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  89590 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89596 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  89598 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  89602 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89608 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  89610 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  89612 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  89612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  89621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  89625 */     GIR_RootConstrainSelectedInstOperands,
     /*  89626 */     // GIR_Coverage, 1162,
     /*  89626 */     GIR_EraseRootFromParent_Done,
     /*  89627 */   // Label 1394: @89627
     /*  89627 */   GIM_Try, /*On fail goto*//*Label 1395*/ GIMT_Encode4(89694), // Rule ID 5035 //
     /*  89632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  89640 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89644 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /*  89648 */     // MIs[1] Operand 1
     /*  89648 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  89653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  89657 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89663 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  89665 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  89669 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89675 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89677 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89679 */     // (xor:{ *:[v2i64] } (setcc:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v2i64] })  =>  (CMTSTv2i64:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, v2i64:{ *:[v2i64] }:$Rn)
     /*  89679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv2i64),
     /*  89682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  89684 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  89692 */     GIR_RootConstrainSelectedInstOperands,
     /*  89693 */     // GIR_Coverage, 5035,
     /*  89693 */     GIR_EraseRootFromParent_Done,
     /*  89694 */   // Label 1395: @89694
     /*  89694 */   GIM_Try, /*On fail goto*//*Label 1396*/ GIMT_Encode4(89779), // Rule ID 13852 //
     /*  89699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89710 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89714 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89718 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89722 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89726 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89730 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89734 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89743 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89749 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89751 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89760 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89762 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89773 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89777 */     GIR_RootConstrainSelectedInstOperands,
     /*  89778 */     // GIR_Coverage, 13852,
     /*  89778 */     GIR_EraseRootFromParent_Done,
     /*  89779 */   // Label 1396: @89779
     /*  89779 */   GIM_Try, /*On fail goto*//*Label 1397*/ GIMT_Encode4(89864), // Rule ID 13851 //
     /*  89784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89787 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  89791 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89795 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89799 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89803 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89816 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89820 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89829 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89833 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89839 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89845 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89847 */     // (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$Vn)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  89854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  89858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89862 */     GIR_RootConstrainSelectedInstOperands,
     /*  89863 */     // GIR_Coverage, 13851,
     /*  89863 */     GIR_EraseRootFromParent_Done,
     /*  89864 */   // Label 1397: @89864
     /*  89864 */   GIM_Try, /*On fail goto*//*Label 1398*/ GIMT_Encode4(89949), // Rule ID 13850 //
     /*  89869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89892 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  89896 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89900 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89904 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89913 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  89917 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  89923 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  89925 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  89932 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$Vm))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  89932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  89935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  89937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  89939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  89943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  89947 */     GIR_RootConstrainSelectedInstOperands,
     /*  89948 */     // GIR_Coverage, 13850,
     /*  89948 */     GIR_EraseRootFromParent_Done,
     /*  89949 */   // Label 1398: @89949
     /*  89949 */   GIM_Try, /*On fail goto*//*Label 1399*/ GIMT_Encode4(90034), // Rule ID 3829 //
     /*  89954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  89957 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  89965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  89969 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89973 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89977 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  89982 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  89986 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  89990 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  89994 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  89998 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90003 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90007 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90013 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90015 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90017 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, immAllOnesV:{ *:[v2i64] })))  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90024 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90032 */     GIR_RootConstrainSelectedInstOperands,
     /*  90033 */     // GIR_Coverage, 3829,
     /*  90033 */     GIR_EraseRootFromParent_Done,
     /*  90034 */   // Label 1399: @90034
     /*  90034 */   GIM_Try, /*On fail goto*//*Label 1400*/ GIMT_Encode4(90066), // Rule ID 4987 //
     /*  90039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90047 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90053 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90055 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90057 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] })  =>  (NOTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /*  90057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90062 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90064 */     GIR_RootConstrainSelectedInstOperands,
     /*  90065 */     // GIR_Coverage, 4987,
     /*  90065 */     GIR_EraseRootFromParent_Done,
     /*  90066 */   // Label 1400: @90066
     /*  90066 */   GIM_Try, /*On fail goto*//*Label 1401*/ GIMT_Encode4(90123), // Rule ID 3825 //
     /*  90071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90095 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90104 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90106 */     // (xor:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm), V128:{ *:[v2i64] }:$Va)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  90121 */     GIR_RootConstrainSelectedInstOperands,
     /*  90122 */     // GIR_Coverage, 3825,
     /*  90122 */     GIR_EraseRootFromParent_Done,
     /*  90123 */   // Label 1401: @90123
     /*  90123 */   GIM_Try, /*On fail goto*//*Label 1402*/ GIMT_Encode4(90180), // Rule ID 13840 //
     /*  90128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90135 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90139 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90143 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  90147 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  90151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90161 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90163 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Va, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, V128:{ *:[v2i64] }:$Va)
     /*  90163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  90166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  90172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90176 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  90178 */     GIR_RootConstrainSelectedInstOperands,
     /*  90179 */     // GIR_Coverage, 13840,
     /*  90179 */     GIR_EraseRootFromParent_Done,
     /*  90180 */   // Label 1402: @90180
     /*  90180 */   GIM_Try, /*On fail goto*//*Label 1403*/ GIMT_Encode4(90203), // Rule ID 5067 //
     /*  90185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90196 */     // (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)  =>  (EORv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$LHS, V128:{ *:[v2i64] }:$RHS)
     /*  90196 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  90201 */     GIR_RootConstrainSelectedInstOperands,
     /*  90202 */     // GIR_Coverage, 5067,
     /*  90202 */     GIR_Done,
     /*  90203 */   // Label 1403: @90203
     /*  90203 */   GIM_Reject,
     /*  90204 */ // Label 1393: @90204
     /*  90204 */ GIM_Reject,
     /*  90205 */ // Label 1340: @90205
     /*  90205 */ GIM_Try, /*On fail goto*//*Label 1404*/ GIMT_Encode4(90439),
     /*  90210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90220 */   GIM_Try, /*On fail goto*//*Label 1405*/ GIMT_Encode4(90316), // Rule ID 1158 //
     /*  90225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90236 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90240 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90244 */     // MIs[1] Operand 1
     /*  90244 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90257 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /*  90261 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90265 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90270 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90275 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90279 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90285 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90287 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90291 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90297 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90299 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90301 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } (and:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /*  90301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90314 */     GIR_RootConstrainSelectedInstOperands,
     /*  90315 */     // GIR_Coverage, 1158,
     /*  90315 */     GIR_EraseRootFromParent_Done,
     /*  90316 */   // Label 1405: @90316
     /*  90316 */   GIM_Try, /*On fail goto*//*Label 1406*/ GIMT_Encode4(90383), // Rule ID 5031 //
     /*  90321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90329 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /*  90333 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /*  90337 */     // MIs[1] Operand 1
     /*  90337 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90346 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90354 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90358 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90364 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90366 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90368 */     // (xor:{ *:[v4i16] } (setcc:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i16] })  =>  (CMTSTv4i16:{ *:[v4i16] } v4i16:{ *:[v4i16] }:$Rn, v4i16:{ *:[v4i16] }:$Rn)
     /*  90368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i16),
     /*  90371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90381 */     GIR_RootConstrainSelectedInstOperands,
     /*  90382 */     // GIR_Coverage, 5031,
     /*  90382 */     GIR_EraseRootFromParent_Done,
     /*  90383 */   // Label 1406: @90383
     /*  90383 */   GIM_Try, /*On fail goto*//*Label 1407*/ GIMT_Encode4(90415), // Rule ID 4982 //
     /*  90388 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90396 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90402 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90406 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] })  =>  (NOTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /*  90406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  90409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90413 */     GIR_RootConstrainSelectedInstOperands,
     /*  90414 */     // GIR_Coverage, 4982,
     /*  90414 */     GIR_EraseRootFromParent_Done,
     /*  90415 */   // Label 1407: @90415
     /*  90415 */   GIM_Try, /*On fail goto*//*Label 1408*/ GIMT_Encode4(90438), // Rule ID 5062 //
     /*  90420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  90431 */     // (xor:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)  =>  (EORv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$LHS, V64:{ *:[v4i16] }:$RHS)
     /*  90431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  90436 */     GIR_RootConstrainSelectedInstOperands,
     /*  90437 */     // GIR_Coverage, 5062,
     /*  90437 */     GIR_Done,
     /*  90438 */   // Label 1408: @90438
     /*  90438 */   GIM_Reject,
     /*  90439 */ // Label 1404: @90439
     /*  90439 */ GIM_Reject,
     /*  90440 */ // Label 1341: @90440
     /*  90440 */ GIM_Try, /*On fail goto*//*Label 1409*/ GIMT_Encode4(91128),
     /*  90445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90455 */   GIM_Try, /*On fail goto*//*Label 1410*/ GIMT_Encode4(90551), // Rule ID 1161 //
     /*  90460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  90463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90471 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90475 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90479 */     // MIs[1] Operand 1
     /*  90479 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90484 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90488 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90492 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90496 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90500 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90505 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  90514 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90520 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  90522 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  90526 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90532 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  90534 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  90536 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /*  90536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  90545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  90549 */     GIR_RootConstrainSelectedInstOperands,
     /*  90550 */     // GIR_Coverage, 1161,
     /*  90550 */     GIR_EraseRootFromParent_Done,
     /*  90551 */   // Label 1410: @90551
     /*  90551 */   GIM_Try, /*On fail goto*//*Label 1411*/ GIMT_Encode4(90618), // Rule ID 5034 //
     /*  90556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  90564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90568 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /*  90572 */     // MIs[1] Operand 1
     /*  90572 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  90577 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  90581 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90587 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  90589 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  90593 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90599 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90601 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90603 */     // (xor:{ *:[v4i32] } (setcc:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v4i32] })  =>  (CMTSTv4i32:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, v4i32:{ *:[v4i32] }:$Rn)
     /*  90603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv4i32),
     /*  90606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  90616 */     GIR_RootConstrainSelectedInstOperands,
     /*  90617 */     // GIR_Coverage, 5034,
     /*  90617 */     GIR_EraseRootFromParent_Done,
     /*  90618 */   // Label 1411: @90618
     /*  90618 */   GIM_Try, /*On fail goto*//*Label 1412*/ GIMT_Encode4(90703), // Rule ID 13849 //
     /*  90623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90654 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90658 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90667 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90675 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90684 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90686 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90693 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90697 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90701 */     GIR_RootConstrainSelectedInstOperands,
     /*  90702 */     // GIR_Coverage, 13849,
     /*  90702 */     GIR_EraseRootFromParent_Done,
     /*  90703 */   // Label 1412: @90703
     /*  90703 */   GIM_Try, /*On fail goto*//*Label 1413*/ GIMT_Encode4(90788), // Rule ID 13848 //
     /*  90708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  90715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90740 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90744 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90748 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90753 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90757 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90763 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90771 */     // (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$Vn)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  90778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90786 */     GIR_RootConstrainSelectedInstOperands,
     /*  90787 */     // GIR_Coverage, 13848,
     /*  90787 */     GIR_EraseRootFromParent_Done,
     /*  90788 */   // Label 1413: @90788
     /*  90788 */   GIM_Try, /*On fail goto*//*Label 1414*/ GIMT_Encode4(90873), // Rule ID 13847 //
     /*  90793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90796 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  90820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90841 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90847 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90849 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90854 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90856 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$Vm))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90861 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  90867 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90871 */     GIR_RootConstrainSelectedInstOperands,
     /*  90872 */     // GIR_Coverage, 13847,
     /*  90872 */     GIR_EraseRootFromParent_Done,
     /*  90873 */   // Label 1414: @90873
     /*  90873 */   GIM_Try, /*On fail goto*//*Label 1415*/ GIMT_Encode4(90958), // Rule ID 3828 //
     /*  90878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  90893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90901 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90906 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  90910 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  90914 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  90918 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  90922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90927 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  90931 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90937 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  90939 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  90941 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, immAllOnesV:{ *:[v4i32] })))  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  90941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  90944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  90946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  90948 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  90952 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  90956 */     GIR_RootConstrainSelectedInstOperands,
     /*  90957 */     // GIR_Coverage, 3828,
     /*  90957 */     GIR_EraseRootFromParent_Done,
     /*  90958 */   // Label 1415: @90958
     /*  90958 */   GIM_Try, /*On fail goto*//*Label 1416*/ GIMT_Encode4(90990), // Rule ID 4985 //
     /*  90963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  90967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  90971 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  90977 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  90979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  90981 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] })  =>  (NOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /*  90981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  90984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  90986 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  90988 */     GIR_RootConstrainSelectedInstOperands,
     /*  90989 */     // GIR_Coverage, 4985,
     /*  90989 */     GIR_EraseRootFromParent_Done,
     /*  90990 */   // Label 1416: @90990
     /*  90990 */   GIM_Try, /*On fail goto*//*Label 1417*/ GIMT_Encode4(91047), // Rule ID 3824 //
     /*  90995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  90998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91019 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91028 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91030 */     // (xor:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm), V128:{ *:[v4i32] }:$Va)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91035 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91039 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91043 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91045 */     GIR_RootConstrainSelectedInstOperands,
     /*  91046 */     // GIR_Coverage, 3824,
     /*  91046 */     GIR_EraseRootFromParent_Done,
     /*  91047 */   // Label 1417: @91047
     /*  91047 */   GIM_Try, /*On fail goto*//*Label 1418*/ GIMT_Encode4(91104), // Rule ID 13839 //
     /*  91052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91055 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /*  91071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /*  91075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91080 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91087 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Va, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /*  91087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91092 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91096 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  91102 */     GIR_RootConstrainSelectedInstOperands,
     /*  91103 */     // GIR_Coverage, 13839,
     /*  91103 */     GIR_EraseRootFromParent_Done,
     /*  91104 */   // Label 1418: @91104
     /*  91104 */   GIM_Try, /*On fail goto*//*Label 1419*/ GIMT_Encode4(91127), // Rule ID 5066 //
     /*  91109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91120 */     // (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)  =>  (EORv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$LHS, V128:{ *:[v4i32] }:$RHS)
     /*  91120 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  91125 */     GIR_RootConstrainSelectedInstOperands,
     /*  91126 */     // GIR_Coverage, 5066,
     /*  91126 */     GIR_Done,
     /*  91127 */   // Label 1419: @91127
     /*  91127 */   GIM_Reject,
     /*  91128 */ // Label 1409: @91128
     /*  91128 */ GIM_Reject,
     /*  91129 */ // Label 1342: @91129
     /*  91129 */ GIM_Try, /*On fail goto*//*Label 1420*/ GIMT_Encode4(91366),
     /*  91134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91144 */   GIM_Try, /*On fail goto*//*Label 1421*/ GIMT_Encode4(91240), // Rule ID 1156 //
     /*  91149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91164 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91168 */     // MIs[1] Operand 1
     /*  91168 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91173 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91177 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91181 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /*  91185 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91189 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91199 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91203 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91209 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91211 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91215 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91221 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91223 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91225 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } (and:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm), immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91238 */     GIR_RootConstrainSelectedInstOperands,
     /*  91239 */     // GIR_Coverage, 1156,
     /*  91239 */     GIR_EraseRootFromParent_Done,
     /*  91240 */   // Label 1421: @91240
     /*  91240 */   GIM_Try, /*On fail goto*//*Label 1422*/ GIMT_Encode4(91307), // Rule ID 5029 //
     /*  91245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91249 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91253 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /*  91257 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /*  91261 */     // MIs[1] Operand 1
     /*  91261 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91266 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91270 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91278 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91282 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91288 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91290 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91292 */     // (xor:{ *:[v8i8] } (setcc:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i8] })  =>  (CMTSTv8i8:{ *:[v8i8] } v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rn)
     /*  91292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i8),
     /*  91295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91301 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91305 */     GIR_RootConstrainSelectedInstOperands,
     /*  91306 */     // GIR_Coverage, 5029,
     /*  91306 */     GIR_EraseRootFromParent_Done,
     /*  91307 */   // Label 1422: @91307
     /*  91307 */   GIM_Try, /*On fail goto*//*Label 1423*/ GIMT_Encode4(91342), // Rule ID 972 //
     /*  91312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91315 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91323 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91333 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] })  =>  (NOTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /*  91333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv8i8),
     /*  91336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91340 */     GIR_RootConstrainSelectedInstOperands,
     /*  91341 */     // GIR_Coverage, 972,
     /*  91341 */     GIR_EraseRootFromParent_Done,
     /*  91342 */   // Label 1423: @91342
     /*  91342 */   GIM_Try, /*On fail goto*//*Label 1424*/ GIMT_Encode4(91365), // Rule ID 1599 //
     /*  91347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91350 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  91358 */     // (xor:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (EORv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /*  91358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /*  91363 */     GIR_RootConstrainSelectedInstOperands,
     /*  91364 */     // GIR_Coverage, 1599,
     /*  91364 */     GIR_Done,
     /*  91365 */   // Label 1424: @91365
     /*  91365 */   GIM_Reject,
     /*  91366 */ // Label 1420: @91366
     /*  91366 */ GIM_Reject,
     /*  91367 */ // Label 1343: @91367
     /*  91367 */ GIM_Try, /*On fail goto*//*Label 1425*/ GIMT_Encode4(92055),
     /*  91372 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91375 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91382 */   GIM_Try, /*On fail goto*//*Label 1426*/ GIMT_Encode4(91478), // Rule ID 1159 //
     /*  91387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  91390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91394 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91402 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91406 */     // MIs[1] Operand 1
     /*  91406 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91437 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  91441 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91447 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  91449 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  91453 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91459 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  91461 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  91463 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /*  91463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  91472 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  91476 */     GIR_RootConstrainSelectedInstOperands,
     /*  91477 */     // GIR_Coverage, 1159,
     /*  91477 */     GIR_EraseRootFromParent_Done,
     /*  91478 */   // Label 1426: @91478
     /*  91478 */   GIM_Try, /*On fail goto*//*Label 1427*/ GIMT_Encode4(91545), // Rule ID 5032 //
     /*  91483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  91491 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91495 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /*  91499 */     // MIs[1] Operand 1
     /*  91499 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  91504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  91508 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91514 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  91516 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  91520 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91526 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91528 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91530 */     // (xor:{ *:[v8i16] } (setcc:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v8i16] })  =>  (CMTSTv8i16:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, v8i16:{ *:[v8i16] }:$Rn)
     /*  91530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv8i16),
     /*  91533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  91543 */     GIR_RootConstrainSelectedInstOperands,
     /*  91544 */     // GIR_Coverage, 5032,
     /*  91544 */     GIR_EraseRootFromParent_Done,
     /*  91545 */   // Label 1427: @91545
     /*  91545 */   GIM_Try, /*On fail goto*//*Label 1428*/ GIMT_Encode4(91630), // Rule ID 13846 //
     /*  91550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91594 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91600 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91613 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91620 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91628 */     GIR_RootConstrainSelectedInstOperands,
     /*  91629 */     // GIR_Coverage, 13846,
     /*  91629 */     GIR_EraseRootFromParent_Done,
     /*  91630 */   // Label 1428: @91630
     /*  91630 */   GIM_Try, /*On fail goto*//*Label 1429*/ GIMT_Encode4(91715), // Rule ID 13845 //
     /*  91635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91650 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91680 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91684 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91690 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91696 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91698 */     // (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$Vn)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  91705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91713 */     GIR_RootConstrainSelectedInstOperands,
     /*  91714 */     // GIR_Coverage, 13845,
     /*  91714 */     GIR_EraseRootFromParent_Done,
     /*  91715 */   // Label 1429: @91715
     /*  91715 */   GIM_Try, /*On fail goto*//*Label 1430*/ GIMT_Encode4(91800), // Rule ID 13844 //
     /*  91720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91723 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91743 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  91747 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91751 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91755 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91759 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91764 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91768 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91774 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91781 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91783 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$Vm))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91790 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91798 */     GIR_RootConstrainSelectedInstOperands,
     /*  91799 */     // GIR_Coverage, 13844,
     /*  91799 */     GIR_EraseRootFromParent_Done,
     /*  91800 */   // Label 1430: @91800
     /*  91800 */   GIM_Try, /*On fail goto*//*Label 1431*/ GIMT_Encode4(91885), // Rule ID 3827 //
     /*  91805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  91820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91824 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91833 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  91837 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91841 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91845 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91849 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91854 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  91858 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91864 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  91866 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  91868 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, immAllOnesV:{ *:[v8i16] })))  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  91871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91873 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  91875 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  91879 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  91883 */     GIR_RootConstrainSelectedInstOperands,
     /*  91884 */     // GIR_Coverage, 3827,
     /*  91884 */     GIR_EraseRootFromParent_Done,
     /*  91885 */   // Label 1431: @91885
     /*  91885 */   GIM_Try, /*On fail goto*//*Label 1432*/ GIMT_Encode4(91917), // Rule ID 4983 //
     /*  91890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91898 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  91904 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  91906 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91908 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] })  =>  (NOTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /*  91908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  91911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  91913 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  91915 */     GIR_RootConstrainSelectedInstOperands,
     /*  91916 */     // GIR_Coverage, 4983,
     /*  91916 */     GIR_EraseRootFromParent_Done,
     /*  91917 */   // Label 1432: @91917
     /*  91917 */   GIM_Try, /*On fail goto*//*Label 1433*/ GIMT_Encode4(91974), // Rule ID 3823 //
     /*  91922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91925 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  91929 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91933 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91937 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  91941 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  91957 */     // (xor:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm), V128:{ *:[v8i16] }:$Va)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  91957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  91960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  91962 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  91966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  91970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  91972 */     GIR_RootConstrainSelectedInstOperands,
     /*  91973 */     // GIR_Coverage, 3823,
     /*  91973 */     GIR_EraseRootFromParent_Done,
     /*  91974 */   // Label 1433: @91974
     /*  91974 */   GIM_Try, /*On fail goto*//*Label 1434*/ GIMT_Encode4(92031), // Rule ID 13838 //
     /*  91979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  91982 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  91986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  91990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  91994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /*  91998 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /*  92002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92014 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Va, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm))  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm, V128:{ *:[v8i16] }:$Va)
     /*  92014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92019 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92027 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92029 */     GIR_RootConstrainSelectedInstOperands,
     /*  92030 */     // GIR_Coverage, 13838,
     /*  92030 */     GIR_EraseRootFromParent_Done,
     /*  92031 */   // Label 1434: @92031
     /*  92031 */   GIM_Try, /*On fail goto*//*Label 1435*/ GIMT_Encode4(92054), // Rule ID 5065 //
     /*  92036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92043 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92047 */     // (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)  =>  (EORv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$LHS, V128:{ *:[v8i16] }:$RHS)
     /*  92047 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92052 */     GIR_RootConstrainSelectedInstOperands,
     /*  92053 */     // GIR_Coverage, 5065,
     /*  92053 */     GIR_Done,
     /*  92054 */   // Label 1435: @92054
     /*  92054 */   GIM_Reject,
     /*  92055 */ // Label 1425: @92055
     /*  92055 */ GIM_Reject,
     /*  92056 */ // Label 1344: @92056
     /*  92056 */ GIM_Try, /*On fail goto*//*Label 1436*/ GIMT_Encode4(92747),
     /*  92061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92064 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92067 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92071 */   GIM_Try, /*On fail goto*//*Label 1437*/ GIMT_Encode4(92167), // Rule ID 1157 //
     /*  92076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92087 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92091 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92095 */     // MIs[1] Operand 1
     /*  92095 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92100 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92104 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92108 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92112 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92116 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92121 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92126 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/3, // MIs[3]
     /*  92130 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92136 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/3,
     /*  92138 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /*  92142 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92148 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92150 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  92152 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm), immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92157 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /*  92161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /*  92165 */     GIR_RootConstrainSelectedInstOperands,
     /*  92166 */     // GIR_Coverage, 1157,
     /*  92166 */     GIR_EraseRootFromParent_Done,
     /*  92167 */   // Label 1437: @92167
     /*  92167 */   GIM_Try, /*On fail goto*//*Label 1438*/ GIMT_Encode4(92234), // Rule ID 5030 //
     /*  92172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ICMP),
     /*  92180 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92184 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /*  92188 */     // MIs[1] Operand 1
     /*  92188 */     GIM_CheckCmpPredicate, /*MI*/1, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /*  92193 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  92197 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92203 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/2,
     /*  92205 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  92209 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92215 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92217 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92219 */     // (xor:{ *:[v16i8] } (setcc:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] }), immAllOnesV:{ *:[v16i8] })  =>  (CMTSTv16i8:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rn)
     /*  92219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMTSTv16i8),
     /*  92222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92224 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /*  92232 */     GIR_RootConstrainSelectedInstOperands,
     /*  92233 */     // GIR_Coverage, 5030,
     /*  92233 */     GIR_EraseRootFromParent_Done,
     /*  92234 */   // Label 1438: @92234
     /*  92234 */   GIM_Try, /*On fail goto*//*Label 1439*/ GIMT_Encode4(92319), // Rule ID 13843 //
     /*  92239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92274 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92279 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92283 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92289 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92300 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92302 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92309 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92313 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92317 */     GIR_RootConstrainSelectedInstOperands,
     /*  92318 */     // GIR_Coverage, 13843,
     /*  92318 */     GIR_EraseRootFromParent_Done,
     /*  92319 */   // Label 1439: @92319
     /*  92319 */   GIM_Try, /*On fail goto*//*Label 1440*/ GIMT_Encode4(92404), // Rule ID 13842 //
     /*  92324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92331 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92335 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92339 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92373 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92379 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92385 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92387 */     // (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$Vn)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /*  92394 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92402 */     GIR_RootConstrainSelectedInstOperands,
     /*  92403 */     // GIR_Coverage, 13842,
     /*  92403 */     GIR_EraseRootFromParent_Done,
     /*  92404 */   // Label 1440: @92404
     /*  92404 */   GIM_Try, /*On fail goto*//*Label 1441*/ GIMT_Encode4(92489), // Rule ID 13841 //
     /*  92409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92428 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92440 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92444 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92448 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92453 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92457 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92470 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92472 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$Vm))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92477 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92487 */     GIR_RootConstrainSelectedInstOperands,
     /*  92488 */     // GIR_Coverage, 13841,
     /*  92488 */     GIR_EraseRootFromParent_Done,
     /*  92489 */   // Label 1441: @92489
     /*  92489 */   GIM_Try, /*On fail goto*//*Label 1442*/ GIMT_Encode4(92574), // Rule ID 3826 //
     /*  92494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92497 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92513 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92522 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  92526 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92530 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92534 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92538 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92543 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  92547 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92553 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  92555 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  92557 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vm, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, immAllOnesV:{ *:[v16i8] })))  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /*  92560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92562 */     GIR_RootToRootCopy, /*OpIdx*/1, // Vn
     /*  92564 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /*  92568 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Va
     /*  92572 */     GIR_RootConstrainSelectedInstOperands,
     /*  92573 */     // GIR_Coverage, 3826,
     /*  92573 */     GIR_EraseRootFromParent_Done,
     /*  92574 */   // Label 1442: @92574
     /*  92574 */   GIM_Try, /*On fail goto*//*Label 1443*/ GIMT_Encode4(92609), // Rule ID 973 //
     /*  92579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92586 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92590 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92596 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /*  92598 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92600 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] })  =>  (NOTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /*  92600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOTv16i8),
     /*  92603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  92605 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  92607 */     GIR_RootConstrainSelectedInstOperands,
     /*  92608 */     // GIR_Coverage, 973,
     /*  92608 */     GIR_EraseRootFromParent_Done,
     /*  92609 */   // Label 1443: @92609
     /*  92609 */   GIM_Try, /*On fail goto*//*Label 1444*/ GIMT_Encode4(92666), // Rule ID 3822 //
     /*  92614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92633 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92638 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92647 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92649 */     // (xor:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm), V128:{ *:[v16i8] }:$Va)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92654 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92658 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Va
     /*  92664 */     GIR_RootConstrainSelectedInstOperands,
     /*  92665 */     // GIR_Coverage, 3822,
     /*  92665 */     GIR_EraseRootFromParent_Done,
     /*  92666 */   // Label 1444: @92666
     /*  92666 */   GIM_Try, /*On fail goto*//*Label 1445*/ GIMT_Encode4(92723), // Rule ID 13837 //
     /*  92671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /*  92674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  92682 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92686 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /*  92690 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /*  92694 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  92706 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Va, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm))  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm, V128:{ *:[v16i8] }:$Va)
     /*  92706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /*  92709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /*  92711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /*  92715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /*  92719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Va
     /*  92721 */     GIR_RootConstrainSelectedInstOperands,
     /*  92722 */     // GIR_Coverage, 13837,
     /*  92722 */     GIR_EraseRootFromParent_Done,
     /*  92723 */   // Label 1445: @92723
     /*  92723 */   GIM_Try, /*On fail goto*//*Label 1446*/ GIMT_Encode4(92746), // Rule ID 1600 //
     /*  92728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  92731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  92739 */     // (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (EORv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /*  92739 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /*  92744 */     GIR_RootConstrainSelectedInstOperands,
     /*  92745 */     // GIR_Coverage, 1600,
     /*  92745 */     GIR_Done,
     /*  92746 */   // Label 1446: @92746
     /*  92746 */   GIM_Reject,
     /*  92747 */ // Label 1436: @92747
     /*  92747 */ GIM_Reject,
     /*  92748 */ // Label 1345: @92748
     /*  92748 */ GIM_Try, /*On fail goto*//*Label 1447*/ GIMT_Encode4(92797), // Rule ID 8494 //
     /*  92753 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /*  92759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /*  92762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92766 */   // (xor:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv1i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2)
     /*  92766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92778 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92791 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92793 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92795 */   GIR_RootConstrainSelectedInstOperands,
     /*  92796 */   // GIR_Coverage, 8494,
     /*  92796 */   GIR_EraseRootFromParent_Done,
     /*  92797 */ // Label 1447: @92797
     /*  92797 */ GIM_Reject,
     /*  92798 */ // Label 1346: @92798
     /*  92798 */ GIM_Try, /*On fail goto*//*Label 1448*/ GIMT_Encode4(92847), // Rule ID 8493 //
     /*  92803 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  92806 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /*  92809 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /*  92812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  92816 */   // (xor:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv2i1] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /*  92816 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  92819 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /*  92823 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  92828 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  92831 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  92833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  92836 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  92838 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  92841 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  92843 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  92845 */   GIR_RootConstrainSelectedInstOperands,
     /*  92846 */   // GIR_Coverage, 8493,
     /*  92846 */   GIR_EraseRootFromParent_Done,
     /*  92847 */ // Label 1448: @92847
     /*  92847 */ GIM_Reject,
     /*  92848 */ // Label 1347: @92848
     /*  92848 */ GIM_Try, /*On fail goto*//*Label 1449*/ GIMT_Encode4(94254),
     /*  92853 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92856 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  92863 */   GIM_Try, /*On fail goto*//*Label 1450*/ GIMT_Encode4(92981), // Rule ID 15844 //
     /*  92868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  92891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  92907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  92911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  92915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92919 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  92923 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92929 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  92931 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  92935 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  92939 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  92943 */     // MIs[5] Op3
     /*  92943 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  92948 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  92952 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  92958 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  92960 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  92962 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  92962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  92965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  92967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  92971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  92975 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  92979 */     GIR_RootConstrainSelectedInstOperands,
     /*  92980 */     // GIR_Coverage, 15844,
     /*  92980 */     GIR_EraseRootFromParent_Done,
     /*  92981 */   // Label 1450: @92981
     /*  92981 */   GIM_Try, /*On fail goto*//*Label 1451*/ GIMT_Encode4(93099), // Rule ID 15843 //
     /*  92986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  92989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  92993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  92997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93013 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93017 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  93025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93029 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93033 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93037 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93041 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93047 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93049 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93053 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93057 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93061 */     // MIs[5] Op3
     /*  93061 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93066 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93070 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93076 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93078 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93080 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93089 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  93093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93097 */     GIR_RootConstrainSelectedInstOperands,
     /*  93098 */     // GIR_Coverage, 15843,
     /*  93098 */     GIR_EraseRootFromParent_Done,
     /*  93099 */   // Label 1451: @93099
     /*  93099 */   GIM_Try, /*On fail goto*//*Label 1452*/ GIMT_Encode4(93217), // Rule ID 15842 //
     /*  93104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93119 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93135 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93159 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93165 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93167 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93171 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93175 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93179 */     // MIs[5] Op3
     /*  93179 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93184 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93188 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93194 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93196 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93198 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  93207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93215 */     GIR_RootConstrainSelectedInstOperands,
     /*  93216 */     // GIR_Coverage, 15842,
     /*  93216 */     GIR_EraseRootFromParent_Done,
     /*  93217 */   // Label 1452: @93217
     /*  93217 */   GIM_Try, /*On fail goto*//*Label 1453*/ GIMT_Encode4(93335), // Rule ID 15841 //
     /*  93222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93233 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93237 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93249 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93253 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93257 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93261 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93265 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93269 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93277 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93283 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  93285 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  93289 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93293 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93297 */     // MIs[5] Op3
     /*  93297 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  93302 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93306 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93312 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93314 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93316 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93321 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  93325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  93329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  93333 */     GIR_RootConstrainSelectedInstOperands,
     /*  93334 */     // GIR_Coverage, 15841,
     /*  93334 */     GIR_EraseRootFromParent_Done,
     /*  93335 */   // Label 1453: @93335
     /*  93335 */   GIM_Try, /*On fail goto*//*Label 1454*/ GIMT_Encode4(93453), // Rule ID 15838 //
     /*  93340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93379 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93383 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93387 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93391 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93395 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93399 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93403 */     // MIs[4] Op3
     /*  93403 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93408 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93412 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93420 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93424 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93430 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93432 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93434 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93439 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93447 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93451 */     GIR_RootConstrainSelectedInstOperands,
     /*  93452 */     // GIR_Coverage, 15838,
     /*  93452 */     GIR_EraseRootFromParent_Done,
     /*  93453 */   // Label 1454: @93453
     /*  93453 */   GIM_Try, /*On fail goto*//*Label 1455*/ GIMT_Encode4(93571), // Rule ID 15840 //
     /*  93458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93473 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93493 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93497 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93501 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93505 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93509 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  93513 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93517 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93521 */     // MIs[4] Op3
     /*  93521 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93526 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93530 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93538 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93542 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93548 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93550 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93552 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93557 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93561 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  93565 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93569 */     GIR_RootConstrainSelectedInstOperands,
     /*  93570 */     // GIR_Coverage, 15840,
     /*  93570 */     GIR_EraseRootFromParent_Done,
     /*  93571 */   // Label 1455: @93571
     /*  93571 */   GIM_Try, /*On fail goto*//*Label 1456*/ GIMT_Encode4(93689), // Rule ID 11972 //
     /*  93576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93619 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93623 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93627 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93631 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93635 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93639 */     // MIs[4] Op3
     /*  93639 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  93644 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93648 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93656 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93660 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93668 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93670 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op3), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  93679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93683 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  93687 */     GIR_RootConstrainSelectedInstOperands,
     /*  93688 */     // GIR_Coverage, 11972,
     /*  93688 */     GIR_EraseRootFromParent_Done,
     /*  93689 */   // Label 1456: @93689
     /*  93689 */   GIM_Try, /*On fail goto*//*Label 1457*/ GIMT_Encode4(93807), // Rule ID 15839 //
     /*  93694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  93705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93709 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93713 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93717 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93721 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93725 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93729 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  93733 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93737 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93741 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93745 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  93749 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93753 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93757 */     // MIs[4] Op3
     /*  93757 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  93762 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  93766 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93772 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  93774 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  93778 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93784 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  93786 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  93788 */     // (xor:{ *:[nxv2i64] } (or:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1), (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }))), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  93791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  93797 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  93801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93805 */     GIR_RootConstrainSelectedInstOperands,
     /*  93806 */     // GIR_Coverage, 15839,
     /*  93806 */     GIR_EraseRootFromParent_Done,
     /*  93807 */   // Label 1457: @93807
     /*  93807 */   GIM_Try, /*On fail goto*//*Label 1458*/ GIMT_Encode4(93878), // Rule ID 15704 //
     /*  93812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93815 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93819 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93823 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93827 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93839 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93843 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93847 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93851 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93857 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93859 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93861 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93868 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  93872 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93876 */     GIR_RootConstrainSelectedInstOperands,
     /*  93877 */     // GIR_Coverage, 15704,
     /*  93877 */     GIR_EraseRootFromParent_Done,
     /*  93878 */   // Label 1458: @93878
     /*  93878 */   GIM_Try, /*On fail goto*//*Label 1459*/ GIMT_Encode4(93949), // Rule ID 15703 //
     /*  93883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  93890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93902 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  93906 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93910 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93914 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93918 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93922 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93928 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  93930 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  93932 */     // (xor:{ *:[nxv2i64] } (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })), nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  93932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  93935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  93937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  93939 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  93943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  93947 */     GIR_RootConstrainSelectedInstOperands,
     /*  93948 */     // GIR_Coverage, 15703,
     /*  93948 */     GIR_EraseRootFromParent_Done,
     /*  93949 */   // Label 1459: @93949
     /*  93949 */   GIM_Try, /*On fail goto*//*Label 1460*/ GIMT_Encode4(94020), // Rule ID 15702 //
     /*  93954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  93957 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  93961 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  93965 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93969 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  93977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  93981 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  93985 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  93989 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  93993 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  93999 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94001 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94003 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94018 */     GIR_RootConstrainSelectedInstOperands,
     /*  94019 */     // GIR_Coverage, 15702,
     /*  94019 */     GIR_EraseRootFromParent_Done,
     /*  94020 */   // Label 1460: @94020
     /*  94020 */   GIM_Try, /*On fail goto*//*Label 1461*/ GIMT_Encode4(94091), // Rule ID 11936 //
     /*  94025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94036 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94040 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  94048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94052 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94056 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94064 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94070 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  94072 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  94074 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (and:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, immAllOnesV:{ *:[nxv2i64] })))  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  94077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94085 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  94089 */     GIR_RootConstrainSelectedInstOperands,
     /*  94090 */     // GIR_Coverage, 11936,
     /*  94090 */     GIR_EraseRootFromParent_Done,
     /*  94091 */   // Label 1461: @94091
     /*  94091 */   GIM_Try, /*On fail goto*//*Label 1462*/ GIMT_Encode4(94152), // Rule ID 11971 //
     /*  94096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  94107 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94111 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94115 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /*  94119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  94123 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94129 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  94131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  94133 */     // (xor:{ *:[nxv2i64] } (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), immAllOnesV:{ *:[nxv2i64] })  =>  (NBSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94138 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  94142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  94146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  94150 */     GIR_RootConstrainSelectedInstOperands,
     /*  94151 */     // GIR_Coverage, 11971,
     /*  94151 */     GIR_EraseRootFromParent_Done,
     /*  94152 */   // Label 1462: @94152
     /*  94152 */   GIM_Try, /*On fail goto*//*Label 1463*/ GIMT_Encode4(94195), // Rule ID 13804 //
     /*  94157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94176 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94178 */     // (xor:{ *:[nxv2i64] } (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  94187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  94191 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  94193 */     GIR_RootConstrainSelectedInstOperands,
     /*  94194 */     // GIR_Coverage, 13804,
     /*  94194 */     GIR_EraseRootFromParent_Done,
     /*  94195 */   // Label 1463: @94195
     /*  94195 */   GIM_Try, /*On fail goto*//*Label 1464*/ GIMT_Encode4(94238), // Rule ID 3150 //
     /*  94200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94203 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  94207 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94211 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /*  94215 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /*  94219 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  94221 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /*  94221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  94224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94226 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  94232 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  94236 */     GIR_RootConstrainSelectedInstOperands,
     /*  94237 */     // GIR_Coverage, 3150,
     /*  94237 */     GIR_EraseRootFromParent_Done,
     /*  94238 */   // Label 1464: @94238
     /*  94238 */   GIM_Try, /*On fail goto*//*Label 1465*/ GIMT_Encode4(94253), // Rule ID 7513 //
     /*  94243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94246 */     // (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /*  94246 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  94251 */     GIR_RootConstrainSelectedInstOperands,
     /*  94252 */     // GIR_Coverage, 7513,
     /*  94252 */     GIR_Done,
     /*  94253 */   // Label 1465: @94253
     /*  94253 */   GIM_Reject,
     /*  94254 */ // Label 1449: @94254
     /*  94254 */ GIM_Reject,
     /*  94255 */ // Label 1348: @94255
     /*  94255 */ GIM_Try, /*On fail goto*//*Label 1466*/ GIMT_Encode4(94304), // Rule ID 8492 //
     /*  94260 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  94263 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /*  94266 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /*  94269 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  94273 */   // (xor:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv4i1] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /*  94273 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  94276 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /*  94280 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  94285 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  94288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  94290 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  94293 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  94295 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  94298 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  94300 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  94302 */   GIR_RootConstrainSelectedInstOperands,
     /*  94303 */   // GIR_Coverage, 8492,
     /*  94303 */   GIR_EraseRootFromParent_Done,
     /*  94304 */ // Label 1466: @94304
     /*  94304 */ GIM_Reject,
     /*  94305 */ // Label 1349: @94305
     /*  94305 */ GIM_Try, /*On fail goto*//*Label 1467*/ GIMT_Encode4(95711),
     /*  94310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94313 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  94320 */   GIM_Try, /*On fail goto*//*Label 1468*/ GIMT_Encode4(94438), // Rule ID 15837 //
     /*  94325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94364 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94368 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94372 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94380 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94386 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94388 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94392 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94396 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94400 */     // MIs[5] Op3
     /*  94400 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94405 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94409 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94417 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94419 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94424 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94432 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94436 */     GIR_RootConstrainSelectedInstOperands,
     /*  94437 */     // GIR_Coverage, 15837,
     /*  94437 */     GIR_EraseRootFromParent_Done,
     /*  94438 */   // Label 1468: @94438
     /*  94438 */   GIM_Try, /*On fail goto*//*Label 1469*/ GIMT_Encode4(94556), // Rule ID 15836 //
     /*  94443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94454 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94458 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94462 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94466 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94470 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94474 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94478 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  94482 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94486 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94490 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94494 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94498 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94504 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94506 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94510 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94514 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94518 */     // MIs[5] Op3
     /*  94518 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94523 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94527 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94533 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94535 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94537 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94546 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  94550 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94554 */     GIR_RootConstrainSelectedInstOperands,
     /*  94555 */     // GIR_Coverage, 15836,
     /*  94555 */     GIR_EraseRootFromParent_Done,
     /*  94556 */   // Label 1469: @94556
     /*  94556 */   GIM_Try, /*On fail goto*//*Label 1470*/ GIMT_Encode4(94674), // Rule ID 15835 //
     /*  94561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94576 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94588 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94592 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94596 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94600 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94604 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94608 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94612 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94616 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94622 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94624 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94628 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94632 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94636 */     // MIs[5] Op3
     /*  94636 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94641 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94645 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94651 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94653 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94655 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  94664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94672 */     GIR_RootConstrainSelectedInstOperands,
     /*  94673 */     // GIR_Coverage, 15835,
     /*  94673 */     GIR_EraseRootFromParent_Done,
     /*  94674 */   // Label 1470: @94674
     /*  94674 */   GIM_Try, /*On fail goto*//*Label 1471*/ GIMT_Encode4(94792), // Rule ID 15834 //
     /*  94679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94698 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94702 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94706 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94710 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94714 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  94718 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94722 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94726 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94730 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  94734 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94740 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  94742 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  94746 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94750 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94754 */     // MIs[5] Op3
     /*  94754 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  94759 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94763 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94769 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94771 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94773 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  94782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  94786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  94790 */     GIR_RootConstrainSelectedInstOperands,
     /*  94791 */     // GIR_Coverage, 15834,
     /*  94791 */     GIR_EraseRootFromParent_Done,
     /*  94792 */   // Label 1471: @94792
     /*  94792 */   GIM_Try, /*On fail goto*//*Label 1472*/ GIMT_Encode4(94910), // Rule ID 15831 //
     /*  94797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94840 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94844 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94848 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94852 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94856 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94860 */     // MIs[4] Op3
     /*  94860 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  94865 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94869 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94875 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94877 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94881 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94887 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  94889 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  94891 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  94891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  94894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  94896 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  94900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  94904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  94908 */     GIR_RootConstrainSelectedInstOperands,
     /*  94909 */     // GIR_Coverage, 15831,
     /*  94909 */     GIR_EraseRootFromParent_Done,
     /*  94910 */   // Label 1472: @94910
     /*  94910 */   GIM_Try, /*On fail goto*//*Label 1473*/ GIMT_Encode4(95028), // Rule ID 15833 //
     /*  94915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  94918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  94922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  94926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94934 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  94938 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94942 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94946 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  94954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  94958 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  94962 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94966 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  94970 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  94974 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  94978 */     // MIs[4] Op3
     /*  94978 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  94983 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  94987 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  94993 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  94995 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  94999 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95005 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95007 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95009 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  95022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95026 */     GIR_RootConstrainSelectedInstOperands,
     /*  95027 */     // GIR_Coverage, 15833,
     /*  95027 */     GIR_EraseRootFromParent_Done,
     /*  95028 */   // Label 1473: @95028
     /*  95028 */   GIM_Try, /*On fail goto*//*Label 1474*/ GIMT_Encode4(95146), // Rule ID 11970 //
     /*  95033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95036 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95040 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95044 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95048 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95060 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95064 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95080 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95084 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95088 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95096 */     // MIs[4] Op3
     /*  95096 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  95101 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95105 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95111 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95113 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95117 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95123 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95125 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95127 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op3), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95132 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  95136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  95144 */     GIR_RootConstrainSelectedInstOperands,
     /*  95145 */     // GIR_Coverage, 11970,
     /*  95145 */     GIR_EraseRootFromParent_Done,
     /*  95146 */   // Label 1474: @95146
     /*  95146 */   GIM_Try, /*On fail goto*//*Label 1475*/ GIMT_Encode4(95264), // Rule ID 15832 //
     /*  95151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95170 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95174 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95178 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95182 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95186 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  95190 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95194 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95198 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95202 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95206 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95210 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95214 */     // MIs[4] Op3
     /*  95214 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  95219 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  95223 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95229 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  95231 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95235 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95241 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95243 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95245 */     // (xor:{ *:[nxv4i32] } (or:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1), (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }))), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  95254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  95258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95262 */     GIR_RootConstrainSelectedInstOperands,
     /*  95263 */     // GIR_Coverage, 15832,
     /*  95263 */     GIR_EraseRootFromParent_Done,
     /*  95264 */   // Label 1475: @95264
     /*  95264 */   GIM_Try, /*On fail goto*//*Label 1476*/ GIMT_Encode4(95335), // Rule ID 15701 //
     /*  95269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95300 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95304 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95308 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95314 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95316 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95318 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95333 */     GIR_RootConstrainSelectedInstOperands,
     /*  95334 */     // GIR_Coverage, 15701,
     /*  95334 */     GIR_EraseRootFromParent_Done,
     /*  95335 */   // Label 1476: @95335
     /*  95335 */   GIM_Try, /*On fail goto*//*Label 1477*/ GIMT_Encode4(95406), // Rule ID 15700 //
     /*  95340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95359 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95363 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95367 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95371 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95375 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95379 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95385 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95387 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95389 */     // (xor:{ *:[nxv4i32] } (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })), nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  95396 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95404 */     GIR_RootConstrainSelectedInstOperands,
     /*  95405 */     // GIR_Coverage, 15700,
     /*  95405 */     GIR_EraseRootFromParent_Done,
     /*  95406 */   // Label 1477: @95406
     /*  95406 */   GIM_Try, /*On fail goto*//*Label 1478*/ GIMT_Encode4(95477), // Rule ID 15699 //
     /*  95411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95438 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95442 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95446 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95450 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95456 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95458 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95460 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95465 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95467 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95475 */     GIR_RootConstrainSelectedInstOperands,
     /*  95476 */     // GIR_Coverage, 15699,
     /*  95476 */     GIR_EraseRootFromParent_Done,
     /*  95477 */   // Label 1478: @95477
     /*  95477 */   GIM_Try, /*On fail goto*//*Label 1479*/ GIMT_Encode4(95548), // Rule ID 11934 //
     /*  95482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95501 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  95505 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95509 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95513 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95517 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  95521 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95527 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  95529 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  95531 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (and:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, immAllOnesV:{ *:[nxv4i32] })))  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  95534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  95546 */     GIR_RootConstrainSelectedInstOperands,
     /*  95547 */     // GIR_Coverage, 11934,
     /*  95547 */     GIR_EraseRootFromParent_Done,
     /*  95548 */   // Label 1479: @95548
     /*  95548 */   GIM_Try, /*On fail goto*//*Label 1480*/ GIMT_Encode4(95609), // Rule ID 11969 //
     /*  95553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  95564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95568 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95572 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /*  95576 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  95580 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95586 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  95588 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  95590 */     // (xor:{ *:[nxv4i32] } (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), immAllOnesV:{ *:[nxv4i32] })  =>  (NBSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  95599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  95603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  95607 */     GIR_RootConstrainSelectedInstOperands,
     /*  95608 */     // GIR_Coverage, 11969,
     /*  95608 */     GIR_EraseRootFromParent_Done,
     /*  95609 */   // Label 1480: @95609
     /*  95609 */   GIM_Try, /*On fail goto*//*Label 1481*/ GIMT_Encode4(95652), // Rule ID 13803 //
     /*  95614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95625 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95629 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95633 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95635 */     // (xor:{ *:[nxv4i32] } (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95640 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  95644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  95648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  95650 */     GIR_RootConstrainSelectedInstOperands,
     /*  95651 */     // GIR_Coverage, 13803,
     /*  95651 */     GIR_EraseRootFromParent_Done,
     /*  95652 */   // Label 1481: @95652
     /*  95652 */   GIM_Try, /*On fail goto*//*Label 1482*/ GIMT_Encode4(95695), // Rule ID 3148 //
     /*  95657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  95664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /*  95672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /*  95676 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  95678 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /*  95678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  95681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95683 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95685 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  95689 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  95693 */     GIR_RootConstrainSelectedInstOperands,
     /*  95694 */     // GIR_Coverage, 3148,
     /*  95694 */     GIR_EraseRootFromParent_Done,
     /*  95695 */   // Label 1482: @95695
     /*  95695 */   GIM_Try, /*On fail goto*//*Label 1483*/ GIMT_Encode4(95710), // Rule ID 7512 //
     /*  95700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95703 */     // (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /*  95703 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  95708 */     GIR_RootConstrainSelectedInstOperands,
     /*  95709 */     // GIR_Coverage, 7512,
     /*  95709 */     GIR_Done,
     /*  95710 */   // Label 1483: @95710
     /*  95710 */   GIM_Reject,
     /*  95711 */ // Label 1467: @95711
     /*  95711 */ GIM_Reject,
     /*  95712 */ // Label 1350: @95712
     /*  95712 */ GIM_Try, /*On fail goto*//*Label 1484*/ GIMT_Encode4(95761), // Rule ID 8491 //
     /*  95717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  95720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /*  95723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /*  95726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  95730 */   // (xor:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv8i1] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /*  95730 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  95733 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /*  95737 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  95742 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  95745 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  95747 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  95750 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  95752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  95755 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  95757 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  95759 */   GIR_RootConstrainSelectedInstOperands,
     /*  95760 */   // GIR_Coverage, 8491,
     /*  95760 */   GIR_EraseRootFromParent_Done,
     /*  95761 */ // Label 1484: @95761
     /*  95761 */ GIM_Reject,
     /*  95762 */ // Label 1351: @95762
     /*  95762 */ GIM_Try, /*On fail goto*//*Label 1485*/ GIMT_Encode4(97168),
     /*  95767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  95777 */   GIM_Try, /*On fail goto*//*Label 1486*/ GIMT_Encode4(95895), // Rule ID 15830 //
     /*  95782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95793 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95797 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95809 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95813 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95817 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95821 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95825 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95829 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95833 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95837 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95843 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95845 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95849 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95853 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95857 */     // MIs[5] Op3
     /*  95857 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95862 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95866 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95872 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95874 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95876 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  95885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  95889 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  95893 */     GIR_RootConstrainSelectedInstOperands,
     /*  95894 */     // GIR_Coverage, 15830,
     /*  95894 */     GIR_EraseRootFromParent_Done,
     /*  95895 */   // Label 1486: @95895
     /*  95895 */   GIM_Try, /*On fail goto*//*Label 1487*/ GIMT_Encode4(96013), // Rule ID 15829 //
     /*  95900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  95903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  95907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  95911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95915 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95919 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  95923 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95927 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95931 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  95939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  95943 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95947 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  95951 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  95955 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95961 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  95963 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  95967 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  95971 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  95975 */     // MIs[5] Op3
     /*  95975 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  95980 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  95984 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  95990 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  95992 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  95994 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  95994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  95997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  95999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  96007 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96011 */     GIR_RootConstrainSelectedInstOperands,
     /*  96012 */     // GIR_Coverage, 15829,
     /*  96012 */     GIR_EraseRootFromParent_Done,
     /*  96013 */   // Label 1487: @96013
     /*  96013 */   GIM_Try, /*On fail goto*//*Label 1488*/ GIMT_Encode4(96131), // Rule ID 15828 //
     /*  96018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96045 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96049 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96061 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96065 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96069 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96073 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96079 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96081 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96085 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96089 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96093 */     // MIs[5] Op3
     /*  96093 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96098 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96102 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96108 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96110 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96112 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  96121 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96125 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96129 */     GIR_RootConstrainSelectedInstOperands,
     /*  96130 */     // GIR_Coverage, 15828,
     /*  96130 */     GIR_EraseRootFromParent_Done,
     /*  96131 */   // Label 1488: @96131
     /*  96131 */   GIM_Try, /*On fail goto*//*Label 1489*/ GIMT_Encode4(96249), // Rule ID 15827 //
     /*  96136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96139 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96143 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96147 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96151 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96171 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96175 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96179 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96183 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96187 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96191 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96197 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  96199 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  96203 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96207 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96211 */     // MIs[5] Op3
     /*  96211 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  96216 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96220 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96226 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96228 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96230 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  96239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  96243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  96247 */     GIR_RootConstrainSelectedInstOperands,
     /*  96248 */     // GIR_Coverage, 15827,
     /*  96248 */     GIR_EraseRootFromParent_Done,
     /*  96249 */   // Label 1489: @96249
     /*  96249 */   GIM_Try, /*On fail goto*//*Label 1490*/ GIMT_Encode4(96367), // Rule ID 15824 //
     /*  96254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96293 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96297 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96301 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96305 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96309 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96313 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96317 */     // MIs[4] Op3
     /*  96317 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96322 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96326 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96332 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96334 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96338 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96344 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96346 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96348 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96361 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96365 */     GIR_RootConstrainSelectedInstOperands,
     /*  96366 */     // GIR_Coverage, 15824,
     /*  96366 */     GIR_EraseRootFromParent_Done,
     /*  96367 */   // Label 1490: @96367
     /*  96367 */   GIM_Try, /*On fail goto*//*Label 1491*/ GIMT_Encode4(96485), // Rule ID 15826 //
     /*  96372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96387 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96391 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96395 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96399 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96403 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96407 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96411 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96415 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96419 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96423 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  96427 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96431 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96435 */     // MIs[4] Op3
     /*  96435 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96440 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96444 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96450 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96452 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96456 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96462 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96464 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96466 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96471 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  96479 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96483 */     GIR_RootConstrainSelectedInstOperands,
     /*  96484 */     // GIR_Coverage, 15826,
     /*  96484 */     GIR_EraseRootFromParent_Done,
     /*  96485 */   // Label 1491: @96485
     /*  96485 */   GIM_Try, /*On fail goto*//*Label 1492*/ GIMT_Encode4(96603), // Rule ID 11968 //
     /*  96490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96525 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96529 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96533 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96537 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96541 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96545 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96549 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96553 */     // MIs[4] Op3
     /*  96553 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  96558 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96562 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96568 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96570 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96574 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96580 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96582 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96584 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op3), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  96593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  96601 */     GIR_RootConstrainSelectedInstOperands,
     /*  96602 */     // GIR_Coverage, 11968,
     /*  96602 */     GIR_EraseRootFromParent_Done,
     /*  96603 */   // Label 1492: @96603
     /*  96603 */   GIM_Try, /*On fail goto*//*Label 1493*/ GIMT_Encode4(96721), // Rule ID 15825 //
     /*  96608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  96619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96623 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96627 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96631 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96635 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96639 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96643 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  96647 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96651 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96655 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96659 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  96663 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96667 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96671 */     // MIs[4] Op3
     /*  96671 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  96676 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  96680 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96686 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  96688 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  96692 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96698 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  96700 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  96702 */     // (xor:{ *:[nxv8i16] } (or:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1), (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }))), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  96705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  96711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  96715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96719 */     GIR_RootConstrainSelectedInstOperands,
     /*  96720 */     // GIR_Coverage, 15825,
     /*  96720 */     GIR_EraseRootFromParent_Done,
     /*  96721 */   // Label 1493: @96721
     /*  96721 */   GIM_Try, /*On fail goto*//*Label 1494*/ GIMT_Encode4(96792), // Rule ID 15698 //
     /*  96726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96741 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96745 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96749 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96753 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96757 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96761 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96765 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96771 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96773 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96775 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96782 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96786 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96790 */     GIR_RootConstrainSelectedInstOperands,
     /*  96791 */     // GIR_Coverage, 15698,
     /*  96791 */     GIR_EraseRootFromParent_Done,
     /*  96792 */   // Label 1494: @96792
     /*  96792 */   GIM_Try, /*On fail goto*//*Label 1495*/ GIMT_Encode4(96863), // Rule ID 15697 //
     /*  96797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  96804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96812 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96836 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96842 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96844 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96846 */     // (xor:{ *:[nxv8i16] } (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })), nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  96853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96861 */     GIR_RootConstrainSelectedInstOperands,
     /*  96862 */     // GIR_Coverage, 15697,
     /*  96862 */     GIR_EraseRootFromParent_Done,
     /*  96863 */   // Label 1495: @96863
     /*  96863 */   GIM_Try, /*On fail goto*//*Label 1496*/ GIMT_Encode4(96934), // Rule ID 15696 //
     /*  96868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  96891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96895 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96899 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96907 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96913 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96915 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96917 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96922 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96924 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  96928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  96932 */     GIR_RootConstrainSelectedInstOperands,
     /*  96933 */     // GIR_Coverage, 15696,
     /*  96933 */     GIR_EraseRootFromParent_Done,
     /*  96934 */   // Label 1496: @96934
     /*  96934 */   GIM_Try, /*On fail goto*//*Label 1497*/ GIMT_Encode4(97005), // Rule ID 11932 //
     /*  96939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  96942 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  96946 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  96950 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96954 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96958 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  96962 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  96966 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  96970 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  96974 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  96978 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  96984 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  96986 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  96988 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (and:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, immAllOnesV:{ *:[nxv8i16] })))  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  96988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  96991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  96993 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  96995 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  96999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97003 */     GIR_RootConstrainSelectedInstOperands,
     /*  97004 */     // GIR_Coverage, 11932,
     /*  97004 */     GIR_EraseRootFromParent_Done,
     /*  97005 */   // Label 1497: @97005
     /*  97005 */   GIM_Try, /*On fail goto*//*Label 1498*/ GIMT_Encode4(97066), // Rule ID 11967 //
     /*  97010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97013 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97017 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  97021 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97025 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97029 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /*  97033 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  97037 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97043 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  97045 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  97047 */     // (xor:{ *:[nxv8i16] } (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), immAllOnesV:{ *:[nxv8i16] })  =>  (NBSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  97056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  97060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  97064 */     GIR_RootConstrainSelectedInstOperands,
     /*  97065 */     // GIR_Coverage, 11967,
     /*  97065 */     GIR_EraseRootFromParent_Done,
     /*  97066 */   // Label 1498: @97066
     /*  97066 */   GIM_Try, /*On fail goto*//*Label 1499*/ GIMT_Encode4(97109), // Rule ID 13802 //
     /*  97071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97092 */     // (xor:{ *:[nxv8i16] } (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  97101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  97105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  97107 */     GIR_RootConstrainSelectedInstOperands,
     /*  97108 */     // GIR_Coverage, 13802,
     /*  97108 */     GIR_EraseRootFromParent_Done,
     /*  97109 */   // Label 1499: @97109
     /*  97109 */   GIM_Try, /*On fail goto*//*Label 1500*/ GIMT_Encode4(97152), // Rule ID 3146 //
     /*  97114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97117 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  97121 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97125 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /*  97129 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /*  97133 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  97135 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /*  97135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  97138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97142 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  97146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  97150 */     GIR_RootConstrainSelectedInstOperands,
     /*  97151 */     // GIR_Coverage, 3146,
     /*  97151 */     GIR_EraseRootFromParent_Done,
     /*  97152 */   // Label 1500: @97152
     /*  97152 */   GIM_Try, /*On fail goto*//*Label 1501*/ GIMT_Encode4(97167), // Rule ID 7511 //
     /*  97157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97160 */     // (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /*  97160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  97165 */     GIR_RootConstrainSelectedInstOperands,
     /*  97166 */     // GIR_Coverage, 7511,
     /*  97166 */     GIR_Done,
     /*  97167 */   // Label 1501: @97167
     /*  97167 */   GIM_Reject,
     /*  97168 */ // Label 1485: @97168
     /*  97168 */ GIM_Reject,
     /*  97169 */ // Label 1352: @97169
     /*  97169 */ GIM_Try, /*On fail goto*//*Label 1502*/ GIMT_Encode4(97218), // Rule ID 8490 //
     /*  97174 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  97177 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /*  97180 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /*  97183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /*  97187 */   // (xor:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (EOR_PPzPP:{ *:[nxv16i1] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /*  97187 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /*  97190 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /*  97194 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  97199 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /*  97202 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  97204 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /*  97207 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /*  97209 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  97212 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  97214 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /*  97216 */   GIR_RootConstrainSelectedInstOperands,
     /*  97217 */   // GIR_Coverage, 8490,
     /*  97217 */   GIR_EraseRootFromParent_Done,
     /*  97218 */ // Label 1502: @97218
     /*  97218 */ GIM_Reject,
     /*  97219 */ // Label 1353: @97219
     /*  97219 */ GIM_Try, /*On fail goto*//*Label 1503*/ GIMT_Encode4(98625),
     /*  97224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /*  97234 */   GIM_Try, /*On fail goto*//*Label 1504*/ GIMT_Encode4(97352), // Rule ID 15823 //
     /*  97239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97266 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97270 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97274 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97278 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97282 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97286 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97290 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97294 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97300 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97302 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97306 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97310 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97314 */     // MIs[5] Op3
     /*  97314 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97319 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97323 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97329 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97331 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97333 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97350 */     GIR_RootConstrainSelectedInstOperands,
     /*  97351 */     // GIR_Coverage, 15823,
     /*  97351 */     GIR_EraseRootFromParent_Done,
     /*  97352 */   // Label 1504: @97352
     /*  97352 */   GIM_Try, /*On fail goto*//*Label 1505*/ GIMT_Encode4(97470), // Rule ID 15822 //
     /*  97357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97384 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97388 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97392 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  97396 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97400 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97404 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97408 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97412 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97418 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97420 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97424 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97428 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97432 */     // MIs[5] Op3
     /*  97432 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97437 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97441 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97447 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97449 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97451 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97460 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op2
     /*  97464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97468 */     GIR_RootConstrainSelectedInstOperands,
     /*  97469 */     // GIR_Coverage, 15822,
     /*  97469 */     GIR_EraseRootFromParent_Done,
     /*  97470 */   // Label 1505: @97470
     /*  97470 */   GIM_Try, /*On fail goto*//*Label 1506*/ GIMT_Encode4(97588), // Rule ID 15821 //
     /*  97475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97490 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97502 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97506 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97522 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97526 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97530 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97536 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97538 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97542 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97546 */     GIM_CheckType, /*MI*/5, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97550 */     // MIs[5] Op3
     /*  97550 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97555 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97559 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97565 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97567 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97569 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/2, // Op1
     /*  97578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97586 */     GIR_RootConstrainSelectedInstOperands,
     /*  97587 */     // GIR_Coverage, 15821,
     /*  97587 */     GIR_EraseRootFromParent_Done,
     /*  97588 */   // Label 1506: @97588
     /*  97588 */   GIM_Try, /*On fail goto*//*Label 1507*/ GIMT_Encode4(97706), // Rule ID 15820 //
     /*  97593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97608 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97612 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97616 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97620 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97624 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97628 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  97632 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97636 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97640 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97644 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  97648 */     GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97654 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  97656 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/1, /*OpIdx*/2, // MIs[5]
     /*  97660 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97664 */     GIM_CheckType, /*MI*/5, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97668 */     // MIs[5] Op3
     /*  97668 */     GIM_CheckIsSameOperand, /*MI*/5, /*OpIdx*/2, /*OtherMI*/3, /*OtherOpIdx*/1,
     /*  97673 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97677 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97683 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97685 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97687 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/5, /*OpIdx*/1, // Op1
     /*  97696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op2
     /*  97700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op3
     /*  97704 */     GIR_RootConstrainSelectedInstOperands,
     /*  97705 */     // GIR_Coverage, 15820,
     /*  97705 */     GIR_EraseRootFromParent_Done,
     /*  97706 */   // Label 1507: @97706
     /*  97706 */   GIM_Try, /*On fail goto*//*Label 1508*/ GIMT_Encode4(97824), // Rule ID 15817 //
     /*  97711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97714 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97718 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97722 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97726 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97730 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97734 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97738 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97742 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97754 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97758 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97762 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97766 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97770 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97774 */     // MIs[4] Op3
     /*  97774 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  97779 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97783 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97789 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97791 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97795 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97801 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97803 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97805 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  97814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  97822 */     GIR_RootConstrainSelectedInstOperands,
     /*  97823 */     // GIR_Coverage, 15817,
     /*  97823 */     GIR_EraseRootFromParent_Done,
     /*  97824 */   // Label 1508: @97824
     /*  97824 */   GIM_Try, /*On fail goto*//*Label 1509*/ GIMT_Encode4(97942), // Rule ID 15819 //
     /*  97829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97840 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97844 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97848 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97852 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97856 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97860 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97880 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  97884 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  97888 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97892 */     // MIs[4] Op3
     /*  97892 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  97897 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  97901 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97907 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  97909 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  97913 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  97919 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  97921 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  97923 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  97923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  97926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  97928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  97932 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Op2
     /*  97936 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  97940 */     GIR_RootConstrainSelectedInstOperands,
     /*  97941 */     // GIR_Coverage, 15819,
     /*  97941 */     GIR_EraseRootFromParent_Done,
     /*  97942 */   // Label 1509: @97942
     /*  97942 */   GIM_Try, /*On fail goto*//*Label 1510*/ GIMT_Encode4(98060), // Rule ID 11966 //
     /*  97947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  97950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  97954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  97958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  97970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97982 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  97986 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  97990 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  97994 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  97998 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98002 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98006 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98010 */     // MIs[4] Op3
     /*  98010 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/2,
     /*  98015 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98019 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98025 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98027 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98031 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98037 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98039 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98041 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op3), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op1
     /*  98050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98054 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op3
     /*  98058 */     GIR_RootConstrainSelectedInstOperands,
     /*  98059 */     // GIR_Coverage, 11966,
     /*  98059 */     GIR_EraseRootFromParent_Done,
     /*  98060 */   // Label 1510: @98060
     /*  98060 */   GIM_Try, /*On fail goto*//*Label 1511*/ GIMT_Encode4(98178), // Rule ID 15818 //
     /*  98065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /*  98076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98100 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /*  98104 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98108 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98112 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98116 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  98120 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98124 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98128 */     // MIs[4] Op3
     /*  98128 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/2, /*OtherOpIdx*/1,
     /*  98133 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /*  98137 */     GIM_CheckOpcodeIsEither, /*MI*/5, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98143 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/5,
     /*  98145 */     GIM_RecordInsn, /*DefineMI*/6, /*MI*/0, /*OpIdx*/2, // MIs[6]
     /*  98149 */     GIM_CheckOpcodeIsEither, /*MI*/6, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98155 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/6,
     /*  98157 */     GIM_CheckIsSafeToFold, /*NumInsns*/6,
     /*  98159 */     // (xor:{ *:[nxv16i8] } (or:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1), (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }))), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98164 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Op1
     /*  98168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Op2
     /*  98172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98176 */     GIR_RootConstrainSelectedInstOperands,
     /*  98177 */     // GIR_Coverage, 15818,
     /*  98177 */     GIR_EraseRootFromParent_Done,
     /*  98178 */   // Label 1511: @98178
     /*  98178 */   GIM_Try, /*On fail goto*//*Label 1512*/ GIMT_Encode4(98249), // Rule ID 15695 //
     /*  98183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98202 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98206 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98210 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98214 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98218 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98222 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98228 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98230 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98232 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98247 */     GIR_RootConstrainSelectedInstOperands,
     /*  98248 */     // GIR_Coverage, 15695,
     /*  98248 */     GIR_EraseRootFromParent_Done,
     /*  98249 */   // Label 1512: @98249
     /*  98249 */   GIM_Try, /*On fail goto*//*Label 1513*/ GIMT_Encode4(98320), // Rule ID 15694 //
     /*  98254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98257 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98261 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98265 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98269 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98281 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98285 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98289 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98293 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98299 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98303 */     // (xor:{ *:[nxv16i8] } (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })), nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /*  98310 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98318 */     GIR_RootConstrainSelectedInstOperands,
     /*  98319 */     // GIR_Coverage, 15694,
     /*  98319 */     GIR_EraseRootFromParent_Done,
     /*  98320 */   // Label 1513: @98320
     /*  98320 */   GIM_Try, /*On fail goto*//*Label 1514*/ GIMT_Encode4(98391), // Rule ID 15693 //
     /*  98325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98340 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98344 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  98348 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98352 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98356 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98360 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98364 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98370 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98372 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98374 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98389 */     GIR_RootConstrainSelectedInstOperands,
     /*  98390 */     // GIR_Coverage, 15693,
     /*  98390 */     GIR_EraseRootFromParent_Done,
     /*  98391 */   // Label 1514: @98391
     /*  98391 */   GIM_Try, /*On fail goto*//*Label 1515*/ GIMT_Encode4(98462), // Rule ID 11930 //
     /*  98396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /*  98407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /*  98419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98431 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /*  98435 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98441 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /*  98443 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  98445 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (and:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, immAllOnesV:{ *:[nxv16i8] })))  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /*  98448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Op3
     /*  98460 */     GIR_RootConstrainSelectedInstOperands,
     /*  98461 */     // GIR_Coverage, 11930,
     /*  98461 */     GIR_EraseRootFromParent_Done,
     /*  98462 */   // Label 1515: @98462
     /*  98462 */   GIM_Try, /*On fail goto*//*Label 1516*/ GIMT_Encode4(98523), // Rule ID 11965 //
     /*  98467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_BSP),
     /*  98478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98486 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /*  98490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /*  98494 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98500 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /*  98502 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  98504 */     // (xor:{ *:[nxv16i8] } (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), immAllOnesV:{ *:[nxv16i8] })  =>  (NBSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NBSL_ZZZZ),
     /*  98507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98509 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op1
     /*  98513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Op2
     /*  98517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /*  98521 */     GIR_RootConstrainSelectedInstOperands,
     /*  98522 */     // GIR_Coverage, 11965,
     /*  98522 */     GIR_EraseRootFromParent_Done,
     /*  98523 */   // Label 1516: @98523
     /*  98523 */   GIM_Try, /*On fail goto*//*Label 1517*/ GIMT_Encode4(98566), // Rule ID 13801 //
     /*  98528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  98535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98547 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98549 */     // (xor:{ *:[nxv16i8] } (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98554 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /*  98558 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /*  98562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /*  98564 */     GIR_RootConstrainSelectedInstOperands,
     /*  98565 */     // GIR_Coverage, 13801,
     /*  98565 */     GIR_EraseRootFromParent_Done,
     /*  98566 */   // Label 1517: @98566
     /*  98566 */   GIM_Try, /*On fail goto*//*Label 1518*/ GIMT_Encode4(98609), // Rule ID 3144 //
     /*  98571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /*  98574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  98582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /*  98586 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /*  98590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98592 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3))  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /*  98592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /*  98595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /*  98597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /*  98599 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /*  98603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op3
     /*  98607 */     GIR_RootConstrainSelectedInstOperands,
     /*  98608 */     // GIR_Coverage, 3144,
     /*  98608 */     GIR_EraseRootFromParent_Done,
     /*  98609 */   // Label 1518: @98609
     /*  98609 */   GIM_Try, /*On fail goto*//*Label 1519*/ GIMT_Encode4(98624), // Rule ID 7510 //
     /*  98614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /*  98617 */     // (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EOR_ZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /*  98617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::EOR_ZZZ),
     /*  98622 */     GIR_RootConstrainSelectedInstOperands,
     /*  98623 */     // GIR_Coverage, 7510,
     /*  98623 */     GIR_Done,
     /*  98624 */   // Label 1519: @98624
     /*  98624 */   GIM_Reject,
     /*  98625 */ // Label 1503: @98625
     /*  98625 */ GIM_Reject,
     /*  98626 */ // Label 1354: @98626
     /*  98626 */ GIM_Reject,
     /*  98627 */ // Label 8: @98627
     /*  98627 */ GIM_Try, /*On fail goto*//*Label 1520*/ GIMT_Encode4(106150),
     /*  98632 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /*  98635 */   GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(23), /*)*//*default:*//*Label 1532*/ GIMT_Encode4(106149),
     /*  98646 */   /*GILLT_v2s64*//*Label 1521*/ GIMT_Encode4(98714), GIMT_Encode4(0),
     /*  98654 */   /*GILLT_v4s32*//*Label 1522*/ GIMT_Encode4(99235), GIMT_Encode4(0),
     /*  98662 */   /*GILLT_v8s16*//*Label 1523*/ GIMT_Encode4(101647),
     /*  98666 */   /*GILLT_v16s8*//*Label 1524*/ GIMT_Encode4(104056), GIMT_Encode4(0),
     /*  98674 */   /*GILLT_nxv2s1*//*Label 1525*/ GIMT_Encode4(105967), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /*  98690 */   /*GILLT_nxv4s1*//*Label 1526*/ GIMT_Encode4(105993),
     /*  98694 */   /*GILLT_nxv4s16*//*Label 1527*/ GIMT_Encode4(106019),
     /*  98698 */   /*GILLT_nxv4s32*//*Label 1528*/ GIMT_Encode4(106045),
     /*  98702 */   /*GILLT_nxv8s1*//*Label 1529*/ GIMT_Encode4(106071),
     /*  98706 */   /*GILLT_nxv8s16*//*Label 1530*/ GIMT_Encode4(106097),
     /*  98710 */   /*GILLT_nxv16s1*//*Label 1531*/ GIMT_Encode4(106123),
     /*  98714 */   // Label 1521: @98714
     /*  98714 */   GIM_Try, /*On fail goto*//*Label 1533*/ GIMT_Encode4(99234),
     /*  98719 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /*  98722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /*  98725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98733 */     GIM_Try, /*On fail goto*//*Label 1534*/ GIMT_Encode4(98795), // Rule ID 5822 //
     /*  98738 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98742 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98748 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98750 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98752 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1i64] }:$Rn), dsub:{ *:[i32] })
     /*  98752 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98755 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98759 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98764 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98768 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98770 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98773 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98775 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98781 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98784 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98789 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98794 */       // GIR_Coverage, 5822,
     /*  98794 */       GIR_EraseRootFromParent_Done,
     /*  98795 */     // Label 1534: @98795
     /*  98795 */     GIM_Try, /*On fail goto*//*Label 1535*/ GIMT_Encode4(98857), // Rule ID 5826 //
     /*  98800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98804 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  98810 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /*  98812 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98814 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v1f64] }:$Rn), dsub:{ *:[i32] })
     /*  98814 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /*  98817 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /*  98821 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98826 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /*  98830 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98832 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  98835 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98837 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  98840 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98843 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98846 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98851 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98856 */       // GIR_Coverage, 5826,
     /*  98856 */       GIR_EraseRootFromParent_Done,
     /*  98857 */     // Label 1535: @98857
     /*  98857 */     GIM_Try, /*On fail goto*//*Label 1536*/ GIMT_Encode4(98915), // Rule ID 5823 //
     /*  98862 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98866 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98870 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98872 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rn, (undef:{ *:[v1i64] }))  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] })
     /*  98872 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98875 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98879 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98884 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98886 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98889 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98891 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98894 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98896 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98899 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98904 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98909 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98914 */       // GIR_Coverage, 5823,
     /*  98914 */       GIR_EraseRootFromParent_Done,
     /*  98915 */     // Label 1536: @98915
     /*  98915 */     GIM_Try, /*On fail goto*//*Label 1537*/ GIMT_Encode4(98973), // Rule ID 5827 //
     /*  98920 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  98924 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /*  98928 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  98930 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rn, (undef:{ *:[v1f64] }))  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] })
     /*  98930 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /*  98933 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98937 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98942 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /*  98944 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  98947 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  98949 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  98952 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /*  98954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /*  98957 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98962 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  98967 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98972 */       // GIR_Coverage, 5827,
     /*  98972 */       GIR_EraseRootFromParent_Done,
     /*  98973 */     // Label 1537: @98973
     /*  98973 */     GIM_Try, /*On fail goto*//*Label 1538*/ GIMT_Encode4(99103), // Rule ID 5821 //
     /*  98978 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  98982 */       // (concat_vectors:{ *:[v2i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn)  =>  (INSvi64lane:{ *:[v2i64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  98982 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  98985 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  98989 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  98994 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  98996 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  98999 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99003 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99008 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99011 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99015 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99018 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99023 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99028 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99033 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99036 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99040 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99045 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99047 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99050 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99054 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99059 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99062 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99066 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99069 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99074 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99079 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99084 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99087 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99089 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99092 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99095 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99098 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99101 */       GIR_RootConstrainSelectedInstOperands,
     /*  99102 */       // GIR_Coverage, 5821,
     /*  99102 */       GIR_EraseRootFromParent_Done,
     /*  99103 */     // Label 1538: @99103
     /*  99103 */     GIM_Try, /*On fail goto*//*Label 1539*/ GIMT_Encode4(99233), // Rule ID 5825 //
     /*  99108 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99112 */       // (concat_vectors:{ *:[v2f64] } V64:{ *:[v1f64] }:$Rd, V64:{ *:[v1f64] }:$Rn)  =>  (INSvi64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /*  99112 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /*  99115 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99119 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99124 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /*  99126 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /*  99129 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99133 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99138 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /*  99141 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /*  99145 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /*  99148 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99153 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99158 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99163 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99166 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99170 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99175 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99177 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99180 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99184 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99189 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99192 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99196 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99199 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99204 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99209 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99214 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99217 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99219 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99222 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99225 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99228 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99231 */       GIR_RootConstrainSelectedInstOperands,
     /*  99232 */       // GIR_Coverage, 5825,
     /*  99232 */       GIR_EraseRootFromParent_Done,
     /*  99233 */     // Label 1539: @99233
     /*  99233 */     GIM_Reject,
     /*  99234 */   // Label 1533: @99234
     /*  99234 */   GIM_Reject,
     /*  99235 */   // Label 1522: @99235
     /*  99235 */   GIM_Try, /*On fail goto*//*Label 1540*/ GIMT_Encode4(101646),
     /*  99240 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /*  99243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /*  99246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99250 */     GIM_Try, /*On fail goto*//*Label 1541*/ GIMT_Encode4(99379), // Rule ID 5445 //
     /*  99255 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99259 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99263 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99267 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99271 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99275 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99279 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99283 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99287 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /*  99291 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99295 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99299 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99304 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /*  99308 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /*  99314 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /*  99316 */       // MIs[2] Operand 2
     /*  99316 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99327 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99329 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /*  99329 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99332 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99336 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99341 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99344 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99348 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99351 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99356 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99361 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99364 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99366 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99369 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99373 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99377 */       GIR_RootConstrainSelectedInstOperands,
     /*  99378 */       // GIR_Coverage, 5445,
     /*  99378 */       GIR_EraseRootFromParent_Done,
     /*  99379 */     // Label 1541: @99379
     /*  99379 */     GIM_Try, /*On fail goto*//*Label 1542*/ GIMT_Encode4(99501), // Rule ID 5441 //
     /*  99384 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99388 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99392 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99396 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99400 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99404 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99408 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99412 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99416 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /*  99420 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99424 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99428 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99433 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99438 */       // MIs[2] Operand 2
     /*  99438 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99449 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99451 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99451 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99454 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99458 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99463 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99466 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99470 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99473 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99478 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99483 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /*  99486 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99488 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99491 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99495 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99499 */       GIR_RootConstrainSelectedInstOperands,
     /*  99500 */       // GIR_Coverage, 5441,
     /*  99500 */       GIR_EraseRootFromParent_Done,
     /*  99501 */     // Label 1542: @99501
     /*  99501 */     GIM_Try, /*On fail goto*//*Label 1543*/ GIMT_Encode4(99623), // Rule ID 5443 //
     /*  99506 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99510 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99514 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99518 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99522 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99526 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99530 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99534 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /*  99538 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /*  99542 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99546 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99550 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99555 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99560 */       // MIs[2] Operand 2
     /*  99560 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99571 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /*  99573 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] })))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /*  99573 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99576 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /*  99580 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99585 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /*  99588 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /*  99592 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99595 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99600 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99605 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /*  99608 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99610 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99613 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /*  99617 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /*  99621 */       GIR_RootConstrainSelectedInstOperands,
     /*  99622 */       // GIR_Coverage, 5443,
     /*  99622 */       GIR_EraseRootFromParent_Done,
     /*  99623 */     // Label 1543: @99623
     /*  99623 */     GIM_Try, /*On fail goto*//*Label 1544*/ GIMT_Encode4(99725), // Rule ID 5591 //
     /*  99628 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /*  99632 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99636 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99640 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /*  99644 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99648 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99652 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99657 */       // MIs[2] Operand 2
     /*  99657 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(32),
     /*  99668 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /*  99672 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /*  99676 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99680 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /*  99684 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /*  99688 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /*  99692 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99697 */       // MIs[4] Operand 2
     /*  99697 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(32),
     /*  99708 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /*  99710 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })), (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vm, 32:{ *:[i32] })))  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /*  99710 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /*  99713 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /*  99715 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /*  99719 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /*  99723 */       GIR_RootConstrainSelectedInstOperands,
     /*  99724 */       // GIR_Coverage, 5591,
     /*  99724 */       GIR_EraseRootFromParent_Done,
     /*  99725 */     // Label 1544: @99725
     /*  99725 */     GIM_Try, /*On fail goto*//*Label 1545*/ GIMT_Encode4(99854), // Rule ID 6377 //
     /*  99730 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99734 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99738 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99742 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99745 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99750 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99754 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99758 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99763 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 32,
     /*  99767 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /*  99769 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] }))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /*  99769 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v2s64,
     /*  99772 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /*  99776 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99781 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /*  99784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /*  99786 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99789 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /*  99793 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99798 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /*  99800 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /*  99803 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /*  99807 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /*  99812 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /*  99815 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /*  99819 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /*  99822 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99827 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99832 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99837 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /*  99840 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99842 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /*  99845 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /*  99849 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /*  99852 */       GIR_RootConstrainSelectedInstOperands,
     /*  99853 */       // GIR_Coverage, 6377,
     /*  99853 */       GIR_EraseRootFromParent_Done,
     /*  99854 */     // Label 1545: @99854
     /*  99854 */     GIM_Try, /*On fail goto*//*Label 1546*/ GIMT_Encode4(99896), // Rule ID 5832 //
     /*  99859 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99866 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /*  99873 */       // (concat_vectors:{ *:[v4i32] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (INSvi64lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })
     /*  99873 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99876 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99878 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99883 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99886 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99891 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99894 */       GIR_RootConstrainSelectedInstOperands,
     /*  99895 */       // GIR_Coverage, 5832,
     /*  99895 */       GIR_EraseRootFromParent_Done,
     /*  99896 */     // Label 1546: @99896
     /*  99896 */     GIM_Try, /*On fail goto*//*Label 1547*/ GIMT_Encode4(99938), // Rule ID 5836 //
     /*  99901 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99908 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /*  99915 */       // (concat_vectors:{ *:[v4f32] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn), (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm))  =>  (INSvi64lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] })
     /*  99915 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /*  99918 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /*  99920 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /*  99925 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /*  99928 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /*  99933 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /*  99936 */       GIR_RootConstrainSelectedInstOperands,
     /*  99937 */       // GIR_Coverage, 5836,
     /*  99937 */       GIR_EraseRootFromParent_Done,
     /*  99938 */     // Label 1547: @99938
     /*  99938 */     GIM_Try, /*On fail goto*//*Label 1548*/ GIMT_Encode4(100061), // Rule ID 2574 //
     /*  99943 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /*  99946 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /*  99950 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /*  99954 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /*  99958 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /*  99961 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /*  99966 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /*  99970 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /*  99974 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /*  99979 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /*  99983 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /*  99987 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /*  99991 */       // MIs[2] Operand 1
     /*  99991 */       // No operand predicates
     /*  99991 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /*  99993 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (RSHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /*  99993 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /*  99996 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100000 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100005 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100007 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100010 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100014 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100019 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100022 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100026 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100029 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100044 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i32_shift),
     /* 100047 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100049 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100052 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100056 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 100059 */       GIR_RootConstrainSelectedInstOperands,
     /* 100060 */       // GIR_Coverage, 2574,
     /* 100060 */       GIR_EraseRootFromParent_Done,
     /* 100061 */     // Label 1548: @100061
     /* 100061 */     GIM_Try, /*On fail goto*//*Label 1549*/ GIMT_Encode4(100184), // Rule ID 6347 //
     /* 100066 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100085 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100089 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 100093 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100097 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100102 */       // MIs[2] imm
     /* 100102 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100106 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100110 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100114 */       // MIs[3] Operand 1
     /* 100114 */       // No operand predicates
     /* 100114 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100116 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 100116 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100119 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100123 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100128 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100130 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100133 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100137 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100142 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100145 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100149 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100152 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100157 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100162 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100167 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100170 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100172 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100175 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100179 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100182 */       GIR_RootConstrainSelectedInstOperands,
     /* 100183 */       // GIR_Coverage, 6347,
     /* 100183 */       GIR_EraseRootFromParent_Done,
     /* 100184 */     // Label 1549: @100184
     /* 100184 */     GIM_Try, /*On fail goto*//*Label 1550*/ GIMT_Encode4(100304), // Rule ID 6383 //
     /* 100189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100201 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100205 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 100209 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 100213 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100217 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100222 */       // MIs[2] imm
     /* 100222 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 100226 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 100230 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 100234 */       // MIs[3] Operand 1
     /* 100234 */       // No operand predicates
     /* 100234 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 100236 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)))  =>  (SHRNv4i32_shift:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 100236 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100239 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100243 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100248 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100250 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100253 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100257 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100262 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100265 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100269 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100272 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100277 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100282 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100287 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i32_shift),
     /* 100290 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100292 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100295 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 100299 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 100302 */       GIR_RootConstrainSelectedInstOperands,
     /* 100303 */       // GIR_Coverage, 6383,
     /* 100303 */       GIR_EraseRootFromParent_Done,
     /* 100304 */     // Label 1550: @100304
     /* 100304 */     GIM_Try, /*On fail goto*//*Label 1551*/ GIMT_Encode4(100421), // Rule ID 2497 //
     /* 100309 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100312 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100316 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100320 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100324 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100327 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 100332 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100336 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100340 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100345 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100350 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100352 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (ADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100352 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100355 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100359 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100364 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100366 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100369 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100373 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100378 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100381 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100385 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100388 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100393 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100398 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100403 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v4i32),
     /* 100406 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100408 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100411 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100415 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100419 */       GIR_RootConstrainSelectedInstOperands,
     /* 100420 */       // GIR_Coverage, 2497,
     /* 100420 */       GIR_EraseRootFromParent_Done,
     /* 100421 */     // Label 1551: @100421
     /* 100421 */     GIM_Try, /*On fail goto*//*Label 1552*/ GIMT_Encode4(100538), // Rule ID 5361 //
     /* 100426 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100429 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100433 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100437 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100441 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100444 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 100449 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100453 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100457 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100462 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100467 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100469 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (SUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100469 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100472 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100476 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100481 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100483 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100486 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100490 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100495 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100498 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100502 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100505 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100510 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100515 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100520 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v4i32),
     /* 100523 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100525 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100528 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100532 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100536 */       GIR_RootConstrainSelectedInstOperands,
     /* 100537 */       // GIR_Coverage, 5361,
     /* 100537 */       GIR_EraseRootFromParent_Done,
     /* 100538 */     // Label 1552: @100538
     /* 100538 */     GIM_Try, /*On fail goto*//*Label 1553*/ GIMT_Encode4(100655), // Rule ID 5364 //
     /* 100543 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100546 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100550 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100554 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100558 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100561 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 100566 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100570 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100574 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100584 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100586 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RADDHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100586 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100589 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100593 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100598 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100600 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100603 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100607 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100612 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100615 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100619 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100622 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100627 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100632 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100637 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v4i32),
     /* 100640 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100642 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100645 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100649 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100653 */       GIR_RootConstrainSelectedInstOperands,
     /* 100654 */       // GIR_Coverage, 5364,
     /* 100654 */       GIR_EraseRootFromParent_Done,
     /* 100655 */     // Label 1553: @100655
     /* 100655 */     GIM_Try, /*On fail goto*//*Label 1554*/ GIMT_Encode4(100772), // Rule ID 5367 //
     /* 100660 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100663 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100667 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100671 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100675 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 100678 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 100683 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100687 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 100691 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100696 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100701 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100703 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm))  =>  (RSUBHNv2i64_v4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 100703 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100706 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100710 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100715 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100717 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100720 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100724 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100729 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100732 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100736 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100739 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100744 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100749 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100754 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v4i32),
     /* 100757 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100759 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100762 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100766 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 100770 */       GIR_RootConstrainSelectedInstOperands,
     /* 100771 */       // GIR_Coverage, 5367,
     /* 100771 */       GIR_EraseRootFromParent_Done,
     /* 100772 */     // Label 1554: @100772
     /* 100772 */     GIM_Try, /*On fail goto*//*Label 1555*/ GIMT_Encode4(100876), // Rule ID 2493 //
     /* 100777 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 100780 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100784 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100788 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 100792 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 100795 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 100800 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 100804 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100809 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100811 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn))  =>  (FCVTXNv4f32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 100811 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 100814 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 100818 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100823 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 100825 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 100828 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 100832 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100837 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 100840 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 100844 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 100847 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100852 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100857 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100862 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv4f32),
     /* 100865 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100867 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100870 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 100874 */       GIR_RootConstrainSelectedInstOperands,
     /* 100875 */       // GIR_Coverage, 2493,
     /* 100875 */       GIR_EraseRootFromParent_Done,
     /* 100876 */     // Label 1555: @100876
     /* 100876 */     GIM_Try, /*On fail goto*//*Label 1556*/ GIMT_Encode4(100932), // Rule ID 5524 //
     /* 100881 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 100885 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100889 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100893 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100898 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 100902 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 100906 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 100910 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100915 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 100917 */       // (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm))  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 100917 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 100920 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 100922 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 100926 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 100930 */       GIR_RootConstrainSelectedInstOperands,
     /* 100931 */       // GIR_Coverage, 5524,
     /* 100931 */       GIR_EraseRootFromParent_Done,
     /* 100932 */     // Label 1556: @100932
     /* 100932 */     GIM_Try, /*On fail goto*//*Label 1557*/ GIMT_Encode4(100998), // Rule ID 5830 //
     /* 100937 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100941 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 100945 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 100951 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 100953 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 100955 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 100955 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 100958 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 100962 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 100967 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 100971 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 100973 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 100976 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 100978 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 100981 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 100984 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 100987 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 100992 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 100997 */       // GIR_Coverage, 5830,
     /* 100997 */       GIR_EraseRootFromParent_Done,
     /* 100998 */     // Label 1557: @100998
     /* 100998 */     GIM_Try, /*On fail goto*//*Label 1558*/ GIMT_Encode4(101064), // Rule ID 5834 //
     /* 101003 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101007 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101011 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101017 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 101019 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101021 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v2f32] }:$Rn), dsub:{ *:[i32] })
     /* 101021 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 101024 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 101028 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101033 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 101037 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101039 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101042 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101044 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101047 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101050 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101053 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101058 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101063 */       // GIR_Coverage, 5834,
     /* 101063 */       GIR_EraseRootFromParent_Done,
     /* 101064 */     // Label 1558: @101064
     /* 101064 */     GIM_Try, /*On fail goto*//*Label 1559*/ GIMT_Encode4(101157), // Rule ID 4949 //
     /* 101069 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101073 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101077 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 101081 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101085 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101090 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101092 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn))  =>  (FCVTNv4i32:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rn)
     /* 101092 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101095 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101099 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101104 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101106 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101109 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101113 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101118 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101121 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101125 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101128 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101133 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101138 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101143 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i32),
     /* 101146 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101148 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101151 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101155 */       GIR_RootConstrainSelectedInstOperands,
     /* 101156 */       // GIR_Coverage, 4949,
     /* 101156 */       GIR_EraseRootFromParent_Done,
     /* 101157 */     // Label 1559: @101157
     /* 101157 */     GIM_Try, /*On fail goto*//*Label 1560*/ GIMT_Encode4(101253), // Rule ID 4996 //
     /* 101162 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 101165 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101169 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101173 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101177 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 101181 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101186 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101188 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn))  =>  (XTNv4i32:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v2i64] }:$Rn)
     /* 101188 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101191 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101195 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101200 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101202 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101205 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101209 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101214 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101217 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101221 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101224 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101229 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101239 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i32),
     /* 101242 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101244 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101247 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 101251 */       GIR_RootConstrainSelectedInstOperands,
     /* 101252 */       // GIR_Coverage, 4996,
     /* 101252 */       GIR_EraseRootFromParent_Done,
     /* 101253 */     // Label 1560: @101253
     /* 101253 */     GIM_Try, /*On fail goto*//*Label 1561*/ GIMT_Encode4(101315), // Rule ID 5831 //
     /* 101258 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101262 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101266 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101270 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101272 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rn, (undef:{ *:[v2i32] }))  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] })
     /* 101272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101284 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101286 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101289 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101291 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101294 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101296 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101299 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101304 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101309 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101314 */       // GIR_Coverage, 5831,
     /* 101314 */       GIR_EraseRootFromParent_Done,
     /* 101315 */     // Label 1561: @101315
     /* 101315 */     GIM_Try, /*On fail goto*//*Label 1562*/ GIMT_Encode4(101377), // Rule ID 5835 //
     /* 101320 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101324 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101328 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 101332 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 101334 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rn, (undef:{ *:[v2f32] }))  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] })
     /* 101334 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 101337 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101341 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101346 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 101348 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101351 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101353 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101356 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 101358 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 101361 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101366 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101371 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101376 */       // GIR_Coverage, 5835,
     /* 101376 */       GIR_EraseRootFromParent_Done,
     /* 101377 */     // Label 1562: @101377
     /* 101377 */     GIM_Try, /*On fail goto*//*Label 1563*/ GIMT_Encode4(101511), // Rule ID 5829 //
     /* 101382 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101386 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101390 */       // (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (INSvi64lane:{ *:[v4i32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101390 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101393 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101397 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101402 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101404 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101407 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101411 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101416 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101419 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101423 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101426 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101431 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101436 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101441 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101444 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101448 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101453 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101455 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101458 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101462 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101467 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101470 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101474 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101477 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101482 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101487 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101492 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101495 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101497 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101500 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101503 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101506 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101509 */       GIR_RootConstrainSelectedInstOperands,
     /* 101510 */       // GIR_Coverage, 5829,
     /* 101510 */       GIR_EraseRootFromParent_Done,
     /* 101511 */     // Label 1563: @101511
     /* 101511 */     GIM_Try, /*On fail goto*//*Label 1564*/ GIMT_Encode4(101645), // Rule ID 5833 //
     /* 101516 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101520 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101524 */       // (concat_vectors:{ *:[v4f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn)  =>  (INSvi64lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 101524 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 101527 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101531 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101536 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 101538 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 101541 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101545 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101550 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 101553 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 101557 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 101560 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101565 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101570 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101575 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 101578 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 101582 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101587 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 101589 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101592 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 101596 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101601 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 101604 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101608 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101611 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101616 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101621 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101626 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 101629 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101631 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101634 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 101637 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 101640 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 101643 */       GIR_RootConstrainSelectedInstOperands,
     /* 101644 */       // GIR_Coverage, 5833,
     /* 101644 */       GIR_EraseRootFromParent_Done,
     /* 101645 */     // Label 1564: @101645
     /* 101645 */     GIM_Reject,
     /* 101646 */   // Label 1540: @101646
     /* 101646 */   GIM_Reject,
     /* 101647 */   // Label 1523: @101647
     /* 101647 */   GIM_Try, /*On fail goto*//*Label 1565*/ GIMT_Encode4(104055),
     /* 101652 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 101655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 101658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101662 */     GIM_Try, /*On fail goto*//*Label 1566*/ GIMT_Encode4(101791), // Rule ID 5439 //
     /* 101667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101679 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101683 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101687 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101691 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101695 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101699 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 101703 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101707 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101711 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101716 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 101720 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 101726 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 101728 */       // MIs[2] Operand 2
     /* 101728 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101739 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 101741 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 101741 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101744 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101748 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101753 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101756 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101760 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101763 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101768 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101773 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 101776 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101778 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101781 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101785 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101789 */       GIR_RootConstrainSelectedInstOperands,
     /* 101790 */       // GIR_Coverage, 5439,
     /* 101790 */       GIR_EraseRootFromParent_Done,
     /* 101791 */     // Label 1566: @101791
     /* 101791 */     GIM_Try, /*On fail goto*//*Label 1567*/ GIMT_Encode4(101913), // Rule ID 5435 //
     /* 101796 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101800 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101804 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101808 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101812 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101816 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101820 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101824 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101828 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 101832 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101836 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101840 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101845 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101850 */       // MIs[2] Operand 2
     /* 101850 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101861 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101863 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101863 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101866 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101870 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101875 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 101878 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 101882 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 101885 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101890 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101895 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 101898 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 101900 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 101903 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 101907 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 101911 */       GIR_RootConstrainSelectedInstOperands,
     /* 101912 */       // GIR_Coverage, 5435,
     /* 101912 */       GIR_EraseRootFromParent_Done,
     /* 101913 */     // Label 1567: @101913
     /* 101913 */     GIM_Try, /*On fail goto*//*Label 1568*/ GIMT_Encode4(102035), // Rule ID 5437 //
     /* 101918 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 101922 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 101926 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 101930 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101934 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 101938 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 101942 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101946 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 101950 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 101954 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 101958 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 101962 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101967 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 101972 */       // MIs[2] Operand 2
     /* 101972 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 101983 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 101985 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] })))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 101985 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 101988 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 101992 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 101997 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 102000 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102004 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102007 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102012 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102017 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102020 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102022 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102025 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 102029 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 102033 */       GIR_RootConstrainSelectedInstOperands,
     /* 102034 */       // GIR_Coverage, 5437,
     /* 102034 */       GIR_EraseRootFromParent_Done,
     /* 102035 */     // Label 1568: @102035
     /* 102035 */     GIM_Try, /*On fail goto*//*Label 1569*/ GIMT_Encode4(102137), // Rule ID 5590 //
     /* 102040 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 102044 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102048 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102052 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102056 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102060 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102064 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102069 */       // MIs[2] Operand 2
     /* 102069 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(16),
     /* 102080 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 102084 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102088 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102092 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 102096 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102100 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102104 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102109 */       // MIs[4] Operand 2
     /* 102109 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(16),
     /* 102120 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 102122 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })), (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vm, 16:{ *:[i32] })))  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 102122 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 102125 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 102127 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 102131 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 102135 */       GIR_RootConstrainSelectedInstOperands,
     /* 102136 */       // GIR_Coverage, 5590,
     /* 102136 */       GIR_EraseRootFromParent_Done,
     /* 102137 */     // Label 1569: @102137
     /* 102137 */     GIM_Try, /*On fail goto*//*Label 1570*/ GIMT_Encode4(102266), // Rule ID 6376 //
     /* 102142 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102146 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102150 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102154 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102157 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102162 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102166 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102170 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102175 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 16,
     /* 102179 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102181 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] }))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 102181 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 102184 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 102188 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102193 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 102196 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 102198 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102201 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102205 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102210 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102212 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102215 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102219 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102224 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102227 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 102231 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102234 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102239 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102244 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102249 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 102252 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102254 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102257 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 102261 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 102264 */       GIR_RootConstrainSelectedInstOperands,
     /* 102265 */       // GIR_Coverage, 6376,
     /* 102265 */       GIR_EraseRootFromParent_Done,
     /* 102266 */     // Label 1570: @102266
     /* 102266 */     GIM_Try, /*On fail goto*//*Label 1571*/ GIMT_Encode4(102308), // Rule ID 5840 //
     /* 102271 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102278 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 102285 */       // (concat_vectors:{ *:[v8i16] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (INSvi64lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })
     /* 102285 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102288 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102290 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102295 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102298 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102303 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102306 */       GIR_RootConstrainSelectedInstOperands,
     /* 102307 */       // GIR_Coverage, 5840,
     /* 102307 */       GIR_EraseRootFromParent_Done,
     /* 102308 */     // Label 1571: @102308
     /* 102308 */     GIM_Try, /*On fail goto*//*Label 1572*/ GIMT_Encode4(102350), // Rule ID 5844 //
     /* 102313 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102320 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 102327 */       // (concat_vectors:{ *:[v8f16] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn), (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rm))  =>  (INSvi64lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] })
     /* 102327 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 102330 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102332 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 102337 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 102340 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 102345 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 102348 */       GIR_RootConstrainSelectedInstOperands,
     /* 102349 */       // GIR_Coverage, 5844,
     /* 102349 */       GIR_EraseRootFromParent_Done,
     /* 102350 */     // Label 1572: @102350
     /* 102350 */     GIM_Try, /*On fail goto*//*Label 1573*/ GIMT_Encode4(102473), // Rule ID 2572 //
     /* 102355 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102358 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102362 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102366 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102370 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102373 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 102378 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102382 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 102386 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102391 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 102395 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102399 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102403 */       // MIs[2] Operand 1
     /* 102403 */       // No operand predicates
     /* 102403 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 102405 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (RSHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102405 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102408 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102412 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102417 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102419 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102422 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102426 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102431 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102434 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102438 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102441 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102446 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102451 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102456 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i16_shift),
     /* 102459 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102461 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102464 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102468 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 102471 */       GIR_RootConstrainSelectedInstOperands,
     /* 102472 */       // GIR_Coverage, 2572,
     /* 102472 */       GIR_EraseRootFromParent_Done,
     /* 102473 */     // Label 1573: @102473
     /* 102473 */     GIM_Try, /*On fail goto*//*Label 1574*/ GIMT_Encode4(102596), // Rule ID 6346 //
     /* 102478 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102481 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102485 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102489 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102493 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102497 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102501 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 102505 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102509 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102514 */       // MIs[2] imm
     /* 102514 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102518 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102522 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102526 */       // MIs[3] Operand 1
     /* 102526 */       // No operand predicates
     /* 102526 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102528 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102528 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102531 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102535 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102540 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102542 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102545 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102549 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102554 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102557 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102561 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102564 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102569 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102574 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102579 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102582 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102584 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102587 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102591 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102594 */       GIR_RootConstrainSelectedInstOperands,
     /* 102595 */       // GIR_Coverage, 6346,
     /* 102595 */       GIR_EraseRootFromParent_Done,
     /* 102596 */     // Label 1574: @102596
     /* 102596 */     GIM_Try, /*On fail goto*//*Label 1575*/ GIMT_Encode4(102716), // Rule ID 6382 //
     /* 102601 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102605 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102609 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 102613 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102617 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 102621 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 102625 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 102629 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102634 */       // MIs[2] imm
     /* 102634 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 102638 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 102642 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 102646 */       // MIs[3] Operand 1
     /* 102646 */       // No operand predicates
     /* 102646 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 102648 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)))  =>  (SHRNv8i16_shift:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 102648 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102651 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102655 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102660 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102662 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102665 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102669 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102674 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102677 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102681 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102684 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102689 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102694 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102699 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i16_shift),
     /* 102702 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102704 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102707 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 102711 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 102714 */       GIR_RootConstrainSelectedInstOperands,
     /* 102715 */       // GIR_Coverage, 6382,
     /* 102715 */       GIR_EraseRootFromParent_Done,
     /* 102716 */     // Label 1575: @102716
     /* 102716 */     GIM_Try, /*On fail goto*//*Label 1576*/ GIMT_Encode4(102833), // Rule ID 2496 //
     /* 102721 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102724 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102728 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102732 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102736 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102739 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 102744 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102748 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102752 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102757 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102762 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102764 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (ADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102764 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102767 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102771 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102776 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102778 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102781 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102785 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102790 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102793 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102797 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102800 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102805 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102810 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102815 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v8i16),
     /* 102818 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102820 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102823 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102827 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102831 */       GIR_RootConstrainSelectedInstOperands,
     /* 102832 */       // GIR_Coverage, 2496,
     /* 102832 */       GIR_EraseRootFromParent_Done,
     /* 102833 */     // Label 1576: @102833
     /* 102833 */     GIM_Try, /*On fail goto*//*Label 1577*/ GIMT_Encode4(102950), // Rule ID 5360 //
     /* 102838 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102841 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102845 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102849 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102853 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102856 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 102861 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102865 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102869 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102874 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102879 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102881 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (SUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102881 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 102884 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 102888 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102893 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 102895 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 102898 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 102902 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 102907 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 102910 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 102914 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 102917 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102922 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102927 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102932 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v8i16),
     /* 102935 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 102937 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 102940 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 102944 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 102948 */       GIR_RootConstrainSelectedInstOperands,
     /* 102949 */       // GIR_Coverage, 5360,
     /* 102949 */       GIR_EraseRootFromParent_Done,
     /* 102950 */     // Label 1577: @102950
     /* 102950 */     GIM_Try, /*On fail goto*//*Label 1578*/ GIMT_Encode4(103067), // Rule ID 5363 //
     /* 102955 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 102958 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 102962 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 102966 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 102970 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 102973 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 102978 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 102982 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 102986 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102991 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 102996 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 102998 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RADDHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 102998 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103001 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103005 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103010 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103012 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103015 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103019 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103024 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103027 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103031 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103034 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103039 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103044 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103049 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v8i16),
     /* 103052 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103054 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103057 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103061 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103065 */       GIR_RootConstrainSelectedInstOperands,
     /* 103066 */       // GIR_Coverage, 5363,
     /* 103066 */       GIR_EraseRootFromParent_Done,
     /* 103067 */     // Label 1578: @103067
     /* 103067 */     GIM_Try, /*On fail goto*//*Label 1579*/ GIMT_Encode4(103184), // Rule ID 5366 //
     /* 103072 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103075 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103079 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103083 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103087 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 103090 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 103095 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103099 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 103103 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103108 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103113 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103115 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))  =>  (RSUBHNv4i32_v8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 103115 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103118 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103122 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103127 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103129 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103132 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103136 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103141 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103144 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103148 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103151 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103156 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103161 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103166 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v8i16),
     /* 103169 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103171 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103174 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103178 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 103182 */       GIR_RootConstrainSelectedInstOperands,
     /* 103183 */       // GIR_Coverage, 5366,
     /* 103183 */       GIR_EraseRootFromParent_Done,
     /* 103184 */     // Label 1579: @103184
     /* 103184 */     GIM_Try, /*On fail goto*//*Label 1580*/ GIMT_Encode4(103285), // Rule ID 4943 //
     /* 103189 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103193 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103197 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 103201 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 103204 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 103209 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 103213 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103218 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103220 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103220 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103223 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103227 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103232 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103234 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103237 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103241 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103246 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103249 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103253 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103256 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103261 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103266 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103271 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103274 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103276 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103279 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 103283 */       GIR_RootConstrainSelectedInstOperands,
     /* 103284 */       // GIR_Coverage, 4943,
     /* 103284 */       GIR_EraseRootFromParent_Done,
     /* 103285 */     // Label 1580: @103285
     /* 103285 */     GIM_Try, /*On fail goto*//*Label 1581*/ GIMT_Encode4(103341), // Rule ID 5515 //
     /* 103290 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 103294 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103298 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103302 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103307 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 103311 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103315 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103319 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103324 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 103326 */       // (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm))  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 103326 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 103329 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 103331 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 103335 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 103339 */       GIR_RootConstrainSelectedInstOperands,
     /* 103340 */       // GIR_Coverage, 5515,
     /* 103340 */       GIR_EraseRootFromParent_Done,
     /* 103341 */     // Label 1581: @103341
     /* 103341 */     GIM_Try, /*On fail goto*//*Label 1582*/ GIMT_Encode4(103407), // Rule ID 5838 //
     /* 103346 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103350 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103354 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103360 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103362 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103364 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4i16] }:$Rn), dsub:{ *:[i32] })
     /* 103364 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103367 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103371 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103376 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103380 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103382 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103385 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103387 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103390 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103393 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103396 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103401 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103406 */       // GIR_Coverage, 5838,
     /* 103406 */       GIR_EraseRootFromParent_Done,
     /* 103407 */     // Label 1582: @103407
     /* 103407 */     GIM_Try, /*On fail goto*//*Label 1583*/ GIMT_Encode4(103473), // Rule ID 5842 //
     /* 103412 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103416 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103420 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 103426 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 103428 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103430 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v4f16] }:$Rn), dsub:{ *:[i32] })
     /* 103430 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 103433 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 103437 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103442 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 103446 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103448 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 103451 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103453 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103456 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103459 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103462 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103467 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103472 */       // GIR_Coverage, 5842,
     /* 103472 */       GIR_EraseRootFromParent_Done,
     /* 103473 */     // Label 1583: @103473
     /* 103473 */     GIM_Try, /*On fail goto*//*Label 1584*/ GIMT_Encode4(103566), // Rule ID 4951 //
     /* 103478 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103482 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103486 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTRUNC),
     /* 103490 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103494 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103499 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103501 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rn)
     /* 103501 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103504 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103508 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103513 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103515 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103518 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103522 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103527 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103530 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103534 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103537 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103542 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103547 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103552 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 103555 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103557 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103560 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103564 */       GIR_RootConstrainSelectedInstOperands,
     /* 103565 */       // GIR_Coverage, 4951,
     /* 103565 */       GIR_EraseRootFromParent_Done,
     /* 103566 */     // Label 1584: @103566
     /* 103566 */     GIM_Try, /*On fail goto*//*Label 1585*/ GIMT_Encode4(103662), // Rule ID 4995 //
     /* 103571 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 103574 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103578 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103582 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 103586 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 103590 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103595 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103597 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn))  =>  (XTNv8i16:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v4i32] }:$Rn)
     /* 103597 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103600 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103604 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103609 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103611 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103614 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103618 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103623 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103626 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103630 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103633 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103638 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i16),
     /* 103651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103653 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103656 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 103660 */       GIR_RootConstrainSelectedInstOperands,
     /* 103661 */       // GIR_Coverage, 4995,
     /* 103661 */       GIR_EraseRootFromParent_Done,
     /* 103662 */     // Label 1585: @103662
     /* 103662 */     GIM_Try, /*On fail goto*//*Label 1586*/ GIMT_Encode4(103724), // Rule ID 5839 //
     /* 103667 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103671 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103675 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103679 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103681 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rn, (undef:{ *:[v4i16] }))  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] })
     /* 103681 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103684 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103688 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103693 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103695 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103698 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103700 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103703 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103705 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103708 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103713 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103718 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103723 */       // GIR_Coverage, 5839,
     /* 103723 */       GIR_EraseRootFromParent_Done,
     /* 103724 */     // Label 1586: @103724
     /* 103724 */     GIM_Try, /*On fail goto*//*Label 1587*/ GIMT_Encode4(103786), // Rule ID 5843 //
     /* 103729 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103733 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 103737 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 103741 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 103743 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rn, (undef:{ *:[v4f16] }))  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] })
     /* 103743 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 103746 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103750 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103755 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 103757 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103760 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103762 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103765 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 103767 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 103770 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103775 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103780 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103785 */       // GIR_Coverage, 5843,
     /* 103785 */       GIR_EraseRootFromParent_Done,
     /* 103786 */     // Label 1587: @103786
     /* 103786 */     GIM_Try, /*On fail goto*//*Label 1588*/ GIMT_Encode4(103920), // Rule ID 5837 //
     /* 103791 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103795 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103799 */       // (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (INSvi64lane:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103799 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103802 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103806 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103811 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103813 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103816 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103820 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103825 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103828 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103832 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103835 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103840 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103845 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103850 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103853 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103857 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103862 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103864 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 103867 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103871 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103876 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 103879 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 103883 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 103886 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103891 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103896 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103901 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 103904 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 103906 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 103909 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 103912 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 103915 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 103918 */       GIR_RootConstrainSelectedInstOperands,
     /* 103919 */       // GIR_Coverage, 5837,
     /* 103919 */       GIR_EraseRootFromParent_Done,
     /* 103920 */     // Label 1588: @103920
     /* 103920 */     GIM_Try, /*On fail goto*//*Label 1589*/ GIMT_Encode4(104054), // Rule ID 5841 //
     /* 103925 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103929 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103933 */       // (concat_vectors:{ *:[v8f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn)  =>  (INSvi64lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 103933 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 103936 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103940 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103945 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 103947 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 103950 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 103954 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103959 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 103962 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 103966 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 103969 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103974 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 103979 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 103984 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 103987 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 103991 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 103996 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 103998 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104001 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104005 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104010 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104013 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104017 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104020 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104025 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104030 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104035 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104038 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104040 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104043 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104046 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104049 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104052 */       GIR_RootConstrainSelectedInstOperands,
     /* 104053 */       // GIR_Coverage, 5841,
     /* 104053 */       GIR_EraseRootFromParent_Done,
     /* 104054 */     // Label 1589: @104054
     /* 104054 */     GIM_Reject,
     /* 104055 */   // Label 1565: @104055
     /* 104055 */   GIM_Reject,
     /* 104056 */   // Label 1524: @104056
     /* 104056 */   GIM_Try, /*On fail goto*//*Label 1590*/ GIMT_Encode4(105966),
     /* 104061 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 104064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 104067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104071 */     GIM_Try, /*On fail goto*//*Label 1591*/ GIMT_Encode4(104200), // Rule ID 5433 //
     /* 104076 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104080 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104084 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104088 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104092 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104096 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104100 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104104 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104108 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 104112 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104116 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104120 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104125 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 104129 */       GIM_CheckOpcodeIsEither, /*MI*/4, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 104135 */       GIM_CheckIsBuildVectorAllOnes, /*MI*/4,
     /* 104137 */       // MIs[2] Operand 2
     /* 104137 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104148 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104150 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 104150 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104153 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104157 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104162 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104165 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104169 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104198 */       GIR_RootConstrainSelectedInstOperands,
     /* 104199 */       // GIR_Coverage, 5433,
     /* 104199 */       GIR_EraseRootFromParent_Done,
     /* 104200 */     // Label 1591: @104200
     /* 104200 */     GIM_Try, /*On fail goto*//*Label 1592*/ GIMT_Encode4(104322), // Rule ID 5429 //
     /* 104205 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104209 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104213 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104217 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104221 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104225 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104229 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104233 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104237 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 104241 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104245 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104249 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104254 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104259 */       // MIs[2] Operand 2
     /* 104259 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104270 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104272 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104272 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104275 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104279 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104284 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104287 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104291 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104299 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104304 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 104307 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104309 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104312 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104316 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104320 */       GIR_RootConstrainSelectedInstOperands,
     /* 104321 */       // GIR_Coverage, 5429,
     /* 104321 */       GIR_EraseRootFromParent_Done,
     /* 104322 */     // Label 1592: @104322
     /* 104322 */     GIM_Try, /*On fail goto*//*Label 1593*/ GIMT_Encode4(104444), // Rule ID 5431 //
     /* 104327 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104331 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104335 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104339 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104343 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104347 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104351 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104355 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 104359 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 104363 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104367 */       GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104371 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104376 */       GIM_CheckRegBankForClass, /*MI*/3, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104381 */       // MIs[2] Operand 2
     /* 104381 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104392 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104394 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] })))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 104394 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104397 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 104401 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104406 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 104409 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104413 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104416 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104421 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104426 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 104429 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104431 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104434 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 104438 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/2, // Rm
     /* 104442 */       GIR_RootConstrainSelectedInstOperands,
     /* 104443 */       // GIR_Coverage, 5431,
     /* 104443 */       GIR_EraseRootFromParent_Done,
     /* 104444 */     // Label 1593: @104444
     /* 104444 */     GIM_Try, /*On fail goto*//*Label 1594*/ GIMT_Encode4(104546), // Rule ID 5589 //
     /* 104449 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 104453 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104457 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104461 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104465 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104469 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104473 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104478 */       // MIs[2] Operand 2
     /* 104478 */       GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 104489 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 104493 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104497 */       GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104501 */       GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 104505 */       GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104509 */       GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104513 */       GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104518 */       // MIs[4] Operand 2
     /* 104518 */       GIM_CheckLiteralInt, /*MI*/4, /*Op*/2, GIMT_Encode8(8),
     /* 104529 */       GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 104531 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })), (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vm, 8:{ *:[i32] })))  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 104531 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 104534 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 104536 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 104540 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Vm
     /* 104544 */       GIR_RootConstrainSelectedInstOperands,
     /* 104545 */       // GIR_Coverage, 5589,
     /* 104545 */       GIR_EraseRootFromParent_Done,
     /* 104546 */     // Label 1594: @104546
     /* 104546 */     GIM_Try, /*On fail goto*//*Label 1595*/ GIMT_Encode4(104675), // Rule ID 6375 //
     /* 104551 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104555 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104559 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104563 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104566 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104571 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104575 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104579 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104584 */       GIM_CheckConstantInt8, /*MI*/1, /*Op*/3, 8,
     /* 104588 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 104590 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Vd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] }))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Vd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 104590 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 104593 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 104597 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104602 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 104605 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 104607 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104610 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104614 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104619 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104621 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104624 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104628 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104633 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104636 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vd
     /* 104640 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104643 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104648 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104653 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104658 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 104661 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104663 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104666 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vn
     /* 104670 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 104673 */       GIR_RootConstrainSelectedInstOperands,
     /* 104674 */       // GIR_Coverage, 6375,
     /* 104674 */       GIR_EraseRootFromParent_Done,
     /* 104675 */     // Label 1595: @104675
     /* 104675 */     GIM_Try, /*On fail goto*//*Label 1596*/ GIMT_Encode4(104717), // Rule ID 5848 //
     /* 104680 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104687 */       GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 104694 */       // (concat_vectors:{ *:[v16i8] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (INSvi64lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, 0:{ *:[i64] }, V128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })
     /* 104694 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 104697 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104699 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 104704 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 104707 */       GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 104712 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 104715 */       GIR_RootConstrainSelectedInstOperands,
     /* 104716 */       // GIR_Coverage, 5848,
     /* 104716 */       GIR_EraseRootFromParent_Done,
     /* 104717 */     // Label 1596: @104717
     /* 104717 */     GIM_Try, /*On fail goto*//*Label 1597*/ GIMT_Encode4(104840), // Rule ID 2570 //
     /* 104722 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104725 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104729 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104733 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 104737 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 104740 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 104745 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 104749 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 104753 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104758 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 104762 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104766 */       GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104770 */       // MIs[2] Operand 1
     /* 104770 */       // No operand predicates
     /* 104770 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 104772 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (RSHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104772 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104775 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104779 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104784 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104786 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104789 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104793 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104798 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104801 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104805 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104808 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104813 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104818 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104823 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv16i8_shift),
     /* 104826 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104828 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104831 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 104835 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 104838 */       GIR_RootConstrainSelectedInstOperands,
     /* 104839 */       // GIR_Coverage, 2570,
     /* 104839 */       GIR_EraseRootFromParent_Done,
     /* 104840 */     // Label 1597: @104840
     /* 104840 */     GIM_Try, /*On fail goto*//*Label 1598*/ GIMT_Encode4(104963), // Rule ID 6345 //
     /* 104845 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 104848 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104852 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104856 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104860 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104864 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104868 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VASHR),
     /* 104872 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104876 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104881 */       // MIs[2] imm
     /* 104881 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 104885 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 104889 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 104893 */       // MIs[3] Operand 1
     /* 104893 */       // No operand predicates
     /* 104893 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 104895 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 104895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 104898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 104902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 104909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 104912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 104916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 104921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 104924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 104928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 104931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 104941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 104949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 104951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 104954 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 104958 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 104961 */       GIR_RootConstrainSelectedInstOperands,
     /* 104962 */       // GIR_Coverage, 6345,
     /* 104962 */       GIR_EraseRootFromParent_Done,
     /* 104963 */     // Label 1598: @104963
     /* 104963 */     GIM_Try, /*On fail goto*//*Label 1599*/ GIMT_Encode4(105083), // Rule ID 6381 //
     /* 104968 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 104972 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 104976 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 104980 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104984 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 104988 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_VLSHR),
     /* 104992 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 104996 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105001 */       // MIs[2] imm
     /* 105001 */       GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 105005 */       GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 105009 */       GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 105013 */       // MIs[3] Operand 1
     /* 105013 */       // No operand predicates
     /* 105013 */       GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 105015 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)))  =>  (SHRNv16i8_shift:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 105015 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105018 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105022 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105027 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105029 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105032 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105036 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105041 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105044 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105048 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105051 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105056 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105061 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105066 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv16i8_shift),
     /* 105069 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105071 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105074 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 105078 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // imm
     /* 105081 */       GIR_RootConstrainSelectedInstOperands,
     /* 105082 */       // GIR_Coverage, 6381,
     /* 105082 */       GIR_EraseRootFromParent_Done,
     /* 105083 */     // Label 1599: @105083
     /* 105083 */     GIM_Try, /*On fail goto*//*Label 1600*/ GIMT_Encode4(105200), // Rule ID 2495 //
     /* 105088 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105091 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105095 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105099 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105103 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105106 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 105111 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105115 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105119 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105124 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105129 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105131 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (ADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105131 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105134 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105138 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105143 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105145 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105148 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105152 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105157 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105160 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105164 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105167 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105172 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105177 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105182 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v16i8),
     /* 105185 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105187 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105190 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105194 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105198 */       GIR_RootConstrainSelectedInstOperands,
     /* 105199 */       // GIR_Coverage, 2495,
     /* 105199 */       GIR_EraseRootFromParent_Done,
     /* 105200 */     // Label 1600: @105200
     /* 105200 */     GIM_Try, /*On fail goto*//*Label 1601*/ GIMT_Encode4(105317), // Rule ID 5359 //
     /* 105205 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105208 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105212 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105216 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105220 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105223 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 105228 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105232 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105236 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105241 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105246 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105248 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (SUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105248 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105251 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105255 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105260 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105262 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105265 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105269 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105274 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105277 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105281 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105284 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105289 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105294 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105299 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v16i8),
     /* 105302 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105304 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105307 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105311 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105315 */       GIR_RootConstrainSelectedInstOperands,
     /* 105316 */       // GIR_Coverage, 5359,
     /* 105316 */       GIR_EraseRootFromParent_Done,
     /* 105317 */     // Label 1601: @105317
     /* 105317 */     GIM_Try, /*On fail goto*//*Label 1602*/ GIMT_Encode4(105434), // Rule ID 5362 //
     /* 105322 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105325 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105329 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105333 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105337 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105340 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 105345 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105349 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105353 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105358 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105363 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105365 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RADDHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105365 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105368 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105372 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105377 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105379 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105382 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105386 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105391 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105394 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105398 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105401 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105406 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105411 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105416 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v16i8),
     /* 105419 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105421 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105424 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105428 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105432 */       GIR_RootConstrainSelectedInstOperands,
     /* 105433 */       // GIR_Coverage, 5362,
     /* 105433 */       GIR_EraseRootFromParent_Done,
     /* 105434 */     // Label 1602: @105434
     /* 105434 */     GIM_Try, /*On fail goto*//*Label 1603*/ GIMT_Encode4(105551), // Rule ID 5365 //
     /* 105439 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105442 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105446 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105450 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 105454 */       GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 105457 */       GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 105462 */       GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 105466 */       GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 105470 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105475 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105480 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105482 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))  =>  (RSUBHNv8i16_v16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 105482 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105485 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105489 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105494 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105496 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105499 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105503 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105508 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105511 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105515 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105518 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105523 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105528 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105533 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v16i8),
     /* 105536 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105538 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105541 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 105545 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 105549 */       GIR_RootConstrainSelectedInstOperands,
     /* 105550 */       // GIR_Coverage, 5365,
     /* 105550 */       GIR_EraseRootFromParent_Done,
     /* 105551 */     // Label 1603: @105551
     /* 105551 */     GIM_Try, /*On fail goto*//*Label 1604*/ GIMT_Encode4(105607), // Rule ID 5506 //
     /* 105556 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 105560 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105564 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105568 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105573 */       GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 105577 */       GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105581 */       GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105585 */       GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105590 */       GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 105592 */       // (concat_vectors:{ *:[v16i8] } (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn), (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vm))  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 105592 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 105595 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 105597 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 105601 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vm
     /* 105605 */       GIR_RootConstrainSelectedInstOperands,
     /* 105606 */       // GIR_Coverage, 5506,
     /* 105606 */       GIR_EraseRootFromParent_Done,
     /* 105607 */     // Label 1604: @105607
     /* 105607 */     GIM_Try, /*On fail goto*//*Label 1605*/ GIMT_Encode4(105673), // Rule ID 5846 //
     /* 105612 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105616 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105620 */       GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 105626 */       GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 105628 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105630 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (FMOVDr:{ *:[i64] } V64:{ *:[v8i8] }:$Rn), dsub:{ *:[i32] })
     /* 105630 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 105633 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVDr),
     /* 105637 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105642 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 105646 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105648 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 105651 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105653 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105656 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105659 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105662 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105667 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105672 */       // GIR_Coverage, 5846,
     /* 105672 */       GIR_EraseRootFromParent_Done,
     /* 105673 */     // Label 1605: @105673
     /* 105673 */     GIM_Try, /*On fail goto*//*Label 1606*/ GIMT_Encode4(105769), // Rule ID 4994 //
     /* 105678 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 105681 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105685 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105689 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 105693 */       GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 105697 */       GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105702 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105704 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn))  =>  (XTNv16i8:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), V128:{ *:[v8i16] }:$Rn)
     /* 105704 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105707 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105711 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105716 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105718 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105721 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105725 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105730 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105733 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105737 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105740 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105745 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105750 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105755 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv16i8),
     /* 105758 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105760 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105763 */       GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 105767 */       GIR_RootConstrainSelectedInstOperands,
     /* 105768 */       // GIR_Coverage, 4994,
     /* 105768 */       GIR_EraseRootFromParent_Done,
     /* 105769 */     // Label 1606: @105769
     /* 105769 */     GIM_Try, /*On fail goto*//*Label 1607*/ GIMT_Encode4(105831), // Rule ID 5847 //
     /* 105774 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105778 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 105782 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 105786 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 105788 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rn, (undef:{ *:[v8i8] }))  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] })
     /* 105788 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 105791 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105795 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105800 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 105802 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105805 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105807 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105810 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 105812 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 105815 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105820 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105825 */       GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105830 */       // GIR_Coverage, 5847,
     /* 105830 */       GIR_EraseRootFromParent_Done,
     /* 105831 */     // Label 1607: @105831
     /* 105831 */     GIM_Try, /*On fail goto*//*Label 1608*/ GIMT_Encode4(105965), // Rule ID 5845 //
     /* 105836 */       GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105840 */       GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105844 */       // (concat_vectors:{ *:[v16i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (INSvi64lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), 1:{ *:[i64] }, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 105844 */       GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 105847 */       GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105851 */       GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105856 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 105858 */       GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 105861 */       GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105865 */       GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105870 */       GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 105873 */       GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 105877 */       GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 105880 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105885 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105890 */       GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105895 */       GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 105898 */       GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 105902 */       GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105907 */       GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 105909 */       GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 105912 */       GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 105916 */       GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 105921 */       GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 105924 */       GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 105928 */       GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 105931 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105936 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 105941 */       GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 105946 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 105949 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 105951 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 105954 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 105957 */       GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 105960 */       GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 105963 */       GIR_RootConstrainSelectedInstOperands,
     /* 105964 */       // GIR_Coverage, 5845,
     /* 105964 */       GIR_EraseRootFromParent_Done,
     /* 105965 */     // Label 1608: @105965
     /* 105965 */     GIM_Reject,
     /* 105966 */   // Label 1590: @105966
     /* 105966 */   GIM_Reject,
     /* 105967 */   // Label 1525: @105967
     /* 105967 */   GIM_Try, /*On fail goto*//*Label 1609*/ GIMT_Encode4(105992), // Rule ID 9121 //
     /* 105972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 105975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 105978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 105981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 105985 */     // (concat_vectors:{ *:[nxv2i1] } nxv1i1:{ *:[nxv1i1] }:$p1, nxv1i1:{ *:[nxv1i1] }:$p2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv1i1] }:$p1, ?:{ *:[nxv1i1] }:$p2)
     /* 105985 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 105990 */     GIR_RootConstrainSelectedInstOperands,
     /* 105991 */     // GIR_Coverage, 9121,
     /* 105991 */     GIR_Done,
     /* 105992 */   // Label 1609: @105992
     /* 105992 */   GIM_Reject,
     /* 105993 */   // Label 1526: @105993
     /* 105993 */   GIM_Try, /*On fail goto*//*Label 1610*/ GIMT_Encode4(106018), // Rule ID 9122 //
     /* 105998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106001 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 106004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 106007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106011 */     // (concat_vectors:{ *:[nxv4i1] } nxv2i1:{ *:[nxv2i1] }:$p1, nxv2i1:{ *:[nxv2i1] }:$p2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv2i1] }:$p1, ?:{ *:[nxv2i1] }:$p2)
     /* 106011 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 106016 */     GIR_RootConstrainSelectedInstOperands,
     /* 106017 */     // GIR_Coverage, 9122,
     /* 106017 */     GIR_Done,
     /* 106018 */   // Label 1610: @106018
     /* 106018 */   GIM_Reject,
     /* 106019 */   // Label 1527: @106019
     /* 106019 */   GIM_Try, /*On fail goto*//*Label 1611*/ GIMT_Encode4(106044), // Rule ID 9125 //
     /* 106024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106027 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 106030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 106033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106037 */     // (concat_vectors:{ *:[nxv4f16] } nxv2f16:{ *:[nxv2f16] }:$v1, nxv2f16:{ *:[nxv2f16] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv2f16] }:$v1, ?:{ *:[nxv2f16] }:$v2)
     /* 106037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106042 */     GIR_RootConstrainSelectedInstOperands,
     /* 106043 */     // GIR_Coverage, 9125,
     /* 106043 */     GIR_Done,
     /* 106044 */   // Label 1611: @106044
     /* 106044 */   GIM_Reject,
     /* 106045 */   // Label 1528: @106045
     /* 106045 */   GIM_Try, /*On fail goto*//*Label 1612*/ GIMT_Encode4(106070), // Rule ID 9127 //
     /* 106050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106053 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 106056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 106059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106063 */     // (concat_vectors:{ *:[nxv4f32] } nxv2f32:{ *:[nxv2f32] }:$v1, nxv2f32:{ *:[nxv2f32] }:$v2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv2f32] }:$v1, ?:{ *:[nxv2f32] }:$v2)
     /* 106063 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 106068 */     GIR_RootConstrainSelectedInstOperands,
     /* 106069 */     // GIR_Coverage, 9127,
     /* 106069 */     GIR_Done,
     /* 106070 */   // Label 1612: @106070
     /* 106070 */   GIM_Reject,
     /* 106071 */   // Label 1529: @106071
     /* 106071 */   GIM_Try, /*On fail goto*//*Label 1613*/ GIMT_Encode4(106096), // Rule ID 9123 //
     /* 106076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106079 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 106082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 106085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106089 */     // (concat_vectors:{ *:[nxv8i1] } nxv4i1:{ *:[nxv4i1] }:$p1, nxv4i1:{ *:[nxv4i1] }:$p2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv4i1] }:$p1, ?:{ *:[nxv4i1] }:$p2)
     /* 106089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 106094 */     GIR_RootConstrainSelectedInstOperands,
     /* 106095 */     // GIR_Coverage, 9123,
     /* 106095 */     GIR_Done,
     /* 106096 */   // Label 1613: @106096
     /* 106096 */   GIM_Reject,
     /* 106097 */   // Label 1530: @106097
     /* 106097 */   GIM_Try, /*On fail goto*//*Label 1614*/ GIMT_Encode4(106122), // Rule ID 9126 //
     /* 106102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106105 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 106108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 106111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 106115 */     // (concat_vectors:{ *:[nxv8f16] } nxv4f16:{ *:[nxv4f16] }:$v1, nxv4f16:{ *:[nxv4f16] }:$v2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv4f16] }:$v1, ?:{ *:[nxv4f16] }:$v2)
     /* 106115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 106120 */     GIR_RootConstrainSelectedInstOperands,
     /* 106121 */     // GIR_Coverage, 9126,
     /* 106121 */     GIR_Done,
     /* 106122 */   // Label 1614: @106122
     /* 106122 */   GIM_Reject,
     /* 106123 */   // Label 1531: @106123
     /* 106123 */   GIM_Try, /*On fail goto*//*Label 1615*/ GIMT_Encode4(106148), // Rule ID 9124 //
     /* 106128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 106131 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 106134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 106137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 106141 */     // (concat_vectors:{ *:[nxv16i1] } nxv8i1:{ *:[nxv8i1] }:$p1, nxv8i1:{ *:[nxv8i1] }:$p2)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } ?:{ *:[nxv8i1] }:$p1, ?:{ *:[nxv8i1] }:$p2)
     /* 106141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 106146 */     GIR_RootConstrainSelectedInstOperands,
     /* 106147 */     // GIR_Coverage, 9124,
     /* 106147 */     GIR_Done,
     /* 106148 */   // Label 1615: @106148
     /* 106148 */   GIM_Reject,
     /* 106149 */   // Label 1532: @106149
     /* 106149 */   GIM_Reject,
     /* 106150 */ // Label 1520: @106150
     /* 106150 */ GIM_Reject,
     /* 106151 */ // Label 9: @106151
     /* 106151 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(24), /*)*//*default:*//*Label 1630*/ GIMT_Encode4(116232),
     /* 106162 */ /*GILLT_s32*//*Label 1616*/ GIMT_Encode4(106250),
     /* 106166 */ /*GILLT_s64*//*Label 1617*/ GIMT_Encode4(106753),
     /* 106170 */ /*GILLT_s128*//*Label 1618*/ GIMT_Encode4(108744),
     /* 106174 */ /*GILLT_v2s32*//*Label 1619*/ GIMT_Encode4(109390),
     /* 106178 */ /*GILLT_v2s64*//*Label 1620*/ GIMT_Encode4(110305),
     /* 106182 */ /*GILLT_v4s16*//*Label 1621*/ GIMT_Encode4(111074),
     /* 106186 */ /*GILLT_v4s32*//*Label 1622*/ GIMT_Encode4(111989),
     /* 106190 */ /*GILLT_v8s8*//*Label 1623*/ GIMT_Encode4(112834),
     /* 106194 */ /*GILLT_v8s16*//*Label 1624*/ GIMT_Encode4(113395),
     /* 106198 */ /*GILLT_v16s8*//*Label 1625*/ GIMT_Encode4(114240), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106218 */ /*GILLT_nxv2s64*//*Label 1626*/ GIMT_Encode4(114692), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 106230 */ /*GILLT_nxv4s32*//*Label 1627*/ GIMT_Encode4(115141), GIMT_Encode4(0),
     /* 106238 */ /*GILLT_nxv8s16*//*Label 1628*/ GIMT_Encode4(115590), GIMT_Encode4(0),
     /* 106246 */ /*GILLT_nxv16s8*//*Label 1629*/ GIMT_Encode4(116039),
     /* 106250 */ // Label 1616: @106250
     /* 106250 */ GIM_Try, /*On fail goto*//*Label 1631*/ GIMT_Encode4(106752),
     /* 106255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 106258 */   GIM_Try, /*On fail goto*//*Label 1632*/ GIMT_Encode4(106332), // Rule ID 7098 //
     /* 106263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106275 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106278 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106282 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106289 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106292 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106296 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106298 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 106305 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>)  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 106305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 106308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106320 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106325 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106330 */     GIR_RootConstrainSelectedInstOperands,
     /* 106331 */     // GIR_Coverage, 7098,
     /* 106331 */     GIR_EraseRootFromParent_Done,
     /* 106332 */   // Label 1632: @106332
     /* 106332 */   GIM_Try, /*On fail goto*//*Label 1633*/ GIMT_Encode4(106406), // Rule ID 7099 //
     /* 106337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106349 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106356 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106363 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106366 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106370 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106372 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 106379 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>)  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 106379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 106382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106404 */     GIR_RootConstrainSelectedInstOperands,
     /* 106405 */     // GIR_Coverage, 7099,
     /* 106405 */     GIR_EraseRootFromParent_Done,
     /* 106406 */   // Label 1633: @106406
     /* 106406 */   GIM_Try, /*On fail goto*//*Label 1634*/ GIMT_Encode4(106475), // Rule ID 7100 //
     /* 106411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106423 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106426 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106430 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106437 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106440 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106444 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106446 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 106453 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>)  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 106456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106458 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106473 */     GIR_RootConstrainSelectedInstOperands,
     /* 106474 */     // GIR_Coverage, 7100,
     /* 106474 */     GIR_EraseRootFromParent_Done,
     /* 106475 */   // Label 1634: @106475
     /* 106475 */   GIM_Try, /*On fail goto*//*Label 1635*/ GIMT_Encode4(106544), // Rule ID 7101 //
     /* 106480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106492 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106495 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106499 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 106506 */     GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106509 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106515 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 106522 */     // (bitconvert:{ *:[f32] } (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>)  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 106522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 106525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106527 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106532 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106537 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106542 */     GIR_RootConstrainSelectedInstOperands,
     /* 106543 */     // GIR_Coverage, 7101,
     /* 106543 */     GIR_EraseRootFromParent_Done,
     /* 106544 */   // Label 1635: @106544
     /* 106544 */   GIM_Try, /*On fail goto*//*Label 1636*/ GIMT_Encode4(106597), // Rule ID 5807 //
     /* 106549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 106565 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106569 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106573 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106575 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v16i8:{ *:[v16i8] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v16i8] }:$src, bsub:{ *:[i32] })
     /* 106575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106580 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(1), // src
     /* 106586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 106591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106596 */     // GIR_Coverage, 5807,
     /* 106596 */     GIR_EraseRootFromParent_Done,
     /* 106597 */   // Label 1636: @106597
     /* 106597 */   GIM_Try, /*On fail goto*//*Label 1637*/ GIMT_Encode4(106650), // Rule ID 5808 //
     /* 106602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106606 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106610 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106614 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 106618 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106622 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106626 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106628 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v8i16:{ *:[v8i16] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v8i16] }:$src, hsub:{ *:[i32] })
     /* 106628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106633 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // src
     /* 106639 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 106644 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106649 */     // GIR_Coverage, 5808,
     /* 106649 */     GIR_EraseRootFromParent_Done,
     /* 106650 */   // Label 1637: @106650
     /* 106650 */   GIM_Try, /*On fail goto*//*Label 1638*/ GIMT_Encode4(106703), // Rule ID 5809 //
     /* 106655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 106667 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 106671 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 106675 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 106679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106681 */     // (bitconvert:{ *:[f32] } (vector_extract:{ *:[i32] } v4i32:{ *:[v4i32] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4i32] }:$src, ssub:{ *:[i32] })
     /* 106681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 106686 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // src
     /* 106692 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106697 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 106702 */     // GIR_Coverage, 5809,
     /* 106702 */     GIR_EraseRootFromParent_Done,
     /* 106703 */   // Label 1638: @106703
     /* 106703 */   GIM_Try, /*On fail goto*//*Label 1639*/ GIMT_Encode4(106727), // Rule ID 6709 //
     /* 106708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106716 */     // (bitconvert:{ *:[f32] } GPR32:{ *:[i32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Xn, FPR32:{ *:[i32] })
     /* 106716 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106721 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106726 */     // GIR_Coverage, 6709,
     /* 106726 */     GIR_Done,
     /* 106727 */   // Label 1639: @106727
     /* 106727 */   GIM_Try, /*On fail goto*//*Label 1640*/ GIMT_Encode4(106751), // Rule ID 6710 //
     /* 106732 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106736 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 106740 */     // (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i32] } FPR32:{ *:[f32] }:$Xn, GPR32:{ *:[i32] })
     /* 106740 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 106745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 106750 */     // GIR_Coverage, 6710,
     /* 106750 */     GIR_Done,
     /* 106751 */   // Label 1640: @106751
     /* 106751 */   GIM_Reject,
     /* 106752 */ // Label 1631: @106752
     /* 106752 */ GIM_Reject,
     /* 106753 */ // Label 1617: @106753
     /* 106753 */ GIM_Try, /*On fail goto*//*Label 1641*/ GIMT_Encode4(106830), // Rule ID 7102 //
     /* 106758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106765 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106769 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106773 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106776 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106780 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106787 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106790 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106794 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106796 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 106803 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>)  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 106803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 106806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106808 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106823 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106828 */   GIR_RootConstrainSelectedInstOperands,
     /* 106829 */   // GIR_Coverage, 7102,
     /* 106829 */   GIR_EraseRootFromParent_Done,
     /* 106830 */ // Label 1641: @106830
     /* 106830 */ GIM_Try, /*On fail goto*//*Label 1642*/ GIMT_Encode4(106907), // Rule ID 7103 //
     /* 106835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106853 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106857 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106867 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106871 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106873 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 106880 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>)  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 106880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 106883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106885 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106890 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 106895 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 106900 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106905 */   GIR_RootConstrainSelectedInstOperands,
     /* 106906 */   // GIR_Coverage, 7103,
     /* 106906 */   GIR_EraseRootFromParent_Done,
     /* 106907 */ // Label 1642: @106907
     /* 106907 */ GIM_Try, /*On fail goto*//*Label 1643*/ GIMT_Encode4(106979), // Rule ID 7104 //
     /* 106912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106919 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106923 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 106930 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 106934 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 106941 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 106944 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 106948 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 106950 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 106957 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>)  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 106957 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 106960 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 106962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 106967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 106972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 106977 */   GIR_RootConstrainSelectedInstOperands,
     /* 106978 */   // GIR_Coverage, 7104,
     /* 106978 */   GIR_EraseRootFromParent_Done,
     /* 106979 */ // Label 1643: @106979
     /* 106979 */ GIM_Try, /*On fail goto*//*Label 1644*/ GIMT_Encode4(107051), // Rule ID 7105 //
     /* 106984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 106987 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 106991 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 106995 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 106999 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 107002 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 107006 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 107013 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 107016 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 107020 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107022 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 107029 */   // (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>)  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 107029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 107032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 107034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 107039 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 107044 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 107049 */   GIR_RootConstrainSelectedInstOperands,
     /* 107050 */   // GIR_Coverage, 7105,
     /* 107050 */   GIR_EraseRootFromParent_Done,
     /* 107051 */ // Label 1644: @107051
     /* 107051 */ GIM_Try, /*On fail goto*//*Label 1645*/ GIMT_Encode4(107107), // Rule ID 5810 //
     /* 107056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107063 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 107067 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 107071 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 107075 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 107079 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 107083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 107085 */   // (bitconvert:{ *:[f64] } (vector_extract:{ *:[i64] } v2i64:{ *:[v2i64] }:$src, 0:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2i64] }:$src, dsub:{ *:[i32] })
     /* 107085 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107088 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 107090 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // src
     /* 107096 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107101 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 107106 */   // GIR_Coverage, 5810,
     /* 107106 */   GIR_EraseRootFromParent_Done,
     /* 107107 */ // Label 1645: @107107
     /* 107107 */ GIM_Try, /*On fail goto*//*Label 1646*/ GIMT_Encode4(107137), // Rule ID 6684 //
     /* 107112 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107115 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107118 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107122 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107126 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] })
     /* 107126 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107131 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107136 */   // GIR_Coverage, 6684,
     /* 107136 */   GIR_Done,
     /* 107137 */ // Label 1646: @107137
     /* 107137 */ GIM_Try, /*On fail goto*//*Label 1647*/ GIMT_Encode4(107167), // Rule ID 6685 //
     /* 107142 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107145 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107152 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107156 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] })
     /* 107156 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107166 */   // GIR_Coverage, 6685,
     /* 107166 */   GIR_Done,
     /* 107167 */ // Label 1647: @107167
     /* 107167 */ GIM_Try, /*On fail goto*//*Label 1648*/ GIMT_Encode4(107197), // Rule ID 6686 //
     /* 107172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107186 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] })
     /* 107186 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107191 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107196 */   // GIR_Coverage, 6686,
     /* 107196 */   GIR_Done,
     /* 107197 */ // Label 1648: @107197
     /* 107197 */ GIM_Try, /*On fail goto*//*Label 1649*/ GIMT_Encode4(107227), // Rule ID 6687 //
     /* 107202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107216 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] })
     /* 107216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107221 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107226 */   // GIR_Coverage, 6687,
     /* 107226 */   GIR_Done,
     /* 107227 */ // Label 1649: @107227
     /* 107227 */ GIM_Try, /*On fail goto*//*Label 1650*/ GIMT_Encode4(107257), // Rule ID 6688 //
     /* 107232 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107235 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107246 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] })
     /* 107246 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107251 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107256 */   // GIR_Coverage, 6688,
     /* 107256 */   GIR_Done,
     /* 107257 */ // Label 1650: @107257
     /* 107257 */ GIM_Try, /*On fail goto*//*Label 1651*/ GIMT_Encode4(107287), // Rule ID 6689 //
     /* 107262 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107265 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107276 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107281 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107286 */   // GIR_Coverage, 6689,
     /* 107286 */   GIR_Done,
     /* 107287 */ // Label 1651: @107287
     /* 107287 */ GIM_Try, /*On fail goto*//*Label 1652*/ GIMT_Encode4(107337), // Rule ID 6695 //
     /* 107292 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107295 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107298 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107302 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107306 */   // (bitconvert:{ *:[i64] } V64:{ *:[v8i8] }:$Vn)  =>  (REV64v8i8:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v8i8] }:$Vn, GPR64:{ *:[i32] }))
     /* 107306 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107309 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107313 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107318 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107327 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107330 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107332 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107335 */   GIR_RootConstrainSelectedInstOperands,
     /* 107336 */   // GIR_Coverage, 6695,
     /* 107336 */   GIR_EraseRootFromParent_Done,
     /* 107337 */ // Label 1652: @107337
     /* 107337 */ GIM_Try, /*On fail goto*//*Label 1653*/ GIMT_Encode4(107387), // Rule ID 6696 //
     /* 107342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107356 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4i16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4i16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107356 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107359 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107363 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107368 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107377 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107380 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107382 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107385 */   GIR_RootConstrainSelectedInstOperands,
     /* 107386 */   // GIR_Coverage, 6696,
     /* 107386 */   GIR_EraseRootFromParent_Done,
     /* 107387 */ // Label 1653: @107387
     /* 107387 */ GIM_Try, /*On fail goto*//*Label 1654*/ GIMT_Encode4(107437), // Rule ID 6697 //
     /* 107392 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107395 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107398 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107402 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107406 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2i32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2i32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107406 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107409 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107413 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107418 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107435 */   GIR_RootConstrainSelectedInstOperands,
     /* 107436 */   // GIR_Coverage, 6697,
     /* 107436 */   GIR_EraseRootFromParent_Done,
     /* 107437 */ // Label 1654: @107437
     /* 107437 */ GIM_Try, /*On fail goto*//*Label 1655*/ GIMT_Encode4(107487), // Rule ID 6698 //
     /* 107442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107456 */   // (bitconvert:{ *:[i64] } V64:{ *:[v4f16] }:$Vn)  =>  (REV64v4i16:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v4f16] }:$Vn, GPR64:{ *:[i32] }))
     /* 107456 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107459 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107463 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107468 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107477 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107480 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107482 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107485 */   GIR_RootConstrainSelectedInstOperands,
     /* 107486 */   // GIR_Coverage, 6698,
     /* 107486 */   GIR_EraseRootFromParent_Done,
     /* 107487 */ // Label 1655: @107487
     /* 107487 */ GIM_Try, /*On fail goto*//*Label 1656*/ GIMT_Encode4(107537), // Rule ID 6699 //
     /* 107492 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107498 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107502 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107506 */   // (bitconvert:{ *:[i64] } V64:{ *:[v2f32] }:$Vn)  =>  (REV64v2i32:{ *:[i64] } (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v2f32] }:$Vn, GPR64:{ *:[i32] }))
     /* 107506 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 107509 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107513 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 107518 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Vn
     /* 107522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 107532 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 107535 */   GIR_RootConstrainSelectedInstOperands,
     /* 107536 */   // GIR_Coverage, 6699,
     /* 107536 */   GIR_EraseRootFromParent_Done,
     /* 107537 */ // Label 1656: @107537
     /* 107537 */ GIM_Try, /*On fail goto*//*Label 1657*/ GIMT_Encode4(107564), // Rule ID 6700 //
     /* 107542 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107545 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107549 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107553 */   // (bitconvert:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107553 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107558 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107563 */   // GIR_Coverage, 6700,
     /* 107563 */   GIR_Done,
     /* 107564 */ // Label 1657: @107564
     /* 107564 */ GIM_Try, /*On fail goto*//*Label 1658*/ GIMT_Encode4(107591), // Rule ID 6701 //
     /* 107569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107580 */   // (bitconvert:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107585 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107590 */   // GIR_Coverage, 6701,
     /* 107590 */   GIR_Done,
     /* 107591 */ // Label 1658: @107591
     /* 107591 */ GIM_Try, /*On fail goto*//*Label 1659*/ GIMT_Encode4(107618), // Rule ID 6702 //
     /* 107596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107603 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107607 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1i64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1i64] }:$Vn, GPR64:{ *:[i32] })
     /* 107607 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107612 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107617 */   // GIR_Coverage, 6702,
     /* 107617 */   GIR_Done,
     /* 107618 */ // Label 1659: @107618
     /* 107618 */ GIM_Try, /*On fail goto*//*Label 1660*/ GIMT_Encode4(107645), // Rule ID 6711 //
     /* 107623 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107626 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107630 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107634 */   // (bitconvert:{ *:[f64] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 107634 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107639 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107644 */   // GIR_Coverage, 6711,
     /* 107644 */   GIR_Done,
     /* 107645 */ // Label 1660: @107645
     /* 107645 */ GIM_Try, /*On fail goto*//*Label 1661*/ GIMT_Encode4(107672), // Rule ID 6712 //
     /* 107650 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107653 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107657 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107661 */   // (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } FPR64:{ *:[f64] }:$Xn, GPR64:{ *:[i32] })
     /* 107661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107666 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107671 */   // GIR_Coverage, 6712,
     /* 107671 */   GIR_Done,
     /* 107672 */ // Label 1661: @107672
     /* 107672 */ GIM_Try, /*On fail goto*//*Label 1662*/ GIMT_Encode4(107699), // Rule ID 6713 //
     /* 107677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107688 */   // (bitconvert:{ *:[i64] } V64:{ *:[v1f64] }:$Vn)  =>  (COPY_TO_REGCLASS:{ *:[i64] } V64:{ *:[v1f64] }:$Vn, GPR64:{ *:[i32] })
     /* 107688 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107693 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 107698 */   // GIR_Coverage, 6713,
     /* 107698 */   GIR_Done,
     /* 107699 */ // Label 1662: @107699
     /* 107699 */ GIM_Try, /*On fail goto*//*Label 1663*/ GIMT_Encode4(107731), // Rule ID 6714 //
     /* 107704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107718 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107721 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107723 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107725 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107730 */   // GIR_Coverage, 6714,
     /* 107730 */   GIR_EraseRootFromParent_Done,
     /* 107731 */ // Label 1663: @107731
     /* 107731 */ GIM_Try, /*On fail goto*//*Label 1664*/ GIMT_Encode4(107763), // Rule ID 6715 //
     /* 107736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107750 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107753 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107755 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107757 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107762 */   // GIR_Coverage, 6715,
     /* 107762 */   GIR_EraseRootFromParent_Done,
     /* 107763 */ // Label 1664: @107763
     /* 107763 */ GIM_Try, /*On fail goto*//*Label 1665*/ GIMT_Encode4(107795), // Rule ID 6716 //
     /* 107768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107782 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107785 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107787 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107789 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107794 */   // GIR_Coverage, 6716,
     /* 107794 */   GIR_EraseRootFromParent_Done,
     /* 107795 */ // Label 1665: @107795
     /* 107795 */ GIM_Try, /*On fail goto*//*Label 1666*/ GIMT_Encode4(107827), // Rule ID 6717 //
     /* 107800 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107806 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107810 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107814 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107814 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107817 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107819 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107821 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107826 */   // GIR_Coverage, 6717,
     /* 107826 */   GIR_EraseRootFromParent_Done,
     /* 107827 */ // Label 1666: @107827
     /* 107827 */ GIM_Try, /*On fail goto*//*Label 1667*/ GIMT_Encode4(107859), // Rule ID 6718 //
     /* 107832 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 107835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107838 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107842 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107846 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 107846 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 107849 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 107851 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 107853 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107858 */   // GIR_Coverage, 6718,
     /* 107858 */   GIR_EraseRootFromParent_Done,
     /* 107859 */ // Label 1667: @107859
     /* 107859 */ GIM_Try, /*On fail goto*//*Label 1668*/ GIMT_Encode4(107885), // Rule ID 6719 //
     /* 107864 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107878 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2i32] }:$src)
     /* 107878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107883 */   GIR_RootConstrainSelectedInstOperands,
     /* 107884 */   // GIR_Coverage, 6719,
     /* 107884 */   GIR_Done,
     /* 107885 */ // Label 1668: @107885
     /* 107885 */ GIM_Try, /*On fail goto*//*Label 1669*/ GIMT_Encode4(107911), // Rule ID 6720 //
     /* 107890 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107893 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107896 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107900 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107904 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4i16] }:$src)
     /* 107904 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107909 */   GIR_RootConstrainSelectedInstOperands,
     /* 107910 */   // GIR_Coverage, 6720,
     /* 107910 */   GIR_Done,
     /* 107911 */ // Label 1669: @107911
     /* 107911 */ GIM_Try, /*On fail goto*//*Label 1670*/ GIMT_Encode4(107937), // Rule ID 6721 //
     /* 107916 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 107922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107926 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107930 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1i64] } FPR64:{ *:[v8i8] }:$src)
     /* 107930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 107935 */   GIR_RootConstrainSelectedInstOperands,
     /* 107936 */   // GIR_Coverage, 6721,
     /* 107936 */   GIR_Done,
     /* 107937 */ // Label 1670: @107937
     /* 107937 */ GIM_Try, /*On fail goto*//*Label 1671*/ GIMT_Encode4(107963), // Rule ID 6722 //
     /* 107942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 107948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107956 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1i64] } FPR64:{ *:[v4f16] }:$src)
     /* 107956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 107961 */   GIR_RootConstrainSelectedInstOperands,
     /* 107962 */   // GIR_Coverage, 6722,
     /* 107962 */   GIR_Done,
     /* 107963 */ // Label 1671: @107963
     /* 107963 */ GIM_Try, /*On fail goto*//*Label 1672*/ GIMT_Encode4(107989), // Rule ID 6723 //
     /* 107968 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 107971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 107974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 107982 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1i64] } FPR64:{ *:[v2f32] }:$src)
     /* 107982 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 107987 */   GIR_RootConstrainSelectedInstOperands,
     /* 107988 */   // GIR_Coverage, 6723,
     /* 107988 */   GIR_Done,
     /* 107989 */ // Label 1672: @107989
     /* 107989 */ GIM_Try, /*On fail goto*//*Label 1673*/ GIMT_Encode4(108018), // Rule ID 6724 //
     /* 107994 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 107997 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108001 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108005 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108008 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108010 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108012 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108017 */   // GIR_Coverage, 6724,
     /* 108017 */   GIR_EraseRootFromParent_Done,
     /* 108018 */ // Label 1673: @108018
     /* 108018 */ GIM_Try, /*On fail goto*//*Label 1674*/ GIMT_Encode4(108047), // Rule ID 6725 //
     /* 108023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108034 */   // (bitconvert:{ *:[v1i64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1i64] }:$src
     /* 108034 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108037 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108039 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108041 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108046 */   // GIR_Coverage, 6725,
     /* 108046 */   GIR_EraseRootFromParent_Done,
     /* 108047 */ // Label 1674: @108047
     /* 108047 */ GIM_Try, /*On fail goto*//*Label 1675*/ GIMT_Encode4(108079), // Rule ID 6779 //
     /* 108052 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108055 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108066 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108066 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108069 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108071 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108078 */   // GIR_Coverage, 6779,
     /* 108078 */   GIR_EraseRootFromParent_Done,
     /* 108079 */ // Label 1675: @108079
     /* 108079 */ GIM_Try, /*On fail goto*//*Label 1676*/ GIMT_Encode4(108111), // Rule ID 6780 //
     /* 108084 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108098 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108101 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108103 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108110 */   // GIR_Coverage, 6780,
     /* 108110 */   GIR_EraseRootFromParent_Done,
     /* 108111 */ // Label 1676: @108111
     /* 108111 */ GIM_Try, /*On fail goto*//*Label 1677*/ GIMT_Encode4(108143), // Rule ID 6781 //
     /* 108116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108126 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108130 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108130 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108133 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108135 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108137 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108142 */   // GIR_Coverage, 6781,
     /* 108142 */   GIR_EraseRootFromParent_Done,
     /* 108143 */ // Label 1677: @108143
     /* 108143 */ GIM_Try, /*On fail goto*//*Label 1678*/ GIMT_Encode4(108175), // Rule ID 6782 //
     /* 108148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108162 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108162 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108165 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108167 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108169 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108174 */   // GIR_Coverage, 6782,
     /* 108174 */   GIR_EraseRootFromParent_Done,
     /* 108175 */ // Label 1678: @108175
     /* 108175 */ GIM_Try, /*On fail goto*//*Label 1679*/ GIMT_Encode4(108207), // Rule ID 6783 //
     /* 108180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108194 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108197 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108199 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108201 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108206 */   // GIR_Coverage, 6783,
     /* 108206 */   GIR_EraseRootFromParent_Done,
     /* 108207 */ // Label 1679: @108207
     /* 108207 */ GIM_Try, /*On fail goto*//*Label 1680*/ GIMT_Encode4(108233), // Rule ID 6784 //
     /* 108212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108226 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108226 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108231 */   GIR_RootConstrainSelectedInstOperands,
     /* 108232 */   // GIR_Coverage, 6784,
     /* 108232 */   GIR_Done,
     /* 108233 */ // Label 1680: @108233
     /* 108233 */ GIM_Try, /*On fail goto*//*Label 1681*/ GIMT_Encode4(108259), // Rule ID 6785 //
     /* 108238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108248 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108252 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108257 */   GIR_RootConstrainSelectedInstOperands,
     /* 108258 */   // GIR_Coverage, 6785,
     /* 108258 */   GIR_Done,
     /* 108259 */ // Label 1681: @108259
     /* 108259 */ GIM_Try, /*On fail goto*//*Label 1682*/ GIMT_Encode4(108285), // Rule ID 6786 //
     /* 108264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108278 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108283 */   GIR_RootConstrainSelectedInstOperands,
     /* 108284 */   // GIR_Coverage, 6786,
     /* 108284 */   GIR_Done,
     /* 108285 */ // Label 1682: @108285
     /* 108285 */ GIM_Try, /*On fail goto*//*Label 1683*/ GIMT_Encode4(108311), // Rule ID 6787 //
     /* 108290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108304 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108304 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108309 */   GIR_RootConstrainSelectedInstOperands,
     /* 108310 */   // GIR_Coverage, 6787,
     /* 108310 */   GIR_Done,
     /* 108311 */ // Label 1683: @108311
     /* 108311 */ GIM_Try, /*On fail goto*//*Label 1684*/ GIMT_Encode4(108337), // Rule ID 6788 //
     /* 108316 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108330 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108335 */   GIR_RootConstrainSelectedInstOperands,
     /* 108336 */   // GIR_Coverage, 6788,
     /* 108336 */   GIR_Done,
     /* 108337 */ // Label 1684: @108337
     /* 108337 */ GIM_Try, /*On fail goto*//*Label 1685*/ GIMT_Encode4(108366), // Rule ID 6789 //
     /* 108342 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108349 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108353 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108356 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108358 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108360 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108365 */   // GIR_Coverage, 6789,
     /* 108365 */   GIR_EraseRootFromParent_Done,
     /* 108366 */ // Label 1685: @108366
     /* 108366 */ GIM_Try, /*On fail goto*//*Label 1686*/ GIMT_Encode4(108395), // Rule ID 6790 //
     /* 108371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108382 */   // (bitconvert:{ *:[f64] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[f64] }:$src
     /* 108382 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108385 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108387 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108389 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108394 */   // GIR_Coverage, 6790,
     /* 108394 */   GIR_EraseRootFromParent_Done,
     /* 108395 */ // Label 1686: @108395
     /* 108395 */ GIM_Try, /*On fail goto*//*Label 1687*/ GIMT_Encode4(108427), // Rule ID 6791 //
     /* 108400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108414 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108426 */   // GIR_Coverage, 6791,
     /* 108426 */   GIR_EraseRootFromParent_Done,
     /* 108427 */ // Label 1687: @108427
     /* 108427 */ GIM_Try, /*On fail goto*//*Label 1688*/ GIMT_Encode4(108459), // Rule ID 6792 //
     /* 108432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108446 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108458 */   // GIR_Coverage, 6792,
     /* 108458 */   GIR_EraseRootFromParent_Done,
     /* 108459 */ // Label 1688: @108459
     /* 108459 */ GIM_Try, /*On fail goto*//*Label 1689*/ GIMT_Encode4(108491), // Rule ID 6793 //
     /* 108464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108478 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108490 */   // GIR_Coverage, 6793,
     /* 108490 */   GIR_EraseRootFromParent_Done,
     /* 108491 */ // Label 1689: @108491
     /* 108491 */ GIM_Try, /*On fail goto*//*Label 1690*/ GIMT_Encode4(108523), // Rule ID 6794 //
     /* 108496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108510 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108522 */   // GIR_Coverage, 6794,
     /* 108522 */   GIR_EraseRootFromParent_Done,
     /* 108523 */ // Label 1690: @108523
     /* 108523 */ GIM_Try, /*On fail goto*//*Label 1691*/ GIMT_Encode4(108555), // Rule ID 6795 //
     /* 108528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108542 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108554 */   // GIR_Coverage, 6795,
     /* 108554 */   GIR_EraseRootFromParent_Done,
     /* 108555 */ // Label 1691: @108555
     /* 108555 */ GIM_Try, /*On fail goto*//*Label 1692*/ GIMT_Encode4(108581), // Rule ID 6796 //
     /* 108560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108574 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2i32] }:$src)
     /* 108574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108579 */   GIR_RootConstrainSelectedInstOperands,
     /* 108580 */   // GIR_Coverage, 6796,
     /* 108580 */   GIR_Done,
     /* 108581 */ // Label 1692: @108581
     /* 108581 */ GIM_Try, /*On fail goto*//*Label 1693*/ GIMT_Encode4(108607), // Rule ID 6797 //
     /* 108586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108596 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108600 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4i16] }:$src)
     /* 108600 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108605 */   GIR_RootConstrainSelectedInstOperands,
     /* 108606 */   // GIR_Coverage, 6797,
     /* 108606 */   GIR_Done,
     /* 108607 */ // Label 1693: @108607
     /* 108607 */ GIM_Try, /*On fail goto*//*Label 1694*/ GIMT_Encode4(108633), // Rule ID 6798 //
     /* 108612 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 108618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108626 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)  =>  (REV64v8i8:{ *:[v1f64] } FPR64:{ *:[v8i8] }:$src)
     /* 108626 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 108631 */   GIR_RootConstrainSelectedInstOperands,
     /* 108632 */   // GIR_Coverage, 6798,
     /* 108632 */   GIR_Done,
     /* 108633 */ // Label 1694: @108633
     /* 108633 */ GIM_Try, /*On fail goto*//*Label 1695*/ GIMT_Encode4(108659), // Rule ID 6799 //
     /* 108638 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108641 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 108644 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108648 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108652 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)  =>  (REV64v2i32:{ *:[v1f64] } FPR64:{ *:[v2f32] }:$src)
     /* 108652 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 108657 */   GIR_RootConstrainSelectedInstOperands,
     /* 108658 */   // GIR_Coverage, 6799,
     /* 108658 */   GIR_Done,
     /* 108659 */ // Label 1695: @108659
     /* 108659 */ GIM_Try, /*On fail goto*//*Label 1696*/ GIMT_Encode4(108685), // Rule ID 6800 //
     /* 108664 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 108670 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108674 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108678 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)  =>  (REV64v4i16:{ *:[v1f64] } FPR64:{ *:[v4f16] }:$src)
     /* 108678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 108683 */   GIR_RootConstrainSelectedInstOperands,
     /* 108684 */   // GIR_Coverage, 6800,
     /* 108684 */   GIR_Done,
     /* 108685 */ // Label 1696: @108685
     /* 108685 */ GIM_Try, /*On fail goto*//*Label 1697*/ GIMT_Encode4(108714), // Rule ID 6801 //
     /* 108690 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108697 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108701 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108701 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108704 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108706 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108708 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108713 */   // GIR_Coverage, 6801,
     /* 108713 */   GIR_EraseRootFromParent_Done,
     /* 108714 */ // Label 1697: @108714
     /* 108714 */ GIM_Try, /*On fail goto*//*Label 1698*/ GIMT_Encode4(108743), // Rule ID 6802 //
     /* 108719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 108722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108726 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108730 */   // (bitconvert:{ *:[v1f64] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v1f64] }:$src
     /* 108730 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108733 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108735 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108737 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 108742 */   // GIR_Coverage, 6802,
     /* 108742 */   GIR_EraseRootFromParent_Done,
     /* 108743 */ // Label 1698: @108743
     /* 108743 */ GIM_Reject,
     /* 108744 */ // Label 1618: @108744
     /* 108744 */ GIM_Try, /*On fail goto*//*Label 1699*/ GIMT_Encode4(108776), // Rule ID 6816 //
     /* 108749 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108752 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108759 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108763 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108763 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108766 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108768 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108770 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108775 */   // GIR_Coverage, 6816,
     /* 108775 */   GIR_EraseRootFromParent_Done,
     /* 108776 */ // Label 1699: @108776
     /* 108776 */ GIM_Try, /*On fail goto*//*Label 1700*/ GIMT_Encode4(108808), // Rule ID 6817 //
     /* 108781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108787 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108791 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108795 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108795 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108798 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108800 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108807 */   // GIR_Coverage, 6817,
     /* 108807 */   GIR_EraseRootFromParent_Done,
     /* 108808 */ // Label 1700: @108808
     /* 108808 */ GIM_Try, /*On fail goto*//*Label 1701*/ GIMT_Encode4(108840), // Rule ID 6818 //
     /* 108813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108827 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108827 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108830 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108832 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108834 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108839 */   // GIR_Coverage, 6818,
     /* 108839 */   GIR_EraseRootFromParent_Done,
     /* 108840 */ // Label 1701: @108840
     /* 108840 */ GIM_Try, /*On fail goto*//*Label 1702*/ GIMT_Encode4(108872), // Rule ID 6819 //
     /* 108845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108859 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108862 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108864 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108866 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108871 */   // GIR_Coverage, 6819,
     /* 108871 */   GIR_EraseRootFromParent_Done,
     /* 108872 */ // Label 1702: @108872
     /* 108872 */ GIM_Try, /*On fail goto*//*Label 1703*/ GIMT_Encode4(108904), // Rule ID 6820 //
     /* 108877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 108883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108891 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108891 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108894 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108896 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108898 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108903 */   // GIR_Coverage, 6820,
     /* 108903 */   GIR_EraseRootFromParent_Done,
     /* 108904 */ // Label 1703: @108904
     /* 108904 */ GIM_Try, /*On fail goto*//*Label 1704*/ GIMT_Encode4(108936), // Rule ID 6821 //
     /* 108909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 108915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108919 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108923 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108923 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108926 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108928 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108930 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108935 */   // GIR_Coverage, 6821,
     /* 108935 */   GIR_EraseRootFromParent_Done,
     /* 108936 */ // Label 1704: @108936
     /* 108936 */ GIM_Try, /*On fail goto*//*Label 1705*/ GIMT_Encode4(108968), // Rule ID 6822 //
     /* 108941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 108944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 108947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108955 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[f128] }:$src
     /* 108955 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 108958 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 108960 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108962 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108967 */   // GIR_Coverage, 6822,
     /* 108967 */   GIR_EraseRootFromParent_Done,
     /* 108968 */ // Label 1705: @108968
     /* 108968 */ GIM_Try, /*On fail goto*//*Label 1706*/ GIMT_Encode4(109001), // Rule ID 6823 //
     /* 108973 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 108976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 108979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 108987 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2i64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2i64] }:$src, FPR128:{ *:[v2i64] }:$src, 8:{ *:[i32] })
     /* 108987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 108990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 108992 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108994 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 108996 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 108999 */   GIR_RootConstrainSelectedInstOperands,
     /* 109000 */   // GIR_Coverage, 6823,
     /* 109000 */   GIR_EraseRootFromParent_Done,
     /* 109001 */ // Label 1706: @109001
     /* 109001 */ GIM_Try, /*On fail goto*//*Label 1707*/ GIMT_Encode4(109072), // Rule ID 6824 //
     /* 109006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109020 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4i32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4i32] }:$src), 8:{ *:[i32] })
     /* 109020 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109023 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109027 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109032 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109036 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109038 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109041 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109045 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109050 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109054 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109056 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109059 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109061 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109064 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109067 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109070 */   GIR_RootConstrainSelectedInstOperands,
     /* 109071 */   // GIR_Coverage, 6824,
     /* 109071 */   GIR_EraseRootFromParent_Done,
     /* 109072 */ // Label 1707: @109072
     /* 109072 */ GIM_Try, /*On fail goto*//*Label 1708*/ GIMT_Encode4(109143), // Rule ID 6825 //
     /* 109077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109091 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8i16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8i16] }:$src), 8:{ *:[i32] })
     /* 109091 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109094 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109098 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109103 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109107 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109109 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109112 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109116 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109121 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109132 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109135 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109138 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109141 */   GIR_RootConstrainSelectedInstOperands,
     /* 109142 */   // GIR_Coverage, 6825,
     /* 109142 */   GIR_EraseRootFromParent_Done,
     /* 109143 */ // Label 1708: @109143
     /* 109143 */ GIM_Try, /*On fail goto*//*Label 1709*/ GIMT_Encode4(109214), // Rule ID 6826 //
     /* 109148 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 109154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109158 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109162 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v8f16] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[v8f16] }:$src), 8:{ *:[i32] })
     /* 109162 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109165 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109169 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109174 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109178 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109180 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109183 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 109187 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109192 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109196 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109198 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109201 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109203 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109206 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109209 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109212 */   GIR_RootConstrainSelectedInstOperands,
     /* 109213 */   // GIR_Coverage, 6826,
     /* 109213 */   GIR_EraseRootFromParent_Done,
     /* 109214 */ // Label 1709: @109214
     /* 109214 */ GIM_Try, /*On fail goto*//*Label 1710*/ GIMT_Encode4(109247), // Rule ID 6827 //
     /* 109219 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 109225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109233 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v2f64] }:$src)  =>  (EXTv16i8:{ *:[f128] } FPR128:{ *:[v2f64] }:$src, FPR128:{ *:[v2f64] }:$src, 8:{ *:[i32] })
     /* 109233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109238 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109245 */   GIR_RootConstrainSelectedInstOperands,
     /* 109246 */   // GIR_Coverage, 6827,
     /* 109246 */   GIR_EraseRootFromParent_Done,
     /* 109247 */ // Label 1710: @109247
     /* 109247 */ GIM_Try, /*On fail goto*//*Label 1711*/ GIMT_Encode4(109318), // Rule ID 6828 //
     /* 109252 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109255 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 109258 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109262 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109266 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v4f32] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[v4f32] }:$src), 8:{ *:[i32] })
     /* 109266 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109269 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109273 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109278 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109282 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109284 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109287 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 109291 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109296 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109302 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109305 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109307 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109310 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109313 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109316 */   GIR_RootConstrainSelectedInstOperands,
     /* 109317 */   // GIR_Coverage, 6828,
     /* 109317 */   GIR_EraseRootFromParent_Done,
     /* 109318 */ // Label 1711: @109318
     /* 109318 */ GIM_Try, /*On fail goto*//*Label 1712*/ GIMT_Encode4(109389), // Rule ID 6829 //
     /* 109323 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 109329 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109333 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 109337 */   // (bitconvert:{ *:[f128] } FPR128:{ *:[v16i8] }:$src)  =>  (EXTv16i8:{ *:[f128] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[v16i8] }:$src), 8:{ *:[i32] })
     /* 109337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 109340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109349 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 109355 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 109358 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 109362 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109367 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 109371 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 109373 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 109376 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109378 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109381 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 109384 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 109387 */   GIR_RootConstrainSelectedInstOperands,
     /* 109388 */   // GIR_Coverage, 6829,
     /* 109388 */   GIR_EraseRootFromParent_Done,
     /* 109389 */ // Label 1712: @109389
     /* 109389 */ GIM_Reject,
     /* 109390 */ // Label 1619: @109390
     /* 109390 */ GIM_Try, /*On fail goto*//*Label 1713*/ GIMT_Encode4(109420), // Rule ID 6681 //
     /* 109395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109401 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109405 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109409 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109409 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109414 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109419 */   // GIR_Coverage, 6681,
     /* 109419 */   GIR_Done,
     /* 109420 */ // Label 1713: @109420
     /* 109420 */ GIM_Try, /*On fail goto*//*Label 1714*/ GIMT_Encode4(109450), // Rule ID 6683 //
     /* 109425 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109435 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109439 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 109439 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109444 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109449 */   // GIR_Coverage, 6683,
     /* 109449 */   GIR_Done,
     /* 109450 */ // Label 1714: @109450
     /* 109450 */ GIM_Try, /*On fail goto*//*Label 1715*/ GIMT_Encode4(109500), // Rule ID 6692 //
     /* 109455 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109458 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109461 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109465 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109469 */   // (bitconvert:{ *:[v2i32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2i32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109469 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109472 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109476 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109481 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109485 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109495 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109498 */   GIR_RootConstrainSelectedInstOperands,
     /* 109499 */   // GIR_Coverage, 6692,
     /* 109499 */   GIR_EraseRootFromParent_Done,
     /* 109500 */ // Label 1715: @109500
     /* 109500 */ GIM_Try, /*On fail goto*//*Label 1716*/ GIMT_Encode4(109550), // Rule ID 6694 //
     /* 109505 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109508 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109515 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 109519 */   // (bitconvert:{ *:[v2f32] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v2i32:{ *:[v2f32] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 109519 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 109522 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109526 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 109531 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 109535 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109540 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109543 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 109545 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 109548 */   GIR_RootConstrainSelectedInstOperands,
     /* 109549 */   // GIR_Coverage, 6694,
     /* 109549 */   GIR_EraseRootFromParent_Done,
     /* 109550 */ // Label 1716: @109550
     /* 109550 */ GIM_Try, /*On fail goto*//*Label 1717*/ GIMT_Encode4(109582), // Rule ID 6726 //
     /* 109555 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109561 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109565 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109569 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109572 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109574 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109581 */   // GIR_Coverage, 6726,
     /* 109581 */   GIR_EraseRootFromParent_Done,
     /* 109582 */ // Label 1717: @109582
     /* 109582 */ GIM_Try, /*On fail goto*//*Label 1718*/ GIMT_Encode4(109614), // Rule ID 6727 //
     /* 109587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109601 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109604 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109606 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109608 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109613 */   // GIR_Coverage, 6727,
     /* 109613 */   GIR_EraseRootFromParent_Done,
     /* 109614 */ // Label 1718: @109614
     /* 109614 */ GIM_Try, /*On fail goto*//*Label 1719*/ GIMT_Encode4(109646), // Rule ID 6728 //
     /* 109619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109633 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109636 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109638 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109645 */   // GIR_Coverage, 6728,
     /* 109645 */   GIR_EraseRootFromParent_Done,
     /* 109646 */ // Label 1719: @109646
     /* 109646 */ GIM_Try, /*On fail goto*//*Label 1720*/ GIMT_Encode4(109678), // Rule ID 6729 //
     /* 109651 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109654 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109661 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109665 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109665 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109668 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109670 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109677 */   // GIR_Coverage, 6729,
     /* 109677 */   GIR_EraseRootFromParent_Done,
     /* 109678 */ // Label 1720: @109678
     /* 109678 */ GIM_Try, /*On fail goto*//*Label 1721*/ GIMT_Encode4(109710), // Rule ID 6730 //
     /* 109683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109689 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109693 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109697 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109700 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109702 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109709 */   // GIR_Coverage, 6730,
     /* 109709 */   GIR_EraseRootFromParent_Done,
     /* 109710 */ // Label 1721: @109710
     /* 109710 */ GIM_Try, /*On fail goto*//*Label 1722*/ GIMT_Encode4(109742), // Rule ID 6731 //
     /* 109715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109729 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109729 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109732 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109734 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109736 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109741 */   // GIR_Coverage, 6731,
     /* 109741 */   GIR_EraseRootFromParent_Done,
     /* 109742 */ // Label 1722: @109742
     /* 109742 */ GIM_Try, /*On fail goto*//*Label 1723*/ GIMT_Encode4(109768), // Rule ID 6732 //
     /* 109747 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109750 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109753 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109757 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109761 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1i64] }:$src)
     /* 109761 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109766 */   GIR_RootConstrainSelectedInstOperands,
     /* 109767 */   // GIR_Coverage, 6732,
     /* 109767 */   GIR_Done,
     /* 109768 */ // Label 1723: @109768
     /* 109768 */ GIM_Try, /*On fail goto*//*Label 1724*/ GIMT_Encode4(109794), // Rule ID 6733 //
     /* 109773 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109779 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109783 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109787 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4i16] }:$src)
     /* 109787 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109792 */   GIR_RootConstrainSelectedInstOperands,
     /* 109793 */   // GIR_Coverage, 6733,
     /* 109793 */   GIR_Done,
     /* 109794 */ // Label 1724: @109794
     /* 109794 */ GIM_Try, /*On fail goto*//*Label 1725*/ GIMT_Encode4(109820), // Rule ID 6734 //
     /* 109799 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 109805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109813 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2i32] } FPR64:{ *:[v8i8] }:$src)
     /* 109813 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 109818 */   GIR_RootConstrainSelectedInstOperands,
     /* 109819 */   // GIR_Coverage, 6734,
     /* 109819 */   GIR_Done,
     /* 109820 */ // Label 1725: @109820
     /* 109820 */ GIM_Try, /*On fail goto*//*Label 1726*/ GIMT_Encode4(109846), // Rule ID 6735 //
     /* 109825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109839 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[f64] }:$src)
     /* 109839 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109844 */   GIR_RootConstrainSelectedInstOperands,
     /* 109845 */   // GIR_Coverage, 6735,
     /* 109845 */   GIR_Done,
     /* 109846 */ // Label 1726: @109846
     /* 109846 */ GIM_Try, /*On fail goto*//*Label 1727*/ GIMT_Encode4(109872), // Rule ID 6736 //
     /* 109851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109865 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2i32] } FPR64:{ *:[v1f64] }:$src)
     /* 109865 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 109870 */   GIR_RootConstrainSelectedInstOperands,
     /* 109871 */   // GIR_Coverage, 6736,
     /* 109871 */   GIR_Done,
     /* 109872 */ // Label 1727: @109872
     /* 109872 */ GIM_Try, /*On fail goto*//*Label 1728*/ GIMT_Encode4(109898), // Rule ID 6737 //
     /* 109877 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 109880 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109883 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109887 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109891 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2i32] } FPR64:{ *:[v4f16] }:$src)
     /* 109891 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 109896 */   GIR_RootConstrainSelectedInstOperands,
     /* 109897 */   // GIR_Coverage, 6737,
     /* 109897 */   GIR_Done,
     /* 109898 */ // Label 1728: @109898
     /* 109898 */ GIM_Try, /*On fail goto*//*Label 1729*/ GIMT_Encode4(109927), // Rule ID 6738 //
     /* 109903 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 109906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109914 */   // (bitconvert:{ *:[v2i32] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v2i32] }:$src
     /* 109914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109917 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109919 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109921 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109926 */   // GIR_Coverage, 6738,
     /* 109926 */   GIR_EraseRootFromParent_Done,
     /* 109927 */ // Label 1729: @109927
     /* 109927 */ GIM_Try, /*On fail goto*//*Label 1730*/ GIMT_Encode4(109959), // Rule ID 6803 //
     /* 109932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 109938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109946 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109946 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109949 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109951 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109958 */   // GIR_Coverage, 6803,
     /* 109958 */   GIR_EraseRootFromParent_Done,
     /* 109959 */ // Label 1730: @109959
     /* 109959 */ GIM_Try, /*On fail goto*//*Label 1731*/ GIMT_Encode4(109991), // Rule ID 6804 //
     /* 109964 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 109970 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109978 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 109978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 109981 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 109983 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 109985 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 109990 */   // GIR_Coverage, 6804,
     /* 109990 */   GIR_EraseRootFromParent_Done,
     /* 109991 */ // Label 1731: @109991
     /* 109991 */ GIM_Try, /*On fail goto*//*Label 1732*/ GIMT_Encode4(110023), // Rule ID 6805 //
     /* 109996 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 109999 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110010 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110010 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110013 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110015 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110017 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110022 */   // GIR_Coverage, 6805,
     /* 110022 */   GIR_EraseRootFromParent_Done,
     /* 110023 */ // Label 1732: @110023
     /* 110023 */ GIM_Try, /*On fail goto*//*Label 1733*/ GIMT_Encode4(110055), // Rule ID 6806 //
     /* 110028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110034 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110038 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110042 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110042 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110045 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110047 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110049 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110054 */   // GIR_Coverage, 6806,
     /* 110054 */   GIR_EraseRootFromParent_Done,
     /* 110055 */ // Label 1733: @110055
     /* 110055 */ GIM_Try, /*On fail goto*//*Label 1734*/ GIMT_Encode4(110087), // Rule ID 6807 //
     /* 110060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110074 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110074 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110077 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110079 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110081 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110086 */   // GIR_Coverage, 6807,
     /* 110086 */   GIR_EraseRootFromParent_Done,
     /* 110087 */ // Label 1734: @110087
     /* 110087 */ GIM_Try, /*On fail goto*//*Label 1735*/ GIMT_Encode4(110119), // Rule ID 6808 //
     /* 110092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110102 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110106 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110109 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110111 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110113 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110118 */   // GIR_Coverage, 6808,
     /* 110118 */   GIR_EraseRootFromParent_Done,
     /* 110119 */ // Label 1735: @110119
     /* 110119 */ GIM_Try, /*On fail goto*//*Label 1736*/ GIMT_Encode4(110145), // Rule ID 6809 //
     /* 110124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110138 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1i64] }:$src)
     /* 110138 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110143 */   GIR_RootConstrainSelectedInstOperands,
     /* 110144 */   // GIR_Coverage, 6809,
     /* 110144 */   GIR_Done,
     /* 110145 */ // Label 1736: @110145
     /* 110145 */ GIM_Try, /*On fail goto*//*Label 1737*/ GIMT_Encode4(110171), // Rule ID 6810 //
     /* 110150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110164 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4i16] }:$src)
     /* 110164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110169 */   GIR_RootConstrainSelectedInstOperands,
     /* 110170 */   // GIR_Coverage, 6810,
     /* 110170 */   GIR_Done,
     /* 110171 */ // Label 1737: @110171
     /* 110171 */ GIM_Try, /*On fail goto*//*Label 1738*/ GIMT_Encode4(110197), // Rule ID 6811 //
     /* 110176 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110179 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 110182 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110190 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)  =>  (REV32v8i8:{ *:[v2f32] } FPR64:{ *:[v8i8] }:$src)
     /* 110190 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 110195 */   GIR_RootConstrainSelectedInstOperands,
     /* 110196 */   // GIR_Coverage, 6811,
     /* 110196 */   GIR_Done,
     /* 110197 */ // Label 1738: @110197
     /* 110197 */ GIM_Try, /*On fail goto*//*Label 1739*/ GIMT_Encode4(110223), // Rule ID 6812 //
     /* 110202 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110208 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110212 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110216 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[v1f64] }:$src)
     /* 110216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110221 */   GIR_RootConstrainSelectedInstOperands,
     /* 110222 */   // GIR_Coverage, 6812,
     /* 110222 */   GIR_Done,
     /* 110223 */ // Label 1739: @110223
     /* 110223 */ GIM_Try, /*On fail goto*//*Label 1740*/ GIMT_Encode4(110249), // Rule ID 6813 //
     /* 110228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 110234 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110238 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110242 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)  =>  (REV64v2i32:{ *:[v2f32] } FPR64:{ *:[f64] }:$src)
     /* 110242 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 110247 */   GIR_RootConstrainSelectedInstOperands,
     /* 110248 */   // GIR_Coverage, 6813,
     /* 110248 */   GIR_Done,
     /* 110249 */ // Label 1740: @110249
     /* 110249 */ GIM_Try, /*On fail goto*//*Label 1741*/ GIMT_Encode4(110275), // Rule ID 6814 //
     /* 110254 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110257 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 110260 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110264 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110268 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)  =>  (REV32v4i16:{ *:[v2f32] } FPR64:{ *:[v4f16] }:$src)
     /* 110268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 110273 */   GIR_RootConstrainSelectedInstOperands,
     /* 110274 */   // GIR_Coverage, 6814,
     /* 110274 */   GIR_Done,
     /* 110275 */ // Label 1741: @110275
     /* 110275 */ GIM_Try, /*On fail goto*//*Label 1742*/ GIMT_Encode4(110304), // Rule ID 6815 //
     /* 110280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 110283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110291 */   // (bitconvert:{ *:[v2f32] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v2f32] }:$src
     /* 110291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 110303 */   // GIR_Coverage, 6815,
     /* 110303 */   GIR_EraseRootFromParent_Done,
     /* 110304 */ // Label 1742: @110304
     /* 110304 */ GIM_Reject,
     /* 110305 */ // Label 1620: @110305
     /* 110305 */ GIM_Try, /*On fail goto*//*Label 1743*/ GIMT_Encode4(110337), // Rule ID 6830 //
     /* 110310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110320 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110324 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110324 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110327 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110329 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110331 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110336 */   // GIR_Coverage, 6830,
     /* 110336 */   GIR_EraseRootFromParent_Done,
     /* 110337 */ // Label 1743: @110337
     /* 110337 */ GIM_Try, /*On fail goto*//*Label 1744*/ GIMT_Encode4(110369), // Rule ID 6831 //
     /* 110342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110356 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110356 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110359 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110361 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110363 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110368 */   // GIR_Coverage, 6831,
     /* 110368 */   GIR_EraseRootFromParent_Done,
     /* 110369 */ // Label 1744: @110369
     /* 110369 */ GIM_Try, /*On fail goto*//*Label 1745*/ GIMT_Encode4(110401), // Rule ID 6832 //
     /* 110374 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110384 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110388 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110388 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110391 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110393 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110395 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110400 */   // GIR_Coverage, 6832,
     /* 110400 */   GIR_EraseRootFromParent_Done,
     /* 110401 */ // Label 1745: @110401
     /* 110401 */ GIM_Try, /*On fail goto*//*Label 1746*/ GIMT_Encode4(110433), // Rule ID 6833 //
     /* 110406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110416 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110420 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110420 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110423 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110425 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110427 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110432 */   // GIR_Coverage, 6833,
     /* 110432 */   GIR_EraseRootFromParent_Done,
     /* 110433 */ // Label 1746: @110433
     /* 110433 */ GIM_Try, /*On fail goto*//*Label 1747*/ GIMT_Encode4(110465), // Rule ID 6834 //
     /* 110438 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110441 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110448 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110452 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110452 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110455 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110457 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110459 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110464 */   // GIR_Coverage, 6834,
     /* 110464 */   GIR_EraseRootFromParent_Done,
     /* 110465 */ // Label 1747: @110465
     /* 110465 */ GIM_Try, /*On fail goto*//*Label 1748*/ GIMT_Encode4(110497), // Rule ID 6835 //
     /* 110470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110476 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110480 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110484 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110484 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110487 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110489 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110491 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110496 */   // GIR_Coverage, 6835,
     /* 110496 */   GIR_EraseRootFromParent_Done,
     /* 110497 */ // Label 1748: @110497
     /* 110497 */ GIM_Try, /*On fail goto*//*Label 1749*/ GIMT_Encode4(110530), // Rule ID 6836 //
     /* 110502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110508 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110512 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110516 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2f64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110521 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110523 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110525 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110528 */   GIR_RootConstrainSelectedInstOperands,
     /* 110529 */   // GIR_Coverage, 6836,
     /* 110529 */   GIR_EraseRootFromParent_Done,
     /* 110530 */ // Label 1749: @110530
     /* 110530 */ GIM_Try, /*On fail goto*//*Label 1750*/ GIMT_Encode4(110556), // Rule ID 6837 //
     /* 110535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110549 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4i32] }:$src)
     /* 110549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110554 */   GIR_RootConstrainSelectedInstOperands,
     /* 110555 */   // GIR_Coverage, 6837,
     /* 110555 */   GIR_Done,
     /* 110556 */ // Label 1750: @110556
     /* 110556 */ GIM_Try, /*On fail goto*//*Label 1751*/ GIMT_Encode4(110582), // Rule ID 6838 //
     /* 110561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110575 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8i16] }:$src)
     /* 110575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110580 */   GIR_RootConstrainSelectedInstOperands,
     /* 110581 */   // GIR_Coverage, 6838,
     /* 110581 */   GIR_Done,
     /* 110582 */ // Label 1751: @110582
     /* 110582 */ GIM_Try, /*On fail goto*//*Label 1752*/ GIMT_Encode4(110608), // Rule ID 6839 //
     /* 110587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110593 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110597 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110601 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2f64] } FPR128:{ *:[v8f16] }:$src)
     /* 110601 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110606 */   GIR_RootConstrainSelectedInstOperands,
     /* 110607 */   // GIR_Coverage, 6839,
     /* 110607 */   GIR_Done,
     /* 110608 */ // Label 1752: @110608
     /* 110608 */ GIM_Try, /*On fail goto*//*Label 1753*/ GIMT_Encode4(110634), // Rule ID 6840 //
     /* 110613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110627 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2f64] } FPR128:{ *:[v16i8] }:$src)
     /* 110627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110632 */   GIR_RootConstrainSelectedInstOperands,
     /* 110633 */   // GIR_Coverage, 6840,
     /* 110633 */   GIR_Done,
     /* 110634 */ // Label 1753: @110634
     /* 110634 */ GIM_Try, /*On fail goto*//*Label 1754*/ GIMT_Encode4(110660), // Rule ID 6841 //
     /* 110639 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110642 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110649 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110653 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2f64] } FPR128:{ *:[v4f32] }:$src)
     /* 110653 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110658 */   GIR_RootConstrainSelectedInstOperands,
     /* 110659 */   // GIR_Coverage, 6841,
     /* 110659 */   GIR_Done,
     /* 110660 */ // Label 1754: @110660
     /* 110660 */ GIM_Try, /*On fail goto*//*Label 1755*/ GIMT_Encode4(110689), // Rule ID 6842 //
     /* 110665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 110668 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110672 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110676 */   // (bitconvert:{ *:[v2f64] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v2f64] }:$src
     /* 110676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110679 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110681 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110683 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110688 */   // GIR_Coverage, 6842,
     /* 110688 */   GIR_EraseRootFromParent_Done,
     /* 110689 */ // Label 1755: @110689
     /* 110689 */ GIM_Try, /*On fail goto*//*Label 1756*/ GIMT_Encode4(110721), // Rule ID 6856 //
     /* 110694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110708 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110708 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110711 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110713 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110715 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110720 */   // GIR_Coverage, 6856,
     /* 110720 */   GIR_EraseRootFromParent_Done,
     /* 110721 */ // Label 1756: @110721
     /* 110721 */ GIM_Try, /*On fail goto*//*Label 1757*/ GIMT_Encode4(110753), // Rule ID 6857 //
     /* 110726 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110729 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110732 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110736 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110740 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110743 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110745 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110747 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110752 */   // GIR_Coverage, 6857,
     /* 110752 */   GIR_EraseRootFromParent_Done,
     /* 110753 */ // Label 1757: @110753
     /* 110753 */ GIM_Try, /*On fail goto*//*Label 1758*/ GIMT_Encode4(110785), // Rule ID 6858 //
     /* 110758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110768 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110772 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110772 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110775 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110777 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110779 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110784 */   // GIR_Coverage, 6858,
     /* 110784 */   GIR_EraseRootFromParent_Done,
     /* 110785 */ // Label 1758: @110785
     /* 110785 */ GIM_Try, /*On fail goto*//*Label 1759*/ GIMT_Encode4(110817), // Rule ID 6859 //
     /* 110790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110804 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110816 */   // GIR_Coverage, 6859,
     /* 110816 */   GIR_EraseRootFromParent_Done,
     /* 110817 */ // Label 1759: @110817
     /* 110817 */ GIM_Try, /*On fail goto*//*Label 1760*/ GIMT_Encode4(110849), // Rule ID 6860 //
     /* 110822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110836 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110848 */   // GIR_Coverage, 6860,
     /* 110848 */   GIR_EraseRootFromParent_Done,
     /* 110849 */ // Label 1760: @110849
     /* 110849 */ GIM_Try, /*On fail goto*//*Label 1761*/ GIMT_Encode4(110881), // Rule ID 6861 //
     /* 110854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 110857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110868 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 110868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 110871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 110873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110880 */   // GIR_Coverage, 6861,
     /* 110880 */   GIR_EraseRootFromParent_Done,
     /* 110881 */ // Label 1761: @110881
     /* 110881 */ GIM_Try, /*On fail goto*//*Label 1762*/ GIMT_Encode4(110914), // Rule ID 6862 //
     /* 110886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 110892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110900 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v2i64] } FPR128:{ *:[f128] }:$src, FPR128:{ *:[f128] }:$src, 8:{ *:[i32] })
     /* 110900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 110903 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 110905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110907 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 110909 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 110912 */   GIR_RootConstrainSelectedInstOperands,
     /* 110913 */   // GIR_Coverage, 6862,
     /* 110913 */   GIR_EraseRootFromParent_Done,
     /* 110914 */ // Label 1762: @110914
     /* 110914 */ GIM_Try, /*On fail goto*//*Label 1763*/ GIMT_Encode4(110940), // Rule ID 6863 //
     /* 110919 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110922 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 110925 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110929 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110933 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4i32] }:$src)
     /* 110933 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 110938 */   GIR_RootConstrainSelectedInstOperands,
     /* 110939 */   // GIR_Coverage, 6863,
     /* 110939 */   GIR_Done,
     /* 110940 */ // Label 1763: @110940
     /* 110940 */ GIM_Try, /*On fail goto*//*Label 1764*/ GIMT_Encode4(110966), // Rule ID 6864 //
     /* 110945 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 110951 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110955 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110959 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8i16] }:$src)
     /* 110959 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 110964 */   GIR_RootConstrainSelectedInstOperands,
     /* 110965 */   // GIR_Coverage, 6864,
     /* 110965 */   GIR_Done,
     /* 110966 */ // Label 1764: @110966
     /* 110966 */ GIM_Try, /*On fail goto*//*Label 1765*/ GIMT_Encode4(110992), // Rule ID 6865 //
     /* 110971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 110974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 110977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110981 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 110985 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)  =>  (REV64v16i8:{ *:[v2i64] } FPR128:{ *:[v16i8] }:$src)
     /* 110985 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 110990 */   GIR_RootConstrainSelectedInstOperands,
     /* 110991 */   // GIR_Coverage, 6865,
     /* 110991 */   GIR_Done,
     /* 110992 */ // Label 1765: @110992
     /* 110992 */ GIM_Try, /*On fail goto*//*Label 1766*/ GIMT_Encode4(111018), // Rule ID 6866 //
     /* 110997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 111003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111011 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)  =>  (REV64v4i32:{ *:[v2i64] } FPR128:{ *:[v4f32] }:$src)
     /* 111011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 111016 */   GIR_RootConstrainSelectedInstOperands,
     /* 111017 */   // GIR_Coverage, 6866,
     /* 111017 */   GIR_Done,
     /* 111018 */ // Label 1766: @111018
     /* 111018 */ GIM_Try, /*On fail goto*//*Label 1767*/ GIMT_Encode4(111044), // Rule ID 6867 //
     /* 111023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 111029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111033 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111037 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)  =>  (REV64v8i16:{ *:[v2i64] } FPR128:{ *:[v8f16] }:$src)
     /* 111037 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 111042 */   GIR_RootConstrainSelectedInstOperands,
     /* 111043 */   // GIR_Coverage, 6867,
     /* 111043 */   GIR_Done,
     /* 111044 */ // Label 1767: @111044
     /* 111044 */ GIM_Try, /*On fail goto*//*Label 1768*/ GIMT_Encode4(111073), // Rule ID 6868 //
     /* 111049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 111052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111060 */   // (bitconvert:{ *:[v2i64] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v2i64] }:$src
     /* 111060 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111063 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111065 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111067 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 111072 */   // GIR_Coverage, 6868,
     /* 111072 */   GIR_EraseRootFromParent_Done,
     /* 111073 */ // Label 1768: @111073
     /* 111073 */ GIM_Reject,
     /* 111074 */ // Label 1621: @111074
     /* 111074 */ GIM_Try, /*On fail goto*//*Label 1769*/ GIMT_Encode4(111104), // Rule ID 6680 //
     /* 111079 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111082 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111089 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111093 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111093 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111098 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111103 */   // GIR_Coverage, 6680,
     /* 111103 */   GIR_Done,
     /* 111104 */ // Label 1769: @111104
     /* 111104 */ GIM_Try, /*On fail goto*//*Label 1770*/ GIMT_Encode4(111134), // Rule ID 6682 //
     /* 111109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111119 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111123 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 111123 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111128 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111133 */   // GIR_Coverage, 6682,
     /* 111133 */   GIR_Done,
     /* 111134 */ // Label 1770: @111134
     /* 111134 */ GIM_Try, /*On fail goto*//*Label 1771*/ GIMT_Encode4(111184), // Rule ID 6691 //
     /* 111139 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111145 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111149 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111153 */   // (bitconvert:{ *:[v4i16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4i16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111165 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111174 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111177 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111179 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111182 */   GIR_RootConstrainSelectedInstOperands,
     /* 111183 */   // GIR_Coverage, 6691,
     /* 111183 */   GIR_EraseRootFromParent_Done,
     /* 111184 */ // Label 1771: @111184
     /* 111184 */ GIM_Try, /*On fail goto*//*Label 1772*/ GIMT_Encode4(111234), // Rule ID 6693 //
     /* 111189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 111203 */   // (bitconvert:{ *:[v4f16] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v4i16:{ *:[v4f16] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 111203 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 111206 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111210 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 111215 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 111219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111227 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 111229 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 111232 */   GIR_RootConstrainSelectedInstOperands,
     /* 111233 */   // GIR_Coverage, 6693,
     /* 111233 */   GIR_EraseRootFromParent_Done,
     /* 111234 */ // Label 1772: @111234
     /* 111234 */ GIM_Try, /*On fail goto*//*Label 1773*/ GIMT_Encode4(111266), // Rule ID 6739 //
     /* 111239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111253 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111256 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111258 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111260 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111265 */   // GIR_Coverage, 6739,
     /* 111265 */   GIR_EraseRootFromParent_Done,
     /* 111266 */ // Label 1773: @111266
     /* 111266 */ GIM_Try, /*On fail goto*//*Label 1774*/ GIMT_Encode4(111298), // Rule ID 6740 //
     /* 111271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111285 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111288 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111290 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111297 */   // GIR_Coverage, 6740,
     /* 111297 */   GIR_EraseRootFromParent_Done,
     /* 111298 */ // Label 1774: @111298
     /* 111298 */ GIM_Try, /*On fail goto*//*Label 1775*/ GIMT_Encode4(111330), // Rule ID 6741 //
     /* 111303 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111306 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111309 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111313 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111317 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111317 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111320 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111322 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111324 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111329 */   // GIR_Coverage, 6741,
     /* 111329 */   GIR_EraseRootFromParent_Done,
     /* 111330 */ // Label 1775: @111330
     /* 111330 */ GIM_Try, /*On fail goto*//*Label 1776*/ GIMT_Encode4(111362), // Rule ID 6742 //
     /* 111335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111349 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111349 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111352 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111354 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111361 */   // GIR_Coverage, 6742,
     /* 111361 */   GIR_EraseRootFromParent_Done,
     /* 111362 */ // Label 1776: @111362
     /* 111362 */ GIM_Try, /*On fail goto*//*Label 1777*/ GIMT_Encode4(111394), // Rule ID 6743 //
     /* 111367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111381 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111381 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111384 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111386 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111388 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111393 */   // GIR_Coverage, 6743,
     /* 111393 */   GIR_EraseRootFromParent_Done,
     /* 111394 */ // Label 1777: @111394
     /* 111394 */ GIM_Try, /*On fail goto*//*Label 1778*/ GIMT_Encode4(111426), // Rule ID 6744 //
     /* 111399 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111402 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111405 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111409 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111413 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111413 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111416 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111418 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111420 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111425 */   // GIR_Coverage, 6744,
     /* 111425 */   GIR_EraseRootFromParent_Done,
     /* 111426 */ // Label 1778: @111426
     /* 111426 */ GIM_Try, /*On fail goto*//*Label 1779*/ GIMT_Encode4(111452), // Rule ID 6745 //
     /* 111431 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111434 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111445 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1i64] }:$src)
     /* 111445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111450 */   GIR_RootConstrainSelectedInstOperands,
     /* 111451 */   // GIR_Coverage, 6745,
     /* 111451 */   GIR_Done,
     /* 111452 */ // Label 1779: @111452
     /* 111452 */ GIM_Try, /*On fail goto*//*Label 1780*/ GIMT_Encode4(111478), // Rule ID 6746 //
     /* 111457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111471 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2i32] }:$src)
     /* 111471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111476 */   GIR_RootConstrainSelectedInstOperands,
     /* 111477 */   // GIR_Coverage, 6746,
     /* 111477 */   GIR_Done,
     /* 111478 */ // Label 1780: @111478
     /* 111478 */ GIM_Try, /*On fail goto*//*Label 1781*/ GIMT_Encode4(111504), // Rule ID 6747 //
     /* 111483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111493 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111497 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4i16] } FPR64:{ *:[v8i8] }:$src)
     /* 111497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111502 */   GIR_RootConstrainSelectedInstOperands,
     /* 111503 */   // GIR_Coverage, 6747,
     /* 111503 */   GIR_Done,
     /* 111504 */ // Label 1781: @111504
     /* 111504 */ GIM_Try, /*On fail goto*//*Label 1782*/ GIMT_Encode4(111530), // Rule ID 6748 //
     /* 111509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111523 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[f64] }:$src)
     /* 111523 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111528 */   GIR_RootConstrainSelectedInstOperands,
     /* 111529 */   // GIR_Coverage, 6748,
     /* 111529 */   GIR_Done,
     /* 111530 */ // Label 1782: @111530
     /* 111530 */ GIM_Try, /*On fail goto*//*Label 1783*/ GIMT_Encode4(111556), // Rule ID 6749 //
     /* 111535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111545 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111549 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4i16] } FPR64:{ *:[v2f32] }:$src)
     /* 111549 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111554 */   GIR_RootConstrainSelectedInstOperands,
     /* 111555 */   // GIR_Coverage, 6749,
     /* 111555 */   GIR_Done,
     /* 111556 */ // Label 1783: @111556
     /* 111556 */ GIM_Try, /*On fail goto*//*Label 1784*/ GIMT_Encode4(111582), // Rule ID 6750 //
     /* 111561 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111564 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111575 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4i16] } FPR64:{ *:[v1f64] }:$src)
     /* 111575 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111580 */   GIR_RootConstrainSelectedInstOperands,
     /* 111581 */   // GIR_Coverage, 6750,
     /* 111581 */   GIR_Done,
     /* 111582 */ // Label 1784: @111582
     /* 111582 */ GIM_Try, /*On fail goto*//*Label 1785*/ GIMT_Encode4(111611), // Rule ID 6751 //
     /* 111587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111594 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111598 */   // (bitconvert:{ *:[v4i16] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v4i16] }:$src
     /* 111598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111601 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111603 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111605 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111610 */   // GIR_Coverage, 6751,
     /* 111610 */   GIR_EraseRootFromParent_Done,
     /* 111611 */ // Label 1785: @111611
     /* 111611 */ GIM_Try, /*On fail goto*//*Label 1786*/ GIMT_Encode4(111643), // Rule ID 6752 //
     /* 111616 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111626 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111630 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111633 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111635 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111637 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111642 */   // GIR_Coverage, 6752,
     /* 111642 */   GIR_EraseRootFromParent_Done,
     /* 111643 */ // Label 1786: @111643
     /* 111643 */ GIM_Try, /*On fail goto*//*Label 1787*/ GIMT_Encode4(111675), // Rule ID 6753 //
     /* 111648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111654 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111658 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111662 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111665 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111667 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111669 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111674 */   // GIR_Coverage, 6753,
     /* 111674 */   GIR_EraseRootFromParent_Done,
     /* 111675 */ // Label 1787: @111675
     /* 111675 */ GIM_Try, /*On fail goto*//*Label 1788*/ GIMT_Encode4(111707), // Rule ID 6754 //
     /* 111680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111694 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111697 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111699 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111701 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111706 */   // GIR_Coverage, 6754,
     /* 111706 */   GIR_EraseRootFromParent_Done,
     /* 111707 */ // Label 1788: @111707
     /* 111707 */ GIM_Try, /*On fail goto*//*Label 1789*/ GIMT_Encode4(111739), // Rule ID 6755 //
     /* 111712 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111722 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111726 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111726 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111729 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111731 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111733 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111738 */   // GIR_Coverage, 6755,
     /* 111738 */   GIR_EraseRootFromParent_Done,
     /* 111739 */ // Label 1789: @111739
     /* 111739 */ GIM_Try, /*On fail goto*//*Label 1790*/ GIMT_Encode4(111771), // Rule ID 6756 //
     /* 111744 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111747 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111750 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111754 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111758 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111761 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111763 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111765 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111770 */   // GIR_Coverage, 6756,
     /* 111770 */   GIR_EraseRootFromParent_Done,
     /* 111771 */ // Label 1790: @111771
     /* 111771 */ GIM_Try, /*On fail goto*//*Label 1791*/ GIMT_Encode4(111803), // Rule ID 6757 //
     /* 111776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111790 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111790 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111793 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111795 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111802 */   // GIR_Coverage, 6757,
     /* 111802 */   GIR_EraseRootFromParent_Done,
     /* 111803 */ // Label 1791: @111803
     /* 111803 */ GIM_Try, /*On fail goto*//*Label 1792*/ GIMT_Encode4(111829), // Rule ID 6758 //
     /* 111808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111822 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1i64] }:$src)
     /* 111822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111827 */   GIR_RootConstrainSelectedInstOperands,
     /* 111828 */   // GIR_Coverage, 6758,
     /* 111828 */   GIR_Done,
     /* 111829 */ // Label 1792: @111829
     /* 111829 */ GIM_Try, /*On fail goto*//*Label 1793*/ GIMT_Encode4(111855), // Rule ID 6759 //
     /* 111834 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111837 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111848 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2i32] }:$src)
     /* 111848 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111853 */   GIR_RootConstrainSelectedInstOperands,
     /* 111854 */   // GIR_Coverage, 6759,
     /* 111854 */   GIR_Done,
     /* 111855 */ // Label 1793: @111855
     /* 111855 */ GIM_Try, /*On fail goto*//*Label 1794*/ GIMT_Encode4(111881), // Rule ID 6760 //
     /* 111860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 111866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111874 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)  =>  (REV16v8i8:{ *:[v4f16] } FPR64:{ *:[v8i8] }:$src)
     /* 111874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 111879 */   GIR_RootConstrainSelectedInstOperands,
     /* 111880 */   // GIR_Coverage, 6760,
     /* 111880 */   GIR_Done,
     /* 111881 */ // Label 1794: @111881
     /* 111881 */ GIM_Try, /*On fail goto*//*Label 1795*/ GIMT_Encode4(111907), // Rule ID 6761 //
     /* 111886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111900 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[f64] }:$src)
     /* 111900 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111905 */   GIR_RootConstrainSelectedInstOperands,
     /* 111906 */   // GIR_Coverage, 6761,
     /* 111906 */   GIR_Done,
     /* 111907 */ // Label 1795: @111907
     /* 111907 */ GIM_Try, /*On fail goto*//*Label 1796*/ GIMT_Encode4(111933), // Rule ID 6762 //
     /* 111912 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111915 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 111918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111926 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v4i16:{ *:[v4f16] } FPR64:{ *:[v2f32] }:$src)
     /* 111926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 111931 */   GIR_RootConstrainSelectedInstOperands,
     /* 111932 */   // GIR_Coverage, 6762,
     /* 111932 */   GIR_Done,
     /* 111933 */ // Label 1796: @111933
     /* 111933 */ GIM_Try, /*On fail goto*//*Label 1797*/ GIMT_Encode4(111959), // Rule ID 6763 //
     /* 111938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 111941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 111944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111952 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v4i16:{ *:[v4f16] } FPR64:{ *:[v1f64] }:$src)
     /* 111952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 111957 */   GIR_RootConstrainSelectedInstOperands,
     /* 111958 */   // GIR_Coverage, 6763,
     /* 111958 */   GIR_Done,
     /* 111959 */ // Label 1797: @111959
     /* 111959 */ GIM_Try, /*On fail goto*//*Label 1798*/ GIMT_Encode4(111988), // Rule ID 6764 //
     /* 111964 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 111967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111971 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111975 */   // (bitconvert:{ *:[v4f16] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v4f16] }:$src
     /* 111975 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 111978 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 111980 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 111982 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 111987 */   // GIR_Coverage, 6764,
     /* 111987 */   GIR_EraseRootFromParent_Done,
     /* 111988 */ // Label 1798: @111988
     /* 111988 */ GIM_Reject,
     /* 111989 */ // Label 1622: @111989
     /* 111989 */ GIM_Try, /*On fail goto*//*Label 1799*/ GIMT_Encode4(112021), // Rule ID 6843 //
     /* 111994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 111997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112008 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112011 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112013 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112020 */   // GIR_Coverage, 6843,
     /* 112020 */   GIR_EraseRootFromParent_Done,
     /* 112021 */ // Label 1799: @112021
     /* 112021 */ GIM_Try, /*On fail goto*//*Label 1800*/ GIMT_Encode4(112053), // Rule ID 6844 //
     /* 112026 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112029 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112040 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112043 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112045 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112047 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112052 */   // GIR_Coverage, 6844,
     /* 112052 */   GIR_EraseRootFromParent_Done,
     /* 112053 */ // Label 1800: @112053
     /* 112053 */ GIM_Try, /*On fail goto*//*Label 1801*/ GIMT_Encode4(112085), // Rule ID 6845 //
     /* 112058 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112061 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112068 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112072 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112075 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112077 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112079 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112084 */   // GIR_Coverage, 6845,
     /* 112084 */   GIR_EraseRootFromParent_Done,
     /* 112085 */ // Label 1801: @112085
     /* 112085 */ GIM_Try, /*On fail goto*//*Label 1802*/ GIMT_Encode4(112117), // Rule ID 6846 //
     /* 112090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112104 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112107 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112109 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112111 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112116 */   // GIR_Coverage, 6846,
     /* 112116 */   GIR_EraseRootFromParent_Done,
     /* 112117 */ // Label 1802: @112117
     /* 112117 */ GIM_Try, /*On fail goto*//*Label 1803*/ GIMT_Encode4(112149), // Rule ID 6847 //
     /* 112122 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112136 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112139 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112141 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112143 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112148 */   // GIR_Coverage, 6847,
     /* 112148 */   GIR_EraseRootFromParent_Done,
     /* 112149 */ // Label 1803: @112149
     /* 112149 */ GIM_Try, /*On fail goto*//*Label 1804*/ GIMT_Encode4(112181), // Rule ID 6848 //
     /* 112154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112160 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112164 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112168 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112171 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112173 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112175 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112180 */   // GIR_Coverage, 6848,
     /* 112180 */   GIR_EraseRootFromParent_Done,
     /* 112181 */ // Label 1804: @112181
     /* 112181 */ GIM_Try, /*On fail goto*//*Label 1805*/ GIMT_Encode4(112252), // Rule ID 6849 //
     /* 112186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112196 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112200 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4f32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112200 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112203 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112207 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112212 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112216 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112230 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112244 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112247 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112250 */   GIR_RootConstrainSelectedInstOperands,
     /* 112251 */   // GIR_Coverage, 6849,
     /* 112251 */   GIR_EraseRootFromParent_Done,
     /* 112252 */ // Label 1805: @112252
     /* 112252 */ GIM_Try, /*On fail goto*//*Label 1806*/ GIMT_Encode4(112278), // Rule ID 6850 //
     /* 112257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112271 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8i16] }:$src)
     /* 112271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112276 */   GIR_RootConstrainSelectedInstOperands,
     /* 112277 */   // GIR_Coverage, 6850,
     /* 112277 */   GIR_Done,
     /* 112278 */ // Label 1806: @112278
     /* 112278 */ GIM_Try, /*On fail goto*//*Label 1807*/ GIMT_Encode4(112304), // Rule ID 6851 //
     /* 112283 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112286 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112289 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112293 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112297 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4f32] } FPR128:{ *:[v8f16] }:$src)
     /* 112297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112302 */   GIR_RootConstrainSelectedInstOperands,
     /* 112303 */   // GIR_Coverage, 6851,
     /* 112303 */   GIR_Done,
     /* 112304 */ // Label 1807: @112304
     /* 112304 */ GIM_Try, /*On fail goto*//*Label 1808*/ GIMT_Encode4(112330), // Rule ID 6852 //
     /* 112309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112323 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4f32] } FPR128:{ *:[v16i8] }:$src)
     /* 112323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112328 */   GIR_RootConstrainSelectedInstOperands,
     /* 112329 */   // GIR_Coverage, 6852,
     /* 112329 */   GIR_Done,
     /* 112330 */ // Label 1808: @112330
     /* 112330 */ GIM_Try, /*On fail goto*//*Label 1809*/ GIMT_Encode4(112356), // Rule ID 6853 //
     /* 112335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112349 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2i64] }:$src)
     /* 112349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112354 */   GIR_RootConstrainSelectedInstOperands,
     /* 112355 */   // GIR_Coverage, 6853,
     /* 112355 */   GIR_Done,
     /* 112356 */ // Label 1809: @112356
     /* 112356 */ GIM_Try, /*On fail goto*//*Label 1810*/ GIMT_Encode4(112382), // Rule ID 6854 //
     /* 112361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112367 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112371 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112375 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4f32] } FPR128:{ *:[v2f64] }:$src)
     /* 112375 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112380 */   GIR_RootConstrainSelectedInstOperands,
     /* 112381 */   // GIR_Coverage, 6854,
     /* 112381 */   GIR_Done,
     /* 112382 */ // Label 1810: @112382
     /* 112382 */ GIM_Try, /*On fail goto*//*Label 1811*/ GIMT_Encode4(112411), // Rule ID 6855 //
     /* 112387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112398 */   // (bitconvert:{ *:[v4f32] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v4f32] }:$src
     /* 112398 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112401 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112403 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112405 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112410 */   // GIR_Coverage, 6855,
     /* 112410 */   GIR_EraseRootFromParent_Done,
     /* 112411 */ // Label 1811: @112411
     /* 112411 */ GIM_Try, /*On fail goto*//*Label 1812*/ GIMT_Encode4(112443), // Rule ID 6869 //
     /* 112416 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112426 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112430 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112430 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112433 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112435 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112437 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112442 */   // GIR_Coverage, 6869,
     /* 112442 */   GIR_EraseRootFromParent_Done,
     /* 112443 */ // Label 1812: @112443
     /* 112443 */ GIM_Try, /*On fail goto*//*Label 1813*/ GIMT_Encode4(112475), // Rule ID 6870 //
     /* 112448 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112458 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112462 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112462 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112465 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112467 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112474 */   // GIR_Coverage, 6870,
     /* 112474 */   GIR_EraseRootFromParent_Done,
     /* 112475 */ // Label 1813: @112475
     /* 112475 */ GIM_Try, /*On fail goto*//*Label 1814*/ GIMT_Encode4(112507), // Rule ID 6871 //
     /* 112480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112490 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112494 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112494 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112497 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112499 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112501 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112506 */   // GIR_Coverage, 6871,
     /* 112506 */   GIR_EraseRootFromParent_Done,
     /* 112507 */ // Label 1814: @112507
     /* 112507 */ GIM_Try, /*On fail goto*//*Label 1815*/ GIMT_Encode4(112539), // Rule ID 6872 //
     /* 112512 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112522 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112526 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112526 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112529 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112531 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112533 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112538 */   // GIR_Coverage, 6872,
     /* 112538 */   GIR_EraseRootFromParent_Done,
     /* 112539 */ // Label 1815: @112539
     /* 112539 */ GIM_Try, /*On fail goto*//*Label 1816*/ GIMT_Encode4(112571), // Rule ID 6873 //
     /* 112544 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112547 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112550 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112554 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112558 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112558 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112561 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112563 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112565 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112570 */   // GIR_Coverage, 6873,
     /* 112570 */   GIR_EraseRootFromParent_Done,
     /* 112571 */ // Label 1816: @112571
     /* 112571 */ GIM_Try, /*On fail goto*//*Label 1817*/ GIMT_Encode4(112603), // Rule ID 6874 //
     /* 112576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112590 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112590 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112593 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112595 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112597 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112602 */   // GIR_Coverage, 6874,
     /* 112602 */   GIR_EraseRootFromParent_Done,
     /* 112603 */ // Label 1817: @112603
     /* 112603 */ GIM_Try, /*On fail goto*//*Label 1818*/ GIMT_Encode4(112674), // Rule ID 6875 //
     /* 112608 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112611 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 112614 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112618 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112622 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v4i32] } (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v4i32:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 112622 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 112625 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112629 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112634 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 112640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 112643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112652 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 112656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 112661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 112669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 112672 */   GIR_RootConstrainSelectedInstOperands,
     /* 112673 */   // GIR_Coverage, 6875,
     /* 112673 */   GIR_EraseRootFromParent_Done,
     /* 112674 */ // Label 1818: @112674
     /* 112674 */ GIM_Try, /*On fail goto*//*Label 1819*/ GIMT_Encode4(112700), // Rule ID 6876 //
     /* 112679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112689 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112693 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2i64] }:$src)
     /* 112693 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112698 */   GIR_RootConstrainSelectedInstOperands,
     /* 112699 */   // GIR_Coverage, 6876,
     /* 112699 */   GIR_Done,
     /* 112700 */ // Label 1819: @112700
     /* 112700 */ GIM_Try, /*On fail goto*//*Label 1820*/ GIMT_Encode4(112726), // Rule ID 6877 //
     /* 112705 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112711 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112715 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112719 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8i16] }:$src)
     /* 112719 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112724 */   GIR_RootConstrainSelectedInstOperands,
     /* 112725 */   // GIR_Coverage, 6877,
     /* 112725 */   GIR_Done,
     /* 112726 */ // Label 1820: @112726
     /* 112726 */ GIM_Try, /*On fail goto*//*Label 1821*/ GIMT_Encode4(112752), // Rule ID 6878 //
     /* 112731 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112734 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 112737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112741 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112745 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)  =>  (REV32v16i8:{ *:[v4i32] } FPR128:{ *:[v16i8] }:$src)
     /* 112745 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 112750 */   GIR_RootConstrainSelectedInstOperands,
     /* 112751 */   // GIR_Coverage, 6878,
     /* 112751 */   GIR_Done,
     /* 112752 */ // Label 1821: @112752
     /* 112752 */ GIM_Try, /*On fail goto*//*Label 1822*/ GIMT_Encode4(112778), // Rule ID 6879 //
     /* 112757 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112760 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 112763 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112767 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112771 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v4i32:{ *:[v4i32] } FPR128:{ *:[v2f64] }:$src)
     /* 112771 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 112776 */   GIR_RootConstrainSelectedInstOperands,
     /* 112777 */   // GIR_Coverage, 6879,
     /* 112777 */   GIR_Done,
     /* 112778 */ // Label 1822: @112778
     /* 112778 */ GIM_Try, /*On fail goto*//*Label 1823*/ GIMT_Encode4(112804), // Rule ID 6880 //
     /* 112783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112786 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 112789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112797 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)  =>  (REV32v8i16:{ *:[v4i32] } FPR128:{ *:[v8f16] }:$src)
     /* 112797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 112802 */   GIR_RootConstrainSelectedInstOperands,
     /* 112803 */   // GIR_Coverage, 6880,
     /* 112803 */   GIR_Done,
     /* 112804 */ // Label 1823: @112804
     /* 112804 */ GIM_Try, /*On fail goto*//*Label 1824*/ GIMT_Encode4(112833), // Rule ID 6881 //
     /* 112809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 112812 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112816 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112820 */   // (bitconvert:{ *:[v4i32] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v4i32] }:$src
     /* 112820 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112823 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 112825 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 112827 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 112832 */   // GIR_Coverage, 6881,
     /* 112832 */   GIR_EraseRootFromParent_Done,
     /* 112833 */ // Label 1824: @112833
     /* 112833 */ GIM_Reject,
     /* 112834 */ // Label 1623: @112834
     /* 112834 */ GIM_Try, /*On fail goto*//*Label 1825*/ GIMT_Encode4(112908), // Rule ID 5684 //
     /* 112839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112846 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 112850 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 112854 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 112858 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 112863 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 112865 */   // (bitconvert:{ *:[v8i8] } (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn))  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (FMOVWSr:{ *:[f32] } GPR32:{ *:[i32] }:$Rn), ssub:{ *:[i32] })
     /* 112865 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 112868 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FMOVWSr),
     /* 112872 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112877 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 112881 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 112883 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 112886 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 112888 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 112891 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112894 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 112897 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112902 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 112907 */   // GIR_Coverage, 5684,
     /* 112907 */   GIR_EraseRootFromParent_Done,
     /* 112908 */ // Label 1825: @112908
     /* 112908 */ GIM_Try, /*On fail goto*//*Label 1826*/ GIMT_Encode4(112938), // Rule ID 6679 //
     /* 112913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112927 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (COPY_TO_REGCLASS:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 112927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112937 */   // GIR_Coverage, 6679,
     /* 112937 */   GIR_Done,
     /* 112938 */ // Label 1826: @112938
     /* 112938 */ GIM_Try, /*On fail goto*//*Label 1827*/ GIMT_Encode4(112988), // Rule ID 6690 //
     /* 112943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 112946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112953 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 112957 */   // (bitconvert:{ *:[v8i8] } GPR64:{ *:[i64] }:$Xn)  =>  (REV64v8i8:{ *:[v8i8] } (COPY_TO_REGCLASS:{ *:[i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] }))
     /* 112957 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 112960 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 112964 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 112969 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Xn
     /* 112973 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 112978 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 112981 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 112983 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 112986 */   GIR_RootConstrainSelectedInstOperands,
     /* 112987 */   // GIR_Coverage, 6690,
     /* 112987 */   GIR_EraseRootFromParent_Done,
     /* 112988 */ // Label 1827: @112988
     /* 112988 */ GIM_Try, /*On fail goto*//*Label 1828*/ GIMT_Encode4(113020), // Rule ID 6765 //
     /* 112993 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 112996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 112999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113007 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113007 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113010 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113012 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113014 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113019 */   // GIR_Coverage, 6765,
     /* 113019 */   GIR_EraseRootFromParent_Done,
     /* 113020 */ // Label 1828: @113020
     /* 113020 */ GIM_Try, /*On fail goto*//*Label 1829*/ GIMT_Encode4(113052), // Rule ID 6766 //
     /* 113025 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113028 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113031 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113035 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113039 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113039 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113042 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113044 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113046 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113051 */   // GIR_Coverage, 6766,
     /* 113051 */   GIR_EraseRootFromParent_Done,
     /* 113052 */ // Label 1829: @113052
     /* 113052 */ GIM_Try, /*On fail goto*//*Label 1830*/ GIMT_Encode4(113084), // Rule ID 6767 //
     /* 113057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113063 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113067 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113071 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113074 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113076 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113083 */   // GIR_Coverage, 6767,
     /* 113083 */   GIR_EraseRootFromParent_Done,
     /* 113084 */ // Label 1830: @113084
     /* 113084 */ GIM_Try, /*On fail goto*//*Label 1831*/ GIMT_Encode4(113116), // Rule ID 6768 //
     /* 113089 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113092 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113095 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113099 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113103 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113103 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113106 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113108 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113115 */   // GIR_Coverage, 6768,
     /* 113115 */   GIR_EraseRootFromParent_Done,
     /* 113116 */ // Label 1831: @113116
     /* 113116 */ GIM_Try, /*On fail goto*//*Label 1832*/ GIMT_Encode4(113148), // Rule ID 6769 //
     /* 113121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113131 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113135 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113135 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113138 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113140 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113142 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113147 */   // GIR_Coverage, 6769,
     /* 113147 */   GIR_EraseRootFromParent_Done,
     /* 113148 */ // Label 1832: @113148
     /* 113148 */ GIM_Try, /*On fail goto*//*Label 1833*/ GIMT_Encode4(113180), // Rule ID 6770 //
     /* 113153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113167 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113167 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113170 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113172 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113174 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113179 */   // GIR_Coverage, 6770,
     /* 113179 */   GIR_EraseRootFromParent_Done,
     /* 113180 */ // Label 1833: @113180
     /* 113180 */ GIM_Try, /*On fail goto*//*Label 1834*/ GIMT_Encode4(113212), // Rule ID 6771 //
     /* 113185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113199 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  FPR64:{ *:[v8i8] }:$src
     /* 113199 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113202 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113204 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113206 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113211 */   // GIR_Coverage, 6771,
     /* 113211 */   GIR_EraseRootFromParent_Done,
     /* 113212 */ // Label 1834: @113212
     /* 113212 */ GIM_Try, /*On fail goto*//*Label 1835*/ GIMT_Encode4(113238), // Rule ID 6772 //
     /* 113217 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113220 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113223 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113227 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113231 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1i64] }:$src)
     /* 113231 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113236 */   GIR_RootConstrainSelectedInstOperands,
     /* 113237 */   // GIR_Coverage, 6772,
     /* 113237 */   GIR_Done,
     /* 113238 */ // Label 1835: @113238
     /* 113238 */ GIM_Try, /*On fail goto*//*Label 1836*/ GIMT_Encode4(113264), // Rule ID 6773 //
     /* 113243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113257 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2i32] }:$src)
     /* 113257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113262 */   GIR_RootConstrainSelectedInstOperands,
     /* 113263 */   // GIR_Coverage, 6773,
     /* 113263 */   GIR_Done,
     /* 113264 */ // Label 1836: @113264
     /* 113264 */ GIM_Try, /*On fail goto*//*Label 1837*/ GIMT_Encode4(113290), // Rule ID 6774 //
     /* 113269 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113283 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4i16] }:$src)
     /* 113283 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113288 */   GIR_RootConstrainSelectedInstOperands,
     /* 113289 */   // GIR_Coverage, 6774,
     /* 113289 */   GIR_Done,
     /* 113290 */ // Label 1837: @113290
     /* 113290 */ GIM_Try, /*On fail goto*//*Label 1838*/ GIMT_Encode4(113316), // Rule ID 6775 //
     /* 113295 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113298 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113301 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113305 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113309 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[f64] }:$src)
     /* 113309 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113314 */   GIR_RootConstrainSelectedInstOperands,
     /* 113315 */   // GIR_Coverage, 6775,
     /* 113315 */   GIR_Done,
     /* 113316 */ // Label 1838: @113316
     /* 113316 */ GIM_Try, /*On fail goto*//*Label 1839*/ GIMT_Encode4(113342), // Rule ID 6776 //
     /* 113321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 113327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113335 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)  =>  (REV32v8i8:{ *:[v8i8] } FPR64:{ *:[v2f32] }:$src)
     /* 113335 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 113340 */   GIR_RootConstrainSelectedInstOperands,
     /* 113341 */   // GIR_Coverage, 6776,
     /* 113341 */   GIR_Done,
     /* 113342 */ // Label 1839: @113342
     /* 113342 */ GIM_Try, /*On fail goto*//*Label 1840*/ GIMT_Encode4(113368), // Rule ID 6777 //
     /* 113347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 113353 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113357 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113361 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)  =>  (REV64v8i8:{ *:[v8i8] } FPR64:{ *:[v1f64] }:$src)
     /* 113361 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 113366 */   GIR_RootConstrainSelectedInstOperands,
     /* 113367 */   // GIR_Coverage, 6777,
     /* 113367 */   GIR_Done,
     /* 113368 */ // Label 1840: @113368
     /* 113368 */ GIM_Try, /*On fail goto*//*Label 1841*/ GIMT_Encode4(113394), // Rule ID 6778 //
     /* 113373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 113379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 113387 */   // (bitconvert:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)  =>  (REV16v8i8:{ *:[v8i8] } FPR64:{ *:[v4f16] }:$src)
     /* 113387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 113392 */   GIR_RootConstrainSelectedInstOperands,
     /* 113393 */   // GIR_Coverage, 6778,
     /* 113393 */   GIR_Done,
     /* 113394 */ // Label 1841: @113394
     /* 113394 */ GIM_Reject,
     /* 113395 */ // Label 1624: @113395
     /* 113395 */ GIM_Try, /*On fail goto*//*Label 1842*/ GIMT_Encode4(113427), // Rule ID 6882 //
     /* 113400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113414 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113417 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113419 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113421 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113426 */   // GIR_Coverage, 6882,
     /* 113426 */   GIR_EraseRootFromParent_Done,
     /* 113427 */ // Label 1842: @113427
     /* 113427 */ GIM_Try, /*On fail goto*//*Label 1843*/ GIMT_Encode4(113459), // Rule ID 6883 //
     /* 113432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113442 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113446 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113446 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113449 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113451 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113453 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113458 */   // GIR_Coverage, 6883,
     /* 113458 */   GIR_EraseRootFromParent_Done,
     /* 113459 */ // Label 1843: @113459
     /* 113459 */ GIM_Try, /*On fail goto*//*Label 1844*/ GIMT_Encode4(113491), // Rule ID 6884 //
     /* 113464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113474 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113478 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113481 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113483 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113485 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113490 */   // GIR_Coverage, 6884,
     /* 113490 */   GIR_EraseRootFromParent_Done,
     /* 113491 */ // Label 1844: @113491
     /* 113491 */ GIM_Try, /*On fail goto*//*Label 1845*/ GIMT_Encode4(113523), // Rule ID 6885 //
     /* 113496 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113506 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113510 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113513 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113515 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113517 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113522 */   // GIR_Coverage, 6885,
     /* 113522 */   GIR_EraseRootFromParent_Done,
     /* 113523 */ // Label 1845: @113523
     /* 113523 */ GIM_Try, /*On fail goto*//*Label 1846*/ GIMT_Encode4(113555), // Rule ID 6886 //
     /* 113528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113542 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113545 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113547 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113549 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113554 */   // GIR_Coverage, 6886,
     /* 113554 */   GIR_EraseRootFromParent_Done,
     /* 113555 */ // Label 1846: @113555
     /* 113555 */ GIM_Try, /*On fail goto*//*Label 1847*/ GIMT_Encode4(113587), // Rule ID 6887 //
     /* 113560 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113574 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113574 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113577 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113579 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113586 */   // GIR_Coverage, 6887,
     /* 113586 */   GIR_EraseRootFromParent_Done,
     /* 113587 */ // Label 1847: @113587
     /* 113587 */ GIM_Try, /*On fail goto*//*Label 1848*/ GIMT_Encode4(113658), // Rule ID 6888 //
     /* 113592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113606 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8i16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 113606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 113609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 113624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 113627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 113636 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 113640 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 113642 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 113645 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 113647 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 113650 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 113653 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 113656 */   GIR_RootConstrainSelectedInstOperands,
     /* 113657 */   // GIR_Coverage, 6888,
     /* 113657 */   GIR_EraseRootFromParent_Done,
     /* 113658 */ // Label 1848: @113658
     /* 113658 */ GIM_Try, /*On fail goto*//*Label 1849*/ GIMT_Encode4(113684), // Rule ID 6889 //
     /* 113663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113673 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113677 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2i64] }:$src)
     /* 113677 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113682 */   GIR_RootConstrainSelectedInstOperands,
     /* 113683 */   // GIR_Coverage, 6889,
     /* 113683 */   GIR_Done,
     /* 113684 */ // Label 1849: @113684
     /* 113684 */ GIM_Try, /*On fail goto*//*Label 1850*/ GIMT_Encode4(113710), // Rule ID 6890 //
     /* 113689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113703 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4i32] }:$src)
     /* 113703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113708 */   GIR_RootConstrainSelectedInstOperands,
     /* 113709 */   // GIR_Coverage, 6890,
     /* 113709 */   GIR_Done,
     /* 113710 */ // Label 1850: @113710
     /* 113710 */ GIM_Try, /*On fail goto*//*Label 1851*/ GIMT_Encode4(113736), // Rule ID 6891 //
     /* 113715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113725 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113729 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8i16] } FPR128:{ *:[v16i8] }:$src)
     /* 113729 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 113734 */   GIR_RootConstrainSelectedInstOperands,
     /* 113735 */   // GIR_Coverage, 6891,
     /* 113735 */   GIR_Done,
     /* 113736 */ // Label 1851: @113736
     /* 113736 */ GIM_Try, /*On fail goto*//*Label 1852*/ GIMT_Encode4(113762), // Rule ID 6892 //
     /* 113741 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113744 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113747 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113751 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113755 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8i16] } FPR128:{ *:[v2f64] }:$src)
     /* 113755 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 113760 */   GIR_RootConstrainSelectedInstOperands,
     /* 113761 */   // GIR_Coverage, 6892,
     /* 113761 */   GIR_Done,
     /* 113762 */ // Label 1852: @113762
     /* 113762 */ GIM_Try, /*On fail goto*//*Label 1853*/ GIMT_Encode4(113788), // Rule ID 6893 //
     /* 113767 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 113770 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113781 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8i16] } FPR128:{ *:[v4f32] }:$src)
     /* 113781 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 113786 */   GIR_RootConstrainSelectedInstOperands,
     /* 113787 */   // GIR_Coverage, 6893,
     /* 113787 */   GIR_Done,
     /* 113788 */ // Label 1853: @113788
     /* 113788 */ GIM_Try, /*On fail goto*//*Label 1854*/ GIMT_Encode4(113817), // Rule ID 6894 //
     /* 113793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 113796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113804 */   // (bitconvert:{ *:[v8i16] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v8i16] }:$src
     /* 113804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113807 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113809 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113811 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113816 */   // GIR_Coverage, 6894,
     /* 113816 */   GIR_EraseRootFromParent_Done,
     /* 113817 */ // Label 1854: @113817
     /* 113817 */ GIM_Try, /*On fail goto*//*Label 1855*/ GIMT_Encode4(113849), // Rule ID 6895 //
     /* 113822 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113825 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 113828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113836 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113836 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113839 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113841 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113843 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113848 */   // GIR_Coverage, 6895,
     /* 113848 */   GIR_EraseRootFromParent_Done,
     /* 113849 */ // Label 1855: @113849
     /* 113849 */ GIM_Try, /*On fail goto*//*Label 1856*/ GIMT_Encode4(113881), // Rule ID 6896 //
     /* 113854 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113857 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113868 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113871 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113873 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113875 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113880 */   // GIR_Coverage, 6896,
     /* 113880 */   GIR_EraseRootFromParent_Done,
     /* 113881 */ // Label 1856: @113881
     /* 113881 */ GIM_Try, /*On fail goto*//*Label 1857*/ GIMT_Encode4(113913), // Rule ID 6897 //
     /* 113886 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113889 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113900 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113900 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113903 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113905 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113907 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113912 */   // GIR_Coverage, 6897,
     /* 113912 */   GIR_EraseRootFromParent_Done,
     /* 113913 */ // Label 1857: @113913
     /* 113913 */ GIM_Try, /*On fail goto*//*Label 1858*/ GIMT_Encode4(113945), // Rule ID 6898 //
     /* 113918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 113924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113928 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113932 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113935 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113937 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113944 */   // GIR_Coverage, 6898,
     /* 113944 */   GIR_EraseRootFromParent_Done,
     /* 113945 */ // Label 1858: @113945
     /* 113945 */ GIM_Try, /*On fail goto*//*Label 1859*/ GIMT_Encode4(113977), // Rule ID 6899 //
     /* 113950 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 113956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113960 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113964 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113964 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113967 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 113969 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 113971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113976 */   // GIR_Coverage, 6899,
     /* 113976 */   GIR_EraseRootFromParent_Done,
     /* 113977 */ // Label 1859: @113977
     /* 113977 */ GIM_Try, /*On fail goto*//*Label 1860*/ GIMT_Encode4(114009), // Rule ID 6900 //
     /* 113982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 113985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 113988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113992 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 113996 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 113996 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 113999 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114001 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114008 */   // GIR_Coverage, 6900,
     /* 114008 */   GIR_EraseRootFromParent_Done,
     /* 114009 */ // Label 1860: @114009
     /* 114009 */ GIM_Try, /*On fail goto*//*Label 1861*/ GIMT_Encode4(114080), // Rule ID 6901 //
     /* 114014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114028 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v8f16] } (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v8i16:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114028 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114031 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114035 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114040 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114044 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114046 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114049 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114053 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114058 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114062 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114067 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114069 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114072 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114075 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114078 */   GIR_RootConstrainSelectedInstOperands,
     /* 114079 */   // GIR_Coverage, 6901,
     /* 114079 */   GIR_EraseRootFromParent_Done,
     /* 114080 */ // Label 1861: @114080
     /* 114080 */ GIM_Try, /*On fail goto*//*Label 1862*/ GIMT_Encode4(114106), // Rule ID 6902 //
     /* 114085 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114088 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114091 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114095 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114099 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2i64] }:$src)
     /* 114099 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114104 */   GIR_RootConstrainSelectedInstOperands,
     /* 114105 */   // GIR_Coverage, 6902,
     /* 114105 */   GIR_Done,
     /* 114106 */ // Label 1862: @114106
     /* 114106 */ GIM_Try, /*On fail goto*//*Label 1863*/ GIMT_Encode4(114132), // Rule ID 6903 //
     /* 114111 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114114 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114117 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114121 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114125 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4i32] }:$src)
     /* 114125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114130 */   GIR_RootConstrainSelectedInstOperands,
     /* 114131 */   // GIR_Coverage, 6903,
     /* 114131 */   GIR_Done,
     /* 114132 */ // Label 1863: @114132
     /* 114132 */ GIM_Try, /*On fail goto*//*Label 1864*/ GIMT_Encode4(114158), // Rule ID 6904 //
     /* 114137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 114143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114147 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114151 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)  =>  (REV16v16i8:{ *:[v8f16] } FPR128:{ *:[v16i8] }:$src)
     /* 114151 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114156 */   GIR_RootConstrainSelectedInstOperands,
     /* 114157 */   // GIR_Coverage, 6904,
     /* 114157 */   GIR_Done,
     /* 114158 */ // Label 1864: @114158
     /* 114158 */ GIM_Try, /*On fail goto*//*Label 1865*/ GIMT_Encode4(114184), // Rule ID 6905 //
     /* 114163 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114173 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114177 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v8i16:{ *:[v8f16] } FPR128:{ *:[v2f64] }:$src)
     /* 114177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 114182 */   GIR_RootConstrainSelectedInstOperands,
     /* 114183 */   // GIR_Coverage, 6905,
     /* 114183 */   GIR_Done,
     /* 114184 */ // Label 1865: @114184
     /* 114184 */ GIM_Try, /*On fail goto*//*Label 1866*/ GIMT_Encode4(114210), // Rule ID 6906 //
     /* 114189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114195 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114199 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114203 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v8i16:{ *:[v8f16] } FPR128:{ *:[v4f32] }:$src)
     /* 114203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 114208 */   GIR_RootConstrainSelectedInstOperands,
     /* 114209 */   // GIR_Coverage, 6906,
     /* 114209 */   GIR_Done,
     /* 114210 */ // Label 1866: @114210
     /* 114210 */ GIM_Try, /*On fail goto*//*Label 1867*/ GIMT_Encode4(114239), // Rule ID 6907 //
     /* 114215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114226 */   // (bitconvert:{ *:[v8f16] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v8f16] }:$src
     /* 114226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114229 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114231 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114238 */   // GIR_Coverage, 6907,
     /* 114238 */   GIR_EraseRootFromParent_Done,
     /* 114239 */ // Label 1867: @114239
     /* 114239 */ GIM_Reject,
     /* 114240 */ // Label 1625: @114240
     /* 114240 */ GIM_Try, /*On fail goto*//*Label 1868*/ GIMT_Encode4(114272), // Rule ID 6908 //
     /* 114245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114259 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114259 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114262 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114264 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114266 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114271 */   // GIR_Coverage, 6908,
     /* 114271 */   GIR_EraseRootFromParent_Done,
     /* 114272 */ // Label 1868: @114272
     /* 114272 */ GIM_Try, /*On fail goto*//*Label 1869*/ GIMT_Encode4(114304), // Rule ID 6909 //
     /* 114277 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114280 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114287 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114291 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114291 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114294 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114296 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114298 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114303 */   // GIR_Coverage, 6909,
     /* 114303 */   GIR_EraseRootFromParent_Done,
     /* 114304 */ // Label 1869: @114304
     /* 114304 */ GIM_Try, /*On fail goto*//*Label 1870*/ GIMT_Encode4(114336), // Rule ID 6910 //
     /* 114309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114323 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114326 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114328 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114330 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114335 */   // GIR_Coverage, 6910,
     /* 114335 */   GIR_EraseRootFromParent_Done,
     /* 114336 */ // Label 1870: @114336
     /* 114336 */ GIM_Try, /*On fail goto*//*Label 1871*/ GIMT_Encode4(114368), // Rule ID 6911 //
     /* 114341 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114344 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114351 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114355 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114358 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114360 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114362 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114367 */   // GIR_Coverage, 6911,
     /* 114367 */   GIR_EraseRootFromParent_Done,
     /* 114368 */ // Label 1871: @114368
     /* 114368 */ GIM_Try, /*On fail goto*//*Label 1872*/ GIMT_Encode4(114400), // Rule ID 6912 //
     /* 114373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114387 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114390 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114392 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114394 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114399 */   // GIR_Coverage, 6912,
     /* 114399 */   GIR_EraseRootFromParent_Done,
     /* 114400 */ // Label 1872: @114400
     /* 114400 */ GIM_Try, /*On fail goto*//*Label 1873*/ GIMT_Encode4(114432), // Rule ID 6913 //
     /* 114405 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114408 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114419 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114419 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114422 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114424 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114431 */   // GIR_Coverage, 6913,
     /* 114431 */   GIR_EraseRootFromParent_Done,
     /* 114432 */ // Label 1873: @114432
     /* 114432 */ GIM_Try, /*On fail goto*//*Label 1874*/ GIMT_Encode4(114464), // Rule ID 6914 //
     /* 114437 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 114440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114443 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114447 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114451 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  FPR128:{ *:[v16i8] }:$src
     /* 114451 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114454 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114456 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114458 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114463 */   // GIR_Coverage, 6914,
     /* 114463 */   GIR_EraseRootFromParent_Done,
     /* 114464 */ // Label 1874: @114464
     /* 114464 */ GIM_Try, /*On fail goto*//*Label 1875*/ GIMT_Encode4(114535), // Rule ID 6915 //
     /* 114469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s128,
     /* 114475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114479 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114483 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[f128] }:$src)  =>  (EXTv16i8:{ *:[v16i8] } (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), (REV64v16i8:{ *:[f128] } FPR128:{ *:[f128] }:$src), 8:{ *:[i32] })
     /* 114483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 114486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114495 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114499 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 114501 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 114504 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114508 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 114513 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 114517 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 114519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 114522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 114524 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 114527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 114530 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 114533 */   GIR_RootConstrainSelectedInstOperands,
     /* 114534 */   // GIR_Coverage, 6915,
     /* 114534 */   GIR_EraseRootFromParent_Done,
     /* 114535 */ // Label 1875: @114535
     /* 114535 */ GIM_Try, /*On fail goto*//*Label 1876*/ GIMT_Encode4(114561), // Rule ID 6916 //
     /* 114540 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114543 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114546 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114550 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114554 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2i64] }:$src)
     /* 114554 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114559 */   GIR_RootConstrainSelectedInstOperands,
     /* 114560 */   // GIR_Coverage, 6916,
     /* 114560 */   GIR_Done,
     /* 114561 */ // Label 1876: @114561
     /* 114561 */ GIM_Try, /*On fail goto*//*Label 1877*/ GIMT_Encode4(114587), // Rule ID 6917 //
     /* 114566 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114569 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114576 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114580 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4i32] }:$src)
     /* 114580 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114585 */   GIR_RootConstrainSelectedInstOperands,
     /* 114586 */   // GIR_Coverage, 6917,
     /* 114586 */   GIR_Done,
     /* 114587 */ // Label 1877: @114587
     /* 114587 */ GIM_Try, /*On fail goto*//*Label 1878*/ GIMT_Encode4(114613), // Rule ID 6918 //
     /* 114592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114606 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8i16] }:$src)
     /* 114606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114611 */   GIR_RootConstrainSelectedInstOperands,
     /* 114612 */   // GIR_Coverage, 6918,
     /* 114612 */   GIR_Done,
     /* 114613 */ // Label 1878: @114613
     /* 114613 */ GIM_Try, /*On fail goto*//*Label 1879*/ GIMT_Encode4(114639), // Rule ID 6919 //
     /* 114618 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114621 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 114624 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114628 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114632 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)  =>  (REV64v16i8:{ *:[v16i8] } FPR128:{ *:[v2f64] }:$src)
     /* 114632 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 114637 */   GIR_RootConstrainSelectedInstOperands,
     /* 114638 */   // GIR_Coverage, 6919,
     /* 114638 */   GIR_Done,
     /* 114639 */ // Label 1879: @114639
     /* 114639 */ GIM_Try, /*On fail goto*//*Label 1880*/ GIMT_Encode4(114665), // Rule ID 6920 //
     /* 114644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 114650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114658 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)  =>  (REV32v16i8:{ *:[v16i8] } FPR128:{ *:[v4f32] }:$src)
     /* 114658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 114663 */   GIR_RootConstrainSelectedInstOperands,
     /* 114664 */   // GIR_Coverage, 6920,
     /* 114664 */   GIR_Done,
     /* 114665 */ // Label 1880: @114665
     /* 114665 */ GIM_Try, /*On fail goto*//*Label 1881*/ GIMT_Encode4(114691), // Rule ID 6921 //
     /* 114670 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsBE),
     /* 114673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 114676 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114680 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 114684 */   // (bitconvert:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)  =>  (REV16v16i8:{ *:[v16i8] } FPR128:{ *:[v8f16] }:$src)
     /* 114684 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 114689 */   GIR_RootConstrainSelectedInstOperands,
     /* 114690 */   // GIR_Coverage, 6921,
     /* 114690 */   GIR_Done,
     /* 114691 */ // Label 1881: @114691
     /* 114691 */ GIM_Reject,
     /* 114692 */ // Label 1626: @114692
     /* 114692 */ GIM_Try, /*On fail goto*//*Label 1882*/ GIMT_Encode4(114724), // Rule ID 10622 //
     /* 114697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114707 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114711 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114714 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114716 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114718 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114723 */   // GIR_Coverage, 10622,
     /* 114723 */   GIR_EraseRootFromParent_Done,
     /* 114724 */ // Label 1882: @114724
     /* 114724 */ GIM_Try, /*On fail goto*//*Label 1883*/ GIMT_Encode4(114756), // Rule ID 10623 //
     /* 114729 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114739 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114743 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114743 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114746 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114748 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114750 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114755 */   // GIR_Coverage, 10623,
     /* 114755 */   GIR_EraseRootFromParent_Done,
     /* 114756 */ // Label 1883: @114756
     /* 114756 */ GIM_Try, /*On fail goto*//*Label 1884*/ GIMT_Encode4(114788), // Rule ID 10624 //
     /* 114761 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114764 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114767 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114771 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114775 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114775 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114778 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114780 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114782 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114787 */   // GIR_Coverage, 10624,
     /* 114787 */   GIR_EraseRootFromParent_Done,
     /* 114788 */ // Label 1884: @114788
     /* 114788 */ GIM_Try, /*On fail goto*//*Label 1885*/ GIMT_Encode4(114820), // Rule ID 10625 //
     /* 114793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114807 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114807 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114810 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114812 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114814 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114819 */   // GIR_Coverage, 10625,
     /* 114819 */   GIR_EraseRootFromParent_Done,
     /* 114820 */ // Label 1885: @114820
     /* 114820 */ GIM_Try, /*On fail goto*//*Label 1886*/ GIMT_Encode4(114852), // Rule ID 10626 //
     /* 114825 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114828 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114831 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114835 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114839 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114839 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114842 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114844 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114851 */   // GIR_Coverage, 10626,
     /* 114851 */   GIR_EraseRootFromParent_Done,
     /* 114852 */ // Label 1886: @114852
     /* 114852 */ GIM_Try, /*On fail goto*//*Label 1887*/ GIMT_Encode4(114884), // Rule ID 10627 //
     /* 114857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114863 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114867 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114871 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 114871 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114874 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114876 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114878 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114883 */   // GIR_Coverage, 10627,
     /* 114883 */   GIR_EraseRootFromParent_Done,
     /* 114884 */ // Label 1887: @114884
     /* 114884 */ GIM_Try, /*On fail goto*//*Label 1888*/ GIMT_Encode4(114916), // Rule ID 10640 //
     /* 114889 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 114895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114899 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114903 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114906 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114908 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114910 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114915 */   // GIR_Coverage, 10640,
     /* 114915 */   GIR_EraseRootFromParent_Done,
     /* 114916 */ // Label 1888: @114916
     /* 114916 */ GIM_Try, /*On fail goto*//*Label 1889*/ GIMT_Encode4(114948), // Rule ID 10641 //
     /* 114921 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114924 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 114927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114935 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114935 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114938 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114940 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114942 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114947 */   // GIR_Coverage, 10641,
     /* 114947 */   GIR_EraseRootFromParent_Done,
     /* 114948 */ // Label 1889: @114948
     /* 114948 */ GIM_Try, /*On fail goto*//*Label 1890*/ GIMT_Encode4(114980), // Rule ID 10642 //
     /* 114953 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 114959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114967 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 114970 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 114972 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 114974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114979 */   // GIR_Coverage, 10642,
     /* 114979 */   GIR_EraseRootFromParent_Done,
     /* 114980 */ // Label 1890: @114980
     /* 114980 */ GIM_Try, /*On fail goto*//*Label 1891*/ GIMT_Encode4(115012), // Rule ID 10643 //
     /* 114985 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 114988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 114991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114995 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 114999 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 114999 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115002 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115004 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115006 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115011 */   // GIR_Coverage, 10643,
     /* 115011 */   GIR_EraseRootFromParent_Done,
     /* 115012 */ // Label 1891: @115012
     /* 115012 */ GIM_Try, /*On fail goto*//*Label 1892*/ GIMT_Encode4(115044), // Rule ID 10644 //
     /* 115017 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115020 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115023 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115027 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115031 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115031 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115034 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115036 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115038 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115043 */   // GIR_Coverage, 10644,
     /* 115043 */   GIR_EraseRootFromParent_Done,
     /* 115044 */ // Label 1892: @115044
     /* 115044 */ GIM_Try, /*On fail goto*//*Label 1893*/ GIMT_Encode4(115076), // Rule ID 10645 //
     /* 115049 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115052 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115055 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115059 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115063 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115063 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115066 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115068 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115070 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115075 */   // GIR_Coverage, 10645,
     /* 115075 */   GIR_EraseRootFromParent_Done,
     /* 115076 */ // Label 1893: @115076
     /* 115076 */ GIM_Try, /*On fail goto*//*Label 1894*/ GIMT_Encode4(115108), // Rule ID 10650 //
     /* 115081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115091 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115095 */   // (bitconvert:{ *:[nxv2i64] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv2i64] }:$src
     /* 115095 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115098 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115100 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115102 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115107 */   // GIR_Coverage, 10650,
     /* 115107 */   GIR_EraseRootFromParent_Done,
     /* 115108 */ // Label 1894: @115108
     /* 115108 */ GIM_Try, /*On fail goto*//*Label 1895*/ GIMT_Encode4(115140), // Rule ID 10651 //
     /* 115113 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115116 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115119 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115123 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115127 */   // (bitconvert:{ *:[nxv2f64] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv2f64] }:$src
     /* 115127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115130 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115132 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115134 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115139 */   // GIR_Coverage, 10651,
     /* 115139 */   GIR_EraseRootFromParent_Done,
     /* 115140 */ // Label 1895: @115140
     /* 115140 */ GIM_Reject,
     /* 115141 */ // Label 1627: @115141
     /* 115141 */ GIM_Try, /*On fail goto*//*Label 1896*/ GIMT_Encode4(115173), // Rule ID 10616 //
     /* 115146 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115149 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115152 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115156 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115160 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115160 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115163 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115165 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115172 */   // GIR_Coverage, 10616,
     /* 115172 */   GIR_EraseRootFromParent_Done,
     /* 115173 */ // Label 1896: @115173
     /* 115173 */ GIM_Try, /*On fail goto*//*Label 1897*/ GIMT_Encode4(115205), // Rule ID 10617 //
     /* 115178 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115181 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115184 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115188 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115192 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115192 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115195 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115197 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115199 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115204 */   // GIR_Coverage, 10617,
     /* 115204 */   GIR_EraseRootFromParent_Done,
     /* 115205 */ // Label 1897: @115205
     /* 115205 */ GIM_Try, /*On fail goto*//*Label 1898*/ GIMT_Encode4(115237), // Rule ID 10618 //
     /* 115210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115220 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115224 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115227 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115229 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115231 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115236 */   // GIR_Coverage, 10618,
     /* 115236 */   GIR_EraseRootFromParent_Done,
     /* 115237 */ // Label 1898: @115237
     /* 115237 */ GIM_Try, /*On fail goto*//*Label 1899*/ GIMT_Encode4(115269), // Rule ID 10619 //
     /* 115242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115256 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115256 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115259 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115261 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115263 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115268 */   // GIR_Coverage, 10619,
     /* 115268 */   GIR_EraseRootFromParent_Done,
     /* 115269 */ // Label 1899: @115269
     /* 115269 */ GIM_Try, /*On fail goto*//*Label 1900*/ GIMT_Encode4(115301), // Rule ID 10620 //
     /* 115274 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115288 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115288 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115291 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115293 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115300 */   // GIR_Coverage, 10620,
     /* 115300 */   GIR_EraseRootFromParent_Done,
     /* 115301 */ // Label 1900: @115301
     /* 115301 */ GIM_Try, /*On fail goto*//*Label 1901*/ GIMT_Encode4(115333), // Rule ID 10621 //
     /* 115306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115320 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115323 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115325 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115327 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115332 */   // GIR_Coverage, 10621,
     /* 115332 */   GIR_EraseRootFromParent_Done,
     /* 115333 */ // Label 1901: @115333
     /* 115333 */ GIM_Try, /*On fail goto*//*Label 1902*/ GIMT_Encode4(115365), // Rule ID 10634 //
     /* 115338 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115341 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115344 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115348 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115352 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115352 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115355 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115357 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115359 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115364 */   // GIR_Coverage, 10634,
     /* 115364 */   GIR_EraseRootFromParent_Done,
     /* 115365 */ // Label 1902: @115365
     /* 115365 */ GIM_Try, /*On fail goto*//*Label 1903*/ GIMT_Encode4(115397), // Rule ID 10635 //
     /* 115370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115384 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115384 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115387 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115389 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115391 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115396 */   // GIR_Coverage, 10635,
     /* 115396 */   GIR_EraseRootFromParent_Done,
     /* 115397 */ // Label 1903: @115397
     /* 115397 */ GIM_Try, /*On fail goto*//*Label 1904*/ GIMT_Encode4(115429), // Rule ID 10636 //
     /* 115402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115412 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115416 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115416 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115419 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115421 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115428 */   // GIR_Coverage, 10636,
     /* 115428 */   GIR_EraseRootFromParent_Done,
     /* 115429 */ // Label 1904: @115429
     /* 115429 */ GIM_Try, /*On fail goto*//*Label 1905*/ GIMT_Encode4(115461), // Rule ID 10637 //
     /* 115434 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115444 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115448 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115448 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115451 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115453 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115455 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115460 */   // GIR_Coverage, 10637,
     /* 115460 */   GIR_EraseRootFromParent_Done,
     /* 115461 */ // Label 1905: @115461
     /* 115461 */ GIM_Try, /*On fail goto*//*Label 1906*/ GIMT_Encode4(115493), // Rule ID 10638 //
     /* 115466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115480 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115483 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115485 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115487 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115492 */   // GIR_Coverage, 10638,
     /* 115492 */   GIR_EraseRootFromParent_Done,
     /* 115493 */ // Label 1906: @115493
     /* 115493 */ GIM_Try, /*On fail goto*//*Label 1907*/ GIMT_Encode4(115525), // Rule ID 10639 //
     /* 115498 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115508 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115512 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115512 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115515 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115517 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115524 */   // GIR_Coverage, 10639,
     /* 115524 */   GIR_EraseRootFromParent_Done,
     /* 115525 */ // Label 1907: @115525
     /* 115525 */ GIM_Try, /*On fail goto*//*Label 1908*/ GIMT_Encode4(115557), // Rule ID 10648 //
     /* 115530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115540 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115544 */   // (bitconvert:{ *:[nxv4i32] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv4i32] }:$src
     /* 115544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115547 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115549 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115551 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115556 */   // GIR_Coverage, 10648,
     /* 115556 */   GIR_EraseRootFromParent_Done,
     /* 115557 */ // Label 1908: @115557
     /* 115557 */ GIM_Try, /*On fail goto*//*Label 1909*/ GIMT_Encode4(115589), // Rule ID 10649 //
     /* 115562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115572 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115576 */   // (bitconvert:{ *:[nxv4f32] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv4f32] }:$src
     /* 115576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115579 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115581 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115583 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115588 */   // GIR_Coverage, 10649,
     /* 115588 */   GIR_EraseRootFromParent_Done,
     /* 115589 */ // Label 1909: @115589
     /* 115589 */ GIM_Reject,
     /* 115590 */ // Label 1628: @115590
     /* 115590 */ GIM_Try, /*On fail goto*//*Label 1910*/ GIMT_Encode4(115622), // Rule ID 10610 //
     /* 115595 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115598 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115605 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115609 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115609 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115612 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115614 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115616 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115621 */   // GIR_Coverage, 10610,
     /* 115621 */   GIR_EraseRootFromParent_Done,
     /* 115622 */ // Label 1910: @115622
     /* 115622 */ GIM_Try, /*On fail goto*//*Label 1911*/ GIMT_Encode4(115654), // Rule ID 10611 //
     /* 115627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115637 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115641 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115644 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115646 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115648 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115653 */   // GIR_Coverage, 10611,
     /* 115653 */   GIR_EraseRootFromParent_Done,
     /* 115654 */ // Label 1911: @115654
     /* 115654 */ GIM_Try, /*On fail goto*//*Label 1912*/ GIMT_Encode4(115686), // Rule ID 10612 //
     /* 115659 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115662 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115669 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115673 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115673 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115676 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115678 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115680 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115685 */   // GIR_Coverage, 10612,
     /* 115685 */   GIR_EraseRootFromParent_Done,
     /* 115686 */ // Label 1912: @115686
     /* 115686 */ GIM_Try, /*On fail goto*//*Label 1913*/ GIMT_Encode4(115718), // Rule ID 10613 //
     /* 115691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115705 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115705 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115708 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115710 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115712 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115717 */   // GIR_Coverage, 10613,
     /* 115717 */   GIR_EraseRootFromParent_Done,
     /* 115718 */ // Label 1913: @115718
     /* 115718 */ GIM_Try, /*On fail goto*//*Label 1914*/ GIMT_Encode4(115750), // Rule ID 10614 //
     /* 115723 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115733 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115737 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115737 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115740 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115742 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115744 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115749 */   // GIR_Coverage, 10614,
     /* 115749 */   GIR_EraseRootFromParent_Done,
     /* 115750 */ // Label 1914: @115750
     /* 115750 */ GIM_Try, /*On fail goto*//*Label 1915*/ GIMT_Encode4(115782), // Rule ID 10615 //
     /* 115755 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115769 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115772 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115774 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115776 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115781 */   // GIR_Coverage, 10615,
     /* 115781 */   GIR_EraseRootFromParent_Done,
     /* 115782 */ // Label 1915: @115782
     /* 115782 */ GIM_Try, /*On fail goto*//*Label 1916*/ GIMT_Encode4(115814), // Rule ID 10628 //
     /* 115787 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115790 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 115793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115797 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115801 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv16i8] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115801 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115804 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115806 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115808 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115813 */   // GIR_Coverage, 10628,
     /* 115813 */   GIR_EraseRootFromParent_Done,
     /* 115814 */ // Label 1916: @115814
     /* 115814 */ GIM_Try, /*On fail goto*//*Label 1917*/ GIMT_Encode4(115846), // Rule ID 10629 //
     /* 115819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115825 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115829 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115833 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115833 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115836 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115838 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115840 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115845 */   // GIR_Coverage, 10629,
     /* 115845 */   GIR_EraseRootFromParent_Done,
     /* 115846 */ // Label 1917: @115846
     /* 115846 */ GIM_Try, /*On fail goto*//*Label 1918*/ GIMT_Encode4(115878), // Rule ID 10630 //
     /* 115851 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115854 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115857 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115865 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115865 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115868 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115870 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115872 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115877 */   // GIR_Coverage, 10630,
     /* 115877 */   GIR_EraseRootFromParent_Done,
     /* 115878 */ // Label 1918: @115878
     /* 115878 */ GIM_Try, /*On fail goto*//*Label 1919*/ GIMT_Encode4(115910), // Rule ID 10631 //
     /* 115883 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115897 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115900 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115902 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115904 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115909 */   // GIR_Coverage, 10631,
     /* 115909 */   GIR_EraseRootFromParent_Done,
     /* 115910 */ // Label 1919: @115910
     /* 115910 */ GIM_Try, /*On fail goto*//*Label 1920*/ GIMT_Encode4(115942), // Rule ID 10632 //
     /* 115915 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 115921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115925 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115929 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115929 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115932 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115934 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115936 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115941 */   // GIR_Coverage, 10632,
     /* 115941 */   GIR_EraseRootFromParent_Done,
     /* 115942 */ // Label 1920: @115942
     /* 115942 */ GIM_Try, /*On fail goto*//*Label 1921*/ GIMT_Encode4(115974), // Rule ID 10633 //
     /* 115947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 115950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 115953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115961 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 115961 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115964 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115966 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 115968 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115973 */   // GIR_Coverage, 10633,
     /* 115973 */   GIR_EraseRootFromParent_Done,
     /* 115974 */ // Label 1921: @115974
     /* 115974 */ GIM_Try, /*On fail goto*//*Label 1922*/ GIMT_Encode4(116006), // Rule ID 10646 //
     /* 115979 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 115982 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 115985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 115993 */   // (bitconvert:{ *:[nxv8i16] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv8i16] }:$src
     /* 115993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 115996 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 115998 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116000 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116005 */   // GIR_Coverage, 10646,
     /* 116005 */   GIR_EraseRootFromParent_Done,
     /* 116006 */ // Label 1922: @116006
     /* 116006 */ GIM_Try, /*On fail goto*//*Label 1923*/ GIMT_Encode4(116038), // Rule ID 10647 //
     /* 116011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 116014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116025 */   // (bitconvert:{ *:[nxv8f16] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv8f16] }:$src
     /* 116025 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116028 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116030 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116032 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116037 */   // GIR_Coverage, 10647,
     /* 116037 */   GIR_EraseRootFromParent_Done,
     /* 116038 */ // Label 1923: @116038
     /* 116038 */ GIM_Reject,
     /* 116039 */ // Label 1629: @116039
     /* 116039 */ GIM_Try, /*On fail goto*//*Label 1924*/ GIMT_Encode4(116071), // Rule ID 10604 //
     /* 116044 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116058 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116058 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116061 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116063 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116070 */   // GIR_Coverage, 10604,
     /* 116070 */   GIR_EraseRootFromParent_Done,
     /* 116071 */ // Label 1924: @116071
     /* 116071 */ GIM_Try, /*On fail goto*//*Label 1925*/ GIMT_Encode4(116103), // Rule ID 10605 //
     /* 116076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116090 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116093 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116095 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116097 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116102 */   // GIR_Coverage, 10605,
     /* 116102 */   GIR_EraseRootFromParent_Done,
     /* 116103 */ // Label 1925: @116103
     /* 116103 */ GIM_Try, /*On fail goto*//*Label 1926*/ GIMT_Encode4(116135), // Rule ID 10606 //
     /* 116108 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116122 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116122 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116125 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116127 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116129 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116134 */   // GIR_Coverage, 10606,
     /* 116134 */   GIR_EraseRootFromParent_Done,
     /* 116135 */ // Label 1926: @116135
     /* 116135 */ GIM_Try, /*On fail goto*//*Label 1927*/ GIMT_Encode4(116167), // Rule ID 10607 //
     /* 116140 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116143 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 116146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116150 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116154 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116154 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116157 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116159 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116161 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116166 */   // GIR_Coverage, 10607,
     /* 116166 */   GIR_EraseRootFromParent_Done,
     /* 116167 */ // Label 1927: @116167
     /* 116167 */ GIM_Try, /*On fail goto*//*Label 1928*/ GIMT_Encode4(116199), // Rule ID 10608 //
     /* 116172 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 116178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116182 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116186 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116186 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116189 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116191 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116193 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116198 */   // GIR_Coverage, 10608,
     /* 116198 */   GIR_EraseRootFromParent_Done,
     /* 116199 */ // Label 1928: @116199
     /* 116199 */ GIM_Try, /*On fail goto*//*Label 1929*/ GIMT_Encode4(116231), // Rule ID 10609 //
     /* 116204 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME_IsLE),
     /* 116207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 116210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116218 */   // (bitconvert:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$src)  =>  ZPR:{ *:[nxv16i8] }:$src
     /* 116218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116221 */   GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 116223 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 116225 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 116230 */   // GIR_Coverage, 10609,
     /* 116230 */   GIR_EraseRootFromParent_Done,
     /* 116231 */ // Label 1929: @116231
     /* 116231 */ GIM_Reject,
     /* 116232 */ // Label 1630: @116232
     /* 116232 */ GIM_Reject,
     /* 116233 */ // Label 10: @116233
     /* 116233 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1938*/ GIMT_Encode4(116723),
     /* 116244 */ /*GILLT_s16*//*Label 1930*/ GIMT_Encode4(116284),
     /* 116248 */ /*GILLT_s32*//*Label 1931*/ GIMT_Encode4(116315),
     /* 116252 */ /*GILLT_s64*//*Label 1932*/ GIMT_Encode4(116346), GIMT_Encode4(0),
     /* 116260 */ /*GILLT_v2s32*//*Label 1933*/ GIMT_Encode4(116377),
     /* 116264 */ /*GILLT_v2s64*//*Label 1934*/ GIMT_Encode4(116408),
     /* 116268 */ /*GILLT_v4s16*//*Label 1935*/ GIMT_Encode4(116439),
     /* 116272 */ /*GILLT_v4s32*//*Label 1936*/ GIMT_Encode4(116470), GIMT_Encode4(0),
     /* 116280 */ /*GILLT_v8s16*//*Label 1937*/ GIMT_Encode4(116501),
     /* 116284 */ // Label 1930: @116284
     /* 116284 */ GIM_Try, /*On fail goto*//*Label 1939*/ GIMT_Encode4(116314), // Rule ID 564 //
     /* 116289 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116292 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116295 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116299 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116303 */   // (ftrunc:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTZHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZHr),
     /* 116308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116312 */   GIR_RootConstrainSelectedInstOperands,
     /* 116313 */   // GIR_Coverage, 564,
     /* 116313 */   GIR_Done,
     /* 116314 */ // Label 1939: @116314
     /* 116314 */ GIM_Reject,
     /* 116315 */ // Label 1931: @116315
     /* 116315 */ GIM_Try, /*On fail goto*//*Label 1940*/ GIMT_Encode4(116345), // Rule ID 566 //
     /* 116320 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116323 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116334 */   // (ftrunc:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZSr),
     /* 116339 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116343 */   GIR_RootConstrainSelectedInstOperands,
     /* 116344 */   // GIR_Coverage, 566,
     /* 116344 */   GIR_Done,
     /* 116345 */ // Label 1940: @116345
     /* 116345 */ GIM_Reject,
     /* 116346 */ // Label 1932: @116346
     /* 116346 */ GIM_Try, /*On fail goto*//*Label 1941*/ GIMT_Encode4(116376), // Rule ID 568 //
     /* 116351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116357 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116361 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116365 */   // (ftrunc:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116365 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZDr),
     /* 116370 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116374 */   GIR_RootConstrainSelectedInstOperands,
     /* 116375 */   // GIR_Coverage, 568,
     /* 116375 */   GIR_Done,
     /* 116376 */ // Label 1941: @116376
     /* 116376 */ GIM_Reject,
     /* 116377 */ // Label 1933: @116377
     /* 116377 */ GIM_Try, /*On fail goto*//*Label 1942*/ GIMT_Encode4(116407), // Rule ID 933 //
     /* 116382 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116388 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116392 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116396 */   // (ftrunc:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTZv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116396 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f32),
     /* 116401 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116405 */   GIR_RootConstrainSelectedInstOperands,
     /* 116406 */   // GIR_Coverage, 933,
     /* 116406 */   GIR_Done,
     /* 116407 */ // Label 1942: @116407
     /* 116407 */ GIM_Reject,
     /* 116408 */ // Label 1934: @116408
     /* 116408 */ GIM_Try, /*On fail goto*//*Label 1943*/ GIMT_Encode4(116438), // Rule ID 937 //
     /* 116413 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116416 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116419 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116423 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116427 */   // (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTZv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116427 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv2f64),
     /* 116432 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116436 */   GIR_RootConstrainSelectedInstOperands,
     /* 116437 */   // GIR_Coverage, 937,
     /* 116437 */   GIR_Done,
     /* 116438 */ // Label 1943: @116438
     /* 116438 */ GIM_Reject,
     /* 116439 */ // Label 1935: @116439
     /* 116439 */ GIM_Try, /*On fail goto*//*Label 1944*/ GIMT_Encode4(116469), // Rule ID 929 //
     /* 116444 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116447 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116450 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116454 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116458 */   // (ftrunc:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTZv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116458 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f16),
     /* 116463 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116467 */   GIR_RootConstrainSelectedInstOperands,
     /* 116468 */   // GIR_Coverage, 929,
     /* 116468 */   GIR_Done,
     /* 116469 */ // Label 1944: @116469
     /* 116469 */ GIM_Reject,
     /* 116470 */ // Label 1936: @116470
     /* 116470 */ GIM_Try, /*On fail goto*//*Label 1945*/ GIMT_Encode4(116500), // Rule ID 935 //
     /* 116475 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116478 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116481 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116485 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116489 */   // (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTZv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116494 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116498 */   GIR_RootConstrainSelectedInstOperands,
     /* 116499 */   // GIR_Coverage, 935,
     /* 116499 */   GIR_Done,
     /* 116500 */ // Label 1945: @116500
     /* 116500 */ GIM_Reject,
     /* 116501 */ // Label 1937: @116501
     /* 116501 */ GIM_Try, /*On fail goto*//*Label 1946*/ GIMT_Encode4(116722),
     /* 116506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 116509 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116513 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116517 */   GIM_Try, /*On fail goto*//*Label 1947*/ GIMT_Encode4(116536), // Rule ID 931 //
     /* 116522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116525 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTZv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 116525 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv8f16),
     /* 116530 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116534 */     GIR_RootConstrainSelectedInstOperands,
     /* 116535 */     // GIR_Coverage, 931,
     /* 116535 */     GIR_Done,
     /* 116536 */   // Label 1947: @116536
     /* 116536 */   GIM_Try, /*On fail goto*//*Label 1948*/ GIMT_Encode4(116721), // Rule ID 7040 //
     /* 116541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 116544 */     // (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTZv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTZv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 116544 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 116547 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 116551 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116556 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 116560 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 116562 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 116565 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116569 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116574 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 116577 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 116579 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 116582 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 116586 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116591 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 116597 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116602 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116607 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 116610 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 116614 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116619 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 116622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 116624 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 116627 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTZv4f32),
     /* 116631 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116636 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 116639 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 116641 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 116644 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 116648 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116653 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 116656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 116658 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 116661 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 116665 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116670 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 116672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 116675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 116679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 116684 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 116687 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 116690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 116693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116703 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 116711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 116713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 116716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 116719 */     GIR_RootConstrainSelectedInstOperands,
     /* 116720 */     // GIR_Coverage, 7040,
     /* 116720 */     GIR_EraseRootFromParent_Done,
     /* 116721 */   // Label 1948: @116721
     /* 116721 */   GIM_Reject,
     /* 116722 */ // Label 1946: @116722
     /* 116722 */ GIM_Reject,
     /* 116723 */ // Label 1938: @116723
     /* 116723 */ GIM_Reject,
     /* 116724 */ // Label 11: @116724
     /* 116724 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1957*/ GIMT_Encode4(117214),
     /* 116735 */ /*GILLT_s16*//*Label 1949*/ GIMT_Encode4(116775),
     /* 116739 */ /*GILLT_s32*//*Label 1950*/ GIMT_Encode4(116806),
     /* 116743 */ /*GILLT_s64*//*Label 1951*/ GIMT_Encode4(116837), GIMT_Encode4(0),
     /* 116751 */ /*GILLT_v2s32*//*Label 1952*/ GIMT_Encode4(116868),
     /* 116755 */ /*GILLT_v2s64*//*Label 1953*/ GIMT_Encode4(116899),
     /* 116759 */ /*GILLT_v4s16*//*Label 1954*/ GIMT_Encode4(116930),
     /* 116763 */ /*GILLT_v4s32*//*Label 1955*/ GIMT_Encode4(116961), GIMT_Encode4(0),
     /* 116771 */ /*GILLT_v8s16*//*Label 1956*/ GIMT_Encode4(116992),
     /* 116775 */ // Label 1949: @116775
     /* 116775 */ GIM_Try, /*On fail goto*//*Label 1958*/ GIMT_Encode4(116805), // Rule ID 528 //
     /* 116780 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 116783 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 116786 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116790 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 116794 */   // (fround:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTAHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 116794 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAHr),
     /* 116799 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116803 */   GIR_RootConstrainSelectedInstOperands,
     /* 116804 */   // GIR_Coverage, 528,
     /* 116804 */   GIR_Done,
     /* 116805 */ // Label 1958: @116805
     /* 116805 */ GIM_Reject,
     /* 116806 */ // Label 1950: @116806
     /* 116806 */ GIM_Try, /*On fail goto*//*Label 1959*/ GIMT_Encode4(116836), // Rule ID 530 //
     /* 116811 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 116817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 116825 */   // (fround:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTASr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 116825 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTASr),
     /* 116830 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116834 */   GIR_RootConstrainSelectedInstOperands,
     /* 116835 */   // GIR_Coverage, 530,
     /* 116835 */   GIR_Done,
     /* 116836 */ // Label 1959: @116836
     /* 116836 */ GIM_Reject,
     /* 116837 */ // Label 1951: @116837
     /* 116837 */ GIM_Try, /*On fail goto*//*Label 1960*/ GIMT_Encode4(116867), // Rule ID 532 //
     /* 116842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 116845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 116848 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116852 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116856 */   // (fround:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTADr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 116856 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTADr),
     /* 116861 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116865 */   GIR_RootConstrainSelectedInstOperands,
     /* 116866 */   // GIR_Coverage, 532,
     /* 116866 */   GIR_Done,
     /* 116867 */ // Label 1960: @116867
     /* 116867 */ GIM_Reject,
     /* 116868 */ // Label 1952: @116868
     /* 116868 */ GIM_Try, /*On fail goto*//*Label 1961*/ GIMT_Encode4(116898), // Rule ID 873 //
     /* 116873 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116876 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 116879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116883 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116887 */   // (fround:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 116887 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f32),
     /* 116892 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116896 */   GIR_RootConstrainSelectedInstOperands,
     /* 116897 */   // GIR_Coverage, 873,
     /* 116897 */   GIR_Done,
     /* 116898 */ // Label 1961: @116898
     /* 116898 */ GIM_Reject,
     /* 116899 */ // Label 1953: @116899
     /* 116899 */ GIM_Try, /*On fail goto*//*Label 1962*/ GIMT_Encode4(116929), // Rule ID 877 //
     /* 116904 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 116910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116914 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116918 */   // (fround:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 116918 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv2f64),
     /* 116923 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116927 */   GIR_RootConstrainSelectedInstOperands,
     /* 116928 */   // GIR_Coverage, 877,
     /* 116928 */   GIR_Done,
     /* 116929 */ // Label 1962: @116929
     /* 116929 */ GIM_Reject,
     /* 116930 */ // Label 1954: @116930
     /* 116930 */ GIM_Try, /*On fail goto*//*Label 1963*/ GIMT_Encode4(116960), // Rule ID 869 //
     /* 116935 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 116938 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 116941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116945 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 116949 */   // (fround:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 116949 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f16),
     /* 116954 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116958 */   GIR_RootConstrainSelectedInstOperands,
     /* 116959 */   // GIR_Coverage, 869,
     /* 116959 */   GIR_Done,
     /* 116960 */ // Label 1963: @116960
     /* 116960 */ GIM_Reject,
     /* 116961 */ // Label 1955: @116961
     /* 116961 */ GIM_Try, /*On fail goto*//*Label 1964*/ GIMT_Encode4(116991), // Rule ID 875 //
     /* 116966 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 116969 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 116972 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116976 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 116980 */   // (fround:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 116980 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 116985 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 116989 */   GIR_RootConstrainSelectedInstOperands,
     /* 116990 */   // GIR_Coverage, 875,
     /* 116990 */   GIR_Done,
     /* 116991 */ // Label 1964: @116991
     /* 116991 */ GIM_Reject,
     /* 116992 */ // Label 1956: @116992
     /* 116992 */ GIM_Try, /*On fail goto*//*Label 1965*/ GIMT_Encode4(117213),
     /* 116997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117000 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117004 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117008 */   GIM_Try, /*On fail goto*//*Label 1966*/ GIMT_Encode4(117027), // Rule ID 871 //
     /* 117013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117016 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv8f16),
     /* 117021 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117025 */     GIR_RootConstrainSelectedInstOperands,
     /* 117026 */     // GIR_Coverage, 871,
     /* 117026 */     GIR_Done,
     /* 117027 */   // Label 1966: @117027
     /* 117027 */   GIM_Try, /*On fail goto*//*Label 1967*/ GIMT_Encode4(117212), // Rule ID 7034 //
     /* 117032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117035 */     // (fround:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTAv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTAv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117035 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117038 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117042 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117047 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117051 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117053 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117056 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117060 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117065 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117068 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117070 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117073 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117077 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117082 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117088 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117093 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117098 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 117101 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 117105 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117110 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 117113 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 117115 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 117118 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTAv4f32),
     /* 117122 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117127 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 117130 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 117132 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 117135 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 117139 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117144 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 117147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 117149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 117152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 117156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 117163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 117166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 117170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 117178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 117181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 117184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 117202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 117204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117207 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 117210 */     GIR_RootConstrainSelectedInstOperands,
     /* 117211 */     // GIR_Coverage, 7034,
     /* 117211 */     GIR_EraseRootFromParent_Done,
     /* 117212 */   // Label 1967: @117212
     /* 117212 */   GIM_Reject,
     /* 117213 */ // Label 1965: @117213
     /* 117213 */ GIM_Reject,
     /* 117214 */ // Label 1957: @117214
     /* 117214 */ GIM_Reject,
     /* 117215 */ // Label 12: @117215
     /* 117215 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 1970*/ GIMT_Encode4(117482),
     /* 117226 */ /*GILLT_s32*//*Label 1968*/ GIMT_Encode4(117234),
     /* 117230 */ /*GILLT_s64*//*Label 1969*/ GIMT_Encode4(117358),
     /* 117234 */ // Label 1968: @117234
     /* 117234 */ GIM_Try, /*On fail goto*//*Label 1971*/ GIMT_Encode4(117277), // Rule ID 4820 //
     /* 117239 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117242 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117249 */   // (lrint:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117249 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117252 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117256 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117261 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117267 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 117270 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117272 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117275 */   GIR_RootConstrainSelectedInstOperands,
     /* 117276 */   // GIR_Coverage, 4820,
     /* 117276 */   GIR_EraseRootFromParent_Done,
     /* 117277 */ // Label 1971: @117277
     /* 117277 */ GIM_Try, /*On fail goto*//*Label 1972*/ GIMT_Encode4(117317), // Rule ID 4826 //
     /* 117282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117285 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117289 */   // (lrint:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117289 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117292 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117296 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117301 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 117310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117315 */   GIR_RootConstrainSelectedInstOperands,
     /* 117316 */   // GIR_Coverage, 4826,
     /* 117316 */   GIR_EraseRootFromParent_Done,
     /* 117317 */ // Label 1972: @117317
     /* 117317 */ GIM_Try, /*On fail goto*//*Label 1973*/ GIMT_Encode4(117357), // Rule ID 4828 //
     /* 117322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 117329 */   // (lrint:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117341 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117345 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117347 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 117350 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117352 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117355 */   GIR_RootConstrainSelectedInstOperands,
     /* 117356 */   // GIR_Coverage, 4828,
     /* 117356 */   GIR_EraseRootFromParent_Done,
     /* 117357 */ // Label 1973: @117357
     /* 117357 */ GIM_Reject,
     /* 117358 */ // Label 1969: @117358
     /* 117358 */ GIM_Try, /*On fail goto*//*Label 1974*/ GIMT_Encode4(117401), // Rule ID 4822 //
     /* 117363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117373 */   // (lrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117373 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117376 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117380 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117385 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117391 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117394 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117396 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117399 */   GIR_RootConstrainSelectedInstOperands,
     /* 117400 */   // GIR_Coverage, 4822,
     /* 117400 */   GIR_EraseRootFromParent_Done,
     /* 117401 */ // Label 1974: @117401
     /* 117401 */ GIM_Try, /*On fail goto*//*Label 1975*/ GIMT_Encode4(117441), // Rule ID 4830 //
     /* 117406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117413 */   // (lrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117413 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117416 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117420 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117425 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117431 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117434 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117436 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117439 */   GIR_RootConstrainSelectedInstOperands,
     /* 117440 */   // GIR_Coverage, 4830,
     /* 117440 */   GIR_EraseRootFromParent_Done,
     /* 117441 */ // Label 1975: @117441
     /* 117441 */ GIM_Try, /*On fail goto*//*Label 1976*/ GIMT_Encode4(117481), // Rule ID 4832 //
     /* 117446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117453 */   // (lrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117465 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117471 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117474 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117476 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117479 */   GIR_RootConstrainSelectedInstOperands,
     /* 117480 */   // GIR_Coverage, 4832,
     /* 117480 */   GIR_EraseRootFromParent_Done,
     /* 117481 */ // Label 1976: @117481
     /* 117481 */ GIM_Reject,
     /* 117482 */ // Label 1970: @117482
     /* 117482 */ GIM_Reject,
     /* 117483 */ // Label 13: @117483
     /* 117483 */ GIM_Try, /*On fail goto*//*Label 1977*/ GIMT_Encode4(117632),
     /* 117488 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 117491 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 1981*/ GIMT_Encode4(117631),
     /* 117502 */   /*GILLT_s16*//*Label 1978*/ GIMT_Encode4(117514),
     /* 117506 */   /*GILLT_s32*//*Label 1979*/ GIMT_Encode4(117555),
     /* 117510 */   /*GILLT_s64*//*Label 1980*/ GIMT_Encode4(117593),
     /* 117514 */   // Label 1978: @117514
     /* 117514 */   GIM_Try, /*On fail goto*//*Label 1982*/ GIMT_Encode4(117554), // Rule ID 4824 //
     /* 117519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117522 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117526 */     // (llrint:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } (FRINTXHr:{ *:[i16] } f16:{ *:[f16] }:$Rn))
     /* 117526 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 117529 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 117533 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117538 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117542 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 117547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117549 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117552 */     GIR_RootConstrainSelectedInstOperands,
     /* 117553 */     // GIR_Coverage, 4824,
     /* 117553 */     GIR_EraseRootFromParent_Done,
     /* 117554 */   // Label 1982: @117554
     /* 117554 */   GIM_Reject,
     /* 117555 */   // Label 1979: @117555
     /* 117555 */   GIM_Try, /*On fail goto*//*Label 1983*/ GIMT_Encode4(117592), // Rule ID 4834 //
     /* 117560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117564 */     // (llrint:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } (FRINTXSr:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 117564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 117567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 117571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117576 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 117585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117587 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117590 */     GIR_RootConstrainSelectedInstOperands,
     /* 117591 */     // GIR_Coverage, 4834,
     /* 117591 */     GIR_EraseRootFromParent_Done,
     /* 117592 */   // Label 1983: @117592
     /* 117592 */   GIM_Reject,
     /* 117593 */   // Label 1980: @117593
     /* 117593 */   GIM_Try, /*On fail goto*//*Label 1984*/ GIMT_Encode4(117630), // Rule ID 4836 //
     /* 117598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 117602 */     // (llrint:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } (FRINTXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 117602 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 117605 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 117609 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117614 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117618 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 117620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 117623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 117625 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 117628 */     GIR_RootConstrainSelectedInstOperands,
     /* 117629 */     // GIR_Coverage, 4836,
     /* 117629 */     GIR_EraseRootFromParent_Done,
     /* 117630 */   // Label 1984: @117630
     /* 117630 */   GIM_Reject,
     /* 117631 */   // Label 1981: @117631
     /* 117631 */   GIM_Reject,
     /* 117632 */ // Label 1977: @117632
     /* 117632 */ GIM_Reject,
     /* 117633 */ // Label 14: @117633
     /* 117633 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 1993*/ GIMT_Encode4(118123),
     /* 117644 */ /*GILLT_s16*//*Label 1985*/ GIMT_Encode4(117684),
     /* 117648 */ /*GILLT_s32*//*Label 1986*/ GIMT_Encode4(117715),
     /* 117652 */ /*GILLT_s64*//*Label 1987*/ GIMT_Encode4(117746), GIMT_Encode4(0),
     /* 117660 */ /*GILLT_v2s32*//*Label 1988*/ GIMT_Encode4(117777),
     /* 117664 */ /*GILLT_v2s64*//*Label 1989*/ GIMT_Encode4(117808),
     /* 117668 */ /*GILLT_v4s16*//*Label 1990*/ GIMT_Encode4(117839),
     /* 117672 */ /*GILLT_v4s32*//*Label 1991*/ GIMT_Encode4(117870), GIMT_Encode4(0),
     /* 117680 */ /*GILLT_v8s16*//*Label 1992*/ GIMT_Encode4(117901),
     /* 117684 */ // Label 1985: @117684
     /* 117684 */ GIM_Try, /*On fail goto*//*Label 1994*/ GIMT_Encode4(117714), // Rule ID 546 //
     /* 117689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 117692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 117695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117699 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 117703 */   // (froundeven:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTNHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 117703 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNHr),
     /* 117708 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117712 */   GIR_RootConstrainSelectedInstOperands,
     /* 117713 */   // GIR_Coverage, 546,
     /* 117713 */   GIR_Done,
     /* 117714 */ // Label 1994: @117714
     /* 117714 */ GIM_Reject,
     /* 117715 */ // Label 1986: @117715
     /* 117715 */ GIM_Try, /*On fail goto*//*Label 1995*/ GIMT_Encode4(117745), // Rule ID 548 //
     /* 117720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 117726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 117734 */   // (froundeven:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTNSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 117734 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNSr),
     /* 117739 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117743 */   GIR_RootConstrainSelectedInstOperands,
     /* 117744 */   // GIR_Coverage, 548,
     /* 117744 */   GIR_Done,
     /* 117745 */ // Label 1995: @117745
     /* 117745 */ GIM_Reject,
     /* 117746 */ // Label 1987: @117746
     /* 117746 */ GIM_Try, /*On fail goto*//*Label 1996*/ GIMT_Encode4(117776), // Rule ID 550 //
     /* 117751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 117754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 117757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117761 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117765 */   // (froundeven:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTNDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 117765 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNDr),
     /* 117770 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117774 */   GIR_RootConstrainSelectedInstOperands,
     /* 117775 */   // GIR_Coverage, 550,
     /* 117775 */   GIR_Done,
     /* 117776 */ // Label 1996: @117776
     /* 117776 */ GIM_Reject,
     /* 117777 */ // Label 1988: @117777
     /* 117777 */ GIM_Try, /*On fail goto*//*Label 1997*/ GIMT_Encode4(117807), // Rule ID 903 //
     /* 117782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 117788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117796 */   // (froundeven:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTNv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 117796 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f32),
     /* 117801 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117805 */   GIR_RootConstrainSelectedInstOperands,
     /* 117806 */   // GIR_Coverage, 903,
     /* 117806 */   GIR_Done,
     /* 117807 */ // Label 1997: @117807
     /* 117807 */ GIM_Reject,
     /* 117808 */ // Label 1989: @117808
     /* 117808 */ GIM_Try, /*On fail goto*//*Label 1998*/ GIMT_Encode4(117838), // Rule ID 907 //
     /* 117813 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117816 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 117819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117827 */   // (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTNv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 117827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv2f64),
     /* 117832 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117836 */   GIR_RootConstrainSelectedInstOperands,
     /* 117837 */   // GIR_Coverage, 907,
     /* 117837 */   GIR_Done,
     /* 117838 */ // Label 1998: @117838
     /* 117838 */ GIM_Reject,
     /* 117839 */ // Label 1990: @117839
     /* 117839 */ GIM_Try, /*On fail goto*//*Label 1999*/ GIMT_Encode4(117869), // Rule ID 899 //
     /* 117844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 117850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 117858 */   // (froundeven:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTNv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 117858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f16),
     /* 117863 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117867 */   GIR_RootConstrainSelectedInstOperands,
     /* 117868 */   // GIR_Coverage, 899,
     /* 117868 */   GIR_Done,
     /* 117869 */ // Label 1999: @117869
     /* 117869 */ GIM_Reject,
     /* 117870 */ // Label 1991: @117870
     /* 117870 */ GIM_Try, /*On fail goto*//*Label 2000*/ GIMT_Encode4(117900), // Rule ID 905 //
     /* 117875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 117878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 117881 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117885 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117889 */   // (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTNv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 117889 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117894 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117898 */   GIR_RootConstrainSelectedInstOperands,
     /* 117899 */   // GIR_Coverage, 905,
     /* 117899 */   GIR_Done,
     /* 117900 */ // Label 2000: @117900
     /* 117900 */ GIM_Reject,
     /* 117901 */ // Label 1992: @117901
     /* 117901 */ GIM_Try, /*On fail goto*//*Label 2001*/ GIMT_Encode4(118122),
     /* 117906 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 117909 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117913 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 117917 */   GIM_Try, /*On fail goto*//*Label 2002*/ GIMT_Encode4(117936), // Rule ID 901 //
     /* 117922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 117925 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTNv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 117925 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv8f16),
     /* 117930 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 117934 */     GIR_RootConstrainSelectedInstOperands,
     /* 117935 */     // GIR_Coverage, 901,
     /* 117935 */     GIR_Done,
     /* 117936 */   // Label 2002: @117936
     /* 117936 */   GIM_Try, /*On fail goto*//*Label 2003*/ GIMT_Encode4(118121), // Rule ID 7036 //
     /* 117941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 117944 */     // (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTNv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTNv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 117944 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 117947 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 117951 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117956 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 117960 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 117962 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 117965 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 117969 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117974 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 117977 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 117979 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 117982 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 117986 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 117991 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 117997 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118002 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118007 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 118010 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 118014 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118019 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 118022 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 118024 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 118027 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTNv4f32),
     /* 118031 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118036 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 118039 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 118041 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 118044 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 118048 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118053 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 118056 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 118058 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 118061 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 118065 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 118072 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 118075 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 118079 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 118084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 118087 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 118090 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 118093 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118098 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 118103 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 118108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 118111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 118113 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 118116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 118119 */     GIR_RootConstrainSelectedInstOperands,
     /* 118120 */     // GIR_Coverage, 7036,
     /* 118120 */     GIR_EraseRootFromParent_Done,
     /* 118121 */   // Label 2003: @118121
     /* 118121 */   GIM_Reject,
     /* 118122 */ // Label 2001: @118122
     /* 118122 */ GIM_Reject,
     /* 118123 */ // Label 1993: @118123
     /* 118123 */ GIM_Reject,
     /* 118124 */ // Label 15: @118124
     /* 118124 */ GIM_Try, /*On fail goto*//*Label 2004*/ GIMT_Encode4(118156), // Rule ID 3903 //
     /* 118129 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 118132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 118136 */   // (readcyclecounter:{ *:[i64] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 57090:{ *:[i32] })
     /* 118136 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 118139 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118141 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(57090),
     /* 118151 */   GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 118154 */   GIR_RootConstrainSelectedInstOperands,
     /* 118155 */   // GIR_Coverage, 3903,
     /* 118155 */   GIR_EraseRootFromParent_Done,
     /* 118156 */ // Label 2004: @118156
     /* 118156 */ GIM_Reject,
     /* 118157 */ // Label 16: @118157
     /* 118157 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2025*/ GIMT_Encode4(127094),
     /* 118168 */ /*GILLT_s8*//*Label 2005*/ GIMT_Encode4(118264),
     /* 118172 */ /*GILLT_s16*//*Label 2006*/ GIMT_Encode4(118440),
     /* 118176 */ /*GILLT_s32*//*Label 2007*/ GIMT_Encode4(118616),
     /* 118180 */ /*GILLT_s64*//*Label 2008*/ GIMT_Encode4(121010),
     /* 118184 */ /*GILLT_s128*//*Label 2009*/ GIMT_Encode4(123723),
     /* 118188 */ /*GILLT_v2s32*//*Label 2010*/ GIMT_Encode4(123932),
     /* 118192 */ /*GILLT_v2s64*//*Label 2011*/ GIMT_Encode4(124310),
     /* 118196 */ /*GILLT_v4s16*//*Label 2012*/ GIMT_Encode4(124688),
     /* 118200 */ /*GILLT_v4s32*//*Label 2013*/ GIMT_Encode4(125066),
     /* 118204 */ /*GILLT_v8s8*//*Label 2014*/ GIMT_Encode4(125444),
     /* 118208 */ /*GILLT_v8s16*//*Label 2015*/ GIMT_Encode4(125652),
     /* 118212 */ /*GILLT_v16s8*//*Label 2016*/ GIMT_Encode4(126030), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 118224 */ /*GILLT_nxv2s16*//*Label 2017*/ GIMT_Encode4(126238),
     /* 118228 */ /*GILLT_nxv2s32*//*Label 2018*/ GIMT_Encode4(126302),
     /* 118232 */ /*GILLT_nxv2s64*//*Label 2019*/ GIMT_Encode4(126366), GIMT_Encode4(0),
     /* 118240 */ /*GILLT_nxv4s16*//*Label 2020*/ GIMT_Encode4(126540),
     /* 118244 */ /*GILLT_nxv4s32*//*Label 2021*/ GIMT_Encode4(126604), GIMT_Encode4(0),
     /* 118252 */ /*GILLT_nxv8s16*//*Label 2022*/ GIMT_Encode4(126778),
     /* 118256 */ /*GILLT_nxv16s1*//*Label 2023*/ GIMT_Encode4(126952),
     /* 118260 */ /*GILLT_nxv16s8*//*Label 2024*/ GIMT_Encode4(126996),
     /* 118264 */ // Label 2005: @118264
     /* 118264 */ GIM_Try, /*On fail goto*//*Label 2026*/ GIMT_Encode4(118439),
     /* 118269 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118272 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 118280 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118284 */   GIM_Try, /*On fail goto*//*Label 2027*/ GIMT_Encode4(118325), // Rule ID 237 //
     /* 118289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118292 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118299 */     // (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 118302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118314 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118319 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118323 */     GIR_RootConstrainSelectedInstOperands,
     /* 118324 */     // GIR_Coverage, 237,
     /* 118324 */     GIR_EraseRootFromParent_Done,
     /* 118325 */   // Label 2027: @118325
     /* 118325 */   GIM_Try, /*On fail goto*//*Label 2028*/ GIMT_Encode4(118366), // Rule ID 238 //
     /* 118330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118333 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118340 */     // (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 118343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118360 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118364 */     GIR_RootConstrainSelectedInstOperands,
     /* 118365 */     // GIR_Coverage, 238,
     /* 118365 */     GIR_EraseRootFromParent_Done,
     /* 118366 */   // Label 2028: @118366
     /* 118366 */   GIM_Try, /*On fail goto*//*Label 2029*/ GIMT_Encode4(118402), // Rule ID 261 //
     /* 118371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118374 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 118381 */     // (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 118381 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 118384 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118386 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118391 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118396 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118400 */     GIR_RootConstrainSelectedInstOperands,
     /* 118401 */     // GIR_Coverage, 261,
     /* 118401 */     GIR_EraseRootFromParent_Done,
     /* 118402 */   // Label 2029: @118402
     /* 118402 */   GIM_Try, /*On fail goto*//*Label 2030*/ GIMT_Encode4(118438), // Rule ID 282 //
     /* 118407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118410 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 118417 */     // (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 118420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118436 */     GIR_RootConstrainSelectedInstOperands,
     /* 118437 */     // GIR_Coverage, 282,
     /* 118437 */     GIR_EraseRootFromParent_Done,
     /* 118438 */   // Label 2030: @118438
     /* 118438 */   GIM_Reject,
     /* 118439 */ // Label 2026: @118439
     /* 118439 */ GIM_Reject,
     /* 118440 */ // Label 2006: @118440
     /* 118440 */ GIM_Try, /*On fail goto*//*Label 2031*/ GIMT_Encode4(118615),
     /* 118445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118448 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 118456 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118460 */   GIM_Try, /*On fail goto*//*Label 2032*/ GIMT_Encode4(118501), // Rule ID 239 //
     /* 118465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118468 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118475 */     // (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroW:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 118478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118480 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118495 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118499 */     GIR_RootConstrainSelectedInstOperands,
     /* 118500 */     // GIR_Coverage, 239,
     /* 118500 */     GIR_EraseRootFromParent_Done,
     /* 118501 */   // Label 2032: @118501
     /* 118501 */   GIM_Try, /*On fail goto*//*Label 2033*/ GIMT_Encode4(118542), // Rule ID 240 //
     /* 118506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118509 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 118516 */     // (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHroX:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 118516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 118519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118526 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118531 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118536 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118540 */     GIR_RootConstrainSelectedInstOperands,
     /* 118541 */     // GIR_Coverage, 240,
     /* 118541 */     GIR_EraseRootFromParent_Done,
     /* 118542 */   // Label 2033: @118542
     /* 118542 */   GIM_Try, /*On fail goto*//*Label 2034*/ GIMT_Encode4(118578), // Rule ID 262 //
     /* 118547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118550 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 118557 */     // (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRHui:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 118557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 118560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118576 */     GIR_RootConstrainSelectedInstOperands,
     /* 118577 */     // GIR_Coverage, 262,
     /* 118577 */     GIR_EraseRootFromParent_Done,
     /* 118578 */   // Label 2034: @118578
     /* 118578 */   GIM_Try, /*On fail goto*//*Label 2035*/ GIMT_Encode4(118614), // Rule ID 283 //
     /* 118583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118586 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 118593 */     // (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURHi:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 118593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 118596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118598 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 118608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118612 */     GIR_RootConstrainSelectedInstOperands,
     /* 118613 */     // GIR_Coverage, 283,
     /* 118613 */     GIR_EraseRootFromParent_Done,
     /* 118614 */   // Label 2035: @118614
     /* 118614 */   GIM_Reject,
     /* 118615 */ // Label 2031: @118615
     /* 118615 */ GIM_Reject,
     /* 118616 */ // Label 2007: @118616
     /* 118616 */ GIM_Try, /*On fail goto*//*Label 2036*/ GIMT_Encode4(118669), // Rule ID 233 //
     /* 118621 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118624 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118628 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118632 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118636 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118643 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 118646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118648 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118653 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118658 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118663 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118667 */   GIR_RootConstrainSelectedInstOperands,
     /* 118668 */   // GIR_Coverage, 233,
     /* 118668 */   GIR_EraseRootFromParent_Done,
     /* 118669 */ // Label 2036: @118669
     /* 118669 */ GIM_Try, /*On fail goto*//*Label 2037*/ GIMT_Encode4(118722), // Rule ID 234 //
     /* 118674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118677 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118681 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118685 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118689 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118696 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118696 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 118699 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118701 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118706 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118711 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118716 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118720 */   GIR_RootConstrainSelectedInstOperands,
     /* 118721 */   // GIR_Coverage, 234,
     /* 118721 */   GIR_EraseRootFromParent_Done,
     /* 118722 */ // Label 2037: @118722
     /* 118722 */ GIM_Try, /*On fail goto*//*Label 2038*/ GIMT_Encode4(118778), // Rule ID 241 //
     /* 118727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118730 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118733 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118737 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118741 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118745 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 118752 */   // (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroW:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 118752 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 118755 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118757 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118772 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118776 */   GIR_RootConstrainSelectedInstOperands,
     /* 118777 */   // GIR_Coverage, 241,
     /* 118777 */   GIR_EraseRootFromParent_Done,
     /* 118778 */ // Label 2038: @118778
     /* 118778 */ GIM_Try, /*On fail goto*//*Label 2039*/ GIMT_Encode4(118834), // Rule ID 242 //
     /* 118783 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 118786 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118789 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 118797 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118801 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 118808 */   // (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSroX:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 118808 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 118811 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118813 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118818 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118823 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118828 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118832 */   GIR_RootConstrainSelectedInstOperands,
     /* 118833 */   // GIR_Coverage, 242,
     /* 118833 */   GIR_EraseRootFromParent_Done,
     /* 118834 */ // Label 2039: @118834
     /* 118834 */ GIM_Try, /*On fail goto*//*Label 2040*/ GIMT_Encode4(118894), // Rule ID 4119 //
     /* 118839 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118842 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 118868 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 118868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 118871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118883 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118888 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118892 */   GIR_RootConstrainSelectedInstOperands,
     /* 118893 */   // GIR_Coverage, 4119,
     /* 118893 */   GIR_EraseRootFromParent_Done,
     /* 118894 */ // Label 2040: @118894
     /* 118894 */ GIM_Try, /*On fail goto*//*Label 2041*/ GIMT_Encode4(118954), // Rule ID 4120 //
     /* 118899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118902 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118906 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 118913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118917 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 118928 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 118928 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 118931 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 118943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 118948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 118952 */   GIR_RootConstrainSelectedInstOperands,
     /* 118953 */   // GIR_Coverage, 4120,
     /* 118953 */   GIR_EraseRootFromParent_Done,
     /* 118954 */ // Label 2041: @118954
     /* 118954 */ GIM_Try, /*On fail goto*//*Label 2042*/ GIMT_Encode4(119014), // Rule ID 4121 //
     /* 118959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 118962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 118966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 118973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 118977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 118981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 118988 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 118988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 118991 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 118993 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 118998 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119003 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119008 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119012 */   GIR_RootConstrainSelectedInstOperands,
     /* 119013 */   // GIR_Coverage, 4121,
     /* 119013 */   GIR_EraseRootFromParent_Done,
     /* 119014 */ // Label 2042: @119014
     /* 119014 */ GIM_Try, /*On fail goto*//*Label 2043*/ GIMT_Encode4(119074), // Rule ID 4122 //
     /* 119019 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119022 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119026 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119037 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119041 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119048 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119048 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119051 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119053 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119058 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119063 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119068 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119072 */   GIR_RootConstrainSelectedInstOperands,
     /* 119073 */   // GIR_Coverage, 4122,
     /* 119073 */   GIR_EraseRootFromParent_Done,
     /* 119074 */ // Label 2043: @119074
     /* 119074 */ GIM_Try, /*On fail goto*//*Label 2044*/ GIMT_Encode4(119134), // Rule ID 4123 //
     /* 119079 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119082 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119086 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119097 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119101 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119108 */   // (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119108 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119111 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119113 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119128 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119132 */   GIR_RootConstrainSelectedInstOperands,
     /* 119133 */   // GIR_Coverage, 4123,
     /* 119133 */   GIR_EraseRootFromParent_Done,
     /* 119134 */ // Label 2044: @119134
     /* 119134 */ GIM_Try, /*On fail goto*//*Label 2045*/ GIMT_Encode4(119194), // Rule ID 4124 //
     /* 119139 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119142 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119146 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119168 */   // (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119192 */   GIR_RootConstrainSelectedInstOperands,
     /* 119193 */   // GIR_Coverage, 4124,
     /* 119193 */   GIR_EraseRootFromParent_Done,
     /* 119194 */ // Label 2045: @119194
     /* 119194 */ GIM_Try, /*On fail goto*//*Label 2046*/ GIMT_Encode4(119242), // Rule ID 260 //
     /* 119199 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119202 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119210 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119214 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119221 */   // (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 119224 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119236 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119240 */   GIR_RootConstrainSelectedInstOperands,
     /* 119241 */   // GIR_Coverage, 260,
     /* 119241 */   GIR_EraseRootFromParent_Done,
     /* 119242 */ // Label 2046: @119242
     /* 119242 */ GIM_Try, /*On fail goto*//*Label 2047*/ GIMT_Encode4(119293), // Rule ID 263 //
     /* 119247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119261 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119265 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 119272 */   // (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRSui:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 119272 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 119275 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119287 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119291 */   GIR_RootConstrainSelectedInstOperands,
     /* 119292 */   // GIR_Coverage, 263,
     /* 119292 */   GIR_EraseRootFromParent_Done,
     /* 119293 */ // Label 2047: @119293
     /* 119293 */ GIM_Try, /*On fail goto*//*Label 2048*/ GIMT_Encode4(119356), // Rule ID 7066 //
     /* 119298 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119301 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119305 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119312 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119319 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119323 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 119330 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 119330 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 119333 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119335 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119340 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119345 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119350 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119354 */   GIR_RootConstrainSelectedInstOperands,
     /* 119355 */   // GIR_Coverage, 7066,
     /* 119355 */   GIR_EraseRootFromParent_Done,
     /* 119356 */ // Label 2048: @119356
     /* 119356 */ GIM_Try, /*On fail goto*//*Label 2049*/ GIMT_Encode4(119419), // Rule ID 7068 //
     /* 119361 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119364 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119368 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119375 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119386 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 119393 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 119393 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 119396 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119403 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119408 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 119413 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119417 */   GIR_RootConstrainSelectedInstOperands,
     /* 119418 */   // GIR_Coverage, 7068,
     /* 119418 */   GIR_EraseRootFromParent_Done,
     /* 119419 */ // Label 2049: @119419
     /* 119419 */ GIM_Try, /*On fail goto*//*Label 2050*/ GIMT_Encode4(119482), // Rule ID 7078 //
     /* 119424 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119427 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119431 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119438 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119445 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119449 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 119456 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 119456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 119459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119461 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119466 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119471 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119476 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119480 */   GIR_RootConstrainSelectedInstOperands,
     /* 119481 */   // GIR_Coverage, 7078,
     /* 119481 */   GIR_EraseRootFromParent_Done,
     /* 119482 */ // Label 2050: @119482
     /* 119482 */ GIM_Try, /*On fail goto*//*Label 2051*/ GIMT_Encode4(119545), // Rule ID 7080 //
     /* 119487 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119490 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119494 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119501 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119508 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119512 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 119519 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 119519 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 119522 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119524 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119529 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119534 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119539 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119543 */   GIR_RootConstrainSelectedInstOperands,
     /* 119544 */   // GIR_Coverage, 7080,
     /* 119544 */   GIR_EraseRootFromParent_Done,
     /* 119545 */ // Label 2051: @119545
     /* 119545 */ GIM_Try, /*On fail goto*//*Label 2052*/ GIMT_Encode4(119608), // Rule ID 7088 //
     /* 119550 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119557 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119564 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119571 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119575 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 119582 */   // (atomic_load:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>  =>  (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 119582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 119585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119602 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119606 */   GIR_RootConstrainSelectedInstOperands,
     /* 119607 */   // GIR_Coverage, 7088,
     /* 119607 */   GIR_EraseRootFromParent_Done,
     /* 119608 */ // Label 2052: @119608
     /* 119608 */ GIM_Try, /*On fail goto*//*Label 2053*/ GIMT_Encode4(119671), // Rule ID 7089 //
     /* 119613 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 119616 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119620 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 119627 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 119630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119634 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119638 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 119645 */   // (atomic_load:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>  =>  (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 119645 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 119648 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119655 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 119660 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 119665 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119669 */   GIR_RootConstrainSelectedInstOperands,
     /* 119670 */   // GIR_Coverage, 7089,
     /* 119670 */   GIR_EraseRootFromParent_Done,
     /* 119671 */ // Label 2053: @119671
     /* 119671 */ GIM_Try, /*On fail goto*//*Label 2054*/ GIMT_Encode4(119719), // Rule ID 281 //
     /* 119676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119691 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119698 */   // (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 119701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119717 */   GIR_RootConstrainSelectedInstOperands,
     /* 119718 */   // GIR_Coverage, 281,
     /* 119718 */   GIR_EraseRootFromParent_Done,
     /* 119719 */ // Label 2054: @119719
     /* 119719 */ GIM_Try, /*On fail goto*//*Label 2055*/ GIMT_Encode4(119770), // Rule ID 284 //
     /* 119724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 119727 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119734 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 119738 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119742 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 119749 */   // (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURSi:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 119749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 119752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119754 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119759 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119764 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119768 */   GIR_RootConstrainSelectedInstOperands,
     /* 119769 */   // GIR_Coverage, 284,
     /* 119769 */   GIR_EraseRootFromParent_Done,
     /* 119770 */ // Label 2055: @119770
     /* 119770 */ GIM_Try, /*On fail goto*//*Label 2056*/ GIMT_Encode4(119825), // Rule ID 4146 //
     /* 119775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 119804 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 119804 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 119807 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119823 */   GIR_RootConstrainSelectedInstOperands,
     /* 119824 */   // GIR_Coverage, 4146,
     /* 119824 */   GIR_EraseRootFromParent_Done,
     /* 119825 */ // Label 2056: @119825
     /* 119825 */ GIM_Try, /*On fail goto*//*Label 2057*/ GIMT_Encode4(119880), // Rule ID 4147 //
     /* 119830 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119833 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119837 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119848 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119852 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119859 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119859 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119862 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119869 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119874 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119878 */   GIR_RootConstrainSelectedInstOperands,
     /* 119879 */   // GIR_Coverage, 4147,
     /* 119879 */   GIR_EraseRootFromParent_Done,
     /* 119880 */ // Label 2057: @119880
     /* 119880 */ GIM_Try, /*On fail goto*//*Label 2058*/ GIMT_Encode4(119935), // Rule ID 4148 //
     /* 119885 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119888 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119892 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 119899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119903 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119907 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 119914 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 119914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 119917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119919 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119929 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119933 */   GIR_RootConstrainSelectedInstOperands,
     /* 119934 */   // GIR_Coverage, 4148,
     /* 119934 */   GIR_EraseRootFromParent_Done,
     /* 119935 */ // Label 2058: @119935
     /* 119935 */ GIM_Try, /*On fail goto*//*Label 2059*/ GIMT_Encode4(119990), // Rule ID 4169 //
     /* 119940 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119943 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 119947 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 119954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 119958 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 119962 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 119969 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 119969 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 119972 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 119974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 119979 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 119984 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 119988 */   GIR_RootConstrainSelectedInstOperands,
     /* 119989 */   // GIR_Coverage, 4169,
     /* 119989 */   GIR_EraseRootFromParent_Done,
     /* 119990 */ // Label 2059: @119990
     /* 119990 */ GIM_Try, /*On fail goto*//*Label 2060*/ GIMT_Encode4(120045), // Rule ID 4170 //
     /* 119995 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 119998 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120002 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120009 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120013 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120017 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120024 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120024 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120027 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120034 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120039 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120043 */   GIR_RootConstrainSelectedInstOperands,
     /* 120044 */   // GIR_Coverage, 4170,
     /* 120044 */   GIR_EraseRootFromParent_Done,
     /* 120045 */ // Label 2060: @120045
     /* 120045 */ GIM_Try, /*On fail goto*//*Label 2061*/ GIMT_Encode4(120100), // Rule ID 4171 //
     /* 120050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 120053 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120057 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120068 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120072 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120079 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120079 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120082 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120084 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120089 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120094 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120098 */   GIR_RootConstrainSelectedInstOperands,
     /* 120099 */   // GIR_Coverage, 4171,
     /* 120099 */   GIR_EraseRootFromParent_Done,
     /* 120100 */ // Label 2061: @120100
     /* 120100 */ GIM_Try, /*On fail goto*//*Label 2062*/ GIMT_Encode4(120158), // Rule ID 7070 //
     /* 120105 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120108 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120112 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120119 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120122 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120126 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 120137 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 120137 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 120140 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120142 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120147 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120152 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120156 */   GIR_RootConstrainSelectedInstOperands,
     /* 120157 */   // GIR_Coverage, 7070,
     /* 120157 */   GIR_EraseRootFromParent_Done,
     /* 120158 */ // Label 2062: @120158
     /* 120158 */ GIM_Try, /*On fail goto*//*Label 2063*/ GIMT_Encode4(120216), // Rule ID 7072 //
     /* 120163 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120166 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120170 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120177 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120180 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120184 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120188 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120195 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15836>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 120198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120200 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120205 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120210 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120214 */   GIR_RootConstrainSelectedInstOperands,
     /* 120215 */   // GIR_Coverage, 7072,
     /* 120215 */   GIR_EraseRootFromParent_Done,
     /* 120216 */ // Label 2063: @120216
     /* 120216 */ GIM_Try, /*On fail goto*//*Label 2064*/ GIMT_Encode4(120274), // Rule ID 7082 //
     /* 120221 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120224 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120235 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120242 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120246 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 120253 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 120253 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 120256 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120258 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120263 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120268 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120272 */   GIR_RootConstrainSelectedInstOperands,
     /* 120273 */   // GIR_Coverage, 7082,
     /* 120273 */   GIR_EraseRootFromParent_Done,
     /* 120274 */ // Label 2064: @120274
     /* 120274 */ GIM_Try, /*On fail goto*//*Label 2065*/ GIMT_Encode4(120332), // Rule ID 7084 //
     /* 120279 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120282 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120286 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120293 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120300 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120304 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120311 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15844>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120311 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 120314 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120330 */   GIR_RootConstrainSelectedInstOperands,
     /* 120331 */   // GIR_Coverage, 7084,
     /* 120331 */   GIR_EraseRootFromParent_Done,
     /* 120332 */ // Label 2065: @120332
     /* 120332 */ GIM_Try, /*On fail goto*//*Label 2066*/ GIMT_Encode4(120390), // Rule ID 7090 //
     /* 120337 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120340 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120344 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120351 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120358 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120362 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 120369 */   // (atomic_load:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>  =>  (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 120369 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 120372 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120384 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120388 */   GIR_RootConstrainSelectedInstOperands,
     /* 120389 */   // GIR_Coverage, 7090,
     /* 120389 */   GIR_EraseRootFromParent_Done,
     /* 120390 */ // Label 2066: @120390
     /* 120390 */ GIM_Try, /*On fail goto*//*Label 2067*/ GIMT_Encode4(120448), // Rule ID 7091 //
     /* 120395 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120402 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120409 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120416 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120420 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120427 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15852>>  =>  (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120427 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 120430 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120432 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120437 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120442 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120446 */   GIR_RootConstrainSelectedInstOperands,
     /* 120447 */   // GIR_Coverage, 7091,
     /* 120447 */   GIR_EraseRootFromParent_Done,
     /* 120448 */ // Label 2067: @120448
     /* 120448 */ GIM_Try, /*On fail goto*//*Label 2068*/ GIMT_Encode4(120509), // Rule ID 7476 //
     /* 120453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120456 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120459 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120463 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120470 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120473 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120477 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120481 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 120488 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15825>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 120491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120498 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120503 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120507 */   GIR_RootConstrainSelectedInstOperands,
     /* 120508 */   // GIR_Coverage, 7476,
     /* 120508 */   GIR_EraseRootFromParent_Done,
     /* 120509 */ // Label 2068: @120509
     /* 120509 */ GIM_Try, /*On fail goto*//*Label 2069*/ GIMT_Encode4(120570), // Rule ID 7478 //
     /* 120514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120517 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120520 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120524 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120531 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120538 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120542 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 120549 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15827>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120549 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 120552 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120559 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120564 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120568 */   GIR_RootConstrainSelectedInstOperands,
     /* 120569 */   // GIR_Coverage, 7478,
     /* 120569 */   GIR_EraseRootFromParent_Done,
     /* 120570 */ // Label 2069: @120570
     /* 120570 */ GIM_Try, /*On fail goto*//*Label 2070*/ GIMT_Encode4(120631), // Rule ID 7480 //
     /* 120575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 120578 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120581 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120592 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120599 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 120603 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 120610 */   // (atomic_load:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15829>>  =>  (LDAPURi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 120610 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURi),
     /* 120613 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 120615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 120620 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 120625 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 120629 */   GIR_RootConstrainSelectedInstOperands,
     /* 120630 */   // GIR_Coverage, 7480,
     /* 120630 */   GIR_EraseRootFromParent_Done,
     /* 120631 */ // Label 2070: @120631
     /* 120631 */ GIM_Try, /*On fail goto*//*Label 2071*/ GIMT_Encode4(120675), // Rule ID 7056 //
     /* 120636 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120639 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120642 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120646 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120660 */   // MIs[0] ptr
     /* 120660 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120664 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120668 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15825>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120668 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 120673 */   GIR_RootConstrainSelectedInstOperands,
     /* 120674 */   // GIR_Coverage, 7056,
     /* 120674 */   GIR_Done,
     /* 120675 */ // Label 2071: @120675
     /* 120675 */ GIM_Try, /*On fail goto*//*Label 2072*/ GIMT_Encode4(120719), // Rule ID 7058 //
     /* 120680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120683 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120686 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120690 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120697 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120704 */   // MIs[0] ptr
     /* 120704 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120712 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15827>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120712 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 120717 */   GIR_RootConstrainSelectedInstOperands,
     /* 120718 */   // GIR_Coverage, 7058,
     /* 120718 */   GIR_Done,
     /* 120719 */ // Label 2072: @120719
     /* 120719 */ GIM_Try, /*On fail goto*//*Label 2073*/ GIMT_Encode4(120763), // Rule ID 7060 //
     /* 120724 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 120727 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120730 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120734 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120748 */   // MIs[0] ptr
     /* 120748 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120752 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120756 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15829>>  =>  (LDAPRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120756 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRW),
     /* 120761 */   GIR_RootConstrainSelectedInstOperands,
     /* 120762 */   // GIR_Coverage, 7060,
     /* 120762 */   GIR_Done,
     /* 120763 */ // Label 2073: @120763
     /* 120763 */ GIM_Try, /*On fail goto*//*Label 2074*/ GIMT_Encode4(120804), // Rule ID 7062 //
     /* 120768 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120771 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120775 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120789 */   // MIs[0] ptr
     /* 120789 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120793 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120797 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15833>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120802 */   GIR_RootConstrainSelectedInstOperands,
     /* 120803 */   // GIR_Coverage, 7062,
     /* 120803 */   GIR_Done,
     /* 120804 */ // Label 2074: @120804
     /* 120804 */ GIM_Try, /*On fail goto*//*Label 2075*/ GIMT_Encode4(120845), // Rule ID 7064 //
     /* 120809 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 120823 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120826 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120830 */   // MIs[0] ptr
     /* 120830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120838 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_8>><<P:Predicate_anonymous_15825>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 120843 */   GIR_RootConstrainSelectedInstOperands,
     /* 120844 */   // GIR_Coverage, 7064,
     /* 120844 */   GIR_Done,
     /* 120845 */ // Label 2075: @120845
     /* 120845 */ GIM_Try, /*On fail goto*//*Label 2076*/ GIMT_Encode4(120886), // Rule ID 7074 //
     /* 120850 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120853 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120864 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120871 */   // MIs[0] ptr
     /* 120871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120875 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120879 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15841>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120879 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120884 */   GIR_RootConstrainSelectedInstOperands,
     /* 120885 */   // GIR_Coverage, 7074,
     /* 120885 */   GIR_Done,
     /* 120886 */ // Label 2076: @120886
     /* 120886 */ GIM_Try, /*On fail goto*//*Label 2077*/ GIMT_Encode4(120927), // Rule ID 7076 //
     /* 120891 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120894 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120898 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 120905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120912 */   // MIs[0] ptr
     /* 120912 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120916 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120920 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_aext>><<P:Predicate_atomic_load_aext_16>><<P:Predicate_anonymous_15827>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120920 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 120925 */   GIR_RootConstrainSelectedInstOperands,
     /* 120926 */   // GIR_Coverage, 7076,
     /* 120926 */   GIR_Done,
     /* 120927 */ // Label 2077: @120927
     /* 120927 */ GIM_Try, /*On fail goto*//*Label 2078*/ GIMT_Encode4(120968), // Rule ID 7086 //
     /* 120932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120939 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120946 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 120949 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120953 */   // MIs[0] ptr
     /* 120953 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120957 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 120961 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15849>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 120961 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 120966 */   GIR_RootConstrainSelectedInstOperands,
     /* 120967 */   // GIR_Coverage, 7086,
     /* 120967 */   GIR_Done,
     /* 120968 */ // Label 2078: @120968
     /* 120968 */ GIM_Try, /*On fail goto*//*Label 2079*/ GIMT_Encode4(121009), // Rule ID 7087 //
     /* 120973 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 120976 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 120980 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 120987 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 120990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 120994 */   // MIs[0] ptr
     /* 120994 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 120998 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 121002 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_32>><<P:Predicate_anonymous_15829>>  =>  (LDARW:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 121002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARW),
     /* 121007 */   GIR_RootConstrainSelectedInstOperands,
     /* 121008 */   // GIR_Coverage, 7087,
     /* 121008 */   GIR_Done,
     /* 121009 */ // Label 2079: @121009
     /* 121009 */ GIM_Reject,
     /* 121010 */ // Label 2008: @121010
     /* 121010 */ GIM_Try, /*On fail goto*//*Label 2080*/ GIMT_Encode4(121063), // Rule ID 235 //
     /* 121015 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121018 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121026 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121030 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121037 */   // (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121037 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 121040 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121042 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121047 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121052 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121057 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121061 */   GIR_RootConstrainSelectedInstOperands,
     /* 121062 */   // GIR_Coverage, 235,
     /* 121062 */   GIR_EraseRootFromParent_Done,
     /* 121063 */ // Label 2080: @121063
     /* 121063 */ GIM_Try, /*On fail goto*//*Label 2081*/ GIMT_Encode4(121116), // Rule ID 236 //
     /* 121068 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121071 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121075 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 121079 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121083 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121090 */   // (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 121093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121095 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121100 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121105 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121110 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121114 */   GIR_RootConstrainSelectedInstOperands,
     /* 121115 */   // GIR_Coverage, 236,
     /* 121115 */   GIR_EraseRootFromParent_Done,
     /* 121116 */ // Label 2081: @121116
     /* 121116 */ GIM_Try, /*On fail goto*//*Label 2082*/ GIMT_Encode4(121172), // Rule ID 243 //
     /* 121121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121124 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121127 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121135 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121139 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121146 */   // (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121146 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121149 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121151 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121156 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121161 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121166 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121170 */   GIR_RootConstrainSelectedInstOperands,
     /* 121171 */   // GIR_Coverage, 243,
     /* 121171 */   GIR_EraseRootFromParent_Done,
     /* 121172 */ // Label 2082: @121172
     /* 121172 */ GIM_Try, /*On fail goto*//*Label 2083*/ GIMT_Encode4(121228), // Rule ID 244 //
     /* 121177 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 121180 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121183 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121191 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121195 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121202 */   // (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121202 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121205 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121207 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121212 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121222 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121226 */   GIR_RootConstrainSelectedInstOperands,
     /* 121227 */   // GIR_Coverage, 244,
     /* 121227 */   GIR_EraseRootFromParent_Done,
     /* 121228 */ // Label 2083: @121228
     /* 121228 */ GIM_Try, /*On fail goto*//*Label 2084*/ GIMT_Encode4(121281), // Rule ID 4085 //
     /* 121233 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121236 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121244 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121248 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121255 */   // (ld:{ *:[v1i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121255 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121258 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121275 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121279 */   GIR_RootConstrainSelectedInstOperands,
     /* 121280 */   // GIR_Coverage, 4085,
     /* 121280 */   GIR_EraseRootFromParent_Done,
     /* 121281 */ // Label 2084: @121281
     /* 121281 */ GIM_Try, /*On fail goto*//*Label 2085*/ GIMT_Encode4(121334), // Rule ID 4086 //
     /* 121286 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121289 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121297 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121301 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121308 */   // (ld:{ *:[v1i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121308 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121311 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121313 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121318 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121328 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121332 */   GIR_RootConstrainSelectedInstOperands,
     /* 121333 */   // GIR_Coverage, 4086,
     /* 121333 */   GIR_EraseRootFromParent_Done,
     /* 121334 */ // Label 2085: @121334
     /* 121334 */ GIM_Try, /*On fail goto*//*Label 2086*/ GIMT_Encode4(121387), // Rule ID 4087 //
     /* 121339 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121342 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121346 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121354 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 121361 */   // (ld:{ *:[v1f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 121361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 121364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121381 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121385 */   GIR_RootConstrainSelectedInstOperands,
     /* 121386 */   // GIR_Coverage, 4087,
     /* 121386 */   GIR_EraseRootFromParent_Done,
     /* 121387 */ // Label 2086: @121387
     /* 121387 */ GIM_Try, /*On fail goto*//*Label 2087*/ GIMT_Encode4(121440), // Rule ID 4088 //
     /* 121392 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121395 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 121403 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121407 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 121414 */   // (ld:{ *:[v1f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 121414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 121417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 121419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121424 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121429 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121434 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121438 */   GIR_RootConstrainSelectedInstOperands,
     /* 121439 */   // GIR_Coverage, 4088,
     /* 121439 */   GIR_EraseRootFromParent_Done,
     /* 121440 */ // Label 2087: @121440
     /* 121440 */ GIM_Try, /*On fail goto*//*Label 2088*/ GIMT_Encode4(121532), // Rule ID 4111 //
     /* 121445 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121448 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 121474 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121474 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121477 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 121481 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121501 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121505 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121512 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121515 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121518 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121521 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121526 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121531 */   // GIR_Coverage, 4111,
     /* 121531 */   GIR_EraseRootFromParent_Done,
     /* 121532 */ // Label 2088: @121532
     /* 121532 */ GIM_Try, /*On fail goto*//*Label 2089*/ GIMT_Encode4(121624), // Rule ID 4112 //
     /* 121537 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121540 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121544 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 121551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121555 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121559 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 121566 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121566 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121569 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 121573 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121583 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121588 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121593 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121599 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121602 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121604 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121610 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121613 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121618 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121623 */   // GIR_Coverage, 4112,
     /* 121623 */   GIR_EraseRootFromParent_Done,
     /* 121624 */ // Label 2089: @121624
     /* 121624 */ GIM_Try, /*On fail goto*//*Label 2090*/ GIMT_Encode4(121716), // Rule ID 4113 //
     /* 121629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121632 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121643 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121647 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121651 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 121658 */   // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121658 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121661 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 121665 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121670 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121675 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121685 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121689 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121691 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121694 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121696 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121699 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121702 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121705 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121710 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121715 */   // GIR_Coverage, 4113,
     /* 121715 */   GIR_EraseRootFromParent_Done,
     /* 121716 */ // Label 2090: @121716
     /* 121716 */ GIM_Try, /*On fail goto*//*Label 2091*/ GIMT_Encode4(121808), // Rule ID 4114 //
     /* 121721 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121724 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 121735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121743 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 121750 */   // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121750 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121753 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 121757 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121762 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121767 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121772 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121777 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121788 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121791 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121794 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121797 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121802 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121807 */   // GIR_Coverage, 4114,
     /* 121807 */   GIR_EraseRootFromParent_Done,
     /* 121808 */ // Label 2091: @121808
     /* 121808 */ GIM_Try, /*On fail goto*//*Label 2092*/ GIMT_Encode4(121900), // Rule ID 4115 //
     /* 121813 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121816 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121820 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121831 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121835 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 121842 */   // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121842 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121845 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 121849 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121859 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121864 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121869 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121873 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121875 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121878 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121880 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121883 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121886 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121889 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121894 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121899 */   // GIR_Coverage, 4115,
     /* 121899 */   GIR_EraseRootFromParent_Done,
     /* 121900 */ // Label 2092: @121900
     /* 121900 */ GIM_Try, /*On fail goto*//*Label 2093*/ GIMT_Encode4(121992), // Rule ID 4116 //
     /* 121905 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 121908 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 121912 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 121919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121923 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 121927 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 121934 */   // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 121934 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 121937 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 121941 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 121946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 121951 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 121956 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 121961 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 121965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 121967 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 121970 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 121972 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 121975 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 121978 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 121981 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 121986 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 121991 */   // GIR_Coverage, 4116,
     /* 121991 */   GIR_EraseRootFromParent_Done,
     /* 121992 */ // Label 2093: @121992
     /* 121992 */ GIM_Try, /*On fail goto*//*Label 2094*/ GIMT_Encode4(122084), // Rule ID 4117 //
     /* 121997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122000 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122004 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122015 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122019 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 122026 */   // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122026 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122029 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 122033 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122038 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122043 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122048 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122053 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122057 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122059 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122062 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122064 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122070 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122073 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122078 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122083 */   // GIR_Coverage, 4117,
     /* 122083 */   GIR_EraseRootFromParent_Done,
     /* 122084 */ // Label 2094: @122084
     /* 122084 */ GIM_Try, /*On fail goto*//*Label 2095*/ GIMT_Encode4(122176), // Rule ID 4118 //
     /* 122089 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122092 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122096 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122107 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122111 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 122118 */   // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 122118 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122121 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 122125 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122130 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122135 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122140 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122145 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122149 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122151 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122154 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122159 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122162 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122165 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122170 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122175 */   // GIR_Coverage, 4118,
     /* 122175 */   GIR_EraseRootFromParent_Done,
     /* 122176 */ // Label 2095: @122176
     /* 122176 */ GIM_Try, /*On fail goto*//*Label 2096*/ GIMT_Encode4(122224), // Rule ID 259 //
     /* 122181 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122184 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122192 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122196 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122203 */   // (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122203 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 122206 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122208 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122218 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122222 */   GIR_RootConstrainSelectedInstOperands,
     /* 122223 */   // GIR_Coverage, 259,
     /* 122223 */   GIR_EraseRootFromParent_Done,
     /* 122224 */ // Label 2096: @122224
     /* 122224 */ GIM_Try, /*On fail goto*//*Label 2097*/ GIMT_Encode4(122275), // Rule ID 264 //
     /* 122229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122232 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122235 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122243 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122247 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122254 */   // (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122254 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122257 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122259 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122264 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122269 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122273 */   GIR_RootConstrainSelectedInstOperands,
     /* 122274 */   // GIR_Coverage, 264,
     /* 122274 */   GIR_EraseRootFromParent_Done,
     /* 122275 */ // Label 2097: @122275
     /* 122275 */ GIM_Try, /*On fail goto*//*Label 2098*/ GIMT_Encode4(122338), // Rule ID 7094 //
     /* 122280 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122283 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122287 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122294 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122301 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122305 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 122312 */   // (atomic_load:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>  =>  (LDRXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 122312 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroW),
     /* 122315 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122317 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122322 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122327 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122332 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122336 */   GIR_RootConstrainSelectedInstOperands,
     /* 122337 */   // GIR_Coverage, 7094,
     /* 122337 */   GIR_EraseRootFromParent_Done,
     /* 122338 */ // Label 2098: @122338
     /* 122338 */ GIM_Try, /*On fail goto*//*Label 2099*/ GIMT_Encode4(122401), // Rule ID 7095 //
     /* 122343 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 122346 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122350 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 122357 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 122360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122364 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122368 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 122375 */   // (atomic_load:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>  =>  (LDRXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 122375 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXroX),
     /* 122378 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 122390 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 122395 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122399 */   GIR_RootConstrainSelectedInstOperands,
     /* 122400 */   // GIR_Coverage, 7095,
     /* 122400 */   GIR_EraseRootFromParent_Done,
     /* 122401 */ // Label 2099: @122401
     /* 122401 */ GIM_Try, /*On fail goto*//*Label 2100*/ GIMT_Encode4(122449), // Rule ID 280 //
     /* 122406 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122409 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122413 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 122417 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122421 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122428 */   // (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 122431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122438 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122443 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122447 */   GIR_RootConstrainSelectedInstOperands,
     /* 122448 */   // GIR_Coverage, 280,
     /* 122448 */   GIR_EraseRootFromParent_Done,
     /* 122449 */ // Label 2100: @122449
     /* 122449 */ GIM_Try, /*On fail goto*//*Label 2101*/ GIMT_Encode4(122500), // Rule ID 285 //
     /* 122454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 122457 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122460 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122464 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122468 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122472 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122479 */   // (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 122479 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122482 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122498 */   GIR_RootConstrainSelectedInstOperands,
     /* 122499 */   // GIR_Coverage, 285,
     /* 122499 */   GIR_EraseRootFromParent_Done,
     /* 122500 */ // Label 2101: @122500
     /* 122500 */ GIM_Try, /*On fail goto*//*Label 2102*/ GIMT_Encode4(122548), // Rule ID 4132 //
     /* 122505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122508 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122516 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122520 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122527 */   // (ld:{ *:[v1f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122527 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122530 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122537 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122542 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122546 */   GIR_RootConstrainSelectedInstOperands,
     /* 122547 */   // GIR_Coverage, 4132,
     /* 122547 */   GIR_EraseRootFromParent_Done,
     /* 122548 */ // Label 2102: @122548
     /* 122548 */ GIM_Try, /*On fail goto*//*Label 2103*/ GIMT_Encode4(122596), // Rule ID 4133 //
     /* 122553 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122556 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122560 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122564 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122568 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 122575 */   // (ld:{ *:[v1i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 122575 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 122578 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122580 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122585 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122590 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122594 */   GIR_RootConstrainSelectedInstOperands,
     /* 122595 */   // GIR_Coverage, 4133,
     /* 122595 */   GIR_EraseRootFromParent_Done,
     /* 122596 */ // Label 2103: @122596
     /* 122596 */ GIM_Try, /*On fail goto*//*Label 2104*/ GIMT_Encode4(122683), // Rule ID 4149 //
     /* 122601 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122604 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122608 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 122615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122619 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122623 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 122630 */   // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122630 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122633 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 122637 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122642 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122652 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122656 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122658 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122661 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122663 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122666 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122669 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122672 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122677 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122682 */   // GIR_Coverage, 4149,
     /* 122682 */   GIR_EraseRootFromParent_Done,
     /* 122683 */ // Label 2104: @122683
     /* 122683 */ GIM_Try, /*On fail goto*//*Label 2105*/ GIMT_Encode4(122770), // Rule ID 4150 //
     /* 122688 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122691 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122695 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 122702 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122706 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122710 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 122717 */   // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122717 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122720 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 122724 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122729 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122734 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122739 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122743 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122745 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122748 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122750 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122753 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122756 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122759 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122764 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122769 */   // GIR_Coverage, 4150,
     /* 122769 */   GIR_EraseRootFromParent_Done,
     /* 122770 */ // Label 2105: @122770
     /* 122770 */ GIM_Try, /*On fail goto*//*Label 2106*/ GIMT_Encode4(122857), // Rule ID 4151 //
     /* 122775 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122778 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122782 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122789 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122793 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122797 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122804 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122804 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122807 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122811 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122816 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122821 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122826 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122830 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122832 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122835 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122837 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122840 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122843 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122846 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122851 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122856 */   // GIR_Coverage, 4151,
     /* 122856 */   GIR_EraseRootFromParent_Done,
     /* 122857 */ // Label 2106: @122857
     /* 122857 */ GIM_Try, /*On fail goto*//*Label 2107*/ GIMT_Encode4(122944), // Rule ID 4152 //
     /* 122862 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122865 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122869 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 122876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122880 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122884 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 122891 */   // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 122891 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 122894 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 122898 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 122903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122913 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122917 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 122919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 122922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 122924 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 122927 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 122930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 122933 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 122938 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 122943 */   // GIR_Coverage, 4152,
     /* 122943 */   GIR_EraseRootFromParent_Done,
     /* 122944 */ // Label 2107: @122944
     /* 122944 */ GIM_Try, /*On fail goto*//*Label 2108*/ GIMT_Encode4(122992), // Rule ID 4160 //
     /* 122949 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 122952 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 122956 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 122960 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 122964 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 122971 */   // (ld:{ *:[v1f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 122971 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 122974 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 122976 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 122981 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 122986 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 122990 */   GIR_RootConstrainSelectedInstOperands,
     /* 122991 */   // GIR_Coverage, 4160,
     /* 122991 */   GIR_EraseRootFromParent_Done,
     /* 122992 */ // Label 2108: @122992
     /* 122992 */ GIM_Try, /*On fail goto*//*Label 2109*/ GIMT_Encode4(123040), // Rule ID 4161 //
     /* 122997 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123000 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123008 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123012 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123019 */   // (ld:{ *:[v1i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123019 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 123022 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123024 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123029 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123034 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123038 */   GIR_RootConstrainSelectedInstOperands,
     /* 123039 */   // GIR_Coverage, 4161,
     /* 123039 */   GIR_EraseRootFromParent_Done,
     /* 123040 */ // Label 2109: @123040
     /* 123040 */ GIM_Try, /*On fail goto*//*Label 2110*/ GIMT_Encode4(123127), // Rule ID 4172 //
     /* 123045 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123048 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123052 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 123059 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123063 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123067 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 123074 */   // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123074 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123077 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 123081 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123096 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123126 */   // GIR_Coverage, 4172,
     /* 123126 */   GIR_EraseRootFromParent_Done,
     /* 123127 */ // Label 2110: @123127
     /* 123127 */ GIM_Try, /*On fail goto*//*Label 2111*/ GIMT_Encode4(123214), // Rule ID 4173 //
     /* 123132 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123135 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123139 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 123146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123150 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123154 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 123161 */   // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123161 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123164 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 123168 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123183 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123187 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123189 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123192 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123194 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123197 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123200 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123203 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123208 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123213 */   // GIR_Coverage, 4173,
     /* 123213 */   GIR_EraseRootFromParent_Done,
     /* 123214 */ // Label 2111: @123214
     /* 123214 */ GIM_Try, /*On fail goto*//*Label 2112*/ GIMT_Encode4(123301), // Rule ID 4174 //
     /* 123219 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123222 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123226 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123237 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123241 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123248 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123248 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123251 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123255 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123270 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123274 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123276 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123279 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123281 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123284 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123287 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123295 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123300 */   // GIR_Coverage, 4174,
     /* 123300 */   GIR_EraseRootFromParent_Done,
     /* 123301 */ // Label 2112: @123301
     /* 123301 */ GIM_Try, /*On fail goto*//*Label 2113*/ GIMT_Encode4(123388), // Rule ID 4175 //
     /* 123306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123309 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123313 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 123320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 123335 */   // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 123335 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 123338 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 123342 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 123347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123357 */   GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123361 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 123363 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 123366 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 123368 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 123371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 123374 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 123377 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 123382 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 123387 */   // GIR_Coverage, 4175,
     /* 123387 */   GIR_EraseRootFromParent_Done,
     /* 123388 */ // Label 2113: @123388
     /* 123388 */ GIM_Try, /*On fail goto*//*Label 2114*/ GIMT_Encode4(123446), // Rule ID 7096 //
     /* 123393 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123396 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123400 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123407 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123414 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123418 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 123425 */   // (atomic_load:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>  =>  (LDRXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 123425 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRXui),
     /* 123428 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123430 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123440 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123444 */   GIR_RootConstrainSelectedInstOperands,
     /* 123445 */   // GIR_Coverage, 7096,
     /* 123445 */   GIR_EraseRootFromParent_Done,
     /* 123446 */ // Label 2114: @123446
     /* 123446 */ GIM_Try, /*On fail goto*//*Label 2115*/ GIMT_Encode4(123504), // Rule ID 7097 //
     /* 123451 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123454 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123458 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123465 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123472 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123476 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123483 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15860>>  =>  (LDURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123483 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURXi),
     /* 123486 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123488 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123493 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123498 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123502 */   GIR_RootConstrainSelectedInstOperands,
     /* 123503 */   // GIR_Coverage, 7097,
     /* 123503 */   GIR_EraseRootFromParent_Done,
     /* 123504 */ // Label 2115: @123504
     /* 123504 */ GIM_Try, /*On fail goto*//*Label 2116*/ GIMT_Encode4(123565), // Rule ID 7481 //
     /* 123509 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 123512 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123515 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123519 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123526 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123529 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123533 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123537 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 123544 */   // (atomic_load:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15831>>  =>  (LDAPURXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 123544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURXi),
     /* 123547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123559 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123563 */   GIR_RootConstrainSelectedInstOperands,
     /* 123564 */   // GIR_Coverage, 7481,
     /* 123564 */   GIR_EraseRootFromParent_Done,
     /* 123565 */ // Label 2116: @123565
     /* 123565 */ GIM_Try, /*On fail goto*//*Label 2117*/ GIMT_Encode4(123596), // Rule ID 6437 //
     /* 123570 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123573 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123581 */   // MIs[0] Rn
     /* 123581 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123589 */   // (ld:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 123589 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev1d),
     /* 123594 */   GIR_RootConstrainSelectedInstOperands,
     /* 123595 */   // GIR_Coverage, 6437,
     /* 123595 */   GIR_Done,
     /* 123596 */ // Label 2117: @123596
     /* 123596 */ GIM_Try, /*On fail goto*//*Label 2118*/ GIMT_Encode4(123640), // Rule ID 7061 //
     /* 123601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 123604 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123607 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123611 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123618 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123625 */   // MIs[0] ptr
     /* 123625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123633 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15831>>  =>  (LDAPRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRX),
     /* 123638 */   GIR_RootConstrainSelectedInstOperands,
     /* 123639 */   // GIR_Coverage, 7061,
     /* 123639 */   GIR_Done,
     /* 123640 */ // Label 2118: @123640
     /* 123640 */ GIM_Try, /*On fail goto*//*Label 2119*/ GIMT_Encode4(123681), // Rule ID 7092 //
     /* 123645 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123648 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123652 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123659 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 123662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123666 */   // MIs[0] ptr
     /* 123666 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123674 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15857>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123674 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123679 */   GIR_RootConstrainSelectedInstOperands,
     /* 123680 */   // GIR_Coverage, 7092,
     /* 123680 */   GIR_Done,
     /* 123681 */ // Label 2119: @123681
     /* 123681 */ GIM_Try, /*On fail goto*//*Label 2120*/ GIMT_Encode4(123722), // Rule ID 7093 //
     /* 123686 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 123689 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123693 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 123700 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 123703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 123707 */   // MIs[0] ptr
     /* 123707 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 123711 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 123715 */   // (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15831>>  =>  (LDARX:{ *:[i64] } GPR64sp:{ *:[i64] }:$ptr)
     /* 123715 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARX),
     /* 123720 */   GIR_RootConstrainSelectedInstOperands,
     /* 123721 */   // GIR_Coverage, 7093,
     /* 123721 */   GIR_Done,
     /* 123722 */ // Label 2120: @123722
     /* 123722 */ GIM_Reject,
     /* 123723 */ // Label 2009: @123723
     /* 123723 */ GIM_Try, /*On fail goto*//*Label 2121*/ GIMT_Encode4(123931),
     /* 123728 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123731 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123735 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 123739 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123743 */   GIM_Try, /*On fail goto*//*Label 2122*/ GIMT_Encode4(123784), // Rule ID 245 //
     /* 123748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123751 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 123758 */     // (ld:{ *:[f128] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 123758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 123761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123763 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123768 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123782 */     GIR_RootConstrainSelectedInstOperands,
     /* 123783 */     // GIR_Coverage, 245,
     /* 123783 */     GIR_EraseRootFromParent_Done,
     /* 123784 */   // Label 2122: @123784
     /* 123784 */   GIM_Try, /*On fail goto*//*Label 2123*/ GIMT_Encode4(123825), // Rule ID 246 //
     /* 123789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 123799 */     // (ld:{ *:[f128] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 123799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 123802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123804 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123823 */     GIR_RootConstrainSelectedInstOperands,
     /* 123824 */     // GIR_Coverage, 246,
     /* 123824 */     GIR_EraseRootFromParent_Done,
     /* 123825 */   // Label 2123: @123825
     /* 123825 */   GIM_Try, /*On fail goto*//*Label 2124*/ GIMT_Encode4(123861), // Rule ID 265 //
     /* 123830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123833 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123840 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123850 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123859 */     GIR_RootConstrainSelectedInstOperands,
     /* 123860 */     // GIR_Coverage, 265,
     /* 123860 */     GIR_EraseRootFromParent_Done,
     /* 123861 */   // Label 2124: @123861
     /* 123861 */   GIM_Try, /*On fail goto*//*Label 2125*/ GIMT_Encode4(123897), // Rule ID 286 //
     /* 123866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 123869 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 123876 */     // (ld:{ *:[f128] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 123876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 123879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123881 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123891 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123895 */     GIR_RootConstrainSelectedInstOperands,
     /* 123896 */     // GIR_Coverage, 286,
     /* 123896 */     GIR_EraseRootFromParent_Done,
     /* 123897 */   // Label 2125: @123897
     /* 123897 */   GIM_Try, /*On fail goto*//*Label 2126*/ GIMT_Encode4(123930), // Rule ID 4141 //
     /* 123902 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 123909 */     // (ld:{ *:[f128] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[f128] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 123909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 123912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123914 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 123924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123928 */     GIR_RootConstrainSelectedInstOperands,
     /* 123929 */     // GIR_Coverage, 4141,
     /* 123929 */     GIR_EraseRootFromParent_Done,
     /* 123930 */   // Label 2126: @123930
     /* 123930 */   GIM_Reject,
     /* 123931 */ // Label 2121: @123931
     /* 123931 */ GIM_Reject,
     /* 123932 */ // Label 2010: @123932
     /* 123932 */ GIM_Try, /*On fail goto*//*Label 2127*/ GIMT_Encode4(124309),
     /* 123937 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 123940 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 123944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 123948 */   GIM_Try, /*On fail goto*//*Label 2128*/ GIMT_Encode4(123993), // Rule ID 4075 //
     /* 123953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 123956 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 123960 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 123967 */     // (ld:{ *:[v2i32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 123967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 123970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 123972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 123977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 123982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 123987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 123991 */     GIR_RootConstrainSelectedInstOperands,
     /* 123992 */     // GIR_Coverage, 4075,
     /* 123992 */     GIR_EraseRootFromParent_Done,
     /* 123993 */   // Label 2128: @123993
     /* 123993 */   GIM_Try, /*On fail goto*//*Label 2129*/ GIMT_Encode4(124038), // Rule ID 4076 //
     /* 123998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124005 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124012 */     // (ld:{ *:[v2i32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124032 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124036 */     GIR_RootConstrainSelectedInstOperands,
     /* 124037 */     // GIR_Coverage, 4076,
     /* 124037 */     GIR_EraseRootFromParent_Done,
     /* 124038 */   // Label 2129: @124038
     /* 124038 */   GIM_Try, /*On fail goto*//*Label 2130*/ GIMT_Encode4(124083), // Rule ID 4077 //
     /* 124043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124046 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124050 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124057 */     // (ld:{ *:[v2f32] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124062 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124067 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124081 */     GIR_RootConstrainSelectedInstOperands,
     /* 124082 */     // GIR_Coverage, 4077,
     /* 124082 */     GIR_EraseRootFromParent_Done,
     /* 124083 */   // Label 2130: @124083
     /* 124083 */   GIM_Try, /*On fail goto*//*Label 2131*/ GIMT_Encode4(124128), // Rule ID 4078 //
     /* 124088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124102 */     // (ld:{ *:[v2f32] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124122 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124126 */     GIR_RootConstrainSelectedInstOperands,
     /* 124127 */     // GIR_Coverage, 4078,
     /* 124127 */     GIR_EraseRootFromParent_Done,
     /* 124128 */   // Label 2131: @124128
     /* 124128 */   GIM_Try, /*On fail goto*//*Label 2132*/ GIMT_Encode4(124168), // Rule ID 4127 //
     /* 124133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124136 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124140 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124147 */     // (ld:{ *:[v2f32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124162 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124166 */     GIR_RootConstrainSelectedInstOperands,
     /* 124167 */     // GIR_Coverage, 4127,
     /* 124167 */     GIR_EraseRootFromParent_Done,
     /* 124168 */   // Label 2132: @124168
     /* 124168 */   GIM_Try, /*On fail goto*//*Label 2133*/ GIMT_Encode4(124208), // Rule ID 4130 //
     /* 124173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124176 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124180 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124187 */     // (ld:{ *:[v2i32] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124192 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124197 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124202 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124206 */     GIR_RootConstrainSelectedInstOperands,
     /* 124207 */     // GIR_Coverage, 4130,
     /* 124207 */     GIR_EraseRootFromParent_Done,
     /* 124208 */   // Label 2133: @124208
     /* 124208 */   GIM_Try, /*On fail goto*//*Label 2134*/ GIMT_Encode4(124248), // Rule ID 4155 //
     /* 124213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124220 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124227 */     // (ld:{ *:[v2f32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124237 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124242 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124246 */     GIR_RootConstrainSelectedInstOperands,
     /* 124247 */     // GIR_Coverage, 4155,
     /* 124247 */     GIR_EraseRootFromParent_Done,
     /* 124248 */   // Label 2134: @124248
     /* 124248 */   GIM_Try, /*On fail goto*//*Label 2135*/ GIMT_Encode4(124288), // Rule ID 4156 //
     /* 124253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124256 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124260 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124267 */     // (ld:{ *:[v2i32] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124272 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124277 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124282 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124286 */     GIR_RootConstrainSelectedInstOperands,
     /* 124287 */     // GIR_Coverage, 4156,
     /* 124287 */     GIR_EraseRootFromParent_Done,
     /* 124288 */   // Label 2135: @124288
     /* 124288 */   GIM_Try, /*On fail goto*//*Label 2136*/ GIMT_Encode4(124308), // Rule ID 6436 //
     /* 124293 */     // MIs[0] Rn
     /* 124293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124301 */     // (ld:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124301 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2s),
     /* 124306 */     GIR_RootConstrainSelectedInstOperands,
     /* 124307 */     // GIR_Coverage, 6436,
     /* 124307 */     GIR_Done,
     /* 124308 */   // Label 2136: @124308
     /* 124308 */   GIM_Reject,
     /* 124309 */ // Label 2127: @124309
     /* 124309 */ GIM_Reject,
     /* 124310 */ // Label 2011: @124310
     /* 124310 */ GIM_Try, /*On fail goto*//*Label 2137*/ GIMT_Encode4(124687),
     /* 124315 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124318 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 124326 */   GIM_Try, /*On fail goto*//*Label 2138*/ GIMT_Encode4(124371), // Rule ID 4089 //
     /* 124331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124334 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124338 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124345 */     // (ld:{ *:[v2i64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124360 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124365 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124369 */     GIR_RootConstrainSelectedInstOperands,
     /* 124370 */     // GIR_Coverage, 4089,
     /* 124370 */     GIR_EraseRootFromParent_Done,
     /* 124371 */   // Label 2138: @124371
     /* 124371 */   GIM_Try, /*On fail goto*//*Label 2139*/ GIMT_Encode4(124416), // Rule ID 4090 //
     /* 124376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124379 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124383 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124390 */     // (ld:{ *:[v2i64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124400 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124410 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124414 */     GIR_RootConstrainSelectedInstOperands,
     /* 124415 */     // GIR_Coverage, 4090,
     /* 124415 */     GIR_EraseRootFromParent_Done,
     /* 124416 */   // Label 2139: @124416
     /* 124416 */   GIM_Try, /*On fail goto*//*Label 2140*/ GIMT_Encode4(124461), // Rule ID 4091 //
     /* 124421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124424 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124428 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 124435 */     // (ld:{ *:[v2f64] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 124435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 124438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124455 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124459 */     GIR_RootConstrainSelectedInstOperands,
     /* 124460 */     // GIR_Coverage, 4091,
     /* 124460 */     GIR_EraseRootFromParent_Done,
     /* 124461 */   // Label 2140: @124461
     /* 124461 */   GIM_Try, /*On fail goto*//*Label 2141*/ GIMT_Encode4(124506), // Rule ID 4092 //
     /* 124466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124473 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 124480 */     // (ld:{ *:[v2f64] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 124480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 124483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124495 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124504 */     GIR_RootConstrainSelectedInstOperands,
     /* 124505 */     // GIR_Coverage, 4092,
     /* 124505 */     GIR_EraseRootFromParent_Done,
     /* 124506 */   // Label 2141: @124506
     /* 124506 */   GIM_Try, /*On fail goto*//*Label 2142*/ GIMT_Encode4(124546), // Rule ID 4135 //
     /* 124511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124514 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124518 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124525 */     // (ld:{ *:[v2f64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124530 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124535 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124540 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124544 */     GIR_RootConstrainSelectedInstOperands,
     /* 124545 */     // GIR_Coverage, 4135,
     /* 124545 */     GIR_EraseRootFromParent_Done,
     /* 124546 */   // Label 2142: @124546
     /* 124546 */   GIM_Try, /*On fail goto*//*Label 2143*/ GIMT_Encode4(124586), // Rule ID 4139 //
     /* 124551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124558 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 124565 */     // (ld:{ *:[v2i64] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 124565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 124568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124575 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124580 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124584 */     GIR_RootConstrainSelectedInstOperands,
     /* 124585 */     // GIR_Coverage, 4139,
     /* 124585 */     GIR_EraseRootFromParent_Done,
     /* 124586 */   // Label 2143: @124586
     /* 124586 */   GIM_Try, /*On fail goto*//*Label 2144*/ GIMT_Encode4(124626), // Rule ID 4162 //
     /* 124591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124605 */     // (ld:{ *:[v2f64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124624 */     GIR_RootConstrainSelectedInstOperands,
     /* 124625 */     // GIR_Coverage, 4162,
     /* 124625 */     GIR_EraseRootFromParent_Done,
     /* 124626 */   // Label 2144: @124626
     /* 124626 */   GIM_Try, /*On fail goto*//*Label 2145*/ GIMT_Encode4(124666), // Rule ID 4163 //
     /* 124631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 124645 */     // (ld:{ *:[v2i64] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 124648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124664 */     GIR_RootConstrainSelectedInstOperands,
     /* 124665 */     // GIR_Coverage, 4163,
     /* 124665 */     GIR_EraseRootFromParent_Done,
     /* 124666 */   // Label 2145: @124666
     /* 124666 */   GIM_Try, /*On fail goto*//*Label 2146*/ GIMT_Encode4(124686), // Rule ID 6433 //
     /* 124671 */     // MIs[0] Rn
     /* 124671 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 124675 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 124679 */     // (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 124679 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev2d),
     /* 124684 */     GIR_RootConstrainSelectedInstOperands,
     /* 124685 */     // GIR_Coverage, 6433,
     /* 124685 */     GIR_Done,
     /* 124686 */   // Label 2146: @124686
     /* 124686 */   GIM_Reject,
     /* 124687 */ // Label 2137: @124687
     /* 124687 */ GIM_Reject,
     /* 124688 */ // Label 2012: @124688
     /* 124688 */ GIM_Try, /*On fail goto*//*Label 2147*/ GIMT_Encode4(125065),
     /* 124693 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 124696 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 124700 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 124704 */   GIM_Try, /*On fail goto*//*Label 2148*/ GIMT_Encode4(124749), // Rule ID 4081 //
     /* 124709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124723 */     // (ld:{ *:[v4i16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124747 */     GIR_RootConstrainSelectedInstOperands,
     /* 124748 */     // GIR_Coverage, 4081,
     /* 124748 */     GIR_EraseRootFromParent_Done,
     /* 124749 */   // Label 2148: @124749
     /* 124749 */   GIM_Try, /*On fail goto*//*Label 2149*/ GIMT_Encode4(124794), // Rule ID 4082 //
     /* 124754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124761 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124768 */     // (ld:{ *:[v4i16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124788 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124792 */     GIR_RootConstrainSelectedInstOperands,
     /* 124793 */     // GIR_Coverage, 4082,
     /* 124793 */     GIR_EraseRootFromParent_Done,
     /* 124794 */   // Label 2149: @124794
     /* 124794 */   GIM_Try, /*On fail goto*//*Label 2150*/ GIMT_Encode4(124839), // Rule ID 4083 //
     /* 124799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124802 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124806 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 124813 */     // (ld:{ *:[v4f16] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 124813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 124816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124833 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124837 */     GIR_RootConstrainSelectedInstOperands,
     /* 124838 */     // GIR_Coverage, 4083,
     /* 124838 */     GIR_EraseRootFromParent_Done,
     /* 124839 */   // Label 2150: @124839
     /* 124839 */   GIM_Try, /*On fail goto*//*Label 2151*/ GIMT_Encode4(124884), // Rule ID 4084 //
     /* 124844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124847 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124851 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 124858 */     // (ld:{ *:[v4f16] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 124858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 124861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124863 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124868 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 124873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 124878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124882 */     GIR_RootConstrainSelectedInstOperands,
     /* 124883 */     // GIR_Coverage, 4084,
     /* 124883 */     GIR_EraseRootFromParent_Done,
     /* 124884 */   // Label 2151: @124884
     /* 124884 */   GIM_Try, /*On fail goto*//*Label 2152*/ GIMT_Encode4(124924), // Rule ID 4129 //
     /* 124889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124896 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124903 */     // (ld:{ *:[v4i16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124908 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124918 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124922 */     GIR_RootConstrainSelectedInstOperands,
     /* 124923 */     // GIR_Coverage, 4129,
     /* 124923 */     GIR_EraseRootFromParent_Done,
     /* 124924 */   // Label 2152: @124924
     /* 124924 */   GIM_Try, /*On fail goto*//*Label 2153*/ GIMT_Encode4(124964), // Rule ID 4131 //
     /* 124929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124932 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124936 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 124943 */     // (ld:{ *:[v4f16] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 124943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 124946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124958 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 124962 */     GIR_RootConstrainSelectedInstOperands,
     /* 124963 */     // GIR_Coverage, 4131,
     /* 124963 */     GIR_EraseRootFromParent_Done,
     /* 124964 */   // Label 2153: @124964
     /* 124964 */   GIM_Try, /*On fail goto*//*Label 2154*/ GIMT_Encode4(125004), // Rule ID 4157 //
     /* 124969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 124972 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 124976 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 124983 */     // (ld:{ *:[v4i16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 124983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 124986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 124988 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 124993 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 124998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125002 */     GIR_RootConstrainSelectedInstOperands,
     /* 125003 */     // GIR_Coverage, 4157,
     /* 125003 */     GIR_EraseRootFromParent_Done,
     /* 125004 */   // Label 2154: @125004
     /* 125004 */   GIM_Try, /*On fail goto*//*Label 2155*/ GIMT_Encode4(125044), // Rule ID 4159 //
     /* 125009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125012 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125016 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125023 */     // (ld:{ *:[v4f16] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125042 */     GIR_RootConstrainSelectedInstOperands,
     /* 125043 */     // GIR_Coverage, 4159,
     /* 125043 */     GIR_EraseRootFromParent_Done,
     /* 125044 */   // Label 2155: @125044
     /* 125044 */   GIM_Try, /*On fail goto*//*Label 2156*/ GIMT_Encode4(125064), // Rule ID 6435 //
     /* 125049 */     // MIs[0] Rn
     /* 125049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125053 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125057 */     // (ld:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125057 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4h),
     /* 125062 */     GIR_RootConstrainSelectedInstOperands,
     /* 125063 */     // GIR_Coverage, 6435,
     /* 125063 */     GIR_Done,
     /* 125064 */   // Label 2156: @125064
     /* 125064 */   GIM_Reject,
     /* 125065 */ // Label 2147: @125065
     /* 125065 */ GIM_Reject,
     /* 125066 */ // Label 2013: @125066
     /* 125066 */ GIM_Try, /*On fail goto*//*Label 2157*/ GIMT_Encode4(125443),
     /* 125071 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125074 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125082 */   GIM_Try, /*On fail goto*//*Label 2158*/ GIMT_Encode4(125127), // Rule ID 4093 //
     /* 125087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125090 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125094 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125101 */     // (ld:{ *:[v4i32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125106 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125116 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125121 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125125 */     GIR_RootConstrainSelectedInstOperands,
     /* 125126 */     // GIR_Coverage, 4093,
     /* 125126 */     GIR_EraseRootFromParent_Done,
     /* 125127 */   // Label 2158: @125127
     /* 125127 */   GIM_Try, /*On fail goto*//*Label 2159*/ GIMT_Encode4(125172), // Rule ID 4094 //
     /* 125132 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125146 */     // (ld:{ *:[v4i32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125161 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125166 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125170 */     GIR_RootConstrainSelectedInstOperands,
     /* 125171 */     // GIR_Coverage, 4094,
     /* 125171 */     GIR_EraseRootFromParent_Done,
     /* 125172 */   // Label 2159: @125172
     /* 125172 */   GIM_Try, /*On fail goto*//*Label 2160*/ GIMT_Encode4(125217), // Rule ID 4095 //
     /* 125177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125180 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125184 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125191 */     // (ld:{ *:[v4f32] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125196 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125201 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125206 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125211 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125215 */     GIR_RootConstrainSelectedInstOperands,
     /* 125216 */     // GIR_Coverage, 4095,
     /* 125216 */     GIR_EraseRootFromParent_Done,
     /* 125217 */   // Label 2160: @125217
     /* 125217 */   GIM_Try, /*On fail goto*//*Label 2161*/ GIMT_Encode4(125262), // Rule ID 4096 //
     /* 125222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125225 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125229 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125236 */     // (ld:{ *:[v4f32] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125241 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125246 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125251 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125260 */     GIR_RootConstrainSelectedInstOperands,
     /* 125261 */     // GIR_Coverage, 4096,
     /* 125261 */     GIR_EraseRootFromParent_Done,
     /* 125262 */   // Label 2161: @125262
     /* 125262 */   GIM_Try, /*On fail goto*//*Label 2162*/ GIMT_Encode4(125302), // Rule ID 4134 //
     /* 125267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125270 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125274 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125281 */     // (ld:{ *:[v4f32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125286 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125296 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125300 */     GIR_RootConstrainSelectedInstOperands,
     /* 125301 */     // GIR_Coverage, 4134,
     /* 125301 */     GIR_EraseRootFromParent_Done,
     /* 125302 */   // Label 2162: @125302
     /* 125302 */   GIM_Try, /*On fail goto*//*Label 2163*/ GIMT_Encode4(125342), // Rule ID 4138 //
     /* 125307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125310 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125314 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125321 */     // (ld:{ *:[v4i32] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125326 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125331 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125336 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125340 */     GIR_RootConstrainSelectedInstOperands,
     /* 125341 */     // GIR_Coverage, 4138,
     /* 125341 */     GIR_EraseRootFromParent_Done,
     /* 125342 */   // Label 2163: @125342
     /* 125342 */   GIM_Try, /*On fail goto*//*Label 2164*/ GIMT_Encode4(125382), // Rule ID 4164 //
     /* 125347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125361 */     // (ld:{ *:[v4f32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125380 */     GIR_RootConstrainSelectedInstOperands,
     /* 125381 */     // GIR_Coverage, 4164,
     /* 125381 */     GIR_EraseRootFromParent_Done,
     /* 125382 */   // Label 2164: @125382
     /* 125382 */   GIM_Try, /*On fail goto*//*Label 2165*/ GIMT_Encode4(125422), // Rule ID 4165 //
     /* 125387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125390 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125401 */     // (ld:{ *:[v4i32] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125406 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125411 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125416 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125420 */     GIR_RootConstrainSelectedInstOperands,
     /* 125421 */     // GIR_Coverage, 4165,
     /* 125421 */     GIR_EraseRootFromParent_Done,
     /* 125422 */   // Label 2165: @125422
     /* 125422 */   GIM_Try, /*On fail goto*//*Label 2166*/ GIMT_Encode4(125442), // Rule ID 6432 //
     /* 125427 */     // MIs[0] Rn
     /* 125427 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125431 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125435 */     // (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125435 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev4s),
     /* 125440 */     GIR_RootConstrainSelectedInstOperands,
     /* 125441 */     // GIR_Coverage, 6432,
     /* 125441 */     GIR_Done,
     /* 125442 */   // Label 2166: @125442
     /* 125442 */   GIM_Reject,
     /* 125443 */ // Label 2157: @125443
     /* 125443 */ GIM_Reject,
     /* 125444 */ // Label 2014: @125444
     /* 125444 */ GIM_Try, /*On fail goto*//*Label 2167*/ GIMT_Encode4(125651),
     /* 125449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125452 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 125460 */   GIM_Try, /*On fail goto*//*Label 2168*/ GIMT_Encode4(125505), // Rule ID 4079 //
     /* 125465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125468 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125472 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 125479 */     // (ld:{ *:[v8i8] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroW:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 125479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 125482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125484 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125489 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125494 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125499 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125503 */     GIR_RootConstrainSelectedInstOperands,
     /* 125504 */     // GIR_Coverage, 4079,
     /* 125504 */     GIR_EraseRootFromParent_Done,
     /* 125505 */   // Label 2168: @125505
     /* 125505 */   GIM_Try, /*On fail goto*//*Label 2169*/ GIMT_Encode4(125550), // Rule ID 4080 //
     /* 125510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125517 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 125524 */     // (ld:{ *:[v8i8] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDroX:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 125524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 125527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125534 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125544 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125548 */     GIR_RootConstrainSelectedInstOperands,
     /* 125549 */     // GIR_Coverage, 4080,
     /* 125549 */     GIR_EraseRootFromParent_Done,
     /* 125550 */   // Label 2169: @125550
     /* 125550 */   GIM_Try, /*On fail goto*//*Label 2170*/ GIMT_Encode4(125590), // Rule ID 4128 //
     /* 125555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125562 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 125569 */     // (ld:{ *:[v8i8] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRDui:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 125569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 125572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125579 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125584 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125588 */     GIR_RootConstrainSelectedInstOperands,
     /* 125589 */     // GIR_Coverage, 4128,
     /* 125589 */     GIR_EraseRootFromParent_Done,
     /* 125590 */   // Label 2170: @125590
     /* 125590 */   GIM_Try, /*On fail goto*//*Label 2171*/ GIMT_Encode4(125630), // Rule ID 4158 //
     /* 125595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125598 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125602 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 125609 */     // (ld:{ *:[v8i8] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURDi:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 125612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125614 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125619 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125628 */     GIR_RootConstrainSelectedInstOperands,
     /* 125629 */     // GIR_Coverage, 4158,
     /* 125629 */     GIR_EraseRootFromParent_Done,
     /* 125630 */   // Label 2171: @125630
     /* 125630 */   GIM_Try, /*On fail goto*//*Label 2172*/ GIMT_Encode4(125650), // Rule ID 6434 //
     /* 125635 */     // MIs[0] Rn
     /* 125635 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 125639 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 125643 */     // (ld:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 125643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8b),
     /* 125648 */     GIR_RootConstrainSelectedInstOperands,
     /* 125649 */     // GIR_Coverage, 6434,
     /* 125649 */     GIR_Done,
     /* 125650 */   // Label 2172: @125650
     /* 125650 */   GIM_Reject,
     /* 125651 */ // Label 2167: @125651
     /* 125651 */ GIM_Reject,
     /* 125652 */ // Label 2015: @125652
     /* 125652 */ GIM_Try, /*On fail goto*//*Label 2173*/ GIMT_Encode4(126029),
     /* 125657 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 125660 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 125664 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 125668 */   GIM_Try, /*On fail goto*//*Label 2174*/ GIMT_Encode4(125713), // Rule ID 4097 //
     /* 125673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125680 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125687 */     // (ld:{ *:[v8i16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125692 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125711 */     GIR_RootConstrainSelectedInstOperands,
     /* 125712 */     // GIR_Coverage, 4097,
     /* 125712 */     GIR_EraseRootFromParent_Done,
     /* 125713 */   // Label 2174: @125713
     /* 125713 */   GIM_Try, /*On fail goto*//*Label 2175*/ GIMT_Encode4(125758), // Rule ID 4098 //
     /* 125718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125721 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125725 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125732 */     // (ld:{ *:[v8i16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125752 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125756 */     GIR_RootConstrainSelectedInstOperands,
     /* 125757 */     // GIR_Coverage, 4098,
     /* 125757 */     GIR_EraseRootFromParent_Done,
     /* 125758 */   // Label 2175: @125758
     /* 125758 */   GIM_Try, /*On fail goto*//*Label 2176*/ GIMT_Encode4(125803), // Rule ID 4099 //
     /* 125763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125770 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 125777 */     // (ld:{ *:[v8f16] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 125777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 125780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125792 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125797 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125801 */     GIR_RootConstrainSelectedInstOperands,
     /* 125802 */     // GIR_Coverage, 4099,
     /* 125802 */     GIR_EraseRootFromParent_Done,
     /* 125803 */   // Label 2176: @125803
     /* 125803 */   GIM_Try, /*On fail goto*//*Label 2177*/ GIMT_Encode4(125848), // Rule ID 4100 //
     /* 125808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125811 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 125822 */     // (ld:{ *:[v8f16] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 125822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 125825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125827 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 125837 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 125842 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125846 */     GIR_RootConstrainSelectedInstOperands,
     /* 125847 */     // GIR_Coverage, 4100,
     /* 125847 */     GIR_EraseRootFromParent_Done,
     /* 125848 */   // Label 2177: @125848
     /* 125848 */   GIM_Try, /*On fail goto*//*Label 2178*/ GIMT_Encode4(125888), // Rule ID 4137 //
     /* 125853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125867 */     // (ld:{ *:[v8i16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125886 */     GIR_RootConstrainSelectedInstOperands,
     /* 125887 */     // GIR_Coverage, 4137,
     /* 125887 */     GIR_EraseRootFromParent_Done,
     /* 125888 */   // Label 2178: @125888
     /* 125888 */   GIM_Try, /*On fail goto*//*Label 2179*/ GIMT_Encode4(125928), // Rule ID 4140 //
     /* 125893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125896 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125900 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 125907 */     // (ld:{ *:[v8f16] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 125907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 125910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125912 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125917 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125926 */     GIR_RootConstrainSelectedInstOperands,
     /* 125927 */     // GIR_Coverage, 4140,
     /* 125927 */     GIR_EraseRootFromParent_Done,
     /* 125928 */   // Label 2179: @125928
     /* 125928 */   GIM_Try, /*On fail goto*//*Label 2180*/ GIMT_Encode4(125968), // Rule ID 4166 //
     /* 125933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125936 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125947 */     // (ld:{ *:[v8i16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125952 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125957 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 125962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 125966 */     GIR_RootConstrainSelectedInstOperands,
     /* 125967 */     // GIR_Coverage, 4166,
     /* 125967 */     GIR_EraseRootFromParent_Done,
     /* 125968 */   // Label 2180: @125968
     /* 125968 */   GIM_Try, /*On fail goto*//*Label 2181*/ GIMT_Encode4(126008), // Rule ID 4168 //
     /* 125973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 125976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 125980 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 125987 */     // (ld:{ *:[v8f16] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 125987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 125990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 125992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 125997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126002 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126006 */     GIR_RootConstrainSelectedInstOperands,
     /* 126007 */     // GIR_Coverage, 4168,
     /* 126007 */     GIR_EraseRootFromParent_Done,
     /* 126008 */   // Label 2181: @126008
     /* 126008 */   GIM_Try, /*On fail goto*//*Label 2182*/ GIMT_Encode4(126028), // Rule ID 6431 //
     /* 126013 */     // MIs[0] Rn
     /* 126013 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126021 */     // (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126021 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev8h),
     /* 126026 */     GIR_RootConstrainSelectedInstOperands,
     /* 126027 */     // GIR_Coverage, 6431,
     /* 126027 */     GIR_Done,
     /* 126028 */   // Label 2182: @126028
     /* 126028 */   GIM_Reject,
     /* 126029 */ // Label 2173: @126029
     /* 126029 */ GIM_Reject,
     /* 126030 */ // Label 2016: @126030
     /* 126030 */ GIM_Try, /*On fail goto*//*Label 2183*/ GIMT_Encode4(126237),
     /* 126035 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126038 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 126046 */   GIM_Try, /*On fail goto*//*Label 2184*/ GIMT_Encode4(126091), // Rule ID 4101 //
     /* 126051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126054 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126058 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 126065 */     // (ld:{ *:[v16i8] } (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroW:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 126065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroW),
     /* 126068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126080 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126089 */     GIR_RootConstrainSelectedInstOperands,
     /* 126090 */     // GIR_Coverage, 4101,
     /* 126090 */     GIR_EraseRootFromParent_Done,
     /* 126091 */   // Label 2184: @126091
     /* 126091 */   GIM_Try, /*On fail goto*//*Label 2185*/ GIMT_Encode4(126136), // Rule ID 4102 //
     /* 126096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126099 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126103 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 126110 */     // (ld:{ *:[v16i8] } (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQroX:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 126110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQroX),
     /* 126113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126115 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126120 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 126125 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 126130 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126134 */     GIR_RootConstrainSelectedInstOperands,
     /* 126135 */     // GIR_Coverage, 4102,
     /* 126135 */     GIR_EraseRootFromParent_Done,
     /* 126136 */   // Label 2185: @126136
     /* 126136 */   GIM_Try, /*On fail goto*//*Label 2186*/ GIMT_Encode4(126176), // Rule ID 4136 //
     /* 126141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126148 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 126155 */     // (ld:{ *:[v16i8] } (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDRQui:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 126155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRQui),
     /* 126158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126160 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126165 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126170 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126174 */     GIR_RootConstrainSelectedInstOperands,
     /* 126175 */     // GIR_Coverage, 4136,
     /* 126175 */     GIR_EraseRootFromParent_Done,
     /* 126176 */   // Label 2186: @126176
     /* 126176 */   GIM_Try, /*On fail goto*//*Label 2187*/ GIMT_Encode4(126216), // Rule ID 4167 //
     /* 126181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 126184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 126188 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 126195 */     // (ld:{ *:[v16i8] } (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDURQi:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 126195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURQi),
     /* 126198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 126200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 126205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 126210 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126214 */     GIR_RootConstrainSelectedInstOperands,
     /* 126215 */     // GIR_Coverage, 4167,
     /* 126215 */     GIR_EraseRootFromParent_Done,
     /* 126216 */   // Label 2187: @126216
     /* 126216 */   GIM_Try, /*On fail goto*//*Label 2188*/ GIMT_Encode4(126236), // Rule ID 6430 //
     /* 126221 */     // MIs[0] Rn
     /* 126221 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126229 */     // (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1Onev16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 126229 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LD1Onev16b),
     /* 126234 */     GIR_RootConstrainSelectedInstOperands,
     /* 126235 */     // GIR_Coverage, 6430,
     /* 126235 */     GIR_Done,
     /* 126236 */   // Label 2188: @126236
     /* 126236 */   GIM_Reject,
     /* 126237 */ // Label 2183: @126237
     /* 126237 */ GIM_Reject,
     /* 126238 */ // Label 2017: @126238
     /* 126238 */ GIM_Try, /*On fail goto*//*Label 2189*/ GIMT_Encode4(126301), // Rule ID 11006 //
     /* 126243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126257 */   // MIs[0] base
     /* 126257 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126261 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126265 */   // (ld:{ *:[nxv2f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_D_IMM:{ *:[nxv2f16] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126265 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126268 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126272 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126277 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126280 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_D_IMM),
     /* 126285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126290 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126292 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126295 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126299 */   GIR_RootConstrainSelectedInstOperands,
     /* 126300 */   // GIR_Coverage, 11006,
     /* 126300 */   GIR_EraseRootFromParent_Done,
     /* 126301 */ // Label 2189: @126301
     /* 126301 */ GIM_Reject,
     /* 126302 */ // Label 2018: @126302
     /* 126302 */ GIM_Try, /*On fail goto*//*Label 2190*/ GIMT_Encode4(126365), // Rule ID 11012 //
     /* 126307 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126317 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126321 */   // MIs[0] base
     /* 126321 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126325 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126329 */   // (ld:{ *:[nxv2f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_D_IMM:{ *:[nxv2f32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126329 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126332 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126336 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126341 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126344 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_D_IMM),
     /* 126349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126351 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126354 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126356 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126359 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126363 */   GIR_RootConstrainSelectedInstOperands,
     /* 126364 */   // GIR_Coverage, 11012,
     /* 126364 */   GIR_EraseRootFromParent_Done,
     /* 126365 */ // Label 2190: @126365
     /* 126365 */ GIM_Reject,
     /* 126366 */ // Label 2019: @126366
     /* 126366 */ GIM_Try, /*On fail goto*//*Label 2191*/ GIMT_Encode4(126539),
     /* 126371 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126374 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126382 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126386 */   GIM_Try, /*On fail goto*//*Label 2192*/ GIMT_Encode4(126434), // Rule ID 10997 //
     /* 126391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126398 */     // (ld:{ *:[nxv2i64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2i64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126423 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126425 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126432 */     GIR_RootConstrainSelectedInstOperands,
     /* 126433 */     // GIR_Coverage, 10997,
     /* 126433 */     GIR_EraseRootFromParent_Done,
     /* 126434 */   // Label 2192: @126434
     /* 126434 */   GIM_Try, /*On fail goto*//*Label 2193*/ GIMT_Encode4(126482), // Rule ID 11015 //
     /* 126439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126446 */     // (ld:{ *:[nxv2f64] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1D_IMM:{ *:[nxv2f64] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 126453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_IMM),
     /* 126466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126468 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126471 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126480 */     GIR_RootConstrainSelectedInstOperands,
     /* 126481 */     // GIR_Coverage, 11015,
     /* 126481 */     GIR_EraseRootFromParent_Done,
     /* 126482 */   // Label 2193: @126482
     /* 126482 */   GIM_Try, /*On fail goto*//*Label 2194*/ GIMT_Encode4(126510), // Rule ID 11042 //
     /* 126487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126494 */     // (ld:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126499 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126508 */     GIR_RootConstrainSelectedInstOperands,
     /* 126509 */     // GIR_Coverage, 11042,
     /* 126509 */     GIR_EraseRootFromParent_Done,
     /* 126510 */   // Label 2194: @126510
     /* 126510 */   GIM_Try, /*On fail goto*//*Label 2195*/ GIMT_Encode4(126538), // Rule ID 11054 //
     /* 126515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126518 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126522 */     // (ld:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv2f64] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126527 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126536 */     GIR_RootConstrainSelectedInstOperands,
     /* 126537 */     // GIR_Coverage, 11054,
     /* 126537 */     GIR_EraseRootFromParent_Done,
     /* 126538 */   // Label 2195: @126538
     /* 126538 */   GIM_Reject,
     /* 126539 */ // Label 2191: @126539
     /* 126539 */ GIM_Reject,
     /* 126540 */ // Label 2020: @126540
     /* 126540 */ GIM_Try, /*On fail goto*//*Label 2196*/ GIMT_Encode4(126603), // Rule ID 11003 //
     /* 126545 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126551 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126559 */   // MIs[0] base
     /* 126559 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126563 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126567 */   // (ld:{ *:[nxv4f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_S_IMM:{ *:[nxv4f16] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126567 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126570 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126574 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126579 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126582 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126584 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_S_IMM),
     /* 126587 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126592 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126597 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126601 */   GIR_RootConstrainSelectedInstOperands,
     /* 126602 */   // GIR_Coverage, 11003,
     /* 126602 */   GIR_EraseRootFromParent_Done,
     /* 126603 */ // Label 2196: @126603
     /* 126603 */ GIM_Reject,
     /* 126604 */ // Label 2021: @126604
     /* 126604 */ GIM_Try, /*On fail goto*//*Label 2197*/ GIMT_Encode4(126777),
     /* 126609 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126612 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126620 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126624 */   GIM_Try, /*On fail goto*//*Label 2198*/ GIMT_Encode4(126672), // Rule ID 10985 //
     /* 126629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126636 */     // (ld:{ *:[nxv4i32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126648 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126651 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126661 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126666 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126670 */     GIR_RootConstrainSelectedInstOperands,
     /* 126671 */     // GIR_Coverage, 10985,
     /* 126671 */     GIR_EraseRootFromParent_Done,
     /* 126672 */   // Label 2198: @126672
     /* 126672 */   GIM_Try, /*On fail goto*//*Label 2199*/ GIMT_Encode4(126720), // Rule ID 11009 //
     /* 126677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126684 */     // (ld:{ *:[nxv4f32] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1W_IMM:{ *:[nxv4f32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126684 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126687 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 126691 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126696 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126699 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_IMM),
     /* 126704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126706 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126709 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126718 */     GIR_RootConstrainSelectedInstOperands,
     /* 126719 */     // GIR_Coverage, 11009,
     /* 126719 */     GIR_EraseRootFromParent_Done,
     /* 126720 */   // Label 2199: @126720
     /* 126720 */   GIM_Try, /*On fail goto*//*Label 2200*/ GIMT_Encode4(126748), // Rule ID 11038 //
     /* 126725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126728 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126732 */     // (ld:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4i32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126737 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126739 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126746 */     GIR_RootConstrainSelectedInstOperands,
     /* 126747 */     // GIR_Coverage, 11038,
     /* 126747 */     GIR_EraseRootFromParent_Done,
     /* 126748 */   // Label 2200: @126748
     /* 126748 */   GIM_Try, /*On fail goto*//*Label 2201*/ GIMT_Encode4(126776), // Rule ID 11050 //
     /* 126753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126756 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126760 */     // (ld:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv4f32] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126765 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126774 */     GIR_RootConstrainSelectedInstOperands,
     /* 126775 */     // GIR_Coverage, 11050,
     /* 126775 */     GIR_EraseRootFromParent_Done,
     /* 126776 */   // Label 2201: @126776
     /* 126776 */   GIM_Reject,
     /* 126777 */ // Label 2197: @126777
     /* 126777 */ GIM_Reject,
     /* 126778 */ // Label 2022: @126778
     /* 126778 */ GIM_Try, /*On fail goto*//*Label 2202*/ GIMT_Encode4(126951),
     /* 126783 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126786 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 126794 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126798 */   GIM_Try, /*On fail goto*//*Label 2203*/ GIMT_Encode4(126846), // Rule ID 10964 //
     /* 126803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126810 */     // (ld:{ *:[nxv8i16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8i16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126822 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126825 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126835 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126844 */     GIR_RootConstrainSelectedInstOperands,
     /* 126845 */     // GIR_Coverage, 10964,
     /* 126845 */     GIR_EraseRootFromParent_Done,
     /* 126846 */   // Label 2203: @126846
     /* 126846 */   GIM_Try, /*On fail goto*//*Label 2204*/ GIMT_Encode4(126894), // Rule ID 11000 //
     /* 126851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126858 */     // (ld:{ *:[nxv8f16] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1H_IMM:{ *:[nxv8f16] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 126861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 126865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 126870 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 126873 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 126875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1H_IMM),
     /* 126878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126880 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 126883 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126892 */     GIR_RootConstrainSelectedInstOperands,
     /* 126893 */     // GIR_Coverage, 11000,
     /* 126893 */     GIR_EraseRootFromParent_Done,
     /* 126894 */   // Label 2204: @126894
     /* 126894 */   GIM_Try, /*On fail goto*//*Label 2205*/ GIMT_Encode4(126922), // Rule ID 11034 //
     /* 126899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126906 */     // (ld:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8i16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126911 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126920 */     GIR_RootConstrainSelectedInstOperands,
     /* 126921 */     // GIR_Coverage, 11034,
     /* 126921 */     GIR_EraseRootFromParent_Done,
     /* 126922 */   // Label 2205: @126922
     /* 126922 */   GIM_Try, /*On fail goto*//*Label 2206*/ GIMT_Encode4(126950), // Rule ID 11046 //
     /* 126927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 126930 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 126934 */     // (ld:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv8f16] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 126937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 126939 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126948 */     GIR_RootConstrainSelectedInstOperands,
     /* 126949 */     // GIR_Coverage, 11046,
     /* 126949 */     GIR_EraseRootFromParent_Done,
     /* 126950 */   // Label 2206: @126950
     /* 126950 */   GIM_Reject,
     /* 126951 */ // Label 2202: @126951
     /* 126951 */ GIM_Reject,
     /* 126952 */ // Label 2023: @126952
     /* 126952 */ GIM_Try, /*On fail goto*//*Label 2207*/ GIMT_Encode4(126995), // Rule ID 2431 //
     /* 126957 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 126960 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 126963 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 126967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 126971 */   // MIs[0] base
     /* 126971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 126975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 126979 */   // (ld:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_PXI:{ *:[nxv16i1] } GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 126979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_PXI),
     /* 126982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pt]
     /* 126984 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 126986 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 126989 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 126993 */   GIR_RootConstrainSelectedInstOperands,
     /* 126994 */   // GIR_Coverage, 2431,
     /* 126994 */   GIR_EraseRootFromParent_Done,
     /* 126995 */ // Label 2207: @126995
     /* 126995 */ GIM_Reject,
     /* 126996 */ // Label 2024: @126996
     /* 126996 */ GIM_Try, /*On fail goto*//*Label 2208*/ GIMT_Encode4(127093),
     /* 127001 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127004 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 127008 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 127012 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 127016 */   GIM_Try, /*On fail goto*//*Label 2209*/ GIMT_Encode4(127064), // Rule ID 10932 //
     /* 127021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 127024 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127028 */     // (ld:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LD1B_IMM:{ *:[nxv16i8] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 127031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 127035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 127040 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 127043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 127045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1B_IMM),
     /* 127048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127050 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 127053 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127055 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127058 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127062 */     GIR_RootConstrainSelectedInstOperands,
     /* 127063 */     // GIR_Coverage, 10932,
     /* 127063 */     GIR_EraseRootFromParent_Done,
     /* 127064 */   // Label 2209: @127064
     /* 127064 */   GIM_Try, /*On fail goto*//*Label 2210*/ GIMT_Encode4(127092), // Rule ID 11030 //
     /* 127069 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 127072 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 127076 */     // (ld:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedload>><<P:Predicate_load>>  =>  (LDR_ZXI:{ *:[nxv16i8] } GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 127076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDR_ZXI),
     /* 127079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 127081 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 127083 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 127086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127090 */     GIR_RootConstrainSelectedInstOperands,
     /* 127091 */     // GIR_Coverage, 11030,
     /* 127091 */     GIR_EraseRootFromParent_Done,
     /* 127092 */   // Label 2210: @127092
     /* 127092 */   GIM_Reject,
     /* 127093 */ // Label 2208: @127093
     /* 127093 */ GIM_Reject,
     /* 127094 */ // Label 2025: @127094
     /* 127094 */ GIM_Reject,
     /* 127095 */ // Label 17: @127095
     /* 127095 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2213*/ GIMT_Encode4(128144),
     /* 127106 */ /*GILLT_s32*//*Label 2211*/ GIMT_Encode4(127114),
     /* 127110 */ /*GILLT_s64*//*Label 2212*/ GIMT_Encode4(127528),
     /* 127114 */ // Label 2211: @127114
     /* 127114 */ GIM_Try, /*On fail goto*//*Label 2214*/ GIMT_Encode4(127527),
     /* 127119 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127122 */   GIM_Try, /*On fail goto*//*Label 2215*/ GIMT_Encode4(127175), // Rule ID 247 //
     /* 127127 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127138 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127142 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127149 */     // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroW),
     /* 127152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127154 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127159 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127169 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127173 */     GIR_RootConstrainSelectedInstOperands,
     /* 127174 */     // GIR_Coverage, 247,
     /* 127174 */     GIR_EraseRootFromParent_Done,
     /* 127175 */   // Label 2215: @127175
     /* 127175 */   GIM_Try, /*On fail goto*//*Label 2216*/ GIMT_Encode4(127228), // Rule ID 248 //
     /* 127180 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127195 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127202 */     // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWroX),
     /* 127205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127217 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127226 */     GIR_RootConstrainSelectedInstOperands,
     /* 127227 */     // GIR_Coverage, 248,
     /* 127227 */     GIR_EraseRootFromParent_Done,
     /* 127228 */   // Label 2216: @127228
     /* 127228 */   GIM_Try, /*On fail goto*//*Label 2217*/ GIMT_Encode4(127281), // Rule ID 251 //
     /* 127233 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127248 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127255 */     // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroW),
     /* 127258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127275 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127279 */     GIR_RootConstrainSelectedInstOperands,
     /* 127280 */     // GIR_Coverage, 251,
     /* 127280 */     GIR_EraseRootFromParent_Done,
     /* 127281 */   // Label 2217: @127281
     /* 127281 */   GIM_Try, /*On fail goto*//*Label 2218*/ GIMT_Encode4(127334), // Rule ID 252 //
     /* 127286 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127297 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127301 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127308 */     // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWroX),
     /* 127311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127313 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127328 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127332 */     GIR_RootConstrainSelectedInstOperands,
     /* 127333 */     // GIR_Coverage, 252,
     /* 127333 */     GIR_EraseRootFromParent_Done,
     /* 127334 */   // Label 2218: @127334
     /* 127334 */   GIM_Try, /*On fail goto*//*Label 2219*/ GIMT_Encode4(127382), // Rule ID 268 //
     /* 127339 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127354 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127361 */     // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHWui),
     /* 127364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127366 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127380 */     GIR_RootConstrainSelectedInstOperands,
     /* 127381 */     // GIR_Coverage, 268,
     /* 127381 */     GIR_EraseRootFromParent_Done,
     /* 127382 */   // Label 2219: @127382
     /* 127382 */   GIM_Try, /*On fail goto*//*Label 2220*/ GIMT_Encode4(127430), // Rule ID 270 //
     /* 127387 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127398 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127402 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127409 */     // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBWui),
     /* 127412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127414 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127419 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127424 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127428 */     GIR_RootConstrainSelectedInstOperands,
     /* 127429 */     // GIR_Coverage, 270,
     /* 127429 */     GIR_EraseRootFromParent_Done,
     /* 127430 */   // Label 2220: @127430
     /* 127430 */   GIM_Try, /*On fail goto*//*Label 2221*/ GIMT_Encode4(127478), // Rule ID 289 //
     /* 127435 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127442 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127446 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127450 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 127457 */     // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHWi),
     /* 127460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127467 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127476 */     GIR_RootConstrainSelectedInstOperands,
     /* 127477 */     // GIR_Coverage, 289,
     /* 127477 */     GIR_EraseRootFromParent_Done,
     /* 127478 */   // Label 2221: @127478
     /* 127478 */   GIM_Try, /*On fail goto*//*Label 2222*/ GIMT_Encode4(127526), // Rule ID 291 //
     /* 127483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 127494 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127498 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 127505 */     // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 127505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBWi),
     /* 127508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127524 */     GIR_RootConstrainSelectedInstOperands,
     /* 127525 */     // GIR_Coverage, 291,
     /* 127525 */     GIR_EraseRootFromParent_Done,
     /* 127526 */   // Label 2222: @127526
     /* 127526 */   GIM_Reject,
     /* 127527 */ // Label 2214: @127527
     /* 127527 */ GIM_Reject,
     /* 127528 */ // Label 2212: @127528
     /* 127528 */ GIM_Try, /*On fail goto*//*Label 2223*/ GIMT_Encode4(128143),
     /* 127533 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 127536 */   GIM_Try, /*On fail goto*//*Label 2224*/ GIMT_Encode4(127589), // Rule ID 249 //
     /* 127541 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127552 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127556 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 127563 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 127563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroW),
     /* 127566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127587 */     GIR_RootConstrainSelectedInstOperands,
     /* 127588 */     // GIR_Coverage, 249,
     /* 127588 */     GIR_EraseRootFromParent_Done,
     /* 127589 */   // Label 2224: @127589
     /* 127589 */   GIM_Try, /*On fail goto*//*Label 2225*/ GIMT_Encode4(127642), // Rule ID 250 //
     /* 127594 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127605 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127609 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 127616 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 127616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXroX),
     /* 127619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127621 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127626 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127631 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127636 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127640 */     GIR_RootConstrainSelectedInstOperands,
     /* 127641 */     // GIR_Coverage, 250,
     /* 127641 */     GIR_EraseRootFromParent_Done,
     /* 127642 */   // Label 2225: @127642
     /* 127642 */   GIM_Try, /*On fail goto*//*Label 2226*/ GIMT_Encode4(127695), // Rule ID 253 //
     /* 127647 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127654 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127658 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127662 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 127669 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 127669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroW),
     /* 127672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127693 */     GIR_RootConstrainSelectedInstOperands,
     /* 127694 */     // GIR_Coverage, 253,
     /* 127694 */     GIR_EraseRootFromParent_Done,
     /* 127695 */   // Label 2226: @127695
     /* 127695 */   GIM_Try, /*On fail goto*//*Label 2227*/ GIMT_Encode4(127748), // Rule ID 254 //
     /* 127700 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127711 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127715 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 127722 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 127722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXroX),
     /* 127725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127732 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127737 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127746 */     GIR_RootConstrainSelectedInstOperands,
     /* 127747 */     // GIR_Coverage, 254,
     /* 127747 */     GIR_EraseRootFromParent_Done,
     /* 127748 */   // Label 2227: @127748
     /* 127748 */   GIM_Try, /*On fail goto*//*Label 2228*/ GIMT_Encode4(127801), // Rule ID 255 //
     /* 127753 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127764 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127768 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 127775 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 127775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroW),
     /* 127778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127780 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127785 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127790 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127799 */     GIR_RootConstrainSelectedInstOperands,
     /* 127800 */     // GIR_Coverage, 255,
     /* 127800 */     GIR_EraseRootFromParent_Done,
     /* 127801 */   // Label 2228: @127801
     /* 127801 */   GIM_Try, /*On fail goto*//*Label 2229*/ GIMT_Encode4(127854), // Rule ID 256 //
     /* 127806 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127821 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 127828 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 127828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWroX),
     /* 127831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 127843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 127848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127852 */     GIR_RootConstrainSelectedInstOperands,
     /* 127853 */     // GIR_Coverage, 256,
     /* 127853 */     GIR_EraseRootFromParent_Done,
     /* 127854 */   // Label 2229: @127854
     /* 127854 */   GIM_Try, /*On fail goto*//*Label 2230*/ GIMT_Encode4(127902), // Rule ID 269 //
     /* 127859 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 127866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127870 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127874 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 127881 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDRSHXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 127881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSHXui),
     /* 127884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127886 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127891 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127900 */     GIR_RootConstrainSelectedInstOperands,
     /* 127901 */     // GIR_Coverage, 269,
     /* 127901 */     GIR_EraseRootFromParent_Done,
     /* 127902 */   // Label 2230: @127902
     /* 127902 */   GIM_Try, /*On fail goto*//*Label 2231*/ GIMT_Encode4(127950), // Rule ID 271 //
     /* 127907 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 127914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127922 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 127929 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDRSBXui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 127929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSBXui),
     /* 127932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127934 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127939 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127944 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127948 */     GIR_RootConstrainSelectedInstOperands,
     /* 127949 */     // GIR_Coverage, 271,
     /* 127949 */     GIR_EraseRootFromParent_Done,
     /* 127950 */   // Label 2231: @127950
     /* 127950 */   GIM_Try, /*On fail goto*//*Label 2232*/ GIMT_Encode4(127998), // Rule ID 272 //
     /* 127955 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 127962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 127966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 127970 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 127977 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDRSWui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 127977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRSWui),
     /* 127980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 127982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 127987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 127992 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 127996 */     GIR_RootConstrainSelectedInstOperands,
     /* 127997 */     // GIR_Coverage, 272,
     /* 127997 */     GIR_EraseRootFromParent_Done,
     /* 127998 */   // Label 2232: @127998
     /* 127998 */   GIM_Try, /*On fail goto*//*Label 2233*/ GIMT_Encode4(128046), // Rule ID 290 //
     /* 128003 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128014 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128018 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128025 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>  =>  (LDURSHXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSHXi),
     /* 128028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128030 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128035 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128044 */     GIR_RootConstrainSelectedInstOperands,
     /* 128045 */     // GIR_Coverage, 290,
     /* 128045 */     GIR_EraseRootFromParent_Done,
     /* 128046 */   // Label 2233: @128046
     /* 128046 */   GIM_Try, /*On fail goto*//*Label 2234*/ GIMT_Encode4(128094), // Rule ID 292 //
     /* 128051 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128062 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128066 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 128073 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>  =>  (LDURSBXi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSBXi),
     /* 128076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128083 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128088 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128092 */     GIR_RootConstrainSelectedInstOperands,
     /* 128093 */     // GIR_Coverage, 292,
     /* 128093 */     GIR_EraseRootFromParent_Done,
     /* 128094 */   // Label 2234: @128094
     /* 128094 */   GIM_Try, /*On fail goto*//*Label 2235*/ GIMT_Encode4(128142), // Rule ID 293 //
     /* 128099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 128106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 128110 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128114 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 128121 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>>  =>  (LDURSWi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128121 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURSWi),
     /* 128124 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128136 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128140 */     GIR_RootConstrainSelectedInstOperands,
     /* 128141 */     // GIR_Coverage, 293,
     /* 128141 */     GIR_EraseRootFromParent_Done,
     /* 128142 */   // Label 2235: @128142
     /* 128142 */   GIM_Reject,
     /* 128143 */ // Label 2223: @128143
     /* 128143 */ GIM_Reject,
     /* 128144 */ // Label 2213: @128144
     /* 128144 */ GIM_Reject,
     /* 128145 */ // Label 18: @128145
     /* 128145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2238*/ GIMT_Encode4(131193),
     /* 128156 */ /*GILLT_s32*//*Label 2236*/ GIMT_Encode4(128164),
     /* 128160 */ /*GILLT_s64*//*Label 2237*/ GIMT_Encode4(129703),
     /* 128164 */ // Label 2236: @128164
     /* 128164 */ GIM_Try, /*On fail goto*//*Label 2239*/ GIMT_Encode4(128220), // Rule ID 229 //
     /* 128169 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128172 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128183 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128187 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128194 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128194 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128197 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128204 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128209 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128214 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128218 */   GIR_RootConstrainSelectedInstOperands,
     /* 128219 */   // GIR_Coverage, 229,
     /* 128219 */   GIR_EraseRootFromParent_Done,
     /* 128220 */ // Label 2239: @128220
     /* 128220 */ GIM_Try, /*On fail goto*//*Label 2240*/ GIMT_Encode4(128276), // Rule ID 230 //
     /* 128225 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128228 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128239 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128243 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128250 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128250 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128253 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128255 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128260 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128265 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128270 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128274 */   GIR_RootConstrainSelectedInstOperands,
     /* 128275 */   // GIR_Coverage, 230,
     /* 128275 */   GIR_EraseRootFromParent_Done,
     /* 128276 */ // Label 2240: @128276
     /* 128276 */ GIM_Try, /*On fail goto*//*Label 2241*/ GIMT_Encode4(128332), // Rule ID 231 //
     /* 128281 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128284 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128295 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128299 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128306 */   // (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128311 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128316 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128321 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128326 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128330 */   GIR_RootConstrainSelectedInstOperands,
     /* 128331 */   // GIR_Coverage, 231,
     /* 128331 */   GIR_EraseRootFromParent_Done,
     /* 128332 */ // Label 2241: @128332
     /* 128332 */ GIM_Try, /*On fail goto*//*Label 2242*/ GIMT_Encode4(128388), // Rule ID 232 //
     /* 128337 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128340 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128347 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128351 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128355 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128362 */   // (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128362 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128365 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128367 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128372 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128377 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128382 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128386 */   GIR_RootConstrainSelectedInstOperands,
     /* 128387 */   // GIR_Coverage, 232,
     /* 128387 */   GIR_EraseRootFromParent_Done,
     /* 128388 */ // Label 2242: @128388
     /* 128388 */ GIM_Try, /*On fail goto*//*Label 2243*/ GIMT_Encode4(128444), // Rule ID 4125 //
     /* 128393 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128396 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128407 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128411 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128418 */   // (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 128418 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128421 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128423 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128428 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128433 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128438 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128442 */   GIR_RootConstrainSelectedInstOperands,
     /* 128443 */   // GIR_Coverage, 4125,
     /* 128443 */   GIR_EraseRootFromParent_Done,
     /* 128444 */ // Label 2243: @128444
     /* 128444 */ GIM_Try, /*On fail goto*//*Label 2244*/ GIMT_Encode4(128500), // Rule ID 4126 //
     /* 128449 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128452 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128474 */   // (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 128474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128477 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128489 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128494 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128498 */   GIR_RootConstrainSelectedInstOperands,
     /* 128499 */   // GIR_Coverage, 4126,
     /* 128499 */   GIR_EraseRootFromParent_Done,
     /* 128500 */ // Label 2244: @128500
     /* 128500 */ GIM_Try, /*On fail goto*//*Label 2245*/ GIMT_Encode4(128551), // Rule ID 266 //
     /* 128505 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128508 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128519 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128523 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 128530 */   // (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 128530 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 128533 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128535 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128540 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128545 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128549 */   GIR_RootConstrainSelectedInstOperands,
     /* 128550 */   // GIR_Coverage, 266,
     /* 128550 */   GIR_EraseRootFromParent_Done,
     /* 128551 */ // Label 2245: @128551
     /* 128551 */ GIM_Try, /*On fail goto*//*Label 2246*/ GIMT_Encode4(128602), // Rule ID 267 //
     /* 128556 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128559 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128570 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128574 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128581 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128581 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128584 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128586 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128591 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128596 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128600 */   GIR_RootConstrainSelectedInstOperands,
     /* 128601 */   // GIR_Coverage, 267,
     /* 128601 */   GIR_EraseRootFromParent_Done,
     /* 128602 */ // Label 2246: @128602
     /* 128602 */ GIM_Try, /*On fail goto*//*Label 2247*/ GIMT_Encode4(128661), // Rule ID 7067 //
     /* 128607 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128617 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128624 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128628 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 128635 */   // (atomic_load:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$offset)
     /* 128635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 128638 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128640 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128645 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128650 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128655 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128659 */   GIR_RootConstrainSelectedInstOperands,
     /* 128660 */   // GIR_Coverage, 7067,
     /* 128660 */   GIR_EraseRootFromParent_Done,
     /* 128661 */ // Label 2247: @128661
     /* 128661 */ GIM_Try, /*On fail goto*//*Label 2248*/ GIMT_Encode4(128720), // Rule ID 7069 //
     /* 128666 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128669 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128676 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128683 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128687 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 128694 */   // (atomic_load:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$offset)
     /* 128694 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 128697 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128699 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128704 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128709 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // offset
     /* 128714 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128718 */   GIR_RootConstrainSelectedInstOperands,
     /* 128719 */   // GIR_Coverage, 7069,
     /* 128719 */   GIR_EraseRootFromParent_Done,
     /* 128720 */ // Label 2248: @128720
     /* 128720 */ GIM_Try, /*On fail goto*//*Label 2249*/ GIMT_Encode4(128779), // Rule ID 7079 //
     /* 128725 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128728 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128735 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128742 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128746 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 128753 */   // (atomic_load:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 128753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 128756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128763 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128768 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128773 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128777 */   GIR_RootConstrainSelectedInstOperands,
     /* 128778 */   // GIR_Coverage, 7079,
     /* 128778 */   GIR_EraseRootFromParent_Done,
     /* 128779 */ // Label 2249: @128779
     /* 128779 */ GIM_Try, /*On fail goto*//*Label 2250*/ GIMT_Encode4(128838), // Rule ID 7081 //
     /* 128784 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 128787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128794 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 128797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128801 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128805 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 128812 */   // (atomic_load:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 128812 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 128815 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128817 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128822 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 128827 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 128832 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128836 */   GIR_RootConstrainSelectedInstOperands,
     /* 128837 */   // GIR_Coverage, 7081,
     /* 128837 */   GIR_EraseRootFromParent_Done,
     /* 128838 */ // Label 2250: @128838
     /* 128838 */ GIM_Try, /*On fail goto*//*Label 2251*/ GIMT_Encode4(128889), // Rule ID 287 //
     /* 128843 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128846 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 128853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128861 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128868 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 128871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128873 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128878 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128883 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128887 */   GIR_RootConstrainSelectedInstOperands,
     /* 128888 */   // GIR_Coverage, 287,
     /* 128888 */   GIR_EraseRootFromParent_Done,
     /* 128889 */ // Label 2251: @128889
     /* 128889 */ GIM_Try, /*On fail goto*//*Label 2252*/ GIMT_Encode4(128940), // Rule ID 288 //
     /* 128894 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128897 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128908 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128912 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 128919 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 128919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 128922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128924 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128929 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128934 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128938 */   GIR_RootConstrainSelectedInstOperands,
     /* 128939 */   // GIR_Coverage, 288,
     /* 128939 */   GIR_EraseRootFromParent_Done,
     /* 128940 */ // Label 2252: @128940
     /* 128940 */ GIM_Try, /*On fail goto*//*Label 2253*/ GIMT_Encode4(128991), // Rule ID 4144 //
     /* 128945 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128948 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 128955 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 128959 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 128963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 128970 */   // (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 128970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 128973 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 128975 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 128980 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 128985 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 128989 */   GIR_RootConstrainSelectedInstOperands,
     /* 128990 */   // GIR_Coverage, 4144,
     /* 128990 */   GIR_EraseRootFromParent_Done,
     /* 128991 */ // Label 2253: @128991
     /* 128991 */ GIM_Try, /*On fail goto*//*Label 2254*/ GIMT_Encode4(129042), // Rule ID 4176 //
     /* 128996 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 128999 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129010 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129014 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129021 */   // (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129026 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129031 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129036 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129040 */   GIR_RootConstrainSelectedInstOperands,
     /* 129041 */   // GIR_Coverage, 4176,
     /* 129041 */   GIR_EraseRootFromParent_Done,
     /* 129042 */ // Label 2254: @129042
     /* 129042 */ GIM_Try, /*On fail goto*//*Label 2255*/ GIMT_Encode4(129093), // Rule ID 4177 //
     /* 129047 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129050 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129061 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129065 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129072 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129072 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129075 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129077 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129082 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129087 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129091 */   GIR_RootConstrainSelectedInstOperands,
     /* 129092 */   // GIR_Coverage, 4177,
     /* 129092 */   GIR_EraseRootFromParent_Done,
     /* 129093 */ // Label 2255: @129093
     /* 129093 */ GIM_Try, /*On fail goto*//*Label 2256*/ GIMT_Encode4(129144), // Rule ID 4178 //
     /* 129098 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129101 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129108 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129112 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129116 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129123 */   // (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129123 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129126 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129128 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129133 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129138 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129142 */   GIR_RootConstrainSelectedInstOperands,
     /* 129143 */   // GIR_Coverage, 4178,
     /* 129143 */   GIR_EraseRootFromParent_Done,
     /* 129144 */ // Label 2256: @129144
     /* 129144 */ GIM_Try, /*On fail goto*//*Label 2257*/ GIMT_Encode4(129198), // Rule ID 7071 //
     /* 129149 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129152 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129159 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129170 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 129177 */   // (atomic_load:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15836>>  =>  (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 129177 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 129180 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129182 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129187 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129192 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129196 */   GIR_RootConstrainSelectedInstOperands,
     /* 129197 */   // GIR_Coverage, 7071,
     /* 129197 */   GIR_EraseRootFromParent_Done,
     /* 129198 */ // Label 2257: @129198
     /* 129198 */ GIM_Try, /*On fail goto*//*Label 2258*/ GIMT_Encode4(129252), // Rule ID 7073 //
     /* 129203 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129206 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129213 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129220 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129224 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129231 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15836>>  =>  (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129231 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 129234 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129241 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129246 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129250 */   GIR_RootConstrainSelectedInstOperands,
     /* 129251 */   // GIR_Coverage, 7073,
     /* 129251 */   GIR_EraseRootFromParent_Done,
     /* 129252 */ // Label 2258: @129252
     /* 129252 */ GIM_Try, /*On fail goto*//*Label 2259*/ GIMT_Encode4(129306), // Rule ID 7083 //
     /* 129257 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129260 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129267 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129274 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129278 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 129285 */   // (atomic_load:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15844>>  =>  (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 129285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 129288 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129295 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129300 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129304 */   GIR_RootConstrainSelectedInstOperands,
     /* 129305 */   // GIR_Coverage, 7083,
     /* 129305 */   GIR_EraseRootFromParent_Done,
     /* 129306 */ // Label 2259: @129306
     /* 129306 */ GIM_Try, /*On fail goto*//*Label 2260*/ GIMT_Encode4(129360), // Rule ID 7085 //
     /* 129311 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129314 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129321 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129328 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129339 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15844>>  =>  (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129339 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 129342 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129358 */   GIR_RootConstrainSelectedInstOperands,
     /* 129359 */   // GIR_Coverage, 7085,
     /* 129359 */   GIR_EraseRootFromParent_Done,
     /* 129360 */ // Label 2260: @129360
     /* 129360 */ GIM_Try, /*On fail goto*//*Label 2261*/ GIMT_Encode4(129417), // Rule ID 7477 //
     /* 129365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129368 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129371 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129378 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129381 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129385 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129389 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 129396 */   // (atomic_load:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15825>>  =>  (LDAPURBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURBi),
     /* 129399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129401 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129406 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129411 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129415 */   GIR_RootConstrainSelectedInstOperands,
     /* 129416 */   // GIR_Coverage, 7477,
     /* 129416 */   GIR_EraseRootFromParent_Done,
     /* 129417 */ // Label 2261: @129417
     /* 129417 */ GIM_Try, /*On fail goto*//*Label 2262*/ GIMT_Encode4(129474), // Rule ID 7479 //
     /* 129422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO_UseLDAPUR),
     /* 129425 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129428 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129435 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129438 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129442 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129446 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 129453 */   // (atomic_load:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15827>>  =>  (LDAPURHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 129453 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAPURHi),
     /* 129456 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 129458 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129463 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 129468 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129472 */   GIR_RootConstrainSelectedInstOperands,
     /* 129473 */   // GIR_Coverage, 7479,
     /* 129473 */   GIR_EraseRootFromParent_Done,
     /* 129474 */ // Label 2262: @129474
     /* 129474 */ GIM_Try, /*On fail goto*//*Label 2263*/ GIMT_Encode4(129514), // Rule ID 7057 //
     /* 129479 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129482 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129485 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129492 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129499 */   // MIs[0] ptr
     /* 129499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129503 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129507 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15825>>  =>  (LDAPRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129507 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRB),
     /* 129512 */   GIR_RootConstrainSelectedInstOperands,
     /* 129513 */   // GIR_Coverage, 7057,
     /* 129513 */   GIR_Done,
     /* 129514 */ // Label 2263: @129514
     /* 129514 */ GIM_Try, /*On fail goto*//*Label 2264*/ GIMT_Encode4(129554), // Rule ID 7059 //
     /* 129519 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC),
     /* 129522 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129525 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129532 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129535 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129539 */   // MIs[0] ptr
     /* 129539 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129543 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129547 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15827>>  =>  (LDAPRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129547 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDAPRH),
     /* 129552 */   GIR_RootConstrainSelectedInstOperands,
     /* 129553 */   // GIR_Coverage, 7059,
     /* 129553 */   GIR_Done,
     /* 129554 */ // Label 2264: @129554
     /* 129554 */ GIM_Try, /*On fail goto*//*Label 2265*/ GIMT_Encode4(129591), // Rule ID 7063 //
     /* 129559 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129562 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129569 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129576 */   // MIs[0] ptr
     /* 129576 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129580 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129584 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15833>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129584 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129589 */   GIR_RootConstrainSelectedInstOperands,
     /* 129590 */   // GIR_Coverage, 7063,
     /* 129590 */   GIR_Done,
     /* 129591 */ // Label 2265: @129591
     /* 129591 */ GIM_Try, /*On fail goto*//*Label 2266*/ GIMT_Encode4(129628), // Rule ID 7065 //
     /* 129596 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129599 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129606 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129613 */   // MIs[0] ptr
     /* 129613 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129617 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129621 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_8>><<P:Predicate_anonymous_15825>>  =>  (LDARB:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129621 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARB),
     /* 129626 */   GIR_RootConstrainSelectedInstOperands,
     /* 129627 */   // GIR_Coverage, 7065,
     /* 129627 */   GIR_Done,
     /* 129628 */ // Label 2266: @129628
     /* 129628 */ GIM_Try, /*On fail goto*//*Label 2267*/ GIMT_Encode4(129665), // Rule ID 7075 //
     /* 129633 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129636 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129643 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 129646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129650 */   // MIs[0] ptr
     /* 129650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129658 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15841>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129658 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129663 */   GIR_RootConstrainSelectedInstOperands,
     /* 129664 */   // GIR_Coverage, 7075,
     /* 129664 */   GIR_Done,
     /* 129665 */ // Label 2267: @129665
     /* 129665 */ GIM_Try, /*On fail goto*//*Label 2268*/ GIMT_Encode4(129702), // Rule ID 7077 //
     /* 129670 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 129673 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129680 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 129683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129687 */   // MIs[0] ptr
     /* 129687 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 129691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 129695 */   // (atomic_load:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_load_zext>><<P:Predicate_atomic_load_zext_16>><<P:Predicate_anonymous_15827>>  =>  (LDARH:{ *:[i32] } GPR64sp:{ *:[i64] }:$ptr)
     /* 129695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LDARH),
     /* 129700 */   GIR_RootConstrainSelectedInstOperands,
     /* 129701 */   // GIR_Coverage, 7077,
     /* 129701 */   GIR_Done,
     /* 129702 */ // Label 2268: @129702
     /* 129702 */ GIM_Reject,
     /* 129703 */ // Label 2237: @129703
     /* 129703 */ GIM_Try, /*On fail goto*//*Label 2269*/ GIMT_Encode4(131192),
     /* 129708 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 129711 */   GIM_Try, /*On fail goto*//*Label 2270*/ GIMT_Encode4(129796), // Rule ID 4103 //
     /* 129716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 129738 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 129745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129765 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129795 */     // GIR_Coverage, 4103,
     /* 129795 */     GIR_EraseRootFromParent_Done,
     /* 129796 */   // Label 2270: @129796
     /* 129796 */   GIM_Try, /*On fail goto*//*Label 2271*/ GIMT_Encode4(129881), // Rule ID 4104 //
     /* 129801 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 129808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129812 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129816 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 129823 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 129830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129845 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129850 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129854 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129861 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129864 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129867 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129880 */     // GIR_Coverage, 4104,
     /* 129880 */     GIR_EraseRootFromParent_Done,
     /* 129881 */   // Label 2271: @129881
     /* 129881 */   GIM_Try, /*On fail goto*//*Label 2272*/ GIMT_Encode4(129966), // Rule ID 4105 //
     /* 129886 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129897 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129901 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 129908 */     // (ld:{ *:[i64] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129908 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129911 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroW),
     /* 129915 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 129920 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 129925 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 129930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 129935 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 129939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 129941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 129944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 129946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 129949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 129952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 129955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 129965 */     // GIR_Coverage, 4105,
     /* 129965 */     GIR_EraseRootFromParent_Done,
     /* 129966 */   // Label 2272: @129966
     /* 129966 */   GIM_Try, /*On fail goto*//*Label 2273*/ GIMT_Encode4(130051), // Rule ID 4106 //
     /* 129971 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 129978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 129982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 129986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 129993 */     // (ld:{ *:[i64] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 129993 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 129996 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHroX),
     /* 130000 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130005 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130010 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130015 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130020 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130024 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130034 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130037 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130040 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130045 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130050 */     // GIR_Coverage, 4106,
     /* 130050 */     GIR_EraseRootFromParent_Done,
     /* 130051 */   // Label 2273: @130051
     /* 130051 */   GIM_Try, /*On fail goto*//*Label 2274*/ GIMT_Encode4(130136), // Rule ID 4107 //
     /* 130056 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130067 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130071 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 130078 */     // (ld:{ *:[i64] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroW),
     /* 130085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130100 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130105 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130135 */     // GIR_Coverage, 4107,
     /* 130135 */     GIR_EraseRootFromParent_Done,
     /* 130136 */   // Label 2274: @130136
     /* 130136 */   GIM_Try, /*On fail goto*//*Label 2275*/ GIMT_Encode4(130221), // Rule ID 4108 //
     /* 130141 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130152 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130156 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 130163 */     // (ld:{ *:[i64] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWroX),
     /* 130170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130175 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130180 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130190 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130194 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130201 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130204 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130207 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130220 */     // GIR_Coverage, 4108,
     /* 130220 */     GIR_EraseRootFromParent_Done,
     /* 130221 */   // Label 2275: @130221
     /* 130221 */   GIM_Try, /*On fail goto*//*Label 2276*/ GIMT_Encode4(130306), // Rule ID 4109 //
     /* 130226 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130237 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130241 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 130248 */     // (ld:{ *:[i64] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130248 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130251 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroW),
     /* 130255 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130260 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130265 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130270 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130275 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130279 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130289 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130300 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130305 */     // GIR_Coverage, 4109,
     /* 130305 */     GIR_EraseRootFromParent_Done,
     /* 130306 */   // Label 2276: @130306
     /* 130306 */   GIM_Try, /*On fail goto*//*Label 2277*/ GIMT_Encode4(130391), // Rule ID 4110 //
     /* 130311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130326 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 130333 */     // (ld:{ *:[i64] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), sub_32:{ *:[i32] })
     /* 130333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBroX),
     /* 130340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 130355 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 130360 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130390 */     // GIR_Coverage, 4110,
     /* 130390 */     GIR_EraseRootFromParent_Done,
     /* 130391 */   // Label 2277: @130391
     /* 130391 */   GIM_Try, /*On fail goto*//*Label 2278*/ GIMT_Encode4(130471), // Rule ID 4142 //
     /* 130396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130411 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130418 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130457 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130470 */     // GIR_Coverage, 4142,
     /* 130470 */     GIR_EraseRootFromParent_Done,
     /* 130471 */   // Label 2278: @130471
     /* 130471 */   GIM_Try, /*On fail goto*//*Label 2279*/ GIMT_Encode4(130551), // Rule ID 4143 //
     /* 130476 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130491 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 130498 */     // (ld:{ *:[i64] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRHHui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHHui),
     /* 130505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130520 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130524 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130531 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130534 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130545 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130550 */     // GIR_Coverage, 4143,
     /* 130550 */     GIR_EraseRootFromParent_Done,
     /* 130551 */   // Label 2279: @130551
     /* 130551 */   GIM_Try, /*On fail goto*//*Label 2280*/ GIMT_Encode4(130631), // Rule ID 4145 //
     /* 130556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130567 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130571 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 130578 */     // (ld:{ *:[i64] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRBBui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130578 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130581 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBBui),
     /* 130585 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130604 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130611 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130614 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130617 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130630 */     // GIR_Coverage, 4145,
     /* 130630 */     GIR_EraseRootFromParent_Done,
     /* 130631 */   // Label 2280: @130631
     /* 130631 */   GIM_Try, /*On fail goto*//*Label 2281*/ GIMT_Encode4(130711), // Rule ID 4153 //
     /* 130636 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130647 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130651 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 130658 */     // (ld:{ *:[i64] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDRWui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), sub_32:{ *:[i32] })
     /* 130658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRWui),
     /* 130665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130670 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130675 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130680 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130684 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130691 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130694 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130700 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130705 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130710 */     // GIR_Coverage, 4153,
     /* 130710 */     GIR_EraseRootFromParent_Done,
     /* 130711 */   // Label 2281: @130711
     /* 130711 */   GIM_Try, /*On fail goto*//*Label 2282*/ GIMT_Encode4(130791), // Rule ID 4179 //
     /* 130716 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 130723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130727 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130731 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 130738 */     // (ld:{ *:[i64] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURWi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURWi),
     /* 130745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130755 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130760 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130764 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130774 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130777 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130790 */     // GIR_Coverage, 4179,
     /* 130790 */     GIR_EraseRootFromParent_Done,
     /* 130791 */   // Label 2282: @130791
     /* 130791 */   GIM_Try, /*On fail goto*//*Label 2283*/ GIMT_Encode4(130871), // Rule ID 4180 //
     /* 130796 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 130803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 130818 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130818 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130821 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 130825 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130830 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130835 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130840 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130870 */     // GIR_Coverage, 4180,
     /* 130870 */     GIR_EraseRootFromParent_Done,
     /* 130871 */   // Label 2283: @130871
     /* 130871 */   GIM_Try, /*On fail goto*//*Label 2284*/ GIMT_Encode4(130951), // Rule ID 4181 //
     /* 130876 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130887 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130891 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130898 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130910 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130915 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 130920 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 130924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 130926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 130929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 130931 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 130934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 130937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 130940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130945 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 130950 */     // GIR_Coverage, 4181,
     /* 130950 */     GIR_EraseRootFromParent_Done,
     /* 130951 */   // Label 2284: @130951
     /* 130951 */   GIM_Try, /*On fail goto*//*Label 2285*/ GIMT_Encode4(131031), // Rule ID 4182 //
     /* 130956 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 130963 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 130967 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 130971 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 130978 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 130978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 130981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 130985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 130990 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 130995 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131000 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131014 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131020 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131025 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131030 */     // GIR_Coverage, 4182,
     /* 131030 */     GIR_EraseRootFromParent_Done,
     /* 131031 */   // Label 2285: @131031
     /* 131031 */   GIM_Try, /*On fail goto*//*Label 2286*/ GIMT_Encode4(131111), // Rule ID 4183 //
     /* 131036 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 131043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131058 */     // (ld:{ *:[i64] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURBBi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBBi),
     /* 131065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131070 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131075 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131080 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131110 */     // GIR_Coverage, 4183,
     /* 131110 */     GIR_EraseRootFromParent_Done,
     /* 131111 */   // Label 2286: @131111
     /* 131111 */   GIM_Try, /*On fail goto*//*Label 2287*/ GIMT_Encode4(131191), // Rule ID 4184 //
     /* 131116 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 131123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131127 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131131 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 131138 */     // (ld:{ *:[i64] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDURHHi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), sub_32:{ *:[i32] })
     /* 131138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 131141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHHi),
     /* 131145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131150 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131155 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131160 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 131166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 131171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 131174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 131180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 131185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 131190 */     // GIR_Coverage, 4184,
     /* 131190 */     GIR_EraseRootFromParent_Done,
     /* 131191 */   // Label 2287: @131191
     /* 131191 */   GIM_Reject,
     /* 131192 */ // Label 2269: @131192
     /* 131192 */ GIM_Reject,
     /* 131193 */ // Label 2238: @131193
     /* 131193 */ GIM_Reject,
     /* 131194 */ // Label 19: @131194
     /* 131194 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(24), /*)*//*default:*//*Label 2308*/ GIMT_Encode4(144719),
     /* 131205 */ /*GILLT_s8*//*Label 2288*/ GIMT_Encode4(131301),
     /* 131209 */ /*GILLT_s16*//*Label 2289*/ GIMT_Encode4(131668),
     /* 131213 */ /*GILLT_s32*//*Label 2290*/ GIMT_Encode4(132807),
     /* 131217 */ /*GILLT_s64*//*Label 2291*/ GIMT_Encode4(137402),
     /* 131221 */ /*GILLT_s128*//*Label 2292*/ GIMT_Encode4(141171),
     /* 131225 */ /*GILLT_v2s32*//*Label 2293*/ GIMT_Encode4(141377),
     /* 131229 */ /*GILLT_v2s64*//*Label 2294*/ GIMT_Encode4(141783),
     /* 131233 */ /*GILLT_v4s16*//*Label 2295*/ GIMT_Encode4(142233),
     /* 131237 */ /*GILLT_v4s32*//*Label 2296*/ GIMT_Encode4(142639),
     /* 131241 */ /*GILLT_v8s8*//*Label 2297*/ GIMT_Encode4(143045),
     /* 131245 */ /*GILLT_v8s16*//*Label 2298*/ GIMT_Encode4(143265),
     /* 131249 */ /*GILLT_v16s8*//*Label 2299*/ GIMT_Encode4(143671), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 131261 */ /*GILLT_nxv2s16*//*Label 2300*/ GIMT_Encode4(143891),
     /* 131265 */ /*GILLT_nxv2s32*//*Label 2301*/ GIMT_Encode4(143951),
     /* 131269 */ /*GILLT_nxv2s64*//*Label 2302*/ GIMT_Encode4(144011), GIMT_Encode4(0),
     /* 131277 */ /*GILLT_nxv4s16*//*Label 2303*/ GIMT_Encode4(144181),
     /* 131281 */ /*GILLT_nxv4s32*//*Label 2304*/ GIMT_Encode4(144241), GIMT_Encode4(0),
     /* 131289 */ /*GILLT_nxv8s16*//*Label 2305*/ GIMT_Encode4(144411),
     /* 131293 */ /*GILLT_nxv16s1*//*Label 2306*/ GIMT_Encode4(144581),
     /* 131297 */ /*GILLT_nxv16s8*//*Label 2307*/ GIMT_Encode4(144625),
     /* 131301 */ // Label 2288: @131301
     /* 131301 */ GIM_Try, /*On fail goto*//*Label 2309*/ GIMT_Encode4(131667),
     /* 131306 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131309 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131313 */   GIM_Try, /*On fail goto*//*Label 2310*/ GIMT_Encode4(131381), // Rule ID 13264 //
     /* 131318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 131330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131351 */     // MIs[2] Operand 1
     /* 131351 */     // No operand predicates
     /* 131351 */     // MIs[0] Rn
     /* 131351 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131355 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131359 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131361 */     // (st (vector_extract:{ *:[i8] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131373 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131379 */     GIR_RootConstrainSelectedInstOperands,
     /* 131380 */     // GIR_Coverage, 13264,
     /* 131380 */     GIR_EraseRootFromParent_Done,
     /* 131381 */   // Label 2310: @131381
     /* 131381 */   GIM_Try, /*On fail goto*//*Label 2311*/ GIMT_Encode4(131480), // Rule ID 13265 //
     /* 131386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 131398 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131402 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131407 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 131411 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 131415 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 131419 */     // MIs[2] Operand 1
     /* 131419 */     // No operand predicates
     /* 131419 */     // MIs[0] Rn
     /* 131419 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 131423 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 131427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 131429 */     // (st (vector_extract:{ *:[i8] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 131429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 131432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 131436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131441 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 131444 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 131448 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 131451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 131464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131467 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 131470 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 131472 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 131478 */     GIR_RootConstrainSelectedInstOperands,
     /* 131479 */     // GIR_Coverage, 13265,
     /* 131479 */     GIR_EraseRootFromParent_Done,
     /* 131480 */   // Label 2311: @131480
     /* 131480 */   GIM_Try, /*On fail goto*//*Label 2312*/ GIMT_Encode4(131529), // Rule ID 303 //
     /* 131485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131496 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 131503 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroW FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 131503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroW),
     /* 131506 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131527 */     GIR_RootConstrainSelectedInstOperands,
     /* 131528 */     // GIR_Coverage, 303,
     /* 131528 */     GIR_EraseRootFromParent_Done,
     /* 131529 */   // Label 2312: @131529
     /* 131529 */   GIM_Try, /*On fail goto*//*Label 2313*/ GIMT_Encode4(131578), // Rule ID 304 //
     /* 131534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 131552 */     // (st FPR8Op:{ *:[i8] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBroX FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 131552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBroX),
     /* 131555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131572 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131576 */     GIR_RootConstrainSelectedInstOperands,
     /* 131577 */     // GIR_Coverage, 304,
     /* 131577 */     GIR_EraseRootFromParent_Done,
     /* 131578 */   // Label 2313: @131578
     /* 131578 */   GIM_Try, /*On fail goto*//*Label 2314*/ GIMT_Encode4(131622), // Rule ID 313 //
     /* 131583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131590 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 131601 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRBui FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 131601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBui),
     /* 131604 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131620 */     GIR_RootConstrainSelectedInstOperands,
     /* 131621 */     // GIR_Coverage, 313,
     /* 131621 */     GIR_EraseRootFromParent_Done,
     /* 131622 */   // Label 2314: @131622
     /* 131622 */   GIM_Try, /*On fail goto*//*Label 2315*/ GIMT_Encode4(131666), // Rule ID 321 //
     /* 131627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 131630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 131634 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131638 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 131645 */     // (st FPR8Op:{ *:[i8] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURBi FPR8Op:{ *:[i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 131645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBi),
     /* 131648 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 131650 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131655 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 131660 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 131664 */     GIR_RootConstrainSelectedInstOperands,
     /* 131665 */     // GIR_Coverage, 321,
     /* 131665 */     GIR_EraseRootFromParent_Done,
     /* 131666 */   // Label 2315: @131666
     /* 131666 */   GIM_Reject,
     /* 131667 */ // Label 2309: @131667
     /* 131667 */ GIM_Reject,
     /* 131668 */ // Label 2289: @131668
     /* 131668 */ GIM_Try, /*On fail goto*//*Label 2316*/ GIMT_Encode4(132806),
     /* 131673 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 131676 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 131680 */   GIM_Try, /*On fail goto*//*Label 2317*/ GIMT_Encode4(131779), // Rule ID 4517 //
     /* 131685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131706 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131710 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131723 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131735 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131746 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131757 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131762 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131767 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131772 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131777 */     GIR_RootConstrainSelectedInstOperands,
     /* 131778 */     // GIR_Coverage, 4517,
     /* 131778 */     GIR_EraseRootFromParent_Done,
     /* 131779 */   // Label 2317: @131779
     /* 131779 */   GIM_Try, /*On fail goto*//*Label 2318*/ GIMT_Encode4(131878), // Rule ID 4518 //
     /* 131784 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131788 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131792 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 131796 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131800 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131805 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131813 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131815 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 131822 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 131822 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131825 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131829 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131834 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131840 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131845 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 131850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 131853 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131861 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131866 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131871 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131876 */     GIR_RootConstrainSelectedInstOperands,
     /* 131877 */     // GIR_Coverage, 4518,
     /* 131877 */     GIR_EraseRootFromParent_Done,
     /* 131878 */   // Label 2318: @131878
     /* 131878 */   GIM_Try, /*On fail goto*//*Label 2319*/ GIMT_Encode4(131977), // Rule ID 13262 //
     /* 131883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131899 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131904 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 131908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 131912 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 131914 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 131921 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 131921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 131924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 131928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 131933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 131939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 131944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 131949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 131952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 131955 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 131960 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 131965 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 131970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 131975 */     GIR_RootConstrainSelectedInstOperands,
     /* 131976 */     // GIR_Coverage, 13262,
     /* 131976 */     GIR_EraseRootFromParent_Done,
     /* 131977 */   // Label 2319: @131977
     /* 131977 */   GIM_Try, /*On fail goto*//*Label 2320*/ GIMT_Encode4(132076), // Rule ID 13263 //
     /* 131982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 131986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 131990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 131994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 131998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132003 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132007 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132011 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132013 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132020 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132051 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132059 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132064 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132074 */     GIR_RootConstrainSelectedInstOperands,
     /* 132075 */     // GIR_Coverage, 13263,
     /* 132075 */     GIR_EraseRootFromParent_Done,
     /* 132076 */   // Label 2320: @132076
     /* 132076 */   GIM_Try, /*On fail goto*//*Label 2321*/ GIMT_Encode4(132170), // Rule ID 4546 //
     /* 132081 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132085 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132089 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132093 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132097 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132102 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132106 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132112 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132119 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132131 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132137 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132150 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132158 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132163 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132168 */     GIR_RootConstrainSelectedInstOperands,
     /* 132169 */     // GIR_Coverage, 4546,
     /* 132169 */     GIR_EraseRootFromParent_Done,
     /* 132170 */   // Label 2321: @132170
     /* 132170 */   GIM_Try, /*On fail goto*//*Label 2322*/ GIMT_Encode4(132264), // Rule ID 4573 //
     /* 132175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132179 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132183 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132187 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132191 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132196 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132200 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132204 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132206 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 132213 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132213 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132216 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132220 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132225 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132231 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132236 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132257 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132262 */     GIR_RootConstrainSelectedInstOperands,
     /* 132263 */     // GIR_Coverage, 4573,
     /* 132263 */     GIR_EraseRootFromParent_Done,
     /* 132264 */   // Label 2322: @132264
     /* 132264 */   GIM_Try, /*On fail goto*//*Label 2323*/ GIMT_Encode4(132358), // Rule ID 13261 //
     /* 132269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132281 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132285 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132290 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132294 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132298 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132300 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132307 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132307 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132310 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132314 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132319 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132325 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132338 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132341 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132346 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132351 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132356 */     GIR_RootConstrainSelectedInstOperands,
     /* 132357 */     // GIR_Coverage, 13261,
     /* 132357 */     GIR_EraseRootFromParent_Done,
     /* 132358 */   // Label 2323: @132358
     /* 132358 */   GIM_Try, /*On fail goto*//*Label 2324*/ GIMT_Encode4(132452), // Rule ID 13267 //
     /* 132363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132375 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132384 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132388 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132394 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 132401 */     // (st (vector_extract:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[i16] } VecListOne64:{ *:[v4i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 132401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132413 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132435 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132445 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132450 */     GIR_RootConstrainSelectedInstOperands,
     /* 132451 */     // GIR_Coverage, 13267,
     /* 132451 */     GIR_EraseRootFromParent_Done,
     /* 132452 */   // Label 2324: @132452
     /* 132452 */   GIM_Try, /*On fail goto*//*Label 2325*/ GIMT_Encode4(132520), // Rule ID 6499 //
     /* 132457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132465 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132469 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132473 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132486 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132490 */     // MIs[2] Operand 1
     /* 132490 */     // No operand predicates
     /* 132490 */     // MIs[0] Rn
     /* 132490 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132500 */     // (st (vector_extract:{ *:[f16] } VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 VecListOne128:{ *:[v8f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132503 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132507 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132518 */     GIR_RootConstrainSelectedInstOperands,
     /* 132519 */     // GIR_Coverage, 6499,
     /* 132519 */     GIR_EraseRootFromParent_Done,
     /* 132520 */   // Label 2325: @132520
     /* 132520 */   GIM_Try, /*On fail goto*//*Label 2326*/ GIMT_Encode4(132619), // Rule ID 6504 //
     /* 132525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132533 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 132537 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132541 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 132550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 132554 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 132558 */     // MIs[2] Operand 1
     /* 132558 */     // No operand predicates
     /* 132558 */     // MIs[0] Rn
     /* 132558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 132562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 132566 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 132568 */     // (st (vector_extract:{ *:[f16] } VecListOne64:{ *:[v4f16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 132568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 132571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 132575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132580 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 132583 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 132587 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 132590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 132600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 132603 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132606 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 132609 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 132611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 132617 */     GIR_RootConstrainSelectedInstOperands,
     /* 132618 */     // GIR_Coverage, 6504,
     /* 132618 */     GIR_EraseRootFromParent_Done,
     /* 132619 */   // Label 2326: @132619
     /* 132619 */   GIM_Try, /*On fail goto*//*Label 2327*/ GIMT_Encode4(132668), // Rule ID 305 //
     /* 132624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132627 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132631 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132635 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132642 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroW FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132645 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132647 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132652 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132662 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132666 */     GIR_RootConstrainSelectedInstOperands,
     /* 132667 */     // GIR_Coverage, 305,
     /* 132667 */     GIR_EraseRootFromParent_Done,
     /* 132668 */   // Label 2327: @132668
     /* 132668 */   GIM_Try, /*On fail goto*//*Label 2328*/ GIMT_Encode4(132717), // Rule ID 306 //
     /* 132673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132680 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132684 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132691 */     // (st FPR16Op:{ *:[f16] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHroX FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 132694 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132715 */     GIR_RootConstrainSelectedInstOperands,
     /* 132716 */     // GIR_Coverage, 306,
     /* 132716 */     GIR_EraseRootFromParent_Done,
     /* 132717 */   // Label 2328: @132717
     /* 132717 */   GIM_Try, /*On fail goto*//*Label 2329*/ GIMT_Encode4(132761), // Rule ID 314 //
     /* 132722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 132740 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRHui FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 132740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 132743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132759 */     GIR_RootConstrainSelectedInstOperands,
     /* 132760 */     // GIR_Coverage, 314,
     /* 132760 */     GIR_EraseRootFromParent_Done,
     /* 132761 */   // Label 2329: @132761
     /* 132761 */   GIM_Try, /*On fail goto*//*Label 2330*/ GIMT_Encode4(132805), // Rule ID 322 //
     /* 132766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 132769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132773 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132777 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 132784 */     // (st FPR16Op:{ *:[f16] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURHi FPR16Op:{ *:[f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 132784 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 132787 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 132789 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132794 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 132799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 132803 */     GIR_RootConstrainSelectedInstOperands,
     /* 132804 */     // GIR_Coverage, 322,
     /* 132804 */     GIR_EraseRootFromParent_Done,
     /* 132805 */   // Label 2330: @132805
     /* 132805 */   GIM_Reject,
     /* 132806 */ // Label 2316: @132806
     /* 132806 */ GIM_Reject,
     /* 132807 */ // Label 2290: @132807
     /* 132807 */ GIM_Try, /*On fail goto*//*Label 2331*/ GIMT_Encode4(132920), // Rule ID 4515 //
     /* 132812 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132815 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132819 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132826 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132834 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132838 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132842 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132847 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132851 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132855 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132857 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 132864 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroW (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 132864 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132867 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132871 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132876 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132882 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 132887 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132892 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroW),
     /* 132895 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 132898 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 132903 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 132908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 132913 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 132918 */   GIR_RootConstrainSelectedInstOperands,
     /* 132919 */   // GIR_Coverage, 4515,
     /* 132919 */   GIR_EraseRootFromParent_Done,
     /* 132920 */ // Label 2331: @132920
     /* 132920 */ GIM_Try, /*On fail goto*//*Label 2332*/ GIMT_Encode4(133033), // Rule ID 4516 //
     /* 132925 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 132928 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 132932 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 132939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 132943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 132947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 132951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 132955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 132960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 132964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 132968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 132970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 132977 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHroX (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 132977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 132980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 132984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 132989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 132995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHroX),
     /* 133008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133021 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133026 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133031 */   GIR_RootConstrainSelectedInstOperands,
     /* 133032 */   // GIR_Coverage, 4516,
     /* 133032 */   GIR_EraseRootFromParent_Done,
     /* 133033 */ // Label 2332: @133033
     /* 133033 */ GIM_Try, /*On fail goto*//*Label 2333*/ GIMT_Encode4(133139), // Rule ID 4519 //
     /* 133038 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133041 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133045 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133049 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133053 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133057 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133061 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133066 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133070 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133074 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133076 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133083 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133083 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133086 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133090 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133095 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133111 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133114 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133137 */   GIR_RootConstrainSelectedInstOperands,
     /* 133138 */   // GIR_Coverage, 4519,
     /* 133138 */   GIR_EraseRootFromParent_Done,
     /* 133139 */ // Label 2333: @133139
     /* 133139 */ GIM_Try, /*On fail goto*//*Label 2334*/ GIMT_Encode4(133245), // Rule ID 4520 //
     /* 133144 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133147 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133151 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133155 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133159 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133163 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133167 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133172 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133176 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133180 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133182 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133189 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133189 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133192 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133196 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133201 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133212 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133217 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133220 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133223 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133228 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133233 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133238 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133243 */   GIR_RootConstrainSelectedInstOperands,
     /* 133244 */   // GIR_Coverage, 4520,
     /* 133244 */   GIR_EraseRootFromParent_Done,
     /* 133245 */ // Label 2334: @133245
     /* 133245 */ GIM_Try, /*On fail goto*//*Label 2335*/ GIMT_Encode4(133351), // Rule ID 4521 //
     /* 133250 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133253 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133257 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133261 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133265 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133269 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133273 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133278 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133282 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133286 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133288 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133295 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133295 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133298 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133302 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133307 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133313 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133318 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133326 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133329 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133334 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133339 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133344 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133349 */   GIR_RootConstrainSelectedInstOperands,
     /* 133350 */   // GIR_Coverage, 4521,
     /* 133350 */   GIR_EraseRootFromParent_Done,
     /* 133351 */ // Label 2335: @133351
     /* 133351 */ GIM_Try, /*On fail goto*//*Label 2336*/ GIMT_Encode4(133457), // Rule ID 4522 //
     /* 133356 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133359 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133363 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133367 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133371 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133375 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133379 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133384 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133388 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133392 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133394 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133401 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133401 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133404 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133408 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133413 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133419 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133424 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133429 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133432 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133435 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133440 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133445 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133450 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133455 */   GIR_RootConstrainSelectedInstOperands,
     /* 133456 */   // GIR_Coverage, 4522,
     /* 133456 */   GIR_EraseRootFromParent_Done,
     /* 133457 */ // Label 2336: @133457
     /* 133457 */ GIM_Try, /*On fail goto*//*Label 2337*/ GIMT_Encode4(133563), // Rule ID 13269 //
     /* 133462 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133465 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133469 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133473 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133477 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133481 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133485 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133490 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133494 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133498 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133500 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 133507 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 133507 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133510 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133514 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133519 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133525 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133530 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 133538 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133541 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133546 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133551 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133556 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133561 */   GIR_RootConstrainSelectedInstOperands,
     /* 133562 */   // GIR_Coverage, 13269,
     /* 133562 */   GIR_EraseRootFromParent_Done,
     /* 133563 */ // Label 2337: @133563
     /* 133563 */ GIM_Try, /*On fail goto*//*Label 2338*/ GIMT_Encode4(133669), // Rule ID 13270 //
     /* 133568 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133571 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133575 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133579 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133583 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 133587 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133596 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133606 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 133613 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 133613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133625 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 133641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 133644 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133647 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133652 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 133657 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 133662 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133667 */   GIR_RootConstrainSelectedInstOperands,
     /* 133668 */   // GIR_Coverage, 13270,
     /* 133668 */   GIR_EraseRootFromParent_Done,
     /* 133669 */ // Label 2338: @133669
     /* 133669 */ GIM_Try, /*On fail goto*//*Label 2339*/ GIMT_Encode4(133777), // Rule ID 4545 //
     /* 133674 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133677 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133681 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133688 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133692 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133696 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 133700 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133704 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133709 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133713 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133717 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133719 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 133726 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHui (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 133726 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 133729 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133733 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133738 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 133744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 133749 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133754 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHui),
     /* 133757 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133775 */   GIR_RootConstrainSelectedInstOperands,
     /* 133776 */   // GIR_Coverage, 4545,
     /* 133776 */   GIR_EraseRootFromParent_Done,
     /* 133777 */ // Label 2339: @133777
     /* 133777 */ GIM_Try, /*On fail goto*//*Label 2340*/ GIMT_Encode4(133878), // Rule ID 4547 //
     /* 133782 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133785 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133789 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133793 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133797 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133801 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133805 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133810 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133814 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133818 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133820 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133827 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133827 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133830 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133834 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133839 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133850 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133855 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133858 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133861 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133866 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133871 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133876 */   GIR_RootConstrainSelectedInstOperands,
     /* 133877 */   // GIR_Coverage, 4547,
     /* 133877 */   GIR_EraseRootFromParent_Done,
     /* 133878 */ // Label 2340: @133878
     /* 133878 */ GIM_Try, /*On fail goto*//*Label 2341*/ GIMT_Encode4(133979), // Rule ID 4548 //
     /* 133883 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 133894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 133898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 133902 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 133906 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133911 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 133915 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 133919 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 133921 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 133928 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 133928 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 133931 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 133935 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 133940 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 133946 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 133951 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 133956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 133959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 133962 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 133967 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 133972 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 133977 */   GIR_RootConstrainSelectedInstOperands,
     /* 133978 */   // GIR_Coverage, 4548,
     /* 133978 */   GIR_EraseRootFromParent_Done,
     /* 133979 */ // Label 2341: @133979
     /* 133979 */ GIM_Try, /*On fail goto*//*Label 2342*/ GIMT_Encode4(134087), // Rule ID 4572 //
     /* 133984 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 133987 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 133991 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 133998 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134002 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134006 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134010 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134014 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134019 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134029 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134036 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHi (EXTRACT_SUBREG:{ *:[f16] } VecListOne128:{ *:[v8i16] }:$Vt, hsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134036 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 134039 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134043 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134048 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Vt
     /* 134054 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 134059 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134064 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHi),
     /* 134067 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134070 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134075 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134080 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134085 */   GIR_RootConstrainSelectedInstOperands,
     /* 134086 */   // GIR_Coverage, 4572,
     /* 134086 */   GIR_EraseRootFromParent_Done,
     /* 134087 */ // Label 2342: @134087
     /* 134087 */ GIM_Try, /*On fail goto*//*Label 2343*/ GIMT_Encode4(134188), // Rule ID 4574 //
     /* 134092 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134095 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134099 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134103 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134107 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134111 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134115 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134120 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134124 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134128 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134130 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134137 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134137 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134140 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134144 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134149 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134155 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134160 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134168 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134171 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134176 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134181 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134186 */   GIR_RootConstrainSelectedInstOperands,
     /* 134187 */   // GIR_Coverage, 4574,
     /* 134187 */   GIR_EraseRootFromParent_Done,
     /* 134188 */ // Label 2343: @134188
     /* 134188 */ GIM_Try, /*On fail goto*//*Label 2344*/ GIMT_Encode4(134289), // Rule ID 4575 //
     /* 134193 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134196 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134200 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134204 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134208 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134212 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134216 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134221 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134225 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134229 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134231 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 134238 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne128:{ *:[v4f32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134238 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134241 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134245 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134250 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134256 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134261 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134266 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134269 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134272 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134277 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134282 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134287 */   GIR_RootConstrainSelectedInstOperands,
     /* 134288 */   // GIR_Coverage, 4575,
     /* 134288 */   GIR_EraseRootFromParent_Done,
     /* 134289 */ // Label 2344: @134289
     /* 134289 */ GIM_Try, /*On fail goto*//*Label 2345*/ GIMT_Encode4(134390), // Rule ID 13266 //
     /* 134294 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134297 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134309 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134313 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134317 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134322 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134332 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 134339 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 134339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134351 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134357 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134362 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134367 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 134370 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134373 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134378 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134383 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134388 */   GIR_RootConstrainSelectedInstOperands,
     /* 134389 */   // GIR_Coverage, 13266,
     /* 134389 */   GIR_EraseRootFromParent_Done,
     /* 134390 */ // Label 2345: @134390
     /* 134390 */ GIM_Try, /*On fail goto*//*Label 2346*/ GIMT_Encode4(134491), // Rule ID 13268 //
     /* 134395 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134398 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134402 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134406 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134410 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 134414 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134418 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134423 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 134427 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 134431 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 134433 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 134440 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, 0:{ *:[i64] }), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi (EXTRACT_SUBREG:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, ssub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 134440 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 134443 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 134447 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134452 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Vt
     /* 134458 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 134463 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134468 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 134471 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134474 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 134479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 134484 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 134489 */   GIR_RootConstrainSelectedInstOperands,
     /* 134490 */   // GIR_Coverage, 13268,
     /* 134490 */   GIR_EraseRootFromParent_Done,
     /* 134491 */ // Label 2346: @134491
     /* 134491 */ GIM_Try, /*On fail goto*//*Label 2347*/ GIMT_Encode4(134573), // Rule ID 6493 //
     /* 134496 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134499 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134503 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134510 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134514 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134518 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 134522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134531 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134535 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134539 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134543 */   // MIs[2] Operand 1
     /* 134543 */   // No operand predicates
     /* 134543 */   // MIs[0] Rn
     /* 134543 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134547 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134551 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134553 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 VecListOne128:{ *:[v16i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134553 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134556 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134560 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134563 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134565 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134571 */   GIR_RootConstrainSelectedInstOperands,
     /* 134572 */   // GIR_Coverage, 6493,
     /* 134572 */   GIR_EraseRootFromParent_Done,
     /* 134573 */ // Label 2347: @134573
     /* 134573 */ GIM_Try, /*On fail goto*//*Label 2348*/ GIMT_Encode4(134655), // Rule ID 6494 //
     /* 134578 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134581 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134585 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 134604 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134608 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134613 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134617 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134621 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134625 */   // MIs[2] Operand 1
     /* 134625 */   // No operand predicates
     /* 134625 */   // MIs[0] Rn
     /* 134625 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134633 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134635 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 VecListOne128:{ *:[v8i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134635 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 134638 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134642 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134647 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134653 */   GIR_RootConstrainSelectedInstOperands,
     /* 134654 */   // GIR_Coverage, 6494,
     /* 134654 */   GIR_EraseRootFromParent_Done,
     /* 134655 */ // Label 2348: @134655
     /* 134655 */ GIM_Try, /*On fail goto*//*Label 2349*/ GIMT_Encode4(134730), // Rule ID 6495 //
     /* 134660 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134663 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134667 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134671 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134675 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134679 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134683 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134688 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134692 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134696 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134700 */   // MIs[2] Operand 1
     /* 134700 */   // No operand predicates
     /* 134700 */   // MIs[0] Rn
     /* 134700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134704 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134708 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134710 */   // (st (vector_extract:{ *:[i32] } VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134710 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134713 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134717 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134720 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134722 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134728 */   GIR_RootConstrainSelectedInstOperands,
     /* 134729 */   // GIR_Coverage, 6495,
     /* 134729 */   GIR_EraseRootFromParent_Done,
     /* 134730 */ // Label 2349: @134730
     /* 134730 */ GIM_Try, /*On fail goto*//*Label 2350*/ GIMT_Encode4(134805), // Rule ID 6496 //
     /* 134735 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134738 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134742 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134746 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134750 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 134754 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134758 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134763 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134767 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134771 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 134775 */   // MIs[2] Operand 1
     /* 134775 */   // No operand predicates
     /* 134775 */   // MIs[0] Rn
     /* 134775 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134779 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134783 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134785 */   // (st (vector_extract:{ *:[f32] } VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 VecListOne128:{ *:[v4f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134785 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 134788 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134792 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134795 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134797 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134803 */   GIR_RootConstrainSelectedInstOperands,
     /* 134804 */   // GIR_Coverage, 6496,
     /* 134804 */   GIR_EraseRootFromParent_Done,
     /* 134805 */ // Label 2350: @134805
     /* 134805 */ GIM_Try, /*On fail goto*//*Label 2351*/ GIMT_Encode4(134918), // Rule ID 6500 //
     /* 134810 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134813 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134817 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 134824 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134828 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134832 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 134836 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134840 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134845 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134849 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134853 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 134857 */   // MIs[2] Operand 1
     /* 134857 */   // No operand predicates
     /* 134857 */   // MIs[0] Rn
     /* 134857 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134861 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134865 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134867 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v8i8] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (ST1i8 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134867 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134870 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134874 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134879 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134882 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134886 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 134889 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 134894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134899 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i8),
     /* 134902 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 134905 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 134908 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 134910 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 134916 */   GIR_RootConstrainSelectedInstOperands,
     /* 134917 */   // GIR_Coverage, 6500,
     /* 134917 */   GIR_EraseRootFromParent_Done,
     /* 134918 */ // Label 2351: @134918
     /* 134918 */ GIM_Try, /*On fail goto*//*Label 2352*/ GIMT_Encode4(135031), // Rule ID 6501 //
     /* 134923 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 134926 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 134930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 134937 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 134941 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 134945 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 134949 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 134953 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 134958 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 134962 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 134966 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 134970 */   // MIs[2] Operand 1
     /* 134970 */   // No operand predicates
     /* 134970 */   // MIs[0] Rn
     /* 134970 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 134974 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 134978 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 134980 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v4i16] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (ST1i16 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 134980 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 134983 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 134987 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 134992 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 134995 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 134999 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135002 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135007 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135012 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i16),
     /* 135015 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135018 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135021 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135023 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135029 */   GIR_RootConstrainSelectedInstOperands,
     /* 135030 */   // GIR_Coverage, 6501,
     /* 135030 */   GIR_EraseRootFromParent_Done,
     /* 135031 */ // Label 2352: @135031
     /* 135031 */ GIM_Try, /*On fail goto*//*Label 2353*/ GIMT_Encode4(135137), // Rule ID 6502 //
     /* 135036 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135039 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135043 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135047 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135051 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135055 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135059 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135064 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135068 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135072 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135076 */   // MIs[2] Operand 1
     /* 135076 */   // No operand predicates
     /* 135076 */   // MIs[0] Rn
     /* 135076 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135084 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135086 */   // (st (vector_extract:{ *:[i32] } VecListOne64:{ *:[v2i32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135098 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135101 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135105 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135108 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135113 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135118 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135121 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135124 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135127 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135135 */   GIR_RootConstrainSelectedInstOperands,
     /* 135136 */   // GIR_Coverage, 6502,
     /* 135136 */   GIR_EraseRootFromParent_Done,
     /* 135137 */ // Label 2353: @135137
     /* 135137 */ GIM_Try, /*On fail goto*//*Label 2354*/ GIMT_Encode4(135243), // Rule ID 6503 //
     /* 135142 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135145 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135149 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135153 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 135157 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 135161 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 135165 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135170 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 135174 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 135178 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 135182 */   // MIs[2] Operand 1
     /* 135182 */   // No operand predicates
     /* 135182 */   // MIs[0] Rn
     /* 135182 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 135186 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 135190 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 135192 */   // (st (vector_extract:{ *:[f32] } VecListOne64:{ *:[v2f32] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i32 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Vt, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 135192 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 135195 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 135199 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 135204 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 135207 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 135211 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 135214 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 135219 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 135224 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i32),
     /* 135227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 135230 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 135233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 135235 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 135241 */   GIR_RootConstrainSelectedInstOperands,
     /* 135242 */   // GIR_Coverage, 6503,
     /* 135242 */   GIR_EraseRootFromParent_Done,
     /* 135243 */ // Label 2354: @135243
     /* 135243 */ GIM_Try, /*On fail goto*//*Label 2355*/ GIMT_Encode4(135303), // Rule ID 295 //
     /* 135248 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135251 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135255 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135266 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135270 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 135277 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 135277 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 135280 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135282 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135287 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135292 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135301 */   GIR_RootConstrainSelectedInstOperands,
     /* 135302 */   // GIR_Coverage, 295,
     /* 135302 */   GIR_EraseRootFromParent_Done,
     /* 135303 */ // Label 2355: @135303
     /* 135303 */ GIM_Try, /*On fail goto*//*Label 2356*/ GIMT_Encode4(135363), // Rule ID 296 //
     /* 135308 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135311 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135315 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135326 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135330 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 135337 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 135337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 135340 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135342 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135347 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135352 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135357 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135361 */   GIR_RootConstrainSelectedInstOperands,
     /* 135362 */   // GIR_Coverage, 296,
     /* 135362 */   GIR_EraseRootFromParent_Done,
     /* 135363 */ // Label 2356: @135363
     /* 135363 */ GIM_Try, /*On fail goto*//*Label 2357*/ GIMT_Encode4(135423), // Rule ID 297 //
     /* 135368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135371 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135375 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135390 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 135397 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 135397 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 135400 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135402 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135407 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135417 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135421 */   GIR_RootConstrainSelectedInstOperands,
     /* 135422 */   // GIR_Coverage, 297,
     /* 135422 */   GIR_EraseRootFromParent_Done,
     /* 135423 */ // Label 2357: @135423
     /* 135423 */ GIM_Try, /*On fail goto*//*Label 2358*/ GIMT_Encode4(135483), // Rule ID 298 //
     /* 135428 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135431 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135435 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135442 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135446 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135450 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 135457 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 135457 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 135460 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135462 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135467 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135472 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135477 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135481 */   GIR_RootConstrainSelectedInstOperands,
     /* 135482 */   // GIR_Coverage, 298,
     /* 135482 */   GIR_EraseRootFromParent_Done,
     /* 135483 */ // Label 2358: @135483
     /* 135483 */ GIM_Try, /*On fail goto*//*Label 2359*/ GIMT_Encode4(135536), // Rule ID 299 //
     /* 135488 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135491 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135495 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135499 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135503 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135510 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroW GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135510 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 135513 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135515 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135520 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135525 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135530 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135534 */   GIR_RootConstrainSelectedInstOperands,
     /* 135535 */   // GIR_Coverage, 299,
     /* 135535 */   GIR_EraseRootFromParent_Done,
     /* 135536 */ // Label 2359: @135536
     /* 135536 */ GIM_Try, /*On fail goto*//*Label 2360*/ GIMT_Encode4(135589), // Rule ID 300 //
     /* 135541 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135544 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135548 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135552 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135556 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135563 */   // (st GPR32:{ *:[i32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWroX GPR32:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135563 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 135566 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135568 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135573 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135578 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135583 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135587 */   GIR_RootConstrainSelectedInstOperands,
     /* 135588 */   // GIR_Coverage, 300,
     /* 135588 */   GIR_EraseRootFromParent_Done,
     /* 135589 */ // Label 2360: @135589
     /* 135589 */ GIM_Try, /*On fail goto*//*Label 2361*/ GIMT_Encode4(135645), // Rule ID 307 //
     /* 135594 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135597 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135600 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135608 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135612 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135619 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135619 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135622 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135624 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135629 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135634 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135639 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135643 */   GIR_RootConstrainSelectedInstOperands,
     /* 135644 */   // GIR_Coverage, 307,
     /* 135644 */   GIR_EraseRootFromParent_Done,
     /* 135645 */ // Label 2361: @135645
     /* 135645 */ GIM_Try, /*On fail goto*//*Label 2362*/ GIMT_Encode4(135701), // Rule ID 308 //
     /* 135650 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135653 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135656 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135660 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135664 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135668 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 135675 */   // (st FPR32Op:{ *:[f32] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 135675 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 135678 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135680 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135685 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135690 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135695 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135699 */   GIR_RootConstrainSelectedInstOperands,
     /* 135700 */   // GIR_Coverage, 308,
     /* 135700 */   GIR_EraseRootFromParent_Done,
     /* 135701 */ // Label 2362: @135701
     /* 135701 */ GIM_Try, /*On fail goto*//*Label 2363*/ GIMT_Encode4(135753), // Rule ID 312 //
     /* 135706 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135709 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135717 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135721 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135728 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRWui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135728 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 135731 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135737 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135742 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135747 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135751 */   GIR_RootConstrainSelectedInstOperands,
     /* 135752 */   // GIR_Coverage, 312,
     /* 135752 */   GIR_EraseRootFromParent_Done,
     /* 135753 */ // Label 2363: @135753
     /* 135753 */ GIM_Try, /*On fail goto*//*Label 2364*/ GIMT_Encode4(135804), // Rule ID 315 //
     /* 135758 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 135761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135764 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135772 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135776 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 135783 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRSui FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 135783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 135786 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 135788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135793 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135798 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135802 */   GIR_RootConstrainSelectedInstOperands,
     /* 135803 */   // GIR_Coverage, 315,
     /* 135803 */   GIR_EraseRootFromParent_Done,
     /* 135804 */ // Label 2364: @135804
     /* 135804 */ GIM_Try, /*On fail goto*//*Label 2365*/ GIMT_Encode4(135863), // Rule ID 317 //
     /* 135809 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135812 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135816 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 135823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135827 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135831 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 135838 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 135838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 135841 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135847 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135852 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135857 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135861 */   GIR_RootConstrainSelectedInstOperands,
     /* 135862 */   // GIR_Coverage, 317,
     /* 135862 */   GIR_EraseRootFromParent_Done,
     /* 135863 */ // Label 2365: @135863
     /* 135863 */ GIM_Try, /*On fail goto*//*Label 2366*/ GIMT_Encode4(135922), // Rule ID 318 //
     /* 135868 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 135871 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 135875 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 135882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 135886 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135890 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 135897 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 135897 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 135900 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 135906 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135911 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 135916 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 135920 */   GIR_RootConstrainSelectedInstOperands,
     /* 135921 */   // GIR_Coverage, 318,
     /* 135921 */   GIR_EraseRootFromParent_Done,
     /* 135922 */ // Label 2366: @135922
     /* 135922 */ GIM_Try, /*On fail goto*//*Label 2367*/ GIMT_Encode4(135999), // Rule ID 7126 //
     /* 135927 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 135930 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 135937 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 135940 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 135944 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 135948 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 135952 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 135957 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 135961 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 135963 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 135970 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRSroW FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 135970 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroW),
     /* 135973 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 135977 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 135982 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 135987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 135992 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 135997 */   GIR_RootConstrainSelectedInstOperands,
     /* 135998 */   // GIR_Coverage, 7126,
     /* 135998 */   GIR_EraseRootFromParent_Done,
     /* 135999 */ // Label 2367: @135999
     /* 135999 */ GIM_Try, /*On fail goto*//*Label 2368*/ GIMT_Encode4(136076), // Rule ID 7127 //
     /* 136004 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136007 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136014 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136017 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136021 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136025 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136029 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136034 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136038 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136040 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136047 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRSroX FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136047 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSroX),
     /* 136050 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136059 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136064 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136069 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136074 */   GIR_RootConstrainSelectedInstOperands,
     /* 136075 */   // GIR_Coverage, 7127,
     /* 136075 */   GIR_EraseRootFromParent_Done,
     /* 136076 */ // Label 2368: @136076
     /* 136076 */ GIM_Try, /*On fail goto*//*Label 2369*/ GIMT_Encode4(136135), // Rule ID 7107 //
     /* 136081 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136084 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136091 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136094 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136098 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136102 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 136109 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15875>>  =>  (STRBBroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 136109 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 136112 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136114 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136119 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136124 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136129 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136133 */   GIR_RootConstrainSelectedInstOperands,
     /* 136134 */   // GIR_Coverage, 7107,
     /* 136134 */   GIR_EraseRootFromParent_Done,
     /* 136135 */ // Label 2369: @136135
     /* 136135 */ GIM_Try, /*On fail goto*//*Label 2370*/ GIMT_Encode4(136194), // Rule ID 7108 //
     /* 136140 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136143 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136150 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136153 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136157 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136161 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 136168 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15875>>  =>  (STRBBroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 136168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 136171 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136173 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136178 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136183 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136188 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136192 */   GIR_RootConstrainSelectedInstOperands,
     /* 136193 */   // GIR_Coverage, 7108,
     /* 136193 */   GIR_EraseRootFromParent_Done,
     /* 136194 */ // Label 2370: @136194
     /* 136194 */ GIM_Try, /*On fail goto*//*Label 2371*/ GIMT_Encode4(136253), // Rule ID 7112 //
     /* 136199 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136209 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136212 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136216 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136220 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 136227 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15882>>  =>  (STRHHroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 136227 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 136230 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136242 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136251 */   GIR_RootConstrainSelectedInstOperands,
     /* 136252 */   // GIR_Coverage, 7112,
     /* 136252 */   GIR_EraseRootFromParent_Done,
     /* 136253 */ // Label 2371: @136253
     /* 136253 */ GIM_Try, /*On fail goto*//*Label 2372*/ GIMT_Encode4(136312), // Rule ID 7113 //
     /* 136258 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136261 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136268 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136279 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 136286 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15882>>  =>  (STRHHroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 136286 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 136289 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136291 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136296 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136301 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136306 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136310 */   GIR_RootConstrainSelectedInstOperands,
     /* 136311 */   // GIR_Coverage, 7113,
     /* 136311 */   GIR_EraseRootFromParent_Done,
     /* 136312 */ // Label 2372: @136312
     /* 136312 */ GIM_Try, /*On fail goto*//*Label 2373*/ GIMT_Encode4(136371), // Rule ID 7117 //
     /* 136317 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136320 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136327 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136330 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136334 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136338 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 136345 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRWroW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 136345 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 136348 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136350 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136355 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136360 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136365 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136369 */   GIR_RootConstrainSelectedInstOperands,
     /* 136370 */   // GIR_Coverage, 7117,
     /* 136370 */   GIR_EraseRootFromParent_Done,
     /* 136371 */ // Label 2373: @136371
     /* 136371 */ GIM_Try, /*On fail goto*//*Label 2374*/ GIMT_Encode4(136430), // Rule ID 7118 //
     /* 136376 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136379 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136386 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136389 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136393 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136397 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 136404 */   // (atomic_store GPR32:{ *:[i32] }:$val, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRWroX GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 136404 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 136407 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136409 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136414 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 136419 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 136424 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136428 */   GIR_RootConstrainSelectedInstOperands,
     /* 136429 */   // GIR_Coverage, 7118,
     /* 136429 */   GIR_EraseRootFromParent_Done,
     /* 136430 */ // Label 2374: @136430
     /* 136430 */ GIM_Try, /*On fail goto*//*Label 2375*/ GIMT_Encode4(136502), // Rule ID 7128 //
     /* 136435 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136438 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136445 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136448 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136452 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136456 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136460 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136465 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136469 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136471 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 136478 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRSui FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 136478 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRSui),
     /* 136481 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136485 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136490 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136495 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136500 */   GIR_RootConstrainSelectedInstOperands,
     /* 136501 */   // GIR_Coverage, 7128,
     /* 136501 */   GIR_EraseRootFromParent_Done,
     /* 136502 */ // Label 2375: @136502
     /* 136502 */ GIM_Try, /*On fail goto*//*Label 2376*/ GIMT_Encode4(136574), // Rule ID 7129 //
     /* 136507 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136510 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 136517 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 136524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 136528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 136532 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136537 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 136543 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136550 */   // (atomic_store (bitconvert:{ *:[i32] } FPR32Op:{ *:[f32] }:$val), (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STURSi FPR32Op:{ *:[f32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136550 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136553 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 136557 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136562 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136567 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 136572 */   GIR_RootConstrainSelectedInstOperands,
     /* 136573 */   // GIR_Coverage, 7129,
     /* 136573 */   GIR_EraseRootFromParent_Done,
     /* 136574 */ // Label 2376: @136574
     /* 136574 */ GIM_Try, /*On fail goto*//*Label 2377*/ GIMT_Encode4(136626), // Rule ID 320 //
     /* 136579 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136582 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136590 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136594 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136601 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURWi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 136604 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136610 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136615 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136620 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136624 */   GIR_RootConstrainSelectedInstOperands,
     /* 136625 */   // GIR_Coverage, 320,
     /* 136625 */   GIR_EraseRootFromParent_Done,
     /* 136626 */ // Label 2377: @136626
     /* 136626 */ GIM_Try, /*On fail goto*//*Label 2378*/ GIMT_Encode4(136677), // Rule ID 323 //
     /* 136631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 136634 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136637 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 136645 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136649 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 136656 */   // (st FPR32Op:{ *:[f32] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURSi FPR32Op:{ *:[f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURSi),
     /* 136659 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 136661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136671 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136675 */   GIR_RootConstrainSelectedInstOperands,
     /* 136676 */   // GIR_Coverage, 323,
     /* 136676 */   GIR_EraseRootFromParent_Done,
     /* 136677 */ // Label 2378: @136677
     /* 136677 */ GIM_Try, /*On fail goto*//*Label 2379*/ GIMT_Encode4(136736), // Rule ID 326 //
     /* 136682 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136685 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136689 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136700 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136704 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136711 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136711 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136714 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136720 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136725 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136730 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136734 */   GIR_RootConstrainSelectedInstOperands,
     /* 136735 */   // GIR_Coverage, 326,
     /* 136735 */   GIR_EraseRootFromParent_Done,
     /* 136736 */ // Label 2379: @136736
     /* 136736 */ GIM_Try, /*On fail goto*//*Label 2380*/ GIMT_Encode4(136795), // Rule ID 327 //
     /* 136741 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 136744 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 136748 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136755 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136759 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136770 */   // (st GPR32z:{ *:[i32] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi GPR32z:{ *:[i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 136770 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136773 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::WZR), // Rt
     /* 136779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136793 */   GIR_RootConstrainSelectedInstOperands,
     /* 136794 */   // GIR_Coverage, 327,
     /* 136794 */   GIR_EraseRootFromParent_Done,
     /* 136795 */ // Label 2380: @136795
     /* 136795 */ GIM_Try, /*On fail goto*//*Label 2381*/ GIMT_Encode4(136849), // Rule ID 7109 //
     /* 136800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136817 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136821 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 136828 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15875>>  =>  (STRBBui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 136828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 136831 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136833 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136838 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136843 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136847 */   GIR_RootConstrainSelectedInstOperands,
     /* 136848 */   // GIR_Coverage, 7109,
     /* 136848 */   GIR_EraseRootFromParent_Done,
     /* 136849 */ // Label 2381: @136849
     /* 136849 */ GIM_Try, /*On fail goto*//*Label 2382*/ GIMT_Encode4(136903), // Rule ID 7110 //
     /* 136854 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136857 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 136864 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136867 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136871 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136875 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 136882 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15875>>  =>  (STURBBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 136885 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136887 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136892 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136897 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136901 */   GIR_RootConstrainSelectedInstOperands,
     /* 136902 */   // GIR_Coverage, 7110,
     /* 136902 */   GIR_EraseRootFromParent_Done,
     /* 136903 */ // Label 2382: @136903
     /* 136903 */ GIM_Try, /*On fail goto*//*Label 2383*/ GIMT_Encode4(136957), // Rule ID 7114 //
     /* 136908 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136911 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136918 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136921 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136925 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136929 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 136936 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15882>>  =>  (STRHHui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 136936 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 136939 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136941 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 136946 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 136951 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 136955 */   GIR_RootConstrainSelectedInstOperands,
     /* 136956 */   // GIR_Coverage, 7114,
     /* 136956 */   GIR_EraseRootFromParent_Done,
     /* 136957 */ // Label 2383: @136957
     /* 136957 */ GIM_Try, /*On fail goto*//*Label 2384*/ GIMT_Encode4(137011), // Rule ID 7115 //
     /* 136962 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 136965 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 136972 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 136975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 136979 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 136983 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 136990 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15882>>  =>  (STURHHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 136990 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 136993 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 136995 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137000 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137005 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137009 */   GIR_RootConstrainSelectedInstOperands,
     /* 137010 */   // GIR_Coverage, 7115,
     /* 137010 */   GIR_EraseRootFromParent_Done,
     /* 137011 */ // Label 2384: @137011
     /* 137011 */ GIM_Try, /*On fail goto*//*Label 2385*/ GIMT_Encode4(137065), // Rule ID 7119 //
     /* 137016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137026 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137029 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137033 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137037 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 137044 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STRWui GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 137044 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 137047 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137049 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137054 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137059 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137063 */   GIR_RootConstrainSelectedInstOperands,
     /* 137064 */   // GIR_Coverage, 7119,
     /* 137064 */   GIR_EraseRootFromParent_Done,
     /* 137065 */ // Label 2385: @137065
     /* 137065 */ GIM_Try, /*On fail goto*//*Label 2386*/ GIMT_Encode4(137119), // Rule ID 7120 //
     /* 137070 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137073 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137080 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137087 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137091 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137098 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15889>>  =>  (STURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137098 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 137101 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137103 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137108 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137113 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137117 */   GIR_RootConstrainSelectedInstOperands,
     /* 137118 */   // GIR_Coverage, 7120,
     /* 137118 */   GIR_EraseRootFromParent_Done,
     /* 137119 */ // Label 2386: @137119
     /* 137119 */ GIM_Try, /*On fail goto*//*Label 2387*/ GIMT_Encode4(137176), // Rule ID 7482 //
     /* 137124 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137127 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137130 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137137 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137144 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137148 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 137155 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15873>>  =>  (STLURBi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137155 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURBi),
     /* 137158 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137165 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137170 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137174 */   GIR_RootConstrainSelectedInstOperands,
     /* 137175 */   // GIR_Coverage, 7482,
     /* 137175 */   GIR_EraseRootFromParent_Done,
     /* 137176 */ // Label 2387: @137176
     /* 137176 */ GIM_Try, /*On fail goto*//*Label 2388*/ GIMT_Encode4(137233), // Rule ID 7483 //
     /* 137181 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137184 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137187 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137194 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 137212 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15880>>  =>  (STLURHi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURHi),
     /* 137215 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137227 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137231 */   GIR_RootConstrainSelectedInstOperands,
     /* 137232 */   // GIR_Coverage, 7483,
     /* 137232 */   GIR_EraseRootFromParent_Done,
     /* 137233 */ // Label 2388: @137233
     /* 137233 */ GIM_Try, /*On fail goto*//*Label 2389*/ GIMT_Encode4(137290), // Rule ID 7484 //
     /* 137238 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 137241 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137244 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137251 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137258 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137262 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 137269 */   // (atomic_store GPR32:{ *:[i32] }:$val, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15887>>  =>  (STLURWi GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 137269 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURWi),
     /* 137272 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 137274 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137279 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137284 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 137288 */   GIR_RootConstrainSelectedInstOperands,
     /* 137289 */   // GIR_Coverage, 7484,
     /* 137289 */   GIR_EraseRootFromParent_Done,
     /* 137290 */ // Label 2389: @137290
     /* 137290 */ GIM_Try, /*On fail goto*//*Label 2390*/ GIMT_Encode4(137327), // Rule ID 7106 //
     /* 137295 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137298 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 137305 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137308 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137312 */   // MIs[0] ptr
     /* 137312 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137320 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_8>><<P:Predicate_anonymous_15873>>  =>  (STLRB GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRB),
     /* 137325 */   GIR_RootConstrainSelectedInstOperands,
     /* 137326 */   // GIR_Coverage, 7106,
     /* 137326 */   GIR_Done,
     /* 137327 */ // Label 2390: @137327
     /* 137327 */ GIM_Try, /*On fail goto*//*Label 2391*/ GIMT_Encode4(137364), // Rule ID 7111 //
     /* 137332 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137335 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 137342 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137349 */   // MIs[0] ptr
     /* 137349 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137353 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137357 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_16>><<P:Predicate_anonymous_15880>>  =>  (STLRH GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137357 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRH),
     /* 137362 */   GIR_RootConstrainSelectedInstOperands,
     /* 137363 */   // GIR_Coverage, 7111,
     /* 137363 */   GIR_Done,
     /* 137364 */ // Label 2391: @137364
     /* 137364 */ GIM_Try, /*On fail goto*//*Label 2392*/ GIMT_Encode4(137401), // Rule ID 7116 //
     /* 137369 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 137372 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 137379 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 137382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 137386 */   // MIs[0] ptr
     /* 137386 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 137390 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 137394 */   // (atomic_store GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_32>><<P:Predicate_anonymous_15887>>  =>  (STLRW GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 137394 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRW),
     /* 137399 */   GIR_RootConstrainSelectedInstOperands,
     /* 137400 */   // GIR_Coverage, 7116,
     /* 137400 */   GIR_Done,
     /* 137401 */ // Label 2392: @137401
     /* 137401 */ GIM_Reject,
     /* 137402 */ // Label 2291: @137402
     /* 137402 */ GIM_Try, /*On fail goto*//*Label 2393*/ GIMT_Encode4(137508), // Rule ID 4523 //
     /* 137407 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137410 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137414 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137418 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137422 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137426 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137430 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137435 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137439 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137443 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137445 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137452 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137452 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137455 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137459 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137464 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137470 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137475 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137480 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137483 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137486 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137491 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137496 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137501 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137506 */   GIR_RootConstrainSelectedInstOperands,
     /* 137507 */   // GIR_Coverage, 4523,
     /* 137507 */   GIR_EraseRootFromParent_Done,
     /* 137508 */ // Label 2393: @137508
     /* 137508 */ GIM_Try, /*On fail goto*//*Label 2394*/ GIMT_Encode4(137614), // Rule ID 4524 //
     /* 137513 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137516 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137520 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137524 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137528 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137532 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137536 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137541 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137545 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137549 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137551 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137558 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137570 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137589 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137592 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137597 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137602 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137612 */   GIR_RootConstrainSelectedInstOperands,
     /* 137613 */   // GIR_Coverage, 4524,
     /* 137613 */   GIR_EraseRootFromParent_Done,
     /* 137614 */ // Label 2394: @137614
     /* 137614 */ GIM_Try, /*On fail goto*//*Label 2395*/ GIMT_Encode4(137720), // Rule ID 4525 //
     /* 137619 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137622 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137626 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137634 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137638 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137642 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137647 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137651 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137655 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137657 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 137664 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 137664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 137695 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137698 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137703 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137708 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137713 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137718 */   GIR_RootConstrainSelectedInstOperands,
     /* 137719 */   // GIR_Coverage, 4525,
     /* 137719 */   GIR_EraseRootFromParent_Done,
     /* 137720 */ // Label 2395: @137720
     /* 137720 */ GIM_Try, /*On fail goto*//*Label 2396*/ GIMT_Encode4(137826), // Rule ID 4526 //
     /* 137725 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137728 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137744 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137748 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137753 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137757 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137761 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137763 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 137770 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 137770 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137773 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137777 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137782 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137788 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137793 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137798 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 137801 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137804 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137809 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 137814 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 137819 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137824 */   GIR_RootConstrainSelectedInstOperands,
     /* 137825 */   // GIR_Coverage, 4526,
     /* 137825 */   GIR_EraseRootFromParent_Done,
     /* 137826 */ // Label 2396: @137826
     /* 137826 */ GIM_Try, /*On fail goto*//*Label 2397*/ GIMT_Encode4(137927), // Rule ID 4549 //
     /* 137831 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137834 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137838 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137842 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137846 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137850 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137854 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137859 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137867 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137869 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137876 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137876 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137879 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137883 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137888 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137894 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 137899 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137904 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 137907 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 137910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 137915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 137920 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 137925 */   GIR_RootConstrainSelectedInstOperands,
     /* 137926 */   // GIR_Coverage, 4549,
     /* 137926 */   GIR_EraseRootFromParent_Done,
     /* 137927 */ // Label 2397: @137927
     /* 137927 */ GIM_Try, /*On fail goto*//*Label 2398*/ GIMT_Encode4(138028), // Rule ID 4550 //
     /* 137932 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 137935 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 137939 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 137943 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 137947 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 137951 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 137955 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 137960 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 137964 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 137968 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 137970 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 137977 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 137977 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 137980 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 137984 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 137989 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 137995 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138000 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138005 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 138008 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138011 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138016 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138021 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138026 */   GIR_RootConstrainSelectedInstOperands,
     /* 138027 */   // GIR_Coverage, 4550,
     /* 138027 */   GIR_EraseRootFromParent_Done,
     /* 138028 */ // Label 2398: @138028
     /* 138028 */ GIM_Try, /*On fail goto*//*Label 2399*/ GIMT_Encode4(138129), // Rule ID 4576 //
     /* 138033 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138036 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138048 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138052 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138056 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138061 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138065 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138071 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138078 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138078 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138081 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138085 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138090 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138096 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138101 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138106 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138112 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138117 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138122 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138127 */   GIR_RootConstrainSelectedInstOperands,
     /* 138128 */   // GIR_Coverage, 4576,
     /* 138128 */   GIR_EraseRootFromParent_Done,
     /* 138129 */ // Label 2399: @138129
     /* 138129 */ GIM_Try, /*On fail goto*//*Label 2400*/ GIMT_Encode4(138230), // Rule ID 4577 //
     /* 138134 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138137 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138149 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138153 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138157 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138162 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 138166 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138170 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 138172 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 138179 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, 0:{ *:[i64] }), (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi (EXTRACT_SUBREG:{ *:[i64] } VecListOne128:{ *:[v2f64] }:$Vt, dsub:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 138179 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 138182 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138186 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138191 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Vt
     /* 138197 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 138210 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138213 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138218 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 138223 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 138228 */   GIR_RootConstrainSelectedInstOperands,
     /* 138229 */   // GIR_Coverage, 4577,
     /* 138229 */   GIR_EraseRootFromParent_Done,
     /* 138230 */ // Label 2400: @138230
     /* 138230 */ GIM_Try, /*On fail goto*//*Label 2401*/ GIMT_Encode4(138305), // Rule ID 6497 //
     /* 138235 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138238 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138242 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138246 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138250 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138254 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138258 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138263 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138267 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138271 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138275 */   // MIs[2] Operand 1
     /* 138275 */   // No operand predicates
     /* 138275 */   // MIs[0] Rn
     /* 138275 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138283 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138285 */   // (st (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138285 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138288 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138292 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138295 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138297 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138303 */   GIR_RootConstrainSelectedInstOperands,
     /* 138304 */   // GIR_Coverage, 6497,
     /* 138304 */   GIR_EraseRootFromParent_Done,
     /* 138305 */ // Label 2401: @138305
     /* 138305 */ GIM_Try, /*On fail goto*//*Label 2402*/ GIMT_Encode4(138380), // Rule ID 6498 //
     /* 138310 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138313 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138317 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 138321 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 138325 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 138329 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 138333 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 138338 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 138342 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 138346 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 138350 */   // MIs[2] Operand 1
     /* 138350 */   // No operand predicates
     /* 138350 */   // MIs[0] Rn
     /* 138350 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 138354 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 138358 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 138360 */   // (st (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1i64 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 138360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1i64),
     /* 138363 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 138367 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 138370 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 138372 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 138378 */   GIR_RootConstrainSelectedInstOperands,
     /* 138379 */   // GIR_Coverage, 6498,
     /* 138379 */   GIR_EraseRootFromParent_Done,
     /* 138380 */ // Label 2402: @138380
     /* 138380 */ GIM_Try, /*On fail goto*//*Label 2403*/ GIMT_Encode4(138433), // Rule ID 301 //
     /* 138385 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138388 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138396 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138400 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138407 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroW GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 138410 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138412 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138417 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138422 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138427 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138431 */   GIR_RootConstrainSelectedInstOperands,
     /* 138432 */   // GIR_Coverage, 301,
     /* 138432 */   GIR_EraseRootFromParent_Done,
     /* 138433 */ // Label 2403: @138433
     /* 138433 */ GIM_Try, /*On fail goto*//*Label 2404*/ GIMT_Encode4(138486), // Rule ID 302 //
     /* 138438 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138441 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138449 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138453 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138460 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXroX GPR64:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138460 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 138463 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138465 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138470 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138475 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138480 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138484 */   GIR_RootConstrainSelectedInstOperands,
     /* 138485 */   // GIR_Coverage, 302,
     /* 138485 */   GIR_EraseRootFromParent_Done,
     /* 138486 */ // Label 2404: @138486
     /* 138486 */ GIM_Try, /*On fail goto*//*Label 2405*/ GIMT_Encode4(138542), // Rule ID 309 //
     /* 138491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138494 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138497 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138505 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138509 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 138516 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 138516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 138519 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138521 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138526 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138531 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138536 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138540 */   GIR_RootConstrainSelectedInstOperands,
     /* 138541 */   // GIR_Coverage, 309,
     /* 138541 */   GIR_EraseRootFromParent_Done,
     /* 138542 */ // Label 2405: @138542
     /* 138542 */ GIM_Try, /*On fail goto*//*Label 2406*/ GIMT_Encode4(138598), // Rule ID 310 //
     /* 138547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 138550 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138557 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 138561 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138565 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 138572 */   // (st FPR64Op:{ *:[f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 138572 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 138575 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 138577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138592 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138596 */   GIR_RootConstrainSelectedInstOperands,
     /* 138597 */   // GIR_Coverage, 310,
     /* 138597 */   GIR_EraseRootFromParent_Done,
     /* 138598 */ // Label 2406: @138598
     /* 138598 */ GIM_Try, /*On fail goto*//*Label 2407*/ GIMT_Encode4(138687), // Rule ID 4481 //
     /* 138603 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138606 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138610 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138621 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138625 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 138632 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend)
     /* 138632 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138635 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138639 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138644 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138650 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138655 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138660 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroW),
     /* 138663 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138666 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138671 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138676 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138681 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138685 */   GIR_RootConstrainSelectedInstOperands,
     /* 138686 */   // GIR_Coverage, 4481,
     /* 138686 */   GIR_EraseRootFromParent_Done,
     /* 138687 */ // Label 2407: @138687
     /* 138687 */ GIM_Try, /*On fail goto*//*Label 2408*/ GIMT_Encode4(138776), // Rule ID 4482 //
     /* 138692 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138695 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138699 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 138706 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138710 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138714 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 138721 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend)
     /* 138721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138733 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138739 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138744 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBroX),
     /* 138752 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138755 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138760 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138765 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138770 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138774 */   GIR_RootConstrainSelectedInstOperands,
     /* 138775 */   // GIR_Coverage, 4482,
     /* 138775 */   GIR_EraseRootFromParent_Done,
     /* 138776 */ // Label 2408: @138776
     /* 138776 */ GIM_Try, /*On fail goto*//*Label 2409*/ GIMT_Encode4(138865), // Rule ID 4483 //
     /* 138781 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138784 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138788 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138795 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138799 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138803 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 138810 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend)
     /* 138810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138822 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138828 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138833 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroW),
     /* 138841 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138844 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138849 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138854 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138859 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138863 */   GIR_RootConstrainSelectedInstOperands,
     /* 138864 */   // GIR_Coverage, 4483,
     /* 138864 */   GIR_EraseRootFromParent_Done,
     /* 138865 */ // Label 2409: @138865
     /* 138865 */ GIM_Try, /*On fail goto*//*Label 2410*/ GIMT_Encode4(138954), // Rule ID 4484 //
     /* 138870 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138873 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138877 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 138884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138888 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138892 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 138899 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend)
     /* 138899 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138902 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138906 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 138911 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 138917 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 138922 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138927 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHroX),
     /* 138930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 138933 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 138938 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 138943 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 138948 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 138952 */   GIR_RootConstrainSelectedInstOperands,
     /* 138953 */   // GIR_Coverage, 4484,
     /* 138953 */   GIR_EraseRootFromParent_Done,
     /* 138954 */ // Label 2410: @138954
     /* 138954 */ GIM_Try, /*On fail goto*//*Label 2411*/ GIMT_Encode4(139043), // Rule ID 4485 //
     /* 138959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 138962 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 138966 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 138973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 138977 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 138981 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 138988 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroW (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend)
     /* 138988 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 138991 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 138995 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139000 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroW),
     /* 139019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139022 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139027 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139032 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139037 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139041 */   GIR_RootConstrainSelectedInstOperands,
     /* 139042 */   // GIR_Coverage, 4485,
     /* 139042 */   GIR_EraseRootFromParent_Done,
     /* 139043 */ // Label 2411: @139043
     /* 139043 */ GIM_Try, /*On fail goto*//*Label 2412*/ GIMT_Encode4(139132), // Rule ID 4486 //
     /* 139048 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139051 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139055 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139066 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139070 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 139077 */   // (st GPR64:{ *:[i64] }:$Rt, (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWroX (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend)
     /* 139077 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139080 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139084 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139089 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139095 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139100 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139105 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWroX),
     /* 139108 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139111 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139116 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139121 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139126 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139130 */   GIR_RootConstrainSelectedInstOperands,
     /* 139131 */   // GIR_Coverage, 4486,
     /* 139131 */   GIR_EraseRootFromParent_Done,
     /* 139132 */ // Label 2412: @139132
     /* 139132 */ GIM_Try, /*On fail goto*//*Label 2413*/ GIMT_Encode4(139185), // Rule ID 4497 //
     /* 139137 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139140 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139148 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139152 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139159 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139159 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139162 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139164 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139169 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139174 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139179 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139183 */   GIR_RootConstrainSelectedInstOperands,
     /* 139184 */   // GIR_Coverage, 4497,
     /* 139184 */   GIR_EraseRootFromParent_Done,
     /* 139185 */ // Label 2413: @139185
     /* 139185 */ GIM_Try, /*On fail goto*//*Label 2414*/ GIMT_Encode4(139238), // Rule ID 4498 //
     /* 139190 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139193 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139201 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139205 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139212 */   // (st FPR64:{ *:[v1i64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139215 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139217 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139222 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139227 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139232 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139236 */   GIR_RootConstrainSelectedInstOperands,
     /* 139237 */   // GIR_Coverage, 4498,
     /* 139237 */   GIR_EraseRootFromParent_Done,
     /* 139238 */ // Label 2414: @139238
     /* 139238 */ GIM_Try, /*On fail goto*//*Label 2415*/ GIMT_Encode4(139291), // Rule ID 4499 //
     /* 139243 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139246 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139254 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139258 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139265 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139265 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139268 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139270 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139275 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139285 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139289 */   GIR_RootConstrainSelectedInstOperands,
     /* 139290 */   // GIR_Coverage, 4499,
     /* 139290 */   GIR_EraseRootFromParent_Done,
     /* 139291 */ // Label 2415: @139291
     /* 139291 */ GIM_Try, /*On fail goto*//*Label 2416*/ GIMT_Encode4(139344), // Rule ID 4500 //
     /* 139296 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139299 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139307 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139311 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139318 */   // (st FPR64:{ *:[v1f64] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139321 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139323 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139328 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139333 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139338 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139342 */   GIR_RootConstrainSelectedInstOperands,
     /* 139343 */   // GIR_Coverage, 4500,
     /* 139343 */   GIR_EraseRootFromParent_Done,
     /* 139344 */ // Label 2416: @139344
     /* 139344 */ GIM_Try, /*On fail goto*//*Label 2417*/ GIMT_Encode4(139396), // Rule ID 311 //
     /* 139349 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139352 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139360 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139364 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139371 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRXui GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139371 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 139374 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 139380 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139385 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139390 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139394 */   GIR_RootConstrainSelectedInstOperands,
     /* 139395 */   // GIR_Coverage, 311,
     /* 139395 */   GIR_EraseRootFromParent_Done,
     /* 139396 */ // Label 2417: @139396
     /* 139396 */ GIM_Try, /*On fail goto*//*Label 2418*/ GIMT_Encode4(139447), // Rule ID 316 //
     /* 139401 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 139404 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139407 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139415 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139419 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139426 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139426 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139429 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139431 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139436 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139441 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139445 */   GIR_RootConstrainSelectedInstOperands,
     /* 139446 */   // GIR_Coverage, 316,
     /* 139446 */   GIR_EraseRootFromParent_Done,
     /* 139447 */ // Label 2418: @139447
     /* 139447 */ GIM_Try, /*On fail goto*//*Label 2419*/ GIMT_Encode4(139495), // Rule ID 4527 //
     /* 139452 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139455 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139463 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139467 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139474 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139474 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139477 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139479 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139484 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139489 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139493 */   GIR_RootConstrainSelectedInstOperands,
     /* 139494 */   // GIR_Coverage, 4527,
     /* 139494 */   GIR_EraseRootFromParent_Done,
     /* 139495 */ // Label 2419: @139495
     /* 139495 */ GIM_Try, /*On fail goto*//*Label 2420*/ GIMT_Encode4(139543), // Rule ID 4528 //
     /* 139500 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139503 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139511 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139515 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 139522 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 139522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 139525 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 139527 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139532 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139541 */   GIR_RootConstrainSelectedInstOperands,
     /* 139542 */   // GIR_Coverage, 4528,
     /* 139542 */   GIR_EraseRootFromParent_Done,
     /* 139543 */ // Label 2420: @139543
     /* 139543 */ GIM_Try, /*On fail goto*//*Label 2421*/ GIMT_Encode4(139627), // Rule ID 4542 //
     /* 139548 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139551 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139555 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 139562 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139566 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139570 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 139577 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STRWui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 139577 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139580 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139584 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139589 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139595 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139600 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRWui),
     /* 139608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139611 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139616 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139621 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139625 */   GIR_RootConstrainSelectedInstOperands,
     /* 139626 */   // GIR_Coverage, 4542,
     /* 139626 */   GIR_EraseRootFromParent_Done,
     /* 139627 */ // Label 2421: @139627
     /* 139627 */ GIM_Try, /*On fail goto*//*Label 2422*/ GIMT_Encode4(139711), // Rule ID 4543 //
     /* 139632 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139635 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139639 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 139646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139650 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139654 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 139661 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STRHHui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset)
     /* 139661 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139664 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139668 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139673 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139679 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139684 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139689 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRHHui),
     /* 139692 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139695 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139700 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139705 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139709 */   GIR_RootConstrainSelectedInstOperands,
     /* 139710 */   // GIR_Coverage, 4543,
     /* 139710 */   GIR_EraseRootFromParent_Done,
     /* 139711 */ // Label 2422: @139711
     /* 139711 */ GIM_Try, /*On fail goto*//*Label 2423*/ GIMT_Encode4(139795), // Rule ID 4544 //
     /* 139716 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 139719 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 139723 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 139730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139734 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139738 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 139745 */   // (st GPR64:{ *:[i64] }:$Rt, (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STRBBui (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset)
     /* 139745 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 139748 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 139752 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 139757 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 139763 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 139768 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139773 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRBBui),
     /* 139776 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 139779 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139784 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 139789 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 139793 */   GIR_RootConstrainSelectedInstOperands,
     /* 139794 */   // GIR_Coverage, 4544,
     /* 139794 */   GIR_EraseRootFromParent_Done,
     /* 139795 */ // Label 2423: @139795
     /* 139795 */ GIM_Try, /*On fail goto*//*Label 2424*/ GIMT_Encode4(139872), // Rule ID 7130 //
     /* 139800 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139810 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139813 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139817 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139821 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139825 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139830 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139834 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139836 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139843 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRDroW FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139843 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 139846 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139850 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139855 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139860 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139865 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139870 */   GIR_RootConstrainSelectedInstOperands,
     /* 139871 */   // GIR_Coverage, 7130,
     /* 139871 */   GIR_EraseRootFromParent_Done,
     /* 139872 */ // Label 2424: @139872
     /* 139872 */ GIM_Try, /*On fail goto*//*Label 2425*/ GIMT_Encode4(139949), // Rule ID 7131 //
     /* 139877 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139880 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139887 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139890 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 139894 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 139898 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 139902 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 139907 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139911 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 139913 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 139920 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRDroX FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 139920 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 139923 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 139927 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139932 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139937 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 139942 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 139947 */   GIR_RootConstrainSelectedInstOperands,
     /* 139948 */   // GIR_Coverage, 7131,
     /* 139948 */   GIR_EraseRootFromParent_Done,
     /* 139949 */ // Label 2425: @139949
     /* 139949 */ GIM_Try, /*On fail goto*//*Label 2426*/ GIMT_Encode4(140008), // Rule ID 7122 //
     /* 139954 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 139957 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 139964 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 139967 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 139971 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 139975 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 139982 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRXroW GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 139982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroW),
     /* 139985 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 139987 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 139992 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 139997 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140002 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140006 */   GIR_RootConstrainSelectedInstOperands,
     /* 140007 */   // GIR_Coverage, 7122,
     /* 140007 */   GIR_EraseRootFromParent_Done,
     /* 140008 */ // Label 2426: @140008
     /* 140008 */ GIM_Try, /*On fail goto*//*Label 2427*/ GIMT_Encode4(140067), // Rule ID 7123 //
     /* 140013 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140016 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140023 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140030 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140034 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 140041 */   // (atomic_store GPR64:{ *:[i64] }:$val, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRXroX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 140041 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXroX),
     /* 140044 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140046 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140051 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 140056 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 140061 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140065 */   GIR_RootConstrainSelectedInstOperands,
     /* 140066 */   // GIR_Coverage, 7123,
     /* 140066 */   GIR_EraseRootFromParent_Done,
     /* 140067 */ // Label 2427: @140067
     /* 140067 */ GIM_Try, /*On fail goto*//*Label 2428*/ GIMT_Encode4(140139), // Rule ID 7132 //
     /* 140072 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140075 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140082 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140085 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140089 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140093 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140097 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140102 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140106 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140108 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140115 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRDui FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset)
     /* 140115 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 140118 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140122 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140127 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140132 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140137 */   GIR_RootConstrainSelectedInstOperands,
     /* 140138 */   // GIR_Coverage, 7132,
     /* 140138 */   GIR_EraseRootFromParent_Done,
     /* 140139 */ // Label 2428: @140139
     /* 140139 */ GIM_Try, /*On fail goto*//*Label 2429*/ GIMT_Encode4(140211), // Rule ID 7133 //
     /* 140144 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140147 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140154 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140157 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140161 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140165 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140169 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140174 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 140180 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140187 */   // (atomic_store (bitconvert:{ *:[i64] } FPR64Op:{ *:[f64] }:$val), (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STURDi FPR64Op:{ *:[f64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140187 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140190 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 140194 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140199 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140204 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 140209 */   GIR_RootConstrainSelectedInstOperands,
     /* 140210 */   // GIR_Coverage, 7133,
     /* 140210 */   GIR_EraseRootFromParent_Done,
     /* 140211 */ // Label 2429: @140211
     /* 140211 */ GIM_Try, /*On fail goto*//*Label 2430*/ GIMT_Encode4(140308), // Rule ID 7474 //
     /* 140216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140219 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140222 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140229 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140232 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140236 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 140240 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 140244 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 140248 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140252 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140256 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 140260 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140265 */   GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 140269 */   GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140273 */   GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140277 */   // MIs[3] Operand 1
     /* 140277 */   // No operand predicates
     /* 140277 */   // MIs[0] Rn
     /* 140277 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140285 */   GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 140287 */   // (atomic_store (bitconvert:{ *:[i64] } (vector_extract:{ *:[f64] } VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15894>>  =>  (STL1 VecListOne128:{ *:[v2f64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140290 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Vt
     /* 140294 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 140297 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 140299 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 140306 */   GIR_RootConstrainSelectedInstOperands,
     /* 140307 */   // GIR_Coverage, 7474,
     /* 140307 */   GIR_EraseRootFromParent_Done,
     /* 140308 */ // Label 2430: @140308
     /* 140308 */ GIM_Try, /*On fail goto*//*Label 2431*/ GIMT_Encode4(140360), // Rule ID 319 //
     /* 140313 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140316 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140324 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140328 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140335 */   // (st GPR64z:{ *:[i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURXi GPR64z:{ *:[i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140335 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140338 */   GIR_CopyOrAddZeroReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, GIMT_Encode2(AArch64::XZR), // Rt
     /* 140344 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140349 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140354 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140358 */   GIR_RootConstrainSelectedInstOperands,
     /* 140359 */   // GIR_Coverage, 319,
     /* 140359 */   GIR_EraseRootFromParent_Done,
     /* 140360 */ // Label 2431: @140360
     /* 140360 */ GIM_Try, /*On fail goto*//*Label 2432*/ GIMT_Encode4(140411), // Rule ID 324 //
     /* 140365 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 140368 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140371 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140379 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140383 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140390 */   // (st FPR64Op:{ *:[f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64Op:{ *:[f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 140390 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140393 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140395 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140400 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140405 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140409 */   GIR_RootConstrainSelectedInstOperands,
     /* 140410 */   // GIR_Coverage, 324,
     /* 140410 */   GIR_EraseRootFromParent_Done,
     /* 140411 */ // Label 2432: @140411
     /* 140411 */ GIM_Try, /*On fail goto*//*Label 2433*/ GIMT_Encode4(140465), // Rule ID 7124 //
     /* 140416 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140419 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140426 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140433 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140437 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 140444 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STRXui GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 140444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRXui),
     /* 140447 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140449 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140454 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140459 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140463 */   GIR_RootConstrainSelectedInstOperands,
     /* 140464 */   // GIR_Coverage, 7124,
     /* 140464 */   GIR_EraseRootFromParent_Done,
     /* 140465 */ // Label 2433: @140465
     /* 140465 */ GIM_Try, /*On fail goto*//*Label 2434*/ GIMT_Encode4(140519), // Rule ID 7125 //
     /* 140470 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140473 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140480 */   GIM_CheckAtomicOrderingWeakerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140483 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140487 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140491 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140498 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15896>>  =>  (STURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140498 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURXi),
     /* 140501 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140503 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140508 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140513 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140517 */   GIR_RootConstrainSelectedInstOperands,
     /* 140518 */   // GIR_Coverage, 7125,
     /* 140518 */   GIR_EraseRootFromParent_Done,
     /* 140519 */ // Label 2434: @140519
     /* 140519 */ GIM_Try, /*On fail goto*//*Label 2435*/ GIMT_Encode4(140576), // Rule ID 7485 //
     /* 140524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRCPC_IMMO),
     /* 140527 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140530 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140537 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140544 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140548 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140555 */   // (atomic_store GPR64:{ *:[i64] }:$val, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15894>>  =>  (STLURXi GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLURXi),
     /* 140558 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 140560 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140565 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140570 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140574 */   GIR_RootConstrainSelectedInstOperands,
     /* 140575 */   // GIR_Coverage, 7485,
     /* 140575 */   GIR_EraseRootFromParent_Done,
     /* 140576 */ // Label 2435: @140576
     /* 140576 */ GIM_Try, /*On fail goto*//*Label 2436*/ GIMT_Encode4(140624), // Rule ID 4551 //
     /* 140581 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140584 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140592 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140596 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140603 */   // (st FPR64:{ *:[v1f64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140603 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140606 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140608 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140613 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140622 */   GIR_RootConstrainSelectedInstOperands,
     /* 140623 */   // GIR_Coverage, 4551,
     /* 140623 */   GIR_EraseRootFromParent_Done,
     /* 140624 */ // Label 2436: @140624
     /* 140624 */ GIM_Try, /*On fail goto*//*Label 2437*/ GIMT_Encode4(140672), // Rule ID 4552 //
     /* 140629 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140632 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 140640 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140644 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 140651 */   // (st FPR64:{ *:[v1i64] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v1i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140651 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 140654 */   GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 140656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140661 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140666 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140670 */   GIR_RootConstrainSelectedInstOperands,
     /* 140671 */   // GIR_Coverage, 4552,
     /* 140671 */   GIR_EraseRootFromParent_Done,
     /* 140672 */ // Label 2437: @140672
     /* 140672 */ GIM_Try, /*On fail goto*//*Label 2438*/ GIMT_Encode4(140756), // Rule ID 4567 //
     /* 140677 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140680 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140684 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 140691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140695 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140699 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 140706 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>>  =>  (STURWi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140706 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140709 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140713 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140718 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140724 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140729 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140734 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURWi),
     /* 140737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140740 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140745 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140750 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140754 */   GIR_RootConstrainSelectedInstOperands,
     /* 140755 */   // GIR_Coverage, 4567,
     /* 140755 */   GIR_EraseRootFromParent_Done,
     /* 140756 */ // Label 2438: @140756
     /* 140756 */ GIM_Try, /*On fail goto*//*Label 2439*/ GIMT_Encode4(140840), // Rule ID 4568 //
     /* 140761 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140764 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 140775 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140779 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140783 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 140790 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>>  =>  (STURHHi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140790 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140793 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140797 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140802 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140808 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140813 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140818 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURHHi),
     /* 140821 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140834 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140838 */   GIR_RootConstrainSelectedInstOperands,
     /* 140839 */   // GIR_Coverage, 4568,
     /* 140839 */   GIR_EraseRootFromParent_Done,
     /* 140840 */ // Label 2439: @140840
     /* 140840 */ GIM_Try, /*On fail goto*//*Label 2440*/ GIMT_Encode4(140924), // Rule ID 4569 //
     /* 140845 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 140848 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 140852 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 140859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140863 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 140867 */   GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 140874 */   // (st GPR64:{ *:[i64] }:$Rt, (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>>  =>  (STURBBi (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rt, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 140874 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 140877 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 140881 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 140886 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/0, /*SubRegIdx*/GIMT_Encode2(20), // Rt
     /* 140892 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 140897 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 140902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURBBi),
     /* 140905 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 140908 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 140913 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 140918 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 140922 */   GIR_RootConstrainSelectedInstOperands,
     /* 140923 */   // GIR_Coverage, 4569,
     /* 140923 */   GIR_EraseRootFromParent_Done,
     /* 140924 */ // Label 2440: @140924
     /* 140924 */ GIM_Try, /*On fail goto*//*Label 2441*/ GIMT_Encode4(141008), // Rule ID 7473 //
     /* 140929 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 140932 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 140935 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 140942 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 140945 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 140949 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 140953 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 140957 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 140961 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 140966 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 140970 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 140974 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 140978 */   // MIs[2] Operand 1
     /* 140978 */   // No operand predicates
     /* 140978 */   // MIs[0] Rn
     /* 140978 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 140982 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 140986 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 140988 */   // (atomic_store (vector_extract:{ *:[i64] } VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15894>>  =>  (STL1 VecListOne128:{ *:[v2i64] }:$Vt, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 140988 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 140991 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 140995 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 140998 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141000 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 141006 */   GIR_RootConstrainSelectedInstOperands,
     /* 141007 */   // GIR_Coverage, 7473,
     /* 141007 */   GIR_EraseRootFromParent_Done,
     /* 141008 */ // Label 2441: @141008
     /* 141008 */ GIM_Try, /*On fail goto*//*Label 2442*/ GIMT_Encode4(141106), // Rule ID 7475 //
     /* 141013 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 141016 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141019 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141026 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141029 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/0, // MIs[1]
     /* 141033 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 141037 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 141041 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141046 */   // MIs[0] Rn
     /* 141046 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141050 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141054 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 141056 */   // (atomic_store (bitconvert:{ *:[i64] } VecListOne64:{ *:[v1f64] }:$Vt), GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15894>>  =>  (STL1 (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, VecListOne64:{ *:[v1f64] }:$Vt, dsub:{ *:[i32] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn)
     /* 141056 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 141059 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 141063 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 141068 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 141071 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Vt
     /* 141075 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 141078 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141083 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141088 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STL1),
     /* 141091 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 141094 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 141097 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 141099 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 141104 */   GIR_RootConstrainSelectedInstOperands,
     /* 141105 */   // GIR_Coverage, 7475,
     /* 141105 */   GIR_EraseRootFromParent_Done,
     /* 141106 */ // Label 2442: @141106
     /* 141106 */ GIM_Try, /*On fail goto*//*Label 2443*/ GIMT_Encode4(141143), // Rule ID 7121 //
     /* 141111 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 141114 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 141121 */   GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 141124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 141128 */   // MIs[0] ptr
     /* 141128 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141136 */   // (atomic_store GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)<<P:Predicate_atomic_store_64>><<P:Predicate_anonymous_15894>>  =>  (STLRX GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$ptr)
     /* 141136 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::STLRX),
     /* 141141 */   GIR_RootConstrainSelectedInstOperands,
     /* 141142 */   // GIR_Coverage, 7121,
     /* 141142 */   GIR_Done,
     /* 141143 */ // Label 2443: @141143
     /* 141143 */ GIM_Try, /*On fail goto*//*Label 2444*/ GIMT_Encode4(141170), // Rule ID 6445 //
     /* 141148 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141151 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141155 */   // MIs[0] Rn
     /* 141155 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141159 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141163 */   // (st v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev1d v1i64:{ *:[v1i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141163 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev1d),
     /* 141168 */   GIR_RootConstrainSelectedInstOperands,
     /* 141169 */   // GIR_Coverage, 6445,
     /* 141169 */   GIR_Done,
     /* 141170 */ // Label 2444: @141170
     /* 141170 */ GIM_Reject,
     /* 141171 */ // Label 2292: @141171
     /* 141171 */ GIM_Try, /*On fail goto*//*Label 2445*/ GIMT_Encode4(141376),
     /* 141176 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141179 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141187 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141191 */   GIM_Try, /*On fail goto*//*Label 2446*/ GIMT_Encode4(141232), // Rule ID 4479 //
     /* 141196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141199 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141206 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141209 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141211 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141216 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141221 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141226 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141230 */     GIR_RootConstrainSelectedInstOperands,
     /* 141231 */     // GIR_Coverage, 4479,
     /* 141231 */     GIR_EraseRootFromParent_Done,
     /* 141232 */   // Label 2446: @141232
     /* 141232 */   GIM_Try, /*On fail goto*//*Label 2447*/ GIMT_Encode4(141273), // Rule ID 4480 //
     /* 141237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_UseSTRQro),
     /* 141240 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141247 */     // (st FPR128:{ *:[f128] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141250 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141271 */     GIR_RootConstrainSelectedInstOperands,
     /* 141272 */     // GIR_Coverage, 4480,
     /* 141272 */     GIR_EraseRootFromParent_Done,
     /* 141273 */   // Label 2447: @141273
     /* 141273 */   GIM_Try, /*On fail goto*//*Label 2448*/ GIMT_Encode4(141306), // Rule ID 4534 //
     /* 141278 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 141285 */     // (st FPR128:{ *:[f128] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 141285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 141288 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141295 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141300 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141304 */     GIR_RootConstrainSelectedInstOperands,
     /* 141305 */     // GIR_Coverage, 4534,
     /* 141305 */     GIR_EraseRootFromParent_Done,
     /* 141306 */   // Label 2448: @141306
     /* 141306 */   GIM_Try, /*On fail goto*//*Label 2449*/ GIMT_Encode4(141339), // Rule ID 4558 //
     /* 141311 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141318 */     // (st FPR128:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141321 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141333 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141337 */     GIR_RootConstrainSelectedInstOperands,
     /* 141338 */     // GIR_Coverage, 4558,
     /* 141338 */     GIR_EraseRootFromParent_Done,
     /* 141339 */   // Label 2449: @141339
     /* 141339 */   GIM_Try, /*On fail goto*//*Label 2450*/ GIMT_Encode4(141375), // Rule ID 325 //
     /* 141344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 141347 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 141354 */     // (st FPR128Op:{ *:[f128] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128Op:{ *:[f128] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 141354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 141357 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141373 */     GIR_RootConstrainSelectedInstOperands,
     /* 141374 */     // GIR_Coverage, 325,
     /* 141374 */     GIR_EraseRootFromParent_Done,
     /* 141375 */   // Label 2450: @141375
     /* 141375 */   GIM_Reject,
     /* 141376 */ // Label 2445: @141376
     /* 141376 */ GIM_Reject,
     /* 141377 */ // Label 2293: @141377
     /* 141377 */ GIM_Try, /*On fail goto*//*Label 2451*/ GIMT_Encode4(141782),
     /* 141382 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141385 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141389 */   GIM_Try, /*On fail goto*//*Label 2452*/ GIMT_Encode4(141438), // Rule ID 4487 //
     /* 141394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141405 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141412 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141415 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141417 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141422 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141427 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141432 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141436 */     GIR_RootConstrainSelectedInstOperands,
     /* 141437 */     // GIR_Coverage, 4487,
     /* 141437 */     GIR_EraseRootFromParent_Done,
     /* 141438 */   // Label 2452: @141438
     /* 141438 */   GIM_Try, /*On fail goto*//*Label 2453*/ GIMT_Encode4(141487), // Rule ID 4488 //
     /* 141443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141450 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141454 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141461 */     // (st FPR64:{ *:[v2i32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141464 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141481 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141485 */     GIR_RootConstrainSelectedInstOperands,
     /* 141486 */     // GIR_Coverage, 4488,
     /* 141486 */     GIR_EraseRootFromParent_Done,
     /* 141487 */   // Label 2453: @141487
     /* 141487 */   GIM_Try, /*On fail goto*//*Label 2454*/ GIMT_Encode4(141536), // Rule ID 4489 //
     /* 141492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141499 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141503 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 141510 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 141510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 141513 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141525 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141534 */     GIR_RootConstrainSelectedInstOperands,
     /* 141535 */     // GIR_Coverage, 4489,
     /* 141535 */     GIR_EraseRootFromParent_Done,
     /* 141536 */   // Label 2454: @141536
     /* 141536 */   GIM_Try, /*On fail goto*//*Label 2455*/ GIMT_Encode4(141585), // Rule ID 4490 //
     /* 141541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141552 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 141559 */     // (st FPR64:{ *:[v2f32] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 141559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 141562 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141579 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141583 */     GIR_RootConstrainSelectedInstOperands,
     /* 141584 */     // GIR_Coverage, 4490,
     /* 141584 */     GIR_EraseRootFromParent_Done,
     /* 141585 */   // Label 2455: @141585
     /* 141585 */   GIM_Try, /*On fail goto*//*Label 2456*/ GIMT_Encode4(141629), // Rule ID 4529 //
     /* 141590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141597 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141601 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141608 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141611 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141627 */     GIR_RootConstrainSelectedInstOperands,
     /* 141628 */     // GIR_Coverage, 4529,
     /* 141628 */     GIR_EraseRootFromParent_Done,
     /* 141629 */   // Label 2456: @141629
     /* 141629 */   GIM_Try, /*On fail goto*//*Label 2457*/ GIMT_Encode4(141673), // Rule ID 4532 //
     /* 141634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141641 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141645 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 141652 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 141652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 141655 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141657 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141662 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141671 */     GIR_RootConstrainSelectedInstOperands,
     /* 141672 */     // GIR_Coverage, 4532,
     /* 141672 */     GIR_EraseRootFromParent_Done,
     /* 141673 */   // Label 2457: @141673
     /* 141673 */   GIM_Try, /*On fail goto*//*Label 2458*/ GIMT_Encode4(141717), // Rule ID 4553 //
     /* 141678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141689 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141696 */     // (st FPR64:{ *:[v2f32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141699 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141701 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141706 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141715 */     GIR_RootConstrainSelectedInstOperands,
     /* 141716 */     // GIR_Coverage, 4553,
     /* 141716 */     GIR_EraseRootFromParent_Done,
     /* 141717 */   // Label 2458: @141717
     /* 141717 */   GIM_Try, /*On fail goto*//*Label 2459*/ GIMT_Encode4(141761), // Rule ID 4556 //
     /* 141722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 141729 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141733 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 141740 */     // (st FPR64:{ *:[v2i32] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v2i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 141740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 141743 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141745 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141750 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 141755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141759 */     GIR_RootConstrainSelectedInstOperands,
     /* 141760 */     // GIR_Coverage, 4556,
     /* 141760 */     GIR_EraseRootFromParent_Done,
     /* 141761 */   // Label 2459: @141761
     /* 141761 */   GIM_Try, /*On fail goto*//*Label 2460*/ GIMT_Encode4(141781), // Rule ID 6444 //
     /* 141766 */     // MIs[0] Rn
     /* 141766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 141770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 141774 */     // (st v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2s v2i32:{ *:[v2i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 141774 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2s),
     /* 141779 */     GIR_RootConstrainSelectedInstOperands,
     /* 141780 */     // GIR_Coverage, 6444,
     /* 141780 */     GIR_Done,
     /* 141781 */   // Label 2460: @141781
     /* 141781 */   GIM_Reject,
     /* 141782 */ // Label 2451: @141782
     /* 141782 */ GIM_Reject,
     /* 141783 */ // Label 2294: @141783
     /* 141783 */ GIM_Try, /*On fail goto*//*Label 2461*/ GIMT_Encode4(142232),
     /* 141788 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 141791 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 141795 */   GIM_Try, /*On fail goto*//*Label 2462*/ GIMT_Encode4(141844), // Rule ID 4501 //
     /* 141800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141811 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141818 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141821 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141842 */     GIR_RootConstrainSelectedInstOperands,
     /* 141843 */     // GIR_Coverage, 4501,
     /* 141843 */     GIR_EraseRootFromParent_Done,
     /* 141844 */   // Label 2462: @141844
     /* 141844 */   GIM_Try, /*On fail goto*//*Label 2463*/ GIMT_Encode4(141893), // Rule ID 4502 //
     /* 141849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141856 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141860 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141867 */     // (st FPR128:{ *:[v2i64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141870 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141872 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141877 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141882 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141887 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141891 */     GIR_RootConstrainSelectedInstOperands,
     /* 141892 */     // GIR_Coverage, 4502,
     /* 141892 */     GIR_EraseRootFromParent_Done,
     /* 141893 */   // Label 2463: @141893
     /* 141893 */   GIM_Try, /*On fail goto*//*Label 2464*/ GIMT_Encode4(141942), // Rule ID 4503 //
     /* 141898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141905 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141909 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 141916 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 141916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 141919 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141936 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141940 */     GIR_RootConstrainSelectedInstOperands,
     /* 141941 */     // GIR_Coverage, 4503,
     /* 141941 */     GIR_EraseRootFromParent_Done,
     /* 141942 */   // Label 2464: @141942
     /* 141942 */   GIM_Try, /*On fail goto*//*Label 2465*/ GIMT_Encode4(141991), // Rule ID 4504 //
     /* 141947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 141950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 141954 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 141958 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 141965 */     // (st FPR128:{ *:[v2f64] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 141965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 141968 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 141970 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 141975 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 141980 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 141985 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 141989 */     GIR_RootConstrainSelectedInstOperands,
     /* 141990 */     // GIR_Coverage, 4504,
     /* 141990 */     GIR_EraseRootFromParent_Done,
     /* 141991 */   // Label 2465: @141991
     /* 141991 */   GIM_Try, /*On fail goto*//*Label 2466*/ GIMT_Encode4(142035), // Rule ID 4536 //
     /* 141996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 141999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142003 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142007 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142014 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142017 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142019 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142029 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142033 */     GIR_RootConstrainSelectedInstOperands,
     /* 142034 */     // GIR_Coverage, 4536,
     /* 142034 */     GIR_EraseRootFromParent_Done,
     /* 142035 */   // Label 2466: @142035
     /* 142035 */   GIM_Try, /*On fail goto*//*Label 2467*/ GIMT_Encode4(142079), // Rule ID 4540 //
     /* 142040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142051 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142058 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142061 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142073 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142077 */     GIR_RootConstrainSelectedInstOperands,
     /* 142078 */     // GIR_Coverage, 4540,
     /* 142078 */     GIR_EraseRootFromParent_Done,
     /* 142079 */   // Label 2467: @142079
     /* 142079 */   GIM_Try, /*On fail goto*//*Label 2468*/ GIMT_Encode4(142123), // Rule ID 4560 //
     /* 142084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142095 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142102 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142105 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142121 */     GIR_RootConstrainSelectedInstOperands,
     /* 142122 */     // GIR_Coverage, 4560,
     /* 142122 */     GIR_EraseRootFromParent_Done,
     /* 142123 */   // Label 2468: @142123
     /* 142123 */   GIM_Try, /*On fail goto*//*Label 2469*/ GIMT_Encode4(142167), // Rule ID 4564 //
     /* 142128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142135 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142139 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142146 */     // (st FPR128:{ *:[v2i64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2i64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142149 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142161 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142165 */     GIR_RootConstrainSelectedInstOperands,
     /* 142166 */     // GIR_Coverage, 4564,
     /* 142166 */     GIR_EraseRootFromParent_Done,
     /* 142167 */   // Label 2469: @142167
     /* 142167 */   GIM_Try, /*On fail goto*//*Label 2470*/ GIMT_Encode4(142211), // Rule ID 4565 //
     /* 142172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142179 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142183 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142190 */     // (st FPR128:{ *:[v2f64] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v2f64] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142193 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142195 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142205 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142209 */     GIR_RootConstrainSelectedInstOperands,
     /* 142210 */     // GIR_Coverage, 4565,
     /* 142210 */     GIR_EraseRootFromParent_Done,
     /* 142211 */   // Label 2470: @142211
     /* 142211 */   GIM_Try, /*On fail goto*//*Label 2471*/ GIMT_Encode4(142231), // Rule ID 6441 //
     /* 142216 */     // MIs[0] Rn
     /* 142216 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142220 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142224 */     // (st v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev2d v2i64:{ *:[v2i64] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142224 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev2d),
     /* 142229 */     GIR_RootConstrainSelectedInstOperands,
     /* 142230 */     // GIR_Coverage, 6441,
     /* 142230 */     GIR_Done,
     /* 142231 */   // Label 2471: @142231
     /* 142231 */   GIM_Reject,
     /* 142232 */ // Label 2461: @142232
     /* 142232 */ GIM_Reject,
     /* 142233 */ // Label 2295: @142233
     /* 142233 */ GIM_Try, /*On fail goto*//*Label 2472*/ GIMT_Encode4(142638),
     /* 142238 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142241 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142245 */   GIM_Try, /*On fail goto*//*Label 2473*/ GIMT_Encode4(142294), // Rule ID 4491 //
     /* 142250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142257 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142261 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142268 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142271 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142273 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142278 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142283 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142292 */     GIR_RootConstrainSelectedInstOperands,
     /* 142293 */     // GIR_Coverage, 4491,
     /* 142293 */     GIR_EraseRootFromParent_Done,
     /* 142294 */   // Label 2473: @142294
     /* 142294 */   GIM_Try, /*On fail goto*//*Label 2474*/ GIMT_Encode4(142343), // Rule ID 4492 //
     /* 142299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142302 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142306 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142310 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142317 */     // (st FPR64:{ *:[v4i16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142320 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142322 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142327 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142341 */     GIR_RootConstrainSelectedInstOperands,
     /* 142342 */     // GIR_Coverage, 4492,
     /* 142342 */     GIR_EraseRootFromParent_Done,
     /* 142343 */   // Label 2474: @142343
     /* 142343 */   GIM_Try, /*On fail goto*//*Label 2475*/ GIMT_Encode4(142392), // Rule ID 4495 //
     /* 142348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142359 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 142366 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 142366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 142369 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142371 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142376 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142381 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142390 */     GIR_RootConstrainSelectedInstOperands,
     /* 142391 */     // GIR_Coverage, 4495,
     /* 142391 */     GIR_EraseRootFromParent_Done,
     /* 142392 */   // Label 2475: @142392
     /* 142392 */   GIM_Try, /*On fail goto*//*Label 2476*/ GIMT_Encode4(142441), // Rule ID 4496 //
     /* 142397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142404 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142408 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 142415 */     // (st FPR64:{ *:[v4f16] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 142415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 142418 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142439 */     GIR_RootConstrainSelectedInstOperands,
     /* 142440 */     // GIR_Coverage, 4496,
     /* 142440 */     GIR_EraseRootFromParent_Done,
     /* 142441 */   // Label 2476: @142441
     /* 142441 */   GIM_Try, /*On fail goto*//*Label 2477*/ GIMT_Encode4(142485), // Rule ID 4531 //
     /* 142446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142453 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142457 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142464 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142467 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142483 */     GIR_RootConstrainSelectedInstOperands,
     /* 142484 */     // GIR_Coverage, 4531,
     /* 142484 */     GIR_EraseRootFromParent_Done,
     /* 142485 */   // Label 2477: @142485
     /* 142485 */   GIM_Try, /*On fail goto*//*Label 2478*/ GIMT_Encode4(142529), // Rule ID 4533 //
     /* 142490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142501 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 142508 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 142508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 142511 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142513 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142518 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142523 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142527 */     GIR_RootConstrainSelectedInstOperands,
     /* 142528 */     // GIR_Coverage, 4533,
     /* 142528 */     GIR_EraseRootFromParent_Done,
     /* 142529 */   // Label 2478: @142529
     /* 142529 */   GIM_Try, /*On fail goto*//*Label 2479*/ GIMT_Encode4(142573), // Rule ID 4555 //
     /* 142534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142537 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142541 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142545 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142552 */     // (st FPR64:{ *:[v4i16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142555 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142557 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142571 */     GIR_RootConstrainSelectedInstOperands,
     /* 142572 */     // GIR_Coverage, 4555,
     /* 142572 */     GIR_EraseRootFromParent_Done,
     /* 142573 */   // Label 2479: @142573
     /* 142573 */   GIM_Try, /*On fail goto*//*Label 2480*/ GIMT_Encode4(142617), // Rule ID 4557 //
     /* 142578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 142585 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142589 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 142596 */     // (st FPR64:{ *:[v4f16] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v4f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 142599 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142611 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142615 */     GIR_RootConstrainSelectedInstOperands,
     /* 142616 */     // GIR_Coverage, 4557,
     /* 142616 */     GIR_EraseRootFromParent_Done,
     /* 142617 */   // Label 2480: @142617
     /* 142617 */   GIM_Try, /*On fail goto*//*Label 2481*/ GIMT_Encode4(142637), // Rule ID 6443 //
     /* 142622 */     // MIs[0] Rn
     /* 142622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 142626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 142630 */     // (st v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4h v4i16:{ *:[v4i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 142630 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4h),
     /* 142635 */     GIR_RootConstrainSelectedInstOperands,
     /* 142636 */     // GIR_Coverage, 6443,
     /* 142636 */     GIR_Done,
     /* 142637 */   // Label 2481: @142637
     /* 142637 */   GIM_Reject,
     /* 142638 */ // Label 2472: @142638
     /* 142638 */ GIM_Reject,
     /* 142639 */ // Label 2296: @142639
     /* 142639 */ GIM_Try, /*On fail goto*//*Label 2482*/ GIMT_Encode4(143044),
     /* 142644 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 142647 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 142651 */   GIM_Try, /*On fail goto*//*Label 2483*/ GIMT_Encode4(142700), // Rule ID 4505 //
     /* 142656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142663 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142667 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142674 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142677 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142689 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142694 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142698 */     GIR_RootConstrainSelectedInstOperands,
     /* 142699 */     // GIR_Coverage, 4505,
     /* 142699 */     GIR_EraseRootFromParent_Done,
     /* 142700 */   // Label 2483: @142700
     /* 142700 */   GIM_Try, /*On fail goto*//*Label 2484*/ GIMT_Encode4(142749), // Rule ID 4506 //
     /* 142705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142712 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142716 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142723 */     // (st FPR128:{ *:[v4i32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142726 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142728 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142743 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142747 */     GIR_RootConstrainSelectedInstOperands,
     /* 142748 */     // GIR_Coverage, 4506,
     /* 142748 */     GIR_EraseRootFromParent_Done,
     /* 142749 */   // Label 2484: @142749
     /* 142749 */   GIM_Try, /*On fail goto*//*Label 2485*/ GIMT_Encode4(142798), // Rule ID 4507 //
     /* 142754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142761 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142765 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 142772 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 142772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 142775 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142787 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142796 */     GIR_RootConstrainSelectedInstOperands,
     /* 142797 */     // GIR_Coverage, 4507,
     /* 142797 */     GIR_EraseRootFromParent_Done,
     /* 142798 */   // Label 2485: @142798
     /* 142798 */   GIM_Try, /*On fail goto*//*Label 2486*/ GIMT_Encode4(142847), // Rule ID 4508 //
     /* 142803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 142806 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142810 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142814 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 142821 */     // (st FPR128:{ *:[v4f32] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 142821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 142824 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 142836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 142841 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142845 */     GIR_RootConstrainSelectedInstOperands,
     /* 142846 */     // GIR_Coverage, 4508,
     /* 142846 */     GIR_EraseRootFromParent_Done,
     /* 142847 */   // Label 2486: @142847
     /* 142847 */   GIM_Try, /*On fail goto*//*Label 2487*/ GIMT_Encode4(142891), // Rule ID 4535 //
     /* 142852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142863 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142870 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142873 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142889 */     GIR_RootConstrainSelectedInstOperands,
     /* 142890 */     // GIR_Coverage, 4535,
     /* 142890 */     GIR_EraseRootFromParent_Done,
     /* 142891 */   // Label 2487: @142891
     /* 142891 */   GIM_Try, /*On fail goto*//*Label 2488*/ GIMT_Encode4(142935), // Rule ID 4539 //
     /* 142896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142903 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142907 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 142914 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 142914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 142917 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142919 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142933 */     GIR_RootConstrainSelectedInstOperands,
     /* 142934 */     // GIR_Coverage, 4539,
     /* 142934 */     GIR_EraseRootFromParent_Done,
     /* 142935 */   // Label 2488: @142935
     /* 142935 */   GIM_Try, /*On fail goto*//*Label 2489*/ GIMT_Encode4(142979), // Rule ID 4559 //
     /* 142940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142947 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142951 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 142958 */     // (st FPR128:{ *:[v4f32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4f32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 142958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 142961 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 142963 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 142968 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 142973 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 142977 */     GIR_RootConstrainSelectedInstOperands,
     /* 142978 */     // GIR_Coverage, 4559,
     /* 142978 */     GIR_EraseRootFromParent_Done,
     /* 142979 */   // Label 2489: @142979
     /* 142979 */   GIM_Try, /*On fail goto*//*Label 2490*/ GIMT_Encode4(143023), // Rule ID 4563 //
     /* 142984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 142987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 142991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 142995 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143002 */     // (st FPR128:{ *:[v4i32] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v4i32] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143005 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143007 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143017 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143021 */     GIR_RootConstrainSelectedInstOperands,
     /* 143022 */     // GIR_Coverage, 4563,
     /* 143022 */     GIR_EraseRootFromParent_Done,
     /* 143023 */   // Label 2490: @143023
     /* 143023 */   GIM_Try, /*On fail goto*//*Label 2491*/ GIMT_Encode4(143043), // Rule ID 6440 //
     /* 143028 */     // MIs[0] Rn
     /* 143028 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143036 */     // (st v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev4s v4i32:{ *:[v4i32] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143036 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev4s),
     /* 143041 */     GIR_RootConstrainSelectedInstOperands,
     /* 143042 */     // GIR_Coverage, 6440,
     /* 143042 */     GIR_Done,
     /* 143043 */   // Label 2491: @143043
     /* 143043 */   GIM_Reject,
     /* 143044 */ // Label 2482: @143044
     /* 143044 */ GIM_Reject,
     /* 143045 */ // Label 2297: @143045
     /* 143045 */ GIM_Try, /*On fail goto*//*Label 2492*/ GIMT_Encode4(143264),
     /* 143050 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143053 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143057 */   GIM_Try, /*On fail goto*//*Label 2493*/ GIMT_Encode4(143106), // Rule ID 4493 //
     /* 143062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143073 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 143080 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroW FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 143080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroW),
     /* 143083 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143100 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143104 */     GIR_RootConstrainSelectedInstOperands,
     /* 143105 */     // GIR_Coverage, 4493,
     /* 143105 */     GIR_EraseRootFromParent_Done,
     /* 143106 */   // Label 2493: @143106
     /* 143106 */   GIM_Try, /*On fail goto*//*Label 2494*/ GIMT_Encode4(143155), // Rule ID 4494 //
     /* 143111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143118 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143122 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 143129 */     // (st FPR64:{ *:[v8i8] }:$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDroX FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 143129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDroX),
     /* 143132 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143139 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143153 */     GIR_RootConstrainSelectedInstOperands,
     /* 143154 */     // GIR_Coverage, 4494,
     /* 143154 */     GIR_EraseRootFromParent_Done,
     /* 143155 */   // Label 2494: @143155
     /* 143155 */   GIM_Try, /*On fail goto*//*Label 2495*/ GIMT_Encode4(143199), // Rule ID 4530 //
     /* 143160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143167 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143171 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 143178 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRDui FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 143178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRDui),
     /* 143181 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143193 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143197 */     GIR_RootConstrainSelectedInstOperands,
     /* 143198 */     // GIR_Coverage, 4530,
     /* 143198 */     GIR_EraseRootFromParent_Done,
     /* 143199 */   // Label 2495: @143199
     /* 143199 */   GIM_Try, /*On fail goto*//*Label 2496*/ GIMT_Encode4(143243), // Rule ID 4554 //
     /* 143204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 143211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143215 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 143222 */     // (st FPR64:{ *:[v8i8] }:$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURDi FPR64:{ *:[v8i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURDi),
     /* 143225 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143237 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143241 */     GIR_RootConstrainSelectedInstOperands,
     /* 143242 */     // GIR_Coverage, 4554,
     /* 143242 */     GIR_EraseRootFromParent_Done,
     /* 143243 */   // Label 2496: @143243
     /* 143243 */   GIM_Try, /*On fail goto*//*Label 2497*/ GIMT_Encode4(143263), // Rule ID 6442 //
     /* 143248 */     // MIs[0] Rn
     /* 143248 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143256 */     // (st v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8b v8i8:{ *:[v8i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8b),
     /* 143261 */     GIR_RootConstrainSelectedInstOperands,
     /* 143262 */     // GIR_Coverage, 6442,
     /* 143262 */     GIR_Done,
     /* 143263 */   // Label 2497: @143263
     /* 143263 */   GIM_Reject,
     /* 143264 */ // Label 2492: @143264
     /* 143264 */ GIM_Reject,
     /* 143265 */ // Label 2298: @143265
     /* 143265 */ GIM_Try, /*On fail goto*//*Label 2498*/ GIMT_Encode4(143670),
     /* 143270 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143273 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143277 */   GIM_Try, /*On fail goto*//*Label 2499*/ GIMT_Encode4(143326), // Rule ID 4509 //
     /* 143282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143293 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143300 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143303 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143324 */     GIR_RootConstrainSelectedInstOperands,
     /* 143325 */     // GIR_Coverage, 4509,
     /* 143325 */     GIR_EraseRootFromParent_Done,
     /* 143326 */   // Label 2499: @143326
     /* 143326 */   GIM_Try, /*On fail goto*//*Label 2500*/ GIMT_Encode4(143375), // Rule ID 4510 //
     /* 143331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143338 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143342 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143349 */     // (st FPR128:{ *:[v8i16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143352 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143369 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143373 */     GIR_RootConstrainSelectedInstOperands,
     /* 143374 */     // GIR_Coverage, 4510,
     /* 143374 */     GIR_EraseRootFromParent_Done,
     /* 143375 */   // Label 2500: @143375
     /* 143375 */   GIM_Try, /*On fail goto*//*Label 2501*/ GIMT_Encode4(143424), // Rule ID 4513 //
     /* 143380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143387 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143391 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143398 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143401 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143408 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143413 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143422 */     GIR_RootConstrainSelectedInstOperands,
     /* 143423 */     // GIR_Coverage, 4513,
     /* 143423 */     GIR_EraseRootFromParent_Done,
     /* 143424 */   // Label 2501: @143424
     /* 143424 */   GIM_Try, /*On fail goto*//*Label 2502*/ GIMT_Encode4(143473), // Rule ID 4514 //
     /* 143429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143436 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143440 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143447 */     // (st FPR128:{ *:[v8f16] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143450 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143452 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143457 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143462 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143471 */     GIR_RootConstrainSelectedInstOperands,
     /* 143472 */     // GIR_Coverage, 4514,
     /* 143472 */     GIR_EraseRootFromParent_Done,
     /* 143473 */   // Label 2502: @143473
     /* 143473 */   GIM_Try, /*On fail goto*//*Label 2503*/ GIMT_Encode4(143517), // Rule ID 4538 //
     /* 143478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143485 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143489 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143496 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143499 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143506 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143511 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143515 */     GIR_RootConstrainSelectedInstOperands,
     /* 143516 */     // GIR_Coverage, 4538,
     /* 143516 */     GIR_EraseRootFromParent_Done,
     /* 143517 */   // Label 2503: @143517
     /* 143517 */   GIM_Try, /*On fail goto*//*Label 2504*/ GIMT_Encode4(143561), // Rule ID 4541 //
     /* 143522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143533 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143540 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143543 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143545 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143555 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143559 */     GIR_RootConstrainSelectedInstOperands,
     /* 143560 */     // GIR_Coverage, 4541,
     /* 143560 */     GIR_EraseRootFromParent_Done,
     /* 143561 */   // Label 2504: @143561
     /* 143561 */   GIM_Try, /*On fail goto*//*Label 2505*/ GIMT_Encode4(143605), // Rule ID 4562 //
     /* 143566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143573 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143577 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143584 */     // (st FPR128:{ *:[v8i16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8i16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143587 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143589 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143594 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143603 */     GIR_RootConstrainSelectedInstOperands,
     /* 143604 */     // GIR_Coverage, 4562,
     /* 143604 */     GIR_EraseRootFromParent_Done,
     /* 143605 */   // Label 2505: @143605
     /* 143605 */   GIM_Try, /*On fail goto*//*Label 2506*/ GIMT_Encode4(143649), // Rule ID 4566 //
     /* 143610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143617 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143621 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143628 */     // (st FPR128:{ *:[v8f16] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v8f16] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143631 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143647 */     GIR_RootConstrainSelectedInstOperands,
     /* 143648 */     // GIR_Coverage, 4566,
     /* 143648 */     GIR_EraseRootFromParent_Done,
     /* 143649 */   // Label 2506: @143649
     /* 143649 */   GIM_Try, /*On fail goto*//*Label 2507*/ GIMT_Encode4(143669), // Rule ID 6439 //
     /* 143654 */     // MIs[0] Rn
     /* 143654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143662 */     // (st v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev8h v8i16:{ *:[v8i16] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143662 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev8h),
     /* 143667 */     GIR_RootConstrainSelectedInstOperands,
     /* 143668 */     // GIR_Coverage, 6439,
     /* 143668 */     GIR_Done,
     /* 143669 */   // Label 2507: @143669
     /* 143669 */   GIM_Reject,
     /* 143670 */ // Label 2498: @143670
     /* 143670 */ GIM_Reject,
     /* 143671 */ // Label 2299: @143671
     /* 143671 */ GIM_Try, /*On fail goto*//*Label 2508*/ GIMT_Encode4(143890),
     /* 143676 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143679 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143683 */   GIM_Try, /*On fail goto*//*Label 2509*/ GIMT_Encode4(143732), // Rule ID 4511 //
     /* 143688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143695 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143699 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed128),
     /* 143706 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Windexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroW FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend128:{ *:[i32] }:$extend)
     /* 143706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroW),
     /* 143709 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143711 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143716 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143721 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143726 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143730 */     GIR_RootConstrainSelectedInstOperands,
     /* 143731 */     // GIR_Coverage, 4511,
     /* 143731 */     GIR_EraseRootFromParent_Done,
     /* 143732 */   // Label 2509: @143732
     /* 143732 */   GIM_Try, /*On fail goto*//*Label 2510*/ GIMT_Encode4(143781), // Rule ID 4512 //
     /* 143737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE_UseSTRQro),
     /* 143740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143748 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed128),
     /* 143755 */     // (st FPR128:{ *:[v16i8] }:$Rt, (ro_Xindexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQroX FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend128:{ *:[i32] }:$extend)
     /* 143755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQroX),
     /* 143758 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143760 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143765 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 143770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 143775 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143779 */     GIR_RootConstrainSelectedInstOperands,
     /* 143780 */     // GIR_Coverage, 4512,
     /* 143780 */     GIR_EraseRootFromParent_Done,
     /* 143781 */   // Label 2510: @143781
     /* 143781 */   GIM_Try, /*On fail goto*//*Label 2511*/ GIMT_Encode4(143825), // Rule ID 4537 //
     /* 143786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143797 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed128),
     /* 143804 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_indexed128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STRQui FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s16:{ *:[i64] }:$offset)
     /* 143804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STRQui),
     /* 143807 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143809 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143823 */     GIR_RootConstrainSelectedInstOperands,
     /* 143824 */     // GIR_Coverage, 4537,
     /* 143824 */     GIR_EraseRootFromParent_Done,
     /* 143825 */   // Label 2511: @143825
     /* 143825 */   GIM_Try, /*On fail goto*//*Label 2512*/ GIMT_Encode4(143869), // Rule ID 4561 //
     /* 143830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_IsLE),
     /* 143833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 143837 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 143841 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled128),
     /* 143848 */     // (st FPR128:{ *:[v16i8] }:$Rt, (am_unscaled128:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STURQi FPR128:{ *:[v16i8] }:$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset)
     /* 143848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STURQi),
     /* 143851 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 143853 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 143858 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 143863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143867 */     GIR_RootConstrainSelectedInstOperands,
     /* 143868 */     // GIR_Coverage, 4561,
     /* 143868 */     GIR_EraseRootFromParent_Done,
     /* 143869 */   // Label 2512: @143869
     /* 143869 */   GIM_Try, /*On fail goto*//*Label 2513*/ GIMT_Encode4(143889), // Rule ID 6438 //
     /* 143874 */     // MIs[0] Rn
     /* 143874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143878 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 143882 */     // (st v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1Onev16b v16i8:{ *:[v16i8] }:$Vt, GPR64sp:{ *:[i64] }:$Rn)
     /* 143882 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ST1Onev16b),
     /* 143887 */     GIR_RootConstrainSelectedInstOperands,
     /* 143888 */     // GIR_Coverage, 6438,
     /* 143888 */     GIR_Done,
     /* 143889 */   // Label 2513: @143889
     /* 143889 */   GIM_Reject,
     /* 143890 */ // Label 2508: @143890
     /* 143890 */ GIM_Reject,
     /* 143891 */ // Label 2300: @143891
     /* 143891 */ GIM_Try, /*On fail goto*//*Label 2514*/ GIMT_Encode4(143950), // Rule ID 10922 //
     /* 143896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143899 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143902 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143906 */   // MIs[0] base
     /* 143906 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143914 */   // (st nxv2f16:{ *:[nxv2f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_D_IMM ZPR:{ *:[nxv2f16] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143926 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143929 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_D_IMM),
     /* 143934 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143939 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 143941 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 143944 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 143948 */   GIR_RootConstrainSelectedInstOperands,
     /* 143949 */   // GIR_Coverage, 10922,
     /* 143949 */   GIR_EraseRootFromParent_Done,
     /* 143950 */ // Label 2514: @143950
     /* 143950 */ GIM_Reject,
     /* 143951 */ // Label 2301: @143951
     /* 143951 */ GIM_Try, /*On fail goto*//*Label 2515*/ GIMT_Encode4(144010), // Rule ID 10928 //
     /* 143956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 143959 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 143962 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 143966 */   // MIs[0] base
     /* 143966 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 143970 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 143974 */   // (st nxv2f32:{ *:[nxv2f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_D_IMM ZPR:{ *:[nxv2f32] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 143974 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 143977 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 143981 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 143986 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 143989 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 143991 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_D_IMM),
     /* 143994 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 143996 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 143999 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144001 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144004 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144008 */   GIR_RootConstrainSelectedInstOperands,
     /* 144009 */   // GIR_Coverage, 10928,
     /* 144009 */   GIR_EraseRootFromParent_Done,
     /* 144010 */ // Label 2515: @144010
     /* 144010 */ GIM_Reject,
     /* 144011 */ // Label 2302: @144011
     /* 144011 */ GIM_Try, /*On fail goto*//*Label 2516*/ GIMT_Encode4(144180),
     /* 144016 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144019 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144023 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144027 */   GIM_Try, /*On fail goto*//*Label 2517*/ GIMT_Encode4(144075), // Rule ID 10913 //
     /* 144032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144035 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144039 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2i64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144039 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144042 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144046 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144051 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144059 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144064 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144073 */     GIR_RootConstrainSelectedInstOperands,
     /* 144074 */     // GIR_Coverage, 10913,
     /* 144074 */     GIR_EraseRootFromParent_Done,
     /* 144075 */   // Label 2517: @144075
     /* 144075 */   GIM_Try, /*On fail goto*//*Label 2518*/ GIMT_Encode4(144123), // Rule ID 10931 //
     /* 144080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144083 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144087 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1D_IMM ZPR:{ *:[nxv2f64] }:$val, (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 144094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144099 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144102 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_IMM),
     /* 144107 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144109 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144112 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144114 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144121 */     GIR_RootConstrainSelectedInstOperands,
     /* 144122 */     // GIR_Coverage, 10931,
     /* 144122 */     GIR_EraseRootFromParent_Done,
     /* 144123 */   // Label 2518: @144123
     /* 144123 */   GIM_Try, /*On fail goto*//*Label 2519*/ GIMT_Encode4(144151), // Rule ID 11043 //
     /* 144128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144131 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144135 */     // (st nxv2i64:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2i64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144138 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144140 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144145 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144149 */     GIR_RootConstrainSelectedInstOperands,
     /* 144150 */     // GIR_Coverage, 11043,
     /* 144150 */     GIR_EraseRootFromParent_Done,
     /* 144151 */   // Label 2519: @144151
     /* 144151 */   GIM_Try, /*On fail goto*//*Label 2520*/ GIMT_Encode4(144179), // Rule ID 11055 //
     /* 144156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144159 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144163 */     // (st nxv2f64:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv2f64] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144166 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144168 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144173 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144177 */     GIR_RootConstrainSelectedInstOperands,
     /* 144178 */     // GIR_Coverage, 11055,
     /* 144178 */     GIR_EraseRootFromParent_Done,
     /* 144179 */   // Label 2520: @144179
     /* 144179 */   GIM_Reject,
     /* 144180 */ // Label 2516: @144180
     /* 144180 */ GIM_Reject,
     /* 144181 */ // Label 2303: @144181
     /* 144181 */ GIM_Try, /*On fail goto*//*Label 2521*/ GIMT_Encode4(144240), // Rule ID 10919 //
     /* 144186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144189 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144192 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144196 */   // MIs[0] base
     /* 144196 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144200 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144204 */   // (st nxv4f16:{ *:[nxv4f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_S_IMM ZPR:{ *:[nxv4f16] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144204 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144207 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144211 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144216 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144219 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144221 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_S_IMM),
     /* 144224 */   GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144226 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144229 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144231 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144234 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144238 */   GIR_RootConstrainSelectedInstOperands,
     /* 144239 */   // GIR_Coverage, 10919,
     /* 144239 */   GIR_EraseRootFromParent_Done,
     /* 144240 */ // Label 2521: @144240
     /* 144240 */ GIM_Reject,
     /* 144241 */ // Label 2304: @144241
     /* 144241 */ GIM_Try, /*On fail goto*//*Label 2522*/ GIMT_Encode4(144410),
     /* 144246 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144249 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144253 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144257 */   GIM_Try, /*On fail goto*//*Label 2523*/ GIMT_Encode4(144305), // Rule ID 10907 //
     /* 144262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144265 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144269 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4i32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144269 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144272 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144276 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144281 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144284 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144289 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144291 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144294 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144299 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144303 */     GIR_RootConstrainSelectedInstOperands,
     /* 144304 */     // GIR_Coverage, 10907,
     /* 144304 */     GIR_EraseRootFromParent_Done,
     /* 144305 */   // Label 2523: @144305
     /* 144305 */   GIM_Try, /*On fail goto*//*Label 2524*/ GIMT_Encode4(144353), // Rule ID 10925 //
     /* 144310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144317 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1W_IMM ZPR:{ *:[nxv4f32] }:$val, (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 144324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144332 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_IMM),
     /* 144337 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144342 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144351 */     GIR_RootConstrainSelectedInstOperands,
     /* 144352 */     // GIR_Coverage, 10925,
     /* 144352 */     GIR_EraseRootFromParent_Done,
     /* 144353 */   // Label 2524: @144353
     /* 144353 */   GIM_Try, /*On fail goto*//*Label 2525*/ GIMT_Encode4(144381), // Rule ID 11039 //
     /* 144358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144365 */     // (st nxv4i32:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4i32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144368 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144370 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144375 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144379 */     GIR_RootConstrainSelectedInstOperands,
     /* 144380 */     // GIR_Coverage, 11039,
     /* 144380 */     GIR_EraseRootFromParent_Done,
     /* 144381 */   // Label 2525: @144381
     /* 144381 */   GIM_Try, /*On fail goto*//*Label 2526*/ GIMT_Encode4(144409), // Rule ID 11051 //
     /* 144386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144389 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144393 */     // (st nxv4f32:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv4f32] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144396 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144398 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144407 */     GIR_RootConstrainSelectedInstOperands,
     /* 144408 */     // GIR_Coverage, 11051,
     /* 144408 */     GIR_EraseRootFromParent_Done,
     /* 144409 */   // Label 2526: @144409
     /* 144409 */   GIM_Reject,
     /* 144410 */ // Label 2522: @144410
     /* 144410 */ GIM_Reject,
     /* 144411 */ // Label 2305: @144411
     /* 144411 */ GIM_Try, /*On fail goto*//*Label 2527*/ GIMT_Encode4(144580),
     /* 144416 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144419 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144423 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144427 */   GIM_Try, /*On fail goto*//*Label 2528*/ GIMT_Encode4(144475), // Rule ID 10898 //
     /* 144432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144439 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8i16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144459 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144461 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144464 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144466 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144473 */     GIR_RootConstrainSelectedInstOperands,
     /* 144474 */     // GIR_Coverage, 10898,
     /* 144474 */     GIR_EraseRootFromParent_Done,
     /* 144475 */   // Label 2528: @144475
     /* 144475 */   GIM_Try, /*On fail goto*//*Label 2529*/ GIMT_Encode4(144523), // Rule ID 10916 //
     /* 144480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144483 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144487 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1H_IMM ZPR:{ *:[nxv8f16] }:$val, (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144487 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144490 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 144494 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144499 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144502 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1H_IMM),
     /* 144507 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144509 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144512 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144521 */     GIR_RootConstrainSelectedInstOperands,
     /* 144522 */     // GIR_Coverage, 10916,
     /* 144522 */     GIR_EraseRootFromParent_Done,
     /* 144523 */   // Label 2529: @144523
     /* 144523 */   GIM_Try, /*On fail goto*//*Label 2530*/ GIMT_Encode4(144551), // Rule ID 11035 //
     /* 144528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144535 */     // (st nxv8i16:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8i16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144538 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144540 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144542 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144549 */     GIR_RootConstrainSelectedInstOperands,
     /* 144550 */     // GIR_Coverage, 11035,
     /* 144550 */     GIR_EraseRootFromParent_Done,
     /* 144551 */   // Label 2530: @144551
     /* 144551 */   GIM_Try, /*On fail goto*//*Label 2531*/ GIMT_Encode4(144579), // Rule ID 11047 //
     /* 144556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144563 */     // (st nxv8f16:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv8f16] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144566 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144568 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144573 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144577 */     GIR_RootConstrainSelectedInstOperands,
     /* 144578 */     // GIR_Coverage, 11047,
     /* 144578 */     GIR_EraseRootFromParent_Done,
     /* 144579 */   // Label 2531: @144579
     /* 144579 */   GIM_Reject,
     /* 144580 */ // Label 2527: @144580
     /* 144580 */ GIM_Reject,
     /* 144581 */ // Label 2306: @144581
     /* 144581 */ GIM_Try, /*On fail goto*//*Label 2532*/ GIMT_Encode4(144624), // Rule ID 2433 //
     /* 144586 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144589 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144592 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 144600 */   // MIs[0] base
     /* 144600 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144604 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144608 */   // (st PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_PXI PPR:{ *:[nxv16i1] }:$Val, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144608 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_PXI),
     /* 144611 */   GIR_RootToRootCopy, /*OpIdx*/0, // Val
     /* 144613 */   GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144615 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144618 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144622 */   GIR_RootConstrainSelectedInstOperands,
     /* 144623 */   // GIR_Coverage, 2433,
     /* 144623 */   GIR_EraseRootFromParent_Done,
     /* 144624 */ // Label 2532: @144624
     /* 144624 */ GIM_Reject,
     /* 144625 */ // Label 2307: @144625
     /* 144625 */ GIM_Try, /*On fail goto*//*Label 2533*/ GIMT_Encode4(144718),
     /* 144630 */   GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 144633 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/0, /*MMO*/0, /*OpIdx*/0,
     /* 144637 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144641 */   GIM_Try, /*On fail goto*//*Label 2534*/ GIMT_Encode4(144689), // Rule ID 10884 //
     /* 144646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 144649 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 144653 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (ST1B_IMM ZPR:{ *:[nxv16i8] }:$val, (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144653 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 144656 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 144660 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 144665 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/31,
     /* 144668 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 144670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1B_IMM),
     /* 144673 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144675 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 144678 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144683 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144687 */     GIR_RootConstrainSelectedInstOperands,
     /* 144688 */     // GIR_Coverage, 10884,
     /* 144688 */     GIR_EraseRootFromParent_Done,
     /* 144689 */   // Label 2534: @144689
     /* 144689 */   GIM_Try, /*On fail goto*//*Label 2535*/ GIMT_Encode4(144717), // Rule ID 11031 //
     /* 144694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_AllowMisalignedMemAccesses_HasSVE_or_SME_IsLE),
     /* 144697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144701 */     // (st nxv16i8:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base)<<P:Predicate_unindexedstore>><<P:Predicate_store>>  =>  (STR_ZXI ZPR:{ *:[nxv16i8] }:$val, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 144701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STR_ZXI),
     /* 144704 */     GIR_RootToRootCopy, /*OpIdx*/0, // val
     /* 144706 */     GIR_RootToRootCopy, /*OpIdx*/1, // base
     /* 144708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 144711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144715 */     GIR_RootConstrainSelectedInstOperands,
     /* 144716 */     // GIR_Coverage, 11031,
     /* 144716 */     GIR_EraseRootFromParent_Done,
     /* 144717 */   // Label 2535: @144717
     /* 144717 */   GIM_Reject,
     /* 144718 */ // Label 2533: @144718
     /* 144718 */ GIM_Reject,
     /* 144719 */ // Label 2308: @144719
     /* 144719 */ GIM_Reject,
     /* 144720 */ // Label 20: @144720
     /* 144720 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2538*/ GIMT_Encode4(146070),
     /* 144731 */ /*GILLT_s32*//*Label 2536*/ GIMT_Encode4(144739),
     /* 144735 */ /*GILLT_s64*//*Label 2537*/ GIMT_Encode4(145757),
     /* 144739 */ // Label 2536: @144739
     /* 144739 */ GIM_Try, /*On fail goto*//*Label 2539*/ GIMT_Encode4(145756),
     /* 144744 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 144747 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 144750 */   GIM_Try, /*On fail goto*//*Label 2540*/ GIMT_Encode4(144805), // Rule ID 7344 //
     /* 144755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144758 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144765 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 144768 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144772 */     // MIs[0] Rn
     /* 144772 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144776 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144780 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144784 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144788 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_monotonic>>  =>  (CASW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASW),
     /* 144791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144797 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144799 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144803 */     GIR_RootConstrainSelectedInstOperands,
     /* 144804 */     // GIR_Coverage, 7344,
     /* 144804 */     GIR_EraseRootFromParent_Done,
     /* 144805 */   // Label 2540: @144805
     /* 144805 */   GIM_Try, /*On fail goto*//*Label 2541*/ GIMT_Encode4(144860), // Rule ID 7345 //
     /* 144810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144813 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144820 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 144823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144827 */     // MIs[0] Rn
     /* 144827 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144839 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144843 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acquire>>  =>  (CASAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144843 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAW),
     /* 144846 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144850 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144858 */     GIR_RootConstrainSelectedInstOperands,
     /* 144859 */     // GIR_Coverage, 7345,
     /* 144859 */     GIR_EraseRootFromParent_Done,
     /* 144860 */   // Label 2541: @144860
     /* 144860 */   GIM_Try, /*On fail goto*//*Label 2542*/ GIMT_Encode4(144915), // Rule ID 7346 //
     /* 144865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144868 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144875 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 144878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144882 */     // MIs[0] Rn
     /* 144882 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144886 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144898 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_release>>  =>  (CASLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLW),
     /* 144901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144909 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144913 */     GIR_RootConstrainSelectedInstOperands,
     /* 144914 */     // GIR_Coverage, 7346,
     /* 144914 */     GIR_EraseRootFromParent_Done,
     /* 144915 */   // Label 2542: @144915
     /* 144915 */   GIM_Try, /*On fail goto*//*Label 2543*/ GIMT_Encode4(144970), // Rule ID 7347 //
     /* 144920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144923 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144930 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 144933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144937 */     // MIs[0] Rn
     /* 144937 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 144945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144953 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_acq_rel>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 144953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 144956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 144958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 144960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 144962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 144964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 144968 */     GIR_RootConstrainSelectedInstOperands,
     /* 144969 */     // GIR_Coverage, 7347,
     /* 144969 */     GIR_EraseRootFromParent_Done,
     /* 144970 */   // Label 2543: @144970
     /* 144970 */   GIM_Try, /*On fail goto*//*Label 2544*/ GIMT_Encode4(145025), // Rule ID 7348 //
     /* 144975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 144978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 144985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 144988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 144992 */     // MIs[0] Rn
     /* 144992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 144996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145004 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145008 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i32>><<P:Predicate_atomic_cmp_swap_i32_seq_cst>>  =>  (CASALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALW),
     /* 145011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145015 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145017 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145019 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145023 */     GIR_RootConstrainSelectedInstOperands,
     /* 145024 */     // GIR_Coverage, 7348,
     /* 145024 */     GIR_EraseRootFromParent_Done,
     /* 145025 */   // Label 2544: @145025
     /* 145025 */   GIM_Try, /*On fail goto*//*Label 2545*/ GIMT_Encode4(145080), // Rule ID 7349 //
     /* 145030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145033 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145040 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145047 */     // MIs[0] Rn
     /* 145047 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145051 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145063 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_monotonic>>  =>  (CASH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASH),
     /* 145066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145072 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145074 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145078 */     GIR_RootConstrainSelectedInstOperands,
     /* 145079 */     // GIR_Coverage, 7349,
     /* 145079 */     GIR_EraseRootFromParent_Done,
     /* 145080 */   // Label 2545: @145080
     /* 145080 */   GIM_Try, /*On fail goto*//*Label 2546*/ GIMT_Encode4(145135), // Rule ID 7350 //
     /* 145085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145088 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145102 */     // MIs[0] Rn
     /* 145102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145114 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145118 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acquire>>  =>  (CASAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAH),
     /* 145121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145123 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145129 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145133 */     GIR_RootConstrainSelectedInstOperands,
     /* 145134 */     // GIR_Coverage, 7350,
     /* 145134 */     GIR_EraseRootFromParent_Done,
     /* 145135 */   // Label 2546: @145135
     /* 145135 */   GIM_Try, /*On fail goto*//*Label 2547*/ GIMT_Encode4(145190), // Rule ID 7351 //
     /* 145140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145143 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145150 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145157 */     // MIs[0] Rn
     /* 145157 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145161 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145173 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_release>>  =>  (CASLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLH),
     /* 145176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145182 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145184 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145188 */     GIR_RootConstrainSelectedInstOperands,
     /* 145189 */     // GIR_Coverage, 7351,
     /* 145189 */     GIR_EraseRootFromParent_Done,
     /* 145190 */   // Label 2547: @145190
     /* 145190 */   GIM_Try, /*On fail goto*//*Label 2548*/ GIMT_Encode4(145245), // Rule ID 7352 //
     /* 145195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145198 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145212 */     // MIs[0] Rn
     /* 145212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145224 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145228 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_acq_rel>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145235 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145243 */     GIR_RootConstrainSelectedInstOperands,
     /* 145244 */     // GIR_Coverage, 7352,
     /* 145244 */     GIR_EraseRootFromParent_Done,
     /* 145245 */   // Label 2548: @145245
     /* 145245 */   GIM_Try, /*On fail goto*//*Label 2549*/ GIMT_Encode4(145300), // Rule ID 7353 //
     /* 145250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145267 */     // MIs[0] Rn
     /* 145267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145279 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145283 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i16>><<P:Predicate_atomic_cmp_swap_i16_seq_cst>>  =>  (CASALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALH),
     /* 145286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145292 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145298 */     GIR_RootConstrainSelectedInstOperands,
     /* 145299 */     // GIR_Coverage, 7353,
     /* 145299 */     GIR_EraseRootFromParent_Done,
     /* 145300 */   // Label 2549: @145300
     /* 145300 */   GIM_Try, /*On fail goto*//*Label 2550*/ GIMT_Encode4(145355), // Rule ID 7354 //
     /* 145305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145308 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145315 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145322 */     // MIs[0] Rn
     /* 145322 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145338 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_monotonic>>  =>  (CASB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASB),
     /* 145341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145347 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145349 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145353 */     GIR_RootConstrainSelectedInstOperands,
     /* 145354 */     // GIR_Coverage, 7354,
     /* 145354 */     GIR_EraseRootFromParent_Done,
     /* 145355 */   // Label 2550: @145355
     /* 145355 */   GIM_Try, /*On fail goto*//*Label 2551*/ GIMT_Encode4(145410), // Rule ID 7355 //
     /* 145360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145363 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145370 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145377 */     // MIs[0] Rn
     /* 145377 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145393 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acquire>>  =>  (CASAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAB),
     /* 145396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145408 */     GIR_RootConstrainSelectedInstOperands,
     /* 145409 */     // GIR_Coverage, 7355,
     /* 145409 */     GIR_EraseRootFromParent_Done,
     /* 145410 */   // Label 2551: @145410
     /* 145410 */   GIM_Try, /*On fail goto*//*Label 2552*/ GIMT_Encode4(145465), // Rule ID 7356 //
     /* 145415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145418 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145425 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145432 */     // MIs[0] Rn
     /* 145432 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145436 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145444 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145448 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_release>>  =>  (CASLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLB),
     /* 145451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145457 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145459 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145463 */     GIR_RootConstrainSelectedInstOperands,
     /* 145464 */     // GIR_Coverage, 7356,
     /* 145464 */     GIR_EraseRootFromParent_Done,
     /* 145465 */   // Label 2552: @145465
     /* 145465 */   GIM_Try, /*On fail goto*//*Label 2553*/ GIMT_Encode4(145520), // Rule ID 7357 //
     /* 145470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145473 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145480 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145487 */     // MIs[0] Rn
     /* 145487 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145503 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_acq_rel>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145512 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145514 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145518 */     GIR_RootConstrainSelectedInstOperands,
     /* 145519 */     // GIR_Coverage, 7357,
     /* 145519 */     GIR_EraseRootFromParent_Done,
     /* 145520 */   // Label 2553: @145520
     /* 145520 */   GIM_Try, /*On fail goto*//*Label 2554*/ GIMT_Encode4(145575), // Rule ID 7358 //
     /* 145525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145528 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145535 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145542 */     // MIs[0] Rn
     /* 145542 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145546 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145550 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145554 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145558 */     // (atomic_cmp_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i8>><<P:Predicate_atomic_cmp_swap_i8_seq_cst>>  =>  (CASALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rold, GPR32:{ *:[i32] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALB),
     /* 145561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145567 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145569 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145573 */     GIR_RootConstrainSelectedInstOperands,
     /* 145574 */     // GIR_Coverage, 7358,
     /* 145574 */     GIR_EraseRootFromParent_Done,
     /* 145575 */   // Label 2554: @145575
     /* 145575 */   GIM_Try, /*On fail goto*//*Label 2555*/ GIMT_Encode4(145635), // Rule ID 13193 //
     /* 145580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145583 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 145590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145594 */     // MIs[0] addr
     /* 145594 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145610 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>>  =>  (CMP_SWAP_8:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145610 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_8),
     /* 145616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145618 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145623 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145625 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145627 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145629 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145633 */     GIR_RootConstrainSelectedInstOperands,
     /* 145634 */     // GIR_Coverage, 13193,
     /* 145634 */     GIR_EraseRootFromParent_Done,
     /* 145635 */   // Label 2555: @145635
     /* 145635 */   GIM_Try, /*On fail goto*//*Label 2556*/ GIMT_Encode4(145695), // Rule ID 13194 //
     /* 145640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145643 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 145650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145654 */     // MIs[0] addr
     /* 145654 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145666 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145670 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>>  =>  (CMP_SWAP_16:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_16),
     /* 145676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145678 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145683 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145685 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145687 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145693 */     GIR_RootConstrainSelectedInstOperands,
     /* 145694 */     // GIR_Coverage, 13194,
     /* 145694 */     GIR_EraseRootFromParent_Done,
     /* 145695 */   // Label 2556: @145695
     /* 145695 */   GIM_Try, /*On fail goto*//*Label 2557*/ GIMT_Encode4(145755), // Rule ID 13195 //
     /* 145700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 145703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 145710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145714 */     // MIs[0] addr
     /* 145714 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145718 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 145730 */     // (atomic_cmp_swap:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>>  =>  (CMP_SWAP_32:{ *:[i32] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR32:{ *:[i32] }:$desired, GPR32:{ *:[i32] }:$new)
     /* 145730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 145733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_32),
     /* 145736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 145738 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 145743 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 145745 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 145747 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 145749 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145753 */     GIR_RootConstrainSelectedInstOperands,
     /* 145754 */     // GIR_Coverage, 13195,
     /* 145754 */     GIR_EraseRootFromParent_Done,
     /* 145755 */   // Label 2557: @145755
     /* 145755 */   GIM_Reject,
     /* 145756 */ // Label 2539: @145756
     /* 145756 */ GIM_Reject,
     /* 145757 */ // Label 2537: @145757
     /* 145757 */ GIM_Try, /*On fail goto*//*Label 2558*/ GIMT_Encode4(146069),
     /* 145762 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 145765 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 145768 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 145775 */   GIM_Try, /*On fail goto*//*Label 2559*/ GIMT_Encode4(145823), // Rule ID 2585 //
     /* 145780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145783 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 145786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145790 */     // MIs[0] Rn
     /* 145790 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145794 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145806 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_monotonic>>  =>  (CASX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASX),
     /* 145809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145815 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145817 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145821 */     GIR_RootConstrainSelectedInstOperands,
     /* 145822 */     // GIR_Coverage, 2585,
     /* 145822 */     GIR_EraseRootFromParent_Done,
     /* 145823 */   // Label 2559: @145823
     /* 145823 */   GIM_Try, /*On fail goto*//*Label 2560*/ GIMT_Encode4(145871), // Rule ID 2586 //
     /* 145828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145831 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 145834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145838 */     // MIs[0] Rn
     /* 145838 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145842 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145854 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acquire>>  =>  (CASAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASAX),
     /* 145857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145863 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145865 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145869 */     GIR_RootConstrainSelectedInstOperands,
     /* 145870 */     // GIR_Coverage, 2586,
     /* 145870 */     GIR_EraseRootFromParent_Done,
     /* 145871 */   // Label 2560: @145871
     /* 145871 */   GIM_Try, /*On fail goto*//*Label 2561*/ GIMT_Encode4(145919), // Rule ID 2587 //
     /* 145876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145879 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 145882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145886 */     // MIs[0] Rn
     /* 145886 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145890 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145902 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_release>>  =>  (CASLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASLX),
     /* 145905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145913 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145917 */     GIR_RootConstrainSelectedInstOperands,
     /* 145918 */     // GIR_Coverage, 2587,
     /* 145918 */     GIR_EraseRootFromParent_Done,
     /* 145919 */   // Label 2561: @145919
     /* 145919 */   GIM_Try, /*On fail goto*//*Label 2562*/ GIMT_Encode4(145967), // Rule ID 2588 //
     /* 145924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145927 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 145930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145934 */     // MIs[0] Rn
     /* 145934 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145938 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145942 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145946 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145950 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_acq_rel>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 145953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 145955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 145957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 145959 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 145961 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 145965 */     GIR_RootConstrainSelectedInstOperands,
     /* 145966 */     // GIR_Coverage, 2588,
     /* 145966 */     GIR_EraseRootFromParent_Done,
     /* 145967 */   // Label 2562: @145967
     /* 145967 */   GIM_Try, /*On fail goto*//*Label 2563*/ GIMT_Encode4(146015), // Rule ID 2589 //
     /* 145972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 145975 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 145978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145982 */     // MIs[0] Rn
     /* 145982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 145986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 145990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 145998 */     // (atomic_cmp_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew)<<P:Predicate_atomic_cmp_swap_i64>><<P:Predicate_atomic_cmp_swap_i64_seq_cst>>  =>  (CASALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rold, GPR64:{ *:[i64] }:$Rnew, GPR64sp:{ *:[i64] }:$Rn)
     /* 145998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CASALX),
     /* 146001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[out]
     /* 146003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rold
     /* 146005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rnew
     /* 146007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146009 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146013 */     GIR_RootConstrainSelectedInstOperands,
     /* 146014 */     // GIR_Coverage, 2589,
     /* 146014 */     GIR_EraseRootFromParent_Done,
     /* 146015 */   // Label 2563: @146015
     /* 146015 */   GIM_Try, /*On fail goto*//*Label 2564*/ GIMT_Encode4(146068), // Rule ID 13196 //
     /* 146020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoLSE),
     /* 146023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146027 */     // MIs[0] addr
     /* 146027 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146031 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146043 */     // (atomic_cmp_swap:{ *:[i64] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>>  =>  (CMP_SWAP_64:{ *:[i64] }:{ *:[i32] } GPR64:{ *:[i64] }:$addr, GPR64:{ *:[i64] }:$desired, GPR64:{ *:[i64] }:$new)
     /* 146043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 146046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMP_SWAP_64),
     /* 146049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 146051 */     GIR_AddTempRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define|RegState::Dead),
     /* 146056 */     GIR_RootToRootCopy, /*OpIdx*/1, // addr
     /* 146058 */     GIR_RootToRootCopy, /*OpIdx*/2, // desired
     /* 146060 */     GIR_RootToRootCopy, /*OpIdx*/3, // new
     /* 146062 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146066 */     GIR_RootConstrainSelectedInstOperands,
     /* 146067 */     // GIR_Coverage, 13196,
     /* 146067 */     GIR_EraseRootFromParent_Done,
     /* 146068 */   // Label 2564: @146068
     /* 146068 */   GIM_Reject,
     /* 146069 */ // Label 2558: @146069
     /* 146069 */ GIM_Reject,
     /* 146070 */ // Label 2538: @146070
     /* 146070 */ GIM_Reject,
     /* 146071 */ // Label 21: @146071
     /* 146071 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2567*/ GIMT_Encode4(147062),
     /* 146082 */ /*GILLT_s32*//*Label 2565*/ GIMT_Encode4(146090),
     /* 146086 */ /*GILLT_s64*//*Label 2566*/ GIMT_Encode4(146835),
     /* 146090 */ // Label 2565: @146090
     /* 146090 */ GIM_Try, /*On fail goto*//*Label 2568*/ GIMT_Encode4(146834),
     /* 146095 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 146098 */   GIM_Try, /*On fail goto*//*Label 2569*/ GIMT_Encode4(146147), // Rule ID 7329 //
     /* 146103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146106 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146113 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146120 */     // MIs[0] Rn
     /* 146120 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146132 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_monotonic>>  =>  (SWPW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPW),
     /* 146135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146139 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146141 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146145 */     GIR_RootConstrainSelectedInstOperands,
     /* 146146 */     // GIR_Coverage, 7329,
     /* 146146 */     GIR_EraseRootFromParent_Done,
     /* 146147 */   // Label 2569: @146147
     /* 146147 */   GIM_Try, /*On fail goto*//*Label 2570*/ GIMT_Encode4(146196), // Rule ID 7330 //
     /* 146152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146155 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146162 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146169 */     // MIs[0] Rn
     /* 146169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146173 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146181 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acquire>>  =>  (SWPAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAW),
     /* 146184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146190 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146194 */     GIR_RootConstrainSelectedInstOperands,
     /* 146195 */     // GIR_Coverage, 7330,
     /* 146195 */     GIR_EraseRootFromParent_Done,
     /* 146196 */   // Label 2570: @146196
     /* 146196 */   GIM_Try, /*On fail goto*//*Label 2571*/ GIMT_Encode4(146245), // Rule ID 7331 //
     /* 146201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146204 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146211 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146214 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146218 */     // MIs[0] Rn
     /* 146218 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146222 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146230 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_release>>  =>  (SWPLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLW),
     /* 146233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146237 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146239 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146243 */     GIR_RootConstrainSelectedInstOperands,
     /* 146244 */     // GIR_Coverage, 7331,
     /* 146244 */     GIR_EraseRootFromParent_Done,
     /* 146245 */   // Label 2571: @146245
     /* 146245 */   GIM_Try, /*On fail goto*//*Label 2572*/ GIMT_Encode4(146294), // Rule ID 7332 //
     /* 146250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146253 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146260 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146267 */     // MIs[0] Rn
     /* 146267 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146271 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146279 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_acq_rel>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146288 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146292 */     GIR_RootConstrainSelectedInstOperands,
     /* 146293 */     // GIR_Coverage, 7332,
     /* 146293 */     GIR_EraseRootFromParent_Done,
     /* 146294 */   // Label 2572: @146294
     /* 146294 */   GIM_Try, /*On fail goto*//*Label 2573*/ GIMT_Encode4(146343), // Rule ID 7333 //
     /* 146299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146302 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 146309 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146316 */     // MIs[0] Rn
     /* 146316 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146320 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146328 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i32>><<P:Predicate_atomic_swap_i32_seq_cst>>  =>  (SWPALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALW),
     /* 146331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146341 */     GIR_RootConstrainSelectedInstOperands,
     /* 146342 */     // GIR_Coverage, 7333,
     /* 146342 */     GIR_EraseRootFromParent_Done,
     /* 146343 */   // Label 2573: @146343
     /* 146343 */   GIM_Try, /*On fail goto*//*Label 2574*/ GIMT_Encode4(146392), // Rule ID 7334 //
     /* 146348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146351 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146358 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146365 */     // MIs[0] Rn
     /* 146365 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146369 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146377 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_monotonic>>  =>  (SWPH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPH),
     /* 146380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146384 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146390 */     GIR_RootConstrainSelectedInstOperands,
     /* 146391 */     // GIR_Coverage, 7334,
     /* 146391 */     GIR_EraseRootFromParent_Done,
     /* 146392 */   // Label 2574: @146392
     /* 146392 */   GIM_Try, /*On fail goto*//*Label 2575*/ GIMT_Encode4(146441), // Rule ID 7335 //
     /* 146397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146400 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146407 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146414 */     // MIs[0] Rn
     /* 146414 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146418 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146422 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146426 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acquire>>  =>  (SWPAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAH),
     /* 146429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146433 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146435 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146439 */     GIR_RootConstrainSelectedInstOperands,
     /* 146440 */     // GIR_Coverage, 7335,
     /* 146440 */     GIR_EraseRootFromParent_Done,
     /* 146441 */   // Label 2575: @146441
     /* 146441 */   GIM_Try, /*On fail goto*//*Label 2576*/ GIMT_Encode4(146490), // Rule ID 7336 //
     /* 146446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146449 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146456 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146463 */     // MIs[0] Rn
     /* 146463 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146467 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146475 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_release>>  =>  (SWPLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLH),
     /* 146478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146482 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146484 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146488 */     GIR_RootConstrainSelectedInstOperands,
     /* 146489 */     // GIR_Coverage, 7336,
     /* 146489 */     GIR_EraseRootFromParent_Done,
     /* 146490 */   // Label 2576: @146490
     /* 146490 */   GIM_Try, /*On fail goto*//*Label 2577*/ GIMT_Encode4(146539), // Rule ID 7337 //
     /* 146495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146498 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146512 */     // MIs[0] Rn
     /* 146512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146524 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_acq_rel>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146537 */     GIR_RootConstrainSelectedInstOperands,
     /* 146538 */     // GIR_Coverage, 7337,
     /* 146538 */     GIR_EraseRootFromParent_Done,
     /* 146539 */   // Label 2577: @146539
     /* 146539 */   GIM_Try, /*On fail goto*//*Label 2578*/ GIMT_Encode4(146588), // Rule ID 7338 //
     /* 146544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146547 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 146554 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146561 */     // MIs[0] Rn
     /* 146561 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146565 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146573 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i16>><<P:Predicate_atomic_swap_i16_seq_cst>>  =>  (SWPALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALH),
     /* 146576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146580 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146582 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146586 */     GIR_RootConstrainSelectedInstOperands,
     /* 146587 */     // GIR_Coverage, 7338,
     /* 146587 */     GIR_EraseRootFromParent_Done,
     /* 146588 */   // Label 2578: @146588
     /* 146588 */   GIM_Try, /*On fail goto*//*Label 2579*/ GIMT_Encode4(146637), // Rule ID 7339 //
     /* 146593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146596 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146603 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146610 */     // MIs[0] Rn
     /* 146610 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146614 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146622 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_monotonic>>  =>  (SWPB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPB),
     /* 146625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146631 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146635 */     GIR_RootConstrainSelectedInstOperands,
     /* 146636 */     // GIR_Coverage, 7339,
     /* 146636 */     GIR_EraseRootFromParent_Done,
     /* 146637 */   // Label 2579: @146637
     /* 146637 */   GIM_Try, /*On fail goto*//*Label 2580*/ GIMT_Encode4(146686), // Rule ID 7340 //
     /* 146642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146645 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146652 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146659 */     // MIs[0] Rn
     /* 146659 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146671 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acquire>>  =>  (SWPAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAB),
     /* 146674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146678 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146684 */     GIR_RootConstrainSelectedInstOperands,
     /* 146685 */     // GIR_Coverage, 7340,
     /* 146685 */     GIR_EraseRootFromParent_Done,
     /* 146686 */   // Label 2580: @146686
     /* 146686 */   GIM_Try, /*On fail goto*//*Label 2581*/ GIMT_Encode4(146735), // Rule ID 7341 //
     /* 146691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146694 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146701 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146708 */     // MIs[0] Rn
     /* 146708 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146712 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146720 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_release>>  =>  (SWPLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLB),
     /* 146723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146727 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146729 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146733 */     GIR_RootConstrainSelectedInstOperands,
     /* 146734 */     // GIR_Coverage, 7341,
     /* 146734 */     GIR_EraseRootFromParent_Done,
     /* 146735 */   // Label 2581: @146735
     /* 146735 */   GIM_Try, /*On fail goto*//*Label 2582*/ GIMT_Encode4(146784), // Rule ID 7342 //
     /* 146740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146743 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146750 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146757 */     // MIs[0] Rn
     /* 146757 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146761 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146769 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_acq_rel>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146778 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146782 */     GIR_RootConstrainSelectedInstOperands,
     /* 146783 */     // GIR_Coverage, 7342,
     /* 146783 */     GIR_EraseRootFromParent_Done,
     /* 146784 */   // Label 2582: @146784
     /* 146784 */   GIM_Try, /*On fail goto*//*Label 2583*/ GIMT_Encode4(146833), // Rule ID 7343 //
     /* 146789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146792 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 146799 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 146802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146806 */     // MIs[0] Rn
     /* 146806 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146810 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 146818 */     // (atomic_swap:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_swap_i8>><<P:Predicate_atomic_swap_i8_seq_cst>>  =>  (SWPALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALB),
     /* 146821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146825 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146827 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146831 */     GIR_RootConstrainSelectedInstOperands,
     /* 146832 */     // GIR_Coverage, 7343,
     /* 146832 */     GIR_EraseRootFromParent_Done,
     /* 146833 */   // Label 2583: @146833
     /* 146833 */   GIM_Reject,
     /* 146834 */ // Label 2568: @146834
     /* 146834 */ GIM_Reject,
     /* 146835 */ // Label 2566: @146835
     /* 146835 */ GIM_Try, /*On fail goto*//*Label 2584*/ GIMT_Encode4(147061),
     /* 146840 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 146843 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 146850 */   GIM_Try, /*On fail goto*//*Label 2585*/ GIMT_Encode4(146892), // Rule ID 7324 //
     /* 146855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146858 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 146861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146865 */     // MIs[0] Rn
     /* 146865 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146869 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146877 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_monotonic>>  =>  (SWPX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPX),
     /* 146880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146886 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146890 */     GIR_RootConstrainSelectedInstOperands,
     /* 146891 */     // GIR_Coverage, 7324,
     /* 146891 */     GIR_EraseRootFromParent_Done,
     /* 146892 */   // Label 2585: @146892
     /* 146892 */   GIM_Try, /*On fail goto*//*Label 2586*/ GIMT_Encode4(146934), // Rule ID 7325 //
     /* 146897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146900 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 146903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146907 */     // MIs[0] Rn
     /* 146907 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146911 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146919 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acquire>>  =>  (SWPAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPAX),
     /* 146922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146924 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146932 */     GIR_RootConstrainSelectedInstOperands,
     /* 146933 */     // GIR_Coverage, 7325,
     /* 146933 */     GIR_EraseRootFromParent_Done,
     /* 146934 */   // Label 2586: @146934
     /* 146934 */   GIM_Try, /*On fail goto*//*Label 2587*/ GIMT_Encode4(146976), // Rule ID 7326 //
     /* 146939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146942 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 146945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146949 */     // MIs[0] Rn
     /* 146949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146953 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146957 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146961 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_release>>  =>  (SWPLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 146961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPLX),
     /* 146964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 146966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 146968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 146970 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 146974 */     GIR_RootConstrainSelectedInstOperands,
     /* 146975 */     // GIR_Coverage, 7326,
     /* 146975 */     GIR_EraseRootFromParent_Done,
     /* 146976 */   // Label 2587: @146976
     /* 146976 */   GIM_Try, /*On fail goto*//*Label 2588*/ GIMT_Encode4(147018), // Rule ID 7327 //
     /* 146981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 146984 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 146987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 146991 */     // MIs[0] Rn
     /* 146991 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 146995 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 146999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147003 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_acq_rel>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147008 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147016 */     GIR_RootConstrainSelectedInstOperands,
     /* 147017 */     // GIR_Coverage, 7327,
     /* 147017 */     GIR_EraseRootFromParent_Done,
     /* 147018 */   // Label 2588: @147018
     /* 147018 */   GIM_Try, /*On fail goto*//*Label 2589*/ GIMT_Encode4(147060), // Rule ID 7328 //
     /* 147023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147026 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147033 */     // MIs[0] Rn
     /* 147033 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147037 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147041 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147045 */     // (atomic_swap:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_swap_i64>><<P:Predicate_atomic_swap_i64_seq_cst>>  =>  (SWPALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SWPALX),
     /* 147048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147050 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147052 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147054 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147058 */     GIR_RootConstrainSelectedInstOperands,
     /* 147059 */     // GIR_Coverage, 7328,
     /* 147059 */     GIR_EraseRootFromParent_Done,
     /* 147060 */   // Label 2589: @147060
     /* 147060 */   GIM_Reject,
     /* 147061 */ // Label 2584: @147061
     /* 147061 */ GIM_Reject,
     /* 147062 */ // Label 2567: @147062
     /* 147062 */ GIM_Reject,
     /* 147063 */ // Label 22: @147063
     /* 147063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2592*/ GIMT_Encode4(148054),
     /* 147074 */ /*GILLT_s32*//*Label 2590*/ GIMT_Encode4(147082),
     /* 147078 */ /*GILLT_s64*//*Label 2591*/ GIMT_Encode4(147827),
     /* 147082 */ // Label 2590: @147082
     /* 147082 */ GIM_Try, /*On fail goto*//*Label 2593*/ GIMT_Encode4(147826),
     /* 147087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 147090 */   GIM_Try, /*On fail goto*//*Label 2594*/ GIMT_Encode4(147139), // Rule ID 7169 //
     /* 147095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147098 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147105 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147112 */     // MIs[0] Rn
     /* 147112 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147116 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147124 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 147127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147131 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147133 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147137 */     GIR_RootConstrainSelectedInstOperands,
     /* 147138 */     // GIR_Coverage, 7169,
     /* 147138 */     GIR_EraseRootFromParent_Done,
     /* 147139 */   // Label 2594: @147139
     /* 147139 */   GIM_Try, /*On fail goto*//*Label 2595*/ GIMT_Encode4(147188), // Rule ID 7170 //
     /* 147144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147147 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147154 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147161 */     // MIs[0] Rn
     /* 147161 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147173 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 147176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147182 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147186 */     GIR_RootConstrainSelectedInstOperands,
     /* 147187 */     // GIR_Coverage, 7170,
     /* 147187 */     GIR_EraseRootFromParent_Done,
     /* 147188 */   // Label 2595: @147188
     /* 147188 */   GIM_Try, /*On fail goto*//*Label 2596*/ GIMT_Encode4(147237), // Rule ID 7171 //
     /* 147193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147196 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147203 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147210 */     // MIs[0] Rn
     /* 147210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147222 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_release>>  =>  (LDADDLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 147225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147231 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147235 */     GIR_RootConstrainSelectedInstOperands,
     /* 147236 */     // GIR_Coverage, 7171,
     /* 147236 */     GIR_EraseRootFromParent_Done,
     /* 147237 */   // Label 2596: @147237
     /* 147237 */   GIM_Try, /*On fail goto*//*Label 2597*/ GIMT_Encode4(147286), // Rule ID 7172 //
     /* 147242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147245 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147259 */     // MIs[0] Rn
     /* 147259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147271 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147284 */     GIR_RootConstrainSelectedInstOperands,
     /* 147285 */     // GIR_Coverage, 7172,
     /* 147285 */     GIR_EraseRootFromParent_Done,
     /* 147286 */   // Label 2597: @147286
     /* 147286 */   GIM_Try, /*On fail goto*//*Label 2598*/ GIMT_Encode4(147335), // Rule ID 7173 //
     /* 147291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147294 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 147301 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147308 */     // MIs[0] Rn
     /* 147308 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147312 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147320 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i32>><<P:Predicate_atomic_load_add_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 147323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147327 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147329 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147333 */     GIR_RootConstrainSelectedInstOperands,
     /* 147334 */     // GIR_Coverage, 7173,
     /* 147334 */     GIR_EraseRootFromParent_Done,
     /* 147335 */   // Label 2598: @147335
     /* 147335 */   GIM_Try, /*On fail goto*//*Label 2599*/ GIMT_Encode4(147384), // Rule ID 7174 //
     /* 147340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147343 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147350 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147357 */     // MIs[0] Rn
     /* 147357 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147361 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147369 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 147372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147376 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147378 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147382 */     GIR_RootConstrainSelectedInstOperands,
     /* 147383 */     // GIR_Coverage, 7174,
     /* 147383 */     GIR_EraseRootFromParent_Done,
     /* 147384 */   // Label 2599: @147384
     /* 147384 */   GIM_Try, /*On fail goto*//*Label 2600*/ GIMT_Encode4(147433), // Rule ID 7175 //
     /* 147389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147392 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147399 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147406 */     // MIs[0] Rn
     /* 147406 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147418 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 147421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147425 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147427 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147431 */     GIR_RootConstrainSelectedInstOperands,
     /* 147432 */     // GIR_Coverage, 7175,
     /* 147432 */     GIR_EraseRootFromParent_Done,
     /* 147433 */   // Label 2600: @147433
     /* 147433 */   GIM_Try, /*On fail goto*//*Label 2601*/ GIMT_Encode4(147482), // Rule ID 7176 //
     /* 147438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147441 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147448 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147455 */     // MIs[0] Rn
     /* 147455 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147459 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147463 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147467 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_release>>  =>  (LDADDLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 147470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147474 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147476 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147480 */     GIR_RootConstrainSelectedInstOperands,
     /* 147481 */     // GIR_Coverage, 7176,
     /* 147481 */     GIR_EraseRootFromParent_Done,
     /* 147482 */   // Label 2601: @147482
     /* 147482 */   GIM_Try, /*On fail goto*//*Label 2602*/ GIMT_Encode4(147531), // Rule ID 7177 //
     /* 147487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147490 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147497 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147504 */     // MIs[0] Rn
     /* 147504 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147516 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147523 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147525 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147529 */     GIR_RootConstrainSelectedInstOperands,
     /* 147530 */     // GIR_Coverage, 7177,
     /* 147530 */     GIR_EraseRootFromParent_Done,
     /* 147531 */   // Label 2602: @147531
     /* 147531 */   GIM_Try, /*On fail goto*//*Label 2603*/ GIMT_Encode4(147580), // Rule ID 7178 //
     /* 147536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147539 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 147546 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147553 */     // MIs[0] Rn
     /* 147553 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147557 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147565 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i16>><<P:Predicate_atomic_load_add_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 147568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147574 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147578 */     GIR_RootConstrainSelectedInstOperands,
     /* 147579 */     // GIR_Coverage, 7178,
     /* 147579 */     GIR_EraseRootFromParent_Done,
     /* 147580 */   // Label 2603: @147580
     /* 147580 */   GIM_Try, /*On fail goto*//*Label 2604*/ GIMT_Encode4(147629), // Rule ID 7179 //
     /* 147585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147588 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147595 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147602 */     // MIs[0] Rn
     /* 147602 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147614 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 147617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147623 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147627 */     GIR_RootConstrainSelectedInstOperands,
     /* 147628 */     // GIR_Coverage, 7179,
     /* 147628 */     GIR_EraseRootFromParent_Done,
     /* 147629 */   // Label 2604: @147629
     /* 147629 */   GIM_Try, /*On fail goto*//*Label 2605*/ GIMT_Encode4(147678), // Rule ID 7180 //
     /* 147634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147637 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147644 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147651 */     // MIs[0] Rn
     /* 147651 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147655 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147663 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 147666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147676 */     GIR_RootConstrainSelectedInstOperands,
     /* 147677 */     // GIR_Coverage, 7180,
     /* 147677 */     GIR_EraseRootFromParent_Done,
     /* 147678 */   // Label 2605: @147678
     /* 147678 */   GIM_Try, /*On fail goto*//*Label 2606*/ GIMT_Encode4(147727), // Rule ID 7181 //
     /* 147683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147686 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147693 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147696 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147700 */     // MIs[0] Rn
     /* 147700 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147712 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_release>>  =>  (LDADDLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 147715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147721 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147725 */     GIR_RootConstrainSelectedInstOperands,
     /* 147726 */     // GIR_Coverage, 7181,
     /* 147726 */     GIR_EraseRootFromParent_Done,
     /* 147727 */   // Label 2606: @147727
     /* 147727 */   GIM_Try, /*On fail goto*//*Label 2607*/ GIMT_Encode4(147776), // Rule ID 7182 //
     /* 147732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147735 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147749 */     // MIs[0] Rn
     /* 147749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147761 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147774 */     GIR_RootConstrainSelectedInstOperands,
     /* 147775 */     // GIR_Coverage, 7182,
     /* 147775 */     GIR_EraseRootFromParent_Done,
     /* 147776 */   // Label 2607: @147776
     /* 147776 */   GIM_Try, /*On fail goto*//*Label 2608*/ GIMT_Encode4(147825), // Rule ID 7183 //
     /* 147781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147784 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 147791 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 147794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147798 */     // MIs[0] Rn
     /* 147798 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147806 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 147810 */     // (atomic_load_add:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_add_i8>><<P:Predicate_atomic_load_add_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 147813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147815 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147817 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147819 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147823 */     GIR_RootConstrainSelectedInstOperands,
     /* 147824 */     // GIR_Coverage, 7183,
     /* 147824 */     GIR_EraseRootFromParent_Done,
     /* 147825 */   // Label 2608: @147825
     /* 147825 */   GIM_Reject,
     /* 147826 */ // Label 2593: @147826
     /* 147826 */ GIM_Reject,
     /* 147827 */ // Label 2591: @147827
     /* 147827 */ GIM_Try, /*On fail goto*//*Label 2609*/ GIMT_Encode4(148053),
     /* 147832 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 147835 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 147842 */   GIM_Try, /*On fail goto*//*Label 2610*/ GIMT_Encode4(147884), // Rule ID 2575 //
     /* 147847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147850 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 147853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147857 */     // MIs[0] Rn
     /* 147857 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147861 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147865 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147869 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 147872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147876 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147878 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147882 */     GIR_RootConstrainSelectedInstOperands,
     /* 147883 */     // GIR_Coverage, 2575,
     /* 147883 */     GIR_EraseRootFromParent_Done,
     /* 147884 */   // Label 2610: @147884
     /* 147884 */   GIM_Try, /*On fail goto*//*Label 2611*/ GIMT_Encode4(147926), // Rule ID 2576 //
     /* 147889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147892 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 147895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147899 */     // MIs[0] Rn
     /* 147899 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147907 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147911 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 147914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147924 */     GIR_RootConstrainSelectedInstOperands,
     /* 147925 */     // GIR_Coverage, 2576,
     /* 147925 */     GIR_EraseRootFromParent_Done,
     /* 147926 */   // Label 2611: @147926
     /* 147926 */   GIM_Try, /*On fail goto*//*Label 2612*/ GIMT_Encode4(147968), // Rule ID 2577 //
     /* 147931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147934 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 147937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147941 */     // MIs[0] Rn
     /* 147941 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147953 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_release>>  =>  (LDADDLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 147956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 147958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 147960 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 147962 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 147966 */     GIR_RootConstrainSelectedInstOperands,
     /* 147967 */     // GIR_Coverage, 2577,
     /* 147967 */     GIR_EraseRootFromParent_Done,
     /* 147968 */   // Label 2612: @147968
     /* 147968 */   GIM_Try, /*On fail goto*//*Label 2613*/ GIMT_Encode4(148010), // Rule ID 2578 //
     /* 147973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 147976 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 147979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147983 */     // MIs[0] Rn
     /* 147983 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 147987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 147991 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 147995 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 147995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 147998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148004 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148008 */     GIR_RootConstrainSelectedInstOperands,
     /* 148009 */     // GIR_Coverage, 2578,
     /* 148009 */     GIR_EraseRootFromParent_Done,
     /* 148010 */   // Label 2613: @148010
     /* 148010 */   GIM_Try, /*On fail goto*//*Label 2614*/ GIMT_Encode4(148052), // Rule ID 2579 //
     /* 148015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148018 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148025 */     // MIs[0] Rn
     /* 148025 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148033 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 148037 */     // (atomic_load_add:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_add_i64>><<P:Predicate_atomic_load_add_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 148037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 148040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 148044 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148046 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148050 */     GIR_RootConstrainSelectedInstOperands,
     /* 148051 */     // GIR_Coverage, 2579,
     /* 148051 */     GIR_EraseRootFromParent_Done,
     /* 148052 */   // Label 2614: @148052
     /* 148052 */   GIM_Reject,
     /* 148053 */ // Label 2609: @148053
     /* 148053 */ GIM_Reject,
     /* 148054 */ // Label 2592: @148054
     /* 148054 */ GIM_Reject,
     /* 148055 */ // Label 23: @148055
     /* 148055 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2617*/ GIMT_Encode4(149546),
     /* 148066 */ /*GILLT_s32*//*Label 2615*/ GIMT_Encode4(148074),
     /* 148070 */ /*GILLT_s64*//*Label 2616*/ GIMT_Encode4(149194),
     /* 148074 */ // Label 2615: @148074
     /* 148074 */ GIM_Try, /*On fail goto*//*Label 2618*/ GIMT_Encode4(149193),
     /* 148079 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 148082 */   GIM_Try, /*On fail goto*//*Label 2619*/ GIMT_Encode4(148156), // Rule ID 7364 //
     /* 148087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148090 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148097 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148104 */     // MIs[0] Rn
     /* 148104 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148108 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148116 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_monotonic>>  =>  (LDADDW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148116 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148119 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148123 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148128 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148134 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148138 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDW),
     /* 148143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148145 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148154 */     GIR_RootConstrainSelectedInstOperands,
     /* 148155 */     // GIR_Coverage, 7364,
     /* 148155 */     GIR_EraseRootFromParent_Done,
     /* 148156 */   // Label 2619: @148156
     /* 148156 */   GIM_Try, /*On fail goto*//*Label 2620*/ GIMT_Encode4(148230), // Rule ID 7365 //
     /* 148161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148178 */     // MIs[0] Rn
     /* 148178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148190 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acquire>>  =>  (LDADDAW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148202 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148208 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148212 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAW),
     /* 148217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148219 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148228 */     GIR_RootConstrainSelectedInstOperands,
     /* 148229 */     // GIR_Coverage, 7365,
     /* 148229 */     GIR_EraseRootFromParent_Done,
     /* 148230 */   // Label 2620: @148230
     /* 148230 */   GIM_Try, /*On fail goto*//*Label 2621*/ GIMT_Encode4(148304), // Rule ID 7366 //
     /* 148235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148252 */     // MIs[0] Rn
     /* 148252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148264 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_release>>  =>  (LDADDLW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148264 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148267 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148271 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148276 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148282 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148286 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLW),
     /* 148291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148293 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148298 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148302 */     GIR_RootConstrainSelectedInstOperands,
     /* 148303 */     // GIR_Coverage, 7366,
     /* 148303 */     GIR_EraseRootFromParent_Done,
     /* 148304 */   // Label 2621: @148304
     /* 148304 */   GIM_Try, /*On fail goto*//*Label 2622*/ GIMT_Encode4(148378), // Rule ID 7367 //
     /* 148309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148312 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148319 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148326 */     // MIs[0] Rn
     /* 148326 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148330 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148338 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_acq_rel>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148338 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148341 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148345 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148350 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148356 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148367 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148370 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148372 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148376 */     GIR_RootConstrainSelectedInstOperands,
     /* 148377 */     // GIR_Coverage, 7367,
     /* 148377 */     GIR_EraseRootFromParent_Done,
     /* 148378 */   // Label 2622: @148378
     /* 148378 */   GIM_Try, /*On fail goto*//*Label 2623*/ GIMT_Encode4(148452), // Rule ID 7368 //
     /* 148383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148386 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 148393 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148400 */     // MIs[0] Rn
     /* 148400 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148404 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148412 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i32>><<P:Predicate_atomic_load_sub_i32_seq_cst>>  =>  (LDADDALW:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148412 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148415 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148419 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148424 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148430 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148434 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALW),
     /* 148439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148450 */     GIR_RootConstrainSelectedInstOperands,
     /* 148451 */     // GIR_Coverage, 7368,
     /* 148451 */     GIR_EraseRootFromParent_Done,
     /* 148452 */   // Label 2623: @148452
     /* 148452 */   GIM_Try, /*On fail goto*//*Label 2624*/ GIMT_Encode4(148526), // Rule ID 7369 //
     /* 148457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148460 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148467 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148474 */     // MIs[0] Rn
     /* 148474 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148478 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148486 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_monotonic>>  =>  (LDADDH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148498 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148504 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148508 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDH),
     /* 148513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148518 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148520 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148524 */     GIR_RootConstrainSelectedInstOperands,
     /* 148525 */     // GIR_Coverage, 7369,
     /* 148525 */     GIR_EraseRootFromParent_Done,
     /* 148526 */   // Label 2624: @148526
     /* 148526 */   GIM_Try, /*On fail goto*//*Label 2625*/ GIMT_Encode4(148600), // Rule ID 7370 //
     /* 148531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148534 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148541 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148548 */     // MIs[0] Rn
     /* 148548 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148560 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acquire>>  =>  (LDADDAH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148572 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148582 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAH),
     /* 148587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148589 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148592 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148594 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148598 */     GIR_RootConstrainSelectedInstOperands,
     /* 148599 */     // GIR_Coverage, 7370,
     /* 148599 */     GIR_EraseRootFromParent_Done,
     /* 148600 */   // Label 2625: @148600
     /* 148600 */   GIM_Try, /*On fail goto*//*Label 2626*/ GIMT_Encode4(148674), // Rule ID 7371 //
     /* 148605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148608 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148622 */     // MIs[0] Rn
     /* 148622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148634 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_release>>  =>  (LDADDLH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148646 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLH),
     /* 148661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148666 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148668 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148672 */     GIR_RootConstrainSelectedInstOperands,
     /* 148673 */     // GIR_Coverage, 7371,
     /* 148673 */     GIR_EraseRootFromParent_Done,
     /* 148674 */   // Label 2626: @148674
     /* 148674 */   GIM_Try, /*On fail goto*//*Label 2627*/ GIMT_Encode4(148748), // Rule ID 7372 //
     /* 148679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148682 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148689 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 148692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148696 */     // MIs[0] Rn
     /* 148696 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148700 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148708 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_acq_rel>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148720 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148726 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148730 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148737 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148742 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148746 */     GIR_RootConstrainSelectedInstOperands,
     /* 148747 */     // GIR_Coverage, 7372,
     /* 148747 */     GIR_EraseRootFromParent_Done,
     /* 148748 */   // Label 2627: @148748
     /* 148748 */   GIM_Try, /*On fail goto*//*Label 2628*/ GIMT_Encode4(148822), // Rule ID 7373 //
     /* 148753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148756 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 148763 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 148766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148770 */     // MIs[0] Rn
     /* 148770 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148774 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148782 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i16>><<P:Predicate_atomic_load_sub_i16_seq_cst>>  =>  (LDADDALH:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148794 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148804 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALH),
     /* 148809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148811 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148814 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148816 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148820 */     GIR_RootConstrainSelectedInstOperands,
     /* 148821 */     // GIR_Coverage, 7373,
     /* 148821 */     GIR_EraseRootFromParent_Done,
     /* 148822 */   // Label 2628: @148822
     /* 148822 */   GIM_Try, /*On fail goto*//*Label 2629*/ GIMT_Encode4(148896), // Rule ID 7374 //
     /* 148827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148830 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148837 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 148840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148844 */     // MIs[0] Rn
     /* 148844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148848 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148856 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_monotonic>>  =>  (LDADDB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148856 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148859 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148863 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148868 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148874 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDB),
     /* 148883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148888 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148890 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148894 */     GIR_RootConstrainSelectedInstOperands,
     /* 148895 */     // GIR_Coverage, 7374,
     /* 148895 */     GIR_EraseRootFromParent_Done,
     /* 148896 */   // Label 2629: @148896
     /* 148896 */   GIM_Try, /*On fail goto*//*Label 2630*/ GIMT_Encode4(148970), // Rule ID 7375 //
     /* 148901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148904 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148911 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 148914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148918 */     // MIs[0] Rn
     /* 148918 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148922 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 148926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148930 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acquire>>  =>  (LDADDAB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 148930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 148933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 148937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 148942 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 148948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 148952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 148954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAB),
     /* 148957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 148959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 148962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 148964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 148968 */     GIR_RootConstrainSelectedInstOperands,
     /* 148969 */     // GIR_Coverage, 7375,
     /* 148969 */     GIR_EraseRootFromParent_Done,
     /* 148970 */   // Label 2630: @148970
     /* 148970 */   GIM_Try, /*On fail goto*//*Label 2631*/ GIMT_Encode4(149044), // Rule ID 7376 //
     /* 148975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 148978 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 148985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 148988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 148992 */     // MIs[0] Rn
     /* 148992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 148996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149004 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_release>>  =>  (LDADDLB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149004 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149007 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149011 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149016 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149022 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLB),
     /* 149031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149033 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149036 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149038 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149042 */     GIR_RootConstrainSelectedInstOperands,
     /* 149043 */     // GIR_Coverage, 7376,
     /* 149043 */     GIR_EraseRootFromParent_Done,
     /* 149044 */   // Label 2631: @149044
     /* 149044 */   GIM_Try, /*On fail goto*//*Label 2632*/ GIMT_Encode4(149118), // Rule ID 7377 //
     /* 149049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149052 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149059 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149062 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149066 */     // MIs[0] Rn
     /* 149066 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149070 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149078 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_acq_rel>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149078 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149081 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149085 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149090 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149096 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149116 */     GIR_RootConstrainSelectedInstOperands,
     /* 149117 */     // GIR_Coverage, 7377,
     /* 149117 */     GIR_EraseRootFromParent_Done,
     /* 149118 */   // Label 2632: @149118
     /* 149118 */   GIM_Try, /*On fail goto*//*Label 2633*/ GIMT_Encode4(149192), // Rule ID 7378 //
     /* 149123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149126 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 149133 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149140 */     // MIs[0] Rn
     /* 149140 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149152 */     // (atomic_load_sub:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_sub_i8>><<P:Predicate_atomic_load_sub_i8_seq_cst>>  =>  (LDADDALB:{ *:[i32] } (SUBWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149152 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149155 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBWrr),
     /* 149159 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149164 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149170 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALB),
     /* 149179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149184 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149190 */     GIR_RootConstrainSelectedInstOperands,
     /* 149191 */     // GIR_Coverage, 7378,
     /* 149191 */     GIR_EraseRootFromParent_Done,
     /* 149192 */   // Label 2633: @149192
     /* 149192 */   GIM_Reject,
     /* 149193 */ // Label 2618: @149193
     /* 149193 */ GIM_Reject,
     /* 149194 */ // Label 2616: @149194
     /* 149194 */ GIM_Try, /*On fail goto*//*Label 2634*/ GIMT_Encode4(149545),
     /* 149199 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 149202 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 149209 */   GIM_Try, /*On fail goto*//*Label 2635*/ GIMT_Encode4(149276), // Rule ID 7359 //
     /* 149214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149217 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149224 */     // MIs[0] Rn
     /* 149224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149236 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_monotonic>>  =>  (LDADDX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149236 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149239 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149243 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149248 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149254 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149258 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDX),
     /* 149263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149265 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149270 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149274 */     GIR_RootConstrainSelectedInstOperands,
     /* 149275 */     // GIR_Coverage, 7359,
     /* 149275 */     GIR_EraseRootFromParent_Done,
     /* 149276 */   // Label 2635: @149276
     /* 149276 */   GIM_Try, /*On fail goto*//*Label 2636*/ GIMT_Encode4(149343), // Rule ID 7360 //
     /* 149281 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149284 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149291 */     // MIs[0] Rn
     /* 149291 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149295 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149303 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acquire>>  =>  (LDADDAX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149315 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149325 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDAX),
     /* 149330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149335 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149337 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149341 */     GIR_RootConstrainSelectedInstOperands,
     /* 149342 */     // GIR_Coverage, 7360,
     /* 149342 */     GIR_EraseRootFromParent_Done,
     /* 149343 */   // Label 2636: @149343
     /* 149343 */   GIM_Try, /*On fail goto*//*Label 2637*/ GIMT_Encode4(149410), // Rule ID 7361 //
     /* 149348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149358 */     // MIs[0] Rn
     /* 149358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149370 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_release>>  =>  (LDADDLX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149370 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149373 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149377 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149382 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149392 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDLX),
     /* 149397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149399 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149404 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149408 */     GIR_RootConstrainSelectedInstOperands,
     /* 149409 */     // GIR_Coverage, 7361,
     /* 149409 */     GIR_EraseRootFromParent_Done,
     /* 149410 */   // Label 2637: @149410
     /* 149410 */   GIM_Try, /*On fail goto*//*Label 2638*/ GIMT_Encode4(149477), // Rule ID 7362 //
     /* 149415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149418 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149425 */     // MIs[0] Rn
     /* 149425 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149437 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_acq_rel>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149449 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149455 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149459 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149466 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149469 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149471 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149475 */     GIR_RootConstrainSelectedInstOperands,
     /* 149476 */     // GIR_Coverage, 7362,
     /* 149476 */     GIR_EraseRootFromParent_Done,
     /* 149477 */   // Label 2638: @149477
     /* 149477 */   GIM_Try, /*On fail goto*//*Label 2639*/ GIMT_Encode4(149544), // Rule ID 7363 //
     /* 149482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149485 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149488 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149492 */     // MIs[0] Rn
     /* 149492 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149496 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149500 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 149504 */     // (atomic_load_sub:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_sub_i64>><<P:Predicate_atomic_load_sub_i64_seq_cst>>  =>  (LDADDALX:{ *:[i64] } (SUBXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149504 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 149507 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SUBXrr),
     /* 149511 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149516 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149526 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDADDALX),
     /* 149531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149536 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149538 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149542 */     GIR_RootConstrainSelectedInstOperands,
     /* 149543 */     // GIR_Coverage, 7363,
     /* 149543 */     GIR_EraseRootFromParent_Done,
     /* 149544 */   // Label 2639: @149544
     /* 149544 */   GIM_Reject,
     /* 149545 */ // Label 2634: @149545
     /* 149545 */ GIM_Reject,
     /* 149546 */ // Label 2617: @149546
     /* 149546 */ GIM_Reject,
     /* 149547 */ // Label 24: @149547
     /* 149547 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2642*/ GIMT_Encode4(151038),
     /* 149558 */ /*GILLT_s32*//*Label 2640*/ GIMT_Encode4(149566),
     /* 149562 */ /*GILLT_s64*//*Label 2641*/ GIMT_Encode4(150686),
     /* 149566 */ // Label 2640: @149566
     /* 149566 */ GIM_Try, /*On fail goto*//*Label 2643*/ GIMT_Encode4(150685),
     /* 149571 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 149574 */   GIM_Try, /*On fail goto*//*Label 2644*/ GIMT_Encode4(149648), // Rule ID 7384 //
     /* 149579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149582 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149589 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149596 */     // MIs[0] Rn
     /* 149596 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149600 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149608 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_monotonic>>  =>  (LDCLRW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149608 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149611 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149615 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149620 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149626 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149630 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRW),
     /* 149635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149637 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149642 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149646 */     GIR_RootConstrainSelectedInstOperands,
     /* 149647 */     // GIR_Coverage, 7384,
     /* 149647 */     GIR_EraseRootFromParent_Done,
     /* 149648 */   // Label 2644: @149648
     /* 149648 */   GIM_Try, /*On fail goto*//*Label 2645*/ GIMT_Encode4(149722), // Rule ID 7385 //
     /* 149653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149656 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149663 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 149666 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149670 */     // MIs[0] Rn
     /* 149670 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149674 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149682 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acquire>>  =>  (LDCLRAW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149694 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149700 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149704 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAW),
     /* 149709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149716 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149720 */     GIR_RootConstrainSelectedInstOperands,
     /* 149721 */     // GIR_Coverage, 7385,
     /* 149721 */     GIR_EraseRootFromParent_Done,
     /* 149722 */   // Label 2645: @149722
     /* 149722 */   GIM_Try, /*On fail goto*//*Label 2646*/ GIMT_Encode4(149796), // Rule ID 7386 //
     /* 149727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149730 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149737 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 149740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149744 */     // MIs[0] Rn
     /* 149744 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149756 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_release>>  =>  (LDCLRLW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149768 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149774 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149778 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLW),
     /* 149783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149788 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149794 */     GIR_RootConstrainSelectedInstOperands,
     /* 149795 */     // GIR_Coverage, 7386,
     /* 149795 */     GIR_EraseRootFromParent_Done,
     /* 149796 */   // Label 2646: @149796
     /* 149796 */   GIM_Try, /*On fail goto*//*Label 2647*/ GIMT_Encode4(149870), // Rule ID 7387 //
     /* 149801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149804 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149811 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 149814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149818 */     // MIs[0] Rn
     /* 149818 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149822 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149830 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_acq_rel>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149830 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149833 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149837 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149842 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149848 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149868 */     GIR_RootConstrainSelectedInstOperands,
     /* 149869 */     // GIR_Coverage, 7387,
     /* 149869 */     GIR_EraseRootFromParent_Done,
     /* 149870 */   // Label 2647: @149870
     /* 149870 */   GIM_Try, /*On fail goto*//*Label 2648*/ GIMT_Encode4(149944), // Rule ID 7388 //
     /* 149875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149878 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 149885 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 149888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149892 */     // MIs[0] Rn
     /* 149892 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149896 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149904 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i32>><<P:Predicate_atomic_load_and_i32_seq_cst>>  =>  (LDCLRALW:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149916 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149922 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 149926 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 149928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALW),
     /* 149931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 149933 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 149936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 149938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 149942 */     GIR_RootConstrainSelectedInstOperands,
     /* 149943 */     // GIR_Coverage, 7388,
     /* 149943 */     GIR_EraseRootFromParent_Done,
     /* 149944 */   // Label 2648: @149944
     /* 149944 */   GIM_Try, /*On fail goto*//*Label 2649*/ GIMT_Encode4(150018), // Rule ID 7389 //
     /* 149949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 149952 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 149959 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 149962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149966 */     // MIs[0] Rn
     /* 149966 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 149970 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 149974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 149978 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_monotonic>>  =>  (LDCLRH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 149978 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 149981 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 149985 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 149990 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 149996 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150000 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRH),
     /* 150005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150010 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150012 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150016 */     GIR_RootConstrainSelectedInstOperands,
     /* 150017 */     // GIR_Coverage, 7389,
     /* 150017 */     GIR_EraseRootFromParent_Done,
     /* 150018 */   // Label 2649: @150018
     /* 150018 */   GIM_Try, /*On fail goto*//*Label 2650*/ GIMT_Encode4(150092), // Rule ID 7390 //
     /* 150023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150026 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150033 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150040 */     // MIs[0] Rn
     /* 150040 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150052 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acquire>>  =>  (LDCLRAH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150052 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150055 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150059 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150064 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150070 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAH),
     /* 150079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150081 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150084 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150086 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150090 */     GIR_RootConstrainSelectedInstOperands,
     /* 150091 */     // GIR_Coverage, 7390,
     /* 150091 */     GIR_EraseRootFromParent_Done,
     /* 150092 */   // Label 2650: @150092
     /* 150092 */   GIM_Try, /*On fail goto*//*Label 2651*/ GIMT_Encode4(150166), // Rule ID 7391 //
     /* 150097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150100 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150107 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150114 */     // MIs[0] Rn
     /* 150114 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150118 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150126 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_release>>  =>  (LDCLRLH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150138 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150144 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150148 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150150 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLH),
     /* 150153 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150155 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150158 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150160 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150164 */     GIR_RootConstrainSelectedInstOperands,
     /* 150165 */     // GIR_Coverage, 7391,
     /* 150165 */     GIR_EraseRootFromParent_Done,
     /* 150166 */   // Label 2651: @150166
     /* 150166 */   GIM_Try, /*On fail goto*//*Label 2652*/ GIMT_Encode4(150240), // Rule ID 7392 //
     /* 150171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150174 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150181 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150188 */     // MIs[0] Rn
     /* 150188 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150200 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_acq_rel>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150212 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150222 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150229 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150234 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150238 */     GIR_RootConstrainSelectedInstOperands,
     /* 150239 */     // GIR_Coverage, 7392,
     /* 150239 */     GIR_EraseRootFromParent_Done,
     /* 150240 */   // Label 2652: @150240
     /* 150240 */   GIM_Try, /*On fail goto*//*Label 2653*/ GIMT_Encode4(150314), // Rule ID 7393 //
     /* 150245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150248 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 150255 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150262 */     // MIs[0] Rn
     /* 150262 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150274 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i16>><<P:Predicate_atomic_load_and_i16_seq_cst>>  =>  (LDCLRALH:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150274 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150277 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150281 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150286 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150292 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150296 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALH),
     /* 150301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150303 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150312 */     GIR_RootConstrainSelectedInstOperands,
     /* 150313 */     // GIR_Coverage, 7393,
     /* 150313 */     GIR_EraseRootFromParent_Done,
     /* 150314 */   // Label 2653: @150314
     /* 150314 */   GIM_Try, /*On fail goto*//*Label 2654*/ GIMT_Encode4(150388), // Rule ID 7394 //
     /* 150319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150322 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150329 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150336 */     // MIs[0] Rn
     /* 150336 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150348 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_monotonic>>  =>  (LDCLRB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150348 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150351 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150355 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150360 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150366 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150370 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRB),
     /* 150375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150377 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150382 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150386 */     GIR_RootConstrainSelectedInstOperands,
     /* 150387 */     // GIR_Coverage, 7394,
     /* 150387 */     GIR_EraseRootFromParent_Done,
     /* 150388 */   // Label 2654: @150388
     /* 150388 */   GIM_Try, /*On fail goto*//*Label 2655*/ GIMT_Encode4(150462), // Rule ID 7395 //
     /* 150393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150396 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150403 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150406 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150410 */     // MIs[0] Rn
     /* 150410 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150414 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150422 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acquire>>  =>  (LDCLRAB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150422 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150425 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150429 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150434 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150440 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAB),
     /* 150449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150456 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150460 */     GIR_RootConstrainSelectedInstOperands,
     /* 150461 */     // GIR_Coverage, 7395,
     /* 150461 */     GIR_EraseRootFromParent_Done,
     /* 150462 */   // Label 2655: @150462
     /* 150462 */   GIM_Try, /*On fail goto*//*Label 2656*/ GIMT_Encode4(150536), // Rule ID 7396 //
     /* 150467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150470 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150477 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150484 */     // MIs[0] Rn
     /* 150484 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150488 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150492 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150496 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_release>>  =>  (LDCLRLB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150508 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150514 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150518 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLB),
     /* 150523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150528 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150530 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150534 */     GIR_RootConstrainSelectedInstOperands,
     /* 150535 */     // GIR_Coverage, 7396,
     /* 150535 */     GIR_EraseRootFromParent_Done,
     /* 150536 */   // Label 2656: @150536
     /* 150536 */   GIM_Try, /*On fail goto*//*Label 2657*/ GIMT_Encode4(150610), // Rule ID 7397 //
     /* 150541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150544 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150551 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150558 */     // MIs[0] Rn
     /* 150558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150562 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150570 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_acq_rel>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150582 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150588 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150602 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150604 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150608 */     GIR_RootConstrainSelectedInstOperands,
     /* 150609 */     // GIR_Coverage, 7397,
     /* 150609 */     GIR_EraseRootFromParent_Done,
     /* 150610 */   // Label 2657: @150610
     /* 150610 */   GIM_Try, /*On fail goto*//*Label 2658*/ GIMT_Encode4(150684), // Rule ID 7398 //
     /* 150615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150618 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 150625 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150632 */     // MIs[0] Rn
     /* 150632 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150636 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 150644 */     // (atomic_load_and:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_and_i8>><<P:Predicate_atomic_load_and_i8_seq_cst>>  =>  (LDCLRALB:{ *:[i32] } (ORNWrr:{ *:[i32] } WZR:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 150647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNWrr),
     /* 150651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150656 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150662 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150666 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALB),
     /* 150671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150673 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150676 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150682 */     GIR_RootConstrainSelectedInstOperands,
     /* 150683 */     // GIR_Coverage, 7398,
     /* 150683 */     GIR_EraseRootFromParent_Done,
     /* 150684 */   // Label 2658: @150684
     /* 150684 */   GIM_Reject,
     /* 150685 */ // Label 2643: @150685
     /* 150685 */ GIM_Reject,
     /* 150686 */ // Label 2641: @150686
     /* 150686 */ GIM_Try, /*On fail goto*//*Label 2659*/ GIMT_Encode4(151037),
     /* 150691 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 150694 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 150701 */   GIM_Try, /*On fail goto*//*Label 2660*/ GIMT_Encode4(150768), // Rule ID 7379 //
     /* 150706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150709 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 150712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150716 */     // MIs[0] Rn
     /* 150716 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150728 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_monotonic>>  =>  (LDCLRX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150728 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150731 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150735 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150740 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150746 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRX),
     /* 150755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150757 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150762 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150766 */     GIR_RootConstrainSelectedInstOperands,
     /* 150767 */     // GIR_Coverage, 7379,
     /* 150767 */     GIR_EraseRootFromParent_Done,
     /* 150768 */   // Label 2660: @150768
     /* 150768 */   GIM_Try, /*On fail goto*//*Label 2661*/ GIMT_Encode4(150835), // Rule ID 7380 //
     /* 150773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150776 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 150779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150783 */     // MIs[0] Rn
     /* 150783 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150787 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150795 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acquire>>  =>  (LDCLRAX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150795 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150798 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150802 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150807 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150813 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150817 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRAX),
     /* 150822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150829 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150833 */     GIR_RootConstrainSelectedInstOperands,
     /* 150834 */     // GIR_Coverage, 7380,
     /* 150834 */     GIR_EraseRootFromParent_Done,
     /* 150835 */   // Label 2661: @150835
     /* 150835 */   GIM_Try, /*On fail goto*//*Label 2662*/ GIMT_Encode4(150902), // Rule ID 7381 //
     /* 150840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150843 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 150846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150850 */     // MIs[0] Rn
     /* 150850 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150862 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_release>>  =>  (LDCLRLX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150862 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150865 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150869 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150874 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150880 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150884 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRLX),
     /* 150889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150891 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150900 */     GIR_RootConstrainSelectedInstOperands,
     /* 150901 */     // GIR_Coverage, 7381,
     /* 150901 */     GIR_EraseRootFromParent_Done,
     /* 150902 */   // Label 2662: @150902
     /* 150902 */   GIM_Try, /*On fail goto*//*Label 2663*/ GIMT_Encode4(150969), // Rule ID 7382 //
     /* 150907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 150913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150917 */     // MIs[0] Rn
     /* 150917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150929 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_acq_rel>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 150936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 150941 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 150947 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 150951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 150953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 150956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 150958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 150961 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 150963 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 150967 */     GIR_RootConstrainSelectedInstOperands,
     /* 150968 */     // GIR_Coverage, 7382,
     /* 150968 */     GIR_EraseRootFromParent_Done,
     /* 150969 */   // Label 2663: @150969
     /* 150969 */   GIM_Try, /*On fail goto*//*Label 2664*/ GIMT_Encode4(151036), // Rule ID 7383 //
     /* 150974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 150977 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 150980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150984 */     // MIs[0] Rn
     /* 150984 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 150988 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 150992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 150996 */     // (atomic_load_and:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_and_i64>><<P:Predicate_atomic_load_and_i64_seq_cst>>  =>  (LDCLRALX:{ *:[i64] } (ORNXrr:{ *:[i64] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$Rm), GPR64sp:{ *:[i64] }:$Rn)
     /* 150996 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 150999 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ORNXrr),
     /* 151003 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 151008 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 151014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 151018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 151020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDCLRALX),
     /* 151023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 151028 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151030 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151034 */     GIR_RootConstrainSelectedInstOperands,
     /* 151035 */     // GIR_Coverage, 7383,
     /* 151035 */     GIR_EraseRootFromParent_Done,
     /* 151036 */   // Label 2664: @151036
     /* 151036 */   GIM_Reject,
     /* 151037 */ // Label 2659: @151037
     /* 151037 */ GIM_Reject,
     /* 151038 */ // Label 2642: @151038
     /* 151038 */ GIM_Reject,
     /* 151039 */ // Label 25: @151039
     /* 151039 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2667*/ GIMT_Encode4(152030),
     /* 151050 */ /*GILLT_s32*//*Label 2665*/ GIMT_Encode4(151058),
     /* 151054 */ /*GILLT_s64*//*Label 2666*/ GIMT_Encode4(151803),
     /* 151058 */ // Label 2665: @151058
     /* 151058 */ GIM_Try, /*On fail goto*//*Label 2668*/ GIMT_Encode4(151802),
     /* 151063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 151066 */   GIM_Try, /*On fail goto*//*Label 2669*/ GIMT_Encode4(151115), // Rule ID 7189 //
     /* 151071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151074 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151081 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151088 */     // MIs[0] Rn
     /* 151088 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151092 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151096 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151100 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_monotonic>>  =>  (LDSETW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETW),
     /* 151103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151107 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151109 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151113 */     GIR_RootConstrainSelectedInstOperands,
     /* 151114 */     // GIR_Coverage, 7189,
     /* 151114 */     GIR_EraseRootFromParent_Done,
     /* 151115 */   // Label 2669: @151115
     /* 151115 */   GIM_Try, /*On fail goto*//*Label 2670*/ GIMT_Encode4(151164), // Rule ID 7190 //
     /* 151120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151123 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151130 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151133 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151137 */     // MIs[0] Rn
     /* 151137 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151141 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151145 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151149 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acquire>>  =>  (LDSETAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAW),
     /* 151152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151156 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151162 */     GIR_RootConstrainSelectedInstOperands,
     /* 151163 */     // GIR_Coverage, 7190,
     /* 151163 */     GIR_EraseRootFromParent_Done,
     /* 151164 */   // Label 2670: @151164
     /* 151164 */   GIM_Try, /*On fail goto*//*Label 2671*/ GIMT_Encode4(151213), // Rule ID 7191 //
     /* 151169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151172 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151179 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151182 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151186 */     // MIs[0] Rn
     /* 151186 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151198 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_release>>  =>  (LDSETLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLW),
     /* 151201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151205 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151211 */     GIR_RootConstrainSelectedInstOperands,
     /* 151212 */     // GIR_Coverage, 7191,
     /* 151212 */     GIR_EraseRootFromParent_Done,
     /* 151213 */   // Label 2671: @151213
     /* 151213 */   GIM_Try, /*On fail goto*//*Label 2672*/ GIMT_Encode4(151262), // Rule ID 7192 //
     /* 151218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151221 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151228 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151235 */     // MIs[0] Rn
     /* 151235 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151247 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_acq_rel>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151256 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151260 */     GIR_RootConstrainSelectedInstOperands,
     /* 151261 */     // GIR_Coverage, 7192,
     /* 151261 */     GIR_EraseRootFromParent_Done,
     /* 151262 */   // Label 2672: @151262
     /* 151262 */   GIM_Try, /*On fail goto*//*Label 2673*/ GIMT_Encode4(151311), // Rule ID 7193 //
     /* 151267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151270 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 151277 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151284 */     // MIs[0] Rn
     /* 151284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151288 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151296 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i32>><<P:Predicate_atomic_load_or_i32_seq_cst>>  =>  (LDSETALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALW),
     /* 151299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151303 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151305 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151309 */     GIR_RootConstrainSelectedInstOperands,
     /* 151310 */     // GIR_Coverage, 7193,
     /* 151310 */     GIR_EraseRootFromParent_Done,
     /* 151311 */   // Label 2673: @151311
     /* 151311 */   GIM_Try, /*On fail goto*//*Label 2674*/ GIMT_Encode4(151360), // Rule ID 7194 //
     /* 151316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151319 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151326 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151333 */     // MIs[0] Rn
     /* 151333 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151341 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151345 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_monotonic>>  =>  (LDSETH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETH),
     /* 151348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151352 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151354 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151358 */     GIR_RootConstrainSelectedInstOperands,
     /* 151359 */     // GIR_Coverage, 7194,
     /* 151359 */     GIR_EraseRootFromParent_Done,
     /* 151360 */   // Label 2674: @151360
     /* 151360 */   GIM_Try, /*On fail goto*//*Label 2675*/ GIMT_Encode4(151409), // Rule ID 7195 //
     /* 151365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151368 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151375 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151382 */     // MIs[0] Rn
     /* 151382 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151386 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151394 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acquire>>  =>  (LDSETAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAH),
     /* 151397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151401 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151403 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151407 */     GIR_RootConstrainSelectedInstOperands,
     /* 151408 */     // GIR_Coverage, 7195,
     /* 151408 */     GIR_EraseRootFromParent_Done,
     /* 151409 */   // Label 2675: @151409
     /* 151409 */   GIM_Try, /*On fail goto*//*Label 2676*/ GIMT_Encode4(151458), // Rule ID 7196 //
     /* 151414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151417 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151424 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151431 */     // MIs[0] Rn
     /* 151431 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151435 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151443 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_release>>  =>  (LDSETLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLH),
     /* 151446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151452 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151456 */     GIR_RootConstrainSelectedInstOperands,
     /* 151457 */     // GIR_Coverage, 7196,
     /* 151457 */     GIR_EraseRootFromParent_Done,
     /* 151458 */   // Label 2676: @151458
     /* 151458 */   GIM_Try, /*On fail goto*//*Label 2677*/ GIMT_Encode4(151507), // Rule ID 7197 //
     /* 151463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151466 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151473 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151480 */     // MIs[0] Rn
     /* 151480 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151484 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151492 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_acq_rel>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151499 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151501 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151505 */     GIR_RootConstrainSelectedInstOperands,
     /* 151506 */     // GIR_Coverage, 7197,
     /* 151506 */     GIR_EraseRootFromParent_Done,
     /* 151507 */   // Label 2677: @151507
     /* 151507 */   GIM_Try, /*On fail goto*//*Label 2678*/ GIMT_Encode4(151556), // Rule ID 7198 //
     /* 151512 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151515 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 151522 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151529 */     // MIs[0] Rn
     /* 151529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151533 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151541 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i16>><<P:Predicate_atomic_load_or_i16_seq_cst>>  =>  (LDSETALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151541 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALH),
     /* 151544 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151546 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151548 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151550 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151554 */     GIR_RootConstrainSelectedInstOperands,
     /* 151555 */     // GIR_Coverage, 7198,
     /* 151555 */     GIR_EraseRootFromParent_Done,
     /* 151556 */   // Label 2678: @151556
     /* 151556 */   GIM_Try, /*On fail goto*//*Label 2679*/ GIMT_Encode4(151605), // Rule ID 7199 //
     /* 151561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151564 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151571 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151574 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151578 */     // MIs[0] Rn
     /* 151578 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151582 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151590 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_monotonic>>  =>  (LDSETB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETB),
     /* 151593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151597 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151599 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151603 */     GIR_RootConstrainSelectedInstOperands,
     /* 151604 */     // GIR_Coverage, 7199,
     /* 151604 */     GIR_EraseRootFromParent_Done,
     /* 151605 */   // Label 2679: @151605
     /* 151605 */   GIM_Try, /*On fail goto*//*Label 2680*/ GIMT_Encode4(151654), // Rule ID 7200 //
     /* 151610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151613 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151620 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151627 */     // MIs[0] Rn
     /* 151627 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151631 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151635 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151639 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acquire>>  =>  (LDSETAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAB),
     /* 151642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151646 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151648 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151652 */     GIR_RootConstrainSelectedInstOperands,
     /* 151653 */     // GIR_Coverage, 7200,
     /* 151653 */     GIR_EraseRootFromParent_Done,
     /* 151654 */   // Label 2680: @151654
     /* 151654 */   GIM_Try, /*On fail goto*//*Label 2681*/ GIMT_Encode4(151703), // Rule ID 7201 //
     /* 151659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151662 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151669 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151676 */     // MIs[0] Rn
     /* 151676 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151680 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151688 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_release>>  =>  (LDSETLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLB),
     /* 151691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151695 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151697 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151701 */     GIR_RootConstrainSelectedInstOperands,
     /* 151702 */     // GIR_Coverage, 7201,
     /* 151702 */     GIR_EraseRootFromParent_Done,
     /* 151703 */   // Label 2681: @151703
     /* 151703 */   GIM_Try, /*On fail goto*//*Label 2682*/ GIMT_Encode4(151752), // Rule ID 7202 //
     /* 151708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151711 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151718 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151725 */     // MIs[0] Rn
     /* 151725 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151737 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_acq_rel>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151744 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151746 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151750 */     GIR_RootConstrainSelectedInstOperands,
     /* 151751 */     // GIR_Coverage, 7202,
     /* 151751 */     GIR_EraseRootFromParent_Done,
     /* 151752 */   // Label 2682: @151752
     /* 151752 */   GIM_Try, /*On fail goto*//*Label 2683*/ GIMT_Encode4(151801), // Rule ID 7203 //
     /* 151757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151760 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 151767 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151774 */     // MIs[0] Rn
     /* 151774 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151778 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 151786 */     // (atomic_load_or:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_or_i8>><<P:Predicate_atomic_load_or_i8_seq_cst>>  =>  (LDSETALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALB),
     /* 151789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151795 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151799 */     GIR_RootConstrainSelectedInstOperands,
     /* 151800 */     // GIR_Coverage, 7203,
     /* 151800 */     GIR_EraseRootFromParent_Done,
     /* 151801 */   // Label 2683: @151801
     /* 151801 */   GIM_Reject,
     /* 151802 */ // Label 2668: @151802
     /* 151802 */ GIM_Reject,
     /* 151803 */ // Label 2666: @151803
     /* 151803 */ GIM_Try, /*On fail goto*//*Label 2684*/ GIMT_Encode4(152029),
     /* 151808 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 151811 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 151818 */   GIM_Try, /*On fail goto*//*Label 2685*/ GIMT_Encode4(151860), // Rule ID 7184 //
     /* 151823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 151829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151833 */     // MIs[0] Rn
     /* 151833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151845 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_monotonic>>  =>  (LDSETX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETX),
     /* 151848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151858 */     GIR_RootConstrainSelectedInstOperands,
     /* 151859 */     // GIR_Coverage, 7184,
     /* 151859 */     GIR_EraseRootFromParent_Done,
     /* 151860 */   // Label 2685: @151860
     /* 151860 */   GIM_Try, /*On fail goto*//*Label 2686*/ GIMT_Encode4(151902), // Rule ID 7185 //
     /* 151865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 151871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151875 */     // MIs[0] Rn
     /* 151875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151887 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acquire>>  =>  (LDSETAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETAX),
     /* 151890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151900 */     GIR_RootConstrainSelectedInstOperands,
     /* 151901 */     // GIR_Coverage, 7185,
     /* 151901 */     GIR_EraseRootFromParent_Done,
     /* 151902 */   // Label 2686: @151902
     /* 151902 */   GIM_Try, /*On fail goto*//*Label 2687*/ GIMT_Encode4(151944), // Rule ID 7186 //
     /* 151907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 151913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151917 */     // MIs[0] Rn
     /* 151917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151929 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_release>>  =>  (LDSETLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETLX),
     /* 151932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151942 */     GIR_RootConstrainSelectedInstOperands,
     /* 151943 */     // GIR_Coverage, 7186,
     /* 151943 */     GIR_EraseRootFromParent_Done,
     /* 151944 */   // Label 2687: @151944
     /* 151944 */   GIM_Try, /*On fail goto*//*Label 2688*/ GIMT_Encode4(151986), // Rule ID 7187 //
     /* 151949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151952 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 151955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151959 */     // MIs[0] Rn
     /* 151959 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 151963 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 151967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 151971 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_acq_rel>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 151971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 151974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 151976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 151978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 151980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 151984 */     GIR_RootConstrainSelectedInstOperands,
     /* 151985 */     // GIR_Coverage, 7187,
     /* 151985 */     GIR_EraseRootFromParent_Done,
     /* 151986 */   // Label 2688: @151986
     /* 151986 */   GIM_Try, /*On fail goto*//*Label 2689*/ GIMT_Encode4(152028), // Rule ID 7188 //
     /* 151991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 151994 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 151997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152001 */     // MIs[0] Rn
     /* 152001 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152013 */     // (atomic_load_or:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_or_i64>><<P:Predicate_atomic_load_or_i64_seq_cst>>  =>  (LDSETALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSETALX),
     /* 152016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152022 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152026 */     GIR_RootConstrainSelectedInstOperands,
     /* 152027 */     // GIR_Coverage, 7188,
     /* 152027 */     GIR_EraseRootFromParent_Done,
     /* 152028 */   // Label 2689: @152028
     /* 152028 */   GIM_Reject,
     /* 152029 */ // Label 2684: @152029
     /* 152029 */ GIM_Reject,
     /* 152030 */ // Label 2667: @152030
     /* 152030 */ GIM_Reject,
     /* 152031 */ // Label 26: @152031
     /* 152031 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2692*/ GIMT_Encode4(153022),
     /* 152042 */ /*GILLT_s32*//*Label 2690*/ GIMT_Encode4(152050),
     /* 152046 */ /*GILLT_s64*//*Label 2691*/ GIMT_Encode4(152795),
     /* 152050 */ // Label 2690: @152050
     /* 152050 */ GIM_Try, /*On fail goto*//*Label 2693*/ GIMT_Encode4(152794),
     /* 152055 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 152058 */   GIM_Try, /*On fail goto*//*Label 2694*/ GIMT_Encode4(152107), // Rule ID 7209 //
     /* 152063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152066 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152073 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152080 */     // MIs[0] Rn
     /* 152080 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152084 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152092 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_monotonic>>  =>  (LDEORW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORW),
     /* 152095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152099 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152101 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152105 */     GIR_RootConstrainSelectedInstOperands,
     /* 152106 */     // GIR_Coverage, 7209,
     /* 152106 */     GIR_EraseRootFromParent_Done,
     /* 152107 */   // Label 2694: @152107
     /* 152107 */   GIM_Try, /*On fail goto*//*Label 2695*/ GIMT_Encode4(152156), // Rule ID 7210 //
     /* 152112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152115 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152122 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152129 */     // MIs[0] Rn
     /* 152129 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152137 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152141 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acquire>>  =>  (LDEORAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAW),
     /* 152144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152148 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152150 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152154 */     GIR_RootConstrainSelectedInstOperands,
     /* 152155 */     // GIR_Coverage, 7210,
     /* 152155 */     GIR_EraseRootFromParent_Done,
     /* 152156 */   // Label 2695: @152156
     /* 152156 */   GIM_Try, /*On fail goto*//*Label 2696*/ GIMT_Encode4(152205), // Rule ID 7211 //
     /* 152161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152164 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152171 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152178 */     // MIs[0] Rn
     /* 152178 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152190 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_release>>  =>  (LDEORLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLW),
     /* 152193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152197 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152199 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152203 */     GIR_RootConstrainSelectedInstOperands,
     /* 152204 */     // GIR_Coverage, 7211,
     /* 152204 */     GIR_EraseRootFromParent_Done,
     /* 152205 */   // Label 2696: @152205
     /* 152205 */   GIM_Try, /*On fail goto*//*Label 2697*/ GIMT_Encode4(152254), // Rule ID 7212 //
     /* 152210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152213 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152220 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152227 */     // MIs[0] Rn
     /* 152227 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152231 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152239 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_acq_rel>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152246 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152248 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152252 */     GIR_RootConstrainSelectedInstOperands,
     /* 152253 */     // GIR_Coverage, 7212,
     /* 152253 */     GIR_EraseRootFromParent_Done,
     /* 152254 */   // Label 2697: @152254
     /* 152254 */   GIM_Try, /*On fail goto*//*Label 2698*/ GIMT_Encode4(152303), // Rule ID 7213 //
     /* 152259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152262 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 152269 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152276 */     // MIs[0] Rn
     /* 152276 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152288 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i32>><<P:Predicate_atomic_load_xor_i32_seq_cst>>  =>  (LDEORALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALW),
     /* 152291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152295 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152301 */     GIR_RootConstrainSelectedInstOperands,
     /* 152302 */     // GIR_Coverage, 7213,
     /* 152302 */     GIR_EraseRootFromParent_Done,
     /* 152303 */   // Label 2698: @152303
     /* 152303 */   GIM_Try, /*On fail goto*//*Label 2699*/ GIMT_Encode4(152352), // Rule ID 7214 //
     /* 152308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152311 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152318 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152325 */     // MIs[0] Rn
     /* 152325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152333 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152337 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_monotonic>>  =>  (LDEORH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORH),
     /* 152340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152346 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152350 */     GIR_RootConstrainSelectedInstOperands,
     /* 152351 */     // GIR_Coverage, 7214,
     /* 152351 */     GIR_EraseRootFromParent_Done,
     /* 152352 */   // Label 2699: @152352
     /* 152352 */   GIM_Try, /*On fail goto*//*Label 2700*/ GIMT_Encode4(152401), // Rule ID 7215 //
     /* 152357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152360 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152367 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152374 */     // MIs[0] Rn
     /* 152374 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152378 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152386 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acquire>>  =>  (LDEORAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAH),
     /* 152389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152393 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152395 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152399 */     GIR_RootConstrainSelectedInstOperands,
     /* 152400 */     // GIR_Coverage, 7215,
     /* 152400 */     GIR_EraseRootFromParent_Done,
     /* 152401 */   // Label 2700: @152401
     /* 152401 */   GIM_Try, /*On fail goto*//*Label 2701*/ GIMT_Encode4(152450), // Rule ID 7216 //
     /* 152406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152409 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152416 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152423 */     // MIs[0] Rn
     /* 152423 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152427 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152435 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_release>>  =>  (LDEORLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLH),
     /* 152438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152444 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152448 */     GIR_RootConstrainSelectedInstOperands,
     /* 152449 */     // GIR_Coverage, 7216,
     /* 152449 */     GIR_EraseRootFromParent_Done,
     /* 152450 */   // Label 2701: @152450
     /* 152450 */   GIM_Try, /*On fail goto*//*Label 2702*/ GIMT_Encode4(152499), // Rule ID 7217 //
     /* 152455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152458 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152465 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152472 */     // MIs[0] Rn
     /* 152472 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152476 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152484 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_acq_rel>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152491 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152493 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152497 */     GIR_RootConstrainSelectedInstOperands,
     /* 152498 */     // GIR_Coverage, 7217,
     /* 152498 */     GIR_EraseRootFromParent_Done,
     /* 152499 */   // Label 2702: @152499
     /* 152499 */   GIM_Try, /*On fail goto*//*Label 2703*/ GIMT_Encode4(152548), // Rule ID 7218 //
     /* 152504 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152507 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 152514 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152521 */     // MIs[0] Rn
     /* 152521 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152533 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i16>><<P:Predicate_atomic_load_xor_i16_seq_cst>>  =>  (LDEORALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALH),
     /* 152536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152542 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152546 */     GIR_RootConstrainSelectedInstOperands,
     /* 152547 */     // GIR_Coverage, 7218,
     /* 152547 */     GIR_EraseRootFromParent_Done,
     /* 152548 */   // Label 2703: @152548
     /* 152548 */   GIM_Try, /*On fail goto*//*Label 2704*/ GIMT_Encode4(152597), // Rule ID 7219 //
     /* 152553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152556 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152563 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152570 */     // MIs[0] Rn
     /* 152570 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152574 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152582 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_monotonic>>  =>  (LDEORB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORB),
     /* 152585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152589 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152591 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152595 */     GIR_RootConstrainSelectedInstOperands,
     /* 152596 */     // GIR_Coverage, 7219,
     /* 152596 */     GIR_EraseRootFromParent_Done,
     /* 152597 */   // Label 2704: @152597
     /* 152597 */   GIM_Try, /*On fail goto*//*Label 2705*/ GIMT_Encode4(152646), // Rule ID 7220 //
     /* 152602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152605 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152612 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152619 */     // MIs[0] Rn
     /* 152619 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152627 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152631 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acquire>>  =>  (LDEORAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAB),
     /* 152634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152638 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152640 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152644 */     GIR_RootConstrainSelectedInstOperands,
     /* 152645 */     // GIR_Coverage, 7220,
     /* 152645 */     GIR_EraseRootFromParent_Done,
     /* 152646 */   // Label 2705: @152646
     /* 152646 */   GIM_Try, /*On fail goto*//*Label 2706*/ GIMT_Encode4(152695), // Rule ID 7221 //
     /* 152651 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152654 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152661 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152668 */     // MIs[0] Rn
     /* 152668 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152672 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152680 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_release>>  =>  (LDEORLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLB),
     /* 152683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152687 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152689 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152693 */     GIR_RootConstrainSelectedInstOperands,
     /* 152694 */     // GIR_Coverage, 7221,
     /* 152694 */     GIR_EraseRootFromParent_Done,
     /* 152695 */   // Label 2706: @152695
     /* 152695 */   GIM_Try, /*On fail goto*//*Label 2707*/ GIMT_Encode4(152744), // Rule ID 7222 //
     /* 152700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152703 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152710 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152717 */     // MIs[0] Rn
     /* 152717 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152721 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152725 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152729 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_acq_rel>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152738 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152742 */     GIR_RootConstrainSelectedInstOperands,
     /* 152743 */     // GIR_Coverage, 7222,
     /* 152743 */     GIR_EraseRootFromParent_Done,
     /* 152744 */   // Label 2707: @152744
     /* 152744 */   GIM_Try, /*On fail goto*//*Label 2708*/ GIMT_Encode4(152793), // Rule ID 7223 //
     /* 152749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152752 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 152759 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152766 */     // MIs[0] Rn
     /* 152766 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 152778 */     // (atomic_load_xor:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_xor_i8>><<P:Predicate_atomic_load_xor_i8_seq_cst>>  =>  (LDEORALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALB),
     /* 152781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152785 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152787 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152791 */     GIR_RootConstrainSelectedInstOperands,
     /* 152792 */     // GIR_Coverage, 7223,
     /* 152792 */     GIR_EraseRootFromParent_Done,
     /* 152793 */   // Label 2708: @152793
     /* 152793 */   GIM_Reject,
     /* 152794 */ // Label 2693: @152794
     /* 152794 */ GIM_Reject,
     /* 152795 */ // Label 2691: @152795
     /* 152795 */ GIM_Try, /*On fail goto*//*Label 2709*/ GIMT_Encode4(153021),
     /* 152800 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 152803 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 152810 */   GIM_Try, /*On fail goto*//*Label 2710*/ GIMT_Encode4(152852), // Rule ID 7204 //
     /* 152815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152818 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 152821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152825 */     // MIs[0] Rn
     /* 152825 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152829 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152837 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_monotonic>>  =>  (LDEORX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORX),
     /* 152840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152844 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152846 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152850 */     GIR_RootConstrainSelectedInstOperands,
     /* 152851 */     // GIR_Coverage, 7204,
     /* 152851 */     GIR_EraseRootFromParent_Done,
     /* 152852 */   // Label 2710: @152852
     /* 152852 */   GIM_Try, /*On fail goto*//*Label 2711*/ GIMT_Encode4(152894), // Rule ID 7205 //
     /* 152857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152860 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 152863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152867 */     // MIs[0] Rn
     /* 152867 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152871 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152875 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152879 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acquire>>  =>  (LDEORAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORAX),
     /* 152882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152888 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152892 */     GIR_RootConstrainSelectedInstOperands,
     /* 152893 */     // GIR_Coverage, 7205,
     /* 152893 */     GIR_EraseRootFromParent_Done,
     /* 152894 */   // Label 2711: @152894
     /* 152894 */   GIM_Try, /*On fail goto*//*Label 2712*/ GIMT_Encode4(152936), // Rule ID 7206 //
     /* 152899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152902 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 152905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152909 */     // MIs[0] Rn
     /* 152909 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152921 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_release>>  =>  (LDEORLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORLX),
     /* 152924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152928 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152930 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152934 */     GIR_RootConstrainSelectedInstOperands,
     /* 152935 */     // GIR_Coverage, 7206,
     /* 152935 */     GIR_EraseRootFromParent_Done,
     /* 152936 */   // Label 2712: @152936
     /* 152936 */   GIM_Try, /*On fail goto*//*Label 2713*/ GIMT_Encode4(152978), // Rule ID 7207 //
     /* 152941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152944 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 152947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152951 */     // MIs[0] Rn
     /* 152951 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 152959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152963 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_acq_rel>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 152963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 152966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 152968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 152970 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 152972 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 152976 */     GIR_RootConstrainSelectedInstOperands,
     /* 152977 */     // GIR_Coverage, 7207,
     /* 152977 */     GIR_EraseRootFromParent_Done,
     /* 152978 */   // Label 2713: @152978
     /* 152978 */   GIM_Try, /*On fail goto*//*Label 2714*/ GIMT_Encode4(153020), // Rule ID 7208 //
     /* 152983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 152986 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 152989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 152993 */     // MIs[0] Rn
     /* 152993 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 152997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153005 */     // (atomic_load_xor:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_xor_i64>><<P:Predicate_atomic_load_xor_i64_seq_cst>>  =>  (LDEORALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDEORALX),
     /* 153008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153012 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153018 */     GIR_RootConstrainSelectedInstOperands,
     /* 153019 */     // GIR_Coverage, 7208,
     /* 153019 */     GIR_EraseRootFromParent_Done,
     /* 153020 */   // Label 2714: @153020
     /* 153020 */   GIM_Reject,
     /* 153021 */ // Label 2709: @153021
     /* 153021 */ GIM_Reject,
     /* 153022 */ // Label 2692: @153022
     /* 153022 */ GIM_Reject,
     /* 153023 */ // Label 27: @153023
     /* 153023 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2717*/ GIMT_Encode4(154014),
     /* 153034 */ /*GILLT_s32*//*Label 2715*/ GIMT_Encode4(153042),
     /* 153038 */ /*GILLT_s64*//*Label 2716*/ GIMT_Encode4(153787),
     /* 153042 */ // Label 2715: @153042
     /* 153042 */ GIM_Try, /*On fail goto*//*Label 2718*/ GIMT_Encode4(153786),
     /* 153047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 153050 */   GIM_Try, /*On fail goto*//*Label 2719*/ GIMT_Encode4(153099), // Rule ID 7249 //
     /* 153055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153058 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153065 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153072 */     // MIs[0] Rn
     /* 153072 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153076 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153084 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_monotonic>>  =>  (LDSMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXW),
     /* 153087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153093 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153097 */     GIR_RootConstrainSelectedInstOperands,
     /* 153098 */     // GIR_Coverage, 7249,
     /* 153098 */     GIR_EraseRootFromParent_Done,
     /* 153099 */   // Label 2719: @153099
     /* 153099 */   GIM_Try, /*On fail goto*//*Label 2720*/ GIMT_Encode4(153148), // Rule ID 7250 //
     /* 153104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153107 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153114 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153121 */     // MIs[0] Rn
     /* 153121 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153125 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153133 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acquire>>  =>  (LDSMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAW),
     /* 153136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153140 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153146 */     GIR_RootConstrainSelectedInstOperands,
     /* 153147 */     // GIR_Coverage, 7250,
     /* 153147 */     GIR_EraseRootFromParent_Done,
     /* 153148 */   // Label 2720: @153148
     /* 153148 */   GIM_Try, /*On fail goto*//*Label 2721*/ GIMT_Encode4(153197), // Rule ID 7251 //
     /* 153153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153156 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153170 */     // MIs[0] Rn
     /* 153170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153182 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_release>>  =>  (LDSMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLW),
     /* 153185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153195 */     GIR_RootConstrainSelectedInstOperands,
     /* 153196 */     // GIR_Coverage, 7251,
     /* 153196 */     GIR_EraseRootFromParent_Done,
     /* 153197 */   // Label 2721: @153197
     /* 153197 */   GIM_Try, /*On fail goto*//*Label 2722*/ GIMT_Encode4(153246), // Rule ID 7252 //
     /* 153202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153205 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153212 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153219 */     // MIs[0] Rn
     /* 153219 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153223 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153231 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_acq_rel>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153238 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153240 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153244 */     GIR_RootConstrainSelectedInstOperands,
     /* 153245 */     // GIR_Coverage, 7252,
     /* 153245 */     GIR_EraseRootFromParent_Done,
     /* 153246 */   // Label 2722: @153246
     /* 153246 */   GIM_Try, /*On fail goto*//*Label 2723*/ GIMT_Encode4(153295), // Rule ID 7253 //
     /* 153251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153254 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 153261 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153268 */     // MIs[0] Rn
     /* 153268 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153272 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153280 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i32>><<P:Predicate_atomic_load_max_i32_seq_cst>>  =>  (LDSMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALW),
     /* 153283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153289 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153293 */     GIR_RootConstrainSelectedInstOperands,
     /* 153294 */     // GIR_Coverage, 7253,
     /* 153294 */     GIR_EraseRootFromParent_Done,
     /* 153295 */   // Label 2723: @153295
     /* 153295 */   GIM_Try, /*On fail goto*//*Label 2724*/ GIMT_Encode4(153344), // Rule ID 7254 //
     /* 153300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153303 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153310 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153317 */     // MIs[0] Rn
     /* 153317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153321 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153329 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_monotonic>>  =>  (LDSMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXH),
     /* 153332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153338 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153342 */     GIR_RootConstrainSelectedInstOperands,
     /* 153343 */     // GIR_Coverage, 7254,
     /* 153343 */     GIR_EraseRootFromParent_Done,
     /* 153344 */   // Label 2724: @153344
     /* 153344 */   GIM_Try, /*On fail goto*//*Label 2725*/ GIMT_Encode4(153393), // Rule ID 7255 //
     /* 153349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153352 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153359 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153366 */     // MIs[0] Rn
     /* 153366 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153370 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153378 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acquire>>  =>  (LDSMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAH),
     /* 153381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153385 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153391 */     GIR_RootConstrainSelectedInstOperands,
     /* 153392 */     // GIR_Coverage, 7255,
     /* 153392 */     GIR_EraseRootFromParent_Done,
     /* 153393 */   // Label 2725: @153393
     /* 153393 */   GIM_Try, /*On fail goto*//*Label 2726*/ GIMT_Encode4(153442), // Rule ID 7256 //
     /* 153398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153401 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153408 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153415 */     // MIs[0] Rn
     /* 153415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153427 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_release>>  =>  (LDSMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLH),
     /* 153430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153436 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153440 */     GIR_RootConstrainSelectedInstOperands,
     /* 153441 */     // GIR_Coverage, 7256,
     /* 153441 */     GIR_EraseRootFromParent_Done,
     /* 153442 */   // Label 2726: @153442
     /* 153442 */   GIM_Try, /*On fail goto*//*Label 2727*/ GIMT_Encode4(153491), // Rule ID 7257 //
     /* 153447 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153450 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153457 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153464 */     // MIs[0] Rn
     /* 153464 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153468 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153476 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_acq_rel>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153483 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153485 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153489 */     GIR_RootConstrainSelectedInstOperands,
     /* 153490 */     // GIR_Coverage, 7257,
     /* 153490 */     GIR_EraseRootFromParent_Done,
     /* 153491 */   // Label 2727: @153491
     /* 153491 */   GIM_Try, /*On fail goto*//*Label 2728*/ GIMT_Encode4(153540), // Rule ID 7258 //
     /* 153496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153499 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 153506 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153509 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153513 */     // MIs[0] Rn
     /* 153513 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153525 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i16>><<P:Predicate_atomic_load_max_i16_seq_cst>>  =>  (LDSMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALH),
     /* 153528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153532 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153534 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153538 */     GIR_RootConstrainSelectedInstOperands,
     /* 153539 */     // GIR_Coverage, 7258,
     /* 153539 */     GIR_EraseRootFromParent_Done,
     /* 153540 */   // Label 2728: @153540
     /* 153540 */   GIM_Try, /*On fail goto*//*Label 2729*/ GIMT_Encode4(153589), // Rule ID 7259 //
     /* 153545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153548 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153555 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153562 */     // MIs[0] Rn
     /* 153562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153566 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153574 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_monotonic>>  =>  (LDSMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXB),
     /* 153577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153587 */     GIR_RootConstrainSelectedInstOperands,
     /* 153588 */     // GIR_Coverage, 7259,
     /* 153588 */     GIR_EraseRootFromParent_Done,
     /* 153589 */   // Label 2729: @153589
     /* 153589 */   GIM_Try, /*On fail goto*//*Label 2730*/ GIMT_Encode4(153638), // Rule ID 7260 //
     /* 153594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153597 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153604 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153611 */     // MIs[0] Rn
     /* 153611 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153623 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acquire>>  =>  (LDSMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAB),
     /* 153626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153630 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153632 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153636 */     GIR_RootConstrainSelectedInstOperands,
     /* 153637 */     // GIR_Coverage, 7260,
     /* 153637 */     GIR_EraseRootFromParent_Done,
     /* 153638 */   // Label 2730: @153638
     /* 153638 */   GIM_Try, /*On fail goto*//*Label 2731*/ GIMT_Encode4(153687), // Rule ID 7261 //
     /* 153643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153646 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153653 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153660 */     // MIs[0] Rn
     /* 153660 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153664 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153672 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_release>>  =>  (LDSMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLB),
     /* 153675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153681 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153685 */     GIR_RootConstrainSelectedInstOperands,
     /* 153686 */     // GIR_Coverage, 7261,
     /* 153686 */     GIR_EraseRootFromParent_Done,
     /* 153687 */   // Label 2731: @153687
     /* 153687 */   GIM_Try, /*On fail goto*//*Label 2732*/ GIMT_Encode4(153736), // Rule ID 7262 //
     /* 153692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153695 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153702 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153709 */     // MIs[0] Rn
     /* 153709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153713 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153721 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_acq_rel>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153728 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153730 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153734 */     GIR_RootConstrainSelectedInstOperands,
     /* 153735 */     // GIR_Coverage, 7262,
     /* 153735 */     GIR_EraseRootFromParent_Done,
     /* 153736 */   // Label 2732: @153736
     /* 153736 */   GIM_Try, /*On fail goto*//*Label 2733*/ GIMT_Encode4(153785), // Rule ID 7263 //
     /* 153741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153744 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 153751 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153758 */     // MIs[0] Rn
     /* 153758 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153762 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 153770 */     // (atomic_load_max:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_max_i8>><<P:Predicate_atomic_load_max_i8_seq_cst>>  =>  (LDSMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALB),
     /* 153773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153777 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153783 */     GIR_RootConstrainSelectedInstOperands,
     /* 153784 */     // GIR_Coverage, 7263,
     /* 153784 */     GIR_EraseRootFromParent_Done,
     /* 153785 */   // Label 2733: @153785
     /* 153785 */   GIM_Reject,
     /* 153786 */ // Label 2718: @153786
     /* 153786 */ GIM_Reject,
     /* 153787 */ // Label 2716: @153787
     /* 153787 */ GIM_Try, /*On fail goto*//*Label 2734*/ GIMT_Encode4(154013),
     /* 153792 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 153795 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 153802 */   GIM_Try, /*On fail goto*//*Label 2735*/ GIMT_Encode4(153844), // Rule ID 7244 //
     /* 153807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153810 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 153813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153817 */     // MIs[0] Rn
     /* 153817 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153829 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_monotonic>>  =>  (LDSMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXX),
     /* 153832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153836 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153838 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153842 */     GIR_RootConstrainSelectedInstOperands,
     /* 153843 */     // GIR_Coverage, 7244,
     /* 153843 */     GIR_EraseRootFromParent_Done,
     /* 153844 */   // Label 2735: @153844
     /* 153844 */   GIM_Try, /*On fail goto*//*Label 2736*/ GIMT_Encode4(153886), // Rule ID 7245 //
     /* 153849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153852 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 153855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153859 */     // MIs[0] Rn
     /* 153859 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153867 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153871 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acquire>>  =>  (LDSMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXAX),
     /* 153874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153878 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153880 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153884 */     GIR_RootConstrainSelectedInstOperands,
     /* 153885 */     // GIR_Coverage, 7245,
     /* 153885 */     GIR_EraseRootFromParent_Done,
     /* 153886 */   // Label 2736: @153886
     /* 153886 */   GIM_Try, /*On fail goto*//*Label 2737*/ GIMT_Encode4(153928), // Rule ID 7246 //
     /* 153891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153894 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 153897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153901 */     // MIs[0] Rn
     /* 153901 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153905 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153913 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_release>>  =>  (LDSMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXLX),
     /* 153916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153920 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153922 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153926 */     GIR_RootConstrainSelectedInstOperands,
     /* 153927 */     // GIR_Coverage, 7246,
     /* 153927 */     GIR_EraseRootFromParent_Done,
     /* 153928 */   // Label 2737: @153928
     /* 153928 */   GIM_Try, /*On fail goto*//*Label 2738*/ GIMT_Encode4(153970), // Rule ID 7247 //
     /* 153933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153936 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 153939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153943 */     // MIs[0] Rn
     /* 153943 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153951 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153955 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_acq_rel>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 153958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 153960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 153962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 153964 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 153968 */     GIR_RootConstrainSelectedInstOperands,
     /* 153969 */     // GIR_Coverage, 7247,
     /* 153969 */     GIR_EraseRootFromParent_Done,
     /* 153970 */   // Label 2738: @153970
     /* 153970 */   GIM_Try, /*On fail goto*//*Label 2739*/ GIMT_Encode4(154012), // Rule ID 7248 //
     /* 153975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 153978 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 153981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153985 */     // MIs[0] Rn
     /* 153985 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 153989 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 153993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 153997 */     // (atomic_load_max:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_max_i64>><<P:Predicate_atomic_load_max_i64_seq_cst>>  =>  (LDSMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 153997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMAXALX),
     /* 154000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154004 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154006 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154010 */     GIR_RootConstrainSelectedInstOperands,
     /* 154011 */     // GIR_Coverage, 7248,
     /* 154011 */     GIR_EraseRootFromParent_Done,
     /* 154012 */   // Label 2739: @154012
     /* 154012 */   GIM_Reject,
     /* 154013 */ // Label 2734: @154013
     /* 154013 */ GIM_Reject,
     /* 154014 */ // Label 2717: @154014
     /* 154014 */ GIM_Reject,
     /* 154015 */ // Label 28: @154015
     /* 154015 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2742*/ GIMT_Encode4(155006),
     /* 154026 */ /*GILLT_s32*//*Label 2740*/ GIMT_Encode4(154034),
     /* 154030 */ /*GILLT_s64*//*Label 2741*/ GIMT_Encode4(154779),
     /* 154034 */ // Label 2740: @154034
     /* 154034 */ GIM_Try, /*On fail goto*//*Label 2743*/ GIMT_Encode4(154778),
     /* 154039 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 154042 */   GIM_Try, /*On fail goto*//*Label 2744*/ GIMT_Encode4(154091), // Rule ID 7269 //
     /* 154047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154050 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154057 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154064 */     // MIs[0] Rn
     /* 154064 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154068 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154076 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_monotonic>>  =>  (LDSMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINW),
     /* 154079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154083 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154085 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154089 */     GIR_RootConstrainSelectedInstOperands,
     /* 154090 */     // GIR_Coverage, 7269,
     /* 154090 */     GIR_EraseRootFromParent_Done,
     /* 154091 */   // Label 2744: @154091
     /* 154091 */   GIM_Try, /*On fail goto*//*Label 2745*/ GIMT_Encode4(154140), // Rule ID 7270 //
     /* 154096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154099 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154106 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154113 */     // MIs[0] Rn
     /* 154113 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154117 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154125 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acquire>>  =>  (LDSMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAW),
     /* 154128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154138 */     GIR_RootConstrainSelectedInstOperands,
     /* 154139 */     // GIR_Coverage, 7270,
     /* 154139 */     GIR_EraseRootFromParent_Done,
     /* 154140 */   // Label 2745: @154140
     /* 154140 */   GIM_Try, /*On fail goto*//*Label 2746*/ GIMT_Encode4(154189), // Rule ID 7271 //
     /* 154145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154148 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154155 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154162 */     // MIs[0] Rn
     /* 154162 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154174 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_release>>  =>  (LDSMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLW),
     /* 154177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154181 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154183 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154187 */     GIR_RootConstrainSelectedInstOperands,
     /* 154188 */     // GIR_Coverage, 7271,
     /* 154188 */     GIR_EraseRootFromParent_Done,
     /* 154189 */   // Label 2746: @154189
     /* 154189 */   GIM_Try, /*On fail goto*//*Label 2747*/ GIMT_Encode4(154238), // Rule ID 7272 //
     /* 154194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154197 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154204 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154211 */     // MIs[0] Rn
     /* 154211 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154215 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154223 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_acq_rel>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154230 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154232 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154236 */     GIR_RootConstrainSelectedInstOperands,
     /* 154237 */     // GIR_Coverage, 7272,
     /* 154237 */     GIR_EraseRootFromParent_Done,
     /* 154238 */   // Label 2747: @154238
     /* 154238 */   GIM_Try, /*On fail goto*//*Label 2748*/ GIMT_Encode4(154287), // Rule ID 7273 //
     /* 154243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154246 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 154253 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154260 */     // MIs[0] Rn
     /* 154260 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154264 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154272 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i32>><<P:Predicate_atomic_load_min_i32_seq_cst>>  =>  (LDSMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALW),
     /* 154275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154285 */     GIR_RootConstrainSelectedInstOperands,
     /* 154286 */     // GIR_Coverage, 7273,
     /* 154286 */     GIR_EraseRootFromParent_Done,
     /* 154287 */   // Label 2748: @154287
     /* 154287 */   GIM_Try, /*On fail goto*//*Label 2749*/ GIMT_Encode4(154336), // Rule ID 7274 //
     /* 154292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154295 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154302 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154309 */     // MIs[0] Rn
     /* 154309 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154313 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154317 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154321 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_monotonic>>  =>  (LDSMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINH),
     /* 154324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154328 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154334 */     GIR_RootConstrainSelectedInstOperands,
     /* 154335 */     // GIR_Coverage, 7274,
     /* 154335 */     GIR_EraseRootFromParent_Done,
     /* 154336 */   // Label 2749: @154336
     /* 154336 */   GIM_Try, /*On fail goto*//*Label 2750*/ GIMT_Encode4(154385), // Rule ID 7275 //
     /* 154341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154344 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154351 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154358 */     // MIs[0] Rn
     /* 154358 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154362 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154370 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acquire>>  =>  (LDSMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAH),
     /* 154373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154379 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154383 */     GIR_RootConstrainSelectedInstOperands,
     /* 154384 */     // GIR_Coverage, 7275,
     /* 154384 */     GIR_EraseRootFromParent_Done,
     /* 154385 */   // Label 2750: @154385
     /* 154385 */   GIM_Try, /*On fail goto*//*Label 2751*/ GIMT_Encode4(154434), // Rule ID 7276 //
     /* 154390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154393 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154400 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154407 */     // MIs[0] Rn
     /* 154407 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154411 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154415 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154419 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_release>>  =>  (LDSMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLH),
     /* 154422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154426 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154432 */     GIR_RootConstrainSelectedInstOperands,
     /* 154433 */     // GIR_Coverage, 7276,
     /* 154433 */     GIR_EraseRootFromParent_Done,
     /* 154434 */   // Label 2751: @154434
     /* 154434 */   GIM_Try, /*On fail goto*//*Label 2752*/ GIMT_Encode4(154483), // Rule ID 7277 //
     /* 154439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154442 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154449 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154456 */     // MIs[0] Rn
     /* 154456 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154468 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_acq_rel>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154473 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154475 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154477 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154481 */     GIR_RootConstrainSelectedInstOperands,
     /* 154482 */     // GIR_Coverage, 7277,
     /* 154482 */     GIR_EraseRootFromParent_Done,
     /* 154483 */   // Label 2752: @154483
     /* 154483 */   GIM_Try, /*On fail goto*//*Label 2753*/ GIMT_Encode4(154532), // Rule ID 7278 //
     /* 154488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154491 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 154498 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154501 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154505 */     // MIs[0] Rn
     /* 154505 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154509 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154513 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154517 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i16>><<P:Predicate_atomic_load_min_i16_seq_cst>>  =>  (LDSMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALH),
     /* 154520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154524 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154526 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154530 */     GIR_RootConstrainSelectedInstOperands,
     /* 154531 */     // GIR_Coverage, 7278,
     /* 154531 */     GIR_EraseRootFromParent_Done,
     /* 154532 */   // Label 2753: @154532
     /* 154532 */   GIM_Try, /*On fail goto*//*Label 2754*/ GIMT_Encode4(154581), // Rule ID 7279 //
     /* 154537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154540 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154554 */     // MIs[0] Rn
     /* 154554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154566 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_monotonic>>  =>  (LDSMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINB),
     /* 154569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154579 */     GIR_RootConstrainSelectedInstOperands,
     /* 154580 */     // GIR_Coverage, 7279,
     /* 154580 */     GIR_EraseRootFromParent_Done,
     /* 154581 */   // Label 2754: @154581
     /* 154581 */   GIM_Try, /*On fail goto*//*Label 2755*/ GIMT_Encode4(154630), // Rule ID 7280 //
     /* 154586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154589 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154596 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154603 */     // MIs[0] Rn
     /* 154603 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154615 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acquire>>  =>  (LDSMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAB),
     /* 154618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154622 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154624 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154628 */     GIR_RootConstrainSelectedInstOperands,
     /* 154629 */     // GIR_Coverage, 7280,
     /* 154629 */     GIR_EraseRootFromParent_Done,
     /* 154630 */   // Label 2755: @154630
     /* 154630 */   GIM_Try, /*On fail goto*//*Label 2756*/ GIMT_Encode4(154679), // Rule ID 7281 //
     /* 154635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154638 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154645 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154652 */     // MIs[0] Rn
     /* 154652 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154656 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154664 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_release>>  =>  (LDSMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLB),
     /* 154667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154671 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154673 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154677 */     GIR_RootConstrainSelectedInstOperands,
     /* 154678 */     // GIR_Coverage, 7281,
     /* 154678 */     GIR_EraseRootFromParent_Done,
     /* 154679 */   // Label 2756: @154679
     /* 154679 */   GIM_Try, /*On fail goto*//*Label 2757*/ GIMT_Encode4(154728), // Rule ID 7282 //
     /* 154684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154687 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154694 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154697 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154701 */     // MIs[0] Rn
     /* 154701 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154713 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_acq_rel>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154720 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154726 */     GIR_RootConstrainSelectedInstOperands,
     /* 154727 */     // GIR_Coverage, 7282,
     /* 154727 */     GIR_EraseRootFromParent_Done,
     /* 154728 */   // Label 2757: @154728
     /* 154728 */   GIM_Try, /*On fail goto*//*Label 2758*/ GIMT_Encode4(154777), // Rule ID 7283 //
     /* 154733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154736 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 154743 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154750 */     // MIs[0] Rn
     /* 154750 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 154762 */     // (atomic_load_min:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_min_i8>><<P:Predicate_atomic_load_min_i8_seq_cst>>  =>  (LDSMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALB),
     /* 154765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154769 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154771 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154775 */     GIR_RootConstrainSelectedInstOperands,
     /* 154776 */     // GIR_Coverage, 7283,
     /* 154776 */     GIR_EraseRootFromParent_Done,
     /* 154777 */   // Label 2758: @154777
     /* 154777 */   GIM_Reject,
     /* 154778 */ // Label 2743: @154778
     /* 154778 */ GIM_Reject,
     /* 154779 */ // Label 2741: @154779
     /* 154779 */ GIM_Try, /*On fail goto*//*Label 2759*/ GIMT_Encode4(155005),
     /* 154784 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 154787 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 154794 */   GIM_Try, /*On fail goto*//*Label 2760*/ GIMT_Encode4(154836), // Rule ID 7264 //
     /* 154799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154802 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 154805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154809 */     // MIs[0] Rn
     /* 154809 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154813 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154821 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_monotonic>>  =>  (LDSMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINX),
     /* 154824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154828 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154830 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154834 */     GIR_RootConstrainSelectedInstOperands,
     /* 154835 */     // GIR_Coverage, 7264,
     /* 154835 */     GIR_EraseRootFromParent_Done,
     /* 154836 */   // Label 2760: @154836
     /* 154836 */   GIM_Try, /*On fail goto*//*Label 2761*/ GIMT_Encode4(154878), // Rule ID 7265 //
     /* 154841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154844 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 154847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154851 */     // MIs[0] Rn
     /* 154851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154863 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acquire>>  =>  (LDSMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINAX),
     /* 154866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154870 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154872 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154876 */     GIR_RootConstrainSelectedInstOperands,
     /* 154877 */     // GIR_Coverage, 7265,
     /* 154877 */     GIR_EraseRootFromParent_Done,
     /* 154878 */   // Label 2761: @154878
     /* 154878 */   GIM_Try, /*On fail goto*//*Label 2762*/ GIMT_Encode4(154920), // Rule ID 7266 //
     /* 154883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154886 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 154889 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154893 */     // MIs[0] Rn
     /* 154893 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154897 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154905 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_release>>  =>  (LDSMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINLX),
     /* 154908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154914 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154918 */     GIR_RootConstrainSelectedInstOperands,
     /* 154919 */     // GIR_Coverage, 7266,
     /* 154919 */     GIR_EraseRootFromParent_Done,
     /* 154920 */   // Label 2762: @154920
     /* 154920 */   GIM_Try, /*On fail goto*//*Label 2763*/ GIMT_Encode4(154962), // Rule ID 7267 //
     /* 154925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154928 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 154931 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154935 */     // MIs[0] Rn
     /* 154935 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154947 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_acq_rel>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 154960 */     GIR_RootConstrainSelectedInstOperands,
     /* 154961 */     // GIR_Coverage, 7267,
     /* 154961 */     GIR_EraseRootFromParent_Done,
     /* 154962 */   // Label 2763: @154962
     /* 154962 */   GIM_Try, /*On fail goto*//*Label 2764*/ GIMT_Encode4(155004), // Rule ID 7268 //
     /* 154967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 154970 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 154973 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154977 */     // MIs[0] Rn
     /* 154977 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 154981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 154985 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 154989 */     // (atomic_load_min:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_min_i64>><<P:Predicate_atomic_load_min_i64_seq_cst>>  =>  (LDSMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 154989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDSMINALX),
     /* 154992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 154994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 154996 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 154998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155002 */     GIR_RootConstrainSelectedInstOperands,
     /* 155003 */     // GIR_Coverage, 7268,
     /* 155003 */     GIR_EraseRootFromParent_Done,
     /* 155004 */   // Label 2764: @155004
     /* 155004 */   GIM_Reject,
     /* 155005 */ // Label 2759: @155005
     /* 155005 */ GIM_Reject,
     /* 155006 */ // Label 2742: @155006
     /* 155006 */ GIM_Reject,
     /* 155007 */ // Label 29: @155007
     /* 155007 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2767*/ GIMT_Encode4(155998),
     /* 155018 */ /*GILLT_s32*//*Label 2765*/ GIMT_Encode4(155026),
     /* 155022 */ /*GILLT_s64*//*Label 2766*/ GIMT_Encode4(155771),
     /* 155026 */ // Label 2765: @155026
     /* 155026 */ GIM_Try, /*On fail goto*//*Label 2768*/ GIMT_Encode4(155770),
     /* 155031 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 155034 */   GIM_Try, /*On fail goto*//*Label 2769*/ GIMT_Encode4(155083), // Rule ID 7289 //
     /* 155039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155042 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155049 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155056 */     // MIs[0] Rn
     /* 155056 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155060 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155068 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_monotonic>>  =>  (LDUMAXW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXW),
     /* 155071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155075 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155077 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155081 */     GIR_RootConstrainSelectedInstOperands,
     /* 155082 */     // GIR_Coverage, 7289,
     /* 155082 */     GIR_EraseRootFromParent_Done,
     /* 155083 */   // Label 2769: @155083
     /* 155083 */   GIM_Try, /*On fail goto*//*Label 2770*/ GIMT_Encode4(155132), // Rule ID 7290 //
     /* 155088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155091 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155098 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155105 */     // MIs[0] Rn
     /* 155105 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155109 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155117 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acquire>>  =>  (LDUMAXAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAW),
     /* 155120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155124 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155126 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155130 */     GIR_RootConstrainSelectedInstOperands,
     /* 155131 */     // GIR_Coverage, 7290,
     /* 155131 */     GIR_EraseRootFromParent_Done,
     /* 155132 */   // Label 2770: @155132
     /* 155132 */   GIM_Try, /*On fail goto*//*Label 2771*/ GIMT_Encode4(155181), // Rule ID 7291 //
     /* 155137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155140 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155147 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155154 */     // MIs[0] Rn
     /* 155154 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155162 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155166 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_release>>  =>  (LDUMAXLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLW),
     /* 155169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155173 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155175 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155179 */     GIR_RootConstrainSelectedInstOperands,
     /* 155180 */     // GIR_Coverage, 7291,
     /* 155180 */     GIR_EraseRootFromParent_Done,
     /* 155181 */   // Label 2771: @155181
     /* 155181 */   GIM_Try, /*On fail goto*//*Label 2772*/ GIMT_Encode4(155230), // Rule ID 7292 //
     /* 155186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155189 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155203 */     // MIs[0] Rn
     /* 155203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155215 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_acq_rel>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155228 */     GIR_RootConstrainSelectedInstOperands,
     /* 155229 */     // GIR_Coverage, 7292,
     /* 155229 */     GIR_EraseRootFromParent_Done,
     /* 155230 */   // Label 2772: @155230
     /* 155230 */   GIM_Try, /*On fail goto*//*Label 2773*/ GIMT_Encode4(155279), // Rule ID 7293 //
     /* 155235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155238 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 155245 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155252 */     // MIs[0] Rn
     /* 155252 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155256 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155264 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i32>><<P:Predicate_atomic_load_umax_i32_seq_cst>>  =>  (LDUMAXALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALW),
     /* 155267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155273 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155277 */     GIR_RootConstrainSelectedInstOperands,
     /* 155278 */     // GIR_Coverage, 7293,
     /* 155278 */     GIR_EraseRootFromParent_Done,
     /* 155279 */   // Label 2773: @155279
     /* 155279 */   GIM_Try, /*On fail goto*//*Label 2774*/ GIMT_Encode4(155328), // Rule ID 7294 //
     /* 155284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155287 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155294 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155301 */     // MIs[0] Rn
     /* 155301 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155313 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_monotonic>>  =>  (LDUMAXH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXH),
     /* 155316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155320 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155322 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155326 */     GIR_RootConstrainSelectedInstOperands,
     /* 155327 */     // GIR_Coverage, 7294,
     /* 155327 */     GIR_EraseRootFromParent_Done,
     /* 155328 */   // Label 2774: @155328
     /* 155328 */   GIM_Try, /*On fail goto*//*Label 2775*/ GIMT_Encode4(155377), // Rule ID 7295 //
     /* 155333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155336 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155343 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155350 */     // MIs[0] Rn
     /* 155350 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155362 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acquire>>  =>  (LDUMAXAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAH),
     /* 155365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155369 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155375 */     GIR_RootConstrainSelectedInstOperands,
     /* 155376 */     // GIR_Coverage, 7295,
     /* 155376 */     GIR_EraseRootFromParent_Done,
     /* 155377 */   // Label 2775: @155377
     /* 155377 */   GIM_Try, /*On fail goto*//*Label 2776*/ GIMT_Encode4(155426), // Rule ID 7296 //
     /* 155382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155385 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155392 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155399 */     // MIs[0] Rn
     /* 155399 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155403 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155411 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_release>>  =>  (LDUMAXLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLH),
     /* 155414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155418 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155420 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155424 */     GIR_RootConstrainSelectedInstOperands,
     /* 155425 */     // GIR_Coverage, 7296,
     /* 155425 */     GIR_EraseRootFromParent_Done,
     /* 155426 */   // Label 2776: @155426
     /* 155426 */   GIM_Try, /*On fail goto*//*Label 2777*/ GIMT_Encode4(155475), // Rule ID 7297 //
     /* 155431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155434 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155441 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155448 */     // MIs[0] Rn
     /* 155448 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155452 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155460 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_acq_rel>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155460 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155463 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155465 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155467 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155469 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155473 */     GIR_RootConstrainSelectedInstOperands,
     /* 155474 */     // GIR_Coverage, 7297,
     /* 155474 */     GIR_EraseRootFromParent_Done,
     /* 155475 */   // Label 2777: @155475
     /* 155475 */   GIM_Try, /*On fail goto*//*Label 2778*/ GIMT_Encode4(155524), // Rule ID 7298 //
     /* 155480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155483 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 155490 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155497 */     // MIs[0] Rn
     /* 155497 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155509 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i16>><<P:Predicate_atomic_load_umax_i16_seq_cst>>  =>  (LDUMAXALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALH),
     /* 155512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155522 */     GIR_RootConstrainSelectedInstOperands,
     /* 155523 */     // GIR_Coverage, 7298,
     /* 155523 */     GIR_EraseRootFromParent_Done,
     /* 155524 */   // Label 2778: @155524
     /* 155524 */   GIM_Try, /*On fail goto*//*Label 2779*/ GIMT_Encode4(155573), // Rule ID 7299 //
     /* 155529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155532 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155539 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155546 */     // MIs[0] Rn
     /* 155546 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155550 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155558 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_monotonic>>  =>  (LDUMAXB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXB),
     /* 155561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155565 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155571 */     GIR_RootConstrainSelectedInstOperands,
     /* 155572 */     // GIR_Coverage, 7299,
     /* 155572 */     GIR_EraseRootFromParent_Done,
     /* 155573 */   // Label 2779: @155573
     /* 155573 */   GIM_Try, /*On fail goto*//*Label 2780*/ GIMT_Encode4(155622), // Rule ID 7300 //
     /* 155578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155581 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155588 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155595 */     // MIs[0] Rn
     /* 155595 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155599 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155607 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acquire>>  =>  (LDUMAXAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAB),
     /* 155610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155616 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155620 */     GIR_RootConstrainSelectedInstOperands,
     /* 155621 */     // GIR_Coverage, 7300,
     /* 155621 */     GIR_EraseRootFromParent_Done,
     /* 155622 */   // Label 2780: @155622
     /* 155622 */   GIM_Try, /*On fail goto*//*Label 2781*/ GIMT_Encode4(155671), // Rule ID 7301 //
     /* 155627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155630 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155637 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155644 */     // MIs[0] Rn
     /* 155644 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155648 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155656 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_release>>  =>  (LDUMAXLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLB),
     /* 155659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155665 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155669 */     GIR_RootConstrainSelectedInstOperands,
     /* 155670 */     // GIR_Coverage, 7301,
     /* 155670 */     GIR_EraseRootFromParent_Done,
     /* 155671 */   // Label 2781: @155671
     /* 155671 */   GIM_Try, /*On fail goto*//*Label 2782*/ GIMT_Encode4(155720), // Rule ID 7302 //
     /* 155676 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155679 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155686 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155693 */     // MIs[0] Rn
     /* 155693 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155697 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155701 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155705 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_acq_rel>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155712 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155718 */     GIR_RootConstrainSelectedInstOperands,
     /* 155719 */     // GIR_Coverage, 7302,
     /* 155719 */     GIR_EraseRootFromParent_Done,
     /* 155720 */   // Label 2782: @155720
     /* 155720 */   GIM_Try, /*On fail goto*//*Label 2783*/ GIMT_Encode4(155769), // Rule ID 7303 //
     /* 155725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155728 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 155735 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155742 */     // MIs[0] Rn
     /* 155742 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155746 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155750 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 155754 */     // (atomic_load_umax:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umax_i8>><<P:Predicate_atomic_load_umax_i8_seq_cst>>  =>  (LDUMAXALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALB),
     /* 155757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155761 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155763 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155767 */     GIR_RootConstrainSelectedInstOperands,
     /* 155768 */     // GIR_Coverage, 7303,
     /* 155768 */     GIR_EraseRootFromParent_Done,
     /* 155769 */   // Label 2783: @155769
     /* 155769 */   GIM_Reject,
     /* 155770 */ // Label 2768: @155770
     /* 155770 */ GIM_Reject,
     /* 155771 */ // Label 2766: @155771
     /* 155771 */ GIM_Try, /*On fail goto*//*Label 2784*/ GIMT_Encode4(155997),
     /* 155776 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 155779 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 155786 */   GIM_Try, /*On fail goto*//*Label 2785*/ GIMT_Encode4(155828), // Rule ID 7284 //
     /* 155791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155794 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 155797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155801 */     // MIs[0] Rn
     /* 155801 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155805 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155813 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_monotonic>>  =>  (LDUMAXX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXX),
     /* 155816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155820 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155822 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155826 */     GIR_RootConstrainSelectedInstOperands,
     /* 155827 */     // GIR_Coverage, 7284,
     /* 155827 */     GIR_EraseRootFromParent_Done,
     /* 155828 */   // Label 2785: @155828
     /* 155828 */   GIM_Try, /*On fail goto*//*Label 2786*/ GIMT_Encode4(155870), // Rule ID 7285 //
     /* 155833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155836 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 155839 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155843 */     // MIs[0] Rn
     /* 155843 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155855 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acquire>>  =>  (LDUMAXAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXAX),
     /* 155858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155868 */     GIR_RootConstrainSelectedInstOperands,
     /* 155869 */     // GIR_Coverage, 7285,
     /* 155869 */     GIR_EraseRootFromParent_Done,
     /* 155870 */   // Label 2786: @155870
     /* 155870 */   GIM_Try, /*On fail goto*//*Label 2787*/ GIMT_Encode4(155912), // Rule ID 7286 //
     /* 155875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155878 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 155881 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155885 */     // MIs[0] Rn
     /* 155885 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155897 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_release>>  =>  (LDUMAXLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXLX),
     /* 155900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155904 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155906 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155910 */     GIR_RootConstrainSelectedInstOperands,
     /* 155911 */     // GIR_Coverage, 7286,
     /* 155911 */     GIR_EraseRootFromParent_Done,
     /* 155912 */   // Label 2787: @155912
     /* 155912 */   GIM_Try, /*On fail goto*//*Label 2788*/ GIMT_Encode4(155954), // Rule ID 7287 //
     /* 155917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155920 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 155923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155927 */     // MIs[0] Rn
     /* 155927 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155931 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155935 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155939 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_acq_rel>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155948 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155952 */     GIR_RootConstrainSelectedInstOperands,
     /* 155953 */     // GIR_Coverage, 7287,
     /* 155953 */     GIR_EraseRootFromParent_Done,
     /* 155954 */   // Label 2788: @155954
     /* 155954 */   GIM_Try, /*On fail goto*//*Label 2789*/ GIMT_Encode4(155996), // Rule ID 7288 //
     /* 155959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 155962 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 155965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155969 */     // MIs[0] Rn
     /* 155969 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 155973 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 155977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 155981 */     // (atomic_load_umax:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umax_i64>><<P:Predicate_atomic_load_umax_i64_seq_cst>>  =>  (LDUMAXALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 155981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMAXALX),
     /* 155984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 155986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 155988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 155990 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 155994 */     GIR_RootConstrainSelectedInstOperands,
     /* 155995 */     // GIR_Coverage, 7288,
     /* 155995 */     GIR_EraseRootFromParent_Done,
     /* 155996 */   // Label 2789: @155996
     /* 155996 */   GIM_Reject,
     /* 155997 */ // Label 2784: @155997
     /* 155997 */ GIM_Reject,
     /* 155998 */ // Label 2767: @155998
     /* 155998 */ GIM_Reject,
     /* 155999 */ // Label 30: @155999
     /* 155999 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 2792*/ GIMT_Encode4(156990),
     /* 156010 */ /*GILLT_s32*//*Label 2790*/ GIMT_Encode4(156018),
     /* 156014 */ /*GILLT_s64*//*Label 2791*/ GIMT_Encode4(156763),
     /* 156018 */ // Label 2790: @156018
     /* 156018 */ GIM_Try, /*On fail goto*//*Label 2793*/ GIMT_Encode4(156762),
     /* 156023 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 156026 */   GIM_Try, /*On fail goto*//*Label 2794*/ GIMT_Encode4(156075), // Rule ID 7309 //
     /* 156031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156034 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156041 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156048 */     // MIs[0] Rn
     /* 156048 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156052 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156060 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_monotonic>>  =>  (LDUMINW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINW),
     /* 156063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156067 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156069 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156073 */     GIR_RootConstrainSelectedInstOperands,
     /* 156074 */     // GIR_Coverage, 7309,
     /* 156074 */     GIR_EraseRootFromParent_Done,
     /* 156075 */   // Label 2794: @156075
     /* 156075 */   GIM_Try, /*On fail goto*//*Label 2795*/ GIMT_Encode4(156124), // Rule ID 7310 //
     /* 156080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156083 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156090 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156097 */     // MIs[0] Rn
     /* 156097 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156101 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156109 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acquire>>  =>  (LDUMINAW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAW),
     /* 156112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156116 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156118 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156122 */     GIR_RootConstrainSelectedInstOperands,
     /* 156123 */     // GIR_Coverage, 7310,
     /* 156123 */     GIR_EraseRootFromParent_Done,
     /* 156124 */   // Label 2795: @156124
     /* 156124 */   GIM_Try, /*On fail goto*//*Label 2796*/ GIMT_Encode4(156173), // Rule ID 7311 //
     /* 156129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156132 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156139 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156146 */     // MIs[0] Rn
     /* 156146 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156150 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156158 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_release>>  =>  (LDUMINLW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLW),
     /* 156161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156165 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156171 */     GIR_RootConstrainSelectedInstOperands,
     /* 156172 */     // GIR_Coverage, 7311,
     /* 156172 */     GIR_EraseRootFromParent_Done,
     /* 156173 */   // Label 2796: @156173
     /* 156173 */   GIM_Try, /*On fail goto*//*Label 2797*/ GIMT_Encode4(156222), // Rule ID 7312 //
     /* 156178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156181 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156188 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156195 */     // MIs[0] Rn
     /* 156195 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156199 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156203 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156207 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_acq_rel>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156214 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156216 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156220 */     GIR_RootConstrainSelectedInstOperands,
     /* 156221 */     // GIR_Coverage, 7312,
     /* 156221 */     GIR_EraseRootFromParent_Done,
     /* 156222 */   // Label 2797: @156222
     /* 156222 */   GIM_Try, /*On fail goto*//*Label 2798*/ GIMT_Encode4(156271), // Rule ID 7313 //
     /* 156227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156230 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 156237 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156244 */     // MIs[0] Rn
     /* 156244 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156248 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156256 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i32>><<P:Predicate_atomic_load_umin_i32_seq_cst>>  =>  (LDUMINALW:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALW),
     /* 156259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156263 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156265 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156269 */     GIR_RootConstrainSelectedInstOperands,
     /* 156270 */     // GIR_Coverage, 7313,
     /* 156270 */     GIR_EraseRootFromParent_Done,
     /* 156271 */   // Label 2798: @156271
     /* 156271 */   GIM_Try, /*On fail goto*//*Label 2799*/ GIMT_Encode4(156320), // Rule ID 7314 //
     /* 156276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156279 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156286 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156293 */     // MIs[0] Rn
     /* 156293 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156297 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156305 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_monotonic>>  =>  (LDUMINH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINH),
     /* 156308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156314 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156318 */     GIR_RootConstrainSelectedInstOperands,
     /* 156319 */     // GIR_Coverage, 7314,
     /* 156319 */     GIR_EraseRootFromParent_Done,
     /* 156320 */   // Label 2799: @156320
     /* 156320 */   GIM_Try, /*On fail goto*//*Label 2800*/ GIMT_Encode4(156369), // Rule ID 7315 //
     /* 156325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156328 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156335 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156342 */     // MIs[0] Rn
     /* 156342 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156346 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156354 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acquire>>  =>  (LDUMINAH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAH),
     /* 156357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156361 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156363 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156367 */     GIR_RootConstrainSelectedInstOperands,
     /* 156368 */     // GIR_Coverage, 7315,
     /* 156368 */     GIR_EraseRootFromParent_Done,
     /* 156369 */   // Label 2800: @156369
     /* 156369 */   GIM_Try, /*On fail goto*//*Label 2801*/ GIMT_Encode4(156418), // Rule ID 7316 //
     /* 156374 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156377 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156384 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156391 */     // MIs[0] Rn
     /* 156391 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156403 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_release>>  =>  (LDUMINLH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLH),
     /* 156406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156410 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156412 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156416 */     GIR_RootConstrainSelectedInstOperands,
     /* 156417 */     // GIR_Coverage, 7316,
     /* 156417 */     GIR_EraseRootFromParent_Done,
     /* 156418 */   // Label 2801: @156418
     /* 156418 */   GIM_Try, /*On fail goto*//*Label 2802*/ GIMT_Encode4(156467), // Rule ID 7317 //
     /* 156423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156426 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156433 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156440 */     // MIs[0] Rn
     /* 156440 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156444 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156452 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_acq_rel>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156461 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156465 */     GIR_RootConstrainSelectedInstOperands,
     /* 156466 */     // GIR_Coverage, 7317,
     /* 156466 */     GIR_EraseRootFromParent_Done,
     /* 156467 */   // Label 2802: @156467
     /* 156467 */   GIM_Try, /*On fail goto*//*Label 2803*/ GIMT_Encode4(156516), // Rule ID 7318 //
     /* 156472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156475 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 156482 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156489 */     // MIs[0] Rn
     /* 156489 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156501 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i16>><<P:Predicate_atomic_load_umin_i16_seq_cst>>  =>  (LDUMINALH:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALH),
     /* 156504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156508 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156510 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156514 */     GIR_RootConstrainSelectedInstOperands,
     /* 156515 */     // GIR_Coverage, 7318,
     /* 156515 */     GIR_EraseRootFromParent_Done,
     /* 156516 */   // Label 2803: @156516
     /* 156516 */   GIM_Try, /*On fail goto*//*Label 2804*/ GIMT_Encode4(156565), // Rule ID 7319 //
     /* 156521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156524 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156538 */     // MIs[0] Rn
     /* 156538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156550 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_monotonic>>  =>  (LDUMINB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINB),
     /* 156553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156563 */     GIR_RootConstrainSelectedInstOperands,
     /* 156564 */     // GIR_Coverage, 7319,
     /* 156564 */     GIR_EraseRootFromParent_Done,
     /* 156565 */   // Label 2804: @156565
     /* 156565 */   GIM_Try, /*On fail goto*//*Label 2805*/ GIMT_Encode4(156614), // Rule ID 7320 //
     /* 156570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156573 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156580 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156587 */     // MIs[0] Rn
     /* 156587 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156595 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156599 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acquire>>  =>  (LDUMINAB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAB),
     /* 156602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156606 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156608 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156612 */     GIR_RootConstrainSelectedInstOperands,
     /* 156613 */     // GIR_Coverage, 7320,
     /* 156613 */     GIR_EraseRootFromParent_Done,
     /* 156614 */   // Label 2805: @156614
     /* 156614 */   GIM_Try, /*On fail goto*//*Label 2806*/ GIMT_Encode4(156663), // Rule ID 7321 //
     /* 156619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156622 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156629 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156632 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156636 */     // MIs[0] Rn
     /* 156636 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156640 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156648 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_release>>  =>  (LDUMINLB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLB),
     /* 156651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156655 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156657 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156661 */     GIR_RootConstrainSelectedInstOperands,
     /* 156662 */     // GIR_Coverage, 7321,
     /* 156662 */     GIR_EraseRootFromParent_Done,
     /* 156663 */   // Label 2806: @156663
     /* 156663 */   GIM_Try, /*On fail goto*//*Label 2807*/ GIMT_Encode4(156712), // Rule ID 7322 //
     /* 156668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156671 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156678 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156685 */     // MIs[0] Rn
     /* 156685 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156697 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_acq_rel>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156706 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156710 */     GIR_RootConstrainSelectedInstOperands,
     /* 156711 */     // GIR_Coverage, 7322,
     /* 156711 */     GIR_EraseRootFromParent_Done,
     /* 156712 */   // Label 2807: @156712
     /* 156712 */   GIM_Try, /*On fail goto*//*Label 2808*/ GIMT_Encode4(156761), // Rule ID 7323 //
     /* 156717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156720 */     GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 156727 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156734 */     // MIs[0] Rn
     /* 156734 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156738 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 156746 */     // (atomic_load_umin:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm)<<P:Predicate_atomic_load_umin_i8>><<P:Predicate_atomic_load_umin_i8_seq_cst>>  =>  (LDUMINALB:{ *:[i32] } GPR32:{ *:[i32] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALB),
     /* 156749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156759 */     GIR_RootConstrainSelectedInstOperands,
     /* 156760 */     // GIR_Coverage, 7323,
     /* 156760 */     GIR_EraseRootFromParent_Done,
     /* 156761 */   // Label 2808: @156761
     /* 156761 */   GIM_Reject,
     /* 156762 */ // Label 2793: @156762
     /* 156762 */ GIM_Reject,
     /* 156763 */ // Label 2791: @156763
     /* 156763 */ GIM_Try, /*On fail goto*//*Label 2809*/ GIMT_Encode4(156989),
     /* 156768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 156771 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 156778 */   GIM_Try, /*On fail goto*//*Label 2810*/ GIMT_Encode4(156820), // Rule ID 7304 //
     /* 156783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156786 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 156789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156793 */     // MIs[0] Rn
     /* 156793 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156797 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156801 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156805 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_monotonic>>  =>  (LDUMINX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINX),
     /* 156808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156812 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156814 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156818 */     GIR_RootConstrainSelectedInstOperands,
     /* 156819 */     // GIR_Coverage, 7304,
     /* 156819 */     GIR_EraseRootFromParent_Done,
     /* 156820 */   // Label 2810: @156820
     /* 156820 */   GIM_Try, /*On fail goto*//*Label 2811*/ GIMT_Encode4(156862), // Rule ID 7305 //
     /* 156825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156828 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 156831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156835 */     // MIs[0] Rn
     /* 156835 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156847 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acquire>>  =>  (LDUMINAX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINAX),
     /* 156850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156856 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156860 */     GIR_RootConstrainSelectedInstOperands,
     /* 156861 */     // GIR_Coverage, 7305,
     /* 156861 */     GIR_EraseRootFromParent_Done,
     /* 156862 */   // Label 2811: @156862
     /* 156862 */   GIM_Try, /*On fail goto*//*Label 2812*/ GIMT_Encode4(156904), // Rule ID 7306 //
     /* 156867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156870 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 156873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156877 */     // MIs[0] Rn
     /* 156877 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156881 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156885 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156889 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_release>>  =>  (LDUMINLX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINLX),
     /* 156892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156898 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156902 */     GIR_RootConstrainSelectedInstOperands,
     /* 156903 */     // GIR_Coverage, 7306,
     /* 156903 */     GIR_EraseRootFromParent_Done,
     /* 156904 */   // Label 2812: @156904
     /* 156904 */   GIM_Try, /*On fail goto*//*Label 2813*/ GIMT_Encode4(156946), // Rule ID 7307 //
     /* 156909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156912 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 156915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156919 */     // MIs[0] Rn
     /* 156919 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156923 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156931 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_acq_rel>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156938 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156940 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156944 */     GIR_RootConstrainSelectedInstOperands,
     /* 156945 */     // GIR_Coverage, 7307,
     /* 156945 */     GIR_EraseRootFromParent_Done,
     /* 156946 */   // Label 2813: @156946
     /* 156946 */   GIM_Try, /*On fail goto*//*Label 2814*/ GIMT_Encode4(156988), // Rule ID 7308 //
     /* 156951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSE),
     /* 156954 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 156957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156961 */     // MIs[0] Rn
     /* 156961 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 156965 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 156969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 156973 */     // (atomic_load_umin:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)<<P:Predicate_atomic_load_umin_i64>><<P:Predicate_atomic_load_umin_i64_seq_cst>>  =>  (LDUMINALX:{ *:[i64] } GPR64:{ *:[i64] }:$Rm, GPR64sp:{ *:[i64] }:$Rn)
     /* 156973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDUMINALX),
     /* 156976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 156978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 156980 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 156982 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 156986 */     GIR_RootConstrainSelectedInstOperands,
     /* 156987 */     // GIR_Coverage, 7308,
     /* 156987 */     GIR_EraseRootFromParent_Done,
     /* 156988 */   // Label 2814: @156988
     /* 156988 */   GIM_Reject,
     /* 156989 */ // Label 2809: @156989
     /* 156989 */ GIM_Reject,
     /* 156990 */ // Label 2792: @156990
     /* 156990 */ GIM_Reject,
     /* 156991 */ // Label 31: @156991
     /* 156991 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2818*/ GIMT_Encode4(157695),
     /* 157002 */ /*GILLT_s16*//*Label 2815*/ GIMT_Encode4(157014),
     /* 157006 */ /*GILLT_s32*//*Label 2816*/ GIMT_Encode4(157241),
     /* 157010 */ /*GILLT_s64*//*Label 2817*/ GIMT_Encode4(157468),
     /* 157014 */ // Label 2815: @157014
     /* 157014 */ GIM_Try, /*On fail goto*//*Label 2819*/ GIMT_Encode4(157240),
     /* 157019 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157022 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157029 */   GIM_Try, /*On fail goto*//*Label 2820*/ GIMT_Encode4(157071), // Rule ID 2580 //
     /* 157034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157037 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157044 */     // MIs[0] Rn
     /* 157044 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157048 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157056 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_monotonic>>  =>  (LDFADDH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDH),
     /* 157059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157065 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157069 */     GIR_RootConstrainSelectedInstOperands,
     /* 157070 */     // GIR_Coverage, 2580,
     /* 157070 */     GIR_EraseRootFromParent_Done,
     /* 157071 */   // Label 2820: @157071
     /* 157071 */   GIM_Try, /*On fail goto*//*Label 2821*/ GIMT_Encode4(157113), // Rule ID 2581 //
     /* 157076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157079 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157086 */     // MIs[0] Rn
     /* 157086 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157090 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157098 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acquire>>  =>  (LDFADDAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAH),
     /* 157101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157111 */     GIR_RootConstrainSelectedInstOperands,
     /* 157112 */     // GIR_Coverage, 2581,
     /* 157112 */     GIR_EraseRootFromParent_Done,
     /* 157113 */   // Label 2821: @157113
     /* 157113 */   GIM_Try, /*On fail goto*//*Label 2822*/ GIMT_Encode4(157155), // Rule ID 2582 //
     /* 157118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157121 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157128 */     // MIs[0] Rn
     /* 157128 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157132 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157140 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_release>>  =>  (LDFADDLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLH),
     /* 157143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157147 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157149 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157153 */     GIR_RootConstrainSelectedInstOperands,
     /* 157154 */     // GIR_Coverage, 2582,
     /* 157154 */     GIR_EraseRootFromParent_Done,
     /* 157155 */   // Label 2822: @157155
     /* 157155 */   GIM_Try, /*On fail goto*//*Label 2823*/ GIMT_Encode4(157197), // Rule ID 2583 //
     /* 157160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157163 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157170 */     // MIs[0] Rn
     /* 157170 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157174 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157182 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_acq_rel>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157189 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157191 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157195 */     GIR_RootConstrainSelectedInstOperands,
     /* 157196 */     // GIR_Coverage, 2583,
     /* 157196 */     GIR_EraseRootFromParent_Done,
     /* 157197 */   // Label 2823: @157197
     /* 157197 */   GIM_Try, /*On fail goto*//*Label 2824*/ GIMT_Encode4(157239), // Rule ID 2584 //
     /* 157202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157205 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157212 */     // MIs[0] Rn
     /* 157212 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157216 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157224 */     // (atomic_load_fadd:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fadd_f16>><<P:Predicate_atomic_load_fadd_f16_seq_cst>>  =>  (LDFADDALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALH),
     /* 157227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157233 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157237 */     GIR_RootConstrainSelectedInstOperands,
     /* 157238 */     // GIR_Coverage, 2584,
     /* 157238 */     GIR_EraseRootFromParent_Done,
     /* 157239 */   // Label 2824: @157239
     /* 157239 */   GIM_Reject,
     /* 157240 */ // Label 2819: @157240
     /* 157240 */ GIM_Reject,
     /* 157241 */ // Label 2816: @157241
     /* 157241 */ GIM_Try, /*On fail goto*//*Label 2825*/ GIMT_Encode4(157467),
     /* 157246 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157249 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157256 */   GIM_Try, /*On fail goto*//*Label 2826*/ GIMT_Encode4(157298), // Rule ID 7399 //
     /* 157261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157264 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157271 */     // MIs[0] Rn
     /* 157271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157283 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_monotonic>>  =>  (LDFADDS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDS),
     /* 157286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157290 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157292 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157296 */     GIR_RootConstrainSelectedInstOperands,
     /* 157297 */     // GIR_Coverage, 7399,
     /* 157297 */     GIR_EraseRootFromParent_Done,
     /* 157298 */   // Label 2826: @157298
     /* 157298 */   GIM_Try, /*On fail goto*//*Label 2827*/ GIMT_Encode4(157340), // Rule ID 7400 //
     /* 157303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157306 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157313 */     // MIs[0] Rn
     /* 157313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157325 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acquire>>  =>  (LDFADDAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAS),
     /* 157328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157338 */     GIR_RootConstrainSelectedInstOperands,
     /* 157339 */     // GIR_Coverage, 7400,
     /* 157339 */     GIR_EraseRootFromParent_Done,
     /* 157340 */   // Label 2827: @157340
     /* 157340 */   GIM_Try, /*On fail goto*//*Label 2828*/ GIMT_Encode4(157382), // Rule ID 7401 //
     /* 157345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157348 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157355 */     // MIs[0] Rn
     /* 157355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157367 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_release>>  =>  (LDFADDLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLS),
     /* 157370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157376 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157380 */     GIR_RootConstrainSelectedInstOperands,
     /* 157381 */     // GIR_Coverage, 7401,
     /* 157381 */     GIR_EraseRootFromParent_Done,
     /* 157382 */   // Label 2828: @157382
     /* 157382 */   GIM_Try, /*On fail goto*//*Label 2829*/ GIMT_Encode4(157424), // Rule ID 7402 //
     /* 157387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157390 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157397 */     // MIs[0] Rn
     /* 157397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157401 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157409 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_acq_rel>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157416 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157418 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157422 */     GIR_RootConstrainSelectedInstOperands,
     /* 157423 */     // GIR_Coverage, 7402,
     /* 157423 */     GIR_EraseRootFromParent_Done,
     /* 157424 */   // Label 2829: @157424
     /* 157424 */   GIM_Try, /*On fail goto*//*Label 2830*/ GIMT_Encode4(157466), // Rule ID 7403 //
     /* 157429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157432 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157439 */     // MIs[0] Rn
     /* 157439 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157443 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157447 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157451 */     // (atomic_load_fadd:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fadd_f32>><<P:Predicate_atomic_load_fadd_f32_seq_cst>>  =>  (LDFADDALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALS),
     /* 157454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157458 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157460 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157464 */     GIR_RootConstrainSelectedInstOperands,
     /* 157465 */     // GIR_Coverage, 7403,
     /* 157465 */     GIR_EraseRootFromParent_Done,
     /* 157466 */   // Label 2830: @157466
     /* 157466 */   GIM_Reject,
     /* 157467 */ // Label 2825: @157467
     /* 157467 */ GIM_Reject,
     /* 157468 */ // Label 2817: @157468
     /* 157468 */ GIM_Try, /*On fail goto*//*Label 2831*/ GIMT_Encode4(157694),
     /* 157473 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 157476 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 157483 */   GIM_Try, /*On fail goto*//*Label 2832*/ GIMT_Encode4(157525), // Rule ID 7404 //
     /* 157488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157491 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157498 */     // MIs[0] Rn
     /* 157498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157502 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157510 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_monotonic>>  =>  (LDFADDD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDD),
     /* 157513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157515 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157519 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157523 */     GIR_RootConstrainSelectedInstOperands,
     /* 157524 */     // GIR_Coverage, 7404,
     /* 157524 */     GIR_EraseRootFromParent_Done,
     /* 157525 */   // Label 2832: @157525
     /* 157525 */   GIM_Try, /*On fail goto*//*Label 2833*/ GIMT_Encode4(157567), // Rule ID 7405 //
     /* 157530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157533 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157540 */     // MIs[0] Rn
     /* 157540 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157552 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acquire>>  =>  (LDFADDAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDAD),
     /* 157555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157559 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157561 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157565 */     GIR_RootConstrainSelectedInstOperands,
     /* 157566 */     // GIR_Coverage, 7405,
     /* 157566 */     GIR_EraseRootFromParent_Done,
     /* 157567 */   // Label 2833: @157567
     /* 157567 */   GIM_Try, /*On fail goto*//*Label 2834*/ GIMT_Encode4(157609), // Rule ID 7406 //
     /* 157572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157575 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157582 */     // MIs[0] Rn
     /* 157582 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157590 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157594 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_release>>  =>  (LDFADDLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDLD),
     /* 157597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157601 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157607 */     GIR_RootConstrainSelectedInstOperands,
     /* 157608 */     // GIR_Coverage, 7406,
     /* 157608 */     GIR_EraseRootFromParent_Done,
     /* 157609 */   // Label 2834: @157609
     /* 157609 */   GIM_Try, /*On fail goto*//*Label 2835*/ GIMT_Encode4(157651), // Rule ID 7407 //
     /* 157614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157617 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157624 */     // MIs[0] Rn
     /* 157624 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157636 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_acq_rel>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157643 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157645 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157649 */     GIR_RootConstrainSelectedInstOperands,
     /* 157650 */     // GIR_Coverage, 7407,
     /* 157650 */     GIR_EraseRootFromParent_Done,
     /* 157651 */   // Label 2835: @157651
     /* 157651 */   GIM_Try, /*On fail goto*//*Label 2836*/ GIMT_Encode4(157693), // Rule ID 7408 //
     /* 157656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157659 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157666 */     // MIs[0] Rn
     /* 157666 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157670 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157678 */     // (atomic_load_fadd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fadd_f64>><<P:Predicate_atomic_load_fadd_f64_seq_cst>>  =>  (LDFADDALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFADDALD),
     /* 157681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157691 */     GIR_RootConstrainSelectedInstOperands,
     /* 157692 */     // GIR_Coverage, 7408,
     /* 157692 */     GIR_EraseRootFromParent_Done,
     /* 157693 */   // Label 2836: @157693
     /* 157693 */   GIM_Reject,
     /* 157694 */ // Label 2831: @157694
     /* 157694 */ GIM_Reject,
     /* 157695 */ // Label 2818: @157695
     /* 157695 */ GIM_Reject,
     /* 157696 */ // Label 32: @157696
     /* 157696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2840*/ GIMT_Encode4(158400),
     /* 157707 */ /*GILLT_s16*//*Label 2837*/ GIMT_Encode4(157719),
     /* 157711 */ /*GILLT_s32*//*Label 2838*/ GIMT_Encode4(157946),
     /* 157715 */ /*GILLT_s64*//*Label 2839*/ GIMT_Encode4(158173),
     /* 157719 */ // Label 2837: @157719
     /* 157719 */ GIM_Try, /*On fail goto*//*Label 2841*/ GIMT_Encode4(157945),
     /* 157724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 157727 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 157734 */   GIM_Try, /*On fail goto*//*Label 2842*/ GIMT_Encode4(157776), // Rule ID 7409 //
     /* 157739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157742 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157749 */     // MIs[0] Rn
     /* 157749 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157753 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157761 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_monotonic>>  =>  (LDFMAXNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMH),
     /* 157764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157768 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157770 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157774 */     GIR_RootConstrainSelectedInstOperands,
     /* 157775 */     // GIR_Coverage, 7409,
     /* 157775 */     GIR_EraseRootFromParent_Done,
     /* 157776 */   // Label 2842: @157776
     /* 157776 */   GIM_Try, /*On fail goto*//*Label 2843*/ GIMT_Encode4(157818), // Rule ID 7410 //
     /* 157781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157784 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 157787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157791 */     // MIs[0] Rn
     /* 157791 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157803 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acquire>>  =>  (LDFMAXNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAH),
     /* 157806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157810 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157812 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157816 */     GIR_RootConstrainSelectedInstOperands,
     /* 157817 */     // GIR_Coverage, 7410,
     /* 157817 */     GIR_EraseRootFromParent_Done,
     /* 157818 */   // Label 2843: @157818
     /* 157818 */   GIM_Try, /*On fail goto*//*Label 2844*/ GIMT_Encode4(157860), // Rule ID 7411 //
     /* 157823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157826 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 157829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157833 */     // MIs[0] Rn
     /* 157833 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157845 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_release>>  =>  (LDFMAXNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLH),
     /* 157848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157852 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157854 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157858 */     GIR_RootConstrainSelectedInstOperands,
     /* 157859 */     // GIR_Coverage, 7411,
     /* 157859 */     GIR_EraseRootFromParent_Done,
     /* 157860 */   // Label 2844: @157860
     /* 157860 */   GIM_Try, /*On fail goto*//*Label 2845*/ GIMT_Encode4(157902), // Rule ID 7412 //
     /* 157865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157868 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 157871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157875 */     // MIs[0] Rn
     /* 157875 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157887 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_acq_rel>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157896 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157900 */     GIR_RootConstrainSelectedInstOperands,
     /* 157901 */     // GIR_Coverage, 7412,
     /* 157901 */     GIR_EraseRootFromParent_Done,
     /* 157902 */   // Label 2845: @157902
     /* 157902 */   GIM_Try, /*On fail goto*//*Label 2846*/ GIMT_Encode4(157944), // Rule ID 7413 //
     /* 157907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157910 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 157913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157917 */     // MIs[0] Rn
     /* 157917 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157921 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157925 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 157929 */     // (atomic_load_fmax:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmax_f16>><<P:Predicate_atomic_load_fmax_f16_seq_cst>>  =>  (LDFMAXNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALH),
     /* 157932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157936 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157938 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 157942 */     GIR_RootConstrainSelectedInstOperands,
     /* 157943 */     // GIR_Coverage, 7413,
     /* 157943 */     GIR_EraseRootFromParent_Done,
     /* 157944 */   // Label 2846: @157944
     /* 157944 */   GIM_Reject,
     /* 157945 */ // Label 2841: @157945
     /* 157945 */ GIM_Reject,
     /* 157946 */ // Label 2838: @157946
     /* 157946 */ GIM_Try, /*On fail goto*//*Label 2847*/ GIMT_Encode4(158172),
     /* 157951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 157954 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 157961 */   GIM_Try, /*On fail goto*//*Label 2848*/ GIMT_Encode4(158003), // Rule ID 7414 //
     /* 157966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 157969 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 157972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157976 */     // MIs[0] Rn
     /* 157976 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 157980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 157984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 157988 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_monotonic>>  =>  (LDFMAXNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 157988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMS),
     /* 157991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 157993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 157995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 157997 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158001 */     GIR_RootConstrainSelectedInstOperands,
     /* 158002 */     // GIR_Coverage, 7414,
     /* 158002 */     GIR_EraseRootFromParent_Done,
     /* 158003 */   // Label 2848: @158003
     /* 158003 */   GIM_Try, /*On fail goto*//*Label 2849*/ GIMT_Encode4(158045), // Rule ID 7415 //
     /* 158008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158011 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158018 */     // MIs[0] Rn
     /* 158018 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158022 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158030 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acquire>>  =>  (LDFMAXNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAS),
     /* 158033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158035 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158039 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158043 */     GIR_RootConstrainSelectedInstOperands,
     /* 158044 */     // GIR_Coverage, 7415,
     /* 158044 */     GIR_EraseRootFromParent_Done,
     /* 158045 */   // Label 2849: @158045
     /* 158045 */   GIM_Try, /*On fail goto*//*Label 2850*/ GIMT_Encode4(158087), // Rule ID 7416 //
     /* 158050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158053 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158056 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158060 */     // MIs[0] Rn
     /* 158060 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158068 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158072 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_release>>  =>  (LDFMAXNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLS),
     /* 158075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158081 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158085 */     GIR_RootConstrainSelectedInstOperands,
     /* 158086 */     // GIR_Coverage, 7416,
     /* 158086 */     GIR_EraseRootFromParent_Done,
     /* 158087 */   // Label 2850: @158087
     /* 158087 */   GIM_Try, /*On fail goto*//*Label 2851*/ GIMT_Encode4(158129), // Rule ID 7417 //
     /* 158092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158095 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158102 */     // MIs[0] Rn
     /* 158102 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158110 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158114 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_acq_rel>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158121 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158123 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158127 */     GIR_RootConstrainSelectedInstOperands,
     /* 158128 */     // GIR_Coverage, 7417,
     /* 158128 */     GIR_EraseRootFromParent_Done,
     /* 158129 */   // Label 2851: @158129
     /* 158129 */   GIM_Try, /*On fail goto*//*Label 2852*/ GIMT_Encode4(158171), // Rule ID 7418 //
     /* 158134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158137 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158144 */     // MIs[0] Rn
     /* 158144 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158148 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158156 */     // (atomic_load_fmax:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmax_f32>><<P:Predicate_atomic_load_fmax_f32_seq_cst>>  =>  (LDFMAXNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALS),
     /* 158159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158163 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158165 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158169 */     GIR_RootConstrainSelectedInstOperands,
     /* 158170 */     // GIR_Coverage, 7418,
     /* 158170 */     GIR_EraseRootFromParent_Done,
     /* 158171 */   // Label 2852: @158171
     /* 158171 */   GIM_Reject,
     /* 158172 */ // Label 2847: @158172
     /* 158172 */ GIM_Reject,
     /* 158173 */ // Label 2839: @158173
     /* 158173 */ GIM_Try, /*On fail goto*//*Label 2853*/ GIMT_Encode4(158399),
     /* 158178 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158181 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158188 */   GIM_Try, /*On fail goto*//*Label 2854*/ GIMT_Encode4(158230), // Rule ID 7419 //
     /* 158193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158196 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158203 */     // MIs[0] Rn
     /* 158203 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158207 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158215 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_monotonic>>  =>  (LDFMAXNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMD),
     /* 158218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158224 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158228 */     GIR_RootConstrainSelectedInstOperands,
     /* 158229 */     // GIR_Coverage, 7419,
     /* 158229 */     GIR_EraseRootFromParent_Done,
     /* 158230 */   // Label 2854: @158230
     /* 158230 */   GIM_Try, /*On fail goto*//*Label 2855*/ GIMT_Encode4(158272), // Rule ID 7420 //
     /* 158235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158238 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158245 */     // MIs[0] Rn
     /* 158245 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158257 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acquire>>  =>  (LDFMAXNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMAD),
     /* 158260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158264 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158266 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158270 */     GIR_RootConstrainSelectedInstOperands,
     /* 158271 */     // GIR_Coverage, 7420,
     /* 158271 */     GIR_EraseRootFromParent_Done,
     /* 158272 */   // Label 2855: @158272
     /* 158272 */   GIM_Try, /*On fail goto*//*Label 2856*/ GIMT_Encode4(158314), // Rule ID 7421 //
     /* 158277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158280 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158287 */     // MIs[0] Rn
     /* 158287 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158295 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158299 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_release>>  =>  (LDFMAXNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMLD),
     /* 158302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158308 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158312 */     GIR_RootConstrainSelectedInstOperands,
     /* 158313 */     // GIR_Coverage, 7421,
     /* 158313 */     GIR_EraseRootFromParent_Done,
     /* 158314 */   // Label 2856: @158314
     /* 158314 */   GIM_Try, /*On fail goto*//*Label 2857*/ GIMT_Encode4(158356), // Rule ID 7422 //
     /* 158319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158322 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158329 */     // MIs[0] Rn
     /* 158329 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158333 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158337 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158341 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_acq_rel>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158348 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158350 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158354 */     GIR_RootConstrainSelectedInstOperands,
     /* 158355 */     // GIR_Coverage, 7422,
     /* 158355 */     GIR_EraseRootFromParent_Done,
     /* 158356 */   // Label 2857: @158356
     /* 158356 */   GIM_Try, /*On fail goto*//*Label 2858*/ GIMT_Encode4(158398), // Rule ID 7423 //
     /* 158361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158364 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158371 */     // MIs[0] Rn
     /* 158371 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158383 */     // (atomic_load_fmax:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmax_f64>><<P:Predicate_atomic_load_fmax_f64_seq_cst>>  =>  (LDFMAXNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXNMALD),
     /* 158386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158390 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158392 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158396 */     GIR_RootConstrainSelectedInstOperands,
     /* 158397 */     // GIR_Coverage, 7423,
     /* 158397 */     GIR_EraseRootFromParent_Done,
     /* 158398 */   // Label 2858: @158398
     /* 158398 */   GIM_Reject,
     /* 158399 */ // Label 2853: @158399
     /* 158399 */ GIM_Reject,
     /* 158400 */ // Label 2840: @158400
     /* 158400 */ GIM_Reject,
     /* 158401 */ // Label 33: @158401
     /* 158401 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2862*/ GIMT_Encode4(159105),
     /* 158412 */ /*GILLT_s16*//*Label 2859*/ GIMT_Encode4(158424),
     /* 158416 */ /*GILLT_s32*//*Label 2860*/ GIMT_Encode4(158651),
     /* 158420 */ /*GILLT_s64*//*Label 2861*/ GIMT_Encode4(158878),
     /* 158424 */ // Label 2859: @158424
     /* 158424 */ GIM_Try, /*On fail goto*//*Label 2863*/ GIMT_Encode4(158650),
     /* 158429 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 158432 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 158439 */   GIM_Try, /*On fail goto*//*Label 2864*/ GIMT_Encode4(158481), // Rule ID 7424 //
     /* 158444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158447 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158454 */     // MIs[0] Rn
     /* 158454 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158458 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158462 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158466 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_monotonic>>  =>  (LDFMINNMH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMH),
     /* 158469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158475 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158479 */     GIR_RootConstrainSelectedInstOperands,
     /* 158480 */     // GIR_Coverage, 7424,
     /* 158480 */     GIR_EraseRootFromParent_Done,
     /* 158481 */   // Label 2864: @158481
     /* 158481 */   GIM_Try, /*On fail goto*//*Label 2865*/ GIMT_Encode4(158523), // Rule ID 7425 //
     /* 158486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158489 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158496 */     // MIs[0] Rn
     /* 158496 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158508 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acquire>>  =>  (LDFMINNMAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAH),
     /* 158511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158517 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158521 */     GIR_RootConstrainSelectedInstOperands,
     /* 158522 */     // GIR_Coverage, 7425,
     /* 158522 */     GIR_EraseRootFromParent_Done,
     /* 158523 */   // Label 2865: @158523
     /* 158523 */   GIM_Try, /*On fail goto*//*Label 2866*/ GIMT_Encode4(158565), // Rule ID 7426 //
     /* 158528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158531 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158538 */     // MIs[0] Rn
     /* 158538 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158550 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_release>>  =>  (LDFMINNMLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLH),
     /* 158553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158555 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158557 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158559 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158563 */     GIR_RootConstrainSelectedInstOperands,
     /* 158564 */     // GIR_Coverage, 7426,
     /* 158564 */     GIR_EraseRootFromParent_Done,
     /* 158565 */   // Label 2866: @158565
     /* 158565 */   GIM_Try, /*On fail goto*//*Label 2867*/ GIMT_Encode4(158607), // Rule ID 7427 //
     /* 158570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158573 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158580 */     // MIs[0] Rn
     /* 158580 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158584 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158592 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_acq_rel>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158599 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158601 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158605 */     GIR_RootConstrainSelectedInstOperands,
     /* 158606 */     // GIR_Coverage, 7427,
     /* 158606 */     GIR_EraseRootFromParent_Done,
     /* 158607 */   // Label 2867: @158607
     /* 158607 */   GIM_Try, /*On fail goto*//*Label 2868*/ GIMT_Encode4(158649), // Rule ID 7428 //
     /* 158612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158615 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158622 */     // MIs[0] Rn
     /* 158622 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158626 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158630 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 158634 */     // (atomic_load_fmin:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmin_f16>><<P:Predicate_atomic_load_fmin_f16_seq_cst>>  =>  (LDFMINNMALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALH),
     /* 158637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158647 */     GIR_RootConstrainSelectedInstOperands,
     /* 158648 */     // GIR_Coverage, 7428,
     /* 158648 */     GIR_EraseRootFromParent_Done,
     /* 158649 */   // Label 2868: @158649
     /* 158649 */   GIM_Reject,
     /* 158650 */ // Label 2863: @158650
     /* 158650 */ GIM_Reject,
     /* 158651 */ // Label 2860: @158651
     /* 158651 */ GIM_Try, /*On fail goto*//*Label 2869*/ GIMT_Encode4(158877),
     /* 158656 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 158659 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 158666 */   GIM_Try, /*On fail goto*//*Label 2870*/ GIMT_Encode4(158708), // Rule ID 7429 //
     /* 158671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158674 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158677 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158681 */     // MIs[0] Rn
     /* 158681 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158685 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158693 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_monotonic>>  =>  (LDFMINNMS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMS),
     /* 158696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158700 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158702 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158706 */     GIR_RootConstrainSelectedInstOperands,
     /* 158707 */     // GIR_Coverage, 7429,
     /* 158707 */     GIR_EraseRootFromParent_Done,
     /* 158708 */   // Label 2870: @158708
     /* 158708 */   GIM_Try, /*On fail goto*//*Label 2871*/ GIMT_Encode4(158750), // Rule ID 7430 //
     /* 158713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158716 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158723 */     // MIs[0] Rn
     /* 158723 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158727 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158735 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acquire>>  =>  (LDFMINNMAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAS),
     /* 158738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158744 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158748 */     GIR_RootConstrainSelectedInstOperands,
     /* 158749 */     // GIR_Coverage, 7430,
     /* 158749 */     GIR_EraseRootFromParent_Done,
     /* 158750 */   // Label 2871: @158750
     /* 158750 */   GIM_Try, /*On fail goto*//*Label 2872*/ GIMT_Encode4(158792), // Rule ID 7431 //
     /* 158755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158758 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158761 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158765 */     // MIs[0] Rn
     /* 158765 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158769 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158777 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_release>>  =>  (LDFMINNMLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLS),
     /* 158780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158786 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158790 */     GIR_RootConstrainSelectedInstOperands,
     /* 158791 */     // GIR_Coverage, 7431,
     /* 158791 */     GIR_EraseRootFromParent_Done,
     /* 158792 */   // Label 2872: @158792
     /* 158792 */   GIM_Try, /*On fail goto*//*Label 2873*/ GIMT_Encode4(158834), // Rule ID 7432 //
     /* 158797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158800 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 158803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158807 */     // MIs[0] Rn
     /* 158807 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158811 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158815 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158819 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_acq_rel>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158826 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158828 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158832 */     GIR_RootConstrainSelectedInstOperands,
     /* 158833 */     // GIR_Coverage, 7432,
     /* 158833 */     GIR_EraseRootFromParent_Done,
     /* 158834 */   // Label 2873: @158834
     /* 158834 */   GIM_Try, /*On fail goto*//*Label 2874*/ GIMT_Encode4(158876), // Rule ID 7433 //
     /* 158839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158842 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 158845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158849 */     // MIs[0] Rn
     /* 158849 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158853 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 158861 */     // (atomic_load_fmin:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmin_f32>><<P:Predicate_atomic_load_fmin_f32_seq_cst>>  =>  (LDFMINNMALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALS),
     /* 158864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158868 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158870 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158874 */     GIR_RootConstrainSelectedInstOperands,
     /* 158875 */     // GIR_Coverage, 7433,
     /* 158875 */     GIR_EraseRootFromParent_Done,
     /* 158876 */   // Label 2874: @158876
     /* 158876 */   GIM_Reject,
     /* 158877 */ // Label 2869: @158877
     /* 158877 */ GIM_Reject,
     /* 158878 */ // Label 2861: @158878
     /* 158878 */ GIM_Try, /*On fail goto*//*Label 2875*/ GIMT_Encode4(159104),
     /* 158883 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 158886 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 158893 */   GIM_Try, /*On fail goto*//*Label 2876*/ GIMT_Encode4(158935), // Rule ID 7434 //
     /* 158898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158901 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 158904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158908 */     // MIs[0] Rn
     /* 158908 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158920 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_monotonic>>  =>  (LDFMINNMD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMD),
     /* 158923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158927 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158929 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158933 */     GIR_RootConstrainSelectedInstOperands,
     /* 158934 */     // GIR_Coverage, 7434,
     /* 158934 */     GIR_EraseRootFromParent_Done,
     /* 158935 */   // Label 2876: @158935
     /* 158935 */   GIM_Try, /*On fail goto*//*Label 2877*/ GIMT_Encode4(158977), // Rule ID 7435 //
     /* 158940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158943 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 158946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158950 */     // MIs[0] Rn
     /* 158950 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158954 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158962 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acquire>>  =>  (LDFMINNMAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 158962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMAD),
     /* 158965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 158967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 158969 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 158971 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 158975 */     GIR_RootConstrainSelectedInstOperands,
     /* 158976 */     // GIR_Coverage, 7435,
     /* 158976 */     GIR_EraseRootFromParent_Done,
     /* 158977 */   // Label 2877: @158977
     /* 158977 */   GIM_Try, /*On fail goto*//*Label 2878*/ GIMT_Encode4(159019), // Rule ID 7436 //
     /* 158982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 158985 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 158988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 158992 */     // MIs[0] Rn
     /* 158992 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 158996 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159004 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_release>>  =>  (LDFMINNMLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMLD),
     /* 159007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159013 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159017 */     GIR_RootConstrainSelectedInstOperands,
     /* 159018 */     // GIR_Coverage, 7436,
     /* 159018 */     GIR_EraseRootFromParent_Done,
     /* 159019 */   // Label 2878: @159019
     /* 159019 */   GIM_Try, /*On fail goto*//*Label 2879*/ GIMT_Encode4(159061), // Rule ID 7437 //
     /* 159024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159027 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159034 */     // MIs[0] Rn
     /* 159034 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159038 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159042 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159046 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_acq_rel>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159051 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159059 */     GIR_RootConstrainSelectedInstOperands,
     /* 159060 */     // GIR_Coverage, 7437,
     /* 159060 */     GIR_EraseRootFromParent_Done,
     /* 159061 */   // Label 2879: @159061
     /* 159061 */   GIM_Try, /*On fail goto*//*Label 2880*/ GIMT_Encode4(159103), // Rule ID 7438 //
     /* 159066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159069 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159076 */     // MIs[0] Rn
     /* 159076 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159080 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159088 */     // (atomic_load_fmin:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmin_f64>><<P:Predicate_atomic_load_fmin_f64_seq_cst>>  =>  (LDFMINNMALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINNMALD),
     /* 159091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159095 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159101 */     GIR_RootConstrainSelectedInstOperands,
     /* 159102 */     // GIR_Coverage, 7438,
     /* 159102 */     GIR_EraseRootFromParent_Done,
     /* 159103 */   // Label 2880: @159103
     /* 159103 */   GIM_Reject,
     /* 159104 */ // Label 2875: @159104
     /* 159104 */ GIM_Reject,
     /* 159105 */ // Label 2862: @159105
     /* 159105 */ GIM_Reject,
     /* 159106 */ // Label 34: @159106
     /* 159106 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2884*/ GIMT_Encode4(159810),
     /* 159117 */ /*GILLT_s16*//*Label 2881*/ GIMT_Encode4(159129),
     /* 159121 */ /*GILLT_s32*//*Label 2882*/ GIMT_Encode4(159356),
     /* 159125 */ /*GILLT_s64*//*Label 2883*/ GIMT_Encode4(159583),
     /* 159129 */ // Label 2881: @159129
     /* 159129 */ GIM_Try, /*On fail goto*//*Label 2885*/ GIMT_Encode4(159355),
     /* 159134 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159137 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159144 */   GIM_Try, /*On fail goto*//*Label 2886*/ GIMT_Encode4(159186), // Rule ID 7439 //
     /* 159149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159152 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159159 */     // MIs[0] Rn
     /* 159159 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159167 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159171 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_monotonic>>  =>  (LDFMAXH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXH),
     /* 159174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159178 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159180 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159184 */     GIR_RootConstrainSelectedInstOperands,
     /* 159185 */     // GIR_Coverage, 7439,
     /* 159185 */     GIR_EraseRootFromParent_Done,
     /* 159186 */   // Label 2886: @159186
     /* 159186 */   GIM_Try, /*On fail goto*//*Label 2887*/ GIMT_Encode4(159228), // Rule ID 7440 //
     /* 159191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159194 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159201 */     // MIs[0] Rn
     /* 159201 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159213 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acquire>>  =>  (LDFMAXAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAH),
     /* 159216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159220 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159222 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159226 */     GIR_RootConstrainSelectedInstOperands,
     /* 159227 */     // GIR_Coverage, 7440,
     /* 159227 */     GIR_EraseRootFromParent_Done,
     /* 159228 */   // Label 2887: @159228
     /* 159228 */   GIM_Try, /*On fail goto*//*Label 2888*/ GIMT_Encode4(159270), // Rule ID 7441 //
     /* 159233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159236 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159243 */     // MIs[0] Rn
     /* 159243 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159255 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_release>>  =>  (LDFMAXLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLH),
     /* 159258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159260 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159268 */     GIR_RootConstrainSelectedInstOperands,
     /* 159269 */     // GIR_Coverage, 7441,
     /* 159269 */     GIR_EraseRootFromParent_Done,
     /* 159270 */   // Label 2888: @159270
     /* 159270 */   GIM_Try, /*On fail goto*//*Label 2889*/ GIMT_Encode4(159312), // Rule ID 7442 //
     /* 159275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159278 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159285 */     // MIs[0] Rn
     /* 159285 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159297 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_acq_rel>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159304 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159306 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159310 */     GIR_RootConstrainSelectedInstOperands,
     /* 159311 */     // GIR_Coverage, 7442,
     /* 159311 */     GIR_EraseRootFromParent_Done,
     /* 159312 */   // Label 2889: @159312
     /* 159312 */   GIM_Try, /*On fail goto*//*Label 2890*/ GIMT_Encode4(159354), // Rule ID 7443 //
     /* 159317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159320 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159327 */     // MIs[0] Rn
     /* 159327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159331 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159335 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159339 */     // (atomic_load_fmaximum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f16>><<P:Predicate_atomic_load_fmaximum_f16_seq_cst>>  =>  (LDFMAXALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALH),
     /* 159342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159346 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159348 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159352 */     GIR_RootConstrainSelectedInstOperands,
     /* 159353 */     // GIR_Coverage, 7443,
     /* 159353 */     GIR_EraseRootFromParent_Done,
     /* 159354 */   // Label 2890: @159354
     /* 159354 */   GIM_Reject,
     /* 159355 */ // Label 2885: @159355
     /* 159355 */ GIM_Reject,
     /* 159356 */ // Label 2882: @159356
     /* 159356 */ GIM_Try, /*On fail goto*//*Label 2891*/ GIMT_Encode4(159582),
     /* 159361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 159364 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 159371 */   GIM_Try, /*On fail goto*//*Label 2892*/ GIMT_Encode4(159413), // Rule ID 7444 //
     /* 159376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159379 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159382 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159386 */     // MIs[0] Rn
     /* 159386 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159390 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159398 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_monotonic>>  =>  (LDFMAXS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXS),
     /* 159401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159411 */     GIR_RootConstrainSelectedInstOperands,
     /* 159412 */     // GIR_Coverage, 7444,
     /* 159412 */     GIR_EraseRootFromParent_Done,
     /* 159413 */   // Label 2892: @159413
     /* 159413 */   GIM_Try, /*On fail goto*//*Label 2893*/ GIMT_Encode4(159455), // Rule ID 7445 //
     /* 159418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159421 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159428 */     // MIs[0] Rn
     /* 159428 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159432 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159440 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acquire>>  =>  (LDFMAXAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAS),
     /* 159443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159447 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159449 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159453 */     GIR_RootConstrainSelectedInstOperands,
     /* 159454 */     // GIR_Coverage, 7445,
     /* 159454 */     GIR_EraseRootFromParent_Done,
     /* 159455 */   // Label 2893: @159455
     /* 159455 */   GIM_Try, /*On fail goto*//*Label 2894*/ GIMT_Encode4(159497), // Rule ID 7446 //
     /* 159460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159463 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159470 */     // MIs[0] Rn
     /* 159470 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159482 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_release>>  =>  (LDFMAXLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLS),
     /* 159485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159489 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159491 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159495 */     GIR_RootConstrainSelectedInstOperands,
     /* 159496 */     // GIR_Coverage, 7446,
     /* 159496 */     GIR_EraseRootFromParent_Done,
     /* 159497 */   // Label 2894: @159497
     /* 159497 */   GIM_Try, /*On fail goto*//*Label 2895*/ GIMT_Encode4(159539), // Rule ID 7447 //
     /* 159502 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159505 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159512 */     // MIs[0] Rn
     /* 159512 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159516 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159524 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_acq_rel>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159531 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159533 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159537 */     GIR_RootConstrainSelectedInstOperands,
     /* 159538 */     // GIR_Coverage, 7447,
     /* 159538 */     GIR_EraseRootFromParent_Done,
     /* 159539 */   // Label 2895: @159539
     /* 159539 */   GIM_Try, /*On fail goto*//*Label 2896*/ GIMT_Encode4(159581), // Rule ID 7448 //
     /* 159544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159547 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159554 */     // MIs[0] Rn
     /* 159554 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 159566 */     // (atomic_load_fmaximum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f32>><<P:Predicate_atomic_load_fmaximum_f32_seq_cst>>  =>  (LDFMAXALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALS),
     /* 159569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159573 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159579 */     GIR_RootConstrainSelectedInstOperands,
     /* 159580 */     // GIR_Coverage, 7448,
     /* 159580 */     GIR_EraseRootFromParent_Done,
     /* 159581 */   // Label 2896: @159581
     /* 159581 */   GIM_Reject,
     /* 159582 */ // Label 2891: @159582
     /* 159582 */ GIM_Reject,
     /* 159583 */ // Label 2883: @159583
     /* 159583 */ GIM_Try, /*On fail goto*//*Label 2897*/ GIMT_Encode4(159809),
     /* 159588 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 159591 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 159598 */   GIM_Try, /*On fail goto*//*Label 2898*/ GIMT_Encode4(159640), // Rule ID 7449 //
     /* 159603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159606 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159613 */     // MIs[0] Rn
     /* 159613 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159617 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159625 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_monotonic>>  =>  (LDFMAXD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXD),
     /* 159628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159632 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159634 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159638 */     GIR_RootConstrainSelectedInstOperands,
     /* 159639 */     // GIR_Coverage, 7449,
     /* 159639 */     GIR_EraseRootFromParent_Done,
     /* 159640 */   // Label 2898: @159640
     /* 159640 */   GIM_Try, /*On fail goto*//*Label 2899*/ GIMT_Encode4(159682), // Rule ID 7450 //
     /* 159645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159648 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159655 */     // MIs[0] Rn
     /* 159655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159659 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159667 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acquire>>  =>  (LDFMAXAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXAD),
     /* 159670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159676 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159680 */     GIR_RootConstrainSelectedInstOperands,
     /* 159681 */     // GIR_Coverage, 7450,
     /* 159681 */     GIR_EraseRootFromParent_Done,
     /* 159682 */   // Label 2899: @159682
     /* 159682 */   GIM_Try, /*On fail goto*//*Label 2900*/ GIMT_Encode4(159724), // Rule ID 7451 //
     /* 159687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159690 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159697 */     // MIs[0] Rn
     /* 159697 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159701 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159709 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_release>>  =>  (LDFMAXLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXLD),
     /* 159712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159714 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159716 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159718 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159722 */     GIR_RootConstrainSelectedInstOperands,
     /* 159723 */     // GIR_Coverage, 7451,
     /* 159723 */     GIR_EraseRootFromParent_Done,
     /* 159724 */   // Label 2900: @159724
     /* 159724 */   GIM_Try, /*On fail goto*//*Label 2901*/ GIMT_Encode4(159766), // Rule ID 7452 //
     /* 159729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159732 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159739 */     // MIs[0] Rn
     /* 159739 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159743 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159747 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159751 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_acq_rel>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159758 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159760 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159764 */     GIR_RootConstrainSelectedInstOperands,
     /* 159765 */     // GIR_Coverage, 7452,
     /* 159765 */     GIR_EraseRootFromParent_Done,
     /* 159766 */   // Label 2901: @159766
     /* 159766 */   GIM_Try, /*On fail goto*//*Label 2902*/ GIMT_Encode4(159808), // Rule ID 7453 //
     /* 159771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159774 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 159777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159781 */     // MIs[0] Rn
     /* 159781 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159793 */     // (atomic_load_fmaximum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fmaximum_f64>><<P:Predicate_atomic_load_fmaximum_f64_seq_cst>>  =>  (LDFMAXALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMAXALD),
     /* 159796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159800 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159802 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159806 */     GIR_RootConstrainSelectedInstOperands,
     /* 159807 */     // GIR_Coverage, 7453,
     /* 159807 */     GIR_EraseRootFromParent_Done,
     /* 159808 */   // Label 2902: @159808
     /* 159808 */   GIM_Reject,
     /* 159809 */ // Label 2897: @159809
     /* 159809 */ GIM_Reject,
     /* 159810 */ // Label 2884: @159810
     /* 159810 */ GIM_Reject,
     /* 159811 */ // Label 35: @159811
     /* 159811 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 2906*/ GIMT_Encode4(160515),
     /* 159822 */ /*GILLT_s16*//*Label 2903*/ GIMT_Encode4(159834),
     /* 159826 */ /*GILLT_s32*//*Label 2904*/ GIMT_Encode4(160061),
     /* 159830 */ /*GILLT_s64*//*Label 2905*/ GIMT_Encode4(160288),
     /* 159834 */ // Label 2903: @159834
     /* 159834 */ GIM_Try, /*On fail goto*//*Label 2907*/ GIMT_Encode4(160060),
     /* 159839 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 159842 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 159849 */   GIM_Try, /*On fail goto*//*Label 2908*/ GIMT_Encode4(159891), // Rule ID 7454 //
     /* 159854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159857 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 159860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159864 */     // MIs[0] Rn
     /* 159864 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159868 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159876 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_monotonic>>  =>  (LDFMINH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINH),
     /* 159879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159883 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159889 */     GIR_RootConstrainSelectedInstOperands,
     /* 159890 */     // GIR_Coverage, 7454,
     /* 159890 */     GIR_EraseRootFromParent_Done,
     /* 159891 */   // Label 2908: @159891
     /* 159891 */   GIM_Try, /*On fail goto*//*Label 2909*/ GIMT_Encode4(159933), // Rule ID 7455 //
     /* 159896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159899 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 159902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159906 */     // MIs[0] Rn
     /* 159906 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159910 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159918 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acquire>>  =>  (LDFMINAH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAH),
     /* 159921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159925 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159931 */     GIR_RootConstrainSelectedInstOperands,
     /* 159932 */     // GIR_Coverage, 7455,
     /* 159932 */     GIR_EraseRootFromParent_Done,
     /* 159933 */   // Label 2909: @159933
     /* 159933 */   GIM_Try, /*On fail goto*//*Label 2910*/ GIMT_Encode4(159975), // Rule ID 7456 //
     /* 159938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159941 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 159944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159948 */     // MIs[0] Rn
     /* 159948 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159952 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159960 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_release>>  =>  (LDFMINLH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 159960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLH),
     /* 159963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 159965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 159967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 159969 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 159973 */     GIR_RootConstrainSelectedInstOperands,
     /* 159974 */     // GIR_Coverage, 7456,
     /* 159974 */     GIR_EraseRootFromParent_Done,
     /* 159975 */   // Label 2910: @159975
     /* 159975 */   GIM_Try, /*On fail goto*//*Label 2911*/ GIMT_Encode4(160017), // Rule ID 7457 //
     /* 159980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 159983 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 159986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 159990 */     // MIs[0] Rn
     /* 159990 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 159994 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 159998 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160002 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_acq_rel>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160009 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160011 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160015 */     GIR_RootConstrainSelectedInstOperands,
     /* 160016 */     // GIR_Coverage, 7457,
     /* 160016 */     GIR_EraseRootFromParent_Done,
     /* 160017 */   // Label 2911: @160017
     /* 160017 */   GIM_Try, /*On fail goto*//*Label 2912*/ GIMT_Encode4(160059), // Rule ID 7458 //
     /* 160022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160025 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160032 */     // MIs[0] Rn
     /* 160032 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 160044 */     // (atomic_load_fminimum:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, FPR16:{ *:[f16] }:$Rm)<<P:Predicate_atomic_load_fminimum_f16>><<P:Predicate_atomic_load_fminimum_f16_seq_cst>>  =>  (LDFMINALH:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALH),
     /* 160047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160053 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160057 */     GIR_RootConstrainSelectedInstOperands,
     /* 160058 */     // GIR_Coverage, 7458,
     /* 160058 */     GIR_EraseRootFromParent_Done,
     /* 160059 */   // Label 2912: @160059
     /* 160059 */   GIM_Reject,
     /* 160060 */ // Label 2907: @160060
     /* 160060 */ GIM_Reject,
     /* 160061 */ // Label 2904: @160061
     /* 160061 */ GIM_Try, /*On fail goto*//*Label 2913*/ GIMT_Encode4(160287),
     /* 160066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 160069 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(4),
     /* 160076 */   GIM_Try, /*On fail goto*//*Label 2914*/ GIMT_Encode4(160118), // Rule ID 7459 //
     /* 160081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160084 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160091 */     // MIs[0] Rn
     /* 160091 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160095 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160103 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_monotonic>>  =>  (LDFMINS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINS),
     /* 160106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160110 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160116 */     GIR_RootConstrainSelectedInstOperands,
     /* 160117 */     // GIR_Coverage, 7459,
     /* 160117 */     GIR_EraseRootFromParent_Done,
     /* 160118 */   // Label 2914: @160118
     /* 160118 */   GIM_Try, /*On fail goto*//*Label 2915*/ GIMT_Encode4(160160), // Rule ID 7460 //
     /* 160123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160126 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160133 */     // MIs[0] Rn
     /* 160133 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160137 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160145 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acquire>>  =>  (LDFMINAS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAS),
     /* 160148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160152 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160154 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160158 */     GIR_RootConstrainSelectedInstOperands,
     /* 160159 */     // GIR_Coverage, 7460,
     /* 160159 */     GIR_EraseRootFromParent_Done,
     /* 160160 */   // Label 2915: @160160
     /* 160160 */   GIM_Try, /*On fail goto*//*Label 2916*/ GIMT_Encode4(160202), // Rule ID 7461 //
     /* 160165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160168 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160175 */     // MIs[0] Rn
     /* 160175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160179 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160183 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160187 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_release>>  =>  (LDFMINLS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLS),
     /* 160190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160196 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160200 */     GIR_RootConstrainSelectedInstOperands,
     /* 160201 */     // GIR_Coverage, 7461,
     /* 160201 */     GIR_EraseRootFromParent_Done,
     /* 160202 */   // Label 2916: @160202
     /* 160202 */   GIM_Try, /*On fail goto*//*Label 2917*/ GIMT_Encode4(160244), // Rule ID 7462 //
     /* 160207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160210 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160217 */     // MIs[0] Rn
     /* 160217 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160221 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160229 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_acq_rel>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160236 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160238 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160242 */     GIR_RootConstrainSelectedInstOperands,
     /* 160243 */     // GIR_Coverage, 7462,
     /* 160243 */     GIR_EraseRootFromParent_Done,
     /* 160244 */   // Label 2917: @160244
     /* 160244 */   GIM_Try, /*On fail goto*//*Label 2918*/ GIMT_Encode4(160286), // Rule ID 7463 //
     /* 160249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160252 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160259 */     // MIs[0] Rn
     /* 160259 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 160271 */     // (atomic_load_fminimum:{ *:[f32] } FPR64:{ *:[i64] }:$Rn, FPR32:{ *:[f32] }:$Rm)<<P:Predicate_atomic_load_fminimum_f32>><<P:Predicate_atomic_load_fminimum_f32_seq_cst>>  =>  (LDFMINALS:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALS),
     /* 160274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160278 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160280 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160284 */     GIR_RootConstrainSelectedInstOperands,
     /* 160285 */     // GIR_Coverage, 7463,
     /* 160285 */     GIR_EraseRootFromParent_Done,
     /* 160286 */   // Label 2918: @160286
     /* 160286 */   GIM_Reject,
     /* 160287 */ // Label 2913: @160287
     /* 160287 */ GIM_Reject,
     /* 160288 */ // Label 2905: @160288
     /* 160288 */ GIM_Try, /*On fail goto*//*Label 2919*/ GIMT_Encode4(160514),
     /* 160293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160296 */   GIM_CheckMemorySizeEqualTo, /*MI*/0, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 160303 */   GIM_Try, /*On fail goto*//*Label 2920*/ GIMT_Encode4(160345), // Rule ID 7464 //
     /* 160308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160311 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Monotonic,
     /* 160314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160318 */     // MIs[0] Rn
     /* 160318 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160322 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160330 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_monotonic>>  =>  (LDFMIND:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMIND),
     /* 160333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160335 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160337 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160339 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160343 */     GIR_RootConstrainSelectedInstOperands,
     /* 160344 */     // GIR_Coverage, 7464,
     /* 160344 */     GIR_EraseRootFromParent_Done,
     /* 160345 */   // Label 2920: @160345
     /* 160345 */   GIM_Try, /*On fail goto*//*Label 2921*/ GIMT_Encode4(160387), // Rule ID 7465 //
     /* 160350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160353 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 160356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160360 */     // MIs[0] Rn
     /* 160360 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160364 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160372 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acquire>>  =>  (LDFMINAD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINAD),
     /* 160375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160381 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160385 */     GIR_RootConstrainSelectedInstOperands,
     /* 160386 */     // GIR_Coverage, 7465,
     /* 160386 */     GIR_EraseRootFromParent_Done,
     /* 160387 */   // Label 2921: @160387
     /* 160387 */   GIM_Try, /*On fail goto*//*Label 2922*/ GIMT_Encode4(160429), // Rule ID 7466 //
     /* 160392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160395 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::Release,
     /* 160398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160402 */     // MIs[0] Rn
     /* 160402 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160406 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160410 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160414 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_release>>  =>  (LDFMINLD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINLD),
     /* 160417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160419 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160421 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160423 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160427 */     GIR_RootConstrainSelectedInstOperands,
     /* 160428 */     // GIR_Coverage, 7466,
     /* 160428 */     GIR_EraseRootFromParent_Done,
     /* 160429 */   // Label 2922: @160429
     /* 160429 */   GIM_Try, /*On fail goto*//*Label 2923*/ GIMT_Encode4(160471), // Rule ID 7467 //
     /* 160434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160437 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::AcquireRelease,
     /* 160440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160444 */     // MIs[0] Rn
     /* 160444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160448 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160456 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_acq_rel>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160463 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160465 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160469 */     GIR_RootConstrainSelectedInstOperands,
     /* 160470 */     // GIR_Coverage, 7467,
     /* 160470 */     GIR_EraseRootFromParent_Done,
     /* 160471 */   // Label 2923: @160471
     /* 160471 */   GIM_Try, /*On fail goto*//*Label 2924*/ GIMT_Encode4(160513), // Rule ID 7468 //
     /* 160476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLSFE),
     /* 160479 */     GIM_CheckAtomicOrdering, /*MI*/0, /*Order*/(uint8_t)AtomicOrdering::SequentiallyConsistent,
     /* 160482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160486 */     // MIs[0] Rn
     /* 160486 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 160490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 160498 */     // (atomic_load_fminimum:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[f64] }:$Rm)<<P:Predicate_atomic_load_fminimum_f64>><<P:Predicate_atomic_load_fminimum_f64_seq_cst>>  =>  (LDFMINALD:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[i64] }:$Rn)
     /* 160498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDFMINALD),
     /* 160501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 160503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 160505 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 160507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160511 */     GIR_RootConstrainSelectedInstOperands,
     /* 160512 */     // GIR_Coverage, 7468,
     /* 160512 */     GIR_EraseRootFromParent_Done,
     /* 160513 */   // Label 2924: @160513
     /* 160513 */   GIM_Reject,
     /* 160514 */ // Label 2919: @160514
     /* 160514 */ GIM_Reject,
     /* 160515 */ // Label 2906: @160515
     /* 160515 */ GIM_Reject,
     /* 160516 */ // Label 36: @160516
     /* 160516 */ GIM_Try, /*On fail goto*//*Label 2925*/ GIMT_Encode4(160543), // Rule ID 7054 //
     /* 160521 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160524 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/0, 4,
     /* 160528 */   // MIs[0] Operand 1
     /* 160528 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160531 */   // (atomic_fence 4:{ *:[i64] }, (timm:{ *:[i64] }))  =>  (DMB 9:{ *:[i32] })
     /* 160531 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160534 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 160537 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160541 */   GIR_RootConstrainSelectedInstOperands,
     /* 160542 */   // GIR_Coverage, 7054,
     /* 160542 */   GIR_EraseRootFromParent_Done,
     /* 160543 */ // Label 2925: @160543
     /* 160543 */ GIM_Try, /*On fail goto*//*Label 2926*/ GIMT_Encode4(160566), // Rule ID 7055 //
     /* 160548 */   // MIs[0] Operand 0
     /* 160548 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 160551 */   // MIs[0] Operand 1
     /* 160551 */   GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 160554 */   // (atomic_fence (timm:{ *:[iPTR] }), (timm:{ *:[iPTR] }))  =>  (DMB 11:{ *:[i32] })
     /* 160554 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 160557 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/11,
     /* 160560 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 160564 */   GIR_RootConstrainSelectedInstOperands,
     /* 160565 */   // GIR_Coverage, 7055,
     /* 160565 */   GIR_EraseRootFromParent_Done,
     /* 160566 */ // Label 2926: @160566
     /* 160566 */ GIM_Reject,
     /* 160567 */ // Label 37: @160567
     /* 160567 */ GIM_Try, /*On fail goto*//*Label 2927*/ GIMT_Encode4(173094),
     /* 160572 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 160575 */   GIM_Try, /*On fail goto*//*Label 2928*/ GIMT_Encode4(160666), // Rule ID 6533 //
     /* 160580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 160588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160606 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160609 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 160614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160618 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160622 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160627 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160634 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESMCrrTied:{ *:[v16i8] } (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160634 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160637 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 160641 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160646 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160650 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160654 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrrTied),
     /* 160659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160661 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160664 */     GIR_RootConstrainSelectedInstOperands,
     /* 160665 */     // GIR_Coverage, 6533,
     /* 160665 */     GIR_EraseRootFromParent_Done,
     /* 160666 */   // Label 2928: @160666
     /* 160666 */   GIM_Try, /*On fail goto*//*Label 2929*/ GIMT_Encode4(160757), // Rule ID 6534 //
     /* 160671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFuseAES),
     /* 160674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 160679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 160682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 160697 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 160700 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 160705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 160709 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 160713 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160718 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160725 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))  =>  (AESIMCrrTied:{ *:[v16i8] } (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$src1, V128:{ *:[v16i8] }:$src2))
     /* 160725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 160728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 160732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 160737 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // src1
     /* 160741 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/3, // src2
     /* 160745 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 160747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrrTied),
     /* 160750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160752 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 160755 */     GIR_RootConstrainSelectedInstOperands,
     /* 160756 */     // GIR_Coverage, 6534,
     /* 160756 */     GIR_EraseRootFromParent_Done,
     /* 160757 */   // Label 2929: @160757
     /* 160757 */   GIM_Try, /*On fail goto*//*Label 2930*/ GIMT_Encode4(160818), // Rule ID 4933 //
     /* 160762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 160767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 160770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 160773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 160781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 160785 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 160789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 160794 */     // MIs[1] Operand 2
     /* 160794 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 160805 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 160807 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8i16] }:$Rn)
     /* 160807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 160810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160812 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 160816 */     GIR_RootConstrainSelectedInstOperands,
     /* 160817 */     // GIR_Coverage, 4933,
     /* 160817 */     GIR_EraseRootFromParent_Done,
     /* 160818 */   // Label 2930: @160818
     /* 160818 */   GIM_Try, /*On fail goto*//*Label 2931*/ GIMT_Encode4(160858), // Rule ID 2647 //
     /* 160823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntb),
     /* 160831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160834 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160838 */     // MIs[0] pattern
     /* 160838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160846 */     // (intrinsic_wo_chain:{ *:[i64] } 1339:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTB_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTB_XPiI),
     /* 160849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160851 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160853 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160856 */     GIR_RootConstrainSelectedInstOperands,
     /* 160857 */     // GIR_Coverage, 2647,
     /* 160857 */     GIR_EraseRootFromParent_Done,
     /* 160858 */   // Label 2931: @160858
     /* 160858 */   GIM_Try, /*On fail goto*//*Label 2932*/ GIMT_Encode4(160898), // Rule ID 9975 //
     /* 160863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnth),
     /* 160871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160878 */     // MIs[0] pattern
     /* 160878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160886 */     // (intrinsic_wo_chain:{ *:[i64] } 1341:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTH_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTH_XPiI),
     /* 160889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160891 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160893 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160896 */     GIR_RootConstrainSelectedInstOperands,
     /* 160897 */     // GIR_Coverage, 9975,
     /* 160897 */     GIR_EraseRootFromParent_Done,
     /* 160898 */   // Label 2932: @160898
     /* 160898 */   GIM_Try, /*On fail goto*//*Label 2933*/ GIMT_Encode4(160938), // Rule ID 9978 //
     /* 160903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntw),
     /* 160911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160914 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160918 */     // MIs[0] pattern
     /* 160918 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160921 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160926 */     // (intrinsic_wo_chain:{ *:[i64] } 1347:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTW_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTW_XPiI),
     /* 160929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160931 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160933 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160936 */     GIR_RootConstrainSelectedInstOperands,
     /* 160937 */     // GIR_Coverage, 9978,
     /* 160937 */     GIR_EraseRootFromParent_Done,
     /* 160938 */   // Label 2933: @160938
     /* 160938 */   GIM_Try, /*On fail goto*//*Label 2934*/ GIMT_Encode4(160978), // Rule ID 9981 //
     /* 160943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 160946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntd),
     /* 160951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 160954 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 160958 */     // MIs[0] pattern
     /* 160958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 160961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 160966 */     // (intrinsic_wo_chain:{ *:[i64] } 1340:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern)  =>  (CNTD_XPiI:{ *:[i64] } (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, 1:{ *:[i32] })
     /* 160966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTD_XPiI),
     /* 160969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 160971 */     GIR_RootToRootCopy, /*OpIdx*/2, // pattern
     /* 160973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 160976 */     GIR_RootConstrainSelectedInstOperands,
     /* 160977 */     // GIR_Coverage, 9981,
     /* 160977 */     GIR_EraseRootFromParent_Done,
     /* 160978 */   // Label 2934: @160978
     /* 160978 */   GIM_Try, /*On fail goto*//*Label 2935*/ GIMT_Encode4(161017), // Rule ID 66 //
     /* 160983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8_HasJS),
     /* 160986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_fjcvtzs),
     /* 160991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 160994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 160997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161005 */     // (intrinsic_wo_chain:{ *:[i32] } 553:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FJCVTZS:{ *:[i32] }:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FJCVTZS),
     /* 161008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161012 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 161015 */     GIR_RootConstrainSelectedInstOperands,
     /* 161016 */     // GIR_Coverage, 66,
     /* 161016 */     GIR_EraseRootFromParent_Done,
     /* 161017 */   // Label 2935: @161017
     /* 161017 */   GIM_Try, /*On fail goto*//*Label 2936*/ GIMT_Encode4(161053), // Rule ID 346 //
     /* 161022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161025 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161030 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161033 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161044 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 161047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161051 */     GIR_RootConstrainSelectedInstOperands,
     /* 161052 */     // GIR_Coverage, 346,
     /* 161052 */     GIR_EraseRootFromParent_Done,
     /* 161053 */   // Label 2936: @161053
     /* 161053 */   GIM_Try, /*On fail goto*//*Label 2937*/ GIMT_Encode4(161089), // Rule ID 347 //
     /* 161058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161072 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161076 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161080 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161080 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 161083 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161085 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161087 */     GIR_RootConstrainSelectedInstOperands,
     /* 161088 */     // GIR_Coverage, 347,
     /* 161088 */     GIR_EraseRootFromParent_Done,
     /* 161089 */   // Label 2937: @161089
     /* 161089 */   GIM_Try, /*On fail goto*//*Label 2938*/ GIMT_Encode4(161125), // Rule ID 348 //
     /* 161094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161116 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161116 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 161119 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161121 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161123 */     GIR_RootConstrainSelectedInstOperands,
     /* 161124 */     // GIR_Coverage, 348,
     /* 161124 */     GIR_EraseRootFromParent_Done,
     /* 161125 */   // Label 2938: @161125
     /* 161125 */   GIM_Try, /*On fail goto*//*Label 2939*/ GIMT_Encode4(161161), // Rule ID 349 //
     /* 161130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161152 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 161155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161159 */     GIR_RootConstrainSelectedInstOperands,
     /* 161160 */     // GIR_Coverage, 349,
     /* 161160 */     GIR_EraseRootFromParent_Done,
     /* 161161 */   // Label 2939: @161161
     /* 161161 */   GIM_Try, /*On fail goto*//*Label 2940*/ GIMT_Encode4(161197), // Rule ID 350 //
     /* 161166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161169 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161174 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161188 */     // (intrinsic_wo_chain:{ *:[i32] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 161191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161193 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161195 */     GIR_RootConstrainSelectedInstOperands,
     /* 161196 */     // GIR_Coverage, 350,
     /* 161196 */     GIR_EraseRootFromParent_Done,
     /* 161197 */   // Label 2940: @161197
     /* 161197 */   GIM_Try, /*On fail goto*//*Label 2941*/ GIMT_Encode4(161233), // Rule ID 351 //
     /* 161202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 161210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161224 */     // (intrinsic_wo_chain:{ *:[i64] } 590:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 161227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161231 */     GIR_RootConstrainSelectedInstOperands,
     /* 161232 */     // GIR_Coverage, 351,
     /* 161232 */     GIR_EraseRootFromParent_Done,
     /* 161233 */   // Label 2941: @161233
     /* 161233 */   GIM_Try, /*On fail goto*//*Label 2942*/ GIMT_Encode4(161269), // Rule ID 352 //
     /* 161238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161256 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161260 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWHr),
     /* 161263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161265 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161267 */     GIR_RootConstrainSelectedInstOperands,
     /* 161268 */     // GIR_Coverage, 352,
     /* 161268 */     GIR_EraseRootFromParent_Done,
     /* 161269 */   // Label 2942: @161269
     /* 161269 */   GIM_Try, /*On fail goto*//*Label 2943*/ GIMT_Encode4(161305), // Rule ID 353 //
     /* 161274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161296 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTAUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXHr),
     /* 161299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161303 */     GIR_RootConstrainSelectedInstOperands,
     /* 161304 */     // GIR_Coverage, 353,
     /* 161304 */     GIR_EraseRootFromParent_Done,
     /* 161305 */   // Label 2943: @161305
     /* 161305 */   GIM_Try, /*On fail goto*//*Label 2944*/ GIMT_Encode4(161341), // Rule ID 354 //
     /* 161310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161332 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 161335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161339 */     GIR_RootConstrainSelectedInstOperands,
     /* 161340 */     // GIR_Coverage, 354,
     /* 161340 */     GIR_EraseRootFromParent_Done,
     /* 161341 */   // Label 2944: @161341
     /* 161341 */   GIM_Try, /*On fail goto*//*Label 2945*/ GIMT_Encode4(161377), // Rule ID 355 //
     /* 161346 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161349 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161354 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161357 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161368 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTAUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 161371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161373 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161375 */     GIR_RootConstrainSelectedInstOperands,
     /* 161376 */     // GIR_Coverage, 355,
     /* 161376 */     GIR_EraseRootFromParent_Done,
     /* 161377 */   // Label 2945: @161377
     /* 161377 */   GIM_Try, /*On fail goto*//*Label 2946*/ GIMT_Encode4(161413), // Rule ID 356 //
     /* 161382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161404 */     // (intrinsic_wo_chain:{ *:[i32] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 161407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161411 */     GIR_RootConstrainSelectedInstOperands,
     /* 161412 */     // GIR_Coverage, 356,
     /* 161412 */     GIR_EraseRootFromParent_Done,
     /* 161413 */   // Label 2946: @161413
     /* 161413 */   GIM_Try, /*On fail goto*//*Label 2947*/ GIMT_Encode4(161449), // Rule ID 357 //
     /* 161418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 161426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161440 */     // (intrinsic_wo_chain:{ *:[i64] } 591:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTAUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 161443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161447 */     GIR_RootConstrainSelectedInstOperands,
     /* 161448 */     // GIR_Coverage, 357,
     /* 161448 */     GIR_EraseRootFromParent_Done,
     /* 161449 */   // Label 2947: @161449
     /* 161449 */   GIM_Try, /*On fail goto*//*Label 2948*/ GIMT_Encode4(161485), // Rule ID 358 //
     /* 161454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161457 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161462 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161465 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161476 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWHr),
     /* 161479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161483 */     GIR_RootConstrainSelectedInstOperands,
     /* 161484 */     // GIR_Coverage, 358,
     /* 161484 */     GIR_EraseRootFromParent_Done,
     /* 161485 */   // Label 2948: @161485
     /* 161485 */   GIM_Try, /*On fail goto*//*Label 2949*/ GIMT_Encode4(161521), // Rule ID 359 //
     /* 161490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161508 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161512 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXHr),
     /* 161515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161519 */     GIR_RootConstrainSelectedInstOperands,
     /* 161520 */     // GIR_Coverage, 359,
     /* 161520 */     GIR_EraseRootFromParent_Done,
     /* 161521 */   // Label 2949: @161521
     /* 161521 */   GIM_Try, /*On fail goto*//*Label 2950*/ GIMT_Encode4(161557), // Rule ID 360 //
     /* 161526 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161529 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161534 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161537 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161548 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 161551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161555 */     GIR_RootConstrainSelectedInstOperands,
     /* 161556 */     // GIR_Coverage, 360,
     /* 161556 */     GIR_EraseRootFromParent_Done,
     /* 161557 */   // Label 2950: @161557
     /* 161557 */   GIM_Try, /*On fail goto*//*Label 2951*/ GIMT_Encode4(161593), // Rule ID 361 //
     /* 161562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161584 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 161587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161591 */     GIR_RootConstrainSelectedInstOperands,
     /* 161592 */     // GIR_Coverage, 361,
     /* 161592 */     GIR_EraseRootFromParent_Done,
     /* 161593 */   // Label 2951: @161593
     /* 161593 */   GIM_Try, /*On fail goto*//*Label 2952*/ GIMT_Encode4(161629), // Rule ID 362 //
     /* 161598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161616 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161620 */     // (intrinsic_wo_chain:{ *:[i32] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 161623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161627 */     GIR_RootConstrainSelectedInstOperands,
     /* 161628 */     // GIR_Coverage, 362,
     /* 161628 */     GIR_EraseRootFromParent_Done,
     /* 161629 */   // Label 2952: @161629
     /* 161629 */   GIM_Try, /*On fail goto*//*Label 2953*/ GIMT_Encode4(161665), // Rule ID 363 //
     /* 161634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161637 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 161642 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161645 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161656 */     // (intrinsic_wo_chain:{ *:[i64] } 592:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161656 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 161659 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161663 */     GIR_RootConstrainSelectedInstOperands,
     /* 161664 */     // GIR_Coverage, 363,
     /* 161664 */     GIR_EraseRootFromParent_Done,
     /* 161665 */   // Label 2953: @161665
     /* 161665 */   GIM_Try, /*On fail goto*//*Label 2954*/ GIMT_Encode4(161701), // Rule ID 364 //
     /* 161670 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161692 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWHr),
     /* 161695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161699 */     GIR_RootConstrainSelectedInstOperands,
     /* 161700 */     // GIR_Coverage, 364,
     /* 161700 */     GIR_EraseRootFromParent_Done,
     /* 161701 */   // Label 2954: @161701
     /* 161701 */   GIM_Try, /*On fail goto*//*Label 2955*/ GIMT_Encode4(161737), // Rule ID 365 //
     /* 161706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161728 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTMUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXHr),
     /* 161731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161735 */     GIR_RootConstrainSelectedInstOperands,
     /* 161736 */     // GIR_Coverage, 365,
     /* 161736 */     GIR_EraseRootFromParent_Done,
     /* 161737 */   // Label 2955: @161737
     /* 161737 */   GIM_Try, /*On fail goto*//*Label 2956*/ GIMT_Encode4(161773), // Rule ID 366 //
     /* 161742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161764 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 161767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161771 */     GIR_RootConstrainSelectedInstOperands,
     /* 161772 */     // GIR_Coverage, 366,
     /* 161772 */     GIR_EraseRootFromParent_Done,
     /* 161773 */   // Label 2956: @161773
     /* 161773 */   GIM_Try, /*On fail goto*//*Label 2957*/ GIMT_Encode4(161809), // Rule ID 367 //
     /* 161778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161800 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTMUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 161800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 161803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161807 */     GIR_RootConstrainSelectedInstOperands,
     /* 161808 */     // GIR_Coverage, 367,
     /* 161808 */     GIR_EraseRootFromParent_Done,
     /* 161809 */   // Label 2957: @161809
     /* 161809 */   GIM_Try, /*On fail goto*//*Label 2958*/ GIMT_Encode4(161845), // Rule ID 368 //
     /* 161814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161836 */     // (intrinsic_wo_chain:{ *:[i32] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 161836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 161839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161843 */     GIR_RootConstrainSelectedInstOperands,
     /* 161844 */     // GIR_Coverage, 368,
     /* 161844 */     GIR_EraseRootFromParent_Done,
     /* 161845 */   // Label 2958: @161845
     /* 161845 */   GIM_Try, /*On fail goto*//*Label 2959*/ GIMT_Encode4(161881), // Rule ID 369 //
     /* 161850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 161858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 161864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 161872 */     // (intrinsic_wo_chain:{ *:[i64] } 593:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTMUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 161872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 161875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161879 */     GIR_RootConstrainSelectedInstOperands,
     /* 161880 */     // GIR_Coverage, 369,
     /* 161880 */     GIR_EraseRootFromParent_Done,
     /* 161881 */   // Label 2959: @161881
     /* 161881 */   GIM_Try, /*On fail goto*//*Label 2960*/ GIMT_Encode4(161917), // Rule ID 370 //
     /* 161886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161908 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 161908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWHr),
     /* 161911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161915 */     GIR_RootConstrainSelectedInstOperands,
     /* 161916 */     // GIR_Coverage, 370,
     /* 161916 */     GIR_EraseRootFromParent_Done,
     /* 161917 */   // Label 2960: @161917
     /* 161917 */   GIM_Try, /*On fail goto*//*Label 2961*/ GIMT_Encode4(161953), // Rule ID 371 //
     /* 161922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 161925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 161933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 161936 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 161940 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 161944 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 161944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXHr),
     /* 161947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161951 */     GIR_RootConstrainSelectedInstOperands,
     /* 161952 */     // GIR_Coverage, 371,
     /* 161952 */     GIR_EraseRootFromParent_Done,
     /* 161953 */   // Label 2961: @161953
     /* 161953 */   GIM_Try, /*On fail goto*//*Label 2962*/ GIMT_Encode4(161989), // Rule ID 372 //
     /* 161958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 161966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 161969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 161972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 161976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 161980 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 161980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWSr),
     /* 161983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 161985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 161987 */     GIR_RootConstrainSelectedInstOperands,
     /* 161988 */     // GIR_Coverage, 372,
     /* 161988 */     GIR_EraseRootFromParent_Done,
     /* 161989 */   // Label 2962: @161989
     /* 161989 */   GIM_Try, /*On fail goto*//*Label 2963*/ GIMT_Encode4(162025), // Rule ID 373 //
     /* 161994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 161997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162016 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXSr),
     /* 162019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162023 */     GIR_RootConstrainSelectedInstOperands,
     /* 162024 */     // GIR_Coverage, 373,
     /* 162024 */     GIR_EraseRootFromParent_Done,
     /* 162025 */   // Label 2963: @162025
     /* 162025 */   GIM_Try, /*On fail goto*//*Label 2964*/ GIMT_Encode4(162061), // Rule ID 374 //
     /* 162030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162033 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162038 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162041 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162052 */     // (intrinsic_wo_chain:{ *:[i32] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUWDr),
     /* 162055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162059 */     GIR_RootConstrainSelectedInstOperands,
     /* 162060 */     // GIR_Coverage, 374,
     /* 162060 */     GIR_EraseRootFromParent_Done,
     /* 162061 */   // Label 2964: @162061
     /* 162061 */   GIM_Try, /*On fail goto*//*Label 2965*/ GIMT_Encode4(162097), // Rule ID 375 //
     /* 162066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 162074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162088 */     // (intrinsic_wo_chain:{ *:[i64] } 594:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSUXDr),
     /* 162091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162095 */     GIR_RootConstrainSelectedInstOperands,
     /* 162096 */     // GIR_Coverage, 375,
     /* 162096 */     GIR_EraseRootFromParent_Done,
     /* 162097 */   // Label 2965: @162097
     /* 162097 */   GIM_Try, /*On fail goto*//*Label 2966*/ GIMT_Encode4(162133), // Rule ID 376 //
     /* 162102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162120 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162124 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWHr),
     /* 162127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162131 */     GIR_RootConstrainSelectedInstOperands,
     /* 162132 */     // GIR_Coverage, 376,
     /* 162132 */     GIR_EraseRootFromParent_Done,
     /* 162133 */   // Label 2966: @162133
     /* 162133 */   GIM_Try, /*On fail goto*//*Label 2967*/ GIMT_Encode4(162169), // Rule ID 377 //
     /* 162138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162156 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162160 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTNUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXHr),
     /* 162163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162167 */     GIR_RootConstrainSelectedInstOperands,
     /* 162168 */     // GIR_Coverage, 377,
     /* 162168 */     GIR_EraseRootFromParent_Done,
     /* 162169 */   // Label 2967: @162169
     /* 162169 */   GIM_Try, /*On fail goto*//*Label 2968*/ GIMT_Encode4(162205), // Rule ID 378 //
     /* 162174 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162192 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162196 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162196 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWSr),
     /* 162199 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162201 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162203 */     GIR_RootConstrainSelectedInstOperands,
     /* 162204 */     // GIR_Coverage, 378,
     /* 162204 */     GIR_EraseRootFromParent_Done,
     /* 162205 */   // Label 2968: @162205
     /* 162205 */   GIM_Try, /*On fail goto*//*Label 2969*/ GIMT_Encode4(162241), // Rule ID 379 //
     /* 162210 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162213 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162218 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162221 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162232 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTNUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXSr),
     /* 162235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162239 */     GIR_RootConstrainSelectedInstOperands,
     /* 162240 */     // GIR_Coverage, 379,
     /* 162240 */     GIR_EraseRootFromParent_Done,
     /* 162241 */   // Label 2969: @162241
     /* 162241 */   GIM_Try, /*On fail goto*//*Label 2970*/ GIMT_Encode4(162277), // Rule ID 380 //
     /* 162246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162268 */     // (intrinsic_wo_chain:{ *:[i32] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUWDr),
     /* 162271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162273 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162275 */     GIR_RootConstrainSelectedInstOperands,
     /* 162276 */     // GIR_Coverage, 380,
     /* 162276 */     GIR_EraseRootFromParent_Done,
     /* 162277 */   // Label 2970: @162277
     /* 162277 */   GIM_Try, /*On fail goto*//*Label 2971*/ GIMT_Encode4(162313), // Rule ID 381 //
     /* 162282 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162285 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 162290 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162293 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162300 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162304 */     // (intrinsic_wo_chain:{ *:[i64] } 595:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTNUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUUXDr),
     /* 162307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162311 */     GIR_RootConstrainSelectedInstOperands,
     /* 162312 */     // GIR_Coverage, 381,
     /* 162312 */     GIR_EraseRootFromParent_Done,
     /* 162313 */   // Label 2971: @162313
     /* 162313 */   GIM_Try, /*On fail goto*//*Label 2972*/ GIMT_Encode4(162349), // Rule ID 382 //
     /* 162318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162340 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWHr),
     /* 162343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162345 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162347 */     GIR_RootConstrainSelectedInstOperands,
     /* 162348 */     // GIR_Coverage, 382,
     /* 162348 */     GIR_EraseRootFromParent_Done,
     /* 162349 */   // Label 2972: @162349
     /* 162349 */   GIM_Try, /*On fail goto*//*Label 2973*/ GIMT_Encode4(162385), // Rule ID 383 //
     /* 162354 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162357 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162362 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162365 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162368 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162376 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXHr),
     /* 162379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162383 */     GIR_RootConstrainSelectedInstOperands,
     /* 162384 */     // GIR_Coverage, 383,
     /* 162384 */     GIR_EraseRootFromParent_Done,
     /* 162385 */   // Label 2973: @162385
     /* 162385 */   GIM_Try, /*On fail goto*//*Label 2974*/ GIMT_Encode4(162421), // Rule ID 384 //
     /* 162390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162412 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 162415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162419 */     GIR_RootConstrainSelectedInstOperands,
     /* 162420 */     // GIR_Coverage, 384,
     /* 162420 */     GIR_EraseRootFromParent_Done,
     /* 162421 */   // Label 2974: @162421
     /* 162421 */   GIM_Try, /*On fail goto*//*Label 2975*/ GIMT_Encode4(162457), // Rule ID 385 //
     /* 162426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162448 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 162451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162455 */     GIR_RootConstrainSelectedInstOperands,
     /* 162456 */     // GIR_Coverage, 385,
     /* 162456 */     GIR_EraseRootFromParent_Done,
     /* 162457 */   // Label 2975: @162457
     /* 162457 */   GIM_Try, /*On fail goto*//*Label 2976*/ GIMT_Encode4(162493), // Rule ID 386 //
     /* 162462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162480 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162484 */     // (intrinsic_wo_chain:{ *:[i32] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 162487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162491 */     GIR_RootConstrainSelectedInstOperands,
     /* 162492 */     // GIR_Coverage, 386,
     /* 162492 */     GIR_EraseRootFromParent_Done,
     /* 162493 */   // Label 2976: @162493
     /* 162493 */   GIM_Try, /*On fail goto*//*Label 2977*/ GIMT_Encode4(162529), // Rule ID 387 //
     /* 162498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 162506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162512 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162520 */     // (intrinsic_wo_chain:{ *:[i64] } 596:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 162523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162527 */     GIR_RootConstrainSelectedInstOperands,
     /* 162528 */     // GIR_Coverage, 387,
     /* 162528 */     GIR_EraseRootFromParent_Done,
     /* 162529 */   // Label 2977: @162529
     /* 162529 */   GIM_Try, /*On fail goto*//*Label 2978*/ GIMT_Encode4(162565), // Rule ID 388 //
     /* 162534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162548 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162556 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 162556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWHr),
     /* 162559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162563 */     GIR_RootConstrainSelectedInstOperands,
     /* 162564 */     // GIR_Coverage, 388,
     /* 162564 */     GIR_EraseRootFromParent_Done,
     /* 162565 */   // Label 2978: @162565
     /* 162565 */   GIM_Try, /*On fail goto*//*Label 2979*/ GIMT_Encode4(162601), // Rule ID 389 //
     /* 162570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 162573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 162584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162588 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 162592 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FCVTPUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 162592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXHr),
     /* 162595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162599 */     GIR_RootConstrainSelectedInstOperands,
     /* 162600 */     // GIR_Coverage, 389,
     /* 162600 */     GIR_EraseRootFromParent_Done,
     /* 162601 */   // Label 2979: @162601
     /* 162601 */   GIM_Try, /*On fail goto*//*Label 2980*/ GIMT_Encode4(162637), // Rule ID 390 //
     /* 162606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162609 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162614 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162617 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162628 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 162628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 162631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162635 */     GIR_RootConstrainSelectedInstOperands,
     /* 162636 */     // GIR_Coverage, 390,
     /* 162636 */     GIR_EraseRootFromParent_Done,
     /* 162637 */   // Label 2980: @162637
     /* 162637 */   GIM_Try, /*On fail goto*//*Label 2981*/ GIMT_Encode4(162673), // Rule ID 391 //
     /* 162642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162645 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162650 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162653 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162664 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FCVTPUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 162664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 162667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162671 */     GIR_RootConstrainSelectedInstOperands,
     /* 162672 */     // GIR_Coverage, 391,
     /* 162672 */     GIR_EraseRootFromParent_Done,
     /* 162673 */   // Label 2981: @162673
     /* 162673 */   GIM_Try, /*On fail goto*//*Label 2982*/ GIMT_Encode4(162709), // Rule ID 392 //
     /* 162678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 162696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162700 */     // (intrinsic_wo_chain:{ *:[i32] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 162700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 162703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162707 */     GIR_RootConstrainSelectedInstOperands,
     /* 162708 */     // GIR_Coverage, 392,
     /* 162708 */     GIR_EraseRootFromParent_Done,
     /* 162709 */   // Label 2982: @162709
     /* 162709 */   GIM_Try, /*On fail goto*//*Label 2983*/ GIMT_Encode4(162745), // Rule ID 393 //
     /* 162714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 162717 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 162722 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162725 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 162732 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162736 */     // (intrinsic_wo_chain:{ *:[i64] } 597:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTPUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 162736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 162739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162743 */     GIR_RootConstrainSelectedInstOperands,
     /* 162744 */     // GIR_Coverage, 393,
     /* 162744 */     GIR_EraseRootFromParent_Done,
     /* 162745 */   // Label 2983: @162745
     /* 162745 */   GIM_Try, /*On fail goto*//*Label 2984*/ GIMT_Encode4(162781), // Rule ID 575 //
     /* 162750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162753 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162758 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162761 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162768 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162772 */     // (intrinsic_wo_chain:{ *:[f32] } 555:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZSr),
     /* 162775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162779 */     GIR_RootConstrainSelectedInstOperands,
     /* 162780 */     // GIR_Coverage, 575,
     /* 162780 */     GIR_EraseRootFromParent_Done,
     /* 162781 */   // Label 2984: @162781
     /* 162781 */   GIM_Try, /*On fail goto*//*Label 2985*/ GIMT_Encode4(162817), // Rule ID 576 //
     /* 162786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32z),
     /* 162794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162808 */     // (intrinsic_wo_chain:{ *:[f64] } 555:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 162811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162815 */     GIR_RootConstrainSelectedInstOperands,
     /* 162816 */     // GIR_Coverage, 576,
     /* 162816 */     GIR_EraseRootFromParent_Done,
     /* 162817 */   // Label 2985: @162817
     /* 162817 */   GIM_Try, /*On fail goto*//*Label 2986*/ GIMT_Encode4(162853), // Rule ID 577 //
     /* 162822 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162825 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162830 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162833 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162844 */     // (intrinsic_wo_chain:{ *:[f32] } 557:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64ZSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZSr),
     /* 162847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162851 */     GIR_RootConstrainSelectedInstOperands,
     /* 162852 */     // GIR_Coverage, 577,
     /* 162852 */     GIR_EraseRootFromParent_Done,
     /* 162853 */   // Label 2986: @162853
     /* 162853 */   GIM_Try, /*On fail goto*//*Label 2987*/ GIMT_Encode4(162889), // Rule ID 578 //
     /* 162858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64z),
     /* 162866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162880 */     // (intrinsic_wo_chain:{ *:[f64] } 557:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 162883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162887 */     GIR_RootConstrainSelectedInstOperands,
     /* 162888 */     // GIR_Coverage, 578,
     /* 162888 */     GIR_EraseRootFromParent_Done,
     /* 162889 */   // Label 2987: @162889
     /* 162889 */   GIM_Try, /*On fail goto*//*Label 2988*/ GIMT_Encode4(162925), // Rule ID 579 //
     /* 162894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162916 */     // (intrinsic_wo_chain:{ *:[f32] } 554:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT32XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XSr),
     /* 162919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162923 */     GIR_RootConstrainSelectedInstOperands,
     /* 162924 */     // GIR_Coverage, 579,
     /* 162924 */     GIR_EraseRootFromParent_Done,
     /* 162925 */   // Label 2988: @162925
     /* 162925 */   GIM_Try, /*On fail goto*//*Label 2989*/ GIMT_Encode4(162961), // Rule ID 580 //
     /* 162930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint32x),
     /* 162938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 162941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 162944 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 162952 */     // (intrinsic_wo_chain:{ *:[f64] } 554:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT32XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 162952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 162955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162959 */     GIR_RootConstrainSelectedInstOperands,
     /* 162960 */     // GIR_Coverage, 580,
     /* 162960 */     GIR_EraseRootFromParent_Done,
     /* 162961 */   // Label 2989: @162961
     /* 162961 */   GIM_Try, /*On fail goto*//*Label 2990*/ GIMT_Encode4(162997), // Rule ID 581 //
     /* 162966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 162969 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 162974 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 162977 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 162980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 162988 */     // (intrinsic_wo_chain:{ *:[f32] } 556:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRINT64XSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 162988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XSr),
     /* 162991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 162993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 162995 */     GIR_RootConstrainSelectedInstOperands,
     /* 162996 */     // GIR_Coverage, 581,
     /* 162996 */     GIR_EraseRootFromParent_Done,
     /* 162997 */   // Label 2990: @162997
     /* 162997 */   GIM_Try, /*On fail goto*//*Label 2991*/ GIMT_Encode4(163033), // Rule ID 582 //
     /* 163002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 163005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_frint64x),
     /* 163010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 163013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 163016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163020 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163024 */     // (intrinsic_wo_chain:{ *:[f64] } 556:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRINT64XDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 163024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 163027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163031 */     GIR_RootConstrainSelectedInstOperands,
     /* 163032 */     // GIR_Coverage, 582,
     /* 163032 */     GIR_EraseRootFromParent_Done,
     /* 163033 */   // Label 2991: @163033
     /* 163033 */   GIM_Try, /*On fail goto*//*Label 2992*/ GIMT_Encode4(163069), // Rule ID 710 //
     /* 163038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 163049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 163052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163060 */     // (intrinsic_wo_chain:{ *:[v8i8] } 582:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (CLSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 163060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i8),
     /* 163063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163065 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163067 */     GIR_RootConstrainSelectedInstOperands,
     /* 163068 */     // GIR_Coverage, 710,
     /* 163068 */     GIR_EraseRootFromParent_Done,
     /* 163069 */   // Label 2992: @163069
     /* 163069 */   GIM_Try, /*On fail goto*//*Label 2993*/ GIMT_Encode4(163105), // Rule ID 711 //
     /* 163074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 163085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 163088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163096 */     // (intrinsic_wo_chain:{ *:[v16i8] } 582:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (CLSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 163096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv16i8),
     /* 163099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163103 */     GIR_RootConstrainSelectedInstOperands,
     /* 163104 */     // GIR_Coverage, 711,
     /* 163104 */     GIR_EraseRootFromParent_Done,
     /* 163105 */   // Label 2993: @163105
     /* 163105 */   GIM_Try, /*On fail goto*//*Label 2994*/ GIMT_Encode4(163141), // Rule ID 712 //
     /* 163110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163132 */     // (intrinsic_wo_chain:{ *:[v4i16] } 582:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (CLSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 163132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i16),
     /* 163135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163139 */     GIR_RootConstrainSelectedInstOperands,
     /* 163140 */     // GIR_Coverage, 712,
     /* 163140 */     GIR_EraseRootFromParent_Done,
     /* 163141 */   // Label 2994: @163141
     /* 163141 */   GIM_Try, /*On fail goto*//*Label 2995*/ GIMT_Encode4(163177), // Rule ID 713 //
     /* 163146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163168 */     // (intrinsic_wo_chain:{ *:[v8i16] } 582:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (CLSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 163168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv8i16),
     /* 163171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163175 */     GIR_RootConstrainSelectedInstOperands,
     /* 163176 */     // GIR_Coverage, 713,
     /* 163176 */     GIR_EraseRootFromParent_Done,
     /* 163177 */   // Label 2995: @163177
     /* 163177 */   GIM_Try, /*On fail goto*//*Label 2996*/ GIMT_Encode4(163213), // Rule ID 714 //
     /* 163182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163196 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163204 */     // (intrinsic_wo_chain:{ *:[v2i32] } 582:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (CLSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 163204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv2i32),
     /* 163207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163211 */     GIR_RootConstrainSelectedInstOperands,
     /* 163212 */     // GIR_Coverage, 714,
     /* 163212 */     GIR_EraseRootFromParent_Done,
     /* 163213 */   // Label 2996: @163213
     /* 163213 */   GIM_Try, /*On fail goto*//*Label 2997*/ GIMT_Encode4(163249), // Rule ID 715 //
     /* 163218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_cls),
     /* 163226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163240 */     // (intrinsic_wo_chain:{ *:[v4i32] } 582:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (CLSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 163240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSv4i32),
     /* 163243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163247 */     GIR_RootConstrainSelectedInstOperands,
     /* 163248 */     // GIR_Coverage, 715,
     /* 163248 */     GIR_EraseRootFromParent_Done,
     /* 163249 */   // Label 2997: @163249
     /* 163249 */   GIM_Try, /*On fail goto*//*Label 2998*/ GIMT_Encode4(163285), // Rule ID 796 //
     /* 163254 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163257 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163262 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163265 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163272 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163276 */     // (intrinsic_wo_chain:{ *:[v4i16] } 590:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTASv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f16),
     /* 163279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163283 */     GIR_RootConstrainSelectedInstOperands,
     /* 163284 */     // GIR_Coverage, 796,
     /* 163284 */     GIR_EraseRootFromParent_Done,
     /* 163285 */   // Label 2998: @163285
     /* 163285 */   GIM_Try, /*On fail goto*//*Label 2999*/ GIMT_Encode4(163321), // Rule ID 797 //
     /* 163290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163293 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163298 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163301 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163308 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163312 */     // (intrinsic_wo_chain:{ *:[v8i16] } 590:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTASv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv8f16),
     /* 163315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163319 */     GIR_RootConstrainSelectedInstOperands,
     /* 163320 */     // GIR_Coverage, 797,
     /* 163320 */     GIR_EraseRootFromParent_Done,
     /* 163321 */   // Label 2999: @163321
     /* 163321 */   GIM_Try, /*On fail goto*//*Label 3000*/ GIMT_Encode4(163357), // Rule ID 798 //
     /* 163326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163348 */     // (intrinsic_wo_chain:{ *:[v2i32] } 590:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTASv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f32),
     /* 163351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163355 */     GIR_RootConstrainSelectedInstOperands,
     /* 163356 */     // GIR_Coverage, 798,
     /* 163356 */     GIR_EraseRootFromParent_Done,
     /* 163357 */   // Label 3000: @163357
     /* 163357 */   GIM_Try, /*On fail goto*//*Label 3001*/ GIMT_Encode4(163393), // Rule ID 799 //
     /* 163362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163376 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163384 */     // (intrinsic_wo_chain:{ *:[v4i32] } 590:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTASv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv4f32),
     /* 163387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163391 */     GIR_RootConstrainSelectedInstOperands,
     /* 163392 */     // GIR_Coverage, 799,
     /* 163392 */     GIR_EraseRootFromParent_Done,
     /* 163393 */   // Label 3001: @163393
     /* 163393 */   GIM_Try, /*On fail goto*//*Label 3002*/ GIMT_Encode4(163429), // Rule ID 800 //
     /* 163398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 163406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163416 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163420 */     // (intrinsic_wo_chain:{ *:[v2i64] } 590:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTASv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv2f64),
     /* 163423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163427 */     GIR_RootConstrainSelectedInstOperands,
     /* 163428 */     // GIR_Coverage, 800,
     /* 163428 */     GIR_EraseRootFromParent_Done,
     /* 163429 */   // Label 3002: @163429
     /* 163429 */   GIM_Try, /*On fail goto*//*Label 3003*/ GIMT_Encode4(163465), // Rule ID 801 //
     /* 163434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163437 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163442 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163445 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163448 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163452 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163456 */     // (intrinsic_wo_chain:{ *:[v4i16] } 591:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTAUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f16),
     /* 163459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163463 */     GIR_RootConstrainSelectedInstOperands,
     /* 163464 */     // GIR_Coverage, 801,
     /* 163464 */     GIR_EraseRootFromParent_Done,
     /* 163465 */   // Label 3003: @163465
     /* 163465 */   GIM_Try, /*On fail goto*//*Label 3004*/ GIMT_Encode4(163501), // Rule ID 802 //
     /* 163470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163484 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163492 */     // (intrinsic_wo_chain:{ *:[v8i16] } 591:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTAUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv8f16),
     /* 163495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163499 */     GIR_RootConstrainSelectedInstOperands,
     /* 163500 */     // GIR_Coverage, 802,
     /* 163500 */     GIR_EraseRootFromParent_Done,
     /* 163501 */   // Label 3004: @163501
     /* 163501 */   GIM_Try, /*On fail goto*//*Label 3005*/ GIMT_Encode4(163537), // Rule ID 803 //
     /* 163506 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163509 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163514 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163528 */     // (intrinsic_wo_chain:{ *:[v2i32] } 591:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTAUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f32),
     /* 163531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163535 */     GIR_RootConstrainSelectedInstOperands,
     /* 163536 */     // GIR_Coverage, 803,
     /* 163536 */     GIR_EraseRootFromParent_Done,
     /* 163537 */   // Label 3005: @163537
     /* 163537 */   GIM_Try, /*On fail goto*//*Label 3006*/ GIMT_Encode4(163573), // Rule ID 804 //
     /* 163542 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163545 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163550 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163564 */     // (intrinsic_wo_chain:{ *:[v4i32] } 591:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTAUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv4f32),
     /* 163567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163569 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163571 */     GIR_RootConstrainSelectedInstOperands,
     /* 163572 */     // GIR_Coverage, 804,
     /* 163572 */     GIR_EraseRootFromParent_Done,
     /* 163573 */   // Label 3006: @163573
     /* 163573 */   GIM_Try, /*On fail goto*//*Label 3007*/ GIMT_Encode4(163609), // Rule ID 805 //
     /* 163578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 163586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163592 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163596 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163600 */     // (intrinsic_wo_chain:{ *:[v2i64] } 591:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTAUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv2f64),
     /* 163603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163607 */     GIR_RootConstrainSelectedInstOperands,
     /* 163608 */     // GIR_Coverage, 805,
     /* 163608 */     GIR_EraseRootFromParent_Done,
     /* 163609 */   // Label 3007: @163609
     /* 163609 */   GIM_Try, /*On fail goto*//*Label 3008*/ GIMT_Encode4(163645), // Rule ID 806 //
     /* 163614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163628 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 592:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f16),
     /* 163639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163643 */     GIR_RootConstrainSelectedInstOperands,
     /* 163644 */     // GIR_Coverage, 806,
     /* 163644 */     GIR_EraseRootFromParent_Done,
     /* 163645 */   // Label 3008: @163645
     /* 163645 */   GIM_Try, /*On fail goto*//*Label 3009*/ GIMT_Encode4(163681), // Rule ID 807 //
     /* 163650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163664 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163668 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 592:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv8f16),
     /* 163675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163679 */     GIR_RootConstrainSelectedInstOperands,
     /* 163680 */     // GIR_Coverage, 807,
     /* 163680 */     GIR_EraseRootFromParent_Done,
     /* 163681 */   // Label 3009: @163681
     /* 163681 */   GIM_Try, /*On fail goto*//*Label 3010*/ GIMT_Encode4(163717), // Rule ID 808 //
     /* 163686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163708 */     // (intrinsic_wo_chain:{ *:[v2i32] } 592:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f32),
     /* 163711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163715 */     GIR_RootConstrainSelectedInstOperands,
     /* 163716 */     // GIR_Coverage, 808,
     /* 163716 */     GIR_EraseRootFromParent_Done,
     /* 163717 */   // Label 3010: @163717
     /* 163717 */   GIM_Try, /*On fail goto*//*Label 3011*/ GIMT_Encode4(163753), // Rule ID 809 //
     /* 163722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163740 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163744 */     // (intrinsic_wo_chain:{ *:[v4i32] } 592:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv4f32),
     /* 163747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163751 */     GIR_RootConstrainSelectedInstOperands,
     /* 163752 */     // GIR_Coverage, 809,
     /* 163752 */     GIR_EraseRootFromParent_Done,
     /* 163753 */   // Label 3011: @163753
     /* 163753 */   GIM_Try, /*On fail goto*//*Label 3012*/ GIMT_Encode4(163789), // Rule ID 810 //
     /* 163758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 163766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163776 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163780 */     // (intrinsic_wo_chain:{ *:[v2i64] } 592:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv2f64),
     /* 163783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163787 */     GIR_RootConstrainSelectedInstOperands,
     /* 163788 */     // GIR_Coverage, 810,
     /* 163788 */     GIR_EraseRootFromParent_Done,
     /* 163789 */   // Label 3012: @163789
     /* 163789 */   GIM_Try, /*On fail goto*//*Label 3013*/ GIMT_Encode4(163825), // Rule ID 811 //
     /* 163794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163808 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163816 */     // (intrinsic_wo_chain:{ *:[v4i16] } 593:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTMUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f16),
     /* 163819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163823 */     GIR_RootConstrainSelectedInstOperands,
     /* 163824 */     // GIR_Coverage, 811,
     /* 163824 */     GIR_EraseRootFromParent_Done,
     /* 163825 */   // Label 3013: @163825
     /* 163825 */   GIM_Try, /*On fail goto*//*Label 3014*/ GIMT_Encode4(163861), // Rule ID 812 //
     /* 163830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 163841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 163844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163852 */     // (intrinsic_wo_chain:{ *:[v8i16] } 593:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTMUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 163852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv8f16),
     /* 163855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163859 */     GIR_RootConstrainSelectedInstOperands,
     /* 163860 */     // GIR_Coverage, 812,
     /* 163860 */     GIR_EraseRootFromParent_Done,
     /* 163861 */   // Label 3014: @163861
     /* 163861 */   GIM_Try, /*On fail goto*//*Label 3015*/ GIMT_Encode4(163897), // Rule ID 813 //
     /* 163866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 163877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 163880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163888 */     // (intrinsic_wo_chain:{ *:[v2i32] } 593:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTMUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 163888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f32),
     /* 163891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163895 */     GIR_RootConstrainSelectedInstOperands,
     /* 163896 */     // GIR_Coverage, 813,
     /* 163896 */     GIR_EraseRootFromParent_Done,
     /* 163897 */   // Label 3015: @163897
     /* 163897 */   GIM_Try, /*On fail goto*//*Label 3016*/ GIMT_Encode4(163933), // Rule ID 814 //
     /* 163902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 163913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 163916 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163924 */     // (intrinsic_wo_chain:{ *:[v4i32] } 593:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTMUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 163924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv4f32),
     /* 163927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163931 */     GIR_RootConstrainSelectedInstOperands,
     /* 163932 */     // GIR_Coverage, 814,
     /* 163932 */     GIR_EraseRootFromParent_Done,
     /* 163933 */   // Label 3016: @163933
     /* 163933 */   GIM_Try, /*On fail goto*//*Label 3017*/ GIMT_Encode4(163969), // Rule ID 815 //
     /* 163938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 163941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 163946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 163949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 163952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163956 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 163960 */     // (intrinsic_wo_chain:{ *:[v2i64] } 593:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTMUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 163960 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv2f64),
     /* 163963 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 163965 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 163967 */     GIR_RootConstrainSelectedInstOperands,
     /* 163968 */     // GIR_Coverage, 815,
     /* 163968 */     GIR_EraseRootFromParent_Done,
     /* 163969 */   // Label 3017: @163969
     /* 163969 */   GIM_Try, /*On fail goto*//*Label 3018*/ GIMT_Encode4(164005), // Rule ID 816 //
     /* 163974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 163977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 163982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 163985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 163988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 163996 */     // (intrinsic_wo_chain:{ *:[v4i16] } 594:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 163996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f16),
     /* 163999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164003 */     GIR_RootConstrainSelectedInstOperands,
     /* 164004 */     // GIR_Coverage, 816,
     /* 164004 */     GIR_EraseRootFromParent_Done,
     /* 164005 */   // Label 3018: @164005
     /* 164005 */   GIM_Try, /*On fail goto*//*Label 3019*/ GIMT_Encode4(164041), // Rule ID 817 //
     /* 164010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164032 */     // (intrinsic_wo_chain:{ *:[v8i16] } 594:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv8f16),
     /* 164035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164039 */     GIR_RootConstrainSelectedInstOperands,
     /* 164040 */     // GIR_Coverage, 817,
     /* 164040 */     GIR_EraseRootFromParent_Done,
     /* 164041 */   // Label 3019: @164041
     /* 164041 */   GIM_Try, /*On fail goto*//*Label 3020*/ GIMT_Encode4(164077), // Rule ID 818 //
     /* 164046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164049 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164054 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164057 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164068 */     // (intrinsic_wo_chain:{ *:[v2i32] } 594:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f32),
     /* 164071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164075 */     GIR_RootConstrainSelectedInstOperands,
     /* 164076 */     // GIR_Coverage, 818,
     /* 164076 */     GIR_EraseRootFromParent_Done,
     /* 164077 */   // Label 3020: @164077
     /* 164077 */   GIM_Try, /*On fail goto*//*Label 3021*/ GIMT_Encode4(164113), // Rule ID 819 //
     /* 164082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164104 */     // (intrinsic_wo_chain:{ *:[v4i32] } 594:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv4f32),
     /* 164107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164111 */     GIR_RootConstrainSelectedInstOperands,
     /* 164112 */     // GIR_Coverage, 819,
     /* 164112 */     GIR_EraseRootFromParent_Done,
     /* 164113 */   // Label 3021: @164113
     /* 164113 */   GIM_Try, /*On fail goto*//*Label 3022*/ GIMT_Encode4(164149), // Rule ID 820 //
     /* 164118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 164126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164140 */     // (intrinsic_wo_chain:{ *:[v2i64] } 594:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv2f64),
     /* 164143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164147 */     GIR_RootConstrainSelectedInstOperands,
     /* 164148 */     // GIR_Coverage, 820,
     /* 164148 */     GIR_EraseRootFromParent_Done,
     /* 164149 */   // Label 3022: @164149
     /* 164149 */   GIM_Try, /*On fail goto*//*Label 3023*/ GIMT_Encode4(164185), // Rule ID 821 //
     /* 164154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164176 */     // (intrinsic_wo_chain:{ *:[v4i16] } 595:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTNUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f16),
     /* 164179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164181 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164183 */     GIR_RootConstrainSelectedInstOperands,
     /* 164184 */     // GIR_Coverage, 821,
     /* 164184 */     GIR_EraseRootFromParent_Done,
     /* 164185 */   // Label 3023: @164185
     /* 164185 */   GIM_Try, /*On fail goto*//*Label 3024*/ GIMT_Encode4(164221), // Rule ID 822 //
     /* 164190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164204 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164208 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164212 */     // (intrinsic_wo_chain:{ *:[v8i16] } 595:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv8f16),
     /* 164215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164219 */     GIR_RootConstrainSelectedInstOperands,
     /* 164220 */     // GIR_Coverage, 822,
     /* 164220 */     GIR_EraseRootFromParent_Done,
     /* 164221 */   // Label 3024: @164221
     /* 164221 */   GIM_Try, /*On fail goto*//*Label 3025*/ GIMT_Encode4(164257), // Rule ID 823 //
     /* 164226 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164229 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164234 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164248 */     // (intrinsic_wo_chain:{ *:[v2i32] } 595:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTNUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f32),
     /* 164251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164255 */     GIR_RootConstrainSelectedInstOperands,
     /* 164256 */     // GIR_Coverage, 823,
     /* 164256 */     GIR_EraseRootFromParent_Done,
     /* 164257 */   // Label 3025: @164257
     /* 164257 */   GIM_Try, /*On fail goto*//*Label 3026*/ GIMT_Encode4(164293), // Rule ID 824 //
     /* 164262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 595:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv4f32),
     /* 164287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164291 */     GIR_RootConstrainSelectedInstOperands,
     /* 164292 */     // GIR_Coverage, 824,
     /* 164292 */     GIR_EraseRootFromParent_Done,
     /* 164293 */   // Label 3026: @164293
     /* 164293 */   GIM_Try, /*On fail goto*//*Label 3027*/ GIMT_Encode4(164329), // Rule ID 825 //
     /* 164298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 164306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164316 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164320 */     // (intrinsic_wo_chain:{ *:[v2i64] } 595:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv2f64),
     /* 164323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164325 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164327 */     GIR_RootConstrainSelectedInstOperands,
     /* 164328 */     // GIR_Coverage, 825,
     /* 164328 */     GIR_EraseRootFromParent_Done,
     /* 164329 */   // Label 3027: @164329
     /* 164329 */   GIM_Try, /*On fail goto*//*Label 3028*/ GIMT_Encode4(164365), // Rule ID 826 //
     /* 164334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164352 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164356 */     // (intrinsic_wo_chain:{ *:[v4i16] } 596:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f16),
     /* 164359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164363 */     GIR_RootConstrainSelectedInstOperands,
     /* 164364 */     // GIR_Coverage, 826,
     /* 164364 */     GIR_EraseRootFromParent_Done,
     /* 164365 */   // Label 3028: @164365
     /* 164365 */   GIM_Try, /*On fail goto*//*Label 3029*/ GIMT_Encode4(164401), // Rule ID 827 //
     /* 164370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164392 */     // (intrinsic_wo_chain:{ *:[v8i16] } 596:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv8f16),
     /* 164395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164399 */     GIR_RootConstrainSelectedInstOperands,
     /* 164400 */     // GIR_Coverage, 827,
     /* 164400 */     GIR_EraseRootFromParent_Done,
     /* 164401 */   // Label 3029: @164401
     /* 164401 */   GIM_Try, /*On fail goto*//*Label 3030*/ GIMT_Encode4(164437), // Rule ID 828 //
     /* 164406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164428 */     // (intrinsic_wo_chain:{ *:[v2i32] } 596:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f32),
     /* 164431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164435 */     GIR_RootConstrainSelectedInstOperands,
     /* 164436 */     // GIR_Coverage, 828,
     /* 164436 */     GIR_EraseRootFromParent_Done,
     /* 164437 */   // Label 3030: @164437
     /* 164437 */   GIM_Try, /*On fail goto*//*Label 3031*/ GIMT_Encode4(164473), // Rule ID 829 //
     /* 164442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164464 */     // (intrinsic_wo_chain:{ *:[v4i32] } 596:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv4f32),
     /* 164467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164471 */     GIR_RootConstrainSelectedInstOperands,
     /* 164472 */     // GIR_Coverage, 829,
     /* 164472 */     GIR_EraseRootFromParent_Done,
     /* 164473 */   // Label 3031: @164473
     /* 164473 */   GIM_Try, /*On fail goto*//*Label 3032*/ GIMT_Encode4(164509), // Rule ID 830 //
     /* 164478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 164486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164500 */     // (intrinsic_wo_chain:{ *:[v2i64] } 596:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv2f64),
     /* 164503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164507 */     GIR_RootConstrainSelectedInstOperands,
     /* 164508 */     // GIR_Coverage, 830,
     /* 164508 */     GIR_EraseRootFromParent_Done,
     /* 164509 */   // Label 3032: @164509
     /* 164509 */   GIM_Try, /*On fail goto*//*Label 3033*/ GIMT_Encode4(164545), // Rule ID 831 //
     /* 164514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164532 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164536 */     // (intrinsic_wo_chain:{ *:[v4i16] } 597:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCVTPUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 164536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f16),
     /* 164539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164543 */     GIR_RootConstrainSelectedInstOperands,
     /* 164544 */     // GIR_Coverage, 831,
     /* 164544 */     GIR_EraseRootFromParent_Done,
     /* 164545 */   // Label 3033: @164545
     /* 164545 */   GIM_Try, /*On fail goto*//*Label 3034*/ GIMT_Encode4(164581), // Rule ID 832 //
     /* 164550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164553 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164558 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164561 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164572 */     // (intrinsic_wo_chain:{ *:[v8i16] } 597:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCVTPUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 164572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv8f16),
     /* 164575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164579 */     GIR_RootConstrainSelectedInstOperands,
     /* 164580 */     // GIR_Coverage, 832,
     /* 164580 */     GIR_EraseRootFromParent_Done,
     /* 164581 */   // Label 3034: @164581
     /* 164581 */   GIM_Try, /*On fail goto*//*Label 3035*/ GIMT_Encode4(164617), // Rule ID 833 //
     /* 164586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164608 */     // (intrinsic_wo_chain:{ *:[v2i32] } 597:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCVTPUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 164608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f32),
     /* 164611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164615 */     GIR_RootConstrainSelectedInstOperands,
     /* 164616 */     // GIR_Coverage, 833,
     /* 164616 */     GIR_EraseRootFromParent_Done,
     /* 164617 */   // Label 3035: @164617
     /* 164617 */   GIM_Try, /*On fail goto*//*Label 3036*/ GIMT_Encode4(164653), // Rule ID 834 //
     /* 164622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164644 */     // (intrinsic_wo_chain:{ *:[v4i32] } 597:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTPUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 164644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv4f32),
     /* 164647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164651 */     GIR_RootConstrainSelectedInstOperands,
     /* 164652 */     // GIR_Coverage, 834,
     /* 164652 */     GIR_EraseRootFromParent_Done,
     /* 164653 */   // Label 3036: @164653
     /* 164653 */   GIM_Try, /*On fail goto*//*Label 3037*/ GIMT_Encode4(164689), // Rule ID 835 //
     /* 164658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 164666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164676 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164680 */     // (intrinsic_wo_chain:{ *:[v2i64] } 597:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTPUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 164680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv2f64),
     /* 164683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164687 */     GIR_RootConstrainSelectedInstOperands,
     /* 164688 */     // GIR_Coverage, 835,
     /* 164688 */     GIR_EraseRootFromParent_Done,
     /* 164689 */   // Label 3037: @164689
     /* 164689 */   GIM_Try, /*On fail goto*//*Label 3038*/ GIMT_Encode4(164725), // Rule ID 836 //
     /* 164694 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtxn),
     /* 164702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164712 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164716 */     // (intrinsic_wo_chain:{ *:[v2f32] } 598:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCVTXNv2f32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 164716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv2f32),
     /* 164719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164723 */     GIR_RootConstrainSelectedInstOperands,
     /* 164724 */     // GIR_Coverage, 836,
     /* 164724 */     GIR_EraseRootFromParent_Done,
     /* 164725 */   // Label 3038: @164725
     /* 164725 */   GIM_Try, /*On fail goto*//*Label 3039*/ GIMT_Encode4(164761), // Rule ID 863 //
     /* 164730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 164741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 164744 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164752 */     // (intrinsic_wo_chain:{ *:[v4f16] } 639:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRECPEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 164752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f16),
     /* 164755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164759 */     GIR_RootConstrainSelectedInstOperands,
     /* 164760 */     // GIR_Coverage, 863,
     /* 164760 */     GIR_EraseRootFromParent_Done,
     /* 164761 */   // Label 3039: @164761
     /* 164761 */   GIM_Try, /*On fail goto*//*Label 3040*/ GIMT_Encode4(164797), // Rule ID 864 //
     /* 164766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 164769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 164777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 164780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164788 */     // (intrinsic_wo_chain:{ *:[v8f16] } 639:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRECPEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 164788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv8f16),
     /* 164791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164795 */     GIR_RootConstrainSelectedInstOperands,
     /* 164796 */     // GIR_Coverage, 864,
     /* 164796 */     GIR_EraseRootFromParent_Done,
     /* 164797 */   // Label 3040: @164797
     /* 164797 */   GIM_Try, /*On fail goto*//*Label 3041*/ GIMT_Encode4(164833), // Rule ID 865 //
     /* 164802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164824 */     // (intrinsic_wo_chain:{ *:[v2f32] } 639:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRECPEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f32),
     /* 164827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164831 */     GIR_RootConstrainSelectedInstOperands,
     /* 164832 */     // GIR_Coverage, 865,
     /* 164832 */     GIR_EraseRootFromParent_Done,
     /* 164833 */   // Label 3041: @164833
     /* 164833 */   GIM_Try, /*On fail goto*//*Label 3042*/ GIMT_Encode4(164869), // Rule ID 866 //
     /* 164838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164852 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164860 */     // (intrinsic_wo_chain:{ *:[v4f32] } 639:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRECPEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv4f32),
     /* 164863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164867 */     GIR_RootConstrainSelectedInstOperands,
     /* 164868 */     // GIR_Coverage, 866,
     /* 164868 */     GIR_EraseRootFromParent_Done,
     /* 164869 */   // Label 3042: @164869
     /* 164869 */   GIM_Try, /*On fail goto*//*Label 3043*/ GIMT_Encode4(164905), // Rule ID 867 //
     /* 164874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 164877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 164882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164896 */     // (intrinsic_wo_chain:{ *:[v2f64] } 639:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRECPEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 164896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv2f64),
     /* 164899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164901 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164903 */     GIR_RootConstrainSelectedInstOperands,
     /* 164904 */     // GIR_Coverage, 867,
     /* 164904 */     GIR_EraseRootFromParent_Done,
     /* 164905 */   // Label 3043: @164905
     /* 164905 */   GIM_Try, /*On fail goto*//*Label 3044*/ GIMT_Encode4(164941), // Rule ID 938 //
     /* 164910 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164913 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164918 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 164921 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 164924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 164932 */     // (intrinsic_wo_chain:{ *:[v2f32] } 643:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 164932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f32),
     /* 164935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164939 */     GIR_RootConstrainSelectedInstOperands,
     /* 164940 */     // GIR_Coverage, 938,
     /* 164940 */     GIR_EraseRootFromParent_Done,
     /* 164941 */   // Label 3044: @164941
     /* 164941 */   GIM_Try, /*On fail goto*//*Label 3045*/ GIMT_Encode4(164977), // Rule ID 939 //
     /* 164946 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164949 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164954 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 164957 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 164960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 164968 */     // (intrinsic_wo_chain:{ *:[v4f32] } 643:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 164968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv4f32),
     /* 164971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 164973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 164975 */     GIR_RootConstrainSelectedInstOperands,
     /* 164976 */     // GIR_Coverage, 939,
     /* 164976 */     GIR_EraseRootFromParent_Done,
     /* 164977 */   // Label 3045: @164977
     /* 164977 */   GIM_Try, /*On fail goto*//*Label 3046*/ GIMT_Encode4(165013), // Rule ID 940 //
     /* 164982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 164985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 164990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 164993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 164996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165000 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165004 */     // (intrinsic_wo_chain:{ *:[v2f64] } 643:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Zv2f64),
     /* 165007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165011 */     GIR_RootConstrainSelectedInstOperands,
     /* 165012 */     // GIR_Coverage, 940,
     /* 165012 */     GIR_EraseRootFromParent_Done,
     /* 165013 */   // Label 3046: @165013
     /* 165013 */   GIM_Try, /*On fail goto*//*Label 3047*/ GIMT_Encode4(165049), // Rule ID 941 //
     /* 165018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165036 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165040 */     // (intrinsic_wo_chain:{ *:[v2f32] } 645:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Zv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f32),
     /* 165043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165045 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165047 */     GIR_RootConstrainSelectedInstOperands,
     /* 165048 */     // GIR_Coverage, 941,
     /* 165048 */     GIR_EraseRootFromParent_Done,
     /* 165049 */   // Label 3047: @165049
     /* 165049 */   GIM_Try, /*On fail goto*//*Label 3048*/ GIMT_Encode4(165085), // Rule ID 942 //
     /* 165054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165072 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165076 */     // (intrinsic_wo_chain:{ *:[v4f32] } 645:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Zv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv4f32),
     /* 165079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165083 */     GIR_RootConstrainSelectedInstOperands,
     /* 165084 */     // GIR_Coverage, 942,
     /* 165084 */     GIR_EraseRootFromParent_Done,
     /* 165085 */   // Label 3048: @165085
     /* 165085 */   GIM_Try, /*On fail goto*//*Label 3049*/ GIMT_Encode4(165121), // Rule ID 943 //
     /* 165090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 165098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165112 */     // (intrinsic_wo_chain:{ *:[v2f64] } 645:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Zv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Zv2f64),
     /* 165115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165119 */     GIR_RootConstrainSelectedInstOperands,
     /* 165120 */     // GIR_Coverage, 943,
     /* 165120 */     GIR_EraseRootFromParent_Done,
     /* 165121 */   // Label 3049: @165121
     /* 165121 */   GIM_Try, /*On fail goto*//*Label 3050*/ GIMT_Encode4(165157), // Rule ID 944 //
     /* 165126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165148 */     // (intrinsic_wo_chain:{ *:[v2f32] } 642:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT32Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f32),
     /* 165151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165155 */     GIR_RootConstrainSelectedInstOperands,
     /* 165156 */     // GIR_Coverage, 944,
     /* 165156 */     GIR_EraseRootFromParent_Done,
     /* 165157 */   // Label 3050: @165157
     /* 165157 */   GIM_Try, /*On fail goto*//*Label 3051*/ GIMT_Encode4(165193), // Rule ID 945 //
     /* 165162 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165165 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165170 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165173 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165176 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165180 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165184 */     // (intrinsic_wo_chain:{ *:[v4f32] } 642:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT32Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv4f32),
     /* 165187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165191 */     GIR_RootConstrainSelectedInstOperands,
     /* 165192 */     // GIR_Coverage, 945,
     /* 165192 */     GIR_EraseRootFromParent_Done,
     /* 165193 */   // Label 3051: @165193
     /* 165193 */   GIM_Try, /*On fail goto*//*Label 3052*/ GIMT_Encode4(165229), // Rule ID 946 //
     /* 165198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 165206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165220 */     // (intrinsic_wo_chain:{ *:[v2f64] } 642:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT32Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32Xv2f64),
     /* 165223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165225 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165227 */     GIR_RootConstrainSelectedInstOperands,
     /* 165228 */     // GIR_Coverage, 946,
     /* 165228 */     GIR_EraseRootFromParent_Done,
     /* 165229 */   // Label 3052: @165229
     /* 165229 */   GIM_Try, /*On fail goto*//*Label 3053*/ GIMT_Encode4(165265), // Rule ID 947 //
     /* 165234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165237 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165242 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165245 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165256 */     // (intrinsic_wo_chain:{ *:[v2f32] } 644:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRINT64Xv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f32),
     /* 165259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165263 */     GIR_RootConstrainSelectedInstOperands,
     /* 165264 */     // GIR_Coverage, 947,
     /* 165264 */     GIR_EraseRootFromParent_Done,
     /* 165265 */   // Label 3053: @165265
     /* 165265 */   GIM_Try, /*On fail goto*//*Label 3054*/ GIMT_Encode4(165301), // Rule ID 948 //
     /* 165270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165288 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165292 */     // (intrinsic_wo_chain:{ *:[v4f32] } 644:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRINT64Xv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv4f32),
     /* 165295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165299 */     GIR_RootConstrainSelectedInstOperands,
     /* 165300 */     // GIR_Coverage, 948,
     /* 165300 */     GIR_EraseRootFromParent_Done,
     /* 165301 */   // Label 3054: @165301
     /* 165301 */   GIM_Try, /*On fail goto*//*Label 3055*/ GIMT_Encode4(165337), // Rule ID 949 //
     /* 165306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFRInt3264),
     /* 165309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 165314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165328 */     // (intrinsic_wo_chain:{ *:[v2f64] } 644:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRINT64Xv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64Xv2f64),
     /* 165331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165335 */     GIR_RootConstrainSelectedInstOperands,
     /* 165336 */     // GIR_Coverage, 949,
     /* 165336 */     GIR_EraseRootFromParent_Done,
     /* 165337 */   // Label 3055: @165337
     /* 165337 */   GIM_Try, /*On fail goto*//*Label 3056*/ GIMT_Encode4(165373), // Rule ID 950 //
     /* 165342 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165364 */     // (intrinsic_wo_chain:{ *:[v4f16] } 646:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FRSQRTEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 165364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f16),
     /* 165367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165371 */     GIR_RootConstrainSelectedInstOperands,
     /* 165372 */     // GIR_Coverage, 950,
     /* 165372 */     GIR_EraseRootFromParent_Done,
     /* 165373 */   // Label 3056: @165373
     /* 165373 */   GIM_Try, /*On fail goto*//*Label 3057*/ GIMT_Encode4(165409), // Rule ID 951 //
     /* 165378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 165381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165392 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165396 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165400 */     // (intrinsic_wo_chain:{ *:[v8f16] } 646:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FRSQRTEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 165400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv8f16),
     /* 165403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165407 */     GIR_RootConstrainSelectedInstOperands,
     /* 165408 */     // GIR_Coverage, 951,
     /* 165408 */     GIR_EraseRootFromParent_Done,
     /* 165409 */   // Label 3057: @165409
     /* 165409 */   GIM_Try, /*On fail goto*//*Label 3058*/ GIMT_Encode4(165445), // Rule ID 952 //
     /* 165414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165436 */     // (intrinsic_wo_chain:{ *:[v2f32] } 646:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FRSQRTEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 165436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f32),
     /* 165439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165441 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165443 */     GIR_RootConstrainSelectedInstOperands,
     /* 165444 */     // GIR_Coverage, 952,
     /* 165444 */     GIR_EraseRootFromParent_Done,
     /* 165445 */   // Label 3058: @165445
     /* 165445 */   GIM_Try, /*On fail goto*//*Label 3059*/ GIMT_Encode4(165481), // Rule ID 953 //
     /* 165450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165464 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165468 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165472 */     // (intrinsic_wo_chain:{ *:[v4f32] } 646:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FRSQRTEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 165472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv4f32),
     /* 165475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165479 */     GIR_RootConstrainSelectedInstOperands,
     /* 165480 */     // GIR_Coverage, 953,
     /* 165480 */     GIR_EraseRootFromParent_Done,
     /* 165481 */   // Label 3059: @165481
     /* 165481 */   GIM_Try, /*On fail goto*//*Label 3060*/ GIMT_Encode4(165517), // Rule ID 954 //
     /* 165486 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165489 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 165494 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165497 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165508 */     // (intrinsic_wo_chain:{ *:[v2f64] } 646:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FRSQRTEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 165508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv2f64),
     /* 165511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165515 */     GIR_RootConstrainSelectedInstOperands,
     /* 165516 */     // GIR_Coverage, 954,
     /* 165516 */     GIR_EraseRootFromParent_Done,
     /* 165517 */   // Label 3060: @165517
     /* 165517 */   GIM_Try, /*On fail goto*//*Label 3061*/ GIMT_Encode4(165553), // Rule ID 1001 //
     /* 165522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165540 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165544 */     // (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 165544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 165547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165551 */     GIR_RootConstrainSelectedInstOperands,
     /* 165552 */     // GIR_Coverage, 1001,
     /* 165552 */     GIR_EraseRootFromParent_Done,
     /* 165553 */   // Label 3061: @165553
     /* 165553 */   GIM_Try, /*On fail goto*//*Label 3062*/ GIMT_Encode4(165589), // Rule ID 1003 //
     /* 165558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165576 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165580 */     // (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 165580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 165583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165587 */     GIR_RootConstrainSelectedInstOperands,
     /* 165588 */     // GIR_Coverage, 1003,
     /* 165588 */     GIR_EraseRootFromParent_Done,
     /* 165589 */   // Label 3062: @165589
     /* 165589 */   GIM_Try, /*On fail goto*//*Label 3063*/ GIMT_Encode4(165625), // Rule ID 1005 //
     /* 165594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165612 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165616 */     // (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 165616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 165619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165621 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165623 */     GIR_RootConstrainSelectedInstOperands,
     /* 165624 */     // GIR_Coverage, 1005,
     /* 165624 */     GIR_EraseRootFromParent_Done,
     /* 165625 */   // Label 3063: @165625
     /* 165625 */   GIM_Try, /*On fail goto*//*Label 3064*/ GIMT_Encode4(165661), // Rule ID 1007 //
     /* 165630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165652 */     // (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 165652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 165655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165659 */     GIR_RootConstrainSelectedInstOperands,
     /* 165660 */     // GIR_Coverage, 1007,
     /* 165660 */     GIR_EraseRootFromParent_Done,
     /* 165661 */   // Label 3064: @165661
     /* 165661 */   GIM_Try, /*On fail goto*//*Label 3065*/ GIMT_Encode4(165697), // Rule ID 1009 //
     /* 165666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 165677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165688 */     // (intrinsic_wo_chain:{ *:[v1i64] } 667:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 165688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 165691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165695 */     GIR_RootConstrainSelectedInstOperands,
     /* 165696 */     // GIR_Coverage, 1009,
     /* 165696 */     GIR_EraseRootFromParent_Done,
     /* 165697 */   // Label 3065: @165697
     /* 165697 */   GIM_Try, /*On fail goto*//*Label 3066*/ GIMT_Encode4(165733), // Rule ID 1011 //
     /* 165702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 165710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165720 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165724 */     // (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 165724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 165727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165731 */     GIR_RootConstrainSelectedInstOperands,
     /* 165732 */     // GIR_Coverage, 1011,
     /* 165732 */     GIR_EraseRootFromParent_Done,
     /* 165733 */   // Label 3066: @165733
     /* 165733 */   GIM_Try, /*On fail goto*//*Label 3067*/ GIMT_Encode4(165769), // Rule ID 1022 //
     /* 165738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 165749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 165752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165760 */     // (intrinsic_wo_chain:{ *:[v8i8] } 685:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 165760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i8),
     /* 165763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165767 */     GIR_RootConstrainSelectedInstOperands,
     /* 165768 */     // GIR_Coverage, 1022,
     /* 165768 */     GIR_EraseRootFromParent_Done,
     /* 165769 */   // Label 3067: @165769
     /* 165769 */   GIM_Try, /*On fail goto*//*Label 3068*/ GIMT_Encode4(165805), // Rule ID 1023 //
     /* 165774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 165785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 165788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165796 */     // (intrinsic_wo_chain:{ *:[v16i8] } 685:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 165796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv16i8),
     /* 165799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165803 */     GIR_RootConstrainSelectedInstOperands,
     /* 165804 */     // GIR_Coverage, 1023,
     /* 165804 */     GIR_EraseRootFromParent_Done,
     /* 165805 */   // Label 3068: @165805
     /* 165805 */   GIM_Try, /*On fail goto*//*Label 3069*/ GIMT_Encode4(165841), // Rule ID 1024 //
     /* 165810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 165821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 165824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165832 */     // (intrinsic_wo_chain:{ *:[v4i16] } 685:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 165832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i16),
     /* 165835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165839 */     GIR_RootConstrainSelectedInstOperands,
     /* 165840 */     // GIR_Coverage, 1024,
     /* 165840 */     GIR_EraseRootFromParent_Done,
     /* 165841 */   // Label 3069: @165841
     /* 165841 */   GIM_Try, /*On fail goto*//*Label 3070*/ GIMT_Encode4(165877), // Rule ID 1025 //
     /* 165846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 165857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 165860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165868 */     // (intrinsic_wo_chain:{ *:[v8i16] } 685:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 165868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv8i16),
     /* 165871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165875 */     GIR_RootConstrainSelectedInstOperands,
     /* 165876 */     // GIR_Coverage, 1025,
     /* 165876 */     GIR_EraseRootFromParent_Done,
     /* 165877 */   // Label 3070: @165877
     /* 165877 */   GIM_Try, /*On fail goto*//*Label 3071*/ GIMT_Encode4(165913), // Rule ID 1026 //
     /* 165882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165885 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165890 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 165893 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 165896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 165904 */     // (intrinsic_wo_chain:{ *:[v2i32] } 685:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 165904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i32),
     /* 165907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165911 */     GIR_RootConstrainSelectedInstOperands,
     /* 165912 */     // GIR_Coverage, 1026,
     /* 165912 */     GIR_EraseRootFromParent_Done,
     /* 165913 */   // Label 3071: @165913
     /* 165913 */   GIM_Try, /*On fail goto*//*Label 3072*/ GIMT_Encode4(165949), // Rule ID 1027 //
     /* 165918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 165929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 165932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165936 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165940 */     // (intrinsic_wo_chain:{ *:[v4i32] } 685:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 165940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv4i32),
     /* 165943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165947 */     GIR_RootConstrainSelectedInstOperands,
     /* 165948 */     // GIR_Coverage, 1027,
     /* 165948 */     GIR_EraseRootFromParent_Done,
     /* 165949 */   // Label 3072: @165949
     /* 165949 */   GIM_Try, /*On fail goto*//*Label 3073*/ GIMT_Encode4(165985), // Rule ID 1028 //
     /* 165954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 165962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 165965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 165968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 165976 */     // (intrinsic_wo_chain:{ *:[v2i64] } 685:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 165976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv2i64),
     /* 165979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 165981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 165983 */     GIR_RootConstrainSelectedInstOperands,
     /* 165984 */     // GIR_Coverage, 1028,
     /* 165984 */     GIR_EraseRootFromParent_Done,
     /* 165985 */   // Label 3073: @165985
     /* 165985 */   GIM_Try, /*On fail goto*//*Label 3074*/ GIMT_Encode4(166021), // Rule ID 1029 //
     /* 165990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 165993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 165998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 166001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166012 */     // (intrinsic_wo_chain:{ *:[v8i8] } 692:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SQNEGv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 166012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i8),
     /* 166015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166019 */     GIR_RootConstrainSelectedInstOperands,
     /* 166020 */     // GIR_Coverage, 1029,
     /* 166020 */     GIR_EraseRootFromParent_Done,
     /* 166021 */   // Label 3074: @166021
     /* 166021 */   GIM_Try, /*On fail goto*//*Label 3075*/ GIMT_Encode4(166057), // Rule ID 1030 //
     /* 166026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166029 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166034 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 166037 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166048 */     // (intrinsic_wo_chain:{ *:[v16i8] } 692:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SQNEGv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 166048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv16i8),
     /* 166051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166055 */     GIR_RootConstrainSelectedInstOperands,
     /* 166056 */     // GIR_Coverage, 1030,
     /* 166056 */     GIR_EraseRootFromParent_Done,
     /* 166057 */   // Label 3075: @166057
     /* 166057 */   GIM_Try, /*On fail goto*//*Label 3076*/ GIMT_Encode4(166093), // Rule ID 1031 //
     /* 166062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166080 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166084 */     // (intrinsic_wo_chain:{ *:[v4i16] } 692:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SQNEGv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 166084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i16),
     /* 166087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166091 */     GIR_RootConstrainSelectedInstOperands,
     /* 166092 */     // GIR_Coverage, 1031,
     /* 166092 */     GIR_EraseRootFromParent_Done,
     /* 166093 */   // Label 3076: @166093
     /* 166093 */   GIM_Try, /*On fail goto*//*Label 3077*/ GIMT_Encode4(166129), // Rule ID 1032 //
     /* 166098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166116 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 692:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SQNEGv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 166120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv8i16),
     /* 166123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166127 */     GIR_RootConstrainSelectedInstOperands,
     /* 166128 */     // GIR_Coverage, 1032,
     /* 166128 */     GIR_EraseRootFromParent_Done,
     /* 166129 */   // Label 3077: @166129
     /* 166129 */   GIM_Try, /*On fail goto*//*Label 3078*/ GIMT_Encode4(166165), // Rule ID 1033 //
     /* 166134 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166152 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166156 */     // (intrinsic_wo_chain:{ *:[v2i32] } 692:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (SQNEGv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i32),
     /* 166159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166163 */     GIR_RootConstrainSelectedInstOperands,
     /* 166164 */     // GIR_Coverage, 1033,
     /* 166164 */     GIR_EraseRootFromParent_Done,
     /* 166165 */   // Label 3078: @166165
     /* 166165 */   GIM_Try, /*On fail goto*//*Label 3079*/ GIMT_Encode4(166201), // Rule ID 1034 //
     /* 166170 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166173 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166178 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166181 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166184 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166192 */     // (intrinsic_wo_chain:{ *:[v4i32] } 692:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (SQNEGv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv4i32),
     /* 166195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166199 */     GIR_RootConstrainSelectedInstOperands,
     /* 166200 */     // GIR_Coverage, 1034,
     /* 166200 */     GIR_EraseRootFromParent_Done,
     /* 166201 */   // Label 3079: @166201
     /* 166201 */   GIM_Try, /*On fail goto*//*Label 3080*/ GIMT_Encode4(166237), // Rule ID 1035 //
     /* 166206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166217 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 166220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166228 */     // (intrinsic_wo_chain:{ *:[v2i64] } 692:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (SQNEGv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 166228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv2i64),
     /* 166231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166235 */     GIR_RootConstrainSelectedInstOperands,
     /* 166236 */     // GIR_Coverage, 1035,
     /* 166236 */     GIR_EraseRootFromParent_Done,
     /* 166237 */   // Label 3080: @166237
     /* 166237 */   GIM_Try, /*On fail goto*//*Label 3081*/ GIMT_Encode4(166273), // Rule ID 1062 //
     /* 166242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 166253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 166256 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166260 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166264 */     // (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 166264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 166267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166271 */     GIR_RootConstrainSelectedInstOperands,
     /* 166272 */     // GIR_Coverage, 1062,
     /* 166272 */     GIR_EraseRootFromParent_Done,
     /* 166273 */   // Label 3081: @166273
     /* 166273 */   GIM_Try, /*On fail goto*//*Label 3082*/ GIMT_Encode4(166309), // Rule ID 1064 //
     /* 166278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 166289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 166292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166300 */     // (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 166300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 166303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166307 */     GIR_RootConstrainSelectedInstOperands,
     /* 166308 */     // GIR_Coverage, 1064,
     /* 166308 */     GIR_EraseRootFromParent_Done,
     /* 166309 */   // Label 3082: @166309
     /* 166309 */   GIM_Try, /*On fail goto*//*Label 3083*/ GIMT_Encode4(166345), // Rule ID 1066 //
     /* 166314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166336 */     // (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 166336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 166339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166343 */     GIR_RootConstrainSelectedInstOperands,
     /* 166344 */     // GIR_Coverage, 1066,
     /* 166344 */     GIR_EraseRootFromParent_Done,
     /* 166345 */   // Label 3083: @166345
     /* 166345 */   GIM_Try, /*On fail goto*//*Label 3084*/ GIMT_Encode4(166381), // Rule ID 1068 //
     /* 166350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166353 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166358 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166361 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166368 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166372 */     // (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 166372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 166375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166379 */     GIR_RootConstrainSelectedInstOperands,
     /* 166380 */     // GIR_Coverage, 1068,
     /* 166380 */     GIR_EraseRootFromParent_Done,
     /* 166381 */   // Label 3084: @166381
     /* 166381 */   GIM_Try, /*On fail goto*//*Label 3085*/ GIMT_Encode4(166417), // Rule ID 1070 //
     /* 166386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166408 */     // (intrinsic_wo_chain:{ *:[v1i64] } 732:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 166408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 166411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166415 */     GIR_RootConstrainSelectedInstOperands,
     /* 166416 */     // GIR_Coverage, 1070,
     /* 166416 */     GIR_EraseRootFromParent_Done,
     /* 166417 */   // Label 3085: @166417
     /* 166417 */   GIM_Try, /*On fail goto*//*Label 3086*/ GIMT_Encode4(166453), // Rule ID 1072 //
     /* 166422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 166430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 166433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166444 */     // (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 166444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 166447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166451 */     GIR_RootConstrainSelectedInstOperands,
     /* 166452 */     // GIR_Coverage, 1072,
     /* 166452 */     GIR_EraseRootFromParent_Done,
     /* 166453 */   // Label 3086: @166453
     /* 166453 */   GIM_Try, /*On fail goto*//*Label 3087*/ GIMT_Encode4(166489), // Rule ID 1086 //
     /* 166458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166476 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166480 */     // (intrinsic_wo_chain:{ *:[v2i32] } 753:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URECPEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv2i32),
     /* 166483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166487 */     GIR_RootConstrainSelectedInstOperands,
     /* 166488 */     // GIR_Coverage, 1086,
     /* 166488 */     GIR_EraseRootFromParent_Done,
     /* 166489 */   // Label 3087: @166489
     /* 166489 */   GIM_Try, /*On fail goto*//*Label 3088*/ GIMT_Encode4(166525), // Rule ID 1087 //
     /* 166494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urecpe),
     /* 166502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166508 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166512 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166516 */     // (intrinsic_wo_chain:{ *:[v4i32] } 753:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URECPEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPEv4i32),
     /* 166519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166523 */     GIR_RootConstrainSelectedInstOperands,
     /* 166524 */     // GIR_Coverage, 1087,
     /* 166524 */     GIR_EraseRootFromParent_Done,
     /* 166525 */   // Label 3088: @166525
     /* 166525 */   GIM_Try, /*On fail goto*//*Label 3089*/ GIMT_Encode4(166561), // Rule ID 1088 //
     /* 166530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 166541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 166544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 756:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (URSQRTEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 166552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv2i32),
     /* 166555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166559 */     GIR_RootConstrainSelectedInstOperands,
     /* 166560 */     // GIR_Coverage, 1088,
     /* 166560 */     GIR_EraseRootFromParent_Done,
     /* 166561 */   // Label 3089: @166561
     /* 166561 */   GIM_Try, /*On fail goto*//*Label 3090*/ GIMT_Encode4(166597), // Rule ID 1089 //
     /* 166566 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166569 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ursqrte),
     /* 166574 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 166577 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166588 */     // (intrinsic_wo_chain:{ *:[v4i32] } 756:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (URSQRTEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 166588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTEv4i32),
     /* 166591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166595 */     GIR_RootConstrainSelectedInstOperands,
     /* 166596 */     // GIR_Coverage, 1089,
     /* 166596 */     GIR_EraseRootFromParent_Done,
     /* 166597 */   // Label 3090: @166597
     /* 166597 */   GIM_Try, /*On fail goto*//*Label 3091*/ GIMT_Encode4(166633), // Rule ID 1653 //
     /* 166602 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166605 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fcvtxn),
     /* 166610 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166624 */     // (intrinsic_wo_chain:{ *:[f32] } 793:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FCVTXNv1i64:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNv1i64),
     /* 166627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166631 */     GIR_RootConstrainSelectedInstOperands,
     /* 166632 */     // GIR_Coverage, 1653,
     /* 166632 */     GIR_EraseRootFromParent_Done,
     /* 166633 */   // Label 3091: @166633
     /* 166633 */   GIM_Try, /*On fail goto*//*Label 3092*/ GIMT_Encode4(166669), // Rule ID 1659 //
     /* 166638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166652 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166656 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166660 */     // (intrinsic_wo_chain:{ *:[i64] } 685:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 166663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166667 */     GIR_RootConstrainSelectedInstOperands,
     /* 166668 */     // GIR_Coverage, 1659,
     /* 166668 */     GIR_EraseRootFromParent_Done,
     /* 166669 */   // Label 3092: @166669
     /* 166669 */   GIM_Try, /*On fail goto*//*Label 3093*/ GIMT_Encode4(166705), // Rule ID 1660 //
     /* 166674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 166682 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166685 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166692 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166696 */     // (intrinsic_wo_chain:{ *:[i32] } 685:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQABSv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i32),
     /* 166699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166701 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166703 */     GIR_RootConstrainSelectedInstOperands,
     /* 166704 */     // GIR_Coverage, 1660,
     /* 166704 */     GIR_EraseRootFromParent_Done,
     /* 166705 */   // Label 3093: @166705
     /* 166705 */   GIM_Try, /*On fail goto*//*Label 3094*/ GIMT_Encode4(166741), // Rule ID 1661 //
     /* 166710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 166721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166732 */     // (intrinsic_wo_chain:{ *:[i64] } 692:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 166732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 166735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166739 */     GIR_RootConstrainSelectedInstOperands,
     /* 166740 */     // GIR_Coverage, 1661,
     /* 166740 */     GIR_EraseRootFromParent_Done,
     /* 166741 */   // Label 3094: @166741
     /* 166741 */   GIM_Try, /*On fail goto*//*Label 3095*/ GIMT_Encode4(166777), // Rule ID 1662 //
     /* 166746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 166754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 166760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166768 */     // (intrinsic_wo_chain:{ *:[i32] } 692:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SQNEGv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 166768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i32),
     /* 166771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166775 */     GIR_RootConstrainSelectedInstOperands,
     /* 166776 */     // GIR_Coverage, 1662,
     /* 166776 */     GIR_EraseRootFromParent_Done,
     /* 166777 */   // Label 3095: @166777
     /* 166777 */   GIM_Try, /*On fail goto*//*Label 3096*/ GIMT_Encode4(166813), // Rule ID 1663 //
     /* 166782 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166785 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtn),
     /* 166790 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166793 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166800 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166804 */     // (intrinsic_wo_chain:{ *:[f32] } 670:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNv1i32),
     /* 166807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166811 */     GIR_RootConstrainSelectedInstOperands,
     /* 166812 */     // GIR_Coverage, 1663,
     /* 166812 */     GIR_EraseRootFromParent_Done,
     /* 166813 */   // Label 3096: @166813
     /* 166813 */   GIM_Try, /*On fail goto*//*Label 3097*/ GIMT_Encode4(166849), // Rule ID 1664 //
     /* 166818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_sqxtun),
     /* 166826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166836 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166840 */     // (intrinsic_wo_chain:{ *:[f32] } 671:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (SQXTUNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNv1i32),
     /* 166843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166847 */     GIR_RootConstrainSelectedInstOperands,
     /* 166848 */     // GIR_Coverage, 1664,
     /* 166848 */     GIR_EraseRootFromParent_Done,
     /* 166849 */   // Label 3097: @166849
     /* 166849 */   GIM_Try, /*On fail goto*//*Label 3098*/ GIMT_Encode4(166885), // Rule ID 1670 //
     /* 166854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166857 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_scalar_uqxtn),
     /* 166862 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166865 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 166868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166876 */     // (intrinsic_wo_chain:{ *:[f32] } 672:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (UQXTNv1i32:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 166876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNv1i32),
     /* 166879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166883 */     GIR_RootConstrainSelectedInstOperands,
     /* 166884 */     // GIR_Coverage, 1670,
     /* 166884 */     GIR_EraseRootFromParent_Done,
     /* 166885 */   // Label 3098: @166885
     /* 166885 */   GIM_Try, /*On fail goto*//*Label 3099*/ GIMT_Encode4(166921), // Rule ID 1943 //
     /* 166890 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166893 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166898 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 166904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166908 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 166912 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 166912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 166915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166919 */     GIR_RootConstrainSelectedInstOperands,
     /* 166920 */     // GIR_Coverage, 1943,
     /* 166920 */     GIR_EraseRootFromParent_Done,
     /* 166921 */   // Label 3099: @166921
     /* 166921 */   GIM_Try, /*On fail goto*//*Label 3100*/ GIMT_Encode4(166957), // Rule ID 1945 //
     /* 166926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 166929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 166937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 166940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 166944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166948 */     // (intrinsic_wo_chain:{ *:[f16] } 604:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 166948 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 166951 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166953 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166955 */     GIR_RootConstrainSelectedInstOperands,
     /* 166956 */     // GIR_Coverage, 1945,
     /* 166956 */     GIR_EraseRootFromParent_Done,
     /* 166957 */   // Label 3100: @166957
     /* 166957 */   GIM_Try, /*On fail goto*//*Label 3101*/ GIMT_Encode4(166993), // Rule ID 1947 //
     /* 166962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 166965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 166970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 166973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 166976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 166980 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 166984 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 166984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 166987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 166989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 166991 */     GIR_RootConstrainSelectedInstOperands,
     /* 166992 */     // GIR_Coverage, 1947,
     /* 166992 */     GIR_EraseRootFromParent_Done,
     /* 166993 */   // Label 3101: @166993
     /* 166993 */   GIM_Try, /*On fail goto*//*Label 3102*/ GIMT_Encode4(167029), // Rule ID 1949 //
     /* 166998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167020 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 167023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167027 */     GIR_RootConstrainSelectedInstOperands,
     /* 167028 */     // GIR_Coverage, 1949,
     /* 167028 */     GIR_EraseRootFromParent_Done,
     /* 167029 */   // Label 3102: @167029
     /* 167029 */   GIM_Try, /*On fail goto*//*Label 3103*/ GIMT_Encode4(167065), // Rule ID 1951 //
     /* 167034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167056 */     // (intrinsic_wo_chain:{ *:[f16] } 606:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 167059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167063 */     GIR_RootConstrainSelectedInstOperands,
     /* 167064 */     // GIR_Coverage, 1951,
     /* 167064 */     GIR_EraseRootFromParent_Done,
     /* 167065 */   // Label 3103: @167065
     /* 167065 */   GIM_Try, /*On fail goto*//*Label 3104*/ GIMT_Encode4(167101), // Rule ID 1953 //
     /* 167070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 167078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167092 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 167095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167099 */     GIR_RootConstrainSelectedInstOperands,
     /* 167100 */     // GIR_Coverage, 1953,
     /* 167100 */     GIR_EraseRootFromParent_Done,
     /* 167101 */   // Label 3104: @167101
     /* 167101 */   GIM_Try, /*On fail goto*//*Label 3105*/ GIMT_Encode4(167137), // Rule ID 1955 //
     /* 167106 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167128 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 167131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167135 */     GIR_RootConstrainSelectedInstOperands,
     /* 167136 */     // GIR_Coverage, 1955,
     /* 167136 */     GIR_EraseRootFromParent_Done,
     /* 167137 */   // Label 3105: @167137
     /* 167137 */   GIM_Try, /*On fail goto*//*Label 3106*/ GIMT_Encode4(167173), // Rule ID 1957 //
     /* 167142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167164 */     // (intrinsic_wo_chain:{ *:[f16] } 610:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 167167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167171 */     GIR_RootConstrainSelectedInstOperands,
     /* 167172 */     // GIR_Coverage, 1957,
     /* 167172 */     GIR_EraseRootFromParent_Done,
     /* 167173 */   // Label 3106: @167173
     /* 167173 */   GIM_Try, /*On fail goto*//*Label 3107*/ GIMT_Encode4(167209), // Rule ID 1959 //
     /* 167178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 167186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167196 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167200 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 167203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167205 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167207 */     GIR_RootConstrainSelectedInstOperands,
     /* 167208 */     // GIR_Coverage, 1959,
     /* 167208 */     GIR_EraseRootFromParent_Done,
     /* 167209 */   // Label 3107: @167209
     /* 167209 */   GIM_Try, /*On fail goto*//*Label 3108*/ GIMT_Encode4(167245), // Rule ID 1961 //
     /* 167214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 167228 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167232 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167236 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 167236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 167239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167243 */     GIR_RootConstrainSelectedInstOperands,
     /* 167244 */     // GIR_Coverage, 1961,
     /* 167244 */     GIR_EraseRootFromParent_Done,
     /* 167245 */   // Label 3108: @167245
     /* 167245 */   GIM_Try, /*On fail goto*//*Label 3109*/ GIMT_Encode4(167281), // Rule ID 1963 //
     /* 167250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 167253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 167261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 167264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 167268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167272 */     // (intrinsic_wo_chain:{ *:[f16] } 612:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 167272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 167275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167279 */     GIR_RootConstrainSelectedInstOperands,
     /* 167280 */     // GIR_Coverage, 1963,
     /* 167280 */     GIR_EraseRootFromParent_Done,
     /* 167281 */   // Label 3109: @167281
     /* 167281 */   GIM_Try, /*On fail goto*//*Label 3110*/ GIMT_Encode4(167317), // Rule ID 1965 //
     /* 167286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167289 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 167294 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167297 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 167300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167308 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 167308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 167311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167315 */     GIR_RootConstrainSelectedInstOperands,
     /* 167316 */     // GIR_Coverage, 1965,
     /* 167316 */     GIR_EraseRootFromParent_Done,
     /* 167317 */   // Label 3110: @167317
     /* 167317 */   GIM_Try, /*On fail goto*//*Label 3111*/ GIMT_Encode4(167353), // Rule ID 2305 //
     /* 167322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167325 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesmc),
     /* 167330 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167344 */     // (intrinsic_wo_chain:{ *:[v16i8] } 521:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMCrr),
     /* 167347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167351 */     GIR_RootConstrainSelectedInstOperands,
     /* 167352 */     // GIR_Coverage, 2305,
     /* 167352 */     GIR_EraseRootFromParent_Done,
     /* 167353 */   // Label 3111: @167353
     /* 167353 */   GIM_Try, /*On fail goto*//*Label 3112*/ GIMT_Encode4(167389), // Rule ID 2306 //
     /* 167358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 167361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesimc),
     /* 167366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 167369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 167372 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 167380 */     // (intrinsic_wo_chain:{ *:[v16i8] } 520:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (AESIMCrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 167380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMCrr),
     /* 167383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167387 */     GIR_RootConstrainSelectedInstOperands,
     /* 167388 */     // GIR_Coverage, 2306,
     /* 167388 */     GIR_EraseRootFromParent_Done,
     /* 167389 */   // Label 3112: @167389
     /* 167389 */   GIM_Try, /*On fail goto*//*Label 3113*/ GIMT_Encode4(167425), // Rule ID 2314 //
     /* 167394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 167397 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1h),
     /* 167402 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167412 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 167416 */     // (intrinsic_wo_chain:{ *:[i32] } 528:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn)  =>  (SHA1Hrr:{ *:[i32] } FPR32:{ *:[i32] }:$Rn)
     /* 167416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Hrr),
     /* 167419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167423 */     GIR_RootConstrainSelectedInstOperands,
     /* 167424 */     // GIR_Coverage, 2314,
     /* 167424 */     GIR_EraseRootFromParent_Done,
     /* 167425 */   // Label 3113: @167425
     /* 167425 */   GIM_Try, /*On fail goto*//*Label 3114*/ GIMT_Encode4(167461), // Rule ID 2511 //
     /* 167430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 167433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqabs),
     /* 167438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167448 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167452 */     // (intrinsic_wo_chain:{ *:[v1i64] } 685:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 167452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABSv1i64),
     /* 167455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167459 */     GIR_RootConstrainSelectedInstOperands,
     /* 167460 */     // GIR_Coverage, 2511,
     /* 167460 */     GIR_EraseRootFromParent_Done,
     /* 167461 */   // Label 3114: @167461
     /* 167461 */   GIM_Try, /*On fail goto*//*Label 3115*/ GIMT_Encode4(167500), // Rule ID 3543 //
     /* 167466 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167469 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167474 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 167477 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 167480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167488 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, 0:{ *:[i32] })
     /* 167488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 167491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167493 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167498 */     GIR_RootConstrainSelectedInstOperands,
     /* 167499 */     // GIR_Coverage, 3543,
     /* 167499 */     GIR_EraseRootFromParent_Done,
     /* 167500 */   // Label 3115: @167500
     /* 167500 */   GIM_Try, /*On fail goto*//*Label 3116*/ GIMT_Encode4(167539), // Rule ID 3544 //
     /* 167505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 167516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 167519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167527 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, 0:{ *:[i32] })
     /* 167527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 167530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167534 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167537 */     GIR_RootConstrainSelectedInstOperands,
     /* 167538 */     // GIR_Coverage, 3544,
     /* 167538 */     GIR_EraseRootFromParent_Done,
     /* 167539 */   // Label 3116: @167539
     /* 167539 */   GIM_Try, /*On fail goto*//*Label 3117*/ GIMT_Encode4(167578), // Rule ID 3545 //
     /* 167544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 167555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 167558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167566 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, 0:{ *:[i32] })
     /* 167566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 167569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167573 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167576 */     GIR_RootConstrainSelectedInstOperands,
     /* 167577 */     // GIR_Coverage, 3545,
     /* 167577 */     GIR_EraseRootFromParent_Done,
     /* 167578 */   // Label 3117: @167578
     /* 167578 */   GIM_Try, /*On fail goto*//*Label 3118*/ GIMT_Encode4(167617), // Rule ID 3546 //
     /* 167583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane_zero),
     /* 167591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 167594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 167597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167605 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1634:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, 0:{ *:[i32] })
     /* 167605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 167608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 167610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 167612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167615 */     GIR_RootConstrainSelectedInstOperands,
     /* 167616 */     // GIR_Coverage, 3546,
     /* 167616 */     GIR_EraseRootFromParent_Done,
     /* 167617 */   // Label 3118: @167617
     /* 167617 */   GIM_Try, /*On fail goto*//*Label 3119*/ GIMT_Encode4(167673), // Rule ID 3550 //
     /* 167622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 167633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 167636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167644 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1636:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (PMOV_ZIP_B:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i64] }, PPR8:{ *:[nxv16i1] }:$Pn)
     /* 167644 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167647 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167651 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167656 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_B),
     /* 167661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167666 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167669 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167671 */     GIR_RootConstrainSelectedInstOperands,
     /* 167672 */     // GIR_Coverage, 3550,
     /* 167672 */     GIR_EraseRootFromParent_Done,
     /* 167673 */   // Label 3119: @167673
     /* 167673 */   GIM_Try, /*On fail goto*//*Label 3120*/ GIMT_Encode4(167729), // Rule ID 3551 //
     /* 167678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 167689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 167692 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167700 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1636:{ *:[iPTR] }, PPR16:{ *:[nxv8i1] }:$Pn)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 167700 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167703 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167707 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167712 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 167717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167725 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167727 */     GIR_RootConstrainSelectedInstOperands,
     /* 167728 */     // GIR_Coverage, 3551,
     /* 167728 */     GIR_EraseRootFromParent_Done,
     /* 167729 */   // Label 3120: @167729
     /* 167729 */   GIM_Try, /*On fail goto*//*Label 3121*/ GIMT_Encode4(167785), // Rule ID 3552 //
     /* 167734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167742 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 167745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 167748 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167752 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167756 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1636:{ *:[iPTR] }, PPR32:{ *:[nxv4i1] }:$Pn)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 167756 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167759 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167763 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167768 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 167773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167775 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167783 */     GIR_RootConstrainSelectedInstOperands,
     /* 167784 */     // GIR_Coverage, 3552,
     /* 167784 */     GIR_EraseRootFromParent_Done,
     /* 167785 */   // Label 3121: @167785
     /* 167785 */   GIM_Try, /*On fail goto*//*Label 3122*/ GIMT_Encode4(167841), // Rule ID 3553 //
     /* 167790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 167793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_zeroing),
     /* 167798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 167801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 167804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 167808 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 167812 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1636:{ *:[iPTR] }, PPR64:{ *:[nxv2i1] }:$Pn)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), 0:{ *:[i32] }, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 167812 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 167815 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 167819 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167824 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 167829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 167831 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 167834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 167837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 167839 */     GIR_RootConstrainSelectedInstOperands,
     /* 167840 */     // GIR_Coverage, 3553,
     /* 167840 */     GIR_EraseRootFromParent_Done,
     /* 167841 */   // Label 3122: @167841
     /* 167841 */   GIM_Try, /*On fail goto*//*Label 3123*/ GIMT_Encode4(167874), // Rule ID 4008 //
     /* 167846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls),
     /* 167851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 167857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167865 */     // (intrinsic_wo_chain:{ *:[i32] } 508:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn)  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 167865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 167868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167872 */     GIR_RootConstrainSelectedInstOperands,
     /* 167873 */     // GIR_Coverage, 4008,
     /* 167873 */     GIR_EraseRootFromParent_Done,
     /* 167874 */   // Label 3123: @167874
     /* 167874 */   GIM_Try, /*On fail goto*//*Label 3124*/ GIMT_Encode4(167939), // Rule ID 4009 //
     /* 167879 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_cls64),
     /* 167884 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 167887 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167898 */     // (intrinsic_wo_chain:{ *:[i32] } 509:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rm)  =>  (EXTRACT_SUBREG:{ *:[i32] } (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rm), sub_32:{ *:[i32] })
     /* 167898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 167901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 167905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 167910 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 167914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 167916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 167919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 167921 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::sub_32),
     /* 167928 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 167933 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 167938 */     // GIR_Coverage, 4009,
     /* 167938 */     GIR_EraseRootFromParent_Done,
     /* 167939 */   // Label 3124: @167939
     /* 167939 */   GIM_Try, /*On fail goto*//*Label 3125*/ GIMT_Encode4(167972), // Rule ID 4815 //
     /* 167944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32z),
     /* 167949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167963 */     // (intrinsic_wo_chain:{ *:[v1f64] } 643:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32ZDr),
     /* 167966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 167968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 167970 */     GIR_RootConstrainSelectedInstOperands,
     /* 167971 */     // GIR_Coverage, 4815,
     /* 167971 */     GIR_EraseRootFromParent_Done,
     /* 167972 */   // Label 3125: @167972
     /* 167972 */   GIM_Try, /*On fail goto*//*Label 3126*/ GIMT_Encode4(168005), // Rule ID 4816 //
     /* 167977 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64z),
     /* 167982 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 167985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 167988 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 167996 */     // (intrinsic_wo_chain:{ *:[v1f64] } 645:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64ZDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 167996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64ZDr),
     /* 167999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168003 */     GIR_RootConstrainSelectedInstOperands,
     /* 168004 */     // GIR_Coverage, 4816,
     /* 168004 */     GIR_EraseRootFromParent_Done,
     /* 168005 */   // Label 3126: @168005
     /* 168005 */   GIM_Try, /*On fail goto*//*Label 3127*/ GIMT_Encode4(168038), // Rule ID 4817 //
     /* 168010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint32x),
     /* 168015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168029 */     // (intrinsic_wo_chain:{ *:[v1f64] } 642:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT32XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT32XDr),
     /* 168032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168036 */     GIR_RootConstrainSelectedInstOperands,
     /* 168037 */     // GIR_Coverage, 4817,
     /* 168037 */     GIR_EraseRootFromParent_Done,
     /* 168038 */   // Label 3127: @168038
     /* 168038 */   GIM_Try, /*On fail goto*//*Label 3128*/ GIMT_Encode4(168071), // Rule ID 4818 //
     /* 168043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frint64x),
     /* 168048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168062 */     // (intrinsic_wo_chain:{ *:[v1f64] } 644:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRINT64XDr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRINT64XDr),
     /* 168065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168069 */     GIR_RootConstrainSelectedInstOperands,
     /* 168070 */     // GIR_Coverage, 4818,
     /* 168070 */     GIR_EraseRootFromParent_Done,
     /* 168071 */   // Label 3128: @168071
     /* 168071 */   GIM_Try, /*On fail goto*//*Label 3129*/ GIMT_Encode4(168104), // Rule ID 4932 //
     /* 168076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvthf2fp),
     /* 168081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 168084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 168087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168095 */     // (intrinsic_wo_chain:{ *:[v4f32] } 774:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4i16] }:$Rn)
     /* 168095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 168098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168102 */     GIR_RootConstrainSelectedInstOperands,
     /* 168103 */     // GIR_Coverage, 4932,
     /* 168103 */     GIR_EraseRootFromParent_Done,
     /* 168104 */   // Label 3129: @168104
     /* 168104 */   GIM_Try, /*On fail goto*//*Label 3130*/ GIMT_Encode4(168137), // Rule ID 4942 //
     /* 168109 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2hf),
     /* 168114 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 168117 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168128 */     // (intrinsic_wo_chain:{ *:[v4i16] } 771:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4i16] } V128:{ *:[v4f32] }:$Rn)
     /* 168128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 168131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168135 */     GIR_RootConstrainSelectedInstOperands,
     /* 168136 */     // GIR_Coverage, 4942,
     /* 168136 */     GIR_EraseRootFromParent_Done,
     /* 168137 */   // Label 3130: @168137
     /* 168137 */   GIM_Try, /*On fail goto*//*Label 3131*/ GIMT_Encode4(168173), // Rule ID 5263 //
     /* 168142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 168145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqneg),
     /* 168150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168164 */     // (intrinsic_wo_chain:{ *:[v1i64] } 692:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn)  =>  (SQNEGv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 168164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEGv1i64),
     /* 168167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168171 */     GIR_RootConstrainSelectedInstOperands,
     /* 168172 */     // GIR_Coverage, 5263,
     /* 168172 */     GIR_EraseRootFromParent_Done,
     /* 168173 */   // Label 3131: @168173
     /* 168173 */   GIM_Try, /*On fail goto*//*Label 3132*/ GIMT_Encode4(168206), // Rule ID 5266 //
     /* 168178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtas),
     /* 168183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168197 */     // (intrinsic_wo_chain:{ *:[v1i64] } 590:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTASv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASv1i64),
     /* 168200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168204 */     GIR_RootConstrainSelectedInstOperands,
     /* 168205 */     // GIR_Coverage, 5266,
     /* 168205 */     GIR_EraseRootFromParent_Done,
     /* 168206 */   // Label 3132: @168206
     /* 168206 */   GIM_Try, /*On fail goto*//*Label 3133*/ GIMT_Encode4(168239), // Rule ID 5267 //
     /* 168211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtau),
     /* 168216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168222 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168226 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168230 */     // (intrinsic_wo_chain:{ *:[v1i64] } 591:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTAUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168230 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUv1i64),
     /* 168233 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168235 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168237 */     GIR_RootConstrainSelectedInstOperands,
     /* 168238 */     // GIR_Coverage, 5267,
     /* 168238 */     GIR_EraseRootFromParent_Done,
     /* 168239 */   // Label 3133: @168239
     /* 168239 */   GIM_Try, /*On fail goto*//*Label 3134*/ GIMT_Encode4(168272), // Rule ID 5268 //
     /* 168244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtms),
     /* 168249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168263 */     // (intrinsic_wo_chain:{ *:[v1i64] } 592:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSv1i64),
     /* 168266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168270 */     GIR_RootConstrainSelectedInstOperands,
     /* 168271 */     // GIR_Coverage, 5268,
     /* 168271 */     GIR_EraseRootFromParent_Done,
     /* 168272 */   // Label 3134: @168272
     /* 168272 */   GIM_Try, /*On fail goto*//*Label 3135*/ GIMT_Encode4(168305), // Rule ID 5269 //
     /* 168277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtmu),
     /* 168282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168296 */     // (intrinsic_wo_chain:{ *:[v1i64] } 593:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTMUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUv1i64),
     /* 168299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168303 */     GIR_RootConstrainSelectedInstOperands,
     /* 168304 */     // GIR_Coverage, 5269,
     /* 168304 */     GIR_EraseRootFromParent_Done,
     /* 168305 */   // Label 3135: @168305
     /* 168305 */   GIM_Try, /*On fail goto*//*Label 3136*/ GIMT_Encode4(168338), // Rule ID 5270 //
     /* 168310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtns),
     /* 168315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168325 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168329 */     // (intrinsic_wo_chain:{ *:[v1i64] } 594:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNSv1i64),
     /* 168332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168336 */     GIR_RootConstrainSelectedInstOperands,
     /* 168337 */     // GIR_Coverage, 5270,
     /* 168337 */     GIR_EraseRootFromParent_Done,
     /* 168338 */   // Label 3136: @168338
     /* 168338 */   GIM_Try, /*On fail goto*//*Label 3137*/ GIMT_Encode4(168371), // Rule ID 5271 //
     /* 168343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtnu),
     /* 168348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168362 */     // (intrinsic_wo_chain:{ *:[v1i64] } 595:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTNUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNUv1i64),
     /* 168365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168369 */     GIR_RootConstrainSelectedInstOperands,
     /* 168370 */     // GIR_Coverage, 5271,
     /* 168370 */     GIR_EraseRootFromParent_Done,
     /* 168371 */   // Label 3137: @168371
     /* 168371 */   GIM_Try, /*On fail goto*//*Label 3138*/ GIMT_Encode4(168404), // Rule ID 5272 //
     /* 168376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtps),
     /* 168381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168395 */     // (intrinsic_wo_chain:{ *:[v1i64] } 596:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSv1i64),
     /* 168398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168402 */     GIR_RootConstrainSelectedInstOperands,
     /* 168403 */     // GIR_Coverage, 5272,
     /* 168403 */     GIR_EraseRootFromParent_Done,
     /* 168404 */   // Label 3138: @168404
     /* 168404 */   GIM_Try, /*On fail goto*//*Label 3139*/ GIMT_Encode4(168437), // Rule ID 5273 //
     /* 168409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtpu),
     /* 168414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168428 */     // (intrinsic_wo_chain:{ *:[v1i64] } 597:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTPUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUv1i64),
     /* 168431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168435 */     GIR_RootConstrainSelectedInstOperands,
     /* 168436 */     // GIR_Coverage, 5273,
     /* 168436 */     GIR_EraseRootFromParent_Done,
     /* 168437 */   // Label 3139: @168437
     /* 168437 */   GIM_Try, /*On fail goto*//*Label 3140*/ GIMT_Encode4(168470), // Rule ID 5274 //
     /* 168442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 168447 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168450 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168461 */     // (intrinsic_wo_chain:{ *:[v1i64] } 599:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZSv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 168464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168468 */     GIR_RootConstrainSelectedInstOperands,
     /* 168469 */     // GIR_Coverage, 5274,
     /* 168469 */     GIR_EraseRootFromParent_Done,
     /* 168470 */   // Label 3140: @168470
     /* 168470 */   GIM_Try, /*On fail goto*//*Label 3141*/ GIMT_Encode4(168503), // Rule ID 5275 //
     /* 168475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 168480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168486 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168490 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168494 */     // (intrinsic_wo_chain:{ *:[v1i64] } 600:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCVTZUv1i64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 168497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168501 */     GIR_RootConstrainSelectedInstOperands,
     /* 168502 */     // GIR_Coverage, 5275,
     /* 168502 */     GIR_EraseRootFromParent_Done,
     /* 168503 */   // Label 3141: @168503
     /* 168503 */   GIM_Try, /*On fail goto*//*Label 3142*/ GIMT_Encode4(168536), // Rule ID 5276 //
     /* 168508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168523 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168527 */     // (intrinsic_wo_chain:{ *:[f16] } 639:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1f16),
     /* 168530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168534 */     GIR_RootConstrainSelectedInstOperands,
     /* 168535 */     // GIR_Coverage, 5276,
     /* 168535 */     GIR_EraseRootFromParent_Done,
     /* 168536 */   // Label 3142: @168536
     /* 168536 */   GIM_Try, /*On fail goto*//*Label 3143*/ GIMT_Encode4(168569), // Rule ID 5277 //
     /* 168541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168560 */     // (intrinsic_wo_chain:{ *:[f32] } 639:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i32),
     /* 168563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168565 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168567 */     GIR_RootConstrainSelectedInstOperands,
     /* 168568 */     // GIR_Coverage, 5277,
     /* 168568 */     GIR_EraseRootFromParent_Done,
     /* 168569 */   // Label 3143: @168569
     /* 168569 */   GIM_Try, /*On fail goto*//*Label 3144*/ GIMT_Encode4(168602), // Rule ID 5278 //
     /* 168574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168593 */     // (intrinsic_wo_chain:{ *:[f64] } 639:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168600 */     GIR_RootConstrainSelectedInstOperands,
     /* 168601 */     // GIR_Coverage, 5278,
     /* 168601 */     GIR_EraseRootFromParent_Done,
     /* 168602 */   // Label 3144: @168602
     /* 168602 */   GIM_Try, /*On fail goto*//*Label 3145*/ GIMT_Encode4(168635), // Rule ID 5279 //
     /* 168607 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpe),
     /* 168612 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168626 */     // (intrinsic_wo_chain:{ *:[v1f64] } 639:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRECPEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPEv1i64),
     /* 168629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168633 */     GIR_RootConstrainSelectedInstOperands,
     /* 168634 */     // GIR_Coverage, 5279,
     /* 168634 */     GIR_EraseRootFromParent_Done,
     /* 168635 */   // Label 3145: @168635
     /* 168635 */   GIM_Try, /*On fail goto*//*Label 3146*/ GIMT_Encode4(168668), // Rule ID 5291 //
     /* 168640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168659 */     // (intrinsic_wo_chain:{ *:[f16] } 641:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRECPXv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1f16),
     /* 168662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168666 */     GIR_RootConstrainSelectedInstOperands,
     /* 168667 */     // GIR_Coverage, 5291,
     /* 168667 */     GIR_EraseRootFromParent_Done,
     /* 168668 */   // Label 3146: @168668
     /* 168668 */   GIM_Try, /*On fail goto*//*Label 3147*/ GIMT_Encode4(168701), // Rule ID 5292 //
     /* 168673 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168678 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168681 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168688 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168692 */     // (intrinsic_wo_chain:{ *:[f32] } 641:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRECPXv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i32),
     /* 168695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168699 */     GIR_RootConstrainSelectedInstOperands,
     /* 168700 */     // GIR_Coverage, 5292,
     /* 168700 */     GIR_EraseRootFromParent_Done,
     /* 168701 */   // Label 3147: @168701
     /* 168701 */   GIM_Try, /*On fail goto*//*Label 3148*/ GIMT_Encode4(168734), // Rule ID 5293 //
     /* 168706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecpx),
     /* 168711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168721 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168725 */     // (intrinsic_wo_chain:{ *:[f64] } 641:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRECPXv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPXv1i64),
     /* 168728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168732 */     GIR_RootConstrainSelectedInstOperands,
     /* 168733 */     // GIR_Coverage, 5293,
     /* 168733 */     GIR_EraseRootFromParent_Done,
     /* 168734 */   // Label 3148: @168734
     /* 168734 */   GIM_Try, /*On fail goto*//*Label 3149*/ GIMT_Encode4(168767), // Rule ID 5294 //
     /* 168739 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168744 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 168747 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 168750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 168758 */     // (intrinsic_wo_chain:{ *:[f16] } 646:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn)  =>  (FRSQRTEv1f16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 168758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1f16),
     /* 168761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168765 */     GIR_RootConstrainSelectedInstOperands,
     /* 168766 */     // GIR_Coverage, 5294,
     /* 168766 */     GIR_EraseRootFromParent_Done,
     /* 168767 */   // Label 3149: @168767
     /* 168767 */   GIM_Try, /*On fail goto*//*Label 3150*/ GIMT_Encode4(168800), // Rule ID 5295 //
     /* 168772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 168783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168787 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168791 */     // (intrinsic_wo_chain:{ *:[f32] } 646:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn)  =>  (FRSQRTEv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 168791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i32),
     /* 168794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168798 */     GIR_RootConstrainSelectedInstOperands,
     /* 168799 */     // GIR_Coverage, 5295,
     /* 168799 */     GIR_EraseRootFromParent_Done,
     /* 168800 */   // Label 3150: @168800
     /* 168800 */   GIM_Try, /*On fail goto*//*Label 3151*/ GIMT_Encode4(168833), // Rule ID 5296 //
     /* 168805 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168810 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168813 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168824 */     // (intrinsic_wo_chain:{ *:[f64] } 646:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 168824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168829 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168831 */     GIR_RootConstrainSelectedInstOperands,
     /* 168832 */     // GIR_Coverage, 5296,
     /* 168832 */     GIR_EraseRootFromParent_Done,
     /* 168833 */   // Label 3151: @168833
     /* 168833 */   GIM_Try, /*On fail goto*//*Label 3152*/ GIMT_Encode4(168866), // Rule ID 5297 //
     /* 168838 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrte),
     /* 168843 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168846 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 168849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168857 */     // (intrinsic_wo_chain:{ *:[v1f64] } 646:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FRSQRTEv1i64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 168857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTEv1i64),
     /* 168860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168864 */     GIR_RootConstrainSelectedInstOperands,
     /* 168865 */     // GIR_Coverage, 5297,
     /* 168865 */     GIR_EraseRootFromParent_Done,
     /* 168866 */   // Label 3152: @168866
     /* 168866 */   GIM_Try, /*On fail goto*//*Label 3153*/ GIMT_Encode4(168899), // Rule ID 5627 //
     /* 168871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 168882 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168890 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 168890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 168897 */     GIR_RootConstrainSelectedInstOperands,
     /* 168898 */     // GIR_Coverage, 5627,
     /* 168898 */     GIR_EraseRootFromParent_Done,
     /* 168899 */   // Label 3153: @168899
     /* 168899 */   GIM_Try, /*On fail goto*//*Label 3154*/ GIMT_Encode4(168984), // Rule ID 5628 //
     /* 168904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 168912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 168915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 168919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168923 */     // (intrinsic_wo_chain:{ *:[f32] } 587:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 168923 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 168926 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 168930 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168935 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168939 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 168943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 168945 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 168948 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 168952 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 168957 */     GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 168964 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 168969 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 168974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 168977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 168979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 168982 */     GIR_RootConstrainSelectedInstOperands,
     /* 168983 */     // GIR_Coverage, 5628,
     /* 168983 */     GIR_EraseRootFromParent_Done,
     /* 168984 */   // Label 3154: @168984
     /* 168984 */   GIM_Try, /*On fail goto*//*Label 3155*/ GIMT_Encode4(169017), // Rule ID 5629 //
     /* 168989 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddv),
     /* 168994 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 168997 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169008 */     // (intrinsic_wo_chain:{ *:[f64] } 587:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 169011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169013 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169015 */     GIR_RootConstrainSelectedInstOperands,
     /* 169016 */     // GIR_Coverage, 5629,
     /* 169016 */     GIR_EraseRootFromParent_Done,
     /* 169017 */   // Label 3155: @169017
     /* 169017 */   GIM_Try, /*On fail goto*//*Label 3156*/ GIMT_Encode4(169050), // Rule ID 5631 //
     /* 169022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169041 */     // (intrinsic_wo_chain:{ *:[f32] } 604:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 169044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169048 */     GIR_RootConstrainSelectedInstOperands,
     /* 169049 */     // GIR_Coverage, 5631,
     /* 169049 */     GIR_EraseRootFromParent_Done,
     /* 169050 */   // Label 3156: @169050
     /* 169050 */   GIM_Try, /*On fail goto*//*Label 3157*/ GIMT_Encode4(169083), // Rule ID 5633 //
     /* 169055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmv),
     /* 169060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169066 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169070 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169074 */     // (intrinsic_wo_chain:{ *:[f64] } 604:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 169077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169081 */     GIR_RootConstrainSelectedInstOperands,
     /* 169082 */     // GIR_Coverage, 5633,
     /* 169082 */     GIR_EraseRootFromParent_Done,
     /* 169083 */   // Label 3157: @169083
     /* 169083 */   GIM_Try, /*On fail goto*//*Label 3158*/ GIMT_Encode4(169116), // Rule ID 5635 //
     /* 169088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169107 */     // (intrinsic_wo_chain:{ *:[f32] } 606:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 169110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169114 */     GIR_RootConstrainSelectedInstOperands,
     /* 169115 */     // GIR_Coverage, 5635,
     /* 169115 */     GIR_EraseRootFromParent_Done,
     /* 169116 */   // Label 3158: @169116
     /* 169116 */   GIM_Try, /*On fail goto*//*Label 3159*/ GIMT_Encode4(169149), // Rule ID 5637 //
     /* 169121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxv),
     /* 169126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169132 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169136 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169140 */     // (intrinsic_wo_chain:{ *:[f64] } 606:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 169143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169147 */     GIR_RootConstrainSelectedInstOperands,
     /* 169148 */     // GIR_Coverage, 5637,
     /* 169148 */     GIR_EraseRootFromParent_Done,
     /* 169149 */   // Label 3159: @169149
     /* 169149 */   GIM_Try, /*On fail goto*//*Label 3160*/ GIMT_Encode4(169182), // Rule ID 5639 //
     /* 169154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169173 */     // (intrinsic_wo_chain:{ *:[f32] } 610:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 169176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169180 */     GIR_RootConstrainSelectedInstOperands,
     /* 169181 */     // GIR_Coverage, 5639,
     /* 169181 */     GIR_EraseRootFromParent_Done,
     /* 169182 */   // Label 3160: @169182
     /* 169182 */   GIM_Try, /*On fail goto*//*Label 3161*/ GIMT_Encode4(169215), // Rule ID 5641 //
     /* 169187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmv),
     /* 169192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169206 */     // (intrinsic_wo_chain:{ *:[f64] } 610:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 169209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169213 */     GIR_RootConstrainSelectedInstOperands,
     /* 169214 */     // GIR_Coverage, 5641,
     /* 169214 */     GIR_EraseRootFromParent_Done,
     /* 169215 */   // Label 3161: @169215
     /* 169215 */   GIM_Try, /*On fail goto*//*Label 3162*/ GIMT_Encode4(169248), // Rule ID 5643 //
     /* 169220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169239 */     // (intrinsic_wo_chain:{ *:[f32] } 612:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 169239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 169242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169246 */     GIR_RootConstrainSelectedInstOperands,
     /* 169247 */     // GIR_Coverage, 5643,
     /* 169247 */     GIR_EraseRootFromParent_Done,
     /* 169248 */   // Label 3162: @169248
     /* 169248 */   GIM_Try, /*On fail goto*//*Label 3163*/ GIMT_Encode4(169281), // Rule ID 5645 //
     /* 169253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminv),
     /* 169258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169272 */     // (intrinsic_wo_chain:{ *:[f64] } 612:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 169272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 169275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169279 */     GIR_RootConstrainSelectedInstOperands,
     /* 169280 */     // GIR_Coverage, 5645,
     /* 169280 */     GIR_EraseRootFromParent_Done,
     /* 169281 */   // Label 3163: @169281
     /* 169281 */   GIM_Try, /*On fail goto*//*Label 3164*/ GIMT_Encode4(169314), // Rule ID 13200 //
     /* 169286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169305 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169312 */     GIR_RootConstrainSelectedInstOperands,
     /* 169313 */     // GIR_Coverage, 13200,
     /* 169313 */     GIR_EraseRootFromParent_Done,
     /* 169314 */   // Label 3164: @169314
     /* 169314 */   GIM_Try, /*On fail goto*//*Label 3165*/ GIMT_Encode4(169347), // Rule ID 13202 //
     /* 169319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169338 */     // (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169345 */     GIR_RootConstrainSelectedInstOperands,
     /* 169346 */     // GIR_Coverage, 13202,
     /* 169346 */     GIR_EraseRootFromParent_Done,
     /* 169347 */   // Label 3165: @169347
     /* 169347 */   GIM_Try, /*On fail goto*//*Label 3166*/ GIMT_Encode4(169380), // Rule ID 13204 //
     /* 169352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169367 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169371 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169378 */     GIR_RootConstrainSelectedInstOperands,
     /* 169379 */     // GIR_Coverage, 13204,
     /* 169379 */     GIR_EraseRootFromParent_Done,
     /* 169380 */   // Label 3166: @169380
     /* 169380 */   GIM_Try, /*On fail goto*//*Label 3167*/ GIMT_Encode4(169413), // Rule ID 13206 //
     /* 169385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169396 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169404 */     // (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169411 */     GIR_RootConstrainSelectedInstOperands,
     /* 169412 */     // GIR_Coverage, 13206,
     /* 169412 */     GIR_EraseRootFromParent_Done,
     /* 169413 */   // Label 3167: @169413
     /* 169413 */   GIM_Try, /*On fail goto*//*Label 3168*/ GIMT_Encode4(169528), // Rule ID 13207 //
     /* 169418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169437 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169437 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169440 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169444 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169449 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169455 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169458 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169462 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169481 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169484 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169487 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169490 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169495 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169500 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169510 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169527 */     // GIR_Coverage, 13207,
     /* 169527 */     GIR_EraseRootFromParent_Done,
     /* 169528 */   // Label 3168: @169528
     /* 169528 */   GIM_Try, /*On fail goto*//*Label 3169*/ GIMT_Encode4(169561), // Rule ID 13209 //
     /* 169533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 169544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169552 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 169552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 169555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169559 */     GIR_RootConstrainSelectedInstOperands,
     /* 169560 */     // GIR_Coverage, 13209,
     /* 169560 */     GIR_EraseRootFromParent_Done,
     /* 169561 */   // Label 3169: @169561
     /* 169561 */   GIM_Try, /*On fail goto*//*Label 3170*/ GIMT_Encode4(169594), // Rule ID 13211 //
     /* 169566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 169574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 169577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 169581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169585 */     // (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 169585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 169588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169592 */     GIR_RootConstrainSelectedInstOperands,
     /* 169593 */     // GIR_Coverage, 13211,
     /* 169593 */     GIR_EraseRootFromParent_Done,
     /* 169594 */   // Label 3170: @169594
     /* 169594 */   GIM_Try, /*On fail goto*//*Label 3171*/ GIMT_Encode4(169627), // Rule ID 13213 //
     /* 169599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 169610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169618 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 169618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 169621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169625 */     GIR_RootConstrainSelectedInstOperands,
     /* 169626 */     // GIR_Coverage, 13213,
     /* 169626 */     GIR_EraseRootFromParent_Done,
     /* 169627 */   // Label 3171: @169627
     /* 169627 */   GIM_Try, /*On fail goto*//*Label 3172*/ GIMT_Encode4(169660), // Rule ID 13215 //
     /* 169632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 169640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 169643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 169647 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169651 */     // (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 169651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 169654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 169656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 169658 */     GIR_RootConstrainSelectedInstOperands,
     /* 169659 */     // GIR_Coverage, 13215,
     /* 169659 */     GIR_EraseRootFromParent_Done,
     /* 169660 */   // Label 3172: @169660
     /* 169660 */   GIM_Try, /*On fail goto*//*Label 3173*/ GIMT_Encode4(169775), // Rule ID 13216 //
     /* 169665 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 169670 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 169676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169680 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169684 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169684 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 169687 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 169691 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169696 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169700 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169702 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169705 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169709 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169714 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169716 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169719 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169723 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169728 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169731 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169734 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 169737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169742 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169747 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169774 */     // GIR_Coverage, 13216,
     /* 169774 */     GIR_EraseRootFromParent_Done,
     /* 169775 */   // Label 3173: @169775
     /* 169775 */   GIM_Try, /*On fail goto*//*Label 3174*/ GIMT_Encode4(169894), // Rule ID 13217 //
     /* 169780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 169788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 169791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169799 */     // (intrinsic_wo_chain:{ *:[i32] } 669:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 169799 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169802 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 169806 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169811 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169815 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169819 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169821 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 169824 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169828 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169833 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 169838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169847 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169850 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169866 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 169883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 169888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169893 */     // GIR_Coverage, 13217,
     /* 169893 */     GIR_EraseRootFromParent_Done,
     /* 169894 */   // Label 3174: @169894
     /* 169894 */   GIM_Try, /*On fail goto*//*Label 3175*/ GIMT_Encode4(170009), // Rule ID 13218 //
     /* 169899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 169904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 169907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 169910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169918 */     // (intrinsic_wo_chain:{ *:[i64] } 669:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 169918 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 169921 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 169925 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169930 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 169934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 169936 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 169939 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 169943 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169948 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 169950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 169953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 169957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 169962 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 169965 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 169968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 169971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 169981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 169986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 169989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 169991 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 169998 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170003 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170008 */     // GIR_Coverage, 13218,
     /* 170008 */     GIR_EraseRootFromParent_Done,
     /* 170009 */   // Label 3175: @170009
     /* 170009 */   GIM_Try, /*On fail goto*//*Label 3176*/ GIMT_Encode4(170128), // Rule ID 13219 //
     /* 170014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170033 */     // (intrinsic_wo_chain:{ *:[i32] } 734:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170033 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170036 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 170040 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170045 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170049 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170055 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170058 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170062 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170067 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170081 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170084 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170087 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170090 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170110 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170127 */     // GIR_Coverage, 13219,
     /* 170127 */     GIR_EraseRootFromParent_Done,
     /* 170128 */   // Label 3176: @170128
     /* 170128 */   GIM_Try, /*On fail goto*//*Label 3177*/ GIMT_Encode4(170243), // Rule ID 13220 //
     /* 170133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 170138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 170141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 170144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170152 */     // (intrinsic_wo_chain:{ *:[i64] } 734:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i64] } (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn), dsub:{ *:[i32] }), dsub:{ *:[i32] })
     /* 170152 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170155 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 170159 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170164 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170168 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 170173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170182 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170184 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 170187 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170191 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170196 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170199 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170202 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170205 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170210 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170215 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170220 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170223 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170225 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 170232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170242 */     // GIR_Coverage, 13220,
     /* 170242 */     GIR_EraseRootFromParent_Done,
     /* 170243 */   // Label 3177: @170243
     /* 170243 */   GIM_Try, /*On fail goto*//*Label 3178*/ GIMT_Encode4(170276), // Rule ID 13222 //
     /* 170248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170267 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 170270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170274 */     GIR_RootConstrainSelectedInstOperands,
     /* 170275 */     // GIR_Coverage, 13222,
     /* 170275 */     GIR_EraseRootFromParent_Done,
     /* 170276 */   // Label 3178: @170276
     /* 170276 */   GIM_Try, /*On fail goto*//*Label 3179*/ GIMT_Encode4(170309), // Rule ID 13224 //
     /* 170281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170296 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170300 */     // (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 170303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170305 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170307 */     GIR_RootConstrainSelectedInstOperands,
     /* 170308 */     // GIR_Coverage, 13224,
     /* 170308 */     GIR_EraseRootFromParent_Done,
     /* 170309 */   // Label 3179: @170309
     /* 170309 */   GIM_Try, /*On fail goto*//*Label 3180*/ GIMT_Encode4(170342), // Rule ID 13226 //
     /* 170314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170333 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 170336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170340 */     GIR_RootConstrainSelectedInstOperands,
     /* 170341 */     // GIR_Coverage, 13226,
     /* 170341 */     GIR_EraseRootFromParent_Done,
     /* 170342 */   // Label 3180: @170342
     /* 170342 */   GIM_Try, /*On fail goto*//*Label 3181*/ GIMT_Encode4(170375), // Rule ID 13228 //
     /* 170347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170362 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170366 */     // (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 170369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170373 */     GIR_RootConstrainSelectedInstOperands,
     /* 170374 */     // GIR_Coverage, 13228,
     /* 170374 */     GIR_EraseRootFromParent_Done,
     /* 170375 */   // Label 3181: @170375
     /* 170375 */   GIM_Try, /*On fail goto*//*Label 3182*/ GIMT_Encode4(170490), // Rule ID 13229 //
     /* 170380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170395 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170399 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170399 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170402 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 170406 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170411 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170415 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170417 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170420 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170424 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170429 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170431 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170434 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170438 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170443 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170446 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170452 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170472 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170479 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170484 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170489 */     // GIR_Coverage, 13229,
     /* 170489 */     GIR_EraseRootFromParent_Done,
     /* 170490 */   // Label 3182: @170490
     /* 170490 */   GIM_Try, /*On fail goto*//*Label 3183*/ GIMT_Encode4(170609), // Rule ID 13230 //
     /* 170495 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 170500 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170503 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170514 */     // (intrinsic_wo_chain:{ *:[i32] } 679:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170514 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170517 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 170521 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170526 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170530 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170534 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170536 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170539 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170543 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170565 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170591 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170598 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170603 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170608 */     // GIR_Coverage, 13230,
     /* 170608 */     GIR_EraseRootFromParent_Done,
     /* 170609 */   // Label 3183: @170609
     /* 170609 */   GIM_Try, /*On fail goto*//*Label 3184*/ GIMT_Encode4(170642), // Rule ID 13232 //
     /* 170614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170633 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 170636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170640 */     GIR_RootConstrainSelectedInstOperands,
     /* 170641 */     // GIR_Coverage, 13232,
     /* 170641 */     GIR_EraseRootFromParent_Done,
     /* 170642 */   // Label 3184: @170642
     /* 170642 */   GIM_Try, /*On fail goto*//*Label 3185*/ GIMT_Encode4(170675), // Rule ID 13234 //
     /* 170647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 170658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170662 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170666 */     // (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 170666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 170669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170673 */     GIR_RootConstrainSelectedInstOperands,
     /* 170674 */     // GIR_Coverage, 13234,
     /* 170674 */     GIR_EraseRootFromParent_Done,
     /* 170675 */   // Label 3185: @170675
     /* 170675 */   GIM_Try, /*On fail goto*//*Label 3186*/ GIMT_Encode4(170708), // Rule ID 13236 //
     /* 170680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 170691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170695 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170699 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 170699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 170702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170706 */     GIR_RootConstrainSelectedInstOperands,
     /* 170707 */     // GIR_Coverage, 13236,
     /* 170707 */     GIR_EraseRootFromParent_Done,
     /* 170708 */   // Label 3186: @170708
     /* 170708 */   GIM_Try, /*On fail goto*//*Label 3187*/ GIMT_Encode4(170741), // Rule ID 13238 //
     /* 170713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 170721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 170724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 170728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170732 */     // (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 170732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 170735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 170737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 170739 */     GIR_RootConstrainSelectedInstOperands,
     /* 170740 */     // GIR_Coverage, 13238,
     /* 170740 */     GIR_EraseRootFromParent_Done,
     /* 170741 */   // Label 3187: @170741
     /* 170741 */   GIM_Try, /*On fail goto*//*Label 3188*/ GIMT_Encode4(170856), // Rule ID 13239 //
     /* 170746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 170757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170765 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170765 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 170768 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 170772 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170777 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170781 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170783 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170786 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170790 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170795 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170797 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170800 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170804 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170809 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170812 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 170818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170828 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170838 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170855 */     // GIR_Coverage, 13239,
     /* 170855 */     GIR_EraseRootFromParent_Done,
     /* 170856 */   // Label 3188: @170856
     /* 170856 */   GIM_Try, /*On fail goto*//*Label 3189*/ GIMT_Encode4(170975), // Rule ID 13240 //
     /* 170861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 170866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 170869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 170872 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170880 */     // (intrinsic_wo_chain:{ *:[i32] } 682:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 170880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 170883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 170887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170892 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170896 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 170900 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 170902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 170905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 170909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 170916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 170919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 170923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 170928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 170931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 170934 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 170937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170947 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 170955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 170957 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 170964 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 170969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 170974 */     // GIR_Coverage, 13240,
     /* 170974 */     GIR_EraseRootFromParent_Done,
     /* 170975 */   // Label 3189: @170975
     /* 170975 */   GIM_Try, /*On fail goto*//*Label 3190*/ GIMT_Encode4(171008), // Rule ID 13242 //
     /* 170980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 170985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 170988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 170991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 170995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 170999 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 170999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 171002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171006 */     GIR_RootConstrainSelectedInstOperands,
     /* 171007 */     // GIR_Coverage, 13242,
     /* 171007 */     GIR_EraseRootFromParent_Done,
     /* 171008 */   // Label 3190: @171008
     /* 171008 */   GIM_Try, /*On fail goto*//*Label 3191*/ GIMT_Encode4(171041), // Rule ID 13244 //
     /* 171013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171032 */     // (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 171035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171039 */     GIR_RootConstrainSelectedInstOperands,
     /* 171040 */     // GIR_Coverage, 13244,
     /* 171040 */     GIR_EraseRootFromParent_Done,
     /* 171041 */   // Label 3191: @171041
     /* 171041 */   GIM_Try, /*On fail goto*//*Label 3192*/ GIMT_Encode4(171074), // Rule ID 13246 //
     /* 171046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171065 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 171068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171072 */     GIR_RootConstrainSelectedInstOperands,
     /* 171073 */     // GIR_Coverage, 13246,
     /* 171073 */     GIR_EraseRootFromParent_Done,
     /* 171074 */   // Label 3192: @171074
     /* 171074 */   GIM_Try, /*On fail goto*//*Label 3193*/ GIMT_Encode4(171107), // Rule ID 13248 //
     /* 171079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171098 */     // (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 171101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171103 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171105 */     GIR_RootConstrainSelectedInstOperands,
     /* 171106 */     // GIR_Coverage, 13248,
     /* 171106 */     GIR_EraseRootFromParent_Done,
     /* 171107 */   // Label 3193: @171107
     /* 171107 */   GIM_Try, /*On fail goto*//*Label 3194*/ GIMT_Encode4(171222), // Rule ID 13249 //
     /* 171112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171127 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171131 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171131 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171134 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 171138 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171143 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171149 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171152 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171156 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171161 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171163 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171166 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171170 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171175 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171178 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171181 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171184 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171189 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171194 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171204 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171216 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171221 */     // GIR_Coverage, 13249,
     /* 171221 */     GIR_EraseRootFromParent_Done,
     /* 171222 */   // Label 3194: @171222
     /* 171222 */   GIM_Try, /*On fail goto*//*Label 3195*/ GIMT_Encode4(171341), // Rule ID 13250 //
     /* 171227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 171232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171246 */     // (intrinsic_wo_chain:{ *:[i32] } 740:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171246 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171249 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 171253 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171258 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171262 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171268 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171271 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171275 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171294 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171297 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171300 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171303 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171308 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171313 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171323 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171335 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171340 */     // GIR_Coverage, 13250,
     /* 171340 */     GIR_EraseRootFromParent_Done,
     /* 171341 */   // Label 3195: @171341
     /* 171341 */   GIM_Try, /*On fail goto*//*Label 3196*/ GIMT_Encode4(171374), // Rule ID 13252 //
     /* 171346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 171357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171365 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 171365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 171368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171372 */     GIR_RootConstrainSelectedInstOperands,
     /* 171373 */     // GIR_Coverage, 13252,
     /* 171373 */     GIR_EraseRootFromParent_Done,
     /* 171374 */   // Label 3196: @171374
     /* 171374 */   GIM_Try, /*On fail goto*//*Label 3197*/ GIMT_Encode4(171407), // Rule ID 13254 //
     /* 171379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s8,
     /* 171387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 171390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 171394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171398 */     // (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 171398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 171401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171405 */     GIR_RootConstrainSelectedInstOperands,
     /* 171406 */     // GIR_Coverage, 13254,
     /* 171406 */     GIR_EraseRootFromParent_Done,
     /* 171407 */   // Label 3197: @171407
     /* 171407 */   GIM_Try, /*On fail goto*//*Label 3198*/ GIMT_Encode4(171440), // Rule ID 13256 //
     /* 171412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 171423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171427 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171431 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 171431 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 171434 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171438 */     GIR_RootConstrainSelectedInstOperands,
     /* 171439 */     // GIR_Coverage, 13256,
     /* 171439 */     GIR_EraseRootFromParent_Done,
     /* 171440 */   // Label 3198: @171440
     /* 171440 */   GIM_Try, /*On fail goto*//*Label 3199*/ GIMT_Encode4(171473), // Rule ID 13258 //
     /* 171445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 171453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 171456 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 171460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171464 */     // (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 171464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 171467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 171469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 171471 */     GIR_RootConstrainSelectedInstOperands,
     /* 171472 */     // GIR_Coverage, 13258,
     /* 171472 */     GIR_EraseRootFromParent_Done,
     /* 171473 */   // Label 3199: @171473
     /* 171473 */   GIM_Try, /*On fail goto*//*Label 3200*/ GIMT_Encode4(171588), // Rule ID 13259 //
     /* 171478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 171489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171497 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn), ssub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171497 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 171500 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 171504 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171509 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171513 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171515 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171518 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171522 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171527 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171541 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171544 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 171550 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171570 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171577 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171582 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171587 */     // GIR_Coverage, 13259,
     /* 171587 */     GIR_EraseRootFromParent_Done,
     /* 171588 */   // Label 3200: @171588
     /* 171588 */   GIM_Try, /*On fail goto*//*Label 3201*/ GIMT_Encode4(171707), // Rule ID 13260 //
     /* 171593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 171598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 171601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 171604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171612 */     // (intrinsic_wo_chain:{ *:[i32] } 743:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] }), ssub:{ *:[i32] })
     /* 171612 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 171615 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 171619 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171624 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171628 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 171632 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 171634 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 171637 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 171641 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 171648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 171651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 171655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 171660 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 171663 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 171666 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 171669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171674 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171679 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 171684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 171687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 171689 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 171696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 171701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 171706 */     // GIR_Coverage, 13260,
     /* 171706 */     GIR_EraseRootFromParent_Done,
     /* 171707 */   // Label 3201: @171707
     /* 171707 */   GIM_Try, /*On fail goto*//*Label 3202*/ GIMT_Encode4(171739), // Rule ID 2393 //
     /* 171712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b16),
     /* 171720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171730 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1676:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_H),
     /* 171733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171735 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171737 */     GIR_RootConstrainSelectedInstOperands,
     /* 171738 */     // GIR_Coverage, 2393,
     /* 171738 */     GIR_EraseRootFromParent_Done,
     /* 171739 */   // Label 3202: @171739
     /* 171739 */   GIM_Try, /*On fail goto*//*Label 3203*/ GIMT_Encode4(171771), // Rule ID 2394 //
     /* 171744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b32),
     /* 171752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171762 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1677:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_S),
     /* 171765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171769 */     GIR_RootConstrainSelectedInstOperands,
     /* 171770 */     // GIR_Coverage, 2394,
     /* 171770 */     GIR_EraseRootFromParent_Done,
     /* 171771 */   // Label 3203: @171771
     /* 171771 */   GIM_Try, /*On fail goto*//*Label 3204*/ GIMT_Encode4(171803), // Rule ID 2395 //
     /* 171776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rev_b64),
     /* 171784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 171787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171794 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1678:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn)  =>  (REV_PP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn)
     /* 171794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV_PP_D),
     /* 171797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 171801 */     GIR_RootConstrainSelectedInstOperands,
     /* 171802 */     // GIR_Coverage, 2395,
     /* 171802 */     GIR_EraseRootFromParent_Done,
     /* 171803 */   // Label 3204: @171803
     /* 171803 */   GIM_Try, /*On fail goto*//*Label 3205*/ GIMT_Encode4(171835), // Rule ID 3089 //
     /* 171808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 171819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 171822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171826 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1858:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 171826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_B),
     /* 171829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171833 */     GIR_RootConstrainSelectedInstOperands,
     /* 171834 */     // GIR_Coverage, 3089,
     /* 171834 */     GIR_EraseRootFromParent_Done,
     /* 171835 */   // Label 3205: @171835
     /* 171835 */   GIM_Try, /*On fail goto*//*Label 3206*/ GIMT_Encode4(171867), // Rule ID 3090 //
     /* 171840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 171851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 171854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171858 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1858:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 171858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_H),
     /* 171861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171863 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171865 */     GIR_RootConstrainSelectedInstOperands,
     /* 171866 */     // GIR_Coverage, 3090,
     /* 171866 */     GIR_EraseRootFromParent_Done,
     /* 171867 */   // Label 3206: @171867
     /* 171867 */   GIM_Try, /*On fail goto*//*Label 3207*/ GIMT_Encode4(171899), // Rule ID 3091 //
     /* 171872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 171875 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnb),
     /* 171880 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 171883 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 171886 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 171890 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1858:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 171890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNB_ZZ_S),
     /* 171893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 171895 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171897 */     GIR_RootConstrainSelectedInstOperands,
     /* 171898 */     // GIR_Coverage, 3091,
     /* 171898 */     GIR_EraseRootFromParent_Done,
     /* 171899 */   // Label 3207: @171899
     /* 171899 */   GIM_Try, /*On fail goto*//*Label 3208*/ GIMT_Encode4(171931), // Rule ID 3345 //
     /* 171904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 171915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 171918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171922 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1668:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 171922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171929 */     GIR_RootConstrainSelectedInstOperands,
     /* 171930 */     // GIR_Coverage, 3345,
     /* 171930 */     GIR_EraseRootFromParent_Done,
     /* 171931 */   // Label 3208: @171931
     /* 171931 */   GIM_Try, /*On fail goto*//*Label 3209*/ GIMT_Encode4(171963), // Rule ID 3346 //
     /* 171936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171939 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171944 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 171947 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 171950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171954 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1668:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 171954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171961 */     GIR_RootConstrainSelectedInstOperands,
     /* 171962 */     // GIR_Coverage, 3346,
     /* 171962 */     GIR_EraseRootFromParent_Done,
     /* 171963 */   // Label 3209: @171963
     /* 171963 */   GIM_Try, /*On fail goto*//*Label 3210*/ GIMT_Encode4(171995), // Rule ID 3347 //
     /* 171968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 171971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpklo),
     /* 171976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 171979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 171982 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 171986 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1668:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKLO_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 171986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 171989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 171991 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 171993 */     GIR_RootConstrainSelectedInstOperands,
     /* 171994 */     // GIR_Coverage, 3347,
     /* 171994 */     GIR_EraseRootFromParent_Done,
     /* 171995 */   // Label 3210: @171995
     /* 171995 */   GIM_Try, /*On fail goto*//*Label 3211*/ GIMT_Encode4(172027), // Rule ID 3426 //
     /* 172000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172018 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1429:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (FEXPA_ZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_H),
     /* 172021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172025 */     GIR_RootConstrainSelectedInstOperands,
     /* 172026 */     // GIR_Coverage, 3426,
     /* 172026 */     GIR_EraseRootFromParent_Done,
     /* 172027 */   // Label 3211: @172027
     /* 172027 */   GIM_Try, /*On fail goto*//*Label 3212*/ GIMT_Encode4(172059), // Rule ID 3427 //
     /* 172032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172035 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172040 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172043 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172050 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1429:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (FEXPA_ZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_S),
     /* 172053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172057 */     GIR_RootConstrainSelectedInstOperands,
     /* 172058 */     // GIR_Coverage, 3427,
     /* 172058 */     GIR_EraseRootFromParent_Done,
     /* 172059 */   // Label 3212: @172059
     /* 172059 */   GIM_Try, /*On fail goto*//*Label 3213*/ GIMT_Encode4(172091), // Rule ID 3428 //
     /* 172064 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SSVE_FEXPA),
     /* 172067 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fexpa_x),
     /* 172072 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 172075 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172082 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1429:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (FEXPA_ZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FEXPA_ZZ_D),
     /* 172085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172089 */     GIR_RootConstrainSelectedInstOperands,
     /* 172090 */     // GIR_Coverage, 3428,
     /* 172090 */     GIR_EraseRootFromParent_Done,
     /* 172091 */   // Label 3213: @172091
     /* 172091 */   GIM_Try, /*On fail goto*//*Label 3214*/ GIMT_Encode4(172123), // Rule ID 3453 //
     /* 172096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 172099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesmc),
     /* 172104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 172110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172114 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1268:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 172114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESMC_ZZ_B),
     /* 172117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 172119 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172121 */     GIR_RootConstrainSelectedInstOperands,
     /* 172122 */     // GIR_Coverage, 3453,
     /* 172122 */     GIR_EraseRootFromParent_Done,
     /* 172123 */   // Label 3214: @172123
     /* 172123 */   GIM_Try, /*On fail goto*//*Label 3215*/ GIMT_Encode4(172155), // Rule ID 4660 //
     /* 172128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172142 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172146 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 172149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172153 */     GIR_RootConstrainSelectedInstOperands,
     /* 172154 */     // GIR_Coverage, 4660,
     /* 172154 */     GIR_EraseRootFromParent_Done,
     /* 172155 */   // Label 3215: @172155
     /* 172155 */   GIM_Try, /*On fail goto*//*Label 3216*/ GIMT_Encode4(172187), // Rule ID 4661 //
     /* 172160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172178 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 172181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172183 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172185 */     GIR_RootConstrainSelectedInstOperands,
     /* 172186 */     // GIR_Coverage, 4661,
     /* 172186 */     GIR_EraseRootFromParent_Done,
     /* 172187 */   // Label 3216: @172187
     /* 172187 */   GIM_Try, /*On fail goto*//*Label 3217*/ GIMT_Encode4(172216), // Rule ID 4662 //
     /* 172192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172207 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 172210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172214 */     GIR_RootConstrainSelectedInstOperands,
     /* 172215 */     // GIR_Coverage, 4662,
     /* 172215 */     GIR_EraseRootFromParent_Done,
     /* 172216 */   // Label 3217: @172216
     /* 172216 */   GIM_Try, /*On fail goto*//*Label 3218*/ GIMT_Encode4(172245), // Rule ID 4663 //
     /* 172221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172236 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 172239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172243 */     GIR_RootConstrainSelectedInstOperands,
     /* 172244 */     // GIR_Coverage, 4663,
     /* 172244 */     GIR_EraseRootFromParent_Done,
     /* 172245 */   // Label 3218: @172245
     /* 172245 */   GIM_Try, /*On fail goto*//*Label 3219*/ GIMT_Encode4(172274), // Rule ID 4664 //
     /* 172250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172265 */     // (intrinsic_wo_chain:{ *:[i32] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 172268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172272 */     GIR_RootConstrainSelectedInstOperands,
     /* 172273 */     // GIR_Coverage, 4664,
     /* 172273 */     GIR_EraseRootFromParent_Done,
     /* 172274 */   // Label 3219: @172274
     /* 172274 */   GIM_Try, /*On fail goto*//*Label 3220*/ GIMT_Encode4(172303), // Rule ID 4665 //
     /* 172279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172294 */     // (intrinsic_wo_chain:{ *:[i64] } 599:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172294 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 172297 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172299 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172301 */     GIR_RootConstrainSelectedInstOperands,
     /* 172302 */     // GIR_Coverage, 4665,
     /* 172302 */     GIR_EraseRootFromParent_Done,
     /* 172303 */   // Label 3220: @172303
     /* 172303 */   GIM_Try, /*On fail goto*//*Label 3221*/ GIMT_Encode4(172335), // Rule ID 4672 //
     /* 172308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172326 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } ?:{ *:[f16] }:$Rn)
     /* 172326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 172329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172333 */     GIR_RootConstrainSelectedInstOperands,
     /* 172334 */     // GIR_Coverage, 4672,
     /* 172334 */     GIR_EraseRootFromParent_Done,
     /* 172335 */   // Label 3221: @172335
     /* 172335 */   GIM_Try, /*On fail goto*//*Label 3222*/ GIMT_Encode4(172367), // Rule ID 4673 //
     /* 172340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 172343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 172354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172358 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } ?:{ *:[f16] }:$Rn)
     /* 172358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 172361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172365 */     GIR_RootConstrainSelectedInstOperands,
     /* 172366 */     // GIR_Coverage, 4673,
     /* 172366 */     GIR_EraseRootFromParent_Done,
     /* 172367 */   // Label 3222: @172367
     /* 172367 */   GIM_Try, /*On fail goto*//*Label 3223*/ GIMT_Encode4(172396), // Rule ID 4674 //
     /* 172372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172387 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } ?:{ *:[f32] }:$Rn)
     /* 172387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 172390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172394 */     GIR_RootConstrainSelectedInstOperands,
     /* 172395 */     // GIR_Coverage, 4674,
     /* 172395 */     GIR_EraseRootFromParent_Done,
     /* 172396 */   // Label 3223: @172396
     /* 172396 */   GIM_Try, /*On fail goto*//*Label 3224*/ GIMT_Encode4(172425), // Rule ID 4675 //
     /* 172401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 172412 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172416 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } ?:{ *:[f32] }:$Rn)
     /* 172416 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 172419 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172421 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172423 */     GIR_RootConstrainSelectedInstOperands,
     /* 172424 */     // GIR_Coverage, 4675,
     /* 172424 */     GIR_EraseRootFromParent_Done,
     /* 172425 */   // Label 3224: @172425
     /* 172425 */   GIM_Try, /*On fail goto*//*Label 3225*/ GIMT_Encode4(172454), // Rule ID 4676 //
     /* 172430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 172438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 172445 */     // (intrinsic_wo_chain:{ *:[i32] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } ?:{ *:[f64] }:$Rn)
     /* 172445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 172448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172452 */     GIR_RootConstrainSelectedInstOperands,
     /* 172453 */     // GIR_Coverage, 4676,
     /* 172453 */     GIR_EraseRootFromParent_Done,
     /* 172454 */   // Label 3225: @172454
     /* 172454 */   GIM_Try, /*On fail goto*//*Label 3226*/ GIMT_Encode4(172483), // Rule ID 4677 //
     /* 172459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 172467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 172470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 172474 */     // (intrinsic_wo_chain:{ *:[i64] } 600:{ *:[iPTR] }, f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } ?:{ *:[f64] }:$Rn)
     /* 172474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 172477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172481 */     GIR_RootConstrainSelectedInstOperands,
     /* 172482 */     // GIR_Coverage, 4677,
     /* 172482 */     GIR_EraseRootFromParent_Done,
     /* 172483 */   // Label 3226: @172483
     /* 172483 */   GIM_Try, /*On fail goto*//*Label 3227*/ GIMT_Encode4(172512), // Rule ID 4972 //
     /* 172488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172503 */     // (intrinsic_wo_chain:{ *:[v4i16] } 599:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 172506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172510 */     GIR_RootConstrainSelectedInstOperands,
     /* 172511 */     // GIR_Coverage, 4972,
     /* 172511 */     GIR_EraseRootFromParent_Done,
     /* 172512 */   // Label 3227: @172512
     /* 172512 */   GIM_Try, /*On fail goto*//*Label 3228*/ GIMT_Encode4(172541), // Rule ID 4973 //
     /* 172517 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172522 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172525 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172532 */     // (intrinsic_wo_chain:{ *:[v8i16] } 599:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 172535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172539 */     GIR_RootConstrainSelectedInstOperands,
     /* 172540 */     // GIR_Coverage, 4973,
     /* 172540 */     GIR_EraseRootFromParent_Done,
     /* 172541 */   // Label 3228: @172541
     /* 172541 */   GIM_Try, /*On fail goto*//*Label 3229*/ GIMT_Encode4(172570), // Rule ID 4974 //
     /* 172546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172561 */     // (intrinsic_wo_chain:{ *:[v2i32] } 599:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 172564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172568 */     GIR_RootConstrainSelectedInstOperands,
     /* 172569 */     // GIR_Coverage, 4974,
     /* 172569 */     GIR_EraseRootFromParent_Done,
     /* 172570 */   // Label 3229: @172570
     /* 172570 */   GIM_Try, /*On fail goto*//*Label 3230*/ GIMT_Encode4(172599), // Rule ID 4975 //
     /* 172575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172586 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172590 */     // (intrinsic_wo_chain:{ *:[v4i32] } 599:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 172593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172595 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172597 */     GIR_RootConstrainSelectedInstOperands,
     /* 172598 */     // GIR_Coverage, 4975,
     /* 172598 */     GIR_EraseRootFromParent_Done,
     /* 172599 */   // Label 3230: @172599
     /* 172599 */   GIM_Try, /*On fail goto*//*Label 3231*/ GIMT_Encode4(172628), // Rule ID 4976 //
     /* 172604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzs),
     /* 172609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172619 */     // (intrinsic_wo_chain:{ *:[v2i64] } 599:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 172622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172626 */     GIR_RootConstrainSelectedInstOperands,
     /* 172627 */     // GIR_Coverage, 4976,
     /* 172627 */     GIR_EraseRootFromParent_Done,
     /* 172628 */   // Label 3231: @172628
     /* 172628 */   GIM_Try, /*On fail goto*//*Label 3232*/ GIMT_Encode4(172657), // Rule ID 4977 //
     /* 172633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 172641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 172644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172648 */     // (intrinsic_wo_chain:{ *:[v4i16] } 600:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } ?:{ *:[v4f16] }:$Rn)
     /* 172648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 172651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172655 */     GIR_RootConstrainSelectedInstOperands,
     /* 172656 */     // GIR_Coverage, 4977,
     /* 172656 */     GIR_EraseRootFromParent_Done,
     /* 172657 */   // Label 3232: @172657
     /* 172657 */   GIM_Try, /*On fail goto*//*Label 3233*/ GIMT_Encode4(172686), // Rule ID 4978 //
     /* 172662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 172670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 172673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172677 */     // (intrinsic_wo_chain:{ *:[v8i16] } 600:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } ?:{ *:[v8f16] }:$Rn)
     /* 172677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 172680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172684 */     GIR_RootConstrainSelectedInstOperands,
     /* 172685 */     // GIR_Coverage, 4978,
     /* 172685 */     GIR_EraseRootFromParent_Done,
     /* 172686 */   // Label 3233: @172686
     /* 172686 */   GIM_Try, /*On fail goto*//*Label 3234*/ GIMT_Encode4(172715), // Rule ID 4979 //
     /* 172691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 172699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 172702 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 172706 */     // (intrinsic_wo_chain:{ *:[v2i32] } 600:{ *:[iPTR] }, v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } ?:{ *:[v2f32] }:$Rn)
     /* 172706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 172709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172713 */     GIR_RootConstrainSelectedInstOperands,
     /* 172714 */     // GIR_Coverage, 4979,
     /* 172714 */     GIR_EraseRootFromParent_Done,
     /* 172715 */   // Label 3234: @172715
     /* 172715 */   GIM_Try, /*On fail goto*//*Label 3235*/ GIMT_Encode4(172744), // Rule ID 4980 //
     /* 172720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 172728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 172731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172735 */     // (intrinsic_wo_chain:{ *:[v4i32] } 600:{ *:[iPTR] }, v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } ?:{ *:[v4f32] }:$Rn)
     /* 172735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 172738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172742 */     GIR_RootConstrainSelectedInstOperands,
     /* 172743 */     // GIR_Coverage, 4980,
     /* 172743 */     GIR_EraseRootFromParent_Done,
     /* 172744 */   // Label 3235: @172744
     /* 172744 */   GIM_Try, /*On fail goto*//*Label 3236*/ GIMT_Encode4(172773), // Rule ID 4981 //
     /* 172749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fcvtzu),
     /* 172754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 172757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 172760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 172764 */     // (intrinsic_wo_chain:{ *:[v2i64] } 600:{ *:[iPTR] }, v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } ?:{ *:[v2f64] }:$Rn)
     /* 172764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 172767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 172769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 172771 */     GIR_RootConstrainSelectedInstOperands,
     /* 172772 */     // GIR_Coverage, 4981,
     /* 172772 */     GIR_EraseRootFromParent_Done,
     /* 172773 */   // Label 3236: @172773
     /* 172773 */   GIM_Try, /*On fail goto*//*Label 3237*/ GIMT_Encode4(172805), // Rule ID 8453 //
     /* 172778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 172789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 172792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172796 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1667:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv8i1] } ?:{ *:[nxv16i1] }:$Op1)
     /* 172796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172803 */     GIR_RootConstrainSelectedInstOperands,
     /* 172804 */     // GIR_Coverage, 8453,
     /* 172804 */     GIR_EraseRootFromParent_Done,
     /* 172805 */   // Label 3237: @172805
     /* 172805 */   GIM_Try, /*On fail goto*//*Label 3238*/ GIMT_Encode4(172837), // Rule ID 8454 //
     /* 172810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 172821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 172824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172828 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1667:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv4i1] } ?:{ *:[nxv8i1] }:$Op1)
     /* 172828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172835 */     GIR_RootConstrainSelectedInstOperands,
     /* 172836 */     // GIR_Coverage, 8454,
     /* 172836 */     GIR_EraseRootFromParent_Done,
     /* 172837 */   // Label 3238: @172837
     /* 172837 */   GIM_Try, /*On fail goto*//*Label 3239*/ GIMT_Encode4(172869), // Rule ID 8455 //
     /* 172842 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 172845 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_punpkhi),
     /* 172850 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 172853 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 172856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 172860 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1667:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1)  =>  (PUNPKHI_PP:{ *:[nxv2i1] } ?:{ *:[nxv4i1] }:$Op1)
     /* 172860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 172863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 172865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172867 */     GIR_RootConstrainSelectedInstOperands,
     /* 172868 */     // GIR_Coverage, 8455,
     /* 172868 */     GIR_EraseRootFromParent_Done,
     /* 172869 */   // Label 3239: @172869
     /* 172869 */   GIM_Try, /*On fail goto*//*Label 3240*/ GIMT_Encode4(172901), // Rule ID 11876 //
     /* 172874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172892 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2051:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (UQXTNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_B),
     /* 172895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172899 */     GIR_RootConstrainSelectedInstOperands,
     /* 172900 */     // GIR_Coverage, 11876,
     /* 172900 */     GIR_EraseRootFromParent_Done,
     /* 172901 */   // Label 3240: @172901
     /* 172901 */   GIM_Try, /*On fail goto*//*Label 3241*/ GIMT_Encode4(172933), // Rule ID 11877 //
     /* 172906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 172917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 172920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172924 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2051:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (UQXTNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 172924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_H),
     /* 172927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172931 */     GIR_RootConstrainSelectedInstOperands,
     /* 172932 */     // GIR_Coverage, 11877,
     /* 172932 */     GIR_EraseRootFromParent_Done,
     /* 172933 */   // Label 3241: @172933
     /* 172933 */   GIM_Try, /*On fail goto*//*Label 3242*/ GIMT_Encode4(172965), // Rule ID 11878 //
     /* 172938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnb),
     /* 172946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 172949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 172952 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172956 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2051:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (UQXTNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 172956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNB_ZZ_S),
     /* 172959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172963 */     GIR_RootConstrainSelectedInstOperands,
     /* 172964 */     // GIR_Coverage, 11878,
     /* 172964 */     GIR_EraseRootFromParent_Done,
     /* 172965 */   // Label 3242: @172965
     /* 172965 */   GIM_Try, /*On fail goto*//*Label 3243*/ GIMT_Encode4(172997), // Rule ID 11879 //
     /* 172970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 172973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 172978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 172981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 172984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 172988 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1860:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1)  =>  (SQXTUNB_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1)
     /* 172988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_B),
     /* 172991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 172993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 172995 */     GIR_RootConstrainSelectedInstOperands,
     /* 172996 */     // GIR_Coverage, 11879,
     /* 172996 */     GIR_EraseRootFromParent_Done,
     /* 172997 */   // Label 3243: @172997
     /* 172997 */   GIM_Try, /*On fail goto*//*Label 3244*/ GIMT_Encode4(173029), // Rule ID 11880 //
     /* 173002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 173013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 173016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1860:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1)  =>  (SQXTUNB_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1)
     /* 173020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_H),
     /* 173023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173027 */     GIR_RootConstrainSelectedInstOperands,
     /* 173028 */     // GIR_Coverage, 11880,
     /* 173028 */     GIR_EraseRootFromParent_Done,
     /* 173029 */   // Label 3244: @173029
     /* 173029 */   GIM_Try, /*On fail goto*//*Label 3245*/ GIMT_Encode4(173061), // Rule ID 11881 //
     /* 173034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 173037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunb),
     /* 173042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 173045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 173048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173052 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1860:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1)  =>  (SQXTUNB_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1)
     /* 173052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNB_ZZ_S),
     /* 173055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 173057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173059 */     GIR_RootConstrainSelectedInstOperands,
     /* 173060 */     // GIR_Coverage, 11881,
     /* 173060 */     GIR_EraseRootFromParent_Done,
     /* 173061 */   // Label 3245: @173061
     /* 173061 */   GIM_Try, /*On fail goto*//*Label 3246*/ GIMT_Encode4(173093), // Rule ID 12047 //
     /* 173066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 173069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesimc),
     /* 173074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 173077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 173080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 173084 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1267:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (AESIMC_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1)
     /* 173084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESIMC_ZZ_B),
     /* 173087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 173089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 173091 */     GIR_RootConstrainSelectedInstOperands,
     /* 173092 */     // GIR_Coverage, 12047,
     /* 173092 */     GIR_EraseRootFromParent_Done,
     /* 173093 */   // Label 3246: @173093
     /* 173093 */   GIM_Reject,
     /* 173094 */ // Label 2927: @173094
     /* 173094 */ GIM_Try, /*On fail goto*//*Label 3247*/ GIMT_Encode4(215420),
     /* 173099 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 173102 */   GIM_Try, /*On fail goto*//*Label 3248*/ GIMT_Encode4(173286), // Rule ID 2564 //
     /* 173107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173148 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173152 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173156 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173159 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173164 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173168 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173189 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173193 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173197 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173201 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173205 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173210 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173214 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173218 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173222 */     // MIs[5] Operand 1
     /* 173222 */     // No operand predicates
     /* 173222 */     // MIs[3] Operand 2
     /* 173222 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173233 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173237 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173239 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173239 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173242 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173246 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173251 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173257 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173262 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173281 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173284 */     GIR_RootConstrainSelectedInstOperands,
     /* 173285 */     // GIR_Coverage, 2564,
     /* 173285 */     GIR_EraseRootFromParent_Done,
     /* 173286 */   // Label 3248: @173286
     /* 173286 */   GIM_Try, /*On fail goto*//*Label 3249*/ GIMT_Encode4(173470), // Rule ID 6301 //
     /* 173291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173308 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173312 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173324 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173328 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173340 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173343 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173348 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173352 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173356 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173361 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173365 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173369 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173373 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 173377 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173381 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173385 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 173389 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173394 */     GIM_RecordInsn, /*DefineMI*/5, /*MI*/4, /*OpIdx*/2, // MIs[5]
     /* 173398 */     GIM_CheckOpcode, /*MI*/5, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173402 */     GIM_CheckI64ImmPredicate, /*MI*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173406 */     // MIs[5] Operand 1
     /* 173406 */     // No operand predicates
     /* 173406 */     // MIs[3] Operand 2
     /* 173406 */     GIM_CheckLiteralInt, /*MI*/3, /*Op*/2, GIMT_Encode8(0),
     /* 173417 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173421 */     GIM_CheckIsSafeToFold, /*NumInsns*/5,
     /* 173423 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173423 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173426 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173430 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173435 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173441 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173446 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173458 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rm
     /* 173465 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/5, // idx
     /* 173468 */     GIR_RootConstrainSelectedInstOperands,
     /* 173469 */     // GIR_Coverage, 6301,
     /* 173469 */     GIR_EraseRootFromParent_Done,
     /* 173470 */   // Label 3249: @173470
     /* 173470 */   GIM_Try, /*On fail goto*//*Label 3250*/ GIMT_Encode4(173631), // Rule ID 2565 //
     /* 173475 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173478 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 173483 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173496 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173512 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173516 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173520 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173524 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173527 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173532 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173536 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173540 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173545 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173549 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173553 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173557 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173561 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173566 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173570 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173574 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173578 */     // MIs[4] Operand 1
     /* 173578 */     // No operand predicates
     /* 173578 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173582 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173584 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173584 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173587 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173591 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173596 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 173615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173619 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173626 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173629 */     GIR_RootConstrainSelectedInstOperands,
     /* 173630 */     // GIR_Coverage, 2565,
     /* 173630 */     GIR_EraseRootFromParent_Done,
     /* 173631 */   // Label 3250: @173631
     /* 173631 */   GIM_Try, /*On fail goto*//*Label 3251*/ GIMT_Encode4(173792), // Rule ID 6302 //
     /* 173636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 173644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 173647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 173650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 173653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173657 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 173661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173665 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 173669 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173673 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 173677 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173681 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 173685 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 173688 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173693 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173697 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173701 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173706 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/3, // MIs[3]
     /* 173710 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173714 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173718 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 173722 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173727 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 173731 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173735 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173739 */     // MIs[4] Operand 1
     /* 173739 */     // No operand predicates
     /* 173739 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 173743 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 173745 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 173745 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 173748 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 173752 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 173757 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 173763 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 173768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 173773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 173776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 173778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 173780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 173783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 173787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 173790 */     GIR_RootConstrainSelectedInstOperands,
     /* 173791 */     // GIR_Coverage, 6302,
     /* 173791 */     GIR_EraseRootFromParent_Done,
     /* 173792 */   // Label 3251: @173792
     /* 173792 */   GIM_Try, /*On fail goto*//*Label 3252*/ GIMT_Encode4(173902), // Rule ID 2085 //
     /* 173797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 173808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 173811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 173814 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 173838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 173842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 173851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173859 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 173863 */     // MIs[3] Operand 1
     /* 173863 */     // No operand predicates
     /* 173863 */     // MIs[1] Operand 2
     /* 173863 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 173874 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173876 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 173883 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SQDMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_indexed),
     /* 173886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 173893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 173897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 173900 */     GIR_RootConstrainSelectedInstOperands,
     /* 173901 */     // GIR_Coverage, 2085,
     /* 173901 */     GIR_EraseRootFromParent_Done,
     /* 173902 */   // Label 3252: @173902
     /* 173902 */   GIM_Try, /*On fail goto*//*Label 3253*/ GIMT_Encode4(174012), // Rule ID 2088 //
     /* 173907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 173910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 173915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 173918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 173921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 173924 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 173932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 173936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173940 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 173944 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 173948 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 173952 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 173956 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 173961 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 173965 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 173969 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 173973 */     // MIs[3] Operand 1
     /* 173973 */     // No operand predicates
     /* 173973 */     // MIs[1] Operand 2
     /* 173973 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 173984 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 173986 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 173993 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SQDMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 173993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_indexed),
     /* 173996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 173998 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 174003 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 174007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 174010 */     GIR_RootConstrainSelectedInstOperands,
     /* 174011 */     // GIR_Coverage, 2088,
     /* 174011 */     GIR_EraseRootFromParent_Done,
     /* 174012 */   // Label 3253: @174012
     /* 174012 */   GIM_Try, /*On fail goto*//*Label 3254*/ GIMT_Encode4(174134), // Rule ID 6955 //
     /* 174017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174052 */     // MIs[1] Operand 2
     /* 174052 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174071 */     // MIs[2] Rn
     /* 174071 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174076 */     // MIs[2] Operand 2
     /* 174076 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174087 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174089 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (ADDPv4i32:{ *:[f128] } ?:{ *:[v4i32] }:$Rn, ?:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 174089 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174092 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 174096 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174101 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174105 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174116 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174123 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174133 */     // GIR_Coverage, 6955,
     /* 174133 */     GIR_EraseRootFromParent_Done,
     /* 174134 */   // Label 3254: @174134
     /* 174134 */   GIM_Try, /*On fail goto*//*Label 3255*/ GIMT_Encode4(174256), // Rule ID 6957 //
     /* 174139 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174144 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174147 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174150 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174157 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174161 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174165 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174169 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174174 */     // MIs[1] Operand 2
     /* 174174 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174193 */     // MIs[2] Rn
     /* 174193 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174198 */     // MIs[2] Operand 2
     /* 174198 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174211 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (ADDPv8i16:{ *:[f128] } ?:{ *:[v8i16] }:$Rn, ?:{ *:[v8i16] }:$Rn), dsub:{ *:[i32] })
     /* 174211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 174218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174227 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174231 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174238 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174250 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174255 */     // GIR_Coverage, 6957,
     /* 174255 */     GIR_EraseRootFromParent_Done,
     /* 174256 */   // Label 3255: @174256
     /* 174256 */   GIM_Try, /*On fail goto*//*Label 3256*/ GIMT_Encode4(174378), // Rule ID 6959 //
     /* 174261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 174266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 174269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 174272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 174275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174287 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 174291 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174296 */     // MIs[1] Operand 2
     /* 174296 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174307 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174311 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174315 */     // MIs[2] Rn
     /* 174315 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174320 */     // MIs[2] Operand 2
     /* 174320 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 174331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174333 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (ADDPv16i8:{ *:[f128] } ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rn), dsub:{ *:[i32] })
     /* 174333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 174340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174345 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174349 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174353 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174360 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174377 */     // GIR_Coverage, 6959,
     /* 174377 */     GIR_EraseRootFromParent_Done,
     /* 174378 */   // Label 3256: @174378
     /* 174378 */   GIM_Try, /*On fail goto*//*Label 3257*/ GIMT_Encode4(174500), // Rule ID 6961 //
     /* 174383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 174391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 174394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 174397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174401 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174405 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174409 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174418 */     // MIs[1] Operand 2
     /* 174418 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174437 */     // MIs[2] Rn
     /* 174437 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174442 */     // MIs[2] Operand 2
     /* 174442 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 174453 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174455 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } FPR128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (FADDPv4f32:{ *:[f128] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] })
     /* 174455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 174462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174467 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174471 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174482 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174489 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174494 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174499 */     // GIR_Coverage, 6961,
     /* 174499 */     GIR_EraseRootFromParent_Done,
     /* 174500 */   // Label 3257: @174500
     /* 174500 */   GIM_Try, /*On fail goto*//*Label 3258*/ GIMT_Encode4(174622), // Rule ID 6963 //
     /* 174505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 174510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 174513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174516 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174519 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 174527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 174535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174540 */     // MIs[1] Operand 2
     /* 174540 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 174551 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 174555 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 174559 */     // MIs[2] Rn
     /* 174559 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 174564 */     // MIs[2] Operand 2
     /* 174564 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 174575 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } FPR128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }))  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (FADDPv8f16:{ *:[f128] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] })
     /* 174577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 174580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 174584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174589 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174593 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 174597 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 174599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174604 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 174611 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174616 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174621 */     // GIR_Coverage, 6963,
     /* 174621 */     GIR_EraseRootFromParent_Done,
     /* 174622 */   // Label 3258: @174622
     /* 174622 */   GIM_Try, /*On fail goto*//*Label 3259*/ GIMT_Encode4(174805), // Rule ID 2563 //
     /* 174627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 174635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174664 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174676 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174679 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174684 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174688 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174692 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174697 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174702 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174706 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174708 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLALv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174708 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174711 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174715 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174734 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174737 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174741 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174754 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174759 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174762 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174766 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174771 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i32_indexed),
     /* 174790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174794 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174797 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174800 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174803 */     GIR_RootConstrainSelectedInstOperands,
     /* 174804 */     // GIR_Coverage, 2563,
     /* 174804 */     GIR_EraseRootFromParent_Done,
     /* 174805 */   // Label 3259: @174805
     /* 174805 */   GIM_Try, /*On fail goto*//*Label 3260*/ GIMT_Encode4(174988), // Rule ID 6300 //
     /* 174810 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 174813 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 174818 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 174821 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 174824 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 174827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 174835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 174839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 174843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 174847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 174851 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 174855 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 174859 */     GIM_CheckNumOperands, /*MI*/2, /*Expected*/4,
     /* 174862 */     GIM_CheckIntrinsicID, /*MI*/2, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 174867 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 174871 */     GIM_CheckType, /*MI*/2, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 174875 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174880 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174885 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 174889 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 174891 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, (vector_extract:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), 0:{ *:[i64] }))  =>  (SQDMLSLv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V64:{ *:[v4i16] }:$Rn, hsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v4i16] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 174891 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 174894 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 174898 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 174905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 174908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 174912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174917 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 174920 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/3, // Rm
     /* 174924 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 174927 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174932 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 174937 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174942 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 174945 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 174949 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 174954 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 174960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 174965 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 174970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i32_indexed),
     /* 174973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 174975 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 174977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 174980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 174983 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 174986 */     GIR_RootConstrainSelectedInstOperands,
     /* 174987 */     // GIR_Coverage, 6300,
     /* 174987 */     GIR_EraseRootFromParent_Done,
     /* 174988 */   // Label 3260: @174988
     /* 174988 */   GIM_Try, /*On fail goto*//*Label 3261*/ GIMT_Encode4(175092), // Rule ID 13515 //
     /* 174993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 174996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 175004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 175007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 175010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175014 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175018 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175022 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175026 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175030 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 175034 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175038 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175042 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 175047 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175051 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175055 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175059 */     // MIs[3] Operand 1
     /* 175059 */     // No operand predicates
     /* 175059 */     // MIs[1] Operand 2
     /* 175059 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175076 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 175079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175090 */     GIR_RootConstrainSelectedInstOperands,
     /* 175091 */     // GIR_Coverage, 13515,
     /* 175091 */     GIR_EraseRootFromParent_Done,
     /* 175092 */   // Label 3261: @175092
     /* 175092 */   GIM_Try, /*On fail goto*//*Label 3262*/ GIMT_Encode4(175196), // Rule ID 13518 //
     /* 175097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 175108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 175111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 175114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 175126 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175130 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 175134 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 175138 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175142 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175146 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175151 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175155 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175159 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175163 */     // MIs[3] Operand 1
     /* 175163 */     // No operand predicates
     /* 175163 */     // MIs[1] Operand 2
     /* 175163 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 175174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175178 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175180 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 175180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 175183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 175187 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175191 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175194 */     GIR_RootConstrainSelectedInstOperands,
     /* 175195 */     // GIR_Coverage, 13518,
     /* 175195 */     GIR_EraseRootFromParent_Done,
     /* 175196 */   // Label 3262: @175196
     /* 175196 */   GIM_Try, /*On fail goto*//*Label 3263*/ GIMT_Encode4(175327), // Rule ID 2520 //
     /* 175201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175243 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175259 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175263 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175276 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175280 */     // MIs[3] Operand 1
     /* 175280 */     // No operand predicates
     /* 175280 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175282 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175282 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175285 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175289 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175294 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175318 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175322 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175325 */     GIR_RootConstrainSelectedInstOperands,
     /* 175326 */     // GIR_Coverage, 2520,
     /* 175326 */     GIR_EraseRootFromParent_Done,
     /* 175327 */   // Label 3263: @175327
     /* 175327 */   GIM_Try, /*On fail goto*//*Label 3264*/ GIMT_Encode4(175458), // Rule ID 2521 //
     /* 175332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175374 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175399 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175403 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175407 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175411 */     // MIs[3] Operand 1
     /* 175411 */     // No operand predicates
     /* 175411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175413 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175456 */     GIR_RootConstrainSelectedInstOperands,
     /* 175457 */     // GIR_Coverage, 2521,
     /* 175457 */     GIR_EraseRootFromParent_Done,
     /* 175458 */   // Label 3264: @175458
     /* 175458 */   GIM_Try, /*On fail goto*//*Label 3265*/ GIMT_Encode4(175589), // Rule ID 2522 //
     /* 175463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175484 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175488 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175492 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175496 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175505 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 175509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 175513 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175517 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175521 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 175525 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175530 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 175534 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175538 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175542 */     // MIs[3] Operand 1
     /* 175542 */     // No operand predicates
     /* 175542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175544 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175556 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175567 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 175584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 175587 */     GIR_RootConstrainSelectedInstOperands,
     /* 175588 */     // GIR_Coverage, 2522,
     /* 175588 */     GIR_EraseRootFromParent_Done,
     /* 175589 */   // Label 3265: @175589
     /* 175589 */   GIM_Try, /*On fail goto*//*Label 3266*/ GIMT_Encode4(175720), // Rule ID 13707 //
     /* 175594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 175597 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175602 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 175605 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 175608 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 175611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175636 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175640 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175644 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 175648 */     // MIs[2] Operand 1
     /* 175648 */     // No operand predicates
     /* 175648 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175652 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175656 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 175660 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175664 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175669 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175673 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175675 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 175675 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 175678 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175682 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175687 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 175693 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 175698 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 175706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175708 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175718 */     GIR_RootConstrainSelectedInstOperands,
     /* 175719 */     // GIR_Coverage, 13707,
     /* 175719 */     GIR_EraseRootFromParent_Done,
     /* 175720 */   // Label 3266: @175720
     /* 175720 */   GIM_Try, /*On fail goto*//*Label 3267*/ GIMT_Encode4(175851), // Rule ID 13708 //
     /* 175725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 175736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 175739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 175742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175754 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175758 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175775 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 175779 */     // MIs[2] Operand 1
     /* 175779 */     // No operand predicates
     /* 175779 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175783 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175787 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 175791 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175795 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175800 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175804 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175806 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 175806 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 175809 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175813 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175818 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 175824 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 175829 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 175837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175846 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175849 */     GIR_RootConstrainSelectedInstOperands,
     /* 175850 */     // GIR_Coverage, 13708,
     /* 175850 */     GIR_EraseRootFromParent_Done,
     /* 175851 */   // Label 3267: @175851
     /* 175851 */   GIM_Try, /*On fail goto*//*Label 3268*/ GIMT_Encode4(175982), // Rule ID 13709 //
     /* 175856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 175864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 175870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 175873 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 175881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175889 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 175893 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175898 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 175902 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 175906 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 175910 */     // MIs[2] Operand 1
     /* 175910 */     // No operand predicates
     /* 175910 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 175914 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 175918 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 175922 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 175926 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175931 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 175935 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 175937 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULXv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 175937 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 175940 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 175944 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 175949 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 175955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 175960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 175965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 175968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 175970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 175973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 175977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 175980 */     GIR_RootConstrainSelectedInstOperands,
     /* 175981 */     // GIR_Coverage, 13709,
     /* 175981 */     GIR_EraseRootFromParent_Done,
     /* 175982 */   // Label 3268: @175982
     /* 175982 */   GIM_Try, /*On fail goto*//*Label 3269*/ GIMT_Encode4(176096), // Rule ID 2061 //
     /* 175987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 175990 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 175995 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 175998 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176001 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176004 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176008 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176012 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176016 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176020 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176023 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176028 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176032 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176036 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176049 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176053 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176057 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176062 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176066 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176070 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176074 */     // MIs[3] Operand 1
     /* 176074 */     // No operand predicates
     /* 176074 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176076 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv1i64_indexed),
     /* 176079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176087 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176094 */     GIR_RootConstrainSelectedInstOperands,
     /* 176095 */     // GIR_Coverage, 2061,
     /* 176095 */     GIR_EraseRootFromParent_Done,
     /* 176096 */   // Label 3269: @176096
     /* 176096 */   GIM_Try, /*On fail goto*//*Label 3270*/ GIMT_Encode4(176210), // Rule ID 2068 //
     /* 176101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 176109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 176112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 176115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 176118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 176134 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 176137 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 176142 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 176146 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 176150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 176155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 176159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 176163 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176167 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176171 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176176 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176180 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176184 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176188 */     // MIs[3] Operand 1
     /* 176188 */     // No operand predicates
     /* 176188 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176190 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64Op:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv1i64_indexed:{ *:[i64] } FPR64Op:{ *:[i64] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv1i64_indexed),
     /* 176193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 176195 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 176197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 176201 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176205 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176208 */     GIR_RootConstrainSelectedInstOperands,
     /* 176209 */     // GIR_Coverage, 2068,
     /* 176209 */     GIR_EraseRootFromParent_Done,
     /* 176210 */   // Label 3270: @176210
     /* 176210 */   GIM_Try, /*On fail goto*//*Label 3271*/ GIMT_Encode4(176314), // Rule ID 1987 //
     /* 176215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 176218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176236 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176252 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176256 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176260 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176264 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176268 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176281 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176285 */     // MIs[3] Operand 1
     /* 176285 */     // No operand predicates
     /* 176285 */     // MIs[1] Operand 2
     /* 176285 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176296 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176298 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176298 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 176301 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176303 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176312 */     GIR_RootConstrainSelectedInstOperands,
     /* 176313 */     // GIR_Coverage, 1987,
     /* 176313 */     GIR_EraseRootFromParent_Done,
     /* 176314 */   // Label 3271: @176314
     /* 176314 */   GIM_Try, /*On fail goto*//*Label 3272*/ GIMT_Encode4(176418), // Rule ID 2017 //
     /* 176319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176340 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176352 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176356 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176360 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176364 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176368 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176372 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176377 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176381 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176385 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176389 */     // MIs[3] Operand 1
     /* 176389 */     // No operand predicates
     /* 176389 */     // MIs[1] Operand 2
     /* 176389 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176400 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176402 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 176405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176409 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176413 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176416 */     GIR_RootConstrainSelectedInstOperands,
     /* 176417 */     // GIR_Coverage, 2017,
     /* 176417 */     GIR_EraseRootFromParent_Done,
     /* 176418 */   // Label 3272: @176418
     /* 176418 */   GIM_Try, /*On fail goto*//*Label 3273*/ GIMT_Encode4(176522), // Rule ID 2024 //
     /* 176423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 176434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176452 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176456 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176481 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176485 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176489 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176493 */     // MIs[3] Operand 1
     /* 176493 */     // No operand predicates
     /* 176493 */     // MIs[1] Operand 2
     /* 176493 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176504 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176506 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 176509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176513 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176517 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176520 */     GIR_RootConstrainSelectedInstOperands,
     /* 176521 */     // GIR_Coverage, 2024,
     /* 176521 */     GIR_EraseRootFromParent_Done,
     /* 176522 */   // Label 3273: @176522
     /* 176522 */   GIM_Try, /*On fail goto*//*Label 3274*/ GIMT_Encode4(176626), // Rule ID 2083 //
     /* 176527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 176538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 176541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 176544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 176572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 176576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 176585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 176597 */     // MIs[3] Operand 1
     /* 176597 */     // No operand predicates
     /* 176597 */     // MIs[1] Operand 2
     /* 176597 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176608 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176610 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 176613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176617 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176621 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176624 */     GIR_RootConstrainSelectedInstOperands,
     /* 176625 */     // GIR_Coverage, 2083,
     /* 176625 */     GIR_EraseRootFromParent_Done,
     /* 176626 */   // Label 3274: @176626
     /* 176626 */   GIM_Try, /*On fail goto*//*Label 3275*/ GIMT_Encode4(176730), // Rule ID 1990 //
     /* 176631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 176639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176652 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176664 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176668 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176672 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176676 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176680 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176684 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176689 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176693 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176697 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176701 */     // MIs[3] Operand 1
     /* 176701 */     // No operand predicates
     /* 176701 */     // MIs[1] Operand 2
     /* 176701 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176712 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176714 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 176717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176721 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176725 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176728 */     GIR_RootConstrainSelectedInstOperands,
     /* 176729 */     // GIR_Coverage, 1990,
     /* 176729 */     GIR_EraseRootFromParent_Done,
     /* 176730 */   // Label 3275: @176730
     /* 176730 */   GIM_Try, /*On fail goto*//*Label 3276*/ GIMT_Encode4(176834), // Rule ID 2020 //
     /* 176735 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176738 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 176743 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176746 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176749 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176772 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176776 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176780 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176784 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176788 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176793 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176797 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176801 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176805 */     // MIs[3] Operand 1
     /* 176805 */     // No operand predicates
     /* 176805 */     // MIs[1] Operand 2
     /* 176805 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176816 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176818 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 176821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176825 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176832 */     GIR_RootConstrainSelectedInstOperands,
     /* 176833 */     // GIR_Coverage, 2020,
     /* 176833 */     GIR_EraseRootFromParent_Done,
     /* 176834 */   // Label 3276: @176834
     /* 176834 */   GIM_Try, /*On fail goto*//*Label 3277*/ GIMT_Encode4(176938), // Rule ID 2027 //
     /* 176839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 176847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 176850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176860 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176872 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176876 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176880 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176884 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176888 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176892 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176897 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 176901 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 176905 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 176909 */     // MIs[3] Operand 1
     /* 176909 */     // No operand predicates
     /* 176909 */     // MIs[1] Operand 2
     /* 176909 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 176920 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 176922 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 176922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 176925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 176927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 176929 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 176933 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 176936 */     GIR_RootConstrainSelectedInstOperands,
     /* 176937 */     // GIR_Coverage, 2027,
     /* 176937 */     GIR_EraseRootFromParent_Done,
     /* 176938 */   // Label 3277: @176938
     /* 176938 */   GIM_Try, /*On fail goto*//*Label 3278*/ GIMT_Encode4(177042), // Rule ID 2086 //
     /* 176943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 176946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 176951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 176954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 176957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 176960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 176964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 176968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 176972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 176976 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 176984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 176988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 176992 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 176996 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177001 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 177005 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177009 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 177013 */     // MIs[3] Operand 1
     /* 177013 */     // No operand predicates
     /* 177013 */     // MIs[1] Operand 2
     /* 177013 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 177024 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 177026 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 177026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 177029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 177037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 177040 */     GIR_RootConstrainSelectedInstOperands,
     /* 177041 */     // GIR_Coverage, 2086,
     /* 177041 */     GIR_EraseRootFromParent_Done,
     /* 177042 */   // Label 3278: @177042
     /* 177042 */   GIM_Try, /*On fail goto*//*Label 3279*/ GIMT_Encode4(177099), // Rule ID 1751 //
     /* 177047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 177058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 177061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 177064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177068 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177075 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 177082 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SQDMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 177082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv8i16_v4i32),
     /* 177085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177097 */     GIR_RootConstrainSelectedInstOperands,
     /* 177098 */     // GIR_Coverage, 1751,
     /* 177098 */     GIR_EraseRootFromParent_Done,
     /* 177099 */   // Label 3279: @177099
     /* 177099 */   GIM_Try, /*On fail goto*//*Label 3280*/ GIMT_Encode4(177156), // Rule ID 1753 //
     /* 177104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 177107 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 177112 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 177115 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 177118 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 177121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177125 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177132 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 177139 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SQDMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 177139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i32_v2i64),
     /* 177142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177144 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 177149 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 177154 */     GIR_RootConstrainSelectedInstOperands,
     /* 177155 */     // GIR_Coverage, 1753,
     /* 177155 */     GIR_EraseRootFromParent_Done,
     /* 177156 */   // Label 3280: @177156
     /* 177156 */   GIM_Try, /*On fail goto*//*Label 3281*/ GIMT_Encode4(177266), // Rule ID 6319 //
     /* 177161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 177166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 177187 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 177191 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177200 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 177211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 177215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 177219 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 177223 */     // MIs[2] Operand 1
     /* 177223 */     // No operand predicates
     /* 177223 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 177225 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, (and:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, 65535:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 177225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177237 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 177243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 177256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177261 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 177264 */     GIR_RootConstrainSelectedInstOperands,
     /* 177265 */     // GIR_Coverage, 6319,
     /* 177265 */     GIR_EraseRootFromParent_Done,
     /* 177266 */   // Label 3281: @177266
     /* 177266 */   GIM_Try, /*On fail goto*//*Label 3282*/ GIMT_Encode4(177363), // Rule ID 13978 //
     /* 177271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177300 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177304 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177308 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177313 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177317 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177323 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177323 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177326 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177330 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177335 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177346 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177361 */     GIR_RootConstrainSelectedInstOperands,
     /* 177362 */     // GIR_Coverage, 13978,
     /* 177362 */     GIR_EraseRootFromParent_Done,
     /* 177363 */   // Label 3282: @177363
     /* 177363 */   GIM_Try, /*On fail goto*//*Label 3283*/ GIMT_Encode4(177460), // Rule ID 13979 //
     /* 177368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177397 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177401 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177405 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177410 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177414 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177418 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177420 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177432 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177443 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177455 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177458 */     GIR_RootConstrainSelectedInstOperands,
     /* 177459 */     // GIR_Coverage, 13979,
     /* 177459 */     GIR_EraseRootFromParent_Done,
     /* 177460 */   // Label 3283: @177460
     /* 177460 */   GIM_Try, /*On fail goto*//*Label 3284*/ GIMT_Encode4(177557), // Rule ID 13980 //
     /* 177465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 177490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177498 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177502 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177507 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177515 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177517 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177517 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177520 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177524 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177529 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177540 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 177552 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177555 */     GIR_RootConstrainSelectedInstOperands,
     /* 177556 */     // GIR_Coverage, 13980,
     /* 177556 */     GIR_EraseRootFromParent_Done,
     /* 177557 */   // Label 3284: @177557
     /* 177557 */   GIM_Try, /*On fail goto*//*Label 3285*/ GIMT_Encode4(177637), // Rule ID 5251 //
     /* 177562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 177567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177570 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177573 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177576 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177580 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177592 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177595 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177604 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177620 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLALi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALi32),
     /* 177623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177627 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177635 */     GIR_RootConstrainSelectedInstOperands,
     /* 177636 */     // GIR_Coverage, 5251,
     /* 177636 */     GIR_EraseRootFromParent_Done,
     /* 177637 */   // Label 3285: @177637
     /* 177637 */   GIM_Try, /*On fail goto*//*Label 3286*/ GIMT_Encode4(177717), // Rule ID 5252 //
     /* 177642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 177647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177660 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 177672 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 177675 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 177680 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 177684 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 177688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177693 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177698 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177700 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm))  =>  (SQDMLSLi32:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 177700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLi32),
     /* 177703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 177705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 177707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 177711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 177715 */     GIR_RootConstrainSelectedInstOperands,
     /* 177716 */     // GIR_Coverage, 5252,
     /* 177716 */     GIR_EraseRootFromParent_Done,
     /* 177717 */   // Label 3286: @177717
     /* 177717 */   GIM_Try, /*On fail goto*//*Label 3287*/ GIMT_Encode4(177814), // Rule ID 5248 //
     /* 177722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 177725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 177733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 177736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 177739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 177759 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177763 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177768 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177772 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177774 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 177774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 177777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177786 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 177792 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 177797 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 177805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177812 */     GIR_RootConstrainSelectedInstOperands,
     /* 177813 */     // GIR_Coverage, 5248,
     /* 177813 */     GIR_EraseRootFromParent_Done,
     /* 177814 */   // Label 3287: @177814
     /* 177814 */   GIM_Try, /*On fail goto*//*Label 3288*/ GIMT_Encode4(177911), // Rule ID 5249 //
     /* 177819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 177830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 177833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 177836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177848 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177852 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 177856 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177860 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177865 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177869 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177871 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 177871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 177874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177883 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 177889 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 177894 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 177902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 177904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 177906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 177909 */     GIR_RootConstrainSelectedInstOperands,
     /* 177910 */     // GIR_Coverage, 5249,
     /* 177910 */     GIR_EraseRootFromParent_Done,
     /* 177911 */   // Label 3288: @177911
     /* 177911 */   GIM_Try, /*On fail goto*//*Label 3289*/ GIMT_Encode4(178008), // Rule ID 5250 //
     /* 177916 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 177919 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 177924 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 177927 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 177930 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 177933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 177945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 177949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 177953 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 177957 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177962 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 177966 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 177968 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 177968 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 177971 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 177975 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 177980 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 177986 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 177991 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 177996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 177999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178006 */     GIR_RootConstrainSelectedInstOperands,
     /* 178007 */     // GIR_Coverage, 5250,
     /* 178007 */     GIR_EraseRootFromParent_Done,
     /* 178008 */   // Label 3289: @178008
     /* 178008 */   GIM_Try, /*On fail goto*//*Label 3290*/ GIMT_Encode4(178089), // Rule ID 13516 //
     /* 178013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178034 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178038 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178042 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178046 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178050 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178063 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178067 */     // MIs[2] Operand 1
     /* 178067 */     // No operand predicates
     /* 178067 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178071 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178073 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178087 */     GIR_RootConstrainSelectedInstOperands,
     /* 178088 */     // GIR_Coverage, 13516,
     /* 178088 */     GIR_EraseRootFromParent_Done,
     /* 178089 */   // Label 3290: @178089
     /* 178089 */   GIM_Try, /*On fail goto*//*Label 3291*/ GIMT_Encode4(178170), // Rule ID 13517 //
     /* 178094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178097 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178102 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178105 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178108 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178127 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178136 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178140 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178144 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178148 */     // MIs[2] Operand 1
     /* 178148 */     // No operand predicates
     /* 178148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178154 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178161 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178168 */     GIR_RootConstrainSelectedInstOperands,
     /* 178169 */     // GIR_Coverage, 13517,
     /* 178169 */     GIR_EraseRootFromParent_Done,
     /* 178170 */   // Label 3291: @178170
     /* 178170 */   GIM_Try, /*On fail goto*//*Label 3292*/ GIMT_Encode4(178251), // Rule ID 13519 //
     /* 178175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 178186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 178189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 178192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178208 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178212 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178225 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178229 */     // MIs[2] Operand 1
     /* 178229 */     // No operand predicates
     /* 178229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178233 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178235 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 178238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178249 */     GIR_RootConstrainSelectedInstOperands,
     /* 178250 */     // GIR_Coverage, 13519,
     /* 178250 */     GIR_EraseRootFromParent_Done,
     /* 178251 */   // Label 3292: @178251
     /* 178251 */   GIM_Try, /*On fail goto*//*Label 3293*/ GIMT_Encode4(178332), // Rule ID 13520 //
     /* 178256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 178267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 178270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 178273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 178285 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178289 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178306 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178310 */     // MIs[2] Operand 1
     /* 178310 */     // No operand predicates
     /* 178310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178316 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 178319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178323 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178327 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178330 */     GIR_RootConstrainSelectedInstOperands,
     /* 178331 */     // GIR_Coverage, 13520,
     /* 178331 */     GIR_EraseRootFromParent_Done,
     /* 178332 */   // Label 3293: @178332
     /* 178332 */   GIM_Try, /*On fail goto*//*Label 3294*/ GIMT_Encode4(178413), // Rule ID 13521 //
     /* 178337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 178348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 178351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 178354 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 178366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178370 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178374 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178387 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178391 */     // MIs[2] Operand 1
     /* 178391 */     // No operand predicates
     /* 178391 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 178400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178411 */     GIR_RootConstrainSelectedInstOperands,
     /* 178412 */     // GIR_Coverage, 13521,
     /* 178412 */     GIR_EraseRootFromParent_Done,
     /* 178413 */   // Label 3294: @178413
     /* 178413 */   GIM_Try, /*On fail goto*//*Label 3295*/ GIMT_Encode4(178494), // Rule ID 13522 //
     /* 178418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 178432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 178435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178472 */     // MIs[2] Operand 1
     /* 178472 */     // No operand predicates
     /* 178472 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178476 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178478 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 178481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178485 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178489 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178492 */     GIR_RootConstrainSelectedInstOperands,
     /* 178493 */     // GIR_Coverage, 13522,
     /* 178493 */     GIR_EraseRootFromParent_Done,
     /* 178494 */   // Label 3295: @178494
     /* 178494 */   GIM_Try, /*On fail goto*//*Label 3296*/ GIMT_Encode4(178575), // Rule ID 13523 //
     /* 178499 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178502 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178507 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 178510 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178513 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178520 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178524 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178528 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 178532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178536 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178549 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 178553 */     // MIs[2] Operand 1
     /* 178553 */     // No operand predicates
     /* 178553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178557 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178559 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 178562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178566 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178570 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178573 */     GIR_RootConstrainSelectedInstOperands,
     /* 178574 */     // GIR_Coverage, 13523,
     /* 178574 */     GIR_EraseRootFromParent_Done,
     /* 178575 */   // Label 3296: @178575
     /* 178575 */   GIM_Try, /*On fail goto*//*Label 3297*/ GIMT_Encode4(178656), // Rule ID 13524 //
     /* 178580 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178583 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178588 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 178591 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 178594 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 178597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178601 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178605 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 178609 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 178613 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178622 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178626 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178630 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 178634 */     // MIs[2] Operand 1
     /* 178634 */     // No operand predicates
     /* 178634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178640 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 178643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 178647 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178651 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178654 */     GIR_RootConstrainSelectedInstOperands,
     /* 178655 */     // GIR_Coverage, 13524,
     /* 178655 */     GIR_EraseRootFromParent_Done,
     /* 178656 */   // Label 3297: @178656
     /* 178656 */   GIM_Try, /*On fail goto*//*Label 3298*/ GIMT_Encode4(178762), // Rule ID 6316 //
     /* 178661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 178666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 178669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 178672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 178675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 178683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 178687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 178691 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178696 */     // MIs[1] Operand 2
     /* 178696 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 178707 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 178711 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178715 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 178719 */     // MIs[2] Operand 1
     /* 178719 */     // No operand predicates
     /* 178719 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178721 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, (sext_inreg:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 178721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 178724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 178728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 178733 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 178739 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 178744 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 178749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 178752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178754 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 178757 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 178760 */     GIR_RootConstrainSelectedInstOperands,
     /* 178761 */     // GIR_Coverage, 6316,
     /* 178761 */     GIR_EraseRootFromParent_Done,
     /* 178762 */   // Label 3298: @178762
     /* 178762 */   GIM_Try, /*On fail goto*//*Label 3299*/ GIMT_Encode4(178843), // Rule ID 1988 //
     /* 178767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178792 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178796 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178800 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178804 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178808 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178821 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178825 */     // MIs[2] Operand 1
     /* 178825 */     // No operand predicates
     /* 178825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178827 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i16_indexed),
     /* 178830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178838 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178841 */     GIR_RootConstrainSelectedInstOperands,
     /* 178842 */     // GIR_Coverage, 1988,
     /* 178842 */     GIR_EraseRootFromParent_Done,
     /* 178843 */   // Label 3299: @178843
     /* 178843 */   GIM_Try, /*On fail goto*//*Label 3300*/ GIMT_Encode4(178924), // Rule ID 1989 //
     /* 178848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 178851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 178856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 178859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 178862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 178865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 178873 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178877 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178881 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178885 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178889 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178894 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178898 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178902 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178906 */     // MIs[2] Operand 1
     /* 178906 */     // No operand predicates
     /* 178906 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178908 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8i16_indexed),
     /* 178911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178915 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 178919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 178922 */     GIR_RootConstrainSelectedInstOperands,
     /* 178923 */     // GIR_Coverage, 1989,
     /* 178923 */     GIR_EraseRootFromParent_Done,
     /* 178924 */   // Label 3300: @178924
     /* 178924 */   GIM_Try, /*On fail goto*//*Label 3301*/ GIMT_Encode4(179005), // Rule ID 2018 //
     /* 178929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 178932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 178937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 178940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 178943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 178946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 178954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 178958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 178962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 178966 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 178970 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 178975 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 178979 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 178983 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 178987 */     // MIs[2] Operand 1
     /* 178987 */     // No operand predicates
     /* 178987 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 178989 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 178989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16_indexed),
     /* 178992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 178994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 178996 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179000 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179003 */     GIR_RootConstrainSelectedInstOperands,
     /* 179004 */     // GIR_Coverage, 2018,
     /* 179004 */     GIR_EraseRootFromParent_Done,
     /* 179005 */   // Label 3301: @179005
     /* 179005 */   GIM_Try, /*On fail goto*//*Label 3302*/ GIMT_Encode4(179086), // Rule ID 2019 //
     /* 179010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179068 */     // MIs[2] Operand 1
     /* 179068 */     // No operand predicates
     /* 179068 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179070 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16_indexed),
     /* 179073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179084 */     GIR_RootConstrainSelectedInstOperands,
     /* 179085 */     // GIR_Coverage, 2019,
     /* 179085 */     GIR_EraseRootFromParent_Done,
     /* 179086 */   // Label 3302: @179086
     /* 179086 */   GIM_Try, /*On fail goto*//*Label 3303*/ GIMT_Encode4(179167), // Rule ID 2025 //
     /* 179091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 179102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179108 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179124 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179128 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179132 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179137 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179141 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179145 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179149 */     // MIs[2] Operand 1
     /* 179149 */     // No operand predicates
     /* 179149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179151 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16_indexed),
     /* 179154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179158 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179162 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179165 */     GIR_RootConstrainSelectedInstOperands,
     /* 179166 */     // GIR_Coverage, 2025,
     /* 179166 */     GIR_EraseRootFromParent_Done,
     /* 179167 */   // Label 3303: @179167
     /* 179167 */   GIM_Try, /*On fail goto*//*Label 3304*/ GIMT_Encode4(179248), // Rule ID 2026 //
     /* 179172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 179183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 179186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 179189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179226 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179230 */     // MIs[2] Operand 1
     /* 179230 */     // No operand predicates
     /* 179230 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179232 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMULHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16_indexed),
     /* 179235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179243 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179246 */     GIR_RootConstrainSelectedInstOperands,
     /* 179247 */     // GIR_Coverage, 2026,
     /* 179247 */     GIR_EraseRootFromParent_Done,
     /* 179248 */   // Label 3304: @179248
     /* 179248 */   GIM_Try, /*On fail goto*//*Label 3305*/ GIMT_Encode4(179329), // Rule ID 2084 //
     /* 179253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 179267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 179270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179278 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179282 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 179286 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 179290 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179294 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 179299 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179303 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179307 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 179311 */     // MIs[2] Operand 1
     /* 179311 */     // No operand predicates
     /* 179311 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179313 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQDMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_indexed),
     /* 179316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179318 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179320 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179324 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179327 */     GIR_RootConstrainSelectedInstOperands,
     /* 179328 */     // GIR_Coverage, 2084,
     /* 179328 */     GIR_EraseRootFromParent_Done,
     /* 179329 */   // Label 3305: @179329
     /* 179329 */   GIM_Try, /*On fail goto*//*Label 3306*/ GIMT_Encode4(179410), // Rule ID 1991 //
     /* 179334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179355 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179371 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179375 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179388 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179392 */     // MIs[2] Operand 1
     /* 179392 */     // No operand predicates
     /* 179392 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179394 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i32_indexed),
     /* 179397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179401 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179405 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179408 */     GIR_RootConstrainSelectedInstOperands,
     /* 179409 */     // GIR_Coverage, 1991,
     /* 179409 */     GIR_EraseRootFromParent_Done,
     /* 179410 */   // Label 3306: @179410
     /* 179410 */   GIM_Try, /*On fail goto*//*Label 3307*/ GIMT_Encode4(179491), // Rule ID 1992 //
     /* 179415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179436 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179469 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179473 */     // MIs[2] Operand 1
     /* 179473 */     // No operand predicates
     /* 179473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179475 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4i32_indexed),
     /* 179478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179486 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179489 */     GIR_RootConstrainSelectedInstOperands,
     /* 179490 */     // GIR_Coverage, 1992,
     /* 179490 */     GIR_EraseRootFromParent_Done,
     /* 179491 */   // Label 3307: @179491
     /* 179491 */   GIM_Try, /*On fail goto*//*Label 3308*/ GIMT_Encode4(179572), // Rule ID 2021 //
     /* 179496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179517 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179525 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179529 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179533 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179537 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179550 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179554 */     // MIs[2] Operand 1
     /* 179554 */     // No operand predicates
     /* 179554 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179556 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32_indexed),
     /* 179559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179563 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179567 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179570 */     GIR_RootConstrainSelectedInstOperands,
     /* 179571 */     // GIR_Coverage, 2021,
     /* 179571 */     GIR_EraseRootFromParent_Done,
     /* 179572 */   // Label 3308: @179572
     /* 179572 */   GIM_Try, /*On fail goto*//*Label 3309*/ GIMT_Encode4(179653), // Rule ID 2022 //
     /* 179577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 179585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179594 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179606 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179610 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179614 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179618 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179631 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179635 */     // MIs[2] Operand 1
     /* 179635 */     // No operand predicates
     /* 179635 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179637 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32_indexed),
     /* 179640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179648 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179651 */     GIR_RootConstrainSelectedInstOperands,
     /* 179652 */     // GIR_Coverage, 2022,
     /* 179652 */     GIR_EraseRootFromParent_Done,
     /* 179653 */   // Label 3309: @179653
     /* 179653 */   GIM_Try, /*On fail goto*//*Label 3310*/ GIMT_Encode4(179734), // Rule ID 2028 //
     /* 179658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 179669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179691 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179695 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179699 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179712 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179716 */     // MIs[2] Operand 1
     /* 179716 */     // No operand predicates
     /* 179716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179718 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32_indexed),
     /* 179721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179723 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179725 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179729 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179732 */     GIR_RootConstrainSelectedInstOperands,
     /* 179733 */     // GIR_Coverage, 2028,
     /* 179733 */     GIR_EraseRootFromParent_Done,
     /* 179734 */   // Label 3310: @179734
     /* 179734 */   GIM_Try, /*On fail goto*//*Label 3311*/ GIMT_Encode4(179815), // Rule ID 2029 //
     /* 179739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 179747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 179750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 179753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 179756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179760 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179772 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179776 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179797 */     // MIs[2] Operand 1
     /* 179797 */     // No operand predicates
     /* 179797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179799 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32_indexed),
     /* 179802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179806 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179813 */     GIR_RootConstrainSelectedInstOperands,
     /* 179814 */     // GIR_Coverage, 2029,
     /* 179814 */     GIR_EraseRootFromParent_Done,
     /* 179815 */   // Label 3311: @179815
     /* 179815 */   GIM_Try, /*On fail goto*//*Label 3312*/ GIMT_Encode4(179896), // Rule ID 2087 //
     /* 179820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 179828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 179834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 179837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 179845 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179849 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 179853 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 179857 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179861 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179874 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 179878 */     // MIs[2] Operand 1
     /* 179878 */     // No operand predicates
     /* 179878 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179880 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_indexed),
     /* 179883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179894 */     GIR_RootConstrainSelectedInstOperands,
     /* 179895 */     // GIR_Coverage, 2087,
     /* 179895 */     GIR_EraseRootFromParent_Done,
     /* 179896 */   // Label 3312: @179896
     /* 179896 */   GIM_Try, /*On fail goto*//*Label 3313*/ GIMT_Encode4(179977), // Rule ID 1993 //
     /* 179901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 179904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 179912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 179915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 179918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179922 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 179930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 179934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 179938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 179942 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 179947 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 179951 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 179955 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 179959 */     // MIs[2] Operand 1
     /* 179959 */     // No operand predicates
     /* 179959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 179961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 179961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2i64_indexed),
     /* 179964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 179966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 179968 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 179972 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 179975 */     GIR_RootConstrainSelectedInstOperands,
     /* 179976 */     // GIR_Coverage, 1993,
     /* 179976 */     GIR_EraseRootFromParent_Done,
     /* 179977 */   // Label 3313: @179977
     /* 179977 */   GIM_Try, /*On fail goto*//*Label 3314*/ GIMT_Encode4(180058), // Rule ID 1994 //
     /* 179982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 179985 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 179990 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 179993 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 179996 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 179999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 180007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 180019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 180028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180036 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 180040 */     // MIs[2] Operand 1
     /* 180040 */     // No operand predicates
     /* 180040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180042 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULXv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i16_indexed),
     /* 180045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180049 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180056 */     GIR_RootConstrainSelectedInstOperands,
     /* 180057 */     // GIR_Coverage, 1994,
     /* 180057 */     GIR_EraseRootFromParent_Done,
     /* 180058 */   // Label 3314: @180058
     /* 180058 */   GIM_Try, /*On fail goto*//*Label 3315*/ GIMT_Encode4(180139), // Rule ID 1995 //
     /* 180063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180121 */     // MIs[2] Operand 1
     /* 180121 */     // No operand predicates
     /* 180121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180123 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULXv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i32_indexed),
     /* 180126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180130 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180134 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180137 */     GIR_RootConstrainSelectedInstOperands,
     /* 180138 */     // GIR_Coverage, 1995,
     /* 180138 */     GIR_EraseRootFromParent_Done,
     /* 180139 */   // Label 3315: @180139
     /* 180139 */   GIM_Try, /*On fail goto*//*Label 3316*/ GIMT_Encode4(180220), // Rule ID 1996 //
     /* 180144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 180152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 180161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180177 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 180181 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180185 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180190 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180194 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180198 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 180202 */     // MIs[2] Operand 1
     /* 180202 */     // No operand predicates
     /* 180202 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180204 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULXv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv1i64_indexed),
     /* 180207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180218 */     GIR_RootConstrainSelectedInstOperands,
     /* 180219 */     // GIR_Coverage, 1996,
     /* 180219 */     GIR_EraseRootFromParent_Done,
     /* 180220 */   // Label 3316: @180220
     /* 180220 */   GIM_Try, /*On fail goto*//*Label 3317*/ GIMT_Encode4(180301), // Rule ID 2023 //
     /* 180225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 180233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180242 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180262 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180266 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180271 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180275 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180279 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180283 */     // MIs[2] Operand 1
     /* 180283 */     // No operand predicates
     /* 180283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180285 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32_indexed),
     /* 180288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180296 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180299 */     GIR_RootConstrainSelectedInstOperands,
     /* 180300 */     // GIR_Coverage, 2023,
     /* 180300 */     GIR_EraseRootFromParent_Done,
     /* 180301 */   // Label 3317: @180301
     /* 180301 */   GIM_Try, /*On fail goto*//*Label 3318*/ GIMT_Encode4(180382), // Rule ID 2030 //
     /* 180306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 180309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 180314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 180317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180327 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180364 */     // MIs[2] Operand 1
     /* 180364 */     // No operand predicates
     /* 180364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180366 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMULHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 180366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32_indexed),
     /* 180369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 180377 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180380 */     GIR_RootConstrainSelectedInstOperands,
     /* 180381 */     // GIR_Coverage, 2030,
     /* 180381 */     GIR_EraseRootFromParent_Done,
     /* 180382 */   // Label 3318: @180382
     /* 180382 */   GIM_Try, /*On fail goto*//*Label 3319*/ GIMT_Encode4(180460), // Rule ID 6303 //
     /* 180387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 180392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 180398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180405 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 180409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 180413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 180417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 180421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 180425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 180434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 180438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 180442 */     // MIs[2] Operand 1
     /* 180442 */     // No operand predicates
     /* 180442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 180444 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQDMULLv1i64_indexed:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Vm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 180444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv1i64_indexed),
     /* 180447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 180451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vm
     /* 180455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 180458 */     GIR_RootConstrainSelectedInstOperands,
     /* 180459 */     // GIR_Coverage, 6303,
     /* 180459 */     GIR_EraseRootFromParent_Done,
     /* 180460 */   // Label 3319: @180460
     /* 180460 */   GIM_Try, /*On fail goto*//*Label 3320*/ GIMT_Encode4(180520), // Rule ID 6369 //
     /* 180465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 180473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 180476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180487 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 8,
     /* 180491 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vn, 8:{ *:[i32] })  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Vn, (MOVIv2d_ns:{ *:[v8i16] } 0:{ *:[i32] }))
     /* 180491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 180494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180503 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180506 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 180511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180515 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180518 */     GIR_RootConstrainSelectedInstOperands,
     /* 180519 */     // GIR_Coverage, 6369,
     /* 180519 */     GIR_EraseRootFromParent_Done,
     /* 180520 */   // Label 3320: @180520
     /* 180520 */   GIM_Try, /*On fail goto*//*Label 3321*/ GIMT_Encode4(180580), // Rule ID 6370 //
     /* 180525 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180530 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 180533 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 180536 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180543 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180547 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 16,
     /* 180551 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, 16:{ *:[i32] })  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn, (MOVIv2d_ns:{ *:[v4i32] } 0:{ *:[i32] }))
     /* 180551 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 180554 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180558 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180563 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180566 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 180571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180575 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180578 */     GIR_RootConstrainSelectedInstOperands,
     /* 180579 */     // GIR_Coverage, 6370,
     /* 180579 */     GIR_EraseRootFromParent_Done,
     /* 180580 */   // Label 3321: @180580
     /* 180580 */   GIM_Try, /*On fail goto*//*Label 3322*/ GIMT_Encode4(180640), // Rule ID 6371 //
     /* 180585 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 180590 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 180593 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 180596 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 180599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 180603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 180607 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 32,
     /* 180611 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, 32:{ *:[i32] })  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn, (MOVIv2d_ns:{ *:[v2i64] } 0:{ *:[i32] }))
     /* 180611 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 180614 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 180618 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 180623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 180626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 180628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 180631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 180635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 180638 */     GIR_RootConstrainSelectedInstOperands,
     /* 180639 */     // GIR_Coverage, 6371,
     /* 180639 */     GIR_EraseRootFromParent_Done,
     /* 180640 */   // Label 3322: @180640
     /* 180640 */   GIM_Try, /*On fail goto*//*Label 3323*/ GIMT_Encode4(180687), // Rule ID 3896 //
     /* 180645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180663 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180667 */     // MIs[0] Operand 3
     /* 180667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 180678 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180683 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180685 */     GIR_RootConstrainSelectedInstOperands,
     /* 180686 */     // GIR_Coverage, 3896,
     /* 180686 */     GIR_EraseRootFromParent_Done,
     /* 180687 */   // Label 3323: @180687
     /* 180687 */   GIM_Try, /*On fail goto*//*Label 3324*/ GIMT_Encode4(180734), // Rule ID 3897 //
     /* 180692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180706 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180714 */     // MIs[0] Operand 3
     /* 180714 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 180725 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] })  =>  (XPACI:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACI),
     /* 180728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180732 */     GIR_RootConstrainSelectedInstOperands,
     /* 180733 */     // GIR_Coverage, 3897,
     /* 180733 */     GIR_EraseRootFromParent_Done,
     /* 180734 */   // Label 3324: @180734
     /* 180734 */   GIM_Try, /*On fail goto*//*Label 3325*/ GIMT_Encode4(180781), // Rule ID 3898 //
     /* 180739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180753 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180757 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180761 */     // MIs[0] Operand 3
     /* 180761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 180772 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180779 */     GIR_RootConstrainSelectedInstOperands,
     /* 180780 */     // GIR_Coverage, 3898,
     /* 180780 */     GIR_EraseRootFromParent_Done,
     /* 180781 */   // Label 3325: @180781
     /* 180781 */   GIM_Try, /*On fail goto*//*Label 3326*/ GIMT_Encode4(180828), // Rule ID 3899 //
     /* 180786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 180789 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_strip),
     /* 180794 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 180797 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 180800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 180808 */     // MIs[0] Operand 3
     /* 180808 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 180819 */     // (intrinsic_wo_chain:{ *:[i64] } 299:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] })  =>  (XPACD:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 180819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XPACD),
     /* 180822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 180824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 180826 */     GIR_RootConstrainSelectedInstOperands,
     /* 180827 */     // GIR_Coverage, 3899,
     /* 180827 */     GIR_EraseRootFromParent_Done,
     /* 180828 */   // Label 3326: @180828
     /* 180828 */   GIM_Try, /*On fail goto*//*Label 3327*/ GIMT_Encode4(180874), // Rule ID 3539 //
     /* 180833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 180844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 180847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180855 */     // MIs[0] Idx
     /* 180855 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180858 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_0),
     /* 180863 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)  =>  (PMOV_PZI_B:{ *:[nxv16i1] } ZPRAny:{ *:[nxv16i8] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_0>>:$Idx)
     /* 180863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_B),
     /* 180866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180872 */     GIR_RootConstrainSelectedInstOperands,
     /* 180873 */     // GIR_Coverage, 3539,
     /* 180873 */     GIR_EraseRootFromParent_Done,
     /* 180874 */   // Label 3327: @180874
     /* 180874 */   GIM_Try, /*On fail goto*//*Label 3328*/ GIMT_Encode4(180920), // Rule ID 3540 //
     /* 180879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 180890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 180893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180897 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180901 */     // MIs[0] Idx
     /* 180901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 180909 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)  =>  (PMOV_PZI_H:{ *:[nxv8i1] } ZPRAny:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Idx)
     /* 180909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_H),
     /* 180912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180918 */     GIR_RootConstrainSelectedInstOperands,
     /* 180919 */     // GIR_Coverage, 3540,
     /* 180919 */     GIR_EraseRootFromParent_Done,
     /* 180920 */   // Label 3328: @180920
     /* 180920 */   GIM_Try, /*On fail goto*//*Label 3329*/ GIMT_Encode4(180966), // Rule ID 3541 //
     /* 180925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 180936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 180939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180947 */     // MIs[0] Idx
     /* 180947 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180950 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 180955 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)  =>  (PMOV_PZI_S:{ *:[nxv4i1] } ZPRAny:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Idx)
     /* 180955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_S),
     /* 180958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 180960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 180962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 180964 */     GIR_RootConstrainSelectedInstOperands,
     /* 180965 */     // GIR_Coverage, 3541,
     /* 180965 */     GIR_EraseRootFromParent_Done,
     /* 180966 */   // Label 3329: @180966
     /* 180966 */   GIM_Try, /*On fail goto*//*Label 3330*/ GIMT_Encode4(181012), // Rule ID 3542 //
     /* 180971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 180974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_pred_lane),
     /* 180979 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 180982 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 180985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 180989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 180993 */     // MIs[0] Idx
     /* 180993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 180996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 181001 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1633:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)  =>  (PMOV_PZI_D:{ *:[nxv2i1] } ZPRAny:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Idx)
     /* 181001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_PZI_D),
     /* 181004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 181006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 181008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Idx
     /* 181010 */     GIR_RootConstrainSelectedInstOperands,
     /* 181011 */     // GIR_Coverage, 3542,
     /* 181011 */     GIR_EraseRootFromParent_Done,
     /* 181012 */   // Label 3330: @181012
     /* 181012 */   GIM_Try, /*On fail goto*//*Label 3331*/ GIMT_Encode4(181068), // Rule ID 2109 //
     /* 181017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrn),
     /* 181025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181034 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181050 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181054 */     // MIs[1] Operand 1
     /* 181054 */     // No operand predicates
     /* 181054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181056 */     // (intrinsic_wo_chain:{ *:[i32] } 699:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNs),
     /* 181059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181063 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181066 */     GIR_RootConstrainSelectedInstOperands,
     /* 181067 */     // GIR_Coverage, 2109,
     /* 181067 */     GIR_EraseRootFromParent_Done,
     /* 181068 */   // Label 3331: @181068
     /* 181068 */   GIM_Try, /*On fail goto*//*Label 3332*/ GIMT_Encode4(181124), // Rule ID 2110 //
     /* 181073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshrun),
     /* 181081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181106 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181110 */     // MIs[1] Operand 1
     /* 181110 */     // No operand predicates
     /* 181110 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181112 */     // (intrinsic_wo_chain:{ *:[i32] } 700:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQRSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNs),
     /* 181115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181119 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181122 */     GIR_RootConstrainSelectedInstOperands,
     /* 181123 */     // GIR_Coverage, 2110,
     /* 181123 */     GIR_EraseRootFromParent_Done,
     /* 181124 */   // Label 3332: @181124
     /* 181124 */   GIM_Try, /*On fail goto*//*Label 3333*/ GIMT_Encode4(181180), // Rule ID 2115 //
     /* 181129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrn),
     /* 181137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181150 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181162 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181166 */     // MIs[1] Operand 1
     /* 181166 */     // No operand predicates
     /* 181166 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181168 */     // (intrinsic_wo_chain:{ *:[i32] } 703:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNs),
     /* 181171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181178 */     GIR_RootConstrainSelectedInstOperands,
     /* 181179 */     // GIR_Coverage, 2115,
     /* 181179 */     GIR_EraseRootFromParent_Done,
     /* 181180 */   // Label 3333: @181180
     /* 181180 */   GIM_Try, /*On fail goto*//*Label 3334*/ GIMT_Encode4(181236), // Rule ID 2116 //
     /* 181185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshrun),
     /* 181193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181210 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181214 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181218 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181222 */     // MIs[1] Operand 1
     /* 181222 */     // No operand predicates
     /* 181222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181224 */     // (intrinsic_wo_chain:{ *:[i32] } 704:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SQSHRUNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNs),
     /* 181227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181234 */     GIR_RootConstrainSelectedInstOperands,
     /* 181235 */     // GIR_Coverage, 2116,
     /* 181235 */     GIR_EraseRootFromParent_Done,
     /* 181236 */   // Label 3334: @181236
     /* 181236 */   GIM_Try, /*On fail goto*//*Label 3335*/ GIMT_Encode4(181292), // Rule ID 2123 //
     /* 181241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshrn),
     /* 181249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181274 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181278 */     // MIs[1] Operand 1
     /* 181278 */     // No operand predicates
     /* 181278 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181280 */     // (intrinsic_wo_chain:{ *:[i32] } 748:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQRSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNs),
     /* 181283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181290 */     GIR_RootConstrainSelectedInstOperands,
     /* 181291 */     // GIR_Coverage, 2123,
     /* 181291 */     GIR_EraseRootFromParent_Done,
     /* 181292 */   // Label 3335: @181292
     /* 181292 */   GIM_Try, /*On fail goto*//*Label 3336*/ GIMT_Encode4(181348), // Rule ID 2126 //
     /* 181297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshrn),
     /* 181305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181318 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181322 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181326 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181330 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181334 */     // MIs[1] Operand 1
     /* 181334 */     // No operand predicates
     /* 181334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181336 */     // (intrinsic_wo_chain:{ *:[i32] } 750:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UQSHRNs:{ *:[i32] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNs),
     /* 181339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181343 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181346 */     GIR_RootConstrainSelectedInstOperands,
     /* 181347 */     // GIR_Coverage, 2126,
     /* 181347 */     GIR_EraseRootFromParent_Done,
     /* 181348 */   // Label 3336: @181348
     /* 181348 */   GIM_Try, /*On fail goto*//*Label 3337*/ GIMT_Encode4(181404), // Rule ID 2148 //
     /* 181353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 181364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 181367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181378 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181382 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181386 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 181390 */     // MIs[1] Operand 1
     /* 181390 */     // No operand predicates
     /* 181390 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181392 */     // (intrinsic_wo_chain:{ *:[v8i8] } 664:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)  =>  (RSHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv8i8_shift),
     /* 181395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181402 */     GIR_RootConstrainSelectedInstOperands,
     /* 181403 */     // GIR_Coverage, 2148,
     /* 181403 */     GIR_EraseRootFromParent_Done,
     /* 181404 */   // Label 3337: @181404
     /* 181404 */   GIM_Try, /*On fail goto*//*Label 3338*/ GIMT_Encode4(181460), // Rule ID 2150 //
     /* 181409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 181420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 181423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181438 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181442 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 181446 */     // MIs[1] Operand 1
     /* 181446 */     // No operand predicates
     /* 181446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181448 */     // (intrinsic_wo_chain:{ *:[v4i16] } 664:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)  =>  (RSHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv4i16_shift),
     /* 181451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181458 */     GIR_RootConstrainSelectedInstOperands,
     /* 181459 */     // GIR_Coverage, 2150,
     /* 181459 */     GIR_EraseRootFromParent_Done,
     /* 181460 */   // Label 3338: @181460
     /* 181460 */   GIM_Try, /*On fail goto*//*Label 3339*/ GIMT_Encode4(181516), // Rule ID 2152 //
     /* 181465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 181468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rshrn),
     /* 181473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 181476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 181479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 181490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181498 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 181502 */     // MIs[1] Operand 1
     /* 181502 */     // No operand predicates
     /* 181502 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181504 */     // (intrinsic_wo_chain:{ *:[v2i32] } 664:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)  =>  (RSHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 181504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNv2i32_shift),
     /* 181507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181511 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181514 */     GIR_RootConstrainSelectedInstOperands,
     /* 181515 */     // GIR_Coverage, 2152,
     /* 181515 */     GIR_EraseRootFromParent_Done,
     /* 181516 */   // Label 3339: @181516
     /* 181516 */   GIM_Try, /*On fail goto*//*Label 3340*/ GIMT_Encode4(181569), // Rule ID 6304 //
     /* 181521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181551 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181555 */     // MIs[1] Operand 1
     /* 181555 */     // No operand predicates
     /* 181555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181557 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZSs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSs),
     /* 181560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181567 */     GIR_RootConstrainSelectedInstOperands,
     /* 181568 */     // GIR_Coverage, 6304,
     /* 181568 */     GIR_EraseRootFromParent_Done,
     /* 181569 */   // Label 3340: @181569
     /* 181569 */   GIM_Try, /*On fail goto*//*Label 3341*/ GIMT_Encode4(181622), // Rule ID 6305 //
     /* 181574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181592 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181604 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181608 */     // MIs[1] Operand 1
     /* 181608 */     // No operand predicates
     /* 181608 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181610 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (FCVTZUs:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUs),
     /* 181613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181620 */     GIR_RootConstrainSelectedInstOperands,
     /* 181621 */     // GIR_Coverage, 6305,
     /* 181621 */     GIR_EraseRootFromParent_Done,
     /* 181622 */   // Label 3341: @181622
     /* 181622 */   GIM_Try, /*On fail goto*//*Label 3342*/ GIMT_Encode4(181675), // Rule ID 6306 //
     /* 181627 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181632 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181635 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181638 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181657 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181661 */     // MIs[1] Operand 1
     /* 181661 */     // No operand predicates
     /* 181661 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181663 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181670 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181673 */     GIR_RootConstrainSelectedInstOperands,
     /* 181674 */     // GIR_Coverage, 6306,
     /* 181674 */     GIR_EraseRootFromParent_Done,
     /* 181675 */   // Label 3342: @181675
     /* 181675 */   GIM_Try, /*On fail goto*//*Label 3343*/ GIMT_Encode4(181728), // Rule ID 6307 //
     /* 181680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181702 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181706 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181710 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181714 */     // MIs[1] Operand 1
     /* 181714 */     // No operand predicates
     /* 181714 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181716 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181723 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181726 */     GIR_RootConstrainSelectedInstOperands,
     /* 181727 */     // GIR_Coverage, 6307,
     /* 181727 */     GIR_EraseRootFromParent_Done,
     /* 181728 */   // Label 3343: @181728
     /* 181728 */   GIM_Try, /*On fail goto*//*Label 3344*/ GIMT_Encode4(181781), // Rule ID 6308 //
     /* 181733 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 181738 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181763 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181767 */     // MIs[1] Operand 1
     /* 181767 */     // No operand predicates
     /* 181767 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181769 */     // (intrinsic_wo_chain:{ *:[v1i64] } 769:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZSd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSd),
     /* 181772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181779 */     GIR_RootConstrainSelectedInstOperands,
     /* 181780 */     // GIR_Coverage, 6308,
     /* 181780 */     GIR_EraseRootFromParent_Done,
     /* 181781 */   // Label 3344: @181781
     /* 181781 */   GIM_Try, /*On fail goto*//*Label 3345*/ GIMT_Encode4(181834), // Rule ID 6309 //
     /* 181786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 181791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181808 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181812 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181816 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181820 */     // MIs[1] Operand 1
     /* 181820 */     // No operand predicates
     /* 181820 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181822 */     // (intrinsic_wo_chain:{ *:[v1i64] } 770:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (FCVTZUd:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUd),
     /* 181825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181832 */     GIR_RootConstrainSelectedInstOperands,
     /* 181833 */     // GIR_Coverage, 6309,
     /* 181833 */     GIR_EraseRootFromParent_Done,
     /* 181834 */   // Label 3345: @181834
     /* 181834 */   GIM_Try, /*On fail goto*//*Label 3346*/ GIMT_Encode4(181887), // Rule ID 6310 //
     /* 181839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 181847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 181850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 181861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181869 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 181873 */     // MIs[1] Operand 1
     /* 181873 */     // No operand predicates
     /* 181873 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181875 */     // (intrinsic_wo_chain:{ *:[f32] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (UCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 181875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFs),
     /* 181878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181882 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181885 */     GIR_RootConstrainSelectedInstOperands,
     /* 181886 */     // GIR_Coverage, 6310,
     /* 181886 */     GIR_EraseRootFromParent_Done,
     /* 181887 */   // Label 3346: @181887
     /* 181887 */   GIM_Try, /*On fail goto*//*Label 3347*/ GIMT_Encode4(181940), // Rule ID 6311 //
     /* 181892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 181897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181914 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181918 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181922 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181926 */     // MIs[1] Operand 1
     /* 181926 */     // No operand predicates
     /* 181926 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181928 */     // (intrinsic_wo_chain:{ *:[f64] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 181931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181933 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181935 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181938 */     GIR_RootConstrainSelectedInstOperands,
     /* 181939 */     // GIR_Coverage, 6311,
     /* 181939 */     GIR_EraseRootFromParent_Done,
     /* 181940 */   // Label 3347: @181940
     /* 181940 */   GIM_Try, /*On fail goto*//*Label 3348*/ GIMT_Encode4(181993), // Rule ID 6312 //
     /* 181945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 181950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 181953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 181956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 181959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181963 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 181967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 181971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 181975 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 181979 */     // MIs[1] Operand 1
     /* 181979 */     // No operand predicates
     /* 181979 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 181981 */     // (intrinsic_wo_chain:{ *:[v1f64] } 772:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 181981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 181984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 181986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 181988 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 181991 */     GIR_RootConstrainSelectedInstOperands,
     /* 181992 */     // GIR_Coverage, 6312,
     /* 181992 */     GIR_EraseRootFromParent_Done,
     /* 181993 */   // Label 3348: @181993
     /* 181993 */   GIM_Try, /*On fail goto*//*Label 3349*/ GIMT_Encode4(182046), // Rule ID 6313 //
     /* 181998 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182003 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182028 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182032 */     // MIs[1] Operand 1
     /* 182032 */     // No operand predicates
     /* 182032 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182034 */     // (intrinsic_wo_chain:{ *:[f64] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SCVTFd:{ *:[f64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFd),
     /* 182037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182041 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182044 */     GIR_RootConstrainSelectedInstOperands,
     /* 182045 */     // GIR_Coverage, 6313,
     /* 182045 */     GIR_EraseRootFromParent_Done,
     /* 182046 */   // Label 3349: @182046
     /* 182046 */   GIM_Try, /*On fail goto*//*Label 3350*/ GIMT_Encode4(182099), // Rule ID 6314 //
     /* 182051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182081 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182085 */     // MIs[1] Operand 1
     /* 182085 */     // No operand predicates
     /* 182085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182087 */     // (intrinsic_wo_chain:{ *:[v1f64] } 773:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (UCVTFd:{ *:[v1f64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 182087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFd),
     /* 182090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182094 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182097 */     GIR_RootConstrainSelectedInstOperands,
     /* 182098 */     // GIR_Coverage, 6314,
     /* 182098 */     GIR_EraseRootFromParent_Done,
     /* 182099 */   // Label 3350: @182099
     /* 182099 */   GIM_Try, /*On fail goto*//*Label 3351*/ GIMT_Encode4(182152), // Rule ID 6315 //
     /* 182104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182134 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182138 */     // MIs[1] Operand 1
     /* 182138 */     // No operand predicates
     /* 182138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182140 */     // (intrinsic_wo_chain:{ *:[f32] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SCVTFs:{ *:[f32] } FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)
     /* 182140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFs),
     /* 182143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 182147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182150 */     GIR_RootConstrainSelectedInstOperands,
     /* 182151 */     // GIR_Coverage, 6315,
     /* 182151 */     GIR_EraseRootFromParent_Done,
     /* 182152 */   // Label 3351: @182152
     /* 182152 */   GIM_Try, /*On fail goto*//*Label 3352*/ GIMT_Encode4(182234), // Rule ID 6317 //
     /* 182157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182187 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182191 */     // MIs[1] Operand 1
     /* 182191 */     // No operand predicates
     /* 182191 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182193 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182193 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182196 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182200 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182205 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182229 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182232 */     GIR_RootConstrainSelectedInstOperands,
     /* 182233 */     // GIR_Coverage, 6317,
     /* 182233 */     GIR_EraseRootFromParent_Done,
     /* 182234 */   // Label 3352: @182234
     /* 182234 */   GIM_Try, /*On fail goto*//*Label 3353*/ GIMT_Encode4(182316), // Rule ID 6318 //
     /* 182239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 182244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182269 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182273 */     // MIs[1] Operand 1
     /* 182273 */     // No operand predicates
     /* 182273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182275 */     // (intrinsic_wo_chain:{ *:[f16] } 772:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182275 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182278 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182282 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182287 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFh),
     /* 182306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182308 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182314 */     GIR_RootConstrainSelectedInstOperands,
     /* 182315 */     // GIR_Coverage, 6318,
     /* 182315 */     GIR_EraseRootFromParent_Done,
     /* 182316 */   // Label 3353: @182316
     /* 182316 */   GIM_Try, /*On fail goto*//*Label 3354*/ GIMT_Encode4(182398), // Rule ID 6320 //
     /* 182321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 182332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182351 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182355 */     // MIs[1] Operand 1
     /* 182355 */     // No operand predicates
     /* 182355 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182357 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR32:{ *:[i32] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182357 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182360 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182364 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182369 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182375 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182380 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182390 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182393 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182396 */     GIR_RootConstrainSelectedInstOperands,
     /* 182397 */     // GIR_Coverage, 6320,
     /* 182397 */     GIR_EraseRootFromParent_Done,
     /* 182398 */   // Label 3354: @182398
     /* 182398 */   GIM_Try, /*On fail goto*//*Label 3355*/ GIMT_Encode4(182480), // Rule ID 6321 //
     /* 182403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 182408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 182411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182421 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182429 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182433 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 182437 */     // MIs[1] Operand 1
     /* 182437 */     // No operand predicates
     /* 182437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182439 */     // (intrinsic_wo_chain:{ *:[f16] } 773:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (UCVTFh:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR64:{ *:[i64] }:$Rn, hsub:{ *:[i32] }), (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)
     /* 182439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 182442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 182446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 182457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFh),
     /* 182470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182472 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182475 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 182478 */     GIR_RootConstrainSelectedInstOperands,
     /* 182479 */     // GIR_Coverage, 6321,
     /* 182479 */     GIR_EraseRootFromParent_Done,
     /* 182480 */   // Label 3355: @182480
     /* 182480 */   GIM_Try, /*On fail goto*//*Label 3356*/ GIMT_Encode4(182586), // Rule ID 6322 //
     /* 182485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182503 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182515 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182519 */     // MIs[1] Operand 1
     /* 182519 */     // No operand predicates
     /* 182519 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182521 */     // (intrinsic_wo_chain:{ *:[i32] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182521 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182524 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182528 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182533 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182554 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182561 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182564 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182567 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182570 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182585 */     // GIR_Coverage, 6322,
     /* 182585 */     GIR_EraseRootFromParent_Done,
     /* 182586 */   // Label 3356: @182586
     /* 182586 */   GIM_Try, /*On fail goto*//*Label 3357*/ GIMT_Encode4(182692), // Rule ID 6323 //
     /* 182591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 182596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182621 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182625 */     // MIs[1] Operand 1
     /* 182625 */     // No operand predicates
     /* 182625 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182627 */     // (intrinsic_wo_chain:{ *:[i64] } 769:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZSh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182627 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182630 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSh),
     /* 182634 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182639 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182646 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182648 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182651 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182655 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182660 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182667 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182670 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182673 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182681 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182686 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182691 */     // GIR_Coverage, 6323,
     /* 182691 */     GIR_EraseRootFromParent_Done,
     /* 182692 */   // Label 3357: @182692
     /* 182692 */   GIM_Try, /*On fail goto*//*Label 3358*/ GIMT_Encode4(182798), // Rule ID 6324 //
     /* 182697 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182702 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 182705 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182708 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182727 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 182731 */     // MIs[1] Operand 1
     /* 182731 */     // No operand predicates
     /* 182731 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182733 */     // (intrinsic_wo_chain:{ *:[i32] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm), hsub:{ *:[i32] })
     /* 182733 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182736 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182740 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182745 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182752 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 182757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182766 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182773 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182776 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182779 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182782 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182787 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 182792 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182797 */     // GIR_Coverage, 6324,
     /* 182797 */     GIR_EraseRootFromParent_Done,
     /* 182798 */   // Label 3358: @182798
     /* 182798 */   GIM_Try, /*On fail goto*//*Label 3359*/ GIMT_Encode4(182904), // Rule ID 6325 //
     /* 182803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 182808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 182814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 182817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182821 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182833 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 182837 */     // MIs[1] Operand 1
     /* 182837 */     // No operand predicates
     /* 182837 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182839 */     // (intrinsic_wo_chain:{ *:[i64] } 770:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), (FCVTZUh:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm), hsub:{ *:[i32] })
     /* 182839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 182842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUh),
     /* 182846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182851 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 182855 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/1, // imm
     /* 182858 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 182860 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 182863 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 182867 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 182872 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 182874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 182877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 182879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 182882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 182885 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 182888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 182898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 182903 */     // GIR_Coverage, 6325,
     /* 182903 */     GIR_EraseRootFromParent_Done,
     /* 182904 */   // Label 3359: @182904
     /* 182904 */   GIM_Try, /*On fail goto*//*Label 3360*/ GIMT_Encode4(182962), // Rule ID 7016 //
     /* 182909 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 182914 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 182917 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 182920 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 182923 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182927 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 182931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 182935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 182939 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm64_0_65535),
     /* 182943 */     // MIs[1] Operand 1
     /* 182943 */     // No operand predicates
     /* 182943 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 182945 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm)  =>  (MOVKXi:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm64_0_65535>>:$imm), 48:{ *:[i32] })
     /* 182945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVKXi),
     /* 182948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 182950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 182952 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // imm
     /* 182957 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/48,
     /* 182960 */     GIR_RootConstrainSelectedInstOperands,
     /* 182961 */     // GIR_Coverage, 7016,
     /* 182961 */     GIR_EraseRootFromParent_Done,
     /* 182962 */   // Label 3360: @182962
     /* 182962 */   GIM_Try, /*On fail goto*//*Label 3361*/ GIMT_Encode4(183004), // Rule ID 3041 //
     /* 182967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 182970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 182975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 182978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 182981 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 182985 */     // MIs[0] Op2
     /* 182985 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 182988 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 182993 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1871:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 182993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_H),
     /* 182996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 182998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183002 */     GIR_RootConstrainSelectedInstOperands,
     /* 183003 */     // GIR_Coverage, 3041,
     /* 183003 */     GIR_EraseRootFromParent_Done,
     /* 183004 */   // Label 3361: @183004
     /* 183004 */   GIM_Try, /*On fail goto*//*Label 3362*/ GIMT_Encode4(183046), // Rule ID 3042 //
     /* 183009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183027 */     // MIs[0] Op2
     /* 183027 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183030 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 183035 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1871:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 183035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_S),
     /* 183038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183044 */     GIR_RootConstrainSelectedInstOperands,
     /* 183045 */     // GIR_Coverage, 3042,
     /* 183045 */     GIR_EraseRootFromParent_Done,
     /* 183046 */   // Label 3362: @183046
     /* 183046 */   GIM_Try, /*On fail goto*//*Label 3363*/ GIMT_Encode4(183088), // Rule ID 3043 //
     /* 183051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllb),
     /* 183059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183069 */     // MIs[0] Op2
     /* 183069 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183072 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 183077 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1871:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 183077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLB_ZZI_D),
     /* 183080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183086 */     GIR_RootConstrainSelectedInstOperands,
     /* 183087 */     // GIR_Coverage, 3043,
     /* 183087 */     GIR_EraseRootFromParent_Done,
     /* 183088 */   // Label 3363: @183088
     /* 183088 */   GIM_Try, /*On fail goto*//*Label 3364*/ GIMT_Encode4(183130), // Rule ID 3077 //
     /* 183093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183111 */     // MIs[0] Op2
     /* 183111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183119 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1852:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_B),
     /* 183122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183128 */     GIR_RootConstrainSelectedInstOperands,
     /* 183129 */     // GIR_Coverage, 3077,
     /* 183129 */     GIR_EraseRootFromParent_Done,
     /* 183130 */   // Label 3364: @183130
     /* 183130 */   GIM_Try, /*On fail goto*//*Label 3365*/ GIMT_Encode4(183172), // Rule ID 3078 //
     /* 183135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183153 */     // MIs[0] Op2
     /* 183153 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183156 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183161 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1852:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_H),
     /* 183164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183170 */     GIR_RootConstrainSelectedInstOperands,
     /* 183171 */     // GIR_Coverage, 3078,
     /* 183171 */     GIR_EraseRootFromParent_Done,
     /* 183172 */   // Label 3365: @183172
     /* 183172 */   GIM_Try, /*On fail goto*//*Label 3366*/ GIMT_Encode4(183214), // Rule ID 3079 //
     /* 183177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunb),
     /* 183185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183195 */     // MIs[0] Op2
     /* 183195 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183198 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183203 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1852:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNB_ZZI_S),
     /* 183206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183212 */     GIR_RootConstrainSelectedInstOperands,
     /* 183213 */     // GIR_Coverage, 3079,
     /* 183213 */     GIR_EraseRootFromParent_Done,
     /* 183214 */   // Label 3366: @183214
     /* 183214 */   GIM_Try, /*On fail goto*//*Label 3367*/ GIMT_Encode4(183256), // Rule ID 3525 //
     /* 183219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 183233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183237 */     // MIs[0] Op2
     /* 183237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 183245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1352:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)  =>  (DUPQ_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Op2)
     /* 183245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_B),
     /* 183248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183254 */     GIR_RootConstrainSelectedInstOperands,
     /* 183255 */     // GIR_Coverage, 3525,
     /* 183255 */     GIR_EraseRootFromParent_Done,
     /* 183256 */   // Label 3367: @183256
     /* 183256 */   GIM_Try, /*On fail goto*//*Label 3368*/ GIMT_Encode4(183298), // Rule ID 3526 //
     /* 183261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183279 */     // MIs[0] Op2
     /* 183279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183287 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1352:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183296 */     GIR_RootConstrainSelectedInstOperands,
     /* 183297 */     // GIR_Coverage, 3526,
     /* 183297 */     GIR_EraseRootFromParent_Done,
     /* 183298 */   // Label 3368: @183298
     /* 183298 */   GIM_Try, /*On fail goto*//*Label 3369*/ GIMT_Encode4(183340), // Rule ID 3527 //
     /* 183303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183321 */     // MIs[0] Op2
     /* 183321 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183324 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183329 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1352:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183338 */     GIR_RootConstrainSelectedInstOperands,
     /* 183339 */     // GIR_Coverage, 3527,
     /* 183339 */     GIR_EraseRootFromParent_Done,
     /* 183340 */   // Label 3369: @183340
     /* 183340 */   GIM_Try, /*On fail goto*//*Label 3370*/ GIMT_Encode4(183382), // Rule ID 3528 //
     /* 183345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183363 */     // MIs[0] Op2
     /* 183363 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183366 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183371 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1352:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183380 */     GIR_RootConstrainSelectedInstOperands,
     /* 183381 */     // GIR_Coverage, 3528,
     /* 183381 */     GIR_EraseRootFromParent_Done,
     /* 183382 */   // Label 3370: @183382
     /* 183382 */   GIM_Try, /*On fail goto*//*Label 3371*/ GIMT_Encode4(183424), // Rule ID 3529 //
     /* 183387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183405 */     // MIs[0] Op2
     /* 183405 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183408 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 183413 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1352:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)  =>  (DUPQ_ZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op2)
     /* 183413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_H),
     /* 183416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183422 */     GIR_RootConstrainSelectedInstOperands,
     /* 183423 */     // GIR_Coverage, 3529,
     /* 183423 */     GIR_EraseRootFromParent_Done,
     /* 183424 */   // Label 3371: @183424
     /* 183424 */   GIM_Try, /*On fail goto*//*Label 3372*/ GIMT_Encode4(183466), // Rule ID 3530 //
     /* 183429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183447 */     // MIs[0] Op2
     /* 183447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 183455 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1352:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)  =>  (DUPQ_ZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op2)
     /* 183455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_S),
     /* 183458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183464 */     GIR_RootConstrainSelectedInstOperands,
     /* 183465 */     // GIR_Coverage, 3530,
     /* 183465 */     GIR_EraseRootFromParent_Done,
     /* 183466 */   // Label 3372: @183466
     /* 183466 */   GIM_Try, /*On fail goto*//*Label 3373*/ GIMT_Encode4(183508), // Rule ID 3531 //
     /* 183471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 183474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_dup_laneq),
     /* 183479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 183482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183489 */     // MIs[0] Op2
     /* 183489 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183492 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 183497 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1352:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)  =>  (DUPQ_ZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op2)
     /* 183497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPQ_ZZI_D),
     /* 183500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183506 */     GIR_RootConstrainSelectedInstOperands,
     /* 183507 */     // GIR_Coverage, 3531,
     /* 183507 */     GIR_EraseRootFromParent_Done,
     /* 183508 */   // Label 3373: @183508
     /* 183508 */   GIM_Try, /*On fail goto*//*Label 3374*/ GIMT_Encode4(183550), // Rule ID 11813 //
     /* 183513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183531 */     // MIs[0] Op2
     /* 183531 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183534 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183539 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1846:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRUNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_B),
     /* 183542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183548 */     GIR_RootConstrainSelectedInstOperands,
     /* 183549 */     // GIR_Coverage, 11813,
     /* 183549 */     GIR_EraseRootFromParent_Done,
     /* 183550 */   // Label 3374: @183550
     /* 183550 */   GIM_Try, /*On fail goto*//*Label 3375*/ GIMT_Encode4(183592), // Rule ID 11814 //
     /* 183555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183573 */     // MIs[0] Op2
     /* 183573 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183576 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183581 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1846:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRUNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_H),
     /* 183584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183590 */     GIR_RootConstrainSelectedInstOperands,
     /* 183591 */     // GIR_Coverage, 11814,
     /* 183591 */     GIR_EraseRootFromParent_Done,
     /* 183592 */   // Label 3375: @183592
     /* 183592 */   GIM_Try, /*On fail goto*//*Label 3376*/ GIMT_Encode4(183634), // Rule ID 11815 //
     /* 183597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunb),
     /* 183605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183615 */     // MIs[0] Op2
     /* 183615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183623 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1846:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRUNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNB_ZZI_S),
     /* 183626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183632 */     GIR_RootConstrainSelectedInstOperands,
     /* 183633 */     // GIR_Coverage, 11815,
     /* 183633 */     GIR_EraseRootFromParent_Done,
     /* 183634 */   // Label 3376: @183634
     /* 183634 */   GIM_Try, /*On fail goto*//*Label 3377*/ GIMT_Encode4(183676), // Rule ID 11816 //
     /* 183639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183657 */     // MIs[0] Op2
     /* 183657 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183660 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183665 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1725:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_B),
     /* 183668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183674 */     GIR_RootConstrainSelectedInstOperands,
     /* 183675 */     // GIR_Coverage, 11816,
     /* 183675 */     GIR_EraseRootFromParent_Done,
     /* 183676 */   // Label 3377: @183676
     /* 183676 */   GIM_Try, /*On fail goto*//*Label 3378*/ GIMT_Encode4(183718), // Rule ID 11817 //
     /* 183681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183699 */     // MIs[0] Op2
     /* 183699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183707 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1725:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_H),
     /* 183710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183716 */     GIR_RootConstrainSelectedInstOperands,
     /* 183717 */     // GIR_Coverage, 11817,
     /* 183717 */     GIR_EraseRootFromParent_Done,
     /* 183718 */   // Label 3378: @183718
     /* 183718 */   GIM_Try, /*On fail goto*//*Label 3379*/ GIMT_Encode4(183760), // Rule ID 11818 //
     /* 183723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnb),
     /* 183731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183741 */     // MIs[0] Op2
     /* 183741 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183744 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183749 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1725:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNB_ZZI_S),
     /* 183752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183758 */     GIR_RootConstrainSelectedInstOperands,
     /* 183759 */     // GIR_Coverage, 11818,
     /* 183759 */     GIR_EraseRootFromParent_Done,
     /* 183760 */   // Label 3379: @183760
     /* 183760 */   GIM_Try, /*On fail goto*//*Label 3380*/ GIMT_Encode4(183802), // Rule ID 11820 //
     /* 183765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183783 */     // MIs[0] Op2
     /* 183783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183791 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1683:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (RSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_B),
     /* 183794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183800 */     GIR_RootConstrainSelectedInstOperands,
     /* 183801 */     // GIR_Coverage, 11820,
     /* 183801 */     GIR_EraseRootFromParent_Done,
     /* 183802 */   // Label 3380: @183802
     /* 183802 */   GIM_Try, /*On fail goto*//*Label 3381*/ GIMT_Encode4(183844), // Rule ID 11822 //
     /* 183807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183825 */     // MIs[0] Op2
     /* 183825 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183828 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183833 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1683:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (RSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_H),
     /* 183836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183842 */     GIR_RootConstrainSelectedInstOperands,
     /* 183843 */     // GIR_Coverage, 11822,
     /* 183843 */     GIR_EraseRootFromParent_Done,
     /* 183844 */   // Label 3381: @183844
     /* 183844 */   GIM_Try, /*On fail goto*//*Label 3382*/ GIMT_Encode4(183886), // Rule ID 11824 //
     /* 183849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnb),
     /* 183857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183867 */     // MIs[0] Op2
     /* 183867 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183870 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 183875 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1683:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (RSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 183875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNB_ZZI_S),
     /* 183878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183884 */     GIR_RootConstrainSelectedInstOperands,
     /* 183885 */     // GIR_Coverage, 11824,
     /* 183885 */     GIR_EraseRootFromParent_Done,
     /* 183886 */   // Label 3382: @183886
     /* 183886 */   GIM_Try, /*On fail goto*//*Label 3383*/ GIMT_Encode4(183928), // Rule ID 11825 //
     /* 183891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 183902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 183905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183909 */     // MIs[0] Op2
     /* 183909 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183912 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 183917 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1850:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 183917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_B),
     /* 183920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183926 */     GIR_RootConstrainSelectedInstOperands,
     /* 183927 */     // GIR_Coverage, 11825,
     /* 183927 */     GIR_EraseRootFromParent_Done,
     /* 183928 */   // Label 3383: @183928
     /* 183928 */   GIM_Try, /*On fail goto*//*Label 3384*/ GIMT_Encode4(183970), // Rule ID 11826 //
     /* 183933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 183944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 183947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183951 */     // MIs[0] Op2
     /* 183951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 183959 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1850:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 183959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_H),
     /* 183962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 183964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 183966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 183968 */     GIR_RootConstrainSelectedInstOperands,
     /* 183969 */     // GIR_Coverage, 11826,
     /* 183969 */     GIR_EraseRootFromParent_Done,
     /* 183970 */   // Label 3384: @183970
     /* 183970 */   GIM_Try, /*On fail goto*//*Label 3385*/ GIMT_Encode4(184012), // Rule ID 11827 //
     /* 183975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 183978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnb),
     /* 183983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 183986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 183989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 183993 */     // MIs[0] Op2
     /* 183993 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 183996 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184001 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1850:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNB_ZZI_S),
     /* 184004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184010 */     GIR_RootConstrainSelectedInstOperands,
     /* 184011 */     // GIR_Coverage, 11827,
     /* 184011 */     GIR_EraseRootFromParent_Done,
     /* 184012 */   // Label 3385: @184012
     /* 184012 */   GIM_Try, /*On fail goto*//*Label 3386*/ GIMT_Encode4(184054), // Rule ID 11828 //
     /* 184017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184035 */     // MIs[0] Op2
     /* 184035 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184038 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184043 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1840:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (SQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_B),
     /* 184046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184052 */     GIR_RootConstrainSelectedInstOperands,
     /* 184053 */     // GIR_Coverage, 11828,
     /* 184053 */     GIR_EraseRootFromParent_Done,
     /* 184054 */   // Label 3386: @184054
     /* 184054 */   GIM_Try, /*On fail goto*//*Label 3387*/ GIMT_Encode4(184096), // Rule ID 11829 //
     /* 184059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184077 */     // MIs[0] Op2
     /* 184077 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184080 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184085 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1840:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (SQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_H),
     /* 184088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184094 */     GIR_RootConstrainSelectedInstOperands,
     /* 184095 */     // GIR_Coverage, 11829,
     /* 184095 */     GIR_EraseRootFromParent_Done,
     /* 184096 */   // Label 3387: @184096
     /* 184096 */   GIM_Try, /*On fail goto*//*Label 3388*/ GIMT_Encode4(184138), // Rule ID 11830 //
     /* 184101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnb),
     /* 184109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184119 */     // MIs[0] Op2
     /* 184119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184127 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1840:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (SQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNB_ZZI_S),
     /* 184130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184136 */     GIR_RootConstrainSelectedInstOperands,
     /* 184137 */     // GIR_Coverage, 11830,
     /* 184137 */     GIR_EraseRootFromParent_Done,
     /* 184138 */   // Label 3388: @184138
     /* 184138 */   GIM_Try, /*On fail goto*//*Label 3389*/ GIMT_Encode4(184180), // Rule ID 11831 //
     /* 184143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184161 */     // MIs[0] Op2
     /* 184161 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184164 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184169 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2045:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_B),
     /* 184172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184178 */     GIR_RootConstrainSelectedInstOperands,
     /* 184179 */     // GIR_Coverage, 11831,
     /* 184179 */     GIR_EraseRootFromParent_Done,
     /* 184180 */   // Label 3389: @184180
     /* 184180 */   GIM_Try, /*On fail goto*//*Label 3390*/ GIMT_Encode4(184222), // Rule ID 11832 //
     /* 184185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184203 */     // MIs[0] Op2
     /* 184203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184211 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2045:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_H),
     /* 184214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184220 */     GIR_RootConstrainSelectedInstOperands,
     /* 184221 */     // GIR_Coverage, 11832,
     /* 184221 */     GIR_EraseRootFromParent_Done,
     /* 184222 */   // Label 3390: @184222
     /* 184222 */   GIM_Try, /*On fail goto*//*Label 3391*/ GIMT_Encode4(184264), // Rule ID 11833 //
     /* 184227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnb),
     /* 184235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184245 */     // MIs[0] Op2
     /* 184245 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184248 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184253 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2045:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNB_ZZI_S),
     /* 184256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184262 */     GIR_RootConstrainSelectedInstOperands,
     /* 184263 */     // GIR_Coverage, 11833,
     /* 184263 */     GIR_EraseRootFromParent_Done,
     /* 184264 */   // Label 3391: @184264
     /* 184264 */   GIM_Try, /*On fail goto*//*Label 3392*/ GIMT_Encode4(184306), // Rule ID 11834 //
     /* 184269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 184280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184287 */     // MIs[0] Op2
     /* 184287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 184295 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2042:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)  =>  (UQRSHRNB_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op2)
     /* 184295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_B),
     /* 184298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184304 */     GIR_RootConstrainSelectedInstOperands,
     /* 184305 */     // GIR_Coverage, 11834,
     /* 184305 */     GIR_EraseRootFromParent_Done,
     /* 184306 */   // Label 3392: @184306
     /* 184306 */   GIM_Try, /*On fail goto*//*Label 3393*/ GIMT_Encode4(184348), // Rule ID 11835 //
     /* 184311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184329 */     // MIs[0] Op2
     /* 184329 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184332 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 184337 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2042:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)  =>  (UQRSHRNB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op2)
     /* 184337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_H),
     /* 184340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184346 */     GIR_RootConstrainSelectedInstOperands,
     /* 184347 */     // GIR_Coverage, 11835,
     /* 184347 */     GIR_EraseRootFromParent_Done,
     /* 184348 */   // Label 3393: @184348
     /* 184348 */   GIM_Try, /*On fail goto*//*Label 3394*/ GIMT_Encode4(184390), // Rule ID 11836 //
     /* 184353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnb),
     /* 184361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 184367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184371 */     // MIs[0] Op2
     /* 184371 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184374 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 184379 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2042:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)  =>  (UQRSHRNB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op2)
     /* 184379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNB_ZZI_S),
     /* 184382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184386 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184388 */     GIR_RootConstrainSelectedInstOperands,
     /* 184389 */     // GIR_Coverage, 11836,
     /* 184389 */     GIR_EraseRootFromParent_Done,
     /* 184390 */   // Label 3394: @184390
     /* 184390 */   GIM_Try, /*On fail goto*//*Label 3395*/ GIMT_Encode4(184432), // Rule ID 11894 //
     /* 184395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184413 */     // MIs[0] Op2
     /* 184413 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184416 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184421 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1872:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (SSHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_H),
     /* 184424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184430 */     GIR_RootConstrainSelectedInstOperands,
     /* 184431 */     // GIR_Coverage, 11894,
     /* 184431 */     GIR_EraseRootFromParent_Done,
     /* 184432 */   // Label 3395: @184432
     /* 184432 */   GIM_Try, /*On fail goto*//*Label 3396*/ GIMT_Encode4(184474), // Rule ID 11895 //
     /* 184437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184455 */     // MIs[0] Op2
     /* 184455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184463 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1872:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (SSHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_S),
     /* 184466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184472 */     GIR_RootConstrainSelectedInstOperands,
     /* 184473 */     // GIR_Coverage, 11895,
     /* 184473 */     GIR_EraseRootFromParent_Done,
     /* 184474 */   // Label 3396: @184474
     /* 184474 */   GIM_Try, /*On fail goto*//*Label 3397*/ GIMT_Encode4(184516), // Rule ID 11896 //
     /* 184479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sshllt),
     /* 184487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184497 */     // MIs[0] Op2
     /* 184497 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184500 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184505 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1872:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (SSHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLT_ZZI_D),
     /* 184508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184514 */     GIR_RootConstrainSelectedInstOperands,
     /* 184515 */     // GIR_Coverage, 11896,
     /* 184515 */     GIR_EraseRootFromParent_Done,
     /* 184516 */   // Label 3397: @184516
     /* 184516 */   GIM_Try, /*On fail goto*//*Label 3398*/ GIMT_Encode4(184558), // Rule ID 11897 //
     /* 184521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184539 */     // MIs[0] Op2
     /* 184539 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184542 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184547 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2065:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLB_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_H),
     /* 184550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184556 */     GIR_RootConstrainSelectedInstOperands,
     /* 184557 */     // GIR_Coverage, 11897,
     /* 184557 */     GIR_EraseRootFromParent_Done,
     /* 184558 */   // Label 3398: @184558
     /* 184558 */   GIM_Try, /*On fail goto*//*Label 3399*/ GIMT_Encode4(184600), // Rule ID 11898 //
     /* 184563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184581 */     // MIs[0] Op2
     /* 184581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184589 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2065:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLB_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184589 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_S),
     /* 184592 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184594 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184596 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184598 */     GIR_RootConstrainSelectedInstOperands,
     /* 184599 */     // GIR_Coverage, 11898,
     /* 184599 */     GIR_EraseRootFromParent_Done,
     /* 184600 */   // Label 3399: @184600
     /* 184600 */   GIM_Try, /*On fail goto*//*Label 3400*/ GIMT_Encode4(184642), // Rule ID 11899 //
     /* 184605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllb),
     /* 184613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184623 */     // MIs[0] Op2
     /* 184623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184631 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2065:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLB_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLB_ZZI_D),
     /* 184634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184640 */     GIR_RootConstrainSelectedInstOperands,
     /* 184641 */     // GIR_Coverage, 11899,
     /* 184641 */     GIR_EraseRootFromParent_Done,
     /* 184642 */   // Label 3400: @184642
     /* 184642 */   GIM_Try, /*On fail goto*//*Label 3401*/ GIMT_Encode4(184684), // Rule ID 11900 //
     /* 184647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 184658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 184661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184665 */     // MIs[0] Op2
     /* 184665 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184668 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 184673 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2066:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)  =>  (USHLLT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op2)
     /* 184673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_H),
     /* 184676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184682 */     GIR_RootConstrainSelectedInstOperands,
     /* 184683 */     // GIR_Coverage, 11900,
     /* 184683 */     GIR_EraseRootFromParent_Done,
     /* 184684 */   // Label 3401: @184684
     /* 184684 */   GIM_Try, /*On fail goto*//*Label 3402*/ GIMT_Encode4(184726), // Rule ID 11901 //
     /* 184689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 184700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 184703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184707 */     // MIs[0] Op2
     /* 184707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 184715 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2066:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)  =>  (USHLLT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op2)
     /* 184715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_S),
     /* 184718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184724 */     GIR_RootConstrainSelectedInstOperands,
     /* 184725 */     // GIR_Coverage, 11901,
     /* 184725 */     GIR_EraseRootFromParent_Done,
     /* 184726 */   // Label 3402: @184726
     /* 184726 */   GIM_Try, /*On fail goto*//*Label 3403*/ GIMT_Encode4(184768), // Rule ID 11902 //
     /* 184731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 184734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ushllt),
     /* 184739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 184742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 184745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 184749 */     // MIs[0] Op2
     /* 184749 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 184752 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 184757 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2066:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)  =>  (USHLLT_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op2)
     /* 184757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLT_ZZI_D),
     /* 184760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 184762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 184764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 184766 */     GIR_RootConstrainSelectedInstOperands,
     /* 184767 */     // GIR_Coverage, 11902,
     /* 184767 */     GIR_EraseRootFromParent_Done,
     /* 184768 */   // Label 3403: @184768
     /* 184768 */   GIM_Try, /*On fail goto*//*Label 3404*/ GIMT_Encode4(184820), // Rule ID 2132 //
     /* 184773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 184784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 184787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184798 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184802 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184806 */     // MIs[1] Operand 1
     /* 184806 */     // No operand predicates
     /* 184806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184808 */     // (intrinsic_wo_chain:{ *:[v4i16] } 769:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184808 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i16_shift),
     /* 184811 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184813 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184815 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184818 */     GIR_RootConstrainSelectedInstOperands,
     /* 184819 */     // GIR_Coverage, 2132,
     /* 184819 */     GIR_EraseRootFromParent_Done,
     /* 184820 */   // Label 3404: @184820
     /* 184820 */   GIM_Try, /*On fail goto*//*Label 3405*/ GIMT_Encode4(184872), // Rule ID 2133 //
     /* 184825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 184828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 184836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 184839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184842 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184850 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184854 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184858 */     // MIs[1] Operand 1
     /* 184858 */     // No operand predicates
     /* 184858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184860 */     // (intrinsic_wo_chain:{ *:[v8i16] } 769:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8i16_shift),
     /* 184863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184867 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184870 */     GIR_RootConstrainSelectedInstOperands,
     /* 184871 */     // GIR_Coverage, 2133,
     /* 184871 */     GIR_EraseRootFromParent_Done,
     /* 184872 */   // Label 3405: @184872
     /* 184872 */   GIM_Try, /*On fail goto*//*Label 3406*/ GIMT_Encode4(184924), // Rule ID 2134 //
     /* 184877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184880 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184885 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 184888 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 184891 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184898 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 184902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184910 */     // MIs[1] Operand 1
     /* 184910 */     // No operand predicates
     /* 184910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184912 */     // (intrinsic_wo_chain:{ *:[v2i32] } 769:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i32_shift),
     /* 184915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184919 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184922 */     GIR_RootConstrainSelectedInstOperands,
     /* 184923 */     // GIR_Coverage, 2134,
     /* 184923 */     GIR_EraseRootFromParent_Done,
     /* 184924 */   // Label 3406: @184924
     /* 184924 */   GIM_Try, /*On fail goto*//*Label 3407*/ GIMT_Encode4(184976), // Rule ID 2135 //
     /* 184929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 184940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 184943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184946 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184950 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 184954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 184958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 184962 */     // MIs[1] Operand 1
     /* 184962 */     // No operand predicates
     /* 184962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 184964 */     // (intrinsic_wo_chain:{ *:[v4i32] } 769:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 184964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4i32_shift),
     /* 184967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 184969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 184971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 184974 */     GIR_RootConstrainSelectedInstOperands,
     /* 184975 */     // GIR_Coverage, 2135,
     /* 184975 */     GIR_EraseRootFromParent_Done,
     /* 184976 */   // Label 3407: @184976
     /* 184976 */   GIM_Try, /*On fail goto*//*Label 3408*/ GIMT_Encode4(185028), // Rule ID 2136 //
     /* 184981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 184984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxs),
     /* 184989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 184992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 184995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 184998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185002 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185014 */     // MIs[1] Operand 1
     /* 185014 */     // No operand predicates
     /* 185014 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185016 */     // (intrinsic_wo_chain:{ *:[v2i64] } 769:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZSv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2i64_shift),
     /* 185019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185026 */     GIR_RootConstrainSelectedInstOperands,
     /* 185027 */     // GIR_Coverage, 2136,
     /* 185027 */     GIR_EraseRootFromParent_Done,
     /* 185028 */   // Label 3408: @185028
     /* 185028 */   GIM_Try, /*On fail goto*//*Label 3409*/ GIMT_Encode4(185080), // Rule ID 2137 //
     /* 185033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185058 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185062 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185066 */     // MIs[1] Operand 1
     /* 185066 */     // No operand predicates
     /* 185066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185068 */     // (intrinsic_wo_chain:{ *:[v4i16] } 770:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i16_shift:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i16_shift),
     /* 185071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185075 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185078 */     GIR_RootConstrainSelectedInstOperands,
     /* 185079 */     // GIR_Coverage, 2137,
     /* 185079 */     GIR_EraseRootFromParent_Done,
     /* 185080 */   // Label 3409: @185080
     /* 185080 */   GIM_Try, /*On fail goto*//*Label 3410*/ GIMT_Encode4(185132), // Rule ID 2138 //
     /* 185085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185102 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185106 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185118 */     // MIs[1] Operand 1
     /* 185118 */     // No operand predicates
     /* 185118 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185120 */     // (intrinsic_wo_chain:{ *:[v8i16] } 770:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv8i16_shift:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8i16_shift),
     /* 185123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185127 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185130 */     GIR_RootConstrainSelectedInstOperands,
     /* 185131 */     // GIR_Coverage, 2138,
     /* 185131 */     GIR_EraseRootFromParent_Done,
     /* 185132 */   // Label 3410: @185132
     /* 185132 */   GIM_Try, /*On fail goto*//*Label 3411*/ GIMT_Encode4(185184), // Rule ID 2139 //
     /* 185137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185170 */     // MIs[1] Operand 1
     /* 185170 */     // No operand predicates
     /* 185170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185172 */     // (intrinsic_wo_chain:{ *:[v2i32] } 770:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i32_shift:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i32_shift),
     /* 185175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185182 */     GIR_RootConstrainSelectedInstOperands,
     /* 185183 */     // GIR_Coverage, 2139,
     /* 185183 */     GIR_EraseRootFromParent_Done,
     /* 185184 */   // Label 3411: @185184
     /* 185184 */   GIM_Try, /*On fail goto*//*Label 3412*/ GIMT_Encode4(185236), // Rule ID 2140 //
     /* 185189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185206 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185214 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185218 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185222 */     // MIs[1] Operand 1
     /* 185222 */     // No operand predicates
     /* 185222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185224 */     // (intrinsic_wo_chain:{ *:[v4i32] } 770:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv4i32_shift:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4i32_shift),
     /* 185227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185234 */     GIR_RootConstrainSelectedInstOperands,
     /* 185235 */     // GIR_Coverage, 2140,
     /* 185235 */     GIR_EraseRootFromParent_Done,
     /* 185236 */   // Label 3412: @185236
     /* 185236 */   GIM_Try, /*On fail goto*//*Label 3413*/ GIMT_Encode4(185288), // Rule ID 2141 //
     /* 185241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfp2fxu),
     /* 185249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185258 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185274 */     // MIs[1] Operand 1
     /* 185274 */     // No operand predicates
     /* 185274 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185276 */     // (intrinsic_wo_chain:{ *:[v2i64] } 770:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (FCVTZUv2i64_shift:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2i64_shift),
     /* 185279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185283 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185286 */     GIR_RootConstrainSelectedInstOperands,
     /* 185287 */     // GIR_Coverage, 2141,
     /* 185287 */     GIR_EraseRootFromParent_Done,
     /* 185288 */   // Label 3413: @185288
     /* 185288 */   GIM_Try, /*On fail goto*//*Label 3414*/ GIMT_Encode4(185340), // Rule ID 2142 //
     /* 185293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185326 */     // MIs[1] Operand 1
     /* 185326 */     // No operand predicates
     /* 185326 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185328 */     // (intrinsic_wo_chain:{ *:[v4f16] } 772:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i16_shift),
     /* 185331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185333 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185335 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185338 */     GIR_RootConstrainSelectedInstOperands,
     /* 185339 */     // GIR_Coverage, 2142,
     /* 185339 */     GIR_EraseRootFromParent_Done,
     /* 185340 */   // Label 3414: @185340
     /* 185340 */   GIM_Try, /*On fail goto*//*Label 3415*/ GIMT_Encode4(185392), // Rule ID 2143 //
     /* 185345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185362 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185370 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185374 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185378 */     // MIs[1] Operand 1
     /* 185378 */     // No operand predicates
     /* 185378 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185380 */     // (intrinsic_wo_chain:{ *:[v8f16] } 772:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8i16_shift),
     /* 185383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185385 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185387 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185390 */     GIR_RootConstrainSelectedInstOperands,
     /* 185391 */     // GIR_Coverage, 2143,
     /* 185391 */     GIR_EraseRootFromParent_Done,
     /* 185392 */   // Label 3415: @185392
     /* 185392 */   GIM_Try, /*On fail goto*//*Label 3416*/ GIMT_Encode4(185444), // Rule ID 2144 //
     /* 185397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185405 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185408 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185411 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185414 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185422 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185426 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185430 */     // MIs[1] Operand 1
     /* 185430 */     // No operand predicates
     /* 185430 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185432 */     // (intrinsic_wo_chain:{ *:[v2f32] } 772:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i32_shift),
     /* 185435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185439 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185442 */     GIR_RootConstrainSelectedInstOperands,
     /* 185443 */     // GIR_Coverage, 2144,
     /* 185443 */     GIR_EraseRootFromParent_Done,
     /* 185444 */   // Label 3416: @185444
     /* 185444 */   GIM_Try, /*On fail goto*//*Label 3417*/ GIMT_Encode4(185496), // Rule ID 2145 //
     /* 185449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185466 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185470 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185474 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185478 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185482 */     // MIs[1] Operand 1
     /* 185482 */     // No operand predicates
     /* 185482 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185484 */     // (intrinsic_wo_chain:{ *:[v4f32] } 772:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4i32_shift),
     /* 185487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185494 */     GIR_RootConstrainSelectedInstOperands,
     /* 185495 */     // GIR_Coverage, 2145,
     /* 185495 */     GIR_EraseRootFromParent_Done,
     /* 185496 */   // Label 3417: @185496
     /* 185496 */   GIM_Try, /*On fail goto*//*Label 3418*/ GIMT_Encode4(185548), // Rule ID 2146 //
     /* 185501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxs2fp),
     /* 185509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185526 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185530 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185534 */     // MIs[1] Operand 1
     /* 185534 */     // No operand predicates
     /* 185534 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185536 */     // (intrinsic_wo_chain:{ *:[v2f64] } 772:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (SCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2i64_shift),
     /* 185539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185546 */     GIR_RootConstrainSelectedInstOperands,
     /* 185547 */     // GIR_Coverage, 2146,
     /* 185547 */     GIR_EraseRootFromParent_Done,
     /* 185548 */   // Label 3418: @185548
     /* 185548 */   GIM_Try, /*On fail goto*//*Label 3419*/ GIMT_Encode4(185600), // Rule ID 2244 //
     /* 185553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 185564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 185567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185586 */     // MIs[1] Operand 1
     /* 185586 */     // No operand predicates
     /* 185586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185588 */     // (intrinsic_wo_chain:{ *:[v4f16] } 773:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i16_shift:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i16_shift),
     /* 185591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185593 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185595 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185598 */     GIR_RootConstrainSelectedInstOperands,
     /* 185599 */     // GIR_Coverage, 2244,
     /* 185599 */     GIR_EraseRootFromParent_Done,
     /* 185600 */   // Label 3419: @185600
     /* 185600 */   GIM_Try, /*On fail goto*//*Label 3420*/ GIMT_Encode4(185652), // Rule ID 2245 //
     /* 185605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 185608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 185616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 185619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185638 */     // MIs[1] Operand 1
     /* 185638 */     // No operand predicates
     /* 185638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185640 */     // (intrinsic_wo_chain:{ *:[v8f16] } 773:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv8i16_shift:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8i16_shift),
     /* 185643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185650 */     GIR_RootConstrainSelectedInstOperands,
     /* 185651 */     // GIR_Coverage, 2245,
     /* 185651 */     GIR_EraseRootFromParent_Done,
     /* 185652 */   // Label 3420: @185652
     /* 185652 */   GIM_Try, /*On fail goto*//*Label 3421*/ GIMT_Encode4(185704), // Rule ID 2246 //
     /* 185657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185660 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185665 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 185668 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 185671 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 185682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185690 */     // MIs[1] Operand 1
     /* 185690 */     // No operand predicates
     /* 185690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185692 */     // (intrinsic_wo_chain:{ *:[v2f32] } 773:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i32_shift:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i32_shift),
     /* 185695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185699 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185702 */     GIR_RootConstrainSelectedInstOperands,
     /* 185703 */     // GIR_Coverage, 2246,
     /* 185703 */     GIR_EraseRootFromParent_Done,
     /* 185704 */   // Label 3421: @185704
     /* 185704 */   GIM_Try, /*On fail goto*//*Label 3422*/ GIMT_Encode4(185756), // Rule ID 2247 //
     /* 185709 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185712 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185717 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 185720 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 185723 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185726 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185734 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185738 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185742 */     // MIs[1] Operand 1
     /* 185742 */     // No operand predicates
     /* 185742 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185744 */     // (intrinsic_wo_chain:{ *:[v4f32] } 773:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv4i32_shift:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185744 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4i32_shift),
     /* 185747 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185749 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185751 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185754 */     GIR_RootConstrainSelectedInstOperands,
     /* 185755 */     // GIR_Coverage, 2247,
     /* 185755 */     GIR_EraseRootFromParent_Done,
     /* 185756 */   // Label 3422: @185756
     /* 185756 */   GIM_Try, /*On fail goto*//*Label 3423*/ GIMT_Encode4(185808), // Rule ID 2248 //
     /* 185761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 185764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcvtfxu2fp),
     /* 185769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 185772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 185775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 185786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 185790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 185794 */     // MIs[1] Operand 1
     /* 185794 */     // No operand predicates
     /* 185794 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 185796 */     // (intrinsic_wo_chain:{ *:[v2f64] } 773:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)  =>  (UCVTFv2i64_shift:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 185796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2i64_shift),
     /* 185799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185803 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 185806 */     GIR_RootConstrainSelectedInstOperands,
     /* 185807 */     // GIR_Coverage, 2248,
     /* 185807 */     GIR_EraseRootFromParent_Done,
     /* 185808 */   // Label 3423: @185808
     /* 185808 */   GIM_Try, /*On fail goto*//*Label 3424*/ GIMT_Encode4(185853), // Rule ID 63 //
     /* 185813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 185816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign_generic),
     /* 185821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 185824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 185827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 185830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 185838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 185842 */     // (intrinsic_wo_chain:{ *:[i64] } 298:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (PACGA:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 185842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACGA),
     /* 185845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185851 */     GIR_RootConstrainSelectedInstOperands,
     /* 185852 */     // GIR_Coverage, 63,
     /* 185852 */     GIR_EraseRootFromParent_Done,
     /* 185853 */   // Label 3424: @185853
     /* 185853 */   GIM_Try, /*On fail goto*//*Label 3425*/ GIMT_Encode4(185898), // Rule ID 129 //
     /* 185858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32b),
     /* 185866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185887 */     // (intrinsic_wo_chain:{ *:[i32] } 510:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Brr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Brr),
     /* 185890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185896 */     GIR_RootConstrainSelectedInstOperands,
     /* 185897 */     // GIR_Coverage, 129,
     /* 185897 */     GIR_EraseRootFromParent_Done,
     /* 185898 */   // Label 3425: @185898
     /* 185898 */   GIM_Try, /*On fail goto*//*Label 3426*/ GIMT_Encode4(185943), // Rule ID 130 //
     /* 185903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32h),
     /* 185911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185932 */     // (intrinsic_wo_chain:{ *:[i32] } 515:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Hrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Hrr),
     /* 185935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185941 */     GIR_RootConstrainSelectedInstOperands,
     /* 185942 */     // GIR_Coverage, 130,
     /* 185942 */     GIR_EraseRootFromParent_Done,
     /* 185943 */   // Label 3426: @185943
     /* 185943 */   GIM_Try, /*On fail goto*//*Label 3427*/ GIMT_Encode4(185988), // Rule ID 131 //
     /* 185948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32w),
     /* 185956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 185959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 185962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 185965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 185977 */     // (intrinsic_wo_chain:{ *:[i32] } 516:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32Wrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 185977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Wrr),
     /* 185980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 185982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 185984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 185986 */     GIR_RootConstrainSelectedInstOperands,
     /* 185987 */     // GIR_Coverage, 131,
     /* 185987 */     GIR_EraseRootFromParent_Done,
     /* 185988 */   // Label 3427: @185988
     /* 185988 */   GIM_Try, /*On fail goto*//*Label 3428*/ GIMT_Encode4(186033), // Rule ID 132 //
     /* 185993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 185996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32x),
     /* 186001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186022 */     // (intrinsic_wo_chain:{ *:[i32] } 517:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32Xrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32Xrr),
     /* 186025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186031 */     GIR_RootConstrainSelectedInstOperands,
     /* 186032 */     // GIR_Coverage, 132,
     /* 186032 */     GIR_EraseRootFromParent_Done,
     /* 186033 */   // Label 3428: @186033
     /* 186033 */   GIM_Try, /*On fail goto*//*Label 3429*/ GIMT_Encode4(186078), // Rule ID 133 //
     /* 186038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cb),
     /* 186046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186067 */     // (intrinsic_wo_chain:{ *:[i32] } 511:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CBrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CBrr),
     /* 186070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186076 */     GIR_RootConstrainSelectedInstOperands,
     /* 186077 */     // GIR_Coverage, 133,
     /* 186077 */     GIR_EraseRootFromParent_Done,
     /* 186078 */   // Label 3429: @186078
     /* 186078 */   GIM_Try, /*On fail goto*//*Label 3430*/ GIMT_Encode4(186123), // Rule ID 134 //
     /* 186083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32ch),
     /* 186091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186112 */     // (intrinsic_wo_chain:{ *:[i32] } 512:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CHrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CHrr),
     /* 186115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186121 */     GIR_RootConstrainSelectedInstOperands,
     /* 186122 */     // GIR_Coverage, 134,
     /* 186122 */     GIR_EraseRootFromParent_Done,
     /* 186123 */   // Label 3430: @186123
     /* 186123 */   GIM_Try, /*On fail goto*//*Label 3431*/ GIMT_Encode4(186168), // Rule ID 135 //
     /* 186128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cw),
     /* 186136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 186145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186157 */     // (intrinsic_wo_chain:{ *:[i32] } 513:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (CRC32CWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 186157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CWrr),
     /* 186160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186166 */     GIR_RootConstrainSelectedInstOperands,
     /* 186167 */     // GIR_Coverage, 135,
     /* 186167 */     GIR_EraseRootFromParent_Done,
     /* 186168 */   // Label 3431: @186168
     /* 186168 */   GIM_Try, /*On fail goto*//*Label 3432*/ GIMT_Encode4(186213), // Rule ID 136 //
     /* 186173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCRC),
     /* 186176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crc32cx),
     /* 186181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 186184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 186187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 186190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 186198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 186202 */     // (intrinsic_wo_chain:{ *:[i32] } 514:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (CRC32CXrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 186202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CRC32CXrr),
     /* 186205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186211 */     GIR_RootConstrainSelectedInstOperands,
     /* 186212 */     // GIR_Coverage, 136,
     /* 186212 */     GIR_EraseRootFromParent_Done,
     /* 186213 */   // Label 3432: @186213
     /* 186213 */   GIM_Try, /*On fail goto*//*Label 3433*/ GIMT_Encode4(186258), // Rule ID 1042 //
     /* 186218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186247 */     // (intrinsic_wo_chain:{ *:[v8i8] } 722:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (SUQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i8),
     /* 186250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186256 */     GIR_RootConstrainSelectedInstOperands,
     /* 186257 */     // GIR_Coverage, 1042,
     /* 186257 */     GIR_EraseRootFromParent_Done,
     /* 186258 */   // Label 3433: @186258
     /* 186258 */   GIM_Try, /*On fail goto*//*Label 3434*/ GIMT_Encode4(186303), // Rule ID 1043 //
     /* 186263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186292 */     // (intrinsic_wo_chain:{ *:[v16i8] } 722:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (SUQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv16i8),
     /* 186295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186301 */     GIR_RootConstrainSelectedInstOperands,
     /* 186302 */     // GIR_Coverage, 1043,
     /* 186302 */     GIR_EraseRootFromParent_Done,
     /* 186303 */   // Label 3434: @186303
     /* 186303 */   GIM_Try, /*On fail goto*//*Label 3435*/ GIMT_Encode4(186348), // Rule ID 1044 //
     /* 186308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186337 */     // (intrinsic_wo_chain:{ *:[v4i16] } 722:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (SUQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i16),
     /* 186340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186346 */     GIR_RootConstrainSelectedInstOperands,
     /* 186347 */     // GIR_Coverage, 1044,
     /* 186347 */     GIR_EraseRootFromParent_Done,
     /* 186348 */   // Label 3435: @186348
     /* 186348 */   GIM_Try, /*On fail goto*//*Label 3436*/ GIMT_Encode4(186393), // Rule ID 1045 //
     /* 186353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186382 */     // (intrinsic_wo_chain:{ *:[v8i16] } 722:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (SUQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv8i16),
     /* 186385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186391 */     GIR_RootConstrainSelectedInstOperands,
     /* 186392 */     // GIR_Coverage, 1045,
     /* 186392 */     GIR_EraseRootFromParent_Done,
     /* 186393 */   // Label 3436: @186393
     /* 186393 */   GIM_Try, /*On fail goto*//*Label 3437*/ GIMT_Encode4(186438), // Rule ID 1046 //
     /* 186398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186427 */     // (intrinsic_wo_chain:{ *:[v2i32] } 722:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (SUQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i32),
     /* 186430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186436 */     GIR_RootConstrainSelectedInstOperands,
     /* 186437 */     // GIR_Coverage, 1046,
     /* 186437 */     GIR_EraseRootFromParent_Done,
     /* 186438 */   // Label 3437: @186438
     /* 186438 */   GIM_Try, /*On fail goto*//*Label 3438*/ GIMT_Encode4(186483), // Rule ID 1047 //
     /* 186443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186472 */     // (intrinsic_wo_chain:{ *:[v4i32] } 722:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SUQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv4i32),
     /* 186475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186481 */     GIR_RootConstrainSelectedInstOperands,
     /* 186482 */     // GIR_Coverage, 1047,
     /* 186482 */     GIR_EraseRootFromParent_Done,
     /* 186483 */   // Label 3438: @186483
     /* 186483 */   GIM_Try, /*On fail goto*//*Label 3439*/ GIMT_Encode4(186528), // Rule ID 1048 //
     /* 186488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 186496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186517 */     // (intrinsic_wo_chain:{ *:[v2i64] } 722:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (SUQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv2i64),
     /* 186520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186526 */     GIR_RootConstrainSelectedInstOperands,
     /* 186527 */     // GIR_Coverage, 1048,
     /* 186527 */     GIR_EraseRootFromParent_Done,
     /* 186528 */   // Label 3439: @186528
     /* 186528 */   GIM_Try, /*On fail goto*//*Label 3440*/ GIMT_Encode4(186573), // Rule ID 1090 //
     /* 186533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186562 */     // (intrinsic_wo_chain:{ *:[v8i8] } 761:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)  =>  (USQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn)
     /* 186562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i8),
     /* 186565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186571 */     GIR_RootConstrainSelectedInstOperands,
     /* 186572 */     // GIR_Coverage, 1090,
     /* 186572 */     GIR_EraseRootFromParent_Done,
     /* 186573 */   // Label 3440: @186573
     /* 186573 */   GIM_Try, /*On fail goto*//*Label 3441*/ GIMT_Encode4(186618), // Rule ID 1091 //
     /* 186578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186607 */     // (intrinsic_wo_chain:{ *:[v16i8] } 761:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (USQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 186607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv16i8),
     /* 186610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186616 */     GIR_RootConstrainSelectedInstOperands,
     /* 186617 */     // GIR_Coverage, 1091,
     /* 186617 */     GIR_EraseRootFromParent_Done,
     /* 186618 */   // Label 3441: @186618
     /* 186618 */   GIM_Try, /*On fail goto*//*Label 3442*/ GIMT_Encode4(186663), // Rule ID 1092 //
     /* 186623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186652 */     // (intrinsic_wo_chain:{ *:[v4i16] } 761:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)  =>  (USQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn)
     /* 186652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i16),
     /* 186655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186661 */     GIR_RootConstrainSelectedInstOperands,
     /* 186662 */     // GIR_Coverage, 1092,
     /* 186662 */     GIR_EraseRootFromParent_Done,
     /* 186663 */   // Label 3442: @186663
     /* 186663 */   GIM_Try, /*On fail goto*//*Label 3443*/ GIMT_Encode4(186708), // Rule ID 1093 //
     /* 186668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 186685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186697 */     // (intrinsic_wo_chain:{ *:[v8i16] } 761:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)  =>  (USQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn)
     /* 186697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv8i16),
     /* 186700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186706 */     GIR_RootConstrainSelectedInstOperands,
     /* 186707 */     // GIR_Coverage, 1093,
     /* 186707 */     GIR_EraseRootFromParent_Done,
     /* 186708 */   // Label 3443: @186708
     /* 186708 */   GIM_Try, /*On fail goto*//*Label 3444*/ GIMT_Encode4(186753), // Rule ID 1094 //
     /* 186713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 186724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 186727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 186730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186742 */     // (intrinsic_wo_chain:{ *:[v2i32] } 761:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)  =>  (USQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn)
     /* 186742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i32),
     /* 186745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186751 */     GIR_RootConstrainSelectedInstOperands,
     /* 186752 */     // GIR_Coverage, 1094,
     /* 186752 */     GIR_EraseRootFromParent_Done,
     /* 186753 */   // Label 3444: @186753
     /* 186753 */   GIM_Try, /*On fail goto*//*Label 3445*/ GIMT_Encode4(186798), // Rule ID 1095 //
     /* 186758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 186769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 186772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 186775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186787 */     // (intrinsic_wo_chain:{ *:[v4i32] } 761:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (USQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 186787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv4i32),
     /* 186790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186796 */     GIR_RootConstrainSelectedInstOperands,
     /* 186797 */     // GIR_Coverage, 1095,
     /* 186797 */     GIR_EraseRootFromParent_Done,
     /* 186798 */   // Label 3445: @186798
     /* 186798 */   GIM_Try, /*On fail goto*//*Label 3446*/ GIMT_Encode4(186843), // Rule ID 1096 //
     /* 186803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 186811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 186814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 186817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 186820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186832 */     // (intrinsic_wo_chain:{ *:[v2i64] } 761:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)  =>  (USQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn)
     /* 186832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv2i64),
     /* 186835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 186837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 186839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 186841 */     GIR_RootConstrainSelectedInstOperands,
     /* 186842 */     // GIR_Coverage, 1096,
     /* 186842 */     GIR_EraseRootFromParent_Done,
     /* 186843 */   // Label 3446: @186843
     /* 186843 */   GIM_Try, /*On fail goto*//*Label 3447*/ GIMT_Encode4(186888), // Rule ID 1108 //
     /* 186848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 186859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 186862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 186865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186877 */     // (intrinsic_wo_chain:{ *:[v8i8] } 577:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ADDPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 186877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i8),
     /* 186880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186886 */     GIR_RootConstrainSelectedInstOperands,
     /* 186887 */     // GIR_Coverage, 1108,
     /* 186887 */     GIR_EraseRootFromParent_Done,
     /* 186888 */   // Label 3447: @186888
     /* 186888 */   GIM_Try, /*On fail goto*//*Label 3448*/ GIMT_Encode4(186933), // Rule ID 1110 //
     /* 186893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 186904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 186907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 186910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 186922 */     // (intrinsic_wo_chain:{ *:[v16i8] } 577:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ADDPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 186922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv16i8),
     /* 186925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186931 */     GIR_RootConstrainSelectedInstOperands,
     /* 186932 */     // GIR_Coverage, 1110,
     /* 186932 */     GIR_EraseRootFromParent_Done,
     /* 186933 */   // Label 3448: @186933
     /* 186933 */   GIM_Try, /*On fail goto*//*Label 3449*/ GIMT_Encode4(186978), // Rule ID 1112 //
     /* 186938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 186949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 186952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 186955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 186967 */     // (intrinsic_wo_chain:{ *:[v4i16] } 577:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ADDPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 186967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i16),
     /* 186970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 186972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 186974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 186976 */     GIR_RootConstrainSelectedInstOperands,
     /* 186977 */     // GIR_Coverage, 1112,
     /* 186977 */     GIR_EraseRootFromParent_Done,
     /* 186978 */   // Label 3449: @186978
     /* 186978 */   GIM_Try, /*On fail goto*//*Label 3450*/ GIMT_Encode4(187023), // Rule ID 1114 //
     /* 186983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 186986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 186991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 186994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 186997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187012 */     // (intrinsic_wo_chain:{ *:[v8i16] } 577:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 187012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv8i16),
     /* 187015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187021 */     GIR_RootConstrainSelectedInstOperands,
     /* 187022 */     // GIR_Coverage, 1114,
     /* 187022 */     GIR_EraseRootFromParent_Done,
     /* 187023 */   // Label 3450: @187023
     /* 187023 */   GIM_Try, /*On fail goto*//*Label 3451*/ GIMT_Encode4(187068), // Rule ID 1116 //
     /* 187028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187057 */     // (intrinsic_wo_chain:{ *:[v2i32] } 577:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ADDPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 187057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 187060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187066 */     GIR_RootConstrainSelectedInstOperands,
     /* 187067 */     // GIR_Coverage, 1116,
     /* 187067 */     GIR_EraseRootFromParent_Done,
     /* 187068 */   // Label 3451: @187068
     /* 187068 */   GIM_Try, /*On fail goto*//*Label 3452*/ GIMT_Encode4(187113), // Rule ID 1118 //
     /* 187073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187102 */     // (intrinsic_wo_chain:{ *:[v4i32] } 577:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 187102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv4i32),
     /* 187105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187111 */     GIR_RootConstrainSelectedInstOperands,
     /* 187112 */     // GIR_Coverage, 1118,
     /* 187112 */     GIR_EraseRootFromParent_Done,
     /* 187113 */   // Label 3452: @187113
     /* 187113 */   GIM_Try, /*On fail goto*//*Label 3453*/ GIMT_Encode4(187158), // Rule ID 1120 //
     /* 187118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addp),
     /* 187126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 577:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDPv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 187147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64),
     /* 187150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187156 */     GIR_RootConstrainSelectedInstOperands,
     /* 187157 */     // GIR_Coverage, 1120,
     /* 187157 */     GIR_EraseRootFromParent_Done,
     /* 187158 */   // Label 3453: @187158
     /* 187158 */   GIM_Try, /*On fail goto*//*Label 3454*/ GIMT_Encode4(187203), // Rule ID 1163 //
     /* 187163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187192 */     // (intrinsic_wo_chain:{ *:[v4f16] } 583:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FABDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 187195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187201 */     GIR_RootConstrainSelectedInstOperands,
     /* 187202 */     // GIR_Coverage, 1163,
     /* 187202 */     GIR_EraseRootFromParent_Done,
     /* 187203 */   // Label 3454: @187203
     /* 187203 */   GIM_Try, /*On fail goto*//*Label 3455*/ GIMT_Encode4(187248), // Rule ID 1164 //
     /* 187208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187237 */     // (intrinsic_wo_chain:{ *:[v8f16] } 583:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FABDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 187240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187246 */     GIR_RootConstrainSelectedInstOperands,
     /* 187247 */     // GIR_Coverage, 1164,
     /* 187247 */     GIR_EraseRootFromParent_Done,
     /* 187248 */   // Label 3455: @187248
     /* 187248 */   GIM_Try, /*On fail goto*//*Label 3456*/ GIMT_Encode4(187293), // Rule ID 1165 //
     /* 187253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187282 */     // (intrinsic_wo_chain:{ *:[v2f32] } 583:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FABDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 187285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187291 */     GIR_RootConstrainSelectedInstOperands,
     /* 187292 */     // GIR_Coverage, 1165,
     /* 187292 */     GIR_EraseRootFromParent_Done,
     /* 187293 */   // Label 3456: @187293
     /* 187293 */   GIM_Try, /*On fail goto*//*Label 3457*/ GIMT_Encode4(187338), // Rule ID 1166 //
     /* 187298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187327 */     // (intrinsic_wo_chain:{ *:[v4f32] } 583:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FABDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 187330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187336 */     GIR_RootConstrainSelectedInstOperands,
     /* 187337 */     // GIR_Coverage, 1166,
     /* 187337 */     GIR_EraseRootFromParent_Done,
     /* 187338 */   // Label 3457: @187338
     /* 187338 */   GIM_Try, /*On fail goto*//*Label 3458*/ GIMT_Encode4(187383), // Rule ID 1167 //
     /* 187343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 187351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187372 */     // (intrinsic_wo_chain:{ *:[v2f64] } 583:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FABDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 187375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187381 */     GIR_RootConstrainSelectedInstOperands,
     /* 187382 */     // GIR_Coverage, 1167,
     /* 187382 */     GIR_EraseRootFromParent_Done,
     /* 187383 */   // Label 3458: @187383
     /* 187383 */   GIM_Try, /*On fail goto*//*Label 3459*/ GIMT_Encode4(187428), // Rule ID 1169 //
     /* 187388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187417 */     // (intrinsic_wo_chain:{ *:[v4i16] } 584:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 187420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187426 */     GIR_RootConstrainSelectedInstOperands,
     /* 187427 */     // GIR_Coverage, 1169,
     /* 187427 */     GIR_EraseRootFromParent_Done,
     /* 187428 */   // Label 3459: @187428
     /* 187428 */   GIM_Try, /*On fail goto*//*Label 3460*/ GIMT_Encode4(187473), // Rule ID 1171 //
     /* 187433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187462 */     // (intrinsic_wo_chain:{ *:[v8i16] } 584:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 187465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187471 */     GIR_RootConstrainSelectedInstOperands,
     /* 187472 */     // GIR_Coverage, 1171,
     /* 187472 */     GIR_EraseRootFromParent_Done,
     /* 187473 */   // Label 3460: @187473
     /* 187473 */   GIM_Try, /*On fail goto*//*Label 3461*/ GIMT_Encode4(187518), // Rule ID 1173 //
     /* 187478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187507 */     // (intrinsic_wo_chain:{ *:[v2i32] } 584:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 187510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187516 */     GIR_RootConstrainSelectedInstOperands,
     /* 187517 */     // GIR_Coverage, 1173,
     /* 187517 */     GIR_EraseRootFromParent_Done,
     /* 187518 */   // Label 3461: @187518
     /* 187518 */   GIM_Try, /*On fail goto*//*Label 3462*/ GIMT_Encode4(187563), // Rule ID 1175 //
     /* 187523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187552 */     // (intrinsic_wo_chain:{ *:[v4i32] } 584:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 187555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187561 */     GIR_RootConstrainSelectedInstOperands,
     /* 187562 */     // GIR_Coverage, 1175,
     /* 187562 */     GIR_EraseRootFromParent_Done,
     /* 187563 */   // Label 3462: @187563
     /* 187563 */   GIM_Try, /*On fail goto*//*Label 3463*/ GIMT_Encode4(187608), // Rule ID 1177 //
     /* 187568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 187576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187597 */     // (intrinsic_wo_chain:{ *:[v2i64] } 584:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 187600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187606 */     GIR_RootConstrainSelectedInstOperands,
     /* 187607 */     // GIR_Coverage, 1177,
     /* 187607 */     GIR_EraseRootFromParent_Done,
     /* 187608 */   // Label 3463: @187608
     /* 187608 */   GIM_Try, /*On fail goto*//*Label 3464*/ GIMT_Encode4(187653), // Rule ID 1179 //
     /* 187613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 585:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 187645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187651 */     GIR_RootConstrainSelectedInstOperands,
     /* 187652 */     // GIR_Coverage, 1179,
     /* 187652 */     GIR_EraseRootFromParent_Done,
     /* 187653 */   // Label 3464: @187653
     /* 187653 */   GIM_Try, /*On fail goto*//*Label 3465*/ GIMT_Encode4(187698), // Rule ID 1181 //
     /* 187658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187687 */     // (intrinsic_wo_chain:{ *:[v8i16] } 585:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 187690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187696 */     GIR_RootConstrainSelectedInstOperands,
     /* 187697 */     // GIR_Coverage, 1181,
     /* 187697 */     GIR_EraseRootFromParent_Done,
     /* 187698 */   // Label 3465: @187698
     /* 187698 */   GIM_Try, /*On fail goto*//*Label 3466*/ GIMT_Encode4(187743), // Rule ID 1183 //
     /* 187703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187732 */     // (intrinsic_wo_chain:{ *:[v2i32] } 585:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 187735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187741 */     GIR_RootConstrainSelectedInstOperands,
     /* 187742 */     // GIR_Coverage, 1183,
     /* 187742 */     GIR_EraseRootFromParent_Done,
     /* 187743 */   // Label 3466: @187743
     /* 187743 */   GIM_Try, /*On fail goto*//*Label 3467*/ GIMT_Encode4(187788), // Rule ID 1185 //
     /* 187748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187777 */     // (intrinsic_wo_chain:{ *:[v4i32] } 585:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 187777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 187780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187786 */     GIR_RootConstrainSelectedInstOperands,
     /* 187787 */     // GIR_Coverage, 1185,
     /* 187787 */     GIR_EraseRootFromParent_Done,
     /* 187788 */   // Label 3467: @187788
     /* 187788 */   GIM_Try, /*On fail goto*//*Label 3468*/ GIMT_Encode4(187833), // Rule ID 1187 //
     /* 187793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 187801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 187804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 187807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 187810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187822 */     // (intrinsic_wo_chain:{ *:[v2i64] } 585:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 187822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 187825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187831 */     GIR_RootConstrainSelectedInstOperands,
     /* 187832 */     // GIR_Coverage, 1187,
     /* 187832 */     GIR_EraseRootFromParent_Done,
     /* 187833 */   // Label 3468: @187833
     /* 187833 */   GIM_Try, /*On fail goto*//*Label 3469*/ GIMT_Encode4(187878), // Rule ID 1189 //
     /* 187838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 187849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 187852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 187855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187867 */     // (intrinsic_wo_chain:{ *:[v4f16] } 586:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 187867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 187870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187876 */     GIR_RootConstrainSelectedInstOperands,
     /* 187877 */     // GIR_Coverage, 1189,
     /* 187877 */     GIR_EraseRootFromParent_Done,
     /* 187878 */   // Label 3469: @187878
     /* 187878 */   GIM_Try, /*On fail goto*//*Label 3470*/ GIMT_Encode4(187923), // Rule ID 1191 //
     /* 187883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 187886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 187894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 187897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 187900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187912 */     // (intrinsic_wo_chain:{ *:[v8f16] } 586:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 187912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 187915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187921 */     GIR_RootConstrainSelectedInstOperands,
     /* 187922 */     // GIR_Coverage, 1191,
     /* 187922 */     GIR_EraseRootFromParent_Done,
     /* 187923 */   // Label 3470: @187923
     /* 187923 */   GIM_Try, /*On fail goto*//*Label 3471*/ GIMT_Encode4(187968), // Rule ID 1193 //
     /* 187928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 187939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 187942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 187945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 187957 */     // (intrinsic_wo_chain:{ *:[v2f32] } 586:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 187957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f32),
     /* 187960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 187962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 187964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 187966 */     GIR_RootConstrainSelectedInstOperands,
     /* 187967 */     // GIR_Coverage, 1193,
     /* 187967 */     GIR_EraseRootFromParent_Done,
     /* 187968 */   // Label 3471: @187968
     /* 187968 */   GIM_Try, /*On fail goto*//*Label 3472*/ GIMT_Encode4(188013), // Rule ID 1195 //
     /* 187973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 187976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 187981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 187984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 187987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 187990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 187998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188002 */     // (intrinsic_wo_chain:{ *:[v4f32] } 586:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 188005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188011 */     GIR_RootConstrainSelectedInstOperands,
     /* 188012 */     // GIR_Coverage, 1195,
     /* 188012 */     GIR_EraseRootFromParent_Done,
     /* 188013 */   // Label 3472: @188013
     /* 188013 */   GIM_Try, /*On fail goto*//*Label 3473*/ GIMT_Encode4(188058), // Rule ID 1197 //
     /* 188018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_faddp),
     /* 188026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188047 */     // (intrinsic_wo_chain:{ *:[v2f64] } 586:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 188050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188056 */     GIR_RootConstrainSelectedInstOperands,
     /* 188057 */     // GIR_Coverage, 1197,
     /* 188057 */     GIR_EraseRootFromParent_Done,
     /* 188058 */   // Label 3473: @188058
     /* 188058 */   GIM_Try, /*On fail goto*//*Label 3474*/ GIMT_Encode4(188103), // Rule ID 1233 //
     /* 188063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188092 */     // (intrinsic_wo_chain:{ *:[v4f16] } 603:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f16),
     /* 188095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188101 */     GIR_RootConstrainSelectedInstOperands,
     /* 188102 */     // GIR_Coverage, 1233,
     /* 188102 */     GIR_EraseRootFromParent_Done,
     /* 188103 */   // Label 3474: @188103
     /* 188103 */   GIM_Try, /*On fail goto*//*Label 3475*/ GIMT_Encode4(188148), // Rule ID 1234 //
     /* 188108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188137 */     // (intrinsic_wo_chain:{ *:[v8f16] } 603:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv8f16),
     /* 188140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188146 */     GIR_RootConstrainSelectedInstOperands,
     /* 188147 */     // GIR_Coverage, 1234,
     /* 188147 */     GIR_EraseRootFromParent_Done,
     /* 188148 */   // Label 3475: @188148
     /* 188148 */   GIM_Try, /*On fail goto*//*Label 3476*/ GIMT_Encode4(188193), // Rule ID 1235 //
     /* 188153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188182 */     // (intrinsic_wo_chain:{ *:[v2f32] } 603:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f32),
     /* 188185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188191 */     GIR_RootConstrainSelectedInstOperands,
     /* 188192 */     // GIR_Coverage, 1235,
     /* 188192 */     GIR_EraseRootFromParent_Done,
     /* 188193 */   // Label 3476: @188193
     /* 188193 */   GIM_Try, /*On fail goto*//*Label 3477*/ GIMT_Encode4(188238), // Rule ID 1236 //
     /* 188198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188227 */     // (intrinsic_wo_chain:{ *:[v4f32] } 603:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv4f32),
     /* 188230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188236 */     GIR_RootConstrainSelectedInstOperands,
     /* 188237 */     // GIR_Coverage, 1236,
     /* 188237 */     GIR_EraseRootFromParent_Done,
     /* 188238 */   // Label 3477: @188238
     /* 188238 */   GIM_Try, /*On fail goto*//*Label 3478*/ GIMT_Encode4(188283), // Rule ID 1237 //
     /* 188243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxnmp),
     /* 188251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188272 */     // (intrinsic_wo_chain:{ *:[v2f64] } 603:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2f64),
     /* 188275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188281 */     GIR_RootConstrainSelectedInstOperands,
     /* 188282 */     // GIR_Coverage, 1237,
     /* 188282 */     GIR_EraseRootFromParent_Done,
     /* 188283 */   // Label 3478: @188283
     /* 188283 */   GIM_Try, /*On fail goto*//*Label 3479*/ GIMT_Encode4(188328), // Rule ID 1248 //
     /* 188288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188317 */     // (intrinsic_wo_chain:{ *:[v4f16] } 605:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f16),
     /* 188320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188326 */     GIR_RootConstrainSelectedInstOperands,
     /* 188327 */     // GIR_Coverage, 1248,
     /* 188327 */     GIR_EraseRootFromParent_Done,
     /* 188328 */   // Label 3479: @188328
     /* 188328 */   GIM_Try, /*On fail goto*//*Label 3480*/ GIMT_Encode4(188373), // Rule ID 1249 //
     /* 188333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188362 */     // (intrinsic_wo_chain:{ *:[v8f16] } 605:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv8f16),
     /* 188365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188371 */     GIR_RootConstrainSelectedInstOperands,
     /* 188372 */     // GIR_Coverage, 1249,
     /* 188372 */     GIR_EraseRootFromParent_Done,
     /* 188373 */   // Label 3480: @188373
     /* 188373 */   GIM_Try, /*On fail goto*//*Label 3481*/ GIMT_Encode4(188418), // Rule ID 1250 //
     /* 188378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188407 */     // (intrinsic_wo_chain:{ *:[v2f32] } 605:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f32),
     /* 188410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188416 */     GIR_RootConstrainSelectedInstOperands,
     /* 188417 */     // GIR_Coverage, 1250,
     /* 188417 */     GIR_EraseRootFromParent_Done,
     /* 188418 */   // Label 3481: @188418
     /* 188418 */   GIM_Try, /*On fail goto*//*Label 3482*/ GIMT_Encode4(188463), // Rule ID 1251 //
     /* 188423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188452 */     // (intrinsic_wo_chain:{ *:[v4f32] } 605:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv4f32),
     /* 188455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188461 */     GIR_RootConstrainSelectedInstOperands,
     /* 188462 */     // GIR_Coverage, 1251,
     /* 188462 */     GIR_EraseRootFromParent_Done,
     /* 188463 */   // Label 3482: @188463
     /* 188463 */   GIM_Try, /*On fail goto*//*Label 3483*/ GIMT_Encode4(188508), // Rule ID 1252 //
     /* 188468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmaxp),
     /* 188476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188497 */     // (intrinsic_wo_chain:{ *:[v2f64] } 605:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2f64),
     /* 188500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188506 */     GIR_RootConstrainSelectedInstOperands,
     /* 188507 */     // GIR_Coverage, 1252,
     /* 188507 */     GIR_EraseRootFromParent_Done,
     /* 188508 */   // Label 3483: @188508
     /* 188508 */   GIM_Try, /*On fail goto*//*Label 3484*/ GIMT_Encode4(188553), // Rule ID 1263 //
     /* 188513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188542 */     // (intrinsic_wo_chain:{ *:[v4f16] } 609:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f16),
     /* 188545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188551 */     GIR_RootConstrainSelectedInstOperands,
     /* 188552 */     // GIR_Coverage, 1263,
     /* 188552 */     GIR_EraseRootFromParent_Done,
     /* 188553 */   // Label 3484: @188553
     /* 188553 */   GIM_Try, /*On fail goto*//*Label 3485*/ GIMT_Encode4(188598), // Rule ID 1264 //
     /* 188558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188587 */     // (intrinsic_wo_chain:{ *:[v8f16] } 609:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv8f16),
     /* 188590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188596 */     GIR_RootConstrainSelectedInstOperands,
     /* 188597 */     // GIR_Coverage, 1264,
     /* 188597 */     GIR_EraseRootFromParent_Done,
     /* 188598 */   // Label 3485: @188598
     /* 188598 */   GIM_Try, /*On fail goto*//*Label 3486*/ GIMT_Encode4(188643), // Rule ID 1265 //
     /* 188603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188632 */     // (intrinsic_wo_chain:{ *:[v2f32] } 609:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f32),
     /* 188635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188641 */     GIR_RootConstrainSelectedInstOperands,
     /* 188642 */     // GIR_Coverage, 1265,
     /* 188642 */     GIR_EraseRootFromParent_Done,
     /* 188643 */   // Label 3486: @188643
     /* 188643 */   GIM_Try, /*On fail goto*//*Label 3487*/ GIMT_Encode4(188688), // Rule ID 1266 //
     /* 188648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188677 */     // (intrinsic_wo_chain:{ *:[v4f32] } 609:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv4f32),
     /* 188680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188686 */     GIR_RootConstrainSelectedInstOperands,
     /* 188687 */     // GIR_Coverage, 1266,
     /* 188687 */     GIR_EraseRootFromParent_Done,
     /* 188688 */   // Label 3487: @188688
     /* 188688 */   GIM_Try, /*On fail goto*//*Label 3488*/ GIMT_Encode4(188733), // Rule ID 1267 //
     /* 188693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminnmp),
     /* 188701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188722 */     // (intrinsic_wo_chain:{ *:[v2f64] } 609:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2f64),
     /* 188725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188731 */     GIR_RootConstrainSelectedInstOperands,
     /* 188732 */     // GIR_Coverage, 1267,
     /* 188732 */     GIR_EraseRootFromParent_Done,
     /* 188733 */   // Label 3488: @188733
     /* 188733 */   GIM_Try, /*On fail goto*//*Label 3489*/ GIMT_Encode4(188778), // Rule ID 1278 //
     /* 188738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188767 */     // (intrinsic_wo_chain:{ *:[v4f16] } 611:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f16),
     /* 188770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188772 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188776 */     GIR_RootConstrainSelectedInstOperands,
     /* 188777 */     // GIR_Coverage, 1278,
     /* 188777 */     GIR_EraseRootFromParent_Done,
     /* 188778 */   // Label 3489: @188778
     /* 188778 */   GIM_Try, /*On fail goto*//*Label 3490*/ GIMT_Encode4(188823), // Rule ID 1279 //
     /* 188783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 188794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 188797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 188800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188812 */     // (intrinsic_wo_chain:{ *:[v8f16] } 611:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 188812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv8f16),
     /* 188815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188821 */     GIR_RootConstrainSelectedInstOperands,
     /* 188822 */     // GIR_Coverage, 1279,
     /* 188822 */     GIR_EraseRootFromParent_Done,
     /* 188823 */   // Label 3490: @188823
     /* 188823 */   GIM_Try, /*On fail goto*//*Label 3491*/ GIMT_Encode4(188868), // Rule ID 1280 //
     /* 188828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 188839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 188842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 188845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188857 */     // (intrinsic_wo_chain:{ *:[v2f32] } 611:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 188857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f32),
     /* 188860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188866 */     GIR_RootConstrainSelectedInstOperands,
     /* 188867 */     // GIR_Coverage, 1280,
     /* 188867 */     GIR_EraseRootFromParent_Done,
     /* 188868 */   // Label 3491: @188868
     /* 188868 */   GIM_Try, /*On fail goto*//*Label 3492*/ GIMT_Encode4(188913), // Rule ID 1281 //
     /* 188873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 188884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 188887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 188890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188902 */     // (intrinsic_wo_chain:{ *:[v4f32] } 611:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 188902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv4f32),
     /* 188905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188911 */     GIR_RootConstrainSelectedInstOperands,
     /* 188912 */     // GIR_Coverage, 1281,
     /* 188912 */     GIR_EraseRootFromParent_Done,
     /* 188913 */   // Label 3492: @188913
     /* 188913 */   GIM_Try, /*On fail goto*//*Label 3493*/ GIMT_Encode4(188958), // Rule ID 1282 //
     /* 188918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 188921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fminp),
     /* 188926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 188929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 188932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 188935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 188947 */     // (intrinsic_wo_chain:{ *:[v2f64] } 611:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 188947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2f64),
     /* 188950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 188956 */     GIR_RootConstrainSelectedInstOperands,
     /* 188957 */     // GIR_Coverage, 1282,
     /* 188957 */     GIR_EraseRootFromParent_Done,
     /* 188958 */   // Label 3493: @188958
     /* 188958 */   GIM_Try, /*On fail goto*//*Label 3494*/ GIMT_Encode4(189003), // Rule ID 1313 //
     /* 188963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 188966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 188971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 188974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 188977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 188980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 188992 */     // (intrinsic_wo_chain:{ *:[v4f16] } 617:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 188992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f16),
     /* 188995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 188997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 188999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189001 */     GIR_RootConstrainSelectedInstOperands,
     /* 189002 */     // GIR_Coverage, 1313,
     /* 189002 */     GIR_EraseRootFromParent_Done,
     /* 189003 */   // Label 3494: @189003
     /* 189003 */   GIM_Try, /*On fail goto*//*Label 3495*/ GIMT_Encode4(189048), // Rule ID 1314 //
     /* 189008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189037 */     // (intrinsic_wo_chain:{ *:[v8f16] } 617:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv8f16),
     /* 189040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189046 */     GIR_RootConstrainSelectedInstOperands,
     /* 189047 */     // GIR_Coverage, 1314,
     /* 189047 */     GIR_EraseRootFromParent_Done,
     /* 189048 */   // Label 3495: @189048
     /* 189048 */   GIM_Try, /*On fail goto*//*Label 3496*/ GIMT_Encode4(189093), // Rule ID 1315 //
     /* 189053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189082 */     // (intrinsic_wo_chain:{ *:[v2f32] } 617:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f32),
     /* 189085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189091 */     GIR_RootConstrainSelectedInstOperands,
     /* 189092 */     // GIR_Coverage, 1315,
     /* 189092 */     GIR_EraseRootFromParent_Done,
     /* 189093 */   // Label 3496: @189093
     /* 189093 */   GIM_Try, /*On fail goto*//*Label 3497*/ GIMT_Encode4(189138), // Rule ID 1316 //
     /* 189098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189127 */     // (intrinsic_wo_chain:{ *:[v4f32] } 617:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv4f32),
     /* 189130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189136 */     GIR_RootConstrainSelectedInstOperands,
     /* 189137 */     // GIR_Coverage, 1316,
     /* 189137 */     GIR_EraseRootFromParent_Done,
     /* 189138 */   // Label 3497: @189138
     /* 189138 */   GIM_Try, /*On fail goto*//*Label 3498*/ GIMT_Encode4(189183), // Rule ID 1317 //
     /* 189143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 189151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189172 */     // (intrinsic_wo_chain:{ *:[v2f64] } 617:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULXv2f64),
     /* 189175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189181 */     GIR_RootConstrainSelectedInstOperands,
     /* 189182 */     // GIR_Coverage, 1317,
     /* 189182 */     GIR_EraseRootFromParent_Done,
     /* 189183 */   // Label 3498: @189183
     /* 189183 */   GIM_Try, /*On fail goto*//*Label 3499*/ GIMT_Encode4(189228), // Rule ID 1328 //
     /* 189188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189217 */     // (intrinsic_wo_chain:{ *:[v4f16] } 640:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRECPSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f16),
     /* 189220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189226 */     GIR_RootConstrainSelectedInstOperands,
     /* 189227 */     // GIR_Coverage, 1328,
     /* 189227 */     GIR_EraseRootFromParent_Done,
     /* 189228 */   // Label 3499: @189228
     /* 189228 */   GIM_Try, /*On fail goto*//*Label 3500*/ GIMT_Encode4(189273), // Rule ID 1329 //
     /* 189233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189262 */     // (intrinsic_wo_chain:{ *:[v8f16] } 640:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRECPSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv8f16),
     /* 189265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189267 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189271 */     GIR_RootConstrainSelectedInstOperands,
     /* 189272 */     // GIR_Coverage, 1329,
     /* 189272 */     GIR_EraseRootFromParent_Done,
     /* 189273 */   // Label 3500: @189273
     /* 189273 */   GIM_Try, /*On fail goto*//*Label 3501*/ GIMT_Encode4(189318), // Rule ID 1330 //
     /* 189278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189307 */     // (intrinsic_wo_chain:{ *:[v2f32] } 640:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRECPSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f32),
     /* 189310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189316 */     GIR_RootConstrainSelectedInstOperands,
     /* 189317 */     // GIR_Coverage, 1330,
     /* 189317 */     GIR_EraseRootFromParent_Done,
     /* 189318 */   // Label 3501: @189318
     /* 189318 */   GIM_Try, /*On fail goto*//*Label 3502*/ GIMT_Encode4(189363), // Rule ID 1331 //
     /* 189323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189352 */     // (intrinsic_wo_chain:{ *:[v4f32] } 640:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRECPSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv4f32),
     /* 189355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189361 */     GIR_RootConstrainSelectedInstOperands,
     /* 189362 */     // GIR_Coverage, 1331,
     /* 189362 */     GIR_EraseRootFromParent_Done,
     /* 189363 */   // Label 3502: @189363
     /* 189363 */   GIM_Try, /*On fail goto*//*Label 3503*/ GIMT_Encode4(189408), // Rule ID 1332 //
     /* 189368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 189376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189397 */     // (intrinsic_wo_chain:{ *:[v2f64] } 640:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRECPSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPSv2f64),
     /* 189400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189406 */     GIR_RootConstrainSelectedInstOperands,
     /* 189407 */     // GIR_Coverage, 1332,
     /* 189407 */     GIR_EraseRootFromParent_Done,
     /* 189408 */   // Label 3503: @189408
     /* 189408 */   GIM_Try, /*On fail goto*//*Label 3504*/ GIMT_Encode4(189453), // Rule ID 1333 //
     /* 189413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189442 */     // (intrinsic_wo_chain:{ *:[v4f16] } 647:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FRSQRTSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 189442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f16),
     /* 189445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189451 */     GIR_RootConstrainSelectedInstOperands,
     /* 189452 */     // GIR_Coverage, 1333,
     /* 189452 */     GIR_EraseRootFromParent_Done,
     /* 189453 */   // Label 3504: @189453
     /* 189453 */   GIM_Try, /*On fail goto*//*Label 3505*/ GIMT_Encode4(189498), // Rule ID 1334 //
     /* 189458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 189461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189487 */     // (intrinsic_wo_chain:{ *:[v8f16] } 647:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FRSQRTSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 189487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv8f16),
     /* 189490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189496 */     GIR_RootConstrainSelectedInstOperands,
     /* 189497 */     // GIR_Coverage, 1334,
     /* 189497 */     GIR_EraseRootFromParent_Done,
     /* 189498 */   // Label 3505: @189498
     /* 189498 */   GIM_Try, /*On fail goto*//*Label 3506*/ GIMT_Encode4(189543), // Rule ID 1335 //
     /* 189503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189532 */     // (intrinsic_wo_chain:{ *:[v2f32] } 647:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FRSQRTSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 189532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f32),
     /* 189535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189541 */     GIR_RootConstrainSelectedInstOperands,
     /* 189542 */     // GIR_Coverage, 1335,
     /* 189542 */     GIR_EraseRootFromParent_Done,
     /* 189543 */   // Label 3506: @189543
     /* 189543 */   GIM_Try, /*On fail goto*//*Label 3507*/ GIMT_Encode4(189588), // Rule ID 1336 //
     /* 189548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189577 */     // (intrinsic_wo_chain:{ *:[v4f32] } 647:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FRSQRTSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 189577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv4f32),
     /* 189580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189586 */     GIR_RootConstrainSelectedInstOperands,
     /* 189587 */     // GIR_Coverage, 1336,
     /* 189587 */     GIR_EraseRootFromParent_Done,
     /* 189588 */   // Label 3507: @189588
     /* 189588 */   GIM_Try, /*On fail goto*//*Label 3508*/ GIMT_Encode4(189633), // Rule ID 1337 //
     /* 189593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 189601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 189604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 189607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 189610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189614 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189618 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189622 */     // (intrinsic_wo_chain:{ *:[v2f64] } 647:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FRSQRTSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 189622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTSv2f64),
     /* 189625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189631 */     GIR_RootConstrainSelectedInstOperands,
     /* 189632 */     // GIR_Coverage, 1337,
     /* 189632 */     GIR_EraseRootFromParent_Done,
     /* 189633 */   // Label 3508: @189633
     /* 189633 */   GIM_Try, /*On fail goto*//*Label 3509*/ GIMT_Encode4(189678), // Rule ID 1354 //
     /* 189638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189667 */     // (intrinsic_wo_chain:{ *:[v8i8] } 660:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (PMULv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv8i8),
     /* 189670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189676 */     GIR_RootConstrainSelectedInstOperands,
     /* 189677 */     // GIR_Coverage, 1354,
     /* 189677 */     GIR_EraseRootFromParent_Done,
     /* 189678 */   // Label 3509: @189678
     /* 189678 */   GIM_Try, /*On fail goto*//*Label 3510*/ GIMT_Encode4(189723), // Rule ID 1355 //
     /* 189683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_pmul),
     /* 189691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189704 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189712 */     // (intrinsic_wo_chain:{ *:[v16i8] } 660:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (PMULv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULv16i8),
     /* 189715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189721 */     GIR_RootConstrainSelectedInstOperands,
     /* 189722 */     // GIR_Coverage, 1355,
     /* 189722 */     GIR_EraseRootFromParent_Done,
     /* 189723 */   // Label 3510: @189723
     /* 189723 */   GIM_Try, /*On fail goto*//*Label 3511*/ GIMT_Encode4(189768), // Rule ID 1369 //
     /* 189728 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189731 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189736 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 189739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 189742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 189745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189757 */     // (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 189757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i8),
     /* 189760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189762 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189764 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189766 */     GIR_RootConstrainSelectedInstOperands,
     /* 189767 */     // GIR_Coverage, 1369,
     /* 189767 */     GIR_EraseRootFromParent_Done,
     /* 189768 */   // Label 3511: @189768
     /* 189768 */   GIM_Try, /*On fail goto*//*Label 3512*/ GIMT_Encode4(189813), // Rule ID 1371 //
     /* 189773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 189784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 189787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 189790 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189802 */     // (intrinsic_wo_chain:{ *:[v16i8] } 666:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 189802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv16i8),
     /* 189805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189811 */     GIR_RootConstrainSelectedInstOperands,
     /* 189812 */     // GIR_Coverage, 1371,
     /* 189812 */     GIR_EraseRootFromParent_Done,
     /* 189813 */   // Label 3512: @189813
     /* 189813 */   GIM_Try, /*On fail goto*//*Label 3513*/ GIMT_Encode4(189858), // Rule ID 1373 //
     /* 189818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189826 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 189829 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 189832 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 189835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189839 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189847 */     // (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 189847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i16),
     /* 189850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189856 */     GIR_RootConstrainSelectedInstOperands,
     /* 189857 */     // GIR_Coverage, 1373,
     /* 189857 */     GIR_EraseRootFromParent_Done,
     /* 189858 */   // Label 3513: @189858
     /* 189858 */   GIM_Try, /*On fail goto*//*Label 3514*/ GIMT_Encode4(189903), // Rule ID 1375 //
     /* 189863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 189874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 189877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 189880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189884 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189888 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189892 */     // (intrinsic_wo_chain:{ *:[v8i16] } 666:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 189892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv8i16),
     /* 189895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189901 */     GIR_RootConstrainSelectedInstOperands,
     /* 189902 */     // GIR_Coverage, 1375,
     /* 189902 */     GIR_EraseRootFromParent_Done,
     /* 189903 */   // Label 3514: @189903
     /* 189903 */   GIM_Try, /*On fail goto*//*Label 3515*/ GIMT_Encode4(189948), // Rule ID 1377 //
     /* 189908 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189911 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189916 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 189919 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 189922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 189925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 189937 */     // (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 189937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv2i32),
     /* 189940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189946 */     GIR_RootConstrainSelectedInstOperands,
     /* 189947 */     // GIR_Coverage, 1377,
     /* 189947 */     GIR_EraseRootFromParent_Done,
     /* 189948 */   // Label 3515: @189948
     /* 189948 */   GIM_Try, /*On fail goto*//*Label 3516*/ GIMT_Encode4(189993), // Rule ID 1379 //
     /* 189953 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 189956 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 189961 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 189964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 189967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 189970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189974 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189978 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 189982 */     // (intrinsic_wo_chain:{ *:[v4i32] } 666:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 189982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDv4i32),
     /* 189985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 189987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 189989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 189991 */     GIR_RootConstrainSelectedInstOperands,
     /* 189992 */     // GIR_Coverage, 1379,
     /* 189992 */     GIR_EraseRootFromParent_Done,
     /* 189993 */   // Label 3516: @189993
     /* 189993 */   GIM_Try, /*On fail goto*//*Label 3517*/ GIMT_Encode4(190038), // Rule ID 1386 //
     /* 189998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190027 */     // (intrinsic_wo_chain:{ *:[v8i8] } 676:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i8),
     /* 190030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190036 */     GIR_RootConstrainSelectedInstOperands,
     /* 190037 */     // GIR_Coverage, 1386,
     /* 190037 */     GIR_EraseRootFromParent_Done,
     /* 190038 */   // Label 3517: @190038
     /* 190038 */   GIM_Try, /*On fail goto*//*Label 3518*/ GIMT_Encode4(190083), // Rule ID 1387 //
     /* 190043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190072 */     // (intrinsic_wo_chain:{ *:[v16i8] } 676:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv16i8),
     /* 190075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190081 */     GIR_RootConstrainSelectedInstOperands,
     /* 190082 */     // GIR_Coverage, 1387,
     /* 190082 */     GIR_EraseRootFromParent_Done,
     /* 190083 */   // Label 3518: @190083
     /* 190083 */   GIM_Try, /*On fail goto*//*Label 3519*/ GIMT_Encode4(190128), // Rule ID 1388 //
     /* 190088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190117 */     // (intrinsic_wo_chain:{ *:[v4i16] } 676:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i16),
     /* 190120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190126 */     GIR_RootConstrainSelectedInstOperands,
     /* 190127 */     // GIR_Coverage, 1388,
     /* 190127 */     GIR_EraseRootFromParent_Done,
     /* 190128 */   // Label 3519: @190128
     /* 190128 */   GIM_Try, /*On fail goto*//*Label 3520*/ GIMT_Encode4(190173), // Rule ID 1389 //
     /* 190133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190150 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190162 */     // (intrinsic_wo_chain:{ *:[v8i16] } 676:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv8i16),
     /* 190165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190171 */     GIR_RootConstrainSelectedInstOperands,
     /* 190172 */     // GIR_Coverage, 1389,
     /* 190172 */     GIR_EraseRootFromParent_Done,
     /* 190173 */   // Label 3520: @190173
     /* 190173 */   GIM_Try, /*On fail goto*//*Label 3521*/ GIMT_Encode4(190218), // Rule ID 1390 //
     /* 190178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190207 */     // (intrinsic_wo_chain:{ *:[v2i32] } 676:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv2i32),
     /* 190210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190216 */     GIR_RootConstrainSelectedInstOperands,
     /* 190217 */     // GIR_Coverage, 1390,
     /* 190217 */     GIR_EraseRootFromParent_Done,
     /* 190218 */   // Label 3521: @190218
     /* 190218 */   GIM_Try, /*On fail goto*//*Label 3522*/ GIMT_Encode4(190263), // Rule ID 1391 //
     /* 190223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_shsub),
     /* 190231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190244 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190248 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190252 */     // (intrinsic_wo_chain:{ *:[v4i32] } 676:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBv4i32),
     /* 190255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190261 */     GIR_RootConstrainSelectedInstOperands,
     /* 190262 */     // GIR_Coverage, 1391,
     /* 190262 */     GIR_EraseRootFromParent_Done,
     /* 190263 */   // Label 3522: @190263
     /* 190263 */   GIM_Try, /*On fail goto*//*Label 3523*/ GIMT_Encode4(190308), // Rule ID 1392 //
     /* 190268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190271 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190276 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190285 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190289 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190297 */     // (intrinsic_wo_chain:{ *:[v8i8] } 678:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i8),
     /* 190300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190306 */     GIR_RootConstrainSelectedInstOperands,
     /* 190307 */     // GIR_Coverage, 1392,
     /* 190307 */     GIR_EraseRootFromParent_Done,
     /* 190308 */   // Label 3523: @190308
     /* 190308 */   GIM_Try, /*On fail goto*//*Label 3524*/ GIMT_Encode4(190353), // Rule ID 1393 //
     /* 190313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190342 */     // (intrinsic_wo_chain:{ *:[v16i8] } 678:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190342 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv16i8),
     /* 190345 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190347 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190349 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190351 */     GIR_RootConstrainSelectedInstOperands,
     /* 190352 */     // GIR_Coverage, 1393,
     /* 190352 */     GIR_EraseRootFromParent_Done,
     /* 190353 */   // Label 3524: @190353
     /* 190353 */   GIM_Try, /*On fail goto*//*Label 3525*/ GIMT_Encode4(190398), // Rule ID 1394 //
     /* 190358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190366 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190383 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190387 */     // (intrinsic_wo_chain:{ *:[v4i16] } 678:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i16),
     /* 190390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190396 */     GIR_RootConstrainSelectedInstOperands,
     /* 190397 */     // GIR_Coverage, 1394,
     /* 190397 */     GIR_EraseRootFromParent_Done,
     /* 190398 */   // Label 3525: @190398
     /* 190398 */   GIM_Try, /*On fail goto*//*Label 3526*/ GIMT_Encode4(190443), // Rule ID 1395 //
     /* 190403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190420 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190424 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190428 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190432 */     // (intrinsic_wo_chain:{ *:[v8i16] } 678:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190432 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv8i16),
     /* 190435 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190437 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190439 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190441 */     GIR_RootConstrainSelectedInstOperands,
     /* 190442 */     // GIR_Coverage, 1395,
     /* 190442 */     GIR_EraseRootFromParent_Done,
     /* 190443 */   // Label 3526: @190443
     /* 190443 */   GIM_Try, /*On fail goto*//*Label 3527*/ GIMT_Encode4(190488), // Rule ID 1396 //
     /* 190448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190451 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190456 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190459 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190469 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190473 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190477 */     // (intrinsic_wo_chain:{ *:[v2i32] } 678:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 190480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190486 */     GIR_RootConstrainSelectedInstOperands,
     /* 190487 */     // GIR_Coverage, 1396,
     /* 190487 */     GIR_EraseRootFromParent_Done,
     /* 190488 */   // Label 3527: @190488
     /* 190488 */   GIM_Try, /*On fail goto*//*Label 3528*/ GIMT_Encode4(190533), // Rule ID 1397 //
     /* 190493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxp),
     /* 190501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190514 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190522 */     // (intrinsic_wo_chain:{ *:[v4i32] } 678:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv4i32),
     /* 190525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190531 */     GIR_RootConstrainSelectedInstOperands,
     /* 190532 */     // GIR_Coverage, 1397,
     /* 190532 */     GIR_EraseRootFromParent_Done,
     /* 190533 */   // Label 3528: @190533
     /* 190533 */   GIM_Try, /*On fail goto*//*Label 3529*/ GIMT_Encode4(190578), // Rule ID 1404 //
     /* 190538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 190549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 190552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 190555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190559 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190563 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190567 */     // (intrinsic_wo_chain:{ *:[v8i8] } 681:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 190567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i8),
     /* 190570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190576 */     GIR_RootConstrainSelectedInstOperands,
     /* 190577 */     // GIR_Coverage, 1404,
     /* 190577 */     GIR_EraseRootFromParent_Done,
     /* 190578 */   // Label 3529: @190578
     /* 190578 */   GIM_Try, /*On fail goto*//*Label 3530*/ GIMT_Encode4(190623), // Rule ID 1405 //
     /* 190583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 190594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 190597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 190600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190604 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190608 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190612 */     // (intrinsic_wo_chain:{ *:[v16i8] } 681:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 190612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv16i8),
     /* 190615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190621 */     GIR_RootConstrainSelectedInstOperands,
     /* 190622 */     // GIR_Coverage, 1405,
     /* 190622 */     GIR_EraseRootFromParent_Done,
     /* 190623 */   // Label 3530: @190623
     /* 190623 */   GIM_Try, /*On fail goto*//*Label 3531*/ GIMT_Encode4(190668), // Rule ID 1406 //
     /* 190628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190649 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190653 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190657 */     // (intrinsic_wo_chain:{ *:[v4i16] } 681:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i16),
     /* 190660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190666 */     GIR_RootConstrainSelectedInstOperands,
     /* 190667 */     // GIR_Coverage, 1406,
     /* 190667 */     GIR_EraseRootFromParent_Done,
     /* 190668 */   // Label 3531: @190668
     /* 190668 */   GIM_Try, /*On fail goto*//*Label 3532*/ GIMT_Encode4(190713), // Rule ID 1407 //
     /* 190673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190694 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190698 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190702 */     // (intrinsic_wo_chain:{ *:[v8i16] } 681:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv8i16),
     /* 190705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190711 */     GIR_RootConstrainSelectedInstOperands,
     /* 190712 */     // GIR_Coverage, 1407,
     /* 190712 */     GIR_EraseRootFromParent_Done,
     /* 190713 */   // Label 3532: @190713
     /* 190713 */   GIM_Try, /*On fail goto*//*Label 3533*/ GIMT_Encode4(190758), // Rule ID 1408 //
     /* 190718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190739 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190743 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190747 */     // (intrinsic_wo_chain:{ *:[v2i32] } 681:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 190750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190756 */     GIR_RootConstrainSelectedInstOperands,
     /* 190757 */     // GIR_Coverage, 1408,
     /* 190757 */     GIR_EraseRootFromParent_Done,
     /* 190758 */   // Label 3533: @190758
     /* 190758 */   GIM_Try, /*On fail goto*//*Label 3534*/ GIMT_Encode4(190803), // Rule ID 1409 //
     /* 190763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminp),
     /* 190771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190780 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190784 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190788 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190792 */     // (intrinsic_wo_chain:{ *:[v4i32] } 681:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINPv4i32),
     /* 190795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190799 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190801 */     GIR_RootConstrainSelectedInstOperands,
     /* 190802 */     // GIR_Coverage, 1409,
     /* 190802 */     GIR_EraseRootFromParent_Done,
     /* 190803 */   // Label 3534: @190803
     /* 190803 */   GIM_Try, /*On fail goto*//*Label 3535*/ GIMT_Encode4(190848), // Rule ID 1423 //
     /* 190808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 190822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 190825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190829 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190833 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190837 */     // (intrinsic_wo_chain:{ *:[v4i16] } 687:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 190837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i16),
     /* 190840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190846 */     GIR_RootConstrainSelectedInstOperands,
     /* 190847 */     // GIR_Coverage, 1423,
     /* 190847 */     GIR_EraseRootFromParent_Done,
     /* 190848 */   // Label 3535: @190848
     /* 190848 */   GIM_Try, /*On fail goto*//*Label 3536*/ GIMT_Encode4(190893), // Rule ID 1424 //
     /* 190853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 190864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 190867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 190870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190882 */     // (intrinsic_wo_chain:{ *:[v8i16] } 687:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 190882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv8i16),
     /* 190885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190891 */     GIR_RootConstrainSelectedInstOperands,
     /* 190892 */     // GIR_Coverage, 1424,
     /* 190892 */     GIR_EraseRootFromParent_Done,
     /* 190893 */   // Label 3536: @190893
     /* 190893 */   GIM_Try, /*On fail goto*//*Label 3537*/ GIMT_Encode4(190938), // Rule ID 1425 //
     /* 190898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190901 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190906 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 190909 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 190912 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 190915 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 190927 */     // (intrinsic_wo_chain:{ *:[v2i32] } 687:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 190927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv2i32),
     /* 190930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190936 */     GIR_RootConstrainSelectedInstOperands,
     /* 190937 */     // GIR_Coverage, 1425,
     /* 190937 */     GIR_EraseRootFromParent_Done,
     /* 190938 */   // Label 3537: @190938
     /* 190938 */   GIM_Try, /*On fail goto*//*Label 3538*/ GIMT_Encode4(190983), // Rule ID 1426 //
     /* 190943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 190951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 190954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 190957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 190960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190964 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 190972 */     // (intrinsic_wo_chain:{ *:[v4i32] } 687:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 190972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv4i32),
     /* 190975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 190977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 190979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 190981 */     GIR_RootConstrainSelectedInstOperands,
     /* 190982 */     // GIR_Coverage, 1426,
     /* 190982 */     GIR_EraseRootFromParent_Done,
     /* 190983 */   // Label 3538: @190983
     /* 190983 */   GIM_Try, /*On fail goto*//*Label 3539*/ GIMT_Encode4(191028), // Rule ID 1427 //
     /* 190988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 190991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 190996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 190999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191013 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191017 */     // (intrinsic_wo_chain:{ *:[v4i16] } 695:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMULHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i16),
     /* 191020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191026 */     GIR_RootConstrainSelectedInstOperands,
     /* 191027 */     // GIR_Coverage, 1427,
     /* 191027 */     GIR_EraseRootFromParent_Done,
     /* 191028 */   // Label 3539: @191028
     /* 191028 */   GIM_Try, /*On fail goto*//*Label 3540*/ GIMT_Encode4(191073), // Rule ID 1428 //
     /* 191033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191062 */     // (intrinsic_wo_chain:{ *:[v8i16] } 695:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMULHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv8i16),
     /* 191065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191071 */     GIR_RootConstrainSelectedInstOperands,
     /* 191072 */     // GIR_Coverage, 1428,
     /* 191072 */     GIR_EraseRootFromParent_Done,
     /* 191073 */   // Label 3540: @191073
     /* 191073 */   GIM_Try, /*On fail goto*//*Label 3541*/ GIMT_Encode4(191118), // Rule ID 1429 //
     /* 191078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191081 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191086 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191107 */     // (intrinsic_wo_chain:{ *:[v2i32] } 695:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMULHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv2i32),
     /* 191110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191116 */     GIR_RootConstrainSelectedInstOperands,
     /* 191117 */     // GIR_Coverage, 1429,
     /* 191117 */     GIR_EraseRootFromParent_Done,
     /* 191118 */   // Label 3541: @191118
     /* 191118 */   GIM_Try, /*On fail goto*//*Label 3542*/ GIMT_Encode4(191163), // Rule ID 1430 //
     /* 191123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 191131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191144 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191148 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191152 */     // (intrinsic_wo_chain:{ *:[v4i32] } 695:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMULHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv4i32),
     /* 191155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191161 */     GIR_RootConstrainSelectedInstOperands,
     /* 191162 */     // GIR_Coverage, 1430,
     /* 191162 */     GIR_EraseRootFromParent_Done,
     /* 191163 */   // Label 3542: @191163
     /* 191163 */   GIM_Try, /*On fail goto*//*Label 3543*/ GIMT_Encode4(191208), // Rule ID 1431 //
     /* 191168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191171 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191176 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191179 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191182 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191189 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191197 */     // (intrinsic_wo_chain:{ *:[v8i8] } 698:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i8),
     /* 191200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191206 */     GIR_RootConstrainSelectedInstOperands,
     /* 191207 */     // GIR_Coverage, 1431,
     /* 191207 */     GIR_EraseRootFromParent_Done,
     /* 191208 */   // Label 3543: @191208
     /* 191208 */   GIM_Try, /*On fail goto*//*Label 3544*/ GIMT_Encode4(191253), // Rule ID 1432 //
     /* 191213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191238 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191242 */     // (intrinsic_wo_chain:{ *:[v16i8] } 698:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv16i8),
     /* 191245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191251 */     GIR_RootConstrainSelectedInstOperands,
     /* 191252 */     // GIR_Coverage, 1432,
     /* 191252 */     GIR_EraseRootFromParent_Done,
     /* 191253 */   // Label 3544: @191253
     /* 191253 */   GIM_Try, /*On fail goto*//*Label 3545*/ GIMT_Encode4(191298), // Rule ID 1433 //
     /* 191258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191287 */     // (intrinsic_wo_chain:{ *:[v4i16] } 698:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i16),
     /* 191290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191296 */     GIR_RootConstrainSelectedInstOperands,
     /* 191297 */     // GIR_Coverage, 1433,
     /* 191297 */     GIR_EraseRootFromParent_Done,
     /* 191298 */   // Label 3545: @191298
     /* 191298 */   GIM_Try, /*On fail goto*//*Label 3546*/ GIMT_Encode4(191343), // Rule ID 1434 //
     /* 191303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191324 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191328 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191332 */     // (intrinsic_wo_chain:{ *:[v8i16] } 698:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv8i16),
     /* 191335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191341 */     GIR_RootConstrainSelectedInstOperands,
     /* 191342 */     // GIR_Coverage, 1434,
     /* 191342 */     GIR_EraseRootFromParent_Done,
     /* 191343 */   // Label 3546: @191343
     /* 191343 */   GIM_Try, /*On fail goto*//*Label 3547*/ GIMT_Encode4(191388), // Rule ID 1435 //
     /* 191348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191373 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191377 */     // (intrinsic_wo_chain:{ *:[v2i32] } 698:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i32),
     /* 191380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191386 */     GIR_RootConstrainSelectedInstOperands,
     /* 191387 */     // GIR_Coverage, 1435,
     /* 191387 */     GIR_EraseRootFromParent_Done,
     /* 191388 */   // Label 3547: @191388
     /* 191388 */   GIM_Try, /*On fail goto*//*Label 3548*/ GIMT_Encode4(191433), // Rule ID 1436 //
     /* 191393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191410 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191414 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191418 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191422 */     // (intrinsic_wo_chain:{ *:[v4i32] } 698:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv4i32),
     /* 191425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191427 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191429 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191431 */     GIR_RootConstrainSelectedInstOperands,
     /* 191432 */     // GIR_Coverage, 1436,
     /* 191432 */     GIR_EraseRootFromParent_Done,
     /* 191433 */   // Label 3548: @191433
     /* 191433 */   GIM_Try, /*On fail goto*//*Label 3549*/ GIMT_Encode4(191478), // Rule ID 1437 //
     /* 191438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191441 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 191446 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191449 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191452 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191463 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191467 */     // (intrinsic_wo_chain:{ *:[v2i64] } 698:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv2i64),
     /* 191470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191476 */     GIR_RootConstrainSelectedInstOperands,
     /* 191477 */     // GIR_Coverage, 1437,
     /* 191477 */     GIR_EraseRootFromParent_Done,
     /* 191478 */   // Label 3549: @191478
     /* 191478 */   GIM_Try, /*On fail goto*//*Label 3550*/ GIMT_Encode4(191523), // Rule ID 1438 //
     /* 191483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191500 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191508 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191512 */     // (intrinsic_wo_chain:{ *:[v8i8] } 701:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i8),
     /* 191515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191517 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191521 */     GIR_RootConstrainSelectedInstOperands,
     /* 191522 */     // GIR_Coverage, 1438,
     /* 191522 */     GIR_EraseRootFromParent_Done,
     /* 191523 */   // Label 3550: @191523
     /* 191523 */   GIM_Try, /*On fail goto*//*Label 3551*/ GIMT_Encode4(191568), // Rule ID 1439 //
     /* 191528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191531 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191536 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191553 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191557 */     // (intrinsic_wo_chain:{ *:[v16i8] } 701:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv16i8),
     /* 191560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191562 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191564 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191566 */     GIR_RootConstrainSelectedInstOperands,
     /* 191567 */     // GIR_Coverage, 1439,
     /* 191567 */     GIR_EraseRootFromParent_Done,
     /* 191568 */   // Label 3551: @191568
     /* 191568 */   GIM_Try, /*On fail goto*//*Label 3552*/ GIMT_Encode4(191613), // Rule ID 1440 //
     /* 191573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191590 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191594 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191598 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191602 */     // (intrinsic_wo_chain:{ *:[v4i16] } 701:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i16),
     /* 191605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191611 */     GIR_RootConstrainSelectedInstOperands,
     /* 191612 */     // GIR_Coverage, 1440,
     /* 191612 */     GIR_EraseRootFromParent_Done,
     /* 191613 */   // Label 3552: @191613
     /* 191613 */   GIM_Try, /*On fail goto*//*Label 3553*/ GIMT_Encode4(191658), // Rule ID 1441 //
     /* 191618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191647 */     // (intrinsic_wo_chain:{ *:[v8i16] } 701:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv8i16),
     /* 191650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191656 */     GIR_RootConstrainSelectedInstOperands,
     /* 191657 */     // GIR_Coverage, 1441,
     /* 191657 */     GIR_EraseRootFromParent_Done,
     /* 191658 */   // Label 3553: @191658
     /* 191658 */   GIM_Try, /*On fail goto*//*Label 3554*/ GIMT_Encode4(191703), // Rule ID 1442 //
     /* 191663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191684 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191692 */     // (intrinsic_wo_chain:{ *:[v2i32] } 701:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 191692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i32),
     /* 191695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191701 */     GIR_RootConstrainSelectedInstOperands,
     /* 191702 */     // GIR_Coverage, 1442,
     /* 191702 */     GIR_EraseRootFromParent_Done,
     /* 191703 */   // Label 3554: @191703
     /* 191703 */   GIM_Try, /*On fail goto*//*Label 3555*/ GIMT_Encode4(191748), // Rule ID 1443 //
     /* 191708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191711 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191716 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 191719 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 191722 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 191725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191733 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191737 */     // (intrinsic_wo_chain:{ *:[v4i32] } 701:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 191737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv4i32),
     /* 191740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191746 */     GIR_RootConstrainSelectedInstOperands,
     /* 191747 */     // GIR_Coverage, 1443,
     /* 191747 */     GIR_EraseRootFromParent_Done,
     /* 191748 */   // Label 3555: @191748
     /* 191748 */   GIM_Try, /*On fail goto*//*Label 3556*/ GIMT_Encode4(191793), // Rule ID 1444 //
     /* 191753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 191761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 191764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 191767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 191770 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191778 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191782 */     // (intrinsic_wo_chain:{ *:[v2i64] } 701:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 191782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv2i64),
     /* 191785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191791 */     GIR_RootConstrainSelectedInstOperands,
     /* 191792 */     // GIR_Coverage, 1444,
     /* 191792 */     GIR_EraseRootFromParent_Done,
     /* 191793 */   // Label 3556: @191793
     /* 191793 */   GIM_Try, /*On fail goto*//*Label 3557*/ GIMT_Encode4(191838), // Rule ID 1458 //
     /* 191798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 191809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 191812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 191815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191819 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191827 */     // (intrinsic_wo_chain:{ *:[v8i8] } 709:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 191827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i8),
     /* 191830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191836 */     GIR_RootConstrainSelectedInstOperands,
     /* 191837 */     // GIR_Coverage, 1458,
     /* 191837 */     GIR_EraseRootFromParent_Done,
     /* 191838 */   // Label 3557: @191838
     /* 191838 */   GIM_Try, /*On fail goto*//*Label 3558*/ GIMT_Encode4(191883), // Rule ID 1459 //
     /* 191843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 191854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 191857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 191860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191864 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191872 */     // (intrinsic_wo_chain:{ *:[v16i8] } 709:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 191872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv16i8),
     /* 191875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191881 */     GIR_RootConstrainSelectedInstOperands,
     /* 191882 */     // GIR_Coverage, 1459,
     /* 191882 */     GIR_EraseRootFromParent_Done,
     /* 191883 */   // Label 3558: @191883
     /* 191883 */   GIM_Try, /*On fail goto*//*Label 3559*/ GIMT_Encode4(191928), // Rule ID 1460 //
     /* 191888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 191899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 191902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 191905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191917 */     // (intrinsic_wo_chain:{ *:[v4i16] } 709:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 191917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i16),
     /* 191920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191926 */     GIR_RootConstrainSelectedInstOperands,
     /* 191927 */     // GIR_Coverage, 1460,
     /* 191927 */     GIR_EraseRootFromParent_Done,
     /* 191928 */   // Label 3559: @191928
     /* 191928 */   GIM_Try, /*On fail goto*//*Label 3560*/ GIMT_Encode4(191973), // Rule ID 1461 //
     /* 191933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 191944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 191947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 191950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 191962 */     // (intrinsic_wo_chain:{ *:[v8i16] } 709:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 191962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv8i16),
     /* 191965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 191967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 191969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 191971 */     GIR_RootConstrainSelectedInstOperands,
     /* 191972 */     // GIR_Coverage, 1461,
     /* 191972 */     GIR_EraseRootFromParent_Done,
     /* 191973 */   // Label 3560: @191973
     /* 191973 */   GIM_Try, /*On fail goto*//*Label 3561*/ GIMT_Encode4(192018), // Rule ID 1462 //
     /* 191978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 191981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 191986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 191989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 191992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 191995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 191999 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192003 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192007 */     // (intrinsic_wo_chain:{ *:[v2i32] } 709:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i32),
     /* 192010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192016 */     GIR_RootConstrainSelectedInstOperands,
     /* 192017 */     // GIR_Coverage, 1462,
     /* 192017 */     GIR_EraseRootFromParent_Done,
     /* 192018 */   // Label 3561: @192018
     /* 192018 */   GIM_Try, /*On fail goto*//*Label 3562*/ GIMT_Encode4(192063), // Rule ID 1463 //
     /* 192023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192044 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192052 */     // (intrinsic_wo_chain:{ *:[v4i32] } 709:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv4i32),
     /* 192055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192057 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192059 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192061 */     GIR_RootConstrainSelectedInstOperands,
     /* 192062 */     // GIR_Coverage, 1463,
     /* 192062 */     GIR_EraseRootFromParent_Done,
     /* 192063 */   // Label 3562: @192063
     /* 192063 */   GIM_Try, /*On fail goto*//*Label 3563*/ GIMT_Encode4(192108), // Rule ID 1464 //
     /* 192068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 192076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192089 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192093 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192097 */     // (intrinsic_wo_chain:{ *:[v2i64] } 709:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv2i64),
     /* 192100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192106 */     GIR_RootConstrainSelectedInstOperands,
     /* 192107 */     // GIR_Coverage, 1464,
     /* 192107 */     GIR_EraseRootFromParent_Done,
     /* 192108 */   // Label 3563: @192108
     /* 192108 */   GIM_Try, /*On fail goto*//*Label 3564*/ GIMT_Encode4(192153), // Rule ID 1465 //
     /* 192113 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192116 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192121 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192124 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192127 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192130 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192134 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192138 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192142 */     // (intrinsic_wo_chain:{ *:[v8i8] } 710:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192142 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i8),
     /* 192145 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192149 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192151 */     GIR_RootConstrainSelectedInstOperands,
     /* 192152 */     // GIR_Coverage, 1465,
     /* 192152 */     GIR_EraseRootFromParent_Done,
     /* 192153 */   // Label 3564: @192153
     /* 192153 */   GIM_Try, /*On fail goto*//*Label 3565*/ GIMT_Encode4(192198), // Rule ID 1466 //
     /* 192158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192166 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192169 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192172 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192175 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192179 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192183 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192187 */     // (intrinsic_wo_chain:{ *:[v16i8] } 710:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv16i8),
     /* 192190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192192 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192194 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192196 */     GIR_RootConstrainSelectedInstOperands,
     /* 192197 */     // GIR_Coverage, 1466,
     /* 192197 */     GIR_EraseRootFromParent_Done,
     /* 192198 */   // Label 3565: @192198
     /* 192198 */   GIM_Try, /*On fail goto*//*Label 3566*/ GIMT_Encode4(192243), // Rule ID 1467 //
     /* 192203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192232 */     // (intrinsic_wo_chain:{ *:[v4i16] } 710:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i16),
     /* 192235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192241 */     GIR_RootConstrainSelectedInstOperands,
     /* 192242 */     // GIR_Coverage, 1467,
     /* 192242 */     GIR_EraseRootFromParent_Done,
     /* 192243 */   // Label 3566: @192243
     /* 192243 */   GIM_Try, /*On fail goto*//*Label 3567*/ GIMT_Encode4(192288), // Rule ID 1468 //
     /* 192248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192251 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192256 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192259 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192262 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192269 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192273 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192277 */     // (intrinsic_wo_chain:{ *:[v8i16] } 710:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv8i16),
     /* 192280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192286 */     GIR_RootConstrainSelectedInstOperands,
     /* 192287 */     // GIR_Coverage, 1468,
     /* 192287 */     GIR_EraseRootFromParent_Done,
     /* 192288 */   // Label 3567: @192288
     /* 192288 */   GIM_Try, /*On fail goto*//*Label 3568*/ GIMT_Encode4(192333), // Rule ID 1469 //
     /* 192293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192314 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192318 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192322 */     // (intrinsic_wo_chain:{ *:[v2i32] } 710:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i32),
     /* 192325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192331 */     GIR_RootConstrainSelectedInstOperands,
     /* 192332 */     // GIR_Coverage, 1469,
     /* 192332 */     GIR_EraseRootFromParent_Done,
     /* 192333 */   // Label 3568: @192333
     /* 192333 */   GIM_Try, /*On fail goto*//*Label 3569*/ GIMT_Encode4(192378), // Rule ID 1470 //
     /* 192338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192346 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192349 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192352 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192359 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192367 */     // (intrinsic_wo_chain:{ *:[v4i32] } 710:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv4i32),
     /* 192370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192376 */     GIR_RootConstrainSelectedInstOperands,
     /* 192377 */     // GIR_Coverage, 1470,
     /* 192377 */     GIR_EraseRootFromParent_Done,
     /* 192378 */   // Label 3569: @192378
     /* 192378 */   GIM_Try, /*On fail goto*//*Label 3570*/ GIMT_Encode4(192423), // Rule ID 1471 //
     /* 192383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 192391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 192394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 192397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 192400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192404 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192408 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192412 */     // (intrinsic_wo_chain:{ *:[v2i64] } 710:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 192412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv2i64),
     /* 192415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192421 */     GIR_RootConstrainSelectedInstOperands,
     /* 192422 */     // GIR_Coverage, 1471,
     /* 192422 */     GIR_EraseRootFromParent_Done,
     /* 192423 */   // Label 3570: @192423
     /* 192423 */   GIM_Try, /*On fail goto*//*Label 3571*/ GIMT_Encode4(192468), // Rule ID 1492 //
     /* 192428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192431 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192436 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192439 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192442 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192453 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192457 */     // (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UABDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i8),
     /* 192460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192466 */     GIR_RootConstrainSelectedInstOperands,
     /* 192467 */     // GIR_Coverage, 1492,
     /* 192467 */     GIR_EraseRootFromParent_Done,
     /* 192468 */   // Label 3571: @192468
     /* 192468 */   GIM_Try, /*On fail goto*//*Label 3572*/ GIMT_Encode4(192513), // Rule ID 1494 //
     /* 192473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192498 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192502 */     // (intrinsic_wo_chain:{ *:[v16i8] } 731:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UABDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv16i8),
     /* 192505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192511 */     GIR_RootConstrainSelectedInstOperands,
     /* 192512 */     // GIR_Coverage, 1494,
     /* 192512 */     GIR_EraseRootFromParent_Done,
     /* 192513 */   // Label 3572: @192513
     /* 192513 */   GIM_Try, /*On fail goto*//*Label 3573*/ GIMT_Encode4(192558), // Rule ID 1496 //
     /* 192518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192547 */     // (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UABDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192547 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i16),
     /* 192550 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192552 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192554 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192556 */     GIR_RootConstrainSelectedInstOperands,
     /* 192557 */     // GIR_Coverage, 1496,
     /* 192557 */     GIR_EraseRootFromParent_Done,
     /* 192558 */   // Label 3573: @192558
     /* 192558 */   GIM_Try, /*On fail goto*//*Label 3574*/ GIMT_Encode4(192603), // Rule ID 1498 //
     /* 192563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192584 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192588 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192592 */     // (intrinsic_wo_chain:{ *:[v8i16] } 731:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UABDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv8i16),
     /* 192595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192601 */     GIR_RootConstrainSelectedInstOperands,
     /* 192602 */     // GIR_Coverage, 1498,
     /* 192602 */     GIR_EraseRootFromParent_Done,
     /* 192603 */   // Label 3574: @192603
     /* 192603 */   GIM_Try, /*On fail goto*//*Label 3575*/ GIMT_Encode4(192648), // Rule ID 1500 //
     /* 192608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192637 */     // (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UABDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv2i32),
     /* 192640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192646 */     GIR_RootConstrainSelectedInstOperands,
     /* 192647 */     // GIR_Coverage, 1500,
     /* 192647 */     GIR_EraseRootFromParent_Done,
     /* 192648 */   // Label 3575: @192648
     /* 192648 */   GIM_Try, /*On fail goto*//*Label 3576*/ GIMT_Encode4(192693), // Rule ID 1502 //
     /* 192653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 192661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192678 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192682 */     // (intrinsic_wo_chain:{ *:[v4i32] } 731:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UABDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDv4i32),
     /* 192685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192691 */     GIR_RootConstrainSelectedInstOperands,
     /* 192692 */     // GIR_Coverage, 1502,
     /* 192692 */     GIR_EraseRootFromParent_Done,
     /* 192693 */   // Label 3576: @192693
     /* 192693 */   GIM_Try, /*On fail goto*//*Label 3577*/ GIMT_Encode4(192738), // Rule ID 1509 //
     /* 192698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192706 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192709 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192712 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192719 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192723 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192727 */     // (intrinsic_wo_chain:{ *:[v8i8] } 737:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UHSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i8),
     /* 192730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192736 */     GIR_RootConstrainSelectedInstOperands,
     /* 192737 */     // GIR_Coverage, 1509,
     /* 192737 */     GIR_EraseRootFromParent_Done,
     /* 192738 */   // Label 3577: @192738
     /* 192738 */   GIM_Try, /*On fail goto*//*Label 3578*/ GIMT_Encode4(192783), // Rule ID 1510 //
     /* 192743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 192754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 192757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 192760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192764 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192772 */     // (intrinsic_wo_chain:{ *:[v16i8] } 737:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UHSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 192772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv16i8),
     /* 192775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192781 */     GIR_RootConstrainSelectedInstOperands,
     /* 192782 */     // GIR_Coverage, 1510,
     /* 192782 */     GIR_EraseRootFromParent_Done,
     /* 192783 */   // Label 3578: @192783
     /* 192783 */   GIM_Try, /*On fail goto*//*Label 3579*/ GIMT_Encode4(192828), // Rule ID 1511 //
     /* 192788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 192799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 192802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 192805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192817 */     // (intrinsic_wo_chain:{ *:[v4i16] } 737:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UHSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 192817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i16),
     /* 192820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192826 */     GIR_RootConstrainSelectedInstOperands,
     /* 192827 */     // GIR_Coverage, 1511,
     /* 192827 */     GIR_EraseRootFromParent_Done,
     /* 192828 */   // Label 3579: @192828
     /* 192828 */   GIM_Try, /*On fail goto*//*Label 3580*/ GIMT_Encode4(192873), // Rule ID 1512 //
     /* 192833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 192844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 192847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 192850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192862 */     // (intrinsic_wo_chain:{ *:[v8i16] } 737:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UHSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 192862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv8i16),
     /* 192865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192871 */     GIR_RootConstrainSelectedInstOperands,
     /* 192872 */     // GIR_Coverage, 1512,
     /* 192872 */     GIR_EraseRootFromParent_Done,
     /* 192873 */   // Label 3580: @192873
     /* 192873 */   GIM_Try, /*On fail goto*//*Label 3581*/ GIMT_Encode4(192918), // Rule ID 1513 //
     /* 192878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192886 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 192889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 192892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 192895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192907 */     // (intrinsic_wo_chain:{ *:[v2i32] } 737:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UHSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 192907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv2i32),
     /* 192910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192916 */     GIR_RootConstrainSelectedInstOperands,
     /* 192917 */     // GIR_Coverage, 1513,
     /* 192917 */     GIR_EraseRootFromParent_Done,
     /* 192918 */   // Label 3581: @192918
     /* 192918 */   GIM_Try, /*On fail goto*//*Label 3582*/ GIMT_Encode4(192963), // Rule ID 1514 //
     /* 192923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uhsub),
     /* 192931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 192934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 192937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 192940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192948 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 192952 */     // (intrinsic_wo_chain:{ *:[v4i32] } 737:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UHSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 192952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBv4i32),
     /* 192955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 192957 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 192959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 192961 */     GIR_RootConstrainSelectedInstOperands,
     /* 192962 */     // GIR_Coverage, 1514,
     /* 192962 */     GIR_EraseRootFromParent_Done,
     /* 192963 */   // Label 3582: @192963
     /* 192963 */   GIM_Try, /*On fail goto*//*Label 3583*/ GIMT_Encode4(193008), // Rule ID 1515 //
     /* 192968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 192971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 192976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 192979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 192982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 192985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192989 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 192997 */     // (intrinsic_wo_chain:{ *:[v8i8] } 739:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 192997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i8),
     /* 193000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193006 */     GIR_RootConstrainSelectedInstOperands,
     /* 193007 */     // GIR_Coverage, 1515,
     /* 193007 */     GIR_EraseRootFromParent_Done,
     /* 193008 */   // Label 3583: @193008
     /* 193008 */   GIM_Try, /*On fail goto*//*Label 3584*/ GIMT_Encode4(193053), // Rule ID 1516 //
     /* 193013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193016 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193021 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193024 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193027 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193034 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193042 */     // (intrinsic_wo_chain:{ *:[v16i8] } 739:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv16i8),
     /* 193045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193051 */     GIR_RootConstrainSelectedInstOperands,
     /* 193052 */     // GIR_Coverage, 1516,
     /* 193052 */     GIR_EraseRootFromParent_Done,
     /* 193053 */   // Label 3584: @193053
     /* 193053 */   GIM_Try, /*On fail goto*//*Label 3585*/ GIMT_Encode4(193098), // Rule ID 1517 //
     /* 193058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193066 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193079 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193083 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193087 */     // (intrinsic_wo_chain:{ *:[v4i16] } 739:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i16),
     /* 193090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193096 */     GIR_RootConstrainSelectedInstOperands,
     /* 193097 */     // GIR_Coverage, 1517,
     /* 193097 */     GIR_EraseRootFromParent_Done,
     /* 193098 */   // Label 3585: @193098
     /* 193098 */   GIM_Try, /*On fail goto*//*Label 3586*/ GIMT_Encode4(193143), // Rule ID 1518 //
     /* 193103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193132 */     // (intrinsic_wo_chain:{ *:[v8i16] } 739:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv8i16),
     /* 193135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193141 */     GIR_RootConstrainSelectedInstOperands,
     /* 193142 */     // GIR_Coverage, 1518,
     /* 193142 */     GIR_EraseRootFromParent_Done,
     /* 193143 */   // Label 3586: @193143
     /* 193143 */   GIM_Try, /*On fail goto*//*Label 3587*/ GIMT_Encode4(193188), // Rule ID 1519 //
     /* 193148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193177 */     // (intrinsic_wo_chain:{ *:[v2i32] } 739:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 193180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193186 */     GIR_RootConstrainSelectedInstOperands,
     /* 193187 */     // GIR_Coverage, 1519,
     /* 193187 */     GIR_EraseRootFromParent_Done,
     /* 193188 */   // Label 3587: @193188
     /* 193188 */   GIM_Try, /*On fail goto*//*Label 3588*/ GIMT_Encode4(193233), // Rule ID 1520 //
     /* 193193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxp),
     /* 193201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193222 */     // (intrinsic_wo_chain:{ *:[v4i32] } 739:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv4i32),
     /* 193225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193231 */     GIR_RootConstrainSelectedInstOperands,
     /* 193232 */     // GIR_Coverage, 1520,
     /* 193232 */     GIR_EraseRootFromParent_Done,
     /* 193233 */   // Label 3588: @193233
     /* 193233 */   GIM_Try, /*On fail goto*//*Label 3589*/ GIMT_Encode4(193278), // Rule ID 1527 //
     /* 193238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193267 */     // (intrinsic_wo_chain:{ *:[v8i8] } 742:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i8),
     /* 193270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193276 */     GIR_RootConstrainSelectedInstOperands,
     /* 193277 */     // GIR_Coverage, 1527,
     /* 193277 */     GIR_EraseRootFromParent_Done,
     /* 193278 */   // Label 3589: @193278
     /* 193278 */   GIM_Try, /*On fail goto*//*Label 3590*/ GIMT_Encode4(193323), // Rule ID 1528 //
     /* 193283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193312 */     // (intrinsic_wo_chain:{ *:[v16i8] } 742:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv16i8),
     /* 193315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193321 */     GIR_RootConstrainSelectedInstOperands,
     /* 193322 */     // GIR_Coverage, 1528,
     /* 193322 */     GIR_EraseRootFromParent_Done,
     /* 193323 */   // Label 3590: @193323
     /* 193323 */   GIM_Try, /*On fail goto*//*Label 3591*/ GIMT_Encode4(193368), // Rule ID 1529 //
     /* 193328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193357 */     // (intrinsic_wo_chain:{ *:[v4i16] } 742:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINPv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i16),
     /* 193360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193366 */     GIR_RootConstrainSelectedInstOperands,
     /* 193367 */     // GIR_Coverage, 1529,
     /* 193367 */     GIR_EraseRootFromParent_Done,
     /* 193368 */   // Label 3591: @193368
     /* 193368 */   GIM_Try, /*On fail goto*//*Label 3592*/ GIMT_Encode4(193413), // Rule ID 1530 //
     /* 193373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193402 */     // (intrinsic_wo_chain:{ *:[v8i16] } 742:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINPv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv8i16),
     /* 193405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193411 */     GIR_RootConstrainSelectedInstOperands,
     /* 193412 */     // GIR_Coverage, 1530,
     /* 193412 */     GIR_EraseRootFromParent_Done,
     /* 193413 */   // Label 3592: @193413
     /* 193413 */   GIM_Try, /*On fail goto*//*Label 3593*/ GIMT_Encode4(193458), // Rule ID 1531 //
     /* 193418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193447 */     // (intrinsic_wo_chain:{ *:[v2i32] } 742:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINPv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 193450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193456 */     GIR_RootConstrainSelectedInstOperands,
     /* 193457 */     // GIR_Coverage, 1531,
     /* 193457 */     GIR_EraseRootFromParent_Done,
     /* 193458 */   // Label 3593: @193458
     /* 193458 */   GIM_Try, /*On fail goto*//*Label 3594*/ GIMT_Encode4(193503), // Rule ID 1532 //
     /* 193463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminp),
     /* 193471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193492 */     // (intrinsic_wo_chain:{ *:[v4i32] } 742:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINPv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINPv4i32),
     /* 193495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193501 */     GIR_RootConstrainSelectedInstOperands,
     /* 193502 */     // GIR_Coverage, 1532,
     /* 193502 */     GIR_EraseRootFromParent_Done,
     /* 193503 */   // Label 3594: @193503
     /* 193503 */   GIM_Try, /*On fail goto*//*Label 3595*/ GIMT_Encode4(193548), // Rule ID 1546 //
     /* 193508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193537 */     // (intrinsic_wo_chain:{ *:[v8i8] } 747:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQRSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i8),
     /* 193540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193546 */     GIR_RootConstrainSelectedInstOperands,
     /* 193547 */     // GIR_Coverage, 1546,
     /* 193547 */     GIR_EraseRootFromParent_Done,
     /* 193548 */   // Label 3595: @193548
     /* 193548 */   GIM_Try, /*On fail goto*//*Label 3596*/ GIMT_Encode4(193593), // Rule ID 1547 //
     /* 193553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193582 */     // (intrinsic_wo_chain:{ *:[v16i8] } 747:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQRSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv16i8),
     /* 193585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193591 */     GIR_RootConstrainSelectedInstOperands,
     /* 193592 */     // GIR_Coverage, 1547,
     /* 193592 */     GIR_EraseRootFromParent_Done,
     /* 193593 */   // Label 3596: @193593
     /* 193593 */   GIM_Try, /*On fail goto*//*Label 3597*/ GIMT_Encode4(193638), // Rule ID 1548 //
     /* 193598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193627 */     // (intrinsic_wo_chain:{ *:[v4i16] } 747:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQRSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i16),
     /* 193630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193636 */     GIR_RootConstrainSelectedInstOperands,
     /* 193637 */     // GIR_Coverage, 1548,
     /* 193637 */     GIR_EraseRootFromParent_Done,
     /* 193638 */   // Label 3597: @193638
     /* 193638 */   GIM_Try, /*On fail goto*//*Label 3598*/ GIMT_Encode4(193683), // Rule ID 1549 //
     /* 193643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193672 */     // (intrinsic_wo_chain:{ *:[v8i16] } 747:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQRSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv8i16),
     /* 193675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193681 */     GIR_RootConstrainSelectedInstOperands,
     /* 193682 */     // GIR_Coverage, 1549,
     /* 193682 */     GIR_EraseRootFromParent_Done,
     /* 193683 */   // Label 3598: @193683
     /* 193683 */   GIM_Try, /*On fail goto*//*Label 3599*/ GIMT_Encode4(193728), // Rule ID 1550 //
     /* 193688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 193699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 193702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 193705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193717 */     // (intrinsic_wo_chain:{ *:[v2i32] } 747:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQRSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 193717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i32),
     /* 193720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193726 */     GIR_RootConstrainSelectedInstOperands,
     /* 193727 */     // GIR_Coverage, 1550,
     /* 193727 */     GIR_EraseRootFromParent_Done,
     /* 193728 */   // Label 3599: @193728
     /* 193728 */   GIM_Try, /*On fail goto*//*Label 3600*/ GIMT_Encode4(193773), // Rule ID 1551 //
     /* 193733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 193744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 193747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 193750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193762 */     // (intrinsic_wo_chain:{ *:[v4i32] } 747:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQRSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 193762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv4i32),
     /* 193765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193771 */     GIR_RootConstrainSelectedInstOperands,
     /* 193772 */     // GIR_Coverage, 1551,
     /* 193772 */     GIR_EraseRootFromParent_Done,
     /* 193773 */   // Label 3600: @193773
     /* 193773 */   GIM_Try, /*On fail goto*//*Label 3601*/ GIMT_Encode4(193818), // Rule ID 1552 //
     /* 193778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 193786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 193789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 193792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 193795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193807 */     // (intrinsic_wo_chain:{ *:[v2i64] } 747:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQRSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 193807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv2i64),
     /* 193810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193816 */     GIR_RootConstrainSelectedInstOperands,
     /* 193817 */     // GIR_Coverage, 1552,
     /* 193817 */     GIR_EraseRootFromParent_Done,
     /* 193818 */   // Label 3601: @193818
     /* 193818 */   GIM_Try, /*On fail goto*//*Label 3602*/ GIMT_Encode4(193863), // Rule ID 1553 //
     /* 193823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 193834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 193837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 193840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193852 */     // (intrinsic_wo_chain:{ *:[v8i8] } 749:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 193852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i8),
     /* 193855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193861 */     GIR_RootConstrainSelectedInstOperands,
     /* 193862 */     // GIR_Coverage, 1553,
     /* 193862 */     GIR_EraseRootFromParent_Done,
     /* 193863 */   // Label 3602: @193863
     /* 193863 */   GIM_Try, /*On fail goto*//*Label 3603*/ GIMT_Encode4(193908), // Rule ID 1554 //
     /* 193868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 193879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 193882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 193885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193897 */     // (intrinsic_wo_chain:{ *:[v16i8] } 749:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 193897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv16i8),
     /* 193900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193906 */     GIR_RootConstrainSelectedInstOperands,
     /* 193907 */     // GIR_Coverage, 1554,
     /* 193907 */     GIR_EraseRootFromParent_Done,
     /* 193908 */   // Label 3603: @193908
     /* 193908 */   GIM_Try, /*On fail goto*//*Label 3604*/ GIMT_Encode4(193953), // Rule ID 1555 //
     /* 193913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 193924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 193927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 193930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 193942 */     // (intrinsic_wo_chain:{ *:[v4i16] } 749:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 193942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i16),
     /* 193945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193951 */     GIR_RootConstrainSelectedInstOperands,
     /* 193952 */     // GIR_Coverage, 1555,
     /* 193952 */     GIR_EraseRootFromParent_Done,
     /* 193953 */   // Label 3604: @193953
     /* 193953 */   GIM_Try, /*On fail goto*//*Label 3605*/ GIMT_Encode4(193998), // Rule ID 1556 //
     /* 193958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 193961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 193966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 193969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 193972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 193975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 193987 */     // (intrinsic_wo_chain:{ *:[v8i16] } 749:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 193987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv8i16),
     /* 193990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 193992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 193994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 193996 */     GIR_RootConstrainSelectedInstOperands,
     /* 193997 */     // GIR_Coverage, 1556,
     /* 193997 */     GIR_EraseRootFromParent_Done,
     /* 193998 */   // Label 3605: @193998
     /* 193998 */   GIM_Try, /*On fail goto*//*Label 3606*/ GIMT_Encode4(194043), // Rule ID 1557 //
     /* 194003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194032 */     // (intrinsic_wo_chain:{ *:[v2i32] } 749:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i32),
     /* 194035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194041 */     GIR_RootConstrainSelectedInstOperands,
     /* 194042 */     // GIR_Coverage, 1557,
     /* 194042 */     GIR_EraseRootFromParent_Done,
     /* 194043 */   // Label 3606: @194043
     /* 194043 */   GIM_Try, /*On fail goto*//*Label 3607*/ GIMT_Encode4(194088), // Rule ID 1558 //
     /* 194048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194077 */     // (intrinsic_wo_chain:{ *:[v4i32] } 749:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv4i32),
     /* 194080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194086 */     GIR_RootConstrainSelectedInstOperands,
     /* 194087 */     // GIR_Coverage, 1558,
     /* 194087 */     GIR_EraseRootFromParent_Done,
     /* 194088 */   // Label 3607: @194088
     /* 194088 */   GIM_Try, /*On fail goto*//*Label 3608*/ GIMT_Encode4(194133), // Rule ID 1559 //
     /* 194093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 194101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194110 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194114 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194118 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194122 */     // (intrinsic_wo_chain:{ *:[v2i64] } 749:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv2i64),
     /* 194125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194131 */     GIR_RootConstrainSelectedInstOperands,
     /* 194132 */     // GIR_Coverage, 1559,
     /* 194132 */     GIR_EraseRootFromParent_Done,
     /* 194133 */   // Label 3608: @194133
     /* 194133 */   GIM_Try, /*On fail goto*//*Label 3609*/ GIMT_Encode4(194178), // Rule ID 1573 //
     /* 194138 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194141 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194146 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194149 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194152 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194167 */     // (intrinsic_wo_chain:{ *:[v8i8] } 755:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (URSHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i8),
     /* 194170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194176 */     GIR_RootConstrainSelectedInstOperands,
     /* 194177 */     // GIR_Coverage, 1573,
     /* 194177 */     GIR_EraseRootFromParent_Done,
     /* 194178 */   // Label 3609: @194178
     /* 194178 */   GIM_Try, /*On fail goto*//*Label 3610*/ GIMT_Encode4(194223), // Rule ID 1574 //
     /* 194183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194204 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194212 */     // (intrinsic_wo_chain:{ *:[v16i8] } 755:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (URSHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv16i8),
     /* 194215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194221 */     GIR_RootConstrainSelectedInstOperands,
     /* 194222 */     // GIR_Coverage, 1574,
     /* 194222 */     GIR_EraseRootFromParent_Done,
     /* 194223 */   // Label 3610: @194223
     /* 194223 */   GIM_Try, /*On fail goto*//*Label 3611*/ GIMT_Encode4(194268), // Rule ID 1575 //
     /* 194228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194257 */     // (intrinsic_wo_chain:{ *:[v4i16] } 755:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (URSHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i16),
     /* 194260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194266 */     GIR_RootConstrainSelectedInstOperands,
     /* 194267 */     // GIR_Coverage, 1575,
     /* 194267 */     GIR_EraseRootFromParent_Done,
     /* 194268 */   // Label 3611: @194268
     /* 194268 */   GIM_Try, /*On fail goto*//*Label 3612*/ GIMT_Encode4(194313), // Rule ID 1576 //
     /* 194273 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194276 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194281 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194284 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194287 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194290 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194294 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194302 */     // (intrinsic_wo_chain:{ *:[v8i16] } 755:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (URSHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv8i16),
     /* 194305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194307 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194311 */     GIR_RootConstrainSelectedInstOperands,
     /* 194312 */     // GIR_Coverage, 1576,
     /* 194312 */     GIR_EraseRootFromParent_Done,
     /* 194313 */   // Label 3612: @194313
     /* 194313 */   GIM_Try, /*On fail goto*//*Label 3613*/ GIMT_Encode4(194358), // Rule ID 1577 //
     /* 194318 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194321 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194326 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194343 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194347 */     // (intrinsic_wo_chain:{ *:[v2i32] } 755:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (URSHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i32),
     /* 194350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194356 */     GIR_RootConstrainSelectedInstOperands,
     /* 194357 */     // GIR_Coverage, 1577,
     /* 194357 */     GIR_EraseRootFromParent_Done,
     /* 194358 */   // Label 3613: @194358
     /* 194358 */   GIM_Try, /*On fail goto*//*Label 3614*/ GIMT_Encode4(194403), // Rule ID 1578 //
     /* 194363 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194366 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194371 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194374 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194377 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194380 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194388 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194392 */     // (intrinsic_wo_chain:{ *:[v4i32] } 755:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (URSHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv4i32),
     /* 194395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194401 */     GIR_RootConstrainSelectedInstOperands,
     /* 194402 */     // GIR_Coverage, 1578,
     /* 194402 */     GIR_EraseRootFromParent_Done,
     /* 194403 */   // Label 3614: @194403
     /* 194403 */   GIM_Try, /*On fail goto*//*Label 3615*/ GIMT_Encode4(194448), // Rule ID 1579 //
     /* 194408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 194416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194437 */     // (intrinsic_wo_chain:{ *:[v2i64] } 755:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (URSHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv2i64),
     /* 194440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194446 */     GIR_RootConstrainSelectedInstOperands,
     /* 194447 */     // GIR_Coverage, 1579,
     /* 194447 */     GIR_EraseRootFromParent_Done,
     /* 194448 */   // Label 3615: @194448
     /* 194448 */   GIM_Try, /*On fail goto*//*Label 3616*/ GIMT_Encode4(194493), // Rule ID 1580 //
     /* 194453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 194464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 194467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 194470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194482 */     // (intrinsic_wo_chain:{ *:[v8i8] } 758:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (USHLv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 194482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i8),
     /* 194485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194491 */     GIR_RootConstrainSelectedInstOperands,
     /* 194492 */     // GIR_Coverage, 1580,
     /* 194492 */     GIR_EraseRootFromParent_Done,
     /* 194493 */   // Label 3616: @194493
     /* 194493 */   GIM_Try, /*On fail goto*//*Label 3617*/ GIMT_Encode4(194538), // Rule ID 1581 //
     /* 194498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 194509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 194512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 194515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194527 */     // (intrinsic_wo_chain:{ *:[v16i8] } 758:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USHLv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 194527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv16i8),
     /* 194530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194536 */     GIR_RootConstrainSelectedInstOperands,
     /* 194537 */     // GIR_Coverage, 1581,
     /* 194537 */     GIR_EraseRootFromParent_Done,
     /* 194538 */   // Label 3617: @194538
     /* 194538 */   GIM_Try, /*On fail goto*//*Label 3618*/ GIMT_Encode4(194583), // Rule ID 1582 //
     /* 194543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 194554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 194557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 194560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194572 */     // (intrinsic_wo_chain:{ *:[v4i16] } 758:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (USHLv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 194572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i16),
     /* 194575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194581 */     GIR_RootConstrainSelectedInstOperands,
     /* 194582 */     // GIR_Coverage, 1582,
     /* 194582 */     GIR_EraseRootFromParent_Done,
     /* 194583 */   // Label 3618: @194583
     /* 194583 */   GIM_Try, /*On fail goto*//*Label 3619*/ GIMT_Encode4(194628), // Rule ID 1583 //
     /* 194588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 194599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 194602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 194605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194609 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194617 */     // (intrinsic_wo_chain:{ *:[v8i16] } 758:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (USHLv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 194617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv8i16),
     /* 194620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194626 */     GIR_RootConstrainSelectedInstOperands,
     /* 194627 */     // GIR_Coverage, 1583,
     /* 194627 */     GIR_EraseRootFromParent_Done,
     /* 194628 */   // Label 3619: @194628
     /* 194628 */   GIM_Try, /*On fail goto*//*Label 3620*/ GIMT_Encode4(194673), // Rule ID 1584 //
     /* 194633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 194644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 194647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 194650 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194662 */     // (intrinsic_wo_chain:{ *:[v2i32] } 758:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (USHLv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 194662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i32),
     /* 194665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194671 */     GIR_RootConstrainSelectedInstOperands,
     /* 194672 */     // GIR_Coverage, 1584,
     /* 194672 */     GIR_EraseRootFromParent_Done,
     /* 194673 */   // Label 3620: @194673
     /* 194673 */   GIM_Try, /*On fail goto*//*Label 3621*/ GIMT_Encode4(194718), // Rule ID 1585 //
     /* 194678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 194689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 194692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 194695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194707 */     // (intrinsic_wo_chain:{ *:[v4i32] } 758:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (USHLv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 194707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv4i32),
     /* 194710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194716 */     GIR_RootConstrainSelectedInstOperands,
     /* 194717 */     // GIR_Coverage, 1585,
     /* 194717 */     GIR_EraseRootFromParent_Done,
     /* 194718 */   // Label 3621: @194718
     /* 194718 */   GIM_Try, /*On fail goto*//*Label 3622*/ GIMT_Encode4(194763), // Rule ID 1586 //
     /* 194723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 194731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 194734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 194737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 194740 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194744 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 194752 */     // (intrinsic_wo_chain:{ *:[v2i64] } 758:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (USHLv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 194752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv2i64),
     /* 194755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194757 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194759 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194761 */     GIR_RootConstrainSelectedInstOperands,
     /* 194762 */     // GIR_Coverage, 1586,
     /* 194762 */     GIR_EraseRootFromParent_Done,
     /* 194763 */   // Label 3622: @194763
     /* 194763 */   GIM_Try, /*On fail goto*//*Label 3623*/ GIMT_Encode4(194808), // Rule ID 1614 //
     /* 194768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194789 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194793 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194797 */     // (intrinsic_wo_chain:{ *:[f64] } 792:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FABD64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 194800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194806 */     GIR_RootConstrainSelectedInstOperands,
     /* 194807 */     // GIR_Coverage, 1614,
     /* 194807 */     GIR_EraseRootFromParent_Done,
     /* 194808 */   // Label 3623: @194808
     /* 194808 */   GIM_Try, /*On fail goto*//*Label 3624*/ GIMT_Encode4(194853), // Rule ID 1615 //
     /* 194813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194834 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194842 */     // (intrinsic_wo_chain:{ *:[f32] } 792:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FABD32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 194845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194851 */     GIR_RootConstrainSelectedInstOperands,
     /* 194852 */     // GIR_Coverage, 1615,
     /* 194852 */     GIR_EraseRootFromParent_Done,
     /* 194853 */   // Label 3624: @194853
     /* 194853 */   GIM_Try, /*On fail goto*//*Label 3625*/ GIMT_Encode4(194898), // Rule ID 1616 //
     /* 194858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 194861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 194866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 194869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 194872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 194875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194879 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194883 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 194887 */     // (intrinsic_wo_chain:{ *:[f16] } 792:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FABD16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 194887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 194890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194896 */     GIR_RootConstrainSelectedInstOperands,
     /* 194897 */     // GIR_Coverage, 1616,
     /* 194897 */     GIR_EraseRootFromParent_Done,
     /* 194898 */   // Label 3625: @194898
     /* 194898 */   GIM_Try, /*On fail goto*//*Label 3626*/ GIMT_Encode4(194943), // Rule ID 1617 //
     /* 194903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 194914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 194917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 194920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194924 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 194932 */     // (intrinsic_wo_chain:{ *:[i64] } 584:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 194932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 194935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194941 */     GIR_RootConstrainSelectedInstOperands,
     /* 194942 */     // GIR_Coverage, 1617,
     /* 194942 */     GIR_EraseRootFromParent_Done,
     /* 194943 */   // Label 3626: @194943
     /* 194943 */   GIM_Try, /*On fail goto*//*Label 3627*/ GIMT_Encode4(194988), // Rule ID 1618 //
     /* 194948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194951 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 194956 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 194959 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 194962 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 194965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 194977 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 194977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE32),
     /* 194980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 194982 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 194984 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 194986 */     GIR_RootConstrainSelectedInstOperands,
     /* 194987 */     // GIR_Coverage, 1618,
     /* 194987 */     GIR_EraseRootFromParent_Done,
     /* 194988 */   // Label 3627: @194988
     /* 194988 */   GIM_Try, /*On fail goto*//*Label 3628*/ GIMT_Encode4(195033), // Rule ID 1619 //
     /* 194993 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 194996 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195001 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195004 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195007 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195022 */     // (intrinsic_wo_chain:{ *:[i64] } 585:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FACGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 195025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195027 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195031 */     GIR_RootConstrainSelectedInstOperands,
     /* 195032 */     // GIR_Coverage, 1619,
     /* 195032 */     GIR_EraseRootFromParent_Done,
     /* 195033 */   // Label 3628: @195033
     /* 195033 */   GIM_Try, /*On fail goto*//*Label 3629*/ GIMT_Encode4(195078), // Rule ID 1620 //
     /* 195038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 195046 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195049 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195052 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195063 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195067 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FACGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT32),
     /* 195070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195076 */     GIR_RootConstrainSelectedInstOperands,
     /* 195077 */     // GIR_Coverage, 1620,
     /* 195077 */     GIR_EraseRootFromParent_Done,
     /* 195078 */   // Label 3629: @195078
     /* 195078 */   GIM_Try, /*On fail goto*//*Label 3630*/ GIMT_Encode4(195123), // Rule ID 1627 //
     /* 195083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195112 */     // (intrinsic_wo_chain:{ *:[f64] } 617:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULX64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195112 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 195115 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195117 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195121 */     GIR_RootConstrainSelectedInstOperands,
     /* 195122 */     // GIR_Coverage, 1627,
     /* 195122 */     GIR_EraseRootFromParent_Done,
     /* 195123 */   // Label 3630: @195123
     /* 195123 */   GIM_Try, /*On fail goto*//*Label 3631*/ GIMT_Encode4(195168), // Rule ID 1628 //
     /* 195128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195149 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195153 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195157 */     // (intrinsic_wo_chain:{ *:[f32] } 617:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULX32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX32),
     /* 195160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195166 */     GIR_RootConstrainSelectedInstOperands,
     /* 195167 */     // GIR_Coverage, 1628,
     /* 195167 */     GIR_EraseRootFromParent_Done,
     /* 195168 */   // Label 3631: @195168
     /* 195168 */   GIM_Try, /*On fail goto*//*Label 3632*/ GIMT_Encode4(195213), // Rule ID 1629 //
     /* 195173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 195181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195190 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195194 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195198 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195202 */     // (intrinsic_wo_chain:{ *:[f16] } 617:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULX16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX16),
     /* 195205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195211 */     GIR_RootConstrainSelectedInstOperands,
     /* 195212 */     // GIR_Coverage, 1629,
     /* 195212 */     GIR_EraseRootFromParent_Done,
     /* 195213 */   // Label 3632: @195213
     /* 195213 */   GIM_Try, /*On fail goto*//*Label 3633*/ GIMT_Encode4(195258), // Rule ID 1630 //
     /* 195218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195226 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195229 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195232 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195247 */     // (intrinsic_wo_chain:{ *:[f64] } 640:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRECPS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 195250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195254 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195256 */     GIR_RootConstrainSelectedInstOperands,
     /* 195257 */     // GIR_Coverage, 1630,
     /* 195257 */     GIR_EraseRootFromParent_Done,
     /* 195258 */   // Label 3633: @195258
     /* 195258 */   GIM_Try, /*On fail goto*//*Label 3634*/ GIMT_Encode4(195303), // Rule ID 1631 //
     /* 195263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195284 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195292 */     // (intrinsic_wo_chain:{ *:[f32] } 640:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRECPS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS32),
     /* 195295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195301 */     GIR_RootConstrainSelectedInstOperands,
     /* 195302 */     // GIR_Coverage, 1631,
     /* 195302 */     GIR_EraseRootFromParent_Done,
     /* 195303 */   // Label 3634: @195303
     /* 195303 */   GIM_Try, /*On fail goto*//*Label 3635*/ GIMT_Encode4(195348), // Rule ID 1632 //
     /* 195308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 195316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195337 */     // (intrinsic_wo_chain:{ *:[f16] } 640:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRECPS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS16),
     /* 195340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195346 */     GIR_RootConstrainSelectedInstOperands,
     /* 195347 */     // GIR_Coverage, 1632,
     /* 195347 */     GIR_EraseRootFromParent_Done,
     /* 195348 */   // Label 3635: @195348
     /* 195348 */   GIM_Try, /*On fail goto*//*Label 3636*/ GIMT_Encode4(195393), // Rule ID 1633 //
     /* 195353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195374 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195378 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195382 */     // (intrinsic_wo_chain:{ *:[f64] } 647:{ *:[iPTR] }, FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FRSQRTS64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 195382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 195385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195391 */     GIR_RootConstrainSelectedInstOperands,
     /* 195392 */     // GIR_Coverage, 1633,
     /* 195392 */     GIR_EraseRootFromParent_Done,
     /* 195393 */   // Label 3636: @195393
     /* 195393 */   GIM_Try, /*On fail goto*//*Label 3637*/ GIMT_Encode4(195438), // Rule ID 1634 //
     /* 195398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 195401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195423 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195427 */     // (intrinsic_wo_chain:{ *:[f32] } 647:{ *:[iPTR] }, FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FRSQRTS32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 195427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS32),
     /* 195430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195436 */     GIR_RootConstrainSelectedInstOperands,
     /* 195437 */     // GIR_Coverage, 1634,
     /* 195437 */     GIR_EraseRootFromParent_Done,
     /* 195438 */   // Label 3637: @195438
     /* 195438 */   GIM_Try, /*On fail goto*//*Label 3638*/ GIMT_Encode4(195483), // Rule ID 1635 //
     /* 195443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 195446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 195451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s16,
     /* 195454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 195457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 195460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 195472 */     // (intrinsic_wo_chain:{ *:[f16] } 647:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FRSQRTS16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 195472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS16),
     /* 195475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195481 */     GIR_RootConstrainSelectedInstOperands,
     /* 195482 */     // GIR_Coverage, 1635,
     /* 195482 */     GIR_EraseRootFromParent_Done,
     /* 195483 */   // Label 3638: @195483
     /* 195483 */   GIM_Try, /*On fail goto*//*Label 3639*/ GIMT_Encode4(195528), // Rule ID 1637 //
     /* 195488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulh),
     /* 195496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195509 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195513 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195517 */     // (intrinsic_wo_chain:{ *:[i32] } 687:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULHv1i32),
     /* 195520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195526 */     GIR_RootConstrainSelectedInstOperands,
     /* 195527 */     // GIR_Coverage, 1637,
     /* 195527 */     GIR_EraseRootFromParent_Done,
     /* 195528 */   // Label 3639: @195528
     /* 195528 */   GIM_Try, /*On fail goto*//*Label 3640*/ GIMT_Encode4(195573), // Rule ID 1638 //
     /* 195533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmulh),
     /* 195541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 195544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195562 */     // (intrinsic_wo_chain:{ *:[i32] } 695:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMULHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULHv1i32),
     /* 195565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195571 */     GIR_RootConstrainSelectedInstOperands,
     /* 195572 */     // GIR_Coverage, 1638,
     /* 195572 */     GIR_EraseRootFromParent_Done,
     /* 195573 */   // Label 3640: @195573
     /* 195573 */   GIM_Try, /*On fail goto*//*Label 3641*/ GIMT_Encode4(195618), // Rule ID 1639 //
     /* 195578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 195586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195595 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195599 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195603 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195607 */     // (intrinsic_wo_chain:{ *:[v1i64] } 698:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 195610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195614 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195616 */     GIR_RootConstrainSelectedInstOperands,
     /* 195617 */     // GIR_Coverage, 1639,
     /* 195617 */     GIR_EraseRootFromParent_Done,
     /* 195618 */   // Label 3641: @195618
     /* 195618 */   GIM_Try, /*On fail goto*//*Label 3642*/ GIMT_Encode4(195663), // Rule ID 1640 //
     /* 195623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 195631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195652 */     // (intrinsic_wo_chain:{ *:[v1i64] } 701:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 195655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195661 */     GIR_RootConstrainSelectedInstOperands,
     /* 195662 */     // GIR_Coverage, 1640,
     /* 195662 */     GIR_EraseRootFromParent_Done,
     /* 195663 */   // Label 3642: @195663
     /* 195663 */   GIM_Try, /*On fail goto*//*Label 3643*/ GIMT_Encode4(195708), // Rule ID 1642 //
     /* 195668 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195671 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 195676 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195679 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195682 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195689 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195693 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195697 */     // (intrinsic_wo_chain:{ *:[v1i64] } 709:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 195700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195706 */     GIR_RootConstrainSelectedInstOperands,
     /* 195707 */     // GIR_Coverage, 1642,
     /* 195707 */     GIR_EraseRootFromParent_Done,
     /* 195708 */   // Label 3643: @195708
     /* 195708 */   GIM_Try, /*On fail goto*//*Label 3644*/ GIMT_Encode4(195753), // Rule ID 1643 //
     /* 195713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 195721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195730 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195734 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195738 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195742 */     // (intrinsic_wo_chain:{ *:[v1i64] } 710:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 195745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195751 */     GIR_RootConstrainSelectedInstOperands,
     /* 195752 */     // GIR_Coverage, 1643,
     /* 195752 */     GIR_EraseRootFromParent_Done,
     /* 195753 */   // Label 3644: @195753
     /* 195753 */   GIM_Try, /*On fail goto*//*Label 3645*/ GIMT_Encode4(195798), // Rule ID 1646 //
     /* 195758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 195766 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195769 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195772 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195783 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195787 */     // (intrinsic_wo_chain:{ *:[v1i64] } 747:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 195790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195796 */     GIR_RootConstrainSelectedInstOperands,
     /* 195797 */     // GIR_Coverage, 1646,
     /* 195797 */     GIR_EraseRootFromParent_Done,
     /* 195798 */   // Label 3645: @195798
     /* 195798 */   GIM_Try, /*On fail goto*//*Label 3646*/ GIMT_Encode4(195843), // Rule ID 1647 //
     /* 195803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195806 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 195811 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195814 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195817 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195820 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195832 */     // (intrinsic_wo_chain:{ *:[v1i64] } 749:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 195835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195841 */     GIR_RootConstrainSelectedInstOperands,
     /* 195842 */     // GIR_Coverage, 1647,
     /* 195842 */     GIR_EraseRootFromParent_Done,
     /* 195843 */   // Label 3646: @195843
     /* 195843 */   GIM_Try, /*On fail goto*//*Label 3647*/ GIMT_Encode4(195888), // Rule ID 1649 //
     /* 195848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 195856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195877 */     // (intrinsic_wo_chain:{ *:[v1i64] } 755:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (URSHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 195880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195882 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195884 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195886 */     GIR_RootConstrainSelectedInstOperands,
     /* 195887 */     // GIR_Coverage, 1649,
     /* 195887 */     GIR_EraseRootFromParent_Done,
     /* 195888 */   // Label 3647: @195888
     /* 195888 */   GIM_Try, /*On fail goto*//*Label 3648*/ GIMT_Encode4(195933), // Rule ID 1650 //
     /* 195893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 195901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 195910 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195914 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195918 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195922 */     // (intrinsic_wo_chain:{ *:[v1i64] } 758:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (USHLv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 195922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 195925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195931 */     GIR_RootConstrainSelectedInstOperands,
     /* 195932 */     // GIR_Coverage, 1650,
     /* 195932 */     GIR_EraseRootFromParent_Done,
     /* 195933 */   // Label 3648: @195933
     /* 195933 */   GIM_Try, /*On fail goto*//*Label 3649*/ GIMT_Encode4(195978), // Rule ID 1651 //
     /* 195938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmulls_scalar),
     /* 195946 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195949 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 195952 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 195955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 195959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 195967 */     // (intrinsic_wo_chain:{ *:[i64] } 691:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQDMULLi32:{ *:[i64] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 195967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLi32),
     /* 195970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 195972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 195974 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 195976 */     GIR_RootConstrainSelectedInstOperands,
     /* 195977 */     // GIR_Coverage, 1651,
     /* 195977 */     GIR_EraseRootFromParent_Done,
     /* 195978 */   // Label 3649: @195978
     /* 195978 */   GIM_Try, /*On fail goto*//*Label 3650*/ GIMT_Encode4(196023), // Rule ID 1665 //
     /* 195983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 195986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 195991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 195994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 195997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196004 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196012 */     // (intrinsic_wo_chain:{ *:[i64] } 722:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 196015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196021 */     GIR_RootConstrainSelectedInstOperands,
     /* 196022 */     // GIR_Coverage, 1665,
     /* 196022 */     GIR_EraseRootFromParent_Done,
     /* 196023 */   // Label 3650: @196023
     /* 196023 */   GIM_Try, /*On fail goto*//*Label 3651*/ GIMT_Encode4(196068), // Rule ID 1666 //
     /* 196028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 196036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196049 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196053 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196057 */     // (intrinsic_wo_chain:{ *:[i32] } 722:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (SUQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i32),
     /* 196060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196066 */     GIR_RootConstrainSelectedInstOperands,
     /* 196067 */     // GIR_Coverage, 1666,
     /* 196067 */     GIR_EraseRootFromParent_Done,
     /* 196068 */   // Label 3651: @196068
     /* 196068 */   GIM_Try, /*On fail goto*//*Label 3652*/ GIMT_Encode4(196113), // Rule ID 1671 //
     /* 196073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 196084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 196087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 196090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196094 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196098 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196102 */     // (intrinsic_wo_chain:{ *:[i64] } 761:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)  =>  (USQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rd, FPR64:{ *:[i64] }:$Rn)
     /* 196102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 196105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196107 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196111 */     GIR_RootConstrainSelectedInstOperands,
     /* 196112 */     // GIR_Coverage, 1671,
     /* 196112 */     GIR_EraseRootFromParent_Done,
     /* 196113 */   // Label 3652: @196113
     /* 196113 */   GIM_Try, /*On fail goto*//*Label 3653*/ GIMT_Encode4(196158), // Rule ID 1672 //
     /* 196118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 196126 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 196129 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 196132 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 196135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196139 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196143 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 196147 */     // (intrinsic_wo_chain:{ *:[i32] } 761:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)  =>  (USQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn)
     /* 196147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i32),
     /* 196150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196156 */     GIR_RootConstrainSelectedInstOperands,
     /* 196157 */     // GIR_Coverage, 1672,
     /* 196157 */     GIR_EraseRootFromParent_Done,
     /* 196158 */   // Label 3653: @196158
     /* 196158 */   GIM_Try, /*On fail goto*//*Label 3654*/ GIMT_Encode4(196203), // Rule ID 1673 //
     /* 196163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196192 */     // (intrinsic_wo_chain:{ *:[v8i8] } 576:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 196195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196201 */     GIR_RootConstrainSelectedInstOperands,
     /* 196202 */     // GIR_Coverage, 1673,
     /* 196202 */     GIR_EraseRootFromParent_Done,
     /* 196203 */   // Label 3654: @196203
     /* 196203 */   GIM_Try, /*On fail goto*//*Label 3655*/ GIMT_Encode4(196248), // Rule ID 1674 //
     /* 196208 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196211 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196216 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196219 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196233 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196237 */     // (intrinsic_wo_chain:{ *:[v4i16] } 576:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 196240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196246 */     GIR_RootConstrainSelectedInstOperands,
     /* 196247 */     // GIR_Coverage, 1674,
     /* 196247 */     GIR_EraseRootFromParent_Done,
     /* 196248 */   // Label 3655: @196248
     /* 196248 */   GIM_Try, /*On fail goto*//*Label 3656*/ GIMT_Encode4(196293), // Rule ID 1675 //
     /* 196253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_addhn),
     /* 196261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196282 */     // (intrinsic_wo_chain:{ *:[v2i32] } 576:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 196285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196291 */     GIR_RootConstrainSelectedInstOperands,
     /* 196292 */     // GIR_Coverage, 1675,
     /* 196292 */     GIR_EraseRootFromParent_Done,
     /* 196293 */   // Label 3656: @196293
     /* 196293 */   GIM_Try, /*On fail goto*//*Label 3657*/ GIMT_Encode4(196338), // Rule ID 1676 //
     /* 196298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196309 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196312 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196327 */     // (intrinsic_wo_chain:{ *:[v8i8] } 721:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 196330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196336 */     GIR_RootConstrainSelectedInstOperands,
     /* 196337 */     // GIR_Coverage, 1676,
     /* 196337 */     GIR_EraseRootFromParent_Done,
     /* 196338 */   // Label 3657: @196338
     /* 196338 */   GIM_Try, /*On fail goto*//*Label 3658*/ GIMT_Encode4(196383), // Rule ID 1677 //
     /* 196343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196360 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196364 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196372 */     // (intrinsic_wo_chain:{ *:[v4i16] } 721:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 196375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196381 */     GIR_RootConstrainSelectedInstOperands,
     /* 196382 */     // GIR_Coverage, 1677,
     /* 196382 */     GIR_EraseRootFromParent_Done,
     /* 196383 */   // Label 3658: @196383
     /* 196383 */   GIM_Try, /*On fail goto*//*Label 3659*/ GIMT_Encode4(196428), // Rule ID 1678 //
     /* 196388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196391 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_subhn),
     /* 196396 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196399 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196417 */     // (intrinsic_wo_chain:{ *:[v2i32] } 721:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 196420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196426 */     GIR_RootConstrainSelectedInstOperands,
     /* 196427 */     // GIR_Coverage, 1678,
     /* 196427 */     GIR_EraseRootFromParent_Done,
     /* 196428 */   // Label 3659: @196428
     /* 196428 */   GIM_Try, /*On fail goto*//*Label 3660*/ GIMT_Encode4(196473), // Rule ID 1679 //
     /* 196433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196450 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196454 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196458 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196462 */     // (intrinsic_wo_chain:{ *:[v8i8] } 663:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv8i16_v8i8),
     /* 196465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196471 */     GIR_RootConstrainSelectedInstOperands,
     /* 196472 */     // GIR_Coverage, 1679,
     /* 196472 */     GIR_EraseRootFromParent_Done,
     /* 196473 */   // Label 3660: @196473
     /* 196473 */   GIM_Try, /*On fail goto*//*Label 3661*/ GIMT_Encode4(196518), // Rule ID 1680 //
     /* 196478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196507 */     // (intrinsic_wo_chain:{ *:[v4i16] } 663:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv4i32_v4i16),
     /* 196510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196516 */     GIR_RootConstrainSelectedInstOperands,
     /* 196517 */     // GIR_Coverage, 1680,
     /* 196517 */     GIR_EraseRootFromParent_Done,
     /* 196518 */   // Label 3661: @196518
     /* 196518 */   GIM_Try, /*On fail goto*//*Label 3662*/ GIMT_Encode4(196563), // Rule ID 1681 //
     /* 196523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_raddhn),
     /* 196531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196540 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196544 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196552 */     // (intrinsic_wo_chain:{ *:[v2i32] } 663:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196552 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNv2i64_v2i32),
     /* 196555 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196557 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196559 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196561 */     GIR_RootConstrainSelectedInstOperands,
     /* 196562 */     // GIR_Coverage, 1681,
     /* 196562 */     GIR_EraseRootFromParent_Done,
     /* 196563 */   // Label 3662: @196563
     /* 196563 */   GIM_Try, /*On fail goto*//*Label 3663*/ GIMT_Encode4(196608), // Rule ID 1682 //
     /* 196568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196571 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196576 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 196579 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 196582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 196585 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196597 */     // (intrinsic_wo_chain:{ *:[v8i8] } 665:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (RSUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 196597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv8i16_v8i8),
     /* 196600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196606 */     GIR_RootConstrainSelectedInstOperands,
     /* 196607 */     // GIR_Coverage, 1682,
     /* 196607 */     GIR_EraseRootFromParent_Done,
     /* 196608 */   // Label 3663: @196608
     /* 196608 */   GIM_Try, /*On fail goto*//*Label 3664*/ GIMT_Encode4(196653), // Rule ID 1683 //
     /* 196613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196642 */     // (intrinsic_wo_chain:{ *:[v4i16] } 665:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (RSUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 196642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv4i32_v4i16),
     /* 196645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196651 */     GIR_RootConstrainSelectedInstOperands,
     /* 196652 */     // GIR_Coverage, 1683,
     /* 196652 */     GIR_EraseRootFromParent_Done,
     /* 196653 */   // Label 3664: @196653
     /* 196653 */   GIM_Try, /*On fail goto*//*Label 3665*/ GIMT_Encode4(196698), // Rule ID 1684 //
     /* 196658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_rsubhn),
     /* 196666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 196669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 196672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 196675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196687 */     // (intrinsic_wo_chain:{ *:[v2i32] } 665:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (RSUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 196687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNv2i64_v2i32),
     /* 196690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196696 */     GIR_RootConstrainSelectedInstOperands,
     /* 196697 */     // GIR_Coverage, 1684,
     /* 196697 */     GIR_EraseRootFromParent_Done,
     /* 196698 */   // Label 3665: @196698
     /* 196698 */   GIM_Try, /*On fail goto*//*Label 3666*/ GIMT_Encode4(196743), // Rule ID 1750 //
     /* 196703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196728 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196732 */     // (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQDMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 196732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv4i16_v4i32),
     /* 196735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196739 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196741 */     GIR_RootConstrainSelectedInstOperands,
     /* 196742 */     // GIR_Coverage, 1750,
     /* 196742 */     GIR_EraseRootFromParent_Done,
     /* 196743 */   // Label 3666: @196743
     /* 196743 */   GIM_Try, /*On fail goto*//*Label 3667*/ GIMT_Encode4(196788), // Rule ID 1752 //
     /* 196748 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 196751 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 196756 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 196759 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 196762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 196765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196769 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196773 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196777 */     // (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQDMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 196777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLv2i32_v2i64),
     /* 196780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 196782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 196784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 196786 */     GIR_RootConstrainSelectedInstOperands,
     /* 196787 */     // GIR_Coverage, 1752,
     /* 196787 */     GIR_EraseRootFromParent_Done,
     /* 196788 */   // Label 3667: @196788
     /* 196788 */   GIM_Try, /*On fail goto*//*Label 3668*/ GIMT_Encode4(196833), // Rule ID 2303 //
     /* 196793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aese),
     /* 196801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196822 */     // (intrinsic_wo_chain:{ *:[v16i8] } 519:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESErr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESErr),
     /* 196825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196831 */     GIR_RootConstrainSelectedInstOperands,
     /* 196832 */     // GIR_Coverage, 2303,
     /* 196832 */     GIR_EraseRootFromParent_Done,
     /* 196833 */   // Label 3668: @196833
     /* 196833 */   GIM_Try, /*On fail goto*//*Label 3669*/ GIMT_Encode4(196878), // Rule ID 2304 //
     /* 196838 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasAES),
     /* 196841 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_aesd),
     /* 196846 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 196849 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 196852 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 196855 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196863 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196867 */     // (intrinsic_wo_chain:{ *:[v16i8] } 518:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)  =>  (AESDrr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn)
     /* 196867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESDrr),
     /* 196870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196876 */     GIR_RootConstrainSelectedInstOperands,
     /* 196877 */     // GIR_Coverage, 2304,
     /* 196877 */     GIR_EraseRootFromParent_Done,
     /* 196878 */   // Label 3669: @196878
     /* 196878 */   GIM_Try, /*On fail goto*//*Label 3670*/ GIMT_Encode4(196923), // Rule ID 2315 //
     /* 196883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su1),
     /* 196891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196900 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196904 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196908 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196912 */     // (intrinsic_wo_chain:{ *:[v4i32] } 532:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA1SU1rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU1rr),
     /* 196915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196917 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196919 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196921 */     GIR_RootConstrainSelectedInstOperands,
     /* 196922 */     // GIR_Coverage, 2315,
     /* 196922 */     GIR_EraseRootFromParent_Done,
     /* 196923 */   // Label 3670: @196923
     /* 196923 */   GIM_Try, /*On fail goto*//*Label 3671*/ GIMT_Encode4(196968), // Rule ID 2316 //
     /* 196928 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 196931 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su0),
     /* 196936 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 196939 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 196942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 196945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 196957 */     // (intrinsic_wo_chain:{ *:[v4i32] } 535:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)  =>  (SHA256SU0rr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn)
     /* 196957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU0rr),
     /* 196960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 196962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 196964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 196966 */     GIR_RootConstrainSelectedInstOperands,
     /* 196967 */     // GIR_Coverage, 2316,
     /* 196967 */     GIR_EraseRootFromParent_Done,
     /* 196968 */   // Label 3671: @196968
     /* 196968 */   GIM_Try, /*On fail goto*//*Label 3672*/ GIMT_Encode4(197013), // Rule ID 2339 //
     /* 196973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 196976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 196981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 196984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 196987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 196990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 196998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197002 */     // (intrinsic_wo_chain:{ *:[v4f16] } 638:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (FSCALEv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 197002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f16),
     /* 197005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197011 */     GIR_RootConstrainSelectedInstOperands,
     /* 197012 */     // GIR_Coverage, 2339,
     /* 197012 */     GIR_EraseRootFromParent_Done,
     /* 197013 */   // Label 3672: @197013
     /* 197013 */   GIM_Try, /*On fail goto*//*Label 3673*/ GIMT_Encode4(197058), // Rule ID 2340 //
     /* 197018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197039 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197043 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197047 */     // (intrinsic_wo_chain:{ *:[v8f16] } 638:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (FSCALEv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 197047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv8f16),
     /* 197050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197056 */     GIR_RootConstrainSelectedInstOperands,
     /* 197057 */     // GIR_Coverage, 2340,
     /* 197057 */     GIR_EraseRootFromParent_Done,
     /* 197058 */   // Label 3673: @197058
     /* 197058 */   GIM_Try, /*On fail goto*//*Label 3674*/ GIMT_Encode4(197103), // Rule ID 2341 //
     /* 197063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197092 */     // (intrinsic_wo_chain:{ *:[v2f32] } 638:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (FSCALEv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 197092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f32),
     /* 197095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197101 */     GIR_RootConstrainSelectedInstOperands,
     /* 197102 */     // GIR_Coverage, 2341,
     /* 197102 */     GIR_EraseRootFromParent_Done,
     /* 197103 */   // Label 3674: @197103
     /* 197103 */   GIM_Try, /*On fail goto*//*Label 3675*/ GIMT_Encode4(197148), // Rule ID 2342 //
     /* 197108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197129 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197133 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197137 */     // (intrinsic_wo_chain:{ *:[v4f32] } 638:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (FSCALEv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 197137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv4f32),
     /* 197140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197142 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197146 */     GIR_RootConstrainSelectedInstOperands,
     /* 197147 */     // GIR_Coverage, 2342,
     /* 197147 */     GIR_EraseRootFromParent_Done,
     /* 197148 */   // Label 3675: @197148
     /* 197148 */   GIM_Try, /*On fail goto*//*Label 3676*/ GIMT_Encode4(197193), // Rule ID 2343 //
     /* 197153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 197156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fscale),
     /* 197161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197170 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197174 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197178 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197182 */     // (intrinsic_wo_chain:{ *:[v2f64] } 638:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (FSCALEv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 197182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALEv2f64),
     /* 197185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197191 */     GIR_RootConstrainSelectedInstOperands,
     /* 197192 */     // GIR_Coverage, 2343,
     /* 197192 */     GIR_EraseRootFromParent_Done,
     /* 197193 */   // Label 3676: @197193
     /* 197193 */   GIM_Try, /*On fail goto*//*Label 3677*/ GIMT_Encode4(197238), // Rule ID 2344 //
     /* 197198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197223 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197227 */     // (intrinsic_wo_chain:{ *:[v4f16] } 588:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 197230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197236 */     GIR_RootConstrainSelectedInstOperands,
     /* 197237 */     // GIR_Coverage, 2344,
     /* 197237 */     GIR_EraseRootFromParent_Done,
     /* 197238 */   // Label 3677: @197238
     /* 197238 */   GIM_Try, /*On fail goto*//*Label 3678*/ GIMT_Encode4(197283), // Rule ID 2347 //
     /* 197243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197272 */     // (intrinsic_wo_chain:{ *:[v8f16] } 588:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 197275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197281 */     GIR_RootConstrainSelectedInstOperands,
     /* 197282 */     // GIR_Coverage, 2347,
     /* 197282 */     GIR_EraseRootFromParent_Done,
     /* 197283 */   // Label 3678: @197283
     /* 197283 */   GIM_Try, /*On fail goto*//*Label 3679*/ GIMT_Encode4(197328), // Rule ID 2350 //
     /* 197288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197309 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197313 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197317 */     // (intrinsic_wo_chain:{ *:[v2f32] } 588:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 197320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197326 */     GIR_RootConstrainSelectedInstOperands,
     /* 197327 */     // GIR_Coverage, 2350,
     /* 197327 */     GIR_EraseRootFromParent_Done,
     /* 197328 */   // Label 3679: @197328
     /* 197328 */   GIM_Try, /*On fail goto*//*Label 3680*/ GIMT_Encode4(197373), // Rule ID 2353 //
     /* 197333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197354 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197358 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197362 */     // (intrinsic_wo_chain:{ *:[v4f32] } 588:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 197365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197371 */     GIR_RootConstrainSelectedInstOperands,
     /* 197372 */     // GIR_Coverage, 2353,
     /* 197372 */     GIR_EraseRootFromParent_Done,
     /* 197373 */   // Label 3680: @197373
     /* 197373 */   GIM_Try, /*On fail goto*//*Label 3681*/ GIMT_Encode4(197418), // Rule ID 2356 //
     /* 197378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197381 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famax),
     /* 197386 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197389 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197392 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197399 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197403 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197407 */     // (intrinsic_wo_chain:{ *:[v2f64] } 588:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 197410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197416 */     GIR_RootConstrainSelectedInstOperands,
     /* 197417 */     // GIR_Coverage, 2356,
     /* 197417 */     GIR_EraseRootFromParent_Done,
     /* 197418 */   // Label 3681: @197418
     /* 197418 */   GIM_Try, /*On fail goto*//*Label 3682*/ GIMT_Encode4(197463), // Rule ID 2359 //
     /* 197423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 197434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 197437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 197440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197452 */     // (intrinsic_wo_chain:{ *:[v4f16] } 589:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 197452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 197455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197461 */     GIR_RootConstrainSelectedInstOperands,
     /* 197462 */     // GIR_Coverage, 2359,
     /* 197462 */     GIR_EraseRootFromParent_Done,
     /* 197463 */   // Label 3682: @197463
     /* 197463 */   GIM_Try, /*On fail goto*//*Label 3683*/ GIMT_Encode4(197508), // Rule ID 2362 //
     /* 197468 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197471 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197476 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 197479 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 197482 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 197485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197493 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197497 */     // (intrinsic_wo_chain:{ *:[v8f16] } 589:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 197497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 197500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197506 */     GIR_RootConstrainSelectedInstOperands,
     /* 197507 */     // GIR_Coverage, 2362,
     /* 197507 */     GIR_EraseRootFromParent_Done,
     /* 197508 */   // Label 3683: @197508
     /* 197508 */   GIM_Try, /*On fail goto*//*Label 3684*/ GIMT_Encode4(197553), // Rule ID 2365 //
     /* 197513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 197524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 197527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 197530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197534 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197538 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197542 */     // (intrinsic_wo_chain:{ *:[v2f32] } 589:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 197542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 197545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197547 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197549 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197551 */     GIR_RootConstrainSelectedInstOperands,
     /* 197552 */     // GIR_Coverage, 2365,
     /* 197552 */     GIR_EraseRootFromParent_Done,
     /* 197553 */   // Label 3684: @197553
     /* 197553 */   GIM_Try, /*On fail goto*//*Label 3685*/ GIMT_Encode4(197598), // Rule ID 2368 //
     /* 197558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 197569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 197572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 197575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197579 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197583 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197587 */     // (intrinsic_wo_chain:{ *:[v4f32] } 589:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 197587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 197590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197596 */     GIR_RootConstrainSelectedInstOperands,
     /* 197597 */     // GIR_Coverage, 2368,
     /* 197597 */     GIR_EraseRootFromParent_Done,
     /* 197598 */   // Label 3685: @197598
     /* 197598 */   GIM_Try, /*On fail goto*//*Label 3686*/ GIMT_Encode4(197643), // Rule ID 2371 //
     /* 197603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 197606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_famin),
     /* 197611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 197614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 197617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 197620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197624 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 197632 */     // (intrinsic_wo_chain:{ *:[v2f64] } 589:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 197632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 197635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197641 */     GIR_RootConstrainSelectedInstOperands,
     /* 197642 */     // GIR_Coverage, 2371,
     /* 197642 */     GIR_EraseRootFromParent_Done,
     /* 197643 */   // Label 3686: @197643
     /* 197643 */   GIM_Try, /*On fail goto*//*Label 3687*/ GIMT_Encode4(197688), // Rule ID 2423 //
     /* 197648 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197651 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aese),
     /* 197656 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197659 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197662 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197669 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197673 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197677 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1266:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESE_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESE_ZZZ_B),
     /* 197680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197682 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197686 */     GIR_RootConstrainSelectedInstOperands,
     /* 197687 */     // GIR_Coverage, 2423,
     /* 197687 */     GIR_EraseRootFromParent_Done,
     /* 197688 */   // Label 3687: @197688
     /* 197688 */   GIM_Try, /*On fail goto*//*Label 3688*/ GIMT_Encode4(197733), // Rule ID 2424 //
     /* 197693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 197696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_aesd),
     /* 197701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 197704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 197707 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 197710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197722 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1265:{ *:[iPTR] }, ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)  =>  (AESD_ZZZ_B:{ *:[nxv16i8] } ZPR8:{ *:[nxv16i8] }:$_Zdn, ZPR8:{ *:[nxv16i8] }:$Zm)
     /* 197722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AESD_ZZZ_B),
     /* 197725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197727 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197731 */     GIR_RootConstrainSelectedInstOperands,
     /* 197732 */     // GIR_Coverage, 2424,
     /* 197732 */     GIR_EraseRootFromParent_Done,
     /* 197733 */   // Label 3688: @197733
     /* 197733 */   GIM_Try, /*On fail goto*//*Label 3689*/ GIMT_Encode4(197778), // Rule ID 2425 //
     /* 197738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 197741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4e),
     /* 197746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 197749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 197752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 197755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197759 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 197767 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1730:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)  =>  (SM4E_ZZZ_S:{ *:[nxv4i32] } ZPR32:{ *:[nxv4i32] }:$_Zdn, ZPR32:{ *:[nxv4i32] }:$Zm)
     /* 197767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E_ZZZ_S),
     /* 197770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 197772 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Zdn
     /* 197774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 197776 */     GIR_RootConstrainSelectedInstOperands,
     /* 197777 */     // GIR_Coverage, 2425,
     /* 197777 */     GIR_EraseRootFromParent_Done,
     /* 197778 */   // Label 3689: @197778
     /* 197778 */   GIM_Try, /*On fail goto*//*Label 3690*/ GIMT_Encode4(197823), // Rule ID 2504 //
     /* 197783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197812 */     // (intrinsic_wo_chain:{ *:[i64] } 686:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 197812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 197815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197821 */     GIR_RootConstrainSelectedInstOperands,
     /* 197822 */     // GIR_Coverage, 2504,
     /* 197822 */     GIR_EraseRootFromParent_Done,
     /* 197823 */   // Label 3690: @197823
     /* 197823 */   GIM_Try, /*On fail goto*//*Label 3691*/ GIMT_Encode4(197868), // Rule ID 2505 //
     /* 197828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197831 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqadd),
     /* 197836 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 197839 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 197842 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 197845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 197857 */     // (intrinsic_wo_chain:{ *:[i32] } 686:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 197857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i32),
     /* 197860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197866 */     GIR_RootConstrainSelectedInstOperands,
     /* 197867 */     // GIR_Coverage, 2505,
     /* 197867 */     GIR_EraseRootFromParent_Done,
     /* 197868 */   // Label 3691: @197868
     /* 197868 */   GIM_Try, /*On fail goto*//*Label 3692*/ GIMT_Encode4(197913), // Rule ID 2506 //
     /* 197873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sisd_fabd),
     /* 197881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197890 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197894 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197898 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197902 */     // (intrinsic_wo_chain:{ *:[v1f64] } 792:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 197905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197911 */     GIR_RootConstrainSelectedInstOperands,
     /* 197912 */     // GIR_Coverage, 2506,
     /* 197912 */     GIR_EraseRootFromParent_Done,
     /* 197913 */   // Label 3692: @197913
     /* 197913 */   GIM_Try, /*On fail goto*//*Label 3693*/ GIMT_Encode4(197958), // Rule ID 2507 //
     /* 197918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 197926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197947 */     // (intrinsic_wo_chain:{ *:[v1i64] } 584:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 197947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE64),
     /* 197950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 197952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 197954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 197956 */     GIR_RootConstrainSelectedInstOperands,
     /* 197957 */     // GIR_Coverage, 2507,
     /* 197957 */     GIR_EraseRootFromParent_Done,
     /* 197958 */   // Label 3693: @197958
     /* 197958 */   GIM_Try, /*On fail goto*//*Label 3694*/ GIMT_Encode4(198003), // Rule ID 2512 //
     /* 197963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 197966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_suqadd),
     /* 197971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 197974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 197977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 197980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 197992 */     // (intrinsic_wo_chain:{ *:[v1i64] } 722:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (SUQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 197992 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADDv1i64),
     /* 197995 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 197997 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 197999 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 198001 */     GIR_RootConstrainSelectedInstOperands,
     /* 198002 */     // GIR_Coverage, 2512,
     /* 198002 */     GIR_EraseRootFromParent_Done,
     /* 198003 */   // Label 3694: @198003
     /* 198003 */   GIM_Try, /*On fail goto*//*Label 3695*/ GIMT_Encode4(198048), // Rule ID 2630 //
     /* 198008 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198011 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198016 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198029 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198037 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_B),
     /* 198040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198046 */     GIR_RootConstrainSelectedInstOperands,
     /* 198047 */     // GIR_Coverage, 2630,
     /* 198047 */     GIR_EraseRootFromParent_Done,
     /* 198048 */   // Label 3695: @198048
     /* 198048 */   GIM_Try, /*On fail goto*//*Label 3696*/ GIMT_Encode4(198093), // Rule ID 2631 //
     /* 198053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198082 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_H),
     /* 198085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198091 */     GIR_RootConstrainSelectedInstOperands,
     /* 198092 */     // GIR_Coverage, 2631,
     /* 198092 */     GIR_EraseRootFromParent_Done,
     /* 198093 */   // Label 3696: @198093
     /* 198093 */   GIM_Try, /*On fail goto*//*Label 3697*/ GIMT_Encode4(198138), // Rule ID 2632 //
     /* 198098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198106 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198109 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198112 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198127 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_S),
     /* 198130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198136 */     GIR_RootConstrainSelectedInstOperands,
     /* 198137 */     // GIR_Coverage, 2632,
     /* 198137 */     GIR_EraseRootFromParent_Done,
     /* 198138 */   // Label 3697: @198138
     /* 198138 */   GIM_Try, /*On fail goto*//*Label 3698*/ GIMT_Encode4(198183), // Rule ID 2633 //
     /* 198143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n32),
     /* 198151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 198154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 198157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198164 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 198168 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198172 */     // (intrinsic_wo_chain:{ *:[i32] } 2032:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 198172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_WP_D),
     /* 198175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198177 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198181 */     GIR_RootConstrainSelectedInstOperands,
     /* 198182 */     // GIR_Coverage, 2633,
     /* 198182 */     GIR_EraseRootFromParent_Done,
     /* 198183 */   // Label 3698: @198183
     /* 198183 */   GIM_Try, /*On fail goto*//*Label 3699*/ GIMT_Encode4(198228), // Rule ID 2634 //
     /* 198188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198202 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 198205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198213 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198217 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_B),
     /* 198220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198224 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198226 */     GIR_RootConstrainSelectedInstOperands,
     /* 198227 */     // GIR_Coverage, 2634,
     /* 198227 */     GIR_EraseRootFromParent_Done,
     /* 198228 */   // Label 3699: @198228
     /* 198228 */   GIM_Try, /*On fail goto*//*Label 3700*/ GIMT_Encode4(198273), // Rule ID 2635 //
     /* 198233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 198250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198262 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_H),
     /* 198265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198269 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198271 */     GIR_RootConstrainSelectedInstOperands,
     /* 198272 */     // GIR_Coverage, 2635,
     /* 198272 */     GIR_EraseRootFromParent_Done,
     /* 198273 */   // Label 3700: @198273
     /* 198273 */   GIM_Try, /*On fail goto*//*Label 3701*/ GIMT_Encode4(198318), // Rule ID 2636 //
     /* 198278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198286 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198289 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198292 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 198295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198299 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198303 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198307 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_S),
     /* 198310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198316 */     GIR_RootConstrainSelectedInstOperands,
     /* 198317 */     // GIR_Coverage, 2636,
     /* 198317 */     GIR_EraseRootFromParent_Done,
     /* 198318 */   // Label 3701: @198318
     /* 198318 */   GIM_Try, /*On fail goto*//*Label 3702*/ GIMT_Encode4(198363), // Rule ID 2637 //
     /* 198323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 198326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp_n64),
     /* 198331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 198334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 198337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 198340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198344 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 198348 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 198352 */     // (intrinsic_wo_chain:{ *:[i64] } 1822:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 198352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_XP_D),
     /* 198355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 198357 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 198359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198361 */     GIR_RootConstrainSelectedInstOperands,
     /* 198362 */     // GIR_Coverage, 2637,
     /* 198362 */     GIR_EraseRootFromParent_Done,
     /* 198363 */   // Label 3702: @198363
     /* 198363 */   GIM_Try, /*On fail goto*//*Label 3703*/ GIMT_Encode4(198408), // Rule ID 3814 //
     /* 198368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su0),
     /* 198376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198397 */     // (intrinsic_wo_chain:{ *:[v2i64] } 539:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU0:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU0),
     /* 198400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198406 */     GIR_RootConstrainSelectedInstOperands,
     /* 198407 */     // GIR_Coverage, 3814,
     /* 198407 */     GIR_EraseRootFromParent_Done,
     /* 198408 */   // Label 3703: @198408
     /* 198408 */   GIM_Try, /*On fail goto*//*Label 3704*/ GIMT_Encode4(198453), // Rule ID 3842 //
     /* 198413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 198416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_rax1),
     /* 198421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198442 */     // (intrinsic_wo_chain:{ *:[v2i64] } 526:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (RAX1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 198442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1),
     /* 198445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198451 */     GIR_RootConstrainSelectedInstOperands,
     /* 198452 */     // GIR_Coverage, 3842,
     /* 198452 */     GIR_EraseRootFromParent_Done,
     /* 198453 */   // Label 3704: @198453
     /* 198453 */   GIM_Try, /*On fail goto*//*Label 3705*/ GIMT_Encode4(198498), // Rule ID 3852 //
     /* 198458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4ekey),
     /* 198466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198479 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198483 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198487 */     // (intrinsic_wo_chain:{ *:[v4i32] } 549:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4ENCKEY:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4ENCKEY),
     /* 198490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 198492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198496 */     GIR_RootConstrainSelectedInstOperands,
     /* 198497 */     // GIR_Coverage, 3852,
     /* 198497 */     GIR_EraseRootFromParent_Done,
     /* 198498 */   // Label 3705: @198498
     /* 198498 */   GIM_Try, /*On fail goto*//*Label 3706*/ GIMT_Encode4(198543), // Rule ID 3853 //
     /* 198503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 198506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm4e),
     /* 198511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198532 */     // (intrinsic_wo_chain:{ *:[v4i32] } 548:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM4E:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 198532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4E),
     /* 198535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 198537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 198539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 198541 */     GIR_RootConstrainSelectedInstOperands,
     /* 198542 */     // GIR_Coverage, 3853,
     /* 198542 */     GIR_EraseRootFromParent_Done,
     /* 198543 */   // Label 3706: @198543
     /* 198543 */   GIM_Try, /*On fail goto*//*Label 3707*/ GIMT_Encode4(198591), // Rule ID 3854 //
     /* 198548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198569 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198573 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198577 */     // (intrinsic_wo_chain:{ *:[v4f16] } 763:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 198577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198586 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198589 */     GIR_RootConstrainSelectedInstOperands,
     /* 198590 */     // GIR_Coverage, 3854,
     /* 198590 */     GIR_EraseRootFromParent_Done,
     /* 198591 */   // Label 3707: @198591
     /* 198591 */   GIM_Try, /*On fail goto*//*Label 3708*/ GIMT_Encode4(198639), // Rule ID 3855 //
     /* 198596 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198599 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198604 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 198607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 198610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 198613 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198617 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198625 */     // (intrinsic_wo_chain:{ *:[v4f16] } 762:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 198625 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f16),
     /* 198628 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198630 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198632 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198634 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198637 */     GIR_RootConstrainSelectedInstOperands,
     /* 198638 */     // GIR_Coverage, 3855,
     /* 198638 */     GIR_EraseRootFromParent_Done,
     /* 198639 */   // Label 3708: @198639
     /* 198639 */   GIM_Try, /*On fail goto*//*Label 3709*/ GIMT_Encode4(198687), // Rule ID 3856 //
     /* 198644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198665 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198669 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198673 */     // (intrinsic_wo_chain:{ *:[v8f16] } 763:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 198673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198685 */     GIR_RootConstrainSelectedInstOperands,
     /* 198686 */     // GIR_Coverage, 3856,
     /* 198686 */     GIR_EraseRootFromParent_Done,
     /* 198687 */   // Label 3709: @198687
     /* 198687 */   GIM_Try, /*On fail goto*//*Label 3710*/ GIMT_Encode4(198735), // Rule ID 3857 //
     /* 198692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 198695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 198703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 198706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 198709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198721 */     // (intrinsic_wo_chain:{ *:[v8f16] } 762:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 198721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv8f16),
     /* 198724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198730 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198733 */     GIR_RootConstrainSelectedInstOperands,
     /* 198734 */     // GIR_Coverage, 3857,
     /* 198734 */     GIR_EraseRootFromParent_Done,
     /* 198735 */   // Label 3710: @198735
     /* 198735 */   GIM_Try, /*On fail goto*//*Label 3711*/ GIMT_Encode4(198783), // Rule ID 3858 //
     /* 198740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198769 */     // (intrinsic_wo_chain:{ *:[v2f32] } 763:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 198769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198778 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198781 */     GIR_RootConstrainSelectedInstOperands,
     /* 198782 */     // GIR_Coverage, 3858,
     /* 198782 */     GIR_EraseRootFromParent_Done,
     /* 198783 */   // Label 3711: @198783
     /* 198783 */   GIM_Try, /*On fail goto*//*Label 3712*/ GIMT_Encode4(198831), // Rule ID 3859 //
     /* 198788 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198796 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 198799 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 198802 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 198805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198809 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198813 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 198817 */     // (intrinsic_wo_chain:{ *:[v2f32] } 762:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 198817 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f32),
     /* 198820 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198822 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198824 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198826 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198829 */     GIR_RootConstrainSelectedInstOperands,
     /* 198830 */     // GIR_Coverage, 3859,
     /* 198830 */     GIR_EraseRootFromParent_Done,
     /* 198831 */   // Label 3712: @198831
     /* 198831 */   GIM_Try, /*On fail goto*//*Label 3713*/ GIMT_Encode4(198879), // Rule ID 3860 //
     /* 198836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198857 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198861 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198865 */     // (intrinsic_wo_chain:{ *:[v4f32] } 763:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 198865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198877 */     GIR_RootConstrainSelectedInstOperands,
     /* 198878 */     // GIR_Coverage, 3860,
     /* 198878 */     GIR_EraseRootFromParent_Done,
     /* 198879 */   // Label 3713: @198879
     /* 198879 */   GIM_Try, /*On fail goto*//*Label 3714*/ GIMT_Encode4(198927), // Rule ID 3861 //
     /* 198884 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198887 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198892 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 198895 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 198898 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 198901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198905 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198909 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198913 */     // (intrinsic_wo_chain:{ *:[v4f32] } 762:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 198913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv4f32),
     /* 198916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198922 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 198925 */     GIR_RootConstrainSelectedInstOperands,
     /* 198926 */     // GIR_Coverage, 3861,
     /* 198926 */     GIR_EraseRootFromParent_Done,
     /* 198927 */   // Label 3714: @198927
     /* 198927 */   GIM_Try, /*On fail goto*//*Label 3715*/ GIMT_Encode4(198975), // Rule ID 3862 //
     /* 198932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot90),
     /* 198940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 198961 */     // (intrinsic_wo_chain:{ *:[v2f64] } 763:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 198961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 198964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 198966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 198968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 198970 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 198973 */     GIR_RootConstrainSelectedInstOperands,
     /* 198974 */     // GIR_Coverage, 3862,
     /* 198974 */     GIR_EraseRootFromParent_Done,
     /* 198975 */   // Label 3715: @198975
     /* 198975 */   GIM_Try, /*On fail goto*//*Label 3716*/ GIMT_Encode4(199023), // Rule ID 3863 //
     /* 198980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 198983 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcadd_rot270),
     /* 198988 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 198991 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 198994 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 198997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199001 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199005 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 199009 */     // (intrinsic_wo_chain:{ *:[v2f64] } 762:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 199009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCADDv2f64),
     /* 199012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199018 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 199021 */     GIR_RootConstrainSelectedInstOperands,
     /* 199022 */     // GIR_Coverage, 3863,
     /* 199022 */     GIR_EraseRootFromParent_Done,
     /* 199023 */   // Label 3716: @199023
     /* 199023 */   GIM_Try, /*On fail goto*//*Label 3717*/ GIMT_Encode4(199065), // Rule ID 3928 //
     /* 199028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199042 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199054 */     // (intrinsic_wo_chain:{ *:[i32] } 2176:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVWr),
     /* 199057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199063 */     GIR_RootConstrainSelectedInstOperands,
     /* 199064 */     // GIR_Coverage, 3928,
     /* 199064 */     GIR_EraseRootFromParent_Done,
     /* 199065 */   // Label 3717: @199065
     /* 199065 */   GIM_Try, /*On fail goto*//*Label 3718*/ GIMT_Encode4(199107), // Rule ID 3929 //
     /* 199070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_udiv),
     /* 199075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199088 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199096 */     // (intrinsic_wo_chain:{ *:[i64] } 2176:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVXr),
     /* 199099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199105 */     GIR_RootConstrainSelectedInstOperands,
     /* 199106 */     // GIR_Coverage, 3929,
     /* 199106 */     GIR_EraseRootFromParent_Done,
     /* 199107 */   // Label 3718: @199107
     /* 199107 */   GIM_Try, /*On fail goto*//*Label 3719*/ GIMT_Encode4(199149), // Rule ID 3930 //
     /* 199112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 199138 */     // (intrinsic_wo_chain:{ *:[i32] } 786:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SDIVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 199138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVWr),
     /* 199141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199147 */     GIR_RootConstrainSelectedInstOperands,
     /* 199148 */     // GIR_Coverage, 3930,
     /* 199148 */     GIR_EraseRootFromParent_Done,
     /* 199149 */   // Label 3719: @199149
     /* 199149 */   GIM_Try, /*On fail goto*//*Label 3720*/ GIMT_Encode4(199191), // Rule ID 3931 //
     /* 199154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sdiv),
     /* 199159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199172 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199176 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 199180 */     // (intrinsic_wo_chain:{ *:[i64] } 786:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SDIVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 199180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVXr),
     /* 199183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199189 */     GIR_RootConstrainSelectedInstOperands,
     /* 199190 */     // GIR_Coverage, 3931,
     /* 199190 */     GIR_EraseRootFromParent_Done,
     /* 199191 */   // Label 3720: @199191
     /* 199191 */   GIM_Try, /*On fail goto*//*Label 3721*/ GIMT_Encode4(199233), // Rule ID 5221 //
     /* 199196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fabd),
     /* 199201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199218 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199222 */     // (intrinsic_wo_chain:{ *:[v1f64] } 583:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FABD64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 199225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199231 */     GIR_RootConstrainSelectedInstOperands,
     /* 199232 */     // GIR_Coverage, 5221,
     /* 199232 */     GIR_EraseRootFromParent_Done,
     /* 199233 */   // Label 3721: @199233
     /* 199233 */   GIM_Try, /*On fail goto*//*Label 3722*/ GIMT_Encode4(199278), // Rule ID 5225 //
     /* 199238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 199246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199259 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199263 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199267 */     // (intrinsic_wo_chain:{ *:[v1i64] } 585:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FACGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT64),
     /* 199270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199276 */     GIR_RootConstrainSelectedInstOperands,
     /* 199277 */     // GIR_Coverage, 5225,
     /* 199277 */     GIR_EraseRootFromParent_Done,
     /* 199278 */   // Label 3722: @199278
     /* 199278 */   GIM_Try, /*On fail goto*//*Label 3723*/ GIMT_Encode4(199323), // Rule ID 5229 //
     /* 199283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmulx),
     /* 199291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199304 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199312 */     // (intrinsic_wo_chain:{ *:[v1f64] } 617:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMULX64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199312 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX64),
     /* 199315 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199317 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199319 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199321 */     GIR_RootConstrainSelectedInstOperands,
     /* 199322 */     // GIR_Coverage, 5229,
     /* 199322 */     GIR_EraseRootFromParent_Done,
     /* 199323 */   // Label 3723: @199323
     /* 199323 */   GIM_Try, /*On fail goto*//*Label 3724*/ GIMT_Encode4(199368), // Rule ID 5230 //
     /* 199328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frecps),
     /* 199336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199349 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199353 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199357 */     // (intrinsic_wo_chain:{ *:[v1f64] } 640:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRECPS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRECPS64),
     /* 199360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199366 */     GIR_RootConstrainSelectedInstOperands,
     /* 199367 */     // GIR_Coverage, 5230,
     /* 199367 */     GIR_EraseRootFromParent_Done,
     /* 199368 */   // Label 3724: @199368
     /* 199368 */   GIM_Try, /*On fail goto*//*Label 3725*/ GIMT_Encode4(199413), // Rule ID 5231 //
     /* 199373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199376 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_frsqrts),
     /* 199381 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199384 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199387 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199394 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199398 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199402 */     // (intrinsic_wo_chain:{ *:[v1f64] } 647:{ *:[iPTR] }, FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FRSQRTS64:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 199402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FRSQRTS64),
     /* 199405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199411 */     GIR_RootConstrainSelectedInstOperands,
     /* 199412 */     // GIR_Coverage, 5231,
     /* 199412 */     GIR_EraseRootFromParent_Done,
     /* 199413 */   // Label 3725: @199413
     /* 199413 */   GIM_Try, /*On fail goto*//*Label 3726*/ GIMT_Encode4(199458), // Rule ID 5232 //
     /* 199418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199426 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199429 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199432 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199447 */     // (intrinsic_wo_chain:{ *:[i64] } 698:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i64),
     /* 199450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199456 */     GIR_RootConstrainSelectedInstOperands,
     /* 199457 */     // GIR_Coverage, 5232,
     /* 199457 */     GIR_EraseRootFromParent_Done,
     /* 199458 */   // Label 3726: @199458
     /* 199458 */   GIM_Try, /*On fail goto*//*Label 3727*/ GIMT_Encode4(199503), // Rule ID 5233 //
     /* 199463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrshl),
     /* 199471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199492 */     // (intrinsic_wo_chain:{ *:[i32] } 698:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHLv1i32),
     /* 199495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199499 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199501 */     GIR_RootConstrainSelectedInstOperands,
     /* 199502 */     // GIR_Coverage, 5233,
     /* 199502 */     GIR_EraseRootFromParent_Done,
     /* 199503 */   // Label 3727: @199503
     /* 199503 */   GIM_Try, /*On fail goto*//*Label 3728*/ GIMT_Encode4(199548), // Rule ID 5234 //
     /* 199508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199511 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199516 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199529 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199533 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199537 */     // (intrinsic_wo_chain:{ *:[i64] } 701:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i64),
     /* 199540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199546 */     GIR_RootConstrainSelectedInstOperands,
     /* 199547 */     // GIR_Coverage, 5234,
     /* 199547 */     GIR_EraseRootFromParent_Done,
     /* 199548 */   // Label 3728: @199548
     /* 199548 */   GIM_Try, /*On fail goto*//*Label 3729*/ GIMT_Encode4(199593), // Rule ID 5235 //
     /* 199553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqshl),
     /* 199561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199582 */     // (intrinsic_wo_chain:{ *:[i32] } 701:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLv1i32),
     /* 199585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199591 */     GIR_RootConstrainSelectedInstOperands,
     /* 199592 */     // GIR_Coverage, 5235,
     /* 199592 */     GIR_EraseRootFromParent_Done,
     /* 199593 */   // Label 3729: @199593
     /* 199593 */   GIM_Try, /*On fail goto*//*Label 3730*/ GIMT_Encode4(199638), // Rule ID 5236 //
     /* 199598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199606 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199609 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199612 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199623 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199627 */     // (intrinsic_wo_chain:{ *:[i64] } 705:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 199630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199636 */     GIR_RootConstrainSelectedInstOperands,
     /* 199637 */     // GIR_Coverage, 5236,
     /* 199637 */     GIR_EraseRootFromParent_Done,
     /* 199638 */   // Label 3730: @199638
     /* 199638 */   GIM_Try, /*On fail goto*//*Label 3731*/ GIMT_Encode4(199683), // Rule ID 5237 //
     /* 199643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199646 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqsub),
     /* 199651 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199664 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199668 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199672 */     // (intrinsic_wo_chain:{ *:[i32] } 705:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i32),
     /* 199675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199681 */     GIR_RootConstrainSelectedInstOperands,
     /* 199682 */     // GIR_Coverage, 5237,
     /* 199682 */     GIR_EraseRootFromParent_Done,
     /* 199683 */   // Label 3731: @199683
     /* 199683 */   GIM_Try, /*On fail goto*//*Label 3732*/ GIMT_Encode4(199728), // Rule ID 5238 //
     /* 199688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199691 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199696 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199717 */     // (intrinsic_wo_chain:{ *:[i64] } 746:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQADDv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 199720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199726 */     GIR_RootConstrainSelectedInstOperands,
     /* 199727 */     // GIR_Coverage, 5238,
     /* 199727 */     GIR_EraseRootFromParent_Done,
     /* 199728 */   // Label 3732: @199728
     /* 199728 */   GIM_Try, /*On fail goto*//*Label 3733*/ GIMT_Encode4(199773), // Rule ID 5239 //
     /* 199733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqadd),
     /* 199741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199754 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199762 */     // (intrinsic_wo_chain:{ *:[i32] } 746:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQADDv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i32),
     /* 199765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199771 */     GIR_RootConstrainSelectedInstOperands,
     /* 199772 */     // GIR_Coverage, 5239,
     /* 199772 */     GIR_EraseRootFromParent_Done,
     /* 199773 */   // Label 3733: @199773
     /* 199773 */   GIM_Try, /*On fail goto*//*Label 3734*/ GIMT_Encode4(199818), // Rule ID 5240 //
     /* 199778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199807 */     // (intrinsic_wo_chain:{ *:[i64] } 747:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i64),
     /* 199810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199816 */     GIR_RootConstrainSelectedInstOperands,
     /* 199817 */     // GIR_Coverage, 5240,
     /* 199817 */     GIR_EraseRootFromParent_Done,
     /* 199818 */   // Label 3734: @199818
     /* 199818 */   GIM_Try, /*On fail goto*//*Label 3735*/ GIMT_Encode4(199863), // Rule ID 5241 //
     /* 199823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqrshl),
     /* 199831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199844 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199848 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199852 */     // (intrinsic_wo_chain:{ *:[i32] } 747:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQRSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHLv1i32),
     /* 199855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199861 */     GIR_RootConstrainSelectedInstOperands,
     /* 199862 */     // GIR_Coverage, 5241,
     /* 199862 */     GIR_EraseRootFromParent_Done,
     /* 199863 */   // Label 3735: @199863
     /* 199863 */   GIM_Try, /*On fail goto*//*Label 3736*/ GIMT_Encode4(199908), // Rule ID 5242 //
     /* 199868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199897 */     // (intrinsic_wo_chain:{ *:[i64] } 749:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i64),
     /* 199900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199906 */     GIR_RootConstrainSelectedInstOperands,
     /* 199907 */     // GIR_Coverage, 5242,
     /* 199907 */     GIR_EraseRootFromParent_Done,
     /* 199908 */   // Label 3736: @199908
     /* 199908 */   GIM_Try, /*On fail goto*//*Label 3737*/ GIMT_Encode4(199953), // Rule ID 5243 //
     /* 199913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqshl),
     /* 199921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 199924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 199927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 199930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199934 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199938 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 199942 */     // (intrinsic_wo_chain:{ *:[i32] } 749:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSHLv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 199942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHLv1i32),
     /* 199945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199951 */     GIR_RootConstrainSelectedInstOperands,
     /* 199952 */     // GIR_Coverage, 5243,
     /* 199952 */     GIR_EraseRootFromParent_Done,
     /* 199953 */   // Label 3737: @199953
     /* 199953 */   GIM_Try, /*On fail goto*//*Label 3738*/ GIMT_Encode4(199998), // Rule ID 5244 //
     /* 199958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 199961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 199966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 199969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 199972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 199975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199979 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199983 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 199987 */     // (intrinsic_wo_chain:{ *:[i64] } 751:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 199987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 199990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 199992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 199994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 199996 */     GIR_RootConstrainSelectedInstOperands,
     /* 199997 */     // GIR_Coverage, 5244,
     /* 199997 */     GIR_EraseRootFromParent_Done,
     /* 199998 */   // Label 3738: @199998
     /* 199998 */   GIM_Try, /*On fail goto*//*Label 3739*/ GIMT_Encode4(200043), // Rule ID 5245 //
     /* 200003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uqsub),
     /* 200011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 200020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200032 */     // (intrinsic_wo_chain:{ *:[i32] } 751:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (UQSUBv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 200032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i32),
     /* 200035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200037 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200041 */     GIR_RootConstrainSelectedInstOperands,
     /* 200042 */     // GIR_Coverage, 5245,
     /* 200042 */     GIR_EraseRootFromParent_Done,
     /* 200043 */   // Label 3739: @200043
     /* 200043 */   GIM_Try, /*On fail goto*//*Label 3740*/ GIMT_Encode4(200088), // Rule ID 5264 //
     /* 200048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 200051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usqadd),
     /* 200056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200069 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200077 */     // (intrinsic_wo_chain:{ *:[v1i64] } 761:{ *:[iPTR] }, FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)  =>  (USQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rd, FPR64:{ *:[v1i64] }:$Rn)
     /* 200077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADDv1i64),
     /* 200080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200086 */     GIR_RootConstrainSelectedInstOperands,
     /* 200087 */     // GIR_Coverage, 5264,
     /* 200087 */     GIR_EraseRootFromParent_Done,
     /* 200088 */   // Label 3740: @200088
     /* 200088 */   GIM_Try, /*On fail goto*//*Label 3741*/ GIMT_Encode4(200130), // Rule ID 5598 //
     /* 200093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 200101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 200107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200111 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200119 */     // (intrinsic_wo_chain:{ *:[v8i8] } 723:{ *:[iPTR] }, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBLv8i8One:{ *:[v8i8] } VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 200119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv8i8One),
     /* 200122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 200128 */     GIR_RootConstrainSelectedInstOperands,
     /* 200129 */     // GIR_Coverage, 5598,
     /* 200129 */     GIR_EraseRootFromParent_Done,
     /* 200130 */   // Label 3741: @200130
     /* 200130 */   GIM_Try, /*On fail goto*//*Label 3742*/ GIMT_Encode4(200172), // Rule ID 5599 //
     /* 200135 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbl1),
     /* 200140 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 200143 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 200146 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 200149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 200161 */     // (intrinsic_wo_chain:{ *:[v16i8] } 723:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBLv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 200161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLv16i8One),
     /* 200164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 200166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Ri
     /* 200168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200170 */     GIR_RootConstrainSelectedInstOperands,
     /* 200171 */     // GIR_Coverage, 5599,
     /* 200171 */     GIR_EraseRootFromParent_Done,
     /* 200172 */   // Label 3742: @200172
     /* 200172 */   GIM_Try, /*On fail goto*//*Label 3743*/ GIMT_Encode4(200269), // Rule ID 6326 //
     /* 200177 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facge),
     /* 200182 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200185 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200188 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200199 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200203 */     // (intrinsic_wo_chain:{ *:[i32] } 584:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGE16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200203 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200206 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGE16),
     /* 200210 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200215 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200219 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200237 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200244 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200247 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200253 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200258 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200263 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200268 */     // GIR_Coverage, 6326,
     /* 200268 */     GIR_EraseRootFromParent_Done,
     /* 200269 */   // Label 3743: @200269
     /* 200269 */   GIM_Try, /*On fail goto*//*Label 3744*/ GIMT_Encode4(200366), // Rule ID 6327 //
     /* 200274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_facgt),
     /* 200279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 200285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 200288 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200292 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200296 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200300 */     // (intrinsic_wo_chain:{ *:[i32] } 585:{ *:[iPTR] }, FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (INSERT_SUBREG:{ *:[i32] } (IMPLICIT_DEF:{ *:[i32] }), (FACGT16:{ *:[i16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm), hsub:{ *:[i32] })
     /* 200300 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 200303 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FACGT16),
     /* 200307 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200312 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 200316 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 200320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 200322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 200325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 200329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 200334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 200336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 200339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 200341 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 200344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 200347 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 200350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 200360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 200365 */     // GIR_Coverage, 6327,
     /* 200365 */     GIR_EraseRootFromParent_Done,
     /* 200366 */   // Label 3744: @200366
     /* 200366 */   GIM_Try, /*On fail goto*//*Label 3745*/ GIMT_Encode4(200408), // Rule ID 6974 //
     /* 200371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sshl),
     /* 200376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200389 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200393 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200397 */     // (intrinsic_wo_chain:{ *:[i64] } 710:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLv1i64),
     /* 200400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200406 */     GIR_RootConstrainSelectedInstOperands,
     /* 200407 */     // GIR_Coverage, 6974,
     /* 200407 */     GIR_EraseRootFromParent_Done,
     /* 200408 */   // Label 3745: @200408
     /* 200408 */   GIM_Try, /*On fail goto*//*Label 3746*/ GIMT_Encode4(200450), // Rule ID 6975 //
     /* 200413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ushl),
     /* 200418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200427 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200431 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200435 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200439 */     // (intrinsic_wo_chain:{ *:[i64] } 758:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (USHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLv1i64),
     /* 200442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200448 */     GIR_RootConstrainSelectedInstOperands,
     /* 200449 */     // GIR_Coverage, 6975,
     /* 200449 */     GIR_EraseRootFromParent_Done,
     /* 200450 */   // Label 3746: @200450
     /* 200450 */   GIM_Try, /*On fail goto*//*Label 3747*/ GIMT_Encode4(200492), // Rule ID 6976 //
     /* 200455 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_srshl),
     /* 200460 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200463 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200466 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200481 */     // (intrinsic_wo_chain:{ *:[i64] } 709:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (SRSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHLv1i64),
     /* 200484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200490 */     GIR_RootConstrainSelectedInstOperands,
     /* 200491 */     // GIR_Coverage, 6976,
     /* 200491 */     GIR_EraseRootFromParent_Done,
     /* 200492 */   // Label 3747: @200492
     /* 200492 */   GIM_Try, /*On fail goto*//*Label 3748*/ GIMT_Encode4(200534), // Rule ID 6977 //
     /* 200497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_urshl),
     /* 200502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200511 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200519 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 200523 */     // (intrinsic_wo_chain:{ *:[i64] } 755:{ *:[iPTR] }, FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)  =>  (URSHLv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i64] }:$Rm)
     /* 200523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHLv1i64),
     /* 200526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 200532 */     GIR_RootConstrainSelectedInstOperands,
     /* 200533 */     // GIR_Coverage, 6977,
     /* 200533 */     GIR_EraseRootFromParent_Done,
     /* 200534 */   // Label 3748: @200534
     /* 200534 */   GIM_Try, /*On fail goto*//*Label 3749*/ GIMT_Encode4(200582), // Rule ID 7017 //
     /* 200539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_blend),
     /* 200544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 200553 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200561 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200565 */     // (intrinsic_wo_chain:{ *:[i64] } 295:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn)  =>  (BFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, 16:{ *:[i64] }, 15:{ *:[i64] })
     /* 200565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BFMXri),
     /* 200568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 200570 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 200572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 200574 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/16,
     /* 200577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 200580 */     GIR_RootConstrainSelectedInstOperands,
     /* 200581 */     // GIR_Coverage, 7017,
     /* 200581 */     GIR_EraseRootFromParent_Done,
     /* 200582 */   // Label 3749: @200582
     /* 200582 */   GIM_Try, /*On fail goto*//*Label 3750*/ GIMT_Encode4(200627), // Rule ID 10075 //
     /* 200587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200604 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200608 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200612 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200616 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQINCP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_B),
     /* 200619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200625 */     GIR_RootConstrainSelectedInstOperands,
     /* 200626 */     // GIR_Coverage, 10075,
     /* 200626 */     GIR_EraseRootFromParent_Done,
     /* 200627 */   // Label 3750: @200627
     /* 200627 */   GIM_Try, /*On fail goto*//*Label 3751*/ GIMT_Encode4(200672), // Rule ID 10076 //
     /* 200632 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200635 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200640 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200643 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200646 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200661 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQINCP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_H),
     /* 200664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200670 */     GIR_RootConstrainSelectedInstOperands,
     /* 200671 */     // GIR_Coverage, 10076,
     /* 200671 */     GIR_EraseRootFromParent_Done,
     /* 200672 */   // Label 3751: @200672
     /* 200672 */   GIM_Try, /*On fail goto*//*Label 3752*/ GIMT_Encode4(200717), // Rule ID 10077 //
     /* 200677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200706 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQINCP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_S),
     /* 200709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200715 */     GIR_RootConstrainSelectedInstOperands,
     /* 200716 */     // GIR_Coverage, 10077,
     /* 200716 */     GIR_EraseRootFromParent_Done,
     /* 200717 */   // Label 3752: @200717
     /* 200717 */   GIM_Try, /*On fail goto*//*Label 3753*/ GIMT_Encode4(200762), // Rule ID 10078 //
     /* 200722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp_n64),
     /* 200730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200739 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200743 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200747 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200751 */     // (intrinsic_wo_chain:{ *:[i64] } 2033:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQINCP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_XP_D),
     /* 200754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200760 */     GIR_RootConstrainSelectedInstOperands,
     /* 200761 */     // GIR_Coverage, 10078,
     /* 200761 */     GIR_EraseRootFromParent_Done,
     /* 200762 */   // Label 3753: @200762
     /* 200762 */   GIM_Try, /*On fail goto*//*Label 3754*/ GIMT_Encode4(200807), // Rule ID 10087 //
     /* 200767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200784 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200788 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200796 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (SQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_B),
     /* 200799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200805 */     GIR_RootConstrainSelectedInstOperands,
     /* 200806 */     // GIR_Coverage, 10087,
     /* 200806 */     GIR_EraseRootFromParent_Done,
     /* 200807 */   // Label 3754: @200807
     /* 200807 */   GIM_Try, /*On fail goto*//*Label 3755*/ GIMT_Encode4(200852), // Rule ID 10088 //
     /* 200812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 200829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200841 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (SQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_H),
     /* 200844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200848 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200850 */     GIR_RootConstrainSelectedInstOperands,
     /* 200851 */     // GIR_Coverage, 10088,
     /* 200851 */     GIR_EraseRootFromParent_Done,
     /* 200852 */   // Label 3755: @200852
     /* 200852 */   GIM_Try, /*On fail goto*//*Label 3756*/ GIMT_Encode4(200897), // Rule ID 10089 //
     /* 200857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 200874 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200882 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200886 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (SQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_S),
     /* 200889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200895 */     GIR_RootConstrainSelectedInstOperands,
     /* 200896 */     // GIR_Coverage, 10089,
     /* 200896 */     GIR_EraseRootFromParent_Done,
     /* 200897 */   // Label 3756: @200897
     /* 200897 */   GIM_Try, /*On fail goto*//*Label 3757*/ GIMT_Encode4(200942), // Rule ID 10090 //
     /* 200902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200905 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp_n64),
     /* 200910 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 200913 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 200916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 200919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200923 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 200927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200931 */     // (intrinsic_wo_chain:{ *:[i64] } 1788:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (SQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 200931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_XP_D),
     /* 200934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200938 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200940 */     GIR_RootConstrainSelectedInstOperands,
     /* 200941 */     // GIR_Coverage, 10090,
     /* 200941 */     GIR_EraseRootFromParent_Done,
     /* 200942 */   // Label 3757: @200942
     /* 200942 */   GIM_Try, /*On fail goto*//*Label 3758*/ GIMT_Encode4(200987), // Rule ID 10091 //
     /* 200947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 200955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 200958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 200961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 200964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 200972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 200976 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_WP_B:{ *:[i32] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 200976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_B),
     /* 200979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 200981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 200983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 200985 */     GIR_RootConstrainSelectedInstOperands,
     /* 200986 */     // GIR_Coverage, 10091,
     /* 200986 */     GIR_EraseRootFromParent_Done,
     /* 200987 */   // Label 3758: @200987
     /* 200987 */   GIM_Try, /*On fail goto*//*Label 3759*/ GIMT_Encode4(201032), // Rule ID 10092 //
     /* 200992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 200995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201021 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_WP_H:{ *:[i32] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_H),
     /* 201024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201030 */     GIR_RootConstrainSelectedInstOperands,
     /* 201031 */     // GIR_Coverage, 10092,
     /* 201031 */     GIR_EraseRootFromParent_Done,
     /* 201032 */   // Label 3759: @201032
     /* 201032 */   GIM_Try, /*On fail goto*//*Label 3760*/ GIMT_Encode4(201077), // Rule ID 10093 //
     /* 201037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201066 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_WP_S:{ *:[i32] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_S),
     /* 201069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201073 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201075 */     GIR_RootConstrainSelectedInstOperands,
     /* 201076 */     // GIR_Coverage, 10093,
     /* 201076 */     GIR_EraseRootFromParent_Done,
     /* 201077 */   // Label 3760: @201077
     /* 201077 */   GIM_Try, /*On fail goto*//*Label 3761*/ GIMT_Encode4(201122), // Rule ID 10094 //
     /* 201082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n32),
     /* 201090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 201093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 201096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 201107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201111 */     // (intrinsic_wo_chain:{ *:[i32] } 2018:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_WP_D:{ *:[i32] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i32] }:$Rn)
     /* 201111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_WP_D),
     /* 201114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201120 */     GIR_RootConstrainSelectedInstOperands,
     /* 201121 */     // GIR_Coverage, 10094,
     /* 201121 */     GIR_EraseRootFromParent_Done,
     /* 201122 */   // Label 3761: @201122
     /* 201122 */   GIM_Try, /*On fail goto*//*Label 3762*/ GIMT_Encode4(201167), // Rule ID 10095 //
     /* 201127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201152 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201156 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (UQDECP_XP_B:{ *:[i64] } PPRAny:{ *:[nxv16i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_B),
     /* 201159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201163 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201165 */     GIR_RootConstrainSelectedInstOperands,
     /* 201166 */     // GIR_Coverage, 10095,
     /* 201166 */     GIR_EraseRootFromParent_Done,
     /* 201167 */   // Label 3762: @201167
     /* 201167 */   GIM_Try, /*On fail goto*//*Label 3763*/ GIMT_Encode4(201212), // Rule ID 10096 //
     /* 201172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 201189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201193 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201201 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv8i1] }:$Pg)  =>  (UQDECP_XP_H:{ *:[i64] } PPRAny:{ *:[nxv8i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_H),
     /* 201204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201210 */     GIR_RootConstrainSelectedInstOperands,
     /* 201211 */     // GIR_Coverage, 10096,
     /* 201211 */     GIR_EraseRootFromParent_Done,
     /* 201212 */   // Label 3763: @201212
     /* 201212 */   GIM_Try, /*On fail goto*//*Label 3764*/ GIMT_Encode4(201257), // Rule ID 10097 //
     /* 201217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 201234 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201238 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201242 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201246 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv4i1] }:$Pg)  =>  (UQDECP_XP_S:{ *:[i64] } PPRAny:{ *:[nxv4i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201246 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_S),
     /* 201249 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201253 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201255 */     GIR_RootConstrainSelectedInstOperands,
     /* 201256 */     // GIR_Coverage, 10097,
     /* 201256 */     GIR_EraseRootFromParent_Done,
     /* 201257 */   // Label 3764: @201257
     /* 201257 */   GIM_Try, /*On fail goto*//*Label 3765*/ GIMT_Encode4(201302), // Rule ID 10098 //
     /* 201262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp_n64),
     /* 201270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 201276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 201279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201287 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201291 */     // (intrinsic_wo_chain:{ *:[i64] } 2019:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, PPRAny:{ *:[nxv2i1] }:$Pg)  =>  (UQDECP_XP_D:{ *:[i64] } PPRAny:{ *:[nxv2i1] }:$Pg, ?:{ *:[i64] }:$Rn)
     /* 201291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_XP_D),
     /* 201294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 201296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pg
     /* 201298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201300 */     GIR_RootConstrainSelectedInstOperands,
     /* 201301 */     // GIR_Coverage, 10098,
     /* 201301 */     GIR_EraseRootFromParent_Done,
     /* 201302 */   // Label 3765: @201302
     /* 201302 */   GIM_Try, /*On fail goto*//*Label 3766*/ GIMT_Encode4(201348), // Rule ID 138 //
     /* 201307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gmi),
     /* 201315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 201321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201325 */     // MIs[0] Rn
     /* 201325 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201337 */     // (intrinsic_wo_chain:{ *:[i64] } 562:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (GMI:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 201337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GMI),
     /* 201340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201342 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201344 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201346 */     GIR_RootConstrainSelectedInstOperands,
     /* 201347 */     // GIR_Coverage, 138,
     /* 201347 */     GIR_EraseRootFromParent_Done,
     /* 201348 */   // Label 3766: @201348
     /* 201348 */   GIM_Try, /*On fail goto*//*Label 3767*/ GIMT_Encode4(201395), // Rule ID 139 //
     /* 201353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 201356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_subp),
     /* 201361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 201364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 201368 */     // MIs[0] Rn
     /* 201368 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 201372 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201376 */     // MIs[0] Rm
     /* 201376 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 201380 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 201384 */     // (intrinsic_wo_chain:{ *:[i64] } 1249:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)  =>  (SUBP:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64sp:{ *:[i64] }:$Rm)
     /* 201384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBP),
     /* 201387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 201389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 201391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 201393 */     GIR_RootConstrainSelectedInstOperands,
     /* 201394 */     // GIR_Coverage, 139,
     /* 201394 */     GIR_EraseRootFromParent_Done,
     /* 201395 */   // Label 3767: @201395
     /* 201395 */   GIM_Try, /*On fail goto*//*Label 3768*/ GIMT_Encode4(201432), // Rule ID 2399 //
     /* 201400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201403 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b16),
     /* 201408 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201411 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201414 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201417 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201421 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2158:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 201424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201428 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201430 */     GIR_RootConstrainSelectedInstOperands,
     /* 201431 */     // GIR_Coverage, 2399,
     /* 201431 */     GIR_EraseRootFromParent_Done,
     /* 201432 */   // Label 3768: @201432
     /* 201432 */   GIM_Try, /*On fail goto*//*Label 3769*/ GIMT_Encode4(201469), // Rule ID 2400 //
     /* 201437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b32),
     /* 201445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201454 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201458 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2159:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 201461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201465 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201467 */     GIR_RootConstrainSelectedInstOperands,
     /* 201468 */     // GIR_Coverage, 2400,
     /* 201468 */     GIR_EraseRootFromParent_Done,
     /* 201469 */   // Label 3769: @201469
     /* 201469 */   GIM_Try, /*On fail goto*//*Label 3770*/ GIMT_Encode4(201506), // Rule ID 2401 //
     /* 201474 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201477 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1_b64),
     /* 201482 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201485 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201488 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201495 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2160:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 201498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201504 */     GIR_RootConstrainSelectedInstOperands,
     /* 201505 */     // GIR_Coverage, 2401,
     /* 201505 */     GIR_EraseRootFromParent_Done,
     /* 201506 */   // Label 3770: @201506
     /* 201506 */   GIM_Try, /*On fail goto*//*Label 3771*/ GIMT_Encode4(201543), // Rule ID 2403 //
     /* 201511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b16),
     /* 201519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201532 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2163:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 201535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201541 */     GIR_RootConstrainSelectedInstOperands,
     /* 201542 */     // GIR_Coverage, 2403,
     /* 201542 */     GIR_EraseRootFromParent_Done,
     /* 201543 */   // Label 3771: @201543
     /* 201543 */   GIM_Try, /*On fail goto*//*Label 3772*/ GIMT_Encode4(201580), // Rule ID 2404 //
     /* 201548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b32),
     /* 201556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201569 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2164:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 201572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201578 */     GIR_RootConstrainSelectedInstOperands,
     /* 201579 */     // GIR_Coverage, 2404,
     /* 201579 */     GIR_EraseRootFromParent_Done,
     /* 201580 */   // Label 3772: @201580
     /* 201580 */   GIM_Try, /*On fail goto*//*Label 3773*/ GIMT_Encode4(201617), // Rule ID 2405 //
     /* 201585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2_b64),
     /* 201593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201602 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201606 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2165:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 201609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201611 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201615 */     GIR_RootConstrainSelectedInstOperands,
     /* 201616 */     // GIR_Coverage, 2405,
     /* 201616 */     GIR_EraseRootFromParent_Done,
     /* 201617 */   // Label 3773: @201617
     /* 201617 */   GIM_Try, /*On fail goto*//*Label 3774*/ GIMT_Encode4(201654), // Rule ID 2407 //
     /* 201622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201625 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b16),
     /* 201630 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201633 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201643 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2084:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 201646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201652 */     GIR_RootConstrainSelectedInstOperands,
     /* 201653 */     // GIR_Coverage, 2407,
     /* 201653 */     GIR_EraseRootFromParent_Done,
     /* 201654 */   // Label 3774: @201654
     /* 201654 */   GIM_Try, /*On fail goto*//*Label 3775*/ GIMT_Encode4(201691), // Rule ID 2408 //
     /* 201659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b32),
     /* 201667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201676 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201680 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2085:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 201683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201685 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201689 */     GIR_RootConstrainSelectedInstOperands,
     /* 201690 */     // GIR_Coverage, 2408,
     /* 201690 */     GIR_EraseRootFromParent_Done,
     /* 201691 */   // Label 3775: @201691
     /* 201691 */   GIM_Try, /*On fail goto*//*Label 3776*/ GIMT_Encode4(201728), // Rule ID 2409 //
     /* 201696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201699 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1_b64),
     /* 201704 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201707 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201710 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201713 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201717 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2086:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201717 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 201720 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201722 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201724 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201726 */     GIR_RootConstrainSelectedInstOperands,
     /* 201727 */     // GIR_Coverage, 2409,
     /* 201727 */     GIR_EraseRootFromParent_Done,
     /* 201728 */   // Label 3776: @201728
     /* 201728 */   GIM_Try, /*On fail goto*//*Label 3777*/ GIMT_Encode4(201765), // Rule ID 2411 //
     /* 201733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b16),
     /* 201741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201754 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2089:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 201757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201763 */     GIR_RootConstrainSelectedInstOperands,
     /* 201764 */     // GIR_Coverage, 2411,
     /* 201764 */     GIR_EraseRootFromParent_Done,
     /* 201765 */   // Label 3777: @201765
     /* 201765 */   GIM_Try, /*On fail goto*//*Label 3778*/ GIMT_Encode4(201802), // Rule ID 2412 //
     /* 201770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201773 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b32),
     /* 201778 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201781 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201784 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201791 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2090:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 201794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201800 */     GIR_RootConstrainSelectedInstOperands,
     /* 201801 */     // GIR_Coverage, 2412,
     /* 201801 */     GIR_EraseRootFromParent_Done,
     /* 201802 */   // Label 3778: @201802
     /* 201802 */   GIM_Try, /*On fail goto*//*Label 3779*/ GIMT_Encode4(201839), // Rule ID 2413 //
     /* 201807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2_b64),
     /* 201815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201828 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2091:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 201831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201837 */     GIR_RootConstrainSelectedInstOperands,
     /* 201838 */     // GIR_Coverage, 2413,
     /* 201838 */     GIR_EraseRootFromParent_Done,
     /* 201839 */   // Label 3779: @201839
     /* 201839 */   GIM_Try, /*On fail goto*//*Label 3780*/ GIMT_Encode4(201876), // Rule ID 2415 //
     /* 201844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b16),
     /* 201852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201865 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1928:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 201868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201874 */     GIR_RootConstrainSelectedInstOperands,
     /* 201875 */     // GIR_Coverage, 2415,
     /* 201875 */     GIR_EraseRootFromParent_Done,
     /* 201876 */   // Label 3780: @201876
     /* 201876 */   GIM_Try, /*On fail goto*//*Label 3781*/ GIMT_Encode4(201913), // Rule ID 2416 //
     /* 201881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b32),
     /* 201889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201902 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1929:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 201905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201911 */     GIR_RootConstrainSelectedInstOperands,
     /* 201912 */     // GIR_Coverage, 2416,
     /* 201912 */     GIR_EraseRootFromParent_Done,
     /* 201913 */   // Label 3781: @201913
     /* 201913 */   GIM_Try, /*On fail goto*//*Label 3782*/ GIMT_Encode4(201950), // Rule ID 2417 //
     /* 201918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1_b64),
     /* 201926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201939 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1930:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 201942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201948 */     GIR_RootConstrainSelectedInstOperands,
     /* 201949 */     // GIR_Coverage, 2417,
     /* 201949 */     GIR_EraseRootFromParent_Done,
     /* 201950 */   // Label 3782: @201950
     /* 201950 */   GIM_Try, /*On fail goto*//*Label 3783*/ GIMT_Encode4(201987), // Rule ID 2419 //
     /* 201955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b16),
     /* 201963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 201966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 201969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 201972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 201976 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1933:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_H:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 201976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 201979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 201981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 201983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 201985 */     GIR_RootConstrainSelectedInstOperands,
     /* 201986 */     // GIR_Coverage, 2419,
     /* 201986 */     GIR_EraseRootFromParent_Done,
     /* 201987 */   // Label 3783: @201987
     /* 201987 */   GIM_Try, /*On fail goto*//*Label 3784*/ GIMT_Encode4(202024), // Rule ID 2420 //
     /* 201992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 201995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b32),
     /* 202000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202013 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1934:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_S:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 202016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202022 */     GIR_RootConstrainSelectedInstOperands,
     /* 202023 */     // GIR_Coverage, 2420,
     /* 202023 */     GIR_EraseRootFromParent_Done,
     /* 202024 */   // Label 3784: @202024
     /* 202024 */   GIM_Try, /*On fail goto*//*Label 3785*/ GIMT_Encode4(202061), // Rule ID 2421 //
     /* 202029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2_b64),
     /* 202037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202050 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1935:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_D:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 202050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 202053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 202055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 202057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 202059 */     GIR_RootConstrainSelectedInstOperands,
     /* 202060 */     // GIR_Coverage, 2421,
     /* 202060 */     GIR_EraseRootFromParent_Done,
     /* 202061 */   // Label 3785: @202061
     /* 202061 */   GIM_Try, /*On fail goto*//*Label 3786*/ GIMT_Encode4(202098), // Rule ID 2422 //
     /* 202066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 202069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histseg),
     /* 202074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202087 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1553:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (HISTSEG_ZZZ:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)
     /* 202087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTSEG_ZZZ),
     /* 202090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 202094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 202096 */     GIR_RootConstrainSelectedInstOperands,
     /* 202097 */     // GIR_Coverage, 2422,
     /* 202097 */     GIR_EraseRootFromParent_Done,
     /* 202098 */   // Label 3786: @202098
     /* 202098 */   GIM_Try, /*On fail goto*//*Label 3787*/ GIMT_Encode4(202138), // Rule ID 2617 //
     /* 202103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pfirst),
     /* 202111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1632:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PFIRST_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PFIRST_B),
     /* 202127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202136 */     GIR_RootConstrainSelectedInstOperands,
     /* 202137 */     // GIR_Coverage, 2617,
     /* 202137 */     GIR_EraseRootFromParent_Done,
     /* 202138 */   // Label 3787: @202138
     /* 202138 */   GIM_Try, /*On fail goto*//*Label 3788*/ GIMT_Encode4(202178), // Rule ID 2618 //
     /* 202143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 202154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202164 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1640:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (PNEXT_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_B),
     /* 202167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202176 */     GIR_RootConstrainSelectedInstOperands,
     /* 202177 */     // GIR_Coverage, 2618,
     /* 202177 */     GIR_EraseRootFromParent_Done,
     /* 202178 */   // Label 3788: @202178
     /* 202178 */   GIM_Try, /*On fail goto*//*Label 3789*/ GIMT_Encode4(202218), // Rule ID 2619 //
     /* 202183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 202194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202204 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1640:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (PNEXT_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_H),
     /* 202207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202216 */     GIR_RootConstrainSelectedInstOperands,
     /* 202217 */     // GIR_Coverage, 2619,
     /* 202217 */     GIR_EraseRootFromParent_Done,
     /* 202218 */   // Label 3789: @202218
     /* 202218 */   GIM_Try, /*On fail goto*//*Label 3790*/ GIMT_Encode4(202258), // Rule ID 2620 //
     /* 202223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 202234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202244 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1640:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (PNEXT_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_S),
     /* 202247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202253 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202256 */     GIR_RootConstrainSelectedInstOperands,
     /* 202257 */     // GIR_Coverage, 2620,
     /* 202257 */     GIR_EraseRootFromParent_Done,
     /* 202258 */   // Label 3790: @202258
     /* 202258 */   GIM_Try, /*On fail goto*//*Label 3791*/ GIMT_Encode4(202298), // Rule ID 2621 //
     /* 202263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pnext),
     /* 202271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 202274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 202284 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1640:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (PNEXT_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PNEXT_D),
     /* 202287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdn]
     /* 202289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202293 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 202296 */     GIR_RootConstrainSelectedInstOperands,
     /* 202297 */     // GIR_Coverage, 2621,
     /* 202297 */     GIR_EraseRootFromParent_Done,
     /* 202298 */   // Label 3791: @202298
     /* 202298 */   GIM_Try, /*On fail goto*//*Label 3792*/ GIMT_Encode4(202335), // Rule ID 2638 //
     /* 202303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202320 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202324 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1820:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_H),
     /* 202327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202329 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202331 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202333 */     GIR_RootConstrainSelectedInstOperands,
     /* 202334 */     // GIR_Coverage, 2638,
     /* 202334 */     GIR_EraseRootFromParent_Done,
     /* 202335 */   // Label 3792: @202335
     /* 202335 */   GIM_Try, /*On fail goto*//*Label 3793*/ GIMT_Encode4(202372), // Rule ID 2639 //
     /* 202340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202351 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202354 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202361 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1820:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_S),
     /* 202364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202370 */     GIR_RootConstrainSelectedInstOperands,
     /* 202371 */     // GIR_Coverage, 2639,
     /* 202371 */     GIR_EraseRootFromParent_Done,
     /* 202372 */   // Label 3793: @202372
     /* 202372 */   GIM_Try, /*On fail goto*//*Label 3794*/ GIMT_Encode4(202409), // Rule ID 2640 //
     /* 202377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincp),
     /* 202385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202394 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202398 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1820:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCP_ZP_D),
     /* 202401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 202403 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202407 */     GIR_RootConstrainSelectedInstOperands,
     /* 202408 */     // GIR_Coverage, 2640,
     /* 202408 */     GIR_EraseRootFromParent_Done,
     /* 202409 */   // Label 3794: @202409
     /* 202409 */   GIM_Try, /*On fail goto*//*Label 3795*/ GIMT_Encode4(202446), // Rule ID 2641 //
     /* 202414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202417 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202422 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202425 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 202428 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 202431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202435 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (CNTP_XPP_B:{ *:[i64] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 202435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_B),
     /* 202438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202444 */     GIR_RootConstrainSelectedInstOperands,
     /* 202445 */     // GIR_Coverage, 2641,
     /* 202445 */     GIR_EraseRootFromParent_Done,
     /* 202446 */   // Label 3795: @202446
     /* 202446 */   GIM_Try, /*On fail goto*//*Label 3796*/ GIMT_Encode4(202483), // Rule ID 2642 //
     /* 202451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 202465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 202468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202472 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (CNTP_XPP_H:{ *:[i64] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 202472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_H),
     /* 202475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202481 */     GIR_RootConstrainSelectedInstOperands,
     /* 202482 */     // GIR_Coverage, 2642,
     /* 202482 */     GIR_EraseRootFromParent_Done,
     /* 202483 */   // Label 3796: @202483
     /* 202483 */   GIM_Try, /*On fail goto*//*Label 3797*/ GIMT_Encode4(202520), // Rule ID 2643 //
     /* 202488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202491 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202496 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 202502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 202505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202509 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (CNTP_XPP_S:{ *:[i64] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 202509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_S),
     /* 202512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202518 */     GIR_RootConstrainSelectedInstOperands,
     /* 202519 */     // GIR_Coverage, 2643,
     /* 202519 */     GIR_EraseRootFromParent_Done,
     /* 202520 */   // Label 3797: @202520
     /* 202520 */   GIM_Try, /*On fail goto*//*Label 3798*/ GIMT_Encode4(202557), // Rule ID 2644 //
     /* 202525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 202528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cntp),
     /* 202533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 202536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 202539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 202542 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 202546 */     // (intrinsic_wo_chain:{ *:[i64] } 1342:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (CNTP_XPP_D:{ *:[i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 202546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNTP_XPP_D),
     /* 202549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 202551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202555 */     GIR_RootConstrainSelectedInstOperands,
     /* 202556 */     // GIR_Coverage, 2644,
     /* 202556 */     GIR_EraseRootFromParent_Done,
     /* 202557 */   // Label 3798: @202557
     /* 202557 */   GIM_Try, /*On fail goto*//*Label 3799*/ GIMT_Encode4(202594), // Rule ID 2822 //
     /* 202562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202565 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202570 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202579 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202583 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1550:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_H),
     /* 202586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202588 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202590 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202592 */     GIR_RootConstrainSelectedInstOperands,
     /* 202593 */     // GIR_Coverage, 2822,
     /* 202593 */     GIR_EraseRootFromParent_Done,
     /* 202594 */   // Label 3799: @202594
     /* 202594 */   GIM_Try, /*On fail goto*//*Label 3800*/ GIMT_Encode4(202631), // Rule ID 2823 //
     /* 202599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202616 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202620 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1550:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_S),
     /* 202623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202629 */     GIR_RootConstrainSelectedInstOperands,
     /* 202630 */     // GIR_Coverage, 2823,
     /* 202630 */     GIR_EraseRootFromParent_Done,
     /* 202631 */   // Label 3800: @202631
     /* 202631 */   GIM_Try, /*On fail goto*//*Label 3801*/ GIMT_Encode4(202668), // Rule ID 2824 //
     /* 202636 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 202639 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftsmul_x),
     /* 202644 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202647 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202650 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1550:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSMUL_ZZZ_D),
     /* 202660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202666 */     GIR_RootConstrainSelectedInstOperands,
     /* 202667 */     // GIR_Coverage, 2824,
     /* 202667 */     GIR_EraseRootFromParent_Done,
     /* 202668 */   // Label 3801: @202668
     /* 202668 */   GIM_Try, /*On fail goto*//*Label 3802*/ GIMT_Encode4(202705), // Rule ID 2995 //
     /* 202673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202690 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202694 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1802:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_B),
     /* 202697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202703 */     GIR_RootConstrainSelectedInstOperands,
     /* 202704 */     // GIR_Coverage, 2995,
     /* 202704 */     GIR_EraseRootFromParent_Done,
     /* 202705 */   // Label 3802: @202705
     /* 202705 */   GIM_Try, /*On fail goto*//*Label 3803*/ GIMT_Encode4(202742), // Rule ID 2996 //
     /* 202710 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202713 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202718 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202721 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202724 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1802:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_H),
     /* 202734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202740 */     GIR_RootConstrainSelectedInstOperands,
     /* 202741 */     // GIR_Coverage, 2996,
     /* 202741 */     GIR_EraseRootFromParent_Done,
     /* 202742 */   // Label 3803: @202742
     /* 202742 */   GIM_Try, /*On fail goto*//*Label 3804*/ GIMT_Encode4(202779), // Rule ID 2997 //
     /* 202747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202768 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1802:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_S),
     /* 202771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202777 */     GIR_RootConstrainSelectedInstOperands,
     /* 202778 */     // GIR_Coverage, 2997,
     /* 202778 */     GIR_EraseRootFromParent_Done,
     /* 202779 */   // Label 3804: @202779
     /* 202779 */   GIM_Try, /*On fail goto*//*Label 3805*/ GIMT_Encode4(202816), // Rule ID 2998 //
     /* 202784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh),
     /* 202792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202805 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1802:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZ_D),
     /* 202808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202814 */     GIR_RootConstrainSelectedInstOperands,
     /* 202815 */     // GIR_Coverage, 2998,
     /* 202815 */     GIR_EraseRootFromParent_Done,
     /* 202816 */   // Label 3805: @202816
     /* 202816 */   GIM_Try, /*On fail goto*//*Label 3806*/ GIMT_Encode4(202853), // Rule ID 2999 //
     /* 202821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmul),
     /* 202829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 202832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202842 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1637:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMUL_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMUL_ZZZ_B),
     /* 202845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202851 */     GIR_RootConstrainSelectedInstOperands,
     /* 202852 */     // GIR_Coverage, 2999,
     /* 202852 */     GIR_EraseRootFromParent_Done,
     /* 202853 */   // Label 3806: @202853
     /* 202853 */   GIM_Try, /*On fail goto*//*Label 3807*/ GIMT_Encode4(202890), // Rule ID 3021 //
     /* 202858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202866 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 202869 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 202872 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 202875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202879 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1695:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 202879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_H),
     /* 202882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202888 */     GIR_RootConstrainSelectedInstOperands,
     /* 202889 */     // GIR_Coverage, 3021,
     /* 202889 */     GIR_EraseRootFromParent_Done,
     /* 202890 */   // Label 3807: @202890
     /* 202890 */   GIM_Try, /*On fail goto*//*Label 3808*/ GIMT_Encode4(202927), // Rule ID 3022 //
     /* 202895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202898 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202903 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 202906 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 202909 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 202912 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202916 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1695:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 202916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_S),
     /* 202919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202925 */     GIR_RootConstrainSelectedInstOperands,
     /* 202926 */     // GIR_Coverage, 3022,
     /* 202926 */     GIR_EraseRootFromParent_Done,
     /* 202927 */   // Label 3808: @202927
     /* 202927 */   GIM_Try, /*On fail goto*//*Label 3809*/ GIMT_Encode4(202964), // Rule ID 3023 //
     /* 202932 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 202935 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlb),
     /* 202940 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 202946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 202949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202953 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1695:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 202953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLB_ZZZ_D),
     /* 202956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202958 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202960 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202962 */     GIR_RootConstrainSelectedInstOperands,
     /* 202963 */     // GIR_Coverage, 3023,
     /* 202963 */     GIR_EraseRootFromParent_Done,
     /* 202964 */   // Label 3809: @202964
     /* 202964 */   GIM_Try, /*On fail goto*//*Label 3810*/ GIMT_Encode4(203001), // Rule ID 3027 //
     /* 202969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 202972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 202977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 202980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 202983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 202986 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 202990 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1638:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLB_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 202990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_Q),
     /* 202993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 202995 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 202997 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 202999 */     GIR_RootConstrainSelectedInstOperands,
     /* 203000 */     // GIR_Coverage, 3027,
     /* 203000 */     GIR_EraseRootFromParent_Done,
     /* 203001 */   // Label 3810: @203001
     /* 203001 */   GIM_Try, /*On fail goto*//*Label 3811*/ GIMT_Encode4(203038), // Rule ID 3028 //
     /* 203006 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203009 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203014 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203017 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203020 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1638:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLB_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_H),
     /* 203030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203036 */     GIR_RootConstrainSelectedInstOperands,
     /* 203037 */     // GIR_Coverage, 3028,
     /* 203037 */     GIR_EraseRootFromParent_Done,
     /* 203038 */   // Label 3811: @203038
     /* 203038 */   GIM_Try, /*On fail goto*//*Label 3812*/ GIMT_Encode4(203075), // Rule ID 3029 //
     /* 203043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullb_pair),
     /* 203051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203064 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1638:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLB_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLB_ZZZ_D),
     /* 203067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203073 */     GIR_RootConstrainSelectedInstOperands,
     /* 203074 */     // GIR_Coverage, 3029,
     /* 203074 */     GIR_EraseRootFromParent_Done,
     /* 203075 */   // Label 3812: @203075
     /* 203075 */   GIM_Try, /*On fail goto*//*Label 3813*/ GIMT_Encode4(203112), // Rule ID 3030 //
     /* 203080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203083 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203088 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203091 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203094 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203101 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1280:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BEXT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_B),
     /* 203104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203110 */     GIR_RootConstrainSelectedInstOperands,
     /* 203111 */     // GIR_Coverage, 3030,
     /* 203111 */     GIR_EraseRootFromParent_Done,
     /* 203112 */   // Label 3813: @203112
     /* 203112 */   GIM_Try, /*On fail goto*//*Label 3814*/ GIMT_Encode4(203149), // Rule ID 3031 //
     /* 203117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203138 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1280:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BEXT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_H),
     /* 203141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203147 */     GIR_RootConstrainSelectedInstOperands,
     /* 203148 */     // GIR_Coverage, 3031,
     /* 203148 */     GIR_EraseRootFromParent_Done,
     /* 203149 */   // Label 3814: @203149
     /* 203149 */   GIM_Try, /*On fail goto*//*Label 3815*/ GIMT_Encode4(203186), // Rule ID 3032 //
     /* 203154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203175 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1280:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BEXT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_S),
     /* 203178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203184 */     GIR_RootConstrainSelectedInstOperands,
     /* 203185 */     // GIR_Coverage, 3032,
     /* 203185 */     GIR_EraseRootFromParent_Done,
     /* 203186 */   // Label 3815: @203186
     /* 203186 */   GIM_Try, /*On fail goto*//*Label 3816*/ GIMT_Encode4(203223), // Rule ID 3033 //
     /* 203191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 203194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bext_x),
     /* 203199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203212 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1280:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BEXT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BEXT_ZZZ_D),
     /* 203215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203221 */     GIR_RootConstrainSelectedInstOperands,
     /* 203222 */     // GIR_Coverage, 3033,
     /* 203222 */     GIR_EraseRootFromParent_Done,
     /* 203223 */   // Label 3816: @203223
     /* 203223 */   GIM_Try, /*On fail goto*//*Label 3817*/ GIMT_Encode4(203260), // Rule ID 3034 //
     /* 203228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 203245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203249 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1696:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 203249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_H),
     /* 203252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203258 */     GIR_RootConstrainSelectedInstOperands,
     /* 203259 */     // GIR_Coverage, 3034,
     /* 203259 */     GIR_EraseRootFromParent_Done,
     /* 203260 */   // Label 3817: @203260
     /* 203260 */   GIM_Try, /*On fail goto*//*Label 3818*/ GIMT_Encode4(203297), // Rule ID 3035 //
     /* 203265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203279 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203286 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1696:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_S),
     /* 203289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203295 */     GIR_RootConstrainSelectedInstOperands,
     /* 203296 */     // GIR_Coverage, 3035,
     /* 203296 */     GIR_EraseRootFromParent_Done,
     /* 203297 */   // Label 3818: @203297
     /* 203297 */   GIM_Try, /*On fail goto*//*Label 3819*/ GIMT_Encode4(203334), // Rule ID 3036 //
     /* 203302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlbt),
     /* 203310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1696:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLBT_ZZZ_D),
     /* 203326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203332 */     GIR_RootConstrainSelectedInstOperands,
     /* 203333 */     // GIR_Coverage, 3036,
     /* 203333 */     GIR_EraseRootFromParent_Done,
     /* 203334 */   // Label 3819: @203334
     /* 203334 */   GIM_Try, /*On fail goto*//*Label 3820*/ GIMT_Encode4(203371), // Rule ID 3083 //
     /* 203339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203360 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1257:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_B),
     /* 203363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203369 */     GIR_RootConstrainSelectedInstOperands,
     /* 203370 */     // GIR_Coverage, 3083,
     /* 203370 */     GIR_EraseRootFromParent_Done,
     /* 203371 */   // Label 3820: @203371
     /* 203371 */   GIM_Try, /*On fail goto*//*Label 3821*/ GIMT_Encode4(203408), // Rule ID 3084 //
     /* 203376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203379 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203384 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203387 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203390 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203397 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1257:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_H),
     /* 203400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203406 */     GIR_RootConstrainSelectedInstOperands,
     /* 203407 */     // GIR_Coverage, 3084,
     /* 203407 */     GIR_EraseRootFromParent_Done,
     /* 203408 */   // Label 3821: @203408
     /* 203408 */   GIM_Try, /*On fail goto*//*Label 3822*/ GIMT_Encode4(203445), // Rule ID 3085 //
     /* 203413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnb),
     /* 203421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 203427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203434 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1257:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNB_ZZZ_S),
     /* 203437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203443 */     GIR_RootConstrainSelectedInstOperands,
     /* 203444 */     // GIR_Coverage, 3085,
     /* 203444 */     GIR_EraseRootFromParent_Done,
     /* 203445 */   // Label 3822: @203445
     /* 203445 */   GIM_Try, /*On fail goto*//*Label 3823*/ GIMT_Encode4(203482), // Rule ID 3092 //
     /* 203450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 203461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 203464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 203467 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203471 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1859:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 203471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_B),
     /* 203474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203476 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203480 */     GIR_RootConstrainSelectedInstOperands,
     /* 203481 */     // GIR_Coverage, 3092,
     /* 203481 */     GIR_EraseRootFromParent_Done,
     /* 203482 */   // Label 3823: @203482
     /* 203482 */   GIM_Try, /*On fail goto*//*Label 3824*/ GIMT_Encode4(203519), // Rule ID 3093 //
     /* 203487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 203498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 203501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203508 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1859:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_H),
     /* 203511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203513 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203515 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203517 */     GIR_RootConstrainSelectedInstOperands,
     /* 203518 */     // GIR_Coverage, 3093,
     /* 203518 */     GIR_EraseRootFromParent_Done,
     /* 203519 */   // Label 3824: @203519
     /* 203519 */   GIM_Try, /*On fail goto*//*Label 3825*/ GIMT_Encode4(203556), // Rule ID 3094 //
     /* 203524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 203527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtnt),
     /* 203532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 203538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203545 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1859:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTNT_ZZ_S),
     /* 203548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203554 */     GIR_RootConstrainSelectedInstOperands,
     /* 203555 */     // GIR_Coverage, 3094,
     /* 203555 */     GIR_EraseRootFromParent_Done,
     /* 203556 */   // Label 3825: @203556
     /* 203556 */   GIM_Try, /*On fail goto*//*Label 3826*/ GIMT_Encode4(203596), // Rule ID 3198 //
     /* 203561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203578 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203582 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203582 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_B),
     /* 203585 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203587 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203589 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203591 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203594 */     GIR_RootConstrainSelectedInstOperands,
     /* 203595 */     // GIR_Coverage, 3198,
     /* 203595 */     GIR_EraseRootFromParent_Done,
     /* 203596 */   // Label 3826: @203596
     /* 203596 */   GIM_Try, /*On fail goto*//*Label 3827*/ GIMT_Encode4(203636), // Rule ID 3199 //
     /* 203601 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203612 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203615 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203618 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203622 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_H),
     /* 203625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203627 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203629 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203631 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203634 */     GIR_RootConstrainSelectedInstOperands,
     /* 203635 */     // GIR_Coverage, 3199,
     /* 203635 */     GIR_EraseRootFromParent_Done,
     /* 203636 */   // Label 3827: @203636
     /* 203636 */   GIM_Try, /*On fail goto*//*Label 3828*/ GIMT_Encode4(203676), // Rule ID 3200 //
     /* 203641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203662 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_S),
     /* 203665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203667 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203671 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203674 */     GIR_RootConstrainSelectedInstOperands,
     /* 203675 */     // GIR_Coverage, 3200,
     /* 203675 */     GIR_EraseRootFromParent_Done,
     /* 203676 */   // Label 3828: @203676
     /* 203676 */   GIM_Try, /*On fail goto*//*Label 3829*/ GIMT_Encode4(203716), // Rule ID 3201 //
     /* 203681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 203695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 203698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203702 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 203702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PWW_D),
     /* 203705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203711 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203714 */     GIR_RootConstrainSelectedInstOperands,
     /* 203715 */     // GIR_Coverage, 3201,
     /* 203715 */     GIR_EraseRootFromParent_Done,
     /* 203716 */   // Label 3829: @203716
     /* 203716 */   GIM_Try, /*On fail goto*//*Label 3830*/ GIMT_Encode4(203756), // Rule ID 3206 //
     /* 203721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 203732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203738 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203742 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_B),
     /* 203745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203747 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203749 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203751 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203754 */     GIR_RootConstrainSelectedInstOperands,
     /* 203755 */     // GIR_Coverage, 3206,
     /* 203755 */     GIR_EraseRootFromParent_Done,
     /* 203756 */   // Label 3830: @203756
     /* 203756 */   GIM_Try, /*On fail goto*//*Label 3831*/ GIMT_Encode4(203796), // Rule ID 3207 //
     /* 203761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 203772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203775 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203778 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203782 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_H),
     /* 203785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203787 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203789 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203791 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203794 */     GIR_RootConstrainSelectedInstOperands,
     /* 203795 */     // GIR_Coverage, 3207,
     /* 203795 */     GIR_EraseRootFromParent_Done,
     /* 203796 */   // Label 3831: @203796
     /* 203796 */   GIM_Try, /*On fail goto*//*Label 3832*/ GIMT_Encode4(203836), // Rule ID 3208 //
     /* 203801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 203812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203822 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_S),
     /* 203825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203831 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203834 */     GIR_RootConstrainSelectedInstOperands,
     /* 203835 */     // GIR_Coverage, 3208,
     /* 203835 */     GIR_EraseRootFromParent_Done,
     /* 203836 */   // Label 3832: @203836
     /* 203836 */   GIM_Try, /*On fail goto*//*Label 3833*/ GIMT_Encode4(203876), // Rule ID 3209 //
     /* 203841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 203844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilelt),
     /* 203849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 203852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 203855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 203858 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 203862 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2139:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 203862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELT_PXX_D),
     /* 203865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 203867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203871 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 203874 */     GIR_RootConstrainSelectedInstOperands,
     /* 203875 */     // GIR_Coverage, 3209,
     /* 203875 */     GIR_EraseRootFromParent_Done,
     /* 203876 */   // Label 3833: @203876
     /* 203876 */   GIM_Try, /*On fail goto*//*Label 3834*/ GIMT_Encode4(203913), // Rule ID 3398 //
     /* 203881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203898 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203902 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 203902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203911 */     GIR_RootConstrainSelectedInstOperands,
     /* 203912 */     // GIR_Coverage, 3398,
     /* 203912 */     GIR_EraseRootFromParent_Done,
     /* 203913 */   // Label 3834: @203913
     /* 203913 */   GIM_Try, /*On fail goto*//*Label 3835*/ GIMT_Encode4(203950), // Rule ID 3399 //
     /* 203918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203926 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 203929 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 203932 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 203935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203939 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1348:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (COMPACT_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 203939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_S),
     /* 203942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203948 */     GIR_RootConstrainSelectedInstOperands,
     /* 203949 */     // GIR_Coverage, 3399,
     /* 203949 */     GIR_EraseRootFromParent_Done,
     /* 203950 */   // Label 3835: @203950
     /* 203950 */   GIM_Try, /*On fail goto*//*Label 3836*/ GIMT_Encode4(203987), // Rule ID 3400 //
     /* 203955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 203963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 203966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 203969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 203972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 203976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 203976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 203979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 203981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 203983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 203985 */     GIR_RootConstrainSelectedInstOperands,
     /* 203986 */     // GIR_Coverage, 3400,
     /* 203986 */     GIR_EraseRootFromParent_Done,
     /* 203987 */   // Label 3836: @203987
     /* 203987 */   GIM_Try, /*On fail goto*//*Label 3837*/ GIMT_Encode4(204024), // Rule ID 3401 //
     /* 203992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE_or_SME2p2),
     /* 203995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_compact),
     /* 204000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1348:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (COMPACT_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::COMPACT_ZPZ_D),
     /* 204016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204022 */     GIR_RootConstrainSelectedInstOperands,
     /* 204023 */     // GIR_Coverage, 3401,
     /* 204023 */     GIR_EraseRootFromParent_Done,
     /* 204024 */   // Label 3837: @204024
     /* 204024 */   GIM_Try, /*On fail goto*//*Label 3838*/ GIMT_Encode4(204061), // Rule ID 3423 //
     /* 204029 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204040 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204043 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204046 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204050 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1551:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (FTSSEL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_H),
     /* 204053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204059 */     GIR_RootConstrainSelectedInstOperands,
     /* 204060 */     // GIR_Coverage, 3423,
     /* 204060 */     GIR_EraseRootFromParent_Done,
     /* 204061 */   // Label 3838: @204061
     /* 204061 */   GIM_Try, /*On fail goto*//*Label 3839*/ GIMT_Encode4(204098), // Rule ID 3424 //
     /* 204066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204083 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204087 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1551:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (FTSSEL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_S),
     /* 204090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204096 */     GIR_RootConstrainSelectedInstOperands,
     /* 204097 */     // GIR_Coverage, 3424,
     /* 204097 */     GIR_EraseRootFromParent_Done,
     /* 204098 */   // Label 3839: @204098
     /* 204098 */   GIM_Try, /*On fail goto*//*Label 3840*/ GIMT_Encode4(204135), // Rule ID 3425 //
     /* 204103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 204106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftssel_x),
     /* 204111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204124 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1551:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (FTSSEL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTSSEL_ZZZ_D),
     /* 204127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204133 */     GIR_RootConstrainSelectedInstOperands,
     /* 204134 */     // GIR_Coverage, 3425,
     /* 204134 */     GIR_EraseRootFromParent_Done,
     /* 204135 */   // Label 3840: @204135
     /* 204135 */   GIM_Try, /*On fail goto*//*Label 3841*/ GIMT_Encode4(204172), // Rule ID 3447 //
     /* 204140 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 204143 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka_z),
     /* 204148 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 204151 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204154 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 204157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 204161 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1301:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKA_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 204161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPzP),
     /* 204164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 204166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204170 */     GIR_RootConstrainSelectedInstOperands,
     /* 204171 */     // GIR_Coverage, 3447,
     /* 204171 */     GIR_EraseRootFromParent_Done,
     /* 204172 */   // Label 3841: @204172
     /* 204172 */   GIM_Try, /*On fail goto*//*Label 3842*/ GIMT_Encode4(204209), // Rule ID 3452 //
     /* 204177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SM4),
     /* 204180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sm4ekey),
     /* 204185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204194 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204198 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1731:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SM4EKEY_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM4EKEY_ZZZ_S),
     /* 204201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204207 */     GIR_RootConstrainSelectedInstOperands,
     /* 204208 */     // GIR_Coverage, 3452,
     /* 204208 */     GIR_EraseRootFromParent_Done,
     /* 204209 */   // Label 3842: @204209
     /* 204209 */   GIM_Try, /*On fail goto*//*Label 3843*/ GIMT_Encode4(204246), // Rule ID 3461 //
     /* 204214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204225 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204228 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204235 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2161:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204244 */     GIR_RootConstrainSelectedInstOperands,
     /* 204245 */     // GIR_Coverage, 3461,
     /* 204245 */     GIR_EraseRootFromParent_Done,
     /* 204246 */   // Label 3843: @204246
     /* 204246 */   GIM_Try, /*On fail goto*//*Label 3844*/ GIMT_Encode4(204283), // Rule ID 3462 //
     /* 204251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204268 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204272 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2161:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204272 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204275 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204281 */     GIR_RootConstrainSelectedInstOperands,
     /* 204282 */     // GIR_Coverage, 3462,
     /* 204282 */     GIR_EraseRootFromParent_Done,
     /* 204283 */   // Label 3844: @204283
     /* 204283 */   GIM_Try, /*On fail goto*//*Label 3845*/ GIMT_Encode4(204320), // Rule ID 3463 //
     /* 204288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204291 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204296 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204299 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204302 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204309 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2161:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204318 */     GIR_RootConstrainSelectedInstOperands,
     /* 204319 */     // GIR_Coverage, 3463,
     /* 204319 */     GIR_EraseRootFromParent_Done,
     /* 204320 */   // Label 3845: @204320
     /* 204320 */   GIM_Try, /*On fail goto*//*Label 3846*/ GIMT_Encode4(204357), // Rule ID 3464 //
     /* 204325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204346 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2161:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204351 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204353 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204355 */     GIR_RootConstrainSelectedInstOperands,
     /* 204356 */     // GIR_Coverage, 3464,
     /* 204356 */     GIR_EraseRootFromParent_Done,
     /* 204357 */   // Label 3846: @204357
     /* 204357 */   GIM_Try, /*On fail goto*//*Label 3847*/ GIMT_Encode4(204394), // Rule ID 3465 //
     /* 204362 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204365 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204370 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204373 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204376 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204383 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2161:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204392 */     GIR_RootConstrainSelectedInstOperands,
     /* 204393 */     // GIR_Coverage, 3465,
     /* 204393 */     GIR_EraseRootFromParent_Done,
     /* 204394 */   // Label 3847: @204394
     /* 204394 */   GIM_Try, /*On fail goto*//*Label 3848*/ GIMT_Encode4(204431), // Rule ID 3466 //
     /* 204399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204420 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2161:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204420 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204423 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204425 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204427 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204429 */     GIR_RootConstrainSelectedInstOperands,
     /* 204430 */     // GIR_Coverage, 3466,
     /* 204430 */     GIR_EraseRootFromParent_Done,
     /* 204431 */   // Label 3848: @204431
     /* 204431 */   GIM_Try, /*On fail goto*//*Label 3849*/ GIMT_Encode4(204468), // Rule ID 3467 //
     /* 204436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 204439 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip1q),
     /* 204444 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204457 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2161:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_Q),
     /* 204460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204464 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204466 */     GIR_RootConstrainSelectedInstOperands,
     /* 204467 */     // GIR_Coverage, 3467,
     /* 204467 */     GIR_EraseRootFromParent_Done,
     /* 204468 */   // Label 3849: @204468
     /* 204468 */   GIM_Try, /*On fail goto*//*Label 3850*/ GIMT_Encode4(204505), // Rule ID 3522 //
     /* 204473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204494 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1374:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADDQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_H),
     /* 204497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204503 */     GIR_RootConstrainSelectedInstOperands,
     /* 204504 */     // GIR_Coverage, 3522,
     /* 204504 */     GIR_EraseRootFromParent_Done,
     /* 204505 */   // Label 3850: @204505
     /* 204505 */   GIM_Try, /*On fail goto*//*Label 3851*/ GIMT_Encode4(204542), // Rule ID 3523 //
     /* 204510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204513 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204518 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204521 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204524 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204531 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1374:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADDQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_S),
     /* 204534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204540 */     GIR_RootConstrainSelectedInstOperands,
     /* 204541 */     // GIR_Coverage, 3523,
     /* 204541 */     GIR_EraseRootFromParent_Done,
     /* 204542 */   // Label 3851: @204542
     /* 204542 */   GIM_Try, /*On fail goto*//*Label 3852*/ GIMT_Encode4(204579), // Rule ID 3524 //
     /* 204547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddqv),
     /* 204555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204568 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1374:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADDQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDQV_D),
     /* 204571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204577 */     GIR_RootConstrainSelectedInstOperands,
     /* 204578 */     // GIR_Coverage, 3524,
     /* 204578 */     GIR_EraseRootFromParent_Done,
     /* 204579 */   // Label 3852: @204579
     /* 204579 */   GIM_Try, /*On fail goto*//*Label 3853*/ GIMT_Encode4(204616), // Rule ID 3554 //
     /* 204584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 204595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 204598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204605 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1625:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_B),
     /* 204608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204614 */     GIR_RootConstrainSelectedInstOperands,
     /* 204615 */     // GIR_Coverage, 3554,
     /* 204615 */     GIR_EraseRootFromParent_Done,
     /* 204616 */   // Label 3853: @204616
     /* 204616 */   GIM_Try, /*On fail goto*//*Label 3854*/ GIMT_Encode4(204653), // Rule ID 3555 //
     /* 204621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 204632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 204635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204642 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1625:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_H),
     /* 204645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204651 */     GIR_RootConstrainSelectedInstOperands,
     /* 204652 */     // GIR_Coverage, 3555,
     /* 204652 */     GIR_EraseRootFromParent_Done,
     /* 204653 */   // Label 3854: @204653
     /* 204653 */   GIM_Try, /*On fail goto*//*Label 3855*/ GIMT_Encode4(204690), // Rule ID 3556 //
     /* 204658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204666 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 204669 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 204672 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204679 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1625:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_S),
     /* 204682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204688 */     GIR_RootConstrainSelectedInstOperands,
     /* 204689 */     // GIR_Coverage, 3556,
     /* 204689 */     GIR_EraseRootFromParent_Done,
     /* 204690 */   // Label 3855: @204690
     /* 204690 */   GIM_Try, /*On fail goto*//*Label 3856*/ GIMT_Encode4(204727), // Rule ID 3557 //
     /* 204695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orqv),
     /* 204703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 204706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 204709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 204716 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1625:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORQV_VPZ_D),
     /* 204719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 204721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204725 */     GIR_RootConstrainSelectedInstOperands,
     /* 204726 */     // GIR_Coverage, 3557,
     /* 204726 */     GIR_EraseRootFromParent_Done,
     /* 204727 */   // Label 3856: @204727
     /* 204727 */   GIM_Try, /*On fail goto*//*Label 3857*/ GIMT_Encode4(204764), // Rule ID 3558 //
     /* 204732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 204743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 204746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 204749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204753 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2169:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 204753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_B),
     /* 204756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204762 */     GIR_RootConstrainSelectedInstOperands,
     /* 204763 */     // GIR_Coverage, 3558,
     /* 204763 */     GIR_EraseRootFromParent_Done,
     /* 204764 */   // Label 3857: @204764
     /* 204764 */   GIM_Try, /*On fail goto*//*Label 3858*/ GIMT_Encode4(204801), // Rule ID 3559 //
     /* 204769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204790 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2169:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 204790 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 204793 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204795 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204799 */     GIR_RootConstrainSelectedInstOperands,
     /* 204800 */     // GIR_Coverage, 3559,
     /* 204800 */     GIR_EraseRootFromParent_Done,
     /* 204801 */   // Label 3858: @204801
     /* 204801 */   GIM_Try, /*On fail goto*//*Label 3859*/ GIMT_Encode4(204838), // Rule ID 3560 //
     /* 204806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204827 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2169:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 204827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 204830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204836 */     GIR_RootConstrainSelectedInstOperands,
     /* 204837 */     // GIR_Coverage, 3560,
     /* 204837 */     GIR_EraseRootFromParent_Done,
     /* 204838 */   // Label 3859: @204838
     /* 204838 */   GIM_Try, /*On fail goto*//*Label 3860*/ GIMT_Encode4(204875), // Rule ID 3561 //
     /* 204843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204860 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204864 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2169:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 204864 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 204867 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204869 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204873 */     GIR_RootConstrainSelectedInstOperands,
     /* 204874 */     // GIR_Coverage, 3561,
     /* 204874 */     GIR_EraseRootFromParent_Done,
     /* 204875 */   // Label 3860: @204875
     /* 204875 */   GIM_Try, /*On fail goto*//*Label 3861*/ GIMT_Encode4(204912), // Rule ID 3562 //
     /* 204880 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204883 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204888 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 204891 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 204894 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 204897 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204901 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2169:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 204901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_H),
     /* 204904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204910 */     GIR_RootConstrainSelectedInstOperands,
     /* 204911 */     // GIR_Coverage, 3562,
     /* 204911 */     GIR_EraseRootFromParent_Done,
     /* 204912 */   // Label 3861: @204912
     /* 204912 */   GIM_Try, /*On fail goto*//*Label 3862*/ GIMT_Encode4(204949), // Rule ID 3563 //
     /* 204917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 204928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 204931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 204934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204938 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2169:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 204938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_S),
     /* 204941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204943 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204945 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204947 */     GIR_RootConstrainSelectedInstOperands,
     /* 204948 */     // GIR_Coverage, 3563,
     /* 204948 */     GIR_EraseRootFromParent_Done,
     /* 204949 */   // Label 3862: @204949
     /* 204949 */   GIM_Try, /*On fail goto*//*Label 3863*/ GIMT_Encode4(204986), // Rule ID 3564 //
     /* 204954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq1),
     /* 204962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 204965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 204968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 204971 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 204975 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2169:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 204975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ1_ZZZ_D),
     /* 204978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 204980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 204982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 204984 */     GIR_RootConstrainSelectedInstOperands,
     /* 204985 */     // GIR_Coverage, 3564,
     /* 204985 */     GIR_EraseRootFromParent_Done,
     /* 204986 */   // Label 3863: @204986
     /* 204986 */   GIM_Try, /*On fail goto*//*Label 3864*/ GIMT_Encode4(205023), // Rule ID 3565 //
     /* 204991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 204994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 204999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 205002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 205005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 205008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205012 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1924:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TBLQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 205012 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_B),
     /* 205015 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205017 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205019 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205021 */     GIR_RootConstrainSelectedInstOperands,
     /* 205022 */     // GIR_Coverage, 3565,
     /* 205022 */     GIR_EraseRootFromParent_Done,
     /* 205023 */   // Label 3864: @205023
     /* 205023 */   GIM_Try, /*On fail goto*//*Label 3865*/ GIMT_Encode4(205060), // Rule ID 3566 //
     /* 205028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1924:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205058 */     GIR_RootConstrainSelectedInstOperands,
     /* 205059 */     // GIR_Coverage, 3566,
     /* 205059 */     GIR_EraseRootFromParent_Done,
     /* 205060 */   // Label 3865: @205060
     /* 205060 */   GIM_Try, /*On fail goto*//*Label 3866*/ GIMT_Encode4(205097), // Rule ID 3567 //
     /* 205065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205082 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205086 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1924:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205093 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205095 */     GIR_RootConstrainSelectedInstOperands,
     /* 205096 */     // GIR_Coverage, 3567,
     /* 205096 */     GIR_EraseRootFromParent_Done,
     /* 205097 */   // Label 3866: @205097
     /* 205097 */   GIM_Try, /*On fail goto*//*Label 3867*/ GIMT_Encode4(205134), // Rule ID 3568 //
     /* 205102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205105 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205110 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205113 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205116 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205123 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1924:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205132 */     GIR_RootConstrainSelectedInstOperands,
     /* 205133 */     // GIR_Coverage, 3568,
     /* 205133 */     GIR_EraseRootFromParent_Done,
     /* 205134 */   // Label 3867: @205134
     /* 205134 */   GIM_Try, /*On fail goto*//*Label 3868*/ GIMT_Encode4(205171), // Rule ID 3569 //
     /* 205139 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205142 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205147 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 205150 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 205153 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 205156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205160 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1924:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TBLQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 205160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_H),
     /* 205163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205165 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205169 */     GIR_RootConstrainSelectedInstOperands,
     /* 205170 */     // GIR_Coverage, 3569,
     /* 205170 */     GIR_EraseRootFromParent_Done,
     /* 205171 */   // Label 3868: @205171
     /* 205171 */   GIM_Try, /*On fail goto*//*Label 3869*/ GIMT_Encode4(205208), // Rule ID 3570 //
     /* 205176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205197 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1924:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TBLQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_S),
     /* 205200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205206 */     GIR_RootConstrainSelectedInstOperands,
     /* 205207 */     // GIR_Coverage, 3570,
     /* 205207 */     GIR_EraseRootFromParent_Done,
     /* 205208 */   // Label 3869: @205208
     /* 205208 */   GIM_Try, /*On fail goto*//*Label 3870*/ GIMT_Encode4(205245), // Rule ID 3571 //
     /* 205213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 205216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tblq),
     /* 205221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205230 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205234 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1924:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TBLQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBLQ_ZZZ_D),
     /* 205237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205243 */     GIR_RootConstrainSelectedInstOperands,
     /* 205244 */     // GIR_Coverage, 3571,
     /* 205244 */     GIR_EraseRootFromParent_Done,
     /* 205245 */   // Label 3870: @205245
     /* 205245 */   GIM_Try, /*On fail goto*//*Label 3871*/ GIMT_Encode4(205282), // Rule ID 8458 //
     /* 205250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb_z),
     /* 205258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 205264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 205267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205271 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1303:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2)  =>  (BRKB_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2)
     /* 205271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPzP),
     /* 205274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205280 */     GIR_RootConstrainSelectedInstOperands,
     /* 205281 */     // GIR_Coverage, 8458,
     /* 205281 */     GIR_EraseRootFromParent_Done,
     /* 205282 */   // Label 3871: @205282
     /* 205282 */   GIM_Try, /*On fail goto*//*Label 3872*/ GIMT_Encode4(205319), // Rule ID 8934 //
     /* 205287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205304 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205308 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1261:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_0:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_0),
     /* 205311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205317 */     GIR_RootConstrainSelectedInstOperands,
     /* 205318 */     // GIR_Coverage, 8934,
     /* 205318 */     GIR_EraseRootFromParent_Done,
     /* 205319 */   // Label 3872: @205319
     /* 205319 */   GIM_Try, /*On fail goto*//*Label 3873*/ GIMT_Encode4(205356), // Rule ID 8935 //
     /* 205324 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205327 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205332 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205335 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205338 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205341 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205345 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1263:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_1:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205345 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_1),
     /* 205348 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205350 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205354 */     GIR_RootConstrainSelectedInstOperands,
     /* 205355 */     // GIR_Coverage, 8935,
     /* 205355 */     GIR_EraseRootFromParent_Done,
     /* 205356 */   // Label 3873: @205356
     /* 205356 */   GIM_Try, /*On fail goto*//*Label 3874*/ GIMT_Encode4(205393), // Rule ID 8936 //
     /* 205361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205378 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205382 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1264:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_2:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205382 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_2),
     /* 205385 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205387 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205389 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205391 */     GIR_RootConstrainSelectedInstOperands,
     /* 205392 */     // GIR_Coverage, 8936,
     /* 205392 */     GIR_EraseRootFromParent_Done,
     /* 205393 */   // Label 3874: @205393
     /* 205393 */   GIM_Try, /*On fail goto*//*Label 3875*/ GIMT_Encode4(205430), // Rule ID 8937 //
     /* 205398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205406 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 205409 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 205412 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 205415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205419 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1262:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADR_LSL_ZZZ_S_3:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 205419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_S_3),
     /* 205422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205428 */     GIR_RootConstrainSelectedInstOperands,
     /* 205429 */     // GIR_Coverage, 8937,
     /* 205429 */     GIR_EraseRootFromParent_Done,
     /* 205430 */   // Label 3875: @205430
     /* 205430 */   GIM_Try, /*On fail goto*//*Label 3876*/ GIMT_Encode4(205467), // Rule ID 8938 //
     /* 205435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrb),
     /* 205443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205456 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1261:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_0:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_0),
     /* 205459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205461 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205465 */     GIR_RootConstrainSelectedInstOperands,
     /* 205466 */     // GIR_Coverage, 8938,
     /* 205466 */     GIR_EraseRootFromParent_Done,
     /* 205467 */   // Label 3876: @205467
     /* 205467 */   GIM_Try, /*On fail goto*//*Label 3877*/ GIMT_Encode4(205504), // Rule ID 8939 //
     /* 205472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrh),
     /* 205480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205493 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1263:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_1:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_1),
     /* 205496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205502 */     GIR_RootConstrainSelectedInstOperands,
     /* 205503 */     // GIR_Coverage, 8939,
     /* 205503 */     GIR_EraseRootFromParent_Done,
     /* 205504 */   // Label 3877: @205504
     /* 205504 */   GIM_Try, /*On fail goto*//*Label 3878*/ GIMT_Encode4(205541), // Rule ID 8940 //
     /* 205509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205512 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrw),
     /* 205517 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205530 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1264:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_2:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_2),
     /* 205533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205539 */     GIR_RootConstrainSelectedInstOperands,
     /* 205540 */     // GIR_Coverage, 8940,
     /* 205540 */     GIR_EraseRootFromParent_Done,
     /* 205541 */   // Label 3878: @205541
     /* 205541 */   GIM_Try, /*On fail goto*//*Label 3879*/ GIMT_Encode4(205578), // Rule ID 8941 //
     /* 205546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 205549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adrd),
     /* 205554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 205557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 205560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 205563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 205567 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1262:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADR_LSL_ZZZ_D_3:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 205567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADR_LSL_ZZZ_D_3),
     /* 205570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 205572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205576 */     GIR_RootConstrainSelectedInstOperands,
     /* 205577 */     // GIR_Coverage, 8941,
     /* 205577 */     GIR_EraseRootFromParent_Done,
     /* 205578 */   // Label 3879: @205578
     /* 205578 */   GIM_Try, /*On fail goto*//*Label 3880*/ GIMT_Encode4(205618), // Rule ID 9941 //
     /* 205583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205586 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205591 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205594 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205597 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205600 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205604 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_B),
     /* 205607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205611 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205613 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205616 */     GIR_RootConstrainSelectedInstOperands,
     /* 205617 */     // GIR_Coverage, 9941,
     /* 205617 */     GIR_EraseRootFromParent_Done,
     /* 205618 */   // Label 3880: @205618
     /* 205618 */   GIM_Try, /*On fail goto*//*Label 3881*/ GIMT_Encode4(205658), // Rule ID 9942 //
     /* 205623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205644 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_H),
     /* 205647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205651 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205653 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205656 */     GIR_RootConstrainSelectedInstOperands,
     /* 205657 */     // GIR_Coverage, 9942,
     /* 205657 */     GIR_EraseRootFromParent_Done,
     /* 205658 */   // Label 3881: @205658
     /* 205658 */   GIM_Try, /*On fail goto*//*Label 3882*/ GIMT_Encode4(205698), // Rule ID 9943 //
     /* 205663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205684 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_S),
     /* 205687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205693 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205696 */     GIR_RootConstrainSelectedInstOperands,
     /* 205697 */     // GIR_Coverage, 9943,
     /* 205697 */     GIR_EraseRootFromParent_Done,
     /* 205698 */   // Label 3882: @205698
     /* 205698 */   GIM_Try, /*On fail goto*//*Label 3883*/ GIMT_Encode4(205738), // Rule ID 9944 //
     /* 205703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205724 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PWW_D),
     /* 205727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205733 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205736 */     GIR_RootConstrainSelectedInstOperands,
     /* 205737 */     // GIR_Coverage, 9944,
     /* 205737 */     GIR_EraseRootFromParent_Done,
     /* 205738 */   // Label 3883: @205738
     /* 205738 */   GIM_Try, /*On fail goto*//*Label 3884*/ GIMT_Encode4(205778), // Rule ID 9953 //
     /* 205743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205746 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205751 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205754 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205757 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205764 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_B),
     /* 205767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205773 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205776 */     GIR_RootConstrainSelectedInstOperands,
     /* 205777 */     // GIR_Coverage, 9953,
     /* 205777 */     GIR_EraseRootFromParent_Done,
     /* 205778 */   // Label 3884: @205778
     /* 205778 */   GIM_Try, /*On fail goto*//*Label 3885*/ GIMT_Encode4(205818), // Rule ID 9954 //
     /* 205783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205800 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205804 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_H),
     /* 205807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205813 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205816 */     GIR_RootConstrainSelectedInstOperands,
     /* 205817 */     // GIR_Coverage, 9954,
     /* 205817 */     GIR_EraseRootFromParent_Done,
     /* 205818 */   // Label 3885: @205818
     /* 205818 */   GIM_Try, /*On fail goto*//*Label 3886*/ GIMT_Encode4(205858), // Rule ID 9955 //
     /* 205823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205844 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_S),
     /* 205847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205849 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205851 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205853 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205856 */     GIR_RootConstrainSelectedInstOperands,
     /* 205857 */     // GIR_Coverage, 9955,
     /* 205857 */     GIR_EraseRootFromParent_Done,
     /* 205858 */   // Label 3886: @205858
     /* 205858 */   GIM_Try, /*On fail goto*//*Label 3887*/ GIMT_Encode4(205898), // Rule ID 9956 //
     /* 205863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 205871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 205874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 205877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 205880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205884 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILELS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 205884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PWW_D),
     /* 205887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205893 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205896 */     GIR_RootConstrainSelectedInstOperands,
     /* 205897 */     // GIR_Coverage, 9956,
     /* 205897 */     GIR_EraseRootFromParent_Done,
     /* 205898 */   // Label 3887: @205898
     /* 205898 */   GIM_Try, /*On fail goto*//*Label 3888*/ GIMT_Encode4(205938), // Rule ID 9957 //
     /* 205903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 205914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205924 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_B),
     /* 205927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205933 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205936 */     GIR_RootConstrainSelectedInstOperands,
     /* 205937 */     // GIR_Coverage, 9957,
     /* 205937 */     GIR_EraseRootFromParent_Done,
     /* 205938 */   // Label 3888: @205938
     /* 205938 */   GIM_Try, /*On fail goto*//*Label 3889*/ GIMT_Encode4(205978), // Rule ID 9958 //
     /* 205943 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205946 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205951 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 205954 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205957 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 205960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 205964 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 205964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_H),
     /* 205967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 205969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 205971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 205973 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 205976 */     GIR_RootConstrainSelectedInstOperands,
     /* 205977 */     // GIR_Coverage, 9958,
     /* 205977 */     GIR_EraseRootFromParent_Done,
     /* 205978 */   // Label 3889: @205978
     /* 205978 */   GIM_Try, /*On fail goto*//*Label 3890*/ GIMT_Encode4(206018), // Rule ID 9959 //
     /* 205983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 205986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 205991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 205994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 205997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206000 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206004 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_S),
     /* 206007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206013 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206016 */     GIR_RootConstrainSelectedInstOperands,
     /* 206017 */     // GIR_Coverage, 9959,
     /* 206017 */     GIR_EraseRootFromParent_Done,
     /* 206018 */   // Label 3890: @206018
     /* 206018 */   GIM_Try, /*On fail goto*//*Label 3891*/ GIMT_Encode4(206058), // Rule ID 9960 //
     /* 206023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilele),
     /* 206031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206044 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2121:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELE_PXX_D),
     /* 206047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206053 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206056 */     GIR_RootConstrainSelectedInstOperands,
     /* 206057 */     // GIR_Coverage, 9960,
     /* 206057 */     GIR_EraseRootFromParent_Done,
     /* 206058 */   // Label 3891: @206058
     /* 206058 */   GIM_Try, /*On fail goto*//*Label 3892*/ GIMT_Encode4(206098), // Rule ID 9969 //
     /* 206063 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206066 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206071 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 206074 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206077 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206080 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206084 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 206087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206093 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206096 */     GIR_RootConstrainSelectedInstOperands,
     /* 206097 */     // GIR_Coverage, 9969,
     /* 206097 */     GIR_EraseRootFromParent_Done,
     /* 206098 */   // Label 3892: @206098
     /* 206098 */   GIM_Try, /*On fail goto*//*Label 3893*/ GIMT_Encode4(206138), // Rule ID 9970 //
     /* 206103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 206114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206124 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 206127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206133 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206136 */     GIR_RootConstrainSelectedInstOperands,
     /* 206137 */     // GIR_Coverage, 9970,
     /* 206137 */     GIR_EraseRootFromParent_Done,
     /* 206138 */   // Label 3893: @206138
     /* 206138 */   GIM_Try, /*On fail goto*//*Label 3894*/ GIMT_Encode4(206178), // Rule ID 9971 //
     /* 206143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 206154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206160 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206164 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 206167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206173 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206176 */     GIR_RootConstrainSelectedInstOperands,
     /* 206177 */     // GIR_Coverage, 9971,
     /* 206177 */     GIR_EraseRootFromParent_Done,
     /* 206178 */   // Label 3894: @206178
     /* 206178 */   GIM_Try, /*On fail goto*//*Label 3895*/ GIMT_Encode4(206218), // Rule ID 9972 //
     /* 206183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilels),
     /* 206191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 206194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 206197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 206200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 206204 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2133:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILELS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 206204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 206207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 206209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206213 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 206216 */     GIR_RootConstrainSelectedInstOperands,
     /* 206217 */     // GIR_Coverage, 9972,
     /* 206217 */     GIR_EraseRootFromParent_Done,
     /* 206218 */   // Label 3895: @206218
     /* 206218 */   GIM_Try, /*On fail goto*//*Label 3896*/ GIMT_Encode4(206255), // Rule ID 10131 //
     /* 206223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206240 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206244 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2031:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQINCP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_H),
     /* 206247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206253 */     GIR_RootConstrainSelectedInstOperands,
     /* 206254 */     // GIR_Coverage, 10131,
     /* 206254 */     GIR_EraseRootFromParent_Done,
     /* 206255 */   // Label 3896: @206255
     /* 206255 */   GIM_Try, /*On fail goto*//*Label 3897*/ GIMT_Encode4(206292), // Rule ID 10132 //
     /* 206260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206274 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206281 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2031:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQINCP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_S),
     /* 206284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206290 */     GIR_RootConstrainSelectedInstOperands,
     /* 206291 */     // GIR_Coverage, 10132,
     /* 206291 */     GIR_EraseRootFromParent_Done,
     /* 206292 */   // Label 3897: @206292
     /* 206292 */   GIM_Try, /*On fail goto*//*Label 3898*/ GIMT_Encode4(206329), // Rule ID 10133 //
     /* 206297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincp),
     /* 206305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206318 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2031:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQINCP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCP_ZP_D),
     /* 206321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206327 */     GIR_RootConstrainSelectedInstOperands,
     /* 206328 */     // GIR_Coverage, 10133,
     /* 206328 */     GIR_EraseRootFromParent_Done,
     /* 206329 */   // Label 3898: @206329
     /* 206329 */   GIM_Try, /*On fail goto*//*Label 3899*/ GIMT_Encode4(206366), // Rule ID 10134 //
     /* 206334 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206337 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206342 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206345 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206348 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206355 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1786:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (SQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_H),
     /* 206358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206360 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206362 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206364 */     GIR_RootConstrainSelectedInstOperands,
     /* 206365 */     // GIR_Coverage, 10134,
     /* 206365 */     GIR_EraseRootFromParent_Done,
     /* 206366 */   // Label 3899: @206366
     /* 206366 */   GIM_Try, /*On fail goto*//*Label 3900*/ GIMT_Encode4(206403), // Rule ID 10135 //
     /* 206371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206392 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1786:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (SQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_S),
     /* 206395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206397 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206399 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206401 */     GIR_RootConstrainSelectedInstOperands,
     /* 206402 */     // GIR_Coverage, 10135,
     /* 206402 */     GIR_EraseRootFromParent_Done,
     /* 206403 */   // Label 3900: @206403
     /* 206403 */   GIM_Try, /*On fail goto*//*Label 3901*/ GIMT_Encode4(206440), // Rule ID 10136 //
     /* 206408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206411 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecp),
     /* 206416 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206419 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206422 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206429 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1786:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (SQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECP_ZP_D),
     /* 206432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206434 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206436 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206438 */     GIR_RootConstrainSelectedInstOperands,
     /* 206439 */     // GIR_Coverage, 10136,
     /* 206439 */     GIR_EraseRootFromParent_Done,
     /* 206440 */   // Label 3901: @206440
     /* 206440 */   GIM_Try, /*On fail goto*//*Label 3902*/ GIMT_Encode4(206477), // Rule ID 10137 //
     /* 206445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 206462 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206466 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2017:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UQDECP_ZP_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 206466 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_H),
     /* 206469 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206471 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206473 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206475 */     GIR_RootConstrainSelectedInstOperands,
     /* 206476 */     // GIR_Coverage, 10137,
     /* 206476 */     GIR_EraseRootFromParent_Done,
     /* 206477 */   // Label 3902: @206477
     /* 206477 */   GIM_Try, /*On fail goto*//*Label 3903*/ GIMT_Encode4(206514), // Rule ID 10138 //
     /* 206482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206485 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206490 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 206499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206503 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2017:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UQDECP_ZP_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 206503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_S),
     /* 206506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206512 */     GIR_RootConstrainSelectedInstOperands,
     /* 206513 */     // GIR_Coverage, 10138,
     /* 206513 */     GIR_EraseRootFromParent_Done,
     /* 206514 */   // Label 3903: @206514
     /* 206514 */   GIM_Try, /*On fail goto*//*Label 3904*/ GIMT_Encode4(206551), // Rule ID 10139 //
     /* 206519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 206522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecp),
     /* 206527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 206536 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206540 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2017:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UQDECP_ZP_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 206540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECP_ZP_D),
     /* 206543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 206545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206549 */     GIR_RootConstrainSelectedInstOperands,
     /* 206550 */     // GIR_Coverage, 10139,
     /* 206550 */     GIR_EraseRootFromParent_Done,
     /* 206551 */   // Label 3904: @206551
     /* 206551 */   GIM_Try, /*On fail goto*//*Label 3905*/ GIMT_Encode4(206588), // Rule ID 11327 //
     /* 206556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206559 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206564 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206567 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206570 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2166:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206586 */     GIR_RootConstrainSelectedInstOperands,
     /* 206587 */     // GIR_Coverage, 11327,
     /* 206587 */     GIR_EraseRootFromParent_Done,
     /* 206588 */   // Label 3905: @206588
     /* 206588 */   GIM_Try, /*On fail goto*//*Label 3906*/ GIMT_Encode4(206625), // Rule ID 11328 //
     /* 206593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206607 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206610 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206614 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2166:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206623 */     GIR_RootConstrainSelectedInstOperands,
     /* 206624 */     // GIR_Coverage, 11328,
     /* 206624 */     GIR_EraseRootFromParent_Done,
     /* 206625 */   // Label 3906: @206625
     /* 206625 */   GIM_Try, /*On fail goto*//*Label 3907*/ GIMT_Encode4(206662), // Rule ID 11329 //
     /* 206630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206633 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206638 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206641 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206644 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206651 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2166:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206660 */     GIR_RootConstrainSelectedInstOperands,
     /* 206661 */     // GIR_Coverage, 11329,
     /* 206661 */     GIR_EraseRootFromParent_Done,
     /* 206662 */   // Label 3907: @206662
     /* 206662 */   GIM_Try, /*On fail goto*//*Label 3908*/ GIMT_Encode4(206699), // Rule ID 11330 //
     /* 206667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206670 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206675 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206678 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206681 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206688 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2166:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206688 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206691 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206693 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206697 */     GIR_RootConstrainSelectedInstOperands,
     /* 206698 */     // GIR_Coverage, 11330,
     /* 206698 */     GIR_EraseRootFromParent_Done,
     /* 206699 */   // Label 3908: @206699
     /* 206699 */   GIM_Try, /*On fail goto*//*Label 3909*/ GIMT_Encode4(206736), // Rule ID 11331 //
     /* 206704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206721 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206725 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2166:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206734 */     GIR_RootConstrainSelectedInstOperands,
     /* 206735 */     // GIR_Coverage, 11331,
     /* 206735 */     GIR_EraseRootFromParent_Done,
     /* 206736 */   // Label 3909: @206736
     /* 206736 */   GIM_Try, /*On fail goto*//*Label 3910*/ GIMT_Encode4(206773), // Rule ID 11332 //
     /* 206741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206762 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2166:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 206762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206771 */     GIR_RootConstrainSelectedInstOperands,
     /* 206772 */     // GIR_Coverage, 11332,
     /* 206772 */     GIR_EraseRootFromParent_Done,
     /* 206773 */   // Label 3910: @206773
     /* 206773 */   GIM_Try, /*On fail goto*//*Label 3911*/ GIMT_Encode4(206810), // Rule ID 11333 //
     /* 206778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zip2q),
     /* 206786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 206789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 206792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 206795 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206799 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2166:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 206799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_Q),
     /* 206802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206806 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206808 */     GIR_RootConstrainSelectedInstOperands,
     /* 206809 */     // GIR_Coverage, 11333,
     /* 206809 */     GIR_EraseRootFromParent_Done,
     /* 206810 */   // Label 3911: @206810
     /* 206810 */   GIM_Try, /*On fail goto*//*Label 3912*/ GIMT_Encode4(206847), // Rule ID 11334 //
     /* 206815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 206826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 206829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 206832 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206836 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2087:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 206836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206843 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206845 */     GIR_RootConstrainSelectedInstOperands,
     /* 206846 */     // GIR_Coverage, 11334,
     /* 206846 */     GIR_EraseRootFromParent_Done,
     /* 206847 */   // Label 3912: @206847
     /* 206847 */   GIM_Try, /*On fail goto*//*Label 3913*/ GIMT_Encode4(206884), // Rule ID 11335 //
     /* 206852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206855 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206860 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206863 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206866 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2087:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 206873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206882 */     GIR_RootConstrainSelectedInstOperands,
     /* 206883 */     // GIR_Coverage, 11335,
     /* 206883 */     GIR_EraseRootFromParent_Done,
     /* 206884 */   // Label 3913: @206884
     /* 206884 */   GIM_Try, /*On fail goto*//*Label 3914*/ GIMT_Encode4(206921), // Rule ID 11336 //
     /* 206889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 206900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 206903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 206906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206910 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2087:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 206910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206915 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206919 */     GIR_RootConstrainSelectedInstOperands,
     /* 206920 */     // GIR_Coverage, 11336,
     /* 206920 */     GIR_EraseRootFromParent_Done,
     /* 206921 */   // Label 3914: @206921
     /* 206921 */   GIM_Try, /*On fail goto*//*Label 3915*/ GIMT_Encode4(206958), // Rule ID 11337 //
     /* 206926 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206929 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206934 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206937 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206940 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2087:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 206947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206956 */     GIR_RootConstrainSelectedInstOperands,
     /* 206957 */     // GIR_Coverage, 11337,
     /* 206957 */     GIR_EraseRootFromParent_Done,
     /* 206958 */   // Label 3915: @206958
     /* 206958 */   GIM_Try, /*On fail goto*//*Label 3916*/ GIMT_Encode4(206995), // Rule ID 11338 //
     /* 206963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 206966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 206971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 206974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 206977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 206980 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 206984 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2087:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 206984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 206987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 206989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 206991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 206993 */     GIR_RootConstrainSelectedInstOperands,
     /* 206994 */     // GIR_Coverage, 11338,
     /* 206994 */     GIR_EraseRootFromParent_Done,
     /* 206995 */   // Label 3916: @206995
     /* 206995 */   GIM_Try, /*On fail goto*//*Label 3917*/ GIMT_Encode4(207032), // Rule ID 11339 //
     /* 207000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207021 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2087:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207030 */     GIR_RootConstrainSelectedInstOperands,
     /* 207031 */     // GIR_Coverage, 11339,
     /* 207031 */     GIR_EraseRootFromParent_Done,
     /* 207032 */   // Label 3917: @207032
     /* 207032 */   GIM_Try, /*On fail goto*//*Label 3918*/ GIMT_Encode4(207069), // Rule ID 11340 //
     /* 207037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp1q),
     /* 207045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207054 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207058 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2087:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_Q),
     /* 207061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207067 */     GIR_RootConstrainSelectedInstOperands,
     /* 207068 */     // GIR_Coverage, 11340,
     /* 207068 */     GIR_EraseRootFromParent_Done,
     /* 207069 */   // Label 3918: @207069
     /* 207069 */   GIM_Try, /*On fail goto*//*Label 3919*/ GIMT_Encode4(207106), // Rule ID 11341 //
     /* 207074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207095 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2092:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207095 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207098 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207100 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207102 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207104 */     GIR_RootConstrainSelectedInstOperands,
     /* 207105 */     // GIR_Coverage, 11341,
     /* 207105 */     GIR_EraseRootFromParent_Done,
     /* 207106 */   // Label 3919: @207106
     /* 207106 */   GIM_Try, /*On fail goto*//*Label 3920*/ GIMT_Encode4(207143), // Rule ID 11342 //
     /* 207111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207114 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207119 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207122 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207125 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207132 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2092:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207141 */     GIR_RootConstrainSelectedInstOperands,
     /* 207142 */     // GIR_Coverage, 11342,
     /* 207142 */     GIR_EraseRootFromParent_Done,
     /* 207143 */   // Label 3920: @207143
     /* 207143 */   GIM_Try, /*On fail goto*//*Label 3921*/ GIMT_Encode4(207180), // Rule ID 11343 //
     /* 207148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207169 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2092:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207178 */     GIR_RootConstrainSelectedInstOperands,
     /* 207179 */     // GIR_Coverage, 11343,
     /* 207179 */     GIR_EraseRootFromParent_Done,
     /* 207180 */   // Label 3921: @207180
     /* 207180 */   GIM_Try, /*On fail goto*//*Label 3922*/ GIMT_Encode4(207217), // Rule ID 11344 //
     /* 207185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207206 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2092:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207213 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207215 */     GIR_RootConstrainSelectedInstOperands,
     /* 207216 */     // GIR_Coverage, 11344,
     /* 207216 */     GIR_EraseRootFromParent_Done,
     /* 207217 */   // Label 3922: @207217
     /* 207217 */   GIM_Try, /*On fail goto*//*Label 3923*/ GIMT_Encode4(207254), // Rule ID 11345 //
     /* 207222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207225 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207230 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207233 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207236 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207243 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2092:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207252 */     GIR_RootConstrainSelectedInstOperands,
     /* 207253 */     // GIR_Coverage, 11345,
     /* 207253 */     GIR_EraseRootFromParent_Done,
     /* 207254 */   // Label 3923: @207254
     /* 207254 */   GIM_Try, /*On fail goto*//*Label 3924*/ GIMT_Encode4(207291), // Rule ID 11346 //
     /* 207259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207280 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2092:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207280 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207283 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207285 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207287 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207289 */     GIR_RootConstrainSelectedInstOperands,
     /* 207290 */     // GIR_Coverage, 11346,
     /* 207290 */     GIR_EraseRootFromParent_Done,
     /* 207291 */   // Label 3924: @207291
     /* 207291 */   GIM_Try, /*On fail goto*//*Label 3925*/ GIMT_Encode4(207328), // Rule ID 11347 //
     /* 207296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzp2q),
     /* 207304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207317 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2092:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_Q),
     /* 207320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207326 */     GIR_RootConstrainSelectedInstOperands,
     /* 207327 */     // GIR_Coverage, 11347,
     /* 207327 */     GIR_EraseRootFromParent_Done,
     /* 207328 */   // Label 3925: @207328
     /* 207328 */   GIM_Try, /*On fail goto*//*Label 3926*/ GIMT_Encode4(207365), // Rule ID 11348 //
     /* 207333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207350 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207354 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1931:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207354 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207357 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207359 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207363 */     GIR_RootConstrainSelectedInstOperands,
     /* 207364 */     // GIR_Coverage, 11348,
     /* 207364 */     GIR_EraseRootFromParent_Done,
     /* 207365 */   // Label 3926: @207365
     /* 207365 */   GIM_Try, /*On fail goto*//*Label 3927*/ GIMT_Encode4(207402), // Rule ID 11349 //
     /* 207370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207391 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1931:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207400 */     GIR_RootConstrainSelectedInstOperands,
     /* 207401 */     // GIR_Coverage, 11349,
     /* 207401 */     GIR_EraseRootFromParent_Done,
     /* 207402 */   // Label 3927: @207402
     /* 207402 */   GIM_Try, /*On fail goto*//*Label 3928*/ GIMT_Encode4(207439), // Rule ID 11350 //
     /* 207407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207418 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207421 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207428 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1931:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207437 */     GIR_RootConstrainSelectedInstOperands,
     /* 207438 */     // GIR_Coverage, 11350,
     /* 207438 */     GIR_EraseRootFromParent_Done,
     /* 207439 */   // Label 3928: @207439
     /* 207439 */   GIM_Try, /*On fail goto*//*Label 3929*/ GIMT_Encode4(207476), // Rule ID 11351 //
     /* 207444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207465 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1931:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207470 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207474 */     GIR_RootConstrainSelectedInstOperands,
     /* 207475 */     // GIR_Coverage, 11351,
     /* 207475 */     GIR_EraseRootFromParent_Done,
     /* 207476 */   // Label 3929: @207476
     /* 207476 */   GIM_Try, /*On fail goto*//*Label 3930*/ GIMT_Encode4(207513), // Rule ID 11352 //
     /* 207481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207495 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207498 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207502 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1931:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207502 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207505 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207507 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207509 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207511 */     GIR_RootConstrainSelectedInstOperands,
     /* 207512 */     // GIR_Coverage, 11352,
     /* 207512 */     GIR_EraseRootFromParent_Done,
     /* 207513 */   // Label 3930: @207513
     /* 207513 */   GIM_Try, /*On fail goto*//*Label 3931*/ GIMT_Encode4(207550), // Rule ID 11353 //
     /* 207518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207539 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1931:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207548 */     GIR_RootConstrainSelectedInstOperands,
     /* 207549 */     // GIR_Coverage, 11353,
     /* 207549 */     GIR_EraseRootFromParent_Done,
     /* 207550 */   // Label 3931: @207550
     /* 207550 */   GIM_Try, /*On fail goto*//*Label 3932*/ GIMT_Encode4(207587), // Rule ID 11354 //
     /* 207555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn1q),
     /* 207563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207572 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207576 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1931:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_Q),
     /* 207579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207585 */     GIR_RootConstrainSelectedInstOperands,
     /* 207586 */     // GIR_Coverage, 11354,
     /* 207586 */     GIR_EraseRootFromParent_Done,
     /* 207587 */   // Label 3932: @207587
     /* 207587 */   GIM_Try, /*On fail goto*//*Label 3933*/ GIMT_Encode4(207624), // Rule ID 11355 //
     /* 207592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207613 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1936:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207622 */     GIR_RootConstrainSelectedInstOperands,
     /* 207623 */     // GIR_Coverage, 11355,
     /* 207623 */     GIR_EraseRootFromParent_Done,
     /* 207624 */   // Label 3933: @207624
     /* 207624 */   GIM_Try, /*On fail goto*//*Label 3934*/ GIMT_Encode4(207661), // Rule ID 11356 //
     /* 207629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207650 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1936:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207655 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207657 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207659 */     GIR_RootConstrainSelectedInstOperands,
     /* 207660 */     // GIR_Coverage, 11356,
     /* 207660 */     GIR_EraseRootFromParent_Done,
     /* 207661 */   // Label 3934: @207661
     /* 207661 */   GIM_Try, /*On fail goto*//*Label 3935*/ GIMT_Encode4(207698), // Rule ID 11357 //
     /* 207666 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207669 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207674 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207677 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207680 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207687 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1936:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 207687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207696 */     GIR_RootConstrainSelectedInstOperands,
     /* 207697 */     // GIR_Coverage, 11357,
     /* 207697 */     GIR_EraseRootFromParent_Done,
     /* 207698 */   // Label 3935: @207698
     /* 207698 */   GIM_Try, /*On fail goto*//*Label 3936*/ GIMT_Encode4(207735), // Rule ID 11358 //
     /* 207703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207720 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207724 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1936:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207733 */     GIR_RootConstrainSelectedInstOperands,
     /* 207734 */     // GIR_Coverage, 11358,
     /* 207734 */     GIR_EraseRootFromParent_Done,
     /* 207735 */   // Label 3936: @207735
     /* 207735 */   GIM_Try, /*On fail goto*//*Label 3937*/ GIMT_Encode4(207772), // Rule ID 11359 //
     /* 207740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207761 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1936:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 207761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207770 */     GIR_RootConstrainSelectedInstOperands,
     /* 207771 */     // GIR_Coverage, 11359,
     /* 207771 */     GIR_EraseRootFromParent_Done,
     /* 207772 */   // Label 3937: @207772
     /* 207772 */   GIM_Try, /*On fail goto*//*Label 3938*/ GIMT_Encode4(207809), // Rule ID 11360 //
     /* 207777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207780 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207785 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207798 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1936:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207803 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207805 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207807 */     GIR_RootConstrainSelectedInstOperands,
     /* 207808 */     // GIR_Coverage, 11360,
     /* 207808 */     GIR_EraseRootFromParent_Done,
     /* 207809 */   // Label 3938: @207809
     /* 207809 */   GIM_Try, /*On fail goto*//*Label 3939*/ GIMT_Encode4(207846), // Rule ID 11361 //
     /* 207814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE_or_SME),
     /* 207817 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_trn2q),
     /* 207822 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207835 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1936:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_Q:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 207835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_Q),
     /* 207838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207844 */     GIR_RootConstrainSelectedInstOperands,
     /* 207845 */     // GIR_Coverage, 11361,
     /* 207845 */     GIR_EraseRootFromParent_Done,
     /* 207846 */   // Label 3939: @207846
     /* 207846 */   GIM_Try, /*On fail goto*//*Label 3940*/ GIMT_Encode4(207883), // Rule ID 11381 //
     /* 207851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 207862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 207865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 207868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207872 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1833:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQRDMULH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 207872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_B),
     /* 207875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207881 */     GIR_RootConstrainSelectedInstOperands,
     /* 207882 */     // GIR_Coverage, 11381,
     /* 207882 */     GIR_EraseRootFromParent_Done,
     /* 207883 */   // Label 3940: @207883
     /* 207883 */   GIM_Try, /*On fail goto*//*Label 3941*/ GIMT_Encode4(207920), // Rule ID 11382 //
     /* 207888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 207899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 207902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 207905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1833:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQRDMULH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 207909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_H),
     /* 207912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207918 */     GIR_RootConstrainSelectedInstOperands,
     /* 207919 */     // GIR_Coverage, 11382,
     /* 207919 */     GIR_EraseRootFromParent_Done,
     /* 207920 */   // Label 3941: @207920
     /* 207920 */   GIM_Try, /*On fail goto*//*Label 3942*/ GIMT_Encode4(207957), // Rule ID 11383 //
     /* 207925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 207936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 207939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 207942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207946 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1833:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQRDMULH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 207946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_S),
     /* 207949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207955 */     GIR_RootConstrainSelectedInstOperands,
     /* 207956 */     // GIR_Coverage, 11383,
     /* 207956 */     GIR_EraseRootFromParent_Done,
     /* 207957 */   // Label 3942: @207957
     /* 207957 */   GIM_Try, /*On fail goto*//*Label 3943*/ GIMT_Encode4(207994), // Rule ID 11384 //
     /* 207962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 207965 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh),
     /* 207970 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 207973 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 207976 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 207979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 207983 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1833:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQRDMULH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 207983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZ_D),
     /* 207986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 207988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 207990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 207992 */     GIR_RootConstrainSelectedInstOperands,
     /* 207993 */     // GIR_Coverage, 11384,
     /* 207993 */     GIR_EraseRootFromParent_Done,
     /* 207994 */   // Label 3943: @207994
     /* 207994 */   GIM_Try, /*On fail goto*//*Label 3944*/ GIMT_Encode4(208031), // Rule ID 11672 //
     /* 207999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208020 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1697:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_H),
     /* 208023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208025 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208027 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208029 */     GIR_RootConstrainSelectedInstOperands,
     /* 208030 */     // GIR_Coverage, 11672,
     /* 208030 */     GIR_EraseRootFromParent_Done,
     /* 208031 */   // Label 3944: @208031
     /* 208031 */   GIM_Try, /*On fail goto*//*Label 3945*/ GIMT_Encode4(208068), // Rule ID 11673 //
     /* 208036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208039 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208044 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208057 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1697:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_S),
     /* 208060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208066 */     GIR_RootConstrainSelectedInstOperands,
     /* 208067 */     // GIR_Coverage, 11673,
     /* 208067 */     GIR_EraseRootFromParent_Done,
     /* 208068 */   // Label 3945: @208068
     /* 208068 */   GIM_Try, /*On fail goto*//*Label 3946*/ GIMT_Encode4(208105), // Rule ID 11674 //
     /* 208073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saddlt),
     /* 208081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208090 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208094 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1697:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLT_ZZZ_D),
     /* 208097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208103 */     GIR_RootConstrainSelectedInstOperands,
     /* 208104 */     // GIR_Coverage, 11674,
     /* 208104 */     GIR_EraseRootFromParent_Done,
     /* 208105 */   // Label 3946: @208105
     /* 208105 */   GIM_Try, /*On fail goto*//*Label 3947*/ GIMT_Encode4(208142), // Rule ID 11675 //
     /* 208110 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208113 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208118 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208121 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208124 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1945:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_H),
     /* 208134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208140 */     GIR_RootConstrainSelectedInstOperands,
     /* 208141 */     // GIR_Coverage, 11675,
     /* 208141 */     GIR_EraseRootFromParent_Done,
     /* 208142 */   // Label 3947: @208142
     /* 208142 */   GIM_Try, /*On fail goto*//*Label 3948*/ GIMT_Encode4(208179), // Rule ID 11676 //
     /* 208147 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208150 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208155 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208168 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1945:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_S),
     /* 208171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208177 */     GIR_RootConstrainSelectedInstOperands,
     /* 208178 */     // GIR_Coverage, 11676,
     /* 208178 */     GIR_EraseRootFromParent_Done,
     /* 208179 */   // Label 3948: @208179
     /* 208179 */   GIM_Try, /*On fail goto*//*Label 3949*/ GIMT_Encode4(208216), // Rule ID 11677 //
     /* 208184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlb),
     /* 208192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208205 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1945:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLB_ZZZ_D),
     /* 208208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208210 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208214 */     GIR_RootConstrainSelectedInstOperands,
     /* 208215 */     // GIR_Coverage, 11677,
     /* 208215 */     GIR_EraseRootFromParent_Done,
     /* 208216 */   // Label 3949: @208216
     /* 208216 */   GIM_Try, /*On fail goto*//*Label 3950*/ GIMT_Encode4(208253), // Rule ID 11678 //
     /* 208221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208242 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1946:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UADDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_H),
     /* 208245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208251 */     GIR_RootConstrainSelectedInstOperands,
     /* 208252 */     // GIR_Coverage, 11678,
     /* 208252 */     GIR_EraseRootFromParent_Done,
     /* 208253 */   // Label 3950: @208253
     /* 208253 */   GIM_Try, /*On fail goto*//*Label 3951*/ GIMT_Encode4(208290), // Rule ID 11679 //
     /* 208258 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208261 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208266 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208269 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208272 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208279 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1946:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UADDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_S),
     /* 208282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208288 */     GIR_RootConstrainSelectedInstOperands,
     /* 208289 */     // GIR_Coverage, 11679,
     /* 208289 */     GIR_EraseRootFromParent_Done,
     /* 208290 */   // Label 3951: @208290
     /* 208290 */   GIM_Try, /*On fail goto*//*Label 3952*/ GIMT_Encode4(208327), // Rule ID 11680 //
     /* 208295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaddlt),
     /* 208303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208316 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1946:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UADDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLT_ZZZ_D),
     /* 208319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208321 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208323 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208325 */     GIR_RootConstrainSelectedInstOperands,
     /* 208326 */     // GIR_Coverage, 11680,
     /* 208326 */     GIR_EraseRootFromParent_Done,
     /* 208327 */   // Label 3952: @208327
     /* 208327 */   GIM_Try, /*On fail goto*//*Label 3953*/ GIMT_Encode4(208364), // Rule ID 11681 //
     /* 208332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208335 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208340 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208343 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208346 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208353 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1874:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_H),
     /* 208356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208362 */     GIR_RootConstrainSelectedInstOperands,
     /* 208363 */     // GIR_Coverage, 11681,
     /* 208363 */     GIR_EraseRootFromParent_Done,
     /* 208364 */   // Label 3953: @208364
     /* 208364 */   GIM_Try, /*On fail goto*//*Label 3954*/ GIMT_Encode4(208401), // Rule ID 11682 //
     /* 208369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208390 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1874:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_S),
     /* 208393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208395 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208397 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208399 */     GIR_RootConstrainSelectedInstOperands,
     /* 208400 */     // GIR_Coverage, 11682,
     /* 208400 */     GIR_EraseRootFromParent_Done,
     /* 208401 */   // Label 3954: @208401
     /* 208401 */   GIM_Try, /*On fail goto*//*Label 3955*/ GIMT_Encode4(208438), // Rule ID 11683 //
     /* 208406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208409 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublb),
     /* 208414 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208417 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208420 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208427 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1874:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLB_ZZZ_D),
     /* 208430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208436 */     GIR_RootConstrainSelectedInstOperands,
     /* 208437 */     // GIR_Coverage, 11683,
     /* 208437 */     GIR_EraseRootFromParent_Done,
     /* 208438 */   // Label 3955: @208438
     /* 208438 */   GIM_Try, /*On fail goto*//*Label 3956*/ GIMT_Encode4(208475), // Rule ID 11684 //
     /* 208443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1876:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_H),
     /* 208467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208473 */     GIR_RootConstrainSelectedInstOperands,
     /* 208474 */     // GIR_Coverage, 11684,
     /* 208474 */     GIR_EraseRootFromParent_Done,
     /* 208475 */   // Label 3956: @208475
     /* 208475 */   GIM_Try, /*On fail goto*//*Label 3957*/ GIMT_Encode4(208512), // Rule ID 11685 //
     /* 208480 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208483 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208488 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208491 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208494 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1876:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_S),
     /* 208504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208510 */     GIR_RootConstrainSelectedInstOperands,
     /* 208511 */     // GIR_Coverage, 11685,
     /* 208511 */     GIR_EraseRootFromParent_Done,
     /* 208512 */   // Label 3957: @208512
     /* 208512 */   GIM_Try, /*On fail goto*//*Label 3958*/ GIMT_Encode4(208549), // Rule ID 11686 //
     /* 208517 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208520 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublt),
     /* 208525 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208528 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208531 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208534 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208538 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1876:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208538 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLT_ZZZ_D),
     /* 208541 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208547 */     GIR_RootConstrainSelectedInstOperands,
     /* 208548 */     // GIR_Coverage, 11686,
     /* 208548 */     GIR_EraseRootFromParent_Done,
     /* 208549 */   // Label 3958: @208549
     /* 208549 */   GIM_Try, /*On fail goto*//*Label 3959*/ GIMT_Encode4(208586), // Rule ID 11687 //
     /* 208554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208557 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208562 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208565 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208568 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208575 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2070:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_H),
     /* 208578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208582 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208584 */     GIR_RootConstrainSelectedInstOperands,
     /* 208585 */     // GIR_Coverage, 11687,
     /* 208585 */     GIR_EraseRootFromParent_Done,
     /* 208586 */   // Label 3959: @208586
     /* 208586 */   GIM_Try, /*On fail goto*//*Label 3960*/ GIMT_Encode4(208623), // Rule ID 11688 //
     /* 208591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208612 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2070:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_S),
     /* 208615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208617 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208619 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208621 */     GIR_RootConstrainSelectedInstOperands,
     /* 208622 */     // GIR_Coverage, 11688,
     /* 208622 */     GIR_EraseRootFromParent_Done,
     /* 208623 */   // Label 3960: @208623
     /* 208623 */   GIM_Try, /*On fail goto*//*Label 3961*/ GIMT_Encode4(208660), // Rule ID 11689 //
     /* 208628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublb),
     /* 208636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208645 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208649 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2070:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLB_ZZZ_D),
     /* 208652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208654 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208656 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208658 */     GIR_RootConstrainSelectedInstOperands,
     /* 208659 */     // GIR_Coverage, 11689,
     /* 208659 */     GIR_EraseRootFromParent_Done,
     /* 208660 */   // Label 3961: @208660
     /* 208660 */   GIM_Try, /*On fail goto*//*Label 3962*/ GIMT_Encode4(208697), // Rule ID 11690 //
     /* 208665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208686 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2071:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_H),
     /* 208689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208695 */     GIR_RootConstrainSelectedInstOperands,
     /* 208696 */     // GIR_Coverage, 11690,
     /* 208696 */     GIR_EraseRootFromParent_Done,
     /* 208697 */   // Label 3962: @208697
     /* 208697 */   GIM_Try, /*On fail goto*//*Label 3963*/ GIMT_Encode4(208734), // Rule ID 11691 //
     /* 208702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208705 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208710 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208713 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208716 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208723 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2071:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_S),
     /* 208726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208728 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208732 */     GIR_RootConstrainSelectedInstOperands,
     /* 208733 */     // GIR_Coverage, 11691,
     /* 208733 */     GIR_EraseRootFromParent_Done,
     /* 208734 */   // Label 3963: @208734
     /* 208734 */   GIM_Try, /*On fail goto*//*Label 3964*/ GIMT_Encode4(208771), // Rule ID 11692 //
     /* 208739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usublt),
     /* 208747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208760 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2071:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBLT_ZZZ_D),
     /* 208763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208767 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208769 */     GIR_RootConstrainSelectedInstOperands,
     /* 208770 */     // GIR_Coverage, 11692,
     /* 208770 */     GIR_EraseRootFromParent_Done,
     /* 208771 */   // Label 3964: @208771
     /* 208771 */   GIM_Try, /*On fail goto*//*Label 3965*/ GIMT_Encode4(208808), // Rule ID 11693 //
     /* 208776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208779 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208784 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208787 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208790 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1692:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_H),
     /* 208800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208806 */     GIR_RootConstrainSelectedInstOperands,
     /* 208807 */     // GIR_Coverage, 11693,
     /* 208807 */     GIR_EraseRootFromParent_Done,
     /* 208808 */   // Label 3965: @208808
     /* 208808 */   GIM_Try, /*On fail goto*//*Label 3966*/ GIMT_Encode4(208845), // Rule ID 11694 //
     /* 208813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208830 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208834 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1692:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_S),
     /* 208837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208843 */     GIR_RootConstrainSelectedInstOperands,
     /* 208844 */     // GIR_Coverage, 11694,
     /* 208844 */     GIR_EraseRootFromParent_Done,
     /* 208845 */   // Label 3966: @208845
     /* 208845 */   GIM_Try, /*On fail goto*//*Label 3967*/ GIMT_Encode4(208882), // Rule ID 11695 //
     /* 208850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208853 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlb),
     /* 208858 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1692:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLB_ZZZ_D),
     /* 208874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208880 */     GIR_RootConstrainSelectedInstOperands,
     /* 208881 */     // GIR_Coverage, 11695,
     /* 208881 */     GIR_EraseRootFromParent_Done,
     /* 208882 */   // Label 3967: @208882
     /* 208882 */   GIM_Try, /*On fail goto*//*Label 3968*/ GIMT_Encode4(208919), // Rule ID 11696 //
     /* 208887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 208895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 208898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 208901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 208904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208908 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1693:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 208908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_H),
     /* 208911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208917 */     GIR_RootConstrainSelectedInstOperands,
     /* 208918 */     // GIR_Coverage, 11696,
     /* 208918 */     GIR_EraseRootFromParent_Done,
     /* 208919 */   // Label 3968: @208919
     /* 208919 */   GIM_Try, /*On fail goto*//*Label 3969*/ GIMT_Encode4(208956), // Rule ID 11697 //
     /* 208924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208927 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 208932 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 208935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 208938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 208941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208945 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1693:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 208945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_S),
     /* 208948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208954 */     GIR_RootConstrainSelectedInstOperands,
     /* 208955 */     // GIR_Coverage, 11697,
     /* 208955 */     GIR_EraseRootFromParent_Done,
     /* 208956 */   // Label 3969: @208956
     /* 208956 */   GIM_Try, /*On fail goto*//*Label 3970*/ GIMT_Encode4(208993), // Rule ID 11698 //
     /* 208961 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 208964 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabdlt),
     /* 208969 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 208972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 208975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 208978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 208982 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1693:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 208982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLT_ZZZ_D),
     /* 208985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 208987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 208989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 208991 */     GIR_RootConstrainSelectedInstOperands,
     /* 208992 */     // GIR_Coverage, 11698,
     /* 208992 */     GIR_EraseRootFromParent_Done,
     /* 208993 */   // Label 3970: @208993
     /* 208993 */   GIM_Try, /*On fail goto*//*Label 3971*/ GIMT_Encode4(209030), // Rule ID 11699 //
     /* 208998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209015 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209019 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1942:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_H),
     /* 209022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209028 */     GIR_RootConstrainSelectedInstOperands,
     /* 209029 */     // GIR_Coverage, 11699,
     /* 209029 */     GIR_EraseRootFromParent_Done,
     /* 209030 */   // Label 3971: @209030
     /* 209030 */   GIM_Try, /*On fail goto*//*Label 3972*/ GIMT_Encode4(209067), // Rule ID 11700 //
     /* 209035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209052 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209056 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1942:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_S),
     /* 209059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209065 */     GIR_RootConstrainSelectedInstOperands,
     /* 209066 */     // GIR_Coverage, 11700,
     /* 209066 */     GIR_EraseRootFromParent_Done,
     /* 209067 */   // Label 3972: @209067
     /* 209067 */   GIM_Try, /*On fail goto*//*Label 3973*/ GIMT_Encode4(209104), // Rule ID 11701 //
     /* 209072 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlb),
     /* 209080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209093 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1942:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209093 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLB_ZZZ_D),
     /* 209096 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209100 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209102 */     GIR_RootConstrainSelectedInstOperands,
     /* 209103 */     // GIR_Coverage, 11701,
     /* 209103 */     GIR_EraseRootFromParent_Done,
     /* 209104 */   // Label 3973: @209104
     /* 209104 */   GIM_Try, /*On fail goto*//*Label 3974*/ GIMT_Encode4(209141), // Rule ID 11702 //
     /* 209109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209130 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1943:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UABDLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_H),
     /* 209133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209139 */     GIR_RootConstrainSelectedInstOperands,
     /* 209140 */     // GIR_Coverage, 11702,
     /* 209140 */     GIR_EraseRootFromParent_Done,
     /* 209141 */   // Label 3974: @209141
     /* 209141 */   GIM_Try, /*On fail goto*//*Label 3975*/ GIMT_Encode4(209178), // Rule ID 11703 //
     /* 209146 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209149 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209154 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209157 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209160 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209167 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1943:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UABDLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_S),
     /* 209170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209176 */     GIR_RootConstrainSelectedInstOperands,
     /* 209177 */     // GIR_Coverage, 11703,
     /* 209177 */     GIR_EraseRootFromParent_Done,
     /* 209178 */   // Label 3975: @209178
     /* 209178 */   GIM_Try, /*On fail goto*//*Label 3976*/ GIMT_Encode4(209215), // Rule ID 11704 //
     /* 209183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabdlt),
     /* 209191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209200 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1943:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UABDLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLT_ZZZ_D),
     /* 209207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209213 */     GIR_RootConstrainSelectedInstOperands,
     /* 209214 */     // GIR_Coverage, 11704,
     /* 209214 */     GIR_EraseRootFromParent_Done,
     /* 209215 */   // Label 3976: @209215
     /* 209215 */   GIM_Try, /*On fail goto*//*Label 3977*/ GIMT_Encode4(209252), // Rule ID 11714 //
     /* 209220 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209223 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209228 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209241 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1878:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_H),
     /* 209244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209250 */     GIR_RootConstrainSelectedInstOperands,
     /* 209251 */     // GIR_Coverage, 11714,
     /* 209251 */     GIR_EraseRootFromParent_Done,
     /* 209252 */   // Label 3977: @209252
     /* 209252 */   GIM_Try, /*On fail goto*//*Label 3978*/ GIMT_Encode4(209289), // Rule ID 11715 //
     /* 209257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209278 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1878:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_S),
     /* 209281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209285 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209287 */     GIR_RootConstrainSelectedInstOperands,
     /* 209288 */     // GIR_Coverage, 11715,
     /* 209288 */     GIR_EraseRootFromParent_Done,
     /* 209289 */   // Label 3978: @209289
     /* 209289 */   GIM_Try, /*On fail goto*//*Label 3979*/ GIMT_Encode4(209326), // Rule ID 11716 //
     /* 209294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209297 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwb),
     /* 209302 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209315 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1878:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWB_ZZZ_D),
     /* 209318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209324 */     GIR_RootConstrainSelectedInstOperands,
     /* 209325 */     // GIR_Coverage, 11716,
     /* 209325 */     GIR_EraseRootFromParent_Done,
     /* 209326 */   // Label 3979: @209326
     /* 209326 */   GIM_Try, /*On fail goto*//*Label 3980*/ GIMT_Encode4(209363), // Rule ID 11717 //
     /* 209331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209342 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209345 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1879:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_H),
     /* 209355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209361 */     GIR_RootConstrainSelectedInstOperands,
     /* 209362 */     // GIR_Coverage, 11717,
     /* 209362 */     GIR_EraseRootFromParent_Done,
     /* 209363 */   // Label 3980: @209363
     /* 209363 */   GIM_Try, /*On fail goto*//*Label 3981*/ GIMT_Encode4(209400), // Rule ID 11718 //
     /* 209368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209385 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209389 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1879:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_S),
     /* 209392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209398 */     GIR_RootConstrainSelectedInstOperands,
     /* 209399 */     // GIR_Coverage, 11718,
     /* 209399 */     GIR_EraseRootFromParent_Done,
     /* 209400 */   // Label 3981: @209400
     /* 209400 */   GIM_Try, /*On fail goto*//*Label 3982*/ GIMT_Encode4(209437), // Rule ID 11719 //
     /* 209405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubwt),
     /* 209413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209426 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1879:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBWT_ZZZ_D),
     /* 209429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209435 */     GIR_RootConstrainSelectedInstOperands,
     /* 209436 */     // GIR_Coverage, 11719,
     /* 209436 */     GIR_EraseRootFromParent_Done,
     /* 209437 */   // Label 3982: @209437
     /* 209437 */   GIM_Try, /*On fail goto*//*Label 3983*/ GIMT_Encode4(209474), // Rule ID 11720 //
     /* 209442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209445 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209450 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209463 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2072:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_H),
     /* 209466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209470 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209472 */     GIR_RootConstrainSelectedInstOperands,
     /* 209473 */     // GIR_Coverage, 11720,
     /* 209473 */     GIR_EraseRootFromParent_Done,
     /* 209474 */   // Label 3983: @209474
     /* 209474 */   GIM_Try, /*On fail goto*//*Label 3984*/ GIMT_Encode4(209511), // Rule ID 11721 //
     /* 209479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209496 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209500 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2072:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_S),
     /* 209503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209507 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209509 */     GIR_RootConstrainSelectedInstOperands,
     /* 209510 */     // GIR_Coverage, 11721,
     /* 209510 */     GIR_EraseRootFromParent_Done,
     /* 209511 */   // Label 3984: @209511
     /* 209511 */   GIM_Try, /*On fail goto*//*Label 3985*/ GIMT_Encode4(209548), // Rule ID 11722 //
     /* 209516 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209519 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwb),
     /* 209524 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209527 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209530 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209537 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2072:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWB_ZZZ_D),
     /* 209540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209546 */     GIR_RootConstrainSelectedInstOperands,
     /* 209547 */     // GIR_Coverage, 11722,
     /* 209547 */     GIR_EraseRootFromParent_Done,
     /* 209548 */   // Label 3985: @209548
     /* 209548 */   GIM_Try, /*On fail goto*//*Label 3986*/ GIMT_Encode4(209585), // Rule ID 11723 //
     /* 209553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209574 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2073:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (USUBWT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_H),
     /* 209577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209583 */     GIR_RootConstrainSelectedInstOperands,
     /* 209584 */     // GIR_Coverage, 11723,
     /* 209584 */     GIR_EraseRootFromParent_Done,
     /* 209585 */   // Label 3986: @209585
     /* 209585 */   GIM_Try, /*On fail goto*//*Label 3987*/ GIMT_Encode4(209622), // Rule ID 11724 //
     /* 209590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209593 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209598 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209601 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209604 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2073:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (USUBWT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_S),
     /* 209614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209620 */     GIR_RootConstrainSelectedInstOperands,
     /* 209621 */     // GIR_Coverage, 11724,
     /* 209621 */     GIR_EraseRootFromParent_Done,
     /* 209622 */   // Label 3987: @209622
     /* 209622 */   GIM_Try, /*On fail goto*//*Label 3988*/ GIMT_Encode4(209659), // Rule ID 11725 //
     /* 209627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usubwt),
     /* 209635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 209641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209648 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2073:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (USUBWT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USUBWT_ZZZ_D),
     /* 209651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209653 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209655 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209657 */     GIR_RootConstrainSelectedInstOperands,
     /* 209658 */     // GIR_Coverage, 11725,
     /* 209658 */     GIR_EraseRootFromParent_Done,
     /* 209659 */   // Label 3988: @209659
     /* 209659 */   GIM_Try, /*On fail goto*//*Label 3989*/ GIMT_Encode4(209696), // Rule ID 11738 //
     /* 209664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209685 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1808:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_H),
     /* 209688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209694 */     GIR_RootConstrainSelectedInstOperands,
     /* 209695 */     // GIR_Coverage, 11738,
     /* 209695 */     GIR_EraseRootFromParent_Done,
     /* 209696 */   // Label 3989: @209696
     /* 209696 */   GIM_Try, /*On fail goto*//*Label 3990*/ GIMT_Encode4(209733), // Rule ID 11739 //
     /* 209701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209722 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1808:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_S),
     /* 209725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209731 */     GIR_RootConstrainSelectedInstOperands,
     /* 209732 */     // GIR_Coverage, 11739,
     /* 209732 */     GIR_EraseRootFromParent_Done,
     /* 209733 */   // Label 3990: @209733
     /* 209733 */   GIM_Try, /*On fail goto*//*Label 3991*/ GIMT_Encode4(209770), // Rule ID 11740 //
     /* 209738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209741 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb),
     /* 209746 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209749 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209752 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209759 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1808:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZ_D),
     /* 209762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209768 */     GIR_RootConstrainSelectedInstOperands,
     /* 209769 */     // GIR_Coverage, 11740,
     /* 209769 */     GIR_EraseRootFromParent_Done,
     /* 209770 */   // Label 3991: @209770
     /* 209770 */   GIM_Try, /*On fail goto*//*Label 3992*/ GIMT_Encode4(209807), // Rule ID 11741 //
     /* 209775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209783 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209786 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209789 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209796 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1810:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQDMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209796 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_H),
     /* 209799 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209801 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209805 */     GIR_RootConstrainSelectedInstOperands,
     /* 209806 */     // GIR_Coverage, 11741,
     /* 209806 */     GIR_EraseRootFromParent_Done,
     /* 209807 */   // Label 3992: @209807
     /* 209807 */   GIM_Try, /*On fail goto*//*Label 3993*/ GIMT_Encode4(209844), // Rule ID 11742 //
     /* 209812 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209815 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209820 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209823 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209826 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209833 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1810:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQDMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_S),
     /* 209836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209842 */     GIR_RootConstrainSelectedInstOperands,
     /* 209843 */     // GIR_Coverage, 11742,
     /* 209843 */     GIR_EraseRootFromParent_Done,
     /* 209844 */   // Label 3993: @209844
     /* 209844 */   GIM_Try, /*On fail goto*//*Label 3994*/ GIMT_Encode4(209881), // Rule ID 11743 //
     /* 209849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt),
     /* 209857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209870 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1810:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQDMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZ_D),
     /* 209873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209879 */     GIR_RootConstrainSelectedInstOperands,
     /* 209880 */     // GIR_Coverage, 11743,
     /* 209880 */     GIR_EraseRootFromParent_Done,
     /* 209881 */   // Label 3994: @209881
     /* 209881 */   GIM_Try, /*On fail goto*//*Label 3995*/ GIMT_Encode4(209918), // Rule ID 11744 //
     /* 209886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209889 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 209894 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 209897 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 209900 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 209903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209907 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1761:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 209907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_H),
     /* 209910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209916 */     GIR_RootConstrainSelectedInstOperands,
     /* 209917 */     // GIR_Coverage, 11744,
     /* 209917 */     GIR_EraseRootFromParent_Done,
     /* 209918 */   // Label 3995: @209918
     /* 209918 */   GIM_Try, /*On fail goto*//*Label 3996*/ GIMT_Encode4(209955), // Rule ID 11745 //
     /* 209923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 209931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 209934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 209937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 209940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1761:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 209944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_S),
     /* 209947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209953 */     GIR_RootConstrainSelectedInstOperands,
     /* 209954 */     // GIR_Coverage, 11745,
     /* 209954 */     GIR_EraseRootFromParent_Done,
     /* 209955 */   // Label 3996: @209955
     /* 209955 */   GIM_Try, /*On fail goto*//*Label 3997*/ GIMT_Encode4(209992), // Rule ID 11746 //
     /* 209960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 209963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb),
     /* 209968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 209971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 209974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 209977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 209981 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1761:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 209981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZ_D),
     /* 209984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 209986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 209988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 209990 */     GIR_RootConstrainSelectedInstOperands,
     /* 209991 */     // GIR_Coverage, 11746,
     /* 209991 */     GIR_EraseRootFromParent_Done,
     /* 209992 */   // Label 3997: @209992
     /* 209992 */   GIM_Try, /*On fail goto*//*Label 3998*/ GIMT_Encode4(210029), // Rule ID 11747 //
     /* 209997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210018 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1763:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_H),
     /* 210021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210025 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210027 */     GIR_RootConstrainSelectedInstOperands,
     /* 210028 */     // GIR_Coverage, 11747,
     /* 210028 */     GIR_EraseRootFromParent_Done,
     /* 210029 */   // Label 3998: @210029
     /* 210029 */   GIM_Try, /*On fail goto*//*Label 3999*/ GIMT_Encode4(210066), // Rule ID 11748 //
     /* 210034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210055 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1763:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_S),
     /* 210058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210064 */     GIR_RootConstrainSelectedInstOperands,
     /* 210065 */     // GIR_Coverage, 11748,
     /* 210065 */     GIR_EraseRootFromParent_Done,
     /* 210066 */   // Label 3999: @210066
     /* 210066 */   GIM_Try, /*On fail goto*//*Label 4000*/ GIMT_Encode4(210103), // Rule ID 11749 //
     /* 210071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210074 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt),
     /* 210079 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210082 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210085 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210092 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1763:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZ_D),
     /* 210095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210097 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210101 */     GIR_RootConstrainSelectedInstOperands,
     /* 210102 */     // GIR_Coverage, 11749,
     /* 210102 */     GIR_EraseRootFromParent_Done,
     /* 210103 */   // Label 4000: @210103
     /* 210103 */   GIM_Try, /*On fail goto*//*Label 4001*/ GIMT_Encode4(210140), // Rule ID 11750 //
     /* 210108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210129 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1999:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_H),
     /* 210132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210134 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210138 */     GIR_RootConstrainSelectedInstOperands,
     /* 210139 */     // GIR_Coverage, 11750,
     /* 210139 */     GIR_EraseRootFromParent_Done,
     /* 210140 */   // Label 4001: @210140
     /* 210140 */   GIM_Try, /*On fail goto*//*Label 4002*/ GIMT_Encode4(210177), // Rule ID 11751 //
     /* 210145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210166 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1999:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_S),
     /* 210169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210173 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210175 */     GIR_RootConstrainSelectedInstOperands,
     /* 210176 */     // GIR_Coverage, 11751,
     /* 210176 */     GIR_EraseRootFromParent_Done,
     /* 210177 */   // Label 4002: @210177
     /* 210177 */   GIM_Try, /*On fail goto*//*Label 4003*/ GIMT_Encode4(210214), // Rule ID 11752 //
     /* 210182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb),
     /* 210190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210203 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1999:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZ_D),
     /* 210206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210212 */     GIR_RootConstrainSelectedInstOperands,
     /* 210213 */     // GIR_Coverage, 11752,
     /* 210213 */     GIR_EraseRootFromParent_Done,
     /* 210214 */   // Label 4003: @210214
     /* 210214 */   GIM_Try, /*On fail goto*//*Label 4004*/ GIMT_Encode4(210251), // Rule ID 11753 //
     /* 210219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210236 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210240 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2001:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMULLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_H),
     /* 210243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210245 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210247 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210249 */     GIR_RootConstrainSelectedInstOperands,
     /* 210250 */     // GIR_Coverage, 11753,
     /* 210250 */     GIR_EraseRootFromParent_Done,
     /* 210251 */   // Label 4004: @210251
     /* 210251 */   GIM_Try, /*On fail goto*//*Label 4005*/ GIMT_Encode4(210288), // Rule ID 11754 //
     /* 210256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2001:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMULLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_S),
     /* 210280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210286 */     GIR_RootConstrainSelectedInstOperands,
     /* 210287 */     // GIR_Coverage, 11754,
     /* 210287 */     GIR_EraseRootFromParent_Done,
     /* 210288 */   // Label 4005: @210288
     /* 210288 */   GIM_Try, /*On fail goto*//*Label 4006*/ GIMT_Encode4(210325), // Rule ID 11755 //
     /* 210293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt),
     /* 210301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 210304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210310 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210314 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2001:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMULLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZ_D),
     /* 210317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210323 */     GIR_RootConstrainSelectedInstOperands,
     /* 210324 */     // GIR_Coverage, 11755,
     /* 210324 */     GIR_EraseRootFromParent_Done,
     /* 210325 */   // Label 4006: @210325
     /* 210325 */   GIM_Try, /*On fail goto*//*Label 4007*/ GIMT_Encode4(210362), // Rule ID 11756 //
     /* 210330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210351 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1639:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (PMULLT_ZZZ_H:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_H),
     /* 210354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210360 */     GIR_RootConstrainSelectedInstOperands,
     /* 210361 */     // GIR_Coverage, 11756,
     /* 210361 */     GIR_EraseRootFromParent_Done,
     /* 210362 */   // Label 4007: @210362
     /* 210362 */   GIM_Try, /*On fail goto*//*Label 4008*/ GIMT_Encode4(210399), // Rule ID 11757 //
     /* 210367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 210375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210384 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210388 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1639:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (PMULLT_ZZZ_D:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_D),
     /* 210391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210395 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210397 */     GIR_RootConstrainSelectedInstOperands,
     /* 210398 */     // GIR_Coverage, 11757,
     /* 210398 */     GIR_EraseRootFromParent_Done,
     /* 210399 */   // Label 4008: @210399
     /* 210399 */   GIM_Try, /*On fail goto*//*Label 4009*/ GIMT_Encode4(210436), // Rule ID 11858 //
     /* 210404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210425 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1669:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RADDHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_B),
     /* 210428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210434 */     GIR_RootConstrainSelectedInstOperands,
     /* 210435 */     // GIR_Coverage, 11858,
     /* 210435 */     GIR_EraseRootFromParent_Done,
     /* 210436 */   // Label 4009: @210436
     /* 210436 */   GIM_Try, /*On fail goto*//*Label 4010*/ GIMT_Encode4(210473), // Rule ID 11859 //
     /* 210441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210444 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210449 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210452 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210455 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210458 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210462 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1669:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RADDHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_H),
     /* 210465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210471 */     GIR_RootConstrainSelectedInstOperands,
     /* 210472 */     // GIR_Coverage, 11859,
     /* 210472 */     GIR_EraseRootFromParent_Done,
     /* 210473 */   // Label 4010: @210473
     /* 210473 */   GIM_Try, /*On fail goto*//*Label 4011*/ GIMT_Encode4(210510), // Rule ID 11860 //
     /* 210478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnb),
     /* 210486 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210499 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1669:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RADDHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNB_ZZZ_S),
     /* 210502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210504 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210506 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210508 */     GIR_RootConstrainSelectedInstOperands,
     /* 210509 */     // GIR_Coverage, 11860,
     /* 210509 */     GIR_EraseRootFromParent_Done,
     /* 210510 */   // Label 4011: @210510
     /* 210510 */   GIM_Try, /*On fail goto*//*Label 4012*/ GIMT_Encode4(210547), // Rule ID 11861 //
     /* 210515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210532 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210536 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1910:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_B),
     /* 210539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210541 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210543 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210545 */     GIR_RootConstrainSelectedInstOperands,
     /* 210546 */     // GIR_Coverage, 11861,
     /* 210546 */     GIR_EraseRootFromParent_Done,
     /* 210547 */   // Label 4012: @210547
     /* 210547 */   GIM_Try, /*On fail goto*//*Label 4013*/ GIMT_Encode4(210584), // Rule ID 11862 //
     /* 210552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210573 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1910:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_H),
     /* 210576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210582 */     GIR_RootConstrainSelectedInstOperands,
     /* 210583 */     // GIR_Coverage, 11862,
     /* 210583 */     GIR_EraseRootFromParent_Done,
     /* 210584 */   // Label 4013: @210584
     /* 210584 */   GIM_Try, /*On fail goto*//*Label 4014*/ GIMT_Encode4(210621), // Rule ID 11863 //
     /* 210589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnb),
     /* 210597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210610 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1910:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNB_ZZZ_S),
     /* 210613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210619 */     GIR_RootConstrainSelectedInstOperands,
     /* 210620 */     // GIR_Coverage, 11863,
     /* 210620 */     GIR_EraseRootFromParent_Done,
     /* 210621 */   // Label 4014: @210621
     /* 210621 */   GIM_Try, /*On fail goto*//*Label 4015*/ GIMT_Encode4(210658), // Rule ID 11864 //
     /* 210626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210629 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210634 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210637 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210640 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210647 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1685:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (RSUBHNB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_B),
     /* 210650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210656 */     GIR_RootConstrainSelectedInstOperands,
     /* 210657 */     // GIR_Coverage, 11864,
     /* 210657 */     GIR_EraseRootFromParent_Done,
     /* 210658 */   // Label 4015: @210658
     /* 210658 */   GIM_Try, /*On fail goto*//*Label 4016*/ GIMT_Encode4(210695), // Rule ID 11865 //
     /* 210663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210680 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1685:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (RSUBHNB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_H),
     /* 210687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210693 */     GIR_RootConstrainSelectedInstOperands,
     /* 210694 */     // GIR_Coverage, 11865,
     /* 210694 */     GIR_EraseRootFromParent_Done,
     /* 210695 */   // Label 4016: @210695
     /* 210695 */   GIM_Try, /*On fail goto*//*Label 4017*/ GIMT_Encode4(210732), // Rule ID 11866 //
     /* 210700 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnb),
     /* 210708 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210711 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 210714 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1685:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RSUBHNB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNB_ZZZ_S),
     /* 210724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210730 */     GIR_RootConstrainSelectedInstOperands,
     /* 210731 */     // GIR_Coverage, 11866,
     /* 210731 */     GIR_EraseRootFromParent_Done,
     /* 210732 */   // Label 4017: @210732
     /* 210732 */   GIM_Try, /*On fail goto*//*Label 4018*/ GIMT_Encode4(210769), // Rule ID 11882 //
     /* 210737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210754 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210758 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2052:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQXTNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210758 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_B),
     /* 210761 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210763 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210765 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210767 */     GIR_RootConstrainSelectedInstOperands,
     /* 210768 */     // GIR_Coverage, 11882,
     /* 210768 */     GIR_EraseRootFromParent_Done,
     /* 210769 */   // Label 4018: @210769
     /* 210769 */   GIM_Try, /*On fail goto*//*Label 4019*/ GIMT_Encode4(210806), // Rule ID 11883 //
     /* 210774 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210777 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210782 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210785 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210788 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2052:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQXTNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_H),
     /* 210798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210804 */     GIR_RootConstrainSelectedInstOperands,
     /* 210805 */     // GIR_Coverage, 11883,
     /* 210805 */     GIR_EraseRootFromParent_Done,
     /* 210806 */   // Label 4019: @210806
     /* 210806 */   GIM_Try, /*On fail goto*//*Label 4020*/ GIMT_Encode4(210843), // Rule ID 11884 //
     /* 210811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqxtnt),
     /* 210819 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210822 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210825 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210832 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2052:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQXTNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQXTNT_ZZ_S),
     /* 210835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210841 */     GIR_RootConstrainSelectedInstOperands,
     /* 210842 */     // GIR_Coverage, 11884,
     /* 210842 */     GIR_EraseRootFromParent_Done,
     /* 210843 */   // Label 4020: @210843
     /* 210843 */   GIM_Try, /*On fail goto*//*Label 4021*/ GIMT_Encode4(210880), // Rule ID 11885 //
     /* 210848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 210856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 210859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 210865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1861:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQXTUNT_ZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 210869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_B),
     /* 210872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210878 */     GIR_RootConstrainSelectedInstOperands,
     /* 210879 */     // GIR_Coverage, 11885,
     /* 210879 */     GIR_EraseRootFromParent_Done,
     /* 210880 */   // Label 4021: @210880
     /* 210880 */   GIM_Try, /*On fail goto*//*Label 4022*/ GIMT_Encode4(210917), // Rule ID 11886 //
     /* 210885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 210893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 210899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 210902 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210906 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1861:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQXTUNT_ZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 210906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_H),
     /* 210909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210911 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210913 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210915 */     GIR_RootConstrainSelectedInstOperands,
     /* 210916 */     // GIR_Coverage, 11886,
     /* 210916 */     GIR_EraseRootFromParent_Done,
     /* 210917 */   // Label 4022: @210917
     /* 210917 */   GIM_Try, /*On fail goto*//*Label 4023*/ GIMT_Encode4(210954), // Rule ID 11887 //
     /* 210922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqxtunt),
     /* 210930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 210933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 210936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 210939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210943 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1861:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQXTUNT_ZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 210943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQXTUNT_ZZ_S),
     /* 210946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210948 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210950 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210952 */     GIR_RootConstrainSelectedInstOperands,
     /* 210953 */     // GIR_Coverage, 11887,
     /* 210953 */     GIR_EraseRootFromParent_Done,
     /* 210954 */   // Label 4023: @210954
     /* 210954 */   GIM_Try, /*On fail goto*//*Label 4024*/ GIMT_Encode4(210991), // Rule ID 11903 //
     /* 210959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 210967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 210970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 210973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 210976 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 210980 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1875:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 210980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_H),
     /* 210983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 210985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 210987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 210989 */     GIR_RootConstrainSelectedInstOperands,
     /* 210990 */     // GIR_Coverage, 11903,
     /* 210990 */     GIR_EraseRootFromParent_Done,
     /* 210991 */   // Label 4024: @210991
     /* 210991 */   GIM_Try, /*On fail goto*//*Label 4025*/ GIMT_Encode4(211028), // Rule ID 11904 //
     /* 210996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 210999 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211004 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211007 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211010 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211013 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211017 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1875:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_S),
     /* 211020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211026 */     GIR_RootConstrainSelectedInstOperands,
     /* 211027 */     // GIR_Coverage, 11904,
     /* 211027 */     GIR_EraseRootFromParent_Done,
     /* 211028 */   // Label 4025: @211028
     /* 211028 */   GIM_Try, /*On fail goto*//*Label 4026*/ GIMT_Encode4(211065), // Rule ID 11905 //
     /* 211033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssublbt),
     /* 211041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211050 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211054 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1875:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLBT_ZZZ_D),
     /* 211057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211059 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211063 */     GIR_RootConstrainSelectedInstOperands,
     /* 211064 */     // GIR_Coverage, 11905,
     /* 211064 */     GIR_EraseRootFromParent_Done,
     /* 211065 */   // Label 4026: @211065
     /* 211065 */   GIM_Try, /*On fail goto*//*Label 4027*/ GIMT_Encode4(211102), // Rule ID 11906 //
     /* 211070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211073 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211078 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 211081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 211084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 211087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211091 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1877:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SSUBLTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 211091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_H),
     /* 211094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211100 */     GIR_RootConstrainSelectedInstOperands,
     /* 211101 */     // GIR_Coverage, 11906,
     /* 211101 */     GIR_EraseRootFromParent_Done,
     /* 211102 */   // Label 4027: @211102
     /* 211102 */   GIM_Try, /*On fail goto*//*Label 4028*/ GIMT_Encode4(211139), // Rule ID 11907 //
     /* 211107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 211118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 211121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 211124 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211128 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1877:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SSUBLTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 211128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_S),
     /* 211131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211137 */     GIR_RootConstrainSelectedInstOperands,
     /* 211138 */     // GIR_Coverage, 11907,
     /* 211138 */     GIR_EraseRootFromParent_Done,
     /* 211139 */   // Label 4028: @211139
     /* 211139 */   GIM_Try, /*On fail goto*//*Label 4029*/ GIMT_Encode4(211176), // Rule ID 11908 //
     /* 211144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211147 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssubltb),
     /* 211152 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 211155 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 211158 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 211161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 211165 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1877:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SSUBLTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 211165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSUBLTB_ZZZ_D),
     /* 211168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 211170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211174 */     GIR_RootConstrainSelectedInstOperands,
     /* 211175 */     // GIR_Coverage, 11908,
     /* 211175 */     GIR_EraseRootFromParent_Done,
     /* 211176 */   // Label 4029: @211176
     /* 211176 */   GIM_Try, /*On fail goto*//*Label 4030*/ GIMT_Encode4(211216), // Rule ID 11995 //
     /* 211181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211202 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_B),
     /* 211205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211214 */     GIR_RootConstrainSelectedInstOperands,
     /* 211215 */     // GIR_Coverage, 11995,
     /* 211215 */     GIR_EraseRootFromParent_Done,
     /* 211216 */   // Label 4030: @211216
     /* 211216 */   GIM_Try, /*On fail goto*//*Label 4031*/ GIMT_Encode4(211256), // Rule ID 11996 //
     /* 211221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211242 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_H),
     /* 211245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211254 */     GIR_RootConstrainSelectedInstOperands,
     /* 211255 */     // GIR_Coverage, 11996,
     /* 211255 */     GIR_EraseRootFromParent_Done,
     /* 211256 */   // Label 4031: @211256
     /* 211256 */   GIM_Try, /*On fail goto*//*Label 4032*/ GIMT_Encode4(211296), // Rule ID 11997 //
     /* 211261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211282 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_S),
     /* 211285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211294 */     GIR_RootConstrainSelectedInstOperands,
     /* 211295 */     // GIR_Coverage, 11997,
     /* 211295 */     GIR_EraseRootFromParent_Done,
     /* 211296 */   // Label 4032: @211296
     /* 211296 */   GIM_Try, /*On fail goto*//*Label 4033*/ GIMT_Encode4(211336), // Rule ID 11998 //
     /* 211301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211322 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGE_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PWW_D),
     /* 211325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211334 */     GIR_RootConstrainSelectedInstOperands,
     /* 211335 */     // GIR_Coverage, 11998,
     /* 211335 */     GIR_EraseRootFromParent_Done,
     /* 211336 */   // Label 4033: @211336
     /* 211336 */   GIM_Try, /*On fail goto*//*Label 4034*/ GIMT_Encode4(211376), // Rule ID 11999 //
     /* 211341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_B),
     /* 211365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211374 */     GIR_RootConstrainSelectedInstOperands,
     /* 211375 */     // GIR_Coverage, 11999,
     /* 211375 */     GIR_EraseRootFromParent_Done,
     /* 211376 */   // Label 4034: @211376
     /* 211376 */   GIM_Try, /*On fail goto*//*Label 4035*/ GIMT_Encode4(211416), // Rule ID 12000 //
     /* 211381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211402 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_H),
     /* 211405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211414 */     GIR_RootConstrainSelectedInstOperands,
     /* 211415 */     // GIR_Coverage, 12000,
     /* 211415 */     GIR_EraseRootFromParent_Done,
     /* 211416 */   // Label 4035: @211416
     /* 211416 */   GIM_Try, /*On fail goto*//*Label 4036*/ GIMT_Encode4(211456), // Rule ID 12001 //
     /* 211421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211442 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_S),
     /* 211445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211454 */     GIR_RootConstrainSelectedInstOperands,
     /* 211455 */     // GIR_Coverage, 12001,
     /* 211455 */     GIR_EraseRootFromParent_Done,
     /* 211456 */   // Label 4036: @211456
     /* 211456 */   GIM_Try, /*On fail goto*//*Label 4037*/ GIMT_Encode4(211496), // Rule ID 12002 //
     /* 211461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211482 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEGT_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PWW_D),
     /* 211485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211491 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211494 */     GIR_RootConstrainSelectedInstOperands,
     /* 211495 */     // GIR_Coverage, 12002,
     /* 211495 */     GIR_EraseRootFromParent_Done,
     /* 211496 */   // Label 4037: @211496
     /* 211496 */   GIM_Try, /*On fail goto*//*Label 4038*/ GIMT_Encode4(211536), // Rule ID 12007 //
     /* 211501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211518 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211522 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_B),
     /* 211525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211531 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211534 */     GIR_RootConstrainSelectedInstOperands,
     /* 211535 */     // GIR_Coverage, 12007,
     /* 211535 */     GIR_EraseRootFromParent_Done,
     /* 211536 */   // Label 4038: @211536
     /* 211536 */   GIM_Try, /*On fail goto*//*Label 4039*/ GIMT_Encode4(211576), // Rule ID 12008 //
     /* 211541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211544 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211549 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211562 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_H),
     /* 211565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211571 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211574 */     GIR_RootConstrainSelectedInstOperands,
     /* 211575 */     // GIR_Coverage, 12008,
     /* 211575 */     GIR_EraseRootFromParent_Done,
     /* 211576 */   // Label 4039: @211576
     /* 211576 */   GIM_Try, /*On fail goto*//*Label 4040*/ GIMT_Encode4(211616), // Rule ID 12009 //
     /* 211581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211598 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211602 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211602 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_S),
     /* 211605 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211607 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211609 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211611 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211614 */     GIR_RootConstrainSelectedInstOperands,
     /* 211615 */     // GIR_Coverage, 12009,
     /* 211615 */     GIR_EraseRootFromParent_Done,
     /* 211616 */   // Label 4040: @211616
     /* 211616 */   GIM_Try, /*On fail goto*//*Label 4041*/ GIMT_Encode4(211656), // Rule ID 12010 //
     /* 211621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 211629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211638 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211642 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHS_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PWW_D),
     /* 211645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211651 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211654 */     GIR_RootConstrainSelectedInstOperands,
     /* 211655 */     // GIR_Coverage, 12010,
     /* 211655 */     GIR_EraseRootFromParent_Done,
     /* 211656 */   // Label 4041: @211656
     /* 211656 */   GIM_Try, /*On fail goto*//*Label 4042*/ GIMT_Encode4(211696), // Rule ID 12011 //
     /* 211661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211678 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211682 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_B),
     /* 211685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211687 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211689 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211691 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211694 */     GIR_RootConstrainSelectedInstOperands,
     /* 211695 */     // GIR_Coverage, 12011,
     /* 211695 */     GIR_EraseRootFromParent_Done,
     /* 211696 */   // Label 4042: @211696
     /* 211696 */   GIM_Try, /*On fail goto*//*Label 4043*/ GIMT_Encode4(211736), // Rule ID 12012 //
     /* 211701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211704 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211709 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211712 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211715 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211718 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211722 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_H),
     /* 211725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211731 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211734 */     GIR_RootConstrainSelectedInstOperands,
     /* 211735 */     // GIR_Coverage, 12012,
     /* 211735 */     GIR_EraseRootFromParent_Done,
     /* 211736 */   // Label 4043: @211736
     /* 211736 */   GIM_Try, /*On fail goto*//*Label 4044*/ GIMT_Encode4(211776), // Rule ID 12013 //
     /* 211741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211744 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211749 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211752 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211755 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211758 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211762 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_S),
     /* 211765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211771 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211774 */     GIR_RootConstrainSelectedInstOperands,
     /* 211775 */     // GIR_Coverage, 12013,
     /* 211775 */     GIR_EraseRootFromParent_Done,
     /* 211776 */   // Label 4044: @211776
     /* 211776 */   GIM_Try, /*On fail goto*//*Label 4045*/ GIMT_Encode4(211816), // Rule ID 12014 //
     /* 211781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 211789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 211795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 211798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211802 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i32:{ *:[i32] }:$Op1, i32:{ *:[i32] }:$Op2)  =>  (WHILEHI_PWW_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i32] }:$Op1, ?:{ *:[i32] }:$Op2)
     /* 211802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PWW_D),
     /* 211805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211811 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211814 */     GIR_RootConstrainSelectedInstOperands,
     /* 211815 */     // GIR_Coverage, 12014,
     /* 211815 */     GIR_EraseRootFromParent_Done,
     /* 211816 */   // Label 4045: @211816
     /* 211816 */   GIM_Try, /*On fail goto*//*Label 4046*/ GIMT_Encode4(211856), // Rule ID 12019 //
     /* 211821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211838 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211842 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211842 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_B),
     /* 211845 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211851 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211854 */     GIR_RootConstrainSelectedInstOperands,
     /* 211855 */     // GIR_Coverage, 12019,
     /* 211855 */     GIR_EraseRootFromParent_Done,
     /* 211856 */   // Label 4046: @211856
     /* 211856 */   GIM_Try, /*On fail goto*//*Label 4047*/ GIMT_Encode4(211896), // Rule ID 12020 //
     /* 211861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 211872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211875 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211882 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_H),
     /* 211885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211891 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211894 */     GIR_RootConstrainSelectedInstOperands,
     /* 211895 */     // GIR_Coverage, 12020,
     /* 211895 */     GIR_EraseRootFromParent_Done,
     /* 211896 */   // Label 4047: @211896
     /* 211896 */   GIM_Try, /*On fail goto*//*Label 4048*/ GIMT_Encode4(211936), // Rule ID 12021 //
     /* 211901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211904 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211909 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 211912 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211915 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211918 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211922 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_S),
     /* 211925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211927 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211929 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211931 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211934 */     GIR_RootConstrainSelectedInstOperands,
     /* 211935 */     // GIR_Coverage, 12021,
     /* 211935 */     GIR_EraseRootFromParent_Done,
     /* 211936 */   // Label 4048: @211936
     /* 211936 */   GIM_Try, /*On fail goto*//*Label 4049*/ GIMT_Encode4(211976), // Rule ID 12022 //
     /* 211941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilege),
     /* 211949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 211952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 211962 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2097:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGE_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 211962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGE_PXX_D),
     /* 211965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 211967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 211969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 211971 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 211974 */     GIR_RootConstrainSelectedInstOperands,
     /* 211975 */     // GIR_Coverage, 12022,
     /* 211975 */     GIR_EraseRootFromParent_Done,
     /* 211976 */   // Label 4049: @211976
     /* 211976 */   GIM_Try, /*On fail goto*//*Label 4050*/ GIMT_Encode4(212016), // Rule ID 12023 //
     /* 211981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 211984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 211989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 211992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 211995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 211998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212002 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_B),
     /* 212005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212007 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212011 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212014 */     GIR_RootConstrainSelectedInstOperands,
     /* 212015 */     // GIR_Coverage, 12023,
     /* 212015 */     GIR_EraseRootFromParent_Done,
     /* 212016 */   // Label 4050: @212016
     /* 212016 */   GIM_Try, /*On fail goto*//*Label 4051*/ GIMT_Encode4(212056), // Rule ID 12024 //
     /* 212021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212029 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212032 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212035 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212042 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_H),
     /* 212045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212051 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212054 */     GIR_RootConstrainSelectedInstOperands,
     /* 212055 */     // GIR_Coverage, 12024,
     /* 212055 */     GIR_EraseRootFromParent_Done,
     /* 212056 */   // Label 4051: @212056
     /* 212056 */   GIM_Try, /*On fail goto*//*Label 4052*/ GIMT_Encode4(212096), // Rule ID 12025 //
     /* 212061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212078 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212082 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_S),
     /* 212085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212087 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212091 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212094 */     GIR_RootConstrainSelectedInstOperands,
     /* 212095 */     // GIR_Coverage, 12025,
     /* 212095 */     GIR_EraseRootFromParent_Done,
     /* 212096 */   // Label 4052: @212096
     /* 212096 */   GIM_Try, /*On fail goto*//*Label 4053*/ GIMT_Encode4(212136), // Rule ID 12026 //
     /* 212101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilegt),
     /* 212109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212122 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2103:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEGT_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEGT_PXX_D),
     /* 212125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212131 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212134 */     GIR_RootConstrainSelectedInstOperands,
     /* 212135 */     // GIR_Coverage, 12026,
     /* 212135 */     GIR_EraseRootFromParent_Done,
     /* 212136 */   // Label 4053: @212136
     /* 212136 */   GIM_Try, /*On fail goto*//*Label 4054*/ GIMT_Encode4(212176), // Rule ID 12031 //
     /* 212141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212158 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212162 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_B),
     /* 212165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212167 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212171 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212174 */     GIR_RootConstrainSelectedInstOperands,
     /* 212175 */     // GIR_Coverage, 12031,
     /* 212175 */     GIR_EraseRootFromParent_Done,
     /* 212176 */   // Label 4054: @212176
     /* 212176 */   GIM_Try, /*On fail goto*//*Label 4055*/ GIMT_Encode4(212216), // Rule ID 12032 //
     /* 212181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212184 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212189 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212192 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212195 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212202 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_H),
     /* 212205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212207 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212209 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212211 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212214 */     GIR_RootConstrainSelectedInstOperands,
     /* 212215 */     // GIR_Coverage, 12032,
     /* 212215 */     GIR_EraseRootFromParent_Done,
     /* 212216 */   // Label 4055: @212216
     /* 212216 */   GIM_Try, /*On fail goto*//*Label 4056*/ GIMT_Encode4(212256), // Rule ID 12033 //
     /* 212221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212242 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_S),
     /* 212245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212249 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212254 */     GIR_RootConstrainSelectedInstOperands,
     /* 212255 */     // GIR_Coverage, 12033,
     /* 212255 */     GIR_EraseRootFromParent_Done,
     /* 212256 */   // Label 4056: @212256
     /* 212256 */   GIM_Try, /*On fail goto*//*Label 4057*/ GIMT_Encode4(212296), // Rule ID 12034 //
     /* 212261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehs),
     /* 212269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212278 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212282 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2115:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHS_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHS_PXX_D),
     /* 212285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212291 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212294 */     GIR_RootConstrainSelectedInstOperands,
     /* 212295 */     // GIR_Coverage, 12034,
     /* 212295 */     GIR_EraseRootFromParent_Done,
     /* 212296 */   // Label 4057: @212296
     /* 212296 */   GIM_Try, /*On fail goto*//*Label 4058*/ GIMT_Encode4(212336), // Rule ID 12035 //
     /* 212301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 212312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212318 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212322 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_B),
     /* 212325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212327 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212329 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212331 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212334 */     GIR_RootConstrainSelectedInstOperands,
     /* 212335 */     // GIR_Coverage, 12035,
     /* 212335 */     GIR_EraseRootFromParent_Done,
     /* 212336 */   // Label 4058: @212336
     /* 212336 */   GIM_Try, /*On fail goto*//*Label 4059*/ GIMT_Encode4(212376), // Rule ID 12036 //
     /* 212341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 212352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212362 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_H),
     /* 212365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212371 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212374 */     GIR_RootConstrainSelectedInstOperands,
     /* 212375 */     // GIR_Coverage, 12036,
     /* 212375 */     GIR_EraseRootFromParent_Done,
     /* 212376 */   // Label 4059: @212376
     /* 212376 */   GIM_Try, /*On fail goto*//*Label 4060*/ GIMT_Encode4(212416), // Rule ID 12037 //
     /* 212381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 212392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212398 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212402 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212402 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_S),
     /* 212405 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212407 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212409 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212411 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212414 */     GIR_RootConstrainSelectedInstOperands,
     /* 212415 */     // GIR_Coverage, 12037,
     /* 212415 */     GIR_EraseRootFromParent_Done,
     /* 212416 */   // Label 4060: @212416
     /* 212416 */   GIM_Try, /*On fail goto*//*Label 4061*/ GIMT_Encode4(212456), // Rule ID 12038 //
     /* 212421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 212424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilehi),
     /* 212429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 212432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 212435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 212438 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 212442 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2109:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEHI_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 212442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEHI_PXX_D),
     /* 212445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 212447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212451 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 212454 */     GIR_RootConstrainSelectedInstOperands,
     /* 212455 */     // GIR_Coverage, 12038,
     /* 212455 */     GIR_EraseRootFromParent_Done,
     /* 212456 */   // Label 4061: @212456
     /* 212456 */   GIM_Try, /*On fail goto*//*Label 4062*/ GIMT_Encode4(212493), // Rule ID 12048 //
     /* 212461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_AES_HasSVEAES),
     /* 212464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmullt_pair),
     /* 212469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212482 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1639:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (PMULLT_ZZZ_Q:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMULLT_ZZZ_Q),
     /* 212485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212487 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212491 */     GIR_RootConstrainSelectedInstOperands,
     /* 212492 */     // GIR_Coverage, 12048,
     /* 212492 */     GIR_EraseRootFromParent_Done,
     /* 212493 */   // Label 4062: @212493
     /* 212493 */   GIM_Try, /*On fail goto*//*Label 4063*/ GIMT_Encode4(212530), // Rule ID 12049 //
     /* 212498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2SHA3),
     /* 212501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rax1),
     /* 212506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1671:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (RAX1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RAX1_ZZZ_D),
     /* 212522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212528 */     GIR_RootConstrainSelectedInstOperands,
     /* 212529 */     // GIR_Coverage, 12049,
     /* 212529 */     GIR_EraseRootFromParent_Done,
     /* 212530 */   // Label 4063: @212530
     /* 212530 */   GIM_Try, /*On fail goto*//*Label 4064*/ GIMT_Encode4(212567), // Rule ID 12050 //
     /* 212535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212552 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212556 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1279:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BDEP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_B),
     /* 212559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212565 */     GIR_RootConstrainSelectedInstOperands,
     /* 212566 */     // GIR_Coverage, 12050,
     /* 212566 */     GIR_EraseRootFromParent_Done,
     /* 212567 */   // Label 4064: @212567
     /* 212567 */   GIM_Try, /*On fail goto*//*Label 4065*/ GIMT_Encode4(212604), // Rule ID 12051 //
     /* 212572 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212575 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212580 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212583 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212586 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212593 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1279:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BDEP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_H),
     /* 212596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212602 */     GIR_RootConstrainSelectedInstOperands,
     /* 212603 */     // GIR_Coverage, 12051,
     /* 212603 */     GIR_EraseRootFromParent_Done,
     /* 212604 */   // Label 4065: @212604
     /* 212604 */   GIM_Try, /*On fail goto*//*Label 4066*/ GIMT_Encode4(212641), // Rule ID 12052 //
     /* 212609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212612 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212617 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212620 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212623 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212626 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212630 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1279:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BDEP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_S),
     /* 212633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212639 */     GIR_RootConstrainSelectedInstOperands,
     /* 212640 */     // GIR_Coverage, 12052,
     /* 212640 */     GIR_EraseRootFromParent_Done,
     /* 212641 */   // Label 4066: @212641
     /* 212641 */   GIM_Try, /*On fail goto*//*Label 4067*/ GIMT_Encode4(212678), // Rule ID 12053 //
     /* 212646 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212649 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bdep_x),
     /* 212654 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212667 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1279:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BDEP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BDEP_ZZZ_D),
     /* 212670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212676 */     GIR_RootConstrainSelectedInstOperands,
     /* 212677 */     // GIR_Coverage, 12053,
     /* 212677 */     GIR_EraseRootFromParent_Done,
     /* 212678 */   // Label 4067: @212678
     /* 212678 */   GIM_Try, /*On fail goto*//*Label 4068*/ GIMT_Encode4(212715), // Rule ID 12054 //
     /* 212683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 212694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 212697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 212700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212704 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1296:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BGRP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 212704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_B),
     /* 212707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212713 */     GIR_RootConstrainSelectedInstOperands,
     /* 212714 */     // GIR_Coverage, 12054,
     /* 212714 */     GIR_EraseRootFromParent_Done,
     /* 212715 */   // Label 4068: @212715
     /* 212715 */   GIM_Try, /*On fail goto*//*Label 4069*/ GIMT_Encode4(212752), // Rule ID 12055 //
     /* 212720 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212723 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212728 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 212731 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 212734 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212741 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1296:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BGRP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 212741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_H),
     /* 212744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212750 */     GIR_RootConstrainSelectedInstOperands,
     /* 212751 */     // GIR_Coverage, 12055,
     /* 212751 */     GIR_EraseRootFromParent_Done,
     /* 212752 */   // Label 4069: @212752
     /* 212752 */   GIM_Try, /*On fail goto*//*Label 4070*/ GIMT_Encode4(212789), // Rule ID 12056 //
     /* 212757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 212768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 212771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212774 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212778 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1296:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BGRP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 212778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_S),
     /* 212781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212787 */     GIR_RootConstrainSelectedInstOperands,
     /* 212788 */     // GIR_Coverage, 12056,
     /* 212788 */     GIR_EraseRootFromParent_Done,
     /* 212789 */   // Label 4070: @212789
     /* 212789 */   GIM_Try, /*On fail goto*//*Label 4071*/ GIMT_Encode4(212826), // Rule ID 12057 //
     /* 212794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNonStreamingSVE2_or_SSVE_BitPerm_HasSVEBitPerm),
     /* 212797 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bgrp_x),
     /* 212802 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 212805 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 212808 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 212815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1296:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BGRP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 212815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BGRP_ZZZ_D),
     /* 212818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 212820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212824 */     GIR_RootConstrainSelectedInstOperands,
     /* 212825 */     // GIR_Coverage, 12057,
     /* 212825 */     GIR_EraseRootFromParent_Done,
     /* 212826 */   // Label 4071: @212826
     /* 212826 */   GIM_Try, /*On fail goto*//*Label 4072*/ GIMT_Encode4(212863), // Rule ID 12170 //
     /* 212831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212848 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212852 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1445:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 212852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_H),
     /* 212855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212857 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212859 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212861 */     GIR_RootConstrainSelectedInstOperands,
     /* 212862 */     // GIR_Coverage, 12170,
     /* 212862 */     GIR_EraseRootFromParent_Done,
     /* 212863 */   // Label 4072: @212863
     /* 212863 */   GIM_Try, /*On fail goto*//*Label 4073*/ GIMT_Encode4(212900), // Rule ID 12171 //
     /* 212868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212871 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212876 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212889 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1445:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 212889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_S),
     /* 212892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212898 */     GIR_RootConstrainSelectedInstOperands,
     /* 212899 */     // GIR_Coverage, 12171,
     /* 212899 */     GIR_EraseRootFromParent_Done,
     /* 212900 */   // Label 4073: @212900
     /* 212900 */   GIM_Try, /*On fail goto*//*Label 4074*/ GIMT_Encode4(212937), // Rule ID 12172 //
     /* 212905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmqv),
     /* 212913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 212916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 212919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 212922 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212926 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1445:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 212926 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMQV_D),
     /* 212929 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212931 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212935 */     GIR_RootConstrainSelectedInstOperands,
     /* 212936 */     // GIR_Coverage, 12172,
     /* 212936 */     GIR_EraseRootFromParent_Done,
     /* 212937 */   // Label 4074: @212937
     /* 212937 */   GIM_Try, /*On fail goto*//*Label 4075*/ GIMT_Encode4(212974), // Rule ID 12173 //
     /* 212942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212945 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 212950 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 212953 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 212956 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 212959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 212963 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1463:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINNMQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 212963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_H),
     /* 212966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 212968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 212970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 212972 */     GIR_RootConstrainSelectedInstOperands,
     /* 212973 */     // GIR_Coverage, 12173,
     /* 212973 */     GIR_EraseRootFromParent_Done,
     /* 212974 */   // Label 4075: @212974
     /* 212974 */   GIM_Try, /*On fail goto*//*Label 4076*/ GIMT_Encode4(213011), // Rule ID 12174 //
     /* 212979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 212982 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 212987 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 212990 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 212993 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 212996 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213000 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1463:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINNMQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_S),
     /* 213003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213007 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213009 */     GIR_RootConstrainSelectedInstOperands,
     /* 213010 */     // GIR_Coverage, 12174,
     /* 213010 */     GIR_EraseRootFromParent_Done,
     /* 213011 */   // Label 4076: @213011
     /* 213011 */   GIM_Try, /*On fail goto*//*Label 4077*/ GIMT_Encode4(213048), // Rule ID 12175 //
     /* 213016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmqv),
     /* 213024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213033 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213037 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1463:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINNMQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMQV_D),
     /* 213040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213042 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213046 */     GIR_RootConstrainSelectedInstOperands,
     /* 213047 */     // GIR_Coverage, 12175,
     /* 213047 */     GIR_EraseRootFromParent_Done,
     /* 213048 */   // Label 4077: @213048
     /* 213048 */   GIM_Try, /*On fail goto*//*Label 4078*/ GIMT_Encode4(213085), // Rule ID 12176 //
     /* 213053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213070 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213074 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1448:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMAXQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_H),
     /* 213077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213083 */     GIR_RootConstrainSelectedInstOperands,
     /* 213084 */     // GIR_Coverage, 12176,
     /* 213084 */     GIR_EraseRootFromParent_Done,
     /* 213085 */   // Label 4078: @213085
     /* 213085 */   GIM_Try, /*On fail goto*//*Label 4079*/ GIMT_Encode4(213122), // Rule ID 12177 //
     /* 213090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213093 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213098 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213111 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1448:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMAXQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_S),
     /* 213114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213120 */     GIR_RootConstrainSelectedInstOperands,
     /* 213121 */     // GIR_Coverage, 12177,
     /* 213121 */     GIR_EraseRootFromParent_Done,
     /* 213122 */   // Label 4079: @213122
     /* 213122 */   GIM_Try, /*On fail goto*//*Label 4080*/ GIMT_Encode4(213159), // Rule ID 12178 //
     /* 213127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxqv),
     /* 213135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213148 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1448:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMAXQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXQV_D),
     /* 213151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213153 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213155 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213157 */     GIR_RootConstrainSelectedInstOperands,
     /* 213158 */     // GIR_Coverage, 12178,
     /* 213158 */     GIR_EraseRootFromParent_Done,
     /* 213159 */   // Label 4080: @213159
     /* 213159 */   GIM_Try, /*On fail goto*//*Label 4081*/ GIMT_Encode4(213196), // Rule ID 12179 //
     /* 213164 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213167 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213172 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213175 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213178 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213185 */     // (intrinsic_wo_chain:{ *:[v8f16] } 1466:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMINQV_H:{ *:[v8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 213185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_H),
     /* 213188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213194 */     GIR_RootConstrainSelectedInstOperands,
     /* 213195 */     // GIR_Coverage, 12179,
     /* 213195 */     GIR_EraseRootFromParent_Done,
     /* 213196 */   // Label 4081: @213196
     /* 213196 */   GIM_Try, /*On fail goto*//*Label 4082*/ GIMT_Encode4(213233), // Rule ID 12180 //
     /* 213201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213222 */     // (intrinsic_wo_chain:{ *:[v4f32] } 1466:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMINQV_S:{ *:[v4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 213222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_S),
     /* 213225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213231 */     GIR_RootConstrainSelectedInstOperands,
     /* 213232 */     // GIR_Coverage, 12180,
     /* 213232 */     GIR_EraseRootFromParent_Done,
     /* 213233 */   // Label 4082: @213233
     /* 213233 */   GIM_Try, /*On fail goto*//*Label 4083*/ GIMT_Encode4(213270), // Rule ID 12181 //
     /* 213238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminqv),
     /* 213246 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213249 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213252 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213259 */     // (intrinsic_wo_chain:{ *:[v2f64] } 1466:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMINQV_D:{ *:[v2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 213259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINQV_D),
     /* 213262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213268 */     GIR_RootConstrainSelectedInstOperands,
     /* 213269 */     // GIR_Coverage, 12181,
     /* 213269 */     GIR_EraseRootFromParent_Done,
     /* 213270 */   // Label 4083: @213270
     /* 213270 */   GIM_Try, /*On fail goto*//*Label 4084*/ GIMT_Encode4(213307), // Rule ID 12182 //
     /* 213275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213296 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1360:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (EORQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_B),
     /* 213299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213305 */     GIR_RootConstrainSelectedInstOperands,
     /* 213306 */     // GIR_Coverage, 12182,
     /* 213306 */     GIR_EraseRootFromParent_Done,
     /* 213307 */   // Label 4084: @213307
     /* 213307 */   GIM_Try, /*On fail goto*//*Label 4085*/ GIMT_Encode4(213344), // Rule ID 12183 //
     /* 213312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213333 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1360:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (EORQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_H),
     /* 213336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213342 */     GIR_RootConstrainSelectedInstOperands,
     /* 213343 */     // GIR_Coverage, 12183,
     /* 213343 */     GIR_EraseRootFromParent_Done,
     /* 213344 */   // Label 4085: @213344
     /* 213344 */   GIM_Try, /*On fail goto*//*Label 4086*/ GIMT_Encode4(213381), // Rule ID 12184 //
     /* 213349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213370 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1360:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (EORQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_S),
     /* 213373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213379 */     GIR_RootConstrainSelectedInstOperands,
     /* 213380 */     // GIR_Coverage, 12184,
     /* 213380 */     GIR_EraseRootFromParent_Done,
     /* 213381 */   // Label 4086: @213381
     /* 213381 */   GIM_Try, /*On fail goto*//*Label 4087*/ GIMT_Encode4(213418), // Rule ID 12185 //
     /* 213386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213389 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorqv),
     /* 213394 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213397 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213400 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213407 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1360:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (EORQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORQV_VPZ_D),
     /* 213410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213416 */     GIR_RootConstrainSelectedInstOperands,
     /* 213417 */     // GIR_Coverage, 12185,
     /* 213417 */     GIR_EraseRootFromParent_Done,
     /* 213418 */   // Label 4087: @213418
     /* 213418 */   GIM_Try, /*On fail goto*//*Label 4088*/ GIMT_Encode4(213455), // Rule ID 12186 //
     /* 213423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213444 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1272:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ANDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_B),
     /* 213447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213453 */     GIR_RootConstrainSelectedInstOperands,
     /* 213454 */     // GIR_Coverage, 12186,
     /* 213454 */     GIR_EraseRootFromParent_Done,
     /* 213455 */   // Label 4088: @213455
     /* 213455 */   GIM_Try, /*On fail goto*//*Label 4089*/ GIMT_Encode4(213492), // Rule ID 12187 //
     /* 213460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213481 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1272:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ANDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_H),
     /* 213484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213486 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213490 */     GIR_RootConstrainSelectedInstOperands,
     /* 213491 */     // GIR_Coverage, 12187,
     /* 213491 */     GIR_EraseRootFromParent_Done,
     /* 213492 */   // Label 4089: @213492
     /* 213492 */   GIM_Try, /*On fail goto*//*Label 4090*/ GIMT_Encode4(213529), // Rule ID 12188 //
     /* 213497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213518 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1272:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ANDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_S),
     /* 213521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213527 */     GIR_RootConstrainSelectedInstOperands,
     /* 213528 */     // GIR_Coverage, 12188,
     /* 213528 */     GIR_EraseRootFromParent_Done,
     /* 213529 */   // Label 4090: @213529
     /* 213529 */   GIM_Try, /*On fail goto*//*Label 4091*/ GIMT_Encode4(213566), // Rule ID 12189 //
     /* 213534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213537 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_andqv),
     /* 213542 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213545 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213548 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213555 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1272:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ANDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ANDQV_VPZ_D),
     /* 213558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213562 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213564 */     GIR_RootConstrainSelectedInstOperands,
     /* 213565 */     // GIR_Coverage, 12189,
     /* 213565 */     GIR_EraseRootFromParent_Done,
     /* 213566 */   // Label 4091: @213566
     /* 213566 */   GIM_Try, /*On fail goto*//*Label 4092*/ GIMT_Encode4(213603), // Rule ID 12190 //
     /* 213571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213592 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1260:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ADDQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_B),
     /* 213595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213601 */     GIR_RootConstrainSelectedInstOperands,
     /* 213602 */     // GIR_Coverage, 12190,
     /* 213602 */     GIR_EraseRootFromParent_Done,
     /* 213603 */   // Label 4092: @213603
     /* 213603 */   GIM_Try, /*On fail goto*//*Label 4093*/ GIMT_Encode4(213640), // Rule ID 12191 //
     /* 213608 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213611 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213616 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213619 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213622 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213629 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1260:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ADDQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_H),
     /* 213632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213638 */     GIR_RootConstrainSelectedInstOperands,
     /* 213639 */     // GIR_Coverage, 12191,
     /* 213639 */     GIR_EraseRootFromParent_Done,
     /* 213640 */   // Label 4093: @213640
     /* 213640 */   GIM_Try, /*On fail goto*//*Label 4094*/ GIMT_Encode4(213677), // Rule ID 12192 //
     /* 213645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213662 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213666 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1260:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ADDQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_S),
     /* 213669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213673 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213675 */     GIR_RootConstrainSelectedInstOperands,
     /* 213676 */     // GIR_Coverage, 12192,
     /* 213676 */     GIR_EraseRootFromParent_Done,
     /* 213677 */   // Label 4094: @213677
     /* 213677 */   GIM_Try, /*On fail goto*//*Label 4095*/ GIMT_Encode4(213714), // Rule ID 12193 //
     /* 213682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213685 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addqv),
     /* 213690 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213693 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213696 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213703 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1260:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ADDQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDQV_VPZ_D),
     /* 213706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213712 */     GIR_RootConstrainSelectedInstOperands,
     /* 213713 */     // GIR_Coverage, 12193,
     /* 213713 */     GIR_EraseRootFromParent_Done,
     /* 213714 */   // Label 4095: @213714
     /* 213714 */   GIM_Try, /*On fail goto*//*Label 4096*/ GIMT_Encode4(213751), // Rule ID 12194 //
     /* 213719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213736 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213740 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1739:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_B),
     /* 213743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213749 */     GIR_RootConstrainSelectedInstOperands,
     /* 213750 */     // GIR_Coverage, 12194,
     /* 213750 */     GIR_EraseRootFromParent_Done,
     /* 213751 */   // Label 4096: @213751
     /* 213751 */   GIM_Try, /*On fail goto*//*Label 4097*/ GIMT_Encode4(213788), // Rule ID 12195 //
     /* 213756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213777 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1739:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_H),
     /* 213780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213786 */     GIR_RootConstrainSelectedInstOperands,
     /* 213787 */     // GIR_Coverage, 12195,
     /* 213787 */     GIR_EraseRootFromParent_Done,
     /* 213788 */   // Label 4097: @213788
     /* 213788 */   GIM_Try, /*On fail goto*//*Label 4098*/ GIMT_Encode4(213825), // Rule ID 12196 //
     /* 213793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213814 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1739:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_S),
     /* 213817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213819 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213821 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213823 */     GIR_RootConstrainSelectedInstOperands,
     /* 213824 */     // GIR_Coverage, 12196,
     /* 213824 */     GIR_EraseRootFromParent_Done,
     /* 213825 */   // Label 4098: @213825
     /* 213825 */   GIM_Try, /*On fail goto*//*Label 4099*/ GIMT_Encode4(213862), // Rule ID 12197 //
     /* 213830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxqv),
     /* 213838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213851 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1739:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXQV_VPZ_D),
     /* 213854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213860 */     GIR_RootConstrainSelectedInstOperands,
     /* 213861 */     // GIR_Coverage, 12197,
     /* 213861 */     GIR_EraseRootFromParent_Done,
     /* 213862 */   // Label 4099: @213862
     /* 213862 */   GIM_Try, /*On fail goto*//*Label 4100*/ GIMT_Encode4(213899), // Rule ID 12198 //
     /* 213867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213870 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213875 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 213878 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 213881 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 213884 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213888 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1977:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMAXQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 213888 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_B),
     /* 213891 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213893 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213897 */     GIR_RootConstrainSelectedInstOperands,
     /* 213898 */     // GIR_Coverage, 12198,
     /* 213898 */     GIR_EraseRootFromParent_Done,
     /* 213899 */   // Label 4100: @213899
     /* 213899 */   GIM_Try, /*On fail goto*//*Label 4101*/ GIMT_Encode4(213936), // Rule ID 12199 //
     /* 213904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213907 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213912 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 213915 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 213918 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 213921 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213925 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1977:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMAXQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 213925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_H),
     /* 213928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213934 */     GIR_RootConstrainSelectedInstOperands,
     /* 213935 */     // GIR_Coverage, 12199,
     /* 213935 */     GIR_EraseRootFromParent_Done,
     /* 213936 */   // Label 4101: @213936
     /* 213936 */   GIM_Try, /*On fail goto*//*Label 4102*/ GIMT_Encode4(213973), // Rule ID 12200 //
     /* 213941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 213952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 213955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 213958 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213962 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1977:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMAXQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 213962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_S),
     /* 213965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 213967 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 213969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 213971 */     GIR_RootConstrainSelectedInstOperands,
     /* 213972 */     // GIR_Coverage, 12200,
     /* 213972 */     GIR_EraseRootFromParent_Done,
     /* 213973 */   // Label 4102: @213973
     /* 213973 */   GIM_Try, /*On fail goto*//*Label 4103*/ GIMT_Encode4(214010), // Rule ID 12201 //
     /* 213978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 213981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxqv),
     /* 213986 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 213989 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 213992 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 213995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 213999 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1977:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMAXQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 213999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXQV_VPZ_D),
     /* 214002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214008 */     GIR_RootConstrainSelectedInstOperands,
     /* 214009 */     // GIR_Coverage, 12201,
     /* 214009 */     GIR_EraseRootFromParent_Done,
     /* 214010 */   // Label 4103: @214010
     /* 214010 */   GIM_Try, /*On fail goto*//*Label 4104*/ GIMT_Encode4(214047), // Rule ID 12202 //
     /* 214015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214036 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1748:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_B),
     /* 214039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214045 */     GIR_RootConstrainSelectedInstOperands,
     /* 214046 */     // GIR_Coverage, 12202,
     /* 214046 */     GIR_EraseRootFromParent_Done,
     /* 214047 */   // Label 4104: @214047
     /* 214047 */   GIM_Try, /*On fail goto*//*Label 4105*/ GIMT_Encode4(214084), // Rule ID 12203 //
     /* 214052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214055 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214060 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214063 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214066 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214073 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1748:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_H),
     /* 214076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214082 */     GIR_RootConstrainSelectedInstOperands,
     /* 214083 */     // GIR_Coverage, 12203,
     /* 214083 */     GIR_EraseRootFromParent_Done,
     /* 214084 */   // Label 4105: @214084
     /* 214084 */   GIM_Try, /*On fail goto*//*Label 4106*/ GIMT_Encode4(214121), // Rule ID 12204 //
     /* 214089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214106 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214110 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1748:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_S),
     /* 214113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214115 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214119 */     GIR_RootConstrainSelectedInstOperands,
     /* 214120 */     // GIR_Coverage, 12204,
     /* 214120 */     GIR_EraseRootFromParent_Done,
     /* 214121 */   // Label 4106: @214121
     /* 214121 */   GIM_Try, /*On fail goto*//*Label 4107*/ GIMT_Encode4(214158), // Rule ID 12205 //
     /* 214126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminqv),
     /* 214134 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214137 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214140 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214147 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1748:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINQV_VPZ_D),
     /* 214150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214156 */     GIR_RootConstrainSelectedInstOperands,
     /* 214157 */     // GIR_Coverage, 12205,
     /* 214157 */     GIR_EraseRootFromParent_Done,
     /* 214158 */   // Label 4107: @214158
     /* 214158 */   GIM_Try, /*On fail goto*//*Label 4108*/ GIMT_Encode4(214195), // Rule ID 12206 //
     /* 214163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214166 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214171 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 214174 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 214177 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214184 */     // (intrinsic_wo_chain:{ *:[v16i8] } 1986:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UMINQV_VPZ_B:{ *:[v16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214184 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_B),
     /* 214187 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214189 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214191 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214193 */     GIR_RootConstrainSelectedInstOperands,
     /* 214194 */     // GIR_Coverage, 12206,
     /* 214194 */     GIR_EraseRootFromParent_Done,
     /* 214195 */   // Label 4108: @214195
     /* 214195 */   GIM_Try, /*On fail goto*//*Label 4109*/ GIMT_Encode4(214232), // Rule ID 12207 //
     /* 214200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 214211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 214214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214221 */     // (intrinsic_wo_chain:{ *:[v8i16] } 1986:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UMINQV_VPZ_H:{ *:[v8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214221 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_H),
     /* 214224 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214226 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214228 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214230 */     GIR_RootConstrainSelectedInstOperands,
     /* 214231 */     // GIR_Coverage, 12207,
     /* 214231 */     GIR_EraseRootFromParent_Done,
     /* 214232 */   // Label 4109: @214232
     /* 214232 */   GIM_Try, /*On fail goto*//*Label 4110*/ GIMT_Encode4(214269), // Rule ID 12208 //
     /* 214237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214240 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214245 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 214248 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 214251 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214254 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214258 */     // (intrinsic_wo_chain:{ *:[v4i32] } 1986:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UMINQV_VPZ_S:{ *:[v4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_S),
     /* 214261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214267 */     GIR_RootConstrainSelectedInstOperands,
     /* 214268 */     // GIR_Coverage, 12208,
     /* 214268 */     GIR_EraseRootFromParent_Done,
     /* 214269 */   // Label 4110: @214269
     /* 214269 */   GIM_Try, /*On fail goto*//*Label 4111*/ GIMT_Encode4(214306), // Rule ID 12209 //
     /* 214274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214277 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminqv),
     /* 214282 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 214285 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 214288 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 214295 */     // (intrinsic_wo_chain:{ *:[v2i64] } 1986:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UMINQV_VPZ_D:{ *:[v2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINQV_VPZ_D),
     /* 214298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 214300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214304 */     GIR_RootConstrainSelectedInstOperands,
     /* 214305 */     // GIR_Coverage, 12209,
     /* 214305 */     GIR_EraseRootFromParent_Done,
     /* 214306 */   // Label 4111: @214306
     /* 214306 */   GIM_Try, /*On fail goto*//*Label 4112*/ GIMT_Encode4(214343), // Rule ID 12210 //
     /* 214311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214332 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2170:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_B),
     /* 214335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214337 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214339 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214341 */     GIR_RootConstrainSelectedInstOperands,
     /* 214342 */     // GIR_Coverage, 12210,
     /* 214342 */     GIR_EraseRootFromParent_Done,
     /* 214343 */   // Label 4112: @214343
     /* 214343 */   GIM_Try, /*On fail goto*//*Label 4113*/ GIMT_Encode4(214380), // Rule ID 12211 //
     /* 214348 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214351 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214356 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214359 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214362 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214369 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2170:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214378 */     GIR_RootConstrainSelectedInstOperands,
     /* 214379 */     // GIR_Coverage, 12211,
     /* 214379 */     GIR_EraseRootFromParent_Done,
     /* 214380 */   // Label 4113: @214380
     /* 214380 */   GIM_Try, /*On fail goto*//*Label 4114*/ GIMT_Encode4(214417), // Rule ID 12212 //
     /* 214385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214406 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2170:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214411 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214413 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214415 */     GIR_RootConstrainSelectedInstOperands,
     /* 214416 */     // GIR_Coverage, 12212,
     /* 214416 */     GIR_EraseRootFromParent_Done,
     /* 214417 */   // Label 4114: @214417
     /* 214417 */   GIM_Try, /*On fail goto*//*Label 4115*/ GIMT_Encode4(214454), // Rule ID 12213 //
     /* 214422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214436 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214443 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2170:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214452 */     GIR_RootConstrainSelectedInstOperands,
     /* 214453 */     // GIR_Coverage, 12213,
     /* 214453 */     GIR_EraseRootFromParent_Done,
     /* 214454 */   // Label 4115: @214454
     /* 214454 */   GIM_Try, /*On fail goto*//*Label 4116*/ GIMT_Encode4(214491), // Rule ID 12214 //
     /* 214459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214476 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214480 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2170:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_H),
     /* 214483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214489 */     GIR_RootConstrainSelectedInstOperands,
     /* 214490 */     // GIR_Coverage, 12214,
     /* 214490 */     GIR_EraseRootFromParent_Done,
     /* 214491 */   // Label 4116: @214491
     /* 214491 */   GIM_Try, /*On fail goto*//*Label 4117*/ GIMT_Encode4(214528), // Rule ID 12215 //
     /* 214496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214517 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2170:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_S),
     /* 214520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214526 */     GIR_RootConstrainSelectedInstOperands,
     /* 214527 */     // GIR_Coverage, 12215,
     /* 214527 */     GIR_EraseRootFromParent_Done,
     /* 214528 */   // Label 4117: @214528
     /* 214528 */   GIM_Try, /*On fail goto*//*Label 4118*/ GIMT_Encode4(214565), // Rule ID 12216 //
     /* 214533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214536 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_zipq2),
     /* 214541 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214544 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214547 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214554 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2170:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIPQ2_ZZZ_D),
     /* 214557 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214563 */     GIR_RootConstrainSelectedInstOperands,
     /* 214564 */     // GIR_Coverage, 12216,
     /* 214564 */     GIR_EraseRootFromParent_Done,
     /* 214565 */   // Label 4118: @214565
     /* 214565 */   GIM_Try, /*On fail goto*//*Label 4119*/ GIMT_Encode4(214602), // Rule ID 12217 //
     /* 214570 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214573 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214578 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214581 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214584 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214591 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2095:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_B),
     /* 214594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214596 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214598 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214600 */     GIR_RootConstrainSelectedInstOperands,
     /* 214601 */     // GIR_Coverage, 12217,
     /* 214601 */     GIR_EraseRootFromParent_Done,
     /* 214602 */   // Label 4119: @214602
     /* 214602 */   GIM_Try, /*On fail goto*//*Label 4120*/ GIMT_Encode4(214639), // Rule ID 12218 //
     /* 214607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214615 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214628 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2095:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214633 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214635 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214637 */     GIR_RootConstrainSelectedInstOperands,
     /* 214638 */     // GIR_Coverage, 12218,
     /* 214638 */     GIR_EraseRootFromParent_Done,
     /* 214639 */   // Label 4120: @214639
     /* 214639 */   GIM_Try, /*On fail goto*//*Label 4121*/ GIMT_Encode4(214676), // Rule ID 12219 //
     /* 214644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214647 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214652 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214655 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2095:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214674 */     GIR_RootConstrainSelectedInstOperands,
     /* 214675 */     // GIR_Coverage, 12219,
     /* 214675 */     GIR_EraseRootFromParent_Done,
     /* 214676 */   // Label 4121: @214676
     /* 214676 */   GIM_Try, /*On fail goto*//*Label 4122*/ GIMT_Encode4(214713), // Rule ID 12220 //
     /* 214681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214698 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214702 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2095:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214705 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214707 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214709 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214711 */     GIR_RootConstrainSelectedInstOperands,
     /* 214712 */     // GIR_Coverage, 12220,
     /* 214712 */     GIR_EraseRootFromParent_Done,
     /* 214713 */   // Label 4122: @214713
     /* 214713 */   GIM_Try, /*On fail goto*//*Label 4123*/ GIMT_Encode4(214750), // Rule ID 12221 //
     /* 214718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214726 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214739 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2095:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_H),
     /* 214742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214748 */     GIR_RootConstrainSelectedInstOperands,
     /* 214749 */     // GIR_Coverage, 12221,
     /* 214749 */     GIR_EraseRootFromParent_Done,
     /* 214750 */   // Label 4123: @214750
     /* 214750 */   GIM_Try, /*On fail goto*//*Label 4124*/ GIMT_Encode4(214787), // Rule ID 12222 //
     /* 214755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214772 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214776 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2095:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 214776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_S),
     /* 214779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214785 */     GIR_RootConstrainSelectedInstOperands,
     /* 214786 */     // GIR_Coverage, 12222,
     /* 214786 */     GIR_EraseRootFromParent_Done,
     /* 214787 */   // Label 4124: @214787
     /* 214787 */   GIM_Try, /*On fail goto*//*Label 4125*/ GIMT_Encode4(214824), // Rule ID 12223 //
     /* 214792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq1),
     /* 214800 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214803 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214806 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214813 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2095:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 214813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ1_ZZZ_D),
     /* 214816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214822 */     GIR_RootConstrainSelectedInstOperands,
     /* 214823 */     // GIR_Coverage, 12223,
     /* 214823 */     GIR_EraseRootFromParent_Done,
     /* 214824 */   // Label 4125: @214824
     /* 214824 */   GIM_Try, /*On fail goto*//*Label 4126*/ GIMT_Encode4(214861), // Rule ID 12224 //
     /* 214829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 214840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 214843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 214846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214850 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2096:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZPQ2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 214850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_B),
     /* 214853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214859 */     GIR_RootConstrainSelectedInstOperands,
     /* 214860 */     // GIR_Coverage, 12224,
     /* 214860 */     GIR_EraseRootFromParent_Done,
     /* 214861 */   // Label 4126: @214861
     /* 214861 */   GIM_Try, /*On fail goto*//*Label 4127*/ GIMT_Encode4(214898), // Rule ID 12225 //
     /* 214866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214887 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2096:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 214887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 214890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214896 */     GIR_RootConstrainSelectedInstOperands,
     /* 214897 */     // GIR_Coverage, 12225,
     /* 214897 */     GIR_EraseRootFromParent_Done,
     /* 214898 */   // Label 4127: @214898
     /* 214898 */   GIM_Try, /*On fail goto*//*Label 4128*/ GIMT_Encode4(214935), // Rule ID 12226 //
     /* 214903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214906 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214911 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 214914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 214917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 214920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214924 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2096:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 214924 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 214927 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214931 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214933 */     GIR_RootConstrainSelectedInstOperands,
     /* 214934 */     // GIR_Coverage, 12226,
     /* 214934 */     GIR_EraseRootFromParent_Done,
     /* 214935 */   // Label 4128: @214935
     /* 214935 */   GIM_Try, /*On fail goto*//*Label 4129*/ GIMT_Encode4(214972), // Rule ID 12227 //
     /* 214940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 214951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 214954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 214957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2096:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 214961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 214964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 214966 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 214968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 214970 */     GIR_RootConstrainSelectedInstOperands,
     /* 214971 */     // GIR_Coverage, 12227,
     /* 214971 */     GIR_EraseRootFromParent_Done,
     /* 214972 */   // Label 4129: @214972
     /* 214972 */   GIM_Try, /*On fail goto*//*Label 4130*/ GIMT_Encode4(215009), // Rule ID 12228 //
     /* 214977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 214980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 214985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 214988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 214991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 214994 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 214998 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 2096:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZPQ2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 214998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_H),
     /* 215001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215003 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215007 */     GIR_RootConstrainSelectedInstOperands,
     /* 215008 */     // GIR_Coverage, 12228,
     /* 215008 */     GIR_EraseRootFromParent_Done,
     /* 215009 */   // Label 4130: @215009
     /* 215009 */   GIM_Try, /*On fail goto*//*Label 4131*/ GIMT_Encode4(215046), // Rule ID 12229 //
     /* 215014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 215025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 215028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 215031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215035 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 2096:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZPQ2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 215035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_S),
     /* 215038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215044 */     GIR_RootConstrainSelectedInstOperands,
     /* 215045 */     // GIR_Coverage, 12229,
     /* 215045 */     GIR_EraseRootFromParent_Done,
     /* 215046 */   // Label 4131: @215046
     /* 215046 */   GIM_Try, /*On fail goto*//*Label 4132*/ GIMT_Encode4(215083), // Rule ID 12230 //
     /* 215051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 215054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uzpq2),
     /* 215059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 215062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 215065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 215068 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 215072 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 2096:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZPQ2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 215072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZPQ2_ZZZ_D),
     /* 215075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 215077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215081 */     GIR_RootConstrainSelectedInstOperands,
     /* 215082 */     // GIR_Coverage, 12230,
     /* 215082 */     GIR_EraseRootFromParent_Done,
     /* 215083 */   // Label 4132: @215083
     /* 215083 */   GIM_Try, /*On fail goto*//*Label 4133*/ GIMT_Encode4(215125), // Rule ID 3214 //
     /* 215088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_b),
     /* 215096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215103 */     // MIs[0] Op1
     /* 215103 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215107 */     // MIs[0] Op2
     /* 215107 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215111 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2149:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_B),
     /* 215114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215120 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215123 */     GIR_RootConstrainSelectedInstOperands,
     /* 215124 */     // GIR_Coverage, 3214,
     /* 215124 */     GIR_EraseRootFromParent_Done,
     /* 215125 */   // Label 4133: @215125
     /* 215125 */   GIM_Try, /*On fail goto*//*Label 4134*/ GIMT_Encode4(215167), // Rule ID 3215 //
     /* 215130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215133 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_h),
     /* 215138 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215141 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215145 */     // MIs[0] Op1
     /* 215145 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215149 */     // MIs[0] Op2
     /* 215149 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215153 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2151:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_H),
     /* 215156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215162 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215165 */     GIR_RootConstrainSelectedInstOperands,
     /* 215166 */     // GIR_Coverage, 3215,
     /* 215166 */     GIR_EraseRootFromParent_Done,
     /* 215167 */   // Label 4134: @215167
     /* 215167 */   GIM_Try, /*On fail goto*//*Label 4135*/ GIMT_Encode4(215209), // Rule ID 3216 //
     /* 215172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_s),
     /* 215180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215187 */     // MIs[0] Op1
     /* 215187 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215191 */     // MIs[0] Op2
     /* 215191 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215195 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2152:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_S),
     /* 215198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215204 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215207 */     GIR_RootConstrainSelectedInstOperands,
     /* 215208 */     // GIR_Coverage, 3216,
     /* 215208 */     GIR_EraseRootFromParent_Done,
     /* 215209 */   // Label 4135: @215209
     /* 215209 */   GIM_Try, /*On fail goto*//*Label 4136*/ GIMT_Encode4(215251), // Rule ID 3217 //
     /* 215214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215217 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilewr_d),
     /* 215222 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215229 */     // MIs[0] Op1
     /* 215229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215233 */     // MIs[0] Op2
     /* 215233 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215237 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2150:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILEWR_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILEWR_PXX_D),
     /* 215240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215246 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215249 */     GIR_RootConstrainSelectedInstOperands,
     /* 215250 */     // GIR_Coverage, 3217,
     /* 215250 */     GIR_EraseRootFromParent_Done,
     /* 215251 */   // Label 4136: @215251
     /* 215251 */   GIM_Try, /*On fail goto*//*Label 4137*/ GIMT_Encode4(215293), // Rule ID 12043 //
     /* 215256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215259 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_b),
     /* 215264 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 215267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215271 */     // MIs[0] Op1
     /* 215271 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215275 */     // MIs[0] Op2
     /* 215275 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215279 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 2145:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_B),
     /* 215282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215288 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215291 */     GIR_RootConstrainSelectedInstOperands,
     /* 215292 */     // GIR_Coverage, 12043,
     /* 215292 */     GIR_EraseRootFromParent_Done,
     /* 215293 */   // Label 4137: @215293
     /* 215293 */   GIM_Try, /*On fail goto*//*Label 4138*/ GIMT_Encode4(215335), // Rule ID 12044 //
     /* 215298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_h),
     /* 215306 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 215309 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215313 */     // MIs[0] Op1
     /* 215313 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215317 */     // MIs[0] Op2
     /* 215317 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215321 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 2147:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_H),
     /* 215324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215330 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215333 */     GIR_RootConstrainSelectedInstOperands,
     /* 215334 */     // GIR_Coverage, 12044,
     /* 215334 */     GIR_EraseRootFromParent_Done,
     /* 215335 */   // Label 4138: @215335
     /* 215335 */   GIM_Try, /*On fail goto*//*Label 4139*/ GIMT_Encode4(215377), // Rule ID 12045 //
     /* 215340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215343 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_s),
     /* 215348 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 215351 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215355 */     // MIs[0] Op1
     /* 215355 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215359 */     // MIs[0] Op2
     /* 215359 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215363 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 2148:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_S),
     /* 215366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215372 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215375 */     GIR_RootConstrainSelectedInstOperands,
     /* 215376 */     // GIR_Coverage, 12045,
     /* 215376 */     GIR_EraseRootFromParent_Done,
     /* 215377 */   // Label 4139: @215377
     /* 215377 */   GIM_Try, /*On fail goto*//*Label 4140*/ GIMT_Encode4(215419), // Rule ID 12046 //
     /* 215382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 215385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_whilerw_d),
     /* 215390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 215393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 215397 */     // MIs[0] Op1
     /* 215397 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 215401 */     // MIs[0] Op2
     /* 215401 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 215405 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 2146:{ *:[iPTR] }, i64:{ *:[i64] }:$Op1, i64:{ *:[i64] }:$Op2)  =>  (WHILERW_PXX_D:{ *:[nxv2i1] }:{ *:[i32] } ?:{ *:[i64] }:$Op1, ?:{ *:[i64] }:$Op2)
     /* 215405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WHILERW_PXX_D),
     /* 215408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 215410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 215412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 215414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 215417 */     GIR_RootConstrainSelectedInstOperands,
     /* 215418 */     // GIR_Coverage, 12046,
     /* 215418 */     GIR_EraseRootFromParent_Done,
     /* 215419 */   // Label 4140: @215419
     /* 215419 */   GIM_Reject,
     /* 215420 */ // Label 3247: @215420
     /* 215420 */ GIM_Try, /*On fail goto*//*Label 4141*/ GIMT_Encode4(258531),
     /* 215425 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 215428 */   GIM_Try, /*On fail goto*//*Label 4142*/ GIMT_Encode4(215541), // Rule ID 2069 //
     /* 215433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215436 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215441 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215444 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215447 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215450 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215453 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215461 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215477 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215481 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215485 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215489 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215493 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215498 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215502 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215506 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215510 */     // MIs[3] Operand 1
     /* 215510 */     // No operand predicates
     /* 215510 */     // MIs[1] Operand 2
     /* 215510 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215521 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215523 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 215526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215530 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215532 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215536 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215539 */     GIR_RootConstrainSelectedInstOperands,
     /* 215540 */     // GIR_Coverage, 2069,
     /* 215540 */     GIR_EraseRootFromParent_Done,
     /* 215541 */   // Label 4142: @215541
     /* 215541 */   GIM_Try, /*On fail goto*//*Label 4143*/ GIMT_Encode4(215654), // Rule ID 2076 //
     /* 215546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215549 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215554 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215557 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215560 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215563 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215566 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215582 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215586 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215590 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215594 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 215598 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 215602 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 215611 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215615 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215619 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 215623 */     // MIs[3] Operand 1
     /* 215623 */     // No operand predicates
     /* 215623 */     // MIs[1] Operand 2
     /* 215623 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215634 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215636 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 215639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215643 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215645 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215652 */     GIR_RootConstrainSelectedInstOperands,
     /* 215653 */     // GIR_Coverage, 2076,
     /* 215653 */     GIR_EraseRootFromParent_Done,
     /* 215654 */   // Label 4143: @215654
     /* 215654 */   GIM_Try, /*On fail goto*//*Label 4144*/ GIMT_Encode4(215767), // Rule ID 2072 //
     /* 215659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 215667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215711 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215715 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215719 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215732 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215736 */     // MIs[3] Operand 1
     /* 215736 */     // No operand predicates
     /* 215736 */     // MIs[1] Operand 2
     /* 215736 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215747 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215749 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 215752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215765 */     GIR_RootConstrainSelectedInstOperands,
     /* 215766 */     // GIR_Coverage, 2072,
     /* 215766 */     GIR_EraseRootFromParent_Done,
     /* 215767 */   // Label 4144: @215767
     /* 215767 */   GIM_Try, /*On fail goto*//*Label 4145*/ GIMT_Encode4(215880), // Rule ID 2079 //
     /* 215772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 215775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 215780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 215783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 215786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 215789 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 215792 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215796 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215800 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 215812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215845 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 215849 */     // MIs[3] Operand 1
     /* 215849 */     // No operand predicates
     /* 215849 */     // MIs[1] Operand 2
     /* 215849 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 215860 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215862 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 215862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 215865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215869 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215878 */     GIR_RootConstrainSelectedInstOperands,
     /* 215879 */     // GIR_Coverage, 2079,
     /* 215879 */     GIR_EraseRootFromParent_Done,
     /* 215880 */   // Label 4145: @215880
     /* 215880 */   GIM_Try, /*On fail goto*//*Label 4146*/ GIMT_Encode4(215985), // Rule ID 3868 //
     /* 215885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 215893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 215896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 215899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 215902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 215905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 215917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 215921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 215925 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 215929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 215933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 215937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 215941 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 215945 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 215950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 215954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 215958 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 215962 */     // MIs[3] Operand 1
     /* 215962 */     // No operand predicates
     /* 215962 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 215964 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 215964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 215967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 215969 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 215971 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 215973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 215977 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 215980 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 215983 */     GIR_RootConstrainSelectedInstOperands,
     /* 215984 */     // GIR_Coverage, 3868,
     /* 215984 */     GIR_EraseRootFromParent_Done,
     /* 215985 */   // Label 4146: @215985
     /* 215985 */   GIM_Try, /*On fail goto*//*Label 4147*/ GIMT_Encode4(216090), // Rule ID 3869 //
     /* 215990 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 215993 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 215998 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216007 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216010 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216014 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216018 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216022 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216026 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216030 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216034 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216038 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216042 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216046 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216050 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216055 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216059 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216063 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216067 */     // MIs[3] Operand 1
     /* 216067 */     // No operand predicates
     /* 216067 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216069 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216082 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216088 */     GIR_RootConstrainSelectedInstOperands,
     /* 216089 */     // GIR_Coverage, 3869,
     /* 216089 */     GIR_EraseRootFromParent_Done,
     /* 216090 */   // Label 4147: @216090
     /* 216090 */   GIM_Try, /*On fail goto*//*Label 4148*/ GIMT_Encode4(216195), // Rule ID 3870 //
     /* 216095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216127 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216131 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216139 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216143 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216147 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216151 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216168 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216172 */     // MIs[3] Operand 1
     /* 216172 */     // No operand predicates
     /* 216172 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216174 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216181 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216187 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216190 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216193 */     GIR_RootConstrainSelectedInstOperands,
     /* 216194 */     // GIR_Coverage, 3870,
     /* 216194 */     GIR_EraseRootFromParent_Done,
     /* 216195 */   // Label 4148: @216195
     /* 216195 */   GIM_Try, /*On fail goto*//*Label 4149*/ GIMT_Encode4(216300), // Rule ID 3871 //
     /* 216200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 216211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 216214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 216217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 216220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 216232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 216244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216256 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216260 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216273 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216277 */     // MIs[3] Operand 1
     /* 216277 */     // No operand predicates
     /* 216277 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216279 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (bitconvert:{ *:[v4f16] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f16_indexed:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16_indexed),
     /* 216282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216292 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216298 */     GIR_RootConstrainSelectedInstOperands,
     /* 216299 */     // GIR_Coverage, 3871,
     /* 216299 */     GIR_EraseRootFromParent_Done,
     /* 216300 */   // Label 4149: @216300
     /* 216300 */   GIM_Try, /*On fail goto*//*Label 4150*/ GIMT_Encode4(216405), // Rule ID 3876 //
     /* 216305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216357 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216361 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216365 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216370 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216374 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216378 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216382 */     // MIs[3] Operand 1
     /* 216382 */     // No operand predicates
     /* 216382 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216384 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216384 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216387 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216389 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216391 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216400 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216403 */     GIR_RootConstrainSelectedInstOperands,
     /* 216404 */     // GIR_Coverage, 3876,
     /* 216404 */     GIR_EraseRootFromParent_Done,
     /* 216405 */   // Label 4150: @216405
     /* 216405 */   GIM_Try, /*On fail goto*//*Label 4151*/ GIMT_Encode4(216510), // Rule ID 3877 //
     /* 216410 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216413 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216418 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216421 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216424 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216427 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216430 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216434 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216438 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216462 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216466 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216475 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216479 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216483 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216487 */     // MIs[3] Operand 1
     /* 216487 */     // No operand predicates
     /* 216487 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216489 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216502 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216505 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216508 */     GIR_RootConstrainSelectedInstOperands,
     /* 216509 */     // GIR_Coverage, 3877,
     /* 216509 */     GIR_EraseRootFromParent_Done,
     /* 216510 */   // Label 4151: @216510
     /* 216510 */   GIM_Try, /*On fail goto*//*Label 4152*/ GIMT_Encode4(216615), // Rule ID 3878 //
     /* 216515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216567 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216571 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216575 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216588 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216592 */     // MIs[3] Operand 1
     /* 216592 */     // No operand predicates
     /* 216592 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216594 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 216594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216603 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216610 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 216613 */     GIR_RootConstrainSelectedInstOperands,
     /* 216614 */     // GIR_Coverage, 3878,
     /* 216614 */     GIR_EraseRootFromParent_Done,
     /* 216615 */   // Label 4152: @216615
     /* 216615 */   GIM_Try, /*On fail goto*//*Label 4153*/ GIMT_Encode4(216720), // Rule ID 3879 //
     /* 216620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 216623 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 216628 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 216631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 216634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 216637 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 216640 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216644 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216648 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216660 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 216672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 216676 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216680 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216685 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216689 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216693 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 216697 */     // MIs[3] Operand 1
     /* 216697 */     // No operand predicates
     /* 216697 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216699 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (bitconvert:{ *:[v8f16] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (FCMLAv8f16_indexed:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 216699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16_indexed),
     /* 216702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216708 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216715 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 216718 */     GIR_RootConstrainSelectedInstOperands,
     /* 216719 */     // GIR_Coverage, 3879,
     /* 216719 */     GIR_EraseRootFromParent_Done,
     /* 216720 */   // Label 4153: @216720
     /* 216720 */   GIM_Try, /*On fail goto*//*Label 4154*/ GIMT_Encode4(216825), // Rule ID 3892 //
     /* 216725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 216733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216753 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216790 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216794 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216798 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216802 */     // MIs[3] Operand 1
     /* 216802 */     // No operand predicates
     /* 216802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216804 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 0:{ *:[i32] })
     /* 216804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 216807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216820 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 216823 */     GIR_RootConstrainSelectedInstOperands,
     /* 216824 */     // GIR_Coverage, 3892,
     /* 216824 */     GIR_EraseRootFromParent_Done,
     /* 216825 */   // Label 4154: @216825
     /* 216825 */   GIM_Try, /*On fail goto*//*Label 4155*/ GIMT_Encode4(216930), // Rule ID 3893 //
     /* 216830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 216838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216882 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216886 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216890 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216895 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 216899 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 216903 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 216907 */     // MIs[3] Operand 1
     /* 216907 */     // No operand predicates
     /* 216907 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 216909 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 1:{ *:[i32] })
     /* 216909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 216912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 216914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 216916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 216918 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 216922 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 216925 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 216928 */     GIR_RootConstrainSelectedInstOperands,
     /* 216929 */     // GIR_Coverage, 3893,
     /* 216929 */     GIR_EraseRootFromParent_Done,
     /* 216930 */   // Label 4155: @216930
     /* 216930 */   GIM_Try, /*On fail goto*//*Label 4156*/ GIMT_Encode4(217035), // Rule ID 3894 //
     /* 216935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 216938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 216943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 216946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 216949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 216952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 216955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 216967 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 216971 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 216975 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216979 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 216983 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 216987 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 216991 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 216995 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217000 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217004 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217008 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217012 */     // MIs[3] Operand 1
     /* 217012 */     // No operand predicates
     /* 217012 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217014 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 2:{ *:[i32] })
     /* 217014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217027 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217030 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 217033 */     GIR_RootConstrainSelectedInstOperands,
     /* 217034 */     // GIR_Coverage, 3894,
     /* 217034 */     GIR_EraseRootFromParent_Done,
     /* 217035 */   // Label 4156: @217035
     /* 217035 */   GIM_Try, /*On fail goto*//*Label 4157*/ GIMT_Encode4(217140), // Rule ID 3895 //
     /* 217040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 217043 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 217048 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 217051 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 217054 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 217057 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 217060 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217072 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 217076 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 217080 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 217088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 217092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 217096 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 217100 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 217105 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 217109 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 217113 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 217117 */     // MIs[3] Operand 1
     /* 217117 */     // No operand predicates
     /* 217117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 217119 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (bitconvert:{ *:[v4f32] } (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)))  =>  (FCMLAv4f32_indexed:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, 3:{ *:[i32] })
     /* 217119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32_indexed),
     /* 217122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 217128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 217132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 217135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 217138 */     GIR_RootConstrainSelectedInstOperands,
     /* 217139 */     // GIR_Coverage, 3895,
     /* 217139 */     GIR_EraseRootFromParent_Done,
     /* 217140 */   // Label 4157: @217140
     /* 217140 */   GIM_Try, /*On fail goto*//*Label 4158*/ GIMT_Encode4(217194), // Rule ID 59 //
     /* 217145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217162 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217166 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217170 */     // MIs[0] Operand 3
     /* 217170 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 217181 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217185 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZA),
     /* 217188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217192 */     GIR_RootConstrainSelectedInstOperands,
     /* 217193 */     // GIR_Coverage, 59,
     /* 217193 */     GIR_EraseRootFromParent_Done,
     /* 217194 */   // Label 4158: @217194
     /* 217194 */   GIM_Try, /*On fail goto*//*Label 4159*/ GIMT_Encode4(217248), // Rule ID 60 //
     /* 217199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217213 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217216 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217220 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217224 */     // MIs[0] Operand 3
     /* 217224 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 217235 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217239 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZA),
     /* 217242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217246 */     GIR_RootConstrainSelectedInstOperands,
     /* 217247 */     // GIR_Coverage, 60,
     /* 217247 */     GIR_EraseRootFromParent_Done,
     /* 217248 */   // Label 4159: @217248
     /* 217248 */   GIM_Try, /*On fail goto*//*Label 4160*/ GIMT_Encode4(217302), // Rule ID 61 //
     /* 217253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217267 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217270 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217274 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217278 */     // MIs[0] Operand 3
     /* 217278 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 217289 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217293 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACIZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIZB),
     /* 217296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217300 */     GIR_RootConstrainSelectedInstOperands,
     /* 217301 */     // GIR_Coverage, 61,
     /* 217301 */     GIR_EraseRootFromParent_Done,
     /* 217302 */   // Label 4160: @217302
     /* 217302 */   GIM_Try, /*On fail goto*//*Label 4161*/ GIMT_Encode4(217356), // Rule ID 62 //
     /* 217307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 217310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 217315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 217324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217332 */     // MIs[0] Operand 3
     /* 217332 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 217343 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/4, 0,
     /* 217347 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, 0:{ *:[i64] })  =>  (PACDZB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd)
     /* 217347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDZB),
     /* 217350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 217352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 217354 */     GIR_RootConstrainSelectedInstOperands,
     /* 217355 */     // GIR_Coverage, 62,
     /* 217355 */     GIR_EraseRootFromParent_Done,
     /* 217356 */   // Label 4161: @217356
     /* 217356 */   GIM_Try, /*On fail goto*//*Label 4162*/ GIMT_Encode4(217412), // Rule ID 2648 //
     /* 217361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch),
     /* 217369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 217372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 217375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217379 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 217383 */     // MIs[0] pattern
     /* 217383 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217386 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217391 */     // MIs[0] imm4
     /* 217391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217399 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1817:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_ZPiI),
     /* 217402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 217404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 217406 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217408 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217410 */     GIR_RootConstrainSelectedInstOperands,
     /* 217411 */     // GIR_Coverage, 2648,
     /* 217411 */     GIR_EraseRootFromParent_Done,
     /* 217412 */   // Label 4162: @217412
     /* 217412 */   GIM_Try, /*On fail goto*//*Label 4163*/ GIMT_Encode4(217468), // Rule ID 2657 //
     /* 217417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n32),
     /* 217425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217439 */     // MIs[0] pattern
     /* 217439 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217442 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217447 */     // MIs[0] imm4
     /* 217447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217455 */     // (intrinsic_wo_chain:{ *:[i32] } 2023:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_WPiI),
     /* 217458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217462 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217464 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217466 */     GIR_RootConstrainSelectedInstOperands,
     /* 217467 */     // GIR_Coverage, 2657,
     /* 217467 */     GIR_EraseRootFromParent_Done,
     /* 217468 */   // Label 4163: @217468
     /* 217468 */   GIM_Try, /*On fail goto*//*Label 4164*/ GIMT_Encode4(217524), // Rule ID 2658 //
     /* 217473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincb_n64),
     /* 217481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217495 */     // MIs[0] pattern
     /* 217495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217503 */     // MIs[0] imm4
     /* 217503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217511 */     // (intrinsic_wo_chain:{ *:[i64] } 1813:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCB_XPiI),
     /* 217514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217518 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217520 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217522 */     GIR_RootConstrainSelectedInstOperands,
     /* 217523 */     // GIR_Coverage, 2658,
     /* 217523 */     GIR_EraseRootFromParent_Done,
     /* 217524 */   // Label 4164: @217524
     /* 217524 */   GIM_Try, /*On fail goto*//*Label 4165*/ GIMT_Encode4(217580), // Rule ID 10030 //
     /* 217529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n32),
     /* 217537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217551 */     // MIs[0] pattern
     /* 217551 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217554 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217559 */     // MIs[0] imm4
     /* 217559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217567 */     // (intrinsic_wo_chain:{ *:[i32] } 2009:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_WPiI),
     /* 217570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217574 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217576 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217578 */     GIR_RootConstrainSelectedInstOperands,
     /* 217579 */     // GIR_Coverage, 10030,
     /* 217579 */     GIR_EraseRootFromParent_Done,
     /* 217580 */   // Label 4165: @217580
     /* 217580 */   GIM_Try, /*On fail goto*//*Label 4166*/ GIMT_Encode4(217636), // Rule ID 10031 //
     /* 217585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincb_n64),
     /* 217593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217607 */     // MIs[0] pattern
     /* 217607 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217610 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217615 */     // MIs[0] imm4
     /* 217615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217623 */     // (intrinsic_wo_chain:{ *:[i64] } 2024:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCB_XPiI),
     /* 217626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217630 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217632 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217634 */     GIR_RootConstrainSelectedInstOperands,
     /* 217635 */     // GIR_Coverage, 10031,
     /* 217635 */     GIR_EraseRootFromParent_Done,
     /* 217636 */   // Label 4166: @217636
     /* 217636 */   GIM_Try, /*On fail goto*//*Label 4167*/ GIMT_Encode4(217692), // Rule ID 10032 //
     /* 217641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecb_n64),
     /* 217649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217663 */     // MIs[0] pattern
     /* 217663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217671 */     // MIs[0] imm4
     /* 217671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217679 */     // (intrinsic_wo_chain:{ *:[i64] } 1779:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECB_XPiI),
     /* 217682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217686 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217688 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217690 */     GIR_RootConstrainSelectedInstOperands,
     /* 217691 */     // GIR_Coverage, 10032,
     /* 217691 */     GIR_EraseRootFromParent_Done,
     /* 217692 */   // Label 4167: @217692
     /* 217692 */   GIM_Try, /*On fail goto*//*Label 4168*/ GIMT_Encode4(217748), // Rule ID 10033 //
     /* 217697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecb_n64),
     /* 217705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217719 */     // MIs[0] pattern
     /* 217719 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217722 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217727 */     // MIs[0] imm4
     /* 217727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217735 */     // (intrinsic_wo_chain:{ *:[i64] } 2010:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECB_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECB_XPiI),
     /* 217738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217742 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217744 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217746 */     GIR_RootConstrainSelectedInstOperands,
     /* 217747 */     // GIR_Coverage, 10033,
     /* 217747 */     GIR_EraseRootFromParent_Done,
     /* 217748 */   // Label 4168: @217748
     /* 217748 */   GIM_Try, /*On fail goto*//*Label 4169*/ GIMT_Encode4(217804), // Rule ID 10036 //
     /* 217753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n32),
     /* 217761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217771 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217775 */     // MIs[0] pattern
     /* 217775 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217778 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217783 */     // MIs[0] imm4
     /* 217783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217791 */     // (intrinsic_wo_chain:{ *:[i32] } 2029:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_WPiI),
     /* 217794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217798 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217800 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217802 */     GIR_RootConstrainSelectedInstOperands,
     /* 217803 */     // GIR_Coverage, 10036,
     /* 217803 */     GIR_EraseRootFromParent_Done,
     /* 217804 */   // Label 4169: @217804
     /* 217804 */   GIM_Try, /*On fail goto*//*Label 4170*/ GIMT_Encode4(217860), // Rule ID 10039 //
     /* 217809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n32),
     /* 217817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 217820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 217823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217827 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 217831 */     // MIs[0] pattern
     /* 217831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217839 */     // MIs[0] imm4
     /* 217839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217847 */     // (intrinsic_wo_chain:{ *:[i32] } 2015:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_WPiI),
     /* 217850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217854 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217856 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217858 */     GIR_RootConstrainSelectedInstOperands,
     /* 217859 */     // GIR_Coverage, 10039,
     /* 217859 */     GIR_EraseRootFromParent_Done,
     /* 217860 */   // Label 4170: @217860
     /* 217860 */   GIM_Try, /*On fail goto*//*Label 4171*/ GIMT_Encode4(217916), // Rule ID 10040 //
     /* 217865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqinch_n64),
     /* 217873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217883 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217887 */     // MIs[0] pattern
     /* 217887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217895 */     // MIs[0] imm4
     /* 217895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217903 */     // (intrinsic_wo_chain:{ *:[i64] } 1819:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCH_XPiI),
     /* 217906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217910 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217912 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217914 */     GIR_RootConstrainSelectedInstOperands,
     /* 217915 */     // GIR_Coverage, 10040,
     /* 217915 */     GIR_EraseRootFromParent_Done,
     /* 217916 */   // Label 4171: @217916
     /* 217916 */   GIM_Try, /*On fail goto*//*Label 4172*/ GIMT_Encode4(217972), // Rule ID 10041 //
     /* 217921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch_n64),
     /* 217929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217943 */     // MIs[0] pattern
     /* 217943 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 217946 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 217951 */     // MIs[0] imm4
     /* 217951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 217954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 217959 */     // (intrinsic_wo_chain:{ *:[i64] } 2030:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 217959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_XPiI),
     /* 217962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 217964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 217966 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 217968 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 217970 */     GIR_RootConstrainSelectedInstOperands,
     /* 217971 */     // GIR_Coverage, 10041,
     /* 217971 */     GIR_EraseRootFromParent_Done,
     /* 217972 */   // Label 4172: @217972
     /* 217972 */   GIM_Try, /*On fail goto*//*Label 4173*/ GIMT_Encode4(218028), // Rule ID 10042 //
     /* 217977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 217980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech_n64),
     /* 217985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 217988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 217991 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 217999 */     // MIs[0] pattern
     /* 217999 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218002 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218007 */     // MIs[0] imm4
     /* 218007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218015 */     // (intrinsic_wo_chain:{ *:[i64] } 1785:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_XPiI),
     /* 218018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218022 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218024 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218026 */     GIR_RootConstrainSelectedInstOperands,
     /* 218027 */     // GIR_Coverage, 10042,
     /* 218027 */     GIR_EraseRootFromParent_Done,
     /* 218028 */   // Label 4173: @218028
     /* 218028 */   GIM_Try, /*On fail goto*//*Label 4174*/ GIMT_Encode4(218084), // Rule ID 10043 //
     /* 218033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech_n64),
     /* 218041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218055 */     // MIs[0] pattern
     /* 218055 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218058 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218063 */     // MIs[0] imm4
     /* 218063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218071 */     // (intrinsic_wo_chain:{ *:[i64] } 2016:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_XPiI),
     /* 218074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218078 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218080 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218082 */     GIR_RootConstrainSelectedInstOperands,
     /* 218083 */     // GIR_Coverage, 10043,
     /* 218083 */     GIR_EraseRootFromParent_Done,
     /* 218084 */   // Label 4174: @218084
     /* 218084 */   GIM_Try, /*On fail goto*//*Label 4175*/ GIMT_Encode4(218140), // Rule ID 10046 //
     /* 218089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n32),
     /* 218097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218107 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218111 */     // MIs[0] pattern
     /* 218111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218119 */     // MIs[0] imm4
     /* 218119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218127 */     // (intrinsic_wo_chain:{ *:[i32] } 2035:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_WPiI),
     /* 218130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218134 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218136 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218138 */     GIR_RootConstrainSelectedInstOperands,
     /* 218139 */     // GIR_Coverage, 10046,
     /* 218139 */     GIR_EraseRootFromParent_Done,
     /* 218140 */   // Label 4175: @218140
     /* 218140 */   GIM_Try, /*On fail goto*//*Label 4176*/ GIMT_Encode4(218196), // Rule ID 10049 //
     /* 218145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n32),
     /* 218153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218159 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218163 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218167 */     // MIs[0] pattern
     /* 218167 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218170 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218175 */     // MIs[0] imm4
     /* 218175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218183 */     // (intrinsic_wo_chain:{ *:[i32] } 2021:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_WPiI),
     /* 218186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218190 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218192 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218194 */     GIR_RootConstrainSelectedInstOperands,
     /* 218195 */     // GIR_Coverage, 10049,
     /* 218195 */     GIR_EraseRootFromParent_Done,
     /* 218196 */   // Label 4176: @218196
     /* 218196 */   GIM_Try, /*On fail goto*//*Label 4177*/ GIMT_Encode4(218252), // Rule ID 10050 //
     /* 218201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw_n64),
     /* 218209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218219 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218223 */     // MIs[0] pattern
     /* 218223 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218226 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218231 */     // MIs[0] imm4
     /* 218231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218239 */     // (intrinsic_wo_chain:{ *:[i64] } 1825:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_XPiI),
     /* 218242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218246 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218248 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218250 */     GIR_RootConstrainSelectedInstOperands,
     /* 218251 */     // GIR_Coverage, 10050,
     /* 218251 */     GIR_EraseRootFromParent_Done,
     /* 218252 */   // Label 4177: @218252
     /* 218252 */   GIM_Try, /*On fail goto*//*Label 4178*/ GIMT_Encode4(218308), // Rule ID 10051 //
     /* 218257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw_n64),
     /* 218265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218275 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218279 */     // MIs[0] pattern
     /* 218279 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218282 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218287 */     // MIs[0] imm4
     /* 218287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218295 */     // (intrinsic_wo_chain:{ *:[i64] } 2036:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_XPiI),
     /* 218298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218302 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218304 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218306 */     GIR_RootConstrainSelectedInstOperands,
     /* 218307 */     // GIR_Coverage, 10051,
     /* 218307 */     GIR_EraseRootFromParent_Done,
     /* 218308 */   // Label 4178: @218308
     /* 218308 */   GIM_Try, /*On fail goto*//*Label 4179*/ GIMT_Encode4(218364), // Rule ID 10052 //
     /* 218313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw_n64),
     /* 218321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218335 */     // MIs[0] pattern
     /* 218335 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218338 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218343 */     // MIs[0] imm4
     /* 218343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218351 */     // (intrinsic_wo_chain:{ *:[i64] } 1791:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_XPiI),
     /* 218354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218358 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218360 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218362 */     GIR_RootConstrainSelectedInstOperands,
     /* 218363 */     // GIR_Coverage, 10052,
     /* 218363 */     GIR_EraseRootFromParent_Done,
     /* 218364 */   // Label 4179: @218364
     /* 218364 */   GIM_Try, /*On fail goto*//*Label 4180*/ GIMT_Encode4(218420), // Rule ID 10053 //
     /* 218369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw_n64),
     /* 218377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218387 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218391 */     // MIs[0] pattern
     /* 218391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218399 */     // MIs[0] imm4
     /* 218399 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218402 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218407 */     // (intrinsic_wo_chain:{ *:[i64] } 2022:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_XPiI),
     /* 218410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218414 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218416 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218418 */     GIR_RootConstrainSelectedInstOperands,
     /* 218419 */     // GIR_Coverage, 10053,
     /* 218419 */     GIR_EraseRootFromParent_Done,
     /* 218420 */   // Label 4180: @218420
     /* 218420 */   GIM_Try, /*On fail goto*//*Label 4181*/ GIMT_Encode4(218476), // Rule ID 10056 //
     /* 218425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n32),
     /* 218433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218443 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218447 */     // MIs[0] pattern
     /* 218447 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218450 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218455 */     // MIs[0] imm4
     /* 218455 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218458 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218463 */     // (intrinsic_wo_chain:{ *:[i32] } 2026:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_WPiI),
     /* 218466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218470 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218472 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218474 */     GIR_RootConstrainSelectedInstOperands,
     /* 218475 */     // GIR_Coverage, 10056,
     /* 218475 */     GIR_EraseRootFromParent_Done,
     /* 218476 */   // Label 4181: @218476
     /* 218476 */   GIM_Try, /*On fail goto*//*Label 4182*/ GIMT_Encode4(218532), // Rule ID 10059 //
     /* 218481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n32),
     /* 218489 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 218492 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 218495 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218499 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 218503 */     // MIs[0] pattern
     /* 218503 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218506 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218511 */     // MIs[0] imm4
     /* 218511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218519 */     // (intrinsic_wo_chain:{ *:[i32] } 2012:{ *:[iPTR] }, GPR32:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_WPiI:{ *:[i32] } ?:{ *:[i32] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_WPiI),
     /* 218522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218526 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218528 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218530 */     GIR_RootConstrainSelectedInstOperands,
     /* 218531 */     // GIR_Coverage, 10059,
     /* 218531 */     GIR_EraseRootFromParent_Done,
     /* 218532 */   // Label 4182: @218532
     /* 218532 */   GIM_Try, /*On fail goto*//*Label 4183*/ GIMT_Encode4(218588), // Rule ID 10060 //
     /* 218537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd_n64),
     /* 218545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218551 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218559 */     // MIs[0] pattern
     /* 218559 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218562 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218567 */     // MIs[0] imm4
     /* 218567 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218570 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218575 */     // (intrinsic_wo_chain:{ *:[i64] } 1816:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218575 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_XPiI),
     /* 218578 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218582 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218584 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218586 */     GIR_RootConstrainSelectedInstOperands,
     /* 218587 */     // GIR_Coverage, 10060,
     /* 218587 */     GIR_EraseRootFromParent_Done,
     /* 218588 */   // Label 4183: @218588
     /* 218588 */   GIM_Try, /*On fail goto*//*Label 4184*/ GIMT_Encode4(218644), // Rule ID 10061 //
     /* 218593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd_n64),
     /* 218601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218615 */     // MIs[0] pattern
     /* 218615 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218618 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218623 */     // MIs[0] imm4
     /* 218623 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218626 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218631 */     // (intrinsic_wo_chain:{ *:[i64] } 2027:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218631 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_XPiI),
     /* 218634 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218636 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218638 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218640 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218642 */     GIR_RootConstrainSelectedInstOperands,
     /* 218643 */     // GIR_Coverage, 10061,
     /* 218643 */     GIR_EraseRootFromParent_Done,
     /* 218644 */   // Label 4184: @218644
     /* 218644 */   GIM_Try, /*On fail goto*//*Label 4185*/ GIMT_Encode4(218700), // Rule ID 10062 //
     /* 218649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd_n64),
     /* 218657 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218660 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218663 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218671 */     // MIs[0] pattern
     /* 218671 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218674 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218679 */     // MIs[0] imm4
     /* 218679 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218682 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218687 */     // (intrinsic_wo_chain:{ *:[i64] } 1782:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_XPiI),
     /* 218690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218694 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218696 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218698 */     GIR_RootConstrainSelectedInstOperands,
     /* 218699 */     // GIR_Coverage, 10062,
     /* 218699 */     GIR_EraseRootFromParent_Done,
     /* 218700 */   // Label 4185: @218700
     /* 218700 */   GIM_Try, /*On fail goto*//*Label 4186*/ GIMT_Encode4(218756), // Rule ID 10063 //
     /* 218705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd_n64),
     /* 218713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 218716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 218719 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218723 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 218727 */     // MIs[0] pattern
     /* 218727 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218730 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218735 */     // MIs[0] imm4
     /* 218735 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218738 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218743 */     // (intrinsic_wo_chain:{ *:[i64] } 2013:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_XPiI:{ *:[i64] } ?:{ *:[i64] }:$Rn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_XPiI),
     /* 218746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rdn]
     /* 218748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 218750 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218752 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218754 */     GIR_RootConstrainSelectedInstOperands,
     /* 218755 */     // GIR_Coverage, 10063,
     /* 218755 */     GIR_EraseRootFromParent_Done,
     /* 218756 */   // Label 4186: @218756
     /* 218756 */   GIM_Try, /*On fail goto*//*Label 4187*/ GIMT_Encode4(218812), // Rule ID 10064 //
     /* 218761 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218764 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqinch),
     /* 218769 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218772 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218779 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218783 */     // MIs[0] pattern
     /* 218783 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218786 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218791 */     // MIs[0] imm4
     /* 218791 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218794 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218799 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2028:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCH_ZPiI),
     /* 218802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218806 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218808 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218810 */     GIR_RootConstrainSelectedInstOperands,
     /* 218811 */     // GIR_Coverage, 10064,
     /* 218811 */     GIR_EraseRootFromParent_Done,
     /* 218812 */   // Label 4187: @218812
     /* 218812 */   GIM_Try, /*On fail goto*//*Label 4188*/ GIMT_Encode4(218868), // Rule ID 10065 //
     /* 218817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdech),
     /* 218825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218831 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218839 */     // MIs[0] pattern
     /* 218839 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218842 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218847 */     // MIs[0] imm4
     /* 218847 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218850 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218855 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1783:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECH_ZPiI),
     /* 218858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218862 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218864 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218866 */     GIR_RootConstrainSelectedInstOperands,
     /* 218867 */     // GIR_Coverage, 10065,
     /* 218867 */     GIR_EraseRootFromParent_Done,
     /* 218868 */   // Label 4188: @218868
     /* 218868 */   GIM_Try, /*On fail goto*//*Label 4189*/ GIMT_Encode4(218924), // Rule ID 10066 //
     /* 218873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdech),
     /* 218881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 218884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 218887 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218895 */     // MIs[0] pattern
     /* 218895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218903 */     // MIs[0] imm4
     /* 218903 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218906 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218911 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2014:{ *:[iPTR] }, ZPR16:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECH_ZPiI:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECH_ZPiI),
     /* 218914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218918 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218920 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218922 */     GIR_RootConstrainSelectedInstOperands,
     /* 218923 */     // GIR_Coverage, 10066,
     /* 218923 */     GIR_EraseRootFromParent_Done,
     /* 218924 */   // Label 4189: @218924
     /* 218924 */   GIM_Try, /*On fail goto*//*Label 4190*/ GIMT_Encode4(218980), // Rule ID 10067 //
     /* 218929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincw),
     /* 218937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 218951 */     // MIs[0] pattern
     /* 218951 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 218954 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 218959 */     // MIs[0] imm4
     /* 218959 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 218962 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 218967 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1823:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 218967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCW_ZPiI),
     /* 218970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 218972 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 218974 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 218976 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 218978 */     GIR_RootConstrainSelectedInstOperands,
     /* 218979 */     // GIR_Coverage, 10067,
     /* 218979 */     GIR_EraseRootFromParent_Done,
     /* 218980 */   // Label 4190: @218980
     /* 218980 */   GIM_Try, /*On fail goto*//*Label 4191*/ GIMT_Encode4(219036), // Rule ID 10068 //
     /* 218985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 218988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincw),
     /* 218993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 218996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 218999 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219003 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219007 */     // MIs[0] pattern
     /* 219007 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219010 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219015 */     // MIs[0] imm4
     /* 219015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2034:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCW_ZPiI),
     /* 219026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219030 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219032 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219034 */     GIR_RootConstrainSelectedInstOperands,
     /* 219035 */     // GIR_Coverage, 10068,
     /* 219035 */     GIR_EraseRootFromParent_Done,
     /* 219036 */   // Label 4191: @219036
     /* 219036 */   GIM_Try, /*On fail goto*//*Label 4192*/ GIMT_Encode4(219092), // Rule ID 10069 //
     /* 219041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecw),
     /* 219049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219059 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219063 */     // MIs[0] pattern
     /* 219063 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219066 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219071 */     // MIs[0] imm4
     /* 219071 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219074 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219079 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1789:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECW_ZPiI),
     /* 219082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219086 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219088 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219090 */     GIR_RootConstrainSelectedInstOperands,
     /* 219091 */     // GIR_Coverage, 10069,
     /* 219091 */     GIR_EraseRootFromParent_Done,
     /* 219092 */   // Label 4192: @219092
     /* 219092 */   GIM_Try, /*On fail goto*//*Label 4193*/ GIMT_Encode4(219148), // Rule ID 10070 //
     /* 219097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecw),
     /* 219105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 219108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 219111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219119 */     // MIs[0] pattern
     /* 219119 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219122 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219127 */     // MIs[0] imm4
     /* 219127 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219130 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219135 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2020:{ *:[iPTR] }, ZPR32:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECW_ZPiI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECW_ZPiI),
     /* 219138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219142 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219144 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219146 */     GIR_RootConstrainSelectedInstOperands,
     /* 219147 */     // GIR_Coverage, 10070,
     /* 219147 */     GIR_EraseRootFromParent_Done,
     /* 219148 */   // Label 4193: @219148
     /* 219148 */   GIM_Try, /*On fail goto*//*Label 4194*/ GIMT_Encode4(219204), // Rule ID 10071 //
     /* 219153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqincd),
     /* 219161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219175 */     // MIs[0] pattern
     /* 219175 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219178 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219183 */     // MIs[0] imm4
     /* 219183 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219186 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1814:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQINCD_ZPiI),
     /* 219194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219198 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219200 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219202 */     GIR_RootConstrainSelectedInstOperands,
     /* 219203 */     // GIR_Coverage, 10071,
     /* 219203 */     GIR_EraseRootFromParent_Done,
     /* 219204 */   // Label 4194: @219204
     /* 219204 */   GIM_Try, /*On fail goto*//*Label 4195*/ GIMT_Encode4(219260), // Rule ID 10072 //
     /* 219209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqincd),
     /* 219217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219231 */     // MIs[0] pattern
     /* 219231 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219234 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219239 */     // MIs[0] imm4
     /* 219239 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219242 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219247 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2025:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQINCD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQINCD_ZPiI),
     /* 219250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219254 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219256 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219258 */     GIR_RootConstrainSelectedInstOperands,
     /* 219259 */     // GIR_Coverage, 10072,
     /* 219259 */     GIR_EraseRootFromParent_Done,
     /* 219260 */   // Label 4195: @219260
     /* 219260 */   GIM_Try, /*On fail goto*//*Label 4196*/ GIMT_Encode4(219316), // Rule ID 10073 //
     /* 219265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219268 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdecd),
     /* 219273 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219276 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219283 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219287 */     // MIs[0] pattern
     /* 219287 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219290 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219295 */     // MIs[0] imm4
     /* 219295 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219298 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219303 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1780:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (SQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDECD_ZPiI),
     /* 219306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219308 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219310 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219312 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219314 */     GIR_RootConstrainSelectedInstOperands,
     /* 219315 */     // GIR_Coverage, 10073,
     /* 219315 */     GIR_EraseRootFromParent_Done,
     /* 219316 */   // Label 4196: @219316
     /* 219316 */   GIM_Try, /*On fail goto*//*Label 4197*/ GIMT_Encode4(219372), // Rule ID 10074 //
     /* 219321 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 219324 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqdecd),
     /* 219329 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 219332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 219335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219339 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 219343 */     // MIs[0] pattern
     /* 219343 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 219346 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_pred_enum),
     /* 219351 */     // MIs[0] imm4
     /* 219351 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 219354 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_incdec_imm),
     /* 219359 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2011:{ *:[iPTR] }, ZPR64:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)  =>  (UQDECD_ZPiI:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Zn, (timm:{ *:[i32] })<<P:Predicate_sve_pred_enum>>:$pattern, (timm:{ *:[i32] })<<P:Predicate_sve_incdec_imm>>:$imm4)
     /* 219359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQDECD_ZPiI),
     /* 219362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 219364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 219366 */     GIR_RootToRootCopy, /*OpIdx*/3, // pattern
     /* 219368 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm4
     /* 219370 */     GIR_RootConstrainSelectedInstOperands,
     /* 219371 */     // GIR_Coverage, 10074,
     /* 219371 */     GIR_EraseRootFromParent_Done,
     /* 219372 */   // Label 4197: @219372
     /* 219372 */   GIM_Try, /*On fail goto*//*Label 4198*/ GIMT_Encode4(219462), // Rule ID 47 //
     /* 219377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219405 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219409 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219413 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219417 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219421 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219425 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219430 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219434 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219438 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219442 */     // MIs[2] Operand 1
     /* 219442 */     // No operand predicates
     /* 219442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219444 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev4f16),
     /* 219447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219451 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219453 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219457 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219460 */     GIR_RootConstrainSelectedInstOperands,
     /* 219461 */     // GIR_Coverage, 47,
     /* 219461 */     GIR_EraseRootFromParent_Done,
     /* 219462 */   // Label 4198: @219462
     /* 219462 */   GIM_Try, /*On fail goto*//*Label 4199*/ GIMT_Encode4(219552), // Rule ID 48 //
     /* 219467 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219470 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 219475 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219478 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219481 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219484 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219487 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219491 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219495 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219511 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219520 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219524 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219528 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219532 */     // MIs[2] Operand 1
     /* 219532 */     // No operand predicates
     /* 219532 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219534 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLALlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALlanev8f16),
     /* 219537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219539 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219541 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219550 */     GIR_RootConstrainSelectedInstOperands,
     /* 219551 */     // GIR_Coverage, 48,
     /* 219551 */     GIR_EraseRootFromParent_Done,
     /* 219552 */   // Label 4199: @219552
     /* 219552 */   GIM_Try, /*On fail goto*//*Label 4200*/ GIMT_Encode4(219642), // Rule ID 49 //
     /* 219557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219581 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219585 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219605 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219618 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219622 */     // MIs[2] Operand 1
     /* 219622 */     // No operand predicates
     /* 219622 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219624 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev4f16),
     /* 219627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219629 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219631 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219633 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219637 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219640 */     GIR_RootConstrainSelectedInstOperands,
     /* 219641 */     // GIR_Coverage, 49,
     /* 219641 */     GIR_EraseRootFromParent_Done,
     /* 219642 */   // Label 4200: @219642
     /* 219642 */   GIM_Try, /*On fail goto*//*Label 4201*/ GIMT_Encode4(219732), // Rule ID 50 //
     /* 219647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 219655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219671 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219679 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219683 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219687 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219691 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219695 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219700 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219704 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219708 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219712 */     // MIs[2] Operand 1
     /* 219712 */     // No operand predicates
     /* 219712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219714 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSLlanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLlanev8f16),
     /* 219717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219721 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219723 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219730 */     GIR_RootConstrainSelectedInstOperands,
     /* 219731 */     // GIR_Coverage, 50,
     /* 219731 */     GIR_EraseRootFromParent_Done,
     /* 219732 */   // Label 4201: @219732
     /* 219732 */   GIM_Try, /*On fail goto*//*Label 4202*/ GIMT_Encode4(219822), // Rule ID 51 //
     /* 219737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219765 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219781 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219785 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219790 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219794 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219798 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219802 */     // MIs[2] Operand 1
     /* 219802 */     // No operand predicates
     /* 219802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219804 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev4f16),
     /* 219807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219813 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219817 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219820 */     GIR_RootConstrainSelectedInstOperands,
     /* 219821 */     // GIR_Coverage, 51,
     /* 219821 */     GIR_EraseRootFromParent_Done,
     /* 219822 */   // Label 4202: @219822
     /* 219822 */   GIM_Try, /*On fail goto*//*Label 4203*/ GIMT_Encode4(219912), // Rule ID 52 //
     /* 219827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 219835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 219838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 219841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 219844 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 219847 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219851 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 219859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219888 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219892 */     // MIs[2] Operand 1
     /* 219892 */     // No operand predicates
     /* 219892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219894 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLAL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2lanev8f16),
     /* 219897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219903 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219907 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 219910 */     GIR_RootConstrainSelectedInstOperands,
     /* 219911 */     // GIR_Coverage, 52,
     /* 219911 */     GIR_EraseRootFromParent_Done,
     /* 219912 */   // Label 4203: @219912
     /* 219912 */   GIM_Try, /*On fail goto*//*Label 4204*/ GIMT_Encode4(220002), // Rule ID 53 //
     /* 219917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 219920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 219925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 219928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 219931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 219934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 219937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219941 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219945 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 219949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 219953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 219957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 219961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 219965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 219970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 219974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 219978 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 219982 */     // MIs[2] Operand 1
     /* 219982 */     // No operand predicates
     /* 219982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 219984 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 219984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev4f16),
     /* 219987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 219989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 219991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 219993 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 219997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220000 */     GIR_RootConstrainSelectedInstOperands,
     /* 220001 */     // GIR_Coverage, 53,
     /* 220001 */     GIR_EraseRootFromParent_Done,
     /* 220002 */   // Label 4204: @220002
     /* 220002 */   GIM_Try, /*On fail goto*//*Label 4205*/ GIMT_Encode4(220092), // Rule ID 54 //
     /* 220007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 220010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 220015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220031 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220035 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220039 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220043 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220047 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220051 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220055 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220060 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220064 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220068 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220072 */     // MIs[2] Operand 1
     /* 220072 */     // No operand predicates
     /* 220072 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220074 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMLSL2lanev8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2lanev8f16),
     /* 220077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220083 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220087 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220090 */     GIR_RootConstrainSelectedInstOperands,
     /* 220091 */     // GIR_Coverage, 54,
     /* 220091 */     GIR_EraseRootFromParent_Done,
     /* 220092 */   // Label 4205: @220092
     /* 220092 */   GIM_Try, /*On fail goto*//*Label 4206*/ GIMT_Encode4(220182), // Rule ID 2070 //
     /* 220097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220100 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220105 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220108 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220114 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220117 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220150 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220154 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220158 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220162 */     // MIs[2] Operand 1
     /* 220162 */     // No operand predicates
     /* 220162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220164 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16_indexed),
     /* 220167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220180 */     GIR_RootConstrainSelectedInstOperands,
     /* 220181 */     // GIR_Coverage, 2070,
     /* 220181 */     GIR_EraseRootFromParent_Done,
     /* 220182 */   // Label 4206: @220182
     /* 220182 */   GIM_Try, /*On fail goto*//*Label 4207*/ GIMT_Encode4(220272), // Rule ID 2071 //
     /* 220187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220211 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220231 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220240 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220244 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220248 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220252 */     // MIs[2] Operand 1
     /* 220252 */     // No operand predicates
     /* 220252 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220254 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLAHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16_indexed),
     /* 220257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220270 */     GIR_RootConstrainSelectedInstOperands,
     /* 220271 */     // GIR_Coverage, 2071,
     /* 220271 */     GIR_EraseRootFromParent_Done,
     /* 220272 */   // Label 4207: @220272
     /* 220272 */   GIM_Try, /*On fail goto*//*Label 4208*/ GIMT_Encode4(220362), // Rule ID 2077 //
     /* 220277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 220288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 220291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 220294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 220297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220301 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220305 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220317 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220321 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220330 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220334 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220338 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220342 */     // MIs[2] Operand 1
     /* 220342 */     // No operand predicates
     /* 220342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220344 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv4i16_indexed:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16_indexed),
     /* 220347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220357 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220360 */     GIR_RootConstrainSelectedInstOperands,
     /* 220361 */     // GIR_Coverage, 2077,
     /* 220361 */     GIR_EraseRootFromParent_Done,
     /* 220362 */   // Label 4208: @220362
     /* 220362 */   GIM_Try, /*On fail goto*//*Label 4209*/ GIMT_Encode4(220452), // Rule ID 2078 //
     /* 220367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 220378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 220381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 220384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 220387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 220407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 220411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 220420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220428 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 220432 */     // MIs[2] Operand 1
     /* 220432 */     // No operand predicates
     /* 220432 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220434 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SQRDMLSHv8i16_indexed:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16_indexed),
     /* 220437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220447 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220450 */     GIR_RootConstrainSelectedInstOperands,
     /* 220451 */     // GIR_Coverage, 2078,
     /* 220451 */     GIR_EraseRootFromParent_Done,
     /* 220452 */   // Label 4209: @220452
     /* 220452 */   GIM_Try, /*On fail goto*//*Label 4210*/ GIMT_Encode4(220542), // Rule ID 2073 //
     /* 220457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220489 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220493 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220497 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220501 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220518 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220522 */     // MIs[2] Operand 1
     /* 220522 */     // No operand predicates
     /* 220522 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220524 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32_indexed),
     /* 220527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220540 */     GIR_RootConstrainSelectedInstOperands,
     /* 220541 */     // GIR_Coverage, 2073,
     /* 220541 */     GIR_EraseRootFromParent_Done,
     /* 220542 */   // Label 4210: @220542
     /* 220542 */   GIM_Try, /*On fail goto*//*Label 4211*/ GIMT_Encode4(220632), // Rule ID 2074 //
     /* 220547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220575 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220579 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220583 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220587 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220591 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220608 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220612 */     // MIs[2] Operand 1
     /* 220612 */     // No operand predicates
     /* 220612 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220614 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32_indexed),
     /* 220617 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220623 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220627 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220630 */     GIR_RootConstrainSelectedInstOperands,
     /* 220631 */     // GIR_Coverage, 2074,
     /* 220631 */     GIR_EraseRootFromParent_Done,
     /* 220632 */   // Label 4211: @220632
     /* 220632 */   GIM_Try, /*On fail goto*//*Label 4212*/ GIMT_Encode4(220722), // Rule ID 2080 //
     /* 220637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 220648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 220651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 220654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 220657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220661 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220665 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 220669 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220673 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220677 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220681 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220685 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220690 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220694 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220698 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220702 */     // MIs[2] Operand 1
     /* 220702 */     // No operand predicates
     /* 220702 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220704 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv2i32_indexed:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32_indexed),
     /* 220707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220709 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220711 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220713 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220717 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220720 */     GIR_RootConstrainSelectedInstOperands,
     /* 220721 */     // GIR_Coverage, 2080,
     /* 220721 */     GIR_EraseRootFromParent_Done,
     /* 220722 */   // Label 4212: @220722
     /* 220722 */   GIM_Try, /*On fail goto*//*Label 4213*/ GIMT_Encode4(220812), // Rule ID 2081 //
     /* 220727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220730 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220735 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 220738 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 220741 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 220744 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 220747 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220751 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220755 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 220767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220771 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220775 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220788 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220792 */     // MIs[2] Operand 1
     /* 220792 */     // No operand predicates
     /* 220792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220794 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv4i32_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32_indexed),
     /* 220797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220807 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220810 */     GIR_RootConstrainSelectedInstOperands,
     /* 220811 */     // GIR_Coverage, 2081,
     /* 220811 */     GIR_EraseRootFromParent_Done,
     /* 220812 */   // Label 4213: @220812
     /* 220812 */   GIM_Try, /*On fail goto*//*Label 4214*/ GIMT_Encode4(220902), // Rule ID 2075 //
     /* 220817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 220825 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220828 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220831 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220834 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220841 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220845 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 220857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220878 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220882 */     // MIs[2] Operand 1
     /* 220882 */     // No operand predicates
     /* 220882 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220884 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLAHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220884 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32_indexed),
     /* 220887 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220889 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220891 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220893 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220900 */     GIR_RootConstrainSelectedInstOperands,
     /* 220901 */     // GIR_Coverage, 2075,
     /* 220901 */     GIR_EraseRootFromParent_Done,
     /* 220902 */   // Label 4214: @220902
     /* 220902 */   GIM_Try, /*On fail goto*//*Label 4215*/ GIMT_Encode4(220992), // Rule ID 2082 //
     /* 220907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 220910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 220915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 220918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 220921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 220924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 220927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220931 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220935 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 220939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 220943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 220947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 220951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 220955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 220960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 220964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 220968 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 220972 */     // MIs[2] Operand 1
     /* 220972 */     // No operand predicates
     /* 220972 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 220974 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SQRDMLSHv1i32_indexed:{ *:[i32] } FPR32Op:{ *:[i32] }:$Rd, FPR32Op:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 220974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32_indexed),
     /* 220977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 220979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 220981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 220983 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 220987 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 220990 */     GIR_RootConstrainSelectedInstOperands,
     /* 220991 */     // GIR_Coverage, 2082,
     /* 220991 */     GIR_EraseRootFromParent_Done,
     /* 220992 */   // Label 4215: @220992
     /* 220992 */   GIM_Try, /*On fail goto*//*Label 4216*/ GIMT_Encode4(221069), // Rule ID 2777 //
     /* 220997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221021 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221025 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221033 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221037 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221049 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221053 */     // MIs[2] Operand 1
     /* 221053 */     // No operand predicates
     /* 221053 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221055 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221067 */     GIR_RootConstrainSelectedInstOperands,
     /* 221068 */     // GIR_Coverage, 2777,
     /* 221068 */     GIR_EraseRootFromParent_Done,
     /* 221069 */   // Label 4216: @221069
     /* 221069 */   GIM_Try, /*On fail goto*//*Label 4217*/ GIMT_Encode4(221146), // Rule ID 2778 //
     /* 221074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221091 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221094 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221102 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221106 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221110 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221114 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221126 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221130 */     // MIs[2] Operand 1
     /* 221130 */     // No operand predicates
     /* 221130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221132 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_H),
     /* 221135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221144 */     GIR_RootConstrainSelectedInstOperands,
     /* 221145 */     // GIR_Coverage, 2778,
     /* 221145 */     GIR_EraseRootFromParent_Done,
     /* 221146 */   // Label 4217: @221146
     /* 221146 */   GIM_Try, /*On fail goto*//*Label 4218*/ GIMT_Encode4(221223), // Rule ID 2779 //
     /* 221151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221175 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221183 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221187 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221191 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221195 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221199 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221203 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221207 */     // MIs[2] Operand 1
     /* 221207 */     // No operand predicates
     /* 221207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221209 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221218 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221221 */     GIR_RootConstrainSelectedInstOperands,
     /* 221222 */     // GIR_Coverage, 2779,
     /* 221222 */     GIR_EraseRootFromParent_Done,
     /* 221223 */   // Label 4218: @221223
     /* 221223 */   GIM_Try, /*On fail goto*//*Label 4219*/ GIMT_Encode4(221300), // Rule ID 2780 //
     /* 221228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221231 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221236 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221239 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221242 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221245 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221248 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221252 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221260 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221264 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221268 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221272 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221276 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221280 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221284 */     // MIs[2] Operand 1
     /* 221284 */     // No operand predicates
     /* 221284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221286 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_S),
     /* 221289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221293 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221298 */     GIR_RootConstrainSelectedInstOperands,
     /* 221299 */     // GIR_Coverage, 2780,
     /* 221299 */     GIR_EraseRootFromParent_Done,
     /* 221300 */   // Label 4219: @221300
     /* 221300 */   GIM_Try, /*On fail goto*//*Label 4220*/ GIMT_Encode4(221377), // Rule ID 2781 //
     /* 221305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221329 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221337 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221341 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221345 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221349 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221353 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221357 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221361 */     // MIs[2] Operand 1
     /* 221361 */     // No operand predicates
     /* 221361 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221363 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221375 */     GIR_RootConstrainSelectedInstOperands,
     /* 221376 */     // GIR_Coverage, 2781,
     /* 221376 */     GIR_EraseRootFromParent_Done,
     /* 221377 */   // Label 4220: @221377
     /* 221377 */   GIM_Try, /*On fail goto*//*Label 4221*/ GIMT_Encode4(221454), // Rule ID 2782 //
     /* 221382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 221390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221426 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221430 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221434 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221438 */     // MIs[2] Operand 1
     /* 221438 */     // No operand predicates
     /* 221438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221440 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FADD_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmI_D),
     /* 221443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221445 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221449 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221452 */     GIR_RootConstrainSelectedInstOperands,
     /* 221453 */     // GIR_Coverage, 2782,
     /* 221453 */     GIR_EraseRootFromParent_Done,
     /* 221454 */   // Label 4221: @221454
     /* 221454 */   GIM_Try, /*On fail goto*//*Label 4222*/ GIMT_Encode4(221531), // Rule ID 7917 //
     /* 221459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221491 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221495 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221499 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221503 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221507 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221511 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221515 */     // MIs[2] Operand 1
     /* 221515 */     // No operand predicates
     /* 221515 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221517 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221529 */     GIR_RootConstrainSelectedInstOperands,
     /* 221530 */     // GIR_Coverage, 7917,
     /* 221530 */     GIR_EraseRootFromParent_Done,
     /* 221531 */   // Label 4222: @221531
     /* 221531 */   GIM_Try, /*On fail goto*//*Label 4223*/ GIMT_Encode4(221608), // Rule ID 7918 //
     /* 221536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221568 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221572 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221576 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221580 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221584 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221588 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221592 */     // MIs[2] Operand 1
     /* 221592 */     // No operand predicates
     /* 221592 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221594 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 221594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_H),
     /* 221597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221603 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221606 */     GIR_RootConstrainSelectedInstOperands,
     /* 221607 */     // GIR_Coverage, 7918,
     /* 221607 */     GIR_EraseRootFromParent_Done,
     /* 221608 */   // Label 4223: @221608
     /* 221608 */   GIM_Try, /*On fail goto*//*Label 4224*/ GIMT_Encode4(221685), // Rule ID 7919 //
     /* 221613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221641 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221645 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221649 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221653 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221657 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221661 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221665 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221669 */     // MIs[2] Operand 1
     /* 221669 */     // No operand predicates
     /* 221669 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221671 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 221671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221680 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221683 */     GIR_RootConstrainSelectedInstOperands,
     /* 221684 */     // GIR_Coverage, 7919,
     /* 221684 */     GIR_EraseRootFromParent_Done,
     /* 221685 */   // Label 4224: @221685
     /* 221685 */   GIM_Try, /*On fail goto*//*Label 4225*/ GIMT_Encode4(221762), // Rule ID 7920 //
     /* 221690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 221701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 221704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 221707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 221710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221722 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221726 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221730 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 221734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221742 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221746 */     // MIs[2] Operand 1
     /* 221746 */     // No operand predicates
     /* 221746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221748 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 221748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_S),
     /* 221751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221755 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221757 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221760 */     GIR_RootConstrainSelectedInstOperands,
     /* 221761 */     // GIR_Coverage, 7920,
     /* 221761 */     GIR_EraseRootFromParent_Done,
     /* 221762 */   // Label 4225: @221762
     /* 221762 */   GIM_Try, /*On fail goto*//*Label 4226*/ GIMT_Encode4(221839), // Rule ID 7921 //
     /* 221767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221819 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221823 */     // MIs[2] Operand 1
     /* 221823 */     // No operand predicates
     /* 221823 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221825 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 221825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 221828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221834 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221837 */     GIR_RootConstrainSelectedInstOperands,
     /* 221838 */     // GIR_Coverage, 7921,
     /* 221838 */     GIR_EraseRootFromParent_Done,
     /* 221839 */   // Label 4226: @221839
     /* 221839 */   GIM_Try, /*On fail goto*//*Label 4227*/ GIMT_Encode4(221916), // Rule ID 7922 //
     /* 221844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221847 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 221852 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 221855 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 221858 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 221861 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 221864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 221888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221896 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 221900 */     // MIs[2] Operand 1
     /* 221900 */     // No operand predicates
     /* 221900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221902 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUB_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 221902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmI_D),
     /* 221905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221907 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221909 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 221914 */     GIR_RootConstrainSelectedInstOperands,
     /* 221915 */     // GIR_Coverage, 7922,
     /* 221915 */     GIR_EraseRootFromParent_Done,
     /* 221916 */   // Label 4227: @221916
     /* 221916 */   GIM_Try, /*On fail goto*//*Label 4228*/ GIMT_Encode4(221993), // Rule ID 7923 //
     /* 221921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 221924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 221929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 221932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 221935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 221938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 221941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 221949 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 221953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 221957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 221961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 221965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 221969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 221973 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 221977 */     // MIs[2] Operand 1
     /* 221977 */     // No operand predicates
     /* 221977 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 221979 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 221979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 221982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 221984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 221986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 221988 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 221991 */     GIR_RootConstrainSelectedInstOperands,
     /* 221992 */     // GIR_Coverage, 7923,
     /* 221992 */     GIR_EraseRootFromParent_Done,
     /* 221993 */   // Label 4228: @221993
     /* 221993 */   GIM_Try, /*On fail goto*//*Label 4229*/ GIMT_Encode4(222070), // Rule ID 7924 //
     /* 221998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222006 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222009 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222012 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222015 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222018 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222022 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222026 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222050 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222054 */     // MIs[2] Operand 1
     /* 222054 */     // No operand predicates
     /* 222054 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222056 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_H),
     /* 222059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222063 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222068 */     GIR_RootConstrainSelectedInstOperands,
     /* 222069 */     // GIR_Coverage, 7924,
     /* 222069 */     GIR_EraseRootFromParent_Done,
     /* 222070 */   // Label 4229: @222070
     /* 222070 */   GIM_Try, /*On fail goto*//*Label 4230*/ GIMT_Encode4(222147), // Rule ID 7925 //
     /* 222075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222099 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222103 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222127 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222131 */     // MIs[2] Operand 1
     /* 222131 */     // No operand predicates
     /* 222131 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222133 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222145 */     GIR_RootConstrainSelectedInstOperands,
     /* 222146 */     // GIR_Coverage, 7925,
     /* 222146 */     GIR_EraseRootFromParent_Done,
     /* 222147 */   // Label 4230: @222147
     /* 222147 */   GIM_Try, /*On fail goto*//*Label 4231*/ GIMT_Encode4(222224), // Rule ID 7926 //
     /* 222152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222155 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222160 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222163 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222166 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222169 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222172 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222176 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222180 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222184 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222188 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222192 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222196 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222200 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222204 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222208 */     // MIs[2] Operand 1
     /* 222208 */     // No operand predicates
     /* 222208 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222210 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_S),
     /* 222213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222215 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222222 */     GIR_RootConstrainSelectedInstOperands,
     /* 222223 */     // GIR_Coverage, 7926,
     /* 222223 */     GIR_EraseRootFromParent_Done,
     /* 222224 */   // Label 4231: @222224
     /* 222224 */   GIM_Try, /*On fail goto*//*Label 4232*/ GIMT_Encode4(222301), // Rule ID 7927 //
     /* 222229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222253 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222257 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222265 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222269 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222281 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222285 */     // MIs[2] Operand 1
     /* 222285 */     // No operand predicates
     /* 222285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222287 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222299 */     GIR_RootConstrainSelectedInstOperands,
     /* 222300 */     // GIR_Coverage, 7927,
     /* 222300 */     GIR_EraseRootFromParent_Done,
     /* 222301 */   // Label 4232: @222301
     /* 222301 */   GIM_Try, /*On fail goto*//*Label 4233*/ GIMT_Encode4(222378), // Rule ID 7928 //
     /* 222306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222309 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul),
     /* 222314 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222323 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222326 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222330 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222334 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222342 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222346 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222350 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222354 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222358 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_two),
     /* 222362 */     // MIs[2] Operand 1
     /* 222362 */     // No operand predicates
     /* 222362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222364 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1484:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_two>>))  =>  (FMUL_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZPmI_D),
     /* 222367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222369 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222371 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222376 */     GIR_RootConstrainSelectedInstOperands,
     /* 222377 */     // GIR_Coverage, 7928,
     /* 222377 */     GIR_EraseRootFromParent_Done,
     /* 222378 */   // Label 4233: @222378
     /* 222378 */   GIM_Try, /*On fail goto*//*Label 4234*/ GIMT_Encode4(222455), // Rule ID 7929 //
     /* 222383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222435 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222439 */     // MIs[2] Operand 1
     /* 222439 */     // No operand predicates
     /* 222439 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222441 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222453 */     GIR_RootConstrainSelectedInstOperands,
     /* 222454 */     // GIR_Coverage, 7929,
     /* 222454 */     GIR_EraseRootFromParent_Done,
     /* 222455 */   // Label 4234: @222455
     /* 222455 */   GIM_Try, /*On fail goto*//*Label 4235*/ GIMT_Encode4(222532), // Rule ID 7930 //
     /* 222460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222484 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222488 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222492 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222496 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222500 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222512 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222516 */     // MIs[2] Operand 1
     /* 222516 */     // No operand predicates
     /* 222516 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222518 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_H),
     /* 222521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222530 */     GIR_RootConstrainSelectedInstOperands,
     /* 222531 */     // GIR_Coverage, 7930,
     /* 222531 */     GIR_EraseRootFromParent_Done,
     /* 222532 */   // Label 4235: @222532
     /* 222532 */   GIM_Try, /*On fail goto*//*Label 4236*/ GIMT_Encode4(222609), // Rule ID 7931 //
     /* 222537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222577 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222589 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222593 */     // MIs[2] Operand 1
     /* 222593 */     // No operand predicates
     /* 222593 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222595 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 222595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222604 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222607 */     GIR_RootConstrainSelectedInstOperands,
     /* 222608 */     // GIR_Coverage, 7931,
     /* 222608 */     GIR_EraseRootFromParent_Done,
     /* 222609 */   // Label 4236: @222609
     /* 222609 */   GIM_Try, /*On fail goto*//*Label 4237*/ GIMT_Encode4(222686), // Rule ID 7932 //
     /* 222614 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222617 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222622 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 222625 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 222628 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 222631 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 222634 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222642 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222646 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222650 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222654 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 222658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222666 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222670 */     // MIs[2] Operand 1
     /* 222670 */     // No operand predicates
     /* 222670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222672 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 222672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_S),
     /* 222675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222681 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222684 */     GIR_RootConstrainSelectedInstOperands,
     /* 222685 */     // GIR_Coverage, 7932,
     /* 222685 */     GIR_EraseRootFromParent_Done,
     /* 222686 */   // Label 4237: @222686
     /* 222686 */   GIM_Try, /*On fail goto*//*Label 4238*/ GIMT_Encode4(222763), // Rule ID 7933 //
     /* 222691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222699 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222702 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222705 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222708 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222711 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222715 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222719 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222743 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_half),
     /* 222747 */     // MIs[2] Operand 1
     /* 222747 */     // No operand predicates
     /* 222747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222749 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_half>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 222749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222761 */     GIR_RootConstrainSelectedInstOperands,
     /* 222762 */     // GIR_Coverage, 7933,
     /* 222762 */     GIR_EraseRootFromParent_Done,
     /* 222763 */   // Label 4238: @222763
     /* 222763 */   GIM_Try, /*On fail goto*//*Label 4239*/ GIMT_Encode4(222840), // Rule ID 7934 //
     /* 222768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 222776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 222779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 222782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 222785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 222788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222808 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 222812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222820 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222824 */     // MIs[2] Operand 1
     /* 222824 */     // No operand predicates
     /* 222824 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222826 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FSUBR_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 222826 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmI_D),
     /* 222829 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222831 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222838 */     GIR_RootConstrainSelectedInstOperands,
     /* 222839 */     // GIR_Coverage, 7934,
     /* 222839 */     GIR_EraseRootFromParent_Done,
     /* 222840 */   // Label 4239: @222840
     /* 222840 */   GIM_Try, /*On fail goto*//*Label 4240*/ GIMT_Encode4(222917), // Rule ID 7935 //
     /* 222845 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 222853 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222856 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222859 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222862 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222865 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222869 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222873 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222877 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222881 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222885 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222889 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222893 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222897 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 222901 */     // MIs[2] Operand 1
     /* 222901 */     // No operand predicates
     /* 222901 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222903 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 222903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 222906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222912 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 222915 */     GIR_RootConstrainSelectedInstOperands,
     /* 222916 */     // GIR_Coverage, 7935,
     /* 222916 */     GIR_EraseRootFromParent_Done,
     /* 222917 */   // Label 4240: @222917
     /* 222917 */   GIM_Try, /*On fail goto*//*Label 4241*/ GIMT_Encode4(222994), // Rule ID 7936 //
     /* 222922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 222925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 222930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 222933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 222936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 222939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 222942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 222950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 222954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 222958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 222962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 222966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 222970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 222974 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 222978 */     // MIs[2] Operand 1
     /* 222978 */     // No operand predicates
     /* 222978 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 222980 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 222980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_H),
     /* 222983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 222985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 222987 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 222989 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 222992 */     GIR_RootConstrainSelectedInstOperands,
     /* 222993 */     // GIR_Coverage, 7936,
     /* 222993 */     GIR_EraseRootFromParent_Done,
     /* 222994 */   // Label 4241: @222994
     /* 222994 */   GIM_Try, /*On fail goto*//*Label 4242*/ GIMT_Encode4(223071), // Rule ID 7937 //
     /* 222999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223051 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223055 */     // MIs[2] Operand 1
     /* 223055 */     // No operand predicates
     /* 223055 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223057 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223069 */     GIR_RootConstrainSelectedInstOperands,
     /* 223070 */     // GIR_Coverage, 7937,
     /* 223070 */     GIR_EraseRootFromParent_Done,
     /* 223071 */   // Label 4242: @223071
     /* 223071 */   GIM_Try, /*On fail goto*//*Label 4243*/ GIMT_Encode4(223148), // Rule ID 7938 //
     /* 223076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223079 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223084 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223087 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223090 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223093 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223096 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223100 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223104 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223120 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223124 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223128 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223132 */     // MIs[2] Operand 1
     /* 223132 */     // No operand predicates
     /* 223132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223134 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_S),
     /* 223137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223143 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223146 */     GIR_RootConstrainSelectedInstOperands,
     /* 223147 */     // GIR_Coverage, 7938,
     /* 223147 */     GIR_EraseRootFromParent_Done,
     /* 223148 */   // Label 4243: @223148
     /* 223148 */   GIM_Try, /*On fail goto*//*Label 4244*/ GIMT_Encode4(223225), // Rule ID 7939 //
     /* 223153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223167 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223170 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223181 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223197 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223201 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223205 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223209 */     // MIs[2] Operand 1
     /* 223209 */     // No operand predicates
     /* 223209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223211 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223220 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223223 */     GIR_RootConstrainSelectedInstOperands,
     /* 223224 */     // GIR_Coverage, 7939,
     /* 223224 */     GIR_EraseRootFromParent_Done,
     /* 223225 */   // Label 4244: @223225
     /* 223225 */   GIM_Try, /*On fail goto*//*Label 4245*/ GIMT_Encode4(223302), // Rule ID 7940 //
     /* 223230 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223233 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnm),
     /* 223238 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223241 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223244 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223247 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223250 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223282 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223286 */     // MIs[2] Operand 1
     /* 223286 */     // No operand predicates
     /* 223286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223288 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1438:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAXNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNM_ZPmI_D),
     /* 223291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223293 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223297 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223300 */     GIR_RootConstrainSelectedInstOperands,
     /* 223301 */     // GIR_Coverage, 7940,
     /* 223301 */     GIR_EraseRootFromParent_Done,
     /* 223302 */   // Label 4245: @223302
     /* 223302 */   GIM_Try, /*On fail goto*//*Label 4246*/ GIMT_Encode4(223379), // Rule ID 7941 //
     /* 223307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223339 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223343 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223347 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223351 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223355 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223359 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223363 */     // MIs[2] Operand 1
     /* 223363 */     // No operand predicates
     /* 223363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223365 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223377 */     GIR_RootConstrainSelectedInstOperands,
     /* 223378 */     // GIR_Coverage, 7941,
     /* 223378 */     GIR_EraseRootFromParent_Done,
     /* 223379 */   // Label 4246: @223379
     /* 223379 */   GIM_Try, /*On fail goto*//*Label 4247*/ GIMT_Encode4(223456), // Rule ID 7942 //
     /* 223384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223387 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223392 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223395 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223398 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223401 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223404 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223412 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223428 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223432 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223436 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223440 */     // MIs[2] Operand 1
     /* 223440 */     // No operand predicates
     /* 223440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223442 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_H),
     /* 223445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223449 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223451 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223454 */     GIR_RootConstrainSelectedInstOperands,
     /* 223455 */     // GIR_Coverage, 7942,
     /* 223455 */     GIR_EraseRootFromParent_Done,
     /* 223456 */   // Label 4247: @223456
     /* 223456 */   GIM_Try, /*On fail goto*//*Label 4248*/ GIMT_Encode4(223533), // Rule ID 7943 //
     /* 223461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223485 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223489 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223505 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223509 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223513 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223517 */     // MIs[2] Operand 1
     /* 223517 */     // No operand predicates
     /* 223517 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223519 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223528 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223531 */     GIR_RootConstrainSelectedInstOperands,
     /* 223532 */     // GIR_Coverage, 7943,
     /* 223532 */     GIR_EraseRootFromParent_Done,
     /* 223533 */   // Label 4248: @223533
     /* 223533 */   GIM_Try, /*On fail goto*//*Label 4249*/ GIMT_Encode4(223610), // Rule ID 7944 //
     /* 223538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223546 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223549 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223552 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223555 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223570 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223574 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223578 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223582 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223586 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223590 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223594 */     // MIs[2] Operand 1
     /* 223594 */     // No operand predicates
     /* 223594 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223596 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 223596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_S),
     /* 223599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223608 */     GIR_RootConstrainSelectedInstOperands,
     /* 223609 */     // GIR_Coverage, 7944,
     /* 223609 */     GIR_EraseRootFromParent_Done,
     /* 223610 */   // Label 4249: @223610
     /* 223610 */   GIM_Try, /*On fail goto*//*Label 4250*/ GIMT_Encode4(223687), // Rule ID 7945 //
     /* 223615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223623 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223626 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223629 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223632 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223639 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223643 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223667 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223671 */     // MIs[2] Operand 1
     /* 223671 */     // No operand predicates
     /* 223671 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223673 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 223673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223680 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223685 */     GIR_RootConstrainSelectedInstOperands,
     /* 223686 */     // GIR_Coverage, 7945,
     /* 223686 */     GIR_EraseRootFromParent_Done,
     /* 223687 */   // Label 4250: @223687
     /* 223687 */   GIM_Try, /*On fail goto*//*Label 4251*/ GIMT_Encode4(223764), // Rule ID 7946 //
     /* 223692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnm),
     /* 223700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 223703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 223706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 223709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 223712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223716 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 223736 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223740 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223744 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223748 */     // MIs[2] Operand 1
     /* 223748 */     // No operand predicates
     /* 223748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223750 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1456:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMINNM_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 223750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNM_ZPmI_D),
     /* 223753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223755 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223757 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223759 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223762 */     GIR_RootConstrainSelectedInstOperands,
     /* 223763 */     // GIR_Coverage, 7946,
     /* 223763 */     GIR_EraseRootFromParent_Done,
     /* 223764 */   // Label 4251: @223764
     /* 223764 */   GIM_Try, /*On fail goto*//*Label 4252*/ GIMT_Encode4(223841), // Rule ID 7947 //
     /* 223769 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223772 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223777 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223786 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223793 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223797 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223813 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223817 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223821 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223825 */     // MIs[2] Operand 1
     /* 223825 */     // No operand predicates
     /* 223825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 223827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 223830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223839 */     GIR_RootConstrainSelectedInstOperands,
     /* 223840 */     // GIR_Coverage, 7947,
     /* 223840 */     GIR_EraseRootFromParent_Done,
     /* 223841 */   // Label 4252: @223841
     /* 223841 */   GIM_Try, /*On fail goto*//*Label 4253*/ GIMT_Encode4(223918), // Rule ID 7948 //
     /* 223846 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223849 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223854 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 223857 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 223860 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 223863 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 223866 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223878 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223882 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223886 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 223890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223898 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 223902 */     // MIs[2] Operand 1
     /* 223902 */     // No operand predicates
     /* 223902 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223904 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 223904 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_H),
     /* 223907 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223909 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223911 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223913 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 223916 */     GIR_RootConstrainSelectedInstOperands,
     /* 223917 */     // GIR_Coverage, 7948,
     /* 223917 */     GIR_EraseRootFromParent_Done,
     /* 223918 */   // Label 4253: @223918
     /* 223918 */   GIM_Try, /*On fail goto*//*Label 4254*/ GIMT_Encode4(223995), // Rule ID 7949 //
     /* 223923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 223926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 223931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 223934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 223937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 223940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 223943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 223951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 223955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 223959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 223963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 223967 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 223971 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 223975 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 223979 */     // MIs[2] Operand 1
     /* 223979 */     // No operand predicates
     /* 223979 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 223981 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 223981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 223984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 223986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 223988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 223990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 223993 */     GIR_RootConstrainSelectedInstOperands,
     /* 223994 */     // GIR_Coverage, 7949,
     /* 223994 */     GIR_EraseRootFromParent_Done,
     /* 223995 */   // Label 4254: @223995
     /* 223995 */   GIM_Try, /*On fail goto*//*Label 4255*/ GIMT_Encode4(224072), // Rule ID 7950 //
     /* 224000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224003 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224008 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224011 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224014 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224017 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224028 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224040 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224052 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224056 */     // MIs[2] Operand 1
     /* 224056 */     // No operand predicates
     /* 224056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224058 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_S),
     /* 224061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224065 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224067 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224070 */     GIR_RootConstrainSelectedInstOperands,
     /* 224071 */     // GIR_Coverage, 7950,
     /* 224071 */     GIR_EraseRootFromParent_Done,
     /* 224072 */   // Label 4255: @224072
     /* 224072 */   GIM_Try, /*On fail goto*//*Label 4256*/ GIMT_Encode4(224149), // Rule ID 7951 //
     /* 224077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224101 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224117 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224121 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224125 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224129 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224133 */     // MIs[2] Operand 1
     /* 224133 */     // No operand predicates
     /* 224133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224135 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224144 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224147 */     GIR_RootConstrainSelectedInstOperands,
     /* 224148 */     // GIR_Coverage, 7951,
     /* 224148 */     GIR_EraseRootFromParent_Done,
     /* 224149 */   // Label 4256: @224149
     /* 224149 */   GIM_Try, /*On fail goto*//*Label 4257*/ GIMT_Encode4(224226), // Rule ID 7952 //
     /* 224154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224157 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmax),
     /* 224162 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224165 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224168 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224171 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224174 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224178 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224206 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224210 */     // MIs[2] Operand 1
     /* 224210 */     // No operand predicates
     /* 224210 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224212 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1432:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMAX_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAX_ZPmI_D),
     /* 224215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224217 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224221 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224224 */     GIR_RootConstrainSelectedInstOperands,
     /* 224225 */     // GIR_Coverage, 7952,
     /* 224225 */     GIR_EraseRootFromParent_Done,
     /* 224226 */   // Label 4257: @224226
     /* 224226 */   GIM_Try, /*On fail goto*//*Label 4258*/ GIMT_Encode4(224303), // Rule ID 7953 //
     /* 224231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224234 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224239 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224242 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224245 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224248 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224251 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224259 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224283 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224287 */     // MIs[2] Operand 1
     /* 224287 */     // No operand predicates
     /* 224287 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224289 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 0:{ *:[i32] })
     /* 224289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224301 */     GIR_RootConstrainSelectedInstOperands,
     /* 224302 */     // GIR_Coverage, 7953,
     /* 224302 */     GIR_EraseRootFromParent_Done,
     /* 224303 */   // Label 4258: @224303
     /* 224303 */   GIM_Try, /*On fail goto*//*Label 4259*/ GIMT_Encode4(224380), // Rule ID 7954 //
     /* 224308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224311 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224316 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224319 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 224322 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224325 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 224328 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224332 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224344 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224348 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 224352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224360 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224364 */     // MIs[2] Operand 1
     /* 224364 */     // No operand predicates
     /* 224364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224366 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$Pg, ZPR:{ *:[nxv8f16] }:$Zs1, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Pg, ?:{ *:[nxv8f16] }:$Zs1, 1:{ *:[i32] })
     /* 224366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_H),
     /* 224369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224371 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224375 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224378 */     GIR_RootConstrainSelectedInstOperands,
     /* 224379 */     // GIR_Coverage, 7954,
     /* 224379 */     GIR_EraseRootFromParent_Done,
     /* 224380 */   // Label 4259: @224380
     /* 224380 */   GIM_Try, /*On fail goto*//*Label 4260*/ GIMT_Encode4(224457), // Rule ID 7955 //
     /* 224385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224413 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224437 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224441 */     // MIs[2] Operand 1
     /* 224441 */     // No operand predicates
     /* 224441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224443 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 0:{ *:[i32] })
     /* 224443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224452 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224455 */     GIR_RootConstrainSelectedInstOperands,
     /* 224456 */     // GIR_Coverage, 7955,
     /* 224456 */     GIR_EraseRootFromParent_Done,
     /* 224457 */   // Label 4260: @224457
     /* 224457 */   GIM_Try, /*On fail goto*//*Label 4261*/ GIMT_Encode4(224534), // Rule ID 7956 //
     /* 224462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224465 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224470 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 224476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224479 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 224482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 224506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224514 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224518 */     // MIs[2] Operand 1
     /* 224518 */     // No operand predicates
     /* 224518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224520 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR:{ *:[nxv4f32] }:$Zs1, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Pg, ?:{ *:[nxv4f32] }:$Zs1, 1:{ *:[i32] })
     /* 224520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_S),
     /* 224523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224525 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224527 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224529 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224532 */     GIR_RootConstrainSelectedInstOperands,
     /* 224533 */     // GIR_Coverage, 7956,
     /* 224533 */     GIR_EraseRootFromParent_Done,
     /* 224534 */   // Label 4261: @224534
     /* 224534 */   GIM_Try, /*On fail goto*//*Label 4262*/ GIMT_Encode4(224611), // Rule ID 7957 //
     /* 224539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224567 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224579 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224583 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224587 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224591 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 224595 */     // MIs[2] Operand 1
     /* 224595 */     // No operand predicates
     /* 224595 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224597 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 0:{ *:[i32] })
     /* 224597 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224600 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224602 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 224609 */     GIR_RootConstrainSelectedInstOperands,
     /* 224610 */     // GIR_Coverage, 7957,
     /* 224610 */     GIR_EraseRootFromParent_Done,
     /* 224611 */   // Label 4262: @224611
     /* 224611 */   GIM_Try, /*On fail goto*//*Label 4263*/ GIMT_Encode4(224688), // Rule ID 7958 //
     /* 224616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 224619 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmin),
     /* 224624 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 224627 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 224630 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 224633 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 224636 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 224644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/4, // MIs[1]
     /* 224652 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 224656 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 224660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 224664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 224668 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm_one),
     /* 224672 */     // MIs[2] Operand 1
     /* 224672 */     // No operand predicates
     /* 224672 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 224674 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1450:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR:{ *:[nxv2f64] }:$Zs1, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm_one>>))  =>  (FMIN_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Pg, ?:{ *:[nxv2f64] }:$Zs1, 1:{ *:[i32] })
     /* 224674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMIN_ZPmI_D),
     /* 224677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 224681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zs1
     /* 224683 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 224686 */     GIR_RootConstrainSelectedInstOperands,
     /* 224687 */     // GIR_Coverage, 7958,
     /* 224687 */     GIR_EraseRootFromParent_Done,
     /* 224688 */   // Label 4263: @224688
     /* 224688 */   GIM_Try, /*On fail goto*//*Label 4264*/ GIMT_Encode4(224744), // Rule ID 55 //
     /* 224693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224696 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224701 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224704 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224707 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224710 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224718 */     // MIs[0] Operand 3
     /* 224718 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(0),
     /* 224729 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224733 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 0:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIA),
     /* 224736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224742 */     GIR_RootConstrainSelectedInstOperands,
     /* 224743 */     // GIR_Coverage, 55,
     /* 224743 */     GIR_EraseRootFromParent_Done,
     /* 224744 */   // Label 4264: @224744
     /* 224744 */   GIM_Try, /*On fail goto*//*Label 4265*/ GIMT_Encode4(224800), // Rule ID 56 //
     /* 224749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224763 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224766 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224774 */     // MIs[0] Operand 3
     /* 224774 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(1),
     /* 224785 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224789 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 1:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACIB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACIB),
     /* 224792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224798 */     GIR_RootConstrainSelectedInstOperands,
     /* 224799 */     // GIR_Coverage, 56,
     /* 224799 */     GIR_EraseRootFromParent_Done,
     /* 224800 */   // Label 4265: @224800
     /* 224800 */   GIM_Try, /*On fail goto*//*Label 4266*/ GIMT_Encode4(224856), // Rule ID 57 //
     /* 224805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224819 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224822 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224830 */     // MIs[0] Operand 3
     /* 224830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(2),
     /* 224841 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224845 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 2:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDA:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDA),
     /* 224848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224852 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224854 */     GIR_RootConstrainSelectedInstOperands,
     /* 224855 */     // GIR_Coverage, 57,
     /* 224855 */     GIR_EraseRootFromParent_Done,
     /* 224856 */   // Label 4266: @224856
     /* 224856 */   GIM_Try, /*On fail goto*//*Label 4267*/ GIMT_Encode4(224912), // Rule ID 58 //
     /* 224861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasPAuth),
     /* 224864 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::ptrauth_sign),
     /* 224869 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 224872 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 224875 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s64,
     /* 224878 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 224886 */     // MIs[0] Operand 3
     /* 224886 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/3, GIMT_Encode8(3),
     /* 224897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 224901 */     // (intrinsic_wo_chain:{ *:[i64] } 297:{ *:[iPTR] }, GPR64:{ *:[i64] }:$Rd, 3:{ *:[i32] }, GPR64sp:{ *:[i64] }:$Rn)  =>  (PACDB:{ *:[i64] } GPR64:{ *:[i64] }:$Rd, GPR64sp:{ *:[i64] }:$Rn)
     /* 224901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PACDB),
     /* 224904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 224906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 224908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 224910 */     GIR_RootConstrainSelectedInstOperands,
     /* 224911 */     // GIR_Coverage, 58,
     /* 224911 */     GIR_EraseRootFromParent_Done,
     /* 224912 */   // Label 4267: @224912
     /* 224912 */   GIM_Try, /*On fail goto*//*Label 4268*/ GIMT_Encode4(224967), // Rule ID 2795 //
     /* 224917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 224920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 224925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 224928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 224931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 224934 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224946 */     // MIs[0] imm
     /* 224946 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 224949 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 224954 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1549:{ *:[iPTR] }, ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_H:{ *:[nxv8f16] } ZPR16:{ *:[nxv8f16] }:$Zn, ZPR16:{ *:[nxv8f16] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 224954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_H),
     /* 224957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 224959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 224961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 224963 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 224965 */     GIR_RootConstrainSelectedInstOperands,
     /* 224966 */     // GIR_Coverage, 2795,
     /* 224966 */     GIR_EraseRootFromParent_Done,
     /* 224967 */   // Label 4268: @224967
     /* 224967 */   GIM_Try, /*On fail goto*//*Label 4269*/ GIMT_Encode4(225022), // Rule ID 2796 //
     /* 224972 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 224975 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 224980 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 224983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 224986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 224989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 224997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225001 */     // MIs[0] imm
     /* 225001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225009 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1549:{ *:[iPTR] }, ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_S:{ *:[nxv4f32] } ZPR32:{ *:[nxv4f32] }:$Zn, ZPR32:{ *:[nxv4f32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_S),
     /* 225012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225018 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225020 */     GIR_RootConstrainSelectedInstOperands,
     /* 225021 */     // GIR_Coverage, 2796,
     /* 225021 */     GIR_EraseRootFromParent_Done,
     /* 225022 */   // Label 4269: @225022
     /* 225022 */   GIM_Try, /*On fail goto*//*Label 4270*/ GIMT_Encode4(225077), // Rule ID 2797 //
     /* 225027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 225030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ftmad_x),
     /* 225035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225044 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225052 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225056 */     // MIs[0] imm
     /* 225056 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225059 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 225064 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1549:{ *:[iPTR] }, ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)  =>  (FTMAD_ZZI_D:{ *:[nxv2f64] } ZPR64:{ *:[nxv2f64] }:$Zn, ZPR64:{ *:[nxv2f64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$imm)
     /* 225064 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FTMAD_ZZI_D),
     /* 225067 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 225069 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 225071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 225073 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225075 */     GIR_RootConstrainSelectedInstOperands,
     /* 225076 */     // GIR_Coverage, 2797,
     /* 225076 */     GIR_EraseRootFromParent_Done,
     /* 225077 */   // Label 4270: @225077
     /* 225077 */   GIM_Try, /*On fail goto*//*Label 4271*/ GIMT_Encode4(225132), // Rule ID 3547 //
     /* 225082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 225099 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225111 */     // MIs[0] Idx
     /* 225111 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225114 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_1),
     /* 225119 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv8i16] }:$Zd, PPR16:{ *:[nxv8i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx)  =>  (PMOV_ZIP_H:{ *:[nxv8i16] } ZPRAny:{ *:[nxv8i16] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_1>>:$Idx, PPR16:{ *:[nxv8i1] }:$Pn)
     /* 225119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_H),
     /* 225122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225128 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225130 */     GIR_RootConstrainSelectedInstOperands,
     /* 225131 */     // GIR_Coverage, 3547,
     /* 225131 */     GIR_EraseRootFromParent_Done,
     /* 225132 */   // Label 4271: @225132
     /* 225132 */   GIM_Try, /*On fail goto*//*Label 4272*/ GIMT_Encode4(225187), // Rule ID 3548 //
     /* 225137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 225154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225162 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225166 */     // MIs[0] Idx
     /* 225166 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225169 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_3),
     /* 225174 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv4i32] }:$Zd, PPR32:{ *:[nxv4i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx)  =>  (PMOV_ZIP_S:{ *:[nxv4i32] } ZPRAny:{ *:[nxv4i32] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_3>>:$Idx, PPR32:{ *:[nxv4i1] }:$Pn)
     /* 225174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_S),
     /* 225177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225181 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225185 */     GIR_RootConstrainSelectedInstOperands,
     /* 225186 */     // GIR_Coverage, 3548,
     /* 225186 */     GIR_EraseRootFromParent_Done,
     /* 225187 */   // Label 4272: @225187
     /* 225187 */   GIM_Try, /*On fail goto*//*Label 4273*/ GIMT_Encode4(225242), // Rule ID 3549 //
     /* 225192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 225195 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_pmov_to_vector_lane_merging),
     /* 225200 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225203 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225206 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 225209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 225221 */     // MIs[0] Idx
     /* 225221 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225224 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_1_7),
     /* 225229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1635:{ *:[iPTR] }, ZPRAny:{ *:[nxv2i64] }:$Zd, PPR64:{ *:[nxv2i1] }:$Pn, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx)  =>  (PMOV_ZIP_D:{ *:[nxv2i64] } ZPRAny:{ *:[nxv2i64] }:$Zd, (timm:{ *:[i32] })<<P:Predicate_timm32_1_7>>:$Idx, PPR64:{ *:[nxv2i1] }:$Pn)
     /* 225229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PMOV_ZIP_D),
     /* 225232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zd
     /* 225236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Idx
     /* 225238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pn
     /* 225240 */     GIR_RootConstrainSelectedInstOperands,
     /* 225241 */     // GIR_Coverage, 3549,
     /* 225241 */     GIR_EraseRootFromParent_Done,
     /* 225242 */   // Label 4273: @225242
     /* 225242 */   GIM_Try, /*On fail goto*//*Label 4274*/ GIMT_Encode4(225297), // Rule ID 3843 //
     /* 225247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 225250 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_xar),
     /* 225255 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 225258 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 225261 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 225264 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225268 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225272 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 225276 */     // MIs[0] imm
     /* 225276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm0_63),
     /* 225284 */     // (intrinsic_wo_chain:{ *:[v2i64] } 550:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)  =>  (XAR:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_timm0_63>>:$imm)
     /* 225284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR),
     /* 225287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 225289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 225291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 225293 */     GIR_RootToRootCopy, /*OpIdx*/4, // imm
     /* 225295 */     GIR_RootConstrainSelectedInstOperands,
     /* 225296 */     // GIR_Coverage, 3843,
     /* 225296 */     GIR_EraseRootFromParent_Done,
     /* 225297 */   // Label 4274: @225297
     /* 225297 */   GIM_Try, /*On fail goto*//*Label 4275*/ GIMT_Encode4(225344), // Rule ID 2849 //
     /* 225302 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225316 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225323 */     // MIs[0] idx
     /* 225323 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225326 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225331 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1485:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMUL_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 225331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_H),
     /* 225334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225340 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225342 */     GIR_RootConstrainSelectedInstOperands,
     /* 225343 */     // GIR_Coverage, 2849,
     /* 225343 */     GIR_EraseRootFromParent_Done,
     /* 225344 */   // Label 4275: @225344
     /* 225344 */   GIM_Try, /*On fail goto*//*Label 4276*/ GIMT_Encode4(225391), // Rule ID 2850 //
     /* 225349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225352 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225357 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225360 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225363 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225370 */     // MIs[0] idx
     /* 225370 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225373 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225378 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1485:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMUL_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 225378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_S),
     /* 225381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225383 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225387 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225389 */     GIR_RootConstrainSelectedInstOperands,
     /* 225390 */     // GIR_Coverage, 2850,
     /* 225390 */     GIR_EraseRootFromParent_Done,
     /* 225391 */   // Label 4276: @225391
     /* 225391 */   GIM_Try, /*On fail goto*//*Label 4277*/ GIMT_Encode4(225438), // Rule ID 2851 //
     /* 225396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 225399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmul_lane),
     /* 225404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225417 */     // MIs[0] idx
     /* 225417 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225420 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225425 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1485:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMUL_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 225425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZI_D),
     /* 225428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225434 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 225436 */     GIR_RootConstrainSelectedInstOperands,
     /* 225437 */     // GIR_Coverage, 2851,
     /* 225437 */     GIR_EraseRootFromParent_Done,
     /* 225438 */   // Label 4277: @225438
     /* 225438 */   GIM_Try, /*On fail goto*//*Label 4278*/ GIMT_Encode4(225485), // Rule ID 3000 //
     /* 225443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225464 */     // MIs[0] Op3
     /* 225464 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225467 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225472 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1616:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (MUL_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_H),
     /* 225475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225477 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225481 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225483 */     GIR_RootConstrainSelectedInstOperands,
     /* 225484 */     // GIR_Coverage, 3000,
     /* 225484 */     GIR_EraseRootFromParent_Done,
     /* 225485 */   // Label 4278: @225485
     /* 225485 */   GIM_Try, /*On fail goto*//*Label 4279*/ GIMT_Encode4(225532), // Rule ID 3001 //
     /* 225490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225493 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225498 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225501 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225504 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225511 */     // MIs[0] Op3
     /* 225511 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225514 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225519 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1616:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (MUL_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_S),
     /* 225522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225530 */     GIR_RootConstrainSelectedInstOperands,
     /* 225531 */     // GIR_Coverage, 3001,
     /* 225531 */     GIR_EraseRootFromParent_Done,
     /* 225532 */   // Label 4279: @225532
     /* 225532 */   GIM_Try, /*On fail goto*//*Label 4280*/ GIMT_Encode4(225579), // Rule ID 3002 //
     /* 225537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mul_lane),
     /* 225545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225558 */     // MIs[0] Op3
     /* 225558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 225566 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1616:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (MUL_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 225566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MUL_ZZZI_D),
     /* 225569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225571 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225573 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225575 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225577 */     GIR_RootConstrainSelectedInstOperands,
     /* 225578 */     // GIR_Coverage, 3002,
     /* 225578 */     GIR_EraseRootFromParent_Done,
     /* 225579 */   // Label 4280: @225579
     /* 225579 */   GIM_Try, /*On fail goto*//*Label 4281*/ GIMT_Encode4(225626), // Rule ID 3003 //
     /* 225584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225587 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225592 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225595 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225598 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225605 */     // MIs[0] Op3
     /* 225605 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225608 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 225613 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1762:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 225613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_S),
     /* 225616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225624 */     GIR_RootConstrainSelectedInstOperands,
     /* 225625 */     // GIR_Coverage, 3003,
     /* 225625 */     GIR_EraseRootFromParent_Done,
     /* 225626 */   // Label 4281: @225626
     /* 225626 */   GIM_Try, /*On fail goto*//*Label 4282*/ GIMT_Encode4(225673), // Rule ID 3004 //
     /* 225631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullb_lane),
     /* 225639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225652 */     // MIs[0] Op3
     /* 225652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 225660 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1762:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 225660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLB_ZZZI_D),
     /* 225663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225671 */     GIR_RootConstrainSelectedInstOperands,
     /* 225672 */     // GIR_Coverage, 3004,
     /* 225672 */     GIR_EraseRootFromParent_Done,
     /* 225673 */   // Label 4282: @225673
     /* 225673 */   GIM_Try, /*On fail goto*//*Label 4283*/ GIMT_Encode4(225720), // Rule ID 3052 //
     /* 225678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225686 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225689 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225692 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 225695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225699 */     // MIs[0] Op3
     /* 225699 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225702 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225707 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1873:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_B),
     /* 225710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225718 */     GIR_RootConstrainSelectedInstOperands,
     /* 225719 */     // GIR_Coverage, 3052,
     /* 225719 */     GIR_EraseRootFromParent_Done,
     /* 225720 */   // Label 4283: @225720
     /* 225720 */   GIM_Try, /*On fail goto*//*Label 4284*/ GIMT_Encode4(225767), // Rule ID 3054 //
     /* 225725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225746 */     // MIs[0] Op3
     /* 225746 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225749 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 225754 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1873:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 225754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_H),
     /* 225757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225765 */     GIR_RootConstrainSelectedInstOperands,
     /* 225766 */     // GIR_Coverage, 3054,
     /* 225766 */     GIR_EraseRootFromParent_Done,
     /* 225767 */   // Label 4284: @225767
     /* 225767 */   GIM_Try, /*On fail goto*//*Label 4285*/ GIMT_Encode4(225814), // Rule ID 3056 //
     /* 225772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225775 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225780 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225793 */     // MIs[0] Op3
     /* 225793 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225796 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 225801 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1873:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 225801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_S),
     /* 225804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225806 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225808 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225810 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225812 */     GIR_RootConstrainSelectedInstOperands,
     /* 225813 */     // GIR_Coverage, 3056,
     /* 225813 */     GIR_EraseRootFromParent_Done,
     /* 225814 */   // Label 4285: @225814
     /* 225814 */   GIM_Try, /*On fail goto*//*Label 4286*/ GIMT_Encode4(225861), // Rule ID 3058 //
     /* 225819 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225822 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ssra),
     /* 225827 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 225830 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 225833 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225840 */     // MIs[0] Op3
     /* 225840 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225843 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 225848 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1873:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 225848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSRA_ZZI_D),
     /* 225851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 225853 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225857 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225859 */     GIR_RootConstrainSelectedInstOperands,
     /* 225860 */     // GIR_Coverage, 3058,
     /* 225860 */     GIR_EraseRootFromParent_Done,
     /* 225861 */   // Label 4286: @225861
     /* 225861 */   GIM_Try, /*On fail goto*//*Label 4287*/ GIMT_Encode4(225908), // Rule ID 3080 //
     /* 225866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225869 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 225874 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 225877 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 225880 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 225883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225887 */     // MIs[0] Op3
     /* 225887 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225890 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 225895 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1853:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 225895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_B),
     /* 225898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225906 */     GIR_RootConstrainSelectedInstOperands,
     /* 225907 */     // GIR_Coverage, 3080,
     /* 225907 */     GIR_EraseRootFromParent_Done,
     /* 225908 */   // Label 4287: @225908
     /* 225908 */   GIM_Try, /*On fail goto*//*Label 4288*/ GIMT_Encode4(225955), // Rule ID 3081 //
     /* 225913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 225921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 225924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 225927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 225930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225934 */     // MIs[0] Op3
     /* 225934 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225937 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 225942 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1853:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 225942 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_H),
     /* 225945 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225947 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225949 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225951 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 225953 */     GIR_RootConstrainSelectedInstOperands,
     /* 225954 */     // GIR_Coverage, 3081,
     /* 225954 */     GIR_EraseRootFromParent_Done,
     /* 225955 */   // Label 4288: @225955
     /* 225955 */   GIM_Try, /*On fail goto*//*Label 4289*/ GIMT_Encode4(226002), // Rule ID 3082 //
     /* 225960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 225963 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrunt),
     /* 225968 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 225971 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 225974 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 225977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 225981 */     // MIs[0] Op3
     /* 225981 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 225984 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 225989 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1853:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 225989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRUNT_ZZI_S),
     /* 225992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 225994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 225996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 225998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226000 */     GIR_RootConstrainSelectedInstOperands,
     /* 226001 */     // GIR_Coverage, 3082,
     /* 226001 */     GIR_EraseRootFromParent_Done,
     /* 226002 */   // Label 4289: @226002
     /* 226002 */   GIM_Try, /*On fail goto*//*Label 4290*/ GIMT_Encode4(226049), // Rule ID 3151 //
     /* 226007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226028 */     // MIs[0] Op3
     /* 226028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 226036 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2154:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (XAR_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 226036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_B),
     /* 226039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226047 */     GIR_RootConstrainSelectedInstOperands,
     /* 226048 */     // GIR_Coverage, 3151,
     /* 226048 */     GIR_EraseRootFromParent_Done,
     /* 226049 */   // Label 4290: @226049
     /* 226049 */   GIM_Try, /*On fail goto*//*Label 4291*/ GIMT_Encode4(226096), // Rule ID 3152 //
     /* 226054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226057 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226062 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226065 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226068 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226075 */     // MIs[0] Op3
     /* 226075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 226083 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2154:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (XAR_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 226083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_H),
     /* 226086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226094 */     GIR_RootConstrainSelectedInstOperands,
     /* 226095 */     // GIR_Coverage, 3152,
     /* 226095 */     GIR_EraseRootFromParent_Done,
     /* 226096 */   // Label 4291: @226096
     /* 226096 */   GIM_Try, /*On fail goto*//*Label 4292*/ GIMT_Encode4(226143), // Rule ID 3153 //
     /* 226101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226122 */     // MIs[0] Op3
     /* 226122 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226125 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 226130 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2154:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (XAR_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 226130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_S),
     /* 226133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226137 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226139 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226141 */     GIR_RootConstrainSelectedInstOperands,
     /* 226142 */     // GIR_Coverage, 3153,
     /* 226142 */     GIR_EraseRootFromParent_Done,
     /* 226143 */   // Label 4292: @226143
     /* 226143 */   GIM_Try, /*On fail goto*//*Label 4293*/ GIMT_Encode4(226190), // Rule ID 3154 //
     /* 226148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_xar),
     /* 226156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226169 */     // MIs[0] Op3
     /* 226169 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226172 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 226177 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2154:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (XAR_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 226177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XAR_ZZZI_D),
     /* 226180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226188 */     GIR_RootConstrainSelectedInstOperands,
     /* 226189 */     // GIR_Coverage, 3154,
     /* 226189 */     GIR_EraseRootFromParent_Done,
     /* 226190 */   // Label 4293: @226190
     /* 226190 */   GIM_Try, /*On fail goto*//*Label 4294*/ GIMT_Encode4(226237), // Rule ID 3532 //
     /* 226195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 226198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_extq),
     /* 226203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226216 */     // MIs[0] Op3
     /* 226216 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226219 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_15),
     /* 226224 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1364:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)  =>  (EXTQ_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_15>>:$Op3)
     /* 226224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTQ_ZZI),
     /* 226227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 226229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226233 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226235 */     GIR_RootConstrainSelectedInstOperands,
     /* 226236 */     // GIR_Coverage, 3532,
     /* 226236 */     GIR_EraseRootFromParent_Done,
     /* 226237 */   // Label 4294: @226237
     /* 226237 */   GIM_Try, /*On fail goto*//*Label 4295*/ GIMT_Encode4(226284), // Rule ID 3580 //
     /* 226242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226245 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226250 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226263 */     // MIs[0] Op3
     /* 226263 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226266 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226271 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1603:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI2_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_B),
     /* 226274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226276 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226280 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226282 */     GIR_RootConstrainSelectedInstOperands,
     /* 226283 */     // GIR_Coverage, 3580,
     /* 226283 */     GIR_EraseRootFromParent_Done,
     /* 226284 */   // Label 4295: @226284
     /* 226284 */   GIM_Try, /*On fail goto*//*Label 4296*/ GIMT_Encode4(226331), // Rule ID 3581 //
     /* 226289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226292 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226297 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226300 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226303 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226310 */     // MIs[0] Op3
     /* 226310 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226313 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226318 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1603:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226318 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226321 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226325 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226327 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226329 */     GIR_RootConstrainSelectedInstOperands,
     /* 226330 */     // GIR_Coverage, 3581,
     /* 226330 */     GIR_EraseRootFromParent_Done,
     /* 226331 */   // Label 4296: @226331
     /* 226331 */   GIM_Try, /*On fail goto*//*Label 4297*/ GIMT_Encode4(226378), // Rule ID 3582 //
     /* 226336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226339 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti2_lane),
     /* 226344 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226347 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226350 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226357 */     // MIs[0] Op3
     /* 226357 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226360 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 226365 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1603:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)  =>  (LUTI2_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$Op3)
     /* 226365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI2_ZZZI_H),
     /* 226368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226376 */     GIR_RootConstrainSelectedInstOperands,
     /* 226377 */     // GIR_Coverage, 3582,
     /* 226377 */     GIR_EraseRootFromParent_Done,
     /* 226378 */   // Label 4297: @226378
     /* 226378 */   GIM_Try, /*On fail goto*//*Label 4298*/ GIMT_Encode4(226425), // Rule ID 3583 //
     /* 226383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 226394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 226397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226404 */     // MIs[0] Op3
     /* 226404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 226412 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1604:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)  =>  (LUTI4_ZZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$Op3)
     /* 226412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_B),
     /* 226415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226423 */     GIR_RootConstrainSelectedInstOperands,
     /* 226424 */     // GIR_Coverage, 3583,
     /* 226424 */     GIR_EraseRootFromParent_Done,
     /* 226425 */   // Label 4298: @226425
     /* 226425 */   GIM_Try, /*On fail goto*//*Label 4299*/ GIMT_Encode4(226472), // Rule ID 3584 //
     /* 226430 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226433 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226438 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226451 */     // MIs[0] Op3
     /* 226451 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226454 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1604:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226470 */     GIR_RootConstrainSelectedInstOperands,
     /* 226471 */     // GIR_Coverage, 3584,
     /* 226471 */     GIR_EraseRootFromParent_Done,
     /* 226472 */   // Label 4299: @226472
     /* 226472 */   GIM_Try, /*On fail goto*//*Label 4300*/ GIMT_Encode4(226519), // Rule ID 3585 //
     /* 226477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT_HasSVE2_or_SME2),
     /* 226480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_luti4_lane),
     /* 226485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 226494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226498 */     // MIs[0] Op3
     /* 226498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 226506 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1604:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)  =>  (LUTI4_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$Op3)
     /* 226506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUTI4_ZZZI_H),
     /* 226509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226511 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226515 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226517 */     GIR_RootConstrainSelectedInstOperands,
     /* 226518 */     // GIR_Coverage, 3585,
     /* 226518 */     GIR_EraseRootFromParent_Done,
     /* 226519 */   // Label 4300: @226519
     /* 226519 */   GIM_Try, /*On fail goto*//*Label 4301*/ GIMT_Encode4(226566), // Rule ID 11375 //
     /* 226524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226545 */     // MIs[0] Op3
     /* 226545 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226548 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1803:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_H),
     /* 226556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226564 */     GIR_RootConstrainSelectedInstOperands,
     /* 226565 */     // GIR_Coverage, 11375,
     /* 226565 */     GIR_EraseRootFromParent_Done,
     /* 226566 */   // Label 4301: @226566
     /* 226566 */   GIM_Try, /*On fail goto*//*Label 4302*/ GIMT_Encode4(226613), // Rule ID 11376 //
     /* 226571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226592 */     // MIs[0] Op3
     /* 226592 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226595 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226600 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1803:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226600 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_S),
     /* 226603 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226605 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226607 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226609 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226611 */     GIR_RootConstrainSelectedInstOperands,
     /* 226612 */     // GIR_Coverage, 11376,
     /* 226612 */     GIR_EraseRootFromParent_Done,
     /* 226613 */   // Label 4302: @226613
     /* 226613 */   GIM_Try, /*On fail goto*//*Label 4303*/ GIMT_Encode4(226660), // Rule ID 11377 //
     /* 226618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226621 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmulh_lane),
     /* 226626 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226629 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226632 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226639 */     // MIs[0] Op3
     /* 226639 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226642 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226647 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1803:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULH_ZZZI_D),
     /* 226650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226658 */     GIR_RootConstrainSelectedInstOperands,
     /* 226659 */     // GIR_Coverage, 11377,
     /* 226659 */     GIR_EraseRootFromParent_Done,
     /* 226660 */   // Label 4303: @226660
     /* 226660 */   GIM_Try, /*On fail goto*//*Label 4304*/ GIMT_Encode4(226707), // Rule ID 11378 //
     /* 226665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 226676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226686 */     // MIs[0] Op3
     /* 226686 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226689 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226694 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1834:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_H),
     /* 226697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226705 */     GIR_RootConstrainSelectedInstOperands,
     /* 226706 */     // GIR_Coverage, 11378,
     /* 226706 */     GIR_EraseRootFromParent_Done,
     /* 226707 */   // Label 4304: @226707
     /* 226707 */   GIM_Try, /*On fail goto*//*Label 4305*/ GIMT_Encode4(226754), // Rule ID 11379 //
     /* 226712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226715 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226720 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226723 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226726 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226733 */     // MIs[0] Op3
     /* 226733 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226736 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226741 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1834:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_S),
     /* 226744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226752 */     GIR_RootConstrainSelectedInstOperands,
     /* 226753 */     // GIR_Coverage, 11379,
     /* 226753 */     GIR_EraseRootFromParent_Done,
     /* 226754 */   // Label 4305: @226754
     /* 226754 */   GIM_Try, /*On fail goto*//*Label 4306*/ GIMT_Encode4(226801), // Rule ID 11380 //
     /* 226759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmulh_lane),
     /* 226767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 226773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 226776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226780 */     // MIs[0] Op3
     /* 226780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 226788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1834:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)  =>  (SQRDMULH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op3)
     /* 226788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMULH_ZZZI_D),
     /* 226791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226799 */     GIR_RootConstrainSelectedInstOperands,
     /* 226800 */     // GIR_Coverage, 11380,
     /* 226800 */     GIR_EraseRootFromParent_Done,
     /* 226801 */   // Label 4306: @226801
     /* 226801 */   GIM_Try, /*On fail goto*//*Label 4307*/ GIMT_Encode4(226848), // Rule ID 11403 //
     /* 226806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226809 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226814 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226827 */     // MIs[0] Op3
     /* 226827 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226830 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226835 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1764:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_S),
     /* 226838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226846 */     GIR_RootConstrainSelectedInstOperands,
     /* 226847 */     // GIR_Coverage, 11403,
     /* 226847 */     GIR_EraseRootFromParent_Done,
     /* 226848 */   // Label 4307: @226848
     /* 226848 */   GIM_Try, /*On fail goto*//*Label 4308*/ GIMT_Encode4(226895), // Rule ID 11404 //
     /* 226853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226856 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smullt_lane),
     /* 226861 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226864 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226867 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226874 */     // MIs[0] Op3
     /* 226874 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226877 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226882 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1764:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLT_ZZZI_D),
     /* 226885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226891 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226893 */     GIR_RootConstrainSelectedInstOperands,
     /* 226894 */     // GIR_Coverage, 11404,
     /* 226894 */     GIR_EraseRootFromParent_Done,
     /* 226895 */   // Label 4308: @226895
     /* 226895 */   GIM_Try, /*On fail goto*//*Label 4309*/ GIMT_Encode4(226942), // Rule ID 11405 //
     /* 226900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 226908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 226911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 226914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 226917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226921 */     // MIs[0] Op3
     /* 226921 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226924 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 226929 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2000:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 226929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_S),
     /* 226932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226940 */     GIR_RootConstrainSelectedInstOperands,
     /* 226941 */     // GIR_Coverage, 11405,
     /* 226941 */     GIR_EraseRootFromParent_Done,
     /* 226942 */   // Label 4309: @226942
     /* 226942 */   GIM_Try, /*On fail goto*//*Label 4310*/ GIMT_Encode4(226989), // Rule ID 11406 //
     /* 226947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullb_lane),
     /* 226955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 226958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 226961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 226964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 226968 */     // MIs[0] Op3
     /* 226968 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 226971 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 226976 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2000:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 226976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLB_ZZZI_D),
     /* 226979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 226981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 226983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 226985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 226987 */     GIR_RootConstrainSelectedInstOperands,
     /* 226988 */     // GIR_Coverage, 11406,
     /* 226988 */     GIR_EraseRootFromParent_Done,
     /* 226989 */   // Label 4310: @226989
     /* 226989 */   GIM_Try, /*On fail goto*//*Label 4311*/ GIMT_Encode4(227036), // Rule ID 11407 //
     /* 226994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 226997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227015 */     // MIs[0] Op3
     /* 227015 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227018 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227023 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2002:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_S),
     /* 227026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227034 */     GIR_RootConstrainSelectedInstOperands,
     /* 227035 */     // GIR_Coverage, 11407,
     /* 227035 */     GIR_EraseRootFromParent_Done,
     /* 227036 */   // Label 4311: @227036
     /* 227036 */   GIM_Try, /*On fail goto*//*Label 4312*/ GIMT_Encode4(227083), // Rule ID 11408 //
     /* 227041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umullt_lane),
     /* 227049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227062 */     // MIs[0] Op3
     /* 227062 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227065 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227070 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2002:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (UMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLT_ZZZI_D),
     /* 227073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227079 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227081 */     GIR_RootConstrainSelectedInstOperands,
     /* 227082 */     // GIR_Coverage, 11408,
     /* 227082 */     GIR_EraseRootFromParent_Done,
     /* 227083 */   // Label 4312: @227083
     /* 227083 */   GIM_Try, /*On fail goto*//*Label 4313*/ GIMT_Encode4(227130), // Rule ID 11409 //
     /* 227088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227091 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227096 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227099 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227109 */     // MIs[0] Op3
     /* 227109 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227112 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227117 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1809:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_S),
     /* 227120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227128 */     GIR_RootConstrainSelectedInstOperands,
     /* 227129 */     // GIR_Coverage, 11409,
     /* 227129 */     GIR_EraseRootFromParent_Done,
     /* 227130 */   // Label 4313: @227130
     /* 227130 */   GIM_Try, /*On fail goto*//*Label 4314*/ GIMT_Encode4(227177), // Rule ID 11410 //
     /* 227135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullb_lane),
     /* 227143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227156 */     // MIs[0] Op3
     /* 227156 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227159 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227164 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1809:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLB_ZZZI_D),
     /* 227167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227173 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227175 */     GIR_RootConstrainSelectedInstOperands,
     /* 227176 */     // GIR_Coverage, 11410,
     /* 227176 */     GIR_EraseRootFromParent_Done,
     /* 227177 */   // Label 4314: @227177
     /* 227177 */   GIM_Try, /*On fail goto*//*Label 4315*/ GIMT_Encode4(227224), // Rule ID 11411 //
     /* 227182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227185 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227190 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227193 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227196 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227203 */     // MIs[0] Op3
     /* 227203 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227206 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 227211 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1811:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op3)
     /* 227211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_S),
     /* 227214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227222 */     GIR_RootConstrainSelectedInstOperands,
     /* 227223 */     // GIR_Coverage, 11411,
     /* 227223 */     GIR_EraseRootFromParent_Done,
     /* 227224 */   // Label 4315: @227224
     /* 227224 */   GIM_Try, /*On fail goto*//*Label 4316*/ GIMT_Encode4(227271), // Rule ID 11412 //
     /* 227229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmullt_lane),
     /* 227237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227250 */     // MIs[0] Op3
     /* 227250 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227253 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 227258 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1811:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)  =>  (SQDMULLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op3)
     /* 227258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMULLT_ZZZI_D),
     /* 227261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 227263 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227265 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227267 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227269 */     GIR_RootConstrainSelectedInstOperands,
     /* 227270 */     // GIR_Coverage, 11412,
     /* 227270 */     GIR_EraseRootFromParent_Done,
     /* 227271 */   // Label 4316: @227271
     /* 227271 */   GIM_Try, /*On fail goto*//*Label 4317*/ GIMT_Encode4(227318), // Rule ID 11656 //
     /* 227276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227297 */     // MIs[0] Op3
     /* 227297 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227300 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227305 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1869:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_B),
     /* 227308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227314 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227316 */     GIR_RootConstrainSelectedInstOperands,
     /* 227317 */     // GIR_Coverage, 11656,
     /* 227317 */     GIR_EraseRootFromParent_Done,
     /* 227318 */   // Label 4317: @227318
     /* 227318 */   GIM_Try, /*On fail goto*//*Label 4318*/ GIMT_Encode4(227365), // Rule ID 11657 //
     /* 227323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227326 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227331 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227334 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227337 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227344 */     // MIs[0] Op3
     /* 227344 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227347 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227352 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1869:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_H),
     /* 227355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227359 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227361 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227363 */     GIR_RootConstrainSelectedInstOperands,
     /* 227364 */     // GIR_Coverage, 11657,
     /* 227364 */     GIR_EraseRootFromParent_Done,
     /* 227365 */   // Label 4318: @227365
     /* 227365 */   GIM_Try, /*On fail goto*//*Label 4319*/ GIMT_Encode4(227412), // Rule ID 11658 //
     /* 227370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227391 */     // MIs[0] Op3
     /* 227391 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227394 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227399 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1869:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_S),
     /* 227402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227410 */     GIR_RootConstrainSelectedInstOperands,
     /* 227411 */     // GIR_Coverage, 11658,
     /* 227411 */     GIR_EraseRootFromParent_Done,
     /* 227412 */   // Label 4319: @227412
     /* 227412 */   GIM_Try, /*On fail goto*//*Label 4320*/ GIMT_Encode4(227459), // Rule ID 11659 //
     /* 227417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshr),
     /* 227425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227438 */     // MIs[0] Op3
     /* 227438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227446 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1869:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHR_ZPmI_D),
     /* 227449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227451 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227455 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227457 */     GIR_RootConstrainSelectedInstOperands,
     /* 227458 */     // GIR_Coverage, 11659,
     /* 227458 */     GIR_EraseRootFromParent_Done,
     /* 227459 */   // Label 4320: @227459
     /* 227459 */   GIM_Try, /*On fail goto*//*Label 4321*/ GIMT_Encode4(227506), // Rule ID 11660 //
     /* 227464 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227467 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227472 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227475 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227478 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227485 */     // MIs[0] Op3
     /* 227485 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227488 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227493 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2060:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSHR_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_B),
     /* 227496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227504 */     GIR_RootConstrainSelectedInstOperands,
     /* 227505 */     // GIR_Coverage, 11660,
     /* 227505 */     GIR_EraseRootFromParent_Done,
     /* 227506 */   // Label 4321: @227506
     /* 227506 */   GIM_Try, /*On fail goto*//*Label 4322*/ GIMT_Encode4(227553), // Rule ID 11662 //
     /* 227511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227532 */     // MIs[0] Op3
     /* 227532 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227535 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227540 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2060:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSHR_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_H),
     /* 227543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227545 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227547 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227549 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227551 */     GIR_RootConstrainSelectedInstOperands,
     /* 227552 */     // GIR_Coverage, 11662,
     /* 227552 */     GIR_EraseRootFromParent_Done,
     /* 227553 */   // Label 4322: @227553
     /* 227553 */   GIM_Try, /*On fail goto*//*Label 4323*/ GIMT_Encode4(227600), // Rule ID 11664 //
     /* 227558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227561 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227566 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227569 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227572 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227579 */     // MIs[0] Op3
     /* 227579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2060:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSHR_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_S),
     /* 227590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227598 */     GIR_RootConstrainSelectedInstOperands,
     /* 227599 */     // GIR_Coverage, 11664,
     /* 227599 */     GIR_EraseRootFromParent_Done,
     /* 227600 */   // Label 4323: @227600
     /* 227600 */   GIM_Try, /*On fail goto*//*Label 4324*/ GIMT_Encode4(227647), // Rule ID 11666 //
     /* 227605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshr),
     /* 227613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227626 */     // MIs[0] Op3
     /* 227626 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227629 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 227634 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2060:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSHR_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 227634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHR_ZPmI_D),
     /* 227637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227645 */     GIR_RootConstrainSelectedInstOperands,
     /* 227646 */     // GIR_Coverage, 11666,
     /* 227646 */     GIR_EraseRootFromParent_Done,
     /* 227647 */   // Label 4324: @227647
     /* 227647 */   GIM_Try, /*On fail goto*//*Label 4325*/ GIMT_Encode4(227694), // Rule ID 11668 //
     /* 227652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 227666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227669 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227673 */     // MIs[0] Op3
     /* 227673 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227676 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL8),
     /* 227681 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1849:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)  =>  (SQSHLU_ZPmI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL8>>:$Op3)
     /* 227681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_B),
     /* 227684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227686 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227688 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227690 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227692 */     GIR_RootConstrainSelectedInstOperands,
     /* 227693 */     // GIR_Coverage, 11668,
     /* 227693 */     GIR_EraseRootFromParent_Done,
     /* 227694 */   // Label 4325: @227694
     /* 227694 */   GIM_Try, /*On fail goto*//*Label 4326*/ GIMT_Encode4(227741), // Rule ID 11669 //
     /* 227699 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227702 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227707 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227710 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 227713 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227716 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227720 */     // MIs[0] Op3
     /* 227720 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227723 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL16),
     /* 227728 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1849:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)  =>  (SQSHLU_ZPmI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL16>>:$Op3)
     /* 227728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_H),
     /* 227731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227733 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227737 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227739 */     GIR_RootConstrainSelectedInstOperands,
     /* 227740 */     // GIR_Coverage, 11669,
     /* 227740 */     GIR_EraseRootFromParent_Done,
     /* 227741 */   // Label 4326: @227741
     /* 227741 */   GIM_Try, /*On fail goto*//*Label 4327*/ GIMT_Encode4(227788), // Rule ID 11670 //
     /* 227746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227749 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227754 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 227760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227767 */     // MIs[0] Op3
     /* 227767 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227770 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL32),
     /* 227775 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1849:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)  =>  (SQSHLU_ZPmI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL32>>:$Op3)
     /* 227775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_S),
     /* 227778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227786 */     GIR_RootConstrainSelectedInstOperands,
     /* 227787 */     // GIR_Coverage, 11670,
     /* 227787 */     GIR_EraseRootFromParent_Done,
     /* 227788 */   // Label 4327: @227788
     /* 227788 */   GIM_Try, /*On fail goto*//*Label 4328*/ GIMT_Encode4(227835), // Rule ID 11671 //
     /* 227793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshlu),
     /* 227801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 227807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227814 */     // MIs[0] Op3
     /* 227814 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227817 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftL64),
     /* 227822 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1849:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)  =>  (SQSHLU_ZPmI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftL64>>:$Op3)
     /* 227822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHLU_ZPmI_D),
     /* 227825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 227827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227831 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227833 */     GIR_RootConstrainSelectedInstOperands,
     /* 227834 */     // GIR_Coverage, 11671,
     /* 227834 */     GIR_EraseRootFromParent_Done,
     /* 227835 */   // Label 4328: @227835
     /* 227835 */   GIM_Try, /*On fail goto*//*Label 4329*/ GIMT_Encode4(227882), // Rule ID 11758 //
     /* 227840 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227843 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227848 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 227851 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 227854 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 227857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227861 */     // MIs[0] Op3
     /* 227861 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227864 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 227869 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2069:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (USRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 227869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_B),
     /* 227872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227876 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227878 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227880 */     GIR_RootConstrainSelectedInstOperands,
     /* 227881 */     // GIR_Coverage, 11758,
     /* 227881 */     GIR_EraseRootFromParent_Done,
     /* 227882 */   // Label 4329: @227882
     /* 227882 */   GIM_Try, /*On fail goto*//*Label 4330*/ GIMT_Encode4(227929), // Rule ID 11760 //
     /* 227887 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227890 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227895 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 227898 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 227901 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 227904 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227908 */     // MIs[0] Op3
     /* 227908 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227911 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 227916 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2069:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (USRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 227916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_H),
     /* 227919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227923 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227925 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227927 */     GIR_RootConstrainSelectedInstOperands,
     /* 227928 */     // GIR_Coverage, 11760,
     /* 227928 */     GIR_EraseRootFromParent_Done,
     /* 227929 */   // Label 4330: @227929
     /* 227929 */   GIM_Try, /*On fail goto*//*Label 4331*/ GIMT_Encode4(227976), // Rule ID 11762 //
     /* 227934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227937 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227942 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 227945 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 227948 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 227951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 227955 */     // MIs[0] Op3
     /* 227955 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 227958 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 227963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2069:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (USRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 227963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_S),
     /* 227966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 227968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 227970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 227972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 227974 */     GIR_RootConstrainSelectedInstOperands,
     /* 227975 */     // GIR_Coverage, 11762,
     /* 227975 */     GIR_EraseRootFromParent_Done,
     /* 227976 */   // Label 4331: @227976
     /* 227976 */   GIM_Try, /*On fail goto*//*Label 4332*/ GIMT_Encode4(228023), // Rule ID 11764 //
     /* 227981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 227984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usra),
     /* 227989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 227992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 227995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 227998 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228002 */     // MIs[0] Op3
     /* 228002 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228005 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228010 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2069:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (USRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USRA_ZZI_D),
     /* 228013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228015 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228017 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228019 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228021 */     GIR_RootConstrainSelectedInstOperands,
     /* 228022 */     // GIR_Coverage, 11764,
     /* 228022 */     GIR_EraseRootFromParent_Done,
     /* 228023 */   // Label 4332: @228023
     /* 228023 */   GIM_Try, /*On fail goto*//*Label 4333*/ GIMT_Encode4(228070), // Rule ID 11766 //
     /* 228028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228031 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228036 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228039 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228049 */     // MIs[0] Op3
     /* 228049 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228052 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1870:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SRSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_B),
     /* 228060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228068 */     GIR_RootConstrainSelectedInstOperands,
     /* 228069 */     // GIR_Coverage, 11766,
     /* 228069 */     GIR_EraseRootFromParent_Done,
     /* 228070 */   // Label 4333: @228070
     /* 228070 */   GIM_Try, /*On fail goto*//*Label 4334*/ GIMT_Encode4(228117), // Rule ID 11767 //
     /* 228075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228092 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228096 */     // MIs[0] Op3
     /* 228096 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228099 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228104 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1870:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SRSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_H),
     /* 228107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228111 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228113 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228115 */     GIR_RootConstrainSelectedInstOperands,
     /* 228116 */     // GIR_Coverage, 11767,
     /* 228116 */     GIR_EraseRootFromParent_Done,
     /* 228117 */   // Label 4334: @228117
     /* 228117 */   GIM_Try, /*On fail goto*//*Label 4335*/ GIMT_Encode4(228164), // Rule ID 11768 //
     /* 228122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228125 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228130 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228133 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228136 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228143 */     // MIs[0] Op3
     /* 228143 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228146 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228151 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1870:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SRSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_S),
     /* 228154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228162 */     GIR_RootConstrainSelectedInstOperands,
     /* 228163 */     // GIR_Coverage, 11768,
     /* 228163 */     GIR_EraseRootFromParent_Done,
     /* 228164 */   // Label 4335: @228164
     /* 228164 */   GIM_Try, /*On fail goto*//*Label 4336*/ GIMT_Encode4(228211), // Rule ID 11769 //
     /* 228169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srsra),
     /* 228177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228186 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228190 */     // MIs[0] Op3
     /* 228190 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228193 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228198 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1870:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (SRSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228198 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSRA_ZZI_D),
     /* 228201 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228203 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228207 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228209 */     GIR_RootConstrainSelectedInstOperands,
     /* 228210 */     // GIR_Coverage, 11769,
     /* 228210 */     GIR_EraseRootFromParent_Done,
     /* 228211 */   // Label 4336: @228211
     /* 228211 */   GIM_Try, /*On fail goto*//*Label 4337*/ GIMT_Encode4(228258), // Rule ID 11774 //
     /* 228216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228224 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228227 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228230 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 228233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228237 */     // MIs[0] Op3
     /* 228237 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228240 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228245 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2062:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (URSRA_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_B),
     /* 228248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228256 */     GIR_RootConstrainSelectedInstOperands,
     /* 228257 */     // GIR_Coverage, 11774,
     /* 228257 */     GIR_EraseRootFromParent_Done,
     /* 228258 */   // Label 4337: @228258
     /* 228258 */   GIM_Try, /*On fail goto*//*Label 4338*/ GIMT_Encode4(228305), // Rule ID 11775 //
     /* 228263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228280 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228284 */     // MIs[0] Op3
     /* 228284 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228287 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228292 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2062:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (URSRA_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228292 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_H),
     /* 228295 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228301 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228303 */     GIR_RootConstrainSelectedInstOperands,
     /* 228304 */     // GIR_Coverage, 11775,
     /* 228304 */     GIR_EraseRootFromParent_Done,
     /* 228305 */   // Label 4338: @228305
     /* 228305 */   GIM_Try, /*On fail goto*//*Label 4339*/ GIMT_Encode4(228352), // Rule ID 11776 //
     /* 228310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228313 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228318 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228331 */     // MIs[0] Op3
     /* 228331 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228334 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228339 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2062:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (URSRA_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_S),
     /* 228342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228346 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228348 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228350 */     GIR_RootConstrainSelectedInstOperands,
     /* 228351 */     // GIR_Coverage, 11776,
     /* 228351 */     GIR_EraseRootFromParent_Done,
     /* 228352 */   // Label 4339: @228352
     /* 228352 */   GIM_Try, /*On fail goto*//*Label 4340*/ GIMT_Encode4(228399), // Rule ID 11777 //
     /* 228357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228360 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursra),
     /* 228365 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 228368 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 228371 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228374 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228378 */     // MIs[0] Op3
     /* 228378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR64),
     /* 228386 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2062:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)  =>  (URSRA_ZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR64>>:$Op3)
     /* 228386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSRA_ZZI_D),
     /* 228389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 228391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228393 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228395 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228397 */     GIR_RootConstrainSelectedInstOperands,
     /* 228398 */     // GIR_Coverage, 11777,
     /* 228398 */     GIR_EraseRootFromParent_Done,
     /* 228399 */   // Label 4340: @228399
     /* 228399 */   GIM_Try, /*On fail goto*//*Label 4341*/ GIMT_Encode4(228446), // Rule ID 11837 //
     /* 228404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228425 */     // MIs[0] Op3
     /* 228425 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228428 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228433 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1847:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRUNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_B),
     /* 228436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228444 */     GIR_RootConstrainSelectedInstOperands,
     /* 228445 */     // GIR_Coverage, 11837,
     /* 228445 */     GIR_EraseRootFromParent_Done,
     /* 228446 */   // Label 4341: @228446
     /* 228446 */   GIM_Try, /*On fail goto*//*Label 4342*/ GIMT_Encode4(228493), // Rule ID 11838 //
     /* 228451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228468 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228472 */     // MIs[0] Op3
     /* 228472 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228475 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228480 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1847:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRUNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228480 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_H),
     /* 228483 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228489 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228491 */     GIR_RootConstrainSelectedInstOperands,
     /* 228492 */     // GIR_Coverage, 11838,
     /* 228492 */     GIR_EraseRootFromParent_Done,
     /* 228493 */   // Label 4342: @228493
     /* 228493 */   GIM_Try, /*On fail goto*//*Label 4343*/ GIMT_Encode4(228540), // Rule ID 11839 //
     /* 228498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228501 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrunt),
     /* 228506 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228519 */     // MIs[0] Op3
     /* 228519 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228522 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228527 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1847:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRUNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRUNT_ZZI_S),
     /* 228530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228538 */     GIR_RootConstrainSelectedInstOperands,
     /* 228539 */     // GIR_Coverage, 11839,
     /* 228539 */     GIR_EraseRootFromParent_Done,
     /* 228540 */   // Label 4343: @228540
     /* 228540 */   GIM_Try, /*On fail goto*//*Label 4344*/ GIMT_Encode4(228587), // Rule ID 11840 //
     /* 228545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228562 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228566 */     // MIs[0] Op3
     /* 228566 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228569 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228574 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1726:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_B),
     /* 228577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228585 */     GIR_RootConstrainSelectedInstOperands,
     /* 228586 */     // GIR_Coverage, 11840,
     /* 228586 */     GIR_EraseRootFromParent_Done,
     /* 228587 */   // Label 4344: @228587
     /* 228587 */   GIM_Try, /*On fail goto*//*Label 4345*/ GIMT_Encode4(228634), // Rule ID 11841 //
     /* 228592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228613 */     // MIs[0] Op3
     /* 228613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1726:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_H),
     /* 228624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228632 */     GIR_RootConstrainSelectedInstOperands,
     /* 228633 */     // GIR_Coverage, 11841,
     /* 228633 */     GIR_EraseRootFromParent_Done,
     /* 228634 */   // Label 4345: @228634
     /* 228634 */   GIM_Try, /*On fail goto*//*Label 4346*/ GIMT_Encode4(228681), // Rule ID 11842 //
     /* 228639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shrnt),
     /* 228647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228656 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228660 */     // MIs[0] Op3
     /* 228660 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228663 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228668 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1726:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNT_ZZI_S),
     /* 228671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228673 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228675 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228677 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228679 */     GIR_RootConstrainSelectedInstOperands,
     /* 228680 */     // GIR_Coverage, 11842,
     /* 228680 */     GIR_EraseRootFromParent_Done,
     /* 228681 */   // Label 4346: @228681
     /* 228681 */   GIM_Try, /*On fail goto*//*Label 4347*/ GIMT_Encode4(228728), // Rule ID 11843 //
     /* 228686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228707 */     // MIs[0] Op3
     /* 228707 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228710 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228715 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1684:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (RSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_B),
     /* 228718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228720 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228722 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228724 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228726 */     GIR_RootConstrainSelectedInstOperands,
     /* 228727 */     // GIR_Coverage, 11843,
     /* 228727 */     GIR_EraseRootFromParent_Done,
     /* 228728 */   // Label 4347: @228728
     /* 228728 */   GIM_Try, /*On fail goto*//*Label 4348*/ GIMT_Encode4(228775), // Rule ID 11844 //
     /* 228733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228741 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228744 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228747 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228750 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228754 */     // MIs[0] Op3
     /* 228754 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228757 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228762 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1684:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (RSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228762 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_H),
     /* 228765 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228767 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228771 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228773 */     GIR_RootConstrainSelectedInstOperands,
     /* 228774 */     // GIR_Coverage, 11844,
     /* 228774 */     GIR_EraseRootFromParent_Done,
     /* 228775 */   // Label 4348: @228775
     /* 228775 */   GIM_Try, /*On fail goto*//*Label 4349*/ GIMT_Encode4(228822), // Rule ID 11845 //
     /* 228780 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228783 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rshrnt),
     /* 228788 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228791 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228794 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228797 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228801 */     // MIs[0] Op3
     /* 228801 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228804 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228809 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1684:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (RSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSHRNT_ZZI_S),
     /* 228812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228820 */     GIR_RootConstrainSelectedInstOperands,
     /* 228821 */     // GIR_Coverage, 11845,
     /* 228821 */     GIR_EraseRootFromParent_Done,
     /* 228822 */   // Label 4349: @228822
     /* 228822 */   GIM_Try, /*On fail goto*//*Label 4350*/ GIMT_Encode4(228869), // Rule ID 11846 //
     /* 228827 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228830 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228835 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228838 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228841 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228844 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228848 */     // MIs[0] Op3
     /* 228848 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228851 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228856 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1851:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_B),
     /* 228859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228861 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228863 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228865 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228867 */     GIR_RootConstrainSelectedInstOperands,
     /* 228868 */     // GIR_Coverage, 11846,
     /* 228868 */     GIR_EraseRootFromParent_Done,
     /* 228869 */   // Label 4350: @228869
     /* 228869 */   GIM_Try, /*On fail goto*//*Label 4351*/ GIMT_Encode4(228916), // Rule ID 11847 //
     /* 228874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 228885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 228888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 228891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228895 */     // MIs[0] Op3
     /* 228895 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228898 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 228903 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1851:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 228903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_H),
     /* 228906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228914 */     GIR_RootConstrainSelectedInstOperands,
     /* 228915 */     // GIR_Coverage, 11847,
     /* 228915 */     GIR_EraseRootFromParent_Done,
     /* 228916 */   // Label 4351: @228916
     /* 228916 */   GIM_Try, /*On fail goto*//*Label 4352*/ GIMT_Encode4(228963), // Rule ID 11848 //
     /* 228921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshrnt),
     /* 228929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 228932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 228935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 228938 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228942 */     // MIs[0] Op3
     /* 228942 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228945 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 228950 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1851:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 228950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHRNT_ZZI_S),
     /* 228953 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 228955 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 228957 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 228959 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 228961 */     GIR_RootConstrainSelectedInstOperands,
     /* 228962 */     // GIR_Coverage, 11848,
     /* 228962 */     GIR_EraseRootFromParent_Done,
     /* 228963 */   // Label 4352: @228963
     /* 228963 */   GIM_Try, /*On fail goto*//*Label 4353*/ GIMT_Encode4(229010), // Rule ID 11849 //
     /* 228968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 228971 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 228976 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 228979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 228982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 228985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 228989 */     // MIs[0] Op3
     /* 228989 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 228992 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 228997 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1841:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (SQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 228997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_B),
     /* 229000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229008 */     GIR_RootConstrainSelectedInstOperands,
     /* 229009 */     // GIR_Coverage, 11849,
     /* 229009 */     GIR_EraseRootFromParent_Done,
     /* 229010 */   // Label 4353: @229010
     /* 229010 */   GIM_Try, /*On fail goto*//*Label 4354*/ GIMT_Encode4(229057), // Rule ID 11850 //
     /* 229015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229032 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229036 */     // MIs[0] Op3
     /* 229036 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229039 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229044 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1841:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (SQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_H),
     /* 229047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229049 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229053 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229055 */     GIR_RootConstrainSelectedInstOperands,
     /* 229056 */     // GIR_Coverage, 11850,
     /* 229056 */     GIR_EraseRootFromParent_Done,
     /* 229057 */   // Label 4354: @229057
     /* 229057 */   GIM_Try, /*On fail goto*//*Label 4355*/ GIMT_Encode4(229104), // Rule ID 11851 //
     /* 229062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229065 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshrnt),
     /* 229070 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229073 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229076 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229083 */     // MIs[0] Op3
     /* 229083 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229086 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1841:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (SQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHRNT_ZZI_S),
     /* 229094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229102 */     GIR_RootConstrainSelectedInstOperands,
     /* 229103 */     // GIR_Coverage, 11851,
     /* 229103 */     GIR_EraseRootFromParent_Done,
     /* 229104 */   // Label 4355: @229104
     /* 229104 */   GIM_Try, /*On fail goto*//*Label 4356*/ GIMT_Encode4(229151), // Rule ID 11852 //
     /* 229109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229130 */     // MIs[0] Op3
     /* 229130 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229133 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229138 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2046:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_B),
     /* 229141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229149 */     GIR_RootConstrainSelectedInstOperands,
     /* 229150 */     // GIR_Coverage, 11852,
     /* 229150 */     GIR_EraseRootFromParent_Done,
     /* 229151 */   // Label 4356: @229151
     /* 229151 */   GIM_Try, /*On fail goto*//*Label 4357*/ GIMT_Encode4(229198), // Rule ID 11853 //
     /* 229156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229159 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229164 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229167 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229170 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229173 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229177 */     // MIs[0] Op3
     /* 229177 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229180 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229185 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2046:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_H),
     /* 229188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229196 */     GIR_RootConstrainSelectedInstOperands,
     /* 229197 */     // GIR_Coverage, 11853,
     /* 229197 */     GIR_EraseRootFromParent_Done,
     /* 229198 */   // Label 4357: @229198
     /* 229198 */   GIM_Try, /*On fail goto*//*Label 4358*/ GIMT_Encode4(229245), // Rule ID 11854 //
     /* 229203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshrnt),
     /* 229211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229224 */     // MIs[0] Op3
     /* 229224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229232 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2046:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHRNT_ZZI_S),
     /* 229235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229243 */     GIR_RootConstrainSelectedInstOperands,
     /* 229244 */     // GIR_Coverage, 11854,
     /* 229244 */     GIR_EraseRootFromParent_Done,
     /* 229245 */   // Label 4358: @229245
     /* 229245 */   GIM_Try, /*On fail goto*//*Label 4359*/ GIMT_Encode4(229292), // Rule ID 11855 //
     /* 229250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229253 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229258 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229261 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229264 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 229267 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229271 */     // MIs[0] Op3
     /* 229271 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229274 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR8),
     /* 229279 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2043:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)  =>  (UQRSHRNT_ZZI_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR8>>:$Op3)
     /* 229279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_B),
     /* 229282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229290 */     GIR_RootConstrainSelectedInstOperands,
     /* 229291 */     // GIR_Coverage, 11855,
     /* 229291 */     GIR_EraseRootFromParent_Done,
     /* 229292 */   // Label 4359: @229292
     /* 229292 */   GIM_Try, /*On fail goto*//*Label 4360*/ GIMT_Encode4(229339), // Rule ID 11856 //
     /* 229297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 229314 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229318 */     // MIs[0] Op3
     /* 229318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR16),
     /* 229326 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2043:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)  =>  (UQRSHRNT_ZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR16>>:$Op3)
     /* 229326 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_H),
     /* 229329 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229331 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229333 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229335 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229337 */     GIR_RootConstrainSelectedInstOperands,
     /* 229338 */     // GIR_Coverage, 11856,
     /* 229338 */     GIR_EraseRootFromParent_Done,
     /* 229339 */   // Label 4360: @229339
     /* 229339 */   GIM_Try, /*On fail goto*//*Label 4361*/ GIMT_Encode4(229386), // Rule ID 11857 //
     /* 229344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229347 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshrnt),
     /* 229352 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229355 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229358 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 229361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229365 */     // MIs[0] Op3
     /* 229365 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 229368 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_tvecshiftR32),
     /* 229373 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2043:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)  =>  (UQRSHRNT_ZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, (timm:{ *:[i32] })<<P:Predicate_tvecshiftR32>>:$Op3)
     /* 229373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHRNT_ZZI_S),
     /* 229376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229378 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 229380 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 229382 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 229384 */     GIR_RootConstrainSelectedInstOperands,
     /* 229385 */     // GIR_Coverage, 11857,
     /* 229385 */     GIR_EraseRootFromParent_Done,
     /* 229386 */   // Label 4361: @229386
     /* 229386 */   GIM_Try, /*On fail goto*//*Label 4362*/ GIMT_Encode4(229453), // Rule ID 2600 //
     /* 229391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 229394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 229399 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229408 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229411 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229423 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229425 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URECPE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229425 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229428 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229432 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229437 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S_UNDEF),
     /* 229442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229449 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229451 */     GIR_RootConstrainSelectedInstOperands,
     /* 229452 */     // GIR_Coverage, 2600,
     /* 229452 */     GIR_EraseRootFromParent_Done,
     /* 229453 */   // Label 4362: @229453
     /* 229453 */   GIM_Try, /*On fail goto*//*Label 4363*/ GIMT_Encode4(229520), // Rule ID 7756 //
     /* 229458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229478 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229490 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229492 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B_UNDEF),
     /* 229509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229516 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229518 */     GIR_RootConstrainSelectedInstOperands,
     /* 229519 */     // GIR_Coverage, 7756,
     /* 229519 */     GIR_EraseRootFromParent_Done,
     /* 229520 */   // Label 4363: @229520
     /* 229520 */   GIM_Try, /*On fail goto*//*Label 4364*/ GIMT_Encode4(229587), // Rule ID 7758 //
     /* 229525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229528 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229533 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229536 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229539 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229542 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229559 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H_UNDEF),
     /* 229576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229578 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229585 */     GIR_RootConstrainSelectedInstOperands,
     /* 229586 */     // GIR_Coverage, 7758,
     /* 229586 */     GIR_EraseRootFromParent_Done,
     /* 229587 */   // Label 4364: @229587
     /* 229587 */   GIM_Try, /*On fail goto*//*Label 4365*/ GIMT_Encode4(229654), // Rule ID 7760 //
     /* 229592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229595 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229600 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229609 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229626 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229626 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229629 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229633 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229638 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S_UNDEF),
     /* 229643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229645 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229652 */     GIR_RootConstrainSelectedInstOperands,
     /* 229653 */     // GIR_Coverage, 7760,
     /* 229653 */     GIR_EraseRootFromParent_Done,
     /* 229654 */   // Label 4365: @229654
     /* 229654 */   GIM_Try, /*On fail goto*//*Label 4366*/ GIMT_Encode4(229721), // Rule ID 7762 //
     /* 229659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 229667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229693 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229693 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229696 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229700 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229705 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D_UNDEF),
     /* 229710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229712 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229715 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229717 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229719 */     GIR_RootConstrainSelectedInstOperands,
     /* 229720 */     // GIR_Coverage, 7762,
     /* 229720 */     GIR_EraseRootFromParent_Done,
     /* 229721 */   // Label 4366: @229721
     /* 229721 */   GIM_Try, /*On fail goto*//*Label 4367*/ GIMT_Encode4(229788), // Rule ID 7792 //
     /* 229726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229729 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229734 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 229737 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 229740 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 229743 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 229746 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229760 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 229760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B_UNDEF),
     /* 229777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229784 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229786 */     GIR_RootConstrainSelectedInstOperands,
     /* 229787 */     // GIR_Coverage, 7792,
     /* 229787 */     GIR_EraseRootFromParent_Done,
     /* 229788 */   // Label 4367: @229788
     /* 229788 */   GIM_Try, /*On fail goto*//*Label 4368*/ GIMT_Encode4(229855), // Rule ID 7794 //
     /* 229793 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 229804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 229807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 229810 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 229813 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229825 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229827 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 229827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229839 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H_UNDEF),
     /* 229844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229846 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229851 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229853 */     GIR_RootConstrainSelectedInstOperands,
     /* 229854 */     // GIR_Coverage, 7794,
     /* 229854 */     GIR_EraseRootFromParent_Done,
     /* 229855 */   // Label 4368: @229855
     /* 229855 */   GIM_Try, /*On fail goto*//*Label 4369*/ GIMT_Encode4(229922), // Rule ID 7796 //
     /* 229860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 229871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 229874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 229877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 229880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229884 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229888 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229894 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 229894 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229897 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229901 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229906 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S_UNDEF),
     /* 229911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229920 */     GIR_RootConstrainSelectedInstOperands,
     /* 229921 */     // GIR_Coverage, 7796,
     /* 229921 */     GIR_EraseRootFromParent_Done,
     /* 229922 */   // Label 4369: @229922
     /* 229922 */   GIM_Try, /*On fail goto*//*Label 4370*/ GIMT_Encode4(229989), // Rule ID 7798 //
     /* 229927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 229935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 229938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 229941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 229944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 229947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 229951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 229955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 229959 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 229961 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 229961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 229964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 229968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 229973 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 229975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D_UNDEF),
     /* 229978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 229980 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 229983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 229985 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 229987 */     GIR_RootConstrainSelectedInstOperands,
     /* 229988 */     // GIR_Coverage, 7798,
     /* 229988 */     GIR_EraseRootFromParent_Done,
     /* 229989 */   // Label 4370: @229989
     /* 229989 */   GIM_Try, /*On fail goto*//*Label 4371*/ GIMT_Encode4(230056), // Rule ID 7804 //
     /* 229994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 229997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230008 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230011 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230014 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230026 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230028 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B_UNDEF),
     /* 230045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230047 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230054 */     GIR_RootConstrainSelectedInstOperands,
     /* 230055 */     // GIR_Coverage, 7804,
     /* 230055 */     GIR_EraseRootFromParent_Done,
     /* 230056 */   // Label 4371: @230056
     /* 230056 */   GIM_Try, /*On fail goto*//*Label 4372*/ GIMT_Encode4(230123), // Rule ID 7806 //
     /* 230061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230093 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230095 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230107 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H_UNDEF),
     /* 230112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230114 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230117 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230119 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230121 */     GIR_RootConstrainSelectedInstOperands,
     /* 230122 */     // GIR_Coverage, 7806,
     /* 230122 */     GIR_EraseRootFromParent_Done,
     /* 230123 */   // Label 4372: @230123
     /* 230123 */   GIM_Try, /*On fail goto*//*Label 4373*/ GIMT_Encode4(230190), // Rule ID 7808 //
     /* 230128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230131 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230136 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230139 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230142 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230145 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230162 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230162 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230165 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230169 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230174 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S_UNDEF),
     /* 230179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230181 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230188 */     GIR_RootConstrainSelectedInstOperands,
     /* 230189 */     // GIR_Coverage, 7808,
     /* 230189 */     GIR_EraseRootFromParent_Done,
     /* 230190 */   // Label 4373: @230190
     /* 230190 */   GIM_Try, /*On fail goto*//*Label 4374*/ GIMT_Encode4(230257), // Rule ID 7810 //
     /* 230195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 230198 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 230203 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230206 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230209 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230212 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230215 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230229 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230229 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230232 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230236 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230241 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D_UNDEF),
     /* 230246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230255 */     GIR_RootConstrainSelectedInstOperands,
     /* 230256 */     // GIR_Coverage, 7810,
     /* 230256 */     GIR_EraseRootFromParent_Done,
     /* 230257 */   // Label 4374: @230257
     /* 230257 */   GIM_Try, /*On fail goto*//*Label 4375*/ GIMT_Encode4(230324), // Rule ID 11538 //
     /* 230262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 230270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230276 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230279 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230282 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230294 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230296 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (URSQRTE_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S_UNDEF),
     /* 230313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230322 */     GIR_RootConstrainSelectedInstOperands,
     /* 230323 */     // GIR_Coverage, 11538,
     /* 230323 */     GIR_EraseRootFromParent_Done,
     /* 230324 */   // Label 4375: @230324
     /* 230324 */   GIM_Try, /*On fail goto*//*Label 4376*/ GIMT_Encode4(230391), // Rule ID 11540 //
     /* 230329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230363 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQABS_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B_UNDEF),
     /* 230380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230382 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230385 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230387 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230389 */     GIR_RootConstrainSelectedInstOperands,
     /* 230390 */     // GIR_Coverage, 11540,
     /* 230390 */     GIR_EraseRootFromParent_Done,
     /* 230391 */   // Label 4376: @230391
     /* 230391 */   GIM_Try, /*On fail goto*//*Label 4377*/ GIMT_Encode4(230458), // Rule ID 11542 //
     /* 230396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230399 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230404 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230407 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230410 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230413 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230416 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230420 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230424 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230428 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230430 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQABS_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230430 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230433 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230437 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230442 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230444 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H_UNDEF),
     /* 230447 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230449 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230456 */     GIR_RootConstrainSelectedInstOperands,
     /* 230457 */     // GIR_Coverage, 11542,
     /* 230457 */     GIR_EraseRootFromParent_Done,
     /* 230458 */   // Label 4377: @230458
     /* 230458 */   GIM_Try, /*On fail goto*//*Label 4378*/ GIMT_Encode4(230525), // Rule ID 11544 //
     /* 230463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230495 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230497 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQABS_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230497 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230500 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230504 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230509 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S_UNDEF),
     /* 230514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230516 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230519 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230521 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230523 */     GIR_RootConstrainSelectedInstOperands,
     /* 230524 */     // GIR_Coverage, 11544,
     /* 230524 */     GIR_EraseRootFromParent_Done,
     /* 230525 */   // Label 4378: @230525
     /* 230525 */   GIM_Try, /*On fail goto*//*Label 4379*/ GIMT_Encode4(230592), // Rule ID 11546 //
     /* 230530 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230533 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 230538 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230541 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230544 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230547 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230550 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230554 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230558 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230562 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230564 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQABS_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230564 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230567 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230571 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230576 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D_UNDEF),
     /* 230581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230583 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230590 */     GIR_RootConstrainSelectedInstOperands,
     /* 230591 */     // GIR_Coverage, 11546,
     /* 230591 */     GIR_EraseRootFromParent_Done,
     /* 230592 */   // Label 4379: @230592
     /* 230592 */   GIM_Try, /*On fail goto*//*Label 4380*/ GIMT_Encode4(230659), // Rule ID 11552 //
     /* 230597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 230608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 230611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 230614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 230617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230629 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230631 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv16i8] }), nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQNEG_ZPmZ_B_UNDEF:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 230631 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230634 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230638 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230643 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B_UNDEF),
     /* 230648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230650 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230653 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230655 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230657 */     GIR_RootConstrainSelectedInstOperands,
     /* 230658 */     // GIR_Coverage, 11552,
     /* 230658 */     GIR_EraseRootFromParent_Done,
     /* 230659 */   // Label 4380: @230659
     /* 230659 */   GIM_Try, /*On fail goto*//*Label 4381*/ GIMT_Encode4(230726), // Rule ID 11554 //
     /* 230664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230667 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230672 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 230675 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 230678 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 230681 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 230684 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230688 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230692 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230696 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230698 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv8i16] }), nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQNEG_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 230698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H_UNDEF),
     /* 230715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230724 */     GIR_RootConstrainSelectedInstOperands,
     /* 230725 */     // GIR_Coverage, 11554,
     /* 230725 */     GIR_EraseRootFromParent_Done,
     /* 230726 */   // Label 4381: @230726
     /* 230726 */   GIM_Try, /*On fail goto*//*Label 4382*/ GIMT_Encode4(230793), // Rule ID 11556 //
     /* 230731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 230742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 230745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 230748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 230751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230765 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv4i32] }), nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQNEG_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 230765 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230768 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230772 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230777 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S_UNDEF),
     /* 230782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230784 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230791 */     GIR_RootConstrainSelectedInstOperands,
     /* 230792 */     // GIR_Coverage, 11556,
     /* 230792 */     GIR_EraseRootFromParent_Done,
     /* 230793 */   // Label 4382: @230793
     /* 230793 */   GIM_Try, /*On fail goto*//*Label 4383*/ GIMT_Encode4(230860), // Rule ID 11558 //
     /* 230798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 230801 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 230806 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 230809 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 230812 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 230815 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 230818 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 230822 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 230826 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 230830 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 230832 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, (undef:{ *:[nxv2i64] }), nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQNEG_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 230832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 230835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 230839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 230844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 230846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D_UNDEF),
     /* 230849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 230851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 230854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 230856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 230858 */     GIR_RootConstrainSelectedInstOperands,
     /* 230859 */     // GIR_Coverage, 11558,
     /* 230859 */     GIR_EraseRootFromParent_Done,
     /* 230860 */   // Label 4383: @230860
     /* 230860 */   GIM_Try, /*On fail goto*//*Label 4384*/ GIMT_Encode4(230914), // Rule ID 30 //
     /* 230865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 230868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smmla),
     /* 230873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 230882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 230885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230889 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230893 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230897 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230901 */     // (intrinsic_wo_chain:{ *:[v4i32] } 683:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 230901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA),
     /* 230904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230906 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230908 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230910 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230912 */     GIR_RootConstrainSelectedInstOperands,
     /* 230913 */     // GIR_Coverage, 30,
     /* 230913 */     GIR_EraseRootFromParent_Done,
     /* 230914 */   // Label 4384: @230914
     /* 230914 */   GIM_Try, /*On fail goto*//*Label 4385*/ GIMT_Encode4(230968), // Rule ID 31 //
     /* 230919 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 230922 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_ummla),
     /* 230927 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230930 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230933 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 230936 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 230939 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230951 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230955 */     // (intrinsic_wo_chain:{ *:[v4i32] } 744:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 230955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA),
     /* 230958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 230960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 230962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 230964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 230966 */     GIR_RootConstrainSelectedInstOperands,
     /* 230967 */     // GIR_Coverage, 31,
     /* 230967 */     GIR_EraseRootFromParent_Done,
     /* 230968 */   // Label 4385: @230968
     /* 230968 */   GIM_Try, /*On fail goto*//*Label 4386*/ GIMT_Encode4(231022), // Rule ID 32 //
     /* 230973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8),
     /* 230976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_usmmla),
     /* 230981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 230984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 230987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 230990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 230993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 230997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231005 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231009 */     // (intrinsic_wo_chain:{ *:[v4i32] } 760:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (USMMLA:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 231009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA),
     /* 231012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231020 */     GIR_RootConstrainSelectedInstOperands,
     /* 231021 */     // GIR_Coverage, 32,
     /* 231021 */     GIR_EraseRootFromParent_Done,
     /* 231022 */   // Label 4386: @231022
     /* 231022 */   GIM_Try, /*On fail goto*//*Label 4387*/ GIMT_Encode4(231076), // Rule ID 39 //
     /* 231027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231063 */     // (intrinsic_wo_chain:{ *:[v2f32] } 613:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLALv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv4f16),
     /* 231066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231074 */     GIR_RootConstrainSelectedInstOperands,
     /* 231075 */     // GIR_Coverage, 39,
     /* 231075 */     GIR_EraseRootFromParent_Done,
     /* 231076 */   // Label 4387: @231076
     /* 231076 */   GIM_Try, /*On fail goto*//*Label 4388*/ GIMT_Encode4(231130), // Rule ID 40 //
     /* 231081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal),
     /* 231089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231105 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231109 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231113 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231117 */     // (intrinsic_wo_chain:{ *:[v4f32] } 613:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLALv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALv8f16),
     /* 231120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231128 */     GIR_RootConstrainSelectedInstOperands,
     /* 231129 */     // GIR_Coverage, 40,
     /* 231129 */     GIR_EraseRootFromParent_Done,
     /* 231130 */   // Label 4388: @231130
     /* 231130 */   GIM_Try, /*On fail goto*//*Label 4389*/ GIMT_Encode4(231184), // Rule ID 41 //
     /* 231135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231159 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231163 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231167 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231171 */     // (intrinsic_wo_chain:{ *:[v2f32] } 615:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSLv4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231171 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv4f16),
     /* 231174 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231176 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231178 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231180 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231182 */     GIR_RootConstrainSelectedInstOperands,
     /* 231183 */     // GIR_Coverage, 41,
     /* 231183 */     GIR_EraseRootFromParent_Done,
     /* 231184 */   // Label 4389: @231184
     /* 231184 */   GIM_Try, /*On fail goto*//*Label 4390*/ GIMT_Encode4(231238), // Rule ID 42 //
     /* 231189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl),
     /* 231197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231209 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231213 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231217 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231221 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231225 */     // (intrinsic_wo_chain:{ *:[v4f32] } 615:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSLv8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLv8f16),
     /* 231228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231236 */     GIR_RootConstrainSelectedInstOperands,
     /* 231237 */     // GIR_Coverage, 42,
     /* 231237 */     GIR_EraseRootFromParent_Done,
     /* 231238 */   // Label 4390: @231238
     /* 231238 */   GIM_Try, /*On fail goto*//*Label 4391*/ GIMT_Encode4(231292), // Rule ID 43 //
     /* 231243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231267 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231271 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231275 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231279 */     // (intrinsic_wo_chain:{ *:[v2f32] } 614:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLAL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v4f16),
     /* 231282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231290 */     GIR_RootConstrainSelectedInstOperands,
     /* 231291 */     // GIR_Coverage, 43,
     /* 231291 */     GIR_EraseRootFromParent_Done,
     /* 231292 */   // Label 4391: @231292
     /* 231292 */   GIM_Try, /*On fail goto*//*Label 4392*/ GIMT_Encode4(231346), // Rule ID 44 //
     /* 231297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlal2),
     /* 231305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231325 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231329 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231333 */     // (intrinsic_wo_chain:{ *:[v4f32] } 614:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLAL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAL2v8f16),
     /* 231336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231344 */     GIR_RootConstrainSelectedInstOperands,
     /* 231345 */     // GIR_Coverage, 44,
     /* 231345 */     GIR_EraseRootFromParent_Done,
     /* 231346 */   // Label 4392: @231346
     /* 231346 */   GIM_Try, /*On fail goto*//*Label 4393*/ GIMT_Encode4(231400), // Rule ID 45 //
     /* 231351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231375 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231379 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231383 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231387 */     // (intrinsic_wo_chain:{ *:[v2f32] } 616:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMLSL2v4f16:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 231387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v4f16),
     /* 231390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231396 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231398 */     GIR_RootConstrainSelectedInstOperands,
     /* 231399 */     // GIR_Coverage, 45,
     /* 231399 */     GIR_EraseRootFromParent_Done,
     /* 231400 */   // Label 4393: @231400
     /* 231400 */   GIM_Try, /*On fail goto*//*Label 4394*/ GIMT_Encode4(231454), // Rule ID 46 //
     /* 231405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP16FML_HasNEON),
     /* 231408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fmlsl2),
     /* 231413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231422 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231425 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231437 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231441 */     // (intrinsic_wo_chain:{ *:[v4f32] } 616:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMLSL2v8f16:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 231441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSL2v8f16),
     /* 231444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231452 */     GIR_RootConstrainSelectedInstOperands,
     /* 231453 */     // GIR_Coverage, 46,
     /* 231453 */     GIR_EraseRootFromParent_Done,
     /* 231454 */   // Label 4394: @231454
     /* 231454 */   GIM_Try, /*On fail goto*//*Label 4395*/ GIMT_Encode4(231508), // Rule ID 1587 //
     /* 231459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231491 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231495 */     // (intrinsic_wo_chain:{ *:[v4i16] } 693:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLAHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i16),
     /* 231498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231506 */     GIR_RootConstrainSelectedInstOperands,
     /* 231507 */     // GIR_Coverage, 1587,
     /* 231507 */     GIR_EraseRootFromParent_Done,
     /* 231508 */   // Label 4395: @231508
     /* 231508 */   GIM_Try, /*On fail goto*//*Label 4396*/ GIMT_Encode4(231562), // Rule ID 1588 //
     /* 231513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231541 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231545 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231549 */     // (intrinsic_wo_chain:{ *:[v8i16] } 693:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLAHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv8i16),
     /* 231552 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231554 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231558 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231560 */     GIR_RootConstrainSelectedInstOperands,
     /* 231561 */     // GIR_Coverage, 1588,
     /* 231561 */     GIR_EraseRootFromParent_Done,
     /* 231562 */   // Label 4396: @231562
     /* 231562 */   GIM_Try, /*On fail goto*//*Label 4397*/ GIMT_Encode4(231616), // Rule ID 1589 //
     /* 231567 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231570 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231575 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231578 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231581 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231584 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231587 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231599 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231603 */     // (intrinsic_wo_chain:{ *:[v2i32] } 693:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLAHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv2i32),
     /* 231606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231614 */     GIR_RootConstrainSelectedInstOperands,
     /* 231615 */     // GIR_Coverage, 1589,
     /* 231615 */     GIR_EraseRootFromParent_Done,
     /* 231616 */   // Label 4397: @231616
     /* 231616 */   GIM_Try, /*On fail goto*//*Label 4398*/ GIMT_Encode4(231670), // Rule ID 1590 //
     /* 231621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 231629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231645 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231649 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231653 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231657 */     // (intrinsic_wo_chain:{ *:[v4i32] } 693:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLAHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv4i32),
     /* 231660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231668 */     GIR_RootConstrainSelectedInstOperands,
     /* 231669 */     // GIR_Coverage, 1590,
     /* 231669 */     GIR_EraseRootFromParent_Done,
     /* 231670 */   // Label 4398: @231670
     /* 231670 */   GIM_Try, /*On fail goto*//*Label 4399*/ GIMT_Encode4(231724), // Rule ID 1591 //
     /* 231675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 231686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 231689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 231692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 231695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231711 */     // (intrinsic_wo_chain:{ *:[v4i16] } 694:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQRDMLSHv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 231711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i16),
     /* 231714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231722 */     GIR_RootConstrainSelectedInstOperands,
     /* 231723 */     // GIR_Coverage, 1591,
     /* 231723 */     GIR_EraseRootFromParent_Done,
     /* 231724 */   // Label 4399: @231724
     /* 231724 */   GIM_Try, /*On fail goto*//*Label 4400*/ GIMT_Encode4(231778), // Rule ID 1592 //
     /* 231729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 231740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 231743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 231746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 231749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231757 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231761 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231765 */     // (intrinsic_wo_chain:{ *:[v8i16] } 694:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQRDMLSHv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 231765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv8i16),
     /* 231768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231770 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231772 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231774 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231776 */     GIR_RootConstrainSelectedInstOperands,
     /* 231777 */     // GIR_Coverage, 1592,
     /* 231777 */     GIR_EraseRootFromParent_Done,
     /* 231778 */   // Label 4400: @231778
     /* 231778 */   GIM_Try, /*On fail goto*//*Label 4401*/ GIMT_Encode4(231832), // Rule ID 1593 //
     /* 231783 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231786 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231791 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 231794 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 231797 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 231800 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 231803 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231807 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231811 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231815 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 231819 */     // (intrinsic_wo_chain:{ *:[v2i32] } 694:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQRDMLSHv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 231819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv2i32),
     /* 231822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231830 */     GIR_RootConstrainSelectedInstOperands,
     /* 231831 */     // GIR_Coverage, 1593,
     /* 231831 */     GIR_EraseRootFromParent_Done,
     /* 231832 */   // Label 4401: @231832
     /* 231832 */   GIM_Try, /*On fail goto*//*Label 4402*/ GIMT_Encode4(231886), // Rule ID 1594 //
     /* 231837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRDM),
     /* 231840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 231845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 231854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231861 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231869 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231873 */     // (intrinsic_wo_chain:{ *:[v4i32] } 694:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQRDMLSHv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv4i32),
     /* 231876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231884 */     GIR_RootConstrainSelectedInstOperands,
     /* 231885 */     // GIR_Coverage, 1594,
     /* 231885 */     GIR_EraseRootFromParent_Done,
     /* 231886 */   // Label 4402: @231886
     /* 231886 */   GIM_Try, /*On fail goto*//*Label 4403*/ GIMT_Encode4(231940), // Rule ID 2307 //
     /* 231891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 231894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1c),
     /* 231899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231915 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 231923 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231927 */     // (intrinsic_wo_chain:{ *:[v4i32] } 527:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Crrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Crrr),
     /* 231930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231936 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231938 */     GIR_RootConstrainSelectedInstOperands,
     /* 231939 */     // GIR_Coverage, 2307,
     /* 231939 */     GIR_EraseRootFromParent_Done,
     /* 231940 */   // Label 4403: @231940
     /* 231940 */   GIM_Try, /*On fail goto*//*Label 4404*/ GIMT_Encode4(231994), // Rule ID 2308 //
     /* 231945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 231948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1p),
     /* 231953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 231956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 231959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 231962 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 231965 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231973 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 231977 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 231981 */     // (intrinsic_wo_chain:{ *:[v4i32] } 530:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Prrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 231981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Prrr),
     /* 231984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 231986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 231988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 231990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 231992 */     GIR_RootConstrainSelectedInstOperands,
     /* 231993 */     // GIR_Coverage, 2308,
     /* 231993 */     GIR_EraseRootFromParent_Done,
     /* 231994 */   // Label 4404: @231994
     /* 231994 */   GIM_Try, /*On fail goto*//*Label 4405*/ GIMT_Encode4(232048), // Rule ID 2309 //
     /* 231999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1m),
     /* 232007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 232016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232023 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232027 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 232031 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232035 */     // (intrinsic_wo_chain:{ *:[v4i32] } 529:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1Mrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1Mrrr),
     /* 232038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232046 */     GIR_RootConstrainSelectedInstOperands,
     /* 232047 */     // GIR_Coverage, 2309,
     /* 232047 */     GIR_EraseRootFromParent_Done,
     /* 232048 */   // Label 4405: @232048
     /* 232048 */   GIM_Try, /*On fail goto*//*Label 4406*/ GIMT_Encode4(232102), // Rule ID 2310 //
     /* 232053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha1su0),
     /* 232061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232077 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232085 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232089 */     // (intrinsic_wo_chain:{ *:[v4i32] } 531:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA1SU0rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA1SU0rrr),
     /* 232092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232100 */     GIR_RootConstrainSelectedInstOperands,
     /* 232101 */     // GIR_Coverage, 2310,
     /* 232101 */     GIR_EraseRootFromParent_Done,
     /* 232102 */   // Label 4406: @232102
     /* 232102 */   GIM_Try, /*On fail goto*//*Label 4407*/ GIMT_Encode4(232156), // Rule ID 2311 //
     /* 232107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h),
     /* 232115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232131 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232139 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232143 */     // (intrinsic_wo_chain:{ *:[v4i32] } 533:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256Hrrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256Hrrr),
     /* 232146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232154 */     GIR_RootConstrainSelectedInstOperands,
     /* 232155 */     // GIR_Coverage, 2311,
     /* 232155 */     GIR_EraseRootFromParent_Done,
     /* 232156 */   // Label 4407: @232156
     /* 232156 */   GIM_Try, /*On fail goto*//*Label 4408*/ GIMT_Encode4(232210), // Rule ID 2312 //
     /* 232161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256h2),
     /* 232169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232185 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232189 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232193 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232197 */     // (intrinsic_wo_chain:{ *:[v4i32] } 534:{ *:[iPTR] }, FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256H2rrr:{ *:[v4i32] } FPR128:{ *:[v4i32] }:$Rd, FPR128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256H2rrr),
     /* 232200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232208 */     GIR_RootConstrainSelectedInstOperands,
     /* 232209 */     // GIR_Coverage, 2312,
     /* 232209 */     GIR_EraseRootFromParent_Done,
     /* 232210 */   // Label 4408: @232210
     /* 232210 */   GIM_Try, /*On fail goto*//*Label 4409*/ GIMT_Encode4(232264), // Rule ID 2313 //
     /* 232215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA2),
     /* 232218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha256su1),
     /* 232223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232239 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232243 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232247 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232251 */     // (intrinsic_wo_chain:{ *:[v4i32] } 536:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SHA256SU1rrr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 232251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA256SU1rrr),
     /* 232254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 232256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 232258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 232260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 232262 */     GIR_RootConstrainSelectedInstOperands,
     /* 232263 */     // GIR_Coverage, 2313,
     /* 232263 */     GIR_EraseRootFromParent_Done,
     /* 232264 */   // Label 4409: @232264
     /* 232264 */   GIM_Try, /*On fail goto*//*Label 4410*/ GIMT_Encode4(232321), // Rule ID 3635 //
     /* 232269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 232286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232301 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232305 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR8:{ *:[nxv16i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_B:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232305 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_B),
     /* 232308 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232312 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232314 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232319 */     GIR_RootConstrainSelectedInstOperands,
     /* 232320 */     // GIR_Coverage, 3635,
     /* 232320 */     GIR_EraseRootFromParent_Done,
     /* 232321 */   // Label 4410: @232321
     /* 232321 */   GIM_Try, /*On fail goto*//*Label 4411*/ GIMT_Encode4(232378), // Rule ID 3636 //
     /* 232326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232329 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232334 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232337 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232340 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 232343 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232346 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232358 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232362 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR16:{ *:[nxv8i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_H:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_H),
     /* 232365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232367 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232369 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232371 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232376 */     GIR_RootConstrainSelectedInstOperands,
     /* 232377 */     // GIR_Coverage, 3636,
     /* 232377 */     GIR_EraseRootFromParent_Done,
     /* 232378 */   // Label 4411: @232378
     /* 232378 */   GIM_Try, /*On fail goto*//*Label 4412*/ GIMT_Encode4(232435), // Rule ID 3637 //
     /* 232383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 232400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232407 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232411 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232415 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232419 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR32:{ *:[nxv4i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_S:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_S),
     /* 232422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232428 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232430 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232433 */     GIR_RootConstrainSelectedInstOperands,
     /* 232434 */     // GIR_Coverage, 3637,
     /* 232434 */     GIR_EraseRootFromParent_Done,
     /* 232435 */   // Label 4412: @232435
     /* 232435 */   GIM_Try, /*On fail goto*//*Label 4413*/ GIMT_Encode4(232492), // Rule ID 3638 //
     /* 232440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 232443 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_psel),
     /* 232448 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 232451 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 232454 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 232457 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 232460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 232464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232468 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 232472 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::MatrixIndexGPR32_12_15RegClassID),
     /* 232476 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1658:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pn, PPR64:{ *:[nxv2i1] }:$Pm, MatrixIndexGPR32Op12_15:{ *:[i32] }:$idx)  =>  (PSEL_PPPRI_D:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[i32] }:$idx, 0:{ *:[i32] })
     /* 232476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PSEL_PPPRI_D),
     /* 232479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 232481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 232483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 232485 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 232487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 232490 */     GIR_RootConstrainSelectedInstOperands,
     /* 232491 */     // GIR_Coverage, 3638,
     /* 232491 */     GIR_EraseRootFromParent_Done,
     /* 232492 */   // Label 4413: @232492
     /* 232492 */   GIM_Try, /*On fail goto*//*Label 4414*/ GIMT_Encode4(232546), // Rule ID 3815 //
     /* 232497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h),
     /* 232505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232521 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232525 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232529 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232533 */     // (intrinsic_wo_chain:{ *:[v2i64] } 537:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H),
     /* 232536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232542 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232544 */     GIR_RootConstrainSelectedInstOperands,
     /* 232545 */     // GIR_Coverage, 3815,
     /* 232545 */     GIR_EraseRootFromParent_Done,
     /* 232546 */   // Label 4414: @232546
     /* 232546 */   GIM_Try, /*On fail goto*//*Label 4415*/ GIMT_Encode4(232600), // Rule ID 3816 //
     /* 232551 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232554 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512h2),
     /* 232559 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232562 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232565 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232568 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232571 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232583 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232587 */     // (intrinsic_wo_chain:{ *:[v2i64] } 538:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512H2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512H2),
     /* 232590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232598 */     GIR_RootConstrainSelectedInstOperands,
     /* 232599 */     // GIR_Coverage, 3816,
     /* 232599 */     GIR_EraseRootFromParent_Done,
     /* 232600 */   // Label 4415: @232600
     /* 232600 */   GIM_Try, /*On fail goto*//*Label 4416*/ GIMT_Encode4(232654), // Rule ID 3817 //
     /* 232605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sha512su1),
     /* 232613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232629 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232633 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232637 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232641 */     // (intrinsic_wo_chain:{ *:[v2i64] } 540:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (SHA512SU1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHA512SU1),
     /* 232644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 232646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232648 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232650 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232652 */     GIR_RootConstrainSelectedInstOperands,
     /* 232653 */     // GIR_Coverage, 3817,
     /* 232653 */     GIR_EraseRootFromParent_Done,
     /* 232654 */   // Label 4416: @232654
     /* 232654 */   GIM_Try, /*On fail goto*//*Label 4417*/ GIMT_Encode4(232708), // Rule ID 3818 //
     /* 232659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 232673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 232676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 232679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232683 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232687 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232691 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232695 */     // (intrinsic_wo_chain:{ *:[v16i8] } 525:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 232695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232706 */     GIR_RootConstrainSelectedInstOperands,
     /* 232707 */     // GIR_Coverage, 3818,
     /* 232707 */     GIR_EraseRootFromParent_Done,
     /* 232708 */   // Label 4417: @232708
     /* 232708 */   GIM_Try, /*On fail goto*//*Label 4418*/ GIMT_Encode4(232762), // Rule ID 3819 //
     /* 232713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232745 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232749 */     // (intrinsic_wo_chain:{ *:[v8i16] } 525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 232749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232760 */     GIR_RootConstrainSelectedInstOperands,
     /* 232761 */     // GIR_Coverage, 3819,
     /* 232761 */     GIR_EraseRootFromParent_Done,
     /* 232762 */   // Label 4418: @232762
     /* 232762 */   GIM_Try, /*On fail goto*//*Label 4419*/ GIMT_Encode4(232816), // Rule ID 3820 //
     /* 232767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 232784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 232787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232791 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232795 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232799 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232803 */     // (intrinsic_wo_chain:{ *:[v4i32] } 525:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 232803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232814 */     GIR_RootConstrainSelectedInstOperands,
     /* 232815 */     // GIR_Coverage, 3820,
     /* 232815 */     GIR_EraseRootFromParent_Done,
     /* 232816 */   // Label 4419: @232816
     /* 232816 */   GIM_Try, /*On fail goto*//*Label 4420*/ GIMT_Encode4(232870), // Rule ID 3821 //
     /* 232821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3u),
     /* 232829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 232832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 232835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 232838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 232841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232845 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232853 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232857 */     // (intrinsic_wo_chain:{ *:[v2i64] } 525:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 232857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 232860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232868 */     GIR_RootConstrainSelectedInstOperands,
     /* 232869 */     // GIR_Coverage, 3821,
     /* 232869 */     GIR_EraseRootFromParent_Done,
     /* 232870 */   // Label 4420: @232870
     /* 232870 */   GIM_Try, /*On fail goto*//*Label 4421*/ GIMT_Encode4(232924), // Rule ID 3830 //
     /* 232875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 232883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 232886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 232889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 232892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 232895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232899 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232903 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232907 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232911 */     // (intrinsic_wo_chain:{ *:[v16i8] } 523:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 232911 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232914 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232920 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232922 */     GIR_RootConstrainSelectedInstOperands,
     /* 232923 */     // GIR_Coverage, 3830,
     /* 232923 */     GIR_EraseRootFromParent_Done,
     /* 232924 */   // Label 4421: @232924
     /* 232924 */   GIM_Try, /*On fail goto*//*Label 4422*/ GIMT_Encode4(232978), // Rule ID 3831 //
     /* 232929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232932 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 232937 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 232940 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 232943 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 232946 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 232949 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232961 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 232965 */     // (intrinsic_wo_chain:{ *:[v8i16] } 523:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 232965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 232968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 232970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 232972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 232974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 232976 */     GIR_RootConstrainSelectedInstOperands,
     /* 232977 */     // GIR_Coverage, 3831,
     /* 232977 */     GIR_EraseRootFromParent_Done,
     /* 232978 */   // Label 4422: @232978
     /* 232978 */   GIM_Try, /*On fail goto*//*Label 4423*/ GIMT_Encode4(233032), // Rule ID 3832 //
     /* 232983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 232986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 232991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 232994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 232997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233015 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233019 */     // (intrinsic_wo_chain:{ *:[v4i32] } 523:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233024 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233026 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233028 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233030 */     GIR_RootConstrainSelectedInstOperands,
     /* 233031 */     // GIR_Coverage, 3832,
     /* 233031 */     GIR_EraseRootFromParent_Done,
     /* 233032 */   // Label 4423: @233032
     /* 233032 */   GIM_Try, /*On fail goto*//*Label 4424*/ GIMT_Encode4(233086), // Rule ID 3833 //
     /* 233037 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233040 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxu),
     /* 233045 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233048 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233051 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233054 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233057 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233061 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233069 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233073 */     // (intrinsic_wo_chain:{ *:[v2i64] } 523:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233084 */     GIR_RootConstrainSelectedInstOperands,
     /* 233085 */     // GIR_Coverage, 3833,
     /* 233085 */     GIR_EraseRootFromParent_Done,
     /* 233086 */   // Label 4424: @233086
     /* 233086 */   GIM_Try, /*On fail goto*//*Label 4425*/ GIMT_Encode4(233140), // Rule ID 3834 //
     /* 233091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233115 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233119 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233123 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233127 */     // (intrinsic_wo_chain:{ *:[v16i8] } 524:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (EOR3:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233138 */     GIR_RootConstrainSelectedInstOperands,
     /* 233139 */     // GIR_Coverage, 3834,
     /* 233139 */     GIR_EraseRootFromParent_Done,
     /* 233140 */   // Label 4425: @233140
     /* 233140 */   GIM_Try, /*On fail goto*//*Label 4426*/ GIMT_Encode4(233194), // Rule ID 3835 //
     /* 233145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233169 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233173 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233177 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233181 */     // (intrinsic_wo_chain:{ *:[v8i16] } 524:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (EOR3:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233192 */     GIR_RootConstrainSelectedInstOperands,
     /* 233193 */     // GIR_Coverage, 3835,
     /* 233193 */     GIR_EraseRootFromParent_Done,
     /* 233194 */   // Label 4426: @233194
     /* 233194 */   GIM_Try, /*On fail goto*//*Label 4427*/ GIMT_Encode4(233248), // Rule ID 3836 //
     /* 233199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233223 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233231 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233235 */     // (intrinsic_wo_chain:{ *:[v4i32] } 524:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (EOR3:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233246 */     GIR_RootConstrainSelectedInstOperands,
     /* 233247 */     // GIR_Coverage, 3836,
     /* 233247 */     GIR_EraseRootFromParent_Done,
     /* 233248 */   // Label 4427: @233248
     /* 233248 */   GIM_Try, /*On fail goto*//*Label 4428*/ GIMT_Encode4(233302), // Rule ID 3837 //
     /* 233253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_eor3s),
     /* 233261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233277 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233281 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233285 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233289 */     // (intrinsic_wo_chain:{ *:[v2i64] } 524:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (EOR3:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3),
     /* 233292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233294 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233298 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233300 */     GIR_RootConstrainSelectedInstOperands,
     /* 233301 */     // GIR_Coverage, 3837,
     /* 233301 */     GIR_EraseRootFromParent_Done,
     /* 233302 */   // Label 4428: @233302
     /* 233302 */   GIM_Try, /*On fail goto*//*Label 4429*/ GIMT_Encode4(233356), // Rule ID 3838 //
     /* 233307 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233310 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233315 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 233318 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 233321 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 233324 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 233327 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233331 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233335 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233339 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233343 */     // (intrinsic_wo_chain:{ *:[v16i8] } 522:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)  =>  (BCAX:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, V128:{ *:[v16i8] }:$Vn, V128:{ *:[v16i8] }:$Vm)
     /* 233343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233354 */     GIR_RootConstrainSelectedInstOperands,
     /* 233355 */     // GIR_Coverage, 3838,
     /* 233355 */     GIR_EraseRootFromParent_Done,
     /* 233356 */   // Label 4429: @233356
     /* 233356 */   GIM_Try, /*On fail goto*//*Label 4430*/ GIMT_Encode4(233410), // Rule ID 3839 //
     /* 233361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233385 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233393 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233397 */     // (intrinsic_wo_chain:{ *:[v8i16] } 522:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)  =>  (BCAX:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, V128:{ *:[v8i16] }:$Vn, V128:{ *:[v8i16] }:$Vm)
     /* 233397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233402 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233404 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233406 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233408 */     GIR_RootConstrainSelectedInstOperands,
     /* 233409 */     // GIR_Coverage, 3839,
     /* 233409 */     GIR_EraseRootFromParent_Done,
     /* 233410 */   // Label 4430: @233410
     /* 233410 */   GIM_Try, /*On fail goto*//*Label 4431*/ GIMT_Encode4(233464), // Rule ID 3840 //
     /* 233415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233439 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233443 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233447 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233451 */     // (intrinsic_wo_chain:{ *:[v4i32] } 522:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (BCAX:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233462 */     GIR_RootConstrainSelectedInstOperands,
     /* 233463 */     // GIR_Coverage, 3840,
     /* 233463 */     GIR_EraseRootFromParent_Done,
     /* 233464 */   // Label 4431: @233464
     /* 233464 */   GIM_Try, /*On fail goto*//*Label 4432*/ GIMT_Encode4(233518), // Rule ID 3841 //
     /* 233469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSHA3),
     /* 233472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_bcaxs),
     /* 233477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 233480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 233483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 233486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 233489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233501 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233505 */     // (intrinsic_wo_chain:{ *:[v2i64] } 522:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)  =>  (BCAX:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm)
     /* 233505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX),
     /* 233508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233510 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233512 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233514 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233516 */     GIR_RootConstrainSelectedInstOperands,
     /* 233517 */     // GIR_Coverage, 3841,
     /* 233517 */     GIR_EraseRootFromParent_Done,
     /* 233518 */   // Label 4432: @233518
     /* 233518 */   GIM_Try, /*On fail goto*//*Label 4433*/ GIMT_Encode4(233572), // Rule ID 3845 //
     /* 233523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3ss1),
     /* 233531 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233534 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233537 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233540 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233543 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233551 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233555 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233559 */     // (intrinsic_wo_chain:{ *:[v4i32] } 543:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)  =>  (SM3SS1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, V128:{ *:[v4i32] }:$Va)
     /* 233559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3SS1),
     /* 233562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 233564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vn
     /* 233566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vm
     /* 233568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Va
     /* 233570 */     GIR_RootConstrainSelectedInstOperands,
     /* 233571 */     // GIR_Coverage, 3845,
     /* 233571 */     GIR_EraseRootFromParent_Done,
     /* 233572 */   // Label 4433: @233572
     /* 233572 */   GIM_Try, /*On fail goto*//*Label 4434*/ GIMT_Encode4(233626), // Rule ID 3846 //
     /* 233577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw1),
     /* 233585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233605 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233609 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233613 */     // (intrinsic_wo_chain:{ *:[v4i32] } 541:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW1),
     /* 233616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233624 */     GIR_RootConstrainSelectedInstOperands,
     /* 233625 */     // GIR_Coverage, 3846,
     /* 233625 */     GIR_EraseRootFromParent_Done,
     /* 233626 */   // Label 4434: @233626
     /* 233626 */   GIM_Try, /*On fail goto*//*Label 4435*/ GIMT_Encode4(233680), // Rule ID 3847 //
     /* 233631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 233634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3partw2),
     /* 233639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 233642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 233645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 233648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 233651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233667 */     // (intrinsic_wo_chain:{ *:[v4i32] } 542:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)  =>  (SM3PARTW2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm)
     /* 233667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3PARTW2),
     /* 233670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 233672 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 233674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 233676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 233678 */     GIR_RootConstrainSelectedInstOperands,
     /* 233679 */     // GIR_Coverage, 3847,
     /* 233679 */     GIR_EraseRootFromParent_Done,
     /* 233680 */   // Label 4435: @233680
     /* 233680 */   GIM_Try, /*On fail goto*//*Label 4436*/ GIMT_Encode4(233737), // Rule ID 3864 //
     /* 233685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233705 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233709 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233713 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233717 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233721 */     // (intrinsic_wo_chain:{ *:[v4f16] } 764:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 0:{ *:[i32] })
     /* 233721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233735 */     GIR_RootConstrainSelectedInstOperands,
     /* 233736 */     // GIR_Coverage, 3864,
     /* 233736 */     GIR_EraseRootFromParent_Done,
     /* 233737 */   // Label 4436: @233737
     /* 233737 */   GIM_Try, /*On fail goto*//*Label 4437*/ GIMT_Encode4(233794), // Rule ID 3865 //
     /* 233742 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233759 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233762 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233774 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233778 */     // (intrinsic_wo_chain:{ *:[v4f16] } 767:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 1:{ *:[i32] })
     /* 233778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233783 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233785 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233787 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233789 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 233792 */     GIR_RootConstrainSelectedInstOperands,
     /* 233793 */     // GIR_Coverage, 3865,
     /* 233793 */     GIR_EraseRootFromParent_Done,
     /* 233794 */   // Label 4437: @233794
     /* 233794 */   GIM_Try, /*On fail goto*//*Label 4438*/ GIMT_Encode4(233851), // Rule ID 3866 //
     /* 233799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 233807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233831 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233835 */     // (intrinsic_wo_chain:{ *:[v4f16] } 765:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 2:{ *:[i32] })
     /* 233835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233842 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233844 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233846 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 233849 */     GIR_RootConstrainSelectedInstOperands,
     /* 233850 */     // GIR_Coverage, 3866,
     /* 233850 */     GIR_EraseRootFromParent_Done,
     /* 233851 */   // Label 4438: @233851
     /* 233851 */   GIM_Try, /*On fail goto*//*Label 4439*/ GIMT_Encode4(233908), // Rule ID 3867 //
     /* 233856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233859 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 233864 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 233867 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 233870 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 233873 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s16,
     /* 233876 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233880 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233884 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233888 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 233892 */     // (intrinsic_wo_chain:{ *:[v4f16] } 766:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMLAv4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v4f16] }:$Rn, ?:{ *:[v4f16] }:$Rm, 3:{ *:[i32] })
     /* 233892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f16),
     /* 233895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233903 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 233906 */     GIR_RootConstrainSelectedInstOperands,
     /* 233907 */     // GIR_Coverage, 3867,
     /* 233907 */     GIR_EraseRootFromParent_Done,
     /* 233908 */   // Label 4439: @233908
     /* 233908 */   GIM_Try, /*On fail goto*//*Label 4440*/ GIMT_Encode4(233965), // Rule ID 3872 //
     /* 233913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 233921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233937 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233941 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233945 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233949 */     // (intrinsic_wo_chain:{ *:[v8f16] } 764:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 0:{ *:[i32] })
     /* 233949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 233952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 233954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 233956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 233958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 233960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 233963 */     GIR_RootConstrainSelectedInstOperands,
     /* 233964 */     // GIR_Coverage, 3872,
     /* 233964 */     GIR_EraseRootFromParent_Done,
     /* 233965 */   // Label 4440: @233965
     /* 233965 */   GIM_Try, /*On fail goto*//*Label 4441*/ GIMT_Encode4(234022), // Rule ID 3873 //
     /* 233970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 233973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 233978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 233981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 233984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 233987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 233990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233994 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 233998 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234002 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234006 */     // (intrinsic_wo_chain:{ *:[v8f16] } 767:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 1:{ *:[i32] })
     /* 234006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234011 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234015 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234017 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234020 */     GIR_RootConstrainSelectedInstOperands,
     /* 234021 */     // GIR_Coverage, 3873,
     /* 234021 */     GIR_EraseRootFromParent_Done,
     /* 234022 */   // Label 4441: @234022
     /* 234022 */   GIM_Try, /*On fail goto*//*Label 4442*/ GIMT_Encode4(234079), // Rule ID 3874 //
     /* 234027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234030 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234035 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234038 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234041 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234044 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234047 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234055 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234059 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234063 */     // (intrinsic_wo_chain:{ *:[v8f16] } 765:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 2:{ *:[i32] })
     /* 234063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234074 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234077 */     GIR_RootConstrainSelectedInstOperands,
     /* 234078 */     // GIR_Coverage, 3874,
     /* 234078 */     GIR_EraseRootFromParent_Done,
     /* 234079 */   // Label 4442: @234079
     /* 234079 */   GIM_Try, /*On fail goto*//*Label 4443*/ GIMT_Encode4(234136), // Rule ID 3875 //
     /* 234084 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasFullFP16_HasNEON),
     /* 234087 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234092 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 234095 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 234098 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 234101 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 234104 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234116 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234120 */     // (intrinsic_wo_chain:{ *:[v8f16] } 766:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMLAv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm, 3:{ *:[i32] })
     /* 234120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv8f16),
     /* 234123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234125 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234129 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234131 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234134 */     GIR_RootConstrainSelectedInstOperands,
     /* 234135 */     // GIR_Coverage, 3875,
     /* 234135 */     GIR_EraseRootFromParent_Done,
     /* 234136 */   // Label 4443: @234136
     /* 234136 */   GIM_Try, /*On fail goto*//*Label 4444*/ GIMT_Encode4(234193), // Rule ID 3880 //
     /* 234141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234165 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234169 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234173 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234177 */     // (intrinsic_wo_chain:{ *:[v2f32] } 764:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 0:{ *:[i32] })
     /* 234177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234186 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234188 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234191 */     GIR_RootConstrainSelectedInstOperands,
     /* 234192 */     // GIR_Coverage, 3880,
     /* 234192 */     GIR_EraseRootFromParent_Done,
     /* 234193 */   // Label 4444: @234193
     /* 234193 */   GIM_Try, /*On fail goto*//*Label 4445*/ GIMT_Encode4(234250), // Rule ID 3881 //
     /* 234198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234201 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234206 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234209 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234212 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234215 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234218 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234226 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234230 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234234 */     // (intrinsic_wo_chain:{ *:[v2f32] } 767:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 1:{ *:[i32] })
     /* 234234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234239 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234243 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234245 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234248 */     GIR_RootConstrainSelectedInstOperands,
     /* 234249 */     // GIR_Coverage, 3881,
     /* 234249 */     GIR_EraseRootFromParent_Done,
     /* 234250 */   // Label 4445: @234250
     /* 234250 */   GIM_Try, /*On fail goto*//*Label 4446*/ GIMT_Encode4(234307), // Rule ID 3882 //
     /* 234255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234279 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234283 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234287 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234291 */     // (intrinsic_wo_chain:{ *:[v2f32] } 765:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 2:{ *:[i32] })
     /* 234291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234302 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234305 */     GIR_RootConstrainSelectedInstOperands,
     /* 234306 */     // GIR_Coverage, 3882,
     /* 234306 */     GIR_EraseRootFromParent_Done,
     /* 234307 */   // Label 4446: @234307
     /* 234307 */   GIM_Try, /*On fail goto*//*Label 4447*/ GIMT_Encode4(234364), // Rule ID 3883 //
     /* 234312 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234315 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234320 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 234323 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 234326 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 234329 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s32,
     /* 234332 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234336 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234344 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234348 */     // (intrinsic_wo_chain:{ *:[v2f32] } 766:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMLAv2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v2f32] }:$Rn, ?:{ *:[v2f32] }:$Rm, 3:{ *:[i32] })
     /* 234348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f32),
     /* 234351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234359 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234362 */     GIR_RootConstrainSelectedInstOperands,
     /* 234363 */     // GIR_Coverage, 3883,
     /* 234363 */     GIR_EraseRootFromParent_Done,
     /* 234364 */   // Label 4447: @234364
     /* 234364 */   GIM_Try, /*On fail goto*//*Label 4448*/ GIMT_Encode4(234421), // Rule ID 3884 //
     /* 234369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234397 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234401 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234405 */     // (intrinsic_wo_chain:{ *:[v4f32] } 764:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 0:{ *:[i32] })
     /* 234405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234416 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234419 */     GIR_RootConstrainSelectedInstOperands,
     /* 234420 */     // GIR_Coverage, 3884,
     /* 234420 */     GIR_EraseRootFromParent_Done,
     /* 234421 */   // Label 4448: @234421
     /* 234421 */   GIM_Try, /*On fail goto*//*Label 4449*/ GIMT_Encode4(234478), // Rule ID 3885 //
     /* 234426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234429 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234434 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234443 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234446 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234450 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234454 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234458 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234462 */     // (intrinsic_wo_chain:{ *:[v4f32] } 767:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 1:{ *:[i32] })
     /* 234462 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234465 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234467 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234469 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234471 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234473 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234476 */     GIR_RootConstrainSelectedInstOperands,
     /* 234477 */     // GIR_Coverage, 3885,
     /* 234477 */     GIR_EraseRootFromParent_Done,
     /* 234478 */   // Label 4449: @234478
     /* 234478 */   GIM_Try, /*On fail goto*//*Label 4450*/ GIMT_Encode4(234535), // Rule ID 3886 //
     /* 234483 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234494 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234497 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234500 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234503 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234515 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234519 */     // (intrinsic_wo_chain:{ *:[v4f32] } 765:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 2:{ *:[i32] })
     /* 234519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234530 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234533 */     GIR_RootConstrainSelectedInstOperands,
     /* 234534 */     // GIR_Coverage, 3886,
     /* 234534 */     GIR_EraseRootFromParent_Done,
     /* 234535 */   // Label 4450: @234535
     /* 234535 */   GIM_Try, /*On fail goto*//*Label 4451*/ GIMT_Encode4(234592), // Rule ID 3887 //
     /* 234540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234543 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234548 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 234551 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 234554 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 234557 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 234560 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234564 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234572 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234576 */     // (intrinsic_wo_chain:{ *:[v4f32] } 766:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMLAv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm, 3:{ *:[i32] })
     /* 234576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv4f32),
     /* 234579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234581 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234583 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234585 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234587 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234590 */     GIR_RootConstrainSelectedInstOperands,
     /* 234591 */     // GIR_Coverage, 3887,
     /* 234591 */     GIR_EraseRootFromParent_Done,
     /* 234592 */   // Label 4451: @234592
     /* 234592 */   GIM_Try, /*On fail goto*//*Label 4452*/ GIMT_Encode4(234649), // Rule ID 3888 //
     /* 234597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot0),
     /* 234605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234621 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234625 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234629 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234633 */     // (intrinsic_wo_chain:{ *:[v2f64] } 764:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 0:{ *:[i32] })
     /* 234633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234638 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234640 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234642 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234644 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 234647 */     GIR_RootConstrainSelectedInstOperands,
     /* 234648 */     // GIR_Coverage, 3888,
     /* 234648 */     GIR_EraseRootFromParent_Done,
     /* 234649 */   // Label 4452: @234649
     /* 234649 */   GIM_Try, /*On fail goto*//*Label 4453*/ GIMT_Encode4(234706), // Rule ID 3889 //
     /* 234654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot90),
     /* 234662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234690 */     // (intrinsic_wo_chain:{ *:[v2f64] } 767:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 1:{ *:[i32] })
     /* 234690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234699 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 234704 */     GIR_RootConstrainSelectedInstOperands,
     /* 234705 */     // GIR_Coverage, 3889,
     /* 234705 */     GIR_EraseRootFromParent_Done,
     /* 234706 */   // Label 4453: @234706
     /* 234706 */   GIM_Try, /*On fail goto*//*Label 4454*/ GIMT_Encode4(234763), // Rule ID 3890 //
     /* 234711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot180),
     /* 234719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234743 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234747 */     // (intrinsic_wo_chain:{ *:[v2f64] } 765:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 2:{ *:[i32] })
     /* 234747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/2,
     /* 234761 */     GIR_RootConstrainSelectedInstOperands,
     /* 234762 */     // GIR_Coverage, 3890,
     /* 234762 */     GIR_EraseRootFromParent_Done,
     /* 234763 */   // Label 4454: @234763
     /* 234763 */   GIM_Try, /*On fail goto*//*Label 4455*/ GIMT_Encode4(234820), // Rule ID 3891 //
     /* 234768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasComplxNum_HasNEON),
     /* 234771 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcmla_rot270),
     /* 234776 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 234779 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 234782 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 234785 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 234788 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234792 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234796 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234800 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234804 */     // (intrinsic_wo_chain:{ *:[v2f64] } 766:{ *:[iPTR] }, V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMLAv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rd, ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm, 3:{ *:[i32] })
     /* 234804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLAv2f64),
     /* 234807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234809 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234811 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234813 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234815 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 234818 */     GIR_RootConstrainSelectedInstOperands,
     /* 234819 */     // GIR_Coverage, 3891,
     /* 234819 */     GIR_EraseRootFromParent_Done,
     /* 234820 */   // Label 4455: @234820
     /* 234820 */   GIM_Try, /*On fail goto*//*Label 4456*/ GIMT_Encode4(234874), // Rule ID 5246 //
     /* 234825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234828 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlah),
     /* 234833 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234836 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234839 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234842 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234845 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234853 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234857 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234861 */     // (intrinsic_wo_chain:{ *:[i32] } 693:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLAHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 234861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAHv1i32),
     /* 234864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234872 */     GIR_RootConstrainSelectedInstOperands,
     /* 234873 */     // GIR_Coverage, 5246,
     /* 234873 */     GIR_EraseRootFromParent_Done,
     /* 234874 */   // Label 4456: @234874
     /* 234874 */   GIM_Try, /*On fail goto*//*Label 4457*/ GIMT_Encode4(234928), // Rule ID 5247 //
     /* 234879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasRDM),
     /* 234882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqrdmlsh),
     /* 234887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 234890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 234893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 234896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_s32,
     /* 234899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234903 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234907 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234911 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 234915 */     // (intrinsic_wo_chain:{ *:[i32] } 694:{ *:[iPTR] }, FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)  =>  (SQRDMLSHv1i32:{ *:[i32] } FPR32:{ *:[i32] }:$Rd, FPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }:$Rm)
     /* 234915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSHv1i32),
     /* 234918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 234926 */     GIR_RootConstrainSelectedInstOperands,
     /* 234927 */     // GIR_Coverage, 5247,
     /* 234927 */     GIR_EraseRootFromParent_Done,
     /* 234928 */   // Label 4457: @234928
     /* 234928 */   GIM_Try, /*On fail goto*//*Label 4458*/ GIMT_Encode4(234979), // Rule ID 5600 //
     /* 234933 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 234938 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 234941 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 234944 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 234947 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 234950 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 234962 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 234966 */     // (intrinsic_wo_chain:{ *:[v8i8] } 727:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)  =>  (TBXv8i8One:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, VecListOne128:{ *:[v16i8] }:$Rn, V64:{ *:[v8i8] }:$Ri)
     /* 234966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv8i8One),
     /* 234969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 234971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 234973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 234975 */     GIR_RootToRootCopy, /*OpIdx*/4, // Ri
     /* 234977 */     GIR_RootConstrainSelectedInstOperands,
     /* 234978 */     // GIR_Coverage, 5600,
     /* 234978 */     GIR_EraseRootFromParent_Done,
     /* 234979 */   // Label 4458: @234979
     /* 234979 */   GIM_Try, /*On fail goto*//*Label 4459*/ GIMT_Encode4(235030), // Rule ID 5601 //
     /* 234984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_tbx1),
     /* 234989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 234992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 234995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 234998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 235001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235005 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235009 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235013 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 235017 */     // (intrinsic_wo_chain:{ *:[v16i8] } 727:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)  =>  (TBXv16i8One:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Ri, V128:{ *:[v16i8] }:$Rn)
     /* 235017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXv16i8One),
     /* 235020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 235022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 235024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ri
     /* 235026 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rn
     /* 235028 */     GIR_RootConstrainSelectedInstOperands,
     /* 235029 */     // GIR_Coverage, 5601,
     /* 235029 */     GIR_EraseRootFromParent_Done,
     /* 235030 */   // Label 4459: @235030
     /* 235030 */   GIM_Try, /*On fail goto*//*Label 4460*/ GIMT_Encode4(235072), // Rule ID 2695 //
     /* 235035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 235046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 235049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 235052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 235055 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235059 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1925:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBX_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 235059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_B),
     /* 235062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235064 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235070 */     GIR_RootConstrainSelectedInstOperands,
     /* 235071 */     // GIR_Coverage, 2695,
     /* 235071 */     GIR_EraseRootFromParent_Done,
     /* 235072 */   // Label 4460: @235072
     /* 235072 */   GIM_Try, /*On fail goto*//*Label 4461*/ GIMT_Encode4(235114), // Rule ID 2696 //
     /* 235077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235101 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1925:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235112 */     GIR_RootConstrainSelectedInstOperands,
     /* 235113 */     // GIR_Coverage, 2696,
     /* 235113 */     GIR_EraseRootFromParent_Done,
     /* 235114 */   // Label 4461: @235114
     /* 235114 */   GIM_Try, /*On fail goto*//*Label 4462*/ GIMT_Encode4(235156), // Rule ID 2697 //
     /* 235119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235122 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235127 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235130 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235136 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235139 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235143 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1925:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235148 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235150 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235152 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235154 */     GIR_RootConstrainSelectedInstOperands,
     /* 235155 */     // GIR_Coverage, 2697,
     /* 235155 */     GIR_EraseRootFromParent_Done,
     /* 235156 */   // Label 4462: @235156
     /* 235156 */   GIM_Try, /*On fail goto*//*Label 4463*/ GIMT_Encode4(235198), // Rule ID 2698 //
     /* 235161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235164 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235169 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235172 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235175 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235178 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235181 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235185 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1925:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235190 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235192 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235194 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235196 */     GIR_RootConstrainSelectedInstOperands,
     /* 235197 */     // GIR_Coverage, 2698,
     /* 235197 */     GIR_EraseRootFromParent_Done,
     /* 235198 */   // Label 4463: @235198
     /* 235198 */   GIM_Try, /*On fail goto*//*Label 4464*/ GIMT_Encode4(235240), // Rule ID 2699 //
     /* 235203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235206 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235211 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235214 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235220 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235223 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235227 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1925:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBX_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_H),
     /* 235230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235236 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235238 */     GIR_RootConstrainSelectedInstOperands,
     /* 235239 */     // GIR_Coverage, 2699,
     /* 235239 */     GIR_EraseRootFromParent_Done,
     /* 235240 */   // Label 4464: @235240
     /* 235240 */   GIM_Try, /*On fail goto*//*Label 4465*/ GIMT_Encode4(235282), // Rule ID 2700 //
     /* 235245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235262 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235265 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235269 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1925:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBX_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_S),
     /* 235272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235278 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235280 */     GIR_RootConstrainSelectedInstOperands,
     /* 235281 */     // GIR_Coverage, 2700,
     /* 235281 */     GIR_EraseRootFromParent_Done,
     /* 235282 */   // Label 4465: @235282
     /* 235282 */   GIM_Try, /*On fail goto*//*Label 4466*/ GIMT_Encode4(235324), // Rule ID 2701 //
     /* 235287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235290 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbx),
     /* 235295 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235298 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235301 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235304 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235307 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235311 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1925:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBX_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235311 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBX_ZZZ_D),
     /* 235314 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235320 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235322 */     GIR_RootConstrainSelectedInstOperands,
     /* 235323 */     // GIR_Coverage, 2701,
     /* 235323 */     GIR_EraseRootFromParent_Done,
     /* 235324 */   // Label 4466: @235324
     /* 235324 */   GIM_Try, /*On fail goto*//*Label 4467*/ GIMT_Encode4(235366), // Rule ID 2740 //
     /* 235329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235332 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235337 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 235340 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 235343 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 235346 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 235349 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235353 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1271:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 235353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235358 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235360 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235362 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235364 */     GIR_RootConstrainSelectedInstOperands,
     /* 235365 */     // GIR_Coverage, 2740,
     /* 235365 */     GIR_EraseRootFromParent_Done,
     /* 235366 */   // Label 4467: @235366
     /* 235366 */   GIM_Try, /*On fail goto*//*Label 4468*/ GIMT_Encode4(235408), // Rule ID 2741 //
     /* 235371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235374 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235379 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 235382 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235385 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 235388 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 235391 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235395 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1271:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 235395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235400 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235402 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235404 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235406 */     GIR_RootConstrainSelectedInstOperands,
     /* 235407 */     // GIR_Coverage, 2741,
     /* 235407 */     GIR_EraseRootFromParent_Done,
     /* 235408 */   // Label 4468: @235408
     /* 235408 */   GIM_Try, /*On fail goto*//*Label 4469*/ GIMT_Encode4(235450), // Rule ID 2742 //
     /* 235413 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235416 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235421 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 235424 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235427 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235430 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 235433 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235437 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1271:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 235437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235446 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235448 */     GIR_RootConstrainSelectedInstOperands,
     /* 235449 */     // GIR_Coverage, 2742,
     /* 235449 */     GIR_EraseRootFromParent_Done,
     /* 235450 */   // Label 4469: @235450
     /* 235450 */   GIM_Try, /*On fail goto*//*Label 4470*/ GIMT_Encode4(235492), // Rule ID 2743 //
     /* 235455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235458 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235463 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 235466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 235475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235479 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1271:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 235479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235484 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235486 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235488 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235490 */     GIR_RootConstrainSelectedInstOperands,
     /* 235491 */     // GIR_Coverage, 2743,
     /* 235491 */     GIR_EraseRootFromParent_Done,
     /* 235492 */   // Label 4470: @235492
     /* 235492 */   GIM_Try, /*On fail goto*//*Label 4471*/ GIMT_Encode4(235534), // Rule ID 2744 //
     /* 235497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_and_z),
     /* 235505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 235508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 235511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 235514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 235517 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 235521 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1271:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (AND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 235521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::AND_PPzPP),
     /* 235524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 235526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235528 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235530 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235532 */     GIR_RootConstrainSelectedInstOperands,
     /* 235533 */     // GIR_Coverage, 2744,
     /* 235533 */     GIR_EraseRootFromParent_Done,
     /* 235534 */   // Label 4471: @235534
     /* 235534 */   GIM_Try, /*On fail goto*//*Label 4472*/ GIMT_Encode4(235576), // Rule ID 2783 //
     /* 235539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235563 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1370:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_H),
     /* 235566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235574 */     GIR_RootConstrainSelectedInstOperands,
     /* 235575 */     // GIR_Coverage, 2783,
     /* 235575 */     GIR_EraseRootFromParent_Done,
     /* 235576 */   // Label 4472: @235576
     /* 235576 */   GIM_Try, /*On fail goto*//*Label 4473*/ GIMT_Encode4(235618), // Rule ID 2785 //
     /* 235581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235605 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1370:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_S),
     /* 235608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235616 */     GIR_RootConstrainSelectedInstOperands,
     /* 235617 */     // GIR_Coverage, 2785,
     /* 235617 */     GIR_EraseRootFromParent_Done,
     /* 235618 */   // Label 4473: @235618
     /* 235618 */   GIM_Try, /*On fail goto*//*Label 4474*/ GIMT_Encode4(235660), // Rule ID 2787 //
     /* 235623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fadd),
     /* 235631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235647 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1370:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZPmZ_D),
     /* 235650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235658 */     GIR_RootConstrainSelectedInstOperands,
     /* 235659 */     // GIR_Coverage, 2787,
     /* 235659 */     GIR_EraseRootFromParent_Done,
     /* 235660 */   // Label 4474: @235660
     /* 235660 */   GIM_Try, /*On fail goto*//*Label 4475*/ GIMT_Encode4(235702), // Rule ID 2789 //
     /* 235665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 235679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 235682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235689 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1544:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (FSCALE_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 235689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_H),
     /* 235692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235700 */     GIR_RootConstrainSelectedInstOperands,
     /* 235701 */     // GIR_Coverage, 2789,
     /* 235701 */     GIR_EraseRootFromParent_Done,
     /* 235702 */   // Label 4475: @235702
     /* 235702 */   GIM_Try, /*On fail goto*//*Label 4476*/ GIMT_Encode4(235744), // Rule ID 2790 //
     /* 235707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 235721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 235724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235731 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1544:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (FSCALE_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 235731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_S),
     /* 235734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235742 */     GIR_RootConstrainSelectedInstOperands,
     /* 235743 */     // GIR_Coverage, 2790,
     /* 235743 */     GIR_EraseRootFromParent_Done,
     /* 235744 */   // Label 4476: @235744
     /* 235744 */   GIM_Try, /*On fail goto*//*Label 4477*/ GIMT_Encode4(235786), // Rule ID 2791 //
     /* 235749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 235752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fscale),
     /* 235757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 235763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 235766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235773 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1544:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (FSCALE_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 235773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSCALE_ZPmZ_D),
     /* 235776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 235778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235784 */     GIR_RootConstrainSelectedInstOperands,
     /* 235785 */     // GIR_Coverage, 2791,
     /* 235785 */     GIR_EraseRootFromParent_Done,
     /* 235786 */   // Label 4477: @235786
     /* 235786 */   GIM_Try, /*On fail goto*//*Label 4478*/ GIMT_Encode4(235828), // Rule ID 2860 //
     /* 235791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f16f32),
     /* 235799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 235802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 235805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235815 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1406:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTNT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_StoH),
     /* 235818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235826 */     GIR_RootConstrainSelectedInstOperands,
     /* 235827 */     // GIR_Coverage, 2860,
     /* 235827 */     GIR_EraseRootFromParent_Done,
     /* 235828 */   // Label 4478: @235828
     /* 235828 */   GIM_Try, /*On fail goto*//*Label 4479*/ GIMT_Encode4(235870), // Rule ID 2861 //
     /* 235833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtnt_f32f64),
     /* 235841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235857 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1407:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNT_ZPmZ_DtoS),
     /* 235860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235868 */     GIR_RootConstrainSelectedInstOperands,
     /* 235869 */     // GIR_Coverage, 2861,
     /* 235869 */     GIR_EraseRootFromParent_Done,
     /* 235870 */   // Label 4479: @235870
     /* 235870 */   GIM_Try, /*On fail goto*//*Label 4480*/ GIMT_Encode4(235912), // Rule ID 2862 //
     /* 235875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f32f16),
     /* 235883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 235892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 235895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235899 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1402:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTLT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 235899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_HtoS),
     /* 235902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235910 */     GIR_RootConstrainSelectedInstOperands,
     /* 235911 */     // GIR_Coverage, 2862,
     /* 235911 */     GIR_EraseRootFromParent_Done,
     /* 235912 */   // Label 4480: @235912
     /* 235912 */   GIM_Try, /*On fail goto*//*Label 4481*/ GIMT_Encode4(235954), // Rule ID 2863 //
     /* 235917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtlt_f64f32),
     /* 235925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 235928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 235931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 235937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235941 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1403:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTLT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 235941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLT_ZPmZ_StoD),
     /* 235944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235952 */     GIR_RootConstrainSelectedInstOperands,
     /* 235953 */     // GIR_Coverage, 2863,
     /* 235953 */     GIR_EraseRootFromParent_Done,
     /* 235954 */   // Label 4481: @235954
     /* 235954 */   GIM_Try, /*On fail goto*//*Label 4482*/ GIMT_Encode4(235996), // Rule ID 2864 //
     /* 235959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 235962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtxnt_f32f64),
     /* 235967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 235970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 235973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 235976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 235979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 235983 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1409:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTXNT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 235983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTXNT_ZPmZ_DtoS),
     /* 235986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 235988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 235990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 235992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 235994 */     GIR_RootConstrainSelectedInstOperands,
     /* 235995 */     // GIR_Coverage, 2864,
     /* 235995 */     GIR_EraseRootFromParent_Done,
     /* 235996 */   // Label 4482: @235996
     /* 235996 */   GIM_Try, /*On fail goto*//*Label 4483*/ GIMT_Encode4(236038), // Rule ID 2865 //
     /* 236001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236025 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1373:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FADDP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_H),
     /* 236028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236036 */     GIR_RootConstrainSelectedInstOperands,
     /* 236037 */     // GIR_Coverage, 2865,
     /* 236037 */     GIR_EraseRootFromParent_Done,
     /* 236038 */   // Label 4483: @236038
     /* 236038 */   GIM_Try, /*On fail goto*//*Label 4484*/ GIMT_Encode4(236080), // Rule ID 2866 //
     /* 236043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236067 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1373:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FADDP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_S),
     /* 236070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236078 */     GIR_RootConstrainSelectedInstOperands,
     /* 236079 */     // GIR_Coverage, 2866,
     /* 236079 */     GIR_EraseRootFromParent_Done,
     /* 236080 */   // Label 4484: @236080
     /* 236080 */   GIM_Try, /*On fail goto*//*Label 4485*/ GIMT_Encode4(236122), // Rule ID 2867 //
     /* 236085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_faddp),
     /* 236093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236109 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1373:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FADDP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDP_ZPmZZ_D),
     /* 236112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236120 */     GIR_RootConstrainSelectedInstOperands,
     /* 236121 */     // GIR_Coverage, 2867,
     /* 236121 */     GIR_EraseRootFromParent_Done,
     /* 236122 */   // Label 4485: @236122
     /* 236122 */   GIM_Try, /*On fail goto*//*Label 4486*/ GIMT_Encode4(236164), // Rule ID 2878 //
     /* 236127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f16),
     /* 236135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236151 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1395:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoS),
     /* 236154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236162 */     GIR_RootConstrainSelectedInstOperands,
     /* 236163 */     // GIR_Coverage, 2878,
     /* 236163 */     GIR_EraseRootFromParent_Done,
     /* 236164 */   // Label 4486: @236164
     /* 236164 */   GIM_Try, /*On fail goto*//*Label 4487*/ GIMT_Encode4(236206), // Rule ID 2880 //
     /* 236169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f32),
     /* 236177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236193 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1393:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoH),
     /* 236196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236204 */     GIR_RootConstrainSelectedInstOperands,
     /* 236205 */     // GIR_Coverage, 2880,
     /* 236205 */     GIR_EraseRootFromParent_Done,
     /* 236206 */   // Label 4487: @236206
     /* 236206 */   GIM_Try, /*On fail goto*//*Label 4488*/ GIMT_Encode4(236248), // Rule ID 2888 //
     /* 236211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 236228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236235 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1430:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FLOGB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 236235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_H),
     /* 236238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236246 */     GIR_RootConstrainSelectedInstOperands,
     /* 236247 */     // GIR_Coverage, 2888,
     /* 236247 */     GIR_EraseRootFromParent_Done,
     /* 236248 */   // Label 4488: @236248
     /* 236248 */   GIM_Try, /*On fail goto*//*Label 4489*/ GIMT_Encode4(236290), // Rule ID 2889 //
     /* 236253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 236270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236277 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1430:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FLOGB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 236277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_S),
     /* 236280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236288 */     GIR_RootConstrainSelectedInstOperands,
     /* 236289 */     // GIR_Coverage, 2889,
     /* 236289 */     GIR_EraseRootFromParent_Done,
     /* 236290 */   // Label 4489: @236290
     /* 236290 */   GIM_Try, /*On fail goto*//*Label 4490*/ GIMT_Encode4(236332), // Rule ID 2890 //
     /* 236295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_flogb),
     /* 236303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236319 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1430:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FLOGB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FLOGB_ZPmZ_D),
     /* 236322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236330 */     GIR_RootConstrainSelectedInstOperands,
     /* 236331 */     // GIR_Coverage, 2890,
     /* 236331 */     GIR_EraseRootFromParent_Done,
     /* 236332 */   // Label 4490: @236332
     /* 236332 */   GIM_Try, /*On fail goto*//*Label 4491*/ GIMT_Encode4(236374), // Rule ID 2894 //
     /* 236337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtx_f32f64),
     /* 236345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 236354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236361 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1408:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTX_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 236361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTX_ZPmZ_DtoS),
     /* 236364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 236366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236372 */     GIR_RootConstrainSelectedInstOperands,
     /* 236373 */     // GIR_Coverage, 2894,
     /* 236373 */     GIR_EraseRootFromParent_Done,
     /* 236374 */   // Label 4491: @236374
     /* 236374 */   GIM_Try, /*On fail goto*//*Label 4492*/ GIMT_Encode4(236416), // Rule ID 2939 //
     /* 236379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236403 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1713:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_S),
     /* 236406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236414 */     GIR_RootConstrainSelectedInstOperands,
     /* 236415 */     // GIR_Coverage, 2939,
     /* 236415 */     GIR_EraseRootFromParent_Done,
     /* 236416 */   // Label 4492: @236416
     /* 236416 */   GIM_Try, /*On fail goto*//*Label 4493*/ GIMT_Encode4(236458), // Rule ID 2940 //
     /* 236421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 236424 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdiv),
     /* 236429 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236432 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236435 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236438 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236441 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236445 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1713:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIV_ZPmZ_D),
     /* 236448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236450 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236454 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236456 */     GIR_RootConstrainSelectedInstOperands,
     /* 236457 */     // GIR_Coverage, 2940,
     /* 236457 */     GIR_EraseRootFromParent_Done,
     /* 236458 */   // Label 4493: @236458
     /* 236458 */   GIM_Try, /*On fail goto*//*Label 4494*/ GIMT_Encode4(236500), // Rule ID 2969 //
     /* 236463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236466 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236471 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236474 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 236477 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236480 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236483 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236487 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1829:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLAH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_B),
     /* 236490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236496 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236498 */     GIR_RootConstrainSelectedInstOperands,
     /* 236499 */     // GIR_Coverage, 2969,
     /* 236499 */     GIR_EraseRootFromParent_Done,
     /* 236500 */   // Label 4494: @236500
     /* 236500 */   GIM_Try, /*On fail goto*//*Label 4495*/ GIMT_Encode4(236542), // Rule ID 2970 //
     /* 236505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236529 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1829:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLAH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_H),
     /* 236532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236540 */     GIR_RootConstrainSelectedInstOperands,
     /* 236541 */     // GIR_Coverage, 2970,
     /* 236541 */     GIR_EraseRootFromParent_Done,
     /* 236542 */   // Label 4495: @236542
     /* 236542 */   GIM_Try, /*On fail goto*//*Label 4496*/ GIMT_Encode4(236584), // Rule ID 2971 //
     /* 236547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236571 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1829:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLAH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_S),
     /* 236574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236582 */     GIR_RootConstrainSelectedInstOperands,
     /* 236583 */     // GIR_Coverage, 2971,
     /* 236583 */     GIR_EraseRootFromParent_Done,
     /* 236584 */   // Label 4496: @236584
     /* 236584 */   GIM_Try, /*On fail goto*//*Label 4497*/ GIMT_Encode4(236626), // Rule ID 2972 //
     /* 236589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah),
     /* 236597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236613 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1829:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLAH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZ_D),
     /* 236616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236624 */     GIR_RootConstrainSelectedInstOperands,
     /* 236625 */     // GIR_Coverage, 2972,
     /* 236625 */     GIR_EraseRootFromParent_Done,
     /* 236626 */   // Label 4497: @236626
     /* 236626 */   GIM_Try, /*On fail goto*//*Label 4498*/ GIMT_Encode4(236668), // Rule ID 2973 //
     /* 236631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 236645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236655 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1750:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_H),
     /* 236658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236666 */     GIR_RootConstrainSelectedInstOperands,
     /* 236667 */     // GIR_Coverage, 2973,
     /* 236667 */     GIR_EraseRootFromParent_Done,
     /* 236668 */   // Label 4498: @236668
     /* 236668 */   GIM_Try, /*On fail goto*//*Label 4499*/ GIMT_Encode4(236710), // Rule ID 2974 //
     /* 236673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 236687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236697 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1750:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_S),
     /* 236700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236708 */     GIR_RootConstrainSelectedInstOperands,
     /* 236709 */     // GIR_Coverage, 2974,
     /* 236709 */     GIR_EraseRootFromParent_Done,
     /* 236710 */   // Label 4499: @236710
     /* 236710 */   GIM_Try, /*On fail goto*//*Label 4500*/ GIMT_Encode4(236752), // Rule ID 2975 //
     /* 236715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb),
     /* 236723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 236729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236739 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1750:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZ_D),
     /* 236742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236750 */     GIR_RootConstrainSelectedInstOperands,
     /* 236751 */     // GIR_Coverage, 2975,
     /* 236751 */     GIR_EraseRootFromParent_Done,
     /* 236752 */   // Label 4500: @236752
     /* 236752 */   GIM_Try, /*On fail goto*//*Label 4501*/ GIMT_Encode4(236794), // Rule ID 3005 //
     /* 236757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 236768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 236771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 236774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236781 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1724:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_B),
     /* 236784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236792 */     GIR_RootConstrainSelectedInstOperands,
     /* 236793 */     // GIR_Coverage, 3005,
     /* 236793 */     GIR_EraseRootFromParent_Done,
     /* 236794 */   // Label 4501: @236794
     /* 236794 */   GIM_Try, /*On fail goto*//*Label 4502*/ GIMT_Encode4(236836), // Rule ID 3007 //
     /* 236799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236823 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1724:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_H),
     /* 236826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236834 */     GIR_RootConstrainSelectedInstOperands,
     /* 236835 */     // GIR_Coverage, 3007,
     /* 236835 */     GIR_EraseRootFromParent_Done,
     /* 236836 */   // Label 4502: @236836
     /* 236836 */   GIM_Try, /*On fail goto*//*Label 4503*/ GIMT_Encode4(236878), // Rule ID 3009 //
     /* 236841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 236861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236865 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1724:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 236865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_S),
     /* 236868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236876 */     GIR_RootConstrainSelectedInstOperands,
     /* 236877 */     // GIR_Coverage, 3009,
     /* 236877 */     GIR_EraseRootFromParent_Done,
     /* 236878 */   // Label 4503: @236878
     /* 236878 */   GIM_Try, /*On fail goto*//*Label 4504*/ GIMT_Encode4(236920), // Rule ID 3011 //
     /* 236883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shadd),
     /* 236891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 236894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 236897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 236900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 236903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236907 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1724:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 236907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHADD_ZPmZ_D),
     /* 236910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 236912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236918 */     GIR_RootConstrainSelectedInstOperands,
     /* 236919 */     // GIR_Coverage, 3011,
     /* 236919 */     GIR_EraseRootFromParent_Done,
     /* 236920 */   // Label 4504: @236920
     /* 236920 */   GIM_Try, /*On fail goto*//*Label 4505*/ GIMT_Encode4(236962), // Rule ID 3013 //
     /* 236925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 236933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 236936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 236939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 236942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 236945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236949 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1694:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 236949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_H),
     /* 236952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 236958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 236960 */     GIR_RootConstrainSelectedInstOperands,
     /* 236961 */     // GIR_Coverage, 3013,
     /* 236961 */     GIR_EraseRootFromParent_Done,
     /* 236962 */   // Label 4505: @236962
     /* 236962 */   GIM_Try, /*On fail goto*//*Label 4506*/ GIMT_Encode4(237004), // Rule ID 3014 //
     /* 236967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 236970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 236975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 236978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 236981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 236984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 236987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 236991 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1694:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 236991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_S),
     /* 236994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 236996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 236998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237002 */     GIR_RootConstrainSelectedInstOperands,
     /* 237003 */     // GIR_Coverage, 3014,
     /* 237003 */     GIR_EraseRootFromParent_Done,
     /* 237004 */   // Label 4506: @237004
     /* 237004 */   GIM_Try, /*On fail goto*//*Label 4507*/ GIMT_Encode4(237046), // Rule ID 3015 //
     /* 237009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sadalp),
     /* 237017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 237023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237033 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1694:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADALP_ZPmZ_D),
     /* 237036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237044 */     GIR_RootConstrainSelectedInstOperands,
     /* 237045 */     // GIR_Coverage, 3015,
     /* 237045 */     GIR_EraseRootFromParent_Done,
     /* 237046 */   // Label 4507: @237046
     /* 237046 */   GIM_Try, /*On fail goto*//*Label 4508*/ GIMT_Encode4(237088), // Rule ID 3016 //
     /* 237051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urecpe),
     /* 237059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2053:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URECPE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URECPE_ZPmZ_S),
     /* 237078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237086 */     GIR_RootConstrainSelectedInstOperands,
     /* 237087 */     // GIR_Coverage, 3016,
     /* 237087 */     GIR_EraseRootFromParent_Done,
     /* 237088 */   // Label 4508: @237088
     /* 237088 */   GIM_Try, /*On fail goto*//*Label 4509*/ GIMT_Encode4(237130), // Rule ID 3017 //
     /* 237093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237117 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1766:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQABS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_B),
     /* 237120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237128 */     GIR_RootConstrainSelectedInstOperands,
     /* 237129 */     // GIR_Coverage, 3017,
     /* 237129 */     GIR_EraseRootFromParent_Done,
     /* 237130 */   // Label 4509: @237130
     /* 237130 */   GIM_Try, /*On fail goto*//*Label 4510*/ GIMT_Encode4(237172), // Rule ID 3018 //
     /* 237135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1766:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQABS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_H),
     /* 237162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237170 */     GIR_RootConstrainSelectedInstOperands,
     /* 237171 */     // GIR_Coverage, 3018,
     /* 237171 */     GIR_EraseRootFromParent_Done,
     /* 237172 */   // Label 4510: @237172
     /* 237172 */   GIM_Try, /*On fail goto*//*Label 4511*/ GIMT_Encode4(237214), // Rule ID 3019 //
     /* 237177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 237194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1766:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQABS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_S),
     /* 237204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237212 */     GIR_RootConstrainSelectedInstOperands,
     /* 237213 */     // GIR_Coverage, 3019,
     /* 237213 */     GIR_EraseRootFromParent_Done,
     /* 237214 */   // Label 4511: @237214
     /* 237214 */   GIM_Try, /*On fail goto*//*Label 4512*/ GIMT_Encode4(237256), // Rule ID 3020 //
     /* 237219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqabs),
     /* 237227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 237236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237243 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1766:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQABS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQABS_ZPmZ_D),
     /* 237246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237254 */     GIR_RootConstrainSelectedInstOperands,
     /* 237255 */     // GIR_Coverage, 3020,
     /* 237255 */     GIR_EraseRootFromParent_Done,
     /* 237256 */   // Label 4512: @237256
     /* 237256 */   GIM_Try, /*On fail goto*//*Label 4513*/ GIMT_Encode4(237298), // Rule ID 3037 //
     /* 237261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237285 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1359:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORBT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_B),
     /* 237288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237296 */     GIR_RootConstrainSelectedInstOperands,
     /* 237297 */     // GIR_Coverage, 3037,
     /* 237297 */     GIR_EraseRootFromParent_Done,
     /* 237298 */   // Label 4513: @237298
     /* 237298 */   GIM_Try, /*On fail goto*//*Label 4514*/ GIMT_Encode4(237340), // Rule ID 3038 //
     /* 237303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237327 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1359:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_H),
     /* 237330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237338 */     GIR_RootConstrainSelectedInstOperands,
     /* 237339 */     // GIR_Coverage, 3038,
     /* 237339 */     GIR_EraseRootFromParent_Done,
     /* 237340 */   // Label 4514: @237340
     /* 237340 */   GIM_Try, /*On fail goto*//*Label 4515*/ GIMT_Encode4(237382), // Rule ID 3039 //
     /* 237345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237369 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1359:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_S),
     /* 237372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237380 */     GIR_RootConstrainSelectedInstOperands,
     /* 237381 */     // GIR_Coverage, 3039,
     /* 237381 */     GIR_EraseRootFromParent_Done,
     /* 237382 */   // Label 4515: @237382
     /* 237382 */   GIM_Try, /*On fail goto*//*Label 4516*/ GIMT_Encode4(237424), // Rule ID 3040 //
     /* 237387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eorbt),
     /* 237395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237411 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1359:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORBT_ZZZ_D),
     /* 237414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237422 */     GIR_RootConstrainSelectedInstOperands,
     /* 237423 */     // GIR_Coverage, 3040,
     /* 237423 */     GIR_EraseRootFromParent_Done,
     /* 237424 */   // Label 4516: @237424
     /* 237424 */   GIM_Try, /*On fail goto*//*Label 4517*/ GIMT_Encode4(237466), // Rule ID 3064 //
     /* 237429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237453 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1687:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_B),
     /* 237456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237464 */     GIR_RootConstrainSelectedInstOperands,
     /* 237465 */     // GIR_Coverage, 3064,
     /* 237465 */     GIR_EraseRootFromParent_Done,
     /* 237466 */   // Label 4517: @237466
     /* 237466 */   GIM_Try, /*On fail goto*//*Label 4518*/ GIMT_Encode4(237508), // Rule ID 3066 //
     /* 237471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237495 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1687:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_H),
     /* 237498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237506 */     GIR_RootConstrainSelectedInstOperands,
     /* 237507 */     // GIR_Coverage, 3066,
     /* 237507 */     GIR_EraseRootFromParent_Done,
     /* 237508 */   // Label 4518: @237508
     /* 237508 */   GIM_Try, /*On fail goto*//*Label 4519*/ GIMT_Encode4(237550), // Rule ID 3068 //
     /* 237513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237537 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1687:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_S),
     /* 237540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237548 */     GIR_RootConstrainSelectedInstOperands,
     /* 237549 */     // GIR_Coverage, 3068,
     /* 237549 */     GIR_EraseRootFromParent_Done,
     /* 237550 */   // Label 4519: @237550
     /* 237550 */   GIM_Try, /*On fail goto*//*Label 4520*/ GIMT_Encode4(237592), // Rule ID 3070 //
     /* 237555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_saba),
     /* 237563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237579 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1687:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABA_ZZZ_D),
     /* 237582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237590 */     GIR_RootConstrainSelectedInstOperands,
     /* 237591 */     // GIR_Coverage, 3070,
     /* 237591 */     GIR_EraseRootFromParent_Done,
     /* 237592 */   // Label 4520: @237592
     /* 237592 */   GIM_Try, /*On fail goto*//*Label 4521*/ GIMT_Encode4(237634), // Rule ID 3072 //
     /* 237597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 237614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237621 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1688:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 237621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_H),
     /* 237624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237632 */     GIR_RootConstrainSelectedInstOperands,
     /* 237633 */     // GIR_Coverage, 3072,
     /* 237633 */     GIR_EraseRootFromParent_Done,
     /* 237634 */   // Label 4521: @237634
     /* 237634 */   GIM_Try, /*On fail goto*//*Label 4522*/ GIMT_Encode4(237676), // Rule ID 3073 //
     /* 237639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237663 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1688:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_S),
     /* 237666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237674 */     GIR_RootConstrainSelectedInstOperands,
     /* 237675 */     // GIR_Coverage, 3073,
     /* 237675 */     GIR_EraseRootFromParent_Done,
     /* 237676 */   // Label 4522: @237676
     /* 237676 */   GIM_Try, /*On fail goto*//*Label 4523*/ GIMT_Encode4(237718), // Rule ID 3074 //
     /* 237681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalb),
     /* 237689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237705 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1688:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALB_ZZZ_D),
     /* 237708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237716 */     GIR_RootConstrainSelectedInstOperands,
     /* 237717 */     // GIR_Coverage, 3074,
     /* 237717 */     GIR_EraseRootFromParent_Done,
     /* 237718 */   // Label 4523: @237718
     /* 237718 */   GIM_Try, /*On fail goto*//*Label 4524*/ GIMT_Encode4(237760), // Rule ID 3075 //
     /* 237723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1251:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_S),
     /* 237750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237758 */     GIR_RootConstrainSelectedInstOperands,
     /* 237759 */     // GIR_Coverage, 3075,
     /* 237759 */     GIR_EraseRootFromParent_Done,
     /* 237760 */   // Label 4524: @237760
     /* 237760 */   GIM_Try, /*On fail goto*//*Label 4525*/ GIMT_Encode4(237802), // Rule ID 3076 //
     /* 237765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclb),
     /* 237773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 237776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 237779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237789 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1251:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLB_ZZZ_D),
     /* 237792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 237794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237800 */     GIR_RootConstrainSelectedInstOperands,
     /* 237801 */     // GIR_Coverage, 3076,
     /* 237801 */     GIR_EraseRootFromParent_Done,
     /* 237802 */   // Label 4525: @237802
     /* 237802 */   GIM_Try, /*On fail goto*//*Label 4526*/ GIMT_Encode4(237844), // Rule ID 3086 //
     /* 237807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 237824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237831 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1258:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 237831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_B),
     /* 237834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237842 */     GIR_RootConstrainSelectedInstOperands,
     /* 237843 */     // GIR_Coverage, 3086,
     /* 237843 */     GIR_EraseRootFromParent_Done,
     /* 237844 */   // Label 4526: @237844
     /* 237844 */   GIM_Try, /*On fail goto*//*Label 4527*/ GIMT_Encode4(237886), // Rule ID 3087 //
     /* 237849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 237866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 237869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237873 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1258:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 237873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_H),
     /* 237876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237884 */     GIR_RootConstrainSelectedInstOperands,
     /* 237885 */     // GIR_Coverage, 3087,
     /* 237885 */     GIR_EraseRootFromParent_Done,
     /* 237886 */   // Label 4527: @237886
     /* 237886 */   GIM_Try, /*On fail goto*//*Label 4528*/ GIMT_Encode4(237928), // Rule ID 3088 //
     /* 237891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 237894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addhnt),
     /* 237899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 237902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 237905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 237908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 237911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237915 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1258:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 237915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNT_ZZZ_S),
     /* 237918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 237922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 237924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 237926 */     GIR_RootConstrainSelectedInstOperands,
     /* 237927 */     // GIR_Coverage, 3088,
     /* 237927 */     GIR_EraseRootFromParent_Done,
     /* 237928 */   // Label 4528: @237928
     /* 237928 */   GIM_Try, /*On fail goto*//*Label 4529*/ GIMT_Encode4(237970), // Rule ID 3105 //
     /* 237933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 237941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 237944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 237947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 237950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 237953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237957 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1317:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CLS_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 237957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_B),
     /* 237960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 237962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 237964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 237966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 237968 */     GIR_RootConstrainSelectedInstOperands,
     /* 237969 */     // GIR_Coverage, 3105,
     /* 237969 */     GIR_EraseRootFromParent_Done,
     /* 237970 */   // Label 4529: @237970
     /* 237970 */   GIM_Try, /*On fail goto*//*Label 4530*/ GIMT_Encode4(238012), // Rule ID 3106 //
     /* 237975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 237978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 237983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 237986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 237989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 237992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 237995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 237999 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1317:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CLS_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 237999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_H),
     /* 238002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238010 */     GIR_RootConstrainSelectedInstOperands,
     /* 238011 */     // GIR_Coverage, 3106,
     /* 238011 */     GIR_EraseRootFromParent_Done,
     /* 238012 */   // Label 4530: @238012
     /* 238012 */   GIM_Try, /*On fail goto*//*Label 4531*/ GIMT_Encode4(238054), // Rule ID 3107 //
     /* 238017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 238034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238041 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1317:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CLS_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 238041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_S),
     /* 238044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238052 */     GIR_RootConstrainSelectedInstOperands,
     /* 238053 */     // GIR_Coverage, 3107,
     /* 238053 */     GIR_EraseRootFromParent_Done,
     /* 238054 */   // Label 4531: @238054
     /* 238054 */   GIM_Try, /*On fail goto*//*Label 4532*/ GIMT_Encode4(238096), // Rule ID 3108 //
     /* 238059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cls),
     /* 238067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 238076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238083 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1317:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CLS_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 238083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLS_ZPmZ_D),
     /* 238086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 238088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 238090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 238092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 238094 */     GIR_RootConstrainSelectedInstOperands,
     /* 238095 */     // GIR_Coverage, 3108,
     /* 238095 */     GIR_EraseRootFromParent_Done,
     /* 238096 */   // Label 4532: @238096
     /* 238096 */   GIM_Try, /*On fail goto*//*Label 4533*/ GIMT_Encode4(238138), // Rule ID 3143 //
     /* 238101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 238115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238125 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1358:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238136 */     GIR_RootConstrainSelectedInstOperands,
     /* 238137 */     // GIR_Coverage, 3143,
     /* 238137 */     GIR_EraseRootFromParent_Done,
     /* 238138 */   // Label 4533: @238138
     /* 238138 */   GIM_Try, /*On fail goto*//*Label 4534*/ GIMT_Encode4(238180), // Rule ID 3145 //
     /* 238143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 238157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238167 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1358:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238178 */     GIR_RootConstrainSelectedInstOperands,
     /* 238179 */     // GIR_Coverage, 3145,
     /* 238179 */     GIR_EraseRootFromParent_Done,
     /* 238180 */   // Label 4534: @238180
     /* 238180 */   GIM_Try, /*On fail goto*//*Label 4535*/ GIMT_Encode4(238222), // Rule ID 3147 //
     /* 238185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 238199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238209 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1358:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238220 */     GIR_RootConstrainSelectedInstOperands,
     /* 238221 */     // GIR_Coverage, 3147,
     /* 238221 */     GIR_EraseRootFromParent_Done,
     /* 238222 */   // Label 4535: @238222
     /* 238222 */   GIM_Try, /*On fail goto*//*Label 4536*/ GIMT_Encode4(238264), // Rule ID 3149 //
     /* 238227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 238230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor3),
     /* 238235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 238241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238251 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1358:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EOR3_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR3_ZZZZ),
     /* 238254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238262 */     GIR_RootConstrainSelectedInstOperands,
     /* 238263 */     // GIR_Coverage, 3149,
     /* 238263 */     GIR_EraseRootFromParent_Done,
     /* 238264 */   // Label 4536: @238264
     /* 238264 */   GIM_Try, /*On fail goto*//*Label 4537*/ GIMT_Encode4(238309), // Rule ID 3188 //
     /* 238269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238293 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1322:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_B),
     /* 238296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238304 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238307 */     GIR_RootConstrainSelectedInstOperands,
     /* 238308 */     // GIR_Coverage, 3188,
     /* 238308 */     GIR_EraseRootFromParent_Done,
     /* 238309 */   // Label 4537: @238309
     /* 238309 */   GIM_Try, /*On fail goto*//*Label 4538*/ GIMT_Encode4(238354), // Rule ID 3189 //
     /* 238314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238338 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1322:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238338 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_H),
     /* 238341 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238343 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238347 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238349 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238352 */     GIR_RootConstrainSelectedInstOperands,
     /* 238353 */     // GIR_Coverage, 3189,
     /* 238353 */     GIR_EraseRootFromParent_Done,
     /* 238354 */   // Label 4538: @238354
     /* 238354 */   GIM_Try, /*On fail goto*//*Label 4539*/ GIMT_Encode4(238399), // Rule ID 3190 //
     /* 238359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpeq_wide),
     /* 238367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238383 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1322:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPEQ_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_WIDE_PPzZZ_S),
     /* 238386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238394 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238397 */     GIR_RootConstrainSelectedInstOperands,
     /* 238398 */     // GIR_Coverage, 3190,
     /* 238398 */     GIR_EraseRootFromParent_Done,
     /* 238399 */   // Label 4539: @238399
     /* 238399 */   GIM_Try, /*On fail goto*//*Label 4540*/ GIMT_Encode4(238444), // Rule ID 3191 //
     /* 238404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238407 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238412 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 238415 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238418 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238421 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238424 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238428 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1324:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238428 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_B),
     /* 238431 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238433 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238437 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238439 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238442 */     GIR_RootConstrainSelectedInstOperands,
     /* 238443 */     // GIR_Coverage, 3191,
     /* 238443 */     GIR_EraseRootFromParent_Done,
     /* 238444 */   // Label 4540: @238444
     /* 238444 */   GIM_Try, /*On fail goto*//*Label 4541*/ GIMT_Encode4(238489), // Rule ID 3192 //
     /* 238449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238452 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238457 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238460 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238463 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238466 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238469 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238473 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1324:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_H),
     /* 238476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238478 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238480 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238482 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238484 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238487 */     GIR_RootConstrainSelectedInstOperands,
     /* 238488 */     // GIR_Coverage, 3192,
     /* 238488 */     GIR_EraseRootFromParent_Done,
     /* 238489 */   // Label 4541: @238489
     /* 238489 */   GIM_Try, /*On fail goto*//*Label 4542*/ GIMT_Encode4(238534), // Rule ID 3193 //
     /* 238494 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238497 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpge_wide),
     /* 238502 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238505 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238508 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238511 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238514 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238518 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1324:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238518 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGE_WIDE_PPzZZ_S),
     /* 238521 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238523 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238525 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238527 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238529 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 238532 */     GIR_RootConstrainSelectedInstOperands,
     /* 238533 */     // GIR_Coverage, 3193,
     /* 238533 */     GIR_EraseRootFromParent_Done,
     /* 238534 */   // Label 4542: @238534
     /* 238534 */   GIM_Try, /*On fail goto*//*Label 4543*/ GIMT_Encode4(238576), // Rule ID 3248 //
     /* 238539 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238542 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238547 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 238550 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238553 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238556 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238563 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1368:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGE_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 238563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_H),
     /* 238566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238572 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238574 */     GIR_RootConstrainSelectedInstOperands,
     /* 238575 */     // GIR_Coverage, 3248,
     /* 238575 */     GIR_EraseRootFromParent_Done,
     /* 238576 */   // Label 4543: @238576
     /* 238576 */   GIM_Try, /*On fail goto*//*Label 4544*/ GIMT_Encode4(238618), // Rule ID 3249 //
     /* 238581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238584 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238589 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 238592 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238595 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238598 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238605 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1368:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGE_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 238605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_S),
     /* 238608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238616 */     GIR_RootConstrainSelectedInstOperands,
     /* 238617 */     // GIR_Coverage, 3249,
     /* 238617 */     GIR_EraseRootFromParent_Done,
     /* 238618 */   // Label 4544: @238618
     /* 238618 */   GIM_Try, /*On fail goto*//*Label 4545*/ GIMT_Encode4(238660), // Rule ID 3250 //
     /* 238623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238626 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facge),
     /* 238631 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 238634 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238637 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238640 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238643 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 238647 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1368:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGE_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 238647 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGE_PPzZZ_D),
     /* 238650 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 238652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238656 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238658 */     GIR_RootConstrainSelectedInstOperands,
     /* 238659 */     // GIR_Coverage, 3250,
     /* 238659 */     GIR_EraseRootFromParent_Done,
     /* 238660 */   // Label 4545: @238660
     /* 238660 */   GIM_Try, /*On fail goto*//*Label 4546*/ GIMT_Encode4(238702), // Rule ID 3302 //
     /* 238665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238668 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238673 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238676 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238679 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238682 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238685 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238689 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1274:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ASR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_B),
     /* 238692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238694 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238698 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238700 */     GIR_RootConstrainSelectedInstOperands,
     /* 238701 */     // GIR_Coverage, 3302,
     /* 238701 */     GIR_EraseRootFromParent_Done,
     /* 238702 */   // Label 4546: @238702
     /* 238702 */   GIM_Try, /*On fail goto*//*Label 4547*/ GIMT_Encode4(238744), // Rule ID 3303 //
     /* 238707 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238710 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238715 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238718 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238721 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238724 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 238727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238731 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1274:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ASR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 238731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_H),
     /* 238734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238740 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238742 */     GIR_RootConstrainSelectedInstOperands,
     /* 238743 */     // GIR_Coverage, 3303,
     /* 238743 */     GIR_EraseRootFromParent_Done,
     /* 238744 */   // Label 4547: @238744
     /* 238744 */   GIM_Try, /*On fail goto*//*Label 4548*/ GIMT_Encode4(238786), // Rule ID 3304 //
     /* 238749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238752 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238757 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238760 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238763 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238766 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 238769 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238773 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1274:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ASR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 238773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_S),
     /* 238776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238778 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238780 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238782 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238784 */     GIR_RootConstrainSelectedInstOperands,
     /* 238785 */     // GIR_Coverage, 3304,
     /* 238785 */     GIR_EraseRootFromParent_Done,
     /* 238786 */   // Label 4548: @238786
     /* 238786 */   GIM_Try, /*On fail goto*//*Label 4549*/ GIMT_Encode4(238828), // Rule ID 3305 //
     /* 238791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238794 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr),
     /* 238799 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 238802 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 238805 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 238808 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238811 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238815 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1274:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238815 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_ZPmZ_D),
     /* 238818 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238820 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238822 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238824 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238826 */     GIR_RootConstrainSelectedInstOperands,
     /* 238827 */     // GIR_Coverage, 3305,
     /* 238827 */     GIR_EraseRootFromParent_Done,
     /* 238828 */   // Label 4549: @238828
     /* 238828 */   GIM_Try, /*On fail goto*//*Label 4550*/ GIMT_Encode4(238870), // Rule ID 3314 //
     /* 238833 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238836 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238841 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238850 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238853 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238857 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1276:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238857 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_B),
     /* 238860 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238862 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238864 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238866 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238868 */     GIR_RootConstrainSelectedInstOperands,
     /* 238869 */     // GIR_Coverage, 3314,
     /* 238869 */     GIR_EraseRootFromParent_Done,
     /* 238870 */   // Label 4550: @238870
     /* 238870 */   GIM_Try, /*On fail goto*//*Label 4551*/ GIMT_Encode4(238912), // Rule ID 3315 //
     /* 238875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 238886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 238889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 238892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238899 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1276:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_H),
     /* 238902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238910 */     GIR_RootConstrainSelectedInstOperands,
     /* 238911 */     // GIR_Coverage, 3315,
     /* 238911 */     GIR_EraseRootFromParent_Done,
     /* 238912 */   // Label 4551: @238912
     /* 238912 */   GIM_Try, /*On fail goto*//*Label 4552*/ GIMT_Encode4(238954), // Rule ID 3316 //
     /* 238917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_asr_wide),
     /* 238925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 238928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 238931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 238934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 238937 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238941 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1276:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ASR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 238941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASR_WIDE_ZPmZ_S),
     /* 238944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238946 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238948 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238950 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238952 */     GIR_RootConstrainSelectedInstOperands,
     /* 238953 */     // GIR_Coverage, 3316,
     /* 238953 */     GIR_EraseRootFromParent_Done,
     /* 238954 */   // Label 4552: @238954
     /* 238954 */   GIM_Try, /*On fail goto*//*Label 4553*/ GIMT_Encode4(238996), // Rule ID 3355 //
     /* 238959 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 238962 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 238967 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 238970 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 238973 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 238976 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 238979 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 238983 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1313:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTA_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 238983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_B),
     /* 238986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 238988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 238990 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 238992 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 238994 */     GIR_RootConstrainSelectedInstOperands,
     /* 238995 */     // GIR_Coverage, 3355,
     /* 238995 */     GIR_EraseRootFromParent_Done,
     /* 238996 */   // Label 4553: @238996
     /* 238996 */   GIM_Try, /*On fail goto*//*Label 4554*/ GIMT_Encode4(239038), // Rule ID 3356 //
     /* 239001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239025 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239025 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239028 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239030 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239032 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239034 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239036 */     GIR_RootConstrainSelectedInstOperands,
     /* 239037 */     // GIR_Coverage, 3356,
     /* 239037 */     GIR_EraseRootFromParent_Done,
     /* 239038 */   // Label 4554: @239038
     /* 239038 */   GIM_Try, /*On fail goto*//*Label 4555*/ GIMT_Encode4(239080), // Rule ID 3357 //
     /* 239043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239046 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239051 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239054 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239057 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239060 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239063 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239067 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239072 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239074 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239076 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239078 */     GIR_RootConstrainSelectedInstOperands,
     /* 239079 */     // GIR_Coverage, 3357,
     /* 239079 */     GIR_EraseRootFromParent_Done,
     /* 239080 */   // Label 4555: @239080
     /* 239080 */   GIM_Try, /*On fail goto*//*Label 4556*/ GIMT_Encode4(239122), // Rule ID 3358 //
     /* 239085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239088 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239093 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239096 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239099 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239102 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239109 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239120 */     GIR_RootConstrainSelectedInstOperands,
     /* 239121 */     // GIR_Coverage, 3358,
     /* 239121 */     GIR_EraseRootFromParent_Done,
     /* 239122 */   // Label 4556: @239122
     /* 239122 */   GIM_Try, /*On fail goto*//*Label 4557*/ GIMT_Encode4(239164), // Rule ID 3359 //
     /* 239127 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239130 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239135 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239144 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239151 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1313:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTA_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_H),
     /* 239154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239158 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239160 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239162 */     GIR_RootConstrainSelectedInstOperands,
     /* 239163 */     // GIR_Coverage, 3359,
     /* 239163 */     GIR_EraseRootFromParent_Done,
     /* 239164 */   // Label 4557: @239164
     /* 239164 */   GIM_Try, /*On fail goto*//*Label 4558*/ GIMT_Encode4(239206), // Rule ID 3360 //
     /* 239169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239172 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239177 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239180 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239183 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239186 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239189 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239193 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1313:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTA_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239193 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_S),
     /* 239196 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239198 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239200 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239202 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239204 */     GIR_RootConstrainSelectedInstOperands,
     /* 239205 */     // GIR_Coverage, 3360,
     /* 239205 */     GIR_EraseRootFromParent_Done,
     /* 239206 */   // Label 4558: @239206
     /* 239206 */   GIM_Try, /*On fail goto*//*Label 4559*/ GIMT_Encode4(239248), // Rule ID 3361 //
     /* 239211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clasta),
     /* 239219 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239222 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239225 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239228 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239231 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239235 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1313:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTA_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTA_ZPZ_D),
     /* 239238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239242 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239244 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239246 */     GIR_RootConstrainSelectedInstOperands,
     /* 239247 */     // GIR_Coverage, 3361,
     /* 239247 */     GIR_EraseRootFromParent_Done,
     /* 239248 */   // Label 4559: @239248
     /* 239248 */   GIM_Try, /*On fail goto*//*Label 4560*/ GIMT_Encode4(239290), // Rule ID 3444 //
     /* 239253 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239256 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpa_z),
     /* 239261 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239264 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239267 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239270 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239277 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1305:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPA_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPA_PPzPP),
     /* 239280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239282 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239284 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239286 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239288 */     GIR_RootConstrainSelectedInstOperands,
     /* 239289 */     // GIR_Coverage, 3444,
     /* 239289 */     GIR_EraseRootFromParent_Done,
     /* 239290 */   // Label 4560: @239290
     /* 239290 */   GIM_Try, /*On fail goto*//*Label 4561*/ GIMT_Encode4(239332), // Rule ID 3445 //
     /* 239295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239298 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkn_z),
     /* 239303 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239319 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1304:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKN_PPzP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKN_PPzP),
     /* 239322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pdm]
     /* 239324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239330 */     GIR_RootConstrainSelectedInstOperands,
     /* 239331 */     // GIR_Coverage, 3445,
     /* 239331 */     GIR_EraseRootFromParent_Done,
     /* 239332 */   // Label 4561: @239332
     /* 239332 */   GIM_Try, /*On fail goto*//*Label 4562*/ GIMT_Encode4(239374), // Rule ID 3446 //
     /* 239337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239340 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brka),
     /* 239345 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239348 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239351 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 239354 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 239357 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239361 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1300:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKA_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 239361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKA_PPmP),
     /* 239364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239366 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239368 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239370 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239372 */     GIR_RootConstrainSelectedInstOperands,
     /* 239373 */     // GIR_Coverage, 3446,
     /* 239373 */     GIR_EraseRootFromParent_Done,
     /* 239374 */   // Label 4562: @239374
     /* 239374 */   GIM_Try, /*On fail goto*//*Label 4563*/ GIMT_Encode4(239419), // Rule ID 3448 //
     /* 239379 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239382 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239387 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 239390 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239393 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239396 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239403 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1607:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (MATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_B),
     /* 239406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239410 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239412 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239414 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239417 */     GIR_RootConstrainSelectedInstOperands,
     /* 239418 */     // GIR_Coverage, 3448,
     /* 239418 */     GIR_EraseRootFromParent_Done,
     /* 239419 */   // Label 4563: @239419
     /* 239419 */   GIM_Try, /*On fail goto*//*Label 4564*/ GIMT_Encode4(239464), // Rule ID 3449 //
     /* 239424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_match),
     /* 239432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 239435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 239448 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1607:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (MATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MATCH_PPzZZ_H),
     /* 239451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 239453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239455 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239457 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239459 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 239462 */     GIR_RootConstrainSelectedInstOperands,
     /* 239463 */     // GIR_Coverage, 3449,
     /* 239463 */     GIR_EraseRootFromParent_Done,
     /* 239464 */   // Label 4564: @239464
     /* 239464 */   GIM_Try, /*On fail goto*//*Label 4565*/ GIMT_Encode4(239506), // Rule ID 3450 //
     /* 239469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 239483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1552:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (HISTCNT_ZPzZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_S),
     /* 239496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239504 */     GIR_RootConstrainSelectedInstOperands,
     /* 239505 */     // GIR_Coverage, 3450,
     /* 239505 */     GIR_EraseRootFromParent_Done,
     /* 239506 */   // Label 4565: @239506
     /* 239506 */   GIM_Try, /*On fail goto*//*Label 4566*/ GIMT_Encode4(239548), // Rule ID 3451 //
     /* 239511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 239514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_histcnt),
     /* 239519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 239525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1552:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (HISTCNT_ZPzZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HISTCNT_ZPzZZ_D),
     /* 239538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239546 */     GIR_RootConstrainSelectedInstOperands,
     /* 239547 */     // GIR_Coverage, 3451,
     /* 239547 */     GIR_EraseRootFromParent_Done,
     /* 239548 */   // Label 4566: @239548
     /* 239548 */   GIM_Try, /*On fail goto*//*Label 4567*/ GIMT_Encode4(239590), // Rule ID 3455 //
     /* 239553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 239556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smmla),
     /* 239561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239577 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1758:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMMLA_ZZZ),
     /* 239580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239588 */     GIR_RootConstrainSelectedInstOperands,
     /* 239589 */     // GIR_Coverage, 3455,
     /* 239589 */     GIR_EraseRootFromParent_Done,
     /* 239590 */   // Label 4567: @239590
     /* 239590 */   GIM_Try, /*On fail goto*//*Label 4568*/ GIMT_Encode4(239632), // Rule ID 3494 //
     /* 239595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239619 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1381:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCLAMP_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 239619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_H),
     /* 239622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239630 */     GIR_RootConstrainSelectedInstOperands,
     /* 239631 */     // GIR_Coverage, 3494,
     /* 239631 */     GIR_EraseRootFromParent_Done,
     /* 239632 */   // Label 4568: @239632
     /* 239632 */   GIM_Try, /*On fail goto*//*Label 4569*/ GIMT_Encode4(239674), // Rule ID 3496 //
     /* 239637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239661 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1381:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCLAMP_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 239661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_S),
     /* 239664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239672 */     GIR_RootConstrainSelectedInstOperands,
     /* 239673 */     // GIR_Coverage, 3496,
     /* 239673 */     GIR_EraseRootFromParent_Done,
     /* 239674 */   // Label 4569: @239674
     /* 239674 */   GIM_Try, /*On fail goto*//*Label 4570*/ GIMT_Encode4(239716), // Rule ID 3498 //
     /* 239679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fclamp),
     /* 239687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239703 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1381:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCLAMP_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 239703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCLAMP_ZZZ_D),
     /* 239706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239714 */     GIR_RootConstrainSelectedInstOperands,
     /* 239715 */     // GIR_Coverage, 3498,
     /* 239715 */     GIR_EraseRootFromParent_Done,
     /* 239716 */   // Label 4570: @239716
     /* 239716 */   GIM_Try, /*On fail goto*//*Label 4571*/ GIMT_Encode4(239758), // Rule ID 3500 //
     /* 239721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 239724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_x2),
     /* 239729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239745 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1719:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_HtoS),
     /* 239748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 239750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239756 */     GIR_RootConstrainSelectedInstOperands,
     /* 239757 */     // GIR_Coverage, 3500,
     /* 239757 */     GIR_EraseRootFromParent_Done,
     /* 239758 */   // Label 4571: @239758
     /* 239758 */   GIM_Try, /*On fail goto*//*Label 4572*/ GIMT_Encode4(239800), // Rule ID 3627 //
     /* 239763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 239777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239787 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1703:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_B),
     /* 239790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239798 */     GIR_RootConstrainSelectedInstOperands,
     /* 239799 */     // GIR_Coverage, 3627,
     /* 239799 */     GIR_EraseRootFromParent_Done,
     /* 239800 */   // Label 4572: @239800
     /* 239800 */   GIM_Try, /*On fail goto*//*Label 4573*/ GIMT_Encode4(239842), // Rule ID 3629 //
     /* 239805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 239819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239829 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1703:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_H),
     /* 239832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239840 */     GIR_RootConstrainSelectedInstOperands,
     /* 239841 */     // GIR_Coverage, 3629,
     /* 239841 */     GIR_EraseRootFromParent_Done,
     /* 239842 */   // Label 4573: @239842
     /* 239842 */   GIM_Try, /*On fail goto*//*Label 4574*/ GIMT_Encode4(239884), // Rule ID 3631 //
     /* 239847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 239858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 239861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 239864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 239867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239871 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1703:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 239871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_S),
     /* 239874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239882 */     GIR_RootConstrainSelectedInstOperands,
     /* 239883 */     // GIR_Coverage, 3631,
     /* 239883 */     GIR_EraseRootFromParent_Done,
     /* 239884 */   // Label 4574: @239884
     /* 239884 */   GIM_Try, /*On fail goto*//*Label 4575*/ GIMT_Encode4(239926), // Rule ID 3633 //
     /* 239889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 239892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sclamp),
     /* 239897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 239900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 239903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 239906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 239909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239913 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1703:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 239913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCLAMP_ZZZ_D),
     /* 239916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 239918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239924 */     GIR_RootConstrainSelectedInstOperands,
     /* 239925 */     // GIR_Coverage, 3633,
     /* 239925 */     GIR_EraseRootFromParent_Done,
     /* 239926 */   // Label 4575: @239926
     /* 239926 */   GIM_Try, /*On fail goto*//*Label 4576*/ GIMT_Encode4(239968), // Rule ID 7538 //
     /* 239931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 239939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 239942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 239945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 239948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 239951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239955 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1912:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 239955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 239958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 239960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 239962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 239964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 239966 */     GIR_RootConstrainSelectedInstOperands,
     /* 239967 */     // GIR_Coverage, 7538,
     /* 239967 */     GIR_EraseRootFromParent_Done,
     /* 239968 */   // Label 4576: @239968
     /* 239968 */   GIM_Try, /*On fail goto*//*Label 4577*/ GIMT_Encode4(240010), // Rule ID 7540 //
     /* 239973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 239976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 239981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 239984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 239987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 239990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 239993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 239997 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1912:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 239997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 240000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240008 */     GIR_RootConstrainSelectedInstOperands,
     /* 240009 */     // GIR_Coverage, 7540,
     /* 240009 */     GIR_EraseRootFromParent_Done,
     /* 240010 */   // Label 4577: @240010
     /* 240010 */   GIM_Try, /*On fail goto*//*Label 4578*/ GIMT_Encode4(240052), // Rule ID 7542 //
     /* 240015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240039 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1912:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 240042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240050 */     GIR_RootConstrainSelectedInstOperands,
     /* 240051 */     // GIR_Coverage, 7542,
     /* 240051 */     GIR_EraseRootFromParent_Done,
     /* 240052 */   // Label 4578: @240052
     /* 240052 */   GIM_Try, /*On fail goto*//*Label 4579*/ GIMT_Encode4(240094), // Rule ID 7544 //
     /* 240057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subr),
     /* 240065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240081 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1912:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 240084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240092 */     GIR_RootConstrainSelectedInstOperands,
     /* 240093 */     // GIR_Coverage, 7544,
     /* 240093 */     GIR_EraseRootFromParent_Done,
     /* 240094 */   // Label 4579: @240094
     /* 240094 */   GIM_Try, /*On fail goto*//*Label 4580*/ GIMT_Encode4(240136), // Rule ID 7562 //
     /* 240099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240123 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1297:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BIC_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_B),
     /* 240126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240134 */     GIR_RootConstrainSelectedInstOperands,
     /* 240135 */     // GIR_Coverage, 7562,
     /* 240135 */     GIR_EraseRootFromParent_Done,
     /* 240136 */   // Label 4580: @240136
     /* 240136 */   GIM_Try, /*On fail goto*//*Label 4581*/ GIMT_Encode4(240178), // Rule ID 7563 //
     /* 240141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240165 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1297:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BIC_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_H),
     /* 240168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240176 */     GIR_RootConstrainSelectedInstOperands,
     /* 240177 */     // GIR_Coverage, 7563,
     /* 240177 */     GIR_EraseRootFromParent_Done,
     /* 240178 */   // Label 4581: @240178
     /* 240178 */   GIM_Try, /*On fail goto*//*Label 4582*/ GIMT_Encode4(240220), // Rule ID 7564 //
     /* 240183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240207 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1297:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BIC_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_S),
     /* 240210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240218 */     GIR_RootConstrainSelectedInstOperands,
     /* 240219 */     // GIR_Coverage, 7564,
     /* 240219 */     GIR_EraseRootFromParent_Done,
     /* 240220 */   // Label 4582: @240220
     /* 240220 */   GIM_Try, /*On fail goto*//*Label 4583*/ GIMT_Encode4(240262), // Rule ID 7565 //
     /* 240225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic),
     /* 240233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240249 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1297:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BIC_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_ZPmZ_D),
     /* 240252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240260 */     GIR_RootConstrainSelectedInstOperands,
     /* 240261 */     // GIR_Coverage, 7565,
     /* 240261 */     GIR_EraseRootFromParent_Done,
     /* 240262 */   // Label 4583: @240262
     /* 240262 */   GIM_Try, /*On fail goto*//*Label 4584*/ GIMT_Encode4(240304), // Rule ID 7678 //
     /* 240267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240291 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1759:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_B),
     /* 240294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240302 */     GIR_RootConstrainSelectedInstOperands,
     /* 240303 */     // GIR_Coverage, 7678,
     /* 240303 */     GIR_EraseRootFromParent_Done,
     /* 240304 */   // Label 4584: @240304
     /* 240304 */   GIM_Try, /*On fail goto*//*Label 4585*/ GIMT_Encode4(240346), // Rule ID 7679 //
     /* 240309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240333 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1759:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_H),
     /* 240336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240344 */     GIR_RootConstrainSelectedInstOperands,
     /* 240345 */     // GIR_Coverage, 7679,
     /* 240345 */     GIR_EraseRootFromParent_Done,
     /* 240346 */   // Label 4585: @240346
     /* 240346 */   GIM_Try, /*On fail goto*//*Label 4586*/ GIMT_Encode4(240388), // Rule ID 7680 //
     /* 240351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240375 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1759:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_S),
     /* 240378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240386 */     GIR_RootConstrainSelectedInstOperands,
     /* 240387 */     // GIR_Coverage, 7680,
     /* 240387 */     GIR_EraseRootFromParent_Done,
     /* 240388 */   // Label 4586: @240388
     /* 240388 */   GIM_Try, /*On fail goto*//*Label 4587*/ GIMT_Encode4(240430), // Rule ID 7681 //
     /* 240393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smulh),
     /* 240401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240417 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1759:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULH_ZPmZ_D),
     /* 240420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240428 */     GIR_RootConstrainSelectedInstOperands,
     /* 240429 */     // GIR_Coverage, 7681,
     /* 240429 */     GIR_EraseRootFromParent_Done,
     /* 240430 */   // Label 4587: @240430
     /* 240430 */   GIM_Try, /*On fail goto*//*Label 4588*/ GIMT_Encode4(240472), // Rule ID 7682 //
     /* 240435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 240449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 240452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240459 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1997:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMULH_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 240459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_B),
     /* 240462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240470 */     GIR_RootConstrainSelectedInstOperands,
     /* 240471 */     // GIR_Coverage, 7682,
     /* 240471 */     GIR_EraseRootFromParent_Done,
     /* 240472 */   // Label 4588: @240472
     /* 240472 */   GIM_Try, /*On fail goto*//*Label 4589*/ GIMT_Encode4(240514), // Rule ID 7683 //
     /* 240477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 240491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 240494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240501 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1997:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMULH_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 240501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_H),
     /* 240504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240512 */     GIR_RootConstrainSelectedInstOperands,
     /* 240513 */     // GIR_Coverage, 7683,
     /* 240513 */     GIR_EraseRootFromParent_Done,
     /* 240514 */   // Label 4589: @240514
     /* 240514 */   GIM_Try, /*On fail goto*//*Label 4590*/ GIMT_Encode4(240556), // Rule ID 7684 //
     /* 240519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240543 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1997:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMULH_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_S),
     /* 240546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240554 */     GIR_RootConstrainSelectedInstOperands,
     /* 240555 */     // GIR_Coverage, 7684,
     /* 240555 */     GIR_EraseRootFromParent_Done,
     /* 240556 */   // Label 4590: @240556
     /* 240556 */   GIM_Try, /*On fail goto*//*Label 4591*/ GIMT_Encode4(240598), // Rule ID 7685 //
     /* 240561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umulh),
     /* 240569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240585 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1997:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMULH_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULH_ZPmZ_D),
     /* 240588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240596 */     GIR_RootConstrainSelectedInstOperands,
     /* 240597 */     // GIR_Coverage, 7685,
     /* 240597 */     GIR_EraseRootFromParent_Done,
     /* 240598 */   // Label 4591: @240598
     /* 240598 */   GIM_Try, /*On fail goto*//*Label 4592*/ GIMT_Encode4(240640), // Rule ID 7694 //
     /* 240603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240627 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1960:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIV_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_S),
     /* 240630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240638 */     GIR_RootConstrainSelectedInstOperands,
     /* 240639 */     // GIR_Coverage, 7694,
     /* 240639 */     GIR_EraseRootFromParent_Done,
     /* 240640 */   // Label 4592: @240640
     /* 240640 */   GIM_Try, /*On fail goto*//*Label 4593*/ GIMT_Encode4(240682), // Rule ID 7695 //
     /* 240645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udiv),
     /* 240653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240669 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1960:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIV_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIV_ZPmZ_D),
     /* 240672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240680 */     GIR_RootConstrainSelectedInstOperands,
     /* 240681 */     // GIR_Coverage, 7695,
     /* 240681 */     GIR_EraseRootFromParent_Done,
     /* 240682 */   // Label 4593: @240682
     /* 240682 */   GIM_Try, /*On fail goto*//*Label 4594*/ GIMT_Encode4(240724), // Rule ID 7696 //
     /* 240687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240711 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1715:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_S),
     /* 240714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240722 */     GIR_RootConstrainSelectedInstOperands,
     /* 240723 */     // GIR_Coverage, 7696,
     /* 240723 */     GIR_EraseRootFromParent_Done,
     /* 240724 */   // Label 4594: @240724
     /* 240724 */   GIM_Try, /*On fail goto*//*Label 4595*/ GIMT_Encode4(240766), // Rule ID 7697 //
     /* 240729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdivr),
     /* 240737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240753 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1715:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDIVR_ZPmZ_D),
     /* 240756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240764 */     GIR_RootConstrainSelectedInstOperands,
     /* 240765 */     // GIR_Coverage, 7697,
     /* 240765 */     GIR_EraseRootFromParent_Done,
     /* 240766 */   // Label 4595: @240766
     /* 240766 */   GIM_Try, /*On fail goto*//*Label 4596*/ GIMT_Encode4(240808), // Rule ID 7698 //
     /* 240771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 240785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 240788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240795 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1962:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UDIVR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 240795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_S),
     /* 240798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240806 */     GIR_RootConstrainSelectedInstOperands,
     /* 240807 */     // GIR_Coverage, 7698,
     /* 240807 */     GIR_EraseRootFromParent_Done,
     /* 240808 */   // Label 4596: @240808
     /* 240808 */   GIM_Try, /*On fail goto*//*Label 4597*/ GIMT_Encode4(240850), // Rule ID 7699 //
     /* 240813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udivr),
     /* 240821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 240827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 240830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 240833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240837 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1962:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UDIVR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 240837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDIVR_ZPmZ_D),
     /* 240840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 240842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 240844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 240846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 240848 */     GIR_RootConstrainSelectedInstOperands,
     /* 240849 */     // GIR_Coverage, 7699,
     /* 240849 */     GIR_EraseRootFromParent_Done,
     /* 240850 */   // Label 4597: @240850
     /* 240850 */   GIM_Try, /*On fail goto*//*Label 4598*/ GIMT_Encode4(240892), // Rule ID 7788 //
     /* 240855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 240866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 240869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 240872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 240875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240879 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1337:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (CNOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 240879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_B),
     /* 240882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240890 */     GIR_RootConstrainSelectedInstOperands,
     /* 240891 */     // GIR_Coverage, 7788,
     /* 240891 */     GIR_EraseRootFromParent_Done,
     /* 240892 */   // Label 4598: @240892
     /* 240892 */   GIM_Try, /*On fail goto*//*Label 4599*/ GIMT_Encode4(240934), // Rule ID 7789 //
     /* 240897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 240908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 240911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 240914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 240917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240921 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1337:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (CNOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 240921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_H),
     /* 240924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240932 */     GIR_RootConstrainSelectedInstOperands,
     /* 240933 */     // GIR_Coverage, 7789,
     /* 240933 */     GIR_EraseRootFromParent_Done,
     /* 240934 */   // Label 4599: @240934
     /* 240934 */   GIM_Try, /*On fail goto*//*Label 4600*/ GIMT_Encode4(240976), // Rule ID 7790 //
     /* 240939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 240950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 240953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 240956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 240959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 240963 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1337:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (CNOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 240963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_S),
     /* 240966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 240968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 240970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 240972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 240974 */     GIR_RootConstrainSelectedInstOperands,
     /* 240975 */     // GIR_Coverage, 7790,
     /* 240975 */     GIR_EraseRootFromParent_Done,
     /* 240976 */   // Label 4600: @240976
     /* 240976 */   GIM_Try, /*On fail goto*//*Label 4601*/ GIMT_Encode4(241018), // Rule ID 7791 //
     /* 240981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 240984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cnot),
     /* 240989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 240992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 240995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 240998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241005 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1337:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (CNOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CNOT_ZPmZ_D),
     /* 241008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241016 */     GIR_RootConstrainSelectedInstOperands,
     /* 241017 */     // GIR_Coverage, 7791,
     /* 241017 */     GIR_EraseRootFromParent_Done,
     /* 241018 */   // Label 4601: @241018
     /* 241018 */   GIM_Try, /*On fail goto*//*Label 4602*/ GIMT_Encode4(241060), // Rule ID 7800 //
     /* 241023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 241037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 241040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241047 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1623:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (NOT_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 241047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_B),
     /* 241050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241058 */     GIR_RootConstrainSelectedInstOperands,
     /* 241059 */     // GIR_Coverage, 7800,
     /* 241059 */     GIR_EraseRootFromParent_Done,
     /* 241060 */   // Label 4602: @241060
     /* 241060 */   GIM_Try, /*On fail goto*//*Label 4603*/ GIMT_Encode4(241102), // Rule ID 7801 //
     /* 241065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 241079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 241082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241089 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1623:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (NOT_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 241089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_H),
     /* 241092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241100 */     GIR_RootConstrainSelectedInstOperands,
     /* 241101 */     // GIR_Coverage, 7801,
     /* 241101 */     GIR_EraseRootFromParent_Done,
     /* 241102 */   // Label 4603: @241102
     /* 241102 */   GIM_Try, /*On fail goto*//*Label 4604*/ GIMT_Encode4(241144), // Rule ID 7802 //
     /* 241107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 241121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 241124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241131 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1623:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (NOT_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 241131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_S),
     /* 241134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241142 */     GIR_RootConstrainSelectedInstOperands,
     /* 241143 */     // GIR_Coverage, 7802,
     /* 241143 */     GIR_EraseRootFromParent_Done,
     /* 241144 */   // Label 4604: @241144
     /* 241144 */   GIM_Try, /*On fail goto*//*Label 4605*/ GIMT_Encode4(241186), // Rule ID 7803 //
     /* 241149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_not),
     /* 241157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 241163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 241166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241173 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1623:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (NOT_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 241173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOT_ZPmZ_D),
     /* 241176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 241178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op3
     /* 241180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op1
     /* 241182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op2
     /* 241184 */     GIR_RootConstrainSelectedInstOperands,
     /* 241185 */     // GIR_Coverage, 7803,
     /* 241185 */     GIR_EraseRootFromParent_Done,
     /* 241186 */   // Label 4605: @241186
     /* 241186 */   GIM_Try, /*On fail goto*//*Label 4606*/ GIMT_Encode4(241228), // Rule ID 7882 //
     /* 241191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241215 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1690:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_B),
     /* 241218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241226 */     GIR_RootConstrainSelectedInstOperands,
     /* 241227 */     // GIR_Coverage, 7882,
     /* 241227 */     GIR_EraseRootFromParent_Done,
     /* 241228 */   // Label 4606: @241228
     /* 241228 */   GIM_Try, /*On fail goto*//*Label 4607*/ GIMT_Encode4(241270), // Rule ID 7883 //
     /* 241233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241257 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1690:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_H),
     /* 241260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241268 */     GIR_RootConstrainSelectedInstOperands,
     /* 241269 */     // GIR_Coverage, 7883,
     /* 241269 */     GIR_EraseRootFromParent_Done,
     /* 241270 */   // Label 4607: @241270
     /* 241270 */   GIM_Try, /*On fail goto*//*Label 4608*/ GIMT_Encode4(241312), // Rule ID 7884 //
     /* 241275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241299 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1690:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_S),
     /* 241302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241310 */     GIR_RootConstrainSelectedInstOperands,
     /* 241311 */     // GIR_Coverage, 7884,
     /* 241311 */     GIR_EraseRootFromParent_Done,
     /* 241312 */   // Label 4608: @241312
     /* 241312 */   GIM_Try, /*On fail goto*//*Label 4609*/ GIMT_Encode4(241354), // Rule ID 7885 //
     /* 241317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabd),
     /* 241325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241341 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1690:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABD_ZPmZ_D),
     /* 241344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241352 */     GIR_RootConstrainSelectedInstOperands,
     /* 241353 */     // GIR_Coverage, 7885,
     /* 241353 */     GIR_EraseRootFromParent_Done,
     /* 241354 */   // Label 4609: @241354
     /* 241354 */   GIM_Try, /*On fail goto*//*Label 4610*/ GIMT_Encode4(241396), // Rule ID 7886 //
     /* 241359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 241370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 241373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 241376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 241379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241383 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1940:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 241383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_B),
     /* 241386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241394 */     GIR_RootConstrainSelectedInstOperands,
     /* 241395 */     // GIR_Coverage, 7886,
     /* 241395 */     GIR_EraseRootFromParent_Done,
     /* 241396 */   // Label 4610: @241396
     /* 241396 */   GIM_Try, /*On fail goto*//*Label 4611*/ GIMT_Encode4(241438), // Rule ID 7887 //
     /* 241401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241425 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1940:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 241425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_H),
     /* 241428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241436 */     GIR_RootConstrainSelectedInstOperands,
     /* 241437 */     // GIR_Coverage, 7887,
     /* 241437 */     GIR_EraseRootFromParent_Done,
     /* 241438 */   // Label 4611: @241438
     /* 241438 */   GIM_Try, /*On fail goto*//*Label 4612*/ GIMT_Encode4(241480), // Rule ID 7888 //
     /* 241443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241467 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1940:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 241467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_S),
     /* 241470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241478 */     GIR_RootConstrainSelectedInstOperands,
     /* 241479 */     // GIR_Coverage, 7888,
     /* 241479 */     GIR_EraseRootFromParent_Done,
     /* 241480 */   // Label 4612: @241480
     /* 241480 */   GIM_Try, /*On fail goto*//*Label 4613*/ GIMT_Encode4(241522), // Rule ID 7889 //
     /* 241485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabd),
     /* 241493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241509 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1940:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 241509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABD_ZPmZ_D),
     /* 241512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241520 */     GIR_RootConstrainSelectedInstOperands,
     /* 241521 */     // GIR_Coverage, 7889,
     /* 241521 */     GIR_EraseRootFromParent_Done,
     /* 241522 */   // Label 4613: @241522
     /* 241522 */   GIM_Try, /*On fail goto*//*Label 4614*/ GIMT_Encode4(241564), // Rule ID 8085 //
     /* 241527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241551 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1546:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUB_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_H),
     /* 241554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241562 */     GIR_RootConstrainSelectedInstOperands,
     /* 241563 */     // GIR_Coverage, 8085,
     /* 241563 */     GIR_EraseRootFromParent_Done,
     /* 241564 */   // Label 4614: @241564
     /* 241564 */   GIM_Try, /*On fail goto*//*Label 4615*/ GIMT_Encode4(241606), // Rule ID 8087 //
     /* 241569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241593 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1546:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUB_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_S),
     /* 241596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241604 */     GIR_RootConstrainSelectedInstOperands,
     /* 241605 */     // GIR_Coverage, 8087,
     /* 241605 */     GIR_EraseRootFromParent_Done,
     /* 241606 */   // Label 4615: @241606
     /* 241606 */   GIM_Try, /*On fail goto*//*Label 4616*/ GIMT_Encode4(241648), // Rule ID 8089 //
     /* 241611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsub),
     /* 241619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241635 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1546:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUB_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZPmZ_D),
     /* 241638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241646 */     GIR_RootConstrainSelectedInstOperands,
     /* 241647 */     // GIR_Coverage, 8089,
     /* 241647 */     GIR_EraseRootFromParent_Done,
     /* 241648 */   // Label 4616: @241648
     /* 241648 */   GIM_Try, /*On fail goto*//*Label 4617*/ GIMT_Encode4(241690), // Rule ID 8097 //
     /* 241653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241677 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1548:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FSUBR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_H),
     /* 241680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241688 */     GIR_RootConstrainSelectedInstOperands,
     /* 241689 */     // GIR_Coverage, 8097,
     /* 241689 */     GIR_EraseRootFromParent_Done,
     /* 241690 */   // Label 4617: @241690
     /* 241690 */   GIM_Try, /*On fail goto*//*Label 4618*/ GIMT_Encode4(241732), // Rule ID 8099 //
     /* 241695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241719 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1548:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FSUBR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_S),
     /* 241722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241730 */     GIR_RootConstrainSelectedInstOperands,
     /* 241731 */     // GIR_Coverage, 8099,
     /* 241731 */     GIR_EraseRootFromParent_Done,
     /* 241732 */   // Label 4618: @241732
     /* 241732 */   GIM_Try, /*On fail goto*//*Label 4619*/ GIMT_Encode4(241774), // Rule ID 8101 //
     /* 241737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fsubr),
     /* 241745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241761 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1548:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FSUBR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FSUBR_ZPmZ_D),
     /* 241764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241772 */     GIR_RootConstrainSelectedInstOperands,
     /* 241773 */     // GIR_Coverage, 8101,
     /* 241773 */     GIR_EraseRootFromParent_Done,
     /* 241774 */   // Label 4619: @241774
     /* 241774 */   GIM_Try, /*On fail goto*//*Label 4620*/ GIMT_Encode4(241816), // Rule ID 8139 //
     /* 241779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241803 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1365:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_H),
     /* 241806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241814 */     GIR_RootConstrainSelectedInstOperands,
     /* 241815 */     // GIR_Coverage, 8139,
     /* 241815 */     GIR_EraseRootFromParent_Done,
     /* 241816 */   // Label 4620: @241816
     /* 241816 */   GIM_Try, /*On fail goto*//*Label 4621*/ GIMT_Encode4(241858), // Rule ID 8140 //
     /* 241821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241845 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1365:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_S),
     /* 241848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241856 */     GIR_RootConstrainSelectedInstOperands,
     /* 241857 */     // GIR_Coverage, 8140,
     /* 241857 */     GIR_EraseRootFromParent_Done,
     /* 241858 */   // Label 4621: @241858
     /* 241858 */   GIM_Try, /*On fail goto*//*Label 4622*/ GIMT_Encode4(241900), // Rule ID 8141 //
     /* 241863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd),
     /* 241871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 241874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 241877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 241880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 241883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241887 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1365:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 241887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPmZ_D),
     /* 241890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241898 */     GIR_RootConstrainSelectedInstOperands,
     /* 241899 */     // GIR_Coverage, 8141,
     /* 241899 */     GIR_EraseRootFromParent_Done,
     /* 241900 */   // Label 4622: @241900
     /* 241900 */   GIM_Try, /*On fail goto*//*Label 4623*/ GIMT_Encode4(241942), // Rule ID 8142 //
     /* 241905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 241913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 241916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 241919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 241922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 241925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241929 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1487:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 241929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_H),
     /* 241932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241940 */     GIR_RootConstrainSelectedInstOperands,
     /* 241941 */     // GIR_Coverage, 8142,
     /* 241941 */     GIR_EraseRootFromParent_Done,
     /* 241942 */   // Label 4623: @241942
     /* 241942 */   GIM_Try, /*On fail goto*//*Label 4624*/ GIMT_Encode4(241984), // Rule ID 8143 //
     /* 241947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 241955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 241958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 241961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 241964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 241967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 241971 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1487:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 241971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_S),
     /* 241974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 241976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 241978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 241980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 241982 */     GIR_RootConstrainSelectedInstOperands,
     /* 241983 */     // GIR_Coverage, 8143,
     /* 241983 */     GIR_EraseRootFromParent_Done,
     /* 241984 */   // Label 4624: @241984
     /* 241984 */   GIM_Try, /*On fail goto*//*Label 4625*/ GIMT_Encode4(242026), // Rule ID 8144 //
     /* 241989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 241992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx),
     /* 241997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242013 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1487:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPmZ_D),
     /* 242016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242024 */     GIR_RootConstrainSelectedInstOperands,
     /* 242025 */     // GIR_Coverage, 8144,
     /* 242025 */     GIR_EraseRootFromParent_Done,
     /* 242026 */   // Label 4625: @242026
     /* 242026 */   GIM_Try, /*On fail goto*//*Label 4626*/ GIMT_Encode4(242068), // Rule ID 8145 //
     /* 242031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242055 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1426:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIVR_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_H),
     /* 242058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242066 */     GIR_RootConstrainSelectedInstOperands,
     /* 242067 */     // GIR_Coverage, 8145,
     /* 242067 */     GIR_EraseRootFromParent_Done,
     /* 242068 */   // Label 4626: @242068
     /* 242068 */   GIM_Try, /*On fail goto*//*Label 4627*/ GIMT_Encode4(242110), // Rule ID 8146 //
     /* 242073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242097 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1426:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIVR_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_S),
     /* 242100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242108 */     GIR_RootConstrainSelectedInstOperands,
     /* 242109 */     // GIR_Coverage, 8146,
     /* 242109 */     GIR_EraseRootFromParent_Done,
     /* 242110 */   // Label 4627: @242110
     /* 242110 */   GIM_Try, /*On fail goto*//*Label 4628*/ GIMT_Encode4(242152), // Rule ID 8147 //
     /* 242115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdivr),
     /* 242123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242139 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1426:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIVR_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIVR_ZPmZ_D),
     /* 242142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242150 */     GIR_RootConstrainSelectedInstOperands,
     /* 242151 */     // GIR_Coverage, 8147,
     /* 242151 */     GIR_EraseRootFromParent_Done,
     /* 242152 */   // Label 4628: @242152
     /* 242152 */   GIM_Try, /*On fail goto*//*Label 4629*/ GIMT_Encode4(242194), // Rule ID 8148 //
     /* 242157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242181 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1424:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDIV_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_H),
     /* 242184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242192 */     GIR_RootConstrainSelectedInstOperands,
     /* 242193 */     // GIR_Coverage, 8148,
     /* 242193 */     GIR_EraseRootFromParent_Done,
     /* 242194 */   // Label 4629: @242194
     /* 242194 */   GIM_Try, /*On fail goto*//*Label 4630*/ GIMT_Encode4(242236), // Rule ID 8149 //
     /* 242199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242223 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1424:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FDIV_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_S),
     /* 242226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242234 */     GIR_RootConstrainSelectedInstOperands,
     /* 242235 */     // GIR_Coverage, 8149,
     /* 242235 */     GIR_EraseRootFromParent_Done,
     /* 242236 */   // Label 4630: @242236
     /* 242236 */   GIM_Try, /*On fail goto*//*Label 4631*/ GIMT_Encode4(242278), // Rule ID 8150 //
     /* 242241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdiv),
     /* 242249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242265 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1424:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FDIV_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDIV_ZPmZ_D),
     /* 242268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 242270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242276 */     GIR_RootConstrainSelectedInstOperands,
     /* 242277 */     // GIR_Coverage, 8150,
     /* 242277 */     GIR_EraseRootFromParent_Done,
     /* 242278 */   // Label 4631: @242278
     /* 242278 */   GIM_Try, /*On fail goto*//*Label 4632*/ GIMT_Encode4(242320), // Rule ID 8187 //
     /* 242283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242307 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1366:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242318 */     GIR_RootConstrainSelectedInstOperands,
     /* 242319 */     // GIR_Coverage, 8187,
     /* 242319 */     GIR_EraseRootFromParent_Done,
     /* 242320 */   // Label 4632: @242320
     /* 242320 */   GIM_Try, /*On fail goto*//*Label 4633*/ GIMT_Encode4(242362), // Rule ID 8189 //
     /* 242325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242349 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242360 */     GIR_RootConstrainSelectedInstOperands,
     /* 242361 */     // GIR_Coverage, 8189,
     /* 242361 */     GIR_EraseRootFromParent_Done,
     /* 242362 */   // Label 4633: @242362
     /* 242362 */   GIM_Try, /*On fail goto*//*Label 4634*/ GIMT_Encode4(242404), // Rule ID 8191 //
     /* 242367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242391 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FABD_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_H_UNDEF),
     /* 242394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242402 */     GIR_RootConstrainSelectedInstOperands,
     /* 242403 */     // GIR_Coverage, 8191,
     /* 242403 */     GIR_EraseRootFromParent_Done,
     /* 242404 */   // Label 4634: @242404
     /* 242404 */   GIM_Try, /*On fail goto*//*Label 4635*/ GIMT_Encode4(242446), // Rule ID 8193 //
     /* 242409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242433 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1366:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242444 */     GIR_RootConstrainSelectedInstOperands,
     /* 242445 */     // GIR_Coverage, 8193,
     /* 242445 */     GIR_EraseRootFromParent_Done,
     /* 242446 */   // Label 4635: @242446
     /* 242446 */   GIM_Try, /*On fail goto*//*Label 4636*/ GIMT_Encode4(242488), // Rule ID 8195 //
     /* 242451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242475 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FABD_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_S_UNDEF),
     /* 242478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242486 */     GIR_RootConstrainSelectedInstOperands,
     /* 242487 */     // GIR_Coverage, 8195,
     /* 242487 */     GIR_EraseRootFromParent_Done,
     /* 242488 */   // Label 4636: @242488
     /* 242488 */   GIM_Try, /*On fail goto*//*Label 4637*/ GIMT_Encode4(242530), // Rule ID 8197 //
     /* 242493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fabd_u),
     /* 242501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242517 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1366:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FABD_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD_ZPZZ_D_UNDEF),
     /* 242520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242528 */     GIR_RootConstrainSelectedInstOperands,
     /* 242529 */     // GIR_Coverage, 8197,
     /* 242529 */     GIR_EraseRootFromParent_Done,
     /* 242530 */   // Label 4637: @242530
     /* 242530 */   GIM_Try, /*On fail goto*//*Label 4638*/ GIMT_Encode4(242572), // Rule ID 8199 //
     /* 242535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 242546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 242552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 242555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242559 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1488:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 242559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242570 */     GIR_RootConstrainSelectedInstOperands,
     /* 242571 */     // GIR_Coverage, 8199,
     /* 242571 */     GIR_EraseRootFromParent_Done,
     /* 242572 */   // Label 4638: @242572
     /* 242572 */   GIM_Try, /*On fail goto*//*Label 4639*/ GIMT_Encode4(242614), // Rule ID 8200 //
     /* 242577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 242588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 242594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 242597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242601 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 242601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242612 */     GIR_RootConstrainSelectedInstOperands,
     /* 242613 */     // GIR_Coverage, 8200,
     /* 242613 */     GIR_EraseRootFromParent_Done,
     /* 242614 */   // Label 4639: @242614
     /* 242614 */   GIM_Try, /*On fail goto*//*Label 4640*/ GIMT_Encode4(242656), // Rule ID 8201 //
     /* 242619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 242630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 242636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 242639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242643 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FMULX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 242643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_H_UNDEF),
     /* 242646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242654 */     GIR_RootConstrainSelectedInstOperands,
     /* 242655 */     // GIR_Coverage, 8201,
     /* 242655 */     GIR_EraseRootFromParent_Done,
     /* 242656 */   // Label 4640: @242656
     /* 242656 */   GIM_Try, /*On fail goto*//*Label 4641*/ GIMT_Encode4(242698), // Rule ID 8202 //
     /* 242661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 242672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 242678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 242681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242685 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1488:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 242685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242696 */     GIR_RootConstrainSelectedInstOperands,
     /* 242697 */     // GIR_Coverage, 8202,
     /* 242697 */     GIR_EraseRootFromParent_Done,
     /* 242698 */   // Label 4641: @242698
     /* 242698 */   GIM_Try, /*On fail goto*//*Label 4642*/ GIMT_Encode4(242740), // Rule ID 8203 //
     /* 242703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 242714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 242720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 242723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242727 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FMULX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 242727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_S_UNDEF),
     /* 242730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242738 */     GIR_RootConstrainSelectedInstOperands,
     /* 242739 */     // GIR_Coverage, 8203,
     /* 242739 */     GIR_EraseRootFromParent_Done,
     /* 242740 */   // Label 4642: @242740
     /* 242740 */   GIM_Try, /*On fail goto*//*Label 4643*/ GIMT_Encode4(242782), // Rule ID 8204 //
     /* 242745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmulx_u),
     /* 242753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 242756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 242759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 242762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 242765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 242769 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1488:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMULX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 242769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULX_ZPZZ_D_UNDEF),
     /* 242772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 242774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242780 */     GIR_RootConstrainSelectedInstOperands,
     /* 242781 */     // GIR_Coverage, 8204,
     /* 242781 */     GIR_EraseRootFromParent_Done,
     /* 242782 */   // Label 4643: @242782
     /* 242782 */   GIM_Try, /*On fail goto*//*Label 4644*/ GIMT_Encode4(242824), // Rule ID 8457 //
     /* 242787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkpb_z),
     /* 242795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242811 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1306:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKPB_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKPB_PPzPP),
     /* 242814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242822 */     GIR_RootConstrainSelectedInstOperands,
     /* 242823 */     // GIR_Coverage, 8457,
     /* 242823 */     GIR_EraseRootFromParent_Done,
     /* 242824 */   // Label 4644: @242824
     /* 242824 */   GIM_Try, /*On fail goto*//*Label 4645*/ GIMT_Encode4(242866), // Rule ID 8459 //
     /* 242829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_brkb),
     /* 242837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 242853 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1302:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BRKB_PPmP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRKB_PPmP),
     /* 242856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242864 */     GIR_RootConstrainSelectedInstOperands,
     /* 242865 */     // GIR_Coverage, 8459,
     /* 242865 */     GIR_EraseRootFromParent_Done,
     /* 242866 */   // Label 4645: @242866
     /* 242866 */   GIM_Try, /*On fail goto*//*Label 4646*/ GIMT_Encode4(242908), // Rule ID 8460 //
     /* 242871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 242879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 242882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 242885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 242888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 242891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242895 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1299:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 242895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 242898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242906 */     GIR_RootConstrainSelectedInstOperands,
     /* 242907 */     // GIR_Coverage, 8460,
     /* 242907 */     GIR_EraseRootFromParent_Done,
     /* 242908 */   // Label 4646: @242908
     /* 242908 */   GIM_Try, /*On fail goto*//*Label 4647*/ GIMT_Encode4(242950), // Rule ID 8461 //
     /* 242913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 242921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 242924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 242927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 242930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 242933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242937 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1299:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 242937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 242940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242948 */     GIR_RootConstrainSelectedInstOperands,
     /* 242949 */     // GIR_Coverage, 8461,
     /* 242949 */     GIR_EraseRootFromParent_Done,
     /* 242950 */   // Label 4647: @242950
     /* 242950 */   GIM_Try, /*On fail goto*//*Label 4648*/ GIMT_Encode4(242992), // Rule ID 8462 //
     /* 242955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 242958 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 242963 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 242966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 242969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 242972 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 242975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 242979 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1299:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 242979 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 242982 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 242984 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 242986 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 242988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 242990 */     GIR_RootConstrainSelectedInstOperands,
     /* 242991 */     // GIR_Coverage, 8462,
     /* 242991 */     GIR_EraseRootFromParent_Done,
     /* 242992 */   // Label 4648: @242992
     /* 242992 */   GIM_Try, /*On fail goto*//*Label 4649*/ GIMT_Encode4(243034), // Rule ID 8463 //
     /* 242997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243017 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243021 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1299:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243028 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243030 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243032 */     GIR_RootConstrainSelectedInstOperands,
     /* 243033 */     // GIR_Coverage, 8463,
     /* 243033 */     GIR_EraseRootFromParent_Done,
     /* 243034 */   // Label 4649: @243034
     /* 243034 */   GIM_Try, /*On fail goto*//*Label 4650*/ GIMT_Encode4(243076), // Rule ID 8464 //
     /* 243039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243042 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bic_z),
     /* 243047 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243050 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243053 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243056 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243063 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1299:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (BIC_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BIC_PPzPP),
     /* 243066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243070 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243072 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243074 */     GIR_RootConstrainSelectedInstOperands,
     /* 243075 */     // GIR_Coverage, 8464,
     /* 243075 */     GIR_EraseRootFromParent_Done,
     /* 243076 */   // Label 4650: @243076
     /* 243076 */   GIM_Try, /*On fail goto*//*Label 4651*/ GIMT_Encode4(243118), // Rule ID 8485 //
     /* 243081 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243084 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243089 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243092 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243095 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243098 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243101 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243105 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1357:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243110 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243112 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243114 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243116 */     GIR_RootConstrainSelectedInstOperands,
     /* 243117 */     // GIR_Coverage, 8485,
     /* 243117 */     GIR_EraseRootFromParent_Done,
     /* 243118 */   // Label 4651: @243118
     /* 243118 */   GIM_Try, /*On fail goto*//*Label 4652*/ GIMT_Encode4(243160), // Rule ID 8486 //
     /* 243123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243147 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1357:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243158 */     GIR_RootConstrainSelectedInstOperands,
     /* 243159 */     // GIR_Coverage, 8486,
     /* 243159 */     GIR_EraseRootFromParent_Done,
     /* 243160 */   // Label 4652: @243160
     /* 243160 */   GIM_Try, /*On fail goto*//*Label 4653*/ GIMT_Encode4(243202), // Rule ID 8487 //
     /* 243165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243168 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243173 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243176 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243179 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243182 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243185 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243189 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1357:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243194 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243196 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243198 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243200 */     GIR_RootConstrainSelectedInstOperands,
     /* 243201 */     // GIR_Coverage, 8487,
     /* 243201 */     GIR_EraseRootFromParent_Done,
     /* 243202 */   // Label 4653: @243202
     /* 243202 */   GIM_Try, /*On fail goto*//*Label 4654*/ GIMT_Encode4(243244), // Rule ID 8488 //
     /* 243207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243210 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243215 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243224 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243227 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243231 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1357:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243231 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243234 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243236 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243240 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243242 */     GIR_RootConstrainSelectedInstOperands,
     /* 243243 */     // GIR_Coverage, 8488,
     /* 243243 */     GIR_EraseRootFromParent_Done,
     /* 243244 */   // Label 4654: @243244
     /* 243244 */   GIM_Try, /*On fail goto*//*Label 4655*/ GIMT_Encode4(243286), // Rule ID 8489 //
     /* 243249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eor_z),
     /* 243257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243269 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243273 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1357:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (EOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EOR_PPzPP),
     /* 243276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243280 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243282 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243284 */     GIR_RootConstrainSelectedInstOperands,
     /* 243285 */     // GIR_Coverage, 8489,
     /* 243285 */     GIR_EraseRootFromParent_Done,
     /* 243286 */   // Label 4655: @243286
     /* 243286 */   GIM_Try, /*On fail goto*//*Label 4656*/ GIMT_Encode4(243328), // Rule ID 8505 //
     /* 243291 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243294 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243299 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243302 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243305 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243308 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243315 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1628:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243322 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243324 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243326 */     GIR_RootConstrainSelectedInstOperands,
     /* 243327 */     // GIR_Coverage, 8505,
     /* 243327 */     GIR_EraseRootFromParent_Done,
     /* 243328 */   // Label 4656: @243328
     /* 243328 */   GIM_Try, /*On fail goto*//*Label 4657*/ GIMT_Encode4(243370), // Rule ID 8506 //
     /* 243333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243336 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243341 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243344 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243347 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243350 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243357 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1628:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243368 */     GIR_RootConstrainSelectedInstOperands,
     /* 243369 */     // GIR_Coverage, 8506,
     /* 243369 */     GIR_EraseRootFromParent_Done,
     /* 243370 */   // Label 4657: @243370
     /* 243370 */   GIM_Try, /*On fail goto*//*Label 4658*/ GIMT_Encode4(243412), // Rule ID 8507 //
     /* 243375 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243378 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243383 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243386 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243389 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243392 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243395 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243399 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1628:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243408 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243410 */     GIR_RootConstrainSelectedInstOperands,
     /* 243411 */     // GIR_Coverage, 8507,
     /* 243411 */     GIR_EraseRootFromParent_Done,
     /* 243412 */   // Label 4658: @243412
     /* 243412 */   GIM_Try, /*On fail goto*//*Label 4659*/ GIMT_Encode4(243454), // Rule ID 8508 //
     /* 243417 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243420 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243425 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243428 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243431 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243434 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243437 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243441 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1628:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243450 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243452 */     GIR_RootConstrainSelectedInstOperands,
     /* 243453 */     // GIR_Coverage, 8508,
     /* 243453 */     GIR_EraseRootFromParent_Done,
     /* 243454 */   // Label 4659: @243454
     /* 243454 */   GIM_Try, /*On fail goto*//*Label 4660*/ GIMT_Encode4(243496), // Rule ID 8509 //
     /* 243459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243462 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orr_z),
     /* 243467 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243470 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243473 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243476 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243483 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1628:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORR_PPzPP),
     /* 243486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243492 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243494 */     GIR_RootConstrainSelectedInstOperands,
     /* 243495 */     // GIR_Coverage, 8509,
     /* 243495 */     GIR_EraseRootFromParent_Done,
     /* 243496 */   // Label 4660: @243496
     /* 243496 */   GIM_Try, /*On fail goto*//*Label 4661*/ GIMT_Encode4(243538), // Rule ID 8510 //
     /* 243501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243504 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243509 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243512 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243515 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243518 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243521 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243525 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1624:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243525 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243528 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243530 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243532 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243534 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243536 */     GIR_RootConstrainSelectedInstOperands,
     /* 243537 */     // GIR_Coverage, 8510,
     /* 243537 */     GIR_EraseRootFromParent_Done,
     /* 243538 */   // Label 4661: @243538
     /* 243538 */   GIM_Try, /*On fail goto*//*Label 4662*/ GIMT_Encode4(243580), // Rule ID 8511 //
     /* 243543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243546 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243551 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243554 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243557 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243560 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243563 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243567 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1624:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243572 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243576 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243578 */     GIR_RootConstrainSelectedInstOperands,
     /* 243579 */     // GIR_Coverage, 8511,
     /* 243579 */     GIR_EraseRootFromParent_Done,
     /* 243580 */   // Label 4662: @243580
     /* 243580 */   GIM_Try, /*On fail goto*//*Label 4663*/ GIMT_Encode4(243622), // Rule ID 8512 //
     /* 243585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243588 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243593 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243596 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243599 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243602 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243609 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1624:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243620 */     GIR_RootConstrainSelectedInstOperands,
     /* 243621 */     // GIR_Coverage, 8512,
     /* 243621 */     GIR_EraseRootFromParent_Done,
     /* 243622 */   // Label 4663: @243622
     /* 243622 */   GIM_Try, /*On fail goto*//*Label 4664*/ GIMT_Encode4(243664), // Rule ID 8513 //
     /* 243627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243630 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243635 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243644 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243651 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1624:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243660 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243662 */     GIR_RootConstrainSelectedInstOperands,
     /* 243663 */     // GIR_Coverage, 8513,
     /* 243663 */     GIR_EraseRootFromParent_Done,
     /* 243664 */   // Label 4664: @243664
     /* 243664 */   GIM_Try, /*On fail goto*//*Label 4665*/ GIMT_Encode4(243706), // Rule ID 8514 //
     /* 243669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243672 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_orn_z),
     /* 243677 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243680 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243683 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243686 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243689 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243693 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1624:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (ORN_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ORN_PPzPP),
     /* 243696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243702 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243704 */     GIR_RootConstrainSelectedInstOperands,
     /* 243705 */     // GIR_Coverage, 8514,
     /* 243705 */     GIR_EraseRootFromParent_Done,
     /* 243706 */   // Label 4665: @243706
     /* 243706 */   GIM_Try, /*On fail goto*//*Label 4666*/ GIMT_Encode4(243748), // Rule ID 8515 //
     /* 243711 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243714 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243719 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243728 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243731 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243735 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1622:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243744 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243746 */     GIR_RootConstrainSelectedInstOperands,
     /* 243747 */     // GIR_Coverage, 8515,
     /* 243747 */     GIR_EraseRootFromParent_Done,
     /* 243748 */   // Label 4666: @243748
     /* 243748 */   GIM_Try, /*On fail goto*//*Label 4667*/ GIMT_Encode4(243790), // Rule ID 8516 //
     /* 243753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243773 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243777 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1622:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243782 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243784 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243786 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243788 */     GIR_RootConstrainSelectedInstOperands,
     /* 243789 */     // GIR_Coverage, 8516,
     /* 243789 */     GIR_EraseRootFromParent_Done,
     /* 243790 */   // Label 4667: @243790
     /* 243790 */   GIM_Try, /*On fail goto*//*Label 4668*/ GIMT_Encode4(243832), // Rule ID 8517 //
     /* 243795 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243798 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243803 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 243806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 243809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 243812 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 243815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243819 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1622:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 243819 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243822 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243824 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243826 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243828 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243830 */     GIR_RootConstrainSelectedInstOperands,
     /* 243831 */     // GIR_Coverage, 8517,
     /* 243831 */     GIR_EraseRootFromParent_Done,
     /* 243832 */   // Label 4668: @243832
     /* 243832 */   GIM_Try, /*On fail goto*//*Label 4669*/ GIMT_Encode4(243874), // Rule ID 8518 //
     /* 243837 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243840 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243845 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 243848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 243851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 243854 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 243857 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243861 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1622:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 243861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243866 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243868 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243870 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243872 */     GIR_RootConstrainSelectedInstOperands,
     /* 243873 */     // GIR_Coverage, 8518,
     /* 243873 */     GIR_EraseRootFromParent_Done,
     /* 243874 */   // Label 4669: @243874
     /* 243874 */   GIM_Try, /*On fail goto*//*Label 4670*/ GIMT_Encode4(243916), // Rule ID 8519 //
     /* 243879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243882 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nor_z),
     /* 243887 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 243890 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 243893 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 243896 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 243899 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243903 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1622:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NOR_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 243903 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NOR_PPzPP),
     /* 243906 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243908 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243910 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243912 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243914 */     GIR_RootConstrainSelectedInstOperands,
     /* 243915 */     // GIR_Coverage, 8519,
     /* 243915 */     GIR_EraseRootFromParent_Done,
     /* 243916 */   // Label 4670: @243916
     /* 243916 */   GIM_Try, /*On fail goto*//*Label 4671*/ GIMT_Encode4(243958), // Rule ID 8520 //
     /* 243921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243924 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 243929 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 243932 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 243935 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 243938 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s1,
     /* 243941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243945 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1618:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 243945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 243948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243950 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243952 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243954 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243956 */     GIR_RootConstrainSelectedInstOperands,
     /* 243957 */     // GIR_Coverage, 8520,
     /* 243957 */     GIR_EraseRootFromParent_Done,
     /* 243958 */   // Label 4671: @243958
     /* 243958 */   GIM_Try, /*On fail goto*//*Label 4672*/ GIMT_Encode4(244000), // Rule ID 8521 //
     /* 243963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 243966 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 243971 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 243974 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 243977 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 243980 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s1,
     /* 243983 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 243987 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1618:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 243987 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 243990 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 243992 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 243994 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 243996 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 243998 */     GIR_RootConstrainSelectedInstOperands,
     /* 243999 */     // GIR_Coverage, 8521,
     /* 243999 */     GIR_EraseRootFromParent_Done,
     /* 244000 */   // Label 4672: @244000
     /* 244000 */   GIM_Try, /*On fail goto*//*Label 4673*/ GIMT_Encode4(244042), // Rule ID 8522 //
     /* 244005 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244016 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244019 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 244022 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s1,
     /* 244025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244029 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1618:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 244029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244036 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244038 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244040 */     GIR_RootConstrainSelectedInstOperands,
     /* 244041 */     // GIR_Coverage, 8522,
     /* 244041 */     GIR_EraseRootFromParent_Done,
     /* 244042 */   // Label 4673: @244042
     /* 244042 */   GIM_Try, /*On fail goto*//*Label 4674*/ GIMT_Encode4(244084), // Rule ID 8523 //
     /* 244047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 244058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244061 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 244064 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s1,
     /* 244067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244071 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1618:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 244071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244080 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244082 */     GIR_RootConstrainSelectedInstOperands,
     /* 244083 */     // GIR_Coverage, 8523,
     /* 244083 */     GIR_EraseRootFromParent_Done,
     /* 244084 */   // Label 4674: @244084
     /* 244084 */   GIM_Try, /*On fail goto*//*Label 4675*/ GIMT_Encode4(244126), // Rule ID 8524 //
     /* 244089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244092 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nand_z),
     /* 244097 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv1s1,
     /* 244100 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 244103 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 244106 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv1s1,
     /* 244109 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 244113 */     // (intrinsic_wo_chain:{ *:[nxv1i1] } 1618:{ *:[iPTR] }, nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (NAND_PPzPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 244113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NAND_PPzPP),
     /* 244116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244120 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244122 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244124 */     GIR_RootConstrainSelectedInstOperands,
     /* 244125 */     // GIR_Coverage, 8524,
     /* 244125 */     GIR_EraseRootFromParent_Done,
     /* 244126 */   // Label 4675: @244126
     /* 244126 */   GIM_Try, /*On fail goto*//*Label 4676*/ GIMT_Encode4(244168), // Rule ID 8532 //
     /* 244131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244134 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244139 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 244142 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244145 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244148 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 244151 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244155 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1315:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (CLASTB_ZPZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 244155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_B),
     /* 244158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244160 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244162 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244164 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244166 */     GIR_RootConstrainSelectedInstOperands,
     /* 244167 */     // GIR_Coverage, 8532,
     /* 244167 */     GIR_EraseRootFromParent_Done,
     /* 244168 */   // Label 4676: @244168
     /* 244168 */   GIM_Try, /*On fail goto*//*Label 4677*/ GIMT_Encode4(244210), // Rule ID 8533 //
     /* 244173 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244176 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244181 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244184 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244187 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244190 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244193 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244197 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 244197 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244200 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244202 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244206 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244208 */     GIR_RootConstrainSelectedInstOperands,
     /* 244209 */     // GIR_Coverage, 8533,
     /* 244209 */     GIR_EraseRootFromParent_Done,
     /* 244210 */   // Label 4677: @244210
     /* 244210 */   GIM_Try, /*On fail goto*//*Label 4678*/ GIMT_Encode4(244252), // Rule ID 8534 //
     /* 244215 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244218 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244223 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244235 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244239 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 244239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244244 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244246 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244248 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244250 */     GIR_RootConstrainSelectedInstOperands,
     /* 244251 */     // GIR_Coverage, 8534,
     /* 244251 */     GIR_EraseRootFromParent_Done,
     /* 244252 */   // Label 4678: @244252
     /* 244252 */   GIM_Try, /*On fail goto*//*Label 4679*/ GIMT_Encode4(244294), // Rule ID 8535 //
     /* 244257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244260 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244265 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244268 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244271 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244274 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244277 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244281 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244286 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244288 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244290 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244292 */     GIR_RootConstrainSelectedInstOperands,
     /* 244293 */     // GIR_Coverage, 8535,
     /* 244293 */     GIR_EraseRootFromParent_Done,
     /* 244294 */   // Label 4679: @244294
     /* 244294 */   GIM_Try, /*On fail goto*//*Label 4680*/ GIMT_Encode4(244336), // Rule ID 8536 //
     /* 244299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244302 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244307 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 244310 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244313 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244316 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 244319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244323 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1315:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (CLASTB_ZPZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 244323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_H),
     /* 244326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244334 */     GIR_RootConstrainSelectedInstOperands,
     /* 244335 */     // GIR_Coverage, 8536,
     /* 244335 */     GIR_EraseRootFromParent_Done,
     /* 244336 */   // Label 4680: @244336
     /* 244336 */   GIM_Try, /*On fail goto*//*Label 4681*/ GIMT_Encode4(244378), // Rule ID 8537 //
     /* 244341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 244352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 244361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244365 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1315:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (CLASTB_ZPZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 244365 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_S),
     /* 244368 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244370 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244372 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244374 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244376 */     GIR_RootConstrainSelectedInstOperands,
     /* 244377 */     // GIR_Coverage, 8537,
     /* 244377 */     GIR_EraseRootFromParent_Done,
     /* 244378 */   // Label 4681: @244378
     /* 244378 */   GIM_Try, /*On fail goto*//*Label 4682*/ GIMT_Encode4(244420), // Rule ID 8538 //
     /* 244383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244386 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_clastb),
     /* 244391 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 244394 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 244397 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 244400 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244403 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 244407 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1315:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (CLASTB_ZPZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 244407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLASTB_ZPZ_D),
     /* 244410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 244412 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244414 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244416 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244418 */     GIR_RootConstrainSelectedInstOperands,
     /* 244419 */     // GIR_Coverage, 8538,
     /* 244419 */     GIR_EraseRootFromParent_Done,
     /* 244420 */   // Label 4682: @244420
     /* 244420 */   GIM_Try, /*On fail goto*//*Label 4683*/ GIMT_Encode4(244465), // Rule ID 9234 //
     /* 244425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244428 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244433 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244436 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244439 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244442 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244445 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244449 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1336:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_B),
     /* 244452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244456 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244458 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244460 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244463 */     GIR_RootConstrainSelectedInstOperands,
     /* 244464 */     // GIR_Coverage, 9234,
     /* 244464 */     GIR_EraseRootFromParent_Done,
     /* 244465 */   // Label 4683: @244465
     /* 244465 */   GIM_Try, /*On fail goto*//*Label 4684*/ GIMT_Encode4(244510), // Rule ID 9235 //
     /* 244470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244473 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244478 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244481 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244484 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244487 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244494 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1336:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_H),
     /* 244497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244505 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244508 */     GIR_RootConstrainSelectedInstOperands,
     /* 244509 */     // GIR_Coverage, 9235,
     /* 244509 */     GIR_EraseRootFromParent_Done,
     /* 244510 */   // Label 4684: @244510
     /* 244510 */   GIM_Try, /*On fail goto*//*Label 4685*/ GIMT_Encode4(244555), // Rule ID 9236 //
     /* 244515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpne_wide),
     /* 244523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244539 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1336:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPNE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPNE_WIDE_PPzZZ_S),
     /* 244542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244550 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244553 */     GIR_RootConstrainSelectedInstOperands,
     /* 244554 */     // GIR_Coverage, 9236,
     /* 244554 */     GIR_EraseRootFromParent_Done,
     /* 244555 */   // Label 4685: @244555
     /* 244555 */   GIM_Try, /*On fail goto*//*Label 4686*/ GIMT_Encode4(244600), // Rule ID 9237 //
     /* 244560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244563 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244568 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244571 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244574 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244577 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244580 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244584 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1326:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_B),
     /* 244587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244591 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244593 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244595 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244598 */     GIR_RootConstrainSelectedInstOperands,
     /* 244599 */     // GIR_Coverage, 9237,
     /* 244599 */     GIR_EraseRootFromParent_Done,
     /* 244600 */   // Label 4686: @244600
     /* 244600 */   GIM_Try, /*On fail goto*//*Label 4687*/ GIMT_Encode4(244645), // Rule ID 9238 //
     /* 244605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244629 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1326:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_H),
     /* 244632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244640 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244643 */     GIR_RootConstrainSelectedInstOperands,
     /* 244644 */     // GIR_Coverage, 9238,
     /* 244644 */     GIR_EraseRootFromParent_Done,
     /* 244645 */   // Label 4687: @244645
     /* 244645 */   GIM_Try, /*On fail goto*//*Label 4688*/ GIMT_Encode4(244690), // Rule ID 9239 //
     /* 244650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244653 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpgt_wide),
     /* 244658 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244661 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244664 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244667 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244670 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244674 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1326:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPGT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPGT_WIDE_PPzZZ_S),
     /* 244677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244685 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244688 */     GIR_RootConstrainSelectedInstOperands,
     /* 244689 */     // GIR_Coverage, 9239,
     /* 244689 */     GIR_EraseRootFromParent_Done,
     /* 244690 */   // Label 4688: @244690
     /* 244690 */   GIM_Try, /*On fail goto*//*Label 4689*/ GIMT_Encode4(244735), // Rule ID 9240 //
     /* 244695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244719 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1334:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_B),
     /* 244722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244730 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244733 */     GIR_RootConstrainSelectedInstOperands,
     /* 244734 */     // GIR_Coverage, 9240,
     /* 244734 */     GIR_EraseRootFromParent_Done,
     /* 244735 */   // Label 4689: @244735
     /* 244735 */   GIM_Try, /*On fail goto*//*Label 4690*/ GIMT_Encode4(244780), // Rule ID 9241 //
     /* 244740 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244743 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244748 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244751 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244754 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244757 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244760 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244764 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1334:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_H),
     /* 244767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244775 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244778 */     GIR_RootConstrainSelectedInstOperands,
     /* 244779 */     // GIR_Coverage, 9241,
     /* 244779 */     GIR_EraseRootFromParent_Done,
     /* 244780 */   // Label 4690: @244780
     /* 244780 */   GIM_Try, /*On fail goto*//*Label 4691*/ GIMT_Encode4(244825), // Rule ID 9242 //
     /* 244785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244788 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplt_wide),
     /* 244793 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244796 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244799 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244802 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244805 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244809 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1334:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLT_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLT_WIDE_PPzZZ_S),
     /* 244812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244814 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244816 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244818 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244820 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244823 */     GIR_RootConstrainSelectedInstOperands,
     /* 244824 */     // GIR_Coverage, 9242,
     /* 244824 */     GIR_EraseRootFromParent_Done,
     /* 244825 */   // Label 4691: @244825
     /* 244825 */   GIM_Try, /*On fail goto*//*Label 4692*/ GIMT_Encode4(244870), // Rule ID 9243 //
     /* 244830 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244833 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244838 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244841 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244844 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244847 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244854 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1331:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_B),
     /* 244857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244865 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244868 */     GIR_RootConstrainSelectedInstOperands,
     /* 244869 */     // GIR_Coverage, 9243,
     /* 244869 */     GIR_EraseRootFromParent_Done,
     /* 244870 */   // Label 4692: @244870
     /* 244870 */   GIM_Try, /*On fail goto*//*Label 4693*/ GIMT_Encode4(244915), // Rule ID 9244 //
     /* 244875 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244878 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244883 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 244886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 244889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 244892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244899 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1331:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_H),
     /* 244902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244908 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244910 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244913 */     GIR_RootConstrainSelectedInstOperands,
     /* 244914 */     // GIR_Coverage, 9244,
     /* 244914 */     GIR_EraseRootFromParent_Done,
     /* 244915 */   // Label 4693: @244915
     /* 244915 */   GIM_Try, /*On fail goto*//*Label 4694*/ GIMT_Encode4(244960), // Rule ID 9245 //
     /* 244920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmple_wide),
     /* 244928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 244931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 244934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 244937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244944 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1331:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLE_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLE_WIDE_PPzZZ_S),
     /* 244947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 244955 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 244958 */     GIR_RootConstrainSelectedInstOperands,
     /* 244959 */     // GIR_Coverage, 9245,
     /* 244959 */     GIR_EraseRootFromParent_Done,
     /* 244960 */   // Label 4694: @244960
     /* 244960 */   GIM_Try, /*On fail goto*//*Label 4695*/ GIMT_Encode4(245005), // Rule ID 9246 //
     /* 244965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 244968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 244973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 244976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 244979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 244982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 244985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 244989 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1330:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 244989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_B),
     /* 244992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 244994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 244996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 244998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245000 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245003 */     GIR_RootConstrainSelectedInstOperands,
     /* 245004 */     // GIR_Coverage, 9246,
     /* 245004 */     GIR_EraseRootFromParent_Done,
     /* 245005 */   // Label 4695: @245005
     /* 245005 */   GIM_Try, /*On fail goto*//*Label 4696*/ GIMT_Encode4(245050), // Rule ID 9247 //
     /* 245010 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245013 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245018 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245021 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245024 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245027 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245030 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245034 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1330:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_H),
     /* 245037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245045 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245048 */     GIR_RootConstrainSelectedInstOperands,
     /* 245049 */     // GIR_Coverage, 9247,
     /* 245049 */     GIR_EraseRootFromParent_Done,
     /* 245050 */   // Label 4696: @245050
     /* 245050 */   GIM_Try, /*On fail goto*//*Label 4697*/ GIMT_Encode4(245095), // Rule ID 9248 //
     /* 245055 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245058 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphs_wide),
     /* 245063 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245075 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245079 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1330:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHS_WIDE_PPzZZ_S),
     /* 245082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245084 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245088 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245090 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245093 */     GIR_RootConstrainSelectedInstOperands,
     /* 245094 */     // GIR_Coverage, 9248,
     /* 245094 */     GIR_EraseRootFromParent_Done,
     /* 245095 */   // Label 4697: @245095
     /* 245095 */   GIM_Try, /*On fail goto*//*Label 4698*/ GIMT_Encode4(245140), // Rule ID 9249 //
     /* 245100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245117 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245120 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245124 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1328:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_B),
     /* 245127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245129 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245131 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245133 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245135 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245138 */     GIR_RootConstrainSelectedInstOperands,
     /* 245139 */     // GIR_Coverage, 9249,
     /* 245139 */     GIR_EraseRootFromParent_Done,
     /* 245140 */   // Label 4698: @245140
     /* 245140 */   GIM_Try, /*On fail goto*//*Label 4699*/ GIMT_Encode4(245185), // Rule ID 9250 //
     /* 245145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245169 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1328:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_H),
     /* 245172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245183 */     GIR_RootConstrainSelectedInstOperands,
     /* 245184 */     // GIR_Coverage, 9250,
     /* 245184 */     GIR_EraseRootFromParent_Done,
     /* 245185 */   // Label 4699: @245185
     /* 245185 */   GIM_Try, /*On fail goto*//*Label 4700*/ GIMT_Encode4(245230), // Rule ID 9251 //
     /* 245190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245193 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmphi_wide),
     /* 245198 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245201 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245204 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245207 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245210 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245214 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1328:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPHI_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPHI_WIDE_PPzZZ_S),
     /* 245217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245225 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245228 */     GIR_RootConstrainSelectedInstOperands,
     /* 245229 */     // GIR_Coverage, 9251,
     /* 245229 */     GIR_EraseRootFromParent_Done,
     /* 245230 */   // Label 4700: @245230
     /* 245230 */   GIM_Try, /*On fail goto*//*Label 4701*/ GIMT_Encode4(245275), // Rule ID 9252 //
     /* 245235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245259 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1332:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_B),
     /* 245262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245270 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245273 */     GIR_RootConstrainSelectedInstOperands,
     /* 245274 */     // GIR_Coverage, 9252,
     /* 245274 */     GIR_EraseRootFromParent_Done,
     /* 245275 */   // Label 4701: @245275
     /* 245275 */   GIM_Try, /*On fail goto*//*Label 4702*/ GIMT_Encode4(245320), // Rule ID 9253 //
     /* 245280 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245283 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245288 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245291 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245294 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245297 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245300 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245304 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1332:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_H),
     /* 245307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245311 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245313 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245315 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245318 */     GIR_RootConstrainSelectedInstOperands,
     /* 245319 */     // GIR_Coverage, 9253,
     /* 245319 */     GIR_EraseRootFromParent_Done,
     /* 245320 */   // Label 4702: @245320
     /* 245320 */   GIM_Try, /*On fail goto*//*Label 4703*/ GIMT_Encode4(245365), // Rule ID 9254 //
     /* 245325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmplo_wide),
     /* 245333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245349 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1332:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLO_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLO_WIDE_PPzZZ_S),
     /* 245352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245360 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245363 */     GIR_RootConstrainSelectedInstOperands,
     /* 245364 */     // GIR_Coverage, 9254,
     /* 245364 */     GIR_EraseRootFromParent_Done,
     /* 245365 */   // Label 4703: @245365
     /* 245365 */   GIM_Try, /*On fail goto*//*Label 4704*/ GIMT_Encode4(245410), // Rule ID 9255 //
     /* 245370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245373 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245378 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 245381 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245384 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245387 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245390 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245394 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1333:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_B),
     /* 245397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245405 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245408 */     GIR_RootConstrainSelectedInstOperands,
     /* 245409 */     // GIR_Coverage, 9255,
     /* 245409 */     GIR_EraseRootFromParent_Done,
     /* 245410 */   // Label 4704: @245410
     /* 245410 */   GIM_Try, /*On fail goto*//*Label 4705*/ GIMT_Encode4(245455), // Rule ID 9256 //
     /* 245415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245418 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245423 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245435 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245439 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1333:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_H),
     /* 245442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245446 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245448 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245450 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245453 */     GIR_RootConstrainSelectedInstOperands,
     /* 245454 */     // GIR_Coverage, 9256,
     /* 245454 */     GIR_EraseRootFromParent_Done,
     /* 245455 */   // Label 4705: @245455
     /* 245455 */   GIM_Try, /*On fail goto*//*Label 4706*/ GIMT_Encode4(245500), // Rule ID 9257 //
     /* 245460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245463 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_cmpls_wide),
     /* 245468 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245471 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245474 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245477 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245480 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245484 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1333:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (CMPLS_WIDE_PPzZZ_S:{ *:[nxv4i1] }:{ *:[i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMPLS_WIDE_PPzZZ_S),
     /* 245487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245491 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245493 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245495 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 245498 */     GIR_RootConstrainSelectedInstOperands,
     /* 245499 */     // GIR_Coverage, 9257,
     /* 245499 */     GIR_EraseRootFromParent_Done,
     /* 245500 */   // Label 4706: @245500
     /* 245500 */   GIM_Try, /*On fail goto*//*Label 4707*/ GIMT_Encode4(245542), // Rule ID 9654 //
     /* 245505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 245516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245529 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1369:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FACGT_PPzZZ_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 245529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_H),
     /* 245532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245534 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245538 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245540 */     GIR_RootConstrainSelectedInstOperands,
     /* 245541 */     // GIR_Coverage, 9654,
     /* 245541 */     GIR_EraseRootFromParent_Done,
     /* 245542 */   // Label 4707: @245542
     /* 245542 */   GIM_Try, /*On fail goto*//*Label 4708*/ GIMT_Encode4(245584), // Rule ID 9655 //
     /* 245547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s1,
     /* 245558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245564 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245571 */     // (intrinsic_wo_chain:{ *:[nxv4i1] } 1369:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FACGT_PPzZZ_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 245571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_S),
     /* 245574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245582 */     GIR_RootConstrainSelectedInstOperands,
     /* 245583 */     // GIR_Coverage, 9655,
     /* 245583 */     GIR_EraseRootFromParent_Done,
     /* 245584 */   // Label 4708: @245584
     /* 245584 */   GIM_Try, /*On fail goto*//*Label 4709*/ GIMT_Encode4(245626), // Rule ID 9656 //
     /* 245589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245592 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_facgt),
     /* 245597 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s1,
     /* 245600 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245603 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245606 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 245613 */     // (intrinsic_wo_chain:{ *:[nxv2i1] } 1369:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FACGT_PPzZZ_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 245613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGT_PPzZZ_D),
     /* 245616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 245618 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245622 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245624 */     GIR_RootConstrainSelectedInstOperands,
     /* 245625 */     // GIR_Coverage, 9656,
     /* 245625 */     GIR_EraseRootFromParent_Done,
     /* 245626 */   // Label 4709: @245626
     /* 245626 */   GIM_Try, /*On fail goto*//*Label 4710*/ GIMT_Encode4(245668), // Rule ID 10194 //
     /* 245631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245655 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1600:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_B),
     /* 245658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245662 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245664 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245666 */     GIR_RootConstrainSelectedInstOperands,
     /* 245667 */     // GIR_Coverage, 10194,
     /* 245667 */     GIR_EraseRootFromParent_Done,
     /* 245668 */   // Label 4710: @245668
     /* 245668 */   GIM_Try, /*On fail goto*//*Label 4711*/ GIMT_Encode4(245710), // Rule ID 10195 //
     /* 245673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245676 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245681 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245684 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245687 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245690 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245693 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245697 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1600:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_H),
     /* 245700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245702 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245704 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245706 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245708 */     GIR_RootConstrainSelectedInstOperands,
     /* 245709 */     // GIR_Coverage, 10195,
     /* 245709 */     GIR_EraseRootFromParent_Done,
     /* 245710 */   // Label 4711: @245710
     /* 245710 */   GIM_Try, /*On fail goto*//*Label 4712*/ GIMT_Encode4(245752), // Rule ID 10196 //
     /* 245715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245718 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245723 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245739 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1600:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_S),
     /* 245742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245744 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245746 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245748 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245750 */     GIR_RootConstrainSelectedInstOperands,
     /* 245751 */     // GIR_Coverage, 10196,
     /* 245751 */     GIR_EraseRootFromParent_Done,
     /* 245752 */   // Label 4712: @245752
     /* 245752 */   GIM_Try, /*On fail goto*//*Label 4713*/ GIMT_Encode4(245794), // Rule ID 10197 //
     /* 245757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245760 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr),
     /* 245765 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245768 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245771 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245774 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245777 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245781 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1600:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245781 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_ZPmZ_D),
     /* 245784 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245786 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245790 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245792 */     GIR_RootConstrainSelectedInstOperands,
     /* 245793 */     // GIR_Coverage, 10197,
     /* 245793 */     GIR_EraseRootFromParent_Done,
     /* 245794 */   // Label 4713: @245794
     /* 245794 */   GIM_Try, /*On fail goto*//*Label 4714*/ GIMT_Encode4(245836), // Rule ID 10198 //
     /* 245799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245802 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245807 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245810 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245813 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245816 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 245819 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245823 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1597:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (LSL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 245823 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_B),
     /* 245826 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245828 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245830 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245832 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245834 */     GIR_RootConstrainSelectedInstOperands,
     /* 245835 */     // GIR_Coverage, 10198,
     /* 245835 */     GIR_EraseRootFromParent_Done,
     /* 245836 */   // Label 4714: @245836
     /* 245836 */   GIM_Try, /*On fail goto*//*Label 4715*/ GIMT_Encode4(245878), // Rule ID 10199 //
     /* 245841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245844 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245849 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 245852 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 245855 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 245858 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 245861 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245865 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1597:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (LSL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 245865 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_H),
     /* 245868 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245870 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245874 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245876 */     GIR_RootConstrainSelectedInstOperands,
     /* 245877 */     // GIR_Coverage, 10199,
     /* 245877 */     GIR_EraseRootFromParent_Done,
     /* 245878 */   // Label 4715: @245878
     /* 245878 */   GIM_Try, /*On fail goto*//*Label 4716*/ GIMT_Encode4(245920), // Rule ID 10200 //
     /* 245883 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245886 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245891 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 245894 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 245897 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 245900 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 245903 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245907 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1597:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (LSL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 245907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_S),
     /* 245910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245912 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245916 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245918 */     GIR_RootConstrainSelectedInstOperands,
     /* 245919 */     // GIR_Coverage, 10200,
     /* 245919 */     GIR_EraseRootFromParent_Done,
     /* 245920 */   // Label 4716: @245920
     /* 245920 */   GIM_Try, /*On fail goto*//*Label 4717*/ GIMT_Encode4(245962), // Rule ID 10201 //
     /* 245925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl),
     /* 245933 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 245936 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 245939 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 245942 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245945 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245949 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1597:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_ZPmZ_D),
     /* 245952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245954 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 245958 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 245960 */     GIR_RootConstrainSelectedInstOperands,
     /* 245961 */     // GIR_Coverage, 10201,
     /* 245961 */     GIR_EraseRootFromParent_Done,
     /* 245962 */   // Label 4717: @245962
     /* 245962 */   GIM_Try, /*On fail goto*//*Label 4718*/ GIMT_Encode4(246004), // Rule ID 10214 //
     /* 245967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 245970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 245975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 245978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 245981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 245984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 245987 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 245991 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1602:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 245991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_B),
     /* 245994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 245996 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 245998 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246000 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246002 */     GIR_RootConstrainSelectedInstOperands,
     /* 246003 */     // GIR_Coverage, 10214,
     /* 246003 */     GIR_EraseRootFromParent_Done,
     /* 246004 */   // Label 4718: @246004
     /* 246004 */   GIM_Try, /*On fail goto*//*Label 4719*/ GIMT_Encode4(246046), // Rule ID 10215 //
     /* 246009 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246012 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246017 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246020 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246023 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246026 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246029 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246033 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1602:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_H),
     /* 246036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246042 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246044 */     GIR_RootConstrainSelectedInstOperands,
     /* 246045 */     // GIR_Coverage, 10215,
     /* 246045 */     GIR_EraseRootFromParent_Done,
     /* 246046 */   // Label 4719: @246046
     /* 246046 */   GIM_Try, /*On fail goto*//*Label 4720*/ GIMT_Encode4(246088), // Rule ID 10216 //
     /* 246051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsr_wide),
     /* 246059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246075 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1602:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSR_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSR_WIDE_ZPmZ_S),
     /* 246078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246086 */     GIR_RootConstrainSelectedInstOperands,
     /* 246087 */     // GIR_Coverage, 10216,
     /* 246087 */     GIR_EraseRootFromParent_Done,
     /* 246088 */   // Label 4720: @246088
     /* 246088 */   GIM_Try, /*On fail goto*//*Label 4721*/ GIMT_Encode4(246130), // Rule ID 10217 //
     /* 246093 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246096 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246101 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 246104 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 246107 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 246110 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246113 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246117 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1599:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246117 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_B),
     /* 246120 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246122 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246126 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246128 */     GIR_RootConstrainSelectedInstOperands,
     /* 246129 */     // GIR_Coverage, 10217,
     /* 246129 */     GIR_EraseRootFromParent_Done,
     /* 246130 */   // Label 4721: @246130
     /* 246130 */   GIM_Try, /*On fail goto*//*Label 4722*/ GIMT_Encode4(246172), // Rule ID 10218 //
     /* 246135 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246138 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246143 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246146 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 246149 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 246152 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246155 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246159 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1599:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_H),
     /* 246162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246164 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246166 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246168 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246170 */     GIR_RootConstrainSelectedInstOperands,
     /* 246171 */     // GIR_Coverage, 10218,
     /* 246171 */     GIR_EraseRootFromParent_Done,
     /* 246172 */   // Label 4722: @246172
     /* 246172 */   GIM_Try, /*On fail goto*//*Label 4723*/ GIMT_Encode4(246214), // Rule ID 10219 //
     /* 246177 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246180 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_lsl_wide),
     /* 246185 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246188 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 246191 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 246194 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246201 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1599:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (LSL_WIDE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSL_WIDE_ZPmZ_S),
     /* 246204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 246206 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246210 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246212 */     GIR_RootConstrainSelectedInstOperands,
     /* 246213 */     // GIR_Coverage, 10219,
     /* 246213 */     GIR_EraseRootFromParent_Done,
     /* 246214 */   // Label 4723: @246214
     /* 246214 */   GIM_Try, /*On fail goto*//*Label 4724*/ GIMT_Encode4(246256), // Rule ID 10246 //
     /* 246219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246222 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f16f64),
     /* 246227 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246230 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246233 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246236 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246239 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246243 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1394:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoH),
     /* 246246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246250 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246252 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246254 */     GIR_RootConstrainSelectedInstOperands,
     /* 246255 */     // GIR_Coverage, 10246,
     /* 246255 */     GIR_EraseRootFromParent_Done,
     /* 246256 */   // Label 4724: @246256
     /* 246256 */   GIM_Try, /*On fail goto*//*Label 4725*/ GIMT_Encode4(246298), // Rule ID 10250 //
     /* 246261 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246264 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f16),
     /* 246269 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246272 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246275 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246278 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246285 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1397:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVT_ZPmZ_HtoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_HtoD),
     /* 246288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246290 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246292 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246294 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246296 */     GIR_RootConstrainSelectedInstOperands,
     /* 246297 */     // GIR_Coverage, 10250,
     /* 246297 */     GIR_EraseRootFromParent_Done,
     /* 246298 */   // Label 4725: @246298
     /* 246298 */   GIM_Try, /*On fail goto*//*Label 4726*/ GIMT_Encode4(246340), // Rule ID 10254 //
     /* 246303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246306 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f32f64),
     /* 246311 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246314 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246317 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246320 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246327 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1396:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVT_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_DtoS),
     /* 246330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246334 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246336 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246338 */     GIR_RootConstrainSelectedInstOperands,
     /* 246339 */     // GIR_Coverage, 10254,
     /* 246339 */     GIR_EraseRootFromParent_Done,
     /* 246340 */   // Label 4726: @246340
     /* 246340 */   GIM_Try, /*On fail goto*//*Label 4727*/ GIMT_Encode4(246382), // Rule ID 10258 //
     /* 246345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246348 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvt_f64f32),
     /* 246353 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246356 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246359 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246362 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246365 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246369 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1398:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVT_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVT_ZPmZ_StoD),
     /* 246372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246374 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246378 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246380 */     GIR_RootConstrainSelectedInstOperands,
     /* 246381 */     // GIR_Coverage, 10258,
     /* 246381 */     GIR_EraseRootFromParent_Done,
     /* 246382 */   // Label 4727: @246382
     /* 246382 */   GIM_Try, /*On fail goto*//*Label 4728*/ GIMT_Encode4(246424), // Rule ID 10262 //
     /* 246387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246390 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f64i32),
     /* 246395 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246398 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246401 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246404 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246407 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246411 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1710:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoD),
     /* 246414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246420 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246422 */     GIR_RootConstrainSelectedInstOperands,
     /* 246423 */     // GIR_Coverage, 10262,
     /* 246423 */     GIR_EraseRootFromParent_Done,
     /* 246424 */   // Label 4728: @246424
     /* 246424 */   GIM_Try, /*On fail goto*//*Label 4729*/ GIMT_Encode4(246466), // Rule ID 10263 //
     /* 246429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246432 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f64i32),
     /* 246437 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246440 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246443 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246446 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246449 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246453 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1957:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoD:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoD),
     /* 246456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246458 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246460 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246462 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246464 */     GIR_RootConstrainSelectedInstOperands,
     /* 246465 */     // GIR_Coverage, 10263,
     /* 246465 */     GIR_EraseRootFromParent_Done,
     /* 246466 */   // Label 4729: @246466
     /* 246466 */   GIM_Try, /*On fail goto*//*Label 4730*/ GIMT_Encode4(246508), // Rule ID 10264 //
     /* 246471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i32),
     /* 246479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246491 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246495 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1954:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246495 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_StoH),
     /* 246498 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246500 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246502 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246504 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246506 */     GIR_RootConstrainSelectedInstOperands,
     /* 246507 */     // GIR_Coverage, 10264,
     /* 246507 */     GIR_EraseRootFromParent_Done,
     /* 246508 */   // Label 4730: @246508
     /* 246508 */   GIM_Try, /*On fail goto*//*Label 4731*/ GIMT_Encode4(246550), // Rule ID 10268 //
     /* 246513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246516 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f32i64),
     /* 246521 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246524 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246530 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246533 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246537 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1709:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoS),
     /* 246540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246542 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246546 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246548 */     GIR_RootConstrainSelectedInstOperands,
     /* 246549 */     // GIR_Coverage, 10268,
     /* 246549 */     GIR_EraseRootFromParent_Done,
     /* 246550 */   // Label 4731: @246550
     /* 246550 */   GIM_Try, /*On fail goto*//*Label 4732*/ GIMT_Encode4(246592), // Rule ID 10272 //
     /* 246555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246558 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i32),
     /* 246563 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246566 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246569 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246572 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246579 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1707:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SCVTF_ZPmZ_StoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 246579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_StoH),
     /* 246582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246590 */     GIR_RootConstrainSelectedInstOperands,
     /* 246591 */     // GIR_Coverage, 10272,
     /* 246591 */     GIR_EraseRootFromParent_Done,
     /* 246592 */   // Label 4732: @246592
     /* 246592 */   GIM_Try, /*On fail goto*//*Label 4733*/ GIMT_Encode4(246634), // Rule ID 10276 //
     /* 246597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246600 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_scvtf_f16i64),
     /* 246605 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246614 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246617 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246621 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1708:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTF_ZPmZ_DtoH),
     /* 246624 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246630 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246632 */     GIR_RootConstrainSelectedInstOperands,
     /* 246633 */     // GIR_Coverage, 10276,
     /* 246633 */     GIR_EraseRootFromParent_Done,
     /* 246634 */   // Label 4733: @246634
     /* 246634 */   GIM_Try, /*On fail goto*//*Label 4734*/ GIMT_Encode4(246676), // Rule ID 10280 //
     /* 246639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246642 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f32i64),
     /* 246647 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246650 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246653 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246656 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246659 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246663 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1956:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoS),
     /* 246666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246672 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246674 */     GIR_RootConstrainSelectedInstOperands,
     /* 246675 */     // GIR_Coverage, 10280,
     /* 246675 */     GIR_EraseRootFromParent_Done,
     /* 246676 */   // Label 4734: @246676
     /* 246676 */   GIM_Try, /*On fail goto*//*Label 4735*/ GIMT_Encode4(246718), // Rule ID 10284 //
     /* 246681 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246684 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ucvtf_f16i64),
     /* 246689 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 246692 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 246695 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246698 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246701 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246705 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1955:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCVTF_ZPmZ_DtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 246705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTF_ZPmZ_DtoH),
     /* 246708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246714 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246716 */     GIR_RootConstrainSelectedInstOperands,
     /* 246717 */     // GIR_Coverage, 10284,
     /* 246717 */     GIR_EraseRootFromParent_Done,
     /* 246718 */   // Label 4735: @246718
     /* 246718 */   GIM_Try, /*On fail goto*//*Label 4736*/ GIMT_Encode4(246760), // Rule ID 10294 //
     /* 246723 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246726 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f64),
     /* 246731 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246734 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246737 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246740 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246743 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246747 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1412:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZS_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_DtoS),
     /* 246750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246756 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246758 */     GIR_RootConstrainSelectedInstOperands,
     /* 246759 */     // GIR_Coverage, 10294,
     /* 246759 */     GIR_EraseRootFromParent_Done,
     /* 246760 */   // Label 4736: @246760
     /* 246760 */   GIM_Try, /*On fail goto*//*Label 4737*/ GIMT_Encode4(246802), // Rule ID 10295 //
     /* 246765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246768 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f64),
     /* 246773 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246776 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246779 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246782 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 246785 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246789 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1419:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FCVTZU_ZPmZ_DtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 246789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_DtoS),
     /* 246792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246798 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246800 */     GIR_RootConstrainSelectedInstOperands,
     /* 246801 */     // GIR_Coverage, 10295,
     /* 246801 */     GIR_EraseRootFromParent_Done,
     /* 246802 */   // Label 4737: @246802
     /* 246802 */   GIM_Try, /*On fail goto*//*Label 4738*/ GIMT_Encode4(246844), // Rule ID 10296 //
     /* 246807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246810 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f32),
     /* 246815 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246824 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 246827 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246831 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1414:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZS_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 246831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_StoD),
     /* 246834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246840 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246842 */     GIR_RootConstrainSelectedInstOperands,
     /* 246843 */     // GIR_Coverage, 10296,
     /* 246843 */     GIR_EraseRootFromParent_Done,
     /* 246844 */   // Label 4738: @246844
     /* 246844 */   GIM_Try, /*On fail goto*//*Label 4739*/ GIMT_Encode4(246886), // Rule ID 10300 //
     /* 246849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246852 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i32f16),
     /* 246857 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246860 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246863 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246866 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246869 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246873 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1411:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoS),
     /* 246876 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246882 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246884 */     GIR_RootConstrainSelectedInstOperands,
     /* 246885 */     // GIR_Coverage, 10300,
     /* 246885 */     GIR_EraseRootFromParent_Done,
     /* 246886 */   // Label 4739: @246886
     /* 246886 */   GIM_Try, /*On fail goto*//*Label 4740*/ GIMT_Encode4(246928), // Rule ID 10304 //
     /* 246891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246894 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzs_i64f16),
     /* 246899 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246902 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246905 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246908 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246911 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246915 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1413:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZS_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZS_ZPmZ_HtoD),
     /* 246918 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246924 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246926 */     GIR_RootConstrainSelectedInstOperands,
     /* 246927 */     // GIR_Coverage, 10304,
     /* 246927 */     GIR_EraseRootFromParent_Done,
     /* 246928 */   // Label 4740: @246928
     /* 246928 */   GIM_Try, /*On fail goto*//*Label 4741*/ GIMT_Encode4(246970), // Rule ID 10308 //
     /* 246933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246936 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i32f16),
     /* 246941 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 246944 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 246947 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 246950 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246953 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246957 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1418:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoS),
     /* 246960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 246962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 246964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 246966 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 246968 */     GIR_RootConstrainSelectedInstOperands,
     /* 246969 */     // GIR_Coverage, 10308,
     /* 246969 */     GIR_EraseRootFromParent_Done,
     /* 246970 */   // Label 4741: @246970
     /* 246970 */   GIM_Try, /*On fail goto*//*Label 4742*/ GIMT_Encode4(247012), // Rule ID 10312 //
     /* 246975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 246978 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f16),
     /* 246983 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 246986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 246989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 246992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 246995 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 246999 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1420:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FCVTZU_ZPmZ_HtoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 246999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_HtoD),
     /* 247002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247008 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247010 */     GIR_RootConstrainSelectedInstOperands,
     /* 247011 */     // GIR_Coverage, 10312,
     /* 247011 */     GIR_EraseRootFromParent_Done,
     /* 247012 */   // Label 4742: @247012
     /* 247012 */   GIM_Try, /*On fail goto*//*Label 4743*/ GIMT_Encode4(247054), // Rule ID 10316 //
     /* 247017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 247020 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fcvtzu_i64f32),
     /* 247025 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247028 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247031 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 247034 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247041 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1421:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FCVTZU_ZPmZ_StoD:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZU_ZPmZ_StoD),
     /* 247044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 247046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247052 */     GIR_RootConstrainSelectedInstOperands,
     /* 247053 */     // GIR_Coverage, 10316,
     /* 247053 */     GIR_EraseRootFromParent_Done,
     /* 247054 */   // Label 4743: @247054
     /* 247054 */   GIM_Try, /*On fail goto*//*Label 4744*/ GIMT_Encode4(247096), // Rule ID 11313 //
     /* 247059 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247062 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ummla),
     /* 247067 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247070 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247073 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247076 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247079 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247083 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1996:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMMLA_ZZZ),
     /* 247086 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247092 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247094 */     GIR_RootConstrainSelectedInstOperands,
     /* 247095 */     // GIR_Coverage, 11313,
     /* 247095 */     GIR_EraseRootFromParent_Done,
     /* 247096 */   // Label 4744: @247096
     /* 247096 */   GIM_Try, /*On fail goto*//*Label 4745*/ GIMT_Encode4(247138), // Rule ID 11314 //
     /* 247101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE),
     /* 247104 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usmmla),
     /* 247109 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247112 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247115 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247118 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247121 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247125 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2067:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USMMLA_ZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMMLA_ZZZ),
     /* 247128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247134 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247136 */     GIR_RootConstrainSelectedInstOperands,
     /* 247137 */     // GIR_Coverage, 11314,
     /* 247137 */     GIR_EraseRootFromParent_Done,
     /* 247138 */   // Label 4745: @247138
     /* 247138 */   GIM_Try, /*On fail goto*//*Label 4746*/ GIMT_Encode4(247180), // Rule ID 11316 //
     /* 247143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP32_HasSVE),
     /* 247146 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247151 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247154 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247157 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247160 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247163 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247167 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1482:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMMLA_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 247167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_S),
     /* 247170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247176 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247178 */     GIR_RootConstrainSelectedInstOperands,
     /* 247179 */     // GIR_Coverage, 11316,
     /* 247179 */     GIR_EraseRootFromParent_Done,
     /* 247180 */   // Label 4746: @247180
     /* 247180 */   GIM_Try, /*On fail goto*//*Label 4747*/ GIMT_Encode4(247222), // Rule ID 11317 //
     /* 247185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulFP64_HasSVE),
     /* 247188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmmla),
     /* 247193 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247202 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247205 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247209 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1482:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMMLA_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 247209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMMLA_ZZZ_D),
     /* 247212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247218 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247220 */     GIR_RootConstrainSelectedInstOperands,
     /* 247221 */     // GIR_Coverage, 11317,
     /* 247221 */     GIR_EraseRootFromParent_Done,
     /* 247222 */   // Label 4747: @247222
     /* 247222 */   GIM_Try, /*On fail goto*//*Label 4748*/ GIMT_Encode4(247264), // Rule ID 11371 //
     /* 247227 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247230 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247235 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 247238 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 247241 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247244 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247247 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247251 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1831:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRDMLSH_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_B),
     /* 247254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247260 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247262 */     GIR_RootConstrainSelectedInstOperands,
     /* 247263 */     // GIR_Coverage, 11371,
     /* 247263 */     GIR_EraseRootFromParent_Done,
     /* 247264 */   // Label 4748: @247264
     /* 247264 */   GIM_Try, /*On fail goto*//*Label 4749*/ GIMT_Encode4(247306), // Rule ID 11372 //
     /* 247269 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247272 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247277 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247280 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247283 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247286 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247289 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247293 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1831:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRDMLSH_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_H),
     /* 247296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247302 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247304 */     GIR_RootConstrainSelectedInstOperands,
     /* 247305 */     // GIR_Coverage, 11372,
     /* 247305 */     GIR_EraseRootFromParent_Done,
     /* 247306 */   // Label 4749: @247306
     /* 247306 */   GIM_Try, /*On fail goto*//*Label 4750*/ GIMT_Encode4(247348), // Rule ID 11373 //
     /* 247311 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247314 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247319 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247322 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247325 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247328 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247331 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247335 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1831:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRDMLSH_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_S),
     /* 247338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247344 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247346 */     GIR_RootConstrainSelectedInstOperands,
     /* 247347 */     // GIR_Coverage, 11373,
     /* 247347 */     GIR_EraseRootFromParent_Done,
     /* 247348 */   // Label 4750: @247348
     /* 247348 */   GIM_Try, /*On fail goto*//*Label 4751*/ GIMT_Encode4(247390), // Rule ID 11374 //
     /* 247353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247356 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh),
     /* 247361 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247364 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247367 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 247370 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 247373 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247377 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1831:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRDMLSH_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 247377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZ_D),
     /* 247380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247388 */     GIR_RootConstrainSelectedInstOperands,
     /* 247389 */     // GIR_Coverage, 11374,
     /* 247389 */     GIR_EraseRootFromParent_Done,
     /* 247390 */   // Label 4751: @247390
     /* 247390 */   GIM_Try, /*On fail goto*//*Label 4752*/ GIMT_Encode4(247432), // Rule ID 11427 //
     /* 247395 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247398 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247403 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247415 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247419 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1752:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_H),
     /* 247422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247428 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247430 */     GIR_RootConstrainSelectedInstOperands,
     /* 247431 */     // GIR_Coverage, 11427,
     /* 247431 */     GIR_EraseRootFromParent_Done,
     /* 247432 */   // Label 4752: @247432
     /* 247432 */   GIM_Try, /*On fail goto*//*Label 4753*/ GIMT_Encode4(247474), // Rule ID 11428 //
     /* 247437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247457 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247461 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1752:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_S),
     /* 247464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247470 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247472 */     GIR_RootConstrainSelectedInstOperands,
     /* 247473 */     // GIR_Coverage, 11428,
     /* 247473 */     GIR_EraseRootFromParent_Done,
     /* 247474 */   // Label 4753: @247474
     /* 247474 */   GIM_Try, /*On fail goto*//*Label 4754*/ GIMT_Encode4(247516), // Rule ID 11429 //
     /* 247479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247482 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt),
     /* 247487 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247490 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247493 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247496 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247503 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1752:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZ_D),
     /* 247506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247512 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247514 */     GIR_RootConstrainSelectedInstOperands,
     /* 247515 */     // GIR_Coverage, 11429,
     /* 247515 */     GIR_EraseRootFromParent_Done,
     /* 247516 */   // Label 4754: @247516
     /* 247516 */   GIM_Try, /*On fail goto*//*Label 4755*/ GIMT_Encode4(247558), // Rule ID 11430 //
     /* 247521 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247524 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247529 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247532 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247535 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247538 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247545 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1988:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_H),
     /* 247548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247556 */     GIR_RootConstrainSelectedInstOperands,
     /* 247557 */     // GIR_Coverage, 11430,
     /* 247557 */     GIR_EraseRootFromParent_Done,
     /* 247558 */   // Label 4755: @247558
     /* 247558 */   GIM_Try, /*On fail goto*//*Label 4756*/ GIMT_Encode4(247600), // Rule ID 11431 //
     /* 247563 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247566 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247571 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247574 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247577 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247580 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247583 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247587 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1988:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_S),
     /* 247590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247596 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247598 */     GIR_RootConstrainSelectedInstOperands,
     /* 247599 */     // GIR_Coverage, 11431,
     /* 247599 */     GIR_EraseRootFromParent_Done,
     /* 247600 */   // Label 4756: @247600
     /* 247600 */   GIM_Try, /*On fail goto*//*Label 4757*/ GIMT_Encode4(247642), // Rule ID 11432 //
     /* 247605 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247608 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb),
     /* 247613 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247616 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247619 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247622 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247625 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247629 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1988:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZ_D),
     /* 247632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247638 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247640 */     GIR_RootConstrainSelectedInstOperands,
     /* 247641 */     // GIR_Coverage, 11432,
     /* 247641 */     GIR_EraseRootFromParent_Done,
     /* 247642 */   // Label 4757: @247642
     /* 247642 */   GIM_Try, /*On fail goto*//*Label 4758*/ GIMT_Encode4(247684), // Rule ID 11433 //
     /* 247647 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247650 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247655 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247658 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247661 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247664 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247667 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247671 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1990:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_H),
     /* 247674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247680 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247682 */     GIR_RootConstrainSelectedInstOperands,
     /* 247683 */     // GIR_Coverage, 11433,
     /* 247683 */     GIR_EraseRootFromParent_Done,
     /* 247684 */   // Label 4758: @247684
     /* 247684 */   GIM_Try, /*On fail goto*//*Label 4759*/ GIMT_Encode4(247726), // Rule ID 11434 //
     /* 247689 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247692 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247697 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247700 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247703 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247706 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247709 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247713 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1990:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_S),
     /* 247716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247722 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247724 */     GIR_RootConstrainSelectedInstOperands,
     /* 247725 */     // GIR_Coverage, 11434,
     /* 247725 */     GIR_EraseRootFromParent_Done,
     /* 247726 */   // Label 4759: @247726
     /* 247726 */   GIM_Try, /*On fail goto*//*Label 4760*/ GIMT_Encode4(247768), // Rule ID 11435 //
     /* 247731 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247734 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt),
     /* 247739 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247742 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247745 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247748 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247755 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1990:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZ_D),
     /* 247758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247764 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247766 */     GIR_RootConstrainSelectedInstOperands,
     /* 247767 */     // GIR_Coverage, 11435,
     /* 247767 */     GIR_EraseRootFromParent_Done,
     /* 247768 */   // Label 4760: @247768
     /* 247768 */   GIM_Try, /*On fail goto*//*Label 4761*/ GIMT_Encode4(247810), // Rule ID 11436 //
     /* 247773 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247776 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247781 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247784 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247787 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247790 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247793 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247797 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1754:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_H),
     /* 247800 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247806 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247808 */     GIR_RootConstrainSelectedInstOperands,
     /* 247809 */     // GIR_Coverage, 11436,
     /* 247809 */     GIR_EraseRootFromParent_Done,
     /* 247810 */   // Label 4761: @247810
     /* 247810 */   GIM_Try, /*On fail goto*//*Label 4762*/ GIMT_Encode4(247852), // Rule ID 11437 //
     /* 247815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247818 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247823 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247835 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247839 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1754:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_S),
     /* 247842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247848 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247850 */     GIR_RootConstrainSelectedInstOperands,
     /* 247851 */     // GIR_Coverage, 11437,
     /* 247851 */     GIR_EraseRootFromParent_Done,
     /* 247852 */   // Label 4762: @247852
     /* 247852 */   GIM_Try, /*On fail goto*//*Label 4763*/ GIMT_Encode4(247894), // Rule ID 11438 //
     /* 247857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247860 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb),
     /* 247865 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247868 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247871 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 247874 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 247877 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247881 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1754:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 247881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZ_D),
     /* 247884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247888 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247890 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247892 */     GIR_RootConstrainSelectedInstOperands,
     /* 247893 */     // GIR_Coverage, 11438,
     /* 247893 */     GIR_EraseRootFromParent_Done,
     /* 247894 */   // Label 4763: @247894
     /* 247894 */   GIM_Try, /*On fail goto*//*Label 4764*/ GIMT_Encode4(247936), // Rule ID 11439 //
     /* 247899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247902 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 247907 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 247910 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 247913 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 247916 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 247919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247923 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1756:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 247923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_H),
     /* 247926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247928 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247932 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247934 */     GIR_RootConstrainSelectedInstOperands,
     /* 247935 */     // GIR_Coverage, 11439,
     /* 247935 */     GIR_EraseRootFromParent_Done,
     /* 247936 */   // Label 4764: @247936
     /* 247936 */   GIM_Try, /*On fail goto*//*Label 4765*/ GIMT_Encode4(247978), // Rule ID 11440 //
     /* 247941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 247949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 247952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 247955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 247958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 247961 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 247965 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1756:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 247965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_S),
     /* 247968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 247970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 247972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 247974 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 247976 */     GIR_RootConstrainSelectedInstOperands,
     /* 247977 */     // GIR_Coverage, 11440,
     /* 247977 */     GIR_EraseRootFromParent_Done,
     /* 247978 */   // Label 4765: @247978
     /* 247978 */   GIM_Try, /*On fail goto*//*Label 4766*/ GIMT_Encode4(248020), // Rule ID 11441 //
     /* 247983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 247986 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt),
     /* 247991 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 247994 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 247997 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248000 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248003 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248007 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1756:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZ_D),
     /* 248010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248014 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248016 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248018 */     GIR_RootConstrainSelectedInstOperands,
     /* 248019 */     // GIR_Coverage, 11441,
     /* 248019 */     GIR_EraseRootFromParent_Done,
     /* 248020 */   // Label 4766: @248020
     /* 248020 */   GIM_Try, /*On fail goto*//*Label 4767*/ GIMT_Encode4(248062), // Rule ID 11442 //
     /* 248025 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248028 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248033 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248036 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248039 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248042 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248045 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248049 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1992:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_H),
     /* 248052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248054 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248058 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248060 */     GIR_RootConstrainSelectedInstOperands,
     /* 248061 */     // GIR_Coverage, 11442,
     /* 248061 */     GIR_EraseRootFromParent_Done,
     /* 248062 */   // Label 4767: @248062
     /* 248062 */   GIM_Try, /*On fail goto*//*Label 4768*/ GIMT_Encode4(248104), // Rule ID 11443 //
     /* 248067 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248070 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248075 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248078 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248081 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248084 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248091 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1992:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_S),
     /* 248094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248100 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248102 */     GIR_RootConstrainSelectedInstOperands,
     /* 248103 */     // GIR_Coverage, 11443,
     /* 248103 */     GIR_EraseRootFromParent_Done,
     /* 248104 */   // Label 4768: @248104
     /* 248104 */   GIM_Try, /*On fail goto*//*Label 4769*/ GIMT_Encode4(248146), // Rule ID 11444 //
     /* 248109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb),
     /* 248117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248133 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1992:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZ_D),
     /* 248136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248140 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248142 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248144 */     GIR_RootConstrainSelectedInstOperands,
     /* 248145 */     // GIR_Coverage, 11444,
     /* 248145 */     GIR_EraseRootFromParent_Done,
     /* 248146 */   // Label 4769: @248146
     /* 248146 */   GIM_Try, /*On fail goto*//*Label 4770*/ GIMT_Encode4(248188), // Rule ID 11445 //
     /* 248151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248159 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248162 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248165 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248168 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248171 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248175 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1994:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_H),
     /* 248178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248180 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248184 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248186 */     GIR_RootConstrainSelectedInstOperands,
     /* 248187 */     // GIR_Coverage, 11445,
     /* 248187 */     GIR_EraseRootFromParent_Done,
     /* 248188 */   // Label 4770: @248188
     /* 248188 */   GIM_Try, /*On fail goto*//*Label 4771*/ GIMT_Encode4(248230), // Rule ID 11446 //
     /* 248193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248196 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248201 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248204 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248207 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248210 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248213 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248217 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1994:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_S),
     /* 248220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248222 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248224 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248226 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248228 */     GIR_RootConstrainSelectedInstOperands,
     /* 248229 */     // GIR_Coverage, 11446,
     /* 248229 */     GIR_EraseRootFromParent_Done,
     /* 248230 */   // Label 4771: @248230
     /* 248230 */   GIM_Try, /*On fail goto*//*Label 4772*/ GIMT_Encode4(248272), // Rule ID 11447 //
     /* 248235 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248238 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt),
     /* 248243 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248255 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248259 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1994:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248259 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZ_D),
     /* 248262 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248264 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248266 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248268 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248270 */     GIR_RootConstrainSelectedInstOperands,
     /* 248271 */     // GIR_Coverage, 11447,
     /* 248271 */     GIR_EraseRootFromParent_Done,
     /* 248272 */   // Label 4772: @248272
     /* 248272 */   GIM_Try, /*On fail goto*//*Label 4773*/ GIMT_Encode4(248314), // Rule ID 11456 //
     /* 248277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248280 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248285 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248288 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248291 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248294 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248297 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248301 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1792:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_H),
     /* 248304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248306 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248310 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248312 */     GIR_RootConstrainSelectedInstOperands,
     /* 248313 */     // GIR_Coverage, 11456,
     /* 248313 */     GIR_EraseRootFromParent_Done,
     /* 248314 */   // Label 4773: @248314
     /* 248314 */   GIM_Try, /*On fail goto*//*Label 4774*/ GIMT_Encode4(248356), // Rule ID 11457 //
     /* 248319 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248322 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248327 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248330 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248333 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248336 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248343 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1792:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248343 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_S),
     /* 248346 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248348 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248350 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248352 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248354 */     GIR_RootConstrainSelectedInstOperands,
     /* 248355 */     // GIR_Coverage, 11457,
     /* 248355 */     GIR_EraseRootFromParent_Done,
     /* 248356 */   // Label 4774: @248356
     /* 248356 */   GIM_Try, /*On fail goto*//*Label 4775*/ GIMT_Encode4(248398), // Rule ID 11458 //
     /* 248361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248364 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb),
     /* 248369 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248372 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248375 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248378 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248381 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248385 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1792:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248385 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZ_D),
     /* 248388 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248390 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248392 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248394 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248396 */     GIR_RootConstrainSelectedInstOperands,
     /* 248397 */     // GIR_Coverage, 11458,
     /* 248397 */     GIR_EraseRootFromParent_Done,
     /* 248398 */   // Label 4775: @248398
     /* 248398 */   GIM_Try, /*On fail goto*//*Label 4776*/ GIMT_Encode4(248440), // Rule ID 11459 //
     /* 248403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248423 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248427 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1795:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_H),
     /* 248430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248434 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248436 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248438 */     GIR_RootConstrainSelectedInstOperands,
     /* 248439 */     // GIR_Coverage, 11459,
     /* 248439 */     GIR_EraseRootFromParent_Done,
     /* 248440 */   // Label 4776: @248440
     /* 248440 */   GIM_Try, /*On fail goto*//*Label 4777*/ GIMT_Encode4(248482), // Rule ID 11460 //
     /* 248445 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248448 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248453 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248456 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248459 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248462 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248465 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248469 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1795:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_S),
     /* 248472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248474 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248478 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248480 */     GIR_RootConstrainSelectedInstOperands,
     /* 248481 */     // GIR_Coverage, 11460,
     /* 248481 */     GIR_EraseRootFromParent_Done,
     /* 248482 */   // Label 4777: @248482
     /* 248482 */   GIM_Try, /*On fail goto*//*Label 4778*/ GIMT_Encode4(248524), // Rule ID 11461 //
     /* 248487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248490 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt),
     /* 248495 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248498 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248501 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248504 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1795:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZ_D),
     /* 248514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248522 */     GIR_RootConstrainSelectedInstOperands,
     /* 248523 */     // GIR_Coverage, 11461,
     /* 248523 */     GIR_EraseRootFromParent_Done,
     /* 248524 */   // Label 4778: @248524
     /* 248524 */   GIM_Try, /*On fail goto*//*Label 4779*/ GIMT_Encode4(248566), // Rule ID 11462 //
     /* 248529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248532 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248537 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248540 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248543 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248546 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248549 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248553 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1797:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_H),
     /* 248556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248558 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248560 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248562 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248564 */     GIR_RootConstrainSelectedInstOperands,
     /* 248565 */     // GIR_Coverage, 11462,
     /* 248565 */     GIR_EraseRootFromParent_Done,
     /* 248566 */   // Label 4779: @248566
     /* 248566 */   GIM_Try, /*On fail goto*//*Label 4780*/ GIMT_Encode4(248608), // Rule ID 11463 //
     /* 248571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248579 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248582 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248585 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248588 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248591 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248595 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1797:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_S),
     /* 248598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248600 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248602 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248604 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248606 */     GIR_RootConstrainSelectedInstOperands,
     /* 248607 */     // GIR_Coverage, 11463,
     /* 248607 */     GIR_EraseRootFromParent_Done,
     /* 248608 */   // Label 4780: @248608
     /* 248608 */   GIM_Try, /*On fail goto*//*Label 4781*/ GIMT_Encode4(248650), // Rule ID 11464 //
     /* 248613 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248616 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb),
     /* 248621 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248630 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248633 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248637 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1797:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248637 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZ_D),
     /* 248640 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248642 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248644 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248646 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248648 */     GIR_RootConstrainSelectedInstOperands,
     /* 248649 */     // GIR_Coverage, 11464,
     /* 248649 */     GIR_EraseRootFromParent_Done,
     /* 248650 */   // Label 4781: @248650
     /* 248650 */   GIM_Try, /*On fail goto*//*Label 4782*/ GIMT_Encode4(248692), // Rule ID 11465 //
     /* 248655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248658 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248663 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248675 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248679 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1800:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248679 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_H),
     /* 248682 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248684 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248686 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248688 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248690 */     GIR_RootConstrainSelectedInstOperands,
     /* 248691 */     // GIR_Coverage, 11465,
     /* 248691 */     GIR_EraseRootFromParent_Done,
     /* 248692 */   // Label 4782: @248692
     /* 248692 */   GIM_Try, /*On fail goto*//*Label 4783*/ GIMT_Encode4(248734), // Rule ID 11466 //
     /* 248697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248700 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248705 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248708 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248711 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248714 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248717 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248721 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1800:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248721 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_S),
     /* 248724 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248726 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248730 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248732 */     GIR_RootConstrainSelectedInstOperands,
     /* 248733 */     // GIR_Coverage, 11466,
     /* 248733 */     GIR_EraseRootFromParent_Done,
     /* 248734 */   // Label 4783: @248734
     /* 248734 */   GIM_Try, /*On fail goto*//*Label 4784*/ GIMT_Encode4(248776), // Rule ID 11467 //
     /* 248739 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248742 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt),
     /* 248747 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248756 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248763 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1800:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248763 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZ_D),
     /* 248766 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248768 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248770 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248772 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248774 */     GIR_RootConstrainSelectedInstOperands,
     /* 248775 */     // GIR_Coverage, 11467,
     /* 248775 */     GIR_EraseRootFromParent_Done,
     /* 248776 */   // Label 4784: @248776
     /* 248776 */   GIM_Try, /*On fail goto*//*Label 4785*/ GIMT_Encode4(248818), // Rule ID 11468 //
     /* 248781 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248784 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248789 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248792 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248795 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248798 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248801 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248805 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1794:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLALBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_H),
     /* 248808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248810 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248812 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248814 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248816 */     GIR_RootConstrainSelectedInstOperands,
     /* 248817 */     // GIR_Coverage, 11468,
     /* 248817 */     GIR_EraseRootFromParent_Done,
     /* 248818 */   // Label 4785: @248818
     /* 248818 */   GIM_Try, /*On fail goto*//*Label 4786*/ GIMT_Encode4(248860), // Rule ID 11469 //
     /* 248823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248826 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248831 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248834 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248837 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248840 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248847 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1794:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLALBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248847 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_S),
     /* 248850 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248852 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248854 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248856 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248858 */     GIR_RootConstrainSelectedInstOperands,
     /* 248859 */     // GIR_Coverage, 11469,
     /* 248859 */     GIR_EraseRootFromParent_Done,
     /* 248860 */   // Label 4786: @248860
     /* 248860 */   GIM_Try, /*On fail goto*//*Label 4787*/ GIMT_Encode4(248902), // Rule ID 11470 //
     /* 248865 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248868 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalbt),
     /* 248873 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 248876 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 248879 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 248882 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 248885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248889 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1794:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLALBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 248889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALBT_ZZZ_D),
     /* 248892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248898 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248900 */     GIR_RootConstrainSelectedInstOperands,
     /* 248901 */     // GIR_Coverage, 11470,
     /* 248901 */     GIR_EraseRootFromParent_Done,
     /* 248902 */   // Label 4787: @248902
     /* 248902 */   GIM_Try, /*On fail goto*//*Label 4788*/ GIMT_Encode4(248944), // Rule ID 11471 //
     /* 248907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 248915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 248918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 248921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 248924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 248927 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248931 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1799:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQDMLSLBT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 248931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_H),
     /* 248934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248936 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248940 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248942 */     GIR_RootConstrainSelectedInstOperands,
     /* 248943 */     // GIR_Coverage, 11471,
     /* 248943 */     GIR_EraseRootFromParent_Done,
     /* 248944 */   // Label 4788: @248944
     /* 248944 */   GIM_Try, /*On fail goto*//*Label 4789*/ GIMT_Encode4(248986), // Rule ID 11472 //
     /* 248949 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248952 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 248957 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 248960 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 248963 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 248966 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 248969 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 248973 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1799:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQDMLSLBT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 248973 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_S),
     /* 248976 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 248978 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 248980 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 248982 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 248984 */     GIR_RootConstrainSelectedInstOperands,
     /* 248985 */     // GIR_Coverage, 11472,
     /* 248985 */     GIR_EraseRootFromParent_Done,
     /* 248986 */   // Label 4789: @248986
     /* 248986 */   GIM_Try, /*On fail goto*//*Label 4790*/ GIMT_Encode4(249028), // Rule ID 11473 //
     /* 248991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 248994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslbt),
     /* 248999 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249002 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 249005 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249008 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249015 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1799:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQDMLSLBT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLBT_ZZZ_D),
     /* 249018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 249020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249026 */     GIR_RootConstrainSelectedInstOperands,
     /* 249027 */     // GIR_Coverage, 11473,
     /* 249027 */     GIR_EraseRootFromParent_Done,
     /* 249028 */   // Label 4790: @249028
     /* 249028 */   GIM_Try, /*On fail goto*//*Label 4791*/ GIMT_Encode4(249070), // Rule ID 11474 //
     /* 249033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249036 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249041 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249044 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249047 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249050 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249057 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1967:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_B),
     /* 249060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249062 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249064 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249066 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249068 */     GIR_RootConstrainSelectedInstOperands,
     /* 249069 */     // GIR_Coverage, 11474,
     /* 249069 */     GIR_EraseRootFromParent_Done,
     /* 249070 */   // Label 4791: @249070
     /* 249070 */   GIM_Try, /*On fail goto*//*Label 4792*/ GIMT_Encode4(249112), // Rule ID 11476 //
     /* 249075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249078 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249083 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249086 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249089 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249092 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249099 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1967:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_H),
     /* 249102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249104 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249108 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249110 */     GIR_RootConstrainSelectedInstOperands,
     /* 249111 */     // GIR_Coverage, 11476,
     /* 249111 */     GIR_EraseRootFromParent_Done,
     /* 249112 */   // Label 4792: @249112
     /* 249112 */   GIM_Try, /*On fail goto*//*Label 4793*/ GIMT_Encode4(249154), // Rule ID 11478 //
     /* 249117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249120 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249125 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249128 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249131 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249134 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249137 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249141 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1967:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_S),
     /* 249144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249146 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249148 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249150 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249152 */     GIR_RootConstrainSelectedInstOperands,
     /* 249153 */     // GIR_Coverage, 11478,
     /* 249153 */     GIR_EraseRootFromParent_Done,
     /* 249154 */   // Label 4793: @249154
     /* 249154 */   GIM_Try, /*On fail goto*//*Label 4794*/ GIMT_Encode4(249196), // Rule ID 11480 //
     /* 249159 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249162 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhadd),
     /* 249167 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249170 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249173 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249176 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249179 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249183 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1967:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHADD_ZPmZ_D),
     /* 249186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249190 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249192 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249194 */     GIR_RootConstrainSelectedInstOperands,
     /* 249195 */     // GIR_Coverage, 11480,
     /* 249195 */     GIR_EraseRootFromParent_Done,
     /* 249196 */   // Label 4794: @249196
     /* 249196 */   GIM_Try, /*On fail goto*//*Label 4795*/ GIMT_Encode4(249238), // Rule ID 11482 //
     /* 249201 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249204 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249209 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249212 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249215 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249218 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249221 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249225 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1727:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_B),
     /* 249228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249230 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249232 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249234 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249236 */     GIR_RootConstrainSelectedInstOperands,
     /* 249237 */     // GIR_Coverage, 11482,
     /* 249237 */     GIR_EraseRootFromParent_Done,
     /* 249238 */   // Label 4795: @249238
     /* 249238 */   GIM_Try, /*On fail goto*//*Label 4796*/ GIMT_Encode4(249280), // Rule ID 11483 //
     /* 249243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249246 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249251 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249254 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249257 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249260 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249267 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1727:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249267 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_H),
     /* 249270 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249272 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249274 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249276 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249278 */     GIR_RootConstrainSelectedInstOperands,
     /* 249279 */     // GIR_Coverage, 11483,
     /* 249279 */     GIR_EraseRootFromParent_Done,
     /* 249280 */   // Label 4796: @249280
     /* 249280 */   GIM_Try, /*On fail goto*//*Label 4797*/ GIMT_Encode4(249322), // Rule ID 11484 //
     /* 249285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249288 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249293 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249296 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249299 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249302 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249305 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249309 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1727:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_S),
     /* 249312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249314 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249316 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249318 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249320 */     GIR_RootConstrainSelectedInstOperands,
     /* 249321 */     // GIR_Coverage, 11484,
     /* 249321 */     GIR_EraseRootFromParent_Done,
     /* 249322 */   // Label 4797: @249322
     /* 249322 */   GIM_Try, /*On fail goto*//*Label 4798*/ GIMT_Encode4(249364), // Rule ID 11485 //
     /* 249327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249330 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsub),
     /* 249335 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249338 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249341 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249344 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249351 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1727:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249351 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUB_ZPmZ_D),
     /* 249354 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249360 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249362 */     GIR_RootConstrainSelectedInstOperands,
     /* 249363 */     // GIR_Coverage, 11485,
     /* 249363 */     GIR_EraseRootFromParent_Done,
     /* 249364 */   // Label 4798: @249364
     /* 249364 */   GIM_Try, /*On fail goto*//*Label 4799*/ GIMT_Encode4(249406), // Rule ID 11486 //
     /* 249369 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249372 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249377 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249386 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249393 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1968:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_B),
     /* 249396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249402 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249404 */     GIR_RootConstrainSelectedInstOperands,
     /* 249405 */     // GIR_Coverage, 11486,
     /* 249405 */     GIR_EraseRootFromParent_Done,
     /* 249406 */   // Label 4799: @249406
     /* 249406 */   GIM_Try, /*On fail goto*//*Label 4800*/ GIMT_Encode4(249448), // Rule ID 11487 //
     /* 249411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249431 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249435 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1968:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_H),
     /* 249438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249446 */     GIR_RootConstrainSelectedInstOperands,
     /* 249447 */     // GIR_Coverage, 11487,
     /* 249447 */     GIR_EraseRootFromParent_Done,
     /* 249448 */   // Label 4800: @249448
     /* 249448 */   GIM_Try, /*On fail goto*//*Label 4801*/ GIMT_Encode4(249490), // Rule ID 11488 //
     /* 249453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249456 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249461 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249464 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249467 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249470 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249477 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1968:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_S),
     /* 249480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249488 */     GIR_RootConstrainSelectedInstOperands,
     /* 249489 */     // GIR_Coverage, 11488,
     /* 249489 */     GIR_EraseRootFromParent_Done,
     /* 249490 */   // Label 4801: @249490
     /* 249490 */   GIM_Try, /*On fail goto*//*Label 4802*/ GIMT_Encode4(249532), // Rule ID 11489 //
     /* 249495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249498 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsub),
     /* 249503 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249506 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249509 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249512 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249519 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1968:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUB_ZPmZ_D),
     /* 249522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249526 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249528 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249530 */     GIR_RootConstrainSelectedInstOperands,
     /* 249531 */     // GIR_Coverage, 11489,
     /* 249531 */     GIR_EraseRootFromParent_Done,
     /* 249532 */   // Label 4802: @249532
     /* 249532 */   GIM_Try, /*On fail goto*//*Label 4803*/ GIMT_Encode4(249574), // Rule ID 11490 //
     /* 249537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249540 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249545 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249548 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249551 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249554 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249557 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249561 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1862:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249561 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_B),
     /* 249564 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249566 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249568 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249570 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249572 */     GIR_RootConstrainSelectedInstOperands,
     /* 249573 */     // GIR_Coverage, 11490,
     /* 249573 */     GIR_EraseRootFromParent_Done,
     /* 249574 */   // Label 4803: @249574
     /* 249574 */   GIM_Try, /*On fail goto*//*Label 4804*/ GIMT_Encode4(249616), // Rule ID 11492 //
     /* 249579 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249582 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249587 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249590 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249593 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249596 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249599 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249603 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1862:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_H),
     /* 249606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249610 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249612 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249614 */     GIR_RootConstrainSelectedInstOperands,
     /* 249615 */     // GIR_Coverage, 11492,
     /* 249615 */     GIR_EraseRootFromParent_Done,
     /* 249616 */   // Label 4804: @249616
     /* 249616 */   GIM_Try, /*On fail goto*//*Label 4805*/ GIMT_Encode4(249658), // Rule ID 11494 //
     /* 249621 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249624 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249629 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249632 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249635 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249638 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249641 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249645 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1862:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_S),
     /* 249648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249650 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249652 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249654 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249656 */     GIR_RootConstrainSelectedInstOperands,
     /* 249657 */     // GIR_Coverage, 11494,
     /* 249657 */     GIR_EraseRootFromParent_Done,
     /* 249658 */   // Label 4805: @249658
     /* 249658 */   GIM_Try, /*On fail goto*//*Label 4806*/ GIMT_Encode4(249700), // Rule ID 11496 //
     /* 249663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249666 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srhadd),
     /* 249671 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249674 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249677 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249680 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249683 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249687 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1862:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRHADD_ZPmZ_D),
     /* 249690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249696 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249698 */     GIR_RootConstrainSelectedInstOperands,
     /* 249699 */     // GIR_Coverage, 11496,
     /* 249699 */     GIR_EraseRootFromParent_Done,
     /* 249700 */   // Label 4806: @249700
     /* 249700 */   GIM_Try, /*On fail goto*//*Label 4807*/ GIMT_Encode4(249742), // Rule ID 11498 //
     /* 249705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249708 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249713 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249716 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249719 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249722 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249725 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249729 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2054:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URHADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_B),
     /* 249732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249736 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249738 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249740 */     GIR_RootConstrainSelectedInstOperands,
     /* 249741 */     // GIR_Coverage, 11498,
     /* 249741 */     GIR_EraseRootFromParent_Done,
     /* 249742 */   // Label 4807: @249742
     /* 249742 */   GIM_Try, /*On fail goto*//*Label 4808*/ GIMT_Encode4(249784), // Rule ID 11500 //
     /* 249747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249750 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249755 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249758 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249761 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249764 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249767 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249771 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2054:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URHADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_H),
     /* 249774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249776 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249780 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249782 */     GIR_RootConstrainSelectedInstOperands,
     /* 249783 */     // GIR_Coverage, 11500,
     /* 249783 */     GIR_EraseRootFromParent_Done,
     /* 249784 */   // Label 4808: @249784
     /* 249784 */   GIM_Try, /*On fail goto*//*Label 4809*/ GIMT_Encode4(249826), // Rule ID 11502 //
     /* 249789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249792 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249797 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249809 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249813 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2054:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URHADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_S),
     /* 249816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249818 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249820 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249822 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249824 */     GIR_RootConstrainSelectedInstOperands,
     /* 249825 */     // GIR_Coverage, 11502,
     /* 249825 */     GIR_EraseRootFromParent_Done,
     /* 249826 */   // Label 4809: @249826
     /* 249826 */   GIM_Try, /*On fail goto*//*Label 4810*/ GIMT_Encode4(249868), // Rule ID 11504 //
     /* 249831 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249834 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urhadd),
     /* 249839 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 249842 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 249845 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 249848 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 249851 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249855 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2054:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URHADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 249855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URHADD_ZPmZ_D),
     /* 249858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249860 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249862 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249864 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249866 */     GIR_RootConstrainSelectedInstOperands,
     /* 249867 */     // GIR_Coverage, 11504,
     /* 249867 */     GIR_EraseRootFromParent_Done,
     /* 249868 */   // Label 4810: @249868
     /* 249868 */   GIM_Try, /*On fail goto*//*Label 4811*/ GIMT_Encode4(249910), // Rule ID 11506 //
     /* 249873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 249881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 249884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 249887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 249890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 249893 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249897 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1728:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 249897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_B),
     /* 249900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249902 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249904 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249906 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249908 */     GIR_RootConstrainSelectedInstOperands,
     /* 249909 */     // GIR_Coverage, 11506,
     /* 249909 */     GIR_EraseRootFromParent_Done,
     /* 249910 */   // Label 4811: @249910
     /* 249910 */   GIM_Try, /*On fail goto*//*Label 4812*/ GIMT_Encode4(249952), // Rule ID 11507 //
     /* 249915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249918 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 249923 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 249926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 249929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 249932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 249935 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249939 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1728:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 249939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_H),
     /* 249942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249944 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249946 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249948 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249950 */     GIR_RootConstrainSelectedInstOperands,
     /* 249951 */     // GIR_Coverage, 11507,
     /* 249951 */     GIR_EraseRootFromParent_Done,
     /* 249952 */   // Label 4812: @249952
     /* 249952 */   GIM_Try, /*On fail goto*//*Label 4813*/ GIMT_Encode4(249994), // Rule ID 11508 //
     /* 249957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 249960 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 249965 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 249968 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 249971 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 249974 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 249977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 249981 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1728:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 249981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_S),
     /* 249984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 249986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 249988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 249990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 249992 */     GIR_RootConstrainSelectedInstOperands,
     /* 249993 */     // GIR_Coverage, 11508,
     /* 249993 */     GIR_EraseRootFromParent_Done,
     /* 249994 */   // Label 4813: @249994
     /* 249994 */   GIM_Try, /*On fail goto*//*Label 4814*/ GIMT_Encode4(250036), // Rule ID 11509 //
     /* 249999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250002 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_shsubr),
     /* 250007 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250016 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250023 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1728:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHSUBR_ZPmZ_D),
     /* 250026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250032 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250034 */     GIR_RootConstrainSelectedInstOperands,
     /* 250035 */     // GIR_Coverage, 11509,
     /* 250035 */     GIR_EraseRootFromParent_Done,
     /* 250036 */   // Label 4814: @250036
     /* 250036 */   GIM_Try, /*On fail goto*//*Label 4815*/ GIMT_Encode4(250078), // Rule ID 11510 //
     /* 250041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250058 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250065 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1969:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UHSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250065 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_B),
     /* 250068 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250072 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250074 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250076 */     GIR_RootConstrainSelectedInstOperands,
     /* 250077 */     // GIR_Coverage, 11510,
     /* 250077 */     GIR_EraseRootFromParent_Done,
     /* 250078 */   // Label 4815: @250078
     /* 250078 */   GIM_Try, /*On fail goto*//*Label 4816*/ GIMT_Encode4(250120), // Rule ID 11511 //
     /* 250083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250086 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250091 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250094 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250097 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250100 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250107 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1969:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UHSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_H),
     /* 250110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250112 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250114 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250116 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250118 */     GIR_RootConstrainSelectedInstOperands,
     /* 250119 */     // GIR_Coverage, 11511,
     /* 250119 */     GIR_EraseRootFromParent_Done,
     /* 250120 */   // Label 4816: @250120
     /* 250120 */   GIM_Try, /*On fail goto*//*Label 4817*/ GIMT_Encode4(250162), // Rule ID 11512 //
     /* 250125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250128 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250133 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250136 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250139 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250142 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250145 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250149 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1969:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UHSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_S),
     /* 250152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250154 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250158 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250160 */     GIR_RootConstrainSelectedInstOperands,
     /* 250161 */     // GIR_Coverage, 11512,
     /* 250161 */     GIR_EraseRootFromParent_Done,
     /* 250162 */   // Label 4817: @250162
     /* 250162 */   GIM_Try, /*On fail goto*//*Label 4818*/ GIMT_Encode4(250204), // Rule ID 11513 //
     /* 250167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uhsubr),
     /* 250175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250191 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1969:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UHSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UHSUBR_ZPmZ_D),
     /* 250194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250200 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250202 */     GIR_RootConstrainSelectedInstOperands,
     /* 250203 */     // GIR_Coverage, 11513,
     /* 250203 */     GIR_EraseRootFromParent_Done,
     /* 250204 */   // Label 4818: @250204
     /* 250204 */   GIM_Try, /*On fail goto*//*Label 4819*/ GIMT_Encode4(250246), // Rule ID 11514 //
     /* 250209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250212 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250217 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250220 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250223 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250226 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250229 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250233 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1944:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UADALP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_H),
     /* 250236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250238 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250242 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250244 */     GIR_RootConstrainSelectedInstOperands,
     /* 250245 */     // GIR_Coverage, 11514,
     /* 250245 */     GIR_EraseRootFromParent_Done,
     /* 250246 */   // Label 4819: @250246
     /* 250246 */   GIM_Try, /*On fail goto*//*Label 4820*/ GIMT_Encode4(250288), // Rule ID 11515 //
     /* 250251 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250254 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250259 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250262 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250265 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250268 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250271 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250275 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1944:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UADALP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_S),
     /* 250278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250284 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250286 */     GIR_RootConstrainSelectedInstOperands,
     /* 250287 */     // GIR_Coverage, 11515,
     /* 250287 */     GIR_EraseRootFromParent_Done,
     /* 250288 */   // Label 4820: @250288
     /* 250288 */   GIM_Try, /*On fail goto*//*Label 4821*/ GIMT_Encode4(250330), // Rule ID 11516 //
     /* 250293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250296 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uadalp),
     /* 250301 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250304 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250307 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250310 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250313 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250317 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1944:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UADALP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250317 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADALP_ZPmZ_D),
     /* 250320 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 250322 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250324 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250326 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250328 */     GIR_RootConstrainSelectedInstOperands,
     /* 250329 */     // GIR_Coverage, 11516,
     /* 250329 */     GIR_EraseRootFromParent_Done,
     /* 250330 */   // Label 4821: @250330
     /* 250330 */   GIM_Try, /*On fail goto*//*Label 4822*/ GIMT_Encode4(250372), // Rule ID 11517 //
     /* 250335 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250338 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250343 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250355 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250359 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1259:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (ADDP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250359 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_B),
     /* 250362 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250364 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250368 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250370 */     GIR_RootConstrainSelectedInstOperands,
     /* 250371 */     // GIR_Coverage, 11517,
     /* 250371 */     GIR_EraseRootFromParent_Done,
     /* 250372 */   // Label 4822: @250372
     /* 250372 */   GIM_Try, /*On fail goto*//*Label 4823*/ GIMT_Encode4(250414), // Rule ID 11518 //
     /* 250377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250397 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250401 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1259:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (ADDP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_H),
     /* 250404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250406 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250408 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250410 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250412 */     GIR_RootConstrainSelectedInstOperands,
     /* 250413 */     // GIR_Coverage, 11518,
     /* 250413 */     GIR_EraseRootFromParent_Done,
     /* 250414 */   // Label 4823: @250414
     /* 250414 */   GIM_Try, /*On fail goto*//*Label 4824*/ GIMT_Encode4(250456), // Rule ID 11519 //
     /* 250419 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250422 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250427 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250430 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250433 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250436 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250439 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250443 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1259:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADDP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_S),
     /* 250446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250448 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250450 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250452 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250454 */     GIR_RootConstrainSelectedInstOperands,
     /* 250455 */     // GIR_Coverage, 11519,
     /* 250455 */     GIR_EraseRootFromParent_Done,
     /* 250456 */   // Label 4824: @250456
     /* 250456 */   GIM_Try, /*On fail goto*//*Label 4825*/ GIMT_Encode4(250498), // Rule ID 11520 //
     /* 250461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250464 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_addp),
     /* 250469 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250472 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250475 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250478 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250485 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1259:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADDP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDP_ZPmZ_D),
     /* 250488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250496 */     GIR_RootConstrainSelectedInstOperands,
     /* 250497 */     // GIR_Coverage, 11520,
     /* 250497 */     GIR_EraseRootFromParent_Done,
     /* 250498 */   // Label 4825: @250498
     /* 250498 */   GIM_Try, /*On fail goto*//*Label 4826*/ GIMT_Encode4(250540), // Rule ID 11521 //
     /* 250503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250506 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250511 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250514 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250517 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250520 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250527 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1738:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250527 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_B),
     /* 250530 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250532 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250536 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250538 */     GIR_RootConstrainSelectedInstOperands,
     /* 250539 */     // GIR_Coverage, 11521,
     /* 250539 */     GIR_EraseRootFromParent_Done,
     /* 250540 */   // Label 4826: @250540
     /* 250540 */   GIM_Try, /*On fail goto*//*Label 4827*/ GIMT_Encode4(250582), // Rule ID 11522 //
     /* 250545 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250548 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250553 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250556 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250559 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250562 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250565 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250569 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1738:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_H),
     /* 250572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250574 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250578 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250580 */     GIR_RootConstrainSelectedInstOperands,
     /* 250581 */     // GIR_Coverage, 11522,
     /* 250581 */     GIR_EraseRootFromParent_Done,
     /* 250582 */   // Label 4827: @250582
     /* 250582 */   GIM_Try, /*On fail goto*//*Label 4828*/ GIMT_Encode4(250624), // Rule ID 11523 //
     /* 250587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250590 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250595 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250598 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250601 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250604 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250611 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1738:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_S),
     /* 250614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250620 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250622 */     GIR_RootConstrainSelectedInstOperands,
     /* 250623 */     // GIR_Coverage, 11523,
     /* 250623 */     GIR_EraseRootFromParent_Done,
     /* 250624 */   // Label 4828: @250624
     /* 250624 */   GIM_Try, /*On fail goto*//*Label 4829*/ GIMT_Encode4(250666), // Rule ID 11524 //
     /* 250629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250632 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smaxp),
     /* 250637 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250646 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250649 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250653 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1738:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXP_ZPmZ_D),
     /* 250656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250658 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250662 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250664 */     GIR_RootConstrainSelectedInstOperands,
     /* 250665 */     // GIR_Coverage, 11524,
     /* 250665 */     GIR_EraseRootFromParent_Done,
     /* 250666 */   // Label 4829: @250666
     /* 250666 */   GIM_Try, /*On fail goto*//*Label 4830*/ GIMT_Encode4(250708), // Rule ID 11525 //
     /* 250671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250674 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250679 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250691 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250695 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1976:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMAXP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_B),
     /* 250698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250700 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250704 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250706 */     GIR_RootConstrainSelectedInstOperands,
     /* 250707 */     // GIR_Coverage, 11525,
     /* 250707 */     GIR_EraseRootFromParent_Done,
     /* 250708 */   // Label 4830: @250708
     /* 250708 */   GIM_Try, /*On fail goto*//*Label 4831*/ GIMT_Encode4(250750), // Rule ID 11526 //
     /* 250713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250727 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250730 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250737 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1976:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMAXP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_H),
     /* 250740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250746 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250748 */     GIR_RootConstrainSelectedInstOperands,
     /* 250749 */     // GIR_Coverage, 11526,
     /* 250749 */     GIR_EraseRootFromParent_Done,
     /* 250750 */   // Label 4831: @250750
     /* 250750 */   GIM_Try, /*On fail goto*//*Label 4832*/ GIMT_Encode4(250792), // Rule ID 11527 //
     /* 250755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250758 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250763 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250775 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250779 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1976:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMAXP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_S),
     /* 250782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250784 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250786 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250788 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250790 */     GIR_RootConstrainSelectedInstOperands,
     /* 250791 */     // GIR_Coverage, 11527,
     /* 250791 */     GIR_EraseRootFromParent_Done,
     /* 250792 */   // Label 4832: @250792
     /* 250792 */   GIM_Try, /*On fail goto*//*Label 4833*/ GIMT_Encode4(250834), // Rule ID 11528 //
     /* 250797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250800 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umaxp),
     /* 250805 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250808 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250811 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250814 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250817 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250821 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1976:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMAXP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250821 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXP_ZPmZ_D),
     /* 250824 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250826 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250828 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250830 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250832 */     GIR_RootConstrainSelectedInstOperands,
     /* 250833 */     // GIR_Coverage, 11528,
     /* 250833 */     GIR_EraseRootFromParent_Done,
     /* 250834 */   // Label 4833: @250834
     /* 250834 */   GIM_Try, /*On fail goto*//*Label 4834*/ GIMT_Encode4(250876), // Rule ID 11529 //
     /* 250839 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250842 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250847 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 250850 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 250853 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 250856 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 250859 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250863 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1747:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 250863 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_B),
     /* 250866 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250870 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250872 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250874 */     GIR_RootConstrainSelectedInstOperands,
     /* 250875 */     // GIR_Coverage, 11529,
     /* 250875 */     GIR_EraseRootFromParent_Done,
     /* 250876 */   // Label 4834: @250876
     /* 250876 */   GIM_Try, /*On fail goto*//*Label 4835*/ GIMT_Encode4(250918), // Rule ID 11530 //
     /* 250881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250884 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250889 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 250892 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 250895 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 250898 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 250901 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250905 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1747:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 250905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_H),
     /* 250908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250910 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250912 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250914 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250916 */     GIR_RootConstrainSelectedInstOperands,
     /* 250917 */     // GIR_Coverage, 11530,
     /* 250917 */     GIR_EraseRootFromParent_Done,
     /* 250918 */   // Label 4835: @250918
     /* 250918 */   GIM_Try, /*On fail goto*//*Label 4836*/ GIMT_Encode4(250960), // Rule ID 11531 //
     /* 250923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250926 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250931 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 250934 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 250937 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 250940 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 250943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250947 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1747:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 250947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_S),
     /* 250950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 250958 */     GIR_RootConstrainSelectedInstOperands,
     /* 250959 */     // GIR_Coverage, 11531,
     /* 250959 */     GIR_EraseRootFromParent_Done,
     /* 250960 */   // Label 4836: @250960
     /* 250960 */   GIM_Try, /*On fail goto*//*Label 4837*/ GIMT_Encode4(251002), // Rule ID 11532 //
     /* 250965 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 250968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sminp),
     /* 250973 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 250976 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 250979 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 250982 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 250985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 250989 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1747:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 250989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINP_ZPmZ_D),
     /* 250992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 250994 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 250996 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 250998 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251000 */     GIR_RootConstrainSelectedInstOperands,
     /* 251001 */     // GIR_Coverage, 11532,
     /* 251001 */     GIR_EraseRootFromParent_Done,
     /* 251002 */   // Label 4837: @251002
     /* 251002 */   GIM_Try, /*On fail goto*//*Label 4838*/ GIMT_Encode4(251044), // Rule ID 11533 //
     /* 251007 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251010 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251015 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251018 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251021 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251024 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251027 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251031 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1985:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UMINP_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_B),
     /* 251034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251040 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251042 */     GIR_RootConstrainSelectedInstOperands,
     /* 251043 */     // GIR_Coverage, 11533,
     /* 251043 */     GIR_EraseRootFromParent_Done,
     /* 251044 */   // Label 4838: @251044
     /* 251044 */   GIM_Try, /*On fail goto*//*Label 4839*/ GIMT_Encode4(251086), // Rule ID 11534 //
     /* 251049 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251052 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251057 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251060 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251063 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251066 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251069 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251073 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1985:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UMINP_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251073 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_H),
     /* 251076 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251078 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251080 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251082 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251084 */     GIR_RootConstrainSelectedInstOperands,
     /* 251085 */     // GIR_Coverage, 11534,
     /* 251085 */     GIR_EraseRootFromParent_Done,
     /* 251086 */   // Label 4839: @251086
     /* 251086 */   GIM_Try, /*On fail goto*//*Label 4840*/ GIMT_Encode4(251128), // Rule ID 11535 //
     /* 251091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251099 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251102 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251105 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251108 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251111 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251115 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1985:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UMINP_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_S),
     /* 251118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251122 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251124 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251126 */     GIR_RootConstrainSelectedInstOperands,
     /* 251127 */     // GIR_Coverage, 11535,
     /* 251127 */     GIR_EraseRootFromParent_Done,
     /* 251128 */   // Label 4840: @251128
     /* 251128 */   GIM_Try, /*On fail goto*//*Label 4841*/ GIMT_Encode4(251170), // Rule ID 11536 //
     /* 251133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251136 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uminp),
     /* 251141 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251144 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251147 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251150 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251153 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251157 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1985:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UMINP_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251157 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINP_ZPmZ_D),
     /* 251160 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251162 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251166 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251168 */     GIR_RootConstrainSelectedInstOperands,
     /* 251169 */     // GIR_Coverage, 11536,
     /* 251169 */     GIR_EraseRootFromParent_Done,
     /* 251170 */   // Label 4841: @251170
     /* 251170 */   GIM_Try, /*On fail goto*//*Label 4842*/ GIMT_Encode4(251212), // Rule ID 11537 //
     /* 251175 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251178 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ursqrte),
     /* 251183 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251199 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2061:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSQRTE_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSQRTE_ZPmZ_S),
     /* 251202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251204 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251208 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251210 */     GIR_RootConstrainSelectedInstOperands,
     /* 251211 */     // GIR_Coverage, 11537,
     /* 251211 */     GIR_EraseRootFromParent_Done,
     /* 251212 */   // Label 4842: @251212
     /* 251212 */   GIM_Try, /*On fail goto*//*Label 4843*/ GIMT_Encode4(251254), // Rule ID 11548 //
     /* 251217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251220 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251225 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251228 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 251231 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 251234 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251241 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1826:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQNEG_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_B),
     /* 251244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251246 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251248 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251250 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251252 */     GIR_RootConstrainSelectedInstOperands,
     /* 251253 */     // GIR_Coverage, 11548,
     /* 251253 */     GIR_EraseRootFromParent_Done,
     /* 251254 */   // Label 4843: @251254
     /* 251254 */   GIM_Try, /*On fail goto*//*Label 4844*/ GIMT_Encode4(251296), // Rule ID 11549 //
     /* 251259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251262 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251267 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251270 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 251273 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 251276 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251279 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251283 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1826:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQNEG_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_H),
     /* 251286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251290 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251292 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251294 */     GIR_RootConstrainSelectedInstOperands,
     /* 251295 */     // GIR_Coverage, 11549,
     /* 251295 */     GIR_EraseRootFromParent_Done,
     /* 251296 */   // Label 4844: @251296
     /* 251296 */   GIM_Try, /*On fail goto*//*Label 4845*/ GIMT_Encode4(251338), // Rule ID 11550 //
     /* 251301 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251304 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251309 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251312 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 251315 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 251318 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251321 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251325 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1826:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQNEG_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_S),
     /* 251328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251334 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251336 */     GIR_RootConstrainSelectedInstOperands,
     /* 251337 */     // GIR_Coverage, 11550,
     /* 251337 */     GIR_EraseRootFromParent_Done,
     /* 251338 */   // Label 4845: @251338
     /* 251338 */   GIM_Try, /*On fail goto*//*Label 4846*/ GIMT_Encode4(251380), // Rule ID 11551 //
     /* 251343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqneg),
     /* 251351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 251357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 251360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251363 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251367 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1826:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQNEG_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQNEG_ZPmZ_D),
     /* 251370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 251372 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251376 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251378 */     GIR_RootConstrainSelectedInstOperands,
     /* 251379 */     // GIR_Coverage, 11551,
     /* 251379 */     GIR_EraseRootFromParent_Done,
     /* 251380 */   // Label 4846: @251380
     /* 251380 */   GIM_Try, /*On fail goto*//*Label 4847*/ GIMT_Encode4(251422), // Rule ID 11560 //
     /* 251385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251388 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251393 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251402 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251405 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251409 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1767:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_B),
     /* 251412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251414 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251416 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251418 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251420 */     GIR_RootConstrainSelectedInstOperands,
     /* 251421 */     // GIR_Coverage, 11560,
     /* 251421 */     GIR_EraseRootFromParent_Done,
     /* 251422 */   // Label 4847: @251422
     /* 251422 */   GIM_Try, /*On fail goto*//*Label 4848*/ GIMT_Encode4(251464), // Rule ID 11561 //
     /* 251427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251430 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251435 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251444 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251451 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1767:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_H),
     /* 251454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251462 */     GIR_RootConstrainSelectedInstOperands,
     /* 251463 */     // GIR_Coverage, 11561,
     /* 251463 */     GIR_EraseRootFromParent_Done,
     /* 251464 */   // Label 4848: @251464
     /* 251464 */   GIM_Try, /*On fail goto*//*Label 4849*/ GIMT_Encode4(251506), // Rule ID 11562 //
     /* 251469 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251472 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251477 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251480 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251483 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251486 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251489 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251493 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1767:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_S),
     /* 251496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251504 */     GIR_RootConstrainSelectedInstOperands,
     /* 251505 */     // GIR_Coverage, 11562,
     /* 251505 */     GIR_EraseRootFromParent_Done,
     /* 251506 */   // Label 4849: @251506
     /* 251506 */   GIM_Try, /*On fail goto*//*Label 4850*/ GIMT_Encode4(251548), // Rule ID 11563 //
     /* 251511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqadd),
     /* 251519 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251522 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251525 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251528 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251531 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251535 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1767:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZPmZ_D),
     /* 251538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251540 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251542 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251544 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251546 */     GIR_RootConstrainSelectedInstOperands,
     /* 251547 */     // GIR_Coverage, 11563,
     /* 251547 */     GIR_EraseRootFromParent_Done,
     /* 251548 */   // Label 4850: @251548
     /* 251548 */   GIM_Try, /*On fail goto*//*Label 4851*/ GIMT_Encode4(251590), // Rule ID 11564 //
     /* 251553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251567 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251570 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251573 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251577 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2003:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_B),
     /* 251580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251582 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251584 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251586 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251588 */     GIR_RootConstrainSelectedInstOperands,
     /* 251589 */     // GIR_Coverage, 11564,
     /* 251589 */     GIR_EraseRootFromParent_Done,
     /* 251590 */   // Label 4851: @251590
     /* 251590 */   GIM_Try, /*On fail goto*//*Label 4852*/ GIMT_Encode4(251632), // Rule ID 11565 //
     /* 251595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251598 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251603 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251615 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251619 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2003:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_H),
     /* 251622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251628 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251630 */     GIR_RootConstrainSelectedInstOperands,
     /* 251631 */     // GIR_Coverage, 11565,
     /* 251631 */     GIR_EraseRootFromParent_Done,
     /* 251632 */   // Label 4852: @251632
     /* 251632 */   GIM_Try, /*On fail goto*//*Label 4853*/ GIMT_Encode4(251674), // Rule ID 11566 //
     /* 251637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251640 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251645 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251648 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251651 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251654 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251661 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2003:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_S),
     /* 251664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251666 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251670 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251672 */     GIR_RootConstrainSelectedInstOperands,
     /* 251673 */     // GIR_Coverage, 11566,
     /* 251673 */     GIR_EraseRootFromParent_Done,
     /* 251674 */   // Label 4853: @251674
     /* 251674 */   GIM_Try, /*On fail goto*//*Label 4854*/ GIMT_Encode4(251716), // Rule ID 11567 //
     /* 251679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251682 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqadd),
     /* 251687 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251690 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251693 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251696 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251699 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251703 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2003:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZPmZ_D),
     /* 251706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251710 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251712 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251714 */     GIR_RootConstrainSelectedInstOperands,
     /* 251715 */     // GIR_Coverage, 11567,
     /* 251715 */     GIR_EraseRootFromParent_Done,
     /* 251716 */   // Label 4854: @251716
     /* 251716 */   GIM_Try, /*On fail goto*//*Label 4855*/ GIMT_Encode4(251758), // Rule ID 11568 //
     /* 251721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251724 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251729 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251732 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251735 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251738 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251741 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251745 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1854:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_B),
     /* 251748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251754 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251756 */     GIR_RootConstrainSelectedInstOperands,
     /* 251757 */     // GIR_Coverage, 11568,
     /* 251757 */     GIR_EraseRootFromParent_Done,
     /* 251758 */   // Label 4855: @251758
     /* 251758 */   GIM_Try, /*On fail goto*//*Label 4856*/ GIMT_Encode4(251800), // Rule ID 11569 //
     /* 251763 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251771 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251774 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251777 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251780 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251783 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251787 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1854:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_H),
     /* 251790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251794 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251796 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251798 */     GIR_RootConstrainSelectedInstOperands,
     /* 251799 */     // GIR_Coverage, 11569,
     /* 251799 */     GIR_EraseRootFromParent_Done,
     /* 251800 */   // Label 4856: @251800
     /* 251800 */   GIM_Try, /*On fail goto*//*Label 4857*/ GIMT_Encode4(251842), // Rule ID 11570 //
     /* 251805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251808 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251813 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251816 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251819 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251822 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251825 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251829 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1854:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_S),
     /* 251832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251834 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251836 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251838 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251840 */     GIR_RootConstrainSelectedInstOperands,
     /* 251841 */     // GIR_Coverage, 11570,
     /* 251841 */     GIR_EraseRootFromParent_Done,
     /* 251842 */   // Label 4857: @251842
     /* 251842 */   GIM_Try, /*On fail goto*//*Label 4858*/ GIMT_Encode4(251884), // Rule ID 11571 //
     /* 251847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsub),
     /* 251855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 251858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 251861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 251864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 251867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251871 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1854:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 251871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZPmZ_D),
     /* 251874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251882 */     GIR_RootConstrainSelectedInstOperands,
     /* 251883 */     // GIR_Coverage, 11571,
     /* 251883 */     GIR_EraseRootFromParent_Done,
     /* 251884 */   // Label 4858: @251884
     /* 251884 */   GIM_Try, /*On fail goto*//*Label 4859*/ GIMT_Encode4(251926), // Rule ID 11572 //
     /* 251889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251892 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 251897 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 251900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 251903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 251906 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 251909 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251913 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2047:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUB_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 251913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_B),
     /* 251916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251918 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251920 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251922 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251924 */     GIR_RootConstrainSelectedInstOperands,
     /* 251925 */     // GIR_Coverage, 11572,
     /* 251925 */     GIR_EraseRootFromParent_Done,
     /* 251926 */   // Label 4859: @251926
     /* 251926 */   GIM_Try, /*On fail goto*//*Label 4860*/ GIMT_Encode4(251968), // Rule ID 11573 //
     /* 251931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 251939 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 251942 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 251945 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 251948 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 251951 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251955 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2047:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUB_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 251955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_H),
     /* 251958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 251960 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 251962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 251964 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 251966 */     GIR_RootConstrainSelectedInstOperands,
     /* 251967 */     // GIR_Coverage, 11573,
     /* 251967 */     GIR_EraseRootFromParent_Done,
     /* 251968 */   // Label 4860: @251968
     /* 251968 */   GIM_Try, /*On fail goto*//*Label 4861*/ GIMT_Encode4(252010), // Rule ID 11574 //
     /* 251973 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 251976 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 251981 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 251984 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 251987 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 251990 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 251993 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 251997 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2047:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUB_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 251997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_S),
     /* 252000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252002 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252006 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252008 */     GIR_RootConstrainSelectedInstOperands,
     /* 252009 */     // GIR_Coverage, 11574,
     /* 252009 */     GIR_EraseRootFromParent_Done,
     /* 252010 */   // Label 4861: @252010
     /* 252010 */   GIM_Try, /*On fail goto*//*Label 4862*/ GIMT_Encode4(252052), // Rule ID 11575 //
     /* 252015 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252018 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsub),
     /* 252023 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252026 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252029 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252032 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252035 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252039 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2047:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUB_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZPmZ_D),
     /* 252042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252044 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252046 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252048 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252050 */     GIR_RootConstrainSelectedInstOperands,
     /* 252051 */     // GIR_Coverage, 11575,
     /* 252051 */     GIR_EraseRootFromParent_Done,
     /* 252052 */   // Label 4862: @252052
     /* 252052 */   GIM_Try, /*On fail goto*//*Label 4863*/ GIMT_Encode4(252094), // Rule ID 11576 //
     /* 252057 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252060 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252065 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252068 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252071 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252074 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252081 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1918:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SUQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_B),
     /* 252084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252086 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252088 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252090 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252092 */     GIR_RootConstrainSelectedInstOperands,
     /* 252093 */     // GIR_Coverage, 11576,
     /* 252093 */     GIR_EraseRootFromParent_Done,
     /* 252094 */   // Label 4863: @252094
     /* 252094 */   GIM_Try, /*On fail goto*//*Label 4864*/ GIMT_Encode4(252136), // Rule ID 11577 //
     /* 252099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252102 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252107 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252110 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252113 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252116 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252119 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252123 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1918:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_H),
     /* 252126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252128 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252130 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252132 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252134 */     GIR_RootConstrainSelectedInstOperands,
     /* 252135 */     // GIR_Coverage, 11577,
     /* 252135 */     GIR_EraseRootFromParent_Done,
     /* 252136 */   // Label 4864: @252136
     /* 252136 */   GIM_Try, /*On fail goto*//*Label 4865*/ GIMT_Encode4(252178), // Rule ID 11578 //
     /* 252141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252144 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252149 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252152 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252155 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252158 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252161 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252165 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1918:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_S),
     /* 252168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252170 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252174 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252176 */     GIR_RootConstrainSelectedInstOperands,
     /* 252177 */     // GIR_Coverage, 11578,
     /* 252177 */     GIR_EraseRootFromParent_Done,
     /* 252178 */   // Label 4865: @252178
     /* 252178 */   GIM_Try, /*On fail goto*//*Label 4866*/ GIMT_Encode4(252220), // Rule ID 11579 //
     /* 252183 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252186 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_suqadd),
     /* 252191 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252194 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252197 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252200 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252203 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252207 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1918:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUQADD_ZPmZ_D),
     /* 252210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252212 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252216 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252218 */     GIR_RootConstrainSelectedInstOperands,
     /* 252219 */     // GIR_Coverage, 11579,
     /* 252219 */     GIR_EraseRootFromParent_Done,
     /* 252220 */   // Label 4866: @252220
     /* 252220 */   GIM_Try, /*On fail goto*//*Label 4867*/ GIMT_Encode4(252262), // Rule ID 11580 //
     /* 252225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252249 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2068:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (USQADD_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_B),
     /* 252252 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252254 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252258 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252260 */     GIR_RootConstrainSelectedInstOperands,
     /* 252261 */     // GIR_Coverage, 11580,
     /* 252261 */     GIR_EraseRootFromParent_Done,
     /* 252262 */   // Label 4867: @252262
     /* 252262 */   GIM_Try, /*On fail goto*//*Label 4868*/ GIMT_Encode4(252304), // Rule ID 11581 //
     /* 252267 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252270 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252275 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252278 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252281 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252284 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252287 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252291 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2068:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (USQADD_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_H),
     /* 252294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252298 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252300 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252302 */     GIR_RootConstrainSelectedInstOperands,
     /* 252303 */     // GIR_Coverage, 11581,
     /* 252303 */     GIR_EraseRootFromParent_Done,
     /* 252304 */   // Label 4868: @252304
     /* 252304 */   GIM_Try, /*On fail goto*//*Label 4869*/ GIMT_Encode4(252346), // Rule ID 11582 //
     /* 252309 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252312 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252317 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252320 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252323 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252326 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252329 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252333 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2068:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (USQADD_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_S),
     /* 252336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252340 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252342 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252344 */     GIR_RootConstrainSelectedInstOperands,
     /* 252345 */     // GIR_Coverage, 11582,
     /* 252345 */     GIR_EraseRootFromParent_Done,
     /* 252346 */   // Label 4869: @252346
     /* 252346 */   GIM_Try, /*On fail goto*//*Label 4870*/ GIMT_Encode4(252388), // Rule ID 11583 //
     /* 252351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252354 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usqadd),
     /* 252359 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252362 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252365 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252368 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252371 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252375 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2068:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (USQADD_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USQADD_ZPmZ_D),
     /* 252378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252380 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252384 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252386 */     GIR_RootConstrainSelectedInstOperands,
     /* 252387 */     // GIR_Coverage, 11583,
     /* 252387 */     GIR_EraseRootFromParent_Done,
     /* 252388 */   // Label 4870: @252388
     /* 252388 */   GIM_Try, /*On fail goto*//*Label 4871*/ GIMT_Encode4(252430), // Rule ID 11584 //
     /* 252393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252396 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252401 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252404 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252407 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252410 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252417 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1857:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_B),
     /* 252420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252428 */     GIR_RootConstrainSelectedInstOperands,
     /* 252429 */     // GIR_Coverage, 11584,
     /* 252429 */     GIR_EraseRootFromParent_Done,
     /* 252430 */   // Label 4871: @252430
     /* 252430 */   GIM_Try, /*On fail goto*//*Label 4872*/ GIMT_Encode4(252472), // Rule ID 11585 //
     /* 252435 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252438 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252443 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252446 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252449 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252452 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252455 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252459 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1857:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_H),
     /* 252462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252466 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252468 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252470 */     GIR_RootConstrainSelectedInstOperands,
     /* 252471 */     // GIR_Coverage, 11585,
     /* 252471 */     GIR_EraseRootFromParent_Done,
     /* 252472 */   // Label 4872: @252472
     /* 252472 */   GIM_Try, /*On fail goto*//*Label 4873*/ GIMT_Encode4(252514), // Rule ID 11586 //
     /* 252477 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252480 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252485 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252488 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252491 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252494 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252497 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252501 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1857:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_S),
     /* 252504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252506 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252508 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252510 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252512 */     GIR_RootConstrainSelectedInstOperands,
     /* 252513 */     // GIR_Coverage, 11586,
     /* 252513 */     GIR_EraseRootFromParent_Done,
     /* 252514 */   // Label 4873: @252514
     /* 252514 */   GIM_Try, /*On fail goto*//*Label 4874*/ GIMT_Encode4(252556), // Rule ID 11587 //
     /* 252519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252522 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqsubr),
     /* 252527 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252530 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252533 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252536 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252539 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252543 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1857:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSUBR_ZPmZ_D),
     /* 252546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252548 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252550 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252552 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252554 */     GIR_RootConstrainSelectedInstOperands,
     /* 252555 */     // GIR_Coverage, 11587,
     /* 252555 */     GIR_EraseRootFromParent_Done,
     /* 252556 */   // Label 4874: @252556
     /* 252556 */   GIM_Try, /*On fail goto*//*Label 4875*/ GIMT_Encode4(252598), // Rule ID 11588 //
     /* 252561 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252564 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252569 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252572 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252575 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252578 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252581 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252585 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2050:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_B),
     /* 252588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252592 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252594 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252596 */     GIR_RootConstrainSelectedInstOperands,
     /* 252597 */     // GIR_Coverage, 11588,
     /* 252597 */     GIR_EraseRootFromParent_Done,
     /* 252598 */   // Label 4875: @252598
     /* 252598 */   GIM_Try, /*On fail goto*//*Label 4876*/ GIMT_Encode4(252640), // Rule ID 11589 //
     /* 252603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252606 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252611 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252614 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252617 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252620 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252623 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252627 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2050:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_H),
     /* 252630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252632 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252634 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252636 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252638 */     GIR_RootConstrainSelectedInstOperands,
     /* 252639 */     // GIR_Coverage, 11589,
     /* 252639 */     GIR_EraseRootFromParent_Done,
     /* 252640 */   // Label 4876: @252640
     /* 252640 */   GIM_Try, /*On fail goto*//*Label 4877*/ GIMT_Encode4(252682), // Rule ID 11590 //
     /* 252645 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252648 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252653 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252656 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252659 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252662 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252665 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252669 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2050:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_S),
     /* 252672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252674 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252676 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252678 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252680 */     GIR_RootConstrainSelectedInstOperands,
     /* 252681 */     // GIR_Coverage, 11590,
     /* 252681 */     GIR_EraseRootFromParent_Done,
     /* 252682 */   // Label 4877: @252682
     /* 252682 */   GIM_Try, /*On fail goto*//*Label 4878*/ GIMT_Encode4(252724), // Rule ID 11591 //
     /* 252687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252690 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqsubr),
     /* 252695 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252698 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252701 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252704 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252711 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2050:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSUBR_ZPmZ_D),
     /* 252714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252718 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252720 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252722 */     GIR_RootConstrainSelectedInstOperands,
     /* 252723 */     // GIR_Coverage, 11591,
     /* 252723 */     GIR_EraseRootFromParent_Done,
     /* 252724 */   // Label 4878: @252724
     /* 252724 */   GIM_Try, /*On fail goto*//*Label 4879*/ GIMT_Encode4(252766), // Rule ID 11592 //
     /* 252729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252732 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252737 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252740 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252743 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252746 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252749 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252753 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1864:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_B),
     /* 252756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252758 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252760 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252762 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252764 */     GIR_RootConstrainSelectedInstOperands,
     /* 252765 */     // GIR_Coverage, 11592,
     /* 252765 */     GIR_EraseRootFromParent_Done,
     /* 252766 */   // Label 4879: @252766
     /* 252766 */   GIM_Try, /*On fail goto*//*Label 4880*/ GIMT_Encode4(252808), // Rule ID 11593 //
     /* 252771 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252774 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252779 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252782 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252785 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252788 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252791 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252795 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1864:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252795 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_H),
     /* 252798 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252800 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252802 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252804 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252806 */     GIR_RootConstrainSelectedInstOperands,
     /* 252807 */     // GIR_Coverage, 11593,
     /* 252807 */     GIR_EraseRootFromParent_Done,
     /* 252808 */   // Label 4880: @252808
     /* 252808 */   GIM_Try, /*On fail goto*//*Label 4881*/ GIMT_Encode4(252850), // Rule ID 11594 //
     /* 252813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 252833 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252837 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1864:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 252837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_S),
     /* 252840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252842 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252844 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252846 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252848 */     GIR_RootConstrainSelectedInstOperands,
     /* 252849 */     // GIR_Coverage, 11594,
     /* 252849 */     GIR_EraseRootFromParent_Done,
     /* 252850 */   // Label 4881: @252850
     /* 252850 */   GIM_Try, /*On fail goto*//*Label 4882*/ GIMT_Encode4(252892), // Rule ID 11595 //
     /* 252855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252858 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_srshl),
     /* 252863 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 252866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 252869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 252872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 252875 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252879 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1864:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 252879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SRSHL_ZPmZ_D),
     /* 252882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252888 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252890 */     GIR_RootConstrainSelectedInstOperands,
     /* 252891 */     // GIR_Coverage, 11595,
     /* 252891 */     GIR_EraseRootFromParent_Done,
     /* 252892 */   // Label 4882: @252892
     /* 252892 */   GIM_Try, /*On fail goto*//*Label 4883*/ GIMT_Encode4(252934), // Rule ID 11596 //
     /* 252897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252900 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 252905 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 252908 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 252911 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 252914 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 252917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252921 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2055:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (URSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 252921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_B),
     /* 252924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252932 */     GIR_RootConstrainSelectedInstOperands,
     /* 252933 */     // GIR_Coverage, 11596,
     /* 252933 */     GIR_EraseRootFromParent_Done,
     /* 252934 */   // Label 4883: @252934
     /* 252934 */   GIM_Try, /*On fail goto*//*Label 4884*/ GIMT_Encode4(252976), // Rule ID 11597 //
     /* 252939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 252947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 252950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 252953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 252956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 252959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 252963 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2055:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (URSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 252963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_H),
     /* 252966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 252968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 252970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 252972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 252974 */     GIR_RootConstrainSelectedInstOperands,
     /* 252975 */     // GIR_Coverage, 11597,
     /* 252975 */     GIR_EraseRootFromParent_Done,
     /* 252976 */   // Label 4884: @252976
     /* 252976 */   GIM_Try, /*On fail goto*//*Label 4885*/ GIMT_Encode4(253018), // Rule ID 11598 //
     /* 252981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 252984 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 252989 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 252992 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 252995 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 252998 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253001 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253005 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2055:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (URSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_S),
     /* 253008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253014 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253016 */     GIR_RootConstrainSelectedInstOperands,
     /* 253017 */     // GIR_Coverage, 11598,
     /* 253017 */     GIR_EraseRootFromParent_Done,
     /* 253018 */   // Label 4885: @253018
     /* 253018 */   GIM_Try, /*On fail goto*//*Label 4886*/ GIMT_Encode4(253060), // Rule ID 11599 //
     /* 253023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_urshl),
     /* 253031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253040 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253043 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253047 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2055:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (URSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::URSHL_ZPmZ_D),
     /* 253050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253052 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253056 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253058 */     GIR_RootConstrainSelectedInstOperands,
     /* 253059 */     // GIR_Coverage, 11599,
     /* 253059 */     GIR_EraseRootFromParent_Done,
     /* 253060 */   // Label 4886: @253060
     /* 253060 */   GIM_Try, /*On fail goto*//*Label 4887*/ GIMT_Encode4(253102), // Rule ID 11600 //
     /* 253065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253068 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253073 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253076 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253079 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253082 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253089 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1848:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253089 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_B),
     /* 253092 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253094 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253098 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253100 */     GIR_RootConstrainSelectedInstOperands,
     /* 253101 */     // GIR_Coverage, 11600,
     /* 253101 */     GIR_EraseRootFromParent_Done,
     /* 253102 */   // Label 4887: @253102
     /* 253102 */   GIM_Try, /*On fail goto*//*Label 4888*/ GIMT_Encode4(253144), // Rule ID 11601 //
     /* 253107 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253110 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253115 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253118 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253121 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253124 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253127 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253131 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1848:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_H),
     /* 253134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253140 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253142 */     GIR_RootConstrainSelectedInstOperands,
     /* 253143 */     // GIR_Coverage, 11601,
     /* 253143 */     GIR_EraseRootFromParent_Done,
     /* 253144 */   // Label 4888: @253144
     /* 253144 */   GIM_Try, /*On fail goto*//*Label 4889*/ GIMT_Encode4(253186), // Rule ID 11602 //
     /* 253149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253152 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253157 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253166 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253169 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253173 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1848:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_S),
     /* 253176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253180 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253182 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253184 */     GIR_RootConstrainSelectedInstOperands,
     /* 253185 */     // GIR_Coverage, 11602,
     /* 253185 */     GIR_EraseRootFromParent_Done,
     /* 253186 */   // Label 4889: @253186
     /* 253186 */   GIM_Try, /*On fail goto*//*Label 4890*/ GIMT_Encode4(253228), // Rule ID 11603 //
     /* 253191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253194 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqshl),
     /* 253199 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253208 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253211 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253215 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1848:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253215 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQSHL_ZPmZ_D),
     /* 253218 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253220 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253222 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253224 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253226 */     GIR_RootConstrainSelectedInstOperands,
     /* 253227 */     // GIR_Coverage, 11603,
     /* 253227 */     GIR_EraseRootFromParent_Done,
     /* 253228 */   // Label 4890: @253228
     /* 253228 */   GIM_Try, /*On fail goto*//*Label 4891*/ GIMT_Encode4(253270), // Rule ID 11604 //
     /* 253233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253236 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253241 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253244 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253247 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253250 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253253 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253257 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2044:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_B),
     /* 253260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253262 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253266 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253268 */     GIR_RootConstrainSelectedInstOperands,
     /* 253269 */     // GIR_Coverage, 11604,
     /* 253269 */     GIR_EraseRootFromParent_Done,
     /* 253270 */   // Label 4891: @253270
     /* 253270 */   GIM_Try, /*On fail goto*//*Label 4892*/ GIMT_Encode4(253312), // Rule ID 11605 //
     /* 253275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253295 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253299 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2044:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_H),
     /* 253302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253304 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253306 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253308 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253310 */     GIR_RootConstrainSelectedInstOperands,
     /* 253311 */     // GIR_Coverage, 11605,
     /* 253311 */     GIR_EraseRootFromParent_Done,
     /* 253312 */   // Label 4892: @253312
     /* 253312 */   GIM_Try, /*On fail goto*//*Label 4893*/ GIMT_Encode4(253354), // Rule ID 11606 //
     /* 253317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253337 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253341 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2044:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_S),
     /* 253344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253346 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253348 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253350 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253352 */     GIR_RootConstrainSelectedInstOperands,
     /* 253353 */     // GIR_Coverage, 11606,
     /* 253353 */     GIR_EraseRootFromParent_Done,
     /* 253354 */   // Label 4893: @253354
     /* 253354 */   GIM_Try, /*On fail goto*//*Label 4894*/ GIMT_Encode4(253396), // Rule ID 11607 //
     /* 253359 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253362 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqshl),
     /* 253367 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253370 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253373 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253376 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253383 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2044:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQSHL_ZPmZ_D),
     /* 253386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253394 */     GIR_RootConstrainSelectedInstOperands,
     /* 253395 */     // GIR_Coverage, 11607,
     /* 253395 */     GIR_EraseRootFromParent_Done,
     /* 253396 */   // Label 4894: @253396
     /* 253396 */   GIM_Try, /*On fail goto*//*Label 4895*/ GIMT_Encode4(253438), // Rule ID 11608 //
     /* 253401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253404 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253409 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253412 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253415 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253418 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253421 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253425 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1835:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253425 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_B),
     /* 253428 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253430 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253432 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253434 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253436 */     GIR_RootConstrainSelectedInstOperands,
     /* 253437 */     // GIR_Coverage, 11608,
     /* 253437 */     GIR_EraseRootFromParent_Done,
     /* 253438 */   // Label 4895: @253438
     /* 253438 */   GIM_Try, /*On fail goto*//*Label 4896*/ GIMT_Encode4(253480), // Rule ID 11609 //
     /* 253443 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253446 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253451 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253460 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253463 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253467 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1835:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_H),
     /* 253470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253476 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253478 */     GIR_RootConstrainSelectedInstOperands,
     /* 253479 */     // GIR_Coverage, 11609,
     /* 253479 */     GIR_EraseRootFromParent_Done,
     /* 253480 */   // Label 4896: @253480
     /* 253480 */   GIM_Try, /*On fail goto*//*Label 4897*/ GIMT_Encode4(253522), // Rule ID 11610 //
     /* 253485 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253488 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253493 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253496 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253499 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253502 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253509 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1835:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_S),
     /* 253512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253514 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253516 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253518 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253520 */     GIR_RootConstrainSelectedInstOperands,
     /* 253521 */     // GIR_Coverage, 11610,
     /* 253521 */     GIR_EraseRootFromParent_Done,
     /* 253522 */   // Label 4897: @253522
     /* 253522 */   GIM_Try, /*On fail goto*//*Label 4898*/ GIMT_Encode4(253564), // Rule ID 11611 //
     /* 253527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrshl),
     /* 253535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253541 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253544 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253547 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253551 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1835:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRSHL_ZPmZ_D),
     /* 253554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253562 */     GIR_RootConstrainSelectedInstOperands,
     /* 253563 */     // GIR_Coverage, 11611,
     /* 253563 */     GIR_EraseRootFromParent_Done,
     /* 253564 */   // Label 4898: @253564
     /* 253564 */   GIM_Try, /*On fail goto*//*Label 4899*/ GIMT_Encode4(253606), // Rule ID 11612 //
     /* 253569 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253572 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253577 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253580 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 253583 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253586 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253589 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253593 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 2037:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UQRSHL_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_B),
     /* 253596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253602 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253604 */     GIR_RootConstrainSelectedInstOperands,
     /* 253605 */     // GIR_Coverage, 11612,
     /* 253605 */     GIR_EraseRootFromParent_Done,
     /* 253606 */   // Label 4899: @253606
     /* 253606 */   GIM_Try, /*On fail goto*//*Label 4900*/ GIMT_Encode4(253648), // Rule ID 11613 //
     /* 253611 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253614 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253619 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253622 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 253625 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253628 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253631 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253635 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 2037:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UQRSHL_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_H),
     /* 253638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253642 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253644 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253646 */     GIR_RootConstrainSelectedInstOperands,
     /* 253647 */     // GIR_Coverage, 11613,
     /* 253647 */     GIR_EraseRootFromParent_Done,
     /* 253648 */   // Label 4900: @253648
     /* 253648 */   GIM_Try, /*On fail goto*//*Label 4901*/ GIMT_Encode4(253690), // Rule ID 11614 //
     /* 253653 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253656 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253661 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253664 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 253667 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253670 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253673 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253677 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2037:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UQRSHL_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_S),
     /* 253680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253684 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253686 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253688 */     GIR_RootConstrainSelectedInstOperands,
     /* 253689 */     // GIR_Coverage, 11614,
     /* 253689 */     GIR_EraseRootFromParent_Done,
     /* 253690 */   // Label 4901: @253690
     /* 253690 */   GIM_Try, /*On fail goto*//*Label 4902*/ GIMT_Encode4(253732), // Rule ID 11615 //
     /* 253695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253698 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uqrshl),
     /* 253703 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 253709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253715 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253719 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 2037:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UQRSHL_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253719 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UQRSHL_ZPmZ_D),
     /* 253722 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 253724 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253726 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253728 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253730 */     GIR_RootConstrainSelectedInstOperands,
     /* 253731 */     // GIR_Coverage, 11615,
     /* 253731 */     GIR_EraseRootFromParent_Done,
     /* 253732 */   // Label 4902: @253732
     /* 253732 */   GIM_Try, /*On fail goto*//*Label 4903*/ GIMT_Encode4(253774), // Rule ID 11790 //
     /* 253737 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253740 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253745 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 253748 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 253751 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253754 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253757 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253761 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1937:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABA_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253761 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_B),
     /* 253764 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253766 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253768 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253770 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253772 */     GIR_RootConstrainSelectedInstOperands,
     /* 253773 */     // GIR_Coverage, 11790,
     /* 253773 */     GIR_EraseRootFromParent_Done,
     /* 253774 */   // Label 4903: @253774
     /* 253774 */   GIM_Try, /*On fail goto*//*Label 4904*/ GIMT_Encode4(253816), // Rule ID 11792 //
     /* 253779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253799 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253803 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1937:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABA_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_H),
     /* 253806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253812 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253814 */     GIR_RootConstrainSelectedInstOperands,
     /* 253815 */     // GIR_Coverage, 11792,
     /* 253815 */     GIR_EraseRootFromParent_Done,
     /* 253816 */   // Label 4904: @253816
     /* 253816 */   GIM_Try, /*On fail goto*//*Label 4905*/ GIMT_Encode4(253858), // Rule ID 11794 //
     /* 253821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253824 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253829 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253832 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253835 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 253838 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 253841 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253845 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1937:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABA_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 253845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_S),
     /* 253848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253850 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253852 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253854 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253856 */     GIR_RootConstrainSelectedInstOperands,
     /* 253857 */     // GIR_Coverage, 11794,
     /* 253857 */     GIR_EraseRootFromParent_Done,
     /* 253858 */   // Label 4905: @253858
     /* 253858 */   GIM_Try, /*On fail goto*//*Label 4906*/ GIMT_Encode4(253900), // Rule ID 11796 //
     /* 253863 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253866 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uaba),
     /* 253871 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 253874 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 253877 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 253880 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 253883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253887 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1937:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UABA_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 253887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABA_ZZZ_D),
     /* 253890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253898 */     GIR_RootConstrainSelectedInstOperands,
     /* 253899 */     // GIR_Coverage, 11796,
     /* 253899 */     GIR_EraseRootFromParent_Done,
     /* 253900 */   // Label 4906: @253900
     /* 253900 */   GIM_Try, /*On fail goto*//*Label 4907*/ GIMT_Encode4(253942), // Rule ID 11798 //
     /* 253905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253908 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 253913 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 253916 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 253919 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 253922 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 253925 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253929 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1689:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 253929 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_H),
     /* 253932 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253936 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253938 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253940 */     GIR_RootConstrainSelectedInstOperands,
     /* 253941 */     // GIR_Coverage, 11798,
     /* 253941 */     GIR_EraseRootFromParent_Done,
     /* 253942 */   // Label 4907: @253942
     /* 253942 */   GIM_Try, /*On fail goto*//*Label 4908*/ GIMT_Encode4(253984), // Rule ID 11799 //
     /* 253947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253950 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 253955 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 253958 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 253961 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 253964 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 253967 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 253971 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1689:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 253971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_S),
     /* 253974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 253976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 253978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 253980 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 253982 */     GIR_RootConstrainSelectedInstOperands,
     /* 253983 */     // GIR_Coverage, 11799,
     /* 253983 */     GIR_EraseRootFromParent_Done,
     /* 253984 */   // Label 4908: @253984
     /* 253984 */   GIM_Try, /*On fail goto*//*Label 4909*/ GIMT_Encode4(254026), // Rule ID 11800 //
     /* 253989 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 253992 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sabalt),
     /* 253997 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254000 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254003 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254006 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254009 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254013 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1689:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254013 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABALT_ZZZ_D),
     /* 254016 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254018 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254022 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254024 */     GIR_RootConstrainSelectedInstOperands,
     /* 254025 */     // GIR_Coverage, 11800,
     /* 254025 */     GIR_EraseRootFromParent_Done,
     /* 254026 */   // Label 4909: @254026
     /* 254026 */   GIM_Try, /*On fail goto*//*Label 4910*/ GIMT_Encode4(254068), // Rule ID 11801 //
     /* 254031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254055 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1938:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_H),
     /* 254058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254066 */     GIR_RootConstrainSelectedInstOperands,
     /* 254067 */     // GIR_Coverage, 11801,
     /* 254067 */     GIR_EraseRootFromParent_Done,
     /* 254068 */   // Label 4910: @254068
     /* 254068 */   GIM_Try, /*On fail goto*//*Label 4911*/ GIMT_Encode4(254110), // Rule ID 11802 //
     /* 254073 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254076 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254081 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254084 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254087 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254090 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254093 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254097 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1938:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_S),
     /* 254100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254102 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254104 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254106 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254108 */     GIR_RootConstrainSelectedInstOperands,
     /* 254109 */     // GIR_Coverage, 11802,
     /* 254109 */     GIR_EraseRootFromParent_Done,
     /* 254110 */   // Label 4911: @254110
     /* 254110 */   GIM_Try, /*On fail goto*//*Label 4912*/ GIMT_Encode4(254152), // Rule ID 11803 //
     /* 254115 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254118 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalb),
     /* 254123 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254135 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254139 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1938:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALB_ZZZ_D),
     /* 254142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254144 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254146 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254150 */     GIR_RootConstrainSelectedInstOperands,
     /* 254151 */     // GIR_Coverage, 11803,
     /* 254151 */     GIR_EraseRootFromParent_Done,
     /* 254152 */   // Label 4912: @254152
     /* 254152 */   GIM_Try, /*On fail goto*//*Label 4913*/ GIMT_Encode4(254194), // Rule ID 11804 //
     /* 254157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254177 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254181 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1939:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UABALT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_H),
     /* 254184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254186 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254190 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254192 */     GIR_RootConstrainSelectedInstOperands,
     /* 254193 */     // GIR_Coverage, 11804,
     /* 254193 */     GIR_EraseRootFromParent_Done,
     /* 254194 */   // Label 4913: @254194
     /* 254194 */   GIM_Try, /*On fail goto*//*Label 4914*/ GIMT_Encode4(254236), // Rule ID 11805 //
     /* 254199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254202 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254207 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254210 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254213 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254216 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254219 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254223 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1939:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UABALT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254223 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_S),
     /* 254226 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254228 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254232 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254234 */     GIR_RootConstrainSelectedInstOperands,
     /* 254235 */     // GIR_Coverage, 11805,
     /* 254235 */     GIR_EraseRootFromParent_Done,
     /* 254236 */   // Label 4914: @254236
     /* 254236 */   GIM_Try, /*On fail goto*//*Label 4915*/ GIMT_Encode4(254278), // Rule ID 11806 //
     /* 254241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254244 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uabalt),
     /* 254249 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254252 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254255 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254258 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254265 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1939:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UABALT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABALT_ZZZ_D),
     /* 254268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254270 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254272 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254274 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254276 */     GIR_RootConstrainSelectedInstOperands,
     /* 254277 */     // GIR_Coverage, 11806,
     /* 254277 */     GIR_EraseRootFromParent_Done,
     /* 254278 */   // Label 4915: @254278
     /* 254278 */   GIM_Try, /*On fail goto*//*Label 4916*/ GIMT_Encode4(254320), // Rule ID 11807 //
     /* 254283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254307 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1252:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (ADCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_S),
     /* 254310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254312 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254314 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254316 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254318 */     GIR_RootConstrainSelectedInstOperands,
     /* 254319 */     // GIR_Coverage, 11807,
     /* 254319 */     GIR_EraseRootFromParent_Done,
     /* 254320 */   // Label 4916: @254320
     /* 254320 */   GIM_Try, /*On fail goto*//*Label 4917*/ GIMT_Encode4(254362), // Rule ID 11808 //
     /* 254325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254328 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_adclt),
     /* 254333 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254336 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254339 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254342 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254345 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254349 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1252:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (ADCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADCLT_ZZZ_D),
     /* 254352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254354 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254356 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254358 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254360 */     GIR_RootConstrainSelectedInstOperands,
     /* 254361 */     // GIR_Coverage, 11808,
     /* 254361 */     GIR_EraseRootFromParent_Done,
     /* 254362 */   // Label 4917: @254362
     /* 254362 */   GIM_Try, /*On fail goto*//*Label 4918*/ GIMT_Encode4(254404), // Rule ID 11809 //
     /* 254367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254370 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254375 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254378 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254381 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254384 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254391 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1701:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_S),
     /* 254394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254402 */     GIR_RootConstrainSelectedInstOperands,
     /* 254403 */     // GIR_Coverage, 11809,
     /* 254403 */     GIR_EraseRootFromParent_Done,
     /* 254404 */   // Label 4918: @254404
     /* 254404 */   GIM_Try, /*On fail goto*//*Label 4919*/ GIMT_Encode4(254446), // Rule ID 11810 //
     /* 254409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254412 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclb),
     /* 254417 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254420 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254423 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254426 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254429 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254433 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1701:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLB_ZZZ_D),
     /* 254436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254442 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254444 */     GIR_RootConstrainSelectedInstOperands,
     /* 254445 */     // GIR_Coverage, 11810,
     /* 254445 */     GIR_EraseRootFromParent_Done,
     /* 254446 */   // Label 4919: @254446
     /* 254446 */   GIM_Try, /*On fail goto*//*Label 4920*/ GIMT_Encode4(254488), // Rule ID 11811 //
     /* 254451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254459 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254462 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254465 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254468 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254471 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254475 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1702:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SBCLT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_S),
     /* 254478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254484 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254486 */     GIR_RootConstrainSelectedInstOperands,
     /* 254487 */     // GIR_Coverage, 11811,
     /* 254487 */     GIR_EraseRootFromParent_Done,
     /* 254488 */   // Label 4920: @254488
     /* 254488 */   GIM_Try, /*On fail goto*//*Label 4921*/ GIMT_Encode4(254530), // Rule ID 11812 //
     /* 254493 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254496 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sbclt),
     /* 254501 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 254504 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 254507 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254510 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254513 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254517 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1702:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SBCLT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBCLT_ZZZ_D),
     /* 254520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 254522 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254524 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254526 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254528 */     GIR_RootConstrainSelectedInstOperands,
     /* 254529 */     // GIR_Coverage, 11812,
     /* 254529 */     GIR_EraseRootFromParent_Done,
     /* 254530 */   // Label 4921: @254530
     /* 254530 */   GIM_Try, /*On fail goto*//*Label 4922*/ GIMT_Encode4(254572), // Rule ID 11867 //
     /* 254535 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254538 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254543 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254555 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254559 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1670:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RADDHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_B),
     /* 254562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254566 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254568 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254570 */     GIR_RootConstrainSelectedInstOperands,
     /* 254571 */     // GIR_Coverage, 11867,
     /* 254571 */     GIR_EraseRootFromParent_Done,
     /* 254572 */   // Label 4922: @254572
     /* 254572 */   GIM_Try, /*On fail goto*//*Label 4923*/ GIMT_Encode4(254614), // Rule ID 11868 //
     /* 254577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254580 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254585 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254588 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254591 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254594 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254597 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254601 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1670:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RADDHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_H),
     /* 254604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254606 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254610 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254612 */     GIR_RootConstrainSelectedInstOperands,
     /* 254613 */     // GIR_Coverage, 11868,
     /* 254613 */     GIR_EraseRootFromParent_Done,
     /* 254614 */   // Label 4923: @254614
     /* 254614 */   GIM_Try, /*On fail goto*//*Label 4924*/ GIMT_Encode4(254656), // Rule ID 11869 //
     /* 254619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254622 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_raddhnt),
     /* 254627 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254630 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254633 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254636 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254643 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1670:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RADDHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RADDHNT_ZZZ_S),
     /* 254646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254648 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254652 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254654 */     GIR_RootConstrainSelectedInstOperands,
     /* 254655 */     // GIR_Coverage, 11869,
     /* 254655 */     GIR_EraseRootFromParent_Done,
     /* 254656 */   // Label 4924: @254656
     /* 254656 */   GIM_Try, /*On fail goto*//*Label 4925*/ GIMT_Encode4(254698), // Rule ID 11870 //
     /* 254661 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254664 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254669 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254672 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254675 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254678 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254681 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254685 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1911:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254685 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_B),
     /* 254688 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254690 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254694 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254696 */     GIR_RootConstrainSelectedInstOperands,
     /* 254697 */     // GIR_Coverage, 11870,
     /* 254697 */     GIR_EraseRootFromParent_Done,
     /* 254698 */   // Label 4925: @254698
     /* 254698 */   GIM_Try, /*On fail goto*//*Label 4926*/ GIMT_Encode4(254740), // Rule ID 11871 //
     /* 254703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254706 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254711 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254714 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254717 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254720 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254723 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254727 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1911:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_H),
     /* 254730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254732 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254734 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254736 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254738 */     GIR_RootConstrainSelectedInstOperands,
     /* 254739 */     // GIR_Coverage, 11871,
     /* 254739 */     GIR_EraseRootFromParent_Done,
     /* 254740 */   // Label 4926: @254740
     /* 254740 */   GIM_Try, /*On fail goto*//*Label 4927*/ GIMT_Encode4(254782), // Rule ID 11872 //
     /* 254745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254748 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_subhnt),
     /* 254753 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254756 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254759 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254762 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254765 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254769 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1911:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNT_ZZZ_S),
     /* 254772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254776 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254778 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254780 */     GIR_RootConstrainSelectedInstOperands,
     /* 254781 */     // GIR_Coverage, 11872,
     /* 254781 */     GIR_EraseRootFromParent_Done,
     /* 254782 */   // Label 4927: @254782
     /* 254782 */   GIM_Try, /*On fail goto*//*Label 4928*/ GIMT_Encode4(254824), // Rule ID 11873 //
     /* 254787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254790 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254795 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 254798 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 254801 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254804 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254811 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1686:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (RSUBHNT_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_B),
     /* 254814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254818 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254820 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254822 */     GIR_RootConstrainSelectedInstOperands,
     /* 254823 */     // GIR_Coverage, 11873,
     /* 254823 */     GIR_EraseRootFromParent_Done,
     /* 254824 */   // Label 4928: @254824
     /* 254824 */   GIM_Try, /*On fail goto*//*Label 4929*/ GIMT_Encode4(254866), // Rule ID 11874 //
     /* 254829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 254840 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 254843 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 254846 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 254849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1686:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (RSUBHNT_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 254853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_H),
     /* 254856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254864 */     GIR_RootConstrainSelectedInstOperands,
     /* 254865 */     // GIR_Coverage, 11874,
     /* 254865 */     GIR_EraseRootFromParent_Done,
     /* 254866 */   // Label 4929: @254866
     /* 254866 */   GIM_Try, /*On fail goto*//*Label 4930*/ GIMT_Encode4(254908), // Rule ID 11875 //
     /* 254871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 254874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rsubhnt),
     /* 254879 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 254882 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 254885 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 254888 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 254891 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 254895 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1686:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (RSUBHNT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 254895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RSUBHNT_ZZZ_S),
     /* 254898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 254900 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254902 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254904 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254906 */     GIR_RootConstrainSelectedInstOperands,
     /* 254907 */     // GIR_Coverage, 11875,
     /* 254907 */     GIR_EraseRootFromParent_Done,
     /* 254908 */   // Label 4930: @254908
     /* 254908 */   GIM_Try, /*On fail goto*//*Label 4931*/ GIMT_Encode4(254953), // Rule ID 11888 //
     /* 254913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 254916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 254921 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 254924 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 254927 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 254930 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 254933 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 254937 */     // (intrinsic_wo_chain:{ *:[nxv16i1] } 1621:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (NMATCH_PPzZZ_B:{ *:[nxv16i1] }:{ *:[i32] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 254937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_B),
     /* 254940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 254942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254946 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254948 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 254951 */     GIR_RootConstrainSelectedInstOperands,
     /* 254952 */     // GIR_Coverage, 11888,
     /* 254952 */     GIR_EraseRootFromParent_Done,
     /* 254953 */   // Label 4931: @254953
     /* 254953 */   GIM_Try, /*On fail goto*//*Label 4932*/ GIMT_Encode4(254998), // Rule ID 11889 //
     /* 254958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2),
     /* 254961 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_nmatch),
     /* 254966 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s1,
     /* 254969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 254972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 254975 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 254978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 254982 */     // (intrinsic_wo_chain:{ *:[nxv8i1] } 1621:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (NMATCH_PPzZZ_H:{ *:[nxv8i1] }:{ *:[i32] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 254982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::NMATCH_PPzZZ_H),
     /* 254985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 254987 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 254989 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 254991 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 254993 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 254996 */     GIR_RootConstrainSelectedInstOperands,
     /* 254997 */     // GIR_Coverage, 11889,
     /* 254997 */     GIR_EraseRootFromParent_Done,
     /* 254998 */   // Label 4932: @254998
     /* 254998 */   GIM_Try, /*On fail goto*//*Label 4933*/ GIMT_Encode4(255040), // Rule ID 11890 //
     /* 255003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255006 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255011 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255014 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255017 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255020 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255023 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255027 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1361:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (EORTB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_B),
     /* 255030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255032 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255034 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255036 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255038 */     GIR_RootConstrainSelectedInstOperands,
     /* 255039 */     // GIR_Coverage, 11890,
     /* 255039 */     GIR_EraseRootFromParent_Done,
     /* 255040 */   // Label 4933: @255040
     /* 255040 */   GIM_Try, /*On fail goto*//*Label 4934*/ GIMT_Encode4(255082), // Rule ID 11891 //
     /* 255045 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255048 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255053 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255056 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255059 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255062 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255065 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255069 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1361:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (EORTB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_H),
     /* 255072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255078 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255080 */     GIR_RootConstrainSelectedInstOperands,
     /* 255081 */     // GIR_Coverage, 11891,
     /* 255081 */     GIR_EraseRootFromParent_Done,
     /* 255082 */   // Label 4934: @255082
     /* 255082 */   GIM_Try, /*On fail goto*//*Label 4935*/ GIMT_Encode4(255124), // Rule ID 11892 //
     /* 255087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255098 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255101 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255104 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255111 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1361:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (EORTB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_S),
     /* 255114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255116 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255118 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255120 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255122 */     GIR_RootConstrainSelectedInstOperands,
     /* 255123 */     // GIR_Coverage, 11892,
     /* 255123 */     GIR_EraseRootFromParent_Done,
     /* 255124 */   // Label 4935: @255124
     /* 255124 */   GIM_Try, /*On fail goto*//*Label 4936*/ GIMT_Encode4(255166), // Rule ID 11893 //
     /* 255129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_eortb),
     /* 255137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255149 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255153 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1361:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (EORTB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255153 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORTB_ZZZ_D),
     /* 255156 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 255158 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255162 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255164 */     GIR_RootConstrainSelectedInstOperands,
     /* 255165 */     // GIR_Coverage, 11893,
     /* 255165 */     GIR_EraseRootFromParent_Done,
     /* 255166 */   // Label 4936: @255166
     /* 255166 */   GIM_Try, /*On fail goto*//*Label 4937*/ GIMT_Encode4(255208), // Rule ID 11909 //
     /* 255171 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255174 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255179 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255188 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255191 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255195 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1444:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_H),
     /* 255198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255202 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255204 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255206 */     GIR_RootConstrainSelectedInstOperands,
     /* 255207 */     // GIR_Coverage, 11909,
     /* 255207 */     GIR_EraseRootFromParent_Done,
     /* 255208 */   // Label 4937: @255208
     /* 255208 */   GIM_Try, /*On fail goto*//*Label 4938*/ GIMT_Encode4(255250), // Rule ID 11910 //
     /* 255213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255216 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255221 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255224 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255227 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255230 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255233 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255237 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1444:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255237 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_S),
     /* 255240 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255242 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255244 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255246 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255248 */     GIR_RootConstrainSelectedInstOperands,
     /* 255249 */     // GIR_Coverage, 11910,
     /* 255249 */     GIR_EraseRootFromParent_Done,
     /* 255250 */   // Label 4938: @255250
     /* 255250 */   GIM_Try, /*On fail goto*//*Label 4939*/ GIMT_Encode4(255292), // Rule ID 11911 //
     /* 255255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255258 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxnmp),
     /* 255263 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255266 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255269 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255272 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255275 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255279 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1444:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMP_ZPmZZ_D),
     /* 255282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255286 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255288 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255290 */     GIR_RootConstrainSelectedInstOperands,
     /* 255291 */     // GIR_Coverage, 11911,
     /* 255291 */     GIR_EraseRootFromParent_Done,
     /* 255292 */   // Label 4939: @255292
     /* 255292 */   GIM_Try, /*On fail goto*//*Label 4940*/ GIMT_Encode4(255334), // Rule ID 11912 //
     /* 255297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255300 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255305 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255308 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255311 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255314 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255321 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1462:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINNMP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_H),
     /* 255324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255326 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255328 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255330 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255332 */     GIR_RootConstrainSelectedInstOperands,
     /* 255333 */     // GIR_Coverage, 11912,
     /* 255333 */     GIR_EraseRootFromParent_Done,
     /* 255334 */   // Label 4940: @255334
     /* 255334 */   GIM_Try, /*On fail goto*//*Label 4941*/ GIMT_Encode4(255376), // Rule ID 11913 //
     /* 255339 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255342 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255347 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255350 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255353 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255356 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255359 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255363 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1462:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINNMP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_S),
     /* 255366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255370 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255372 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255374 */     GIR_RootConstrainSelectedInstOperands,
     /* 255375 */     // GIR_Coverage, 11913,
     /* 255375 */     GIR_EraseRootFromParent_Done,
     /* 255376 */   // Label 4941: @255376
     /* 255376 */   GIM_Try, /*On fail goto*//*Label 4942*/ GIMT_Encode4(255418), // Rule ID 11914 //
     /* 255381 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255384 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminnmp),
     /* 255389 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255392 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255395 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255398 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255401 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255405 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1462:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINNMP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255405 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMP_ZPmZZ_D),
     /* 255408 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255410 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255412 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255414 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255416 */     GIR_RootConstrainSelectedInstOperands,
     /* 255417 */     // GIR_Coverage, 11914,
     /* 255417 */     GIR_EraseRootFromParent_Done,
     /* 255418 */   // Label 4942: @255418
     /* 255418 */   GIM_Try, /*On fail goto*//*Label 4943*/ GIMT_Encode4(255460), // Rule ID 11915 //
     /* 255423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255426 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255431 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255434 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255437 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255440 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255447 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1447:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMAXP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_H),
     /* 255450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255452 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255454 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255456 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255458 */     GIR_RootConstrainSelectedInstOperands,
     /* 255459 */     // GIR_Coverage, 11915,
     /* 255459 */     GIR_EraseRootFromParent_Done,
     /* 255460 */   // Label 4943: @255460
     /* 255460 */   GIM_Try, /*On fail goto*//*Label 4944*/ GIMT_Encode4(255502), // Rule ID 11916 //
     /* 255465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255468 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255473 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255482 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255485 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255489 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1447:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMAXP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_S),
     /* 255492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255494 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255496 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255498 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255500 */     GIR_RootConstrainSelectedInstOperands,
     /* 255501 */     // GIR_Coverage, 11916,
     /* 255501 */     GIR_EraseRootFromParent_Done,
     /* 255502 */   // Label 4944: @255502
     /* 255502 */   GIM_Try, /*On fail goto*//*Label 4945*/ GIMT_Encode4(255544), // Rule ID 11917 //
     /* 255507 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255510 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmaxp),
     /* 255515 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255518 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255521 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255524 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255527 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255531 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1447:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMAXP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255531 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAXP_ZPmZZ_D),
     /* 255534 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255536 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255540 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255542 */     GIR_RootConstrainSelectedInstOperands,
     /* 255543 */     // GIR_Coverage, 11917,
     /* 255543 */     GIR_EraseRootFromParent_Done,
     /* 255544 */   // Label 4945: @255544
     /* 255544 */   GIM_Try, /*On fail goto*//*Label 4946*/ GIMT_Encode4(255586), // Rule ID 11918 //
     /* 255549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255552 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255557 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255560 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 255563 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255566 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255573 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1465:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMINP_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_H),
     /* 255576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255582 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255584 */     GIR_RootConstrainSelectedInstOperands,
     /* 255585 */     // GIR_Coverage, 11918,
     /* 255585 */     GIR_EraseRootFromParent_Done,
     /* 255586 */   // Label 4946: @255586
     /* 255586 */   GIM_Try, /*On fail goto*//*Label 4947*/ GIMT_Encode4(255628), // Rule ID 11919 //
     /* 255591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 255605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255611 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255615 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1465:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FMINP_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 255615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_S),
     /* 255618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255620 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255622 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255624 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255626 */     GIR_RootConstrainSelectedInstOperands,
     /* 255627 */     // GIR_Coverage, 11919,
     /* 255627 */     GIR_EraseRootFromParent_Done,
     /* 255628 */   // Label 4947: @255628
     /* 255628 */   GIM_Try, /*On fail goto*//*Label 4948*/ GIMT_Encode4(255670), // Rule ID 11920 //
     /* 255633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fminp),
     /* 255641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 255647 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255650 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255653 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255657 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1465:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FMINP_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 255657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINP_ZPmZZ_D),
     /* 255660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255664 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255666 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255668 */     GIR_RootConstrainSelectedInstOperands,
     /* 255669 */     // GIR_Coverage, 11920,
     /* 255669 */     GIR_EraseRootFromParent_Done,
     /* 255670 */   // Label 4948: @255670
     /* 255670 */   GIM_Try, /*On fail goto*//*Label 4949*/ GIMT_Encode4(255712), // Rule ID 11925 //
     /* 255675 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255678 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb),
     /* 255683 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255686 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255689 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255692 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1471:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ_SHH),
     /* 255702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255710 */     GIR_RootConstrainSelectedInstOperands,
     /* 255711 */     // GIR_Coverage, 11925,
     /* 255711 */     GIR_EraseRootFromParent_Done,
     /* 255712 */   // Label 4949: @255712
     /* 255712 */   GIM_Try, /*On fail goto*//*Label 4950*/ GIMT_Encode4(255754), // Rule ID 11926 //
     /* 255717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255720 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt),
     /* 255725 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255728 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255731 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255734 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255737 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255741 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1473:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLALT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ_SHH),
     /* 255744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255746 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255750 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255752 */     GIR_RootConstrainSelectedInstOperands,
     /* 255753 */     // GIR_Coverage, 11926,
     /* 255753 */     GIR_EraseRootFromParent_Done,
     /* 255754 */   // Label 4950: @255754
     /* 255754 */   GIM_Try, /*On fail goto*//*Label 4951*/ GIMT_Encode4(255796), // Rule ID 11927 //
     /* 255759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255762 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb),
     /* 255767 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255776 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255783 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1478:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLB_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZ_SHH),
     /* 255786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255792 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255794 */     GIR_RootConstrainSelectedInstOperands,
     /* 255795 */     // GIR_Coverage, 11927,
     /* 255795 */     GIR_EraseRootFromParent_Done,
     /* 255796 */   // Label 4951: @255796
     /* 255796 */   GIM_Try, /*On fail goto*//*Label 4952*/ GIMT_Encode4(255838), // Rule ID 11928 //
     /* 255801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt),
     /* 255809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255825 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1480:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FMLSLT_ZZZ_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 255825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZ_SHH),
     /* 255828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 255830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255836 */     GIR_RootConstrainSelectedInstOperands,
     /* 255837 */     // GIR_Coverage, 11928,
     /* 255837 */     GIR_EraseRootFromParent_Done,
     /* 255838 */   // Label 4952: @255838
     /* 255838 */   GIM_Try, /*On fail goto*//*Label 4953*/ GIMT_Encode4(255880), // Rule ID 11929 //
     /* 255843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255846 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255851 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 255854 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 255857 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 255860 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 255863 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255867 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1278:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 255867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255872 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255874 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255876 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255878 */     GIR_RootConstrainSelectedInstOperands,
     /* 255879 */     // GIR_Coverage, 11929,
     /* 255879 */     GIR_EraseRootFromParent_Done,
     /* 255880 */   // Label 4953: @255880
     /* 255880 */   GIM_Try, /*On fail goto*//*Label 4954*/ GIMT_Encode4(255922), // Rule ID 11931 //
     /* 255885 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255893 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 255896 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 255899 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 255902 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 255905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255909 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1278:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 255909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255916 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255918 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255920 */     GIR_RootConstrainSelectedInstOperands,
     /* 255921 */     // GIR_Coverage, 11931,
     /* 255921 */     GIR_EraseRootFromParent_Done,
     /* 255922 */   // Label 4954: @255922
     /* 255922 */   GIM_Try, /*On fail goto*//*Label 4955*/ GIMT_Encode4(255964), // Rule ID 11933 //
     /* 255927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255930 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255935 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 255938 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 255941 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 255944 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 255947 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255951 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1278:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 255951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 255958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 255960 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 255962 */     GIR_RootConstrainSelectedInstOperands,
     /* 255963 */     // GIR_Coverage, 11933,
     /* 255963 */     GIR_EraseRootFromParent_Done,
     /* 255964 */   // Label 4955: @255964
     /* 255964 */   GIM_Try, /*On fail goto*//*Label 4956*/ GIMT_Encode4(256006), // Rule ID 11935 //
     /* 255969 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 255972 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_bcax),
     /* 255977 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 255980 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 255983 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 255986 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 255989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 255993 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1278:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (BCAX_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 255993 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BCAX_ZZZZ),
     /* 255996 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 255998 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256002 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256004 */     GIR_RootConstrainSelectedInstOperands,
     /* 256005 */     // GIR_Coverage, 11935,
     /* 256005 */     GIR_EraseRootFromParent_Done,
     /* 256006 */   // Label 4956: @256006
     /* 256006 */   GIM_Try, /*On fail goto*//*Label 4957*/ GIMT_Encode4(256048), // Rule ID 12058 //
     /* 256011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256014 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256019 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256028 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256035 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1950:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UCLAMP_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_B),
     /* 256038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256040 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256042 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256044 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256046 */     GIR_RootConstrainSelectedInstOperands,
     /* 256047 */     // GIR_Coverage, 12058,
     /* 256047 */     GIR_EraseRootFromParent_Done,
     /* 256048 */   // Label 4957: @256048
     /* 256048 */   GIM_Try, /*On fail goto*//*Label 4958*/ GIMT_Encode4(256090), // Rule ID 12060 //
     /* 256053 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256056 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256061 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256064 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256067 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256070 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256073 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256077 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1950:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UCLAMP_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_H),
     /* 256080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256084 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256086 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256088 */     GIR_RootConstrainSelectedInstOperands,
     /* 256089 */     // GIR_Coverage, 12060,
     /* 256089 */     GIR_EraseRootFromParent_Done,
     /* 256090 */   // Label 4958: @256090
     /* 256090 */   GIM_Try, /*On fail goto*//*Label 4959*/ GIMT_Encode4(256132), // Rule ID 12062 //
     /* 256095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256115 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256119 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1950:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (UCLAMP_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_S),
     /* 256122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256124 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256126 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256128 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256130 */     GIR_RootConstrainSelectedInstOperands,
     /* 256131 */     // GIR_Coverage, 12062,
     /* 256131 */     GIR_EraseRootFromParent_Done,
     /* 256132 */   // Label 4959: @256132
     /* 256132 */   GIM_Try, /*On fail goto*//*Label 4960*/ GIMT_Encode4(256174), // Rule ID 12064 //
     /* 256137 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME),
     /* 256140 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_uclamp),
     /* 256145 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256154 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256157 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256161 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1950:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (UCLAMP_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256161 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCLAMP_ZZZ_D),
     /* 256164 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256170 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256172 */     GIR_RootConstrainSelectedInstOperands,
     /* 256173 */     // GIR_Coverage, 12064,
     /* 256173 */     GIR_EraseRootFromParent_Done,
     /* 256174 */   // Label 4960: @256174
     /* 256174 */   GIM_Try, /*On fail goto*//*Label 4961*/ GIMT_Encode4(256216), // Rule ID 12066 //
     /* 256179 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256182 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_x2),
     /* 256187 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256190 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256193 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256196 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256203 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1428:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FDOT_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_S),
     /* 256206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256214 */     GIR_RootConstrainSelectedInstOperands,
     /* 256215 */     // GIR_Coverage, 12066,
     /* 256215 */     GIR_EraseRootFromParent_Done,
     /* 256216 */   // Label 4961: @256216
     /* 256216 */   GIM_Try, /*On fail goto*//*Label 4962*/ GIMT_Encode4(256258), // Rule ID 12068 //
     /* 256221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 256224 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_x2),
     /* 256229 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256238 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256241 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256245 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1966:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_HtoS),
     /* 256248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 256250 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256254 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256256 */     GIR_RootConstrainSelectedInstOperands,
     /* 256257 */     // GIR_Coverage, 12068,
     /* 256257 */     GIR_EraseRootFromParent_Done,
     /* 256258 */   // Label 4962: @256258
     /* 256258 */   GIM_Try, /*On fail goto*//*Label 4963*/ GIMT_Encode4(256300), // Rule ID 12231 //
     /* 256263 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256266 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256271 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 256274 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 256277 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 256280 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 256283 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256287 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1926:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (TBXQ_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 256287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_B),
     /* 256290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256294 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256296 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256298 */     GIR_RootConstrainSelectedInstOperands,
     /* 256299 */     // GIR_Coverage, 12231,
     /* 256299 */     GIR_EraseRootFromParent_Done,
     /* 256300 */   // Label 4963: @256300
     /* 256300 */   GIM_Try, /*On fail goto*//*Label 4964*/ GIMT_Encode4(256342), // Rule ID 12232 //
     /* 256305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256313 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256322 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256325 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256329 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1926:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256329 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256332 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256334 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256336 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256338 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256340 */     GIR_RootConstrainSelectedInstOperands,
     /* 256341 */     // GIR_Coverage, 12232,
     /* 256341 */     GIR_EraseRootFromParent_Done,
     /* 256342 */   // Label 4964: @256342
     /* 256342 */   GIM_Try, /*On fail goto*//*Label 4965*/ GIMT_Encode4(256384), // Rule ID 12233 //
     /* 256347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256350 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256355 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256364 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256367 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256371 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1926:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256380 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256382 */     GIR_RootConstrainSelectedInstOperands,
     /* 256383 */     // GIR_Coverage, 12233,
     /* 256383 */     GIR_EraseRootFromParent_Done,
     /* 256384 */   // Label 4965: @256384
     /* 256384 */   GIM_Try, /*On fail goto*//*Label 4966*/ GIMT_Encode4(256426), // Rule ID 12234 //
     /* 256389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256392 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256397 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256400 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256403 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256406 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256409 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256413 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1926:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256418 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256420 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256422 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256424 */     GIR_RootConstrainSelectedInstOperands,
     /* 256425 */     // GIR_Coverage, 12234,
     /* 256425 */     GIR_EraseRootFromParent_Done,
     /* 256426 */   // Label 4966: @256426
     /* 256426 */   GIM_Try, /*On fail goto*//*Label 4967*/ GIMT_Encode4(256468), // Rule ID 12235 //
     /* 256431 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256434 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256439 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256442 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 256445 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256448 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256451 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256455 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1926:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (TBXQ_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 256455 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_H),
     /* 256458 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256460 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256462 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256464 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256466 */     GIR_RootConstrainSelectedInstOperands,
     /* 256467 */     // GIR_Coverage, 12235,
     /* 256467 */     GIR_EraseRootFromParent_Done,
     /* 256468 */   // Label 4967: @256468
     /* 256468 */   GIM_Try, /*On fail goto*//*Label 4968*/ GIMT_Encode4(256510), // Rule ID 12236 //
     /* 256473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256481 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 256487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256490 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256493 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256497 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1926:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (TBXQ_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 256497 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_S),
     /* 256500 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256502 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256504 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256506 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256508 */     GIR_RootConstrainSelectedInstOperands,
     /* 256509 */     // GIR_Coverage, 12236,
     /* 256509 */     GIR_EraseRootFromParent_Done,
     /* 256510 */   // Label 4968: @256510
     /* 256510 */   GIM_Try, /*On fail goto*//*Label 4969*/ GIMT_Encode4(256552), // Rule ID 12237 //
     /* 256515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2p1),
     /* 256518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_tbxq),
     /* 256523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 256529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256539 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1926:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (TBXQ_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 256539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TBXQ_ZZZ_D),
     /* 256542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256544 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256546 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256548 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256550 */     GIR_RootConstrainSelectedInstOperands,
     /* 256551 */     // GIR_Coverage, 12237,
     /* 256551 */     GIR_EraseRootFromParent_Done,
     /* 256552 */   // Label 4969: @256552
     /* 256552 */   GIM_Try, /*On fail goto*//*Label 4970*/ GIMT_Encode4(256594), // Rule ID 12582 //
     /* 256557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256560 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256565 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256568 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256571 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256574 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256577 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256581 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1378:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_H),
     /* 256584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256588 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256590 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256592 */     GIR_RootConstrainSelectedInstOperands,
     /* 256593 */     // GIR_Coverage, 12582,
     /* 256593 */     GIR_EraseRootFromParent_Done,
     /* 256594 */   // Label 4970: @256594
     /* 256594 */   GIM_Try, /*On fail goto*//*Label 4971*/ GIMT_Encode4(256636), // Rule ID 12583 //
     /* 256599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256623 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1378:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256623 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_S),
     /* 256626 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256628 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256630 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256632 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256634 */     GIR_RootConstrainSelectedInstOperands,
     /* 256635 */     // GIR_Coverage, 12583,
     /* 256635 */     GIR_EraseRootFromParent_Done,
     /* 256636 */   // Label 4971: @256636
     /* 256636 */   GIM_Try, /*On fail goto*//*Label 4972*/ GIMT_Encode4(256678), // Rule ID 12584 //
     /* 256641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin),
     /* 256649 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256658 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256665 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1378:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPmZ_D),
     /* 256668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256676 */     GIR_RootConstrainSelectedInstOperands,
     /* 256677 */     // GIR_Coverage, 12584,
     /* 256677 */     GIR_EraseRootFromParent_Done,
     /* 256678 */   // Label 4972: @256678
     /* 256678 */   GIM_Try, /*On fail goto*//*Label 4973*/ GIMT_Encode4(256720), // Rule ID 12585 //
     /* 256683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256691 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256694 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256697 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256700 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256707 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1376:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPmZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_H),
     /* 256710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256712 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256714 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256716 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256718 */     GIR_RootConstrainSelectedInstOperands,
     /* 256719 */     // GIR_Coverage, 12585,
     /* 256719 */     GIR_EraseRootFromParent_Done,
     /* 256720 */   // Label 4973: @256720
     /* 256720 */   GIM_Try, /*On fail goto*//*Label 4974*/ GIMT_Encode4(256762), // Rule ID 12586 //
     /* 256725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256733 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256736 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256739 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256742 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256749 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1376:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPmZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_S),
     /* 256752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256754 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256758 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256760 */     GIR_RootConstrainSelectedInstOperands,
     /* 256761 */     // GIR_Coverage, 12586,
     /* 256761 */     GIR_EraseRootFromParent_Done,
     /* 256762 */   // Label 4974: @256762
     /* 256762 */   GIM_Try, /*On fail goto*//*Label 4975*/ GIMT_Encode4(256804), // Rule ID 12587 //
     /* 256767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax),
     /* 256775 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 256778 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256781 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 256784 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 256787 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256791 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1376:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPmZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 256791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPmZ_D),
     /* 256794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 256796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256800 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256802 */     GIR_RootConstrainSelectedInstOperands,
     /* 256803 */     // GIR_Coverage, 12587,
     /* 256803 */     GIR_EraseRootFromParent_Done,
     /* 256804 */   // Label 4975: @256804
     /* 256804 */   GIM_Try, /*On fail goto*//*Label 4976*/ GIMT_Encode4(256846), // Rule ID 12588 //
     /* 256809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256817 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 256820 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 256823 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 256826 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 256829 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256833 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1377:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 256833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256838 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256842 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256844 */     GIR_RootConstrainSelectedInstOperands,
     /* 256845 */     // GIR_Coverage, 12588,
     /* 256845 */     GIR_EraseRootFromParent_Done,
     /* 256846 */   // Label 4976: @256846
     /* 256846 */   GIM_Try, /*On fail goto*//*Label 4977*/ GIMT_Encode4(256888), // Rule ID 12591 //
     /* 256851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256859 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 256862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 256868 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 256871 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256875 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 256875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256880 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256882 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256884 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256886 */     GIR_RootConstrainSelectedInstOperands,
     /* 256887 */     // GIR_Coverage, 12591,
     /* 256887 */     GIR_EraseRootFromParent_Done,
     /* 256888 */   // Label 4977: @256888
     /* 256888 */   GIM_Try, /*On fail goto*//*Label 4978*/ GIMT_Encode4(256930), // Rule ID 12594 //
     /* 256893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 256904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 256910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 256913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256917 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMAX_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 256917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_H_UNDEF),
     /* 256920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256928 */     GIR_RootConstrainSelectedInstOperands,
     /* 256929 */     // GIR_Coverage, 12594,
     /* 256929 */     GIR_EraseRootFromParent_Done,
     /* 256930 */   // Label 4978: @256930
     /* 256930 */   GIM_Try, /*On fail goto*//*Label 4979*/ GIMT_Encode4(256972), // Rule ID 12597 //
     /* 256935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256943 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 256946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 256949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 256952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 256955 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 256959 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1377:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 256959 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 256962 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 256964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 256966 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 256968 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 256970 */     GIR_RootConstrainSelectedInstOperands,
     /* 256971 */     // GIR_Coverage, 12597,
     /* 256971 */     GIR_EraseRootFromParent_Done,
     /* 256972 */   // Label 4979: @256972
     /* 256972 */   GIM_Try, /*On fail goto*//*Label 4980*/ GIMT_Encode4(257014), // Rule ID 12600 //
     /* 256977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 256980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 256985 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 256988 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 256991 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 256994 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 256997 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257001 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMAX_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257001 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_S_UNDEF),
     /* 257004 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257006 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257010 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257012 */     GIR_RootConstrainSelectedInstOperands,
     /* 257013 */     // GIR_Coverage, 12600,
     /* 257013 */     GIR_EraseRootFromParent_Done,
     /* 257014 */   // Label 4980: @257014
     /* 257014 */   GIM_Try, /*On fail goto*//*Label 4981*/ GIMT_Encode4(257056), // Rule ID 12603 //
     /* 257019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famax_u),
     /* 257027 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257036 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257039 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257043 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1377:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMAX_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAX_ZPZZ_D_UNDEF),
     /* 257046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257052 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257054 */     GIR_RootConstrainSelectedInstOperands,
     /* 257055 */     // GIR_Coverage, 12603,
     /* 257055 */     GIR_EraseRootFromParent_Done,
     /* 257056 */   // Label 4981: @257056
     /* 257056 */   GIM_Try, /*On fail goto*//*Label 4982*/ GIMT_Encode4(257098), // Rule ID 12606 //
     /* 257061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 257072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 257075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 257078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 257081 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257085 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1379:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 257085 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257088 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257090 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257094 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257096 */     GIR_RootConstrainSelectedInstOperands,
     /* 257097 */     // GIR_Coverage, 12606,
     /* 257097 */     GIR_EraseRootFromParent_Done,
     /* 257098 */   // Label 4982: @257098
     /* 257098 */   GIM_Try, /*On fail goto*//*Label 4983*/ GIMT_Encode4(257140), // Rule ID 12609 //
     /* 257103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257111 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 257114 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257117 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 257120 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 257123 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257127 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 257127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257136 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257138 */     GIR_RootConstrainSelectedInstOperands,
     /* 257139 */     // GIR_Coverage, 12609,
     /* 257139 */     GIR_EraseRootFromParent_Done,
     /* 257140 */   // Label 4983: @257140
     /* 257140 */   GIM_Try, /*On fail goto*//*Label 4984*/ GIMT_Encode4(257182), // Rule ID 12612 //
     /* 257145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 257156 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257159 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 257162 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 257165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257169 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (FAMIN_ZPZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 257169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_H_UNDEF),
     /* 257172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257180 */     GIR_RootConstrainSelectedInstOperands,
     /* 257181 */     // GIR_Coverage, 12612,
     /* 257181 */     GIR_EraseRootFromParent_Done,
     /* 257182 */   // Label 4984: @257182
     /* 257182 */   GIM_Try, /*On fail goto*//*Label 4985*/ GIMT_Encode4(257224), // Rule ID 12615 //
     /* 257187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257195 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 257198 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 257201 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 257204 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 257207 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257211 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1379:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 257211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257216 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257218 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257220 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257222 */     GIR_RootConstrainSelectedInstOperands,
     /* 257223 */     // GIR_Coverage, 12615,
     /* 257223 */     GIR_EraseRootFromParent_Done,
     /* 257224 */   // Label 4985: @257224
     /* 257224 */   GIM_Try, /*On fail goto*//*Label 4986*/ GIMT_Encode4(257266), // Rule ID 12618 //
     /* 257229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257237 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 257240 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257243 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 257246 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 257249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257253 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (FAMIN_ZPZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 257253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_S_UNDEF),
     /* 257256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257258 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257260 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257262 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257264 */     GIR_RootConstrainSelectedInstOperands,
     /* 257265 */     // GIR_Coverage, 12618,
     /* 257265 */     GIR_EraseRootFromParent_Done,
     /* 257266 */   // Label 4986: @257266
     /* 257266 */   GIM_Try, /*On fail goto*//*Label 4987*/ GIMT_Encode4(257308), // Rule ID 12621 //
     /* 257271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasSVE2_or_SME2),
     /* 257274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_famin_u),
     /* 257279 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 257282 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 257285 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 257288 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 257291 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 257295 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1379:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (FAMIN_ZPZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 257295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMIN_ZPZZ_D_UNDEF),
     /* 257298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 257300 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 257302 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 257304 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 257306 */     GIR_RootConstrainSelectedInstOperands,
     /* 257307 */     // GIR_Coverage, 12621,
     /* 257307 */     GIR_EraseRootFromParent_Done,
     /* 257308 */   // Label 4987: @257308
     /* 257308 */   GIM_Try, /*On fail goto*//*Label 4988*/ GIMT_Encode4(257451), // Rule ID 5602 //
     /* 257313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257321 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257324 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257327 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257330 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257334 */     // MIs[0] idx
     /* 257334 */     // No operand predicates
     /* 257334 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257334 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257337 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257341 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257346 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257348 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257351 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257355 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257360 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257363 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257367 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257370 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257375 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257380 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257385 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257388 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257392 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257399 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257402 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257406 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257411 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257414 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257421 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257426 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257444 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257447 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257449 */     GIR_RootConstrainSelectedInstOperands,
     /* 257450 */     // GIR_Coverage, 5602,
     /* 257450 */     GIR_EraseRootFromParent_Done,
     /* 257451 */   // Label 4988: @257451
     /* 257451 */   GIM_Try, /*On fail goto*//*Label 4989*/ GIMT_Encode4(257542), // Rule ID 5603 //
     /* 257456 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257459 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257464 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257467 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 257470 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257477 */     // MIs[0] idx
     /* 257477 */     // No operand predicates
     /* 257477 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v8i8:{ *:[v8i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257533 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257536 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257538 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257540 */     GIR_RootConstrainSelectedInstOperands,
     /* 257541 */     // GIR_Coverage, 5603,
     /* 257541 */     GIR_EraseRootFromParent_Done,
     /* 257542 */   // Label 4989: @257542
     /* 257542 */   GIM_Try, /*On fail goto*//*Label 4990*/ GIMT_Encode4(257633), // Rule ID 5604 //
     /* 257547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257550 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257555 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257558 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257561 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257564 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257568 */     // MIs[0] idx
     /* 257568 */     // No operand predicates
     /* 257568 */     // (intrinsic_wo_chain:{ *:[v16i8] } 775:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257568 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257571 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257575 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257580 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257594 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257597 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257601 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257604 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257624 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257629 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257631 */     GIR_RootConstrainSelectedInstOperands,
     /* 257632 */     // GIR_Coverage, 5604,
     /* 257632 */     GIR_EraseRootFromParent_Done,
     /* 257633 */   // Label 4990: @257633
     /* 257633 */   GIM_Try, /*On fail goto*//*Label 4991*/ GIMT_Encode4(257672), // Rule ID 5605 //
     /* 257638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 257649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 257652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257655 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257659 */     // MIs[0] idx
     /* 257659 */     // No operand predicates
     /* 257659 */     // (intrinsic_wo_chain:{ *:[v16i8] } 776:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_B:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_B),
     /* 257662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257664 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257666 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257668 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257670 */     GIR_RootConstrainSelectedInstOperands,
     /* 257671 */     // GIR_Coverage, 5605,
     /* 257671 */     GIR_EraseRootFromParent_Done,
     /* 257672 */   // Label 4991: @257672
     /* 257672 */   GIM_Try, /*On fail goto*//*Label 4992*/ GIMT_Encode4(257815), // Rule ID 5606 //
     /* 257677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257698 */     // MIs[0] idx
     /* 257698 */     // No operand predicates
     /* 257698 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257698 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 257701 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257705 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257710 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 257712 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 257715 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257719 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257724 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 257727 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257731 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 257734 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257739 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257744 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257749 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257752 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257756 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257761 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257763 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257766 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257770 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257775 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257778 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257782 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257785 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257790 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257800 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257803 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257805 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257808 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 257811 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257813 */     GIR_RootConstrainSelectedInstOperands,
     /* 257814 */     // GIR_Coverage, 5606,
     /* 257814 */     GIR_EraseRootFromParent_Done,
     /* 257815 */   // Label 4992: @257815
     /* 257815 */   GIM_Try, /*On fail goto*//*Label 4993*/ GIMT_Encode4(257906), // Rule ID 5607 //
     /* 257820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257823 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 257828 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257831 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 257834 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 257837 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257841 */     // MIs[0] idx
     /* 257841 */     // No operand predicates
     /* 257841 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v4i16:{ *:[v4i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257841 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257844 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257848 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257853 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257867 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257870 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 257874 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257877 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257882 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257887 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257897 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 257902 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257904 */     GIR_RootConstrainSelectedInstOperands,
     /* 257905 */     // GIR_Coverage, 5607,
     /* 257905 */     GIR_EraseRootFromParent_Done,
     /* 257906 */   // Label 4993: @257906
     /* 257906 */   GIM_Try, /*On fail goto*//*Label 4994*/ GIMT_Encode4(257997), // Rule ID 5608 //
     /* 257911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 257914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 257919 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 257922 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 257925 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 257928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257932 */     // MIs[0] idx
     /* 257932 */     // No operand predicates
     /* 257932 */     // (intrinsic_wo_chain:{ *:[v8i16] } 775:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 257932 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 257935 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 257939 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 257946 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 257949 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 257953 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 257958 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 257961 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 257965 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 257968 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257973 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 257978 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 257983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 257986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 257988 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 257990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 257993 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 257995 */     GIR_RootConstrainSelectedInstOperands,
     /* 257996 */     // GIR_Coverage, 5608,
     /* 257996 */     GIR_EraseRootFromParent_Done,
     /* 257997 */   // Label 4994: @257997
     /* 257997 */   GIM_Try, /*On fail goto*//*Label 4995*/ GIMT_Encode4(258036), // Rule ID 5609 //
     /* 258002 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258005 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258010 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258013 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258016 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258019 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258023 */     // MIs[0] idx
     /* 258023 */     // No operand predicates
     /* 258023 */     // (intrinsic_wo_chain:{ *:[v8i16] } 776:{ *:[iPTR] }, v8i16:{ *:[v8i16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258023 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258026 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258028 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258030 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258032 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258034 */     GIR_RootConstrainSelectedInstOperands,
     /* 258035 */     // GIR_Coverage, 5609,
     /* 258035 */     GIR_EraseRootFromParent_Done,
     /* 258036 */   // Label 4995: @258036
     /* 258036 */   GIM_Try, /*On fail goto*//*Label 4996*/ GIMT_Encode4(258179), // Rule ID 5610 //
     /* 258041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258044 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258049 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258052 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258055 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258062 */     // MIs[0] idx
     /* 258062 */     // No operand predicates
     /* 258062 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258062 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 258065 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258069 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258074 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 258076 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 258079 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258083 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258088 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 258091 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258095 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 258098 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258103 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258108 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258113 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258116 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258120 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258125 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258139 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258142 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258172 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/2,
     /* 258175 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258177 */     GIR_RootConstrainSelectedInstOperands,
     /* 258178 */     // GIR_Coverage, 5610,
     /* 258178 */     GIR_EraseRootFromParent_Done,
     /* 258179 */   // Label 4996: @258179
     /* 258179 */   GIM_Try, /*On fail goto*//*Label 4997*/ GIMT_Encode4(258270), // Rule ID 5611 //
     /* 258184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258187 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258192 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 258198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258205 */     // MIs[0] idx
     /* 258205 */     // No operand predicates
     /* 258205 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v4f16:{ *:[v4f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258205 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258208 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258212 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258219 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258222 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258226 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258231 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258234 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 258238 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258251 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258264 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258266 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258268 */     GIR_RootConstrainSelectedInstOperands,
     /* 258269 */     // GIR_Coverage, 5611,
     /* 258269 */     GIR_EraseRootFromParent_Done,
     /* 258270 */   // Label 4997: @258270
     /* 258270 */   GIM_Try, /*On fail goto*//*Label 4998*/ GIMT_Encode4(258361), // Rule ID 5612 //
     /* 258275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258278 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_lane),
     /* 258283 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258292 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258296 */     // MIs[0] idx
     /* 258296 */     // No operand predicates
     /* 258296 */     // (intrinsic_wo_chain:{ *:[v8f16] } 775:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258308 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258310 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258313 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258317 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258322 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258325 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258337 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258342 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258352 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258354 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258357 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258359 */     GIR_RootConstrainSelectedInstOperands,
     /* 258360 */     // GIR_Coverage, 5612,
     /* 258360 */     GIR_EraseRootFromParent_Done,
     /* 258361 */   // Label 4998: @258361
     /* 258361 */   GIM_Try, /*On fail goto*//*Label 4999*/ GIMT_Encode4(258400), // Rule ID 5613 //
     /* 258366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258369 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti2_laneq),
     /* 258374 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 258377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 258380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258387 */     // MIs[0] idx
     /* 258387 */     // No operand predicates
     /* 258387 */     // (intrinsic_wo_chain:{ *:[v8f16] } 776:{ *:[iPTR] }, v8f16:{ *:[v8f16] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT2_H:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 258387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT2_H),
     /* 258390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258396 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258398 */     GIR_RootConstrainSelectedInstOperands,
     /* 258399 */     // GIR_Coverage, 5613,
     /* 258399 */     GIR_EraseRootFromParent_Done,
     /* 258400 */   // Label 4999: @258400
     /* 258400 */   GIM_Try, /*On fail goto*//*Label 5000*/ GIMT_Encode4(258439), // Rule ID 5614 //
     /* 258405 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258408 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_laneq),
     /* 258413 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258416 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258419 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 258422 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258426 */     // MIs[0] idx
     /* 258426 */     // No operand predicates
     /* 258426 */     // (intrinsic_wo_chain:{ *:[v16i8] } 779:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v16i8:{ *:[v16i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 258435 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258437 */     GIR_RootConstrainSelectedInstOperands,
     /* 258438 */     // GIR_Coverage, 5614,
     /* 258438 */     GIR_EraseRootFromParent_Done,
     /* 258439 */   // Label 5000: @258439
     /* 258439 */   GIM_Try, /*On fail goto*//*Label 5001*/ GIMT_Encode4(258530), // Rule ID 5615 //
     /* 258444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasLUT),
     /* 258447 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vluti4q_lane),
     /* 258452 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258455 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258458 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 258461 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258465 */     // MIs[0] idx
     /* 258465 */     // No operand predicates
     /* 258465 */     // (intrinsic_wo_chain:{ *:[v16i8] } 777:{ *:[iPTR] }, v16i8:{ *:[v16i8] }:$Rn, v8i8:{ *:[v8i8] }:$Rm, i32:{ *:[i32] }:$idx)  =>  (LUT4_B:{ *:[v16i8] } VecListOne16b:{ *:[v16i8] }:$Rn, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), V64:{ *:[v8i8] }:$Rm, dsub:{ *:[i32] }), (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 258465 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 258468 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 258472 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 258479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 258482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 258486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 258491 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 258494 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/3, // Rm
     /* 258498 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 258501 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 258516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LUT4_B),
     /* 258519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 258521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 258523 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 258526 */     GIR_RootToRootCopy, /*OpIdx*/4, // idx
     /* 258528 */     GIR_RootConstrainSelectedInstOperands,
     /* 258529 */     // GIR_Coverage, 5615,
     /* 258529 */     GIR_EraseRootFromParent_Done,
     /* 258530 */   // Label 5001: @258530
     /* 258530 */   GIM_Reject,
     /* 258531 */ // Label 4141: @258531
     /* 258531 */ GIM_Try, /*On fail goto*//*Label 5002*/ GIMT_Encode4(265642),
     /* 258536 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 258539 */   GIM_Try, /*On fail goto*//*Label 5003*/ GIMT_Encode4(258586), // Rule ID 2961 //
     /* 258544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258571 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1610:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_B_UNDEF),
     /* 258574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258584 */     GIR_RootConstrainSelectedInstOperands,
     /* 258585 */     // GIR_Coverage, 2961,
     /* 258585 */     GIR_EraseRootFromParent_Done,
     /* 258586 */   // Label 5003: @258586
     /* 258586 */   GIM_Try, /*On fail goto*//*Label 5004*/ GIMT_Encode4(258633), // Rule ID 2963 //
     /* 258591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258618 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1610:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_H_UNDEF),
     /* 258621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258631 */     GIR_RootConstrainSelectedInstOperands,
     /* 258632 */     // GIR_Coverage, 2963,
     /* 258632 */     GIR_EraseRootFromParent_Done,
     /* 258633 */   // Label 5004: @258633
     /* 258633 */   GIM_Try, /*On fail goto*//*Label 5005*/ GIMT_Encode4(258680), // Rule ID 2965 //
     /* 258638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258665 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1610:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_S_UNDEF),
     /* 258668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258678 */     GIR_RootConstrainSelectedInstOperands,
     /* 258679 */     // GIR_Coverage, 2965,
     /* 258679 */     GIR_EraseRootFromParent_Done,
     /* 258680 */   // Label 5005: @258680
     /* 258680 */   GIM_Try, /*On fail goto*//*Label 5006*/ GIMT_Encode4(258727), // Rule ID 2967 //
     /* 258685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_u),
     /* 258693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1610:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 258712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPZZZ_D_UNDEF),
     /* 258715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258725 */     GIR_RootConstrainSelectedInstOperands,
     /* 258726 */     // GIR_Coverage, 2967,
     /* 258726 */     GIR_EraseRootFromParent_Done,
     /* 258727 */   // Label 5006: @258727
     /* 258727 */   GIM_Try, /*On fail goto*//*Label 5007*/ GIMT_Encode4(258774), // Rule ID 7634 //
     /* 258732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 258743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 258746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 258749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 258752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 258755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258759 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1613:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPZZZ_B_UNDEF:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 258759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_B_UNDEF),
     /* 258762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258772 */     GIR_RootConstrainSelectedInstOperands,
     /* 258773 */     // GIR_Coverage, 7634,
     /* 258773 */     GIR_EraseRootFromParent_Done,
     /* 258774 */   // Label 5007: @258774
     /* 258774 */   GIM_Try, /*On fail goto*//*Label 5008*/ GIMT_Encode4(258821), // Rule ID 7636 //
     /* 258779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 258790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 258793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 258796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 258799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 258802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258806 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1613:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPZZZ_H_UNDEF:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 258806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_H_UNDEF),
     /* 258809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258819 */     GIR_RootConstrainSelectedInstOperands,
     /* 258820 */     // GIR_Coverage, 7636,
     /* 258820 */     GIR_EraseRootFromParent_Done,
     /* 258821 */   // Label 5008: @258821
     /* 258821 */   GIM_Try, /*On fail goto*//*Label 5009*/ GIMT_Encode4(258868), // Rule ID 7638 //
     /* 258826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 258837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 258840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 258843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 258846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 258849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258853 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1613:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPZZZ_S_UNDEF:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 258853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_S_UNDEF),
     /* 258856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258866 */     GIR_RootConstrainSelectedInstOperands,
     /* 258867 */     // GIR_Coverage, 7638,
     /* 258867 */     GIR_EraseRootFromParent_Done,
     /* 258868 */   // Label 5009: @258868
     /* 258868 */   GIM_Try, /*On fail goto*//*Label 5010*/ GIMT_Encode4(258915), // Rule ID 7640 //
     /* 258873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 258876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_u),
     /* 258881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 258884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 258887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 258890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 258893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 258896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 258900 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1613:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPZZZ_D_UNDEF:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 258900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPZZZ_D_UNDEF),
     /* 258903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 258905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 258907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 258909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 258911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 258913 */     GIR_RootConstrainSelectedInstOperands,
     /* 258914 */     // GIR_Coverage, 7640,
     /* 258914 */     GIR_EraseRootFromParent_Done,
     /* 258915 */   // Label 5010: @258915
     /* 258915 */   GIM_Try, /*On fail goto*//*Label 5011*/ GIMT_Encode4(258995), // Rule ID 5724 //
     /* 258920 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 258925 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 258928 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 258931 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 258934 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 258937 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 258940 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258944 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 258952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258956 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258960 */     // MIs[1] Operand 1
     /* 258960 */     // No operand predicates
     /* 258960 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 258964 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 258968 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 258972 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 258976 */     // MIs[2] Operand 1
     /* 258976 */     // No operand predicates
     /* 258976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 258978 */     // (intrinsic_wo_chain:{ *:[v16i8] } 768:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, V128:{ *:[v16i8] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2)
     /* 258978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 258981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 258983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 258985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 258988 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 258990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 258993 */     GIR_RootConstrainSelectedInstOperands,
     /* 258994 */     // GIR_Coverage, 5724,
     /* 258994 */     GIR_EraseRootFromParent_Done,
     /* 258995 */   // Label 5011: @258995
     /* 258995 */   GIM_Try, /*On fail goto*//*Label 5012*/ GIMT_Encode4(259075), // Rule ID 5725 //
     /* 259000 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259005 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 259008 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 259011 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259014 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s16,
     /* 259017 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259020 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259024 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259028 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259032 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259036 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259040 */     // MIs[1] Operand 1
     /* 259040 */     // No operand predicates
     /* 259040 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259044 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259048 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259052 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 259056 */     // MIs[2] Operand 1
     /* 259056 */     // No operand predicates
     /* 259056 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259058 */     // (intrinsic_wo_chain:{ *:[v8i16] } 768:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, V128:{ *:[v8i16] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2)
     /* 259058 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 259061 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259063 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259068 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259070 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259073 */     GIR_RootConstrainSelectedInstOperands,
     /* 259074 */     // GIR_Coverage, 5725,
     /* 259074 */     GIR_EraseRootFromParent_Done,
     /* 259075 */   // Label 5012: @259075
     /* 259075 */   GIM_Try, /*On fail goto*//*Label 5013*/ GIMT_Encode4(259155), // Rule ID 5726 //
     /* 259080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259097 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259100 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259104 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259116 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259120 */     // MIs[1] Operand 1
     /* 259120 */     // No operand predicates
     /* 259120 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259132 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 259136 */     // MIs[2] Operand 1
     /* 259136 */     // No operand predicates
     /* 259136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259138 */     // (intrinsic_wo_chain:{ *:[v4i32] } 768:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, V128:{ *:[v4i32] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2)
     /* 259138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 259141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259148 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259153 */     GIR_RootConstrainSelectedInstOperands,
     /* 259154 */     // GIR_Coverage, 5726,
     /* 259154 */     GIR_EraseRootFromParent_Done,
     /* 259155 */   // Label 5013: @259155
     /* 259155 */   GIM_Try, /*On fail goto*//*Label 5014*/ GIMT_Encode4(259235), // Rule ID 5727 //
     /* 259160 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_vcopy_lane),
     /* 259165 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 259168 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 259171 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 259174 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v2s64,
     /* 259177 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_s64,
     /* 259180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259184 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259188 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 259192 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259196 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259200 */     // MIs[1] Operand 1
     /* 259200 */     // No operand predicates
     /* 259200 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259204 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/5, // MIs[2]
     /* 259208 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 259212 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 259216 */     // MIs[2] Operand 1
     /* 259216 */     // No operand predicates
     /* 259216 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 259218 */     // (intrinsic_wo_chain:{ *:[v2i64] } 768:{ *:[iPTR] }, V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Vd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, V128:{ *:[v2i64] }:$Vs, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2)
     /* 259218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 259221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 259223 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 259228 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vs
     /* 259230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 259233 */     GIR_RootConstrainSelectedInstOperands,
     /* 259234 */     // GIR_Coverage, 5727,
     /* 259234 */     GIR_EraseRootFromParent_Done,
     /* 259235 */   // Label 5014: @259235
     /* 259235 */   GIM_Try, /*On fail goto*//*Label 5015*/ GIMT_Encode4(259299), // Rule ID 3848 //
     /* 259240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259243 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1a),
     /* 259248 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259251 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259254 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259257 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259260 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259264 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259268 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259272 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259276 */     // MIs[0] imm
     /* 259276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259284 */     // (intrinsic_wo_chain:{ *:[v4i32] } 544:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1A),
     /* 259287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259295 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259297 */     GIR_RootConstrainSelectedInstOperands,
     /* 259298 */     // GIR_Coverage, 3848,
     /* 259298 */     GIR_EraseRootFromParent_Done,
     /* 259299 */   // Label 5015: @259299
     /* 259299 */   GIM_Try, /*On fail goto*//*Label 5016*/ GIMT_Encode4(259363), // Rule ID 3849 //
     /* 259304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt1b),
     /* 259312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259332 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259336 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259340 */     // MIs[0] imm
     /* 259340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259348 */     // (intrinsic_wo_chain:{ *:[v4i32] } 545:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT1B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT1B),
     /* 259351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259359 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259361 */     GIR_RootConstrainSelectedInstOperands,
     /* 259362 */     // GIR_Coverage, 3849,
     /* 259362 */     GIR_EraseRootFromParent_Done,
     /* 259363 */   // Label 5016: @259363
     /* 259363 */   GIM_Try, /*On fail goto*//*Label 5017*/ GIMT_Encode4(259427), // Rule ID 3850 //
     /* 259368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2a),
     /* 259376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259392 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259396 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259400 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259404 */     // MIs[0] imm
     /* 259404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259412 */     // (intrinsic_wo_chain:{ *:[v4i32] } 546:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2A:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2A),
     /* 259415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259423 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259425 */     GIR_RootConstrainSelectedInstOperands,
     /* 259426 */     // GIR_Coverage, 3850,
     /* 259426 */     GIR_EraseRootFromParent_Done,
     /* 259427 */   // Label 5017: @259427
     /* 259427 */   GIM_Try, /*On fail goto*//*Label 5018*/ GIMT_Encode4(259491), // Rule ID 3851 //
     /* 259432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSM4),
     /* 259435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_crypto_sm3tt2b),
     /* 259440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 259443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 259446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 259449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 259452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259464 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 259468 */     // MIs[0] imm
     /* 259468 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259471 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS_timm),
     /* 259476 */     // (intrinsic_wo_chain:{ *:[v4i32] } 547:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)  =>  (SM3TT2B:{ *:[v4i32] } V128:{ *:[v4i32] }:$Vd, V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm, (timm:{ *:[i64] })<<P:Predicate_VectorIndexS_timm>>:$imm)
     /* 259476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SM3TT2B),
     /* 259479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vdst]
     /* 259481 */     GIR_RootToRootCopy, /*OpIdx*/2, // Vd
     /* 259483 */     GIR_RootToRootCopy, /*OpIdx*/3, // Vn
     /* 259485 */     GIR_RootToRootCopy, /*OpIdx*/4, // Vm
     /* 259487 */     GIR_RootToRootCopy, /*OpIdx*/5, // imm
     /* 259489 */     GIR_RootConstrainSelectedInstOperands,
     /* 259490 */     // GIR_Coverage, 3851,
     /* 259490 */     GIR_EraseRootFromParent_Done,
     /* 259491 */   // Label 5018: @259491
     /* 259491 */   GIM_Try, /*On fail goto*//*Label 5019*/ GIMT_Encode4(259543), // Rule ID 2846 //
     /* 259496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259510 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259513 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259520 */     // MIs[0] idx
     /* 259520 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259523 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259528 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1469:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLA_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 259528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_H),
     /* 259531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259535 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259537 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259539 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259541 */     GIR_RootConstrainSelectedInstOperands,
     /* 259542 */     // GIR_Coverage, 2846,
     /* 259542 */     GIR_EraseRootFromParent_Done,
     /* 259543 */   // Label 5019: @259543
     /* 259543 */   GIM_Try, /*On fail goto*//*Label 5020*/ GIMT_Encode4(259595), // Rule ID 2847 //
     /* 259548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259551 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259556 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259559 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259562 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259565 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259568 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259572 */     // MIs[0] idx
     /* 259572 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259575 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259580 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1469:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLA_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 259580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_S),
     /* 259583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259585 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259587 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259589 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259591 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259593 */     GIR_RootConstrainSelectedInstOperands,
     /* 259594 */     // GIR_Coverage, 2847,
     /* 259594 */     GIR_EraseRootFromParent_Done,
     /* 259595 */   // Label 5020: @259595
     /* 259595 */   GIM_Try, /*On fail goto*//*Label 5021*/ GIMT_Encode4(259647), // Rule ID 2848 //
     /* 259600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259603 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla_lane),
     /* 259608 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259611 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259614 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259617 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259620 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259624 */     // MIs[0] idx
     /* 259624 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259627 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259632 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1469:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLA_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 259632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZZZI_D),
     /* 259635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259637 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259641 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259643 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 259645 */     GIR_RootConstrainSelectedInstOperands,
     /* 259646 */     // GIR_Coverage, 2848,
     /* 259646 */     GIR_EraseRootFromParent_Done,
     /* 259647 */   // Label 5021: @259647
     /* 259647 */   GIM_Try, /*On fail goto*//*Label 5022*/ GIMT_Encode4(259699), // Rule ID 2976 //
     /* 259652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259655 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259660 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 259663 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 259666 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259669 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259676 */     // MIs[0] Op4
     /* 259676 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259679 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259684 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1609:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLA_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259684 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_H),
     /* 259687 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259691 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259693 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259695 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259697 */     GIR_RootConstrainSelectedInstOperands,
     /* 259698 */     // GIR_Coverage, 2976,
     /* 259698 */     GIR_EraseRootFromParent_Done,
     /* 259699 */   // Label 5022: @259699
     /* 259699 */   GIM_Try, /*On fail goto*//*Label 5023*/ GIMT_Encode4(259751), // Rule ID 2977 //
     /* 259704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259707 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259712 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259715 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259718 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259721 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259724 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259728 */     // MIs[0] Op4
     /* 259728 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259731 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259736 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1609:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLA_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_S),
     /* 259739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259741 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259745 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259747 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259749 */     GIR_RootConstrainSelectedInstOperands,
     /* 259750 */     // GIR_Coverage, 2977,
     /* 259750 */     GIR_EraseRootFromParent_Done,
     /* 259751 */   // Label 5023: @259751
     /* 259751 */   GIM_Try, /*On fail goto*//*Label 5024*/ GIMT_Encode4(259803), // Rule ID 2978 //
     /* 259756 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259759 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla_lane),
     /* 259764 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259767 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259770 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 259773 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 259776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259780 */     // MIs[0] Op4
     /* 259780 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259783 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259788 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1609:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLA_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZZZI_D),
     /* 259791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259795 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259797 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259799 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259801 */     GIR_RootConstrainSelectedInstOperands,
     /* 259802 */     // GIR_Coverage, 2978,
     /* 259802 */     GIR_EraseRootFromParent_Done,
     /* 259803 */   // Label 5024: @259803
     /* 259803 */   GIM_Try, /*On fail goto*//*Label 5025*/ GIMT_Encode4(259855), // Rule ID 2979 //
     /* 259808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259811 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259816 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259819 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259825 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259828 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259832 */     // MIs[0] Op4
     /* 259832 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259835 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 259840 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1751:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 259840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_S),
     /* 259843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259853 */     GIR_RootConstrainSelectedInstOperands,
     /* 259854 */     // GIR_Coverage, 2979,
     /* 259854 */     GIR_EraseRootFromParent_Done,
     /* 259855 */   // Label 5025: @259855
     /* 259855 */   GIM_Try, /*On fail goto*//*Label 5026*/ GIMT_Encode4(259907), // Rule ID 2980 //
     /* 259860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 259863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalb_lane),
     /* 259868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 259877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 259880 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259884 */     // MIs[0] Op4
     /* 259884 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259887 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259892 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1751:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALB_ZZZI_D),
     /* 259895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259899 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259901 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259903 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259905 */     GIR_RootConstrainSelectedInstOperands,
     /* 259906 */     // GIR_Coverage, 2980,
     /* 259906 */     GIR_EraseRootFromParent_Done,
     /* 259907 */   // Label 5026: @259907
     /* 259907 */   GIM_Try, /*On fail goto*//*Label 5027*/ GIMT_Encode4(259959), // Rule ID 2983 //
     /* 259912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 259920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 259923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 259926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 259929 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 259932 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259936 */     // MIs[0] Op4
     /* 259936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 259944 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1717:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 259944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_S),
     /* 259947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 259949 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 259951 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 259953 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 259955 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 259957 */     GIR_RootConstrainSelectedInstOperands,
     /* 259958 */     // GIR_Coverage, 2983,
     /* 259958 */     GIR_EraseRootFromParent_Done,
     /* 259959 */   // Label 5027: @259959
     /* 259959 */   GIM_Try, /*On fail goto*//*Label 5028*/ GIMT_Encode4(260011), // Rule ID 2984 //
     /* 259964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 259967 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane),
     /* 259972 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 259975 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 259978 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 259981 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 259984 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 259988 */     // MIs[0] Op4
     /* 259988 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 259991 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 259996 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1717:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 259996 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_D),
     /* 259999 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260001 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260003 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260005 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260007 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260009 */     GIR_RootConstrainSelectedInstOperands,
     /* 260010 */     // GIR_Coverage, 2984,
     /* 260010 */     GIR_EraseRootFromParent_Done,
     /* 260011 */   // Label 5028: @260011
     /* 260011 */   GIM_Try, /*On fail goto*//*Label 5029*/ GIMT_Encode4(260063), // Rule ID 3457 //
     /* 260016 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260019 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_usdot_lane),
     /* 260024 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260033 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260040 */     // MIs[0] Op4
     /* 260040 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260043 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260048 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 2064:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (USDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USDOT_ZZZI),
     /* 260051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260053 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260055 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260057 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260059 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260061 */     GIR_RootConstrainSelectedInstOperands,
     /* 260062 */     // GIR_Coverage, 3457,
     /* 260062 */     GIR_EraseRootFromParent_Done,
     /* 260063 */   // Label 5029: @260063
     /* 260063 */   GIM_Try, /*On fail goto*//*Label 5030*/ GIMT_Encode4(260115), // Rule ID 3501 //
     /* 260068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 260071 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sdot_lane_x2),
     /* 260076 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260085 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260092 */     // MIs[0] Op4
     /* 260092 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260095 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260100 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1718:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZI_HtoS),
     /* 260103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260105 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260107 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260109 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260111 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260113 */     GIR_RootConstrainSelectedInstOperands,
     /* 260114 */     // GIR_Coverage, 3501,
     /* 260114 */     GIR_EraseRootFromParent_Done,
     /* 260115 */   // Label 5030: @260115
     /* 260115 */   GIM_Try, /*On fail goto*//*Label 5031*/ GIMT_Encode4(260167), // Rule ID 7708 //
     /* 260120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260123 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260128 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260131 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260134 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260137 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260140 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260144 */     // MIs[0] Op4
     /* 260144 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260147 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260152 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1964:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_S),
     /* 260155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260159 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260161 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260163 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260165 */     GIR_RootConstrainSelectedInstOperands,
     /* 260166 */     // GIR_Coverage, 7708,
     /* 260166 */     GIR_EraseRootFromParent_Done,
     /* 260167 */   // Label 5031: @260167
     /* 260167 */   GIM_Try, /*On fail goto*//*Label 5032*/ GIMT_Encode4(260219), // Rule ID 7709 //
     /* 260172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260175 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane),
     /* 260180 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260183 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260186 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260189 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260192 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260196 */     // MIs[0] Op4
     /* 260196 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260199 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260204 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1964:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (UDOT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260204 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_D),
     /* 260207 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260209 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260211 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260213 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260215 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260217 */     GIR_RootConstrainSelectedInstOperands,
     /* 260218 */     // GIR_Coverage, 7709,
     /* 260218 */     GIR_EraseRootFromParent_Done,
     /* 260219 */   // Label 5032: @260219
     /* 260219 */   GIM_Try, /*On fail goto*//*Label 5033*/ GIMT_Encode4(260271), // Rule ID 8349 //
     /* 260224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260238 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260241 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260244 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260248 */     // MIs[0] idx
     /* 260248 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260251 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260256 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1476:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)  =>  (FMLS_ZZZI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$idx)
     /* 260256 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_H),
     /* 260259 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260261 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260265 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260267 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260269 */     GIR_RootConstrainSelectedInstOperands,
     /* 260270 */     // GIR_Coverage, 8349,
     /* 260270 */     GIR_EraseRootFromParent_Done,
     /* 260271 */   // Label 5033: @260271
     /* 260271 */   GIM_Try, /*On fail goto*//*Label 5034*/ GIMT_Encode4(260323), // Rule ID 8350 //
     /* 260276 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260279 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260284 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260287 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260290 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260293 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260296 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260300 */     // MIs[0] idx
     /* 260300 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260303 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260308 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1476:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)  =>  (FMLS_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$idx)
     /* 260308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_S),
     /* 260311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260313 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260317 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260319 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260321 */     GIR_RootConstrainSelectedInstOperands,
     /* 260322 */     // GIR_Coverage, 8350,
     /* 260322 */     GIR_EraseRootFromParent_Done,
     /* 260323 */   // Label 5034: @260323
     /* 260323 */   GIM_Try, /*On fail goto*//*Label 5035*/ GIMT_Encode4(260375), // Rule ID 8351 //
     /* 260328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 260331 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_lane),
     /* 260336 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260339 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260345 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260348 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260352 */     // MIs[0] idx
     /* 260352 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260355 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260360 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1476:{ *:[iPTR] }, nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)  =>  (FMLS_ZZZI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$idx)
     /* 260360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZZZI_D),
     /* 260363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260365 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260369 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260371 */     GIR_RootToRootCopy, /*OpIdx*/5, // idx
     /* 260373 */     GIR_RootConstrainSelectedInstOperands,
     /* 260374 */     // GIR_Coverage, 8351,
     /* 260374 */     GIR_EraseRootFromParent_Done,
     /* 260375 */   // Label 5035: @260375
     /* 260375 */   GIM_Try, /*On fail goto*//*Label 5036*/ GIMT_Encode4(260427), // Rule ID 11315 //
     /* 260380 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMatMulInt8_HasSVE_or_SME),
     /* 260383 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sudot_lane),
     /* 260388 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260391 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260394 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 260397 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 260400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260404 */     // MIs[0] Op4
     /* 260404 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260407 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260412 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1913:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SUDOT_ZZZI:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUDOT_ZZZI),
     /* 260415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260417 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260419 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260421 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260423 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260425 */     GIR_RootConstrainSelectedInstOperands,
     /* 260426 */     // GIR_Coverage, 11315,
     /* 260426 */     GIR_EraseRootFromParent_Done,
     /* 260427 */   // Label 5036: @260427
     /* 260427 */   GIM_Try, /*On fail goto*//*Label 5037*/ GIMT_Encode4(260479), // Rule ID 11362 //
     /* 260432 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260435 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260440 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260443 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260446 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260449 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260452 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260456 */     // MIs[0] Op4
     /* 260456 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260459 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260464 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1612:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (MLS_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_H),
     /* 260467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260477 */     GIR_RootConstrainSelectedInstOperands,
     /* 260478 */     // GIR_Coverage, 11362,
     /* 260478 */     GIR_EraseRootFromParent_Done,
     /* 260479 */   // Label 5037: @260479
     /* 260479 */   GIM_Try, /*On fail goto*//*Label 5038*/ GIMT_Encode4(260531), // Rule ID 11363 //
     /* 260484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260504 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260508 */     // MIs[0] Op4
     /* 260508 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260511 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260516 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1612:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (MLS_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_S),
     /* 260519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260521 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260523 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260525 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260527 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260529 */     GIR_RootConstrainSelectedInstOperands,
     /* 260530 */     // GIR_Coverage, 11363,
     /* 260530 */     GIR_EraseRootFromParent_Done,
     /* 260531 */   // Label 5038: @260531
     /* 260531 */   GIM_Try, /*On fail goto*//*Label 5039*/ GIMT_Encode4(260583), // Rule ID 11364 //
     /* 260536 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260539 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls_lane),
     /* 260544 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260547 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260550 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260553 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260556 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260560 */     // MIs[0] Op4
     /* 260560 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260563 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260568 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1612:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (MLS_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260568 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZZZI_D),
     /* 260571 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260573 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260577 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260579 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260581 */     GIR_RootConstrainSelectedInstOperands,
     /* 260582 */     // GIR_Coverage, 11364,
     /* 260582 */     GIR_EraseRootFromParent_Done,
     /* 260583 */   // Label 5039: @260583
     /* 260583 */   GIM_Try, /*On fail goto*//*Label 5040*/ GIMT_Encode4(260635), // Rule ID 11365 //
     /* 260588 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260591 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260596 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260605 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260608 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260612 */     // MIs[0] Op4
     /* 260612 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260615 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260620 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1830:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_H),
     /* 260623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260625 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260627 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260629 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260631 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260633 */     GIR_RootConstrainSelectedInstOperands,
     /* 260634 */     // GIR_Coverage, 11365,
     /* 260634 */     GIR_EraseRootFromParent_Done,
     /* 260635 */   // Label 5040: @260635
     /* 260635 */   GIM_Try, /*On fail goto*//*Label 5041*/ GIMT_Encode4(260687), // Rule ID 11366 //
     /* 260640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260643 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260648 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260657 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260664 */     // MIs[0] Op4
     /* 260664 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260667 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260672 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1830:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_S),
     /* 260675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260677 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260681 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260683 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260685 */     GIR_RootConstrainSelectedInstOperands,
     /* 260686 */     // GIR_Coverage, 11366,
     /* 260686 */     GIR_EraseRootFromParent_Done,
     /* 260687 */   // Label 5041: @260687
     /* 260687 */   GIM_Try, /*On fail goto*//*Label 5042*/ GIMT_Encode4(260739), // Rule ID 11367 //
     /* 260692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260695 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlah_lane),
     /* 260700 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260703 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260706 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260709 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260712 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260716 */     // MIs[0] Op4
     /* 260716 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260719 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260724 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1830:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLAH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLAH_ZZZI_D),
     /* 260727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260729 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260733 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260735 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260737 */     GIR_RootConstrainSelectedInstOperands,
     /* 260738 */     // GIR_Coverage, 11367,
     /* 260738 */     GIR_EraseRootFromParent_Done,
     /* 260739 */   // Label 5042: @260739
     /* 260739 */   GIM_Try, /*On fail goto*//*Label 5043*/ GIMT_Encode4(260791), // Rule ID 11368 //
     /* 260744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260747 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260752 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 260755 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 260758 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260761 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260768 */     // MIs[0] Op4
     /* 260768 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260771 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260776 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1832:{ *:[iPTR] }, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260776 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_H),
     /* 260779 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260781 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260783 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260785 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260787 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260789 */     GIR_RootConstrainSelectedInstOperands,
     /* 260790 */     // GIR_Coverage, 11368,
     /* 260790 */     GIR_EraseRootFromParent_Done,
     /* 260791 */   // Label 5043: @260791
     /* 260791 */   GIM_Try, /*On fail goto*//*Label 5044*/ GIMT_Encode4(260843), // Rule ID 11369 //
     /* 260796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260799 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260804 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260807 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260810 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260813 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260816 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260820 */     // MIs[0] Op4
     /* 260820 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260823 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260828 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1832:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_S),
     /* 260831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260833 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260837 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260839 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260841 */     GIR_RootConstrainSelectedInstOperands,
     /* 260842 */     // GIR_Coverage, 11369,
     /* 260842 */     GIR_EraseRootFromParent_Done,
     /* 260843 */   // Label 5044: @260843
     /* 260843 */   GIM_Try, /*On fail goto*//*Label 5045*/ GIMT_Encode4(260895), // Rule ID 11370 //
     /* 260848 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260851 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqrdmlsh_lane),
     /* 260856 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 260865 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 260868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260872 */     // MIs[0] Op4
     /* 260872 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260875 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD32b_timm),
     /* 260880 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1832:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)  =>  (SQRDMLSH_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexD32b_timm>>:$Op4)
     /* 260880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQRDMLSH_ZZZI_D),
     /* 260883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260885 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260887 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260889 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260891 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260893 */     GIR_RootConstrainSelectedInstOperands,
     /* 260894 */     // GIR_Coverage, 11370,
     /* 260894 */     GIR_EraseRootFromParent_Done,
     /* 260895 */   // Label 5045: @260895
     /* 260895 */   GIM_Try, /*On fail goto*//*Label 5046*/ GIMT_Encode4(260947), // Rule ID 11413 //
     /* 260900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260903 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 260908 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 260911 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 260914 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 260917 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 260920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260924 */     // MIs[0] Op4
     /* 260924 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260927 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 260932 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1753:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 260932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_S),
     /* 260935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260937 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260941 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260943 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260945 */     GIR_RootConstrainSelectedInstOperands,
     /* 260946 */     // GIR_Coverage, 11413,
     /* 260946 */     GIR_EraseRootFromParent_Done,
     /* 260947 */   // Label 5046: @260947
     /* 260947 */   GIM_Try, /*On fail goto*//*Label 5047*/ GIMT_Encode4(260999), // Rule ID 11414 //
     /* 260952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 260955 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlalt_lane),
     /* 260960 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 260963 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 260966 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 260969 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 260972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 260976 */     // MIs[0] Op4
     /* 260976 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 260979 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 260984 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1753:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 260984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLALT_ZZZI_D),
     /* 260987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 260989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 260991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 260993 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 260995 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 260997 */     GIR_RootConstrainSelectedInstOperands,
     /* 260998 */     // GIR_Coverage, 11414,
     /* 260998 */     GIR_EraseRootFromParent_Done,
     /* 260999 */   // Label 5047: @260999
     /* 260999 */   GIM_Try, /*On fail goto*//*Label 5048*/ GIMT_Encode4(261051), // Rule ID 11415 //
     /* 261004 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261007 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261012 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261021 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261028 */     // MIs[0] Op4
     /* 261028 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261031 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261036 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1989:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261036 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_S),
     /* 261039 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261043 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261045 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261047 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261049 */     GIR_RootConstrainSelectedInstOperands,
     /* 261050 */     // GIR_Coverage, 11415,
     /* 261050 */     GIR_EraseRootFromParent_Done,
     /* 261051 */   // Label 5048: @261051
     /* 261051 */   GIM_Try, /*On fail goto*//*Label 5049*/ GIMT_Encode4(261103), // Rule ID 11416 //
     /* 261056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalb_lane),
     /* 261064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261067 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261070 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261073 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261076 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261080 */     // MIs[0] Op4
     /* 261080 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261083 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261088 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1989:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALB_ZZZI_D),
     /* 261091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261101 */     GIR_RootConstrainSelectedInstOperands,
     /* 261102 */     // GIR_Coverage, 11416,
     /* 261102 */     GIR_EraseRootFromParent_Done,
     /* 261103 */   // Label 5049: @261103
     /* 261103 */   GIM_Try, /*On fail goto*//*Label 5050*/ GIMT_Encode4(261155), // Rule ID 11417 //
     /* 261108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261132 */     // MIs[0] Op4
     /* 261132 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261135 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261140 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1991:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_S),
     /* 261143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261145 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261147 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261149 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261151 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261153 */     GIR_RootConstrainSelectedInstOperands,
     /* 261154 */     // GIR_Coverage, 11417,
     /* 261154 */     GIR_EraseRootFromParent_Done,
     /* 261155 */   // Label 5050: @261155
     /* 261155 */   GIM_Try, /*On fail goto*//*Label 5051*/ GIMT_Encode4(261207), // Rule ID 11418 //
     /* 261160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261163 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlalt_lane),
     /* 261168 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261171 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261174 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261177 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261180 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261184 */     // MIs[0] Op4
     /* 261184 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261187 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261192 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1991:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261192 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLALT_ZZZI_D),
     /* 261195 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261197 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261199 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261201 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261203 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261205 */     GIR_RootConstrainSelectedInstOperands,
     /* 261206 */     // GIR_Coverage, 11418,
     /* 261206 */     GIR_EraseRootFromParent_Done,
     /* 261207 */   // Label 5051: @261207
     /* 261207 */   GIM_Try, /*On fail goto*//*Label 5052*/ GIMT_Encode4(261259), // Rule ID 11419 //
     /* 261212 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261215 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261220 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261223 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261226 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261229 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261232 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261236 */     // MIs[0] Op4
     /* 261236 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261239 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261244 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1755:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_S),
     /* 261247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261249 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261251 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261253 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261255 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261257 */     GIR_RootConstrainSelectedInstOperands,
     /* 261258 */     // GIR_Coverage, 11419,
     /* 261258 */     GIR_EraseRootFromParent_Done,
     /* 261259 */   // Label 5052: @261259
     /* 261259 */   GIM_Try, /*On fail goto*//*Label 5053*/ GIMT_Encode4(261311), // Rule ID 11420 //
     /* 261264 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261267 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslb_lane),
     /* 261272 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261281 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261284 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261288 */     // MIs[0] Op4
     /* 261288 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261291 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261296 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1755:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLB_ZZZI_D),
     /* 261299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261301 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261303 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261305 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261307 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261309 */     GIR_RootConstrainSelectedInstOperands,
     /* 261310 */     // GIR_Coverage, 11420,
     /* 261310 */     GIR_EraseRootFromParent_Done,
     /* 261311 */   // Label 5053: @261311
     /* 261311 */   GIM_Try, /*On fail goto*//*Label 5054*/ GIMT_Encode4(261363), // Rule ID 11421 //
     /* 261316 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261319 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261324 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261333 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261336 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261340 */     // MIs[0] Op4
     /* 261340 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261343 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261348 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1757:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_S),
     /* 261351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261353 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261355 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261357 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261359 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261361 */     GIR_RootConstrainSelectedInstOperands,
     /* 261362 */     // GIR_Coverage, 11421,
     /* 261362 */     GIR_EraseRootFromParent_Done,
     /* 261363 */   // Label 5054: @261363
     /* 261363 */   GIM_Try, /*On fail goto*//*Label 5055*/ GIMT_Encode4(261415), // Rule ID 11422 //
     /* 261368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261371 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_smlslt_lane),
     /* 261376 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261379 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261382 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261385 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261388 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261392 */     // MIs[0] Op4
     /* 261392 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261395 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261400 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1757:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMLSLT_ZZZI_D),
     /* 261403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261407 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261409 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261411 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261413 */     GIR_RootConstrainSelectedInstOperands,
     /* 261414 */     // GIR_Coverage, 11422,
     /* 261414 */     GIR_EraseRootFromParent_Done,
     /* 261415 */   // Label 5055: @261415
     /* 261415 */   GIM_Try, /*On fail goto*//*Label 5056*/ GIMT_Encode4(261467), // Rule ID 11423 //
     /* 261420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261423 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261428 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261431 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261434 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261437 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261440 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261444 */     // MIs[0] Op4
     /* 261444 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261447 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261452 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1993:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_S),
     /* 261455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261457 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261459 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261461 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261463 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261465 */     GIR_RootConstrainSelectedInstOperands,
     /* 261466 */     // GIR_Coverage, 11423,
     /* 261466 */     GIR_EraseRootFromParent_Done,
     /* 261467 */   // Label 5056: @261467
     /* 261467 */   GIM_Try, /*On fail goto*//*Label 5057*/ GIMT_Encode4(261519), // Rule ID 11424 //
     /* 261472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261475 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslb_lane),
     /* 261480 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261483 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261486 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261489 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261492 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261496 */     // MIs[0] Op4
     /* 261496 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261499 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261504 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1993:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261504 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLB_ZZZI_D),
     /* 261507 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261509 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261511 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261513 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261515 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261517 */     GIR_RootConstrainSelectedInstOperands,
     /* 261518 */     // GIR_Coverage, 11424,
     /* 261518 */     GIR_EraseRootFromParent_Done,
     /* 261519 */   // Label 5057: @261519
     /* 261519 */   GIM_Try, /*On fail goto*//*Label 5058*/ GIMT_Encode4(261571), // Rule ID 11425 //
     /* 261524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261527 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261532 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261541 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261544 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261548 */     // MIs[0] Op4
     /* 261548 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261551 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261556 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1995:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261556 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_S),
     /* 261559 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261561 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261563 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261565 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261567 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261569 */     GIR_RootConstrainSelectedInstOperands,
     /* 261570 */     // GIR_Coverage, 11425,
     /* 261570 */     GIR_EraseRootFromParent_Done,
     /* 261571 */   // Label 5058: @261571
     /* 261571 */   GIM_Try, /*On fail goto*//*Label 5059*/ GIMT_Encode4(261623), // Rule ID 11426 //
     /* 261576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261579 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_umlslt_lane),
     /* 261584 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261593 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261596 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261600 */     // MIs[0] Op4
     /* 261600 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261603 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261608 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1995:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMLSLT_ZZZI_D),
     /* 261611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261613 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261615 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261617 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261619 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261621 */     GIR_RootConstrainSelectedInstOperands,
     /* 261622 */     // GIR_Coverage, 11426,
     /* 261622 */     GIR_EraseRootFromParent_Done,
     /* 261623 */   // Label 5059: @261623
     /* 261623 */   GIM_Try, /*On fail goto*//*Label 5060*/ GIMT_Encode4(261675), // Rule ID 11448 //
     /* 261628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261631 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261636 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261639 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261645 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261652 */     // MIs[0] Op4
     /* 261652 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261655 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261660 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1793:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261660 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_S),
     /* 261663 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261665 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261667 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261669 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261671 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261673 */     GIR_RootConstrainSelectedInstOperands,
     /* 261674 */     // GIR_Coverage, 11448,
     /* 261674 */     GIR_EraseRootFromParent_Done,
     /* 261675 */   // Label 5060: @261675
     /* 261675 */   GIM_Try, /*On fail goto*//*Label 5061*/ GIMT_Encode4(261727), // Rule ID 11449 //
     /* 261680 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261683 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalb_lane),
     /* 261688 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261697 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261700 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261704 */     // MIs[0] Op4
     /* 261704 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261707 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261712 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1793:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALB_ZZZI_D),
     /* 261715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261725 */     GIR_RootConstrainSelectedInstOperands,
     /* 261726 */     // GIR_Coverage, 11449,
     /* 261726 */     GIR_EraseRootFromParent_Done,
     /* 261727 */   // Label 5061: @261727
     /* 261727 */   GIM_Try, /*On fail goto*//*Label 5062*/ GIMT_Encode4(261779), // Rule ID 11450 //
     /* 261732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261752 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261756 */     // MIs[0] Op4
     /* 261756 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261759 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261764 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1796:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_S),
     /* 261767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261773 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261775 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261777 */     GIR_RootConstrainSelectedInstOperands,
     /* 261778 */     // GIR_Coverage, 11450,
     /* 261778 */     GIR_EraseRootFromParent_Done,
     /* 261779 */   // Label 5062: @261779
     /* 261779 */   GIM_Try, /*On fail goto*//*Label 5063*/ GIMT_Encode4(261831), // Rule ID 11451 //
     /* 261784 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261787 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlalt_lane),
     /* 261792 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261795 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261798 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261801 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261804 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261808 */     // MIs[0] Op4
     /* 261808 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261811 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261816 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1796:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLALT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261816 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALT_ZZZI_D),
     /* 261819 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261821 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261823 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261825 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261827 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261829 */     GIR_RootConstrainSelectedInstOperands,
     /* 261830 */     // GIR_Coverage, 11451,
     /* 261830 */     GIR_EraseRootFromParent_Done,
     /* 261831 */   // Label 5063: @261831
     /* 261831 */   GIM_Try, /*On fail goto*//*Label 5064*/ GIMT_Encode4(261883), // Rule ID 11452 //
     /* 261836 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261839 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 261844 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261847 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261850 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261853 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261856 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261860 */     // MIs[0] Op4
     /* 261860 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261863 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261868 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1798:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261868 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_S),
     /* 261871 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261877 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261879 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261881 */     GIR_RootConstrainSelectedInstOperands,
     /* 261882 */     // GIR_Coverage, 11452,
     /* 261882 */     GIR_EraseRootFromParent_Done,
     /* 261883 */   // Label 5064: @261883
     /* 261883 */   GIM_Try, /*On fail goto*//*Label 5065*/ GIMT_Encode4(261935), // Rule ID 11453 //
     /* 261888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261891 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslb_lane),
     /* 261896 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 261899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 261902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 261905 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 261908 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261912 */     // MIs[0] Op4
     /* 261912 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261915 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 261920 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1798:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLB_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 261920 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLB_ZZZI_D),
     /* 261923 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261925 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261929 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261931 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261933 */     GIR_RootConstrainSelectedInstOperands,
     /* 261934 */     // GIR_Coverage, 11453,
     /* 261934 */     GIR_EraseRootFromParent_Done,
     /* 261935 */   // Label 5065: @261935
     /* 261935 */   GIM_Try, /*On fail goto*//*Label 5066*/ GIMT_Encode4(261987), // Rule ID 11454 //
     /* 261940 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261943 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 261948 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 261951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 261954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 261957 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 261960 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 261964 */     // MIs[0] Op4
     /* 261964 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 261967 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 261972 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1801:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 261972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_S),
     /* 261975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 261977 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 261979 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 261981 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 261983 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 261985 */     GIR_RootConstrainSelectedInstOperands,
     /* 261986 */     // GIR_Coverage, 11454,
     /* 261986 */     GIR_EraseRootFromParent_Done,
     /* 261987 */   // Label 5066: @261987
     /* 261987 */   GIM_Try, /*On fail goto*//*Label 5067*/ GIMT_Encode4(262039), // Rule ID 11455 //
     /* 261992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 261995 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_sqdmlslt_lane),
     /* 262000 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262003 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 262006 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262009 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262012 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262016 */     // MIs[0] Op4
     /* 262016 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262019 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262024 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1801:{ *:[iPTR] }, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (SQDMLSLT_ZZZI_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLT_ZZZI_D),
     /* 262027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262033 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262035 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262037 */     GIR_RootConstrainSelectedInstOperands,
     /* 262038 */     // GIR_Coverage, 11455,
     /* 262038 */     GIR_EraseRootFromParent_Done,
     /* 262039 */   // Label 5067: @262039
     /* 262039 */   GIM_Try, /*On fail goto*//*Label 5068*/ GIMT_Encode4(262091), // Rule ID 11921 //
     /* 262044 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262047 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalb_lane),
     /* 262052 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262055 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262058 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262061 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262064 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262068 */     // MIs[0] Op4
     /* 262068 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262071 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262076 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1472:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI_SHH),
     /* 262079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262085 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262087 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262089 */     GIR_RootConstrainSelectedInstOperands,
     /* 262090 */     // GIR_Coverage, 11921,
     /* 262090 */     GIR_EraseRootFromParent_Done,
     /* 262091 */   // Label 5068: @262091
     /* 262091 */   GIM_Try, /*On fail goto*//*Label 5069*/ GIMT_Encode4(262143), // Rule ID 11922 //
     /* 262096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262099 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlalt_lane),
     /* 262104 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262107 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262110 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262113 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262116 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262120 */     // MIs[0] Op4
     /* 262120 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262123 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262128 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1474:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLALT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI_SHH),
     /* 262131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262133 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262137 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262139 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262141 */     GIR_RootConstrainSelectedInstOperands,
     /* 262142 */     // GIR_Coverage, 11922,
     /* 262142 */     GIR_EraseRootFromParent_Done,
     /* 262143 */   // Label 5069: @262143
     /* 262143 */   GIM_Try, /*On fail goto*//*Label 5070*/ GIMT_Encode4(262195), // Rule ID 11923 //
     /* 262148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262151 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslb_lane),
     /* 262156 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262159 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262165 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262168 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262172 */     // MIs[0] Op4
     /* 262172 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262175 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262180 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1479:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLB_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLB_ZZZI_SHH),
     /* 262183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262187 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262189 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262191 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262193 */     GIR_RootConstrainSelectedInstOperands,
     /* 262194 */     // GIR_Coverage, 11923,
     /* 262194 */     GIR_EraseRootFromParent_Done,
     /* 262195 */   // Label 5070: @262195
     /* 262195 */   GIM_Try, /*On fail goto*//*Label 5071*/ GIMT_Encode4(262247), // Rule ID 11924 //
     /* 262200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 262203 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmlslt_lane),
     /* 262208 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262217 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262224 */     // MIs[0] Op4
     /* 262224 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262227 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 262232 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1481:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)  =>  (FMLSLT_ZZZI_SHH:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Op4)
     /* 262232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSLT_ZZZI_SHH),
     /* 262235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262237 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262241 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262243 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262245 */     GIR_RootConstrainSelectedInstOperands,
     /* 262246 */     // GIR_Coverage, 11924,
     /* 262246 */     GIR_EraseRootFromParent_Done,
     /* 262247 */   // Label 5071: @262247
     /* 262247 */   GIM_Try, /*On fail goto*//*Label 5072*/ GIMT_Encode4(262299), // Rule ID 12067 //
     /* 262252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fdot_lane_x2),
     /* 262260 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262266 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262269 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262276 */     // MIs[0] Op4
     /* 262276 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262279 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262284 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1427:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (FDOT_ZZZI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_S),
     /* 262287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262289 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262291 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262293 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262295 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262297 */     GIR_RootConstrainSelectedInstOperands,
     /* 262298 */     // GIR_Coverage, 12067,
     /* 262298 */     GIR_EraseRootFromParent_Done,
     /* 262299 */   // Label 5072: @262299
     /* 262299 */   GIM_Try, /*On fail goto*//*Label 5073*/ GIMT_Encode4(262351), // Rule ID 12069 //
     /* 262304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2p1_or_SME2),
     /* 262307 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_udot_lane_x2),
     /* 262312 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262315 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 262318 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262321 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262324 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262328 */     // MIs[0] Op4
     /* 262328 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 262331 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 262336 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1965:{ *:[iPTR] }, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)  =>  (UDOT_ZZZI_HtoS:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Op4)
     /* 262336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZI_HtoS),
     /* 262339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262341 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262343 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262345 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262347 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262349 */     GIR_RootConstrainSelectedInstOperands,
     /* 262350 */     // GIR_Coverage, 12069,
     /* 262350 */     GIR_EraseRootFromParent_Done,
     /* 262351 */   // Label 5073: @262351
     /* 262351 */   GIM_Try, /*On fail goto*//*Label 5074*/ GIMT_Encode4(262398), // Rule ID 2825 //
     /* 262356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262364 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262367 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262370 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262373 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262376 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262379 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262383 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1468:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262388 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262390 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262392 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262394 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262396 */     GIR_RootConstrainSelectedInstOperands,
     /* 262397 */     // GIR_Coverage, 2825,
     /* 262397 */     GIR_EraseRootFromParent_Done,
     /* 262398 */   // Label 5074: @262398
     /* 262398 */   GIM_Try, /*On fail goto*//*Label 5075*/ GIMT_Encode4(262445), // Rule ID 2828 //
     /* 262403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262406 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262411 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 262414 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262417 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 262420 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 262423 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 262426 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262430 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 262430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262435 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262437 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262439 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262441 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262443 */     GIR_RootConstrainSelectedInstOperands,
     /* 262444 */     // GIR_Coverage, 2828,
     /* 262444 */     GIR_EraseRootFromParent_Done,
     /* 262445 */   // Label 5075: @262445
     /* 262445 */   GIM_Try, /*On fail goto*//*Label 5076*/ GIMT_Encode4(262492), // Rule ID 2831 //
     /* 262450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 262461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 262467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 262470 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 262473 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262477 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 262477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_H),
     /* 262480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262484 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262486 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262488 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262490 */     GIR_RootConstrainSelectedInstOperands,
     /* 262491 */     // GIR_Coverage, 2831,
     /* 262491 */     GIR_EraseRootFromParent_Done,
     /* 262492 */   // Label 5076: @262492
     /* 262492 */   GIM_Try, /*On fail goto*//*Label 5077*/ GIMT_Encode4(262539), // Rule ID 2834 //
     /* 262497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262500 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262505 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262508 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262511 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262514 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262517 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262520 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262524 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1468:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262529 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262533 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262535 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262537 */     GIR_RootConstrainSelectedInstOperands,
     /* 262538 */     // GIR_Coverage, 2834,
     /* 262538 */     GIR_EraseRootFromParent_Done,
     /* 262539 */   // Label 5077: @262539
     /* 262539 */   GIM_Try, /*On fail goto*//*Label 5078*/ GIMT_Encode4(262586), // Rule ID 2837 //
     /* 262544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262552 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 262555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 262561 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 262564 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 262567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262571 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 262571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_S),
     /* 262574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262576 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262578 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262580 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262582 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262584 */     GIR_RootConstrainSelectedInstOperands,
     /* 262585 */     // GIR_Coverage, 2837,
     /* 262585 */     GIR_EraseRootFromParent_Done,
     /* 262586 */   // Label 5078: @262586
     /* 262586 */   GIM_Try, /*On fail goto*//*Label 5079*/ GIMT_Encode4(262633), // Rule ID 2840 //
     /* 262591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262594 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmla),
     /* 262599 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262602 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262605 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262608 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262611 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262618 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1468:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLA_ZPmZZ_D),
     /* 262621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262625 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262627 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262629 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262631 */     GIR_RootConstrainSelectedInstOperands,
     /* 262632 */     // GIR_Coverage, 2840,
     /* 262632 */     GIR_EraseRootFromParent_Done,
     /* 262633 */   // Label 5079: @262633
     /* 262633 */   GIM_Try, /*On fail goto*//*Label 5080*/ GIMT_Encode4(262680), // Rule ID 2843 //
     /* 262638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262646 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262655 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262658 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262665 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1431:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 262665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_H),
     /* 262668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262672 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262674 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262676 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262678 */     GIR_RootConstrainSelectedInstOperands,
     /* 262679 */     // GIR_Coverage, 2843,
     /* 262679 */     GIR_EraseRootFromParent_Done,
     /* 262680 */   // Label 5080: @262680
     /* 262680 */   GIM_Try, /*On fail goto*//*Label 5081*/ GIMT_Encode4(262727), // Rule ID 2844 //
     /* 262685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262688 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262693 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262696 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262699 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262702 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262705 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262708 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262712 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1431:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 262712 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_S),
     /* 262715 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262717 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262719 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262721 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262723 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262725 */     GIR_RootConstrainSelectedInstOperands,
     /* 262726 */     // GIR_Coverage, 2844,
     /* 262726 */     GIR_EraseRootFromParent_Done,
     /* 262727 */   // Label 5081: @262727
     /* 262727 */   GIM_Try, /*On fail goto*//*Label 5082*/ GIMT_Encode4(262774), // Rule ID 2845 //
     /* 262732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262735 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmad),
     /* 262740 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262743 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262746 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262749 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262752 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262755 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262759 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1431:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 262759 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMAD_ZPmZZ_D),
     /* 262762 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262764 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262766 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262768 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262770 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262772 */     GIR_RootConstrainSelectedInstOperands,
     /* 262773 */     // GIR_Coverage, 2845,
     /* 262773 */     GIR_EraseRootFromParent_Done,
     /* 262774 */   // Label 5082: @262774
     /* 262774 */   GIM_Try, /*On fail goto*//*Label 5083*/ GIMT_Encode4(262821), // Rule ID 2941 //
     /* 262779 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262782 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262787 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 262790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 262793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262796 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262799 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 262802 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262806 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1606:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MAD_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 262806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_B),
     /* 262809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262811 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262813 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262815 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262817 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262819 */     GIR_RootConstrainSelectedInstOperands,
     /* 262820 */     // GIR_Coverage, 2941,
     /* 262820 */     GIR_EraseRootFromParent_Done,
     /* 262821 */   // Label 5083: @262821
     /* 262821 */   GIM_Try, /*On fail goto*//*Label 5084*/ GIMT_Encode4(262868), // Rule ID 2944 //
     /* 262826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 262837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 262840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 262843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 262846 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 262849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262853 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1606:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MAD_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 262853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_H),
     /* 262856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262858 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262862 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262864 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262866 */     GIR_RootConstrainSelectedInstOperands,
     /* 262867 */     // GIR_Coverage, 2944,
     /* 262867 */     GIR_EraseRootFromParent_Done,
     /* 262868 */   // Label 5084: @262868
     /* 262868 */   GIM_Try, /*On fail goto*//*Label 5085*/ GIMT_Encode4(262915), // Rule ID 2947 //
     /* 262873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262876 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262881 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 262884 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 262887 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 262890 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 262893 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 262896 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262900 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1606:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MAD_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 262900 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_S),
     /* 262903 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262905 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262907 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262909 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262911 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262913 */     GIR_RootConstrainSelectedInstOperands,
     /* 262914 */     // GIR_Coverage, 2947,
     /* 262914 */     GIR_EraseRootFromParent_Done,
     /* 262915 */   // Label 5085: @262915
     /* 262915 */   GIM_Try, /*On fail goto*//*Label 5086*/ GIMT_Encode4(262962), // Rule ID 2950 //
     /* 262920 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262923 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mad),
     /* 262928 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 262931 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 262934 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 262937 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 262940 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 262943 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262947 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1606:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MAD_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 262947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MAD_ZPmZZ_D),
     /* 262950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 262952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 262954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 262956 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 262958 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 262960 */     GIR_RootConstrainSelectedInstOperands,
     /* 262961 */     // GIR_Coverage, 2950,
     /* 262961 */     GIR_EraseRootFromParent_Done,
     /* 262962 */   // Label 5086: @262962
     /* 262962 */   GIM_Try, /*On fail goto*//*Label 5087*/ GIMT_Encode4(263009), // Rule ID 2953 //
     /* 262967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 262970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 262975 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 262978 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 262981 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 262984 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 262987 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 262990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 262994 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1608:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLA_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 262994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_B),
     /* 262997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 262999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263007 */     GIR_RootConstrainSelectedInstOperands,
     /* 263008 */     // GIR_Coverage, 2953,
     /* 263008 */     GIR_EraseRootFromParent_Done,
     /* 263009 */   // Label 5087: @263009
     /* 263009 */   GIM_Try, /*On fail goto*//*Label 5088*/ GIMT_Encode4(263056), // Rule ID 2955 //
     /* 263014 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263017 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263022 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263031 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263034 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263041 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1608:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLA_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_H),
     /* 263044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263050 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263052 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263054 */     GIR_RootConstrainSelectedInstOperands,
     /* 263055 */     // GIR_Coverage, 2955,
     /* 263055 */     GIR_EraseRootFromParent_Done,
     /* 263056 */   // Label 5088: @263056
     /* 263056 */   GIM_Try, /*On fail goto*//*Label 5089*/ GIMT_Encode4(263103), // Rule ID 2957 //
     /* 263061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263069 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263072 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263075 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263078 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263081 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263084 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263088 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1608:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLA_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_S),
     /* 263091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263093 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263095 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263097 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263099 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263101 */     GIR_RootConstrainSelectedInstOperands,
     /* 263102 */     // GIR_Coverage, 2957,
     /* 263102 */     GIR_EraseRootFromParent_Done,
     /* 263103 */   // Label 5089: @263103
     /* 263103 */   GIM_Try, /*On fail goto*//*Label 5090*/ GIMT_Encode4(263150), // Rule ID 2959 //
     /* 263108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263111 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mla),
     /* 263116 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263119 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263122 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263125 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263128 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263131 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263135 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1608:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLA_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLA_ZPmZZ_D),
     /* 263138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263144 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263146 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263148 */     GIR_RootConstrainSelectedInstOperands,
     /* 263149 */     // GIR_Coverage, 2959,
     /* 263149 */     GIR_EraseRootFromParent_Done,
     /* 263150 */   // Label 5090: @263150
     /* 263150 */   GIM_Try, /*On fail goto*//*Label 5091*/ GIMT_Encode4(263197), // Rule ID 7614 //
     /* 263155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263158 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263163 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263178 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263182 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1614:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MSB_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263182 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_B),
     /* 263185 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263187 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263189 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263191 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263193 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263195 */     GIR_RootConstrainSelectedInstOperands,
     /* 263196 */     // GIR_Coverage, 7614,
     /* 263196 */     GIR_EraseRootFromParent_Done,
     /* 263197 */   // Label 5091: @263197
     /* 263197 */   GIM_Try, /*On fail goto*//*Label 5092*/ GIMT_Encode4(263244), // Rule ID 7617 //
     /* 263202 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263205 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263210 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263213 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263216 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263219 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263222 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263225 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263229 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1614:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MSB_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_H),
     /* 263232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263238 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263240 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263242 */     GIR_RootConstrainSelectedInstOperands,
     /* 263243 */     // GIR_Coverage, 7617,
     /* 263243 */     GIR_EraseRootFromParent_Done,
     /* 263244 */   // Label 5092: @263244
     /* 263244 */   GIM_Try, /*On fail goto*//*Label 5093*/ GIMT_Encode4(263291), // Rule ID 7620 //
     /* 263249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263252 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263257 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263260 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263263 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263266 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263269 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263272 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263276 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1614:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MSB_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_S),
     /* 263279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263285 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263287 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263289 */     GIR_RootConstrainSelectedInstOperands,
     /* 263290 */     // GIR_Coverage, 7620,
     /* 263290 */     GIR_EraseRootFromParent_Done,
     /* 263291 */   // Label 5093: @263291
     /* 263291 */   GIM_Try, /*On fail goto*//*Label 5094*/ GIMT_Encode4(263338), // Rule ID 7623 //
     /* 263296 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263299 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_msb),
     /* 263304 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263307 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263310 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263313 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263316 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263319 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263323 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1614:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MSB_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSB_ZPmZZ_D),
     /* 263326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 263328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263330 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263332 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263334 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263336 */     GIR_RootConstrainSelectedInstOperands,
     /* 263337 */     // GIR_Coverage, 7623,
     /* 263337 */     GIR_EraseRootFromParent_Done,
     /* 263338 */   // Label 5094: @263338
     /* 263338 */   GIM_Try, /*On fail goto*//*Label 5095*/ GIMT_Encode4(263385), // Rule ID 7626 //
     /* 263343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263346 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263351 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s8,
     /* 263354 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 263357 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 263360 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 263363 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 263366 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263370 */     // (intrinsic_wo_chain:{ *:[nxv16i8] } 1611:{ *:[iPTR] }, nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op4)  =>  (MLS_ZPmZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[nxv16i8] }:$Op4)
     /* 263370 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_B),
     /* 263373 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263377 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263379 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263381 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263383 */     GIR_RootConstrainSelectedInstOperands,
     /* 263384 */     // GIR_Coverage, 7626,
     /* 263384 */     GIR_EraseRootFromParent_Done,
     /* 263385 */   // Label 5095: @263385
     /* 263385 */   GIM_Try, /*On fail goto*//*Label 5096*/ GIMT_Encode4(263432), // Rule ID 7628 //
     /* 263390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263393 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263398 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263401 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263404 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263407 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263410 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263417 */     // (intrinsic_wo_chain:{ *:[nxv8i16] } 1611:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op4)  =>  (MLS_ZPmZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3, ?:{ *:[nxv8i16] }:$Op4)
     /* 263417 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_H),
     /* 263420 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263422 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263424 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263426 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263428 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263430 */     GIR_RootConstrainSelectedInstOperands,
     /* 263431 */     // GIR_Coverage, 7628,
     /* 263431 */     GIR_EraseRootFromParent_Done,
     /* 263432 */   // Label 5096: @263432
     /* 263432 */   GIM_Try, /*On fail goto*//*Label 5097*/ GIMT_Encode4(263479), // Rule ID 7630 //
     /* 263437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263440 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263445 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263448 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263451 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263454 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263457 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263464 */     // (intrinsic_wo_chain:{ *:[nxv4i32] } 1611:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op4)  =>  (MLS_ZPmZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3, ?:{ *:[nxv4i32] }:$Op4)
     /* 263464 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_S),
     /* 263467 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263469 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263471 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263473 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263475 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263477 */     GIR_RootConstrainSelectedInstOperands,
     /* 263478 */     // GIR_Coverage, 7630,
     /* 263478 */     GIR_EraseRootFromParent_Done,
     /* 263479 */   // Label 5097: @263479
     /* 263479 */   GIM_Try, /*On fail goto*//*Label 5098*/ GIMT_Encode4(263526), // Rule ID 7632 //
     /* 263484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263487 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_mls),
     /* 263492 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263495 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263498 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263501 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263504 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263507 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263511 */     // (intrinsic_wo_chain:{ *:[nxv2i64] } 1611:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op4)  =>  (MLS_ZPmZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3, ?:{ *:[nxv2i64] }:$Op4)
     /* 263511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MLS_ZPmZZ_D),
     /* 263514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263518 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263520 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263522 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263524 */     GIR_RootConstrainSelectedInstOperands,
     /* 263525 */     // GIR_Coverage, 7632,
     /* 263525 */     GIR_EraseRootFromParent_Done,
     /* 263526 */   // Label 5098: @263526
     /* 263526 */   GIM_Try, /*On fail goto*//*Label 5099*/ GIMT_Encode4(263573), // Rule ID 8262 //
     /* 263531 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263534 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263539 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263542 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263545 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263548 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263551 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263554 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263558 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1475:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263558 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263561 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263563 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263565 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263567 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263569 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263571 */     GIR_RootConstrainSelectedInstOperands,
     /* 263572 */     // GIR_Coverage, 8262,
     /* 263572 */     GIR_EraseRootFromParent_Done,
     /* 263573 */   // Label 5099: @263573
     /* 263573 */   GIM_Try, /*On fail goto*//*Label 5100*/ GIMT_Encode4(263620), // Rule ID 8265 //
     /* 263578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263586 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263589 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263592 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263595 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263598 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263601 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263605 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263614 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263616 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263618 */     GIR_RootConstrainSelectedInstOperands,
     /* 263619 */     // GIR_Coverage, 8265,
     /* 263619 */     GIR_EraseRootFromParent_Done,
     /* 263620 */   // Label 5100: @263620
     /* 263620 */   GIM_Try, /*On fail goto*//*Label 5101*/ GIMT_Encode4(263667), // Rule ID 8268 //
     /* 263625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263628 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263633 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263636 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263639 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263642 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263645 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263648 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263652 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_H),
     /* 263655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263657 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263661 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263663 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263665 */     GIR_RootConstrainSelectedInstOperands,
     /* 263666 */     // GIR_Coverage, 8268,
     /* 263666 */     GIR_EraseRootFromParent_Done,
     /* 263667 */   // Label 5101: @263667
     /* 263667 */   GIM_Try, /*On fail goto*//*Label 5102*/ GIMT_Encode4(263714), // Rule ID 8271 //
     /* 263672 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263675 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263680 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263683 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263686 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263689 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263692 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263695 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263699 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1475:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263704 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263708 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263710 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263712 */     GIR_RootConstrainSelectedInstOperands,
     /* 263713 */     // GIR_Coverage, 8271,
     /* 263713 */     GIR_EraseRootFromParent_Done,
     /* 263714 */   // Label 5102: @263714
     /* 263714 */   GIM_Try, /*On fail goto*//*Label 5103*/ GIMT_Encode4(263761), // Rule ID 8274 //
     /* 263719 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263722 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263727 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 263730 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263733 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 263736 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 263739 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 263742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263746 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 263746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_S),
     /* 263749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263751 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263753 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263755 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263757 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263759 */     GIR_RootConstrainSelectedInstOperands,
     /* 263760 */     // GIR_Coverage, 8274,
     /* 263760 */     GIR_EraseRootFromParent_Done,
     /* 263761 */   // Label 5103: @263761
     /* 263761 */   GIM_Try, /*On fail goto*//*Label 5104*/ GIMT_Encode4(263808), // Rule ID 8277 //
     /* 263766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263769 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls),
     /* 263774 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 263777 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263780 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 263783 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 263786 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 263789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263793 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1475:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 263793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPmZZ_D),
     /* 263796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263802 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263804 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263806 */     GIR_RootConstrainSelectedInstOperands,
     /* 263807 */     // GIR_Coverage, 8277,
     /* 263807 */     GIR_EraseRootFromParent_Done,
     /* 263808 */   // Label 5104: @263808
     /* 263808 */   GIM_Try, /*On fail goto*//*Label 5105*/ GIMT_Encode4(263855), // Rule ID 8280 //
     /* 263813 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263816 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263821 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 263824 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 263827 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 263830 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 263833 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 263836 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263840 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1491:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 263840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 263843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263845 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263849 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263851 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263853 */     GIR_RootConstrainSelectedInstOperands,
     /* 263854 */     // GIR_Coverage, 8280,
     /* 263854 */     GIR_EraseRootFromParent_Done,
     /* 263855 */   // Label 5105: @263855
     /* 263855 */   GIM_Try, /*On fail goto*//*Label 5106*/ GIMT_Encode4(263902), // Rule ID 8281 //
     /* 263860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263863 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263868 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 263871 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263874 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 263877 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 263880 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 263883 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263887 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 263887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 263890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263892 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263894 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263896 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263898 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263900 */     GIR_RootConstrainSelectedInstOperands,
     /* 263901 */     // GIR_Coverage, 8281,
     /* 263901 */     GIR_EraseRootFromParent_Done,
     /* 263902 */   // Label 5106: @263902
     /* 263902 */   GIM_Try, /*On fail goto*//*Label 5107*/ GIMT_Encode4(263949), // Rule ID 8282 //
     /* 263907 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263910 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263915 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 263918 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 263921 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 263924 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 263927 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 263930 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263934 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 263934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_H),
     /* 263937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263941 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263943 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263945 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263947 */     GIR_RootConstrainSelectedInstOperands,
     /* 263948 */     // GIR_Coverage, 8282,
     /* 263948 */     GIR_EraseRootFromParent_Done,
     /* 263949 */   // Label 5107: @263949
     /* 263949 */   GIM_Try, /*On fail goto*//*Label 5108*/ GIMT_Encode4(263996), // Rule ID 8283 //
     /* 263954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 263957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 263962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 263965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 263968 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 263971 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 263974 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 263977 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 263981 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1491:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 263981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 263984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 263986 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 263988 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 263990 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 263992 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 263994 */     GIR_RootConstrainSelectedInstOperands,
     /* 263995 */     // GIR_Coverage, 8283,
     /* 263995 */     GIR_EraseRootFromParent_Done,
     /* 263996 */   // Label 5108: @263996
     /* 263996 */   GIM_Try, /*On fail goto*//*Label 5109*/ GIMT_Encode4(264043), // Rule ID 8284 //
     /* 264001 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264004 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264009 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264012 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264015 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264018 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264021 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264024 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264028 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_S),
     /* 264031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264033 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264035 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264037 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264039 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264041 */     GIR_RootConstrainSelectedInstOperands,
     /* 264042 */     // GIR_Coverage, 8284,
     /* 264042 */     GIR_EraseRootFromParent_Done,
     /* 264043 */   // Label 5109: @264043
     /* 264043 */   GIM_Try, /*On fail goto*//*Label 5110*/ GIMT_Encode4(264090), // Rule ID 8285 //
     /* 264048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264051 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla),
     /* 264056 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264059 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264062 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264065 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264068 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264075 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1491:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPmZZ_D),
     /* 264078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264084 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264086 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264088 */     GIR_RootConstrainSelectedInstOperands,
     /* 264089 */     // GIR_Coverage, 8285,
     /* 264089 */     GIR_EraseRootFromParent_Done,
     /* 264090 */   // Label 5110: @264090
     /* 264090 */   GIM_Try, /*On fail goto*//*Label 5111*/ GIMT_Encode4(264137), // Rule ID 8286 //
     /* 264095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264098 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264103 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264118 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264122 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1493:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264129 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264131 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264133 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264135 */     GIR_RootConstrainSelectedInstOperands,
     /* 264136 */     // GIR_Coverage, 8286,
     /* 264136 */     GIR_EraseRootFromParent_Done,
     /* 264137 */   // Label 5111: @264137
     /* 264137 */   GIM_Try, /*On fail goto*//*Label 5112*/ GIMT_Encode4(264184), // Rule ID 8287 //
     /* 264142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264145 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264150 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264159 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264162 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264165 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264169 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264174 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264176 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264178 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264180 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264182 */     GIR_RootConstrainSelectedInstOperands,
     /* 264183 */     // GIR_Coverage, 8287,
     /* 264183 */     GIR_EraseRootFromParent_Done,
     /* 264184 */   // Label 5112: @264184
     /* 264184 */   GIM_Try, /*On fail goto*//*Label 5113*/ GIMT_Encode4(264231), // Rule ID 8288 //
     /* 264189 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264192 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264197 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264200 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264203 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264206 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264209 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264212 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264216 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPmZZ_H:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_H),
     /* 264219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264225 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264227 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264229 */     GIR_RootConstrainSelectedInstOperands,
     /* 264230 */     // GIR_Coverage, 8288,
     /* 264230 */     GIR_EraseRootFromParent_Done,
     /* 264231 */   // Label 5113: @264231
     /* 264231 */   GIM_Try, /*On fail goto*//*Label 5114*/ GIMT_Encode4(264278), // Rule ID 8289 //
     /* 264236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264239 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264244 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264247 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264250 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264253 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264256 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264263 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1493:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264268 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264272 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264274 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264276 */     GIR_RootConstrainSelectedInstOperands,
     /* 264277 */     // GIR_Coverage, 8289,
     /* 264277 */     GIR_EraseRootFromParent_Done,
     /* 264278 */   // Label 5114: @264278
     /* 264278 */   GIM_Try, /*On fail goto*//*Label 5115*/ GIMT_Encode4(264325), // Rule ID 8290 //
     /* 264283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 264300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 264303 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 264306 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264310 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPmZZ_S:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 264310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_S),
     /* 264313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264315 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264317 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264319 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264321 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264323 */     GIR_RootConstrainSelectedInstOperands,
     /* 264324 */     // GIR_Coverage, 8290,
     /* 264324 */     GIR_EraseRootFromParent_Done,
     /* 264325 */   // Label 5115: @264325
     /* 264325 */   GIM_Try, /*On fail goto*//*Label 5116*/ GIMT_Encode4(264372), // Rule ID 8291 //
     /* 264330 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264333 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls),
     /* 264338 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264341 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264344 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264347 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264350 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264353 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264357 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1493:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPmZZ_D),
     /* 264360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 264362 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264364 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264366 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264368 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264370 */     GIR_RootConstrainSelectedInstOperands,
     /* 264371 */     // GIR_Coverage, 8291,
     /* 264371 */     GIR_EraseRootFromParent_Done,
     /* 264372 */   // Label 5116: @264372
     /* 264372 */   GIM_Try, /*On fail goto*//*Label 5117*/ GIMT_Encode4(264419), // Rule ID 8292 //
     /* 264377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264380 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264385 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264388 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264391 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264394 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264397 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264400 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264404 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1483:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_H),
     /* 264407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264409 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264413 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264415 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264417 */     GIR_RootConstrainSelectedInstOperands,
     /* 264418 */     // GIR_Coverage, 8292,
     /* 264418 */     GIR_EraseRootFromParent_Done,
     /* 264419 */   // Label 5117: @264419
     /* 264419 */   GIM_Try, /*On fail goto*//*Label 5118*/ GIMT_Encode4(264466), // Rule ID 8293 //
     /* 264424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264427 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264432 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264435 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264438 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264441 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264444 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264451 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1483:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264451 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_S),
     /* 264454 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264456 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264458 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264460 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264462 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264464 */     GIR_RootConstrainSelectedInstOperands,
     /* 264465 */     // GIR_Coverage, 8293,
     /* 264465 */     GIR_EraseRootFromParent_Done,
     /* 264466 */   // Label 5118: @264466
     /* 264466 */   GIM_Try, /*On fail goto*//*Label 5119*/ GIMT_Encode4(264513), // Rule ID 8294 //
     /* 264471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264474 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmsb),
     /* 264479 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264482 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264485 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264488 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264491 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264498 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1483:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSB_ZPmZZ_D),
     /* 264501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264503 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264505 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264507 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264509 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264511 */     GIR_RootConstrainSelectedInstOperands,
     /* 264512 */     // GIR_Coverage, 8294,
     /* 264512 */     GIR_EraseRootFromParent_Done,
     /* 264513 */   // Label 5119: @264513
     /* 264513 */   GIM_Try, /*On fail goto*//*Label 5120*/ GIMT_Encode4(264560), // Rule ID 8295 //
     /* 264518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264538 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264545 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1490:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMAD_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_H),
     /* 264548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264554 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264556 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264558 */     GIR_RootConstrainSelectedInstOperands,
     /* 264559 */     // GIR_Coverage, 8295,
     /* 264559 */     GIR_EraseRootFromParent_Done,
     /* 264560 */   // Label 5120: @264560
     /* 264560 */   GIM_Try, /*On fail goto*//*Label 5121*/ GIMT_Encode4(264607), // Rule ID 8296 //
     /* 264565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264573 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264576 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264579 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264582 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264585 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264588 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264592 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1490:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMAD_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_S),
     /* 264595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264601 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264603 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264605 */     GIR_RootConstrainSelectedInstOperands,
     /* 264606 */     // GIR_Coverage, 8296,
     /* 264606 */     GIR_EraseRootFromParent_Done,
     /* 264607 */   // Label 5121: @264607
     /* 264607 */   GIM_Try, /*On fail goto*//*Label 5122*/ GIMT_Encode4(264654), // Rule ID 8297 //
     /* 264612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264615 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmad),
     /* 264620 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264632 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264635 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264639 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1490:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMAD_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMAD_ZPmZZ_D),
     /* 264642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264644 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264646 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264648 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264650 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264652 */     GIR_RootConstrainSelectedInstOperands,
     /* 264653 */     // GIR_Coverage, 8297,
     /* 264653 */     GIR_EraseRootFromParent_Done,
     /* 264654 */   // Label 5122: @264654
     /* 264654 */   GIM_Try, /*On fail goto*//*Label 5123*/ GIMT_Encode4(264701), // Rule ID 8298 //
     /* 264659 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264662 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264667 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264670 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264673 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264676 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264679 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264682 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264686 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1495:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMSB_ZPmZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_H),
     /* 264689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264695 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264697 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264699 */     GIR_RootConstrainSelectedInstOperands,
     /* 264700 */     // GIR_Coverage, 8298,
     /* 264700 */     GIR_EraseRootFromParent_Done,
     /* 264701 */   // Label 5123: @264701
     /* 264701 */   GIM_Try, /*On fail goto*//*Label 5124*/ GIMT_Encode4(264748), // Rule ID 8299 //
     /* 264706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264709 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264714 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264717 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264720 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264723 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264726 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264729 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264733 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1495:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMSB_ZPmZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_S),
     /* 264736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264740 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264742 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264744 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264746 */     GIR_RootConstrainSelectedInstOperands,
     /* 264747 */     // GIR_Coverage, 8299,
     /* 264747 */     GIR_EraseRootFromParent_Done,
     /* 264748 */   // Label 5124: @264748
     /* 264748 */   GIM_Try, /*On fail goto*//*Label 5125*/ GIMT_Encode4(264795), // Rule ID 8300 //
     /* 264753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmsb),
     /* 264761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 264764 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264767 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 264770 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 264773 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 264776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264780 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1495:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMSB_ZPmZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 264780 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSB_ZPmZZ_D),
     /* 264783 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 264785 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264787 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264789 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264791 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264793 */     GIR_RootConstrainSelectedInstOperands,
     /* 264794 */     // GIR_Coverage, 8300,
     /* 264794 */     GIR_EraseRootFromParent_Done,
     /* 264795 */   // Label 5125: @264795
     /* 264795 */   GIM_Try, /*On fail goto*//*Label 5126*/ GIMT_Encode4(264842), // Rule ID 8301 //
     /* 264800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264803 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264808 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 264811 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 264814 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 264817 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 264820 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 264823 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264827 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1477:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 264827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264832 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264834 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264836 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264838 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264840 */     GIR_RootConstrainSelectedInstOperands,
     /* 264841 */     // GIR_Coverage, 8301,
     /* 264841 */     GIR_EraseRootFromParent_Done,
     /* 264842 */   // Label 5126: @264842
     /* 264842 */   GIM_Try, /*On fail goto*//*Label 5127*/ GIMT_Encode4(264889), // Rule ID 8304 //
     /* 264847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 264858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 264864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 264867 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 264870 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264874 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 264874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264879 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264881 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264883 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264885 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264887 */     GIR_RootConstrainSelectedInstOperands,
     /* 264888 */     // GIR_Coverage, 8304,
     /* 264888 */     GIR_EraseRootFromParent_Done,
     /* 264889 */   // Label 5127: @264889
     /* 264889 */   GIM_Try, /*On fail goto*//*Label 5128*/ GIMT_Encode4(264936), // Rule ID 8307 //
     /* 264894 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264897 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264902 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 264905 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 264908 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 264911 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 264914 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 264917 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264921 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 264921 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_H_UNDEF),
     /* 264924 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264928 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264930 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264932 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264934 */     GIR_RootConstrainSelectedInstOperands,
     /* 264935 */     // GIR_Coverage, 8307,
     /* 264935 */     GIR_EraseRootFromParent_Done,
     /* 264936 */   // Label 5128: @264936
     /* 264936 */   GIM_Try, /*On fail goto*//*Label 5129*/ GIMT_Encode4(264983), // Rule ID 8310 //
     /* 264941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264944 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264949 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 264952 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 264955 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 264958 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 264961 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 264964 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 264968 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1477:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 264968 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 264971 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 264973 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 264975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 264977 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 264979 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 264981 */     GIR_RootConstrainSelectedInstOperands,
     /* 264982 */     // GIR_Coverage, 8310,
     /* 264982 */     GIR_EraseRootFromParent_Done,
     /* 264983 */   // Label 5129: @264983
     /* 264983 */   GIM_Try, /*On fail goto*//*Label 5130*/ GIMT_Encode4(265030), // Rule ID 8313 //
     /* 264988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 264991 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 264996 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 264999 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265005 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265008 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265011 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265015 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_S_UNDEF),
     /* 265018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265022 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265024 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265026 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265028 */     GIR_RootConstrainSelectedInstOperands,
     /* 265029 */     // GIR_Coverage, 8313,
     /* 265029 */     GIR_EraseRootFromParent_Done,
     /* 265030 */   // Label 5130: @265030
     /* 265030 */   GIM_Try, /*On fail goto*//*Label 5131*/ GIMT_Encode4(265077), // Rule ID 8316 //
     /* 265035 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265038 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fmls_u),
     /* 265043 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265058 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265062 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1477:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLS_ZPZZZ_D_UNDEF),
     /* 265065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265071 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265073 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265075 */     GIR_RootConstrainSelectedInstOperands,
     /* 265076 */     // GIR_Coverage, 8316,
     /* 265076 */     GIR_EraseRootFromParent_Done,
     /* 265077 */   // Label 5131: @265077
     /* 265077 */   GIM_Try, /*On fail goto*//*Label 5132*/ GIMT_Encode4(265124), // Rule ID 8319 //
     /* 265082 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265085 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265090 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265093 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265096 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265099 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265102 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265105 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265109 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1492:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265114 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265118 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265120 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265122 */     GIR_RootConstrainSelectedInstOperands,
     /* 265123 */     // GIR_Coverage, 8319,
     /* 265123 */     GIR_EraseRootFromParent_Done,
     /* 265124 */   // Label 5132: @265124
     /* 265124 */   GIM_Try, /*On fail goto*//*Label 5133*/ GIMT_Encode4(265171), // Rule ID 8322 //
     /* 265129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265132 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265137 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265146 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265149 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265152 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265156 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265156 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265159 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265161 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265165 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265167 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265169 */     GIR_RootConstrainSelectedInstOperands,
     /* 265170 */     // GIR_Coverage, 8322,
     /* 265170 */     GIR_EraseRootFromParent_Done,
     /* 265171 */   // Label 5133: @265171
     /* 265171 */   GIM_Try, /*On fail goto*//*Label 5134*/ GIMT_Encode4(265218), // Rule ID 8325 //
     /* 265176 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265179 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265184 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265187 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265190 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265193 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265196 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265199 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265203 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLA_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_H_UNDEF),
     /* 265206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265214 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265216 */     GIR_RootConstrainSelectedInstOperands,
     /* 265217 */     // GIR_Coverage, 8325,
     /* 265217 */     GIR_EraseRootFromParent_Done,
     /* 265218 */   // Label 5134: @265218
     /* 265218 */   GIM_Try, /*On fail goto*//*Label 5135*/ GIMT_Encode4(265265), // Rule ID 8328 //
     /* 265223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265226 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265231 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265234 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265237 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265240 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265243 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265246 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265250 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1492:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265259 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265261 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265263 */     GIR_RootConstrainSelectedInstOperands,
     /* 265264 */     // GIR_Coverage, 8328,
     /* 265264 */     GIR_EraseRootFromParent_Done,
     /* 265265 */   // Label 5135: @265265
     /* 265265 */   GIM_Try, /*On fail goto*//*Label 5136*/ GIMT_Encode4(265312), // Rule ID 8331 //
     /* 265270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265273 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265278 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265281 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265284 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265287 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265290 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265293 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265297 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLA_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265297 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_S_UNDEF),
     /* 265300 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265302 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265306 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265308 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265310 */     GIR_RootConstrainSelectedInstOperands,
     /* 265311 */     // GIR_Coverage, 8331,
     /* 265311 */     GIR_EraseRootFromParent_Done,
     /* 265312 */   // Label 5136: @265312
     /* 265312 */   GIM_Try, /*On fail goto*//*Label 5137*/ GIMT_Encode4(265359), // Rule ID 8334 //
     /* 265317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265320 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmla_u),
     /* 265325 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265328 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265331 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265334 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265337 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265340 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265344 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1492:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLA_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLA_ZPZZZ_D_UNDEF),
     /* 265347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265349 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265353 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265355 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265357 */     GIR_RootConstrainSelectedInstOperands,
     /* 265358 */     // GIR_Coverage, 8334,
     /* 265358 */     GIR_EraseRootFromParent_Done,
     /* 265359 */   // Label 5137: @265359
     /* 265359 */   GIM_Try, /*On fail goto*//*Label 5138*/ GIMT_Encode4(265406), // Rule ID 8337 //
     /* 265364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265367 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265372 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 265375 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 265378 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 265381 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 265384 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 265387 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265391 */     // (intrinsic_wo_chain:{ *:[nxv8f16] } 1494:{ *:[iPTR] }, nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3, nxv8f16:{ *:[nxv8f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3, ?:{ *:[nxv8f16] }:$Op4)
     /* 265391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265396 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265398 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265400 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265402 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265404 */     GIR_RootConstrainSelectedInstOperands,
     /* 265405 */     // GIR_Coverage, 8337,
     /* 265405 */     GIR_EraseRootFromParent_Done,
     /* 265406 */   // Label 5138: @265406
     /* 265406 */   GIM_Try, /*On fail goto*//*Label 5139*/ GIMT_Encode4(265453), // Rule ID 8339 //
     /* 265411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265419 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s16,
     /* 265422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 265428 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s16,
     /* 265431 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s16,
     /* 265434 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265438 */     // (intrinsic_wo_chain:{ *:[nxv4f16] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3, nxv4f16:{ *:[nxv4f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3, ?:{ *:[nxv4f16] }:$Op4)
     /* 265438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265447 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265449 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265451 */     GIR_RootConstrainSelectedInstOperands,
     /* 265452 */     // GIR_Coverage, 8339,
     /* 265452 */     GIR_EraseRootFromParent_Done,
     /* 265453 */   // Label 5139: @265453
     /* 265453 */   GIM_Try, /*On fail goto*//*Label 5140*/ GIMT_Encode4(265500), // Rule ID 8341 //
     /* 265458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s16,
     /* 265469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 265475 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s16,
     /* 265478 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s16,
     /* 265481 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265485 */     // (intrinsic_wo_chain:{ *:[nxv2f16] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3, nxv2f16:{ *:[nxv2f16] }:$Op4)  =>  (FNMLS_ZPZZZ_H_UNDEF:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3, ?:{ *:[nxv2f16] }:$Op4)
     /* 265485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_H_UNDEF),
     /* 265488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265492 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265494 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265496 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265498 */     GIR_RootConstrainSelectedInstOperands,
     /* 265499 */     // GIR_Coverage, 8341,
     /* 265499 */     GIR_EraseRootFromParent_Done,
     /* 265500 */   // Label 5140: @265500
     /* 265500 */   GIM_Try, /*On fail goto*//*Label 5141*/ GIMT_Encode4(265547), // Rule ID 8343 //
     /* 265505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265508 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265513 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 265516 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 265519 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 265522 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 265525 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 265528 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265532 */     // (intrinsic_wo_chain:{ *:[nxv4f32] } 1494:{ *:[iPTR] }, nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3, nxv4f32:{ *:[nxv4f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3, ?:{ *:[nxv4f32] }:$Op4)
     /* 265532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265537 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265539 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265541 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265543 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265545 */     GIR_RootConstrainSelectedInstOperands,
     /* 265546 */     // GIR_Coverage, 8343,
     /* 265546 */     GIR_EraseRootFromParent_Done,
     /* 265547 */   // Label 5141: @265547
     /* 265547 */   GIM_Try, /*On fail goto*//*Label 5142*/ GIMT_Encode4(265594), // Rule ID 8345 //
     /* 265552 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265555 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265560 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s32,
     /* 265563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 265569 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s32,
     /* 265572 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s32,
     /* 265575 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265579 */     // (intrinsic_wo_chain:{ *:[nxv2f32] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3, nxv2f32:{ *:[nxv2f32] }:$Op4)  =>  (FNMLS_ZPZZZ_S_UNDEF:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3, ?:{ *:[nxv2f32] }:$Op4)
     /* 265579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_S_UNDEF),
     /* 265582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265584 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265586 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265588 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265590 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265592 */     GIR_RootConstrainSelectedInstOperands,
     /* 265593 */     // GIR_Coverage, 8345,
     /* 265593 */     GIR_EraseRootFromParent_Done,
     /* 265594 */   // Label 5142: @265594
     /* 265594 */   GIM_Try, /*On fail goto*//*Label 5143*/ GIMT_Encode4(265641), // Rule ID 8347 //
     /* 265599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 265602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fnmls_u),
     /* 265607 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 265610 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 265613 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 265616 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 265619 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 265622 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 265626 */     // (intrinsic_wo_chain:{ *:[nxv2f64] } 1494:{ *:[iPTR] }, nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3, nxv2f64:{ *:[nxv2f64] }:$Op4)  =>  (FNMLS_ZPZZZ_D_UNDEF:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3, ?:{ *:[nxv2f64] }:$Op4)
     /* 265626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMLS_ZPZZZ_D_UNDEF),
     /* 265629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 265631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 265633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 265635 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 265637 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 265639 */     GIR_RootConstrainSelectedInstOperands,
     /* 265640 */     // GIR_Coverage, 8347,
     /* 265640 */     GIR_EraseRootFromParent_Done,
     /* 265641 */   // Label 5143: @265641
     /* 265641 */   GIM_Reject,
     /* 265642 */ // Label 5002: @265642
     /* 265642 */ GIM_Reject,
     /* 265643 */ // Label 38: @265643
     /* 265643 */ GIM_Try, /*On fail goto*//*Label 5144*/ GIMT_Encode4(265721),
     /* 265648 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/1,
     /* 265651 */   GIM_Try, /*On fail goto*//*Label 5145*/ GIMT_Encode4(265673), // Rule ID 78 //
     /* 265656 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265659 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcommit),
     /* 265664 */     // (intrinsic_void 2173:{ *:[iPTR] })  =>  (TCOMMIT)
     /* 265664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCOMMIT),
     /* 265667 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265671 */     GIR_RootConstrainSelectedInstOperands,
     /* 265672 */     // GIR_Coverage, 78,
     /* 265672 */     GIR_EraseRootFromParent_Done,
     /* 265673 */   // Label 5145: @265673
     /* 265673 */   GIM_Try, /*On fail goto*//*Label 5146*/ GIMT_Encode4(265698), // Rule ID 2386 //
     /* 265678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 265681 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_setffr),
     /* 265686 */     // (intrinsic_void 1723:{ *:[iPTR] })  =>  (SETFFR:{ *:[i64] })
     /* 265686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SETFFR),
     /* 265689 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 265692 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265696 */     GIR_RootConstrainSelectedInstOperands,
     /* 265697 */     // GIR_Coverage, 2386,
     /* 265697 */     GIR_EraseRootFromParent_Done,
     /* 265698 */   // Label 5146: @265698
     /* 265698 */   GIM_Try, /*On fail goto*//*Label 5147*/ GIMT_Encode4(265720), // Rule ID 7168 //
     /* 265703 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_clrex),
     /* 265708 */     // (intrinsic_void 507:{ *:[iPTR] })  =>  (CLREX 15:{ *:[i64] })
     /* 265708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLREX),
     /* 265711 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 265714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265718 */     GIR_RootConstrainSelectedInstOperands,
     /* 265719 */     // GIR_Coverage, 7168,
     /* 265719 */     GIR_EraseRootFromParent_Done,
     /* 265720 */   // Label 5147: @265720
     /* 265720 */   GIM_Reject,
     /* 265721 */ // Label 5144: @265721
     /* 265721 */ GIM_Try, /*On fail goto*//*Label 5148*/ GIMT_Encode4(266321),
     /* 265726 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/2,
     /* 265729 */   GIM_Try, /*On fail goto*//*Label 5149*/ GIMT_Encode4(265761), // Rule ID 79 //
     /* 265734 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 265737 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_tcancel),
     /* 265742 */     // MIs[0] imm
     /* 265742 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265745 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm64_0_65535),
     /* 265750 */     // (intrinsic_void 2172:{ *:[iPTR] }, (timm:{ *:[i64] })<<P:Predicate_timm64_0_65535>>:$imm)  =>  (TCANCEL (timm:{ *:[i64] }):$imm)
     /* 265750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TCANCEL),
     /* 265753 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265759 */     GIR_RootConstrainSelectedInstOperands,
     /* 265760 */     // GIR_Coverage, 79,
     /* 265760 */     GIR_EraseRootFromParent_Done,
     /* 265761 */   // Label 5149: @265761
     /* 265761 */   GIM_Try, /*On fail goto*//*Label 5150*/ GIMT_Encode4(265786), // Rule ID 227 //
     /* 265766 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_break),
     /* 265771 */     // MIs[0] imm
     /* 265771 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265774 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265779 */     // (intrinsic_void 505:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (BRK (timm:{ *:[i32] }):$imm)
     /* 265779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 265782 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265784 */     GIR_RootConstrainSelectedInstOperands,
     /* 265785 */     // GIR_Coverage, 227,
     /* 265785 */     GIR_EraseRootFromParent_Done,
     /* 265786 */   // Label 5150: @265786
     /* 265786 */   GIM_Try, /*On fail goto*//*Label 5151*/ GIMT_Encode4(265811), // Rule ID 228 //
     /* 265791 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hlt),
     /* 265796 */     // MIs[0] imm
     /* 265796 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265799 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_65535),
     /* 265804 */     // (intrinsic_void 564:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_65535>>:$imm)  =>  (HLT (timm:{ *:[i32] }):$imm)
     /* 265804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HLT),
     /* 265807 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265809 */     GIR_RootConstrainSelectedInstOperands,
     /* 265810 */     // GIR_Coverage, 228,
     /* 265810 */     GIR_EraseRootFromParent_Done,
     /* 265811 */   // Label 5151: @265811
     /* 265811 */   GIM_Try, /*On fail goto*//*Label 5152*/ GIMT_Encode4(265843), // Rule ID 3619 //
     /* 265816 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 265819 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_zero),
     /* 265824 */     // MIs[0] imm
     /* 265824 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 265827 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_255),
     /* 265832 */     // (intrinsic_void 1229:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)  =>  (ZERO_M_PSEUDO (timm:{ *:[i32] })<<P:Predicate_timm32_0_255>>:$imm)
     /* 265832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZERO_M_PSEUDO),
     /* 265835 */     GIR_RootToRootCopy, /*OpIdx*/1, // imm
     /* 265837 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 265841 */     GIR_RootConstrainSelectedInstOperands,
     /* 265842 */     // GIR_Coverage, 3619,
     /* 265842 */     GIR_EraseRootFromParent_Done,
     /* 265843 */   // Label 5152: @265843
     /* 265843 */   GIM_Try, /*On fail goto*//*Label 5153*/ GIMT_Encode4(265883), // Rule ID 16 //
     /* 265848 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_hint),
     /* 265853 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265864 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_127),
     /* 265868 */     // MIs[1] Operand 1
     /* 265868 */     // No operand predicates
     /* 265868 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265870 */     // (intrinsic_void 563:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm0_127>>:$imm)  =>  (HINT (imm:{ *:[i32] }):$imm)
     /* 265870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HINT),
     /* 265873 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 265876 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 265881 */     GIR_RootConstrainSelectedInstOperands,
     /* 265882 */     // GIR_Coverage, 16,
     /* 265882 */     GIR_EraseRootFromParent_Done,
     /* 265883 */   // Label 5153: @265883
     /* 265883 */   GIM_Try, /*On fail goto*//*Label 5154*/ GIMT_Encode4(265923), // Rule ID 17 //
     /* 265888 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dmb),
     /* 265893 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265904 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 265908 */     // MIs[1] Operand 1
     /* 265908 */     // No operand predicates
     /* 265908 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265910 */     // (intrinsic_void 551:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DMB (imm:{ *:[i32] }):$CRm)
     /* 265910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DMB),
     /* 265913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 265916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 265921 */     GIR_RootConstrainSelectedInstOperands,
     /* 265922 */     // GIR_Coverage, 17,
     /* 265922 */     GIR_EraseRootFromParent_Done,
     /* 265923 */   // Label 5154: @265923
     /* 265923 */   GIM_Try, /*On fail goto*//*Label 5155*/ GIMT_Encode4(265963), // Rule ID 18 //
     /* 265928 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_dsb),
     /* 265933 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265944 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 265948 */     // MIs[1] Operand 1
     /* 265948 */     // No operand predicates
     /* 265948 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265950 */     // (intrinsic_void 552:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (DSB (imm:{ *:[i32] }):$CRm)
     /* 265950 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DSB),
     /* 265953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 265956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 265961 */     GIR_RootConstrainSelectedInstOperands,
     /* 265962 */     // GIR_Coverage, 18,
     /* 265962 */     GIR_EraseRootFromParent_Done,
     /* 265963 */   // Label 5155: @265963
     /* 265963 */   GIM_Try, /*On fail goto*//*Label 5156*/ GIMT_Encode4(266003), // Rule ID 19 //
     /* 265968 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_isb),
     /* 265973 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 265976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 265980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 265984 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 265988 */     // MIs[1] Operand 1
     /* 265988 */     // No operand predicates
     /* 265988 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 265990 */     // (intrinsic_void 567:{ *:[iPTR] }, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$CRm)  =>  (ISB (imm:{ *:[i32] }):$CRm)
     /* 265990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ISB),
     /* 265993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // CRm
     /* 265996 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 266001 */     GIR_RootConstrainSelectedInstOperands,
     /* 266002 */     // GIR_Coverage, 19,
     /* 266002 */     GIR_EraseRootFromParent_Done,
     /* 266003 */   // Label 5156: @266003
     /* 266003 */   GIM_Try, /*On fail goto*//*Label 5157*/ GIMT_Encode4(266027), // Rule ID 72 //
     /* 266008 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpcr),
     /* 266013 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266020 */     // (intrinsic_w_chain:{ *:[i64] } 560:{ *:[iPTR] })  =>  (MRS_FPCR:{ *:[i64] })
     /* 266020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPCR),
     /* 266023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266025 */     GIR_RootConstrainSelectedInstOperands,
     /* 266026 */     // GIR_Coverage, 72,
     /* 266026 */     GIR_EraseRootFromParent_Done,
     /* 266027 */   // Label 5157: @266027
     /* 266027 */   GIM_Try, /*On fail goto*//*Label 5158*/ GIMT_Encode4(266051), // Rule ID 74 //
     /* 266032 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_get_fpsr),
     /* 266037 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266044 */     // (intrinsic_w_chain:{ *:[i64] } 561:{ *:[iPTR] })  =>  (MRS_FPSR:{ *:[i64] })
     /* 266044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS_FPSR),
     /* 266047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266049 */     GIR_RootConstrainSelectedInstOperands,
     /* 266050 */     // GIR_Coverage, 74,
     /* 266050 */     GIR_EraseRootFromParent_Done,
     /* 266051 */   // Label 5158: @266051
     /* 266051 */   GIM_Try, /*On fail goto*//*Label 5159*/ GIMT_Encode4(266082), // Rule ID 77 //
     /* 266056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266059 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_tstart),
     /* 266064 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266067 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266071 */     // (intrinsic_w_chain:{ *:[i64] } 2174:{ *:[iPTR] })  =>  (TSTART:{ *:[i64] })
     /* 266071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TSTART),
     /* 266074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266076 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266080 */     GIR_RootConstrainSelectedInstOperands,
     /* 266081 */     // GIR_Coverage, 77,
     /* 266081 */     GIR_EraseRootFromParent_Done,
     /* 266082 */   // Label 5159: @266082
     /* 266082 */   GIM_Try, /*On fail goto*//*Label 5160*/ GIMT_Encode4(266109), // Rule ID 80 //
     /* 266087 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasTME),
     /* 266090 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ttest),
     /* 266095 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266098 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266102 */     // (intrinsic_w_chain:{ *:[i64] } 2175:{ *:[iPTR] })  =>  (TTEST:{ *:[i64] })
     /* 266102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::TTEST),
     /* 266105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266107 */     GIR_RootConstrainSelectedInstOperands,
     /* 266108 */     // GIR_Coverage, 80,
     /* 266108 */     GIR_EraseRootFromParent_Done,
     /* 266109 */   // Label 5160: @266109
     /* 266109 */   GIM_Try, /*On fail goto*//*Label 5161*/ GIMT_Encode4(266140), // Rule ID 2385 //
     /* 266114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr),
     /* 266122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 266125 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266129 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1673:{ *:[iPTR] })  =>  (RDFFR_P:{ *:[nxv16i1] })
     /* 266129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_P),
     /* 266132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 266134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266138 */     GIR_RootConstrainSelectedInstOperands,
     /* 266139 */     // GIR_Coverage, 2385,
     /* 266139 */     GIR_EraseRootFromParent_Done,
     /* 266140 */   // Label 5161: @266140
     /* 266140 */   GIM_Try, /*On fail goto*//*Label 5162*/ GIMT_Encode4(266180), // Rule ID 12853 //
     /* 266145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sme_get_tpidr2),
     /* 266153 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266156 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266160 */     // (intrinsic_w_chain:{ *:[i64] } 898:{ *:[iPTR] })  =>  (MRS:{ *:[i64] }:{ *:[i32] } 56965:{ *:[i32] })
     /* 266160 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MRS),
     /* 266163 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266165 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266175 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/0,
     /* 266178 */     GIR_RootConstrainSelectedInstOperands,
     /* 266179 */     // GIR_Coverage, 12853,
     /* 266179 */     GIR_EraseRootFromParent_Done,
     /* 266180 */   // Label 5162: @266180
     /* 266180 */   GIM_Try, /*On fail goto*//*Label 5163*/ GIMT_Encode4(266214), // Rule ID 2387 //
     /* 266185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266188 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_wrffr),
     /* 266193 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 266196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266200 */     // (intrinsic_void 2153:{ *:[iPTR] }, PPR8:{ *:[nxv16i1] }:$Pn)  =>  (WRFFR:{ *:[i64] } PPR8:{ *:[nxv16i1] }:$Pn)
     /* 266200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::WRFFR),
     /* 266203 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pn
     /* 266205 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FFR*/0,
     /* 266208 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266212 */     GIR_RootConstrainSelectedInstOperands,
     /* 266213 */     // GIR_Coverage, 2387,
     /* 266213 */     GIR_EraseRootFromParent_Done,
     /* 266214 */   // Label 5163: @266214
     /* 266214 */   GIM_Try, /*On fail goto*//*Label 5164*/ GIMT_Encode4(266237), // Rule ID 73 //
     /* 266219 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpcr),
     /* 266224 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266227 */     // (intrinsic_void 787:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPCR i64:{ *:[i64] }:$val)
     /* 266227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPCR),
     /* 266230 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266232 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPCR*/0,
     /* 266235 */     GIR_RootConstrainSelectedInstOperands,
     /* 266236 */     // GIR_Coverage, 73,
     /* 266236 */     GIR_EraseRootFromParent_Done,
     /* 266237 */   // Label 5164: @266237
     /* 266237 */   GIM_Try, /*On fail goto*//*Label 5165*/ GIMT_Encode4(266260), // Rule ID 75 //
     /* 266242 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpsr),
     /* 266247 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266250 */     // (intrinsic_void 789:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPSR i64:{ *:[i64] }:$val)
     /* 266250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPSR),
     /* 266253 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266255 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPSR*/0,
     /* 266258 */     GIR_RootConstrainSelectedInstOperands,
     /* 266259 */     // GIR_Coverage, 75,
     /* 266259 */     GIR_EraseRootFromParent_Done,
     /* 266260 */   // Label 5165: @266260
     /* 266260 */   GIM_Try, /*On fail goto*//*Label 5166*/ GIMT_Encode4(266287), // Rule ID 76 //
     /* 266265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_set_fpmr),
     /* 266270 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266273 */     // (intrinsic_void 788:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR_FPMR i64:{ *:[i64] }:$val)
     /* 266273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR_FPMR),
     /* 266276 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266278 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::FPMR*/0,
     /* 266281 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266285 */     GIR_RootConstrainSelectedInstOperands,
     /* 266286 */     // GIR_Coverage, 76,
     /* 266286 */     GIR_EraseRootFromParent_Done,
     /* 266287 */   // Label 5166: @266287
     /* 266287 */   GIM_Try, /*On fail goto*//*Label 5167*/ GIMT_Encode4(266320), // Rule ID 12852 //
     /* 266292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEandIsNonStreamingSafe),
     /* 266295 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_set_tpidr2),
     /* 266300 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 266303 */     // (intrinsic_void 973:{ *:[iPTR] }, i64:{ *:[i64] }:$val)  =>  (MSR 56965:{ *:[i32] }, GPR64:{ *:[i64] }:$val)
     /* 266303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MSR),
     /* 266306 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(56965),
     /* 266316 */     GIR_RootToRootCopy, /*OpIdx*/1, // val
     /* 266318 */     GIR_RootConstrainSelectedInstOperands,
     /* 266319 */     // GIR_Coverage, 12852,
     /* 266319 */     GIR_EraseRootFromParent_Done,
     /* 266320 */   // Label 5167: @266320
     /* 266320 */   GIM_Reject,
     /* 266321 */ // Label 5148: @266321
     /* 266321 */ GIM_Try, /*On fail goto*//*Label 5168*/ GIMT_Encode4(267292),
     /* 266326 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/3,
     /* 266329 */   GIM_Try, /*On fail goto*//*Label 5169*/ GIMT_Encode4(266405), // Rule ID 7134 //
     /* 266334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266339 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266342 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266346 */     // MIs[0] addr
     /* 266346 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266350 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266354 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_1),
     /* 266358 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266358 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266361 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRB),
     /* 266365 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266370 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266374 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266378 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266380 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266383 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266385 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266388 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266391 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266399 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266404 */     // GIR_Coverage, 7134,
     /* 266404 */     GIR_EraseRootFromParent_Done,
     /* 266405 */   // Label 5169: @266405
     /* 266405 */   GIM_Try, /*On fail goto*//*Label 5170*/ GIMT_Encode4(266481), // Rule ID 7135 //
     /* 266410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266415 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266418 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266422 */     // MIs[0] addr
     /* 266422 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266430 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_2),
     /* 266434 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRH),
     /* 266441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266446 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266450 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266454 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266461 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266464 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266467 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266470 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266475 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266480 */     // GIR_Coverage, 7135,
     /* 266480 */     GIR_EraseRootFromParent_Done,
     /* 266481 */   // Label 5170: @266481
     /* 266481 */   GIM_Try, /*On fail goto*//*Label 5171*/ GIMT_Encode4(266557), // Rule ID 7136 //
     /* 266486 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266491 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266494 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266498 */     // MIs[0] addr
     /* 266498 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266502 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266506 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_4),
     /* 266510 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266510 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266513 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDXRW),
     /* 266517 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266522 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266526 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266537 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266543 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266546 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266551 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266556 */     // GIR_Coverage, 7136,
     /* 266556 */     GIR_EraseRootFromParent_Done,
     /* 266557 */   // Label 5171: @266557
     /* 266557 */   GIM_Try, /*On fail goto*//*Label 5172*/ GIMT_Encode4(266599), // Rule ID 7137 //
     /* 266562 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldxr),
     /* 266567 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266570 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266574 */     // MIs[0] addr
     /* 266574 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266582 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldxr_8),
     /* 266586 */     // (intrinsic_w_chain:{ *:[i64] } 573:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldxr_8>>  =>  (LDXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDXRX),
     /* 266589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266591 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266593 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266597 */     GIR_RootConstrainSelectedInstOperands,
     /* 266598 */     // GIR_Coverage, 7137,
     /* 266598 */     GIR_EraseRootFromParent_Done,
     /* 266599 */   // Label 5172: @266599
     /* 266599 */   GIM_Try, /*On fail goto*//*Label 5173*/ GIMT_Encode4(266675), // Rule ID 7141 //
     /* 266604 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266609 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266612 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266616 */     // MIs[0] addr
     /* 266616 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266620 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266624 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_1),
     /* 266628 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_1>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRB:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266628 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266631 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRB),
     /* 266635 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266640 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266644 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266648 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266650 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266653 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266655 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266664 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266669 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266674 */     // GIR_Coverage, 7141,
     /* 266674 */     GIR_EraseRootFromParent_Done,
     /* 266675 */   // Label 5173: @266675
     /* 266675 */   GIM_Try, /*On fail goto*//*Label 5174*/ GIMT_Encode4(266751), // Rule ID 7142 //
     /* 266680 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266685 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266692 */     // MIs[0] addr
     /* 266692 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266700 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_2),
     /* 266704 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_2>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRH:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRH),
     /* 266711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266720 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266731 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266734 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266737 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266740 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266750 */     // GIR_Coverage, 7142,
     /* 266750 */     GIR_EraseRootFromParent_Done,
     /* 266751 */   // Label 5174: @266751
     /* 266751 */   GIM_Try, /*On fail goto*//*Label 5175*/ GIMT_Encode4(266827), // Rule ID 7143 //
     /* 266756 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266761 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266764 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266768 */     // MIs[0] addr
     /* 266768 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266772 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266776 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_4),
     /* 266780 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_4>>  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (LDAXRW:{ *:[i32] } GPR64sp:{ *:[i64] }:$addr), sub_32:{ *:[i32] })
     /* 266780 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 266783 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDAXRW),
     /* 266787 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 266792 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // addr
     /* 266796 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266800 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 266802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 266805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 266807 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 266810 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 266813 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 266816 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 266821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 266826 */     // GIR_Coverage, 7143,
     /* 266826 */     GIR_EraseRootFromParent_Done,
     /* 266827 */   // Label 5175: @266827
     /* 266827 */   GIM_Try, /*On fail goto*//*Label 5176*/ GIMT_Encode4(266869), // Rule ID 7144 //
     /* 266832 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_ldaxr),
     /* 266837 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266840 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266844 */     // MIs[0] addr
     /* 266844 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 266848 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 266852 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_ldaxr_8),
     /* 266856 */     // (intrinsic_w_chain:{ *:[i64] } 570:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_ldaxr_8>>  =>  (LDAXRX:{ *:[i64] } GPR64sp:{ *:[i64] }:$addr)
     /* 266856 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAXRX),
     /* 266859 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266861 */     GIR_RootToRootCopy, /*OpIdx*/2, // addr
     /* 266863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266867 */     GIR_RootConstrainSelectedInstOperands,
     /* 266868 */     // GIR_Coverage, 7144,
     /* 266868 */     GIR_EraseRootFromParent_Done,
     /* 266869 */   // Label 5176: @266869
     /* 266869 */   GIM_Try, /*On fail goto*//*Label 5177*/ GIMT_Encode4(266909), // Rule ID 20 //
     /* 266874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasGCS),
     /* 266877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_gcspopm),
     /* 266882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 266885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 266888 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266892 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 266896 */     // (intrinsic_w_chain:{ *:[i64] } 558:{ *:[iPTR] }, GPR64:{ *:[i64] }:$src)  =>  (GCSPOPM:{ *:[i64] } GPR64:{ *:[i64] }:$src)
     /* 266896 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::GCSPOPM),
     /* 266899 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rt]
     /* 266901 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 266903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266907 */     GIR_RootConstrainSelectedInstOperands,
     /* 266908 */     // GIR_Coverage, 20,
     /* 266908 */     GIR_EraseRootFromParent_Done,
     /* 266909 */   // Label 5177: @266909
     /* 266909 */   GIM_Try, /*On fail goto*//*Label 5178*/ GIMT_Encode4(266949), // Rule ID 2384 //
     /* 266914 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 266917 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_rdffr_z),
     /* 266922 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv16s1,
     /* 266925 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 266928 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 266936 */     // (intrinsic_w_chain:{ *:[nxv16i1] } 1674:{ *:[iPTR] }, PPRAny:{ *:[nxv16i1] }:$Pg)  =>  (RDFFR_PPz:{ *:[nxv16i1] } PPRAny:{ *:[nxv16i1] }:$Pg)
     /* 266936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RDFFR_PPz),
     /* 266939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 266941 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 266943 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266947 */     GIR_RootConstrainSelectedInstOperands,
     /* 266948 */     // GIR_Coverage, 2384,
     /* 266948 */     GIR_EraseRootFromParent_Done,
     /* 266949 */   // Label 5178: @266949
     /* 266949 */   GIM_Try, /*On fail goto*//*Label 5179*/ GIMT_Encode4(266989), // Rule ID 2491 //
     /* 266954 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 266957 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 266962 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 266965 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 266968 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 266972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 266976 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F1CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 266976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL),
     /* 266979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 266981 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 266983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 266987 */     GIR_RootConstrainSelectedInstOperands,
     /* 266988 */     // GIR_Coverage, 2491,
     /* 266988 */     GIR_EraseRootFromParent_Done,
     /* 266989 */   // Label 5179: @266989
     /* 266989 */   GIM_Try, /*On fail goto*//*Label 5180*/ GIMT_Encode4(267029), // Rule ID 2492 //
     /* 266994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 266997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl1),
     /* 267002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267016 */     // (intrinsic_w_chain:{ *:[v8f16] } 618:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F1CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267016 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTL2),
     /* 267019 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267021 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267023 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267027 */     GIR_RootConstrainSelectedInstOperands,
     /* 267028 */     // GIR_Coverage, 2492,
     /* 267028 */     GIR_EraseRootFromParent_Done,
     /* 267029 */   // Label 5180: @267029
     /* 267029 */   GIM_Try, /*On fail goto*//*Label 5181*/ GIMT_Encode4(267069), // Rule ID 7021 //
     /* 267034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267037 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267042 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 267048 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267052 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 267056 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn)  =>  (F2CVTL:{ *:[v8f16] } V64:{ *:[v8i8] }:$Rn)
     /* 267056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL),
     /* 267059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267061 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267063 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267067 */     GIR_RootConstrainSelectedInstOperands,
     /* 267068 */     // GIR_Coverage, 7021,
     /* 267068 */     GIR_EraseRootFromParent_Done,
     /* 267069 */   // Label 5181: @267069
     /* 267069 */   GIM_Try, /*On fail goto*//*Label 5182*/ GIMT_Encode4(267109), // Rule ID 7022 //
     /* 267074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 267077 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_cvtl2),
     /* 267082 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 267085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 267088 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267092 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 267096 */     // (intrinsic_w_chain:{ *:[v8f16] } 619:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn)  =>  (F2CVTL2:{ *:[v8f16] } V128:{ *:[v16i8] }:$Rn)
     /* 267096 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTL2),
     /* 267099 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 267103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267107 */     GIR_RootConstrainSelectedInstOperands,
     /* 267108 */     // GIR_Coverage, 7022,
     /* 267108 */     GIR_EraseRootFromParent_Done,
     /* 267109 */   // Label 5182: @267109
     /* 267109 */   GIM_Try, /*On fail goto*//*Label 5183*/ GIMT_Encode4(267145), // Rule ID 3572 //
     /* 267114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt1),
     /* 267122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267128 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267132 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1498:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVT_ZZ_BtoH),
     /* 267135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267139 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267143 */     GIR_RootConstrainSelectedInstOperands,
     /* 267144 */     // GIR_Coverage, 3572,
     /* 267144 */     GIR_EraseRootFromParent_Done,
     /* 267145 */   // Label 5183: @267145
     /* 267145 */   GIM_Try, /*On fail goto*//*Label 5184*/ GIMT_Encode4(267183), // Rule ID 4000 //
     /* 267150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 267153 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg_sp),
     /* 267158 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 267161 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267168 */     // (intrinsic_w_chain:{ *:[i64] } 566:{ *:[iPTR] }, i64:{ *:[i64] }:$Rm)  =>  (IRGstack:{ *:[i64] } SP:{ *:[i64] }, i64:{ *:[i64] }:$Rm)
     /* 267168 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRGstack),
     /* 267171 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 267173 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::SP), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 267179 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 267181 */     GIR_RootConstrainSelectedInstOperands,
     /* 267182 */     // GIR_Coverage, 4000,
     /* 267182 */     GIR_EraseRootFromParent_Done,
     /* 267183 */   // Label 5184: @267183
     /* 267183 */   GIM_Try, /*On fail goto*//*Label 5185*/ GIMT_Encode4(267219), // Rule ID 12578 //
     /* 267188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267191 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvt2),
     /* 267196 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267199 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267206 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1500:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267206 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVT_ZZ_BtoH),
     /* 267209 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267211 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267213 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267217 */     GIR_RootConstrainSelectedInstOperands,
     /* 267218 */     // GIR_Coverage, 12578,
     /* 267218 */     GIR_EraseRootFromParent_Done,
     /* 267219 */   // Label 5185: @267219
     /* 267219 */   GIM_Try, /*On fail goto*//*Label 5186*/ GIMT_Encode4(267255), // Rule ID 12579 //
     /* 267224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267227 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt1),
     /* 267232 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267235 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267242 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1504:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F1CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267242 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F1CVTLT_ZZ_BtoH),
     /* 267245 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267247 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267249 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267253 */     GIR_RootConstrainSelectedInstOperands,
     /* 267254 */     // GIR_Coverage, 12579,
     /* 267254 */     GIR_EraseRootFromParent_Done,
     /* 267255 */   // Label 5186: @267255
     /* 267255 */   GIM_Try, /*On fail goto*//*Label 5187*/ GIMT_Encode4(267291), // Rule ID 12580 //
     /* 267260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8_HasSVE2_or_SME2),
     /* 267263 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_cvtlt2),
     /* 267268 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 267271 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 267274 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 267278 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1505:{ *:[iPTR] }, nxv16i8:{ *:[nxv16i8] }:$Op1)  =>  (F2CVTLT_ZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv16i8] }:$Op1)
     /* 267278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::F2CVTLT_ZZ_BtoH),
     /* 267281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 267283 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 267285 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 267289 */     GIR_RootConstrainSelectedInstOperands,
     /* 267290 */     // GIR_Coverage, 12580,
     /* 267290 */     GIR_EraseRootFromParent_Done,
     /* 267291 */   // Label 5187: @267291
     /* 267291 */   GIM_Reject,
     /* 267292 */ // Label 5168: @267292
     /* 267292 */ GIM_Try, /*On fail goto*//*Label 5188*/ GIMT_Encode4(271460),
     /* 267297 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/4,
     /* 267300 */   GIM_Try, /*On fail goto*//*Label 5189*/ GIMT_Encode4(267397), // Rule ID 7152 //
     /* 267305 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267310 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267313 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267316 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267353 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267364 */     // MIs[0] addr
     /* 267364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267376 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267378 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267387 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267395 */     GIR_RootConstrainSelectedInstOperands,
     /* 267396 */     // GIR_Coverage, 7152,
     /* 267396 */     GIR_EraseRootFromParent_Done,
     /* 267397 */   // Label 5189: @267397
     /* 267397 */   GIM_Try, /*On fail goto*//*Label 5190*/ GIMT_Encode4(267494), // Rule ID 7153 //
     /* 267402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267413 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267429 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267433 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267437 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267441 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267445 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267450 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267461 */     // MIs[0] addr
     /* 267461 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267465 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267469 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267475 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 267478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267484 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267486 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267492 */     GIR_RootConstrainSelectedInstOperands,
     /* 267493 */     // GIR_Coverage, 7153,
     /* 267493 */     GIR_EraseRootFromParent_Done,
     /* 267494 */   // Label 5190: @267494
     /* 267494 */   GIM_Try, /*On fail goto*//*Label 5191*/ GIMT_Encode4(267591), // Rule ID 7162 //
     /* 267499 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267504 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267507 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267510 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267514 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267518 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267522 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267526 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267530 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267534 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267538 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267542 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267547 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(255),
     /* 267558 */     // MIs[0] addr
     /* 267558 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267562 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267566 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 267570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267572 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 255:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 267575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267577 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267581 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267583 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267589 */     GIR_RootConstrainSelectedInstOperands,
     /* 267590 */     // GIR_Coverage, 7162,
     /* 267590 */     GIR_EraseRootFromParent_Done,
     /* 267591 */   // Label 5191: @267591
     /* 267591 */   GIM_Try, /*On fail goto*//*Label 5192*/ GIMT_Encode4(267688), // Rule ID 7163 //
     /* 267596 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 267601 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267604 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267607 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 267619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 267623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 267627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 267635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s32,
     /* 267639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267644 */     GIM_CheckConstantInt, /*MI*/2, /*Op*/2, GIMT_Encode8(65535),
     /* 267655 */     // MIs[0] addr
     /* 267655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 267667 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 267669 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } (and:{ *:[i32] } GPR32:{ *:[i32] }:$val, 65535:{ *:[i32] })), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 267669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 267672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // val
     /* 267678 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 267686 */     GIR_RootConstrainSelectedInstOperands,
     /* 267687 */     // GIR_Coverage, 7163,
     /* 267687 */     GIR_EraseRootFromParent_Done,
     /* 267688 */   // Label 5192: @267688
     /* 267688 */   GIM_Try, /*On fail goto*//*Label 5193*/ GIMT_Encode4(267799), // Rule ID 7155 //
     /* 267693 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267698 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267704 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267720 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267729 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 267740 */     // MIs[0] addr
     /* 267740 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267744 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267748 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 267752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267754 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 267785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267790 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267792 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267797 */     GIR_RootConstrainSelectedInstOperands,
     /* 267798 */     // GIR_Coverage, 7155,
     /* 267798 */     GIR_EraseRootFromParent_Done,
     /* 267799 */   // Label 5193: @267799
     /* 267799 */   GIM_Try, /*On fail goto*//*Label 5194*/ GIMT_Encode4(267910), // Rule ID 7156 //
     /* 267804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267815 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267819 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267823 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267827 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267831 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267840 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 267851 */     // MIs[0] addr
     /* 267851 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267855 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267859 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 267863 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267865 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267865 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267868 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267872 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267877 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267883 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267888 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 267896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 267898 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 267901 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 267903 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 267908 */     GIR_RootConstrainSelectedInstOperands,
     /* 267909 */     // GIR_Coverage, 7156,
     /* 267909 */     GIR_EraseRootFromParent_Done,
     /* 267910 */   // Label 5194: @267910
     /* 267910 */   GIM_Try, /*On fail goto*//*Label 5195*/ GIMT_Encode4(268021), // Rule ID 7157 //
     /* 267915 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 267920 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 267923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 267926 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267930 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 267934 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 267938 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 267942 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 267946 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 267951 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 267962 */     // MIs[0] addr
     /* 267962 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 267966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 267970 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 267974 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 267976 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 267976 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 267979 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 267983 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 267988 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 267994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 267999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268012 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268014 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268019 */     GIR_RootConstrainSelectedInstOperands,
     /* 268020 */     // GIR_Coverage, 7157,
     /* 268020 */     GIR_EraseRootFromParent_Done,
     /* 268021 */   // Label 5195: @268021
     /* 268021 */   GIM_Try, /*On fail goto*//*Label 5196*/ GIMT_Encode4(268132), // Rule ID 7165 //
     /* 268026 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268031 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268037 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268041 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268045 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268049 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268053 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268057 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268062 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(255),
     /* 268073 */     // MIs[0] addr
     /* 268073 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268077 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268081 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 268085 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268087 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 255:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268087 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268090 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268094 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268099 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268105 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268110 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268115 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 268118 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268120 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268123 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268125 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268130 */     GIR_RootConstrainSelectedInstOperands,
     /* 268131 */     // GIR_Coverage, 7165,
     /* 268131 */     GIR_EraseRootFromParent_Done,
     /* 268132 */   // Label 5196: @268132
     /* 268132 */   GIM_Try, /*On fail goto*//*Label 5197*/ GIMT_Encode4(268243), // Rule ID 7166 //
     /* 268137 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268142 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268145 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268148 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268156 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268160 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268164 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268173 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 268184 */     // MIs[0] addr
     /* 268184 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268192 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 268196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268198 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 65535:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 268229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268234 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268236 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268241 */     GIR_RootConstrainSelectedInstOperands,
     /* 268242 */     // GIR_Coverage, 7166,
     /* 268242 */     GIR_EraseRootFromParent_Done,
     /* 268243 */   // Label 5197: @268243
     /* 268243 */   GIM_Try, /*On fail goto*//*Label 5198*/ GIMT_Encode4(268354), // Rule ID 7167 //
     /* 268248 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268253 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268263 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268267 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 268271 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 268275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 268279 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268284 */     GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4294967295),
     /* 268295 */     // MIs[0] addr
     /* 268295 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268299 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268303 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268307 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268309 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (and:{ *:[i64] } GPR64:{ *:[i64] }:$val, 4294967295:{ *:[i64] }), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 268309 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 268312 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 268316 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 268321 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 268327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 268337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 268345 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268352 */     GIR_RootConstrainSelectedInstOperands,
     /* 268353 */     // GIR_Coverage, 7167,
     /* 268353 */     GIR_EraseRootFromParent_Done,
     /* 268354 */   // Label 5198: @268354
     /* 268354 */   GIM_Try, /*On fail goto*//*Label 5199*/ GIMT_Encode4(268405), // Rule ID 70 //
     /* 268359 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_fixedshadow),
     /* 268364 */     // MIs[0] ptr
     /* 268364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268372 */     // MIs[0] accessinfo
     /* 268372 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268375 */     // MIs[0] fixed_shadow
     /* 268375 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268378 */     // (intrinsic_void 191:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_FIXEDSHADOW),
     /* 268381 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268383 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268385 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268387 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268390 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268393 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268396 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268399 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268403 */     GIR_RootConstrainSelectedInstOperands,
     /* 268404 */     // GIR_Coverage, 70,
     /* 268404 */     GIR_EraseRootFromParent_Done,
     /* 268405 */   // Label 5199: @268405
     /* 268405 */   GIM_Try, /*On fail goto*//*Label 5200*/ GIMT_Encode4(268456), // Rule ID 71 //
     /* 268410 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules_fixedshadow),
     /* 268415 */     // MIs[0] ptr
     /* 268415 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 268419 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 268423 */     // MIs[0] accessinfo
     /* 268423 */     GIM_CheckIsImm, /*MI*/0, /*Op*/2,
     /* 268426 */     // MIs[0] fixed_shadow
     /* 268426 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 268429 */     // (intrinsic_void 193:{ *:[iPTR] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo, (timm:{ *:[i64] }):$fixed_shadow)
     /* 268429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES_FIXEDSHADOW),
     /* 268432 */     GIR_RootToRootCopy, /*OpIdx*/1, // ptr
     /* 268434 */     GIR_RootToRootCopy, /*OpIdx*/2, // accessinfo
     /* 268436 */     GIR_RootToRootCopy, /*OpIdx*/3, // fixed_shadow
     /* 268438 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 268441 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 268444 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 268447 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 268450 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268454 */     GIR_RootConstrainSelectedInstOperands,
     /* 268455 */     // GIR_Coverage, 71,
     /* 268455 */     GIR_EraseRootFromParent_Done,
     /* 268456 */   // Label 5200: @268456
     /* 268456 */   GIM_Try, /*On fail goto*//*Label 5201*/ GIMT_Encode4(268525), // Rule ID 7154 //
     /* 268461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 268466 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268472 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268484 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268488 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268493 */     // MIs[0] addr
     /* 268493 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268501 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 268505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268507 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 268510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268516 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268518 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268523 */     GIR_RootConstrainSelectedInstOperands,
     /* 268524 */     // GIR_Coverage, 7154,
     /* 268524 */     GIR_EraseRootFromParent_Done,
     /* 268525 */   // Label 5201: @268525
     /* 268525 */   GIM_Try, /*On fail goto*//*Label 5202*/ GIMT_Encode4(268594), // Rule ID 7164 //
     /* 268530 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 268535 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 268538 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 268541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 268549 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 268553 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 268557 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 268562 */     // MIs[0] addr
     /* 268562 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 268566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 268570 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 268574 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 268576 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$val), GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } GPR32:{ *:[i32] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 268576 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 268579 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 268581 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // val
     /* 268585 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 268587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 268592 */     GIR_RootConstrainSelectedInstOperands,
     /* 268593 */     // GIR_Coverage, 7164,
     /* 268593 */     GIR_EraseRootFromParent_Done,
     /* 268594 */   // Label 5202: @268594
     /* 268594 */   GIM_Try, /*On fail goto*//*Label 5203*/ GIMT_Encode4(268636), // Rule ID 3596 //
     /* 268599 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268602 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268607 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268610 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268613 */     // MIs[0] tile
     /* 268613 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268616 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268621 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268621 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_BToS_PSEUDO),
     /* 268624 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268626 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268628 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268630 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268634 */     GIR_RootConstrainSelectedInstOperands,
     /* 268635 */     // GIR_Coverage, 3596,
     /* 268635 */     GIR_EraseRootFromParent_Done,
     /* 268636 */   // Label 5203: @268636
     /* 268636 */   GIM_Try, /*On fail goto*//*Label 5204*/ GIMT_Encode4(268678), // Rule ID 3600 //
     /* 268641 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268644 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_wide_1x1),
     /* 268649 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268652 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268655 */     // MIs[0] tile
     /* 268655 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268658 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268663 */     // (intrinsic_void 1022:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HToS_PSEUDO),
     /* 268666 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268668 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268670 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268676 */     GIR_RootConstrainSelectedInstOperands,
     /* 268677 */     // GIR_Coverage, 3600,
     /* 268677 */     GIR_EraseRootFromParent_Done,
     /* 268678 */   // Label 5204: @268678
     /* 268678 */   GIM_Try, /*On fail goto*//*Label 5205*/ GIMT_Encode4(268720), // Rule ID 3604 //
     /* 268683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 268686 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4a_za64_wide_1x1),
     /* 268691 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268694 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268697 */     // MIs[0] tile
     /* 268697 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268700 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268705 */     // (intrinsic_void 1026:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 268705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4A_MZZ_HtoD_PSEUDO),
     /* 268708 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268712 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268714 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268718 */     GIR_RootConstrainSelectedInstOperands,
     /* 268719 */     // GIR_Coverage, 3604,
     /* 268719 */     GIR_EraseRootFromParent_Done,
     /* 268720 */   // Label 5205: @268720
     /* 268720 */   GIM_Try, /*On fail goto*//*Label 5206*/ GIMT_Encode4(268762), // Rule ID 3774 //
     /* 268725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 268728 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268739 */     // MIs[0] tile
     /* 268739 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268742 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268747 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_H_PSEUDO),
     /* 268750 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268752 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268754 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268756 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268760 */     GIR_RootConstrainSelectedInstOperands,
     /* 268761 */     // GIR_Coverage, 3774,
     /* 268761 */     GIR_EraseRootFromParent_Done,
     /* 268762 */   // Label 5206: @268762
     /* 268762 */   GIM_Try, /*On fail goto*//*Label 5207*/ GIMT_Encode4(268804), // Rule ID 3778 //
     /* 268767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32_HasSME_MOP4),
     /* 268770 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za32_1x1),
     /* 268775 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268778 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268781 */     // MIs[0] tile
     /* 268781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268789 */     // (intrinsic_void 882:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoS_PSEUDO),
     /* 268792 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268794 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268796 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268798 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268802 */     GIR_RootConstrainSelectedInstOperands,
     /* 268803 */     // GIR_Coverage, 3778,
     /* 268803 */     GIR_EraseRootFromParent_Done,
     /* 268804 */   // Label 5207: @268804
     /* 268804 */   GIM_Try, /*On fail goto*//*Label 5208*/ GIMT_Encode4(268846), // Rule ID 3782 //
     /* 268809 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268812 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268817 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 268820 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 268823 */     // MIs[0] tile
     /* 268823 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268826 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268831 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4A_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 268831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_S_PSEUDO),
     /* 268834 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268844 */     GIR_RootConstrainSelectedInstOperands,
     /* 268845 */     // GIR_Coverage, 3782,
     /* 268845 */     GIR_EraseRootFromParent_Done,
     /* 268846 */   // Label 5208: @268846
     /* 268846 */   GIM_Try, /*On fail goto*//*Label 5209*/ GIMT_Encode4(268888), // Rule ID 3786 //
     /* 268851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 268854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_1x1),
     /* 268859 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 268862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 268865 */     // MIs[0] tile
     /* 268865 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268868 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 268873 */     // (intrinsic_void 919:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4A_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 268873 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_D_PSEUDO),
     /* 268876 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268878 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268880 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268886 */     GIR_RootConstrainSelectedInstOperands,
     /* 268887 */     // GIR_Coverage, 3786,
     /* 268887 */     GIR_EraseRootFromParent_Done,
     /* 268888 */   // Label 5209: @268888
     /* 268888 */   GIM_Try, /*On fail goto*//*Label 5210*/ GIMT_Encode4(268930), // Rule ID 3790 //
     /* 268893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4a_wide_1x1),
     /* 268901 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 268904 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 268907 */     // MIs[0] tile
     /* 268907 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268910 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268915 */     // (intrinsic_void 923:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4A_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 268915 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_HtoS_PSEUDO),
     /* 268918 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268920 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268922 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268924 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268928 */     GIR_RootConstrainSelectedInstOperands,
     /* 268929 */     // GIR_Coverage, 3790,
     /* 268929 */     GIR_EraseRootFromParent_Done,
     /* 268930 */   // Label 5210: @268930
     /* 268930 */   GIM_Try, /*On fail goto*//*Label 5211*/ GIMT_Encode4(268972), // Rule ID 3794 //
     /* 268935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16_HasSME_MOP4),
     /* 268938 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmop4a_za16_1x1),
     /* 268943 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268946 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268949 */     // MIs[0] tile
     /* 268949 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268952 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 268957 */     // (intrinsic_void 878:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOP4A_MZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4A_MZZ_BtoH_PSEUDO),
     /* 268960 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 268962 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 268964 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 268966 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 268970 */     GIR_RootConstrainSelectedInstOperands,
     /* 268971 */     // GIR_Coverage, 3794,
     /* 268971 */     GIR_EraseRootFromParent_Done,
     /* 268972 */   // Label 5211: @268972
     /* 268972 */   GIM_Try, /*On fail goto*//*Label 5212*/ GIMT_Encode4(269014), // Rule ID 12657 //
     /* 268977 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 268980 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 268985 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 268988 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 268991 */     // MIs[0] tile
     /* 268991 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 268994 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 268999 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 268999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_BToS_PSEUDO),
     /* 269002 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269004 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269006 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269008 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269012 */     GIR_RootConstrainSelectedInstOperands,
     /* 269013 */     // GIR_Coverage, 12657,
     /* 269013 */     GIR_EraseRootFromParent_Done,
     /* 269014 */   // Label 5212: @269014
     /* 269014 */   GIM_Try, /*On fail goto*//*Label 5213*/ GIMT_Encode4(269056), // Rule ID 12661 //
     /* 269019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269022 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_wide_1x1),
     /* 269027 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269030 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269033 */     // MIs[0] tile
     /* 269033 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269036 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269041 */     // (intrinsic_void 1074:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_BToS_PSEUDO),
     /* 269044 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269046 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269048 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269054 */     GIR_RootConstrainSelectedInstOperands,
     /* 269055 */     // GIR_Coverage, 12661,
     /* 269055 */     GIR_EraseRootFromParent_Done,
     /* 269056 */   // Label 5213: @269056
     /* 269056 */   GIM_Try, /*On fail goto*//*Label 5214*/ GIMT_Encode4(269098), // Rule ID 12665 //
     /* 269061 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269064 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_wide_1x1),
     /* 269069 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269072 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269075 */     // MIs[0] tile
     /* 269075 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269078 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269083 */     // (intrinsic_void 1082:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269083 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_BToS_PSEUDO),
     /* 269086 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269088 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269092 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269096 */     GIR_RootConstrainSelectedInstOperands,
     /* 269097 */     // GIR_Coverage, 12665,
     /* 269097 */     GIR_EraseRootFromParent_Done,
     /* 269098 */   // Label 5214: @269098
     /* 269098 */   GIM_Try, /*On fail goto*//*Label 5215*/ GIMT_Encode4(269140), // Rule ID 12669 //
     /* 269103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269106 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_wide_1x1),
     /* 269111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269114 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269117 */     // MIs[0] tile
     /* 269117 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269120 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269125 */     // (intrinsic_void 1191:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_BToS_PSEUDO),
     /* 269128 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269130 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269132 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269134 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269138 */     GIR_RootConstrainSelectedInstOperands,
     /* 269139 */     // GIR_Coverage, 12669,
     /* 269139 */     GIR_EraseRootFromParent_Done,
     /* 269140 */   // Label 5215: @269140
     /* 269140 */   GIM_Try, /*On fail goto*//*Label 5216*/ GIMT_Encode4(269182), // Rule ID 12673 //
     /* 269145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269148 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_wide_1x1),
     /* 269153 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269156 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269159 */     // MIs[0] tile
     /* 269159 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269162 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269167 */     // (intrinsic_void 1199:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_BToS_PSEUDO),
     /* 269170 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269172 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269174 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269176 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269180 */     GIR_RootConstrainSelectedInstOperands,
     /* 269181 */     // GIR_Coverage, 12673,
     /* 269181 */     GIR_EraseRootFromParent_Done,
     /* 269182 */   // Label 5216: @269182
     /* 269182 */   GIM_Try, /*On fail goto*//*Label 5217*/ GIMT_Encode4(269224), // Rule ID 12677 //
     /* 269187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269190 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269201 */     // MIs[0] tile
     /* 269201 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269204 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269209 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4A_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_BToS_PSEUDO),
     /* 269212 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269216 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269218 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269222 */     GIR_RootConstrainSelectedInstOperands,
     /* 269223 */     // GIR_Coverage, 12677,
     /* 269223 */     GIR_EraseRootFromParent_Done,
     /* 269224 */   // Label 5217: @269224
     /* 269224 */   GIM_Try, /*On fail goto*//*Label 5218*/ GIMT_Encode4(269266), // Rule ID 12681 //
     /* 269229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269232 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269237 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 269240 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 269243 */     // MIs[0] tile
     /* 269243 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269246 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269251 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOP4S_MZZ_BToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 269251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_BToS_PSEUDO),
     /* 269254 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269264 */     GIR_RootConstrainSelectedInstOperands,
     /* 269265 */     // GIR_Coverage, 12681,
     /* 269265 */     GIR_EraseRootFromParent_Done,
     /* 269266 */   // Label 5218: @269266
     /* 269266 */   GIM_Try, /*On fail goto*//*Label 5219*/ GIMT_Encode4(269308), // Rule ID 12685 //
     /* 269271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_wide_1x1),
     /* 269279 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269285 */     // MIs[0] tile
     /* 269285 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269288 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269293 */     // (intrinsic_void 1030:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HToS_PSEUDO),
     /* 269296 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269302 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269306 */     GIR_RootConstrainSelectedInstOperands,
     /* 269307 */     // GIR_Coverage, 12685,
     /* 269307 */     GIR_EraseRootFromParent_Done,
     /* 269308 */   // Label 5219: @269308
     /* 269308 */   GIM_Try, /*On fail goto*//*Label 5220*/ GIMT_Encode4(269350), // Rule ID 12689 //
     /* 269313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269316 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_wide_1x1),
     /* 269321 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269324 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269327 */     // MIs[0] tile
     /* 269327 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269330 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269335 */     // (intrinsic_void 1157:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HToS_PSEUDO),
     /* 269338 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269342 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269348 */     GIR_RootConstrainSelectedInstOperands,
     /* 269349 */     // GIR_Coverage, 12689,
     /* 269349 */     GIR_EraseRootFromParent_Done,
     /* 269350 */   // Label 5220: @269350
     /* 269350 */   GIM_Try, /*On fail goto*//*Label 5221*/ GIMT_Encode4(269392), // Rule ID 12693 //
     /* 269355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269358 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_wide_1x1),
     /* 269363 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269366 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269369 */     // MIs[0] tile
     /* 269369 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269372 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269377 */     // (intrinsic_void 1165:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HToS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HToS_PSEUDO),
     /* 269380 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269386 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269390 */     GIR_RootConstrainSelectedInstOperands,
     /* 269391 */     // GIR_Coverage, 12693,
     /* 269391 */     GIR_EraseRootFromParent_Done,
     /* 269392 */   // Label 5221: @269392
     /* 269392 */   GIM_Try, /*On fail goto*//*Label 5222*/ GIMT_Encode4(269434), // Rule ID 12697 //
     /* 269397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269400 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smop4s_za64_wide_1x1),
     /* 269405 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269408 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269411 */     // MIs[0] tile
     /* 269411 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269414 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269419 */     // (intrinsic_void 1034:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOP4S_MZZ_HtoD_PSEUDO),
     /* 269422 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269426 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269428 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269432 */     GIR_RootConstrainSelectedInstOperands,
     /* 269433 */     // GIR_Coverage, 12697,
     /* 269433 */     GIR_EraseRootFromParent_Done,
     /* 269434 */   // Label 5222: @269434
     /* 269434 */   GIM_Try, /*On fail goto*//*Label 5223*/ GIMT_Encode4(269476), // Rule ID 12701 //
     /* 269439 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269442 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4a_za64_wide_1x1),
     /* 269447 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269450 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269453 */     // MIs[0] tile
     /* 269453 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269456 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269461 */     // (intrinsic_void 1078:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4A_MZZ_HtoD_PSEUDO),
     /* 269464 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269466 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269470 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269474 */     GIR_RootConstrainSelectedInstOperands,
     /* 269475 */     // GIR_Coverage, 12701,
     /* 269475 */     GIR_EraseRootFromParent_Done,
     /* 269476 */   // Label 5223: @269476
     /* 269476 */   GIM_Try, /*On fail goto*//*Label 5224*/ GIMT_Encode4(269518), // Rule ID 12705 //
     /* 269481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269484 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumop4s_za64_wide_1x1),
     /* 269489 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269492 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269495 */     // MIs[0] tile
     /* 269495 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269498 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269503 */     // (intrinsic_void 1086:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOP4S_MZZ_HtoD_PSEUDO),
     /* 269506 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269508 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269512 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269516 */     GIR_RootConstrainSelectedInstOperands,
     /* 269517 */     // GIR_Coverage, 12705,
     /* 269517 */     GIR_EraseRootFromParent_Done,
     /* 269518 */   // Label 5224: @269518
     /* 269518 */   GIM_Try, /*On fail goto*//*Label 5225*/ GIMT_Encode4(269560), // Rule ID 12709 //
     /* 269523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269526 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4a_za64_wide_1x1),
     /* 269531 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269534 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269537 */     // MIs[0] tile
     /* 269537 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269540 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269545 */     // (intrinsic_void 1161:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4A_MZZ_HtoD_PSEUDO),
     /* 269548 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269550 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269552 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269554 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269558 */     GIR_RootConstrainSelectedInstOperands,
     /* 269559 */     // GIR_Coverage, 12709,
     /* 269559 */     GIR_EraseRootFromParent_Done,
     /* 269560 */   // Label 5225: @269560
     /* 269560 */   GIM_Try, /*On fail goto*//*Label 5226*/ GIMT_Encode4(269602), // Rule ID 12713 //
     /* 269565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269568 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umop4s_za64_wide_1x1),
     /* 269573 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269576 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269579 */     // MIs[0] tile
     /* 269579 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269582 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269587 */     // (intrinsic_void 1169:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOP4S_MZZ_HtoD_PSEUDO),
     /* 269590 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269592 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269594 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269596 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269600 */     GIR_RootConstrainSelectedInstOperands,
     /* 269601 */     // GIR_Coverage, 12713,
     /* 269601 */     GIR_EraseRootFromParent_Done,
     /* 269602 */   // Label 5226: @269602
     /* 269602 */   GIM_Try, /*On fail goto*//*Label 5227*/ GIMT_Encode4(269644), // Rule ID 12717 //
     /* 269607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269610 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4a_za64_wide_1x1),
     /* 269615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269621 */     // MIs[0] tile
     /* 269621 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269624 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269629 */     // (intrinsic_void 1195:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4A_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4A_MZZ_HtoD_PSEUDO),
     /* 269632 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269636 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269638 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269642 */     GIR_RootConstrainSelectedInstOperands,
     /* 269643 */     // GIR_Coverage, 12717,
     /* 269643 */     GIR_EraseRootFromParent_Done,
     /* 269644 */   // Label 5227: @269644
     /* 269644 */   GIM_Try, /*On fail goto*//*Label 5228*/ GIMT_Encode4(269686), // Rule ID 12721 //
     /* 269649 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64_HasSME_MOP4),
     /* 269652 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmop4s_za64_wide_1x1),
     /* 269657 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269660 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269663 */     // MIs[0] tile
     /* 269663 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269666 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269671 */     // (intrinsic_void 1203:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOP4S_MZZ_HtoD_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 269671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOP4S_MZZ_HtoD_PSEUDO),
     /* 269674 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269684 */     GIR_RootConstrainSelectedInstOperands,
     /* 269685 */     // GIR_Coverage, 12721,
     /* 269685 */     GIR_EraseRootFromParent_Done,
     /* 269686 */   // Label 5228: @269686
     /* 269686 */   GIM_Try, /*On fail goto*//*Label 5229*/ GIMT_Encode4(269728), // Rule ID 13176 //
     /* 269691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_wide_1x1),
     /* 269699 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269705 */     // MIs[0] tile
     /* 269705 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269708 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269713 */     // (intrinsic_void 931:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_HtoS_PSEUDO),
     /* 269716 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269720 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269726 */     GIR_RootConstrainSelectedInstOperands,
     /* 269727 */     // GIR_Coverage, 13176,
     /* 269727 */     GIR_EraseRootFromParent_Done,
     /* 269728 */   // Label 5229: @269728
     /* 269728 */   GIM_Try, /*On fail goto*//*Label 5230*/ GIMT_Encode4(269770), // Rule ID 13180 //
     /* 269733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME_MOP4),
     /* 269736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 269744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 269747 */     // MIs[0] tile
     /* 269747 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269750 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 269755 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOP4S_MZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 269755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_S_PSEUDO),
     /* 269758 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269760 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269762 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269764 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269768 */     GIR_RootConstrainSelectedInstOperands,
     /* 269769 */     // GIR_Coverage, 13180,
     /* 269769 */     GIR_EraseRootFromParent_Done,
     /* 269770 */   // Label 5230: @269770
     /* 269770 */   GIM_Try, /*On fail goto*//*Label 5231*/ GIMT_Encode4(269812), // Rule ID 13184 //
     /* 269775 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_HasSME_MOP4),
     /* 269778 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 269786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 269789 */     // MIs[0] tile
     /* 269789 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269792 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 269797 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOP4S_MZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 269797 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_H_PSEUDO),
     /* 269800 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269802 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269804 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269806 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269810 */     GIR_RootConstrainSelectedInstOperands,
     /* 269811 */     // GIR_Coverage, 13184,
     /* 269811 */     GIR_EraseRootFromParent_Done,
     /* 269812 */   // Label 5231: @269812
     /* 269812 */   GIM_Try, /*On fail goto*//*Label 5232*/ GIMT_Encode4(269854), // Rule ID 13188 //
     /* 269817 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64_HasSME_MOP4),
     /* 269820 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mop4s_1x1),
     /* 269825 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 269828 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 269831 */     // MIs[0] tile
     /* 269831 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 269834 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 269839 */     // (intrinsic_void 927:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOP4S_MZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 269839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOP4S_MZZ_D_PSEUDO),
     /* 269842 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 269844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 269846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 269848 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269852 */     GIR_RootConstrainSelectedInstOperands,
     /* 269853 */     // GIR_Coverage, 13188,
     /* 269853 */     GIR_EraseRootFromParent_Done,
     /* 269854 */   // Label 5232: @269854
     /* 269854 */   GIM_Try, /*On fail goto*//*Label 5233*/ GIMT_Encode4(269908), // Rule ID 8901 //
     /* 269859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269862 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 269867 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 269870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269874 */     // MIs[0] base
     /* 269874 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269878 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269882 */     // MIs[0] prfop
     /* 269882 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 269885 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 269890 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv16i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_PRI),
     /* 269893 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 269895 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 269897 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 269899 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269906 */     GIR_RootConstrainSelectedInstOperands,
     /* 269907 */     // GIR_Coverage, 8901,
     /* 269907 */     GIR_EraseRootFromParent_Done,
     /* 269908 */   // Label 5233: @269908
     /* 269908 */   GIM_Try, /*On fail goto*//*Label 5234*/ GIMT_Encode4(269962), // Rule ID 8904 //
     /* 269913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269916 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 269921 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 269924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269928 */     // MIs[0] base
     /* 269928 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269932 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269936 */     // MIs[0] prfop
     /* 269936 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 269939 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 269944 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv8i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_PRI),
     /* 269947 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 269949 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 269951 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 269953 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 269956 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 269960 */     GIR_RootConstrainSelectedInstOperands,
     /* 269961 */     // GIR_Coverage, 8904,
     /* 269961 */     GIR_EraseRootFromParent_Done,
     /* 269962 */   // Label 5234: @269962
     /* 269962 */   GIM_Try, /*On fail goto*//*Label 5235*/ GIMT_Encode4(270016), // Rule ID 8907 //
     /* 269967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 269970 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 269975 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 269978 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 269982 */     // MIs[0] base
     /* 269982 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 269986 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 269990 */     // MIs[0] prfop
     /* 269990 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 269993 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 269998 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 269998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_PRI),
     /* 270001 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270003 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270005 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270007 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270010 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270014 */     GIR_RootConstrainSelectedInstOperands,
     /* 270015 */     // GIR_Coverage, 8907,
     /* 270015 */     GIR_EraseRootFromParent_Done,
     /* 270016 */   // Label 5235: @270016
     /* 270016 */   GIM_Try, /*On fail goto*//*Label 5236*/ GIMT_Encode4(270070), // Rule ID 8910 //
     /* 270021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270024 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prf),
     /* 270029 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 270032 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 270036 */     // MIs[0] base
     /* 270036 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270044 */     // MIs[0] prfop
     /* 270044 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270047 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 270052 */     // (intrinsic_void 1641:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_PRI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$gp, GPR64:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 270052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_PRI),
     /* 270055 */     GIR_RootToRootCopy, /*OpIdx*/3, // prfop
     /* 270057 */     GIR_RootToRootCopy, /*OpIdx*/1, // gp
     /* 270059 */     GIR_RootToRootCopy, /*OpIdx*/2, // base
     /* 270061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 270064 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270068 */     GIR_RootConstrainSelectedInstOperands,
     /* 270069 */     // GIR_Coverage, 8910,
     /* 270069 */     GIR_EraseRootFromParent_Done,
     /* 270070 */   // Label 5236: @270070
     /* 270070 */   GIM_Try, /*On fail goto*//*Label 5237*/ GIMT_Encode4(270124), // Rule ID 15 //
     /* 270075 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_space),
     /* 270080 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 270083 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 270086 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 270089 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 270097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 270101 */     // MIs[1] Operand 1
     /* 270101 */     // No operand predicates
     /* 270101 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270105 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 270107 */     // (intrinsic_w_chain:{ *:[i64] } 1239:{ *:[iPTR] }, (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)  =>  (SPACE:{ *:[i64] } (imm:{ *:[i32] }):$size, GPR64:{ *:[i64] }:$Rn)
     /* 270107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SPACE),
     /* 270110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // size
     /* 270115 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 270117 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 270122 */     GIR_RootConstrainSelectedInstOperands,
     /* 270123 */     // GIR_Coverage, 15,
     /* 270123 */     GIR_EraseRootFromParent_Done,
     /* 270124 */   // Label 5237: @270124
     /* 270124 */   GIM_Try, /*On fail goto*//*Label 5238*/ GIMT_Encode4(270192), // Rule ID 68 //
     /* 270129 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess),
     /* 270134 */     // MIs[0] Operand 1
     /* 270134 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270138 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64_with_sub_32_in_MatrixIndexGPR32_8_11RegClassID),
     /* 270142 */     // MIs[0] ptr
     /* 270142 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270150 */     // MIs[0] accessinfo
     /* 270150 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270153 */     // (intrinsic_void 190:{ *:[iPTR] }, X9:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270153 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270157 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X9), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270163 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X9
     /* 270167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS),
     /* 270170 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270172 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270174 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270177 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270180 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270183 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270186 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270190 */     GIR_RootConstrainSelectedInstOperands,
     /* 270191 */     // GIR_Coverage, 68,
     /* 270191 */     GIR_EraseRootFromParent_Done,
     /* 270192 */   // Label 5238: @270192
     /* 270192 */   GIM_Try, /*On fail goto*//*Label 5239*/ GIMT_Encode4(270260), // Rule ID 69 //
     /* 270197 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::hwasan_check_memaccess_shortgranules),
     /* 270202 */     // MIs[0] Operand 1
     /* 270202 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/64,
     /* 270206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64common_and_GPR64noipRegClassID),
     /* 270210 */     // MIs[0] ptr
     /* 270210 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 270214 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64noipRegClassID),
     /* 270218 */     // MIs[0] accessinfo
     /* 270218 */     GIM_CheckIsImm, /*MI*/0, /*Op*/3,
     /* 270221 */     // (intrinsic_void 192:{ *:[iPTR] }, X20:{ *:[i64] }, GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)  =>  (HWASAN_CHECK_MEMACCESS_SHORTGRANULES:{ *:[i64] } GPR64noip:{ *:[i64] }:$ptr, (timm:{ *:[i32] }):$accessinfo)
     /* 270221 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270225 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::X20), /*AddRegisterRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270231 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // X20
     /* 270235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::HWASAN_CHECK_MEMACCESS_SHORTGRANULES),
     /* 270238 */     GIR_RootToRootCopy, /*OpIdx*/2, // ptr
     /* 270240 */     GIR_RootToRootCopy, /*OpIdx*/3, // accessinfo
     /* 270242 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X16*/0,
     /* 270245 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::X17*/1,
     /* 270248 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::LR*/2,
     /* 270251 */     GIR_SetImplicitDefDead, /*InsnID*/0, /*OpIdx for AArch64::NZCV*/3,
     /* 270254 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270258 */     GIR_RootConstrainSelectedInstOperands,
     /* 270259 */     // GIR_Coverage, 69,
     /* 270259 */     GIR_EraseRootFromParent_Done,
     /* 270260 */   // Label 5239: @270260
     /* 270260 */   GIM_Try, /*On fail goto*//*Label 5240*/ GIMT_Encode4(270340), // Rule ID 7148 //
     /* 270265 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270270 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270273 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270276 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270280 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270284 */     // MIs[0] addr
     /* 270284 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270288 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270292 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_1),
     /* 270296 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_1>>  =>  (STXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270296 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270299 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270303 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270308 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270314 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270319 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRB),
     /* 270327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270329 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270332 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270334 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270338 */     GIR_RootConstrainSelectedInstOperands,
     /* 270339 */     // GIR_Coverage, 7148,
     /* 270339 */     GIR_EraseRootFromParent_Done,
     /* 270340 */   // Label 5240: @270340
     /* 270340 */   GIM_Try, /*On fail goto*//*Label 5241*/ GIMT_Encode4(270420), // Rule ID 7149 //
     /* 270345 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270350 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270353 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270356 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270360 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270364 */     // MIs[0] addr
     /* 270364 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270368 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270372 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_2),
     /* 270376 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_2>>  =>  (STXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270376 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270379 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270383 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270388 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270394 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270404 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRH),
     /* 270407 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270409 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270412 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270414 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270418 */     GIR_RootConstrainSelectedInstOperands,
     /* 270419 */     // GIR_Coverage, 7149,
     /* 270419 */     GIR_EraseRootFromParent_Done,
     /* 270420 */   // Label 5241: @270420
     /* 270420 */   GIM_Try, /*On fail goto*//*Label 5242*/ GIMT_Encode4(270500), // Rule ID 7150 //
     /* 270425 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270430 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270433 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270436 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270440 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270444 */     // MIs[0] addr
     /* 270444 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270448 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270452 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_4),
     /* 270456 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_4>>  =>  (STXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270468 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRW),
     /* 270487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270489 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270492 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270494 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270498 */     GIR_RootConstrainSelectedInstOperands,
     /* 270499 */     // GIR_Coverage, 7150,
     /* 270499 */     GIR_EraseRootFromParent_Done,
     /* 270500 */   // Label 5242: @270500
     /* 270500 */   GIM_Try, /*On fail goto*//*Label 5243*/ GIMT_Encode4(270551), // Rule ID 7151 //
     /* 270505 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxr),
     /* 270510 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270513 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270516 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270520 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270524 */     // MIs[0] addr
     /* 270524 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270532 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stxr_8),
     /* 270536 */     // (intrinsic_w_chain:{ *:[i32] } 1248:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stxr_8>>  =>  (STXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXRX),
     /* 270539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270541 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270543 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270545 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270549 */     GIR_RootConstrainSelectedInstOperands,
     /* 270550 */     // GIR_Coverage, 7151,
     /* 270550 */     GIR_EraseRootFromParent_Done,
     /* 270551 */   // Label 5243: @270551
     /* 270551 */   GIM_Try, /*On fail goto*//*Label 5244*/ GIMT_Encode4(270631), // Rule ID 7158 //
     /* 270556 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270561 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270564 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270567 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270571 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270575 */     // MIs[0] addr
     /* 270575 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270579 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270583 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_1),
     /* 270587 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_1>>  =>  (STLXRB:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRB),
     /* 270618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270620 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270623 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270625 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270629 */     GIR_RootConstrainSelectedInstOperands,
     /* 270630 */     // GIR_Coverage, 7158,
     /* 270630 */     GIR_EraseRootFromParent_Done,
     /* 270631 */   // Label 5244: @270631
     /* 270631 */   GIM_Try, /*On fail goto*//*Label 5245*/ GIMT_Encode4(270711), // Rule ID 7159 //
     /* 270636 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270641 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270644 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270647 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270655 */     // MIs[0] addr
     /* 270655 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270663 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_2),
     /* 270667 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_2>>  =>  (STLXRH:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270679 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRH),
     /* 270698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270703 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270705 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270709 */     GIR_RootConstrainSelectedInstOperands,
     /* 270710 */     // GIR_Coverage, 7159,
     /* 270710 */     GIR_EraseRootFromParent_Done,
     /* 270711 */   // Label 5245: @270711
     /* 270711 */   GIM_Try, /*On fail goto*//*Label 5246*/ GIMT_Encode4(270791), // Rule ID 7160 //
     /* 270716 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270721 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270724 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270727 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270731 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270735 */     // MIs[0] addr
     /* 270735 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270743 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_4),
     /* 270747 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_4>>  =>  (STLXRW:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$val, sub_32:{ *:[i32] }), GPR64sp:{ *:[i64] }:$addr)
     /* 270747 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 270750 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 270754 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 270759 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // val
     /* 270765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270770 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRW),
     /* 270778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270780 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 270783 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270785 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270789 */     GIR_RootConstrainSelectedInstOperands,
     /* 270790 */     // GIR_Coverage, 7160,
     /* 270790 */     GIR_EraseRootFromParent_Done,
     /* 270791 */   // Label 5246: @270791
     /* 270791 */   GIM_Try, /*On fail goto*//*Label 5247*/ GIMT_Encode4(270842), // Rule ID 7161 //
     /* 270796 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxr),
     /* 270801 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 270804 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 270807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 270811 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 270815 */     // MIs[0] addr
     /* 270815 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 270819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 270823 */     GIM_CheckCxxInsnPredicate, /*MI*/0, /*FnId*/GIMT_Encode2(GICXXPred_MI_Predicate_stlxr_8),
     /* 270827 */     // (intrinsic_w_chain:{ *:[i32] } 1246:{ *:[iPTR] }, GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)<<P:Predicate_stlxr_8>>  =>  (STLXRX:{ *:[i32] } GPR64:{ *:[i64] }:$val, GPR64sp:{ *:[i64] }:$addr)
     /* 270827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXRX),
     /* 270830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 270832 */     GIR_RootToRootCopy, /*OpIdx*/2, // val
     /* 270834 */     GIR_RootToRootCopy, /*OpIdx*/3, // addr
     /* 270836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270840 */     GIR_RootConstrainSelectedInstOperands,
     /* 270841 */     // GIR_Coverage, 7161,
     /* 270841 */     GIR_EraseRootFromParent_Done,
     /* 270842 */   // Label 5247: @270842
     /* 270842 */   GIM_Try, /*On fail goto*//*Label 5248*/ GIMT_Encode4(270891), // Rule ID 2484 //
     /* 270847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 270850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 270855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 270858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 270861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 270864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270868 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270872 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270876 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCVTN_F16v8f8:{ *:[v8i8] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 270876 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v8f8),
     /* 270879 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270881 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270883 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270885 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270889 */     GIR_RootConstrainSelectedInstOperands,
     /* 270890 */     // GIR_Coverage, 2484,
     /* 270890 */     GIR_EraseRootFromParent_Done,
     /* 270891 */   // Label 5248: @270891
     /* 270891 */   GIM_Try, /*On fail goto*//*Label 5249*/ GIMT_Encode4(270940), // Rule ID 2485 //
     /* 270896 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 270899 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 270904 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 270907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 270910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 270913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270921 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270925 */     // (intrinsic_w_chain:{ *:[v16i8] } 620:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTN_F16v16f8:{ *:[v16i8] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 270925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F16v16f8),
     /* 270928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270930 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270932 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270934 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270938 */     GIR_RootConstrainSelectedInstOperands,
     /* 270939 */     // GIR_Coverage, 2485,
     /* 270939 */     GIR_EraseRootFromParent_Done,
     /* 270940 */   // Label 5249: @270940
     /* 270940 */   GIM_Try, /*On fail goto*//*Label 5250*/ GIMT_Encode4(270989), // Rule ID 2486 //
     /* 270945 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 270948 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn),
     /* 270953 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s8,
     /* 270956 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 270959 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 270962 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 270966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 270974 */     // (intrinsic_w_chain:{ *:[v8i8] } 620:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F32v8f8:{ *:[v8i8] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 270974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F32v8f8),
     /* 270977 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 270979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 270981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 270983 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 270987 */     GIR_RootConstrainSelectedInstOperands,
     /* 270988 */     // GIR_Coverage, 2486,
     /* 270988 */     GIR_EraseRootFromParent_Done,
     /* 270989 */   // Label 5250: @270989
     /* 270989 */   GIM_Try, /*On fail goto*//*Label 5251*/ GIMT_Encode4(271042), // Rule ID 8787 //
     /* 270994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 270997 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271002 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271005 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271008 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271016 */     // MIs[0] base
     /* 271016 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271024 */     // (intrinsic_w_chain:{ *:[nxv4i32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4i32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271029 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271031 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271036 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271040 */     GIR_RootConstrainSelectedInstOperands,
     /* 271041 */     // GIR_Coverage, 8787,
     /* 271041 */     GIR_EraseRootFromParent_Done,
     /* 271042 */   // Label 5251: @271042
     /* 271042 */   GIM_Try, /*On fail goto*//*Label 5252*/ GIMT_Encode4(271095), // Rule ID 8790 //
     /* 271047 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271050 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1uwq),
     /* 271055 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 271058 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271061 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271065 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271069 */     // MIs[0] base
     /* 271069 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271073 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271077 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1574:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1W_Q_IMM:{ *:[nxv4f32] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271077 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1W_Q_IMM),
     /* 271080 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271082 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271084 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271086 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271089 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271093 */     GIR_RootConstrainSelectedInstOperands,
     /* 271094 */     // GIR_Coverage, 8790,
     /* 271094 */     GIR_EraseRootFromParent_Done,
     /* 271095 */   // Label 5252: @271095
     /* 271095 */   GIM_Try, /*On fail goto*//*Label 5253*/ GIMT_Encode4(271148), // Rule ID 8799 //
     /* 271100 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271103 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271108 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271111 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271122 */     // MIs[0] base
     /* 271122 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271130 */     // (intrinsic_w_chain:{ *:[nxv2i64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2i64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271137 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271139 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271142 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271146 */     GIR_RootConstrainSelectedInstOperands,
     /* 271147 */     // GIR_Coverage, 8799,
     /* 271147 */     GIR_EraseRootFromParent_Done,
     /* 271148 */   // Label 5253: @271148
     /* 271148 */   GIM_Try, /*On fail goto*//*Label 5254*/ GIMT_Encode4(271201), // Rule ID 8802 //
     /* 271153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271156 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_ld1udq),
     /* 271161 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv2s64,
     /* 271164 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271167 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271171 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271175 */     // MIs[0] base
     /* 271175 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271179 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271183 */     // (intrinsic_w_chain:{ *:[nxv2f64] } 1573:{ *:[iPTR] }, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (LD1D_Q_IMM:{ *:[nxv2f64] } PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1D_Q_IMM),
     /* 271186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zt]
     /* 271188 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271190 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271195 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271199 */     GIR_RootConstrainSelectedInstOperands,
     /* 271200 */     // GIR_Coverage, 8802,
     /* 271200 */     GIR_EraseRootFromParent_Done,
     /* 271201 */   // Label 5254: @271201
     /* 271201 */   GIM_Try, /*On fail goto*//*Label 5255*/ GIMT_Encode4(271247), // Rule ID 137 //
     /* 271206 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasMTE),
     /* 271209 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_irg),
     /* 271214 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 271217 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271220 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271224 */     // MIs[0] Rn
     /* 271224 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271228 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271232 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 271236 */     // (intrinsic_w_chain:{ *:[i64] } 565:{ *:[iPTR] }, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (IRG:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 271236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::IRG),
     /* 271239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 271241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271243 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 271245 */     GIR_RootConstrainSelectedInstOperands,
     /* 271246 */     // GIR_Coverage, 137,
     /* 271246 */     GIR_EraseRootFromParent_Done,
     /* 271247 */   // Label 5255: @271247
     /* 271247 */   GIM_Try, /*On fail goto*//*Label 5256*/ GIMT_Encode4(271300), // Rule ID 8793 //
     /* 271252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271255 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271260 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271263 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271274 */     // MIs[0] base
     /* 271274 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271282 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4i32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271285 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271287 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271289 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271294 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271298 */     GIR_RootConstrainSelectedInstOperands,
     /* 271299 */     // GIR_Coverage, 8793,
     /* 271299 */     GIR_EraseRootFromParent_Done,
     /* 271300 */   // Label 5256: @271300
     /* 271300 */   GIM_Try, /*On fail goto*//*Label 5257*/ GIMT_Encode4(271353), // Rule ID 8796 //
     /* 271305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271308 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1wq),
     /* 271313 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 271316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271319 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271323 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271327 */     // MIs[0] base
     /* 271327 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271331 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271335 */     // (intrinsic_void 1894:{ *:[iPTR] }, ZPR128:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1W_Q_IMM Z_q:{ *:[nxv4f32] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1W_Q_IMM),
     /* 271338 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271342 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271344 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271351 */     GIR_RootConstrainSelectedInstOperands,
     /* 271352 */     // GIR_Coverage, 8796,
     /* 271352 */     GIR_EraseRootFromParent_Done,
     /* 271353 */   // Label 5257: @271353
     /* 271353 */   GIM_Try, /*On fail goto*//*Label 5258*/ GIMT_Encode4(271406), // Rule ID 8805 //
     /* 271358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271366 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271372 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271376 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271380 */     // MIs[0] base
     /* 271380 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271384 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271388 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2i64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271395 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271400 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271404 */     GIR_RootConstrainSelectedInstOperands,
     /* 271405 */     // GIR_Coverage, 8805,
     /* 271405 */     GIR_EraseRootFromParent_Done,
     /* 271406 */   // Label 5258: @271406
     /* 271406 */   GIM_Try, /*On fail goto*//*Label 5259*/ GIMT_Encode4(271459), // Rule ID 8808 //
     /* 271411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 271414 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_st1dq),
     /* 271419 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 271422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 271425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271433 */     // MIs[0] base
     /* 271433 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/3, /*SizeInBits*/64,
     /* 271437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271441 */     // (intrinsic_void 1890:{ *:[iPTR] }, ZPR128:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base)  =>  (ST1D_Q_IMM Z_q:{ *:[nxv2f64] }:$Zt, PPR3bAny:{ *:[nxv1i1] }:$Pg, GPR64sp:{ *:[i64] }:$base, 0:{ *:[i64] })
     /* 271441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ST1D_Q_IMM),
     /* 271444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zt
     /* 271446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pg
     /* 271448 */     GIR_RootToRootCopy, /*OpIdx*/3, // base
     /* 271450 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 271453 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271457 */     GIR_RootConstrainSelectedInstOperands,
     /* 271458 */     // GIR_Coverage, 8808,
     /* 271458 */     GIR_EraseRootFromParent_Done,
     /* 271459 */   // Label 5259: @271459
     /* 271459 */   GIM_Reject,
     /* 271460 */ // Label 5188: @271460
     /* 271460 */ GIM_Try, /*On fail goto*//*Label 5260*/ GIMT_Encode4(274165),
     /* 271465 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/5,
     /* 271468 */   GIM_Try, /*On fail goto*//*Label 5261*/ GIMT_Encode4(271539), // Rule ID 3409 //
     /* 271473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271476 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271481 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 271487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271490 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271510 */     // MIs[1] Operand 1
     /* 271510 */     // No operand predicates
     /* 271510 */     // MIs[0] prfop
     /* 271510 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271513 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271518 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271520 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv4i1] }:$Pg, ZPR32:{ *:[nxv4i32] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_PZI),
     /* 271523 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271529 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271532 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271537 */     GIR_RootConstrainSelectedInstOperands,
     /* 271538 */     // GIR_Coverage, 3409,
     /* 271538 */     GIR_EraseRootFromParent_Done,
     /* 271539 */   // Label 5261: @271539
     /* 271539 */   GIM_Try, /*On fail goto*//*Label 5262*/ GIMT_Encode4(271610), // Rule ID 3422 //
     /* 271544 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271547 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_scalar_offset),
     /* 271552 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271555 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 271558 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 271561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271565 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271569 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 271573 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 271577 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 271581 */     // MIs[1] Operand 1
     /* 271581 */     // No operand predicates
     /* 271581 */     // MIs[0] prfop
     /* 271581 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271584 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271589 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 271591 */     // (intrinsic_void 1643:{ *:[iPTR] }, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_PZI (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR_3b:{ *:[nxv2i1] }:$Pg, ZPR32:{ *:[nxv2i64] }:$Zn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 271591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_PZI),
     /* 271594 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271596 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271598 */     GIR_RootToRootCopy, /*OpIdx*/2, // Zn
     /* 271600 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 271603 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 271608 */     GIR_RootConstrainSelectedInstOperands,
     /* 271609 */     // GIR_Coverage, 3422,
     /* 271609 */     GIR_EraseRootFromParent_Done,
     /* 271610 */   // Label 5262: @271610
     /* 271610 */   GIM_Try, /*On fail goto*//*Label 5263*/ GIMT_Encode4(271669), // Rule ID 3608 //
     /* 271615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271618 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271623 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271626 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271629 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271632 */     // MIs[0] tile
     /* 271632 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271635 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271640 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271644 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271648 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271652 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDHA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_S_PSEUDO_S),
     /* 271655 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271657 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271659 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271661 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271663 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271667 */     GIR_RootConstrainSelectedInstOperands,
     /* 271668 */     // GIR_Coverage, 3608,
     /* 271668 */     GIR_EraseRootFromParent_Done,
     /* 271669 */   // Label 5263: @271669
     /* 271669 */   GIM_Try, /*On fail goto*//*Label 5264*/ GIMT_Encode4(271728), // Rule ID 3609 //
     /* 271674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271677 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addha),
     /* 271682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271688 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271691 */     // MIs[0] tile
     /* 271691 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271694 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271699 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271703 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271707 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271711 */     // (intrinsic_void 804:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDHA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHA_MPPZ_D_PSEUDO_D),
     /* 271714 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271716 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271718 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271720 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271722 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271726 */     GIR_RootConstrainSelectedInstOperands,
     /* 271727 */     // GIR_Coverage, 3609,
     /* 271727 */     GIR_EraseRootFromParent_Done,
     /* 271728 */   // Label 5264: @271728
     /* 271728 */   GIM_Try, /*On fail goto*//*Label 5265*/ GIMT_Encode4(271787), // Rule ID 12638 //
     /* 271733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 271736 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271741 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 271744 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 271747 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 271750 */     // MIs[0] tile
     /* 271750 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271753 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 271758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271766 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271770 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$pn, PPR3bAny:{ *:[nxv4i1] }:$pm, ZPR32:{ *:[nxv4i32] }:$zn)  =>  (ADDVA_MPPZ_S_PSEUDO_S (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, ?:{ *:[nxv4i1] }:$pn, ?:{ *:[nxv4i1] }:$pm, ?:{ *:[nxv4i32] }:$zn)
     /* 271770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_S_PSEUDO_S),
     /* 271773 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271775 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271777 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271779 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271781 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271785 */     GIR_RootConstrainSelectedInstOperands,
     /* 271786 */     // GIR_Coverage, 12638,
     /* 271786 */     GIR_EraseRootFromParent_Done,
     /* 271787 */   // Label 5265: @271787
     /* 271787 */   GIM_Try, /*On fail goto*//*Label 5266*/ GIMT_Encode4(271846), // Rule ID 12639 //
     /* 271792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 271795 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_addva),
     /* 271800 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 271803 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 271806 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 271809 */     // MIs[0] tile
     /* 271809 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 271812 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 271817 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271821 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271825 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271829 */     // (intrinsic_void 805:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$pn, PPR3bAny:{ *:[nxv2i1] }:$pm, ZPR64:{ *:[nxv2i64] }:$zn)  =>  (ADDVA_MPPZ_D_PSEUDO_D (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, ?:{ *:[nxv2i1] }:$pn, ?:{ *:[nxv2i1] }:$pm, ?:{ *:[nxv2i64] }:$zn)
     /* 271829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDVA_MPPZ_D_PSEUDO_D),
     /* 271832 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 271834 */     GIR_RootToRootCopy, /*OpIdx*/2, // pn
     /* 271836 */     GIR_RootToRootCopy, /*OpIdx*/3, // pm
     /* 271838 */     GIR_RootToRootCopy, /*OpIdx*/4, // zn
     /* 271840 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271844 */     GIR_RootConstrainSelectedInstOperands,
     /* 271845 */     // GIR_Coverage, 12639,
     /* 271845 */     GIR_EraseRootFromParent_Done,
     /* 271846 */   // Label 5266: @271846
     /* 271846 */   GIM_Try, /*On fail goto*//*Label 5267*/ GIMT_Encode4(271906), // Rule ID 3407 //
     /* 271851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271854 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 271859 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271862 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271865 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271869 */     // MIs[0] Rn
     /* 271869 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271873 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271877 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271881 */     // MIs[0] prfop
     /* 271881 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271884 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271889 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 271889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_UXTW_SCALED),
     /* 271892 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271894 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271896 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271898 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271900 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271904 */     GIR_RootConstrainSelectedInstOperands,
     /* 271905 */     // GIR_Coverage, 3407,
     /* 271905 */     GIR_EraseRootFromParent_Done,
     /* 271906 */   // Label 5267: @271906
     /* 271906 */   GIM_Try, /*On fail goto*//*Label 5268*/ GIMT_Encode4(271966), // Rule ID 3408 //
     /* 271911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271914 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 271919 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 271922 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 271925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271929 */     // MIs[0] Rn
     /* 271929 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 271941 */     // MIs[0] prfop
     /* 271941 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 271944 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 271949 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW8Only:{ *:[nxv4i32] }:$Zm)
     /* 271949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_S_SXTW_SCALED),
     /* 271952 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 271954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 271956 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 271958 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 271960 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 271964 */     GIR_RootConstrainSelectedInstOperands,
     /* 271965 */     // GIR_Coverage, 3408,
     /* 271965 */     GIR_EraseRootFromParent_Done,
     /* 271966 */   // Label 5268: @271966
     /* 271966 */   GIM_Try, /*On fail goto*//*Label 5269*/ GIMT_Encode4(272026), // Rule ID 3419 //
     /* 271971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 271974 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_uxtw_index),
     /* 271979 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 271982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 271985 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 271989 */     // MIs[0] Rn
     /* 271989 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 271993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 271997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272001 */     // MIs[0] prfop
     /* 272001 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272004 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272009 */     // (intrinsic_void 1645:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_UXTW_SCALED),
     /* 272012 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272014 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272016 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272018 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272024 */     GIR_RootConstrainSelectedInstOperands,
     /* 272025 */     // GIR_Coverage, 3419,
     /* 272025 */     GIR_EraseRootFromParent_Done,
     /* 272026 */   // Label 5269: @272026
     /* 272026 */   GIM_Try, /*On fail goto*//*Label 5270*/ GIMT_Encode4(272086), // Rule ID 3420 //
     /* 272031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_sxtw_index),
     /* 272039 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272042 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272049 */     // MIs[0] Rn
     /* 272049 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272053 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272057 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272061 */     // MIs[0] prfop
     /* 272061 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272064 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272069 */     // (intrinsic_void 1644:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW8Only:{ *:[nxv2i64] }:$Zm)
     /* 272069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SXTW_SCALED),
     /* 272072 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272074 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272076 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272078 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272080 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272084 */     GIR_RootConstrainSelectedInstOperands,
     /* 272085 */     // GIR_Coverage, 3420,
     /* 272085 */     GIR_EraseRootFromParent_Done,
     /* 272086 */   // Label 5270: @272086
     /* 272086 */   GIM_Try, /*On fail goto*//*Label 5271*/ GIMT_Encode4(272146), // Rule ID 3421 //
     /* 272091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272094 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfb_gather_index),
     /* 272099 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272102 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272109 */     // MIs[0] Rn
     /* 272109 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272113 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272117 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272121 */     // MIs[0] prfop
     /* 272121 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272124 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272129 */     // (intrinsic_void 1642:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFB_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL8:{ *:[nxv2i64] }:$Zm)
     /* 272129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFB_D_SCALED),
     /* 272132 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272134 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272136 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272140 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272144 */     GIR_RootConstrainSelectedInstOperands,
     /* 272145 */     // GIR_Coverage, 3421,
     /* 272145 */     GIR_EraseRootFromParent_Done,
     /* 272146 */   // Label 5271: @272146
     /* 272146 */   GIM_Try, /*On fail goto*//*Label 5272*/ GIMT_Encode4(272206), // Rule ID 8913 //
     /* 272151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272154 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272159 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272162 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272165 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272169 */     // MIs[0] Rn
     /* 272169 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272173 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272177 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272181 */     // MIs[0] prfop
     /* 272181 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272184 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272189 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_UXTW_SCALED),
     /* 272192 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272198 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272200 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272204 */     GIR_RootConstrainSelectedInstOperands,
     /* 272205 */     // GIR_Coverage, 8913,
     /* 272205 */     GIR_EraseRootFromParent_Done,
     /* 272206 */   // Label 5272: @272206
     /* 272206 */   GIM_Try, /*On fail goto*//*Label 5273*/ GIMT_Encode4(272266), // Rule ID 8914 //
     /* 272211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272214 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272219 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272222 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272225 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272229 */     // MIs[0] Rn
     /* 272229 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272233 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272237 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272241 */     // MIs[0] prfop
     /* 272241 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272244 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272249 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW16:{ *:[nxv4i32] }:$Zm)
     /* 272249 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_S_SXTW_SCALED),
     /* 272252 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272254 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272260 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272264 */     GIR_RootConstrainSelectedInstOperands,
     /* 272265 */     // GIR_Coverage, 8914,
     /* 272265 */     GIR_EraseRootFromParent_Done,
     /* 272266 */   // Label 5273: @272266
     /* 272266 */   GIM_Try, /*On fail goto*//*Label 5274*/ GIMT_Encode4(272326), // Rule ID 8915 //
     /* 272271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272274 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272279 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272282 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272285 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272289 */     // MIs[0] Rn
     /* 272289 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272301 */     // MIs[0] prfop
     /* 272301 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272304 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272309 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_UXTW_SCALED),
     /* 272312 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272314 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272316 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272318 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272320 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272324 */     GIR_RootConstrainSelectedInstOperands,
     /* 272325 */     // GIR_Coverage, 8915,
     /* 272325 */     GIR_EraseRootFromParent_Done,
     /* 272326 */   // Label 5274: @272326
     /* 272326 */   GIM_Try, /*On fail goto*//*Label 5275*/ GIMT_Encode4(272386), // Rule ID 8916 //
     /* 272331 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272334 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272339 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272342 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272345 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272349 */     // MIs[0] Rn
     /* 272349 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272357 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272361 */     // MIs[0] prfop
     /* 272361 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272364 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272369 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW32:{ *:[nxv4i32] }:$Zm)
     /* 272369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_S_SXTW_SCALED),
     /* 272372 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272374 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272378 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272380 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272384 */     GIR_RootConstrainSelectedInstOperands,
     /* 272385 */     // GIR_Coverage, 8916,
     /* 272385 */     GIR_EraseRootFromParent_Done,
     /* 272386 */   // Label 5275: @272386
     /* 272386 */   GIM_Try, /*On fail goto*//*Label 5276*/ GIMT_Encode4(272446), // Rule ID 8917 //
     /* 272391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272394 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272399 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272402 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272405 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272409 */     // MIs[0] Rn
     /* 272409 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272421 */     // MIs[0] prfop
     /* 272421 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272424 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272429 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtUXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_UXTW_SCALED),
     /* 272432 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272434 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272436 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272440 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272444 */     GIR_RootConstrainSelectedInstOperands,
     /* 272445 */     // GIR_Coverage, 8917,
     /* 272445 */     GIR_EraseRootFromParent_Done,
     /* 272446 */   // Label 5276: @272446
     /* 272446 */   GIM_Try, /*On fail goto*//*Label 5277*/ GIMT_Encode4(272506), // Rule ID 8918 //
     /* 272451 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272454 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272459 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 272462 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 272465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272469 */     // MIs[0] Rn
     /* 272469 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272473 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272481 */     // MIs[0] prfop
     /* 272481 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272484 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272489 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_S_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv4i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR32ExtSXTW64:{ *:[nxv4i32] }:$Zm)
     /* 272489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_S_SXTW_SCALED),
     /* 272492 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272496 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272498 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272500 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272504 */     GIR_RootConstrainSelectedInstOperands,
     /* 272505 */     // GIR_Coverage, 8918,
     /* 272505 */     GIR_EraseRootFromParent_Done,
     /* 272506 */   // Label 5277: @272506
     /* 272506 */   GIM_Try, /*On fail goto*//*Label 5278*/ GIMT_Encode4(272566), // Rule ID 8919 //
     /* 272511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272514 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_uxtw_index),
     /* 272519 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272525 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272529 */     // MIs[0] Rn
     /* 272529 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272533 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272537 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272541 */     // MIs[0] prfop
     /* 272541 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272544 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272549 */     // (intrinsic_void 1653:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272549 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_UXTW_SCALED),
     /* 272552 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272554 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272560 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272564 */     GIR_RootConstrainSelectedInstOperands,
     /* 272565 */     // GIR_Coverage, 8919,
     /* 272565 */     GIR_EraseRootFromParent_Done,
     /* 272566 */   // Label 5278: @272566
     /* 272566 */   GIM_Try, /*On fail goto*//*Label 5279*/ GIMT_Encode4(272626), // Rule ID 8920 //
     /* 272571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272574 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_sxtw_index),
     /* 272579 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272582 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272585 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272589 */     // MIs[0] Rn
     /* 272589 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272597 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272601 */     // MIs[0] prfop
     /* 272601 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272604 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272609 */     // (intrinsic_void 1652:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW16:{ *:[nxv2i64] }:$Zm)
     /* 272609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SXTW_SCALED),
     /* 272612 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272614 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272616 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272618 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272624 */     GIR_RootConstrainSelectedInstOperands,
     /* 272625 */     // GIR_Coverage, 8920,
     /* 272625 */     GIR_EraseRootFromParent_Done,
     /* 272626 */   // Label 5279: @272626
     /* 272626 */   GIM_Try, /*On fail goto*//*Label 5280*/ GIMT_Encode4(272686), // Rule ID 8921 //
     /* 272631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_uxtw_index),
     /* 272639 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272642 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272645 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272649 */     // MIs[0] Rn
     /* 272649 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272661 */     // MIs[0] prfop
     /* 272661 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272664 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272669 */     // (intrinsic_void 1657:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_UXTW_SCALED),
     /* 272672 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272676 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272678 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272680 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272684 */     GIR_RootConstrainSelectedInstOperands,
     /* 272685 */     // GIR_Coverage, 8921,
     /* 272685 */     GIR_EraseRootFromParent_Done,
     /* 272686 */   // Label 5280: @272686
     /* 272686 */   GIM_Try, /*On fail goto*//*Label 5281*/ GIMT_Encode4(272746), // Rule ID 8922 //
     /* 272691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272694 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_sxtw_index),
     /* 272699 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272702 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272705 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272709 */     // MIs[0] Rn
     /* 272709 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272713 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272717 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272721 */     // MIs[0] prfop
     /* 272721 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272724 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272729 */     // (intrinsic_void 1656:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW32:{ *:[nxv2i64] }:$Zm)
     /* 272729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SXTW_SCALED),
     /* 272732 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272736 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272740 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272744 */     GIR_RootConstrainSelectedInstOperands,
     /* 272745 */     // GIR_Coverage, 8922,
     /* 272745 */     GIR_EraseRootFromParent_Done,
     /* 272746 */   // Label 5281: @272746
     /* 272746 */   GIM_Try, /*On fail goto*//*Label 5282*/ GIMT_Encode4(272806), // Rule ID 8923 //
     /* 272751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272754 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_uxtw_index),
     /* 272759 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272762 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272765 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272769 */     // MIs[0] Rn
     /* 272769 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272773 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272777 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272781 */     // MIs[0] prfop
     /* 272781 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272784 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272789 */     // (intrinsic_void 1649:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_UXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtUXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_UXTW_SCALED),
     /* 272792 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272796 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272798 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272800 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272804 */     GIR_RootConstrainSelectedInstOperands,
     /* 272805 */     // GIR_Coverage, 8923,
     /* 272805 */     GIR_EraseRootFromParent_Done,
     /* 272806 */   // Label 5282: @272806
     /* 272806 */   GIM_Try, /*On fail goto*//*Label 5283*/ GIMT_Encode4(272866), // Rule ID 8924 //
     /* 272811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272814 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_sxtw_index),
     /* 272819 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272822 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272825 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272829 */     // MIs[0] Rn
     /* 272829 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272841 */     // MIs[0] prfop
     /* 272841 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272844 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272849 */     // (intrinsic_void 1648:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SXTW_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtSXTW64:{ *:[nxv2i64] }:$Zm)
     /* 272849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SXTW_SCALED),
     /* 272852 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272860 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272864 */     GIR_RootConstrainSelectedInstOperands,
     /* 272865 */     // GIR_Coverage, 8924,
     /* 272865 */     GIR_EraseRootFromParent_Done,
     /* 272866 */   // Label 5283: @272866
     /* 272866 */   GIM_Try, /*On fail goto*//*Label 5284*/ GIMT_Encode4(272926), // Rule ID 8925 //
     /* 272871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272874 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfh_gather_index),
     /* 272879 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272889 */     // MIs[0] Rn
     /* 272889 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272897 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272901 */     // MIs[0] prfop
     /* 272901 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272904 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272909 */     // (intrinsic_void 1650:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFH_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL16:{ *:[nxv2i64] }:$Zm)
     /* 272909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFH_D_SCALED),
     /* 272912 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272914 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272918 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272920 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272924 */     GIR_RootConstrainSelectedInstOperands,
     /* 272925 */     // GIR_Coverage, 8925,
     /* 272925 */     GIR_EraseRootFromParent_Done,
     /* 272926 */   // Label 5284: @272926
     /* 272926 */   GIM_Try, /*On fail goto*//*Label 5285*/ GIMT_Encode4(272986), // Rule ID 8926 //
     /* 272931 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272934 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfw_gather_index),
     /* 272939 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 272942 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 272945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 272949 */     // MIs[0] Rn
     /* 272949 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 272953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 272957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 272961 */     // MIs[0] prfop
     /* 272961 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 272964 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 272969 */     // (intrinsic_void 1654:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFW_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL32:{ *:[nxv2i64] }:$Zm)
     /* 272969 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFW_D_SCALED),
     /* 272972 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 272974 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 272976 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 272978 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 272980 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 272984 */     GIR_RootConstrainSelectedInstOperands,
     /* 272985 */     // GIR_Coverage, 8926,
     /* 272985 */     GIR_EraseRootFromParent_Done,
     /* 272986 */   // Label 5285: @272986
     /* 272986 */   GIM_Try, /*On fail goto*//*Label 5286*/ GIMT_Encode4(273046), // Rule ID 8927 //
     /* 272991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE),
     /* 272994 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sve_prfd_gather_index),
     /* 272999 */     GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 273002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 273005 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 273009 */     // MIs[0] Rn
     /* 273009 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/2, /*SizeInBits*/64,
     /* 273013 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 273017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273021 */     // MIs[0] prfop
     /* 273021 */     GIM_CheckIsImm, /*MI*/0, /*Op*/4,
     /* 273024 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_prfop),
     /* 273029 */     // (intrinsic_void 1646:{ *:[iPTR] }, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm, (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop)  =>  (PRFD_D_SCALED (timm:{ *:[i32] })<<P:Predicate_sve_prfop>>:$prfop, PPR3bAny:{ *:[nxv2i1] }:$Pg, GPR64sp:{ *:[i64] }:$Rn, ZPR64ExtLSL64:{ *:[nxv2i64] }:$Zm)
     /* 273029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFD_D_SCALED),
     /* 273032 */     GIR_RootToRootCopy, /*OpIdx*/4, // prfop
     /* 273034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Pg
     /* 273036 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 273038 */     GIR_RootToRootCopy, /*OpIdx*/3, // Zm
     /* 273040 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273044 */     GIR_RootConstrainSelectedInstOperands,
     /* 273045 */     // GIR_Coverage, 8927,
     /* 273045 */     GIR_EraseRootFromParent_Done,
     /* 273046 */   // Label 5286: @273046
     /* 273046 */   GIM_Try, /*On fail goto*//*Label 5287*/ GIMT_Encode4(273104), // Rule ID 2374 //
     /* 273051 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273054 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb),
     /* 273059 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273062 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273065 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273068 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273071 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273075 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273079 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273083 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273087 */     // (intrinsic_w_chain:{ *:[v8f16] } 626:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBv8f16),
     /* 273090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273096 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273098 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273102 */     GIR_RootConstrainSelectedInstOperands,
     /* 273103 */     // GIR_Coverage, 2374,
     /* 273103 */     GIR_EraseRootFromParent_Done,
     /* 273104 */   // Label 5287: @273104
     /* 273104 */   GIM_Try, /*On fail goto*//*Label 5288*/ GIMT_Encode4(273162), // Rule ID 2375 //
     /* 273109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273112 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt),
     /* 273117 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273126 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273129 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273133 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273137 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273141 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273145 */     // (intrinsic_w_chain:{ *:[v8f16] } 636:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273145 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTv8f16),
     /* 273148 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273150 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273152 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273154 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273156 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273160 */     GIR_RootConstrainSelectedInstOperands,
     /* 273161 */     // GIR_Coverage, 2375,
     /* 273161 */     GIR_EraseRootFromParent_Done,
     /* 273162 */   // Label 5288: @273162
     /* 273162 */   GIM_Try, /*On fail goto*//*Label 5289*/ GIMT_Encode4(273220), // Rule ID 2376 //
     /* 273167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273170 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb),
     /* 273175 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273178 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273181 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273184 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273187 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273191 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273195 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273199 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273203 */     // (intrinsic_w_chain:{ *:[v4f32] } 628:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBv4f32),
     /* 273206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273208 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273212 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273214 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273218 */     GIR_RootConstrainSelectedInstOperands,
     /* 273219 */     // GIR_Coverage, 2376,
     /* 273219 */     GIR_EraseRootFromParent_Done,
     /* 273220 */   // Label 5289: @273220
     /* 273220 */   GIM_Try, /*On fail goto*//*Label 5290*/ GIMT_Encode4(273278), // Rule ID 2377 //
     /* 273225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273228 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt),
     /* 273233 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273236 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273239 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273242 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273245 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273249 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273253 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273257 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273261 */     // (intrinsic_w_chain:{ *:[v4f32] } 630:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLBTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273261 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTv4f32),
     /* 273264 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273266 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273270 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273272 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273276 */     GIR_RootConstrainSelectedInstOperands,
     /* 273277 */     // GIR_Coverage, 2377,
     /* 273277 */     GIR_EraseRootFromParent_Done,
     /* 273278 */   // Label 5290: @273278
     /* 273278 */   GIM_Try, /*On fail goto*//*Label 5291*/ GIMT_Encode4(273336), // Rule ID 2378 //
     /* 273283 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273286 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb),
     /* 273291 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273294 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273297 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273300 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273303 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273315 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273319 */     // (intrinsic_w_chain:{ *:[v4f32] } 632:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273319 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBv4f32),
     /* 273322 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273324 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273328 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273330 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273334 */     GIR_RootConstrainSelectedInstOperands,
     /* 273335 */     // GIR_Coverage, 2378,
     /* 273335 */     GIR_EraseRootFromParent_Done,
     /* 273336 */   // Label 5291: @273336
     /* 273336 */   GIM_Try, /*On fail goto*//*Label 5292*/ GIMT_Encode4(273394), // Rule ID 2379 //
     /* 273341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 273344 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt),
     /* 273349 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273358 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273361 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273365 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273369 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273373 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273377 */     // (intrinsic_w_chain:{ *:[v4f32] } 634:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FMLALLTTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTv4f32),
     /* 273380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273382 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273386 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273388 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273392 */     GIR_RootConstrainSelectedInstOperands,
     /* 273393 */     // GIR_Coverage, 2379,
     /* 273393 */     GIR_EraseRootFromParent_Done,
     /* 273394 */   // Label 5292: @273394
     /* 273394 */   GIM_Try, /*On fail goto*//*Label 5293*/ GIMT_Encode4(273452), // Rule ID 2380 //
     /* 273399 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273402 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273407 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 273410 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 273413 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273416 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273419 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273431 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273435 */     // (intrinsic_w_chain:{ *:[v4f16] } 622:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f16),
     /* 273438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273444 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273446 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273450 */     GIR_RootConstrainSelectedInstOperands,
     /* 273451 */     // GIR_Coverage, 2380,
     /* 273451 */     GIR_EraseRootFromParent_Done,
     /* 273452 */   // Label 5293: @273452
     /* 273452 */   GIM_Try, /*On fail goto*//*Label 5294*/ GIMT_Encode4(273510), // Rule ID 2381 //
     /* 273457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 273460 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2),
     /* 273465 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 273468 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 273471 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273474 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273477 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273481 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273489 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273493 */     // (intrinsic_w_chain:{ *:[v8f16] } 622:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273493 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv8f16),
     /* 273496 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273498 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273500 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273502 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273504 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273508 */     GIR_RootConstrainSelectedInstOperands,
     /* 273509 */     // GIR_Coverage, 2381,
     /* 273509 */     GIR_EraseRootFromParent_Done,
     /* 273510 */   // Label 5294: @273510
     /* 273510 */   GIM_Try, /*On fail goto*//*Label 5295*/ GIMT_Encode4(273568), // Rule ID 2382 //
     /* 273515 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273518 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273523 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 273526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 273529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 273532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v8s8,
     /* 273535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273539 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273543 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273547 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 273551 */     // (intrinsic_w_chain:{ *:[v2f32] } 624:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (FDOTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 273551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv2f32),
     /* 273554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273556 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273560 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273562 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273566 */     GIR_RootConstrainSelectedInstOperands,
     /* 273567 */     // GIR_Coverage, 2382,
     /* 273567 */     GIR_EraseRootFromParent_Done,
     /* 273568 */   // Label 5295: @273568
     /* 273568 */   GIM_Try, /*On fail goto*//*Label 5296*/ GIMT_Encode4(273626), // Rule ID 2383 //
     /* 273573 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 273576 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4),
     /* 273581 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 273584 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 273587 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 273590 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 273593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273605 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273609 */     // (intrinsic_w_chain:{ *:[v4f32] } 624:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (FDOTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 273609 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTv4f32),
     /* 273612 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 273616 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273618 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273620 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273624 */     GIR_RootConstrainSelectedInstOperands,
     /* 273625 */     // GIR_Coverage, 2383,
     /* 273625 */     GIR_EraseRootFromParent_Done,
     /* 273626 */   // Label 5296: @273626
     /* 273626 */   GIM_Try, /*On fail goto*//*Label 5297*/ GIMT_Encode4(273684), // Rule ID 2487 //
     /* 273631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8),
     /* 273634 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fcvtn2),
     /* 273639 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v16s8,
     /* 273642 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 273645 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 273648 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v4s32,
     /* 273651 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273655 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273659 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273663 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 273667 */     // (intrinsic_w_chain:{ *:[v16i8] } 621:{ *:[iPTR] }, V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCVTN_F322v16f8:{ *:[v16i8] } V128:{ *:[v16i8] }:$_Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 273667 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTN_F322v16f8),
     /* 273670 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 273672 */     GIR_RootToRootCopy, /*OpIdx*/2, // _Rd
     /* 273674 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 273676 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 273678 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273682 */     GIR_RootConstrainSelectedInstOperands,
     /* 273683 */     // GIR_Coverage, 2487,
     /* 273683 */     GIR_EraseRootFromParent_Done,
     /* 273684 */   // Label 5297: @273684
     /* 273684 */   GIM_Try, /*On fail goto*//*Label 5298*/ GIMT_Encode4(273740), // Rule ID 13197 //
     /* 273689 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stlxp),
     /* 273694 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273697 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273700 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273703 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273707 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273711 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273715 */     // MIs[0] addr
     /* 273715 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273719 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273723 */     // (intrinsic_w_chain:{ *:[i32] } 1245:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STLXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273723 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STLXPX),
     /* 273726 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273728 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273730 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273732 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273734 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273738 */     GIR_RootConstrainSelectedInstOperands,
     /* 273739 */     // GIR_Coverage, 13197,
     /* 273739 */     GIR_EraseRootFromParent_Done,
     /* 273740 */   // Label 5298: @273740
     /* 273740 */   GIM_Try, /*On fail goto*//*Label 5299*/ GIMT_Encode4(273796), // Rule ID 13198 //
     /* 273745 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_stxp),
     /* 273750 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s32,
     /* 273753 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 273756 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 273759 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 273763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273771 */     // MIs[0] addr
     /* 273771 */     GIM_CheckPointerToAny, /*MI*/0, /*Op*/4, /*SizeInBits*/64,
     /* 273775 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 273779 */     // (intrinsic_w_chain:{ *:[i32] } 1247:{ *:[iPTR] }, GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)  =>  (STXPX:{ *:[i32] } GPR64:{ *:[i64] }:$lo, GPR64:{ *:[i64] }:$hi, GPR64:{ *:[i64] }:$addr)
     /* 273779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::STXPX),
     /* 273782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Ws]
     /* 273784 */     GIR_RootToRootCopy, /*OpIdx*/2, // lo
     /* 273786 */     GIR_RootToRootCopy, /*OpIdx*/3, // hi
     /* 273788 */     GIR_RootToRootCopy, /*OpIdx*/4, // addr
     /* 273790 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273794 */     GIR_RootConstrainSelectedInstOperands,
     /* 273795 */     // GIR_Coverage, 13198,
     /* 273795 */     GIR_EraseRootFromParent_Done,
     /* 273796 */   // Label 5299: @273796
     /* 273796 */   GIM_Try, /*On fail goto*//*Label 5300*/ GIMT_Encode4(273842), // Rule ID 3454 //
     /* 273801 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 273804 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 273809 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273812 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273815 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273818 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273821 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273825 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1510:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273825 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoH),
     /* 273828 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273830 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273832 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273834 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273836 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273840 */     GIR_RootConstrainSelectedInstOperands,
     /* 273841 */     // GIR_Coverage, 3454,
     /* 273841 */     GIR_EraseRootFromParent_Done,
     /* 273842 */   // Label 5300: @273842
     /* 273842 */   GIM_Try, /*On fail goto*//*Label 5301*/ GIMT_Encode4(273888), // Rule ID 3576 //
     /* 273847 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273850 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb),
     /* 273855 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273858 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273861 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273864 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273871 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1512:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALB_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZ),
     /* 273874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273880 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273882 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273886 */     GIR_RootConstrainSelectedInstOperands,
     /* 273887 */     // GIR_Coverage, 3576,
     /* 273887 */     GIR_EraseRootFromParent_Done,
     /* 273888 */   // Label 5301: @273888
     /* 273888 */   GIM_Try, /*On fail goto*//*Label 5302*/ GIMT_Encode4(273934), // Rule ID 12625 //
     /* 273893 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273896 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt),
     /* 273901 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 273904 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 273907 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273910 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273917 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1522:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALT_ZZZ:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273917 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZ),
     /* 273920 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273922 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273926 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273928 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273932 */     GIR_RootConstrainSelectedInstOperands,
     /* 273933 */     // GIR_Coverage, 12625,
     /* 273933 */     GIR_EraseRootFromParent_Done,
     /* 273934 */   // Label 5302: @273934
     /* 273934 */   GIM_Try, /*On fail goto*//*Label 5303*/ GIMT_Encode4(273980), // Rule ID 12629 //
     /* 273939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273942 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb),
     /* 273947 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273950 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 273953 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 273956 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 273959 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 273963 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1514:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 273963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZ),
     /* 273966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 273968 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 273970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 273972 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 273974 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 273978 */     GIR_RootConstrainSelectedInstOperands,
     /* 273979 */     // GIR_Coverage, 12629,
     /* 273979 */     GIR_EraseRootFromParent_Done,
     /* 273980 */   // Label 5303: @273980
     /* 273980 */   GIM_Try, /*On fail goto*//*Label 5304*/ GIMT_Encode4(274026), // Rule ID 12630 //
     /* 273985 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 273988 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt),
     /* 273993 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 273996 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 273999 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274002 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274009 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1516:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLBT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274009 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZ),
     /* 274012 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274014 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274016 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274018 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274020 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274024 */     GIR_RootConstrainSelectedInstOperands,
     /* 274025 */     // GIR_Coverage, 12630,
     /* 274025 */     GIR_EraseRootFromParent_Done,
     /* 274026 */   // Label 5304: @274026
     /* 274026 */   GIM_Try, /*On fail goto*//*Label 5305*/ GIMT_Encode4(274072), // Rule ID 12631 //
     /* 274031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274034 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb),
     /* 274039 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274042 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274045 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274048 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274055 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1518:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTB_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZ),
     /* 274058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274062 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274064 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274066 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274070 */     GIR_RootConstrainSelectedInstOperands,
     /* 274071 */     // GIR_Coverage, 12631,
     /* 274071 */     GIR_EraseRootFromParent_Done,
     /* 274072 */   // Label 5305: @274072
     /* 274072 */   GIM_Try, /*On fail goto*//*Label 5306*/ GIMT_Encode4(274118), // Rule ID 12632 //
     /* 274077 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 274080 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt),
     /* 274085 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274088 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274091 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274094 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274097 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274101 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1520:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FMLALLTT_ZZZ:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZ),
     /* 274104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274106 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274110 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274112 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274116 */     GIR_RootConstrainSelectedInstOperands,
     /* 274117 */     // GIR_Coverage, 12632,
     /* 274117 */     GIR_EraseRootFromParent_Done,
     /* 274118 */   // Label 5306: @274118
     /* 274118 */   GIM_Try, /*On fail goto*//*Label 5307*/ GIMT_Encode4(274164), // Rule ID 12633 //
     /* 274123 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 274126 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot),
     /* 274131 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 274134 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 274137 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 274140 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274143 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 274147 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1510:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (FDOT_ZZZ_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 274147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZ_BtoS),
     /* 274150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 274152 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 274154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 274156 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 274158 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274162 */     GIR_RootConstrainSelectedInstOperands,
     /* 274163 */     // GIR_Coverage, 12633,
     /* 274163 */     GIR_EraseRootFromParent_Done,
     /* 274164 */   // Label 5307: @274164
     /* 274164 */   GIM_Reject,
     /* 274165 */ // Label 5260: @274165
     /* 274165 */ GIM_Try, /*On fail goto*//*Label 5308*/ GIMT_Encode4(277158),
     /* 274170 */   GIM_CheckNumOperands, /*MI*/0, /*Expected*/6,
     /* 274173 */   GIM_Try, /*On fail goto*//*Label 5309*/ GIMT_Encode4(274241), // Rule ID 2514 //
     /* 274178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalb_lane),
     /* 274186 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274195 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274198 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274206 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274210 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274214 */     // MIs[0] Idx
     /* 274214 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274217 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274222 */     // (intrinsic_w_chain:{ *:[v8f16] } 627:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALBlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALBlanev8f16),
     /* 274225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274229 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274231 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274233 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274235 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274239 */     GIR_RootConstrainSelectedInstOperands,
     /* 274240 */     // GIR_Coverage, 2514,
     /* 274240 */     GIR_EraseRootFromParent_Done,
     /* 274241 */   // Label 5309: @274241
     /* 274241 */   GIM_Try, /*On fail goto*//*Label 5310*/ GIMT_Encode4(274309), // Rule ID 2515 //
     /* 274246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274249 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbb_lane),
     /* 274254 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274263 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274266 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274274 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274278 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274282 */     // MIs[0] Idx
     /* 274282 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274285 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274290 */     // (intrinsic_w_chain:{ *:[v4f32] } 629:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBBlanev4f32),
     /* 274293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274295 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274299 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274301 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274303 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274307 */     GIR_RootConstrainSelectedInstOperands,
     /* 274308 */     // GIR_Coverage, 2515,
     /* 274308 */     GIR_EraseRootFromParent_Done,
     /* 274309 */   // Label 5310: @274309
     /* 274309 */   GIM_Try, /*On fail goto*//*Label 5311*/ GIMT_Encode4(274377), // Rule ID 2516 //
     /* 274314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274317 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274322 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s32,
     /* 274325 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 274328 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274331 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274334 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274338 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274342 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274346 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274350 */     // MIs[0] Idx
     /* 274350 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274353 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274358 */     // (intrinsic_w_chain:{ *:[v2f32] } 625:{ *:[iPTR] }, V64:{ *:[v2f32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev2f32:{ *:[v2f32] } ?:{ *:[v2f32] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev2f32),
     /* 274361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274363 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274367 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274369 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274371 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274375 */     GIR_RootConstrainSelectedInstOperands,
     /* 274376 */     // GIR_Coverage, 2516,
     /* 274376 */     GIR_EraseRootFromParent_Done,
     /* 274377 */   // Label 5311: @274377
     /* 274377 */   GIM_Try, /*On fail goto*//*Label 5312*/ GIMT_Encode4(274445), // Rule ID 2517 //
     /* 274382 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT4),
     /* 274385 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot4_lane),
     /* 274390 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274399 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274406 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274410 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274414 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274418 */     // MIs[0] Idx
     /* 274418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS32b_timm),
     /* 274426 */     // (intrinsic_w_chain:{ *:[v4f32] } 625:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexS32b_timm>>:$Idx)  =>  (FDOTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f32),
     /* 274429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274433 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274435 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274437 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274439 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274443 */     GIR_RootConstrainSelectedInstOperands,
     /* 274444 */     // GIR_Coverage, 2517,
     /* 274444 */     GIR_EraseRootFromParent_Done,
     /* 274445 */   // Label 5312: @274445
     /* 274445 */   GIM_Try, /*On fail goto*//*Label 5313*/ GIMT_Encode4(274513), // Rule ID 2518 //
     /* 274450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274453 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274458 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s16,
     /* 274461 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 274464 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 274467 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274470 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274474 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 274482 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274486 */     // MIs[0] Idx
     /* 274486 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274489 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274494 */     // (intrinsic_w_chain:{ *:[v4f16] } 623:{ *:[iPTR] }, V64:{ *:[v4f16] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev4f16:{ *:[v4f16] } ?:{ *:[v4f16] }:$Rd, ?:{ *:[v8i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev4f16),
     /* 274497 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274511 */     GIR_RootConstrainSelectedInstOperands,
     /* 274512 */     // GIR_Coverage, 2518,
     /* 274512 */     GIR_EraseRootFromParent_Done,
     /* 274513 */   // Label 5313: @274513
     /* 274513 */   GIM_Try, /*On fail goto*//*Label 5314*/ GIMT_Encode4(274581), // Rule ID 2519 //
     /* 274518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8DOT2),
     /* 274521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fdot2_lane),
     /* 274526 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274535 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274538 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274542 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274546 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274550 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 274554 */     // MIs[0] Idx
     /* 274554 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274557 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH32b_timm),
     /* 274562 */     // (intrinsic_w_chain:{ *:[v8f16] } 623:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_lo:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexH32b_timm>>:$Idx)  =>  (FDOTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOTlanev8f16),
     /* 274565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274571 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274573 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274575 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274579 */     GIR_RootConstrainSelectedInstOperands,
     /* 274580 */     // GIR_Coverage, 2519,
     /* 274580 */     GIR_EraseRootFromParent_Done,
     /* 274581 */   // Label 5314: @274581
     /* 274581 */   GIM_Try, /*On fail goto*//*Label 5315*/ GIMT_Encode4(274649), // Rule ID 7023 //
     /* 274586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274589 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalt_lane),
     /* 274594 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v8s16,
     /* 274597 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 274600 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274603 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274606 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274618 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274622 */     // MIs[0] Idx
     /* 274622 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274625 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274630 */     // (intrinsic_w_chain:{ *:[v8f16] } 637:{ *:[iPTR] }, V128:{ *:[v8f16] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALTlanev8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274630 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALTlanev8f16),
     /* 274633 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274635 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274637 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274639 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274641 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274643 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274647 */     GIR_RootConstrainSelectedInstOperands,
     /* 274648 */     // GIR_Coverage, 7023,
     /* 274648 */     GIR_EraseRootFromParent_Done,
     /* 274649 */   // Label 5315: @274649
     /* 274649 */   GIM_Try, /*On fail goto*//*Label 5316*/ GIMT_Encode4(274717), // Rule ID 7024 //
     /* 274654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274657 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlallbt_lane),
     /* 274662 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274665 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274668 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274671 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274674 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274678 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274682 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274686 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274690 */     // MIs[0] Idx
     /* 274690 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274693 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274698 */     // (intrinsic_w_chain:{ *:[v4f32] } 631:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLBTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274698 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBTlanev4f32),
     /* 274701 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274703 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274707 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274709 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274711 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274715 */     GIR_RootConstrainSelectedInstOperands,
     /* 274716 */     // GIR_Coverage, 7024,
     /* 274716 */     GIR_EraseRootFromParent_Done,
     /* 274717 */   // Label 5316: @274717
     /* 274717 */   GIM_Try, /*On fail goto*//*Label 5317*/ GIMT_Encode4(274785), // Rule ID 7025 //
     /* 274722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274725 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltb_lane),
     /* 274730 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274733 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274736 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274739 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274742 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274754 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274758 */     // MIs[0] Idx
     /* 274758 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274761 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274766 */     // (intrinsic_w_chain:{ *:[v4f32] } 633:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTBlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274766 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTBlanev4f32),
     /* 274769 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274771 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274773 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274775 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274777 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274779 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274783 */     GIR_RootConstrainSelectedInstOperands,
     /* 274784 */     // GIR_Coverage, 7025,
     /* 274784 */     GIR_EraseRootFromParent_Done,
     /* 274785 */   // Label 5317: @274785
     /* 274785 */   GIM_Try, /*On fail goto*//*Label 5318*/ GIMT_Encode4(274853), // Rule ID 7026 //
     /* 274790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFP8FMA),
     /* 274793 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_fp8_fmlalltt_lane),
     /* 274798 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v4s32,
     /* 274801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 274804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 274807 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_v16s8,
     /* 274810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 274822 */     GIM_RootCheckRegBankForClass, /*Op*/4, /*RC*/GIMT_Encode2(AArch64::FPR128_0to7RegClassID),
     /* 274826 */     // MIs[0] Idx
     /* 274826 */     GIM_CheckIsImm, /*MI*/0, /*Op*/5,
     /* 274829 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/5, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB32b_timm),
     /* 274834 */     // (intrinsic_w_chain:{ *:[v4f32] } 635:{ *:[iPTR] }, V128:{ *:[v4f32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128_0to7:{ *:[v16i8] }:$Rm, (timm:{ *:[i32] })<<P:Predicate_VectorIndexB32b_timm>>:$Idx)  =>  (FMLALLTTlanev4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rd, ?:{ *:[v16i8] }:$Rn, ?:{ *:[v16i8] }:$Rm, ?:{ *:[i32] }:$Idx)
     /* 274834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTTlanev4f32),
     /* 274837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 274839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 274841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 274843 */     GIR_RootToRootCopy, /*OpIdx*/4, // Rm
     /* 274845 */     GIR_RootToRootCopy, /*OpIdx*/5, // Idx
     /* 274847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274851 */     GIR_RootConstrainSelectedInstOperands,
     /* 274852 */     // GIR_Coverage, 7026,
     /* 274852 */     GIR_EraseRootFromParent_Done,
     /* 274853 */   // Label 5318: @274853
     /* 274853 */   GIM_Try, /*On fail goto*//*Label 5319*/ GIMT_Encode4(274913), // Rule ID 3588 //
     /* 274858 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 274861 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 274866 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 274869 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 274872 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 274875 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 274878 */     // MIs[0] tile
     /* 274878 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274881 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274886 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274890 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274894 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 274894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_S_PSEUDO),
     /* 274897 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274899 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274901 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274903 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274905 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274907 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274911 */     GIR_RootConstrainSelectedInstOperands,
     /* 274912 */     // GIR_Coverage, 3588,
     /* 274912 */     GIR_EraseRootFromParent_Done,
     /* 274913 */   // Label 5319: @274913
     /* 274913 */   GIM_Try, /*On fail goto*//*Label 5320*/ GIMT_Encode4(274973), // Rule ID 3589 //
     /* 274918 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F32),
     /* 274921 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za32),
     /* 274926 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 274929 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 274932 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 274935 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 274938 */     // MIs[0] tile
     /* 274938 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 274941 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 274946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 274954 */     // (intrinsic_void 887:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 274954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoS_PSEUDO),
     /* 274957 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 274959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 274961 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 274963 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 274965 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 274967 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 274971 */     GIR_RootConstrainSelectedInstOperands,
     /* 274972 */     // GIR_Coverage, 3589,
     /* 274972 */     GIR_EraseRootFromParent_Done,
     /* 274973 */   // Label 5320: @274973
     /* 274973 */   GIM_Try, /*On fail goto*//*Label 5321*/ GIMT_Encode4(275033), // Rule ID 3590 //
     /* 274978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 274981 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 274986 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 274989 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 274992 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 274995 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 274998 */     // MIs[0] tile
     /* 274998 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275001 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275014 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_D_PSEUDO),
     /* 275017 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275023 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275025 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275027 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275031 */     GIR_RootConstrainSelectedInstOperands,
     /* 275032 */     // GIR_Coverage, 3590,
     /* 275032 */     GIR_EraseRootFromParent_Done,
     /* 275033 */   // Label 5321: @275033
     /* 275033 */   GIM_Try, /*On fail goto*//*Label 5322*/ GIMT_Encode4(275093), // Rule ID 3591 //
     /* 275038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF8F16),
     /* 275041 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_fp8_fmopa_za16),
     /* 275046 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275049 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275052 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275055 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275058 */     // MIs[0] tile
     /* 275058 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275061 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275066 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275070 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275074 */     // (intrinsic_void 886:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (FMOPA_MPPZZ_BtoH_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_BtoH_PSEUDO),
     /* 275077 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275081 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275083 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275085 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275087 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275091 */     GIR_RootConstrainSelectedInstOperands,
     /* 275092 */     // GIR_Coverage, 3591,
     /* 275092 */     GIR_EraseRootFromParent_Done,
     /* 275093 */   // Label 5322: @275093
     /* 275093 */   GIM_Try, /*On fail goto*//*Label 5323*/ GIMT_Encode4(275153), // Rule ID 3592 //
     /* 275098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 275101 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa),
     /* 275106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275112 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275115 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275118 */     // MIs[0] tile
     /* 275118 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275121 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 275126 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275130 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275134 */     // (intrinsic_void 935:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPA_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPA_MPPZZ_H_PSEUDO),
     /* 275137 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275139 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275141 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275143 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275145 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275147 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275151 */     GIR_RootConstrainSelectedInstOperands,
     /* 275152 */     // GIR_Coverage, 3592,
     /* 275152 */     GIR_EraseRootFromParent_Done,
     /* 275153 */   // Label 5323: @275153
     /* 275153 */   GIM_Try, /*On fail goto*//*Label 5324*/ GIMT_Encode4(275213), // Rule ID 3593 //
     /* 275158 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275161 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275166 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275169 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275172 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275175 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275178 */     // MIs[0] tile
     /* 275178 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275181 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275186 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275190 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275194 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_S_PSEUDO),
     /* 275197 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275199 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275201 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275203 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275205 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275207 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275211 */     GIR_RootConstrainSelectedInstOperands,
     /* 275212 */     // GIR_Coverage, 3593,
     /* 275212 */     GIR_EraseRootFromParent_Done,
     /* 275213 */   // Label 5324: @275213
     /* 275213 */   GIM_Try, /*On fail goto*//*Label 5325*/ GIMT_Encode4(275273), // Rule ID 3594 //
     /* 275218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 275221 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_wide),
     /* 275226 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275229 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275232 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275235 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275238 */     // MIs[0] tile
     /* 275238 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275241 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275246 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275250 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275254 */     // (intrinsic_void 1038:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_D_PSEUDO),
     /* 275257 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275259 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275261 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275263 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275265 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275267 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275271 */     GIR_RootConstrainSelectedInstOperands,
     /* 275272 */     // GIR_Coverage, 3594,
     /* 275272 */     GIR_EraseRootFromParent_Done,
     /* 275273 */   // Label 5325: @275273
     /* 275273 */   GIM_Try, /*On fail goto*//*Label 5326*/ GIMT_Encode4(275333), // Rule ID 3595 //
     /* 275278 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275281 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mopa_wide),
     /* 275286 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275289 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275292 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275295 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275298 */     // MIs[0] tile
     /* 275298 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275301 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275306 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275310 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275314 */     // (intrinsic_void 937:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPAL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPAL_MPPZZ_PSEUDO),
     /* 275317 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275319 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275321 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275323 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275325 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275327 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275331 */     GIR_RootConstrainSelectedInstOperands,
     /* 275332 */     // GIR_Coverage, 3595,
     /* 275332 */     GIR_EraseRootFromParent_Done,
     /* 275333 */   // Label 5326: @275333
     /* 275333 */   GIM_Try, /*On fail goto*//*Label 5327*/ GIMT_Encode4(275393), // Rule ID 3689 //
     /* 275338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275341 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smopa_za32),
     /* 275346 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275349 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275352 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275355 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275358 */     // MIs[0] tile
     /* 275358 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275361 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275366 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275370 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275374 */     // (intrinsic_void 1039:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 275374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPA_MPPZZ_HtoS_PSEUDO),
     /* 275377 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275379 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275381 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275383 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275385 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275387 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275391 */     GIR_RootConstrainSelectedInstOperands,
     /* 275392 */     // GIR_Coverage, 3689,
     /* 275392 */     GIR_EraseRootFromParent_Done,
     /* 275393 */   // Label 5327: @275393
     /* 275393 */   GIM_Try, /*On fail goto*//*Label 5328*/ GIMT_Encode4(275453), // Rule ID 3690 //
     /* 275398 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 275401 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmopa_za32),
     /* 275406 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275409 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275412 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275415 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275418 */     // MIs[0] tile
     /* 275418 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275421 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275426 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275434 */     // (intrinsic_void 806:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 275434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPA_MPPZZ_S_PSEUDO),
     /* 275437 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275443 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275445 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275447 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275451 */     GIR_RootConstrainSelectedInstOperands,
     /* 275452 */     // GIR_Coverage, 3690,
     /* 275452 */     GIR_EraseRootFromParent_Done,
     /* 275453 */   // Label 5328: @275453
     /* 275453 */   GIM_Try, /*On fail goto*//*Label 5329*/ GIMT_Encode4(275513), // Rule ID 12640 //
     /* 275458 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275461 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275466 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 275469 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 275472 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 275475 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 275478 */     // MIs[0] tile
     /* 275478 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275481 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275486 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275494 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4f32:{ *:[nxv4f32] }:$Zn, nxv4f32:{ *:[nxv4f32] }:$Zm)  =>  (FMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4f32] }:$Zn, ?:{ *:[nxv4f32] }:$Zm)
     /* 275494 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_S_PSEUDO),
     /* 275497 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275499 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275501 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275503 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275505 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275507 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275511 */     GIR_RootConstrainSelectedInstOperands,
     /* 275512 */     // GIR_Coverage, 12640,
     /* 275512 */     GIR_EraseRootFromParent_Done,
     /* 275513 */   // Label 5329: @275513
     /* 275513 */   GIM_Try, /*On fail goto*//*Label 5330*/ GIMT_Encode4(275573), // Rule ID 12641 //
     /* 275518 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF64F64),
     /* 275521 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 275526 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 275529 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 275532 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv2s64,
     /* 275535 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv2s64,
     /* 275538 */     // MIs[0] tile
     /* 275538 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275541 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 275546 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275550 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275554 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv2i1] }:$Pn, PPR3bAny:{ *:[nxv2i1] }:$Pm, nxv2f64:{ *:[nxv2f64] }:$Zn, nxv2f64:{ *:[nxv2f64] }:$Zm)  =>  (FMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv2i1] }:$Pn, ?:{ *:[nxv2i1] }:$Pm, ?:{ *:[nxv2f64] }:$Zn, ?:{ *:[nxv2f64] }:$Zm)
     /* 275554 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_D_PSEUDO),
     /* 275557 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275559 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275561 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275563 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275565 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275567 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275571 */     GIR_RootConstrainSelectedInstOperands,
     /* 275572 */     // GIR_Coverage, 12641,
     /* 275572 */     GIR_EraseRootFromParent_Done,
     /* 275573 */   // Label 5330: @275573
     /* 275573 */   GIM_Try, /*On fail goto*//*Label 5331*/ GIMT_Encode4(275633), // Rule ID 12642 //
     /* 275578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275581 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops_wide),
     /* 275586 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 275589 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 275592 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 275595 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 275598 */     // MIs[0] tile
     /* 275598 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275601 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275606 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275610 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275614 */     // (intrinsic_void 940:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPSL_MPPZZ_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 275614 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPSL_MPPZZ_PSEUDO),
     /* 275617 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275623 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275625 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275627 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275631 */     GIR_RootConstrainSelectedInstOperands,
     /* 275632 */     // GIR_Coverage, 12642,
     /* 275632 */     GIR_EraseRootFromParent_Done,
     /* 275633 */   // Label 5331: @275633
     /* 275633 */   GIM_Try, /*On fail goto*//*Label 5332*/ GIMT_Encode4(275693), // Rule ID 12643 //
     /* 275638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275641 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 275646 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275649 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275652 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275655 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275658 */     // MIs[0] tile
     /* 275658 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275661 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275674 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_S_PSEUDO),
     /* 275677 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275683 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275685 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275687 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275691 */     GIR_RootConstrainSelectedInstOperands,
     /* 275692 */     // GIR_Coverage, 12643,
     /* 275692 */     GIR_EraseRootFromParent_Done,
     /* 275693 */   // Label 5332: @275693
     /* 275693 */   GIM_Try, /*On fail goto*//*Label 5333*/ GIMT_Encode4(275753), // Rule ID 12644 //
     /* 275698 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275701 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 275706 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275709 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275712 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275715 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275718 */     // MIs[0] tile
     /* 275718 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275721 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275726 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275734 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_S_PSEUDO),
     /* 275737 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275739 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275743 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275745 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275747 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275751 */     GIR_RootConstrainSelectedInstOperands,
     /* 275752 */     // GIR_Coverage, 12644,
     /* 275752 */     GIR_EraseRootFromParent_Done,
     /* 275753 */   // Label 5333: @275753
     /* 275753 */   GIM_Try, /*On fail goto*//*Label 5334*/ GIMT_Encode4(275813), // Rule ID 12645 //
     /* 275758 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275761 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 275766 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275769 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275772 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275775 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275778 */     // MIs[0] tile
     /* 275778 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275781 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275786 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275794 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (UMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_S_PSEUDO),
     /* 275797 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275801 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275803 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275805 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275807 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275811 */     GIR_RootConstrainSelectedInstOperands,
     /* 275812 */     // GIR_Coverage, 12645,
     /* 275812 */     GIR_EraseRootFromParent_Done,
     /* 275813 */   // Label 5334: @275813
     /* 275813 */   GIM_Try, /*On fail goto*//*Label 5335*/ GIMT_Encode4(275873), // Rule ID 12646 //
     /* 275818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275821 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 275826 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275829 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275832 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275835 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275838 */     // MIs[0] tile
     /* 275838 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275841 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275846 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275850 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275854 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_S_PSEUDO),
     /* 275857 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275859 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275861 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275863 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275865 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275871 */     GIR_RootConstrainSelectedInstOperands,
     /* 275872 */     // GIR_Coverage, 12646,
     /* 275872 */     GIR_EraseRootFromParent_Done,
     /* 275873 */   // Label 5335: @275873
     /* 275873 */   GIM_Try, /*On fail goto*//*Label 5336*/ GIMT_Encode4(275933), // Rule ID 12647 //
     /* 275878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275881 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 275886 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275889 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275892 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275895 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275898 */     // MIs[0] tile
     /* 275898 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275901 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275914 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (SUMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_S_PSEUDO),
     /* 275917 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275923 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275925 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275927 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275931 */     GIR_RootConstrainSelectedInstOperands,
     /* 275932 */     // GIR_Coverage, 12647,
     /* 275932 */     GIR_EraseRootFromParent_Done,
     /* 275933 */   // Label 5336: @275933
     /* 275933 */   GIM_Try, /*On fail goto*//*Label 5337*/ GIMT_Encode4(275993), // Rule ID 12648 //
     /* 275938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 275941 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 275946 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 275949 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 275952 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 275955 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 275958 */     // MIs[0] tile
     /* 275958 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 275961 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 275966 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275970 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 275974 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPA_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 275974 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_S_PSEUDO),
     /* 275977 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 275979 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 275981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 275983 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 275985 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 275987 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 275991 */     GIR_RootConstrainSelectedInstOperands,
     /* 275992 */     // GIR_Coverage, 12648,
     /* 275992 */     GIR_EraseRootFromParent_Done,
     /* 275993 */   // Label 5337: @275993
     /* 275993 */   GIM_Try, /*On fail goto*//*Label 5338*/ GIMT_Encode4(276053), // Rule ID 12649 //
     /* 275998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME),
     /* 276001 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276006 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 276009 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 276012 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276015 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv16s8,
     /* 276018 */     // MIs[0] tile
     /* 276018 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276021 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276034 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv16i1] }:$Pn, PPR3bAny:{ *:[nxv16i1] }:$Pm, nxv16i8:{ *:[nxv16i8] }:$Zn, nxv16i8:{ *:[nxv16i8] }:$Zm)  =>  (USMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv16i1] }:$Pn, ?:{ *:[nxv16i1] }:$Pm, ?:{ *:[nxv16i8] }:$Zn, ?:{ *:[nxv16i8] }:$Zm)
     /* 276034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_S_PSEUDO),
     /* 276037 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276039 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276043 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276045 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276047 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276051 */     GIR_RootConstrainSelectedInstOperands,
     /* 276052 */     // GIR_Coverage, 12649,
     /* 276052 */     GIR_EraseRootFromParent_Done,
     /* 276053 */   // Label 5338: @276053
     /* 276053 */   GIM_Try, /*On fail goto*//*Label 5339*/ GIMT_Encode4(276113), // Rule ID 12650 //
     /* 276058 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276061 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_wide),
     /* 276066 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276069 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276072 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276075 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276078 */     // MIs[0] tile
     /* 276078 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276081 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276086 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276094 */     // (intrinsic_void 1040:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_D_PSEUDO),
     /* 276097 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276099 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276101 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276103 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276105 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276107 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276111 */     GIR_RootConstrainSelectedInstOperands,
     /* 276112 */     // GIR_Coverage, 12650,
     /* 276112 */     GIR_EraseRootFromParent_Done,
     /* 276113 */   // Label 5339: @276113
     /* 276113 */   GIM_Try, /*On fail goto*//*Label 5340*/ GIMT_Encode4(276173), // Rule ID 12651 //
     /* 276118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276121 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_wide),
     /* 276126 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276129 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276132 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276135 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276138 */     // MIs[0] tile
     /* 276138 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276141 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276146 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276150 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276154 */     // (intrinsic_void 1173:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_D_PSEUDO),
     /* 276157 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276161 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276163 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276165 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276167 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276171 */     GIR_RootConstrainSelectedInstOperands,
     /* 276172 */     // GIR_Coverage, 12651,
     /* 276172 */     GIR_EraseRootFromParent_Done,
     /* 276173 */   // Label 5340: @276173
     /* 276173 */   GIM_Try, /*On fail goto*//*Label 5341*/ GIMT_Encode4(276233), // Rule ID 12652 //
     /* 276178 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276181 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_wide),
     /* 276186 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276189 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276192 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276195 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276198 */     // MIs[0] tile
     /* 276198 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276201 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276214 */     // (intrinsic_void 1175:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_D_PSEUDO),
     /* 276217 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276223 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276225 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276227 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276231 */     GIR_RootConstrainSelectedInstOperands,
     /* 276232 */     // GIR_Coverage, 12652,
     /* 276232 */     GIR_EraseRootFromParent_Done,
     /* 276233 */   // Label 5341: @276233
     /* 276233 */   GIM_Try, /*On fail goto*//*Label 5342*/ GIMT_Encode4(276293), // Rule ID 12653 //
     /* 276238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276241 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumopa_wide),
     /* 276246 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276252 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276255 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276258 */     // MIs[0] tile
     /* 276258 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276261 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276266 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276274 */     // (intrinsic_void 1090:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPA_MPPZZ_D_PSEUDO),
     /* 276277 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276279 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276281 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276283 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276285 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276287 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276291 */     GIR_RootConstrainSelectedInstOperands,
     /* 276292 */     // GIR_Coverage, 12653,
     /* 276292 */     GIR_EraseRootFromParent_Done,
     /* 276293 */   // Label 5342: @276293
     /* 276293 */   GIM_Try, /*On fail goto*//*Label 5343*/ GIMT_Encode4(276353), // Rule ID 12654 //
     /* 276298 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276301 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_sumops_wide),
     /* 276306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276312 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276315 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276318 */     // MIs[0] tile
     /* 276318 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276321 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276326 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276334 */     // (intrinsic_void 1091:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SUMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUMOPS_MPPZZ_D_PSEUDO),
     /* 276337 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276343 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276345 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276347 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276351 */     GIR_RootConstrainSelectedInstOperands,
     /* 276352 */     // GIR_Coverage, 12654,
     /* 276352 */     GIR_EraseRootFromParent_Done,
     /* 276353 */   // Label 5343: @276353
     /* 276353 */   GIM_Try, /*On fail goto*//*Label 5344*/ GIMT_Encode4(276413), // Rule ID 12655 //
     /* 276358 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276361 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmopa_wide),
     /* 276366 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276369 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276372 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276375 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276378 */     // MIs[0] tile
     /* 276378 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276381 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276386 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276390 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276394 */     // (intrinsic_void 1207:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPA_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPA_MPPZZ_D_PSEUDO),
     /* 276397 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276399 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276401 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276403 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276405 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276407 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276411 */     GIR_RootConstrainSelectedInstOperands,
     /* 276412 */     // GIR_Coverage, 12655,
     /* 276412 */     GIR_EraseRootFromParent_Done,
     /* 276413 */   // Label 5344: @276413
     /* 276413 */   GIM_Try, /*On fail goto*//*Label 5345*/ GIMT_Encode4(276473), // Rule ID 12656 //
     /* 276418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEI16I64),
     /* 276421 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_usmops_wide),
     /* 276426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276432 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276435 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276438 */     // MIs[0] tile
     /* 276438 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276441 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_7),
     /* 276446 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276454 */     // (intrinsic_void 1208:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_7>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (USMOPS_MPPZZ_D_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USMOPS_MPPZZ_D_PSEUDO),
     /* 276457 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276459 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276461 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276463 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276465 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276467 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276471 */     GIR_RootConstrainSelectedInstOperands,
     /* 276472 */     // GIR_Coverage, 12656,
     /* 276472 */     GIR_EraseRootFromParent_Done,
     /* 276473 */   // Label 5345: @276473
     /* 276473 */   GIM_Try, /*On fail goto*//*Label 5346*/ GIMT_Encode4(276533), // Rule ID 13030 //
     /* 276478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276481 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_bmops_za32),
     /* 276486 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 276489 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 276492 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv4s32,
     /* 276495 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv4s32,
     /* 276498 */     // MIs[0] tile
     /* 276498 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276501 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276506 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276510 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276514 */     // (intrinsic_void 807:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv4i1] }:$Pn, PPR3bAny:{ *:[nxv4i1] }:$Pm, nxv4i32:{ *:[nxv4i32] }:$Zn, nxv4i32:{ *:[nxv4i32] }:$Zm)  =>  (BMOPS_MPPZZ_S_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv4i1] }:$Pn, ?:{ *:[nxv4i1] }:$Pm, ?:{ *:[nxv4i32] }:$Zn, ?:{ *:[nxv4i32] }:$Zm)
     /* 276514 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BMOPS_MPPZZ_S_PSEUDO),
     /* 276517 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276519 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276521 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276523 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276525 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276527 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276531 */     GIR_RootConstrainSelectedInstOperands,
     /* 276532 */     // GIR_Coverage, 13030,
     /* 276532 */     GIR_EraseRootFromParent_Done,
     /* 276533 */   // Label 5346: @276533
     /* 276533 */   GIM_Try, /*On fail goto*//*Label 5347*/ GIMT_Encode4(276593), // Rule ID 13031 //
     /* 276538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276541 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_smops_za32),
     /* 276546 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276549 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276552 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276555 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276558 */     // MIs[0] tile
     /* 276558 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276561 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276566 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276570 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276574 */     // (intrinsic_void 1041:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (SMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276577 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276579 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276581 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276583 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276585 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276587 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276591 */     GIR_RootConstrainSelectedInstOperands,
     /* 276592 */     // GIR_Coverage, 13031,
     /* 276592 */     GIR_EraseRootFromParent_Done,
     /* 276593 */   // Label 5347: @276593
     /* 276593 */   GIM_Try, /*On fail goto*//*Label 5348*/ GIMT_Encode4(276653), // Rule ID 13032 //
     /* 276598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276601 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umopa_za32),
     /* 276606 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276609 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276612 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276615 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276618 */     // MIs[0] tile
     /* 276618 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276621 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276630 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276634 */     // (intrinsic_void 1174:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPA_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPA_MPPZZ_HtoS_PSEUDO),
     /* 276637 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276641 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276643 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276645 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276647 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276651 */     GIR_RootConstrainSelectedInstOperands,
     /* 276652 */     // GIR_Coverage, 13032,
     /* 276652 */     GIR_EraseRootFromParent_Done,
     /* 276653 */   // Label 5348: @276653
     /* 276653 */   GIM_Try, /*On fail goto*//*Label 5349*/ GIMT_Encode4(276713), // Rule ID 13033 //
     /* 276658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSME2),
     /* 276661 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_umops_za32),
     /* 276666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276672 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276675 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276678 */     // MIs[0] tile
     /* 276678 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276681 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_3),
     /* 276686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276690 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276694 */     // (intrinsic_void 1176:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_3>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8i16:{ *:[nxv8i16] }:$Zn, nxv8i16:{ *:[nxv8i16] }:$Zm)  =>  (UMOPS_MPPZZ_HtoS_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8i16] }:$Zn, ?:{ *:[nxv8i16] }:$Zm)
     /* 276694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOPS_MPPZZ_HtoS_PSEUDO),
     /* 276697 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276701 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276703 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276705 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276707 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276711 */     GIR_RootConstrainSelectedInstOperands,
     /* 276712 */     // GIR_Coverage, 13033,
     /* 276712 */     GIR_EraseRootFromParent_Done,
     /* 276713 */   // Label 5349: @276713
     /* 276713 */   GIM_Try, /*On fail goto*//*Label 5350*/ GIMT_Encode4(276773), // Rule ID 13144 //
     /* 276718 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSMEF16F16_or_SMEF8F16),
     /* 276721 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/0, GIMT_Encode2(Intrinsic::aarch64_sme_mops),
     /* 276726 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 276729 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 276732 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv8s16,
     /* 276735 */     GIM_RootCheckType, /*Op*/5, /*Type*/GILLT_nxv8s16,
     /* 276738 */     // MIs[0] tile
     /* 276738 */     GIM_CheckIsImm, /*MI*/0, /*Op*/1,
     /* 276741 */     GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_timm32_0_1),
     /* 276746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::PPR_3bRegClassID),
     /* 276754 */     // (intrinsic_void 938:{ *:[iPTR] }, (timm:{ *:[i32] })<<P:Predicate_timm32_0_1>>:$tile, PPR3bAny:{ *:[nxv8i1] }:$Pn, PPR3bAny:{ *:[nxv8i1] }:$Pm, nxv8f16:{ *:[nxv8f16] }:$Zn, nxv8f16:{ *:[nxv8f16] }:$Zm)  =>  (FMOPS_MPPZZ_H_PSEUDO ?:{ *:[i32] }:$tile, ?:{ *:[nxv8i1] }:$Pn, ?:{ *:[nxv8i1] }:$Pm, ?:{ *:[nxv8f16] }:$Zn, ?:{ *:[nxv8f16] }:$Zm)
     /* 276754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOPS_MPPZZ_H_PSEUDO),
     /* 276757 */     GIR_RootToRootCopy, /*OpIdx*/1, // tile
     /* 276759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Pn
     /* 276761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Pm
     /* 276763 */     GIR_RootToRootCopy, /*OpIdx*/4, // Zn
     /* 276765 */     GIR_RootToRootCopy, /*OpIdx*/5, // Zm
     /* 276767 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276771 */     GIR_RootConstrainSelectedInstOperands,
     /* 276772 */     // GIR_Coverage, 13144,
     /* 276772 */     GIR_EraseRootFromParent_Done,
     /* 276773 */   // Label 5350: @276773
     /* 276773 */   GIM_Try, /*On fail goto*//*Label 5351*/ GIMT_Encode4(276821), // Rule ID 3575 //
     /* 276778 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276781 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalb_lane),
     /* 276786 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276789 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276792 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276795 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276798 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276802 */     // MIs[0] Op4
     /* 276802 */     // No operand predicates
     /* 276802 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1513:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALB_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALB_ZZZI),
     /* 276805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276811 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276813 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276815 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276819 */     GIR_RootConstrainSelectedInstOperands,
     /* 276820 */     // GIR_Coverage, 3575,
     /* 276820 */     GIR_EraseRootFromParent_Done,
     /* 276821 */   // Label 5351: @276821
     /* 276821 */   GIM_Try, /*On fail goto*//*Label 5352*/ GIMT_Encode4(276869), // Rule ID 3577 //
     /* 276826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276829 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbb_lane),
     /* 276834 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276843 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276846 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276850 */     // MIs[0] Op4
     /* 276850 */     // No operand predicates
     /* 276850 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1515:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBB_ZZZI),
     /* 276853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276859 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276861 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276863 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276867 */     GIR_RootConstrainSelectedInstOperands,
     /* 276868 */     // GIR_Coverage, 3577,
     /* 276868 */     GIR_EraseRootFromParent_Done,
     /* 276869 */   // Label 5352: @276869
     /* 276869 */   GIM_Try, /*On fail goto*//*Label 5353*/ GIMT_Encode4(276917), // Rule ID 3578 //
     /* 276874 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT2),
     /* 276877 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 276882 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276885 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276888 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276891 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276894 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276898 */     // MIs[0] Op4
     /* 276898 */     // No operand predicates
     /* 276898 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1511:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoH:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoH),
     /* 276901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276907 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276909 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276911 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276915 */     GIR_RootConstrainSelectedInstOperands,
     /* 276916 */     // GIR_Coverage, 3578,
     /* 276916 */     GIR_EraseRootFromParent_Done,
     /* 276917 */   // Label 5353: @276917
     /* 276917 */   GIM_Try, /*On fail goto*//*Label 5354*/ GIMT_Encode4(276965), // Rule ID 3579 //
     /* 276922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8DOT4),
     /* 276925 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fdot_lane),
     /* 276930 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 276933 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 276936 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276939 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276942 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276946 */     // MIs[0] Op4
     /* 276946 */     // No operand predicates
     /* 276946 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1511:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FDOT_ZZZI_BtoS:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDOT_ZZZI_BtoS),
     /* 276949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 276953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 276955 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 276957 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 276959 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 276963 */     GIR_RootConstrainSelectedInstOperands,
     /* 276964 */     // GIR_Coverage, 3579,
     /* 276964 */     GIR_EraseRootFromParent_Done,
     /* 276965 */   // Label 5354: @276965
     /* 276965 */   GIM_Try, /*On fail goto*//*Label 5355*/ GIMT_Encode4(277013), // Rule ID 12624 //
     /* 276970 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 276973 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalt_lane),
     /* 276978 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv8s16,
     /* 276981 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 276984 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 276987 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 276990 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 276994 */     // MIs[0] Op4
     /* 276994 */     // No operand predicates
     /* 276994 */     // (intrinsic_w_chain:{ *:[nxv8f16] } 1523:{ *:[iPTR] }, nxv8f16:{ *:[nxv8f16] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALT_ZZZI:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 276994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALT_ZZZI),
     /* 276997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 276999 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277001 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277003 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277005 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277007 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277011 */     GIR_RootConstrainSelectedInstOperands,
     /* 277012 */     // GIR_Coverage, 12624,
     /* 277012 */     GIR_EraseRootFromParent_Done,
     /* 277013 */   // Label 5355: @277013
     /* 277013 */   GIM_Try, /*On fail goto*//*Label 5356*/ GIMT_Encode4(277061), // Rule ID 12626 //
     /* 277018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277021 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlallbt_lane),
     /* 277026 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277029 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277032 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277035 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277038 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277042 */     // MIs[0] Op4
     /* 277042 */     // No operand predicates
     /* 277042 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1517:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLBT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277042 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLBT_ZZZI),
     /* 277045 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277047 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277051 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277053 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277055 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277059 */     GIR_RootConstrainSelectedInstOperands,
     /* 277060 */     // GIR_Coverage, 12626,
     /* 277060 */     GIR_EraseRootFromParent_Done,
     /* 277061 */   // Label 5356: @277061
     /* 277061 */   GIM_Try, /*On fail goto*//*Label 5357*/ GIMT_Encode4(277109), // Rule ID 12627 //
     /* 277066 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277069 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltb_lane),
     /* 277074 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277077 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277080 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277083 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277086 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277090 */     // MIs[0] Op4
     /* 277090 */     // No operand predicates
     /* 277090 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1519:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTB_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTB_ZZZI),
     /* 277093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277095 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277099 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277101 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277103 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277107 */     GIR_RootConstrainSelectedInstOperands,
     /* 277108 */     // GIR_Coverage, 12627,
     /* 277108 */     GIR_EraseRootFromParent_Done,
     /* 277109 */   // Label 5357: @277109
     /* 277109 */   GIM_Try, /*On fail goto*//*Label 5358*/ GIMT_Encode4(277157), // Rule ID 12628 //
     /* 277114 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSSVE_FP8FMA),
     /* 277117 */     GIM_CheckIntrinsicID, /*MI*/0, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_sve_fp8_fmlalltt_lane),
     /* 277122 */     GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_nxv4s32,
     /* 277125 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 277128 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 277131 */     GIM_RootCheckType, /*Op*/4, /*Type*/GILLT_nxv16s8,
     /* 277134 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 277138 */     // MIs[0] Op4
     /* 277138 */     // No operand predicates
     /* 277138 */     // (intrinsic_w_chain:{ *:[nxv4f32] } 1521:{ *:[iPTR] }, nxv4f32:{ *:[nxv4f32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3, i32:{ *:[i32] }:$Op4)  =>  (FMLALLTT_ZZZI:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3, ?:{ *:[i32] }:$Op4)
     /* 277138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLALLTT_ZZZI),
     /* 277141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zda]
     /* 277143 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 277145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 277147 */     GIR_RootToRootCopy, /*OpIdx*/4, // Op3
     /* 277149 */     GIR_RootToRootCopy, /*OpIdx*/5, // Op4
     /* 277151 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/1, /*MergeInsnID's*/0,
     /* 277155 */     GIR_RootConstrainSelectedInstOperands,
     /* 277156 */     // GIR_Coverage, 12628,
     /* 277156 */     GIR_EraseRootFromParent_Done,
     /* 277157 */   // Label 5358: @277157
     /* 277157 */   GIM_Reject,
     /* 277158 */ // Label 5308: @277158
     /* 277158 */ GIM_Reject,
     /* 277159 */ // Label 39: @277159
     /* 277159 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 5363*/ GIMT_Encode4(277448),
     /* 277170 */ /*GILLT_s64*//*Label 5359*/ GIMT_Encode4(277202), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277182 */ /*GILLT_v2s64*//*Label 5360*/ GIMT_Encode4(277262), GIMT_Encode4(0),
     /* 277190 */ /*GILLT_v4s32*//*Label 5361*/ GIMT_Encode4(277324), GIMT_Encode4(0),
     /* 277198 */ /*GILLT_v8s16*//*Label 5362*/ GIMT_Encode4(277386),
     /* 277202 */ // Label 5359: @277202
     /* 277202 */ GIM_Try, /*On fail goto*//*Label 5364*/ GIMT_Encode4(277261), // Rule ID 6535 //
     /* 277207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 277210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277214 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277218 */   // (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] })
     /* 277218 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 277221 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 277225 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 277230 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 277232 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 277235 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277237 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 277240 */   GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 277242 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 277245 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277250 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 277255 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 277260 */   // GIR_Coverage, 6535,
     /* 277260 */   GIR_EraseRootFromParent_Done,
     /* 277261 */ // Label 5364: @277261
     /* 277261 */ GIM_Reject,
     /* 277262 */ // Label 5360: @277262
     /* 277262 */ GIM_Try, /*On fail goto*//*Label 5365*/ GIMT_Encode4(277323),
     /* 277267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 277270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277274 */   GIM_Try, /*On fail goto*//*Label 5366*/ GIMT_Encode4(277301), // Rule ID 6405 //
     /* 277279 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 277286 */     // (anyext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 277286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 277289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277291 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277296 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277299 */     GIR_RootConstrainSelectedInstOperands,
     /* 277300 */     // GIR_Coverage, 6405,
     /* 277300 */     GIR_EraseRootFromParent_Done,
     /* 277301 */   // Label 5366: @277301
     /* 277301 */   GIM_Try, /*On fail goto*//*Label 5367*/ GIMT_Encode4(277322), // Rule ID 6398 //
     /* 277306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277310 */     // (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 277310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 277313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277315 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277317 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277320 */     GIR_RootConstrainSelectedInstOperands,
     /* 277321 */     // GIR_Coverage, 6398,
     /* 277321 */     GIR_EraseRootFromParent_Done,
     /* 277322 */   // Label 5367: @277322
     /* 277322 */   GIM_Reject,
     /* 277323 */ // Label 5365: @277323
     /* 277323 */ GIM_Reject,
     /* 277324 */ // Label 5361: @277324
     /* 277324 */ GIM_Try, /*On fail goto*//*Label 5368*/ GIMT_Encode4(277385),
     /* 277329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 277332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277336 */   GIM_Try, /*On fail goto*//*Label 5369*/ GIMT_Encode4(277363), // Rule ID 6402 //
     /* 277341 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 277348 */     // (anyext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 277348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 277351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277361 */     GIR_RootConstrainSelectedInstOperands,
     /* 277362 */     // GIR_Coverage, 6402,
     /* 277362 */     GIR_EraseRootFromParent_Done,
     /* 277363 */   // Label 5369: @277363
     /* 277363 */   GIM_Try, /*On fail goto*//*Label 5370*/ GIMT_Encode4(277384), // Rule ID 6395 //
     /* 277368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277372 */     // (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 277372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 277375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277377 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277379 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277382 */     GIR_RootConstrainSelectedInstOperands,
     /* 277383 */     // GIR_Coverage, 6395,
     /* 277383 */     GIR_EraseRootFromParent_Done,
     /* 277384 */   // Label 5370: @277384
     /* 277384 */   GIM_Reject,
     /* 277385 */ // Label 5368: @277385
     /* 277385 */ GIM_Reject,
     /* 277386 */ // Label 5362: @277386
     /* 277386 */ GIM_Try, /*On fail goto*//*Label 5371*/ GIMT_Encode4(277447),
     /* 277391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 277394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277398 */   GIM_Try, /*On fail goto*//*Label 5372*/ GIMT_Encode4(277425), // Rule ID 6399 //
     /* 277403 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 277410 */     // (anyext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 277410 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 277413 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 277420 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277423 */     GIR_RootConstrainSelectedInstOperands,
     /* 277424 */     // GIR_Coverage, 6399,
     /* 277424 */     GIR_EraseRootFromParent_Done,
     /* 277425 */   // Label 5372: @277425
     /* 277425 */   GIM_Try, /*On fail goto*//*Label 5373*/ GIMT_Encode4(277446), // Rule ID 6392 //
     /* 277430 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277434 */     // (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 277434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 277437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277439 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 277441 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 277444 */     GIR_RootConstrainSelectedInstOperands,
     /* 277445 */     // GIR_Coverage, 6392,
     /* 277445 */     GIR_EraseRootFromParent_Done,
     /* 277446 */   // Label 5373: @277446
     /* 277446 */   GIM_Reject,
     /* 277447 */ // Label 5371: @277447
     /* 277447 */ GIM_Reject,
     /* 277448 */ // Label 5363: @277448
     /* 277448 */ GIM_Reject,
     /* 277449 */ // Label 40: @277449
     /* 277449 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(10), /*)*//*default:*//*Label 5378*/ GIMT_Encode4(278885),
     /* 277460 */ /*GILLT_s32*//*Label 5374*/ GIMT_Encode4(277492), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 277472 */ /*GILLT_v2s32*//*Label 5375*/ GIMT_Encode4(277531), GIMT_Encode4(0),
     /* 277480 */ /*GILLT_v4s16*//*Label 5376*/ GIMT_Encode4(277887), GIMT_Encode4(0),
     /* 277488 */ /*GILLT_v8s8*//*Label 5377*/ GIMT_Encode4(278386),
     /* 277492 */ // Label 5374: @277492
     /* 277492 */ GIM_Try, /*On fail goto*//*Label 5379*/ GIMT_Encode4(277530), // Rule ID 6556 //
     /* 277497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 277500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277504 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277508 */   // (trunc:{ *:[i32] } GPR64sp:{ *:[i64] }:$src)  =>  (EXTRACT_SUBREG:{ *:[i32] } GPR64sp:{ *:[i64] }:$src, sub_32:{ *:[i32] })
     /* 277508 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 277511 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 277513 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(20), // src
     /* 277519 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 277524 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 277529 */   // GIR_Coverage, 6556,
     /* 277529 */   GIR_EraseRootFromParent_Done,
     /* 277530 */ // Label 5379: @277530
     /* 277530 */ GIM_Reject,
     /* 277531 */ // Label 5375: @277531
     /* 277531 */ GIM_Try, /*On fail goto*//*Label 5380*/ GIMT_Encode4(277886),
     /* 277536 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277539 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277543 */   GIM_Try, /*On fail goto*//*Label 5381*/ GIMT_Encode4(277621), // Rule ID 5444 //
     /* 277548 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277552 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277556 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 277568 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277572 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277576 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277585 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277591 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 277593 */     // MIs[1] Operand 2
     /* 277593 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277604 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277606 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 277606 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277609 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277619 */     GIR_RootConstrainSelectedInstOperands,
     /* 277620 */     // GIR_Coverage, 5444,
     /* 277620 */     GIR_EraseRootFromParent_Done,
     /* 277621 */   // Label 5381: @277621
     /* 277621 */   GIM_Try, /*On fail goto*//*Label 5382*/ GIMT_Encode4(277692), // Rule ID 5440 //
     /* 277626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277638 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277642 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 277646 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277650 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277659 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277664 */     // MIs[1] Operand 2
     /* 277664 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277677 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (ADDHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv2i64_v2i32),
     /* 277680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277690 */     GIR_RootConstrainSelectedInstOperands,
     /* 277691 */     // GIR_Coverage, 5440,
     /* 277691 */     GIR_EraseRootFromParent_Done,
     /* 277692 */   // Label 5382: @277692
     /* 277692 */   GIM_Try, /*On fail goto*//*Label 5383*/ GIMT_Encode4(277763), // Rule ID 5442 //
     /* 277697 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277701 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277705 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277709 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277713 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 277717 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277721 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 277725 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277735 */     // MIs[1] Operand 2
     /* 277735 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(32),
     /* 277746 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277748 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm), 32:{ *:[i32] }))  =>  (SUBHNv2i64_v2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 277748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv2i64_v2i32),
     /* 277751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277753 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277757 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277761 */     GIR_RootConstrainSelectedInstOperands,
     /* 277762 */     // GIR_Coverage, 5442,
     /* 277762 */     GIR_EraseRootFromParent_Done,
     /* 277763 */   // Label 5383: @277763
     /* 277763 */   GIM_Try, /*On fail goto*//*Label 5384*/ GIMT_Encode4(277816), // Rule ID 2162 //
     /* 277768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 277779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277788 */     // MIs[1] imm
     /* 277788 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277792 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277796 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277800 */     // MIs[2] Operand 1
     /* 277800 */     // No operand predicates
     /* 277800 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277802 */     // (trunc:{ *:[v2i32] } (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 277802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277814 */     GIR_RootConstrainSelectedInstOperands,
     /* 277815 */     // GIR_Coverage, 2162,
     /* 277815 */     GIR_EraseRootFromParent_Done,
     /* 277816 */   // Label 5384: @277816
     /* 277816 */   GIM_Try, /*On fail goto*//*Label 5385*/ GIMT_Encode4(277866), // Rule ID 6380 //
     /* 277821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 277833 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277838 */     // MIs[1] imm
     /* 277838 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 277842 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 277846 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64Narrow),
     /* 277850 */     // MIs[2] Operand 1
     /* 277850 */     // No operand predicates
     /* 277850 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 277852 */     // (trunc:{ *:[v2i32] } (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm))  =>  (SHRNv2i32_shift:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64Narrow>>:$imm)
     /* 277852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv2i32_shift),
     /* 277855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277857 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 277861 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 277864 */     GIR_RootConstrainSelectedInstOperands,
     /* 277865 */     // GIR_Coverage, 6380,
     /* 277865 */     GIR_EraseRootFromParent_Done,
     /* 277866 */   // Label 5385: @277866
     /* 277866 */   GIM_Try, /*On fail goto*//*Label 5386*/ GIMT_Encode4(277885), // Rule ID 1099 //
     /* 277871 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 277874 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277878 */     // (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)  =>  (XTNv2i32:{ *:[v2i32] } V128:{ *:[v2i64] }:$Rn)
     /* 277878 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv2i32),
     /* 277883 */     GIR_RootConstrainSelectedInstOperands,
     /* 277884 */     // GIR_Coverage, 1099,
     /* 277884 */     GIR_Done,
     /* 277885 */   // Label 5386: @277885
     /* 277885 */   GIM_Reject,
     /* 277886 */ // Label 5380: @277886
     /* 277886 */ GIM_Reject,
     /* 277887 */ // Label 5376: @277887
     /* 277887 */ GIM_Try, /*On fail goto*//*Label 5387*/ GIMT_Encode4(278385),
     /* 277892 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 277899 */   GIM_Try, /*On fail goto*//*Label 5388*/ GIMT_Encode4(277977), // Rule ID 5438 //
     /* 277904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 277924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 277932 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 277937 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 277941 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 277947 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 277949 */     // MIs[1] Operand 2
     /* 277949 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 277960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 277962 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 277962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 277965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 277967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 277971 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 277975 */     GIR_RootConstrainSelectedInstOperands,
     /* 277976 */     // GIR_Coverage, 5438,
     /* 277976 */     GIR_EraseRootFromParent_Done,
     /* 277977 */   // Label 5388: @277977
     /* 277977 */   GIM_Try, /*On fail goto*//*Label 5389*/ GIMT_Encode4(278048), // Rule ID 5434 //
     /* 277982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 277986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 277990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 277994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 277998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278015 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278020 */     // MIs[1] Operand 2
     /* 278020 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278031 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278033 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (ADDHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv4i32_v4i16),
     /* 278036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278038 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278046 */     GIR_RootConstrainSelectedInstOperands,
     /* 278047 */     // GIR_Coverage, 5434,
     /* 278047 */     GIR_EraseRootFromParent_Done,
     /* 278048 */   // Label 5389: @278048
     /* 278048 */   GIM_Try, /*On fail goto*//*Label 5390*/ GIMT_Encode4(278119), // Rule ID 5436 //
     /* 278053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 278081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278086 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278091 */     // MIs[1] Operand 2
     /* 278091 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 278102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278104 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm), 16:{ *:[i32] }))  =>  (SUBHNv4i32_v4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 278104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv4i32_v4i16),
     /* 278107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278109 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278117 */     GIR_RootConstrainSelectedInstOperands,
     /* 278118 */     // GIR_Coverage, 5436,
     /* 278118 */     GIR_EraseRootFromParent_Done,
     /* 278119 */   // Label 5390: @278119
     /* 278119 */   GIM_Try, /*On fail goto*//*Label 5391*/ GIMT_Encode4(278211), // Rule ID 5560 //
     /* 278124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278132 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278135 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278139 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278143 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278147 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278151 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278155 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278160 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278164 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278168 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 278172 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278177 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278179 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vn), (trunc:{ *:[v2i32] } V128:{ *:[v2i64] }:$Vm)))  =>  (XTNv4i16:{ *:[v4i16] } (UZP1v4i32:{ *:[f128] } V128:{ *:[v2i64] }:$Vn, V128:{ *:[v2i64] }:$Vm))
     /* 278179 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278182 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 278186 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278191 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278206 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278209 */     GIR_RootConstrainSelectedInstOperands,
     /* 278210 */     // GIR_Coverage, 5560,
     /* 278210 */     GIR_EraseRootFromParent_Done,
     /* 278211 */   // Label 5391: @278211
     /* 278211 */   GIM_Try, /*On fail goto*//*Label 5392*/ GIMT_Encode4(278264), // Rule ID 2161 //
     /* 278216 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278219 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278223 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278227 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278231 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278236 */     // MIs[1] imm
     /* 278236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278244 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278248 */     // MIs[2] Operand 1
     /* 278248 */     // No operand predicates
     /* 278248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278250 */     // (trunc:{ *:[v4i16] } (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278255 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278259 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278262 */     GIR_RootConstrainSelectedInstOperands,
     /* 278263 */     // GIR_Coverage, 2161,
     /* 278263 */     GIR_EraseRootFromParent_Done,
     /* 278264 */   // Label 5392: @278264
     /* 278264 */   GIM_Try, /*On fail goto*//*Label 5393*/ GIMT_Encode4(278314), // Rule ID 6379 //
     /* 278269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278273 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278277 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278286 */     // MIs[1] imm
     /* 278286 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278290 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278294 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32Narrow),
     /* 278298 */     // MIs[2] Operand 1
     /* 278298 */     // No operand predicates
     /* 278298 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278300 */     // (trunc:{ *:[v4i16] } (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm))  =>  (SHRNv4i16_shift:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32Narrow>>:$imm)
     /* 278300 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv4i16_shift),
     /* 278303 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278305 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278309 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278312 */     GIR_RootConstrainSelectedInstOperands,
     /* 278313 */     // GIR_Coverage, 6379,
     /* 278313 */     GIR_EraseRootFromParent_Done,
     /* 278314 */   // Label 5393: @278314
     /* 278314 */   GIM_Try, /*On fail goto*//*Label 5394*/ GIMT_Encode4(278365), // Rule ID 5588 //
     /* 278319 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278323 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278327 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278330 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 278334 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 278338 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278348 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278350 */     // (trunc:{ *:[v4i16] } (concat_vectors:{ *:[v4i32] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm))  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vm)
     /* 278350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 278353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278355 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278359 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278363 */     GIR_RootConstrainSelectedInstOperands,
     /* 278364 */     // GIR_Coverage, 5588,
     /* 278364 */     GIR_EraseRootFromParent_Done,
     /* 278365 */   // Label 5394: @278365
     /* 278365 */   GIM_Try, /*On fail goto*//*Label 5395*/ GIMT_Encode4(278384), // Rule ID 1098 //
     /* 278370 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278373 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278377 */     // (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)  =>  (XTNv4i16:{ *:[v4i16] } V128:{ *:[v4i32] }:$Rn)
     /* 278377 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv4i16),
     /* 278382 */     GIR_RootConstrainSelectedInstOperands,
     /* 278383 */     // GIR_Coverage, 1098,
     /* 278383 */     GIR_Done,
     /* 278384 */   // Label 5395: @278384
     /* 278384 */   GIM_Reject,
     /* 278385 */ // Label 5387: @278385
     /* 278385 */ GIM_Reject,
     /* 278386 */ // Label 5377: @278386
     /* 278386 */ GIM_Try, /*On fail goto*//*Label 5396*/ GIMT_Encode4(278884),
     /* 278391 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278394 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278398 */   GIM_Try, /*On fail goto*//*Label 5397*/ GIMT_Encode4(278476), // Rule ID 5432 //
     /* 278403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278407 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278411 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 278423 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278427 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278431 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278436 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 278440 */     GIM_CheckOpcodeIsEither, /*MI*/3, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 278446 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/3,
     /* 278448 */     // MIs[1] Operand 2
     /* 278448 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278459 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278461 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 278461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278474 */     GIR_RootConstrainSelectedInstOperands,
     /* 278475 */     // GIR_Coverage, 5432,
     /* 278475 */     GIR_EraseRootFromParent_Done,
     /* 278476 */   // Label 5397: @278476
     /* 278476 */   GIM_Try, /*On fail goto*//*Label 5398*/ GIMT_Encode4(278547), // Rule ID 5428 //
     /* 278481 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278485 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278489 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278493 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278497 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ADD),
     /* 278501 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278505 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278509 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278514 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278519 */     // MIs[1] Operand 2
     /* 278519 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278530 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278532 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (ADDHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278532 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ADDHNv8i16_v8i8),
     /* 278535 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278541 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278545 */     GIR_RootConstrainSelectedInstOperands,
     /* 278546 */     // GIR_Coverage, 5428,
     /* 278546 */     GIR_EraseRootFromParent_Done,
     /* 278547 */   // Label 5398: @278547
     /* 278547 */   GIM_Try, /*On fail goto*//*Label 5399*/ GIMT_Encode4(278618), // Rule ID 5430 //
     /* 278552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 278572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 278580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278590 */     // MIs[1] Operand 2
     /* 278590 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 278601 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278603 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm), 8:{ *:[i32] }))  =>  (SUBHNv8i16_v8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 278603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBHNv8i16_v8i8),
     /* 278606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 278612 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/2, // Rm
     /* 278616 */     GIR_RootConstrainSelectedInstOperands,
     /* 278617 */     // GIR_Coverage, 5430,
     /* 278617 */     GIR_EraseRootFromParent_Done,
     /* 278618 */   // Label 5399: @278618
     /* 278618 */   GIM_Try, /*On fail goto*//*Label 5400*/ GIMT_Encode4(278710), // Rule ID 5533 //
     /* 278623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278631 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 278646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278650 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278654 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278659 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 278663 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_TRUNC),
     /* 278667 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 278671 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 278678 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vn), (trunc:{ *:[v4i16] } V128:{ *:[v4i32] }:$Vm)))  =>  (XTNv8i8:{ *:[v8i8] } (UZP1v8i16:{ *:[f128] } V128:{ *:[v4i32] }:$Vn, V128:{ *:[v4i32] }:$Vm))
     /* 278678 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 278681 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 278685 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278690 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Vn
     /* 278694 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, // Vm
     /* 278698 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278708 */     GIR_RootConstrainSelectedInstOperands,
     /* 278709 */     // GIR_Coverage, 5533,
     /* 278709 */     GIR_EraseRootFromParent_Done,
     /* 278710 */   // Label 5400: @278710
     /* 278710 */   GIM_Try, /*On fail goto*//*Label 5401*/ GIMT_Encode4(278763), // Rule ID 2160 //
     /* 278715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VASHR),
     /* 278726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278735 */     // MIs[1] imm
     /* 278735 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278739 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278743 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278747 */     // MIs[2] Operand 1
     /* 278747 */     // No operand predicates
     /* 278747 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278749 */     // (trunc:{ *:[v8i8] } (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 278749 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278752 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278758 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278761 */     GIR_RootConstrainSelectedInstOperands,
     /* 278762 */     // GIR_Coverage, 2160,
     /* 278762 */     GIR_EraseRootFromParent_Done,
     /* 278763 */   // Label 5401: @278763
     /* 278763 */   GIM_Try, /*On fail goto*//*Label 5402*/ GIMT_Encode4(278813), // Rule ID 6378 //
     /* 278768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_VLSHR),
     /* 278776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 278780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278785 */     // MIs[1] imm
     /* 278785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 278789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 278793 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16Narrow),
     /* 278797 */     // MIs[2] Operand 1
     /* 278797 */     // No operand predicates
     /* 278797 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 278799 */     // (trunc:{ *:[v8i8] } (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm))  =>  (SHRNv8i8_shift:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16Narrow>>:$imm)
     /* 278799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SHRNv8i8_shift),
     /* 278802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 278808 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 278811 */     GIR_RootConstrainSelectedInstOperands,
     /* 278812 */     // GIR_Coverage, 6378,
     /* 278812 */     GIR_EraseRootFromParent_Done,
     /* 278813 */   // Label 5402: @278813
     /* 278813 */   GIM_Try, /*On fail goto*//*Label 5403*/ GIMT_Encode4(278864), // Rule ID 5587 //
     /* 278818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 278822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONCAT_VECTORS),
     /* 278826 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 278829 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 278833 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 278837 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278842 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 278847 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 278849 */     // (trunc:{ *:[v8i8] } (concat_vectors:{ *:[v8i16] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm))  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vm)
     /* 278849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 278852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 278854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 278858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Vm
     /* 278862 */     GIR_RootConstrainSelectedInstOperands,
     /* 278863 */     // GIR_Coverage, 5587,
     /* 278863 */     GIR_EraseRootFromParent_Done,
     /* 278864 */   // Label 5403: @278864
     /* 278864 */   GIM_Try, /*On fail goto*//*Label 5404*/ GIMT_Encode4(278883), // Rule ID 1097 //
     /* 278869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 278872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 278876 */     // (trunc:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)  =>  (XTNv8i8:{ *:[v8i8] } V128:{ *:[v8i16] }:$Rn)
     /* 278876 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::XTNv8i8),
     /* 278881 */     GIR_RootConstrainSelectedInstOperands,
     /* 278882 */     // GIR_Coverage, 1097,
     /* 278882 */     GIR_Done,
     /* 278883 */   // Label 5404: @278883
     /* 278883 */   GIM_Reject,
     /* 278884 */ // Label 5396: @278884
     /* 278884 */ GIM_Reject,
     /* 278885 */ // Label 5378: @278885
     /* 278885 */ GIM_Reject,
     /* 278886 */ // Label 41: @278886
     /* 278886 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5407*/ GIMT_Encode4(279005),
     /* 278897 */ /*GILLT_s32*//*Label 5405*/ GIMT_Encode4(278905),
     /* 278901 */ /*GILLT_s64*//*Label 5406*/ GIMT_Encode4(278925),
     /* 278905 */ // Label 5405: @278905
     /* 278905 */ GIM_Try, /*On fail goto*//*Label 5408*/ GIMT_Encode4(278924), // Rule ID 81 //
     /* 278910 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278914 */   // MIs[0] Operand 1
     /* 278914 */   // No operand predicates
     /* 278914 */   // (imm:{ *:[i32] }):$src  =>  (MOVi32imm:{ *:[i32] } (imm:{ *:[i32] }):$src)
     /* 278914 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 278917 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278919 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 278922 */   GIR_RootConstrainSelectedInstOperands,
     /* 278923 */   // GIR_Coverage, 81,
     /* 278923 */   GIR_EraseRootFromParent_Done,
     /* 278924 */ // Label 5408: @278924
     /* 278924 */ GIM_Reject,
     /* 278925 */ // Label 5406: @278925
     /* 278925 */ GIM_Try, /*On fail goto*//*Label 5409*/ GIMT_Encode4(278985), // Rule ID 3904 //
     /* 278930 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_OptimizedGISelOrOtherSelector),
     /* 278933 */   GIM_CheckI64ImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_i64imm_32bit),
     /* 278937 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 278941 */   // MIs[0] Operand 1
     /* 278941 */   // No operand predicates
     /* 278941 */   // (imm:{ *:[i64] })<<P:Predicate_i64imm_32bit>>:$src  =>  (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i64] }, (MOVi32imm:{ *:[i32] } (trunc_imm:{ *:[i32] } (imm:{ *:[i64] }):$src)), sub_32:{ *:[i32] })
     /* 278941 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 278944 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVi32imm),
     /* 278948 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 278953 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // src
     /* 278958 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 278960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 278963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278965 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 278968 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 278971 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/20,
     /* 278974 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 278979 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 278984 */   // GIR_Coverage, 3904,
     /* 278984 */   GIR_EraseRootFromParent_Done,
     /* 278985 */ // Label 5409: @278985
     /* 278985 */ GIM_Try, /*On fail goto*//*Label 5410*/ GIMT_Encode4(279004), // Rule ID 82 //
     /* 278990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 278994 */   // MIs[0] Operand 1
     /* 278994 */   // No operand predicates
     /* 278994 */   // (imm:{ *:[i64] }):$src  =>  (MOVi64imm:{ *:[i64] } (imm:{ *:[i64] }):$src)
     /* 278994 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::MOVi64imm),
     /* 278997 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 278999 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/0, // src
     /* 279002 */   GIR_RootConstrainSelectedInstOperands,
     /* 279003 */   // GIR_Coverage, 82,
     /* 279003 */   GIR_EraseRootFromParent_Done,
     /* 279004 */ // Label 5410: @279004
     /* 279004 */ GIM_Reject,
     /* 279005 */ // Label 5407: @279005
     /* 279005 */ GIM_Reject,
     /* 279006 */ // Label 42: @279006
     /* 279006 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 5414*/ GIMT_Encode4(279246),
     /* 279017 */ /*GILLT_s16*//*Label 5411*/ GIMT_Encode4(279029),
     /* 279021 */ /*GILLT_s32*//*Label 5412*/ GIMT_Encode4(279081),
     /* 279025 */ /*GILLT_s64*//*Label 5413*/ GIMT_Encode4(279194),
     /* 279029 */ // Label 5411: @279029
     /* 279029 */ GIM_Try, /*On fail goto*//*Label 5415*/ GIMT_Encode4(279052), // Rule ID 506 //
     /* 279034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279037 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279045 */   // MIs[0] Operand 1
     /* 279045 */   // No operand predicates
     /* 279045 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>  =>  (FMOVH0:{ *:[f16] })
     /* 279045 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVH0),
     /* 279048 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279050 */   GIR_RootConstrainSelectedInstOperands,
     /* 279051 */   // GIR_Coverage, 506,
     /* 279051 */   GIR_EraseRootFromParent_Done,
     /* 279052 */ // Label 5415: @279052
     /* 279052 */ GIM_Try, /*On fail goto*//*Label 5416*/ GIMT_Encode4(279080), // Rule ID 688 //
     /* 279057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 279060 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 279064 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279068 */   // MIs[0] Operand 1
     /* 279068 */   // No operand predicates
     /* 279068 */   // (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm  =>  (FMOVHi:{ *:[f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] }):$imm))
     /* 279068 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVHi),
     /* 279071 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279073 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm
     /* 279078 */   GIR_RootConstrainSelectedInstOperands,
     /* 279079 */   // GIR_Coverage, 688,
     /* 279079 */   GIR_EraseRootFromParent_Done,
     /* 279080 */ // Label 5416: @279080
     /* 279080 */ GIM_Reject,
     /* 279081 */ // Label 5412: @279081
     /* 279081 */ GIM_Try, /*On fail goto*//*Label 5417*/ GIMT_Encode4(279104), // Rule ID 507 //
     /* 279086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279089 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279093 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279097 */   // MIs[0] Operand 1
     /* 279097 */   // No operand predicates
     /* 279097 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>  =>  (FMOVS0:{ *:[f32] })
     /* 279097 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVS0),
     /* 279100 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279102 */   GIR_RootConstrainSelectedInstOperands,
     /* 279103 */   // GIR_Coverage, 507,
     /* 279103 */   GIR_EraseRootFromParent_Done,
     /* 279104 */ // Label 5417: @279104
     /* 279104 */ GIM_Try, /*On fail goto*//*Label 5418*/ GIMT_Encode4(279132), // Rule ID 689 //
     /* 279109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279112 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 279116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279120 */   // MIs[0] Operand 1
     /* 279120 */   // No operand predicates
     /* 279120 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm  =>  (FMOVSi:{ *:[f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] }):$imm))
     /* 279120 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVSi),
     /* 279123 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279125 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm
     /* 279130 */   GIR_RootConstrainSelectedInstOperands,
     /* 279131 */   // GIR_Coverage, 689,
     /* 279131 */   GIR_EraseRootFromParent_Done,
     /* 279132 */ // Label 5418: @279132
     /* 279132 */ GIM_Try, /*On fail goto*//*Label 5419*/ GIMT_Encode4(279193), // Rule ID 6067 //
     /* 279137 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 279140 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32SIMDModImmType4),
     /* 279144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279148 */   // MIs[0] Operand 1
     /* 279148 */   // No operand predicates
     /* 279148 */   // (fpimm:{ *:[f32] })<<P:Predicate_fpimm32SIMDModImmType4>><<X:fpimm32SIMDModImmType4XForm>>:$in  =>  (EXTRACT_SUBREG:{ *:[f32] } (MOVIv2i32:{ *:[i64] } (fpimm32SIMDModImmType4XForm:{ *:[i32] } f32:{ *:[f32] }:$in), 24:{ *:[i32] }), ssub:{ *:[i32] })
     /* 279148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 279151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2i32),
     /* 279155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279160 */   GIR_CustomRenderer, /*InsnID*/1, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32SIMDModImmType4), // in
     /* 279165 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/24,
     /* 279168 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 279170 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 279173 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 279175 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 279182 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 279187 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279192 */   // GIR_Coverage, 6067,
     /* 279192 */   GIR_EraseRootFromParent_Done,
     /* 279193 */ // Label 5419: @279193
     /* 279193 */ GIM_Reject,
     /* 279194 */ // Label 5413: @279194
     /* 279194 */ GIM_Try, /*On fail goto*//*Label 5420*/ GIMT_Encode4(279217), // Rule ID 508 //
     /* 279199 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279202 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 279206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279210 */   // MIs[0] Operand 1
     /* 279210 */   // No operand predicates
     /* 279210 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>  =>  (FMOVD0:{ *:[f64] })
     /* 279210 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVD0),
     /* 279213 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279215 */   GIR_RootConstrainSelectedInstOperands,
     /* 279216 */   // GIR_Coverage, 508,
     /* 279216 */   GIR_EraseRootFromParent_Done,
     /* 279217 */ // Label 5420: @279217
     /* 279217 */ GIM_Try, /*On fail goto*//*Label 5421*/ GIMT_Encode4(279245), // Rule ID 690 //
     /* 279222 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 279225 */   GIM_CheckAPFloatImmPredicate, /*MI*/0, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 279229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279233 */   // MIs[0] Operand 1
     /* 279233 */   // No operand predicates
     /* 279233 */   // (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm  =>  (FMOVDi:{ *:[f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] }):$imm))
     /* 279233 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMOVDi),
     /* 279236 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279238 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm
     /* 279243 */   GIR_RootConstrainSelectedInstOperands,
     /* 279244 */   // GIR_Coverage, 690,
     /* 279244 */   GIR_EraseRootFromParent_Done,
     /* 279245 */ // Label 5421: @279245
     /* 279245 */ GIM_Reject,
     /* 279246 */ // Label 5414: @279246
     /* 279246 */ GIM_Reject,
     /* 279247 */ // Label 43: @279247
     /* 279247 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5427*/ GIMT_Encode4(281144),
     /* 279258 */ /*GILLT_s32*//*Label 5422*/ GIMT_Encode4(279294),
     /* 279262 */ /*GILLT_s64*//*Label 5423*/ GIMT_Encode4(280735), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 279274 */ /*GILLT_v2s64*//*Label 5424*/ GIMT_Encode4(280958), GIMT_Encode4(0),
     /* 279282 */ /*GILLT_v4s32*//*Label 5425*/ GIMT_Encode4(281020), GIMT_Encode4(0),
     /* 279290 */ /*GILLT_v8s16*//*Label 5426*/ GIMT_Encode4(281082),
     /* 279294 */ // Label 5422: @279294
     /* 279294 */ GIM_Try, /*On fail goto*//*Label 5428*/ GIMT_Encode4(279414), // Rule ID 13199 //
     /* 279299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279306 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279310 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279314 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279317 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279322 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279326 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279331 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279333 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279333 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279336 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 279340 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279345 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279351 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279354 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279358 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279363 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279365 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279368 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279372 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279377 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279380 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279383 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279386 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279391 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279396 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279401 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279404 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279406 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279409 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279412 */   GIR_RootConstrainSelectedInstOperands,
     /* 279413 */   // GIR_Coverage, 13199,
     /* 279413 */   GIR_EraseRootFromParent_Done,
     /* 279414 */ // Label 5428: @279414
     /* 279414 */ GIM_Try, /*On fail goto*//*Label 5429*/ GIMT_Encode4(279534), // Rule ID 13201 //
     /* 279419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279422 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279426 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279430 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279434 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279437 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279442 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279446 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279451 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279453 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 669:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279453 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279456 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 279460 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279465 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279469 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279471 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279474 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279478 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279483 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279485 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279488 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279492 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279497 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279500 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279503 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279506 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279511 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279516 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279521 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279524 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279526 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279529 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279532 */   GIR_RootConstrainSelectedInstOperands,
     /* 279533 */   // GIR_Coverage, 13201,
     /* 279533 */   GIR_EraseRootFromParent_Done,
     /* 279534 */ // Label 5429: @279534
     /* 279534 */ GIM_Try, /*On fail goto*//*Label 5430*/ GIMT_Encode4(279654), // Rule ID 13203 //
     /* 279539 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279542 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279546 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279550 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279554 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279557 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279562 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 279566 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279571 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279573 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279573 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279576 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 279580 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279585 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279591 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279594 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279598 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279603 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279605 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279608 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279612 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279617 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279620 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279623 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279626 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279631 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279636 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279649 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279652 */   GIR_RootConstrainSelectedInstOperands,
     /* 279653 */   // GIR_Coverage, 13203,
     /* 279653 */   GIR_EraseRootFromParent_Done,
     /* 279654 */ // Label 5430: @279654
     /* 279654 */ GIM_Try, /*On fail goto*//*Label 5431*/ GIMT_Encode4(279774), // Rule ID 13205 //
     /* 279659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 279662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279666 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279674 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279677 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddv),
     /* 279682 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 279686 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279691 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279693 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 669:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279693 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 279696 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 279700 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279705 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279709 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279711 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279714 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279718 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279723 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279725 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279728 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279732 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279737 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279740 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279743 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 279746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279756 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 279761 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 279764 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279766 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279769 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279772 */   GIR_RootConstrainSelectedInstOperands,
     /* 279773 */   // GIR_Coverage, 13205,
     /* 279773 */   GIR_EraseRootFromParent_Done,
     /* 279774 */ // Label 5431: @279774
     /* 279774 */ GIM_Try, /*On fail goto*//*Label 5432*/ GIMT_Encode4(279894), // Rule ID 13221 //
     /* 279779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279786 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279790 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279794 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279797 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 279802 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 279806 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 279811 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279813 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279813 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279816 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 279820 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279825 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279829 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279831 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279834 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279838 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279843 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279845 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279848 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279852 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279857 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279860 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279863 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279866 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279871 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279876 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 279881 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 279884 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 279886 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 279889 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 279892 */   GIR_RootConstrainSelectedInstOperands,
     /* 279893 */   // GIR_Coverage, 13221,
     /* 279893 */   GIR_EraseRootFromParent_Done,
     /* 279894 */ // Label 5432: @279894
     /* 279894 */ GIM_Try, /*On fail goto*//*Label 5433*/ GIMT_Encode4(280014), // Rule ID 13223 //
     /* 279899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 279902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 279906 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 279910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 279914 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 279917 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 279922 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 279926 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279931 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 279933 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 679:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 279933 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 279936 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 279940 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279945 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 279949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 279951 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 279954 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 279958 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 279965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 279968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 279972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 279977 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 279980 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 279983 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 279986 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279991 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 279996 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280001 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280004 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280006 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280009 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280012 */   GIR_RootConstrainSelectedInstOperands,
     /* 280013 */   // GIR_Coverage, 13223,
     /* 280013 */   GIR_EraseRootFromParent_Done,
     /* 280014 */ // Label 5433: @280014
     /* 280014 */ GIM_Try, /*On fail goto*//*Label 5434*/ GIMT_Encode4(280134), // Rule ID 13225 //
     /* 280019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280026 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280034 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280037 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280053 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280053 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280056 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 280060 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280065 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280071 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280074 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280078 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280100 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280103 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280106 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280111 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280116 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280121 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280124 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280126 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280129 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280132 */   GIR_RootConstrainSelectedInstOperands,
     /* 280133 */   // GIR_Coverage, 13225,
     /* 280133 */   GIR_EraseRootFromParent_Done,
     /* 280134 */ // Label 5434: @280134
     /* 280134 */ GIM_Try, /*On fail goto*//*Label 5435*/ GIMT_Encode4(280254), // Rule ID 13227 //
     /* 280139 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280146 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280150 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280154 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280157 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_smaxv),
     /* 280162 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280166 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280171 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280173 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 679:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280173 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280176 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 280180 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280185 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280189 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280191 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280194 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280198 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280205 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280208 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280212 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280217 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280220 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280223 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280226 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280231 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280236 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280241 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280244 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280246 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280249 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280252 */   GIR_RootConstrainSelectedInstOperands,
     /* 280253 */   // GIR_Coverage, 13227,
     /* 280253 */   GIR_EraseRootFromParent_Done,
     /* 280254 */ // Label 5435: @280254
     /* 280254 */ GIM_Try, /*On fail goto*//*Label 5436*/ GIMT_Encode4(280374), // Rule ID 13231 //
     /* 280259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280266 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280274 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280277 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280282 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 280286 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280291 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280293 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280293 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280296 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 280300 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280305 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280309 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280311 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280314 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280318 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280323 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280325 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280328 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280332 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280337 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280340 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280343 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280346 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280351 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280356 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280366 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280369 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280372 */   GIR_RootConstrainSelectedInstOperands,
     /* 280373 */   // GIR_Coverage, 13231,
     /* 280373 */   GIR_EraseRootFromParent_Done,
     /* 280374 */ // Label 5436: @280374
     /* 280374 */ GIM_Try, /*On fail goto*//*Label 5437*/ GIMT_Encode4(280494), // Rule ID 13233 //
     /* 280379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 280382 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280386 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280390 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280394 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280397 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280402 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 280406 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280411 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280413 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 682:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SMOVvi8to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280413 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 280416 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 280420 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280425 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280429 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280431 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280434 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280438 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280443 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280460 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280463 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 280466 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280471 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280476 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 280481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 280484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280486 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280489 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280492 */   GIR_RootConstrainSelectedInstOperands,
     /* 280493 */   // GIR_Coverage, 13233,
     /* 280493 */   GIR_EraseRootFromParent_Done,
     /* 280494 */ // Label 5437: @280494
     /* 280494 */ GIM_Try, /*On fail goto*//*Label 5438*/ GIMT_Encode4(280614), // Rule ID 13235 //
     /* 280499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280506 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280510 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280514 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280517 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280522 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 280526 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 280531 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280533 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280533 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280536 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 280540 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280545 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280549 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280551 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280554 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280558 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280563 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280565 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280568 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280572 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280577 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280580 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280583 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280596 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280601 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280604 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280606 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280609 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280612 */   GIR_RootConstrainSelectedInstOperands,
     /* 280613 */   // GIR_Coverage, 13235,
     /* 280613 */   GIR_EraseRootFromParent_Done,
     /* 280614 */ // Label 5438: @280614
     /* 280614 */ GIM_Try, /*On fail goto*//*Label 5439*/ GIMT_Encode4(280734), // Rule ID 13237 //
     /* 280619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 280622 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280626 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280630 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 280634 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 280637 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sminv),
     /* 280642 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 280646 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280651 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 280653 */   // (sext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 682:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SMOVvi16to32:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (SMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 280653 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 280656 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 280660 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280665 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 280669 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 280671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 280674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 280688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280697 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280700 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 280703 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 280706 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280711 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280716 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 280721 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 280724 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280726 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280729 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280732 */   GIR_RootConstrainSelectedInstOperands,
     /* 280733 */   // GIR_Coverage, 13237,
     /* 280733 */   GIR_EraseRootFromParent_Done,
     /* 280734 */ // Label 5439: @280734
     /* 280734 */ GIM_Reject,
     /* 280735 */ // Label 5423: @280735
     /* 280735 */ GIM_Try, /*On fail goto*//*Label 5440*/ GIMT_Encode4(280957),
     /* 280740 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 280743 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 280747 */   GIM_Try, /*On fail goto*//*Label 5441*/ GIMT_Encode4(280801), // Rule ID 5673 //
     /* 280752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 280764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280785 */     // MIs[2] Operand 1
     /* 280785 */     // No operand predicates
     /* 280785 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280787 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMOVvi32to64:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 280787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280792 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 280796 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 280799 */     GIR_RootConstrainSelectedInstOperands,
     /* 280800 */     // GIR_Coverage, 5673,
     /* 280800 */     GIR_EraseRootFromParent_Done,
     /* 280801 */   // Label 5441: @280801
     /* 280801 */   GIM_Try, /*On fail goto*//*Label 5442*/ GIMT_Encode4(280880), // Rule ID 11282 //
     /* 280806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 280809 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 280813 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 280817 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 280821 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 280825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 280829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 280833 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 280837 */     // MIs[2] Operand 1
     /* 280837 */     // No operand predicates
     /* 280837 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 280839 */     // (sext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index))  =>  (SMOVvi32to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 280839 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 280842 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 280846 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280851 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 280857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 280867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi32to64),
     /* 280870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280872 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280875 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 280878 */     GIR_RootConstrainSelectedInstOperands,
     /* 280879 */     // GIR_Coverage, 11282,
     /* 280879 */     GIR_EraseRootFromParent_Done,
     /* 280880 */   // Label 5442: @280880
     /* 280880 */   GIM_Try, /*On fail goto*//*Label 5443*/ GIMT_Encode4(280956), // Rule ID 6537 //
     /* 280885 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280889 */     // (sext:{ *:[i64] } GPR32:{ *:[i32] }:$src)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$src, sub_32:{ *:[i32] }), 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 280889 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 280892 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 280896 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280901 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 280903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 280906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 280910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 280915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 280918 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 280922 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 280925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 280930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 280935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 280940 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 280943 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280945 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 280948 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 280954 */     GIR_RootConstrainSelectedInstOperands,
     /* 280955 */     // GIR_Coverage, 6537,
     /* 280955 */     GIR_EraseRootFromParent_Done,
     /* 280956 */   // Label 5443: @280956
     /* 280956 */   GIM_Reject,
     /* 280957 */ // Label 5440: @280957
     /* 280957 */ GIM_Reject,
     /* 280958 */ // Label 5424: @280958
     /* 280958 */ GIM_Try, /*On fail goto*//*Label 5444*/ GIMT_Encode4(281019),
     /* 280963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 280966 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 280970 */   GIM_Try, /*On fail goto*//*Label 5445*/ GIMT_Encode4(280997), // Rule ID 6407 //
     /* 280975 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 280982 */     // (sext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SSHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 280982 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i32_shift),
     /* 280985 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 280987 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 280992 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 280995 */     GIR_RootConstrainSelectedInstOperands,
     /* 280996 */     // GIR_Coverage, 6407,
     /* 280996 */     GIR_EraseRootFromParent_Done,
     /* 280997 */   // Label 5445: @280997
     /* 280997 */   GIM_Try, /*On fail goto*//*Label 5446*/ GIMT_Encode4(281018), // Rule ID 6396 //
     /* 281002 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281006 */     // (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 281006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 281009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281013 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281016 */     GIR_RootConstrainSelectedInstOperands,
     /* 281017 */     // GIR_Coverage, 6396,
     /* 281017 */     GIR_EraseRootFromParent_Done,
     /* 281018 */   // Label 5446: @281018
     /* 281018 */   GIM_Reject,
     /* 281019 */ // Label 5444: @281019
     /* 281019 */ GIM_Reject,
     /* 281020 */ // Label 5425: @281020
     /* 281020 */ GIM_Try, /*On fail goto*//*Label 5447*/ GIMT_Encode4(281081),
     /* 281025 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 281028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281032 */   GIM_Try, /*On fail goto*//*Label 5448*/ GIMT_Encode4(281059), // Rule ID 6404 //
     /* 281037 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 281044 */     // (sext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SSHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 281044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i16_shift),
     /* 281047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281057 */     GIR_RootConstrainSelectedInstOperands,
     /* 281058 */     // GIR_Coverage, 6404,
     /* 281058 */     GIR_EraseRootFromParent_Done,
     /* 281059 */   // Label 5448: @281059
     /* 281059 */   GIM_Try, /*On fail goto*//*Label 5449*/ GIMT_Encode4(281080), // Rule ID 6393 //
     /* 281064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281068 */     // (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 281068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 281071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281073 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281075 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281078 */     GIR_RootConstrainSelectedInstOperands,
     /* 281079 */     // GIR_Coverage, 6393,
     /* 281079 */     GIR_EraseRootFromParent_Done,
     /* 281080 */   // Label 5449: @281080
     /* 281080 */   GIM_Reject,
     /* 281081 */ // Label 5447: @281081
     /* 281081 */ GIM_Reject,
     /* 281082 */ // Label 5426: @281082
     /* 281082 */ GIM_Try, /*On fail goto*//*Label 5450*/ GIMT_Encode4(281143),
     /* 281087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 281090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281094 */   GIM_Try, /*On fail goto*//*Label 5451*/ GIMT_Encode4(281121), // Rule ID 6401 //
     /* 281099 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 281106 */     // (sext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (SSHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 281106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv16i8_shift),
     /* 281109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281111 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 281116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281119 */     GIR_RootConstrainSelectedInstOperands,
     /* 281120 */     // GIR_Coverage, 6401,
     /* 281120 */     GIR_EraseRootFromParent_Done,
     /* 281121 */   // Label 5451: @281121
     /* 281121 */   GIM_Try, /*On fail goto*//*Label 5452*/ GIMT_Encode4(281142), // Rule ID 6390 //
     /* 281126 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 281130 */     // (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 281130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 281133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 281137 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281140 */     GIR_RootConstrainSelectedInstOperands,
     /* 281141 */     // GIR_Coverage, 6390,
     /* 281141 */     GIR_EraseRootFromParent_Done,
     /* 281142 */   // Label 5452: @281142
     /* 281142 */   GIM_Reject,
     /* 281143 */ // Label 5450: @281143
     /* 281143 */ GIM_Reject,
     /* 281144 */ // Label 5427: @281144
     /* 281144 */ GIM_Reject,
     /* 281145 */ // Label 44: @281145
     /* 281145 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(22), /*)*//*default:*//*Label 5458*/ GIMT_Encode4(282798),
     /* 281156 */ /*GILLT_s32*//*Label 5453*/ GIMT_Encode4(281236),
     /* 281160 */ /*GILLT_s64*//*Label 5454*/ GIMT_Encode4(281730), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281212 */ /*GILLT_nxv2s64*//*Label 5455*/ GIMT_Encode4(282372), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 281224 */ /*GILLT_nxv4s32*//*Label 5456*/ GIMT_Encode4(282581), GIMT_Encode4(0),
     /* 281232 */ /*GILLT_nxv8s16*//*Label 5457*/ GIMT_Encode4(282725),
     /* 281236 */ // Label 5453: @281236
     /* 281236 */ GIM_Try, /*On fail goto*//*Label 5459*/ GIMT_Encode4(281729),
     /* 281241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 281244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281248 */   GIM_Try, /*On fail goto*//*Label 5460*/ GIMT_Encode4(281313), // Rule ID 5668 //
     /* 281253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281265 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281269 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281282 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281286 */     // MIs[2] Operand 1
     /* 281286 */     // No operand predicates
     /* 281286 */     // MIs[0] Operand 2
     /* 281286 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281299 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281304 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281308 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281311 */     GIR_RootConstrainSelectedInstOperands,
     /* 281312 */     // GIR_Coverage, 5668,
     /* 281312 */     GIR_EraseRootFromParent_Done,
     /* 281313 */   // Label 5460: @281313
     /* 281313 */   GIM_Try, /*On fail goto*//*Label 5461*/ GIMT_Encode4(281378), // Rule ID 5670 //
     /* 281318 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281322 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281326 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281330 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281334 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281347 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281351 */     // MIs[2] Operand 1
     /* 281351 */     // No operand predicates
     /* 281351 */     // MIs[0] Operand 2
     /* 281351 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281362 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281364 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281364 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281367 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281376 */     GIR_RootConstrainSelectedInstOperands,
     /* 281377 */     // GIR_Coverage, 5670,
     /* 281377 */     GIR_EraseRootFromParent_Done,
     /* 281378 */   // Label 5461: @281378
     /* 281378 */   GIM_Try, /*On fail goto*//*Label 5462*/ GIMT_Encode4(281443), // Rule ID 5672 //
     /* 281383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281412 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281416 */     // MIs[2] Operand 1
     /* 281416 */     // No operand predicates
     /* 281416 */     // MIs[0] Operand 2
     /* 281416 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281427 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281429 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281429 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281432 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 281438 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 281441 */     GIR_RootConstrainSelectedInstOperands,
     /* 281442 */     // GIR_Coverage, 5672,
     /* 281442 */     GIR_EraseRootFromParent_Done,
     /* 281443 */   // Label 5462: @281443
     /* 281443 */   GIM_Try, /*On fail goto*//*Label 5463*/ GIMT_Encode4(281533), // Rule ID 11278 //
     /* 281448 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281459 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281463 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281467 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281471 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281475 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281479 */     // MIs[2] Operand 1
     /* 281479 */     // No operand predicates
     /* 281479 */     // MIs[0] Operand 2
     /* 281479 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281490 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281492 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index), i8:{ *:[Other] })  =>  (SMOVvi8to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 281492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281504 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281510 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281515 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to32),
     /* 281523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281525 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281528 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281531 */     GIR_RootConstrainSelectedInstOperands,
     /* 281532 */     // GIR_Coverage, 11278,
     /* 281532 */     GIR_EraseRootFromParent_Done,
     /* 281533 */   // Label 5463: @281533
     /* 281533 */   GIM_Try, /*On fail goto*//*Label 5464*/ GIMT_Encode4(281623), // Rule ID 11280 //
     /* 281538 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281545 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281549 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 281553 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 281557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 281561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281565 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281569 */     // MIs[2] Operand 1
     /* 281569 */     // No operand predicates
     /* 281569 */     // MIs[0] Operand 2
     /* 281569 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 281582 */     // (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index), i16:{ *:[Other] })  =>  (SMOVvi16to32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 281582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 281585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to32),
     /* 281613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 281621 */     GIR_RootConstrainSelectedInstOperands,
     /* 281622 */     // GIR_Coverage, 11280,
     /* 281622 */     GIR_EraseRootFromParent_Done,
     /* 281623 */   // Label 5464: @281623
     /* 281623 */   GIM_Try, /*On fail goto*//*Label 5465*/ GIMT_Encode4(281658), // Rule ID 6542 //
     /* 281628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281632 */     // MIs[0] Operand 2
     /* 281632 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281643 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i16:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 281643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281648 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281650 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281653 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 281656 */     GIR_RootConstrainSelectedInstOperands,
     /* 281657 */     // GIR_Coverage, 6542,
     /* 281657 */     GIR_EraseRootFromParent_Done,
     /* 281658 */   // Label 5465: @281658
     /* 281658 */   GIM_Try, /*On fail goto*//*Label 5466*/ GIMT_Encode4(281693), // Rule ID 6543 //
     /* 281663 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281667 */     // MIs[0] Operand 2
     /* 281667 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281678 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i8:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 281678 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281681 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281683 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281685 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281688 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 281691 */     GIR_RootConstrainSelectedInstOperands,
     /* 281692 */     // GIR_Coverage, 6543,
     /* 281692 */     GIR_EraseRootFromParent_Done,
     /* 281693 */   // Label 5466: @281693
     /* 281693 */   GIM_Try, /*On fail goto*//*Label 5467*/ GIMT_Encode4(281728), // Rule ID 6544 //
     /* 281698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 281702 */     // MIs[0] Operand 2
     /* 281702 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 281713 */     // (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$src, i1:{ *:[Other] })  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 281713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 281716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281718 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 281720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281723 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 281726 */     GIR_RootConstrainSelectedInstOperands,
     /* 281727 */     // GIR_Coverage, 6544,
     /* 281727 */     GIR_EraseRootFromParent_Done,
     /* 281728 */   // Label 5467: @281728
     /* 281728 */   GIM_Reject,
     /* 281729 */ // Label 5459: @281729
     /* 281729 */ GIM_Reject,
     /* 281730 */ // Label 5454: @281730
     /* 281730 */ GIM_Try, /*On fail goto*//*Label 5468*/ GIMT_Encode4(282371),
     /* 281735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 281738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 281742 */   GIM_Try, /*On fail goto*//*Label 5469*/ GIMT_Encode4(281819), // Rule ID 5674 //
     /* 281747 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281751 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281755 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281759 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281763 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281767 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 281771 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281775 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281788 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281792 */     // MIs[3] Operand 1
     /* 281792 */     // No operand predicates
     /* 281792 */     // MIs[0] Operand 2
     /* 281792 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281803 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281805 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 281805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 281808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 281814 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281817 */     GIR_RootConstrainSelectedInstOperands,
     /* 281818 */     // GIR_Coverage, 5674,
     /* 281818 */     GIR_EraseRootFromParent_Done,
     /* 281819 */   // Label 5469: @281819
     /* 281819 */   GIM_Try, /*On fail goto*//*Label 5470*/ GIMT_Encode4(281896), // Rule ID 5675 //
     /* 281824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281844 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 281848 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281857 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281861 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281865 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 281869 */     // MIs[3] Operand 1
     /* 281869 */     // No operand predicates
     /* 281869 */     // MIs[0] Operand 2
     /* 281869 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 281880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281882 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 281882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 281885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281887 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 281891 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 281894 */     GIR_RootConstrainSelectedInstOperands,
     /* 281895 */     // GIR_Coverage, 5675,
     /* 281895 */     GIR_EraseRootFromParent_Done,
     /* 281896 */   // Label 5470: @281896
     /* 281896 */   GIM_Try, /*On fail goto*//*Label 5471*/ GIMT_Encode4(281998), // Rule ID 11279 //
     /* 281901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 281904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 281908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 281912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 281916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 281920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 281924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 281928 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 281932 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 281936 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 281940 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 281944 */     // MIs[3] Operand 1
     /* 281944 */     // No operand predicates
     /* 281944 */     // MIs[0] Operand 2
     /* 281944 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 281955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 281957 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 281957 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 281960 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 281964 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 281969 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 281975 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 281980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 281985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 281988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 281990 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 281993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 281996 */     GIR_RootConstrainSelectedInstOperands,
     /* 281997 */     // GIR_Coverage, 11279,
     /* 281997 */     GIR_EraseRootFromParent_Done,
     /* 281998 */   // Label 5471: @281998
     /* 281998 */   GIM_Try, /*On fail goto*//*Label 5472*/ GIMT_Encode4(282100), // Rule ID 11281 //
     /* 282003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 282006 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282010 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 282014 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 282018 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 282022 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282026 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282030 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 282034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 282038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282042 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282046 */     // MIs[3] Operand 1
     /* 282046 */     // No operand predicates
     /* 282046 */     // MIs[0] Operand 2
     /* 282046 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282057 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 282059 */     // (sext_inreg:{ *:[i64] } (anyext:{ *:[i64] } (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 282059 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 282062 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282066 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282071 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 282077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282092 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // index
     /* 282098 */     GIR_RootConstrainSelectedInstOperands,
     /* 282099 */     // GIR_Coverage, 11281,
     /* 282099 */     GIR_EraseRootFromParent_Done,
     /* 282100 */   // Label 5472: @282100
     /* 282100 */   GIM_Try, /*On fail goto*//*Label 5473*/ GIMT_Encode4(282165), // Rule ID 5669 //
     /* 282105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 282117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 282138 */     // MIs[2] Operand 1
     /* 282138 */     // No operand predicates
     /* 282138 */     // MIs[0] Operand 2
     /* 282138 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282149 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282151 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx), i8:{ *:[Other] })  =>  (SMOVvi8to64:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)
     /* 282151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi8to64),
     /* 282154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282156 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282163 */     GIR_RootConstrainSelectedInstOperands,
     /* 282164 */     // GIR_Coverage, 5669,
     /* 282164 */     GIR_EraseRootFromParent_Done,
     /* 282165 */   // Label 5473: @282165
     /* 282165 */   GIM_Try, /*On fail goto*//*Label 5474*/ GIMT_Encode4(282230), // Rule ID 5671 //
     /* 282170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 282178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 282182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 282186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 282195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 282199 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 282203 */     // MIs[2] Operand 1
     /* 282203 */     // No operand predicates
     /* 282203 */     // MIs[0] Operand 2
     /* 282203 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 282216 */     // (sext_inreg:{ *:[i64] } (vector_extract:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), i16:{ *:[Other] })  =>  (SMOVvi16to64:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 282216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMOVvi16to64),
     /* 282219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 282225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 282228 */     GIR_RootConstrainSelectedInstOperands,
     /* 282229 */     // GIR_Coverage, 5671,
     /* 282229 */     GIR_EraseRootFromParent_Done,
     /* 282230 */   // Label 5474: @282230
     /* 282230 */   GIM_Try, /*On fail goto*//*Label 5475*/ GIMT_Encode4(282265), // Rule ID 6538 //
     /* 282235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282239 */     // MIs[0] Operand 2
     /* 282239 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282250 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i32:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 31:{ *:[i64] })
     /* 282250 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282253 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282255 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282257 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 282263 */     GIR_RootConstrainSelectedInstOperands,
     /* 282264 */     // GIR_Coverage, 6538,
     /* 282264 */     GIR_EraseRootFromParent_Done,
     /* 282265 */   // Label 5475: @282265
     /* 282265 */   GIM_Try, /*On fail goto*//*Label 5476*/ GIMT_Encode4(282300), // Rule ID 6539 //
     /* 282270 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282274 */     // MIs[0] Operand 2
     /* 282274 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282285 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i16:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 15:{ *:[i64] })
     /* 282285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282290 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282295 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 282298 */     GIR_RootConstrainSelectedInstOperands,
     /* 282299 */     // GIR_Coverage, 6539,
     /* 282299 */     GIR_EraseRootFromParent_Done,
     /* 282300 */   // Label 5476: @282300
     /* 282300 */   GIM_Try, /*On fail goto*//*Label 5477*/ GIMT_Encode4(282335), // Rule ID 6540 //
     /* 282305 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282309 */     // MIs[0] Operand 2
     /* 282309 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282320 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i8:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 7:{ *:[i64] })
     /* 282320 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282323 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282325 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282330 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 282333 */     GIR_RootConstrainSelectedInstOperands,
     /* 282334 */     // GIR_Coverage, 6540,
     /* 282334 */     GIR_EraseRootFromParent_Done,
     /* 282335 */   // Label 5477: @282335
     /* 282335 */   GIM_Try, /*On fail goto*//*Label 5478*/ GIMT_Encode4(282370), // Rule ID 6541 //
     /* 282340 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 282344 */     // MIs[0] Operand 2
     /* 282344 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 282355 */     // (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$src, i1:{ *:[Other] })  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$src, 0:{ *:[i64] }, 0:{ *:[i64] })
     /* 282355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 282358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 282360 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 282362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282365 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 282368 */     GIR_RootConstrainSelectedInstOperands,
     /* 282369 */     // GIR_Coverage, 6541,
     /* 282369 */     GIR_EraseRootFromParent_Done,
     /* 282370 */   // Label 5478: @282370
     /* 282370 */   GIM_Reject,
     /* 282371 */ // Label 5468: @282371
     /* 282371 */ GIM_Reject,
     /* 282372 */ // Label 5455: @282372
     /* 282372 */ GIM_Try, /*On fail goto*//*Label 5479*/ GIMT_Encode4(282580),
     /* 282377 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 282380 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282384 */   GIM_Try, /*On fail goto*//*Label 5480*/ GIMT_Encode4(282449), // Rule ID 10550 //
     /* 282389 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282392 */     // MIs[0] Operand 2
     /* 282392 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(32),
     /* 282403 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i32:{ *:[Other] })  =>  (SXTW_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282403 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282406 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282410 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282415 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282418 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282420 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282423 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282427 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282432 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTW_ZPmZ_D_UNDEF),
     /* 282437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282439 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282445 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282447 */     GIR_RootConstrainSelectedInstOperands,
     /* 282448 */     // GIR_Coverage, 10550,
     /* 282448 */     GIR_EraseRootFromParent_Done,
     /* 282449 */   // Label 5480: @282449
     /* 282449 */   GIM_Try, /*On fail goto*//*Label 5481*/ GIMT_Encode4(282514), // Rule ID 10551 //
     /* 282454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282457 */     // MIs[0] Operand 2
     /* 282457 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282468 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i16:{ *:[Other] })  =>  (SXTH_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282468 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282471 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282475 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282480 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282483 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282485 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282488 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282492 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_D_UNDEF),
     /* 282502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282504 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282510 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282512 */     GIR_RootConstrainSelectedInstOperands,
     /* 282513 */     // GIR_Coverage, 10551,
     /* 282513 */     GIR_EraseRootFromParent_Done,
     /* 282514 */   // Label 5481: @282514
     /* 282514 */   GIM_Try, /*On fail goto*//*Label 5482*/ GIMT_Encode4(282579), // Rule ID 10552 //
     /* 282519 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282522 */     // MIs[0] Operand 2
     /* 282522 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282533 */     // (sext_inreg:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, nxv2i8:{ *:[Other] })  =>  (SXTB_ZPmZ_D_UNDEF:{ *:[nxv2i64] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv2i64] }:$Zs)
     /* 282533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 282540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282545 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282548 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282562 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282564 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_D_UNDEF),
     /* 282567 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282569 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282572 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282577 */     GIR_RootConstrainSelectedInstOperands,
     /* 282578 */     // GIR_Coverage, 10552,
     /* 282578 */     GIR_EraseRootFromParent_Done,
     /* 282579 */   // Label 5482: @282579
     /* 282579 */   GIM_Reject,
     /* 282580 */ // Label 5479: @282580
     /* 282580 */ GIM_Reject,
     /* 282581 */ // Label 5456: @282581
     /* 282581 */ GIM_Try, /*On fail goto*//*Label 5483*/ GIMT_Encode4(282724),
     /* 282586 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 282589 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282593 */   GIM_Try, /*On fail goto*//*Label 5484*/ GIMT_Encode4(282658), // Rule ID 10553 //
     /* 282598 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282601 */     // MIs[0] Operand 2
     /* 282601 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(16),
     /* 282612 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i16:{ *:[Other] })  =>  (SXTH_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282612 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282615 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282619 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282624 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282627 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282629 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282632 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282636 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTH_ZPmZ_S_UNDEF),
     /* 282646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282648 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282654 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282656 */     GIR_RootConstrainSelectedInstOperands,
     /* 282657 */     // GIR_Coverage, 10553,
     /* 282657 */     GIR_EraseRootFromParent_Done,
     /* 282658 */   // Label 5484: @282658
     /* 282658 */   GIM_Try, /*On fail goto*//*Label 5485*/ GIMT_Encode4(282723), // Rule ID 10554 //
     /* 282663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282666 */     // MIs[0] Operand 2
     /* 282666 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282677 */     // (sext_inreg:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, nxv4i8:{ *:[Other] })  =>  (SXTB_ZPmZ_S_UNDEF:{ *:[nxv4i32] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv4i32] }:$Zs)
     /* 282677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 282684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282689 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282692 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282694 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282697 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282701 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282706 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_S_UNDEF),
     /* 282711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282713 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282719 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282721 */     GIR_RootConstrainSelectedInstOperands,
     /* 282722 */     // GIR_Coverage, 10554,
     /* 282722 */     GIR_EraseRootFromParent_Done,
     /* 282723 */   // Label 5485: @282723
     /* 282723 */   GIM_Reject,
     /* 282724 */ // Label 5483: @282724
     /* 282724 */ GIM_Reject,
     /* 282725 */ // Label 5457: @282725
     /* 282725 */ GIM_Try, /*On fail goto*//*Label 5486*/ GIMT_Encode4(282797), // Rule ID 10555 //
     /* 282730 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 282733 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 282736 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 282740 */   // MIs[0] Operand 2
     /* 282740 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 282751 */   // (sext_inreg:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Zs, nxv8i8:{ *:[Other] })  =>  (SXTB_ZPmZ_H_UNDEF:{ *:[nxv8i16] } (IMPLICIT_DEF:{ *:[nxv16i8] }), (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), ZPR:{ *:[nxv8i16] }:$Zs)
     /* 282751 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 282754 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 282758 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282763 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 282766 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 282768 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 282771 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282775 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282780 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 282782 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SXTB_ZPmZ_H_UNDEF),
     /* 282785 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 282787 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282790 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 282793 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 282795 */   GIR_RootConstrainSelectedInstOperands,
     /* 282796 */   // GIR_Coverage, 10555,
     /* 282796 */   GIR_EraseRootFromParent_Done,
     /* 282797 */ // Label 5486: @282797
     /* 282797 */ GIM_Reject,
     /* 282798 */ // Label 5458: @282798
     /* 282798 */ GIM_Reject,
     /* 282799 */ // Label 45: @282799
     /* 282799 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5491*/ GIMT_Encode4(285577),
     /* 282810 */ /*GILLT_s32*//*Label 5487*/ GIMT_Encode4(282846), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 282826 */ /*GILLT_v2s64*//*Label 5488*/ GIMT_Encode4(284647), GIMT_Encode4(0),
     /* 282834 */ /*GILLT_v4s32*//*Label 5489*/ GIMT_Encode4(284957), GIMT_Encode4(0),
     /* 282842 */ /*GILLT_v8s16*//*Label 5490*/ GIMT_Encode4(285267),
     /* 282846 */ // Label 5487: @282846
     /* 282846 */ GIM_Try, /*On fail goto*//*Label 5492*/ GIMT_Encode4(282996), // Rule ID 13208 //
     /* 282851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 282854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282858 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 282862 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 282866 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 282869 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 282874 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 282878 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 282883 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 282885 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 282885 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 282888 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 282892 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282897 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 282901 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 282903 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 282906 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 282910 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282915 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 282917 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 282920 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 282924 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282929 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 282932 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 282935 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 282938 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282943 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282948 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 282953 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 282956 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282960 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 282965 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 282972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 282977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 282982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 282985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 282987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 282990 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 282995 */   // GIR_Coverage, 13208,
     /* 282995 */   GIR_EraseRootFromParent_Done,
     /* 282996 */ // Label 5492: @282996
     /* 282996 */ GIM_Try, /*On fail goto*//*Label 5493*/ GIMT_Encode4(283146), // Rule ID 13210 //
     /* 283001 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283004 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283008 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283012 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283016 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283019 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283024 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283028 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283033 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283035 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 734:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283035 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283038 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 283042 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283047 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283053 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283056 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283060 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283079 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283082 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283085 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283088 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283093 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283098 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283115 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283122 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283127 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283132 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283135 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283137 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283140 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283145 */   // GIR_Coverage, 13210,
     /* 283145 */   GIR_EraseRootFromParent_Done,
     /* 283146 */ // Label 5493: @283146
     /* 283146 */ GIM_Try, /*On fail goto*//*Label 5494*/ GIMT_Encode4(283296), // Rule ID 13212 //
     /* 283151 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283154 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283158 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283162 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283166 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283169 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283174 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283178 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283183 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283185 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283185 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283188 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 283192 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283197 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283201 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283203 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283206 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283210 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283215 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283217 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283220 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283224 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283229 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283232 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283235 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283238 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283243 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283248 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283253 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283256 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283260 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283265 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283272 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283277 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283282 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283285 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283287 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283290 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283295 */   // GIR_Coverage, 13212,
     /* 283295 */   GIR_EraseRootFromParent_Done,
     /* 283296 */ // Label 5494: @283296
     /* 283296 */ GIM_Try, /*On fail goto*//*Label 5495*/ GIMT_Encode4(283446), // Rule ID 13214 //
     /* 283301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283308 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283316 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283319 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddv),
     /* 283324 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283328 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283333 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283335 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 734:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283335 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283338 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 283342 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283347 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283353 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283356 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283360 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283365 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283367 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283370 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283374 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283379 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283382 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283385 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283388 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283393 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283398 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283403 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283406 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283410 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283415 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283422 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283427 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283437 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283440 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283445 */   // GIR_Coverage, 13214,
     /* 283445 */   GIR_EraseRootFromParent_Done,
     /* 283446 */ // Label 5495: @283446
     /* 283446 */ GIM_Try, /*On fail goto*//*Label 5496*/ GIMT_Encode4(283596), // Rule ID 13241 //
     /* 283451 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283454 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283458 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283462 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283466 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283469 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283474 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 283478 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283483 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283485 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283485 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283488 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 283492 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283497 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283503 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283506 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283510 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283515 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283517 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283520 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283524 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283529 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283532 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283535 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283538 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283543 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283548 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283565 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283572 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283577 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283582 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283585 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283587 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283590 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283595 */   // GIR_Coverage, 13241,
     /* 283595 */   GIR_EraseRootFromParent_Done,
     /* 283596 */ // Label 5496: @283596
     /* 283596 */ GIM_Try, /*On fail goto*//*Label 5497*/ GIMT_Encode4(283746), // Rule ID 13243 //
     /* 283601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 283604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283608 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283612 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283616 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283619 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283624 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 283628 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283633 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283635 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 740:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283635 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 283638 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 283642 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283647 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283651 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283653 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283656 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283660 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283665 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283667 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283670 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283674 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283679 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283682 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283685 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 283688 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283693 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283698 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 283703 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283706 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283710 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283715 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283722 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283727 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283737 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283740 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283745 */   // GIR_Coverage, 13243,
     /* 283745 */   GIR_EraseRootFromParent_Done,
     /* 283746 */ // Label 5497: @283746
     /* 283746 */ GIM_Try, /*On fail goto*//*Label 5498*/ GIMT_Encode4(283896), // Rule ID 13245 //
     /* 283751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283758 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283762 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283766 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283769 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283774 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 283778 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 283783 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283785 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283785 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283788 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 283792 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283797 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283801 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283803 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283806 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283810 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283815 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283817 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283820 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283824 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283829 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283832 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283835 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283838 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283843 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283848 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 283853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 283856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283865 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 283872 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 283877 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 283885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 283887 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 283890 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283895 */   // GIR_Coverage, 13245,
     /* 283895 */   GIR_EraseRootFromParent_Done,
     /* 283896 */ // Label 5498: @283896
     /* 283896 */ GIM_Try, /*On fail goto*//*Label 5499*/ GIMT_Encode4(284046), // Rule ID 13247 //
     /* 283901 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 283904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 283908 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 283912 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 283916 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 283919 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_umaxv),
     /* 283924 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 283928 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283933 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 283935 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 740:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMAXVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 283935 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 283938 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 283942 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283947 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 283951 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 283953 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 283956 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 283960 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283965 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 283967 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 283970 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 283974 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 283979 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 283982 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 283985 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 283988 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283993 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 283998 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284003 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284006 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284010 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284015 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284022 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284027 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284032 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284035 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284037 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284040 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284045 */   // GIR_Coverage, 13247,
     /* 284045 */   GIR_EraseRootFromParent_Done,
     /* 284046 */ // Label 5499: @284046
     /* 284046 */ GIM_Try, /*On fail goto*//*Label 5500*/ GIMT_Encode4(284196), // Rule ID 13251 //
     /* 284051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284058 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284066 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284069 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284074 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 284078 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284085 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284085 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284088 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 284092 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284097 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284101 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284103 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284106 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284110 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284115 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284117 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284120 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284124 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284129 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284132 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284135 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284138 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284143 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284148 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284153 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284156 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284160 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284165 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284172 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284177 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284182 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284185 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284187 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284190 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284195 */   // GIR_Coverage, 13251,
     /* 284195 */   GIR_EraseRootFromParent_Done,
     /* 284196 */ // Label 5500: @284196
     /* 284196 */ GIM_Try, /*On fail goto*//*Label 5501*/ GIMT_Encode4(284346), // Rule ID 13253 //
     /* 284201 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 284204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284208 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284212 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284216 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284219 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284224 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 284228 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284233 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284235 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i8] } 743:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn), bsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284235 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s8,
     /* 284238 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 284242 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284247 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284251 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284253 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284256 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284260 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284265 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284267 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284270 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284274 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284279 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284282 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284285 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/1,
     /* 284288 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284293 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284298 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 284303 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284306 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284310 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284315 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284322 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284327 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284332 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284335 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284337 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284340 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284345 */   // GIR_Coverage, 13253,
     /* 284345 */   GIR_EraseRootFromParent_Done,
     /* 284346 */ // Label 5501: @284346
     /* 284346 */ GIM_Try, /*On fail goto*//*Label 5502*/ GIMT_Encode4(284496), // Rule ID 13255 //
     /* 284351 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284358 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284362 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284366 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284369 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284374 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284378 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284383 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284385 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284385 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284388 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 284392 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284397 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284401 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284403 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284406 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284410 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284415 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284417 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284420 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284424 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284429 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284432 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284435 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284438 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284443 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284448 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284453 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284456 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284460 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284465 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284472 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284477 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284482 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284485 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284487 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284490 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284495 */   // GIR_Coverage, 13255,
     /* 284495 */   GIR_EraseRootFromParent_Done,
     /* 284496 */ // Label 5502: @284496
     /* 284496 */ GIM_Try, /*On fail goto*//*Label 5503*/ GIMT_Encode4(284646), // Rule ID 13257 //
     /* 284501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 284504 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284508 */   GIM_RecordInsnIgnoreCopies, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284512 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284516 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 284519 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uminv),
     /* 284524 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 284528 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284533 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284535 */   // (zext:{ *:[i32] } (intrinsic_wo_chain:{ *:[i16] } 743:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (COPY_TO_REGCLASS:{ *:[i32] } (EXTRACT_SUBREG:{ *:[i32] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (UMINVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn), hsub:{ *:[i32] }), ssub:{ *:[i32] }), GPR32:{ *:[i32] })
     /* 284535 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s16,
     /* 284538 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 284542 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284547 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 284553 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 284556 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 284560 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284565 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 284567 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 284570 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 284574 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284579 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 284582 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/3,
     /* 284585 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/9,
     /* 284588 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284593 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284598 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 284603 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 284606 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284610 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 284615 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 284622 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 284627 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284632 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 284635 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 284637 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 284640 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 284645 */   // GIR_Coverage, 13257,
     /* 284645 */   GIR_EraseRootFromParent_Done,
     /* 284646 */ // Label 5503: @284646
     /* 284646 */ GIM_Reject,
     /* 284647 */ // Label 5488: @284647
     /* 284647 */ GIM_Try, /*On fail goto*//*Label 5504*/ GIMT_Encode4(284956),
     /* 284652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 284655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284659 */   GIM_Try, /*On fail goto*//*Label 5505*/ GIMT_Encode4(284724), // Rule ID 702 //
     /* 284664 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284667 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284671 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284675 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284678 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284683 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284687 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284691 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284693 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284700 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284707 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284707 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 284710 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284722 */     GIR_RootConstrainSelectedInstOperands,
     /* 284723 */     // GIR_Coverage, 702,
     /* 284723 */     GIR_EraseRootFromParent_Done,
     /* 284724 */   // Label 5505: @284724
     /* 284724 */   GIM_Try, /*On fail goto*//*Label 5506*/ GIMT_Encode4(284789), // Rule ID 1711 //
     /* 284729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284740 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284743 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284748 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284752 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284756 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284758 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284765 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284772 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 284772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i32_v2i64),
     /* 284775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284777 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284782 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 284787 */     GIR_RootConstrainSelectedInstOperands,
     /* 284788 */     // GIR_Coverage, 1711,
     /* 284788 */     GIR_EraseRootFromParent_Done,
     /* 284789 */   // Label 5506: @284789
     /* 284789 */   GIM_Try, /*On fail goto*//*Label 5507*/ GIMT_Encode4(284848), // Rule ID 700 //
     /* 284794 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284805 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284808 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284817 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284833 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 731:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 284833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 284836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284842 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284846 */     GIR_RootConstrainSelectedInstOperands,
     /* 284847 */     // GIR_Coverage, 700,
     /* 284847 */     GIR_EraseRootFromParent_Done,
     /* 284848 */   // Label 5507: @284848
     /* 284848 */   GIM_Try, /*On fail goto*//*Label 5508*/ GIMT_Encode4(284907), // Rule ID 1709 //
     /* 284853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284864 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284867 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 284872 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 284876 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 284880 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284885 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284890 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 284892 */     // (zext:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i32] } 666:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 284892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv2i32_v2i64),
     /* 284895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284897 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 284901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 284905 */     GIR_RootConstrainSelectedInstOperands,
     /* 284906 */     // GIR_Coverage, 1709,
     /* 284906 */     GIR_EraseRootFromParent_Done,
     /* 284907 */   // Label 5508: @284907
     /* 284907 */   GIM_Try, /*On fail goto*//*Label 5509*/ GIMT_Encode4(284934), // Rule ID 6406 //
     /* 284912 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 284919 */     // (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (USHLLv4i32_shift:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i32] })
     /* 284919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i32_shift),
     /* 284922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284924 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 284929 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284932 */     GIR_RootConstrainSelectedInstOperands,
     /* 284933 */     // GIR_Coverage, 6406,
     /* 284933 */     GIR_EraseRootFromParent_Done,
     /* 284934 */   // Label 5509: @284934
     /* 284934 */   GIM_Try, /*On fail goto*//*Label 5510*/ GIMT_Encode4(284955), // Rule ID 6397 //
     /* 284939 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 284943 */     // (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, 0:{ *:[i32] })
     /* 284943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 284946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 284948 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 284950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 284953 */     GIR_RootConstrainSelectedInstOperands,
     /* 284954 */     // GIR_Coverage, 6397,
     /* 284954 */     GIR_EraseRootFromParent_Done,
     /* 284955 */   // Label 5510: @284955
     /* 284955 */   GIM_Reject,
     /* 284956 */ // Label 5504: @284956
     /* 284956 */ GIM_Reject,
     /* 284957 */ // Label 5489: @284957
     /* 284957 */ GIM_Try, /*On fail goto*//*Label 5511*/ GIMT_Encode4(285266),
     /* 284962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 284965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 284969 */   GIM_Try, /*On fail goto*//*Label 5512*/ GIMT_Encode4(285034), // Rule ID 698 //
     /* 284974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 284977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 284981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 284985 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 284988 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 284993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 284997 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285017 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 285020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285032 */     GIR_RootConstrainSelectedInstOperands,
     /* 285033 */     // GIR_Coverage, 698,
     /* 285033 */     GIR_EraseRootFromParent_Done,
     /* 285034 */   // Label 5512: @285034
     /* 285034 */   GIM_Try, /*On fail goto*//*Label 5513*/ GIMT_Encode4(285099), // Rule ID 1707 //
     /* 285039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285042 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285046 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285050 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285053 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285062 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285066 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285068 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285075 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285082 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 285082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i16_v4i32),
     /* 285085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285097 */     GIR_RootConstrainSelectedInstOperands,
     /* 285098 */     // GIR_Coverage, 1707,
     /* 285098 */     GIR_EraseRootFromParent_Done,
     /* 285099 */   // Label 5513: @285099
     /* 285099 */   GIM_Try, /*On fail goto*//*Label 5514*/ GIMT_Encode4(285158), // Rule ID 696 //
     /* 285104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285115 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285118 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285123 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285127 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285131 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285136 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285141 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285143 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 731:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 285146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285148 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285156 */     GIR_RootConstrainSelectedInstOperands,
     /* 285157 */     // GIR_Coverage, 696,
     /* 285157 */     GIR_EraseRootFromParent_Done,
     /* 285158 */   // Label 5514: @285158
     /* 285158 */   GIM_Try, /*On fail goto*//*Label 5515*/ GIMT_Encode4(285217), // Rule ID 1705 //
     /* 285163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285174 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285177 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 285186 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 285190 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285195 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285200 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285202 */     // (zext:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 666:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 285202 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv4i16_v4i32),
     /* 285205 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285207 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285215 */     GIR_RootConstrainSelectedInstOperands,
     /* 285216 */     // GIR_Coverage, 1705,
     /* 285216 */     GIR_EraseRootFromParent_Done,
     /* 285217 */   // Label 5515: @285217
     /* 285217 */   GIM_Try, /*On fail goto*//*Label 5516*/ GIMT_Encode4(285244), // Rule ID 6403 //
     /* 285222 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 285229 */     // (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (USHLLv8i16_shift:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i32] })
     /* 285229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i16_shift),
     /* 285232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285234 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285239 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285242 */     GIR_RootConstrainSelectedInstOperands,
     /* 285243 */     // GIR_Coverage, 6403,
     /* 285243 */     GIR_EraseRootFromParent_Done,
     /* 285244 */   // Label 5516: @285244
     /* 285244 */   GIM_Try, /*On fail goto*//*Label 5517*/ GIMT_Encode4(285265), // Rule ID 6394 //
     /* 285249 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285253 */     // (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, 0:{ *:[i32] })
     /* 285253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 285256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285258 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285260 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285263 */     GIR_RootConstrainSelectedInstOperands,
     /* 285264 */     // GIR_Coverage, 6394,
     /* 285264 */     GIR_EraseRootFromParent_Done,
     /* 285265 */   // Label 5517: @285265
     /* 285265 */   GIM_Reject,
     /* 285266 */ // Label 5511: @285266
     /* 285266 */ GIM_Reject,
     /* 285267 */ // Label 5490: @285267
     /* 285267 */ GIM_Try, /*On fail goto*//*Label 5518*/ GIMT_Encode4(285576),
     /* 285272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 285275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285279 */   GIM_Try, /*On fail goto*//*Label 5519*/ GIMT_Encode4(285344), // Rule ID 694 //
     /* 285284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285287 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285291 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285295 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285298 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285303 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285307 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285311 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285313 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285320 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285327 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 285330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285332 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285337 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285342 */     GIR_RootConstrainSelectedInstOperands,
     /* 285343 */     // GIR_Coverage, 694,
     /* 285343 */     GIR_EraseRootFromParent_Done,
     /* 285344 */   // Label 5519: @285344
     /* 285344 */   GIM_Try, /*On fail goto*//*Label 5520*/ GIMT_Encode4(285409), // Rule ID 1703 //
     /* 285349 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285360 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285363 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285368 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285372 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285376 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285378 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285385 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285392 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm)))  =>  (SABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 285392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv16i8_v8i16),
     /* 285395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285397 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285402 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 285407 */     GIR_RootConstrainSelectedInstOperands,
     /* 285408 */     // GIR_Coverage, 1703,
     /* 285408 */     GIR_EraseRootFromParent_Done,
     /* 285409 */   // Label 5520: @285409
     /* 285409 */   GIM_Try, /*On fail goto*//*Label 5521*/ GIMT_Encode4(285468), // Rule ID 692 //
     /* 285414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285425 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285428 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uabd),
     /* 285433 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285437 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285441 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285446 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285451 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285453 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 731:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285453 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 285456 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285458 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285462 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285466 */     GIR_RootConstrainSelectedInstOperands,
     /* 285467 */     // GIR_Coverage, 692,
     /* 285467 */     GIR_EraseRootFromParent_Done,
     /* 285468 */   // Label 5521: @285468
     /* 285468 */   GIM_Try, /*On fail goto*//*Label 5522*/ GIMT_Encode4(285527), // Rule ID 1701 //
     /* 285473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 285476 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285480 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 285484 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 285487 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sabd),
     /* 285492 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 285496 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 285500 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285505 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285512 */     // (zext:{ *:[v8i16] } (intrinsic_wo_chain:{ *:[v8i8] } 666:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm))  =>  (SABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 285512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SABDLv8i8_v8i16),
     /* 285515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 285521 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 285525 */     GIR_RootConstrainSelectedInstOperands,
     /* 285526 */     // GIR_Coverage, 1701,
     /* 285526 */     GIR_EraseRootFromParent_Done,
     /* 285527 */   // Label 5522: @285527
     /* 285527 */   GIM_Try, /*On fail goto*//*Label 5523*/ GIMT_Encode4(285554), // Rule ID 6400 //
     /* 285532 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 285539 */     // (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn))  =>  (USHLLv16i8_shift:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i32] })
     /* 285539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv16i8_shift),
     /* 285542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 285549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285552 */     GIR_RootConstrainSelectedInstOperands,
     /* 285553 */     // GIR_Coverage, 6400,
     /* 285553 */     GIR_EraseRootFromParent_Done,
     /* 285554 */   // Label 5523: @285554
     /* 285554 */   GIM_Try, /*On fail goto*//*Label 5524*/ GIMT_Encode4(285575), // Rule ID 6391 //
     /* 285559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 285563 */     // (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn)  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, 0:{ *:[i32] })
     /* 285563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 285566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285570 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 285573 */     GIR_RootConstrainSelectedInstOperands,
     /* 285574 */     // GIR_Coverage, 6391,
     /* 285574 */     GIR_EraseRootFromParent_Done,
     /* 285575 */   // Label 5524: @285575
     /* 285575 */   GIM_Reject,
     /* 285576 */ // Label 5518: @285576
     /* 285576 */ GIM_Reject,
     /* 285577 */ // Label 5491: @285577
     /* 285577 */ GIM_Reject,
     /* 285578 */ // Label 46: @285578
     /* 285578 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 5530*/ GIMT_Encode4(286402),
     /* 285589 */ /*GILLT_s32*//*Label 5525*/ GIMT_Encode4(285625),
     /* 285593 */ /*GILLT_s64*//*Label 5526*/ GIMT_Encode4(285802), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 285605 */ /*GILLT_v2s64*//*Label 5527*/ GIMT_Encode4(285975), GIMT_Encode4(0),
     /* 285613 */ /*GILLT_v4s32*//*Label 5528*/ GIMT_Encode4(286120), GIMT_Encode4(0),
     /* 285621 */ /*GILLT_v8s16*//*Label 5529*/ GIMT_Encode4(286261),
     /* 285625 */ // Label 5525: @285625
     /* 285625 */ GIM_Try, /*On fail goto*//*Label 5531*/ GIMT_Encode4(285801),
     /* 285630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 285633 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285644 */   GIM_Try, /*On fail goto*//*Label 5532*/ GIMT_Encode4(285681), // Rule ID 3934 //
     /* 285649 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285653 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 285657 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285661 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285666 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285668 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285668 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285671 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285673 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285675 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285679 */     GIR_RootConstrainSelectedInstOperands,
     /* 285680 */     // GIR_Coverage, 3934,
     /* 285680 */     GIR_EraseRootFromParent_Done,
     /* 285681 */   // Label 5532: @285681
     /* 285681 */   GIM_Try, /*On fail goto*//*Label 5533*/ GIMT_Encode4(285718), // Rule ID 3935 //
     /* 285686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285705 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285710 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285716 */     GIR_RootConstrainSelectedInstOperands,
     /* 285717 */     // GIR_Coverage, 3935,
     /* 285717 */     GIR_EraseRootFromParent_Done,
     /* 285718 */   // Label 5533: @285718
     /* 285718 */   GIM_Try, /*On fail goto*//*Label 5534*/ GIMT_Encode4(285755), // Rule ID 3933 //
     /* 285723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285735 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285740 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285742 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 285742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285747 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285753 */     GIR_RootConstrainSelectedInstOperands,
     /* 285754 */     // GIR_Coverage, 3933,
     /* 285754 */     GIR_EraseRootFromParent_Done,
     /* 285755 */   // Label 5534: @285755
     /* 285755 */   GIM_Try, /*On fail goto*//*Label 5535*/ GIMT_Encode4(285800), // Rule ID 3932 //
     /* 285760 */     // (shl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSLVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 285760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 285763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 285767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285772 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 285778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285783 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVWr),
     /* 285791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285798 */     GIR_RootConstrainSelectedInstOperands,
     /* 285799 */     // GIR_Coverage, 3932,
     /* 285799 */     GIR_EraseRootFromParent_Done,
     /* 285800 */   // Label 5535: @285800
     /* 285800 */   GIM_Reject,
     /* 285801 */ // Label 5531: @285801
     /* 285801 */ GIM_Reject,
     /* 285802 */ // Label 5526: @285802
     /* 285802 */ GIM_Try, /*On fail goto*//*Label 5536*/ GIMT_Encode4(285974),
     /* 285807 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 285810 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 285813 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285817 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285821 */   GIM_Try, /*On fail goto*//*Label 5537*/ GIMT_Encode4(285889), // Rule ID 3936 //
     /* 285826 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285830 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 285834 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285838 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285843 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285845 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285845 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285848 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285852 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285860 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285864 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 285880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285882 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285884 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285887 */     GIR_RootConstrainSelectedInstOperands,
     /* 285888 */     // GIR_Coverage, 3936,
     /* 285888 */     GIR_EraseRootFromParent_Done,
     /* 285889 */   // Label 5537: @285889
     /* 285889 */   GIM_Try, /*On fail goto*//*Label 5538*/ GIMT_Encode4(285957), // Rule ID 3937 //
     /* 285894 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 285898 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 285902 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 285906 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285911 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 285913 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 285913 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 285916 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 285920 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 285925 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 285928 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 285932 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 285935 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 285940 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 285945 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 285948 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 285950 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 285952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 285955 */     GIR_RootConstrainSelectedInstOperands,
     /* 285956 */     // GIR_Coverage, 3937,
     /* 285956 */     GIR_EraseRootFromParent_Done,
     /* 285957 */   // Label 5538: @285957
     /* 285957 */   GIM_Try, /*On fail goto*//*Label 5539*/ GIMT_Encode4(285973), // Rule ID 120 //
     /* 285962 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 285966 */     // (shl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSLVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 285966 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSLVXr),
     /* 285971 */     GIR_RootConstrainSelectedInstOperands,
     /* 285972 */     // GIR_Coverage, 120,
     /* 285972 */     GIR_Done,
     /* 285973 */   // Label 5539: @285973
     /* 285973 */   GIM_Reject,
     /* 285974 */ // Label 5536: @285974
     /* 285974 */ GIM_Reject,
     /* 285975 */ // Label 5527: @285975
     /* 285975 */ GIM_Try, /*On fail goto*//*Label 5540*/ GIMT_Encode4(286119),
     /* 285980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 285983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 285986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 285990 */   GIM_Try, /*On fail goto*//*Label 5541*/ GIMT_Encode4(286054), // Rule ID 6389 //
     /* 285995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 285999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286007 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286020 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286024 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286028 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286032 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286036 */     // MIs[3] Operand 1
     /* 286036 */     // No operand predicates
     /* 286036 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286038 */     // (shl:{ *:[v2i64] } (sext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (SSHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286038 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 286041 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286043 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286047 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286052 */     GIR_RootConstrainSelectedInstOperands,
     /* 286053 */     // GIR_Coverage, 6389,
     /* 286053 */     GIR_EraseRootFromParent_Done,
     /* 286054 */   // Label 5541: @286054
     /* 286054 */   GIM_Try, /*On fail goto*//*Label 5542*/ GIMT_Encode4(286118), // Rule ID 6386 //
     /* 286059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 286071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286084 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 286088 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286092 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286096 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286100 */     // MIs[3] Operand 1
     /* 286100 */     // No operand predicates
     /* 286100 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286102 */     // (shl:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm), (AArch64dup:{ *:[v2i64] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))  =>  (USHLLv2i32_shift:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rm, (trunc_imm:{ *:[i32] } (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$size))
     /* 286102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv2i32_shift),
     /* 286105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286111 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/3, /*Renderer*/GIMT_Encode2(GICR_renderTruncImm), // size
     /* 286116 */     GIR_RootConstrainSelectedInstOperands,
     /* 286117 */     // GIR_Coverage, 6386,
     /* 286117 */     GIR_EraseRootFromParent_Done,
     /* 286118 */   // Label 5542: @286118
     /* 286118 */   GIM_Reject,
     /* 286119 */ // Label 5540: @286119
     /* 286119 */ GIM_Reject,
     /* 286120 */ // Label 5528: @286120
     /* 286120 */ GIM_Try, /*On fail goto*//*Label 5543*/ GIMT_Encode4(286260),
     /* 286125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 286128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 286131 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286135 */   GIM_Try, /*On fail goto*//*Label 5544*/ GIMT_Encode4(286197), // Rule ID 6388 //
     /* 286140 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286144 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286148 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286152 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286157 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286161 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286165 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286169 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286173 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286177 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286181 */     // MIs[3] Operand 1
     /* 286181 */     // No operand predicates
     /* 286181 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286183 */     // (shl:{ *:[v4i32] } (sext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (SSHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 286186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286188 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286192 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286195 */     GIR_RootConstrainSelectedInstOperands,
     /* 286196 */     // GIR_Coverage, 6388,
     /* 286196 */     GIR_EraseRootFromParent_Done,
     /* 286197 */   // Label 5544: @286197
     /* 286197 */   GIM_Try, /*On fail goto*//*Label 5545*/ GIMT_Encode4(286259), // Rule ID 6385 //
     /* 286202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 286214 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286231 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286235 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286239 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_15),
     /* 286243 */     // MIs[3] Operand 1
     /* 286243 */     // No operand predicates
     /* 286243 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286245 */     // (shl:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm), (AArch64dup:{ *:[v4i32] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size))  =>  (USHLLv4i16_shift:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_15>>:$size)
     /* 286245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv4i16_shift),
     /* 286248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286250 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286254 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286257 */     GIR_RootConstrainSelectedInstOperands,
     /* 286258 */     // GIR_Coverage, 6385,
     /* 286258 */     GIR_EraseRootFromParent_Done,
     /* 286259 */   // Label 5545: @286259
     /* 286259 */   GIM_Reject,
     /* 286260 */ // Label 5543: @286260
     /* 286260 */ GIM_Reject,
     /* 286261 */ // Label 5529: @286261
     /* 286261 */ GIM_Try, /*On fail goto*//*Label 5546*/ GIMT_Encode4(286401),
     /* 286266 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 286269 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 286272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 286276 */   GIM_Try, /*On fail goto*//*Label 5547*/ GIMT_Encode4(286338), // Rule ID 6387 //
     /* 286281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286293 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286298 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286302 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286306 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286310 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286314 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286318 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286322 */     // MIs[3] Operand 1
     /* 286322 */     // No operand predicates
     /* 286322 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286324 */     // (shl:{ *:[v8i16] } (sext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (SSHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 286327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286329 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286333 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286336 */     GIR_RootConstrainSelectedInstOperands,
     /* 286337 */     // GIR_Coverage, 6387,
     /* 286337 */     GIR_EraseRootFromParent_Done,
     /* 286338 */   // Label 5547: @286338
     /* 286338 */   GIM_Try, /*On fail goto*//*Label 5548*/ GIMT_Encode4(286400), // Rule ID 6384 //
     /* 286343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 286355 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 286360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 286364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 286368 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 286372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 286376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286380 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm32_0_7),
     /* 286384 */     // MIs[3] Operand 1
     /* 286384 */     // No operand predicates
     /* 286384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 286386 */     // (shl:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm), (AArch64dup:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size))  =>  (USHLLv8i8_shift:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] })<<P:Predicate_imm32_0_7>>:$size)
     /* 286386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHLLv8i8_shift),
     /* 286389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286395 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // size
     /* 286398 */     GIR_RootConstrainSelectedInstOperands,
     /* 286399 */     // GIR_Coverage, 6384,
     /* 286399 */     GIR_EraseRootFromParent_Done,
     /* 286400 */   // Label 5548: @286400
     /* 286400 */   GIM_Reject,
     /* 286401 */ // Label 5546: @286401
     /* 286401 */ GIM_Reject,
     /* 286402 */ // Label 5530: @286402
     /* 286402 */ GIM_Reject,
     /* 286403 */ // Label 47: @286403
     /* 286403 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5551*/ GIMT_Encode4(286946),
     /* 286414 */ /*GILLT_s32*//*Label 5549*/ GIMT_Encode4(286422),
     /* 286418 */ /*GILLT_s64*//*Label 5550*/ GIMT_Encode4(286688),
     /* 286422 */ // Label 5549: @286422
     /* 286422 */ GIM_Try, /*On fail goto*//*Label 5552*/ GIMT_Encode4(286687),
     /* 286427 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286430 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286433 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286437 */   GIM_Try, /*On fail goto*//*Label 5553*/ GIMT_Encode4(286476), // Rule ID 4012 //
     /* 286442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286446 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286450 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286454 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top16Zero),
     /* 286459 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 286463 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286465 */     // (srl:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }<<P:Predicate_top16Zero>>:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 286465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 286468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286470 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286474 */     GIR_RootConstrainSelectedInstOperands,
     /* 286475 */     // GIR_Coverage, 4012,
     /* 286475 */     GIR_EraseRootFromParent_Done,
     /* 286476 */   // Label 5553: @286476
     /* 286476 */   GIM_Try, /*On fail goto*//*Label 5554*/ GIMT_Encode4(286514), // Rule ID 4023 //
     /* 286481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286493 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 286497 */     // MIs[1] Operand 1
     /* 286497 */     // No operand predicates
     /* 286497 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286499 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (UBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 286499 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMWri),
     /* 286502 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286504 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286506 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286509 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 286512 */     GIR_RootConstrainSelectedInstOperands,
     /* 286513 */     // GIR_Coverage, 4023,
     /* 286513 */     GIR_EraseRootFromParent_Done,
     /* 286514 */   // Label 5554: @286514
     /* 286514 */   GIM_Try, /*On fail goto*//*Label 5555*/ GIMT_Encode4(286555), // Rule ID 3940 //
     /* 286519 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 286531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286540 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286542 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286547 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286553 */     GIR_RootConstrainSelectedInstOperands,
     /* 286554 */     // GIR_Coverage, 3940,
     /* 286554 */     GIR_EraseRootFromParent_Done,
     /* 286555 */   // Label 5555: @286555
     /* 286555 */   GIM_Try, /*On fail goto*//*Label 5556*/ GIMT_Encode4(286596), // Rule ID 3941 //
     /* 286560 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286583 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286590 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286594 */     GIR_RootConstrainSelectedInstOperands,
     /* 286595 */     // GIR_Coverage, 3941,
     /* 286595 */     GIR_EraseRootFromParent_Done,
     /* 286596 */   // Label 5556: @286596
     /* 286596 */   GIM_Try, /*On fail goto*//*Label 5557*/ GIMT_Encode4(286637), // Rule ID 3939 //
     /* 286601 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286613 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286617 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286622 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286624 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 286624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286629 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286635 */     GIR_RootConstrainSelectedInstOperands,
     /* 286636 */     // GIR_Coverage, 3939,
     /* 286636 */     GIR_EraseRootFromParent_Done,
     /* 286637 */   // Label 5557: @286637
     /* 286637 */   GIM_Try, /*On fail goto*//*Label 5558*/ GIMT_Encode4(286686), // Rule ID 3938 //
     /* 286642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286646 */     // (srl:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (LSRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 286646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 286649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 286653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286658 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 286664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286669 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVWr),
     /* 286677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286679 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286681 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286684 */     GIR_RootConstrainSelectedInstOperands,
     /* 286685 */     // GIR_Coverage, 3938,
     /* 286685 */     GIR_EraseRootFromParent_Done,
     /* 286686 */   // Label 5558: @286686
     /* 286686 */   GIM_Reject,
     /* 286687 */ // Label 5552: @286687
     /* 286687 */ GIM_Reject,
     /* 286688 */ // Label 5550: @286688
     /* 286688 */ GIM_Try, /*On fail goto*//*Label 5559*/ GIMT_Encode4(286945),
     /* 286693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 286696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286703 */   GIM_Try, /*On fail goto*//*Label 5560*/ GIMT_Encode4(286742), // Rule ID 4013 //
     /* 286708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 286716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 286720 */     GIM_CheckLeafOperandPredicate, /*MI*/1, /*MO*/1, /*Predicate*/GIMT_Encode2(GICXXPred_MO_Predicate_top32Zero),
     /* 286725 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 286729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286731 */     // (srl:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }<<P:Predicate_top32Zero>>:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 286731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 286734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 286740 */     GIR_RootConstrainSelectedInstOperands,
     /* 286741 */     // GIR_Coverage, 4013,
     /* 286741 */     GIR_EraseRootFromParent_Done,
     /* 286742 */   // Label 5560: @286742
     /* 286742 */   GIM_Try, /*On fail goto*//*Label 5561*/ GIMT_Encode4(286780), // Rule ID 4024 //
     /* 286747 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286751 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286755 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 286759 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 286763 */     // MIs[1] Operand 1
     /* 286763 */     // No operand predicates
     /* 286763 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286765 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (UBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 286765 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UBFMXri),
     /* 286768 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286770 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286772 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 286775 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 286778 */     GIR_RootConstrainSelectedInstOperands,
     /* 286779 */     // GIR_Coverage, 4024,
     /* 286779 */     GIR_EraseRootFromParent_Done,
     /* 286780 */   // Label 5561: @286780
     /* 286780 */   GIM_Try, /*On fail goto*//*Label 5562*/ GIMT_Encode4(286852), // Rule ID 3942 //
     /* 286785 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 286797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286806 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286808 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286827 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 286843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286845 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286847 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286850 */     GIR_RootConstrainSelectedInstOperands,
     /* 286851 */     // GIR_Coverage, 3942,
     /* 286851 */     GIR_EraseRootFromParent_Done,
     /* 286852 */   // Label 5562: @286852
     /* 286852 */   GIM_Try, /*On fail goto*//*Label 5563*/ GIMT_Encode4(286924), // Rule ID 3943 //
     /* 286857 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286861 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 286865 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 286869 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286873 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 286880 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 286880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 286883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 286887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 286892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 286895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 286899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 286902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 286907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 286915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 286917 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 286919 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 286922 */     GIR_RootConstrainSelectedInstOperands,
     /* 286923 */     // GIR_Coverage, 3943,
     /* 286923 */     GIR_EraseRootFromParent_Done,
     /* 286924 */   // Label 5563: @286924
     /* 286924 */   GIM_Try, /*On fail goto*//*Label 5564*/ GIMT_Encode4(286944), // Rule ID 121 //
     /* 286929 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286933 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 286937 */     // (srl:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (LSRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 286937 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::LSRVXr),
     /* 286942 */     GIR_RootConstrainSelectedInstOperands,
     /* 286943 */     // GIR_Coverage, 121,
     /* 286943 */     GIR_Done,
     /* 286944 */   // Label 5564: @286944
     /* 286944 */   GIM_Reject,
     /* 286945 */ // Label 5559: @286945
     /* 286945 */ GIM_Reject,
     /* 286946 */ // Label 5551: @286946
     /* 286946 */ GIM_Reject,
     /* 286947 */ // Label 48: @286947
     /* 286947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5567*/ GIMT_Encode4(287771),
     /* 286958 */ /*GILLT_s32*//*Label 5565*/ GIMT_Encode4(286966),
     /* 286962 */ /*GILLT_s64*//*Label 5566*/ GIMT_Encode4(287321),
     /* 286966 */ // Label 5565: @286966
     /* 286966 */ GIM_Try, /*On fail goto*//*Label 5568*/ GIMT_Encode4(287320),
     /* 286971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 286974 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 286977 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 286981 */   GIM_Try, /*On fail goto*//*Label 5569*/ GIMT_Encode4(287045), // Rule ID 6551 //
     /* 286986 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 286990 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 286994 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 286998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287003 */     // MIs[1] Operand 2
     /* 287003 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287014 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287018 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287022 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287026 */     // MIs[2] Operand 1
     /* 287026 */     // No operand predicates
     /* 287026 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287028 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287028 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287031 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287033 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287037 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287040 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287043 */     GIR_RootConstrainSelectedInstOperands,
     /* 287044 */     // GIR_Coverage, 6551,
     /* 287044 */     GIR_EraseRootFromParent_Done,
     /* 287045 */   // Label 5569: @287045
     /* 287045 */   GIM_Try, /*On fail goto*//*Label 5570*/ GIMT_Encode4(287109), // Rule ID 6553 //
     /* 287050 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287054 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287058 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287067 */     // MIs[1] Operand 2
     /* 287067 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287078 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287082 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287086 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287090 */     // MIs[2] Operand 1
     /* 287090 */     // No operand predicates
     /* 287090 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287092 */     // (sra:{ *:[i32] } (sext_inreg:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287101 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287107 */     GIR_RootConstrainSelectedInstOperands,
     /* 287108 */     // GIR_Coverage, 6553,
     /* 287108 */     GIR_EraseRootFromParent_Done,
     /* 287109 */   // Label 5570: @287109
     /* 287109 */   GIM_Try, /*On fail goto*//*Label 5571*/ GIMT_Encode4(287147), // Rule ID 4021 //
     /* 287114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287118 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287122 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287126 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287130 */     // MIs[1] Operand 1
     /* 287130 */     // No operand predicates
     /* 287130 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287132 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMWri),
     /* 287135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287139 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287142 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287145 */     GIR_RootConstrainSelectedInstOperands,
     /* 287146 */     // GIR_Coverage, 4021,
     /* 287146 */     GIR_EraseRootFromParent_Done,
     /* 287147 */   // Label 5571: @287147
     /* 287147 */   GIM_Try, /*On fail goto*//*Label 5572*/ GIMT_Encode4(287188), // Rule ID 2438 //
     /* 287152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 287164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287175 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287180 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287186 */     GIR_RootConstrainSelectedInstOperands,
     /* 287187 */     // GIR_Coverage, 2438,
     /* 287187 */     GIR_EraseRootFromParent_Done,
     /* 287188 */   // Label 5572: @287188
     /* 287188 */   GIM_Try, /*On fail goto*//*Label 5573*/ GIMT_Encode4(287229), // Rule ID 2439 //
     /* 287193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287209 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287216 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287221 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287227 */     GIR_RootConstrainSelectedInstOperands,
     /* 287228 */     // GIR_Coverage, 2439,
     /* 287228 */     GIR_EraseRootFromParent_Done,
     /* 287229 */   // Label 5573: @287229
     /* 287229 */   GIM_Try, /*On fail goto*//*Label 5574*/ GIMT_Encode4(287270), // Rule ID 2437 //
     /* 287234 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287246 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287250 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287255 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287257 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 287257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287262 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287264 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287268 */     GIR_RootConstrainSelectedInstOperands,
     /* 287269 */     // GIR_Coverage, 2437,
     /* 287269 */     GIR_EraseRootFromParent_Done,
     /* 287270 */   // Label 5574: @287270
     /* 287270 */   GIM_Try, /*On fail goto*//*Label 5575*/ GIMT_Encode4(287319), // Rule ID 2436 //
     /* 287275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287279 */     // (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (ASRVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 287279 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 287282 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 287286 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287291 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 287297 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287302 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287307 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVWr),
     /* 287310 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287312 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287314 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287317 */     GIR_RootConstrainSelectedInstOperands,
     /* 287318 */     // GIR_Coverage, 2436,
     /* 287318 */     GIR_EraseRootFromParent_Done,
     /* 287319 */   // Label 5575: @287319
     /* 287319 */   GIM_Reject,
     /* 287320 */ // Label 5568: @287320
     /* 287320 */ GIM_Reject,
     /* 287321 */ // Label 5566: @287321
     /* 287321 */ GIM_Try, /*On fail goto*//*Label 5576*/ GIMT_Encode4(287770),
     /* 287326 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287329 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287336 */   GIM_Try, /*On fail goto*//*Label 5577*/ GIMT_Encode4(287400), // Rule ID 6552 //
     /* 287341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287349 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287353 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287358 */     // MIs[1] Operand 2
     /* 287358 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(8),
     /* 287369 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287373 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287377 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_7),
     /* 287381 */     // MIs[2] Operand 1
     /* 287381 */     // No operand predicates
     /* 287381 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287383 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i8:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_7>>:$imm, 7:{ *:[i64] })
     /* 287383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287392 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287395 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/7,
     /* 287398 */     GIR_RootConstrainSelectedInstOperands,
     /* 287399 */     // GIR_Coverage, 6552,
     /* 287399 */     GIR_EraseRootFromParent_Done,
     /* 287400 */   // Label 5577: @287400
     /* 287400 */   GIM_Try, /*On fail goto*//*Label 5578*/ GIMT_Encode4(287464), // Rule ID 6554 //
     /* 287405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287409 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 287413 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 287417 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287422 */     // MIs[1] Operand 2
     /* 287422 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 287433 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287437 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287441 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_15),
     /* 287445 */     // MIs[2] Operand 1
     /* 287445 */     // No operand predicates
     /* 287445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287447 */     // (sra:{ *:[i64] } (sext_inreg:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, i16:{ *:[Other] }), (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_15>>:$imm, 15:{ *:[i64] })
     /* 287447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287452 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287456 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/15,
     /* 287462 */     GIR_RootConstrainSelectedInstOperands,
     /* 287463 */     // GIR_Coverage, 6554,
     /* 287463 */     GIR_EraseRootFromParent_Done,
     /* 287464 */   // Label 5578: @287464
     /* 287464 */   GIM_Try, /*On fail goto*//*Label 5579*/ GIMT_Encode4(287567), // Rule ID 6555 //
     /* 287469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 287490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287494 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287498 */     // MIs[2] Operand 1
     /* 287498 */     // No operand predicates
     /* 287498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 287500 */     // (sra:{ *:[i64] } (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rn), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (SBFMXri:{ *:[i64] } (INSERT_SUBREG:{ *:[i64] } (IMPLICIT_DEF:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn, sub_32:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm, 31:{ *:[i64] })
     /* 287500 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 287503 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 287507 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287512 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 287514 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287517 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 287521 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287526 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 287529 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287536 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287541 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287546 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287556 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287559 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 287562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/31,
     /* 287565 */     GIR_RootConstrainSelectedInstOperands,
     /* 287566 */     // GIR_Coverage, 6555,
     /* 287566 */     GIR_EraseRootFromParent_Done,
     /* 287567 */   // Label 5579: @287567
     /* 287567 */   GIM_Try, /*On fail goto*//*Label 5580*/ GIMT_Encode4(287605), // Rule ID 4022 //
     /* 287572 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287576 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287580 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287584 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287588 */     // MIs[1] Operand 1
     /* 287588 */     // No operand predicates
     /* 287588 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287590 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (SBFMXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm, 63:{ *:[i64] })
     /* 287590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SBFMXri),
     /* 287593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287595 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287597 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287600 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/63,
     /* 287603 */     GIR_RootConstrainSelectedInstOperands,
     /* 287604 */     // GIR_Coverage, 4022,
     /* 287604 */     GIR_EraseRootFromParent_Done,
     /* 287605 */   // Label 5580: @287605
     /* 287605 */   GIM_Try, /*On fail goto*//*Label 5581*/ GIMT_Encode4(287677), // Rule ID 2440 //
     /* 287610 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287614 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287618 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 287622 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287631 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287633 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287633 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287636 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287640 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287655 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287660 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287670 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287672 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287675 */     GIR_RootConstrainSelectedInstOperands,
     /* 287676 */     // GIR_Coverage, 2440,
     /* 287676 */     GIR_EraseRootFromParent_Done,
     /* 287677 */   // Label 5581: @287677
     /* 287677 */   GIM_Try, /*On fail goto*//*Label 5582*/ GIMT_Encode4(287749), // Rule ID 2441 //
     /* 287682 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287686 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287690 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 287694 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287703 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287705 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 287705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 287708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 287712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 287717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 287720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 287724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 287727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 287732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287742 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287744 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 287747 */     GIR_RootConstrainSelectedInstOperands,
     /* 287748 */     // GIR_Coverage, 2441,
     /* 287748 */     GIR_EraseRootFromParent_Done,
     /* 287749 */   // Label 5582: @287749
     /* 287749 */   GIM_Try, /*On fail goto*//*Label 5583*/ GIMT_Encode4(287769), // Rule ID 119 //
     /* 287754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287762 */     // (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (ASRVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 287762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ASRVXr),
     /* 287767 */     GIR_RootConstrainSelectedInstOperands,
     /* 287768 */     // GIR_Coverage, 119,
     /* 287768 */     GIR_Done,
     /* 287769 */   // Label 5583: @287769
     /* 287769 */   GIM_Reject,
     /* 287770 */ // Label 5576: @287770
     /* 287770 */ GIM_Reject,
     /* 287771 */ // Label 5567: @287771
     /* 287771 */ GIM_Reject,
     /* 287772 */ // Label 49: @287772
     /* 287772 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5586*/ GIMT_Encode4(287901),
     /* 287783 */ /*GILLT_s32*//*Label 5584*/ GIMT_Encode4(287791),
     /* 287787 */ /*GILLT_s64*//*Label 5585*/ GIMT_Encode4(287846),
     /* 287791 */ // Label 5584: @287791
     /* 287791 */ GIM_Try, /*On fail goto*//*Label 5587*/ GIMT_Encode4(287845), // Rule ID 188 //
     /* 287796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287799 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 287802 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287817 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287821 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287825 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287829 */   // MIs[1] Operand 1
     /* 287829 */   // No operand predicates
     /* 287829 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287831 */   // (fshr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287831 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 287834 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287836 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287838 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287840 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287843 */   GIR_RootConstrainSelectedInstOperands,
     /* 287844 */   // GIR_Coverage, 188,
     /* 287844 */   GIR_EraseRootFromParent_Done,
     /* 287845 */ // Label 5587: @287845
     /* 287845 */ GIM_Reject,
     /* 287846 */ // Label 5585: @287846
     /* 287846 */ GIM_Try, /*On fail goto*//*Label 5588*/ GIMT_Encode4(287900), // Rule ID 189 //
     /* 287851 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 287854 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287857 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 287860 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287864 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287868 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 287872 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 287876 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287880 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 287884 */   // MIs[1] Operand 1
     /* 287884 */   // No operand predicates
     /* 287884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287886 */   // (fshr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, (imm:{ *:[i64] }):$imm)
     /* 287886 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 287889 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287891 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 287893 */   GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 287895 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 287898 */   GIR_RootConstrainSelectedInstOperands,
     /* 287899 */   // GIR_Coverage, 189,
     /* 287899 */   GIR_EraseRootFromParent_Done,
     /* 287900 */ // Label 5588: @287900
     /* 287900 */ GIM_Reject,
     /* 287901 */ // Label 5586: @287901
     /* 287901 */ GIM_Reject,
     /* 287902 */ // Label 50: @287902
     /* 287902 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 5591*/ GIMT_Encode4(288443),
     /* 287913 */ /*GILLT_s32*//*Label 5589*/ GIMT_Encode4(287921),
     /* 287917 */ /*GILLT_s64*//*Label 5590*/ GIMT_Encode4(288186),
     /* 287921 */ // Label 5589: @287921
     /* 287921 */ GIM_Try, /*On fail goto*//*Label 5592*/ GIMT_Encode4(288185),
     /* 287926 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 287929 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 287932 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287936 */   GIM_Try, /*On fail goto*//*Label 5593*/ GIMT_Encode4(287975), // Rule ID 184 //
     /* 287941 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 287945 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 287949 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 287953 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287958 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 16,
     /* 287962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287964 */     // (rotr:{ *:[i32] } (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn), 16:{ *:[i64] })  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 287964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 287967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 287969 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 287973 */     GIR_RootConstrainSelectedInstOperands,
     /* 287974 */     // GIR_Coverage, 184,
     /* 287974 */     GIR_EraseRootFromParent_Done,
     /* 287975 */   // Label 5593: @287975
     /* 287975 */   GIM_Try, /*On fail goto*//*Label 5594*/ GIMT_Encode4(288012), // Rule ID 4017 //
     /* 287980 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 287984 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 287988 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 287992 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_31),
     /* 287996 */     // MIs[1] Operand 1
     /* 287996 */     // No operand predicates
     /* 287996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 287998 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)  =>  (EXTRWrri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_31>>:$imm)
     /* 287998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRWrri),
     /* 288001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288005 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288010 */     GIR_RootConstrainSelectedInstOperands,
     /* 288011 */     // GIR_Coverage, 4017,
     /* 288011 */     GIR_EraseRootFromParent_Done,
     /* 288012 */   // Label 5594: @288012
     /* 288012 */   GIM_Try, /*On fail goto*//*Label 5595*/ GIMT_Encode4(288053), // Rule ID 3946 //
     /* 288017 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 288029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288033 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288038 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288040 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (anyext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288045 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288047 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288051 */     GIR_RootConstrainSelectedInstOperands,
     /* 288052 */     // GIR_Coverage, 3946,
     /* 288052 */     GIR_EraseRootFromParent_Done,
     /* 288053 */   // Label 5595: @288053
     /* 288053 */   GIM_Try, /*On fail goto*//*Label 5596*/ GIMT_Encode4(288094), // Rule ID 3947 //
     /* 288058 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288070 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288074 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288081 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288092 */     GIR_RootConstrainSelectedInstOperands,
     /* 288093 */     // GIR_Coverage, 3947,
     /* 288093 */     GIR_EraseRootFromParent_Done,
     /* 288094 */   // Label 5596: @288094
     /* 288094 */   GIM_Try, /*On fail goto*//*Label 5597*/ GIMT_Encode4(288135), // Rule ID 3945 //
     /* 288099 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288111 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288115 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288122 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 288122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288127 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288133 */     GIR_RootConstrainSelectedInstOperands,
     /* 288134 */     // GIR_Coverage, 3945,
     /* 288134 */     GIR_EraseRootFromParent_Done,
     /* 288135 */   // Label 5597: @288135
     /* 288135 */   GIM_Try, /*On fail goto*//*Label 5598*/ GIMT_Encode4(288184), // Rule ID 3944 //
     /* 288140 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288144 */     // (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, i64:{ *:[i64] }:$Rm)  =>  (RORVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$Rm, sub_32:{ *:[i32] }))
     /* 288144 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 288147 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 288151 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288156 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(20), // Rm
     /* 288162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVWr),
     /* 288175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288182 */     GIR_RootConstrainSelectedInstOperands,
     /* 288183 */     // GIR_Coverage, 3944,
     /* 288183 */     GIR_EraseRootFromParent_Done,
     /* 288184 */   // Label 5598: @288184
     /* 288184 */   GIM_Reject,
     /* 288185 */ // Label 5592: @288185
     /* 288185 */ GIM_Reject,
     /* 288186 */ // Label 5590: @288186
     /* 288186 */ GIM_Try, /*On fail goto*//*Label 5599*/ GIMT_Encode4(288442),
     /* 288191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 288194 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288201 */   GIM_Try, /*On fail goto*//*Label 5600*/ GIMT_Encode4(288240), // Rule ID 187 //
     /* 288206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 288210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BSWAP),
     /* 288214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 288218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288223 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 32,
     /* 288227 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288229 */     // (rotr:{ *:[i64] } (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn), 32:{ *:[i64] })  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 288229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 288232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 288238 */     GIR_RootConstrainSelectedInstOperands,
     /* 288239 */     // GIR_Coverage, 187,
     /* 288239 */     GIR_EraseRootFromParent_Done,
     /* 288240 */   // Label 5600: @288240
     /* 288240 */   GIM_Try, /*On fail goto*//*Label 5601*/ GIMT_Encode4(288277), // Rule ID 4018 //
     /* 288245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 288257 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_63),
     /* 288261 */     // MIs[1] Operand 1
     /* 288261 */     // No operand predicates
     /* 288261 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288263 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)  =>  (EXTRXrri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_imm0_63>>:$imm)
     /* 288263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTRXrri),
     /* 288266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288268 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288270 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288272 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 288275 */     GIR_RootConstrainSelectedInstOperands,
     /* 288276 */     // GIR_Coverage, 4018,
     /* 288276 */     GIR_EraseRootFromParent_Done,
     /* 288277 */   // Label 5601: @288277
     /* 288277 */   GIM_Try, /*On fail goto*//*Label 5602*/ GIMT_Encode4(288349), // Rule ID 3948 //
     /* 288282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288286 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288290 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT),
     /* 288294 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288298 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288303 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288305 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288305 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288308 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288312 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288317 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288320 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288324 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288332 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288344 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288347 */     GIR_RootConstrainSelectedInstOperands,
     /* 288348 */     // GIR_Coverage, 3948,
     /* 288348 */     GIR_EraseRootFromParent_Done,
     /* 288349 */   // Label 5602: @288349
     /* 288349 */   GIM_Try, /*On fail goto*//*Label 5603*/ GIMT_Encode4(288421), // Rule ID 3949 //
     /* 288354 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 288366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 288370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288375 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288377 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (zext:{ *:[i64] } GPR32:{ *:[i32] }:$Rm))  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (SUBREG_TO_REG:{ *:[i64] } 0:{ *:[i32] }, GPR32:{ *:[i32] }:$Rm, sub_32:{ *:[i32] }))
     /* 288377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 288380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 288384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 288389 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 288392 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 288396 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/20,
     /* 288399 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::GPR64allRegClassID),
     /* 288404 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 288409 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288412 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288414 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 288416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 288419 */     GIR_RootConstrainSelectedInstOperands,
     /* 288420 */     // GIR_Coverage, 3949,
     /* 288420 */     GIR_EraseRootFromParent_Done,
     /* 288421 */   // Label 5603: @288421
     /* 288421 */   GIM_Try, /*On fail goto*//*Label 5604*/ GIMT_Encode4(288441), // Rule ID 122 //
     /* 288426 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 288434 */     // (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (RORVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 288434 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RORVXr),
     /* 288439 */     GIR_RootConstrainSelectedInstOperands,
     /* 288440 */     // GIR_Coverage, 122,
     /* 288440 */     GIR_Done,
     /* 288441 */   // Label 5604: @288441
     /* 288441 */   GIM_Reject,
     /* 288442 */ // Label 5599: @288442
     /* 288442 */ GIM_Reject,
     /* 288443 */ // Label 5591: @288443
     /* 288443 */ GIM_Reject,
     /* 288444 */ // Label 51: @288444
     /* 288444 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5613*/ GIMT_Encode4(296220),
     /* 288455 */ /*GILLT_s64*//*Label 5605*/ GIMT_Encode4(288491), GIMT_Encode4(0),
     /* 288463 */ /*GILLT_v2s32*//*Label 5606*/ GIMT_Encode4(288884),
     /* 288467 */ /*GILLT_v2s64*//*Label 5607*/ GIMT_Encode4(289932),
     /* 288471 */ /*GILLT_v4s16*//*Label 5608*/ GIMT_Encode4(290980),
     /* 288475 */ /*GILLT_v4s32*//*Label 5609*/ GIMT_Encode4(292028),
     /* 288479 */ /*GILLT_v8s8*//*Label 5610*/ GIMT_Encode4(293076),
     /* 288483 */ /*GILLT_v8s16*//*Label 5611*/ GIMT_Encode4(294124),
     /* 288487 */ /*GILLT_v16s8*//*Label 5612*/ GIMT_Encode4(295172),
     /* 288491 */ // Label 5605: @288491
     /* 288491 */ GIM_Try, /*On fail goto*//*Label 5614*/ GIMT_Encode4(288883),
     /* 288496 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 288499 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 288502 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288506 */   GIM_Try, /*On fail goto*//*Label 5615*/ GIMT_Encode4(288542), // Rule ID 5256 //
     /* 288511 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288514 */     // MIs[0] Operand 1
     /* 288514 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288533 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv1i64rz),
     /* 288536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288538 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288540 */     GIR_RootConstrainSelectedInstOperands,
     /* 288541 */     // GIR_Coverage, 5256,
     /* 288541 */     GIR_EraseRootFromParent_Done,
     /* 288542 */   // Label 5615: @288542
     /* 288542 */   GIM_Try, /*On fail goto*//*Label 5616*/ GIMT_Encode4(288578), // Rule ID 5257 //
     /* 288547 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288550 */     // MIs[0] Operand 1
     /* 288550 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288555 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288559 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288565 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288567 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288569 */     // (setcc:{ *:[v1i64] } immAllZerosV:{ *:[v1i64] }, v1i64:{ *:[v1i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 288572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288574 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288576 */     GIR_RootConstrainSelectedInstOperands,
     /* 288577 */     // GIR_Coverage, 5257,
     /* 288577 */     GIR_EraseRootFromParent_Done,
     /* 288578 */   // Label 5616: @288578
     /* 288578 */   GIM_Try, /*On fail goto*//*Label 5617*/ GIMT_Encode4(288614), // Rule ID 2508 //
     /* 288583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288586 */     // MIs[0] Operand 1
     /* 288586 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288591 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288595 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288601 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288603 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288605 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64rz),
     /* 288608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288612 */     GIR_RootConstrainSelectedInstOperands,
     /* 288613 */     // GIR_Coverage, 2508,
     /* 288613 */     GIR_EraseRootFromParent_Done,
     /* 288614 */   // Label 5617: @288614
     /* 288614 */   GIM_Try, /*On fail goto*//*Label 5618*/ GIMT_Encode4(288650), // Rule ID 5253 //
     /* 288619 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288622 */     // MIs[0] Operand 1
     /* 288622 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288631 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288637 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288639 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288641 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGE:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288641 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288644 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288646 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288648 */     GIR_RootConstrainSelectedInstOperands,
     /* 288649 */     // GIR_Coverage, 5253,
     /* 288649 */     GIR_EraseRootFromParent_Done,
     /* 288650 */   // Label 5618: @288650
     /* 288650 */   GIM_Try, /*On fail goto*//*Label 5619*/ GIMT_Encode4(288686), // Rule ID 5254 //
     /* 288655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288658 */     // MIs[0] Operand 1
     /* 288658 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288673 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 288675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288677 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllOnesV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64rz),
     /* 288680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288684 */     GIR_RootConstrainSelectedInstOperands,
     /* 288685 */     // GIR_Coverage, 5254,
     /* 288685 */     GIR_EraseRootFromParent_Done,
     /* 288686 */   // Label 5619: @288686
     /* 288686 */   GIM_Try, /*On fail goto*//*Label 5620*/ GIMT_Encode4(288722), // Rule ID 5255 //
     /* 288691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288694 */     // MIs[0] Operand 1
     /* 288694 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 288703 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288709 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288711 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288713 */     // (setcc:{ *:[v1i64] } v1i64:{ *:[v1i64] }:$Rn, immAllZerosV:{ *:[v1i64] }, SETGT:{ *:[Other] })  =>  (CMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 288713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64rz),
     /* 288716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288718 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288720 */     GIR_RootConstrainSelectedInstOperands,
     /* 288721 */     // GIR_Coverage, 5255,
     /* 288721 */     GIR_EraseRootFromParent_Done,
     /* 288722 */   // Label 5620: @288722
     /* 288722 */   GIM_Try, /*On fail goto*//*Label 5621*/ GIMT_Encode4(288754), // Rule ID 1608 //
     /* 288727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288730 */     // MIs[0] Operand 1
     /* 288730 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288743 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv1i64),
     /* 288746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288748 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288752 */     GIR_RootConstrainSelectedInstOperands,
     /* 288753 */     // GIR_Coverage, 1608,
     /* 288753 */     GIR_EraseRootFromParent_Done,
     /* 288754 */   // Label 5621: @288754
     /* 288754 */   GIM_Try, /*On fail goto*//*Label 5622*/ GIMT_Encode4(288786), // Rule ID 1609 //
     /* 288759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288762 */     // MIs[0] Operand 1
     /* 288762 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288767 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288771 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288775 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288775 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv1i64),
     /* 288778 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288780 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288782 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288784 */     GIR_RootConstrainSelectedInstOperands,
     /* 288785 */     // GIR_Coverage, 1609,
     /* 288785 */     GIR_EraseRootFromParent_Done,
     /* 288786 */   // Label 5622: @288786
     /* 288786 */   GIM_Try, /*On fail goto*//*Label 5623*/ GIMT_Encode4(288818), // Rule ID 1610 //
     /* 288791 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288794 */     // MIs[0] Operand 1
     /* 288794 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288807 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288807 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv1i64),
     /* 288810 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288816 */     GIR_RootConstrainSelectedInstOperands,
     /* 288817 */     // GIR_Coverage, 1610,
     /* 288817 */     GIR_EraseRootFromParent_Done,
     /* 288818 */   // Label 5623: @288818
     /* 288818 */   GIM_Try, /*On fail goto*//*Label 5624*/ GIMT_Encode4(288850), // Rule ID 1611 //
     /* 288823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288826 */     // MIs[0] Operand 1
     /* 288826 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 288831 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288835 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288839 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288839 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv1i64),
     /* 288842 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288844 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288846 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288848 */     GIR_RootConstrainSelectedInstOperands,
     /* 288849 */     // GIR_Coverage, 1611,
     /* 288849 */     GIR_EraseRootFromParent_Done,
     /* 288850 */   // Label 5624: @288850
     /* 288850 */   GIM_Try, /*On fail goto*//*Label 5625*/ GIMT_Encode4(288882), // Rule ID 1612 //
     /* 288855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288858 */     // MIs[0] Operand 1
     /* 288858 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 288863 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288867 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288871 */     // (setcc:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 288871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv1i64),
     /* 288874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288876 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 288878 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 288880 */     GIR_RootConstrainSelectedInstOperands,
     /* 288881 */     // GIR_Coverage, 1612,
     /* 288881 */     GIR_EraseRootFromParent_Done,
     /* 288882 */   // Label 5625: @288882
     /* 288882 */   GIM_Reject,
     /* 288883 */ // Label 5614: @288883
     /* 288883 */ GIM_Reject,
     /* 288884 */ // Label 5606: @288884
     /* 288884 */ GIM_Try, /*On fail goto*//*Label 5626*/ GIMT_Encode4(289931),
     /* 288889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 288892 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 288895 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288899 */   GIM_Try, /*On fail goto*//*Label 5627*/ GIMT_Encode4(288939), // Rule ID 754 //
     /* 288904 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288907 */     // MIs[0] Operand 1
     /* 288907 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 288912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288916 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288922 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288928 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288930 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 288930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 288933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288935 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288937 */     GIR_RootConstrainSelectedInstOperands,
     /* 288938 */     // GIR_Coverage, 754,
     /* 288938 */     GIR_EraseRootFromParent_Done,
     /* 288939 */   // Label 5627: @288939
     /* 288939 */   GIM_Try, /*On fail goto*//*Label 5628*/ GIMT_Encode4(288979), // Rule ID 761 //
     /* 288944 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 288947 */     // MIs[0] Operand 1
     /* 288947 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 288952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288956 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288962 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 288964 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 288968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 288970 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 288970 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 288973 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 288975 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 288977 */     GIR_RootConstrainSelectedInstOperands,
     /* 288978 */     // GIR_Coverage, 761,
     /* 288978 */     GIR_EraseRootFromParent_Done,
     /* 288979 */   // Label 5628: @288979
     /* 288979 */   GIM_Try, /*On fail goto*//*Label 5629*/ GIMT_Encode4(289016), // Rule ID 5190 //
     /* 288984 */     // MIs[0] Operand 1
     /* 288984 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 288989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 288993 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 288999 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289005 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289007 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289007 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289010 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289012 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289014 */     GIR_RootConstrainSelectedInstOperands,
     /* 289015 */     // GIR_Coverage, 5190,
     /* 289015 */     GIR_EraseRootFromParent_Done,
     /* 289016 */   // Label 5629: @289016
     /* 289016 */   GIM_Try, /*On fail goto*//*Label 5630*/ GIMT_Encode4(289053), // Rule ID 5197 //
     /* 289021 */     // MIs[0] Operand 1
     /* 289021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289030 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289036 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289038 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289042 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289044 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289044 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289047 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289049 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289051 */     GIR_RootConstrainSelectedInstOperands,
     /* 289052 */     // GIR_Coverage, 5197,
     /* 289052 */     GIR_EraseRootFromParent_Done,
     /* 289053 */   // Label 5630: @289053
     /* 289053 */   GIM_Try, /*On fail goto*//*Label 5631*/ GIMT_Encode4(289090), // Rule ID 5204 //
     /* 289058 */     // MIs[0] Operand 1
     /* 289058 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289067 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289073 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289075 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289079 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289081 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289088 */     GIR_RootConstrainSelectedInstOperands,
     /* 289089 */     // GIR_Coverage, 5204,
     /* 289089 */     GIR_EraseRootFromParent_Done,
     /* 289090 */   // Label 5631: @289090
     /* 289090 */   GIM_Try, /*On fail goto*//*Label 5632*/ GIMT_Encode4(289127), // Rule ID 5211 //
     /* 289095 */     // MIs[0] Operand 1
     /* 289095 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289100 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289104 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289110 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289116 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289118 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289118 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289121 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289123 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289125 */     GIR_RootConstrainSelectedInstOperands,
     /* 289126 */     // GIR_Coverage, 5211,
     /* 289126 */     GIR_EraseRootFromParent_Done,
     /* 289127 */   // Label 5632: @289127
     /* 289127 */   GIM_Try, /*On fail goto*//*Label 5633*/ GIMT_Encode4(289164), // Rule ID 5218 //
     /* 289132 */     // MIs[0] Operand 1
     /* 289132 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289137 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289141 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289147 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289149 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289153 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289155 */     // (setcc:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, V64:{ *:[v2i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289155 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289158 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289160 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289162 */     GIR_RootConstrainSelectedInstOperands,
     /* 289163 */     // GIR_Coverage, 5218,
     /* 289163 */     GIR_EraseRootFromParent_Done,
     /* 289164 */   // Label 5633: @289164
     /* 289164 */   GIM_Try, /*On fail goto*//*Label 5634*/ GIMT_Encode4(289204), // Rule ID 726 //
     /* 289169 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289172 */     // MIs[0] Operand 1
     /* 289172 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289177 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289185 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289191 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289193 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289195 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289195 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289198 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289200 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289202 */     GIR_RootConstrainSelectedInstOperands,
     /* 289203 */     // GIR_Coverage, 726,
     /* 289203 */     GIR_EraseRootFromParent_Done,
     /* 289204 */   // Label 5634: @289204
     /* 289204 */   GIM_Try, /*On fail goto*//*Label 5635*/ GIMT_Encode4(289244), // Rule ID 737 //
     /* 289209 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289212 */     // MIs[0] Operand 1
     /* 289212 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289235 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289242 */     GIR_RootConstrainSelectedInstOperands,
     /* 289243 */     // GIR_Coverage, 737,
     /* 289243 */     GIR_EraseRootFromParent_Done,
     /* 289244 */   // Label 5635: @289244
     /* 289244 */   GIM_Try, /*On fail goto*//*Label 5636*/ GIMT_Encode4(289284), // Rule ID 738 //
     /* 289249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289252 */     // MIs[0] Operand 1
     /* 289252 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289261 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289265 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289271 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 289273 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289275 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllOnesV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289280 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289282 */     GIR_RootConstrainSelectedInstOperands,
     /* 289283 */     // GIR_Coverage, 738,
     /* 289283 */     GIR_EraseRootFromParent_Done,
     /* 289284 */   // Label 5636: @289284
     /* 289284 */   GIM_Try, /*On fail goto*//*Label 5637*/ GIMT_Encode4(289324), // Rule ID 747 //
     /* 289289 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289292 */     // MIs[0] Operand 1
     /* 289292 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289297 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289301 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289305 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289311 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289313 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289315 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289315 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289318 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289320 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289322 */     GIR_RootConstrainSelectedInstOperands,
     /* 289323 */     // GIR_Coverage, 747,
     /* 289323 */     GIR_EraseRootFromParent_Done,
     /* 289324 */   // Label 5637: @289324
     /* 289324 */   GIM_Try, /*On fail goto*//*Label 5638*/ GIMT_Encode4(289361), // Rule ID 5155 //
     /* 289329 */     // MIs[0] Operand 1
     /* 289329 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289338 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289342 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289348 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289350 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289352 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289352 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32rz),
     /* 289355 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289357 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289359 */     GIR_RootConstrainSelectedInstOperands,
     /* 289360 */     // GIR_Coverage, 5155,
     /* 289360 */     GIR_EraseRootFromParent_Done,
     /* 289361 */   // Label 5638: @289361
     /* 289361 */   GIM_Try, /*On fail goto*//*Label 5639*/ GIMT_Encode4(289398), // Rule ID 5162 //
     /* 289366 */     // MIs[0] Operand 1
     /* 289366 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289371 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289379 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289385 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289387 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289389 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGT:{ *:[Other] })  =>  (CMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289389 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32rz),
     /* 289392 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289394 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289396 */     GIR_RootConstrainSelectedInstOperands,
     /* 289397 */     // GIR_Coverage, 5162,
     /* 289397 */     GIR_EraseRootFromParent_Done,
     /* 289398 */   // Label 5639: @289398
     /* 289398 */   GIM_Try, /*On fail goto*//*Label 5640*/ GIMT_Encode4(289435), // Rule ID 5169 //
     /* 289403 */     // MIs[0] Operand 1
     /* 289403 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289408 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289412 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289416 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289422 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289424 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289426 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETGE:{ *:[Other] })  =>  (CMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289426 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32rz),
     /* 289429 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289431 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289433 */     GIR_RootConstrainSelectedInstOperands,
     /* 289434 */     // GIR_Coverage, 5169,
     /* 289434 */     GIR_EraseRootFromParent_Done,
     /* 289435 */   // Label 5640: @289435
     /* 289435 */   GIM_Try, /*On fail goto*//*Label 5641*/ GIMT_Encode4(289472), // Rule ID 5176 //
     /* 289440 */     // MIs[0] Operand 1
     /* 289440 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289445 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289453 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289459 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289463 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLT:{ *:[Other] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 289466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289468 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289470 */     GIR_RootConstrainSelectedInstOperands,
     /* 289471 */     // GIR_Coverage, 5176,
     /* 289471 */     GIR_EraseRootFromParent_Done,
     /* 289472 */   // Label 5641: @289472
     /* 289472 */   GIM_Try, /*On fail goto*//*Label 5642*/ GIMT_Encode4(289509), // Rule ID 5183 //
     /* 289477 */     // MIs[0] Operand 1
     /* 289477 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289482 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 289490 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289496 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289500 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, immAllZerosV:{ *:[v2i32] }, SETLE:{ *:[Other] })  =>  (CMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 289500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i32rz),
     /* 289503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289507 */     GIR_RootConstrainSelectedInstOperands,
     /* 289508 */     // GIR_Coverage, 5183,
     /* 289508 */     GIR_EraseRootFromParent_Done,
     /* 289509 */   // Label 5642: @289509
     /* 289509 */   GIM_Try, /*On fail goto*//*Label 5643*/ GIMT_Encode4(289541), // Rule ID 1125 //
     /* 289514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289517 */     // MIs[0] Operand 1
     /* 289517 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289522 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289526 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289530 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289535 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289537 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289539 */     GIR_RootConstrainSelectedInstOperands,
     /* 289540 */     // GIR_Coverage, 1125,
     /* 289540 */     GIR_EraseRootFromParent_Done,
     /* 289541 */   // Label 5643: @289541
     /* 289541 */   GIM_Try, /*On fail goto*//*Label 5644*/ GIMT_Encode4(289573), // Rule ID 1132 //
     /* 289546 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289549 */     // MIs[0] Operand 1
     /* 289549 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289554 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289558 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289562 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289569 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289571 */     GIR_RootConstrainSelectedInstOperands,
     /* 289572 */     // GIR_Coverage, 1132,
     /* 289572 */     GIR_EraseRootFromParent_Done,
     /* 289573 */   // Label 5644: @289573
     /* 289573 */   GIM_Try, /*On fail goto*//*Label 5645*/ GIMT_Encode4(289605), // Rule ID 1139 //
     /* 289578 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289581 */     // MIs[0] Operand 1
     /* 289581 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289586 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289590 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289594 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289599 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289601 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289603 */     GIR_RootConstrainSelectedInstOperands,
     /* 289604 */     // GIR_Coverage, 1139,
     /* 289604 */     GIR_EraseRootFromParent_Done,
     /* 289605 */   // Label 5645: @289605
     /* 289605 */   GIM_Try, /*On fail goto*//*Label 5646*/ GIMT_Encode4(289637), // Rule ID 1146 //
     /* 289610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289613 */     // MIs[0] Operand 1
     /* 289613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289626 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289635 */     GIR_RootConstrainSelectedInstOperands,
     /* 289636 */     // GIR_Coverage, 1146,
     /* 289636 */     GIR_EraseRootFromParent_Done,
     /* 289637 */   // Label 5646: @289637
     /* 289637 */   GIM_Try, /*On fail goto*//*Label 5647*/ GIMT_Encode4(289669), // Rule ID 1153 //
     /* 289642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289645 */     // MIs[0] Operand 1
     /* 289645 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289658 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289667 */     GIR_RootConstrainSelectedInstOperands,
     /* 289668 */     // GIR_Coverage, 1153,
     /* 289668 */     GIR_EraseRootFromParent_Done,
     /* 289669 */   // Label 5647: @289669
     /* 289669 */   GIM_Try, /*On fail goto*//*Label 5648*/ GIMT_Encode4(289698), // Rule ID 5092 //
     /* 289674 */     // MIs[0] Operand 1
     /* 289674 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 289679 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289687 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i32),
     /* 289690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289692 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289696 */     GIR_RootConstrainSelectedInstOperands,
     /* 289697 */     // GIR_Coverage, 5092,
     /* 289697 */     GIR_EraseRootFromParent_Done,
     /* 289698 */   // Label 5648: @289698
     /* 289698 */   GIM_Try, /*On fail goto*//*Label 5649*/ GIMT_Encode4(289727), // Rule ID 5099 //
     /* 289703 */     // MIs[0] Operand 1
     /* 289703 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 289708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289716 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289716 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289719 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289721 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289723 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289725 */     GIR_RootConstrainSelectedInstOperands,
     /* 289726 */     // GIR_Coverage, 5099,
     /* 289726 */     GIR_EraseRootFromParent_Done,
     /* 289727 */   // Label 5649: @289727
     /* 289727 */   GIM_Try, /*On fail goto*//*Label 5650*/ GIMT_Encode4(289756), // Rule ID 5106 //
     /* 289732 */     // MIs[0] Operand 1
     /* 289732 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289737 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289745 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289750 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289754 */     GIR_RootConstrainSelectedInstOperands,
     /* 289755 */     // GIR_Coverage, 5106,
     /* 289755 */     GIR_EraseRootFromParent_Done,
     /* 289756 */   // Label 5650: @289756
     /* 289756 */   GIM_Try, /*On fail goto*//*Label 5651*/ GIMT_Encode4(289785), // Rule ID 5113 //
     /* 289761 */     // MIs[0] Operand 1
     /* 289761 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 289766 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289770 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289774 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289779 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289781 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289783 */     GIR_RootConstrainSelectedInstOperands,
     /* 289784 */     // GIR_Coverage, 5113,
     /* 289784 */     GIR_EraseRootFromParent_Done,
     /* 289785 */   // Label 5651: @289785
     /* 289785 */   GIM_Try, /*On fail goto*//*Label 5652*/ GIMT_Encode4(289814), // Rule ID 5120 //
     /* 289790 */     // MIs[0] Operand 1
     /* 289790 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 289795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289803 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 289803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289808 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289812 */     GIR_RootConstrainSelectedInstOperands,
     /* 289813 */     // GIR_Coverage, 5120,
     /* 289813 */     GIR_EraseRootFromParent_Done,
     /* 289814 */   // Label 5652: @289814
     /* 289814 */   GIM_Try, /*On fail goto*//*Label 5653*/ GIMT_Encode4(289843), // Rule ID 5127 //
     /* 289819 */     // MIs[0] Operand 1
     /* 289819 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 289824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289832 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i32),
     /* 289835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289837 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289841 */     GIR_RootConstrainSelectedInstOperands,
     /* 289842 */     // GIR_Coverage, 5127,
     /* 289842 */     GIR_EraseRootFromParent_Done,
     /* 289843 */   // Label 5653: @289843
     /* 289843 */   GIM_Try, /*On fail goto*//*Label 5654*/ GIMT_Encode4(289872), // Rule ID 5134 //
     /* 289848 */     // MIs[0] Operand 1
     /* 289848 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 289853 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289861 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i32),
     /* 289864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289866 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289868 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289870 */     GIR_RootConstrainSelectedInstOperands,
     /* 289871 */     // GIR_Coverage, 5134,
     /* 289871 */     GIR_EraseRootFromParent_Done,
     /* 289872 */   // Label 5654: @289872
     /* 289872 */   GIM_Try, /*On fail goto*//*Label 5655*/ GIMT_Encode4(289901), // Rule ID 5141 //
     /* 289877 */     // MIs[0] Operand 1
     /* 289877 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 289882 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289890 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i32),
     /* 289893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289895 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289899 */     GIR_RootConstrainSelectedInstOperands,
     /* 289900 */     // GIR_Coverage, 5141,
     /* 289900 */     GIR_EraseRootFromParent_Done,
     /* 289901 */   // Label 5655: @289901
     /* 289901 */   GIM_Try, /*On fail goto*//*Label 5656*/ GIMT_Encode4(289930), // Rule ID 5148 //
     /* 289906 */     // MIs[0] Operand 1
     /* 289906 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 289911 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289915 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 289919 */     // (setcc:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rm, V64:{ *:[v2i32] }:$Rn)
     /* 289919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i32),
     /* 289922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 289926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 289928 */     GIR_RootConstrainSelectedInstOperands,
     /* 289929 */     // GIR_Coverage, 5148,
     /* 289929 */     GIR_EraseRootFromParent_Done,
     /* 289930 */   // Label 5656: @289930
     /* 289930 */   GIM_Reject,
     /* 289931 */ // Label 5626: @289931
     /* 289931 */ GIM_Reject,
     /* 289932 */ // Label 5607: @289932
     /* 289932 */ GIM_Try, /*On fail goto*//*Label 5657*/ GIMT_Encode4(290979),
     /* 289937 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 289940 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 289943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289947 */   GIM_Try, /*On fail goto*//*Label 5658*/ GIMT_Encode4(289987), // Rule ID 756 //
     /* 289952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289955 */     // MIs[0] Operand 1
     /* 289955 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 289960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 289964 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 289970 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 289972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 289976 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 289978 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 289978 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 289981 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 289983 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 289985 */     GIR_RootConstrainSelectedInstOperands,
     /* 289986 */     // GIR_Coverage, 756,
     /* 289986 */     GIR_EraseRootFromParent_Done,
     /* 289987 */   // Label 5658: @289987
     /* 289987 */   GIM_Try, /*On fail goto*//*Label 5659*/ GIMT_Encode4(290027), // Rule ID 763 //
     /* 289992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 289995 */     // MIs[0] Operand 1
     /* 289995 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290004 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290010 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290018 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290023 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290025 */     GIR_RootConstrainSelectedInstOperands,
     /* 290026 */     // GIR_Coverage, 763,
     /* 290026 */     GIR_EraseRootFromParent_Done,
     /* 290027 */   // Label 5659: @290027
     /* 290027 */   GIM_Try, /*On fail goto*//*Label 5660*/ GIMT_Encode4(290064), // Rule ID 5192 //
     /* 290032 */     // MIs[0] Operand 1
     /* 290032 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290037 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290041 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290047 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290053 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290055 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290060 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290062 */     GIR_RootConstrainSelectedInstOperands,
     /* 290063 */     // GIR_Coverage, 5192,
     /* 290063 */     GIR_EraseRootFromParent_Done,
     /* 290064 */   // Label 5660: @290064
     /* 290064 */   GIM_Try, /*On fail goto*//*Label 5661*/ GIMT_Encode4(290101), // Rule ID 5199 //
     /* 290069 */     // MIs[0] Operand 1
     /* 290069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290078 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290084 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290086 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290092 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290097 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290099 */     GIR_RootConstrainSelectedInstOperands,
     /* 290100 */     // GIR_Coverage, 5199,
     /* 290100 */     GIR_EraseRootFromParent_Done,
     /* 290101 */   // Label 5661: @290101
     /* 290101 */   GIM_Try, /*On fail goto*//*Label 5662*/ GIMT_Encode4(290138), // Rule ID 5206 //
     /* 290106 */     // MIs[0] Operand 1
     /* 290106 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290115 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290121 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290123 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290129 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290129 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290132 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290134 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290136 */     GIR_RootConstrainSelectedInstOperands,
     /* 290137 */     // GIR_Coverage, 5206,
     /* 290137 */     GIR_EraseRootFromParent_Done,
     /* 290138 */   // Label 5662: @290138
     /* 290138 */   GIM_Try, /*On fail goto*//*Label 5663*/ GIMT_Encode4(290175), // Rule ID 5213 //
     /* 290143 */     // MIs[0] Operand 1
     /* 290143 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290160 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290166 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290173 */     GIR_RootConstrainSelectedInstOperands,
     /* 290174 */     // GIR_Coverage, 5213,
     /* 290174 */     GIR_EraseRootFromParent_Done,
     /* 290175 */   // Label 5663: @290175
     /* 290175 */   GIM_Try, /*On fail goto*//*Label 5664*/ GIMT_Encode4(290212), // Rule ID 5220 //
     /* 290180 */     // MIs[0] Operand 1
     /* 290180 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 290189 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290195 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290201 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290203 */     // (setcc:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290208 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 290210 */     GIR_RootConstrainSelectedInstOperands,
     /* 290211 */     // GIR_Coverage, 5220,
     /* 290211 */     GIR_EraseRootFromParent_Done,
     /* 290212 */   // Label 5664: @290212
     /* 290212 */   GIM_Try, /*On fail goto*//*Label 5665*/ GIMT_Encode4(290252), // Rule ID 728 //
     /* 290217 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290220 */     // MIs[0] Operand 1
     /* 290220 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290225 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290241 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290243 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290243 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290246 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290248 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290250 */     GIR_RootConstrainSelectedInstOperands,
     /* 290251 */     // GIR_Coverage, 728,
     /* 290251 */     GIR_EraseRootFromParent_Done,
     /* 290252 */   // Label 5665: @290252
     /* 290252 */   GIM_Try, /*On fail goto*//*Label 5666*/ GIMT_Encode4(290292), // Rule ID 741 //
     /* 290257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290260 */     // MIs[0] Operand 1
     /* 290260 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290265 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290269 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290273 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290279 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290281 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290283 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290290 */     GIR_RootConstrainSelectedInstOperands,
     /* 290291 */     // GIR_Coverage, 741,
     /* 290291 */     GIR_EraseRootFromParent_Done,
     /* 290292 */   // Label 5666: @290292
     /* 290292 */   GIM_Try, /*On fail goto*//*Label 5667*/ GIMT_Encode4(290332), // Rule ID 742 //
     /* 290297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290300 */     // MIs[0] Operand 1
     /* 290300 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290305 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290319 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 290321 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290323 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllOnesV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290328 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290330 */     GIR_RootConstrainSelectedInstOperands,
     /* 290331 */     // GIR_Coverage, 742,
     /* 290331 */     GIR_EraseRootFromParent_Done,
     /* 290332 */   // Label 5667: @290332
     /* 290332 */   GIM_Try, /*On fail goto*//*Label 5668*/ GIMT_Encode4(290372), // Rule ID 749 //
     /* 290337 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290340 */     // MIs[0] Operand 1
     /* 290340 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290345 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290349 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290353 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290359 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290361 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290363 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290370 */     GIR_RootConstrainSelectedInstOperands,
     /* 290371 */     // GIR_Coverage, 749,
     /* 290371 */     GIR_EraseRootFromParent_Done,
     /* 290372 */   // Label 5668: @290372
     /* 290372 */   GIM_Try, /*On fail goto*//*Label 5669*/ GIMT_Encode4(290409), // Rule ID 5157 //
     /* 290377 */     // MIs[0] Operand 1
     /* 290377 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290382 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290390 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290396 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290398 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290400 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETEQ:{ *:[Other] })  =>  (CMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64rz),
     /* 290403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290405 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290407 */     GIR_RootConstrainSelectedInstOperands,
     /* 290408 */     // GIR_Coverage, 5157,
     /* 290408 */     GIR_EraseRootFromParent_Done,
     /* 290409 */   // Label 5669: @290409
     /* 290409 */   GIM_Try, /*On fail goto*//*Label 5670*/ GIMT_Encode4(290446), // Rule ID 5164 //
     /* 290414 */     // MIs[0] Operand 1
     /* 290414 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290419 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290427 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290433 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290435 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290437 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGT:{ *:[Other] })  =>  (CMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64rz),
     /* 290440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290442 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290444 */     GIR_RootConstrainSelectedInstOperands,
     /* 290445 */     // GIR_Coverage, 5164,
     /* 290445 */     GIR_EraseRootFromParent_Done,
     /* 290446 */   // Label 5670: @290446
     /* 290446 */   GIM_Try, /*On fail goto*//*Label 5671*/ GIMT_Encode4(290483), // Rule ID 5171 //
     /* 290451 */     // MIs[0] Operand 1
     /* 290451 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290464 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290470 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290472 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290474 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETGE:{ *:[Other] })  =>  (CMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290474 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64rz),
     /* 290477 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290479 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290481 */     GIR_RootConstrainSelectedInstOperands,
     /* 290482 */     // GIR_Coverage, 5171,
     /* 290482 */     GIR_EraseRootFromParent_Done,
     /* 290483 */   // Label 5671: @290483
     /* 290483 */   GIM_Try, /*On fail goto*//*Label 5672*/ GIMT_Encode4(290520), // Rule ID 5178 //
     /* 290488 */     // MIs[0] Operand 1
     /* 290488 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290497 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290501 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290507 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290511 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLT:{ *:[Other] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 290514 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290518 */     GIR_RootConstrainSelectedInstOperands,
     /* 290519 */     // GIR_Coverage, 5178,
     /* 290519 */     GIR_EraseRootFromParent_Done,
     /* 290520 */   // Label 5672: @290520
     /* 290520 */   GIM_Try, /*On fail goto*//*Label 5673*/ GIMT_Encode4(290557), // Rule ID 5185 //
     /* 290525 */     // MIs[0] Operand 1
     /* 290525 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290530 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 290538 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 290544 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 290546 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 290548 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, immAllZerosV:{ *:[v2i64] }, SETLE:{ *:[Other] })  =>  (CMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 290548 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv2i64rz),
     /* 290551 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290553 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290555 */     GIR_RootConstrainSelectedInstOperands,
     /* 290556 */     // GIR_Coverage, 5185,
     /* 290556 */     GIR_EraseRootFromParent_Done,
     /* 290557 */   // Label 5673: @290557
     /* 290557 */   GIM_Try, /*On fail goto*//*Label 5674*/ GIMT_Encode4(290589), // Rule ID 1127 //
     /* 290562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290565 */     // MIs[0] Operand 1
     /* 290565 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290578 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290583 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290585 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290587 */     GIR_RootConstrainSelectedInstOperands,
     /* 290588 */     // GIR_Coverage, 1127,
     /* 290588 */     GIR_EraseRootFromParent_Done,
     /* 290589 */   // Label 5674: @290589
     /* 290589 */   GIM_Try, /*On fail goto*//*Label 5675*/ GIMT_Encode4(290621), // Rule ID 1134 //
     /* 290594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290597 */     // MIs[0] Operand 1
     /* 290597 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290610 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290615 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290619 */     GIR_RootConstrainSelectedInstOperands,
     /* 290620 */     // GIR_Coverage, 1134,
     /* 290620 */     GIR_EraseRootFromParent_Done,
     /* 290621 */   // Label 5675: @290621
     /* 290621 */   GIM_Try, /*On fail goto*//*Label 5676*/ GIMT_Encode4(290653), // Rule ID 1141 //
     /* 290626 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290629 */     // MIs[0] Operand 1
     /* 290629 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290642 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290642 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290645 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290647 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290651 */     GIR_RootConstrainSelectedInstOperands,
     /* 290652 */     // GIR_Coverage, 1141,
     /* 290652 */     GIR_EraseRootFromParent_Done,
     /* 290653 */   // Label 5676: @290653
     /* 290653 */   GIM_Try, /*On fail goto*//*Label 5677*/ GIMT_Encode4(290685), // Rule ID 1148 //
     /* 290658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290661 */     // MIs[0] Operand 1
     /* 290661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290674 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290683 */     GIR_RootConstrainSelectedInstOperands,
     /* 290684 */     // GIR_Coverage, 1148,
     /* 290684 */     GIR_EraseRootFromParent_Done,
     /* 290685 */   // Label 5677: @290685
     /* 290685 */   GIM_Try, /*On fail goto*//*Label 5678*/ GIMT_Encode4(290717), // Rule ID 1155 //
     /* 290690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 290693 */     // MIs[0] Operand 1
     /* 290693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290706 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290715 */     GIR_RootConstrainSelectedInstOperands,
     /* 290716 */     // GIR_Coverage, 1155,
     /* 290716 */     GIR_EraseRootFromParent_Done,
     /* 290717 */   // Label 5678: @290717
     /* 290717 */   GIM_Try, /*On fail goto*//*Label 5679*/ GIMT_Encode4(290746), // Rule ID 5094 //
     /* 290722 */     // MIs[0] Operand 1
     /* 290722 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 290727 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290731 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290735 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv2i64),
     /* 290738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290742 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290744 */     GIR_RootConstrainSelectedInstOperands,
     /* 290745 */     // GIR_Coverage, 5094,
     /* 290745 */     GIR_EraseRootFromParent_Done,
     /* 290746 */   // Label 5679: @290746
     /* 290746 */   GIM_Try, /*On fail goto*//*Label 5680*/ GIMT_Encode4(290775), // Rule ID 5101 //
     /* 290751 */     // MIs[0] Operand 1
     /* 290751 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 290756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290764 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290769 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290771 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290773 */     GIR_RootConstrainSelectedInstOperands,
     /* 290774 */     // GIR_Coverage, 5101,
     /* 290774 */     GIR_EraseRootFromParent_Done,
     /* 290775 */   // Label 5680: @290775
     /* 290775 */   GIM_Try, /*On fail goto*//*Label 5681*/ GIMT_Encode4(290804), // Rule ID 5108 //
     /* 290780 */     // MIs[0] Operand 1
     /* 290780 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 290785 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290789 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290793 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290798 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290800 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290802 */     GIR_RootConstrainSelectedInstOperands,
     /* 290803 */     // GIR_Coverage, 5108,
     /* 290803 */     GIR_EraseRootFromParent_Done,
     /* 290804 */   // Label 5681: @290804
     /* 290804 */   GIM_Try, /*On fail goto*//*Label 5682*/ GIMT_Encode4(290833), // Rule ID 5115 //
     /* 290809 */     // MIs[0] Operand 1
     /* 290809 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 290814 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290822 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290827 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290829 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290831 */     GIR_RootConstrainSelectedInstOperands,
     /* 290832 */     // GIR_Coverage, 5115,
     /* 290832 */     GIR_EraseRootFromParent_Done,
     /* 290833 */   // Label 5682: @290833
     /* 290833 */   GIM_Try, /*On fail goto*//*Label 5683*/ GIMT_Encode4(290862), // Rule ID 5122 //
     /* 290838 */     // MIs[0] Operand 1
     /* 290838 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 290843 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290851 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 290851 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290854 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290856 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290860 */     GIR_RootConstrainSelectedInstOperands,
     /* 290861 */     // GIR_Coverage, 5122,
     /* 290861 */     GIR_EraseRootFromParent_Done,
     /* 290862 */   // Label 5683: @290862
     /* 290862 */   GIM_Try, /*On fail goto*//*Label 5684*/ GIMT_Encode4(290891), // Rule ID 5129 //
     /* 290867 */     // MIs[0] Operand 1
     /* 290867 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 290872 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290876 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290880 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290880 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv2i64),
     /* 290883 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290885 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290889 */     GIR_RootConstrainSelectedInstOperands,
     /* 290890 */     // GIR_Coverage, 5129,
     /* 290890 */     GIR_EraseRootFromParent_Done,
     /* 290891 */   // Label 5684: @290891
     /* 290891 */   GIM_Try, /*On fail goto*//*Label 5685*/ GIMT_Encode4(290920), // Rule ID 5136 //
     /* 290896 */     // MIs[0] Operand 1
     /* 290896 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 290901 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290905 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290909 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290909 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv2i64),
     /* 290912 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290914 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290916 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290918 */     GIR_RootConstrainSelectedInstOperands,
     /* 290919 */     // GIR_Coverage, 5136,
     /* 290919 */     GIR_EraseRootFromParent_Done,
     /* 290920 */   // Label 5685: @290920
     /* 290920 */   GIM_Try, /*On fail goto*//*Label 5686*/ GIMT_Encode4(290949), // Rule ID 5143 //
     /* 290925 */     // MIs[0] Operand 1
     /* 290925 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 290930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290938 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290938 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv2i64),
     /* 290941 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290943 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290945 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290947 */     GIR_RootConstrainSelectedInstOperands,
     /* 290948 */     // GIR_Coverage, 5143,
     /* 290948 */     GIR_EraseRootFromParent_Done,
     /* 290949 */   // Label 5686: @290949
     /* 290949 */   GIM_Try, /*On fail goto*//*Label 5687*/ GIMT_Encode4(290978), // Rule ID 5150 //
     /* 290954 */     // MIs[0] Operand 1
     /* 290954 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 290959 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290963 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 290967 */     // (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rm, V128:{ *:[v2i64] }:$Rn)
     /* 290967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv2i64),
     /* 290970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 290972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 290974 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 290976 */     GIR_RootConstrainSelectedInstOperands,
     /* 290977 */     // GIR_Coverage, 5150,
     /* 290977 */     GIR_EraseRootFromParent_Done,
     /* 290978 */   // Label 5687: @290978
     /* 290978 */   GIM_Reject,
     /* 290979 */ // Label 5657: @290979
     /* 290979 */ GIM_Reject,
     /* 290980 */ // Label 5608: @290980
     /* 290980 */ GIM_Try, /*On fail goto*//*Label 5688*/ GIMT_Encode4(292027),
     /* 290985 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 290988 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 290991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 290995 */   GIM_Try, /*On fail goto*//*Label 5689*/ GIMT_Encode4(291035), // Rule ID 752 //
     /* 291000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291003 */     // MIs[0] Operand 1
     /* 291003 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291008 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291012 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291018 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291024 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291026 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291026 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291029 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291031 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291033 */     GIR_RootConstrainSelectedInstOperands,
     /* 291034 */     // GIR_Coverage, 752,
     /* 291034 */     GIR_EraseRootFromParent_Done,
     /* 291035 */   // Label 5689: @291035
     /* 291035 */   GIM_Try, /*On fail goto*//*Label 5690*/ GIMT_Encode4(291075), // Rule ID 759 //
     /* 291040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291043 */     // MIs[0] Operand 1
     /* 291043 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291048 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291052 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291058 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291060 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291066 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291071 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291073 */     GIR_RootConstrainSelectedInstOperands,
     /* 291074 */     // GIR_Coverage, 759,
     /* 291074 */     GIR_EraseRootFromParent_Done,
     /* 291075 */   // Label 5690: @291075
     /* 291075 */   GIM_Try, /*On fail goto*//*Label 5691*/ GIMT_Encode4(291112), // Rule ID 5188 //
     /* 291080 */     // MIs[0] Operand 1
     /* 291080 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291089 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291095 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291101 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291103 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291103 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291106 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291108 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291110 */     GIR_RootConstrainSelectedInstOperands,
     /* 291111 */     // GIR_Coverage, 5188,
     /* 291111 */     GIR_EraseRootFromParent_Done,
     /* 291112 */   // Label 5691: @291112
     /* 291112 */   GIM_Try, /*On fail goto*//*Label 5692*/ GIMT_Encode4(291149), // Rule ID 5195 //
     /* 291117 */     // MIs[0] Operand 1
     /* 291117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291126 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291132 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291138 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291140 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291147 */     GIR_RootConstrainSelectedInstOperands,
     /* 291148 */     // GIR_Coverage, 5195,
     /* 291148 */     GIR_EraseRootFromParent_Done,
     /* 291149 */   // Label 5692: @291149
     /* 291149 */   GIM_Try, /*On fail goto*//*Label 5693*/ GIMT_Encode4(291186), // Rule ID 5202 //
     /* 291154 */     // MIs[0] Operand 1
     /* 291154 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291159 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291163 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291169 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291175 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291177 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291182 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291184 */     GIR_RootConstrainSelectedInstOperands,
     /* 291185 */     // GIR_Coverage, 5202,
     /* 291185 */     GIR_EraseRootFromParent_Done,
     /* 291186 */   // Label 5693: @291186
     /* 291186 */   GIM_Try, /*On fail goto*//*Label 5694*/ GIMT_Encode4(291223), // Rule ID 5209 //
     /* 291191 */     // MIs[0] Operand 1
     /* 291191 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291200 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291206 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291208 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291214 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291219 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291221 */     GIR_RootConstrainSelectedInstOperands,
     /* 291222 */     // GIR_Coverage, 5209,
     /* 291222 */     GIR_EraseRootFromParent_Done,
     /* 291223 */   // Label 5694: @291223
     /* 291223 */   GIM_Try, /*On fail goto*//*Label 5695*/ GIMT_Encode4(291260), // Rule ID 5216 //
     /* 291228 */     // MIs[0] Operand 1
     /* 291228 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 291237 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291243 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291245 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291249 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291251 */     // (setcc:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, V64:{ *:[v4i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 291258 */     GIR_RootConstrainSelectedInstOperands,
     /* 291259 */     // GIR_Coverage, 5216,
     /* 291259 */     GIR_EraseRootFromParent_Done,
     /* 291260 */   // Label 5695: @291260
     /* 291260 */   GIM_Try, /*On fail goto*//*Label 5696*/ GIMT_Encode4(291300), // Rule ID 724 //
     /* 291265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291268 */     // MIs[0] Operand 1
     /* 291268 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291273 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291291 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291296 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291298 */     GIR_RootConstrainSelectedInstOperands,
     /* 291299 */     // GIR_Coverage, 724,
     /* 291299 */     GIR_EraseRootFromParent_Done,
     /* 291300 */   // Label 5696: @291300
     /* 291300 */   GIM_Try, /*On fail goto*//*Label 5697*/ GIMT_Encode4(291340), // Rule ID 733 //
     /* 291305 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291308 */     // MIs[0] Operand 1
     /* 291308 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291313 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291317 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291321 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291327 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291331 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291336 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291338 */     GIR_RootConstrainSelectedInstOperands,
     /* 291339 */     // GIR_Coverage, 733,
     /* 291339 */     GIR_EraseRootFromParent_Done,
     /* 291340 */   // Label 5697: @291340
     /* 291340 */   GIM_Try, /*On fail goto*//*Label 5698*/ GIMT_Encode4(291380), // Rule ID 734 //
     /* 291345 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291348 */     // MIs[0] Operand 1
     /* 291348 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291353 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291357 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291361 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291367 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 291369 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291371 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllOnesV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291376 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291378 */     GIR_RootConstrainSelectedInstOperands,
     /* 291379 */     // GIR_Coverage, 734,
     /* 291379 */     GIR_EraseRootFromParent_Done,
     /* 291380 */   // Label 5698: @291380
     /* 291380 */   GIM_Try, /*On fail goto*//*Label 5699*/ GIMT_Encode4(291420), // Rule ID 745 //
     /* 291385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291388 */     // MIs[0] Operand 1
     /* 291388 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291393 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291401 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291407 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291409 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291411 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291411 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291414 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291416 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291418 */     GIR_RootConstrainSelectedInstOperands,
     /* 291419 */     // GIR_Coverage, 745,
     /* 291419 */     GIR_EraseRootFromParent_Done,
     /* 291420 */   // Label 5699: @291420
     /* 291420 */   GIM_Try, /*On fail goto*//*Label 5700*/ GIMT_Encode4(291457), // Rule ID 5153 //
     /* 291425 */     // MIs[0] Operand 1
     /* 291425 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291434 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291438 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291444 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291446 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291448 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16rz),
     /* 291451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291453 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291455 */     GIR_RootConstrainSelectedInstOperands,
     /* 291456 */     // GIR_Coverage, 5153,
     /* 291456 */     GIR_EraseRootFromParent_Done,
     /* 291457 */   // Label 5700: @291457
     /* 291457 */   GIM_Try, /*On fail goto*//*Label 5701*/ GIMT_Encode4(291494), // Rule ID 5160 //
     /* 291462 */     // MIs[0] Operand 1
     /* 291462 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291467 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291475 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291481 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291485 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGT:{ *:[Other] })  =>  (CMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16rz),
     /* 291488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291490 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291492 */     GIR_RootConstrainSelectedInstOperands,
     /* 291493 */     // GIR_Coverage, 5160,
     /* 291493 */     GIR_EraseRootFromParent_Done,
     /* 291494 */   // Label 5701: @291494
     /* 291494 */   GIM_Try, /*On fail goto*//*Label 5702*/ GIMT_Encode4(291531), // Rule ID 5167 //
     /* 291499 */     // MIs[0] Operand 1
     /* 291499 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291508 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291512 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291518 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291520 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291522 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETGE:{ *:[Other] })  =>  (CMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16rz),
     /* 291525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291529 */     GIR_RootConstrainSelectedInstOperands,
     /* 291530 */     // GIR_Coverage, 5167,
     /* 291530 */     GIR_EraseRootFromParent_Done,
     /* 291531 */   // Label 5702: @291531
     /* 291531 */   GIM_Try, /*On fail goto*//*Label 5703*/ GIMT_Encode4(291568), // Rule ID 5174 //
     /* 291536 */     // MIs[0] Operand 1
     /* 291536 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291541 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291557 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291559 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLT:{ *:[Other] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291559 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 291562 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291564 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291566 */     GIR_RootConstrainSelectedInstOperands,
     /* 291567 */     // GIR_Coverage, 5174,
     /* 291567 */     GIR_EraseRootFromParent_Done,
     /* 291568 */   // Label 5703: @291568
     /* 291568 */   GIM_Try, /*On fail goto*//*Label 5704*/ GIMT_Encode4(291605), // Rule ID 5181 //
     /* 291573 */     // MIs[0] Operand 1
     /* 291573 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 291586 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 291592 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 291594 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 291596 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, immAllZerosV:{ *:[v4i16] }, SETLE:{ *:[Other] })  =>  (CMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 291596 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i16rz),
     /* 291599 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291601 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291603 */     GIR_RootConstrainSelectedInstOperands,
     /* 291604 */     // GIR_Coverage, 5181,
     /* 291604 */     GIR_EraseRootFromParent_Done,
     /* 291605 */   // Label 5704: @291605
     /* 291605 */   GIM_Try, /*On fail goto*//*Label 5705*/ GIMT_Encode4(291637), // Rule ID 1123 //
     /* 291610 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291613 */     // MIs[0] Operand 1
     /* 291613 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291618 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291622 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291626 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291631 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291633 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291635 */     GIR_RootConstrainSelectedInstOperands,
     /* 291636 */     // GIR_Coverage, 1123,
     /* 291636 */     GIR_EraseRootFromParent_Done,
     /* 291637 */   // Label 5705: @291637
     /* 291637 */   GIM_Try, /*On fail goto*//*Label 5706*/ GIMT_Encode4(291669), // Rule ID 1130 //
     /* 291642 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291645 */     // MIs[0] Operand 1
     /* 291645 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291650 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291654 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291658 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291663 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291665 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291667 */     GIR_RootConstrainSelectedInstOperands,
     /* 291668 */     // GIR_Coverage, 1130,
     /* 291668 */     GIR_EraseRootFromParent_Done,
     /* 291669 */   // Label 5706: @291669
     /* 291669 */   GIM_Try, /*On fail goto*//*Label 5707*/ GIMT_Encode4(291701), // Rule ID 1137 //
     /* 291674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291677 */     // MIs[0] Operand 1
     /* 291677 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291682 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291686 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291690 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291695 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291697 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291699 */     GIR_RootConstrainSelectedInstOperands,
     /* 291700 */     // GIR_Coverage, 1137,
     /* 291700 */     GIR_EraseRootFromParent_Done,
     /* 291701 */   // Label 5707: @291701
     /* 291701 */   GIM_Try, /*On fail goto*//*Label 5708*/ GIMT_Encode4(291733), // Rule ID 1144 //
     /* 291706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291709 */     // MIs[0] Operand 1
     /* 291709 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291722 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291731 */     GIR_RootConstrainSelectedInstOperands,
     /* 291732 */     // GIR_Coverage, 1144,
     /* 291732 */     GIR_EraseRootFromParent_Done,
     /* 291733 */   // Label 5708: @291733
     /* 291733 */   GIM_Try, /*On fail goto*//*Label 5709*/ GIMT_Encode4(291765), // Rule ID 1151 //
     /* 291738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 291741 */     // MIs[0] Operand 1
     /* 291741 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291754 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 291757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291763 */     GIR_RootConstrainSelectedInstOperands,
     /* 291764 */     // GIR_Coverage, 1151,
     /* 291764 */     GIR_EraseRootFromParent_Done,
     /* 291765 */   // Label 5709: @291765
     /* 291765 */   GIM_Try, /*On fail goto*//*Label 5710*/ GIMT_Encode4(291794), // Rule ID 5090 //
     /* 291770 */     // MIs[0] Operand 1
     /* 291770 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 291775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291783 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i16),
     /* 291786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291788 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291792 */     GIR_RootConstrainSelectedInstOperands,
     /* 291793 */     // GIR_Coverage, 5090,
     /* 291793 */     GIR_EraseRootFromParent_Done,
     /* 291794 */   // Label 5710: @291794
     /* 291794 */   GIM_Try, /*On fail goto*//*Label 5711*/ GIMT_Encode4(291823), // Rule ID 5097 //
     /* 291799 */     // MIs[0] Operand 1
     /* 291799 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 291804 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291808 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291812 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291812 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291815 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291817 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291819 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291821 */     GIR_RootConstrainSelectedInstOperands,
     /* 291822 */     // GIR_Coverage, 5097,
     /* 291822 */     GIR_EraseRootFromParent_Done,
     /* 291823 */   // Label 5711: @291823
     /* 291823 */   GIM_Try, /*On fail goto*//*Label 5712*/ GIMT_Encode4(291852), // Rule ID 5104 //
     /* 291828 */     // MIs[0] Operand 1
     /* 291828 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 291833 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291837 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291841 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291846 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291848 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291850 */     GIR_RootConstrainSelectedInstOperands,
     /* 291851 */     // GIR_Coverage, 5104,
     /* 291851 */     GIR_EraseRootFromParent_Done,
     /* 291852 */   // Label 5712: @291852
     /* 291852 */   GIM_Try, /*On fail goto*//*Label 5713*/ GIMT_Encode4(291881), // Rule ID 5111 //
     /* 291857 */     // MIs[0] Operand 1
     /* 291857 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 291862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291870 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291875 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291877 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291879 */     GIR_RootConstrainSelectedInstOperands,
     /* 291880 */     // GIR_Coverage, 5111,
     /* 291880 */     GIR_EraseRootFromParent_Done,
     /* 291881 */   // Label 5713: @291881
     /* 291881 */   GIM_Try, /*On fail goto*//*Label 5714*/ GIMT_Encode4(291910), // Rule ID 5118 //
     /* 291886 */     // MIs[0] Operand 1
     /* 291886 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 291891 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291895 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291899 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 291899 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 291902 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291906 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291908 */     GIR_RootConstrainSelectedInstOperands,
     /* 291909 */     // GIR_Coverage, 5118,
     /* 291909 */     GIR_EraseRootFromParent_Done,
     /* 291910 */   // Label 5714: @291910
     /* 291910 */   GIM_Try, /*On fail goto*//*Label 5715*/ GIMT_Encode4(291939), // Rule ID 5125 //
     /* 291915 */     // MIs[0] Operand 1
     /* 291915 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 291920 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291924 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291928 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 291928 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i16),
     /* 291931 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291933 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291935 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291937 */     GIR_RootConstrainSelectedInstOperands,
     /* 291938 */     // GIR_Coverage, 5125,
     /* 291938 */     GIR_EraseRootFromParent_Done,
     /* 291939 */   // Label 5715: @291939
     /* 291939 */   GIM_Try, /*On fail goto*//*Label 5716*/ GIMT_Encode4(291968), // Rule ID 5132 //
     /* 291944 */     // MIs[0] Operand 1
     /* 291944 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 291949 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291953 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291957 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 291957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i16),
     /* 291960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291966 */     GIR_RootConstrainSelectedInstOperands,
     /* 291967 */     // GIR_Coverage, 5132,
     /* 291967 */     GIR_EraseRootFromParent_Done,
     /* 291968 */   // Label 5716: @291968
     /* 291968 */   GIM_Try, /*On fail goto*//*Label 5717*/ GIMT_Encode4(291997), // Rule ID 5139 //
     /* 291973 */     // MIs[0] Operand 1
     /* 291973 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 291978 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 291986 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 291986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i16),
     /* 291989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 291991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 291993 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 291995 */     GIR_RootConstrainSelectedInstOperands,
     /* 291996 */     // GIR_Coverage, 5139,
     /* 291996 */     GIR_EraseRootFromParent_Done,
     /* 291997 */   // Label 5717: @291997
     /* 291997 */   GIM_Try, /*On fail goto*//*Label 5718*/ GIMT_Encode4(292026), // Rule ID 5146 //
     /* 292002 */     // MIs[0] Operand 1
     /* 292002 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 292007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 292015 */     // (setcc:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rm, V64:{ *:[v4i16] }:$Rn)
     /* 292015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i16),
     /* 292018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292020 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292024 */     GIR_RootConstrainSelectedInstOperands,
     /* 292025 */     // GIR_Coverage, 5146,
     /* 292025 */     GIR_EraseRootFromParent_Done,
     /* 292026 */   // Label 5718: @292026
     /* 292026 */   GIM_Reject,
     /* 292027 */ // Label 5688: @292027
     /* 292027 */ GIM_Reject,
     /* 292028 */ // Label 5609: @292028
     /* 292028 */ GIM_Try, /*On fail goto*//*Label 5719*/ GIMT_Encode4(293075),
     /* 292033 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 292036 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 292039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292043 */   GIM_Try, /*On fail goto*//*Label 5720*/ GIMT_Encode4(292083), // Rule ID 755 //
     /* 292048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292051 */     // MIs[0] Operand 1
     /* 292051 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292056 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292060 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292066 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292072 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292074 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292079 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292081 */     GIR_RootConstrainSelectedInstOperands,
     /* 292082 */     // GIR_Coverage, 755,
     /* 292082 */     GIR_EraseRootFromParent_Done,
     /* 292083 */   // Label 5720: @292083
     /* 292083 */   GIM_Try, /*On fail goto*//*Label 5721*/ GIMT_Encode4(292123), // Rule ID 762 //
     /* 292088 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292091 */     // MIs[0] Operand 1
     /* 292091 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292096 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292100 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292106 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292108 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292112 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292114 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292119 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292121 */     GIR_RootConstrainSelectedInstOperands,
     /* 292122 */     // GIR_Coverage, 762,
     /* 292122 */     GIR_EraseRootFromParent_Done,
     /* 292123 */   // Label 5721: @292123
     /* 292123 */   GIM_Try, /*On fail goto*//*Label 5722*/ GIMT_Encode4(292160), // Rule ID 5191 //
     /* 292128 */     // MIs[0] Operand 1
     /* 292128 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292133 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292137 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292143 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292151 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292151 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292154 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292158 */     GIR_RootConstrainSelectedInstOperands,
     /* 292159 */     // GIR_Coverage, 5191,
     /* 292159 */     GIR_EraseRootFromParent_Done,
     /* 292160 */   // Label 5722: @292160
     /* 292160 */   GIM_Try, /*On fail goto*//*Label 5723*/ GIMT_Encode4(292197), // Rule ID 5198 //
     /* 292165 */     // MIs[0] Operand 1
     /* 292165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292174 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292180 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292186 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292188 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292195 */     GIR_RootConstrainSelectedInstOperands,
     /* 292196 */     // GIR_Coverage, 5198,
     /* 292196 */     GIR_EraseRootFromParent_Done,
     /* 292197 */   // Label 5723: @292197
     /* 292197 */   GIM_Try, /*On fail goto*//*Label 5724*/ GIMT_Encode4(292234), // Rule ID 5205 //
     /* 292202 */     // MIs[0] Operand 1
     /* 292202 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292211 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292217 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292219 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292223 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292225 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292230 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292232 */     GIR_RootConstrainSelectedInstOperands,
     /* 292233 */     // GIR_Coverage, 5205,
     /* 292233 */     GIR_EraseRootFromParent_Done,
     /* 292234 */   // Label 5724: @292234
     /* 292234 */   GIM_Try, /*On fail goto*//*Label 5725*/ GIMT_Encode4(292271), // Rule ID 5212 //
     /* 292239 */     // MIs[0] Operand 1
     /* 292239 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292244 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292248 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292254 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292256 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292260 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292262 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292262 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292265 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292267 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292269 */     GIR_RootConstrainSelectedInstOperands,
     /* 292270 */     // GIR_Coverage, 5212,
     /* 292270 */     GIR_EraseRootFromParent_Done,
     /* 292271 */   // Label 5725: @292271
     /* 292271 */   GIM_Try, /*On fail goto*//*Label 5726*/ GIMT_Encode4(292308), // Rule ID 5219 //
     /* 292276 */     // MIs[0] Operand 1
     /* 292276 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 292285 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292291 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292299 */     // (setcc:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 292306 */     GIR_RootConstrainSelectedInstOperands,
     /* 292307 */     // GIR_Coverage, 5219,
     /* 292307 */     GIR_EraseRootFromParent_Done,
     /* 292308 */   // Label 5726: @292308
     /* 292308 */   GIM_Try, /*On fail goto*//*Label 5727*/ GIMT_Encode4(292348), // Rule ID 727 //
     /* 292313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292316 */     // MIs[0] Operand 1
     /* 292316 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292329 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292335 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292337 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292339 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292344 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292346 */     GIR_RootConstrainSelectedInstOperands,
     /* 292347 */     // GIR_Coverage, 727,
     /* 292347 */     GIR_EraseRootFromParent_Done,
     /* 292348 */   // Label 5727: @292348
     /* 292348 */   GIM_Try, /*On fail goto*//*Label 5728*/ GIMT_Encode4(292388), // Rule ID 739 //
     /* 292353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292356 */     // MIs[0] Operand 1
     /* 292356 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292361 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292365 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292369 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292375 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292377 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292379 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292379 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292382 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292384 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292386 */     GIR_RootConstrainSelectedInstOperands,
     /* 292387 */     // GIR_Coverage, 739,
     /* 292387 */     GIR_EraseRootFromParent_Done,
     /* 292388 */   // Label 5728: @292388
     /* 292388 */   GIM_Try, /*On fail goto*//*Label 5729*/ GIMT_Encode4(292428), // Rule ID 740 //
     /* 292393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292396 */     // MIs[0] Operand 1
     /* 292396 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292401 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292415 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 292417 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292419 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllOnesV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292419 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292422 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292424 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292426 */     GIR_RootConstrainSelectedInstOperands,
     /* 292427 */     // GIR_Coverage, 740,
     /* 292427 */     GIR_EraseRootFromParent_Done,
     /* 292428 */   // Label 5729: @292428
     /* 292428 */   GIM_Try, /*On fail goto*//*Label 5730*/ GIMT_Encode4(292468), // Rule ID 748 //
     /* 292433 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292436 */     // MIs[0] Operand 1
     /* 292436 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292441 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292449 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292455 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292457 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292459 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292464 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292466 */     GIR_RootConstrainSelectedInstOperands,
     /* 292467 */     // GIR_Coverage, 748,
     /* 292467 */     GIR_EraseRootFromParent_Done,
     /* 292468 */   // Label 5730: @292468
     /* 292468 */   GIM_Try, /*On fail goto*//*Label 5731*/ GIMT_Encode4(292505), // Rule ID 5156 //
     /* 292473 */     // MIs[0] Operand 1
     /* 292473 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292478 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292494 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292496 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETEQ:{ *:[Other] })  =>  (CMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292496 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32rz),
     /* 292499 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292501 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292503 */     GIR_RootConstrainSelectedInstOperands,
     /* 292504 */     // GIR_Coverage, 5156,
     /* 292504 */     GIR_EraseRootFromParent_Done,
     /* 292505 */   // Label 5731: @292505
     /* 292505 */   GIM_Try, /*On fail goto*//*Label 5732*/ GIMT_Encode4(292542), // Rule ID 5163 //
     /* 292510 */     // MIs[0] Operand 1
     /* 292510 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292515 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292523 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292529 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292533 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGT:{ *:[Other] })  =>  (CMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32rz),
     /* 292536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292538 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292540 */     GIR_RootConstrainSelectedInstOperands,
     /* 292541 */     // GIR_Coverage, 5163,
     /* 292541 */     GIR_EraseRootFromParent_Done,
     /* 292542 */   // Label 5732: @292542
     /* 292542 */   GIM_Try, /*On fail goto*//*Label 5733*/ GIMT_Encode4(292579), // Rule ID 5170 //
     /* 292547 */     // MIs[0] Operand 1
     /* 292547 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292552 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292560 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292566 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292570 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETGE:{ *:[Other] })  =>  (CMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32rz),
     /* 292573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292575 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292577 */     GIR_RootConstrainSelectedInstOperands,
     /* 292578 */     // GIR_Coverage, 5170,
     /* 292578 */     GIR_EraseRootFromParent_Done,
     /* 292579 */   // Label 5733: @292579
     /* 292579 */   GIM_Try, /*On fail goto*//*Label 5734*/ GIMT_Encode4(292616), // Rule ID 5177 //
     /* 292584 */     // MIs[0] Operand 1
     /* 292584 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292589 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292597 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292603 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292605 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292607 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLT:{ *:[Other] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 292610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292612 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292614 */     GIR_RootConstrainSelectedInstOperands,
     /* 292615 */     // GIR_Coverage, 5177,
     /* 292615 */     GIR_EraseRootFromParent_Done,
     /* 292616 */   // Label 5734: @292616
     /* 292616 */   GIM_Try, /*On fail goto*//*Label 5735*/ GIMT_Encode4(292653), // Rule ID 5184 //
     /* 292621 */     // MIs[0] Operand 1
     /* 292621 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292626 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 292634 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 292640 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 292642 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 292644 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, immAllZerosV:{ *:[v4i32] }, SETLE:{ *:[Other] })  =>  (CMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 292644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv4i32rz),
     /* 292647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292649 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292651 */     GIR_RootConstrainSelectedInstOperands,
     /* 292652 */     // GIR_Coverage, 5184,
     /* 292652 */     GIR_EraseRootFromParent_Done,
     /* 292653 */   // Label 5735: @292653
     /* 292653 */   GIM_Try, /*On fail goto*//*Label 5736*/ GIMT_Encode4(292685), // Rule ID 1126 //
     /* 292658 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292661 */     // MIs[0] Operand 1
     /* 292661 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292670 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292674 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292674 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292677 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292679 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292681 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292683 */     GIR_RootConstrainSelectedInstOperands,
     /* 292684 */     // GIR_Coverage, 1126,
     /* 292684 */     GIR_EraseRootFromParent_Done,
     /* 292685 */   // Label 5736: @292685
     /* 292685 */   GIM_Try, /*On fail goto*//*Label 5737*/ GIMT_Encode4(292717), // Rule ID 1133 //
     /* 292690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292693 */     // MIs[0] Operand 1
     /* 292693 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292698 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292702 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292706 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 292709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292711 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292713 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292715 */     GIR_RootConstrainSelectedInstOperands,
     /* 292716 */     // GIR_Coverage, 1133,
     /* 292716 */     GIR_EraseRootFromParent_Done,
     /* 292717 */   // Label 5737: @292717
     /* 292717 */   GIM_Try, /*On fail goto*//*Label 5738*/ GIMT_Encode4(292749), // Rule ID 1140 //
     /* 292722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292725 */     // MIs[0] Operand 1
     /* 292725 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292730 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292734 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292738 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292738 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292741 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292743 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292747 */     GIR_RootConstrainSelectedInstOperands,
     /* 292748 */     // GIR_Coverage, 1140,
     /* 292748 */     GIR_EraseRootFromParent_Done,
     /* 292749 */   // Label 5738: @292749
     /* 292749 */   GIM_Try, /*On fail goto*//*Label 5739*/ GIMT_Encode4(292781), // Rule ID 1147 //
     /* 292754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292757 */     // MIs[0] Operand 1
     /* 292757 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292770 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 292773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292779 */     GIR_RootConstrainSelectedInstOperands,
     /* 292780 */     // GIR_Coverage, 1147,
     /* 292780 */     GIR_EraseRootFromParent_Done,
     /* 292781 */   // Label 5739: @292781
     /* 292781 */   GIM_Try, /*On fail goto*//*Label 5740*/ GIMT_Encode4(292813), // Rule ID 1154 //
     /* 292786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 292789 */     // MIs[0] Operand 1
     /* 292789 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292802 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 292805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292811 */     GIR_RootConstrainSelectedInstOperands,
     /* 292812 */     // GIR_Coverage, 1154,
     /* 292812 */     GIR_EraseRootFromParent_Done,
     /* 292813 */   // Label 5740: @292813
     /* 292813 */   GIM_Try, /*On fail goto*//*Label 5741*/ GIMT_Encode4(292842), // Rule ID 5093 //
     /* 292818 */     // MIs[0] Operand 1
     /* 292818 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 292823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292827 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292831 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv4i32),
     /* 292834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292836 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292840 */     GIR_RootConstrainSelectedInstOperands,
     /* 292841 */     // GIR_Coverage, 5093,
     /* 292841 */     GIR_EraseRootFromParent_Done,
     /* 292842 */   // Label 5741: @292842
     /* 292842 */   GIM_Try, /*On fail goto*//*Label 5742*/ GIMT_Encode4(292871), // Rule ID 5100 //
     /* 292847 */     // MIs[0] Operand 1
     /* 292847 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 292852 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292856 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292860 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292865 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292867 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292869 */     GIR_RootConstrainSelectedInstOperands,
     /* 292870 */     // GIR_Coverage, 5100,
     /* 292870 */     GIR_EraseRootFromParent_Done,
     /* 292871 */   // Label 5742: @292871
     /* 292871 */   GIM_Try, /*On fail goto*//*Label 5743*/ GIMT_Encode4(292900), // Rule ID 5107 //
     /* 292876 */     // MIs[0] Operand 1
     /* 292876 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 292881 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292889 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 292892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292894 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292898 */     GIR_RootConstrainSelectedInstOperands,
     /* 292899 */     // GIR_Coverage, 5107,
     /* 292899 */     GIR_EraseRootFromParent_Done,
     /* 292900 */   // Label 5743: @292900
     /* 292900 */   GIM_Try, /*On fail goto*//*Label 5744*/ GIMT_Encode4(292929), // Rule ID 5114 //
     /* 292905 */     // MIs[0] Operand 1
     /* 292905 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 292910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292914 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292918 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292918 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 292921 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292923 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292925 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292927 */     GIR_RootConstrainSelectedInstOperands,
     /* 292928 */     // GIR_Coverage, 5114,
     /* 292928 */     GIR_EraseRootFromParent_Done,
     /* 292929 */   // Label 5744: @292929
     /* 292929 */   GIM_Try, /*On fail goto*//*Label 5745*/ GIMT_Encode4(292958), // Rule ID 5121 //
     /* 292934 */     // MIs[0] Operand 1
     /* 292934 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 292939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292943 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292947 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 292947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 292950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292956 */     GIR_RootConstrainSelectedInstOperands,
     /* 292957 */     // GIR_Coverage, 5121,
     /* 292957 */     GIR_EraseRootFromParent_Done,
     /* 292958 */   // Label 5745: @292958
     /* 292958 */   GIM_Try, /*On fail goto*//*Label 5746*/ GIMT_Encode4(292987), // Rule ID 5128 //
     /* 292963 */     // MIs[0] Operand 1
     /* 292963 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 292968 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292972 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 292976 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 292976 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv4i32),
     /* 292979 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 292981 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 292983 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 292985 */     GIR_RootConstrainSelectedInstOperands,
     /* 292986 */     // GIR_Coverage, 5128,
     /* 292986 */     GIR_EraseRootFromParent_Done,
     /* 292987 */   // Label 5746: @292987
     /* 292987 */   GIM_Try, /*On fail goto*//*Label 5747*/ GIMT_Encode4(293016), // Rule ID 5135 //
     /* 292992 */     // MIs[0] Operand 1
     /* 292992 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 292997 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293001 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293005 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv4i32),
     /* 293008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293014 */     GIR_RootConstrainSelectedInstOperands,
     /* 293015 */     // GIR_Coverage, 5135,
     /* 293015 */     GIR_EraseRootFromParent_Done,
     /* 293016 */   // Label 5747: @293016
     /* 293016 */   GIM_Try, /*On fail goto*//*Label 5748*/ GIMT_Encode4(293045), // Rule ID 5142 //
     /* 293021 */     // MIs[0] Operand 1
     /* 293021 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 293026 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293030 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293034 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293034 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv4i32),
     /* 293037 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293041 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293043 */     GIR_RootConstrainSelectedInstOperands,
     /* 293044 */     // GIR_Coverage, 5142,
     /* 293044 */     GIR_EraseRootFromParent_Done,
     /* 293045 */   // Label 5748: @293045
     /* 293045 */   GIM_Try, /*On fail goto*//*Label 5749*/ GIMT_Encode4(293074), // Rule ID 5149 //
     /* 293050 */     // MIs[0] Operand 1
     /* 293050 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 293055 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293059 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 293063 */     // (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, V128:{ *:[v4i32] }:$Rn)
     /* 293063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv4i32),
     /* 293066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293068 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293070 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293072 */     GIR_RootConstrainSelectedInstOperands,
     /* 293073 */     // GIR_Coverage, 5149,
     /* 293073 */     GIR_EraseRootFromParent_Done,
     /* 293074 */   // Label 5749: @293074
     /* 293074 */   GIM_Reject,
     /* 293075 */ // Label 5719: @293075
     /* 293075 */ GIM_Reject,
     /* 293076 */ // Label 5610: @293076
     /* 293076 */ GIM_Try, /*On fail goto*//*Label 5750*/ GIMT_Encode4(294123),
     /* 293081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 293084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 293087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293091 */   GIM_Try, /*On fail goto*//*Label 5751*/ GIMT_Encode4(293131), // Rule ID 750 //
     /* 293096 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293099 */     // MIs[0] Operand 1
     /* 293099 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293104 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293108 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293114 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293120 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293122 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293122 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293125 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293127 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293129 */     GIR_RootConstrainSelectedInstOperands,
     /* 293130 */     // GIR_Coverage, 750,
     /* 293130 */     GIR_EraseRootFromParent_Done,
     /* 293131 */   // Label 5751: @293131
     /* 293131 */   GIM_Try, /*On fail goto*//*Label 5752*/ GIMT_Encode4(293171), // Rule ID 757 //
     /* 293136 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293139 */     // MIs[0] Operand 1
     /* 293139 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293148 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293154 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293156 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293160 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293162 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293162 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293165 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293167 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293169 */     GIR_RootConstrainSelectedInstOperands,
     /* 293170 */     // GIR_Coverage, 757,
     /* 293170 */     GIR_EraseRootFromParent_Done,
     /* 293171 */   // Label 5752: @293171
     /* 293171 */   GIM_Try, /*On fail goto*//*Label 5753*/ GIMT_Encode4(293208), // Rule ID 5186 //
     /* 293176 */     // MIs[0] Operand 1
     /* 293176 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293181 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293185 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293191 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293193 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293197 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293199 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293199 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293202 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293204 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293206 */     GIR_RootConstrainSelectedInstOperands,
     /* 293207 */     // GIR_Coverage, 5186,
     /* 293207 */     GIR_EraseRootFromParent_Done,
     /* 293208 */   // Label 5753: @293208
     /* 293208 */   GIM_Try, /*On fail goto*//*Label 5754*/ GIMT_Encode4(293245), // Rule ID 5193 //
     /* 293213 */     // MIs[0] Operand 1
     /* 293213 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293218 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293222 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293228 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293230 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293234 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293236 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293236 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293239 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293241 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293243 */     GIR_RootConstrainSelectedInstOperands,
     /* 293244 */     // GIR_Coverage, 5193,
     /* 293244 */     GIR_EraseRootFromParent_Done,
     /* 293245 */   // Label 5754: @293245
     /* 293245 */   GIM_Try, /*On fail goto*//*Label 5755*/ GIMT_Encode4(293282), // Rule ID 5200 //
     /* 293250 */     // MIs[0] Operand 1
     /* 293250 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293255 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293259 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293265 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293267 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293271 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293273 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293278 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293280 */     GIR_RootConstrainSelectedInstOperands,
     /* 293281 */     // GIR_Coverage, 5200,
     /* 293281 */     GIR_EraseRootFromParent_Done,
     /* 293282 */   // Label 5755: @293282
     /* 293282 */   GIM_Try, /*On fail goto*//*Label 5756*/ GIMT_Encode4(293319), // Rule ID 5207 //
     /* 293287 */     // MIs[0] Operand 1
     /* 293287 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293296 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293302 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293304 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293308 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293310 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293315 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293317 */     GIR_RootConstrainSelectedInstOperands,
     /* 293318 */     // GIR_Coverage, 5207,
     /* 293318 */     GIR_EraseRootFromParent_Done,
     /* 293319 */   // Label 5756: @293319
     /* 293319 */   GIM_Try, /*On fail goto*//*Label 5757*/ GIMT_Encode4(293356), // Rule ID 5214 //
     /* 293324 */     // MIs[0] Operand 1
     /* 293324 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 293333 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293339 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293341 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293345 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293347 */     // (setcc:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, V64:{ *:[v8i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293352 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 293354 */     GIR_RootConstrainSelectedInstOperands,
     /* 293355 */     // GIR_Coverage, 5214,
     /* 293355 */     GIR_EraseRootFromParent_Done,
     /* 293356 */   // Label 5757: @293356
     /* 293356 */   GIM_Try, /*On fail goto*//*Label 5758*/ GIMT_Encode4(293396), // Rule ID 722 //
     /* 293361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293364 */     // MIs[0] Operand 1
     /* 293364 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293369 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293373 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293377 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293383 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293385 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293387 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293387 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293390 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293394 */     GIR_RootConstrainSelectedInstOperands,
     /* 293395 */     // GIR_Coverage, 722,
     /* 293395 */     GIR_EraseRootFromParent_Done,
     /* 293396 */   // Label 5758: @293396
     /* 293396 */   GIM_Try, /*On fail goto*//*Label 5759*/ GIMT_Encode4(293436), // Rule ID 729 //
     /* 293401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293404 */     // MIs[0] Operand 1
     /* 293404 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293409 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293425 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293427 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293427 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293430 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293434 */     GIR_RootConstrainSelectedInstOperands,
     /* 293435 */     // GIR_Coverage, 729,
     /* 293435 */     GIR_EraseRootFromParent_Done,
     /* 293436 */   // Label 5759: @293436
     /* 293436 */   GIM_Try, /*On fail goto*//*Label 5760*/ GIMT_Encode4(293476), // Rule ID 730 //
     /* 293441 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293444 */     // MIs[0] Operand 1
     /* 293444 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293449 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293457 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293463 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 293465 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293467 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllOnesV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293472 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293474 */     GIR_RootConstrainSelectedInstOperands,
     /* 293475 */     // GIR_Coverage, 730,
     /* 293475 */     GIR_EraseRootFromParent_Done,
     /* 293476 */   // Label 5760: @293476
     /* 293476 */   GIM_Try, /*On fail goto*//*Label 5761*/ GIMT_Encode4(293516), // Rule ID 743 //
     /* 293481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293484 */     // MIs[0] Operand 1
     /* 293484 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293489 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293497 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293503 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293505 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293507 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293507 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293510 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293514 */     GIR_RootConstrainSelectedInstOperands,
     /* 293515 */     // GIR_Coverage, 743,
     /* 293515 */     GIR_EraseRootFromParent_Done,
     /* 293516 */   // Label 5761: @293516
     /* 293516 */   GIM_Try, /*On fail goto*//*Label 5762*/ GIMT_Encode4(293553), // Rule ID 5151 //
     /* 293521 */     // MIs[0] Operand 1
     /* 293521 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293526 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293534 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293540 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293542 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293544 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8rz),
     /* 293547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293549 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293551 */     GIR_RootConstrainSelectedInstOperands,
     /* 293552 */     // GIR_Coverage, 5151,
     /* 293552 */     GIR_EraseRootFromParent_Done,
     /* 293553 */   // Label 5762: @293553
     /* 293553 */   GIM_Try, /*On fail goto*//*Label 5763*/ GIMT_Encode4(293590), // Rule ID 5158 //
     /* 293558 */     // MIs[0] Operand 1
     /* 293558 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293563 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293567 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293571 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293577 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293581 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGT:{ *:[Other] })  =>  (CMGTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8rz),
     /* 293584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293588 */     GIR_RootConstrainSelectedInstOperands,
     /* 293589 */     // GIR_Coverage, 5158,
     /* 293589 */     GIR_EraseRootFromParent_Done,
     /* 293590 */   // Label 5763: @293590
     /* 293590 */   GIM_Try, /*On fail goto*//*Label 5764*/ GIMT_Encode4(293627), // Rule ID 5165 //
     /* 293595 */     // MIs[0] Operand 1
     /* 293595 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293600 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293604 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293608 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293614 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293616 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293618 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETGE:{ *:[Other] })  =>  (CMGEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8rz),
     /* 293621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293623 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293625 */     GIR_RootConstrainSelectedInstOperands,
     /* 293626 */     // GIR_Coverage, 5165,
     /* 293626 */     GIR_EraseRootFromParent_Done,
     /* 293627 */   // Label 5764: @293627
     /* 293627 */   GIM_Try, /*On fail goto*//*Label 5765*/ GIMT_Encode4(293664), // Rule ID 5172 //
     /* 293632 */     // MIs[0] Operand 1
     /* 293632 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 293637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293653 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293655 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLT:{ *:[Other] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 293658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293660 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293662 */     GIR_RootConstrainSelectedInstOperands,
     /* 293663 */     // GIR_Coverage, 5172,
     /* 293663 */     GIR_EraseRootFromParent_Done,
     /* 293664 */   // Label 5765: @293664
     /* 293664 */   GIM_Try, /*On fail goto*//*Label 5766*/ GIMT_Encode4(293701), // Rule ID 5179 //
     /* 293669 */     // MIs[0] Operand 1
     /* 293669 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 293674 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293678 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 293682 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 293688 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 293690 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 293692 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, immAllZerosV:{ *:[v8i8] }, SETLE:{ *:[Other] })  =>  (CMLEv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 293692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i8rz),
     /* 293695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293699 */     GIR_RootConstrainSelectedInstOperands,
     /* 293700 */     // GIR_Coverage, 5179,
     /* 293700 */     GIR_EraseRootFromParent_Done,
     /* 293701 */   // Label 5766: @293701
     /* 293701 */   GIM_Try, /*On fail goto*//*Label 5767*/ GIMT_Encode4(293733), // Rule ID 1121 //
     /* 293706 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293709 */     // MIs[0] Operand 1
     /* 293709 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293714 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293718 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293722 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293727 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293729 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293731 */     GIR_RootConstrainSelectedInstOperands,
     /* 293732 */     // GIR_Coverage, 1121,
     /* 293732 */     GIR_EraseRootFromParent_Done,
     /* 293733 */   // Label 5767: @293733
     /* 293733 */   GIM_Try, /*On fail goto*//*Label 5768*/ GIMT_Encode4(293765), // Rule ID 1128 //
     /* 293738 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293741 */     // MIs[0] Operand 1
     /* 293741 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293746 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293750 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293754 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 293757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293761 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293763 */     GIR_RootConstrainSelectedInstOperands,
     /* 293764 */     // GIR_Coverage, 1128,
     /* 293764 */     GIR_EraseRootFromParent_Done,
     /* 293765 */   // Label 5768: @293765
     /* 293765 */   GIM_Try, /*On fail goto*//*Label 5769*/ GIMT_Encode4(293797), // Rule ID 1135 //
     /* 293770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293773 */     // MIs[0] Operand 1
     /* 293773 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293778 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293782 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293786 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 293789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293791 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293795 */     GIR_RootConstrainSelectedInstOperands,
     /* 293796 */     // GIR_Coverage, 1135,
     /* 293796 */     GIR_EraseRootFromParent_Done,
     /* 293797 */   // Label 5769: @293797
     /* 293797 */   GIM_Try, /*On fail goto*//*Label 5770*/ GIMT_Encode4(293829), // Rule ID 1142 //
     /* 293802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293805 */     // MIs[0] Operand 1
     /* 293805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293818 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 293821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293827 */     GIR_RootConstrainSelectedInstOperands,
     /* 293828 */     // GIR_Coverage, 1142,
     /* 293828 */     GIR_EraseRootFromParent_Done,
     /* 293829 */   // Label 5770: @293829
     /* 293829 */   GIM_Try, /*On fail goto*//*Label 5771*/ GIMT_Encode4(293861), // Rule ID 1149 //
     /* 293834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 293837 */     // MIs[0] Operand 1
     /* 293837 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293850 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 293853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293859 */     GIR_RootConstrainSelectedInstOperands,
     /* 293860 */     // GIR_Coverage, 1149,
     /* 293860 */     GIR_EraseRootFromParent_Done,
     /* 293861 */   // Label 5771: @293861
     /* 293861 */   GIM_Try, /*On fail goto*//*Label 5772*/ GIMT_Encode4(293890), // Rule ID 5088 //
     /* 293866 */     // MIs[0] Operand 1
     /* 293866 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 293871 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293875 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293879 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i8),
     /* 293882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293884 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293886 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293888 */     GIR_RootConstrainSelectedInstOperands,
     /* 293889 */     // GIR_Coverage, 5088,
     /* 293889 */     GIR_EraseRootFromParent_Done,
     /* 293890 */   // Label 5772: @293890
     /* 293890 */   GIM_Try, /*On fail goto*//*Label 5773*/ GIMT_Encode4(293919), // Rule ID 5095 //
     /* 293895 */     // MIs[0] Operand 1
     /* 293895 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 293900 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293908 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293908 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 293911 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293913 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293917 */     GIR_RootConstrainSelectedInstOperands,
     /* 293918 */     // GIR_Coverage, 5095,
     /* 293918 */     GIR_EraseRootFromParent_Done,
     /* 293919 */   // Label 5773: @293919
     /* 293919 */   GIM_Try, /*On fail goto*//*Label 5774*/ GIMT_Encode4(293948), // Rule ID 5102 //
     /* 293924 */     // MIs[0] Operand 1
     /* 293924 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 293929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293937 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 293940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293942 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293944 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293946 */     GIR_RootConstrainSelectedInstOperands,
     /* 293947 */     // GIR_Coverage, 5102,
     /* 293947 */     GIR_EraseRootFromParent_Done,
     /* 293948 */   // Label 5774: @293948
     /* 293948 */   GIM_Try, /*On fail goto*//*Label 5775*/ GIMT_Encode4(293977), // Rule ID 5109 //
     /* 293953 */     // MIs[0] Operand 1
     /* 293953 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 293958 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293962 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293966 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 293969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 293971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 293973 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 293975 */     GIR_RootConstrainSelectedInstOperands,
     /* 293976 */     // GIR_Coverage, 5109,
     /* 293976 */     GIR_EraseRootFromParent_Done,
     /* 293977 */   // Label 5775: @293977
     /* 293977 */   GIM_Try, /*On fail goto*//*Label 5776*/ GIMT_Encode4(294006), // Rule ID 5116 //
     /* 293982 */     // MIs[0] Operand 1
     /* 293982 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 293987 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293991 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 293995 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 293995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 293998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294000 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294002 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294004 */     GIR_RootConstrainSelectedInstOperands,
     /* 294005 */     // GIR_Coverage, 5116,
     /* 294005 */     GIR_EraseRootFromParent_Done,
     /* 294006 */   // Label 5776: @294006
     /* 294006 */   GIM_Try, /*On fail goto*//*Label 5777*/ GIMT_Encode4(294035), // Rule ID 5123 //
     /* 294011 */     // MIs[0] Operand 1
     /* 294011 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294016 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294020 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294024 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294024 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i8),
     /* 294027 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294029 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294031 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294033 */     GIR_RootConstrainSelectedInstOperands,
     /* 294034 */     // GIR_Coverage, 5123,
     /* 294034 */     GIR_EraseRootFromParent_Done,
     /* 294035 */   // Label 5777: @294035
     /* 294035 */   GIM_Try, /*On fail goto*//*Label 5778*/ GIMT_Encode4(294064), // Rule ID 5130 //
     /* 294040 */     // MIs[0] Operand 1
     /* 294040 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294045 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294049 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294053 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294053 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i8),
     /* 294056 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294058 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294060 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294062 */     GIR_RootConstrainSelectedInstOperands,
     /* 294063 */     // GIR_Coverage, 5130,
     /* 294063 */     GIR_EraseRootFromParent_Done,
     /* 294064 */   // Label 5778: @294064
     /* 294064 */   GIM_Try, /*On fail goto*//*Label 5779*/ GIMT_Encode4(294093), // Rule ID 5137 //
     /* 294069 */     // MIs[0] Operand 1
     /* 294069 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 294074 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294078 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294082 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i8),
     /* 294085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294091 */     GIR_RootConstrainSelectedInstOperands,
     /* 294092 */     // GIR_Coverage, 5137,
     /* 294092 */     GIR_EraseRootFromParent_Done,
     /* 294093 */   // Label 5779: @294093
     /* 294093 */   GIM_Try, /*On fail goto*//*Label 5780*/ GIMT_Encode4(294122), // Rule ID 5144 //
     /* 294098 */     // MIs[0] Operand 1
     /* 294098 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 294103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 294111 */     // (setcc:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rm, V64:{ *:[v8i8] }:$Rn)
     /* 294111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i8),
     /* 294114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294116 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294118 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294120 */     GIR_RootConstrainSelectedInstOperands,
     /* 294121 */     // GIR_Coverage, 5144,
     /* 294121 */     GIR_EraseRootFromParent_Done,
     /* 294122 */   // Label 5780: @294122
     /* 294122 */   GIM_Reject,
     /* 294123 */ // Label 5750: @294123
     /* 294123 */ GIM_Reject,
     /* 294124 */ // Label 5611: @294124
     /* 294124 */ GIM_Try, /*On fail goto*//*Label 5781*/ GIMT_Encode4(295171),
     /* 294129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 294132 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 294135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294139 */   GIM_Try, /*On fail goto*//*Label 5782*/ GIMT_Encode4(294179), // Rule ID 753 //
     /* 294144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294147 */     // MIs[0] Operand 1
     /* 294147 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294152 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294156 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294162 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294168 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294170 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294177 */     GIR_RootConstrainSelectedInstOperands,
     /* 294178 */     // GIR_Coverage, 753,
     /* 294178 */     GIR_EraseRootFromParent_Done,
     /* 294179 */   // Label 5782: @294179
     /* 294179 */   GIM_Try, /*On fail goto*//*Label 5783*/ GIMT_Encode4(294219), // Rule ID 760 //
     /* 294184 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294187 */     // MIs[0] Operand 1
     /* 294187 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294196 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294202 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294208 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294210 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294217 */     GIR_RootConstrainSelectedInstOperands,
     /* 294218 */     // GIR_Coverage, 760,
     /* 294218 */     GIR_EraseRootFromParent_Done,
     /* 294219 */   // Label 5783: @294219
     /* 294219 */   GIM_Try, /*On fail goto*//*Label 5784*/ GIMT_Encode4(294256), // Rule ID 5189 //
     /* 294224 */     // MIs[0] Operand 1
     /* 294224 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294229 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294233 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294239 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294241 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294245 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294247 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294252 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294254 */     GIR_RootConstrainSelectedInstOperands,
     /* 294255 */     // GIR_Coverage, 5189,
     /* 294255 */     GIR_EraseRootFromParent_Done,
     /* 294256 */   // Label 5784: @294256
     /* 294256 */   GIM_Try, /*On fail goto*//*Label 5785*/ GIMT_Encode4(294293), // Rule ID 5196 //
     /* 294261 */     // MIs[0] Operand 1
     /* 294261 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294270 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294276 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294278 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294282 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294284 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294284 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294287 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294289 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294291 */     GIR_RootConstrainSelectedInstOperands,
     /* 294292 */     // GIR_Coverage, 5196,
     /* 294292 */     GIR_EraseRootFromParent_Done,
     /* 294293 */   // Label 5785: @294293
     /* 294293 */   GIM_Try, /*On fail goto*//*Label 5786*/ GIMT_Encode4(294330), // Rule ID 5203 //
     /* 294298 */     // MIs[0] Operand 1
     /* 294298 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294303 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294307 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294313 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294315 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294319 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294321 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294326 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294328 */     GIR_RootConstrainSelectedInstOperands,
     /* 294329 */     // GIR_Coverage, 5203,
     /* 294329 */     GIR_EraseRootFromParent_Done,
     /* 294330 */   // Label 5786: @294330
     /* 294330 */   GIM_Try, /*On fail goto*//*Label 5787*/ GIMT_Encode4(294367), // Rule ID 5210 //
     /* 294335 */     // MIs[0] Operand 1
     /* 294335 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294340 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294344 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294350 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294352 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294356 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294358 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294363 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294365 */     GIR_RootConstrainSelectedInstOperands,
     /* 294366 */     // GIR_Coverage, 5210,
     /* 294366 */     GIR_EraseRootFromParent_Done,
     /* 294367 */   // Label 5787: @294367
     /* 294367 */   GIM_Try, /*On fail goto*//*Label 5788*/ GIMT_Encode4(294404), // Rule ID 5217 //
     /* 294372 */     // MIs[0] Operand 1
     /* 294372 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294377 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 294381 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294387 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294389 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294393 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294395 */     // (setcc:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294395 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294398 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294400 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 294402 */     GIR_RootConstrainSelectedInstOperands,
     /* 294403 */     // GIR_Coverage, 5217,
     /* 294403 */     GIR_EraseRootFromParent_Done,
     /* 294404 */   // Label 5788: @294404
     /* 294404 */   GIM_Try, /*On fail goto*//*Label 5789*/ GIMT_Encode4(294444), // Rule ID 725 //
     /* 294409 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294412 */     // MIs[0] Operand 1
     /* 294412 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294417 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294425 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294431 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294435 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294442 */     GIR_RootConstrainSelectedInstOperands,
     /* 294443 */     // GIR_Coverage, 725,
     /* 294443 */     GIR_EraseRootFromParent_Done,
     /* 294444 */   // Label 5789: @294444
     /* 294444 */   GIM_Try, /*On fail goto*//*Label 5790*/ GIMT_Encode4(294484), // Rule ID 735 //
     /* 294449 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294452 */     // MIs[0] Operand 1
     /* 294452 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294457 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294465 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294471 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294475 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294482 */     GIR_RootConstrainSelectedInstOperands,
     /* 294483 */     // GIR_Coverage, 735,
     /* 294483 */     GIR_EraseRootFromParent_Done,
     /* 294484 */   // Label 5790: @294484
     /* 294484 */   GIM_Try, /*On fail goto*//*Label 5791*/ GIMT_Encode4(294524), // Rule ID 736 //
     /* 294489 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294492 */     // MIs[0] Operand 1
     /* 294492 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294497 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294505 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294511 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 294513 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294515 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllOnesV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294520 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294522 */     GIR_RootConstrainSelectedInstOperands,
     /* 294523 */     // GIR_Coverage, 736,
     /* 294523 */     GIR_EraseRootFromParent_Done,
     /* 294524 */   // Label 5791: @294524
     /* 294524 */   GIM_Try, /*On fail goto*//*Label 5792*/ GIMT_Encode4(294564), // Rule ID 746 //
     /* 294529 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294532 */     // MIs[0] Operand 1
     /* 294532 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294537 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294541 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294545 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294551 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294553 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294555 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294555 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294558 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294560 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294562 */     GIR_RootConstrainSelectedInstOperands,
     /* 294563 */     // GIR_Coverage, 746,
     /* 294563 */     GIR_EraseRootFromParent_Done,
     /* 294564 */   // Label 5792: @294564
     /* 294564 */   GIM_Try, /*On fail goto*//*Label 5793*/ GIMT_Encode4(294601), // Rule ID 5154 //
     /* 294569 */     // MIs[0] Operand 1
     /* 294569 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294578 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294582 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294588 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294590 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294592 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETEQ:{ *:[Other] })  =>  (CMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16rz),
     /* 294595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294597 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294599 */     GIR_RootConstrainSelectedInstOperands,
     /* 294600 */     // GIR_Coverage, 5154,
     /* 294600 */     GIR_EraseRootFromParent_Done,
     /* 294601 */   // Label 5793: @294601
     /* 294601 */   GIM_Try, /*On fail goto*//*Label 5794*/ GIMT_Encode4(294638), // Rule ID 5161 //
     /* 294606 */     // MIs[0] Operand 1
     /* 294606 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294611 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294619 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294625 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294627 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294629 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGT:{ *:[Other] })  =>  (CMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16rz),
     /* 294632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294634 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294636 */     GIR_RootConstrainSelectedInstOperands,
     /* 294637 */     // GIR_Coverage, 5161,
     /* 294637 */     GIR_EraseRootFromParent_Done,
     /* 294638 */   // Label 5794: @294638
     /* 294638 */   GIM_Try, /*On fail goto*//*Label 5795*/ GIMT_Encode4(294675), // Rule ID 5168 //
     /* 294643 */     // MIs[0] Operand 1
     /* 294643 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294648 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294656 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294662 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294664 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294666 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETGE:{ *:[Other] })  =>  (CMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294666 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16rz),
     /* 294669 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294673 */     GIR_RootConstrainSelectedInstOperands,
     /* 294674 */     // GIR_Coverage, 5168,
     /* 294674 */     GIR_EraseRootFromParent_Done,
     /* 294675 */   // Label 5795: @294675
     /* 294675 */   GIM_Try, /*On fail goto*//*Label 5796*/ GIMT_Encode4(294712), // Rule ID 5175 //
     /* 294680 */     // MIs[0] Operand 1
     /* 294680 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 294685 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294693 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294699 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294701 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294703 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLT:{ *:[Other] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 294706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294710 */     GIR_RootConstrainSelectedInstOperands,
     /* 294711 */     // GIR_Coverage, 5175,
     /* 294711 */     GIR_EraseRootFromParent_Done,
     /* 294712 */   // Label 5796: @294712
     /* 294712 */   GIM_Try, /*On fail goto*//*Label 5797*/ GIMT_Encode4(294749), // Rule ID 5182 //
     /* 294717 */     // MIs[0] Operand 1
     /* 294717 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 294722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 294730 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 294736 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 294738 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 294740 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, immAllZerosV:{ *:[v8i16] }, SETLE:{ *:[Other] })  =>  (CMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 294740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv8i16rz),
     /* 294743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294745 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294747 */     GIR_RootConstrainSelectedInstOperands,
     /* 294748 */     // GIR_Coverage, 5182,
     /* 294748 */     GIR_EraseRootFromParent_Done,
     /* 294749 */   // Label 5797: @294749
     /* 294749 */   GIM_Try, /*On fail goto*//*Label 5798*/ GIMT_Encode4(294781), // Rule ID 1124 //
     /* 294754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294757 */     // MIs[0] Operand 1
     /* 294757 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294770 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 294773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294775 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294779 */     GIR_RootConstrainSelectedInstOperands,
     /* 294780 */     // GIR_Coverage, 1124,
     /* 294780 */     GIR_EraseRootFromParent_Done,
     /* 294781 */   // Label 5798: @294781
     /* 294781 */   GIM_Try, /*On fail goto*//*Label 5799*/ GIMT_Encode4(294813), // Rule ID 1131 //
     /* 294786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294789 */     // MIs[0] Operand 1
     /* 294789 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294794 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294798 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294802 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294802 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 294805 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294807 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294809 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294811 */     GIR_RootConstrainSelectedInstOperands,
     /* 294812 */     // GIR_Coverage, 1131,
     /* 294812 */     GIR_EraseRootFromParent_Done,
     /* 294813 */   // Label 5799: @294813
     /* 294813 */   GIM_Try, /*On fail goto*//*Label 5800*/ GIMT_Encode4(294845), // Rule ID 1138 //
     /* 294818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294821 */     // MIs[0] Operand 1
     /* 294821 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294826 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294830 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294834 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 294837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294839 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294841 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294843 */     GIR_RootConstrainSelectedInstOperands,
     /* 294844 */     // GIR_Coverage, 1138,
     /* 294844 */     GIR_EraseRootFromParent_Done,
     /* 294845 */   // Label 5800: @294845
     /* 294845 */   GIM_Try, /*On fail goto*//*Label 5801*/ GIMT_Encode4(294877), // Rule ID 1145 //
     /* 294850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294853 */     // MIs[0] Operand 1
     /* 294853 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 294858 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294862 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294866 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 294869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294871 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294873 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294875 */     GIR_RootConstrainSelectedInstOperands,
     /* 294876 */     // GIR_Coverage, 1145,
     /* 294876 */     GIR_EraseRootFromParent_Done,
     /* 294877 */   // Label 5801: @294877
     /* 294877 */   GIM_Try, /*On fail goto*//*Label 5802*/ GIMT_Encode4(294909), // Rule ID 1152 //
     /* 294882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 294885 */     // MIs[0] Operand 1
     /* 294885 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 294890 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294894 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294898 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294898 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 294901 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294903 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294905 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294907 */     GIR_RootConstrainSelectedInstOperands,
     /* 294908 */     // GIR_Coverage, 1152,
     /* 294908 */     GIR_EraseRootFromParent_Done,
     /* 294909 */   // Label 5802: @294909
     /* 294909 */   GIM_Try, /*On fail goto*//*Label 5803*/ GIMT_Encode4(294938), // Rule ID 5091 //
     /* 294914 */     // MIs[0] Operand 1
     /* 294914 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 294919 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294923 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294927 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv8i16),
     /* 294930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294934 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294936 */     GIR_RootConstrainSelectedInstOperands,
     /* 294937 */     // GIR_Coverage, 5091,
     /* 294937 */     GIR_EraseRootFromParent_Done,
     /* 294938 */   // Label 5803: @294938
     /* 294938 */   GIM_Try, /*On fail goto*//*Label 5804*/ GIMT_Encode4(294967), // Rule ID 5098 //
     /* 294943 */     // MIs[0] Operand 1
     /* 294943 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 294948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294956 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 294959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294963 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294965 */     GIR_RootConstrainSelectedInstOperands,
     /* 294966 */     // GIR_Coverage, 5098,
     /* 294966 */     GIR_EraseRootFromParent_Done,
     /* 294967 */   // Label 5804: @294967
     /* 294967 */   GIM_Try, /*On fail goto*//*Label 5805*/ GIMT_Encode4(294996), // Rule ID 5105 //
     /* 294972 */     // MIs[0] Operand 1
     /* 294972 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 294977 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294981 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 294985 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 294985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 294988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 294990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 294992 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 294994 */     GIR_RootConstrainSelectedInstOperands,
     /* 294995 */     // GIR_Coverage, 5105,
     /* 294995 */     GIR_EraseRootFromParent_Done,
     /* 294996 */   // Label 5805: @294996
     /* 294996 */   GIM_Try, /*On fail goto*//*Label 5806*/ GIMT_Encode4(295025), // Rule ID 5112 //
     /* 295001 */     // MIs[0] Operand 1
     /* 295001 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295006 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295010 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295014 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295019 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295021 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295023 */     GIR_RootConstrainSelectedInstOperands,
     /* 295024 */     // GIR_Coverage, 5112,
     /* 295024 */     GIR_EraseRootFromParent_Done,
     /* 295025 */   // Label 5806: @295025
     /* 295025 */   GIM_Try, /*On fail goto*//*Label 5807*/ GIMT_Encode4(295054), // Rule ID 5119 //
     /* 295030 */     // MIs[0] Operand 1
     /* 295030 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295043 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 295043 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295046 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295048 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295052 */     GIR_RootConstrainSelectedInstOperands,
     /* 295053 */     // GIR_Coverage, 5119,
     /* 295053 */     GIR_EraseRootFromParent_Done,
     /* 295054 */   // Label 5807: @295054
     /* 295054 */   GIM_Try, /*On fail goto*//*Label 5808*/ GIMT_Encode4(295083), // Rule ID 5126 //
     /* 295059 */     // MIs[0] Operand 1
     /* 295059 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295064 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295068 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295072 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv8i16),
     /* 295075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295079 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295081 */     GIR_RootConstrainSelectedInstOperands,
     /* 295082 */     // GIR_Coverage, 5126,
     /* 295082 */     GIR_EraseRootFromParent_Done,
     /* 295083 */   // Label 5808: @295083
     /* 295083 */   GIM_Try, /*On fail goto*//*Label 5809*/ GIMT_Encode4(295112), // Rule ID 5133 //
     /* 295088 */     // MIs[0] Operand 1
     /* 295088 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295093 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295097 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295101 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv8i16),
     /* 295104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295110 */     GIR_RootConstrainSelectedInstOperands,
     /* 295111 */     // GIR_Coverage, 5133,
     /* 295111 */     GIR_EraseRootFromParent_Done,
     /* 295112 */   // Label 5809: @295112
     /* 295112 */   GIM_Try, /*On fail goto*//*Label 5810*/ GIMT_Encode4(295141), // Rule ID 5140 //
     /* 295117 */     // MIs[0] Operand 1
     /* 295117 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 295122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295130 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv8i16),
     /* 295133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295135 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295137 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295139 */     GIR_RootConstrainSelectedInstOperands,
     /* 295140 */     // GIR_Coverage, 5140,
     /* 295140 */     GIR_EraseRootFromParent_Done,
     /* 295141 */   // Label 5810: @295141
     /* 295141 */   GIM_Try, /*On fail goto*//*Label 5811*/ GIMT_Encode4(295170), // Rule ID 5147 //
     /* 295146 */     // MIs[0] Operand 1
     /* 295146 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 295151 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295155 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295159 */     // (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rm, V128:{ *:[v8i16] }:$Rn)
     /* 295159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv8i16),
     /* 295162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295164 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295166 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295168 */     GIR_RootConstrainSelectedInstOperands,
     /* 295169 */     // GIR_Coverage, 5147,
     /* 295169 */     GIR_EraseRootFromParent_Done,
     /* 295170 */   // Label 5811: @295170
     /* 295170 */   GIM_Reject,
     /* 295171 */ // Label 5781: @295171
     /* 295171 */ GIM_Reject,
     /* 295172 */ // Label 5612: @295172
     /* 295172 */ GIM_Try, /*On fail goto*//*Label 5812*/ GIMT_Encode4(296219),
     /* 295177 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 295180 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 295183 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295187 */   GIM_Try, /*On fail goto*//*Label 5813*/ GIMT_Encode4(295227), // Rule ID 751 //
     /* 295192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295195 */     // MIs[0] Operand 1
     /* 295195 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295204 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295210 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295212 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295216 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295218 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295223 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295225 */     GIR_RootConstrainSelectedInstOperands,
     /* 295226 */     // GIR_Coverage, 751,
     /* 295226 */     GIR_EraseRootFromParent_Done,
     /* 295227 */   // Label 5813: @295227
     /* 295227 */   GIM_Try, /*On fail goto*//*Label 5814*/ GIMT_Encode4(295267), // Rule ID 758 //
     /* 295232 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295235 */     // MIs[0] Operand 1
     /* 295235 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295244 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295250 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295252 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295256 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295258 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295263 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295265 */     GIR_RootConstrainSelectedInstOperands,
     /* 295266 */     // GIR_Coverage, 758,
     /* 295266 */     GIR_EraseRootFromParent_Done,
     /* 295267 */   // Label 5814: @295267
     /* 295267 */   GIM_Try, /*On fail goto*//*Label 5815*/ GIMT_Encode4(295304), // Rule ID 5187 //
     /* 295272 */     // MIs[0] Operand 1
     /* 295272 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295289 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295293 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295295 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295295 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295298 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295300 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295302 */     GIR_RootConstrainSelectedInstOperands,
     /* 295303 */     // GIR_Coverage, 5187,
     /* 295303 */     GIR_EraseRootFromParent_Done,
     /* 295304 */   // Label 5815: @295304
     /* 295304 */   GIM_Try, /*On fail goto*//*Label 5816*/ GIMT_Encode4(295341), // Rule ID 5194 //
     /* 295309 */     // MIs[0] Operand 1
     /* 295309 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295318 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295324 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295330 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295332 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295339 */     GIR_RootConstrainSelectedInstOperands,
     /* 295340 */     // GIR_Coverage, 5194,
     /* 295340 */     GIR_EraseRootFromParent_Done,
     /* 295341 */   // Label 5816: @295341
     /* 295341 */   GIM_Try, /*On fail goto*//*Label 5817*/ GIMT_Encode4(295378), // Rule ID 5201 //
     /* 295346 */     // MIs[0] Operand 1
     /* 295346 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295355 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295361 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295363 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295367 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295369 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETGE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295369 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295372 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295374 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295376 */     GIR_RootConstrainSelectedInstOperands,
     /* 295377 */     // GIR_Coverage, 5201,
     /* 295377 */     GIR_EraseRootFromParent_Done,
     /* 295378 */   // Label 5817: @295378
     /* 295378 */   GIM_Try, /*On fail goto*//*Label 5818*/ GIMT_Encode4(295415), // Rule ID 5208 //
     /* 295383 */     // MIs[0] Operand 1
     /* 295383 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295392 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295398 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295406 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295411 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295413 */     GIR_RootConstrainSelectedInstOperands,
     /* 295414 */     // GIR_Coverage, 5208,
     /* 295414 */     GIR_EraseRootFromParent_Done,
     /* 295415 */   // Label 5818: @295415
     /* 295415 */   GIM_Try, /*On fail goto*//*Label 5819*/ GIMT_Encode4(295452), // Rule ID 5215 //
     /* 295420 */     // MIs[0] Operand 1
     /* 295420 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295425 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 295429 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295435 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295443 */     // (setcc:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$Rn, SETLE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295448 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rn
     /* 295450 */     GIR_RootConstrainSelectedInstOperands,
     /* 295451 */     // GIR_Coverage, 5215,
     /* 295451 */     GIR_EraseRootFromParent_Done,
     /* 295452 */   // Label 5819: @295452
     /* 295452 */   GIM_Try, /*On fail goto*//*Label 5820*/ GIMT_Encode4(295492), // Rule ID 723 //
     /* 295457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295460 */     // MIs[0] Operand 1
     /* 295460 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295473 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295479 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295483 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295488 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295490 */     GIR_RootConstrainSelectedInstOperands,
     /* 295491 */     // GIR_Coverage, 723,
     /* 295491 */     GIR_EraseRootFromParent_Done,
     /* 295492 */   // Label 5820: @295492
     /* 295492 */   GIM_Try, /*On fail goto*//*Label 5821*/ GIMT_Encode4(295532), // Rule ID 731 //
     /* 295497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295500 */     // MIs[0] Operand 1
     /* 295500 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295505 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295521 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295523 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295530 */     GIR_RootConstrainSelectedInstOperands,
     /* 295531 */     // GIR_Coverage, 731,
     /* 295531 */     GIR_EraseRootFromParent_Done,
     /* 295532 */   // Label 5821: @295532
     /* 295532 */   GIM_Try, /*On fail goto*//*Label 5822*/ GIMT_Encode4(295572), // Rule ID 732 //
     /* 295537 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295540 */     // MIs[0] Operand 1
     /* 295540 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295545 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295553 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295559 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/1,
     /* 295561 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295563 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllOnesV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295568 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295570 */     GIR_RootConstrainSelectedInstOperands,
     /* 295571 */     // GIR_Coverage, 732,
     /* 295571 */     GIR_EraseRootFromParent_Done,
     /* 295572 */   // Label 5822: @295572
     /* 295572 */   GIM_Try, /*On fail goto*//*Label 5823*/ GIMT_Encode4(295612), // Rule ID 744 //
     /* 295577 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295580 */     // MIs[0] Operand 1
     /* 295580 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295585 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295593 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295599 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295601 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295603 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295608 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295610 */     GIR_RootConstrainSelectedInstOperands,
     /* 295611 */     // GIR_Coverage, 744,
     /* 295611 */     GIR_EraseRootFromParent_Done,
     /* 295612 */   // Label 5823: @295612
     /* 295612 */   GIM_Try, /*On fail goto*//*Label 5824*/ GIMT_Encode4(295649), // Rule ID 5152 //
     /* 295617 */     // MIs[0] Operand 1
     /* 295617 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295622 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295630 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295636 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295638 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295640 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETEQ:{ *:[Other] })  =>  (CMEQv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295640 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8rz),
     /* 295643 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295645 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295647 */     GIR_RootConstrainSelectedInstOperands,
     /* 295648 */     // GIR_Coverage, 5152,
     /* 295648 */     GIR_EraseRootFromParent_Done,
     /* 295649 */   // Label 5824: @295649
     /* 295649 */   GIM_Try, /*On fail goto*//*Label 5825*/ GIMT_Encode4(295686), // Rule ID 5159 //
     /* 295654 */     // MIs[0] Operand 1
     /* 295654 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295667 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295673 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295677 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGT:{ *:[Other] })  =>  (CMGTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295677 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8rz),
     /* 295680 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295682 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295684 */     GIR_RootConstrainSelectedInstOperands,
     /* 295685 */     // GIR_Coverage, 5159,
     /* 295685 */     GIR_EraseRootFromParent_Done,
     /* 295686 */   // Label 5825: @295686
     /* 295686 */   GIM_Try, /*On fail goto*//*Label 5826*/ GIMT_Encode4(295723), // Rule ID 5166 //
     /* 295691 */     // MIs[0] Operand 1
     /* 295691 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295696 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295700 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295704 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295710 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295714 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETGE:{ *:[Other] })  =>  (CMGEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295714 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8rz),
     /* 295717 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295719 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295721 */     GIR_RootConstrainSelectedInstOperands,
     /* 295722 */     // GIR_Coverage, 5166,
     /* 295722 */     GIR_EraseRootFromParent_Done,
     /* 295723 */   // Label 5826: @295723
     /* 295723 */   GIM_Try, /*On fail goto*//*Label 5827*/ GIMT_Encode4(295760), // Rule ID 5173 //
     /* 295728 */     // MIs[0] Operand 1
     /* 295728 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 295733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295751 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLT:{ *:[Other] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 295754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295756 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295758 */     GIR_RootConstrainSelectedInstOperands,
     /* 295759 */     // GIR_Coverage, 5173,
     /* 295759 */     GIR_EraseRootFromParent_Done,
     /* 295760 */   // Label 5827: @295760
     /* 295760 */   GIM_Try, /*On fail goto*//*Label 5828*/ GIMT_Encode4(295797), // Rule ID 5180 //
     /* 295765 */     // MIs[0] Operand 1
     /* 295765 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 295770 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295774 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 295778 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 295784 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 295786 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 295788 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, immAllZerosV:{ *:[v16i8] }, SETLE:{ *:[Other] })  =>  (CMLEv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 295788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLEv16i8rz),
     /* 295791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295793 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295795 */     GIR_RootConstrainSelectedInstOperands,
     /* 295796 */     // GIR_Coverage, 5180,
     /* 295796 */     GIR_EraseRootFromParent_Done,
     /* 295797 */   // Label 5828: @295797
     /* 295797 */   GIM_Try, /*On fail goto*//*Label 5829*/ GIMT_Encode4(295829), // Rule ID 1122 //
     /* 295802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295805 */     // MIs[0] Operand 1
     /* 295805 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295818 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 295821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295823 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295825 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295827 */     GIR_RootConstrainSelectedInstOperands,
     /* 295828 */     // GIR_Coverage, 1122,
     /* 295828 */     GIR_EraseRootFromParent_Done,
     /* 295829 */   // Label 5829: @295829
     /* 295829 */   GIM_Try, /*On fail goto*//*Label 5830*/ GIMT_Encode4(295861), // Rule ID 1129 //
     /* 295834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295837 */     // MIs[0] Operand 1
     /* 295837 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 295842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295846 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295850 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 295853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295855 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295859 */     GIR_RootConstrainSelectedInstOperands,
     /* 295860 */     // GIR_Coverage, 1129,
     /* 295860 */     GIR_EraseRootFromParent_Done,
     /* 295861 */   // Label 5830: @295861
     /* 295861 */   GIM_Try, /*On fail goto*//*Label 5831*/ GIMT_Encode4(295893), // Rule ID 1136 //
     /* 295866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295869 */     // MIs[0] Operand 1
     /* 295869 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295874 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295878 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295882 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295882 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 295885 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295887 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295891 */     GIR_RootConstrainSelectedInstOperands,
     /* 295892 */     // GIR_Coverage, 1136,
     /* 295892 */     GIR_EraseRootFromParent_Done,
     /* 295893 */   // Label 5831: @295893
     /* 295893 */   GIM_Try, /*On fail goto*//*Label 5832*/ GIMT_Encode4(295925), // Rule ID 1143 //
     /* 295898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295901 */     // MIs[0] Operand 1
     /* 295901 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 295906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295914 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295914 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 295917 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295923 */     GIR_RootConstrainSelectedInstOperands,
     /* 295924 */     // GIR_Coverage, 1143,
     /* 295924 */     GIR_EraseRootFromParent_Done,
     /* 295925 */   // Label 5832: @295925
     /* 295925 */   GIM_Try, /*On fail goto*//*Label 5833*/ GIMT_Encode4(295957), // Rule ID 1150 //
     /* 295930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 295933 */     // MIs[0] Operand 1
     /* 295933 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 295938 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295942 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295946 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295946 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 295949 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295953 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295955 */     GIR_RootConstrainSelectedInstOperands,
     /* 295956 */     // GIR_Coverage, 1150,
     /* 295956 */     GIR_EraseRootFromParent_Done,
     /* 295957 */   // Label 5833: @295957
     /* 295957 */   GIM_Try, /*On fail goto*//*Label 5834*/ GIMT_Encode4(295986), // Rule ID 5089 //
     /* 295962 */     // MIs[0] Operand 1
     /* 295962 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_EQ),
     /* 295967 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295971 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 295975 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETEQ:{ *:[Other] })  =>  (CMEQv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 295975 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMEQv16i8),
     /* 295978 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 295980 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 295982 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 295984 */     GIR_RootConstrainSelectedInstOperands,
     /* 295985 */     // GIR_Coverage, 5089,
     /* 295985 */     GIR_EraseRootFromParent_Done,
     /* 295986 */   // Label 5834: @295986
     /* 295986 */   GIM_Try, /*On fail goto*//*Label 5835*/ GIMT_Encode4(296015), // Rule ID 5096 //
     /* 295991 */     // MIs[0] Operand 1
     /* 295991 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGT),
     /* 295996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296000 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296004 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296009 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296011 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296013 */     GIR_RootConstrainSelectedInstOperands,
     /* 296014 */     // GIR_Coverage, 5096,
     /* 296014 */     GIR_EraseRootFromParent_Done,
     /* 296015 */   // Label 5835: @296015
     /* 296015 */   GIM_Try, /*On fail goto*//*Label 5836*/ GIMT_Encode4(296044), // Rule ID 5103 //
     /* 296020 */     // MIs[0] Operand 1
     /* 296020 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SGE),
     /* 296025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296029 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296033 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETGE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296033 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296036 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296038 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296040 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296042 */     GIR_RootConstrainSelectedInstOperands,
     /* 296043 */     // GIR_Coverage, 5103,
     /* 296043 */     GIR_EraseRootFromParent_Done,
     /* 296044 */   // Label 5836: @296044
     /* 296044 */   GIM_Try, /*On fail goto*//*Label 5837*/ GIMT_Encode4(296073), // Rule ID 5110 //
     /* 296049 */     // MIs[0] Operand 1
     /* 296049 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGT),
     /* 296054 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296058 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296062 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296069 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296071 */     GIR_RootConstrainSelectedInstOperands,
     /* 296072 */     // GIR_Coverage, 5110,
     /* 296072 */     GIR_EraseRootFromParent_Done,
     /* 296073 */   // Label 5837: @296073
     /* 296073 */   GIM_Try, /*On fail goto*//*Label 5838*/ GIMT_Encode4(296102), // Rule ID 5117 //
     /* 296078 */     // MIs[0] Operand 1
     /* 296078 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_UGE),
     /* 296083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296091 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETUGE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 296091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296096 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296098 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296100 */     GIR_RootConstrainSelectedInstOperands,
     /* 296101 */     // GIR_Coverage, 5117,
     /* 296101 */     GIR_EraseRootFromParent_Done,
     /* 296102 */   // Label 5838: @296102
     /* 296102 */   GIM_Try, /*On fail goto*//*Label 5839*/ GIMT_Encode4(296131), // Rule ID 5124 //
     /* 296107 */     // MIs[0] Operand 1
     /* 296107 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLT),
     /* 296112 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296116 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296120 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLT:{ *:[Other] })  =>  (CMGTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296120 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGTv16i8),
     /* 296123 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296125 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296127 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296129 */     GIR_RootConstrainSelectedInstOperands,
     /* 296130 */     // GIR_Coverage, 5124,
     /* 296130 */     GIR_EraseRootFromParent_Done,
     /* 296131 */   // Label 5839: @296131
     /* 296131 */   GIM_Try, /*On fail goto*//*Label 5840*/ GIMT_Encode4(296160), // Rule ID 5131 //
     /* 296136 */     // MIs[0] Operand 1
     /* 296136 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_SLE),
     /* 296141 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296149 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETLE:{ *:[Other] })  =>  (CMGEv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMGEv16i8),
     /* 296152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296154 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296158 */     GIR_RootConstrainSelectedInstOperands,
     /* 296159 */     // GIR_Coverage, 5131,
     /* 296159 */     GIR_EraseRootFromParent_Done,
     /* 296160 */   // Label 5840: @296160
     /* 296160 */   GIM_Try, /*On fail goto*//*Label 5841*/ GIMT_Encode4(296189), // Rule ID 5138 //
     /* 296165 */     // MIs[0] Operand 1
     /* 296165 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULT),
     /* 296170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296178 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULT:{ *:[Other] })  =>  (CMHIv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296178 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHIv16i8),
     /* 296181 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296183 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296185 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296187 */     GIR_RootConstrainSelectedInstOperands,
     /* 296188 */     // GIR_Coverage, 5138,
     /* 296188 */     GIR_EraseRootFromParent_Done,
     /* 296189 */   // Label 5841: @296189
     /* 296189 */   GIM_Try, /*On fail goto*//*Label 5842*/ GIMT_Encode4(296218), // Rule ID 5145 //
     /* 296194 */     // MIs[0] Operand 1
     /* 296194 */     GIM_CheckCmpPredicate, /*MI*/0, /*Op*/1, /*Predicate*/GIMT_Encode2(CmpInst::ICMP_ULE),
     /* 296199 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 296207 */     // (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, SETULE:{ *:[Other] })  =>  (CMHSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rm, V128:{ *:[v16i8] }:$Rn)
     /* 296207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMHSv16i8),
     /* 296210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 296212 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rm
     /* 296214 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 296216 */     GIR_RootConstrainSelectedInstOperands,
     /* 296217 */     // GIR_Coverage, 5145,
     /* 296217 */     GIR_EraseRootFromParent_Done,
     /* 296218 */   // Label 5842: @296218
     /* 296218 */   GIM_Reject,
     /* 296219 */ // Label 5812: @296219
     /* 296219 */ GIM_Reject,
     /* 296220 */ // Label 5613: @296220
     /* 296220 */ GIM_Reject,
     /* 296221 */ // Label 52: @296221
     /* 296221 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(12), GIMT_Encode2(24), /*)*//*default:*//*Label 5855*/ GIMT_Encode4(297265),
     /* 296232 */ /*GILLT_nxv1s1*//*Label 5843*/ GIMT_Encode4(296280),
     /* 296236 */ /*GILLT_nxv2s1*//*Label 5844*/ GIMT_Encode4(296309),
     /* 296240 */ /*GILLT_nxv2s16*//*Label 5845*/ GIMT_Encode4(296338),
     /* 296244 */ /*GILLT_nxv2s32*//*Label 5846*/ GIMT_Encode4(296423),
     /* 296248 */ /*GILLT_nxv2s64*//*Label 5847*/ GIMT_Encode4(296508),
     /* 296252 */ /*GILLT_nxv4s1*//*Label 5848*/ GIMT_Encode4(296674),
     /* 296256 */ /*GILLT_nxv4s16*//*Label 5849*/ GIMT_Encode4(296703),
     /* 296260 */ /*GILLT_nxv4s32*//*Label 5850*/ GIMT_Encode4(296788),
     /* 296264 */ /*GILLT_nxv8s1*//*Label 5851*/ GIMT_Encode4(296954),
     /* 296268 */ /*GILLT_nxv8s16*//*Label 5852*/ GIMT_Encode4(296983),
     /* 296272 */ /*GILLT_nxv16s1*//*Label 5853*/ GIMT_Encode4(297149),
     /* 296276 */ /*GILLT_nxv16s8*//*Label 5854*/ GIMT_Encode4(297178),
     /* 296280 */ // Label 5843: @296280
     /* 296280 */ GIM_Try, /*On fail goto*//*Label 5856*/ GIMT_Encode4(296308), // Rule ID 8499 //
     /* 296285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv1s1,
     /* 296291 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv1s1,
     /* 296294 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv1s1,
     /* 296297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296301 */   // (vselect:{ *:[nxv1i1] } nxv1i1:{ *:[nxv1i1] }:$Op1, nxv1i1:{ *:[nxv1i1] }:$Op2, nxv1i1:{ *:[nxv1i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv1i1] } ?:{ *:[nxv1i1] }:$Op1, ?:{ *:[nxv1i1] }:$Op2, ?:{ *:[nxv1i1] }:$Op3)
     /* 296301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296306 */   GIR_RootConstrainSelectedInstOperands,
     /* 296307 */   // GIR_Coverage, 8499,
     /* 296307 */   GIR_Done,
     /* 296308 */ // Label 5856: @296308
     /* 296308 */ GIM_Reject,
     /* 296309 */ // Label 5844: @296309
     /* 296309 */ GIM_Try, /*On fail goto*//*Label 5857*/ GIMT_Encode4(296337), // Rule ID 8498 //
     /* 296314 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296317 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296320 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 296323 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s1,
     /* 296326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296330 */   // (vselect:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2, nxv2i1:{ *:[nxv2i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2, ?:{ *:[nxv2i1] }:$Op3)
     /* 296330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296335 */   GIR_RootConstrainSelectedInstOperands,
     /* 296336 */   // GIR_Coverage, 8498,
     /* 296336 */   GIR_Done,
     /* 296337 */ // Label 5857: @296337
     /* 296337 */ GIM_Reject,
     /* 296338 */ // Label 5845: @296338
     /* 296338 */ GIM_Try, /*On fail goto*//*Label 5858*/ GIMT_Encode4(296422),
     /* 296343 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296346 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 296349 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s16,
     /* 296352 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296356 */   GIM_Try, /*On fail goto*//*Label 5859*/ GIMT_Encode4(296406), // Rule ID 3157 //
     /* 296361 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296364 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296368 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296372 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296376 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296380 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296384 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296388 */     // MIs[2] Operand 1
     /* 296388 */     // No operand predicates
     /* 296388 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296390 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv2f16:{ *:[nxv2f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296390 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296393 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296395 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296397 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296399 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296404 */     GIR_RootConstrainSelectedInstOperands,
     /* 296405 */     // GIR_Coverage, 3157,
     /* 296405 */     GIR_EraseRootFromParent_Done,
     /* 296406 */   // Label 5859: @296406
     /* 296406 */   GIM_Try, /*On fail goto*//*Label 5860*/ GIMT_Encode4(296421), // Rule ID 2737 //
     /* 296411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296414 */     // (vselect:{ *:[nxv2f16] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2, nxv2f16:{ *:[nxv2f16] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f16] }:$Op2, ?:{ *:[nxv2f16] }:$Op3)
     /* 296414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296419 */     GIR_RootConstrainSelectedInstOperands,
     /* 296420 */     // GIR_Coverage, 2737,
     /* 296420 */     GIR_Done,
     /* 296421 */   // Label 5860: @296421
     /* 296421 */   GIM_Reject,
     /* 296422 */ // Label 5858: @296422
     /* 296422 */ GIM_Reject,
     /* 296423 */ // Label 5846: @296423
     /* 296423 */ GIM_Try, /*On fail goto*//*Label 5861*/ GIMT_Encode4(296507),
     /* 296428 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296431 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 296434 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s32,
     /* 296437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296441 */   GIM_Try, /*On fail goto*//*Label 5862*/ GIMT_Encode4(296491), // Rule ID 3159 //
     /* 296446 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296461 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296465 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296469 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296473 */     // MIs[2] Operand 1
     /* 296473 */     // No operand predicates
     /* 296473 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296475 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv2f32:{ *:[nxv2f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296480 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296482 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296484 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296489 */     GIR_RootConstrainSelectedInstOperands,
     /* 296490 */     // GIR_Coverage, 3159,
     /* 296490 */     GIR_EraseRootFromParent_Done,
     /* 296491 */   // Label 5862: @296491
     /* 296491 */   GIM_Try, /*On fail goto*//*Label 5863*/ GIMT_Encode4(296506), // Rule ID 2738 //
     /* 296496 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296499 */     // (vselect:{ *:[nxv2f32] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2, nxv2f32:{ *:[nxv2f32] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f32] }:$Op2, ?:{ *:[nxv2f32] }:$Op3)
     /* 296499 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296504 */     GIR_RootConstrainSelectedInstOperands,
     /* 296505 */     // GIR_Coverage, 2738,
     /* 296505 */     GIR_Done,
     /* 296506 */   // Label 5863: @296506
     /* 296506 */   GIM_Reject,
     /* 296507 */ // Label 5861: @296507
     /* 296507 */ GIM_Reject,
     /* 296508 */ // Label 5847: @296508
     /* 296508 */ GIM_Try, /*On fail goto*//*Label 5864*/ GIMT_Encode4(296673),
     /* 296513 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 296516 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296519 */   GIM_Try, /*On fail goto*//*Label 5865*/ GIMT_Encode4(296576), // Rule ID 3160 //
     /* 296524 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296527 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296530 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296542 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 296546 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296550 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296554 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 296558 */     // MIs[2] Operand 1
     /* 296558 */     // No operand predicates
     /* 296558 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296560 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$pg, (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8), nxv2f64:{ *:[nxv2f64] }:$zd)  =>  (FCPY_ZPmI_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$zd, ?:{ *:[nxv2i1] }:$pg, (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 296560 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_D),
     /* 296563 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296565 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296567 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296569 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 296574 */     GIR_RootConstrainSelectedInstOperands,
     /* 296575 */     // GIR_Coverage, 3160,
     /* 296575 */     GIR_EraseRootFromParent_Done,
     /* 296576 */   // Label 5865: @296576
     /* 296576 */   GIM_Try, /*On fail goto*//*Label 5866*/ GIMT_Encode4(296628), // Rule ID 7545 //
     /* 296581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296584 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 296600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 296604 */     // MIs[0] Op2
     /* 296604 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 296609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296611 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, (sub:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op2), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SUBR_ZPmZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_D),
     /* 296614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 296616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 296618 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 296622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 296626 */     GIR_RootConstrainSelectedInstOperands,
     /* 296627 */     // GIR_Coverage, 7545,
     /* 296627 */     GIR_EraseRootFromParent_Done,
     /* 296628 */   // Label 5866: @296628
     /* 296628 */   GIM_Try, /*On fail goto*//*Label 5867*/ GIMT_Encode4(296650), // Rule ID 2733 //
     /* 296633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296636 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296639 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296643 */     // (vselect:{ *:[nxv2i64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2, nxv2i64:{ *:[nxv2i64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 296643 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296648 */     GIR_RootConstrainSelectedInstOperands,
     /* 296649 */     // GIR_Coverage, 2733,
     /* 296649 */     GIR_Done,
     /* 296650 */   // Label 5867: @296650
     /* 296650 */   GIM_Try, /*On fail goto*//*Label 5868*/ GIMT_Encode4(296672), // Rule ID 2739 //
     /* 296655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296658 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 296661 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296665 */     // (vselect:{ *:[nxv2f64] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2, nxv2f64:{ *:[nxv2f64] }:$Op3)  =>  (SEL_ZPZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2f64] }:$Op2, ?:{ *:[nxv2f64] }:$Op3)
     /* 296665 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_D),
     /* 296670 */     GIR_RootConstrainSelectedInstOperands,
     /* 296671 */     // GIR_Coverage, 2739,
     /* 296671 */     GIR_Done,
     /* 296672 */   // Label 5868: @296672
     /* 296672 */   GIM_Reject,
     /* 296673 */ // Label 5864: @296673
     /* 296673 */ GIM_Reject,
     /* 296674 */ // Label 5848: @296674
     /* 296674 */ GIM_Try, /*On fail goto*//*Label 5869*/ GIMT_Encode4(296702), // Rule ID 8497 //
     /* 296679 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296685 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 296688 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s1,
     /* 296691 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296695 */   // (vselect:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2, nxv4i1:{ *:[nxv4i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2, ?:{ *:[nxv4i1] }:$Op3)
     /* 296695 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296700 */   GIR_RootConstrainSelectedInstOperands,
     /* 296701 */   // GIR_Coverage, 8497,
     /* 296701 */   GIR_Done,
     /* 296702 */ // Label 5869: @296702
     /* 296702 */ GIM_Reject,
     /* 296703 */ // Label 5849: @296703
     /* 296703 */ GIM_Try, /*On fail goto*//*Label 5870*/ GIMT_Encode4(296787),
     /* 296708 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296711 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 296714 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s16,
     /* 296717 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296721 */   GIM_Try, /*On fail goto*//*Label 5871*/ GIMT_Encode4(296771), // Rule ID 3156 //
     /* 296726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296729 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296733 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296737 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 296741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296749 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 296753 */     // MIs[2] Operand 1
     /* 296753 */     // No operand predicates
     /* 296753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296755 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv4f16:{ *:[nxv4f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 296755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 296758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296760 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296762 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296764 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 296769 */     GIR_RootConstrainSelectedInstOperands,
     /* 296770 */     // GIR_Coverage, 3156,
     /* 296770 */     GIR_EraseRootFromParent_Done,
     /* 296771 */   // Label 5871: @296771
     /* 296771 */   GIM_Try, /*On fail goto*//*Label 5872*/ GIMT_Encode4(296786), // Rule ID 2735 //
     /* 296776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296779 */     // (vselect:{ *:[nxv4f16] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2, nxv4f16:{ *:[nxv4f16] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f16] }:$Op2, ?:{ *:[nxv4f16] }:$Op3)
     /* 296779 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 296784 */     GIR_RootConstrainSelectedInstOperands,
     /* 296785 */     // GIR_Coverage, 2735,
     /* 296785 */     GIR_Done,
     /* 296786 */   // Label 5872: @296786
     /* 296786 */   GIM_Reject,
     /* 296787 */ // Label 5870: @296787
     /* 296787 */ GIM_Reject,
     /* 296788 */ // Label 5850: @296788
     /* 296788 */ GIM_Try, /*On fail goto*//*Label 5873*/ GIMT_Encode4(296953),
     /* 296793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 296796 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296799 */   GIM_Try, /*On fail goto*//*Label 5874*/ GIMT_Encode4(296856), // Rule ID 3158 //
     /* 296804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296807 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 296810 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296814 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296818 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 296822 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 296826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 296830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 296834 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 296838 */     // MIs[2] Operand 1
     /* 296838 */     // No operand predicates
     /* 296838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 296840 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$pg, (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8), nxv4f32:{ *:[nxv4f32] }:$zd)  =>  (FCPY_ZPmI_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$zd, ?:{ *:[nxv4i1] }:$pg, (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 296840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_S),
     /* 296843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 296845 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 296847 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 296849 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 296854 */     GIR_RootConstrainSelectedInstOperands,
     /* 296855 */     // GIR_Coverage, 3158,
     /* 296855 */     GIR_EraseRootFromParent_Done,
     /* 296856 */   // Label 5874: @296856
     /* 296856 */   GIM_Try, /*On fail goto*//*Label 5875*/ GIMT_Encode4(296908), // Rule ID 7543 //
     /* 296861 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296864 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296868 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 296872 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 296876 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 296880 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 296884 */     // MIs[0] Op2
     /* 296884 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 296889 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 296891 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, (sub:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op2), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SUBR_ZPmZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 296891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_S),
     /* 296894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 296896 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 296898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 296902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 296906 */     GIR_RootConstrainSelectedInstOperands,
     /* 296907 */     // GIR_Coverage, 7543,
     /* 296907 */     GIR_EraseRootFromParent_Done,
     /* 296908 */   // Label 5875: @296908
     /* 296908 */   GIM_Try, /*On fail goto*//*Label 5876*/ GIMT_Encode4(296930), // Rule ID 2732 //
     /* 296913 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296916 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 296919 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296923 */     // (vselect:{ *:[nxv4i32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2, nxv4i32:{ *:[nxv4i32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 296923 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 296928 */     GIR_RootConstrainSelectedInstOperands,
     /* 296929 */     // GIR_Coverage, 2732,
     /* 296929 */     GIR_Done,
     /* 296930 */   // Label 5876: @296930
     /* 296930 */   GIM_Try, /*On fail goto*//*Label 5877*/ GIMT_Encode4(296952), // Rule ID 2736 //
     /* 296935 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 296941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 296945 */     // (vselect:{ *:[nxv4f32] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2, nxv4f32:{ *:[nxv4f32] }:$Op3)  =>  (SEL_ZPZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4f32] }:$Op2, ?:{ *:[nxv4f32] }:$Op3)
     /* 296945 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_S),
     /* 296950 */     GIR_RootConstrainSelectedInstOperands,
     /* 296951 */     // GIR_Coverage, 2736,
     /* 296951 */     GIR_Done,
     /* 296952 */   // Label 5877: @296952
     /* 296952 */   GIM_Reject,
     /* 296953 */ // Label 5873: @296953
     /* 296953 */ GIM_Reject,
     /* 296954 */ // Label 5851: @296954
     /* 296954 */ GIM_Try, /*On fail goto*//*Label 5878*/ GIMT_Encode4(296982), // Rule ID 8496 //
     /* 296959 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 296962 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 296965 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 296968 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s1,
     /* 296971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 296975 */   // (vselect:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2, nxv8i1:{ *:[nxv8i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2, ?:{ *:[nxv8i1] }:$Op3)
     /* 296975 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 296980 */   GIR_RootConstrainSelectedInstOperands,
     /* 296981 */   // GIR_Coverage, 8496,
     /* 296981 */   GIR_Done,
     /* 296982 */ // Label 5878: @296982
     /* 296982 */ GIM_Reject,
     /* 296983 */ // Label 5852: @296983
     /* 296983 */ GIM_Try, /*On fail goto*//*Label 5879*/ GIMT_Encode4(297148),
     /* 296988 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 296991 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 296994 */   GIM_Try, /*On fail goto*//*Label 5880*/ GIMT_Encode4(297051), // Rule ID 3155 //
     /* 296999 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297002 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297005 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297009 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297013 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SPLAT_VECTOR),
     /* 297017 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 297021 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 297025 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 297029 */     GIM_CheckAPFloatImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 297033 */     // MIs[2] Operand 1
     /* 297033 */     // No operand predicates
     /* 297033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 297035 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$pg, (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8), nxv8f16:{ *:[nxv8f16] }:$zd)  =>  (FCPY_ZPmI_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$zd, ?:{ *:[nxv8i1] }:$pg, (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 297035 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCPY_ZPmI_H),
     /* 297038 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 297040 */     GIR_RootToRootCopy, /*OpIdx*/3, // zd
     /* 297042 */     GIR_RootToRootCopy, /*OpIdx*/1, // pg
     /* 297044 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/2, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 297049 */     GIR_RootConstrainSelectedInstOperands,
     /* 297050 */     // GIR_Coverage, 3155,
     /* 297050 */     GIR_EraseRootFromParent_Done,
     /* 297051 */   // Label 5880: @297051
     /* 297051 */   GIM_Try, /*On fail goto*//*Label 5881*/ GIMT_Encode4(297103), // Rule ID 7541 //
     /* 297056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297059 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 297075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 297079 */     // MIs[0] Op2
     /* 297079 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297084 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297086 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, (sub:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op2), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SUBR_ZPmZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_H),
     /* 297089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297091 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297101 */     GIR_RootConstrainSelectedInstOperands,
     /* 297102 */     // GIR_Coverage, 7541,
     /* 297102 */     GIR_EraseRootFromParent_Done,
     /* 297103 */   // Label 5881: @297103
     /* 297103 */   GIM_Try, /*On fail goto*//*Label 5882*/ GIMT_Encode4(297125), // Rule ID 2731 //
     /* 297108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297111 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297114 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297118 */     // (vselect:{ *:[nxv8i16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 297118 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297123 */     GIR_RootConstrainSelectedInstOperands,
     /* 297124 */     // GIR_Coverage, 2731,
     /* 297124 */     GIR_Done,
     /* 297125 */   // Label 5882: @297125
     /* 297125 */   GIM_Try, /*On fail goto*//*Label 5883*/ GIMT_Encode4(297147), // Rule ID 2734 //
     /* 297130 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297133 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 297136 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297140 */     // (vselect:{ *:[nxv8f16] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2, nxv8f16:{ *:[nxv8f16] }:$Op3)  =>  (SEL_ZPZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8f16] }:$Op2, ?:{ *:[nxv8f16] }:$Op3)
     /* 297140 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_H),
     /* 297145 */     GIR_RootConstrainSelectedInstOperands,
     /* 297146 */     // GIR_Coverage, 2734,
     /* 297146 */     GIR_Done,
     /* 297147 */   // Label 5883: @297147
     /* 297147 */   GIM_Reject,
     /* 297148 */ // Label 5879: @297148
     /* 297148 */ GIM_Reject,
     /* 297149 */ // Label 5853: @297149
     /* 297149 */ GIM_Try, /*On fail goto*//*Label 5884*/ GIMT_Encode4(297177), // Rule ID 8495 //
     /* 297154 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297157 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297160 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 297163 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s1,
     /* 297166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRorPNRRegClassID),
     /* 297170 */   // (vselect:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i1:{ *:[nxv16i1] }:$Op2, nxv16i1:{ *:[nxv16i1] }:$Op3)  =>  (SEL_PPPP:{ *:[nxv16i1] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i1] }:$Op2, ?:{ *:[nxv16i1] }:$Op3)
     /* 297170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_PPPP),
     /* 297175 */   GIR_RootConstrainSelectedInstOperands,
     /* 297176 */   // GIR_Coverage, 8495,
     /* 297176 */   GIR_Done,
     /* 297177 */ // Label 5884: @297177
     /* 297177 */ GIM_Reject,
     /* 297178 */ // Label 5854: @297178
     /* 297178 */ GIM_Try, /*On fail goto*//*Label 5885*/ GIMT_Encode4(297264),
     /* 297183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 297186 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297189 */   GIM_Try, /*On fail goto*//*Label 5886*/ GIMT_Encode4(297241), // Rule ID 7539 //
     /* 297194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297197 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 297205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 297209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 297213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 297217 */     // MIs[0] Op2
     /* 297217 */     GIM_CheckIsSameOperand, /*MI*/0, /*OpIdx*/3, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 297222 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 297224 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, (sub:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op2), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SUBR_ZPmZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297224 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SUBR_ZPmZ_B),
     /* 297227 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 297229 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 297231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Op2
     /* 297235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op3
     /* 297239 */     GIR_RootConstrainSelectedInstOperands,
     /* 297240 */     // GIR_Coverage, 7539,
     /* 297240 */     GIR_EraseRootFromParent_Done,
     /* 297241 */   // Label 5886: @297241
     /* 297241 */   GIM_Try, /*On fail goto*//*Label 5887*/ GIMT_Encode4(297263), // Rule ID 2730 //
     /* 297246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 297249 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 297252 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 297256 */     // (vselect:{ *:[nxv16i8] } nxv16i1:{ *:[nxv16i1] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SEL_ZPZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i1] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 297256 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SEL_ZPZZ_B),
     /* 297261 */     GIR_RootConstrainSelectedInstOperands,
     /* 297262 */     // GIR_Coverage, 2730,
     /* 297262 */     GIR_Done,
     /* 297263 */   // Label 5887: @297263
     /* 297263 */   GIM_Reject,
     /* 297264 */ // Label 5885: @297264
     /* 297264 */ GIM_Reject,
     /* 297265 */ // Label 5855: @297265
     /* 297265 */ GIM_Reject,
     /* 297266 */ // Label 53: @297266
     /* 297266 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5892*/ GIMT_Encode4(297749),
     /* 297277 */ /*GILLT_s64*//*Label 5888*/ GIMT_Encode4(297313), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297297 */ /*GILLT_v4s32*//*Label 5889*/ GIMT_Encode4(297344), GIMT_Encode4(0),
     /* 297305 */ /*GILLT_v8s16*//*Label 5890*/ GIMT_Encode4(297479),
     /* 297309 */ /*GILLT_v16s8*//*Label 5891*/ GIMT_Encode4(297614),
     /* 297313 */ // Label 5888: @297313
     /* 297313 */ GIM_Try, /*On fail goto*//*Label 5893*/ GIMT_Encode4(297343), // Rule ID 128 //
     /* 297318 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297321 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297328 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297332 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297336 */   // (mulhu:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297336 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULHrr),
     /* 297341 */   GIR_RootConstrainSelectedInstOperands,
     /* 297342 */   // GIR_Coverage, 128,
     /* 297342 */   GIR_Done,
     /* 297343 */ // Label 5893: @297343
     /* 297343 */ GIM_Reject,
     /* 297344 */ // Label 5889: @297344
     /* 297344 */ GIM_Try, /*On fail goto*//*Label 5894*/ GIMT_Encode4(297478), // Rule ID 6565 //
     /* 297349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297367 */   // (mulhu:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (UMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (UMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297367 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297370 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 297374 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297379 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297383 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297387 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297389 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297392 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297396 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297401 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297407 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297412 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297417 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297420 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297424 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297429 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297435 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297440 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297445 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297448 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 297452 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297457 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297460 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297463 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297465 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 297468 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297470 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297473 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297476 */   GIR_RootConstrainSelectedInstOperands,
     /* 297477 */   // GIR_Coverage, 6565,
     /* 297477 */   GIR_EraseRootFromParent_Done,
     /* 297478 */ // Label 5894: @297478
     /* 297478 */ GIM_Reject,
     /* 297479 */ // Label 5890: @297479
     /* 297479 */ GIM_Try, /*On fail goto*//*Label 5895*/ GIMT_Encode4(297613), // Rule ID 6564 //
     /* 297484 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297487 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297498 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297502 */   // (mulhu:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (UMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (UMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 297502 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297505 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 297509 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297514 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297518 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297522 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297524 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297527 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297531 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297536 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297542 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297547 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297552 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297555 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297559 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297564 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297570 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297575 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 297587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297598 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297600 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 297603 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297605 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297608 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297611 */   GIR_RootConstrainSelectedInstOperands,
     /* 297612 */   // GIR_Coverage, 6564,
     /* 297612 */   GIR_EraseRootFromParent_Done,
     /* 297613 */ // Label 5895: @297613
     /* 297613 */ GIM_Reject,
     /* 297614 */ // Label 5891: @297614
     /* 297614 */ GIM_Try, /*On fail goto*//*Label 5896*/ GIMT_Encode4(297748), // Rule ID 6563 //
     /* 297619 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 297622 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 297625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297633 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297637 */   // (mulhu:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (UMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (UMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 297637 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297640 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 297644 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297649 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297653 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297659 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297662 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297666 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297671 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297677 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297682 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297687 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297690 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297694 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297699 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297705 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297710 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 297722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297727 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297730 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297733 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297735 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 297738 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297740 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297743 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297746 */   GIR_RootConstrainSelectedInstOperands,
     /* 297747 */   // GIR_Coverage, 6563,
     /* 297747 */   GIR_EraseRootFromParent_Done,
     /* 297748 */ // Label 5896: @297748
     /* 297748 */ GIM_Reject,
     /* 297749 */ // Label 5892: @297749
     /* 297749 */ GIM_Reject,
     /* 297750 */ // Label 54: @297750
     /* 297750 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 5901*/ GIMT_Encode4(298233),
     /* 297761 */ /*GILLT_s64*//*Label 5897*/ GIMT_Encode4(297797), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 297781 */ /*GILLT_v4s32*//*Label 5898*/ GIMT_Encode4(297828), GIMT_Encode4(0),
     /* 297789 */ /*GILLT_v8s16*//*Label 5899*/ GIMT_Encode4(297963),
     /* 297793 */ /*GILLT_v16s8*//*Label 5900*/ GIMT_Encode4(298098),
     /* 297797 */ // Label 5897: @297797
     /* 297797 */ GIM_Try, /*On fail goto*//*Label 5902*/ GIMT_Encode4(297827), // Rule ID 127 //
     /* 297802 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 297805 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 297808 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297812 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297816 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 297820 */   // (mulhs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMULHrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 297820 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULHrr),
     /* 297825 */   GIR_RootConstrainSelectedInstOperands,
     /* 297826 */   // GIR_Coverage, 127,
     /* 297826 */   GIR_Done,
     /* 297827 */ // Label 5902: @297827
     /* 297827 */ GIM_Reject,
     /* 297828 */ // Label 5898: @297828
     /* 297828 */ GIM_Try, /*On fail goto*//*Label 5903*/ GIMT_Encode4(297962), // Rule ID 6562 //
     /* 297833 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 297836 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 297839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297843 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297847 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297851 */   // (mulhs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } (SMULLv2i32_v2i64:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v4i32] }:$Rm, dsub:{ *:[i32] })), (SMULLv4i32_v2i64:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm))
     /* 297851 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297854 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 297858 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297863 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 297867 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 297871 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 297873 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 297876 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297880 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297885 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 297891 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297896 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297901 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 297904 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 297908 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297913 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 297919 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 297924 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297929 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 297932 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 297936 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 297944 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 297947 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 297949 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 297952 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 297954 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 297957 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 297960 */   GIR_RootConstrainSelectedInstOperands,
     /* 297961 */   // GIR_Coverage, 6562,
     /* 297961 */   GIR_EraseRootFromParent_Done,
     /* 297962 */ // Label 5903: @297962
     /* 297962 */ GIM_Reject,
     /* 297963 */ // Label 5899: @297963
     /* 297963 */ GIM_Try, /*On fail goto*//*Label 5904*/ GIMT_Encode4(298097), // Rule ID 6561 //
     /* 297968 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 297971 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 297974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297982 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 297986 */   // (mulhs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } (SMULLv4i16_v4i32:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v8i16] }:$Rm, dsub:{ *:[i32] })), (SMULLv8i16_v4i32:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm))
     /* 297986 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 297989 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 297993 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 297998 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298002 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298006 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298008 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298011 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298015 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298020 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298026 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298031 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298036 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298039 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298043 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298048 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298054 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298059 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298064 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298067 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 298071 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298076 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298079 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298082 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298084 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 298087 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298089 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298092 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298095 */   GIR_RootConstrainSelectedInstOperands,
     /* 298096 */   // GIR_Coverage, 6561,
     /* 298096 */   GIR_EraseRootFromParent_Done,
     /* 298097 */ // Label 5904: @298097
     /* 298097 */ GIM_Reject,
     /* 298098 */ // Label 5900: @298098
     /* 298098 */ GIM_Try, /*On fail goto*//*Label 5905*/ GIMT_Encode4(298232), // Rule ID 6560 //
     /* 298103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298106 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298113 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298117 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298121 */   // (mulhs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } (SMULLv8i8_v8i16:{ *:[f128] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v16i8] }:$Rm, dsub:{ *:[i32] })), (SMULLv16i8_v8i16:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm))
     /* 298121 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 298124 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 298128 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298133 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 298137 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 298141 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 298143 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 298146 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298150 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298155 */   GIR_CopySubReg, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 298161 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298166 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298171 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 298174 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 298178 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298183 */   GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 298189 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298194 */   GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 298202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 298206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 298211 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 298214 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 298217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 298219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 298222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 298224 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 298227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/3,
     /* 298230 */   GIR_RootConstrainSelectedInstOperands,
     /* 298231 */   // GIR_Coverage, 6560,
     /* 298231 */   GIR_EraseRootFromParent_Done,
     /* 298232 */ // Label 5905: @298232
     /* 298232 */ GIM_Reject,
     /* 298233 */ // Label 5901: @298233
     /* 298233 */ GIM_Reject,
     /* 298234 */ // Label 55: @298234
     /* 298234 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5918*/ GIMT_Encode4(298705),
     /* 298245 */ /*GILLT_s64*//*Label 5906*/ GIMT_Encode4(298329), GIMT_Encode4(0),
     /* 298253 */ /*GILLT_v2s32*//*Label 5907*/ GIMT_Encode4(298363),
     /* 298257 */ /*GILLT_v2s64*//*Label 5908*/ GIMT_Encode4(298397),
     /* 298261 */ /*GILLT_v4s16*//*Label 5909*/ GIMT_Encode4(298431),
     /* 298265 */ /*GILLT_v4s32*//*Label 5910*/ GIMT_Encode4(298465),
     /* 298269 */ /*GILLT_v8s8*//*Label 5911*/ GIMT_Encode4(298499),
     /* 298273 */ /*GILLT_v8s16*//*Label 5912*/ GIMT_Encode4(298533),
     /* 298277 */ /*GILLT_v16s8*//*Label 5913*/ GIMT_Encode4(298567), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298297 */ /*GILLT_nxv2s64*//*Label 5914*/ GIMT_Encode4(298601), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298309 */ /*GILLT_nxv4s32*//*Label 5915*/ GIMT_Encode4(298627), GIMT_Encode4(0),
     /* 298317 */ /*GILLT_nxv8s16*//*Label 5916*/ GIMT_Encode4(298653), GIMT_Encode4(0),
     /* 298325 */ /*GILLT_nxv16s8*//*Label 5917*/ GIMT_Encode4(298679),
     /* 298329 */ // Label 5906: @298329
     /* 298329 */ GIM_Try, /*On fail goto*//*Label 5919*/ GIMT_Encode4(298362), // Rule ID 1645 //
     /* 298334 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298337 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298340 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298351 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298355 */   // (uaddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298355 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv1i64),
     /* 298360 */   GIR_RootConstrainSelectedInstOperands,
     /* 298361 */   // GIR_Coverage, 1645,
     /* 298361 */   GIR_Done,
     /* 298362 */ // Label 5919: @298362
     /* 298362 */ GIM_Reject,
     /* 298363 */ // Label 5907: @298363
     /* 298363 */ GIM_Try, /*On fail goto*//*Label 5920*/ GIMT_Encode4(298396), // Rule ID 1543 //
     /* 298368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298374 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298377 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298381 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298385 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298389 */   // (uaddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298389 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i32),
     /* 298394 */   GIR_RootConstrainSelectedInstOperands,
     /* 298395 */   // GIR_Coverage, 1543,
     /* 298395 */   GIR_Done,
     /* 298396 */ // Label 5920: @298396
     /* 298396 */ GIM_Reject,
     /* 298397 */ // Label 5908: @298397
     /* 298397 */ GIM_Try, /*On fail goto*//*Label 5921*/ GIMT_Encode4(298430), // Rule ID 1545 //
     /* 298402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298415 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298419 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298423 */   // (uaddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 298423 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv2i64),
     /* 298428 */   GIR_RootConstrainSelectedInstOperands,
     /* 298429 */   // GIR_Coverage, 1545,
     /* 298429 */   GIR_Done,
     /* 298430 */ // Label 5921: @298430
     /* 298430 */ GIM_Reject,
     /* 298431 */ // Label 5909: @298431
     /* 298431 */ GIM_Try, /*On fail goto*//*Label 5922*/ GIMT_Encode4(298464), // Rule ID 1541 //
     /* 298436 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 298442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 298445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298449 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298453 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298457 */   // (uaddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 298457 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i16),
     /* 298462 */   GIR_RootConstrainSelectedInstOperands,
     /* 298463 */   // GIR_Coverage, 1541,
     /* 298463 */   GIR_Done,
     /* 298464 */ // Label 5922: @298464
     /* 298464 */ GIM_Reject,
     /* 298465 */ // Label 5910: @298465
     /* 298465 */ GIM_Try, /*On fail goto*//*Label 5923*/ GIMT_Encode4(298498), // Rule ID 1544 //
     /* 298470 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298473 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298476 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 298479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298487 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298491 */   // (uaddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 298491 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv4i32),
     /* 298496 */   GIR_RootConstrainSelectedInstOperands,
     /* 298497 */   // GIR_Coverage, 1544,
     /* 298497 */   GIR_Done,
     /* 298498 */ // Label 5923: @298498
     /* 298498 */ GIM_Reject,
     /* 298499 */ // Label 5911: @298499
     /* 298499 */ GIM_Try, /*On fail goto*//*Label 5924*/ GIMT_Encode4(298532), // Rule ID 1539 //
     /* 298504 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298507 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 298510 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 298513 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298517 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298521 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298525 */   // (uaddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 298525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i8),
     /* 298530 */   GIR_RootConstrainSelectedInstOperands,
     /* 298531 */   // GIR_Coverage, 1539,
     /* 298531 */   GIR_Done,
     /* 298532 */ // Label 5924: @298532
     /* 298532 */ GIM_Reject,
     /* 298533 */ // Label 5912: @298533
     /* 298533 */ GIM_Try, /*On fail goto*//*Label 5925*/ GIMT_Encode4(298566), // Rule ID 1542 //
     /* 298538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 298544 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 298547 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298551 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298555 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298559 */   // (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 298559 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv8i16),
     /* 298564 */   GIR_RootConstrainSelectedInstOperands,
     /* 298565 */   // GIR_Coverage, 1542,
     /* 298565 */   GIR_Done,
     /* 298566 */ // Label 5925: @298566
     /* 298566 */ GIM_Reject,
     /* 298567 */ // Label 5913: @298567
     /* 298567 */ GIM_Try, /*On fail goto*//*Label 5926*/ GIMT_Encode4(298600), // Rule ID 1540 //
     /* 298572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 298578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 298581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298589 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298593 */   // (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 298593 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADDv16i8),
     /* 298598 */   GIR_RootConstrainSelectedInstOperands,
     /* 298599 */   // GIR_Coverage, 1540,
     /* 298599 */   GIR_Done,
     /* 298600 */ // Label 5926: @298600
     /* 298600 */ GIM_Reject,
     /* 298601 */ // Label 5914: @298601
     /* 298601 */ GIM_Try, /*On fail goto*//*Label 5927*/ GIMT_Encode4(298626), // Rule ID 7497 //
     /* 298606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 298612 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 298615 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298619 */   // (uaddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 298619 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_D),
     /* 298624 */   GIR_RootConstrainSelectedInstOperands,
     /* 298625 */   // GIR_Coverage, 7497,
     /* 298625 */   GIR_Done,
     /* 298626 */ // Label 5927: @298626
     /* 298626 */ GIM_Reject,
     /* 298627 */ // Label 5915: @298627
     /* 298627 */ GIM_Try, /*On fail goto*//*Label 5928*/ GIMT_Encode4(298652), // Rule ID 7496 //
     /* 298632 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 298638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 298641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298645 */   // (uaddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 298645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_S),
     /* 298650 */   GIR_RootConstrainSelectedInstOperands,
     /* 298651 */   // GIR_Coverage, 7496,
     /* 298651 */   GIR_Done,
     /* 298652 */ // Label 5928: @298652
     /* 298652 */ GIM_Reject,
     /* 298653 */ // Label 5916: @298653
     /* 298653 */ GIM_Try, /*On fail goto*//*Label 5929*/ GIMT_Encode4(298678), // Rule ID 7495 //
     /* 298658 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298661 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 298664 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 298667 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298671 */   // (uaddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 298671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_H),
     /* 298676 */   GIR_RootConstrainSelectedInstOperands,
     /* 298677 */   // GIR_Coverage, 7495,
     /* 298677 */   GIR_Done,
     /* 298678 */ // Label 5929: @298678
     /* 298678 */ GIM_Reject,
     /* 298679 */ // Label 5917: @298679
     /* 298679 */ GIM_Try, /*On fail goto*//*Label 5930*/ GIMT_Encode4(298704), // Rule ID 7494 //
     /* 298684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 298687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 298690 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 298693 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 298697 */   // (uaddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 298697 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQADD_ZZZ_B),
     /* 298702 */   GIR_RootConstrainSelectedInstOperands,
     /* 298703 */   // GIR_Coverage, 7494,
     /* 298703 */   GIR_Done,
     /* 298704 */ // Label 5930: @298704
     /* 298704 */ GIM_Reject,
     /* 298705 */ // Label 5918: @298705
     /* 298705 */ GIM_Reject,
     /* 298706 */ // Label 56: @298706
     /* 298706 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5943*/ GIMT_Encode4(301081),
     /* 298717 */ /*GILLT_s64*//*Label 5931*/ GIMT_Encode4(298801), GIMT_Encode4(0),
     /* 298725 */ /*GILLT_v2s32*//*Label 5932*/ GIMT_Encode4(298835),
     /* 298729 */ /*GILLT_v2s64*//*Label 5933*/ GIMT_Encode4(298869),
     /* 298733 */ /*GILLT_v4s16*//*Label 5934*/ GIMT_Encode4(299855),
     /* 298737 */ /*GILLT_v4s32*//*Label 5935*/ GIMT_Encode4(299889),
     /* 298741 */ /*GILLT_v8s8*//*Label 5936*/ GIMT_Encode4(300875),
     /* 298745 */ /*GILLT_v8s16*//*Label 5937*/ GIMT_Encode4(300909),
     /* 298749 */ /*GILLT_v16s8*//*Label 5938*/ GIMT_Encode4(300943), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298769 */ /*GILLT_nxv2s64*//*Label 5939*/ GIMT_Encode4(300977), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 298781 */ /*GILLT_nxv4s32*//*Label 5940*/ GIMT_Encode4(301003), GIMT_Encode4(0),
     /* 298789 */ /*GILLT_nxv8s16*//*Label 5941*/ GIMT_Encode4(301029), GIMT_Encode4(0),
     /* 298797 */ /*GILLT_nxv16s8*//*Label 5942*/ GIMT_Encode4(301055),
     /* 298801 */ // Label 5931: @298801
     /* 298801 */ GIM_Try, /*On fail goto*//*Label 5944*/ GIMT_Encode4(298834), // Rule ID 1636 //
     /* 298806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 298812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 298815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298819 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298823 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298827 */   // (saddsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQADDv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 298827 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv1i64),
     /* 298832 */   GIR_RootConstrainSelectedInstOperands,
     /* 298833 */   // GIR_Coverage, 1636,
     /* 298833 */   GIR_Done,
     /* 298834 */ // Label 5944: @298834
     /* 298834 */ GIM_Reject,
     /* 298835 */ // Label 5932: @298835
     /* 298835 */ GIM_Try, /*On fail goto*//*Label 5945*/ GIMT_Encode4(298868), // Rule ID 1420 //
     /* 298840 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 298846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 298861 */   // (saddsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQADDv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 298861 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i32),
     /* 298866 */   GIR_RootConstrainSelectedInstOperands,
     /* 298867 */   // GIR_Coverage, 1420,
     /* 298867 */   GIR_Done,
     /* 298868 */ // Label 5945: @298868
     /* 298868 */ GIM_Reject,
     /* 298869 */ // Label 5933: @298869
     /* 298869 */ GIM_Try, /*On fail goto*//*Label 5946*/ GIMT_Encode4(299854),
     /* 298874 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 298877 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 298880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298884 */   GIM_Try, /*On fail goto*//*Label 5947*/ GIMT_Encode4(299006), // Rule ID 13586 //
     /* 298889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 298892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 298896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 298900 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 298903 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 298908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 298912 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 298916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 298920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 298924 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298928 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 298932 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 298936 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 298940 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 298944 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298949 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 298953 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 298957 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 298961 */     // MIs[4] Operand 1
     /* 298961 */     // No operand predicates
     /* 298961 */     // MIs[2] Operand 2
     /* 298961 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 298972 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 298976 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 298978 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 298985 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 298985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 298988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 298990 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 298992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 298997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299004 */     GIR_RootConstrainSelectedInstOperands,
     /* 299005 */     // GIR_Coverage, 13586,
     /* 299005 */     GIR_EraseRootFromParent_Done,
     /* 299006 */   // Label 5947: @299006
     /* 299006 */   GIM_Try, /*On fail goto*//*Label 5948*/ GIMT_Encode4(299128), // Rule ID 2060 //
     /* 299011 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299014 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299018 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299022 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299026 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299029 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299034 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299038 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299050 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299062 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299066 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299070 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299075 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299079 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299083 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299087 */     // MIs[4] Operand 1
     /* 299087 */     // No operand predicates
     /* 299087 */     // MIs[2] Operand 2
     /* 299087 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 299098 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299100 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299107 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLALv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299107 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_indexed),
     /* 299110 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299112 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299114 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299126 */     GIR_RootConstrainSelectedInstOperands,
     /* 299127 */     // GIR_Coverage, 2060,
     /* 299127 */     GIR_EraseRootFromParent_Done,
     /* 299128 */   // Label 5948: @299128
     /* 299128 */   GIM_Try, /*On fail goto*//*Label 5949*/ GIMT_Encode4(299247), // Rule ID 13584 //
     /* 299133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299144 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299147 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299156 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299165 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299169 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299173 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299177 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299181 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299185 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299189 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299193 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299198 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299202 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299206 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299210 */     // MIs[4] Operand 1
     /* 299210 */     // No operand predicates
     /* 299210 */     // MIs[2] Operand 2
     /* 299210 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299221 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299225 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299227 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299238 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299242 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299245 */     GIR_RootConstrainSelectedInstOperands,
     /* 299246 */     // GIR_Coverage, 13584,
     /* 299246 */     GIR_EraseRootFromParent_Done,
     /* 299247 */   // Label 5949: @299247
     /* 299247 */   GIM_Try, /*On fail goto*//*Label 5950*/ GIMT_Encode4(299366), // Rule ID 2058 //
     /* 299252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299267 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299270 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299275 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299279 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299283 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299288 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299292 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299296 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299300 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299304 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299308 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299312 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299316 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299321 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299325 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299329 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299333 */     // MIs[4] Operand 1
     /* 299333 */     // No operand predicates
     /* 299333 */     // MIs[2] Operand 2
     /* 299333 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 299344 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299346 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299351 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 299361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 299364 */     GIR_RootConstrainSelectedInstOperands,
     /* 299365 */     // GIR_Coverage, 2058,
     /* 299365 */     GIR_EraseRootFromParent_Done,
     /* 299366 */   // Label 5950: @299366
     /* 299366 */   GIM_Try, /*On fail goto*//*Label 5951*/ GIMT_Encode4(299437), // Rule ID 13484 //
     /* 299371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299382 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299385 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299390 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299394 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299398 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299402 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299404 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299411 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299418 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299423 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299435 */     GIR_RootConstrainSelectedInstOperands,
     /* 299436 */     // GIR_Coverage, 13484,
     /* 299436 */     GIR_EraseRootFromParent_Done,
     /* 299437 */   // Label 5951: @299437
     /* 299437 */   GIM_Try, /*On fail goto*//*Label 5952*/ GIMT_Encode4(299508), // Rule ID 1745 //
     /* 299442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299457 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299460 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299465 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299469 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299475 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299482 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 299489 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLALv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 299489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i32_v2i64),
     /* 299492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 299501 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 299506 */     GIR_RootConstrainSelectedInstOperands,
     /* 299507 */     // GIR_Coverage, 1745,
     /* 299507 */     GIR_EraseRootFromParent_Done,
     /* 299508 */   // Label 5952: @299508
     /* 299508 */   GIM_Try, /*On fail goto*//*Label 5953*/ GIMT_Encode4(299604), // Rule ID 13585 //
     /* 299513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299524 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299527 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299532 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299536 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299540 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299545 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299549 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299553 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299557 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299561 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299566 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299570 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299574 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299578 */     // MIs[3] Operand 1
     /* 299578 */     // No operand predicates
     /* 299578 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299584 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299595 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299599 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299602 */     GIR_RootConstrainSelectedInstOperands,
     /* 299603 */     // GIR_Coverage, 13585,
     /* 299603 */     GIR_EraseRootFromParent_Done,
     /* 299604 */   // Label 5953: @299604
     /* 299604 */   GIM_Try, /*On fail goto*//*Label 5954*/ GIMT_Encode4(299700), // Rule ID 2059 //
     /* 299609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299612 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299616 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299620 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299624 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299627 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299632 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299636 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 299653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299657 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 299661 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299666 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 299670 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299674 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 299678 */     // MIs[3] Operand 1
     /* 299678 */     // No operand predicates
     /* 299678 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 299680 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLALv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 299680 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_indexed),
     /* 299683 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299685 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 299695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 299698 */     GIR_RootConstrainSelectedInstOperands,
     /* 299699 */     // GIR_Coverage, 2059,
     /* 299699 */     GIR_EraseRootFromParent_Done,
     /* 299700 */   // Label 5954: @299700
     /* 299700 */   GIM_Try, /*On fail goto*//*Label 5955*/ GIMT_Encode4(299765), // Rule ID 13483 //
     /* 299705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299716 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299719 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299724 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299728 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299737 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299742 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299746 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299748 */     // (saddsat:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm), V128:{ *:[v2i64] }:$Rd)  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299748 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299751 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299753 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 299755 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299759 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299763 */     GIR_RootConstrainSelectedInstOperands,
     /* 299764 */     // GIR_Coverage, 13483,
     /* 299764 */     GIR_EraseRootFromParent_Done,
     /* 299765 */   // Label 5955: @299765
     /* 299765 */   GIM_Try, /*On fail goto*//*Label 5956*/ GIMT_Encode4(299830), // Rule ID 1744 //
     /* 299770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 299781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299785 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299788 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299793 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 299797 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 299801 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299806 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299811 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 299813 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLALv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 299813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv2i32_v2i64),
     /* 299816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 299818 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 299820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 299824 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 299828 */     GIR_RootConstrainSelectedInstOperands,
     /* 299829 */     // GIR_Coverage, 1744,
     /* 299829 */     GIR_EraseRootFromParent_Done,
     /* 299830 */   // Label 5956: @299830
     /* 299830 */   GIM_Try, /*On fail goto*//*Label 5957*/ GIMT_Encode4(299853), // Rule ID 1422 //
     /* 299835 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299838 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299842 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299846 */     // (saddsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQADDv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 299846 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv2i64),
     /* 299851 */     GIR_RootConstrainSelectedInstOperands,
     /* 299852 */     // GIR_Coverage, 1422,
     /* 299852 */     GIR_Done,
     /* 299853 */   // Label 5957: @299853
     /* 299853 */   GIM_Reject,
     /* 299854 */ // Label 5946: @299854
     /* 299854 */ GIM_Reject,
     /* 299855 */ // Label 5934: @299855
     /* 299855 */ GIM_Try, /*On fail goto*//*Label 5958*/ GIMT_Encode4(299888), // Rule ID 1418 //
     /* 299860 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299863 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 299866 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299869 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299873 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299877 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 299881 */   // (saddsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQADDv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 299881 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i16),
     /* 299886 */   GIR_RootConstrainSelectedInstOperands,
     /* 299887 */   // GIR_Coverage, 1418,
     /* 299887 */   GIR_Done,
     /* 299888 */ // Label 5958: @299888
     /* 299888 */ GIM_Reject,
     /* 299889 */ // Label 5935: @299889
     /* 299889 */ GIM_Try, /*On fail goto*//*Label 5959*/ GIMT_Encode4(300874),
     /* 299894 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 299897 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 299900 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299904 */   GIM_Try, /*On fail goto*//*Label 5960*/ GIMT_Encode4(300026), // Rule ID 13583 //
     /* 299909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 299912 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 299916 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 299920 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 299923 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 299928 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 299932 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 299936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 299940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 299944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299948 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 299952 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 299956 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 299960 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 299964 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 299969 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 299973 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 299977 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 299981 */     // MIs[4] Operand 1
     /* 299981 */     // No operand predicates
     /* 299981 */     // MIs[2] Operand 2
     /* 299981 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 299992 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 299996 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 299998 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300005 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300012 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300017 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300021 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300024 */     GIR_RootConstrainSelectedInstOperands,
     /* 300025 */     // GIR_Coverage, 13583,
     /* 300025 */     GIR_EraseRootFromParent_Done,
     /* 300026 */   // Label 5960: @300026
     /* 300026 */   GIM_Try, /*On fail goto*//*Label 5961*/ GIMT_Encode4(300148), // Rule ID 2057 //
     /* 300031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300034 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300038 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300042 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300046 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300049 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300054 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300058 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300062 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300066 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300070 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300074 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300078 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300082 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300086 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300090 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300095 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300099 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300103 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300107 */     // MIs[4] Operand 1
     /* 300107 */     // No operand predicates
     /* 300107 */     // MIs[2] Operand 2
     /* 300107 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 300118 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300120 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300127 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLALv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_indexed),
     /* 300130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300132 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300134 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300146 */     GIR_RootConstrainSelectedInstOperands,
     /* 300147 */     // GIR_Coverage, 2057,
     /* 300147 */     GIR_EraseRootFromParent_Done,
     /* 300148 */   // Label 5961: @300148
     /* 300148 */   GIM_Try, /*On fail goto*//*Label 5962*/ GIMT_Encode4(300267), // Rule ID 13581 //
     /* 300153 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300164 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300167 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300172 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300176 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300197 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300201 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300205 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300209 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300213 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300218 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300222 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300226 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300230 */     // MIs[4] Operand 1
     /* 300230 */     // No operand predicates
     /* 300230 */     // MIs[2] Operand 2
     /* 300230 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300241 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300245 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300247 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300247 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300250 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300252 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300254 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300258 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300262 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300265 */     GIR_RootConstrainSelectedInstOperands,
     /* 300266 */     // GIR_Coverage, 13581,
     /* 300266 */     GIR_EraseRootFromParent_Done,
     /* 300267 */   // Label 5962: @300267
     /* 300267 */   GIM_Try, /*On fail goto*//*Label 5963*/ GIMT_Encode4(300386), // Rule ID 2055 //
     /* 300272 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300275 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300279 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300283 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300287 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300290 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300295 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300299 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 300316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300320 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 300324 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300328 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300332 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 300336 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300341 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 300345 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300349 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300353 */     // MIs[4] Operand 1
     /* 300353 */     // No operand predicates
     /* 300353 */     // MIs[2] Operand 2
     /* 300353 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 300364 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 300366 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300371 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300373 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 300381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 300384 */     GIR_RootConstrainSelectedInstOperands,
     /* 300385 */     // GIR_Coverage, 2055,
     /* 300385 */     GIR_EraseRootFromParent_Done,
     /* 300386 */   // Label 5963: @300386
     /* 300386 */   GIM_Try, /*On fail goto*//*Label 5964*/ GIMT_Encode4(300457), // Rule ID 13482 //
     /* 300391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300402 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300405 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300414 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300422 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300424 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300431 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300438 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300443 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300455 */     GIR_RootConstrainSelectedInstOperands,
     /* 300456 */     // GIR_Coverage, 13482,
     /* 300456 */     GIR_EraseRootFromParent_Done,
     /* 300457 */   // Label 5964: @300457
     /* 300457 */   GIM_Try, /*On fail goto*//*Label 5965*/ GIMT_Encode4(300528), // Rule ID 1743 //
     /* 300462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300477 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300480 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300489 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300493 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300495 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300502 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 300509 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLALv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv8i16_v4i32),
     /* 300512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300514 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300516 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 300521 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 300526 */     GIR_RootConstrainSelectedInstOperands,
     /* 300527 */     // GIR_Coverage, 1743,
     /* 300527 */     GIR_EraseRootFromParent_Done,
     /* 300528 */   // Label 5965: @300528
     /* 300528 */   GIM_Try, /*On fail goto*//*Label 5966*/ GIMT_Encode4(300624), // Rule ID 13582 //
     /* 300533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300544 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300547 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300552 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300556 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300560 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300565 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300569 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300573 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300577 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300581 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300586 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300590 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300594 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300598 */     // MIs[3] Operand 1
     /* 300598 */     // No operand predicates
     /* 300598 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300604 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300604 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300607 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300609 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300611 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300619 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300622 */     GIR_RootConstrainSelectedInstOperands,
     /* 300623 */     // GIR_Coverage, 13582,
     /* 300623 */     GIR_EraseRootFromParent_Done,
     /* 300624 */   // Label 5966: @300624
     /* 300624 */   GIM_Try, /*On fail goto*//*Label 5967*/ GIMT_Encode4(300720), // Rule ID 2056 //
     /* 300629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300632 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300644 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300647 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300656 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300660 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300665 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 300669 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 300673 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300677 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 300681 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 300686 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 300690 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 300694 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 300698 */     // MIs[3] Operand 1
     /* 300698 */     // No operand predicates
     /* 300698 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 300700 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLALv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 300700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_indexed),
     /* 300703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300705 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300711 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 300715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 300718 */     GIR_RootConstrainSelectedInstOperands,
     /* 300719 */     // GIR_Coverage, 2056,
     /* 300719 */     GIR_EraseRootFromParent_Done,
     /* 300720 */   // Label 5967: @300720
     /* 300720 */   GIM_Try, /*On fail goto*//*Label 5968*/ GIMT_Encode4(300785), // Rule ID 13481 //
     /* 300725 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 300732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300736 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300739 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300748 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300752 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300762 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300766 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300768 */     // (saddsat:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm), V128:{ *:[v4i32] }:$Rd)  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300768 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300771 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300773 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rd
     /* 300775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300779 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300783 */     GIR_RootConstrainSelectedInstOperands,
     /* 300784 */     // GIR_Coverage, 13481,
     /* 300784 */     GIR_EraseRootFromParent_Done,
     /* 300785 */   // Label 5968: @300785
     /* 300785 */   GIM_Try, /*On fail goto*//*Label 5969*/ GIMT_Encode4(300850), // Rule ID 1742 //
     /* 300790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 300801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 300805 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 300808 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 300813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 300817 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 300821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300831 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 300833 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLALv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 300833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLALv4i16_v4i32),
     /* 300836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 300838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 300840 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 300844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 300848 */     GIR_RootConstrainSelectedInstOperands,
     /* 300849 */     // GIR_Coverage, 1742,
     /* 300849 */     GIR_EraseRootFromParent_Done,
     /* 300850 */   // Label 5969: @300850
     /* 300850 */   GIM_Try, /*On fail goto*//*Label 5970*/ GIMT_Encode4(300873), // Rule ID 1421 //
     /* 300855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300866 */     // (saddsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQADDv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 300866 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv4i32),
     /* 300871 */     GIR_RootConstrainSelectedInstOperands,
     /* 300872 */     // GIR_Coverage, 1421,
     /* 300872 */     GIR_Done,
     /* 300873 */   // Label 5970: @300873
     /* 300873 */   GIM_Reject,
     /* 300874 */ // Label 5959: @300874
     /* 300874 */ GIM_Reject,
     /* 300875 */ // Label 5936: @300875
     /* 300875 */ GIM_Try, /*On fail goto*//*Label 5971*/ GIMT_Encode4(300908), // Rule ID 1416 //
     /* 300880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 300886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 300889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 300901 */   // (saddsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQADDv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 300901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i8),
     /* 300906 */   GIR_RootConstrainSelectedInstOperands,
     /* 300907 */   // GIR_Coverage, 1416,
     /* 300907 */   GIR_Done,
     /* 300908 */ // Label 5971: @300908
     /* 300908 */ GIM_Reject,
     /* 300909 */ // Label 5937: @300909
     /* 300909 */ GIM_Try, /*On fail goto*//*Label 5972*/ GIMT_Encode4(300942), // Rule ID 1419 //
     /* 300914 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300917 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 300920 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 300923 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300927 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300931 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300935 */   // (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQADDv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 300935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv8i16),
     /* 300940 */   GIR_RootConstrainSelectedInstOperands,
     /* 300941 */   // GIR_Coverage, 1419,
     /* 300941 */   GIR_Done,
     /* 300942 */ // Label 5972: @300942
     /* 300942 */ GIM_Reject,
     /* 300943 */ // Label 5938: @300943
     /* 300943 */ GIM_Try, /*On fail goto*//*Label 5973*/ GIMT_Encode4(300976), // Rule ID 1417 //
     /* 300948 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 300951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 300954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 300957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300961 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300965 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 300969 */   // (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQADDv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 300969 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADDv16i8),
     /* 300974 */   GIR_RootConstrainSelectedInstOperands,
     /* 300975 */   // GIR_Coverage, 1417,
     /* 300975 */   GIR_Done,
     /* 300976 */ // Label 5973: @300976
     /* 300976 */ GIM_Reject,
     /* 300977 */ // Label 5939: @300977
     /* 300977 */ GIM_Try, /*On fail goto*//*Label 5974*/ GIMT_Encode4(301002), // Rule ID 7493 //
     /* 300982 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 300985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 300988 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 300991 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 300995 */   // (saddsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQADD_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 300995 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_D),
     /* 301000 */   GIR_RootConstrainSelectedInstOperands,
     /* 301001 */   // GIR_Coverage, 7493,
     /* 301001 */   GIR_Done,
     /* 301002 */ // Label 5974: @301002
     /* 301002 */ GIM_Reject,
     /* 301003 */ // Label 5940: @301003
     /* 301003 */ GIM_Try, /*On fail goto*//*Label 5975*/ GIMT_Encode4(301028), // Rule ID 7492 //
     /* 301008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301021 */   // (saddsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQADD_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301021 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_S),
     /* 301026 */   GIR_RootConstrainSelectedInstOperands,
     /* 301027 */   // GIR_Coverage, 7492,
     /* 301027 */   GIR_Done,
     /* 301028 */ // Label 5975: @301028
     /* 301028 */ GIM_Reject,
     /* 301029 */ // Label 5941: @301029
     /* 301029 */ GIM_Try, /*On fail goto*//*Label 5976*/ GIMT_Encode4(301054), // Rule ID 7491 //
     /* 301034 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301037 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301040 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301047 */   // (saddsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQADD_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301047 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_H),
     /* 301052 */   GIR_RootConstrainSelectedInstOperands,
     /* 301053 */   // GIR_Coverage, 7491,
     /* 301053 */   GIR_Done,
     /* 301054 */ // Label 5976: @301054
     /* 301054 */ GIM_Reject,
     /* 301055 */ // Label 5942: @301055
     /* 301055 */ GIM_Try, /*On fail goto*//*Label 5977*/ GIMT_Encode4(301080), // Rule ID 7490 //
     /* 301060 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301073 */   // (saddsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQADD_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301073 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQADD_ZZZ_B),
     /* 301078 */   GIR_RootConstrainSelectedInstOperands,
     /* 301079 */   // GIR_Coverage, 7490,
     /* 301079 */   GIR_Done,
     /* 301080 */ // Label 5977: @301080
     /* 301080 */ GIM_Reject,
     /* 301081 */ // Label 5943: @301081
     /* 301081 */ GIM_Reject,
     /* 301082 */ // Label 57: @301082
     /* 301082 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 5990*/ GIMT_Encode4(301553),
     /* 301093 */ /*GILLT_s64*//*Label 5978*/ GIMT_Encode4(301177), GIMT_Encode4(0),
     /* 301101 */ /*GILLT_v2s32*//*Label 5979*/ GIMT_Encode4(301211),
     /* 301105 */ /*GILLT_v2s64*//*Label 5980*/ GIMT_Encode4(301245),
     /* 301109 */ /*GILLT_v4s16*//*Label 5981*/ GIMT_Encode4(301279),
     /* 301113 */ /*GILLT_v4s32*//*Label 5982*/ GIMT_Encode4(301313),
     /* 301117 */ /*GILLT_v8s8*//*Label 5983*/ GIMT_Encode4(301347),
     /* 301121 */ /*GILLT_v8s16*//*Label 5984*/ GIMT_Encode4(301381),
     /* 301125 */ /*GILLT_v16s8*//*Label 5985*/ GIMT_Encode4(301415), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301145 */ /*GILLT_nxv2s64*//*Label 5986*/ GIMT_Encode4(301449), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301157 */ /*GILLT_nxv4s32*//*Label 5987*/ GIMT_Encode4(301475), GIMT_Encode4(0),
     /* 301165 */ /*GILLT_nxv8s16*//*Label 5988*/ GIMT_Encode4(301501), GIMT_Encode4(0),
     /* 301173 */ /*GILLT_nxv16s8*//*Label 5989*/ GIMT_Encode4(301527),
     /* 301177 */ // Label 5978: @301177
     /* 301177 */ GIM_Try, /*On fail goto*//*Label 5991*/ GIMT_Encode4(301210), // Rule ID 1648 //
     /* 301182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301199 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301203 */   // (usubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (UQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301203 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv1i64),
     /* 301208 */   GIR_RootConstrainSelectedInstOperands,
     /* 301209 */   // GIR_Coverage, 1648,
     /* 301209 */   GIR_Done,
     /* 301210 */ // Label 5991: @301210
     /* 301210 */ GIM_Reject,
     /* 301211 */ // Label 5979: @301211
     /* 301211 */ GIM_Try, /*On fail goto*//*Label 5992*/ GIMT_Encode4(301244), // Rule ID 1564 //
     /* 301216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301222 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301225 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301229 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301233 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301237 */   // (usubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i32),
     /* 301242 */   GIR_RootConstrainSelectedInstOperands,
     /* 301243 */   // GIR_Coverage, 1564,
     /* 301243 */   GIR_Done,
     /* 301244 */ // Label 5992: @301244
     /* 301244 */ GIM_Reject,
     /* 301245 */ // Label 5980: @301245
     /* 301245 */ GIM_Try, /*On fail goto*//*Label 5993*/ GIMT_Encode4(301278), // Rule ID 1566 //
     /* 301250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301271 */   // (usubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 301271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv2i64),
     /* 301276 */   GIR_RootConstrainSelectedInstOperands,
     /* 301277 */   // GIR_Coverage, 1566,
     /* 301277 */   GIR_Done,
     /* 301278 */ // Label 5993: @301278
     /* 301278 */ GIM_Reject,
     /* 301279 */ // Label 5981: @301279
     /* 301279 */ GIM_Try, /*On fail goto*//*Label 5994*/ GIMT_Encode4(301312), // Rule ID 1562 //
     /* 301284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 301290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 301293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301297 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301301 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301305 */   // (usubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 301305 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i16),
     /* 301310 */   GIR_RootConstrainSelectedInstOperands,
     /* 301311 */   // GIR_Coverage, 1562,
     /* 301311 */   GIR_Done,
     /* 301312 */ // Label 5994: @301312
     /* 301312 */ GIM_Reject,
     /* 301313 */ // Label 5982: @301313
     /* 301313 */ GIM_Try, /*On fail goto*//*Label 5995*/ GIMT_Encode4(301346), // Rule ID 1565 //
     /* 301318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301324 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 301327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301331 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301335 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301339 */   // (usubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 301339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv4i32),
     /* 301344 */   GIR_RootConstrainSelectedInstOperands,
     /* 301345 */   // GIR_Coverage, 1565,
     /* 301345 */   GIR_Done,
     /* 301346 */ // Label 5995: @301346
     /* 301346 */ GIM_Reject,
     /* 301347 */ // Label 5983: @301347
     /* 301347 */ GIM_Try, /*On fail goto*//*Label 5996*/ GIMT_Encode4(301380), // Rule ID 1560 //
     /* 301352 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301355 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 301358 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 301361 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301365 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301369 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301373 */   // (usubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 301373 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i8),
     /* 301378 */   GIR_RootConstrainSelectedInstOperands,
     /* 301379 */   // GIR_Coverage, 1560,
     /* 301379 */   GIR_Done,
     /* 301380 */ // Label 5996: @301380
     /* 301380 */ GIM_Reject,
     /* 301381 */ // Label 5984: @301381
     /* 301381 */ GIM_Try, /*On fail goto*//*Label 5997*/ GIMT_Encode4(301414), // Rule ID 1563 //
     /* 301386 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 301392 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 301395 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301399 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301403 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301407 */   // (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 301407 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv8i16),
     /* 301412 */   GIR_RootConstrainSelectedInstOperands,
     /* 301413 */   // GIR_Coverage, 1563,
     /* 301413 */   GIR_Done,
     /* 301414 */ // Label 5997: @301414
     /* 301414 */ GIM_Reject,
     /* 301415 */ // Label 5985: @301415
     /* 301415 */ GIM_Try, /*On fail goto*//*Label 5998*/ GIMT_Encode4(301448), // Rule ID 1561 //
     /* 301420 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 301426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 301429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301437 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301441 */   // (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 301441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUBv16i8),
     /* 301446 */   GIR_RootConstrainSelectedInstOperands,
     /* 301447 */   // GIR_Coverage, 1561,
     /* 301447 */   GIR_Done,
     /* 301448 */ // Label 5998: @301448
     /* 301448 */ GIM_Reject,
     /* 301449 */ // Label 5986: @301449
     /* 301449 */ GIM_Try, /*On fail goto*//*Label 5999*/ GIMT_Encode4(301474), // Rule ID 7505 //
     /* 301454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 301460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 301463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301467 */   // (usubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 301467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_D),
     /* 301472 */   GIR_RootConstrainSelectedInstOperands,
     /* 301473 */   // GIR_Coverage, 7505,
     /* 301473 */   GIR_Done,
     /* 301474 */ // Label 5999: @301474
     /* 301474 */ GIM_Reject,
     /* 301475 */ // Label 5987: @301475
     /* 301475 */ GIM_Try, /*On fail goto*//*Label 6000*/ GIMT_Encode4(301500), // Rule ID 7504 //
     /* 301480 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301483 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 301486 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 301489 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301493 */   // (usubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 301493 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_S),
     /* 301498 */   GIR_RootConstrainSelectedInstOperands,
     /* 301499 */   // GIR_Coverage, 7504,
     /* 301499 */   GIR_Done,
     /* 301500 */ // Label 6000: @301500
     /* 301500 */ GIM_Reject,
     /* 301501 */ // Label 5988: @301501
     /* 301501 */ GIM_Try, /*On fail goto*//*Label 6001*/ GIMT_Encode4(301526), // Rule ID 7503 //
     /* 301506 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 301512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 301515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301519 */   // (usubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 301519 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_H),
     /* 301524 */   GIR_RootConstrainSelectedInstOperands,
     /* 301525 */   // GIR_Coverage, 7503,
     /* 301525 */   GIR_Done,
     /* 301526 */ // Label 6001: @301526
     /* 301526 */ GIM_Reject,
     /* 301527 */ // Label 5989: @301527
     /* 301527 */ GIM_Try, /*On fail goto*//*Label 6002*/ GIMT_Encode4(301552), // Rule ID 7502 //
     /* 301532 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 301535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 301538 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 301541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 301545 */   // (usubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 301545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UQSUB_ZZZ_B),
     /* 301550 */   GIR_RootConstrainSelectedInstOperands,
     /* 301551 */   // GIR_Coverage, 7502,
     /* 301551 */   GIR_Done,
     /* 301552 */ // Label 6002: @301552
     /* 301552 */ GIM_Reject,
     /* 301553 */ // Label 5990: @301553
     /* 301553 */ GIM_Reject,
     /* 301554 */ // Label 58: @301554
     /* 301554 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 6015*/ GIMT_Encode4(302943),
     /* 301565 */ /*GILLT_s64*//*Label 6003*/ GIMT_Encode4(301649), GIMT_Encode4(0),
     /* 301573 */ /*GILLT_v2s32*//*Label 6004*/ GIMT_Encode4(301683),
     /* 301577 */ /*GILLT_v2s64*//*Label 6005*/ GIMT_Encode4(301717),
     /* 301581 */ /*GILLT_v4s16*//*Label 6006*/ GIMT_Encode4(302210),
     /* 301585 */ /*GILLT_v4s32*//*Label 6007*/ GIMT_Encode4(302244),
     /* 301589 */ /*GILLT_v8s8*//*Label 6008*/ GIMT_Encode4(302737),
     /* 301593 */ /*GILLT_v8s16*//*Label 6009*/ GIMT_Encode4(302771),
     /* 301597 */ /*GILLT_v16s8*//*Label 6010*/ GIMT_Encode4(302805), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301617 */ /*GILLT_nxv2s64*//*Label 6011*/ GIMT_Encode4(302839), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 301629 */ /*GILLT_nxv4s32*//*Label 6012*/ GIMT_Encode4(302865), GIMT_Encode4(0),
     /* 301637 */ /*GILLT_nxv8s16*//*Label 6013*/ GIMT_Encode4(302891), GIMT_Encode4(0),
     /* 301645 */ /*GILLT_nxv16s8*//*Label 6014*/ GIMT_Encode4(302917),
     /* 301649 */ // Label 6003: @301649
     /* 301649 */ GIM_Try, /*On fail goto*//*Label 6016*/ GIMT_Encode4(301682), // Rule ID 1641 //
     /* 301654 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301657 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 301660 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 301663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301671 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301675 */   // (ssubsat:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)  =>  (SQSUBv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, FPR64:{ *:[v1i64] }:$Rm)
     /* 301675 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv1i64),
     /* 301680 */   GIR_RootConstrainSelectedInstOperands,
     /* 301681 */   // GIR_Coverage, 1641,
     /* 301681 */   GIR_Done,
     /* 301682 */ // Label 6016: @301682
     /* 301682 */ GIM_Reject,
     /* 301683 */ // Label 6004: @301683
     /* 301683 */ GIM_Try, /*On fail goto*//*Label 6017*/ GIMT_Encode4(301716), // Rule ID 1449 //
     /* 301688 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301691 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 301694 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301701 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301705 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301709 */   // (ssubsat:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SQSUBv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 301709 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i32),
     /* 301714 */   GIR_RootConstrainSelectedInstOperands,
     /* 301715 */   // GIR_Coverage, 1449,
     /* 301715 */   GIR_Done,
     /* 301716 */ // Label 6017: @301716
     /* 301716 */ GIM_Reject,
     /* 301717 */ // Label 6005: @301717
     /* 301717 */ GIM_Try, /*On fail goto*//*Label 6018*/ GIMT_Encode4(302209),
     /* 301722 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 301725 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 301728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301732 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301736 */   GIM_Try, /*On fail goto*//*Label 6019*/ GIMT_Encode4(301854), // Rule ID 2067 //
     /* 301741 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301744 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301748 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301752 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301755 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301760 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301764 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301768 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301772 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 301776 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301780 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 301784 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301788 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301792 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301796 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301801 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 301805 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301809 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301813 */     // MIs[4] Operand 1
     /* 301813 */     // No operand predicates
     /* 301813 */     // MIs[2] Operand 2
     /* 301813 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 301824 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 301826 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 301833 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] })))  =>  (SQDMLSLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_indexed),
     /* 301836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301840 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 301845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 301849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 301852 */     GIR_RootConstrainSelectedInstOperands,
     /* 301853 */     // GIR_Coverage, 2067,
     /* 301853 */     GIR_EraseRootFromParent_Done,
     /* 301854 */   // Label 6019: @301854
     /* 301854 */   GIM_Try, /*On fail goto*//*Label 6020*/ GIMT_Encode4(301969), // Rule ID 2065 //
     /* 301859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301870 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301873 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301882 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 301886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 301891 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 301895 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 301899 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301903 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 301907 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 301911 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 301915 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 301919 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 301924 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 301928 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 301932 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 301936 */     // MIs[4] Operand 1
     /* 301936 */     // No operand predicates
     /* 301936 */     // MIs[2] Operand 2
     /* 301936 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 301947 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 301949 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 301949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 301952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 301954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 301956 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 301960 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 301964 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 301967 */     GIR_RootConstrainSelectedInstOperands,
     /* 301968 */     // GIR_Coverage, 2065,
     /* 301968 */     GIR_EraseRootFromParent_Done,
     /* 301969 */   // Label 6020: @301969
     /* 301969 */   GIM_Try, /*On fail goto*//*Label 6021*/ GIMT_Encode4(302036), // Rule ID 1749 //
     /* 301974 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 301977 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 301981 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 301985 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 301988 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 301993 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 301997 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302001 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302003 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302010 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 302017 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm)))  =>  (SQDMLSLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302017 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i32_v2i64),
     /* 302020 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302022 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302024 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302029 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302034 */     GIR_RootConstrainSelectedInstOperands,
     /* 302035 */     // GIR_Coverage, 1749,
     /* 302035 */     GIR_EraseRootFromParent_Done,
     /* 302036 */   // Label 6021: @302036
     /* 302036 */   GIM_Try, /*On fail goto*//*Label 6022*/ GIMT_Encode4(302128), // Rule ID 2066 //
     /* 302041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302048 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302052 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302055 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302060 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302064 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302068 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 302081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302085 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302089 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302094 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302098 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302102 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 302106 */     // MIs[3] Operand 1
     /* 302106 */     // No operand predicates
     /* 302106 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302108 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SQDMLSLv2i32_indexed:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_indexed),
     /* 302111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302113 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302119 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302123 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302126 */     GIR_RootConstrainSelectedInstOperands,
     /* 302127 */     // GIR_Coverage, 2066,
     /* 302127 */     GIR_EraseRootFromParent_Done,
     /* 302128 */   // Label 6022: @302128
     /* 302128 */   GIM_Try, /*On fail goto*//*Label 6023*/ GIMT_Encode4(302189), // Rule ID 1748 //
     /* 302133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302140 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302144 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302147 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302152 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 302156 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 302160 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302170 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302172 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (intrinsic_wo_chain:{ *:[v2i64] } 690:{ *:[iPTR] }, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm))  =>  (SQDMLSLv2i32_v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 302172 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv2i32_v2i64),
     /* 302175 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302177 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302183 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302187 */     GIR_RootConstrainSelectedInstOperands,
     /* 302188 */     // GIR_Coverage, 1748,
     /* 302188 */     GIR_EraseRootFromParent_Done,
     /* 302189 */   // Label 6023: @302189
     /* 302189 */   GIM_Try, /*On fail goto*//*Label 6024*/ GIMT_Encode4(302208), // Rule ID 1451 //
     /* 302194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302201 */     // (ssubsat:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (SQSUBv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 302201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv2i64),
     /* 302206 */     GIR_RootConstrainSelectedInstOperands,
     /* 302207 */     // GIR_Coverage, 1451,
     /* 302207 */     GIR_Done,
     /* 302208 */   // Label 6024: @302208
     /* 302208 */   GIM_Reject,
     /* 302209 */ // Label 6018: @302209
     /* 302209 */ GIM_Reject,
     /* 302210 */ // Label 6006: @302210
     /* 302210 */ GIM_Try, /*On fail goto*//*Label 6025*/ GIMT_Encode4(302243), // Rule ID 1447 //
     /* 302215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 302221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302228 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302232 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302236 */   // (ssubsat:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SQSUBv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302236 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i16),
     /* 302241 */   GIR_RootConstrainSelectedInstOperands,
     /* 302242 */   // GIR_Coverage, 1447,
     /* 302242 */   GIR_Done,
     /* 302243 */ // Label 6025: @302243
     /* 302243 */ GIM_Reject,
     /* 302244 */ // Label 6007: @302244
     /* 302244 */ GIM_Try, /*On fail goto*//*Label 6026*/ GIMT_Encode4(302736),
     /* 302249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 302252 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 302255 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302259 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302263 */   GIM_Try, /*On fail goto*//*Label 6027*/ GIMT_Encode4(302381), // Rule ID 2064 //
     /* 302268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302271 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302275 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302279 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302282 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302287 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302291 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302303 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302307 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302311 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302315 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302319 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302323 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302328 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302332 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302336 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302340 */     // MIs[4] Operand 1
     /* 302340 */     // No operand predicates
     /* 302340 */     // MIs[2] Operand 2
     /* 302340 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 302351 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302353 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302360 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] })))  =>  (SQDMLSLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_indexed),
     /* 302363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302365 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302367 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302376 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302379 */     GIR_RootConstrainSelectedInstOperands,
     /* 302380 */     // GIR_Coverage, 2064,
     /* 302380 */     GIR_EraseRootFromParent_Done,
     /* 302381 */   // Label 6027: @302381
     /* 302381 */   GIM_Try, /*On fail goto*//*Label 6028*/ GIMT_Encode4(302496), // Rule ID 2062 //
     /* 302386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302389 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302393 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302397 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302400 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302405 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302409 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 302426 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302430 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 302434 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302438 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302442 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 302446 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302451 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 302455 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302459 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302463 */     // MIs[4] Operand 1
     /* 302463 */     // No operand predicates
     /* 302463 */     // MIs[2] Operand 2
     /* 302463 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(0),
     /* 302474 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 302476 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] })))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302487 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 302491 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 302494 */     GIR_RootConstrainSelectedInstOperands,
     /* 302495 */     // GIR_Coverage, 2062,
     /* 302495 */     GIR_EraseRootFromParent_Done,
     /* 302496 */   // Label 6028: @302496
     /* 302496 */   GIM_Try, /*On fail goto*//*Label 6029*/ GIMT_Encode4(302563), // Rule ID 1747 //
     /* 302501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302512 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302515 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302520 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302524 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302528 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302530 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302537 */     GIM_CheckComplexPattern, /*MI*/1, /*Op*/3, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 302544 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm)))  =>  (SQDMLSLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302544 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv8i16_v4i32),
     /* 302547 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302549 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302551 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 302556 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 302561 */     GIR_RootConstrainSelectedInstOperands,
     /* 302562 */     // GIR_Coverage, 1747,
     /* 302562 */     GIR_EraseRootFromParent_Done,
     /* 302563 */   // Label 6029: @302563
     /* 302563 */   GIM_Try, /*On fail goto*//*Label 6030*/ GIMT_Encode4(302655), // Rule ID 2063 //
     /* 302568 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302571 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302575 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302579 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302582 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302587 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302591 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302595 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302600 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/3, // MIs[2]
     /* 302604 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 302608 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302612 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 302616 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 302621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 302625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 302629 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 302633 */     // MIs[3] Operand 1
     /* 302633 */     // No operand predicates
     /* 302633 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 302635 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)))  =>  (SQDMLSLv4i16_indexed:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 302635 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_indexed),
     /* 302638 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302640 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302642 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302646 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 302650 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 302653 */     GIR_RootConstrainSelectedInstOperands,
     /* 302654 */     // GIR_Coverage, 2063,
     /* 302654 */     GIR_EraseRootFromParent_Done,
     /* 302655 */   // Label 6030: @302655
     /* 302655 */   GIM_Try, /*On fail goto*//*Label 6031*/ GIMT_Encode4(302716), // Rule ID 1746 //
     /* 302660 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302663 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 302667 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 302671 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/4,
     /* 302674 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_sqdmull),
     /* 302679 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 302683 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 302687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302692 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302697 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 302699 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (intrinsic_wo_chain:{ *:[v4i32] } 690:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm))  =>  (SQDMLSLv4i16_v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 302699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SQDMLSLv4i16_v4i32),
     /* 302702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 302704 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 302706 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 302710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Rm
     /* 302714 */     GIR_RootConstrainSelectedInstOperands,
     /* 302715 */     // GIR_Coverage, 1746,
     /* 302715 */     GIR_EraseRootFromParent_Done,
     /* 302716 */   // Label 6031: @302716
     /* 302716 */   GIM_Try, /*On fail goto*//*Label 6032*/ GIMT_Encode4(302735), // Rule ID 1450 //
     /* 302721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302724 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302728 */     // (ssubsat:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SQSUBv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 302728 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv4i32),
     /* 302733 */     GIR_RootConstrainSelectedInstOperands,
     /* 302734 */     // GIR_Coverage, 1450,
     /* 302734 */     GIR_Done,
     /* 302735 */   // Label 6032: @302735
     /* 302735 */   GIM_Reject,
     /* 302736 */ // Label 6026: @302736
     /* 302736 */ GIM_Reject,
     /* 302737 */ // Label 6008: @302737
     /* 302737 */ GIM_Try, /*On fail goto*//*Label 6033*/ GIMT_Encode4(302770), // Rule ID 1445 //
     /* 302742 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302745 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 302748 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 302751 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302755 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302759 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 302763 */   // (ssubsat:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SQSUBv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 302763 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i8),
     /* 302768 */   GIR_RootConstrainSelectedInstOperands,
     /* 302769 */   // GIR_Coverage, 1445,
     /* 302769 */   GIR_Done,
     /* 302770 */ // Label 6033: @302770
     /* 302770 */ GIM_Reject,
     /* 302771 */ // Label 6009: @302771
     /* 302771 */ GIM_Try, /*On fail goto*//*Label 6034*/ GIMT_Encode4(302804), // Rule ID 1448 //
     /* 302776 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302779 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 302782 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 302785 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302789 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302793 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302797 */   // (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SQSUBv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 302797 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv8i16),
     /* 302802 */   GIR_RootConstrainSelectedInstOperands,
     /* 302803 */   // GIR_Coverage, 1448,
     /* 302803 */   GIR_Done,
     /* 302804 */ // Label 6034: @302804
     /* 302804 */ GIM_Reject,
     /* 302805 */ // Label 6010: @302805
     /* 302805 */ GIM_Try, /*On fail goto*//*Label 6035*/ GIMT_Encode4(302838), // Rule ID 1446 //
     /* 302810 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 302813 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 302816 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 302819 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302823 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302827 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 302831 */   // (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SQSUBv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 302831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUBv16i8),
     /* 302836 */   GIR_RootConstrainSelectedInstOperands,
     /* 302837 */   // GIR_Coverage, 1446,
     /* 302837 */   GIR_Done,
     /* 302838 */ // Label 6035: @302838
     /* 302838 */ GIM_Reject,
     /* 302839 */ // Label 6011: @302839
     /* 302839 */ GIM_Try, /*On fail goto*//*Label 6036*/ GIMT_Encode4(302864), // Rule ID 7501 //
     /* 302844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 302850 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 302853 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302857 */   // (ssubsat:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (SQSUB_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 302857 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_D),
     /* 302862 */   GIR_RootConstrainSelectedInstOperands,
     /* 302863 */   // GIR_Coverage, 7501,
     /* 302863 */   GIR_Done,
     /* 302864 */ // Label 6036: @302864
     /* 302864 */ GIM_Reject,
     /* 302865 */ // Label 6012: @302865
     /* 302865 */ GIM_Try, /*On fail goto*//*Label 6037*/ GIMT_Encode4(302890), // Rule ID 7500 //
     /* 302870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 302876 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 302879 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302883 */   // (ssubsat:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (SQSUB_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 302883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_S),
     /* 302888 */   GIR_RootConstrainSelectedInstOperands,
     /* 302889 */   // GIR_Coverage, 7500,
     /* 302889 */   GIR_Done,
     /* 302890 */ // Label 6037: @302890
     /* 302890 */ GIM_Reject,
     /* 302891 */ // Label 6013: @302891
     /* 302891 */ GIM_Try, /*On fail goto*//*Label 6038*/ GIMT_Encode4(302916), // Rule ID 7499 //
     /* 302896 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302899 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 302902 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 302905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302909 */   // (ssubsat:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (SQSUB_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 302909 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_H),
     /* 302914 */   GIR_RootConstrainSelectedInstOperands,
     /* 302915 */   // GIR_Coverage, 7499,
     /* 302915 */   GIR_Done,
     /* 302916 */ // Label 6038: @302916
     /* 302916 */ GIM_Reject,
     /* 302917 */ // Label 6014: @302917
     /* 302917 */ GIM_Try, /*On fail goto*//*Label 6039*/ GIMT_Encode4(302942), // Rule ID 7498 //
     /* 302922 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 302925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 302928 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 302931 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 302935 */   // (ssubsat:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (SQSUB_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 302935 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SQSUB_ZZZ_B),
     /* 302940 */   GIR_RootConstrainSelectedInstOperands,
     /* 302941 */   // GIR_Coverage, 7498,
     /* 302941 */   GIR_Done,
     /* 302942 */ // Label 6039: @302942
     /* 302942 */ GIM_Reject,
     /* 302943 */ // Label 6015: @302943
     /* 302943 */ GIM_Reject,
     /* 302944 */ // Label 59: @302944
     /* 302944 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6051*/ GIMT_Encode4(304741),
     /* 302955 */ /*GILLT_s16*//*Label 6040*/ GIMT_Encode4(303039),
     /* 302959 */ /*GILLT_s32*//*Label 6041*/ GIMT_Encode4(303265),
     /* 302963 */ /*GILLT_s64*//*Label 6042*/ GIMT_Encode4(303619), GIMT_Encode4(0),
     /* 302971 */ /*GILLT_v2s32*//*Label 6043*/ GIMT_Encode4(303791),
     /* 302975 */ /*GILLT_v2s64*//*Label 6044*/ GIMT_Encode4(303829),
     /* 302979 */ /*GILLT_v4s16*//*Label 6045*/ GIMT_Encode4(304005),
     /* 302983 */ /*GILLT_v4s32*//*Label 6046*/ GIMT_Encode4(304043), GIMT_Encode4(0),
     /* 302991 */ /*GILLT_v8s16*//*Label 6047*/ GIMT_Encode4(304219), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303015 */ /*GILLT_nxv2s64*//*Label 6048*/ GIMT_Encode4(304663), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 303027 */ /*GILLT_nxv4s32*//*Label 6049*/ GIMT_Encode4(304689), GIMT_Encode4(0),
     /* 303035 */ /*GILLT_nxv8s16*//*Label 6050*/ GIMT_Encode4(304715),
     /* 303039 */ // Label 6040: @303039
     /* 303039 */ GIM_Try, /*On fail goto*//*Label 6052*/ GIMT_Encode4(303264),
     /* 303044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 303047 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 303050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303054 */   GIM_Try, /*On fail goto*//*Label 6053*/ GIMT_Encode4(303145), // Rule ID 6953 //
     /* 303059 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303063 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303067 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303071 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303075 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303080 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303092 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303096 */     // MIs[2] Rn
     /* 303096 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303101 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303107 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303107 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303110 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303114 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303119 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303125 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303130 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303135 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303138 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303140 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303143 */     GIR_RootConstrainSelectedInstOperands,
     /* 303144 */     // GIR_Coverage, 6953,
     /* 303144 */     GIR_EraseRootFromParent_Done,
     /* 303145 */   // Label 6053: @303145
     /* 303145 */   GIM_Try, /*On fail goto*//*Label 6054*/ GIMT_Encode4(303236), // Rule ID 14020 //
     /* 303150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303158 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 303162 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303171 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303187 */     // MIs[2] Rn
     /* 303187 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303192 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303196 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303198 */     // (fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 303198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 303229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303234 */     GIR_RootConstrainSelectedInstOperands,
     /* 303235 */     // GIR_Coverage, 14020,
     /* 303235 */     GIR_EraseRootFromParent_Done,
     /* 303236 */   // Label 6054: @303236
     /* 303236 */   GIM_Try, /*On fail goto*//*Label 6055*/ GIMT_Encode4(303263), // Rule ID 584 //
     /* 303241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 303244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303248 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 303252 */     // (fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 303252 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 303257 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303261 */     GIR_RootConstrainSelectedInstOperands,
     /* 303262 */     // GIR_Coverage, 584,
     /* 303262 */     GIR_Done,
     /* 303263 */   // Label 6055: @303263
     /* 303263 */   GIM_Reject,
     /* 303264 */ // Label 6052: @303264
     /* 303264 */ GIM_Reject,
     /* 303265 */ // Label 6041: @303265
     /* 303265 */ GIM_Try, /*On fail goto*//*Label 6056*/ GIMT_Encode4(303618),
     /* 303270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 303273 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 303276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303280 */   GIM_Try, /*On fail goto*//*Label 6057*/ GIMT_Encode4(303371), // Rule ID 6951 //
     /* 303285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303289 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303293 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303297 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303301 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303306 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303318 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303322 */     // MIs[2] Rn
     /* 303322 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303327 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303333 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303333 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303336 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303340 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303345 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303366 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303369 */     GIR_RootConstrainSelectedInstOperands,
     /* 303370 */     // GIR_Coverage, 6951,
     /* 303370 */     GIR_EraseRootFromParent_Done,
     /* 303371 */   // Label 6057: @303371
     /* 303371 */   GIM_Try, /*On fail goto*//*Label 6058*/ GIMT_Encode4(303435), // Rule ID 13192 //
     /* 303376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303392 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303397 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303413 */     // MIs[2] Rn
     /* 303413 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303418 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303422 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303424 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303424 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303427 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303429 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303433 */     GIR_RootConstrainSelectedInstOperands,
     /* 303434 */     // GIR_Coverage, 13192,
     /* 303434 */     GIR_EraseRootFromParent_Done,
     /* 303435 */   // Label 6058: @303435
     /* 303435 */   GIM_Try, /*On fail goto*//*Label 6059*/ GIMT_Encode4(303526), // Rule ID 14018 //
     /* 303440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 303452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303456 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303461 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303465 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303469 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303473 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303477 */     // MIs[2] Rn
     /* 303477 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303482 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303486 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303488 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 303488 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 303491 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 303495 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 303500 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 303506 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303511 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303521 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 303524 */     GIR_RootConstrainSelectedInstOperands,
     /* 303525 */     // GIR_Coverage, 14018,
     /* 303525 */     GIR_EraseRootFromParent_Done,
     /* 303526 */   // Label 6059: @303526
     /* 303526 */   GIM_Try, /*On fail goto*//*Label 6060*/ GIMT_Encode4(303590), // Rule ID 15845 //
     /* 303531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303543 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303547 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303552 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303564 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303568 */     // MIs[2] Rn
     /* 303568 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303573 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303577 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303579 */     // (fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } FPR64:{ *:[v2f32] }:$Rn)
     /* 303579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 303582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303584 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303588 */     GIR_RootConstrainSelectedInstOperands,
     /* 303589 */     // GIR_Coverage, 15845,
     /* 303589 */     GIR_EraseRootFromParent_Done,
     /* 303590 */   // Label 6060: @303590
     /* 303590 */   GIM_Try, /*On fail goto*//*Label 6061*/ GIMT_Encode4(303617), // Rule ID 586 //
     /* 303595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 303606 */     // (fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 303606 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 303611 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303615 */     GIR_RootConstrainSelectedInstOperands,
     /* 303616 */     // GIR_Coverage, 586,
     /* 303616 */     GIR_Done,
     /* 303617 */   // Label 6061: @303617
     /* 303617 */   GIM_Reject,
     /* 303618 */ // Label 6056: @303618
     /* 303618 */ GIM_Reject,
     /* 303619 */ // Label 6042: @303619
     /* 303619 */ GIM_Try, /*On fail goto*//*Label 6062*/ GIMT_Encode4(303790),
     /* 303624 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 303627 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 303630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303634 */   GIM_Try, /*On fail goto*//*Label 6063*/ GIMT_Encode4(303698), // Rule ID 6949 //
     /* 303639 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303643 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303647 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303651 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303655 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303660 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 303664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303672 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303676 */     // MIs[2] Rn
     /* 303676 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303681 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 303685 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303687 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303696 */     GIR_RootConstrainSelectedInstOperands,
     /* 303697 */     // GIR_Coverage, 6949,
     /* 303697 */     GIR_EraseRootFromParent_Done,
     /* 303698 */   // Label 6063: @303698
     /* 303698 */   GIM_Try, /*On fail goto*//*Label 6064*/ GIMT_Encode4(303762), // Rule ID 14016 //
     /* 303703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303711 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303715 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 303719 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303724 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 303728 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303732 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 303736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 303740 */     // MIs[2] Rn
     /* 303740 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303745 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 303749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303751 */     // (fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 303751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 303754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303760 */     GIR_RootConstrainSelectedInstOperands,
     /* 303761 */     // GIR_Coverage, 14016,
     /* 303761 */     GIR_EraseRootFromParent_Done,
     /* 303762 */   // Label 6064: @303762
     /* 303762 */   GIM_Try, /*On fail goto*//*Label 6065*/ GIMT_Encode4(303789), // Rule ID 588 //
     /* 303767 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 303770 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303774 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303778 */     // (fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 303778 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 303783 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303787 */     GIR_RootConstrainSelectedInstOperands,
     /* 303788 */     // GIR_Coverage, 588,
     /* 303788 */     GIR_Done,
     /* 303789 */   // Label 6065: @303789
     /* 303789 */   GIM_Reject,
     /* 303790 */ // Label 6062: @303790
     /* 303790 */ GIM_Reject,
     /* 303791 */ // Label 6043: @303791
     /* 303791 */ GIM_Try, /*On fail goto*//*Label 6066*/ GIMT_Encode4(303828), // Rule ID 1203 //
     /* 303796 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 303802 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 303805 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303809 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303813 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 303817 */   // (fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 303817 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 303822 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 303826 */   GIR_RootConstrainSelectedInstOperands,
     /* 303827 */   // GIR_Coverage, 1203,
     /* 303827 */   GIR_Done,
     /* 303828 */ // Label 6066: @303828
     /* 303828 */ GIM_Reject,
     /* 303829 */ // Label 6044: @303829
     /* 303829 */ GIM_Try, /*On fail goto*//*Label 6067*/ GIMT_Encode4(304004),
     /* 303834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303844 */   GIM_Try, /*On fail goto*//*Label 6068*/ GIMT_Encode4(303910), // Rule ID 6971 //
     /* 303849 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303853 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303857 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303861 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303870 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303875 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303879 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303883 */     // MIs[2] Rn
     /* 303883 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303888 */     // MIs[2] Rm
     /* 303888 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303893 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303895 */     // (fadd:{ *:[v2f64] } (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 303895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 303898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303904 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303908 */     GIR_RootConstrainSelectedInstOperands,
     /* 303909 */     // GIR_Coverage, 6971,
     /* 303909 */     GIR_EraseRootFromParent_Done,
     /* 303910 */   // Label 6068: @303910
     /* 303910 */   GIM_Try, /*On fail goto*//*Label 6069*/ GIMT_Encode4(303976), // Rule ID 14028 //
     /* 303915 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 303919 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_ZIP2),
     /* 303923 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 303927 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 303931 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303936 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 303945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_ZIP1),
     /* 303949 */     // MIs[2] Rn
     /* 303949 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 303954 */     // MIs[2] Rm
     /* 303954 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 303959 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 303961 */     // (fadd:{ *:[v2f64] } (AArch64zip2:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm), (AArch64zip1:{ *:[v2f64] } FPR128:{ *:[v2f64] }:$Rn, FPR128:{ *:[v2f64] }:$Rm))  =>  (FADDPv2f64:{ *:[v2f64] } ?:{ *:[v2f64] }:$Rn, ?:{ *:[v2f64] }:$Rm)
     /* 303961 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2f64),
     /* 303964 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 303966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 303970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 303974 */     GIR_RootConstrainSelectedInstOperands,
     /* 303975 */     // GIR_Coverage, 14028,
     /* 303975 */     GIR_EraseRootFromParent_Done,
     /* 303976 */   // Label 6069: @303976
     /* 303976 */   GIM_Try, /*On fail goto*//*Label 6070*/ GIMT_Encode4(304003), // Rule ID 1207 //
     /* 303981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 303984 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303988 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 303992 */     // (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 303992 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 303997 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304001 */     GIR_RootConstrainSelectedInstOperands,
     /* 304002 */     // GIR_Coverage, 1207,
     /* 304002 */     GIR_Done,
     /* 304003 */   // Label 6070: @304003
     /* 304003 */   GIM_Reject,
     /* 304004 */ // Label 6067: @304004
     /* 304004 */ GIM_Reject,
     /* 304005 */ // Label 6045: @304005
     /* 304005 */ GIM_Try, /*On fail goto*//*Label 6071*/ GIMT_Encode4(304042), // Rule ID 1199 //
     /* 304010 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304013 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 304016 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 304019 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304023 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304027 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304031 */   // (fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 304031 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 304036 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304040 */   GIR_RootConstrainSelectedInstOperands,
     /* 304041 */   // GIR_Coverage, 1199,
     /* 304041 */   GIR_Done,
     /* 304042 */ // Label 6071: @304042
     /* 304042 */ GIM_Reject,
     /* 304043 */ // Label 6046: @304043
     /* 304043 */ GIM_Try, /*On fail goto*//*Label 6072*/ GIMT_Encode4(304218),
     /* 304048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304058 */   GIM_Try, /*On fail goto*//*Label 6073*/ GIMT_Encode4(304124), // Rule ID 6972 //
     /* 304063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304075 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304079 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304084 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304089 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304093 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304097 */     // MIs[2] Rn
     /* 304097 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304102 */     // MIs[2] Rm
     /* 304102 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304107 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304109 */     // (fadd:{ *:[v4f32] } (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304109 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304112 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304114 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304122 */     GIR_RootConstrainSelectedInstOperands,
     /* 304123 */     // GIR_Coverage, 6972,
     /* 304123 */     GIR_EraseRootFromParent_Done,
     /* 304124 */   // Label 6073: @304124
     /* 304124 */   GIM_Try, /*On fail goto*//*Label 6074*/ GIMT_Encode4(304190), // Rule ID 14029 //
     /* 304129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304133 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304137 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 304141 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 304145 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304163 */     // MIs[2] Rn
     /* 304163 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304168 */     // MIs[2] Rm
     /* 304168 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304173 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304175 */     // (fadd:{ *:[v4f32] } (AArch64uzp2:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm), (AArch64uzp1:{ *:[v4f32] } FPR128:{ *:[v4f32] }:$Rn, FPR128:{ *:[v4f32] }:$Rm))  =>  (FADDPv4f32:{ *:[v4f32] } ?:{ *:[v4f32] }:$Rn, ?:{ *:[v4f32] }:$Rm)
     /* 304175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 304178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304188 */     GIR_RootConstrainSelectedInstOperands,
     /* 304189 */     // GIR_Coverage, 14029,
     /* 304189 */     GIR_EraseRootFromParent_Done,
     /* 304190 */   // Label 6074: @304190
     /* 304190 */   GIM_Try, /*On fail goto*//*Label 6075*/ GIMT_Encode4(304217), // Rule ID 1205 //
     /* 304195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304202 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304206 */     // (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 304206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304215 */     GIR_RootConstrainSelectedInstOperands,
     /* 304216 */     // GIR_Coverage, 1205,
     /* 304216 */     GIR_Done,
     /* 304217 */   // Label 6075: @304217
     /* 304217 */   GIM_Reject,
     /* 304218 */ // Label 6072: @304218
     /* 304218 */ GIM_Reject,
     /* 304219 */ // Label 6047: @304219
     /* 304219 */ GIM_Try, /*On fail goto*//*Label 6076*/ GIMT_Encode4(304662),
     /* 304224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304227 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304230 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304234 */   GIM_Try, /*On fail goto*//*Label 6077*/ GIMT_Encode4(304303), // Rule ID 6973 //
     /* 304239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP1),
     /* 304250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304258 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304268 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304272 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP2),
     /* 304276 */     // MIs[2] Rn
     /* 304276 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304281 */     // MIs[2] Rm
     /* 304281 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304286 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304288 */     // (fadd:{ *:[v8f16] } (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304297 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304301 */     GIR_RootConstrainSelectedInstOperands,
     /* 304302 */     // GIR_Coverage, 6973,
     /* 304302 */     GIR_EraseRootFromParent_Done,
     /* 304303 */   // Label 6077: @304303
     /* 304303 */   GIM_Try, /*On fail goto*//*Label 6078*/ GIMT_Encode4(304372), // Rule ID 14030 //
     /* 304308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304311 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 304315 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UZP2),
     /* 304319 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 304323 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 304327 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304332 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304337 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 304341 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_UZP1),
     /* 304345 */     // MIs[2] Rn
     /* 304345 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 304350 */     // MIs[2] Rm
     /* 304350 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/2, /*OtherMI*/1, /*OtherOpIdx*/2,
     /* 304355 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 304357 */     // (fadd:{ *:[v8f16] } (AArch64uzp2:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm), (AArch64uzp1:{ *:[v8f16] } FPR128:{ *:[v8f16] }:$Rn, FPR128:{ *:[v8f16] }:$Rm))  =>  (FADDPv8f16:{ *:[v8f16] } ?:{ *:[v8f16] }:$Rn, ?:{ *:[v8f16] }:$Rm)
     /* 304357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 304360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 304362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 304366 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 304370 */     GIR_RootConstrainSelectedInstOperands,
     /* 304371 */     // GIR_Coverage, 14030,
     /* 304371 */     GIR_EraseRootFromParent_Done,
     /* 304372 */   // Label 6078: @304372
     /* 304372 */   GIM_Try, /*On fail goto*//*Label 6079*/ GIMT_Encode4(304399), // Rule ID 1201 //
     /* 304377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 304380 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304384 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304388 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 304388 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 304393 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304397 */     GIR_RootConstrainSelectedInstOperands,
     /* 304398 */     // GIR_Coverage, 1201,
     /* 304398 */     GIR_Done,
     /* 304399 */   // Label 6079: @304399
     /* 304399 */   GIM_Try, /*On fail goto*//*Label 6080*/ GIMT_Encode4(304661), // Rule ID 7042 //
     /* 304404 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 304407 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304411 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304415 */     // (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 304415 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 304418 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304422 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304427 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 304431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 304433 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 304436 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 304440 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304445 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 304449 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 304451 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 304454 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304458 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304463 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 304466 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 304469 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 304471 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 304474 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304478 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304483 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 304489 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304494 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304499 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 304502 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304506 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304511 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 304514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 304516 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 304519 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 304523 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304528 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 304534 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304539 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304544 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 304547 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 304551 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304556 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 304559 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 304561 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 304564 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 304568 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304573 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 304576 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 304579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 304581 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 304584 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 304588 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304593 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 304596 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 304598 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 304601 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 304605 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 304612 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 304615 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 304619 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 304624 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 304627 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 304630 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 304633 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304638 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 304643 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 304651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 304653 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 304656 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 304659 */     GIR_RootConstrainSelectedInstOperands,
     /* 304660 */     // GIR_Coverage, 7042,
     /* 304660 */     GIR_EraseRootFromParent_Done,
     /* 304661 */   // Label 6080: @304661
     /* 304661 */   GIM_Reject,
     /* 304662 */ // Label 6076: @304662
     /* 304662 */ GIM_Reject,
     /* 304663 */ // Label 6048: @304663
     /* 304663 */ GIM_Try, /*On fail goto*//*Label 6081*/ GIMT_Encode4(304688), // Rule ID 2820 //
     /* 304668 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304671 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 304674 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 304677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304681 */   // (fadd:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FADD_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 304681 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_D),
     /* 304686 */   GIR_RootConstrainSelectedInstOperands,
     /* 304687 */   // GIR_Coverage, 2820,
     /* 304687 */   GIR_Done,
     /* 304688 */ // Label 6081: @304688
     /* 304688 */ GIM_Reject,
     /* 304689 */ // Label 6049: @304689
     /* 304689 */ GIM_Try, /*On fail goto*//*Label 6082*/ GIMT_Encode4(304714), // Rule ID 2818 //
     /* 304694 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304697 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 304700 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 304703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304707 */   // (fadd:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FADD_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 304707 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_S),
     /* 304712 */   GIR_RootConstrainSelectedInstOperands,
     /* 304713 */   // GIR_Coverage, 2818,
     /* 304713 */   GIR_Done,
     /* 304714 */ // Label 6082: @304714
     /* 304714 */ GIM_Reject,
     /* 304715 */ // Label 6050: @304715
     /* 304715 */ GIM_Try, /*On fail goto*//*Label 6083*/ GIMT_Encode4(304740), // Rule ID 2816 //
     /* 304720 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 304723 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 304726 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 304729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 304733 */   // (fadd:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FADD_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 304733 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADD_ZZZ_H),
     /* 304738 */   GIR_RootConstrainSelectedInstOperands,
     /* 304739 */   // GIR_Coverage, 2816,
     /* 304739 */   GIR_Done,
     /* 304740 */ // Label 6083: @304740
     /* 304740 */ GIM_Reject,
     /* 304741 */ // Label 6051: @304741
     /* 304741 */ GIM_Reject,
     /* 304742 */ // Label 60: @304742
     /* 304742 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6095*/ GIMT_Encode4(305479),
     /* 304753 */ /*GILLT_s16*//*Label 6084*/ GIMT_Encode4(304837),
     /* 304757 */ /*GILLT_s32*//*Label 6085*/ GIMT_Encode4(304875),
     /* 304761 */ /*GILLT_s64*//*Label 6086*/ GIMT_Encode4(304913), GIMT_Encode4(0),
     /* 304769 */ /*GILLT_v2s32*//*Label 6087*/ GIMT_Encode4(304951),
     /* 304773 */ /*GILLT_v2s64*//*Label 6088*/ GIMT_Encode4(304989),
     /* 304777 */ /*GILLT_v4s16*//*Label 6089*/ GIMT_Encode4(305027),
     /* 304781 */ /*GILLT_v4s32*//*Label 6090*/ GIMT_Encode4(305065), GIMT_Encode4(0),
     /* 304789 */ /*GILLT_v8s16*//*Label 6091*/ GIMT_Encode4(305103), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304813 */ /*GILLT_nxv2s64*//*Label 6092*/ GIMT_Encode4(305401), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 304825 */ /*GILLT_nxv4s32*//*Label 6093*/ GIMT_Encode4(305427), GIMT_Encode4(0),
     /* 304833 */ /*GILLT_nxv8s16*//*Label 6094*/ GIMT_Encode4(305453),
     /* 304837 */ // Label 6084: @304837
     /* 304837 */ GIM_Try, /*On fail goto*//*Label 6096*/ GIMT_Encode4(304874), // Rule ID 632 //
     /* 304842 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 304845 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 304848 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 304851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304859 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 304863 */   // (fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 304863 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 304868 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304872 */   GIR_RootConstrainSelectedInstOperands,
     /* 304873 */   // GIR_Coverage, 632,
     /* 304873 */   GIR_Done,
     /* 304874 */ // Label 6096: @304874
     /* 304874 */ GIM_Reject,
     /* 304875 */ // Label 6085: @304875
     /* 304875 */ GIM_Try, /*On fail goto*//*Label 6097*/ GIMT_Encode4(304912), // Rule ID 634 //
     /* 304880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 304886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 304889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 304901 */   // (fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 304901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 304906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304910 */   GIR_RootConstrainSelectedInstOperands,
     /* 304911 */   // GIR_Coverage, 634,
     /* 304911 */   GIR_Done,
     /* 304912 */ // Label 6097: @304912
     /* 304912 */ GIM_Reject,
     /* 304913 */ // Label 6086: @304913
     /* 304913 */ GIM_Try, /*On fail goto*//*Label 6098*/ GIMT_Encode4(304950), // Rule ID 636 //
     /* 304918 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 304921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 304924 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 304927 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304931 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304935 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304939 */   // (fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 304939 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 304944 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304948 */   GIR_RootConstrainSelectedInstOperands,
     /* 304949 */   // GIR_Coverage, 636,
     /* 304949 */   GIR_Done,
     /* 304950 */ // Label 6098: @304950
     /* 304950 */ GIM_Reject,
     /* 304951 */ // Label 6087: @304951
     /* 304951 */ GIM_Try, /*On fail goto*//*Label 6099*/ GIMT_Encode4(304988), // Rule ID 1343 //
     /* 304956 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304959 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 304962 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 304965 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304969 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304973 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 304977 */   // (fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 304977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 304982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 304986 */   GIR_RootConstrainSelectedInstOperands,
     /* 304987 */   // GIR_Coverage, 1343,
     /* 304987 */   GIR_Done,
     /* 304988 */ // Label 6099: @304988
     /* 304988 */ GIM_Reject,
     /* 304989 */ // Label 6088: @304989
     /* 304989 */ GIM_Try, /*On fail goto*//*Label 6100*/ GIMT_Encode4(305026), // Rule ID 1347 //
     /* 304994 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 304997 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 305000 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 305003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305011 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305015 */   // (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 305015 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 305020 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305024 */   GIR_RootConstrainSelectedInstOperands,
     /* 305025 */   // GIR_Coverage, 1347,
     /* 305025 */   GIR_Done,
     /* 305026 */ // Label 6100: @305026
     /* 305026 */ GIM_Reject,
     /* 305027 */ // Label 6089: @305027
     /* 305027 */ GIM_Try, /*On fail goto*//*Label 6101*/ GIMT_Encode4(305064), // Rule ID 1339 //
     /* 305032 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305035 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 305038 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 305041 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305045 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305049 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305053 */   // (fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 305053 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 305058 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305062 */   GIR_RootConstrainSelectedInstOperands,
     /* 305063 */   // GIR_Coverage, 1339,
     /* 305063 */   GIR_Done,
     /* 305064 */ // Label 6101: @305064
     /* 305064 */ GIM_Reject,
     /* 305065 */ // Label 6090: @305065
     /* 305065 */ GIM_Try, /*On fail goto*//*Label 6102*/ GIMT_Encode4(305102), // Rule ID 1345 //
     /* 305070 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 305073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 305076 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 305079 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305083 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305087 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305091 */   // (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 305091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305100 */   GIR_RootConstrainSelectedInstOperands,
     /* 305101 */   // GIR_Coverage, 1345,
     /* 305101 */   GIR_Done,
     /* 305102 */ // Label 6102: @305102
     /* 305102 */ GIM_Reject,
     /* 305103 */ // Label 6091: @305103
     /* 305103 */ GIM_Try, /*On fail goto*//*Label 6103*/ GIMT_Encode4(305400),
     /* 305108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305111 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 305114 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305118 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305122 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305126 */   GIM_Try, /*On fail goto*//*Label 6104*/ GIMT_Encode4(305145), // Rule ID 1341 //
     /* 305131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305134 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 305134 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 305139 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 305143 */     GIR_RootConstrainSelectedInstOperands,
     /* 305144 */     // GIR_Coverage, 1341,
     /* 305144 */     GIR_Done,
     /* 305145 */   // Label 6104: @305145
     /* 305145 */   GIM_Try, /*On fail goto*//*Label 6105*/ GIMT_Encode4(305399), // Rule ID 7048 //
     /* 305150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 305153 */     // (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 305153 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 305156 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305160 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305165 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 305169 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 305171 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 305174 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 305178 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305183 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 305187 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 305189 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 305192 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305196 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305201 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 305204 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 305207 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 305209 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 305212 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305216 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305221 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 305227 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305232 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305237 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 305240 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305244 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305249 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 305252 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 305254 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 305257 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305261 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305266 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 305272 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305277 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305282 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 305285 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 305289 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305294 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 305297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 305299 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 305302 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 305306 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305311 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 305314 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 305317 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 305319 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 305322 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 305326 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305331 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 305334 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 305336 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 305339 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 305343 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 305350 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 305353 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 305357 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305362 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 305365 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 305368 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 305371 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305376 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305381 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 305386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 305389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 305391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305394 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 305397 */     GIR_RootConstrainSelectedInstOperands,
     /* 305398 */     // GIR_Coverage, 7048,
     /* 305398 */     GIR_EraseRootFromParent_Done,
     /* 305399 */   // Label 6105: @305399
     /* 305399 */   GIM_Reject,
     /* 305400 */ // Label 6103: @305400
     /* 305400 */ GIM_Reject,
     /* 305401 */ // Label 6092: @305401
     /* 305401 */ GIM_Try, /*On fail goto*//*Label 6106*/ GIMT_Encode4(305426), // Rule ID 8248 //
     /* 305406 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305409 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 305412 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 305415 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305419 */   // (fsub:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FSUB_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 305419 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_D),
     /* 305424 */   GIR_RootConstrainSelectedInstOperands,
     /* 305425 */   // GIR_Coverage, 8248,
     /* 305425 */   GIR_Done,
     /* 305426 */ // Label 6106: @305426
     /* 305426 */ GIM_Reject,
     /* 305427 */ // Label 6093: @305427
     /* 305427 */ GIM_Try, /*On fail goto*//*Label 6107*/ GIMT_Encode4(305452), // Rule ID 8246 //
     /* 305432 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 305438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 305441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305445 */   // (fsub:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FSUB_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 305445 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_S),
     /* 305450 */   GIR_RootConstrainSelectedInstOperands,
     /* 305451 */   // GIR_Coverage, 8246,
     /* 305451 */   GIR_Done,
     /* 305452 */ // Label 6107: @305452
     /* 305452 */ GIM_Reject,
     /* 305453 */ // Label 6094: @305453
     /* 305453 */ GIM_Try, /*On fail goto*//*Label 6108*/ GIMT_Encode4(305478), // Rule ID 8244 //
     /* 305458 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 305461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 305464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 305467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 305471 */   // (fsub:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FSUB_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 305471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUB_ZZZ_H),
     /* 305476 */   GIR_RootConstrainSelectedInstOperands,
     /* 305477 */   // GIR_Coverage, 8244,
     /* 305477 */   GIR_Done,
     /* 305478 */ // Label 6108: @305478
     /* 305478 */ GIM_Reject,
     /* 305479 */ // Label 6095: @305479
     /* 305479 */ GIM_Reject,
     /* 305480 */ // Label 61: @305480
     /* 305480 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(22), /*)*//*default:*//*Label 6120*/ GIMT_Encode4(309575),
     /* 305491 */ /*GILLT_s16*//*Label 6109*/ GIMT_Encode4(305575),
     /* 305495 */ /*GILLT_s32*//*Label 6110*/ GIMT_Encode4(306217),
     /* 305499 */ /*GILLT_s64*//*Label 6111*/ GIMT_Encode4(306847), GIMT_Encode4(0),
     /* 305507 */ /*GILLT_v2s32*//*Label 6112*/ GIMT_Encode4(307477),
     /* 305511 */ /*GILLT_v2s64*//*Label 6113*/ GIMT_Encode4(308007),
     /* 305515 */ /*GILLT_v4s16*//*Label 6114*/ GIMT_Encode4(308365),
     /* 305519 */ /*GILLT_v4s32*//*Label 6115*/ GIMT_Encode4(308707), GIMT_Encode4(0),
     /* 305527 */ /*GILLT_v8s16*//*Label 6116*/ GIMT_Encode4(309065), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305551 */ /*GILLT_nxv2s64*//*Label 6117*/ GIMT_Encode4(309497), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 305563 */ /*GILLT_nxv4s32*//*Label 6118*/ GIMT_Encode4(309523), GIMT_Encode4(0),
     /* 305571 */ /*GILLT_nxv8s16*//*Label 6119*/ GIMT_Encode4(309549),
     /* 305575 */ // Label 6109: @305575
     /* 305575 */ GIM_Try, /*On fail goto*//*Label 6121*/ GIMT_Encode4(306216),
     /* 305580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 305583 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 305586 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305590 */   GIM_Try, /*On fail goto*//*Label 6122*/ GIMT_Encode4(305703), // Rule ID 6281 //
     /* 305595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305610 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305614 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305619 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305623 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 305627 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305631 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305635 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 305639 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305644 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 305648 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305652 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305656 */     // MIs[3] Operand 1
     /* 305656 */     // No operand predicates
     /* 305656 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305658 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305670 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305676 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305681 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305686 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305689 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305691 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305694 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 305698 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 305701 */     GIR_RootConstrainSelectedInstOperands,
     /* 305702 */     // GIR_Coverage, 6281,
     /* 305702 */     GIR_EraseRootFromParent_Done,
     /* 305703 */   // Label 6122: @305703
     /* 305703 */   GIM_Try, /*On fail goto*//*Label 6123*/ GIMT_Encode4(305816), // Rule ID 13997 //
     /* 305708 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305719 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305723 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305727 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305732 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 305736 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 305740 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 305744 */     // MIs[2] Operand 1
     /* 305744 */     // No operand predicates
     /* 305744 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 305748 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305752 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305756 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 305760 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305765 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 305769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 305771 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 305771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305783 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 305789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 305802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305804 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 305811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 305814 */     GIR_RootConstrainSelectedInstOperands,
     /* 305815 */     // GIR_Coverage, 13997,
     /* 305815 */     GIR_EraseRootFromParent_Done,
     /* 305816 */   // Label 6123: @305816
     /* 305816 */   GIM_Try, /*On fail goto*//*Label 6124*/ GIMT_Encode4(305895), // Rule ID 13931 //
     /* 305821 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305832 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305836 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305840 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305845 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305849 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305855 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305855 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305858 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305862 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305867 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305873 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305878 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305888 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 305890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305893 */     GIR_RootConstrainSelectedInstOperands,
     /* 305894 */     // GIR_Coverage, 13931,
     /* 305894 */     GIR_EraseRootFromParent_Done,
     /* 305895 */   // Label 6124: @305895
     /* 305895 */   GIM_Try, /*On fail goto*//*Label 6125*/ GIMT_Encode4(305974), // Rule ID 4838 //
     /* 305900 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 305903 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305907 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 305911 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305915 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305919 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305923 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305928 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 305932 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 305934 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 305934 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 305937 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 305941 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 305946 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 305952 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 305957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 305962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 305965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 305967 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 305969 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 305972 */     GIR_RootConstrainSelectedInstOperands,
     /* 305973 */     // GIR_Coverage, 4838,
     /* 305973 */     GIR_EraseRootFromParent_Done,
     /* 305974 */   // Label 6125: @305974
     /* 305974 */   GIM_Try, /*On fail goto*//*Label 6126*/ GIMT_Encode4(306037), // Rule ID 13540 //
     /* 305979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 305982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 305986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 305990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 305994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 305998 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306003 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306007 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306011 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306015 */     // MIs[2] Operand 1
     /* 306015 */     // No operand predicates
     /* 306015 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306021 */     // (fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306026 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306028 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306032 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306035 */     GIR_RootConstrainSelectedInstOperands,
     /* 306036 */     // GIR_Coverage, 13540,
     /* 306036 */     GIR_EraseRootFromParent_Done,
     /* 306037 */   // Label 6126: @306037
     /* 306037 */   GIM_Try, /*On fail goto*//*Label 6127*/ GIMT_Encode4(306100), // Rule ID 2012 //
     /* 306042 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 306045 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306049 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306053 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306057 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 306061 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 306070 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306074 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306078 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 306082 */     // MIs[2] Operand 1
     /* 306082 */     // No operand predicates
     /* 306082 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306084 */     // (fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 306087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306091 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306095 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306098 */     GIR_RootConstrainSelectedInstOperands,
     /* 306099 */     // GIR_Coverage, 2012,
     /* 306099 */     GIR_EraseRootFromParent_Done,
     /* 306100 */   // Label 6127: @306100
     /* 306100 */   GIM_Try, /*On fail goto*//*Label 6128*/ GIMT_Encode4(306144), // Rule ID 4843 //
     /* 306105 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306108 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306112 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306116 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306120 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306129 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306131 */     // (fmul:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a), FPR16:{ *:[f16] }:$b)  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306140 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306142 */     GIR_RootConstrainSelectedInstOperands,
     /* 306143 */     // GIR_Coverage, 4843,
     /* 306143 */     GIR_EraseRootFromParent_Done,
     /* 306144 */   // Label 6128: @306144
     /* 306144 */   GIM_Try, /*On fail goto*//*Label 6129*/ GIMT_Encode4(306188), // Rule ID 13936 //
     /* 306149 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306152 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306156 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306160 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306164 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 306168 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306173 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306175 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$b, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$a))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 306175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 306178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306184 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306186 */     GIR_RootConstrainSelectedInstOperands,
     /* 306187 */     // GIR_Coverage, 13936,
     /* 306187 */     GIR_EraseRootFromParent_Done,
     /* 306188 */   // Label 6129: @306188
     /* 306188 */   GIM_Try, /*On fail goto*//*Label 6130*/ GIMT_Encode4(306215), // Rule ID 620 //
     /* 306193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 306196 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306200 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 306204 */     // (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 306204 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 306209 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306213 */     GIR_RootConstrainSelectedInstOperands,
     /* 306214 */     // GIR_Coverage, 620,
     /* 306214 */     GIR_Done,
     /* 306215 */   // Label 6130: @306215
     /* 306215 */   GIM_Reject,
     /* 306216 */ // Label 6121: @306216
     /* 306216 */ GIM_Reject,
     /* 306217 */ // Label 6110: @306217
     /* 306217 */ GIM_Try, /*On fail goto*//*Label 6131*/ GIMT_Encode4(306846),
     /* 306222 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 306225 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 306228 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306232 */   GIM_Try, /*On fail goto*//*Label 6132*/ GIMT_Encode4(306345), // Rule ID 6283 //
     /* 306237 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306256 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306261 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306265 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306269 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306273 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306277 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306281 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306294 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306298 */     // MIs[3] Operand 1
     /* 306298 */     // No operand predicates
     /* 306298 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306300 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306300 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306303 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306307 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306312 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306318 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306343 */     GIR_RootConstrainSelectedInstOperands,
     /* 306344 */     // GIR_Coverage, 6283,
     /* 306344 */     GIR_EraseRootFromParent_Done,
     /* 306345 */   // Label 6132: @306345
     /* 306345 */   GIM_Try, /*On fail goto*//*Label 6133*/ GIMT_Encode4(306458), // Rule ID 13999 //
     /* 306350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306369 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306382 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306386 */     // MIs[2] Operand 1
     /* 306386 */     // No operand predicates
     /* 306386 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 306390 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306394 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306398 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 306402 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306407 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 306411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306413 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 306413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306425 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 306431 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306436 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306446 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306456 */     GIR_RootConstrainSelectedInstOperands,
     /* 306457 */     // GIR_Coverage, 13999,
     /* 306457 */     GIR_EraseRootFromParent_Done,
     /* 306458 */   // Label 6133: @306458
     /* 306458 */   GIM_Try, /*On fail goto*//*Label 6134*/ GIMT_Encode4(306534), // Rule ID 13933 //
     /* 306463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306475 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306479 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306484 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306488 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306492 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306494 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306494 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306497 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306501 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306506 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306512 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306517 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306527 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306532 */     GIR_RootConstrainSelectedInstOperands,
     /* 306533 */     // GIR_Coverage, 13933,
     /* 306533 */     GIR_EraseRootFromParent_Done,
     /* 306534 */   // Label 6134: @306534
     /* 306534 */   GIM_Try, /*On fail goto*//*Label 6135*/ GIMT_Encode4(306610), // Rule ID 4840 //
     /* 306539 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306564 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306568 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306570 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 306570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 306573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306582 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 306588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306603 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306608 */     GIR_RootConstrainSelectedInstOperands,
     /* 306609 */     // GIR_Coverage, 4840,
     /* 306609 */     GIR_EraseRootFromParent_Done,
     /* 306610 */   // Label 6135: @306610
     /* 306610 */   GIM_Try, /*On fail goto*//*Label 6136*/ GIMT_Encode4(306673), // Rule ID 13542 //
     /* 306615 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306618 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306622 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306626 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306630 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306634 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306647 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306651 */     // MIs[2] Operand 1
     /* 306651 */     // No operand predicates
     /* 306651 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306655 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306657 */     // (fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306662 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 306664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306671 */     GIR_RootConstrainSelectedInstOperands,
     /* 306672 */     // GIR_Coverage, 13542,
     /* 306672 */     GIR_EraseRootFromParent_Done,
     /* 306673 */   // Label 6136: @306673
     /* 306673 */   GIM_Try, /*On fail goto*//*Label 6137*/ GIMT_Encode4(306736), // Rule ID 2014 //
     /* 306678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 306697 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306701 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306706 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 306710 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306714 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 306718 */     // MIs[2] Operand 1
     /* 306718 */     // No operand predicates
     /* 306718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 306720 */     // (fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 306720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 306723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 306727 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 306731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 306734 */     GIR_RootConstrainSelectedInstOperands,
     /* 306735 */     // GIR_Coverage, 2014,
     /* 306735 */     GIR_EraseRootFromParent_Done,
     /* 306736 */   // Label 6137: @306736
     /* 306736 */   GIM_Try, /*On fail goto*//*Label 6138*/ GIMT_Encode4(306777), // Rule ID 4844 //
     /* 306741 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306745 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306749 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306753 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306764 */     // (fmul:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a), FPR32:{ *:[f32] }:$b)  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306773 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 306775 */     GIR_RootConstrainSelectedInstOperands,
     /* 306776 */     // GIR_Coverage, 4844,
     /* 306776 */     GIR_EraseRootFromParent_Done,
     /* 306777 */   // Label 6138: @306777
     /* 306777 */   GIM_Try, /*On fail goto*//*Label 6139*/ GIMT_Encode4(306818), // Rule ID 13937 //
     /* 306782 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 306790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 306794 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 306798 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306803 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 306805 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$b, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$a))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 306805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 306808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 306814 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 306816 */     GIR_RootConstrainSelectedInstOperands,
     /* 306817 */     // GIR_Coverage, 13937,
     /* 306817 */     GIR_EraseRootFromParent_Done,
     /* 306818 */   // Label 6139: @306818
     /* 306818 */   GIM_Try, /*On fail goto*//*Label 6140*/ GIMT_Encode4(306845), // Rule ID 622 //
     /* 306823 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 306826 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306830 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 306834 */     // (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 306834 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 306839 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 306843 */     GIR_RootConstrainSelectedInstOperands,
     /* 306844 */     // GIR_Coverage, 622,
     /* 306844 */     GIR_Done,
     /* 306845 */   // Label 6140: @306845
     /* 306845 */   GIM_Reject,
     /* 306846 */ // Label 6131: @306846
     /* 306846 */ GIM_Reject,
     /* 306847 */ // Label 6111: @306847
     /* 306847 */ GIM_Try, /*On fail goto*//*Label 6141*/ GIMT_Encode4(307476),
     /* 306852 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 306855 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 306858 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306862 */   GIM_Try, /*On fail goto*//*Label 6142*/ GIMT_Encode4(306975), // Rule ID 6285 //
     /* 306867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306870 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306874 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306878 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306882 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306891 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 306895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 306899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 306911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 306920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 306924 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 306928 */     // MIs[3] Operand 1
     /* 306928 */     // No operand predicates
     /* 306928 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 306930 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 306930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 306933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 306937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 306942 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 306948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 306953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 306958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 306961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 306963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 306966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 306970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 306973 */     GIR_RootConstrainSelectedInstOperands,
     /* 306974 */     // GIR_Coverage, 6285,
     /* 306974 */     GIR_EraseRootFromParent_Done,
     /* 306975 */   // Label 6142: @306975
     /* 306975 */   GIM_Try, /*On fail goto*//*Label 6143*/ GIMT_Encode4(307088), // Rule ID 14001 //
     /* 306980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 306983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 306987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 306991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 306995 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 306999 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307012 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307016 */     // MIs[2] Operand 1
     /* 307016 */     // No operand predicates
     /* 307016 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 307020 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307024 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307028 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 307032 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307037 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 307041 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307043 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 307043 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307046 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307050 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307055 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 307061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307076 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307079 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307083 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307086 */     GIR_RootConstrainSelectedInstOperands,
     /* 307087 */     // GIR_Coverage, 14001,
     /* 307087 */     GIR_EraseRootFromParent_Done,
     /* 307088 */   // Label 6143: @307088
     /* 307088 */   GIM_Try, /*On fail goto*//*Label 6144*/ GIMT_Encode4(307164), // Rule ID 13935 //
     /* 307093 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307097 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307101 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307105 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307109 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307114 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307122 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307124 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307136 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307142 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307147 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307157 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307159 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307162 */     GIR_RootConstrainSelectedInstOperands,
     /* 307163 */     // GIR_Coverage, 13935,
     /* 307163 */     GIR_EraseRootFromParent_Done,
     /* 307164 */   // Label 6144: @307164
     /* 307164 */   GIM_Try, /*On fail goto*//*Label 6145*/ GIMT_Encode4(307240), // Rule ID 4842 //
     /* 307169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307181 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307185 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307189 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307194 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 307198 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307200 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 307200 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 307203 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 307207 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307212 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 307218 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307228 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307231 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307233 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307238 */     GIR_RootConstrainSelectedInstOperands,
     /* 307239 */     // GIR_Coverage, 4842,
     /* 307239 */     GIR_EraseRootFromParent_Done,
     /* 307240 */   // Label 6145: @307240
     /* 307240 */   GIM_Try, /*On fail goto*//*Label 6146*/ GIMT_Encode4(307303), // Rule ID 13544 //
     /* 307245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307281 */     // MIs[2] Operand 1
     /* 307281 */     // No operand predicates
     /* 307281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307285 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307287 */     // (fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307292 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307301 */     GIR_RootConstrainSelectedInstOperands,
     /* 307302 */     // GIR_Coverage, 13544,
     /* 307302 */     GIR_EraseRootFromParent_Done,
     /* 307303 */   // Label 6146: @307303
     /* 307303 */   GIM_Try, /*On fail goto*//*Label 6147*/ GIMT_Encode4(307366), // Rule ID 2016 //
     /* 307308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 307323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 307327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307336 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307340 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307344 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 307348 */     // MIs[2] Operand 1
     /* 307348 */     // No operand predicates
     /* 307348 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307350 */     // (fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 307353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307355 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307361 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307364 */     GIR_RootConstrainSelectedInstOperands,
     /* 307365 */     // GIR_Coverage, 2016,
     /* 307365 */     GIR_EraseRootFromParent_Done,
     /* 307366 */   // Label 6147: @307366
     /* 307366 */   GIM_Try, /*On fail goto*//*Label 6148*/ GIMT_Encode4(307407), // Rule ID 4845 //
     /* 307371 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307375 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307379 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307383 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307388 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307392 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307394 */     // (fmul:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a), FPR64:{ *:[f64] }:$b)  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307394 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307397 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307399 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307403 */     GIR_RootToRootCopy, /*OpIdx*/2, // b
     /* 307405 */     GIR_RootConstrainSelectedInstOperands,
     /* 307406 */     // GIR_Coverage, 4845,
     /* 307406 */     GIR_EraseRootFromParent_Done,
     /* 307407 */   // Label 6148: @307407
     /* 307407 */   GIM_Try, /*On fail goto*//*Label 6149*/ GIMT_Encode4(307448), // Rule ID 13938 //
     /* 307412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 307424 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 307428 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307433 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307435 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$b, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$a))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 307435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 307438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // a
     /* 307444 */     GIR_RootToRootCopy, /*OpIdx*/1, // b
     /* 307446 */     GIR_RootConstrainSelectedInstOperands,
     /* 307447 */     // GIR_Coverage, 13938,
     /* 307447 */     GIR_EraseRootFromParent_Done,
     /* 307448 */   // Label 6149: @307448
     /* 307448 */   GIM_Try, /*On fail goto*//*Label 6150*/ GIMT_Encode4(307475), // Rule ID 624 //
     /* 307453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 307456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307460 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307464 */     // (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 307464 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 307469 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 307473 */     GIR_RootConstrainSelectedInstOperands,
     /* 307474 */     // GIR_Coverage, 624,
     /* 307474 */     GIR_Done,
     /* 307475 */   // Label 6150: @307475
     /* 307475 */   GIM_Reject,
     /* 307476 */ // Label 6141: @307476
     /* 307476 */ GIM_Reject,
     /* 307477 */ // Label 6112: @307477
     /* 307477 */ GIM_Try, /*On fail goto*//*Label 6151*/ GIMT_Encode4(308006),
     /* 307482 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 307485 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 307488 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307492 */   GIM_Try, /*On fail goto*//*Label 6152*/ GIMT_Encode4(307578), // Rule ID 13533 //
     /* 307497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307500 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307504 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307508 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307512 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307516 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307520 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307524 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307528 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307533 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307537 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307541 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307545 */     // MIs[3] Operand 1
     /* 307545 */     // No operand predicates
     /* 307545 */     // MIs[1] Operand 2
     /* 307545 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307560 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307562 */     // (fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307562 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307565 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307567 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307569 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307573 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307576 */     GIR_RootConstrainSelectedInstOperands,
     /* 307577 */     // GIR_Coverage, 13533,
     /* 307577 */     GIR_EraseRootFromParent_Done,
     /* 307578 */   // Label 6152: @307578
     /* 307578 */   GIM_Try, /*On fail goto*//*Label 6153*/ GIMT_Encode4(307664), // Rule ID 2005 //
     /* 307583 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307586 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 307598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307602 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 307606 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307610 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307614 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 307618 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307623 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 307627 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307631 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307635 */     // MIs[3] Operand 1
     /* 307635 */     // No operand predicates
     /* 307635 */     // MIs[1] Operand 2
     /* 307635 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 307646 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 307648 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307648 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307651 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307653 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 307659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 307662 */     GIR_RootConstrainSelectedInstOperands,
     /* 307663 */     // GIR_Coverage, 2005,
     /* 307663 */     GIR_EraseRootFromParent_Done,
     /* 307664 */   // Label 6153: @307664
     /* 307664 */   GIM_Try, /*On fail goto*//*Label 6154*/ GIMT_Encode4(307727), // Rule ID 13534 //
     /* 307669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307684 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307688 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307693 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307697 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307701 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307705 */     // MIs[2] Operand 1
     /* 307705 */     // No operand predicates
     /* 307705 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307709 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307711 */     // (fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307716 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307722 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307725 */     GIR_RootConstrainSelectedInstOperands,
     /* 307726 */     // GIR_Coverage, 13534,
     /* 307726 */     GIR_EraseRootFromParent_Done,
     /* 307727 */   // Label 6154: @307727
     /* 307727 */   GIM_Try, /*On fail goto*//*Label 6155*/ GIMT_Encode4(307790), // Rule ID 2006 //
     /* 307732 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307735 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307743 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 307747 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 307751 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 307755 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 307764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 307768 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 307772 */     // MIs[2] Operand 1
     /* 307772 */     // No operand predicates
     /* 307772 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 307774 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 307774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 307788 */     GIR_RootConstrainSelectedInstOperands,
     /* 307789 */     // GIR_Coverage, 2006,
     /* 307789 */     GIR_EraseRootFromParent_Done,
     /* 307790 */   // Label 6155: @307790
     /* 307790 */   GIM_Try, /*On fail goto*//*Label 6156*/ GIMT_Encode4(307884), // Rule ID 14003 //
     /* 307795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 307799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307812 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307816 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307818 */     // (fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307818 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307821 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307825 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307844 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307847 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307851 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307854 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307859 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307864 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307874 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 307876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307882 */     GIR_RootConstrainSelectedInstOperands,
     /* 307883 */     // GIR_Coverage, 14003,
     /* 307883 */     GIR_EraseRootFromParent_Done,
     /* 307884 */   // Label 6156: @307884
     /* 307884 */   GIM_Try, /*On fail goto*//*Label 6157*/ GIMT_Encode4(307978), // Rule ID 6287 //
     /* 307889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307893 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 307897 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 307901 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 307905 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307910 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 307912 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 307912 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 307915 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 307919 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307924 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 307926 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 307929 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 307933 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 307938 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 307941 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 307945 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 307948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 307958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 307963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 307966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 307968 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 307970 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 307973 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 307976 */     GIR_RootConstrainSelectedInstOperands,
     /* 307977 */     // GIR_Coverage, 6287,
     /* 307977 */     GIR_EraseRootFromParent_Done,
     /* 307978 */   // Label 6157: @307978
     /* 307978 */   GIM_Try, /*On fail goto*//*Label 6158*/ GIMT_Encode4(308005), // Rule ID 1323 //
     /* 307983 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 307986 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307990 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 307994 */     // (fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 307994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 307999 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308003 */     GIR_RootConstrainSelectedInstOperands,
     /* 308004 */     // GIR_Coverage, 1323,
     /* 308004 */     GIR_Done,
     /* 308005 */   // Label 6158: @308005
     /* 308005 */   GIM_Reject,
     /* 308006 */ // Label 6151: @308006
     /* 308006 */ GIM_Reject,
     /* 308007 */ // Label 6113: @308007
     /* 308007 */ GIM_Try, /*On fail goto*//*Label 6159*/ GIMT_Encode4(308364),
     /* 308012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 308018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308022 */   GIM_Try, /*On fail goto*//*Label 6160*/ GIMT_Encode4(308085), // Rule ID 13538 //
     /* 308027 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308030 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308034 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308038 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308042 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308046 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308051 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308055 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308059 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308063 */     // MIs[2] Operand 1
     /* 308063 */     // No operand predicates
     /* 308063 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308069 */     // (fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308069 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308072 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308074 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308076 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308080 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308083 */     GIR_RootConstrainSelectedInstOperands,
     /* 308084 */     // GIR_Coverage, 13538,
     /* 308084 */     GIR_EraseRootFromParent_Done,
     /* 308085 */   // Label 6160: @308085
     /* 308085 */   GIM_Try, /*On fail goto*//*Label 6161*/ GIMT_Encode4(308148), // Rule ID 2010 //
     /* 308090 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308093 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 308105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 308109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 308130 */     // MIs[2] Operand 1
     /* 308130 */     // No operand predicates
     /* 308130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308132 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308132 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308135 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308137 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308139 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308143 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308146 */     GIR_RootConstrainSelectedInstOperands,
     /* 308147 */     // GIR_Coverage, 2010,
     /* 308147 */     GIR_EraseRootFromParent_Done,
     /* 308148 */   // Label 6161: @308148
     /* 308148 */   GIM_Try, /*On fail goto*//*Label 6162*/ GIMT_Encode4(308242), // Rule ID 14007 //
     /* 308153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308174 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308176 */     // (fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308176 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308179 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308183 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308202 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308205 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308209 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308222 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308232 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308240 */     GIR_RootConstrainSelectedInstOperands,
     /* 308241 */     // GIR_Coverage, 14007,
     /* 308241 */     GIR_EraseRootFromParent_Done,
     /* 308242 */   // Label 6162: @308242
     /* 308242 */   GIM_Try, /*On fail goto*//*Label 6163*/ GIMT_Encode4(308336), // Rule ID 6291 //
     /* 308247 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308251 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308255 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308259 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 308263 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308270 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308270 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308273 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308277 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308282 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308284 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308287 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308291 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308296 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308299 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308303 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 308306 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308311 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308316 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308321 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 308324 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308326 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308328 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308331 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308334 */     GIR_RootConstrainSelectedInstOperands,
     /* 308335 */     // GIR_Coverage, 6291,
     /* 308335 */     GIR_EraseRootFromParent_Done,
     /* 308336 */   // Label 6163: @308336
     /* 308336 */   GIM_Try, /*On fail goto*//*Label 6164*/ GIMT_Encode4(308363), // Rule ID 1327 //
     /* 308341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308348 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308352 */     // (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 308352 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 308357 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308361 */     GIR_RootConstrainSelectedInstOperands,
     /* 308362 */     // GIR_Coverage, 1327,
     /* 308362 */     GIR_Done,
     /* 308363 */   // Label 6164: @308363
     /* 308363 */   GIM_Reject,
     /* 308364 */ // Label 6159: @308364
     /* 308364 */ GIM_Reject,
     /* 308365 */ // Label 6114: @308365
     /* 308365 */ GIM_Try, /*On fail goto*//*Label 6165*/ GIMT_Encode4(308706),
     /* 308370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 308373 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 308376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308380 */   GIM_Try, /*On fail goto*//*Label 6166*/ GIMT_Encode4(308466), // Rule ID 13527 //
     /* 308385 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308388 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308392 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308396 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308400 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308404 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308408 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308412 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308421 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308425 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308429 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308433 */     // MIs[3] Operand 1
     /* 308433 */     // No operand predicates
     /* 308433 */     // MIs[1] Operand 2
     /* 308433 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308444 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308448 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308450 */     // (fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308450 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308453 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308455 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308464 */     GIR_RootConstrainSelectedInstOperands,
     /* 308465 */     // GIR_Coverage, 13527,
     /* 308465 */     GIR_EraseRootFromParent_Done,
     /* 308466 */   // Label 6166: @308466
     /* 308466 */   GIM_Try, /*On fail goto*//*Label 6167*/ GIMT_Encode4(308552), // Rule ID 1999 //
     /* 308471 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308474 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308478 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308482 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 308486 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 308494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308498 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308502 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 308506 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308511 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 308515 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308519 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308523 */     // MIs[3] Operand 1
     /* 308523 */     // No operand predicates
     /* 308523 */     // MIs[1] Operand 2
     /* 308523 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 308534 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 308536 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308536 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308539 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308541 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308543 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 308547 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 308550 */     GIR_RootConstrainSelectedInstOperands,
     /* 308551 */     // GIR_Coverage, 1999,
     /* 308551 */     GIR_EraseRootFromParent_Done,
     /* 308552 */   // Label 6167: @308552
     /* 308552 */   GIM_Try, /*On fail goto*//*Label 6168*/ GIMT_Encode4(308615), // Rule ID 13528 //
     /* 308557 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308560 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308564 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308568 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308572 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308589 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308593 */     // MIs[2] Operand 1
     /* 308593 */     // No operand predicates
     /* 308593 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308599 */     // (fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308604 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308610 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308613 */     GIR_RootConstrainSelectedInstOperands,
     /* 308614 */     // GIR_Coverage, 13528,
     /* 308614 */     GIR_EraseRootFromParent_Done,
     /* 308615 */   // Label 6168: @308615
     /* 308615 */   GIM_Try, /*On fail goto*//*Label 6169*/ GIMT_Encode4(308678), // Rule ID 2000 //
     /* 308620 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308623 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 308635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 308639 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308643 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 308648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308656 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 308660 */     // MIs[2] Operand 1
     /* 308660 */     // No operand predicates
     /* 308660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308662 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308662 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 308665 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308667 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308669 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308673 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308676 */     GIR_RootConstrainSelectedInstOperands,
     /* 308677 */     // GIR_Coverage, 2000,
     /* 308677 */     GIR_EraseRootFromParent_Done,
     /* 308678 */   // Label 6169: @308678
     /* 308678 */   GIM_Try, /*On fail goto*//*Label 6170*/ GIMT_Encode4(308705), // Rule ID 1319 //
     /* 308683 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 308686 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308690 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 308694 */     // (fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 308694 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 308699 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 308703 */     GIR_RootConstrainSelectedInstOperands,
     /* 308704 */     // GIR_Coverage, 1319,
     /* 308704 */     GIR_Done,
     /* 308705 */   // Label 6170: @308705
     /* 308705 */   GIM_Reject,
     /* 308706 */ // Label 6165: @308706
     /* 308706 */ GIM_Reject,
     /* 308707 */ // Label 6115: @308707
     /* 308707 */ GIM_Try, /*On fail goto*//*Label 6171*/ GIMT_Encode4(309064),
     /* 308712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308715 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 308718 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308722 */   GIM_Try, /*On fail goto*//*Label 6172*/ GIMT_Encode4(308785), // Rule ID 13536 //
     /* 308727 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308730 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308734 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308738 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308742 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308746 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308759 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308763 */     // MIs[2] Operand 1
     /* 308763 */     // No operand predicates
     /* 308763 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308767 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308769 */     // (fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308774 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308776 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308780 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308783 */     GIR_RootConstrainSelectedInstOperands,
     /* 308784 */     // GIR_Coverage, 13536,
     /* 308784 */     GIR_EraseRootFromParent_Done,
     /* 308785 */   // Label 6172: @308785
     /* 308785 */   GIM_Try, /*On fail goto*//*Label 6173*/ GIMT_Encode4(308848), // Rule ID 2008 //
     /* 308790 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 308793 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308797 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308801 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 308805 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 308809 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 308813 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 308822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 308826 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 308830 */     // MIs[2] Operand 1
     /* 308830 */     // No operand predicates
     /* 308830 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 308832 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 308832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308837 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 308839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 308846 */     GIR_RootConstrainSelectedInstOperands,
     /* 308847 */     // GIR_Coverage, 2008,
     /* 308847 */     GIR_EraseRootFromParent_Done,
     /* 308848 */   // Label 6173: @308848
     /* 308848 */   GIM_Try, /*On fail goto*//*Label 6174*/ GIMT_Encode4(308942), // Rule ID 14005 //
     /* 308853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 308857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308874 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308876 */     // (fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308876 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308879 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308883 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308888 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308890 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308893 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308897 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308902 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308905 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 308909 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 308912 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 308930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 308932 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 308934 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 308937 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 308940 */     GIR_RootConstrainSelectedInstOperands,
     /* 308941 */     // GIR_Coverage, 14005,
     /* 308941 */     GIR_EraseRootFromParent_Done,
     /* 308942 */   // Label 6174: @308942
     /* 308942 */   GIM_Try, /*On fail goto*//*Label 6175*/ GIMT_Encode4(309036), // Rule ID 6289 //
     /* 308947 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 308951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 308955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 308959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 308963 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 308968 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 308970 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 308970 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 308973 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 308977 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308982 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 308984 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 308987 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 308991 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 308996 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 308999 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309003 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 309006 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309011 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309016 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 309021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 309024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309026 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309028 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309031 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 309034 */     GIR_RootConstrainSelectedInstOperands,
     /* 309035 */     // GIR_Coverage, 6289,
     /* 309035 */     GIR_EraseRootFromParent_Done,
     /* 309036 */   // Label 6175: @309036
     /* 309036 */   GIM_Try, /*On fail goto*//*Label 6176*/ GIMT_Encode4(309063), // Rule ID 1325 //
     /* 309041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 309044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309052 */     // (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 309052 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309057 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309061 */     GIR_RootConstrainSelectedInstOperands,
     /* 309062 */     // GIR_Coverage, 1325,
     /* 309062 */     GIR_Done,
     /* 309063 */   // Label 6176: @309063
     /* 309063 */   GIM_Reject,
     /* 309064 */ // Label 6171: @309064
     /* 309064 */ GIM_Reject,
     /* 309065 */ // Label 6116: @309065
     /* 309065 */ GIM_Try, /*On fail goto*//*Label 6177*/ GIMT_Encode4(309496),
     /* 309070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309073 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 309076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309080 */   GIM_Try, /*On fail goto*//*Label 6178*/ GIMT_Encode4(309143), // Rule ID 13530 //
     /* 309085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309121 */     // MIs[2] Operand 1
     /* 309121 */     // No operand predicates
     /* 309121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309125 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309127 */     // (fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 309134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309141 */     GIR_RootConstrainSelectedInstOperands,
     /* 309142 */     // GIR_Coverage, 13530,
     /* 309142 */     GIR_EraseRootFromParent_Done,
     /* 309143 */   // Label 6178: @309143
     /* 309143 */   GIM_Try, /*On fail goto*//*Label 6179*/ GIMT_Encode4(309206), // Rule ID 2002 //
     /* 309148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 309159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 309163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309167 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309171 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 309176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 309180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 309184 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 309188 */     // MIs[2] Operand 1
     /* 309188 */     // No operand predicates
     /* 309188 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 309190 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 309190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 309193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309195 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 309197 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 309201 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 309204 */     GIR_RootConstrainSelectedInstOperands,
     /* 309205 */     // GIR_Coverage, 2002,
     /* 309205 */     GIR_EraseRootFromParent_Done,
     /* 309206 */   // Label 6179: @309206
     /* 309206 */   GIM_Try, /*On fail goto*//*Label 6180*/ GIMT_Encode4(309233), // Rule ID 1321 //
     /* 309211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 309214 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309218 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309222 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 309222 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 309227 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 309231 */     GIR_RootConstrainSelectedInstOperands,
     /* 309232 */     // GIR_Coverage, 1321,
     /* 309232 */     GIR_Done,
     /* 309233 */   // Label 6180: @309233
     /* 309233 */   GIM_Try, /*On fail goto*//*Label 6181*/ GIMT_Encode4(309495), // Rule ID 7046 //
     /* 309238 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 309241 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309245 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309249 */     // (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 309249 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 309252 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309256 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309261 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 309265 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 309267 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 309270 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 309274 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309279 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 309283 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 309285 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 309288 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309292 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309297 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 309300 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 309303 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 309305 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 309308 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309312 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309317 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 309323 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309328 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309333 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 309336 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309340 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309345 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 309348 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 309350 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 309353 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309357 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309362 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 309368 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309373 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309378 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 309381 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 309385 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309390 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 309393 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 309395 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 309398 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 309402 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309407 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 309410 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 309413 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 309415 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 309418 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 309422 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309427 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 309430 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 309432 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 309435 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 309439 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309444 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 309446 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 309449 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 309453 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309458 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 309461 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 309464 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 309467 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309472 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 309482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 309485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 309487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309490 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 309493 */     GIR_RootConstrainSelectedInstOperands,
     /* 309494 */     // GIR_Coverage, 7046,
     /* 309494 */     GIR_EraseRootFromParent_Done,
     /* 309495 */   // Label 6181: @309495
     /* 309495 */   GIM_Reject,
     /* 309496 */ // Label 6177: @309496
     /* 309496 */ GIM_Reject,
     /* 309497 */ // Label 6117: @309497
     /* 309497 */ GIM_Try, /*On fail goto*//*Label 6182*/ GIMT_Encode4(309522), // Rule ID 8254 //
     /* 309502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 309508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 309511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309515 */   // (fmul:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (FMUL_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 309515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_D),
     /* 309520 */   GIR_RootConstrainSelectedInstOperands,
     /* 309521 */   // GIR_Coverage, 8254,
     /* 309521 */   GIR_Done,
     /* 309522 */ // Label 6182: @309522
     /* 309522 */ GIM_Reject,
     /* 309523 */ // Label 6118: @309523
     /* 309523 */ GIM_Try, /*On fail goto*//*Label 6183*/ GIMT_Encode4(309548), // Rule ID 8252 //
     /* 309528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 309534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 309537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309541 */   // (fmul:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (FMUL_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 309541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_S),
     /* 309546 */   GIR_RootConstrainSelectedInstOperands,
     /* 309547 */   // GIR_Coverage, 8252,
     /* 309547 */   GIR_Done,
     /* 309548 */ // Label 6183: @309548
     /* 309548 */ GIM_Reject,
     /* 309549 */ // Label 6119: @309549
     /* 309549 */ GIM_Try, /*On fail goto*//*Label 6184*/ GIMT_Encode4(309574), // Rule ID 8250 //
     /* 309554 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 309557 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 309560 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 309563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 309567 */   // (fmul:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (FMUL_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 309567 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMUL_ZZZ_H),
     /* 309572 */   GIR_RootConstrainSelectedInstOperands,
     /* 309573 */   // GIR_Coverage, 8250,
     /* 309573 */   GIR_Done,
     /* 309574 */ // Label 6184: @309574
     /* 309574 */ GIM_Reject,
     /* 309575 */ // Label 6120: @309575
     /* 309575 */ GIM_Reject,
     /* 309576 */ // Label 62: @309576
     /* 309576 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6193*/ GIMT_Encode4(325848),
     /* 309587 */ /*GILLT_s16*//*Label 6185*/ GIMT_Encode4(309627),
     /* 309591 */ /*GILLT_s32*//*Label 6186*/ GIMT_Encode4(312631),
     /* 309595 */ /*GILLT_s64*//*Label 6187*/ GIMT_Encode4(315779), GIMT_Encode4(0),
     /* 309603 */ /*GILLT_v2s32*//*Label 6188*/ GIMT_Encode4(318927),
     /* 309607 */ /*GILLT_v2s64*//*Label 6189*/ GIMT_Encode4(320448),
     /* 309611 */ /*GILLT_v4s16*//*Label 6190*/ GIMT_Encode4(321969),
     /* 309615 */ /*GILLT_v4s32*//*Label 6191*/ GIMT_Encode4(323148), GIMT_Encode4(0),
     /* 309623 */ /*GILLT_v8s16*//*Label 6192*/ GIMT_Encode4(324669),
     /* 309627 */ // Label 6185: @309627
     /* 309627 */ GIM_Try, /*On fail goto*//*Label 6194*/ GIMT_Encode4(312630),
     /* 309632 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 309635 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 309638 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 309641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309645 */   GIM_Try, /*On fail goto*//*Label 6195*/ GIMT_Encode4(309795), // Rule ID 4900 //
     /* 309650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309674 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309678 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309682 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309686 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309690 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309694 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309699 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 309707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309711 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 309715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309720 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309722 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309722 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309725 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309729 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309734 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309740 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309745 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309750 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309753 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309757 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309762 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309768 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 309781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309783 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 309793 */     GIR_RootConstrainSelectedInstOperands,
     /* 309794 */     // GIR_Coverage, 4900,
     /* 309794 */     GIR_EraseRootFromParent_Done,
     /* 309795 */   // Label 6195: @309795
     /* 309795 */   GIM_Try, /*On fail goto*//*Label 6196*/ GIMT_Encode4(309942), // Rule ID 4864 //
     /* 309800 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309803 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309807 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309811 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309815 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 309819 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309824 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 309828 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 309832 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309836 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 309840 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 309844 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309848 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309852 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 309856 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309861 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 309865 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309869 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 309871 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 309871 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 309874 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309878 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309883 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 309889 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309894 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309899 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 309902 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 309906 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 309911 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 309917 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 309922 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 309930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 309932 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 309935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 309938 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 309940 */     GIR_RootConstrainSelectedInstOperands,
     /* 309941 */     // GIR_Coverage, 4864,
     /* 309941 */     GIR_EraseRootFromParent_Done,
     /* 309942 */   // Label 6196: @309942
     /* 309942 */   GIM_Try, /*On fail goto*//*Label 6197*/ GIMT_Encode4(310089), // Rule ID 13944 //
     /* 309947 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 309950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 309954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 309958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 309962 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 309966 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309970 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309974 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 309978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 309983 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 309987 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 309991 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 309995 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 309999 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310003 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310008 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310012 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310016 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310018 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310018 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310021 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310025 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310030 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310036 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 310077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310082 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310085 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310087 */     GIR_RootConstrainSelectedInstOperands,
     /* 310088 */     // GIR_Coverage, 13944,
     /* 310088 */     GIR_EraseRootFromParent_Done,
     /* 310089 */   // Label 6197: @310089
     /* 310089 */   GIM_Try, /*On fail goto*//*Label 6198*/ GIMT_Encode4(310220), // Rule ID 6119 //
     /* 310094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 310134 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 310138 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310142 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310146 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310150 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310155 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 310159 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310163 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310167 */     // MIs[4] Operand 1
     /* 310167 */     // No operand predicates
     /* 310167 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310171 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310173 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310185 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310191 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310196 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310206 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310208 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310211 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 310215 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 310218 */     GIR_RootConstrainSelectedInstOperands,
     /* 310219 */     // GIR_Coverage, 6119,
     /* 310219 */     GIR_EraseRootFromParent_Done,
     /* 310220 */   // Label 6198: @310220
     /* 310220 */   GIM_Try, /*On fail goto*//*Label 6199*/ GIMT_Encode4(310351), // Rule ID 6151 //
     /* 310225 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310228 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310232 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310236 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310240 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310249 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310253 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310257 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310261 */     // MIs[2] Operand 1
     /* 310261 */     // No operand predicates
     /* 310261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310269 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 310273 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 310277 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310281 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310285 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 310289 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310294 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 310298 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310302 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310304 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310304 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310307 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310311 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310316 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310327 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310346 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310349 */     GIR_RootConstrainSelectedInstOperands,
     /* 310350 */     // GIR_Coverage, 6151,
     /* 310350 */     GIR_EraseRootFromParent_Done,
     /* 310351 */   // Label 6199: @310351
     /* 310351 */   GIM_Try, /*On fail goto*//*Label 6200*/ GIMT_Encode4(310482), // Rule ID 6215 //
     /* 310356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310359 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310363 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310367 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310371 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310375 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310379 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310383 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310392 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310396 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310400 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310404 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310408 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310412 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310417 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 310421 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310425 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310429 */     // MIs[4] Operand 1
     /* 310429 */     // No operand predicates
     /* 310429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310433 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310435 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310435 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310438 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310442 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310447 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310458 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310468 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 310477 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 310480 */     GIR_RootConstrainSelectedInstOperands,
     /* 310481 */     // GIR_Coverage, 6215,
     /* 310481 */     GIR_EraseRootFromParent_Done,
     /* 310482 */   // Label 6200: @310482
     /* 310482 */   GIM_Try, /*On fail goto*//*Label 6201*/ GIMT_Encode4(310613), // Rule ID 6183 //
     /* 310487 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 310498 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 310502 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 310506 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310510 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310514 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310518 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310523 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310527 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310531 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310535 */     // MIs[3] Operand 1
     /* 310535 */     // No operand predicates
     /* 310535 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 310539 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310543 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310547 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 310551 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310556 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 310560 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310564 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 310566 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310566 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310569 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310573 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310578 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310584 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310589 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 310597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310599 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310601 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310604 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310611 */     GIR_RootConstrainSelectedInstOperands,
     /* 310612 */     // GIR_Coverage, 6183,
     /* 310612 */     GIR_EraseRootFromParent_Done,
     /* 310613 */   // Label 6201: @310613
     /* 310613 */   GIM_Try, /*On fail goto*//*Label 6202*/ GIMT_Encode4(310748), // Rule ID 2459 //
     /* 310618 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310629 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310633 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310637 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310642 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310654 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310658 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310662 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310667 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 310671 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310675 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 310677 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 310677 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 310680 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310684 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310689 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 310695 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310700 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310717 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 310736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 310738 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 310744 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 310746 */     GIR_RootConstrainSelectedInstOperands,
     /* 310747 */     // GIR_Coverage, 2459,
     /* 310747 */     GIR_EraseRootFromParent_Done,
     /* 310748 */   // Label 6202: @310748
     /* 310748 */   GIM_Try, /*On fail goto*//*Label 6203*/ GIMT_Encode4(310867), // Rule ID 6087 //
     /* 310753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310777 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 310781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 310785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 310797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310802 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 310806 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310810 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310814 */     // MIs[3] Operand 1
     /* 310814 */     // No operand predicates
     /* 310814 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310820 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310820 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310823 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310827 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310832 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310838 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310843 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310848 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310851 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310853 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310855 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310858 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 310862 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 310865 */     GIR_RootConstrainSelectedInstOperands,
     /* 310866 */     // GIR_Coverage, 6087,
     /* 310866 */     GIR_EraseRootFromParent_Done,
     /* 310867 */   // Label 6203: @310867
     /* 310867 */   GIM_Try, /*On fail goto*//*Label 6204*/ GIMT_Encode4(310986), // Rule ID 2534 //
     /* 310872 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 310875 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310879 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310883 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310887 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 310891 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 310896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 310900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 310904 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 310908 */     // MIs[2] Operand 1
     /* 310908 */     // No operand predicates
     /* 310908 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 310912 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 310916 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 310920 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 310924 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310929 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 310933 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 310939 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 310939 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 310942 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 310946 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 310951 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 310957 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 310962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 310967 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 310970 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 310972 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 310974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 310977 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 310981 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 310984 */     GIR_RootConstrainSelectedInstOperands,
     /* 310985 */     // GIR_Coverage, 2534,
     /* 310985 */     GIR_EraseRootFromParent_Done,
     /* 310986 */   // Label 6204: @310986
     /* 310986 */   GIM_Try, /*On fail goto*//*Label 6205*/ GIMT_Encode4(311086), // Rule ID 4862 //
     /* 310991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 310994 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 310998 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311002 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311006 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311010 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311015 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311027 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311031 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311040 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311042 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311078 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311082 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311084 */     GIR_RootConstrainSelectedInstOperands,
     /* 311085 */     // GIR_Coverage, 4862,
     /* 311085 */     GIR_EraseRootFromParent_Done,
     /* 311086 */   // Label 6205: @311086
     /* 311086 */   GIM_Try, /*On fail goto*//*Label 6206*/ GIMT_Encode4(311186), // Rule ID 4898 //
     /* 311091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311094 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311098 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311102 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311106 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311115 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311123 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311127 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311131 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311135 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311140 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311142 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311178 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311180 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311184 */     GIR_RootConstrainSelectedInstOperands,
     /* 311185 */     // GIR_Coverage, 4898,
     /* 311185 */     GIR_EraseRootFromParent_Done,
     /* 311186 */   // Label 6206: @311186
     /* 311186 */   GIM_Try, /*On fail goto*//*Label 6207*/ GIMT_Encode4(311283), // Rule ID 13940 //
     /* 311191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311206 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311210 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311214 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311218 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311227 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311231 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311235 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311239 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311241 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311253 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311259 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311279 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311281 */     GIR_RootConstrainSelectedInstOperands,
     /* 311282 */     // GIR_Coverage, 13940,
     /* 311282 */     GIR_EraseRootFromParent_Done,
     /* 311283 */   // Label 6207: @311283
     /* 311283 */   GIM_Try, /*On fail goto*//*Label 6208*/ GIMT_Encode4(311383), // Rule ID 13942 //
     /* 311288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311316 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311320 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311329 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311333 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311339 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311339 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311342 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311346 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311351 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311357 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311372 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311375 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311381 */     GIR_RootConstrainSelectedInstOperands,
     /* 311382 */     // GIR_Coverage, 13942,
     /* 311382 */     GIR_EraseRootFromParent_Done,
     /* 311383 */   // Label 6208: @311383
     /* 311383 */   GIM_Try, /*On fail goto*//*Label 6209*/ GIMT_Encode4(311483), // Rule ID 4896 //
     /* 311388 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311391 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311395 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311399 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311403 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311407 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311411 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311416 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311420 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 311424 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311428 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 311432 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311439 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 311470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311472 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 311481 */     GIR_RootConstrainSelectedInstOperands,
     /* 311482 */     // GIR_Coverage, 4896,
     /* 311482 */     GIR_EraseRootFromParent_Done,
     /* 311483 */   // Label 6209: @311483
     /* 311483 */   GIM_Try, /*On fail goto*//*Label 6210*/ GIMT_Encode4(311580), // Rule ID 4860 //
     /* 311488 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311491 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311495 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311499 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311503 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311507 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311511 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311515 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311519 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311523 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311528 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 311532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311536 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 311538 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 311538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 311556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 311569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311571 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311578 */     GIR_RootConstrainSelectedInstOperands,
     /* 311579 */     // GIR_Coverage, 4860,
     /* 311579 */     GIR_EraseRootFromParent_Done,
     /* 311580 */   // Label 6210: @311580
     /* 311580 */   GIM_Try, /*On fail goto*//*Label 6211*/ GIMT_Encode4(311664), // Rule ID 6149 //
     /* 311585 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311588 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311592 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311596 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311600 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311604 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 311613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311617 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311621 */     // MIs[2] Operand 1
     /* 311621 */     // No operand predicates
     /* 311621 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 311625 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311629 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 311633 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311644 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311651 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 311655 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 311659 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 311662 */     GIR_RootConstrainSelectedInstOperands,
     /* 311663 */     // GIR_Coverage, 6149,
     /* 311663 */     GIR_EraseRootFromParent_Done,
     /* 311664 */   // Label 6211: @311664
     /* 311664 */   GIM_Try, /*On fail goto*//*Label 6212*/ GIMT_Encode4(311745), // Rule ID 6181 //
     /* 311669 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311680 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311692 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311696 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311700 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311705 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311709 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311713 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311717 */     // MIs[3] Operand 1
     /* 311717 */     // No operand predicates
     /* 311717 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311721 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311725 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311727 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311732 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311734 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 311736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311743 */     GIR_RootConstrainSelectedInstOperands,
     /* 311744 */     // GIR_Coverage, 6181,
     /* 311744 */     GIR_EraseRootFromParent_Done,
     /* 311745 */   // Label 6212: @311745
     /* 311745 */   GIM_Try, /*On fail goto*//*Label 6213*/ GIMT_Encode4(311829), // Rule ID 6213 //
     /* 311750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311765 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311770 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 311774 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311778 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311782 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311786 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311791 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311795 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311799 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311803 */     // MIs[3] Operand 1
     /* 311803 */     // No operand predicates
     /* 311803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311809 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 311820 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311824 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311827 */     GIR_RootConstrainSelectedInstOperands,
     /* 311828 */     // GIR_Coverage, 6213,
     /* 311828 */     GIR_EraseRootFromParent_Done,
     /* 311829 */   // Label 6213: @311829
     /* 311829 */   GIM_Try, /*On fail goto*//*Label 6214*/ GIMT_Encode4(311910), // Rule ID 6117 //
     /* 311834 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 311837 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311841 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 311845 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 311849 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 311853 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 311857 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311861 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311865 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 311869 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 311874 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 311878 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 311882 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 311886 */     // MIs[3] Operand 1
     /* 311886 */     // No operand predicates
     /* 311886 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311890 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 311892 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 311892 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 311895 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 311897 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 311899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 311901 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 311905 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 311908 */     GIR_RootConstrainSelectedInstOperands,
     /* 311909 */     // GIR_Coverage, 6117,
     /* 311909 */     GIR_EraseRootFromParent_Done,
     /* 311910 */   // Label 6214: @311910
     /* 311910 */   GIM_Try, /*On fail goto*//*Label 6215*/ GIMT_Encode4(311995), // Rule ID 2457 //
     /* 311915 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 311918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 311922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 311926 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 311930 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 311934 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311939 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 311943 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311947 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311951 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 311953 */     // (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 311953 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 311956 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 311960 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 311965 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 311971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 311976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 311981 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 311984 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 311986 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 311989 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 311991 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 311993 */     GIR_RootConstrainSelectedInstOperands,
     /* 311994 */     // GIR_Coverage, 2457,
     /* 311994 */     GIR_EraseRootFromParent_Done,
     /* 311995 */   // Label 6215: @311995
     /* 311995 */   GIM_Try, /*On fail goto*//*Label 6216*/ GIMT_Encode4(312080), // Rule ID 2455 //
     /* 312000 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312003 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312007 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312011 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312015 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312019 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312023 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312028 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312038 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 312038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 312041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312050 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 312056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312061 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312066 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312069 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312071 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312073 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312078 */     GIR_RootConstrainSelectedInstOperands,
     /* 312079 */     // GIR_Coverage, 2455,
     /* 312079 */     GIR_EraseRootFromParent_Done,
     /* 312080 */   // Label 6216: @312080
     /* 312080 */   GIM_Try, /*On fail goto*//*Label 6217*/ GIMT_Encode4(312149), // Rule ID 2532 //
     /* 312085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312121 */     // MIs[2] Operand 1
     /* 312121 */     // No operand predicates
     /* 312121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312125 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312131 */     // (fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312131 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312134 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312136 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312138 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312147 */     GIR_RootConstrainSelectedInstOperands,
     /* 312148 */     // GIR_Coverage, 2532,
     /* 312148 */     GIR_EraseRootFromParent_Done,
     /* 312149 */   // Label 6217: @312149
     /* 312149 */   GIM_Try, /*On fail goto*//*Label 6218*/ GIMT_Encode4(312218), // Rule ID 6085 //
     /* 312154 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312157 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312161 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312165 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312169 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 312173 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312177 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 312182 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 312186 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 312190 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 312194 */     // MIs[2] Operand 1
     /* 312194 */     // No operand predicates
     /* 312194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312198 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312200 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 312200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 312203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 312205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 312207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 312216 */     GIR_RootConstrainSelectedInstOperands,
     /* 312217 */     // GIR_Coverage, 6085,
     /* 312217 */     GIR_EraseRootFromParent_Done,
     /* 312218 */   // Label 6218: @312218
     /* 312218 */   GIM_Try, /*On fail goto*//*Label 6219*/ GIMT_Encode4(312283), // Rule ID 4916 //
     /* 312223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312238 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312243 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312247 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312251 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312255 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312266 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312271 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312275 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312277 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312281 */     GIR_RootConstrainSelectedInstOperands,
     /* 312282 */     // GIR_Coverage, 4916,
     /* 312282 */     GIR_EraseRootFromParent_Done,
     /* 312283 */   // Label 6219: @312283
     /* 312283 */   GIM_Try, /*On fail goto*//*Label 6220*/ GIMT_Encode4(312348), // Rule ID 13960 //
     /* 312288 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312291 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 312316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 312324 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312329 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 312331 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 312334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312336 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312340 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 312342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 312346 */     GIR_RootConstrainSelectedInstOperands,
     /* 312347 */     // GIR_Coverage, 13960,
     /* 312347 */     GIR_EraseRootFromParent_Done,
     /* 312348 */   // Label 6220: @312348
     /* 312348 */   GIM_Try, /*On fail goto*//*Label 6221*/ GIMT_Encode4(312398), // Rule ID 4913 //
     /* 312353 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312356 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312360 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312364 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312368 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312373 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312377 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312383 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312388 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312392 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312394 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312396 */     GIR_RootConstrainSelectedInstOperands,
     /* 312397 */     // GIR_Coverage, 4913,
     /* 312397 */     GIR_EraseRootFromParent_Done,
     /* 312398 */   // Label 6221: @312398
     /* 312398 */   GIM_Try, /*On fail goto*//*Label 6222*/ GIMT_Encode4(312448), // Rule ID 13376 //
     /* 312403 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312410 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312414 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312418 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312423 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312431 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312433 */     // (fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312438 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 312440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312446 */     GIR_RootConstrainSelectedInstOperands,
     /* 312447 */     // GIR_Coverage, 13376,
     /* 312447 */     GIR_EraseRootFromParent_Done,
     /* 312448 */   // Label 6222: @312448
     /* 312448 */   GIM_Try, /*On fail goto*//*Label 6223*/ GIMT_Encode4(312498), // Rule ID 644 //
     /* 312453 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312456 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312472 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312477 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312481 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312483 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312488 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 312494 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312496 */     GIR_RootConstrainSelectedInstOperands,
     /* 312497 */     // GIR_Coverage, 644,
     /* 312497 */     GIR_EraseRootFromParent_Done,
     /* 312498 */   // Label 6223: @312498
     /* 312498 */   GIM_Try, /*On fail goto*//*Label 6224*/ GIMT_Encode4(312548), // Rule ID 13957 //
     /* 312503 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 312506 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312510 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 312514 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312518 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312522 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312533 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 312536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 312542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 312544 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312546 */     GIR_RootConstrainSelectedInstOperands,
     /* 312547 */     // GIR_Coverage, 13957,
     /* 312547 */     GIR_EraseRootFromParent_Done,
     /* 312548 */   // Label 6224: @312548
     /* 312548 */   GIM_Try, /*On fail goto*//*Label 6225*/ GIMT_Encode4(312598), // Rule ID 656 //
     /* 312553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312556 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312560 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312564 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 312568 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312572 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 312576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312581 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 312583 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 312586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312588 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 312590 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 312592 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 312596 */     GIR_RootConstrainSelectedInstOperands,
     /* 312597 */     // GIR_Coverage, 656,
     /* 312597 */     GIR_EraseRootFromParent_Done,
     /* 312598 */   // Label 6225: @312598
     /* 312598 */   GIM_Try, /*On fail goto*//*Label 6226*/ GIMT_Encode4(312629), // Rule ID 638 //
     /* 312603 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 312606 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312610 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312614 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 312618 */     // (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 312618 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 312623 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 312627 */     GIR_RootConstrainSelectedInstOperands,
     /* 312628 */     // GIR_Coverage, 638,
     /* 312628 */     GIR_Done,
     /* 312629 */   // Label 6226: @312629
     /* 312629 */   GIM_Reject,
     /* 312630 */ // Label 6194: @312630
     /* 312630 */ GIM_Reject,
     /* 312631 */ // Label 6186: @312631
     /* 312631 */ GIM_Try, /*On fail goto*//*Label 6227*/ GIMT_Encode4(315778),
     /* 312636 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 312639 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 312642 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 312645 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312649 */   GIM_Try, /*On fail goto*//*Label 6228*/ GIMT_Encode4(312799), // Rule ID 4906 //
     /* 312654 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312657 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312661 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312665 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312669 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312673 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312678 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312703 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312707 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 312711 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312715 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 312719 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312726 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312726 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312729 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312733 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312738 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312744 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312749 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312766 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312772 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 312785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312787 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312790 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 312797 */     GIR_RootConstrainSelectedInstOperands,
     /* 312798 */     // GIR_Coverage, 4906,
     /* 312798 */     GIR_EraseRootFromParent_Done,
     /* 312799 */   // Label 6228: @312799
     /* 312799 */   GIM_Try, /*On fail goto*//*Label 6229*/ GIMT_Encode4(312946), // Rule ID 4870 //
     /* 312804 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312807 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312811 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312815 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312819 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 312823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312828 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 312832 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 312836 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312840 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 312844 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 312848 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312852 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312856 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 312860 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312865 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 312869 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312873 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 312875 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 312875 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 312878 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312882 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312887 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 312893 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312898 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312903 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 312906 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 312910 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 312915 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 312921 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 312926 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312931 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 312934 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 312936 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 312939 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 312942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 312944 */     GIR_RootConstrainSelectedInstOperands,
     /* 312945 */     // GIR_Coverage, 4870,
     /* 312945 */     GIR_EraseRootFromParent_Done,
     /* 312946 */   // Label 6229: @312946
     /* 312946 */   GIM_Try, /*On fail goto*//*Label 6230*/ GIMT_Encode4(313093), // Rule ID 13950 //
     /* 312951 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 312954 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 312958 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 312962 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 312966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 312970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 312978 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 312982 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 312987 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 312991 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 312995 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 312999 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313003 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313007 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313012 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313016 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313020 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313022 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313022 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313025 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313029 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313034 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313040 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313045 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 313081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313086 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313089 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313091 */     GIR_RootConstrainSelectedInstOperands,
     /* 313092 */     // GIR_Coverage, 13950,
     /* 313092 */     GIR_EraseRootFromParent_Done,
     /* 313093 */   // Label 6230: @313093
     /* 313093 */   GIM_Try, /*On fail goto*//*Label 6231*/ GIMT_Encode4(313224), // Rule ID 6135 //
     /* 313098 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313117 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313122 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313134 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 313138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 313142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313146 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313150 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313154 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313159 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 313163 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313167 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313171 */     // MIs[4] Operand 1
     /* 313171 */     // No operand predicates
     /* 313171 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313175 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313177 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313177 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313180 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313184 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313189 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313195 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313200 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313205 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313208 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313210 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313212 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 313219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 313222 */     GIR_RootConstrainSelectedInstOperands,
     /* 313223 */     // GIR_Coverage, 6135,
     /* 313223 */     GIR_EraseRootFromParent_Done,
     /* 313224 */   // Label 6231: @313224
     /* 313224 */   GIM_Try, /*On fail goto*//*Label 6232*/ GIMT_Encode4(313355), // Rule ID 6167 //
     /* 313229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313261 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313265 */     // MIs[2] Operand 1
     /* 313265 */     // No operand predicates
     /* 313265 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313269 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313273 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 313277 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 313281 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313285 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313289 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 313293 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313298 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 313302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313306 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313308 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313308 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313311 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313315 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313320 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313326 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313331 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313341 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313343 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313353 */     GIR_RootConstrainSelectedInstOperands,
     /* 313354 */     // GIR_Coverage, 6167,
     /* 313354 */     GIR_EraseRootFromParent_Done,
     /* 313355 */   // Label 6232: @313355
     /* 313355 */   GIM_Try, /*On fail goto*//*Label 6233*/ GIMT_Encode4(313486), // Rule ID 6231 //
     /* 313360 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313363 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313367 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313371 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313387 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313391 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313396 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313408 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313412 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313416 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313421 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 313425 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313429 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313433 */     // MIs[4] Operand 1
     /* 313433 */     // No operand predicates
     /* 313433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313437 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313439 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313451 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313457 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313462 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313467 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313470 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313472 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313474 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313477 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 313481 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 313484 */     GIR_RootConstrainSelectedInstOperands,
     /* 313485 */     // GIR_Coverage, 6231,
     /* 313485 */     GIR_EraseRootFromParent_Done,
     /* 313486 */   // Label 6233: @313486
     /* 313486 */   GIM_Try, /*On fail goto*//*Label 6234*/ GIMT_Encode4(313617), // Rule ID 6199 //
     /* 313491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313498 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 313502 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 313506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 313510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313514 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313518 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313535 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313539 */     // MIs[3] Operand 1
     /* 313539 */     // No operand predicates
     /* 313539 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 313543 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313547 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313551 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 313555 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313560 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 313564 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313568 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 313570 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313570 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313573 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313577 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313582 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313588 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313598 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 313601 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313603 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313605 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313608 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313612 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313615 */     GIR_RootConstrainSelectedInstOperands,
     /* 313616 */     // GIR_Coverage, 6199,
     /* 313616 */     GIR_EraseRootFromParent_Done,
     /* 313617 */   // Label 6234: @313617
     /* 313617 */   GIM_Try, /*On fail goto*//*Label 6235*/ GIMT_Encode4(313752), // Rule ID 2465 //
     /* 313622 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313629 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313633 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313637 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313646 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313671 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 313675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313679 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 313681 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 313681 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 313684 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313688 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313693 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 313699 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313704 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313709 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313712 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313716 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313721 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313727 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 313740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 313742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 313748 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 313750 */     GIR_RootConstrainSelectedInstOperands,
     /* 313751 */     // GIR_Coverage, 2465,
     /* 313751 */     GIR_EraseRootFromParent_Done,
     /* 313752 */   // Label 6235: @313752
     /* 313752 */   GIM_Try, /*On fail goto*//*Label 6236*/ GIMT_Encode4(313871), // Rule ID 6103 //
     /* 313757 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313760 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313764 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313768 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313772 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313776 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313781 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 313785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 313789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 313801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 313810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313818 */     // MIs[3] Operand 1
     /* 313818 */     // No operand predicates
     /* 313818 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313822 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313824 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313836 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313842 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313847 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313852 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313855 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313857 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313859 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 313866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 313869 */     GIR_RootConstrainSelectedInstOperands,
     /* 313870 */     // GIR_Coverage, 6103,
     /* 313870 */     GIR_EraseRootFromParent_Done,
     /* 313871 */   // Label 6236: @313871
     /* 313871 */   GIM_Try, /*On fail goto*//*Label 6237*/ GIMT_Encode4(313990), // Rule ID 2550 //
     /* 313876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 313879 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 313883 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313887 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313891 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 313895 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313900 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 313904 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 313908 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 313912 */     // MIs[2] Operand 1
     /* 313912 */     // No operand predicates
     /* 313912 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 313916 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 313920 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 313924 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 313928 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313933 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 313937 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313941 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 313943 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 313943 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 313946 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 313950 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 313955 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 313961 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 313966 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 313971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 313974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 313976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 313978 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 313981 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 313985 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 313988 */     GIR_RootConstrainSelectedInstOperands,
     /* 313989 */     // GIR_Coverage, 2550,
     /* 313989 */     GIR_EraseRootFromParent_Done,
     /* 313990 */   // Label 6237: @313990
     /* 313990 */   GIM_Try, /*On fail goto*//*Label 6238*/ GIMT_Encode4(314090), // Rule ID 4868 //
     /* 313995 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 313998 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314002 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314006 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314010 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314014 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314019 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314040 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314044 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314046 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314046 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314049 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314053 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314058 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314064 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314074 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314077 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314082 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314088 */     GIR_RootConstrainSelectedInstOperands,
     /* 314089 */     // GIR_Coverage, 4868,
     /* 314089 */     GIR_EraseRootFromParent_Done,
     /* 314090 */   // Label 6238: @314090
     /* 314090 */   GIM_Try, /*On fail goto*//*Label 6239*/ GIMT_Encode4(314190), // Rule ID 4904 //
     /* 314095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314119 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314123 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314139 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314146 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314182 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 314184 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314188 */     GIR_RootConstrainSelectedInstOperands,
     /* 314189 */     // GIR_Coverage, 4904,
     /* 314189 */     GIR_EraseRootFromParent_Done,
     /* 314190 */   // Label 6239: @314190
     /* 314190 */   GIM_Try, /*On fail goto*//*Label 6240*/ GIMT_Encode4(314287), // Rule ID 13946 //
     /* 314195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314231 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314245 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314257 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314280 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314283 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314285 */     GIR_RootConstrainSelectedInstOperands,
     /* 314286 */     // GIR_Coverage, 13946,
     /* 314286 */     GIR_EraseRootFromParent_Done,
     /* 314287 */   // Label 6240: @314287
     /* 314287 */   GIM_Try, /*On fail goto*//*Label 6241*/ GIMT_Encode4(314387), // Rule ID 13948 //
     /* 314292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314307 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314312 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314316 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314320 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314324 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314328 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314333 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314337 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314341 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314343 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 314343 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314346 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314350 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314355 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 314361 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314366 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314376 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314379 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314385 */     GIR_RootConstrainSelectedInstOperands,
     /* 314386 */     // GIR_Coverage, 13948,
     /* 314386 */     GIR_EraseRootFromParent_Done,
     /* 314387 */   // Label 6241: @314387
     /* 314387 */   GIM_Try, /*On fail goto*//*Label 6242*/ GIMT_Encode4(314487), // Rule ID 4902 //
     /* 314392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314395 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314399 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314403 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314407 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314411 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314415 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314420 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 314424 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 314428 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314432 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 314436 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314441 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314443 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 314474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 314485 */     GIR_RootConstrainSelectedInstOperands,
     /* 314486 */     // GIR_Coverage, 4902,
     /* 314486 */     GIR_EraseRootFromParent_Done,
     /* 314487 */   // Label 6242: @314487
     /* 314487 */   GIM_Try, /*On fail goto*//*Label 6243*/ GIMT_Encode4(314584), // Rule ID 4866 //
     /* 314492 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 314495 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314499 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314503 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314507 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314519 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314523 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314527 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314532 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 314536 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 314542 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 314542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 314545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 314549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 314554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 314560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 314573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 314575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 314580 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 314582 */     GIR_RootConstrainSelectedInstOperands,
     /* 314583 */     // GIR_Coverage, 4866,
     /* 314583 */     GIR_EraseRootFromParent_Done,
     /* 314584 */   // Label 6243: @314584
     /* 314584 */   GIM_Try, /*On fail goto*//*Label 6244*/ GIMT_Encode4(314662), // Rule ID 6253 //
     /* 314589 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314593 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314597 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314601 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314617 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314622 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 314626 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314630 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314634 */     // MIs[3] Operand 1
     /* 314634 */     // No operand predicates
     /* 314634 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314638 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314642 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314644 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314644 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314647 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314649 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314651 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314653 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314657 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314660 */     GIR_RootConstrainSelectedInstOperands,
     /* 314661 */     // GIR_Coverage, 6253,
     /* 314661 */     GIR_EraseRootFromParent_Done,
     /* 314662 */   // Label 6244: @314662
     /* 314662 */   GIM_Try, /*On fail goto*//*Label 6245*/ GIMT_Encode4(314746), // Rule ID 6165 //
     /* 314667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 314695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314699 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314703 */     // MIs[2] Operand 1
     /* 314703 */     // No operand predicates
     /* 314703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 314707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314711 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 314715 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314720 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314724 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314726 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314726 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314729 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314731 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314733 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 314737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 314741 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 314744 */     GIR_RootConstrainSelectedInstOperands,
     /* 314745 */     // GIR_Coverage, 6165,
     /* 314745 */     GIR_EraseRootFromParent_Done,
     /* 314746 */   // Label 6245: @314746
     /* 314746 */   GIM_Try, /*On fail goto*//*Label 6246*/ GIMT_Encode4(314827), // Rule ID 6197 //
     /* 314751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314754 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314758 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314762 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314766 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314770 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314774 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314778 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314782 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314787 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314791 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314795 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314799 */     // MIs[3] Operand 1
     /* 314799 */     // No operand predicates
     /* 314799 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314803 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314807 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314809 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314814 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314816 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 314818 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314822 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314825 */     GIR_RootConstrainSelectedInstOperands,
     /* 314826 */     // GIR_Coverage, 6197,
     /* 314826 */     GIR_EraseRootFromParent_Done,
     /* 314827 */   // Label 6246: @314827
     /* 314827 */   GIM_Try, /*On fail goto*//*Label 6247*/ GIMT_Encode4(314911), // Rule ID 6229 //
     /* 314832 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 314839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 314847 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314852 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 314856 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314860 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314864 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 314868 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314873 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 314877 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314881 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314885 */     // MIs[3] Operand 1
     /* 314885 */     // No operand predicates
     /* 314885 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314889 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314891 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 314902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314906 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314909 */     GIR_RootConstrainSelectedInstOperands,
     /* 314910 */     // GIR_Coverage, 6229,
     /* 314910 */     GIR_EraseRootFromParent_Done,
     /* 314911 */   // Label 6247: @314911
     /* 314911 */   GIM_Try, /*On fail goto*//*Label 6248*/ GIMT_Encode4(314989), // Rule ID 6275 //
     /* 314916 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 314924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 314928 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314932 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 314936 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 314940 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 314944 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 314948 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 314953 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 314957 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 314961 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 314965 */     // MIs[3] Operand 1
     /* 314965 */     // No operand predicates
     /* 314965 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 314969 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 314971 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 314971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 314974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 314976 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 314978 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 314980 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 314984 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 314987 */     GIR_RootConstrainSelectedInstOperands,
     /* 314988 */     // GIR_Coverage, 6275,
     /* 314988 */     GIR_EraseRootFromParent_Done,
     /* 314989 */   // Label 6248: @314989
     /* 314989 */   GIM_Try, /*On fail goto*//*Label 6249*/ GIMT_Encode4(315070), // Rule ID 6133 //
     /* 314994 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 314997 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 315017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315034 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 315038 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315042 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315046 */     // MIs[3] Operand 1
     /* 315046 */     // No operand predicates
     /* 315046 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315050 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315052 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315052 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 315055 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315057 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315059 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315061 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 315065 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 315068 */     GIR_RootConstrainSelectedInstOperands,
     /* 315069 */     // GIR_Coverage, 6133,
     /* 315069 */     GIR_EraseRootFromParent_Done,
     /* 315070 */   // Label 6249: @315070
     /* 315070 */   GIM_Try, /*On fail goto*//*Label 6250*/ GIMT_Encode4(315155), // Rule ID 2463 //
     /* 315075 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315090 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315094 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315099 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315103 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315107 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315113 */     // (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315113 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315116 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315120 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315125 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 315131 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315151 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315153 */     GIR_RootConstrainSelectedInstOperands,
     /* 315154 */     // GIR_Coverage, 2463,
     /* 315154 */     GIR_EraseRootFromParent_Done,
     /* 315155 */   // Label 6250: @315155
     /* 315155 */   GIM_Try, /*On fail goto*//*Label 6251*/ GIMT_Encode4(315240), // Rule ID 2461 //
     /* 315160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315163 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315167 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315171 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315175 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315179 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315183 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315188 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315192 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315196 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315198 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 315198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 315201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 315216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315231 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315236 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315238 */     GIR_RootConstrainSelectedInstOperands,
     /* 315239 */     // GIR_Coverage, 2461,
     /* 315239 */     GIR_EraseRootFromParent_Done,
     /* 315240 */   // Label 6251: @315240
     /* 315240 */   GIM_Try, /*On fail goto*//*Label 6252*/ GIMT_Encode4(315309), // Rule ID 2548 //
     /* 315245 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315260 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315264 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315269 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315273 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315277 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315281 */     // MIs[2] Operand 1
     /* 315281 */     // No operand predicates
     /* 315281 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315285 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315289 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315291 */     // (fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315296 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315298 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315300 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315304 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315307 */     GIR_RootConstrainSelectedInstOperands,
     /* 315308 */     // GIR_Coverage, 2548,
     /* 315308 */     GIR_EraseRootFromParent_Done,
     /* 315309 */   // Label 6252: @315309
     /* 315309 */   GIM_Try, /*On fail goto*//*Label 6253*/ GIMT_Encode4(315378), // Rule ID 6101 //
     /* 315314 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 315317 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315329 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 315333 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315337 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315342 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 315346 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 315350 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 315354 */     // MIs[2] Operand 1
     /* 315354 */     // No operand predicates
     /* 315354 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315358 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315360 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 315360 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 315363 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 315365 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 315367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315369 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315373 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 315376 */     GIR_RootConstrainSelectedInstOperands,
     /* 315377 */     // GIR_Coverage, 6101,
     /* 315377 */     GIR_EraseRootFromParent_Done,
     /* 315378 */   // Label 6253: @315378
     /* 315378 */   GIM_Try, /*On fail goto*//*Label 6254*/ GIMT_Encode4(315440), // Rule ID 4917 //
     /* 315383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315400 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315412 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315416 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315421 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315423 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 315426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315428 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315432 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315434 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315438 */     GIR_RootConstrainSelectedInstOperands,
     /* 315439 */     // GIR_Coverage, 4917,
     /* 315439 */     GIR_EraseRootFromParent_Done,
     /* 315440 */   // Label 6254: @315440
     /* 315440 */   GIM_Try, /*On fail goto*//*Label 6255*/ GIMT_Encode4(315502), // Rule ID 13961 //
     /* 315445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315461 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315466 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 315470 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315474 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 315478 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 315485 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 315488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315494 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 315496 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 315500 */     GIR_RootConstrainSelectedInstOperands,
     /* 315501 */     // GIR_Coverage, 13961,
     /* 315501 */     GIR_EraseRootFromParent_Done,
     /* 315502 */   // Label 6255: @315502
     /* 315502 */   GIM_Try, /*On fail goto*//*Label 6256*/ GIMT_Encode4(315549), // Rule ID 4914 //
     /* 315507 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315511 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315515 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315519 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315524 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315528 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315532 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315534 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315534 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315537 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315539 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315543 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315545 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315547 */     GIR_RootConstrainSelectedInstOperands,
     /* 315548 */     // GIR_Coverage, 4914,
     /* 315548 */     GIR_EraseRootFromParent_Done,
     /* 315549 */   // Label 6256: @315549
     /* 315549 */   GIM_Try, /*On fail goto*//*Label 6257*/ GIMT_Encode4(315599), // Rule ID 13378 //
     /* 315554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315569 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315574 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315578 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315582 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315584 */     // (fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315589 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 315591 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315595 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315597 */     GIR_RootConstrainSelectedInstOperands,
     /* 315598 */     // GIR_Coverage, 13378,
     /* 315598 */     GIR_EraseRootFromParent_Done,
     /* 315599 */   // Label 6257: @315599
     /* 315599 */   GIM_Try, /*On fail goto*//*Label 6258*/ GIMT_Encode4(315649), // Rule ID 646 //
     /* 315604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315611 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315615 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315619 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315623 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315632 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315634 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 315645 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315647 */     GIR_RootConstrainSelectedInstOperands,
     /* 315648 */     // GIR_Coverage, 646,
     /* 315648 */     GIR_EraseRootFromParent_Done,
     /* 315649 */   // Label 6258: @315649
     /* 315649 */   GIM_Try, /*On fail goto*//*Label 6259*/ GIMT_Encode4(315696), // Rule ID 13958 //
     /* 315654 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 315662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315675 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315679 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315681 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 315684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315686 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 315690 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 315692 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 315694 */     GIR_RootConstrainSelectedInstOperands,
     /* 315695 */     // GIR_Coverage, 13958,
     /* 315695 */     GIR_EraseRootFromParent_Done,
     /* 315696 */   // Label 6259: @315696
     /* 315696 */   GIM_Try, /*On fail goto*//*Label 6260*/ GIMT_Encode4(315746), // Rule ID 658 //
     /* 315701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315704 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315708 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 315716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315720 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 315724 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315729 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 315731 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 315734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315736 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 315738 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 315740 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 315744 */     GIR_RootConstrainSelectedInstOperands,
     /* 315745 */     // GIR_Coverage, 658,
     /* 315745 */     GIR_EraseRootFromParent_Done,
     /* 315746 */   // Label 6260: @315746
     /* 315746 */   GIM_Try, /*On fail goto*//*Label 6261*/ GIMT_Encode4(315777), // Rule ID 640 //
     /* 315751 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315754 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315758 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315762 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 315766 */     // (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 315766 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 315771 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 315775 */     GIR_RootConstrainSelectedInstOperands,
     /* 315776 */     // GIR_Coverage, 640,
     /* 315776 */     GIR_Done,
     /* 315777 */   // Label 6261: @315777
     /* 315777 */   GIM_Reject,
     /* 315778 */ // Label 6227: @315778
     /* 315778 */ GIM_Reject,
     /* 315779 */ // Label 6187: @315779
     /* 315779 */ GIM_Try, /*On fail goto*//*Label 6262*/ GIMT_Encode4(318926),
     /* 315784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 315787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 315790 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 315793 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315797 */   GIM_Try, /*On fail goto*//*Label 6263*/ GIMT_Encode4(315947), // Rule ID 4912 //
     /* 315802 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315805 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315809 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315813 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315817 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315821 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315826 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315830 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315834 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315838 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315842 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 315846 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315851 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 315855 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 315859 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315863 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 315867 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 315874 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 315874 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 315877 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315881 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315886 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 315892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315897 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315902 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 315905 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 315909 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 315914 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 315920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 315925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 315933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 315935 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 315938 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 315941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 315945 */     GIR_RootConstrainSelectedInstOperands,
     /* 315946 */     // GIR_Coverage, 4912,
     /* 315946 */     GIR_EraseRootFromParent_Done,
     /* 315947 */   // Label 6263: @315947
     /* 315947 */   GIM_Try, /*On fail goto*//*Label 6264*/ GIMT_Encode4(316094), // Rule ID 4876 //
     /* 315952 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 315955 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 315959 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 315963 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 315967 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 315971 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 315976 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 315980 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 315984 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 315988 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 315992 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 315996 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316000 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316004 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316008 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316013 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316017 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316021 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316023 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316023 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316026 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316030 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316035 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316041 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316046 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316063 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316069 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316079 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316082 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316084 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316087 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316090 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316092 */     GIR_RootConstrainSelectedInstOperands,
     /* 316093 */     // GIR_Coverage, 4876,
     /* 316093 */     GIR_EraseRootFromParent_Done,
     /* 316094 */   // Label 6264: @316094
     /* 316094 */   GIM_Try, /*On fail goto*//*Label 6265*/ GIMT_Encode4(316241), // Rule ID 13956 //
     /* 316099 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316102 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316106 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316110 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316114 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316118 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316122 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316126 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316130 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316135 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316139 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316143 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316147 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316151 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316155 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316160 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 316164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316170 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316170 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316173 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316177 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316182 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316188 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316193 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316198 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316201 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316205 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316210 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316216 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316221 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 316229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316231 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316237 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316239 */     GIR_RootConstrainSelectedInstOperands,
     /* 316240 */     // GIR_Coverage, 13956,
     /* 316240 */     GIR_EraseRootFromParent_Done,
     /* 316241 */   // Label 6265: @316241
     /* 316241 */   GIM_Try, /*On fail goto*//*Label 6266*/ GIMT_Encode4(316372), // Rule ID 6139 //
     /* 316246 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316261 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316265 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316270 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 316286 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 316290 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316294 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316298 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316302 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316307 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 316311 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316315 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316319 */     // MIs[4] Operand 1
     /* 316319 */     // No operand predicates
     /* 316319 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316323 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316325 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316325 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316328 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316332 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316337 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316343 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316348 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316360 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 316367 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 316370 */     GIR_RootConstrainSelectedInstOperands,
     /* 316371 */     // GIR_Coverage, 6139,
     /* 316371 */     GIR_EraseRootFromParent_Done,
     /* 316372 */   // Label 6266: @316372
     /* 316372 */   GIM_Try, /*On fail goto*//*Label 6267*/ GIMT_Encode4(316503), // Rule ID 6171 //
     /* 316377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316380 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316384 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316388 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316392 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 316405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316409 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316413 */     // MIs[2] Operand 1
     /* 316413 */     // No operand predicates
     /* 316413 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316417 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316421 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 316425 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 316429 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316433 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316437 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 316441 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316446 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 316450 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316454 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316456 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316456 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316459 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316463 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316468 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316474 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316479 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316484 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316487 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316489 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316491 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 316498 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 316501 */     GIR_RootConstrainSelectedInstOperands,
     /* 316502 */     // GIR_Coverage, 6171,
     /* 316502 */     GIR_EraseRootFromParent_Done,
     /* 316503 */   // Label 6267: @316503
     /* 316503 */   GIM_Try, /*On fail goto*//*Label 6268*/ GIMT_Encode4(316634), // Rule ID 6235 //
     /* 316508 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316519 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316544 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316548 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 316552 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316556 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316560 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 316564 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316569 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 316573 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316577 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316581 */     // MIs[4] Operand 1
     /* 316581 */     // No operand predicates
     /* 316581 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316585 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316587 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316587 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316590 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316594 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316599 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316610 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316620 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316622 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 316629 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 316632 */     GIR_RootConstrainSelectedInstOperands,
     /* 316633 */     // GIR_Coverage, 6235,
     /* 316633 */     GIR_EraseRootFromParent_Done,
     /* 316634 */   // Label 6268: @316634
     /* 316634 */   GIM_Try, /*On fail goto*//*Label 6269*/ GIMT_Encode4(316765), // Rule ID 6203 //
     /* 316639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 316650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 316654 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 316658 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316662 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316666 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316670 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316675 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316679 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316683 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316687 */     // MIs[3] Operand 1
     /* 316687 */     // No operand predicates
     /* 316687 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 316691 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316695 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316699 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 316703 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316708 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 316712 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316716 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 316718 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 316749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 316751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 316753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 316760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 316763 */     GIR_RootConstrainSelectedInstOperands,
     /* 316764 */     // GIR_Coverage, 6203,
     /* 316764 */     GIR_EraseRootFromParent_Done,
     /* 316765 */   // Label 6269: @316765
     /* 316765 */   GIM_Try, /*On fail goto*//*Label 6270*/ GIMT_Encode4(316900), // Rule ID 2471 //
     /* 316770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 316773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316785 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316789 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316794 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316814 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316819 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 316823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316827 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 316829 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 316829 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 316832 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316836 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316841 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 316847 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316852 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316869 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316875 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316880 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316885 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 316888 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 316890 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 316893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 316896 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 316898 */     GIR_RootConstrainSelectedInstOperands,
     /* 316899 */     // GIR_Coverage, 2471,
     /* 316899 */     GIR_EraseRootFromParent_Done,
     /* 316900 */   // Label 6270: @316900
     /* 316900 */   GIM_Try, /*On fail goto*//*Label 6271*/ GIMT_Encode4(317019), // Rule ID 6107 //
     /* 316905 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 316908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 316912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 316924 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316929 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 316933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 316937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 316941 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 316945 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 316949 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 316954 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 316958 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 316962 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 316966 */     // MIs[3] Operand 1
     /* 316966 */     // No operand predicates
     /* 316966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316970 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 316972 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 316972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 316975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 316979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 316984 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 316990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 316995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317005 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317007 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317010 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317017 */     GIR_RootConstrainSelectedInstOperands,
     /* 317018 */     // GIR_Coverage, 6107,
     /* 317018 */     GIR_EraseRootFromParent_Done,
     /* 317019 */   // Label 6271: @317019
     /* 317019 */   GIM_Try, /*On fail goto*//*Label 6272*/ GIMT_Encode4(317138), // Rule ID 2554 //
     /* 317024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317027 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317031 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317035 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317039 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317043 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317048 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317052 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317056 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317060 */     // MIs[2] Operand 1
     /* 317060 */     // No operand predicates
     /* 317060 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317064 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317068 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317072 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 317076 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317081 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 317085 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317089 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317091 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317091 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317094 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317098 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317103 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317109 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317114 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 317122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317126 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317129 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317133 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317136 */     GIR_RootConstrainSelectedInstOperands,
     /* 317137 */     // GIR_Coverage, 2554,
     /* 317137 */     GIR_EraseRootFromParent_Done,
     /* 317138 */   // Label 6272: @317138
     /* 317138 */   GIM_Try, /*On fail goto*//*Label 6273*/ GIMT_Encode4(317238), // Rule ID 4874 //
     /* 317143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317162 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317167 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317188 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317194 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317206 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317217 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317230 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317234 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317236 */     GIR_RootConstrainSelectedInstOperands,
     /* 317237 */     // GIR_Coverage, 4874,
     /* 317237 */     GIR_EraseRootFromParent_Done,
     /* 317238 */   // Label 6273: @317238
     /* 317238 */   GIM_Try, /*On fail goto*//*Label 6274*/ GIMT_Encode4(317338), // Rule ID 4910 //
     /* 317243 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317246 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317250 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317254 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317258 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317267 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317271 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317275 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317279 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317283 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317287 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317292 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317294 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317294 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317297 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317301 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317306 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317312 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317327 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317330 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 317332 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317336 */     GIR_RootConstrainSelectedInstOperands,
     /* 317337 */     // GIR_Coverage, 4910,
     /* 317337 */     GIR_EraseRootFromParent_Done,
     /* 317338 */   // Label 6274: @317338
     /* 317338 */   GIM_Try, /*On fail goto*//*Label 6275*/ GIMT_Encode4(317435), // Rule ID 13952 //
     /* 317343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317358 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317362 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317366 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317370 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317374 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317379 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317391 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317393 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317405 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317411 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317416 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317421 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317424 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317426 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317431 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317433 */     GIR_RootConstrainSelectedInstOperands,
     /* 317434 */     // GIR_Coverage, 13952,
     /* 317434 */     GIR_EraseRootFromParent_Done,
     /* 317435 */   // Label 6275: @317435
     /* 317435 */   GIM_Try, /*On fail goto*//*Label 6276*/ GIMT_Encode4(317535), // Rule ID 13954 //
     /* 317440 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317443 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317447 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317451 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 317464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317468 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317472 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317476 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317481 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317485 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317491 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 317491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317503 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 317509 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317514 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317519 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317522 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317524 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317533 */     GIR_RootConstrainSelectedInstOperands,
     /* 317534 */     // GIR_Coverage, 13954,
     /* 317534 */     GIR_EraseRootFromParent_Done,
     /* 317535 */   // Label 6276: @317535
     /* 317535 */   GIM_Try, /*On fail goto*//*Label 6277*/ GIMT_Encode4(317635), // Rule ID 4908 //
     /* 317540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317543 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317547 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317551 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317555 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317559 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317563 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317568 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 317572 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 317576 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317580 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 317584 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317589 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317591 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317603 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317609 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317614 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 317622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317624 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317626 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 317633 */     GIR_RootConstrainSelectedInstOperands,
     /* 317634 */     // GIR_Coverage, 4908,
     /* 317634 */     GIR_EraseRootFromParent_Done,
     /* 317635 */   // Label 6277: @317635
     /* 317635 */   GIM_Try, /*On fail goto*//*Label 6278*/ GIMT_Encode4(317732), // Rule ID 4872 //
     /* 317640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 317643 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 317651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317659 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317663 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317667 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317671 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317675 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317680 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 317684 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317688 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 317690 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 317690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 317693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 317697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 317702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 317708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 317721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 317723 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 317725 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 317728 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 317730 */     GIR_RootConstrainSelectedInstOperands,
     /* 317731 */     // GIR_Coverage, 4872,
     /* 317731 */     GIR_EraseRootFromParent_Done,
     /* 317732 */   // Label 6278: @317732
     /* 317732 */   GIM_Try, /*On fail goto*//*Label 6279*/ GIMT_Encode4(317810), // Rule ID 6257 //
     /* 317737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317741 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317745 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317749 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317761 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317770 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 317774 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317778 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 317782 */     // MIs[3] Operand 1
     /* 317782 */     // No operand predicates
     /* 317782 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317786 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317790 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317792 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 317792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317797 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317799 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317801 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317808 */     GIR_RootConstrainSelectedInstOperands,
     /* 317809 */     // GIR_Coverage, 6257,
     /* 317809 */     GIR_EraseRootFromParent_Done,
     /* 317810 */   // Label 6279: @317810
     /* 317810 */   GIM_Try, /*On fail goto*//*Label 6280*/ GIMT_Encode4(317894), // Rule ID 6169 //
     /* 317815 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317818 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317822 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317826 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317830 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 317834 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 317843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317847 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317851 */     // MIs[2] Operand 1
     /* 317851 */     // No operand predicates
     /* 317851 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 317855 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317859 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 317863 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317872 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317874 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317881 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 317885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 317889 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 317892 */     GIR_RootConstrainSelectedInstOperands,
     /* 317893 */     // GIR_Coverage, 6169,
     /* 317893 */     GIR_EraseRootFromParent_Done,
     /* 317894 */   // Label 6280: @317894
     /* 317894 */   GIM_Try, /*On fail goto*//*Label 6281*/ GIMT_Encode4(317975), // Rule ID 6201 //
     /* 317899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317902 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317906 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317910 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317914 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 317918 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 317922 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 317926 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 317930 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 317935 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 317939 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 317943 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 317947 */     // MIs[3] Operand 1
     /* 317947 */     // No operand predicates
     /* 317947 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317951 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 317955 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 317957 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 317957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 317960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 317962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 317964 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 317966 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 317970 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 317973 */     GIR_RootConstrainSelectedInstOperands,
     /* 317974 */     // GIR_Coverage, 6201,
     /* 317974 */     GIR_EraseRootFromParent_Done,
     /* 317975 */   // Label 6281: @317975
     /* 317975 */   GIM_Try, /*On fail goto*//*Label 6282*/ GIMT_Encode4(318059), // Rule ID 6233 //
     /* 317980 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 317983 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 317987 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 317991 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 317995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 318004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318012 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318016 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318021 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318025 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318029 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318033 */     // MIs[3] Operand 1
     /* 318033 */     // No operand predicates
     /* 318033 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318037 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318039 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318039 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318042 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318044 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318050 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318054 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318057 */     GIR_RootConstrainSelectedInstOperands,
     /* 318058 */     // GIR_Coverage, 6233,
     /* 318058 */     GIR_EraseRootFromParent_Done,
     /* 318059 */   // Label 6282: @318059
     /* 318059 */   GIM_Try, /*On fail goto*//*Label 6283*/ GIMT_Encode4(318137), // Rule ID 6279 //
     /* 318064 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318068 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318072 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318076 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318080 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318084 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318088 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318092 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318096 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318101 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318105 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318109 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318113 */     // MIs[3] Operand 1
     /* 318113 */     // No operand predicates
     /* 318113 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318117 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318119 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 318119 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318122 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318124 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318126 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318135 */     GIR_RootConstrainSelectedInstOperands,
     /* 318136 */     // GIR_Coverage, 6279,
     /* 318136 */     GIR_EraseRootFromParent_Done,
     /* 318137 */   // Label 6283: @318137
     /* 318137 */   GIM_Try, /*On fail goto*//*Label 6284*/ GIMT_Encode4(318218), // Rule ID 6137 //
     /* 318142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318145 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318149 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318153 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318157 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318173 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 318177 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318182 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 318186 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318190 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318194 */     // MIs[3] Operand 1
     /* 318194 */     // No operand predicates
     /* 318194 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318198 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 318200 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318200 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 318203 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318205 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318207 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318209 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 318213 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 318216 */     GIR_RootConstrainSelectedInstOperands,
     /* 318217 */     // GIR_Coverage, 6137,
     /* 318217 */     GIR_EraseRootFromParent_Done,
     /* 318218 */   // Label 6284: @318218
     /* 318218 */   GIM_Try, /*On fail goto*//*Label 6285*/ GIMT_Encode4(318303), // Rule ID 2469 //
     /* 318223 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318226 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318230 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318234 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318238 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318242 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318247 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318251 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318255 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318259 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318261 */     // (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318261 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318264 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318268 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318273 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 318279 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318284 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318289 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318292 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318294 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318297 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318299 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318301 */     GIR_RootConstrainSelectedInstOperands,
     /* 318302 */     // GIR_Coverage, 2469,
     /* 318302 */     GIR_EraseRootFromParent_Done,
     /* 318303 */   // Label 6285: @318303
     /* 318303 */   GIM_Try, /*On fail goto*//*Label 6286*/ GIMT_Encode4(318388), // Rule ID 2467 //
     /* 318308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318311 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318323 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318327 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318331 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318336 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 318340 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318344 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318346 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 318346 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 318349 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 318353 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 318358 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 318364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318379 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318381 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 318384 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318386 */     GIR_RootConstrainSelectedInstOperands,
     /* 318387 */     // GIR_Coverage, 2467,
     /* 318387 */     GIR_EraseRootFromParent_Done,
     /* 318388 */   // Label 6286: @318388
     /* 318388 */   GIM_Try, /*On fail goto*//*Label 6287*/ GIMT_Encode4(318457), // Rule ID 2552 //
     /* 318393 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318396 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318400 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318404 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318408 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318412 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318425 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318429 */     // MIs[2] Operand 1
     /* 318429 */     // No operand predicates
     /* 318429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318433 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318437 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318439 */     // (fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318444 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318446 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318448 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318455 */     GIR_RootConstrainSelectedInstOperands,
     /* 318456 */     // GIR_Coverage, 2552,
     /* 318456 */     GIR_EraseRootFromParent_Done,
     /* 318457 */   // Label 6287: @318457
     /* 318457 */   GIM_Try, /*On fail goto*//*Label 6288*/ GIMT_Encode4(318526), // Rule ID 6105 //
     /* 318462 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 318465 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318469 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318473 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 318477 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 318481 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318485 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318490 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 318494 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318498 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 318502 */     // MIs[2] Operand 1
     /* 318502 */     // No operand predicates
     /* 318502 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318506 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318508 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 318508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 318511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 318513 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 318515 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318517 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318521 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 318524 */     GIR_RootConstrainSelectedInstOperands,
     /* 318525 */     // GIR_Coverage, 6105,
     /* 318525 */     GIR_EraseRootFromParent_Done,
     /* 318526 */   // Label 6288: @318526
     /* 318526 */   GIM_Try, /*On fail goto*//*Label 6289*/ GIMT_Encode4(318588), // Rule ID 4918 //
     /* 318531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318539 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318543 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318552 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318556 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318560 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318564 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318571 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 318574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318580 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318586 */     GIR_RootConstrainSelectedInstOperands,
     /* 318587 */     // GIR_Coverage, 4918,
     /* 318587 */     GIR_EraseRootFromParent_Done,
     /* 318588 */   // Label 6289: @318588
     /* 318588 */   GIM_Try, /*On fail goto*//*Label 6290*/ GIMT_Encode4(318650), // Rule ID 13962 //
     /* 318593 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 318618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 318626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318631 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 318633 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 318636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318638 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318642 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318644 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 318648 */     GIR_RootConstrainSelectedInstOperands,
     /* 318649 */     // GIR_Coverage, 13962,
     /* 318649 */     GIR_EraseRootFromParent_Done,
     /* 318650 */   // Label 6290: @318650
     /* 318650 */   GIM_Try, /*On fail goto*//*Label 6291*/ GIMT_Encode4(318697), // Rule ID 4915 //
     /* 318655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318659 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318663 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318667 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318682 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318687 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318691 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318693 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318695 */     GIR_RootConstrainSelectedInstOperands,
     /* 318696 */     // GIR_Coverage, 4915,
     /* 318696 */     GIR_EraseRootFromParent_Done,
     /* 318697 */   // Label 6291: @318697
     /* 318697 */   GIM_Try, /*On fail goto*//*Label 6292*/ GIMT_Encode4(318747), // Rule ID 13380 //
     /* 318702 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318705 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318709 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318713 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318717 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318722 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318726 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318730 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318732 */     // (fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318732 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318735 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318737 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 318739 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318743 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318745 */     GIR_RootConstrainSelectedInstOperands,
     /* 318746 */     // GIR_Coverage, 13380,
     /* 318746 */     GIR_EraseRootFromParent_Done,
     /* 318747 */   // Label 6292: @318747
     /* 318747 */   GIM_Try, /*On fail goto*//*Label 6293*/ GIMT_Encode4(318797), // Rule ID 648 //
     /* 318752 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318759 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318763 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318767 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318771 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318776 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318780 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318782 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318782 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318785 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318787 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318789 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 318793 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318795 */     GIR_RootConstrainSelectedInstOperands,
     /* 318796 */     // GIR_Coverage, 648,
     /* 318796 */     GIR_EraseRootFromParent_Done,
     /* 318797 */   // Label 6293: @318797
     /* 318797 */   GIM_Try, /*On fail goto*//*Label 6294*/ GIMT_Encode4(318844), // Rule ID 13959 //
     /* 318802 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318806 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 318810 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318814 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318823 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318827 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318829 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318829 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 318832 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318834 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 318838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 318840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 318842 */     GIR_RootConstrainSelectedInstOperands,
     /* 318843 */     // GIR_Coverage, 13959,
     /* 318843 */     GIR_EraseRootFromParent_Done,
     /* 318844 */   // Label 6294: @318844
     /* 318844 */   GIM_Try, /*On fail goto*//*Label 6295*/ GIMT_Encode4(318894), // Rule ID 660 //
     /* 318849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318852 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 318864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 318872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318877 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 318879 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318879 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 318882 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 318884 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 318886 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 318888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 318892 */     GIR_RootConstrainSelectedInstOperands,
     /* 318893 */     // GIR_Coverage, 660,
     /* 318893 */     GIR_EraseRootFromParent_Done,
     /* 318894 */   // Label 6295: @318894
     /* 318894 */   GIM_Try, /*On fail goto*//*Label 6296*/ GIMT_Encode4(318925), // Rule ID 642 //
     /* 318899 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 318902 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318914 */     // (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 318914 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 318919 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 318923 */     GIR_RootConstrainSelectedInstOperands,
     /* 318924 */     // GIR_Coverage, 642,
     /* 318924 */     GIR_Done,
     /* 318925 */   // Label 6296: @318925
     /* 318925 */   GIM_Reject,
     /* 318926 */ // Label 6262: @318926
     /* 318926 */ GIM_Reject,
     /* 318927 */ // Label 6188: @318927
     /* 318927 */ GIM_Try, /*On fail goto*//*Label 6297*/ GIMT_Encode4(320447),
     /* 318932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 318935 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 318938 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 318941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318945 */   GIM_Try, /*On fail goto*//*Label 6298*/ GIMT_Encode4(319023), // Rule ID 6237 //
     /* 318950 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 318954 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 318958 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318962 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 318966 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 318970 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 318974 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 318978 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 318983 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 318987 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 318991 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 318995 */     // MIs[3] Operand 1
     /* 318995 */     // No operand predicates
     /* 318995 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 318999 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319003 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319005 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319005 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319008 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319010 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319012 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319014 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319018 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319021 */     GIR_RootConstrainSelectedInstOperands,
     /* 319022 */     // GIR_Coverage, 6237,
     /* 319022 */     GIR_EraseRootFromParent_Done,
     /* 319023 */   // Label 6298: @319023
     /* 319023 */   GIM_Try, /*On fail goto*//*Label 6299*/ GIMT_Encode4(319107), // Rule ID 6153 //
     /* 319028 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319031 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319035 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319039 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319043 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319047 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319060 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319064 */     // MIs[2] Operand 1
     /* 319064 */     // No operand predicates
     /* 319064 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 319068 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319072 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319076 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319081 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319085 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319087 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319087 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319090 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319092 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319094 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 319098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319105 */     GIR_RootConstrainSelectedInstOperands,
     /* 319106 */     // GIR_Coverage, 6153,
     /* 319106 */     GIR_EraseRootFromParent_Done,
     /* 319107 */   // Label 6299: @319107
     /* 319107 */   GIM_Try, /*On fail goto*//*Label 6300*/ GIMT_Encode4(319188), // Rule ID 6185 //
     /* 319112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319156 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319160 */     // MIs[3] Operand 1
     /* 319160 */     // No operand predicates
     /* 319160 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319164 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319168 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319170 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319179 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319186 */     GIR_RootConstrainSelectedInstOperands,
     /* 319187 */     // GIR_Coverage, 6185,
     /* 319187 */     GIR_EraseRootFromParent_Done,
     /* 319188 */   // Label 6300: @319188
     /* 319188 */   GIM_Try, /*On fail goto*//*Label 6301*/ GIMT_Encode4(319272), // Rule ID 6217 //
     /* 319193 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319204 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319221 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319225 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319229 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319234 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319238 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319242 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319246 */     // MIs[3] Operand 1
     /* 319246 */     // No operand predicates
     /* 319246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319250 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319252 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319257 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319259 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319263 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319267 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319270 */     GIR_RootConstrainSelectedInstOperands,
     /* 319271 */     // GIR_Coverage, 6217,
     /* 319271 */     GIR_EraseRootFromParent_Done,
     /* 319272 */   // Label 6301: @319272
     /* 319272 */   GIM_Try, /*On fail goto*//*Label 6302*/ GIMT_Encode4(319350), // Rule ID 6259 //
     /* 319277 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319281 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319285 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319289 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319293 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319314 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 319318 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319322 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319326 */     // MIs[3] Operand 1
     /* 319326 */     // No operand predicates
     /* 319326 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319330 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319332 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319332 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319335 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319337 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319339 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319348 */     GIR_RootConstrainSelectedInstOperands,
     /* 319349 */     // GIR_Coverage, 6259,
     /* 319349 */     GIR_EraseRootFromParent_Done,
     /* 319350 */   // Label 6302: @319350
     /* 319350 */   GIM_Try, /*On fail goto*//*Label 6303*/ GIMT_Encode4(319431), // Rule ID 6121 //
     /* 319355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319382 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319386 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 319390 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319395 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 319399 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319403 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319407 */     // MIs[3] Operand 1
     /* 319407 */     // No operand predicates
     /* 319407 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319411 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 319413 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319413 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319416 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319418 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319420 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319422 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319426 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 319429 */     GIR_RootConstrainSelectedInstOperands,
     /* 319430 */     // GIR_Coverage, 6121,
     /* 319430 */     GIR_EraseRootFromParent_Done,
     /* 319431 */   // Label 6303: @319431
     /* 319431 */   GIM_Try, /*On fail goto*//*Label 6304*/ GIMT_Encode4(319500), // Rule ID 2536 //
     /* 319436 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319439 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319443 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319447 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319451 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319455 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319468 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319472 */     // MIs[2] Operand 1
     /* 319472 */     // No operand predicates
     /* 319472 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319476 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319480 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319482 */     // (fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319482 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319485 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319487 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319489 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319491 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319495 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319498 */     GIR_RootConstrainSelectedInstOperands,
     /* 319499 */     // GIR_Coverage, 2536,
     /* 319499 */     GIR_EraseRootFromParent_Done,
     /* 319500 */   // Label 6304: @319500
     /* 319500 */   GIM_Try, /*On fail goto*//*Label 6305*/ GIMT_Encode4(319569), // Rule ID 6089 //
     /* 319505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 319520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 319524 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 319528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319533 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 319537 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 319541 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 319545 */     // MIs[2] Operand 1
     /* 319545 */     // No operand predicates
     /* 319545 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319549 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319551 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 319551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 319554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319556 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319558 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 319560 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 319567 */     GIR_RootConstrainSelectedInstOperands,
     /* 319568 */     // GIR_Coverage, 6089,
     /* 319568 */     GIR_EraseRootFromParent_Done,
     /* 319569 */   // Label 6305: @319569
     /* 319569 */   GIM_Try, /*On fail goto*//*Label 6306*/ GIMT_Encode4(319662), // Rule ID 6241 //
     /* 319574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319594 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319598 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319603 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319607 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319611 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319613 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319625 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319628 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319632 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319635 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319640 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319645 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319648 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319650 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319652 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319654 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319660 */     GIR_RootConstrainSelectedInstOperands,
     /* 319661 */     // GIR_Coverage, 6241,
     /* 319661 */     GIR_EraseRootFromParent_Done,
     /* 319662 */   // Label 6306: @319662
     /* 319662 */   GIM_Try, /*On fail goto*//*Label 6307*/ GIMT_Encode4(319761), // Rule ID 6155 //
     /* 319667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319695 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319699 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319704 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319708 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319710 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319710 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319713 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319717 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319722 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319725 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 319729 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319732 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319737 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319742 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319745 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319747 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319749 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 319753 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319756 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319759 */     GIR_RootConstrainSelectedInstOperands,
     /* 319760 */     // GIR_Coverage, 6155,
     /* 319760 */     GIR_EraseRootFromParent_Done,
     /* 319761 */   // Label 6307: @319761
     /* 319761 */   GIM_Try, /*On fail goto*//*Label 6308*/ GIMT_Encode4(319857), // Rule ID 6187 //
     /* 319766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319793 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319798 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319802 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319806 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319808 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319820 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319823 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319827 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319830 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319835 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319840 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319843 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319845 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319847 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 319849 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319852 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319855 */     GIR_RootConstrainSelectedInstOperands,
     /* 319856 */     // GIR_Coverage, 6187,
     /* 319856 */     GIR_EraseRootFromParent_Done,
     /* 319857 */   // Label 6308: @319857
     /* 319857 */   GIM_Try, /*On fail goto*//*Label 6309*/ GIMT_Encode4(319956), // Rule ID 6219 //
     /* 319862 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 319865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 319869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319873 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 319877 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 319886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 319890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319894 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319899 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319903 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 319905 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 319905 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 319908 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 319912 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 319917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 319920 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 319924 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 319927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 319932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 319940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 319942 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 319944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 319948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 319951 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 319954 */     GIR_RootConstrainSelectedInstOperands,
     /* 319955 */     // GIR_Coverage, 6219,
     /* 319955 */     GIR_EraseRootFromParent_Done,
     /* 319956 */   // Label 6309: @319956
     /* 319956 */   GIM_Try, /*On fail goto*//*Label 6310*/ GIMT_Encode4(320049), // Rule ID 6263 //
     /* 319961 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319965 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 319969 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 319973 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 319977 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 319981 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 319985 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 319989 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 319994 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 319998 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320000 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320000 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320003 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320007 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320012 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320015 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320019 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320022 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320027 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320037 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320039 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320041 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320044 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320047 */     GIR_RootConstrainSelectedInstOperands,
     /* 320048 */     // GIR_Coverage, 6263,
     /* 320048 */     GIR_EraseRootFromParent_Done,
     /* 320049 */   // Label 6310: @320049
     /* 320049 */   GIM_Try, /*On fail goto*//*Label 6311*/ GIMT_Encode4(320145), // Rule ID 6123 //
     /* 320054 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320073 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320077 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 320081 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 320085 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320090 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320094 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 320096 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320096 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320099 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320103 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320108 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320111 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320115 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 320131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320135 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320137 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320140 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320143 */     GIR_RootConstrainSelectedInstOperands,
     /* 320144 */     // GIR_Coverage, 6123,
     /* 320144 */     GIR_EraseRootFromParent_Done,
     /* 320145 */   // Label 6311: @320145
     /* 320145 */   GIM_Try, /*On fail goto*//*Label 6312*/ GIMT_Encode4(320229), // Rule ID 2538 //
     /* 320150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320153 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320157 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320161 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320165 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320170 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320174 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320178 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320180 */     // (fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320180 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320183 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320187 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320192 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320195 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320199 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320202 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320212 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320215 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320217 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320219 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320221 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320224 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320227 */     GIR_RootConstrainSelectedInstOperands,
     /* 320228 */     // GIR_Coverage, 2538,
     /* 320228 */     GIR_EraseRootFromParent_Done,
     /* 320229 */   // Label 6312: @320229
     /* 320229 */   GIM_Try, /*On fail goto*//*Label 6313*/ GIMT_Encode4(320279), // Rule ID 13410 //
     /* 320234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320249 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320254 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320258 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320262 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320264 */     // (fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320264 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 320267 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320269 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320271 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320277 */     GIR_RootConstrainSelectedInstOperands,
     /* 320278 */     // GIR_Coverage, 13410,
     /* 320278 */     GIR_EraseRootFromParent_Done,
     /* 320279 */   // Label 6313: @320279
     /* 320279 */   GIM_Try, /*On fail goto*//*Label 6314*/ GIMT_Encode4(320363), // Rule ID 6091 //
     /* 320284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320291 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320295 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 320299 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 320303 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320308 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320312 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320314 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 320314 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 320317 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 320321 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 320326 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 320329 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320333 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 320336 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320341 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 320346 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 320349 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320351 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320353 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 320358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 320361 */     GIR_RootConstrainSelectedInstOperands,
     /* 320362 */     // GIR_Coverage, 6091,
     /* 320362 */     GIR_EraseRootFromParent_Done,
     /* 320363 */   // Label 6314: @320363
     /* 320363 */   GIM_Try, /*On fail goto*//*Label 6315*/ GIMT_Encode4(320413), // Rule ID 1308 //
     /* 320368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320375 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320379 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320383 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 320387 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320396 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 320398 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320398 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 320401 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320403 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320405 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320411 */     GIR_RootConstrainSelectedInstOperands,
     /* 320412 */     // GIR_Coverage, 1308,
     /* 320412 */     GIR_EraseRootFromParent_Done,
     /* 320413 */   // Label 6315: @320413
     /* 320413 */   GIM_Try, /*On fail goto*//*Label 6316*/ GIMT_Encode4(320446), // Rule ID 1298 //
     /* 320418 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320421 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320425 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320429 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 320433 */     // (fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 320433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 320436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320442 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 320444 */     GIR_RootConstrainSelectedInstOperands,
     /* 320445 */     // GIR_Coverage, 1298,
     /* 320445 */     GIR_EraseRootFromParent_Done,
     /* 320446 */   // Label 6316: @320446
     /* 320446 */   GIM_Reject,
     /* 320447 */ // Label 6297: @320447
     /* 320447 */ GIM_Reject,
     /* 320448 */ // Label 6189: @320448
     /* 320448 */ GIM_Try, /*On fail goto*//*Label 6317*/ GIMT_Encode4(321968),
     /* 320453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320456 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 320459 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 320462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320466 */   GIM_Try, /*On fail goto*//*Label 6318*/ GIMT_Encode4(320544), // Rule ID 6249 //
     /* 320471 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320475 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320479 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320483 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320487 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320491 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320495 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320499 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320504 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320508 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320512 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320516 */     // MIs[3] Operand 1
     /* 320516 */     // No operand predicates
     /* 320516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320520 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320524 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320526 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320526 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320529 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320531 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320533 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320542 */     GIR_RootConstrainSelectedInstOperands,
     /* 320543 */     // GIR_Coverage, 6249,
     /* 320543 */     GIR_EraseRootFromParent_Done,
     /* 320544 */   // Label 6318: @320544
     /* 320544 */   GIM_Try, /*On fail goto*//*Label 6319*/ GIMT_Encode4(320628), // Rule ID 6161 //
     /* 320549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320564 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320581 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320585 */     // MIs[2] Operand 1
     /* 320585 */     // No operand predicates
     /* 320585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 320589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320593 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320597 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320602 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320606 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320608 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320613 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320615 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 320619 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 320623 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 320626 */     GIR_RootConstrainSelectedInstOperands,
     /* 320627 */     // GIR_Coverage, 6161,
     /* 320627 */     GIR_EraseRootFromParent_Done,
     /* 320628 */   // Label 6319: @320628
     /* 320628 */   GIM_Try, /*On fail goto*//*Label 6320*/ GIMT_Encode4(320709), // Rule ID 6193 //
     /* 320633 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320644 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320648 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320652 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320656 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320660 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320664 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320669 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320673 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320677 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320681 */     // MIs[3] Operand 1
     /* 320681 */     // No operand predicates
     /* 320681 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320685 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320689 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320691 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320696 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 320700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320707 */     GIR_RootConstrainSelectedInstOperands,
     /* 320708 */     // GIR_Coverage, 6193,
     /* 320708 */     GIR_EraseRootFromParent_Done,
     /* 320709 */   // Label 6320: @320709
     /* 320709 */   GIM_Try, /*On fail goto*//*Label 6321*/ GIMT_Encode4(320793), // Rule ID 6225 //
     /* 320714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320725 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320729 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 320738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320746 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320750 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320755 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320759 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320763 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320767 */     // MIs[3] Operand 1
     /* 320767 */     // No operand predicates
     /* 320767 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320771 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320773 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320773 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320776 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320778 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320780 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 320784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320791 */     GIR_RootConstrainSelectedInstOperands,
     /* 320792 */     // GIR_Coverage, 6225,
     /* 320792 */     GIR_EraseRootFromParent_Done,
     /* 320793 */   // Label 6321: @320793
     /* 320793 */   GIM_Try, /*On fail goto*//*Label 6322*/ GIMT_Encode4(320871), // Rule ID 6271 //
     /* 320798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320818 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320822 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320826 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320830 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 320839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320847 */     // MIs[3] Operand 1
     /* 320847 */     // No operand predicates
     /* 320847 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320851 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320853 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320853 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320856 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320858 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320860 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320862 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320866 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320869 */     GIR_RootConstrainSelectedInstOperands,
     /* 320870 */     // GIR_Coverage, 6271,
     /* 320870 */     GIR_EraseRootFromParent_Done,
     /* 320871 */   // Label 6322: @320871
     /* 320871 */   GIM_Try, /*On fail goto*//*Label 6323*/ GIMT_Encode4(320952), // Rule ID 6129 //
     /* 320876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 320887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 320891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320895 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 320899 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320903 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320907 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 320911 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320916 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 320920 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320924 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320928 */     // MIs[3] Operand 1
     /* 320928 */     // No operand predicates
     /* 320928 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320932 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 320934 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 320934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 320937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 320939 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 320941 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 320943 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 320947 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 320950 */     GIR_RootConstrainSelectedInstOperands,
     /* 320951 */     // GIR_Coverage, 6129,
     /* 320951 */     GIR_EraseRootFromParent_Done,
     /* 320952 */   // Label 6323: @320952
     /* 320952 */   GIM_Try, /*On fail goto*//*Label 6324*/ GIMT_Encode4(321021), // Rule ID 2544 //
     /* 320957 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 320960 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 320964 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 320968 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 320972 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 320976 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320981 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 320985 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 320989 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 320993 */     // MIs[2] Operand 1
     /* 320993 */     // No operand predicates
     /* 320993 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 320997 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321001 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321003 */     // (fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321008 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321010 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321012 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321019 */     GIR_RootConstrainSelectedInstOperands,
     /* 321020 */     // GIR_Coverage, 2544,
     /* 321020 */     GIR_EraseRootFromParent_Done,
     /* 321021 */   // Label 6324: @321021
     /* 321021 */   GIM_Try, /*On fail goto*//*Label 6325*/ GIMT_Encode4(321090), // Rule ID 6097 //
     /* 321026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 321041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321045 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 321049 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321054 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 321058 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 321062 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 321066 */     // MIs[2] Operand 1
     /* 321066 */     // No operand predicates
     /* 321066 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321070 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321072 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 321072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321077 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321079 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321081 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321085 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 321088 */     GIR_RootConstrainSelectedInstOperands,
     /* 321089 */     // GIR_Coverage, 6097,
     /* 321089 */     GIR_EraseRootFromParent_Done,
     /* 321090 */   // Label 6325: @321090
     /* 321090 */   GIM_Try, /*On fail goto*//*Label 6326*/ GIMT_Encode4(321183), // Rule ID 6251 //
     /* 321095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321115 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321119 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321132 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321134 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321146 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321149 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321153 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321156 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321161 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321171 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321173 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321178 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321181 */     GIR_RootConstrainSelectedInstOperands,
     /* 321182 */     // GIR_Coverage, 6251,
     /* 321182 */     GIR_EraseRootFromParent_Done,
     /* 321183 */   // Label 6326: @321183
     /* 321183 */   GIM_Try, /*On fail goto*//*Label 6327*/ GIMT_Encode4(321282), // Rule ID 6163 //
     /* 321188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321203 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321216 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321220 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321225 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321229 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321231 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321231 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321234 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321238 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321243 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321246 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321250 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321258 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321263 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321266 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321268 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321270 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 321274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321280 */     GIR_RootConstrainSelectedInstOperands,
     /* 321281 */     // GIR_Coverage, 6163,
     /* 321281 */     GIR_EraseRootFromParent_Done,
     /* 321282 */   // Label 6327: @321282
     /* 321282 */   GIM_Try, /*On fail goto*//*Label 6328*/ GIMT_Encode4(321378), // Rule ID 6195 //
     /* 321287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321302 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321306 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321310 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321314 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321319 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321323 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321329 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321329 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321332 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321336 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321341 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321344 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321348 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321351 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321356 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321361 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321364 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321366 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321368 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321370 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321373 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321376 */     GIR_RootConstrainSelectedInstOperands,
     /* 321377 */     // GIR_Coverage, 6195,
     /* 321377 */     GIR_EraseRootFromParent_Done,
     /* 321378 */   // Label 6328: @321378
     /* 321378 */   GIM_Try, /*On fail goto*//*Label 6329*/ GIMT_Encode4(321477), // Rule ID 6227 //
     /* 321383 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321386 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321390 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321394 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321398 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 321407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321420 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321424 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321426 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321426 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321429 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321433 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321438 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321445 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321448 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321453 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321458 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321461 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321463 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 321469 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321472 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321475 */     GIR_RootConstrainSelectedInstOperands,
     /* 321476 */     // GIR_Coverage, 6227,
     /* 321476 */     GIR_EraseRootFromParent_Done,
     /* 321477 */   // Label 6329: @321477
     /* 321477 */   GIM_Try, /*On fail goto*//*Label 6330*/ GIMT_Encode4(321570), // Rule ID 6273 //
     /* 321482 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321486 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321490 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321494 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321498 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321502 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321506 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321510 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321515 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321519 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321521 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321521 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321524 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321528 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321533 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321536 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321540 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321543 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321548 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321562 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321565 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321568 */     GIR_RootConstrainSelectedInstOperands,
     /* 321569 */     // GIR_Coverage, 6273,
     /* 321569 */     GIR_EraseRootFromParent_Done,
     /* 321570 */   // Label 6330: @321570
     /* 321570 */   GIM_Try, /*On fail goto*//*Label 6331*/ GIMT_Encode4(321666), // Rule ID 6131 //
     /* 321575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321582 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321586 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321590 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321594 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 321598 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 321602 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 321606 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 321617 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 321636 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 321652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321656 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321664 */     GIR_RootConstrainSelectedInstOperands,
     /* 321665 */     // GIR_Coverage, 6131,
     /* 321665 */     GIR_EraseRootFromParent_Done,
     /* 321666 */   // Label 6331: @321666
     /* 321666 */   GIM_Try, /*On fail goto*//*Label 6332*/ GIMT_Encode4(321750), // Rule ID 2546 //
     /* 321671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321701 */     // (fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321701 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321704 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321708 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321713 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321720 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321723 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321728 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321733 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321736 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321738 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321740 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321748 */     GIR_RootConstrainSelectedInstOperands,
     /* 321749 */     // GIR_Coverage, 2546,
     /* 321749 */     GIR_EraseRootFromParent_Done,
     /* 321750 */   // Label 6332: @321750
     /* 321750 */   GIM_Try, /*On fail goto*//*Label 6333*/ GIMT_Encode4(321800), // Rule ID 13414 //
     /* 321755 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321758 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321762 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321766 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321770 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321775 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321779 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321783 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321785 */     // (fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321785 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321788 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321790 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321792 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321794 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321798 */     GIR_RootConstrainSelectedInstOperands,
     /* 321799 */     // GIR_Coverage, 13414,
     /* 321799 */     GIR_EraseRootFromParent_Done,
     /* 321800 */   // Label 6333: @321800
     /* 321800 */   GIM_Try, /*On fail goto*//*Label 6334*/ GIMT_Encode4(321884), // Rule ID 6099 //
     /* 321805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 321820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 321824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321835 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 321835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 321838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 321842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 321847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 321850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 321857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 321870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321874 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321876 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 321879 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 321882 */     GIR_RootConstrainSelectedInstOperands,
     /* 321883 */     // GIR_Coverage, 6099,
     /* 321883 */     GIR_EraseRootFromParent_Done,
     /* 321884 */   // Label 6334: @321884
     /* 321884 */   GIM_Try, /*On fail goto*//*Label 6335*/ GIMT_Encode4(321934), // Rule ID 1312 //
     /* 321889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321892 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 321900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 321904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 321908 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321917 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 321919 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 321922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321926 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 321928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 321932 */     GIR_RootConstrainSelectedInstOperands,
     /* 321933 */     // GIR_Coverage, 1312,
     /* 321933 */     GIR_EraseRootFromParent_Done,
     /* 321934 */   // Label 6335: @321934
     /* 321934 */   GIM_Try, /*On fail goto*//*Label 6336*/ GIMT_Encode4(321967), // Rule ID 1302 //
     /* 321939 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 321942 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321946 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321950 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 321954 */     // (fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 321954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 321957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 321959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 321961 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 321963 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 321965 */     GIR_RootConstrainSelectedInstOperands,
     /* 321966 */     // GIR_Coverage, 1302,
     /* 321966 */     GIR_EraseRootFromParent_Done,
     /* 321967 */   // Label 6336: @321967
     /* 321967 */   GIM_Reject,
     /* 321968 */ // Label 6317: @321968
     /* 321968 */ GIM_Reject,
     /* 321969 */ // Label 6190: @321969
     /* 321969 */ GIM_Try, /*On fail goto*//*Label 6337*/ GIMT_Encode4(323147),
     /* 321974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 321977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 321980 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 321983 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 321987 */   GIM_Try, /*On fail goto*//*Label 6338*/ GIMT_Encode4(322071), // Rule ID 6145 //
     /* 321992 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 321995 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 321999 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322003 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322007 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322011 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322016 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322020 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322024 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322028 */     // MIs[2] Operand 1
     /* 322028 */     // No operand predicates
     /* 322028 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 322032 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322036 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322040 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322045 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322049 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322051 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322056 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322058 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 322062 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322066 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322069 */     GIR_RootConstrainSelectedInstOperands,
     /* 322070 */     // GIR_Coverage, 6145,
     /* 322070 */     GIR_EraseRootFromParent_Done,
     /* 322071 */   // Label 6338: @322071
     /* 322071 */   GIM_Try, /*On fail goto*//*Label 6339*/ GIMT_Encode4(322152), // Rule ID 6177 //
     /* 322076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322079 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322083 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322087 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322091 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322095 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322099 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322103 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322107 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322112 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322116 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322120 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322124 */     // MIs[3] Operand 1
     /* 322124 */     // No operand predicates
     /* 322124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322128 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322132 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322134 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322134 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322137 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322139 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322141 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322143 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322147 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322150 */     GIR_RootConstrainSelectedInstOperands,
     /* 322151 */     // GIR_Coverage, 6177,
     /* 322151 */     GIR_EraseRootFromParent_Done,
     /* 322152 */   // Label 6339: @322152
     /* 322152 */   GIM_Try, /*On fail goto*//*Label 6340*/ GIMT_Encode4(322236), // Rule ID 6209 //
     /* 322157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322160 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322164 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322168 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322172 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322177 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322181 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322185 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322189 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322193 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322198 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322202 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322206 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322210 */     // MIs[3] Operand 1
     /* 322210 */     // No operand predicates
     /* 322210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322214 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322216 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322221 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322227 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322231 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322234 */     GIR_RootConstrainSelectedInstOperands,
     /* 322235 */     // GIR_Coverage, 6209,
     /* 322235 */     GIR_EraseRootFromParent_Done,
     /* 322236 */   // Label 6340: @322236
     /* 322236 */   GIM_Try, /*On fail goto*//*Label 6341*/ GIMT_Encode4(322317), // Rule ID 6113 //
     /* 322241 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322244 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322252 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322256 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322268 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322272 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 322276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322281 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 322285 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322289 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322293 */     // MIs[3] Operand 1
     /* 322293 */     // No operand predicates
     /* 322293 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322297 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 322299 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322304 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322306 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322308 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 322315 */     GIR_RootConstrainSelectedInstOperands,
     /* 322316 */     // GIR_Coverage, 6113,
     /* 322316 */     GIR_EraseRootFromParent_Done,
     /* 322317 */   // Label 6341: @322317
     /* 322317 */   GIM_Try, /*On fail goto*//*Label 6342*/ GIMT_Encode4(322386), // Rule ID 2528 //
     /* 322322 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322325 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322329 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322333 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322337 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322346 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322350 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322354 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322358 */     // MIs[2] Operand 1
     /* 322358 */     // No operand predicates
     /* 322358 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322368 */     // (fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322373 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322375 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322377 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322381 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322384 */     GIR_RootConstrainSelectedInstOperands,
     /* 322385 */     // GIR_Coverage, 2528,
     /* 322385 */     GIR_EraseRootFromParent_Done,
     /* 322386 */   // Label 6342: @322386
     /* 322386 */   GIM_Try, /*On fail goto*//*Label 6343*/ GIMT_Encode4(322455), // Rule ID 6081 //
     /* 322391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322394 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322398 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322402 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 322406 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 322410 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 322414 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 322419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 322423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 322427 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 322431 */     // MIs[2] Operand 1
     /* 322431 */     // No operand predicates
     /* 322431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322437 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 322437 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322440 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322442 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322444 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322446 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322450 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 322453 */     GIR_RootConstrainSelectedInstOperands,
     /* 322454 */     // GIR_Coverage, 6081,
     /* 322454 */     GIR_EraseRootFromParent_Done,
     /* 322455 */   // Label 6343: @322455
     /* 322455 */   GIM_Try, /*On fail goto*//*Label 6344*/ GIMT_Encode4(322554), // Rule ID 6147 //
     /* 322460 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322471 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322475 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322488 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322492 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322497 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322503 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322518 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322522 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 322546 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322549 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322552 */     GIR_RootConstrainSelectedInstOperands,
     /* 322553 */     // GIR_Coverage, 6147,
     /* 322553 */     GIR_EraseRootFromParent_Done,
     /* 322554 */   // Label 6344: @322554
     /* 322554 */   GIM_Try, /*On fail goto*//*Label 6345*/ GIMT_Encode4(322650), // Rule ID 6179 //
     /* 322559 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322566 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322570 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322582 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322586 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322591 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322595 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322601 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322613 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322616 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322620 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322638 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322640 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322642 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322645 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322648 */     GIR_RootConstrainSelectedInstOperands,
     /* 322649 */     // GIR_Coverage, 6179,
     /* 322649 */     GIR_EraseRootFromParent_Done,
     /* 322650 */   // Label 6345: @322650
     /* 322650 */   GIM_Try, /*On fail goto*//*Label 6346*/ GIMT_Encode4(322749), // Rule ID 6211 //
     /* 322655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322662 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322666 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 322679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322683 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322687 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322692 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322698 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322710 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322713 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322717 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322725 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322730 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322733 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322735 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322737 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 322741 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322744 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322747 */     GIR_RootConstrainSelectedInstOperands,
     /* 322748 */     // GIR_Coverage, 6211,
     /* 322748 */     GIR_EraseRootFromParent_Done,
     /* 322749 */   // Label 6346: @322749
     /* 322749 */   GIM_Try, /*On fail goto*//*Label 6347*/ GIMT_Encode4(322845), // Rule ID 6115 //
     /* 322754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 322777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 322781 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 322785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322790 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322794 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 322796 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322808 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322811 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 322815 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322818 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322823 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 322831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322835 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 322837 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322840 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322843 */     GIR_RootConstrainSelectedInstOperands,
     /* 322844 */     // GIR_Coverage, 6115,
     /* 322844 */     GIR_EraseRootFromParent_Done,
     /* 322845 */   // Label 6347: @322845
     /* 322845 */   GIM_Try, /*On fail goto*//*Label 6348*/ GIMT_Encode4(322929), // Rule ID 2530 //
     /* 322850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 322865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322870 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322874 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322878 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322880 */     // (fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 322880 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 322883 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 322887 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 322892 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 322895 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322899 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 322902 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 322907 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 322912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 322915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322919 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322921 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 322924 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 322927 */     GIR_RootConstrainSelectedInstOperands,
     /* 322928 */     // GIR_Coverage, 2530,
     /* 322928 */     GIR_EraseRootFromParent_Done,
     /* 322929 */   // Label 6348: @322929
     /* 322929 */   GIM_Try, /*On fail goto*//*Label 6349*/ GIMT_Encode4(322979), // Rule ID 13406 //
     /* 322934 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 322941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 322945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 322949 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322954 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322958 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322962 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 322964 */     // (fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 322964 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 322967 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 322969 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 322971 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 322973 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 322977 */     GIR_RootConstrainSelectedInstOperands,
     /* 322978 */     // GIR_Coverage, 13406,
     /* 322978 */     GIR_EraseRootFromParent_Done,
     /* 322979 */   // Label 6349: @322979
     /* 322979 */   GIM_Try, /*On fail goto*//*Label 6350*/ GIMT_Encode4(323063), // Rule ID 6083 //
     /* 322984 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 322987 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 322991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 322995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 322999 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 323003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323008 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323012 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323014 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323014 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 323017 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323021 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323026 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323029 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323033 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 323036 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323041 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 323046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 323049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323051 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323058 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323061 */     GIR_RootConstrainSelectedInstOperands,
     /* 323062 */     // GIR_Coverage, 6083,
     /* 323062 */     GIR_EraseRootFromParent_Done,
     /* 323063 */   // Label 6350: @323063
     /* 323063 */   GIM_Try, /*On fail goto*//*Label 6351*/ GIMT_Encode4(323113), // Rule ID 1304 //
     /* 323068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323071 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323079 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323083 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 323087 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323092 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323096 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 323098 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323098 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 323101 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323103 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323105 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323107 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323111 */     GIR_RootConstrainSelectedInstOperands,
     /* 323112 */     // GIR_Coverage, 1304,
     /* 323112 */     GIR_EraseRootFromParent_Done,
     /* 323113 */   // Label 6351: @323113
     /* 323113 */   GIM_Try, /*On fail goto*//*Label 6352*/ GIMT_Encode4(323146), // Rule ID 1294 //
     /* 323118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 323121 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323125 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 323133 */     // (fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 323133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 323136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323138 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323140 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 323144 */     GIR_RootConstrainSelectedInstOperands,
     /* 323145 */     // GIR_Coverage, 1294,
     /* 323145 */     GIR_EraseRootFromParent_Done,
     /* 323146 */   // Label 6352: @323146
     /* 323146 */   GIM_Reject,
     /* 323147 */ // Label 6337: @323147
     /* 323147 */ GIM_Reject,
     /* 323148 */ // Label 6191: @323148
     /* 323148 */ GIM_Try, /*On fail goto*//*Label 6353*/ GIMT_Encode4(324668),
     /* 323153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323156 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 323159 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 323162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323166 */   GIM_Try, /*On fail goto*//*Label 6354*/ GIMT_Encode4(323244), // Rule ID 6243 //
     /* 323171 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323175 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323179 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323183 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323187 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323191 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323195 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323199 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323204 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323208 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323212 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323216 */     // MIs[3] Operand 1
     /* 323216 */     // No operand predicates
     /* 323216 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323220 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323224 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323226 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323231 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323233 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323235 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323239 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323242 */     GIR_RootConstrainSelectedInstOperands,
     /* 323243 */     // GIR_Coverage, 6243,
     /* 323243 */     GIR_EraseRootFromParent_Done,
     /* 323244 */   // Label 6354: @323244
     /* 323244 */   GIM_Try, /*On fail goto*//*Label 6355*/ GIMT_Encode4(323328), // Rule ID 6157 //
     /* 323249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323252 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323256 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323260 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323264 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323268 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323281 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323285 */     // MIs[2] Operand 1
     /* 323285 */     // No operand predicates
     /* 323285 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 323289 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323293 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323297 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323302 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323306 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323308 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323308 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323311 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323313 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323315 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 323319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323326 */     GIR_RootConstrainSelectedInstOperands,
     /* 323327 */     // GIR_Coverage, 6157,
     /* 323327 */     GIR_EraseRootFromParent_Done,
     /* 323328 */   // Label 6355: @323328
     /* 323328 */   GIM_Try, /*On fail goto*//*Label 6356*/ GIMT_Encode4(323409), // Rule ID 6189 //
     /* 323333 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323336 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323340 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323344 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323360 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323364 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323369 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323373 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323377 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323381 */     // MIs[3] Operand 1
     /* 323381 */     // No operand predicates
     /* 323381 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323385 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323389 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323391 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323400 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323404 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323407 */     GIR_RootConstrainSelectedInstOperands,
     /* 323408 */     // GIR_Coverage, 6189,
     /* 323408 */     GIR_EraseRootFromParent_Done,
     /* 323409 */   // Label 6356: @323409
     /* 323409 */   GIM_Try, /*On fail goto*//*Label 6357*/ GIMT_Encode4(323493), // Rule ID 6221 //
     /* 323414 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323417 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323421 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323425 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323429 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323434 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323438 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323442 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323446 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323450 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323455 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323459 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323463 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323467 */     // MIs[3] Operand 1
     /* 323467 */     // No operand predicates
     /* 323467 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323471 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323473 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323473 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323476 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323478 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323480 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 323484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323491 */     GIR_RootConstrainSelectedInstOperands,
     /* 323492 */     // GIR_Coverage, 6221,
     /* 323492 */     GIR_EraseRootFromParent_Done,
     /* 323493 */   // Label 6357: @323493
     /* 323493 */   GIM_Try, /*On fail goto*//*Label 6358*/ GIMT_Encode4(323571), // Rule ID 6265 //
     /* 323498 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323510 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323514 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323518 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323522 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323526 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323530 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323535 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 323539 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323543 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323547 */     // MIs[3] Operand 1
     /* 323547 */     // No operand predicates
     /* 323547 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323551 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323553 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323553 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323556 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323558 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323560 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323562 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323566 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323569 */     GIR_RootConstrainSelectedInstOperands,
     /* 323570 */     // GIR_Coverage, 6265,
     /* 323570 */     GIR_EraseRootFromParent_Done,
     /* 323571 */   // Label 6358: @323571
     /* 323571 */   GIM_Try, /*On fail goto*//*Label 6359*/ GIMT_Encode4(323652), // Rule ID 6125 //
     /* 323576 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323579 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323583 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323587 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323591 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323603 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323607 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 323611 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323616 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 323620 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323624 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323628 */     // MIs[3] Operand 1
     /* 323628 */     // No operand predicates
     /* 323628 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 323634 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323639 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323641 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 323650 */     GIR_RootConstrainSelectedInstOperands,
     /* 323651 */     // GIR_Coverage, 6125,
     /* 323651 */     GIR_EraseRootFromParent_Done,
     /* 323652 */   // Label 6359: @323652
     /* 323652 */   GIM_Try, /*On fail goto*//*Label 6360*/ GIMT_Encode4(323721), // Rule ID 2540 //
     /* 323657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323660 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323664 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323668 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323672 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323676 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323681 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323685 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323689 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323693 */     // MIs[2] Operand 1
     /* 323693 */     // No operand predicates
     /* 323693 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323697 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323701 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323703 */     // (fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323703 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323706 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323708 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323710 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323712 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323716 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323719 */     GIR_RootConstrainSelectedInstOperands,
     /* 323720 */     // GIR_Coverage, 2540,
     /* 323720 */     GIR_EraseRootFromParent_Done,
     /* 323721 */   // Label 6360: @323721
     /* 323721 */   GIM_Try, /*On fail goto*//*Label 6361*/ GIMT_Encode4(323790), // Rule ID 6093 //
     /* 323726 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323729 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323733 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 323737 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 323741 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323745 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 323749 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 323758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 323762 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 323766 */     // MIs[2] Operand 1
     /* 323766 */     // No operand predicates
     /* 323766 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323772 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 323772 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 323775 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323777 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323779 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 323781 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323785 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 323788 */     GIR_RootConstrainSelectedInstOperands,
     /* 323789 */     // GIR_Coverage, 6093,
     /* 323789 */     GIR_EraseRootFromParent_Done,
     /* 323790 */   // Label 6361: @323790
     /* 323790 */   GIM_Try, /*On fail goto*//*Label 6362*/ GIMT_Encode4(323883), // Rule ID 6247 //
     /* 323795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323807 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 323811 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323815 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 323819 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323832 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323834 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323846 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 323853 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323856 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323861 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323866 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323869 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323871 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323873 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 323875 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323878 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323881 */     GIR_RootConstrainSelectedInstOperands,
     /* 323882 */     // GIR_Coverage, 6247,
     /* 323882 */     GIR_EraseRootFromParent_Done,
     /* 323883 */   // Label 6362: @323883
     /* 323883 */   GIM_Try, /*On fail goto*//*Label 6363*/ GIMT_Encode4(323982), // Rule ID 6159 //
     /* 323888 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 323899 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 323903 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323908 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 323912 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323916 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 323920 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323925 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323929 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 323931 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 323931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 323934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 323938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 323943 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 323946 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 323950 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 323953 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 323958 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 323963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 323966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 323968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 323970 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 323974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 323977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 323980 */     GIR_RootConstrainSelectedInstOperands,
     /* 323981 */     // GIR_Coverage, 6159,
     /* 323981 */     GIR_EraseRootFromParent_Done,
     /* 323982 */   // Label 6363: @323982
     /* 323982 */   GIM_Try, /*On fail goto*//*Label 6364*/ GIMT_Encode4(324078), // Rule ID 6191 //
     /* 323987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 323990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 323994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 323998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324019 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324023 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324029 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324041 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324044 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324048 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324051 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324056 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324061 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324064 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324066 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324068 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324070 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324073 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324076 */     GIR_RootConstrainSelectedInstOperands,
     /* 324077 */     // GIR_Coverage, 6191,
     /* 324077 */     GIR_EraseRootFromParent_Done,
     /* 324078 */   // Label 6364: @324078
     /* 324078 */   GIM_Try, /*On fail goto*//*Label 6365*/ GIMT_Encode4(324177), // Rule ID 6223 //
     /* 324083 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324086 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324090 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324094 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324111 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324115 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324120 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324124 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324126 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324126 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324129 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324133 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324138 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324141 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324145 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324148 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324153 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324163 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324165 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324169 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324172 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324175 */     GIR_RootConstrainSelectedInstOperands,
     /* 324176 */     // GIR_Coverage, 6223,
     /* 324176 */     GIR_EraseRootFromParent_Done,
     /* 324177 */   // Label 6365: @324177
     /* 324177 */   GIM_Try, /*On fail goto*//*Label 6366*/ GIMT_Encode4(324270), // Rule ID 6269 //
     /* 324182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324198 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324202 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324206 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324210 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324215 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324219 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324221 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324233 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324240 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324258 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324260 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324262 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324265 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324268 */     GIR_RootConstrainSelectedInstOperands,
     /* 324269 */     // GIR_Coverage, 6269,
     /* 324269 */     GIR_EraseRootFromParent_Done,
     /* 324270 */   // Label 6366: @324270
     /* 324270 */   GIM_Try, /*On fail goto*//*Label 6367*/ GIMT_Encode4(324366), // Rule ID 6127 //
     /* 324275 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324278 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324282 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324286 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324290 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324294 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324298 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 324302 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 324306 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324315 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 324317 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 324352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324356 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324364 */     GIR_RootConstrainSelectedInstOperands,
     /* 324365 */     // GIR_Coverage, 6127,
     /* 324365 */     GIR_EraseRootFromParent_Done,
     /* 324366 */   // Label 6367: @324366
     /* 324366 */   GIM_Try, /*On fail goto*//*Label 6368*/ GIMT_Encode4(324450), // Rule ID 2542 //
     /* 324371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324401 */     // (fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324401 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324404 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324408 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324413 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324416 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324420 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324423 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324438 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324440 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324445 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324448 */     GIR_RootConstrainSelectedInstOperands,
     /* 324449 */     // GIR_Coverage, 2542,
     /* 324449 */     GIR_EraseRootFromParent_Done,
     /* 324450 */   // Label 6368: @324450
     /* 324450 */   GIM_Try, /*On fail goto*//*Label 6369*/ GIMT_Encode4(324500), // Rule ID 13412 //
     /* 324455 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324475 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324479 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324483 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324485 */     // (fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324485 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 324488 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324490 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324492 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324498 */     GIR_RootConstrainSelectedInstOperands,
     /* 324499 */     // GIR_Coverage, 13412,
     /* 324499 */     GIR_EraseRootFromParent_Done,
     /* 324500 */   // Label 6369: @324500
     /* 324500 */   GIM_Try, /*On fail goto*//*Label 6370*/ GIMT_Encode4(324584), // Rule ID 6095 //
     /* 324505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 324520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 324524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324535 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 324535 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 324538 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 324542 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 324547 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 324550 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324554 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 324557 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324562 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 324567 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 324570 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324572 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324574 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324576 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 324579 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 324582 */     GIR_RootConstrainSelectedInstOperands,
     /* 324583 */     // GIR_Coverage, 6095,
     /* 324583 */     GIR_EraseRootFromParent_Done,
     /* 324584 */   // Label 6370: @324584
     /* 324584 */   GIM_Try, /*On fail goto*//*Label 6371*/ GIMT_Encode4(324634), // Rule ID 1310 //
     /* 324589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324592 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 324608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324613 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324617 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 324619 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324619 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 324622 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324624 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324626 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 324628 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324632 */     GIR_RootConstrainSelectedInstOperands,
     /* 324633 */     // GIR_Coverage, 1310,
     /* 324633 */     GIR_EraseRootFromParent_Done,
     /* 324634 */   // Label 6371: @324634
     /* 324634 */   GIM_Try, /*On fail goto*//*Label 6372*/ GIMT_Encode4(324667), // Rule ID 1300 //
     /* 324639 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 324642 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324646 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324650 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324654 */     // (fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 324654 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 324657 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324659 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324661 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 324665 */     GIR_RootConstrainSelectedInstOperands,
     /* 324666 */     // GIR_Coverage, 1300,
     /* 324666 */     GIR_EraseRootFromParent_Done,
     /* 324667 */   // Label 6372: @324667
     /* 324667 */   GIM_Reject,
     /* 324668 */ // Label 6353: @324668
     /* 324668 */ GIM_Reject,
     /* 324669 */ // Label 6192: @324669
     /* 324669 */ GIM_Try, /*On fail goto*//*Label 6373*/ GIMT_Encode4(325847),
     /* 324674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 324680 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 324683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324687 */   GIM_Try, /*On fail goto*//*Label 6374*/ GIMT_Encode4(324771), // Rule ID 6141 //
     /* 324692 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324695 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324699 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324703 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324707 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 324711 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324716 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 324720 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324724 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324728 */     // MIs[2] Operand 1
     /* 324728 */     // No operand predicates
     /* 324728 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 324732 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324736 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324740 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324749 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324751 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324751 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324754 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324756 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 324762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 324766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 324769 */     GIR_RootConstrainSelectedInstOperands,
     /* 324770 */     // GIR_Coverage, 6141,
     /* 324770 */     GIR_EraseRootFromParent_Done,
     /* 324771 */   // Label 6374: @324771
     /* 324771 */   GIM_Try, /*On fail goto*//*Label 6375*/ GIMT_Encode4(324852), // Rule ID 6173 //
     /* 324776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324779 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324783 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324787 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324791 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324795 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324799 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324803 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324807 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324812 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324816 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324820 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324824 */     // MIs[3] Operand 1
     /* 324824 */     // No operand predicates
     /* 324824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324828 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324832 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324834 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324834 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324837 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324839 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324841 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 324843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324847 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324850 */     GIR_RootConstrainSelectedInstOperands,
     /* 324851 */     // GIR_Coverage, 6173,
     /* 324851 */     GIR_EraseRootFromParent_Done,
     /* 324852 */   // Label 6375: @324852
     /* 324852 */   GIM_Try, /*On fail goto*//*Label 6376*/ GIMT_Encode4(324936), // Rule ID 6205 //
     /* 324857 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324860 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 324864 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324868 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324872 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324877 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 324881 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324885 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324889 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324893 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324898 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324902 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324906 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324910 */     // MIs[3] Operand 1
     /* 324910 */     // No operand predicates
     /* 324910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324916 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 324919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 324921 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 324923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 324927 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 324931 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 324934 */     GIR_RootConstrainSelectedInstOperands,
     /* 324935 */     // GIR_Coverage, 6205,
     /* 324935 */     GIR_EraseRootFromParent_Done,
     /* 324936 */   // Label 6376: @324936
     /* 324936 */   GIM_Try, /*On fail goto*//*Label 6377*/ GIMT_Encode4(325017), // Rule ID 6109 //
     /* 324941 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 324944 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324948 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 324952 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 324956 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324960 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 324964 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 324968 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 324972 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 324976 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 324981 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 324985 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 324989 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 324993 */     // MIs[3] Operand 1
     /* 324993 */     // No operand predicates
     /* 324993 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 324997 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 324999 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 324999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325004 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325006 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325008 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 325015 */     GIR_RootConstrainSelectedInstOperands,
     /* 325016 */     // GIR_Coverage, 6109,
     /* 325016 */     GIR_EraseRootFromParent_Done,
     /* 325017 */   // Label 6377: @325017
     /* 325017 */   GIM_Try, /*On fail goto*//*Label 6378*/ GIMT_Encode4(325086), // Rule ID 2524 //
     /* 325022 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325029 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325033 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325037 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325041 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325046 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325050 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325054 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325058 */     // MIs[2] Operand 1
     /* 325058 */     // No operand predicates
     /* 325058 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325062 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325068 */     // (fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325068 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325071 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325073 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325075 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325077 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325081 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325084 */     GIR_RootConstrainSelectedInstOperands,
     /* 325085 */     // GIR_Coverage, 2524,
     /* 325085 */     GIR_EraseRootFromParent_Done,
     /* 325086 */   // Label 6378: @325086
     /* 325086 */   GIM_Try, /*On fail goto*//*Label 6379*/ GIMT_Encode4(325155), // Rule ID 6077 //
     /* 325091 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325094 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 325106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325110 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 325114 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 325119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 325123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 325127 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 325131 */     // MIs[2] Operand 1
     /* 325131 */     // No operand predicates
     /* 325131 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325135 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325137 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 325137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325142 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325144 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325146 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325150 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 325153 */     GIR_RootConstrainSelectedInstOperands,
     /* 325154 */     // GIR_Coverage, 6077,
     /* 325154 */     GIR_EraseRootFromParent_Done,
     /* 325155 */   // Label 6379: @325155
     /* 325155 */   GIM_Try, /*On fail goto*//*Label 6380*/ GIMT_Encode4(325254), // Rule ID 6143 //
     /* 325160 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325163 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325167 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325171 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325175 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325180 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325184 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325188 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325192 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325197 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325203 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325203 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325206 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325210 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325215 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325218 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325222 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325225 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325230 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 325246 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325249 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325252 */     GIR_RootConstrainSelectedInstOperands,
     /* 325253 */     // GIR_Coverage, 6143,
     /* 325253 */     GIR_EraseRootFromParent_Done,
     /* 325254 */   // Label 6380: @325254
     /* 325254 */   GIM_Try, /*On fail goto*//*Label 6381*/ GIMT_Encode4(325350), // Rule ID 6175 //
     /* 325259 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325270 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325282 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325286 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325295 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325299 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325301 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325301 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325304 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325308 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325313 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325316 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325320 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325323 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325328 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325338 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325340 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325342 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325345 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325348 */     GIR_RootConstrainSelectedInstOperands,
     /* 325349 */     // GIR_Coverage, 6175,
     /* 325349 */     GIR_EraseRootFromParent_Done,
     /* 325350 */   // Label 6381: @325350
     /* 325350 */   GIM_Try, /*On fail goto*//*Label 6382*/ GIMT_Encode4(325449), // Rule ID 6207 //
     /* 325355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325358 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325362 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325366 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325370 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325375 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 325379 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325383 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325387 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325392 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325396 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325398 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325410 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325413 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325417 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325435 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325437 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 325441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325447 */     GIR_RootConstrainSelectedInstOperands,
     /* 325448 */     // GIR_Coverage, 6207,
     /* 325448 */     GIR_EraseRootFromParent_Done,
     /* 325449 */   // Label 6382: @325449
     /* 325449 */   GIM_Try, /*On fail goto*//*Label 6383*/ GIMT_Encode4(325545), // Rule ID 6111 //
     /* 325454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325457 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325461 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325465 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325469 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325473 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 325477 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 325481 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 325485 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325490 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 325496 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325496 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325499 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325503 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325508 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325511 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 325515 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 325531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325533 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325537 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325540 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325543 */     GIR_RootConstrainSelectedInstOperands,
     /* 325544 */     // GIR_Coverage, 6111,
     /* 325544 */     GIR_EraseRootFromParent_Done,
     /* 325545 */   // Label 6383: @325545
     /* 325545 */   GIM_Try, /*On fail goto*//*Label 6384*/ GIMT_Encode4(325629), // Rule ID 2526 //
     /* 325550 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325561 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325565 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325570 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325574 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325578 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325580 */     // (fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325580 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325583 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325587 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325592 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325595 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325599 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325602 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325607 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325624 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325627 */     GIR_RootConstrainSelectedInstOperands,
     /* 325628 */     // GIR_Coverage, 2526,
     /* 325628 */     GIR_EraseRootFromParent_Done,
     /* 325629 */   // Label 6384: @325629
     /* 325629 */   GIM_Try, /*On fail goto*//*Label 6385*/ GIMT_Encode4(325679), // Rule ID 13408 //
     /* 325634 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325637 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 325641 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325645 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325654 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325658 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325662 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325664 */     // (fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325664 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 325667 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325669 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325671 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325673 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325677 */     GIR_RootConstrainSelectedInstOperands,
     /* 325678 */     // GIR_Coverage, 13408,
     /* 325678 */     GIR_EraseRootFromParent_Done,
     /* 325679 */   // Label 6385: @325679
     /* 325679 */   GIM_Try, /*On fail goto*//*Label 6386*/ GIMT_Encode4(325763), // Rule ID 6079 //
     /* 325684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325687 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 325699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 325703 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325708 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325712 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325714 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 325714 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 325717 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 325721 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 325726 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 325729 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325733 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 325736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 325746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 325749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325751 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325753 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 325758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 325761 */     GIR_RootConstrainSelectedInstOperands,
     /* 325762 */     // GIR_Coverage, 6079,
     /* 325762 */     GIR_EraseRootFromParent_Done,
     /* 325763 */   // Label 6386: @325763
     /* 325763 */   GIM_Try, /*On fail goto*//*Label 6387*/ GIMT_Encode4(325813), // Rule ID 1306 //
     /* 325768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 325779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 325783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 325787 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325792 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325796 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 325798 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 325801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325805 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 325807 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 325811 */     GIR_RootConstrainSelectedInstOperands,
     /* 325812 */     // GIR_Coverage, 1306,
     /* 325812 */     GIR_EraseRootFromParent_Done,
     /* 325813 */   // Label 6387: @325813
     /* 325813 */   GIM_Try, /*On fail goto*//*Label 6388*/ GIMT_Encode4(325846), // Rule ID 1296 //
     /* 325818 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 325821 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325825 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 325833 */     // (fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 325833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 325836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 325838 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 325840 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 325842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 325844 */     GIR_RootConstrainSelectedInstOperands,
     /* 325845 */     // GIR_Coverage, 1296,
     /* 325845 */     GIR_EraseRootFromParent_Done,
     /* 325846 */   // Label 6388: @325846
     /* 325846 */   GIM_Reject,
     /* 325847 */ // Label 6373: @325847
     /* 325847 */ GIM_Reject,
     /* 325848 */ // Label 6193: @325848
     /* 325848 */ GIM_Reject,
     /* 325849 */ // Label 63: @325849
     /* 325849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6397*/ GIMT_Encode4(326464),
     /* 325860 */ /*GILLT_s16*//*Label 6389*/ GIMT_Encode4(325900),
     /* 325864 */ /*GILLT_s32*//*Label 6390*/ GIMT_Encode4(325938),
     /* 325868 */ /*GILLT_s64*//*Label 6391*/ GIMT_Encode4(325976), GIMT_Encode4(0),
     /* 325876 */ /*GILLT_v2s32*//*Label 6392*/ GIMT_Encode4(326014),
     /* 325880 */ /*GILLT_v2s64*//*Label 6393*/ GIMT_Encode4(326052),
     /* 325884 */ /*GILLT_v4s16*//*Label 6394*/ GIMT_Encode4(326090),
     /* 325888 */ /*GILLT_v4s32*//*Label 6395*/ GIMT_Encode4(326128), GIMT_Encode4(0),
     /* 325896 */ /*GILLT_v8s16*//*Label 6396*/ GIMT_Encode4(326166),
     /* 325900 */ // Label 6389: @325900
     /* 325900 */ GIM_Try, /*On fail goto*//*Label 6398*/ GIMT_Encode4(325937), // Rule ID 590 //
     /* 325905 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 325908 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 325911 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 325914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325918 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325922 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 325926 */   // (fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 325926 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 325931 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325935 */   GIR_RootConstrainSelectedInstOperands,
     /* 325936 */   // GIR_Coverage, 590,
     /* 325936 */   GIR_Done,
     /* 325937 */ // Label 6398: @325937
     /* 325937 */ GIM_Reject,
     /* 325938 */ // Label 6390: @325938
     /* 325938 */ GIM_Try, /*On fail goto*//*Label 6399*/ GIMT_Encode4(325975), // Rule ID 592 //
     /* 325943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 325949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 325952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 325964 */   // (fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 325964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 325969 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 325973 */   GIR_RootConstrainSelectedInstOperands,
     /* 325974 */   // GIR_Coverage, 592,
     /* 325974 */   GIR_Done,
     /* 325975 */ // Label 6399: @325975
     /* 325975 */ GIM_Reject,
     /* 325976 */ // Label 6391: @325976
     /* 325976 */ GIM_Try, /*On fail goto*//*Label 6400*/ GIMT_Encode4(326013), // Rule ID 594 //
     /* 325981 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 325984 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 325987 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 325990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 325998 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326002 */   // (fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 326002 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 326007 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326011 */   GIR_RootConstrainSelectedInstOperands,
     /* 326012 */   // GIR_Coverage, 594,
     /* 326012 */   GIR_Done,
     /* 326013 */ // Label 6400: @326013
     /* 326013 */ GIM_Reject,
     /* 326014 */ // Label 6392: @326014
     /* 326014 */ GIM_Try, /*On fail goto*//*Label 6401*/ GIMT_Encode4(326051), // Rule ID 1228 //
     /* 326019 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326022 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 326025 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 326028 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326032 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326036 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326040 */   // (fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 326040 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 326045 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326049 */   GIR_RootConstrainSelectedInstOperands,
     /* 326050 */   // GIR_Coverage, 1228,
     /* 326050 */   GIR_Done,
     /* 326051 */ // Label 6401: @326051
     /* 326051 */ GIM_Reject,
     /* 326052 */ // Label 6393: @326052
     /* 326052 */ GIM_Try, /*On fail goto*//*Label 6402*/ GIMT_Encode4(326089), // Rule ID 1232 //
     /* 326057 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326060 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 326063 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 326066 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326070 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326074 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326078 */   // (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 326078 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 326083 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326087 */   GIR_RootConstrainSelectedInstOperands,
     /* 326088 */   // GIR_Coverage, 1232,
     /* 326088 */   GIR_Done,
     /* 326089 */ // Label 6402: @326089
     /* 326089 */ GIM_Reject,
     /* 326090 */ // Label 6394: @326090
     /* 326090 */ GIM_Try, /*On fail goto*//*Label 6403*/ GIMT_Encode4(326127), // Rule ID 1224 //
     /* 326095 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326098 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 326101 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 326104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326108 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326112 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326116 */   // (fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 326116 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 326121 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326125 */   GIR_RootConstrainSelectedInstOperands,
     /* 326126 */   // GIR_Coverage, 1224,
     /* 326126 */   GIR_Done,
     /* 326127 */ // Label 6403: @326127
     /* 326127 */ GIM_Reject,
     /* 326128 */ // Label 6395: @326128
     /* 326128 */ GIM_Try, /*On fail goto*//*Label 6404*/ GIMT_Encode4(326165), // Rule ID 1230 //
     /* 326133 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 326136 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 326139 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 326142 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326146 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326150 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326154 */   // (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 326154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326163 */   GIR_RootConstrainSelectedInstOperands,
     /* 326164 */   // GIR_Coverage, 1230,
     /* 326164 */   GIR_Done,
     /* 326165 */ // Label 6404: @326165
     /* 326165 */ GIM_Reject,
     /* 326166 */ // Label 6396: @326166
     /* 326166 */ GIM_Try, /*On fail goto*//*Label 6405*/ GIMT_Encode4(326463),
     /* 326171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 326177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326185 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326189 */   GIM_Try, /*On fail goto*//*Label 6406*/ GIMT_Encode4(326208), // Rule ID 1226 //
     /* 326194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 326197 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 326197 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 326202 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 326206 */     GIR_RootConstrainSelectedInstOperands,
     /* 326207 */     // GIR_Coverage, 1226,
     /* 326207 */     GIR_Done,
     /* 326208 */   // Label 6406: @326208
     /* 326208 */   GIM_Try, /*On fail goto*//*Label 6407*/ GIMT_Encode4(326462), // Rule ID 7044 //
     /* 326213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 326216 */     // (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 326216 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 326219 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326223 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326228 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 326232 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 326234 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 326237 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 326241 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326246 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 326250 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 326252 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 326255 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326259 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326264 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 326267 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 326270 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 326272 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 326275 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326279 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326284 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 326290 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326295 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326300 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 326303 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326307 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326312 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 326315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 326317 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 326320 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326324 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326329 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 326335 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326340 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326345 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 326348 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 326352 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326357 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 326360 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 326362 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 326365 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 326369 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326374 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 326377 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 326380 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 326382 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 326385 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 326389 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326394 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 326397 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 326399 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 326402 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 326406 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326411 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 326413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 326416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 326420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326425 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 326428 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 326431 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 326434 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326439 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326444 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 326449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 326452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 326454 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326457 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 326460 */     GIR_RootConstrainSelectedInstOperands,
     /* 326461 */     // GIR_Coverage, 7044,
     /* 326461 */     GIR_EraseRootFromParent_Done,
     /* 326462 */   // Label 6407: @326462
     /* 326462 */   GIM_Reject,
     /* 326463 */ // Label 6405: @326463
     /* 326463 */ GIM_Reject,
     /* 326464 */ // Label 6397: @326464
     /* 326464 */ GIM_Reject,
     /* 326465 */ // Label 64: @326465
     /* 326465 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6416*/ GIMT_Encode4(329971),
     /* 326476 */ /*GILLT_s16*//*Label 6408*/ GIMT_Encode4(326516),
     /* 326480 */ /*GILLT_s32*//*Label 6409*/ GIMT_Encode4(327684),
     /* 326484 */ /*GILLT_s64*//*Label 6410*/ GIMT_Encode4(328707), GIMT_Encode4(0),
     /* 326492 */ /*GILLT_v2s32*//*Label 6411*/ GIMT_Encode4(329730),
     /* 326496 */ /*GILLT_v2s64*//*Label 6412*/ GIMT_Encode4(329757),
     /* 326500 */ /*GILLT_v4s16*//*Label 6413*/ GIMT_Encode4(329784),
     /* 326504 */ /*GILLT_v4s32*//*Label 6414*/ GIMT_Encode4(329864), GIMT_Encode4(0),
     /* 326512 */ /*GILLT_v8s16*//*Label 6415*/ GIMT_Encode4(329891),
     /* 326516 */ // Label 6408: @326516
     /* 326516 */ GIM_Try, /*On fail goto*//*Label 6417*/ GIMT_Encode4(327683),
     /* 326521 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 326524 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326528 */   GIM_Try, /*On fail goto*//*Label 6418*/ GIMT_Encode4(326686), // Rule ID 4882 //
     /* 326533 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326536 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326540 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326544 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326548 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326552 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326564 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326568 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326572 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326577 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326581 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326585 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326589 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326593 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326597 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326602 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326606 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326611 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326613 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 326616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326625 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326631 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326636 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326653 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326674 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326677 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326684 */     GIR_RootConstrainSelectedInstOperands,
     /* 326685 */     // GIR_Coverage, 4882,
     /* 326685 */     GIR_EraseRootFromParent_Done,
     /* 326686 */   // Label 6418: @326686
     /* 326686 */   GIM_Try, /*On fail goto*//*Label 6419*/ GIMT_Encode4(326844), // Rule ID 4881 //
     /* 326691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326698 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 326702 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326706 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326710 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326722 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326726 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326730 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326735 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326739 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 326743 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326747 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326751 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 326755 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326760 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 326764 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326769 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 326771 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 326771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 326774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326783 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 326789 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326794 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326799 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326802 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326806 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326811 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326822 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 326838 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326842 */     GIR_RootConstrainSelectedInstOperands,
     /* 326843 */     // GIR_Coverage, 4881,
     /* 326843 */     GIR_EraseRootFromParent_Done,
     /* 326844 */   // Label 6419: @326844
     /* 326844 */   GIM_Try, /*On fail goto*//*Label 6420*/ GIMT_Encode4(326955), // Rule ID 4880 //
     /* 326849 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326852 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326856 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326860 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326864 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326868 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 326876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326880 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 326884 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 326888 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326893 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 326897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326907 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 326909 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 326909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 326912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 326916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 326921 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 326927 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326932 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 326937 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 326940 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 326942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 326945 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 326949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 326953 */     GIR_RootConstrainSelectedInstOperands,
     /* 326954 */     // GIR_Coverage, 4880,
     /* 326954 */     GIR_EraseRootFromParent_Done,
     /* 326955 */   // Label 6420: @326955
     /* 326955 */   GIM_Try, /*On fail goto*//*Label 6421*/ GIMT_Encode4(327066), // Rule ID 4878 //
     /* 326960 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 326963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 326967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 326971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 326975 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 326979 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 326983 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 326988 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 326992 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 326996 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327000 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327004 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327009 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327013 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327018 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327020 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327053 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327060 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327064 */     GIR_RootConstrainSelectedInstOperands,
     /* 327065 */     // GIR_Coverage, 4878,
     /* 327065 */     GIR_EraseRootFromParent_Done,
     /* 327066 */   // Label 6421: @327066
     /* 327066 */   GIM_Try, /*On fail goto*//*Label 6422*/ GIMT_Encode4(327177), // Rule ID 4879 //
     /* 327071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327090 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327106 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327110 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327115 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327124 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327129 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327131 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327143 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 327149 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327154 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327164 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327167 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327175 */     GIR_RootConstrainSelectedInstOperands,
     /* 327176 */     // GIR_Coverage, 4879,
     /* 327176 */     GIR_EraseRootFromParent_Done,
     /* 327177 */   // Label 6422: @327177
     /* 327177 */   GIM_Try, /*On fail goto*//*Label 6423*/ GIMT_Encode4(327288), // Rule ID 4877 //
     /* 327182 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327185 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327189 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327193 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327197 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327201 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327205 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 327214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 327222 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327226 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327231 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327235 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 327242 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 327242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 327245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 327260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327275 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327279 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327282 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327286 */     GIR_RootConstrainSelectedInstOperands,
     /* 327287 */     // GIR_Coverage, 4877,
     /* 327287 */     GIR_EraseRootFromParent_Done,
     /* 327288 */   // Label 6423: @327288
     /* 327288 */   GIM_Try, /*On fail goto*//*Label 6424*/ GIMT_Encode4(327352), // Rule ID 650 //
     /* 327293 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327296 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327300 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327304 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327308 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327312 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327316 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327321 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327326 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327331 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327333 */     // (fneg:{ *:[f16] } (fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327333 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327336 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327338 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327350 */     GIR_RootConstrainSelectedInstOperands,
     /* 327351 */     // GIR_Coverage, 650,
     /* 327351 */     GIR_EraseRootFromParent_Done,
     /* 327352 */   // Label 6424: @327352
     /* 327352 */   GIM_Try, /*On fail goto*//*Label 6425*/ GIMT_Encode4(327416), // Rule ID 649 //
     /* 327357 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327372 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327376 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s16,
     /* 327380 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327385 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327390 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327395 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327397 */     // (fneg:{ *:[f16] } (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra))  =>  (FNMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 327397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDHrrr),
     /* 327400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327402 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327406 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327414 */     GIR_RootConstrainSelectedInstOperands,
     /* 327415 */     // GIR_Coverage, 649,
     /* 327415 */     GIR_EraseRootFromParent_Done,
     /* 327416 */   // Label 6425: @327416
     /* 327416 */   GIM_Try, /*On fail goto*//*Label 6426*/ GIMT_Encode4(327467), // Rule ID 626 //
     /* 327421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327424 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327428 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 327432 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327436 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327445 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327450 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327452 */     // (fneg:{ *:[f16] } (fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327452 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 327455 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327457 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327461 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327465 */     GIR_RootConstrainSelectedInstOperands,
     /* 327466 */     // GIR_Coverage, 626,
     /* 327466 */     GIR_EraseRootFromParent_Done,
     /* 327467 */   // Label 6426: @327467
     /* 327467 */   GIM_Try, /*On fail goto*//*Label 6427*/ GIMT_Encode4(327518), // Rule ID 625 //
     /* 327472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327475 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327479 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 327483 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 327487 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 327491 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327496 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327501 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 327503 */     // (fneg:{ *:[f16] } (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm))  =>  (FNMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 327503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULHrr),
     /* 327506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 327512 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 327516 */     GIR_RootConstrainSelectedInstOperands,
     /* 327517 */     // GIR_Coverage, 625,
     /* 327517 */     GIR_EraseRootFromParent_Done,
     /* 327518 */   // Label 6427: @327518
     /* 327518 */   GIM_Try, /*On fail goto*//*Label 6428*/ GIMT_Encode4(327537), // Rule ID 524 //
     /* 327523 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 327526 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327530 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FNEGHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 327530 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGHr),
     /* 327535 */     GIR_RootConstrainSelectedInstOperands,
     /* 327536 */     // GIR_Coverage, 524,
     /* 327536 */     GIR_Done,
     /* 327537 */   // Label 6428: @327537
     /* 327537 */   GIM_Try, /*On fail goto*//*Label 6429*/ GIMT_Encode4(327682), // Rule ID 6409 //
     /* 327542 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327546 */     // (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (EORWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32768:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 327546 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 327549 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 327553 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327558 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 327560 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 327563 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 327567 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327572 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 327575 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 327579 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 327582 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327587 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327592 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327597 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 327600 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327604 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327609 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 327612 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 327617 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327620 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::EORWri),
     /* 327624 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327629 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 327632 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 327637 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 327639 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327642 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327646 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327651 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 327654 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327659 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327662 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 327664 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 327671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 327676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327681 */     // GIR_Coverage, 6409,
     /* 327681 */     GIR_EraseRootFromParent_Done,
     /* 327682 */   // Label 6429: @327682
     /* 327682 */   GIM_Reject,
     /* 327683 */ // Label 6417: @327683
     /* 327683 */ GIM_Reject,
     /* 327684 */ // Label 6409: @327684
     /* 327684 */ GIM_Try, /*On fail goto*//*Label 6430*/ GIMT_Encode4(328706),
     /* 327689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 327692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327696 */   GIM_Try, /*On fail goto*//*Label 6431*/ GIMT_Encode4(327854), // Rule ID 4888 //
     /* 327701 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327704 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327708 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 327712 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327716 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327720 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327724 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327728 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327732 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327736 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327740 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327745 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327749 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327753 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327757 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327761 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327765 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327770 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327774 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327779 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327781 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327781 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327784 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327788 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327793 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327799 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327804 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 327842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 327845 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 327848 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 327852 */     GIR_RootConstrainSelectedInstOperands,
     /* 327853 */     // GIR_Coverage, 4888,
     /* 327853 */     GIR_EraseRootFromParent_Done,
     /* 327854 */   // Label 6431: @327854
     /* 327854 */   GIM_Try, /*On fail goto*//*Label 6432*/ GIMT_Encode4(328012), // Rule ID 4887 //
     /* 327859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 327862 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 327866 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 327870 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 327874 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 327878 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 327882 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 327886 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327890 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327894 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 327898 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327903 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 327907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 327911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 327915 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 327919 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 327923 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327928 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 327932 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327937 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 327939 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 327939 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 327942 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327946 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327951 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 327957 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327962 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 327970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 327974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 327979 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 327985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 327990 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 327995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 327998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328000 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328006 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328010 */     GIR_RootConstrainSelectedInstOperands,
     /* 328011 */     // GIR_Coverage, 4887,
     /* 328011 */     GIR_EraseRootFromParent_Done,
     /* 328012 */   // Label 6432: @328012
     /* 328012 */   GIM_Try, /*On fail goto*//*Label 6433*/ GIMT_Encode4(328123), // Rule ID 4886 //
     /* 328017 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328032 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328036 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328040 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328044 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328048 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328052 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328056 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328061 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328065 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328070 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328077 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328077 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328080 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328084 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328089 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328095 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328100 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328105 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328108 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328110 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328113 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328117 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328121 */     GIR_RootConstrainSelectedInstOperands,
     /* 328122 */     // GIR_Coverage, 4886,
     /* 328122 */     GIR_EraseRootFromParent_Done,
     /* 328123 */   // Label 6433: @328123
     /* 328123 */   GIM_Try, /*On fail goto*//*Label 6434*/ GIMT_Encode4(328234), // Rule ID 4884 //
     /* 328128 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328131 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328135 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328139 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328143 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328147 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328151 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328164 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328168 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328172 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328177 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328181 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328186 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328188 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328200 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328206 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328211 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328225 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328228 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328232 */     GIR_RootConstrainSelectedInstOperands,
     /* 328233 */     // GIR_Coverage, 4884,
     /* 328233 */     GIR_EraseRootFromParent_Done,
     /* 328234 */   // Label 6434: @328234
     /* 328234 */   GIM_Try, /*On fail goto*//*Label 6435*/ GIMT_Encode4(328345), // Rule ID 4885 //
     /* 328239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328246 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328250 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328254 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328258 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328262 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328266 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328270 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328274 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328278 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328283 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328287 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328292 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328299 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 328317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328335 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328339 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328343 */     GIR_RootConstrainSelectedInstOperands,
     /* 328344 */     // GIR_Coverage, 4885,
     /* 328344 */     GIR_EraseRootFromParent_Done,
     /* 328345 */   // Label 6435: @328345
     /* 328345 */   GIM_Try, /*On fail goto*//*Label 6436*/ GIMT_Encode4(328456), // Rule ID 4883 //
     /* 328350 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328353 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328357 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328361 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328365 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328369 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328373 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328378 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 328382 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328386 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 328390 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328394 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328399 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328403 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328408 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 328410 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 328410 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 328413 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328417 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328422 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 328428 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328438 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328441 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328443 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328447 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328450 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328454 */     GIR_RootConstrainSelectedInstOperands,
     /* 328455 */     // GIR_Coverage, 4883,
     /* 328455 */     GIR_EraseRootFromParent_Done,
     /* 328456 */   // Label 6436: @328456
     /* 328456 */   GIM_Try, /*On fail goto*//*Label 6437*/ GIMT_Encode4(328520), // Rule ID 652 //
     /* 328461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328480 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328499 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328501 */     // (fneg:{ *:[f32] } (fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328506 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328510 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328518 */     GIR_RootConstrainSelectedInstOperands,
     /* 328519 */     // GIR_Coverage, 652,
     /* 328519 */     GIR_EraseRootFromParent_Done,
     /* 328520 */   // Label 6437: @328520
     /* 328520 */   GIM_Try, /*On fail goto*//*Label 6438*/ GIMT_Encode4(328584), // Rule ID 651 //
     /* 328525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328544 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s32,
     /* 328548 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328558 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328563 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328565 */     // (fneg:{ *:[f32] } (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra))  =>  (FNMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 328565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDSrrr),
     /* 328568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328574 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328578 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328582 */     GIR_RootConstrainSelectedInstOperands,
     /* 328583 */     // GIR_Coverage, 651,
     /* 328583 */     GIR_EraseRootFromParent_Done,
     /* 328584 */   // Label 6438: @328584
     /* 328584 */   GIM_Try, /*On fail goto*//*Label 6439*/ GIMT_Encode4(328635), // Rule ID 628 //
     /* 328589 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328592 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328596 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 328600 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328604 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328613 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328618 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328620 */     // (fneg:{ *:[f32] } (fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 328620 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 328623 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328625 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328629 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328633 */     GIR_RootConstrainSelectedInstOperands,
     /* 328634 */     // GIR_Coverage, 628,
     /* 328634 */     GIR_EraseRootFromParent_Done,
     /* 328635 */   // Label 6439: @328635
     /* 328635 */   GIM_Try, /*On fail goto*//*Label 6440*/ GIMT_Encode4(328686), // Rule ID 627 //
     /* 328640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328643 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328647 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 328651 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 328655 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 328659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328664 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328669 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 328671 */     // (fneg:{ *:[f32] } (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm))  =>  (FNMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 328671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULSrr),
     /* 328674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328676 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 328680 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 328684 */     GIR_RootConstrainSelectedInstOperands,
     /* 328685 */     // GIR_Coverage, 627,
     /* 328685 */     GIR_EraseRootFromParent_Done,
     /* 328686 */   // Label 6440: @328686
     /* 328686 */   GIM_Try, /*On fail goto*//*Label 6441*/ GIMT_Encode4(328705), // Rule ID 525 //
     /* 328691 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328694 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 328698 */     // (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FNEGSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 328698 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGSr),
     /* 328703 */     GIR_RootConstrainSelectedInstOperands,
     /* 328704 */     // GIR_Coverage, 525,
     /* 328704 */     GIR_Done,
     /* 328705 */   // Label 6441: @328705
     /* 328705 */   GIM_Reject,
     /* 328706 */ // Label 6430: @328706
     /* 328706 */ GIM_Reject,
     /* 328707 */ // Label 6410: @328707
     /* 328707 */ GIM_Try, /*On fail goto*//*Label 6442*/ GIMT_Encode4(329729),
     /* 328712 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 328715 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328719 */   GIM_Try, /*On fail goto*//*Label 6443*/ GIMT_Encode4(328877), // Rule ID 4894 //
     /* 328724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 328735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328739 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328743 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328747 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328751 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328755 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328759 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328763 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328768 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328780 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328784 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328788 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328793 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328797 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328802 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328804 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328804 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328807 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328811 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328816 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328827 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328832 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328835 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328839 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328844 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 328850 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328855 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 328863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 328865 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 328868 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 328871 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 328875 */     GIR_RootConstrainSelectedInstOperands,
     /* 328876 */     // GIR_Coverage, 4894,
     /* 328876 */     GIR_EraseRootFromParent_Done,
     /* 328877 */   // Label 6443: @328877
     /* 328877 */   GIM_Try, /*On fail goto*//*Label 6444*/ GIMT_Encode4(329035), // Rule ID 4893 //
     /* 328882 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 328885 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 328889 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 328893 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 328897 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 328901 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 328905 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 328909 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328913 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328917 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 328921 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328926 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 328930 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 328934 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 328938 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 328942 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 328946 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328951 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 328955 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 328962 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 328962 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 328965 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328969 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 328974 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 328980 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 328985 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 328990 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 328993 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 328997 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329002 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329008 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329013 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329026 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 329029 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329033 */     GIR_RootConstrainSelectedInstOperands,
     /* 329034 */     // GIR_Coverage, 4893,
     /* 329034 */     GIR_EraseRootFromParent_Done,
     /* 329035 */   // Label 6444: @329035
     /* 329035 */   GIM_Try, /*On fail goto*//*Label 6445*/ GIMT_Encode4(329146), // Rule ID 4892 //
     /* 329040 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329055 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329059 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329071 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329075 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329079 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329084 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329088 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329093 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329098 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329100 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329100 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329103 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329107 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329112 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329118 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329136 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329140 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329144 */     GIR_RootConstrainSelectedInstOperands,
     /* 329145 */     // GIR_Coverage, 4892,
     /* 329145 */     GIR_EraseRootFromParent_Done,
     /* 329146 */   // Label 6445: @329146
     /* 329146 */   GIM_Try, /*On fail goto*//*Label 6446*/ GIMT_Encode4(329257), // Rule ID 4890 //
     /* 329151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329166 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329170 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329174 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329179 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329183 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329187 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329191 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329195 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329200 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329204 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329209 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329211 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329211 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329214 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329218 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329223 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329229 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329239 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329242 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329248 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329251 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329255 */     GIR_RootConstrainSelectedInstOperands,
     /* 329256 */     // GIR_Coverage, 4890,
     /* 329256 */     GIR_EraseRootFromParent_Done,
     /* 329257 */   // Label 6446: @329257
     /* 329257 */   GIM_Try, /*On fail goto*//*Label 6447*/ GIMT_Encode4(329368), // Rule ID 4891 //
     /* 329262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329273 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329277 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329281 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 329289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329293 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329297 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329301 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329306 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329310 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329315 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329320 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329322 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329322 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329325 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329329 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329334 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 329340 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329345 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329350 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329353 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329358 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329366 */     GIR_RootConstrainSelectedInstOperands,
     /* 329367 */     // GIR_Coverage, 4891,
     /* 329367 */     GIR_EraseRootFromParent_Done,
     /* 329368 */   // Label 6447: @329368
     /* 329368 */   GIM_Try, /*On fail goto*//*Label 6448*/ GIMT_Encode4(329479), // Rule ID 4889 //
     /* 329373 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329376 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329380 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329384 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329388 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329392 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329396 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329401 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 329405 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 329409 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329413 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 329417 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329422 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 329426 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329431 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 329433 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 329433 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329436 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 329440 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329445 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 329451 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329456 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329461 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329464 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329466 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329470 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329473 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329477 */     GIR_RootConstrainSelectedInstOperands,
     /* 329478 */     // GIR_Coverage, 4889,
     /* 329478 */     GIR_EraseRootFromParent_Done,
     /* 329479 */   // Label 6448: @329479
     /* 329479 */   GIM_Try, /*On fail goto*//*Label 6449*/ GIMT_Encode4(329543), // Rule ID 654 //
     /* 329484 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMA),
     /* 329495 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329499 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329503 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329507 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329512 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329517 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329522 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329524 */     // (fneg:{ *:[f64] } (fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329529 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329533 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329537 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329541 */     GIR_RootConstrainSelectedInstOperands,
     /* 329542 */     // GIR_Coverage, 654,
     /* 329542 */     GIR_EraseRootFromParent_Done,
     /* 329543 */   // Label 6449: @329543
     /* 329543 */   GIM_Try, /*On fail goto*//*Label 6450*/ GIMT_Encode4(329607), // Rule ID 653 //
     /* 329548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMA),
     /* 329559 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329563 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329567 */     GIM_CheckType, /*MI*/1, /*Op*/3, /*Type*/GILLT_s64,
     /* 329571 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329576 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329586 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329588 */     // (fneg:{ *:[f64] } (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra))  =>  (FNMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 329588 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMADDDrrr),
     /* 329591 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/3, // Ra
     /* 329605 */     GIR_RootConstrainSelectedInstOperands,
     /* 329606 */     // GIR_Coverage, 653,
     /* 329606 */     GIR_EraseRootFromParent_Done,
     /* 329607 */   // Label 6450: @329607
     /* 329607 */   GIM_Try, /*On fail goto*//*Label 6451*/ GIMT_Encode4(329658), // Rule ID 630 //
     /* 329612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329615 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329619 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FMUL),
     /* 329623 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329627 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329631 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329636 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329641 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329643 */     // (fneg:{ *:[f64] } (fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 329643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 329646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329648 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329652 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329656 */     GIR_RootConstrainSelectedInstOperands,
     /* 329657 */     // GIR_Coverage, 630,
     /* 329657 */     GIR_EraseRootFromParent_Done,
     /* 329658 */   // Label 6451: @329658
     /* 329658 */   GIM_Try, /*On fail goto*//*Label 6452*/ GIMT_Encode4(329709), // Rule ID 629 //
     /* 329663 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 329670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_STRICT_FMUL),
     /* 329674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 329678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 329682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329687 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329692 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 329694 */     // (fneg:{ *:[f64] } (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm))  =>  (FNMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 329694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMULDrr),
     /* 329697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 329703 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 329707 */     GIR_RootConstrainSelectedInstOperands,
     /* 329708 */     // GIR_Coverage, 629,
     /* 329708 */     GIR_EraseRootFromParent_Done,
     /* 329709 */   // Label 6452: @329709
     /* 329709 */   GIM_Try, /*On fail goto*//*Label 6453*/ GIMT_Encode4(329728), // Rule ID 526 //
     /* 329714 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 329717 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329721 */     // (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FNEGDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 329721 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGDr),
     /* 329726 */     GIR_RootConstrainSelectedInstOperands,
     /* 329727 */     // GIR_Coverage, 526,
     /* 329727 */     GIR_Done,
     /* 329728 */   // Label 6453: @329728
     /* 329728 */   GIM_Reject,
     /* 329729 */ // Label 6442: @329729
     /* 329729 */ GIM_Reject,
     /* 329730 */ // Label 6411: @329730
     /* 329730 */ GIM_Try, /*On fail goto*//*Label 6454*/ GIMT_Encode4(329756), // Rule ID 860 //
     /* 329735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 329741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329749 */   // (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FNEGv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 329749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f32),
     /* 329754 */   GIR_RootConstrainSelectedInstOperands,
     /* 329755 */   // GIR_Coverage, 860,
     /* 329755 */   GIR_Done,
     /* 329756 */ // Label 6454: @329756
     /* 329756 */ GIM_Reject,
     /* 329757 */ // Label 6412: @329757
     /* 329757 */ GIM_Try, /*On fail goto*//*Label 6455*/ GIMT_Encode4(329783), // Rule ID 862 //
     /* 329762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 329768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329772 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329776 */   // (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FNEGv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 329776 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv2f64),
     /* 329781 */   GIR_RootConstrainSelectedInstOperands,
     /* 329782 */   // GIR_Coverage, 862,
     /* 329782 */   GIR_Done,
     /* 329783 */ // Label 6455: @329783
     /* 329783 */ GIM_Reject,
     /* 329784 */ // Label 6413: @329784
     /* 329784 */ GIM_Try, /*On fail goto*//*Label 6456*/ GIMT_Encode4(329863),
     /* 329789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 329792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 329800 */   GIM_Try, /*On fail goto*//*Label 6457*/ GIMT_Encode4(329815), // Rule ID 858 //
     /* 329805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329808 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FNEGv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 329808 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f16),
     /* 329813 */     GIR_RootConstrainSelectedInstOperands,
     /* 329814 */     // GIR_Coverage, 858,
     /* 329814 */     GIR_Done,
     /* 329815 */   // Label 6457: @329815
     /* 329815 */   GIM_Try, /*On fail goto*//*Label 6458*/ GIMT_Encode4(329862), // Rule ID 6412 //
     /* 329820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329823 */     // (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (EORv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (MOVIv4i16:{ *:[i64] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329823 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 329826 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv4i16),
     /* 329830 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329835 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329845 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv8i8),
     /* 329853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329855 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329860 */     GIR_RootConstrainSelectedInstOperands,
     /* 329861 */     // GIR_Coverage, 6412,
     /* 329861 */     GIR_EraseRootFromParent_Done,
     /* 329862 */   // Label 6458: @329862
     /* 329862 */   GIM_Reject,
     /* 329863 */ // Label 6456: @329863
     /* 329863 */ GIM_Reject,
     /* 329864 */ // Label 6414: @329864
     /* 329864 */ GIM_Try, /*On fail goto*//*Label 6459*/ GIMT_Encode4(329890), // Rule ID 861 //
     /* 329869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 329875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329879 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329883 */   // (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FNEGv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 329883 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv4f32),
     /* 329888 */   GIR_RootConstrainSelectedInstOperands,
     /* 329889 */   // GIR_Coverage, 861,
     /* 329889 */   GIR_Done,
     /* 329890 */ // Label 6459: @329890
     /* 329890 */ GIM_Reject,
     /* 329891 */ // Label 6415: @329891
     /* 329891 */ GIM_Try, /*On fail goto*//*Label 6460*/ GIMT_Encode4(329970),
     /* 329896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 329899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 329907 */   GIM_Try, /*On fail goto*//*Label 6461*/ GIMT_Encode4(329922), // Rule ID 859 //
     /* 329912 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 329915 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FNEGv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 329915 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FNEGv8f16),
     /* 329920 */     GIR_RootConstrainSelectedInstOperands,
     /* 329921 */     // GIR_Coverage, 859,
     /* 329921 */     GIR_Done,
     /* 329922 */   // Label 6461: @329922
     /* 329922 */   GIM_Try, /*On fail goto*//*Label 6462*/ GIMT_Encode4(329969), // Rule ID 6413 //
     /* 329927 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 329930 */     // (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (EORv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (MOVIv8i16:{ *:[f128] } 128:{ *:[i32] }, 8:{ *:[i32] }))
     /* 329930 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 329933 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv8i16),
     /* 329937 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 329942 */     GIR_AddImm, /*InsnID*/1, /*Imm*/GIMT_Encode8(128),
     /* 329952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 329955 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 329957 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EORv16i8),
     /* 329960 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 329962 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 329964 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 329967 */     GIR_RootConstrainSelectedInstOperands,
     /* 329968 */     // GIR_Coverage, 6413,
     /* 329968 */     GIR_EraseRootFromParent_Done,
     /* 329969 */   // Label 6462: @329969
     /* 329969 */   GIM_Reject,
     /* 329970 */ // Label 6460: @329970
     /* 329970 */ GIM_Reject,
     /* 329971 */ // Label 6416: @329971
     /* 329971 */ GIM_Reject,
     /* 329972 */ // Label 65: @329972
     /* 329972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(9), /*)*//*default:*//*Label 6467*/ GIMT_Encode4(330219),
     /* 329983 */ /*GILLT_s32*//*Label 6463*/ GIMT_Encode4(330011),
     /* 329987 */ /*GILLT_s64*//*Label 6464*/ GIMT_Encode4(330042), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 329999 */ /*GILLT_v2s64*//*Label 6465*/ GIMT_Encode4(330103), GIMT_Encode4(0),
     /* 330007 */ /*GILLT_v4s32*//*Label 6466*/ GIMT_Encode4(330161),
     /* 330011 */ // Label 6463: @330011
     /* 330011 */ GIM_Try, /*On fail goto*//*Label 6468*/ GIMT_Encode4(330041), // Rule ID 516 //
     /* 330016 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330026 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330030 */   // (fpextend:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTSHr:{ *:[f32] } FPR16:{ *:[f16] }:$Rn)
     /* 330030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSHr),
     /* 330035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330039 */   GIR_RootConstrainSelectedInstOperands,
     /* 330040 */   // GIR_Coverage, 516,
     /* 330040 */   GIR_Done,
     /* 330041 */ // Label 6468: @330041
     /* 330041 */ GIM_Reject,
     /* 330042 */ // Label 6464: @330042
     /* 330042 */ GIM_Try, /*On fail goto*//*Label 6469*/ GIMT_Encode4(330072), // Rule ID 514 //
     /* 330047 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330050 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330061 */   // (fpextend:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTDHr:{ *:[f64] } FPR16:{ *:[f16] }:$Rn)
     /* 330061 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDHr),
     /* 330066 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330070 */   GIR_RootConstrainSelectedInstOperands,
     /* 330071 */   // GIR_Coverage, 514,
     /* 330071 */   GIR_Done,
     /* 330072 */ // Label 6469: @330072
     /* 330072 */ GIM_Try, /*On fail goto*//*Label 6470*/ GIMT_Encode4(330102), // Rule ID 518 //
     /* 330077 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330080 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330083 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330087 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330091 */   // (fpextend:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTDSr:{ *:[f64] } FPR32:{ *:[f32] }:$Rn)
     /* 330091 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTDSr),
     /* 330096 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330100 */   GIR_RootConstrainSelectedInstOperands,
     /* 330101 */   // GIR_Coverage, 518,
     /* 330101 */   GIR_Done,
     /* 330102 */ // Label 6470: @330102
     /* 330102 */ GIM_Reject,
     /* 330103 */ // Label 6465: @330103
     /* 330103 */ GIM_Try, /*On fail goto*//*Label 6471*/ GIMT_Encode4(330160),
     /* 330108 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 330111 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330115 */   GIM_Try, /*On fail goto*//*Label 6472*/ GIMT_Encode4(330139), // Rule ID 4937 //
     /* 330120 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4f32),
     /* 330127 */     // (fpextend:{ *:[v2f64] } (extract_high_v4f32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn))  =>  (FCVTLv4i32:{ *:[v2f64] } V128:{ *:[v4f32] }:$Rn)
     /* 330127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i32),
     /* 330130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330132 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330137 */     GIR_RootConstrainSelectedInstOperands,
     /* 330138 */     // GIR_Coverage, 4937,
     /* 330138 */     GIR_EraseRootFromParent_Done,
     /* 330139 */   // Label 6472: @330139
     /* 330139 */   GIM_Try, /*On fail goto*//*Label 6473*/ GIMT_Encode4(330159), // Rule ID 4935 //
     /* 330144 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330148 */     // (fpextend:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTLv2i32:{ *:[v2f64] } V64:{ *:[v2f32] }:$Rn)
     /* 330148 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv2i32),
     /* 330153 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330157 */     GIR_RootConstrainSelectedInstOperands,
     /* 330158 */     // GIR_Coverage, 4935,
     /* 330158 */     GIR_Done,
     /* 330159 */   // Label 6473: @330159
     /* 330159 */   GIM_Reject,
     /* 330160 */ // Label 6471: @330160
     /* 330160 */ GIM_Reject,
     /* 330161 */ // Label 6466: @330161
     /* 330161 */ GIM_Try, /*On fail goto*//*Label 6474*/ GIMT_Encode4(330218),
     /* 330166 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 330169 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330173 */   GIM_Try, /*On fail goto*//*Label 6475*/ GIMT_Encode4(330197), // Rule ID 4941 //
     /* 330178 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8f16),
     /* 330185 */     // (fpextend:{ *:[v4f32] } (extract_high_v8f16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn))  =>  (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)
     /* 330185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 330188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 330195 */     GIR_RootConstrainSelectedInstOperands,
     /* 330196 */     // GIR_Coverage, 4941,
     /* 330196 */     GIR_EraseRootFromParent_Done,
     /* 330197 */   // Label 6475: @330197
     /* 330197 */   GIM_Try, /*On fail goto*//*Label 6476*/ GIMT_Encode4(330217), // Rule ID 4939 //
     /* 330202 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330206 */     // (fpextend:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTLv4i16:{ *:[v4f32] } V64:{ *:[v4f16] }:$Rn)
     /* 330206 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 330211 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330215 */     GIR_RootConstrainSelectedInstOperands,
     /* 330216 */     // GIR_Coverage, 4939,
     /* 330216 */     GIR_Done,
     /* 330217 */   // Label 6476: @330217
     /* 330217 */   GIM_Reject,
     /* 330218 */ // Label 6474: @330218
     /* 330218 */ GIM_Reject,
     /* 330219 */ // Label 6467: @330219
     /* 330219 */ GIM_Reject,
     /* 330220 */ // Label 66: @330220
     /* 330220 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(8), /*)*//*default:*//*Label 6481*/ GIMT_Encode4(330407),
     /* 330231 */ /*GILLT_s16*//*Label 6477*/ GIMT_Encode4(330259),
     /* 330235 */ /*GILLT_s32*//*Label 6478*/ GIMT_Encode4(330320), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 330247 */ /*GILLT_v2s32*//*Label 6479*/ GIMT_Encode4(330351), GIMT_Encode4(0),
     /* 330255 */ /*GILLT_v4s16*//*Label 6480*/ GIMT_Encode4(330379),
     /* 330259 */ // Label 6477: @330259
     /* 330259 */ GIM_Try, /*On fail goto*//*Label 6482*/ GIMT_Encode4(330289), // Rule ID 510 //
     /* 330264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330274 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330278 */   // (fpround:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTHDr:{ *:[f16] } FPR64:{ *:[f64] }:$Rn)
     /* 330278 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHDr),
     /* 330283 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330287 */   GIR_RootConstrainSelectedInstOperands,
     /* 330288 */   // GIR_Coverage, 510,
     /* 330288 */   GIR_Done,
     /* 330289 */ // Label 6482: @330289
     /* 330289 */ GIM_Try, /*On fail goto*//*Label 6483*/ GIMT_Encode4(330319), // Rule ID 520 //
     /* 330294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330308 */   // (fpround:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTHSr:{ *:[f16] } FPR32:{ *:[f32] }:$Rn)
     /* 330308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTHSr),
     /* 330313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330317 */   GIR_RootConstrainSelectedInstOperands,
     /* 330318 */   // GIR_Coverage, 520,
     /* 330318 */   GIR_Done,
     /* 330319 */ // Label 6483: @330319
     /* 330319 */ GIM_Reject,
     /* 330320 */ // Label 6478: @330320
     /* 330320 */ GIM_Try, /*On fail goto*//*Label 6484*/ GIMT_Encode4(330350), // Rule ID 512 //
     /* 330325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330331 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330335 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330339 */   // (fpround:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTSDr:{ *:[f32] } FPR64:{ *:[f64] }:$Rn)
     /* 330339 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTSDr),
     /* 330344 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330348 */   GIR_RootConstrainSelectedInstOperands,
     /* 330349 */   // GIR_Coverage, 512,
     /* 330349 */   GIR_Done,
     /* 330350 */ // Label 6484: @330350
     /* 330350 */ GIM_Reject,
     /* 330351 */ // Label 6479: @330351
     /* 330351 */ GIM_Try, /*On fail goto*//*Label 6485*/ GIMT_Encode4(330378), // Rule ID 4945 //
     /* 330356 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 330359 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330363 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330367 */   // (fpround:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTNv2i32:{ *:[v2f32] } V128:{ *:[v2f64] }:$Rn)
     /* 330367 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv2i32),
     /* 330372 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330376 */   GIR_RootConstrainSelectedInstOperands,
     /* 330377 */   // GIR_Coverage, 4945,
     /* 330377 */   GIR_Done,
     /* 330378 */ // Label 6485: @330378
     /* 330378 */ GIM_Reject,
     /* 330379 */ // Label 6480: @330379
     /* 330379 */ GIM_Try, /*On fail goto*//*Label 6486*/ GIMT_Encode4(330406), // Rule ID 4947 //
     /* 330384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 330387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 330395 */   // (fpround:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTNv4i16:{ *:[v4f16] } V128:{ *:[v4f32] }:$Rn)
     /* 330395 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 330400 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330404 */   GIR_RootConstrainSelectedInstOperands,
     /* 330405 */   // GIR_Coverage, 4947,
     /* 330405 */   GIR_Done,
     /* 330406 */ // Label 6486: @330406
     /* 330406 */ GIM_Reject,
     /* 330407 */ // Label 6481: @330407
     /* 330407 */ GIM_Reject,
     /* 330408 */ // Label 67: @330408
     /* 330408 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6494*/ GIMT_Encode4(331384),
     /* 330419 */ /*GILLT_s32*//*Label 6487*/ GIMT_Encode4(330455),
     /* 330423 */ /*GILLT_s64*//*Label 6488*/ GIMT_Encode4(330842), GIMT_Encode4(0),
     /* 330431 */ /*GILLT_v2s32*//*Label 6489*/ GIMT_Encode4(331229),
     /* 330435 */ /*GILLT_v2s64*//*Label 6490*/ GIMT_Encode4(331260),
     /* 330439 */ /*GILLT_v4s16*//*Label 6491*/ GIMT_Encode4(331291),
     /* 330443 */ /*GILLT_v4s32*//*Label 6492*/ GIMT_Encode4(331322), GIMT_Encode4(0),
     /* 330451 */ /*GILLT_v8s16*//*Label 6493*/ GIMT_Encode4(331353),
     /* 330455 */ // Label 6487: @330455
     /* 330455 */ GIM_Try, /*On fail goto*//*Label 6495*/ GIMT_Encode4(330492), // Rule ID 4684 //
     /* 330460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330479 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330481 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330481 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWSr),
     /* 330484 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330486 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330490 */   GIR_RootConstrainSelectedInstOperands,
     /* 330491 */   // GIR_Coverage, 4684,
     /* 330491 */   GIR_EraseRootFromParent_Done,
     /* 330492 */ // Label 6495: @330492
     /* 330492 */ GIM_Try, /*On fail goto*//*Label 6496*/ GIMT_Encode4(330529), // Rule ID 4686 //
     /* 330497 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330500 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330504 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330508 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330512 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330516 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330518 */   // (fp_to_sint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330518 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUWDr),
     /* 330521 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330523 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330527 */   GIR_RootConstrainSelectedInstOperands,
     /* 330528 */   // GIR_Coverage, 4686,
     /* 330528 */   GIR_EraseRootFromParent_Done,
     /* 330529 */ // Label 6496: @330529
     /* 330529 */ GIM_Try, /*On fail goto*//*Label 6497*/ GIMT_Encode4(330566), // Rule ID 4704 //
     /* 330534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330549 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330553 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330555 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330555 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWSr),
     /* 330558 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330560 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330564 */   GIR_RootConstrainSelectedInstOperands,
     /* 330565 */   // GIR_Coverage, 4704,
     /* 330565 */   GIR_EraseRootFromParent_Done,
     /* 330566 */ // Label 6497: @330566
     /* 330566 */ GIM_Try, /*On fail goto*//*Label 6498*/ GIMT_Encode4(330603), // Rule ID 4706 //
     /* 330571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330574 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330578 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330582 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330586 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330590 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330592 */   // (fp_to_sint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330592 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUWDr),
     /* 330595 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330597 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330601 */   GIR_RootConstrainSelectedInstOperands,
     /* 330602 */   // GIR_Coverage, 4706,
     /* 330602 */   GIR_EraseRootFromParent_Done,
     /* 330603 */ // Label 6498: @330603
     /* 330603 */ GIM_Try, /*On fail goto*//*Label 6499*/ GIMT_Encode4(330640), // Rule ID 4744 //
     /* 330608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330615 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330619 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330623 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330627 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330629 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330629 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 330632 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330634 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330638 */   GIR_RootConstrainSelectedInstOperands,
     /* 330639 */   // GIR_Coverage, 4744,
     /* 330639 */   GIR_EraseRootFromParent_Done,
     /* 330640 */ // Label 6499: @330640
     /* 330640 */ GIM_Try, /*On fail goto*//*Label 6500*/ GIMT_Encode4(330677), // Rule ID 4746 //
     /* 330645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330652 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330656 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 330660 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330664 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330666 */   // (fp_to_sint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 330669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330671 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330675 */   GIR_RootConstrainSelectedInstOperands,
     /* 330676 */   // GIR_Coverage, 4746,
     /* 330676 */   GIR_EraseRootFromParent_Done,
     /* 330677 */ // Label 6500: @330677
     /* 330677 */ GIM_Try, /*On fail goto*//*Label 6501*/ GIMT_Encode4(330714), // Rule ID 4724 //
     /* 330682 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330685 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330689 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330693 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330697 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330701 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330703 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 330703 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330706 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330708 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330712 */   GIR_RootConstrainSelectedInstOperands,
     /* 330713 */   // GIR_Coverage, 4724,
     /* 330713 */   GIR_EraseRootFromParent_Done,
     /* 330714 */ // Label 6501: @330714
     /* 330714 */ GIM_Try, /*On fail goto*//*Label 6502*/ GIMT_Encode4(330751), // Rule ID 4726 //
     /* 330719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 330734 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330738 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330740 */   // (fp_to_sint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 330740 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330743 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330745 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330749 */   GIR_RootConstrainSelectedInstOperands,
     /* 330750 */   // GIR_Coverage, 4726,
     /* 330750 */   GIR_EraseRootFromParent_Done,
     /* 330751 */ // Label 6502: @330751
     /* 330751 */ GIM_Try, /*On fail goto*//*Label 6503*/ GIMT_Encode4(330781), // Rule ID 395 //
     /* 330756 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 330759 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 330762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330766 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 330770 */   // (fp_to_sint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 330770 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 330775 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330779 */   GIR_RootConstrainSelectedInstOperands,
     /* 330780 */   // GIR_Coverage, 395,
     /* 330780 */   GIR_Done,
     /* 330781 */ // Label 6503: @330781
     /* 330781 */ GIM_Try, /*On fail goto*//*Label 6504*/ GIMT_Encode4(330811), // Rule ID 399 //
     /* 330786 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330789 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330792 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330796 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 330800 */   // (fp_to_sint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 330800 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 330805 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330809 */   GIR_RootConstrainSelectedInstOperands,
     /* 330810 */   // GIR_Coverage, 399,
     /* 330810 */   GIR_Done,
     /* 330811 */ // Label 6504: @330811
     /* 330811 */ GIM_Try, /*On fail goto*//*Label 6505*/ GIMT_Encode4(330841), // Rule ID 403 //
     /* 330816 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 330819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 330826 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 330830 */   // (fp_to_sint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 330830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 330835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 330839 */   GIR_RootConstrainSelectedInstOperands,
     /* 330840 */   // GIR_Coverage, 403,
     /* 330840 */   GIR_Done,
     /* 330841 */ // Label 6505: @330841
     /* 330841 */ GIM_Reject,
     /* 330842 */ // Label 6488: @330842
     /* 330842 */ GIM_Try, /*On fail goto*//*Label 6506*/ GIMT_Encode4(330879), // Rule ID 4685 //
     /* 330847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330854 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330858 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330862 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330866 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330868 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330868 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXSr),
     /* 330871 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330873 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330877 */   GIR_RootConstrainSelectedInstOperands,
     /* 330878 */   // GIR_Coverage, 4685,
     /* 330878 */   GIR_EraseRootFromParent_Done,
     /* 330879 */ // Label 6506: @330879
     /* 330879 */ GIM_Try, /*On fail goto*//*Label 6507*/ GIMT_Encode4(330916), // Rule ID 4687 //
     /* 330884 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330891 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330895 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 330899 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330903 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330905 */   // (fp_to_sint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330905 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPSUXDr),
     /* 330908 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330910 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330914 */   GIR_RootConstrainSelectedInstOperands,
     /* 330915 */   // GIR_Coverage, 4687,
     /* 330915 */   GIR_EraseRootFromParent_Done,
     /* 330916 */ // Label 6507: @330916
     /* 330916 */ GIM_Try, /*On fail goto*//*Label 6508*/ GIMT_Encode4(330953), // Rule ID 4705 //
     /* 330921 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330928 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330932 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330936 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 330940 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330942 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 330942 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXSr),
     /* 330945 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330947 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330951 */   GIR_RootConstrainSelectedInstOperands,
     /* 330952 */   // GIR_Coverage, 4705,
     /* 330952 */   GIR_EraseRootFromParent_Done,
     /* 330953 */ // Label 6508: @330953
     /* 330953 */ GIM_Try, /*On fail goto*//*Label 6509*/ GIMT_Encode4(330990), // Rule ID 4707 //
     /* 330958 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 330961 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 330965 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 330969 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 330973 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 330977 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 330979 */   // (fp_to_sint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 330979 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMSUXDr),
     /* 330982 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 330984 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 330988 */   GIR_RootConstrainSelectedInstOperands,
     /* 330989 */   // GIR_Coverage, 4707,
     /* 330989 */   GIR_EraseRootFromParent_Done,
     /* 330990 */ // Label 6509: @330990
     /* 330990 */ GIM_Try, /*On fail goto*//*Label 6510*/ GIMT_Encode4(331027), // Rule ID 4745 //
     /* 330995 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 330998 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331002 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331006 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331010 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331014 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331016 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331016 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 331019 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331021 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331025 */   GIR_RootConstrainSelectedInstOperands,
     /* 331026 */   // GIR_Coverage, 4745,
     /* 331026 */   GIR_EraseRootFromParent_Done,
     /* 331027 */ // Label 6510: @331027
     /* 331027 */ GIM_Try, /*On fail goto*//*Label 6511*/ GIMT_Encode4(331064), // Rule ID 4747 //
     /* 331032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331039 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331043 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331047 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331053 */   // (fp_to_sint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331053 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 331056 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331058 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331062 */   GIR_RootConstrainSelectedInstOperands,
     /* 331063 */   // GIR_Coverage, 4747,
     /* 331063 */   GIR_EraseRootFromParent_Done,
     /* 331064 */ // Label 6511: @331064
     /* 331064 */ GIM_Try, /*On fail goto*//*Label 6512*/ GIMT_Encode4(331101), // Rule ID 4725 //
     /* 331069 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331076 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331080 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331084 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331088 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331090 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331090 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331093 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331095 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331099 */   GIR_RootConstrainSelectedInstOperands,
     /* 331100 */   // GIR_Coverage, 4725,
     /* 331100 */   GIR_EraseRootFromParent_Done,
     /* 331101 */ // Label 6512: @331101
     /* 331101 */ GIM_Try, /*On fail goto*//*Label 6513*/ GIMT_Encode4(331138), // Rule ID 4727 //
     /* 331106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331109 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331113 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331117 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331121 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331127 */   // (fp_to_sint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331127 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331130 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331132 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331136 */   GIR_RootConstrainSelectedInstOperands,
     /* 331137 */   // GIR_Coverage, 4727,
     /* 331137 */   GIR_EraseRootFromParent_Done,
     /* 331138 */ // Label 6513: @331138
     /* 331138 */ GIM_Try, /*On fail goto*//*Label 6514*/ GIMT_Encode4(331168), // Rule ID 397 //
     /* 331143 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331146 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331149 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331153 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331157 */   // (fp_to_sint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 331157 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 331162 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331166 */   GIR_RootConstrainSelectedInstOperands,
     /* 331167 */   // GIR_Coverage, 397,
     /* 331167 */   GIR_Done,
     /* 331168 */ // Label 6514: @331168
     /* 331168 */ GIM_Try, /*On fail goto*//*Label 6515*/ GIMT_Encode4(331198), // Rule ID 401 //
     /* 331173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331187 */   // (fp_to_sint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 331187 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 331192 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331196 */   GIR_RootConstrainSelectedInstOperands,
     /* 331197 */   // GIR_Coverage, 401,
     /* 331197 */   GIR_Done,
     /* 331198 */ // Label 6515: @331198
     /* 331198 */ GIM_Try, /*On fail goto*//*Label 6516*/ GIMT_Encode4(331228), // Rule ID 405 //
     /* 331203 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331206 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331209 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331213 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331217 */   // (fp_to_sint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 331217 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 331222 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331226 */   GIR_RootConstrainSelectedInstOperands,
     /* 331227 */   // GIR_Coverage, 405,
     /* 331227 */   GIR_Done,
     /* 331228 */ // Label 6516: @331228
     /* 331228 */ GIM_Reject,
     /* 331229 */ // Label 6489: @331229
     /* 331229 */ GIM_Try, /*On fail goto*//*Label 6517*/ GIMT_Encode4(331259), // Rule ID 843 //
     /* 331234 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 331240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331248 */   // (fp_to_sint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 331248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 331253 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331257 */   GIR_RootConstrainSelectedInstOperands,
     /* 331258 */   // GIR_Coverage, 843,
     /* 331258 */   GIR_Done,
     /* 331259 */ // Label 6517: @331259
     /* 331259 */ GIM_Reject,
     /* 331260 */ // Label 6490: @331260
     /* 331260 */ GIM_Try, /*On fail goto*//*Label 6518*/ GIMT_Encode4(331290), // Rule ID 847 //
     /* 331265 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331268 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 331271 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331275 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331279 */   // (fp_to_sint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 331279 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 331284 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331288 */   GIR_RootConstrainSelectedInstOperands,
     /* 331289 */   // GIR_Coverage, 847,
     /* 331289 */   GIR_Done,
     /* 331290 */ // Label 6518: @331290
     /* 331290 */ GIM_Reject,
     /* 331291 */ // Label 6491: @331291
     /* 331291 */ GIM_Try, /*On fail goto*//*Label 6519*/ GIMT_Encode4(331321), // Rule ID 839 //
     /* 331296 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331299 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 331302 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331306 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331310 */   // (fp_to_sint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 331310 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 331315 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331319 */   GIR_RootConstrainSelectedInstOperands,
     /* 331320 */   // GIR_Coverage, 839,
     /* 331320 */   GIR_Done,
     /* 331321 */ // Label 6519: @331321
     /* 331321 */ GIM_Reject,
     /* 331322 */ // Label 6492: @331322
     /* 331322 */ GIM_Try, /*On fail goto*//*Label 6520*/ GIMT_Encode4(331352), // Rule ID 845 //
     /* 331327 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 331330 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 331333 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331337 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331341 */   // (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 331341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 331346 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331350 */   GIR_RootConstrainSelectedInstOperands,
     /* 331351 */   // GIR_Coverage, 845,
     /* 331351 */   GIR_Done,
     /* 331352 */ // Label 6520: @331352
     /* 331352 */ GIM_Reject,
     /* 331353 */ // Label 6493: @331353
     /* 331353 */ GIM_Try, /*On fail goto*//*Label 6521*/ GIMT_Encode4(331383), // Rule ID 841 //
     /* 331358 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 331361 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 331364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 331372 */   // (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 331372 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 331377 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331381 */   GIR_RootConstrainSelectedInstOperands,
     /* 331382 */   // GIR_Coverage, 841,
     /* 331382 */   GIR_Done,
     /* 331383 */ // Label 6521: @331383
     /* 331383 */ GIM_Reject,
     /* 331384 */ // Label 6494: @331384
     /* 331384 */ GIM_Reject,
     /* 331385 */ // Label 68: @331385
     /* 331385 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6529*/ GIMT_Encode4(332361),
     /* 331396 */ /*GILLT_s32*//*Label 6522*/ GIMT_Encode4(331432),
     /* 331400 */ /*GILLT_s64*//*Label 6523*/ GIMT_Encode4(331819), GIMT_Encode4(0),
     /* 331408 */ /*GILLT_v2s32*//*Label 6524*/ GIMT_Encode4(332206),
     /* 331412 */ /*GILLT_v2s64*//*Label 6525*/ GIMT_Encode4(332237),
     /* 331416 */ /*GILLT_v4s16*//*Label 6526*/ GIMT_Encode4(332268),
     /* 331420 */ /*GILLT_v4s32*//*Label 6527*/ GIMT_Encode4(332299), GIMT_Encode4(0),
     /* 331428 */ /*GILLT_v8s16*//*Label 6528*/ GIMT_Encode4(332330),
     /* 331432 */ // Label 6522: @331432
     /* 331432 */ GIM_Try, /*On fail goto*//*Label 6530*/ GIMT_Encode4(331469), // Rule ID 4694 //
     /* 331437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331444 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331448 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331452 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331456 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331458 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331458 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWSr),
     /* 331461 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331463 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331467 */   GIR_RootConstrainSelectedInstOperands,
     /* 331468 */   // GIR_Coverage, 4694,
     /* 331468 */   GIR_EraseRootFromParent_Done,
     /* 331469 */ // Label 6530: @331469
     /* 331469 */ GIM_Try, /*On fail goto*//*Label 6531*/ GIMT_Encode4(331506), // Rule ID 4696 //
     /* 331474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331489 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331493 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331495 */   // (fp_to_uint:{ *:[i32] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331495 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUWDr),
     /* 331498 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331500 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331504 */   GIR_RootConstrainSelectedInstOperands,
     /* 331505 */   // GIR_Coverage, 4696,
     /* 331505 */   GIR_EraseRootFromParent_Done,
     /* 331506 */ // Label 6531: @331506
     /* 331506 */ GIM_Try, /*On fail goto*//*Label 6532*/ GIMT_Encode4(331543), // Rule ID 4714 //
     /* 331511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331526 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331530 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331532 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWSr),
     /* 331535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331537 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331541 */   GIR_RootConstrainSelectedInstOperands,
     /* 331542 */   // GIR_Coverage, 4714,
     /* 331542 */   GIR_EraseRootFromParent_Done,
     /* 331543 */ // Label 6532: @331543
     /* 331543 */ GIM_Try, /*On fail goto*//*Label 6533*/ GIMT_Encode4(331580), // Rule ID 4716 //
     /* 331548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331555 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331559 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331563 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331567 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331569 */   // (fp_to_uint:{ *:[i32] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUWDr),
     /* 331572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331574 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331578 */   GIR_RootConstrainSelectedInstOperands,
     /* 331579 */   // GIR_Coverage, 4716,
     /* 331579 */   GIR_EraseRootFromParent_Done,
     /* 331580 */ // Label 6533: @331580
     /* 331580 */ GIM_Try, /*On fail goto*//*Label 6534*/ GIMT_Encode4(331617), // Rule ID 4754 //
     /* 331585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331592 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331596 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331600 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331604 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331606 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331606 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWSr),
     /* 331609 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331611 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331615 */   GIR_RootConstrainSelectedInstOperands,
     /* 331616 */   // GIR_Coverage, 4754,
     /* 331616 */   GIR_EraseRootFromParent_Done,
     /* 331617 */ // Label 6534: @331617
     /* 331617 */ GIM_Try, /*On fail goto*//*Label 6535*/ GIMT_Encode4(331654), // Rule ID 4756 //
     /* 331622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331629 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331633 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331637 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331641 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331643 */   // (fp_to_uint:{ *:[i32] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331643 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUWDr),
     /* 331646 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331648 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331652 */   GIR_RootConstrainSelectedInstOperands,
     /* 331653 */   // GIR_Coverage, 4756,
     /* 331653 */   GIR_EraseRootFromParent_Done,
     /* 331654 */ // Label 6535: @331654
     /* 331654 */ GIM_Try, /*On fail goto*//*Label 6536*/ GIMT_Encode4(331691), // Rule ID 4734 //
     /* 331659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331666 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331670 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331674 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331678 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331680 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 331680 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 331683 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331685 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331689 */   GIR_RootConstrainSelectedInstOperands,
     /* 331690 */   // GIR_Coverage, 4734,
     /* 331690 */   GIR_EraseRootFromParent_Done,
     /* 331691 */ // Label 6536: @331691
     /* 331691 */ GIM_Try, /*On fail goto*//*Label 6537*/ GIMT_Encode4(331728), // Rule ID 4736 //
     /* 331696 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331703 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331707 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 331711 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331715 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331717 */   // (fp_to_uint:{ *:[i32] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 331717 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331720 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331722 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331726 */   GIR_RootConstrainSelectedInstOperands,
     /* 331727 */   // GIR_Coverage, 4736,
     /* 331727 */   GIR_EraseRootFromParent_Done,
     /* 331728 */ // Label 6537: @331728
     /* 331728 */ GIM_Try, /*On fail goto*//*Label 6538*/ GIMT_Encode4(331758), // Rule ID 407 //
     /* 331733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 331736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 331739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331743 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 331747 */   // (fp_to_uint:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } FPR16:{ *:[f16] }:$Rn)
     /* 331747 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 331752 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331756 */   GIR_RootConstrainSelectedInstOperands,
     /* 331757 */   // GIR_Coverage, 407,
     /* 331757 */   GIR_Done,
     /* 331758 */ // Label 6538: @331758
     /* 331758 */ GIM_Try, /*On fail goto*//*Label 6539*/ GIMT_Encode4(331788), // Rule ID 411 //
     /* 331763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 331777 */   // (fp_to_uint:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } FPR32:{ *:[f32] }:$Rn)
     /* 331777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 331782 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331786 */   GIR_RootConstrainSelectedInstOperands,
     /* 331787 */   // GIR_Coverage, 411,
     /* 331787 */   GIR_Done,
     /* 331788 */ // Label 6539: @331788
     /* 331788 */ GIM_Try, /*On fail goto*//*Label 6540*/ GIMT_Encode4(331818), // Rule ID 415 //
     /* 331793 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 331796 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331799 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 331803 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 331807 */   // (fp_to_uint:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } FPR64:{ *:[f64] }:$Rn)
     /* 331807 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 331812 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 331816 */   GIR_RootConstrainSelectedInstOperands,
     /* 331817 */   // GIR_Coverage, 415,
     /* 331817 */   GIR_Done,
     /* 331818 */ // Label 6540: @331818
     /* 331818 */ GIM_Reject,
     /* 331819 */ // Label 6523: @331819
     /* 331819 */ GIM_Try, /*On fail goto*//*Label 6541*/ GIMT_Encode4(331856), // Rule ID 4695 //
     /* 331824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331831 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331835 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331839 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331843 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331845 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTPUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331845 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXSr),
     /* 331848 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331850 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331854 */   GIR_RootConstrainSelectedInstOperands,
     /* 331855 */   // GIR_Coverage, 4695,
     /* 331855 */   GIR_EraseRootFromParent_Done,
     /* 331856 */ // Label 6541: @331856
     /* 331856 */ GIM_Try, /*On fail goto*//*Label 6542*/ GIMT_Encode4(331893), // Rule ID 4697 //
     /* 331861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331868 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331872 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCEIL),
     /* 331876 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331880 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331882 */   // (fp_to_uint:{ *:[i64] } (fceil:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTPUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331882 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTPUUXDr),
     /* 331885 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331887 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331891 */   GIR_RootConstrainSelectedInstOperands,
     /* 331892 */   // GIR_Coverage, 4697,
     /* 331892 */   GIR_EraseRootFromParent_Done,
     /* 331893 */ // Label 6542: @331893
     /* 331893 */ GIM_Try, /*On fail goto*//*Label 6543*/ GIMT_Encode4(331930), // Rule ID 4715 //
     /* 331898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331901 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331905 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331909 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331913 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331917 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331919 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTMUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331919 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXSr),
     /* 331922 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331924 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331928 */   GIR_RootConstrainSelectedInstOperands,
     /* 331929 */   // GIR_Coverage, 4715,
     /* 331929 */   GIR_EraseRootFromParent_Done,
     /* 331930 */ // Label 6543: @331930
     /* 331930 */ GIM_Try, /*On fail goto*//*Label 6544*/ GIMT_Encode4(331967), // Rule ID 4717 //
     /* 331935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 331938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331942 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331946 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FFLOOR),
     /* 331950 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 331954 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331956 */   // (fp_to_uint:{ *:[i64] } (ffloor:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTMUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 331956 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTMUUXDr),
     /* 331959 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331961 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 331965 */   GIR_RootConstrainSelectedInstOperands,
     /* 331966 */   // GIR_Coverage, 4717,
     /* 331966 */   GIR_EraseRootFromParent_Done,
     /* 331967 */ // Label 6544: @331967
     /* 331967 */ GIM_Try, /*On fail goto*//*Label 6545*/ GIMT_Encode4(332004), // Rule ID 4755 //
     /* 331972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 331975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 331979 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 331983 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 331987 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 331991 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 331993 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTAUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 331993 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXSr),
     /* 331996 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 331998 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332002 */   GIR_RootConstrainSelectedInstOperands,
     /* 332003 */   // GIR_Coverage, 4755,
     /* 332003 */   GIR_EraseRootFromParent_Done,
     /* 332004 */ // Label 6545: @332004
     /* 332004 */ GIM_Try, /*On fail goto*//*Label 6546*/ GIMT_Encode4(332041), // Rule ID 4757 //
     /* 332009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332016 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332020 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_ROUND),
     /* 332024 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332028 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332030 */   // (fp_to_uint:{ *:[i64] } (fround:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTAUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332030 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTAUUXDr),
     /* 332033 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332035 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332039 */   GIR_RootConstrainSelectedInstOperands,
     /* 332040 */   // GIR_Coverage, 4757,
     /* 332040 */   GIR_EraseRootFromParent_Done,
     /* 332041 */ // Label 6546: @332041
     /* 332041 */ GIM_Try, /*On fail goto*//*Label 6547*/ GIMT_Encode4(332078), // Rule ID 4735 //
     /* 332046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332049 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332053 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332057 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332061 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332067 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f32] } f32:{ *:[f32] }:$Rn))  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 332067 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332070 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332072 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332076 */   GIR_RootConstrainSelectedInstOperands,
     /* 332077 */   // GIR_Coverage, 4735,
     /* 332077 */   GIR_EraseRootFromParent_Done,
     /* 332078 */ // Label 6547: @332078
     /* 332078 */ GIM_Try, /*On fail goto*//*Label 6548*/ GIMT_Encode4(332115), // Rule ID 4737 //
     /* 332083 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332086 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332090 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332094 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC_TRUNC),
     /* 332098 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 332102 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332104 */   // (fp_to_uint:{ *:[i64] } (ftrunc:{ *:[f64] } f64:{ *:[f64] }:$Rn))  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 332104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332109 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332113 */   GIR_RootConstrainSelectedInstOperands,
     /* 332114 */   // GIR_Coverage, 4737,
     /* 332114 */   GIR_EraseRootFromParent_Done,
     /* 332115 */ // Label 6548: @332115
     /* 332115 */ GIM_Try, /*On fail goto*//*Label 6549*/ GIMT_Encode4(332145), // Rule ID 409 //
     /* 332120 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332123 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 332126 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332130 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332134 */   // (fp_to_uint:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } FPR16:{ *:[f16] }:$Rn)
     /* 332134 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 332139 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332143 */   GIR_RootConstrainSelectedInstOperands,
     /* 332144 */   // GIR_Coverage, 409,
     /* 332144 */   GIR_Done,
     /* 332145 */ // Label 6549: @332145
     /* 332145 */ GIM_Try, /*On fail goto*//*Label 6550*/ GIMT_Encode4(332175), // Rule ID 413 //
     /* 332150 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332153 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332156 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332160 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332164 */   // (fp_to_uint:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } FPR32:{ *:[f32] }:$Rn)
     /* 332164 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 332169 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332173 */   GIR_RootConstrainSelectedInstOperands,
     /* 332174 */   // GIR_Coverage, 413,
     /* 332174 */   GIR_Done,
     /* 332175 */ // Label 6550: @332175
     /* 332175 */ GIM_Try, /*On fail goto*//*Label 6551*/ GIMT_Encode4(332205), // Rule ID 417 //
     /* 332180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 332183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332190 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332194 */   // (fp_to_uint:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } FPR64:{ *:[f64] }:$Rn)
     /* 332194 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 332199 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332203 */   GIR_RootConstrainSelectedInstOperands,
     /* 332204 */   // GIR_Coverage, 417,
     /* 332204 */   GIR_Done,
     /* 332205 */ // Label 6551: @332205
     /* 332205 */ GIM_Reject,
     /* 332206 */ // Label 6524: @332206
     /* 332206 */ GIM_Try, /*On fail goto*//*Label 6552*/ GIMT_Encode4(332236), // Rule ID 853 //
     /* 332211 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 332217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332221 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332225 */   // (fp_to_uint:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 332225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 332230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332234 */   GIR_RootConstrainSelectedInstOperands,
     /* 332235 */   // GIR_Coverage, 853,
     /* 332235 */   GIR_Done,
     /* 332236 */ // Label 6552: @332236
     /* 332236 */ GIM_Reject,
     /* 332237 */ // Label 6525: @332237
     /* 332237 */ GIM_Try, /*On fail goto*//*Label 6553*/ GIMT_Encode4(332267), // Rule ID 857 //
     /* 332242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332252 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332256 */   // (fp_to_uint:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 332256 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 332261 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332265 */   GIR_RootConstrainSelectedInstOperands,
     /* 332266 */   // GIR_Coverage, 857,
     /* 332266 */   GIR_Done,
     /* 332267 */ // Label 6553: @332267
     /* 332267 */ GIM_Reject,
     /* 332268 */ // Label 6526: @332268
     /* 332268 */ GIM_Try, /*On fail goto*//*Label 6554*/ GIMT_Encode4(332298), // Rule ID 849 //
     /* 332273 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332276 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 332279 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332283 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332287 */   // (fp_to_uint:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 332287 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 332292 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332296 */   GIR_RootConstrainSelectedInstOperands,
     /* 332297 */   // GIR_Coverage, 849,
     /* 332297 */   GIR_Done,
     /* 332298 */ // Label 6554: @332298
     /* 332298 */ GIM_Reject,
     /* 332299 */ // Label 6527: @332299
     /* 332299 */ GIM_Try, /*On fail goto*//*Label 6555*/ GIMT_Encode4(332329), // Rule ID 855 //
     /* 332304 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 332307 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332310 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332314 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332318 */   // (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 332318 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 332323 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332327 */   GIR_RootConstrainSelectedInstOperands,
     /* 332328 */   // GIR_Coverage, 855,
     /* 332328 */   GIR_Done,
     /* 332329 */ // Label 6555: @332329
     /* 332329 */ GIM_Reject,
     /* 332330 */ // Label 6528: @332330
     /* 332330 */ GIM_Try, /*On fail goto*//*Label 6556*/ GIMT_Encode4(332360), // Rule ID 851 //
     /* 332335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 332338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332345 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332349 */   // (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 332349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 332354 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332358 */   GIR_RootConstrainSelectedInstOperands,
     /* 332359 */   // GIR_Coverage, 851,
     /* 332359 */   GIR_Done,
     /* 332360 */ // Label 6556: @332360
     /* 332360 */ GIM_Reject,
     /* 332361 */ // Label 6529: @332361
     /* 332361 */ GIM_Reject,
     /* 332362 */ // Label 69: @332362
     /* 332362 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6565*/ GIMT_Encode4(336989),
     /* 332373 */ /*GILLT_s16*//*Label 6557*/ GIMT_Encode4(332413),
     /* 332377 */ /*GILLT_s32*//*Label 6558*/ GIMT_Encode4(332854),
     /* 332381 */ /*GILLT_s64*//*Label 6559*/ GIMT_Encode4(334850), GIMT_Encode4(0),
     /* 332389 */ /*GILLT_v2s32*//*Label 6560*/ GIMT_Encode4(336834),
     /* 332393 */ /*GILLT_v2s64*//*Label 6561*/ GIMT_Encode4(336865),
     /* 332397 */ /*GILLT_v4s16*//*Label 6562*/ GIMT_Encode4(336896),
     /* 332401 */ /*GILLT_v4s32*//*Label 6563*/ GIMT_Encode4(336927), GIMT_Encode4(0),
     /* 332409 */ /*GILLT_v8s16*//*Label 6564*/ GIMT_Encode4(336958),
     /* 332413 */ // Label 6557: @332413
     /* 332413 */ GIM_Try, /*On fail goto*//*Label 6566*/ GIMT_Encode4(332516), // Rule ID 5337 //
     /* 332418 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 332421 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332428 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332432 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXT_INREG),
     /* 332436 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 332440 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 332444 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332448 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 332452 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 332456 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332461 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 332465 */   // MIs[1] Operand 2
     /* 332465 */   GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(16),
     /* 332476 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 332478 */   // (sint_to_fp:{ *:[f16] } (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), i16:{ *:[Other] }))  =>  (SCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 332478 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332481 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332485 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332490 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 332496 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332501 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332506 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 332509 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332511 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332514 */   GIR_RootConstrainSelectedInstOperands,
     /* 332515 */   // GIR_Coverage, 5337,
     /* 332515 */   GIR_EraseRootFromParent_Done,
     /* 332516 */ // Label 6566: @332516
     /* 332516 */ GIM_Try, /*On fail goto*//*Label 6567*/ GIMT_Encode4(332596), // Rule ID 2447 //
     /* 332521 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332524 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332527 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332531 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332535 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332539 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 332543 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332547 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332552 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332558 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 332558 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 332561 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332565 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332570 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 332576 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332581 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332586 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 332589 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332591 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332594 */   GIR_RootConstrainSelectedInstOperands,
     /* 332595 */   // GIR_Coverage, 2447,
     /* 332595 */   GIR_EraseRootFromParent_Done,
     /* 332596 */ // Label 6567: @332596
     /* 332596 */ GIM_Try, /*On fail goto*//*Label 6568*/ GIMT_Encode4(332676), // Rule ID 2451 //
     /* 332601 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332604 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332611 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332615 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 332619 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 332623 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 332627 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332632 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 332636 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332638 */   // (sint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 332638 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 332641 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 332645 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332650 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 332656 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332661 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 332666 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 332669 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332671 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332674 */   GIR_RootConstrainSelectedInstOperands,
     /* 332675 */   // GIR_Coverage, 2451,
     /* 332675 */   GIR_EraseRootFromParent_Done,
     /* 332676 */ // Label 6568: @332676
     /* 332676 */ GIM_Try, /*On fail goto*//*Label 6569*/ GIMT_Encode4(332733), // Rule ID 5328 //
     /* 332681 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 332684 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332691 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332695 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 332699 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 332703 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332705 */   // (sint_to_fp:{ *:[f16] } (fp_to_sint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (SCVTFv1i16:{ *:[f16] } (FCVTZSv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 332705 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 332708 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1f16),
     /* 332712 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332717 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 332721 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 332723 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 332726 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 332728 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 332731 */   GIR_RootConstrainSelectedInstOperands,
     /* 332732 */   // GIR_Coverage, 5328,
     /* 332732 */   GIR_EraseRootFromParent_Done,
     /* 332733 */ // Label 6569: @332733
     /* 332733 */ GIM_Try, /*On fail goto*//*Label 6570*/ GIMT_Encode4(332763), // Rule ID 443 //
     /* 332738 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332748 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 332752 */   // (sint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 332752 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWHri),
     /* 332757 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332761 */   GIR_RootConstrainSelectedInstOperands,
     /* 332762 */   // GIR_Coverage, 443,
     /* 332762 */   GIR_Done,
     /* 332763 */ // Label 6570: @332763
     /* 332763 */ GIM_Try, /*On fail goto*//*Label 6571*/ GIMT_Encode4(332793), // Rule ID 449 //
     /* 332768 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 332771 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332774 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332778 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 332782 */   // (sint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 332782 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXHri),
     /* 332787 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332791 */   GIR_RootConstrainSelectedInstOperands,
     /* 332792 */   // GIR_Coverage, 449,
     /* 332792 */   GIR_Done,
     /* 332793 */ // Label 6571: @332793
     /* 332793 */ GIM_Try, /*On fail goto*//*Label 6572*/ GIMT_Encode4(332823), // Rule ID 491 //
     /* 332798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332808 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332812 */   // (sint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 332812 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHSr),
     /* 332817 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332821 */   GIR_RootConstrainSelectedInstOperands,
     /* 332822 */   // GIR_Coverage, 491,
     /* 332822 */   GIR_Done,
     /* 332823 */ // Label 6572: @332823
     /* 332823 */ GIM_Try, /*On fail goto*//*Label 6573*/ GIMT_Encode4(332853), // Rule ID 495 //
     /* 332828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 332831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 332834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 332838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332842 */   // (sint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 332842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFHDr),
     /* 332847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 332851 */   GIR_RootConstrainSelectedInstOperands,
     /* 332852 */   // GIR_Coverage, 495,
     /* 332852 */   GIR_Done,
     /* 332853 */ // Label 6573: @332853
     /* 332853 */ GIM_Reject,
     /* 332854 */ // Label 6558: @332854
     /* 332854 */ GIM_Try, /*On fail goto*//*Label 6574*/ GIMT_Encode4(333092), // Rule ID 6414 //
     /* 332859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 332862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 332865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 332869 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 332873 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 332877 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 332880 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 332887 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 332891 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 332893 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 332900 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 332900 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 332903 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 332907 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332912 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 332917 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 332922 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 332927 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 332932 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 332934 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 332937 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 332941 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 332948 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 332951 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 332955 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332960 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 332963 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 332966 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 332969 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332974 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 332979 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 332984 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 332987 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 332991 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 332996 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 332999 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333002 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333004 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333007 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333011 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333016 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333023 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333028 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333033 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333036 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333040 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333045 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333048 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333065 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333072 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333077 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333082 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333085 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333087 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333090 */   GIR_RootConstrainSelectedInstOperands,
     /* 333091 */   // GIR_Coverage, 6414,
     /* 333091 */   GIR_EraseRootFromParent_Done,
     /* 333092 */ // Label 6574: @333092
     /* 333092 */ GIM_Try, /*On fail goto*//*Label 6575*/ GIMT_Encode4(333330), // Rule ID 6415 //
     /* 333097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333107 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333111 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333115 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333118 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333125 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333129 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333131 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 333138 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$ext), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333138 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333141 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 333145 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333150 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333155 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333160 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333165 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333170 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333172 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333175 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333179 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333184 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333186 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333189 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333193 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333198 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333201 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333204 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333207 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333212 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333217 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333222 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333225 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333229 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333234 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333237 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333240 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333242 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333245 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333249 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333254 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333261 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333266 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333271 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333274 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333278 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333283 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333286 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333289 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333291 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333294 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333298 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333303 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333310 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333315 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333320 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333323 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333325 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333328 */   GIR_RootConstrainSelectedInstOperands,
     /* 333329 */   // GIR_Coverage, 6415,
     /* 333329 */   GIR_EraseRootFromParent_Done,
     /* 333330 */ // Label 6575: @333330
     /* 333330 */ GIM_Try, /*On fail goto*//*Label 6576*/ GIMT_Encode4(333519), // Rule ID 6418 //
     /* 333335 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333338 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333341 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333345 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333349 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333353 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333356 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333363 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333367 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333369 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 333376 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333376 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333379 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 333383 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333388 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333393 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333398 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333403 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333408 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333410 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333413 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333417 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333422 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333424 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333427 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333431 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333436 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333439 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333442 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333445 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333450 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333455 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333460 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333463 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333467 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333472 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333475 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333478 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333480 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333483 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333487 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333492 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333499 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333504 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333509 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333512 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333514 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333517 */   GIR_RootConstrainSelectedInstOperands,
     /* 333518 */   // GIR_Coverage, 6418,
     /* 333518 */   GIR_EraseRootFromParent_Done,
     /* 333519 */ // Label 6576: @333519
     /* 333519 */ GIM_Try, /*On fail goto*//*Label 6577*/ GIMT_Encode4(333708), // Rule ID 6419 //
     /* 333524 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333530 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333534 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333538 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333542 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333545 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 333552 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333556 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333558 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 333565 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333565 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 333568 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 333572 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333577 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333582 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 333587 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 333592 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333597 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 333599 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 333602 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333606 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333613 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333616 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333620 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333625 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 333628 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 333631 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 333634 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333639 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333644 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 333649 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333652 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333656 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333661 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333664 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333667 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333669 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333672 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333676 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333681 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333688 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333693 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333698 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333701 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333706 */   GIR_RootConstrainSelectedInstOperands,
     /* 333707 */   // GIR_Coverage, 6419,
     /* 333707 */   GIR_EraseRootFromParent_Done,
     /* 333708 */ // Label 6577: @333708
     /* 333708 */ GIM_Try, /*On fail goto*//*Label 6578*/ GIMT_Encode4(333941), // Rule ID 6416 //
     /* 333713 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333716 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333719 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333723 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333727 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333731 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333734 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333741 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333745 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333747 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 333754 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333754 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333757 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 333761 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333766 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 333771 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 333776 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 333781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 333783 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 333786 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 333790 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333795 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 333797 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 333800 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 333804 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333809 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 333812 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 333815 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 333818 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333823 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333828 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 333833 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 333836 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 333840 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333845 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 333848 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 333851 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 333853 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 333856 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333860 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333865 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 333872 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 333877 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333882 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 333885 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 333889 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333894 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 333897 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 333900 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 333902 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 333905 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 333909 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333914 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 333921 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333926 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 333931 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 333934 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 333936 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 333939 */   GIR_RootConstrainSelectedInstOperands,
     /* 333940 */   // GIR_Coverage, 6416,
     /* 333940 */   GIR_EraseRootFromParent_Done,
     /* 333941 */ // Label 6578: @333941
     /* 333941 */ GIM_Try, /*On fail goto*//*Label 6579*/ GIMT_Encode4(334174), // Rule ID 6417 //
     /* 333946 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 333949 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 333952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 333956 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 333960 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 333964 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 333967 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 333974 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 333978 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 333980 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 333987 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv8i8_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 333987 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s8,
     /* 333990 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 333994 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 333999 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334004 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334009 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334014 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 334016 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 334019 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334023 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334028 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 334030 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 334033 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334037 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334042 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 334045 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 334048 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/1,
     /* 334051 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334056 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334061 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 334066 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 334069 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv8i8_shift),
     /* 334073 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334078 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 334081 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 334084 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334086 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334089 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334093 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334098 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 334105 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334110 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334115 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334118 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334122 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334127 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334130 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334147 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334154 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334159 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334164 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334167 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334169 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334172 */   GIR_RootConstrainSelectedInstOperands,
     /* 334173 */   // GIR_Coverage, 6417,
     /* 334173 */   GIR_EraseRootFromParent_Done,
     /* 334174 */ // Label 6579: @334174
     /* 334174 */ GIM_Try, /*On fail goto*//*Label 6580*/ GIMT_Encode4(334358), // Rule ID 6420 //
     /* 334179 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334189 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334193 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334197 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334200 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334207 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334211 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334213 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 334220 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334220 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334223 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 334227 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334232 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334237 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334242 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334249 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334252 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334256 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334261 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334263 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334266 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334270 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334275 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334278 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334281 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334284 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334289 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334294 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334299 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334302 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334306 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334311 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334314 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334317 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334331 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334338 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334343 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334348 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334351 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334353 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334356 */   GIR_RootConstrainSelectedInstOperands,
     /* 334357 */   // GIR_Coverage, 6420,
     /* 334357 */   GIR_EraseRootFromParent_Done,
     /* 334358 */ // Label 6580: @334358
     /* 334358 */ GIM_Try, /*On fail goto*//*Label 6581*/ GIMT_Encode4(334542), // Rule ID 6421 //
     /* 334363 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334366 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334373 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334377 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 334381 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334384 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 334391 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334395 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334397 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 334404 */   // (sint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[f32] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), ssub:{ *:[i32] }))
     /* 334404 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s16,
     /* 334407 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 334411 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334416 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334421 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 334426 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334431 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334433 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334436 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334440 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334445 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334447 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334450 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334454 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334459 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334462 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334465 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/9,
     /* 334468 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334473 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334478 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 334483 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334486 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 334490 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334495 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334498 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334515 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 334522 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334527 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334532 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334535 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334537 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334540 */   GIR_RootConstrainSelectedInstOperands,
     /* 334541 */   // GIR_Coverage, 6421,
     /* 334541 */   GIR_EraseRootFromParent_Done,
     /* 334542 */ // Label 6581: @334542
     /* 334542 */ GIM_Try, /*On fail goto*//*Label 6582*/ GIMT_Encode4(334622), // Rule ID 2453 //
     /* 334547 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334550 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334553 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334557 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334561 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334565 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 334569 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334573 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334578 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334582 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334584 */   // (sint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 334584 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 334587 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334591 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334596 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 334602 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334607 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334612 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 334615 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334617 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334620 */   GIR_RootConstrainSelectedInstOperands,
     /* 334621 */   // GIR_Coverage, 2453,
     /* 334621 */   GIR_EraseRootFromParent_Done,
     /* 334622 */ // Label 6582: @334622
     /* 334622 */ GIM_Try, /*On fail goto*//*Label 6583*/ GIMT_Encode4(334702), // Rule ID 5333 //
     /* 334627 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 334630 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334637 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334641 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 334645 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 334649 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 334653 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334658 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 334662 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334664 */   // (sint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 334664 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334667 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 334671 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334676 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 334682 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334687 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 334692 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334695 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334697 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334700 */   GIR_RootConstrainSelectedInstOperands,
     /* 334701 */   // GIR_Coverage, 5333,
     /* 334701 */   GIR_EraseRootFromParent_Done,
     /* 334702 */ // Label 6583: @334702
     /* 334702 */ GIM_Try, /*On fail goto*//*Label 6584*/ GIMT_Encode4(334759), // Rule ID 5316 //
     /* 334707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 334710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334717 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334721 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 334725 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 334729 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334731 */   // (sint_to_fp:{ *:[f32] } (fp_to_sint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (SCVTFv1i32:{ *:[f32] } (FCVTZSv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 334731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 334734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i32),
     /* 334738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334743 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 334747 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 334749 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 334752 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 334754 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 334757 */   GIR_RootConstrainSelectedInstOperands,
     /* 334758 */   // GIR_Coverage, 5316,
     /* 334758 */   GIR_EraseRootFromParent_Done,
     /* 334759 */ // Label 6584: @334759
     /* 334759 */ GIM_Try, /*On fail goto*//*Label 6585*/ GIMT_Encode4(334789), // Rule ID 445 //
     /* 334764 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334770 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334774 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 334778 */   // (sint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 334778 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWSri),
     /* 334783 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334787 */   GIR_RootConstrainSelectedInstOperands,
     /* 334788 */   // GIR_Coverage, 445,
     /* 334788 */   GIR_Done,
     /* 334789 */ // Label 6585: @334789
     /* 334789 */ GIM_Try, /*On fail goto*//*Label 6586*/ GIMT_Encode4(334819), // Rule ID 451 //
     /* 334794 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 334797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 334808 */   // (sint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 334808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXSri),
     /* 334813 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334817 */   GIR_RootConstrainSelectedInstOperands,
     /* 334818 */   // GIR_Coverage, 451,
     /* 334818 */   GIR_Done,
     /* 334819 */ // Label 6586: @334819
     /* 334819 */ GIM_Try, /*On fail goto*//*Label 6587*/ GIMT_Encode4(334849), // Rule ID 497 //
     /* 334824 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 334827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 334830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334838 */   // (sint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (SCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 334838 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFSDr),
     /* 334843 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 334847 */   GIR_RootConstrainSelectedInstOperands,
     /* 334848 */   // GIR_Coverage, 497,
     /* 334848 */   GIR_Done,
     /* 334849 */ // Label 6587: @334849
     /* 334849 */ GIM_Reject,
     /* 334850 */ // Label 6559: @334850
     /* 334850 */ GIM_Try, /*On fail goto*//*Label 6588*/ GIMT_Encode4(335036), // Rule ID 6426 //
     /* 334855 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 334858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 334861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334865 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 334869 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 334873 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 334876 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 334880 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 334884 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 334886 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 334893 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 334893 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 334896 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 334900 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334905 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 334910 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 334915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 334920 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 334925 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 334927 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 334930 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 334934 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 334941 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 334944 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 334948 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334953 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 334956 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 334959 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 334962 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334967 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 334972 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 334977 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 334980 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 334984 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 334989 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 334992 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 334995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 334997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335009 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335026 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335029 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335031 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335034 */   GIR_RootConstrainSelectedInstOperands,
     /* 335035 */   // GIR_Coverage, 6426,
     /* 335035 */   GIR_EraseRootFromParent_Done,
     /* 335036 */ // Label 6588: @335036
     /* 335036 */ GIM_Try, /*On fail goto*//*Label 6589*/ GIMT_Encode4(335222), // Rule ID 6427 //
     /* 335041 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335044 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335047 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335051 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335055 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335059 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335062 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335066 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335070 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335072 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 335079 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$ext), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335079 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335082 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 335086 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335101 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335106 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335111 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335113 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335116 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335120 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335125 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335127 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335130 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335134 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335139 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335142 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335145 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335148 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335153 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335158 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335163 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335166 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335170 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335175 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335178 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335181 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335183 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335186 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335190 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335195 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335202 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335207 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335220 */   GIR_RootConstrainSelectedInstOperands,
     /* 335221 */   // GIR_Coverage, 6427,
     /* 335221 */   GIR_EraseRootFromParent_Done,
     /* 335222 */ // Label 6589: @335222
     /* 335222 */ GIM_Try, /*On fail goto*//*Label 6590*/ GIMT_Encode4(335460), // Rule ID 6422 //
     /* 335227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335237 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335241 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335245 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335248 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335255 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335259 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335261 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 335268 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335268 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335271 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 335275 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335280 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335285 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335290 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335295 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335300 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335302 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335305 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335309 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335314 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335316 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335319 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335323 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335328 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335331 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335334 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335337 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335342 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335347 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335352 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335355 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335359 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335364 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335367 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335370 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335372 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335375 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335379 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335384 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335391 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335396 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335401 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335404 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335408 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335413 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335416 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335419 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335421 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335424 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335428 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335433 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335450 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335453 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335455 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335458 */   GIR_RootConstrainSelectedInstOperands,
     /* 335459 */   // GIR_Coverage, 6422,
     /* 335459 */   GIR_EraseRootFromParent_Done,
     /* 335460 */ // Label 6590: @335460
     /* 335460 */ GIM_Try, /*On fail goto*//*Label 6591*/ GIMT_Encode4(335698), // Rule ID 6423 //
     /* 335465 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335468 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335471 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335475 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335479 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 335483 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335486 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 335493 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335497 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335499 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 335506 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$ext), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335506 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 335509 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 335513 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335518 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335523 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 335528 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // ext
     /* 335533 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 335540 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 335543 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335547 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335552 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 335554 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 335557 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335561 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335566 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 335569 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 335572 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 335575 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335580 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335585 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 335590 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 335593 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 335597 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335602 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 335605 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 335608 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335610 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335613 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335617 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335622 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335629 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335634 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335639 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335642 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335646 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335651 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335654 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335657 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335659 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335662 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335666 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335671 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335678 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335683 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335693 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335696 */   GIR_RootConstrainSelectedInstOperands,
     /* 335697 */   // GIR_Coverage, 6423,
     /* 335697 */   GIR_EraseRootFromParent_Done,
     /* 335698 */ // Label 6591: @335698
     /* 335698 */ GIM_Try, /*On fail goto*//*Label 6592*/ GIMT_Encode4(335879), // Rule ID 6428 //
     /* 335703 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335706 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335709 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335713 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335717 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335721 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335724 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335728 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335732 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335734 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 335741 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335741 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335744 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 335748 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335753 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335758 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335763 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335768 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335770 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335773 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335777 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335782 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335784 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335787 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335791 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335796 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335799 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335802 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335805 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335810 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335815 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 335820 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 335823 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 335827 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335832 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 335835 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 335838 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 335840 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 335843 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 335847 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335852 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 335859 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335864 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 335869 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 335872 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 335874 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 335877 */   GIR_RootConstrainSelectedInstOperands,
     /* 335878 */   // GIR_Coverage, 6428,
     /* 335878 */   GIR_EraseRootFromParent_Done,
     /* 335879 */ // Label 6592: @335879
     /* 335879 */ GIM_Try, /*On fail goto*//*Label 6593*/ GIMT_Encode4(336060), // Rule ID 6429 //
     /* 335884 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 335887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 335890 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335894 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 335898 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 335902 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 335905 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 335909 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 335913 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 335915 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 335922 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 335922 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 335925 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 335929 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335934 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 335939 */   GIR_ComplexSubOperandRenderer, /*InsnID*/5, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 335944 */   GIR_MergeMemOperands, /*InsnID*/5, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 335949 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 335951 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s64,
     /* 335954 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 335958 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 335965 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 335968 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 335972 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 335977 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 335980 */   GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/4,
     /* 335983 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/18,
     /* 335986 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335991 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 335996 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336001 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336004 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336008 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336013 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336016 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336019 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336021 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336024 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336028 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336033 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336040 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336045 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336058 */   GIR_RootConstrainSelectedInstOperands,
     /* 336059 */   // GIR_Coverage, 6429,
     /* 336059 */   GIR_EraseRootFromParent_Done,
     /* 336060 */ // Label 6593: @336060
     /* 336060 */ GIM_Try, /*On fail goto*//*Label 6594*/ GIMT_Encode4(336293), // Rule ID 6424 //
     /* 336065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336075 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336079 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336083 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336086 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336093 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336097 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336099 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 336106 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336106 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336109 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 336113 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336118 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336123 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336128 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336135 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336138 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336142 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336147 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336149 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336152 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336156 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336161 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336164 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336167 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336170 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336175 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336180 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336185 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336188 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336192 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336197 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336200 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336203 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336205 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336208 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336212 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336217 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336224 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336229 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336234 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336237 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336241 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336246 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336249 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336252 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336254 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336257 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336261 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336266 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336273 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336278 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336283 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336286 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336288 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336291 */   GIR_RootConstrainSelectedInstOperands,
     /* 336292 */   // GIR_Coverage, 6424,
     /* 336292 */   GIR_EraseRootFromParent_Done,
     /* 336293 */ // Label 6594: @336293
     /* 336293 */ GIM_Try, /*On fail goto*//*Label 6595*/ GIMT_Encode4(336526), // Rule ID 6425 //
     /* 336298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_NotForCodeSize_UseAlternateSExtLoadCVTF32),
     /* 336301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336308 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336312 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SEXTLOAD),
     /* 336316 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 336319 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 336326 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 336330 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336332 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 336339 */   // (sint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>>)  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv2i32_shift:{ *:[f128] } (EXTRACT_SUBREG:{ *:[f64] } (SSHLLv4i16_shift:{ *:[f128] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }), 0:{ *:[i32] }), dsub:{ *:[i32] }))
     /* 336339 */   GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_s16,
     /* 336342 */   GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 336346 */   GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336351 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 336356 */   GIR_ComplexSubOperandRenderer, /*InsnID*/7, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 336361 */   GIR_MergeMemOperands, /*InsnID*/7, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 336366 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 336368 */   GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_s64,
     /* 336371 */   GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 336375 */   GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336380 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/6,
     /* 336382 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s64,
     /* 336385 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 336389 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336394 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 336397 */   GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/6,
     /* 336400 */   GIR_AddImm8, /*InsnID*/5, /*Imm*/9,
     /* 336403 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336408 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336413 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 336418 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 336421 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv4i16_shift),
     /* 336425 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336430 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 336433 */   GIR_AddImm8, /*InsnID*/4, /*Imm*/0,
     /* 336436 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 336438 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s64,
     /* 336441 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336445 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336450 */   GIR_AddTempSubRegister, /*InsnID*/3, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336457 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336462 */   GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336467 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 336470 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SSHLLv2i32_shift),
     /* 336474 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336479 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 336482 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 336485 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 336487 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336490 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336494 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336499 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 336506 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336511 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336516 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336519 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336521 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336524 */   GIR_RootConstrainSelectedInstOperands,
     /* 336525 */   // GIR_Coverage, 6425,
     /* 336525 */   GIR_EraseRootFromParent_Done,
     /* 336526 */ // Label 6595: @336526
     /* 336526 */ GIM_Try, /*On fail goto*//*Label 6596*/ GIMT_Encode4(336606), // Rule ID 2449 //
     /* 336531 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336537 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336541 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336545 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336549 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336553 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336557 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336562 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336568 */   // (sint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 336568 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 336571 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336575 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336580 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 336586 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336591 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336596 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 336599 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336601 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336604 */   GIR_RootConstrainSelectedInstOperands,
     /* 336605 */   // GIR_Coverage, 2449,
     /* 336605 */   GIR_EraseRootFromParent_Done,
     /* 336606 */ // Label 6596: @336606
     /* 336606 */ GIM_Try, /*On fail goto*//*Label 6597*/ GIMT_Encode4(336686), // Rule ID 5335 //
     /* 336611 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336614 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336617 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336621 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336625 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 336629 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336633 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 336637 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336642 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 336646 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336648 */   // (sint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (SCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 336648 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336651 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 336655 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336660 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 336666 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336671 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336676 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336679 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336681 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336684 */   GIR_RootConstrainSelectedInstOperands,
     /* 336685 */   // GIR_Coverage, 5335,
     /* 336685 */   GIR_EraseRootFromParent_Done,
     /* 336686 */ // Label 6597: @336686
     /* 336686 */ GIM_Try, /*On fail goto*//*Label 6598*/ GIMT_Encode4(336743), // Rule ID 5312 //
     /* 336691 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 336694 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336697 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336701 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 336705 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOSI),
     /* 336709 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 336713 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 336715 */   // (sint_to_fp:{ *:[f64] } (fp_to_sint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (SCVTFv1i64:{ *:[f64] } (FCVTZSv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 336715 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 336718 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv1i64),
     /* 336722 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 336727 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 336731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 336733 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 336736 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 336738 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 336741 */   GIR_RootConstrainSelectedInstOperands,
     /* 336742 */   // GIR_Coverage, 5312,
     /* 336742 */   GIR_EraseRootFromParent_Done,
     /* 336743 */ // Label 6598: @336743
     /* 336743 */ GIM_Try, /*On fail goto*//*Label 6599*/ GIMT_Encode4(336773), // Rule ID 447 //
     /* 336748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 336762 */   // (sint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (SCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 336762 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUWDri),
     /* 336767 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336771 */   GIR_RootConstrainSelectedInstOperands,
     /* 336772 */   // GIR_Coverage, 447,
     /* 336772 */   GIR_Done,
     /* 336773 */ // Label 6599: @336773
     /* 336773 */ GIM_Try, /*On fail goto*//*Label 6600*/ GIMT_Encode4(336803), // Rule ID 453 //
     /* 336778 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 336781 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 336784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336788 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 336792 */   // (sint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (SCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 336792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFUXDri),
     /* 336797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336801 */   GIR_RootConstrainSelectedInstOperands,
     /* 336802 */   // GIR_Coverage, 453,
     /* 336802 */   GIR_Done,
     /* 336803 */ // Label 6600: @336803
     /* 336803 */ GIM_Try, /*On fail goto*//*Label 6601*/ GIMT_Encode4(336833), // Rule ID 493 //
     /* 336808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 336811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 336814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 336822 */   // (sint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (SCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 336822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFDSr),
     /* 336827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336831 */   GIR_RootConstrainSelectedInstOperands,
     /* 336832 */   // GIR_Coverage, 493,
     /* 336832 */   GIR_Done,
     /* 336833 */ // Label 6601: @336833
     /* 336833 */ GIM_Reject,
     /* 336834 */ // Label 6560: @336834
     /* 336834 */ GIM_Try, /*On fail goto*//*Label 6602*/ GIMT_Encode4(336864), // Rule ID 1017 //
     /* 336839 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336842 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 336845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336849 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336853 */   // (sint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (SCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 336853 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f32),
     /* 336858 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336862 */   GIR_RootConstrainSelectedInstOperands,
     /* 336863 */   // GIR_Coverage, 1017,
     /* 336863 */   GIR_Done,
     /* 336864 */ // Label 6602: @336864
     /* 336864 */ GIM_Reject,
     /* 336865 */ // Label 6561: @336865
     /* 336865 */ GIM_Try, /*On fail goto*//*Label 6603*/ GIMT_Encode4(336895), // Rule ID 1021 //
     /* 336870 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336873 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 336876 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336880 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336884 */   // (sint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (SCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 336884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv2f64),
     /* 336889 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336893 */   GIR_RootConstrainSelectedInstOperands,
     /* 336894 */   // GIR_Coverage, 1021,
     /* 336894 */   GIR_Done,
     /* 336895 */ // Label 6603: @336895
     /* 336895 */ GIM_Reject,
     /* 336896 */ // Label 6562: @336896
     /* 336896 */ GIM_Try, /*On fail goto*//*Label 6604*/ GIMT_Encode4(336926), // Rule ID 1013 //
     /* 336901 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 336904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 336907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 336915 */   // (sint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (SCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 336915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f16),
     /* 336920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336924 */   GIR_RootConstrainSelectedInstOperands,
     /* 336925 */   // GIR_Coverage, 1013,
     /* 336925 */   GIR_Done,
     /* 336926 */ // Label 6604: @336926
     /* 336926 */ GIM_Reject,
     /* 336927 */ // Label 6563: @336927
     /* 336927 */ GIM_Try, /*On fail goto*//*Label 6605*/ GIMT_Encode4(336957), // Rule ID 1019 //
     /* 336932 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 336935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 336938 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336942 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336946 */   // (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (SCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 336946 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv4f32),
     /* 336951 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336955 */   GIR_RootConstrainSelectedInstOperands,
     /* 336956 */   // GIR_Coverage, 1019,
     /* 336956 */   GIR_Done,
     /* 336957 */ // Label 6605: @336957
     /* 336957 */ GIM_Reject,
     /* 336958 */ // Label 6564: @336958
     /* 336958 */ GIM_Try, /*On fail goto*//*Label 6606*/ GIMT_Encode4(336988), // Rule ID 1015 //
     /* 336963 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 336966 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 336969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336973 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 336977 */   // (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (SCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 336977 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv8f16),
     /* 336982 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 336986 */   GIR_RootConstrainSelectedInstOperands,
     /* 336987 */   // GIR_Coverage, 1015,
     /* 336987 */   GIR_Done,
     /* 336988 */ // Label 6606: @336988
     /* 336988 */ GIM_Reject,
     /* 336989 */ // Label 6565: @336989
     /* 336989 */ GIM_Reject,
     /* 336990 */ // Label 70: @336990
     /* 336990 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6615*/ GIMT_Encode4(340995),
     /* 337001 */ /*GILLT_s16*//*Label 6607*/ GIMT_Encode4(337041),
     /* 337005 */ /*GILLT_s32*//*Label 6608*/ GIMT_Encode4(337486),
     /* 337009 */ /*GILLT_s64*//*Label 6609*/ GIMT_Encode4(338894), GIMT_Encode4(0),
     /* 337017 */ /*GILLT_v2s32*//*Label 6610*/ GIMT_Encode4(340840),
     /* 337021 */ /*GILLT_v2s64*//*Label 6611*/ GIMT_Encode4(340871),
     /* 337025 */ /*GILLT_v4s16*//*Label 6612*/ GIMT_Encode4(340902),
     /* 337029 */ /*GILLT_v4s32*//*Label 6613*/ GIMT_Encode4(340933), GIMT_Encode4(0),
     /* 337037 */ /*GILLT_v8s16*//*Label 6614*/ GIMT_Encode4(340964),
     /* 337041 */ // Label 6607: @337041
     /* 337041 */ GIM_Try, /*On fail goto*//*Label 6616*/ GIMT_Encode4(337148), // Rule ID 5338 //
     /* 337046 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337056 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337060 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_AND),
     /* 337064 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 337068 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 337072 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 337076 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337080 */   GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 337084 */   GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 337088 */   GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337093 */   GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 337097 */   GIM_CheckConstantInt, /*MI*/1, /*Op*/2, GIMT_Encode8(65535),
     /* 337108 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 337110 */   // (uint_to_fp:{ *:[f16] } (and:{ *:[i32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), 65535:{ *:[i32] }))  =>  (UCVTFv1i16:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } FPR128:{ *:[v8i16] }:$Rn, hsub:{ *:[i32] }))
     /* 337110 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337113 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337117 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337122 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 337128 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337133 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337138 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337141 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337143 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337146 */   GIR_RootConstrainSelectedInstOperands,
     /* 337147 */   // GIR_Coverage, 5338,
     /* 337147 */   GIR_EraseRootFromParent_Done,
     /* 337148 */ // Label 6616: @337148
     /* 337148 */ GIM_Try, /*On fail goto*//*Label 6617*/ GIMT_Encode4(337228), // Rule ID 4783 //
     /* 337153 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337163 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337167 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337171 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 337175 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337179 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337184 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337188 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337190 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHSr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 337190 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337193 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337197 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337202 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 337208 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337213 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 337221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337223 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337226 */   GIR_RootConstrainSelectedInstOperands,
     /* 337227 */   // GIR_Coverage, 4783,
     /* 337227 */   GIR_EraseRootFromParent_Done,
     /* 337228 */ // Label 6617: @337228
     /* 337228 */ GIM_Try, /*On fail goto*//*Label 6618*/ GIMT_Encode4(337308), // Rule ID 4787 //
     /* 337233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337239 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337243 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337247 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 337251 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 337255 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 337259 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337264 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 337268 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337270 */   // (uint_to_fp:{ *:[f16] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFHDr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 337270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 337273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 337277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337282 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 337288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 337298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 337301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337306 */   GIR_RootConstrainSelectedInstOperands,
     /* 337307 */   // GIR_Coverage, 4787,
     /* 337307 */   GIR_EraseRootFromParent_Done,
     /* 337308 */ // Label 6618: @337308
     /* 337308 */ GIM_Try, /*On fail goto*//*Label 6619*/ GIMT_Encode4(337365), // Rule ID 5332 //
     /* 337313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsSME2p2StreamingSafe),
     /* 337316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 337331 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 337335 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337337 */   // (uint_to_fp:{ *:[f16] } (fp_to_uint:{ *:[i32] } f16:{ *:[f16] }:$Rn))  =>  (UCVTFv1i16:{ *:[f16] } (FCVTZUv1f16:{ *:[f16] } f16:{ *:[f16] }:$Rn))
     /* 337337 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 337340 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1f16),
     /* 337344 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337349 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 337353 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 337355 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 337358 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337360 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337363 */   GIR_RootConstrainSelectedInstOperands,
     /* 337364 */   // GIR_Coverage, 5332,
     /* 337364 */   GIR_EraseRootFromParent_Done,
     /* 337365 */ // Label 6619: @337365
     /* 337365 */ GIM_Try, /*On fail goto*//*Label 6620*/ GIMT_Encode4(337395), // Rule ID 467 //
     /* 337370 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 337373 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337376 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337380 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 337384 */   // (uint_to_fp:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWHri:{ *:[f16] } GPR32:{ *:[i32] }:$Rn)
     /* 337384 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWHri),
     /* 337389 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337393 */   GIR_RootConstrainSelectedInstOperands,
     /* 337394 */   // GIR_Coverage, 467,
     /* 337394 */   GIR_Done,
     /* 337395 */ // Label 6620: @337395
     /* 337395 */ GIM_Try, /*On fail goto*//*Label 6621*/ GIMT_Encode4(337425), // Rule ID 473 //
     /* 337400 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 337403 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337406 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337410 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 337414 */   // (uint_to_fp:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXHri:{ *:[f16] } GPR64:{ *:[i64] }:$Rn)
     /* 337414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXHri),
     /* 337419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337423 */   GIR_RootConstrainSelectedInstOperands,
     /* 337424 */   // GIR_Coverage, 473,
     /* 337424 */   GIR_Done,
     /* 337425 */ // Label 6621: @337425
     /* 337425 */ GIM_Try, /*On fail goto*//*Label 6622*/ GIMT_Encode4(337455), // Rule ID 499 //
     /* 337430 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337433 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337436 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337440 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337444 */   // (uint_to_fp:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFHSr:{ *:[f16] } FPR32:{ *:[i32] }:$Rn)
     /* 337444 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHSr),
     /* 337449 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337453 */   GIR_RootConstrainSelectedInstOperands,
     /* 337454 */   // GIR_Coverage, 499,
     /* 337454 */   GIR_Done,
     /* 337455 */ // Label 6622: @337455
     /* 337455 */ GIM_Try, /*On fail goto*//*Label 6623*/ GIMT_Encode4(337485), // Rule ID 503 //
     /* 337460 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 337463 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 337466 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337470 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 337474 */   // (uint_to_fp:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFHDr:{ *:[f16] } FPR64:{ *:[i64] }:$Rn)
     /* 337474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFHDr),
     /* 337479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 337483 */   GIR_RootConstrainSelectedInstOperands,
     /* 337484 */   // GIR_Coverage, 503,
     /* 337484 */   GIR_Done,
     /* 337485 */ // Label 6623: @337485
     /* 337485 */ GIM_Reject,
     /* 337486 */ // Label 6608: @337486
     /* 337486 */ GIM_Try, /*On fail goto*//*Label 6624*/ GIMT_Encode4(337626), // Rule ID 5339 //
     /* 337491 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337494 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337497 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337501 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337505 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337509 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337512 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337519 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337523 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337525 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 337532 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337532 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337535 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 337539 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337544 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337549 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337554 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337559 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337564 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337566 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337569 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337573 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337578 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337580 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337583 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337587 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337592 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337595 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337598 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337601 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337606 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337611 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337616 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337619 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337621 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337624 */   GIR_RootConstrainSelectedInstOperands,
     /* 337625 */   // GIR_Coverage, 5339,
     /* 337625 */   GIR_EraseRootFromParent_Done,
     /* 337626 */ // Label 6624: @337626
     /* 337626 */ GIM_Try, /*On fail goto*//*Label 6625*/ GIMT_Encode4(337766), // Rule ID 5340 //
     /* 337631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337641 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337645 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337649 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337652 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 337659 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337663 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337665 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 337672 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 337672 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 337675 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 337679 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337684 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337689 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337694 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337699 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337704 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337706 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337709 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337713 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337718 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337720 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337723 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337727 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337732 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337735 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337738 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 337741 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337746 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337751 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 337756 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337759 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337761 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337764 */   GIR_RootConstrainSelectedInstOperands,
     /* 337765 */   // GIR_Coverage, 5340,
     /* 337765 */   GIR_EraseRootFromParent_Done,
     /* 337766 */ // Label 6625: @337766
     /* 337766 */ GIM_Try, /*On fail goto*//*Label 6626*/ GIMT_Encode4(337906), // Rule ID 5343 //
     /* 337771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337777 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337781 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337785 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337789 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337792 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337799 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337803 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337805 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 337812 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337812 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337815 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 337819 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337824 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337829 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337834 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337839 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337846 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337849 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337853 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 337860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 337863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 337867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337872 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 337875 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 337878 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 337881 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337886 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337891 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 337896 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 337899 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 337901 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 337904 */   GIR_RootConstrainSelectedInstOperands,
     /* 337905 */   // GIR_Coverage, 5343,
     /* 337905 */   GIR_EraseRootFromParent_Done,
     /* 337906 */ // Label 6626: @337906
     /* 337906 */ GIM_Try, /*On fail goto*//*Label 6627*/ GIMT_Encode4(338046), // Rule ID 5344 //
     /* 337911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 337914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 337917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 337921 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 337925 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 337929 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 337932 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 337939 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 337943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 337945 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 337952 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 337952 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 337955 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 337959 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337964 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 337969 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 337974 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 337979 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 337984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 337986 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 337989 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 337993 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 337998 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338000 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338003 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338007 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338012 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338015 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338018 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338021 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338026 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338031 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338036 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338039 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338041 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338044 */   GIR_RootConstrainSelectedInstOperands,
     /* 338045 */   // GIR_Coverage, 5344,
     /* 338045 */   GIR_EraseRootFromParent_Done,
     /* 338046 */ // Label 6627: @338046
     /* 338046 */ GIM_Try, /*On fail goto*//*Label 6628*/ GIMT_Encode4(338181), // Rule ID 5341 //
     /* 338051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338061 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338065 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338069 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338072 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338079 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338083 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338085 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 338092 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 338092 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338095 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 338099 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338104 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338109 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338114 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338119 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338121 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338124 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338128 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338133 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338135 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338138 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338142 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338147 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338150 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338153 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338156 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338161 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338166 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338171 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338174 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338176 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338179 */   GIR_RootConstrainSelectedInstOperands,
     /* 338180 */   // GIR_Coverage, 5341,
     /* 338180 */   GIR_EraseRootFromParent_Done,
     /* 338181 */ // Label 6628: @338181
     /* 338181 */ GIM_Try, /*On fail goto*//*Label 6629*/ GIMT_Encode4(338316), // Rule ID 5342 //
     /* 338186 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338189 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338196 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338200 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338204 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338207 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 338214 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338218 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338220 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 338227 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 338227 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 338230 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 338234 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338239 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338244 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338249 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338254 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338256 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338259 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338263 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338268 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338270 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338273 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338277 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338282 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338285 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338288 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 338291 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338296 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338301 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 338306 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338309 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338311 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338314 */   GIR_RootConstrainSelectedInstOperands,
     /* 338315 */   // GIR_Coverage, 5342,
     /* 338315 */   GIR_EraseRootFromParent_Done,
     /* 338316 */ // Label 6629: @338316
     /* 338316 */ GIM_Try, /*On fail goto*//*Label 6630*/ GIMT_Encode4(338451), // Rule ID 5345 //
     /* 338321 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338324 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338327 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338331 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338335 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338339 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338342 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338349 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338353 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338355 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 338362 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 338362 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338365 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 338369 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338374 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338379 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338384 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338389 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338391 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338394 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338398 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338403 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338405 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338408 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338412 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338420 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338423 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338426 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338431 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338436 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338441 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338444 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338446 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338449 */   GIR_RootConstrainSelectedInstOperands,
     /* 338450 */   // GIR_Coverage, 5345,
     /* 338450 */   GIR_EraseRootFromParent_Done,
     /* 338451 */ // Label 6630: @338451
     /* 338451 */ GIM_Try, /*On fail goto*//*Label 6631*/ GIMT_Encode4(338586), // Rule ID 5346 //
     /* 338456 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338462 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338466 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338470 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 338474 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338477 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 338484 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338490 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 338497 */   // (uint_to_fp:{ *:[f32] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i32:{ *:[f32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 338497 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 338500 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 338504 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338509 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338514 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 338519 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338524 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338526 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 338529 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338533 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338538 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338540 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338543 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338547 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338552 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 338555 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 338558 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 338561 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338566 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338571 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 338576 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338579 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338581 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338584 */   GIR_RootConstrainSelectedInstOperands,
     /* 338585 */   // GIR_Coverage, 5346,
     /* 338585 */   GIR_EraseRootFromParent_Done,
     /* 338586 */ // Label 6631: @338586
     /* 338586 */ GIM_Try, /*On fail goto*//*Label 6632*/ GIMT_Encode4(338666), // Rule ID 4789 //
     /* 338591 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338597 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338601 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338605 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338609 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 338613 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338617 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338622 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338626 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338628 */   // (uint_to_fp:{ *:[f32] } (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFSDr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 338628 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338631 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338635 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338640 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 338646 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338651 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338656 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 338659 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338661 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338664 */   GIR_RootConstrainSelectedInstOperands,
     /* 338665 */   // GIR_Coverage, 4789,
     /* 338665 */   GIR_EraseRootFromParent_Done,
     /* 338666 */ // Label 6632: @338666
     /* 338666 */ GIM_Try, /*On fail goto*//*Label 6633*/ GIMT_Encode4(338746), // Rule ID 5334 //
     /* 338671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338677 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338681 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338685 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 338689 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 338693 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 338697 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338702 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 338706 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338708 */   // (uint_to_fp:{ *:[f32] } (vector_extract:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i32:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } FPR128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 338708 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338711 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 338715 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338720 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 338726 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338731 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 338736 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338739 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338741 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338744 */   GIR_RootConstrainSelectedInstOperands,
     /* 338745 */   // GIR_Coverage, 5334,
     /* 338745 */   GIR_EraseRootFromParent_Done,
     /* 338746 */ // Label 6633: @338746
     /* 338746 */ GIM_Try, /*On fail goto*//*Label 6634*/ GIMT_Encode4(338803), // Rule ID 5324 //
     /* 338751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338761 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338765 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 338769 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 338773 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338775 */   // (uint_to_fp:{ *:[f32] } (fp_to_uint:{ *:[i32] } f32:{ *:[f32] }:$Rn))  =>  (UCVTFv1i32:{ *:[f32] } (FCVTZUv1i32:{ *:[i32] } f32:{ *:[f32] }:$Rn))
     /* 338775 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 338778 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i32),
     /* 338782 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338787 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 338791 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 338793 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 338796 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 338798 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 338801 */   GIR_RootConstrainSelectedInstOperands,
     /* 338802 */   // GIR_Coverage, 5324,
     /* 338802 */   GIR_EraseRootFromParent_Done,
     /* 338803 */ // Label 6634: @338803
     /* 338803 */ GIM_Try, /*On fail goto*//*Label 6635*/ GIMT_Encode4(338833), // Rule ID 469 //
     /* 338808 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338811 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338814 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338818 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 338822 */   // (uint_to_fp:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWSri:{ *:[f32] } GPR32:{ *:[i32] }:$Rn)
     /* 338822 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWSri),
     /* 338827 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338831 */   GIR_RootConstrainSelectedInstOperands,
     /* 338832 */   // GIR_Coverage, 469,
     /* 338832 */   GIR_Done,
     /* 338833 */ // Label 6635: @338833
     /* 338833 */ GIM_Try, /*On fail goto*//*Label 6636*/ GIMT_Encode4(338863), // Rule ID 475 //
     /* 338838 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 338841 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338844 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338848 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 338852 */   // (uint_to_fp:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXSri:{ *:[f32] } GPR64:{ *:[i64] }:$Rn)
     /* 338852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXSri),
     /* 338857 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338861 */   GIR_RootConstrainSelectedInstOperands,
     /* 338862 */   // GIR_Coverage, 475,
     /* 338862 */   GIR_Done,
     /* 338863 */ // Label 6636: @338863
     /* 338863 */ GIM_Try, /*On fail goto*//*Label 6637*/ GIMT_Encode4(338893), // Rule ID 505 //
     /* 338868 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 338871 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 338874 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 338878 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338882 */   // (uint_to_fp:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)  =>  (UCVTFSDr:{ *:[f32] } FPR64:{ *:[i64] }:$Rn)
     /* 338882 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFSDr),
     /* 338887 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 338891 */   GIR_RootConstrainSelectedInstOperands,
     /* 338892 */   // GIR_Coverage, 505,
     /* 338892 */   GIR_Done,
     /* 338893 */ // Label 6637: @338893
     /* 338893 */ GIM_Reject,
     /* 338894 */ // Label 6609: @338894
     /* 338894 */ GIM_Try, /*On fail goto*//*Label 6638*/ GIMT_Encode4(339031), // Rule ID 5355 //
     /* 338899 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 338902 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 338905 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 338909 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 338913 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 338917 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 338920 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 338924 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 338928 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 338930 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 338937 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 338937 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 338940 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 338944 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338949 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 338954 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 338959 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 338964 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 338969 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 338971 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 338974 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 338978 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338983 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 338985 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 338988 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 338992 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 338997 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339000 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339003 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339006 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339011 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339016 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339021 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339024 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339026 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339029 */   GIR_RootConstrainSelectedInstOperands,
     /* 339030 */   // GIR_Coverage, 5355,
     /* 339030 */   GIR_EraseRootFromParent_Done,
     /* 339031 */ // Label 6638: @339031
     /* 339031 */ GIM_Try, /*On fail goto*//*Label 6639*/ GIMT_Encode4(339168), // Rule ID 5356 //
     /* 339036 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339039 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339042 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339046 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339050 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339054 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339057 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339061 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339065 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339067 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 339074 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] }))
     /* 339074 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339077 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 339081 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339086 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339091 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339096 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339101 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339106 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339108 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339111 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339115 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339120 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339122 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339125 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339129 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339134 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339137 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339140 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339143 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339148 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339153 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339166 */   GIR_RootConstrainSelectedInstOperands,
     /* 339167 */   // GIR_Coverage, 5356,
     /* 339167 */   GIR_EraseRootFromParent_Done,
     /* 339168 */ // Label 6639: @339168
     /* 339168 */ GIM_Try, /*On fail goto*//*Label 6640*/ GIMT_Encode4(339308), // Rule ID 5347 //
     /* 339173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339183 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339187 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339191 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339194 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339201 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339205 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339207 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 339214 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339214 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339217 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 339221 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339226 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339231 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339236 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339241 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339246 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339248 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339251 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339255 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339260 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339262 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339265 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339269 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339274 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339277 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339280 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339283 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339288 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339293 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339298 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339301 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339303 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339306 */   GIR_RootConstrainSelectedInstOperands,
     /* 339307 */   // GIR_Coverage, 5347,
     /* 339307 */   GIR_EraseRootFromParent_Done,
     /* 339308 */ // Label 6640: @339308
     /* 339308 */ GIM_Try, /*On fail goto*//*Label 6641*/ GIMT_Encode4(339448), // Rule ID 5348 //
     /* 339313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339323 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339327 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339331 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339334 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 339341 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339345 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339347 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 339354 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] }))
     /* 339354 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 339357 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 339361 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339366 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339371 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339376 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339381 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339386 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339388 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339391 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339395 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339400 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339402 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339405 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339409 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339414 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339417 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339420 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 339423 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339428 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339433 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 339438 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339441 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339443 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339446 */   GIR_RootConstrainSelectedInstOperands,
     /* 339447 */   // GIR_Coverage, 5348,
     /* 339447 */   GIR_EraseRootFromParent_Done,
     /* 339448 */ // Label 6641: @339448
     /* 339448 */ GIM_Try, /*On fail goto*//*Label 6642*/ GIMT_Encode4(339588), // Rule ID 5351 //
     /* 339453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339463 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339467 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339471 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339474 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339481 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339485 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339487 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 339494 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 339494 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339497 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 339501 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339506 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339511 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339516 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339521 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339526 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339528 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339531 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339535 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339542 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339545 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339549 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339554 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339557 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339560 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339563 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339568 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339573 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339578 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339581 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339583 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339586 */   GIR_RootConstrainSelectedInstOperands,
     /* 339587 */   // GIR_Coverage, 5351,
     /* 339587 */   GIR_EraseRootFromParent_Done,
     /* 339588 */ // Label 6642: @339588
     /* 339588 */ GIM_Try, /*On fail goto*//*Label 6643*/ GIMT_Encode4(339728), // Rule ID 5352 //
     /* 339593 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339596 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339603 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339607 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 339611 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339614 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 339621 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339625 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339627 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 339634 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] }))
     /* 339634 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 339637 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 339641 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339646 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339651 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 339656 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 339661 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339666 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339668 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339671 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339675 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339680 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339682 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339685 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339689 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339694 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339697 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339700 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 339703 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339708 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339713 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 339718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339726 */   GIR_RootConstrainSelectedInstOperands,
     /* 339727 */   // GIR_Coverage, 5352,
     /* 339727 */   GIR_EraseRootFromParent_Done,
     /* 339728 */ // Label 6643: @339728
     /* 339728 */ GIM_Try, /*On fail goto*//*Label 6644*/ GIMT_Encode4(339860), // Rule ID 5357 //
     /* 339733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339743 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339747 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339751 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339754 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339758 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339764 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 339771 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] }))
     /* 339771 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339774 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 339778 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339783 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339788 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339793 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339798 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339800 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339803 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339807 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339812 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339814 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339817 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339821 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339826 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339829 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339832 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339835 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339840 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339845 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339850 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339853 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339855 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339858 */   GIR_RootConstrainSelectedInstOperands,
     /* 339859 */   // GIR_Coverage, 5357,
     /* 339859 */   GIR_EraseRootFromParent_Done,
     /* 339860 */ // Label 6644: @339860
     /* 339860 */ GIM_Try, /*On fail goto*//*Label 6645*/ GIMT_Encode4(339992), // Rule ID 5358 //
     /* 339865 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 339868 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 339871 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339875 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 339879 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 339883 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 339886 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 339890 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 339894 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 339896 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 339903 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] }))
     /* 339903 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 339906 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 339910 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339915 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 339920 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 339925 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 339930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 339932 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 339935 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 339939 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339944 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 339946 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 339949 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 339953 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 339958 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 339961 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 339964 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 339967 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339972 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 339977 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 339982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 339985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 339987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 339990 */   GIR_RootConstrainSelectedInstOperands,
     /* 339991 */   // GIR_Coverage, 5358,
     /* 339991 */   GIR_EraseRootFromParent_Done,
     /* 339992 */ // Label 6645: @339992
     /* 339992 */ GIM_Try, /*On fail goto*//*Label 6646*/ GIMT_Encode4(340127), // Rule ID 5349 //
     /* 339997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340007 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340011 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340015 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340018 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340025 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340029 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340031 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 340038 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] }))
     /* 340038 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340041 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 340045 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340050 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340055 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340060 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340065 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340067 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340070 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340074 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340079 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340081 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340084 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340088 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340093 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340096 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340099 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340102 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340107 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340112 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340117 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340120 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340122 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340125 */   GIR_RootConstrainSelectedInstOperands,
     /* 340126 */   // GIR_Coverage, 5349,
     /* 340126 */   GIR_EraseRootFromParent_Done,
     /* 340127 */ // Label 6646: @340127
     /* 340127 */ GIM_Try, /*On fail goto*//*Label 6647*/ GIMT_Encode4(340262), // Rule ID 5350 //
     /* 340132 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340135 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340138 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340142 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340146 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340150 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340153 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 340160 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340164 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340166 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 340173 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] }))
     /* 340173 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s8,
     /* 340176 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 340180 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340185 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340190 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340195 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340200 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340202 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340205 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340209 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340214 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340216 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340219 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340223 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340228 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340231 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340234 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 340237 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340242 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340247 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 340252 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340255 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340257 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340260 */   GIR_RootConstrainSelectedInstOperands,
     /* 340261 */   // GIR_Coverage, 5350,
     /* 340261 */   GIR_EraseRootFromParent_Done,
     /* 340262 */ // Label 6647: @340262
     /* 340262 */ GIM_Try, /*On fail goto*//*Label 6648*/ GIMT_Encode4(340397), // Rule ID 5353 //
     /* 340267 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340270 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340277 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340281 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340285 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340288 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340295 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340299 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340301 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 340308 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] }))
     /* 340308 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340311 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 340315 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340320 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340325 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340330 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340337 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340340 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340344 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340349 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340351 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340354 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340358 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340363 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340366 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340369 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340372 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340377 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340382 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340387 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340390 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340392 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340395 */   GIR_RootConstrainSelectedInstOperands,
     /* 340396 */   // GIR_Coverage, 5353,
     /* 340396 */   GIR_EraseRootFromParent_Done,
     /* 340397 */ // Label 6648: @340397
     /* 340397 */ GIM_Try, /*On fail goto*//*Label 6649*/ GIMT_Encode4(340532), // Rule ID 5354 //
     /* 340402 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340408 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340412 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340416 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ZEXTLOAD),
     /* 340420 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 340423 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 340430 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 340434 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340436 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 340443 */   // (uint_to_fp:{ *:[f64] } (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>>)  =>  (UCVTFv1i64:{ *:[f64] } (INSERT_SUBREG:{ *:[f64] } (IMPLICIT_DEF:{ *:[f64] }), (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] }))
     /* 340443 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s16,
     /* 340446 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 340450 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340455 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 340460 */   GIR_ComplexSubOperandRenderer, /*InsnID*/3, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 340465 */   GIR_MergeMemOperands, /*InsnID*/3, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 340470 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 340472 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 340475 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 340479 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 340486 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340489 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 340493 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340498 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 340501 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 340504 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 340507 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340512 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340517 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 340522 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340525 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340527 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340530 */   GIR_RootConstrainSelectedInstOperands,
     /* 340531 */   // GIR_Coverage, 5354,
     /* 340531 */   GIR_EraseRootFromParent_Done,
     /* 340532 */ // Label 6649: @340532
     /* 340532 */ GIM_Try, /*On fail goto*//*Label 6650*/ GIMT_Encode4(340612), // Rule ID 4785 //
     /* 340537 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 340540 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340543 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340547 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340551 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340555 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340559 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340563 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340568 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 340572 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340574 */   // (uint_to_fp:{ *:[f64] } (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFDSr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, ssub:{ *:[i32] }))
     /* 340574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 340577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340586 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 340592 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340597 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340602 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 340605 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340607 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340610 */   GIR_RootConstrainSelectedInstOperands,
     /* 340611 */   // GIR_Coverage, 4785,
     /* 340611 */   GIR_EraseRootFromParent_Done,
     /* 340612 */ // Label 6650: @340612
     /* 340612 */ GIM_Try, /*On fail goto*//*Label 6651*/ GIMT_Encode4(340692), // Rule ID 5336 //
     /* 340617 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340620 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340623 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340627 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340631 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 340635 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340639 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 340643 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340648 */   GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 340652 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340654 */   // (uint_to_fp:{ *:[f64] } (vector_extract:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }))  =>  (UCVTFv1i64:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] }))
     /* 340654 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340657 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 340661 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340666 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 340672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340677 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340682 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340685 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340687 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340690 */   GIR_RootConstrainSelectedInstOperands,
     /* 340691 */   // GIR_Coverage, 5336,
     /* 340691 */   GIR_EraseRootFromParent_Done,
     /* 340692 */ // Label 6651: @340692
     /* 340692 */ GIM_Try, /*On fail goto*//*Label 6652*/ GIMT_Encode4(340749), // Rule ID 5320 //
     /* 340697 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsSME2p2StreamingSafe),
     /* 340700 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340703 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340707 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 340711 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FPTOUI),
     /* 340715 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 340719 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 340721 */   // (uint_to_fp:{ *:[f64] } (fp_to_uint:{ *:[i64] } f64:{ *:[f64] }:$Rn))  =>  (UCVTFv1i64:{ *:[f64] } (FCVTZUv1i64:{ *:[i64] } f64:{ *:[f64] }:$Rn))
     /* 340721 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 340724 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv1i64),
     /* 340728 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 340733 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 340737 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 340739 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 340742 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 340744 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 340747 */   GIR_RootConstrainSelectedInstOperands,
     /* 340748 */   // GIR_Coverage, 5320,
     /* 340748 */   GIR_EraseRootFromParent_Done,
     /* 340749 */ // Label 6652: @340749
     /* 340749 */ GIM_Try, /*On fail goto*//*Label 6653*/ GIMT_Encode4(340779), // Rule ID 471 //
     /* 340754 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340757 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 340768 */   // (uint_to_fp:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)  =>  (UCVTFUWDri:{ *:[f64] } GPR32:{ *:[i32] }:$Rn)
     /* 340768 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUWDri),
     /* 340773 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340777 */   GIR_RootConstrainSelectedInstOperands,
     /* 340778 */   // GIR_Coverage, 471,
     /* 340778 */   GIR_Done,
     /* 340779 */ // Label 6653: @340779
     /* 340779 */ GIM_Try, /*On fail goto*//*Label 6654*/ GIMT_Encode4(340809), // Rule ID 477 //
     /* 340784 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 340787 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 340790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 340798 */   // (uint_to_fp:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)  =>  (UCVTFUXDri:{ *:[f64] } GPR64:{ *:[i64] }:$Rn)
     /* 340798 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFUXDri),
     /* 340803 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340807 */   GIR_RootConstrainSelectedInstOperands,
     /* 340808 */   // GIR_Coverage, 477,
     /* 340808 */   GIR_Done,
     /* 340809 */ // Label 6654: @340809
     /* 340809 */ GIM_Try, /*On fail goto*//*Label 6655*/ GIMT_Encode4(340839), // Rule ID 501 //
     /* 340814 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPRCVT_HasNEON),
     /* 340817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 340820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 340828 */   // (uint_to_fp:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)  =>  (UCVTFDSr:{ *:[f64] } FPR32:{ *:[i32] }:$Rn)
     /* 340828 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFDSr),
     /* 340833 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340837 */   GIR_RootConstrainSelectedInstOperands,
     /* 340838 */   // GIR_Coverage, 501,
     /* 340838 */   GIR_Done,
     /* 340839 */ // Label 6655: @340839
     /* 340839 */ GIM_Reject,
     /* 340840 */ // Label 6610: @340840
     /* 340840 */ GIM_Try, /*On fail goto*//*Label 6656*/ GIMT_Encode4(340870), // Rule ID 1078 //
     /* 340845 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 340851 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340855 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340859 */   // (uint_to_fp:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)  =>  (UCVTFv2f32:{ *:[v2f32] } V64:{ *:[v2i32] }:$Rn)
     /* 340859 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f32),
     /* 340864 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340868 */   GIR_RootConstrainSelectedInstOperands,
     /* 340869 */   // GIR_Coverage, 1078,
     /* 340869 */   GIR_Done,
     /* 340870 */ // Label 6656: @340870
     /* 340870 */ GIM_Reject,
     /* 340871 */ // Label 6611: @340871
     /* 340871 */ GIM_Try, /*On fail goto*//*Label 6657*/ GIMT_Encode4(340901), // Rule ID 1082 //
     /* 340876 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340879 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 340882 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340886 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340890 */   // (uint_to_fp:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)  =>  (UCVTFv2f64:{ *:[v2f64] } V128:{ *:[v2i64] }:$Rn)
     /* 340890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv2f64),
     /* 340895 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340899 */   GIR_RootConstrainSelectedInstOperands,
     /* 340900 */   // GIR_Coverage, 1082,
     /* 340900 */   GIR_Done,
     /* 340901 */ // Label 6657: @340901
     /* 340901 */ GIM_Reject,
     /* 340902 */ // Label 6612: @340902
     /* 340902 */ GIM_Try, /*On fail goto*//*Label 6658*/ GIMT_Encode4(340932), // Rule ID 1074 //
     /* 340907 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340910 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 340913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 340921 */   // (uint_to_fp:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)  =>  (UCVTFv4f16:{ *:[v4f16] } V64:{ *:[v4i16] }:$Rn)
     /* 340921 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f16),
     /* 340926 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340930 */   GIR_RootConstrainSelectedInstOperands,
     /* 340931 */   // GIR_Coverage, 1074,
     /* 340931 */   GIR_Done,
     /* 340932 */ // Label 6658: @340932
     /* 340932 */ GIM_Reject,
     /* 340933 */ // Label 6613: @340933
     /* 340933 */ GIM_Try, /*On fail goto*//*Label 6659*/ GIMT_Encode4(340963), // Rule ID 1080 //
     /* 340938 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 340941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 340944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340952 */   // (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)  =>  (UCVTFv4f32:{ *:[v4f32] } V128:{ *:[v4i32] }:$Rn)
     /* 340952 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv4f32),
     /* 340957 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340961 */   GIR_RootConstrainSelectedInstOperands,
     /* 340962 */   // GIR_Coverage, 1080,
     /* 340962 */   GIR_Done,
     /* 340963 */ // Label 6659: @340963
     /* 340963 */ GIM_Reject,
     /* 340964 */ // Label 6614: @340964
     /* 340964 */ GIM_Try, /*On fail goto*//*Label 6660*/ GIMT_Encode4(340994), // Rule ID 1076 //
     /* 340969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 340972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 340975 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340979 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 340983 */   // (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)  =>  (UCVTFv8f16:{ *:[v8f16] } V128:{ *:[v8i16] }:$Rn)
     /* 340983 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv8f16),
     /* 340988 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 340992 */   GIR_RootConstrainSelectedInstOperands,
     /* 340993 */   // GIR_Coverage, 1076,
     /* 340993 */   GIR_Done,
     /* 340994 */ // Label 6660: @340994
     /* 340994 */ GIM_Reject,
     /* 340995 */ // Label 6615: @340995
     /* 340995 */ GIM_Reject,
     /* 340996 */ // Label 71: @340996
     /* 340996 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6668*/ GIMT_Encode4(341315),
     /* 341007 */ /*GILLT_s32*//*Label 6661*/ GIMT_Encode4(341043),
     /* 341011 */ /*GILLT_s64*//*Label 6662*/ GIMT_Encode4(341116), GIMT_Encode4(0),
     /* 341019 */ /*GILLT_v2s32*//*Label 6663*/ GIMT_Encode4(341189),
     /* 341023 */ /*GILLT_v2s64*//*Label 6664*/ GIMT_Encode4(341213),
     /* 341027 */ /*GILLT_v4s16*//*Label 6665*/ GIMT_Encode4(341237),
     /* 341031 */ /*GILLT_v4s32*//*Label 6666*/ GIMT_Encode4(341264), GIMT_Encode4(0),
     /* 341039 */ /*GILLT_v8s16*//*Label 6667*/ GIMT_Encode4(341288),
     /* 341043 */ // Label 6661: @341043
     /* 341043 */ GIM_Try, /*On fail goto*//*Label 6669*/ GIMT_Encode4(341069), // Rule ID 4618 //
     /* 341048 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341058 */   // (fp_to_sint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 341058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWHr),
     /* 341063 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341067 */   GIR_RootConstrainSelectedInstOperands,
     /* 341068 */   // GIR_Coverage, 4618,
     /* 341068 */   GIR_Done,
     /* 341069 */ // Label 6669: @341069
     /* 341069 */ GIM_Try, /*On fail goto*//*Label 6670*/ GIMT_Encode4(341092), // Rule ID 4620 //
     /* 341074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341077 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341081 */   // (fp_to_sint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 341081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWSr),
     /* 341086 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341090 */   GIR_RootConstrainSelectedInstOperands,
     /* 341091 */   // GIR_Coverage, 4620,
     /* 341091 */   GIR_Done,
     /* 341092 */ // Label 6670: @341092
     /* 341092 */ GIM_Try, /*On fail goto*//*Label 6671*/ GIMT_Encode4(341115), // Rule ID 4622 //
     /* 341097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341100 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341104 */   // (fp_to_sint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 341104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUWDr),
     /* 341109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341113 */   GIR_RootConstrainSelectedInstOperands,
     /* 341114 */   // GIR_Coverage, 4622,
     /* 341114 */   GIR_Done,
     /* 341115 */ // Label 6671: @341115
     /* 341115 */ GIM_Reject,
     /* 341116 */ // Label 6662: @341116
     /* 341116 */ GIM_Try, /*On fail goto*//*Label 6672*/ GIMT_Encode4(341142), // Rule ID 4619 //
     /* 341121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341131 */   // (fp_to_sint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZSUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 341131 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXHr),
     /* 341136 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341140 */   GIR_RootConstrainSelectedInstOperands,
     /* 341141 */   // GIR_Coverage, 4619,
     /* 341141 */   GIR_Done,
     /* 341142 */ // Label 6672: @341142
     /* 341142 */ GIM_Try, /*On fail goto*//*Label 6673*/ GIMT_Encode4(341165), // Rule ID 4621 //
     /* 341147 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341150 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341154 */   // (fp_to_sint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZSUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 341154 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXSr),
     /* 341159 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341163 */   GIR_RootConstrainSelectedInstOperands,
     /* 341164 */   // GIR_Coverage, 4621,
     /* 341164 */   GIR_Done,
     /* 341165 */ // Label 6673: @341165
     /* 341165 */ GIM_Try, /*On fail goto*//*Label 6674*/ GIMT_Encode4(341188), // Rule ID 4623 //
     /* 341170 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341177 */   // (fp_to_sint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZSUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 341177 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSUXDr),
     /* 341182 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341186 */   GIR_RootConstrainSelectedInstOperands,
     /* 341187 */   // GIR_Coverage, 4623,
     /* 341187 */   GIR_Done,
     /* 341188 */ // Label 6674: @341188
     /* 341188 */ GIM_Reject,
     /* 341189 */ // Label 6663: @341189
     /* 341189 */ GIM_Try, /*On fail goto*//*Label 6675*/ GIMT_Encode4(341212), // Rule ID 4959 //
     /* 341194 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341197 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341201 */   // (fp_to_sint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZSv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 341201 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f32),
     /* 341206 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341210 */   GIR_RootConstrainSelectedInstOperands,
     /* 341211 */   // GIR_Coverage, 4959,
     /* 341211 */   GIR_Done,
     /* 341212 */ // Label 6675: @341212
     /* 341212 */ GIM_Reject,
     /* 341213 */ // Label 6664: @341213
     /* 341213 */ GIM_Try, /*On fail goto*//*Label 6676*/ GIMT_Encode4(341236), // Rule ID 4961 //
     /* 341218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341225 */   // (fp_to_sint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZSv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 341225 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv2f64),
     /* 341230 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341234 */   GIR_RootConstrainSelectedInstOperands,
     /* 341235 */   // GIR_Coverage, 4961,
     /* 341235 */   GIR_Done,
     /* 341236 */ // Label 6676: @341236
     /* 341236 */ GIM_Reject,
     /* 341237 */ // Label 6665: @341237
     /* 341237 */ GIM_Try, /*On fail goto*//*Label 6677*/ GIMT_Encode4(341263), // Rule ID 4954 //
     /* 341242 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341248 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341252 */   // (fp_to_sint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZSv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 341252 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f16),
     /* 341257 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341261 */   GIR_RootConstrainSelectedInstOperands,
     /* 341262 */   // GIR_Coverage, 4954,
     /* 341262 */   GIR_Done,
     /* 341263 */ // Label 6677: @341263
     /* 341263 */ GIM_Reject,
     /* 341264 */ // Label 6666: @341264
     /* 341264 */ GIM_Try, /*On fail goto*//*Label 6678*/ GIMT_Encode4(341287), // Rule ID 4960 //
     /* 341269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341272 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341276 */   // (fp_to_sint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZSv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 341276 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv4f32),
     /* 341281 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341285 */   GIR_RootConstrainSelectedInstOperands,
     /* 341286 */   // GIR_Coverage, 4960,
     /* 341286 */   GIR_Done,
     /* 341287 */ // Label 6678: @341287
     /* 341287 */ GIM_Reject,
     /* 341288 */ // Label 6667: @341288
     /* 341288 */ GIM_Try, /*On fail goto*//*Label 6679*/ GIMT_Encode4(341314), // Rule ID 4955 //
     /* 341293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341303 */   // (fp_to_sint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZSv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 341303 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZSv8f16),
     /* 341308 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341312 */   GIR_RootConstrainSelectedInstOperands,
     /* 341313 */   // GIR_Coverage, 4955,
     /* 341313 */   GIR_Done,
     /* 341314 */ // Label 6679: @341314
     /* 341314 */ GIM_Reject,
     /* 341315 */ // Label 6668: @341315
     /* 341315 */ GIM_Reject,
     /* 341316 */ // Label 72: @341316
     /* 341316 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 6687*/ GIMT_Encode4(341635),
     /* 341327 */ /*GILLT_s32*//*Label 6680*/ GIMT_Encode4(341363),
     /* 341331 */ /*GILLT_s64*//*Label 6681*/ GIMT_Encode4(341436), GIMT_Encode4(0),
     /* 341339 */ /*GILLT_v2s32*//*Label 6682*/ GIMT_Encode4(341509),
     /* 341343 */ /*GILLT_v2s64*//*Label 6683*/ GIMT_Encode4(341533),
     /* 341347 */ /*GILLT_v4s16*//*Label 6684*/ GIMT_Encode4(341557),
     /* 341351 */ /*GILLT_v4s32*//*Label 6685*/ GIMT_Encode4(341584), GIMT_Encode4(0),
     /* 341359 */ /*GILLT_v8s16*//*Label 6686*/ GIMT_Encode4(341608),
     /* 341363 */ // Label 6680: @341363
     /* 341363 */ GIM_Try, /*On fail goto*//*Label 6688*/ GIMT_Encode4(341389), // Rule ID 4642 //
     /* 341368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341378 */   // (fp_to_uint_sat_gi:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 341378 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWHr),
     /* 341383 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341387 */   GIR_RootConstrainSelectedInstOperands,
     /* 341388 */   // GIR_Coverage, 4642,
     /* 341388 */   GIR_Done,
     /* 341389 */ // Label 6688: @341389
     /* 341389 */ GIM_Try, /*On fail goto*//*Label 6689*/ GIMT_Encode4(341412), // Rule ID 4644 //
     /* 341394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341401 */   // (fp_to_uint_sat_gi:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 341401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWSr),
     /* 341406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341410 */   GIR_RootConstrainSelectedInstOperands,
     /* 341411 */   // GIR_Coverage, 4644,
     /* 341411 */   GIR_Done,
     /* 341412 */ // Label 6689: @341412
     /* 341412 */ GIM_Try, /*On fail goto*//*Label 6690*/ GIMT_Encode4(341435), // Rule ID 4646 //
     /* 341417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341424 */   // (fp_to_uint_sat_gi:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 341424 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUWDr),
     /* 341429 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341433 */   GIR_RootConstrainSelectedInstOperands,
     /* 341434 */   // GIR_Coverage, 4646,
     /* 341434 */   GIR_Done,
     /* 341435 */ // Label 6690: @341435
     /* 341435 */ GIM_Reject,
     /* 341436 */ // Label 6681: @341436
     /* 341436 */ GIM_Try, /*On fail goto*//*Label 6691*/ GIMT_Encode4(341462), // Rule ID 4643 //
     /* 341441 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341444 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341447 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341451 */   // (fp_to_uint_sat_gi:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTZUUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 341451 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXHr),
     /* 341456 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341460 */   GIR_RootConstrainSelectedInstOperands,
     /* 341461 */   // GIR_Coverage, 4643,
     /* 341461 */   GIR_Done,
     /* 341462 */ // Label 6691: @341462
     /* 341462 */ GIM_Try, /*On fail goto*//*Label 6692*/ GIMT_Encode4(341485), // Rule ID 4645 //
     /* 341467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341474 */   // (fp_to_uint_sat_gi:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTZUUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 341474 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXSr),
     /* 341479 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341483 */   GIR_RootConstrainSelectedInstOperands,
     /* 341484 */   // GIR_Coverage, 4645,
     /* 341484 */   GIR_Done,
     /* 341485 */ // Label 6692: @341485
     /* 341485 */ GIM_Try, /*On fail goto*//*Label 6693*/ GIMT_Encode4(341508), // Rule ID 4647 //
     /* 341490 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341493 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 341497 */   // (fp_to_uint_sat_gi:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTZUUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 341497 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUUXDr),
     /* 341502 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341506 */   GIR_RootConstrainSelectedInstOperands,
     /* 341507 */   // GIR_Coverage, 4647,
     /* 341507 */   GIR_Done,
     /* 341508 */ // Label 6693: @341508
     /* 341508 */ GIM_Reject,
     /* 341509 */ // Label 6682: @341509
     /* 341509 */ GIM_Try, /*On fail goto*//*Label 6694*/ GIMT_Encode4(341532), // Rule ID 4969 //
     /* 341514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 341517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341521 */   // (fp_to_uint_sat_gi:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)  =>  (FCVTZUv2f32:{ *:[v2i32] } v2f32:{ *:[v2f32] }:$Rn)
     /* 341521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f32),
     /* 341526 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341530 */   GIR_RootConstrainSelectedInstOperands,
     /* 341531 */   // GIR_Coverage, 4969,
     /* 341531 */   GIR_Done,
     /* 341532 */ // Label 6694: @341532
     /* 341532 */ GIM_Reject,
     /* 341533 */ // Label 6683: @341533
     /* 341533 */ GIM_Try, /*On fail goto*//*Label 6695*/ GIMT_Encode4(341556), // Rule ID 4971 //
     /* 341538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 341541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341545 */   // (fp_to_uint_sat_gi:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)  =>  (FCVTZUv2f64:{ *:[v2i64] } v2f64:{ *:[v2f64] }:$Rn)
     /* 341545 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv2f64),
     /* 341550 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341554 */   GIR_RootConstrainSelectedInstOperands,
     /* 341555 */   // GIR_Coverage, 4971,
     /* 341555 */   GIR_Done,
     /* 341556 */ // Label 6695: @341556
     /* 341556 */ GIM_Reject,
     /* 341557 */ // Label 6684: @341557
     /* 341557 */ GIM_Try, /*On fail goto*//*Label 6696*/ GIMT_Encode4(341583), // Rule ID 4964 //
     /* 341562 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 341568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341572 */   // (fp_to_uint_sat_gi:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)  =>  (FCVTZUv4f16:{ *:[v4i16] } v4f16:{ *:[v4f16] }:$Rn)
     /* 341572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f16),
     /* 341577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341581 */   GIR_RootConstrainSelectedInstOperands,
     /* 341582 */   // GIR_Coverage, 4964,
     /* 341582 */   GIR_Done,
     /* 341583 */ // Label 6696: @341583
     /* 341583 */ GIM_Reject,
     /* 341584 */ // Label 6685: @341584
     /* 341584 */ GIM_Try, /*On fail goto*//*Label 6697*/ GIMT_Encode4(341607), // Rule ID 4970 //
     /* 341589 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 341592 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341596 */   // (fp_to_uint_sat_gi:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)  =>  (FCVTZUv4f32:{ *:[v4i32] } v4f32:{ *:[v4f32] }:$Rn)
     /* 341596 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv4f32),
     /* 341601 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341605 */   GIR_RootConstrainSelectedInstOperands,
     /* 341606 */   // GIR_Coverage, 4970,
     /* 341606 */   GIR_Done,
     /* 341607 */ // Label 6697: @341607
     /* 341607 */ GIM_Reject,
     /* 341608 */ // Label 6686: @341608
     /* 341608 */ GIM_Try, /*On fail goto*//*Label 6698*/ GIMT_Encode4(341634), // Rule ID 4965 //
     /* 341613 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 341619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 341623 */   // (fp_to_uint_sat_gi:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)  =>  (FCVTZUv8f16:{ *:[v8i16] } v8f16:{ *:[v8f16] }:$Rn)
     /* 341623 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTZUv8f16),
     /* 341628 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 341632 */   GIR_RootConstrainSelectedInstOperands,
     /* 341633 */   // GIR_Coverage, 4965,
     /* 341633 */   GIR_Done,
     /* 341634 */ // Label 6698: @341634
     /* 341634 */ GIM_Reject,
     /* 341635 */ // Label 6687: @341635
     /* 341635 */ GIM_Reject,
     /* 341636 */ // Label 73: @341636
     /* 341636 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6707*/ GIMT_Encode4(342492),
     /* 341647 */ /*GILLT_s16*//*Label 6699*/ GIMT_Encode4(341687),
     /* 341651 */ /*GILLT_s32*//*Label 6700*/ GIMT_Encode4(341906),
     /* 341655 */ /*GILLT_s64*//*Label 6701*/ GIMT_Encode4(341980), GIMT_Encode4(0),
     /* 341663 */ /*GILLT_v2s32*//*Label 6702*/ GIMT_Encode4(342054),
     /* 341667 */ /*GILLT_v2s64*//*Label 6703*/ GIMT_Encode4(342128),
     /* 341671 */ /*GILLT_v4s16*//*Label 6704*/ GIMT_Encode4(342202),
     /* 341675 */ /*GILLT_v4s32*//*Label 6705*/ GIMT_Encode4(342310), GIMT_Encode4(0),
     /* 341683 */ /*GILLT_v8s16*//*Label 6706*/ GIMT_Encode4(342384),
     /* 341687 */ // Label 6699: @341687
     /* 341687 */ GIM_Try, /*On fail goto*//*Label 6708*/ GIMT_Encode4(341905),
     /* 341692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 341695 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341699 */   GIM_Try, /*On fail goto*//*Label 6709*/ GIMT_Encode4(341740), // Rule ID 5222 //
     /* 341704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 341707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 341719 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s16,
     /* 341723 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341725 */     // (fabs:{ *:[f16] } (fsub:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm))  =>  (FABD16:{ *:[f16] } f16:{ *:[f16] }:$Rn, f16:{ *:[f16] }:$Rm)
     /* 341725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD16),
     /* 341728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341730 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341734 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341738 */     GIR_RootConstrainSelectedInstOperands,
     /* 341739 */     // GIR_Coverage, 5222,
     /* 341739 */     GIR_EraseRootFromParent_Done,
     /* 341740 */   // Label 6709: @341740
     /* 341740 */   GIM_Try, /*On fail goto*//*Label 6710*/ GIMT_Encode4(341759), // Rule ID 521 //
     /* 341745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 341748 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341752 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FABSHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 341752 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSHr),
     /* 341757 */     GIR_RootConstrainSelectedInstOperands,
     /* 341758 */     // GIR_Coverage, 521,
     /* 341758 */     GIR_Done,
     /* 341759 */   // Label 6710: @341759
     /* 341759 */   GIM_Try, /*On fail goto*//*Label 6711*/ GIMT_Encode4(341904), // Rule ID 6408 //
     /* 341764 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341768 */     // (fabs:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[f16] } (COPY_TO_REGCLASS:{ *:[f32] } (ANDWri:{ *:[i32] } (COPY_TO_REGCLASS:{ *:[i32] } (INSERT_SUBREG:{ *:[f32] } (IMPLICIT_DEF:{ *:[f32] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), GPR32:{ *:[i32] }), (logical_imm32_XFORM:{ *:[i32] } 32767:{ *:[i32] })), FPR32:{ *:[i32] }), hsub:{ *:[i32] })
     /* 341768 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 341771 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 341775 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341780 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 341782 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s32,
     /* 341785 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 341789 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341794 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 341797 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 341801 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 341804 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341809 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341814 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341819 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s32,
     /* 341822 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341826 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341831 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 341834 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 341839 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 341842 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::ANDWri),
     /* 341846 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341851 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 341854 */     GIR_CustomRenderer, /*InsnID*/2, /*OldInsnID*/0, /*Renderer*/GIMT_Encode2(GICR_renderLogicalImm32), // 
     /* 341859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 341861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 341864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 341873 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 341876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 341884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 341886 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 341893 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 341898 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341903 */     // GIR_Coverage, 6408,
     /* 341903 */     GIR_EraseRootFromParent_Done,
     /* 341904 */   // Label 6711: @341904
     /* 341904 */   GIM_Reject,
     /* 341905 */ // Label 6708: @341905
     /* 341905 */ GIM_Reject,
     /* 341906 */ // Label 6700: @341906
     /* 341906 */ GIM_Try, /*On fail goto*//*Label 6712*/ GIMT_Encode4(341979),
     /* 341911 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 341914 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341918 */   GIM_Try, /*On fail goto*//*Label 6713*/ GIMT_Encode4(341959), // Rule ID 5223 //
     /* 341923 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 341926 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 341930 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 341934 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 341938 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 341942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 341944 */     // (fabs:{ *:[f32] } (fsub:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm))  =>  (FABD32:{ *:[f32] } f32:{ *:[f32] }:$Rn, f32:{ *:[f32] }:$Rm)
     /* 341944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD32),
     /* 341947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 341949 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 341953 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 341957 */     GIR_RootConstrainSelectedInstOperands,
     /* 341958 */     // GIR_Coverage, 5223,
     /* 341958 */     GIR_EraseRootFromParent_Done,
     /* 341959 */   // Label 6713: @341959
     /* 341959 */   GIM_Try, /*On fail goto*//*Label 6714*/ GIMT_Encode4(341978), // Rule ID 522 //
     /* 341964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 341967 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 341971 */     // (fabs:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FABSSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 341971 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSSr),
     /* 341976 */     GIR_RootConstrainSelectedInstOperands,
     /* 341977 */     // GIR_Coverage, 522,
     /* 341977 */     GIR_Done,
     /* 341978 */   // Label 6714: @341978
     /* 341978 */   GIM_Reject,
     /* 341979 */ // Label 6712: @341979
     /* 341979 */ GIM_Reject,
     /* 341980 */ // Label 6701: @341980
     /* 341980 */ GIM_Try, /*On fail goto*//*Label 6715*/ GIMT_Encode4(342053),
     /* 341985 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 341988 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 341992 */   GIM_Try, /*On fail goto*//*Label 6716*/ GIMT_Encode4(342033), // Rule ID 5224 //
     /* 341997 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342000 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342004 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342008 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 342012 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 342016 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342018 */     // (fabs:{ *:[f64] } (fsub:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm))  =>  (FABD64:{ *:[f64] } f64:{ *:[f64] }:$Rn, f64:{ *:[f64] }:$Rm)
     /* 342018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABD64),
     /* 342021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342023 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342027 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342031 */     GIR_RootConstrainSelectedInstOperands,
     /* 342032 */     // GIR_Coverage, 5224,
     /* 342032 */     GIR_EraseRootFromParent_Done,
     /* 342033 */   // Label 6716: @342033
     /* 342033 */   GIM_Try, /*On fail goto*//*Label 6717*/ GIMT_Encode4(342052), // Rule ID 523 //
     /* 342038 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342041 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342045 */     // (fabs:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FABSDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 342045 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSDr),
     /* 342050 */     GIR_RootConstrainSelectedInstOperands,
     /* 342051 */     // GIR_Coverage, 523,
     /* 342051 */     GIR_Done,
     /* 342052 */   // Label 6717: @342052
     /* 342052 */   GIM_Reject,
     /* 342053 */ // Label 6715: @342053
     /* 342053 */ GIM_Reject,
     /* 342054 */ // Label 6702: @342054
     /* 342054 */ GIM_Try, /*On fail goto*//*Label 6718*/ GIMT_Encode4(342127),
     /* 342059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342066 */   GIM_Try, /*On fail goto*//*Label 6719*/ GIMT_Encode4(342107), // Rule ID 5036 //
     /* 342071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342086 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342090 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342092 */     // (fabs:{ *:[v2f32] } (fsub:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm))  =>  (FABDv2f32:{ *:[v2f32] } v2f32:{ *:[v2f32] }:$Rn, v2f32:{ *:[v2f32] }:$Rm)
     /* 342092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f32),
     /* 342095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342097 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342101 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342105 */     GIR_RootConstrainSelectedInstOperands,
     /* 342106 */     // GIR_Coverage, 5036,
     /* 342106 */     GIR_EraseRootFromParent_Done,
     /* 342107 */   // Label 6719: @342107
     /* 342107 */   GIM_Try, /*On fail goto*//*Label 6720*/ GIMT_Encode4(342126), // Rule ID 768 //
     /* 342112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342119 */     // (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FABSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 342119 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f32),
     /* 342124 */     GIR_RootConstrainSelectedInstOperands,
     /* 342125 */     // GIR_Coverage, 768,
     /* 342125 */     GIR_Done,
     /* 342126 */   // Label 6720: @342126
     /* 342126 */   GIM_Reject,
     /* 342127 */ // Label 6718: @342127
     /* 342127 */ GIM_Reject,
     /* 342128 */ // Label 6703: @342128
     /* 342128 */ GIM_Try, /*On fail goto*//*Label 6721*/ GIMT_Encode4(342201),
     /* 342133 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342136 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342140 */   GIM_Try, /*On fail goto*//*Label 6722*/ GIMT_Encode4(342181), // Rule ID 5038 //
     /* 342145 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342152 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342156 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342160 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 342164 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342166 */     // (fabs:{ *:[v2f64] } (fsub:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm))  =>  (FABDv2f64:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, v2f64:{ *:[v2f64] }:$Rm)
     /* 342166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv2f64),
     /* 342169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342179 */     GIR_RootConstrainSelectedInstOperands,
     /* 342180 */     // GIR_Coverage, 5038,
     /* 342180 */     GIR_EraseRootFromParent_Done,
     /* 342181 */   // Label 6722: @342181
     /* 342181 */   GIM_Try, /*On fail goto*//*Label 6723*/ GIMT_Encode4(342200), // Rule ID 770 //
     /* 342186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342189 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342193 */     // (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FABSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 342193 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv2f64),
     /* 342198 */     GIR_RootConstrainSelectedInstOperands,
     /* 342199 */     // GIR_Coverage, 770,
     /* 342199 */     GIR_Done,
     /* 342200 */   // Label 6723: @342200
     /* 342200 */   GIM_Reject,
     /* 342201 */ // Label 6721: @342201
     /* 342201 */ GIM_Reject,
     /* 342202 */ // Label 6704: @342202
     /* 342202 */ GIM_Try, /*On fail goto*//*Label 6724*/ GIMT_Encode4(342309),
     /* 342207 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342210 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342214 */   GIM_Try, /*On fail goto*//*Label 6725*/ GIMT_Encode4(342255), // Rule ID 5039 //
     /* 342219 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342222 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342226 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342230 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342234 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 342238 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342240 */     // (fabs:{ *:[v4f16] } (fsub:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm))  =>  (FABDv4f16:{ *:[v4f16] } v4f16:{ *:[v4f16] }:$Rn, v4f16:{ *:[v4f16] }:$Rm)
     /* 342240 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f16),
     /* 342243 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342245 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342249 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342253 */     GIR_RootConstrainSelectedInstOperands,
     /* 342254 */     // GIR_Coverage, 5039,
     /* 342254 */     GIR_EraseRootFromParent_Done,
     /* 342255 */   // Label 6725: @342255
     /* 342255 */   GIM_Try, /*On fail goto*//*Label 6726*/ GIMT_Encode4(342274), // Rule ID 766 //
     /* 342260 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342267 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FABSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 342267 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f16),
     /* 342272 */     GIR_RootConstrainSelectedInstOperands,
     /* 342273 */     // GIR_Coverage, 766,
     /* 342273 */     GIR_Done,
     /* 342274 */   // Label 6726: @342274
     /* 342274 */   GIM_Try, /*On fail goto*//*Label 6727*/ GIMT_Encode4(342308), // Rule ID 6410 //
     /* 342279 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342282 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342286 */     // (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (BICv4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 342286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv4i16),
     /* 342289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342291 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342293 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 342303 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 342306 */     GIR_RootConstrainSelectedInstOperands,
     /* 342307 */     // GIR_Coverage, 6410,
     /* 342307 */     GIR_EraseRootFromParent_Done,
     /* 342308 */   // Label 6727: @342308
     /* 342308 */   GIM_Reject,
     /* 342309 */ // Label 6724: @342309
     /* 342309 */ GIM_Reject,
     /* 342310 */ // Label 6705: @342310
     /* 342310 */ GIM_Try, /*On fail goto*//*Label 6728*/ GIMT_Encode4(342383),
     /* 342315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342322 */   GIM_Try, /*On fail goto*//*Label 6729*/ GIMT_Encode4(342363), // Rule ID 5037 //
     /* 342327 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342338 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342342 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 342346 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342348 */     // (fabs:{ *:[v4f32] } (fsub:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm))  =>  (FABDv4f32:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, v4f32:{ *:[v4f32] }:$Rm)
     /* 342348 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv4f32),
     /* 342351 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342353 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342357 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342361 */     GIR_RootConstrainSelectedInstOperands,
     /* 342362 */     // GIR_Coverage, 5037,
     /* 342362 */     GIR_EraseRootFromParent_Done,
     /* 342363 */   // Label 6729: @342363
     /* 342363 */   GIM_Try, /*On fail goto*//*Label 6730*/ GIMT_Encode4(342382), // Rule ID 769 //
     /* 342368 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342371 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342375 */     // (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FABSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 342375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv4f32),
     /* 342380 */     GIR_RootConstrainSelectedInstOperands,
     /* 342381 */     // GIR_Coverage, 769,
     /* 342381 */     GIR_Done,
     /* 342382 */   // Label 6730: @342382
     /* 342382 */   GIM_Reject,
     /* 342383 */ // Label 6728: @342383
     /* 342383 */ GIM_Reject,
     /* 342384 */ // Label 6706: @342384
     /* 342384 */ GIM_Try, /*On fail goto*//*Label 6731*/ GIMT_Encode4(342491),
     /* 342389 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342396 */   GIM_Try, /*On fail goto*//*Label 6732*/ GIMT_Encode4(342437), // Rule ID 5040 //
     /* 342401 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342404 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 342408 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FSUB),
     /* 342412 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342416 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 342420 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 342422 */     // (fabs:{ *:[v8f16] } (fsub:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm))  =>  (FABDv8f16:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, v8f16:{ *:[v8f16] }:$Rm)
     /* 342422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FABDv8f16),
     /* 342425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342427 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 342431 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rm
     /* 342435 */     GIR_RootConstrainSelectedInstOperands,
     /* 342436 */     // GIR_Coverage, 5040,
     /* 342436 */     GIR_EraseRootFromParent_Done,
     /* 342437 */   // Label 6732: @342437
     /* 342437 */   GIM_Try, /*On fail goto*//*Label 6733*/ GIMT_Encode4(342456), // Rule ID 767 //
     /* 342442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342445 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342449 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FABSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 342449 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FABSv8f16),
     /* 342454 */     GIR_RootConstrainSelectedInstOperands,
     /* 342455 */     // GIR_Coverage, 767,
     /* 342455 */     GIR_Done,
     /* 342456 */   // Label 6733: @342456
     /* 342456 */   GIM_Try, /*On fail goto*//*Label 6734*/ GIMT_Encode4(342490), // Rule ID 6411 //
     /* 342461 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342464 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342468 */     // (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (BICv8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, 128:{ *:[i32] }, 8:{ *:[i32] })
     /* 342468 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BICv8i16),
     /* 342471 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 342473 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342475 */     GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(128),
     /* 342485 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/8,
     /* 342488 */     GIR_RootConstrainSelectedInstOperands,
     /* 342489 */     // GIR_Coverage, 6411,
     /* 342489 */     GIR_EraseRootFromParent_Done,
     /* 342490 */   // Label 6734: @342490
     /* 342490 */   GIM_Reject,
     /* 342491 */ // Label 6731: @342491
     /* 342491 */ GIM_Reject,
     /* 342492 */ // Label 6707: @342492
     /* 342492 */ GIM_Reject,
     /* 342493 */ // Label 74: @342493
     /* 342493 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6743*/ GIMT_Encode4(342774),
     /* 342504 */ /*GILLT_s16*//*Label 6735*/ GIMT_Encode4(342544),
     /* 342508 */ /*GILLT_s32*//*Label 6736*/ GIMT_Encode4(342571),
     /* 342512 */ /*GILLT_s64*//*Label 6737*/ GIMT_Encode4(342595), GIMT_Encode4(0),
     /* 342520 */ /*GILLT_v2s32*//*Label 6738*/ GIMT_Encode4(342619),
     /* 342524 */ /*GILLT_v2s64*//*Label 6739*/ GIMT_Encode4(342650),
     /* 342528 */ /*GILLT_v4s16*//*Label 6740*/ GIMT_Encode4(342681),
     /* 342532 */ /*GILLT_v4s32*//*Label 6741*/ GIMT_Encode4(342712), GIMT_Encode4(0),
     /* 342540 */ /*GILLT_v8s16*//*Label 6742*/ GIMT_Encode4(342743),
     /* 342544 */ // Label 6735: @342544
     /* 342544 */ GIM_Try, /*On fail goto*//*Label 6744*/ GIMT_Encode4(342570), // Rule ID 4858 //
     /* 342549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342559 */   // (fcanonicalize:{ *:[f16] } f16:{ *:[f16] }:$a)  =>  (FMINNMHrr:{ *:[f16] } f16:{ *:[f16] }:$a, f16:{ *:[f16] }:$a)
     /* 342559 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342562 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342564 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342566 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342568 */   GIR_RootConstrainSelectedInstOperands,
     /* 342569 */   // GIR_Coverage, 4858,
     /* 342569 */   GIR_EraseRootFromParent_Done,
     /* 342570 */ // Label 6744: @342570
     /* 342570 */ GIM_Reject,
     /* 342571 */ // Label 6736: @342571
     /* 342571 */ GIM_Try, /*On fail goto*//*Label 6745*/ GIMT_Encode4(342594), // Rule ID 4855 //
     /* 342576 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342579 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342583 */   // (fcanonicalize:{ *:[f32] } f32:{ *:[f32] }:$a)  =>  (FMINNMSrr:{ *:[f32] } f32:{ *:[f32] }:$a, f32:{ *:[f32] }:$a)
     /* 342583 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342586 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342588 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342590 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342592 */   GIR_RootConstrainSelectedInstOperands,
     /* 342593 */   // GIR_Coverage, 4855,
     /* 342593 */   GIR_EraseRootFromParent_Done,
     /* 342594 */ // Label 6745: @342594
     /* 342594 */ GIM_Reject,
     /* 342595 */ // Label 6737: @342595
     /* 342595 */ GIM_Try, /*On fail goto*//*Label 6746*/ GIMT_Encode4(342618), // Rule ID 4852 //
     /* 342600 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342603 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342607 */   // (fcanonicalize:{ *:[f64] } f64:{ *:[f64] }:$a)  =>  (FMINNMDrr:{ *:[f64] } f64:{ *:[f64] }:$a, f64:{ *:[f64] }:$a)
     /* 342607 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342610 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342612 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342614 */   GIR_RootToRootCopy, /*OpIdx*/1, // a
     /* 342616 */   GIR_RootConstrainSelectedInstOperands,
     /* 342617 */   // GIR_Coverage, 4852,
     /* 342617 */   GIR_EraseRootFromParent_Done,
     /* 342618 */ // Label 6746: @342618
     /* 342618 */ GIM_Reject,
     /* 342619 */ // Label 6738: @342619
     /* 342619 */ GIM_Try, /*On fail goto*//*Label 6747*/ GIMT_Encode4(342649), // Rule ID 5049 //
     /* 342624 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342630 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342634 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342638 */   // (fcanonicalize:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rn)
     /* 342638 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342641 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342643 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342645 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342647 */   GIR_RootConstrainSelectedInstOperands,
     /* 342648 */   // GIR_Coverage, 5049,
     /* 342648 */   GIR_EraseRootFromParent_Done,
     /* 342649 */ // Label 6747: @342649
     /* 342649 */ GIM_Reject,
     /* 342650 */ // Label 6739: @342650
     /* 342650 */ GIM_Try, /*On fail goto*//*Label 6748*/ GIMT_Encode4(342680), // Rule ID 5043 //
     /* 342655 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342658 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 342661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342665 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342669 */   // (fcanonicalize:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn)
     /* 342669 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 342672 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342674 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342676 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342678 */   GIR_RootConstrainSelectedInstOperands,
     /* 342679 */   // GIR_Coverage, 5043,
     /* 342679 */   GIR_EraseRootFromParent_Done,
     /* 342680 */ // Label 6748: @342680
     /* 342680 */ GIM_Reject,
     /* 342681 */ // Label 6740: @342681
     /* 342681 */ GIM_Try, /*On fail goto*//*Label 6749*/ GIMT_Encode4(342711), // Rule ID 5055 //
     /* 342686 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342689 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 342692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342700 */   // (fcanonicalize:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn)
     /* 342700 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 342703 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342705 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342707 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342709 */   GIR_RootConstrainSelectedInstOperands,
     /* 342710 */   // GIR_Coverage, 5055,
     /* 342710 */   GIR_EraseRootFromParent_Done,
     /* 342711 */ // Label 6749: @342711
     /* 342711 */ GIM_Reject,
     /* 342712 */ // Label 6741: @342712
     /* 342712 */ GIM_Try, /*On fail goto*//*Label 6750*/ GIMT_Encode4(342742), // Rule ID 5046 //
     /* 342717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 342723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342727 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342731 */   // (fcanonicalize:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn)
     /* 342731 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 342734 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342736 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342738 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342740 */   GIR_RootConstrainSelectedInstOperands,
     /* 342741 */   // GIR_Coverage, 5046,
     /* 342741 */   GIR_EraseRootFromParent_Done,
     /* 342742 */ // Label 6750: @342742
     /* 342742 */ GIM_Reject,
     /* 342743 */ // Label 6742: @342743
     /* 342743 */ GIM_Try, /*On fail goto*//*Label 6751*/ GIMT_Encode4(342773), // Rule ID 5052 //
     /* 342748 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 342751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 342754 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342758 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 342762 */   // (fcanonicalize:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn)
     /* 342762 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 342765 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 342767 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 342771 */   GIR_RootConstrainSelectedInstOperands,
     /* 342772 */   // GIR_Coverage, 5052,
     /* 342772 */   GIR_EraseRootFromParent_Done,
     /* 342773 */ // Label 6751: @342773
     /* 342773 */ GIM_Reject,
     /* 342774 */ // Label 6743: @342774
     /* 342774 */ GIM_Reject,
     /* 342775 */ // Label 75: @342775
     /* 342775 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6760*/ GIMT_Encode4(343152),
     /* 342786 */ /*GILLT_s16*//*Label 6752*/ GIMT_Encode4(342826),
     /* 342790 */ /*GILLT_s32*//*Label 6753*/ GIMT_Encode4(342864),
     /* 342794 */ /*GILLT_s64*//*Label 6754*/ GIMT_Encode4(342902), GIMT_Encode4(0),
     /* 342802 */ /*GILLT_v2s32*//*Label 6755*/ GIMT_Encode4(342962),
     /* 342806 */ /*GILLT_v2s64*//*Label 6756*/ GIMT_Encode4(343000),
     /* 342810 */ /*GILLT_v4s16*//*Label 6757*/ GIMT_Encode4(343038),
     /* 342814 */ /*GILLT_v4s32*//*Label 6758*/ GIMT_Encode4(343076), GIMT_Encode4(0),
     /* 342822 */ /*GILLT_v8s16*//*Label 6759*/ GIMT_Encode4(343114),
     /* 342826 */ // Label 6752: @342826
     /* 342826 */ GIM_Try, /*On fail goto*//*Label 6761*/ GIMT_Encode4(342863), // Rule ID 608 //
     /* 342831 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 342834 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 342837 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 342840 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342844 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342848 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 342852 */   // (fminnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 342852 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 342857 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342861 */   GIR_RootConstrainSelectedInstOperands,
     /* 342862 */   // GIR_Coverage, 608,
     /* 342862 */   GIR_Done,
     /* 342863 */ // Label 6761: @342863
     /* 342863 */ GIM_Reject,
     /* 342864 */ // Label 6753: @342864
     /* 342864 */ GIM_Try, /*On fail goto*//*Label 6762*/ GIMT_Encode4(342901), // Rule ID 610 //
     /* 342869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 342875 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 342878 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342882 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342886 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 342890 */   // (fminnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 342890 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 342895 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342899 */   GIR_RootConstrainSelectedInstOperands,
     /* 342900 */   // GIR_Coverage, 610,
     /* 342900 */   GIR_Done,
     /* 342901 */ // Label 6762: @342901
     /* 342901 */ GIM_Reject,
     /* 342902 */ // Label 6754: @342902
     /* 342902 */ GIM_Try, /*On fail goto*//*Label 6763*/ GIMT_Encode4(342961),
     /* 342907 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 342910 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 342913 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342917 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342921 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342925 */   GIM_Try, /*On fail goto*//*Label 6764*/ GIMT_Encode4(342944), // Rule ID 612 //
     /* 342930 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 342933 */     // (fminnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 342933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342942 */     GIR_RootConstrainSelectedInstOperands,
     /* 342943 */     // GIR_Coverage, 612,
     /* 342943 */     GIR_Done,
     /* 342944 */   // Label 6764: @342944
     /* 342944 */   GIM_Try, /*On fail goto*//*Label 6765*/ GIMT_Encode4(342960), // Rule ID 4849 //
     /* 342949 */     // (fminnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 342949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 342954 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342958 */     GIR_RootConstrainSelectedInstOperands,
     /* 342959 */     // GIR_Coverage, 4849,
     /* 342959 */     GIR_Done,
     /* 342960 */   // Label 6765: @342960
     /* 342960 */   GIM_Reject,
     /* 342961 */ // Label 6763: @342961
     /* 342961 */ GIM_Reject,
     /* 342962 */ // Label 6755: @342962
     /* 342962 */ GIM_Try, /*On fail goto*//*Label 6766*/ GIMT_Encode4(342999), // Rule ID 1273 //
     /* 342967 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 342970 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 342973 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 342976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342980 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342984 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 342988 */   // (fminnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 342988 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 342993 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 342997 */   GIR_RootConstrainSelectedInstOperands,
     /* 342998 */   // GIR_Coverage, 1273,
     /* 342998 */   GIR_Done,
     /* 342999 */ // Label 6766: @342999
     /* 342999 */ GIM_Reject,
     /* 343000 */ // Label 6756: @343000
     /* 343000 */ GIM_Try, /*On fail goto*//*Label 6767*/ GIMT_Encode4(343037), // Rule ID 1277 //
     /* 343005 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343026 */   // (fminnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343026 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343031 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343035 */   GIR_RootConstrainSelectedInstOperands,
     /* 343036 */   // GIR_Coverage, 1277,
     /* 343036 */   GIR_Done,
     /* 343037 */ // Label 6767: @343037
     /* 343037 */ GIM_Reject,
     /* 343038 */ // Label 6757: @343038
     /* 343038 */ GIM_Try, /*On fail goto*//*Label 6768*/ GIMT_Encode4(343075), // Rule ID 1269 //
     /* 343043 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343046 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343049 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343052 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343056 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343060 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343064 */   // (fminnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343064 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343069 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343073 */   GIR_RootConstrainSelectedInstOperands,
     /* 343074 */   // GIR_Coverage, 1269,
     /* 343074 */   GIR_Done,
     /* 343075 */ // Label 6768: @343075
     /* 343075 */ GIM_Reject,
     /* 343076 */ // Label 6758: @343076
     /* 343076 */ GIM_Try, /*On fail goto*//*Label 6769*/ GIMT_Encode4(343113), // Rule ID 1275 //
     /* 343081 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343084 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343087 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343098 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343102 */   // (fminnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343111 */   GIR_RootConstrainSelectedInstOperands,
     /* 343112 */   // GIR_Coverage, 1275,
     /* 343112 */   GIR_Done,
     /* 343113 */ // Label 6769: @343113
     /* 343113 */ GIM_Reject,
     /* 343114 */ // Label 6759: @343114
     /* 343114 */ GIM_Try, /*On fail goto*//*Label 6770*/ GIMT_Encode4(343151), // Rule ID 1271 //
     /* 343119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343140 */   // (fminnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343149 */   GIR_RootConstrainSelectedInstOperands,
     /* 343150 */   // GIR_Coverage, 1271,
     /* 343150 */   GIR_Done,
     /* 343151 */ // Label 6770: @343151
     /* 343151 */ GIM_Reject,
     /* 343152 */ // Label 6760: @343152
     /* 343152 */ GIM_Reject,
     /* 343153 */ // Label 76: @343153
     /* 343153 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6779*/ GIMT_Encode4(343530),
     /* 343164 */ /*GILLT_s16*//*Label 6771*/ GIMT_Encode4(343204),
     /* 343168 */ /*GILLT_s32*//*Label 6772*/ GIMT_Encode4(343242),
     /* 343172 */ /*GILLT_s64*//*Label 6773*/ GIMT_Encode4(343280), GIMT_Encode4(0),
     /* 343180 */ /*GILLT_v2s32*//*Label 6774*/ GIMT_Encode4(343340),
     /* 343184 */ /*GILLT_v2s64*//*Label 6775*/ GIMT_Encode4(343378),
     /* 343188 */ /*GILLT_v4s16*//*Label 6776*/ GIMT_Encode4(343416),
     /* 343192 */ /*GILLT_v4s32*//*Label 6777*/ GIMT_Encode4(343454), GIMT_Encode4(0),
     /* 343200 */ /*GILLT_v8s16*//*Label 6778*/ GIMT_Encode4(343492),
     /* 343204 */ // Label 6771: @343204
     /* 343204 */ GIM_Try, /*On fail goto*//*Label 6780*/ GIMT_Encode4(343241), // Rule ID 596 //
     /* 343209 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343212 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343215 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343218 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343222 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343226 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343230 */   // (fmaxnum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 343230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343239 */   GIR_RootConstrainSelectedInstOperands,
     /* 343240 */   // GIR_Coverage, 596,
     /* 343240 */   GIR_Done,
     /* 343241 */ // Label 6780: @343241
     /* 343241 */ GIM_Reject,
     /* 343242 */ // Label 6772: @343242
     /* 343242 */ GIM_Try, /*On fail goto*//*Label 6781*/ GIMT_Encode4(343279), // Rule ID 598 //
     /* 343247 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343253 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343256 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343260 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343264 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343268 */   // (fmaxnum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 343268 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343273 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343277 */   GIR_RootConstrainSelectedInstOperands,
     /* 343278 */   // GIR_Coverage, 598,
     /* 343278 */   GIR_Done,
     /* 343279 */ // Label 6781: @343279
     /* 343279 */ GIM_Reject,
     /* 343280 */ // Label 6773: @343280
     /* 343280 */ GIM_Try, /*On fail goto*//*Label 6782*/ GIMT_Encode4(343339),
     /* 343285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343299 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343303 */   GIM_Try, /*On fail goto*//*Label 6783*/ GIMT_Encode4(343322), // Rule ID 600 //
     /* 343308 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 343311 */     // (fmaxnum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 343311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343316 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343320 */     GIR_RootConstrainSelectedInstOperands,
     /* 343321 */     // GIR_Coverage, 600,
     /* 343321 */     GIR_Done,
     /* 343322 */   // Label 6783: @343322
     /* 343322 */   GIM_Try, /*On fail goto*//*Label 6784*/ GIMT_Encode4(343338), // Rule ID 4848 //
     /* 343327 */     // (fmaxnum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXNMDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 343327 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 343332 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343336 */     GIR_RootConstrainSelectedInstOperands,
     /* 343337 */     // GIR_Coverage, 4848,
     /* 343337 */     GIR_Done,
     /* 343338 */   // Label 6784: @343338
     /* 343338 */   GIM_Reject,
     /* 343339 */ // Label 6782: @343339
     /* 343339 */ GIM_Reject,
     /* 343340 */ // Label 6774: @343340
     /* 343340 */ GIM_Try, /*On fail goto*//*Label 6785*/ GIMT_Encode4(343377), // Rule ID 1243 //
     /* 343345 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343348 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343351 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343354 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343358 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343362 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343366 */   // (fmaxnum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343366 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 343371 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343375 */   GIR_RootConstrainSelectedInstOperands,
     /* 343376 */   // GIR_Coverage, 1243,
     /* 343376 */   GIR_Done,
     /* 343377 */ // Label 6785: @343377
     /* 343377 */ GIM_Reject,
     /* 343378 */ // Label 6775: @343378
     /* 343378 */ GIM_Try, /*On fail goto*//*Label 6786*/ GIMT_Encode4(343415), // Rule ID 1247 //
     /* 343383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343404 */   // (fmaxnum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 343409 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343413 */   GIR_RootConstrainSelectedInstOperands,
     /* 343414 */   // GIR_Coverage, 1247,
     /* 343414 */   GIR_Done,
     /* 343415 */ // Label 6786: @343415
     /* 343415 */ GIM_Reject,
     /* 343416 */ // Label 6776: @343416
     /* 343416 */ GIM_Try, /*On fail goto*//*Label 6787*/ GIMT_Encode4(343453), // Rule ID 1239 //
     /* 343421 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343424 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343427 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343430 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343434 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343438 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343442 */   // (fmaxnum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343442 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 343447 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343451 */   GIR_RootConstrainSelectedInstOperands,
     /* 343452 */   // GIR_Coverage, 1239,
     /* 343452 */   GIR_Done,
     /* 343453 */ // Label 6787: @343453
     /* 343453 */ GIM_Reject,
     /* 343454 */ // Label 6777: @343454
     /* 343454 */ GIM_Try, /*On fail goto*//*Label 6788*/ GIMT_Encode4(343491), // Rule ID 1245 //
     /* 343459 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343462 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343465 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343472 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343476 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343480 */   // (fmaxnum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 343485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343489 */   GIR_RootConstrainSelectedInstOperands,
     /* 343490 */   // GIR_Coverage, 1245,
     /* 343490 */   GIR_Done,
     /* 343491 */ // Label 6788: @343491
     /* 343491 */ GIM_Reject,
     /* 343492 */ // Label 6778: @343492
     /* 343492 */ GIM_Try, /*On fail goto*//*Label 6789*/ GIMT_Encode4(343529), // Rule ID 1241 //
     /* 343497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343503 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343506 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343510 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343514 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343518 */   // (fmaxnum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343518 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 343523 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343527 */   GIR_RootConstrainSelectedInstOperands,
     /* 343528 */   // GIR_Coverage, 1241,
     /* 343528 */   GIR_Done,
     /* 343529 */ // Label 6789: @343529
     /* 343529 */ GIM_Reject,
     /* 343530 */ // Label 6779: @343530
     /* 343530 */ GIM_Reject,
     /* 343531 */ // Label 77: @343531
     /* 343531 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6798*/ GIMT_Encode4(343880),
     /* 343542 */ /*GILLT_s16*//*Label 6790*/ GIMT_Encode4(343582),
     /* 343546 */ /*GILLT_s32*//*Label 6791*/ GIMT_Encode4(343620),
     /* 343550 */ /*GILLT_s64*//*Label 6792*/ GIMT_Encode4(343655), GIMT_Encode4(0),
     /* 343558 */ /*GILLT_v2s32*//*Label 6793*/ GIMT_Encode4(343690),
     /* 343562 */ /*GILLT_v2s64*//*Label 6794*/ GIMT_Encode4(343728),
     /* 343566 */ /*GILLT_v4s16*//*Label 6795*/ GIMT_Encode4(343766),
     /* 343570 */ /*GILLT_v4s32*//*Label 6796*/ GIMT_Encode4(343804), GIMT_Encode4(0),
     /* 343578 */ /*GILLT_v8s16*//*Label 6797*/ GIMT_Encode4(343842),
     /* 343582 */ // Label 6790: @343582
     /* 343582 */ GIM_Try, /*On fail goto*//*Label 6799*/ GIMT_Encode4(343619), // Rule ID 4856 //
     /* 343587 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343604 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343608 */   // (fminnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMINNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 343608 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMHrr),
     /* 343613 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343617 */   GIR_RootConstrainSelectedInstOperands,
     /* 343618 */   // GIR_Coverage, 4856,
     /* 343618 */   GIR_Done,
     /* 343619 */ // Label 6799: @343619
     /* 343619 */ GIM_Reject,
     /* 343620 */ // Label 6791: @343620
     /* 343620 */ GIM_Try, /*On fail goto*//*Label 6800*/ GIMT_Encode4(343654), // Rule ID 4853 //
     /* 343625 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343628 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343639 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343643 */   // (fminnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMINNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 343643 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMSrr),
     /* 343648 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343652 */   GIR_RootConstrainSelectedInstOperands,
     /* 343653 */   // GIR_Coverage, 4853,
     /* 343653 */   GIR_Done,
     /* 343654 */ // Label 6800: @343654
     /* 343654 */ GIM_Reject,
     /* 343655 */ // Label 6792: @343655
     /* 343655 */ GIM_Try, /*On fail goto*//*Label 6801*/ GIMT_Encode4(343689), // Rule ID 4850 //
     /* 343660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 343663 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 343666 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343670 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343674 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343678 */   // (fminnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMINNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 343678 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMDrr),
     /* 343683 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343687 */   GIR_RootConstrainSelectedInstOperands,
     /* 343688 */   // GIR_Coverage, 4850,
     /* 343688 */   GIR_Done,
     /* 343689 */ // Label 6801: @343689
     /* 343689 */ GIM_Reject,
     /* 343690 */ // Label 6793: @343690
     /* 343690 */ GIM_Try, /*On fail goto*//*Label 6802*/ GIMT_Encode4(343727), // Rule ID 5047 //
     /* 343695 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343698 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 343701 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 343704 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343708 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343712 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343716 */   // (fminnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 343716 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f32),
     /* 343721 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343725 */   GIR_RootConstrainSelectedInstOperands,
     /* 343726 */   // GIR_Coverage, 5047,
     /* 343726 */   GIR_Done,
     /* 343727 */ // Label 6802: @343727
     /* 343727 */ GIM_Reject,
     /* 343728 */ // Label 6794: @343728
     /* 343728 */ GIM_Try, /*On fail goto*//*Label 6803*/ GIMT_Encode4(343765), // Rule ID 5041 //
     /* 343733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 343739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 343742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343750 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343754 */   // (fminnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 343754 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv2f64),
     /* 343759 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343763 */   GIR_RootConstrainSelectedInstOperands,
     /* 343764 */   // GIR_Coverage, 5041,
     /* 343764 */   GIR_Done,
     /* 343765 */ // Label 6803: @343765
     /* 343765 */ GIM_Reject,
     /* 343766 */ // Label 6795: @343766
     /* 343766 */ GIM_Try, /*On fail goto*//*Label 6804*/ GIMT_Encode4(343803), // Rule ID 5053 //
     /* 343771 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 343777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 343780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343784 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 343792 */   // (fminnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 343792 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f16),
     /* 343797 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343801 */   GIR_RootConstrainSelectedInstOperands,
     /* 343802 */   // GIR_Coverage, 5053,
     /* 343802 */   GIR_Done,
     /* 343803 */ // Label 6804: @343803
     /* 343803 */ GIM_Reject,
     /* 343804 */ // Label 6796: @343804
     /* 343804 */ GIM_Try, /*On fail goto*//*Label 6805*/ GIMT_Encode4(343841), // Rule ID 5044 //
     /* 343809 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 343812 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 343815 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 343818 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343822 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343826 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343830 */   // (fminnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 343830 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv4f32),
     /* 343835 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343839 */   GIR_RootConstrainSelectedInstOperands,
     /* 343840 */   // GIR_Coverage, 5044,
     /* 343840 */   GIR_Done,
     /* 343841 */ // Label 6805: @343841
     /* 343841 */ GIM_Reject,
     /* 343842 */ // Label 6797: @343842
     /* 343842 */ GIM_Try, /*On fail goto*//*Label 6806*/ GIMT_Encode4(343879), // Rule ID 5050 //
     /* 343847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 343850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 343853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 343856 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343860 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343864 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 343868 */   // (fminnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 343868 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMv8f16),
     /* 343873 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343877 */   GIR_RootConstrainSelectedInstOperands,
     /* 343878 */   // GIR_Coverage, 5050,
     /* 343878 */   GIR_Done,
     /* 343879 */ // Label 6806: @343879
     /* 343879 */ GIM_Reject,
     /* 343880 */ // Label 6798: @343880
     /* 343880 */ GIM_Reject,
     /* 343881 */ // Label 78: @343881
     /* 343881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6815*/ GIMT_Encode4(344230),
     /* 343892 */ /*GILLT_s16*//*Label 6807*/ GIMT_Encode4(343932),
     /* 343896 */ /*GILLT_s32*//*Label 6808*/ GIMT_Encode4(343970),
     /* 343900 */ /*GILLT_s64*//*Label 6809*/ GIMT_Encode4(344005), GIMT_Encode4(0),
     /* 343908 */ /*GILLT_v2s32*//*Label 6810*/ GIMT_Encode4(344040),
     /* 343912 */ /*GILLT_v2s64*//*Label 6811*/ GIMT_Encode4(344078),
     /* 343916 */ /*GILLT_v4s16*//*Label 6812*/ GIMT_Encode4(344116),
     /* 343920 */ /*GILLT_v4s32*//*Label 6813*/ GIMT_Encode4(344154), GIMT_Encode4(0),
     /* 343928 */ /*GILLT_v8s16*//*Label 6814*/ GIMT_Encode4(344192),
     /* 343932 */ // Label 6807: @343932
     /* 343932 */ GIM_Try, /*On fail goto*//*Label 6816*/ GIMT_Encode4(343969), // Rule ID 4857 //
     /* 343937 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 343940 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 343943 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 343946 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343950 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343954 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 343958 */   // (fmaxnum_ieee:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)  =>  (FMAXNMHrr:{ *:[f16] } FPR16:{ *:[f16] }:$a, FPR16:{ *:[f16] }:$b)
     /* 343958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMHrr),
     /* 343963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 343967 */   GIR_RootConstrainSelectedInstOperands,
     /* 343968 */   // GIR_Coverage, 4857,
     /* 343968 */   GIR_Done,
     /* 343969 */ // Label 6816: @343969
     /* 343969 */ GIM_Reject,
     /* 343970 */ // Label 6808: @343970
     /* 343970 */ GIM_Try, /*On fail goto*//*Label 6817*/ GIMT_Encode4(344004), // Rule ID 4854 //
     /* 343975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 343978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 343981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 343993 */   // (fmaxnum_ieee:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)  =>  (FMAXNMSrr:{ *:[f32] } FPR32:{ *:[f32] }:$a, FPR32:{ *:[f32] }:$b)
     /* 343993 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMSrr),
     /* 343998 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344002 */   GIR_RootConstrainSelectedInstOperands,
     /* 344003 */   // GIR_Coverage, 4854,
     /* 344003 */   GIR_Done,
     /* 344004 */ // Label 6817: @344004
     /* 344004 */ GIM_Reject,
     /* 344005 */ // Label 6809: @344005
     /* 344005 */ GIM_Try, /*On fail goto*//*Label 6818*/ GIMT_Encode4(344039), // Rule ID 4851 //
     /* 344010 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344013 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344016 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344020 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344024 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344028 */   // (fmaxnum_ieee:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)  =>  (FMAXNMDrr:{ *:[f64] } FPR64:{ *:[f64] }:$a, FPR64:{ *:[f64] }:$b)
     /* 344028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMDrr),
     /* 344033 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344037 */   GIR_RootConstrainSelectedInstOperands,
     /* 344038 */   // GIR_Coverage, 4851,
     /* 344038 */   GIR_Done,
     /* 344039 */ // Label 6818: @344039
     /* 344039 */ GIM_Reject,
     /* 344040 */ // Label 6810: @344040
     /* 344040 */ GIM_Try, /*On fail goto*//*Label 6819*/ GIMT_Encode4(344077), // Rule ID 5048 //
     /* 344045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344066 */   // (fmaxnum_ieee:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXNMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344066 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f32),
     /* 344071 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344075 */   GIR_RootConstrainSelectedInstOperands,
     /* 344076 */   // GIR_Coverage, 5048,
     /* 344076 */   GIR_Done,
     /* 344077 */ // Label 6819: @344077
     /* 344077 */ GIM_Reject,
     /* 344078 */ // Label 6811: @344078
     /* 344078 */ GIM_Try, /*On fail goto*//*Label 6820*/ GIMT_Encode4(344115), // Rule ID 5042 //
     /* 344083 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344086 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344089 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344100 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344104 */   // (fmaxnum_ieee:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXNMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344104 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv2f64),
     /* 344109 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344113 */   GIR_RootConstrainSelectedInstOperands,
     /* 344114 */   // GIR_Coverage, 5042,
     /* 344114 */   GIR_Done,
     /* 344115 */ // Label 6820: @344115
     /* 344115 */ GIM_Reject,
     /* 344116 */ // Label 6812: @344116
     /* 344116 */ GIM_Try, /*On fail goto*//*Label 6821*/ GIMT_Encode4(344153), // Rule ID 5054 //
     /* 344121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344142 */   // (fmaxnum_ieee:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXNMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f16),
     /* 344147 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344151 */   GIR_RootConstrainSelectedInstOperands,
     /* 344152 */   // GIR_Coverage, 5054,
     /* 344152 */   GIR_Done,
     /* 344153 */ // Label 6821: @344153
     /* 344153 */ GIM_Reject,
     /* 344154 */ // Label 6813: @344154
     /* 344154 */ GIM_Try, /*On fail goto*//*Label 6822*/ GIMT_Encode4(344191), // Rule ID 5045 //
     /* 344159 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344162 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344165 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344168 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344172 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344176 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344180 */   // (fmaxnum_ieee:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXNMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344180 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv4f32),
     /* 344185 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344189 */   GIR_RootConstrainSelectedInstOperands,
     /* 344190 */   // GIR_Coverage, 5045,
     /* 344190 */   GIR_Done,
     /* 344191 */ // Label 6822: @344191
     /* 344191 */ GIM_Reject,
     /* 344192 */ // Label 6814: @344192
     /* 344192 */ GIM_Try, /*On fail goto*//*Label 6823*/ GIMT_Encode4(344229), // Rule ID 5051 //
     /* 344197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344214 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344218 */   // (fmaxnum_ieee:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXNMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344218 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMv8f16),
     /* 344223 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344227 */   GIR_RootConstrainSelectedInstOperands,
     /* 344228 */   // GIR_Coverage, 5051,
     /* 344228 */   GIR_Done,
     /* 344229 */ // Label 6823: @344229
     /* 344229 */ GIM_Reject,
     /* 344230 */ // Label 6815: @344230
     /* 344230 */ GIM_Reject,
     /* 344231 */ // Label 79: @344231
     /* 344231 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6832*/ GIMT_Encode4(344933),
     /* 344242 */ /*GILLT_s16*//*Label 6824*/ GIMT_Encode4(344282),
     /* 344246 */ /*GILLT_s32*//*Label 6825*/ GIMT_Encode4(344320),
     /* 344250 */ /*GILLT_s64*//*Label 6826*/ GIMT_Encode4(344358), GIMT_Encode4(0),
     /* 344258 */ /*GILLT_v2s32*//*Label 6827*/ GIMT_Encode4(344418),
     /* 344262 */ /*GILLT_v2s64*//*Label 6828*/ GIMT_Encode4(344521),
     /* 344266 */ /*GILLT_v4s16*//*Label 6829*/ GIMT_Encode4(344624),
     /* 344270 */ /*GILLT_v4s32*//*Label 6830*/ GIMT_Encode4(344727), GIMT_Encode4(0),
     /* 344278 */ /*GILLT_v8s16*//*Label 6831*/ GIMT_Encode4(344830),
     /* 344282 */ // Label 6824: @344282
     /* 344282 */ GIM_Try, /*On fail goto*//*Label 6833*/ GIMT_Encode4(344319), // Rule ID 614 //
     /* 344287 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344290 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344293 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344296 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344300 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344304 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 344308 */   // (fminimum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMINHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 344308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINHrr),
     /* 344313 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344317 */   GIR_RootConstrainSelectedInstOperands,
     /* 344318 */   // GIR_Coverage, 614,
     /* 344318 */   GIR_Done,
     /* 344319 */ // Label 6833: @344319
     /* 344319 */ GIM_Reject,
     /* 344320 */ // Label 6825: @344320
     /* 344320 */ GIM_Try, /*On fail goto*//*Label 6834*/ GIMT_Encode4(344357), // Rule ID 616 //
     /* 344325 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 344331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 344334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 344346 */   // (fminimum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMINSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 344346 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINSrr),
     /* 344351 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344355 */   GIR_RootConstrainSelectedInstOperands,
     /* 344356 */   // GIR_Coverage, 616,
     /* 344356 */   GIR_Done,
     /* 344357 */ // Label 6834: @344357
     /* 344357 */ GIM_Reject,
     /* 344358 */ // Label 6826: @344358
     /* 344358 */ GIM_Try, /*On fail goto*//*Label 6835*/ GIMT_Encode4(344417),
     /* 344363 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 344366 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 344369 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344373 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344377 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344381 */   GIM_Try, /*On fail goto*//*Label 6836*/ GIMT_Encode4(344400), // Rule ID 618 //
     /* 344386 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 344389 */     // (fminimum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMINDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 344389 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 344394 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344398 */     GIR_RootConstrainSelectedInstOperands,
     /* 344399 */     // GIR_Coverage, 618,
     /* 344399 */     GIR_Done,
     /* 344400 */   // Label 6836: @344400
     /* 344400 */   GIM_Try, /*On fail goto*//*Label 6837*/ GIMT_Encode4(344416), // Rule ID 4847 //
     /* 344405 */     // (fminimum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMINDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 344405 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINDrr),
     /* 344410 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344414 */     GIR_RootConstrainSelectedInstOperands,
     /* 344415 */     // GIR_Coverage, 4847,
     /* 344415 */     GIR_Done,
     /* 344416 */   // Label 6837: @344416
     /* 344416 */   GIM_Reject,
     /* 344417 */ // Label 6835: @344417
     /* 344417 */ GIM_Reject,
     /* 344418 */ // Label 6827: @344418
     /* 344418 */ GIM_Try, /*On fail goto*//*Label 6838*/ GIMT_Encode4(344520),
     /* 344423 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344426 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 344429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344433 */   GIM_Try, /*On fail goto*//*Label 6839*/ GIMT_Encode4(344492), // Rule ID 2366 //
     /* 344438 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344441 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344445 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344449 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344453 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344458 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344462 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344466 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 344470 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344475 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344477 */     // (fminimum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f32),
     /* 344480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344482 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344490 */     GIR_RootConstrainSelectedInstOperands,
     /* 344491 */     // GIR_Coverage, 2366,
     /* 344491 */     GIR_EraseRootFromParent_Done,
     /* 344492 */   // Label 6839: @344492
     /* 344492 */   GIM_Try, /*On fail goto*//*Label 6840*/ GIMT_Encode4(344519), // Rule ID 1288 //
     /* 344497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344500 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344504 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344508 */     // (fminimum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMINv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 344508 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f32),
     /* 344513 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344517 */     GIR_RootConstrainSelectedInstOperands,
     /* 344518 */     // GIR_Coverage, 1288,
     /* 344518 */     GIR_Done,
     /* 344519 */   // Label 6840: @344519
     /* 344519 */   GIM_Reject,
     /* 344520 */ // Label 6838: @344520
     /* 344520 */ GIM_Reject,
     /* 344521 */ // Label 6828: @344521
     /* 344521 */ GIM_Try, /*On fail goto*//*Label 6841*/ GIMT_Encode4(344623),
     /* 344526 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344529 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 344532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344536 */   GIM_Try, /*On fail goto*//*Label 6842*/ GIMT_Encode4(344595), // Rule ID 2372 //
     /* 344541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344544 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344548 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344552 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344556 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344569 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 344573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344578 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344580 */     // (fminimum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344580 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv2f64),
     /* 344583 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344585 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344593 */     GIR_RootConstrainSelectedInstOperands,
     /* 344594 */     // GIR_Coverage, 2372,
     /* 344594 */     GIR_EraseRootFromParent_Done,
     /* 344595 */   // Label 6842: @344595
     /* 344595 */   GIM_Try, /*On fail goto*//*Label 6843*/ GIMT_Encode4(344622), // Rule ID 1292 //
     /* 344600 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344603 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344611 */     // (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMINv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 344611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv2f64),
     /* 344616 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344620 */     GIR_RootConstrainSelectedInstOperands,
     /* 344621 */     // GIR_Coverage, 1292,
     /* 344621 */     GIR_Done,
     /* 344622 */   // Label 6843: @344622
     /* 344622 */   GIM_Reject,
     /* 344623 */ // Label 6841: @344623
     /* 344623 */ GIM_Reject,
     /* 344624 */ // Label 6829: @344624
     /* 344624 */ GIM_Try, /*On fail goto*//*Label 6844*/ GIMT_Encode4(344726),
     /* 344629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344632 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 344635 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344639 */   GIM_Try, /*On fail goto*//*Label 6845*/ GIMT_Encode4(344698), // Rule ID 2360 //
     /* 344644 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344647 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344651 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344655 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344659 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344672 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 344676 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344681 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344683 */     // (fminimum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344683 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f16),
     /* 344686 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344688 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344692 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344696 */     GIR_RootConstrainSelectedInstOperands,
     /* 344697 */     // GIR_Coverage, 2360,
     /* 344697 */     GIR_EraseRootFromParent_Done,
     /* 344698 */   // Label 6845: @344698
     /* 344698 */   GIM_Try, /*On fail goto*//*Label 6846*/ GIMT_Encode4(344725), // Rule ID 1284 //
     /* 344703 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344706 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344710 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 344714 */     // (fminimum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMINv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 344714 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f16),
     /* 344719 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344723 */     GIR_RootConstrainSelectedInstOperands,
     /* 344724 */     // GIR_Coverage, 1284,
     /* 344724 */     GIR_Done,
     /* 344725 */   // Label 6846: @344725
     /* 344725 */   GIM_Reject,
     /* 344726 */ // Label 6844: @344726
     /* 344726 */ GIM_Reject,
     /* 344727 */ // Label 6830: @344727
     /* 344727 */ GIM_Try, /*On fail goto*//*Label 6847*/ GIMT_Encode4(344829),
     /* 344732 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344735 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 344738 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344742 */   GIM_Try, /*On fail goto*//*Label 6848*/ GIMT_Encode4(344801), // Rule ID 2369 //
     /* 344747 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344750 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344754 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344758 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344762 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344767 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344771 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344775 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 344779 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344784 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344786 */     // (fminimum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv4f32),
     /* 344789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344791 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344795 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344799 */     GIR_RootConstrainSelectedInstOperands,
     /* 344800 */     // GIR_Coverage, 2369,
     /* 344800 */     GIR_EraseRootFromParent_Done,
     /* 344801 */   // Label 6848: @344801
     /* 344801 */   GIM_Try, /*On fail goto*//*Label 6849*/ GIMT_Encode4(344828), // Rule ID 1290 //
     /* 344806 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 344809 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344813 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344817 */     // (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMINv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 344817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv4f32),
     /* 344822 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344826 */     GIR_RootConstrainSelectedInstOperands,
     /* 344827 */     // GIR_Coverage, 1290,
     /* 344827 */     GIR_Done,
     /* 344828 */   // Label 6849: @344828
     /* 344828 */   GIM_Reject,
     /* 344829 */ // Label 6847: @344829
     /* 344829 */ GIM_Reject,
     /* 344830 */ // Label 6831: @344830
     /* 344830 */ GIM_Try, /*On fail goto*//*Label 6850*/ GIMT_Encode4(344932),
     /* 344835 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344838 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 344841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344845 */   GIM_Try, /*On fail goto*//*Label 6851*/ GIMT_Encode4(344904), // Rule ID 2363 //
     /* 344850 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 344853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 344857 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344861 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 344874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 344878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 344882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344887 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 344889 */     // (fminimum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344889 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMINv8f16),
     /* 344892 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 344894 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 344898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 344902 */     GIR_RootConstrainSelectedInstOperands,
     /* 344903 */     // GIR_Coverage, 2363,
     /* 344903 */     GIR_EraseRootFromParent_Done,
     /* 344904 */   // Label 6851: @344904
     /* 344904 */   GIM_Try, /*On fail goto*//*Label 6852*/ GIMT_Encode4(344931), // Rule ID 1286 //
     /* 344909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 344912 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344916 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 344920 */     // (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMINv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 344920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINv8f16),
     /* 344925 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 344929 */     GIR_RootConstrainSelectedInstOperands,
     /* 344930 */     // GIR_Coverage, 1286,
     /* 344930 */     GIR_Done,
     /* 344931 */   // Label 6852: @344931
     /* 344931 */   GIM_Reject,
     /* 344932 */ // Label 6850: @344932
     /* 344932 */ GIM_Reject,
     /* 344933 */ // Label 6832: @344933
     /* 344933 */ GIM_Reject,
     /* 344934 */ // Label 80: @344934
     /* 344934 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 6861*/ GIMT_Encode4(345636),
     /* 344945 */ /*GILLT_s16*//*Label 6853*/ GIMT_Encode4(344985),
     /* 344949 */ /*GILLT_s32*//*Label 6854*/ GIMT_Encode4(345023),
     /* 344953 */ /*GILLT_s64*//*Label 6855*/ GIMT_Encode4(345061), GIMT_Encode4(0),
     /* 344961 */ /*GILLT_v2s32*//*Label 6856*/ GIMT_Encode4(345121),
     /* 344965 */ /*GILLT_v2s64*//*Label 6857*/ GIMT_Encode4(345224),
     /* 344969 */ /*GILLT_v4s16*//*Label 6858*/ GIMT_Encode4(345327),
     /* 344973 */ /*GILLT_v4s32*//*Label 6859*/ GIMT_Encode4(345430), GIMT_Encode4(0),
     /* 344981 */ /*GILLT_v8s16*//*Label 6860*/ GIMT_Encode4(345533),
     /* 344985 */ // Label 6853: @344985
     /* 344985 */ GIM_Try, /*On fail goto*//*Label 6862*/ GIMT_Encode4(345022), // Rule ID 602 //
     /* 344990 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 344993 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 344996 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 344999 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345003 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345007 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 345011 */   // (fmaximum:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMAXHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 345011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXHrr),
     /* 345016 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345020 */   GIR_RootConstrainSelectedInstOperands,
     /* 345021 */   // GIR_Coverage, 602,
     /* 345021 */   GIR_Done,
     /* 345022 */ // Label 6862: @345022
     /* 345022 */ GIM_Reject,
     /* 345023 */ // Label 6854: @345023
     /* 345023 */ GIM_Try, /*On fail goto*//*Label 6863*/ GIMT_Encode4(345060), // Rule ID 604 //
     /* 345028 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345045 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 345049 */   // (fmaximum:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMAXSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 345049 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXSrr),
     /* 345054 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345058 */   GIR_RootConstrainSelectedInstOperands,
     /* 345059 */   // GIR_Coverage, 604,
     /* 345059 */   GIR_Done,
     /* 345060 */ // Label 6863: @345060
     /* 345060 */ GIM_Reject,
     /* 345061 */ // Label 6855: @345061
     /* 345061 */ GIM_Try, /*On fail goto*//*Label 6864*/ GIMT_Encode4(345120),
     /* 345066 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345069 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345072 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345076 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345080 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345084 */   GIM_Try, /*On fail goto*//*Label 6865*/ GIMT_Encode4(345103), // Rule ID 606 //
     /* 345089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 345092 */     // (fmaximum:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMAXDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 345092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345097 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345101 */     GIR_RootConstrainSelectedInstOperands,
     /* 345102 */     // GIR_Coverage, 606,
     /* 345102 */     GIR_Done,
     /* 345103 */   // Label 6865: @345103
     /* 345103 */   GIM_Try, /*On fail goto*//*Label 6866*/ GIMT_Encode4(345119), // Rule ID 4846 //
     /* 345108 */     // (fmaximum:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FMAXDrr:{ *:[v1f64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 345108 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXDrr),
     /* 345113 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345117 */     GIR_RootConstrainSelectedInstOperands,
     /* 345118 */     // GIR_Coverage, 4846,
     /* 345118 */     GIR_Done,
     /* 345119 */   // Label 6866: @345119
     /* 345119 */   GIM_Reject,
     /* 345120 */ // Label 6864: @345120
     /* 345120 */ GIM_Reject,
     /* 345121 */ // Label 6856: @345121
     /* 345121 */ GIM_Try, /*On fail goto*//*Label 6867*/ GIMT_Encode4(345223),
     /* 345126 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345129 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345132 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345136 */   GIM_Try, /*On fail goto*//*Label 6868*/ GIMT_Encode4(345195), // Rule ID 2351 //
     /* 345141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345148 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345152 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345156 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345161 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345165 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345169 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345173 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345180 */     // (fmaximum:{ *:[v2f32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FAMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f32),
     /* 345183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345189 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345193 */     GIR_RootConstrainSelectedInstOperands,
     /* 345194 */     // GIR_Coverage, 2351,
     /* 345194 */     GIR_EraseRootFromParent_Done,
     /* 345195 */   // Label 6868: @345195
     /* 345195 */   GIM_Try, /*On fail goto*//*Label 6869*/ GIMT_Encode4(345222), // Rule ID 1258 //
     /* 345200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345207 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345211 */     // (fmaximum:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMAXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 345211 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f32),
     /* 345216 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345220 */     GIR_RootConstrainSelectedInstOperands,
     /* 345221 */     // GIR_Coverage, 1258,
     /* 345221 */     GIR_Done,
     /* 345222 */   // Label 6869: @345222
     /* 345222 */   GIM_Reject,
     /* 345223 */ // Label 6867: @345223
     /* 345223 */ GIM_Reject,
     /* 345224 */ // Label 6857: @345224
     /* 345224 */ GIM_Try, /*On fail goto*//*Label 6870*/ GIMT_Encode4(345326),
     /* 345229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345232 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 345235 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345239 */   GIM_Try, /*On fail goto*//*Label 6871*/ GIMT_Encode4(345298), // Rule ID 2357 //
     /* 345244 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345247 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345251 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345255 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345259 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345264 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345268 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345272 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 345276 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345281 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345283 */     // (fmaximum:{ *:[v2f64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FAMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345283 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv2f64),
     /* 345286 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345288 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345292 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345296 */     GIR_RootConstrainSelectedInstOperands,
     /* 345297 */     // GIR_Coverage, 2357,
     /* 345297 */     GIR_EraseRootFromParent_Done,
     /* 345298 */   // Label 6871: @345298
     /* 345298 */   GIM_Try, /*On fail goto*//*Label 6872*/ GIMT_Encode4(345325), // Rule ID 1262 //
     /* 345303 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345306 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345310 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345314 */     // (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMAXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 345314 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv2f64),
     /* 345319 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345323 */     GIR_RootConstrainSelectedInstOperands,
     /* 345324 */     // GIR_Coverage, 1262,
     /* 345324 */     GIR_Done,
     /* 345325 */   // Label 6872: @345325
     /* 345325 */   GIM_Reject,
     /* 345326 */ // Label 6870: @345326
     /* 345326 */ GIM_Reject,
     /* 345327 */ // Label 6858: @345327
     /* 345327 */ GIM_Try, /*On fail goto*//*Label 6873*/ GIMT_Encode4(345429),
     /* 345332 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345335 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345338 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345342 */   GIM_Try, /*On fail goto*//*Label 6874*/ GIMT_Encode4(345401), // Rule ID 2345 //
     /* 345347 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345350 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345354 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345358 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345362 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345367 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345371 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345375 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345379 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345386 */     // (fmaximum:{ *:[v4f16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FAMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f16),
     /* 345389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345391 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345399 */     GIR_RootConstrainSelectedInstOperands,
     /* 345400 */     // GIR_Coverage, 2345,
     /* 345400 */     GIR_EraseRootFromParent_Done,
     /* 345401 */   // Label 6874: @345401
     /* 345401 */   GIM_Try, /*On fail goto*//*Label 6875*/ GIMT_Encode4(345428), // Rule ID 1254 //
     /* 345406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345417 */     // (fmaximum:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMAXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 345417 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f16),
     /* 345422 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345426 */     GIR_RootConstrainSelectedInstOperands,
     /* 345427 */     // GIR_Coverage, 1254,
     /* 345427 */     GIR_Done,
     /* 345428 */   // Label 6875: @345428
     /* 345428 */   GIM_Reject,
     /* 345429 */ // Label 6873: @345429
     /* 345429 */ GIM_Reject,
     /* 345430 */ // Label 6859: @345430
     /* 345430 */ GIM_Try, /*On fail goto*//*Label 6876*/ GIMT_Encode4(345532),
     /* 345435 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345438 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345445 */   GIM_Try, /*On fail goto*//*Label 6877*/ GIMT_Encode4(345504), // Rule ID 2354 //
     /* 345450 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345453 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345457 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345461 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345482 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345487 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345489 */     // (fmaximum:{ *:[v4f32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FAMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv4f32),
     /* 345492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345494 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345498 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345502 */     GIR_RootConstrainSelectedInstOperands,
     /* 345503 */     // GIR_Coverage, 2354,
     /* 345503 */     GIR_EraseRootFromParent_Done,
     /* 345504 */   // Label 6877: @345504
     /* 345504 */   GIM_Try, /*On fail goto*//*Label 6878*/ GIMT_Encode4(345531), // Rule ID 1260 //
     /* 345509 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345516 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345520 */     // (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMAXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 345520 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv4f32),
     /* 345525 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345529 */     GIR_RootConstrainSelectedInstOperands,
     /* 345530 */     // GIR_Coverage, 1260,
     /* 345530 */     GIR_Done,
     /* 345531 */   // Label 6878: @345531
     /* 345531 */   GIM_Reject,
     /* 345532 */ // Label 6876: @345532
     /* 345532 */ GIM_Reject,
     /* 345533 */ // Label 6860: @345533
     /* 345533 */ GIM_Try, /*On fail goto*//*Label 6879*/ GIMT_Encode4(345635),
     /* 345538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345541 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345548 */   GIM_Try, /*On fail goto*//*Label 6880*/ GIMT_Encode4(345607), // Rule ID 2348 //
     /* 345553 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFAMINMAX_HasNEON),
     /* 345556 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 345560 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345564 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345568 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345573 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 345577 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 345581 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345590 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 345592 */     // (fmaximum:{ *:[v8f16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FAMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345592 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FAMAXv8f16),
     /* 345595 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345597 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 345601 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 345605 */     GIR_RootConstrainSelectedInstOperands,
     /* 345606 */     // GIR_Coverage, 2348,
     /* 345606 */     GIR_EraseRootFromParent_Done,
     /* 345607 */   // Label 6880: @345607
     /* 345607 */   GIM_Try, /*On fail goto*//*Label 6881*/ GIMT_Encode4(345634), // Rule ID 1256 //
     /* 345612 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 345615 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345619 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345623 */     // (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMAXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 345623 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXv8f16),
     /* 345628 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 345632 */     GIR_RootConstrainSelectedInstOperands,
     /* 345633 */     // GIR_Coverage, 1256,
     /* 345633 */     GIR_Done,
     /* 345634 */   // Label 6881: @345634
     /* 345634 */   GIM_Reject,
     /* 345635 */ // Label 6879: @345635
     /* 345635 */ GIM_Reject,
     /* 345636 */ // Label 6861: @345636
     /* 345636 */ GIM_Reject,
     /* 345637 */ // Label 81: @345637
     /* 345637 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6890*/ GIMT_Encode4(346040),
     /* 345648 */ /*GILLT_s32*//*Label 6882*/ GIMT_Encode4(345688),
     /* 345652 */ /*GILLT_s64*//*Label 6883*/ GIMT_Encode4(345762), GIMT_Encode4(0),
     /* 345660 */ /*GILLT_v2s32*//*Label 6884*/ GIMT_Encode4(345836), GIMT_Encode4(0),
     /* 345668 */ /*GILLT_v4s16*//*Label 6885*/ GIMT_Encode4(345870),
     /* 345672 */ /*GILLT_v4s32*//*Label 6886*/ GIMT_Encode4(345904),
     /* 345676 */ /*GILLT_v8s8*//*Label 6887*/ GIMT_Encode4(345938),
     /* 345680 */ /*GILLT_v8s16*//*Label 6888*/ GIMT_Encode4(345972),
     /* 345684 */ /*GILLT_v16s8*//*Label 6889*/ GIMT_Encode4(346006),
     /* 345688 */ // Label 6882: @345688
     /* 345688 */ GIM_Try, /*On fail goto*//*Label 6891*/ GIMT_Encode4(345761),
     /* 345693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 345696 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 345699 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345703 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345707 */   GIM_Try, /*On fail goto*//*Label 6892*/ GIMT_Encode4(345741), // Rule ID 2328 //
     /* 345712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345715 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345719 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345723 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 345727 */     // MIs[1] Operand 1
     /* 345727 */     // No operand predicates
     /* 345727 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345729 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 345729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINWri),
     /* 345732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345734 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345736 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345739 */     GIR_RootConstrainSelectedInstOperands,
     /* 345740 */     // GIR_Coverage, 2328,
     /* 345740 */     GIR_EraseRootFromParent_Done,
     /* 345741 */   // Label 6892: @345741
     /* 345741 */   GIM_Try, /*On fail goto*//*Label 6893*/ GIMT_Encode4(345760), // Rule ID 2327 //
     /* 345746 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345749 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 345753 */     // (smin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 345753 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINWrr),
     /* 345758 */     GIR_RootConstrainSelectedInstOperands,
     /* 345759 */     // GIR_Coverage, 2327,
     /* 345759 */     GIR_Done,
     /* 345760 */   // Label 6893: @345760
     /* 345760 */   GIM_Reject,
     /* 345761 */ // Label 6891: @345761
     /* 345761 */ GIM_Reject,
     /* 345762 */ // Label 6883: @345762
     /* 345762 */ GIM_Try, /*On fail goto*//*Label 6894*/ GIMT_Encode4(345835),
     /* 345767 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 345770 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 345773 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345777 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345781 */   GIM_Try, /*On fail goto*//*Label 6895*/ GIMT_Encode4(345815), // Rule ID 2330 //
     /* 345786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 345793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 345797 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 345801 */     // MIs[1] Operand 1
     /* 345801 */     // No operand predicates
     /* 345801 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 345803 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 345803 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMINXri),
     /* 345806 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 345808 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 345810 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 345813 */     GIR_RootConstrainSelectedInstOperands,
     /* 345814 */     // GIR_Coverage, 2330,
     /* 345814 */     GIR_EraseRootFromParent_Done,
     /* 345815 */   // Label 6895: @345815
     /* 345815 */   GIM_Try, /*On fail goto*//*Label 6896*/ GIMT_Encode4(345834), // Rule ID 2329 //
     /* 345820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 345823 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 345827 */     // (smin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 345827 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINXrr),
     /* 345832 */     GIR_RootConstrainSelectedInstOperands,
     /* 345833 */     // GIR_Coverage, 2329,
     /* 345833 */     GIR_Done,
     /* 345834 */   // Label 6896: @345834
     /* 345834 */   GIM_Reject,
     /* 345835 */ // Label 6894: @345835
     /* 345835 */ GIM_Reject,
     /* 345836 */ // Label 6884: @345836
     /* 345836 */ GIM_Try, /*On fail goto*//*Label 6897*/ GIMT_Encode4(345869), // Rule ID 1414 //
     /* 345841 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 345847 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 345850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345858 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345862 */   // (smin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 345862 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv2i32),
     /* 345867 */   GIR_RootConstrainSelectedInstOperands,
     /* 345868 */   // GIR_Coverage, 1414,
     /* 345868 */   GIR_Done,
     /* 345869 */ // Label 6897: @345869
     /* 345869 */ GIM_Reject,
     /* 345870 */ // Label 6885: @345870
     /* 345870 */ GIM_Try, /*On fail goto*//*Label 6898*/ GIMT_Encode4(345903), // Rule ID 1412 //
     /* 345875 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345878 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 345881 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 345884 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345888 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345892 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345896 */   // (smin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 345896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i16),
     /* 345901 */   GIR_RootConstrainSelectedInstOperands,
     /* 345902 */   // GIR_Coverage, 1412,
     /* 345902 */   GIR_Done,
     /* 345903 */ // Label 6898: @345903
     /* 345903 */ GIM_Reject,
     /* 345904 */ // Label 6886: @345904
     /* 345904 */ GIM_Try, /*On fail goto*//*Label 6899*/ GIMT_Encode4(345937), // Rule ID 1415 //
     /* 345909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 345915 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 345918 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345922 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345926 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345930 */   // (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 345930 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv4i32),
     /* 345935 */   GIR_RootConstrainSelectedInstOperands,
     /* 345936 */   // GIR_Coverage, 1415,
     /* 345936 */   GIR_Done,
     /* 345937 */ // Label 6899: @345937
     /* 345937 */ GIM_Reject,
     /* 345938 */ // Label 6887: @345938
     /* 345938 */ GIM_Try, /*On fail goto*//*Label 6900*/ GIMT_Encode4(345971), // Rule ID 1410 //
     /* 345943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 345949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 345952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345956 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345960 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 345964 */   // (smin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 345964 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i8),
     /* 345969 */   GIR_RootConstrainSelectedInstOperands,
     /* 345970 */   // GIR_Coverage, 1410,
     /* 345970 */   GIR_Done,
     /* 345971 */ // Label 6900: @345971
     /* 345971 */ GIM_Reject,
     /* 345972 */ // Label 6888: @345972
     /* 345972 */ GIM_Try, /*On fail goto*//*Label 6901*/ GIMT_Encode4(346005), // Rule ID 1413 //
     /* 345977 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 345980 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 345983 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 345986 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345990 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345994 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 345998 */   // (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 345998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv8i16),
     /* 346003 */   GIR_RootConstrainSelectedInstOperands,
     /* 346004 */   // GIR_Coverage, 1413,
     /* 346004 */   GIR_Done,
     /* 346005 */ // Label 6901: @346005
     /* 346005 */ GIM_Reject,
     /* 346006 */ // Label 6889: @346006
     /* 346006 */ GIM_Try, /*On fail goto*//*Label 6902*/ GIMT_Encode4(346039), // Rule ID 1411 //
     /* 346011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346017 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346032 */   // (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346032 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINv16i8),
     /* 346037 */   GIR_RootConstrainSelectedInstOperands,
     /* 346038 */   // GIR_Coverage, 1411,
     /* 346038 */   GIR_Done,
     /* 346039 */ // Label 6902: @346039
     /* 346039 */ GIM_Reject,
     /* 346040 */ // Label 6890: @346040
     /* 346040 */ GIM_Reject,
     /* 346041 */ // Label 82: @346041
     /* 346041 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6911*/ GIMT_Encode4(346444),
     /* 346052 */ /*GILLT_s32*//*Label 6903*/ GIMT_Encode4(346092),
     /* 346056 */ /*GILLT_s64*//*Label 6904*/ GIMT_Encode4(346166), GIMT_Encode4(0),
     /* 346064 */ /*GILLT_v2s32*//*Label 6905*/ GIMT_Encode4(346240), GIMT_Encode4(0),
     /* 346072 */ /*GILLT_v4s16*//*Label 6906*/ GIMT_Encode4(346274),
     /* 346076 */ /*GILLT_v4s32*//*Label 6907*/ GIMT_Encode4(346308),
     /* 346080 */ /*GILLT_v8s8*//*Label 6908*/ GIMT_Encode4(346342),
     /* 346084 */ /*GILLT_v8s16*//*Label 6909*/ GIMT_Encode4(346376),
     /* 346088 */ /*GILLT_v16s8*//*Label 6910*/ GIMT_Encode4(346410),
     /* 346092 */ // Label 6903: @346092
     /* 346092 */ GIM_Try, /*On fail goto*//*Label 6912*/ GIMT_Encode4(346165),
     /* 346097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346103 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346107 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346111 */   GIM_Try, /*On fail goto*//*Label 6913*/ GIMT_Encode4(346145), // Rule ID 2324 //
     /* 346116 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346127 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_32b),
     /* 346131 */     // MIs[1] Operand 1
     /* 346131 */     // No operand predicates
     /* 346131 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346133 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_simm8_32b>>:$imm)  =>  (SMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346133 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXWri),
     /* 346136 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346138 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346140 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346143 */     GIR_RootConstrainSelectedInstOperands,
     /* 346144 */     // GIR_Coverage, 2324,
     /* 346144 */     GIR_EraseRootFromParent_Done,
     /* 346145 */   // Label 6913: @346145
     /* 346145 */   GIM_Try, /*On fail goto*//*Label 6914*/ GIMT_Encode4(346164), // Rule ID 2323 //
     /* 346150 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346153 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346157 */     // (smax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (SMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346157 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXWrr),
     /* 346162 */     GIR_RootConstrainSelectedInstOperands,
     /* 346163 */     // GIR_Coverage, 2323,
     /* 346163 */     GIR_Done,
     /* 346164 */   // Label 6914: @346164
     /* 346164 */   GIM_Reject,
     /* 346165 */ // Label 6912: @346165
     /* 346165 */ GIM_Reject,
     /* 346166 */ // Label 6904: @346166
     /* 346166 */ GIM_Try, /*On fail goto*//*Label 6915*/ GIMT_Encode4(346239),
     /* 346171 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346174 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346177 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346181 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346185 */   GIM_Try, /*On fail goto*//*Label 6916*/ GIMT_Encode4(346219), // Rule ID 2326 //
     /* 346190 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346193 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346197 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346201 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_simm8_64b),
     /* 346205 */     // MIs[1] Operand 1
     /* 346205 */     // No operand predicates
     /* 346205 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346207 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm8_64b>>:$imm)  =>  (SMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346207 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMAXXri),
     /* 346210 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346212 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346214 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346217 */     GIR_RootConstrainSelectedInstOperands,
     /* 346218 */     // GIR_Coverage, 2326,
     /* 346218 */     GIR_EraseRootFromParent_Done,
     /* 346219 */   // Label 6916: @346219
     /* 346219 */   GIM_Try, /*On fail goto*//*Label 6917*/ GIMT_Encode4(346238), // Rule ID 2325 //
     /* 346224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346227 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346231 */     // (smax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (SMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346231 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXXrr),
     /* 346236 */     GIR_RootConstrainSelectedInstOperands,
     /* 346237 */     // GIR_Coverage, 2325,
     /* 346237 */     GIR_Done,
     /* 346238 */   // Label 6917: @346238
     /* 346238 */   GIM_Reject,
     /* 346239 */ // Label 6915: @346239
     /* 346239 */ GIM_Reject,
     /* 346240 */ // Label 6905: @346240
     /* 346240 */ GIM_Try, /*On fail goto*//*Label 6918*/ GIMT_Encode4(346273), // Rule ID 1402 //
     /* 346245 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346248 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346251 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346254 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346258 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346262 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346266 */   // (smax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346266 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv2i32),
     /* 346271 */   GIR_RootConstrainSelectedInstOperands,
     /* 346272 */   // GIR_Coverage, 1402,
     /* 346272 */   GIR_Done,
     /* 346273 */ // Label 6918: @346273
     /* 346273 */ GIM_Reject,
     /* 346274 */ // Label 6906: @346274
     /* 346274 */ GIM_Try, /*On fail goto*//*Label 6919*/ GIMT_Encode4(346307), // Rule ID 1400 //
     /* 346279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346300 */   // (smax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i16),
     /* 346305 */   GIR_RootConstrainSelectedInstOperands,
     /* 346306 */   // GIR_Coverage, 1400,
     /* 346306 */   GIR_Done,
     /* 346307 */ // Label 6919: @346307
     /* 346307 */ GIM_Reject,
     /* 346308 */ // Label 6907: @346308
     /* 346308 */ GIM_Try, /*On fail goto*//*Label 6920*/ GIMT_Encode4(346341), // Rule ID 1403 //
     /* 346313 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346316 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346319 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346326 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346330 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346334 */   // (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (SMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346334 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv4i32),
     /* 346339 */   GIR_RootConstrainSelectedInstOperands,
     /* 346340 */   // GIR_Coverage, 1403,
     /* 346340 */   GIR_Done,
     /* 346341 */ // Label 6920: @346341
     /* 346341 */ GIM_Reject,
     /* 346342 */ // Label 6908: @346342
     /* 346342 */ GIM_Try, /*On fail goto*//*Label 6921*/ GIMT_Encode4(346375), // Rule ID 1398 //
     /* 346347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346368 */   // (smax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i8),
     /* 346373 */   GIR_RootConstrainSelectedInstOperands,
     /* 346374 */   // GIR_Coverage, 1398,
     /* 346374 */   GIR_Done,
     /* 346375 */ // Label 6921: @346375
     /* 346375 */ GIM_Reject,
     /* 346376 */ // Label 6909: @346376
     /* 346376 */ GIM_Try, /*On fail goto*//*Label 6922*/ GIMT_Encode4(346409), // Rule ID 1401 //
     /* 346381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346387 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346398 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346402 */   // (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (SMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346402 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv8i16),
     /* 346407 */   GIR_RootConstrainSelectedInstOperands,
     /* 346408 */   // GIR_Coverage, 1401,
     /* 346408 */   GIR_Done,
     /* 346409 */ // Label 6922: @346409
     /* 346409 */ GIM_Reject,
     /* 346410 */ // Label 6910: @346410
     /* 346410 */ GIM_Try, /*On fail goto*//*Label 6923*/ GIMT_Encode4(346443), // Rule ID 1399 //
     /* 346415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346421 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346424 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346428 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346432 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346436 */   // (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXv16i8),
     /* 346441 */   GIR_RootConstrainSelectedInstOperands,
     /* 346442 */   // GIR_Coverage, 1399,
     /* 346442 */   GIR_Done,
     /* 346443 */ // Label 6923: @346443
     /* 346443 */ GIM_Reject,
     /* 346444 */ // Label 6911: @346444
     /* 346444 */ GIM_Reject,
     /* 346445 */ // Label 83: @346445
     /* 346445 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6932*/ GIMT_Encode4(346848),
     /* 346456 */ /*GILLT_s32*//*Label 6924*/ GIMT_Encode4(346496),
     /* 346460 */ /*GILLT_s64*//*Label 6925*/ GIMT_Encode4(346570), GIMT_Encode4(0),
     /* 346468 */ /*GILLT_v2s32*//*Label 6926*/ GIMT_Encode4(346644), GIMT_Encode4(0),
     /* 346476 */ /*GILLT_v4s16*//*Label 6927*/ GIMT_Encode4(346678),
     /* 346480 */ /*GILLT_v4s32*//*Label 6928*/ GIMT_Encode4(346712),
     /* 346484 */ /*GILLT_v8s8*//*Label 6929*/ GIMT_Encode4(346746),
     /* 346488 */ /*GILLT_v8s16*//*Label 6930*/ GIMT_Encode4(346780),
     /* 346492 */ /*GILLT_v16s8*//*Label 6931*/ GIMT_Encode4(346814),
     /* 346496 */ // Label 6924: @346496
     /* 346496 */ GIM_Try, /*On fail goto*//*Label 6933*/ GIMT_Encode4(346569),
     /* 346501 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346504 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346515 */   GIM_Try, /*On fail goto*//*Label 6934*/ GIMT_Encode4(346549), // Rule ID 2336 //
     /* 346520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346531 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 346535 */     // MIs[1] Operand 1
     /* 346535 */     // No operand predicates
     /* 346535 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346537 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMINWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINWri),
     /* 346540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346547 */     GIR_RootConstrainSelectedInstOperands,
     /* 346548 */     // GIR_Coverage, 2336,
     /* 346548 */     GIR_EraseRootFromParent_Done,
     /* 346549 */   // Label 6934: @346549
     /* 346549 */   GIM_Try, /*On fail goto*//*Label 6935*/ GIMT_Encode4(346568), // Rule ID 2335 //
     /* 346554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346557 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346561 */     // (umin:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMINWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINWrr),
     /* 346566 */     GIR_RootConstrainSelectedInstOperands,
     /* 346567 */     // GIR_Coverage, 2335,
     /* 346567 */     GIR_Done,
     /* 346568 */   // Label 6935: @346568
     /* 346568 */   GIM_Reject,
     /* 346569 */ // Label 6933: @346569
     /* 346569 */ GIM_Reject,
     /* 346570 */ // Label 6925: @346570
     /* 346570 */ GIM_Try, /*On fail goto*//*Label 6936*/ GIMT_Encode4(346643),
     /* 346575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346578 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346581 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346585 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346589 */   GIM_Try, /*On fail goto*//*Label 6937*/ GIMT_Encode4(346623), // Rule ID 2338 //
     /* 346594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346605 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 346609 */     // MIs[1] Operand 1
     /* 346609 */     // No operand predicates
     /* 346609 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346611 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMINXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 346611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMINXri),
     /* 346614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346618 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346621 */     GIR_RootConstrainSelectedInstOperands,
     /* 346622 */     // GIR_Coverage, 2338,
     /* 346622 */     GIR_EraseRootFromParent_Done,
     /* 346623 */   // Label 6937: @346623
     /* 346623 */   GIM_Try, /*On fail goto*//*Label 6938*/ GIMT_Encode4(346642), // Rule ID 2337 //
     /* 346628 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346631 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346635 */     // (umin:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMINXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 346635 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINXrr),
     /* 346640 */     GIR_RootConstrainSelectedInstOperands,
     /* 346641 */     // GIR_Coverage, 2337,
     /* 346641 */     GIR_Done,
     /* 346642 */   // Label 6938: @346642
     /* 346642 */   GIM_Reject,
     /* 346643 */ // Label 6936: @346643
     /* 346643 */ GIM_Reject,
     /* 346644 */ // Label 6926: @346644
     /* 346644 */ GIM_Try, /*On fail goto*//*Label 6939*/ GIMT_Encode4(346677), // Rule ID 1537 //
     /* 346649 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 346655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 346658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346662 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346670 */   // (umin:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMINv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 346670 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv2i32),
     /* 346675 */   GIR_RootConstrainSelectedInstOperands,
     /* 346676 */   // GIR_Coverage, 1537,
     /* 346676 */   GIR_Done,
     /* 346677 */ // Label 6939: @346677
     /* 346677 */ GIM_Reject,
     /* 346678 */ // Label 6927: @346678
     /* 346678 */ GIM_Try, /*On fail goto*//*Label 6940*/ GIMT_Encode4(346711), // Rule ID 1535 //
     /* 346683 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346686 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 346689 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 346692 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346696 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346700 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346704 */   // (umin:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMINv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 346704 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i16),
     /* 346709 */   GIR_RootConstrainSelectedInstOperands,
     /* 346710 */   // GIR_Coverage, 1535,
     /* 346710 */   GIR_Done,
     /* 346711 */ // Label 6940: @346711
     /* 346711 */ GIM_Reject,
     /* 346712 */ // Label 6928: @346712
     /* 346712 */ GIM_Try, /*On fail goto*//*Label 6941*/ GIMT_Encode4(346745), // Rule ID 1538 //
     /* 346717 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346720 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 346723 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 346726 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346730 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346734 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346738 */   // (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMINv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 346738 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv4i32),
     /* 346743 */   GIR_RootConstrainSelectedInstOperands,
     /* 346744 */   // GIR_Coverage, 1538,
     /* 346744 */   GIR_Done,
     /* 346745 */ // Label 6941: @346745
     /* 346745 */ GIM_Reject,
     /* 346746 */ // Label 6929: @346746
     /* 346746 */ GIM_Try, /*On fail goto*//*Label 6942*/ GIMT_Encode4(346779), // Rule ID 1533 //
     /* 346751 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346754 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 346757 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 346760 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346764 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346768 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 346772 */   // (umin:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMINv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 346772 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i8),
     /* 346777 */   GIR_RootConstrainSelectedInstOperands,
     /* 346778 */   // GIR_Coverage, 1533,
     /* 346778 */   GIR_Done,
     /* 346779 */ // Label 6942: @346779
     /* 346779 */ GIM_Reject,
     /* 346780 */ // Label 6930: @346780
     /* 346780 */ GIM_Try, /*On fail goto*//*Label 6943*/ GIMT_Encode4(346813), // Rule ID 1536 //
     /* 346785 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 346791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 346794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346806 */   // (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMINv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 346806 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv8i16),
     /* 346811 */   GIR_RootConstrainSelectedInstOperands,
     /* 346812 */   // GIR_Coverage, 1536,
     /* 346812 */   GIR_Done,
     /* 346813 */ // Label 6943: @346813
     /* 346813 */ GIM_Reject,
     /* 346814 */ // Label 6931: @346814
     /* 346814 */ GIM_Try, /*On fail goto*//*Label 6944*/ GIMT_Encode4(346847), // Rule ID 1534 //
     /* 346819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 346822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 346825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 346828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 346840 */   // (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMINv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 346840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINv16i8),
     /* 346845 */   GIR_RootConstrainSelectedInstOperands,
     /* 346846 */   // GIR_Coverage, 1534,
     /* 346846 */   GIR_Done,
     /* 346847 */ // Label 6944: @346847
     /* 346847 */ GIM_Reject,
     /* 346848 */ // Label 6932: @346848
     /* 346848 */ GIM_Reject,
     /* 346849 */ // Label 84: @346849
     /* 346849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6953*/ GIMT_Encode4(347252),
     /* 346860 */ /*GILLT_s32*//*Label 6945*/ GIMT_Encode4(346900),
     /* 346864 */ /*GILLT_s64*//*Label 6946*/ GIMT_Encode4(346974), GIMT_Encode4(0),
     /* 346872 */ /*GILLT_v2s32*//*Label 6947*/ GIMT_Encode4(347048), GIMT_Encode4(0),
     /* 346880 */ /*GILLT_v4s16*//*Label 6948*/ GIMT_Encode4(347082),
     /* 346884 */ /*GILLT_v4s32*//*Label 6949*/ GIMT_Encode4(347116),
     /* 346888 */ /*GILLT_v8s8*//*Label 6950*/ GIMT_Encode4(347150),
     /* 346892 */ /*GILLT_v8s16*//*Label 6951*/ GIMT_Encode4(347184),
     /* 346896 */ /*GILLT_v16s8*//*Label 6952*/ GIMT_Encode4(347218),
     /* 346900 */ // Label 6945: @346900
     /* 346900 */ GIM_Try, /*On fail goto*//*Label 6954*/ GIMT_Encode4(346973),
     /* 346905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 346908 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 346911 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346915 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346919 */   GIM_Try, /*On fail goto*//*Label 6955*/ GIMT_Encode4(346953), // Rule ID 2332 //
     /* 346924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346927 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 346931 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 346935 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_32b),
     /* 346939 */     // MIs[1] Operand 1
     /* 346939 */     // No operand predicates
     /* 346939 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 346941 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_uimm8_32b>>:$imm)  =>  (UMAXWri:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 346941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXWri),
     /* 346944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 346946 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 346948 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 346951 */     GIR_RootConstrainSelectedInstOperands,
     /* 346952 */     // GIR_Coverage, 2332,
     /* 346952 */     GIR_EraseRootFromParent_Done,
     /* 346953 */   // Label 6955: @346953
     /* 346953 */   GIM_Try, /*On fail goto*//*Label 6956*/ GIMT_Encode4(346972), // Rule ID 2331 //
     /* 346958 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 346961 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 346965 */     // (umax:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)  =>  (UMAXWrr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, GPR32:{ *:[i32] }:$Rm)
     /* 346965 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXWrr),
     /* 346970 */     GIR_RootConstrainSelectedInstOperands,
     /* 346971 */     // GIR_Coverage, 2331,
     /* 346971 */     GIR_Done,
     /* 346972 */   // Label 6956: @346972
     /* 346972 */   GIM_Reject,
     /* 346973 */ // Label 6954: @346973
     /* 346973 */ GIM_Reject,
     /* 346974 */ // Label 6946: @346974
     /* 346974 */ GIM_Try, /*On fail goto*//*Label 6957*/ GIMT_Encode4(347047),
     /* 346979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 346982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 346985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 346993 */   GIM_Try, /*On fail goto*//*Label 6958*/ GIMT_Encode4(347027), // Rule ID 2334 //
     /* 346998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 347005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 347009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_uimm8_64b),
     /* 347013 */     // MIs[1] Operand 1
     /* 347013 */     // No operand predicates
     /* 347013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 347015 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_uimm8_64b>>:$imm)  =>  (UMAXXri:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$imm)
     /* 347015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMAXXri),
     /* 347018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 347022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 347025 */     GIR_RootConstrainSelectedInstOperands,
     /* 347026 */     // GIR_Coverage, 2334,
     /* 347026 */     GIR_EraseRootFromParent_Done,
     /* 347027 */   // Label 6958: @347027
     /* 347027 */   GIM_Try, /*On fail goto*//*Label 6959*/ GIMT_Encode4(347046), // Rule ID 2333 //
     /* 347032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347035 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347039 */     // (umax:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)  =>  (UMAXXrr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm)
     /* 347039 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXXrr),
     /* 347044 */     GIR_RootConstrainSelectedInstOperands,
     /* 347045 */     // GIR_Coverage, 2333,
     /* 347045 */     GIR_Done,
     /* 347046 */   // Label 6959: @347046
     /* 347046 */   GIM_Reject,
     /* 347047 */ // Label 6957: @347047
     /* 347047 */ GIM_Reject,
     /* 347048 */ // Label 6947: @347048
     /* 347048 */ GIM_Try, /*On fail goto*//*Label 6960*/ GIMT_Encode4(347081), // Rule ID 1525 //
     /* 347053 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347056 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347059 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 347062 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347066 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347070 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347074 */   // (umax:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMAXv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 347074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv2i32),
     /* 347079 */   GIR_RootConstrainSelectedInstOperands,
     /* 347080 */   // GIR_Coverage, 1525,
     /* 347080 */   GIR_Done,
     /* 347081 */ // Label 6960: @347081
     /* 347081 */ GIM_Reject,
     /* 347082 */ // Label 6948: @347082
     /* 347082 */ GIM_Try, /*On fail goto*//*Label 6961*/ GIMT_Encode4(347115), // Rule ID 1523 //
     /* 347087 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347090 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347093 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 347096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347108 */   // (umax:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMAXv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 347108 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i16),
     /* 347113 */   GIR_RootConstrainSelectedInstOperands,
     /* 347114 */   // GIR_Coverage, 1523,
     /* 347114 */   GIR_Done,
     /* 347115 */ // Label 6961: @347115
     /* 347115 */ GIM_Reject,
     /* 347116 */ // Label 6949: @347116
     /* 347116 */ GIM_Try, /*On fail goto*//*Label 6962*/ GIMT_Encode4(347149), // Rule ID 1526 //
     /* 347121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347134 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347138 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347142 */   // (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UMAXv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 347142 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv4i32),
     /* 347147 */   GIR_RootConstrainSelectedInstOperands,
     /* 347148 */   // GIR_Coverage, 1526,
     /* 347148 */   GIR_Done,
     /* 347149 */ // Label 6962: @347149
     /* 347149 */ GIM_Reject,
     /* 347150 */ // Label 6950: @347150
     /* 347150 */ GIM_Try, /*On fail goto*//*Label 6963*/ GIMT_Encode4(347183), // Rule ID 1521 //
     /* 347155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347161 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 347164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347172 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347176 */   // (umax:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMAXv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 347176 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i8),
     /* 347181 */   GIR_RootConstrainSelectedInstOperands,
     /* 347182 */   // GIR_Coverage, 1521,
     /* 347182 */   GIR_Done,
     /* 347183 */ // Label 6963: @347183
     /* 347183 */ GIM_Reject,
     /* 347184 */ // Label 6951: @347184
     /* 347184 */ GIM_Try, /*On fail goto*//*Label 6964*/ GIMT_Encode4(347217), // Rule ID 1524 //
     /* 347189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347202 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347206 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347210 */   // (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UMAXv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 347210 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv8i16),
     /* 347215 */   GIR_RootConstrainSelectedInstOperands,
     /* 347216 */   // GIR_Coverage, 1524,
     /* 347216 */   GIR_Done,
     /* 347217 */ // Label 6964: @347217
     /* 347217 */ GIM_Reject,
     /* 347218 */ // Label 6952: @347218
     /* 347218 */ GIM_Try, /*On fail goto*//*Label 6965*/ GIMT_Encode4(347251), // Rule ID 1522 //
     /* 347223 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 347229 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 347232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347240 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347244 */   // (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UMAXv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 347244 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXv16i8),
     /* 347249 */   GIR_RootConstrainSelectedInstOperands,
     /* 347250 */   // GIR_Coverage, 1522,
     /* 347250 */   GIR_Done,
     /* 347251 */ // Label 6965: @347251
     /* 347251 */ GIM_Reject,
     /* 347252 */ // Label 6953: @347252
     /* 347252 */ GIM_Reject,
     /* 347253 */ // Label 85: @347253
     /* 347253 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 6975*/ GIMT_Encode4(348067),
     /* 347264 */ /*GILLT_s32*//*Label 6966*/ GIMT_Encode4(347304),
     /* 347268 */ /*GILLT_s64*//*Label 6967*/ GIMT_Encode4(347331), GIMT_Encode4(0),
     /* 347276 */ /*GILLT_v2s32*//*Label 6968*/ GIMT_Encode4(347410),
     /* 347280 */ /*GILLT_v2s64*//*Label 6969*/ GIMT_Encode4(347437),
     /* 347284 */ /*GILLT_v4s16*//*Label 6970*/ GIMT_Encode4(347620),
     /* 347288 */ /*GILLT_v4s32*//*Label 6971*/ GIMT_Encode4(347647),
     /* 347292 */ /*GILLT_v8s8*//*Label 6972*/ GIMT_Encode4(347830),
     /* 347296 */ /*GILLT_v8s16*//*Label 6973*/ GIMT_Encode4(347857),
     /* 347300 */ /*GILLT_v16s8*//*Label 6974*/ GIMT_Encode4(348040),
     /* 347304 */ // Label 6966: @347304
     /* 347304 */ GIM_Try, /*On fail goto*//*Label 6976*/ GIMT_Encode4(347330), // Rule ID 2317 //
     /* 347309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 347315 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347319 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 347323 */   // (abs:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (ABSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 347323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSWr),
     /* 347328 */   GIR_RootConstrainSelectedInstOperands,
     /* 347329 */   // GIR_Coverage, 2317,
     /* 347329 */   GIR_Done,
     /* 347330 */ // Label 6976: @347330
     /* 347330 */ GIM_Reject,
     /* 347331 */ // Label 6967: @347331
     /* 347331 */ GIM_Try, /*On fail goto*//*Label 6977*/ GIMT_Encode4(347409),
     /* 347336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 347339 */   GIM_Try, /*On fail goto*//*Label 6978*/ GIMT_Encode4(347362), // Rule ID 1652 //
     /* 347344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347347 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347351 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347355 */     // (abs:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)  =>  (ABSv1i64:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn)
     /* 347355 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 347360 */     GIR_RootConstrainSelectedInstOperands,
     /* 347361 */     // GIR_Coverage, 1652,
     /* 347361 */     GIR_Done,
     /* 347362 */   // Label 6978: @347362
     /* 347362 */   GIM_Try, /*On fail goto*//*Label 6979*/ GIMT_Encode4(347385), // Rule ID 2318 //
     /* 347367 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 347370 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347374 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 347378 */     // (abs:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (ABSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 347378 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSXr),
     /* 347383 */     GIR_RootConstrainSelectedInstOperands,
     /* 347384 */     // GIR_Coverage, 2318,
     /* 347384 */     GIR_Done,
     /* 347385 */   // Label 6979: @347385
     /* 347385 */   GIM_Try, /*On fail goto*//*Label 6980*/ GIMT_Encode4(347408), // Rule ID 2510 //
     /* 347390 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoCSSC),
     /* 347393 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347397 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347401 */     // (abs:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)  =>  (ABSv1i64:{ *:[i64] } FPR64:{ *:[i64] }:$Rn)
     /* 347401 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv1i64),
     /* 347406 */     GIR_RootConstrainSelectedInstOperands,
     /* 347407 */     // GIR_Coverage, 2510,
     /* 347407 */     GIR_Done,
     /* 347408 */   // Label 6980: @347408
     /* 347408 */   GIM_Reject,
     /* 347409 */ // Label 6977: @347409
     /* 347409 */ GIM_Reject,
     /* 347410 */ // Label 6968: @347410
     /* 347410 */ GIM_Try, /*On fail goto*//*Label 6981*/ GIMT_Encode4(347436), // Rule ID 707 //
     /* 347415 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347425 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347429 */   // (abs:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (ABSv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 347429 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i32),
     /* 347434 */   GIR_RootConstrainSelectedInstOperands,
     /* 347435 */   // GIR_Coverage, 707,
     /* 347435 */   GIR_Done,
     /* 347436 */ // Label 6981: @347436
     /* 347436 */ GIM_Reject,
     /* 347437 */ // Label 6969: @347437
     /* 347437 */ GIM_Try, /*On fail goto*//*Label 6982*/ GIMT_Encode4(347619),
     /* 347442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347445 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347449 */   GIM_Try, /*On fail goto*//*Label 6983*/ GIMT_Encode4(347527), // Rule ID 4924 //
     /* 347454 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347458 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347462 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347466 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 347470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347478 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347482 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347486 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347490 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347494 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 347503 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 347510 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opA)), (zext:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$opB))))  =>  (UABDLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$opA, V128:{ *:[v4i32] }:$opB)
     /* 347510 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i32_v2i64),
     /* 347513 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347525 */     GIR_RootConstrainSelectedInstOperands,
     /* 347526 */     // GIR_Coverage, 4924,
     /* 347526 */     GIR_EraseRootFromParent_Done,
     /* 347527 */   // Label 6983: @347527
     /* 347527 */   GIM_Try, /*On fail goto*//*Label 6984*/ GIMT_Encode4(347599), // Rule ID 4923 //
     /* 347532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 347544 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 347548 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347552 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347556 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347560 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347565 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347569 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347573 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 347577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347582 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347584 */     // (abs:{ *:[v2i64] } (sub:{ *:[v2i64] } (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA), (zext:{ *:[v2i64] } V64:{ *:[v2i32] }:$opB)))  =>  (UABDLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$opA, V64:{ *:[v2i32] }:$opB)
     /* 347584 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv2i32_v2i64),
     /* 347587 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347589 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347593 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347597 */     GIR_RootConstrainSelectedInstOperands,
     /* 347598 */     // GIR_Coverage, 4923,
     /* 347598 */     GIR_EraseRootFromParent_Done,
     /* 347599 */   // Label 6984: @347599
     /* 347599 */   GIM_Try, /*On fail goto*//*Label 6985*/ GIMT_Encode4(347618), // Rule ID 709 //
     /* 347604 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347607 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347611 */     // (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ABSv2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 347611 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv2i64),
     /* 347616 */     GIR_RootConstrainSelectedInstOperands,
     /* 347617 */     // GIR_Coverage, 709,
     /* 347617 */     GIR_Done,
     /* 347618 */   // Label 6985: @347618
     /* 347618 */   GIM_Reject,
     /* 347619 */ // Label 6982: @347619
     /* 347619 */ GIM_Reject,
     /* 347620 */ // Label 6970: @347620
     /* 347620 */ GIM_Try, /*On fail goto*//*Label 6986*/ GIMT_Encode4(347646), // Rule ID 705 //
     /* 347625 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347628 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347631 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347635 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347639 */   // (abs:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ABSv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 347639 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i16),
     /* 347644 */   GIR_RootConstrainSelectedInstOperands,
     /* 347645 */   // GIR_Coverage, 705,
     /* 347645 */   GIR_Done,
     /* 347646 */ // Label 6986: @347646
     /* 347646 */ GIM_Reject,
     /* 347647 */ // Label 6971: @347647
     /* 347647 */ GIM_Try, /*On fail goto*//*Label 6987*/ GIMT_Encode4(347829),
     /* 347652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347655 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347659 */   GIM_Try, /*On fail goto*//*Label 6988*/ GIMT_Encode4(347737), // Rule ID 4922 //
     /* 347664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347668 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347672 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347676 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347692 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347696 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347700 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347704 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347706 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347713 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 347720 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opA)), (zext:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$opB))))  =>  (UABDLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$opA, V128:{ *:[v8i16] }:$opB)
     /* 347720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i16_v4i32),
     /* 347723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347735 */     GIR_RootConstrainSelectedInstOperands,
     /* 347736 */     // GIR_Coverage, 4922,
     /* 347736 */     GIR_EraseRootFromParent_Done,
     /* 347737 */   // Label 6988: @347737
     /* 347737 */   GIM_Try, /*On fail goto*//*Label 6989*/ GIMT_Encode4(347809), // Rule ID 4921 //
     /* 347742 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347746 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347750 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 347754 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 347758 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347762 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347766 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347783 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 347787 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347792 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347794 */     // (abs:{ *:[v4i32] } (sub:{ *:[v4i32] } (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA), (zext:{ *:[v4i32] } V64:{ *:[v4i16] }:$opB)))  =>  (UABDLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$opA, V64:{ *:[v4i16] }:$opB)
     /* 347794 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv4i16_v4i32),
     /* 347797 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347799 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 347803 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 347807 */     GIR_RootConstrainSelectedInstOperands,
     /* 347808 */     // GIR_Coverage, 4921,
     /* 347808 */     GIR_EraseRootFromParent_Done,
     /* 347809 */   // Label 6989: @347809
     /* 347809 */   GIM_Try, /*On fail goto*//*Label 6990*/ GIMT_Encode4(347828), // Rule ID 708 //
     /* 347814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347817 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347821 */     // (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ABSv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 347821 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv4i32),
     /* 347826 */     GIR_RootConstrainSelectedInstOperands,
     /* 347827 */     // GIR_Coverage, 708,
     /* 347827 */     GIR_Done,
     /* 347828 */   // Label 6990: @347828
     /* 347828 */   GIM_Reject,
     /* 347829 */ // Label 6987: @347829
     /* 347829 */ GIM_Reject,
     /* 347830 */ // Label 6972: @347830
     /* 347830 */ GIM_Try, /*On fail goto*//*Label 6991*/ GIMT_Encode4(347856), // Rule ID 703 //
     /* 347835 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 347838 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347841 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347845 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347849 */   // (abs:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ABSv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 347849 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i8),
     /* 347854 */   GIR_RootConstrainSelectedInstOperands,
     /* 347855 */   // GIR_Coverage, 703,
     /* 347855 */   GIR_Done,
     /* 347856 */ // Label 6991: @347856
     /* 347856 */ GIM_Reject,
     /* 347857 */ // Label 6973: @347857
     /* 347857 */ GIM_Try, /*On fail goto*//*Label 6992*/ GIMT_Encode4(348039),
     /* 347862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 347869 */   GIM_Try, /*On fail goto*//*Label 6993*/ GIMT_Encode4(347947), // Rule ID 4920 //
     /* 347874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347886 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347890 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347894 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347898 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347902 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347906 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347910 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 347916 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347923 */     GIM_CheckComplexPattern, /*MI*/3, /*Op*/1, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 347930 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opA)), (zext:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$opB))))  =>  (UABDLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$opA, V128:{ *:[v16i8] }:$opB)
     /* 347930 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv16i8_v8i16),
     /* 347933 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 347935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // opA
     /* 347940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // opB
     /* 347945 */     GIR_RootConstrainSelectedInstOperands,
     /* 347946 */     // GIR_Coverage, 4920,
     /* 347946 */     GIR_EraseRootFromParent_Done,
     /* 347947 */   // Label 6993: @347947
     /* 347947 */   GIM_Try, /*On fail goto*//*Label 6994*/ GIMT_Encode4(348019), // Rule ID 4919 //
     /* 347952 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 347956 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_SUB),
     /* 347960 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 347964 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 347968 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 347972 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347976 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347980 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 347985 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 347989 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_ZEXT),
     /* 347993 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 347997 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348002 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 348004 */     // (abs:{ *:[v8i16] } (sub:{ *:[v8i16] } (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA), (zext:{ *:[v8i16] } V64:{ *:[v8i8] }:$opB)))  =>  (UABDLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$opA, V64:{ *:[v8i8] }:$opB)
     /* 348004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UABDLv8i8_v8i16),
     /* 348007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // opA
     /* 348013 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // opB
     /* 348017 */     GIR_RootConstrainSelectedInstOperands,
     /* 348018 */     // GIR_Coverage, 4919,
     /* 348018 */     GIR_EraseRootFromParent_Done,
     /* 348019 */   // Label 6994: @348019
     /* 348019 */   GIM_Try, /*On fail goto*//*Label 6995*/ GIMT_Encode4(348038), // Rule ID 706 //
     /* 348024 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348027 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348031 */     // (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ABSv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 348031 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv8i16),
     /* 348036 */     GIR_RootConstrainSelectedInstOperands,
     /* 348037 */     // GIR_Coverage, 706,
     /* 348037 */     GIR_Done,
     /* 348038 */   // Label 6995: @348038
     /* 348038 */   GIM_Reject,
     /* 348039 */ // Label 6992: @348039
     /* 348039 */ GIM_Reject,
     /* 348040 */ // Label 6974: @348040
     /* 348040 */ GIM_Try, /*On fail goto*//*Label 6996*/ GIMT_Encode4(348066), // Rule ID 704 //
     /* 348045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 348048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 348051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348059 */   // (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ABSv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 348059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ABSv16i8),
     /* 348064 */   GIR_RootConstrainSelectedInstOperands,
     /* 348065 */   // GIR_Coverage, 704,
     /* 348065 */   GIR_Done,
     /* 348066 */ // Label 6996: @348066
     /* 348066 */ GIM_Reject,
     /* 348067 */ // Label 6975: @348067
     /* 348067 */ GIM_Reject,
     /* 348068 */ // Label 86: @348068
     /* 348068 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 6999*/ GIMT_Encode4(348233),
     /* 348079 */ /*GILLT_s32*//*Label 6997*/ GIMT_Encode4(348087),
     /* 348083 */ /*GILLT_s64*//*Label 6998*/ GIMT_Encode4(348160),
     /* 348087 */ // Label 6997: @348087
     /* 348087 */ GIM_Try, /*On fail goto*//*Label 7000*/ GIMT_Encode4(348113), // Rule ID 4765 //
     /* 348092 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348095 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 348098 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348102 */   // (lround:{ *:[i32] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUWHr:{ *:[i32] } f16:{ *:[f16] }:$Rn)
     /* 348102 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWHr),
     /* 348107 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348111 */   GIR_RootConstrainSelectedInstOperands,
     /* 348112 */   // GIR_Coverage, 4765,
     /* 348112 */   GIR_Done,
     /* 348113 */ // Label 7000: @348113
     /* 348113 */ GIM_Try, /*On fail goto*//*Label 7001*/ GIMT_Encode4(348136), // Rule ID 4771 //
     /* 348118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348121 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348125 */   // (lround:{ *:[i32] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUWSr:{ *:[i32] } f32:{ *:[f32] }:$Rn)
     /* 348125 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWSr),
     /* 348130 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348134 */   GIR_RootConstrainSelectedInstOperands,
     /* 348135 */   // GIR_Coverage, 4771,
     /* 348135 */   GIR_Done,
     /* 348136 */ // Label 7001: @348136
     /* 348136 */ GIM_Try, /*On fail goto*//*Label 7002*/ GIMT_Encode4(348159), // Rule ID 4773 //
     /* 348141 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348144 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 348148 */   // (lround:{ *:[i32] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUWDr:{ *:[i32] } f64:{ *:[f64] }:$Rn)
     /* 348148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUWDr),
     /* 348153 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348157 */   GIR_RootConstrainSelectedInstOperands,
     /* 348158 */   // GIR_Coverage, 4773,
     /* 348158 */   GIR_Done,
     /* 348159 */ // Label 7002: @348159
     /* 348159 */ GIM_Reject,
     /* 348160 */ // Label 6998: @348160
     /* 348160 */ GIM_Try, /*On fail goto*//*Label 7003*/ GIMT_Encode4(348186), // Rule ID 4767 //
     /* 348165 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348168 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 348171 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348175 */   // (lround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 348175 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 348180 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348184 */   GIR_RootConstrainSelectedInstOperands,
     /* 348185 */   // GIR_Coverage, 4767,
     /* 348185 */   GIR_Done,
     /* 348186 */ // Label 7003: @348186
     /* 348186 */ GIM_Try, /*On fail goto*//*Label 7004*/ GIMT_Encode4(348209), // Rule ID 4775 //
     /* 348191 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 348194 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348198 */   // (lround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 348198 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 348203 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348207 */   GIR_RootConstrainSelectedInstOperands,
     /* 348208 */   // GIR_Coverage, 4775,
     /* 348208 */   GIR_Done,
     /* 348209 */ // Label 7004: @348209
     /* 348209 */ GIM_Try, /*On fail goto*//*Label 7005*/ GIMT_Encode4(348232), // Rule ID 4777 //
     /* 348214 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 348217 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348221 */   // (lround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 348221 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 348226 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348230 */   GIR_RootConstrainSelectedInstOperands,
     /* 348231 */   // GIR_Coverage, 4777,
     /* 348231 */   GIR_Done,
     /* 348232 */ // Label 7005: @348232
     /* 348232 */ GIM_Reject,
     /* 348233 */ // Label 6999: @348233
     /* 348233 */ GIM_Reject,
     /* 348234 */ // Label 87: @348234
     /* 348234 */ GIM_Try, /*On fail goto*//*Label 7006*/ GIMT_Encode4(348332),
     /* 348239 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_s64,
     /* 348242 */   GIM_SwitchType, /*MI*/0, /*Op*/1, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7010*/ GIMT_Encode4(348331),
     /* 348253 */   /*GILLT_s16*//*Label 7007*/ GIMT_Encode4(348265),
     /* 348257 */   /*GILLT_s32*//*Label 7008*/ GIMT_Encode4(348289),
     /* 348261 */   /*GILLT_s64*//*Label 7009*/ GIMT_Encode4(348310),
     /* 348265 */   // Label 7007: @348265
     /* 348265 */   GIM_Try, /*On fail goto*//*Label 7011*/ GIMT_Encode4(348288), // Rule ID 4769 //
     /* 348270 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 348273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348277 */     // (llround:{ *:[i64] } f16:{ *:[f16] }:$Rn)  =>  (FCVTASUXHr:{ *:[i64] } f16:{ *:[f16] }:$Rn)
     /* 348277 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXHr),
     /* 348282 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348286 */     GIR_RootConstrainSelectedInstOperands,
     /* 348287 */     // GIR_Coverage, 4769,
     /* 348287 */     GIR_Done,
     /* 348288 */   // Label 7011: @348288
     /* 348288 */   GIM_Reject,
     /* 348289 */   // Label 7008: @348289
     /* 348289 */   GIM_Try, /*On fail goto*//*Label 7012*/ GIMT_Encode4(348309), // Rule ID 4779 //
     /* 348294 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348298 */     // (llround:{ *:[i64] } f32:{ *:[f32] }:$Rn)  =>  (FCVTASUXSr:{ *:[i64] } f32:{ *:[f32] }:$Rn)
     /* 348298 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXSr),
     /* 348303 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348307 */     GIR_RootConstrainSelectedInstOperands,
     /* 348308 */     // GIR_Coverage, 4779,
     /* 348308 */     GIR_Done,
     /* 348309 */   // Label 7012: @348309
     /* 348309 */   GIM_Reject,
     /* 348310 */   // Label 7009: @348310
     /* 348310 */   GIM_Try, /*On fail goto*//*Label 7013*/ GIMT_Encode4(348330), // Rule ID 4781 //
     /* 348315 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 348319 */     // (llround:{ *:[i64] } f64:{ *:[f64] }:$Rn)  =>  (FCVTASUXDr:{ *:[i64] } f64:{ *:[f64] }:$Rn)
     /* 348319 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCVTASUXDr),
     /* 348324 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 348328 */     GIR_RootConstrainSelectedInstOperands,
     /* 348329 */     // GIR_Coverage, 4781,
     /* 348329 */     GIR_Done,
     /* 348330 */   // Label 7013: @348330
     /* 348330 */   GIM_Reject,
     /* 348331 */   // Label 7010: @348331
     /* 348331 */   GIM_Reject,
     /* 348332 */ // Label 7006: @348332
     /* 348332 */ GIM_Reject,
     /* 348333 */ // Label 88: @348333
     /* 348333 */ GIM_Try, /*On fail goto*//*Label 7014*/ GIMT_Encode4(348348), // Rule ID 225 //
     /* 348338 */   // MIs[0] addr
     /* 348338 */   GIM_CheckIsMBB, /*MI*/0, /*Op*/0,
     /* 348341 */   // (br (bb:{ *:[Other] }):$addr)  =>  (B (bb:{ *:[Other] }):$addr)
     /* 348341 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::B),
     /* 348346 */   GIR_RootConstrainSelectedInstOperands,
     /* 348347 */   // GIR_Coverage, 225,
     /* 348347 */   GIR_Done,
     /* 348348 */ // Label 7014: @348348
     /* 348348 */ GIM_Reject,
     /* 348349 */ // Label 89: @348349
     /* 348349 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(21), /*)*//*default:*//*Label 7026*/ GIMT_Encode4(353720),
     /* 348360 */ /*GILLT_s64*//*Label 7015*/ GIMT_Encode4(348432), GIMT_Encode4(0),
     /* 348368 */ /*GILLT_v2s32*//*Label 7016*/ GIMT_Encode4(348834), GIMT_Encode4(0),
     /* 348376 */ /*GILLT_v4s16*//*Label 7017*/ GIMT_Encode4(349236), GIMT_Encode4(0),
     /* 348384 */ /*GILLT_v8s8*//*Label 7018*/ GIMT_Encode4(349638), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 348396 */ /*GILLT_nxv1s1*//*Label 7019*/ GIMT_Encode4(349818),
     /* 348400 */ /*GILLT_nxv2s1*//*Label 7020*/ GIMT_Encode4(352081),
     /* 348404 */ /*GILLT_nxv2s16*//*Label 7021*/ GIMT_Encode4(352936),
     /* 348408 */ /*GILLT_nxv2s32*//*Label 7022*/ GIMT_Encode4(353223), GIMT_Encode4(0),
     /* 348416 */ /*GILLT_nxv4s1*//*Label 7023*/ GIMT_Encode4(353293),
     /* 348420 */ /*GILLT_nxv4s16*//*Label 7024*/ GIMT_Encode4(353580), GIMT_Encode4(0),
     /* 348428 */ /*GILLT_nxv8s1*//*Label 7025*/ GIMT_Encode4(353650),
     /* 348432 */ // Label 7015: @348432
     /* 348432 */ GIM_Try, /*On fail goto*//*Label 7027*/ GIMT_Encode4(348833),
     /* 348437 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 348440 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348444 */   GIM_Try, /*On fail goto*//*Label 7028*/ GIMT_Encode4(348496), // Rule ID 5594 //
     /* 348449 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348453 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348457 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348461 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348463 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348468 */     // MIs[0] Operand 2
     /* 348468 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348479 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348481 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 348481 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 348484 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348486 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348490 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348494 */     GIR_RootConstrainSelectedInstOperands,
     /* 348495 */     // GIR_Coverage, 5594,
     /* 348495 */     GIR_EraseRootFromParent_Done,
     /* 348496 */   // Label 7028: @348496
     /* 348496 */   GIM_Try, /*On fail goto*//*Label 7029*/ GIMT_Encode4(348548), // Rule ID 5597 //
     /* 348501 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348505 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348509 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 348513 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348515 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348520 */     // MIs[0] Operand 2
     /* 348520 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348531 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348533 */     // (extract_subvector:{ *:[v1i64] } (anyext:{ *:[v2i64] } V64:{ *:[v2i32] }:$Vn)<<P:Predicate_anyext_oneuse>>, 1:{ *:[i64] })  =>  (ZIP2v2i32:{ *:[v1i64] } V64:{ *:[v2i32] }:$Vn, V64:{ *:[v2i32] }:$Vn)
     /* 348533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 348536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348538 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348542 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348546 */     GIR_RootConstrainSelectedInstOperands,
     /* 348547 */     // GIR_Coverage, 5597,
     /* 348547 */     GIR_EraseRootFromParent_Done,
     /* 348548 */   // Label 7029: @348548
     /* 348548 */   GIM_Try, /*On fail goto*//*Label 7030*/ GIMT_Encode4(348616), // Rule ID 5473 //
     /* 348553 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348557 */     // MIs[0] Operand 2
     /* 348557 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348568 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348568 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348571 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348575 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348580 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348584 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348588 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348591 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348593 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348596 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348598 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348615 */     // GIR_Coverage, 5473,
     /* 348615 */     GIR_EraseRootFromParent_Done,
     /* 348616 */   // Label 7030: @348616
     /* 348616 */   GIM_Try, /*On fail goto*//*Label 7031*/ GIMT_Encode4(348684), // Rule ID 5478 //
     /* 348621 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348625 */     // MIs[0] Operand 2
     /* 348625 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348636 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348636 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348639 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348643 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348648 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348652 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348656 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348659 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348661 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348664 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348666 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348673 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348678 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348683 */     // GIR_Coverage, 5478,
     /* 348683 */     GIR_EraseRootFromParent_Done,
     /* 348684 */   // Label 7031: @348684
     /* 348684 */   GIM_Try, /*On fail goto*//*Label 7032*/ GIMT_Encode4(348726), // Rule ID 6927 //
     /* 348689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348693 */     // MIs[0] Operand 2
     /* 348693 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348704 */     // (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, dsub:{ *:[i32] })
     /* 348704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348709 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348720 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348725 */     // GIR_Coverage, 6927,
     /* 348725 */     GIR_EraseRootFromParent_Done,
     /* 348726 */   // Label 7032: @348726
     /* 348726 */   GIM_Try, /*On fail goto*//*Label 7033*/ GIMT_Encode4(348768), // Rule ID 6928 //
     /* 348731 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348735 */     // MIs[0] Operand 2
     /* 348735 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348746 */     // (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 348746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348751 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 348757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348767 */     // GIR_Coverage, 6928,
     /* 348767 */     GIR_EraseRootFromParent_Done,
     /* 348768 */   // Label 7033: @348768
     /* 348768 */   GIM_Try, /*On fail goto*//*Label 7034*/ GIMT_Encode4(348832), // Rule ID 6932 //
     /* 348773 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348777 */     // MIs[0] Operand 2
     /* 348777 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 348788 */     // (extract_subvector:{ *:[v1i64] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 348788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 348795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 348807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348809 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348812 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 348814 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 348821 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348826 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348831 */     // GIR_Coverage, 6932,
     /* 348831 */     GIR_EraseRootFromParent_Done,
     /* 348832 */   // Label 7034: @348832
     /* 348832 */   GIM_Reject,
     /* 348833 */ // Label 7027: @348833
     /* 348833 */ GIM_Reject,
     /* 348834 */ // Label 7016: @348834
     /* 348834 */ GIM_Try, /*On fail goto*//*Label 7035*/ GIMT_Encode4(349235),
     /* 348839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 348842 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348846 */   GIM_Try, /*On fail goto*//*Label 7036*/ GIMT_Encode4(348898), // Rule ID 5593 //
     /* 348851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348863 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348865 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348870 */     // MIs[0] Operand 2
     /* 348870 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 348881 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348883 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348883 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 348886 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348888 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348896 */     GIR_RootConstrainSelectedInstOperands,
     /* 348897 */     // GIR_Coverage, 5593,
     /* 348897 */     GIR_EraseRootFromParent_Done,
     /* 348898 */   // Label 7036: @348898
     /* 348898 */   GIM_Try, /*On fail goto*//*Label 7037*/ GIMT_Encode4(348950), // Rule ID 5596 //
     /* 348903 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 348907 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 348911 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 348915 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 348917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 348922 */     // MIs[0] Operand 2
     /* 348922 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 348935 */     // (extract_subvector:{ *:[v2i32] } (anyext:{ *:[v4i32] } V64:{ *:[v4i16] }:$Vn)<<P:Predicate_anyext_oneuse>>, 2:{ *:[i64] })  =>  (ZIP2v4i16:{ *:[v2i32] } V64:{ *:[v4i16] }:$Vn, V64:{ *:[v4i16] }:$Vn)
     /* 348935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 348938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 348940 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348944 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 348948 */     GIR_RootConstrainSelectedInstOperands,
     /* 348949 */     // GIR_Coverage, 5596,
     /* 348949 */     GIR_EraseRootFromParent_Done,
     /* 348950 */   // Label 7037: @348950
     /* 348950 */   GIM_Try, /*On fail goto*//*Label 7038*/ GIMT_Encode4(349018), // Rule ID 5463 //
     /* 348955 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 348959 */     // MIs[0] Operand 2
     /* 348959 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 348970 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 348970 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 348973 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 348977 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 348982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348986 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 348990 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 348993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 348995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 348998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349000 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349007 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349012 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349017 */     // GIR_Coverage, 5463,
     /* 349017 */     GIR_EraseRootFromParent_Done,
     /* 349018 */   // Label 7038: @349018
     /* 349018 */   GIM_Try, /*On fail goto*//*Label 7039*/ GIMT_Encode4(349086), // Rule ID 5468 //
     /* 349023 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349027 */     // MIs[0] Operand 2
     /* 349027 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 349038 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349050 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349054 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349058 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349061 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349068 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349075 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349080 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349085 */     // GIR_Coverage, 5468,
     /* 349085 */     GIR_EraseRootFromParent_Done,
     /* 349086 */   // Label 7039: @349086
     /* 349086 */   GIM_Try, /*On fail goto*//*Label 7040*/ GIMT_Encode4(349128), // Rule ID 6924 //
     /* 349091 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349095 */     // MIs[0] Operand 2
     /* 349095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349106 */     // (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] })
     /* 349106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349111 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349117 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349127 */     // GIR_Coverage, 6924,
     /* 349127 */     GIR_EraseRootFromParent_Done,
     /* 349128 */   // Label 7040: @349128
     /* 349128 */   GIM_Try, /*On fail goto*//*Label 7041*/ GIMT_Encode4(349170), // Rule ID 6926 //
     /* 349133 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349137 */     // MIs[0] Operand 2
     /* 349137 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349148 */     // (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, dsub:{ *:[i32] })
     /* 349148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349153 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349169 */     // GIR_Coverage, 6926,
     /* 349169 */     GIR_EraseRootFromParent_Done,
     /* 349170 */   // Label 7041: @349170
     /* 349170 */   GIM_Try, /*On fail goto*//*Label 7042*/ GIMT_Encode4(349234), // Rule ID 6931 //
     /* 349175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349179 */     // MIs[0] Operand 2
     /* 349179 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349190 */     // (extract_subvector:{ *:[v2i32] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v4i32] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349202 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349206 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349209 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349216 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349223 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349228 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349233 */     // GIR_Coverage, 6931,
     /* 349233 */     GIR_EraseRootFromParent_Done,
     /* 349234 */   // Label 7042: @349234
     /* 349234 */   GIM_Reject,
     /* 349235 */ // Label 7035: @349235
     /* 349235 */ GIM_Reject,
     /* 349236 */ // Label 7017: @349236
     /* 349236 */ GIM_Try, /*On fail goto*//*Label 7043*/ GIMT_Encode4(349637),
     /* 349241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 349244 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349248 */   GIM_Try, /*On fail goto*//*Label 7044*/ GIMT_Encode4(349300), // Rule ID 5592 //
     /* 349253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349261 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349265 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349267 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349272 */     // MIs[0] Operand 2
     /* 349272 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349283 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349285 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 0:{ *:[i64] })  =>  (ZIP1v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 349285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 349288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349294 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349298 */     GIR_RootConstrainSelectedInstOperands,
     /* 349299 */     // GIR_Coverage, 5592,
     /* 349299 */     GIR_EraseRootFromParent_Done,
     /* 349300 */   // Label 7044: @349300
     /* 349300 */   GIM_Try, /*On fail goto*//*Label 7045*/ GIMT_Encode4(349352), // Rule ID 5595 //
     /* 349305 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 349309 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ANYEXT),
     /* 349313 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 349317 */     GIM_CheckHasOneUse, /*MI*/1,
     /* 349319 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349324 */     // MIs[0] Operand 2
     /* 349324 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349335 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 349337 */     // (extract_subvector:{ *:[v4i16] } (anyext:{ *:[v8i16] } V64:{ *:[v8i8] }:$Vn)<<P:Predicate_anyext_oneuse>>, 4:{ *:[i64] })  =>  (ZIP2v8i8:{ *:[v4i16] } V64:{ *:[v8i8] }:$Vn, V64:{ *:[v8i8] }:$Vn)
     /* 349337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 349340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 349342 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Vn
     /* 349350 */     GIR_RootConstrainSelectedInstOperands,
     /* 349351 */     // GIR_Coverage, 5595,
     /* 349351 */     GIR_EraseRootFromParent_Done,
     /* 349352 */   // Label 7045: @349352
     /* 349352 */   GIM_Try, /*On fail goto*//*Label 7046*/ GIMT_Encode4(349420), // Rule ID 5453 //
     /* 349357 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349361 */     // MIs[0] Operand 2
     /* 349361 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349372 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349384 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349388 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349392 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349402 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349409 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349414 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349419 */     // GIR_Coverage, 5453,
     /* 349419 */     GIR_EraseRootFromParent_Done,
     /* 349420 */   // Label 7046: @349420
     /* 349420 */   GIM_Try, /*On fail goto*//*Label 7047*/ GIMT_Encode4(349488), // Rule ID 5458 //
     /* 349425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349429 */     // MIs[0] Operand 2
     /* 349429 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 349440 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349440 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349443 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349447 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349456 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349460 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349463 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349465 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349468 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349470 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349487 */     // GIR_Coverage, 5458,
     /* 349487 */     GIR_EraseRootFromParent_Done,
     /* 349488 */   // Label 7047: @349488
     /* 349488 */   GIM_Try, /*On fail goto*//*Label 7048*/ GIMT_Encode4(349530), // Rule ID 6922 //
     /* 349493 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349497 */     // MIs[0] Operand 2
     /* 349497 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349508 */     // (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, dsub:{ *:[i32] })
     /* 349508 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349511 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349513 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349519 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349524 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349529 */     // GIR_Coverage, 6922,
     /* 349529 */     GIR_EraseRootFromParent_Done,
     /* 349530 */   // Label 7048: @349530
     /* 349530 */   GIM_Try, /*On fail goto*//*Label 7049*/ GIMT_Encode4(349572), // Rule ID 6925 //
     /* 349535 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349539 */     // MIs[0] Operand 2
     /* 349539 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349550 */     // (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })
     /* 349550 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349553 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349555 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349571 */     // GIR_Coverage, 6925,
     /* 349571 */     GIR_EraseRootFromParent_Done,
     /* 349572 */   // Label 7049: @349572
     /* 349572 */   GIM_Try, /*On fail goto*//*Label 7050*/ GIMT_Encode4(349636), // Rule ID 6930 //
     /* 349577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349581 */     // MIs[0] Operand 2
     /* 349581 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349592 */     // (extract_subvector:{ *:[v4i16] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v8i16] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349604 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349608 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349613 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349616 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349618 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349625 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349630 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349635 */     // GIR_Coverage, 6930,
     /* 349635 */     GIR_EraseRootFromParent_Done,
     /* 349636 */   // Label 7050: @349636
     /* 349636 */   GIM_Reject,
     /* 349637 */ // Label 7043: @349637
     /* 349637 */ GIM_Reject,
     /* 349638 */ // Label 7018: @349638
     /* 349638 */ GIM_Try, /*On fail goto*//*Label 7051*/ GIMT_Encode4(349817),
     /* 349643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 349646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349650 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349654 */   GIM_Try, /*On fail goto*//*Label 7052*/ GIMT_Encode4(349718), // Rule ID 5448 //
     /* 349659 */     // MIs[0] Operand 2
     /* 349659 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 349670 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, 8:{ *:[i32] }), dsub:{ *:[i32] })
     /* 349670 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349673 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 349677 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349682 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349686 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349690 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/8,
     /* 349693 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349695 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349698 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349700 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349707 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349712 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349717 */     // GIR_Coverage, 5448,
     /* 349717 */     GIR_EraseRootFromParent_Done,
     /* 349718 */   // Label 7052: @349718
     /* 349718 */   GIM_Try, /*On fail goto*//*Label 7053*/ GIMT_Encode4(349756), // Rule ID 6923 //
     /* 349723 */     // MIs[0] Operand 2
     /* 349723 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349734 */     // (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, dsub:{ *:[i32] })
     /* 349734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349739 */     GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 349745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349755 */     // GIR_Coverage, 6923,
     /* 349755 */     GIR_EraseRootFromParent_Done,
     /* 349756 */   // Label 7053: @349756
     /* 349756 */   GIM_Try, /*On fail goto*//*Label 7054*/ GIMT_Encode4(349816), // Rule ID 6929 //
     /* 349761 */     // MIs[0] Operand 2
     /* 349761 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349772 */     // (extract_subvector:{ *:[v8i8] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (DUPv2i64lane:{ *:[f128] } FPR128:{ *:[v16i8] }:$Rn, 1:{ *:[i64] }), dsub:{ *:[i32] })
     /* 349772 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 349775 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 349779 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349784 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 349788 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 349791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349793 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 349796 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 349798 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 349805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 349810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 349815 */     // GIR_Coverage, 6929,
     /* 349815 */     GIR_EraseRootFromParent_Done,
     /* 349816 */   // Label 7054: @349816
     /* 349816 */   GIM_Reject,
     /* 349817 */ // Label 7051: @349817
     /* 349817 */ GIM_Reject,
     /* 349818 */ // Label 7019: @349818
     /* 349818 */ GIM_Try, /*On fail goto*//*Label 7055*/ GIMT_Encode4(349853), // Rule ID 9021 //
     /* 349823 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349829 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349833 */   // MIs[0] Operand 2
     /* 349833 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349844 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349844 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349847 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349849 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349851 */   GIR_RootConstrainSelectedInstOperands,
     /* 349852 */   // GIR_Coverage, 9021,
     /* 349852 */   GIR_EraseRootFromParent_Done,
     /* 349853 */ // Label 7055: @349853
     /* 349853 */ GIM_Try, /*On fail goto*//*Label 7056*/ GIMT_Encode4(349888), // Rule ID 9022 //
     /* 349858 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349861 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 349864 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349868 */   // MIs[0] Operand 2
     /* 349868 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349879 */   // (extract_subvector:{ *:[nxv1i1] } nxv2i1:{ *:[nxv2i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv2i1] }:$Ps)
     /* 349879 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349882 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349884 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 349886 */   GIR_RootConstrainSelectedInstOperands,
     /* 349887 */   // GIR_Coverage, 9022,
     /* 349887 */   GIR_EraseRootFromParent_Done,
     /* 349888 */ // Label 7056: @349888
     /* 349888 */ GIM_Try, /*On fail goto*//*Label 7057*/ GIMT_Encode4(349942), // Rule ID 9029 //
     /* 349893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349903 */   // MIs[0] Operand 2
     /* 349903 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 349914 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349914 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349917 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349921 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349926 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349930 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349932 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349935 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349937 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349940 */   GIR_RootConstrainSelectedInstOperands,
     /* 349941 */   // GIR_Coverage, 9029,
     /* 349941 */   GIR_EraseRootFromParent_Done,
     /* 349942 */ // Label 7057: @349942
     /* 349942 */ GIM_Try, /*On fail goto*//*Label 7058*/ GIMT_Encode4(349996), // Rule ID 9030 //
     /* 349947 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 349950 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 349953 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 349957 */   // MIs[0] Operand 2
     /* 349957 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 349968 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 349968 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 349971 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 349975 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 349980 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 349984 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 349986 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 349989 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 349991 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 349994 */   GIR_RootConstrainSelectedInstOperands,
     /* 349995 */   // GIR_Coverage, 9030,
     /* 349995 */   GIR_EraseRootFromParent_Done,
     /* 349996 */ // Label 7058: @349996
     /* 349996 */ GIM_Try, /*On fail goto*//*Label 7059*/ GIMT_Encode4(350050), // Rule ID 9031 //
     /* 350001 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350004 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350007 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350011 */   // MIs[0] Operand 2
     /* 350011 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350022 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350022 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350025 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350029 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350034 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350038 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350040 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350043 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350045 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350048 */   GIR_RootConstrainSelectedInstOperands,
     /* 350049 */   // GIR_Coverage, 9031,
     /* 350049 */   GIR_EraseRootFromParent_Done,
     /* 350050 */ // Label 7059: @350050
     /* 350050 */ GIM_Try, /*On fail goto*//*Label 7060*/ GIMT_Encode4(350104), // Rule ID 9032 //
     /* 350055 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350058 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 350061 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350065 */   // MIs[0] Operand 2
     /* 350065 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350076 */   // (extract_subvector:{ *:[nxv1i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv4i1] }:$Ps))
     /* 350076 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350079 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350083 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350088 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350092 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350094 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350097 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350099 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350102 */   GIR_RootConstrainSelectedInstOperands,
     /* 350103 */   // GIR_Coverage, 9032,
     /* 350103 */   GIR_EraseRootFromParent_Done,
     /* 350104 */ // Label 7060: @350104
     /* 350104 */ GIM_Try, /*On fail goto*//*Label 7061*/ GIMT_Encode4(350175), // Rule ID 9041 //
     /* 350109 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350112 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350115 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350119 */   // MIs[0] Operand 2
     /* 350119 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350130 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350130 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350133 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350137 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350142 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350146 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350148 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350151 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350155 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350160 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350173 */   GIR_RootConstrainSelectedInstOperands,
     /* 350174 */   // GIR_Coverage, 9041,
     /* 350174 */   GIR_EraseRootFromParent_Done,
     /* 350175 */ // Label 7061: @350175
     /* 350175 */ GIM_Try, /*On fail goto*//*Label 7062*/ GIMT_Encode4(350246), // Rule ID 9042 //
     /* 350180 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350183 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350186 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350190 */   // MIs[0] Operand 2
     /* 350190 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350201 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350201 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350204 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350208 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350213 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350219 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350222 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350226 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350231 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350234 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350236 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350239 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350241 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350244 */   GIR_RootConstrainSelectedInstOperands,
     /* 350245 */   // GIR_Coverage, 9042,
     /* 350245 */   GIR_EraseRootFromParent_Done,
     /* 350246 */ // Label 7062: @350246
     /* 350246 */ GIM_Try, /*On fail goto*//*Label 7063*/ GIMT_Encode4(350317), // Rule ID 9043 //
     /* 350251 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350254 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350257 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350261 */   // MIs[0] Operand 2
     /* 350261 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350272 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350272 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350275 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350279 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350284 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350288 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350290 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350293 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350297 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350302 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350305 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350307 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350310 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350312 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350315 */   GIR_RootConstrainSelectedInstOperands,
     /* 350316 */   // GIR_Coverage, 9043,
     /* 350316 */   GIR_EraseRootFromParent_Done,
     /* 350317 */ // Label 7063: @350317
     /* 350317 */ GIM_Try, /*On fail goto*//*Label 7064*/ GIMT_Encode4(350388), // Rule ID 9044 //
     /* 350322 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350328 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350332 */   // MIs[0] Operand 2
     /* 350332 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350343 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350343 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350346 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350350 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350355 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350361 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350364 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350368 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350373 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350376 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350378 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350381 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350383 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350386 */   GIR_RootConstrainSelectedInstOperands,
     /* 350387 */   // GIR_Coverage, 9044,
     /* 350387 */   GIR_EraseRootFromParent_Done,
     /* 350388 */ // Label 7064: @350388
     /* 350388 */ GIM_Try, /*On fail goto*//*Label 7065*/ GIMT_Encode4(350459), // Rule ID 9045 //
     /* 350393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350399 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350403 */   // MIs[0] Operand 2
     /* 350403 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 350414 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350414 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350417 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350421 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350426 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350432 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350435 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350439 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350444 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350447 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350449 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350452 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350454 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350457 */   GIR_RootConstrainSelectedInstOperands,
     /* 350458 */   // GIR_Coverage, 9045,
     /* 350458 */   GIR_EraseRootFromParent_Done,
     /* 350459 */ // Label 7065: @350459
     /* 350459 */ GIM_Try, /*On fail goto*//*Label 7066*/ GIMT_Encode4(350530), // Rule ID 9046 //
     /* 350464 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350467 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350470 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350474 */   // MIs[0] Operand 2
     /* 350474 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 350485 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350485 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350488 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350492 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350497 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350501 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350503 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350506 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350510 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350515 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350518 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350520 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350523 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350525 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350528 */   GIR_RootConstrainSelectedInstOperands,
     /* 350529 */   // GIR_Coverage, 9046,
     /* 350529 */   GIR_EraseRootFromParent_Done,
     /* 350530 */ // Label 7066: @350530
     /* 350530 */ GIM_Try, /*On fail goto*//*Label 7067*/ GIMT_Encode4(350601), // Rule ID 9047 //
     /* 350535 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350538 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350541 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350545 */   // MIs[0] Operand 2
     /* 350545 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 350556 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350556 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350559 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350563 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350568 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350572 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350574 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350577 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350581 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350586 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350589 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350594 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350596 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350599 */   GIR_RootConstrainSelectedInstOperands,
     /* 350600 */   // GIR_Coverage, 9047,
     /* 350600 */   GIR_EraseRootFromParent_Done,
     /* 350601 */ // Label 7067: @350601
     /* 350601 */ GIM_Try, /*On fail goto*//*Label 7068*/ GIMT_Encode4(350672), // Rule ID 9048 //
     /* 350606 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350609 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 350612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350616 */   // MIs[0] Operand 2
     /* 350616 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 350627 */   // (extract_subvector:{ *:[nxv1i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps)))
     /* 350627 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350630 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350634 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350639 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350643 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350645 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350648 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350652 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350657 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350660 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350662 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350665 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350667 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350670 */   GIR_RootConstrainSelectedInstOperands,
     /* 350671 */   // GIR_Coverage, 9048,
     /* 350671 */   GIR_EraseRootFromParent_Done,
     /* 350672 */ // Label 7068: @350672
     /* 350672 */ GIM_Try, /*On fail goto*//*Label 7069*/ GIMT_Encode4(350760), // Rule ID 9057 //
     /* 350677 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350680 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350687 */   // MIs[0] Operand 2
     /* 350687 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 350698 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350698 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350701 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350705 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350710 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350714 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350716 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350719 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350723 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350728 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350731 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350733 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350736 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350740 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350745 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350748 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350750 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350753 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350755 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350758 */   GIR_RootConstrainSelectedInstOperands,
     /* 350759 */   // GIR_Coverage, 9057,
     /* 350759 */   GIR_EraseRootFromParent_Done,
     /* 350760 */ // Label 7069: @350760
     /* 350760 */ GIM_Try, /*On fail goto*//*Label 7070*/ GIMT_Encode4(350848), // Rule ID 9058 //
     /* 350765 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350768 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350775 */   // MIs[0] Operand 2
     /* 350775 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(1),
     /* 350786 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 1:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350786 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350789 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350793 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350798 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350802 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350804 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350807 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350811 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350816 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350819 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350821 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350824 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350828 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350833 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350836 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350838 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350841 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350843 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350846 */   GIR_RootConstrainSelectedInstOperands,
     /* 350847 */   // GIR_Coverage, 9058,
     /* 350847 */   GIR_EraseRootFromParent_Done,
     /* 350848 */ // Label 7070: @350848
     /* 350848 */ GIM_Try, /*On fail goto*//*Label 7071*/ GIMT_Encode4(350936), // Rule ID 9059 //
     /* 350853 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350856 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350863 */   // MIs[0] Operand 2
     /* 350863 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 350874 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350874 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350877 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350881 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350886 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350890 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350892 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350895 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350899 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350904 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350909 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 350912 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 350916 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350921 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 350924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 350926 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350929 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 350931 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 350934 */   GIR_RootConstrainSelectedInstOperands,
     /* 350935 */   // GIR_Coverage, 9059,
     /* 350935 */   GIR_EraseRootFromParent_Done,
     /* 350936 */ // Label 7071: @350936
     /* 350936 */ GIM_Try, /*On fail goto*//*Label 7072*/ GIMT_Encode4(351024), // Rule ID 9060 //
     /* 350941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 350944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 350947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 350951 */   // MIs[0] Operand 2
     /* 350951 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(3),
     /* 350962 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 3:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 350962 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 350965 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350969 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350974 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 350978 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 350980 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 350983 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 350987 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 350992 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 350995 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 350997 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351000 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351004 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351009 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351014 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351017 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351019 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351022 */   GIR_RootConstrainSelectedInstOperands,
     /* 351023 */   // GIR_Coverage, 9060,
     /* 351023 */   GIR_EraseRootFromParent_Done,
     /* 351024 */ // Label 7072: @351024
     /* 351024 */ GIM_Try, /*On fail goto*//*Label 7073*/ GIMT_Encode4(351112), // Rule ID 9061 //
     /* 351029 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351032 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351035 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351039 */   // MIs[0] Operand 2
     /* 351039 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 351050 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351050 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351053 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351057 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351062 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351066 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351068 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351071 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351075 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351080 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351083 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351085 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351088 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351092 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351097 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351107 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351110 */   GIR_RootConstrainSelectedInstOperands,
     /* 351111 */   // GIR_Coverage, 9061,
     /* 351111 */   GIR_EraseRootFromParent_Done,
     /* 351112 */ // Label 7073: @351112
     /* 351112 */ GIM_Try, /*On fail goto*//*Label 7074*/ GIMT_Encode4(351200), // Rule ID 9062 //
     /* 351117 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351120 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351123 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351127 */   // MIs[0] Operand 2
     /* 351127 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(5),
     /* 351138 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 5:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351138 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351141 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351145 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351150 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351154 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351156 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351159 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351163 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351168 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351171 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351173 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351176 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351180 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351185 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351188 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351190 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351193 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351195 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351198 */   GIR_RootConstrainSelectedInstOperands,
     /* 351199 */   // GIR_Coverage, 9062,
     /* 351199 */   GIR_EraseRootFromParent_Done,
     /* 351200 */ // Label 7074: @351200
     /* 351200 */ GIM_Try, /*On fail goto*//*Label 7075*/ GIMT_Encode4(351288), // Rule ID 9063 //
     /* 351205 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351208 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351211 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351215 */   // MIs[0] Operand 2
     /* 351215 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 351226 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351226 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351229 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351233 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351238 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351242 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351244 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351247 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351251 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351256 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351259 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351261 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351264 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351268 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351273 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351283 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351286 */   GIR_RootConstrainSelectedInstOperands,
     /* 351287 */   // GIR_Coverage, 9063,
     /* 351287 */   GIR_EraseRootFromParent_Done,
     /* 351288 */ // Label 7075: @351288
     /* 351288 */ GIM_Try, /*On fail goto*//*Label 7076*/ GIMT_Encode4(351376), // Rule ID 9064 //
     /* 351293 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351296 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351303 */   // MIs[0] Operand 2
     /* 351303 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 351314 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 7:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351314 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351317 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351321 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351326 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351330 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351332 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351335 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351339 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351344 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351347 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351349 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351352 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351356 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351361 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351364 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351366 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351369 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351371 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351374 */   GIR_RootConstrainSelectedInstOperands,
     /* 351375 */   // GIR_Coverage, 9064,
     /* 351375 */   GIR_EraseRootFromParent_Done,
     /* 351376 */ // Label 7076: @351376
     /* 351376 */ GIM_Try, /*On fail goto*//*Label 7077*/ GIMT_Encode4(351464), // Rule ID 9065 //
     /* 351381 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351391 */   // MIs[0] Operand 2
     /* 351391 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 351402 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351402 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351405 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351409 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351414 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351418 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351420 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351423 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351427 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351432 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351435 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351449 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351452 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351454 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351457 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351459 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351462 */   GIR_RootConstrainSelectedInstOperands,
     /* 351463 */   // GIR_Coverage, 9065,
     /* 351463 */   GIR_EraseRootFromParent_Done,
     /* 351464 */ // Label 7077: @351464
     /* 351464 */ GIM_Try, /*On fail goto*//*Label 7078*/ GIMT_Encode4(351552), // Rule ID 9066 //
     /* 351469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351475 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351479 */   // MIs[0] Operand 2
     /* 351479 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(9),
     /* 351490 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 9:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351490 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351493 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351497 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351502 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351506 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351508 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351511 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351515 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351520 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351523 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351525 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351528 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351532 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351537 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351540 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351542 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351545 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351547 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351550 */   GIR_RootConstrainSelectedInstOperands,
     /* 351551 */   // GIR_Coverage, 9066,
     /* 351551 */   GIR_EraseRootFromParent_Done,
     /* 351552 */ // Label 7078: @351552
     /* 351552 */ GIM_Try, /*On fail goto*//*Label 7079*/ GIMT_Encode4(351640), // Rule ID 9067 //
     /* 351557 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351560 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351563 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351567 */   // MIs[0] Operand 2
     /* 351567 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 351578 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351578 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351581 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351585 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351590 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351594 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351596 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351599 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351603 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351608 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351611 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351613 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351616 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351620 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351625 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351628 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351630 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351633 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351635 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351638 */   GIR_RootConstrainSelectedInstOperands,
     /* 351639 */   // GIR_Coverage, 9067,
     /* 351639 */   GIR_EraseRootFromParent_Done,
     /* 351640 */ // Label 7079: @351640
     /* 351640 */ GIM_Try, /*On fail goto*//*Label 7080*/ GIMT_Encode4(351728), // Rule ID 9068 //
     /* 351645 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351648 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351651 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351655 */   // MIs[0] Operand 2
     /* 351655 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(11),
     /* 351666 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 11:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351666 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351669 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351673 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351678 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351682 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351684 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351687 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351691 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351696 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351699 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351701 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351704 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351708 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351713 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351716 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351723 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351726 */   GIR_RootConstrainSelectedInstOperands,
     /* 351727 */   // GIR_Coverage, 9068,
     /* 351727 */   GIR_EraseRootFromParent_Done,
     /* 351728 */ // Label 7080: @351728
     /* 351728 */ GIM_Try, /*On fail goto*//*Label 7081*/ GIMT_Encode4(351816), // Rule ID 9069 //
     /* 351733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351739 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351743 */   // MIs[0] Operand 2
     /* 351743 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 351754 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351754 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351757 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351761 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351766 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351770 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351772 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351775 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351779 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351784 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351787 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351801 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351804 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351806 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351809 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351811 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351814 */   GIR_RootConstrainSelectedInstOperands,
     /* 351815 */   // GIR_Coverage, 9069,
     /* 351815 */   GIR_EraseRootFromParent_Done,
     /* 351816 */ // Label 7081: @351816
     /* 351816 */ GIM_Try, /*On fail goto*//*Label 7082*/ GIMT_Encode4(351904), // Rule ID 9070 //
     /* 351821 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351824 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351827 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351831 */   // MIs[0] Operand 2
     /* 351831 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(13),
     /* 351842 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 13:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351842 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351845 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351849 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351854 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351860 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351863 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351867 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351872 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351875 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351877 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351880 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351884 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351889 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351892 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351894 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351897 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351899 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351902 */   GIR_RootConstrainSelectedInstOperands,
     /* 351903 */   // GIR_Coverage, 9070,
     /* 351903 */   GIR_EraseRootFromParent_Done,
     /* 351904 */ // Label 7082: @351904
     /* 351904 */ GIM_Try, /*On fail goto*//*Label 7083*/ GIMT_Encode4(351992), // Rule ID 9071 //
     /* 351909 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 351912 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 351915 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 351919 */   // MIs[0] Operand 2
     /* 351919 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 351930 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 351930 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 351933 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351937 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351942 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 351946 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 351948 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 351951 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351955 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351960 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 351963 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 351965 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 351968 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 351972 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 351977 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 351980 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 351982 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 351985 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 351987 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 351990 */   GIR_RootConstrainSelectedInstOperands,
     /* 351991 */   // GIR_Coverage, 9071,
     /* 351991 */   GIR_EraseRootFromParent_Done,
     /* 351992 */ // Label 7083: @351992
     /* 351992 */ GIM_Try, /*On fail goto*//*Label 7084*/ GIMT_Encode4(352080), // Rule ID 9072 //
     /* 351997 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352007 */   // MIs[0] Operand 2
     /* 352007 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 352018 */   // (extract_subvector:{ *:[nxv1i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 15:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))))
     /* 352018 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv1s1,
     /* 352021 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352025 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352030 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352034 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 352036 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352039 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352043 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352048 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 352051 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352065 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352068 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352075 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352078 */   GIR_RootConstrainSelectedInstOperands,
     /* 352079 */   // GIR_Coverage, 9072,
     /* 352079 */   GIR_EraseRootFromParent_Done,
     /* 352080 */ // Label 7084: @352080
     /* 352080 */ GIM_Reject,
     /* 352081 */ // Label 7020: @352081
     /* 352081 */ GIM_Try, /*On fail goto*//*Label 7085*/ GIMT_Encode4(352116), // Rule ID 9023 //
     /* 352086 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 352092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352096 */   // MIs[0] Operand 2
     /* 352096 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352107 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 352107 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352110 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352112 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352114 */   GIR_RootConstrainSelectedInstOperands,
     /* 352115 */   // GIR_Coverage, 9023,
     /* 352115 */   GIR_EraseRootFromParent_Done,
     /* 352116 */ // Label 7085: @352116
     /* 352116 */ GIM_Try, /*On fail goto*//*Label 7086*/ GIMT_Encode4(352151), // Rule ID 9024 //
     /* 352121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 352127 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352131 */   // MIs[0] Operand 2
     /* 352131 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352142 */   // (extract_subvector:{ *:[nxv2i1] } nxv4i1:{ *:[nxv4i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } PPR:{ *:[nxv4i1] }:$Ps)
     /* 352142 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352145 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352147 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 352149 */   GIR_RootConstrainSelectedInstOperands,
     /* 352150 */   // GIR_Coverage, 9024,
     /* 352150 */   GIR_EraseRootFromParent_Done,
     /* 352151 */ // Label 7086: @352151
     /* 352151 */ GIM_Try, /*On fail goto*//*Label 7087*/ GIMT_Encode4(352205), // Rule ID 9033 //
     /* 352156 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352159 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352162 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352166 */   // MIs[0] Operand 2
     /* 352166 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352177 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352177 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352180 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352184 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352189 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352193 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352200 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352203 */   GIR_RootConstrainSelectedInstOperands,
     /* 352204 */   // GIR_Coverage, 9033,
     /* 352204 */   GIR_EraseRootFromParent_Done,
     /* 352205 */ // Label 7087: @352205
     /* 352205 */ GIM_Try, /*On fail goto*//*Label 7088*/ GIMT_Encode4(352259), // Rule ID 9034 //
     /* 352210 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352220 */   // MIs[0] Operand 2
     /* 352220 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352231 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352231 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352234 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352238 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352243 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352247 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352249 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352252 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352254 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352257 */   GIR_RootConstrainSelectedInstOperands,
     /* 352258 */   // GIR_Coverage, 9034,
     /* 352258 */   GIR_EraseRootFromParent_Done,
     /* 352259 */ // Label 7088: @352259
     /* 352259 */ GIM_Try, /*On fail goto*//*Label 7089*/ GIMT_Encode4(352313), // Rule ID 9035 //
     /* 352264 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352270 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352274 */   // MIs[0] Operand 2
     /* 352274 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352285 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352285 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352288 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352292 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352297 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352301 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352303 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352306 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352308 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352311 */   GIR_RootConstrainSelectedInstOperands,
     /* 352312 */   // GIR_Coverage, 9035,
     /* 352312 */   GIR_EraseRootFromParent_Done,
     /* 352313 */ // Label 7089: @352313
     /* 352313 */ GIM_Try, /*On fail goto*//*Label 7090*/ GIMT_Encode4(352367), // Rule ID 9036 //
     /* 352318 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352321 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 352324 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352328 */   // MIs[0] Operand 2
     /* 352328 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352339 */   // (extract_subvector:{ *:[nxv2i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv8i1] }:$Ps))
     /* 352339 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352342 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352346 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352351 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352355 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352357 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352360 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352362 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352365 */   GIR_RootConstrainSelectedInstOperands,
     /* 352366 */   // GIR_Coverage, 9036,
     /* 352366 */   GIR_EraseRootFromParent_Done,
     /* 352367 */ // Label 7090: @352367
     /* 352367 */ GIM_Try, /*On fail goto*//*Label 7091*/ GIMT_Encode4(352438), // Rule ID 9049 //
     /* 352372 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352375 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352382 */   // MIs[0] Operand 2
     /* 352382 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352393 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352393 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352396 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352400 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352405 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352409 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352411 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352414 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352418 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352423 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352426 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352428 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352431 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352433 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352436 */   GIR_RootConstrainSelectedInstOperands,
     /* 352437 */   // GIR_Coverage, 9049,
     /* 352437 */   GIR_EraseRootFromParent_Done,
     /* 352438 */ // Label 7091: @352438
     /* 352438 */ GIM_Try, /*On fail goto*//*Label 7092*/ GIMT_Encode4(352509), // Rule ID 9050 //
     /* 352443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352453 */   // MIs[0] Operand 2
     /* 352453 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352464 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 2:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352464 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352467 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352471 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352476 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352480 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352482 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352485 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352489 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352494 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352497 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352499 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352502 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352504 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352507 */   GIR_RootConstrainSelectedInstOperands,
     /* 352508 */   // GIR_Coverage, 9050,
     /* 352508 */   GIR_EraseRootFromParent_Done,
     /* 352509 */ // Label 7092: @352509
     /* 352509 */ GIM_Try, /*On fail goto*//*Label 7093*/ GIMT_Encode4(352580), // Rule ID 9051 //
     /* 352514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352520 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352524 */   // MIs[0] Operand 2
     /* 352524 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 352535 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352535 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352538 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352542 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352547 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352551 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352553 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352556 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352560 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352565 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352568 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352570 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352573 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352575 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352578 */   GIR_RootConstrainSelectedInstOperands,
     /* 352579 */   // GIR_Coverage, 9051,
     /* 352579 */   GIR_EraseRootFromParent_Done,
     /* 352580 */ // Label 7093: @352580
     /* 352580 */ GIM_Try, /*On fail goto*//*Label 7094*/ GIMT_Encode4(352651), // Rule ID 9052 //
     /* 352585 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352595 */   // MIs[0] Operand 2
     /* 352595 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 352606 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 6:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352606 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352609 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352613 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352618 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352622 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352624 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352627 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352631 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352636 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352639 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352641 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352644 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352646 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352649 */   GIR_RootConstrainSelectedInstOperands,
     /* 352650 */   // GIR_Coverage, 9052,
     /* 352650 */   GIR_EraseRootFromParent_Done,
     /* 352651 */ // Label 7094: @352651
     /* 352651 */ GIM_Try, /*On fail goto*//*Label 7095*/ GIMT_Encode4(352722), // Rule ID 9053 //
     /* 352656 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352666 */   // MIs[0] Operand 2
     /* 352666 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 352677 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352677 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352680 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352684 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352689 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352695 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352698 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352702 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352707 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352710 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352712 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352715 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352717 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352720 */   GIR_RootConstrainSelectedInstOperands,
     /* 352721 */   // GIR_Coverage, 9053,
     /* 352721 */   GIR_EraseRootFromParent_Done,
     /* 352722 */ // Label 7095: @352722
     /* 352722 */ GIM_Try, /*On fail goto*//*Label 7096*/ GIMT_Encode4(352793), // Rule ID 9054 //
     /* 352727 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352730 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352733 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352737 */   // MIs[0] Operand 2
     /* 352737 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(10),
     /* 352748 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 10:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKLO_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352748 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352751 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352755 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352760 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352764 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352766 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352769 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352773 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352778 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352781 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352783 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352786 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352788 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352791 */   GIR_RootConstrainSelectedInstOperands,
     /* 352792 */   // GIR_Coverage, 9054,
     /* 352792 */   GIR_EraseRootFromParent_Done,
     /* 352793 */ // Label 7096: @352793
     /* 352793 */ GIM_Try, /*On fail goto*//*Label 7097*/ GIMT_Encode4(352864), // Rule ID 9055 //
     /* 352798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352804 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352808 */   // MIs[0] Operand 2
     /* 352808 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 352819 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352819 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352822 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352826 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352831 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352835 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352837 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352840 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352844 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352849 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352852 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352854 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 352857 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352859 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352862 */   GIR_RootConstrainSelectedInstOperands,
     /* 352863 */   // GIR_Coverage, 9055,
     /* 352863 */   GIR_EraseRootFromParent_Done,
     /* 352864 */ // Label 7097: @352864
     /* 352864 */ GIM_Try, /*On fail goto*//*Label 7098*/ GIMT_Encode4(352935), // Rule ID 9056 //
     /* 352869 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352872 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 352875 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 352879 */   // MIs[0] Operand 2
     /* 352879 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(14),
     /* 352890 */   // (extract_subvector:{ *:[nxv2i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 14:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv2i1] } (PUNPKHI_PP:{ *:[nxv1i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps)))
     /* 352890 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 352893 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352897 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352902 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 352906 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 352908 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 352911 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352915 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 352920 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 352923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 352925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 352928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 352930 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 352933 */   GIR_RootConstrainSelectedInstOperands,
     /* 352934 */   // GIR_Coverage, 9056,
     /* 352934 */   GIR_EraseRootFromParent_Done,
     /* 352935 */ // Label 7098: @352935
     /* 352935 */ GIM_Reject,
     /* 352936 */ // Label 7021: @352936
     /* 352936 */ GIM_Try, /*On fail goto*//*Label 7099*/ GIMT_Encode4(352971), // Rule ID 9073 //
     /* 352941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352951 */   // MIs[0] Operand 2
     /* 352951 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 352962 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352962 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 352965 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 352967 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 352969 */   GIR_RootConstrainSelectedInstOperands,
     /* 352970 */   // GIR_Coverage, 9073,
     /* 352970 */   GIR_EraseRootFromParent_Done,
     /* 352971 */ // Label 7099: @352971
     /* 352971 */ GIM_Try, /*On fail goto*//*Label 7100*/ GIMT_Encode4(353006), // Rule ID 9074 //
     /* 352976 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 352979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 352982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 352986 */   // MIs[0] Operand 2
     /* 352986 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 352997 */   // (extract_subvector:{ *:[nxv2f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$Zs)
     /* 352997 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353000 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353002 */   GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353004 */   GIR_RootConstrainSelectedInstOperands,
     /* 353005 */   // GIR_Coverage, 9074,
     /* 353005 */   GIR_EraseRootFromParent_Done,
     /* 353006 */ // Label 7100: @353006
     /* 353006 */ GIM_Try, /*On fail goto*//*Label 7101*/ GIMT_Encode4(353060), // Rule ID 9079 //
     /* 353011 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353021 */   // MIs[0] Operand 2
     /* 353021 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353032 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353032 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353035 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353039 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353044 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353048 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353050 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353053 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353055 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353058 */   GIR_RootConstrainSelectedInstOperands,
     /* 353059 */   // GIR_Coverage, 9079,
     /* 353059 */   GIR_EraseRootFromParent_Done,
     /* 353060 */ // Label 7101: @353060
     /* 353060 */ GIM_Try, /*On fail goto*//*Label 7102*/ GIMT_Encode4(353114), // Rule ID 9080 //
     /* 353065 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353068 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353075 */   // MIs[0] Operand 2
     /* 353075 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353086 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKLO_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353086 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353089 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353093 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353098 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353102 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353104 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353107 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353109 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353112 */   GIR_RootConstrainSelectedInstOperands,
     /* 353113 */   // GIR_Coverage, 9080,
     /* 353113 */   GIR_EraseRootFromParent_Done,
     /* 353114 */ // Label 7102: @353114
     /* 353114 */ GIM_Try, /*On fail goto*//*Label 7103*/ GIMT_Encode4(353168), // Rule ID 9081 //
     /* 353119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353129 */   // MIs[0] Operand 2
     /* 353129 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353140 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353140 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353143 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353147 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353152 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353156 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353158 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353161 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353163 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353166 */   GIR_RootConstrainSelectedInstOperands,
     /* 353167 */   // GIR_Coverage, 9081,
     /* 353167 */   GIR_EraseRootFromParent_Done,
     /* 353168 */ // Label 7103: @353168
     /* 353168 */ GIM_Try, /*On fail goto*//*Label 7104*/ GIMT_Encode4(353222), // Rule ID 9082 //
     /* 353173 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353176 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353183 */   // MIs[0] Operand 2
     /* 353183 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(6),
     /* 353194 */   // (extract_subvector:{ *:[nxv2f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 6:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f16] } (UUNPKHI_ZZ_S:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$Zs))
     /* 353194 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 353197 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353201 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353206 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Zs
     /* 353210 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353212 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353215 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353217 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353220 */   GIR_RootConstrainSelectedInstOperands,
     /* 353221 */   // GIR_Coverage, 9082,
     /* 353221 */   GIR_EraseRootFromParent_Done,
     /* 353222 */ // Label 7104: @353222
     /* 353222 */ GIM_Reject,
     /* 353223 */ // Label 7022: @353223
     /* 353223 */ GIM_Try, /*On fail goto*//*Label 7105*/ GIMT_Encode4(353292),
     /* 353228 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 353231 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353235 */   GIM_Try, /*On fail goto*//*Label 7106*/ GIMT_Encode4(353263), // Rule ID 9077 //
     /* 353240 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353243 */     // MIs[0] Operand 2
     /* 353243 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353254 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 353254 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_D),
     /* 353257 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353259 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353261 */     GIR_RootConstrainSelectedInstOperands,
     /* 353262 */     // GIR_Coverage, 9077,
     /* 353262 */     GIR_EraseRootFromParent_Done,
     /* 353263 */   // Label 7106: @353263
     /* 353263 */   GIM_Try, /*On fail goto*//*Label 7107*/ GIMT_Encode4(353291), // Rule ID 9078 //
     /* 353268 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353271 */     // MIs[0] Operand 2
     /* 353271 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(2),
     /* 353282 */     // (extract_subvector:{ *:[nxv2f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 2:{ *:[i64] })  =>  (UUNPKHI_ZZ_D:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$Zs)
     /* 353282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_D),
     /* 353285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353287 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353289 */     GIR_RootConstrainSelectedInstOperands,
     /* 353290 */     // GIR_Coverage, 9078,
     /* 353290 */     GIR_EraseRootFromParent_Done,
     /* 353291 */   // Label 7107: @353291
     /* 353291 */   GIM_Reject,
     /* 353292 */ // Label 7105: @353292
     /* 353292 */ GIM_Reject,
     /* 353293 */ // Label 7023: @353293
     /* 353293 */ GIM_Try, /*On fail goto*//*Label 7108*/ GIMT_Encode4(353328), // Rule ID 9025 //
     /* 353298 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353301 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353304 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353308 */   // MIs[0] Operand 2
     /* 353308 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353319 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 353319 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353322 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353324 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353326 */   GIR_RootConstrainSelectedInstOperands,
     /* 353327 */   // GIR_Coverage, 9025,
     /* 353327 */   GIR_EraseRootFromParent_Done,
     /* 353328 */ // Label 7108: @353328
     /* 353328 */ GIM_Try, /*On fail goto*//*Label 7109*/ GIMT_Encode4(353363), // Rule ID 9026 //
     /* 353333 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353336 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 353339 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353343 */   // MIs[0] Operand 2
     /* 353343 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353354 */   // (extract_subvector:{ *:[nxv4i1] } nxv8i1:{ *:[nxv8i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } PPR:{ *:[nxv8i1] }:$Ps)
     /* 353354 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353357 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353359 */   GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353361 */   GIR_RootConstrainSelectedInstOperands,
     /* 353362 */   // GIR_Coverage, 9026,
     /* 353362 */   GIR_EraseRootFromParent_Done,
     /* 353363 */ // Label 7109: @353363
     /* 353363 */ GIM_Try, /*On fail goto*//*Label 7110*/ GIMT_Encode4(353417), // Rule ID 9037 //
     /* 353368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353378 */   // MIs[0] Operand 2
     /* 353378 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353389 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353389 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353392 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353396 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353401 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353405 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353412 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353415 */   GIR_RootConstrainSelectedInstOperands,
     /* 353416 */   // GIR_Coverage, 9037,
     /* 353416 */   GIR_EraseRootFromParent_Done,
     /* 353417 */ // Label 7110: @353417
     /* 353417 */ GIM_Try, /*On fail goto*//*Label 7111*/ GIMT_Encode4(353471), // Rule ID 9038 //
     /* 353422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353432 */   // MIs[0] Operand 2
     /* 353432 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353443 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 4:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKLO_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353443 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353446 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353450 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353455 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353459 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353461 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353464 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353466 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353469 */   GIR_RootConstrainSelectedInstOperands,
     /* 353470 */   // GIR_Coverage, 9038,
     /* 353470 */   GIR_EraseRootFromParent_Done,
     /* 353471 */ // Label 7111: @353471
     /* 353471 */ GIM_Try, /*On fail goto*//*Label 7112*/ GIMT_Encode4(353525), // Rule ID 9039 //
     /* 353476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353482 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353486 */   // MIs[0] Operand 2
     /* 353486 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353497 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353497 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353500 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353504 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353509 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353513 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353515 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353518 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353520 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353523 */   GIR_RootConstrainSelectedInstOperands,
     /* 353524 */   // GIR_Coverage, 9039,
     /* 353524 */   GIR_EraseRootFromParent_Done,
     /* 353525 */ // Label 7112: @353525
     /* 353525 */ GIM_Try, /*On fail goto*//*Label 7113*/ GIMT_Encode4(353579), // Rule ID 9040 //
     /* 353530 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353533 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353540 */   // MIs[0] Operand 2
     /* 353540 */   GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(12),
     /* 353551 */   // (extract_subvector:{ *:[nxv4i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 12:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv4i1] } (PUNPKHI_PP:{ *:[nxv1i1] } PPR:{ *:[nxv16i1] }:$Ps))
     /* 353551 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 353554 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353558 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353563 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Ps
     /* 353567 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353569 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353572 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353574 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 353577 */   GIR_RootConstrainSelectedInstOperands,
     /* 353578 */   // GIR_Coverage, 9040,
     /* 353578 */   GIR_EraseRootFromParent_Done,
     /* 353579 */ // Label 7113: @353579
     /* 353579 */ GIM_Reject,
     /* 353580 */ // Label 7024: @353580
     /* 353580 */ GIM_Try, /*On fail goto*//*Label 7114*/ GIMT_Encode4(353649),
     /* 353585 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 353588 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 353592 */   GIM_Try, /*On fail goto*//*Label 7115*/ GIMT_Encode4(353620), // Rule ID 9075 //
     /* 353597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353600 */     // MIs[0] Operand 2
     /* 353600 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353611 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (UUNPKLO_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 353611 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKLO_ZZ_S),
     /* 353614 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353616 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353618 */     GIR_RootConstrainSelectedInstOperands,
     /* 353619 */     // GIR_Coverage, 9075,
     /* 353619 */     GIR_EraseRootFromParent_Done,
     /* 353620 */   // Label 7115: @353620
     /* 353620 */   GIM_Try, /*On fail goto*//*Label 7116*/ GIMT_Encode4(353648), // Rule ID 9076 //
     /* 353625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353628 */     // MIs[0] Operand 2
     /* 353628 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(4),
     /* 353639 */     // (extract_subvector:{ *:[nxv4f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 4:{ *:[i64] })  =>  (UUNPKHI_ZZ_S:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$Zs)
     /* 353639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UUNPKHI_ZZ_S),
     /* 353642 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 353644 */     GIR_RootToRootCopy, /*OpIdx*/1, // Zs
     /* 353646 */     GIR_RootConstrainSelectedInstOperands,
     /* 353647 */     // GIR_Coverage, 9076,
     /* 353647 */     GIR_EraseRootFromParent_Done,
     /* 353648 */   // Label 7116: @353648
     /* 353648 */   GIM_Reject,
     /* 353649 */ // Label 7114: @353649
     /* 353649 */ GIM_Reject,
     /* 353650 */ // Label 7025: @353650
     /* 353650 */ GIM_Try, /*On fail goto*//*Label 7117*/ GIMT_Encode4(353719),
     /* 353655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 353658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 353662 */   GIM_Try, /*On fail goto*//*Label 7118*/ GIMT_Encode4(353690), // Rule ID 9027 //
     /* 353667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353670 */     // MIs[0] Operand 2
     /* 353670 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(0),
     /* 353681 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 0:{ *:[i64] })  =>  (PUNPKLO_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 353681 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKLO_PP),
     /* 353684 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353686 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353688 */     GIR_RootConstrainSelectedInstOperands,
     /* 353689 */     // GIR_Coverage, 9027,
     /* 353689 */     GIR_EraseRootFromParent_Done,
     /* 353690 */   // Label 7118: @353690
     /* 353690 */   GIM_Try, /*On fail goto*//*Label 7119*/ GIMT_Encode4(353718), // Rule ID 9028 //
     /* 353695 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 353698 */     // MIs[0] Operand 2
     /* 353698 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(8),
     /* 353709 */     // (extract_subvector:{ *:[nxv8i1] } nxv16i1:{ *:[nxv16i1] }:$Ps, 8:{ *:[i64] })  =>  (PUNPKHI_PP:{ *:[nxv8i1] } PPR:{ *:[nxv16i1] }:$Ps)
     /* 353709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PUNPKHI_PP),
     /* 353712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Pd]
     /* 353714 */     GIR_RootToRootCopy, /*OpIdx*/1, // Ps
     /* 353716 */     GIR_RootConstrainSelectedInstOperands,
     /* 353717 */     // GIR_Coverage, 9028,
     /* 353717 */     GIR_EraseRootFromParent_Done,
     /* 353718 */   // Label 7119: @353718
     /* 353718 */   GIM_Reject,
     /* 353719 */ // Label 7117: @353719
     /* 353719 */ GIM_Reject,
     /* 353720 */ // Label 7026: @353720
     /* 353720 */ GIM_Reject,
     /* 353721 */ // Label 90: @353721
     /* 353721 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 7135*/ GIMT_Encode4(386642),
     /* 353732 */ /*GILLT_s64*//*Label 7120*/ GIMT_Encode4(353816), GIMT_Encode4(0),
     /* 353740 */ /*GILLT_v2s32*//*Label 7121*/ GIMT_Encode4(354526),
     /* 353744 */ /*GILLT_v2s64*//*Label 7122*/ GIMT_Encode4(358057),
     /* 353748 */ /*GILLT_v4s16*//*Label 7123*/ GIMT_Encode4(361298),
     /* 353752 */ /*GILLT_v4s32*//*Label 7124*/ GIMT_Encode4(364938),
     /* 353756 */ /*GILLT_v8s8*//*Label 7125*/ GIMT_Encode4(368006),
     /* 353760 */ /*GILLT_v8s16*//*Label 7126*/ GIMT_Encode4(371219),
     /* 353764 */ /*GILLT_v16s8*//*Label 7127*/ GIMT_Encode4(374638), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 353776 */ /*GILLT_nxv2s16*//*Label 7128*/ GIMT_Encode4(377842),
     /* 353780 */ /*GILLT_nxv2s32*//*Label 7129*/ GIMT_Encode4(377967),
     /* 353784 */ /*GILLT_nxv2s64*//*Label 7130*/ GIMT_Encode4(378092), GIMT_Encode4(0),
     /* 353792 */ /*GILLT_nxv4s16*//*Label 7131*/ GIMT_Encode4(380070),
     /* 353796 */ /*GILLT_nxv4s32*//*Label 7132*/ GIMT_Encode4(380222), GIMT_Encode4(0),
     /* 353804 */ /*GILLT_nxv8s16*//*Label 7133*/ GIMT_Encode4(382254), GIMT_Encode4(0),
     /* 353812 */ /*GILLT_nxv16s8*//*Label 7134*/ GIMT_Encode4(384522),
     /* 353816 */ // Label 7120: @353816
     /* 353816 */ GIM_Try, /*On fail goto*//*Label 7136*/ GIMT_Encode4(354525),
     /* 353821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 353824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 353827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 353830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353834 */   GIM_Try, /*On fail goto*//*Label 7137*/ GIMT_Encode4(353964), // Rule ID 5750 //
     /* 353839 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353843 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353847 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353851 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 353855 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353859 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353864 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353868 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353872 */     // MIs[2] Operand 1
     /* 353872 */     // No operand predicates
     /* 353872 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 353876 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 353880 */     // MIs[3] Operand 1
     /* 353880 */     // No operand predicates
     /* 353880 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 353882 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 353882 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 353885 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 353889 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353894 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 353897 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 353901 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 353904 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353909 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353914 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 353917 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 353921 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 353926 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 353929 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 353932 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 353936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 353939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 353941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 353944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 353946 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 353953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 353963 */     // GIR_Coverage, 5750,
     /* 353963 */     GIR_EraseRootFromParent_Done,
     /* 353964 */   // Label 7137: @353964
     /* 353964 */   GIM_Try, /*On fail goto*//*Label 7138*/ GIMT_Encode4(354125), // Rule ID 5751 //
     /* 353969 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353973 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 353977 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 353981 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 353985 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 353989 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 353994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 353998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354002 */     // MIs[2] Operand 1
     /* 354002 */     // No operand predicates
     /* 354002 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354006 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354010 */     // MIs[3] Operand 1
     /* 354010 */     // No operand predicates
     /* 354010 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354012 */     // (vector_insert:{ *:[v1f64] } V64:{ *:[v1f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354012 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 354015 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354019 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354024 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354027 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354031 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 354034 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354039 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354044 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 354047 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354051 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354056 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354059 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354063 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354066 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354071 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354088 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354091 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354094 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354097 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354100 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354102 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354105 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354107 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354114 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354119 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354124 */     // GIR_Coverage, 5751,
     /* 354124 */     GIR_EraseRootFromParent_Done,
     /* 354125 */   // Label 7138: @354125
     /* 354125 */   GIM_Try, /*On fail goto*//*Label 7139*/ GIMT_Encode4(354255), // Rule ID 5790 //
     /* 354130 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354134 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354138 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354142 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 354146 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354150 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354155 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354159 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354163 */     // MIs[2] Operand 1
     /* 354163 */     // No operand predicates
     /* 354163 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354167 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354171 */     // MIs[3] Operand 1
     /* 354171 */     // No operand predicates
     /* 354171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354173 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 354176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354185 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354188 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354192 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354195 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354200 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354217 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354223 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354227 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354230 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354232 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354235 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354237 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354249 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354254 */     // GIR_Coverage, 5790,
     /* 354254 */     GIR_EraseRootFromParent_Done,
     /* 354255 */   // Label 7139: @354255
     /* 354255 */   GIM_Try, /*On fail goto*//*Label 7140*/ GIMT_Encode4(354416), // Rule ID 5791 //
     /* 354260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 354268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 354272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 354276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 354280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 354289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354293 */     // MIs[2] Operand 1
     /* 354293 */     // No operand predicates
     /* 354293 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 354297 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 354301 */     // MIs[3] Operand 1
     /* 354301 */     // No operand predicates
     /* 354301 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 354303 */     // (vector_insert:{ *:[v1i64] } V64:{ *:[v1i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (INSvi64lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 354303 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 354306 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354310 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354315 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 354318 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 354322 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 354325 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354330 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354335 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 354338 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354342 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354347 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 354350 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 354354 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 354357 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354362 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354367 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 354370 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 354374 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354379 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 354382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 354385 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 354388 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 354391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354398 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 354405 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354410 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 354415 */     // GIR_Coverage, 5791,
     /* 354415 */     GIR_EraseRootFromParent_Done,
     /* 354416 */   // Label 7140: @354416
     /* 354416 */   GIM_Try, /*On fail goto*//*Label 7141*/ GIMT_Encode4(354452), // Rule ID 6703 //
     /* 354421 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354425 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354429 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354433 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354437 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354439 */     // (vector_insert:{ *:[v1i64] } (undef:{ *:[v1i64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 354439 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354442 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354444 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354446 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354451 */     // GIR_Coverage, 6703,
     /* 354451 */     GIR_EraseRootFromParent_Done,
     /* 354452 */   // Label 7141: @354452
     /* 354452 */   GIM_Try, /*On fail goto*//*Label 7142*/ GIMT_Encode4(354488), // Rule ID 6705 //
     /* 354457 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354461 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354465 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 354469 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354473 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354475 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), GPR64:{ *:[i64] }:$Xn, 0:{ *:[i64] })  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } GPR64:{ *:[i64] }:$Xn, FPR64:{ *:[i32] })
     /* 354475 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354478 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354480 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354487 */     // GIR_Coverage, 6705,
     /* 354487 */     GIR_EraseRootFromParent_Done,
     /* 354488 */   // Label 7142: @354488
     /* 354488 */   GIM_Try, /*On fail goto*//*Label 7143*/ GIMT_Encode4(354524), // Rule ID 6707 //
     /* 354493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354501 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354505 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354509 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 354511 */     // (vector_insert:{ *:[v1f64] } (undef:{ *:[v1f64] }), FPR64:{ *:[f64] }:$Xn, 0:{ *:[i64] })  =>  FPR64:{ *:[v1f64] }:$Xn
     /* 354511 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 354514 */     GIR_RootToRootCopy, /*OpIdx*/0, // dst
     /* 354516 */     GIR_RootToRootCopy, /*OpIdx*/2, // Xn
     /* 354518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354523 */     // GIR_Coverage, 6707,
     /* 354523 */     GIR_EraseRootFromParent_Done,
     /* 354524 */   // Label 7143: @354524
     /* 354524 */   GIM_Reject,
     /* 354525 */ // Label 7136: @354525
     /* 354525 */ GIM_Reject,
     /* 354526 */ // Label 7121: @354526
     /* 354526 */ GIM_Try, /*On fail goto*//*Label 7144*/ GIMT_Encode4(358056),
     /* 354531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 354534 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 354537 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 354540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354544 */   GIM_Try, /*On fail goto*//*Label 7145*/ GIMT_Encode4(354653), // Rule ID 4307 //
     /* 354549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354553 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354559 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354561 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354565 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354569 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354572 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354576 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354580 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354584 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354586 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354593 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354593 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354596 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354600 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354605 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354620 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354626 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354628 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354631 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354636 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354639 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354642 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354647 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354652 */     // GIR_Coverage, 4307,
     /* 354652 */     GIR_EraseRootFromParent_Done,
     /* 354653 */   // Label 7145: @354653
     /* 354653 */   GIM_Try, /*On fail goto*//*Label 7146*/ GIMT_Encode4(354762), // Rule ID 4308 //
     /* 354658 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354662 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354668 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354678 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354681 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354685 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354689 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354693 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354695 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354702 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354702 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354705 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354709 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354719 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354724 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354729 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354735 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354737 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354740 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354745 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354751 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354756 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354761 */     // GIR_Coverage, 4308,
     /* 354761 */     GIR_EraseRootFromParent_Done,
     /* 354762 */   // Label 7146: @354762
     /* 354762 */   GIM_Try, /*On fail goto*//*Label 7147*/ GIMT_Encode4(354871), // Rule ID 4415 //
     /* 354767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354771 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354777 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354779 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354783 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354787 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354790 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354794 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354798 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354802 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354804 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 354811 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354811 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354814 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 354818 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354828 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354833 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354838 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354844 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354851 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354854 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354857 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354860 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354865 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354870 */     // GIR_Coverage, 4415,
     /* 354870 */     GIR_EraseRootFromParent_Done,
     /* 354871 */   // Label 7147: @354871
     /* 354871 */   GIM_Try, /*On fail goto*//*Label 7148*/ GIMT_Encode4(354980), // Rule ID 4416 //
     /* 354876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354880 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 354886 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 354888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 354896 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 354899 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 354903 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 354907 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 354911 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 354913 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 354920 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 354920 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 354923 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 354927 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 354932 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 354937 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 354942 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 354947 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 354953 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 354955 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 354958 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 354960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 354963 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 354966 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 354969 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 354974 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 354979 */     // GIR_Coverage, 4416,
     /* 354979 */     GIR_EraseRootFromParent_Done,
     /* 354980 */   // Label 7148: @354980
     /* 354980 */   GIM_Try, /*On fail goto*//*Label 7149*/ GIMT_Encode4(355085), // Rule ID 4313 //
     /* 354985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 354989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 354993 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 354997 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355001 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355004 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355008 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355025 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355047 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355052 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355058 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355065 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355071 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355079 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355084 */     // GIR_Coverage, 4313,
     /* 355084 */     GIR_EraseRootFromParent_Done,
     /* 355085 */   // Label 7149: @355085
     /* 355085 */   GIM_Try, /*On fail goto*//*Label 7150*/ GIMT_Encode4(355190), // Rule ID 4315 //
     /* 355090 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355094 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355098 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355102 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355106 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355109 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355113 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355117 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355123 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355130 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355130 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355133 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355137 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355142 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355157 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355189 */     // GIR_Coverage, 4315,
     /* 355189 */     GIR_EraseRootFromParent_Done,
     /* 355190 */   // Label 7150: @355190
     /* 355190 */   GIM_Try, /*On fail goto*//*Label 7151*/ GIMT_Encode4(355295), // Rule ID 4421 //
     /* 355195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355203 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355207 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355211 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355214 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355218 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355222 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355226 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355228 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 355235 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355235 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355238 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 355242 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355247 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355252 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355262 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355268 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355275 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355284 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355294 */     // GIR_Coverage, 4421,
     /* 355294 */     GIR_EraseRootFromParent_Done,
     /* 355295 */   // Label 7151: @355295
     /* 355295 */   GIM_Try, /*On fail goto*//*Label 7152*/ GIMT_Encode4(355400), // Rule ID 4423 //
     /* 355300 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355304 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355308 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355312 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355316 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355319 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355323 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355327 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355331 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355333 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 355340 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 355340 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355343 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 355347 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355352 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355357 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 355362 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 355367 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355373 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355380 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355383 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355386 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355389 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355394 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355399 */     // GIR_Coverage, 4423,
     /* 355399 */     GIR_EraseRootFromParent_Done,
     /* 355400 */   // Label 7152: @355400
     /* 355400 */   GIM_Try, /*On fail goto*//*Label 7153*/ GIMT_Encode4(355504), // Rule ID 4305 //
     /* 355405 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355409 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355415 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355417 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355421 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355425 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355428 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355432 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355436 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355442 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355449 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355449 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355452 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355456 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355503 */     // GIR_Coverage, 4305,
     /* 355503 */     GIR_EraseRootFromParent_Done,
     /* 355504 */   // Label 7153: @355504
     /* 355504 */   GIM_Try, /*On fail goto*//*Label 7154*/ GIMT_Encode4(355608), // Rule ID 4306 //
     /* 355509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355553 */     // (vector_insert:{ *:[v2i32] } immAllZerosV:{ *:[v2i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355607 */     // GIR_Coverage, 4306,
     /* 355607 */     GIR_EraseRootFromParent_Done,
     /* 355608 */   // Label 7154: @355608
     /* 355608 */   GIM_Try, /*On fail goto*//*Label 7155*/ GIMT_Encode4(355712), // Rule ID 4413 //
     /* 355613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355633 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355657 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355679 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355711 */     // GIR_Coverage, 4413,
     /* 355711 */     GIR_EraseRootFromParent_Done,
     /* 355712 */   // Label 7155: @355712
     /* 355712 */   GIM_Try, /*On fail goto*//*Label 7156*/ GIMT_Encode4(355816), // Rule ID 4414 //
     /* 355717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355721 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 355727 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 355729 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355733 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355737 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355740 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355744 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355748 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355754 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355761 */     // (vector_insert:{ *:[v2f32] } immAllZerosV:{ *:[v2f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355761 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355764 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355768 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355773 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355783 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355789 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355796 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355805 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355810 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355815 */     // GIR_Coverage, 4414,
     /* 355815 */     GIR_EraseRootFromParent_Done,
     /* 355816 */   // Label 7156: @355816
     /* 355816 */   GIM_Try, /*On fail goto*//*Label 7157*/ GIMT_Encode4(355916), // Rule ID 4309 //
     /* 355821 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355825 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355837 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355844 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 355861 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 355861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 355868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355883 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 355902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 355905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 355910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 355915 */     // GIR_Coverage, 4309,
     /* 355915 */     GIR_EraseRootFromParent_Done,
     /* 355916 */   // Label 7157: @355916
     /* 355916 */   GIM_Try, /*On fail goto*//*Label 7158*/ GIMT_Encode4(356016), // Rule ID 4311 //
     /* 355921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 355925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 355929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 355933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 355937 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 355940 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 355944 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 355948 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 355952 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 355954 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 355961 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 355961 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 355964 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 355968 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 355973 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 355978 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 355983 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 355989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 355991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 355994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 355996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 355999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356015 */     // GIR_Coverage, 4311,
     /* 356015 */     GIR_EraseRootFromParent_Done,
     /* 356016 */   // Label 7158: @356016
     /* 356016 */   GIM_Try, /*On fail goto*//*Label 7159*/ GIMT_Encode4(356116), // Rule ID 4417 //
     /* 356021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356029 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356033 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356037 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356040 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356044 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356048 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356054 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 356061 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 356061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 356068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356078 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356083 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356089 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356096 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356099 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356102 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356110 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356115 */     // GIR_Coverage, 4417,
     /* 356115 */     GIR_EraseRootFromParent_Done,
     /* 356116 */   // Label 7159: @356116
     /* 356116 */   GIM_Try, /*On fail goto*//*Label 7160*/ GIMT_Encode4(356216), // Rule ID 4419 //
     /* 356121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356129 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356133 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356137 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356140 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356144 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 356148 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356152 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356154 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 356161 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 356161 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 356164 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 356168 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356173 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 356178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 356183 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356189 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356191 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356194 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356196 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 356199 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 356202 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 356205 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356210 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 356215 */     // GIR_Coverage, 4419,
     /* 356215 */     GIR_EraseRootFromParent_Done,
     /* 356216 */   // Label 7160: @356216
     /* 356216 */   GIM_Try, /*On fail goto*//*Label 7161*/ GIMT_Encode4(356336), // Rule ID 6481 //
     /* 356221 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356228 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356232 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356236 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356240 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356243 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356247 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 356254 */     // MIs[2] Rn
     /* 356254 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 356258 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356263 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356267 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356269 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i16:{ *:[f128] } (IMPLICIT_DEF:{ *:[v8i16] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356269 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 356272 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356276 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356281 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356283 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356286 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 356290 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356295 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356298 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356301 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 356305 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356311 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356313 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356316 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356318 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356325 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356330 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356335 */     // GIR_Coverage, 6481,
     /* 356335 */     GIR_EraseRootFromParent_Done,
     /* 356336 */   // Label 7161: @356336
     /* 356336 */   GIM_Try, /*On fail goto*//*Label 7162*/ GIMT_Encode4(356456), // Rule ID 6483 //
     /* 356341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 356344 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 356348 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 356352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 356356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 356360 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 356363 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 356367 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 356374 */     // MIs[2] Rn
     /* 356374 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 356378 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 356383 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 356387 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 356389 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 356389 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 356392 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 356396 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 356403 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356406 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 356410 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356415 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356418 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 356421 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 356425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 356431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356438 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356445 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356450 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356455 */     // GIR_Coverage, 6483,
     /* 356455 */     GIR_EraseRootFromParent_Done,
     /* 356456 */   // Label 7162: @356456
     /* 356456 */   GIM_Try, /*On fail goto*//*Label 7163*/ GIMT_Encode4(356586), // Rule ID 5742 //
     /* 356461 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356465 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356469 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356473 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356477 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356481 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356486 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356490 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356494 */     // MIs[2] Operand 1
     /* 356494 */     // No operand predicates
     /* 356494 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356498 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356502 */     // MIs[3] Operand 1
     /* 356502 */     // No operand predicates
     /* 356502 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356504 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356504 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356507 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356511 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356516 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356519 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356523 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356526 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356531 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356536 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356539 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356543 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356548 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356554 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356558 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356568 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356575 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356580 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356585 */     // GIR_Coverage, 5742,
     /* 356585 */     GIR_EraseRootFromParent_Done,
     /* 356586 */   // Label 7163: @356586
     /* 356586 */   GIM_Try, /*On fail goto*//*Label 7164*/ GIMT_Encode4(356747), // Rule ID 5743 //
     /* 356591 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356624 */     // MIs[2] Operand 1
     /* 356624 */     // No operand predicates
     /* 356624 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356628 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356632 */     // MIs[3] Operand 1
     /* 356632 */     // No operand predicates
     /* 356632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356634 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356634 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 356637 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356641 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356646 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356649 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356653 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 356656 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356661 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356678 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356698 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356701 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356705 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356710 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356713 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356716 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 356719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356722 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356724 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356727 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356729 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356746 */     // GIR_Coverage, 5743,
     /* 356746 */     GIR_EraseRootFromParent_Done,
     /* 356747 */   // Label 7164: @356747
     /* 356747 */   GIM_Try, /*On fail goto*//*Label 7165*/ GIMT_Encode4(356877), // Rule ID 5782 //
     /* 356752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 356768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356777 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356781 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356785 */     // MIs[2] Operand 1
     /* 356785 */     // No operand predicates
     /* 356785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356793 */     // MIs[3] Operand 1
     /* 356793 */     // No operand predicates
     /* 356793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356795 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 356798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356807 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356810 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356814 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356817 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356822 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356827 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356830 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356834 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356839 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 356842 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 356845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 356852 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 356854 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 356857 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 356859 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 356866 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356871 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356876 */     // GIR_Coverage, 5782,
     /* 356876 */     GIR_EraseRootFromParent_Done,
     /* 356877 */   // Label 7165: @356877
     /* 356877 */   GIM_Try, /*On fail goto*//*Label 7166*/ GIMT_Encode4(357038), // Rule ID 5783 //
     /* 356882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356886 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 356890 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 356894 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 356898 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 356902 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356907 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 356911 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356915 */     // MIs[2] Operand 1
     /* 356915 */     // No operand predicates
     /* 356915 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 356919 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 356923 */     // MIs[3] Operand 1
     /* 356923 */     // No operand predicates
     /* 356923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 356925 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 356925 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 356928 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356932 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356937 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 356940 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 356944 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 356947 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356952 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356957 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 356960 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 356964 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 356969 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 356972 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 356976 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 356979 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 356984 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 356989 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 356992 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 356996 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357001 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357004 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 357007 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 357010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 357013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357020 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357027 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357032 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357037 */     // GIR_Coverage, 5783,
     /* 357037 */     GIR_EraseRootFromParent_Done,
     /* 357038 */   // Label 7166: @357038
     /* 357038 */   GIM_Try, /*On fail goto*//*Label 7167*/ GIMT_Encode4(357104), // Rule ID 5689 //
     /* 357043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357051 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357055 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357059 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357061 */     // (vector_insert:{ *:[v2i32] } (undef:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i32] } (IMPLICIT_DEF:{ *:[v2i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 357061 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 357064 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357068 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357073 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357075 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357078 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357080 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357083 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357085 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357088 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357093 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357098 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357103 */     // GIR_Coverage, 5689,
     /* 357103 */     GIR_EraseRootFromParent_Done,
     /* 357104 */   // Label 7167: @357104
     /* 357104 */   GIM_Try, /*On fail goto*//*Label 7168*/ GIMT_Encode4(357170), // Rule ID 5705 //
     /* 357109 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 357113 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 357117 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357121 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 357125 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357127 */     // (vector_insert:{ *:[v2f32] } (undef:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f32] } (IMPLICIT_DEF:{ *:[v2f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 357127 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s32,
     /* 357130 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357134 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357139 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357141 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357144 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 357149 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 357151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 357154 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357159 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357164 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357169 */     // GIR_Coverage, 5705,
     /* 357169 */     GIR_EraseRootFromParent_Done,
     /* 357170 */   // Label 7168: @357170
     /* 357170 */   GIM_Try, /*On fail goto*//*Label 7169*/ GIMT_Encode4(357305), // Rule ID 5713 //
     /* 357175 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357183 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 357187 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 357191 */     // MIs[1] Operand 1
     /* 357191 */     // No operand predicates
     /* 357191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357199 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357203 */     // MIs[2] Operand 1
     /* 357203 */     // No operand predicates
     /* 357203 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357205 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 357205 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357208 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357212 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357219 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357222 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357226 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357231 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357234 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357238 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357241 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357246 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357251 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357256 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357259 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 357263 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357268 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357271 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 357274 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 357280 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357282 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357285 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357287 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357299 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357304 */     // GIR_Coverage, 5713,
     /* 357304 */     GIR_EraseRootFromParent_Done,
     /* 357305 */   // Label 7169: @357305
     /* 357305 */   GIM_Try, /*On fail goto*//*Label 7170*/ GIMT_Encode4(357437), // Rule ID 6490 //
     /* 357310 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357314 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357318 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357322 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357325 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357329 */     // MIs[1] Rn
     /* 357329 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357333 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357338 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357342 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357346 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357350 */     // MIs[2] Operand 1
     /* 357350 */     // No operand predicates
     /* 357350 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357352 */     // (vector_insert:{ *:[v2i32] } VecListOne64:{ *:[v2i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2i32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357352 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357355 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357359 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357364 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357367 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 357371 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357374 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357379 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357384 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357387 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 357391 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357396 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357399 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 357402 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357406 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357412 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357419 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357436 */     // GIR_Coverage, 6490,
     /* 357436 */     GIR_EraseRootFromParent_Done,
     /* 357437 */   // Label 7170: @357437
     /* 357437 */   GIM_Try, /*On fail goto*//*Label 7171*/ GIMT_Encode4(357569), // Rule ID 6491 //
     /* 357442 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357446 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357450 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 357454 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 357457 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 357461 */     // MIs[1] Rn
     /* 357461 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 357465 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 357470 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357474 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357478 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357482 */     // MIs[2] Operand 1
     /* 357482 */     // No operand predicates
     /* 357482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357484 */     // (vector_insert:{ *:[v2f32] } VecListOne64:{ *:[v2f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (LD1i32:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v2f32] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 357484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 357487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 357491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357496 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 357499 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 357503 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357506 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357511 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357516 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357519 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 357523 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357528 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 357534 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 357538 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 357544 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357551 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357558 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357563 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357568 */     // GIR_Coverage, 6491,
     /* 357568 */     GIR_EraseRootFromParent_Done,
     /* 357569 */   // Label 7171: @357569
     /* 357569 */   GIM_Try, /*On fail goto*//*Label 7172*/ GIMT_Encode4(357752), // Rule ID 5793 //
     /* 357574 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 357578 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 357582 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 357586 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357591 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 357595 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357599 */     // MIs[2] Operand 1
     /* 357599 */     // No operand predicates
     /* 357599 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 357601 */     // (vector_insert:{ *:[v2i32] } v2i32:{ *:[v2i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 357601 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s128,
     /* 357604 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357608 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357613 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357615 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_s128,
     /* 357618 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357622 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357627 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357630 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 357634 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 357637 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357642 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357647 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357652 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357655 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357659 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357664 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357666 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357669 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357673 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357678 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357681 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 357685 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357688 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357693 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357698 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357703 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357706 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357710 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357715 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357718 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immd
     /* 357721 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357724 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357734 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357751 */     // GIR_Coverage, 5793,
     /* 357751 */     GIR_EraseRootFromParent_Done,
     /* 357752 */   // Label 7172: @357752
     /* 357752 */   GIM_Try, /*On fail goto*//*Label 7173*/ GIMT_Encode4(357930), // Rule ID 5716 //
     /* 357757 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357761 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357765 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357769 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357773 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357777 */     // MIs[1] Operand 1
     /* 357777 */     // No operand predicates
     /* 357777 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357779 */     // (vector_insert:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (INSvi32lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 357779 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 357782 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357786 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357791 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 357793 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 357796 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357800 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357805 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 357808 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 357812 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/18,
     /* 357815 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357820 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357825 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 357830 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357833 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357837 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357844 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357847 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357851 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357856 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357859 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357863 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357866 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357871 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357876 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357881 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 357884 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 357888 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357893 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 357896 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 357899 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 357902 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 357905 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 357907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 357910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 357912 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 357919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357929 */     // GIR_Coverage, 5716,
     /* 357929 */     GIR_EraseRootFromParent_Done,
     /* 357930 */   // Label 7173: @357930
     /* 357930 */   GIM_Try, /*On fail goto*//*Label 7174*/ GIMT_Encode4(358055), // Rule ID 5719 //
     /* 357935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 357939 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 357943 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 357947 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 357951 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 357955 */     // MIs[1] Operand 1
     /* 357955 */     // No operand predicates
     /* 357955 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 357957 */     // (vector_insert:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (INSvi32gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 357957 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s32,
     /* 357960 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 357964 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 357971 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 357974 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 357978 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 357983 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 357986 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 357990 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 357993 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 357998 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358003 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358008 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 358011 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 358015 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358020 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 358023 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 358026 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 358030 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 358035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358037 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 358044 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358049 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358054 */     // GIR_Coverage, 5719,
     /* 358054 */     GIR_EraseRootFromParent_Done,
     /* 358055 */   // Label 7174: @358055
     /* 358055 */   GIM_Reject,
     /* 358056 */ // Label 7144: @358056
     /* 358056 */ GIM_Reject,
     /* 358057 */ // Label 7122: @358057
     /* 358057 */ GIM_Try, /*On fail goto*//*Label 7175*/ GIMT_Encode4(361297),
     /* 358062 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 358065 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 358068 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 358071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358075 */   GIM_Try, /*On fail goto*//*Label 7176*/ GIMT_Encode4(358184), // Rule ID 4331 //
     /* 358080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358084 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358090 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358092 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358096 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358100 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358103 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358107 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358111 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358115 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358117 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358124 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358124 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358127 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358131 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358183 */     // GIR_Coverage, 4331,
     /* 358183 */     GIR_EraseRootFromParent_Done,
     /* 358184 */   // Label 7176: @358184
     /* 358184 */   GIM_Try, /*On fail goto*//*Label 7177*/ GIMT_Encode4(358293), // Rule ID 4332 //
     /* 358189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358193 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358199 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358201 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358205 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358209 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358212 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358216 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358220 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358224 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358226 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358233 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358250 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358255 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358260 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358266 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358268 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358271 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358273 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358276 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358279 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358282 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358287 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358292 */     // GIR_Coverage, 4332,
     /* 358292 */     GIR_EraseRootFromParent_Done,
     /* 358293 */   // Label 7177: @358293
     /* 358293 */   GIM_Try, /*On fail goto*//*Label 7178*/ GIMT_Encode4(358402), // Rule ID 4439 //
     /* 358298 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358302 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358308 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358310 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358314 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358318 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358321 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358325 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358329 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358333 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358335 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358342 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358359 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358364 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358369 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358375 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358377 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358380 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358382 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358391 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358396 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358401 */     // GIR_Coverage, 4439,
     /* 358401 */     GIR_EraseRootFromParent_Done,
     /* 358402 */   // Label 7178: @358402
     /* 358402 */   GIM_Try, /*On fail goto*//*Label 7179*/ GIMT_Encode4(358511), // Rule ID 4440 //
     /* 358407 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358411 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358417 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358419 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358423 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358427 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358430 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358434 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358438 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358442 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358444 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358451 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358463 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358468 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358473 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358478 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358486 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358489 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358491 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358494 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358497 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358505 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358510 */     // GIR_Coverage, 4440,
     /* 358510 */     GIR_EraseRootFromParent_Done,
     /* 358511 */   // Label 7179: @358511
     /* 358511 */   GIM_Try, /*On fail goto*//*Label 7180*/ GIMT_Encode4(358616), // Rule ID 4337 //
     /* 358516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358524 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358528 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358532 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358535 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358539 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358543 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358547 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358549 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358556 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358556 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358559 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358563 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358568 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358573 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358578 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358583 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358589 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358591 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358594 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358599 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358602 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358605 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358610 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358615 */     // GIR_Coverage, 4337,
     /* 358615 */     GIR_EraseRootFromParent_Done,
     /* 358616 */   // Label 7180: @358616
     /* 358616 */   GIM_Try, /*On fail goto*//*Label 7181*/ GIMT_Encode4(358721), // Rule ID 4339 //
     /* 358621 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358625 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358629 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358633 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358637 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358640 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358644 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358648 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358652 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358654 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358661 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358661 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358664 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358668 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358673 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358688 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358694 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358696 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358699 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358707 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358710 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358715 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358720 */     // GIR_Coverage, 4339,
     /* 358720 */     GIR_EraseRootFromParent_Done,
     /* 358721 */   // Label 7181: @358721
     /* 358721 */   GIM_Try, /*On fail goto*//*Label 7182*/ GIMT_Encode4(358826), // Rule ID 4445 //
     /* 358726 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358730 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358742 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358745 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358749 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358753 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358757 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358759 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 358766 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 358773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358778 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358783 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358788 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358793 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358799 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358801 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358804 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358806 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358812 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358815 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358820 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358825 */     // GIR_Coverage, 4445,
     /* 358825 */     GIR_EraseRootFromParent_Done,
     /* 358826 */   // Label 7182: @358826
     /* 358826 */   GIM_Try, /*On fail goto*//*Label 7183*/ GIMT_Encode4(358931), // Rule ID 4447 //
     /* 358831 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358835 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 358839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358847 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358850 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358854 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358858 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358862 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358864 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 358871 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 358871 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358874 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 358878 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358883 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358888 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 358893 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 358898 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 358904 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 358906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 358909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 358911 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 358914 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 358917 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 358920 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 358925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 358930 */     // GIR_Coverage, 4447,
     /* 358930 */     GIR_EraseRootFromParent_Done,
     /* 358931 */   // Label 7183: @358931
     /* 358931 */   GIM_Try, /*On fail goto*//*Label 7184*/ GIMT_Encode4(359035), // Rule ID 4329 //
     /* 358936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 358940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 358946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 358948 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 358952 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 358956 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 358959 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 358963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 358967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 358971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 358973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 358980 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 358980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 358983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 358987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 358992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 358997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359002 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359008 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359010 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359013 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359015 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359018 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359021 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359024 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359034 */     // GIR_Coverage, 4329,
     /* 359034 */     GIR_EraseRootFromParent_Done,
     /* 359035 */   // Label 7184: @359035
     /* 359035 */   GIM_Try, /*On fail goto*//*Label 7185*/ GIMT_Encode4(359139), // Rule ID 4330 //
     /* 359040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359044 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359050 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359052 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359056 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359060 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359063 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359067 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359071 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359075 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359077 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359084 */     // (vector_insert:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359084 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359087 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359091 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359096 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359101 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359106 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359112 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359114 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359117 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359122 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359125 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359128 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359133 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359138 */     // GIR_Coverage, 4330,
     /* 359138 */     GIR_EraseRootFromParent_Done,
     /* 359139 */   // Label 7185: @359139
     /* 359139 */   GIM_Try, /*On fail goto*//*Label 7186*/ GIMT_Encode4(359243), // Rule ID 4437 //
     /* 359144 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359148 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359154 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359156 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359160 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359164 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359167 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359171 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359175 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359179 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359181 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359188 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359188 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359191 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359195 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359200 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359205 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359210 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359216 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359218 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359221 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359223 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359226 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359242 */     // GIR_Coverage, 4437,
     /* 359242 */     GIR_EraseRootFromParent_Done,
     /* 359243 */   // Label 7186: @359243
     /* 359243 */   GIM_Try, /*On fail goto*//*Label 7187*/ GIMT_Encode4(359347), // Rule ID 4438 //
     /* 359248 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359252 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 359258 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 359260 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359264 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359268 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359271 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359275 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359292 */     // (vector_insert:{ *:[v2f64] } immAllZerosV:{ *:[v2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359346 */     // GIR_Coverage, 4438,
     /* 359346 */     GIR_EraseRootFromParent_Done,
     /* 359347 */   // Label 7187: @359347
     /* 359347 */   GIM_Try, /*On fail goto*//*Label 7188*/ GIMT_Encode4(359447), // Rule ID 4333 //
     /* 359352 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359356 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359360 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359364 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359368 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359371 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359375 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359379 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359383 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359385 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359392 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359392 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359395 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359399 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359404 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359409 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359414 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359420 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359427 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359430 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359433 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359436 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359441 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359446 */     // GIR_Coverage, 4333,
     /* 359446 */     GIR_EraseRootFromParent_Done,
     /* 359447 */   // Label 7188: @359447
     /* 359447 */   GIM_Try, /*On fail goto*//*Label 7189*/ GIMT_Encode4(359547), // Rule ID 4335 //
     /* 359452 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359456 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359468 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359475 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359492 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359546 */     // GIR_Coverage, 4335,
     /* 359546 */     GIR_EraseRootFromParent_Done,
     /* 359547 */   // Label 7189: @359547
     /* 359547 */   GIM_Try, /*On fail goto*//*Label 7190*/ GIMT_Encode4(359647), // Rule ID 4441 //
     /* 359552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359560 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359564 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359568 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359571 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359575 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359579 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359583 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359585 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 359592 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 359592 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359595 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 359599 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359604 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359609 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359614 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359622 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359625 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359627 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359630 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359633 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359636 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359646 */     // GIR_Coverage, 4441,
     /* 359646 */     GIR_EraseRootFromParent_Done,
     /* 359647 */   // Label 7190: @359647
     /* 359647 */   GIM_Try, /*On fail goto*//*Label 7191*/ GIMT_Encode4(359747), // Rule ID 4443 //
     /* 359652 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359656 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 359668 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 359671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 359675 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 359679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 359685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 359692 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 359692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 359695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 359699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 359709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 359714 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 359720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 359725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359727 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 359730 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359733 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359736 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359746 */     // GIR_Coverage, 4443,
     /* 359746 */     GIR_EraseRootFromParent_Done,
     /* 359747 */   // Label 7191: @359747
     /* 359747 */   GIM_Try, /*On fail goto*//*Label 7192*/ GIMT_Encode4(359860), // Rule ID 5748 //
     /* 359752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359760 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359764 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359768 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359772 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359776 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359781 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359785 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359789 */     // MIs[3] Operand 1
     /* 359789 */     // No operand predicates
     /* 359789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359793 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359795 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359807 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359811 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359814 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359828 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359835 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359838 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359844 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359849 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359854 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359859 */     // GIR_Coverage, 5748,
     /* 359859 */     GIR_EraseRootFromParent_Done,
     /* 359860 */   // Label 7192: @359860
     /* 359860 */   GIM_Try, /*On fail goto*//*Label 7193*/ GIMT_Encode4(359973), // Rule ID 5788 //
     /* 359865 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 359869 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 359873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 359877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 359889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 359898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 359902 */     // MIs[3] Operand 1
     /* 359902 */     // No operand predicates
     /* 359902 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 359906 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 359908 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (DUPi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 359908 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 359911 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 359915 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359920 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 359924 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 359927 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 359929 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 359932 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 359936 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 359941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 359943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 359946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 359948 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 359951 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 359954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 359957 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359962 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 359972 */     // GIR_Coverage, 5788,
     /* 359972 */     GIR_EraseRootFromParent_Done,
     /* 359973 */   // Label 7193: @359973
     /* 359973 */   GIM_Try, /*On fail goto*//*Label 7194*/ GIMT_Encode4(360051), // Rule ID 1941 //
     /* 359978 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 359981 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 359985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 359989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 359993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 359997 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360001 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360006 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360010 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360014 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360018 */     // MIs[2] Operand 1
     /* 360018 */     // No operand predicates
     /* 360018 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360022 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360026 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360030 */     // MIs[3] Operand 1
     /* 360030 */     // No operand predicates
     /* 360030 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360032 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 360032 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360035 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360037 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360039 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360042 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360046 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 360049 */     GIR_RootConstrainSelectedInstOperands,
     /* 360050 */     // GIR_Coverage, 1941,
     /* 360050 */     GIR_EraseRootFromParent_Done,
     /* 360051 */   // Label 7194: @360051
     /* 360051 */   GIM_Try, /*On fail goto*//*Label 7195*/ GIMT_Encode4(360146), // Rule ID 7470 //
     /* 360056 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 360059 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360063 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360067 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 360071 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360075 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 360079 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360083 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 360086 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 360090 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 360097 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 360100 */     // MIs[2] Rn
     /* 360100 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 360104 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360109 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360113 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360117 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360121 */     // MIs[3] Operand 1
     /* 360121 */     // No operand predicates
     /* 360121 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360123 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (bitconvert:{ *:[f64] } (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15831>>), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 360126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360128 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360130 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 360133 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 360137 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/4, /*MergeInsnID's*/0, 1, 2, 3,
     /* 360144 */     GIR_RootConstrainSelectedInstOperands,
     /* 360145 */     // GIR_Coverage, 7470,
     /* 360145 */     GIR_EraseRootFromParent_Done,
     /* 360146 */   // Label 7195: @360146
     /* 360146 */   GIM_Try, /*On fail goto*//*Label 7196*/ GIMT_Encode4(360235), // Rule ID 5745 //
     /* 360151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360159 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360163 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360175 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360179 */     // MIs[2] Operand 1
     /* 360179 */     // No operand predicates
     /* 360179 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360183 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360187 */     // MIs[3] Operand 1
     /* 360187 */     // No operand predicates
     /* 360187 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360189 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2f64] } ZPR:{ *:[nxv2f64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 360189 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360192 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360196 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360201 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 360207 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360212 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360217 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360220 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360222 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360227 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360230 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360233 */     GIR_RootConstrainSelectedInstOperands,
     /* 360234 */     // GIR_Coverage, 5745,
     /* 360234 */     GIR_EraseRootFromParent_Done,
     /* 360235 */   // Label 7196: @360235
     /* 360235 */   GIM_Try, /*On fail goto*//*Label 7197*/ GIMT_Encode4(360324), // Rule ID 5785 //
     /* 360240 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360244 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360248 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 360252 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360256 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360260 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360264 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360268 */     // MIs[2] Operand 1
     /* 360268 */     // No operand predicates
     /* 360268 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360272 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360276 */     // MIs[3] Operand 1
     /* 360276 */     // No operand predicates
     /* 360276 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360278 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$Immn)
     /* 360278 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360281 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 360285 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360290 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 360296 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360301 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 360306 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360309 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 360313 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360316 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360319 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360322 */     GIR_RootConstrainSelectedInstOperands,
     /* 360323 */     // GIR_Coverage, 5785,
     /* 360323 */     GIR_EraseRootFromParent_Done,
     /* 360324 */   // Label 7197: @360324
     /* 360324 */   GIM_Try, /*On fail goto*//*Label 7198*/ GIMT_Encode4(360391), // Rule ID 5747 //
     /* 360329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360345 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360349 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360362 */     // MIs[2] Operand 1
     /* 360362 */     // No operand predicates
     /* 360362 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360366 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360370 */     // MIs[3] Operand 1
     /* 360370 */     // No operand predicates
     /* 360370 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360372 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 360372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360377 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360379 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360382 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360386 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360389 */     GIR_RootConstrainSelectedInstOperands,
     /* 360390 */     // GIR_Coverage, 5747,
     /* 360390 */     GIR_EraseRootFromParent_Done,
     /* 360391 */   // Label 7198: @360391
     /* 360391 */   GIM_Try, /*On fail goto*//*Label 7199*/ GIMT_Encode4(360489), // Rule ID 5749 //
     /* 360396 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360400 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360404 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360408 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360412 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360416 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360421 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360425 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360429 */     // MIs[2] Operand 1
     /* 360429 */     // No operand predicates
     /* 360429 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360433 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360437 */     // MIs[3] Operand 1
     /* 360437 */     // No operand predicates
     /* 360437 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360439 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (vector_extract:{ *:[f64] } V64:{ *:[v1f64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2f64] } 0:{ *:[i64] }, V64:{ *:[v1f64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 360439 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360442 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360446 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360451 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 360454 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360458 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360476 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360478 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360481 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360484 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360487 */     GIR_RootConstrainSelectedInstOperands,
     /* 360488 */     // GIR_Coverage, 5749,
     /* 360488 */     GIR_EraseRootFromParent_Done,
     /* 360489 */   // Label 7199: @360489
     /* 360489 */   GIM_Try, /*On fail goto*//*Label 7200*/ GIMT_Encode4(360556), // Rule ID 5787 //
     /* 360494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 360510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360519 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360523 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360527 */     // MIs[2] Operand 1
     /* 360527 */     // No operand predicates
     /* 360527 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360531 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360535 */     // MIs[3] Operand 1
     /* 360535 */     // No operand predicates
     /* 360535 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360537 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 360537 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360540 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360542 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360547 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360551 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360554 */     GIR_RootConstrainSelectedInstOperands,
     /* 360555 */     // GIR_Coverage, 5787,
     /* 360555 */     GIR_EraseRootFromParent_Done,
     /* 360556 */   // Label 7200: @360556
     /* 360556 */   GIM_Try, /*On fail goto*//*Label 7201*/ GIMT_Encode4(360654), // Rule ID 5789 //
     /* 360561 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 360573 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 360577 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 360581 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360586 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 360590 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360594 */     // MIs[2] Operand 1
     /* 360594 */     // No operand predicates
     /* 360594 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 360598 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360602 */     // MIs[3] Operand 1
     /* 360602 */     // No operand predicates
     /* 360602 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 360604 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (vector_extract:{ *:[i64] } V64:{ *:[v1i64] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, V64:{ *:[v1i64] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 360604 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360607 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 360611 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360616 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 360619 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360623 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 360626 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360631 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 360639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360641 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 360643 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 360646 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360649 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 360652 */     GIR_RootConstrainSelectedInstOperands,
     /* 360653 */     // GIR_Coverage, 5789,
     /* 360653 */     GIR_EraseRootFromParent_Done,
     /* 360654 */   // Label 7201: @360654
     /* 360654 */   GIM_Try, /*On fail goto*//*Label 7202*/ GIMT_Encode4(360720), // Rule ID 5693 //
     /* 360659 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360663 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360671 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360675 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360677 */     // (vector_insert:{ *:[v2i64] } (undef:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), GPR64:{ *:[i64] }:$Rn, dsub:{ *:[i32] })
     /* 360677 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360680 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360684 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360689 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360691 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360694 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360696 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360699 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360701 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360704 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360709 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360714 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 360719 */     // GIR_Coverage, 5693,
     /* 360719 */     GIR_EraseRootFromParent_Done,
     /* 360720 */   // Label 7202: @360720
     /* 360720 */   GIM_Try, /*On fail goto*//*Label 7203*/ GIMT_Encode4(360786), // Rule ID 5707 //
     /* 360725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 360729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 360733 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360737 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 360741 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 360743 */     // (vector_insert:{ *:[v2f64] } (undef:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] })
     /* 360743 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 360746 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 360750 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 360755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 360757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 360760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360762 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 360765 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 360767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 360770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360780 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 360785 */     // GIR_Coverage, 5707,
     /* 360785 */     GIR_EraseRootFromParent_Done,
     /* 360786 */   // Label 7203: @360786
     /* 360786 */   GIM_Try, /*On fail goto*//*Label 7204*/ GIMT_Encode4(360855), // Rule ID 6472 //
     /* 360791 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360803 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360806 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360810 */     // MIs[1] Rn
     /* 360810 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360814 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360827 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360831 */     // MIs[2] Operand 1
     /* 360831 */     // No operand predicates
     /* 360831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360833 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360833 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 360836 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360838 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360840 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360843 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360847 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360853 */     GIR_RootConstrainSelectedInstOperands,
     /* 360854 */     // GIR_Coverage, 6472,
     /* 360854 */     GIR_EraseRootFromParent_Done,
     /* 360855 */   // Label 7204: @360855
     /* 360855 */   GIM_Try, /*On fail goto*//*Label 7205*/ GIMT_Encode4(360924), // Rule ID 6473 //
     /* 360860 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360864 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360868 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360872 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 360875 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360879 */     // MIs[1] Rn
     /* 360879 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360883 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360888 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360892 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360896 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360900 */     // MIs[2] Operand 1
     /* 360900 */     // No operand predicates
     /* 360900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360902 */     // (vector_insert:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LD1i64:{ *:[v2f64] } VecListOne128:{ *:[v2f64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360902 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i64),
     /* 360905 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360907 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360909 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360912 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360916 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 360922 */     GIR_RootConstrainSelectedInstOperands,
     /* 360923 */     // GIR_Coverage, 6473,
     /* 360923 */     GIR_EraseRootFromParent_Done,
     /* 360924 */   // Label 7205: @360924
     /* 360924 */   GIM_Try, /*On fail goto*//*Label 7206*/ GIMT_Encode4(361006), // Rule ID 7469 //
     /* 360929 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON_HasRCPC3),
     /* 360932 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 360936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 360940 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 360944 */     GIM_CheckAtomicOrderingOrStrongerThan, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Unordered,
     /* 360947 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 360951 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(8),
     /* 360958 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::Acquire,
     /* 360961 */     // MIs[1] Rn
     /* 360961 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 360965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 360970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 360974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 360978 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 360982 */     // MIs[2] Operand 1
     /* 360982 */     // No operand predicates
     /* 360982 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 360984 */     // (vector_insert:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (atomic_load:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_atomic_load_nonext>><<P:Predicate_atomic_load_nonext_64>><<P:Predicate_anonymous_15831>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (LDAP1:{ *:[v2i64] } VecListOne128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 360984 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LDAP1),
     /* 360987 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 360989 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 360991 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 360994 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 360998 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361004 */     GIR_RootConstrainSelectedInstOperands,
     /* 361005 */     // GIR_Coverage, 7469,
     /* 361005 */     GIR_EraseRootFromParent_Done,
     /* 361006 */   // Label 7206: @361006
     /* 361006 */   GIM_Try, /*On fail goto*//*Label 7207*/ GIMT_Encode4(361055), // Rule ID 5714 //
     /* 361011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 361019 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 361023 */     // MIs[1] Operand 1
     /* 361023 */     // No operand predicates
     /* 361023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361031 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361035 */     // MIs[2] Operand 1
     /* 361035 */     // No operand predicates
     /* 361035 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361037 */     // (vector_insert:{ *:[v2f64] } v2f64:{ *:[v2f64] }:$Rn, (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64gpr:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, XZR:{ *:[i64] })
     /* 361037 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 361040 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361042 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361044 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 361047 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 361053 */     GIR_RootConstrainSelectedInstOperands,
     /* 361054 */     // GIR_Coverage, 5714,
     /* 361054 */     GIR_EraseRootFromParent_Done,
     /* 361055 */   // Label 7207: @361055
     /* 361055 */   GIM_Try, /*On fail goto*//*Label 7208*/ GIMT_Encode4(361156), // Rule ID 5794 //
     /* 361060 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 361064 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 361068 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 361072 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 361081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361085 */     // MIs[2] Operand 1
     /* 361085 */     // No operand predicates
     /* 361085 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361087 */     // (vector_insert:{ *:[v2i64] } v2i64:{ *:[v2i64] }:$src, (bitconvert:{ *:[i64] } FPR64:{ *:[f64] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR64:{ *:[f64] }:$Sn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361087 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 361090 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361094 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361099 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361101 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 361104 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361108 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361113 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361116 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 361120 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361123 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361128 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361133 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361138 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361141 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361143 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 361145 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 361148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361151 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361154 */     GIR_RootConstrainSelectedInstOperands,
     /* 361155 */     // GIR_Coverage, 5794,
     /* 361155 */     GIR_EraseRootFromParent_Done,
     /* 361156 */   // Label 7208: @361156
     /* 361156 */   GIM_Try, /*On fail goto*//*Label 7209*/ GIMT_Encode4(361200), // Rule ID 1937 //
     /* 361161 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 361164 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361168 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 361172 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 361176 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361180 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361184 */     // MIs[1] Operand 1
     /* 361184 */     // No operand predicates
     /* 361184 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361186 */     // (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, GPR64:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (INSvi64gpr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, (imm:{ *:[i64] }):$idx, GPR64:{ *:[i64] }:$Rn)
     /* 361186 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64gpr),
     /* 361189 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361191 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 361193 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 361196 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 361198 */     GIR_RootConstrainSelectedInstOperands,
     /* 361199 */     // GIR_Coverage, 1937,
     /* 361199 */     GIR_EraseRootFromParent_Done,
     /* 361200 */   // Label 7209: @361200
     /* 361200 */   GIM_Try, /*On fail goto*//*Label 7210*/ GIMT_Encode4(361296), // Rule ID 5718 //
     /* 361205 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361209 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361213 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 361217 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 361221 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 361225 */     // MIs[1] Operand 1
     /* 361225 */     // No operand predicates
     /* 361225 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 361227 */     // (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (INSvi64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm, (INSERT_SUBREG:{ *:[v2f64] } (IMPLICIT_DEF:{ *:[v2f64] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 361227 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v2s64,
     /* 361230 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 361234 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361239 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 361241 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 361244 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 361248 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361253 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 361256 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 361260 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 361263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 361273 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361278 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi64lane),
     /* 361281 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361283 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 361285 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 361288 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361291 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361294 */     GIR_RootConstrainSelectedInstOperands,
     /* 361295 */     // GIR_Coverage, 5718,
     /* 361295 */     GIR_EraseRootFromParent_Done,
     /* 361296 */   // Label 7210: @361296
     /* 361296 */   GIM_Reject,
     /* 361297 */ // Label 7175: @361297
     /* 361297 */ GIM_Reject,
     /* 361298 */ // Label 7123: @361298
     /* 361298 */ GIM_Try, /*On fail goto*//*Label 7211*/ GIMT_Encode4(364937),
     /* 361303 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 361306 */   GIM_Try, /*On fail goto*//*Label 7212*/ GIMT_Encode4(361432), // Rule ID 4271 //
     /* 361311 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361314 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361317 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361325 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361331 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361333 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361337 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361341 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361344 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361348 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361355 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361359 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361363 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361365 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361372 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361372 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361375 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361379 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361384 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361399 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361405 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361407 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361410 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361412 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361415 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361418 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361421 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361431 */     // GIR_Coverage, 4271,
     /* 361431 */     GIR_EraseRootFromParent_Done,
     /* 361432 */   // Label 7212: @361432
     /* 361432 */   GIM_Try, /*On fail goto*//*Label 7213*/ GIMT_Encode4(361558), // Rule ID 4272 //
     /* 361437 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361440 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361443 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361447 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361451 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361457 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361459 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361463 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361467 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361470 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361474 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361481 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361485 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361489 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361491 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361498 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361498 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361501 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361505 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361510 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361557 */     // GIR_Coverage, 4272,
     /* 361557 */     GIR_EraseRootFromParent_Done,
     /* 361558 */   // Label 7213: @361558
     /* 361558 */   GIM_Try, /*On fail goto*//*Label 7214*/ GIMT_Encode4(361677), // Rule ID 4379 //
     /* 361563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361577 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361583 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361585 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361589 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361593 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361596 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361600 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361604 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361608 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361610 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361617 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361629 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361634 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361644 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361650 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361657 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361663 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361666 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361676 */     // GIR_Coverage, 4379,
     /* 361676 */     GIR_EraseRootFromParent_Done,
     /* 361677 */   // Label 7214: @361677
     /* 361677 */   GIM_Try, /*On fail goto*//*Label 7215*/ GIMT_Encode4(361796), // Rule ID 4380 //
     /* 361682 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 361685 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361688 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361692 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361696 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 361702 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 361704 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361708 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361712 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361715 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361719 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361723 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361727 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361729 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361736 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361748 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361753 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361758 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361763 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361769 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361771 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361774 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361776 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361785 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361795 */     // GIR_Coverage, 4380,
     /* 361795 */     GIR_EraseRootFromParent_Done,
     /* 361796 */   // Label 7215: @361796
     /* 361796 */   GIM_Try, /*On fail goto*//*Label 7216*/ GIMT_Encode4(361918), // Rule ID 4277 //
     /* 361801 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361804 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361807 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361819 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361823 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361827 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361830 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361834 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361841 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361845 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361849 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361851 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 361858 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361858 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361861 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 361865 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361870 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361875 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 361880 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 361885 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 361891 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 361893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 361896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 361898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 361901 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 361904 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 361907 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361912 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 361917 */     // GIR_Coverage, 4277,
     /* 361917 */     GIR_EraseRootFromParent_Done,
     /* 361918 */   // Label 7216: @361918
     /* 361918 */   GIM_Try, /*On fail goto*//*Label 7217*/ GIMT_Encode4(362040), // Rule ID 4279 //
     /* 361923 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 361926 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 361929 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 361933 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 361937 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 361941 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 361945 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 361949 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 361952 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 361956 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 361963 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 361967 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 361971 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 361973 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 361980 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 361980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 361983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 361987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 361992 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 361997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362039 */     // GIR_Coverage, 4279,
     /* 362039 */     GIR_EraseRootFromParent_Done,
     /* 362040 */   // Label 7217: @362040
     /* 362040 */   GIM_Try, /*On fail goto*//*Label 7218*/ GIMT_Encode4(362155), // Rule ID 4385 //
     /* 362045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362078 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 362095 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 362102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362117 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362122 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362128 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362130 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362133 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362135 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362138 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362141 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362149 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362154 */     // GIR_Coverage, 4385,
     /* 362154 */     GIR_EraseRootFromParent_Done,
     /* 362155 */   // Label 7218: @362155
     /* 362155 */   GIM_Try, /*On fail goto*//*Label 7219*/ GIMT_Encode4(362270), // Rule ID 4387 //
     /* 362160 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362163 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362166 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362186 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362189 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362193 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362197 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362201 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362203 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 362210 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 362210 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362213 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 362217 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362222 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362227 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 362232 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 362237 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362243 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362245 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362248 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362250 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362253 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362256 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362259 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362264 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362269 */     // GIR_Coverage, 4387,
     /* 362269 */     GIR_EraseRootFromParent_Done,
     /* 362270 */   // Label 7219: @362270
     /* 362270 */   GIM_Try, /*On fail goto*//*Label 7220*/ GIMT_Encode4(362391), // Rule ID 4269 //
     /* 362275 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362278 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362281 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362285 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362289 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362295 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362305 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362308 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362312 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362319 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362323 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362327 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362329 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362336 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362336 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362339 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362343 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362348 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362353 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362358 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362364 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362366 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362369 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362371 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362374 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362377 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362380 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362385 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362390 */     // GIR_Coverage, 4269,
     /* 362390 */     GIR_EraseRootFromParent_Done,
     /* 362391 */   // Label 7220: @362391
     /* 362391 */   GIM_Try, /*On fail goto*//*Label 7221*/ GIMT_Encode4(362512), // Rule ID 4270 //
     /* 362396 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362399 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362402 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362406 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362410 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362416 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362426 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362429 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362433 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362457 */     // (vector_insert:{ *:[v4i16] } immAllZerosV:{ *:[v4i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362479 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362511 */     // GIR_Coverage, 4270,
     /* 362511 */     GIR_EraseRootFromParent_Done,
     /* 362512 */   // Label 7221: @362512
     /* 362512 */   GIM_Try, /*On fail goto*//*Label 7222*/ GIMT_Encode4(362626), // Rule ID 4377 //
     /* 362517 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362520 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362523 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362527 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362531 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362537 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362539 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362543 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362547 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362550 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362554 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362558 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362562 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362564 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362571 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362583 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362588 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362593 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362599 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362606 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362612 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362615 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362620 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362625 */     // GIR_Coverage, 4377,
     /* 362625 */     GIR_EraseRootFromParent_Done,
     /* 362626 */   // Label 7222: @362626
     /* 362626 */   GIM_Try, /*On fail goto*//*Label 7223*/ GIMT_Encode4(362740), // Rule ID 4378 //
     /* 362631 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362634 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362637 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362645 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 362651 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 362653 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362657 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362661 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362664 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362668 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362672 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362676 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362678 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362685 */     // (vector_insert:{ *:[v4f16] } immAllZerosV:{ *:[v4f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362685 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362688 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362692 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362697 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362702 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362707 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362715 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362718 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362726 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362729 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362739 */     // GIR_Coverage, 4378,
     /* 362739 */     GIR_EraseRootFromParent_Done,
     /* 362740 */   // Label 7223: @362740
     /* 362740 */   GIM_Try, /*On fail goto*//*Label 7224*/ GIMT_Encode4(362857), // Rule ID 4273 //
     /* 362745 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362748 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362751 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362755 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362759 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362763 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362767 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362771 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362774 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362778 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362785 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362789 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362795 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 362802 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 362802 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362805 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 362809 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362814 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362819 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362824 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362837 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362840 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362843 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362846 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362851 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362856 */     // GIR_Coverage, 4273,
     /* 362856 */     GIR_EraseRootFromParent_Done,
     /* 362857 */   // Label 7224: @362857
     /* 362857 */   GIM_Try, /*On fail goto*//*Label 7225*/ GIMT_Encode4(362974), // Rule ID 4275 //
     /* 362862 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 362865 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362868 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362872 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362876 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362880 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 362884 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 362888 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 362891 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 362895 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 362902 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 362906 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 362910 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 362912 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 362919 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 362919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 362922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 362926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 362931 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 362936 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 362941 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 362947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 362949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 362952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 362954 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 362957 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 362960 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 362963 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362968 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 362973 */     // GIR_Coverage, 4275,
     /* 362973 */     GIR_EraseRootFromParent_Done,
     /* 362974 */   // Label 7225: @362974
     /* 362974 */   GIM_Try, /*On fail goto*//*Label 7226*/ GIMT_Encode4(363084), // Rule ID 4381 //
     /* 362979 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 362982 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 362985 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 362989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 362993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 362997 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363001 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363005 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363008 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363012 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363016 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363020 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363022 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 363029 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 363029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 363036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363041 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363046 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363051 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363057 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363059 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363062 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363064 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363067 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363070 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363073 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363078 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363083 */     // GIR_Coverage, 4381,
     /* 363083 */     GIR_EraseRootFromParent_Done,
     /* 363084 */   // Label 7226: @363084
     /* 363084 */   GIM_Try, /*On fail goto*//*Label 7227*/ GIMT_Encode4(363194), // Rule ID 4383 //
     /* 363089 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363092 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363095 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363099 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363103 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363107 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363111 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363115 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363118 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363122 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 363126 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363130 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363132 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 363139 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 363139 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 363142 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 363146 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363151 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 363156 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 363161 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363167 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363174 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 363177 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 363180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 363183 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363188 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 363193 */     // GIR_Coverage, 4383,
     /* 363193 */     GIR_EraseRootFromParent_Done,
     /* 363194 */   // Label 7227: @363194
     /* 363194 */   GIM_Try, /*On fail goto*//*Label 7228*/ GIMT_Encode4(363324), // Rule ID 6485 //
     /* 363199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 363202 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363205 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363208 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363220 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 363224 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 363228 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 363231 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 363235 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 363242 */     // MIs[2] Rn
     /* 363242 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/64,
     /* 363246 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 363251 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363255 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 363257 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i8:{ *:[f128] } (IMPLICIT_DEF:{ *:[v16i8] }), 0:{ *:[i64] }, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 363257 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 363260 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 363264 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363269 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 363271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 363278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363283 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363286 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 363289 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 363293 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 363299 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363301 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363304 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363306 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363313 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363318 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363323 */     // GIR_Coverage, 6485,
     /* 363323 */     GIR_EraseRootFromParent_Done,
     /* 363324 */   // Label 7228: @363324
     /* 363324 */   GIM_Try, /*On fail goto*//*Label 7229*/ GIMT_Encode4(363464), // Rule ID 5734 //
     /* 363329 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363332 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363335 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363343 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363347 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363351 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363355 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363359 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363364 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363368 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363372 */     // MIs[2] Operand 1
     /* 363372 */     // No operand predicates
     /* 363372 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363376 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363380 */     // MIs[3] Operand 1
     /* 363380 */     // No operand predicates
     /* 363380 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363382 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363382 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363385 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363389 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363394 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363397 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363401 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363404 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363409 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363414 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363417 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363421 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363426 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363432 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363436 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363439 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363441 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363444 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363446 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363453 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363458 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363463 */     // GIR_Coverage, 5734,
     /* 363463 */     GIR_EraseRootFromParent_Done,
     /* 363464 */   // Label 7229: @363464
     /* 363464 */   GIM_Try, /*On fail goto*//*Label 7230*/ GIMT_Encode4(363635), // Rule ID 5735 //
     /* 363469 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 363472 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363475 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363487 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363491 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363495 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363499 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363504 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363508 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363512 */     // MIs[2] Operand 1
     /* 363512 */     // No operand predicates
     /* 363512 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363516 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363520 */     // MIs[3] Operand 1
     /* 363520 */     // No operand predicates
     /* 363520 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363522 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363522 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 363525 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363529 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363534 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363537 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363541 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 363544 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363549 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363566 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363569 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363573 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363576 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363581 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363586 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363589 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363593 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363598 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363601 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363604 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363607 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363610 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363617 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363624 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363629 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363634 */     // GIR_Coverage, 5735,
     /* 363634 */     GIR_EraseRootFromParent_Done,
     /* 363635 */   // Label 7230: @363635
     /* 363635 */   GIM_Try, /*On fail goto*//*Label 7231*/ GIMT_Encode4(363775), // Rule ID 5774 //
     /* 363640 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363643 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363646 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363650 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363654 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363658 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363662 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 363666 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363670 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363675 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363679 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363683 */     // MIs[2] Operand 1
     /* 363683 */     // No operand predicates
     /* 363683 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363687 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363691 */     // MIs[3] Operand 1
     /* 363691 */     // No operand predicates
     /* 363691 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363693 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363693 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 363696 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363700 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363705 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363708 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363712 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363715 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363720 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363725 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363728 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363732 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363737 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363743 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363747 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363750 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363752 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363755 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363757 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363774 */     // GIR_Coverage, 5774,
     /* 363774 */     GIR_EraseRootFromParent_Done,
     /* 363775 */   // Label 7231: @363775
     /* 363775 */   GIM_Try, /*On fail goto*//*Label 7232*/ GIMT_Encode4(363946), // Rule ID 5775 //
     /* 363780 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363783 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363786 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363790 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363794 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 363798 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 363802 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 363806 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 363810 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363815 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 363819 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363823 */     // MIs[2] Operand 1
     /* 363823 */     // No operand predicates
     /* 363823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 363827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 363831 */     // MIs[3] Operand 1
     /* 363831 */     // No operand predicates
     /* 363831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 363833 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 363833 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 363836 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363840 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363845 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 363848 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 363852 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 363855 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363860 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363865 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 363868 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 363872 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363877 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 363880 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 363884 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 363887 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363892 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363897 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 363900 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 363904 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363909 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 363912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 363915 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 363918 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 363921 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 363923 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363926 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 363928 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 363935 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363940 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 363945 */     // GIR_Coverage, 5775,
     /* 363945 */     GIR_EraseRootFromParent_Done,
     /* 363946 */   // Label 7232: @363946
     /* 363946 */   GIM_Try, /*On fail goto*//*Label 7233*/ GIMT_Encode4(364025), // Rule ID 5687 //
     /* 363951 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 363954 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 363957 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 363961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 363965 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 363969 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 363973 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 363977 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 363979 */     // (vector_insert:{ *:[v4i16] } (undef:{ *:[v4i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 363979 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 363982 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 363986 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 363991 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 363995 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364000 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364003 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364005 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 364008 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364011 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 364014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364019 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 364024 */     // GIR_Coverage, 5687,
     /* 364024 */     GIR_EraseRootFromParent_Done,
     /* 364025 */   // Label 7233: @364025
     /* 364025 */   GIM_Try, /*On fail goto*//*Label 7234*/ GIMT_Encode4(364101), // Rule ID 5695 //
     /* 364030 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364033 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364036 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364052 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364056 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364058 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 364058 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 364061 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364065 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364070 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364072 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364075 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364080 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364095 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364100 */     // GIR_Coverage, 5695,
     /* 364100 */     GIR_EraseRootFromParent_Done,
     /* 364101 */   // Label 7234: @364101
     /* 364101 */   GIM_Try, /*On fail goto*//*Label 7235*/ GIMT_Encode4(364177), // Rule ID 5699 //
     /* 364106 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364109 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364112 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364116 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364120 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 364124 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364128 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364132 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364134 */     // (vector_insert:{ *:[v4f16] } (undef:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f16] } (IMPLICIT_DEF:{ *:[v4f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 364134 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s16,
     /* 364137 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364141 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364148 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364151 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 364156 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 364158 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 364161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364171 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364176 */     // GIR_Coverage, 5699,
     /* 364176 */     GIR_EraseRootFromParent_Done,
     /* 364177 */   // Label 7235: @364177
     /* 364177 */   GIM_Try, /*On fail goto*//*Label 7236*/ GIMT_Encode4(364322), // Rule ID 5711 //
     /* 364182 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364185 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364188 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364192 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364196 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364200 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 364204 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 364208 */     // MIs[1] Operand 1
     /* 364208 */     // No operand predicates
     /* 364208 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364212 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364216 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364220 */     // MIs[2] Operand 1
     /* 364220 */     // No operand predicates
     /* 364220 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364222 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] }), dsub:{ *:[i32] })
     /* 364222 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364225 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364229 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364234 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364236 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364239 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364243 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364248 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364251 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364255 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364258 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364263 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364268 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 364280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364288 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // imm
     /* 364291 */     GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 364297 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364299 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364302 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364304 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364311 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364321 */     // GIR_Coverage, 5711,
     /* 364321 */     GIR_EraseRootFromParent_Done,
     /* 364322 */   // Label 7236: @364322
     /* 364322 */   GIM_Try, /*On fail goto*//*Label 7237*/ GIMT_Encode4(364471), // Rule ID 6489 //
     /* 364327 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364330 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364333 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364337 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364341 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364345 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364349 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364352 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 364356 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 364363 */     // MIs[1] Rn
     /* 364363 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 364367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364380 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364384 */     // MIs[2] Operand 1
     /* 364384 */     // No operand predicates
     /* 364384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364386 */     // (vector_insert:{ *:[v4i16] } VecListOne64:{ *:[v4i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4i16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364386 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364389 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364393 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364398 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364401 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 364405 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364408 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364413 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364418 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364421 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 364425 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364430 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364433 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 364436 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364440 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364448 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364451 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364453 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364460 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364465 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364470 */     // GIR_Coverage, 6489,
     /* 364470 */     GIR_EraseRootFromParent_Done,
     /* 364471 */   // Label 7237: @364471
     /* 364471 */   GIM_Try, /*On fail goto*//*Label 7238*/ GIMT_Encode4(364613), // Rule ID 6492 //
     /* 364476 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364479 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364482 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364486 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364490 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 364494 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364498 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364501 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 364505 */     // MIs[1] Rn
     /* 364505 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 364509 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 364514 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 364518 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364522 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364526 */     // MIs[2] Operand 1
     /* 364526 */     // No operand predicates
     /* 364526 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364528 */     // (vector_insert:{ *:[v4f16] } VecListOne64:{ *:[v4f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (LD1i16:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v4f16] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 364528 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 364531 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 364535 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364540 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 364543 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 364547 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364550 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364555 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364560 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364563 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 364567 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364572 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364575 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 364578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 364582 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 364588 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364590 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364593 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364595 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364607 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364612 */     // GIR_Coverage, 6492,
     /* 364612 */     GIR_EraseRootFromParent_Done,
     /* 364613 */   // Label 7238: @364613
     /* 364613 */   GIM_Try, /*On fail goto*//*Label 7239*/ GIMT_Encode4(364801), // Rule ID 5709 //
     /* 364618 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 364621 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364624 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364628 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364632 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364636 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 364640 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364644 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 364648 */     // MIs[1] Operand 1
     /* 364648 */     // No operand predicates
     /* 364648 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364650 */     // (vector_insert:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (INSvi16lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 364650 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v8s16,
     /* 364653 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364657 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 364664 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v8s16,
     /* 364667 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364671 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364676 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 364679 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364683 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/9,
     /* 364686 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364691 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364696 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 364701 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364704 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364708 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364713 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364727 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364730 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364734 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364737 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364742 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364747 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 364759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364764 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 364770 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 364773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 364776 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364778 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364781 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364783 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364790 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364795 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364800 */     // GIR_Coverage, 5709,
     /* 364800 */     GIR_EraseRootFromParent_Done,
     /* 364801 */   // Label 7239: @364801
     /* 364801 */   GIM_Try, /*On fail goto*//*Label 7240*/ GIMT_Encode4(364936), // Rule ID 5720 //
     /* 364806 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364809 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364812 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 364824 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 364828 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 364832 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 364836 */     // MIs[1] Operand 1
     /* 364836 */     // No operand predicates
     /* 364836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 364838 */     // (vector_insert:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (INSvi16gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 364838 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v8s16,
     /* 364841 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 364845 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364850 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 364852 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 364855 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 364859 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364864 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 364867 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 364871 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 364874 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364879 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364884 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364889 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 364892 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 364896 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 364901 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 364904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 364907 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 364911 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 364913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 364916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 364918 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 364925 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 364930 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364935 */     // GIR_Coverage, 5720,
     /* 364935 */     GIR_EraseRootFromParent_Done,
     /* 364936 */   // Label 7240: @364936
     /* 364936 */   GIM_Reject,
     /* 364937 */ // Label 7211: @364937
     /* 364937 */ GIM_Reject,
     /* 364938 */ // Label 7124: @364938
     /* 364938 */ GIM_Try, /*On fail goto*//*Label 7241*/ GIMT_Encode4(368005),
     /* 364943 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 364946 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 364949 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 364952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 364956 */   GIM_Try, /*On fail goto*//*Label 7242*/ GIMT_Encode4(365065), // Rule ID 4295 //
     /* 364961 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 364965 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 364971 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 364973 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 364977 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 364981 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 364984 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 364988 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 364992 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 364996 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 364998 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365005 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365017 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365022 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365032 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365038 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365045 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365048 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365051 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365054 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365064 */     // GIR_Coverage, 4295,
     /* 365064 */     GIR_EraseRootFromParent_Done,
     /* 365065 */   // Label 7242: @365065
     /* 365065 */   GIM_Try, /*On fail goto*//*Label 7243*/ GIMT_Encode4(365174), // Rule ID 4296 //
     /* 365070 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365074 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365080 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365090 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365093 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365097 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365101 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365105 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365107 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365114 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365114 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365117 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365121 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365126 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365141 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365173 */     // GIR_Coverage, 4296,
     /* 365173 */     GIR_EraseRootFromParent_Done,
     /* 365174 */   // Label 7243: @365174
     /* 365174 */   GIM_Try, /*On fail goto*//*Label 7244*/ GIMT_Encode4(365283), // Rule ID 4403 //
     /* 365179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365183 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365189 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365206 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365223 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365245 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365250 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365263 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365266 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365269 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365277 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365282 */     // GIR_Coverage, 4403,
     /* 365282 */     GIR_EraseRootFromParent_Done,
     /* 365283 */   // Label 7244: @365283
     /* 365283 */   GIM_Try, /*On fail goto*//*Label 7245*/ GIMT_Encode4(365392), // Rule ID 4404 //
     /* 365288 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365292 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365298 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365300 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365304 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365308 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365311 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365315 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365319 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365323 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365325 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365332 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365349 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365354 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365359 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365365 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365372 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365375 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365378 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365381 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365386 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365391 */     // GIR_Coverage, 4404,
     /* 365391 */     GIR_EraseRootFromParent_Done,
     /* 365392 */   // Label 7245: @365392
     /* 365392 */   GIM_Try, /*On fail goto*//*Label 7246*/ GIMT_Encode4(365497), // Rule ID 4301 //
     /* 365397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365416 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365420 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365424 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365428 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365430 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365437 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365449 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365454 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365459 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365464 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365472 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365475 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365477 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365480 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365483 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365486 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365491 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365496 */     // GIR_Coverage, 4301,
     /* 365496 */     GIR_EraseRootFromParent_Done,
     /* 365497 */   // Label 7246: @365497
     /* 365497 */   GIM_Try, /*On fail goto*//*Label 7247*/ GIMT_Encode4(365602), // Rule ID 4303 //
     /* 365502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365518 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365521 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365525 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365529 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365533 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365535 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365542 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365554 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365559 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365564 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365569 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365577 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365580 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365582 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365585 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365591 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365596 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365601 */     // GIR_Coverage, 4303,
     /* 365601 */     GIR_EraseRootFromParent_Done,
     /* 365602 */   // Label 7247: @365602
     /* 365602 */   GIM_Try, /*On fail goto*//*Label 7248*/ GIMT_Encode4(365707), // Rule ID 4409 //
     /* 365607 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365611 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365615 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365619 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365623 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365626 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365630 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365634 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365640 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 365647 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365647 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365650 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 365654 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365659 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365664 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365674 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365680 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365687 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365690 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365693 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365696 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365706 */     // GIR_Coverage, 4409,
     /* 365706 */     GIR_EraseRootFromParent_Done,
     /* 365707 */   // Label 7248: @365707
     /* 365707 */   GIM_Try, /*On fail goto*//*Label 7249*/ GIMT_Encode4(365812), // Rule ID 4411 //
     /* 365712 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365716 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 365720 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365724 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365728 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365731 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365735 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365739 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365743 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365745 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 365752 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 365752 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365755 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 365759 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365764 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 365774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 365779 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365811 */     // GIR_Coverage, 4411,
     /* 365811 */     GIR_EraseRootFromParent_Done,
     /* 365812 */   // Label 7249: @365812
     /* 365812 */   GIM_Try, /*On fail goto*//*Label 7250*/ GIMT_Encode4(365916), // Rule ID 4293 //
     /* 365817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365821 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365827 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365829 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365833 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365837 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365840 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365844 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365848 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365852 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365854 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 365861 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 365861 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365864 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 365868 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365873 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365878 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365883 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365889 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365891 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365894 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 365896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 365899 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 365902 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 365905 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 365910 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 365915 */     // GIR_Coverage, 4293,
     /* 365915 */     GIR_EraseRootFromParent_Done,
     /* 365916 */   // Label 7250: @365916
     /* 365916 */   GIM_Try, /*On fail goto*//*Label 7251*/ GIMT_Encode4(366020), // Rule ID 4294 //
     /* 365921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 365925 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 365931 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 365933 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 365937 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 365941 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 365944 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 365948 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 365952 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 365956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 365958 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 365965 */     // (vector_insert:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 365965 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 365968 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 365972 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 365977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 365982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 365987 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 365993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 365995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 365998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366019 */     // GIR_Coverage, 4294,
     /* 366019 */     GIR_EraseRootFromParent_Done,
     /* 366020 */   // Label 7251: @366020
     /* 366020 */   GIM_Try, /*On fail goto*//*Label 7252*/ GIMT_Encode4(366124), // Rule ID 4401 //
     /* 366025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366029 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366035 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366045 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366048 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366052 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366056 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366060 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366062 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366069 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366069 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366072 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366076 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366081 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366086 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366091 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366097 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366104 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366110 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366113 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366118 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366123 */     // GIR_Coverage, 4401,
     /* 366123 */     GIR_EraseRootFromParent_Done,
     /* 366124 */   // Label 7252: @366124
     /* 366124 */   GIM_Try, /*On fail goto*//*Label 7253*/ GIMT_Encode4(366228), // Rule ID 4402 //
     /* 366129 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366133 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 366139 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 366141 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366145 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366149 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366152 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366156 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366160 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366164 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366166 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366173 */     // (vector_insert:{ *:[v4f32] } immAllZerosV:{ *:[v4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366173 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366176 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366180 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366190 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366195 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366201 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366203 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366206 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366208 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366211 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366214 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366217 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366227 */     // GIR_Coverage, 4402,
     /* 366227 */     GIR_EraseRootFromParent_Done,
     /* 366228 */   // Label 7253: @366228
     /* 366228 */   GIM_Try, /*On fail goto*//*Label 7254*/ GIMT_Encode4(366328), // Rule ID 4297 //
     /* 366233 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366237 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366241 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366245 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366249 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366252 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366256 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366260 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366264 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366266 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366273 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366327 */     // GIR_Coverage, 4297,
     /* 366327 */     GIR_EraseRootFromParent_Done,
     /* 366328 */   // Label 7254: @366328
     /* 366328 */   GIM_Try, /*On fail goto*//*Label 7255*/ GIMT_Encode4(366428), // Rule ID 4299 //
     /* 366333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366341 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366345 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366349 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366352 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366356 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366360 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366364 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366366 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366373 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366385 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366395 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366401 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366403 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366406 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366408 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366417 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366427 */     // GIR_Coverage, 4299,
     /* 366427 */     GIR_EraseRootFromParent_Done,
     /* 366428 */   // Label 7255: @366428
     /* 366428 */   GIM_Try, /*On fail goto*//*Label 7256*/ GIMT_Encode4(366528), // Rule ID 4405 //
     /* 366433 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366437 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366441 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366445 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366449 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366452 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366456 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366460 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366466 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 366473 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 366473 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366476 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 366480 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366485 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366490 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366495 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366501 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366508 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366511 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366517 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366522 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366527 */     // GIR_Coverage, 4405,
     /* 366527 */     GIR_EraseRootFromParent_Done,
     /* 366528 */   // Label 7256: @366528
     /* 366528 */   GIM_Try, /*On fail goto*//*Label 7257*/ GIMT_Encode4(366628), // Rule ID 4407 //
     /* 366533 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366537 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 366549 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 366552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 366556 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 366560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 366566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 366573 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 366573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 366576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 366580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 366590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 366595 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 366601 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 366606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366608 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 366611 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366614 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366617 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366627 */     // GIR_Coverage, 4407,
     /* 366627 */     GIR_EraseRootFromParent_Done,
     /* 366628 */   // Label 7257: @366628
     /* 366628 */   GIM_Try, /*On fail goto*//*Label 7258*/ GIMT_Encode4(366741), // Rule ID 5740 //
     /* 366633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366641 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366645 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366649 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366653 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366662 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366666 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366670 */     // MIs[3] Operand 1
     /* 366670 */     // No operand predicates
     /* 366670 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366674 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366676 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 366676 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 366679 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 366683 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366688 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 366692 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366709 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366711 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366714 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366716 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366719 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366722 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366725 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366730 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366735 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366740 */     // GIR_Coverage, 5740,
     /* 366740 */     GIR_EraseRootFromParent_Done,
     /* 366741 */   // Label 7258: @366741
     /* 366741 */   GIM_Try, /*On fail goto*//*Label 7259*/ GIMT_Encode4(366854), // Rule ID 5780 //
     /* 366746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 366750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 366754 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 366758 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366762 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366766 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 366770 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366775 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 366779 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366783 */     // MIs[3] Operand 1
     /* 366783 */     // No operand predicates
     /* 366783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 366787 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366789 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), (DUPi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), ssub:{ *:[i32] })
     /* 366789 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 366792 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 366796 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366801 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 366805 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 366808 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 366810 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366813 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 366817 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366822 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 366824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 366827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366829 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 366832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 366835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 366838 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366843 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366848 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 366853 */     // GIR_Coverage, 5780,
     /* 366853 */     GIR_EraseRootFromParent_Done,
     /* 366854 */   // Label 7259: @366854
     /* 366854 */   GIM_Try, /*On fail goto*//*Label 7260*/ GIMT_Encode4(366932), // Rule ID 1940 //
     /* 366859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 366862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 366878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366899 */     // MIs[2] Operand 1
     /* 366899 */     // No operand predicates
     /* 366899 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366903 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366907 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366911 */     // MIs[3] Operand 1
     /* 366911 */     // No operand predicates
     /* 366911 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366913 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 366913 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 366916 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 366918 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 366920 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 366923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 366927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 366930 */     GIR_RootConstrainSelectedInstOperands,
     /* 366931 */     // GIR_Coverage, 1940,
     /* 366931 */     GIR_EraseRootFromParent_Done,
     /* 366932 */   // Label 7260: @366932
     /* 366932 */   GIM_Try, /*On fail goto*//*Label 7261*/ GIMT_Encode4(367021), // Rule ID 5737 //
     /* 366937 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 366941 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 366945 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 366949 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 366953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 366957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366961 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 366965 */     // MIs[2] Operand 1
     /* 366965 */     // No operand predicates
     /* 366965 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 366969 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 366973 */     // MIs[3] Operand 1
     /* 366973 */     // No operand predicates
     /* 366973 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 366975 */     // (vector_insert:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } v4f32:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4f32] } ZPR:{ *:[nxv4f32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 366975 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 366978 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 366982 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 366987 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 366993 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 366998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367003 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367006 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367008 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367010 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367016 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367019 */     GIR_RootConstrainSelectedInstOperands,
     /* 367020 */     // GIR_Coverage, 5737,
     /* 367020 */     GIR_EraseRootFromParent_Done,
     /* 367021 */   // Label 7261: @367021
     /* 367021 */   GIM_Try, /*On fail goto*//*Label 7262*/ GIMT_Encode4(367110), // Rule ID 5777 //
     /* 367026 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367030 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367034 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 367038 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367042 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367046 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367050 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367054 */     // MIs[2] Operand 1
     /* 367054 */     // No operand predicates
     /* 367054 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367058 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367062 */     // MIs[3] Operand 1
     /* 367062 */     // No operand predicates
     /* 367062 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367064 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$Immn)
     /* 367064 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367067 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 367071 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367076 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 367082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 367092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367097 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367102 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367105 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367108 */     GIR_RootConstrainSelectedInstOperands,
     /* 367109 */     // GIR_Coverage, 5777,
     /* 367109 */     GIR_EraseRootFromParent_Done,
     /* 367110 */   // Label 7262: @367110
     /* 367110 */   GIM_Try, /*On fail goto*//*Label 7263*/ GIMT_Encode4(367177), // Rule ID 5739 //
     /* 367115 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367119 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367123 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367127 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367131 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367135 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367140 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367144 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367148 */     // MIs[2] Operand 1
     /* 367148 */     // No operand predicates
     /* 367148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367156 */     // MIs[3] Operand 1
     /* 367156 */     // No operand predicates
     /* 367156 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367158 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 367158 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367161 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367163 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367165 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367168 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367172 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367175 */     GIR_RootConstrainSelectedInstOperands,
     /* 367176 */     // GIR_Coverage, 5739,
     /* 367176 */     GIR_EraseRootFromParent_Done,
     /* 367177 */   // Label 7263: @367177
     /* 367177 */   GIM_Try, /*On fail goto*//*Label 7264*/ GIMT_Encode4(367275), // Rule ID 5741 //
     /* 367182 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367215 */     // MIs[2] Operand 1
     /* 367215 */     // No operand predicates
     /* 367215 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367219 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367223 */     // MIs[3] Operand 1
     /* 367223 */     // No operand predicates
     /* 367223 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367225 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (vector_extract:{ *:[f32] } V64:{ *:[v2f32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4f32] } 0:{ *:[i64] }, V64:{ *:[v2f32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 367225 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367228 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367232 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367237 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367240 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367244 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367247 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367252 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367257 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367260 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367262 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367264 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367267 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367270 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367273 */     GIR_RootConstrainSelectedInstOperands,
     /* 367274 */     // GIR_Coverage, 5741,
     /* 367274 */     GIR_EraseRootFromParent_Done,
     /* 367275 */   // Label 7264: @367275
     /* 367275 */   GIM_Try, /*On fail goto*//*Label 7265*/ GIMT_Encode4(367342), // Rule ID 5779 //
     /* 367280 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367284 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367288 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367292 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 367296 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367300 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367305 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367309 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367313 */     // MIs[2] Operand 1
     /* 367313 */     // No operand predicates
     /* 367313 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367317 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367321 */     // MIs[3] Operand 1
     /* 367321 */     // No operand predicates
     /* 367321 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367323 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 367323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367328 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367330 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367333 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367337 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367340 */     GIR_RootConstrainSelectedInstOperands,
     /* 367341 */     // GIR_Coverage, 5779,
     /* 367341 */     GIR_EraseRootFromParent_Done,
     /* 367342 */   // Label 7265: @367342
     /* 367342 */   GIM_Try, /*On fail goto*//*Label 7266*/ GIMT_Encode4(367440), // Rule ID 5781 //
     /* 367347 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367351 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367355 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 367359 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 367363 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 367367 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367372 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 367376 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367380 */     // MIs[2] Operand 1
     /* 367380 */     // No operand predicates
     /* 367380 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 367384 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367388 */     // MIs[3] Operand 1
     /* 367388 */     // No operand predicates
     /* 367388 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 367390 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, V64:{ *:[v2i32] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 367390 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367393 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 367397 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367402 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 367405 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367409 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 367412 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367417 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 367422 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367425 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367427 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367429 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 367432 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367435 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 367438 */     GIR_RootConstrainSelectedInstOperands,
     /* 367439 */     // GIR_Coverage, 5781,
     /* 367439 */     GIR_EraseRootFromParent_Done,
     /* 367440 */   // Label 7266: @367440
     /* 367440 */   GIM_Try, /*On fail goto*//*Label 7267*/ GIMT_Encode4(367506), // Rule ID 5691 //
     /* 367445 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367449 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367453 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367457 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367461 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367463 */     // (vector_insert:{ *:[v4i32] } (undef:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), GPR32:{ *:[i32] }:$Rn, ssub:{ *:[i32] })
     /* 367463 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367466 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367470 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367475 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367482 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367485 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367487 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367490 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367495 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367500 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367505 */     // GIR_Coverage, 5691,
     /* 367505 */     GIR_EraseRootFromParent_Done,
     /* 367506 */   // Label 7267: @367506
     /* 367506 */   GIM_Try, /*On fail goto*//*Label 7268*/ GIMT_Encode4(367572), // Rule ID 5703 //
     /* 367511 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 367515 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 367519 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367523 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 367527 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367529 */     // (vector_insert:{ *:[v4f32] } (undef:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] })
     /* 367529 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367532 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367536 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367541 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 367543 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367546 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 367556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367566 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367571 */     // GIR_Coverage, 5703,
     /* 367571 */     GIR_EraseRootFromParent_Done,
     /* 367572 */   // Label 7268: @367572
     /* 367572 */   GIM_Try, /*On fail goto*//*Label 7269*/ GIMT_Encode4(367625), // Rule ID 5712 //
     /* 367577 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367581 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367585 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 367589 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 367593 */     // MIs[1] Operand 1
     /* 367593 */     // No operand predicates
     /* 367593 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367597 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367601 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367605 */     // MIs[2] Operand 1
     /* 367605 */     // No operand predicates
     /* 367605 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367607 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32gpr:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, WZR:{ *:[i32] })
     /* 367607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 367610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367612 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 367617 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 367623 */     GIR_RootConstrainSelectedInstOperands,
     /* 367624 */     // GIR_Coverage, 5712,
     /* 367624 */     GIR_EraseRootFromParent_Done,
     /* 367625 */   // Label 7269: @367625
     /* 367625 */   GIM_Try, /*On fail goto*//*Label 7270*/ GIMT_Encode4(367694), // Rule ID 6470 //
     /* 367630 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367642 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367645 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 367649 */     // MIs[1] Rn
     /* 367649 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 367653 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 367658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367666 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367670 */     // MIs[2] Operand 1
     /* 367670 */     // No operand predicates
     /* 367670 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367672 */     // (vector_insert:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4i32] } VecListOne128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 367672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 367675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367677 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367679 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367682 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367686 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367692 */     GIR_RootConstrainSelectedInstOperands,
     /* 367693 */     // GIR_Coverage, 6470,
     /* 367693 */     GIR_EraseRootFromParent_Done,
     /* 367694 */   // Label 7270: @367694
     /* 367694 */   GIM_Try, /*On fail goto*//*Label 7271*/ GIMT_Encode4(367763), // Rule ID 6471 //
     /* 367699 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367703 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367707 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 367711 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 367714 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 367718 */     // MIs[1] Rn
     /* 367718 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 367722 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 367727 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367731 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367735 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367739 */     // MIs[2] Operand 1
     /* 367739 */     // No operand predicates
     /* 367739 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367741 */     // (vector_insert:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (LD1i32:{ *:[v4f32] } VecListOne128:{ *:[v4f32] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 367741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i32),
     /* 367744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367746 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367748 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 367751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 367755 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 367761 */     GIR_RootConstrainSelectedInstOperands,
     /* 367762 */     // GIR_Coverage, 6471,
     /* 367762 */     GIR_EraseRootFromParent_Done,
     /* 367763 */   // Label 7271: @367763
     /* 367763 */   GIM_Try, /*On fail goto*//*Label 7272*/ GIMT_Encode4(367864), // Rule ID 5792 //
     /* 367768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 367772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 367776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 367780 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 367789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367793 */     // MIs[2] Operand 1
     /* 367793 */     // No operand predicates
     /* 367793 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 367795 */     // (vector_insert:{ *:[v4i32] } v4i32:{ *:[v4i32] }:$src, (bitconvert:{ *:[i32] } FPR32:{ *:[f32] }:$Sn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$src, (imm:{ *:[i64] }):$Immd, (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), FPR32:{ *:[f32] }:$Sn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367795 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 367798 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367802 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367807 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 367812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367821 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367824 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Sn
     /* 367828 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367836 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367841 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367851 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 367853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immd
     /* 367856 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367859 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 367862 */     GIR_RootConstrainSelectedInstOperands,
     /* 367863 */     // GIR_Coverage, 5792,
     /* 367863 */     GIR_EraseRootFromParent_Done,
     /* 367864 */   // Label 7272: @367864
     /* 367864 */   GIM_Try, /*On fail goto*//*Label 7273*/ GIMT_Encode4(367908), // Rule ID 1936 //
     /* 367869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 367872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 367880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367888 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367892 */     // MIs[1] Operand 1
     /* 367892 */     // No operand predicates
     /* 367892 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367894 */     // (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (INSvi32gpr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 367894 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32gpr),
     /* 367897 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367899 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 367901 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 367904 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 367906 */     GIR_RootConstrainSelectedInstOperands,
     /* 367907 */     // GIR_Coverage, 1936,
     /* 367907 */     GIR_EraseRootFromParent_Done,
     /* 367908 */   // Label 7273: @367908
     /* 367908 */   GIM_Try, /*On fail goto*//*Label 7274*/ GIMT_Encode4(368004), // Rule ID 5717 //
     /* 367913 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367917 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 367925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 367929 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 367933 */     // MIs[1] Operand 1
     /* 367933 */     // No operand predicates
     /* 367933 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 367935 */     // (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (INSvi32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm, (INSERT_SUBREG:{ *:[v4f32] } (IMPLICIT_DEF:{ *:[v4f32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 367935 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 367938 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 367942 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367947 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 367949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 367952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 367956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 367961 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 367964 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 367968 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 367971 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367976 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 367981 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 367986 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi32lane),
     /* 367989 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 367991 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 367993 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 367996 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 367999 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368002 */     GIR_RootConstrainSelectedInstOperands,
     /* 368003 */     // GIR_Coverage, 5717,
     /* 368003 */     GIR_EraseRootFromParent_Done,
     /* 368004 */   // Label 7274: @368004
     /* 368004 */   GIM_Reject,
     /* 368005 */ // Label 7241: @368005
     /* 368005 */ GIM_Reject,
     /* 368006 */ // Label 7125: @368006
     /* 368006 */ GIM_Try, /*On fail goto*//*Label 7275*/ GIMT_Encode4(371218),
     /* 368011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 368014 */   GIM_Try, /*On fail goto*//*Label 7276*/ GIMT_Encode4(368133), // Rule ID 4199 //
     /* 368019 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368022 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368025 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368029 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368033 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368039 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368041 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368045 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368049 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368052 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368056 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368060 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368064 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368066 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368073 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368073 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368076 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368080 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368085 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368090 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368095 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368100 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368106 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368108 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368111 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368113 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368116 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368119 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368122 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368127 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368132 */     // GIR_Coverage, 4199,
     /* 368132 */     GIR_EraseRootFromParent_Done,
     /* 368133 */   // Label 7276: @368133
     /* 368133 */   GIM_Try, /*On fail goto*//*Label 7277*/ GIMT_Encode4(368252), // Rule ID 4200 //
     /* 368138 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368141 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368144 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368148 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368152 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368158 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368160 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368164 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368168 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368171 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368175 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368179 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368183 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368185 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368192 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368192 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368195 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368199 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368204 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368209 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368214 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368219 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368225 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368232 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368235 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368238 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368241 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368246 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368251 */     // GIR_Coverage, 4200,
     /* 368251 */     GIR_EraseRootFromParent_Done,
     /* 368252 */   // Label 7277: @368252
     /* 368252 */   GIM_Try, /*On fail goto*//*Label 7278*/ GIMT_Encode4(368378), // Rule ID 4235 //
     /* 368257 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368260 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368263 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368271 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368277 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368287 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368290 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368294 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368301 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368305 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368309 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368311 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368318 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368318 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368321 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368325 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368330 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368335 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368345 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368351 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368361 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368364 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368367 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368372 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368377 */     // GIR_Coverage, 4235,
     /* 368377 */     GIR_EraseRootFromParent_Done,
     /* 368378 */   // Label 7278: @368378
     /* 368378 */   GIM_Try, /*On fail goto*//*Label 7279*/ GIMT_Encode4(368504), // Rule ID 4236 //
     /* 368383 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368386 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368389 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368393 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368397 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 368403 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 368405 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368409 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368413 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368416 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368420 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368427 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368431 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368437 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368444 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368444 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368447 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368451 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368461 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368471 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368477 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368479 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368482 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368484 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368487 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368490 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368493 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368498 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368503 */     // GIR_Coverage, 4236,
     /* 368503 */     GIR_EraseRootFromParent_Done,
     /* 368504 */   // Label 7279: @368504
     /* 368504 */   GIM_Try, /*On fail goto*//*Label 7280*/ GIMT_Encode4(368619), // Rule ID 4205 //
     /* 368509 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368512 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368515 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368519 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368523 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368527 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368531 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368535 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368538 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368542 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368546 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368550 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368552 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368559 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368559 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368562 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368566 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368571 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368576 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368581 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368586 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368592 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368594 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368597 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368599 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368602 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368605 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368608 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368613 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368618 */     // GIR_Coverage, 4205,
     /* 368618 */     GIR_EraseRootFromParent_Done,
     /* 368619 */   // Label 7280: @368619
     /* 368619 */   GIM_Try, /*On fail goto*//*Label 7281*/ GIMT_Encode4(368734), // Rule ID 4207 //
     /* 368624 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368627 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368630 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368634 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368638 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368642 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368646 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368650 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368653 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368657 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368661 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368665 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368667 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368674 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368674 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368677 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368681 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368691 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368696 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368701 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368707 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368720 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368723 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368728 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368733 */     // GIR_Coverage, 4207,
     /* 368733 */     GIR_EraseRootFromParent_Done,
     /* 368734 */   // Label 7281: @368734
     /* 368734 */   GIM_Try, /*On fail goto*//*Label 7282*/ GIMT_Encode4(368856), // Rule ID 4241 //
     /* 368739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368749 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368753 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368757 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368761 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368765 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368768 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368772 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368779 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368783 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368787 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368789 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 368796 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368796 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368799 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 368803 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368808 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368823 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368829 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368831 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368834 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368836 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368839 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368842 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368845 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368855 */     // GIR_Coverage, 4241,
     /* 368855 */     GIR_EraseRootFromParent_Done,
     /* 368856 */   // Label 7282: @368856
     /* 368856 */   GIM_Try, /*On fail goto*//*Label 7283*/ GIMT_Encode4(368978), // Rule ID 4243 //
     /* 368861 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 368864 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368867 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 368879 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 368883 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 368887 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 368890 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 368894 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 368901 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 368905 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 368909 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 368911 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 368918 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 368918 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 368921 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 368925 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 368930 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 368935 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 368940 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 368945 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 368951 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 368953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 368956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 368958 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 368961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 368964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 368967 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368972 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 368977 */     // GIR_Coverage, 4243,
     /* 368977 */     GIR_EraseRootFromParent_Done,
     /* 368978 */   // Label 7283: @368978
     /* 368978 */   GIM_Try, /*On fail goto*//*Label 7284*/ GIMT_Encode4(369092), // Rule ID 4197 //
     /* 368983 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 368986 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 368989 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 368993 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 368997 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369003 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369005 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369009 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369013 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369016 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369020 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369024 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369028 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369030 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369037 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369037 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369040 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369044 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369049 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369054 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369059 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369065 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369067 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369070 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369072 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369075 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369078 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369081 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369086 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369091 */     // GIR_Coverage, 4197,
     /* 369091 */     GIR_EraseRootFromParent_Done,
     /* 369092 */   // Label 7284: @369092
     /* 369092 */   GIM_Try, /*On fail goto*//*Label 7285*/ GIMT_Encode4(369206), // Rule ID 4198 //
     /* 369097 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369100 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369103 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369111 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369117 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369119 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369123 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369127 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369130 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369134 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369138 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369142 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369144 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369151 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369163 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369168 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369173 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369179 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369181 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369184 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369189 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369192 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369195 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369200 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369205 */     // GIR_Coverage, 4198,
     /* 369205 */     GIR_EraseRootFromParent_Done,
     /* 369206 */   // Label 7285: @369206
     /* 369206 */   GIM_Try, /*On fail goto*//*Label 7286*/ GIMT_Encode4(369327), // Rule ID 4233 //
     /* 369211 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369214 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369217 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369221 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369225 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369231 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369233 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369237 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369241 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369244 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369248 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369255 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369259 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369263 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369265 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369272 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369284 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369289 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369294 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369300 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369307 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369310 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369313 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369316 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369321 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369326 */     // GIR_Coverage, 4233,
     /* 369326 */     GIR_EraseRootFromParent_Done,
     /* 369327 */   // Label 7286: @369327
     /* 369327 */   GIM_Try, /*On fail goto*//*Label 7287*/ GIMT_Encode4(369448), // Rule ID 4234 //
     /* 369332 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369335 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369338 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369342 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369346 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 369352 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 369354 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369358 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369362 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369365 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369369 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369376 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369380 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369386 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369393 */     // (vector_insert:{ *:[v8i8] } immAllZerosV:{ *:[v8i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369405 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369415 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369421 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369423 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369426 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369428 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369431 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369434 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369437 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369442 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369447 */     // GIR_Coverage, 4234,
     /* 369447 */     GIR_EraseRootFromParent_Done,
     /* 369448 */   // Label 7287: @369448
     /* 369448 */   GIM_Try, /*On fail goto*//*Label 7288*/ GIMT_Encode4(369558), // Rule ID 4201 //
     /* 369453 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369456 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369459 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369467 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369471 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369475 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369479 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369482 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369486 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369490 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369494 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369496 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369503 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369503 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369506 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369510 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369515 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369520 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369525 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369533 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369536 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369541 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369544 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369547 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369552 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369557 */     // GIR_Coverage, 4201,
     /* 369557 */     GIR_EraseRootFromParent_Done,
     /* 369558 */   // Label 7288: @369558
     /* 369558 */   GIM_Try, /*On fail goto*//*Label 7289*/ GIMT_Encode4(369668), // Rule ID 4203 //
     /* 369563 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369566 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369569 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369573 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369577 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369581 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369585 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369589 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369592 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369596 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369600 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369604 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369606 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369613 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369625 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369630 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369635 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369641 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369643 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369646 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369648 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369651 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369654 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369657 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369662 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369667 */     // GIR_Coverage, 4203,
     /* 369667 */     GIR_EraseRootFromParent_Done,
     /* 369668 */   // Label 7289: @369668
     /* 369668 */   GIM_Try, /*On fail goto*//*Label 7290*/ GIMT_Encode4(369785), // Rule ID 4237 //
     /* 369673 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369676 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369679 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369683 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369687 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369691 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369695 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369699 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369702 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369706 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369713 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369717 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369721 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369723 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 369730 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 369730 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369733 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 369737 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369742 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369747 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369752 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369765 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369768 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369771 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369779 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369784 */     // GIR_Coverage, 4237,
     /* 369784 */     GIR_EraseRootFromParent_Done,
     /* 369785 */   // Label 7290: @369785
     /* 369785 */   GIM_Try, /*On fail goto*//*Label 7291*/ GIMT_Encode4(369902), // Rule ID 4239 //
     /* 369790 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 369793 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369796 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369800 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 369804 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 369808 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 369812 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 369816 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 369819 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 369823 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 369830 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 369834 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 369838 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 369840 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 369847 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 369847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 369850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 369854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369859 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 369864 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 369869 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 369875 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 369877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 369882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 369885 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 369888 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 369891 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369896 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 369901 */     // GIR_Coverage, 4239,
     /* 369901 */     GIR_EraseRootFromParent_Done,
     /* 369902 */   // Label 7291: @369902
     /* 369902 */   GIM_Try, /*On fail goto*//*Label 7292*/ GIMT_Encode4(370042), // Rule ID 5758 //
     /* 369907 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 369910 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 369913 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369917 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369921 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 369925 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 369929 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 369933 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 369937 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369942 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 369946 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369950 */     // MIs[2] Operand 1
     /* 369950 */     // No operand predicates
     /* 369950 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 369954 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 369958 */     // MIs[3] Operand 1
     /* 369958 */     // No operand predicates
     /* 369958 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 369960 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 369960 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 369963 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 369967 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 369972 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 369975 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 369979 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 369982 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 369987 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 369992 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 369995 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 369999 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370004 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370010 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370014 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370017 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370019 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370022 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370024 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370031 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370041 */     // GIR_Coverage, 5758,
     /* 370041 */     GIR_EraseRootFromParent_Done,
     /* 370042 */   // Label 7292: @370042
     /* 370042 */   GIM_Try, /*On fail goto*//*Label 7293*/ GIMT_Encode4(370213), // Rule ID 5759 //
     /* 370047 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370050 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370053 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370057 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370061 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370065 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370069 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370073 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370077 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370082 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370086 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370090 */     // MIs[2] Operand 1
     /* 370090 */     // No operand predicates
     /* 370090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370098 */     // MIs[3] Operand 1
     /* 370098 */     // No operand predicates
     /* 370098 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370100 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370100 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 370103 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370107 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370112 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 370115 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370119 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 370122 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370127 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370144 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370147 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370151 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370154 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370159 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370164 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370167 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370171 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370176 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370179 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370182 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370185 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370188 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370190 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370193 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370195 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370202 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370207 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370212 */     // GIR_Coverage, 5759,
     /* 370212 */     GIR_EraseRootFromParent_Done,
     /* 370213 */   // Label 7293: @370213
     /* 370213 */   GIM_Try, /*On fail goto*//*Label 7294*/ GIMT_Encode4(370353), // Rule ID 5766 //
     /* 370218 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370221 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370224 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370228 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 370244 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370248 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370261 */     // MIs[2] Operand 1
     /* 370261 */     // No operand predicates
     /* 370261 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370265 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370269 */     // MIs[3] Operand 1
     /* 370269 */     // No operand predicates
     /* 370269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370271 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370271 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370274 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370278 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370283 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370286 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370290 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370293 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370298 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370303 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370306 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370310 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370315 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370321 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370325 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370328 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370330 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370333 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370335 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370352 */     // GIR_Coverage, 5766,
     /* 370352 */     GIR_EraseRootFromParent_Done,
     /* 370353 */   // Label 7294: @370353
     /* 370353 */   GIM_Try, /*On fail goto*//*Label 7295*/ GIMT_Encode4(370524), // Rule ID 5767 //
     /* 370358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 370380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 370384 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 370388 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370393 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 370397 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370401 */     // MIs[2] Operand 1
     /* 370401 */     // No operand predicates
     /* 370401 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 370405 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370409 */     // MIs[3] Operand 1
     /* 370409 */     // No operand predicates
     /* 370409 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 370411 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$src, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn), dsub:{ *:[i32] })
     /* 370411 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 370414 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370418 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370423 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 370426 */     GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370430 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/3,
     /* 370433 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370438 */     GIR_ConstrainOperandRC, /*InsnID*/3, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370443 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370446 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370450 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370455 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370458 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 370462 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370465 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370470 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 370482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370487 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370490 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // Immd
     /* 370493 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 370496 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // Immn
     /* 370499 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370501 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370504 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370506 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370513 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370518 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370523 */     // GIR_Coverage, 5767,
     /* 370523 */     GIR_EraseRootFromParent_Done,
     /* 370524 */   // Label 7295: @370524
     /* 370524 */   GIM_Try, /*On fail goto*//*Label 7296*/ GIMT_Encode4(370603), // Rule ID 5682 //
     /* 370529 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370532 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370535 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370539 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 370543 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 370547 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370551 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 370555 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370557 */     // (vector_insert:{ *:[v8i8] } (undef:{ *:[v8i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 370557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 370560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370569 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 370573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370578 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370581 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370583 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 370586 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 370589 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 370592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 370602 */     // GIR_Coverage, 5682,
     /* 370602 */     GIR_EraseRootFromParent_Done,
     /* 370603 */   // Label 7296: @370603
     /* 370603 */   GIM_Try, /*On fail goto*//*Label 7297*/ GIMT_Encode4(370745), // Rule ID 6487 //
     /* 370608 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 370611 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370614 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370618 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370622 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370626 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370630 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370633 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 370637 */     // MIs[1] Rn
     /* 370637 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 370641 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 370646 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 370650 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370654 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370658 */     // MIs[2] Operand 1
     /* 370658 */     // No operand predicates
     /* 370658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370660 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 370660 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370663 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370667 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370672 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370675 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 370679 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370682 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370687 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370704 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370707 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370710 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370714 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370720 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370722 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370725 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370727 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370734 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370739 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370744 */     // GIR_Coverage, 6487,
     /* 370744 */     GIR_EraseRootFromParent_Done,
     /* 370745 */   // Label 7297: @370745
     /* 370745 */   GIM_Try, /*On fail goto*//*Label 7298*/ GIMT_Encode4(370894), // Rule ID 6488 //
     /* 370750 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370753 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370756 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370760 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370764 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 370768 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 370772 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 370775 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 370779 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 370786 */     // MIs[1] Rn
     /* 370786 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 370790 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 370795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 370799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370803 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370807 */     // MIs[2] Operand 1
     /* 370807 */     // No operand predicates
     /* 370807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 370809 */     // (vector_insert:{ *:[v8i8] } VecListOne64:{ *:[v8i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (LD1i8:{ *:[f128] } (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, VecListOne64:{ *:[v8i8] }:$Rd, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn), dsub:{ *:[i32] })
     /* 370809 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 370812 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 370816 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370821 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/0,
     /* 370824 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rd
     /* 370828 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370831 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370836 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370841 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370844 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 370848 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370853 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/2, // idx
     /* 370859 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 370863 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 370869 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 370871 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 370874 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 370876 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 370883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370893 */     // GIR_Coverage, 6488,
     /* 370893 */     GIR_EraseRootFromParent_Done,
     /* 370894 */   // Label 7298: @370894
     /* 370894 */   GIM_Try, /*On fail goto*//*Label 7299*/ GIMT_Encode4(371029), // Rule ID 5721 //
     /* 370899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 370902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 370905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 370917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 370921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 370925 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 370929 */     // MIs[1] Operand 1
     /* 370929 */     // No operand predicates
     /* 370929 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 370931 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, GPR32:{ *:[i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8gpr:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, GPR32:{ *:[i32] }:$Rm), dsub:{ *:[i32] })
     /* 370931 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 370934 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 370938 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370943 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 370945 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 370948 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 370952 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370957 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 370960 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 370964 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 370967 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370972 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 370977 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 370982 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 370985 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 370989 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 370994 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 370997 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 371000 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371004 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371006 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371009 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371011 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371018 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371023 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371028 */     // GIR_Coverage, 5721,
     /* 371028 */     GIR_EraseRootFromParent_Done,
     /* 371029 */   // Label 7299: @371029
     /* 371029 */   GIM_Try, /*On fail goto*//*Label 7300*/ GIMT_Encode4(371217), // Rule ID 5722 //
     /* 371034 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 371037 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371040 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371044 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371048 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371052 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 371056 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 371060 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 371064 */     // MIs[1] Operand 1
     /* 371064 */     // No operand predicates
     /* 371064 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 371066 */     // (vector_insert:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (INSvi8lane:{ *:[f128] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] }), dsub:{ *:[i32] })
     /* 371066 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v16s8,
     /* 371069 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371073 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371078 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 371080 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v16s8,
     /* 371083 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371087 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371092 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 371095 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 371099 */     GIR_AddImm8, /*InsnID*/4, /*Imm*/1,
     /* 371102 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371107 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371112 */     GIR_ConstrainOperandRC, /*InsnID*/4, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 371117 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v16s8,
     /* 371120 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 371124 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371129 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 371131 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 371134 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 371138 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371143 */     GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 371146 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 371150 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/3,
     /* 371153 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371158 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371163 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371168 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 371171 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 371175 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371180 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 371183 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // imm
     /* 371186 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 371189 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 371192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 371197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371199 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 371206 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 371211 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371216 */     // GIR_Coverage, 5722,
     /* 371216 */     GIR_EraseRootFromParent_Done,
     /* 371217 */   // Label 7300: @371217
     /* 371217 */   GIM_Reject,
     /* 371218 */ // Label 7275: @371218
     /* 371218 */ GIM_Reject,
     /* 371219 */ // Label 7126: @371219
     /* 371219 */ GIM_Try, /*On fail goto*//*Label 7301*/ GIMT_Encode4(374637),
     /* 371224 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 371227 */   GIM_Try, /*On fail goto*//*Label 7302*/ GIMT_Encode4(371353), // Rule ID 4259 //
     /* 371232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371242 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371246 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371252 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371254 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371258 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371262 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371265 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371269 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371276 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371280 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371286 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371293 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371293 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371296 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371300 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371305 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371310 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371315 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371320 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371326 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371328 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371331 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371339 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371342 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371347 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371352 */     // GIR_Coverage, 4259,
     /* 371352 */     GIR_EraseRootFromParent_Done,
     /* 371353 */   // Label 7302: @371353
     /* 371353 */   GIM_Try, /*On fail goto*//*Label 7303*/ GIMT_Encode4(371479), // Rule ID 4260 //
     /* 371358 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371361 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371364 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371368 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371372 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371378 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371380 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371384 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371388 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371391 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371395 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371402 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371406 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371410 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371412 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371419 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371419 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371422 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371426 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371431 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371436 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371441 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371446 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371459 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371462 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371465 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371468 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371473 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371478 */     // GIR_Coverage, 4260,
     /* 371478 */     GIR_EraseRootFromParent_Done,
     /* 371479 */   // Label 7303: @371479
     /* 371479 */   GIM_Try, /*On fail goto*//*Label 7304*/ GIMT_Encode4(371598), // Rule ID 4367 //
     /* 371484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371494 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371498 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371504 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371514 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371517 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371521 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371525 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371529 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371531 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371538 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371550 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371555 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371560 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371565 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371571 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371573 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371576 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371578 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371581 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371584 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371587 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371592 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371597 */     // GIR_Coverage, 4367,
     /* 371597 */     GIR_EraseRootFromParent_Done,
     /* 371598 */   // Label 7304: @371598
     /* 371598 */   GIM_Try, /*On fail goto*//*Label 7305*/ GIMT_Encode4(371717), // Rule ID 4368 //
     /* 371603 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371606 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371609 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371617 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 371623 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 371625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371633 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371657 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371684 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371690 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371697 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371700 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371703 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371716 */     // GIR_Coverage, 4368,
     /* 371716 */     GIR_EraseRootFromParent_Done,
     /* 371717 */   // Label 7305: @371717
     /* 371717 */   GIM_Try, /*On fail goto*//*Label 7306*/ GIMT_Encode4(371839), // Rule ID 4265 //
     /* 371722 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371725 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371728 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371740 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371744 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371748 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371751 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371755 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371762 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371766 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371770 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371772 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 371779 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371779 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371782 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 371786 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371791 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371796 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371801 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371806 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371812 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371819 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371822 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371825 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371828 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371833 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371838 */     // GIR_Coverage, 4265,
     /* 371838 */     GIR_EraseRootFromParent_Done,
     /* 371839 */   // Label 7306: @371839
     /* 371839 */   GIM_Try, /*On fail goto*//*Label 7307*/ GIMT_Encode4(371961), // Rule ID 4267 //
     /* 371844 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 371847 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371850 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371862 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371866 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371870 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371873 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371877 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 371884 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 371888 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 371892 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 371894 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 371901 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 371901 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 371904 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 371908 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 371913 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 371918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 371923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 371928 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 371934 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 371936 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 371939 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 371941 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 371944 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 371947 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 371950 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 371960 */     // GIR_Coverage, 4267,
     /* 371960 */     GIR_EraseRootFromParent_Done,
     /* 371961 */   // Label 7307: @371961
     /* 371961 */   GIM_Try, /*On fail goto*//*Label 7308*/ GIMT_Encode4(372076), // Rule ID 4373 //
     /* 371966 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 371969 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 371972 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 371976 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 371980 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 371984 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 371988 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 371992 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 371995 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 371999 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372003 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372007 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372009 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 372016 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372016 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372019 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 372023 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372028 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372033 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372038 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372043 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372049 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372051 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372054 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372059 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372062 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372065 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372070 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372075 */     // GIR_Coverage, 4373,
     /* 372075 */     GIR_EraseRootFromParent_Done,
     /* 372076 */   // Label 7308: @372076
     /* 372076 */   GIM_Try, /*On fail goto*//*Label 7309*/ GIMT_Encode4(372191), // Rule ID 4375 //
     /* 372081 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372084 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372087 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372091 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372095 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372099 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372103 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372107 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372110 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372114 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372118 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372122 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372124 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 372131 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 372131 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372134 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 372138 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372143 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372148 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 372153 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 372158 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372164 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372166 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372169 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372171 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372174 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372177 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372180 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372185 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372190 */     // GIR_Coverage, 4375,
     /* 372190 */     GIR_EraseRootFromParent_Done,
     /* 372191 */   // Label 7309: @372191
     /* 372191 */   GIM_Try, /*On fail goto*//*Label 7310*/ GIMT_Encode4(372312), // Rule ID 4257 //
     /* 372196 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372199 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372202 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372210 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372216 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372226 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372229 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372233 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372240 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372244 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372248 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372250 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372257 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372257 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372260 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372264 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372269 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372274 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372279 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372285 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372287 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372290 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372292 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372295 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372298 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372301 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372306 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372311 */     // GIR_Coverage, 4257,
     /* 372311 */     GIR_EraseRootFromParent_Done,
     /* 372312 */   // Label 7310: @372312
     /* 372312 */   GIM_Try, /*On fail goto*//*Label 7311*/ GIMT_Encode4(372433), // Rule ID 4258 //
     /* 372317 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372320 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372323 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372327 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372331 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372337 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372339 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372343 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372347 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372350 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372354 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372361 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372365 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372369 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372371 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372378 */     // (vector_insert:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372378 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372381 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372385 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372390 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372395 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372400 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372406 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372413 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372416 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372419 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372422 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372427 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372432 */     // GIR_Coverage, 4258,
     /* 372432 */     GIR_EraseRootFromParent_Done,
     /* 372433 */   // Label 7311: @372433
     /* 372433 */   GIM_Try, /*On fail goto*//*Label 7312*/ GIMT_Encode4(372547), // Rule ID 4365 //
     /* 372438 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372441 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372444 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372448 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372452 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372458 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372460 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372464 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372468 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372471 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372475 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372479 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372483 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372485 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372492 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372492 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372495 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372499 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372504 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372509 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372514 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372520 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372522 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372525 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372527 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372530 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372533 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372536 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372541 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372546 */     // GIR_Coverage, 4365,
     /* 372546 */     GIR_EraseRootFromParent_Done,
     /* 372547 */   // Label 7312: @372547
     /* 372547 */   GIM_Try, /*On fail goto*//*Label 7313*/ GIMT_Encode4(372661), // Rule ID 4366 //
     /* 372552 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372555 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372558 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372562 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372566 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 372572 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 372574 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372578 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372582 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372585 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372589 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372593 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372597 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372599 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372606 */     // (vector_insert:{ *:[v8f16] } immAllZerosV:{ *:[v8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372606 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372609 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372613 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372618 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372623 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372628 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372634 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372636 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372639 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372644 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372647 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372650 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372655 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372660 */     // GIR_Coverage, 4366,
     /* 372660 */     GIR_EraseRootFromParent_Done,
     /* 372661 */   // Label 7313: @372661
     /* 372661 */   GIM_Try, /*On fail goto*//*Label 7314*/ GIMT_Encode4(372778), // Rule ID 4261 //
     /* 372666 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372669 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372672 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372684 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372688 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372692 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372695 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372699 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372706 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372710 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372714 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372716 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372723 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372723 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372726 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372730 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372735 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372745 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372751 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372753 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372756 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372758 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372761 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372764 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372767 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372772 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372777 */     // GIR_Coverage, 4261,
     /* 372777 */     GIR_EraseRootFromParent_Done,
     /* 372778 */   // Label 7314: @372778
     /* 372778 */   GIM_Try, /*On fail goto*//*Label 7315*/ GIMT_Encode4(372895), // Rule ID 4263 //
     /* 372783 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 372786 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372789 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372801 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372805 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372809 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372812 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372816 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 372823 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372827 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372831 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372833 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 372840 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 372840 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372843 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 372847 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372852 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372857 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372862 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372875 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372884 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372889 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 372894 */     // GIR_Coverage, 4263,
     /* 372894 */     GIR_EraseRootFromParent_Done,
     /* 372895 */   // Label 7315: @372895
     /* 372895 */   GIM_Try, /*On fail goto*//*Label 7316*/ GIMT_Encode4(373005), // Rule ID 4369 //
     /* 372900 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 372903 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 372906 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372910 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 372914 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 372918 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 372922 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 372926 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 372929 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 372933 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 372937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 372941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 372943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 372950 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 372950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 372953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 372957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 372962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 372967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 372972 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 372978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 372980 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 372983 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 372985 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 372988 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 372991 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 372994 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 372999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373004 */     // GIR_Coverage, 4369,
     /* 373004 */     GIR_EraseRootFromParent_Done,
     /* 373005 */   // Label 7316: @373005
     /* 373005 */   GIM_Try, /*On fail goto*//*Label 7317*/ GIMT_Encode4(373115), // Rule ID 4371 //
     /* 373010 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373013 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373016 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373028 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373032 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 373036 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 373039 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 373043 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 373047 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373051 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 373053 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 373060 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 373060 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 373063 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 373067 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373072 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 373077 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 373082 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 373088 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373095 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 373098 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373101 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373104 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373109 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373114 */     // GIR_Coverage, 4371,
     /* 373114 */     GIR_EraseRootFromParent_Done,
     /* 373115 */   // Label 7317: @373115
     /* 373115 */   GIM_Try, /*On fail goto*//*Label 7318*/ GIMT_Encode4(373238), // Rule ID 5732 //
     /* 373120 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373123 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373126 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373130 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373134 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373138 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373142 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373146 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373150 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373154 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373159 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373163 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373167 */     // MIs[3] Operand 1
     /* 373167 */     // No operand predicates
     /* 373167 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373173 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 373173 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 373176 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 373180 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373185 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 373192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373194 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373197 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373201 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373206 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373208 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373211 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373213 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373219 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373222 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373227 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373237 */     // GIR_Coverage, 5732,
     /* 373237 */     GIR_EraseRootFromParent_Done,
     /* 373238 */   // Label 7318: @373238
     /* 373238 */   GIM_Try, /*On fail goto*//*Label 7319*/ GIMT_Encode4(373361), // Rule ID 5772 //
     /* 373243 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373246 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373249 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373253 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 373257 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 373261 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 373265 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373269 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373273 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 373277 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373282 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 373286 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373290 */     // MIs[3] Operand 1
     /* 373290 */     // No operand predicates
     /* 373290 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 373294 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373296 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), (DUPi16:{ *:[i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), hsub:{ *:[i32] })
     /* 373296 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 373299 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 373303 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373308 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 373312 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 373315 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 373317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 373324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373329 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 373331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 373334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373336 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373339 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 373342 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 373345 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373350 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 373360 */     // GIR_Coverage, 5772,
     /* 373360 */     GIR_EraseRootFromParent_Done,
     /* 373361 */   // Label 7319: @373361
     /* 373361 */   GIM_Try, /*On fail goto*//*Label 7320*/ GIMT_Encode4(373449), // Rule ID 1939 //
     /* 373366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 373369 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373372 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373375 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373395 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373399 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373404 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373408 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373412 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373416 */     // MIs[2] Operand 1
     /* 373416 */     // No operand predicates
     /* 373416 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373420 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373424 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373428 */     // MIs[3] Operand 1
     /* 373428 */     // No operand predicates
     /* 373428 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373430 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 373430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373435 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 373437 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 373440 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373444 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 373447 */     GIR_RootConstrainSelectedInstOperands,
     /* 373448 */     // GIR_Coverage, 1939,
     /* 373448 */     GIR_EraseRootFromParent_Done,
     /* 373449 */   // Label 7320: @373449
     /* 373449 */   GIM_Try, /*On fail goto*//*Label 7321*/ GIMT_Encode4(373548), // Rule ID 5729 //
     /* 373454 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373457 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373460 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373464 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373468 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373472 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 373476 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373480 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373484 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373488 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373492 */     // MIs[2] Operand 1
     /* 373492 */     // No operand predicates
     /* 373492 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373496 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373500 */     // MIs[3] Operand 1
     /* 373500 */     // No operand predicates
     /* 373500 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373502 */     // (vector_insert:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } v8f16:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8f16] } ZPR:{ *:[nxv8f16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 373502 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373505 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373509 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373514 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 373520 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373525 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 373530 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373533 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373535 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373537 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373540 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373543 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373546 */     GIR_RootConstrainSelectedInstOperands,
     /* 373547 */     // GIR_Coverage, 5729,
     /* 373547 */     GIR_EraseRootFromParent_Done,
     /* 373548 */   // Label 7321: @373548
     /* 373548 */   GIM_Try, /*On fail goto*//*Label 7322*/ GIMT_Encode4(373647), // Rule ID 5769 //
     /* 373553 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373556 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373559 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 373575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373579 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373583 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373587 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 373591 */     // MIs[2] Operand 1
     /* 373591 */     // No operand predicates
     /* 373591 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373595 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373599 */     // MIs[3] Operand 1
     /* 373599 */     // No operand predicates
     /* 373599 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373601 */     // (vector_insert:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } v8i16:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$Immn)
     /* 373601 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373604 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 373608 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373613 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 373619 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373624 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 373629 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373632 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373634 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 373636 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373639 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373642 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373645 */     GIR_RootConstrainSelectedInstOperands,
     /* 373646 */     // GIR_Coverage, 5769,
     /* 373646 */     GIR_EraseRootFromParent_Done,
     /* 373647 */   // Label 7322: @373647
     /* 373647 */   GIM_Try, /*On fail goto*//*Label 7323*/ GIMT_Encode4(373724), // Rule ID 5731 //
     /* 373652 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373655 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373658 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373662 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373666 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373670 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373674 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373678 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373682 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373687 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373691 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373695 */     // MIs[2] Operand 1
     /* 373695 */     // No operand predicates
     /* 373695 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373699 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373703 */     // MIs[3] Operand 1
     /* 373703 */     // No operand predicates
     /* 373703 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373705 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 373705 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373708 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373710 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373712 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373715 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373719 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373722 */     GIR_RootConstrainSelectedInstOperands,
     /* 373723 */     // GIR_Coverage, 5731,
     /* 373723 */     GIR_EraseRootFromParent_Done,
     /* 373724 */   // Label 7323: @373724
     /* 373724 */   GIM_Try, /*On fail goto*//*Label 7324*/ GIMT_Encode4(373832), // Rule ID 5733 //
     /* 373729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 373732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373739 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373743 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373747 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373751 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373755 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373759 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373764 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373768 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373772 */     // MIs[2] Operand 1
     /* 373772 */     // No operand predicates
     /* 373772 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373776 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373780 */     // MIs[3] Operand 1
     /* 373780 */     // No operand predicates
     /* 373780 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373782 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (vector_extract:{ *:[f16] } V64:{ *:[v4f16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8f16] } 0:{ *:[i64] }, V64:{ *:[v4f16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373782 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373785 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373789 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373794 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373797 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373801 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373804 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373809 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373814 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373817 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373819 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373821 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373824 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 373827 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373830 */     GIR_RootConstrainSelectedInstOperands,
     /* 373831 */     // GIR_Coverage, 5733,
     /* 373831 */     GIR_EraseRootFromParent_Done,
     /* 373832 */   // Label 7324: @373832
     /* 373832 */   GIM_Try, /*On fail goto*//*Label 7325*/ GIMT_Encode4(373909), // Rule ID 5771 //
     /* 373837 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373840 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373843 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373847 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373851 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373855 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373859 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 373863 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373867 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373872 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373876 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373880 */     // MIs[2] Operand 1
     /* 373880 */     // No operand predicates
     /* 373880 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373884 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373888 */     // MIs[3] Operand 1
     /* 373888 */     // No operand predicates
     /* 373888 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373890 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 373890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 373893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 373895 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 373897 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 373900 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 373907 */     GIR_RootConstrainSelectedInstOperands,
     /* 373908 */     // GIR_Coverage, 5771,
     /* 373908 */     GIR_EraseRootFromParent_Done,
     /* 373909 */   // Label 7325: @373909
     /* 373909 */   GIM_Try, /*On fail goto*//*Label 7326*/ GIMT_Encode4(374017), // Rule ID 5773 //
     /* 373914 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 373917 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 373920 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373924 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373928 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 373932 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 373936 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 373940 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 373944 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373949 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 373953 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373957 */     // MIs[2] Operand 1
     /* 373957 */     // No operand predicates
     /* 373957 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 373961 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 373965 */     // MIs[3] Operand 1
     /* 373965 */     // No operand predicates
     /* 373965 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 373967 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i64] }, V64:{ *:[v4i16] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 373967 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 373970 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 373974 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 373979 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 373982 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 373986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 373989 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 373994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 373999 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374002 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374004 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 374006 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 374009 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374012 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 374015 */     GIR_RootConstrainSelectedInstOperands,
     /* 374016 */     // GIR_Coverage, 5773,
     /* 374016 */     GIR_EraseRootFromParent_Done,
     /* 374017 */   // Label 7326: @374017
     /* 374017 */   GIM_Try, /*On fail goto*//*Label 7327*/ GIMT_Encode4(374096), // Rule ID 5685 //
     /* 374022 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374025 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374028 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 374044 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374048 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374050 */     // (vector_insert:{ *:[v8i16] } (undef:{ *:[v8i16] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v8i16] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 374050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 374053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 374057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374062 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 374066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 374085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 374095 */     // GIR_Coverage, 5685,
     /* 374095 */     GIR_EraseRootFromParent_Done,
     /* 374096 */   // Label 7327: @374096
     /* 374096 */   GIM_Try, /*On fail goto*//*Label 7328*/ GIMT_Encode4(374172), // Rule ID 5697 //
     /* 374101 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374104 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374107 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374119 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374123 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374127 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374129 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 374129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374141 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374143 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374146 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374148 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374153 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374156 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374161 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374166 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374171 */     // GIR_Coverage, 5697,
     /* 374171 */     GIR_EraseRootFromParent_Done,
     /* 374172 */   // Label 7328: @374172
     /* 374172 */   GIM_Try, /*On fail goto*//*Label 7329*/ GIMT_Encode4(374248), // Rule ID 5701 //
     /* 374177 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374180 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374183 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374187 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374191 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 374195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374199 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374203 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374205 */     // (vector_insert:{ *:[v8f16] } (undef:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] })
     /* 374205 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374208 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374212 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374217 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374219 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374222 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374224 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374227 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374229 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 374232 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374237 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374242 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374247 */     // GIR_Coverage, 5701,
     /* 374247 */     GIR_EraseRootFromParent_Done,
     /* 374248 */   // Label 7329: @374248
     /* 374248 */   GIM_Try, /*On fail goto*//*Label 7330*/ GIMT_Encode4(374311), // Rule ID 5710 //
     /* 374253 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374256 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374259 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374263 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374267 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374271 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 374275 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 374279 */     // MIs[1] Operand 1
     /* 374279 */     // No operand predicates
     /* 374279 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374283 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374287 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374291 */     // MIs[2] Operand 1
     /* 374291 */     // No operand predicates
     /* 374291 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374293 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16gpr:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, WZR:{ *:[i32] })
     /* 374293 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 374296 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374298 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374300 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // imm
     /* 374303 */     GIR_AddRegister, /*InsnID*/0, GIMT_Encode2(AArch64::WZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 374309 */     GIR_RootConstrainSelectedInstOperands,
     /* 374310 */     // GIR_Coverage, 5710,
     /* 374310 */     GIR_EraseRootFromParent_Done,
     /* 374311 */   // Label 7330: @374311
     /* 374311 */   GIM_Try, /*On fail goto*//*Label 7331*/ GIMT_Encode4(374397), // Rule ID 6469 //
     /* 374316 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374319 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374322 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374326 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374330 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374334 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374338 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374341 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 374345 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 374352 */     // MIs[1] Rn
     /* 374352 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 374356 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 374361 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374365 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374369 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374373 */     // MIs[2] Operand 1
     /* 374373 */     // No operand predicates
     /* 374373 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374375 */     // (vector_insert:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8i16] } VecListOne128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 374375 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 374378 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374380 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374382 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374385 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374389 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374395 */     GIR_RootConstrainSelectedInstOperands,
     /* 374396 */     // GIR_Coverage, 6469,
     /* 374396 */     GIR_EraseRootFromParent_Done,
     /* 374397 */   // Label 7331: @374397
     /* 374397 */   GIM_Try, /*On fail goto*//*Label 7332*/ GIMT_Encode4(374476), // Rule ID 6474 //
     /* 374402 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374405 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374408 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374412 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374416 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 374420 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374424 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374427 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 374431 */     // MIs[1] Rn
     /* 374431 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 374435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 374440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 374444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374448 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374452 */     // MIs[2] Operand 1
     /* 374452 */     // No operand predicates
     /* 374452 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374454 */     // (vector_insert:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (LD1i16:{ *:[v8f16] } VecListOne128:{ *:[v8f16] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 374454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i16),
     /* 374457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374459 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374461 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 374464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 374468 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374474 */     GIR_RootConstrainSelectedInstOperands,
     /* 374475 */     // GIR_Coverage, 6474,
     /* 374475 */     GIR_EraseRootFromParent_Done,
     /* 374476 */   // Label 7332: @374476
     /* 374476 */   GIM_Try, /*On fail goto*//*Label 7333*/ GIMT_Encode4(374530), // Rule ID 1935 //
     /* 374481 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 374484 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374487 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374490 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374498 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 374502 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 374506 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374510 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374514 */     // MIs[1] Operand 1
     /* 374514 */     // No operand predicates
     /* 374514 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374516 */     // (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (INSvi16gpr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 374516 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16gpr),
     /* 374519 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374521 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 374523 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 374526 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 374528 */     GIR_RootConstrainSelectedInstOperands,
     /* 374529 */     // GIR_Coverage, 1935,
     /* 374529 */     GIR_EraseRootFromParent_Done,
     /* 374530 */   // Label 7333: @374530
     /* 374530 */   GIM_Try, /*On fail goto*//*Label 7334*/ GIMT_Encode4(374636), // Rule ID 5715 //
     /* 374535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 374538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374545 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374549 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374553 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 374557 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 374561 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 374565 */     // MIs[1] Operand 1
     /* 374565 */     // No operand predicates
     /* 374565 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 374567 */     // (vector_insert:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (INSvi16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm, (INSERT_SUBREG:{ *:[v8f16] } (IMPLICIT_DEF:{ *:[v8f16] }), FPR16:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 374567 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 374570 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 374574 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374579 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 374581 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 374584 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 374588 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374593 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 374596 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 374600 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 374603 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374608 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374613 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 374618 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi16lane),
     /* 374621 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374623 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 374625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 374628 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374634 */     GIR_RootConstrainSelectedInstOperands,
     /* 374635 */     // GIR_Coverage, 5715,
     /* 374635 */     GIR_EraseRootFromParent_Done,
     /* 374636 */   // Label 7334: @374636
     /* 374636 */   GIM_Reject,
     /* 374637 */ // Label 7301: @374637
     /* 374637 */ GIM_Reject,
     /* 374638 */ // Label 7127: @374638
     /* 374638 */ GIM_Try, /*On fail goto*//*Label 7335*/ GIMT_Encode4(377841),
     /* 374643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 374646 */   GIM_Try, /*On fail goto*//*Label 7336*/ GIMT_Encode4(374765), // Rule ID 4187 //
     /* 374651 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374654 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374657 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374661 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374665 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374671 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374673 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374677 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374681 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374684 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374688 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374692 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374696 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374698 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374705 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374705 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374708 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374712 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374717 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374722 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374727 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374732 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374738 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374740 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374743 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374745 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374748 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374751 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374754 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374759 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374764 */     // GIR_Coverage, 4187,
     /* 374764 */     GIR_EraseRootFromParent_Done,
     /* 374765 */   // Label 7336: @374765
     /* 374765 */   GIM_Try, /*On fail goto*//*Label 7337*/ GIMT_Encode4(374884), // Rule ID 4188 //
     /* 374770 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 374773 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374776 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374780 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374784 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374790 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374792 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374796 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374800 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374803 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374807 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374811 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374815 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374817 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 374824 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374824 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374827 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 374831 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374841 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374851 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374857 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374859 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374862 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374864 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374867 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374870 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374873 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374878 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 374883 */     // GIR_Coverage, 4188,
     /* 374883 */     GIR_EraseRootFromParent_Done,
     /* 374884 */   // Label 7337: @374884
     /* 374884 */   GIM_Try, /*On fail goto*//*Label 7338*/ GIMT_Encode4(375010), // Rule ID 4223 //
     /* 374889 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 374892 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 374895 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 374899 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 374903 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 374909 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 374911 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 374915 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 374919 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 374922 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 374926 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 374933 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 374937 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 374941 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 374943 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 374950 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 374950 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 374953 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 374957 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 374962 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 374967 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 374972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 374977 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 374983 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 374985 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 374988 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 374990 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 374993 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 374996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 374999 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375004 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375009 */     // GIR_Coverage, 4223,
     /* 375009 */     GIR_EraseRootFromParent_Done,
     /* 375010 */   // Label 7338: @375010
     /* 375010 */   GIM_Try, /*On fail goto*//*Label 7339*/ GIMT_Encode4(375136), // Rule ID 4224 //
     /* 375015 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375018 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375021 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375025 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375029 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375035 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375037 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375041 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375045 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375048 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375052 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375059 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375063 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375067 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375069 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375076 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375076 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375079 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375083 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375088 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375098 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375103 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375109 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375111 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375114 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375116 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375119 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375122 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375125 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375130 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375135 */     // GIR_Coverage, 4224,
     /* 375135 */     GIR_EraseRootFromParent_Done,
     /* 375136 */   // Label 7339: @375136
     /* 375136 */   GIM_Try, /*On fail goto*//*Label 7340*/ GIMT_Encode4(375251), // Rule ID 4193 //
     /* 375141 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375144 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375147 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375151 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375155 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375159 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375163 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375167 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375170 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375174 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375178 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375182 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375184 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375191 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375191 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375194 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375198 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375203 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375208 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375213 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375218 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375224 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375226 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375229 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375231 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375234 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375237 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375240 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375245 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375250 */     // GIR_Coverage, 4193,
     /* 375250 */     GIR_EraseRootFromParent_Done,
     /* 375251 */   // Label 7340: @375251
     /* 375251 */   GIM_Try, /*On fail goto*//*Label 7341*/ GIMT_Encode4(375366), // Rule ID 4195 //
     /* 375256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375266 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375270 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375274 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375278 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375282 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375285 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375289 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375297 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375299 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375306 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375306 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375309 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375313 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375318 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375323 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375328 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375333 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375339 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375341 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375344 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375346 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375349 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375355 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375360 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375365 */     // GIR_Coverage, 4195,
     /* 375365 */     GIR_EraseRootFromParent_Done,
     /* 375366 */   // Label 7341: @375366
     /* 375366 */   GIM_Try, /*On fail goto*//*Label 7342*/ GIMT_Encode4(375488), // Rule ID 4229 //
     /* 375371 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375374 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375377 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375381 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375385 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375389 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375393 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375397 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375400 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375404 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375411 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375415 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375419 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375421 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 375428 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375428 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375431 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 375435 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375440 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375445 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375450 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375455 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375463 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375466 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375471 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375477 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375482 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375487 */     // GIR_Coverage, 4229,
     /* 375487 */     GIR_EraseRootFromParent_Done,
     /* 375488 */   // Label 7342: @375488
     /* 375488 */   GIM_Try, /*On fail goto*//*Label 7343*/ GIMT_Encode4(375610), // Rule ID 4231 //
     /* 375493 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375496 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375499 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375503 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375507 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 375511 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375515 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375519 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375522 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375526 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375533 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375537 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375541 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375543 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 375550 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 375550 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375553 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 375557 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375562 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375567 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 375572 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 375577 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375583 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375590 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375599 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375604 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375609 */     // GIR_Coverage, 4231,
     /* 375609 */     GIR_EraseRootFromParent_Done,
     /* 375610 */   // Label 7343: @375610
     /* 375610 */   GIM_Try, /*On fail goto*//*Label 7344*/ GIMT_Encode4(375724), // Rule ID 4185 //
     /* 375615 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375618 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375621 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375625 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375629 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375635 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375637 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375641 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375645 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375648 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375652 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375656 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375660 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375662 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375669 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375681 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375686 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375691 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375723 */     // GIR_Coverage, 4185,
     /* 375723 */     GIR_EraseRootFromParent_Done,
     /* 375724 */   // Label 7344: @375724
     /* 375724 */   GIM_Try, /*On fail goto*//*Label 7345*/ GIMT_Encode4(375838), // Rule ID 4186 //
     /* 375729 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 375732 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375735 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375739 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375743 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375749 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375751 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375755 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375759 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375762 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375766 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375770 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375774 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375776 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 375783 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 375783 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375786 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 375790 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375795 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375805 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375811 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375813 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375816 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375818 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375821 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375824 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375827 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375837 */     // GIR_Coverage, 4186,
     /* 375837 */     GIR_EraseRootFromParent_Done,
     /* 375838 */   // Label 7345: @375838
     /* 375838 */   GIM_Try, /*On fail goto*//*Label 7346*/ GIMT_Encode4(375959), // Rule ID 4221 //
     /* 375843 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375846 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375849 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375853 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375857 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375863 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375865 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375869 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375873 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375876 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 375880 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 375887 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 375891 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 375895 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 375897 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 375904 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 375904 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 375907 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 375911 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 375916 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 375921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 375926 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 375932 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 375934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 375937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 375939 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 375942 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 375945 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 375948 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 375958 */     // GIR_Coverage, 4221,
     /* 375958 */     GIR_EraseRootFromParent_Done,
     /* 375959 */   // Label 7346: @375959
     /* 375959 */   GIM_Try, /*On fail goto*//*Label 7347*/ GIMT_Encode4(376080), // Rule ID 4222 //
     /* 375964 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 375967 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 375970 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 375974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 375978 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 375984 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 375986 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 375990 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 375994 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 375997 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376001 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376008 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376012 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376018 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376025 */     // (vector_insert:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376037 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376042 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376047 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376079 */     // GIR_Coverage, 4222,
     /* 376079 */     GIR_EraseRootFromParent_Done,
     /* 376080 */   // Label 7347: @376080
     /* 376080 */   GIM_Try, /*On fail goto*//*Label 7348*/ GIMT_Encode4(376190), // Rule ID 4189 //
     /* 376085 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376088 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376091 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376111 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376114 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376118 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376122 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376126 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376128 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376135 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376147 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376152 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376157 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376173 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376176 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376179 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376184 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376189 */     // GIR_Coverage, 4189,
     /* 376189 */     GIR_EraseRootFromParent_Done,
     /* 376190 */   // Label 7348: @376190
     /* 376190 */   GIM_Try, /*On fail goto*//*Label 7349*/ GIMT_Encode4(376300), // Rule ID 4191 //
     /* 376195 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376198 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376201 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376209 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376221 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376224 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376228 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376232 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376236 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376238 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376245 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376257 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376262 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376267 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376275 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376278 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376280 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376283 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376286 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376289 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376294 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376299 */     // GIR_Coverage, 4191,
     /* 376299 */     GIR_EraseRootFromParent_Done,
     /* 376300 */   // Label 7349: @376300
     /* 376300 */   GIM_Try, /*On fail goto*//*Label 7350*/ GIMT_Encode4(376417), // Rule ID 4225 //
     /* 376305 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376308 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376311 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376315 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376319 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376323 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376327 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376331 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376334 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376338 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376345 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376349 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376353 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376355 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 376362 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 376362 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376365 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 376369 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376374 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376379 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376384 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376390 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376392 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376395 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376397 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376400 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376403 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376406 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376411 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376416 */     // GIR_Coverage, 4225,
     /* 376416 */     GIR_EraseRootFromParent_Done,
     /* 376417 */   // Label 7350: @376417
     /* 376417 */   GIM_Try, /*On fail goto*//*Label 7351*/ GIMT_Encode4(376534), // Rule ID 4227 //
     /* 376422 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376425 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376428 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 376448 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 376451 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 376455 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 376462 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 376466 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376470 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 376472 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 376479 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 376479 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 376482 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 376486 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376491 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 376496 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 376501 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 376507 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 376512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376514 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 376517 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376520 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376523 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376528 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376533 */     // GIR_Coverage, 4227,
     /* 376533 */     GIR_EraseRootFromParent_Done,
     /* 376534 */   // Label 7351: @376534
     /* 376534 */   GIM_Try, /*On fail goto*//*Label 7352*/ GIMT_Encode4(376657), // Rule ID 5756 //
     /* 376539 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376542 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376545 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376549 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376553 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376565 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376569 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376573 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376578 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376582 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376586 */     // MIs[3] Operand 1
     /* 376586 */     // No operand predicates
     /* 376586 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376590 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376592 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 376592 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 376595 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 376599 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376604 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376608 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 376611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376613 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376616 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376620 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376627 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376630 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376635 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376638 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376641 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376646 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376651 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376656 */     // GIR_Coverage, 5756,
     /* 376656 */     GIR_EraseRootFromParent_Done,
     /* 376657 */   // Label 7352: @376657
     /* 376657 */   GIM_Try, /*On fail goto*//*Label 7353*/ GIMT_Encode4(376780), // Rule ID 5764 //
     /* 376662 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376665 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376668 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376672 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 376676 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 376680 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 376684 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376688 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376692 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 376696 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376701 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 376705 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376709 */     // MIs[3] Operand 1
     /* 376709 */     // No operand predicates
     /* 376709 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 376713 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376715 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), 0:{ *:[i64] })  =>  (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), (DUPi8:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), bsub:{ *:[i32] })
     /* 376715 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s8,
     /* 376718 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::DUPi8),
     /* 376722 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376727 */     GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 376731 */     GIR_CopyConstantAsSImm, /*NewInsnID*/2, /*OldInsnID*/3, // Immn
     /* 376734 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 376736 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376739 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 376743 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376748 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 376750 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 376753 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376755 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376758 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 376761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 376764 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376769 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376774 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 376779 */     // GIR_Coverage, 5764,
     /* 376779 */     GIR_EraseRootFromParent_Done,
     /* 376780 */   // Label 7353: @376780
     /* 376780 */   GIM_Try, /*On fail goto*//*Label 7354*/ GIMT_Encode4(376868), // Rule ID 1938 //
     /* 376785 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 376788 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376791 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376794 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376798 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376802 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376806 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376810 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 376814 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376818 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376823 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376827 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376831 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376835 */     // MIs[2] Operand 1
     /* 376835 */     // No operand predicates
     /* 376835 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376839 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376843 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376847 */     // MIs[3] Operand 1
     /* 376847 */     // No operand predicates
     /* 376847 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376849 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx2), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx2)
     /* 376849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376854 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 376856 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 376859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 376863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx2
     /* 376866 */     GIR_RootConstrainSelectedInstOperands,
     /* 376867 */     // GIR_Coverage, 1938,
     /* 376867 */     GIR_EraseRootFromParent_Done,
     /* 376868 */   // Label 7354: @376868
     /* 376868 */   GIM_Try, /*On fail goto*//*Label 7355*/ GIMT_Encode4(376967), // Rule ID 5753 //
     /* 376873 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 376876 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376879 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376891 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 376895 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 376903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376907 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 376911 */     // MIs[2] Operand 1
     /* 376911 */     // No operand predicates
     /* 376911 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 376915 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 376919 */     // MIs[3] Operand 1
     /* 376919 */     // No operand predicates
     /* 376919 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 376921 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i8] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 376921 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 376924 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 376928 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 376933 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 376939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376944 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 376949 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 376952 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 376954 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 376956 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 376959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 376962 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 376965 */     GIR_RootConstrainSelectedInstOperands,
     /* 376966 */     // GIR_Coverage, 5753,
     /* 376966 */     GIR_EraseRootFromParent_Done,
     /* 376967 */   // Label 7355: @376967
     /* 376967 */   GIM_Try, /*On fail goto*//*Label 7356*/ GIMT_Encode4(377066), // Rule ID 5761 //
     /* 376972 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 376975 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 376978 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 376982 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 376986 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 376990 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 376994 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 376998 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377002 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377006 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377010 */     // MIs[2] Operand 1
     /* 377010 */     // No operand predicates
     /* 377010 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377014 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377018 */     // MIs[3] Operand 1
     /* 377018 */     // No operand predicates
     /* 377018 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377020 */     // (vector_insert:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } v16i8:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immd, (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$Rm, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$Immn)
     /* 377020 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377023 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377027 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377032 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // Rm
     /* 377038 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377043 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377048 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377051 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377053 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377055 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377061 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377064 */     GIR_RootConstrainSelectedInstOperands,
     /* 377065 */     // GIR_Coverage, 5761,
     /* 377065 */     GIR_EraseRootFromParent_Done,
     /* 377066 */   // Label 7356: @377066
     /* 377066 */   GIM_Try, /*On fail goto*//*Label 7357*/ GIMT_Encode4(377143), // Rule ID 5755 //
     /* 377071 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377074 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377077 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377085 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377089 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377093 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377097 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377101 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377114 */     // MIs[2] Operand 1
     /* 377114 */     // No operand predicates
     /* 377114 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377118 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377122 */     // MIs[3] Operand 1
     /* 377122 */     // No operand predicates
     /* 377122 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377124 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 377124 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377127 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377129 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377131 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377141 */     GIR_RootConstrainSelectedInstOperands,
     /* 377142 */     // GIR_Coverage, 5755,
     /* 377142 */     GIR_EraseRootFromParent_Done,
     /* 377143 */   // Label 7357: @377143
     /* 377143 */   GIM_Try, /*On fail goto*//*Label 7358*/ GIMT_Encode4(377251), // Rule ID 5757 //
     /* 377148 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377151 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377154 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377158 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377162 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377166 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377170 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 377174 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377178 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377183 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377187 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377191 */     // MIs[2] Operand 1
     /* 377191 */     // No operand predicates
     /* 377191 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377195 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377199 */     // MIs[3] Operand 1
     /* 377199 */     // No operand predicates
     /* 377199 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377201 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 377201 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377204 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377208 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377213 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377216 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377220 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377223 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377228 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377238 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377240 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377243 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377249 */     GIR_RootConstrainSelectedInstOperands,
     /* 377250 */     // GIR_Coverage, 5757,
     /* 377250 */     GIR_EraseRootFromParent_Done,
     /* 377251 */   // Label 7358: @377251
     /* 377251 */   GIM_Try, /*On fail goto*//*Label 7359*/ GIMT_Encode4(377328), // Rule ID 5763 //
     /* 377256 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377259 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377262 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377266 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377270 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377274 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377278 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 377282 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377286 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377291 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377295 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377299 */     // MIs[2] Operand 1
     /* 377299 */     // No operand predicates
     /* 377299 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377303 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377307 */     // MIs[3] Operand 1
     /* 377307 */     // No operand predicates
     /* 377307 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377309 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$Immn)
     /* 377309 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377312 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377314 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377319 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377323 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377326 */     GIR_RootConstrainSelectedInstOperands,
     /* 377327 */     // GIR_Coverage, 5763,
     /* 377327 */     GIR_EraseRootFromParent_Done,
     /* 377328 */   // Label 7359: @377328
     /* 377328 */   GIM_Try, /*On fail goto*//*Label 7360*/ GIMT_Encode4(377436), // Rule ID 5765 //
     /* 377333 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377336 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377339 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377343 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 377355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 377359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 377363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 377372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377376 */     // MIs[2] Operand 1
     /* 377376 */     // No operand predicates
     /* 377376 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 377380 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377384 */     // MIs[3] Operand 1
     /* 377384 */     // No operand predicates
     /* 377384 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 377386 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (vector_extract:{ *:[i32] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i64] }):$Immn), (imm:{ *:[i64] }):$Immd)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, (imm:{ *:[i64] }):$Immd, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i64] }, V64:{ *:[v8i8] }:$Rn, dsub:{ *:[i32] }), (imm:{ *:[i64] }):$Immn)
     /* 377386 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377389 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377393 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377398 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 377401 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377405 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 377408 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377413 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 377418 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377421 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377423 */     GIR_RootToRootCopy, /*OpIdx*/1, // src
     /* 377425 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Immd
     /* 377428 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377431 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // Immn
     /* 377434 */     GIR_RootConstrainSelectedInstOperands,
     /* 377435 */     // GIR_Coverage, 5765,
     /* 377435 */     GIR_EraseRootFromParent_Done,
     /* 377436 */   // Label 7360: @377436
     /* 377436 */   GIM_Try, /*On fail goto*//*Label 7361*/ GIMT_Encode4(377515), // Rule ID 5680 //
     /* 377441 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377444 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377447 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377451 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 377455 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 377459 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 377463 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 377467 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377469 */     // (vector_insert:{ *:[v16i8] } (undef:{ *:[v16i8] }), GPR32:{ *:[i32] }:$Rn, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, (COPY_TO_REGCLASS:{ *:[f32] } GPR32:{ *:[i32] }:$Rn, FPR32:{ *:[i32] }), ssub:{ *:[i32] })
     /* 377469 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 377472 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 377476 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rn
     /* 377485 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377490 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 377493 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377498 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377501 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 377504 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377509 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377514 */     // GIR_Coverage, 5680,
     /* 377514 */     GIR_EraseRootFromParent_Done,
     /* 377515 */   // Label 7361: @377515
     /* 377515 */   GIM_Try, /*On fail goto*//*Label 7362*/ GIMT_Encode4(377594), // Rule ID 6467 //
     /* 377520 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377523 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377526 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377530 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377534 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377538 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377542 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377545 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 377549 */     // MIs[1] Rn
     /* 377549 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 377553 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 377558 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377562 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377566 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377570 */     // MIs[2] Operand 1
     /* 377570 */     // No operand predicates
     /* 377570 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377572 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 377572 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 377575 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377577 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377579 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377582 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377586 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377592 */     GIR_RootConstrainSelectedInstOperands,
     /* 377593 */     // GIR_Coverage, 6467,
     /* 377593 */     GIR_EraseRootFromParent_Done,
     /* 377594 */   // Label 7362: @377594
     /* 377594 */   GIM_Try, /*On fail goto*//*Label 7363*/ GIMT_Encode4(377680), // Rule ID 6468 //
     /* 377599 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377602 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377605 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377613 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 377617 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 377621 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 377624 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 377628 */     GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 377635 */     // MIs[1] Rn
     /* 377635 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 377639 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 377644 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 377648 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377652 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377656 */     // MIs[2] Operand 1
     /* 377656 */     // No operand predicates
     /* 377656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 377658 */     // (vector_insert:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (LD1i8:{ *:[v16i8] } VecListOne128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx, GPR64sp:{ *:[i64] }:$Rn)
     /* 377658 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1i8),
     /* 377661 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377663 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377665 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 377668 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 377672 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 377678 */     GIR_RootConstrainSelectedInstOperands,
     /* 377679 */     // GIR_Coverage, 6468,
     /* 377679 */     GIR_EraseRootFromParent_Done,
     /* 377680 */   // Label 7363: @377680
     /* 377680 */   GIM_Try, /*On fail goto*//*Label 7364*/ GIMT_Encode4(377734), // Rule ID 1934 //
     /* 377685 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 377688 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377691 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377694 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377698 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377702 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 377706 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377710 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377714 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377718 */     // MIs[1] Operand 1
     /* 377718 */     // No operand predicates
     /* 377718 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377720 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, GPR32:{ *:[i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (INSvi8gpr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, (imm:{ *:[i64] }):$idx, GPR32:{ *:[i32] }:$Rn)
     /* 377720 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8gpr),
     /* 377723 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377725 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 377727 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 377730 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 377732 */     GIR_RootConstrainSelectedInstOperands,
     /* 377733 */     // GIR_Coverage, 1934,
     /* 377733 */     GIR_EraseRootFromParent_Done,
     /* 377734 */   // Label 7364: @377734
     /* 377734 */   GIM_Try, /*On fail goto*//*Label 7365*/ GIMT_Encode4(377840), // Rule ID 5723 //
     /* 377739 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 377742 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377745 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377749 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377753 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 377761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 377765 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 377769 */     // MIs[1] Operand 1
     /* 377769 */     // No operand predicates
     /* 377769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 377771 */     // (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, FPR8:{ *:[i8] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm)  =>  (INSvi8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$imm, (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rm, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 377771 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 377774 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 377778 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377783 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377785 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 377788 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 377792 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377797 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377800 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 377804 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 377807 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377812 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 377817 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 377822 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::INSvi8lane),
     /* 377825 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 377827 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 377829 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 377832 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377835 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 377838 */     GIR_RootConstrainSelectedInstOperands,
     /* 377839 */     // GIR_Coverage, 5723,
     /* 377839 */     GIR_EraseRootFromParent_Done,
     /* 377840 */   // Label 7365: @377840
     /* 377840 */   GIM_Reject,
     /* 377841 */ // Label 7335: @377841
     /* 377841 */ GIM_Reject,
     /* 377842 */ // Label 7128: @377842
     /* 377842 */ GIM_Try, /*On fail goto*//*Label 7366*/ GIMT_Encode4(377966), // Rule ID 11242 //
     /* 377847 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377850 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 377853 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 377856 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377859 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377863 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 377867 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377871 */   // (vector_insert:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f16] }:$src)
     /* 377871 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377874 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 377878 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377883 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 377887 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 377889 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 377892 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 377896 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377901 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 377904 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 377907 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 377909 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 377912 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 377916 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377921 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 377924 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 377926 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 377929 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 377933 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 377938 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 377941 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 377944 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 377947 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 377950 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 377952 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 377955 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 377957 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 377959 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 377962 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 377964 */   GIR_RootConstrainSelectedInstOperands,
     /* 377965 */   // GIR_Coverage, 11242,
     /* 377965 */   GIR_EraseRootFromParent_Done,
     /* 377966 */ // Label 7366: @377966
     /* 377966 */ GIM_Reject,
     /* 377967 */ // Label 7129: @377967
     /* 377967 */ GIM_Try, /*On fail goto*//*Label 7367*/ GIMT_Encode4(378091), // Rule ID 11245 //
     /* 377972 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 377975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 377978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 377981 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 377984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 377988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 377992 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 377996 */   // (vector_insert:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), ?:{ *:[f32] }:$src)
     /* 377996 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 377999 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 378003 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378008 */   GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 378012 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 378014 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 378017 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 378021 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378026 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 378029 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 378032 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 378034 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 378037 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 378041 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378046 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 378049 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 378051 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 378054 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 378058 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378063 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 378066 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 378069 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 378072 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 378075 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378077 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 378080 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 378082 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 378084 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378087 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 378089 */   GIR_RootConstrainSelectedInstOperands,
     /* 378090 */   // GIR_Coverage, 11245,
     /* 378090 */   GIR_EraseRootFromParent_Done,
     /* 378091 */ // Label 7367: @378091
     /* 378091 */ GIM_Reject,
     /* 378092 */ // Label 7130: @378092
     /* 378092 */ GIM_Try, /*On fail goto*//*Label 7368*/ GIMT_Encode4(380069),
     /* 378097 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 378100 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 378103 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 378106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378110 */   GIM_Try, /*On fail goto*//*Label 7369*/ GIMT_Encode4(378219), // Rule ID 4355 //
     /* 378115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378119 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378125 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378135 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378138 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378142 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378146 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378150 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378152 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378159 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378159 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378162 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378166 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378171 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378176 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378181 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378186 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378192 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378199 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378202 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378205 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378208 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378213 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378218 */     // GIR_Coverage, 4355,
     /* 378218 */     GIR_EraseRootFromParent_Done,
     /* 378219 */   // Label 7369: @378219
     /* 378219 */   GIM_Try, /*On fail goto*//*Label 7370*/ GIMT_Encode4(378328), // Rule ID 4356 //
     /* 378224 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378228 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378234 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378236 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378240 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378244 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378247 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378251 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378255 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378259 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378261 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378268 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378268 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378271 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378275 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378280 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378285 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378290 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378295 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378301 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378308 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378314 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378317 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378322 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378327 */     // GIR_Coverage, 4356,
     /* 378327 */     GIR_EraseRootFromParent_Done,
     /* 378328 */   // Label 7370: @378328
     /* 378328 */   GIM_Try, /*On fail goto*//*Label 7371*/ GIMT_Encode4(378437), // Rule ID 4463 //
     /* 378333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378337 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378343 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378353 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378356 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378360 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378364 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378368 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378370 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378377 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378377 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378380 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378384 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378389 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378394 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378399 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378404 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378410 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378412 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378415 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378417 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378420 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378423 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378426 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378431 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378436 */     // GIR_Coverage, 4463,
     /* 378436 */     GIR_EraseRootFromParent_Done,
     /* 378437 */   // Label 7371: @378437
     /* 378437 */   GIM_Try, /*On fail goto*//*Label 7372*/ GIMT_Encode4(378546), // Rule ID 4464 //
     /* 378442 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378446 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378452 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378454 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378458 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378462 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378465 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378469 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378473 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378477 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378479 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378486 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378486 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378489 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378493 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378498 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378503 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378508 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378513 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378519 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378521 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378524 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378526 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378529 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378532 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378535 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378540 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378545 */     // GIR_Coverage, 4464,
     /* 378545 */     GIR_EraseRootFromParent_Done,
     /* 378546 */   // Label 7372: @378546
     /* 378546 */   GIM_Try, /*On fail goto*//*Label 7373*/ GIMT_Encode4(378651), // Rule ID 4361 //
     /* 378551 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378555 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378559 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378563 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378567 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378570 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378574 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378578 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378582 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378584 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378591 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378591 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378594 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378598 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378603 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378608 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378613 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378618 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378631 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378634 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378637 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378640 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378645 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378650 */     // GIR_Coverage, 4361,
     /* 378650 */     GIR_EraseRootFromParent_Done,
     /* 378651 */   // Label 7373: @378651
     /* 378651 */   GIM_Try, /*On fail goto*//*Label 7374*/ GIMT_Encode4(378756), // Rule ID 4363 //
     /* 378656 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378660 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378664 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378668 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378672 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378675 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378679 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378683 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378687 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378689 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378696 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378696 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378699 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378703 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378708 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378713 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378718 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378723 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378729 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378736 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378742 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378745 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378750 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378755 */     // GIR_Coverage, 4363,
     /* 378755 */     GIR_EraseRootFromParent_Done,
     /* 378756 */   // Label 7374: @378756
     /* 378756 */   GIM_Try, /*On fail goto*//*Label 7375*/ GIMT_Encode4(378861), // Rule ID 4469 //
     /* 378761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378777 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378780 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378784 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378788 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378792 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378794 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 378801 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroW:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378801 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378804 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroW),
     /* 378808 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378813 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378818 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378823 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378828 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378834 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378841 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378847 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378850 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378855 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378860 */     // GIR_Coverage, 4469,
     /* 378860 */     GIR_EraseRootFromParent_Done,
     /* 378861 */   // Label 7375: @378861
     /* 378861 */   GIM_Try, /*On fail goto*//*Label 7376*/ GIMT_Encode4(378966), // Rule ID 4471 //
     /* 378866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 378874 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378878 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378882 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378885 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378889 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 378893 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 378897 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 378899 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 378906 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDroX:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend), dsub:{ *:[i32] })
     /* 378906 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 378909 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDroX),
     /* 378913 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 378918 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 378923 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 378928 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 378933 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 378939 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 378941 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 378944 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 378946 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 378949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 378952 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 378955 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 378960 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 378965 */     // GIR_Coverage, 4471,
     /* 378965 */     GIR_EraseRootFromParent_Done,
     /* 378966 */   // Label 7376: @378966
     /* 378966 */   GIM_Try, /*On fail goto*//*Label 7377*/ GIMT_Encode4(379070), // Rule ID 4353 //
     /* 378971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 378975 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 378981 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 378983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 378987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 378991 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 378994 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 378998 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379002 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379006 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379008 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379015 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379015 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379018 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379022 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379027 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379032 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379037 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379043 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379050 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379053 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379056 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379059 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379064 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379069 */     // GIR_Coverage, 4353,
     /* 379069 */     GIR_EraseRootFromParent_Done,
     /* 379070 */   // Label 7377: @379070
     /* 379070 */   GIM_Try, /*On fail goto*//*Label 7378*/ GIMT_Encode4(379174), // Rule ID 4354 //
     /* 379075 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379079 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379085 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379087 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379091 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379095 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379098 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379102 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379106 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379110 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379112 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379119 */     // (vector_insert:{ *:[nxv2i64] } immAllZerosV:{ *:[nxv2i64] }, (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379119 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379122 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379126 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379131 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379136 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379141 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379147 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379149 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379152 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379154 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379157 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379160 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379163 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379168 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379173 */     // GIR_Coverage, 4354,
     /* 379173 */     GIR_EraseRootFromParent_Done,
     /* 379174 */   // Label 7378: @379174
     /* 379174 */   GIM_Try, /*On fail goto*//*Label 7379*/ GIMT_Encode4(379278), // Rule ID 4461 //
     /* 379179 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379183 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379189 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379199 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379202 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379206 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379210 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379216 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379223 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379235 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379240 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379245 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379251 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379253 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379256 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379258 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379261 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379264 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379267 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379272 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379277 */     // GIR_Coverage, 4461,
     /* 379277 */     GIR_EraseRootFromParent_Done,
     /* 379278 */   // Label 7379: @379278
     /* 379278 */   GIM_Try, /*On fail goto*//*Label 7380*/ GIMT_Encode4(379382), // Rule ID 4462 //
     /* 379283 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379287 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 379293 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 379295 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379299 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379303 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379306 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379310 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379314 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379318 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379320 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379327 */     // (vector_insert:{ *:[nxv2f64] } immAllZerosV:{ *:[nxv2f64] }, (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379327 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379330 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379334 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379339 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379344 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379349 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379355 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379357 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379360 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379362 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379371 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379376 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379381 */     // GIR_Coverage, 4462,
     /* 379381 */     GIR_EraseRootFromParent_Done,
     /* 379382 */   // Label 7380: @379382
     /* 379382 */   GIM_Try, /*On fail goto*//*Label 7381*/ GIMT_Encode4(379482), // Rule ID 4357 //
     /* 379387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379406 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379410 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379414 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379418 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379420 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379427 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379427 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379430 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379434 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379439 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379444 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379449 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379455 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379462 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379465 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379468 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379476 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379481 */     // GIR_Coverage, 4357,
     /* 379481 */     GIR_EraseRootFromParent_Done,
     /* 379482 */   // Label 7381: @379482
     /* 379482 */   GIM_Try, /*On fail goto*//*Label 7382*/ GIMT_Encode4(379582), // Rule ID 4359 //
     /* 379487 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379491 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379503 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379510 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379527 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (ld:{ *:[i64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379549 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379581 */     // GIR_Coverage, 4359,
     /* 379581 */     GIR_EraseRootFromParent_Done,
     /* 379582 */   // Label 7382: @379582
     /* 379582 */   GIM_Try, /*On fail goto*//*Label 7383*/ GIMT_Encode4(379682), // Rule ID 4465 //
     /* 379587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379595 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379599 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379603 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379606 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379610 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379614 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379618 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379620 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 379627 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDRDui:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset), dsub:{ *:[i32] })
     /* 379627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRDui),
     /* 379634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379639 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379649 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379655 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379657 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379660 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379665 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379671 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379676 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379681 */     // GIR_Coverage, 4465,
     /* 379681 */     GIR_EraseRootFromParent_Done,
     /* 379682 */   // Label 7383: @379682
     /* 379682 */   GIM_Try, /*On fail goto*//*Label 7384*/ GIMT_Encode4(379782), // Rule ID 4467 //
     /* 379687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379691 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 379703 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 379706 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 379710 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 379714 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379718 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 379720 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 379727 */     // (vector_insert:{ *:[nxv2f64] } (undef:{ *:[nxv2f64] }), (ld:{ *:[f64] } (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i64] }, (LDURDi:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), dsub:{ *:[i32] })
     /* 379727 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 379730 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURDi),
     /* 379734 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379739 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 379744 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 379749 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 379755 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379757 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 379760 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 379762 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 379765 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379768 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 379771 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 379776 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379781 */     // GIR_Coverage, 4467,
     /* 379781 */     GIR_EraseRootFromParent_Done,
     /* 379782 */   // Label 7384: @379782
     /* 379782 */   GIM_Try, /*On fail goto*//*Label 7385*/ GIMT_Encode4(379846), // Rule ID 11300 //
     /* 379787 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379790 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 379794 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 379798 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 379802 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 379806 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 379810 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 379814 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 379818 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 379822 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 379826 */     // MIs[3] Operand 1
     /* 379826 */     // No operand predicates
     /* 379826 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 379830 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 379832 */     // (vector_insert:{ *:[nxv2i64] } (undef:{ *:[nxv2i64] }), (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$Idx)
     /* 379832 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 379835 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 379841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 379844 */     GIR_RootConstrainSelectedInstOperands,
     /* 379845 */     // GIR_Coverage, 11300,
     /* 379845 */     GIR_EraseRootFromParent_Done,
     /* 379846 */   // Label 7385: @379846
     /* 379846 */   GIM_Try, /*On fail goto*//*Label 7386*/ GIMT_Encode4(379957), // Rule ID 11241 //
     /* 379851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379854 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379858 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379862 */     // (vector_insert:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } GPR64:{ *:[i64] }:$index)), GPR64:{ *:[i64] }:$src)
     /* 379862 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379865 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379869 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379874 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379878 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379880 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379883 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379887 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379892 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 379895 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 379898 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 379900 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 379903 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 379907 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379912 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 379915 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 379917 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 379920 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 379924 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379929 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 379932 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 379935 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 379938 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 379941 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 379943 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_D),
     /* 379946 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 379948 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 379950 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 379953 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 379955 */     GIR_RootConstrainSelectedInstOperands,
     /* 379956 */     // GIR_Coverage, 11241,
     /* 379956 */     GIR_EraseRootFromParent_Done,
     /* 379957 */   // Label 7386: @379957
     /* 379957 */   GIM_Try, /*On fail goto*//*Label 7387*/ GIMT_Encode4(380068), // Rule ID 11247 //
     /* 379962 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 379965 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 379969 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 379973 */     // (vector_insert:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$vec, FPR64:{ *:[f64] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (CMPEQ_PPzZZ_D:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_D:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_D:{ *:[nxv16i8] } 0:{ *:[i64] }, 1:{ *:[i64] }), (DUP_ZR_D:{ *:[nxv16i8] } ?:{ *:[i64] }:$index)), ?:{ *:[f64] }:$src)
     /* 379973 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 379976 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 379980 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 379985 */     GIR_Copy, /*NewInsnID*/4, /*OldInsnID*/0, /*OpIdx*/3, // index
     /* 379989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 379991 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 379994 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_D),
     /* 379998 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380003 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380006 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380011 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380014 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_D),
     /* 380018 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380023 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380026 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380028 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380031 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_D),
     /* 380035 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380040 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380043 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380046 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380049 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380052 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380054 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_D),
     /* 380057 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380059 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380061 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380064 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380066 */     GIR_RootConstrainSelectedInstOperands,
     /* 380067 */     // GIR_Coverage, 11247,
     /* 380067 */     GIR_EraseRootFromParent_Done,
     /* 380068 */   // Label 7387: @380068
     /* 380068 */   GIM_Reject,
     /* 380069 */ // Label 7368: @380069
     /* 380069 */ GIM_Reject,
     /* 380070 */ // Label 7131: @380070
     /* 380070 */ GIM_Try, /*On fail goto*//*Label 7388*/ GIMT_Encode4(380221), // Rule ID 11243 //
     /* 380075 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 380078 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 380081 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 380084 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380087 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380091 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 380095 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380099 */   // (vector_insert:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 380099 */   GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 380102 */   GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 380106 */   GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380111 */   GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 380117 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 380122 */   GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 380127 */   GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 380130 */   GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 380134 */   GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380139 */   GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 380142 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 380144 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 380147 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 380151 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380156 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 380159 */   GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 380162 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 380164 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 380167 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 380171 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380176 */   GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 380179 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 380181 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 380184 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 380188 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380193 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 380196 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 380199 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 380202 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 380205 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380207 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 380210 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 380212 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 380214 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380217 */   GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 380219 */   GIR_RootConstrainSelectedInstOperands,
     /* 380220 */   // GIR_Coverage, 11243,
     /* 380220 */   GIR_EraseRootFromParent_Done,
     /* 380221 */ // Label 7388: @380221
     /* 380221 */ GIM_Reject,
     /* 380222 */ // Label 7132: @380222
     /* 380222 */ GIM_Try, /*On fail goto*//*Label 7389*/ GIMT_Encode4(382253),
     /* 380227 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 380230 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 380233 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 380236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380240 */   GIM_Try, /*On fail goto*//*Label 7390*/ GIMT_Encode4(380349), // Rule ID 4319 //
     /* 380245 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380249 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380255 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380257 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380261 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380265 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380268 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380272 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380276 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380280 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380282 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380289 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380306 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380311 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380316 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380322 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380324 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380327 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380329 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380332 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380335 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380338 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380343 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380348 */     // GIR_Coverage, 4319,
     /* 380348 */     GIR_EraseRootFromParent_Done,
     /* 380349 */   // Label 7390: @380349
     /* 380349 */   GIM_Try, /*On fail goto*//*Label 7391*/ GIMT_Encode4(380458), // Rule ID 4320 //
     /* 380354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380358 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380364 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380374 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380377 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380381 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380385 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380389 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380391 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380398 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380398 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380401 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380405 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380410 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380415 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380420 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380425 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380431 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380433 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380436 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380447 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380452 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380457 */     // GIR_Coverage, 4320,
     /* 380457 */     GIR_EraseRootFromParent_Done,
     /* 380458 */   // Label 7391: @380458
     /* 380458 */   GIM_Try, /*On fail goto*//*Label 7392*/ GIMT_Encode4(380567), // Rule ID 4427 //
     /* 380463 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380467 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380473 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380475 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380479 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380483 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380486 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380490 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380494 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380498 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380500 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380507 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380507 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380510 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380514 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380519 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380524 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380529 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380534 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380540 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380542 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380545 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380547 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380550 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380553 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380556 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380561 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380566 */     // GIR_Coverage, 4427,
     /* 380566 */     GIR_EraseRootFromParent_Done,
     /* 380567 */   // Label 7392: @380567
     /* 380567 */   GIM_Try, /*On fail goto*//*Label 7393*/ GIMT_Encode4(380676), // Rule ID 4428 //
     /* 380572 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380576 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 380582 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 380584 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380588 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380592 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380595 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380599 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380603 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380607 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380609 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380616 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380616 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380619 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380623 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380628 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380633 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380638 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380643 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380649 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380651 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380654 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380656 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380659 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380662 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380665 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380670 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380675 */     // GIR_Coverage, 4428,
     /* 380675 */     GIR_EraseRootFromParent_Done,
     /* 380676 */   // Label 7393: @380676
     /* 380676 */   GIM_Try, /*On fail goto*//*Label 7394*/ GIMT_Encode4(380781), // Rule ID 4325 //
     /* 380681 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380685 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380689 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380693 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380697 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380700 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380704 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380708 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380712 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380714 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380721 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380721 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380724 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380728 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380733 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380738 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380743 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380748 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380754 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380756 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380759 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380761 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380764 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380767 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380770 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380775 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380780 */     // GIR_Coverage, 4325,
     /* 380780 */     GIR_EraseRootFromParent_Done,
     /* 380781 */   // Label 7394: @380781
     /* 380781 */   GIM_Try, /*On fail goto*//*Label 7395*/ GIMT_Encode4(380886), // Rule ID 4327 //
     /* 380786 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380790 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380794 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380798 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380802 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380805 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380809 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380813 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380817 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380819 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 380826 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380826 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380829 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 380833 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380838 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380843 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380848 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380853 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380859 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380861 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380864 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380866 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380869 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380872 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380880 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380885 */     // GIR_Coverage, 4327,
     /* 380885 */     GIR_EraseRootFromParent_Done,
     /* 380886 */   // Label 7395: @380886
     /* 380886 */   GIM_Try, /*On fail goto*//*Label 7396*/ GIMT_Encode4(380991), // Rule ID 4433 //
     /* 380891 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 380895 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 380899 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 380903 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 380907 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 380910 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 380914 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 380918 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 380922 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 380924 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed32),
     /* 380931 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Windexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroW:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 380931 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 380934 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroW),
     /* 380938 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 380943 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 380948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 380953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 380958 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 380964 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 380966 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 380969 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 380971 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 380974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 380977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 380980 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 380985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 380990 */     // GIR_Coverage, 4433,
     /* 380990 */     GIR_EraseRootFromParent_Done,
     /* 380991 */   // Label 7396: @380991
     /* 380991 */   GIM_Try, /*On fail goto*//*Label 7397*/ GIMT_Encode4(381096), // Rule ID 4435 //
     /* 380996 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381000 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381004 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381008 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381012 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381015 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381019 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381023 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381027 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381029 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed32),
     /* 381036 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (ro_Xindexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSroX:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend32:{ *:[i32] }:$extend), ssub:{ *:[i32] })
     /* 381036 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381039 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSroX),
     /* 381043 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381048 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381053 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 381058 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 381063 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381069 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381076 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381085 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381090 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381095 */     // GIR_Coverage, 4435,
     /* 381095 */     GIR_EraseRootFromParent_Done,
     /* 381096 */   // Label 7397: @381096
     /* 381096 */   GIM_Try, /*On fail goto*//*Label 7398*/ GIMT_Encode4(381200), // Rule ID 4317 //
     /* 381101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381105 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381111 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381113 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381117 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381121 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381124 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381128 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381132 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381136 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381138 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381145 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381157 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381162 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381167 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381175 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381178 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381180 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381183 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381186 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381189 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381194 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381199 */     // GIR_Coverage, 4317,
     /* 381199 */     GIR_EraseRootFromParent_Done,
     /* 381200 */   // Label 7398: @381200
     /* 381200 */   GIM_Try, /*On fail goto*//*Label 7399*/ GIMT_Encode4(381304), // Rule ID 4318 //
     /* 381205 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381209 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381215 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381225 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381228 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381232 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381236 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381240 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381242 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381249 */     // (vector_insert:{ *:[nxv4i32] } immAllZerosV:{ *:[nxv4i32] }, (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381249 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381252 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381256 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381261 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381266 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381271 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381277 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381279 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381282 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381284 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381287 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381290 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381293 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381298 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381303 */     // GIR_Coverage, 4318,
     /* 381303 */     GIR_EraseRootFromParent_Done,
     /* 381304 */   // Label 7399: @381304
     /* 381304 */   GIM_Try, /*On fail goto*//*Label 7400*/ GIMT_Encode4(381408), // Rule ID 4425 //
     /* 381309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381321 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381325 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381329 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381332 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381336 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381340 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381344 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381346 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381353 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381353 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381356 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381360 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381365 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381370 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381375 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381381 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381383 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381386 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381391 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381394 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381402 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381407 */     // GIR_Coverage, 4425,
     /* 381407 */     GIR_EraseRootFromParent_Done,
     /* 381408 */   // Label 7400: @381408
     /* 381408 */   GIM_Try, /*On fail goto*//*Label 7401*/ GIMT_Encode4(381512), // Rule ID 4426 //
     /* 381413 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381417 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 381423 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 381425 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381429 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381433 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381436 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381440 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381444 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381448 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381450 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381457 */     // (vector_insert:{ *:[nxv4f32] } immAllZerosV:{ *:[nxv4f32] }, (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381457 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381460 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381464 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381469 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381474 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381479 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381485 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381487 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381490 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381492 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381495 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381498 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381501 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381506 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381511 */     // GIR_Coverage, 4426,
     /* 381511 */     GIR_EraseRootFromParent_Done,
     /* 381512 */   // Label 7401: @381512
     /* 381512 */   GIM_Try, /*On fail goto*//*Label 7402*/ GIMT_Encode4(381612), // Rule ID 4321 //
     /* 381517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381525 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381529 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381533 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381536 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381540 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381544 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381548 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381550 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381557 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381569 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381574 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381579 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381585 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381587 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381590 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381592 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381595 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381598 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381601 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381606 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381611 */     // GIR_Coverage, 4321,
     /* 381611 */     GIR_EraseRootFromParent_Done,
     /* 381612 */   // Label 7402: @381612
     /* 381612 */   GIM_Try, /*On fail goto*//*Label 7403*/ GIMT_Encode4(381712), // Rule ID 4323 //
     /* 381617 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381621 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381625 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381629 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381633 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381636 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381640 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381644 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381648 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381650 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381657 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (ld:{ *:[i32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381657 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381660 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381664 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381669 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381674 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381679 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381685 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381687 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381690 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381692 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381695 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381698 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381701 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381706 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381711 */     // GIR_Coverage, 4323,
     /* 381711 */     GIR_EraseRootFromParent_Done,
     /* 381712 */   // Label 7403: @381712
     /* 381712 */   GIM_Try, /*On fail goto*//*Label 7404*/ GIMT_Encode4(381812), // Rule ID 4429 //
     /* 381717 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381721 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381733 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381736 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381740 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381744 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381748 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381750 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed32),
     /* 381757 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_indexed32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDRSui:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, uimm12s4:{ *:[i64] }:$offset), ssub:{ *:[i32] })
     /* 381757 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381760 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRSui),
     /* 381764 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381769 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381774 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381779 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381785 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381787 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381790 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381792 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381801 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381806 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381811 */     // GIR_Coverage, 4429,
     /* 381811 */     GIR_EraseRootFromParent_Done,
     /* 381812 */   // Label 7404: @381812
     /* 381812 */   GIM_Try, /*On fail goto*//*Label 7405*/ GIMT_Encode4(381912), // Rule ID 4431 //
     /* 381817 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381821 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381825 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381829 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 381833 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 381836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 381840 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 381844 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381848 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 381850 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled32),
     /* 381857 */     // (vector_insert:{ *:[nxv4f32] } (undef:{ *:[nxv4f32] }), (ld:{ *:[f32] } (am_unscaled32:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i64] }, (LDURSi:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), ssub:{ *:[i32] })
     /* 381857 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 381860 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURSi),
     /* 381864 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 381869 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 381874 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 381879 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 381885 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 381887 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 381890 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 381892 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 381895 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 381898 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 381901 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 381906 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 381911 */     // GIR_Coverage, 4431,
     /* 381911 */     GIR_EraseRootFromParent_Done,
     /* 381912 */   // Label 7405: @381912
     /* 381912 */   GIM_Try, /*On fail goto*//*Label 7406*/ GIMT_Encode4(381976), // Rule ID 11298 //
     /* 381917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381920 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 381924 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 381928 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 381932 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 381936 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 381940 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 381944 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 381948 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 381952 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 381956 */     // MIs[3] Operand 1
     /* 381956 */     // No operand predicates
     /* 381956 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 381960 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 381962 */     // (vector_insert:{ *:[nxv4i32] } (undef:{ *:[nxv4i32] }), (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$Idx)
     /* 381962 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 381965 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 381967 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 381971 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 381974 */     GIR_RootConstrainSelectedInstOperands,
     /* 381975 */     // GIR_Coverage, 11298,
     /* 381975 */     GIR_EraseRootFromParent_Done,
     /* 381976 */   // Label 7406: @381976
     /* 381976 */   GIM_Try, /*On fail goto*//*Label 7407*/ GIMT_Encode4(382114), // Rule ID 11240 //
     /* 381981 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 381984 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 381988 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 381992 */     // (vector_insert:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 381992 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 381995 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 381999 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382004 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382010 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382015 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382020 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382023 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 382027 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382032 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382035 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382037 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382040 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 382044 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382049 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382052 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382055 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382057 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382060 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 382064 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382069 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382072 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382074 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382077 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 382081 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382086 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382089 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382092 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382095 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382098 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382100 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_S),
     /* 382103 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382105 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382107 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382110 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382112 */     GIR_RootConstrainSelectedInstOperands,
     /* 382113 */     // GIR_Coverage, 11240,
     /* 382113 */     GIR_EraseRootFromParent_Done,
     /* 382114 */   // Label 7407: @382114
     /* 382114 */   GIM_Try, /*On fail goto*//*Label 7408*/ GIMT_Encode4(382252), // Rule ID 11246 //
     /* 382119 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 382122 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 382126 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382130 */     // (vector_insert:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$vec, FPR32:{ *:[f32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (CMPEQ_PPzZZ_S:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_S:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_S:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_S:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f32] }:$src)
     /* 382130 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 382133 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 382137 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382142 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 382148 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 382153 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 382158 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 382161 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 382165 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382170 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 382173 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 382175 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 382178 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_S),
     /* 382182 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382187 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 382190 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 382193 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 382195 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 382198 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_S),
     /* 382202 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382207 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 382210 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 382212 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 382215 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_S),
     /* 382219 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382224 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 382227 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 382230 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 382233 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 382236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382238 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_S),
     /* 382241 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 382243 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 382245 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382248 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 382250 */     GIR_RootConstrainSelectedInstOperands,
     /* 382251 */     // GIR_Coverage, 11246,
     /* 382251 */     GIR_EraseRootFromParent_Done,
     /* 382252 */   // Label 7408: @382252
     /* 382252 */   GIM_Reject,
     /* 382253 */ // Label 7389: @382253
     /* 382253 */ GIM_Reject,
     /* 382254 */ // Label 7133: @382254
     /* 382254 */ GIM_Try, /*On fail goto*//*Label 7409*/ GIMT_Encode4(384521),
     /* 382259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 382262 */   GIM_Try, /*On fail goto*//*Label 7410*/ GIMT_Encode4(382388), // Rule ID 4283 //
     /* 382267 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382270 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382273 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382281 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382287 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382289 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382293 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382297 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382300 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382304 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382311 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382315 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382319 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382321 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382328 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382328 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382331 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382335 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382340 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382345 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382350 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382355 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382361 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382363 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382366 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382368 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382371 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382374 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382377 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382382 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382387 */     // GIR_Coverage, 4283,
     /* 382387 */     GIR_EraseRootFromParent_Done,
     /* 382388 */   // Label 7410: @382388
     /* 382388 */   GIM_Try, /*On fail goto*//*Label 7411*/ GIMT_Encode4(382514), // Rule ID 4284 //
     /* 382393 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382396 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382399 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382403 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382407 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382413 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382415 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382419 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382423 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382426 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382430 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382437 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382441 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382445 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382447 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382454 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382454 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382457 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382461 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382466 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382471 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382476 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382481 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382487 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382489 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382492 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382494 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382497 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382500 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382503 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382508 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382513 */     // GIR_Coverage, 4284,
     /* 382513 */     GIR_EraseRootFromParent_Done,
     /* 382514 */   // Label 7411: @382514
     /* 382514 */   GIM_Try, /*On fail goto*//*Label 7412*/ GIMT_Encode4(382633), // Rule ID 4391 //
     /* 382519 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382522 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382525 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382529 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382533 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382539 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382541 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382545 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382549 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382552 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382556 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382560 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382564 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382566 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382573 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382573 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382576 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382580 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382585 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382590 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382595 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382600 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382606 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382608 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382611 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382613 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382616 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382619 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382622 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382627 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382632 */     // GIR_Coverage, 4391,
     /* 382632 */     GIR_EraseRootFromParent_Done,
     /* 382633 */   // Label 7412: @382633
     /* 382633 */   GIM_Try, /*On fail goto*//*Label 7413*/ GIMT_Encode4(382752), // Rule ID 4392 //
     /* 382638 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 382641 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382644 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382648 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382652 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 382658 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 382660 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382664 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382668 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382671 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382675 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382679 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382683 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382685 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382692 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382692 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382695 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382699 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382704 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382709 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382714 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382719 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382725 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382727 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382730 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382732 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382735 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382738 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382751 */     // GIR_Coverage, 4392,
     /* 382751 */     GIR_EraseRootFromParent_Done,
     /* 382752 */   // Label 7413: @382752
     /* 382752 */   GIM_Try, /*On fail goto*//*Label 7414*/ GIMT_Encode4(382874), // Rule ID 4289 //
     /* 382757 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382760 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382763 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382767 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382771 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382775 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382779 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382783 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382786 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382790 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382797 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382801 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382805 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382807 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 382814 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382814 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382817 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 382821 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382826 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382831 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382836 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382841 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382849 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382852 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382854 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382857 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382860 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382863 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382868 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382873 */     // GIR_Coverage, 4289,
     /* 382873 */     GIR_EraseRootFromParent_Done,
     /* 382874 */   // Label 7414: @382874
     /* 382874 */   GIM_Try, /*On fail goto*//*Label 7415*/ GIMT_Encode4(382996), // Rule ID 4291 //
     /* 382879 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 382882 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 382885 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382889 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 382893 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 382897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 382901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 382905 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 382908 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 382912 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 382919 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 382923 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 382927 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 382929 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 382936 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 382936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 382939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 382943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 382948 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 382953 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 382958 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 382963 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 382969 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 382971 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 382974 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 382976 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 382979 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 382982 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 382985 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 382990 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 382995 */     // GIR_Coverage, 4291,
     /* 382995 */     GIR_EraseRootFromParent_Done,
     /* 382996 */   // Label 7415: @382996
     /* 382996 */   GIM_Try, /*On fail goto*//*Label 7416*/ GIMT_Encode4(383111), // Rule ID 4397 //
     /* 383001 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383004 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383007 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383019 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383023 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383027 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383030 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383034 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383038 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383042 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383044 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed16),
     /* 383051 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Windexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroW:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383051 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383054 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroW),
     /* 383058 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383063 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383068 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383073 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383078 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383084 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383091 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383094 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383097 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383100 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383105 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383110 */     // GIR_Coverage, 4397,
     /* 383110 */     GIR_EraseRootFromParent_Done,
     /* 383111 */   // Label 7416: @383111
     /* 383111 */   GIM_Try, /*On fail goto*//*Label 7417*/ GIMT_Encode4(383226), // Rule ID 4399 //
     /* 383116 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383119 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383122 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383126 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383130 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383134 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383138 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383142 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383145 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383149 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383153 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383157 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383159 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed16),
     /* 383166 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (ro_Xindexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHroX:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend16:{ *:[i32] }:$extend), hsub:{ *:[i32] })
     /* 383166 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383169 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHroX),
     /* 383173 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383178 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383183 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 383188 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 383193 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383199 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383201 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383204 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383206 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383209 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383212 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383215 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383220 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383225 */     // GIR_Coverage, 4399,
     /* 383225 */     GIR_EraseRootFromParent_Done,
     /* 383226 */   // Label 7417: @383226
     /* 383226 */   GIM_Try, /*On fail goto*//*Label 7418*/ GIMT_Encode4(383347), // Rule ID 4281 //
     /* 383231 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383234 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383237 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383241 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383245 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383251 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383253 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383257 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383261 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383264 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383268 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383275 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383279 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383283 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383285 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383292 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383292 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383295 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383299 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383304 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383309 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383314 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383320 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383322 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383325 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383327 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383333 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383336 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383341 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383346 */     // GIR_Coverage, 4281,
     /* 383346 */     GIR_EraseRootFromParent_Done,
     /* 383347 */   // Label 7418: @383347
     /* 383347 */   GIM_Try, /*On fail goto*//*Label 7419*/ GIMT_Encode4(383468), // Rule ID 4282 //
     /* 383352 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383355 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383358 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383366 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383372 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383374 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383378 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383382 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383385 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383389 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383396 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383400 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383404 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383406 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383413 */     // (vector_insert:{ *:[nxv8i16] } immAllZerosV:{ *:[nxv8i16] }, (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383413 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383416 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383420 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383425 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383430 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383435 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383448 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383451 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383454 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383457 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383462 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383467 */     // GIR_Coverage, 4282,
     /* 383467 */     GIR_EraseRootFromParent_Done,
     /* 383468 */   // Label 7419: @383468
     /* 383468 */   GIM_Try, /*On fail goto*//*Label 7420*/ GIMT_Encode4(383582), // Rule ID 4389 //
     /* 383473 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383476 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383479 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383483 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383487 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383493 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383495 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383499 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383503 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383506 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383510 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383514 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383520 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383527 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383527 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383530 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383534 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383539 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383544 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383549 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383555 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383557 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383560 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383562 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383565 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383568 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383571 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383576 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383581 */     // GIR_Coverage, 4389,
     /* 383581 */     GIR_EraseRootFromParent_Done,
     /* 383582 */   // Label 7420: @383582
     /* 383582 */   GIM_Try, /*On fail goto*//*Label 7421*/ GIMT_Encode4(383696), // Rule ID 4390 //
     /* 383587 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383590 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383593 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383601 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 383607 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 383609 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383613 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383617 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383620 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383624 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383628 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383634 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383641 */     // (vector_insert:{ *:[nxv8f16] } immAllZerosV:{ *:[nxv8f16] }, (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383653 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383658 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383663 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383669 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383671 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383674 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383676 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383679 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383682 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383685 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383690 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383695 */     // GIR_Coverage, 4390,
     /* 383695 */     GIR_EraseRootFromParent_Done,
     /* 383696 */   // Label 7421: @383696
     /* 383696 */   GIM_Try, /*On fail goto*//*Label 7422*/ GIMT_Encode4(383813), // Rule ID 4285 //
     /* 383701 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383704 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383707 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383711 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383715 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383727 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383730 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383734 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383741 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383745 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383749 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383751 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383758 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383758 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383761 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383765 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383770 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383775 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383780 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383786 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383793 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383796 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383799 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383802 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383807 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383812 */     // GIR_Coverage, 4285,
     /* 383812 */     GIR_EraseRootFromParent_Done,
     /* 383813 */   // Label 7422: @383813
     /* 383813 */   GIM_Try, /*On fail goto*//*Label 7423*/ GIMT_Encode4(383930), // Rule ID 4287 //
     /* 383818 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 383821 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383824 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383832 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383836 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383840 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383844 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383847 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383851 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 383858 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383862 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383866 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383868 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 383875 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (ld:{ *:[i32] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 383875 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383878 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 383882 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383887 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 383892 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 383897 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 383903 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 383905 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 383908 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 383910 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 383913 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 383916 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 383919 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383924 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 383929 */     // GIR_Coverage, 4287,
     /* 383929 */     GIR_EraseRootFromParent_Done,
     /* 383930 */   // Label 7423: @383930
     /* 383930 */   GIM_Try, /*On fail goto*//*Label 7424*/ GIMT_Encode4(384040), // Rule ID 4393 //
     /* 383935 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 383938 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 383941 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 383945 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 383949 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 383953 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 383957 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 383961 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 383964 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 383968 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 383972 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 383976 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 383978 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed16),
     /* 383985 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_indexed16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDRHui:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, uimm12s2:{ *:[i64] }:$offset), hsub:{ *:[i32] })
     /* 383985 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 383988 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRHui),
     /* 383992 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 383997 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384002 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384007 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384013 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384020 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384023 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384026 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384029 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384034 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384039 */     // GIR_Coverage, 4393,
     /* 384039 */     GIR_EraseRootFromParent_Done,
     /* 384040 */   // Label 7424: @384040
     /* 384040 */   GIM_Try, /*On fail goto*//*Label 7425*/ GIMT_Encode4(384150), // Rule ID 4395 //
     /* 384045 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384048 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384051 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384063 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384067 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384071 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384074 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384078 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384082 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384086 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384088 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled16),
     /* 384095 */     // (vector_insert:{ *:[nxv8f16] } (undef:{ *:[nxv8f16] }), (ld:{ *:[f16] } (am_unscaled16:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i64] }, (LDURHi:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), hsub:{ *:[i32] })
     /* 384095 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 384098 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURHi),
     /* 384102 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384107 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384112 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 384117 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384123 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384125 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384128 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384130 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384133 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384136 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 384139 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384144 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384149 */     // GIR_Coverage, 4395,
     /* 384149 */     GIR_EraseRootFromParent_Done,
     /* 384150 */   // Label 7425: @384150
     /* 384150 */   GIM_Try, /*On fail goto*//*Label 7426*/ GIMT_Encode4(384224), // Rule ID 11296 //
     /* 384155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384158 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384161 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384164 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 384176 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384180 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 384184 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 384188 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 384192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 384196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 384200 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 384204 */     // MIs[3] Operand 1
     /* 384204 */     // No operand predicates
     /* 384204 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 384210 */     // (vector_insert:{ *:[nxv8i16] } (undef:{ *:[nxv8i16] }), (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$Idx)
     /* 384210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 384213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384215 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 384219 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 384222 */     GIR_RootConstrainSelectedInstOperands,
     /* 384223 */     // GIR_Coverage, 11296,
     /* 384223 */     GIR_EraseRootFromParent_Done,
     /* 384224 */   // Label 7426: @384224
     /* 384224 */   GIM_Try, /*On fail goto*//*Label 7427*/ GIMT_Encode4(384372), // Rule ID 11239 //
     /* 384229 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384232 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384235 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384238 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384242 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384246 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384250 */     // (vector_insert:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 384250 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384253 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384257 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384262 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384268 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384273 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384278 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384281 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 384285 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384290 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384293 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384295 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384298 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 384302 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384307 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384310 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384313 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384315 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384318 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 384322 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384327 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 384330 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384332 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 384335 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 384339 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384344 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384347 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 384350 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 384353 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 384356 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384358 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_H),
     /* 384361 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384363 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 384365 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384368 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 384370 */     GIR_RootConstrainSelectedInstOperands,
     /* 384371 */     // GIR_Coverage, 11239,
     /* 384371 */     GIR_EraseRootFromParent_Done,
     /* 384372 */   // Label 7427: @384372
     /* 384372 */   GIM_Try, /*On fail goto*//*Label 7428*/ GIMT_Encode4(384520), // Rule ID 11244 //
     /* 384377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 384380 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 384383 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384386 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384390 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 384394 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384398 */     // (vector_insert:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$vec, FPR16:{ *:[f16] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmV_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (CMPEQ_PPzZZ_H:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_H:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_H:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_H:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), ?:{ *:[f16] }:$src)
     /* 384398 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 384401 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 384405 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384410 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 384416 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 384421 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 384426 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 384429 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 384433 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384438 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 384441 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 384443 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 384446 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_H),
     /* 384450 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384455 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 384458 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 384461 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 384463 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 384466 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_H),
     /* 384470 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384475 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 384478 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 384480 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 384483 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_H),
     /* 384487 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384492 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 384495 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 384498 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 384501 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 384504 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384506 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmV_H),
     /* 384509 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 384511 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 384513 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384516 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 384518 */     GIR_RootConstrainSelectedInstOperands,
     /* 384519 */     // GIR_Coverage, 11244,
     /* 384519 */     GIR_EraseRootFromParent_Done,
     /* 384520 */   // Label 7428: @384520
     /* 384520 */   GIM_Reject,
     /* 384521 */ // Label 7409: @384521
     /* 384521 */ GIM_Reject,
     /* 384522 */ // Label 7134: @384522
     /* 384522 */ GIM_Try, /*On fail goto*//*Label 7429*/ GIMT_Encode4(386641),
     /* 384527 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 384530 */   GIM_Try, /*On fail goto*//*Label 7430*/ GIMT_Encode4(384649), // Rule ID 4211 //
     /* 384535 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384538 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384541 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384545 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384549 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384555 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384557 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384561 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384565 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384568 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384572 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384576 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384580 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384582 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384589 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384589 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384592 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384596 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384601 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384616 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384622 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384624 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384627 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384629 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384632 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384635 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384638 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384643 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384648 */     // GIR_Coverage, 4211,
     /* 384648 */     GIR_EraseRootFromParent_Done,
     /* 384649 */   // Label 7430: @384649
     /* 384649 */   GIM_Try, /*On fail goto*//*Label 7431*/ GIMT_Encode4(384768), // Rule ID 4212 //
     /* 384654 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 384657 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384660 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384664 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384668 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384674 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384676 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384680 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384684 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384687 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384691 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384695 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384699 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384701 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384708 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384708 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384711 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384715 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384720 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384725 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384730 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384735 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384743 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384746 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384748 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384754 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384757 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384762 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384767 */     // GIR_Coverage, 4212,
     /* 384767 */     GIR_EraseRootFromParent_Done,
     /* 384768 */   // Label 7431: @384768
     /* 384768 */   GIM_Try, /*On fail goto*//*Label 7432*/ GIMT_Encode4(384894), // Rule ID 4247 //
     /* 384773 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384776 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384779 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384783 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384787 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384793 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384795 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384799 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384803 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384806 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384810 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384817 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384821 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384825 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384827 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 384834 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384834 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384837 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 384841 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384846 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384851 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384856 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384861 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384867 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384869 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384872 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 384874 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 384877 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 384880 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 384883 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384888 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 384893 */     // GIR_Coverage, 4247,
     /* 384893 */     GIR_EraseRootFromParent_Done,
     /* 384894 */   // Label 7432: @384894
     /* 384894 */   GIM_Try, /*On fail goto*//*Label 7433*/ GIMT_Encode4(385020), // Rule ID 4248 //
     /* 384899 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 384902 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 384905 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 384909 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 384913 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 384919 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 384921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 384925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 384929 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 384932 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 384936 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 384943 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 384947 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 384951 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 384953 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 384960 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 384960 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 384963 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 384967 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 384972 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 384977 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 384982 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 384987 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 384993 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 384995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 384998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385000 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385003 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385006 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385009 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385014 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385019 */     // GIR_Coverage, 4248,
     /* 385019 */     GIR_EraseRootFromParent_Done,
     /* 385020 */   // Label 7433: @385020
     /* 385020 */   GIM_Try, /*On fail goto*//*Label 7434*/ GIMT_Encode4(385135), // Rule ID 4217 //
     /* 385025 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385028 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385031 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385043 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385047 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385051 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385054 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385058 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385062 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385066 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385068 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385075 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385075 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385078 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385082 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385087 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385092 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385097 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385102 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385115 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385118 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385121 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385124 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385129 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385134 */     // GIR_Coverage, 4217,
     /* 385134 */     GIR_EraseRootFromParent_Done,
     /* 385135 */   // Label 7434: @385135
     /* 385135 */   GIM_Try, /*On fail goto*//*Label 7435*/ GIMT_Encode4(385250), // Rule ID 4219 //
     /* 385140 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385143 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385146 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385150 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385154 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385158 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385162 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385166 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385169 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385173 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385177 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385181 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385183 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385190 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385190 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385193 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385197 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385202 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385207 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385212 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385217 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385223 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385225 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385228 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385230 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385233 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385236 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385239 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385244 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385249 */     // GIR_Coverage, 4219,
     /* 385249 */     GIR_EraseRootFromParent_Done,
     /* 385250 */   // Label 7435: @385250
     /* 385250 */   GIM_Try, /*On fail goto*//*Label 7436*/ GIMT_Encode4(385372), // Rule ID 4253 //
     /* 385255 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385258 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385261 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385265 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385269 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385273 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385277 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385281 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385284 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385288 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385295 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385299 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385303 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385305 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed8),
     /* 385312 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Windexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroW:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroW),
     /* 385319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385324 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385329 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385334 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385339 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385345 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385347 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385350 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385352 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385355 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385358 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385361 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385366 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385371 */     // GIR_Coverage, 4253,
     /* 385371 */     GIR_EraseRootFromParent_Done,
     /* 385372 */   // Label 7436: @385372
     /* 385372 */   GIM_Try, /*On fail goto*//*Label 7437*/ GIMT_Encode4(385494), // Rule ID 4255 //
     /* 385377 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385380 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385383 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385403 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385406 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385410 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385417 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385421 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385425 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385427 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed8),
     /* 385434 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (ro_Xindexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBroX:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend8:{ *:[i32] }:$extend), bsub:{ *:[i32] })
     /* 385434 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385437 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBroX),
     /* 385441 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385446 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385451 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 385456 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 385461 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385467 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385474 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385477 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385480 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385483 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385488 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385493 */     // GIR_Coverage, 4255,
     /* 385493 */     GIR_EraseRootFromParent_Done,
     /* 385494 */   // Label 7437: @385494
     /* 385494 */   GIM_Try, /*On fail goto*//*Label 7438*/ GIMT_Encode4(385608), // Rule ID 4209 //
     /* 385499 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385502 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385505 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385509 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385513 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385519 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385529 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385532 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385536 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385540 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385544 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385546 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385553 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385553 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385556 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385560 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385565 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385570 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385575 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385588 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385594 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385597 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385602 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385607 */     // GIR_Coverage, 4209,
     /* 385607 */     GIR_EraseRootFromParent_Done,
     /* 385608 */   // Label 7438: @385608
     /* 385608 */   GIM_Try, /*On fail goto*//*Label 7439*/ GIMT_Encode4(385722), // Rule ID 4210 //
     /* 385613 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385616 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385619 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385627 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385633 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385643 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385646 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385650 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385654 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385658 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385660 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385667 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385667 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385670 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385674 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385679 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385684 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385689 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385695 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385705 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385708 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385711 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385716 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385721 */     // GIR_Coverage, 4210,
     /* 385721 */     GIR_EraseRootFromParent_Done,
     /* 385722 */   // Label 7439: @385722
     /* 385722 */   GIM_Try, /*On fail goto*//*Label 7440*/ GIMT_Encode4(385843), // Rule ID 4245 //
     /* 385727 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385730 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385733 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385737 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385741 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385747 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385757 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385760 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385764 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385771 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385775 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385779 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385781 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 385788 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 385788 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385791 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 385795 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385800 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385805 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385810 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385816 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385818 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385821 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385823 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385826 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385829 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385832 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385837 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385842 */     // GIR_Coverage, 4245,
     /* 385842 */     GIR_EraseRootFromParent_Done,
     /* 385843 */   // Label 7440: @385843
     /* 385843 */   GIM_Try, /*On fail goto*//*Label 7441*/ GIMT_Encode4(385964), // Rule ID 4246 //
     /* 385848 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 385851 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385854 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385862 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 385868 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 385870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385878 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385881 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 385885 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 385892 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 385896 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 385900 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 385902 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 385909 */     // (vector_insert:{ *:[nxv16i8] } immAllZerosV:{ *:[nxv16i8] }, (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 385909 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 385912 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 385916 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 385921 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 385926 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 385931 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 385937 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 385939 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 385942 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 385944 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 385947 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 385950 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 385953 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385958 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 385963 */     // GIR_Coverage, 4246,
     /* 385963 */     GIR_EraseRootFromParent_Done,
     /* 385964 */   // Label 7441: @385964
     /* 385964 */   GIM_Try, /*On fail goto*//*Label 7442*/ GIMT_Encode4(386074), // Rule ID 4213 //
     /* 385969 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 385972 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 385975 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 385979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 385983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 385987 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 385991 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 385995 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 385998 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386002 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386006 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386010 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386012 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386019 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386031 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386036 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386041 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386047 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386054 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386057 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386063 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386068 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386073 */     // GIR_Coverage, 4213,
     /* 386073 */     GIR_EraseRootFromParent_Done,
     /* 386074 */   // Label 7442: @386074
     /* 386074 */   GIM_Try, /*On fail goto*//*Label 7443*/ GIMT_Encode4(386184), // Rule ID 4215 //
     /* 386079 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s8,
     /* 386082 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386085 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386089 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386093 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386097 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386101 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386105 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386108 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386112 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386116 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386120 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386122 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386129 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i8] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386129 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386132 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386136 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386141 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386146 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386151 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386157 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386164 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386167 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386170 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386173 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386178 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386183 */     // GIR_Coverage, 4215,
     /* 386183 */     GIR_EraseRootFromParent_Done,
     /* 386184 */   // Label 7443: @386184
     /* 386184 */   GIM_Try, /*On fail goto*//*Label 7444*/ GIMT_Encode4(386301), // Rule ID 4249 //
     /* 386189 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386192 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386195 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386207 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386211 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386215 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386218 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386222 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386229 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386233 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386237 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386239 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 386246 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDRBui:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, uimm12s1:{ *:[i64] }:$offset), bsub:{ *:[i32] })
     /* 386246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDRBui),
     /* 386253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386258 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386263 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386268 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386274 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386281 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386284 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386287 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386290 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386295 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386300 */     // GIR_Coverage, 4249,
     /* 386300 */     GIR_EraseRootFromParent_Done,
     /* 386301 */   // Label 7444: @386301
     /* 386301 */   GIM_Try, /*On fail goto*//*Label 7445*/ GIMT_Encode4(386418), // Rule ID 4251 //
     /* 386306 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386309 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386312 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386316 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386320 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386324 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386328 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 386332 */     GIM_CheckAtomicOrdering, /*MI*/2, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 386335 */     GIM_CheckMemorySizeLessThanLLT, /*MI*/2, /*MMO*/0, /*OpIdx*/0,
     /* 386339 */     GIM_CheckMemorySizeEqualTo, /*MI*/2, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 386346 */     GIM_CheckPointerToAny, /*MI*/2, /*Op*/1, /*SizeInBits*/0,
     /* 386350 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386354 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 386356 */     GIM_CheckComplexPattern, /*MI*/2, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled8),
     /* 386363 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (ld:{ *:[i32] } (am_unscaled8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i64] }, (LDURBi:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset), bsub:{ *:[i32] })
     /* 386363 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s8,
     /* 386366 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::LDURBi),
     /* 386370 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386375 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 386380 */     GIR_ComplexSubOperandRenderer, /*InsnID*/1, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 386385 */     GIR_MergeMemOperands, /*InsnID*/1, /*NumInsns*/3, /*MergeInsnID's*/0, 1, 2,
     /* 386391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 386396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386398 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 386401 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386404 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 386407 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386412 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 386417 */     // GIR_Coverage, 4251,
     /* 386417 */     GIR_EraseRootFromParent_Done,
     /* 386418 */   // Label 7445: @386418
     /* 386418 */   GIM_Try, /*On fail goto*//*Label 7446*/ GIMT_Encode4(386492), // Rule ID 11294 //
     /* 386423 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386426 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386429 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386432 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386436 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 386440 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_IMPLICIT_DEF),
     /* 386444 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 386448 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 386452 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 386456 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 386460 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 386464 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386468 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 386472 */     // MIs[3] Operand 1
     /* 386472 */     // No operand predicates
     /* 386472 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/3, 0,
     /* 386476 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 386478 */     // (vector_insert:{ *:[nxv16i8] } (undef:{ *:[nxv16i8] }), (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx), 0:{ *:[i64] })  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$Idx)
     /* 386478 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 386481 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 386483 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // vec
     /* 386487 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // Idx
     /* 386490 */     GIR_RootConstrainSelectedInstOperands,
     /* 386491 */     // GIR_Coverage, 11294,
     /* 386491 */     GIR_EraseRootFromParent_Done,
     /* 386492 */   // Label 7446: @386492
     /* 386492 */   GIM_Try, /*On fail goto*//*Label 7447*/ GIMT_Encode4(386640), // Rule ID 11238 //
     /* 386497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386500 */     GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 386503 */     GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 386506 */     GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386510 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386514 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386518 */     // (vector_insert:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR32:{ *:[i32] }:$src, GPR64:{ *:[i64] }:$index)  =>  (CPY_ZPmR_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (CMPEQ_PPzZZ_B:{ *:[nxv1i1] }:{ *:[i32] } (PTRUE_B:{ *:[nxv1i1] } 31:{ *:[i32] }), (INDEX_II_B:{ *:[nxv16i8] } 0:{ *:[i32] }, 1:{ *:[i32] }), (DUP_ZR_B:{ *:[nxv16i8] } (EXTRACT_SUBREG:{ *:[i32] } GPR64:{ *:[i64] }:$index, sub_32:{ *:[i32] }))), GPR32:{ *:[i32] }:$src)
     /* 386518 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_s32,
     /* 386521 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386525 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386530 */     GIR_CopySubReg, /*NewInsnID*/5, /*OldInsnID*/0, /*OpIdx*/3, /*SubRegIdx*/GIMT_Encode2(20), // index
     /* 386536 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/0, GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 386541 */     GIR_ConstrainOperandRC, /*InsnID*/5, /*Op*/1, GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 386546 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_nxv16s8,
     /* 386549 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 386553 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386558 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 386561 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 386563 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_nxv16s8,
     /* 386566 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::INDEX_II_B),
     /* 386570 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386575 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/0,
     /* 386578 */     GIR_AddImm8, /*InsnID*/3, /*Imm*/1,
     /* 386581 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 386583 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv1s1,
     /* 386586 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::PTRUE_B),
     /* 386590 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386595 */     GIR_AddImm8, /*InsnID*/2, /*Imm*/31,
     /* 386598 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 386600 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 386603 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::CMPEQ_PPzZZ_B),
     /* 386607 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386612 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 386615 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 386618 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/3,
     /* 386621 */     GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 386624 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CPY_ZPmR_B),
     /* 386629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 386631 */     GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 386633 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 386636 */     GIR_RootToRootCopy, /*OpIdx*/2, // src
     /* 386638 */     GIR_RootConstrainSelectedInstOperands,
     /* 386639 */     // GIR_Coverage, 11238,
     /* 386639 */     GIR_EraseRootFromParent_Done,
     /* 386640 */   // Label 7447: @386640
     /* 386640 */   GIM_Reject,
     /* 386641 */ // Label 7429: @386641
     /* 386641 */ GIM_Reject,
     /* 386642 */ // Label 7135: @386642
     /* 386642 */ GIM_Reject,
     /* 386643 */ // Label 91: @386643
     /* 386643 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 7451*/ GIMT_Encode4(389560),
     /* 386654 */ /*GILLT_s16*//*Label 7448*/ GIMT_Encode4(386666),
     /* 386658 */ /*GILLT_s32*//*Label 7449*/ GIMT_Encode4(387300),
     /* 386662 */ /*GILLT_s64*//*Label 7450*/ GIMT_Encode4(388893),
     /* 386666 */ // Label 7448: @386666
     /* 386666 */ GIM_Try, /*On fail goto*//*Label 7452*/ GIMT_Encode4(386710), // Rule ID 11287 //
     /* 386671 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386674 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386677 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386684 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386688 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$Zs, hsub:{ *:[i32] })
     /* 386688 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386691 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386693 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386699 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386704 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386709 */   // GIR_Coverage, 11287,
     /* 386709 */   GIR_EraseRootFromParent_Done,
     /* 386710 */ // Label 7452: @386710
     /* 386710 */ GIM_Try, /*On fail goto*//*Label 7453*/ GIMT_Encode4(386754), // Rule ID 11288 //
     /* 386715 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386718 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386721 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386724 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386728 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386732 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$Zs, hsub:{ *:[i32] })
     /* 386732 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386735 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386737 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386743 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386748 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386753 */   // GIR_Coverage, 11288,
     /* 386753 */   GIR_EraseRootFromParent_Done,
     /* 386754 */ // Label 7453: @386754
     /* 386754 */ GIM_Try, /*On fail goto*//*Label 7454*/ GIMT_Encode4(386798), // Rule ID 11289 //
     /* 386759 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386762 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 386765 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386768 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386772 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386776 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$Zs, hsub:{ *:[i32] })
     /* 386776 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386779 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386781 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Zs
     /* 386787 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386792 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386797 */   // GIR_Coverage, 11289,
     /* 386797 */   GIR_EraseRootFromParent_Done,
     /* 386798 */ // Label 7454: @386798
     /* 386798 */ GIM_Try, /*On fail goto*//*Label 7455*/ GIMT_Encode4(386843), // Rule ID 5817 //
     /* 386803 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386806 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386809 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386813 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386817 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 386821 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] })
     /* 386821 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386824 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386826 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 386832 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386837 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386842 */   // GIR_Coverage, 5817,
     /* 386842 */   GIR_EraseRootFromParent_Done,
     /* 386843 */ // Label 7455: @386843
     /* 386843 */ GIM_Try, /*On fail goto*//*Label 7456*/ GIMT_Encode4(386888), // Rule ID 5820 //
     /* 386848 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 386851 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386854 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386858 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 386862 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386866 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386870 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 386874 */   // MIs[1] Operand 1
     /* 386874 */   // No operand predicates
     /* 386874 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386876 */   // (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPi16:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 386876 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi16),
     /* 386879 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386881 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 386883 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 386886 */   GIR_RootConstrainSelectedInstOperands,
     /* 386887 */   // GIR_Coverage, 5820,
     /* 386887 */   GIR_EraseRootFromParent_Done,
     /* 386888 */ // Label 7456: @386888
     /* 386888 */ GIM_Try, /*On fail goto*//*Label 7457*/ GIMT_Encode4(386964), // Rule ID 11262 //
     /* 386893 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 386899 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386902 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386906 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386910 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386914 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 386918 */   // MIs[1] Operand 1
     /* 386918 */   // No operand predicates
     /* 386918 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386920 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), hsub:{ *:[i32] })
     /* 386920 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386923 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 386927 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 386932 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 386936 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 386939 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 386941 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 386944 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 386946 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 386953 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386958 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 386963 */   // GIR_Coverage, 11262,
     /* 386963 */   GIR_EraseRootFromParent_Done,
     /* 386964 */ // Label 7457: @386964
     /* 386964 */ GIM_Try, /*On fail goto*//*Label 7458*/ GIMT_Encode4(387040), // Rule ID 11263 //
     /* 386969 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 386972 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 386975 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 386978 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 386982 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 386986 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 386990 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 386994 */   // MIs[1] Operand 1
     /* 386994 */   // No operand predicates
     /* 386994 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 386996 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), hsub:{ *:[i32] })
     /* 386996 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 386999 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 387003 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387008 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387012 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387015 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387017 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387020 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387022 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 387029 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387034 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387039 */   // GIR_Coverage, 11263,
     /* 387039 */   GIR_EraseRootFromParent_Done,
     /* 387040 */ // Label 7458: @387040
     /* 387040 */ GIM_Try, /*On fail goto*//*Label 7459*/ GIMT_Encode4(387116), // Rule ID 11264 //
     /* 387045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 387051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387058 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387062 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387066 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 387070 */   // MIs[1] Operand 1
     /* 387070 */   // No operand predicates
     /* 387070 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387072 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f16] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), hsub:{ *:[i32] })
     /* 387072 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 387075 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 387079 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387084 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 387088 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 387091 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387093 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387096 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387098 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::hsub),
     /* 387105 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387110 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387115 */   // GIR_Coverage, 11264,
     /* 387115 */   GIR_EraseRootFromParent_Done,
     /* 387116 */ // Label 7459: @387116
     /* 387116 */ GIM_Try, /*On fail goto*//*Label 7460*/ GIMT_Encode4(387177), // Rule ID 11252 //
     /* 387121 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387124 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387127 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387130 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387134 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387138 */   // (vector_extract:{ *:[f16] } nxv8f16:{ *:[nxv8f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8f16] }:$vec)
     /* 387138 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387141 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 387145 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387150 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387156 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387160 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387163 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387165 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387168 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387170 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387173 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387175 */   GIR_RootConstrainSelectedInstOperands,
     /* 387176 */   // GIR_Coverage, 11252,
     /* 387176 */   GIR_EraseRootFromParent_Done,
     /* 387177 */ // Label 7460: @387177
     /* 387177 */ GIM_Try, /*On fail goto*//*Label 7461*/ GIMT_Encode4(387238), // Rule ID 11253 //
     /* 387182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 387188 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387195 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387199 */   // (vector_extract:{ *:[f16] } nxv4f16:{ *:[nxv4f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f16] }:$vec)
     /* 387199 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387202 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 387206 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387211 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387217 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387221 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387224 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387226 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387229 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387231 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387234 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387236 */   GIR_RootConstrainSelectedInstOperands,
     /* 387237 */   // GIR_Coverage, 11253,
     /* 387237 */   GIR_EraseRootFromParent_Done,
     /* 387238 */ // Label 7461: @387238
     /* 387238 */ GIM_Try, /*On fail goto*//*Label 7462*/ GIMT_Encode4(387299), // Rule ID 11254 //
     /* 387243 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 387249 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 387256 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 387260 */   // (vector_extract:{ *:[f16] } nxv2f16:{ *:[nxv2f16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_H:{ *:[f16] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f16] }:$vec)
     /* 387260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 387263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 387267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387272 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 387278 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 387282 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 387285 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 387287 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_H),
     /* 387290 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 387292 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387295 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 387297 */   GIR_RootConstrainSelectedInstOperands,
     /* 387298 */   // GIR_Coverage, 11254,
     /* 387298 */   GIR_EraseRootFromParent_Done,
     /* 387299 */ // Label 7462: @387299
     /* 387299 */ GIM_Reject,
     /* 387300 */ // Label 7449: @387300
     /* 387300 */ GIM_Try, /*On fail goto*//*Label 7463*/ GIMT_Encode4(387345), // Rule ID 6996 //
     /* 387305 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387308 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387319 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387323 */   // (extractelt:{ *:[i32] } V128:{ *:[v4i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4i32] }:$V, ssub:{ *:[i32] })
     /* 387323 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387326 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387328 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 387334 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387339 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387344 */   // GIR_Coverage, 6996,
     /* 387344 */   GIR_EraseRootFromParent_Done,
     /* 387345 */ // Label 7463: @387345
     /* 387345 */ GIM_Try, /*On fail goto*//*Label 7464*/ GIMT_Encode4(387390), // Rule ID 6997 //
     /* 387350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 387353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387364 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387368 */   // (extractelt:{ *:[i32] } V64:{ *:[v2i32] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } V64:{ *:[v2i32] }:$V, ssub:{ *:[i32] })
     /* 387368 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387371 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387373 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // V
     /* 387379 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387384 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 387389 */   // GIR_Coverage, 6997,
     /* 387389 */   GIR_EraseRootFromParent_Done,
     /* 387390 */ // Label 7464: @387390
     /* 387390 */ GIM_Try, /*On fail goto*//*Label 7465*/ GIMT_Encode4(387434), // Rule ID 11283 //
     /* 387395 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387398 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387401 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387404 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387408 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387412 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$Zs, ssub:{ *:[i32] })
     /* 387412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387417 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387423 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387428 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387433 */   // GIR_Coverage, 11283,
     /* 387433 */   GIR_EraseRootFromParent_Done,
     /* 387434 */ // Label 7465: @387434
     /* 387434 */ GIM_Try, /*On fail goto*//*Label 7466*/ GIMT_Encode4(387478), // Rule ID 11284 //
     /* 387439 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387442 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387445 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387452 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387456 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$Zs, ssub:{ *:[i32] })
     /* 387456 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387459 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387461 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387467 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387472 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387477 */   // GIR_Coverage, 11284,
     /* 387477 */   GIR_EraseRootFromParent_Done,
     /* 387478 */ // Label 7466: @387478
     /* 387478 */ GIM_Try, /*On fail goto*//*Label 7467*/ GIMT_Encode4(387522), // Rule ID 11285 //
     /* 387483 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387496 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387500 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$Zs, ssub:{ *:[i32] })
     /* 387500 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387503 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387505 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387511 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387516 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387521 */   // GIR_Coverage, 11285,
     /* 387521 */   GIR_EraseRootFromParent_Done,
     /* 387522 */ // Label 7467: @387522
     /* 387522 */ GIM_Try, /*On fail goto*//*Label 7468*/ GIMT_Encode4(387566), // Rule ID 11290 //
     /* 387527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387533 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387536 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387540 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387544 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$Zs, ssub:{ *:[i32] })
     /* 387544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387549 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387555 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387560 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387565 */   // GIR_Coverage, 11290,
     /* 387565 */   GIR_EraseRootFromParent_Done,
     /* 387566 */ // Label 7468: @387566
     /* 387566 */ GIM_Try, /*On fail goto*//*Label 7469*/ GIMT_Encode4(387610), // Rule ID 11291 //
     /* 387571 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 387574 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 387577 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387580 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387584 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387588 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$Zs, ssub:{ *:[i32] })
     /* 387588 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387591 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387593 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Zs
     /* 387599 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387604 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387609 */   // GIR_Coverage, 11291,
     /* 387609 */   GIR_EraseRootFromParent_Done,
     /* 387610 */ // Label 7469: @387610
     /* 387610 */ GIM_Try, /*On fail goto*//*Label 7470*/ GIMT_Encode4(387655), // Rule ID 5816 //
     /* 387615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387618 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387621 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387625 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387629 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 387633 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] })
     /* 387633 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387636 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 387638 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 387644 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 387649 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387654 */   // GIR_Coverage, 5816,
     /* 387654 */   GIR_EraseRootFromParent_Done,
     /* 387655 */ // Label 7470: @387655
     /* 387655 */ GIM_Try, /*On fail goto*//*Label 7471*/ GIMT_Encode4(387728), // Rule ID 11268 //
     /* 387660 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387663 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 387666 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387669 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387673 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387677 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387681 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 387685 */   // MIs[1] Operand 1
     /* 387685 */   // No operand predicates
     /* 387685 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387687 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)  =>  (UMOVvi8:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v16i8] } ZPR:{ *:[nxv16i8] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$index)
     /* 387687 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 387690 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387694 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387699 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387705 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387710 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387715 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 387718 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387720 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387723 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387726 */   GIR_RootConstrainSelectedInstOperands,
     /* 387727 */   // GIR_Coverage, 11268,
     /* 387727 */   GIR_EraseRootFromParent_Done,
     /* 387728 */ // Label 7471: @387728
     /* 387728 */ GIM_Try, /*On fail goto*//*Label 7472*/ GIMT_Encode4(387801), // Rule ID 11269 //
     /* 387733 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387736 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 387739 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387746 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387750 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387754 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 387758 */   // MIs[1] Operand 1
     /* 387758 */   // No operand predicates
     /* 387758 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387760 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)  =>  (UMOVvi16:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v8i16] } ZPR:{ *:[nxv8i16] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$index)
     /* 387760 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 387763 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387767 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387772 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387778 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387783 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387788 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 387791 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387793 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387796 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387799 */   GIR_RootConstrainSelectedInstOperands,
     /* 387800 */   // GIR_Coverage, 11269,
     /* 387800 */   GIR_EraseRootFromParent_Done,
     /* 387801 */ // Label 7472: @387801
     /* 387801 */ GIM_Try, /*On fail goto*//*Label 7473*/ GIMT_Encode4(387874), // Rule ID 11270 //
     /* 387806 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 387809 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 387812 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387815 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387819 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387823 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387827 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 387831 */   // MIs[1] Operand 1
     /* 387831 */   // No operand predicates
     /* 387831 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387833 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)  =>  (UMOVvi32:{ *:[i32] } (EXTRACT_SUBREG:{ *:[v4i32] } ZPR:{ *:[nxv4i32] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$index)
     /* 387833 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 387836 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 387840 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 387845 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 387851 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387856 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 387861 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 387864 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387866 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 387869 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 387872 */   GIR_RootConstrainSelectedInstOperands,
     /* 387873 */   // GIR_Coverage, 11270,
     /* 387873 */   GIR_EraseRootFromParent_Done,
     /* 387874 */ // Label 7473: @387874
     /* 387874 */ GIM_Try, /*On fail goto*//*Label 7474*/ GIMT_Encode4(387922), // Rule ID 1926 //
     /* 387879 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387882 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 387885 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387896 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387900 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387904 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387908 */   // MIs[1] Operand 1
     /* 387908 */   // No operand predicates
     /* 387908 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387910 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi8_idx0:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387910 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8_idx0),
     /* 387913 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387915 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387917 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387920 */   GIR_RootConstrainSelectedInstOperands,
     /* 387921 */   // GIR_Coverage, 1926,
     /* 387921 */   GIR_EraseRootFromParent_Done,
     /* 387922 */ // Label 7474: @387922
     /* 387922 */ GIM_Try, /*On fail goto*//*Label 7475*/ GIMT_Encode4(387970), // Rule ID 1927 //
     /* 387927 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387930 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 387933 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387936 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387940 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 387952 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 387956 */   // MIs[1] Operand 1
     /* 387956 */   // No operand predicates
     /* 387956 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 387958 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi16_idx0:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 387958 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16_idx0),
     /* 387961 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 387963 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 387965 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 387968 */   GIR_RootConstrainSelectedInstOperands,
     /* 387969 */   // GIR_Coverage, 1927,
     /* 387969 */   GIR_EraseRootFromParent_Done,
     /* 387970 */ // Label 7475: @387970
     /* 387970 */ GIM_Try, /*On fail goto*//*Label 7476*/ GIMT_Encode4(388018), // Rule ID 1928 //
     /* 387975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 387978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 387981 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 387984 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 387988 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 387992 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 387996 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388000 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 388004 */   // MIs[1] Operand 1
     /* 388004 */   // No operand predicates
     /* 388004 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388006 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi32_idx0:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388006 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32_idx0),
     /* 388009 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388011 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388013 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388016 */   GIR_RootConstrainSelectedInstOperands,
     /* 388017 */   // GIR_Coverage, 1928,
     /* 388017 */   GIR_EraseRootFromParent_Done,
     /* 388018 */ // Label 7476: @388018
     /* 388018 */ GIM_Try, /*On fail goto*//*Label 7477*/ GIMT_Encode4(388066), // Rule ID 1930 //
     /* 388023 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388026 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 388029 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388032 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388036 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388040 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388044 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388048 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 388052 */   // MIs[1] Operand 1
     /* 388052 */   // No operand predicates
     /* 388052 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388054 */   // (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (UMOVvi8:{ *:[i32] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388054 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi8),
     /* 388057 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388059 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388061 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388064 */   GIR_RootConstrainSelectedInstOperands,
     /* 388065 */   // GIR_Coverage, 1930,
     /* 388065 */   GIR_EraseRootFromParent_Done,
     /* 388066 */ // Label 7477: @388066
     /* 388066 */ GIM_Try, /*On fail goto*//*Label 7478*/ GIMT_Encode4(388114), // Rule ID 1931 //
     /* 388071 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 388077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388088 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388092 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388096 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 388100 */   // MIs[1] Operand 1
     /* 388100 */   // No operand predicates
     /* 388100 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388102 */   // (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (UMOVvi16:{ *:[i32] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi16),
     /* 388105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388107 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388109 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388112 */   GIR_RootConstrainSelectedInstOperands,
     /* 388113 */   // GIR_Coverage, 1931,
     /* 388113 */   GIR_EraseRootFromParent_Done,
     /* 388114 */ // Label 7478: @388114
     /* 388114 */ GIM_Try, /*On fail goto*//*Label 7479*/ GIMT_Encode4(388162), // Rule ID 1932 //
     /* 388119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 388122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388136 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388140 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388144 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388148 */   // MIs[1] Operand 1
     /* 388148 */   // No operand predicates
     /* 388148 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388150 */   // (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (UMOVvi32:{ *:[i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 388150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi32),
     /* 388153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388155 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388157 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388160 */   GIR_RootConstrainSelectedInstOperands,
     /* 388161 */   // GIR_Coverage, 1932,
     /* 388161 */   GIR_EraseRootFromParent_Done,
     /* 388162 */ // Label 7479: @388162
     /* 388162 */ GIM_Try, /*On fail goto*//*Label 7480*/ GIMT_Encode4(388207), // Rule ID 5819 //
     /* 388167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 388170 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388173 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388177 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388181 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388185 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388189 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 388193 */   // MIs[1] Operand 1
     /* 388193 */   // No operand predicates
     /* 388193 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388195 */   // (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPi32:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 388195 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi32),
     /* 388198 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388200 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 388202 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 388205 */   GIR_RootConstrainSelectedInstOperands,
     /* 388206 */   // GIR_Coverage, 5819,
     /* 388206 */   GIR_EraseRootFromParent_Done,
     /* 388207 */ // Label 7480: @388207
     /* 388207 */ GIM_Try, /*On fail goto*//*Label 7481*/ GIMT_Encode4(388283), // Rule ID 11258 //
     /* 388212 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388215 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388218 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388221 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388225 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388229 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388233 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 388237 */   // MIs[1] Operand 1
     /* 388237 */   // No operand predicates
     /* 388237 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388239 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index), ssub:{ *:[i32] })
     /* 388239 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388242 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 388246 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388251 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388255 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388258 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388260 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388263 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388265 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388272 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388277 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388282 */   // GIR_Coverage, 11258,
     /* 388282 */   GIR_EraseRootFromParent_Done,
     /* 388283 */ // Label 7481: @388283
     /* 388283 */ GIM_Try, /*On fail goto*//*Label 7482*/ GIMT_Encode4(388359), // Rule ID 11259 //
     /* 388288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388301 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388305 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388309 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 388313 */   // MIs[1] Operand 1
     /* 388313 */   // No operand predicates
     /* 388313 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388315 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_H:{ *:[nxv16i8] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index), ssub:{ *:[i32] })
     /* 388315 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388318 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 388322 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388327 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388331 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388334 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388336 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388339 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388341 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388348 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388353 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388358 */   // GIR_Coverage, 11259,
     /* 388358 */   GIR_EraseRootFromParent_Done,
     /* 388359 */ // Label 7482: @388359
     /* 388359 */ GIM_Try, /*On fail goto*//*Label 7483*/ GIMT_Encode4(388435), // Rule ID 11260 //
     /* 388364 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388370 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388377 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388381 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388385 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388389 */   // MIs[1] Operand 1
     /* 388389 */   // No operand predicates
     /* 388389 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388391 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 388391 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388394 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388398 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388403 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388407 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388410 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388412 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388415 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388417 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388424 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388429 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388434 */   // GIR_Coverage, 11260,
     /* 388434 */   GIR_EraseRootFromParent_Done,
     /* 388435 */ // Label 7483: @388435
     /* 388435 */ GIM_Try, /*On fail goto*//*Label 7484*/ GIMT_Encode4(388511), // Rule ID 11265 //
     /* 388440 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388443 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388446 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388449 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388453 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388457 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388461 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 388465 */   // MIs[1] Operand 1
     /* 388465 */   // No operand predicates
     /* 388465 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388467 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_S:{ *:[nxv16i8] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index), ssub:{ *:[i32] })
     /* 388467 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388470 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 388474 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388479 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388483 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388486 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388488 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388491 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388493 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388500 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388505 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388510 */   // GIR_Coverage, 11265,
     /* 388510 */   GIR_EraseRootFromParent_Done,
     /* 388511 */ // Label 7484: @388511
     /* 388511 */ GIM_Try, /*On fail goto*//*Label 7485*/ GIMT_Encode4(388587), // Rule ID 11266 //
     /* 388516 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388519 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388522 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388525 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388529 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 388533 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 388537 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 388541 */   // MIs[1] Operand 1
     /* 388541 */   // No operand predicates
     /* 388541 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 388543 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f32] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), ssub:{ *:[i32] })
     /* 388543 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 388546 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 388550 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388555 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 388559 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 388562 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388564 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388567 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388569 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 388576 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388581 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388586 */   // GIR_Coverage, 11266,
     /* 388586 */   GIR_EraseRootFromParent_Done,
     /* 388587 */ // Label 7485: @388587
     /* 388587 */ GIM_Try, /*On fail goto*//*Label 7486*/ GIMT_Encode4(388648), // Rule ID 11248 //
     /* 388592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 388598 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388601 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388605 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388609 */   // (vector_extract:{ *:[i32] } nxv16i8:{ *:[nxv16i8] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_B:{ *:[i32] } (WHILELS_PXX_B:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv16i8] }:$vec)
     /* 388609 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388612 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_B),
     /* 388616 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388621 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388627 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388631 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388634 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388636 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_B),
     /* 388639 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388641 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388644 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388646 */   GIR_RootConstrainSelectedInstOperands,
     /* 388647 */   // GIR_Coverage, 11248,
     /* 388647 */   GIR_EraseRootFromParent_Done,
     /* 388648 */ // Label 7486: @388648
     /* 388648 */ GIM_Try, /*On fail goto*//*Label 7487*/ GIMT_Encode4(388709), // Rule ID 11249 //
     /* 388653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 388659 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388662 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388666 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388670 */   // (vector_extract:{ *:[i32] } nxv8i16:{ *:[nxv8i16] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_H:{ *:[i32] } (WHILELS_PXX_H:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv8i16] }:$vec)
     /* 388670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_H),
     /* 388677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388682 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388688 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388692 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388695 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388697 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_H),
     /* 388700 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388702 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388705 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388707 */   GIR_RootConstrainSelectedInstOperands,
     /* 388708 */   // GIR_Coverage, 11249,
     /* 388708 */   GIR_EraseRootFromParent_Done,
     /* 388709 */ // Label 7487: @388709
     /* 388709 */ GIM_Try, /*On fail goto*//*Label 7488*/ GIMT_Encode4(388770), // Rule ID 11250 //
     /* 388714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 388727 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388731 */   // (vector_extract:{ *:[i32] } nxv4i32:{ *:[nxv4i32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_S:{ *:[i32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4i32] }:$vec)
     /* 388731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388743 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388749 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388753 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388756 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388758 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_S),
     /* 388761 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 388763 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388766 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388768 */   GIR_RootConstrainSelectedInstOperands,
     /* 388769 */   // GIR_Coverage, 11250,
     /* 388769 */   GIR_EraseRootFromParent_Done,
     /* 388770 */ // Label 7488: @388770
     /* 388770 */ GIM_Try, /*On fail goto*//*Label 7489*/ GIMT_Encode4(388831), // Rule ID 11255 //
     /* 388775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 388781 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388784 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388788 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388792 */   // (vector_extract:{ *:[f32] } nxv4f32:{ *:[nxv4f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_S:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv4f32] }:$vec)
     /* 388792 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388795 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_S),
     /* 388799 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388804 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388810 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388814 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388817 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388819 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388822 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388824 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388827 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388829 */   GIR_RootConstrainSelectedInstOperands,
     /* 388830 */   // GIR_Coverage, 11255,
     /* 388830 */   GIR_EraseRootFromParent_Done,
     /* 388831 */ // Label 7489: @388831
     /* 388831 */ GIM_Try, /*On fail goto*//*Label 7490*/ GIMT_Encode4(388892), // Rule ID 11256 //
     /* 388836 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388839 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 388842 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388845 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 388849 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 388853 */   // (vector_extract:{ *:[f32] } nxv2f32:{ *:[nxv2f32] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_S:{ *:[f32] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f32] }:$vec)
     /* 388853 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 388856 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 388860 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 388865 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 388871 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 388875 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 388878 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 388880 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_S),
     /* 388883 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 388885 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 388888 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 388890 */   GIR_RootConstrainSelectedInstOperands,
     /* 388891 */   // GIR_Coverage, 11256,
     /* 388891 */   GIR_EraseRootFromParent_Done,
     /* 388892 */ // Label 7490: @388892
     /* 388892 */ GIM_Reject,
     /* 388893 */ // Label 7450: @388893
     /* 388893 */ GIM_Try, /*On fail goto*//*Label 7491*/ GIMT_Encode4(388938), // Rule ID 6995 //
     /* 388898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 388901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388912 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388916 */   // (extractelt:{ *:[i64] } V128:{ *:[v2i64] }:$V, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2i64] }:$V, dsub:{ *:[i32] })
     /* 388916 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388919 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388921 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // V
     /* 388927 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388932 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 388937 */   // GIR_Coverage, 6995,
     /* 388937 */   GIR_EraseRootFromParent_Done,
     /* 388938 */ // Label 7491: @388938
     /* 388938 */ GIM_Try, /*On fail goto*//*Label 7492*/ GIMT_Encode4(388982), // Rule ID 11286 //
     /* 388943 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388946 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388949 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388952 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388956 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 388960 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$Zs, dsub:{ *:[i32] })
     /* 388960 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 388963 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 388965 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 388971 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 388976 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 388981 */   // GIR_Coverage, 11286,
     /* 388981 */   GIR_EraseRootFromParent_Done,
     /* 388982 */ // Label 7492: @388982
     /* 388982 */ GIM_Try, /*On fail goto*//*Label 7493*/ GIMT_Encode4(389026), // Rule ID 11292 //
     /* 388987 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 388990 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 388993 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 388996 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389000 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389004 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$Zs, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$Zs, dsub:{ *:[i32] })
     /* 389004 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389007 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389009 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Zs
     /* 389015 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389020 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389025 */   // GIR_Coverage, 11292,
     /* 389025 */   GIR_EraseRootFromParent_Done,
     /* 389026 */ // Label 7493: @389026
     /* 389026 */ GIM_Try, /*On fail goto*//*Label 7494*/ GIMT_Encode4(389071), // Rule ID 5815 //
     /* 389031 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389034 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389037 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389041 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389045 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 389049 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })  =>  (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] })
     /* 389049 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389052 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389054 */   GIR_CopySubReg, /*NewInsnID*/0, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 389060 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389065 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389070 */   // GIR_Coverage, 5815,
     /* 389070 */   GIR_EraseRootFromParent_Done,
     /* 389071 */ // Label 7494: @389071
     /* 389071 */ GIM_Try, /*On fail goto*//*Label 7495*/ GIMT_Encode4(389144), // Rule ID 11271 //
     /* 389076 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389082 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389085 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389089 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389093 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389097 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389101 */   // MIs[1] Operand 1
     /* 389101 */   // No operand predicates
     /* 389101 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389103 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)  =>  (UMOVvi64:{ *:[i64] } (EXTRACT_SUBREG:{ *:[v2i64] } ZPR:{ *:[nxv2i64] }:$vec, zsub:{ *:[i32] }), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$index)
     /* 389103 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 389106 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389110 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389115 */   GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(43), // vec
     /* 389121 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389126 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389131 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 389134 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389136 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389139 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // index
     /* 389142 */   GIR_RootConstrainSelectedInstOperands,
     /* 389143 */   // GIR_Coverage, 11271,
     /* 389143 */   GIR_EraseRootFromParent_Done,
     /* 389144 */ // Label 7495: @389144
     /* 389144 */ GIM_Try, /*On fail goto*//*Label 7496*/ GIMT_Encode4(389192), // Rule ID 1929 //
     /* 389149 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 389152 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389155 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389158 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389162 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389166 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389170 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389174 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndex0),
     /* 389178 */   // MIs[1] Operand 1
     /* 389178 */   // No operand predicates
     /* 389178 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389180 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndex0>>:$idx)  =>  (UMOVvi64_idx0:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389180 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64_idx0),
     /* 389183 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389185 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389187 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389190 */   GIR_RootConstrainSelectedInstOperands,
     /* 389191 */   // GIR_Coverage, 1929,
     /* 389191 */   GIR_EraseRootFromParent_Done,
     /* 389192 */ // Label 7496: @389192
     /* 389192 */ GIM_Try, /*On fail goto*//*Label 7497*/ GIMT_Encode4(389240), // Rule ID 1933 //
     /* 389197 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389200 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389203 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389214 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389218 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389222 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389226 */   // MIs[1] Operand 1
     /* 389226 */   // No operand predicates
     /* 389226 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389228 */   // (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (UMOVvi64:{ *:[i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 389228 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMOVvi64),
     /* 389231 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389233 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389235 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389238 */   GIR_RootConstrainSelectedInstOperands,
     /* 389239 */   // GIR_Coverage, 1933,
     /* 389239 */   GIR_EraseRootFromParent_Done,
     /* 389240 */ // Label 7497: @389240
     /* 389240 */ GIM_Try, /*On fail goto*//*Label 7498*/ GIMT_Encode4(389285), // Rule ID 5818 //
     /* 389245 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 389248 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389251 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389255 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389259 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389263 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389267 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 389271 */   // MIs[1] Operand 1
     /* 389271 */   // No operand predicates
     /* 389271 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389273 */   // (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPi64:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 389273 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPi64),
     /* 389276 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389278 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 389280 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 389283 */   GIR_RootConstrainSelectedInstOperands,
     /* 389284 */   // GIR_Coverage, 5818,
     /* 389284 */   GIR_EraseRootFromParent_Done,
     /* 389285 */ // Label 7498: @389285
     /* 389285 */ GIM_Try, /*On fail goto*//*Label 7499*/ GIMT_Encode4(389361), // Rule ID 11261 //
     /* 389290 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389293 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389296 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389299 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389303 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389307 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389311 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389315 */   // MIs[1] Operand 1
     /* 389315 */   // No operand predicates
     /* 389315 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389317 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[i64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 389317 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389320 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389324 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389329 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389333 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389336 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389338 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389341 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389343 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389350 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389355 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389360 */   // GIR_Coverage, 11261,
     /* 389360 */   GIR_EraseRootFromParent_Done,
     /* 389361 */ // Label 7499: @389361
     /* 389361 */ GIM_Try, /*On fail goto*//*Label 7500*/ GIMT_Encode4(389437), // Rule ID 11267 //
     /* 389366 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389375 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389379 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 389383 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389387 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389391 */   // MIs[1] Operand 1
     /* 389391 */   // No operand predicates
     /* 389391 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389393 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)  =>  (EXTRACT_SUBREG:{ *:[f64] } (DUP_ZZI_D:{ *:[nxv16i8] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index), dsub:{ *:[i32] })
     /* 389393 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389396 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389400 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389405 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // vec
     /* 389409 */   GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/1, // index
     /* 389412 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389414 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 389417 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389419 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 389426 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389431 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389436 */   // GIR_Coverage, 11267,
     /* 389436 */   GIR_EraseRootFromParent_Done,
     /* 389437 */ // Label 7500: @389437
     /* 389437 */ GIM_Try, /*On fail goto*//*Label 7501*/ GIMT_Encode4(389498), // Rule ID 11251 //
     /* 389442 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389448 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389451 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389455 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389459 */   // (vector_extract:{ *:[i64] } nxv2i64:{ *:[nxv2i64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_RPZ_D:{ *:[i64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2i64] }:$vec)
     /* 389459 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389462 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 389466 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389471 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389477 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389481 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389484 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_RPZ_D),
     /* 389489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 389491 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389494 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389496 */   GIR_RootConstrainSelectedInstOperands,
     /* 389497 */   // GIR_Coverage, 11251,
     /* 389497 */   GIR_EraseRootFromParent_Done,
     /* 389498 */ // Label 7501: @389498
     /* 389498 */ GIM_Try, /*On fail goto*//*Label 7502*/ GIMT_Encode4(389559), // Rule ID 11257 //
     /* 389503 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389506 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 389509 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 389512 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 389516 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 389520 */   // (vector_extract:{ *:[f64] } nxv2f64:{ *:[nxv2f64] }:$vec, GPR64:{ *:[i64] }:$index)  =>  (LASTB_VPZ_D:{ *:[f64] } (WHILELS_PXX_D:{ *:[nxv1i1] }:{ *:[i32] } XZR:{ *:[i64] }, GPR64:{ *:[i64] }:$index), ZPR:{ *:[nxv2f64] }:$vec)
     /* 389520 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv1s1,
     /* 389523 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::WHILELS_PXX_D),
     /* 389527 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389532 */   GIR_AddRegister, /*InsnID*/1, GIMT_Encode2(AArch64::XZR), /*AddRegisterRegFlags*/GIMT_Encode2(0),
     /* 389538 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/2, // index
     /* 389542 */   GIR_SetImplicitDefDead, /*InsnID*/1, /*OpIdx for AArch64::NZCV*/0,
     /* 389545 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389547 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LASTB_VPZ_D),
     /* 389550 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vd]
     /* 389552 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389555 */   GIR_RootToRootCopy, /*OpIdx*/1, // vec
     /* 389557 */   GIR_RootConstrainSelectedInstOperands,
     /* 389558 */   // GIR_Coverage, 11257,
     /* 389558 */   GIR_EraseRootFromParent_Done,
     /* 389559 */ // Label 7502: @389559
     /* 389559 */ GIM_Reject,
     /* 389560 */ // Label 7451: @389560
     /* 389560 */ GIM_Reject,
     /* 389561 */ // Label 92: @389561
     /* 389561 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(14), GIMT_Encode2(24), /*)*//*default:*//*Label 7510*/ GIMT_Encode4(391880),
     /* 389572 */ /*GILLT_nxv2s16*//*Label 7503*/ GIMT_Encode4(389612),
     /* 389576 */ /*GILLT_nxv2s32*//*Label 7504*/ GIMT_Encode4(389971),
     /* 389580 */ /*GILLT_nxv2s64*//*Label 7505*/ GIMT_Encode4(390273), GIMT_Encode4(0),
     /* 389588 */ /*GILLT_nxv4s16*//*Label 7506*/ GIMT_Encode4(390648),
     /* 389592 */ /*GILLT_nxv4s32*//*Label 7507*/ GIMT_Encode4(390950), GIMT_Encode4(0),
     /* 389600 */ /*GILLT_nxv8s16*//*Label 7508*/ GIMT_Encode4(391325), GIMT_Encode4(0),
     /* 389608 */ /*GILLT_nxv16s8*//*Label 7509*/ GIMT_Encode4(391736),
     /* 389612 */ // Label 7503: @389612
     /* 389612 */ GIM_Try, /*On fail goto*//*Label 7511*/ GIMT_Encode4(389970),
     /* 389617 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 389620 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389624 */   GIM_Try, /*On fail goto*//*Label 7512*/ GIMT_Encode4(389688), // Rule ID 6049 //
     /* 389629 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389632 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389636 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389640 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 389644 */     // MIs[1] Operand 1
     /* 389644 */     // No operand predicates
     /* 389644 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389646 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 389646 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 389649 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 389653 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389658 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 389661 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 389663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 389666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 389668 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389674 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 389677 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389682 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 389687 */     // GIR_Coverage, 6049,
     /* 389687 */     GIR_EraseRootFromParent_Done,
     /* 389688 */   // Label 7512: @389688
     /* 389688 */   GIM_Try, /*On fail goto*//*Label 7513*/ GIMT_Encode4(389745), // Rule ID 2671 //
     /* 389693 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389704 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 389708 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389712 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389717 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389721 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389725 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 389729 */     // MIs[2] Operand 1
     /* 389729 */     // No operand predicates
     /* 389729 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389731 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 389731 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 389734 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389736 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389740 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389743 */     GIR_RootConstrainSelectedInstOperands,
     /* 389744 */     // GIR_Coverage, 2671,
     /* 389744 */     GIR_EraseRootFromParent_Done,
     /* 389745 */   // Label 7513: @389745
     /* 389745 */   GIM_Try, /*On fail goto*//*Label 7514*/ GIMT_Encode4(389802), // Rule ID 2673 //
     /* 389750 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389753 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389757 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389761 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 389765 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389782 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 389786 */     // MIs[2] Operand 1
     /* 389786 */     // No operand predicates
     /* 389786 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389788 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f16] } ZPR:{ *:[nxv2f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 389788 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 389791 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389793 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389797 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389800 */     GIR_RootConstrainSelectedInstOperands,
     /* 389801 */     // GIR_Coverage, 2673,
     /* 389801 */     GIR_EraseRootFromParent_Done,
     /* 389802 */   // Label 7514: @389802
     /* 389802 */   GIM_Try, /*On fail goto*//*Label 7515*/ GIMT_Encode4(389859), // Rule ID 8391 //
     /* 389807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 389818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 389822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 389826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 389835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 389839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 389843 */     // MIs[2] Operand 1
     /* 389843 */     // No operand predicates
     /* 389843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 389845 */     // (splat_vector:{ *:[nxv2f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv2f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 389845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 389854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 389857 */     GIR_RootConstrainSelectedInstOperands,
     /* 389858 */     // GIR_Coverage, 8391,
     /* 389858 */     GIR_EraseRootFromParent_Done,
     /* 389859 */   // Label 7515: @389859
     /* 389859 */   GIM_Try, /*On fail goto*//*Label 7516*/ GIMT_Encode4(389893), // Rule ID 8434 //
     /* 389864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389875 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 389879 */     // MIs[1] Operand 1
     /* 389879 */     // No operand predicates
     /* 389879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 389881 */     // (splat_vector:{ *:[nxv2f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv2f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 389881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 389884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389886 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 389891 */     GIR_RootConstrainSelectedInstOperands,
     /* 389892 */     // GIR_Coverage, 8434,
     /* 389892 */     GIR_EraseRootFromParent_Done,
     /* 389893 */   // Label 7516: @389893
     /* 389893 */   GIM_Try, /*On fail goto*//*Label 7517*/ GIMT_Encode4(389969), // Rule ID 8412 //
     /* 389898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 389901 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389905 */     // (splat_vector:{ *:[nxv2f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv2f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 389905 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 389908 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 389912 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389917 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 389919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 389922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 389926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 389931 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 389934 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 389938 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 389941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389951 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 389956 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 389959 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 389961 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 389964 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 389967 */     GIR_RootConstrainSelectedInstOperands,
     /* 389968 */     // GIR_Coverage, 8412,
     /* 389968 */     GIR_EraseRootFromParent_Done,
     /* 389969 */   // Label 7517: @389969
     /* 389969 */   GIM_Reject,
     /* 389970 */ // Label 7511: @389970
     /* 389970 */ GIM_Reject,
     /* 389971 */ // Label 7504: @389971
     /* 389971 */ GIM_Try, /*On fail goto*//*Label 7518*/ GIMT_Encode4(390272),
     /* 389976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 389979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 389983 */   GIM_Try, /*On fail goto*//*Label 7519*/ GIMT_Encode4(390047), // Rule ID 6047 //
     /* 389988 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 389991 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 389995 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 389999 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390003 */     // MIs[1] Operand 1
     /* 390003 */     // No operand predicates
     /* 390003 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390005 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390005 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390008 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390012 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390017 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390020 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390022 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390025 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390027 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390030 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390033 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390036 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390041 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390046 */     // GIR_Coverage, 6047,
     /* 390046 */     GIR_EraseRootFromParent_Done,
     /* 390047 */   // Label 7519: @390047
     /* 390047 */   GIM_Try, /*On fail goto*//*Label 7520*/ GIMT_Encode4(390104), // Rule ID 8400 //
     /* 390052 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390055 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390059 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390063 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 390067 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390071 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390076 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390080 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390084 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390088 */     // MIs[2] Operand 1
     /* 390088 */     // No operand predicates
     /* 390088 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390090 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv2f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390090 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390093 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390095 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390099 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390102 */     GIR_RootConstrainSelectedInstOperands,
     /* 390103 */     // GIR_Coverage, 8400,
     /* 390103 */     GIR_EraseRootFromParent_Done,
     /* 390104 */   // Label 7520: @390104
     /* 390104 */   GIM_Try, /*On fail goto*//*Label 7521*/ GIMT_Encode4(390161), // Rule ID 8409 //
     /* 390109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390112 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390116 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390120 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 390124 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390128 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390133 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390137 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390141 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390145 */     // MIs[2] Operand 1
     /* 390145 */     // No operand predicates
     /* 390145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390147 */     // (splat_vector:{ *:[nxv2f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f32] } ZPR:{ *:[nxv2f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390147 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390150 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390152 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390156 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390159 */     GIR_RootConstrainSelectedInstOperands,
     /* 390160 */     // GIR_Coverage, 8409,
     /* 390160 */     GIR_EraseRootFromParent_Done,
     /* 390161 */   // Label 7521: @390161
     /* 390161 */   GIM_Try, /*On fail goto*//*Label 7522*/ GIMT_Encode4(390195), // Rule ID 8436 //
     /* 390166 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390169 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390173 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390177 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 390181 */     // MIs[1] Operand 1
     /* 390181 */     // No operand predicates
     /* 390181 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390183 */     // (splat_vector:{ *:[nxv2f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv2f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 390183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 390186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390188 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 390193 */     GIR_RootConstrainSelectedInstOperands,
     /* 390194 */     // GIR_Coverage, 8436,
     /* 390194 */     GIR_EraseRootFromParent_Done,
     /* 390195 */   // Label 7522: @390195
     /* 390195 */   GIM_Try, /*On fail goto*//*Label 7523*/ GIMT_Encode4(390271), // Rule ID 8414 //
     /* 390200 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390203 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390207 */     // (splat_vector:{ *:[nxv2f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv2f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390207 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390210 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390214 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390219 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390221 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390224 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390228 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390233 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390236 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390240 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 390243 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390248 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390253 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 390258 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390261 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390263 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390266 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390269 */     GIR_RootConstrainSelectedInstOperands,
     /* 390270 */     // GIR_Coverage, 8414,
     /* 390270 */     GIR_EraseRootFromParent_Done,
     /* 390271 */   // Label 7523: @390271
     /* 390271 */   GIM_Reject,
     /* 390272 */ // Label 7518: @390272
     /* 390272 */ GIM_Reject,
     /* 390273 */ // Label 7505: @390273
     /* 390273 */ GIM_Try, /*On fail goto*//*Label 7524*/ GIMT_Encode4(390647),
     /* 390278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 390281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390285 */   GIM_Try, /*On fail goto*//*Label 7525*/ GIMT_Encode4(390339), // Rule ID 6042 //
     /* 390290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390293 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390297 */     // (splat_vector:{ *:[nxv2i64] } 0:{ *:[i64] })  =>  (SUBREG_TO_REG:{ *:[nxv2i64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390297 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390300 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390304 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390309 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390312 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390314 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390317 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390319 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390322 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390325 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390328 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390333 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390338 */     // GIR_Coverage, 6042,
     /* 390338 */     GIR_EraseRootFromParent_Done,
     /* 390339 */   // Label 7525: @390339
     /* 390339 */   GIM_Try, /*On fail goto*//*Label 7526*/ GIMT_Encode4(390403), // Rule ID 6046 //
     /* 390344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390355 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390359 */     // MIs[1] Operand 1
     /* 390359 */     // No operand predicates
     /* 390359 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390361 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv2f64] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390361 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390364 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390368 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390373 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390376 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390378 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390381 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390383 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390386 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390389 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390392 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390397 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390402 */     // GIR_Coverage, 6046,
     /* 390402 */     GIR_EraseRootFromParent_Done,
     /* 390403 */   // Label 7526: @390403
     /* 390403 */   GIM_Try, /*On fail goto*//*Label 7527*/ GIMT_Encode4(390460), // Rule ID 2668 //
     /* 390408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390411 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390415 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390419 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390423 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390427 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390432 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390436 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390440 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390444 */     // MIs[2] Operand 1
     /* 390444 */     // No operand predicates
     /* 390444 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390446 */     // (splat_vector:{ *:[nxv2i64] } (vector_extract:{ *:[i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2i64] } ZPR:{ *:[nxv2i64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390446 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390449 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390458 */     GIR_RootConstrainSelectedInstOperands,
     /* 390459 */     // GIR_Coverage, 2668,
     /* 390459 */     GIR_EraseRootFromParent_Done,
     /* 390460 */   // Label 7527: @390460
     /* 390460 */   GIM_Try, /*On fail goto*//*Label 7528*/ GIMT_Encode4(390517), // Rule ID 8406 //
     /* 390465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 390480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390497 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_d),
     /* 390501 */     // MIs[2] Operand 1
     /* 390501 */     // No operand predicates
     /* 390501 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390503 */     // (splat_vector:{ *:[nxv2f64] } (vector_extract:{ *:[f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index))  =>  (DUP_ZZI_D:{ *:[nxv2f64] } ZPR:{ *:[nxv2f64] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_d>>:$index)
     /* 390503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390508 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390512 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390515 */     GIR_RootConstrainSelectedInstOperands,
     /* 390516 */     // GIR_Coverage, 8406,
     /* 390516 */     GIR_EraseRootFromParent_Done,
     /* 390517 */   // Label 7528: @390517
     /* 390517 */   GIM_Try, /*On fail goto*//*Label 7529*/ GIMT_Encode4(390551), // Rule ID 8437 //
     /* 390522 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390525 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390529 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390533 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm64),
     /* 390537 */     // MIs[1] Operand 1
     /* 390537 */     // No operand predicates
     /* 390537 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390539 */     // (splat_vector:{ *:[nxv2f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>><<X:fpimm64XForm>>:$imm8)  =>  (FDUP_ZI_D:{ *:[nxv2f64] } (fpimm64XForm:{ *:[f64] } (fpimm:{ *:[f64] })<<P:Predicate_fpimm64>>:$imm8))
     /* 390539 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_D),
     /* 390542 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390544 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm64), // imm8
     /* 390549 */     GIR_RootConstrainSelectedInstOperands,
     /* 390550 */     // GIR_Coverage, 8437,
     /* 390550 */     GIR_EraseRootFromParent_Done,
     /* 390551 */   // Label 7529: @390551
     /* 390551 */   GIM_Try, /*On fail goto*//*Label 7530*/ GIMT_Encode4(390570), // Rule ID 2391 //
     /* 390556 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390559 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 390563 */     // (splat_vector:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)  =>  (DUP_ZR_D:{ *:[nxv2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 390563 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_D),
     /* 390568 */     GIR_RootConstrainSelectedInstOperands,
     /* 390569 */     // GIR_Coverage, 2391,
     /* 390569 */     GIR_Done,
     /* 390570 */   // Label 7530: @390570
     /* 390570 */   GIM_Try, /*On fail goto*//*Label 7531*/ GIMT_Encode4(390646), // Rule ID 8415 //
     /* 390575 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390578 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390582 */     // (splat_vector:{ *:[nxv2f64] } FPR64:{ *:[f64] }:$src)  =>  (DUP_ZZI_D:{ *:[nxv2f64] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR64:{ *:[f64] }:$src, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390582 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390585 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390589 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390596 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390599 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390603 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390608 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390611 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390615 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 390618 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390623 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390628 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 390633 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_D),
     /* 390636 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390638 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390641 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390644 */     GIR_RootConstrainSelectedInstOperands,
     /* 390645 */     // GIR_Coverage, 8415,
     /* 390645 */     GIR_EraseRootFromParent_Done,
     /* 390646 */   // Label 7531: @390646
     /* 390646 */   GIM_Reject,
     /* 390647 */ // Label 7524: @390647
     /* 390647 */ GIM_Reject,
     /* 390648 */ // Label 7506: @390648
     /* 390648 */ GIM_Try, /*On fail goto*//*Label 7532*/ GIMT_Encode4(390949),
     /* 390653 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 390656 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390660 */   GIM_Try, /*On fail goto*//*Label 7533*/ GIMT_Encode4(390724), // Rule ID 6050 //
     /* 390665 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390668 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390672 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390676 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 390680 */     // MIs[1] Operand 1
     /* 390680 */     // No operand predicates
     /* 390680 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390682 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390682 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390685 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390689 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390694 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390697 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390699 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390702 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390704 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390710 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 390713 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390718 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 390723 */     // GIR_Coverage, 6050,
     /* 390723 */     GIR_EraseRootFromParent_Done,
     /* 390724 */   // Label 7533: @390724
     /* 390724 */   GIM_Try, /*On fail goto*//*Label 7534*/ GIMT_Encode4(390781), // Rule ID 2672 //
     /* 390729 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390732 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390736 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390740 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 390744 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390748 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390753 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390757 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390761 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 390765 */     // MIs[2] Operand 1
     /* 390765 */     // No operand predicates
     /* 390765 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390767 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f16] } ZPR:{ *:[nxv4f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 390767 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 390770 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390772 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390776 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390779 */     GIR_RootConstrainSelectedInstOperands,
     /* 390780 */     // GIR_Coverage, 2672,
     /* 390780 */     GIR_EraseRootFromParent_Done,
     /* 390781 */   // Label 7534: @390781
     /* 390781 */   GIM_Try, /*On fail goto*//*Label 7535*/ GIMT_Encode4(390838), // Rule ID 8394 //
     /* 390786 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390789 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390793 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 390797 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 390801 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 390805 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390810 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 390814 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 390818 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 390822 */     // MIs[2] Operand 1
     /* 390822 */     // No operand predicates
     /* 390822 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 390824 */     // (splat_vector:{ *:[nxv4f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv4f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 390824 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390827 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390829 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 390833 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 390836 */     GIR_RootConstrainSelectedInstOperands,
     /* 390837 */     // GIR_Coverage, 8394,
     /* 390837 */     GIR_EraseRootFromParent_Done,
     /* 390838 */   // Label 7535: @390838
     /* 390838 */   GIM_Try, /*On fail goto*//*Label 7536*/ GIMT_Encode4(390872), // Rule ID 8433 //
     /* 390843 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390846 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 390850 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 390854 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 390858 */     // MIs[1] Operand 1
     /* 390858 */     // No operand predicates
     /* 390858 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 390860 */     // (splat_vector:{ *:[nxv4f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv4f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 390860 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 390863 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390865 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 390870 */     GIR_RootConstrainSelectedInstOperands,
     /* 390871 */     // GIR_Coverage, 8433,
     /* 390871 */     GIR_EraseRootFromParent_Done,
     /* 390872 */   // Label 7536: @390872
     /* 390872 */   GIM_Try, /*On fail goto*//*Label 7537*/ GIMT_Encode4(390948), // Rule ID 8411 //
     /* 390877 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 390880 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390884 */     // (splat_vector:{ *:[nxv4f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv4f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 390884 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 390887 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 390891 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390896 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 390898 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 390901 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 390905 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390910 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 390913 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 390917 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 390920 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390925 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390930 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 390935 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 390938 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 390940 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 390943 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390946 */     GIR_RootConstrainSelectedInstOperands,
     /* 390947 */     // GIR_Coverage, 8411,
     /* 390947 */     GIR_EraseRootFromParent_Done,
     /* 390948 */   // Label 7537: @390948
     /* 390948 */   GIM_Reject,
     /* 390949 */ // Label 7532: @390949
     /* 390949 */ GIM_Reject,
     /* 390950 */ // Label 7507: @390950
     /* 390950 */ GIM_Try, /*On fail goto*//*Label 7538*/ GIMT_Encode4(391324),
     /* 390955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 390958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 390962 */   GIM_Try, /*On fail goto*//*Label 7539*/ GIMT_Encode4(391016), // Rule ID 6043 //
     /* 390967 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 390970 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 390974 */     // (splat_vector:{ *:[nxv4i32] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv4i32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 390974 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 390977 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 390981 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 390986 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 390989 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 390991 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 390994 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 390996 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 390999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391005 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391010 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391015 */     // GIR_Coverage, 6043,
     /* 391015 */     GIR_EraseRootFromParent_Done,
     /* 391016 */   // Label 7539: @391016
     /* 391016 */   GIM_Try, /*On fail goto*//*Label 7540*/ GIMT_Encode4(391080), // Rule ID 6048 //
     /* 391021 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391024 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391028 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391032 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391036 */     // MIs[1] Operand 1
     /* 391036 */     // No operand predicates
     /* 391036 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391038 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv4f32] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391053 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391055 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391058 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391060 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391063 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391066 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391069 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391074 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391079 */     // GIR_Coverage, 6048,
     /* 391079 */     GIR_EraseRootFromParent_Done,
     /* 391080 */   // Label 7540: @391080
     /* 391080 */   GIM_Try, /*On fail goto*//*Label 7541*/ GIMT_Encode4(391137), // Rule ID 2665 //
     /* 391085 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391088 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391092 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391096 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391100 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391104 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391109 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391113 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391117 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391121 */     // MIs[2] Operand 1
     /* 391121 */     // No operand predicates
     /* 391121 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391123 */     // (splat_vector:{ *:[nxv4i32] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4i32] } ZPR:{ *:[nxv4i32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391123 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391126 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391128 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391132 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391135 */     GIR_RootConstrainSelectedInstOperands,
     /* 391136 */     // GIR_Coverage, 2665,
     /* 391136 */     GIR_EraseRootFromParent_Done,
     /* 391137 */   // Label 7541: @391137
     /* 391137 */   GIM_Try, /*On fail goto*//*Label 7542*/ GIMT_Encode4(391194), // Rule ID 8403 //
     /* 391142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391145 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391149 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391153 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 391157 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391161 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391166 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391170 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391174 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_s),
     /* 391178 */     // MIs[2] Operand 1
     /* 391178 */     // No operand predicates
     /* 391178 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391180 */     // (splat_vector:{ *:[nxv4f32] } (vector_extract:{ *:[f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index))  =>  (DUP_ZZI_S:{ *:[nxv4f32] } ZPR:{ *:[nxv4f32] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_s>>:$index)
     /* 391180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391185 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391189 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391192 */     GIR_RootConstrainSelectedInstOperands,
     /* 391193 */     // GIR_Coverage, 8403,
     /* 391193 */     GIR_EraseRootFromParent_Done,
     /* 391194 */   // Label 7542: @391194
     /* 391194 */   GIM_Try, /*On fail goto*//*Label 7543*/ GIMT_Encode4(391228), // Rule ID 8435 //
     /* 391199 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391210 */     GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm32),
     /* 391214 */     // MIs[1] Operand 1
     /* 391214 */     // No operand predicates
     /* 391214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391216 */     // (splat_vector:{ *:[nxv4f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>><<X:fpimm32XForm>>:$imm8)  =>  (FDUP_ZI_S:{ *:[nxv4f32] } (fpimm32XForm:{ *:[f32] } (fpimm:{ *:[f32] })<<P:Predicate_fpimm32>>:$imm8))
     /* 391216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_S),
     /* 391219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391221 */     GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm32), // imm8
     /* 391226 */     GIR_RootConstrainSelectedInstOperands,
     /* 391227 */     // GIR_Coverage, 8435,
     /* 391227 */     GIR_EraseRootFromParent_Done,
     /* 391228 */   // Label 7543: @391228
     /* 391228 */   GIM_Try, /*On fail goto*//*Label 7544*/ GIMT_Encode4(391247), // Rule ID 2390 //
     /* 391233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391236 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391240 */     // (splat_vector:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_S:{ *:[nxv4i32] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391240 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_S),
     /* 391245 */     GIR_RootConstrainSelectedInstOperands,
     /* 391246 */     // GIR_Coverage, 2390,
     /* 391246 */     GIR_Done,
     /* 391247 */   // Label 7544: @391247
     /* 391247 */   GIM_Try, /*On fail goto*//*Label 7545*/ GIMT_Encode4(391323), // Rule ID 8413 //
     /* 391252 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391255 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391259 */     // (splat_vector:{ *:[nxv4f32] } FPR32:{ *:[f32] }:$src)  =>  (DUP_ZZI_S:{ *:[nxv4f32] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR32:{ *:[f32] }:$src, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391259 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391262 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391266 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391271 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391273 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391276 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391280 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391285 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391288 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391292 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 391295 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391300 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391305 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 391310 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_S),
     /* 391313 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391315 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391318 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391321 */     GIR_RootConstrainSelectedInstOperands,
     /* 391322 */     // GIR_Coverage, 8413,
     /* 391322 */     GIR_EraseRootFromParent_Done,
     /* 391323 */   // Label 7545: @391323
     /* 391323 */   GIM_Reject,
     /* 391324 */ // Label 7538: @391324
     /* 391324 */ GIM_Reject,
     /* 391325 */ // Label 7508: @391325
     /* 391325 */ GIM_Try, /*On fail goto*//*Label 7546*/ GIMT_Encode4(391386), // Rule ID 6044 //
     /* 391330 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391333 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391336 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391340 */   GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391344 */   // (splat_vector:{ *:[nxv8i16] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv8i16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391344 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391347 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391351 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391356 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391359 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391361 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391364 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391366 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391369 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391372 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391375 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391380 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391385 */   // GIR_Coverage, 6044,
     /* 391385 */   GIR_EraseRootFromParent_Done,
     /* 391386 */ // Label 7546: @391386
     /* 391386 */ GIM_Try, /*On fail goto*//*Label 7547*/ GIMT_Encode4(391457), // Rule ID 6051 //
     /* 391391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391401 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391405 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391409 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm0),
     /* 391413 */   // MIs[1] Operand 1
     /* 391413 */   // No operand predicates
     /* 391413 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391415 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm0>>)  =>  (SUBREG_TO_REG:{ *:[nxv8f16] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391415 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391418 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391422 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391427 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391430 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391432 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391435 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391437 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391440 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391443 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391446 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391451 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391456 */   // GIR_Coverage, 6051,
     /* 391456 */   GIR_EraseRootFromParent_Done,
     /* 391457 */ // Label 7547: @391457
     /* 391457 */ GIM_Try, /*On fail goto*//*Label 7548*/ GIMT_Encode4(391521), // Rule ID 2662 //
     /* 391462 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391465 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391468 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391472 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391476 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391480 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391484 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391488 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391493 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391497 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391501 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391505 */   // MIs[2] Operand 1
     /* 391505 */   // No operand predicates
     /* 391505 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391507 */   // (splat_vector:{ *:[nxv8i16] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8i16] } ZPR:{ *:[nxv8i16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391507 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391510 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391512 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391516 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391519 */   GIR_RootConstrainSelectedInstOperands,
     /* 391520 */   // GIR_Coverage, 2662,
     /* 391520 */   GIR_EraseRootFromParent_Done,
     /* 391521 */ // Label 7548: @391521
     /* 391521 */ GIM_Try, /*On fail goto*//*Label 7549*/ GIMT_Encode4(391585), // Rule ID 8397 //
     /* 391526 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391529 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391532 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391536 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391540 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391544 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 391548 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391552 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391557 */   GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391561 */   GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391565 */   GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_h),
     /* 391569 */   // MIs[2] Operand 1
     /* 391569 */   // No operand predicates
     /* 391569 */   GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391571 */   // (splat_vector:{ *:[nxv8f16] } (vector_extract:{ *:[f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index))  =>  (DUP_ZZI_H:{ *:[nxv8f16] } ZPR:{ *:[nxv8f16] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_h>>:$index)
     /* 391571 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391574 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391576 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391580 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391583 */   GIR_RootConstrainSelectedInstOperands,
     /* 391584 */   // GIR_Coverage, 8397,
     /* 391584 */   GIR_EraseRootFromParent_Done,
     /* 391585 */ // Label 7549: @391585
     /* 391585 */ GIM_Try, /*On fail goto*//*Label 7550*/ GIMT_Encode4(391626), // Rule ID 8432 //
     /* 391590 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391593 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391600 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391604 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FCONSTANT),
     /* 391608 */   GIM_CheckAPFloatImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_APFloat_Predicate_fpimm16),
     /* 391612 */   // MIs[1] Operand 1
     /* 391612 */   // No operand predicates
     /* 391612 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 391614 */   // (splat_vector:{ *:[nxv8f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>><<X:fpimm16XForm>>:$imm8)  =>  (FDUP_ZI_H:{ *:[nxv8f16] } (fpimm16XForm:{ *:[f16] } (fpimm:{ *:[f16] })<<P:Predicate_fpimm16>>:$imm8))
     /* 391614 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FDUP_ZI_H),
     /* 391617 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391619 */   GIR_CustomRenderer, /*InsnID*/0, /*OldInsnID*/1, /*Renderer*/GIMT_Encode2(GICR_renderFPImm16), // imm8
     /* 391624 */   GIR_RootConstrainSelectedInstOperands,
     /* 391625 */   // GIR_Coverage, 8432,
     /* 391625 */   GIR_EraseRootFromParent_Done,
     /* 391626 */ // Label 7550: @391626
     /* 391626 */ GIM_Try, /*On fail goto*//*Label 7551*/ GIMT_Encode4(391652), // Rule ID 2389 //
     /* 391631 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391634 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391637 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391641 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391645 */   // (splat_vector:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_H:{ *:[nxv8i16] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391645 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_H),
     /* 391650 */   GIR_RootConstrainSelectedInstOperands,
     /* 391651 */   // GIR_Coverage, 2389,
     /* 391651 */   GIR_Done,
     /* 391652 */ // Label 7551: @391652
     /* 391652 */ GIM_Try, /*On fail goto*//*Label 7552*/ GIMT_Encode4(391735), // Rule ID 8410 //
     /* 391657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 391663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391671 */   // (splat_vector:{ *:[nxv8f16] } FPR16:{ *:[f16] }:$src)  =>  (DUP_ZZI_H:{ *:[nxv8f16] } (INSERT_SUBREG:{ *:[nxv16i8] } (IMPLICIT_DEF:{ *:[nxv16i8] }), FPR16:{ *:[f16] }:$src, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 391671 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_nxv16s8,
     /* 391674 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 391678 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391683 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 391685 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_nxv16s8,
     /* 391688 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 391692 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391697 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 391700 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // src
     /* 391704 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 391707 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391712 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391717 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 391722 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_H),
     /* 391725 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391727 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391730 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391733 */   GIR_RootConstrainSelectedInstOperands,
     /* 391734 */   // GIR_Coverage, 8410,
     /* 391734 */   GIR_EraseRootFromParent_Done,
     /* 391735 */ // Label 7552: @391735
     /* 391735 */ GIM_Reject,
     /* 391736 */ // Label 7509: @391736
     /* 391736 */ GIM_Try, /*On fail goto*//*Label 7553*/ GIMT_Encode4(391879),
     /* 391741 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391748 */   GIM_Try, /*On fail goto*//*Label 7554*/ GIMT_Encode4(391802), // Rule ID 6045 //
     /* 391753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 391756 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/1, 0,
     /* 391760 */     // (splat_vector:{ *:[nxv16i8] } 0:{ *:[i32] })  =>  (SUBREG_TO_REG:{ *:[nxv16i8] } 0:{ *:[i32] }, (MOVIv2d_ns:{ *:[f128] } 0:{ *:[i32] }), zsub:{ *:[i32] })
     /* 391760 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 391763 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::MOVIv2d_ns),
     /* 391767 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391772 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 391775 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391777 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 391780 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 391782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 391785 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391788 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/43,
     /* 391791 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391796 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 391801 */     // GIR_Coverage, 6045,
     /* 391801 */     GIR_EraseRootFromParent_Done,
     /* 391802 */   // Label 7554: @391802
     /* 391802 */   GIM_Try, /*On fail goto*//*Label 7555*/ GIMT_Encode4(391859), // Rule ID 2659 //
     /* 391807 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391810 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 391814 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 391818 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 391822 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 391826 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 391831 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 391835 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 391839 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_sve_elm_idx_extdup_b),
     /* 391843 */     // MIs[2] Operand 1
     /* 391843 */     // No operand predicates
     /* 391843 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 391845 */     // (splat_vector:{ *:[nxv16i8] } (vector_extract:{ *:[i32] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index))  =>  (DUP_ZZI_B:{ *:[nxv16i8] } ZPR:{ *:[nxv16i8] }:$vec, (imm:{ *:[i64] })<<P:Predicate_sve_elm_idx_extdup_b>>:$index)
     /* 391845 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZZI_B),
     /* 391848 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zd]
     /* 391850 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // vec
     /* 391854 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // index
     /* 391857 */     GIR_RootConstrainSelectedInstOperands,
     /* 391858 */     // GIR_Coverage, 2659,
     /* 391858 */     GIR_EraseRootFromParent_Done,
     /* 391859 */   // Label 7555: @391859
     /* 391859 */   GIM_Try, /*On fail goto*//*Label 7556*/ GIMT_Encode4(391878), // Rule ID 2388 //
     /* 391864 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 391867 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32spRegClassID),
     /* 391871 */     // (splat_vector:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)  =>  (DUP_ZR_B:{ *:[nxv16i8] } GPR32sp:{ *:[i32] }:$Rn)
     /* 391871 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUP_ZR_B),
     /* 391876 */     GIR_RootConstrainSelectedInstOperands,
     /* 391877 */     // GIR_Coverage, 2388,
     /* 391877 */     GIR_Done,
     /* 391878 */   // Label 7556: @391878
     /* 391878 */   GIM_Reject,
     /* 391879 */ // Label 7553: @391879
     /* 391879 */ GIM_Reject,
     /* 391880 */ // Label 7510: @391880
     /* 391880 */ GIM_Reject,
     /* 391881 */ // Label 93: @391881
     /* 391881 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(4), /*)*//*default:*//*Label 7559*/ GIMT_Encode4(392032),
     /* 391892 */ /*GILLT_s32*//*Label 7557*/ GIMT_Encode4(391900),
     /* 391896 */ /*GILLT_s64*//*Label 7558*/ GIMT_Encode4(391966),
     /* 391900 */ // Label 7557: @391900
     /* 391900 */ GIM_Try, /*On fail goto*//*Label 7560*/ GIMT_Encode4(391965),
     /* 391905 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 391908 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391912 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 391916 */   GIM_Try, /*On fail goto*//*Label 7561*/ GIMT_Encode4(391931), // Rule ID 2321 //
     /* 391921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391924 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CTZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 391924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZWr),
     /* 391929 */     GIR_RootConstrainSelectedInstOperands,
     /* 391930 */     // GIR_Coverage, 2321,
     /* 391930 */     GIR_Done,
     /* 391931 */   // Label 7561: @391931
     /* 391931 */   GIM_Try, /*On fail goto*//*Label 7562*/ GIMT_Encode4(391964), // Rule ID 4004 //
     /* 391936 */     // (cttz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn))
     /* 391936 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 391939 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 391943 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 391948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 391952 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 391954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 391957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 391959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 391962 */     GIR_RootConstrainSelectedInstOperands,
     /* 391963 */     // GIR_Coverage, 4004,
     /* 391963 */     GIR_EraseRootFromParent_Done,
     /* 391964 */   // Label 7562: @391964
     /* 391964 */   GIM_Reject,
     /* 391965 */ // Label 7560: @391965
     /* 391965 */ GIM_Reject,
     /* 391966 */ // Label 7558: @391966
     /* 391966 */ GIM_Try, /*On fail goto*//*Label 7563*/ GIMT_Encode4(392031),
     /* 391971 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 391974 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391978 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 391982 */   GIM_Try, /*On fail goto*//*Label 7564*/ GIMT_Encode4(391997), // Rule ID 2322 //
     /* 391987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 391990 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CTZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 391990 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CTZXr),
     /* 391995 */     GIR_RootConstrainSelectedInstOperands,
     /* 391996 */     // GIR_Coverage, 2322,
     /* 391996 */     GIR_Done,
     /* 391997 */   // Label 7564: @391997
     /* 391997 */   GIM_Try, /*On fail goto*//*Label 7565*/ GIMT_Encode4(392030), // Rule ID 4005 //
     /* 392002 */     // (cttz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn))
     /* 392002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 392005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 392009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 392014 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 392018 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 392020 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 392023 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392025 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 392028 */     GIR_RootConstrainSelectedInstOperands,
     /* 392029 */     // GIR_Coverage, 4005,
     /* 392029 */     GIR_EraseRootFromParent_Done,
     /* 392030 */   // Label 7565: @392030
     /* 392030 */   GIM_Reject,
     /* 392031 */ // Label 7563: @392031
     /* 392031 */ GIM_Reject,
     /* 392032 */ // Label 7559: @392032
     /* 392032 */ GIM_Reject,
     /* 392033 */ // Label 94: @392033
     /* 392033 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7574*/ GIMT_Encode4(392706),
     /* 392044 */ /*GILLT_s32*//*Label 7566*/ GIMT_Encode4(392084),
     /* 392048 */ /*GILLT_s64*//*Label 7567*/ GIMT_Encode4(392314), GIMT_Encode4(0),
     /* 392056 */ /*GILLT_v2s32*//*Label 7568*/ GIMT_Encode4(392544), GIMT_Encode4(0),
     /* 392064 */ /*GILLT_v4s16*//*Label 7569*/ GIMT_Encode4(392571),
     /* 392068 */ /*GILLT_v4s32*//*Label 7570*/ GIMT_Encode4(392598),
     /* 392072 */ /*GILLT_v8s8*//*Label 7571*/ GIMT_Encode4(392625),
     /* 392076 */ /*GILLT_v8s16*//*Label 7572*/ GIMT_Encode4(392652),
     /* 392080 */ /*GILLT_v16s8*//*Label 7573*/ GIMT_Encode4(392679),
     /* 392084 */ // Label 7566: @392084
     /* 392084 */ GIM_Try, /*On fail goto*//*Label 7575*/ GIMT_Encode4(392313),
     /* 392089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392096 */   GIM_Try, /*On fail goto*//*Label 7576*/ GIMT_Encode4(392196), // Rule ID 4006 //
     /* 392101 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392105 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392109 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392113 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 392117 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392121 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392125 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 392129 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392133 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392137 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392141 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 392145 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 392149 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392153 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s32,
     /* 392157 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392161 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392166 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 392170 */     // MIs[3] Rn
     /* 392170 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 392175 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392179 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392183 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392185 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] }), GPR32:{ *:[i32] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392185 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 392188 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 392194 */     GIR_RootConstrainSelectedInstOperands,
     /* 392195 */     // GIR_Coverage, 4006,
     /* 392195 */     GIR_EraseRootFromParent_Done,
     /* 392196 */   // Label 7576: @392196
     /* 392196 */   GIM_Try, /*On fail goto*//*Label 7577*/ GIMT_Encode4(392296), // Rule ID 13881 //
     /* 392201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392209 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392213 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s32,
     /* 392217 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392221 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392225 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 392229 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392233 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392237 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392241 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 392245 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s32,
     /* 392249 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392254 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 392258 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392262 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392266 */     // MIs[4] Rn
     /* 392266 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 392271 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 31,
     /* 392275 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392279 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392283 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392285 */     // (ctlz:{ *:[i32] } (or:{ *:[i32] } (shl:{ *:[i32] } (xor:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, (sra:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 31:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i32] }))  =>  (CLSWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392285 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSWr),
     /* 392288 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392294 */     GIR_RootConstrainSelectedInstOperands,
     /* 392295 */     // GIR_Coverage, 13881,
     /* 392295 */     GIR_EraseRootFromParent_Done,
     /* 392296 */   // Label 7577: @392296
     /* 392296 */   GIM_Try, /*On fail goto*//*Label 7578*/ GIMT_Encode4(392312), // Rule ID 180 //
     /* 392301 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392305 */     // (ctlz:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CLZWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392305 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZWr),
     /* 392310 */     GIR_RootConstrainSelectedInstOperands,
     /* 392311 */     // GIR_Coverage, 180,
     /* 392311 */     GIR_Done,
     /* 392312 */   // Label 7578: @392312
     /* 392312 */   GIM_Reject,
     /* 392313 */ // Label 7575: @392313
     /* 392313 */ GIM_Reject,
     /* 392314 */ // Label 7567: @392314
     /* 392314 */ GIM_Try, /*On fail goto*//*Label 7579*/ GIMT_Encode4(392543),
     /* 392319 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392322 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392326 */   GIM_Try, /*On fail goto*//*Label 7580*/ GIMT_Encode4(392426), // Rule ID 4007 //
     /* 392331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392347 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392351 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392355 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392359 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392363 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392367 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392371 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 392375 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 392379 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392383 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_s64,
     /* 392387 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392391 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392396 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 392400 */     // MIs[3] Rn
     /* 392400 */     GIM_CheckIsSameOperand, /*MI*/3, /*OpIdx*/2, /*OtherMI*/4, /*OtherOpIdx*/1,
     /* 392405 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392409 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392413 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392415 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] }), GPR64:{ *:[i64] }:$Rn), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392415 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 392418 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392420 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/4, /*OpIdx*/1, // Rn
     /* 392424 */     GIR_RootConstrainSelectedInstOperands,
     /* 392425 */     // GIR_Coverage, 4007,
     /* 392425 */     GIR_EraseRootFromParent_Done,
     /* 392426 */   // Label 7580: @392426
     /* 392426 */   GIM_Try, /*On fail goto*//*Label 7581*/ GIMT_Encode4(392526), // Rule ID 13882 //
     /* 392431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_OR),
     /* 392439 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 392443 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392447 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 392451 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_SHL),
     /* 392455 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 392459 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 392463 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 392467 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 392471 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 392475 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 392479 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392484 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 392488 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_ASHR),
     /* 392492 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 392496 */     // MIs[4] Rn
     /* 392496 */     GIM_CheckIsSameOperand, /*MI*/4, /*OpIdx*/1, /*OtherMI*/3, /*OtherOpIdx*/1,
     /* 392501 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 63,
     /* 392505 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 392509 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 392513 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 392515 */     // (ctlz:{ *:[i64] } (or:{ *:[i64] } (shl:{ *:[i64] } (xor:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, (sra:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 63:{ *:[i64] })), 1:{ *:[i64] }), 1:{ *:[i64] }))  =>  (CLSXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392515 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CLSXr),
     /* 392518 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392520 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 392524 */     GIR_RootConstrainSelectedInstOperands,
     /* 392525 */     // GIR_Coverage, 13882,
     /* 392525 */     GIR_EraseRootFromParent_Done,
     /* 392526 */   // Label 7581: @392526
     /* 392526 */   GIM_Try, /*On fail goto*//*Label 7582*/ GIMT_Encode4(392542), // Rule ID 181 //
     /* 392531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392535 */     // (ctlz:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CLZXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392535 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZXr),
     /* 392540 */     GIR_RootConstrainSelectedInstOperands,
     /* 392541 */     // GIR_Coverage, 181,
     /* 392541 */     GIR_Done,
     /* 392542 */   // Label 7582: @392542
     /* 392542 */   GIM_Reject,
     /* 392543 */ // Label 7579: @392543
     /* 392543 */ GIM_Reject,
     /* 392544 */ // Label 7568: @392544
     /* 392544 */ GIM_Try, /*On fail goto*//*Label 7583*/ GIMT_Encode4(392570), // Rule ID 720 //
     /* 392549 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392552 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 392555 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392559 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392563 */   // (ctlz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (CLZv2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 392563 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv2i32),
     /* 392568 */   GIR_RootConstrainSelectedInstOperands,
     /* 392569 */   // GIR_Coverage, 720,
     /* 392569 */   GIR_Done,
     /* 392570 */ // Label 7583: @392570
     /* 392570 */ GIM_Reject,
     /* 392571 */ // Label 7569: @392571
     /* 392571 */ GIM_Try, /*On fail goto*//*Label 7584*/ GIMT_Encode4(392597), // Rule ID 718 //
     /* 392576 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392579 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 392582 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392586 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392590 */   // (ctlz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (CLZv4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 392590 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i16),
     /* 392595 */   GIR_RootConstrainSelectedInstOperands,
     /* 392596 */   // GIR_Coverage, 718,
     /* 392596 */   GIR_Done,
     /* 392597 */ // Label 7584: @392597
     /* 392597 */ GIM_Reject,
     /* 392598 */ // Label 7570: @392598
     /* 392598 */ GIM_Try, /*On fail goto*//*Label 7585*/ GIMT_Encode4(392624), // Rule ID 721 //
     /* 392603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 392609 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392613 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392617 */   // (ctlz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (CLZv4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 392617 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv4i32),
     /* 392622 */   GIR_RootConstrainSelectedInstOperands,
     /* 392623 */   // GIR_Coverage, 721,
     /* 392623 */   GIR_Done,
     /* 392624 */ // Label 7585: @392624
     /* 392624 */ GIM_Reject,
     /* 392625 */ // Label 7571: @392625
     /* 392625 */ GIM_Try, /*On fail goto*//*Label 7586*/ GIMT_Encode4(392651), // Rule ID 716 //
     /* 392630 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392633 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392636 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392640 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392644 */   // (ctlz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CLZv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392644 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i8),
     /* 392649 */   GIR_RootConstrainSelectedInstOperands,
     /* 392650 */   // GIR_Coverage, 716,
     /* 392650 */   GIR_Done,
     /* 392651 */ // Label 7586: @392651
     /* 392651 */ GIM_Reject,
     /* 392652 */ // Label 7572: @392652
     /* 392652 */ GIM_Try, /*On fail goto*//*Label 7587*/ GIMT_Encode4(392678), // Rule ID 719 //
     /* 392657 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392660 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 392663 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392667 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392671 */   // (ctlz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (CLZv8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 392671 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv8i16),
     /* 392676 */   GIR_RootConstrainSelectedInstOperands,
     /* 392677 */   // GIR_Coverage, 719,
     /* 392677 */   GIR_Done,
     /* 392678 */ // Label 7587: @392678
     /* 392678 */ GIM_Reject,
     /* 392679 */ // Label 7573: @392679
     /* 392679 */ GIM_Try, /*On fail goto*//*Label 7588*/ GIMT_Encode4(392705), // Rule ID 717 //
     /* 392684 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392687 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392690 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392694 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392698 */   // (ctlz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CLZv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392698 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CLZv16i8),
     /* 392703 */   GIR_RootConstrainSelectedInstOperands,
     /* 392704 */   // GIR_Coverage, 717,
     /* 392704 */   GIR_Done,
     /* 392705 */ // Label 7588: @392705
     /* 392705 */ GIM_Reject,
     /* 392706 */ // Label 7574: @392706
     /* 392706 */ GIM_Reject,
     /* 392707 */ // Label 95: @392707
     /* 392707 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7593*/ GIMT_Encode4(392866),
     /* 392718 */ /*GILLT_s32*//*Label 7589*/ GIMT_Encode4(392758),
     /* 392722 */ /*GILLT_s64*//*Label 7590*/ GIMT_Encode4(392785), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 392746 */ /*GILLT_v8s8*//*Label 7591*/ GIMT_Encode4(392812), GIMT_Encode4(0),
     /* 392754 */ /*GILLT_v16s8*//*Label 7592*/ GIMT_Encode4(392839),
     /* 392758 */ // Label 7589: @392758
     /* 392758 */ GIM_Try, /*On fail goto*//*Label 7594*/ GIMT_Encode4(392784), // Rule ID 2319 //
     /* 392763 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392766 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392769 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392773 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392777 */   // (ctpop:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (CNTWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392777 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTWr),
     /* 392782 */   GIR_RootConstrainSelectedInstOperands,
     /* 392783 */   // GIR_Coverage, 2319,
     /* 392783 */   GIR_Done,
     /* 392784 */ // Label 7594: @392784
     /* 392784 */ GIM_Reject,
     /* 392785 */ // Label 7590: @392785
     /* 392785 */ GIM_Try, /*On fail goto*//*Label 7595*/ GIMT_Encode4(392811), // Rule ID 2320 //
     /* 392790 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasCSSC),
     /* 392793 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392796 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392800 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392804 */   // (ctpop:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (CNTXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 392804 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTXr),
     /* 392809 */   GIR_RootConstrainSelectedInstOperands,
     /* 392810 */   // GIR_Coverage, 2320,
     /* 392810 */   GIR_Done,
     /* 392811 */ // Label 7595: @392811
     /* 392811 */ GIM_Reject,
     /* 392812 */ // Label 7591: @392812
     /* 392812 */ GIM_Try, /*On fail goto*//*Label 7596*/ GIMT_Encode4(392838), // Rule ID 764 //
     /* 392817 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 392823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 392831 */   // (ctpop:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (CNTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 392831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv8i8),
     /* 392836 */   GIR_RootConstrainSelectedInstOperands,
     /* 392837 */   // GIR_Coverage, 764,
     /* 392837 */   GIR_Done,
     /* 392838 */ // Label 7596: @392838
     /* 392838 */ GIM_Reject,
     /* 392839 */ // Label 7592: @392839
     /* 392839 */ GIM_Try, /*On fail goto*//*Label 7597*/ GIMT_Encode4(392865), // Rule ID 765 //
     /* 392844 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 392847 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 392850 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392854 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 392858 */   // (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (CNTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 392858 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::CNTv16i8),
     /* 392863 */   GIR_RootConstrainSelectedInstOperands,
     /* 392864 */   // GIR_Coverage, 765,
     /* 392864 */   GIR_Done,
     /* 392865 */ // Label 7597: @392865
     /* 392865 */ GIM_Reject,
     /* 392866 */ // Label 7593: @392866
     /* 392866 */ GIM_Reject,
     /* 392867 */ // Label 96: @392867
     /* 392867 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 7605*/ GIMT_Encode4(393180),
     /* 392878 */ /*GILLT_s32*//*Label 7598*/ GIMT_Encode4(392914),
     /* 392882 */ /*GILLT_s64*//*Label 7599*/ GIMT_Encode4(392987), GIMT_Encode4(0),
     /* 392890 */ /*GILLT_v2s32*//*Label 7600*/ GIMT_Encode4(393060),
     /* 392894 */ /*GILLT_v2s64*//*Label 7601*/ GIMT_Encode4(393084),
     /* 392898 */ /*GILLT_v4s16*//*Label 7602*/ GIMT_Encode4(393108),
     /* 392902 */ /*GILLT_v4s32*//*Label 7603*/ GIMT_Encode4(393132), GIMT_Encode4(0),
     /* 392910 */ /*GILLT_v8s16*//*Label 7604*/ GIMT_Encode4(393156),
     /* 392914 */ // Label 7598: @392914
     /* 392914 */ GIM_Try, /*On fail goto*//*Label 7606*/ GIMT_Encode4(392986),
     /* 392919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 392922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392926 */   GIM_Try, /*On fail goto*//*Label 7607*/ GIMT_Encode4(392969), // Rule ID 4010 //
     /* 392931 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 392935 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 392939 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 392943 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 392947 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392952 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 16,
     /* 392956 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 392958 */     // (bswap:{ *:[i32] } (rotr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn, 16:{ *:[i64] }))  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392958 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 392961 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 392963 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 392967 */     GIR_RootConstrainSelectedInstOperands,
     /* 392968 */     // GIR_Coverage, 4010,
     /* 392968 */     GIR_EraseRootFromParent_Done,
     /* 392969 */   // Label 7607: @392969
     /* 392969 */   GIM_Try, /*On fail goto*//*Label 7608*/ GIMT_Encode4(392985), // Rule ID 185 //
     /* 392974 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 392978 */     // (bswap:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REVWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 392978 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVWr),
     /* 392983 */     GIR_RootConstrainSelectedInstOperands,
     /* 392984 */     // GIR_Coverage, 185,
     /* 392984 */     GIR_Done,
     /* 392985 */   // Label 7608: @392985
     /* 392985 */   GIM_Reject,
     /* 392986 */ // Label 7606: @392986
     /* 392986 */ GIM_Reject,
     /* 392987 */ // Label 7599: @392987
     /* 392987 */ GIM_Try, /*On fail goto*//*Label 7609*/ GIMT_Encode4(393059),
     /* 392992 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 392995 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 392999 */   GIM_Try, /*On fail goto*//*Label 7610*/ GIMT_Encode4(393042), // Rule ID 4011 //
     /* 393004 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 393008 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_ROTR),
     /* 393012 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 393016 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 393020 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393025 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 32,
     /* 393029 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 393031 */     // (bswap:{ *:[i64] } (rotr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn, 32:{ *:[i64] }))  =>  (REV32Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393031 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::REV32Xr),
     /* 393034 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 393036 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 393040 */     GIR_RootConstrainSelectedInstOperands,
     /* 393041 */     // GIR_Coverage, 4011,
     /* 393041 */     GIR_EraseRootFromParent_Done,
     /* 393042 */   // Label 7610: @393042
     /* 393042 */   GIM_Try, /*On fail goto*//*Label 7611*/ GIMT_Encode4(393058), // Rule ID 186 //
     /* 393047 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393051 */     // (bswap:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REVXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393051 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REVXr),
     /* 393056 */     GIR_RootConstrainSelectedInstOperands,
     /* 393057 */     // GIR_Coverage, 186,
     /* 393057 */     GIR_Done,
     /* 393058 */   // Label 7611: @393058
     /* 393058 */   GIM_Reject,
     /* 393059 */ // Label 7609: @393059
     /* 393059 */ GIM_Reject,
     /* 393060 */ // Label 7600: @393060
     /* 393060 */ GIM_Try, /*On fail goto*//*Label 7612*/ GIMT_Encode4(393083), // Rule ID 5023 //
     /* 393065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393068 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393072 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393076 */   // (bswap:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV32v8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 393076 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 393081 */   GIR_RootConstrainSelectedInstOperands,
     /* 393082 */   // GIR_Coverage, 5023,
     /* 393082 */   GIR_Done,
     /* 393083 */ // Label 7612: @393083
     /* 393083 */ GIM_Reject,
     /* 393084 */ // Label 7601: @393084
     /* 393084 */ GIM_Try, /*On fail goto*//*Label 7613*/ GIMT_Encode4(393107), // Rule ID 5025 //
     /* 393089 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393092 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393096 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393100 */   // (bswap:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)  =>  (REV64v16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 393100 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 393105 */   GIR_RootConstrainSelectedInstOperands,
     /* 393106 */   // GIR_Coverage, 5025,
     /* 393106 */   GIR_Done,
     /* 393107 */ // Label 7613: @393107
     /* 393107 */ GIM_Reject,
     /* 393108 */ // Label 7602: @393108
     /* 393108 */ GIM_Try, /*On fail goto*//*Label 7614*/ GIMT_Encode4(393131), // Rule ID 5021 //
     /* 393113 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393116 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393120 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393124 */   // (bswap:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV16v8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 393124 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 393129 */   GIR_RootConstrainSelectedInstOperands,
     /* 393130 */   // GIR_Coverage, 5021,
     /* 393130 */   GIR_Done,
     /* 393131 */ // Label 7614: @393131
     /* 393131 */ GIM_Reject,
     /* 393132 */ // Label 7603: @393132
     /* 393132 */ GIM_Try, /*On fail goto*//*Label 7615*/ GIMT_Encode4(393155), // Rule ID 5024 //
     /* 393137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393144 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393148 */   // (bswap:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV32v16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 393148 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 393153 */   GIR_RootConstrainSelectedInstOperands,
     /* 393154 */   // GIR_Coverage, 5024,
     /* 393154 */   GIR_Done,
     /* 393155 */ // Label 7615: @393155
     /* 393155 */ GIM_Reject,
     /* 393156 */ // Label 7604: @393156
     /* 393156 */ GIM_Try, /*On fail goto*//*Label 7616*/ GIMT_Encode4(393179), // Rule ID 5022 //
     /* 393161 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393164 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393168 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393172 */   // (bswap:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV16v16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 393172 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 393177 */   GIR_RootConstrainSelectedInstOperands,
     /* 393178 */   // GIR_Coverage, 5022,
     /* 393178 */   GIR_Done,
     /* 393179 */ // Label 7616: @393179
     /* 393179 */ GIM_Reject,
     /* 393180 */ // Label 7605: @393180
     /* 393180 */ GIM_Reject,
     /* 393181 */ // Label 97: @393181
     /* 393181 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 7621*/ GIMT_Encode4(393334),
     /* 393192 */ /*GILLT_s32*//*Label 7617*/ GIMT_Encode4(393232),
     /* 393196 */ /*GILLT_s64*//*Label 7618*/ GIMT_Encode4(393256), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 393220 */ /*GILLT_v8s8*//*Label 7619*/ GIMT_Encode4(393280), GIMT_Encode4(0),
     /* 393228 */ /*GILLT_v16s8*//*Label 7620*/ GIMT_Encode4(393307),
     /* 393232 */ // Label 7617: @393232
     /* 393232 */ GIM_Try, /*On fail goto*//*Label 7622*/ GIMT_Encode4(393255), // Rule ID 182 //
     /* 393237 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393240 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393244 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 393248 */   // (bitreverse:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (RBITWr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 393248 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITWr),
     /* 393253 */   GIR_RootConstrainSelectedInstOperands,
     /* 393254 */   // GIR_Coverage, 182,
     /* 393254 */   GIR_Done,
     /* 393255 */ // Label 7622: @393255
     /* 393255 */ GIM_Reject,
     /* 393256 */ // Label 7618: @393256
     /* 393256 */ GIM_Try, /*On fail goto*//*Label 7623*/ GIMT_Encode4(393279), // Rule ID 183 //
     /* 393261 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393264 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393268 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 393272 */   // (bitreverse:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (RBITXr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 393272 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITXr),
     /* 393277 */   GIR_RootConstrainSelectedInstOperands,
     /* 393278 */   // GIR_Coverage, 183,
     /* 393278 */   GIR_Done,
     /* 393279 */ // Label 7623: @393279
     /* 393279 */ GIM_Reject,
     /* 393280 */ // Label 7619: @393280
     /* 393280 */ GIM_Try, /*On fail goto*//*Label 7624*/ GIMT_Encode4(393306), // Rule ID 974 //
     /* 393285 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393288 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 393291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393295 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393299 */   // (bitreverse:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (RBITv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 393299 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv8i8),
     /* 393304 */   GIR_RootConstrainSelectedInstOperands,
     /* 393305 */   // GIR_Coverage, 974,
     /* 393305 */   GIR_Done,
     /* 393306 */ // Label 7624: @393306
     /* 393306 */ GIM_Reject,
     /* 393307 */ // Label 7620: @393307
     /* 393307 */ GIM_Try, /*On fail goto*//*Label 7625*/ GIMT_Encode4(393333), // Rule ID 975 //
     /* 393312 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393315 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 393318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393326 */   // (bitreverse:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (RBITv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 393326 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::RBITv16i8),
     /* 393331 */   GIR_RootConstrainSelectedInstOperands,
     /* 393332 */   // GIR_Coverage, 975,
     /* 393332 */   GIR_Done,
     /* 393333 */ // Label 7625: @393333
     /* 393333 */ GIM_Reject,
     /* 393334 */ // Label 7621: @393334
     /* 393334 */ GIM_Reject,
     /* 393335 */ // Label 98: @393335
     /* 393335 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7634*/ GIMT_Encode4(393825),
     /* 393346 */ /*GILLT_s16*//*Label 7626*/ GIMT_Encode4(393386),
     /* 393350 */ /*GILLT_s32*//*Label 7627*/ GIMT_Encode4(393417),
     /* 393354 */ /*GILLT_s64*//*Label 7628*/ GIMT_Encode4(393448), GIMT_Encode4(0),
     /* 393362 */ /*GILLT_v2s32*//*Label 7629*/ GIMT_Encode4(393479),
     /* 393366 */ /*GILLT_v2s64*//*Label 7630*/ GIMT_Encode4(393510),
     /* 393370 */ /*GILLT_v4s16*//*Label 7631*/ GIMT_Encode4(393541),
     /* 393374 */ /*GILLT_v4s32*//*Label 7632*/ GIMT_Encode4(393572), GIMT_Encode4(0),
     /* 393382 */ /*GILLT_v8s16*//*Label 7633*/ GIMT_Encode4(393603),
     /* 393386 */ // Label 7626: @393386
     /* 393386 */ GIM_Try, /*On fail goto*//*Label 7635*/ GIMT_Encode4(393416), // Rule ID 552 //
     /* 393391 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393394 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393397 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393401 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393405 */   // (fceil:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTPHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393405 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPHr),
     /* 393410 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393414 */   GIR_RootConstrainSelectedInstOperands,
     /* 393415 */   // GIR_Coverage, 552,
     /* 393415 */   GIR_Done,
     /* 393416 */ // Label 7635: @393416
     /* 393416 */ GIM_Reject,
     /* 393417 */ // Label 7627: @393417
     /* 393417 */ GIM_Try, /*On fail goto*//*Label 7636*/ GIMT_Encode4(393447), // Rule ID 554 //
     /* 393422 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393432 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393436 */   // (fceil:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTPSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393436 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPSr),
     /* 393441 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393445 */   GIR_RootConstrainSelectedInstOperands,
     /* 393446 */   // GIR_Coverage, 554,
     /* 393446 */   GIR_Done,
     /* 393447 */ // Label 7636: @393447
     /* 393447 */ GIM_Reject,
     /* 393448 */ // Label 7628: @393448
     /* 393448 */ GIM_Try, /*On fail goto*//*Label 7637*/ GIMT_Encode4(393478), // Rule ID 556 //
     /* 393453 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393467 */   // (fceil:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTPDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPDr),
     /* 393472 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393476 */   GIR_RootConstrainSelectedInstOperands,
     /* 393477 */   // GIR_Coverage, 556,
     /* 393477 */   GIR_Done,
     /* 393478 */ // Label 7637: @393478
     /* 393478 */ GIM_Reject,
     /* 393479 */ // Label 7629: @393479
     /* 393479 */ GIM_Try, /*On fail goto*//*Label 7638*/ GIMT_Encode4(393509), // Rule ID 913 //
     /* 393484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393498 */   // (fceil:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTPv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f32),
     /* 393503 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393507 */   GIR_RootConstrainSelectedInstOperands,
     /* 393508 */   // GIR_Coverage, 913,
     /* 393508 */   GIR_Done,
     /* 393509 */ // Label 7638: @393509
     /* 393509 */ GIM_Reject,
     /* 393510 */ // Label 7630: @393510
     /* 393510 */ GIM_Try, /*On fail goto*//*Label 7639*/ GIMT_Encode4(393540), // Rule ID 917 //
     /* 393515 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393518 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 393521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393529 */   // (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTPv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 393529 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv2f64),
     /* 393534 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393538 */   GIR_RootConstrainSelectedInstOperands,
     /* 393539 */   // GIR_Coverage, 917,
     /* 393539 */   GIR_Done,
     /* 393540 */ // Label 7639: @393540
     /* 393540 */ GIM_Reject,
     /* 393541 */ // Label 7631: @393541
     /* 393541 */ GIM_Try, /*On fail goto*//*Label 7640*/ GIMT_Encode4(393571), // Rule ID 909 //
     /* 393546 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393549 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 393552 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393556 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393560 */   // (fceil:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTPv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 393560 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f16),
     /* 393565 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393569 */   GIR_RootConstrainSelectedInstOperands,
     /* 393570 */   // GIR_Coverage, 909,
     /* 393570 */   GIR_Done,
     /* 393571 */ // Label 7640: @393571
     /* 393571 */ GIM_Reject,
     /* 393572 */ // Label 7632: @393572
     /* 393572 */ GIM_Try, /*On fail goto*//*Label 7641*/ GIMT_Encode4(393602), // Rule ID 915 //
     /* 393577 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393580 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 393583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393587 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393591 */   // (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTPv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 393591 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393596 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393600 */   GIR_RootConstrainSelectedInstOperands,
     /* 393601 */   // GIR_Coverage, 915,
     /* 393601 */   GIR_Done,
     /* 393602 */ // Label 7641: @393602
     /* 393602 */ GIM_Reject,
     /* 393603 */ // Label 7633: @393603
     /* 393603 */ GIM_Try, /*On fail goto*//*Label 7642*/ GIMT_Encode4(393824),
     /* 393608 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 393611 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393615 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393619 */   GIM_Try, /*On fail goto*//*Label 7643*/ GIMT_Encode4(393638), // Rule ID 911 //
     /* 393624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 393627 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTPv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 393627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv8f16),
     /* 393632 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393636 */     GIR_RootConstrainSelectedInstOperands,
     /* 393637 */     // GIR_Coverage, 911,
     /* 393637 */     GIR_Done,
     /* 393638 */   // Label 7643: @393638
     /* 393638 */   GIM_Try, /*On fail goto*//*Label 7644*/ GIMT_Encode4(393823), // Rule ID 7028 //
     /* 393643 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 393646 */     // (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTPv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTPv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 393646 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 393649 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 393653 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393658 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 393662 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 393664 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 393667 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393671 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393676 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 393679 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 393681 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 393684 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 393688 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393693 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 393699 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393704 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393709 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 393712 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 393716 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393721 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 393724 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 393726 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 393729 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTPv4f32),
     /* 393733 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393738 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 393741 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 393743 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 393746 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 393750 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393755 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 393758 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 393760 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 393763 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 393767 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393772 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 393774 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 393777 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 393781 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 393786 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 393789 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 393792 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 393795 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393800 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 393805 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393810 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 393813 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 393815 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 393818 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 393821 */     GIR_RootConstrainSelectedInstOperands,
     /* 393822 */     // GIR_Coverage, 7028,
     /* 393822 */     GIR_EraseRootFromParent_Done,
     /* 393823 */   // Label 7644: @393823
     /* 393823 */   GIM_Reject,
     /* 393824 */ // Label 7642: @393824
     /* 393824 */ GIM_Reject,
     /* 393825 */ // Label 7634: @393825
     /* 393825 */ GIM_Reject,
     /* 393826 */ // Label 99: @393826
     /* 393826 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7653*/ GIMT_Encode4(394125),
     /* 393837 */ /*GILLT_s16*//*Label 7645*/ GIMT_Encode4(393877),
     /* 393841 */ /*GILLT_s32*//*Label 7646*/ GIMT_Encode4(393908),
     /* 393845 */ /*GILLT_s64*//*Label 7647*/ GIMT_Encode4(393939), GIMT_Encode4(0),
     /* 393853 */ /*GILLT_v2s32*//*Label 7648*/ GIMT_Encode4(393970),
     /* 393857 */ /*GILLT_v2s64*//*Label 7649*/ GIMT_Encode4(394001),
     /* 393861 */ /*GILLT_v4s16*//*Label 7650*/ GIMT_Encode4(394032),
     /* 393865 */ /*GILLT_v4s32*//*Label 7651*/ GIMT_Encode4(394063), GIMT_Encode4(0),
     /* 393873 */ /*GILLT_v8s16*//*Label 7652*/ GIMT_Encode4(394094),
     /* 393877 */ // Label 7645: @393877
     /* 393877 */ GIM_Try, /*On fail goto*//*Label 7654*/ GIMT_Encode4(393907), // Rule ID 570 //
     /* 393882 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 393885 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 393888 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393892 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 393896 */   // (fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 393896 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 393901 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393905 */   GIR_RootConstrainSelectedInstOperands,
     /* 393906 */   // GIR_Coverage, 570,
     /* 393906 */   GIR_Done,
     /* 393907 */ // Label 7654: @393907
     /* 393907 */ GIM_Reject,
     /* 393908 */ // Label 7646: @393908
     /* 393908 */ GIM_Try, /*On fail goto*//*Label 7655*/ GIMT_Encode4(393938), // Rule ID 572 //
     /* 393913 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393916 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 393919 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393923 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 393927 */   // (fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 393927 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 393932 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393936 */   GIR_RootConstrainSelectedInstOperands,
     /* 393937 */   // GIR_Coverage, 572,
     /* 393937 */   GIR_Done,
     /* 393938 */ // Label 7655: @393938
     /* 393938 */ GIM_Reject,
     /* 393939 */ // Label 7647: @393939
     /* 393939 */ GIM_Try, /*On fail goto*//*Label 7656*/ GIMT_Encode4(393969), // Rule ID 574 //
     /* 393944 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 393947 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 393950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393958 */   // (fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 393958 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 393963 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393967 */   GIR_RootConstrainSelectedInstOperands,
     /* 393968 */   // GIR_Coverage, 574,
     /* 393968 */   GIR_Done,
     /* 393969 */ // Label 7656: @393969
     /* 393969 */ GIM_Reject,
     /* 393970 */ // Label 7648: @393970
     /* 393970 */ GIM_Try, /*On fail goto*//*Label 7657*/ GIMT_Encode4(394000), // Rule ID 960 //
     /* 393975 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 393978 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 393981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 393989 */   // (fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 393989 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 393994 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 393998 */   GIR_RootConstrainSelectedInstOperands,
     /* 393999 */   // GIR_Coverage, 960,
     /* 393999 */   GIR_Done,
     /* 394000 */ // Label 7657: @394000
     /* 394000 */ GIM_Reject,
     /* 394001 */ // Label 7649: @394001
     /* 394001 */ GIM_Try, /*On fail goto*//*Label 7658*/ GIMT_Encode4(394031), // Rule ID 964 //
     /* 394006 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394009 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394012 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394016 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394020 */   // (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394020 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 394025 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394029 */   GIR_RootConstrainSelectedInstOperands,
     /* 394030 */   // GIR_Coverage, 964,
     /* 394030 */   GIR_Done,
     /* 394031 */ // Label 7658: @394031
     /* 394031 */ GIM_Reject,
     /* 394032 */ // Label 7650: @394032
     /* 394032 */ GIM_Try, /*On fail goto*//*Label 7659*/ GIMT_Encode4(394062), // Rule ID 956 //
     /* 394037 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394040 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394043 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394047 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394051 */   // (fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 394056 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394060 */   GIR_RootConstrainSelectedInstOperands,
     /* 394061 */   // GIR_Coverage, 956,
     /* 394061 */   GIR_Done,
     /* 394062 */ // Label 7659: @394062
     /* 394062 */ GIM_Reject,
     /* 394063 */ // Label 7651: @394063
     /* 394063 */ GIM_Try, /*On fail goto*//*Label 7660*/ GIMT_Encode4(394093), // Rule ID 962 //
     /* 394068 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394071 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394074 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394078 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394082 */   // (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394082 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 394087 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394091 */   GIR_RootConstrainSelectedInstOperands,
     /* 394092 */   // GIR_Coverage, 962,
     /* 394092 */   GIR_Done,
     /* 394093 */ // Label 7660: @394093
     /* 394093 */ GIM_Reject,
     /* 394094 */ // Label 7652: @394094
     /* 394094 */ GIM_Try, /*On fail goto*//*Label 7661*/ GIMT_Encode4(394124), // Rule ID 958 //
     /* 394099 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394102 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394105 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394109 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394113 */   // (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394113 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 394118 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394122 */   GIR_RootConstrainSelectedInstOperands,
     /* 394123 */   // GIR_Coverage, 958,
     /* 394123 */   GIR_Done,
     /* 394124 */ // Label 7661: @394124
     /* 394124 */ GIM_Reject,
     /* 394125 */ // Label 7653: @394125
     /* 394125 */ GIM_Reject,
     /* 394126 */ // Label 100: @394126
     /* 394126 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7670*/ GIMT_Encode4(394616),
     /* 394137 */ /*GILLT_s16*//*Label 7662*/ GIMT_Encode4(394177),
     /* 394141 */ /*GILLT_s32*//*Label 7663*/ GIMT_Encode4(394208),
     /* 394145 */ /*GILLT_s64*//*Label 7664*/ GIMT_Encode4(394239), GIMT_Encode4(0),
     /* 394153 */ /*GILLT_v2s32*//*Label 7665*/ GIMT_Encode4(394270),
     /* 394157 */ /*GILLT_v2s64*//*Label 7666*/ GIMT_Encode4(394301),
     /* 394161 */ /*GILLT_v4s16*//*Label 7667*/ GIMT_Encode4(394332),
     /* 394165 */ /*GILLT_v4s32*//*Label 7668*/ GIMT_Encode4(394363), GIMT_Encode4(0),
     /* 394173 */ /*GILLT_v8s16*//*Label 7669*/ GIMT_Encode4(394394),
     /* 394177 */ // Label 7662: @394177
     /* 394177 */ GIM_Try, /*On fail goto*//*Label 7671*/ GIMT_Encode4(394207), // Rule ID 540 //
     /* 394182 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394185 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394188 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394192 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394196 */   // (ffloor:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTMHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMHr),
     /* 394201 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394205 */   GIR_RootConstrainSelectedInstOperands,
     /* 394206 */   // GIR_Coverage, 540,
     /* 394206 */   GIR_Done,
     /* 394207 */ // Label 7671: @394207
     /* 394207 */ GIM_Reject,
     /* 394208 */ // Label 7663: @394208
     /* 394208 */ GIM_Try, /*On fail goto*//*Label 7672*/ GIMT_Encode4(394238), // Rule ID 542 //
     /* 394213 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394216 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394223 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394227 */   // (ffloor:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTMSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394227 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMSr),
     /* 394232 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394236 */   GIR_RootConstrainSelectedInstOperands,
     /* 394237 */   // GIR_Coverage, 542,
     /* 394237 */   GIR_Done,
     /* 394238 */ // Label 7672: @394238
     /* 394238 */ GIM_Reject,
     /* 394239 */ // Label 7664: @394239
     /* 394239 */ GIM_Try, /*On fail goto*//*Label 7673*/ GIMT_Encode4(394269), // Rule ID 544 //
     /* 394244 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394247 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394250 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394254 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394258 */   // (ffloor:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTMDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394258 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMDr),
     /* 394263 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394267 */   GIR_RootConstrainSelectedInstOperands,
     /* 394268 */   // GIR_Coverage, 544,
     /* 394268 */   GIR_Done,
     /* 394269 */ // Label 7673: @394269
     /* 394269 */ GIM_Reject,
     /* 394270 */ // Label 7665: @394270
     /* 394270 */ GIM_Try, /*On fail goto*//*Label 7674*/ GIMT_Encode4(394300), // Rule ID 893 //
     /* 394275 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394278 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394285 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394289 */   // (ffloor:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTMv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394289 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f32),
     /* 394294 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394298 */   GIR_RootConstrainSelectedInstOperands,
     /* 394299 */   // GIR_Coverage, 893,
     /* 394299 */   GIR_Done,
     /* 394300 */ // Label 7674: @394300
     /* 394300 */ GIM_Reject,
     /* 394301 */ // Label 7666: @394301
     /* 394301 */ GIM_Try, /*On fail goto*//*Label 7675*/ GIMT_Encode4(394331), // Rule ID 897 //
     /* 394306 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394309 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394312 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394316 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394320 */   // (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTMv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394320 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv2f64),
     /* 394325 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394329 */   GIR_RootConstrainSelectedInstOperands,
     /* 394330 */   // GIR_Coverage, 897,
     /* 394330 */   GIR_Done,
     /* 394331 */ // Label 7675: @394331
     /* 394331 */ GIM_Reject,
     /* 394332 */ // Label 7667: @394332
     /* 394332 */ GIM_Try, /*On fail goto*//*Label 7676*/ GIMT_Encode4(394362), // Rule ID 889 //
     /* 394337 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394340 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394343 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394347 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394351 */   // (ffloor:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTMv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394351 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f16),
     /* 394356 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394360 */   GIR_RootConstrainSelectedInstOperands,
     /* 394361 */   // GIR_Coverage, 889,
     /* 394361 */   GIR_Done,
     /* 394362 */ // Label 7676: @394362
     /* 394362 */ GIM_Reject,
     /* 394363 */ // Label 7668: @394363
     /* 394363 */ GIM_Try, /*On fail goto*//*Label 7677*/ GIMT_Encode4(394393), // Rule ID 895 //
     /* 394368 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394371 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394374 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394378 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394382 */   // (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTMv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394382 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394387 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394391 */   GIR_RootConstrainSelectedInstOperands,
     /* 394392 */   // GIR_Coverage, 895,
     /* 394392 */   GIR_Done,
     /* 394393 */ // Label 7677: @394393
     /* 394393 */ GIM_Reject,
     /* 394394 */ // Label 7669: @394394
     /* 394394 */ GIM_Try, /*On fail goto*//*Label 7678*/ GIMT_Encode4(394615),
     /* 394399 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394410 */   GIM_Try, /*On fail goto*//*Label 7679*/ GIMT_Encode4(394429), // Rule ID 891 //
     /* 394415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394418 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTMv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394418 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv8f16),
     /* 394423 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394427 */     GIR_RootConstrainSelectedInstOperands,
     /* 394428 */     // GIR_Coverage, 891,
     /* 394428 */     GIR_Done,
     /* 394429 */   // Label 7679: @394429
     /* 394429 */   GIM_Try, /*On fail goto*//*Label 7680*/ GIMT_Encode4(394614), // Rule ID 7030 //
     /* 394434 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394437 */     // (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTMv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTMv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394437 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394440 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394444 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394449 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394455 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394458 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394462 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394467 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394470 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394472 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394475 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394479 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394484 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394490 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394495 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394500 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394503 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394507 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394512 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 394515 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 394517 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 394520 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTMv4f32),
     /* 394524 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394529 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 394532 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 394534 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 394537 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 394541 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394546 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 394549 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 394551 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 394554 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 394558 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394563 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 394565 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 394568 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 394572 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394577 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 394580 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 394583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 394586 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394591 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394596 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 394604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 394606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 394609 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 394612 */     GIR_RootConstrainSelectedInstOperands,
     /* 394613 */     // GIR_Coverage, 7030,
     /* 394613 */     GIR_EraseRootFromParent_Done,
     /* 394614 */   // Label 7680: @394614
     /* 394614 */   GIM_Reject,
     /* 394615 */ // Label 7678: @394615
     /* 394615 */ GIM_Reject,
     /* 394616 */ // Label 7670: @394616
     /* 394616 */ GIM_Reject,
     /* 394617 */ // Label 101: @394617
     /* 394617 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7689*/ GIMT_Encode4(395107),
     /* 394628 */ /*GILLT_s16*//*Label 7681*/ GIMT_Encode4(394668),
     /* 394632 */ /*GILLT_s32*//*Label 7682*/ GIMT_Encode4(394699),
     /* 394636 */ /*GILLT_s64*//*Label 7683*/ GIMT_Encode4(394730), GIMT_Encode4(0),
     /* 394644 */ /*GILLT_v2s32*//*Label 7684*/ GIMT_Encode4(394761),
     /* 394648 */ /*GILLT_v2s64*//*Label 7685*/ GIMT_Encode4(394792),
     /* 394652 */ /*GILLT_v4s16*//*Label 7686*/ GIMT_Encode4(394823),
     /* 394656 */ /*GILLT_v4s32*//*Label 7687*/ GIMT_Encode4(394854), GIMT_Encode4(0),
     /* 394664 */ /*GILLT_v8s16*//*Label 7688*/ GIMT_Encode4(394885),
     /* 394668 */ // Label 7681: @394668
     /* 394668 */ GIM_Try, /*On fail goto*//*Label 7690*/ GIMT_Encode4(394698), // Rule ID 558 //
     /* 394673 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 394676 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 394679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 394687 */   // (frint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTXHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 394687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXHr),
     /* 394692 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394696 */   GIR_RootConstrainSelectedInstOperands,
     /* 394697 */   // GIR_Coverage, 558,
     /* 394697 */   GIR_Done,
     /* 394698 */ // Label 7690: @394698
     /* 394698 */ GIM_Reject,
     /* 394699 */ // Label 7682: @394699
     /* 394699 */ GIM_Try, /*On fail goto*//*Label 7691*/ GIMT_Encode4(394729), // Rule ID 560 //
     /* 394704 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394707 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 394710 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394714 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 394718 */   // (frint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTXSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 394718 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXSr),
     /* 394723 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394727 */   GIR_RootConstrainSelectedInstOperands,
     /* 394728 */   // GIR_Coverage, 560,
     /* 394728 */   GIR_Done,
     /* 394729 */ // Label 7691: @394729
     /* 394729 */ GIM_Reject,
     /* 394730 */ // Label 7683: @394730
     /* 394730 */ GIM_Try, /*On fail goto*//*Label 7692*/ GIMT_Encode4(394760), // Rule ID 562 //
     /* 394735 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 394738 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 394741 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394745 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394749 */   // (frint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTXDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 394749 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXDr),
     /* 394754 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394758 */   GIR_RootConstrainSelectedInstOperands,
     /* 394759 */   // GIR_Coverage, 562,
     /* 394759 */   GIR_Done,
     /* 394760 */ // Label 7692: @394760
     /* 394760 */ GIM_Reject,
     /* 394761 */ // Label 7684: @394761
     /* 394761 */ GIM_Try, /*On fail goto*//*Label 7693*/ GIMT_Encode4(394791), // Rule ID 923 //
     /* 394766 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 394772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394776 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394780 */   // (frint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTXv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 394780 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f32),
     /* 394785 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394789 */   GIR_RootConstrainSelectedInstOperands,
     /* 394790 */   // GIR_Coverage, 923,
     /* 394790 */   GIR_Done,
     /* 394791 */ // Label 7693: @394791
     /* 394791 */ GIM_Reject,
     /* 394792 */ // Label 7685: @394792
     /* 394792 */ GIM_Try, /*On fail goto*//*Label 7694*/ GIMT_Encode4(394822), // Rule ID 927 //
     /* 394797 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394800 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 394803 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394807 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394811 */   // (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTXv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 394811 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv2f64),
     /* 394816 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394820 */   GIR_RootConstrainSelectedInstOperands,
     /* 394821 */   // GIR_Coverage, 927,
     /* 394821 */   GIR_Done,
     /* 394822 */ // Label 7694: @394822
     /* 394822 */ GIM_Reject,
     /* 394823 */ // Label 7686: @394823
     /* 394823 */ GIM_Try, /*On fail goto*//*Label 7695*/ GIMT_Encode4(394853), // Rule ID 919 //
     /* 394828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 394834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394842 */   // (frint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTXv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 394842 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f16),
     /* 394847 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394851 */   GIR_RootConstrainSelectedInstOperands,
     /* 394852 */   // GIR_Coverage, 919,
     /* 394852 */   GIR_Done,
     /* 394853 */ // Label 7695: @394853
     /* 394853 */ GIM_Reject,
     /* 394854 */ // Label 7687: @394854
     /* 394854 */ GIM_Try, /*On fail goto*//*Label 7696*/ GIMT_Encode4(394884), // Rule ID 925 //
     /* 394859 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 394862 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 394865 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394869 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394873 */   // (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTXv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 394873 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394878 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394882 */   GIR_RootConstrainSelectedInstOperands,
     /* 394883 */   // GIR_Coverage, 925,
     /* 394883 */   GIR_Done,
     /* 394884 */ // Label 7696: @394884
     /* 394884 */ GIM_Reject,
     /* 394885 */ // Label 7688: @394885
     /* 394885 */ GIM_Try, /*On fail goto*//*Label 7697*/ GIMT_Encode4(395106),
     /* 394890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 394893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394897 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394901 */   GIM_Try, /*On fail goto*//*Label 7698*/ GIMT_Encode4(394920), // Rule ID 921 //
     /* 394906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 394909 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTXv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 394909 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv8f16),
     /* 394914 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 394918 */     GIR_RootConstrainSelectedInstOperands,
     /* 394919 */     // GIR_Coverage, 921,
     /* 394919 */     GIR_Done,
     /* 394920 */   // Label 7698: @394920
     /* 394920 */   GIM_Try, /*On fail goto*//*Label 7699*/ GIMT_Encode4(395105), // Rule ID 7038 //
     /* 394925 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 394928 */     // (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTXv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTXv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 394928 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 394931 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 394935 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394940 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 394944 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 394946 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 394949 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 394953 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394958 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 394961 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 394963 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 394966 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 394970 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 394975 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 394981 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 394986 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 394991 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 394994 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 394998 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395003 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395006 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395008 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395011 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTXv4f32),
     /* 395015 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395020 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395023 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395025 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395028 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395032 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395037 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395040 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395042 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395045 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395049 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395054 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395068 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395071 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395074 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395082 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395087 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395092 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395095 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395097 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395100 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395103 */     GIR_RootConstrainSelectedInstOperands,
     /* 395104 */     // GIR_Coverage, 7038,
     /* 395104 */     GIR_EraseRootFromParent_Done,
     /* 395105 */   // Label 7699: @395105
     /* 395105 */   GIM_Reject,
     /* 395106 */ // Label 7697: @395106
     /* 395106 */ GIM_Reject,
     /* 395107 */ // Label 7689: @395107
     /* 395107 */ GIM_Reject,
     /* 395108 */ // Label 102: @395108
     /* 395108 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7708*/ GIMT_Encode4(395598),
     /* 395119 */ /*GILLT_s16*//*Label 7700*/ GIMT_Encode4(395159),
     /* 395123 */ /*GILLT_s32*//*Label 7701*/ GIMT_Encode4(395190),
     /* 395127 */ /*GILLT_s64*//*Label 7702*/ GIMT_Encode4(395221), GIMT_Encode4(0),
     /* 395135 */ /*GILLT_v2s32*//*Label 7703*/ GIMT_Encode4(395252),
     /* 395139 */ /*GILLT_v2s64*//*Label 7704*/ GIMT_Encode4(395283),
     /* 395143 */ /*GILLT_v4s16*//*Label 7705*/ GIMT_Encode4(395314),
     /* 395147 */ /*GILLT_v4s32*//*Label 7706*/ GIMT_Encode4(395345), GIMT_Encode4(0),
     /* 395155 */ /*GILLT_v8s16*//*Label 7707*/ GIMT_Encode4(395376),
     /* 395159 */ // Label 7700: @395159
     /* 395159 */ GIM_Try, /*On fail goto*//*Label 7709*/ GIMT_Encode4(395189), // Rule ID 534 //
     /* 395164 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395167 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395178 */   // (fnearbyint:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FRINTIHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 395178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIHr),
     /* 395183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395187 */   GIR_RootConstrainSelectedInstOperands,
     /* 395188 */   // GIR_Coverage, 534,
     /* 395188 */   GIR_Done,
     /* 395189 */ // Label 7709: @395189
     /* 395189 */ GIM_Reject,
     /* 395190 */ // Label 7701: @395190
     /* 395190 */ GIM_Try, /*On fail goto*//*Label 7710*/ GIMT_Encode4(395220), // Rule ID 536 //
     /* 395195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395209 */   // (fnearbyint:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FRINTISr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 395209 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTISr),
     /* 395214 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395218 */   GIR_RootConstrainSelectedInstOperands,
     /* 395219 */   // GIR_Coverage, 536,
     /* 395219 */   GIR_Done,
     /* 395220 */ // Label 7710: @395220
     /* 395220 */ GIM_Reject,
     /* 395221 */ // Label 7702: @395221
     /* 395221 */ GIM_Try, /*On fail goto*//*Label 7711*/ GIMT_Encode4(395251), // Rule ID 538 //
     /* 395226 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 395229 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 395232 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395236 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395240 */   // (fnearbyint:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FRINTIDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 395240 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIDr),
     /* 395245 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395249 */   GIR_RootConstrainSelectedInstOperands,
     /* 395250 */   // GIR_Coverage, 538,
     /* 395250 */   GIR_Done,
     /* 395251 */ // Label 7711: @395251
     /* 395251 */ GIM_Reject,
     /* 395252 */ // Label 7703: @395252
     /* 395252 */ GIM_Try, /*On fail goto*//*Label 7712*/ GIMT_Encode4(395282), // Rule ID 883 //
     /* 395257 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395260 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 395263 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395267 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395271 */   // (fnearbyint:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FRINTIv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 395271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f32),
     /* 395276 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395280 */   GIR_RootConstrainSelectedInstOperands,
     /* 395281 */   // GIR_Coverage, 883,
     /* 395281 */   GIR_Done,
     /* 395282 */ // Label 7712: @395282
     /* 395282 */ GIM_Reject,
     /* 395283 */ // Label 7704: @395283
     /* 395283 */ GIM_Try, /*On fail goto*//*Label 7713*/ GIMT_Encode4(395313), // Rule ID 887 //
     /* 395288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 395294 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395298 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395302 */   // (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FRINTIv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 395302 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv2f64),
     /* 395307 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395311 */   GIR_RootConstrainSelectedInstOperands,
     /* 395312 */   // GIR_Coverage, 887,
     /* 395312 */   GIR_Done,
     /* 395313 */ // Label 7713: @395313
     /* 395313 */ GIM_Reject,
     /* 395314 */ // Label 7705: @395314
     /* 395314 */ GIM_Try, /*On fail goto*//*Label 7714*/ GIMT_Encode4(395344), // Rule ID 879 //
     /* 395319 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395322 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 395325 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395329 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395333 */   // (fnearbyint:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FRINTIv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 395333 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f16),
     /* 395338 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395342 */   GIR_RootConstrainSelectedInstOperands,
     /* 395343 */   // GIR_Coverage, 879,
     /* 395343 */   GIR_Done,
     /* 395344 */ // Label 7714: @395344
     /* 395344 */ GIM_Reject,
     /* 395345 */ // Label 7706: @395345
     /* 395345 */ GIM_Try, /*On fail goto*//*Label 7715*/ GIMT_Encode4(395375), // Rule ID 885 //
     /* 395350 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 395353 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395364 */   // (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FRINTIv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 395364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395369 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395373 */   GIR_RootConstrainSelectedInstOperands,
     /* 395374 */   // GIR_Coverage, 885,
     /* 395374 */   GIR_Done,
     /* 395375 */ // Label 7715: @395375
     /* 395375 */ GIM_Reject,
     /* 395376 */ // Label 7707: @395376
     /* 395376 */ GIM_Try, /*On fail goto*//*Label 7716*/ GIMT_Encode4(395597),
     /* 395381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395384 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395388 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395392 */   GIM_Try, /*On fail goto*//*Label 7717*/ GIMT_Encode4(395411), // Rule ID 881 //
     /* 395397 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 395400 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FRINTIv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 395400 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv8f16),
     /* 395405 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395409 */     GIR_RootConstrainSelectedInstOperands,
     /* 395410 */     // GIR_Coverage, 881,
     /* 395410 */     GIR_Done,
     /* 395411 */   // Label 7717: @395411
     /* 395411 */   GIM_Try, /*On fail goto*//*Label 7718*/ GIMT_Encode4(395596), // Rule ID 7032 //
     /* 395416 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 395419 */     // (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FRINTIv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FRINTIv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn)))
     /* 395419 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s32,
     /* 395422 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 395426 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395431 */     GIR_Copy, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 395435 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/8,
     /* 395437 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 395440 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395444 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395449 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 395452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 395454 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 395457 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395461 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395466 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395472 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395477 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395482 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 395485 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 395489 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395494 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 395497 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 395499 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 395502 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FRINTIv4f32),
     /* 395506 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395511 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 395514 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 395516 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 395519 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 395523 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395528 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 395531 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 395533 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 395536 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 395540 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395545 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 395547 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 395550 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 395554 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395559 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 395562 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 395565 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 395568 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395573 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395578 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395583 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 395586 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 395588 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395591 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/6,
     /* 395594 */     GIR_RootConstrainSelectedInstOperands,
     /* 395595 */     // GIR_Coverage, 7032,
     /* 395595 */     GIR_EraseRootFromParent_Done,
     /* 395596 */   // Label 7718: @395596
     /* 395596 */   GIM_Reject,
     /* 395597 */ // Label 7716: @395597
     /* 395597 */ GIM_Reject,
     /* 395598 */ // Label 7708: @395598
     /* 395598 */ GIM_Reject,
     /* 395599 */ // Label 103: @395599
     /* 395599 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7727*/ GIMT_Encode4(396724),
     /* 395610 */ /*GILLT_s16*//*Label 7719*/ GIMT_Encode4(395650),
     /* 395614 */ /*GILLT_s32*//*Label 7720*/ GIMT_Encode4(395876),
     /* 395618 */ /*GILLT_s64*//*Label 7721*/ GIMT_Encode4(396102), GIMT_Encode4(0),
     /* 395626 */ /*GILLT_v2s32*//*Label 7722*/ GIMT_Encode4(396274),
     /* 395630 */ /*GILLT_v2s64*//*Label 7723*/ GIMT_Encode4(396312),
     /* 395634 */ /*GILLT_v4s16*//*Label 7724*/ GIMT_Encode4(396350),
     /* 395638 */ /*GILLT_v4s32*//*Label 7725*/ GIMT_Encode4(396388), GIMT_Encode4(0),
     /* 395646 */ /*GILLT_v8s16*//*Label 7726*/ GIMT_Encode4(396426),
     /* 395650 */ // Label 7719: @395650
     /* 395650 */ GIM_Try, /*On fail goto*//*Label 7728*/ GIMT_Encode4(395875),
     /* 395655 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 395658 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 395661 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395665 */   GIM_Try, /*On fail goto*//*Label 7729*/ GIMT_Encode4(395756), // Rule ID 6952 //
     /* 395670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395682 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395691 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395695 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395699 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395703 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395707 */     // MIs[2] Rn
     /* 395707 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395712 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395716 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395718 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395718 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395721 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395725 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395730 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395736 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395741 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395746 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395749 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395751 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395754 */     GIR_RootConstrainSelectedInstOperands,
     /* 395755 */     // GIR_Coverage, 6952,
     /* 395755 */     GIR_EraseRootFromParent_Done,
     /* 395756 */   // Label 7729: @395756
     /* 395756 */   GIM_Try, /*On fail goto*//*Label 7730*/ GIMT_Encode4(395847), // Rule ID 14019 //
     /* 395761 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395765 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395769 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 395773 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395777 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395782 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 395786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395794 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395798 */     // MIs[2] Rn
     /* 395798 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395803 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 395807 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395809 */     // (strict_fadd:{ *:[f16] } (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f16] } FPR128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] }))
     /* 395809 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395812 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395816 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395821 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395827 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395832 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395837 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 395840 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395842 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395845 */     GIR_RootConstrainSelectedInstOperands,
     /* 395846 */     // GIR_Coverage, 14019,
     /* 395846 */     GIR_EraseRootFromParent_Done,
     /* 395847 */   // Label 7730: @395847
     /* 395847 */   GIM_Try, /*On fail goto*//*Label 7731*/ GIMT_Encode4(395874), // Rule ID 583 //
     /* 395852 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 395855 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395859 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 395863 */     // (strict_fadd:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FADDHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 395863 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDHrr),
     /* 395868 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 395872 */     GIR_RootConstrainSelectedInstOperands,
     /* 395873 */     // GIR_Coverage, 583,
     /* 395873 */     GIR_Done,
     /* 395874 */   // Label 7731: @395874
     /* 395874 */   GIM_Reject,
     /* 395875 */ // Label 7728: @395875
     /* 395875 */ GIM_Reject,
     /* 395876 */ // Label 7720: @395876
     /* 395876 */ GIM_Try, /*On fail goto*//*Label 7732*/ GIMT_Encode4(396101),
     /* 395881 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 395884 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 395887 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 395891 */   GIM_Try, /*On fail goto*//*Label 7733*/ GIMT_Encode4(395982), // Rule ID 6950 //
     /* 395896 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395900 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395904 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395908 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 395912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395917 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 395921 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 395925 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395929 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 395933 */     // MIs[2] Rn
     /* 395933 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 395938 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 395942 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 395944 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 395944 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 395947 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 395951 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 395956 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 395962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 395967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 395972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 395975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 395977 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 395980 */     GIR_RootConstrainSelectedInstOperands,
     /* 395981 */     // GIR_Coverage, 6950,
     /* 395981 */     GIR_EraseRootFromParent_Done,
     /* 395982 */   // Label 7733: @395982
     /* 395982 */   GIM_Try, /*On fail goto*//*Label 7734*/ GIMT_Encode4(396073), // Rule ID 14017 //
     /* 395987 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 395991 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 395995 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 395999 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396003 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396008 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 396012 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396016 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396020 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396024 */     // MIs[2] Rn
     /* 396024 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396029 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 396033 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396035 */     // (strict_fadd:{ *:[f32] } (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f32] } FPR128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } FPR128:{ *:[v4f32] }:$Rn, dsub:{ *:[i32] }))
     /* 396035 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 396038 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396042 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396047 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396053 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396058 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396063 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 396066 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396068 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396071 */     GIR_RootConstrainSelectedInstOperands,
     /* 396072 */     // GIR_Coverage, 14017,
     /* 396072 */     GIR_EraseRootFromParent_Done,
     /* 396073 */   // Label 7734: @396073
     /* 396073 */   GIM_Try, /*On fail goto*//*Label 7735*/ GIMT_Encode4(396100), // Rule ID 585 //
     /* 396078 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396081 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396085 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396089 */     // (strict_fadd:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FADDSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDSrr),
     /* 396094 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396098 */     GIR_RootConstrainSelectedInstOperands,
     /* 396099 */     // GIR_Coverage, 585,
     /* 396099 */     GIR_Done,
     /* 396100 */   // Label 7735: @396100
     /* 396100 */   GIM_Reject,
     /* 396101 */ // Label 7732: @396101
     /* 396101 */ GIM_Reject,
     /* 396102 */ // Label 7721: @396102
     /* 396102 */ GIM_Try, /*On fail goto*//*Label 7736*/ GIMT_Encode4(396273),
     /* 396107 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396110 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396117 */   GIM_Try, /*On fail goto*//*Label 7737*/ GIMT_Encode4(396181), // Rule ID 6948 //
     /* 396122 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396126 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396130 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396134 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396138 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396143 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 396147 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396151 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396155 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396159 */     // MIs[2] Rn
     /* 396159 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396164 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 1,
     /* 396168 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396170 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 396170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 396173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396175 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396179 */     GIR_RootConstrainSelectedInstOperands,
     /* 396180 */     // GIR_Coverage, 6948,
     /* 396180 */     GIR_EraseRootFromParent_Done,
     /* 396181 */   // Label 7737: @396181
     /* 396181 */   GIM_Try, /*On fail goto*//*Label 7738*/ GIMT_Encode4(396245), // Rule ID 14015 //
     /* 396186 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 396190 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396194 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396198 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 396202 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396207 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 1,
     /* 396211 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 396215 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 396219 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 396223 */     // MIs[2] Rn
     /* 396223 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 396228 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 396232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 396234 */     // (strict_fadd:{ *:[f64] } (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (vector_extract:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FADDPv2i64p:{ *:[f64] } FPR128:{ *:[v2f64] }:$Rn)
     /* 396234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 396237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 396239 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 396243 */     GIR_RootConstrainSelectedInstOperands,
     /* 396244 */     // GIR_Coverage, 14015,
     /* 396244 */     GIR_EraseRootFromParent_Done,
     /* 396245 */   // Label 7738: @396245
     /* 396245 */   GIM_Try, /*On fail goto*//*Label 7739*/ GIMT_Encode4(396272), // Rule ID 587 //
     /* 396250 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396253 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396257 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396261 */     // (strict_fadd:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FADDDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396261 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDDrr),
     /* 396266 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396270 */     GIR_RootConstrainSelectedInstOperands,
     /* 396271 */     // GIR_Coverage, 587,
     /* 396271 */     GIR_Done,
     /* 396272 */   // Label 7739: @396272
     /* 396272 */   GIM_Reject,
     /* 396273 */ // Label 7736: @396273
     /* 396273 */ GIM_Reject,
     /* 396274 */ // Label 7722: @396274
     /* 396274 */ GIM_Try, /*On fail goto*//*Label 7740*/ GIMT_Encode4(396311), // Rule ID 1202 //
     /* 396279 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396282 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396285 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396288 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396292 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396296 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396300 */   // (strict_fadd:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FADDv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396300 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f32),
     /* 396305 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396309 */   GIR_RootConstrainSelectedInstOperands,
     /* 396310 */   // GIR_Coverage, 1202,
     /* 396310 */   GIR_Done,
     /* 396311 */ // Label 7740: @396311
     /* 396311 */ GIM_Reject,
     /* 396312 */ // Label 7723: @396312
     /* 396312 */ GIM_Try, /*On fail goto*//*Label 7741*/ GIMT_Encode4(396349), // Rule ID 1206 //
     /* 396317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396338 */   // (strict_fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FADDv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv2f64),
     /* 396343 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396347 */   GIR_RootConstrainSelectedInstOperands,
     /* 396348 */   // GIR_Coverage, 1206,
     /* 396348 */   GIR_Done,
     /* 396349 */ // Label 7741: @396349
     /* 396349 */ GIM_Reject,
     /* 396350 */ // Label 7724: @396350
     /* 396350 */ GIM_Try, /*On fail goto*//*Label 7742*/ GIMT_Encode4(396387), // Rule ID 1198 //
     /* 396355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396368 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396372 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396376 */   // (strict_fadd:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FADDv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396376 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f16),
     /* 396381 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396385 */   GIR_RootConstrainSelectedInstOperands,
     /* 396386 */   // GIR_Coverage, 1198,
     /* 396386 */   GIR_Done,
     /* 396387 */ // Label 7742: @396387
     /* 396387 */ GIM_Reject,
     /* 396388 */ // Label 7725: @396388
     /* 396388 */ GIM_Try, /*On fail goto*//*Label 7743*/ GIMT_Encode4(396425), // Rule ID 1204 //
     /* 396393 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396396 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 396399 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 396402 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396406 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396410 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396414 */   // (strict_fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FADDv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 396414 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396419 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396423 */   GIR_RootConstrainSelectedInstOperands,
     /* 396424 */   // GIR_Coverage, 1204,
     /* 396424 */   GIR_Done,
     /* 396425 */ // Label 7743: @396425
     /* 396425 */ GIM_Reject,
     /* 396426 */ // Label 7726: @396426
     /* 396426 */ GIM_Try, /*On fail goto*//*Label 7744*/ GIMT_Encode4(396723),
     /* 396431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 396434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 396437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396441 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396445 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396449 */   GIM_Try, /*On fail goto*//*Label 7745*/ GIMT_Encode4(396468), // Rule ID 1200 //
     /* 396454 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396457 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FADDv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 396457 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDv8f16),
     /* 396462 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396466 */     GIR_RootConstrainSelectedInstOperands,
     /* 396467 */     // GIR_Coverage, 1200,
     /* 396467 */     GIR_Done,
     /* 396468 */   // Label 7745: @396468
     /* 396468 */   GIM_Try, /*On fail goto*//*Label 7746*/ GIMT_Encode4(396722), // Rule ID 7041 //
     /* 396473 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 396476 */     // (strict_fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FADDv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FADDv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 396476 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 396479 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396483 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396488 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 396492 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 396494 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 396497 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 396501 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396506 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 396510 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 396512 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 396515 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396519 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396524 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 396527 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 396530 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 396532 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 396535 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396539 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396544 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 396550 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396555 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396560 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 396563 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396567 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396572 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 396575 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 396577 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 396580 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 396584 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396589 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 396595 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396600 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396605 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 396608 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 396612 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396617 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 396620 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 396622 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 396625 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FADDv4f32),
     /* 396629 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396634 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 396637 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 396640 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 396642 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 396645 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 396649 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396654 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 396657 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 396659 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 396662 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 396666 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396671 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 396673 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 396676 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 396680 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 396685 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 396688 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 396691 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 396694 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396699 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396704 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396709 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 396712 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 396714 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 396717 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 396720 */     GIR_RootConstrainSelectedInstOperands,
     /* 396721 */     // GIR_Coverage, 7041,
     /* 396721 */     GIR_EraseRootFromParent_Done,
     /* 396722 */   // Label 7746: @396722
     /* 396722 */   GIM_Reject,
     /* 396723 */ // Label 7744: @396723
     /* 396723 */ GIM_Reject,
     /* 396724 */ // Label 7727: @396724
     /* 396724 */ GIM_Reject,
     /* 396725 */ // Label 104: @396725
     /* 396725 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7755*/ GIMT_Encode4(397340),
     /* 396736 */ /*GILLT_s16*//*Label 7747*/ GIMT_Encode4(396776),
     /* 396740 */ /*GILLT_s32*//*Label 7748*/ GIMT_Encode4(396814),
     /* 396744 */ /*GILLT_s64*//*Label 7749*/ GIMT_Encode4(396852), GIMT_Encode4(0),
     /* 396752 */ /*GILLT_v2s32*//*Label 7750*/ GIMT_Encode4(396890),
     /* 396756 */ /*GILLT_v2s64*//*Label 7751*/ GIMT_Encode4(396928),
     /* 396760 */ /*GILLT_v4s16*//*Label 7752*/ GIMT_Encode4(396966),
     /* 396764 */ /*GILLT_v4s32*//*Label 7753*/ GIMT_Encode4(397004), GIMT_Encode4(0),
     /* 396772 */ /*GILLT_v8s16*//*Label 7754*/ GIMT_Encode4(397042),
     /* 396776 */ // Label 7747: @396776
     /* 396776 */ GIM_Try, /*On fail goto*//*Label 7756*/ GIMT_Encode4(396813), // Rule ID 631 //
     /* 396781 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 396784 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 396787 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 396790 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396794 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396798 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 396802 */   // (strict_fsub:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FSUBHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 396802 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBHrr),
     /* 396807 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396811 */   GIR_RootConstrainSelectedInstOperands,
     /* 396812 */   // GIR_Coverage, 631,
     /* 396812 */   GIR_Done,
     /* 396813 */ // Label 7756: @396813
     /* 396813 */ GIM_Reject,
     /* 396814 */ // Label 7748: @396814
     /* 396814 */ GIM_Try, /*On fail goto*//*Label 7757*/ GIMT_Encode4(396851), // Rule ID 633 //
     /* 396819 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396822 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 396825 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 396828 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396832 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396836 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 396840 */   // (strict_fsub:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FSUBSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 396840 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBSrr),
     /* 396845 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396849 */   GIR_RootConstrainSelectedInstOperands,
     /* 396850 */   // GIR_Coverage, 633,
     /* 396850 */   GIR_Done,
     /* 396851 */ // Label 7757: @396851
     /* 396851 */ GIM_Reject,
     /* 396852 */ // Label 7749: @396852
     /* 396852 */ GIM_Try, /*On fail goto*//*Label 7758*/ GIMT_Encode4(396889), // Rule ID 635 //
     /* 396857 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 396860 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 396863 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 396866 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396870 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396874 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396878 */   // (strict_fsub:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FSUBDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 396878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBDrr),
     /* 396883 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396887 */   GIR_RootConstrainSelectedInstOperands,
     /* 396888 */   // GIR_Coverage, 635,
     /* 396888 */   GIR_Done,
     /* 396889 */ // Label 7758: @396889
     /* 396889 */ GIM_Reject,
     /* 396890 */ // Label 7750: @396890
     /* 396890 */ GIM_Try, /*On fail goto*//*Label 7759*/ GIMT_Encode4(396927), // Rule ID 1342 //
     /* 396895 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 396901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 396904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396916 */   // (strict_fsub:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FSUBv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 396916 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f32),
     /* 396921 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396925 */   GIR_RootConstrainSelectedInstOperands,
     /* 396926 */   // GIR_Coverage, 1342,
     /* 396926 */   GIR_Done,
     /* 396927 */ // Label 7759: @396927
     /* 396927 */ GIM_Reject,
     /* 396928 */ // Label 7751: @396928
     /* 396928 */ GIM_Try, /*On fail goto*//*Label 7760*/ GIMT_Encode4(396965), // Rule ID 1346 //
     /* 396933 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 396936 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 396939 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 396942 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396946 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396950 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 396954 */   // (strict_fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FSUBv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 396954 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv2f64),
     /* 396959 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 396963 */   GIR_RootConstrainSelectedInstOperands,
     /* 396964 */   // GIR_Coverage, 1346,
     /* 396964 */   GIR_Done,
     /* 396965 */ // Label 7760: @396965
     /* 396965 */ GIM_Reject,
     /* 396966 */ // Label 7752: @396966
     /* 396966 */ GIM_Try, /*On fail goto*//*Label 7761*/ GIMT_Encode4(397003), // Rule ID 1338 //
     /* 396971 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 396974 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 396977 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 396980 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396984 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396988 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 396992 */   // (strict_fsub:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FSUBv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 396992 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f16),
     /* 396997 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397001 */   GIR_RootConstrainSelectedInstOperands,
     /* 397002 */   // GIR_Coverage, 1338,
     /* 397002 */   GIR_Done,
     /* 397003 */ // Label 7761: @397003
     /* 397003 */ GIM_Reject,
     /* 397004 */ // Label 7753: @397004
     /* 397004 */ GIM_Try, /*On fail goto*//*Label 7762*/ GIMT_Encode4(397041), // Rule ID 1344 //
     /* 397009 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397012 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397015 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 397018 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397022 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397026 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397030 */   // (strict_fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FSUBv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 397030 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397035 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397039 */   GIR_RootConstrainSelectedInstOperands,
     /* 397040 */   // GIR_Coverage, 1344,
     /* 397040 */   GIR_Done,
     /* 397041 */ // Label 7762: @397041
     /* 397041 */ GIM_Reject,
     /* 397042 */ // Label 7754: @397042
     /* 397042 */ GIM_Try, /*On fail goto*//*Label 7763*/ GIMT_Encode4(397339),
     /* 397047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 397053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397057 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397061 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397065 */   GIM_Try, /*On fail goto*//*Label 7764*/ GIMT_Encode4(397084), // Rule ID 1340 //
     /* 397070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397073 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FSUBv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 397073 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSUBv8f16),
     /* 397078 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397082 */     GIR_RootConstrainSelectedInstOperands,
     /* 397083 */     // GIR_Coverage, 1340,
     /* 397083 */     GIR_Done,
     /* 397084 */   // Label 7764: @397084
     /* 397084 */   GIM_Try, /*On fail goto*//*Label 7765*/ GIMT_Encode4(397338), // Rule ID 7047 //
     /* 397089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 397092 */     // (strict_fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FSUBv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FSUBv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 397092 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 397095 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397099 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397104 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 397108 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 397110 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 397113 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 397117 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397122 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 397126 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 397128 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 397131 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397135 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397140 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 397143 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 397146 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 397148 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 397151 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397155 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397160 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 397166 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397171 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397176 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 397179 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397183 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397188 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 397191 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 397193 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 397196 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397200 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397205 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 397211 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397216 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397221 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 397224 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 397228 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397233 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 397236 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 397238 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 397241 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FSUBv4f32),
     /* 397245 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397250 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 397253 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 397256 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 397258 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 397261 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 397265 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397270 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 397273 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 397275 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 397278 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 397282 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397287 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 397289 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 397292 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 397296 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397301 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 397304 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 397307 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 397310 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397315 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397320 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 397325 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 397328 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 397330 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397333 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 397336 */     GIR_RootConstrainSelectedInstOperands,
     /* 397337 */     // GIR_Coverage, 7047,
     /* 397337 */     GIR_EraseRootFromParent_Done,
     /* 397338 */   // Label 7765: @397338
     /* 397338 */   GIM_Reject,
     /* 397339 */ // Label 7763: @397339
     /* 397339 */ GIM_Reject,
     /* 397340 */ // Label 7755: @397340
     /* 397340 */ GIM_Reject,
     /* 397341 */ // Label 105: @397341
     /* 397341 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7774*/ GIMT_Encode4(401062),
     /* 397352 */ /*GILLT_s16*//*Label 7766*/ GIMT_Encode4(397392),
     /* 397356 */ /*GILLT_s32*//*Label 7767*/ GIMT_Encode4(397946),
     /* 397360 */ /*GILLT_s64*//*Label 7768*/ GIMT_Encode4(398494), GIMT_Encode4(0),
     /* 397368 */ /*GILLT_v2s32*//*Label 7769*/ GIMT_Encode4(399042),
     /* 397372 */ /*GILLT_v2s64*//*Label 7770*/ GIMT_Encode4(399572),
     /* 397376 */ /*GILLT_v4s16*//*Label 7771*/ GIMT_Encode4(399930),
     /* 397380 */ /*GILLT_v4s32*//*Label 7772*/ GIMT_Encode4(400272), GIMT_Encode4(0),
     /* 397388 */ /*GILLT_v8s16*//*Label 7773*/ GIMT_Encode4(400630),
     /* 397392 */ // Label 7766: @397392
     /* 397392 */ GIM_Try, /*On fail goto*//*Label 7775*/ GIMT_Encode4(397945),
     /* 397397 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 397400 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 397403 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397407 */   GIM_Try, /*On fail goto*//*Label 7776*/ GIMT_Encode4(397520), // Rule ID 6280 //
     /* 397412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397427 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397431 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397436 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397452 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 397456 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397461 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 397465 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397469 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397473 */     // MIs[3] Operand 1
     /* 397473 */     // No operand predicates
     /* 397473 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397475 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 397475 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397478 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397482 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397487 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 397493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397498 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397503 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397506 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397508 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397511 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 397515 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 397518 */     GIR_RootConstrainSelectedInstOperands,
     /* 397519 */     // GIR_Coverage, 6280,
     /* 397519 */     GIR_EraseRootFromParent_Done,
     /* 397520 */   // Label 7776: @397520
     /* 397520 */   GIM_Try, /*On fail goto*//*Label 7777*/ GIMT_Encode4(397633), // Rule ID 13996 //
     /* 397525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397528 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397532 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397536 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397540 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397544 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397549 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397553 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397557 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397561 */     // MIs[2] Operand 1
     /* 397561 */     // No operand predicates
     /* 397561 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 397565 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397569 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397573 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 397577 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397582 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 397586 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 397588 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i16_indexed:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 397588 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397591 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397595 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397600 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 397606 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397611 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397621 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397624 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397628 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397631 */     GIR_RootConstrainSelectedInstOperands,
     /* 397632 */     // GIR_Coverage, 13996,
     /* 397632 */     GIR_EraseRootFromParent_Done,
     /* 397633 */   // Label 7777: @397633
     /* 397633 */   GIM_Try, /*On fail goto*//*Label 7778*/ GIMT_Encode4(397712), // Rule ID 13930 //
     /* 397638 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397641 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397645 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397649 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397653 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397657 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397662 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397666 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397670 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397672 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rn)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 397672 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397675 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397679 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397684 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 397690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397705 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397707 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397710 */     GIR_RootConstrainSelectedInstOperands,
     /* 397711 */     // GIR_Coverage, 13930,
     /* 397711 */     GIR_EraseRootFromParent_Done,
     /* 397712 */   // Label 7778: @397712
     /* 397712 */   GIM_Try, /*On fail goto*//*Label 7779*/ GIMT_Encode4(397791), // Rule ID 4837 //
     /* 397717 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397720 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397745 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 397751 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }))  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }))
     /* 397751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 397754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 397758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 397763 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 397769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397774 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397779 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397782 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397784 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397786 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 397789 */     GIR_RootConstrainSelectedInstOperands,
     /* 397790 */     // GIR_Coverage, 4837,
     /* 397790 */     GIR_EraseRootFromParent_Done,
     /* 397791 */   // Label 7779: @397791
     /* 397791 */   GIM_Try, /*On fail goto*//*Label 7780*/ GIMT_Encode4(397854), // Rule ID 13539 //
     /* 397796 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397811 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397815 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397820 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397824 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397828 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397832 */     // MIs[2] Operand 1
     /* 397832 */     // No operand predicates
     /* 397832 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397836 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397838 */     // (strict_fmul:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16Op:{ *:[f16] }:$Rn)  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397838 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397841 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397843 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 397845 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397849 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397852 */     GIR_RootConstrainSelectedInstOperands,
     /* 397853 */     // GIR_Coverage, 13539,
     /* 397853 */     GIR_EraseRootFromParent_Done,
     /* 397854 */   // Label 7780: @397854
     /* 397854 */   GIM_Try, /*On fail goto*//*Label 7781*/ GIMT_Encode4(397917), // Rule ID 2011 //
     /* 397859 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 397862 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397866 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 397870 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397874 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 397878 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397882 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 397887 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 397891 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 397895 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 397899 */     // MIs[2] Operand 1
     /* 397899 */     // No operand predicates
     /* 397899 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 397901 */     // (strict_fmul:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv1i16_indexed:{ *:[f16] } FPR16Op:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 397901 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i16_indexed),
     /* 397904 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 397906 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 397908 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 397912 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 397915 */     GIR_RootConstrainSelectedInstOperands,
     /* 397916 */     // GIR_Coverage, 2011,
     /* 397916 */     GIR_EraseRootFromParent_Done,
     /* 397917 */   // Label 7781: @397917
     /* 397917 */   GIM_Try, /*On fail goto*//*Label 7782*/ GIMT_Encode4(397944), // Rule ID 619 //
     /* 397922 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 397925 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397929 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 397933 */     // (strict_fmul:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FMULHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 397933 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULHrr),
     /* 397938 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 397942 */     GIR_RootConstrainSelectedInstOperands,
     /* 397943 */     // GIR_Coverage, 619,
     /* 397943 */     GIR_Done,
     /* 397944 */   // Label 7782: @397944
     /* 397944 */   GIM_Reject,
     /* 397945 */ // Label 7775: @397945
     /* 397945 */ GIM_Reject,
     /* 397946 */ // Label 7767: @397946
     /* 397946 */ GIM_Try, /*On fail goto*//*Label 7783*/ GIMT_Encode4(398493),
     /* 397951 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 397954 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 397957 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 397961 */   GIM_Try, /*On fail goto*//*Label 7784*/ GIMT_Encode4(398074), // Rule ID 6282 //
     /* 397966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 397969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 397973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 397977 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 397981 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 397985 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 397990 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 397994 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 397998 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398002 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398006 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398010 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398023 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398027 */     // MIs[3] Operand 1
     /* 398027 */     // No operand predicates
     /* 398027 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398029 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 398029 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398032 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398036 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398041 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 398047 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398052 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398057 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398060 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398062 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398069 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398072 */     GIR_RootConstrainSelectedInstOperands,
     /* 398073 */     // GIR_Coverage, 6282,
     /* 398073 */     GIR_EraseRootFromParent_Done,
     /* 398074 */   // Label 7784: @398074
     /* 398074 */   GIM_Try, /*On fail goto*//*Label 7785*/ GIMT_Encode4(398187), // Rule ID 13998 //
     /* 398079 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398082 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398086 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398090 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398094 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398098 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398103 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398107 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398111 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398115 */     // MIs[2] Operand 1
     /* 398115 */     // No operand predicates
     /* 398115 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398119 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398123 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398127 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 398131 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398136 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 398140 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398142 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i32_indexed:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 398142 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398145 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398149 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398154 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 398160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398175 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398178 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398182 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398185 */     GIR_RootConstrainSelectedInstOperands,
     /* 398186 */     // GIR_Coverage, 13998,
     /* 398186 */     GIR_EraseRootFromParent_Done,
     /* 398187 */   // Label 7785: @398187
     /* 398187 */   GIM_Try, /*On fail goto*//*Label 7786*/ GIMT_Encode4(398263), // Rule ID 13932 //
     /* 398192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398213 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398217 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398221 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398223 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rn)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 398223 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398226 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398230 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398235 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 398241 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398246 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398251 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398254 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398256 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398258 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398261 */     GIR_RootConstrainSelectedInstOperands,
     /* 398262 */     // GIR_Coverage, 13932,
     /* 398262 */     GIR_EraseRootFromParent_Done,
     /* 398263 */   // Label 7786: @398263
     /* 398263 */   GIM_Try, /*On fail goto*//*Label 7787*/ GIMT_Encode4(398339), // Rule ID 4839 //
     /* 398268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398297 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398299 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }))  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }))
     /* 398299 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 398302 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398306 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398311 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 398317 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398322 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398332 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398334 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398337 */     GIR_RootConstrainSelectedInstOperands,
     /* 398338 */     // GIR_Coverage, 4839,
     /* 398338 */     GIR_EraseRootFromParent_Done,
     /* 398339 */   // Label 7787: @398339
     /* 398339 */   GIM_Try, /*On fail goto*//*Label 7788*/ GIMT_Encode4(398402), // Rule ID 13541 //
     /* 398344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398347 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398351 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398355 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398359 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398363 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398368 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398372 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398376 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398380 */     // MIs[2] Operand 1
     /* 398380 */     // No operand predicates
     /* 398380 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398384 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398386 */     // (strict_fmul:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32Op:{ *:[f32] }:$Rn)  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398391 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398393 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398397 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398400 */     GIR_RootConstrainSelectedInstOperands,
     /* 398401 */     // GIR_Coverage, 13541,
     /* 398401 */     GIR_EraseRootFromParent_Done,
     /* 398402 */   // Label 7788: @398402
     /* 398402 */   GIM_Try, /*On fail goto*//*Label 7789*/ GIMT_Encode4(398465), // Rule ID 2013 //
     /* 398407 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398410 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398414 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398418 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398422 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 398426 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398435 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398439 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398443 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 398447 */     // MIs[2] Operand 1
     /* 398447 */     // No operand predicates
     /* 398447 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398449 */     // (strict_fmul:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv1i32_indexed:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398449 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i32_indexed),
     /* 398452 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398454 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398463 */     GIR_RootConstrainSelectedInstOperands,
     /* 398464 */     // GIR_Coverage, 2013,
     /* 398464 */     GIR_EraseRootFromParent_Done,
     /* 398465 */   // Label 7789: @398465
     /* 398465 */   GIM_Try, /*On fail goto*//*Label 7790*/ GIMT_Encode4(398492), // Rule ID 621 //
     /* 398470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 398473 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398477 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 398481 */     // (strict_fmul:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FMULSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 398481 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULSrr),
     /* 398486 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 398490 */     GIR_RootConstrainSelectedInstOperands,
     /* 398491 */     // GIR_Coverage, 621,
     /* 398491 */     GIR_Done,
     /* 398492 */   // Label 7790: @398492
     /* 398492 */   GIM_Reject,
     /* 398493 */ // Label 7783: @398493
     /* 398493 */ GIM_Reject,
     /* 398494 */ // Label 7768: @398494
     /* 398494 */ GIM_Try, /*On fail goto*//*Label 7791*/ GIMT_Encode4(399041),
     /* 398499 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 398502 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 398505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398509 */   GIM_Try, /*On fail goto*//*Label 7792*/ GIMT_Encode4(398622), // Rule ID 6284 //
     /* 398514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398517 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398521 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398525 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398529 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398533 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398538 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398542 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 398546 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398550 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398554 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 398558 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398563 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 398567 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398571 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398575 */     // MIs[3] Operand 1
     /* 398575 */     // No operand predicates
     /* 398575 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398577 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 398577 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398580 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398584 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398589 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398595 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398608 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398610 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398613 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 398617 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 398620 */     GIR_RootConstrainSelectedInstOperands,
     /* 398621 */     // GIR_Coverage, 6284,
     /* 398621 */     GIR_EraseRootFromParent_Done,
     /* 398622 */   // Label 7792: @398622
     /* 398622 */   GIM_Try, /*On fail goto*//*Label 7793*/ GIMT_Encode4(398735), // Rule ID 14000 //
     /* 398627 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398630 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398634 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398638 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398642 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398646 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398651 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398655 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398659 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398663 */     // MIs[2] Operand 1
     /* 398663 */     // No operand predicates
     /* 398663 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 398667 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398671 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398675 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 398679 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398684 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 398688 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 398690 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }))  =>  (FMULv1i64_indexed:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 398690 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398693 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398697 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398702 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 398708 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398713 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398718 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398721 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398723 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398726 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398730 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398733 */     GIR_RootConstrainSelectedInstOperands,
     /* 398734 */     // GIR_Coverage, 14000,
     /* 398734 */     GIR_EraseRootFromParent_Done,
     /* 398735 */   // Label 7793: @398735
     /* 398735 */   GIM_Try, /*On fail goto*//*Label 7794*/ GIMT_Encode4(398811), // Rule ID 13934 //
     /* 398740 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398744 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398748 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398752 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398756 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398761 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398765 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398769 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398771 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rn)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398771 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398774 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398778 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398783 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398789 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398804 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398806 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398809 */     GIR_RootConstrainSelectedInstOperands,
     /* 398810 */     // GIR_Coverage, 13934,
     /* 398810 */     GIR_EraseRootFromParent_Done,
     /* 398811 */   // Label 7794: @398811
     /* 398811 */   GIM_Try, /*On fail goto*//*Label 7795*/ GIMT_Encode4(398887), // Rule ID 4841 //
     /* 398816 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398828 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398832 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398836 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398841 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 398845 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 398847 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }))  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }))
     /* 398847 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 398850 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 398854 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 398859 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 398865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398870 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398875 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 398878 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398880 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 398882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 398885 */     GIR_RootConstrainSelectedInstOperands,
     /* 398886 */     // GIR_Coverage, 4841,
     /* 398886 */     GIR_EraseRootFromParent_Done,
     /* 398887 */   // Label 7795: @398887
     /* 398887 */   GIM_Try, /*On fail goto*//*Label 7796*/ GIMT_Encode4(398950), // Rule ID 13543 //
     /* 398892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 398899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398907 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398911 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398916 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398920 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398924 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398928 */     // MIs[2] Operand 1
     /* 398928 */     // No operand predicates
     /* 398928 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398932 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398934 */     // (strict_fmul:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64Op:{ *:[f64] }:$Rn)  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398934 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 398937 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 398939 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 398941 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 398945 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 398948 */     GIR_RootConstrainSelectedInstOperands,
     /* 398949 */     // GIR_Coverage, 13543,
     /* 398949 */     GIR_EraseRootFromParent_Done,
     /* 398950 */   // Label 7796: @398950
     /* 398950 */   GIM_Try, /*On fail goto*//*Label 7797*/ GIMT_Encode4(399013), // Rule ID 2015 //
     /* 398955 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 398958 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 398962 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 398966 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 398970 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 398974 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 398978 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 398983 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 398987 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 398991 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 398995 */     // MIs[2] Operand 1
     /* 398995 */     // No operand predicates
     /* 398995 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 398997 */     // (strict_fmul:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv1i64_indexed:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 398997 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv1i64_indexed),
     /* 399000 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399011 */     GIR_RootConstrainSelectedInstOperands,
     /* 399012 */     // GIR_Coverage, 2015,
     /* 399012 */     GIR_EraseRootFromParent_Done,
     /* 399013 */   // Label 7797: @399013
     /* 399013 */   GIM_Try, /*On fail goto*//*Label 7798*/ GIMT_Encode4(399040), // Rule ID 623 //
     /* 399018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 399021 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399025 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399029 */     // (strict_fmul:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FMULDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 399029 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULDrr),
     /* 399034 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399038 */     GIR_RootConstrainSelectedInstOperands,
     /* 399039 */     // GIR_Coverage, 623,
     /* 399039 */     GIR_Done,
     /* 399040 */   // Label 7798: @399040
     /* 399040 */   GIM_Reject,
     /* 399041 */ // Label 7791: @399041
     /* 399041 */ GIM_Reject,
     /* 399042 */ // Label 7769: @399042
     /* 399042 */ GIM_Try, /*On fail goto*//*Label 7799*/ GIMT_Encode4(399571),
     /* 399047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 399050 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 399053 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399057 */   GIM_Try, /*On fail goto*//*Label 7800*/ GIMT_Encode4(399143), // Rule ID 13531 //
     /* 399062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399077 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399081 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399085 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399089 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399093 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399098 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399102 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399106 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399110 */     // MIs[3] Operand 1
     /* 399110 */     // No operand predicates
     /* 399110 */     // MIs[1] Operand 2
     /* 399110 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399121 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399125 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399127 */     // (strict_fmul:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399127 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399130 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399132 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399134 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399138 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399141 */     GIR_RootConstrainSelectedInstOperands,
     /* 399142 */     // GIR_Coverage, 13531,
     /* 399142 */     GIR_EraseRootFromParent_Done,
     /* 399143 */   // Label 7800: @399143
     /* 399143 */   GIM_Try, /*On fail goto*//*Label 7801*/ GIMT_Encode4(399229), // Rule ID 2003 //
     /* 399148 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399151 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399155 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399159 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399163 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399167 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399171 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399175 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399179 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399183 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399188 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399192 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399196 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399200 */     // MIs[3] Operand 1
     /* 399200 */     // No operand predicates
     /* 399200 */     // MIs[1] Operand 2
     /* 399200 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 399211 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 399213 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (extract_subvector:{ *:[v2f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399213 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399216 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399218 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399220 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 399224 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 399227 */     GIR_RootConstrainSelectedInstOperands,
     /* 399228 */     // GIR_Coverage, 2003,
     /* 399228 */     GIR_EraseRootFromParent_Done,
     /* 399229 */   // Label 7801: @399229
     /* 399229 */   GIM_Try, /*On fail goto*//*Label 7802*/ GIMT_Encode4(399292), // Rule ID 13532 //
     /* 399234 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399237 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399241 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399245 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399249 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399253 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399258 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399262 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399266 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399270 */     // MIs[2] Operand 1
     /* 399270 */     // No operand predicates
     /* 399270 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399274 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399276 */     // (strict_fmul:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399276 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399279 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399287 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399290 */     GIR_RootConstrainSelectedInstOperands,
     /* 399291 */     // GIR_Coverage, 13532,
     /* 399291 */     GIR_EraseRootFromParent_Done,
     /* 399292 */   // Label 7802: @399292
     /* 399292 */   GIM_Try, /*On fail goto*//*Label 7803*/ GIMT_Encode4(399355), // Rule ID 2004 //
     /* 399297 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399300 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399304 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399308 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 399312 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 399316 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399320 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399325 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399329 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399333 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 399337 */     // MIs[2] Operand 1
     /* 399337 */     // No operand predicates
     /* 399337 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399339 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399339 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399342 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399344 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399346 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399350 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399353 */     GIR_RootConstrainSelectedInstOperands,
     /* 399354 */     // GIR_Coverage, 2004,
     /* 399354 */     GIR_EraseRootFromParent_Done,
     /* 399355 */   // Label 7803: @399355
     /* 399355 */   GIM_Try, /*On fail goto*//*Label 7804*/ GIMT_Encode4(399449), // Rule ID 14002 //
     /* 399360 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399364 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399368 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399372 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399377 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399381 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399383 */     // (strict_fmul:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn)  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399383 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399386 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399390 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399395 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399397 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399400 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399404 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399409 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399412 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399416 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399419 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399424 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399429 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399434 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399437 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399439 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399441 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399444 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399447 */     GIR_RootConstrainSelectedInstOperands,
     /* 399448 */     // GIR_Coverage, 14002,
     /* 399448 */     GIR_EraseRootFromParent_Done,
     /* 399449 */   // Label 7804: @399449
     /* 399449 */   GIM_Try, /*On fail goto*//*Label 7805*/ GIMT_Encode4(399543), // Rule ID 6286 //
     /* 399454 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399458 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399462 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399466 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 399470 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399475 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399477 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399477 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399480 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399484 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399489 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399491 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399494 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399498 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399503 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399506 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399510 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 399513 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399518 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399523 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 399528 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i32_indexed),
     /* 399531 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399533 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399535 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399538 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399541 */     GIR_RootConstrainSelectedInstOperands,
     /* 399542 */     // GIR_Coverage, 6286,
     /* 399542 */     GIR_EraseRootFromParent_Done,
     /* 399543 */   // Label 7805: @399543
     /* 399543 */   GIM_Try, /*On fail goto*//*Label 7806*/ GIMT_Encode4(399570), // Rule ID 1322 //
     /* 399548 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399551 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399555 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399559 */     // (strict_fmul:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FMULv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 399559 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f32),
     /* 399564 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399568 */     GIR_RootConstrainSelectedInstOperands,
     /* 399569 */     // GIR_Coverage, 1322,
     /* 399569 */     GIR_Done,
     /* 399570 */   // Label 7806: @399570
     /* 399570 */   GIM_Reject,
     /* 399571 */ // Label 7799: @399571
     /* 399571 */ GIM_Reject,
     /* 399572 */ // Label 7770: @399572
     /* 399572 */ GIM_Try, /*On fail goto*//*Label 7807*/ GIMT_Encode4(399929),
     /* 399577 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399580 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 399583 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399587 */   GIM_Try, /*On fail goto*//*Label 7808*/ GIMT_Encode4(399650), // Rule ID 13537 //
     /* 399592 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399595 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399599 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 399603 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399607 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399611 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399616 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399620 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399624 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399628 */     // MIs[2] Operand 1
     /* 399628 */     // No operand predicates
     /* 399628 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399632 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399634 */     // (strict_fmul:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399639 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399645 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399648 */     GIR_RootConstrainSelectedInstOperands,
     /* 399649 */     // GIR_Coverage, 13537,
     /* 399649 */     GIR_EraseRootFromParent_Done,
     /* 399650 */   // Label 7808: @399650
     /* 399650 */   GIM_Try, /*On fail goto*//*Label 7809*/ GIMT_Encode4(399713), // Rule ID 2009 //
     /* 399655 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399658 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399662 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399666 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 399670 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 399674 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 399678 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399683 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 399687 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399691 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 399695 */     // MIs[2] Operand 1
     /* 399695 */     // No operand predicates
     /* 399695 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 399697 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 399697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399704 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399708 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 399711 */     GIR_RootConstrainSelectedInstOperands,
     /* 399712 */     // GIR_Coverage, 2009,
     /* 399712 */     GIR_EraseRootFromParent_Done,
     /* 399713 */   // Label 7809: @399713
     /* 399713 */   GIM_Try, /*On fail goto*//*Label 7810*/ GIMT_Encode4(399807), // Rule ID 14006 //
     /* 399718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399730 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399735 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399739 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399741 */     // (strict_fmul:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn)  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399741 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399744 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399748 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399753 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399755 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399758 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399762 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399767 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399770 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399774 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399777 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399782 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399787 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399792 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399795 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399797 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 399799 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399802 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399805 */     GIR_RootConstrainSelectedInstOperands,
     /* 399806 */     // GIR_Coverage, 14006,
     /* 399806 */     GIR_EraseRootFromParent_Done,
     /* 399807 */   // Label 7810: @399807
     /* 399807 */   GIM_Try, /*On fail goto*//*Label 7811*/ GIMT_Encode4(399901), // Rule ID 6290 //
     /* 399812 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399816 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 399820 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 399824 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 399828 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 399835 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rm))  =>  (FMULv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 399835 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 399838 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 399842 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399847 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 399849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 399852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 399856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 399861 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 399864 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 399868 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 399871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399881 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399886 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv2i64_indexed),
     /* 399889 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 399891 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 399893 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 399896 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 399899 */     GIR_RootConstrainSelectedInstOperands,
     /* 399900 */     // GIR_Coverage, 6290,
     /* 399900 */     GIR_EraseRootFromParent_Done,
     /* 399901 */   // Label 7811: @399901
     /* 399901 */   GIM_Try, /*On fail goto*//*Label 7812*/ GIMT_Encode4(399928), // Rule ID 1326 //
     /* 399906 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 399909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 399917 */     // (strict_fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FMULv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 399917 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv2f64),
     /* 399922 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 399926 */     GIR_RootConstrainSelectedInstOperands,
     /* 399927 */     // GIR_Coverage, 1326,
     /* 399927 */     GIR_Done,
     /* 399928 */   // Label 7812: @399928
     /* 399928 */   GIM_Reject,
     /* 399929 */ // Label 7807: @399929
     /* 399929 */ GIM_Reject,
     /* 399930 */ // Label 7771: @399930
     /* 399930 */ GIM_Try, /*On fail goto*//*Label 7813*/ GIMT_Encode4(400271),
     /* 399935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 399938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 399941 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 399945 */   GIM_Try, /*On fail goto*//*Label 7814*/ GIMT_Encode4(400031), // Rule ID 13525 //
     /* 399950 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 399953 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 399957 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 399961 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399965 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 399969 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 399973 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 399977 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 399981 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 399986 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 399990 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 399994 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 399998 */     // MIs[3] Operand 1
     /* 399998 */     // No operand predicates
     /* 399998 */     // MIs[1] Operand 2
     /* 399998 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400009 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400013 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400015 */     // (strict_fmul:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400020 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400022 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400026 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400029 */     GIR_RootConstrainSelectedInstOperands,
     /* 400030 */     // GIR_Coverage, 13525,
     /* 400030 */     GIR_EraseRootFromParent_Done,
     /* 400031 */   // Label 7814: @400031
     /* 400031 */   GIM_Try, /*On fail goto*//*Label 7815*/ GIMT_Encode4(400117), // Rule ID 1997 //
     /* 400036 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400039 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400043 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400047 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 400051 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400055 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 400059 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400063 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400067 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 400071 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400076 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 400080 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400084 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400088 */     // MIs[3] Operand 1
     /* 400088 */     // No operand predicates
     /* 400088 */     // MIs[1] Operand 2
     /* 400088 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 400099 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 400101 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (extract_subvector:{ *:[v4f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400106 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400108 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 400112 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 400115 */     GIR_RootConstrainSelectedInstOperands,
     /* 400116 */     // GIR_Coverage, 1997,
     /* 400116 */     GIR_EraseRootFromParent_Done,
     /* 400117 */   // Label 7815: @400117
     /* 400117 */   GIM_Try, /*On fail goto*//*Label 7816*/ GIMT_Encode4(400180), // Rule ID 13526 //
     /* 400122 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400125 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400129 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400133 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400137 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400141 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400146 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400150 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400154 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400158 */     // MIs[2] Operand 1
     /* 400158 */     // No operand predicates
     /* 400158 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400164 */     // (strict_fmul:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn)  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400169 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400171 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400175 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400178 */     GIR_RootConstrainSelectedInstOperands,
     /* 400179 */     // GIR_Coverage, 13526,
     /* 400179 */     GIR_EraseRootFromParent_Done,
     /* 400180 */   // Label 7816: @400180
     /* 400180 */   GIM_Try, /*On fail goto*//*Label 7817*/ GIMT_Encode4(400243), // Rule ID 1998 //
     /* 400185 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400188 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400192 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400196 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400200 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400204 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400208 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400213 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400217 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400221 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400225 */     // MIs[2] Operand 1
     /* 400225 */     // No operand predicates
     /* 400225 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400227 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400227 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i16_indexed),
     /* 400230 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400232 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400234 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400238 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400241 */     GIR_RootConstrainSelectedInstOperands,
     /* 400242 */     // GIR_Coverage, 1998,
     /* 400242 */     GIR_EraseRootFromParent_Done,
     /* 400243 */   // Label 7817: @400243
     /* 400243 */   GIM_Try, /*On fail goto*//*Label 7818*/ GIMT_Encode4(400270), // Rule ID 1318 //
     /* 400248 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400251 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400255 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400259 */     // (strict_fmul:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FMULv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 400259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f16),
     /* 400264 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400268 */     GIR_RootConstrainSelectedInstOperands,
     /* 400269 */     // GIR_Coverage, 1318,
     /* 400269 */     GIR_Done,
     /* 400270 */   // Label 7818: @400270
     /* 400270 */   GIM_Reject,
     /* 400271 */ // Label 7813: @400271
     /* 400271 */ GIM_Reject,
     /* 400272 */ // Label 7772: @400272
     /* 400272 */ GIM_Try, /*On fail goto*//*Label 7819*/ GIMT_Encode4(400629),
     /* 400277 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400280 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 400283 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400287 */   GIM_Try, /*On fail goto*//*Label 7820*/ GIMT_Encode4(400350), // Rule ID 13535 //
     /* 400292 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400295 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400299 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400303 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400307 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400311 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400316 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400320 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400324 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400328 */     // MIs[2] Operand 1
     /* 400328 */     // No operand predicates
     /* 400328 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400332 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400334 */     // (strict_fmul:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400334 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400337 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400339 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400341 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400345 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400348 */     GIR_RootConstrainSelectedInstOperands,
     /* 400349 */     // GIR_Coverage, 13535,
     /* 400349 */     GIR_EraseRootFromParent_Done,
     /* 400350 */   // Label 7820: @400350
     /* 400350 */   GIM_Try, /*On fail goto*//*Label 7821*/ GIMT_Encode4(400413), // Rule ID 2007 //
     /* 400355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400358 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400362 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400366 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 400370 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 400374 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400378 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400383 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400387 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400391 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 400395 */     // MIs[2] Operand 1
     /* 400395 */     // No operand predicates
     /* 400395 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400397 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400397 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400400 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400402 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400404 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400408 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400411 */     GIR_RootConstrainSelectedInstOperands,
     /* 400412 */     // GIR_Coverage, 2007,
     /* 400412 */     GIR_EraseRootFromParent_Done,
     /* 400413 */   // Label 7821: @400413
     /* 400413 */   GIM_Try, /*On fail goto*//*Label 7822*/ GIMT_Encode4(400507), // Rule ID 14004 //
     /* 400418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400430 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400435 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400439 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400441 */     // (strict_fmul:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn)  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400441 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400444 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400448 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400453 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400455 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400458 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400462 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400467 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400470 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400474 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400477 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400482 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400487 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400492 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400495 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400497 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400499 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400502 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400505 */     GIR_RootConstrainSelectedInstOperands,
     /* 400506 */     // GIR_Coverage, 14004,
     /* 400506 */     GIR_EraseRootFromParent_Done,
     /* 400507 */   // Label 7822: @400507
     /* 400507 */   GIM_Try, /*On fail goto*//*Label 7823*/ GIMT_Encode4(400601), // Rule ID 6288 //
     /* 400512 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 400524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 400528 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 400535 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rm))  =>  (FMULv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 400535 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 400538 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 400542 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400547 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 400549 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 400552 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 400556 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400561 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 400564 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400568 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 400571 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400576 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400581 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 400586 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv4i32_indexed),
     /* 400589 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400591 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 400596 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 400599 */     GIR_RootConstrainSelectedInstOperands,
     /* 400600 */     // GIR_Coverage, 6288,
     /* 400600 */     GIR_EraseRootFromParent_Done,
     /* 400601 */   // Label 7823: @400601
     /* 400601 */   GIM_Try, /*On fail goto*//*Label 7824*/ GIMT_Encode4(400628), // Rule ID 1324 //
     /* 400606 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 400609 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400613 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400617 */     // (strict_fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FMULv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 400617 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400622 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400626 */     GIR_RootConstrainSelectedInstOperands,
     /* 400627 */     // GIR_Coverage, 1324,
     /* 400627 */     GIR_Done,
     /* 400628 */   // Label 7824: @400628
     /* 400628 */   GIM_Reject,
     /* 400629 */ // Label 7819: @400629
     /* 400629 */ GIM_Reject,
     /* 400630 */ // Label 7773: @400630
     /* 400630 */ GIM_Try, /*On fail goto*//*Label 7825*/ GIMT_Encode4(401061),
     /* 400635 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400638 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 400641 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400645 */   GIM_Try, /*On fail goto*//*Label 7826*/ GIMT_Encode4(400708), // Rule ID 13529 //
     /* 400650 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400653 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 400657 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400661 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400665 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400669 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400674 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400678 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400682 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400686 */     // MIs[2] Operand 1
     /* 400686 */     // No operand predicates
     /* 400686 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400690 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400692 */     // (strict_fmul:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn)  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400692 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400695 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400697 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 400699 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400703 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400706 */     GIR_RootConstrainSelectedInstOperands,
     /* 400707 */     // GIR_Coverage, 13529,
     /* 400707 */     GIR_EraseRootFromParent_Done,
     /* 400708 */   // Label 7826: @400708
     /* 400708 */   GIM_Try, /*On fail goto*//*Label 7827*/ GIMT_Encode4(400771), // Rule ID 2001 //
     /* 400713 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400716 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 400724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 400728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 400732 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 400736 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 400741 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 400745 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 400749 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 400753 */     // MIs[2] Operand 1
     /* 400753 */     // No operand predicates
     /* 400753 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 400755 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (FMULv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 400755 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMULv8i16_indexed),
     /* 400758 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 400760 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 400762 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 400766 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 400769 */     GIR_RootConstrainSelectedInstOperands,
     /* 400770 */     // GIR_Coverage, 2001,
     /* 400770 */     GIR_EraseRootFromParent_Done,
     /* 400771 */   // Label 7827: @400771
     /* 400771 */   GIM_Try, /*On fail goto*//*Label 7828*/ GIMT_Encode4(400798), // Rule ID 1320 //
     /* 400776 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 400779 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400783 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400787 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FMULv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 400787 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMULv8f16),
     /* 400792 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 400796 */     GIR_RootConstrainSelectedInstOperands,
     /* 400797 */     // GIR_Coverage, 1320,
     /* 400797 */     GIR_Done,
     /* 400798 */   // Label 7828: @400798
     /* 400798 */   GIM_Try, /*On fail goto*//*Label 7829*/ GIMT_Encode4(401060), // Rule ID 7045 //
     /* 400803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 400806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400814 */     // (strict_fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FMULv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FMULv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 400814 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 400817 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400821 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400826 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 400830 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 400832 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 400835 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 400839 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400844 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 400848 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 400850 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 400853 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400857 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400862 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 400865 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 400868 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 400870 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 400873 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400877 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400882 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 400888 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400893 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400898 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 400901 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400905 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400910 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 400913 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 400915 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 400918 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 400922 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400927 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 400933 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 400938 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 400943 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 400946 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 400950 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400955 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 400958 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 400960 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 400963 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FMULv4f32),
     /* 400967 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400972 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 400975 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 400978 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 400980 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 400983 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 400987 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 400992 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 400995 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 400997 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 401000 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401004 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401009 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401011 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401014 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401018 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401023 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401026 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 401029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401032 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 401050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401055 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 401058 */     GIR_RootConstrainSelectedInstOperands,
     /* 401059 */     // GIR_Coverage, 7045,
     /* 401059 */     GIR_EraseRootFromParent_Done,
     /* 401060 */   // Label 7829: @401060
     /* 401060 */   GIM_Reject,
     /* 401061 */ // Label 7825: @401061
     /* 401061 */ GIM_Reject,
     /* 401062 */ // Label 7774: @401062
     /* 401062 */ GIM_Reject,
     /* 401063 */ // Label 106: @401063
     /* 401063 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7838*/ GIMT_Encode4(401678),
     /* 401074 */ /*GILLT_s16*//*Label 7830*/ GIMT_Encode4(401114),
     /* 401078 */ /*GILLT_s32*//*Label 7831*/ GIMT_Encode4(401152),
     /* 401082 */ /*GILLT_s64*//*Label 7832*/ GIMT_Encode4(401190), GIMT_Encode4(0),
     /* 401090 */ /*GILLT_v2s32*//*Label 7833*/ GIMT_Encode4(401228),
     /* 401094 */ /*GILLT_v2s64*//*Label 7834*/ GIMT_Encode4(401266),
     /* 401098 */ /*GILLT_v4s16*//*Label 7835*/ GIMT_Encode4(401304),
     /* 401102 */ /*GILLT_v4s32*//*Label 7836*/ GIMT_Encode4(401342), GIMT_Encode4(0),
     /* 401110 */ /*GILLT_v8s16*//*Label 7837*/ GIMT_Encode4(401380),
     /* 401114 */ // Label 7830: @401114
     /* 401114 */ GIM_Try, /*On fail goto*//*Label 7839*/ GIMT_Encode4(401151), // Rule ID 589 //
     /* 401119 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401122 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401125 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 401128 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401132 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401136 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401140 */   // (strict_fdiv:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)  =>  (FDIVHrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm)
     /* 401140 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVHrr),
     /* 401145 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401149 */   GIR_RootConstrainSelectedInstOperands,
     /* 401150 */   // GIR_Coverage, 589,
     /* 401150 */   GIR_Done,
     /* 401151 */ // Label 7839: @401151
     /* 401151 */ GIM_Reject,
     /* 401152 */ // Label 7831: @401152
     /* 401152 */ GIM_Try, /*On fail goto*//*Label 7840*/ GIMT_Encode4(401189), // Rule ID 591 //
     /* 401157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 401160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 401163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 401166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401170 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401174 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 401178 */   // (strict_fdiv:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FDIVSrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 401178 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVSrr),
     /* 401183 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401187 */   GIR_RootConstrainSelectedInstOperands,
     /* 401188 */   // GIR_Coverage, 591,
     /* 401188 */   GIR_Done,
     /* 401189 */ // Label 7840: @401189
     /* 401189 */ GIM_Reject,
     /* 401190 */ // Label 7832: @401190
     /* 401190 */ GIM_Try, /*On fail goto*//*Label 7841*/ GIMT_Encode4(401227), // Rule ID 593 //
     /* 401195 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 401198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 401201 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 401204 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401208 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401212 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401216 */   // (strict_fdiv:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FDIVDrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 401216 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVDrr),
     /* 401221 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401225 */   GIR_RootConstrainSelectedInstOperands,
     /* 401226 */   // GIR_Coverage, 593,
     /* 401226 */   GIR_Done,
     /* 401227 */ // Label 7841: @401227
     /* 401227 */ GIM_Reject,
     /* 401228 */ // Label 7833: @401228
     /* 401228 */ GIM_Try, /*On fail goto*//*Label 7842*/ GIMT_Encode4(401265), // Rule ID 1227 //
     /* 401233 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401236 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 401239 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 401242 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401246 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401250 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401254 */   // (strict_fdiv:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FDIVv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 401254 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f32),
     /* 401259 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401263 */   GIR_RootConstrainSelectedInstOperands,
     /* 401264 */   // GIR_Coverage, 1227,
     /* 401264 */   GIR_Done,
     /* 401265 */ // Label 7842: @401265
     /* 401265 */ GIM_Reject,
     /* 401266 */ // Label 7834: @401266
     /* 401266 */ GIM_Try, /*On fail goto*//*Label 7843*/ GIMT_Encode4(401303), // Rule ID 1231 //
     /* 401271 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 401277 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 401280 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401284 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401288 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401292 */   // (strict_fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FDIVv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 401292 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv2f64),
     /* 401297 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401301 */   GIR_RootConstrainSelectedInstOperands,
     /* 401302 */   // GIR_Coverage, 1231,
     /* 401302 */   GIR_Done,
     /* 401303 */ // Label 7843: @401303
     /* 401303 */ GIM_Reject,
     /* 401304 */ // Label 7835: @401304
     /* 401304 */ GIM_Try, /*On fail goto*//*Label 7844*/ GIMT_Encode4(401341), // Rule ID 1223 //
     /* 401309 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401312 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 401315 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 401318 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401322 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401326 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401330 */   // (strict_fdiv:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FDIVv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 401330 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f16),
     /* 401335 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401339 */   GIR_RootConstrainSelectedInstOperands,
     /* 401340 */   // GIR_Coverage, 1223,
     /* 401340 */   GIR_Done,
     /* 401341 */ // Label 7844: @401341
     /* 401341 */ GIM_Reject,
     /* 401342 */ // Label 7836: @401342
     /* 401342 */ GIM_Try, /*On fail goto*//*Label 7845*/ GIMT_Encode4(401379), // Rule ID 1229 //
     /* 401347 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 401350 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 401353 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 401356 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401360 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401364 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401368 */   // (strict_fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FDIVv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 401368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401373 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401377 */   GIR_RootConstrainSelectedInstOperands,
     /* 401378 */   // GIR_Coverage, 1229,
     /* 401378 */   GIR_Done,
     /* 401379 */ // Label 7845: @401379
     /* 401379 */ GIM_Reject,
     /* 401380 */ // Label 7837: @401380
     /* 401380 */ GIM_Try, /*On fail goto*//*Label 7846*/ GIMT_Encode4(401677),
     /* 401385 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401388 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 401391 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401395 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401399 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401403 */   GIM_Try, /*On fail goto*//*Label 7847*/ GIMT_Encode4(401422), // Rule ID 1225 //
     /* 401408 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 401411 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FDIVv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 401411 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FDIVv8f16),
     /* 401416 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 401420 */     GIR_RootConstrainSelectedInstOperands,
     /* 401421 */     // GIR_Coverage, 1225,
     /* 401421 */     GIR_Done,
     /* 401422 */   // Label 7847: @401422
     /* 401422 */   GIM_Try, /*On fail goto*//*Label 7848*/ GIMT_Encode4(401676), // Rule ID 7043 //
     /* 401427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNoFullFP16),
     /* 401430 */     // (strict_fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCVTNv8i16:{ *:[v8f16] } (INSERT_SUBREG:{ *:[f128] } (IMPLICIT_DEF:{ *:[f128] }), (FCVTNv4i16:{ *:[v4f16] } (FDIVv4f32:{ *:[v4f32] } (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rn, dsub:{ *:[i32] })), (FCVTLv4i16:{ *:[v4f32] } (EXTRACT_SUBREG:{ *:[v4i16] } V128:{ *:[v8f16] }:$Rm, dsub:{ *:[i32] })))), dsub:{ *:[i32] }), (FDIVv4f32:{ *:[v4f32] } (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rn), (FCVTLv8i16:{ *:[v4f32] } V128:{ *:[v8f16] }:$Rm)))
     /* 401430 */     GIR_MakeTempReg, /*TempRegID*/10, /*TypeID*/GILLT_v4s32,
     /* 401433 */     GIR_BuildMI, /*InsnID*/11, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401437 */     GIR_AddTempRegister, /*InsnID*/11, /*TempRegID*/10, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401442 */     GIR_Copy, /*NewInsnID*/11, /*OldInsnID*/0, /*OpIdx*/2, // Rm
     /* 401446 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/11,
     /* 401448 */     GIR_MakeTempReg, /*TempRegID*/9, /*TypeID*/GILLT_v4s32,
     /* 401451 */     GIR_BuildMI, /*InsnID*/10, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv8i16),
     /* 401455 */     GIR_AddTempRegister, /*InsnID*/10, /*TempRegID*/9, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401460 */     GIR_Copy, /*NewInsnID*/10, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 401464 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/10,
     /* 401466 */     GIR_MakeTempReg, /*TempRegID*/8, /*TypeID*/GILLT_v4s32,
     /* 401469 */     GIR_BuildMI, /*InsnID*/9, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401473 */     GIR_AddTempRegister, /*InsnID*/9, /*TempRegID*/8, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401478 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/9,
     /* 401481 */     GIR_AddSimpleTempRegister, /*InsnID*/9, /*TempRegID*/10,
     /* 401484 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/9,
     /* 401486 */     GIR_MakeTempReg, /*TempRegID*/7, /*TypeID*/GILLT_v4s16,
     /* 401489 */     GIR_BuildMI, /*InsnID*/8, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401493 */     GIR_AddTempRegister, /*InsnID*/8, /*TempRegID*/7, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401498 */     GIR_CopySubReg, /*NewInsnID*/8, /*OldInsnID*/0, /*OpIdx*/2, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 401504 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401509 */     GIR_ConstrainOperandRC, /*InsnID*/8, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401514 */     GIR_MakeTempReg, /*TempRegID*/6, /*TypeID*/GILLT_v4s32,
     /* 401517 */     GIR_BuildMI, /*InsnID*/7, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401521 */     GIR_AddTempRegister, /*InsnID*/7, /*TempRegID*/6, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401526 */     GIR_AddSimpleTempRegister, /*InsnID*/7, /*TempRegID*/7,
     /* 401529 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/7,
     /* 401531 */     GIR_MakeTempReg, /*TempRegID*/5, /*TypeID*/GILLT_v4s16,
     /* 401534 */     GIR_BuildMI, /*InsnID*/6, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401538 */     GIR_AddTempRegister, /*InsnID*/6, /*TempRegID*/5, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401543 */     GIR_CopySubReg, /*NewInsnID*/6, /*OldInsnID*/0, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 401549 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401554 */     GIR_ConstrainOperandRC, /*InsnID*/6, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401559 */     GIR_MakeTempReg, /*TempRegID*/4, /*TypeID*/GILLT_v4s32,
     /* 401562 */     GIR_BuildMI, /*InsnID*/5, /*Opcode*/GIMT_Encode2(AArch64::FCVTLv4i16),
     /* 401566 */     GIR_AddTempRegister, /*InsnID*/5, /*TempRegID*/4, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401571 */     GIR_AddSimpleTempRegister, /*InsnID*/5, /*TempRegID*/5,
     /* 401574 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/5,
     /* 401576 */     GIR_MakeTempReg, /*TempRegID*/3, /*TypeID*/GILLT_v4s32,
     /* 401579 */     GIR_BuildMI, /*InsnID*/4, /*Opcode*/GIMT_Encode2(AArch64::FDIVv4f32),
     /* 401583 */     GIR_AddTempRegister, /*InsnID*/4, /*TempRegID*/3, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401588 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/4,
     /* 401591 */     GIR_AddSimpleTempRegister, /*InsnID*/4, /*TempRegID*/6,
     /* 401594 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/4,
     /* 401596 */     GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_v4s16,
     /* 401599 */     GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv4i16),
     /* 401603 */     GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401608 */     GIR_AddSimpleTempRegister, /*InsnID*/3, /*TempRegID*/3,
     /* 401611 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 401613 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 401616 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 401620 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401625 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 401627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 401630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 401634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401639 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 401642 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/2,
     /* 401645 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 401648 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401653 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401658 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 401663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCVTNv8i16),
     /* 401666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 401668 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401671 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/8,
     /* 401674 */     GIR_RootConstrainSelectedInstOperands,
     /* 401675 */     // GIR_Coverage, 7043,
     /* 401675 */     GIR_EraseRootFromParent_Done,
     /* 401676 */   // Label 7848: @401676
     /* 401676 */   GIM_Reject,
     /* 401677 */ // Label 7846: @401677
     /* 401677 */ GIM_Reject,
     /* 401678 */ // Label 7838: @401678
     /* 401678 */ GIM_Reject,
     /* 401679 */ // Label 107: @401679
     /* 401679 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 7857*/ GIMT_Encode4(417285),
     /* 401690 */ /*GILLT_s16*//*Label 7849*/ GIMT_Encode4(401730),
     /* 401694 */ /*GILLT_s32*//*Label 7850*/ GIMT_Encode4(404504),
     /* 401698 */ /*GILLT_s64*//*Label 7851*/ GIMT_Encode4(407434), GIMT_Encode4(0),
     /* 401706 */ /*GILLT_v2s32*//*Label 7852*/ GIMT_Encode4(410364),
     /* 401710 */ /*GILLT_v2s64*//*Label 7853*/ GIMT_Encode4(411885),
     /* 401714 */ /*GILLT_v4s16*//*Label 7854*/ GIMT_Encode4(413406),
     /* 401718 */ /*GILLT_v4s32*//*Label 7855*/ GIMT_Encode4(414585), GIMT_Encode4(0),
     /* 401726 */ /*GILLT_v8s16*//*Label 7856*/ GIMT_Encode4(416106),
     /* 401730 */ // Label 7849: @401730
     /* 401730 */ GIM_Try, /*On fail goto*//*Label 7858*/ GIMT_Encode4(404503),
     /* 401735 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 401738 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s16,
     /* 401741 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s16,
     /* 401744 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401748 */   GIM_Try, /*On fail goto*//*Label 7859*/ GIMT_Encode4(401898), // Rule ID 4899 //
     /* 401753 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401756 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401760 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401764 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401768 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401772 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401777 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401781 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401785 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401789 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401793 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 401797 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401802 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 401806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 401810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401814 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 401818 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401825 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401837 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 401856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401865 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 401871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 401884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 401886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 401889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 401892 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 401896 */     GIR_RootConstrainSelectedInstOperands,
     /* 401897 */     // GIR_Coverage, 4899,
     /* 401897 */     GIR_EraseRootFromParent_Done,
     /* 401898 */   // Label 7859: @401898
     /* 401898 */   GIM_Try, /*On fail goto*//*Label 7860*/ GIMT_Encode4(402045), // Rule ID 4863 //
     /* 401903 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 401906 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 401910 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401914 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401918 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 401922 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401927 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 401931 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 401935 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 401939 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 401943 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 401947 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 401951 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 401955 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 401959 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 401964 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 401968 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401972 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 401974 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 401974 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 401977 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 401981 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 401986 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 401992 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 401997 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402002 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402005 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402009 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402014 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402020 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402025 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402030 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402033 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402035 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402038 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402041 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402043 */     GIR_RootConstrainSelectedInstOperands,
     /* 402044 */     // GIR_Coverage, 4863,
     /* 402044 */     GIR_EraseRootFromParent_Done,
     /* 402045 */   // Label 7860: @402045
     /* 402045 */   GIM_Try, /*On fail goto*//*Label 7861*/ GIMT_Encode4(402192), // Rule ID 13943 //
     /* 402050 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402053 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402057 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402061 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402065 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402069 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402073 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402077 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402081 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402086 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402090 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402094 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402098 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402102 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402106 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402111 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 402115 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402119 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402121 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402121 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402124 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402128 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402133 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402139 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402144 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402149 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402152 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402156 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402161 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402167 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402172 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402177 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 402180 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402182 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402185 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402190 */     GIR_RootConstrainSelectedInstOperands,
     /* 402191 */     // GIR_Coverage, 13943,
     /* 402191 */     GIR_EraseRootFromParent_Done,
     /* 402192 */   // Label 7861: @402192
     /* 402192 */   GIM_Try, /*On fail goto*//*Label 7862*/ GIMT_Encode4(402323), // Rule ID 6118 //
     /* 402197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402208 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402212 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402216 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402221 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402225 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402229 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402233 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 402237 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 402241 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402245 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402249 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402253 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402258 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 402262 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402266 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402270 */     // MIs[4] Operand 1
     /* 402270 */     // No operand predicates
     /* 402270 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402274 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402276 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402276 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402279 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402283 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402288 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402311 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402314 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 402318 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 402321 */     GIR_RootConstrainSelectedInstOperands,
     /* 402322 */     // GIR_Coverage, 6118,
     /* 402322 */     GIR_EraseRootFromParent_Done,
     /* 402323 */   // Label 7862: @402323
     /* 402323 */   GIM_Try, /*On fail goto*//*Label 7863*/ GIMT_Encode4(402454), // Rule ID 6150 //
     /* 402328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402343 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402347 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402352 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 402356 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402360 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402364 */     // MIs[2] Operand 1
     /* 402364 */     // No operand predicates
     /* 402364 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402368 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402372 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 402376 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 402380 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402384 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402388 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 402392 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402397 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 402401 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402405 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402407 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402407 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402410 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402414 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402419 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402430 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402435 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402438 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402440 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402442 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 402449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 402452 */     GIR_RootConstrainSelectedInstOperands,
     /* 402453 */     // GIR_Coverage, 6150,
     /* 402453 */     GIR_EraseRootFromParent_Done,
     /* 402454 */   // Label 7863: @402454
     /* 402454 */   GIM_Try, /*On fail goto*//*Label 7864*/ GIMT_Encode4(402585), // Rule ID 6214 //
     /* 402459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402474 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402478 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402482 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402486 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402495 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402499 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 402503 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402507 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402511 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 402515 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402520 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 402524 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402528 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402532 */     // MIs[4] Operand 1
     /* 402532 */     // No operand predicates
     /* 402532 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402536 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402538 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402538 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402541 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402545 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402550 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402556 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402561 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402566 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402569 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402571 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402573 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402576 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 402580 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 402583 */     GIR_RootConstrainSelectedInstOperands,
     /* 402584 */     // GIR_Coverage, 6214,
     /* 402584 */     GIR_EraseRootFromParent_Done,
     /* 402585 */   // Label 7864: @402585
     /* 402585 */   GIM_Try, /*On fail goto*//*Label 7865*/ GIMT_Encode4(402716), // Rule ID 6182 //
     /* 402590 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402593 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402597 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 402601 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 402605 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 402609 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402613 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402617 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402621 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402626 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402630 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402634 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402638 */     // MIs[3] Operand 1
     /* 402638 */     // No operand predicates
     /* 402638 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 402642 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402646 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402650 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 402654 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402659 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 402663 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402667 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 402669 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402669 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402672 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402676 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402681 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402687 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402692 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402697 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 402700 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402702 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402704 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402711 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402714 */     GIR_RootConstrainSelectedInstOperands,
     /* 402715 */     // GIR_Coverage, 6182,
     /* 402715 */     GIR_EraseRootFromParent_Done,
     /* 402716 */   // Label 7865: @402716
     /* 402716 */   GIM_Try, /*On fail goto*//*Label 7866*/ GIMT_Encode4(402851), // Rule ID 2458 //
     /* 402721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 402724 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402728 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402732 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402736 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402745 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402749 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402753 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402757 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402761 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402765 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402770 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 402774 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402778 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 402780 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 402780 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s16,
     /* 402783 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402787 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402792 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 402798 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402803 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402808 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402811 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402815 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402820 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402826 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402831 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402836 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 402839 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 402841 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402844 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 402847 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 402849 */     GIR_RootConstrainSelectedInstOperands,
     /* 402850 */     // GIR_Coverage, 2458,
     /* 402850 */     GIR_EraseRootFromParent_Done,
     /* 402851 */   // Label 7866: @402851
     /* 402851 */   GIM_Try, /*On fail goto*//*Label 7867*/ GIMT_Encode4(402970), // Rule ID 6086 //
     /* 402856 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402859 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402863 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402867 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402871 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402875 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402880 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 402884 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 402888 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402892 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402896 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 402900 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402905 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 402909 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 402913 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 402917 */     // MIs[3] Operand 1
     /* 402917 */     // No operand predicates
     /* 402917 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402921 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 402923 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 402923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 402926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 402930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 402935 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 402941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 402946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 402951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 402954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 402956 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 402958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 402961 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 402965 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 402968 */     GIR_RootConstrainSelectedInstOperands,
     /* 402969 */     // GIR_Coverage, 6086,
     /* 402969 */     GIR_EraseRootFromParent_Done,
     /* 402970 */   // Label 7867: @402970
     /* 402970 */   GIM_Try, /*On fail goto*//*Label 7868*/ GIMT_Encode4(403089), // Rule ID 2533 //
     /* 402975 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 402978 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 402982 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 402986 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 402990 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 402994 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 402999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403007 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403011 */     // MIs[2] Operand 1
     /* 403011 */     // No operand predicates
     /* 403011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 403027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403032 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 403036 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403040 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403042 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (vector_extract:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403042 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403045 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403049 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403054 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 403073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403077 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403087 */     GIR_RootConstrainSelectedInstOperands,
     /* 403088 */     // GIR_Coverage, 2533,
     /* 403088 */     GIR_EraseRootFromParent_Done,
     /* 403089 */   // Label 7868: @403089
     /* 403089 */   GIM_Try, /*On fail goto*//*Label 7869*/ GIMT_Encode4(403189), // Rule ID 4861 //
     /* 403094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403118 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403122 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403126 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403130 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403134 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403139 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403143 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403145 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403145 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403148 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403152 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403157 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403163 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403173 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403176 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403187 */     GIR_RootConstrainSelectedInstOperands,
     /* 403188 */     // GIR_Coverage, 4861,
     /* 403188 */     GIR_EraseRootFromParent_Done,
     /* 403189 */   // Label 7869: @403189
     /* 403189 */   GIM_Try, /*On fail goto*//*Label 7870*/ GIMT_Encode4(403289), // Rule ID 4897 //
     /* 403194 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403197 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403201 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403205 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403209 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403213 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403218 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403222 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403226 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 403230 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403234 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403238 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403245 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403257 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403263 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403268 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403273 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403276 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403278 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403281 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 403283 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 403287 */     GIR_RootConstrainSelectedInstOperands,
     /* 403288 */     // GIR_Coverage, 4897,
     /* 403288 */     GIR_EraseRootFromParent_Done,
     /* 403289 */   // Label 7870: @403289
     /* 403289 */   GIM_Try, /*On fail goto*//*Label 7871*/ GIMT_Encode4(403386), // Rule ID 13939 //
     /* 403294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403330 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403334 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403338 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403342 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403344 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403344 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403347 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403351 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403356 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403362 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403367 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403372 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403375 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403377 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403379 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403382 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403384 */     GIR_RootConstrainSelectedInstOperands,
     /* 403385 */     // GIR_Coverage, 13939,
     /* 403385 */     GIR_EraseRootFromParent_Done,
     /* 403386 */   // Label 7871: @403386
     /* 403386 */   GIM_Try, /*On fail goto*//*Label 7872*/ GIMT_Encode4(403486), // Rule ID 13941 //
     /* 403391 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403394 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403398 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403402 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403406 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403411 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403415 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403419 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403423 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403427 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403432 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403440 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403442 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 403442 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403445 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403449 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403454 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 403460 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403465 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403475 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403478 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403482 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403484 */     GIR_RootConstrainSelectedInstOperands,
     /* 403485 */     // GIR_Coverage, 13941,
     /* 403485 */     GIR_EraseRootFromParent_Done,
     /* 403486 */   // Label 7872: @403486
     /* 403486 */   GIM_Try, /*On fail goto*//*Label 7873*/ GIMT_Encode4(403586), // Rule ID 4895 //
     /* 403491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 403523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 403527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 403535 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403540 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403542 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403542 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403545 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403549 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403554 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403565 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 403573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403575 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403577 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 403584 */     GIR_RootConstrainSelectedInstOperands,
     /* 403585 */     // GIR_Coverage, 4895,
     /* 403585 */     GIR_EraseRootFromParent_Done,
     /* 403586 */   // Label 7873: @403586
     /* 403586 */   GIM_Try, /*On fail goto*//*Label 7874*/ GIMT_Encode4(403683), // Rule ID 4859 //
     /* 403591 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 403594 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403598 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403602 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403606 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403610 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403614 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403618 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403622 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403626 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403631 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 403635 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403639 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 403641 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] })), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 403641 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 403644 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 403648 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 403653 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 403659 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403664 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 403669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 403672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 403674 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 403676 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 403679 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 403681 */     GIR_RootConstrainSelectedInstOperands,
     /* 403682 */     // GIR_Coverage, 4859,
     /* 403682 */     GIR_EraseRootFromParent_Done,
     /* 403683 */   // Label 7874: @403683
     /* 403683 */   GIM_Try, /*On fail goto*//*Label 7875*/ GIMT_Encode4(403767), // Rule ID 6148 //
     /* 403688 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403691 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403695 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403699 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403703 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 403707 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403712 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 403716 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403720 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403724 */     // MIs[2] Operand 1
     /* 403724 */     // No operand predicates
     /* 403724 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 403728 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403732 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s16,
     /* 403736 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403741 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403745 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403747 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403747 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403750 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403752 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403754 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 403758 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 403762 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 403765 */     GIR_RootConstrainSelectedInstOperands,
     /* 403766 */     // GIR_Coverage, 6148,
     /* 403766 */     GIR_EraseRootFromParent_Done,
     /* 403767 */   // Label 7875: @403767
     /* 403767 */   GIM_Try, /*On fail goto*//*Label 7876*/ GIMT_Encode4(403848), // Rule ID 6180 //
     /* 403772 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403779 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403783 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403787 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403791 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403795 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403799 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403803 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403808 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403812 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403816 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403820 */     // MIs[3] Operand 1
     /* 403820 */     // No operand predicates
     /* 403820 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403824 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403830 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403835 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403837 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 403839 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403843 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403846 */     GIR_RootConstrainSelectedInstOperands,
     /* 403847 */     // GIR_Coverage, 6180,
     /* 403847 */     GIR_EraseRootFromParent_Done,
     /* 403848 */   // Label 7876: @403848
     /* 403848 */   GIM_Try, /*On fail goto*//*Label 7877*/ GIMT_Encode4(403932), // Rule ID 6212 //
     /* 403853 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403856 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 403860 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403864 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403868 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403873 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 403877 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403881 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403885 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403889 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403894 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403898 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403902 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403906 */     // MIs[3] Operand 1
     /* 403906 */     // No operand predicates
     /* 403906 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403910 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403912 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rn), (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403912 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403915 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 403917 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 403919 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 403923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 403927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 403930 */     GIR_RootConstrainSelectedInstOperands,
     /* 403931 */     // GIR_Coverage, 6212,
     /* 403931 */     GIR_EraseRootFromParent_Done,
     /* 403932 */   // Label 7877: @403932
     /* 403932 */   GIM_Try, /*On fail goto*//*Label 7878*/ GIMT_Encode4(404013), // Rule ID 6116 //
     /* 403937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 403940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 403948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 403952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 403956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 403960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 403964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 403968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 403972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 403977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 403981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 403985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 403989 */     // MIs[3] Operand 1
     /* 403989 */     // No operand predicates
     /* 403989 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 403993 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 403995 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), FPR16:{ *:[f16] }:$Rd)  =>  (FMLSv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 403995 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i16_indexed),
     /* 403998 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404000 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404002 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404004 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 404008 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 404011 */     GIR_RootConstrainSelectedInstOperands,
     /* 404012 */     // GIR_Coverage, 6116,
     /* 404012 */     GIR_EraseRootFromParent_Done,
     /* 404013 */   // Label 7878: @404013
     /* 404013 */   GIM_Try, /*On fail goto*//*Label 7879*/ GIMT_Encode4(404098), // Rule ID 2456 //
     /* 404018 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404021 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404025 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404029 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404033 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404037 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404042 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404046 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404056 */     // (strict_fma:{ *:[f16] } (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rn, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404056 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404059 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404063 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404068 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rn
     /* 404074 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404079 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404089 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404092 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404094 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404096 */     GIR_RootConstrainSelectedInstOperands,
     /* 404097 */     // GIR_Coverage, 2456,
     /* 404097 */     GIR_EraseRootFromParent_Done,
     /* 404098 */   // Label 7879: @404098
     /* 404098 */   GIM_Try, /*On fail goto*//*Label 7880*/ GIMT_Encode4(404183), // Rule ID 2454 //
     /* 404103 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404106 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404110 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404114 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404118 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404122 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404126 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404131 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404135 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404139 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404141 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (extractelt:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, 0:{ *:[i64] }), FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (EXTRACT_SUBREG:{ *:[f16] } V128:{ *:[v8f16] }:$Rm, hsub:{ *:[i32] }), FPR16:{ *:[f16] }:$Ra)
     /* 404141 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 404144 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404148 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404153 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(9), // Rm
     /* 404159 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404169 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404172 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404174 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404176 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404179 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404181 */     GIR_RootConstrainSelectedInstOperands,
     /* 404182 */     // GIR_Coverage, 2454,
     /* 404182 */     GIR_EraseRootFromParent_Done,
     /* 404183 */   // Label 7880: @404183
     /* 404183 */   GIM_Try, /*On fail goto*//*Label 7881*/ GIMT_Encode4(404252), // Rule ID 2531 //
     /* 404188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404191 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404195 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404199 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404203 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404212 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404216 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404220 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404224 */     // MIs[2] Operand 1
     /* 404224 */     // No operand predicates
     /* 404224 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404228 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404232 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404234 */     // (strict_fma:{ *:[f16] } (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404234 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404237 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404239 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404241 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404243 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404247 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404250 */     GIR_RootConstrainSelectedInstOperands,
     /* 404251 */     // GIR_Coverage, 2531,
     /* 404251 */     GIR_EraseRootFromParent_Done,
     /* 404252 */   // Label 7881: @404252
     /* 404252 */   GIM_Try, /*On fail goto*//*Label 7882*/ GIMT_Encode4(404321), // Rule ID 6084 //
     /* 404257 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 404260 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404264 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404268 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404272 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 404276 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404280 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 404285 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 404289 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 404293 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 404297 */     // MIs[2] Operand 1
     /* 404297 */     // No operand predicates
     /* 404297 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404301 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 404303 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (vector_extract:{ *:[f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), FPR16:{ *:[f16] }:$Rd)  =>  (FMLAv1i16_indexed:{ *:[f16] } FPR16:{ *:[f16] }:$Rd, FPR16:{ *:[f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 404303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i16_indexed),
     /* 404306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 404308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 404310 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404312 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404316 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 404319 */     GIR_RootConstrainSelectedInstOperands,
     /* 404320 */     // GIR_Coverage, 6084,
     /* 404320 */     GIR_EraseRootFromParent_Done,
     /* 404321 */   // Label 7882: @404321
     /* 404321 */   GIM_Try, /*On fail goto*//*Label 7883*/ GIMT_Encode4(404371), // Rule ID 13375 //
     /* 404326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404329 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404333 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404337 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404341 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404346 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404356 */     // (strict_fma:{ *:[f16] } (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404361 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 404363 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404367 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404369 */     GIR_RootConstrainSelectedInstOperands,
     /* 404370 */     // GIR_Coverage, 13375,
     /* 404370 */     GIR_EraseRootFromParent_Done,
     /* 404371 */   // Label 7883: @404371
     /* 404371 */   GIM_Try, /*On fail goto*//*Label 7884*/ GIMT_Encode4(404421), // Rule ID 643 //
     /* 404376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404383 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 404387 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404391 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404395 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404400 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404404 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404406 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Rm), FPR16:{ *:[f16] }:$Ra)  =>  (FMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404406 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBHrrr),
     /* 404409 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404411 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404413 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 404417 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404419 */     GIR_RootConstrainSelectedInstOperands,
     /* 404420 */     // GIR_Coverage, 643,
     /* 404420 */     GIR_EraseRootFromParent_Done,
     /* 404421 */   // Label 7884: @404421
     /* 404421 */   GIM_Try, /*On fail goto*//*Label 7885*/ GIMT_Encode4(404471), // Rule ID 655 //
     /* 404426 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404429 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404433 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404437 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 404441 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404445 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 404449 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404454 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 404456 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, (fneg:{ *:[f16] } FPR16:{ *:[f16] }:$Ra))  =>  (FNMSUBHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404456 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBHrrr),
     /* 404459 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404461 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 404463 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 404465 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 404469 */     GIR_RootConstrainSelectedInstOperands,
     /* 404470 */     // GIR_Coverage, 655,
     /* 404470 */     GIR_EraseRootFromParent_Done,
     /* 404471 */   // Label 7885: @404471
     /* 404471 */   GIM_Try, /*On fail goto*//*Label 7886*/ GIMT_Encode4(404502), // Rule ID 637 //
     /* 404476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 404479 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404483 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404487 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 404491 */     // (strict_fma:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)  =>  (FMADDHrrr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn, FPR16:{ *:[f16] }:$Rm, FPR16:{ *:[f16] }:$Ra)
     /* 404491 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDHrrr),
     /* 404496 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 404500 */     GIR_RootConstrainSelectedInstOperands,
     /* 404501 */     // GIR_Coverage, 637,
     /* 404501 */     GIR_Done,
     /* 404502 */   // Label 7886: @404502
     /* 404502 */   GIM_Reject,
     /* 404503 */ // Label 7858: @404503
     /* 404503 */ GIM_Reject,
     /* 404504 */ // Label 7850: @404504
     /* 404504 */ GIM_Try, /*On fail goto*//*Label 7887*/ GIMT_Encode4(407433),
     /* 404509 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 404512 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 404515 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s32,
     /* 404518 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404522 */   GIM_Try, /*On fail goto*//*Label 7888*/ GIMT_Encode4(404672), // Rule ID 4905 //
     /* 404527 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404530 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404534 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404538 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404542 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404546 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404551 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404555 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404559 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404563 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404567 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404571 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404576 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404580 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 404584 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404588 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 404592 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404599 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404599 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404602 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404606 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404611 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404617 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404622 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 404658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404660 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404663 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404666 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 404670 */     GIR_RootConstrainSelectedInstOperands,
     /* 404671 */     // GIR_Coverage, 4905,
     /* 404671 */     GIR_EraseRootFromParent_Done,
     /* 404672 */   // Label 7888: @404672
     /* 404672 */   GIM_Try, /*On fail goto*//*Label 7889*/ GIMT_Encode4(404819), // Rule ID 4869 //
     /* 404677 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404680 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404684 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404688 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404692 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404696 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404701 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404705 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 404709 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404713 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 404717 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 404721 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404725 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404729 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404733 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404738 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404742 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404746 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404748 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404748 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404751 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404755 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404760 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404766 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404771 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404776 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404779 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404783 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404788 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404794 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404799 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404804 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404807 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404809 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404812 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404815 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404817 */     GIR_RootConstrainSelectedInstOperands,
     /* 404818 */     // GIR_Coverage, 4869,
     /* 404818 */     GIR_EraseRootFromParent_Done,
     /* 404819 */   // Label 7889: @404819
     /* 404819 */   GIM_Try, /*On fail goto*//*Label 7890*/ GIMT_Encode4(404966), // Rule ID 13949 //
     /* 404824 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 404827 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404831 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 404835 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 404839 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 404843 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404847 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404851 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 404855 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404860 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 404864 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 404868 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404872 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404876 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 404880 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404885 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 404889 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404893 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 404895 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 404895 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 404898 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404902 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404907 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 404913 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404918 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404923 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 404926 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 404930 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 404935 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 404941 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 404946 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404951 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 404954 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 404956 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 404959 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 404962 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 404964 */     GIR_RootConstrainSelectedInstOperands,
     /* 404965 */     // GIR_Coverage, 13949,
     /* 404965 */     GIR_EraseRootFromParent_Done,
     /* 404966 */   // Label 7890: @404966
     /* 404966 */   GIM_Try, /*On fail goto*//*Label 7891*/ GIMT_Encode4(405097), // Rule ID 6134 //
     /* 404971 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 404974 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 404978 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 404982 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 404986 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 404990 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 404995 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 404999 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405003 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405007 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405011 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 405015 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405019 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405023 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405027 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405032 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 405036 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405040 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405044 */     // MIs[4] Operand 1
     /* 405044 */     // No operand predicates
     /* 405044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405048 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405050 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405062 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405068 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405073 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405078 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405081 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405083 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405085 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 405092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 405095 */     GIR_RootConstrainSelectedInstOperands,
     /* 405096 */     // GIR_Coverage, 6134,
     /* 405096 */     GIR_EraseRootFromParent_Done,
     /* 405097 */   // Label 7891: @405097
     /* 405097 */   GIM_Try, /*On fail goto*//*Label 7892*/ GIMT_Encode4(405228), // Rule ID 6166 //
     /* 405102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405105 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405109 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405113 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405117 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405121 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405126 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405130 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405134 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405138 */     // MIs[2] Operand 1
     /* 405138 */     // No operand predicates
     /* 405138 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405142 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405146 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 405150 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 405154 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405158 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405162 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 405166 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405171 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 405175 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405179 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405181 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405181 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405184 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405188 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405193 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405199 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405204 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405216 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405219 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405223 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405226 */     GIR_RootConstrainSelectedInstOperands,
     /* 405227 */     // GIR_Coverage, 6166,
     /* 405227 */     GIR_EraseRootFromParent_Done,
     /* 405228 */   // Label 7892: @405228
     /* 405228 */   GIM_Try, /*On fail goto*//*Label 7893*/ GIMT_Encode4(405359), // Rule ID 6230 //
     /* 405233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405236 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405240 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405244 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405248 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405252 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405256 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405260 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405264 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405269 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405273 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405277 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405281 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405285 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405289 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405294 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 405298 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405302 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405306 */     // MIs[4] Operand 1
     /* 405306 */     // No operand predicates
     /* 405306 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405310 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405312 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405312 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405315 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405319 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405324 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405330 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405335 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405340 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405343 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405345 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405347 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405350 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 405354 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 405357 */     GIR_RootConstrainSelectedInstOperands,
     /* 405358 */     // GIR_Coverage, 6230,
     /* 405358 */     GIR_EraseRootFromParent_Done,
     /* 405359 */   // Label 7893: @405359
     /* 405359 */   GIM_Try, /*On fail goto*//*Label 7894*/ GIMT_Encode4(405490), // Rule ID 6198 //
     /* 405364 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 405379 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 405383 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405387 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405391 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405395 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405400 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405404 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405408 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405412 */     // MIs[3] Operand 1
     /* 405412 */     // No operand predicates
     /* 405412 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 405416 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405420 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405424 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 405428 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405433 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 405437 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405441 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 405443 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405443 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405446 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405450 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405455 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405461 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405466 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405471 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 405474 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405476 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405481 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405485 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405488 */     GIR_RootConstrainSelectedInstOperands,
     /* 405489 */     // GIR_Coverage, 6198,
     /* 405489 */     GIR_EraseRootFromParent_Done,
     /* 405490 */   // Label 7894: @405490
     /* 405490 */   GIM_Try, /*On fail goto*//*Label 7895*/ GIMT_Encode4(405625), // Rule ID 2464 //
     /* 405495 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405510 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405514 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405519 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405523 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405527 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405531 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405535 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405539 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405544 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 405548 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405552 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405554 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 405554 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s32,
     /* 405557 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405561 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405566 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 405572 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405577 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405582 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405585 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405589 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405594 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405600 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405605 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405610 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 405613 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405615 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405618 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 405621 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405623 */     GIR_RootConstrainSelectedInstOperands,
     /* 405624 */     // GIR_Coverage, 2464,
     /* 405624 */     GIR_EraseRootFromParent_Done,
     /* 405625 */   // Label 7895: @405625
     /* 405625 */   GIM_Try, /*On fail goto*//*Label 7896*/ GIMT_Encode4(405744), // Rule ID 6102 //
     /* 405630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405645 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405649 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405654 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405658 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405662 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405666 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405670 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 405674 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405679 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 405683 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405687 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405691 */     // MIs[3] Operand 1
     /* 405691 */     // No operand predicates
     /* 405691 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405695 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405697 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405697 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405700 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405704 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405709 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405715 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405720 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405725 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405728 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405730 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405732 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 405742 */     GIR_RootConstrainSelectedInstOperands,
     /* 405743 */     // GIR_Coverage, 6102,
     /* 405743 */     GIR_EraseRootFromParent_Done,
     /* 405744 */   // Label 7896: @405744
     /* 405744 */   GIM_Try, /*On fail goto*//*Label 7897*/ GIMT_Encode4(405863), // Rule ID 2549 //
     /* 405749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 405752 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405756 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405760 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405764 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405768 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405773 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 405777 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 405781 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 405785 */     // MIs[2] Operand 1
     /* 405785 */     // No operand predicates
     /* 405785 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 405789 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405793 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405797 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 405801 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405806 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 405810 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405814 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 405816 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, (EXTRACT_SUBREG:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 405816 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405819 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405823 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405828 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405834 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405839 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 405847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 405849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 405851 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405854 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 405858 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 405861 */     GIR_RootConstrainSelectedInstOperands,
     /* 405862 */     // GIR_Coverage, 2549,
     /* 405862 */     GIR_EraseRootFromParent_Done,
     /* 405863 */   // Label 7897: @405863
     /* 405863 */   GIM_Try, /*On fail goto*//*Label 7898*/ GIMT_Encode4(405963), // Rule ID 4867 //
     /* 405868 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405871 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405875 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405879 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405883 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405887 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405892 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405896 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 405900 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 405904 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 405908 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 405919 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 405919 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 405922 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 405926 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 405931 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 405937 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 405942 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405947 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 405950 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 405952 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 405955 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 405959 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 405961 */     GIR_RootConstrainSelectedInstOperands,
     /* 405962 */     // GIR_Coverage, 4867,
     /* 405962 */     GIR_EraseRootFromParent_Done,
     /* 405963 */   // Label 7898: @405963
     /* 405963 */   GIM_Try, /*On fail goto*//*Label 7899*/ GIMT_Encode4(406063), // Rule ID 4903 //
     /* 405968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 405971 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 405975 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 405979 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 405983 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 405987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 405992 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 405996 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 406004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406008 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406012 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406017 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406019 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406019 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406022 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406026 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406031 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406037 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406042 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406047 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406050 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406052 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406055 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 406057 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 406061 */     GIR_RootConstrainSelectedInstOperands,
     /* 406062 */     // GIR_Coverage, 4903,
     /* 406062 */     GIR_EraseRootFromParent_Done,
     /* 406063 */   // Label 7899: @406063
     /* 406063 */   GIM_Try, /*On fail goto*//*Label 7900*/ GIMT_Encode4(406160), // Rule ID 13945 //
     /* 406068 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406071 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406075 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406079 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406083 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406087 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406091 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406095 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406099 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406104 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406108 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406112 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406116 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406118 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406118 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406121 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406125 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406130 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406136 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406141 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406146 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406149 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406151 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406153 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406156 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406158 */     GIR_RootConstrainSelectedInstOperands,
     /* 406159 */     // GIR_Coverage, 13945,
     /* 406159 */     GIR_EraseRootFromParent_Done,
     /* 406160 */   // Label 7900: @406160
     /* 406160 */   GIM_Try, /*On fail goto*//*Label 7901*/ GIMT_Encode4(406260), // Rule ID 13947 //
     /* 406165 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406168 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406172 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406176 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406180 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406185 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406189 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406193 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406197 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406201 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406206 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406214 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406216 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406216 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406219 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406223 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406228 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 406234 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406239 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406244 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406247 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406249 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406252 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406256 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406258 */     GIR_RootConstrainSelectedInstOperands,
     /* 406259 */     // GIR_Coverage, 13947,
     /* 406259 */     GIR_EraseRootFromParent_Done,
     /* 406260 */   // Label 7901: @406260
     /* 406260 */   GIM_Try, /*On fail goto*//*Label 7902*/ GIMT_Encode4(406360), // Rule ID 4901 //
     /* 406265 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406268 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406272 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406276 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406280 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406284 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406288 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406293 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406297 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 406301 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406305 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 406309 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406314 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406316 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406316 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406319 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406323 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406328 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406334 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406344 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 406347 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406349 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406351 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406354 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 406358 */     GIR_RootConstrainSelectedInstOperands,
     /* 406359 */     // GIR_Coverage, 4901,
     /* 406359 */     GIR_EraseRootFromParent_Done,
     /* 406360 */   // Label 7902: @406360
     /* 406360 */   GIM_Try, /*On fail goto*//*Label 7903*/ GIMT_Encode4(406457), // Rule ID 4865 //
     /* 406365 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406368 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406372 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406376 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406380 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406384 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406388 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406392 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406396 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406400 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406405 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 406409 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406413 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 406415 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] })), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 406415 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406418 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406422 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406427 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 406433 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406438 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 406446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 406448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406450 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 406453 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 406455 */     GIR_RootConstrainSelectedInstOperands,
     /* 406456 */     // GIR_Coverage, 4865,
     /* 406456 */     GIR_EraseRootFromParent_Done,
     /* 406457 */   // Label 7903: @406457
     /* 406457 */   GIM_Try, /*On fail goto*//*Label 7904*/ GIMT_Encode4(406535), // Rule ID 6252 //
     /* 406462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406478 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406482 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406486 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406490 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406495 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 406499 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406503 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406507 */     // MIs[3] Operand 1
     /* 406507 */     // No operand predicates
     /* 406507 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406511 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406515 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406517 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406517 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406520 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406522 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406524 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406526 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406530 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406533 */     GIR_RootConstrainSelectedInstOperands,
     /* 406534 */     // GIR_Coverage, 6252,
     /* 406534 */     GIR_EraseRootFromParent_Done,
     /* 406535 */   // Label 7904: @406535
     /* 406535 */   GIM_Try, /*On fail goto*//*Label 7905*/ GIMT_Encode4(406619), // Rule ID 6164 //
     /* 406540 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406543 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406547 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406551 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406555 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406559 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 406568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406572 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406576 */     // MIs[2] Operand 1
     /* 406576 */     // No operand predicates
     /* 406576 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 406580 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406584 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s32,
     /* 406588 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406593 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406597 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406599 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406599 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406602 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406604 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406606 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 406610 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 406614 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 406617 */     GIR_RootConstrainSelectedInstOperands,
     /* 406618 */     // GIR_Coverage, 6164,
     /* 406618 */     GIR_EraseRootFromParent_Done,
     /* 406619 */   // Label 7905: @406619
     /* 406619 */   GIM_Try, /*On fail goto*//*Label 7906*/ GIMT_Encode4(406700), // Rule ID 6196 //
     /* 406624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406627 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406631 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406635 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406639 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406643 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406647 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406651 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406655 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406660 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406664 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406668 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406672 */     // MIs[3] Operand 1
     /* 406672 */     // No operand predicates
     /* 406672 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406676 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406680 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406682 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406682 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406685 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406687 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406689 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 406691 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406695 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406698 */     GIR_RootConstrainSelectedInstOperands,
     /* 406699 */     // GIR_Coverage, 6196,
     /* 406699 */     GIR_EraseRootFromParent_Done,
     /* 406700 */   // Label 7906: @406700
     /* 406700 */   GIM_Try, /*On fail goto*//*Label 7907*/ GIMT_Encode4(406784), // Rule ID 6228 //
     /* 406705 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406708 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406712 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406716 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406720 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406725 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 406729 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406733 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406737 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406741 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406746 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406750 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406754 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406758 */     // MIs[3] Operand 1
     /* 406758 */     // No operand predicates
     /* 406758 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406762 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406764 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rn), (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406769 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406771 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 406775 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406779 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406782 */     GIR_RootConstrainSelectedInstOperands,
     /* 406783 */     // GIR_Coverage, 6228,
     /* 406783 */     GIR_EraseRootFromParent_Done,
     /* 406784 */   // Label 7907: @406784
     /* 406784 */   GIM_Try, /*On fail goto*//*Label 7908*/ GIMT_Encode4(406862), // Rule ID 6274 //
     /* 406789 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406793 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406797 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406801 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406805 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406809 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406813 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406817 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406821 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406826 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 406830 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406834 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406838 */     // MIs[3] Operand 1
     /* 406838 */     // No operand predicates
     /* 406838 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406842 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406844 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406849 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406851 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406853 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406857 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406860 */     GIR_RootConstrainSelectedInstOperands,
     /* 406861 */     // GIR_Coverage, 6274,
     /* 406861 */     GIR_EraseRootFromParent_Done,
     /* 406862 */   // Label 7908: @406862
     /* 406862 */   GIM_Try, /*On fail goto*//*Label 7909*/ GIMT_Encode4(406943), // Rule ID 6132 //
     /* 406867 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 406870 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406874 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 406878 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 406882 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 406886 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 406890 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406894 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406898 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 406902 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406907 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 406911 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 406915 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 406919 */     // MIs[3] Operand 1
     /* 406919 */     // No operand predicates
     /* 406919 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406923 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 406925 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), FPR32:{ *:[f32] }:$Rd)  =>  (FMLSv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 406925 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i32_indexed),
     /* 406928 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 406930 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 406932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 406934 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 406938 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 406941 */     GIR_RootConstrainSelectedInstOperands,
     /* 406942 */     // GIR_Coverage, 6132,
     /* 406942 */     GIR_EraseRootFromParent_Done,
     /* 406943 */   // Label 7909: @406943
     /* 406943 */   GIM_Try, /*On fail goto*//*Label 7910*/ GIMT_Encode4(407028), // Rule ID 2462 //
     /* 406948 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 406951 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 406955 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 406959 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 406963 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 406967 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 406972 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 406976 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406980 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 406984 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 406986 */     // (strict_fma:{ *:[f32] } (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rn, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 406986 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 406989 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 406993 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 406998 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rn
     /* 407004 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407009 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407014 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407017 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407019 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407022 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407024 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407026 */     GIR_RootConstrainSelectedInstOperands,
     /* 407027 */     // GIR_Coverage, 2462,
     /* 407027 */     GIR_EraseRootFromParent_Done,
     /* 407028 */   // Label 7910: @407028
     /* 407028 */   GIM_Try, /*On fail goto*//*Label 7911*/ GIMT_Encode4(407113), // Rule ID 2460 //
     /* 407033 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407036 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407040 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407044 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407048 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407052 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407056 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407061 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407069 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407071 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (extractelt:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, 0:{ *:[i64] }), FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (EXTRACT_SUBREG:{ *:[i32] } V128:{ *:[v4f32] }:$Rm, ssub:{ *:[i32] }), FPR32:{ *:[f32] }:$Ra)
     /* 407071 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 407074 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407078 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407083 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(18), // Rm
     /* 407089 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407094 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407099 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407102 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407104 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407106 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407109 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407111 */     GIR_RootConstrainSelectedInstOperands,
     /* 407112 */     // GIR_Coverage, 2460,
     /* 407112 */     GIR_EraseRootFromParent_Done,
     /* 407113 */   // Label 7911: @407113
     /* 407113 */   GIM_Try, /*On fail goto*//*Label 7912*/ GIMT_Encode4(407182), // Rule ID 2547 //
     /* 407118 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407121 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407125 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407129 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407133 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407137 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407142 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407146 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407150 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407154 */     // MIs[2] Operand 1
     /* 407154 */     // No operand predicates
     /* 407154 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407158 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407162 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407164 */     // (strict_fma:{ *:[f32] } (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407164 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407167 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407169 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407171 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407173 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407177 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407180 */     GIR_RootConstrainSelectedInstOperands,
     /* 407181 */     // GIR_Coverage, 2547,
     /* 407181 */     GIR_EraseRootFromParent_Done,
     /* 407182 */   // Label 7912: @407182
     /* 407182 */   GIM_Try, /*On fail goto*//*Label 7913*/ GIMT_Encode4(407251), // Rule ID 6100 //
     /* 407187 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407190 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407194 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407198 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407202 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 407206 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407210 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 407219 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407223 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 407227 */     // MIs[2] Operand 1
     /* 407227 */     // No operand predicates
     /* 407227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 407233 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR32:{ *:[f32] }:$Rd)  =>  (FMLAv1i32_indexed:{ *:[f32] } FPR32:{ *:[f32] }:$Rd, FPR32:{ *:[f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 407233 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i32_indexed),
     /* 407236 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 407238 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 407240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407242 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407246 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 407249 */     GIR_RootConstrainSelectedInstOperands,
     /* 407250 */     // GIR_Coverage, 6100,
     /* 407250 */     GIR_EraseRootFromParent_Done,
     /* 407251 */   // Label 7913: @407251
     /* 407251 */   GIM_Try, /*On fail goto*//*Label 7914*/ GIMT_Encode4(407301), // Rule ID 13377 //
     /* 407256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407259 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407263 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407267 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407271 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407276 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407280 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407284 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407286 */     // (strict_fma:{ *:[f32] } (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407291 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 407293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407297 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407299 */     GIR_RootConstrainSelectedInstOperands,
     /* 407300 */     // GIR_Coverage, 13377,
     /* 407300 */     GIR_EraseRootFromParent_Done,
     /* 407301 */   // Label 7914: @407301
     /* 407301 */   GIM_Try, /*On fail goto*//*Label 7915*/ GIMT_Encode4(407351), // Rule ID 645 //
     /* 407306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407309 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407313 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 407317 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407321 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407325 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407330 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407334 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407336 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Rm), FPR32:{ *:[f32] }:$Ra)  =>  (FMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407336 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBSrrr),
     /* 407339 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407341 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407343 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 407347 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407349 */     GIR_RootConstrainSelectedInstOperands,
     /* 407350 */     // GIR_Coverage, 645,
     /* 407350 */     GIR_EraseRootFromParent_Done,
     /* 407351 */   // Label 7915: @407351
     /* 407351 */   GIM_Try, /*On fail goto*//*Label 7916*/ GIMT_Encode4(407401), // Rule ID 657 //
     /* 407356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407363 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 407371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 407379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407384 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 407386 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, (fneg:{ *:[f32] } FPR32:{ *:[f32] }:$Ra))  =>  (FNMSUBSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407386 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBSrrr),
     /* 407389 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407391 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 407393 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 407395 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 407399 */     GIR_RootConstrainSelectedInstOperands,
     /* 407400 */     // GIR_Coverage, 657,
     /* 407400 */     GIR_EraseRootFromParent_Done,
     /* 407401 */   // Label 7916: @407401
     /* 407401 */   GIM_Try, /*On fail goto*//*Label 7917*/ GIMT_Encode4(407432), // Rule ID 639 //
     /* 407406 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407409 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407413 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407417 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 407421 */     // (strict_fma:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)  =>  (FMADDSrrr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm, FPR32:{ *:[f32] }:$Ra)
     /* 407421 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDSrrr),
     /* 407426 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 407430 */     GIR_RootConstrainSelectedInstOperands,
     /* 407431 */     // GIR_Coverage, 639,
     /* 407431 */     GIR_Done,
     /* 407432 */   // Label 7917: @407432
     /* 407432 */   GIM_Reject,
     /* 407433 */ // Label 7887: @407433
     /* 407433 */ GIM_Reject,
     /* 407434 */ // Label 7851: @407434
     /* 407434 */ GIM_Try, /*On fail goto*//*Label 7918*/ GIMT_Encode4(410363),
     /* 407439 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 407442 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 407445 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 407448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407452 */   GIM_Try, /*On fail goto*//*Label 7919*/ GIMT_Encode4(407602), // Rule ID 4911 //
     /* 407457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407460 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407464 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407468 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407472 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407476 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407481 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407485 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407489 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407493 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407497 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407501 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407506 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407510 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 407514 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407518 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 407522 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407529 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407529 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407532 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407536 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407541 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407547 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407552 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407557 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407560 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407564 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407569 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407575 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407580 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407585 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 407588 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407590 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407593 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407596 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Ra
     /* 407600 */     GIR_RootConstrainSelectedInstOperands,
     /* 407601 */     // GIR_Coverage, 4911,
     /* 407601 */     GIR_EraseRootFromParent_Done,
     /* 407602 */   // Label 7919: @407602
     /* 407602 */   GIM_Try, /*On fail goto*//*Label 7920*/ GIMT_Encode4(407749), // Rule ID 4875 //
     /* 407607 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407610 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407614 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407618 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407622 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407626 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407631 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407647 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 407651 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407655 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407659 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407663 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407668 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407672 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407676 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407678 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407678 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407681 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407685 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407690 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407696 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407701 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407706 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407709 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407713 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407718 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407724 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407729 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407734 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407737 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407739 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407742 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407745 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407747 */     GIR_RootConstrainSelectedInstOperands,
     /* 407748 */     // GIR_Coverage, 4875,
     /* 407748 */     GIR_EraseRootFromParent_Done,
     /* 407749 */   // Label 7920: @407749
     /* 407749 */   GIM_Try, /*On fail goto*//*Label 7921*/ GIMT_Encode4(407896), // Rule ID 13955 //
     /* 407754 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 407757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 407769 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 407773 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407777 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407781 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 407785 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407790 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 407794 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 407798 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407802 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407806 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407810 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407815 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 407819 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407823 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 407825 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 407825 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 407828 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407832 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407837 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 407843 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407848 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407853 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407856 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407860 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407865 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407871 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407876 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 407884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 407886 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 407889 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 407892 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 407894 */     GIR_RootConstrainSelectedInstOperands,
     /* 407895 */     // GIR_Coverage, 13955,
     /* 407895 */     GIR_EraseRootFromParent_Done,
     /* 407896 */   // Label 7921: @407896
     /* 407896 */   GIM_Try, /*On fail goto*//*Label 7922*/ GIMT_Encode4(408027), // Rule ID 6138 //
     /* 407901 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 407904 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 407908 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407912 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407916 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 407920 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407925 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 407929 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 407933 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 407937 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 407941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/1, // MIs[3]
     /* 407945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 407949 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 407953 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 407957 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 407962 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 407966 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 407970 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 407974 */     // MIs[4] Operand 1
     /* 407974 */     // No operand predicates
     /* 407974 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 407978 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 407980 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 407980 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 407983 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 407987 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 407992 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 407998 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408003 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408008 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408011 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408013 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408015 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408018 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 408022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 408025 */     GIR_RootConstrainSelectedInstOperands,
     /* 408026 */     // GIR_Coverage, 6138,
     /* 408026 */     GIR_EraseRootFromParent_Done,
     /* 408027 */   // Label 7922: @408027
     /* 408027 */   GIM_Try, /*On fail goto*//*Label 7923*/ GIMT_Encode4(408158), // Rule ID 6170 //
     /* 408032 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408035 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408039 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408043 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408047 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408051 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408056 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408060 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408064 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408068 */     // MIs[2] Operand 1
     /* 408068 */     // No operand predicates
     /* 408068 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408072 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408076 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 408080 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/1, // MIs[4]
     /* 408084 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408088 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408092 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 408096 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408101 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 408105 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408109 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408111 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408111 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408114 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408118 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408123 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408129 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408134 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408139 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408142 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408144 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408146 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408156 */     GIR_RootConstrainSelectedInstOperands,
     /* 408157 */     // GIR_Coverage, 6170,
     /* 408157 */     GIR_EraseRootFromParent_Done,
     /* 408158 */   // Label 7923: @408158
     /* 408158 */   GIM_Try, /*On fail goto*//*Label 7924*/ GIMT_Encode4(408289), // Rule ID 6234 //
     /* 408163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408166 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408170 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408174 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408178 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408182 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408186 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408190 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408194 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408199 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408203 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408207 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408211 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408215 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408219 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408224 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/3, /*OpIdx*/2, // MIs[4]
     /* 408228 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408232 */     GIM_CheckI64ImmPredicate, /*MI*/4, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408236 */     // MIs[4] Operand 1
     /* 408236 */     // No operand predicates
     /* 408236 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408240 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408242 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] })), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408242 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408245 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408249 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408254 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408265 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408277 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rm
     /* 408284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/4, // idx
     /* 408287 */     GIR_RootConstrainSelectedInstOperands,
     /* 408288 */     // GIR_Coverage, 6234,
     /* 408288 */     GIR_EraseRootFromParent_Done,
     /* 408289 */   // Label 7924: @408289
     /* 408289 */   GIM_Try, /*On fail goto*//*Label 7925*/ GIMT_Encode4(408420), // Rule ID 6202 //
     /* 408294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 408309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 408313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408342 */     // MIs[3] Operand 1
     /* 408342 */     // No operand predicates
     /* 408342 */     GIM_RecordInsn, /*DefineMI*/4, /*MI*/0, /*OpIdx*/2, // MIs[4]
     /* 408346 */     GIM_CheckOpcode, /*MI*/4, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408350 */     GIM_CheckType, /*MI*/4, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408354 */     GIM_CheckType, /*MI*/4, /*Op*/2, /*Type*/GILLT_s64,
     /* 408358 */     GIM_CheckRegBankForClass, /*MI*/4, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408363 */     GIM_CheckConstantInt8, /*MI*/4, /*Op*/2, 0,
     /* 408367 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408371 */     GIM_CheckIsSafeToFold, /*NumInsns*/4,
     /* 408373 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408373 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408376 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408380 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408385 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/4, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408391 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408396 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 408404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408408 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408411 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408415 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408418 */     GIR_RootConstrainSelectedInstOperands,
     /* 408419 */     // GIR_Coverage, 6202,
     /* 408419 */     GIR_EraseRootFromParent_Done,
     /* 408420 */   // Label 7925: @408420
     /* 408420 */   GIM_Try, /*On fail goto*//*Label 7926*/ GIMT_Encode4(408555), // Rule ID 2470 //
     /* 408425 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408440 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408444 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408449 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408461 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408465 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408469 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408474 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 408478 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408482 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408484 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 408484 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 408487 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408491 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408496 */     GIR_CopySubReg, /*NewInsnID*/2, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 408502 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408507 */     GIR_ConstrainOperandRC, /*InsnID*/2, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408512 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408515 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408519 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408524 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408530 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408535 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 408543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408545 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408548 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 408551 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408553 */     GIR_RootConstrainSelectedInstOperands,
     /* 408554 */     // GIR_Coverage, 2470,
     /* 408554 */     GIR_EraseRootFromParent_Done,
     /* 408555 */   // Label 7926: @408555
     /* 408555 */   GIM_Try, /*On fail goto*//*Label 7927*/ GIMT_Encode4(408674), // Rule ID 6106 //
     /* 408560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408567 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408571 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408575 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408579 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408584 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408588 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408592 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408596 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408600 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 408604 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408609 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 408613 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408617 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408621 */     // MIs[3] Operand 1
     /* 408621 */     // No operand predicates
     /* 408621 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408625 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408627 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408627 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408630 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408634 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408639 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408645 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408650 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408655 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408658 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408660 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408662 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408665 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408669 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 408672 */     GIR_RootConstrainSelectedInstOperands,
     /* 408673 */     // GIR_Coverage, 6106,
     /* 408673 */     GIR_EraseRootFromParent_Done,
     /* 408674 */   // Label 7927: @408674
     /* 408674 */   GIM_Try, /*On fail goto*//*Label 7928*/ GIMT_Encode4(408793), // Rule ID 2553 //
     /* 408679 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 408682 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408686 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408690 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408694 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408698 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408703 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 408707 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 408711 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 408715 */     // MIs[2] Operand 1
     /* 408715 */     // No operand predicates
     /* 408715 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 408719 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408723 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408727 */     GIM_CheckType, /*MI*/3, /*Op*/2, /*Type*/GILLT_s64,
     /* 408731 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408736 */     GIM_CheckConstantInt8, /*MI*/3, /*Op*/2, 0,
     /* 408740 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408744 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 408746 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, (EXTRACT_SUBREG:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 408746 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408749 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408753 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408758 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/3, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408764 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408769 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 408777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 408779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 408781 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408784 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 408788 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 408791 */     GIR_RootConstrainSelectedInstOperands,
     /* 408792 */     // GIR_Coverage, 2553,
     /* 408792 */     GIR_EraseRootFromParent_Done,
     /* 408793 */   // Label 7928: @408793
     /* 408793 */   GIM_Try, /*On fail goto*//*Label 7929*/ GIMT_Encode4(408893), // Rule ID 4873 //
     /* 408798 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408801 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408805 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408809 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408813 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408817 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408822 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408826 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 408830 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408834 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408838 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408843 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408847 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408849 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408849 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408852 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408856 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408861 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408867 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408872 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408877 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 408880 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408882 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408885 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 408889 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 408891 */     GIR_RootConstrainSelectedInstOperands,
     /* 408892 */     // GIR_Coverage, 4873,
     /* 408892 */     GIR_EraseRootFromParent_Done,
     /* 408893 */   // Label 7929: @408893
     /* 408893 */   GIM_Try, /*On fail goto*//*Label 7930*/ GIMT_Encode4(408993), // Rule ID 4909 //
     /* 408898 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 408901 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 408905 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 408909 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 408913 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 408917 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408922 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 408926 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408930 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 408934 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 408938 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 408942 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408947 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 408949 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 408949 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 408952 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 408956 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 408961 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 408967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 408972 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 408977 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 408980 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 408982 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 408985 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 408987 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 408991 */     GIR_RootConstrainSelectedInstOperands,
     /* 408992 */     // GIR_Coverage, 4909,
     /* 408992 */     GIR_EraseRootFromParent_Done,
     /* 408993 */   // Label 7930: @408993
     /* 408993 */   GIM_Try, /*On fail goto*//*Label 7931*/ GIMT_Encode4(409090), // Rule ID 13951 //
     /* 408998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409009 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409013 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409017 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409021 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409025 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409029 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409034 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409038 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409042 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409046 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409048 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409048 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409051 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409055 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409060 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409066 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409071 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409076 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409079 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409081 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409083 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409086 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409088 */     GIR_RootConstrainSelectedInstOperands,
     /* 409089 */     // GIR_Coverage, 13951,
     /* 409089 */     GIR_EraseRootFromParent_Done,
     /* 409090 */   // Label 7931: @409090
     /* 409090 */   GIM_Try, /*On fail goto*//*Label 7932*/ GIMT_Encode4(409190), // Rule ID 13953 //
     /* 409095 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409098 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409102 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409106 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409110 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409115 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409119 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409123 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409127 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409131 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409136 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409140 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409144 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409146 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409158 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409164 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409174 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409177 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409182 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409186 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409188 */     GIR_RootConstrainSelectedInstOperands,
     /* 409189 */     // GIR_Coverage, 13953,
     /* 409189 */     GIR_EraseRootFromParent_Done,
     /* 409190 */   // Label 7932: @409190
     /* 409190 */   GIM_Try, /*On fail goto*//*Label 7933*/ GIMT_Encode4(409290), // Rule ID 4907 //
     /* 409195 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409198 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409202 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409206 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409210 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409214 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409218 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409223 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409227 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/3, // MIs[2]
     /* 409231 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409235 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 409239 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409244 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409246 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409246 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409249 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409253 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409258 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409264 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409269 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409274 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 409277 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409281 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409284 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Ra
     /* 409288 */     GIR_RootConstrainSelectedInstOperands,
     /* 409289 */     // GIR_Coverage, 4907,
     /* 409289 */     GIR_EraseRootFromParent_Done,
     /* 409290 */   // Label 7933: @409290
     /* 409290 */   GIM_Try, /*On fail goto*//*Label 7934*/ GIMT_Encode4(409387), // Rule ID 4871 //
     /* 409295 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409298 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409335 */     GIM_CheckConstantInt8, /*MI*/2, /*Op*/2, 0,
     /* 409339 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409343 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 409345 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] })), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 409345 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409348 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409352 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409357 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 409363 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409368 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409373 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 409376 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409380 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409383 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409385 */     GIR_RootConstrainSelectedInstOperands,
     /* 409386 */     // GIR_Coverage, 4871,
     /* 409386 */     GIR_EraseRootFromParent_Done,
     /* 409387 */   // Label 7934: @409387
     /* 409387 */   GIM_Try, /*On fail goto*//*Label 7935*/ GIMT_Encode4(409465), // Rule ID 6256 //
     /* 409392 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409396 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409400 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409404 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409408 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409412 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409416 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409420 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409425 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409429 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409433 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409437 */     // MIs[3] Operand 1
     /* 409437 */     // No operand predicates
     /* 409437 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409441 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409445 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409447 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409447 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409450 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409452 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409454 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409456 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409460 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409463 */     GIR_RootConstrainSelectedInstOperands,
     /* 409464 */     // GIR_Coverage, 6256,
     /* 409464 */     GIR_EraseRootFromParent_Done,
     /* 409465 */   // Label 7935: @409465
     /* 409465 */   GIM_Try, /*On fail goto*//*Label 7936*/ GIMT_Encode4(409549), // Rule ID 6168 //
     /* 409470 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409473 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409477 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409481 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409485 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409489 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409494 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 409498 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409502 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409506 */     // MIs[2] Operand 1
     /* 409506 */     // No operand predicates
     /* 409506 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 409510 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409514 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_s64,
     /* 409518 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409523 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409527 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409529 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409529 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409532 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409534 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409536 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 409540 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 409544 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 409547 */     GIR_RootConstrainSelectedInstOperands,
     /* 409548 */     // GIR_Coverage, 6168,
     /* 409548 */     GIR_EraseRootFromParent_Done,
     /* 409549 */   // Label 7936: @409549
     /* 409549 */   GIM_Try, /*On fail goto*//*Label 7937*/ GIMT_Encode4(409630), // Rule ID 6200 //
     /* 409554 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409557 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409561 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409565 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409569 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409573 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409577 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409581 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409585 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409590 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409594 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409598 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409602 */     // MIs[3] Operand 1
     /* 409602 */     // No operand predicates
     /* 409602 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409606 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409610 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409612 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409612 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409615 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409617 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409619 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 409621 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409625 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409628 */     GIR_RootConstrainSelectedInstOperands,
     /* 409629 */     // GIR_Coverage, 6200,
     /* 409629 */     GIR_EraseRootFromParent_Done,
     /* 409630 */   // Label 7937: @409630
     /* 409630 */   GIM_Try, /*On fail goto*//*Label 7938*/ GIMT_Encode4(409714), // Rule ID 6232 //
     /* 409635 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409638 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409642 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409646 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409650 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409655 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 409659 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409663 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409667 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409671 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409676 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409680 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409684 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409688 */     // MIs[3] Operand 1
     /* 409688 */     // No operand predicates
     /* 409688 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409692 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409694 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rn), (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409694 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409697 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409699 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409701 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 409705 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409709 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409712 */     GIR_RootConstrainSelectedInstOperands,
     /* 409713 */     // GIR_Coverage, 6232,
     /* 409713 */     GIR_EraseRootFromParent_Done,
     /* 409714 */   // Label 7938: @409714
     /* 409714 */   GIM_Try, /*On fail goto*//*Label 7939*/ GIMT_Encode4(409792), // Rule ID 6278 //
     /* 409719 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409723 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409727 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409731 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409735 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409756 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 409760 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409764 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 409768 */     // MIs[3] Operand 1
     /* 409768 */     // No operand predicates
     /* 409768 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409772 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409774 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 409774 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409777 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409779 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409781 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409783 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409787 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409790 */     GIR_RootConstrainSelectedInstOperands,
     /* 409791 */     // GIR_Coverage, 6278,
     /* 409791 */     GIR_EraseRootFromParent_Done,
     /* 409792 */   // Label 7939: @409792
     /* 409792 */   GIM_Try, /*On fail goto*//*Label 7940*/ GIMT_Encode4(409873), // Rule ID 6136 //
     /* 409797 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 409800 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409804 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409808 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 409812 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 409816 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 409820 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409824 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409828 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 409832 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409837 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 409841 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 409845 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 409849 */     // MIs[3] Operand 1
     /* 409849 */     // No operand predicates
     /* 409849 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409853 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 409855 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), FPR64:{ *:[f64] }:$Rd)  =>  (FMLSv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 409855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv1i64_indexed),
     /* 409858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 409860 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 409862 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 409864 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 409868 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 409871 */     GIR_RootConstrainSelectedInstOperands,
     /* 409872 */     // GIR_Coverage, 6136,
     /* 409872 */     GIR_EraseRootFromParent_Done,
     /* 409873 */   // Label 7940: @409873
     /* 409873 */   GIM_Try, /*On fail goto*//*Label 7941*/ GIMT_Encode4(409958), // Rule ID 2468 //
     /* 409878 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409881 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 409885 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409889 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409893 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409897 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409902 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409906 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409910 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409914 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 409916 */     // (strict_fma:{ *:[f64] } (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rn, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 409916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 409919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 409923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 409928 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rn
     /* 409934 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409939 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 409947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 409949 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 409952 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 409954 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 409956 */     GIR_RootConstrainSelectedInstOperands,
     /* 409957 */     // GIR_Coverage, 2468,
     /* 409957 */     GIR_EraseRootFromParent_Done,
     /* 409958 */   // Label 7941: @409958
     /* 409958 */   GIM_Try, /*On fail goto*//*Label 7942*/ GIMT_Encode4(410043), // Rule ID 2466 //
     /* 409963 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 409966 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409970 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 409974 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 409978 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 409982 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 409986 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 409991 */     GIM_CheckConstantInt8, /*MI*/1, /*Op*/2, 0,
     /* 409995 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 409999 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410001 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (extractelt:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, 0:{ *:[i64] }), FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (EXTRACT_SUBREG:{ *:[i64] } V128:{ *:[v2f64] }:$Rm, dsub:{ *:[i32] }), FPR64:{ *:[f64] }:$Ra)
     /* 410001 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 410004 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 410008 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 410013 */     GIR_CopySubReg, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, /*SubRegIdx*/GIMT_Encode2(3), // Rm
     /* 410019 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410024 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410036 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 410039 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410041 */     GIR_RootConstrainSelectedInstOperands,
     /* 410042 */     // GIR_Coverage, 2466,
     /* 410042 */     GIR_EraseRootFromParent_Done,
     /* 410043 */   // Label 7942: @410043
     /* 410043 */   GIM_Try, /*On fail goto*//*Label 7943*/ GIMT_Encode4(410112), // Rule ID 2551 //
     /* 410048 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410051 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410055 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410059 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410063 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410067 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410072 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410076 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410080 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410084 */     // MIs[2] Operand 1
     /* 410084 */     // No operand predicates
     /* 410084 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410088 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410092 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410094 */     // (strict_fma:{ *:[f64] } (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410094 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410097 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410099 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410101 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410103 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410107 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410110 */     GIR_RootConstrainSelectedInstOperands,
     /* 410111 */     // GIR_Coverage, 2551,
     /* 410111 */     GIR_EraseRootFromParent_Done,
     /* 410112 */   // Label 7943: @410112
     /* 410112 */   GIM_Try, /*On fail goto*//*Label 7944*/ GIMT_Encode4(410181), // Rule ID 6104 //
     /* 410117 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410120 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410124 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410128 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_VECTOR_ELT),
     /* 410132 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 410136 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410145 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410149 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410153 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 410157 */     // MIs[2] Operand 1
     /* 410157 */     // No operand predicates
     /* 410157 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410161 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410163 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), FPR64:{ *:[f64] }:$Rd)  =>  (FMLAv1i64_indexed:{ *:[f64] } FPR64:{ *:[f64] }:$Rd, FPR64:{ *:[f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)
     /* 410163 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv1i64_indexed),
     /* 410166 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410168 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410170 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410172 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410176 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410179 */     GIR_RootConstrainSelectedInstOperands,
     /* 410180 */     // GIR_Coverage, 6104,
     /* 410180 */     GIR_EraseRootFromParent_Done,
     /* 410181 */   // Label 7944: @410181
     /* 410181 */   GIM_Try, /*On fail goto*//*Label 7945*/ GIMT_Encode4(410231), // Rule ID 13379 //
     /* 410186 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410189 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410193 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410197 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410201 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410206 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410210 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410214 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410216 */     // (strict_fma:{ *:[f64] } (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410216 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410219 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410221 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410223 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410229 */     GIR_RootConstrainSelectedInstOperands,
     /* 410230 */     // GIR_Coverage, 13379,
     /* 410230 */     GIR_EraseRootFromParent_Done,
     /* 410231 */   // Label 7945: @410231
     /* 410231 */   GIM_Try, /*On fail goto*//*Label 7946*/ GIMT_Encode4(410281), // Rule ID 647 //
     /* 410236 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410239 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410243 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410247 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410251 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410255 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410260 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410264 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410266 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Rm), FPR64:{ *:[f64] }:$Ra)  =>  (FMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410266 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMSUBDrrr),
     /* 410269 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410271 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410273 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410277 */     GIR_RootToRootCopy, /*OpIdx*/3, // Ra
     /* 410279 */     GIR_RootConstrainSelectedInstOperands,
     /* 410280 */     // GIR_Coverage, 647,
     /* 410280 */     GIR_EraseRootFromParent_Done,
     /* 410281 */   // Label 7946: @410281
     /* 410281 */   GIM_Try, /*On fail goto*//*Label 7947*/ GIMT_Encode4(410331), // Rule ID 659 //
     /* 410286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410289 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410293 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 410301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 410309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410314 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 410316 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, (fneg:{ *:[f64] } FPR64:{ *:[f64] }:$Ra))  =>  (FNMSUBDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410316 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FNMSUBDrrr),
     /* 410319 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 410321 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410323 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 410325 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Ra
     /* 410329 */     GIR_RootConstrainSelectedInstOperands,
     /* 410330 */     // GIR_Coverage, 659,
     /* 410330 */     GIR_EraseRootFromParent_Done,
     /* 410331 */   // Label 7947: @410331
     /* 410331 */   GIM_Try, /*On fail goto*//*Label 7948*/ GIMT_Encode4(410362), // Rule ID 641 //
     /* 410336 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 410339 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410351 */     // (strict_fma:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)  =>  (FMADDDrrr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm, FPR64:{ *:[f64] }:$Ra)
     /* 410351 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMADDDrrr),
     /* 410356 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 410360 */     GIR_RootConstrainSelectedInstOperands,
     /* 410361 */     // GIR_Coverage, 641,
     /* 410361 */     GIR_Done,
     /* 410362 */   // Label 7948: @410362
     /* 410362 */   GIM_Reject,
     /* 410363 */ // Label 7918: @410363
     /* 410363 */ GIM_Reject,
     /* 410364 */ // Label 7852: @410364
     /* 410364 */ GIM_Try, /*On fail goto*//*Label 7949*/ GIMT_Encode4(411884),
     /* 410369 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410372 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 410375 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 410378 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410382 */   GIM_Try, /*On fail goto*//*Label 7950*/ GIMT_Encode4(410460), // Rule ID 6236 //
     /* 410387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410391 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410395 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410399 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410403 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410407 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410411 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410415 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410420 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410424 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410428 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410432 */     // MIs[3] Operand 1
     /* 410432 */     // No operand predicates
     /* 410432 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410436 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410440 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410442 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410442 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410445 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410447 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410449 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410451 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410455 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410458 */     GIR_RootConstrainSelectedInstOperands,
     /* 410459 */     // GIR_Coverage, 6236,
     /* 410459 */     GIR_EraseRootFromParent_Done,
     /* 410460 */   // Label 7950: @410460
     /* 410460 */   GIM_Try, /*On fail goto*//*Label 7951*/ GIMT_Encode4(410544), // Rule ID 6152 //
     /* 410465 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410468 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410472 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410476 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410480 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410484 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410489 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410493 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410497 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410501 */     // MIs[2] Operand 1
     /* 410501 */     // No operand predicates
     /* 410501 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 410505 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410509 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410513 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410518 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410522 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410524 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410524 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410527 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410529 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410531 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 410535 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410539 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410542 */     GIR_RootConstrainSelectedInstOperands,
     /* 410543 */     // GIR_Coverage, 6152,
     /* 410543 */     GIR_EraseRootFromParent_Done,
     /* 410544 */   // Label 7951: @410544
     /* 410544 */   GIM_Try, /*On fail goto*//*Label 7952*/ GIMT_Encode4(410625), // Rule ID 6184 //
     /* 410549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410552 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410556 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410560 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410564 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410568 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410572 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410576 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410580 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410585 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410589 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410593 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410597 */     // MIs[3] Operand 1
     /* 410597 */     // No operand predicates
     /* 410597 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410601 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410605 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410607 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410607 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410610 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410612 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410614 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410616 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410620 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410623 */     GIR_RootConstrainSelectedInstOperands,
     /* 410624 */     // GIR_Coverage, 6184,
     /* 410624 */     GIR_EraseRootFromParent_Done,
     /* 410625 */   // Label 7952: @410625
     /* 410625 */   GIM_Try, /*On fail goto*//*Label 7953*/ GIMT_Encode4(410709), // Rule ID 6216 //
     /* 410630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410633 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410637 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410641 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410645 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410650 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 410654 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410658 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410662 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410666 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410671 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410675 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410679 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410683 */     // MIs[3] Operand 1
     /* 410683 */     // No operand predicates
     /* 410683 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410687 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410689 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410689 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410692 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410694 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410696 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 410700 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410704 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410707 */     GIR_RootConstrainSelectedInstOperands,
     /* 410708 */     // GIR_Coverage, 6216,
     /* 410708 */     GIR_EraseRootFromParent_Done,
     /* 410709 */   // Label 7953: @410709
     /* 410709 */   GIM_Try, /*On fail goto*//*Label 7954*/ GIMT_Encode4(410787), // Rule ID 6258 //
     /* 410714 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410718 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410722 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410726 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410730 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410734 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410738 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410742 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410746 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410751 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 410755 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410759 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410763 */     // MIs[3] Operand 1
     /* 410763 */     // No operand predicates
     /* 410763 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410767 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410769 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410769 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410772 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410774 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410776 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410778 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410782 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410785 */     GIR_RootConstrainSelectedInstOperands,
     /* 410786 */     // GIR_Coverage, 6258,
     /* 410786 */     GIR_EraseRootFromParent_Done,
     /* 410787 */   // Label 7954: @410787
     /* 410787 */   GIM_Try, /*On fail goto*//*Label 7955*/ GIMT_Encode4(410868), // Rule ID 6120 //
     /* 410792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410795 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410799 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410803 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 410807 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 410811 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 410815 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410819 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410823 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 410827 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410832 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 410836 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410840 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410844 */     // MIs[3] Operand 1
     /* 410844 */     // No operand predicates
     /* 410844 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410848 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 410850 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410850 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 410853 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410855 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410857 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410859 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 410863 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 410866 */     GIR_RootConstrainSelectedInstOperands,
     /* 410867 */     // GIR_Coverage, 6120,
     /* 410867 */     GIR_EraseRootFromParent_Done,
     /* 410868 */   // Label 7955: @410868
     /* 410868 */   GIM_Try, /*On fail goto*//*Label 7956*/ GIMT_Encode4(410937), // Rule ID 2535 //
     /* 410873 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410876 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 410880 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410884 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410888 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410892 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410897 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410901 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410905 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410909 */     // MIs[2] Operand 1
     /* 410909 */     // No operand predicates
     /* 410909 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410913 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410917 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410919 */     // (strict_fma:{ *:[v2f32] } (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410919 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410922 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410924 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410926 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 410928 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 410932 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 410935 */     GIR_RootConstrainSelectedInstOperands,
     /* 410936 */     // GIR_Coverage, 2535,
     /* 410936 */     GIR_EraseRootFromParent_Done,
     /* 410937 */   // Label 7956: @410937
     /* 410937 */   GIM_Try, /*On fail goto*//*Label 7957*/ GIMT_Encode4(411006), // Rule ID 6088 //
     /* 410942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 410945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 410953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 410957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 410961 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 410965 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 410970 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 410974 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 410978 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 410982 */     // MIs[2] Operand 1
     /* 410982 */     // No operand predicates
     /* 410982 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 410986 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 410988 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 410988 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 410991 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 410993 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 410995 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 410997 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411001 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 411004 */     GIR_RootConstrainSelectedInstOperands,
     /* 411005 */     // GIR_Coverage, 6088,
     /* 411005 */     GIR_EraseRootFromParent_Done,
     /* 411006 */   // Label 7957: @411006
     /* 411006 */   GIM_Try, /*On fail goto*//*Label 7958*/ GIMT_Encode4(411099), // Rule ID 6240 //
     /* 411011 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411015 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411019 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411023 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411027 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411031 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411035 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411040 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411044 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411048 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411050 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411050 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411053 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411057 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411062 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411065 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411069 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411072 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411077 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411082 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411085 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411087 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411089 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411091 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411094 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411097 */     GIR_RootConstrainSelectedInstOperands,
     /* 411098 */     // GIR_Coverage, 6240,
     /* 411098 */     GIR_EraseRootFromParent_Done,
     /* 411099 */   // Label 7958: @411099
     /* 411099 */   GIM_Try, /*On fail goto*//*Label 7959*/ GIMT_Encode4(411198), // Rule ID 6154 //
     /* 411104 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411107 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411111 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411115 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411119 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411124 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411128 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411132 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411136 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411141 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411145 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411147 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411147 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411150 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411154 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411159 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411162 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411166 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411169 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411174 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411179 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411182 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411184 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411186 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 411190 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411193 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411196 */     GIR_RootConstrainSelectedInstOperands,
     /* 411197 */     // GIR_Coverage, 6154,
     /* 411197 */     GIR_EraseRootFromParent_Done,
     /* 411198 */   // Label 7959: @411198
     /* 411198 */   GIM_Try, /*On fail goto*//*Label 7960*/ GIMT_Encode4(411294), // Rule ID 6186 //
     /* 411203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411206 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411210 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411214 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411218 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411222 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411226 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411230 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411235 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411239 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411243 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411245 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411245 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411248 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411252 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411257 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411260 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411264 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411267 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411272 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411277 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411280 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411282 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411284 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411286 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411289 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411292 */     GIR_RootConstrainSelectedInstOperands,
     /* 411293 */     // GIR_Coverage, 6186,
     /* 411293 */     GIR_EraseRootFromParent_Done,
     /* 411294 */   // Label 7960: @411294
     /* 411294 */   GIM_Try, /*On fail goto*//*Label 7961*/ GIMT_Encode4(411393), // Rule ID 6218 //
     /* 411299 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411302 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411306 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411310 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411314 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411319 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 411323 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411327 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411331 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411336 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411340 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411342 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411342 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411345 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411349 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411354 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411357 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411361 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411364 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411369 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411374 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411377 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411379 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411381 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 411385 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411388 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411391 */     GIR_RootConstrainSelectedInstOperands,
     /* 411392 */     // GIR_Coverage, 6218,
     /* 411392 */     GIR_EraseRootFromParent_Done,
     /* 411393 */   // Label 7961: @411393
     /* 411393 */   GIM_Try, /*On fail goto*//*Label 7962*/ GIMT_Encode4(411486), // Rule ID 6262 //
     /* 411398 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411402 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411406 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411410 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411414 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411418 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411422 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411426 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411431 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411435 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411437 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411437 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411440 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411444 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411449 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411452 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411456 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411459 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411464 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411469 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411472 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411474 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411476 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411478 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411481 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411484 */     GIR_RootConstrainSelectedInstOperands,
     /* 411485 */     // GIR_Coverage, 6262,
     /* 411485 */     GIR_EraseRootFromParent_Done,
     /* 411486 */   // Label 7962: @411486
     /* 411486 */   GIM_Try, /*On fail goto*//*Label 7963*/ GIMT_Encode4(411582), // Rule ID 6122 //
     /* 411491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411506 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 411518 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 411522 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411527 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411531 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 411533 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm)), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411533 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411536 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411540 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411545 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411548 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411552 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411555 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411560 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411565 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i32_indexed),
     /* 411568 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411570 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411572 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411574 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411577 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411580 */     GIR_RootConstrainSelectedInstOperands,
     /* 411581 */     // GIR_Coverage, 6122,
     /* 411581 */     GIR_EraseRootFromParent_Done,
     /* 411582 */   // Label 7963: @411582
     /* 411582 */   GIM_Try, /*On fail goto*//*Label 7964*/ GIMT_Encode4(411666), // Rule ID 2537 //
     /* 411587 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411590 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411594 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411598 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411602 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411607 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411611 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411615 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411617 */     // (strict_fma:{ *:[v2f32] } (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411617 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411620 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411624 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411629 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411632 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411636 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411639 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411644 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411654 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411656 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411658 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411661 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411664 */     GIR_RootConstrainSelectedInstOperands,
     /* 411665 */     // GIR_Coverage, 2537,
     /* 411665 */     GIR_EraseRootFromParent_Done,
     /* 411666 */   // Label 7964: @411666
     /* 411666 */   GIM_Try, /*On fail goto*//*Label 7965*/ GIMT_Encode4(411716), // Rule ID 13409 //
     /* 411671 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411674 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411678 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411682 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411686 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411691 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411695 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411701 */     // (strict_fma:{ *:[v2f32] } (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411706 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411708 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411710 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411714 */     GIR_RootConstrainSelectedInstOperands,
     /* 411715 */     // GIR_Coverage, 13409,
     /* 411715 */     GIR_EraseRootFromParent_Done,
     /* 411716 */   // Label 7965: @411716
     /* 411716 */   GIM_Try, /*On fail goto*//*Label 7966*/ GIMT_Encode4(411800), // Rule ID 6090 //
     /* 411721 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411724 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411728 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411732 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 411736 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 411740 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411745 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411749 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411751 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (AArch64dup:{ *:[v2f32] } FPR32Op:{ *:[f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2i32_indexed:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 411751 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 411754 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 411758 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 411763 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 411766 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411770 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 411773 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411778 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 411783 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i32_indexed),
     /* 411786 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411788 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411790 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411792 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 411795 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 411798 */     GIR_RootConstrainSelectedInstOperands,
     /* 411799 */     // GIR_Coverage, 6090,
     /* 411799 */     GIR_EraseRootFromParent_Done,
     /* 411800 */   // Label 7966: @411800
     /* 411800 */   GIM_Try, /*On fail goto*//*Label 7967*/ GIMT_Encode4(411850), // Rule ID 1307 //
     /* 411805 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411808 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411812 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 411816 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411820 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 411824 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411833 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 411835 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, (fneg:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm), V64:{ *:[v2f32] }:$Rd)  =>  (FMLSv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411835 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f32),
     /* 411838 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411840 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411842 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 411844 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 411848 */     GIR_RootConstrainSelectedInstOperands,
     /* 411849 */     // GIR_Coverage, 1307,
     /* 411849 */     GIR_EraseRootFromParent_Done,
     /* 411850 */   // Label 7967: @411850
     /* 411850 */   GIM_Try, /*On fail goto*//*Label 7968*/ GIMT_Encode4(411883), // Rule ID 1297 //
     /* 411855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411858 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411862 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411866 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 411870 */     // (strict_fma:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rd)  =>  (FMLAv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rd, V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 411870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f32),
     /* 411873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411879 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 411881 */     GIR_RootConstrainSelectedInstOperands,
     /* 411882 */     // GIR_Coverage, 1297,
     /* 411882 */     GIR_EraseRootFromParent_Done,
     /* 411883 */   // Label 7968: @411883
     /* 411883 */   GIM_Reject,
     /* 411884 */ // Label 7949: @411884
     /* 411884 */ GIM_Reject,
     /* 411885 */ // Label 7853: @411885
     /* 411885 */ GIM_Try, /*On fail goto*//*Label 7969*/ GIMT_Encode4(413405),
     /* 411890 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411893 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 411896 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 411899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411903 */   GIM_Try, /*On fail goto*//*Label 7970*/ GIMT_Encode4(411981), // Rule ID 6248 //
     /* 411908 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411912 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411916 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411920 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 411924 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 411928 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 411932 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 411936 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411941 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 411945 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 411949 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 411953 */     // MIs[3] Operand 1
     /* 411953 */     // No operand predicates
     /* 411953 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411957 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 411961 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 411963 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 411963 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 411966 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 411968 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 411970 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 411972 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 411976 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 411979 */     GIR_RootConstrainSelectedInstOperands,
     /* 411980 */     // GIR_Coverage, 6248,
     /* 411980 */     GIR_EraseRootFromParent_Done,
     /* 411981 */   // Label 7970: @411981
     /* 411981 */   GIM_Try, /*On fail goto*//*Label 7971*/ GIMT_Encode4(412065), // Rule ID 6160 //
     /* 411986 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 411989 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 411993 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 411997 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412001 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412005 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412010 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412014 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412018 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412022 */     // MIs[2] Operand 1
     /* 412022 */     // No operand predicates
     /* 412022 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 412026 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412030 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412034 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412039 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412043 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412045 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412045 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412048 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412050 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412052 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 412056 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412060 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412063 */     GIR_RootConstrainSelectedInstOperands,
     /* 412064 */     // GIR_Coverage, 6160,
     /* 412064 */     GIR_EraseRootFromParent_Done,
     /* 412065 */   // Label 7971: @412065
     /* 412065 */   GIM_Try, /*On fail goto*//*Label 7972*/ GIMT_Encode4(412146), // Rule ID 6192 //
     /* 412070 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412073 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412077 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412081 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412085 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412089 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412093 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412097 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412101 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412106 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412110 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412114 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412118 */     // MIs[3] Operand 1
     /* 412118 */     // No operand predicates
     /* 412118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412122 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412126 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412128 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412128 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412131 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412133 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412135 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412137 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412141 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412144 */     GIR_RootConstrainSelectedInstOperands,
     /* 412145 */     // GIR_Coverage, 6192,
     /* 412145 */     GIR_EraseRootFromParent_Done,
     /* 412146 */   // Label 7972: @412146
     /* 412146 */   GIM_Try, /*On fail goto*//*Label 7973*/ GIMT_Encode4(412230), // Rule ID 6224 //
     /* 412151 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412154 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412158 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412162 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412166 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412171 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412175 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412179 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412183 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412192 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412196 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412200 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412204 */     // MIs[3] Operand 1
     /* 412204 */     // No operand predicates
     /* 412204 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412208 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412210 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412210 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412213 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412215 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412217 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412221 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412225 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412228 */     GIR_RootConstrainSelectedInstOperands,
     /* 412229 */     // GIR_Coverage, 6224,
     /* 412229 */     GIR_EraseRootFromParent_Done,
     /* 412230 */   // Label 7973: @412230
     /* 412230 */   GIM_Try, /*On fail goto*//*Label 7974*/ GIMT_Encode4(412308), // Rule ID 6270 //
     /* 412235 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412239 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412243 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412247 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412251 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412255 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412259 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412263 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412267 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412272 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 412276 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412280 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412284 */     // MIs[3] Operand 1
     /* 412284 */     // No operand predicates
     /* 412284 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412288 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412290 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412290 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412293 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412295 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412297 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412299 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412303 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412306 */     GIR_RootConstrainSelectedInstOperands,
     /* 412307 */     // GIR_Coverage, 6270,
     /* 412307 */     GIR_EraseRootFromParent_Done,
     /* 412308 */   // Label 7974: @412308
     /* 412308 */   GIM_Try, /*On fail goto*//*Label 7975*/ GIMT_Encode4(412389), // Rule ID 6128 //
     /* 412313 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412316 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412320 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412324 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412328 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412332 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412336 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412340 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412344 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 412348 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412353 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 412357 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412361 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412365 */     // MIs[3] Operand 1
     /* 412365 */     // No operand predicates
     /* 412365 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412369 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 412371 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412371 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412374 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412376 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412378 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412380 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412384 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 412387 */     GIR_RootConstrainSelectedInstOperands,
     /* 412388 */     // GIR_Coverage, 6128,
     /* 412388 */     GIR_EraseRootFromParent_Done,
     /* 412389 */   // Label 7975: @412389
     /* 412389 */   GIM_Try, /*On fail goto*//*Label 7976*/ GIMT_Encode4(412458), // Rule ID 2543 //
     /* 412394 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412397 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412401 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412405 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412409 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412413 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412418 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412422 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412426 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412430 */     // MIs[2] Operand 1
     /* 412430 */     // No operand predicates
     /* 412430 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412434 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412438 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412440 */     // (strict_fma:{ *:[v2f64] } (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412440 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412443 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412445 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412447 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412449 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412453 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412456 */     GIR_RootConstrainSelectedInstOperands,
     /* 412457 */     // GIR_Coverage, 2543,
     /* 412457 */     GIR_EraseRootFromParent_Done,
     /* 412458 */   // Label 7976: @412458
     /* 412458 */   GIM_Try, /*On fail goto*//*Label 7977*/ GIMT_Encode4(412527), // Rule ID 6096 //
     /* 412463 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412466 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412470 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412474 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE64),
     /* 412478 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412482 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 412486 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412491 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 412495 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 412499 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 412503 */     // MIs[2] Operand 1
     /* 412503 */     // No operand predicates
     /* 412503 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412507 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412509 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 412509 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 412512 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412514 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412516 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412518 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412522 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 412525 */     GIR_RootConstrainSelectedInstOperands,
     /* 412526 */     // GIR_Coverage, 6096,
     /* 412526 */     GIR_EraseRootFromParent_Done,
     /* 412527 */   // Label 7977: @412527
     /* 412527 */   GIM_Try, /*On fail goto*//*Label 7978*/ GIMT_Encode4(412620), // Rule ID 6250 //
     /* 412532 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412536 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412540 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412544 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412548 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412552 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412556 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412569 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412571 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412571 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412574 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412578 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412583 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412586 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412590 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412593 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412598 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412603 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412606 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412608 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412610 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412612 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412615 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412618 */     GIR_RootConstrainSelectedInstOperands,
     /* 412619 */     // GIR_Coverage, 6250,
     /* 412619 */     GIR_EraseRootFromParent_Done,
     /* 412620 */   // Label 7978: @412620
     /* 412620 */   GIM_Try, /*On fail goto*//*Label 7979*/ GIMT_Encode4(412719), // Rule ID 6162 //
     /* 412625 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412628 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412632 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412636 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412640 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412645 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412649 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412653 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412657 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412662 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412666 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412668 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412668 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412671 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412675 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412680 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412683 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 412687 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412690 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412695 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412700 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412703 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412705 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412707 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 412711 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412714 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412717 */     GIR_RootConstrainSelectedInstOperands,
     /* 412718 */     // GIR_Coverage, 6162,
     /* 412718 */     GIR_EraseRootFromParent_Done,
     /* 412719 */   // Label 7979: @412719
     /* 412719 */   GIM_Try, /*On fail goto*//*Label 7980*/ GIMT_Encode4(412815), // Rule ID 6194 //
     /* 412724 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412727 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412731 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412735 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412739 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412743 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412747 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412751 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412760 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412764 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412766 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412766 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412769 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412773 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412778 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412781 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412785 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412788 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412793 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412798 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412801 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412803 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412805 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 412807 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412810 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412813 */     GIR_RootConstrainSelectedInstOperands,
     /* 412814 */     // GIR_Coverage, 6194,
     /* 412814 */     GIR_EraseRootFromParent_Done,
     /* 412815 */   // Label 7980: @412815
     /* 412815 */   GIM_Try, /*On fail goto*//*Label 7981*/ GIMT_Encode4(412914), // Rule ID 6226 //
     /* 412820 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 412823 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 412827 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412831 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 412835 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412840 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 412844 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 412848 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412852 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412857 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412861 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412863 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412863 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412866 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412870 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412875 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412878 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412882 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412885 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412890 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412895 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412898 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412900 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412902 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 412906 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 412909 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 412912 */     GIR_RootConstrainSelectedInstOperands,
     /* 412913 */     // GIR_Coverage, 6226,
     /* 412913 */     GIR_EraseRootFromParent_Done,
     /* 412914 */   // Label 7981: @412914
     /* 412914 */   GIM_Try, /*On fail goto*//*Label 7982*/ GIMT_Encode4(413007), // Rule ID 6272 //
     /* 412919 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412923 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 412927 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 412931 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 412935 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 412939 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 412943 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 412947 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412952 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412956 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 412958 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } (fneg:{ *:[f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 412958 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 412961 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 412965 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 412970 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 412973 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 412977 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 412980 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 412985 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 412990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 412993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 412995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 412997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 412999 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413002 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413005 */     GIR_RootConstrainSelectedInstOperands,
     /* 413006 */     // GIR_Coverage, 6272,
     /* 413006 */     GIR_EraseRootFromParent_Done,
     /* 413007 */   // Label 7982: @413007
     /* 413007 */   GIM_Try, /*On fail goto*//*Label 7983*/ GIMT_Encode4(413103), // Rule ID 6130 //
     /* 413012 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413015 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413019 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413023 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413027 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413031 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413035 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 413039 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s64,
     /* 413043 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413048 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413052 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413054 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm)), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413054 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413057 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413061 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413066 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413069 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413073 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413076 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413081 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413086 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2i64_indexed),
     /* 413089 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413091 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413093 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413095 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413098 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413101 */     GIR_RootConstrainSelectedInstOperands,
     /* 413102 */     // GIR_Coverage, 6130,
     /* 413102 */     GIR_EraseRootFromParent_Done,
     /* 413103 */   // Label 7983: @413103
     /* 413103 */   GIM_Try, /*On fail goto*//*Label 7984*/ GIMT_Encode4(413187), // Rule ID 2545 //
     /* 413108 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413111 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413115 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413119 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413123 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413128 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413132 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413136 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413138 */     // (strict_fma:{ *:[v2f64] } (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413138 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413141 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413145 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413150 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413153 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413157 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413160 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413165 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413170 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413173 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413175 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413177 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413179 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413182 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413185 */     GIR_RootConstrainSelectedInstOperands,
     /* 413186 */     // GIR_Coverage, 2545,
     /* 413186 */     GIR_EraseRootFromParent_Done,
     /* 413187 */   // Label 7984: @413187
     /* 413187 */   GIM_Try, /*On fail goto*//*Label 7985*/ GIMT_Encode4(413237), // Rule ID 13413 //
     /* 413192 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413195 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413199 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413203 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413207 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413212 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413216 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413220 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413222 */     // (strict_fma:{ *:[v2f64] } (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413222 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 413225 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413227 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413229 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413231 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413235 */     GIR_RootConstrainSelectedInstOperands,
     /* 413236 */     // GIR_Coverage, 13413,
     /* 413236 */     GIR_EraseRootFromParent_Done,
     /* 413237 */   // Label 7985: @413237
     /* 413237 */   GIM_Try, /*On fail goto*//*Label 7986*/ GIMT_Encode4(413321), // Rule ID 6098 //
     /* 413242 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413245 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413249 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413253 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413257 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s64,
     /* 413261 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413270 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413272 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (AArch64dup:{ *:[v2f64] } FPR64Op:{ *:[f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2i64_indexed:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR64Op:{ *:[f64] }:$Rm, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413272 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 413275 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413279 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413284 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413287 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413291 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 413294 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413299 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413304 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2i64_indexed),
     /* 413307 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413309 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413311 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413313 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413316 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413319 */     GIR_RootConstrainSelectedInstOperands,
     /* 413320 */     // GIR_Coverage, 6098,
     /* 413320 */     GIR_EraseRootFromParent_Done,
     /* 413321 */   // Label 7986: @413321
     /* 413321 */   GIM_Try, /*On fail goto*//*Label 7987*/ GIMT_Encode4(413371), // Rule ID 1311 //
     /* 413326 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413329 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413333 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413337 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413341 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 413345 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413350 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413354 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 413356 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm), V128:{ *:[v2f64] }:$Rd)  =>  (FMLSv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413356 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv2f64),
     /* 413359 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413361 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413363 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413365 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413369 */     GIR_RootConstrainSelectedInstOperands,
     /* 413370 */     // GIR_Coverage, 1311,
     /* 413370 */     GIR_EraseRootFromParent_Done,
     /* 413371 */   // Label 7987: @413371
     /* 413371 */   GIM_Try, /*On fail goto*//*Label 7988*/ GIMT_Encode4(413404), // Rule ID 1301 //
     /* 413376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 413379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413387 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413391 */     // (strict_fma:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rd)  =>  (FMLAv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rd, V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 413391 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv2f64),
     /* 413394 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413396 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413398 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413400 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 413402 */     GIR_RootConstrainSelectedInstOperands,
     /* 413403 */     // GIR_Coverage, 1301,
     /* 413403 */     GIR_EraseRootFromParent_Done,
     /* 413404 */   // Label 7988: @413404
     /* 413404 */   GIM_Reject,
     /* 413405 */ // Label 7969: @413405
     /* 413405 */ GIM_Reject,
     /* 413406 */ // Label 7854: @413406
     /* 413406 */ GIM_Try, /*On fail goto*//*Label 7989*/ GIMT_Encode4(414584),
     /* 413411 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413414 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 413417 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 413420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413424 */   GIM_Try, /*On fail goto*//*Label 7990*/ GIMT_Encode4(413508), // Rule ID 6144 //
     /* 413429 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413432 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413436 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413440 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413444 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413448 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413453 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413457 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413461 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413465 */     // MIs[2] Operand 1
     /* 413465 */     // No operand predicates
     /* 413465 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 413469 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413473 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413477 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413482 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413486 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413488 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413488 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413491 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413493 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413495 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 413499 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413503 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413506 */     GIR_RootConstrainSelectedInstOperands,
     /* 413507 */     // GIR_Coverage, 6144,
     /* 413507 */     GIR_EraseRootFromParent_Done,
     /* 413508 */   // Label 7990: @413508
     /* 413508 */   GIM_Try, /*On fail goto*//*Label 7991*/ GIMT_Encode4(413589), // Rule ID 6176 //
     /* 413513 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413516 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413520 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413524 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413528 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413532 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413536 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413540 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413544 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413549 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413553 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413557 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413561 */     // MIs[3] Operand 1
     /* 413561 */     // No operand predicates
     /* 413561 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413565 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413569 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413571 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413571 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413574 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413576 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413578 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413580 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413584 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413587 */     GIR_RootConstrainSelectedInstOperands,
     /* 413588 */     // GIR_Coverage, 6176,
     /* 413588 */     GIR_EraseRootFromParent_Done,
     /* 413589 */   // Label 7991: @413589
     /* 413589 */   GIM_Try, /*On fail goto*//*Label 7992*/ GIMT_Encode4(413673), // Rule ID 6208 //
     /* 413594 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413597 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413601 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413605 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413609 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413614 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413618 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413622 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413626 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413630 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413635 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413639 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413643 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413647 */     // MIs[3] Operand 1
     /* 413647 */     // No operand predicates
     /* 413647 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413651 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413653 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413653 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413656 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413658 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413660 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 413664 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413668 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413671 */     GIR_RootConstrainSelectedInstOperands,
     /* 413672 */     // GIR_Coverage, 6208,
     /* 413672 */     GIR_EraseRootFromParent_Done,
     /* 413673 */   // Label 7992: @413673
     /* 413673 */   GIM_Try, /*On fail goto*//*Label 7993*/ GIMT_Encode4(413754), // Rule ID 6112 //
     /* 413678 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413681 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413697 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 413701 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413705 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413709 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 413713 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413718 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 413722 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413726 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413730 */     // MIs[3] Operand 1
     /* 413730 */     // No operand predicates
     /* 413730 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413734 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 413736 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413736 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413739 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413741 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413743 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 413749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 413752 */     GIR_RootConstrainSelectedInstOperands,
     /* 413753 */     // GIR_Coverage, 6112,
     /* 413753 */     GIR_EraseRootFromParent_Done,
     /* 413754 */   // Label 7993: @413754
     /* 413754 */   GIM_Try, /*On fail goto*//*Label 7994*/ GIMT_Encode4(413823), // Rule ID 2527 //
     /* 413759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413774 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413778 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413783 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413787 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413791 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413795 */     // MIs[2] Operand 1
     /* 413795 */     // No operand predicates
     /* 413795 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413799 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413805 */     // (strict_fma:{ *:[v4f16] } (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413810 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413812 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 413814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413818 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413821 */     GIR_RootConstrainSelectedInstOperands,
     /* 413822 */     // GIR_Coverage, 2527,
     /* 413822 */     GIR_EraseRootFromParent_Done,
     /* 413823 */   // Label 7994: @413823
     /* 413823 */   GIM_Try, /*On fail goto*//*Label 7995*/ GIMT_Encode4(413892), // Rule ID 6080 //
     /* 413828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413835 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 413839 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 413843 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 413847 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 413851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 413856 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 413860 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 413864 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 413868 */     // MIs[2] Operand 1
     /* 413868 */     // No operand predicates
     /* 413868 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413872 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413874 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64duplane16:{ *:[v4f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 413874 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 413877 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413879 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413881 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 413883 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413887 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 413890 */     GIR_RootConstrainSelectedInstOperands,
     /* 413891 */     // GIR_Coverage, 6080,
     /* 413891 */     GIR_EraseRootFromParent_Done,
     /* 413892 */   // Label 7995: @413892
     /* 413892 */   GIM_Try, /*On fail goto*//*Label 7996*/ GIMT_Encode4(413991), // Rule ID 6146 //
     /* 413897 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413900 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 413904 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 413908 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 413912 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413917 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 413921 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 413925 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 413929 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413934 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 413938 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 413940 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 413940 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 413943 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 413947 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 413952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 413955 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 413959 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 413962 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 413967 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 413972 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 413975 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 413977 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 413979 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 413983 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 413986 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 413989 */     GIR_RootConstrainSelectedInstOperands,
     /* 413990 */     // GIR_Coverage, 6146,
     /* 413990 */     GIR_EraseRootFromParent_Done,
     /* 413991 */   // Label 7996: @413991
     /* 413991 */   GIM_Try, /*On fail goto*//*Label 7997*/ GIMT_Encode4(414087), // Rule ID 6178 //
     /* 413996 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 413999 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414003 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414007 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414011 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414015 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414019 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414023 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414028 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414032 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414036 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414038 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414038 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414041 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414045 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414050 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414053 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414057 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414060 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414065 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414070 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414073 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414075 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414077 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414079 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414082 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414085 */     GIR_RootConstrainSelectedInstOperands,
     /* 414086 */     // GIR_Coverage, 6178,
     /* 414086 */     GIR_EraseRootFromParent_Done,
     /* 414087 */   // Label 7997: @414087
     /* 414087 */   GIM_Try, /*On fail goto*//*Label 7998*/ GIMT_Encode4(414186), // Rule ID 6210 //
     /* 414092 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414095 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414099 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414103 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414107 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414112 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414116 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414120 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414124 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414129 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414133 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414135 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414135 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414138 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414142 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414147 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414150 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414154 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414157 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414162 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414172 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414178 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414181 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414184 */     GIR_RootConstrainSelectedInstOperands,
     /* 414185 */     // GIR_Coverage, 6210,
     /* 414185 */     GIR_EraseRootFromParent_Done,
     /* 414186 */   // Label 7998: @414186
     /* 414186 */   GIM_Try, /*On fail goto*//*Label 7999*/ GIMT_Encode4(414282), // Rule ID 6114 //
     /* 414191 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414194 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414198 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414202 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414206 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414210 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414214 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 414218 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 414222 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414227 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414231 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 414233 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414233 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414236 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414240 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414245 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414248 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414252 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414255 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414260 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414265 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i16_indexed),
     /* 414268 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414270 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414272 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414274 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414277 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414280 */     GIR_RootConstrainSelectedInstOperands,
     /* 414281 */     // GIR_Coverage, 6114,
     /* 414281 */     GIR_EraseRootFromParent_Done,
     /* 414282 */   // Label 7999: @414282
     /* 414282 */   GIM_Try, /*On fail goto*//*Label 8000*/ GIMT_Encode4(414366), // Rule ID 2529 //
     /* 414287 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414290 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414294 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414298 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414302 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414307 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414311 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414315 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414317 */     // (strict_fma:{ *:[v4f16] } (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414317 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414320 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414324 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414329 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414332 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414336 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414339 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414344 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414349 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 414352 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414354 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414356 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414358 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414361 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414364 */     GIR_RootConstrainSelectedInstOperands,
     /* 414365 */     // GIR_Coverage, 2529,
     /* 414365 */     GIR_EraseRootFromParent_Done,
     /* 414366 */   // Label 8000: @414366
     /* 414366 */   GIM_Try, /*On fail goto*//*Label 8001*/ GIMT_Encode4(414416), // Rule ID 13405 //
     /* 414371 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414374 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414378 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414382 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414386 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414391 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414395 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414401 */     // (strict_fma:{ *:[v4f16] } (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 414404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414414 */     GIR_RootConstrainSelectedInstOperands,
     /* 414415 */     // GIR_Coverage, 13405,
     /* 414415 */     GIR_EraseRootFromParent_Done,
     /* 414416 */   // Label 8001: @414416
     /* 414416 */   GIM_Try, /*On fail goto*//*Label 8002*/ GIMT_Encode4(414500), // Rule ID 6082 //
     /* 414421 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414424 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414428 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414432 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 414436 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 414440 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414445 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414449 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414451 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (AArch64dup:{ *:[v4f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4i16_indexed:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 414451 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 414454 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 414458 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 414463 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 414466 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414470 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 414473 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414478 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 414483 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i16_indexed),
     /* 414486 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414488 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414490 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414492 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 414495 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 414498 */     GIR_RootConstrainSelectedInstOperands,
     /* 414499 */     // GIR_Coverage, 6082,
     /* 414499 */     GIR_EraseRootFromParent_Done,
     /* 414500 */   // Label 8002: @414500
     /* 414500 */   GIM_Try, /*On fail goto*//*Label 8003*/ GIMT_Encode4(414550), // Rule ID 1303 //
     /* 414505 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414508 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414512 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414516 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414520 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 414524 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414529 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 414535 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, (fneg:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm), V64:{ *:[v4f16] }:$Rd)  =>  (FMLSv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f16),
     /* 414538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414540 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414542 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414544 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414548 */     GIR_RootConstrainSelectedInstOperands,
     /* 414549 */     // GIR_Coverage, 1303,
     /* 414549 */     GIR_EraseRootFromParent_Done,
     /* 414550 */   // Label 8003: @414550
     /* 414550 */   GIM_Try, /*On fail goto*//*Label 8004*/ GIMT_Encode4(414583), // Rule ID 1293 //
     /* 414555 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 414558 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414562 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414566 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 414570 */     // (strict_fma:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rd)  =>  (FMLAv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rd, V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 414570 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f16),
     /* 414573 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414575 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414577 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414579 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 414581 */     GIR_RootConstrainSelectedInstOperands,
     /* 414582 */     // GIR_Coverage, 1293,
     /* 414582 */     GIR_EraseRootFromParent_Done,
     /* 414583 */   // Label 8004: @414583
     /* 414583 */   GIM_Reject,
     /* 414584 */ // Label 7989: @414584
     /* 414584 */ GIM_Reject,
     /* 414585 */ // Label 7855: @414585
     /* 414585 */ GIM_Try, /*On fail goto*//*Label 8005*/ GIMT_Encode4(416105),
     /* 414590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 414596 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 414599 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414603 */   GIM_Try, /*On fail goto*//*Label 8006*/ GIMT_Encode4(414681), // Rule ID 6242 //
     /* 414608 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414612 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414616 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414620 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414624 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414628 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414632 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414636 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414641 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 414645 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414649 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414653 */     // MIs[3] Operand 1
     /* 414653 */     // No operand predicates
     /* 414653 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414657 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414661 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414663 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414663 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414666 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414668 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414679 */     GIR_RootConstrainSelectedInstOperands,
     /* 414680 */     // GIR_Coverage, 6242,
     /* 414680 */     GIR_EraseRootFromParent_Done,
     /* 414681 */   // Label 8006: @414681
     /* 414681 */   GIM_Try, /*On fail goto*//*Label 8007*/ GIMT_Encode4(414765), // Rule ID 6156 //
     /* 414686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414689 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414693 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414697 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414701 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414705 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414710 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 414714 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414718 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414722 */     // MIs[2] Operand 1
     /* 414722 */     // No operand predicates
     /* 414722 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 414726 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414730 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414734 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414739 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414743 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414745 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414745 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414748 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414750 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414752 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 414756 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 414760 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 414763 */     GIR_RootConstrainSelectedInstOperands,
     /* 414764 */     // GIR_Coverage, 6156,
     /* 414764 */     GIR_EraseRootFromParent_Done,
     /* 414765 */   // Label 8007: @414765
     /* 414765 */   GIM_Try, /*On fail goto*//*Label 8008*/ GIMT_Encode4(414846), // Rule ID 6188 //
     /* 414770 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414781 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414793 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414797 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414801 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414806 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414810 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414814 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414818 */     // MIs[3] Operand 1
     /* 414818 */     // No operand predicates
     /* 414818 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414822 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414826 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414828 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414828 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414831 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414833 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 414837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414844 */     GIR_RootConstrainSelectedInstOperands,
     /* 414845 */     // GIR_Coverage, 6188,
     /* 414845 */     GIR_EraseRootFromParent_Done,
     /* 414846 */   // Label 8008: @414846
     /* 414846 */   GIM_Try, /*On fail goto*//*Label 8009*/ GIMT_Encode4(414930), // Rule ID 6220 //
     /* 414851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 414854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 414858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414866 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414871 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 414875 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414879 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414883 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 414887 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414892 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 414896 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414900 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414904 */     // MIs[3] Operand 1
     /* 414904 */     // No operand predicates
     /* 414904 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414908 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414910 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414910 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414913 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414915 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414917 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 414921 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 414925 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 414928 */     GIR_RootConstrainSelectedInstOperands,
     /* 414929 */     // GIR_Coverage, 6220,
     /* 414929 */     GIR_EraseRootFromParent_Done,
     /* 414930 */   // Label 8009: @414930
     /* 414930 */   GIM_Try, /*On fail goto*//*Label 8010*/ GIMT_Encode4(415008), // Rule ID 6264 //
     /* 414935 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414939 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 414943 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 414947 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414951 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 414955 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 414959 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 414963 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 414967 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414972 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/1, /*OpIdx*/2, // MIs[3]
     /* 414976 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 414980 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 414984 */     // MIs[3] Operand 1
     /* 414984 */     // No operand predicates
     /* 414984 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 414988 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 414990 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 414990 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 414993 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 414995 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 414997 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 414999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415003 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415006 */     GIR_RootConstrainSelectedInstOperands,
     /* 415007 */     // GIR_Coverage, 6264,
     /* 415007 */     GIR_EraseRootFromParent_Done,
     /* 415008 */   // Label 8010: @415008
     /* 415008 */   GIM_Try, /*On fail goto*//*Label 8011*/ GIMT_Encode4(415089), // Rule ID 6124 //
     /* 415013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415016 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415020 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415024 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415028 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415032 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415036 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415040 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415044 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 415048 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415053 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 415057 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415061 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415065 */     // MIs[3] Operand 1
     /* 415065 */     // No operand predicates
     /* 415065 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415069 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 415071 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415071 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415074 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415076 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415078 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415080 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415084 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 415087 */     GIR_RootConstrainSelectedInstOperands,
     /* 415088 */     // GIR_Coverage, 6124,
     /* 415088 */     GIR_EraseRootFromParent_Done,
     /* 415089 */   // Label 8011: @415089
     /* 415089 */   GIM_Try, /*On fail goto*//*Label 8012*/ GIMT_Encode4(415158), // Rule ID 2539 //
     /* 415094 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415097 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415101 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415105 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415109 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415113 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415118 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415122 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415126 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415130 */     // MIs[2] Operand 1
     /* 415130 */     // No operand predicates
     /* 415130 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415134 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415138 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415140 */     // (strict_fma:{ *:[v4f32] } (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415140 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415143 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415145 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415147 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415149 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415153 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415156 */     GIR_RootConstrainSelectedInstOperands,
     /* 415157 */     // GIR_Coverage, 2539,
     /* 415157 */     GIR_EraseRootFromParent_Done,
     /* 415158 */   // Label 8012: @415158
     /* 415158 */   GIM_Try, /*On fail goto*//*Label 8013*/ GIMT_Encode4(415227), // Rule ID 6092 //
     /* 415163 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415166 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415170 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415174 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 415178 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415182 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 415186 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415191 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 415195 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 415199 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 415203 */     // MIs[2] Operand 1
     /* 415203 */     // No operand predicates
     /* 415203 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415207 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415209 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)
     /* 415209 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415212 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415214 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415218 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415222 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 415225 */     GIR_RootConstrainSelectedInstOperands,
     /* 415226 */     // GIR_Coverage, 6092,
     /* 415226 */     GIR_EraseRootFromParent_Done,
     /* 415227 */   // Label 8013: @415227
     /* 415227 */   GIM_Try, /*On fail goto*//*Label 8014*/ GIMT_Encode4(415320), // Rule ID 6246 //
     /* 415232 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415236 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415240 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415244 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415248 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415252 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415256 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415269 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415271 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415271 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415274 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415278 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415283 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415286 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415290 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415293 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415298 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415308 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415310 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415312 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415315 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415318 */     GIR_RootConstrainSelectedInstOperands,
     /* 415319 */     // GIR_Coverage, 6246,
     /* 415319 */     GIR_EraseRootFromParent_Done,
     /* 415320 */   // Label 8014: @415320
     /* 415320 */   GIM_Try, /*On fail goto*//*Label 8015*/ GIMT_Encode4(415419), // Rule ID 6158 //
     /* 415325 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415328 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415332 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415336 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415340 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415345 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415349 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415353 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415357 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415362 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415366 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415368 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415368 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415371 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415375 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415380 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415383 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415387 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415390 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415395 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415400 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415403 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415405 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415407 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 415411 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415414 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415417 */     GIR_RootConstrainSelectedInstOperands,
     /* 415418 */     // GIR_Coverage, 6158,
     /* 415418 */     GIR_EraseRootFromParent_Done,
     /* 415419 */   // Label 8015: @415419
     /* 415419 */   GIM_Try, /*On fail goto*//*Label 8016*/ GIMT_Encode4(415515), // Rule ID 6190 //
     /* 415424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415427 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415431 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415435 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415447 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415451 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415456 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415460 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415464 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415466 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415466 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415469 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415473 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415478 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415481 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415485 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415488 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415493 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415498 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415501 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415503 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415507 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415510 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415513 */     GIR_RootConstrainSelectedInstOperands,
     /* 415514 */     // GIR_Coverage, 6190,
     /* 415514 */     GIR_EraseRootFromParent_Done,
     /* 415515 */   // Label 8016: @415515
     /* 415515 */   GIM_Try, /*On fail goto*//*Label 8017*/ GIMT_Encode4(415614), // Rule ID 6222 //
     /* 415520 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415523 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415527 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415531 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415535 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415540 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 415544 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415548 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415552 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415557 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415561 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415563 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415563 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415566 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415570 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415575 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415578 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415582 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415585 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415590 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415595 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415598 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415600 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415602 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 415606 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415609 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415612 */     GIR_RootConstrainSelectedInstOperands,
     /* 415613 */     // GIR_Coverage, 6222,
     /* 415613 */     GIR_EraseRootFromParent_Done,
     /* 415614 */   // Label 8017: @415614
     /* 415614 */   GIM_Try, /*On fail goto*//*Label 8018*/ GIMT_Encode4(415707), // Rule ID 6268 //
     /* 415619 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415623 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415627 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415631 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415635 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415639 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415643 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415647 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415652 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415656 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415658 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } (fneg:{ *:[f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415658 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415661 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415665 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415670 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415673 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415677 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415680 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415685 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415690 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415693 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415695 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415697 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415699 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415702 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415705 */     GIR_RootConstrainSelectedInstOperands,
     /* 415706 */     // GIR_Coverage, 6268,
     /* 415706 */     GIR_EraseRootFromParent_Done,
     /* 415707 */   // Label 8018: @415707
     /* 415707 */   GIM_Try, /*On fail goto*//*Label 8019*/ GIMT_Encode4(415803), // Rule ID 6126 //
     /* 415712 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415715 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415719 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415723 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415727 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415731 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 415735 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 415739 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s32,
     /* 415743 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415748 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415752 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 415754 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm)), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415754 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415757 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415761 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415766 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415769 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 415773 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415776 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415781 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415786 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4i32_indexed),
     /* 415789 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415791 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415793 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 415795 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415798 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415801 */     GIR_RootConstrainSelectedInstOperands,
     /* 415802 */     // GIR_Coverage, 6126,
     /* 415802 */     GIR_EraseRootFromParent_Done,
     /* 415803 */   // Label 8019: @415803
     /* 415803 */   GIM_Try, /*On fail goto*//*Label 8020*/ GIMT_Encode4(415887), // Rule ID 2541 //
     /* 415808 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415811 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415815 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415819 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415823 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415828 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415832 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415836 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415838 */     // (strict_fma:{ *:[v4f32] } (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415838 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415841 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415845 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415850 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415853 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415857 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415860 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415865 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415870 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 415873 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415875 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415877 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415879 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 415882 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 415885 */     GIR_RootConstrainSelectedInstOperands,
     /* 415886 */     // GIR_Coverage, 2541,
     /* 415886 */     GIR_EraseRootFromParent_Done,
     /* 415887 */   // Label 8020: @415887
     /* 415887 */   GIM_Try, /*On fail goto*//*Label 8021*/ GIMT_Encode4(415937), // Rule ID 13411 //
     /* 415892 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415895 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 415899 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 415903 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 415907 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415912 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415916 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415920 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415922 */     // (strict_fma:{ *:[v4f32] } (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 415922 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 415925 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 415927 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 415929 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 415931 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415935 */     GIR_RootConstrainSelectedInstOperands,
     /* 415936 */     // GIR_Coverage, 13411,
     /* 415936 */     GIR_EraseRootFromParent_Done,
     /* 415937 */   // Label 8021: @415937
     /* 415937 */   GIM_Try, /*On fail goto*//*Label 8022*/ GIMT_Encode4(416021), // Rule ID 6094 //
     /* 415942 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 415945 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415949 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 415953 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 415957 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s32,
     /* 415961 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 415966 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415970 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 415972 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (AArch64dup:{ *:[v4f32] } FPR32Op:{ *:[f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4i32_indexed:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, (SUBREG_TO_REG:{ *:[f128] } 0:{ *:[i32] }, FPR32Op:{ *:[f32] }:$Rm, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 415972 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 415975 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 415979 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 415984 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 415987 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 415991 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 415994 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 415999 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 416004 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4i32_indexed),
     /* 416007 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416009 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416011 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416013 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416016 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416019 */     GIR_RootConstrainSelectedInstOperands,
     /* 416020 */     // GIR_Coverage, 6094,
     /* 416020 */     GIR_EraseRootFromParent_Done,
     /* 416021 */   // Label 8022: @416021
     /* 416021 */   GIM_Try, /*On fail goto*//*Label 8023*/ GIMT_Encode4(416071), // Rule ID 1309 //
     /* 416026 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416029 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416033 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416037 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416041 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 416045 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416050 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416054 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 416056 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm), V128:{ *:[v4f32] }:$Rd)  =>  (FMLSv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416056 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv4f32),
     /* 416059 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416061 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416063 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416065 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416069 */     GIR_RootConstrainSelectedInstOperands,
     /* 416070 */     // GIR_Coverage, 1309,
     /* 416070 */     GIR_EraseRootFromParent_Done,
     /* 416071 */   // Label 8023: @416071
     /* 416071 */   GIM_Try, /*On fail goto*//*Label 8024*/ GIMT_Encode4(416104), // Rule ID 1299 //
     /* 416076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 416079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416083 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416087 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416091 */     // (strict_fma:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rd)  =>  (FMLAv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rd, V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 416091 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv4f32),
     /* 416094 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416096 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416098 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416100 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 416102 */     GIR_RootConstrainSelectedInstOperands,
     /* 416103 */     // GIR_Coverage, 1299,
     /* 416103 */     GIR_EraseRootFromParent_Done,
     /* 416104 */   // Label 8024: @416104
     /* 416104 */   GIM_Reject,
     /* 416105 */ // Label 8005: @416105
     /* 416105 */ GIM_Reject,
     /* 416106 */ // Label 7856: @416106
     /* 416106 */ GIM_Try, /*On fail goto*//*Label 8025*/ GIMT_Encode4(417284),
     /* 416111 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416114 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 416117 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 416120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416124 */   GIM_Try, /*On fail goto*//*Label 8026*/ GIMT_Encode4(416208), // Rule ID 6140 //
     /* 416129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416165 */     // MIs[2] Operand 1
     /* 416165 */     // No operand predicates
     /* 416165 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/2, // MIs[3]
     /* 416169 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416173 */     GIM_CheckType, /*MI*/3, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416177 */     GIM_CheckRegBankForClass, /*MI*/3, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416182 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416186 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416188 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416188 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416191 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416193 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416195 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/3, /*OpIdx*/1, // Rn
     /* 416199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416203 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416206 */     GIR_RootConstrainSelectedInstOperands,
     /* 416207 */     // GIR_Coverage, 6140,
     /* 416207 */     GIR_EraseRootFromParent_Done,
     /* 416208 */   // Label 8026: @416208
     /* 416208 */   GIM_Try, /*On fail goto*//*Label 8027*/ GIMT_Encode4(416289), // Rule ID 6172 //
     /* 416213 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416216 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416220 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416224 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416228 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416232 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416236 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416240 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416244 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416249 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416253 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416257 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416261 */     // MIs[3] Operand 1
     /* 416261 */     // No operand predicates
     /* 416261 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416265 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416269 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416271 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416271 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416274 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416276 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416278 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416280 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416284 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416287 */     GIR_RootConstrainSelectedInstOperands,
     /* 416288 */     // GIR_Coverage, 6172,
     /* 416288 */     GIR_EraseRootFromParent_Done,
     /* 416289 */   // Label 8027: @416289
     /* 416289 */   GIM_Try, /*On fail goto*//*Label 8028*/ GIMT_Encode4(416373), // Rule ID 6204 //
     /* 416294 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416309 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416314 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416318 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416322 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416326 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416330 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416335 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416339 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416343 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416347 */     // MIs[3] Operand 1
     /* 416347 */     // No operand predicates
     /* 416347 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416351 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416353 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416353 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416356 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416358 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416360 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416364 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416368 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416371 */     GIR_RootConstrainSelectedInstOperands,
     /* 416372 */     // GIR_Coverage, 6204,
     /* 416372 */     GIR_EraseRootFromParent_Done,
     /* 416373 */   // Label 8028: @416373
     /* 416373 */   GIM_Try, /*On fail goto*//*Label 8029*/ GIMT_Encode4(416454), // Rule ID 6108 //
     /* 416378 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416381 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416385 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416389 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416393 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416397 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416401 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416405 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416409 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 416413 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416418 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 416422 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416426 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416430 */     // MIs[3] Operand 1
     /* 416430 */     // No operand predicates
     /* 416430 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416434 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 416436 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416436 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416439 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416441 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416443 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416445 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 416452 */     GIR_RootConstrainSelectedInstOperands,
     /* 416453 */     // GIR_Coverage, 6108,
     /* 416453 */     GIR_EraseRootFromParent_Done,
     /* 416454 */   // Label 8029: @416454
     /* 416454 */   GIM_Try, /*On fail goto*//*Label 8030*/ GIMT_Encode4(416523), // Rule ID 2523 //
     /* 416459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416466 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416470 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416474 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416478 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416483 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416487 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416491 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416495 */     // MIs[2] Operand 1
     /* 416495 */     // No operand predicates
     /* 416495 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416499 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416503 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416505 */     // (strict_fma:{ *:[v8f16] } (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416505 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416508 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416510 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416512 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416514 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416518 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416521 */     GIR_RootConstrainSelectedInstOperands,
     /* 416522 */     // GIR_Coverage, 2523,
     /* 416522 */     GIR_EraseRootFromParent_Done,
     /* 416523 */   // Label 8030: @416523
     /* 416523 */   GIM_Try, /*On fail goto*//*Label 8031*/ GIMT_Encode4(416592), // Rule ID 6076 //
     /* 416528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416531 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416535 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416539 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 416543 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416547 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 416551 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 416556 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 416560 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 416564 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 416568 */     // MIs[2] Operand 1
     /* 416568 */     // No operand predicates
     /* 416568 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416572 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416574 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64duplane16:{ *:[v8f16] } V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128_lo:{ *:[v8f16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)
     /* 416574 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 416577 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416579 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416581 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416583 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416587 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 416590 */     GIR_RootConstrainSelectedInstOperands,
     /* 416591 */     // GIR_Coverage, 6076,
     /* 416591 */     GIR_EraseRootFromParent_Done,
     /* 416592 */   // Label 8031: @416592
     /* 416592 */   GIM_Try, /*On fail goto*//*Label 8032*/ GIMT_Encode4(416691), // Rule ID 6142 //
     /* 416597 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416600 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416604 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416608 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 416612 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416617 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416621 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416625 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416629 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416634 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416638 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416640 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416640 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416643 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416647 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416652 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416655 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 416659 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416662 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416667 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416672 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416675 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416677 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416679 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rn
     /* 416683 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416686 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416689 */     GIR_RootConstrainSelectedInstOperands,
     /* 416690 */     // GIR_Coverage, 6142,
     /* 416690 */     GIR_EraseRootFromParent_Done,
     /* 416691 */   // Label 8032: @416691
     /* 416691 */   GIM_Try, /*On fail goto*//*Label 8033*/ GIMT_Encode4(416787), // Rule ID 6174 //
     /* 416696 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416699 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416703 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416707 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416711 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416715 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416719 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416723 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416728 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416732 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416736 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416738 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416738 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416741 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416745 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416750 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416753 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416757 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416760 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416765 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416770 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416773 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416775 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416777 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 416779 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416782 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416785 */     GIR_RootConstrainSelectedInstOperands,
     /* 416786 */     // GIR_Coverage, 6174,
     /* 416786 */     GIR_EraseRootFromParent_Done,
     /* 416787 */   // Label 8033: @416787
     /* 416787 */   GIM_Try, /*On fail goto*//*Label 8034*/ GIMT_Encode4(416886), // Rule ID 6206 //
     /* 416792 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416795 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416799 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416803 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416807 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416812 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 416816 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416820 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416824 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416829 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416833 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416835 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416835 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416838 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416842 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416847 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416850 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416854 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416857 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416862 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416867 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416870 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416872 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416874 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 416878 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416881 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416884 */     GIR_RootConstrainSelectedInstOperands,
     /* 416885 */     // GIR_Coverage, 6206,
     /* 416885 */     GIR_EraseRootFromParent_Done,
     /* 416886 */   // Label 8034: @416886
     /* 416886 */   GIM_Try, /*On fail goto*//*Label 8035*/ GIMT_Encode4(416982), // Rule ID 6110 //
     /* 416891 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416894 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416898 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 416902 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 416906 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 416910 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 416914 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUP),
     /* 416918 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_s16,
     /* 416922 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416927 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416931 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 416933 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm)), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 416933 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 416936 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 416940 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 416945 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 416948 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 416952 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 416955 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 416960 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 416965 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8i16_indexed),
     /* 416968 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 416970 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 416972 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 416974 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 416977 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 416980 */     GIR_RootConstrainSelectedInstOperands,
     /* 416981 */     // GIR_Coverage, 6110,
     /* 416981 */     GIR_EraseRootFromParent_Done,
     /* 416982 */   // Label 8035: @416982
     /* 416982 */   GIM_Try, /*On fail goto*//*Label 8036*/ GIMT_Encode4(417066), // Rule ID 2525 //
     /* 416987 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 416990 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 416994 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 416998 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417002 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417007 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417011 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417015 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417017 */     // (strict_fma:{ *:[v8f16] } (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417017 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417020 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417024 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417029 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417032 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417036 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417039 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417044 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417049 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417052 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417054 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417056 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417058 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417061 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417064 */     GIR_RootConstrainSelectedInstOperands,
     /* 417065 */     // GIR_Coverage, 2525,
     /* 417065 */     GIR_EraseRootFromParent_Done,
     /* 417066 */   // Label 8036: @417066
     /* 417066 */   GIM_Try, /*On fail goto*//*Label 8037*/ GIMT_Encode4(417116), // Rule ID 13407 //
     /* 417071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 417078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417082 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417086 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417091 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417095 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417099 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417101 */     // (strict_fma:{ *:[v8f16] } (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417101 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 417104 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417106 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417108 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417110 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417114 */     GIR_RootConstrainSelectedInstOperands,
     /* 417115 */     // GIR_Coverage, 13407,
     /* 417115 */     GIR_EraseRootFromParent_Done,
     /* 417116 */   // Label 8037: @417116
     /* 417116 */   GIM_Try, /*On fail goto*//*Label 8038*/ GIMT_Encode4(417200), // Rule ID 6078 //
     /* 417121 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417124 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417128 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417132 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUP),
     /* 417136 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_s16,
     /* 417140 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417145 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417149 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417151 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (AArch64dup:{ *:[v8f16] } FPR16Op_lo:{ *:[f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8i16_indexed:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, (SUBREG_TO_REG:{ *:[v16i8] } 0:{ *:[i32] }, FPR16Op_lo:{ *:[f16] }:$Rm, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 417151 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 417154 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 417158 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417163 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/0,
     /* 417166 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417170 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 417173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16_loRegClassID),
     /* 417183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8i16_indexed),
     /* 417186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417188 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417190 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417192 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417195 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 417198 */     GIR_RootConstrainSelectedInstOperands,
     /* 417199 */     // GIR_Coverage, 6078,
     /* 417199 */     GIR_EraseRootFromParent_Done,
     /* 417200 */   // Label 8038: @417200
     /* 417200 */   GIM_Try, /*On fail goto*//*Label 8039*/ GIMT_Encode4(417250), // Rule ID 1305 //
     /* 417205 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417208 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417212 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 417216 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FNEG),
     /* 417220 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417224 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417229 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 417235 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm), V128:{ *:[v8f16] }:$Rd)  =>  (FMLSv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLSv8f16),
     /* 417238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417240 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417242 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 417244 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 417248 */     GIR_RootConstrainSelectedInstOperands,
     /* 417249 */     // GIR_Coverage, 1305,
     /* 417249 */     GIR_EraseRootFromParent_Done,
     /* 417250 */   // Label 8039: @417250
     /* 417250 */   GIM_Try, /*On fail goto*//*Label 8040*/ GIMT_Encode4(417283), // Rule ID 1295 //
     /* 417255 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417258 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417262 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417266 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417270 */     // (strict_fma:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rd)  =>  (FMLAv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rd, V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 417270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FMLAv8f16),
     /* 417273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 417275 */     GIR_RootToRootCopy, /*OpIdx*/3, // Rd
     /* 417277 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 417279 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rm
     /* 417281 */     GIR_RootConstrainSelectedInstOperands,
     /* 417282 */     // GIR_Coverage, 1295,
     /* 417282 */     GIR_EraseRootFromParent_Done,
     /* 417283 */   // Label 8040: @417283
     /* 417283 */   GIM_Reject,
     /* 417284 */ // Label 8025: @417284
     /* 417284 */ GIM_Reject,
     /* 417285 */ // Label 7857: @417285
     /* 417285 */ GIM_Reject,
     /* 417286 */ // Label 108: @417286
     /* 417286 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(11), /*)*//*default:*//*Label 8049*/ GIMT_Encode4(417585),
     /* 417297 */ /*GILLT_s16*//*Label 8041*/ GIMT_Encode4(417337),
     /* 417301 */ /*GILLT_s32*//*Label 8042*/ GIMT_Encode4(417368),
     /* 417305 */ /*GILLT_s64*//*Label 8043*/ GIMT_Encode4(417399), GIMT_Encode4(0),
     /* 417313 */ /*GILLT_v2s32*//*Label 8044*/ GIMT_Encode4(417430),
     /* 417317 */ /*GILLT_v2s64*//*Label 8045*/ GIMT_Encode4(417461),
     /* 417321 */ /*GILLT_v4s16*//*Label 8046*/ GIMT_Encode4(417492),
     /* 417325 */ /*GILLT_v4s32*//*Label 8047*/ GIMT_Encode4(417523), GIMT_Encode4(0),
     /* 417333 */ /*GILLT_v8s16*//*Label 8048*/ GIMT_Encode4(417554),
     /* 417337 */ // Label 8041: @417337
     /* 417337 */ GIM_Try, /*On fail goto*//*Label 8050*/ GIMT_Encode4(417367), // Rule ID 569 //
     /* 417342 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417345 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 417348 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417352 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417356 */   // (strict_fsqrt:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (FSQRTHr:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 417356 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTHr),
     /* 417361 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417365 */   GIR_RootConstrainSelectedInstOperands,
     /* 417366 */   // GIR_Coverage, 569,
     /* 417366 */   GIR_Done,
     /* 417367 */ // Label 8050: @417367
     /* 417367 */ GIM_Reject,
     /* 417368 */ // Label 8042: @417368
     /* 417368 */ GIM_Try, /*On fail goto*//*Label 8051*/ GIMT_Encode4(417398), // Rule ID 571 //
     /* 417373 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 417376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 417379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417383 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417387 */   // (strict_fsqrt:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (FSQRTSr:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 417387 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTSr),
     /* 417392 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417396 */   GIR_RootConstrainSelectedInstOperands,
     /* 417397 */   // GIR_Coverage, 571,
     /* 417397 */   GIR_Done,
     /* 417398 */ // Label 8051: @417398
     /* 417398 */ GIM_Reject,
     /* 417399 */ // Label 8043: @417399
     /* 417399 */ GIM_Try, /*On fail goto*//*Label 8052*/ GIMT_Encode4(417429), // Rule ID 573 //
     /* 417404 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFPARMv8),
     /* 417407 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 417410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417418 */   // (strict_fsqrt:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (FSQRTDr:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 417418 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTDr),
     /* 417423 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417427 */   GIR_RootConstrainSelectedInstOperands,
     /* 417428 */   // GIR_Coverage, 573,
     /* 417428 */   GIR_Done,
     /* 417429 */ // Label 8052: @417429
     /* 417429 */ GIM_Reject,
     /* 417430 */ // Label 8044: @417430
     /* 417430 */ GIM_Try, /*On fail goto*//*Label 8053*/ GIMT_Encode4(417460), // Rule ID 959 //
     /* 417435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417441 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417445 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417449 */   // (strict_fsqrt:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FSQRTv2f32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417449 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f32),
     /* 417454 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417458 */   GIR_RootConstrainSelectedInstOperands,
     /* 417459 */   // GIR_Coverage, 959,
     /* 417459 */   GIR_Done,
     /* 417460 */ // Label 8053: @417460
     /* 417460 */ GIM_Reject,
     /* 417461 */ // Label 8045: @417461
     /* 417461 */ GIM_Try, /*On fail goto*//*Label 8054*/ GIMT_Encode4(417491), // Rule ID 963 //
     /* 417466 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417469 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417472 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417476 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417480 */   // (strict_fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FSQRTv2f64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417480 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv2f64),
     /* 417485 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417489 */   GIR_RootConstrainSelectedInstOperands,
     /* 417490 */   // GIR_Coverage, 963,
     /* 417490 */   GIR_Done,
     /* 417491 */ // Label 8054: @417491
     /* 417491 */ GIM_Reject,
     /* 417492 */ // Label 8046: @417492
     /* 417492 */ GIM_Try, /*On fail goto*//*Label 8055*/ GIMT_Encode4(417522), // Rule ID 955 //
     /* 417497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417511 */   // (strict_fsqrt:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FSQRTv4f16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f16),
     /* 417516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417520 */   GIR_RootConstrainSelectedInstOperands,
     /* 417521 */   // GIR_Coverage, 955,
     /* 417521 */   GIR_Done,
     /* 417522 */ // Label 8055: @417522
     /* 417522 */ GIM_Reject,
     /* 417523 */ // Label 8047: @417523
     /* 417523 */ GIM_Try, /*On fail goto*//*Label 8056*/ GIMT_Encode4(417553), // Rule ID 961 //
     /* 417528 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 417531 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417538 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417542 */   // (strict_fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FSQRTv4f32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 417542 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv4f32),
     /* 417547 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417551 */   GIR_RootConstrainSelectedInstOperands,
     /* 417552 */   // GIR_Coverage, 961,
     /* 417552 */   GIR_Done,
     /* 417553 */ // Label 8056: @417553
     /* 417553 */ GIM_Reject,
     /* 417554 */ // Label 8048: @417554
     /* 417554 */ GIM_Try, /*On fail goto*//*Label 8057*/ GIMT_Encode4(417584), // Rule ID 957 //
     /* 417559 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417562 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417565 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417569 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417573 */   // (strict_fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FSQRTv8f16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 417573 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FSQRTv8f16),
     /* 417578 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417582 */   GIR_RootConstrainSelectedInstOperands,
     /* 417583 */   // GIR_Coverage, 957,
     /* 417583 */   GIR_Done,
     /* 417584 */ // Label 8057: @417584
     /* 417584 */ GIM_Reject,
     /* 417585 */ // Label 8049: @417585
     /* 417585 */ GIM_Reject,
     /* 417586 */ // Label 109: @417586
     /* 417586 */ GIM_Try, /*On fail goto*//*Label 8058*/ GIMT_Encode4(417599), // Rule ID 6557 //
     /* 417591 */   // (trap)  =>  (BRK 1:{ *:[i32] })
     /* 417591 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417594 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/1,
     /* 417597 */   GIR_RootConstrainSelectedInstOperands,
     /* 417598 */   // GIR_Coverage, 6557,
     /* 417598 */   GIR_EraseRootFromParent_Done,
     /* 417599 */ // Label 8058: @417599
     /* 417599 */ GIM_Reject,
     /* 417600 */ // Label 110: @417600
     /* 417600 */ GIM_Try, /*On fail goto*//*Label 8059*/ GIMT_Encode4(417620), // Rule ID 6558 //
     /* 417605 */   // (debugtrap)  =>  (BRK 61440:{ *:[i32] })
     /* 417605 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417608 */   GIR_AddImm, /*InsnID*/0, /*Imm*/GIMT_Encode8(61440),
     /* 417618 */   GIR_RootConstrainSelectedInstOperands,
     /* 417619 */   // GIR_Coverage, 6558,
     /* 417619 */   GIR_EraseRootFromParent_Done,
     /* 417620 */ // Label 8059: @417620
     /* 417620 */ GIM_Reject,
     /* 417621 */ // Label 111: @417621
     /* 417621 */ GIM_Try, /*On fail goto*//*Label 8060*/ GIMT_Encode4(417645), // Rule ID 6559 //
     /* 417626 */   // MIs[0] kind
     /* 417626 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 417629 */   GIM_CheckImmOperandPredicate, /*MI*/0, /*MO*/0, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_ubsan_trap_imm),
     /* 417634 */   // (ubsantrap (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>><<X:ubsan_trap_xform>>:$kind)  =>  (BRK (ubsan_trap_xform:{ *:[i32] } (timm:{ *:[i32] })<<P:Predicate_ubsan_trap_imm>>:$kind))
     /* 417634 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BRK),
     /* 417637 */   GIR_CustomOperandRenderer, /*InsnID*/0, /*OldInsnID*/0, /*OpIdx*/0, /*OperandRenderer*/GIMT_Encode2(GICR_renderUbsanTrap), // kind
     /* 417643 */   GIR_RootConstrainSelectedInstOperands,
     /* 417644 */   // GIR_Coverage, 6559,
     /* 417644 */   GIR_EraseRootFromParent_Done,
     /* 417645 */ // Label 8060: @417645
     /* 417645 */ GIM_Reject,
     /* 417646 */ // Label 112: @417646
     /* 417646 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8064*/ GIMT_Encode4(417955),
     /* 417657 */ /*GILLT_s16*//*Label 8061*/ GIMT_Encode4(417669),
     /* 417661 */ /*GILLT_s32*//*Label 8062*/ GIMT_Encode4(417822),
     /* 417665 */ /*GILLT_s64*//*Label 8063*/ GIMT_Encode4(417927),
     /* 417669 */ // Label 8061: @417669
     /* 417669 */ GIM_Try, /*On fail goto*//*Label 8065*/ GIMT_Encode4(417770), // Rule ID 5620 //
     /* 417674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 417680 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417684 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417688 */   // (vecreduce_fadd:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv8f16:{ *:[f128] } (FADDPv8f16:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn), V128:{ *:[v8f16] }:$Rn), dsub:{ *:[i32] }))
     /* 417688 */   GIR_MakeTempReg, /*TempRegID*/2, /*TypeID*/GILLT_s128,
     /* 417691 */   GIR_BuildMI, /*InsnID*/3, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417695 */   GIR_AddTempRegister, /*InsnID*/3, /*TempRegID*/2, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417700 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417704 */   GIR_Copy, /*NewInsnID*/3, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417708 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/3,
     /* 417710 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417713 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv8f16),
     /* 417717 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417722 */   GIR_AddSimpleTempRegister, /*InsnID*/2, /*TempRegID*/2,
     /* 417725 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417729 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417731 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417734 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417738 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417743 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417750 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417755 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417760 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417763 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417765 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417768 */   GIR_RootConstrainSelectedInstOperands,
     /* 417769 */   // GIR_Coverage, 5620,
     /* 417769 */   GIR_EraseRootFromParent_Done,
     /* 417770 */ // Label 8065: @417770
     /* 417770 */ GIM_Try, /*On fail goto*//*Label 8066*/ GIMT_Encode4(417821), // Rule ID 5621 //
     /* 417775 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16),
     /* 417778 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417781 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417785 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417789 */   // (vecreduce_fadd:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FADDPv2i16p:{ *:[f16] } (FADDPv4f16:{ *:[i64] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rn))
     /* 417789 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417792 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f16),
     /* 417796 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417801 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417805 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417809 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 417811 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i16p),
     /* 417814 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417816 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417819 */   GIR_RootConstrainSelectedInstOperands,
     /* 417820 */   // GIR_Coverage, 5621,
     /* 417820 */   GIR_EraseRootFromParent_Done,
     /* 417821 */ // Label 8066: @417821
     /* 417821 */ GIM_Reject,
     /* 417822 */ // Label 8062: @417822
     /* 417822 */ GIM_Try, /*On fail goto*//*Label 8067*/ GIMT_Encode4(417899), // Rule ID 5622 //
     /* 417827 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 417830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417838 */   // (vecreduce_fadd:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } (EXTRACT_SUBREG:{ *:[i64] } (FADDPv4f32:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn), dsub:{ *:[i32] }))
     /* 417838 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s128,
     /* 417841 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::FADDPv4f32),
     /* 417845 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417850 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417854 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 417858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 417860 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 417863 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 417867 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 417872 */   GIR_AddTempSubRegister, /*InsnID*/1, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 417879 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417884 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417889 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 417892 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 417894 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 417897 */   GIR_RootConstrainSelectedInstOperands,
     /* 417898 */   // GIR_Coverage, 5622,
     /* 417898 */   GIR_EraseRootFromParent_Done,
     /* 417899 */ // Label 8067: @417899
     /* 417899 */ GIM_Try, /*On fail goto*//*Label 8068*/ GIMT_Encode4(417926), // Rule ID 5623 //
     /* 417904 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 417907 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 417911 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417915 */   // (vecreduce_fadd:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FADDPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 417915 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i32p),
     /* 417920 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417924 */   GIR_RootConstrainSelectedInstOperands,
     /* 417925 */   // GIR_Coverage, 5623,
     /* 417925 */   GIR_Done,
     /* 417926 */ // Label 8068: @417926
     /* 417926 */ GIM_Reject,
     /* 417927 */ // Label 8063: @417927
     /* 417927 */ GIM_Try, /*On fail goto*//*Label 8069*/ GIMT_Encode4(417954), // Rule ID 5624 //
     /* 417932 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 417935 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417939 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 417943 */   // (vecreduce_fadd:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FADDPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 417943 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FADDPv2i64p),
     /* 417948 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 417952 */   GIR_RootConstrainSelectedInstOperands,
     /* 417953 */   // GIR_Coverage, 5624,
     /* 417953 */   GIR_Done,
     /* 417954 */ // Label 8069: @417954
     /* 417954 */ GIM_Reject,
     /* 417955 */ // Label 8064: @417955
     /* 417955 */ GIM_Reject,
     /* 417956 */ // Label 113: @417956
     /* 417956 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8073*/ GIMT_Encode4(418126),
     /* 417967 */ /*GILLT_s16*//*Label 8070*/ GIMT_Encode4(417979),
     /* 417971 */ /*GILLT_s32*//*Label 8071*/ GIMT_Encode4(418040),
     /* 417975 */ /*GILLT_s64*//*Label 8072*/ GIMT_Encode4(418098),
     /* 417979 */ // Label 8070: @417979
     /* 417979 */ GIM_Try, /*On fail goto*//*Label 8074*/ GIMT_Encode4(418009), // Rule ID 1942 //
     /* 417984 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 417987 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 417990 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 417994 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 417998 */   // (vecreduce_fmax:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 417998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i16v),
     /* 418003 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418007 */   GIR_RootConstrainSelectedInstOperands,
     /* 418008 */   // GIR_Coverage, 1942,
     /* 418008 */   GIR_Done,
     /* 418009 */ // Label 8074: @418009
     /* 418009 */ GIM_Try, /*On fail goto*//*Label 8075*/ GIMT_Encode4(418039), // Rule ID 1944 //
     /* 418014 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418017 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418028 */   // (vecreduce_fmax:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418028 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv8i16v),
     /* 418033 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418037 */   GIR_RootConstrainSelectedInstOperands,
     /* 418038 */   // GIR_Coverage, 1944,
     /* 418038 */   GIR_Done,
     /* 418039 */ // Label 8075: @418039
     /* 418039 */ GIM_Reject,
     /* 418040 */ // Label 8071: @418040
     /* 418040 */ GIM_Try, /*On fail goto*//*Label 8076*/ GIMT_Encode4(418070), // Rule ID 1946 //
     /* 418045 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418051 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418055 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418059 */   // (vecreduce_fmax:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418059 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMVv4i32v),
     /* 418064 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418068 */   GIR_RootConstrainSelectedInstOperands,
     /* 418069 */   // GIR_Coverage, 1946,
     /* 418069 */   GIR_Done,
     /* 418070 */ // Label 8076: @418070
     /* 418070 */ GIM_Try, /*On fail goto*//*Label 8077*/ GIMT_Encode4(418097), // Rule ID 5630 //
     /* 418075 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418078 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418082 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418086 */   // (vecreduce_fmax:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418086 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i32p),
     /* 418091 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418095 */   GIR_RootConstrainSelectedInstOperands,
     /* 418096 */   // GIR_Coverage, 5630,
     /* 418096 */   GIR_Done,
     /* 418097 */ // Label 8077: @418097
     /* 418097 */ GIM_Reject,
     /* 418098 */ // Label 8072: @418098
     /* 418098 */ GIM_Try, /*On fail goto*//*Label 8078*/ GIMT_Encode4(418125), // Rule ID 5632 //
     /* 418103 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418114 */   // (vecreduce_fmax:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418114 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXNMPv2i64p),
     /* 418119 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418123 */   GIR_RootConstrainSelectedInstOperands,
     /* 418124 */   // GIR_Coverage, 5632,
     /* 418124 */   GIR_Done,
     /* 418125 */ // Label 8078: @418125
     /* 418125 */ GIM_Reject,
     /* 418126 */ // Label 8073: @418126
     /* 418126 */ GIM_Reject,
     /* 418127 */ // Label 114: @418127
     /* 418127 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8082*/ GIMT_Encode4(418297),
     /* 418138 */ /*GILLT_s16*//*Label 8079*/ GIMT_Encode4(418150),
     /* 418142 */ /*GILLT_s32*//*Label 8080*/ GIMT_Encode4(418211),
     /* 418146 */ /*GILLT_s64*//*Label 8081*/ GIMT_Encode4(418269),
     /* 418150 */ // Label 8079: @418150
     /* 418150 */ GIM_Try, /*On fail goto*//*Label 8083*/ GIMT_Encode4(418180), // Rule ID 1954 //
     /* 418155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418169 */   // (vecreduce_fmin:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINNMVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i16v),
     /* 418174 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418178 */   GIR_RootConstrainSelectedInstOperands,
     /* 418179 */   // GIR_Coverage, 1954,
     /* 418179 */   GIR_Done,
     /* 418180 */ // Label 8083: @418180
     /* 418180 */ GIM_Try, /*On fail goto*//*Label 8084*/ GIMT_Encode4(418210), // Rule ID 1956 //
     /* 418185 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418188 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418191 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418195 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418199 */   // (vecreduce_fmin:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINNMVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418199 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv8i16v),
     /* 418204 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418208 */   GIR_RootConstrainSelectedInstOperands,
     /* 418209 */   // GIR_Coverage, 1956,
     /* 418209 */   GIR_Done,
     /* 418210 */ // Label 8084: @418210
     /* 418210 */ GIM_Reject,
     /* 418211 */ // Label 8080: @418211
     /* 418211 */ GIM_Try, /*On fail goto*//*Label 8085*/ GIMT_Encode4(418241), // Rule ID 1958 //
     /* 418216 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418219 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418222 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418226 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418230 */   // (vecreduce_fmin:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINNMVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418230 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMVv4i32v),
     /* 418235 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418239 */   GIR_RootConstrainSelectedInstOperands,
     /* 418240 */   // GIR_Coverage, 1958,
     /* 418240 */   GIR_Done,
     /* 418241 */ // Label 8085: @418241
     /* 418241 */ GIM_Try, /*On fail goto*//*Label 8086*/ GIMT_Encode4(418268), // Rule ID 5638 //
     /* 418246 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418249 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418253 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418257 */   // (vecreduce_fmin:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINNMPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418257 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i32p),
     /* 418262 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418266 */   GIR_RootConstrainSelectedInstOperands,
     /* 418267 */   // GIR_Coverage, 5638,
     /* 418267 */   GIR_Done,
     /* 418268 */ // Label 8086: @418268
     /* 418268 */ GIM_Reject,
     /* 418269 */ // Label 8081: @418269
     /* 418269 */ GIM_Try, /*On fail goto*//*Label 8087*/ GIMT_Encode4(418296), // Rule ID 5640 //
     /* 418274 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418277 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418281 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418285 */   // (vecreduce_fmin:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINNMPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418285 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINNMPv2i64p),
     /* 418290 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418294 */   GIR_RootConstrainSelectedInstOperands,
     /* 418295 */   // GIR_Coverage, 5640,
     /* 418295 */   GIR_Done,
     /* 418296 */ // Label 8087: @418296
     /* 418296 */ GIM_Reject,
     /* 418297 */ // Label 8082: @418297
     /* 418297 */ GIM_Reject,
     /* 418298 */ // Label 115: @418298
     /* 418298 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8091*/ GIMT_Encode4(418468),
     /* 418309 */ /*GILLT_s16*//*Label 8088*/ GIMT_Encode4(418321),
     /* 418313 */ /*GILLT_s32*//*Label 8089*/ GIMT_Encode4(418382),
     /* 418317 */ /*GILLT_s64*//*Label 8090*/ GIMT_Encode4(418440),
     /* 418321 */ // Label 8088: @418321
     /* 418321 */ GIM_Try, /*On fail goto*//*Label 8092*/ GIMT_Encode4(418351), // Rule ID 1948 //
     /* 418326 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418329 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418332 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418336 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418340 */   // (vecreduce_fmaximum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMAXVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418340 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i16v),
     /* 418345 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418349 */   GIR_RootConstrainSelectedInstOperands,
     /* 418350 */   // GIR_Coverage, 1948,
     /* 418350 */   GIR_Done,
     /* 418351 */ // Label 8092: @418351
     /* 418351 */ GIM_Try, /*On fail goto*//*Label 8093*/ GIMT_Encode4(418381), // Rule ID 1950 //
     /* 418356 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418359 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418362 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418366 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418370 */   // (vecreduce_fmaximum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMAXVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418370 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv8i16v),
     /* 418375 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418379 */   GIR_RootConstrainSelectedInstOperands,
     /* 418380 */   // GIR_Coverage, 1950,
     /* 418380 */   GIR_Done,
     /* 418381 */ // Label 8093: @418381
     /* 418381 */ GIM_Reject,
     /* 418382 */ // Label 8089: @418382
     /* 418382 */ GIM_Try, /*On fail goto*//*Label 8094*/ GIMT_Encode4(418412), // Rule ID 1952 //
     /* 418387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418393 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418397 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418401 */   // (vecreduce_fmaximum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMAXVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418401 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXVv4i32v),
     /* 418406 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418410 */   GIR_RootConstrainSelectedInstOperands,
     /* 418411 */   // GIR_Coverage, 1952,
     /* 418411 */   GIR_Done,
     /* 418412 */ // Label 8094: @418412
     /* 418412 */ GIM_Try, /*On fail goto*//*Label 8095*/ GIMT_Encode4(418439), // Rule ID 5634 //
     /* 418417 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418420 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418424 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418428 */   // (vecreduce_fmaximum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMAXPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418428 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i32p),
     /* 418433 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418437 */   GIR_RootConstrainSelectedInstOperands,
     /* 418438 */   // GIR_Coverage, 5634,
     /* 418438 */   GIR_Done,
     /* 418439 */ // Label 8095: @418439
     /* 418439 */ GIM_Reject,
     /* 418440 */ // Label 8090: @418440
     /* 418440 */ GIM_Try, /*On fail goto*//*Label 8096*/ GIMT_Encode4(418467), // Rule ID 5636 //
     /* 418445 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418448 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418452 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418456 */   // (vecreduce_fmaximum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMAXPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMAXPv2i64p),
     /* 418461 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418465 */   GIR_RootConstrainSelectedInstOperands,
     /* 418466 */   // GIR_Coverage, 5636,
     /* 418466 */   GIR_Done,
     /* 418467 */ // Label 8096: @418467
     /* 418467 */ GIM_Reject,
     /* 418468 */ // Label 8091: @418468
     /* 418468 */ GIM_Reject,
     /* 418469 */ // Label 116: @418469
     /* 418469 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8100*/ GIMT_Encode4(418639),
     /* 418480 */ /*GILLT_s16*//*Label 8097*/ GIMT_Encode4(418492),
     /* 418484 */ /*GILLT_s32*//*Label 8098*/ GIMT_Encode4(418553),
     /* 418488 */ /*GILLT_s64*//*Label 8099*/ GIMT_Encode4(418611),
     /* 418492 */ // Label 8097: @418492
     /* 418492 */ GIM_Try, /*On fail goto*//*Label 8101*/ GIMT_Encode4(418522), // Rule ID 1960 //
     /* 418497 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418511 */   // (vecreduce_fminimum:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)  =>  (FMINVv4i16v:{ *:[f16] } V64:{ *:[v4f16] }:$Rn)
     /* 418511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i16v),
     /* 418516 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418520 */   GIR_RootConstrainSelectedInstOperands,
     /* 418521 */   // GIR_Coverage, 1960,
     /* 418521 */   GIR_Done,
     /* 418522 */ // Label 8101: @418522
     /* 418522 */ GIM_Try, /*On fail goto*//*Label 8102*/ GIMT_Encode4(418552), // Rule ID 1962 //
     /* 418527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 418530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418541 */   // (vecreduce_fminimum:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)  =>  (FMINVv8i16v:{ *:[f16] } V128:{ *:[v8f16] }:$Rn)
     /* 418541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv8i16v),
     /* 418546 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418550 */   GIR_RootConstrainSelectedInstOperands,
     /* 418551 */   // GIR_Coverage, 1962,
     /* 418551 */   GIR_Done,
     /* 418552 */ // Label 8102: @418552
     /* 418552 */ GIM_Reject,
     /* 418553 */ // Label 8098: @418553
     /* 418553 */ GIM_Try, /*On fail goto*//*Label 8103*/ GIMT_Encode4(418583), // Rule ID 1964 //
     /* 418558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 418561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 418564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418572 */   // (vecreduce_fminimum:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)  =>  (FMINVv4i32v:{ *:[f32] } V128:{ *:[v4f32] }:$Rn)
     /* 418572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINVv4i32v),
     /* 418577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418581 */   GIR_RootConstrainSelectedInstOperands,
     /* 418582 */   // GIR_Coverage, 1964,
     /* 418582 */   GIR_Done,
     /* 418583 */ // Label 8103: @418583
     /* 418583 */ GIM_Try, /*On fail goto*//*Label 8104*/ GIMT_Encode4(418610), // Rule ID 5642 //
     /* 418588 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 418591 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 418595 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418599 */   // (vecreduce_fminimum:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)  =>  (FMINPv2i32p:{ *:[f32] } V64:{ *:[v2f32] }:$Rn)
     /* 418599 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i32p),
     /* 418604 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418608 */   GIR_RootConstrainSelectedInstOperands,
     /* 418609 */   // GIR_Coverage, 5642,
     /* 418609 */   GIR_Done,
     /* 418610 */ // Label 8104: @418610
     /* 418610 */ GIM_Reject,
     /* 418611 */ // Label 8099: @418611
     /* 418611 */ GIM_Try, /*On fail goto*//*Label 8105*/ GIMT_Encode4(418638), // Rule ID 5644 //
     /* 418616 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 418619 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418623 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418627 */   // (vecreduce_fminimum:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)  =>  (FMINPv2i64p:{ *:[f64] } V128:{ *:[v2f64] }:$Rn)
     /* 418627 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FMINPv2i64p),
     /* 418632 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 418636 */   GIR_RootConstrainSelectedInstOperands,
     /* 418637 */   // GIR_Coverage, 5644,
     /* 418637 */   GIR_Done,
     /* 418638 */ // Label 8105: @418638
     /* 418638 */ GIM_Reject,
     /* 418639 */ // Label 8100: @418639
     /* 418639 */ GIM_Reject,
     /* 418640 */ // Label 117: @418640
     /* 418640 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(4), /*)*//*default:*//*Label 8110*/ GIMT_Encode4(419768),
     /* 418651 */ /*GILLT_s8*//*Label 8106*/ GIMT_Encode4(418667),
     /* 418655 */ /*GILLT_s16*//*Label 8107*/ GIMT_Encode4(418714),
     /* 418659 */ /*GILLT_s32*//*Label 8108*/ GIMT_Encode4(419129),
     /* 418663 */ /*GILLT_s64*//*Label 8109*/ GIMT_Encode4(419582),
     /* 418667 */ // Label 8106: @418667
     /* 418667 */ GIM_Try, /*On fail goto*//*Label 8111*/ GIMT_Encode4(418690), // Rule ID 5929 //
     /* 418672 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418675 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418679 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418683 */   // (vecreduce_add:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)  =>  (ADDVv8i8v:{ *:[i8] } V64:{ *:[v8i8] }:$Rn)
     /* 418683 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i8v),
     /* 418688 */   GIR_RootConstrainSelectedInstOperands,
     /* 418689 */   // GIR_Coverage, 5929,
     /* 418689 */   GIR_Done,
     /* 418690 */ // Label 8111: @418690
     /* 418690 */ GIM_Try, /*On fail goto*//*Label 8112*/ GIMT_Encode4(418713), // Rule ID 5930 //
     /* 418695 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 418702 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418706 */   // (vecreduce_add:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)  =>  (ADDVv16i8v:{ *:[i8] } V128:{ *:[v16i8] }:$Rn)
     /* 418706 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv16i8v),
     /* 418711 */   GIR_RootConstrainSelectedInstOperands,
     /* 418712 */   // GIR_Coverage, 5930,
     /* 418712 */   GIR_Done,
     /* 418713 */ // Label 8112: @418713
     /* 418713 */ GIM_Reject,
     /* 418714 */ // Label 8107: @418714
     /* 418714 */ GIM_Try, /*On fail goto*//*Label 8113*/ GIMT_Encode4(418764), // Rule ID 5876 //
     /* 418719 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418722 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418726 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418730 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418734 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418737 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418742 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418746 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418751 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418753 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418753 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 418756 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418758 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418762 */   GIR_RootConstrainSelectedInstOperands,
     /* 418763 */   // GIR_Coverage, 5876,
     /* 418763 */   GIR_EraseRootFromParent_Done,
     /* 418764 */ // Label 8113: @418764
     /* 418764 */ GIM_Try, /*On fail goto*//*Label 8114*/ GIMT_Encode4(418814), // Rule ID 5878 //
     /* 418769 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418772 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418776 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418780 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418784 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418787 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 418792 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418796 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418801 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418803 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418803 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 418806 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418808 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418812 */   GIR_RootConstrainSelectedInstOperands,
     /* 418813 */   // GIR_Coverage, 5878,
     /* 418813 */   GIR_EraseRootFromParent_Done,
     /* 418814 */ // Label 8114: @418814
     /* 418814 */ GIM_Try, /*On fail goto*//*Label 8115*/ GIMT_Encode4(418864), // Rule ID 5886 //
     /* 418819 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418822 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418826 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418830 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418834 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418837 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418842 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 418846 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418851 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418853 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v4i16] } 667:{ *:[iPTR] }, V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418853 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418856 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418858 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418862 */   GIR_RootConstrainSelectedInstOperands,
     /* 418863 */   // GIR_Coverage, 5886,
     /* 418863 */   GIR_EraseRootFromParent_Done,
     /* 418864 */ // Label 8115: @418864
     /* 418864 */ GIM_Try, /*On fail goto*//*Label 8116*/ GIMT_Encode4(418914), // Rule ID 5888 //
     /* 418869 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418872 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418876 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418880 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 418884 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 418887 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 418892 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 418896 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418901 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418903 */   // (vecreduce_add:{ *:[i16] } (intrinsic_wo_chain:{ *:[v8i16] } 667:{ *:[iPTR] }, V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418903 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 418906 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418908 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 418912 */   GIR_RootConstrainSelectedInstOperands,
     /* 418913 */   // GIR_Coverage, 5888,
     /* 418913 */   GIR_EraseRootFromParent_Done,
     /* 418914 */ // Label 8116: @418914
     /* 418914 */ GIM_Try, /*On fail goto*//*Label 8117*/ GIMT_Encode4(418956), // Rule ID 5885 //
     /* 418919 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 418922 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418926 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418930 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418934 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 418938 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 418943 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418945 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 418945 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 418948 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418950 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418954 */   GIR_RootConstrainSelectedInstOperands,
     /* 418955 */   // GIR_Coverage, 5885,
     /* 418955 */   GIR_EraseRootFromParent_Done,
     /* 418956 */ // Label 8117: @418956
     /* 418956 */ GIM_Try, /*On fail goto*//*Label 8118*/ GIMT_Encode4(418998), // Rule ID 5887 //
     /* 418961 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 418964 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 418968 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 418972 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 418976 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 418980 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 418985 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 418987 */   // (vecreduce_add:{ *:[i16] } (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 418987 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 418990 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 418992 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 418996 */   GIR_RootConstrainSelectedInstOperands,
     /* 418997 */   // GIR_Coverage, 5887,
     /* 418997 */   GIR_EraseRootFromParent_Done,
     /* 418998 */ // Label 8118: @418998
     /* 418998 */ GIM_Try, /*On fail goto*//*Label 8119*/ GIMT_Encode4(419040), // Rule ID 5875 //
     /* 419003 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419006 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419010 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419014 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419018 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419022 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419027 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419029 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn))  =>  (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn)
     /* 419029 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 419032 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419034 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419038 */   GIR_RootConstrainSelectedInstOperands,
     /* 419039 */   // GIR_Coverage, 5875,
     /* 419039 */   GIR_EraseRootFromParent_Done,
     /* 419040 */ // Label 8119: @419040
     /* 419040 */ GIM_Try, /*On fail goto*//*Label 8120*/ GIMT_Encode4(419082), // Rule ID 5877 //
     /* 419045 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419052 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419056 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419060 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419064 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419069 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419071 */   // (vecreduce_add:{ *:[i16] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn))  =>  (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn)
     /* 419071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 419074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419076 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419080 */   GIR_RootConstrainSelectedInstOperands,
     /* 419081 */   // GIR_Coverage, 5877,
     /* 419081 */   GIR_EraseRootFromParent_Done,
     /* 419082 */ // Label 8120: @419082
     /* 419082 */ GIM_Try, /*On fail goto*//*Label 8121*/ GIMT_Encode4(419105), // Rule ID 5931 //
     /* 419087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419090 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419094 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419098 */   // (vecreduce_add:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)  =>  (ADDVv4i16v:{ *:[i16] } V64:{ *:[v4i16] }:$Rn)
     /* 419098 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i16v),
     /* 419103 */   GIR_RootConstrainSelectedInstOperands,
     /* 419104 */   // GIR_Coverage, 5931,
     /* 419104 */   GIR_Done,
     /* 419105 */ // Label 8121: @419105
     /* 419105 */ GIM_Try, /*On fail goto*//*Label 8122*/ GIMT_Encode4(419128), // Rule ID 5932 //
     /* 419110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419121 */   // (vecreduce_add:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)  =>  (ADDVv8i16v:{ *:[i16] } V128:{ *:[v8i16] }:$Rn)
     /* 419121 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv8i16v),
     /* 419126 */   GIR_RootConstrainSelectedInstOperands,
     /* 419127 */   // GIR_Coverage, 5932,
     /* 419127 */   GIR_Done,
     /* 419128 */ // Label 8122: @419128
     /* 419128 */ GIM_Reject,
     /* 419129 */ // Label 8108: @419129
     /* 419129 */ GIM_Try, /*On fail goto*//*Label 8123*/ GIMT_Encode4(419179), // Rule ID 5880 //
     /* 419134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419137 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419141 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419145 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419149 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419152 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419157 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419161 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419166 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419168 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419168 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 419171 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419173 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419177 */   GIR_RootConstrainSelectedInstOperands,
     /* 419178 */   // GIR_Coverage, 5880,
     /* 419178 */   GIR_EraseRootFromParent_Done,
     /* 419179 */ // Label 8123: @419179
     /* 419179 */ GIM_Try, /*On fail goto*//*Label 8124*/ GIMT_Encode4(419229), // Rule ID 5882 //
     /* 419184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419187 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419191 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419195 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419199 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419202 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419207 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419211 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419216 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419218 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 732:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419218 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 419221 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419223 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419227 */   GIR_RootConstrainSelectedInstOperands,
     /* 419228 */   // GIR_Coverage, 5882,
     /* 419228 */   GIR_EraseRootFromParent_Done,
     /* 419229 */ // Label 8124: @419229
     /* 419229 */ GIM_Try, /*On fail goto*//*Label 8125*/ GIMT_Encode4(419279), // Rule ID 5890 //
     /* 419234 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419241 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419245 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419249 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419252 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419257 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 419261 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419266 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419268 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v4i32] } 667:{ *:[iPTR] }, V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419268 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 419271 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419273 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419277 */   GIR_RootConstrainSelectedInstOperands,
     /* 419278 */   // GIR_Coverage, 5890,
     /* 419278 */   GIR_EraseRootFromParent_Done,
     /* 419279 */ // Label 8125: @419279
     /* 419279 */ GIM_Try, /*On fail goto*//*Label 8126*/ GIMT_Encode4(419329), // Rule ID 5892 //
     /* 419284 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419287 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419291 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419295 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419299 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419302 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419307 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 419311 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419316 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419318 */   // (vecreduce_add:{ *:[i32] } (intrinsic_wo_chain:{ *:[v2i32] } 667:{ *:[iPTR] }, V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419318 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 419321 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419323 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419327 */   GIR_RootConstrainSelectedInstOperands,
     /* 419328 */   // GIR_Coverage, 5892,
     /* 419328 */   GIR_EraseRootFromParent_Done,
     /* 419329 */ // Label 8126: @419329
     /* 419329 */ GIM_Try, /*On fail goto*//*Label 8127*/ GIMT_Encode4(419371), // Rule ID 5889 //
     /* 419334 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419337 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419341 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419345 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419349 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419353 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419358 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419360 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419360 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 419363 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419365 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419369 */   GIR_RootConstrainSelectedInstOperands,
     /* 419370 */   // GIR_Coverage, 5889,
     /* 419370 */   GIR_EraseRootFromParent_Done,
     /* 419371 */ // Label 8127: @419371
     /* 419371 */ GIM_Try, /*On fail goto*//*Label 8128*/ GIMT_Encode4(419413), // Rule ID 5891 //
     /* 419376 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419379 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419383 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419387 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419391 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419395 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419400 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419402 */   // (vecreduce_add:{ *:[i32] } (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419402 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 419405 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419407 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419411 */   GIR_RootConstrainSelectedInstOperands,
     /* 419412 */   // GIR_Coverage, 5891,
     /* 419412 */   GIR_EraseRootFromParent_Done,
     /* 419413 */ // Label 8128: @419413
     /* 419413 */ GIM_Try, /*On fail goto*//*Label 8129*/ GIMT_Encode4(419455), // Rule ID 5879 //
     /* 419418 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419421 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419425 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419429 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419433 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419437 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419442 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419444 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn))  =>  (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn)
     /* 419444 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 419447 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419449 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419453 */   GIR_RootConstrainSelectedInstOperands,
     /* 419454 */   // GIR_Coverage, 5879,
     /* 419454 */   GIR_EraseRootFromParent_Done,
     /* 419455 */ // Label 8129: @419455
     /* 419455 */ GIM_Try, /*On fail goto*//*Label 8130*/ GIMT_Encode4(419497), // Rule ID 5881 //
     /* 419460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419467 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419471 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419475 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419479 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419484 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419486 */   // (vecreduce_add:{ *:[i32] } (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn))  =>  (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn)
     /* 419486 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 419489 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419491 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419495 */   GIR_RootConstrainSelectedInstOperands,
     /* 419496 */   // GIR_Coverage, 5881,
     /* 419496 */   GIR_EraseRootFromParent_Done,
     /* 419497 */ // Label 8130: @419497
     /* 419497 */ GIM_Try, /*On fail goto*//*Label 8131*/ GIMT_Encode4(419558), // Rule ID 5933 //
     /* 419502 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419505 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419509 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419513 */   // (vecreduce_add:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (ADDPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419513 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419516 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i32),
     /* 419520 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419525 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419529 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419533 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419535 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419538 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419540 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419547 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419552 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419557 */   // GIR_Coverage, 5933,
     /* 419557 */   GIR_EraseRootFromParent_Done,
     /* 419558 */ // Label 8131: @419558
     /* 419558 */ GIM_Try, /*On fail goto*//*Label 8132*/ GIMT_Encode4(419581), // Rule ID 5934 //
     /* 419563 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419566 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419570 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419574 */   // (vecreduce_add:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (ADDVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419574 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDVv4i32v),
     /* 419579 */   GIR_RootConstrainSelectedInstOperands,
     /* 419580 */   // GIR_Coverage, 5934,
     /* 419580 */   GIR_Done,
     /* 419581 */ // Label 8132: @419581
     /* 419581 */ GIM_Reject,
     /* 419582 */ // Label 8109: @419582
     /* 419582 */ GIM_Try, /*On fail goto*//*Label 8133*/ GIMT_Encode4(419767),
     /* 419587 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 419590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419594 */   GIM_Try, /*On fail goto*//*Label 8134*/ GIMT_Encode4(419637), // Rule ID 5884 //
     /* 419599 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419603 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419607 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419610 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 419615 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419619 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419626 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 732:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 419629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419631 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419635 */     GIR_RootConstrainSelectedInstOperands,
     /* 419636 */     // GIR_Coverage, 5884,
     /* 419636 */     GIR_EraseRootFromParent_Done,
     /* 419637 */   // Label 8134: @419637
     /* 419637 */   GIM_Try, /*On fail goto*//*Label 8135*/ GIMT_Encode4(419680), // Rule ID 5894 //
     /* 419642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 419650 */     GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 419653 */     GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_saddlp),
     /* 419658 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 419662 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419667 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419669 */     // (vecreduce_add:{ *:[i64] } (intrinsic_wo_chain:{ *:[v2i64] } 667:{ *:[iPTR] }, V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419669 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 419672 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419674 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/2, // Rn
     /* 419678 */     GIR_RootConstrainSelectedInstOperands,
     /* 419679 */     // GIR_Coverage, 5894,
     /* 419679 */     GIR_EraseRootFromParent_Done,
     /* 419680 */   // Label 8135: @419680
     /* 419680 */   GIM_Try, /*On fail goto*//*Label 8136*/ GIMT_Encode4(419715), // Rule ID 5893 //
     /* 419685 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419689 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_SADDLP),
     /* 419693 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419697 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419702 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419704 */     // (vecreduce_add:{ *:[i64] } (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419704 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 419707 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419709 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419713 */     GIR_RootConstrainSelectedInstOperands,
     /* 419714 */     // GIR_Coverage, 5893,
     /* 419714 */     GIR_EraseRootFromParent_Done,
     /* 419715 */   // Label 8136: @419715
     /* 419715 */   GIM_Try, /*On fail goto*//*Label 8137*/ GIMT_Encode4(419750), // Rule ID 5883 //
     /* 419720 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 419724 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 419728 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419732 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419737 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 419739 */     // (vecreduce_add:{ *:[i64] } (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn))  =>  (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn)
     /* 419739 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 419742 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 419744 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 419748 */     GIR_RootConstrainSelectedInstOperands,
     /* 419749 */     // GIR_Coverage, 5883,
     /* 419749 */     GIR_EraseRootFromParent_Done,
     /* 419750 */   // Label 8137: @419750
     /* 419750 */   GIM_Try, /*On fail goto*//*Label 8138*/ GIMT_Encode4(419766), // Rule ID 5935 //
     /* 419755 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419759 */     // (vecreduce_add:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)  =>  (ADDPv2i64p:{ *:[i64] } V128:{ *:[v2i64] }:$Rn)
     /* 419759 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ADDPv2i64p),
     /* 419764 */     GIR_RootConstrainSelectedInstOperands,
     /* 419765 */     // GIR_Coverage, 5935,
     /* 419765 */     GIR_Done,
     /* 419766 */   // Label 8138: @419766
     /* 419766 */   GIM_Reject,
     /* 419767 */ // Label 8133: @419767
     /* 419767 */ GIM_Reject,
     /* 419768 */ // Label 8110: @419768
     /* 419768 */ GIM_Reject,
     /* 419769 */ // Label 118: @419769
     /* 419769 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8142*/ GIMT_Encode4(419971),
     /* 419780 */ /*GILLT_s8*//*Label 8139*/ GIMT_Encode4(419792),
     /* 419784 */ /*GILLT_s16*//*Label 8140*/ GIMT_Encode4(419839),
     /* 419788 */ /*GILLT_s32*//*Label 8141*/ GIMT_Encode4(419886),
     /* 419792 */ // Label 8139: @419792
     /* 419792 */ GIM_Try, /*On fail goto*//*Label 8143*/ GIMT_Encode4(419815), // Rule ID 6026 //
     /* 419797 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 419800 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419804 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419808 */   // (vecreduce_smax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 419808 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i8v),
     /* 419813 */   GIR_RootConstrainSelectedInstOperands,
     /* 419814 */   // GIR_Coverage, 6026,
     /* 419814 */   GIR_Done,
     /* 419815 */ // Label 8143: @419815
     /* 419815 */ GIM_Try, /*On fail goto*//*Label 8144*/ GIMT_Encode4(419838), // Rule ID 6027 //
     /* 419820 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 419823 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 419827 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419831 */   // (vecreduce_smax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 419831 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv16i8v),
     /* 419836 */   GIR_RootConstrainSelectedInstOperands,
     /* 419837 */   // GIR_Coverage, 6027,
     /* 419837 */   GIR_Done,
     /* 419838 */ // Label 8144: @419838
     /* 419838 */ GIM_Reject,
     /* 419839 */ // Label 8140: @419839
     /* 419839 */ GIM_Try, /*On fail goto*//*Label 8145*/ GIMT_Encode4(419862), // Rule ID 6028 //
     /* 419844 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 419847 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419851 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419855 */   // (vecreduce_smax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 419855 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i16v),
     /* 419860 */   GIR_RootConstrainSelectedInstOperands,
     /* 419861 */   // GIR_Coverage, 6028,
     /* 419861 */   GIR_Done,
     /* 419862 */ // Label 8145: @419862
     /* 419862 */ GIM_Try, /*On fail goto*//*Label 8146*/ GIMT_Encode4(419885), // Rule ID 6029 //
     /* 419867 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 419870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 419874 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419878 */   // (vecreduce_smax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 419878 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv8i16v),
     /* 419883 */   GIR_RootConstrainSelectedInstOperands,
     /* 419884 */   // GIR_Coverage, 6029,
     /* 419884 */   GIR_Done,
     /* 419885 */ // Label 8146: @419885
     /* 419885 */ GIM_Reject,
     /* 419886 */ // Label 8141: @419886
     /* 419886 */ GIM_Try, /*On fail goto*//*Label 8147*/ GIMT_Encode4(419909), // Rule ID 6030 //
     /* 419891 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 419894 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419898 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 419902 */   // (vecreduce_smax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 419902 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMAXVv4i32v),
     /* 419907 */   GIR_RootConstrainSelectedInstOperands,
     /* 419908 */   // GIR_Coverage, 6030,
     /* 419908 */   GIR_Done,
     /* 419909 */ // Label 8147: @419909
     /* 419909 */ GIM_Try, /*On fail goto*//*Label 8148*/ GIMT_Encode4(419970), // Rule ID 6031 //
     /* 419914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 419917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419925 */   // (vecreduce_smax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 419925 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 419928 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMAXPv2i32),
     /* 419932 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 419937 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419941 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 419945 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 419947 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 419950 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 419952 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 419959 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 419964 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 419969 */   // GIR_Coverage, 6031,
     /* 419969 */   GIR_EraseRootFromParent_Done,
     /* 419970 */ // Label 8148: @419970
     /* 419970 */ GIM_Reject,
     /* 419971 */ // Label 8142: @419971
     /* 419971 */ GIM_Reject,
     /* 419972 */ // Label 119: @419972
     /* 419972 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8152*/ GIMT_Encode4(420174),
     /* 419983 */ /*GILLT_s8*//*Label 8149*/ GIMT_Encode4(419995),
     /* 419987 */ /*GILLT_s16*//*Label 8150*/ GIMT_Encode4(420042),
     /* 419991 */ /*GILLT_s32*//*Label 8151*/ GIMT_Encode4(420089),
     /* 419995 */ // Label 8149: @419995
     /* 419995 */ GIM_Try, /*On fail goto*//*Label 8153*/ GIMT_Encode4(420018), // Rule ID 6020 //
     /* 420000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420011 */   // (vecreduce_smin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (SMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i8v),
     /* 420016 */   GIR_RootConstrainSelectedInstOperands,
     /* 420017 */   // GIR_Coverage, 6020,
     /* 420017 */   GIR_Done,
     /* 420018 */ // Label 8153: @420018
     /* 420018 */ GIM_Try, /*On fail goto*//*Label 8154*/ GIMT_Encode4(420041), // Rule ID 6021 //
     /* 420023 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420026 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420030 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420034 */   // (vecreduce_smin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (SMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420034 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv16i8v),
     /* 420039 */   GIR_RootConstrainSelectedInstOperands,
     /* 420040 */   // GIR_Coverage, 6021,
     /* 420040 */   GIR_Done,
     /* 420041 */ // Label 8154: @420041
     /* 420041 */ GIM_Reject,
     /* 420042 */ // Label 8150: @420042
     /* 420042 */ GIM_Try, /*On fail goto*//*Label 8155*/ GIMT_Encode4(420065), // Rule ID 6022 //
     /* 420047 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420050 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420054 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420058 */   // (vecreduce_smin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (SMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420058 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i16v),
     /* 420063 */   GIR_RootConstrainSelectedInstOperands,
     /* 420064 */   // GIR_Coverage, 6022,
     /* 420064 */   GIR_Done,
     /* 420065 */ // Label 8155: @420065
     /* 420065 */ GIM_Try, /*On fail goto*//*Label 8156*/ GIMT_Encode4(420088), // Rule ID 6023 //
     /* 420070 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420077 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420081 */   // (vecreduce_smin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (SMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420081 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv8i16v),
     /* 420086 */   GIR_RootConstrainSelectedInstOperands,
     /* 420087 */   // GIR_Coverage, 6023,
     /* 420087 */   GIR_Done,
     /* 420088 */ // Label 8156: @420088
     /* 420088 */ GIM_Reject,
     /* 420089 */ // Label 8151: @420089
     /* 420089 */ GIM_Try, /*On fail goto*//*Label 8157*/ GIMT_Encode4(420112), // Rule ID 6024 //
     /* 420094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420105 */   // (vecreduce_smin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (SMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMINVv4i32v),
     /* 420110 */   GIR_RootConstrainSelectedInstOperands,
     /* 420111 */   // GIR_Coverage, 6024,
     /* 420111 */   GIR_Done,
     /* 420112 */ // Label 8157: @420112
     /* 420112 */ GIM_Try, /*On fail goto*//*Label 8158*/ GIMT_Encode4(420173), // Rule ID 6025 //
     /* 420117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420128 */   // (vecreduce_smin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (SMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420128 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420131 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SMINPv2i32),
     /* 420135 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420140 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420144 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420148 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420150 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420153 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420155 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420162 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420167 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420172 */   // GIR_Coverage, 6025,
     /* 420172 */   GIR_EraseRootFromParent_Done,
     /* 420173 */ // Label 8158: @420173
     /* 420173 */ GIM_Reject,
     /* 420174 */ // Label 8152: @420174
     /* 420174 */ GIM_Reject,
     /* 420175 */ // Label 120: @420175
     /* 420175 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8162*/ GIMT_Encode4(420377),
     /* 420186 */ /*GILLT_s8*//*Label 8159*/ GIMT_Encode4(420198),
     /* 420190 */ /*GILLT_s16*//*Label 8160*/ GIMT_Encode4(420245),
     /* 420194 */ /*GILLT_s32*//*Label 8161*/ GIMT_Encode4(420292),
     /* 420198 */ // Label 8159: @420198
     /* 420198 */ GIM_Try, /*On fail goto*//*Label 8163*/ GIMT_Encode4(420221), // Rule ID 6014 //
     /* 420203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420210 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420214 */   // (vecreduce_umax:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMAXVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420214 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i8v),
     /* 420219 */   GIR_RootConstrainSelectedInstOperands,
     /* 420220 */   // GIR_Coverage, 6014,
     /* 420220 */   GIR_Done,
     /* 420221 */ // Label 8163: @420221
     /* 420221 */ GIM_Try, /*On fail goto*//*Label 8164*/ GIMT_Encode4(420244), // Rule ID 6015 //
     /* 420226 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420229 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420233 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420237 */   // (vecreduce_umax:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMAXVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420237 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv16i8v),
     /* 420242 */   GIR_RootConstrainSelectedInstOperands,
     /* 420243 */   // GIR_Coverage, 6015,
     /* 420243 */   GIR_Done,
     /* 420244 */ // Label 8164: @420244
     /* 420244 */ GIM_Reject,
     /* 420245 */ // Label 8160: @420245
     /* 420245 */ GIM_Try, /*On fail goto*//*Label 8165*/ GIMT_Encode4(420268), // Rule ID 6016 //
     /* 420250 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420253 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420257 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420261 */   // (vecreduce_umax:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMAXVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420261 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i16v),
     /* 420266 */   GIR_RootConstrainSelectedInstOperands,
     /* 420267 */   // GIR_Coverage, 6016,
     /* 420267 */   GIR_Done,
     /* 420268 */ // Label 8165: @420268
     /* 420268 */ GIM_Try, /*On fail goto*//*Label 8166*/ GIMT_Encode4(420291), // Rule ID 6017 //
     /* 420273 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420276 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420280 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420284 */   // (vecreduce_umax:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMAXVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420284 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv8i16v),
     /* 420289 */   GIR_RootConstrainSelectedInstOperands,
     /* 420290 */   // GIR_Coverage, 6017,
     /* 420290 */   GIR_Done,
     /* 420291 */ // Label 8166: @420291
     /* 420291 */ GIM_Reject,
     /* 420292 */ // Label 8161: @420292
     /* 420292 */ GIM_Try, /*On fail goto*//*Label 8167*/ GIMT_Encode4(420315), // Rule ID 6018 //
     /* 420297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420308 */   // (vecreduce_umax:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMAXVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420308 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMAXVv4i32v),
     /* 420313 */   GIR_RootConstrainSelectedInstOperands,
     /* 420314 */   // GIR_Coverage, 6018,
     /* 420314 */   GIR_Done,
     /* 420315 */ // Label 8167: @420315
     /* 420315 */ GIM_Try, /*On fail goto*//*Label 8168*/ GIMT_Encode4(420376), // Rule ID 6019 //
     /* 420320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420323 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420327 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420331 */   // (vecreduce_umax:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMAXPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420331 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420334 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMAXPv2i32),
     /* 420338 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420343 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420347 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420351 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420353 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420356 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420358 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420365 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420370 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420375 */   // GIR_Coverage, 6019,
     /* 420375 */   GIR_EraseRootFromParent_Done,
     /* 420376 */ // Label 8168: @420376
     /* 420376 */ GIM_Reject,
     /* 420377 */ // Label 8162: @420377
     /* 420377 */ GIM_Reject,
     /* 420378 */ // Label 121: @420378
     /* 420378 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(0), GIMT_Encode2(3), /*)*//*default:*//*Label 8172*/ GIMT_Encode4(420580),
     /* 420389 */ /*GILLT_s8*//*Label 8169*/ GIMT_Encode4(420401),
     /* 420393 */ /*GILLT_s16*//*Label 8170*/ GIMT_Encode4(420448),
     /* 420397 */ /*GILLT_s32*//*Label 8171*/ GIMT_Encode4(420495),
     /* 420401 */ // Label 8169: @420401
     /* 420401 */ GIM_Try, /*On fail goto*//*Label 8173*/ GIMT_Encode4(420424), // Rule ID 6008 //
     /* 420406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 420409 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420413 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420417 */   // (vecreduce_umin:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)  =>  (UMINVv8i8v:{ *:[i8] } FPR64:{ *:[v8i8] }:$Rn)
     /* 420417 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i8v),
     /* 420422 */   GIR_RootConstrainSelectedInstOperands,
     /* 420423 */   // GIR_Coverage, 6008,
     /* 420423 */   GIR_Done,
     /* 420424 */ // Label 8173: @420424
     /* 420424 */ GIM_Try, /*On fail goto*//*Label 8174*/ GIMT_Encode4(420447), // Rule ID 6009 //
     /* 420429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 420432 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 420436 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420440 */   // (vecreduce_umin:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)  =>  (UMINVv16i8v:{ *:[i8] } FPR128:{ *:[v16i8] }:$Rn)
     /* 420440 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv16i8v),
     /* 420445 */   GIR_RootConstrainSelectedInstOperands,
     /* 420446 */   // GIR_Coverage, 6009,
     /* 420446 */   GIR_Done,
     /* 420447 */ // Label 8174: @420447
     /* 420447 */ GIM_Reject,
     /* 420448 */ // Label 8170: @420448
     /* 420448 */ GIM_Try, /*On fail goto*//*Label 8175*/ GIMT_Encode4(420471), // Rule ID 6010 //
     /* 420453 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420456 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420460 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420464 */   // (vecreduce_umin:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)  =>  (UMINVv4i16v:{ *:[i16] } FPR64:{ *:[v4i16] }:$Rn)
     /* 420464 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i16v),
     /* 420469 */   GIR_RootConstrainSelectedInstOperands,
     /* 420470 */   // GIR_Coverage, 6010,
     /* 420470 */   GIR_Done,
     /* 420471 */ // Label 8175: @420471
     /* 420471 */ GIM_Try, /*On fail goto*//*Label 8176*/ GIMT_Encode4(420494), // Rule ID 6011 //
     /* 420476 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 420479 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 420483 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420487 */   // (vecreduce_umin:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)  =>  (UMINVv8i16v:{ *:[i16] } FPR128:{ *:[v8i16] }:$Rn)
     /* 420487 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv8i16v),
     /* 420492 */   GIR_RootConstrainSelectedInstOperands,
     /* 420493 */   // GIR_Coverage, 6011,
     /* 420493 */   GIR_Done,
     /* 420494 */ // Label 8176: @420494
     /* 420494 */ GIM_Reject,
     /* 420495 */ // Label 8171: @420495
     /* 420495 */ GIM_Try, /*On fail goto*//*Label 8177*/ GIMT_Encode4(420518), // Rule ID 6012 //
     /* 420500 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420503 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420507 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420511 */   // (vecreduce_umin:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)  =>  (UMINVv4i32v:{ *:[i32] } V128:{ *:[v4i32] }:$Rn)
     /* 420511 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMINVv4i32v),
     /* 420516 */   GIR_RootConstrainSelectedInstOperands,
     /* 420517 */   // GIR_Coverage, 6012,
     /* 420517 */   GIR_Done,
     /* 420518 */ // Label 8177: @420518
     /* 420518 */ GIM_Try, /*On fail goto*//*Label 8178*/ GIMT_Encode4(420579), // Rule ID 6013 //
     /* 420523 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420526 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420530 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420534 */   // (vecreduce_umin:{ *:[i32] } V64:{ *:[v2i32] }:$Rn)  =>  (EXTRACT_SUBREG:{ *:[i32] } (UMINPv2i32:{ *:[i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rn), ssub:{ *:[i32] })
     /* 420534 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 420537 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UMINPv2i32),
     /* 420541 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 420546 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420550 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 420554 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 420556 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 420559 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 420561 */   GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::ssub),
     /* 420568 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 420573 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420578 */   // GIR_Coverage, 6013,
     /* 420578 */   GIR_EraseRootFromParent_Done,
     /* 420579 */ // Label 8178: @420579
     /* 420579 */ GIM_Reject,
     /* 420580 */ // Label 8172: @420580
     /* 420580 */ GIM_Reject,
     /* 420581 */ // Label 122: @420581
     /* 420581 */ GIM_Try, /*On fail goto*//*Label 8179*/ GIMT_Encode4(420720),
     /* 420586 */   GIM_CheckIsImm, /*MI*/0, /*Op*/0,
     /* 420589 */   GIM_CheckPointerToAny, /*MI*/0, /*Op*/1, /*SizeInBits*/0,
     /* 420593 */   GIM_Try, /*On fail goto*//*Label 8180*/ GIMT_Encode4(420627), // Rule ID 257 //
     /* 420598 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Windexed64),
     /* 420605 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Windexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend))  =>  (PRFMroW (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR32:{ *:[i32] }:$Rm, ro_Wextend64:{ *:[i32] }:$extend)
     /* 420605 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroW),
     /* 420608 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420610 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420615 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 420620 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 420625 */     GIR_RootConstrainSelectedInstOperands,
     /* 420626 */     // GIR_Coverage, 257,
     /* 420626 */     GIR_EraseRootFromParent_Done,
     /* 420627 */   // Label 8180: @420627
     /* 420627 */   GIM_Try, /*On fail goto*//*Label 8181*/ GIMT_Encode4(420661), // Rule ID 258 //
     /* 420632 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_ro_Xindexed64),
     /* 420639 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (ro_Xindexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend))  =>  (PRFMroX (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, GPR64:{ *:[i64] }:$Rm, ro_Xextend64:{ *:[i32] }:$extend)
     /* 420639 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMroX),
     /* 420642 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420644 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420649 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // Rm
     /* 420654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/2, // extend
     /* 420659 */     GIR_RootConstrainSelectedInstOperands,
     /* 420660 */     // GIR_Coverage, 258,
     /* 420660 */     GIR_EraseRootFromParent_Done,
     /* 420661 */   // Label 8181: @420661
     /* 420661 */   GIM_Try, /*On fail goto*//*Label 8182*/ GIMT_Encode4(420690), // Rule ID 273 //
     /* 420666 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed64),
     /* 420673 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_indexed64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset))  =>  (PRFMui (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, uimm12s8:{ *:[i64] }:$offset)
     /* 420673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFMui),
     /* 420676 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420678 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420683 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 420688 */     GIR_RootConstrainSelectedInstOperands,
     /* 420689 */     // GIR_Coverage, 273,
     /* 420689 */     GIR_EraseRootFromParent_Done,
     /* 420690 */   // Label 8182: @420690
     /* 420690 */   GIM_Try, /*On fail goto*//*Label 8183*/ GIMT_Encode4(420719), // Rule ID 294 //
     /* 420695 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_unscaled64),
     /* 420702 */     // (AArch64Prefetch (timm:{ *:[i32] }):$Rt, (am_unscaled64:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_simm9>>:$offset))  =>  (PRFUMi (timm:{ *:[i32] }):$Rt, GPR64sp:{ *:[i64] }:$Rn, (imm:{ *:[i64] }):$offset)
     /* 420702 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::PRFUMi),
     /* 420705 */     GIR_RootToRootCopy, /*OpIdx*/0, // Rt
     /* 420707 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 420712 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/1, // offset
     /* 420717 */     GIR_RootConstrainSelectedInstOperands,
     /* 420718 */     // GIR_Coverage, 294,
     /* 420718 */     GIR_EraseRootFromParent_Done,
     /* 420719 */   // Label 8183: @420719
     /* 420719 */   GIM_Reject,
     /* 420720 */ // Label 8179: @420720
     /* 420720 */ GIM_Reject,
     /* 420721 */ // Label 123: @420721
     /* 420721 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8196*/ GIMT_Encode4(421708),
     /* 420732 */ /*GILLT_s64*//*Label 8184*/ GIMT_Encode4(420816), GIMT_Encode4(0),
     /* 420740 */ /*GILLT_v2s32*//*Label 8185*/ GIMT_Encode4(420854),
     /* 420744 */ /*GILLT_v2s64*//*Label 8186*/ GIMT_Encode4(420892),
     /* 420748 */ /*GILLT_v4s16*//*Label 8187*/ GIMT_Encode4(420930),
     /* 420752 */ /*GILLT_v4s32*//*Label 8188*/ GIMT_Encode4(420968),
     /* 420756 */ /*GILLT_v8s8*//*Label 8189*/ GIMT_Encode4(421006),
     /* 420760 */ /*GILLT_v8s16*//*Label 8190*/ GIMT_Encode4(421044),
     /* 420764 */ /*GILLT_v16s8*//*Label 8191*/ GIMT_Encode4(421082), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420784 */ /*GILLT_nxv2s64*//*Label 8192*/ GIMT_Encode4(421120), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 420796 */ /*GILLT_nxv4s32*//*Label 8193*/ GIMT_Encode4(421267), GIMT_Encode4(0),
     /* 420804 */ /*GILLT_nxv8s16*//*Label 8194*/ GIMT_Encode4(421414), GIMT_Encode4(0),
     /* 420812 */ /*GILLT_nxv16s8*//*Label 8195*/ GIMT_Encode4(421561),
     /* 420816 */ // Label 8184: @420816
     /* 420816 */ GIM_Try, /*On fail goto*//*Label 8197*/ GIMT_Encode4(420853), // Rule ID 5083 //
     /* 420821 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 420824 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 420827 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_s64,
     /* 420830 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420834 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420838 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420842 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420846 */   // (AArch64bsp:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)  =>  (BSPv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rd, V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm)
     /* 420846 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420851 */   GIR_RootConstrainSelectedInstOperands,
     /* 420852 */   // GIR_Coverage, 5083,
     /* 420852 */   GIR_Done,
     /* 420853 */ // Label 8197: @420853
     /* 420853 */ GIM_Reject,
     /* 420854 */ // Label 8185: @420854
     /* 420854 */ GIM_Try, /*On fail goto*//*Label 8198*/ GIMT_Encode4(420891), // Rule ID 5082 //
     /* 420859 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 420862 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 420865 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s32,
     /* 420868 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420872 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420876 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420880 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420884 */   // (AArch64bsp:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (BSPv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 420884 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420889 */   GIR_RootConstrainSelectedInstOperands,
     /* 420890 */   // GIR_Coverage, 5082,
     /* 420890 */   GIR_Done,
     /* 420891 */ // Label 8198: @420891
     /* 420891 */ GIM_Reject,
     /* 420892 */ // Label 8186: @420892
     /* 420892 */ GIM_Try, /*On fail goto*//*Label 8199*/ GIMT_Encode4(420929), // Rule ID 5087 //
     /* 420897 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 420900 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 420903 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v2s64,
     /* 420906 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420910 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420914 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420918 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420922 */   // (AArch64bsp:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (BSPv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rd, V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 420922 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 420927 */   GIR_RootConstrainSelectedInstOperands,
     /* 420928 */   // GIR_Coverage, 5087,
     /* 420928 */   GIR_Done,
     /* 420929 */ // Label 8199: @420929
     /* 420929 */ GIM_Reject,
     /* 420930 */ // Label 8187: @420930
     /* 420930 */ GIM_Try, /*On fail goto*//*Label 8200*/ GIMT_Encode4(420967), // Rule ID 5081 //
     /* 420935 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 420938 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 420941 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s16,
     /* 420944 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420948 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420952 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420956 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 420960 */   // (AArch64bsp:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (BSPv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rd, V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 420960 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 420965 */   GIR_RootConstrainSelectedInstOperands,
     /* 420966 */   // GIR_Coverage, 5081,
     /* 420966 */   GIR_Done,
     /* 420967 */ // Label 8200: @420967
     /* 420967 */ GIM_Reject,
     /* 420968 */ // Label 8188: @420968
     /* 420968 */ GIM_Try, /*On fail goto*//*Label 8201*/ GIMT_Encode4(421005), // Rule ID 5086 //
     /* 420973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 420976 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 420979 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v4s32,
     /* 420982 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420986 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420990 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420994 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 420998 */   // (AArch64bsp:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (BSPv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 420998 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421003 */   GIR_RootConstrainSelectedInstOperands,
     /* 421004 */   // GIR_Coverage, 5086,
     /* 421004 */   GIR_Done,
     /* 421005 */ // Label 8201: @421005
     /* 421005 */ GIM_Reject,
     /* 421006 */ // Label 8189: @421006
     /* 421006 */ GIM_Try, /*On fail goto*//*Label 8202*/ GIMT_Encode4(421043), // Rule ID 5080 //
     /* 421011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 421014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 421017 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 421020 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421024 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421028 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421032 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421036 */   // (AArch64bsp:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (BSPv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 421036 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv8i8),
     /* 421041 */   GIR_RootConstrainSelectedInstOperands,
     /* 421042 */   // GIR_Coverage, 5080,
     /* 421042 */   GIR_Done,
     /* 421043 */ // Label 8202: @421043
     /* 421043 */ GIM_Reject,
     /* 421044 */ // Label 8190: @421044
     /* 421044 */ GIM_Try, /*On fail goto*//*Label 8203*/ GIMT_Encode4(421081), // Rule ID 5085 //
     /* 421049 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 421052 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 421055 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s16,
     /* 421058 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421062 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421066 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421070 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421074 */   // (AArch64bsp:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (BSPv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rd, V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 421074 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421079 */   GIR_RootConstrainSelectedInstOperands,
     /* 421080 */   // GIR_Coverage, 5085,
     /* 421080 */   GIR_Done,
     /* 421081 */ // Label 8203: @421081
     /* 421081 */ GIM_Reject,
     /* 421082 */ // Label 8191: @421082
     /* 421082 */ GIM_Try, /*On fail goto*//*Label 8204*/ GIMT_Encode4(421119), // Rule ID 5084 //
     /* 421087 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 421090 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 421093 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 421096 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421100 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421104 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421108 */   GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 421112 */   // (AArch64bsp:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (BSPv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 421112 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::BSPv16i8),
     /* 421117 */   GIR_RootConstrainSelectedInstOperands,
     /* 421118 */   // GIR_Coverage, 5084,
     /* 421118 */   GIR_Done,
     /* 421119 */ // Label 8204: @421119
     /* 421119 */ GIM_Reject,
     /* 421120 */ // Label 8192: @421120
     /* 421120 */ GIM_Try, /*On fail goto*//*Label 8205*/ GIMT_Encode4(421266),
     /* 421125 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421128 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421131 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv2s64,
     /* 421134 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421138 */   GIM_Try, /*On fail goto*//*Label 8206*/ GIMT_Encode4(421191), // Rule ID 11951 //
     /* 421143 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421146 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421150 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421154 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421158 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421162 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421166 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421172 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421174 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421176 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, immAllOnesV:{ *:[nxv2i64] }), nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421176 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421179 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421181 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421185 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421187 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421189 */     GIR_RootConstrainSelectedInstOperands,
     /* 421190 */     // GIR_Coverage, 11951,
     /* 421190 */     GIR_EraseRootFromParent_Done,
     /* 421191 */   // Label 8206: @421191
     /* 421191 */   GIM_Try, /*On fail goto*//*Label 8207*/ GIMT_Encode4(421244), // Rule ID 11962 //
     /* 421196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421199 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421203 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421207 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 421211 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 421215 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421219 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421225 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421227 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421229 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, (xor:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op2, immAllOnesV:{ *:[nxv2i64] }))  =>  (BSL2N_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421229 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421232 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421234 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421236 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421240 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421242 */     GIR_RootConstrainSelectedInstOperands,
     /* 421243 */     // GIR_Coverage, 11962,
     /* 421243 */     GIR_EraseRootFromParent_Done,
     /* 421244 */   // Label 8207: @421244
     /* 421244 */   GIM_Try, /*On fail goto*//*Label 8208*/ GIMT_Encode4(421265), // Rule ID 11943 //
     /* 421249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421252 */     // (AArch64bsp:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op3, nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2, ?:{ *:[nxv2i64] }:$Op3)
     /* 421252 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421255 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421257 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421259 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421261 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421263 */     GIR_RootConstrainSelectedInstOperands,
     /* 421264 */     // GIR_Coverage, 11943,
     /* 421264 */     GIR_EraseRootFromParent_Done,
     /* 421265 */   // Label 8208: @421265
     /* 421265 */   GIM_Reject,
     /* 421266 */ // Label 8205: @421266
     /* 421266 */ GIM_Reject,
     /* 421267 */ // Label 8193: @421267
     /* 421267 */ GIM_Try, /*On fail goto*//*Label 8209*/ GIMT_Encode4(421413),
     /* 421272 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421275 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421278 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv4s32,
     /* 421281 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421285 */   GIM_Try, /*On fail goto*//*Label 8210*/ GIMT_Encode4(421338), // Rule ID 11949 //
     /* 421290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421293 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421297 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421301 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421305 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421313 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421319 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421321 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421323 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, immAllOnesV:{ *:[nxv4i32] }), nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421323 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421326 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421328 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421332 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421334 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421336 */     GIR_RootConstrainSelectedInstOperands,
     /* 421337 */     // GIR_Coverage, 11949,
     /* 421337 */     GIR_EraseRootFromParent_Done,
     /* 421338 */   // Label 8210: @421338
     /* 421338 */   GIM_Try, /*On fail goto*//*Label 8211*/ GIMT_Encode4(421391), // Rule ID 11959 //
     /* 421343 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421346 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421350 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421354 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 421358 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 421362 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421366 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421372 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421374 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421376 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, (xor:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op2, immAllOnesV:{ *:[nxv4i32] }))  =>  (BSL2N_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421376 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421379 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421381 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421383 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421387 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421389 */     GIR_RootConstrainSelectedInstOperands,
     /* 421390 */     // GIR_Coverage, 11959,
     /* 421390 */     GIR_EraseRootFromParent_Done,
     /* 421391 */   // Label 8211: @421391
     /* 421391 */   GIM_Try, /*On fail goto*//*Label 8212*/ GIMT_Encode4(421412), // Rule ID 11941 //
     /* 421396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421399 */     // (AArch64bsp:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op3, nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2, ?:{ *:[nxv4i32] }:$Op3)
     /* 421399 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421402 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421404 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421406 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421408 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421410 */     GIR_RootConstrainSelectedInstOperands,
     /* 421411 */     // GIR_Coverage, 11941,
     /* 421411 */     GIR_EraseRootFromParent_Done,
     /* 421412 */   // Label 8212: @421412
     /* 421412 */   GIM_Reject,
     /* 421413 */ // Label 8209: @421413
     /* 421413 */ GIM_Reject,
     /* 421414 */ // Label 8194: @421414
     /* 421414 */ GIM_Try, /*On fail goto*//*Label 8213*/ GIMT_Encode4(421560),
     /* 421419 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421422 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421425 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 421428 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421432 */   GIM_Try, /*On fail goto*//*Label 8214*/ GIMT_Encode4(421485), // Rule ID 11947 //
     /* 421437 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421448 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421452 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421456 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421460 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421466 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421468 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421470 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, immAllOnesV:{ *:[nxv8i16] }), nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421479 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421483 */     GIR_RootConstrainSelectedInstOperands,
     /* 421484 */     // GIR_Coverage, 11947,
     /* 421484 */     GIR_EraseRootFromParent_Done,
     /* 421485 */   // Label 8214: @421485
     /* 421485 */   GIM_Try, /*On fail goto*//*Label 8215*/ GIMT_Encode4(421538), // Rule ID 11956 //
     /* 421490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421493 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421497 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421501 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 421505 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 421509 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421513 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421519 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421521 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421523 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, (xor:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op2, immAllOnesV:{ *:[nxv8i16] }))  =>  (BSL2N_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421523 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421526 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421528 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421530 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421534 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421536 */     GIR_RootConstrainSelectedInstOperands,
     /* 421537 */     // GIR_Coverage, 11956,
     /* 421537 */     GIR_EraseRootFromParent_Done,
     /* 421538 */   // Label 8215: @421538
     /* 421538 */   GIM_Try, /*On fail goto*//*Label 8216*/ GIMT_Encode4(421559), // Rule ID 11939 //
     /* 421543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421546 */     // (AArch64bsp:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op3, nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 421546 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421549 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421551 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421553 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421555 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421557 */     GIR_RootConstrainSelectedInstOperands,
     /* 421558 */     // GIR_Coverage, 11939,
     /* 421558 */     GIR_EraseRootFromParent_Done,
     /* 421559 */   // Label 8216: @421559
     /* 421559 */   GIM_Reject,
     /* 421560 */ // Label 8213: @421560
     /* 421560 */ GIM_Reject,
     /* 421561 */ // Label 8195: @421561
     /* 421561 */ GIM_Try, /*On fail goto*//*Label 8217*/ GIMT_Encode4(421707),
     /* 421566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421572 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 421575 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 421579 */   GIM_Try, /*On fail goto*//*Label 8218*/ GIMT_Encode4(421632), // Rule ID 11945 //
     /* 421584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 421591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421599 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421603 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421607 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421613 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421615 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421617 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, immAllOnesV:{ *:[nxv16i8] }), nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL1N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421617 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL1N_ZZZZ),
     /* 421620 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421622 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op1
     /* 421626 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421628 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421630 */     GIR_RootConstrainSelectedInstOperands,
     /* 421631 */     // GIR_Coverage, 11945,
     /* 421631 */     GIR_EraseRootFromParent_Done,
     /* 421632 */   // Label 8218: @421632
     /* 421632 */   GIM_Try, /*On fail goto*//*Label 8219*/ GIMT_Encode4(421685), // Rule ID 11953 //
     /* 421637 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421640 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 421644 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_XOR),
     /* 421648 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 421652 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 421656 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 421660 */     GIM_CheckOpcodeIsEither, /*MI*/2, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 421666 */     GIM_CheckIsBuildVectorAllOnes, /*MI*/2,
     /* 421668 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 421670 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, (xor:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op2, immAllOnesV:{ *:[nxv16i8] }))  =>  (BSL2N_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421670 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL2N_ZZZZ),
     /* 421673 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421675 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421677 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Op2
     /* 421681 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421683 */     GIR_RootConstrainSelectedInstOperands,
     /* 421684 */     // GIR_Coverage, 11953,
     /* 421684 */     GIR_EraseRootFromParent_Done,
     /* 421685 */   // Label 8219: @421685
     /* 421685 */   GIM_Try, /*On fail goto*//*Label 8220*/ GIMT_Encode4(421706), // Rule ID 11937 //
     /* 421690 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE2_or_SME),
     /* 421693 */     // (AArch64bsp:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op3, nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (BSL_ZZZZ:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 421693 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::BSL_ZZZZ),
     /* 421696 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 421698 */     GIR_RootToRootCopy, /*OpIdx*/2, // Op1
     /* 421700 */     GIR_RootToRootCopy, /*OpIdx*/3, // Op2
     /* 421702 */     GIR_RootToRootCopy, /*OpIdx*/1, // Op3
     /* 421704 */     GIR_RootConstrainSelectedInstOperands,
     /* 421705 */     // GIR_Coverage, 11937,
     /* 421705 */     GIR_EraseRootFromParent_Done,
     /* 421706 */   // Label 8220: @421706
     /* 421706 */   GIM_Reject,
     /* 421707 */ // Label 8217: @421707
     /* 421707 */ GIM_Reject,
     /* 421708 */ // Label 8196: @421708
     /* 421708 */ GIM_Reject,
     /* 421709 */ // Label 124: @421709
     /* 421709 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8229*/ GIMT_Encode4(423691),
     /* 421720 */ /*GILLT_s64*//*Label 8221*/ GIMT_Encode4(421756), GIMT_Encode4(0),
     /* 421728 */ /*GILLT_v2s32*//*Label 8222*/ GIMT_Encode4(421951),
     /* 421732 */ /*GILLT_v2s64*//*Label 8223*/ GIMT_Encode4(422198),
     /* 421736 */ /*GILLT_v4s16*//*Label 8224*/ GIMT_Encode4(422445),
     /* 421740 */ /*GILLT_v4s32*//*Label 8225*/ GIMT_Encode4(422721),
     /* 421744 */ /*GILLT_v8s8*//*Label 8226*/ GIMT_Encode4(422968),
     /* 421748 */ /*GILLT_v8s16*//*Label 8227*/ GIMT_Encode4(423193),
     /* 421752 */ /*GILLT_v16s8*//*Label 8228*/ GIMT_Encode4(423469),
     /* 421756 */ // Label 8221: @421756
     /* 421756 */ GIM_Try, /*On fail goto*//*Label 8230*/ GIMT_Encode4(421950),
     /* 421761 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 421764 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421768 */   GIM_Try, /*On fail goto*//*Label 8231*/ GIMT_Encode4(421815), // Rule ID 6453 //
     /* 421773 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421777 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421781 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421784 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421788 */     // MIs[1] Rn
     /* 421788 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421792 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421797 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421799 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421799 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421802 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421804 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421808 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421813 */     GIR_RootConstrainSelectedInstOperands,
     /* 421814 */     // GIR_Coverage, 6453,
     /* 421814 */     GIR_EraseRootFromParent_Done,
     /* 421815 */   // Label 8231: @421815
     /* 421815 */   GIM_Try, /*On fail goto*//*Label 8232*/ GIMT_Encode4(421862), // Rule ID 6464 //
     /* 421820 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421824 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421828 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421831 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421835 */     // MIs[1] Rn
     /* 421835 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421839 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421846 */     // (AArch64dup:{ *:[v1f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421851 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421855 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421860 */     GIR_RootConstrainSelectedInstOperands,
     /* 421861 */     // GIR_Coverage, 6464,
     /* 421861 */     GIR_EraseRootFromParent_Done,
     /* 421862 */   // Label 8232: @421862
     /* 421862 */   GIM_Try, /*On fail goto*//*Label 8233*/ GIMT_Encode4(421909), // Rule ID 13278 //
     /* 421867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421871 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421875 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421878 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421882 */     // MIs[1] Rn
     /* 421882 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421886 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421891 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421893 */     // (AArch64dup:{ *:[v1i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv1d:{ *:[v1i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421893 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv1d),
     /* 421896 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421898 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 421902 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 421907 */     GIR_RootConstrainSelectedInstOperands,
     /* 421908 */     // GIR_Coverage, 13278,
     /* 421908 */     GIR_EraseRootFromParent_Done,
     /* 421909 */   // Label 8233: @421909
     /* 421909 */   GIM_Try, /*On fail goto*//*Label 8234*/ GIMT_Encode4(421929), // Rule ID 5646 //
     /* 421914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 421918 */     // (AArch64dup:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1i64] } GPR64:{ *:[i64] }:$Rn, FPR64:{ *:[i32] })
     /* 421918 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421923 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421928 */     // GIR_Coverage, 5646,
     /* 421928 */     GIR_Done,
     /* 421929 */   // Label 8234: @421929
     /* 421929 */   GIM_Try, /*On fail goto*//*Label 8235*/ GIMT_Encode4(421949), // Rule ID 5647 //
     /* 421934 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421938 */     // (AArch64dup:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn)  =>  (COPY_TO_REGCLASS:{ *:[v1f64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[i32] })
     /* 421938 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 421943 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421948 */     // GIR_Coverage, 5647,
     /* 421948 */     GIR_Done,
     /* 421949 */   // Label 8235: @421949
     /* 421949 */   GIM_Reject,
     /* 421950 */ // Label 8230: @421950
     /* 421950 */ GIM_Reject,
     /* 421951 */ // Label 8222: @421951
     /* 421951 */ GIM_Try, /*On fail goto*//*Label 8236*/ GIMT_Encode4(422197),
     /* 421956 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 421959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 421963 */   GIM_Try, /*On fail goto*//*Label 8237*/ GIMT_Encode4(422010), // Rule ID 6450 //
     /* 421968 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 421972 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 421976 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 421979 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 421983 */     // MIs[1] Rn
     /* 421983 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 421987 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 421992 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 421994 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 421994 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 421997 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 421999 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422003 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422008 */     GIR_RootConstrainSelectedInstOperands,
     /* 422009 */     // GIR_Coverage, 6450,
     /* 422009 */     GIR_EraseRootFromParent_Done,
     /* 422010 */   // Label 8237: @422010
     /* 422010 */   GIM_Try, /*On fail goto*//*Label 8238*/ GIMT_Encode4(422057), // Rule ID 6461 //
     /* 422015 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422019 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422023 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422026 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422030 */     // MIs[1] Rn
     /* 422030 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422034 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422039 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422041 */     // (AArch64dup:{ *:[v2f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422041 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 422044 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422046 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422050 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422055 */     GIR_RootConstrainSelectedInstOperands,
     /* 422056 */     // GIR_Coverage, 6461,
     /* 422056 */     GIR_EraseRootFromParent_Done,
     /* 422057 */   // Label 8238: @422057
     /* 422057 */   GIM_Try, /*On fail goto*//*Label 8239*/ GIMT_Encode4(422104), // Rule ID 13275 //
     /* 422062 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422066 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422070 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422073 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422077 */     // MIs[1] Rn
     /* 422077 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422086 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422088 */     // (AArch64dup:{ *:[v2i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2s:{ *:[v2i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2s),
     /* 422091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422093 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422097 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422102 */     GIR_RootConstrainSelectedInstOperands,
     /* 422103 */     // GIR_Coverage, 13275,
     /* 422103 */     GIR_EraseRootFromParent_Done,
     /* 422104 */   // Label 8239: @422104
     /* 422104 */   GIM_Try, /*On fail goto*//*Label 8240*/ GIMT_Encode4(422123), // Rule ID 1916 //
     /* 422109 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422112 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422116 */     // (AArch64dup:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv2i32gpr:{ *:[v2i32] } GPR32:{ *:[i32] }:$Rn)
     /* 422116 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32gpr),
     /* 422121 */     GIR_RootConstrainSelectedInstOperands,
     /* 422122 */     // GIR_Coverage, 1916,
     /* 422122 */     GIR_Done,
     /* 422123 */   // Label 8240: @422123
     /* 422123 */   GIM_Try, /*On fail goto*//*Label 8241*/ GIMT_Encode4(422196), // Rule ID 5648 //
     /* 422128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422132 */     // (AArch64dup:{ *:[v2f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv2i32lane:{ *:[v2f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422132 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422135 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422139 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422144 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422146 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422149 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422153 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422158 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422161 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422165 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 422168 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422173 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422178 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 422186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422188 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422191 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422194 */     GIR_RootConstrainSelectedInstOperands,
     /* 422195 */     // GIR_Coverage, 5648,
     /* 422195 */     GIR_EraseRootFromParent_Done,
     /* 422196 */   // Label 8241: @422196
     /* 422196 */   GIM_Reject,
     /* 422197 */ // Label 8236: @422197
     /* 422197 */ GIM_Reject,
     /* 422198 */ // Label 8223: @422198
     /* 422198 */ GIM_Try, /*On fail goto*//*Label 8242*/ GIMT_Encode4(422444),
     /* 422203 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 422206 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422210 */   GIM_Try, /*On fail goto*//*Label 8243*/ GIMT_Encode4(422257), // Rule ID 6452 //
     /* 422215 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422219 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422223 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422226 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422230 */     // MIs[1] Rn
     /* 422230 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422234 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422239 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422241 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422241 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422244 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422246 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422250 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422255 */     GIR_RootConstrainSelectedInstOperands,
     /* 422256 */     // GIR_Coverage, 6452,
     /* 422256 */     GIR_EraseRootFromParent_Done,
     /* 422257 */   // Label 8243: @422257
     /* 422257 */   GIM_Try, /*On fail goto*//*Label 8244*/ GIMT_Encode4(422304), // Rule ID 6463 //
     /* 422262 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422266 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422270 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422273 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422277 */     // MIs[1] Rn
     /* 422277 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422281 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422286 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422288 */     // (AArch64dup:{ *:[v2f64] } (ld:{ *:[f64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2f64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422288 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422291 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422293 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422297 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422302 */     GIR_RootConstrainSelectedInstOperands,
     /* 422303 */     // GIR_Coverage, 6463,
     /* 422303 */     GIR_EraseRootFromParent_Done,
     /* 422304 */   // Label 8244: @422304
     /* 422304 */   GIM_Try, /*On fail goto*//*Label 8245*/ GIMT_Encode4(422351), // Rule ID 13277 //
     /* 422309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422313 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422317 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422320 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422324 */     // MIs[1] Rn
     /* 422324 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422328 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422333 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422335 */     // (AArch64dup:{ *:[v2i64] } (ld:{ *:[i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422335 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 422338 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422340 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422344 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422349 */     GIR_RootConstrainSelectedInstOperands,
     /* 422350 */     // GIR_Coverage, 13277,
     /* 422350 */     GIR_EraseRootFromParent_Done,
     /* 422351 */   // Label 8245: @422351
     /* 422351 */   GIM_Try, /*On fail goto*//*Label 8246*/ GIMT_Encode4(422370), // Rule ID 1918 //
     /* 422356 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422359 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 422363 */     // (AArch64dup:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)  =>  (DUPv2i64gpr:{ *:[v2i64] } GPR64:{ *:[i64] }:$Rn)
     /* 422363 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64gpr),
     /* 422368 */     GIR_RootConstrainSelectedInstOperands,
     /* 422369 */     // GIR_Coverage, 1918,
     /* 422369 */     GIR_Done,
     /* 422370 */   // Label 8246: @422370
     /* 422370 */   GIM_Try, /*On fail goto*//*Label 8247*/ GIMT_Encode4(422443), // Rule ID 5650 //
     /* 422375 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422379 */     // (AArch64dup:{ *:[v2f64] } FPR64:{ *:[f64] }:$Rn)  =>  (DUPv2i64lane:{ *:[v2f64] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR64:{ *:[f64] }:$Rn, dsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422379 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422382 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422386 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422391 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422393 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422396 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422400 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422405 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422408 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422412 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/3,
     /* 422415 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422420 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422425 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422430 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 422433 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422435 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422438 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422441 */     GIR_RootConstrainSelectedInstOperands,
     /* 422442 */     // GIR_Coverage, 5650,
     /* 422442 */     GIR_EraseRootFromParent_Done,
     /* 422443 */   // Label 8247: @422443
     /* 422443 */   GIM_Reject,
     /* 422444 */ // Label 8242: @422444
     /* 422444 */ GIM_Reject,
     /* 422445 */ // Label 8224: @422445
     /* 422445 */ GIM_Try, /*On fail goto*//*Label 8248*/ GIMT_Encode4(422506), // Rule ID 6448 //
     /* 422450 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422453 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422457 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422461 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422465 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422468 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422472 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 422479 */   // MIs[1] Rn
     /* 422479 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422483 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422488 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422490 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422490 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422493 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422495 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422499 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422504 */   GIR_RootConstrainSelectedInstOperands,
     /* 422505 */   // GIR_Coverage, 6448,
     /* 422505 */   GIR_EraseRootFromParent_Done,
     /* 422506 */ // Label 8248: @422506
     /* 422506 */ GIM_Try, /*On fail goto*//*Label 8249*/ GIMT_Encode4(422560), // Rule ID 6465 //
     /* 422511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422514 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422518 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422522 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422526 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422529 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422533 */   // MIs[1] Rn
     /* 422533 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422537 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422542 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422544 */   // (AArch64dup:{ *:[v4f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422544 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422547 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422549 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422553 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422558 */   GIR_RootConstrainSelectedInstOperands,
     /* 422559 */   // GIR_Coverage, 6465,
     /* 422559 */   GIR_EraseRootFromParent_Done,
     /* 422560 */ // Label 8249: @422560
     /* 422560 */ GIM_Try, /*On fail goto*//*Label 8250*/ GIMT_Encode4(422614), // Rule ID 13273 //
     /* 422565 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422568 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422572 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422576 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422580 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422583 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422587 */   // MIs[1] Rn
     /* 422587 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422591 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422596 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422598 */   // (AArch64dup:{ *:[v4i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4h:{ *:[v4i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422598 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4h),
     /* 422601 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422603 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422607 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422612 */   GIR_RootConstrainSelectedInstOperands,
     /* 422613 */   // GIR_Coverage, 13273,
     /* 422613 */   GIR_EraseRootFromParent_Done,
     /* 422614 */ // Label 8250: @422614
     /* 422614 */ GIM_Try, /*On fail goto*//*Label 8251*/ GIMT_Encode4(422640), // Rule ID 1914 //
     /* 422619 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422622 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422625 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422629 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422633 */   // (AArch64dup:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i16gpr:{ *:[v4i16] } GPR32:{ *:[i32] }:$Rn)
     /* 422633 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16gpr),
     /* 422638 */   GIR_RootConstrainSelectedInstOperands,
     /* 422639 */   // GIR_Coverage, 1914,
     /* 422639 */   GIR_Done,
     /* 422640 */ // Label 8251: @422640
     /* 422640 */ GIM_Try, /*On fail goto*//*Label 8252*/ GIMT_Encode4(422720), // Rule ID 5651 //
     /* 422645 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 422648 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422652 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422656 */   // (AArch64dup:{ *:[v4f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv4i16lane:{ *:[v4f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422656 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 422659 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422663 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422668 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422670 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 422673 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422677 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422682 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422685 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422689 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 422692 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422697 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422702 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 422707 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 422710 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422712 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422715 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422718 */   GIR_RootConstrainSelectedInstOperands,
     /* 422719 */   // GIR_Coverage, 5651,
     /* 422719 */   GIR_EraseRootFromParent_Done,
     /* 422720 */ // Label 8252: @422720
     /* 422720 */ GIM_Reject,
     /* 422721 */ // Label 8225: @422721
     /* 422721 */ GIM_Try, /*On fail goto*//*Label 8253*/ GIMT_Encode4(422967),
     /* 422726 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 422729 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422733 */   GIM_Try, /*On fail goto*//*Label 8254*/ GIMT_Encode4(422780), // Rule ID 6451 //
     /* 422738 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422742 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422746 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422749 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422753 */     // MIs[1] Rn
     /* 422753 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422757 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422762 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422764 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422764 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422767 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422769 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422773 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422778 */     GIR_RootConstrainSelectedInstOperands,
     /* 422779 */     // GIR_Coverage, 6451,
     /* 422779 */     GIR_EraseRootFromParent_Done,
     /* 422780 */   // Label 8254: @422780
     /* 422780 */   GIM_Try, /*On fail goto*//*Label 8255*/ GIMT_Encode4(422827), // Rule ID 6462 //
     /* 422785 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422789 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422793 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422796 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422800 */     // MIs[1] Rn
     /* 422800 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422804 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422809 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422811 */     // (AArch64dup:{ *:[v4f32] } (ld:{ *:[f32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4f32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422811 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422814 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422816 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422820 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422825 */     GIR_RootConstrainSelectedInstOperands,
     /* 422826 */     // GIR_Coverage, 6462,
     /* 422826 */     GIR_EraseRootFromParent_Done,
     /* 422827 */   // Label 8255: @422827
     /* 422827 */   GIM_Try, /*On fail goto*//*Label 8256*/ GIMT_Encode4(422874), // Rule ID 13276 //
     /* 422832 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422836 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422840 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422843 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422847 */     // MIs[1] Rn
     /* 422847 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 422851 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 422856 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 422858 */     // (AArch64dup:{ *:[v4i32] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 422858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 422861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 422863 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 422867 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 422872 */     GIR_RootConstrainSelectedInstOperands,
     /* 422873 */     // GIR_Coverage, 13276,
     /* 422873 */     GIR_EraseRootFromParent_Done,
     /* 422874 */   // Label 8256: @422874
     /* 422874 */   GIM_Try, /*On fail goto*//*Label 8257*/ GIMT_Encode4(422893), // Rule ID 1917 //
     /* 422879 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 422882 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 422886 */     // (AArch64dup:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv4i32gpr:{ *:[v4i32] } GPR32:{ *:[i32] }:$Rn)
     /* 422886 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32gpr),
     /* 422891 */     GIR_RootConstrainSelectedInstOperands,
     /* 422892 */     // GIR_Coverage, 1917,
     /* 422892 */     GIR_Done,
     /* 422893 */   // Label 8257: @422893
     /* 422893 */   GIM_Try, /*On fail goto*//*Label 8258*/ GIMT_Encode4(422966), // Rule ID 5649 //
     /* 422898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422902 */     // (AArch64dup:{ *:[v4f32] } FPR32:{ *:[f32] }:$Rn)  =>  (DUPv4i32lane:{ *:[v4f32] } (INSERT_SUBREG:{ *:[v4i32] } (IMPLICIT_DEF:{ *:[v4i32] }), FPR32:{ *:[f32] }:$Rn, ssub:{ *:[i32] }), 0:{ *:[i64] })
     /* 422902 */     GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v4s32,
     /* 422905 */     GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 422909 */     GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422914 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 422916 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v4s32,
     /* 422919 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 422923 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 422928 */     GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 422931 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 422935 */     GIR_AddImm8, /*InsnID*/1, /*Imm*/18,
     /* 422938 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422943 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 422948 */     GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 422953 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 422956 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 422958 */     GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 422961 */     GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 422964 */     GIR_RootConstrainSelectedInstOperands,
     /* 422965 */     // GIR_Coverage, 5649,
     /* 422965 */     GIR_EraseRootFromParent_Done,
     /* 422966 */   // Label 8258: @422966
     /* 422966 */   GIM_Reject,
     /* 422967 */ // Label 8253: @422967
     /* 422967 */ GIM_Reject,
     /* 422968 */ // Label 8226: @422968
     /* 422968 */ GIM_Try, /*On fail goto*//*Label 8259*/ GIMT_Encode4(423025), // Rule ID 13271 //
     /* 422973 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 422976 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 422980 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 422984 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 422988 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 422991 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 422995 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/0,
     /* 422999 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423001 */   GIM_CheckComplexPattern, /*MI*/1, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_am_indexed8),
     /* 423008 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i8] } (am_indexed8:{ *:[iPTR] } GPR64sp:{ *:[i64] }:$Rn))<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423008 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 423011 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423013 */   GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 423018 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423023 */   GIR_RootConstrainSelectedInstOperands,
     /* 423024 */   // GIR_Coverage, 13271,
     /* 423024 */   GIR_EraseRootFromParent_Done,
     /* 423025 */ // Label 8259: @423025
     /* 423025 */ GIM_Try, /*On fail goto*//*Label 8260*/ GIMT_Encode4(423086), // Rule ID 6446 //
     /* 423030 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423033 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423037 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423041 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423045 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423048 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423052 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 423059 */   // MIs[1] Rn
     /* 423059 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423063 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423068 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423070 */   // (AArch64dup:{ *:[v8i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv8b:{ *:[v8i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423070 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8b),
     /* 423073 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423075 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423079 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423084 */   GIR_RootConstrainSelectedInstOperands,
     /* 423085 */   // GIR_Coverage, 6446,
     /* 423085 */   GIR_EraseRootFromParent_Done,
     /* 423086 */ // Label 8260: @423086
     /* 423086 */ GIM_Try, /*On fail goto*//*Label 8261*/ GIMT_Encode4(423112), // Rule ID 1912 //
     /* 423091 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423094 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423097 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423101 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423105 */   // (AArch64dup:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i8gpr:{ *:[v8i8] } GPR32:{ *:[i32] }:$Rn)
     /* 423105 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8gpr),
     /* 423110 */   GIR_RootConstrainSelectedInstOperands,
     /* 423111 */   // GIR_Coverage, 1912,
     /* 423111 */   GIR_Done,
     /* 423112 */ // Label 8261: @423112
     /* 423112 */ GIM_Try, /*On fail goto*//*Label 8262*/ GIMT_Encode4(423192), // Rule ID 5653 //
     /* 423117 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423120 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423124 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423128 */   // (AArch64dup:{ *:[v8i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv8i8lane:{ *:[v8i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423128 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 423131 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423135 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423140 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423142 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 423145 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423149 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423154 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423157 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423161 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 423164 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423169 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423174 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423179 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 423182 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423184 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423187 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423190 */   GIR_RootConstrainSelectedInstOperands,
     /* 423191 */   // GIR_Coverage, 5653,
     /* 423191 */   GIR_EraseRootFromParent_Done,
     /* 423192 */ // Label 8262: @423192
     /* 423192 */ GIM_Reject,
     /* 423193 */ // Label 8227: @423193
     /* 423193 */ GIM_Try, /*On fail goto*//*Label 8263*/ GIMT_Encode4(423254), // Rule ID 6449 //
     /* 423198 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423205 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423209 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423213 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423216 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423220 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(2),
     /* 423227 */   // MIs[1] Rn
     /* 423227 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423231 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423236 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423238 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423238 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423241 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423243 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423247 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423252 */   GIR_RootConstrainSelectedInstOperands,
     /* 423253 */   // GIR_Coverage, 6449,
     /* 423253 */   GIR_EraseRootFromParent_Done,
     /* 423254 */ // Label 8263: @423254
     /* 423254 */ GIM_Try, /*On fail goto*//*Label 8264*/ GIMT_Encode4(423308), // Rule ID 6466 //
     /* 423259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423262 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423266 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423270 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423274 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423277 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423281 */   // MIs[1] Rn
     /* 423281 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423285 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423290 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423292 */   // (AArch64dup:{ *:[v8f16] } (ld:{ *:[f16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8f16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423292 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423295 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423297 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423301 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423306 */   GIR_RootConstrainSelectedInstOperands,
     /* 423307 */   // GIR_Coverage, 6466,
     /* 423307 */   GIR_EraseRootFromParent_Done,
     /* 423308 */ // Label 8264: @423308
     /* 423308 */ GIM_Try, /*On fail goto*//*Label 8265*/ GIMT_Encode4(423362), // Rule ID 13274 //
     /* 423313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423316 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423320 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423324 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423328 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423331 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423335 */   // MIs[1] Rn
     /* 423335 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423339 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423344 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423346 */   // (AArch64dup:{ *:[v8i16] } (ld:{ *:[i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423346 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423349 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423351 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423355 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423360 */   GIR_RootConstrainSelectedInstOperands,
     /* 423361 */   // GIR_Coverage, 13274,
     /* 423361 */   GIR_EraseRootFromParent_Done,
     /* 423362 */ // Label 8265: @423362
     /* 423362 */ GIM_Try, /*On fail goto*//*Label 8266*/ GIMT_Encode4(423388), // Rule ID 1915 //
     /* 423367 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423370 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423373 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423377 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423381 */   // (AArch64dup:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv8i16gpr:{ *:[v8i16] } GPR32:{ *:[i32] }:$Rn)
     /* 423381 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16gpr),
     /* 423386 */   GIR_RootConstrainSelectedInstOperands,
     /* 423387 */   // GIR_Coverage, 1915,
     /* 423387 */   GIR_Done,
     /* 423388 */ // Label 8266: @423388
     /* 423388 */ GIM_Try, /*On fail goto*//*Label 8267*/ GIMT_Encode4(423468), // Rule ID 5652 //
     /* 423393 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 423396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423400 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423404 */   // (AArch64dup:{ *:[v8f16] } FPR16:{ *:[f16] }:$Rn)  =>  (DUPv8i16lane:{ *:[v8f16] } (INSERT_SUBREG:{ *:[v8i16] } (IMPLICIT_DEF:{ *:[v8i16] }), FPR16:{ *:[f16] }:$Rn, hsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423404 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v8s16,
     /* 423407 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423411 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423416 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423418 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v8s16,
     /* 423421 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423425 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423430 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423433 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423437 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/9,
     /* 423440 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423445 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423450 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 423455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423460 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423463 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423466 */   GIR_RootConstrainSelectedInstOperands,
     /* 423467 */   // GIR_Coverage, 5652,
     /* 423467 */   GIR_EraseRootFromParent_Done,
     /* 423468 */ // Label 8267: @423468
     /* 423468 */ GIM_Reject,
     /* 423469 */ // Label 8228: @423469
     /* 423469 */ GIM_Try, /*On fail goto*//*Label 8268*/ GIMT_Encode4(423530), // Rule ID 6447 //
     /* 423474 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423477 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423481 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423485 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423489 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423492 */   GIM_CheckMemorySizeLessThanLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423496 */   GIM_CheckMemorySizeEqualTo, /*MI*/1, /*MMO*/0, /*Size*/GIMT_Encode4(1),
     /* 423503 */   // MIs[1] Rn
     /* 423503 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423507 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423512 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423514 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423514 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423517 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423519 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423523 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423528 */   GIR_RootConstrainSelectedInstOperands,
     /* 423529 */   // GIR_Coverage, 6447,
     /* 423529 */   GIR_EraseRootFromParent_Done,
     /* 423530 */ // Label 8268: @423530
     /* 423530 */ GIM_Try, /*On fail goto*//*Label 8269*/ GIMT_Encode4(423584), // Rule ID 13272 //
     /* 423535 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423538 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423542 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423546 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423550 */   GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423553 */   GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423557 */   // MIs[1] Rn
     /* 423557 */   GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423561 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423566 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423568 */   // (AArch64dup:{ *:[v16i8] } (ld:{ *:[i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>)  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423568 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 423571 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423573 */   GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423577 */   GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423582 */   GIR_RootConstrainSelectedInstOperands,
     /* 423583 */   // GIR_Coverage, 13272,
     /* 423583 */   GIR_EraseRootFromParent_Done,
     /* 423584 */ // Label 8269: @423584
     /* 423584 */ GIM_Try, /*On fail goto*//*Label 8270*/ GIMT_Encode4(423610), // Rule ID 1913 //
     /* 423589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 423595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 423603 */   // (AArch64dup:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)  =>  (DUPv16i8gpr:{ *:[v16i8] } GPR32:{ *:[i32] }:$Rn)
     /* 423603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8gpr),
     /* 423608 */   GIR_RootConstrainSelectedInstOperands,
     /* 423609 */   // GIR_Coverage, 1913,
     /* 423609 */   GIR_Done,
     /* 423610 */ // Label 8270: @423610
     /* 423610 */ GIM_Try, /*On fail goto*//*Label 8271*/ GIMT_Encode4(423690), // Rule ID 5654 //
     /* 423615 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s8,
     /* 423618 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423622 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423626 */   // (AArch64dup:{ *:[v16i8] } FPR8:{ *:[i8] }:$Rn)  =>  (DUPv16i8lane:{ *:[v16i8] } (INSERT_SUBREG:{ *:[v16i8] } (IMPLICIT_DEF:{ *:[v16i8] }), FPR8:{ *:[i8] }:$Rn, bsub:{ *:[i32] }), 0:{ *:[i64] })
     /* 423626 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_v16s8,
     /* 423629 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 423633 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423638 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 423640 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v16s8,
     /* 423643 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 423647 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 423652 */   GIR_AddSimpleTempRegister, /*InsnID*/1, /*TempRegID*/1,
     /* 423655 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 423659 */   GIR_AddImm8, /*InsnID*/1, /*Imm*/1,
     /* 423662 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423667 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423672 */   GIR_ConstrainOperandRC, /*InsnID*/1, /*Op*/2, GIMT_Encode2(AArch64::FPR8RegClassID),
     /* 423677 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 423680 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423682 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 423685 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 423688 */   GIR_RootConstrainSelectedInstOperands,
     /* 423689 */   // GIR_Coverage, 5654,
     /* 423689 */   GIR_EraseRootFromParent_Done,
     /* 423690 */ // Label 8271: @423690
     /* 423690 */ GIM_Reject,
     /* 423691 */ // Label 8229: @423691
     /* 423691 */ GIM_Reject,
     /* 423692 */ // Label 125: @423692
     /* 423692 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(11), /*)*//*default:*//*Label 8274*/ GIMT_Encode4(423946),
     /* 423703 */ /*GILLT_v4s16*//*Label 8272*/ GIMT_Encode4(423719), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423715 */ /*GILLT_v8s16*//*Label 8273*/ GIMT_Encode4(423805),
     /* 423719 */ // Label 8272: @423719
     /* 423719 */ GIM_Try, /*On fail goto*//*Label 8275*/ GIMT_Encode4(423804),
     /* 423724 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423727 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423730 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423734 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423738 */   GIM_Try, /*On fail goto*//*Label 8276*/ GIMT_Encode4(423772), // Rule ID 1922 //
     /* 423743 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423746 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423750 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423754 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423758 */     // MIs[1] Operand 1
     /* 423758 */     // No operand predicates
     /* 423758 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423760 */     // (AArch64duplane16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv4i16lane:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423760 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 423763 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423765 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423770 */     GIR_RootConstrainSelectedInstOperands,
     /* 423771 */     // GIR_Coverage, 1922,
     /* 423771 */     GIR_EraseRootFromParent_Done,
     /* 423772 */   // Label 8276: @423772
     /* 423772 */   GIM_Try, /*On fail goto*//*Label 8277*/ GIMT_Encode4(423803), // Rule ID 5655 //
     /* 423777 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423781 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423785 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423789 */     // MIs[1] Operand 1
     /* 423789 */     // No operand predicates
     /* 423789 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423791 */     // (AArch64duplane16:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv4i16lane:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 423791 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i16lane),
     /* 423794 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423796 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423798 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423801 */     GIR_RootConstrainSelectedInstOperands,
     /* 423802 */     // GIR_Coverage, 5655,
     /* 423802 */     GIR_EraseRootFromParent_Done,
     /* 423803 */   // Label 8277: @423803
     /* 423803 */   GIM_Reject,
     /* 423804 */ // Label 8275: @423804
     /* 423804 */ GIM_Reject,
     /* 423805 */ // Label 8273: @423805
     /* 423805 */ GIM_Try, /*On fail goto*//*Label 8278*/ GIMT_Encode4(423945),
     /* 423810 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 423813 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423816 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423820 */   GIM_Try, /*On fail goto*//*Label 8279*/ GIMT_Encode4(423871), // Rule ID 6457 //
     /* 423825 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 423829 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 423833 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 423836 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 423840 */     // MIs[1] Rn
     /* 423840 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 423844 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 423849 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 423853 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423855 */     // (AArch64duplane16:{ *:[v8i16] } (ld:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv8h:{ *:[v8i16] } GPR64sp:{ *:[i64] }:$Rn)
     /* 423855 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv8h),
     /* 423858 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 423860 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 423864 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 423869 */     GIR_RootConstrainSelectedInstOperands,
     /* 423870 */     // GIR_Coverage, 6457,
     /* 423870 */     GIR_EraseRootFromParent_Done,
     /* 423871 */   // Label 8279: @423871
     /* 423871 */   GIM_Try, /*On fail goto*//*Label 8280*/ GIMT_Encode4(423909), // Rule ID 1923 //
     /* 423876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 423879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423887 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423891 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423895 */     // MIs[1] Operand 1
     /* 423895 */     // No operand predicates
     /* 423895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423897 */     // (AArch64duplane16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx)  =>  (DUPv8i16lane:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 423897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423904 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 423907 */     GIR_RootConstrainSelectedInstOperands,
     /* 423908 */     // GIR_Coverage, 1923,
     /* 423908 */     GIR_EraseRootFromParent_Done,
     /* 423909 */   // Label 8280: @423909
     /* 423909 */   GIM_Try, /*On fail goto*//*Label 8281*/ GIMT_Encode4(423944), // Rule ID 5656 //
     /* 423914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423918 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 423922 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 423926 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 423930 */     // MIs[1] Operand 1
     /* 423930 */     // No operand predicates
     /* 423930 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 423932 */     // (AArch64duplane16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)  =>  (DUPv8i16lane:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$imm)
     /* 423932 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i16lane),
     /* 423935 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 423937 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 423939 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 423942 */     GIR_RootConstrainSelectedInstOperands,
     /* 423943 */     // GIR_Coverage, 5656,
     /* 423943 */     GIR_EraseRootFromParent_Done,
     /* 423944 */   // Label 8281: @423944
     /* 423944 */   GIM_Reject,
     /* 423945 */ // Label 8278: @423945
     /* 423945 */ GIM_Reject,
     /* 423946 */ // Label 8274: @423946
     /* 423946 */ GIM_Reject,
     /* 423947 */ // Label 126: @423947
     /* 423947 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(9), /*)*//*default:*//*Label 8284*/ GIMT_Encode4(424201),
     /* 423958 */ /*GILLT_v2s32*//*Label 8282*/ GIMT_Encode4(423974), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 423970 */ /*GILLT_v4s32*//*Label 8283*/ GIMT_Encode4(424060),
     /* 423974 */ // Label 8282: @423974
     /* 423974 */ GIM_Try, /*On fail goto*//*Label 8285*/ GIMT_Encode4(424059),
     /* 423979 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 423982 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 423985 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 423989 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 423993 */   GIM_Try, /*On fail goto*//*Label 8286*/ GIMT_Encode4(424027), // Rule ID 1920 //
     /* 423998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424001 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424005 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424009 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424013 */     // MIs[1] Operand 1
     /* 424013 */     // No operand predicates
     /* 424013 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424015 */     // (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv2i32lane:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424015 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 424018 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424020 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424022 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424025 */     GIR_RootConstrainSelectedInstOperands,
     /* 424026 */     // GIR_Coverage, 1920,
     /* 424026 */     GIR_EraseRootFromParent_Done,
     /* 424027 */   // Label 8286: @424027
     /* 424027 */   GIM_Try, /*On fail goto*//*Label 8287*/ GIMT_Encode4(424058), // Rule ID 5657 //
     /* 424032 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424036 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424040 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424044 */     // MIs[1] Operand 1
     /* 424044 */     // No operand predicates
     /* 424044 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424046 */     // (AArch64duplane32:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv2i32lane:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 424046 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i32lane),
     /* 424049 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424051 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424053 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424056 */     GIR_RootConstrainSelectedInstOperands,
     /* 424057 */     // GIR_Coverage, 5657,
     /* 424057 */     GIR_EraseRootFromParent_Done,
     /* 424058 */   // Label 8287: @424058
     /* 424058 */   GIM_Reject,
     /* 424059 */ // Label 8285: @424059
     /* 424059 */ GIM_Reject,
     /* 424060 */ // Label 8283: @424060
     /* 424060 */ GIM_Try, /*On fail goto*//*Label 8288*/ GIMT_Encode4(424200),
     /* 424065 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424068 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424071 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424075 */   GIM_Try, /*On fail goto*//*Label 8289*/ GIMT_Encode4(424126), // Rule ID 6459 //
     /* 424080 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424084 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424088 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424091 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424095 */     // MIs[1] Rn
     /* 424095 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424099 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424104 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424108 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424110 */     // (AArch64duplane32:{ *:[v4i32] } (ld:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv4s:{ *:[v4i32] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424110 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv4s),
     /* 424113 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424115 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424119 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424124 */     GIR_RootConstrainSelectedInstOperands,
     /* 424125 */     // GIR_Coverage, 6459,
     /* 424125 */     GIR_EraseRootFromParent_Done,
     /* 424126 */   // Label 8289: @424126
     /* 424126 */   GIM_Try, /*On fail goto*//*Label 8290*/ GIMT_Encode4(424164), // Rule ID 1921 //
     /* 424131 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424134 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424138 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424142 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424146 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424150 */     // MIs[1] Operand 1
     /* 424150 */     // No operand predicates
     /* 424150 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424152 */     // (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)  =>  (DUPv4i32lane:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424152 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424155 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424157 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424159 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424162 */     GIR_RootConstrainSelectedInstOperands,
     /* 424163 */     // GIR_Coverage, 1921,
     /* 424163 */     GIR_EraseRootFromParent_Done,
     /* 424164 */   // Label 8290: @424164
     /* 424164 */   GIM_Try, /*On fail goto*//*Label 8291*/ GIMT_Encode4(424199), // Rule ID 5658 //
     /* 424169 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424173 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424177 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424181 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 424185 */     // MIs[1] Operand 1
     /* 424185 */     // No operand predicates
     /* 424185 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424187 */     // (AArch64duplane32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)  =>  (DUPv4i32lane:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$imm)
     /* 424187 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv4i32lane),
     /* 424190 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424192 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424197 */     GIR_RootConstrainSelectedInstOperands,
     /* 424198 */     // GIR_Coverage, 5658,
     /* 424198 */     GIR_EraseRootFromParent_Done,
     /* 424199 */   // Label 8291: @424199
     /* 424199 */   GIM_Reject,
     /* 424200 */ // Label 8288: @424200
     /* 424200 */ GIM_Reject,
     /* 424201 */ // Label 8284: @424201
     /* 424201 */ GIM_Reject,
     /* 424202 */ // Label 127: @424202
     /* 424202 */ GIM_Try, /*On fail goto*//*Label 8292*/ GIMT_Encode4(424347),
     /* 424207 */   GIM_RootCheckType, /*Op*/0, /*Type*/GILLT_v2s64,
     /* 424210 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424213 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424216 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424220 */   GIM_Try, /*On fail goto*//*Label 8293*/ GIMT_Encode4(424271), // Rule ID 6460 //
     /* 424225 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424229 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424233 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424236 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424240 */     // MIs[1] Rn
     /* 424240 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424244 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424249 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424253 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424255 */     // (AArch64duplane64:{ *:[v2i64] } (ld:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv2d:{ *:[v2i64] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424255 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv2d),
     /* 424258 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424260 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424264 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424269 */     GIR_RootConstrainSelectedInstOperands,
     /* 424270 */     // GIR_Coverage, 6460,
     /* 424270 */     GIR_EraseRootFromParent_Done,
     /* 424271 */   // Label 8293: @424271
     /* 424271 */   GIM_Try, /*On fail goto*//*Label 8294*/ GIMT_Encode4(424346),
     /* 424276 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424280 */     GIM_Try, /*On fail goto*//*Label 8295*/ GIMT_Encode4(424314), // Rule ID 1919 //
     /* 424285 */       GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424288 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424292 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424296 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 424300 */       // MIs[1] Operand 1
     /* 424300 */       // No operand predicates
     /* 424300 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424302 */       // (AArch64duplane64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$idx)  =>  (DUPv2i64lane:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424302 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 424305 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424307 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424309 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424312 */       GIR_RootConstrainSelectedInstOperands,
     /* 424313 */       // GIR_Coverage, 1919,
     /* 424313 */       GIR_EraseRootFromParent_Done,
     /* 424314 */     // Label 8295: @424314
     /* 424314 */     GIM_Try, /*On fail goto*//*Label 8296*/ GIMT_Encode4(424345), // Rule ID 5659 //
     /* 424319 */       GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424323 */       GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424327 */       GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexD),
     /* 424331 */       // MIs[1] Operand 1
     /* 424331 */       // No operand predicates
     /* 424331 */       GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424333 */       // (AArch64duplane64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)  =>  (DUPv2i64lane:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexD>>:$imm)
     /* 424333 */       GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv2i64lane),
     /* 424336 */       GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424338 */       GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424340 */       GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424343 */       GIR_RootConstrainSelectedInstOperands,
     /* 424344 */       // GIR_Coverage, 5659,
     /* 424344 */       GIR_EraseRootFromParent_Done,
     /* 424345 */     // Label 8296: @424345
     /* 424345 */     GIM_Reject,
     /* 424346 */   // Label 8294: @424346
     /* 424346 */   GIM_Reject,
     /* 424347 */ // Label 8292: @424347
     /* 424347 */ GIM_Reject,
     /* 424348 */ // Label 128: @424348
     /* 424348 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(9), GIMT_Encode2(12), /*)*//*default:*//*Label 8299*/ GIMT_Encode4(424526),
     /* 424359 */ /*GILLT_v8s8*//*Label 8297*/ GIMT_Encode4(424371), GIMT_Encode4(0),
     /* 424367 */ /*GILLT_v16s8*//*Label 8298*/ GIMT_Encode4(424420),
     /* 424371 */ // Label 8297: @424371
     /* 424371 */ GIM_Try, /*On fail goto*//*Label 8300*/ GIMT_Encode4(424419), // Rule ID 1924 //
     /* 424376 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424379 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424382 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424385 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424389 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424393 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424397 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424401 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 424405 */   // MIs[1] Operand 1
     /* 424405 */   // No operand predicates
     /* 424405 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424407 */   // (AArch64duplane8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv8i8lane:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424407 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv8i8lane),
     /* 424410 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424412 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424414 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424417 */   GIR_RootConstrainSelectedInstOperands,
     /* 424418 */   // GIR_Coverage, 1924,
     /* 424418 */   GIR_EraseRootFromParent_Done,
     /* 424419 */ // Label 8300: @424419
     /* 424419 */ GIM_Reject,
     /* 424420 */ // Label 8298: @424420
     /* 424420 */ GIM_Try, /*On fail goto*//*Label 8301*/ GIMT_Encode4(424525),
     /* 424425 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 424428 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424431 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424435 */   GIM_Try, /*On fail goto*//*Label 8302*/ GIMT_Encode4(424486), // Rule ID 6455 //
     /* 424440 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424444 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_LOAD),
     /* 424448 */     GIM_CheckAtomicOrdering, /*MI*/1, /*Order*/(uint8_t)AtomicOrdering::NotAtomic,
     /* 424451 */     GIM_CheckMemorySizeEqualToLLT, /*MI*/1, /*MMO*/0, /*OpIdx*/0,
     /* 424455 */     // MIs[1] Rn
     /* 424455 */     GIM_CheckPointerToAny, /*MI*/1, /*Op*/1, /*SizeInBits*/64,
     /* 424459 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64spRegClassID),
     /* 424464 */     GIM_CheckConstantInt8, /*MI*/0, /*Op*/2, 0,
     /* 424468 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424470 */     // (AArch64duplane8:{ *:[v16i8] } (ld:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[i64] })  =>  (LD1Rv16b:{ *:[v16i8] } GPR64sp:{ *:[i64] }:$Rn)
     /* 424470 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::LD1Rv16b),
     /* 424473 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Vt]
     /* 424475 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424479 */     GIR_MergeMemOperands, /*InsnID*/0, /*NumInsns*/2, /*MergeInsnID's*/0, 1,
     /* 424484 */     GIR_RootConstrainSelectedInstOperands,
     /* 424485 */     // GIR_Coverage, 6455,
     /* 424485 */     GIR_EraseRootFromParent_Done,
     /* 424486 */   // Label 8302: @424486
     /* 424486 */   GIM_Try, /*On fail goto*//*Label 8303*/ GIMT_Encode4(424524), // Rule ID 1925 //
     /* 424491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 424494 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424498 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 424502 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424506 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexB),
     /* 424510 */     // MIs[1] Operand 1
     /* 424510 */     // No operand predicates
     /* 424510 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424512 */     // (AArch64duplane8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] })<<P:Predicate_VectorIndexB>>:$idx)  =>  (DUPv16i8lane:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i64] }):$idx)
     /* 424512 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::DUPv16i8lane),
     /* 424515 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424517 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424519 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // idx
     /* 424522 */     GIR_RootConstrainSelectedInstOperands,
     /* 424523 */     // GIR_Coverage, 1925,
     /* 424523 */     GIR_EraseRootFromParent_Done,
     /* 424524 */   // Label 8303: @424524
     /* 424524 */   GIM_Reject,
     /* 424525 */ // Label 8301: @424525
     /* 424525 */ GIM_Reject,
     /* 424526 */ // Label 8299: @424526
     /* 424526 */ GIM_Reject,
     /* 424527 */ // Label 129: @424527
     /* 424527 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(24), /*)*//*default:*//*Label 8313*/ GIMT_Encode4(426176),
     /* 424538 */ /*GILLT_s64*//*Label 8304*/ GIMT_Encode4(424622), GIMT_Encode4(0),
     /* 424546 */ /*GILLT_v2s32*//*Label 8305*/ GIMT_Encode4(424943),
     /* 424550 */ /*GILLT_v2s64*//*Label 8306*/ GIMT_Encode4(425264),
     /* 424554 */ /*GILLT_v4s16*//*Label 8307*/ GIMT_Encode4(425347),
     /* 424558 */ /*GILLT_v4s32*//*Label 8308*/ GIMT_Encode4(425668),
     /* 424562 */ /*GILLT_v8s8*//*Label 8309*/ GIMT_Encode4(425751),
     /* 424566 */ /*GILLT_v8s16*//*Label 8310*/ GIMT_Encode4(425960),
     /* 424570 */ /*GILLT_v16s8*//*Label 8311*/ GIMT_Encode4(426043), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 424618 */ /*GILLT_nxv16s8*//*Label 8312*/ GIMT_Encode4(426129),
     /* 424622 */ // Label 8304: @424622
     /* 424622 */ GIM_Try, /*On fail goto*//*Label 8314*/ GIMT_Encode4(424942),
     /* 424627 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 424630 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 424633 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424637 */   GIM_Try, /*On fail goto*//*Label 8315*/ GIMT_Encode4(424752), // Rule ID 5474 //
     /* 424642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424650 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424654 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424659 */     // MIs[1] Operand 2
     /* 424659 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424670 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424674 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424678 */     // MIs[2] Rn
     /* 424678 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424683 */     // MIs[2] Operand 2
     /* 424683 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 424694 */     // MIs[0] imm
     /* 424694 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424698 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424702 */     // MIs[3] Operand 1
     /* 424702 */     // No operand predicates
     /* 424702 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424704 */     // (AArch64ext:{ *:[v1i64] } (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1i64] } V128:{ *:[v2i64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1i64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424704 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424707 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424711 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424716 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424720 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424724 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424727 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424729 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424732 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424734 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424741 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424746 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424751 */     // GIR_Coverage, 5474,
     /* 424751 */     GIR_EraseRootFromParent_Done,
     /* 424752 */   // Label 8315: @424752
     /* 424752 */   GIM_Try, /*On fail goto*//*Label 8316*/ GIMT_Encode4(424867), // Rule ID 5479 //
     /* 424757 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424761 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424765 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 424769 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424774 */     // MIs[1] Operand 2
     /* 424774 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424785 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424789 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424793 */     // MIs[2] Rn
     /* 424793 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 424798 */     // MIs[2] Operand 2
     /* 424798 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(1),
     /* 424809 */     // MIs[0] imm
     /* 424809 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 424813 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424817 */     // MIs[3] Operand 1
     /* 424817 */     // No operand predicates
     /* 424817 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 424819 */     // (AArch64ext:{ *:[v1f64] } (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v1f64] } V128:{ *:[v2f64] }:$Rn, 1:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v1f64] } (EXTv16i8:{ *:[f128] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 424819 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 424822 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 424826 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 424831 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424835 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 424839 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 424842 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 424844 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 424847 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 424849 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 424856 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424861 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424866 */     // GIR_Coverage, 5479,
     /* 424866 */     GIR_EraseRootFromParent_Done,
     /* 424867 */   // Label 8316: @424867
     /* 424867 */   GIM_Try, /*On fail goto*//*Label 8317*/ GIMT_Encode4(424904), // Rule ID 5471 //
     /* 424872 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424876 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424880 */     // MIs[0] imm
     /* 424880 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424884 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424888 */     // MIs[1] Operand 1
     /* 424888 */     // No operand predicates
     /* 424888 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424890 */     // (AArch64ext:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, V64:{ *:[v1i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424890 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424893 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424895 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424897 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424899 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424902 */     GIR_RootConstrainSelectedInstOperands,
     /* 424903 */     // GIR_Coverage, 5471,
     /* 424903 */     GIR_EraseRootFromParent_Done,
     /* 424904 */   // Label 8317: @424904
     /* 424904 */   GIM_Try, /*On fail goto*//*Label 8318*/ GIMT_Encode4(424941), // Rule ID 5476 //
     /* 424909 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424913 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424917 */     // MIs[0] imm
     /* 424917 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 424921 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 424925 */     // MIs[1] Operand 1
     /* 424925 */     // No operand predicates
     /* 424925 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 424927 */     // (AArch64ext:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v1f64] } V64:{ *:[v1f64] }:$Rn, V64:{ *:[v1f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 424927 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 424930 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 424932 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 424934 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 424936 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 424939 */     GIR_RootConstrainSelectedInstOperands,
     /* 424940 */     // GIR_Coverage, 5476,
     /* 424940 */     GIR_EraseRootFromParent_Done,
     /* 424941 */   // Label 8318: @424941
     /* 424941 */   GIM_Reject,
     /* 424942 */ // Label 8314: @424942
     /* 424942 */ GIM_Reject,
     /* 424943 */ // Label 8305: @424943
     /* 424943 */ GIM_Try, /*On fail goto*//*Label 8319*/ GIMT_Encode4(425263),
     /* 424948 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 424951 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 424954 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 424958 */   GIM_Try, /*On fail goto*//*Label 8320*/ GIMT_Encode4(425073), // Rule ID 5464 //
     /* 424963 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 424967 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424971 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 424975 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 424980 */     // MIs[1] Operand 2
     /* 424980 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 424991 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 424995 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 424999 */     // MIs[2] Rn
     /* 424999 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425004 */     // MIs[2] Operand 2
     /* 425004 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 425015 */     // MIs[0] imm
     /* 425015 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425019 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425023 */     // MIs[3] Operand 1
     /* 425023 */     // No operand predicates
     /* 425023 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425025 */     // (AArch64ext:{ *:[v2i32] } (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2i32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425025 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425028 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425032 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425037 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425041 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425045 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425048 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425050 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425053 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425055 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425062 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425067 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425072 */     // GIR_Coverage, 5464,
     /* 425072 */     GIR_EraseRootFromParent_Done,
     /* 425073 */   // Label 8320: @425073
     /* 425073 */   GIM_Try, /*On fail goto*//*Label 8321*/ GIMT_Encode4(425188), // Rule ID 5469 //
     /* 425078 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425082 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425086 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425090 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425095 */     // MIs[1] Operand 2
     /* 425095 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425106 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425110 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425114 */     // MIs[2] Rn
     /* 425114 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425119 */     // MIs[2] Operand 2
     /* 425119 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(2),
     /* 425130 */     // MIs[0] imm
     /* 425130 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425134 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425138 */     // MIs[3] Operand 1
     /* 425138 */     // No operand predicates
     /* 425138 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425140 */     // (AArch64ext:{ *:[v2f32] } (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v2f32] } V128:{ *:[v4f32] }:$Rn, 2:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v2f32] } (EXTv16i8:{ *:[f128] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425140 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425143 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425147 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425152 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425156 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425160 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425163 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425165 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425168 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425170 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425177 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425182 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425187 */     // GIR_Coverage, 5469,
     /* 425187 */     GIR_EraseRootFromParent_Done,
     /* 425188 */   // Label 8321: @425188
     /* 425188 */   GIM_Try, /*On fail goto*//*Label 8322*/ GIMT_Encode4(425225), // Rule ID 5461 //
     /* 425193 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425197 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425201 */     // MIs[0] imm
     /* 425201 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425205 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425209 */     // MIs[1] Operand 1
     /* 425209 */     // No operand predicates
     /* 425209 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425211 */     // (AArch64ext:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425211 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425214 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425216 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425218 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425220 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425223 */     GIR_RootConstrainSelectedInstOperands,
     /* 425224 */     // GIR_Coverage, 5461,
     /* 425224 */     GIR_EraseRootFromParent_Done,
     /* 425225 */   // Label 8322: @425225
     /* 425225 */   GIM_Try, /*On fail goto*//*Label 8323*/ GIMT_Encode4(425262), // Rule ID 5466 //
     /* 425230 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425234 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425238 */     // MIs[0] imm
     /* 425238 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425242 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425246 */     // MIs[1] Operand 1
     /* 425246 */     // No operand predicates
     /* 425246 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425248 */     // (AArch64ext:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425248 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425251 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425253 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425255 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425257 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425260 */     GIR_RootConstrainSelectedInstOperands,
     /* 425261 */     // GIR_Coverage, 5466,
     /* 425261 */     GIR_EraseRootFromParent_Done,
     /* 425262 */   // Label 8323: @425262
     /* 425262 */   GIM_Reject,
     /* 425263 */ // Label 8319: @425263
     /* 425263 */ GIM_Reject,
     /* 425264 */ // Label 8306: @425264
     /* 425264 */ GIM_Try, /*On fail goto*//*Label 8324*/ GIMT_Encode4(425346),
     /* 425269 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 425272 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 425275 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425279 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425283 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425287 */   GIM_Try, /*On fail goto*//*Label 8325*/ GIMT_Encode4(425316), // Rule ID 5472 //
     /* 425292 */     // MIs[0] imm
     /* 425292 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425296 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425300 */     // MIs[1] Operand 1
     /* 425300 */     // No operand predicates
     /* 425300 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425302 */     // (AArch64ext:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425302 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425305 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425307 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425309 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425311 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425314 */     GIR_RootConstrainSelectedInstOperands,
     /* 425315 */     // GIR_Coverage, 5472,
     /* 425315 */     GIR_EraseRootFromParent_Done,
     /* 425316 */   // Label 8325: @425316
     /* 425316 */   GIM_Try, /*On fail goto*//*Label 8326*/ GIMT_Encode4(425345), // Rule ID 5477 //
     /* 425321 */     // MIs[0] imm
     /* 425321 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425325 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425329 */     // MIs[1] Operand 1
     /* 425329 */     // No operand predicates
     /* 425329 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425331 */     // (AArch64ext:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425331 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425334 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425336 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425338 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425340 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425343 */     GIR_RootConstrainSelectedInstOperands,
     /* 425344 */     // GIR_Coverage, 5477,
     /* 425344 */     GIR_EraseRootFromParent_Done,
     /* 425345 */   // Label 8326: @425345
     /* 425345 */   GIM_Reject,
     /* 425346 */ // Label 8324: @425346
     /* 425346 */ GIM_Reject,
     /* 425347 */ // Label 8307: @425347
     /* 425347 */ GIM_Try, /*On fail goto*//*Label 8327*/ GIMT_Encode4(425667),
     /* 425352 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 425355 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 425358 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425362 */   GIM_Try, /*On fail goto*//*Label 8328*/ GIMT_Encode4(425477), // Rule ID 5454 //
     /* 425367 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425371 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425375 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425379 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425384 */     // MIs[1] Operand 2
     /* 425384 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425395 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425399 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425403 */     // MIs[2] Rn
     /* 425403 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425408 */     // MIs[2] Operand 2
     /* 425408 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 425419 */     // MIs[0] imm
     /* 425419 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425423 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425427 */     // MIs[3] Operand 1
     /* 425427 */     // No operand predicates
     /* 425427 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425429 */     // (AArch64ext:{ *:[v4i16] } (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4i16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425429 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425432 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425436 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425441 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425445 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425449 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425452 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425454 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425457 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425459 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425466 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425471 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425476 */     // GIR_Coverage, 5454,
     /* 425476 */     GIR_EraseRootFromParent_Done,
     /* 425477 */   // Label 8328: @425477
     /* 425477 */   GIM_Try, /*On fail goto*//*Label 8329*/ GIMT_Encode4(425592), // Rule ID 5459 //
     /* 425482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425486 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425490 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425494 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425499 */     // MIs[1] Operand 2
     /* 425499 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425510 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425514 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425518 */     // MIs[2] Rn
     /* 425518 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425523 */     // MIs[2] Operand 2
     /* 425523 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(4),
     /* 425534 */     // MIs[0] imm
     /* 425534 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425538 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425542 */     // MIs[3] Operand 1
     /* 425542 */     // No operand predicates
     /* 425542 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425544 */     // (AArch64ext:{ *:[v4f16] } (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v4f16] } V128:{ *:[v8f16] }:$Rn, 4:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v4f16] } (EXTv16i8:{ *:[f128] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425544 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425547 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425551 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425556 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425560 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425564 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425567 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425569 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425572 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425574 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425581 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425586 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425591 */     // GIR_Coverage, 5459,
     /* 425591 */     GIR_EraseRootFromParent_Done,
     /* 425592 */   // Label 8329: @425592
     /* 425592 */   GIM_Try, /*On fail goto*//*Label 8330*/ GIMT_Encode4(425629), // Rule ID 5451 //
     /* 425597 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425601 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425605 */     // MIs[0] imm
     /* 425605 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425609 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425613 */     // MIs[1] Operand 1
     /* 425613 */     // No operand predicates
     /* 425613 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425615 */     // (AArch64ext:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425615 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425618 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425620 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425622 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425624 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425627 */     GIR_RootConstrainSelectedInstOperands,
     /* 425628 */     // GIR_Coverage, 5451,
     /* 425628 */     GIR_EraseRootFromParent_Done,
     /* 425629 */   // Label 8330: @425629
     /* 425629 */   GIM_Try, /*On fail goto*//*Label 8331*/ GIMT_Encode4(425666), // Rule ID 5456 //
     /* 425634 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425638 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425642 */     // MIs[0] imm
     /* 425642 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425646 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425650 */     // MIs[1] Operand 1
     /* 425650 */     // No operand predicates
     /* 425650 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425652 */     // (AArch64ext:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425652 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425655 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425657 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425659 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425661 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425664 */     GIR_RootConstrainSelectedInstOperands,
     /* 425665 */     // GIR_Coverage, 5456,
     /* 425665 */     GIR_EraseRootFromParent_Done,
     /* 425666 */   // Label 8331: @425666
     /* 425666 */   GIM_Reject,
     /* 425667 */ // Label 8327: @425667
     /* 425667 */ GIM_Reject,
     /* 425668 */ // Label 8308: @425668
     /* 425668 */ GIM_Try, /*On fail goto*//*Label 8332*/ GIMT_Encode4(425750),
     /* 425673 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 425676 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 425679 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425683 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425687 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425691 */   GIM_Try, /*On fail goto*//*Label 8333*/ GIMT_Encode4(425720), // Rule ID 5462 //
     /* 425696 */     // MIs[0] imm
     /* 425696 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425700 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425704 */     // MIs[1] Operand 1
     /* 425704 */     // No operand predicates
     /* 425704 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425706 */     // (AArch64ext:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425706 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425709 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425711 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425713 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425715 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425718 */     GIR_RootConstrainSelectedInstOperands,
     /* 425719 */     // GIR_Coverage, 5462,
     /* 425719 */     GIR_EraseRootFromParent_Done,
     /* 425720 */   // Label 8333: @425720
     /* 425720 */   GIM_Try, /*On fail goto*//*Label 8334*/ GIMT_Encode4(425749), // Rule ID 5467 //
     /* 425725 */     // MIs[0] imm
     /* 425725 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425729 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425733 */     // MIs[1] Operand 1
     /* 425733 */     // No operand predicates
     /* 425733 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425735 */     // (AArch64ext:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425740 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425742 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425744 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425747 */     GIR_RootConstrainSelectedInstOperands,
     /* 425748 */     // GIR_Coverage, 5467,
     /* 425748 */     GIR_EraseRootFromParent_Done,
     /* 425749 */   // Label 8334: @425749
     /* 425749 */   GIM_Reject,
     /* 425750 */ // Label 8332: @425750
     /* 425750 */ GIM_Reject,
     /* 425751 */ // Label 8309: @425751
     /* 425751 */ GIM_Try, /*On fail goto*//*Label 8335*/ GIMT_Encode4(425959),
     /* 425756 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 425759 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 425762 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425766 */   GIM_Try, /*On fail goto*//*Label 8336*/ GIMT_Encode4(425881), // Rule ID 5449 //
     /* 425771 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 425775 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425779 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 425783 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425788 */     // MIs[1] Operand 2
     /* 425788 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 425799 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 425803 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 425807 */     // MIs[2] Rn
     /* 425807 */     GIM_CheckIsSameOperand, /*MI*/2, /*OpIdx*/1, /*OtherMI*/1, /*OtherOpIdx*/1,
     /* 425812 */     // MIs[2] Operand 2
     /* 425812 */     GIM_CheckLiteralInt, /*MI*/2, /*Op*/2, GIMT_Encode8(8),
     /* 425823 */     // MIs[0] imm
     /* 425823 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/0, /*OpIdx*/3, // MIs[3]
     /* 425827 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425831 */     // MIs[3] Operand 1
     /* 425831 */     // No operand predicates
     /* 425831 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 425833 */     // (AArch64ext:{ *:[v8i8] } (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 0:{ *:[i64] }), (extract_subvector:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn, 8:{ *:[i64] }), (imm:{ *:[i32] }):$imm)  =>  (EXTRACT_SUBREG:{ *:[v8i8] } (EXTv16i8:{ *:[f128] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm), dsub:{ *:[i32] })
     /* 425833 */     GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s128,
     /* 425836 */     GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 425840 */     GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 425845 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425849 */     GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 425853 */     GIR_CopyConstantAsSImm, /*NewInsnID*/1, /*OldInsnID*/3, // imm
     /* 425856 */     GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 425858 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::COPY),
     /* 425861 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 425863 */     GIR_AddTempSubRegister, /*InsnID*/0, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(0), GIMT_Encode2(AArch64::dsub),
     /* 425870 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425875 */     GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425880 */     // GIR_Coverage, 5449,
     /* 425880 */     GIR_EraseRootFromParent_Done,
     /* 425881 */   // Label 8336: @425881
     /* 425881 */   GIM_Try, /*On fail goto*//*Label 8337*/ GIMT_Encode4(425921), // Rule ID 1868 //
     /* 425886 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 425889 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425893 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425897 */     // MIs[0] imm
     /* 425897 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425901 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425905 */     // MIs[1] Operand 1
     /* 425905 */     // No operand predicates
     /* 425905 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425907 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425907 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425910 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425912 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425914 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425916 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425919 */     GIR_RootConstrainSelectedInstOperands,
     /* 425920 */     // GIR_Coverage, 1868,
     /* 425920 */     GIR_EraseRootFromParent_Done,
     /* 425921 */   // Label 8337: @425921
     /* 425921 */   GIM_Try, /*On fail goto*//*Label 8338*/ GIMT_Encode4(425958), // Rule ID 5446 //
     /* 425926 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425930 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 425934 */     // MIs[0] imm
     /* 425934 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425938 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425942 */     // MIs[1] Operand 1
     /* 425942 */     // No operand predicates
     /* 425942 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425944 */     // (AArch64ext:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425944 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv8i8),
     /* 425947 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 425949 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 425951 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 425953 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 425956 */     GIR_RootConstrainSelectedInstOperands,
     /* 425957 */     // GIR_Coverage, 5446,
     /* 425957 */     GIR_EraseRootFromParent_Done,
     /* 425958 */   // Label 8338: @425958
     /* 425958 */   GIM_Reject,
     /* 425959 */ // Label 8335: @425959
     /* 425959 */ GIM_Reject,
     /* 425960 */ // Label 8310: @425960
     /* 425960 */ GIM_Try, /*On fail goto*//*Label 8339*/ GIMT_Encode4(426042),
     /* 425965 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 425968 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 425971 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425975 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425979 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 425983 */   GIM_Try, /*On fail goto*//*Label 8340*/ GIMT_Encode4(426012), // Rule ID 5452 //
     /* 425988 */     // MIs[0] imm
     /* 425988 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 425992 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 425996 */     // MIs[1] Operand 1
     /* 425996 */     // No operand predicates
     /* 425996 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 425998 */     // (AArch64ext:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 425998 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426001 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426003 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426005 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426007 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426010 */     GIR_RootConstrainSelectedInstOperands,
     /* 426011 */     // GIR_Coverage, 5452,
     /* 426011 */     GIR_EraseRootFromParent_Done,
     /* 426012 */   // Label 8340: @426012
     /* 426012 */   GIM_Try, /*On fail goto*//*Label 8341*/ GIMT_Encode4(426041), // Rule ID 5457 //
     /* 426017 */     // MIs[0] imm
     /* 426017 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426021 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426025 */     // MIs[1] Operand 1
     /* 426025 */     // No operand predicates
     /* 426025 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426027 */     // (AArch64ext:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426027 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426030 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426032 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426034 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426036 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426039 */     GIR_RootConstrainSelectedInstOperands,
     /* 426040 */     // GIR_Coverage, 5457,
     /* 426040 */     GIR_EraseRootFromParent_Done,
     /* 426041 */   // Label 8341: @426041
     /* 426041 */   GIM_Reject,
     /* 426042 */ // Label 8339: @426042
     /* 426042 */ GIM_Reject,
     /* 426043 */ // Label 8311: @426043
     /* 426043 */ GIM_Try, /*On fail goto*//*Label 8342*/ GIMT_Encode4(426128),
     /* 426048 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 426051 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 426054 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426058 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426062 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426066 */   GIM_Try, /*On fail goto*//*Label 8343*/ GIMT_Encode4(426098), // Rule ID 1869 //
     /* 426071 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426074 */     // MIs[0] imm
     /* 426074 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426078 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426082 */     // MIs[1] Operand 1
     /* 426082 */     // No operand predicates
     /* 426082 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426084 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426084 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426087 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426089 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426091 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426093 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426096 */     GIR_RootConstrainSelectedInstOperands,
     /* 426097 */     // GIR_Coverage, 1869,
     /* 426097 */     GIR_EraseRootFromParent_Done,
     /* 426098 */   // Label 8343: @426098
     /* 426098 */   GIM_Try, /*On fail goto*//*Label 8344*/ GIMT_Encode4(426127), // Rule ID 5447 //
     /* 426103 */     // MIs[0] imm
     /* 426103 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426107 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426111 */     // MIs[1] Operand 1
     /* 426111 */     // No operand predicates
     /* 426111 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426113 */     // (AArch64ext:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)  =>  (EXTv16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm, (imm:{ *:[i32] }):$imm)
     /* 426113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXTv16i8),
     /* 426116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426118 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426120 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rm
     /* 426122 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 426125 */     GIR_RootConstrainSelectedInstOperands,
     /* 426126 */     // GIR_Coverage, 5447,
     /* 426126 */     GIR_EraseRootFromParent_Done,
     /* 426127 */   // Label 8344: @426127
     /* 426127 */   GIM_Reject,
     /* 426128 */ // Label 8342: @426128
     /* 426128 */ GIM_Reject,
     /* 426129 */ // Label 8312: @426129
     /* 426129 */ GIM_Try, /*On fail goto*//*Label 8345*/ GIMT_Encode4(426175), // Rule ID 2729 //
     /* 426134 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 426137 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 426140 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 426143 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 426147 */   // MIs[0] Op3
     /* 426147 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 426151 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 426155 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_imm0_255),
     /* 426159 */   // MIs[1] Operand 1
     /* 426159 */   // No operand predicates
     /* 426159 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426161 */   // (AArch64ext:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)  =>  (EXT_ZZI:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, (imm:{ *:[i32] })<<P:Predicate_imm0_255>>:$Op3)
     /* 426161 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::EXT_ZZI),
     /* 426164 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Zdn]
     /* 426166 */   GIR_RootToRootCopy, /*OpIdx*/1, // Op1
     /* 426168 */   GIR_RootToRootCopy, /*OpIdx*/2, // Op2
     /* 426170 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // Op3
     /* 426173 */   GIR_RootConstrainSelectedInstOperands,
     /* 426174 */   // GIR_Coverage, 2729,
     /* 426174 */   GIR_EraseRootFromParent_Done,
     /* 426175 */ // Label 8345: @426175
     /* 426175 */ GIM_Reject,
     /* 426176 */ // Label 8313: @426176
     /* 426176 */ GIM_Reject,
     /* 426177 */ // Label 130: @426177
     /* 426177 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8353*/ GIMT_Encode4(426735),
     /* 426188 */ /*GILLT_s32*//*Label 8346*/ GIMT_Encode4(426224),
     /* 426192 */ /*GILLT_s64*//*Label 8347*/ GIMT_Encode4(426262), GIMT_Encode4(0),
     /* 426200 */ /*GILLT_v2s32*//*Label 8348*/ GIMT_Encode4(426360),
     /* 426204 */ /*GILLT_v2s64*//*Label 8349*/ GIMT_Encode4(426435),
     /* 426208 */ /*GILLT_v4s16*//*Label 8350*/ GIMT_Encode4(426510),
     /* 426212 */ /*GILLT_v4s32*//*Label 8351*/ GIMT_Encode4(426585), GIMT_Encode4(0),
     /* 426220 */ /*GILLT_v8s16*//*Label 8352*/ GIMT_Encode4(426660),
     /* 426224 */ // Label 8346: @426224
     /* 426224 */ GIM_Try, /*On fail goto*//*Label 8354*/ GIMT_Encode4(426261), // Rule ID 1622 //
     /* 426229 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426242 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426246 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426250 */   // (AArch64fcmeq:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMEQ32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426250 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ32),
     /* 426255 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426259 */   GIR_RootConstrainSelectedInstOperands,
     /* 426260 */   // GIR_Coverage, 1622,
     /* 426260 */   GIR_Done,
     /* 426261 */ // Label 8354: @426261
     /* 426261 */ GIM_Reject,
     /* 426262 */ // Label 8347: @426262
     /* 426262 */ GIM_Try, /*On fail goto*//*Label 8355*/ GIMT_Encode4(426359),
     /* 426267 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426270 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426273 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426277 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426281 */   GIM_Try, /*On fail goto*//*Label 8356*/ GIMT_Encode4(426312), // Rule ID 2509 //
     /* 426286 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426289 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426293 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426299 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426301 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426303 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMEQv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426303 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv1i64rz),
     /* 426306 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426308 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426310 */     GIR_RootConstrainSelectedInstOperands,
     /* 426311 */     // GIR_Coverage, 2509,
     /* 426311 */     GIR_EraseRootFromParent_Done,
     /* 426312 */   // Label 8356: @426312
     /* 426312 */   GIM_Try, /*On fail goto*//*Label 8357*/ GIMT_Encode4(426335), // Rule ID 1621 //
     /* 426317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426320 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426324 */     // (AArch64fcmeq:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMEQ64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426324 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 426329 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426333 */     GIR_RootConstrainSelectedInstOperands,
     /* 426334 */     // GIR_Coverage, 1621,
     /* 426334 */     GIR_Done,
     /* 426335 */   // Label 8357: @426335
     /* 426335 */   GIM_Try, /*On fail goto*//*Label 8358*/ GIMT_Encode4(426358), // Rule ID 5226 //
     /* 426340 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426343 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426347 */     // (AArch64fcmeq:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMEQ64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQ64),
     /* 426352 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426356 */     GIR_RootConstrainSelectedInstOperands,
     /* 426357 */     // GIR_Coverage, 5226,
     /* 426357 */     GIR_Done,
     /* 426358 */   // Label 8358: @426358
     /* 426358 */   GIM_Reject,
     /* 426359 */ // Label 8355: @426359
     /* 426359 */ GIM_Reject,
     /* 426360 */ // Label 8348: @426360
     /* 426360 */ GIM_Try, /*On fail goto*//*Label 8359*/ GIMT_Encode4(426434),
     /* 426365 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426368 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426371 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426375 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426379 */   GIM_Try, /*On fail goto*//*Label 8360*/ GIMT_Encode4(426410), // Rule ID 773 //
     /* 426384 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426387 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426391 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426397 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426399 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426401 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMEQv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 426401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i32rz),
     /* 426404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426408 */     GIR_RootConstrainSelectedInstOperands,
     /* 426409 */     // GIR_Coverage, 773,
     /* 426409 */     GIR_EraseRootFromParent_Done,
     /* 426410 */   // Label 8360: @426410
     /* 426410 */   GIM_Try, /*On fail goto*//*Label 8361*/ GIMT_Encode4(426433), // Rule ID 1210 //
     /* 426415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426418 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426422 */     // (AArch64fcmeq:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMEQv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 426422 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f32),
     /* 426427 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426431 */     GIR_RootConstrainSelectedInstOperands,
     /* 426432 */     // GIR_Coverage, 1210,
     /* 426432 */     GIR_Done,
     /* 426433 */   // Label 8361: @426433
     /* 426433 */   GIM_Reject,
     /* 426434 */ // Label 8359: @426434
     /* 426434 */ GIM_Reject,
     /* 426435 */ // Label 8349: @426435
     /* 426435 */ GIM_Try, /*On fail goto*//*Label 8362*/ GIMT_Encode4(426509),
     /* 426440 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 426443 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 426446 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426450 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426454 */   GIM_Try, /*On fail goto*//*Label 8363*/ GIMT_Encode4(426485), // Rule ID 775 //
     /* 426459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426462 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426466 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426472 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426474 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426476 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMEQv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 426476 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2i64rz),
     /* 426479 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426481 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426483 */     GIR_RootConstrainSelectedInstOperands,
     /* 426484 */     // GIR_Coverage, 775,
     /* 426484 */     GIR_EraseRootFromParent_Done,
     /* 426485 */   // Label 8363: @426485
     /* 426485 */   GIM_Try, /*On fail goto*//*Label 8364*/ GIMT_Encode4(426508), // Rule ID 1212 //
     /* 426490 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426493 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426497 */     // (AArch64fcmeq:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMEQv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 426497 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv2f64),
     /* 426502 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426506 */     GIR_RootConstrainSelectedInstOperands,
     /* 426507 */     // GIR_Coverage, 1212,
     /* 426507 */     GIR_Done,
     /* 426508 */   // Label 8364: @426508
     /* 426508 */   GIM_Reject,
     /* 426509 */ // Label 8362: @426509
     /* 426509 */ GIM_Reject,
     /* 426510 */ // Label 8350: @426510
     /* 426510 */ GIM_Try, /*On fail goto*//*Label 8365*/ GIMT_Encode4(426584),
     /* 426515 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 426518 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 426521 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426525 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426529 */   GIM_Try, /*On fail goto*//*Label 8366*/ GIMT_Encode4(426560), // Rule ID 771 //
     /* 426534 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426537 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426541 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426547 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426549 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426551 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMEQv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 426551 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i16rz),
     /* 426554 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426556 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426558 */     GIR_RootConstrainSelectedInstOperands,
     /* 426559 */     // GIR_Coverage, 771,
     /* 426559 */     GIR_EraseRootFromParent_Done,
     /* 426560 */   // Label 8366: @426560
     /* 426560 */   GIM_Try, /*On fail goto*//*Label 8367*/ GIMT_Encode4(426583), // Rule ID 1208 //
     /* 426565 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426568 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426572 */     // (AArch64fcmeq:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMEQv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 426572 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f16),
     /* 426577 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426581 */     GIR_RootConstrainSelectedInstOperands,
     /* 426582 */     // GIR_Coverage, 1208,
     /* 426582 */     GIR_Done,
     /* 426583 */   // Label 8367: @426583
     /* 426583 */   GIM_Reject,
     /* 426584 */ // Label 8365: @426584
     /* 426584 */ GIM_Reject,
     /* 426585 */ // Label 8351: @426585
     /* 426585 */ GIM_Try, /*On fail goto*//*Label 8368*/ GIMT_Encode4(426659),
     /* 426590 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 426593 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 426596 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426600 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426604 */   GIM_Try, /*On fail goto*//*Label 8369*/ GIMT_Encode4(426635), // Rule ID 774 //
     /* 426609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426612 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426616 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426622 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426624 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426626 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMEQv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 426626 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4i32rz),
     /* 426629 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426631 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426633 */     GIR_RootConstrainSelectedInstOperands,
     /* 426634 */     // GIR_Coverage, 774,
     /* 426634 */     GIR_EraseRootFromParent_Done,
     /* 426635 */   // Label 8369: @426635
     /* 426635 */   GIM_Try, /*On fail goto*//*Label 8370*/ GIMT_Encode4(426658), // Rule ID 1211 //
     /* 426640 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426643 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426647 */     // (AArch64fcmeq:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMEQv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 426647 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv4f32),
     /* 426652 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426656 */     GIR_RootConstrainSelectedInstOperands,
     /* 426657 */     // GIR_Coverage, 1211,
     /* 426657 */     GIR_Done,
     /* 426658 */   // Label 8370: @426658
     /* 426658 */   GIM_Reject,
     /* 426659 */ // Label 8368: @426659
     /* 426659 */ GIM_Reject,
     /* 426660 */ // Label 8352: @426660
     /* 426660 */ GIM_Try, /*On fail goto*//*Label 8371*/ GIMT_Encode4(426734),
     /* 426665 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 426668 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 426671 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426675 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426679 */   GIM_Try, /*On fail goto*//*Label 8372*/ GIMT_Encode4(426710), // Rule ID 772 //
     /* 426684 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426687 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426691 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426697 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426699 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426701 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMEQv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 426701 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8i16rz),
     /* 426704 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426706 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426708 */     GIR_RootConstrainSelectedInstOperands,
     /* 426709 */     // GIR_Coverage, 772,
     /* 426709 */     GIR_EraseRootFromParent_Done,
     /* 426710 */   // Label 8372: @426710
     /* 426710 */   GIM_Try, /*On fail goto*//*Label 8373*/ GIMT_Encode4(426733), // Rule ID 1209 //
     /* 426715 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 426718 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 426722 */     // (AArch64fcmeq:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMEQv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 426722 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMEQv8f16),
     /* 426727 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426731 */     GIR_RootConstrainSelectedInstOperands,
     /* 426732 */     // GIR_Coverage, 1209,
     /* 426732 */     GIR_Done,
     /* 426733 */   // Label 8373: @426733
     /* 426733 */   GIM_Reject,
     /* 426734 */ // Label 8371: @426734
     /* 426734 */ GIM_Reject,
     /* 426735 */ // Label 8353: @426735
     /* 426735 */ GIM_Reject,
     /* 426736 */ // Label 131: @426736
     /* 426736 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8381*/ GIMT_Encode4(427827),
     /* 426747 */ /*GILLT_s32*//*Label 8374*/ GIMT_Encode4(426783),
     /* 426751 */ /*GILLT_s64*//*Label 8375*/ GIMT_Encode4(426821), GIMT_Encode4(0),
     /* 426759 */ /*GILLT_v2s32*//*Label 8376*/ GIMT_Encode4(426962),
     /* 426763 */ /*GILLT_v2s64*//*Label 8377*/ GIMT_Encode4(427135),
     /* 426767 */ /*GILLT_v4s16*//*Label 8378*/ GIMT_Encode4(427308),
     /* 426771 */ /*GILLT_v4s32*//*Label 8379*/ GIMT_Encode4(427481), GIMT_Encode4(0),
     /* 426779 */ /*GILLT_v8s16*//*Label 8380*/ GIMT_Encode4(427654),
     /* 426783 */ // Label 8374: @426783
     /* 426783 */ GIM_Try, /*On fail goto*//*Label 8382*/ GIMT_Encode4(426820), // Rule ID 1624 //
     /* 426788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 426794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 426797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426801 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426805 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 426809 */   // (AArch64fcmge:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGE32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 426809 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE32),
     /* 426814 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426818 */   GIR_RootConstrainSelectedInstOperands,
     /* 426819 */   // GIR_Coverage, 1624,
     /* 426819 */   GIR_Done,
     /* 426820 */ // Label 8382: @426820
     /* 426820 */ GIM_Reject,
     /* 426821 */ // Label 8375: @426821
     /* 426821 */ GIM_Try, /*On fail goto*//*Label 8383*/ GIMT_Encode4(426961),
     /* 426826 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 426829 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 426832 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426836 */   GIM_Try, /*On fail goto*//*Label 8384*/ GIMT_Encode4(426871), // Rule ID 5260 //
     /* 426841 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426844 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426848 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426854 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426856 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426860 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426862 */     // (AArch64fcmge:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426862 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv1i64rz),
     /* 426865 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426867 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 426869 */     GIR_RootConstrainSelectedInstOperands,
     /* 426870 */     // GIR_Coverage, 5260,
     /* 426870 */     GIR_EraseRootFromParent_Done,
     /* 426871 */   // Label 8384: @426871
     /* 426871 */   GIM_Try, /*On fail goto*//*Label 8385*/ GIMT_Encode4(426906), // Rule ID 5258 //
     /* 426876 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426879 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426883 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 426887 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 426893 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 426895 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 426897 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGEv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 426897 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv1i64rz),
     /* 426900 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 426902 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 426904 */     GIR_RootConstrainSelectedInstOperands,
     /* 426905 */     // GIR_Coverage, 5258,
     /* 426905 */     GIR_EraseRootFromParent_Done,
     /* 426906 */   // Label 8385: @426906
     /* 426906 */   GIM_Try, /*On fail goto*//*Label 8386*/ GIMT_Encode4(426933), // Rule ID 1623 //
     /* 426911 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426914 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426918 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426922 */     // (AArch64fcmge:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGE64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 426922 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 426927 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426931 */     GIR_RootConstrainSelectedInstOperands,
     /* 426932 */     // GIR_Coverage, 1623,
     /* 426932 */     GIR_Done,
     /* 426933 */   // Label 8386: @426933
     /* 426933 */   GIM_Try, /*On fail goto*//*Label 8387*/ GIMT_Encode4(426960), // Rule ID 5227 //
     /* 426938 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426941 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426945 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426949 */     // (AArch64fcmge:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGE64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 426949 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGE64),
     /* 426954 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 426958 */     GIR_RootConstrainSelectedInstOperands,
     /* 426959 */     // GIR_Coverage, 5227,
     /* 426959 */     GIR_Done,
     /* 426960 */   // Label 8387: @426960
     /* 426960 */   GIM_Reject,
     /* 426961 */ // Label 8383: @426961
     /* 426961 */ GIM_Reject,
     /* 426962 */ // Label 8376: @426962
     /* 426962 */ GIM_Try, /*On fail goto*//*Label 8388*/ GIMT_Encode4(427134),
     /* 426967 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426970 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 426973 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 426977 */   GIM_Try, /*On fail goto*//*Label 8389*/ GIMT_Encode4(427036), // Rule ID 1172 //
     /* 426982 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 426985 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 426989 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 426993 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 426997 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427002 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427006 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427010 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 427014 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427019 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427021 */     // (AArch64fcmge:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427021 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f32),
     /* 427024 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427026 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427030 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427034 */     GIR_RootConstrainSelectedInstOperands,
     /* 427035 */     // GIR_Coverage, 1172,
     /* 427035 */     GIR_EraseRootFromParent_Done,
     /* 427036 */   // Label 8389: @427036
     /* 427036 */   GIM_Try, /*On fail goto*//*Label 8390*/ GIMT_Encode4(427071), // Rule ID 788 //
     /* 427041 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427044 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427048 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427054 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427056 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427060 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427062 */     // (AArch64fcmge:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427062 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i32rz),
     /* 427065 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427067 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427069 */     GIR_RootConstrainSelectedInstOperands,
     /* 427070 */     // GIR_Coverage, 788,
     /* 427070 */     GIR_EraseRootFromParent_Done,
     /* 427071 */   // Label 8390: @427071
     /* 427071 */   GIM_Try, /*On fail goto*//*Label 8391*/ GIMT_Encode4(427106), // Rule ID 778 //
     /* 427076 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427079 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427083 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427087 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427093 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427095 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427097 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGEv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 427097 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i32rz),
     /* 427100 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427102 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427104 */     GIR_RootConstrainSelectedInstOperands,
     /* 427105 */     // GIR_Coverage, 778,
     /* 427105 */     GIR_EraseRootFromParent_Done,
     /* 427106 */   // Label 8391: @427106
     /* 427106 */   GIM_Try, /*On fail goto*//*Label 8392*/ GIMT_Encode4(427133), // Rule ID 1215 //
     /* 427111 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427114 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427118 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427122 */     // (AArch64fcmge:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGEv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 427122 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f32),
     /* 427127 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427131 */     GIR_RootConstrainSelectedInstOperands,
     /* 427132 */     // GIR_Coverage, 1215,
     /* 427132 */     GIR_Done,
     /* 427133 */   // Label 8392: @427133
     /* 427133 */   GIM_Reject,
     /* 427134 */ // Label 8388: @427134
     /* 427134 */ GIM_Reject,
     /* 427135 */ // Label 8377: @427135
     /* 427135 */ GIM_Try, /*On fail goto*//*Label 8393*/ GIMT_Encode4(427307),
     /* 427140 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427143 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 427146 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427150 */   GIM_Try, /*On fail goto*//*Label 8394*/ GIMT_Encode4(427209), // Rule ID 1176 //
     /* 427155 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427158 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427162 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427166 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427170 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427175 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427179 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427183 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 427187 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427192 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427194 */     // (AArch64fcmge:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427194 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv2f64),
     /* 427197 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427199 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427203 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427207 */     GIR_RootConstrainSelectedInstOperands,
     /* 427208 */     // GIR_Coverage, 1176,
     /* 427208 */     GIR_EraseRootFromParent_Done,
     /* 427209 */   // Label 8394: @427209
     /* 427209 */   GIM_Try, /*On fail goto*//*Label 8395*/ GIMT_Encode4(427244), // Rule ID 790 //
     /* 427214 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427217 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427221 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427227 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427229 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427233 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427235 */     // (AArch64fcmge:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427235 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv2i64rz),
     /* 427238 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427240 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427242 */     GIR_RootConstrainSelectedInstOperands,
     /* 427243 */     // GIR_Coverage, 790,
     /* 427243 */     GIR_EraseRootFromParent_Done,
     /* 427244 */   // Label 8395: @427244
     /* 427244 */   GIM_Try, /*On fail goto*//*Label 8396*/ GIMT_Encode4(427279), // Rule ID 780 //
     /* 427249 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427252 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427256 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427260 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427266 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427268 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427270 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGEv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 427270 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2i64rz),
     /* 427273 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427275 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427277 */     GIR_RootConstrainSelectedInstOperands,
     /* 427278 */     // GIR_Coverage, 780,
     /* 427278 */     GIR_EraseRootFromParent_Done,
     /* 427279 */   // Label 8396: @427279
     /* 427279 */   GIM_Try, /*On fail goto*//*Label 8397*/ GIMT_Encode4(427306), // Rule ID 1217 //
     /* 427284 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427287 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427291 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427295 */     // (AArch64fcmge:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGEv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 427295 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv2f64),
     /* 427300 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427304 */     GIR_RootConstrainSelectedInstOperands,
     /* 427305 */     // GIR_Coverage, 1217,
     /* 427305 */     GIR_Done,
     /* 427306 */   // Label 8397: @427306
     /* 427306 */   GIM_Reject,
     /* 427307 */ // Label 8393: @427307
     /* 427307 */ GIM_Reject,
     /* 427308 */ // Label 8378: @427308
     /* 427308 */ GIM_Try, /*On fail goto*//*Label 8398*/ GIMT_Encode4(427480),
     /* 427313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 427319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427323 */   GIM_Try, /*On fail goto*//*Label 8399*/ GIMT_Encode4(427382), // Rule ID 1168 //
     /* 427328 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427331 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427335 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427339 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427343 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427348 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427352 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427356 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 427360 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427365 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427367 */     // (AArch64fcmge:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427367 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f16),
     /* 427370 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427372 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427376 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427380 */     GIR_RootConstrainSelectedInstOperands,
     /* 427381 */     // GIR_Coverage, 1168,
     /* 427381 */     GIR_EraseRootFromParent_Done,
     /* 427382 */   // Label 8399: @427382
     /* 427382 */   GIM_Try, /*On fail goto*//*Label 8400*/ GIMT_Encode4(427417), // Rule ID 786 //
     /* 427387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427390 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427394 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427400 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427402 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427406 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427408 */     // (AArch64fcmge:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427408 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i16rz),
     /* 427411 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427413 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427415 */     GIR_RootConstrainSelectedInstOperands,
     /* 427416 */     // GIR_Coverage, 786,
     /* 427416 */     GIR_EraseRootFromParent_Done,
     /* 427417 */   // Label 8400: @427417
     /* 427417 */   GIM_Try, /*On fail goto*//*Label 8401*/ GIMT_Encode4(427452), // Rule ID 776 //
     /* 427422 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427425 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427429 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427433 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427439 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427441 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427443 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGEv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 427443 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i16rz),
     /* 427446 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427448 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427450 */     GIR_RootConstrainSelectedInstOperands,
     /* 427451 */     // GIR_Coverage, 776,
     /* 427451 */     GIR_EraseRootFromParent_Done,
     /* 427452 */   // Label 8401: @427452
     /* 427452 */   GIM_Try, /*On fail goto*//*Label 8402*/ GIMT_Encode4(427479), // Rule ID 1213 //
     /* 427457 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427460 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427464 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427468 */     // (AArch64fcmge:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGEv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 427468 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f16),
     /* 427473 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427477 */     GIR_RootConstrainSelectedInstOperands,
     /* 427478 */     // GIR_Coverage, 1213,
     /* 427478 */     GIR_Done,
     /* 427479 */   // Label 8402: @427479
     /* 427479 */   GIM_Reject,
     /* 427480 */ // Label 8398: @427480
     /* 427480 */ GIM_Reject,
     /* 427481 */ // Label 8379: @427481
     /* 427481 */ GIM_Try, /*On fail goto*//*Label 8403*/ GIMT_Encode4(427653),
     /* 427486 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427489 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 427492 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427496 */   GIM_Try, /*On fail goto*//*Label 8404*/ GIMT_Encode4(427555), // Rule ID 1174 //
     /* 427501 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427504 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427508 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427512 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427516 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427521 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427525 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427529 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 427533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427538 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427540 */     // (AArch64fcmge:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427540 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv4f32),
     /* 427543 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427545 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427549 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427553 */     GIR_RootConstrainSelectedInstOperands,
     /* 427554 */     // GIR_Coverage, 1174,
     /* 427554 */     GIR_EraseRootFromParent_Done,
     /* 427555 */   // Label 8404: @427555
     /* 427555 */   GIM_Try, /*On fail goto*//*Label 8405*/ GIMT_Encode4(427590), // Rule ID 789 //
     /* 427560 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427563 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427567 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427573 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427575 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427579 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427581 */     // (AArch64fcmge:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427581 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv4i32rz),
     /* 427584 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427586 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427588 */     GIR_RootConstrainSelectedInstOperands,
     /* 427589 */     // GIR_Coverage, 789,
     /* 427589 */     GIR_EraseRootFromParent_Done,
     /* 427590 */   // Label 8405: @427590
     /* 427590 */   GIM_Try, /*On fail goto*//*Label 8406*/ GIMT_Encode4(427625), // Rule ID 779 //
     /* 427595 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427598 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427602 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427606 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427612 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427614 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427616 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGEv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 427616 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4i32rz),
     /* 427619 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427621 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427623 */     GIR_RootConstrainSelectedInstOperands,
     /* 427624 */     // GIR_Coverage, 779,
     /* 427624 */     GIR_EraseRootFromParent_Done,
     /* 427625 */   // Label 8406: @427625
     /* 427625 */   GIM_Try, /*On fail goto*//*Label 8407*/ GIMT_Encode4(427652), // Rule ID 1216 //
     /* 427630 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427633 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427637 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427641 */     // (AArch64fcmge:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGEv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 427641 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv4f32),
     /* 427646 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427650 */     GIR_RootConstrainSelectedInstOperands,
     /* 427651 */     // GIR_Coverage, 1216,
     /* 427651 */     GIR_Done,
     /* 427652 */   // Label 8407: @427652
     /* 427652 */   GIM_Reject,
     /* 427653 */ // Label 8403: @427653
     /* 427653 */ GIM_Reject,
     /* 427654 */ // Label 8380: @427654
     /* 427654 */ GIM_Try, /*On fail goto*//*Label 8408*/ GIMT_Encode4(427826),
     /* 427659 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427662 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 427665 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427669 */   GIM_Try, /*On fail goto*//*Label 8409*/ GIMT_Encode4(427728), // Rule ID 1170 //
     /* 427674 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427677 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427681 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427685 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427689 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427694 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 427698 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 427702 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 427706 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427711 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 427713 */     // (AArch64fcmge:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427713 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGEv8f16),
     /* 427716 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427718 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 427722 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 427726 */     GIR_RootConstrainSelectedInstOperands,
     /* 427727 */     // GIR_Coverage, 1170,
     /* 427727 */     GIR_EraseRootFromParent_Done,
     /* 427728 */   // Label 8409: @427728
     /* 427728 */   GIM_Try, /*On fail goto*//*Label 8410*/ GIMT_Encode4(427763), // Rule ID 787 //
     /* 427733 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427736 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427740 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427746 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427748 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427752 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427754 */     // (AArch64fcmge:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLEv8i16rz),
     /* 427757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427759 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427761 */     GIR_RootConstrainSelectedInstOperands,
     /* 427762 */     // GIR_Coverage, 787,
     /* 427762 */     GIR_EraseRootFromParent_Done,
     /* 427763 */   // Label 8410: @427763
     /* 427763 */   GIM_Try, /*On fail goto*//*Label 8411*/ GIMT_Encode4(427798), // Rule ID 777 //
     /* 427768 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427771 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427775 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427779 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427785 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427787 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427789 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGEv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 427789 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8i16rz),
     /* 427792 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427794 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427796 */     GIR_RootConstrainSelectedInstOperands,
     /* 427797 */     // GIR_Coverage, 777,
     /* 427797 */     GIR_EraseRootFromParent_Done,
     /* 427798 */   // Label 8411: @427798
     /* 427798 */   GIM_Try, /*On fail goto*//*Label 8412*/ GIMT_Encode4(427825), // Rule ID 1214 //
     /* 427803 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 427806 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427810 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 427814 */     // (AArch64fcmge:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGEv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 427814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGEv8f16),
     /* 427819 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427823 */     GIR_RootConstrainSelectedInstOperands,
     /* 427824 */     // GIR_Coverage, 1214,
     /* 427824 */     GIR_Done,
     /* 427825 */   // Label 8412: @427825
     /* 427825 */   GIM_Reject,
     /* 427826 */ // Label 8408: @427826
     /* 427826 */ GIM_Reject,
     /* 427827 */ // Label 8381: @427827
     /* 427827 */ GIM_Reject,
     /* 427828 */ // Label 132: @427828
     /* 427828 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(11), /*)*//*default:*//*Label 8420*/ GIMT_Encode4(428919),
     /* 427839 */ /*GILLT_s32*//*Label 8413*/ GIMT_Encode4(427875),
     /* 427843 */ /*GILLT_s64*//*Label 8414*/ GIMT_Encode4(427913), GIMT_Encode4(0),
     /* 427851 */ /*GILLT_v2s32*//*Label 8415*/ GIMT_Encode4(428054),
     /* 427855 */ /*GILLT_v2s64*//*Label 8416*/ GIMT_Encode4(428227),
     /* 427859 */ /*GILLT_v4s16*//*Label 8417*/ GIMT_Encode4(428400),
     /* 427863 */ /*GILLT_v4s32*//*Label 8418*/ GIMT_Encode4(428573), GIMT_Encode4(0),
     /* 427871 */ /*GILLT_v8s16*//*Label 8419*/ GIMT_Encode4(428746),
     /* 427875 */ // Label 8413: @427875
     /* 427875 */ GIM_Try, /*On fail goto*//*Label 8421*/ GIMT_Encode4(427912), // Rule ID 1626 //
     /* 427880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 427886 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s32,
     /* 427889 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427893 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427897 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 427901 */   // (AArch64fcmgt:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)  =>  (FCMGT32:{ *:[i32] } FPR32:{ *:[f32] }:$Rn, FPR32:{ *:[f32] }:$Rm)
     /* 427901 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT32),
     /* 427906 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 427910 */   GIR_RootConstrainSelectedInstOperands,
     /* 427911 */   // GIR_Coverage, 1626,
     /* 427911 */   GIR_Done,
     /* 427912 */ // Label 8421: @427912
     /* 427912 */ GIM_Reject,
     /* 427913 */ // Label 8414: @427913
     /* 427913 */ GIM_Try, /*On fail goto*//*Label 8422*/ GIMT_Encode4(428053),
     /* 427918 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 427921 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_s64,
     /* 427924 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427928 */   GIM_Try, /*On fail goto*//*Label 8423*/ GIMT_Encode4(427963), // Rule ID 5261 //
     /* 427933 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427936 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 427940 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427946 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427948 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427952 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427954 */     // (AArch64fcmgt:{ *:[v1i64] } immAllZerosV:{ *:[v1f64] }, FPR64:{ *:[v1f64] }:$Rn)  =>  (FCMLTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv1i64rz),
     /* 427957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427959 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 427961 */     GIR_RootConstrainSelectedInstOperands,
     /* 427962 */     // GIR_Coverage, 5261,
     /* 427962 */     GIR_EraseRootFromParent_Done,
     /* 427963 */   // Label 8423: @427963
     /* 427963 */   GIM_Try, /*On fail goto*//*Label 8424*/ GIMT_Encode4(427998), // Rule ID 5259 //
     /* 427968 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 427971 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 427975 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 427979 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 427985 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 427987 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 427989 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, immAllZerosV:{ *:[v1f64] })  =>  (FCMGTv1i64rz:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn)
     /* 427989 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv1i64rz),
     /* 427992 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 427994 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 427996 */     GIR_RootConstrainSelectedInstOperands,
     /* 427997 */     // GIR_Coverage, 5259,
     /* 427997 */     GIR_EraseRootFromParent_Done,
     /* 427998 */   // Label 8424: @427998
     /* 427998 */   GIM_Try, /*On fail goto*//*Label 8425*/ GIMT_Encode4(428025), // Rule ID 1625 //
     /* 428003 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428006 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428010 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428014 */     // (AArch64fcmgt:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)  =>  (FCMGT64:{ *:[i64] } FPR64:{ *:[f64] }:$Rn, FPR64:{ *:[f64] }:$Rm)
     /* 428014 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 428019 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428023 */     GIR_RootConstrainSelectedInstOperands,
     /* 428024 */     // GIR_Coverage, 1625,
     /* 428024 */     GIR_Done,
     /* 428025 */   // Label 8425: @428025
     /* 428025 */   GIM_Try, /*On fail goto*//*Label 8426*/ GIMT_Encode4(428052), // Rule ID 5228 //
     /* 428030 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428033 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428037 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428041 */     // (AArch64fcmgt:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)  =>  (FCMGT64:{ *:[v1i64] } FPR64:{ *:[v1f64] }:$Rn, FPR64:{ *:[v1f64] }:$Rm)
     /* 428041 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGT64),
     /* 428046 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428050 */     GIR_RootConstrainSelectedInstOperands,
     /* 428051 */     // GIR_Coverage, 5228,
     /* 428051 */     GIR_Done,
     /* 428052 */   // Label 8426: @428052
     /* 428052 */   GIM_Reject,
     /* 428053 */ // Label 8422: @428053
     /* 428053 */ GIM_Reject,
     /* 428054 */ // Label 8415: @428054
     /* 428054 */ GIM_Try, /*On fail goto*//*Label 8427*/ GIMT_Encode4(428226),
     /* 428059 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428062 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 428065 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428069 */   GIM_Try, /*On fail goto*//*Label 8428*/ GIMT_Encode4(428128), // Rule ID 1182 //
     /* 428074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428077 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428081 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428085 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428089 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428094 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428098 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428102 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 428106 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428111 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428113 */     // (AArch64fcmgt:{ *:[v2i32] } (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn), (fabs:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rm))  =>  (FACGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428113 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f32),
     /* 428116 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428118 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428122 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428126 */     GIR_RootConstrainSelectedInstOperands,
     /* 428127 */     // GIR_Coverage, 1182,
     /* 428127 */     GIR_EraseRootFromParent_Done,
     /* 428128 */   // Label 8428: @428128
     /* 428128 */   GIM_Try, /*On fail goto*//*Label 8429*/ GIMT_Encode4(428163), // Rule ID 793 //
     /* 428133 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428136 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428140 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428146 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428148 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428152 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428154 */     // (AArch64fcmgt:{ *:[v2i32] } immAllZerosV:{ *:[v2f32] }, V64:{ *:[v2f32] }:$Rn)  =>  (FCMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428154 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i32rz),
     /* 428157 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428159 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428161 */     GIR_RootConstrainSelectedInstOperands,
     /* 428162 */     // GIR_Coverage, 793,
     /* 428162 */     GIR_EraseRootFromParent_Done,
     /* 428163 */   // Label 8429: @428163
     /* 428163 */   GIM_Try, /*On fail goto*//*Label 8430*/ GIMT_Encode4(428198), // Rule ID 783 //
     /* 428168 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428171 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428175 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428179 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428185 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428187 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428189 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, immAllZerosV:{ *:[v2f32] })  =>  (FCMGTv2i32rz:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn)
     /* 428189 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i32rz),
     /* 428192 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428194 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428196 */     GIR_RootConstrainSelectedInstOperands,
     /* 428197 */     // GIR_Coverage, 783,
     /* 428197 */     GIR_EraseRootFromParent_Done,
     /* 428198 */   // Label 8430: @428198
     /* 428198 */   GIM_Try, /*On fail goto*//*Label 8431*/ GIMT_Encode4(428225), // Rule ID 1220 //
     /* 428203 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428206 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428210 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428214 */     // (AArch64fcmgt:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (FCMGTv2f32:{ *:[v2i32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 428214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f32),
     /* 428219 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428223 */     GIR_RootConstrainSelectedInstOperands,
     /* 428224 */     // GIR_Coverage, 1220,
     /* 428224 */     GIR_Done,
     /* 428225 */   // Label 8431: @428225
     /* 428225 */   GIM_Reject,
     /* 428226 */ // Label 8427: @428226
     /* 428226 */ GIM_Reject,
     /* 428227 */ // Label 8416: @428227
     /* 428227 */ GIM_Try, /*On fail goto*//*Label 8432*/ GIMT_Encode4(428399),
     /* 428232 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428235 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 428238 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428242 */   GIM_Try, /*On fail goto*//*Label 8433*/ GIMT_Encode4(428301), // Rule ID 1186 //
     /* 428247 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428250 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428254 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428258 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428262 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428267 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428271 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428275 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 428279 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428284 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428286 */     // (AArch64fcmgt:{ *:[v2i64] } (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn), (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rm))  =>  (FACGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428286 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv2f64),
     /* 428289 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428291 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428295 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428299 */     GIR_RootConstrainSelectedInstOperands,
     /* 428300 */     // GIR_Coverage, 1186,
     /* 428300 */     GIR_EraseRootFromParent_Done,
     /* 428301 */   // Label 8433: @428301
     /* 428301 */   GIM_Try, /*On fail goto*//*Label 8434*/ GIMT_Encode4(428336), // Rule ID 795 //
     /* 428306 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428309 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428313 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428319 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428321 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428325 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428327 */     // (AArch64fcmgt:{ *:[v2i64] } immAllZerosV:{ *:[v2f64] }, V128:{ *:[v2f64] }:$Rn)  =>  (FCMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428327 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv2i64rz),
     /* 428330 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428332 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428334 */     GIR_RootConstrainSelectedInstOperands,
     /* 428335 */     // GIR_Coverage, 795,
     /* 428335 */     GIR_EraseRootFromParent_Done,
     /* 428336 */   // Label 8434: @428336
     /* 428336 */   GIM_Try, /*On fail goto*//*Label 8435*/ GIMT_Encode4(428371), // Rule ID 785 //
     /* 428341 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428344 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428348 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428352 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428358 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428360 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428362 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, immAllZerosV:{ *:[v2f64] })  =>  (FCMGTv2i64rz:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn)
     /* 428362 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2i64rz),
     /* 428365 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428367 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428369 */     GIR_RootConstrainSelectedInstOperands,
     /* 428370 */     // GIR_Coverage, 785,
     /* 428370 */     GIR_EraseRootFromParent_Done,
     /* 428371 */   // Label 8435: @428371
     /* 428371 */   GIM_Try, /*On fail goto*//*Label 8436*/ GIMT_Encode4(428398), // Rule ID 1222 //
     /* 428376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428379 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428383 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428387 */     // (AArch64fcmgt:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (FCMGTv2f64:{ *:[v2i64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 428387 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv2f64),
     /* 428392 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428396 */     GIR_RootConstrainSelectedInstOperands,
     /* 428397 */     // GIR_Coverage, 1222,
     /* 428397 */     GIR_Done,
     /* 428398 */   // Label 8436: @428398
     /* 428398 */   GIM_Reject,
     /* 428399 */ // Label 8432: @428399
     /* 428399 */ GIM_Reject,
     /* 428400 */ // Label 8417: @428400
     /* 428400 */ GIM_Try, /*On fail goto*//*Label 8437*/ GIMT_Encode4(428572),
     /* 428405 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428408 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 428411 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428415 */   GIM_Try, /*On fail goto*//*Label 8438*/ GIMT_Encode4(428474), // Rule ID 1178 //
     /* 428420 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428423 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428427 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428431 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428435 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428440 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428444 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428448 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 428452 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428457 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428459 */     // (AArch64fcmgt:{ *:[v4i16] } (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn), (fabs:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rm))  =>  (FACGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428459 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f16),
     /* 428462 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428468 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428472 */     GIR_RootConstrainSelectedInstOperands,
     /* 428473 */     // GIR_Coverage, 1178,
     /* 428473 */     GIR_EraseRootFromParent_Done,
     /* 428474 */   // Label 8438: @428474
     /* 428474 */   GIM_Try, /*On fail goto*//*Label 8439*/ GIMT_Encode4(428509), // Rule ID 791 //
     /* 428479 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428482 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428486 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428492 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428494 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428498 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428500 */     // (AArch64fcmgt:{ *:[v4i16] } immAllZerosV:{ *:[v4f16] }, V64:{ *:[v4f16] }:$Rn)  =>  (FCMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428500 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i16rz),
     /* 428503 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428505 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428507 */     GIR_RootConstrainSelectedInstOperands,
     /* 428508 */     // GIR_Coverage, 791,
     /* 428508 */     GIR_EraseRootFromParent_Done,
     /* 428509 */   // Label 8439: @428509
     /* 428509 */   GIM_Try, /*On fail goto*//*Label 8440*/ GIMT_Encode4(428544), // Rule ID 781 //
     /* 428514 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428517 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428521 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428525 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428531 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428533 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428535 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, immAllZerosV:{ *:[v4f16] })  =>  (FCMGTv4i16rz:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn)
     /* 428535 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i16rz),
     /* 428538 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428540 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428542 */     GIR_RootConstrainSelectedInstOperands,
     /* 428543 */     // GIR_Coverage, 781,
     /* 428543 */     GIR_EraseRootFromParent_Done,
     /* 428544 */   // Label 8440: @428544
     /* 428544 */   GIM_Try, /*On fail goto*//*Label 8441*/ GIMT_Encode4(428571), // Rule ID 1218 //
     /* 428549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428552 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428556 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 428560 */     // (AArch64fcmgt:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (FCMGTv4f16:{ *:[v4i16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 428560 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f16),
     /* 428565 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428569 */     GIR_RootConstrainSelectedInstOperands,
     /* 428570 */     // GIR_Coverage, 1218,
     /* 428570 */     GIR_Done,
     /* 428571 */   // Label 8441: @428571
     /* 428571 */   GIM_Reject,
     /* 428572 */ // Label 8437: @428572
     /* 428572 */ GIM_Reject,
     /* 428573 */ // Label 8418: @428573
     /* 428573 */ GIM_Try, /*On fail goto*//*Label 8442*/ GIMT_Encode4(428745),
     /* 428578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 428584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428588 */   GIM_Try, /*On fail goto*//*Label 8443*/ GIMT_Encode4(428647), // Rule ID 1184 //
     /* 428593 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428596 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428600 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428604 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428608 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428613 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428617 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428621 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 428625 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428630 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428632 */     // (AArch64fcmgt:{ *:[v4i32] } (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn), (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rm))  =>  (FACGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428632 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv4f32),
     /* 428635 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428637 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428641 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428645 */     GIR_RootConstrainSelectedInstOperands,
     /* 428646 */     // GIR_Coverage, 1184,
     /* 428646 */     GIR_EraseRootFromParent_Done,
     /* 428647 */   // Label 8443: @428647
     /* 428647 */   GIM_Try, /*On fail goto*//*Label 8444*/ GIMT_Encode4(428682), // Rule ID 794 //
     /* 428652 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428655 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428659 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428665 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428667 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428671 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428673 */     // (AArch64fcmgt:{ *:[v4i32] } immAllZerosV:{ *:[v4f32] }, V128:{ *:[v4f32] }:$Rn)  =>  (FCMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428673 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv4i32rz),
     /* 428676 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428678 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428680 */     GIR_RootConstrainSelectedInstOperands,
     /* 428681 */     // GIR_Coverage, 794,
     /* 428681 */     GIR_EraseRootFromParent_Done,
     /* 428682 */   // Label 8444: @428682
     /* 428682 */   GIM_Try, /*On fail goto*//*Label 8445*/ GIMT_Encode4(428717), // Rule ID 784 //
     /* 428687 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428690 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428694 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428698 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428704 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428706 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428708 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, immAllZerosV:{ *:[v4f32] })  =>  (FCMGTv4i32rz:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn)
     /* 428708 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4i32rz),
     /* 428711 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428713 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428715 */     GIR_RootConstrainSelectedInstOperands,
     /* 428716 */     // GIR_Coverage, 784,
     /* 428716 */     GIR_EraseRootFromParent_Done,
     /* 428717 */   // Label 8445: @428717
     /* 428717 */   GIM_Try, /*On fail goto*//*Label 8446*/ GIMT_Encode4(428744), // Rule ID 1221 //
     /* 428722 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 428725 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428729 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428733 */     // (AArch64fcmgt:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (FCMGTv4f32:{ *:[v4i32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 428733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv4f32),
     /* 428738 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428742 */     GIR_RootConstrainSelectedInstOperands,
     /* 428743 */     // GIR_Coverage, 1221,
     /* 428743 */     GIR_Done,
     /* 428744 */   // Label 8446: @428744
     /* 428744 */   GIM_Reject,
     /* 428745 */ // Label 8442: @428745
     /* 428745 */ GIM_Reject,
     /* 428746 */ // Label 8419: @428746
     /* 428746 */ GIM_Try, /*On fail goto*//*Label 8447*/ GIMT_Encode4(428918),
     /* 428751 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428754 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 428757 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428761 */   GIM_Try, /*On fail goto*//*Label 8448*/ GIMT_Encode4(428820), // Rule ID 1180 //
     /* 428766 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428769 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428773 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428777 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428781 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428786 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/0, /*OpIdx*/2, // MIs[2]
     /* 428790 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_FABS),
     /* 428794 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 428798 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428803 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 428805 */     // (AArch64fcmgt:{ *:[v8i16] } (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn), (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rm))  =>  (FACGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428805 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FACGTv8f16),
     /* 428808 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428810 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rn
     /* 428814 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 428818 */     GIR_RootConstrainSelectedInstOperands,
     /* 428819 */     // GIR_Coverage, 1180,
     /* 428819 */     GIR_EraseRootFromParent_Done,
     /* 428820 */   // Label 8448: @428820
     /* 428820 */   GIM_Try, /*On fail goto*//*Label 8449*/ GIMT_Encode4(428855), // Rule ID 792 //
     /* 428825 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428828 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 428832 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428838 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428840 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428844 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428846 */     // (AArch64fcmgt:{ *:[v8i16] } immAllZerosV:{ *:[v8f16] }, V128:{ *:[v8f16] }:$Rn)  =>  (FCMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428846 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMLTv8i16rz),
     /* 428849 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428851 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 428853 */     GIR_RootConstrainSelectedInstOperands,
     /* 428854 */     // GIR_Coverage, 792,
     /* 428854 */     GIR_EraseRootFromParent_Done,
     /* 428855 */   // Label 8449: @428855
     /* 428855 */   GIM_Try, /*On fail goto*//*Label 8450*/ GIMT_Encode4(428890), // Rule ID 782 //
     /* 428860 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428863 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428867 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 428871 */     GIM_CheckOpcodeIsEither, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR), GIMT_Encode2(TargetOpcode::G_BUILD_VECTOR_TRUNC),
     /* 428877 */     GIM_CheckIsBuildVectorAllZeros, /*MI*/1,
     /* 428879 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 428881 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, immAllZerosV:{ *:[v8f16] })  =>  (FCMGTv8i16rz:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn)
     /* 428881 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8i16rz),
     /* 428884 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 428886 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 428888 */     GIR_RootConstrainSelectedInstOperands,
     /* 428889 */     // GIR_Coverage, 782,
     /* 428889 */     GIR_EraseRootFromParent_Done,
     /* 428890 */   // Label 8450: @428890
     /* 428890 */   GIM_Try, /*On fail goto*//*Label 8451*/ GIMT_Encode4(428917), // Rule ID 1219 //
     /* 428895 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEON),
     /* 428898 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428902 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 428906 */     // (AArch64fcmgt:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (FCMGTv8f16:{ *:[v8i16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 428906 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::FCMGTv8f16),
     /* 428911 */     GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 428915 */     GIR_RootConstrainSelectedInstOperands,
     /* 428916 */     // GIR_Coverage, 1219,
     /* 428916 */     GIR_Done,
     /* 428917 */   // Label 8451: @428917
     /* 428917 */   GIM_Reject,
     /* 428918 */ // Label 8447: @428918
     /* 428918 */ GIM_Reject,
     /* 428919 */ // Label 8420: @428919
     /* 428919 */ GIM_Reject,
     /* 428920 */ // Label 133: @428920
     /* 428920 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(2), GIMT_Encode2(12), /*)*//*default:*//*Label 8456*/ GIMT_Encode4(429073),
     /* 428931 */ /*GILLT_s32*//*Label 8452*/ GIMT_Encode4(428971),
     /* 428935 */ /*GILLT_s64*//*Label 8453*/ GIMT_Encode4(428995), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 428959 */ /*GILLT_v8s8*//*Label 8454*/ GIMT_Encode4(429019), GIMT_Encode4(0),
     /* 428967 */ /*GILLT_v16s8*//*Label 8455*/ GIMT_Encode4(429046),
     /* 428971 */ // Label 8452: @428971
     /* 428971 */ GIM_Try, /*On fail goto*//*Label 8457*/ GIMT_Encode4(428994), // Rule ID 4014 //
     /* 428976 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 428979 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 428983 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR32RegClassID),
     /* 428987 */   // (AArch64rev16:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)  =>  (REV16Wr:{ *:[i32] } GPR32:{ *:[i32] }:$Rn)
     /* 428987 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Wr),
     /* 428992 */   GIR_RootConstrainSelectedInstOperands,
     /* 428993 */   // GIR_Coverage, 4014,
     /* 428993 */   GIR_Done,
     /* 428994 */ // Label 8457: @428994
     /* 428994 */ GIM_Reject,
     /* 428995 */ // Label 8453: @428995
     /* 428995 */ GIM_Try, /*On fail goto*//*Label 8458*/ GIMT_Encode4(429018), // Rule ID 4015 //
     /* 429000 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 429003 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 429007 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::GPR64RegClassID),
     /* 429011 */   // (AArch64rev16:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)  =>  (REV16Xr:{ *:[i64] } GPR64:{ *:[i64] }:$Rn)
     /* 429011 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16Xr),
     /* 429016 */   GIR_RootConstrainSelectedInstOperands,
     /* 429017 */   // GIR_Coverage, 4015,
     /* 429017 */   GIR_Done,
     /* 429018 */ // Label 8458: @429018
     /* 429018 */ GIM_Reject,
     /* 429019 */ // Label 8454: @429019
     /* 429019 */ GIM_Try, /*On fail goto*//*Label 8459*/ GIMT_Encode4(429045), // Rule ID 976 //
     /* 429024 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429027 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429030 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429034 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429038 */   // (AArch64rev16:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV16v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429038 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v8i8),
     /* 429043 */   GIR_RootConstrainSelectedInstOperands,
     /* 429044 */   // GIR_Coverage, 976,
     /* 429044 */   GIR_Done,
     /* 429045 */ // Label 8459: @429045
     /* 429045 */ GIM_Reject,
     /* 429046 */ // Label 8455: @429046
     /* 429046 */ GIM_Try, /*On fail goto*//*Label 8460*/ GIMT_Encode4(429072), // Rule ID 977 //
     /* 429051 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429054 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429065 */   // (AArch64rev16:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV16v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429065 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV16v16i8),
     /* 429070 */   GIR_RootConstrainSelectedInstOperands,
     /* 429071 */   // GIR_Coverage, 977,
     /* 429071 */   GIR_Done,
     /* 429072 */ // Label 8460: @429072
     /* 429072 */ GIM_Reject,
     /* 429073 */ // Label 8456: @429073
     /* 429073 */ GIM_Reject,
     /* 429074 */ // Label 134: @429074
     /* 429074 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(7), GIMT_Encode2(12), /*)*//*default:*//*Label 8465*/ GIMT_Encode4(429249),
     /* 429085 */ /*GILLT_v4s16*//*Label 8461*/ GIMT_Encode4(429105), GIMT_Encode4(0),
     /* 429093 */ /*GILLT_v8s8*//*Label 8462*/ GIMT_Encode4(429150),
     /* 429097 */ /*GILLT_v8s16*//*Label 8463*/ GIMT_Encode4(429177),
     /* 429101 */ /*GILLT_v16s8*//*Label 8464*/ GIMT_Encode4(429222),
     /* 429105 */ // Label 8461: @429105
     /* 429105 */ GIM_Try, /*On fail goto*//*Label 8466*/ GIMT_Encode4(429149),
     /* 429110 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429113 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429117 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429121 */   GIM_Try, /*On fail goto*//*Label 8467*/ GIMT_Encode4(429136), // Rule ID 980 //
     /* 429126 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429129 */     // (AArch64rev32:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV32v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 429129 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 429134 */     GIR_RootConstrainSelectedInstOperands,
     /* 429135 */     // GIR_Coverage, 980,
     /* 429135 */     GIR_Done,
     /* 429136 */   // Label 8467: @429136
     /* 429136 */   GIM_Try, /*On fail goto*//*Label 8468*/ GIMT_Encode4(429148), // Rule ID 4997 //
     /* 429141 */     // (AArch64rev32:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV32v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 429141 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v4i16),
     /* 429146 */     GIR_RootConstrainSelectedInstOperands,
     /* 429147 */     // GIR_Coverage, 4997,
     /* 429147 */     GIR_Done,
     /* 429148 */   // Label 8468: @429148
     /* 429148 */   GIM_Reject,
     /* 429149 */ // Label 8466: @429149
     /* 429149 */ GIM_Reject,
     /* 429150 */ // Label 8462: @429150
     /* 429150 */ GIM_Try, /*On fail goto*//*Label 8469*/ GIMT_Encode4(429176), // Rule ID 978 //
     /* 429155 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429158 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429161 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429165 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429169 */   // (AArch64rev32:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV32v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429169 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i8),
     /* 429174 */   GIR_RootConstrainSelectedInstOperands,
     /* 429175 */   // GIR_Coverage, 978,
     /* 429175 */   GIR_Done,
     /* 429176 */ // Label 8469: @429176
     /* 429176 */ GIM_Reject,
     /* 429177 */ // Label 8463: @429177
     /* 429177 */ GIM_Try, /*On fail goto*//*Label 8470*/ GIMT_Encode4(429221),
     /* 429182 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429185 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429189 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429193 */   GIM_Try, /*On fail goto*//*Label 8471*/ GIMT_Encode4(429208), // Rule ID 981 //
     /* 429198 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429201 */     // (AArch64rev32:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV32v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 429201 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 429206 */     GIR_RootConstrainSelectedInstOperands,
     /* 429207 */     // GIR_Coverage, 981,
     /* 429207 */     GIR_Done,
     /* 429208 */   // Label 8471: @429208
     /* 429208 */   GIM_Try, /*On fail goto*//*Label 8472*/ GIMT_Encode4(429220), // Rule ID 4999 //
     /* 429213 */     // (AArch64rev32:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV32v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 429213 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v8i16),
     /* 429218 */     GIR_RootConstrainSelectedInstOperands,
     /* 429219 */     // GIR_Coverage, 4999,
     /* 429219 */     GIR_Done,
     /* 429220 */   // Label 8472: @429220
     /* 429220 */   GIM_Reject,
     /* 429221 */ // Label 8470: @429221
     /* 429221 */ GIM_Reject,
     /* 429222 */ // Label 8464: @429222
     /* 429222 */ GIM_Try, /*On fail goto*//*Label 8473*/ GIMT_Encode4(429248), // Rule ID 979 //
     /* 429227 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429230 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429233 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429237 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429241 */   // (AArch64rev32:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV32v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429241 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV32v16i8),
     /* 429246 */   GIR_RootConstrainSelectedInstOperands,
     /* 429247 */   // GIR_Coverage, 979,
     /* 429247 */   GIR_Done,
     /* 429248 */ // Label 8473: @429248
     /* 429248 */ GIM_Reject,
     /* 429249 */ // Label 8465: @429249
     /* 429249 */ GIM_Reject,
     /* 429250 */ // Label 135: @429250
     /* 429250 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(12), /*)*//*default:*//*Label 8480*/ GIMT_Encode4(429523),
     /* 429261 */ /*GILLT_v2s32*//*Label 8474*/ GIMT_Encode4(429289), GIMT_Encode4(0),
     /* 429269 */ /*GILLT_v4s16*//*Label 8475*/ GIMT_Encode4(429334),
     /* 429273 */ /*GILLT_v4s32*//*Label 8476*/ GIMT_Encode4(429379),
     /* 429277 */ /*GILLT_v8s8*//*Label 8477*/ GIMT_Encode4(429424),
     /* 429281 */ /*GILLT_v8s16*//*Label 8478*/ GIMT_Encode4(429451),
     /* 429285 */ /*GILLT_v16s8*//*Label 8479*/ GIMT_Encode4(429496),
     /* 429289 */ // Label 8474: @429289
     /* 429289 */ GIM_Try, /*On fail goto*//*Label 8481*/ GIMT_Encode4(429333),
     /* 429294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429301 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429305 */   GIM_Try, /*On fail goto*//*Label 8482*/ GIMT_Encode4(429320), // Rule ID 986 //
     /* 429310 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429313 */     // (AArch64rev64:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)  =>  (REV64v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 429313 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 429318 */     GIR_RootConstrainSelectedInstOperands,
     /* 429319 */     // GIR_Coverage, 986,
     /* 429319 */     GIR_Done,
     /* 429320 */   // Label 8482: @429320
     /* 429320 */   GIM_Try, /*On fail goto*//*Label 8483*/ GIMT_Encode4(429332), // Rule ID 5001 //
     /* 429325 */     // (AArch64rev64:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)  =>  (REV64v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn)
     /* 429325 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v2i32),
     /* 429330 */     GIR_RootConstrainSelectedInstOperands,
     /* 429331 */     // GIR_Coverage, 5001,
     /* 429331 */     GIR_Done,
     /* 429332 */   // Label 8483: @429332
     /* 429332 */   GIM_Reject,
     /* 429333 */ // Label 8481: @429333
     /* 429333 */ GIM_Reject,
     /* 429334 */ // Label 8475: @429334
     /* 429334 */ GIM_Try, /*On fail goto*//*Label 8484*/ GIMT_Encode4(429378),
     /* 429339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429342 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429346 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429350 */   GIM_Try, /*On fail goto*//*Label 8485*/ GIMT_Encode4(429365), // Rule ID 984 //
     /* 429355 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429358 */     // (AArch64rev64:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)  =>  (REV64v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 429358 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 429363 */     GIR_RootConstrainSelectedInstOperands,
     /* 429364 */     // GIR_Coverage, 984,
     /* 429364 */     GIR_Done,
     /* 429365 */   // Label 8485: @429365
     /* 429365 */   GIM_Try, /*On fail goto*//*Label 8486*/ GIMT_Encode4(429377), // Rule ID 4998 //
     /* 429370 */     // (AArch64rev64:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)  =>  (REV64v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn)
     /* 429370 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i16),
     /* 429375 */     GIR_RootConstrainSelectedInstOperands,
     /* 429376 */     // GIR_Coverage, 4998,
     /* 429376 */     GIR_Done,
     /* 429377 */   // Label 8486: @429377
     /* 429377 */   GIM_Reject,
     /* 429378 */ // Label 8484: @429378
     /* 429378 */ GIM_Reject,
     /* 429379 */ // Label 8476: @429379
     /* 429379 */ GIM_Try, /*On fail goto*//*Label 8487*/ GIMT_Encode4(429423),
     /* 429384 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429391 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429395 */   GIM_Try, /*On fail goto*//*Label 8488*/ GIMT_Encode4(429410), // Rule ID 987 //
     /* 429400 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429403 */     // (AArch64rev64:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)  =>  (REV64v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 429403 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 429408 */     GIR_RootConstrainSelectedInstOperands,
     /* 429409 */     // GIR_Coverage, 987,
     /* 429409 */     GIR_Done,
     /* 429410 */   // Label 8488: @429410
     /* 429410 */   GIM_Try, /*On fail goto*//*Label 8489*/ GIMT_Encode4(429422), // Rule ID 5002 //
     /* 429415 */     // (AArch64rev64:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)  =>  (REV64v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn)
     /* 429415 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v4i32),
     /* 429420 */     GIR_RootConstrainSelectedInstOperands,
     /* 429421 */     // GIR_Coverage, 5002,
     /* 429421 */     GIR_Done,
     /* 429422 */   // Label 8489: @429422
     /* 429422 */   GIM_Reject,
     /* 429423 */ // Label 8487: @429423
     /* 429423 */ GIM_Reject,
     /* 429424 */ // Label 8477: @429424
     /* 429424 */ GIM_Try, /*On fail goto*//*Label 8490*/ GIMT_Encode4(429450), // Rule ID 982 //
     /* 429429 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429432 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429439 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429443 */   // (AArch64rev64:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)  =>  (REV64v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 429443 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i8),
     /* 429448 */   GIR_RootConstrainSelectedInstOperands,
     /* 429449 */   // GIR_Coverage, 982,
     /* 429449 */   GIR_Done,
     /* 429450 */ // Label 8490: @429450
     /* 429450 */ GIM_Reject,
     /* 429451 */ // Label 8478: @429451
     /* 429451 */ GIM_Try, /*On fail goto*//*Label 8491*/ GIMT_Encode4(429495),
     /* 429456 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429459 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429463 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429467 */   GIM_Try, /*On fail goto*//*Label 8492*/ GIMT_Encode4(429482), // Rule ID 985 //
     /* 429472 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429475 */     // (AArch64rev64:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)  =>  (REV64v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 429475 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 429480 */     GIR_RootConstrainSelectedInstOperands,
     /* 429481 */     // GIR_Coverage, 985,
     /* 429481 */     GIR_Done,
     /* 429482 */   // Label 8492: @429482
     /* 429482 */   GIM_Try, /*On fail goto*//*Label 8493*/ GIMT_Encode4(429494), // Rule ID 5000 //
     /* 429487 */     // (AArch64rev64:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)  =>  (REV64v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn)
     /* 429487 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v8i16),
     /* 429492 */     GIR_RootConstrainSelectedInstOperands,
     /* 429493 */     // GIR_Coverage, 5000,
     /* 429493 */     GIR_Done,
     /* 429494 */   // Label 8493: @429494
     /* 429494 */   GIM_Reject,
     /* 429495 */ // Label 8491: @429495
     /* 429495 */ GIM_Reject,
     /* 429496 */ // Label 8479: @429496
     /* 429496 */ GIM_Try, /*On fail goto*//*Label 8494*/ GIMT_Encode4(429522), // Rule ID 983 //
     /* 429501 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429504 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429507 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429511 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429515 */   // (AArch64rev64:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)  =>  (REV64v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 429515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::REV64v16i8),
     /* 429520 */   GIR_RootConstrainSelectedInstOperands,
     /* 429521 */   // GIR_Coverage, 983,
     /* 429521 */   GIR_Done,
     /* 429522 */ // Label 8494: @429522
     /* 429522 */ GIM_Reject,
     /* 429523 */ // Label 8480: @429523
     /* 429523 */ GIM_Reject,
     /* 429524 */ // Label 136: @429524
     /* 429524 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8501*/ GIMT_Encode4(429729),
     /* 429535 */ /*GILLT_s64*//*Label 8495*/ GIMT_Encode4(429567), GIMT_Encode4(0),
     /* 429543 */ /*GILLT_v2s32*//*Label 8496*/ GIMT_Encode4(429594),
     /* 429547 */ /*GILLT_v2s64*//*Label 8497*/ GIMT_Encode4(429621),
     /* 429551 */ /*GILLT_v4s16*//*Label 8498*/ GIMT_Encode4(429648),
     /* 429555 */ /*GILLT_v4s32*//*Label 8499*/ GIMT_Encode4(429675), GIMT_Encode4(0),
     /* 429563 */ /*GILLT_v8s16*//*Label 8500*/ GIMT_Encode4(429702),
     /* 429567 */ // Label 8495: @429567
     /* 429567 */ GIM_Try, /*On fail goto*//*Label 8502*/ GIMT_Encode4(429593), // Rule ID 1008 //
     /* 429572 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429575 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429578 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429582 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429586 */   // (AArch64saddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (SADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 429586 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 429591 */   GIR_RootConstrainSelectedInstOperands,
     /* 429592 */   // GIR_Coverage, 1008,
     /* 429592 */   GIR_Done,
     /* 429593 */ // Label 8502: @429593
     /* 429593 */ GIM_Reject,
     /* 429594 */ // Label 8496: @429594
     /* 429594 */ GIM_Try, /*On fail goto*//*Label 8503*/ GIMT_Encode4(429620), // Rule ID 1004 //
     /* 429599 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429602 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429605 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429609 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429613 */   // (AArch64saddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 429613 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i16_v2i32),
     /* 429618 */   GIR_RootConstrainSelectedInstOperands,
     /* 429619 */   // GIR_Coverage, 1004,
     /* 429619 */   GIR_Done,
     /* 429620 */ // Label 8503: @429620
     /* 429620 */ GIM_Reject,
     /* 429621 */ // Label 8497: @429621
     /* 429621 */ GIM_Try, /*On fail goto*//*Label 8504*/ GIMT_Encode4(429647), // Rule ID 1010 //
     /* 429626 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429629 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429632 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429636 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429640 */   // (AArch64saddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 429640 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv4i32_v2i64),
     /* 429645 */   GIR_RootConstrainSelectedInstOperands,
     /* 429646 */   // GIR_Coverage, 1010,
     /* 429646 */   GIR_Done,
     /* 429647 */ // Label 8504: @429647
     /* 429647 */ GIM_Reject,
     /* 429648 */ // Label 8498: @429648
     /* 429648 */ GIM_Try, /*On fail goto*//*Label 8505*/ GIMT_Encode4(429674), // Rule ID 1000 //
     /* 429653 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429656 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429659 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429663 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429667 */   // (AArch64saddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (SADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 429667 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i8_v4i16),
     /* 429672 */   GIR_RootConstrainSelectedInstOperands,
     /* 429673 */   // GIR_Coverage, 1000,
     /* 429673 */   GIR_Done,
     /* 429674 */ // Label 8505: @429674
     /* 429674 */ GIM_Reject,
     /* 429675 */ // Label 8499: @429675
     /* 429675 */ GIM_Try, /*On fail goto*//*Label 8506*/ GIMT_Encode4(429701), // Rule ID 1006 //
     /* 429680 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429683 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 429686 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429690 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429694 */   // (AArch64saddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 429694 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv8i16_v4i32),
     /* 429699 */   GIR_RootConstrainSelectedInstOperands,
     /* 429700 */   // GIR_Coverage, 1006,
     /* 429700 */   GIR_Done,
     /* 429701 */ // Label 8506: @429701
     /* 429701 */ GIM_Reject,
     /* 429702 */ // Label 8500: @429702
     /* 429702 */ GIM_Try, /*On fail goto*//*Label 8507*/ GIMT_Encode4(429728), // Rule ID 1002 //
     /* 429707 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 429710 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 429713 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429717 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429721 */   // (AArch64saddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (SADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 429721 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv16i8_v8i16),
     /* 429726 */   GIR_RootConstrainSelectedInstOperands,
     /* 429727 */   // GIR_Coverage, 1002,
     /* 429727 */   GIR_Done,
     /* 429728 */ // Label 8507: @429728
     /* 429728 */ GIM_Reject,
     /* 429729 */ // Label 8501: @429729
     /* 429729 */ GIM_Reject,
     /* 429730 */ // Label 137: @429730
     /* 429730 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8510*/ GIMT_Encode4(430128),
     /* 429741 */ /*GILLT_v2s64*//*Label 8508*/ GIMT_Encode4(429753), GIMT_Encode4(0),
     /* 429749 */ /*GILLT_v4s32*//*Label 8509*/ GIMT_Encode4(429891),
     /* 429753 */ // Label 8508: @429753
     /* 429753 */ GIM_Try, /*On fail goto*//*Label 8511*/ GIMT_Encode4(429812), // Rule ID 5910 //
     /* 429758 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 429761 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429765 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429769 */   // (AArch64saddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (SADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 429769 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 429772 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i32v),
     /* 429776 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429781 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429785 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429787 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429790 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429792 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429795 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429798 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 429801 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429806 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429811 */   // GIR_Coverage, 5910,
     /* 429811 */   GIR_EraseRootFromParent_Done,
     /* 429812 */ // Label 8511: @429812
     /* 429812 */ GIM_Try, /*On fail goto*//*Label 8512*/ GIMT_Encode4(429890), // Rule ID 6032 //
     /* 429817 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 429820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429824 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429828 */   // (AArch64saddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (SADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 429828 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 429831 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::SADDLPv2i32_v1i64),
     /* 429835 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429840 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429844 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 429846 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 429849 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 429853 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429858 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429860 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 429863 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429865 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429868 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 429871 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 429874 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429879 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429884 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429889 */   // GIR_Coverage, 6032,
     /* 429889 */   GIR_EraseRootFromParent_Done,
     /* 429890 */ // Label 8512: @429890
     /* 429890 */ GIM_Reject,
     /* 429891 */ // Label 8509: @429891
     /* 429891 */ GIM_Try, /*On fail goto*//*Label 8513*/ GIMT_Encode4(429950), // Rule ID 5906 //
     /* 429896 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 429899 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429903 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429907 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 429907 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 429910 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i8v),
     /* 429914 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429919 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429923 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429925 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429928 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429930 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429933 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429936 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 429939 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429944 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 429949 */   // GIR_Coverage, 5906,
     /* 429949 */   GIR_EraseRootFromParent_Done,
     /* 429950 */ // Label 8513: @429950
     /* 429950 */ GIM_Try, /*On fail goto*//*Label 8514*/ GIMT_Encode4(430009), // Rule ID 5907 //
     /* 429955 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 429958 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 429962 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 429966 */   // (AArch64saddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 429966 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 429969 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv4i16v),
     /* 429973 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 429978 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 429982 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 429984 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 429987 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 429989 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 429992 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 429995 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 429998 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430008 */   // GIR_Coverage, 5907,
     /* 430008 */   GIR_EraseRootFromParent_Done,
     /* 430009 */ // Label 8514: @430009
     /* 430009 */ GIM_Try, /*On fail goto*//*Label 8515*/ GIMT_Encode4(430068), // Rule ID 5908 //
     /* 430014 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 430017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430025 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 430025 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 430028 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv16i8v),
     /* 430032 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430037 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430041 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430043 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430046 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430048 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430051 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430054 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 430057 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430062 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430067 */   // GIR_Coverage, 5908,
     /* 430067 */   GIR_EraseRootFromParent_Done,
     /* 430068 */ // Label 8515: @430068
     /* 430068 */ GIM_Try, /*On fail goto*//*Label 8516*/ GIMT_Encode4(430127), // Rule ID 5909 //
     /* 430073 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 430076 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430080 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430084 */   // (AArch64saddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (SADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 430084 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 430087 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::SADDLVv8i16v),
     /* 430091 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 430096 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 430100 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 430102 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 430105 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430107 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 430110 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 430113 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 430116 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430121 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430126 */   // GIR_Coverage, 5909,
     /* 430126 */   GIR_EraseRootFromParent_Done,
     /* 430127 */ // Label 8516: @430127
     /* 430127 */ GIM_Reject,
     /* 430128 */ // Label 8510: @430128
     /* 430128 */ GIM_Reject,
     /* 430129 */ // Label 138: @430129
     /* 430129 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8521*/ GIMT_Encode4(430498),
     /* 430140 */ /*GILLT_v2s32*//*Label 8517*/ GIMT_Encode4(430200), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430152 */ /*GILLT_v4s32*//*Label 8518*/ GIMT_Encode4(430320), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430184 */ /*GILLT_nxv2s64*//*Label 8519*/ GIMT_Encode4(430440), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 430196 */ /*GILLT_nxv4s32*//*Label 8520*/ GIMT_Encode4(430469),
     /* 430200 */ // Label 8517: @430200
     /* 430200 */ GIM_Try, /*On fail goto*//*Label 8522*/ GIMT_Encode4(430319),
     /* 430205 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430208 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 430211 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 430214 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430218 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430222 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430226 */   GIM_Try, /*On fail goto*//*Label 8523*/ GIMT_Encode4(430299), // Rule ID 26 //
     /* 430231 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430234 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 430238 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 430242 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430246 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430250 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430254 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430258 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430262 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430267 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430271 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430275 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430279 */     // MIs[3] Operand 1
     /* 430279 */     // No operand predicates
     /* 430279 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430281 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430281 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev8i8),
     /* 430284 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430286 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 430288 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430290 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430294 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430297 */     GIR_RootConstrainSelectedInstOperands,
     /* 430298 */     // GIR_Coverage, 26,
     /* 430298 */     GIR_EraseRootFromParent_Done,
     /* 430299 */   // Label 8523: @430299
     /* 430299 */   GIM_Try, /*On fail goto*//*Label 8524*/ GIMT_Encode4(430318), // Rule ID 22 //
     /* 430304 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430307 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430311 */     // (AArch64sdot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 430311 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv8i8),
     /* 430316 */     GIR_RootConstrainSelectedInstOperands,
     /* 430317 */     // GIR_Coverage, 22,
     /* 430317 */     GIR_Done,
     /* 430318 */   // Label 8524: @430318
     /* 430318 */   GIM_Reject,
     /* 430319 */ // Label 8522: @430319
     /* 430319 */ GIM_Reject,
     /* 430320 */ // Label 8518: @430320
     /* 430320 */ GIM_Try, /*On fail goto*//*Label 8525*/ GIMT_Encode4(430439),
     /* 430325 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430328 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 430331 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 430334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430346 */   GIM_Try, /*On fail goto*//*Label 8526*/ GIMT_Encode4(430419), // Rule ID 27 //
     /* 430351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 430358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 430362 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430366 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430370 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430374 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430378 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430382 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430387 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430391 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430395 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430399 */     // MIs[3] Operand 1
     /* 430399 */     // No operand predicates
     /* 430399 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430401 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (SDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430401 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SDOTlanev16i8),
     /* 430404 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 430406 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 430408 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430410 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430414 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430417 */     GIR_RootConstrainSelectedInstOperands,
     /* 430418 */     // GIR_Coverage, 27,
     /* 430418 */     GIR_EraseRootFromParent_Done,
     /* 430419 */   // Label 8526: @430419
     /* 430419 */   GIM_Try, /*On fail goto*//*Label 8527*/ GIMT_Encode4(430438), // Rule ID 23 //
     /* 430424 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 430427 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430431 */     // (AArch64sdot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (SDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 430431 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOTv16i8),
     /* 430436 */     GIR_RootConstrainSelectedInstOperands,
     /* 430437 */     // GIR_Coverage, 23,
     /* 430437 */     GIR_Done,
     /* 430438 */   // Label 8527: @430438
     /* 430438 */   GIM_Reject,
     /* 430439 */ // Label 8525: @430439
     /* 430439 */ GIM_Reject,
     /* 430440 */ // Label 8519: @430440
     /* 430440 */ GIM_Try, /*On fail goto*//*Label 8528*/ GIMT_Encode4(430468), // Rule ID 2982 //
     /* 430445 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430448 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 430451 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 430454 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 430457 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430461 */   // (AArch64sdot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (SDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 430461 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_D),
     /* 430466 */   GIR_RootConstrainSelectedInstOperands,
     /* 430467 */   // GIR_Coverage, 2982,
     /* 430467 */   GIR_Done,
     /* 430468 */ // Label 8528: @430468
     /* 430468 */ GIM_Reject,
     /* 430469 */ // Label 8520: @430469
     /* 430469 */ GIM_Try, /*On fail goto*//*Label 8529*/ GIMT_Encode4(430497), // Rule ID 2981 //
     /* 430474 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 430477 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 430480 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 430483 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 430486 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 430490 */   // (AArch64sdot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (SDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 430490 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SDOT_ZZZ_S),
     /* 430495 */   GIR_RootConstrainSelectedInstOperands,
     /* 430496 */   // GIR_Coverage, 2981,
     /* 430496 */   GIR_Done,
     /* 430497 */ // Label 8529: @430497
     /* 430497 */ GIM_Reject,
     /* 430498 */ // Label 8521: @430498
     /* 430498 */ GIM_Reject,
     /* 430499 */ // Label 139: @430499
     /* 430499 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8533*/ GIMT_Encode4(430615),
     /* 430510 */ /*GILLT_s16*//*Label 8530*/ GIMT_Encode4(430522),
     /* 430514 */ /*GILLT_s32*//*Label 8531*/ GIMT_Encode4(430553),
     /* 430518 */ /*GILLT_s64*//*Label 8532*/ GIMT_Encode4(430584),
     /* 430522 */ // Label 8530: @430522
     /* 430522 */ GIM_Try, /*On fail goto*//*Label 8534*/ GIMT_Encode4(430552), // Rule ID 1658 //
     /* 430527 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 430530 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 430533 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430537 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 430541 */   // (AArch64sitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (SCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 430541 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i16),
     /* 430546 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430550 */   GIR_RootConstrainSelectedInstOperands,
     /* 430551 */   // GIR_Coverage, 1658,
     /* 430551 */   GIR_Done,
     /* 430552 */ // Label 8534: @430552
     /* 430552 */ GIM_Reject,
     /* 430553 */ // Label 8531: @430553
     /* 430553 */ GIM_Try, /*On fail goto*//*Label 8535*/ GIMT_Encode4(430583), // Rule ID 1657 //
     /* 430558 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 430561 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 430564 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430568 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 430572 */   // (AArch64sitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (SCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 430572 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i32),
     /* 430577 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430581 */   GIR_RootConstrainSelectedInstOperands,
     /* 430582 */   // GIR_Coverage, 1657,
     /* 430582 */   GIR_Done,
     /* 430583 */ // Label 8535: @430583
     /* 430583 */ GIM_Reject,
     /* 430584 */ // Label 8532: @430584
     /* 430584 */ GIM_Try, /*On fail goto*//*Label 8536*/ GIMT_Encode4(430614), // Rule ID 1656 //
     /* 430589 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 430592 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 430595 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430599 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430603 */   // (AArch64sitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (SCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 430603 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SCVTFv1i64),
     /* 430608 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 430612 */   GIR_RootConstrainSelectedInstOperands,
     /* 430613 */   // GIR_Coverage, 1656,
     /* 430613 */   GIR_Done,
     /* 430614 */ // Label 8536: @430614
     /* 430614 */ GIM_Reject,
     /* 430615 */ // Label 8533: @430615
     /* 430615 */ GIM_Reject,
     /* 430616 */ // Label 140: @430616
     /* 430616 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8540*/ GIMT_Encode4(431848),
     /* 430627 */ /*GILLT_v2s64*//*Label 8537*/ GIMT_Encode4(430647), GIMT_Encode4(0),
     /* 430635 */ /*GILLT_v4s32*//*Label 8538*/ GIMT_Encode4(431208), GIMT_Encode4(0),
     /* 430643 */ /*GILLT_v8s16*//*Label 8539*/ GIMT_Encode4(431769),
     /* 430647 */ // Label 8537: @430647
     /* 430647 */ GIM_Try, /*On fail goto*//*Label 8541*/ GIMT_Encode4(431207),
     /* 430652 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 430655 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 430658 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430662 */   GIM_Try, /*On fail goto*//*Label 8542*/ GIMT_Encode4(430754), // Rule ID 2054 //
     /* 430667 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430670 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430674 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430678 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430682 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430686 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430690 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430694 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430698 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430703 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430707 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430711 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430715 */     // MIs[3] Operand 1
     /* 430715 */     // No operand predicates
     /* 430715 */     // MIs[1] Operand 2
     /* 430715 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 430726 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430728 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430735 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430735 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 430738 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430740 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430745 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430749 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430752 */     GIR_RootConstrainSelectedInstOperands,
     /* 430753 */     // GIR_Coverage, 2054,
     /* 430753 */     GIR_EraseRootFromParent_Done,
     /* 430754 */   // Label 8542: @430754
     /* 430754 */   GIM_Try, /*On fail goto*//*Label 8543*/ GIMT_Encode4(430846), // Rule ID 13580 //
     /* 430759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430762 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430766 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430770 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430774 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430778 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430782 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430786 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430790 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430795 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430799 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430803 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430807 */     // MIs[3] Operand 1
     /* 430807 */     // No operand predicates
     /* 430807 */     // MIs[1] Operand 2
     /* 430807 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 430818 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430820 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 430827 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (SMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430827 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_indexed),
     /* 430830 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430832 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 430837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430844 */     GIR_RootConstrainSelectedInstOperands,
     /* 430845 */     // GIR_Coverage, 13580,
     /* 430845 */     GIR_EraseRootFromParent_Done,
     /* 430846 */   // Label 8543: @430846
     /* 430846 */   GIM_Try, /*On fail goto*//*Label 8544*/ GIMT_Encode4(430932), // Rule ID 13578 //
     /* 430851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430854 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 430858 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430862 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430866 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430870 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430874 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430878 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430882 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430887 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430891 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430895 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430899 */     // MIs[3] Operand 1
     /* 430899 */     // No operand predicates
     /* 430899 */     // MIs[1] Operand 2
     /* 430899 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 430910 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 430916 */     // (AArch64smull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 430916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 430919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 430921 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 430923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 430927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 430930 */     GIR_RootConstrainSelectedInstOperands,
     /* 430931 */     // GIR_Coverage, 13578,
     /* 430931 */     GIR_EraseRootFromParent_Done,
     /* 430932 */   // Label 8544: @430932
     /* 430932 */   GIM_Try, /*On fail goto*//*Label 8545*/ GIMT_Encode4(431018), // Rule ID 2052 //
     /* 430937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 430940 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 430944 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 430948 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 430952 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430956 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 430960 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 430964 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 430968 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 430972 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 430977 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 430981 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 430985 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 430989 */     // MIs[3] Operand 1
     /* 430989 */     // No operand predicates
     /* 430989 */     // MIs[1] Operand 2
     /* 430989 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431000 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431002 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431002 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431005 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431007 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431009 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431013 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431016 */     GIR_RootConstrainSelectedInstOperands,
     /* 431017 */     // GIR_Coverage, 2052,
     /* 431017 */     GIR_EraseRootFromParent_Done,
     /* 431018 */   // Label 8545: @431018
     /* 431018 */   GIM_Try, /*On fail goto*//*Label 8546*/ GIMT_Encode4(431057), // Rule ID 1741 //
     /* 431023 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431026 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431033 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 431040 */     // (AArch64smull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (SMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 431040 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i32_v2i64),
     /* 431043 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431045 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431050 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431055 */     GIR_RootConstrainSelectedInstOperands,
     /* 431056 */     // GIR_Coverage, 1741,
     /* 431056 */     GIR_EraseRootFromParent_Done,
     /* 431057 */   // Label 8546: @431057
     /* 431057 */   GIM_Try, /*On fail goto*//*Label 8547*/ GIMT_Encode4(431120), // Rule ID 13579 //
     /* 431062 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431065 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431069 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431073 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431077 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431081 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431086 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431090 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431094 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431098 */     // MIs[2] Operand 1
     /* 431098 */     // No operand predicates
     /* 431098 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431102 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431104 */     // (AArch64smull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431104 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431107 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431109 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431111 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431115 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431118 */     GIR_RootConstrainSelectedInstOperands,
     /* 431119 */     // GIR_Coverage, 13579,
     /* 431119 */     GIR_EraseRootFromParent_Done,
     /* 431120 */   // Label 8547: @431120
     /* 431120 */   GIM_Try, /*On fail goto*//*Label 8548*/ GIMT_Encode4(431183), // Rule ID 2053 //
     /* 431125 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431128 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431132 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431136 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 431140 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 431144 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431148 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431153 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431157 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431161 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 431165 */     // MIs[2] Operand 1
     /* 431165 */     // No operand predicates
     /* 431165 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431167 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (SMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431167 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_indexed),
     /* 431170 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431172 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431174 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431178 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431181 */     GIR_RootConstrainSelectedInstOperands,
     /* 431182 */     // GIR_Coverage, 2053,
     /* 431182 */     GIR_EraseRootFromParent_Done,
     /* 431183 */   // Label 8548: @431183
     /* 431183 */   GIM_Try, /*On fail goto*//*Label 8549*/ GIMT_Encode4(431206), // Rule ID 1740 //
     /* 431188 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431191 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431195 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431199 */     // (AArch64smull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (SMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv2i32_v2i64),
     /* 431204 */     GIR_RootConstrainSelectedInstOperands,
     /* 431205 */     // GIR_Coverage, 1740,
     /* 431205 */     GIR_Done,
     /* 431206 */   // Label 8549: @431206
     /* 431206 */   GIM_Reject,
     /* 431207 */ // Label 8541: @431207
     /* 431207 */ GIM_Reject,
     /* 431208 */ // Label 8538: @431208
     /* 431208 */ GIM_Try, /*On fail goto*//*Label 8550*/ GIMT_Encode4(431768),
     /* 431213 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 431216 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 431219 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431223 */   GIM_Try, /*On fail goto*//*Label 8551*/ GIMT_Encode4(431315), // Rule ID 2051 //
     /* 431228 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431231 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431235 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431239 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431243 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431247 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431251 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431255 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431259 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431264 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431268 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431272 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431276 */     // MIs[3] Operand 1
     /* 431276 */     // No operand predicates
     /* 431276 */     // MIs[1] Operand 2
     /* 431276 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 431287 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431289 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431296 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431296 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 431299 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431301 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431306 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431310 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431313 */     GIR_RootConstrainSelectedInstOperands,
     /* 431314 */     // GIR_Coverage, 2051,
     /* 431314 */     GIR_EraseRootFromParent_Done,
     /* 431315 */   // Label 8551: @431315
     /* 431315 */   GIM_Try, /*On fail goto*//*Label 8552*/ GIMT_Encode4(431407), // Rule ID 13577 //
     /* 431320 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431323 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431327 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431331 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431335 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431339 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431343 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431347 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431351 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431356 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431360 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431364 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431368 */     // MIs[3] Operand 1
     /* 431368 */     // No operand predicates
     /* 431368 */     // MIs[1] Operand 2
     /* 431368 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 431379 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431381 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431388 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (SMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431388 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_indexed),
     /* 431391 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431393 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431398 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431402 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431405 */     GIR_RootConstrainSelectedInstOperands,
     /* 431406 */     // GIR_Coverage, 13577,
     /* 431406 */     GIR_EraseRootFromParent_Done,
     /* 431407 */   // Label 8552: @431407
     /* 431407 */   GIM_Try, /*On fail goto*//*Label 8553*/ GIMT_Encode4(431493), // Rule ID 13575 //
     /* 431412 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431415 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431419 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431423 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431427 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431431 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431435 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431439 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431443 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431448 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431452 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431456 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431460 */     // MIs[3] Operand 1
     /* 431460 */     // No operand predicates
     /* 431460 */     // MIs[1] Operand 2
     /* 431460 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431471 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431475 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431477 */     // (AArch64smull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431477 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431480 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431482 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431484 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431488 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431491 */     GIR_RootConstrainSelectedInstOperands,
     /* 431492 */     // GIR_Coverage, 13575,
     /* 431492 */     GIR_EraseRootFromParent_Done,
     /* 431493 */   // Label 8553: @431493
     /* 431493 */   GIM_Try, /*On fail goto*//*Label 8554*/ GIMT_Encode4(431579), // Rule ID 2049 //
     /* 431498 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431501 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431505 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431509 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 431513 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431517 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 431521 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431525 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431529 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 431533 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431538 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 431542 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431546 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431550 */     // MIs[3] Operand 1
     /* 431550 */     // No operand predicates
     /* 431550 */     // MIs[1] Operand 2
     /* 431550 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 431561 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 431563 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431563 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431566 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431568 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431570 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 431574 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 431577 */     GIR_RootConstrainSelectedInstOperands,
     /* 431578 */     // GIR_Coverage, 2049,
     /* 431578 */     GIR_EraseRootFromParent_Done,
     /* 431579 */   // Label 8554: @431579
     /* 431579 */   GIM_Try, /*On fail goto*//*Label 8555*/ GIMT_Encode4(431618), // Rule ID 1739 //
     /* 431584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431587 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431594 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 431601 */     // (AArch64smull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (SMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 431601 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i16_v4i32),
     /* 431604 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431606 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431611 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431616 */     GIR_RootConstrainSelectedInstOperands,
     /* 431617 */     // GIR_Coverage, 1739,
     /* 431617 */     GIR_EraseRootFromParent_Done,
     /* 431618 */   // Label 8555: @431618
     /* 431618 */   GIM_Try, /*On fail goto*//*Label 8556*/ GIMT_Encode4(431681), // Rule ID 13576 //
     /* 431623 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431626 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 431630 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431634 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431638 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431642 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431647 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431651 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431655 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431659 */     // MIs[2] Operand 1
     /* 431659 */     // No operand predicates
     /* 431659 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431663 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431665 */     // (AArch64smull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431665 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431668 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431670 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 431672 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431676 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431679 */     GIR_RootConstrainSelectedInstOperands,
     /* 431680 */     // GIR_Coverage, 13576,
     /* 431680 */     GIR_EraseRootFromParent_Done,
     /* 431681 */   // Label 8556: @431681
     /* 431681 */   GIM_Try, /*On fail goto*//*Label 8557*/ GIMT_Encode4(431744), // Rule ID 2050 //
     /* 431686 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431689 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431693 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 431697 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 431701 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 431705 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 431709 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 431714 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 431718 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 431722 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 431726 */     // MIs[2] Operand 1
     /* 431726 */     // No operand predicates
     /* 431726 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 431728 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (SMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 431728 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_indexed),
     /* 431731 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431733 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 431735 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 431739 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 431742 */     GIR_RootConstrainSelectedInstOperands,
     /* 431743 */     // GIR_Coverage, 2050,
     /* 431743 */     GIR_EraseRootFromParent_Done,
     /* 431744 */   // Label 8557: @431744
     /* 431744 */   GIM_Try, /*On fail goto*//*Label 8558*/ GIMT_Encode4(431767), // Rule ID 1738 //
     /* 431749 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431752 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431756 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431760 */     // (AArch64smull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (SMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 431760 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv4i16_v4i32),
     /* 431765 */     GIR_RootConstrainSelectedInstOperands,
     /* 431766 */     // GIR_Coverage, 1738,
     /* 431766 */     GIR_Done,
     /* 431767 */   // Label 8558: @431767
     /* 431767 */   GIM_Reject,
     /* 431768 */ // Label 8550: @431768
     /* 431768 */ GIM_Reject,
     /* 431769 */ // Label 8539: @431769
     /* 431769 */ GIM_Try, /*On fail goto*//*Label 8559*/ GIMT_Encode4(431847),
     /* 431774 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 431777 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 431780 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 431784 */   GIM_Try, /*On fail goto*//*Label 8560*/ GIMT_Encode4(431823), // Rule ID 1737 //
     /* 431789 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431792 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 431799 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 431806 */     // (AArch64smull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (SMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 431806 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SMULLv16i8_v8i16),
     /* 431809 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 431811 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 431816 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 431821 */     GIR_RootConstrainSelectedInstOperands,
     /* 431822 */     // GIR_Coverage, 1737,
     /* 431822 */     GIR_EraseRootFromParent_Done,
     /* 431823 */   // Label 8560: @431823
     /* 431823 */   GIM_Try, /*On fail goto*//*Label 8561*/ GIMT_Encode4(431846), // Rule ID 1736 //
     /* 431828 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431831 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431835 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431839 */     // (AArch64smull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (SMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 431839 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::SMULLv8i8_v8i16),
     /* 431844 */     GIR_RootConstrainSelectedInstOperands,
     /* 431845 */     // GIR_Coverage, 1736,
     /* 431845 */     GIR_Done,
     /* 431846 */   // Label 8561: @431846
     /* 431846 */   GIM_Reject,
     /* 431847 */ // Label 8559: @431847
     /* 431847 */ GIM_Reject,
     /* 431848 */ // Label 8540: @431848
     /* 431848 */ GIM_Reject,
     /* 431849 */ // Label 141: @431849
     /* 431849 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8580*/ GIMT_Encode4(432628),
     /* 431860 */ /*GILLT_v2s32*//*Label 8562*/ GIMT_Encode4(431936),
     /* 431864 */ /*GILLT_v2s64*//*Label 8563*/ GIMT_Encode4(431991),
     /* 431868 */ /*GILLT_v4s16*//*Label 8564*/ GIMT_Encode4(432046),
     /* 431872 */ /*GILLT_v4s32*//*Label 8565*/ GIMT_Encode4(432101),
     /* 431876 */ /*GILLT_v8s8*//*Label 8566*/ GIMT_Encode4(432156),
     /* 431880 */ /*GILLT_v8s16*//*Label 8567*/ GIMT_Encode4(432190),
     /* 431884 */ /*GILLT_v16s8*//*Label 8568*/ GIMT_Encode4(432245), GIMT_Encode4(0),
     /* 431892 */ /*GILLT_nxv2s1*//*Label 8569*/ GIMT_Encode4(432279),
     /* 431896 */ /*GILLT_nxv2s16*//*Label 8570*/ GIMT_Encode4(432305),
     /* 431900 */ /*GILLT_nxv2s32*//*Label 8571*/ GIMT_Encode4(432331),
     /* 431904 */ /*GILLT_nxv2s64*//*Label 8572*/ GIMT_Encode4(432357),
     /* 431908 */ /*GILLT_nxv4s1*//*Label 8573*/ GIMT_Encode4(432404),
     /* 431912 */ /*GILLT_nxv4s16*//*Label 8574*/ GIMT_Encode4(432430),
     /* 431916 */ /*GILLT_nxv4s32*//*Label 8575*/ GIMT_Encode4(432456),
     /* 431920 */ /*GILLT_nxv8s1*//*Label 8576*/ GIMT_Encode4(432503),
     /* 431924 */ /*GILLT_nxv8s16*//*Label 8577*/ GIMT_Encode4(432529),
     /* 431928 */ /*GILLT_nxv16s1*//*Label 8578*/ GIMT_Encode4(432576),
     /* 431932 */ /*GILLT_nxv16s8*//*Label 8579*/ GIMT_Encode4(432602),
     /* 431936 */ // Label 8562: @431936
     /* 431936 */ GIM_Try, /*On fail goto*//*Label 8581*/ GIMT_Encode4(431990),
     /* 431941 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 431944 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 431947 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431951 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431955 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 431959 */   GIM_Try, /*On fail goto*//*Label 8582*/ GIMT_Encode4(431974), // Rule ID 1874 //
     /* 431964 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431967 */     // (AArch64trn1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 431967 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 431972 */     GIR_RootConstrainSelectedInstOperands,
     /* 431973 */     // GIR_Coverage, 1874,
     /* 431973 */     GIR_Done,
     /* 431974 */   // Label 8582: @431974
     /* 431974 */   GIM_Try, /*On fail goto*//*Label 8583*/ GIMT_Encode4(431989), // Rule ID 2501 //
     /* 431979 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 431982 */     // (AArch64trn1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 431982 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i32),
     /* 431987 */     GIR_RootConstrainSelectedInstOperands,
     /* 431988 */     // GIR_Coverage, 2501,
     /* 431988 */     GIR_Done,
     /* 431989 */   // Label 8583: @431989
     /* 431989 */   GIM_Reject,
     /* 431990 */ // Label 8581: @431990
     /* 431990 */ GIM_Reject,
     /* 431991 */ // Label 8563: @431991
     /* 431991 */ GIM_Try, /*On fail goto*//*Label 8584*/ GIMT_Encode4(432045),
     /* 431996 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 431999 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 432002 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432006 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432010 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432014 */   GIM_Try, /*On fail goto*//*Label 8585*/ GIMT_Encode4(432029), // Rule ID 1876 //
     /* 432019 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432022 */     // (AArch64trn1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 432022 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 432027 */     GIR_RootConstrainSelectedInstOperands,
     /* 432028 */     // GIR_Coverage, 1876,
     /* 432028 */     GIR_Done,
     /* 432029 */   // Label 8585: @432029
     /* 432029 */   GIM_Try, /*On fail goto*//*Label 8586*/ GIMT_Encode4(432044), // Rule ID 2503 //
     /* 432034 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432037 */     // (AArch64trn1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 432037 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v2i64),
     /* 432042 */     GIR_RootConstrainSelectedInstOperands,
     /* 432043 */     // GIR_Coverage, 2503,
     /* 432043 */     GIR_Done,
     /* 432044 */   // Label 8586: @432044
     /* 432044 */   GIM_Reject,
     /* 432045 */ // Label 8584: @432045
     /* 432045 */ GIM_Reject,
     /* 432046 */ // Label 8564: @432046
     /* 432046 */ GIM_Try, /*On fail goto*//*Label 8587*/ GIMT_Encode4(432100),
     /* 432051 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432054 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432057 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432061 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432065 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432069 */   GIM_Try, /*On fail goto*//*Label 8588*/ GIMT_Encode4(432084), // Rule ID 1872 //
     /* 432074 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432077 */     // (AArch64trn1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432077 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 432082 */     GIR_RootConstrainSelectedInstOperands,
     /* 432083 */     // GIR_Coverage, 1872,
     /* 432083 */     GIR_Done,
     /* 432084 */   // Label 8588: @432084
     /* 432084 */   GIM_Try, /*On fail goto*//*Label 8589*/ GIMT_Encode4(432099), // Rule ID 2499 //
     /* 432089 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432092 */     // (AArch64trn1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 432092 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i16),
     /* 432097 */     GIR_RootConstrainSelectedInstOperands,
     /* 432098 */     // GIR_Coverage, 2499,
     /* 432098 */     GIR_Done,
     /* 432099 */   // Label 8589: @432099
     /* 432099 */   GIM_Reject,
     /* 432100 */ // Label 8587: @432100
     /* 432100 */ GIM_Reject,
     /* 432101 */ // Label 8565: @432101
     /* 432101 */ GIM_Try, /*On fail goto*//*Label 8590*/ GIMT_Encode4(432155),
     /* 432106 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432109 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 432112 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432116 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432120 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432124 */   GIM_Try, /*On fail goto*//*Label 8591*/ GIMT_Encode4(432139), // Rule ID 1875 //
     /* 432129 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432132 */     // (AArch64trn1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432132 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 432137 */     GIR_RootConstrainSelectedInstOperands,
     /* 432138 */     // GIR_Coverage, 1875,
     /* 432138 */     GIR_Done,
     /* 432139 */   // Label 8591: @432139
     /* 432139 */   GIM_Try, /*On fail goto*//*Label 8592*/ GIMT_Encode4(432154), // Rule ID 2502 //
     /* 432144 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432147 */     // (AArch64trn1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 432147 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v4i32),
     /* 432152 */     GIR_RootConstrainSelectedInstOperands,
     /* 432153 */     // GIR_Coverage, 2502,
     /* 432153 */     GIR_Done,
     /* 432154 */   // Label 8592: @432154
     /* 432154 */   GIM_Reject,
     /* 432155 */ // Label 8590: @432155
     /* 432155 */ GIM_Reject,
     /* 432156 */ // Label 8566: @432156
     /* 432156 */ GIM_Try, /*On fail goto*//*Label 8593*/ GIMT_Encode4(432189), // Rule ID 1870 //
     /* 432161 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432164 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432167 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432170 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432174 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432178 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432182 */   // (AArch64trn1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432182 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i8),
     /* 432187 */   GIR_RootConstrainSelectedInstOperands,
     /* 432188 */   // GIR_Coverage, 1870,
     /* 432188 */   GIR_Done,
     /* 432189 */ // Label 8593: @432189
     /* 432189 */ GIM_Reject,
     /* 432190 */ // Label 8567: @432190
     /* 432190 */ GIM_Try, /*On fail goto*//*Label 8594*/ GIMT_Encode4(432244),
     /* 432195 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432198 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432201 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432205 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432209 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432213 */   GIM_Try, /*On fail goto*//*Label 8595*/ GIMT_Encode4(432228), // Rule ID 1873 //
     /* 432218 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432221 */     // (AArch64trn1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 432221 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 432226 */     GIR_RootConstrainSelectedInstOperands,
     /* 432227 */     // GIR_Coverage, 1873,
     /* 432227 */     GIR_Done,
     /* 432228 */   // Label 8595: @432228
     /* 432228 */   GIM_Try, /*On fail goto*//*Label 8596*/ GIMT_Encode4(432243), // Rule ID 2500 //
     /* 432233 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432236 */     // (AArch64trn1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 432236 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v8i16),
     /* 432241 */     GIR_RootConstrainSelectedInstOperands,
     /* 432242 */     // GIR_Coverage, 2500,
     /* 432242 */     GIR_Done,
     /* 432243 */   // Label 8596: @432243
     /* 432243 */   GIM_Reject,
     /* 432244 */ // Label 8594: @432244
     /* 432244 */ GIM_Reject,
     /* 432245 */ // Label 8568: @432245
     /* 432245 */ GIM_Try, /*On fail goto*//*Label 8597*/ GIMT_Encode4(432278), // Rule ID 1871 //
     /* 432250 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432253 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 432256 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 432259 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432263 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432267 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432271 */   // (AArch64trn1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 432271 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1v16i8),
     /* 432276 */   GIR_RootConstrainSelectedInstOperands,
     /* 432277 */   // GIR_Coverage, 1871,
     /* 432277 */   GIR_Done,
     /* 432278 */ // Label 8597: @432278
     /* 432278 */ GIM_Reject,
     /* 432279 */ // Label 8569: @432279
     /* 432279 */ GIM_Try, /*On fail goto*//*Label 8598*/ GIMT_Encode4(432304), // Rule ID 9017 //
     /* 432284 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432287 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 432290 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 432293 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432297 */   // (AArch64trn1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 432297 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_D),
     /* 432302 */   GIR_RootConstrainSelectedInstOperands,
     /* 432303 */   // GIR_Coverage, 9017,
     /* 432303 */   GIR_Done,
     /* 432304 */ // Label 8598: @432304
     /* 432304 */ GIM_Reject,
     /* 432305 */ // Label 8570: @432305
     /* 432305 */ GIM_Try, /*On fail goto*//*Label 8599*/ GIMT_Encode4(432330), // Rule ID 8993 //
     /* 432310 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432313 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 432316 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 432319 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432323 */   // (AArch64trn1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 432323 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432328 */   GIR_RootConstrainSelectedInstOperands,
     /* 432329 */   // GIR_Coverage, 8993,
     /* 432329 */   GIR_Done,
     /* 432330 */ // Label 8599: @432330
     /* 432330 */ GIM_Reject,
     /* 432331 */ // Label 8571: @432331
     /* 432331 */ GIM_Try, /*On fail goto*//*Label 8600*/ GIMT_Encode4(432356), // Rule ID 8994 //
     /* 432336 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432339 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 432342 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 432345 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432349 */   // (AArch64trn1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 432349 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432354 */   GIR_RootConstrainSelectedInstOperands,
     /* 432355 */   // GIR_Coverage, 8994,
     /* 432355 */   GIR_Done,
     /* 432356 */ // Label 8600: @432356
     /* 432356 */ GIM_Reject,
     /* 432357 */ // Label 8572: @432357
     /* 432357 */ GIM_Try, /*On fail goto*//*Label 8601*/ GIMT_Encode4(432403),
     /* 432362 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 432365 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 432368 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432372 */   GIM_Try, /*On fail goto*//*Label 8602*/ GIMT_Encode4(432387), // Rule ID 8989 //
     /* 432377 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432380 */     // (AArch64trn1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 432380 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432385 */     GIR_RootConstrainSelectedInstOperands,
     /* 432386 */     // GIR_Coverage, 8989,
     /* 432386 */     GIR_Done,
     /* 432387 */   // Label 8602: @432387
     /* 432387 */   GIM_Try, /*On fail goto*//*Label 8603*/ GIMT_Encode4(432402), // Rule ID 8995 //
     /* 432392 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432395 */     // (AArch64trn1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 432395 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_D),
     /* 432400 */     GIR_RootConstrainSelectedInstOperands,
     /* 432401 */     // GIR_Coverage, 8995,
     /* 432401 */     GIR_Done,
     /* 432402 */   // Label 8603: @432402
     /* 432402 */   GIM_Reject,
     /* 432403 */ // Label 8601: @432403
     /* 432403 */ GIM_Reject,
     /* 432404 */ // Label 8573: @432404
     /* 432404 */ GIM_Try, /*On fail goto*//*Label 8604*/ GIMT_Encode4(432429), // Rule ID 9016 //
     /* 432409 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432412 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 432415 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 432418 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432422 */   // (AArch64trn1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 432422 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_S),
     /* 432427 */   GIR_RootConstrainSelectedInstOperands,
     /* 432428 */   // GIR_Coverage, 9016,
     /* 432428 */   GIR_Done,
     /* 432429 */ // Label 8604: @432429
     /* 432429 */ GIM_Reject,
     /* 432430 */ // Label 8574: @432430
     /* 432430 */ GIM_Try, /*On fail goto*//*Label 8605*/ GIMT_Encode4(432455), // Rule ID 8991 //
     /* 432435 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432438 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 432441 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 432444 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432448 */   // (AArch64trn1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 432448 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432453 */   GIR_RootConstrainSelectedInstOperands,
     /* 432454 */   // GIR_Coverage, 8991,
     /* 432454 */   GIR_Done,
     /* 432455 */ // Label 8605: @432455
     /* 432455 */ GIM_Reject,
     /* 432456 */ // Label 8575: @432456
     /* 432456 */ GIM_Try, /*On fail goto*//*Label 8606*/ GIMT_Encode4(432502),
     /* 432461 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 432464 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 432467 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432471 */   GIM_Try, /*On fail goto*//*Label 8607*/ GIMT_Encode4(432486), // Rule ID 8988 //
     /* 432476 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432479 */     // (AArch64trn1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 432479 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432484 */     GIR_RootConstrainSelectedInstOperands,
     /* 432485 */     // GIR_Coverage, 8988,
     /* 432485 */     GIR_Done,
     /* 432486 */   // Label 8607: @432486
     /* 432486 */   GIM_Try, /*On fail goto*//*Label 8608*/ GIMT_Encode4(432501), // Rule ID 8992 //
     /* 432491 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432494 */     // (AArch64trn1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 432494 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_S),
     /* 432499 */     GIR_RootConstrainSelectedInstOperands,
     /* 432500 */     // GIR_Coverage, 8992,
     /* 432500 */     GIR_Done,
     /* 432501 */   // Label 8608: @432501
     /* 432501 */   GIM_Reject,
     /* 432502 */ // Label 8606: @432502
     /* 432502 */ GIM_Reject,
     /* 432503 */ // Label 8576: @432503
     /* 432503 */ GIM_Try, /*On fail goto*//*Label 8609*/ GIMT_Encode4(432528), // Rule ID 9015 //
     /* 432508 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432511 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 432514 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 432517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432521 */   // (AArch64trn1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 432521 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_H),
     /* 432526 */   GIR_RootConstrainSelectedInstOperands,
     /* 432527 */   // GIR_Coverage, 9015,
     /* 432527 */   GIR_Done,
     /* 432528 */ // Label 8609: @432528
     /* 432528 */ GIM_Reject,
     /* 432529 */ // Label 8577: @432529
     /* 432529 */ GIM_Try, /*On fail goto*//*Label 8610*/ GIMT_Encode4(432575),
     /* 432534 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 432537 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 432540 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432544 */   GIM_Try, /*On fail goto*//*Label 8611*/ GIMT_Encode4(432559), // Rule ID 8987 //
     /* 432549 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432552 */     // (AArch64trn1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 432552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 432557 */     GIR_RootConstrainSelectedInstOperands,
     /* 432558 */     // GIR_Coverage, 8987,
     /* 432558 */     GIR_Done,
     /* 432559 */   // Label 8611: @432559
     /* 432559 */   GIM_Try, /*On fail goto*//*Label 8612*/ GIMT_Encode4(432574), // Rule ID 8990 //
     /* 432564 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432567 */     // (AArch64trn1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 432567 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_H),
     /* 432572 */     GIR_RootConstrainSelectedInstOperands,
     /* 432573 */     // GIR_Coverage, 8990,
     /* 432573 */     GIR_Done,
     /* 432574 */   // Label 8612: @432574
     /* 432574 */   GIM_Reject,
     /* 432575 */ // Label 8610: @432575
     /* 432575 */ GIM_Reject,
     /* 432576 */ // Label 8578: @432576
     /* 432576 */ GIM_Try, /*On fail goto*//*Label 8613*/ GIMT_Encode4(432601), // Rule ID 2414 //
     /* 432581 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432584 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 432587 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 432590 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 432594 */   // (AArch64trn1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 432594 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_PPP_B),
     /* 432599 */   GIR_RootConstrainSelectedInstOperands,
     /* 432600 */   // GIR_Coverage, 2414,
     /* 432600 */   GIR_Done,
     /* 432601 */ // Label 8613: @432601
     /* 432601 */ GIM_Reject,
     /* 432602 */ // Label 8579: @432602
     /* 432602 */ GIM_Try, /*On fail goto*//*Label 8614*/ GIMT_Encode4(432627), // Rule ID 8986 //
     /* 432607 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 432610 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 432613 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 432616 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 432620 */   // (AArch64trn1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 432620 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN1_ZZZ_B),
     /* 432625 */   GIR_RootConstrainSelectedInstOperands,
     /* 432626 */   // GIR_Coverage, 8986,
     /* 432626 */   GIR_Done,
     /* 432627 */ // Label 8614: @432627
     /* 432627 */ GIM_Reject,
     /* 432628 */ // Label 8580: @432628
     /* 432628 */ GIM_Reject,
     /* 432629 */ // Label 142: @432629
     /* 432629 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8633*/ GIMT_Encode4(433408),
     /* 432640 */ /*GILLT_v2s32*//*Label 8615*/ GIMT_Encode4(432716),
     /* 432644 */ /*GILLT_v2s64*//*Label 8616*/ GIMT_Encode4(432771),
     /* 432648 */ /*GILLT_v4s16*//*Label 8617*/ GIMT_Encode4(432826),
     /* 432652 */ /*GILLT_v4s32*//*Label 8618*/ GIMT_Encode4(432881),
     /* 432656 */ /*GILLT_v8s8*//*Label 8619*/ GIMT_Encode4(432936),
     /* 432660 */ /*GILLT_v8s16*//*Label 8620*/ GIMT_Encode4(432970),
     /* 432664 */ /*GILLT_v16s8*//*Label 8621*/ GIMT_Encode4(433025), GIMT_Encode4(0),
     /* 432672 */ /*GILLT_nxv2s1*//*Label 8622*/ GIMT_Encode4(433059),
     /* 432676 */ /*GILLT_nxv2s16*//*Label 8623*/ GIMT_Encode4(433085),
     /* 432680 */ /*GILLT_nxv2s32*//*Label 8624*/ GIMT_Encode4(433111),
     /* 432684 */ /*GILLT_nxv2s64*//*Label 8625*/ GIMT_Encode4(433137),
     /* 432688 */ /*GILLT_nxv4s1*//*Label 8626*/ GIMT_Encode4(433184),
     /* 432692 */ /*GILLT_nxv4s16*//*Label 8627*/ GIMT_Encode4(433210),
     /* 432696 */ /*GILLT_nxv4s32*//*Label 8628*/ GIMT_Encode4(433236),
     /* 432700 */ /*GILLT_nxv8s1*//*Label 8629*/ GIMT_Encode4(433283),
     /* 432704 */ /*GILLT_nxv8s16*//*Label 8630*/ GIMT_Encode4(433309),
     /* 432708 */ /*GILLT_nxv16s1*//*Label 8631*/ GIMT_Encode4(433356),
     /* 432712 */ /*GILLT_nxv16s8*//*Label 8632*/ GIMT_Encode4(433382),
     /* 432716 */ // Label 8615: @432716
     /* 432716 */ GIM_Try, /*On fail goto*//*Label 8634*/ GIMT_Encode4(432770),
     /* 432721 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 432724 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 432727 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432731 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432735 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432739 */   GIM_Try, /*On fail goto*//*Label 8635*/ GIMT_Encode4(432754), // Rule ID 1881 //
     /* 432744 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432747 */     // (AArch64trn2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 432747 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 432752 */     GIR_RootConstrainSelectedInstOperands,
     /* 432753 */     // GIR_Coverage, 1881,
     /* 432753 */     GIR_Done,
     /* 432754 */   // Label 8635: @432754
     /* 432754 */   GIM_Try, /*On fail goto*//*Label 8636*/ GIMT_Encode4(432769), // Rule ID 5483 //
     /* 432759 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432762 */     // (AArch64trn2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (TRN2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 432762 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i32),
     /* 432767 */     GIR_RootConstrainSelectedInstOperands,
     /* 432768 */     // GIR_Coverage, 5483,
     /* 432768 */     GIR_Done,
     /* 432769 */   // Label 8636: @432769
     /* 432769 */   GIM_Reject,
     /* 432770 */ // Label 8634: @432770
     /* 432770 */ GIM_Reject,
     /* 432771 */ // Label 8616: @432771
     /* 432771 */ GIM_Try, /*On fail goto*//*Label 8637*/ GIMT_Encode4(432825),
     /* 432776 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 432779 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 432782 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432786 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432790 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432794 */   GIM_Try, /*On fail goto*//*Label 8638*/ GIMT_Encode4(432809), // Rule ID 1883 //
     /* 432799 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432802 */     // (AArch64trn2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 432802 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 432807 */     GIR_RootConstrainSelectedInstOperands,
     /* 432808 */     // GIR_Coverage, 1883,
     /* 432808 */     GIR_Done,
     /* 432809 */   // Label 8638: @432809
     /* 432809 */   GIM_Try, /*On fail goto*//*Label 8639*/ GIMT_Encode4(432824), // Rule ID 5485 //
     /* 432814 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432817 */     // (AArch64trn2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (TRN2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 432817 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v2i64),
     /* 432822 */     GIR_RootConstrainSelectedInstOperands,
     /* 432823 */     // GIR_Coverage, 5485,
     /* 432823 */     GIR_Done,
     /* 432824 */   // Label 8639: @432824
     /* 432824 */   GIM_Reject,
     /* 432825 */ // Label 8637: @432825
     /* 432825 */ GIM_Reject,
     /* 432826 */ // Label 8617: @432826
     /* 432826 */ GIM_Try, /*On fail goto*//*Label 8640*/ GIMT_Encode4(432880),
     /* 432831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 432834 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 432837 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432841 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432845 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432849 */   GIM_Try, /*On fail goto*//*Label 8641*/ GIMT_Encode4(432864), // Rule ID 1879 //
     /* 432854 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432857 */     // (AArch64trn2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 432857 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432862 */     GIR_RootConstrainSelectedInstOperands,
     /* 432863 */     // GIR_Coverage, 1879,
     /* 432863 */     GIR_Done,
     /* 432864 */   // Label 8641: @432864
     /* 432864 */   GIM_Try, /*On fail goto*//*Label 8642*/ GIMT_Encode4(432879), // Rule ID 5481 //
     /* 432869 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432872 */     // (AArch64trn2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (TRN2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 432872 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i16),
     /* 432877 */     GIR_RootConstrainSelectedInstOperands,
     /* 432878 */     // GIR_Coverage, 5481,
     /* 432878 */     GIR_Done,
     /* 432879 */   // Label 8642: @432879
     /* 432879 */   GIM_Reject,
     /* 432880 */ // Label 8640: @432880
     /* 432880 */ GIM_Reject,
     /* 432881 */ // Label 8618: @432881
     /* 432881 */ GIM_Try, /*On fail goto*//*Label 8643*/ GIMT_Encode4(432935),
     /* 432886 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 432889 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 432892 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432896 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432900 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432904 */   GIM_Try, /*On fail goto*//*Label 8644*/ GIMT_Encode4(432919), // Rule ID 1882 //
     /* 432909 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432912 */     // (AArch64trn2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 432912 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 432917 */     GIR_RootConstrainSelectedInstOperands,
     /* 432918 */     // GIR_Coverage, 1882,
     /* 432918 */     GIR_Done,
     /* 432919 */   // Label 8644: @432919
     /* 432919 */   GIM_Try, /*On fail goto*//*Label 8645*/ GIMT_Encode4(432934), // Rule ID 5484 //
     /* 432924 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432927 */     // (AArch64trn2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (TRN2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 432927 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v4i32),
     /* 432932 */     GIR_RootConstrainSelectedInstOperands,
     /* 432933 */     // GIR_Coverage, 5484,
     /* 432933 */     GIR_Done,
     /* 432934 */   // Label 8645: @432934
     /* 432934 */   GIM_Reject,
     /* 432935 */ // Label 8643: @432935
     /* 432935 */ GIM_Reject,
     /* 432936 */ // Label 8619: @432936
     /* 432936 */ GIM_Try, /*On fail goto*//*Label 8646*/ GIMT_Encode4(432969), // Rule ID 1877 //
     /* 432941 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 432944 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 432947 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 432950 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432954 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432958 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 432962 */   // (AArch64trn2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (TRN2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 432962 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i8),
     /* 432967 */   GIR_RootConstrainSelectedInstOperands,
     /* 432968 */   // GIR_Coverage, 1877,
     /* 432968 */   GIR_Done,
     /* 432969 */ // Label 8646: @432969
     /* 432969 */ GIM_Reject,
     /* 432970 */ // Label 8620: @432970
     /* 432970 */ GIM_Try, /*On fail goto*//*Label 8647*/ GIMT_Encode4(433024),
     /* 432975 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 432978 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 432981 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432985 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432989 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 432993 */   GIM_Try, /*On fail goto*//*Label 8648*/ GIMT_Encode4(433008), // Rule ID 1880 //
     /* 432998 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433001 */     // (AArch64trn2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 433001 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 433006 */     GIR_RootConstrainSelectedInstOperands,
     /* 433007 */     // GIR_Coverage, 1880,
     /* 433007 */     GIR_Done,
     /* 433008 */   // Label 8648: @433008
     /* 433008 */   GIM_Try, /*On fail goto*//*Label 8649*/ GIMT_Encode4(433023), // Rule ID 5482 //
     /* 433013 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433016 */     // (AArch64trn2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (TRN2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 433016 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v8i16),
     /* 433021 */     GIR_RootConstrainSelectedInstOperands,
     /* 433022 */     // GIR_Coverage, 5482,
     /* 433022 */     GIR_Done,
     /* 433023 */   // Label 8649: @433023
     /* 433023 */   GIM_Reject,
     /* 433024 */ // Label 8647: @433024
     /* 433024 */ GIM_Reject,
     /* 433025 */ // Label 8621: @433025
     /* 433025 */ GIM_Try, /*On fail goto*//*Label 8650*/ GIMT_Encode4(433058), // Rule ID 1878 //
     /* 433030 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433033 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433036 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433039 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433043 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433047 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433051 */   // (AArch64trn2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (TRN2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 433051 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2v16i8),
     /* 433056 */   GIR_RootConstrainSelectedInstOperands,
     /* 433057 */   // GIR_Coverage, 1878,
     /* 433057 */   GIR_Done,
     /* 433058 */ // Label 8650: @433058
     /* 433058 */ GIM_Reject,
     /* 433059 */ // Label 8622: @433059
     /* 433059 */ GIM_Try, /*On fail goto*//*Label 8651*/ GIMT_Encode4(433084), // Rule ID 9020 //
     /* 433064 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433067 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 433070 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 433073 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433077 */   // (AArch64trn2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (TRN2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 433077 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_D),
     /* 433082 */   GIR_RootConstrainSelectedInstOperands,
     /* 433083 */   // GIR_Coverage, 9020,
     /* 433083 */   GIR_Done,
     /* 433084 */ // Label 8651: @433084
     /* 433084 */ GIM_Reject,
     /* 433085 */ // Label 8623: @433085
     /* 433085 */ GIM_Try, /*On fail goto*//*Label 8652*/ GIMT_Encode4(433110), // Rule ID 9003 //
     /* 433090 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433093 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 433096 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 433099 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433103 */   // (AArch64trn2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 433103 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433108 */   GIR_RootConstrainSelectedInstOperands,
     /* 433109 */   // GIR_Coverage, 9003,
     /* 433109 */   GIR_Done,
     /* 433110 */ // Label 8652: @433110
     /* 433110 */ GIM_Reject,
     /* 433111 */ // Label 8624: @433111
     /* 433111 */ GIM_Try, /*On fail goto*//*Label 8653*/ GIMT_Encode4(433136), // Rule ID 9004 //
     /* 433116 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433119 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 433122 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 433125 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433129 */   // (AArch64trn2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 433129 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433134 */   GIR_RootConstrainSelectedInstOperands,
     /* 433135 */   // GIR_Coverage, 9004,
     /* 433135 */   GIR_Done,
     /* 433136 */ // Label 8653: @433136
     /* 433136 */ GIM_Reject,
     /* 433137 */ // Label 8625: @433137
     /* 433137 */ GIM_Try, /*On fail goto*//*Label 8654*/ GIMT_Encode4(433183),
     /* 433142 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 433145 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 433148 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433152 */   GIM_Try, /*On fail goto*//*Label 8655*/ GIMT_Encode4(433167), // Rule ID 8999 //
     /* 433157 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433160 */     // (AArch64trn2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 433160 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433165 */     GIR_RootConstrainSelectedInstOperands,
     /* 433166 */     // GIR_Coverage, 8999,
     /* 433166 */     GIR_Done,
     /* 433167 */   // Label 8655: @433167
     /* 433167 */   GIM_Try, /*On fail goto*//*Label 8656*/ GIMT_Encode4(433182), // Rule ID 9005 //
     /* 433172 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433175 */     // (AArch64trn2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (TRN2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 433175 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_D),
     /* 433180 */     GIR_RootConstrainSelectedInstOperands,
     /* 433181 */     // GIR_Coverage, 9005,
     /* 433181 */     GIR_Done,
     /* 433182 */   // Label 8656: @433182
     /* 433182 */   GIM_Reject,
     /* 433183 */ // Label 8654: @433183
     /* 433183 */ GIM_Reject,
     /* 433184 */ // Label 8626: @433184
     /* 433184 */ GIM_Try, /*On fail goto*//*Label 8657*/ GIMT_Encode4(433209), // Rule ID 9019 //
     /* 433189 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433192 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 433195 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 433198 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433202 */   // (AArch64trn2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (TRN2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 433202 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_S),
     /* 433207 */   GIR_RootConstrainSelectedInstOperands,
     /* 433208 */   // GIR_Coverage, 9019,
     /* 433208 */   GIR_Done,
     /* 433209 */ // Label 8657: @433209
     /* 433209 */ GIM_Reject,
     /* 433210 */ // Label 8627: @433210
     /* 433210 */ GIM_Try, /*On fail goto*//*Label 8658*/ GIMT_Encode4(433235), // Rule ID 9001 //
     /* 433215 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433218 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 433221 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 433224 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433228 */   // (AArch64trn2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 433228 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433233 */   GIR_RootConstrainSelectedInstOperands,
     /* 433234 */   // GIR_Coverage, 9001,
     /* 433234 */   GIR_Done,
     /* 433235 */ // Label 8658: @433235
     /* 433235 */ GIM_Reject,
     /* 433236 */ // Label 8628: @433236
     /* 433236 */ GIM_Try, /*On fail goto*//*Label 8659*/ GIMT_Encode4(433282),
     /* 433241 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 433244 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 433247 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433251 */   GIM_Try, /*On fail goto*//*Label 8660*/ GIMT_Encode4(433266), // Rule ID 8998 //
     /* 433256 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433259 */     // (AArch64trn2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 433259 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433264 */     GIR_RootConstrainSelectedInstOperands,
     /* 433265 */     // GIR_Coverage, 8998,
     /* 433265 */     GIR_Done,
     /* 433266 */   // Label 8660: @433266
     /* 433266 */   GIM_Try, /*On fail goto*//*Label 8661*/ GIMT_Encode4(433281), // Rule ID 9002 //
     /* 433271 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433274 */     // (AArch64trn2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (TRN2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 433274 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_S),
     /* 433279 */     GIR_RootConstrainSelectedInstOperands,
     /* 433280 */     // GIR_Coverage, 9002,
     /* 433280 */     GIR_Done,
     /* 433281 */   // Label 8661: @433281
     /* 433281 */   GIM_Reject,
     /* 433282 */ // Label 8659: @433282
     /* 433282 */ GIM_Reject,
     /* 433283 */ // Label 8629: @433283
     /* 433283 */ GIM_Try, /*On fail goto*//*Label 8662*/ GIMT_Encode4(433308), // Rule ID 9018 //
     /* 433288 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433291 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 433294 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 433297 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433301 */   // (AArch64trn2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (TRN2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 433301 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_H),
     /* 433306 */   GIR_RootConstrainSelectedInstOperands,
     /* 433307 */   // GIR_Coverage, 9018,
     /* 433307 */   GIR_Done,
     /* 433308 */ // Label 8662: @433308
     /* 433308 */ GIM_Reject,
     /* 433309 */ // Label 8630: @433309
     /* 433309 */ GIM_Try, /*On fail goto*//*Label 8663*/ GIMT_Encode4(433355),
     /* 433314 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 433317 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 433320 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433324 */   GIM_Try, /*On fail goto*//*Label 8664*/ GIMT_Encode4(433339), // Rule ID 8997 //
     /* 433329 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433332 */     // (AArch64trn2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 433332 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 433337 */     GIR_RootConstrainSelectedInstOperands,
     /* 433338 */     // GIR_Coverage, 8997,
     /* 433338 */     GIR_Done,
     /* 433339 */   // Label 8664: @433339
     /* 433339 */   GIM_Try, /*On fail goto*//*Label 8665*/ GIMT_Encode4(433354), // Rule ID 9000 //
     /* 433344 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433347 */     // (AArch64trn2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (TRN2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 433347 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_H),
     /* 433352 */     GIR_RootConstrainSelectedInstOperands,
     /* 433353 */     // GIR_Coverage, 9000,
     /* 433353 */     GIR_Done,
     /* 433354 */   // Label 8665: @433354
     /* 433354 */   GIM_Reject,
     /* 433355 */ // Label 8663: @433355
     /* 433355 */ GIM_Reject,
     /* 433356 */ // Label 8631: @433356
     /* 433356 */ GIM_Try, /*On fail goto*//*Label 8666*/ GIMT_Encode4(433381), // Rule ID 2418 //
     /* 433361 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433364 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 433367 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 433370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 433374 */   // (AArch64trn2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (TRN2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 433374 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_PPP_B),
     /* 433379 */   GIR_RootConstrainSelectedInstOperands,
     /* 433380 */   // GIR_Coverage, 2418,
     /* 433380 */   GIR_Done,
     /* 433381 */ // Label 8666: @433381
     /* 433381 */ GIM_Reject,
     /* 433382 */ // Label 8632: @433382
     /* 433382 */ GIM_Try, /*On fail goto*//*Label 8667*/ GIMT_Encode4(433407), // Rule ID 8996 //
     /* 433387 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 433390 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 433393 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 433396 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 433400 */   // (AArch64trn2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (TRN2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 433400 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::TRN2_ZZZ_B),
     /* 433405 */   GIR_RootConstrainSelectedInstOperands,
     /* 433406 */   // GIR_Coverage, 8996,
     /* 433406 */   GIR_Done,
     /* 433407 */ // Label 8667: @433407
     /* 433407 */ GIM_Reject,
     /* 433408 */ // Label 8633: @433408
     /* 433408 */ GIM_Reject,
     /* 433409 */ // Label 143: @433409
     /* 433409 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(11), /*)*//*default:*//*Label 8674*/ GIMT_Encode4(433614),
     /* 433420 */ /*GILLT_s64*//*Label 8668*/ GIMT_Encode4(433452), GIMT_Encode4(0),
     /* 433428 */ /*GILLT_v2s32*//*Label 8669*/ GIMT_Encode4(433479),
     /* 433432 */ /*GILLT_v2s64*//*Label 8670*/ GIMT_Encode4(433506),
     /* 433436 */ /*GILLT_v4s16*//*Label 8671*/ GIMT_Encode4(433533),
     /* 433440 */ /*GILLT_v4s32*//*Label 8672*/ GIMT_Encode4(433560), GIMT_Encode4(0),
     /* 433448 */ /*GILLT_v8s16*//*Label 8673*/ GIMT_Encode4(433587),
     /* 433452 */ // Label 8668: @433452
     /* 433452 */ GIM_Try, /*On fail goto*//*Label 8675*/ GIMT_Encode4(433478), // Rule ID 1069 //
     /* 433457 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433460 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433467 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433471 */   // (AArch64uaddlp_n:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)  =>  (UADDLPv2i32_v1i64:{ *:[v1i64] } V64:{ *:[v2i32] }:$Rn)
     /* 433471 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 433476 */   GIR_RootConstrainSelectedInstOperands,
     /* 433477 */   // GIR_Coverage, 1069,
     /* 433477 */   GIR_Done,
     /* 433478 */ // Label 8675: @433478
     /* 433478 */ GIM_Reject,
     /* 433479 */ // Label 8669: @433479
     /* 433479 */ GIM_Try, /*On fail goto*//*Label 8676*/ GIMT_Encode4(433505), // Rule ID 1065 //
     /* 433484 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433487 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 433490 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433494 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433498 */   // (AArch64uaddlp_n:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)  =>  (UADDLPv4i16_v2i32:{ *:[v2i32] } V64:{ *:[v4i16] }:$Rn)
     /* 433498 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i16_v2i32),
     /* 433503 */   GIR_RootConstrainSelectedInstOperands,
     /* 433504 */   // GIR_Coverage, 1065,
     /* 433504 */   GIR_Done,
     /* 433505 */ // Label 8676: @433505
     /* 433505 */ GIM_Reject,
     /* 433506 */ // Label 8670: @433506
     /* 433506 */ GIM_Try, /*On fail goto*//*Label 8677*/ GIMT_Encode4(433532), // Rule ID 1071 //
     /* 433511 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433514 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433517 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433521 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433525 */   // (AArch64uaddlp_n:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (UADDLPv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)
     /* 433525 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv4i32_v2i64),
     /* 433530 */   GIR_RootConstrainSelectedInstOperands,
     /* 433531 */   // GIR_Coverage, 1071,
     /* 433531 */   GIR_Done,
     /* 433532 */ // Label 8677: @433532
     /* 433532 */ GIM_Reject,
     /* 433533 */ // Label 8671: @433533
     /* 433533 */ GIM_Try, /*On fail goto*//*Label 8678*/ GIMT_Encode4(433559), // Rule ID 1061 //
     /* 433538 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433541 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 433544 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433548 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433552 */   // (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)  =>  (UADDLPv8i8_v4i16:{ *:[v4i16] } V64:{ *:[v8i8] }:$Rn)
     /* 433552 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i8_v4i16),
     /* 433557 */   GIR_RootConstrainSelectedInstOperands,
     /* 433558 */   // GIR_Coverage, 1061,
     /* 433558 */   GIR_Done,
     /* 433559 */ // Label 8678: @433559
     /* 433559 */ GIM_Reject,
     /* 433560 */ // Label 8672: @433560
     /* 433560 */ GIM_Try, /*On fail goto*//*Label 8679*/ GIMT_Encode4(433586), // Rule ID 1067 //
     /* 433565 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433568 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433571 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433575 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433579 */   // (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (UADDLPv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)
     /* 433579 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv8i16_v4i32),
     /* 433584 */   GIR_RootConstrainSelectedInstOperands,
     /* 433585 */   // GIR_Coverage, 1067,
     /* 433585 */   GIR_Done,
     /* 433586 */ // Label 8679: @433586
     /* 433586 */ GIM_Reject,
     /* 433587 */ // Label 8673: @433587
     /* 433587 */ GIM_Try, /*On fail goto*//*Label 8680*/ GIMT_Encode4(433613), // Rule ID 1063 //
     /* 433592 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 433595 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 433598 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433602 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433606 */   // (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)  =>  (UADDLPv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn)
     /* 433606 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv16i8_v8i16),
     /* 433611 */   GIR_RootConstrainSelectedInstOperands,
     /* 433612 */   // GIR_Coverage, 1063,
     /* 433612 */   GIR_Done,
     /* 433613 */ // Label 8680: @433613
     /* 433613 */ GIM_Reject,
     /* 433614 */ // Label 8674: @433614
     /* 433614 */ GIM_Reject,
     /* 433615 */ // Label 144: @433615
     /* 433615 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(9), /*)*//*default:*//*Label 8683*/ GIMT_Encode4(434481),
     /* 433626 */ /*GILLT_v2s64*//*Label 8681*/ GIMT_Encode4(433638), GIMT_Encode4(0),
     /* 433634 */ /*GILLT_v4s32*//*Label 8682*/ GIMT_Encode4(433932),
     /* 433638 */ // Label 8681: @433638
     /* 433638 */ GIM_Try, /*On fail goto*//*Label 8684*/ GIMT_Encode4(433720), // Rule ID 5896 //
     /* 433643 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433650 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433654 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 433658 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 433661 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 433666 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 433670 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433675 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433677 */   // (AArch64uaddlv:{ *:[v2i64] } (intrinsic_wo_chain:{ *:[v4i32] } 732:{ *:[iPTR] }, V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 433677 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433680 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433684 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433689 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433693 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433695 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433698 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433700 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433703 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433706 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433709 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433714 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433719 */   // GIR_Coverage, 5896,
     /* 433719 */   GIR_EraseRootFromParent_Done,
     /* 433720 */ // Label 8684: @433720
     /* 433720 */ GIM_Try, /*On fail goto*//*Label 8685*/ GIMT_Encode4(433794), // Rule ID 5895 //
     /* 433725 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433728 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433732 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433736 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 433740 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433744 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433749 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433751 */   // (AArch64uaddlv:{ *:[v2i64] } (AArch64uaddlp_n:{ *:[v4i32] } V128:{ *:[v8i16] }:$op))  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$op), ssub:{ *:[i32] })
     /* 433751 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 433754 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 433758 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433763 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 433767 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433769 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433772 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433774 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433777 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433780 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 433783 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433788 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 433793 */   // GIR_Coverage, 5895,
     /* 433793 */   GIR_EraseRootFromParent_Done,
     /* 433794 */ // Label 8685: @433794
     /* 433794 */ GIM_Try, /*On fail goto*//*Label 8686*/ GIMT_Encode4(433853), // Rule ID 5905 //
     /* 433799 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 433802 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433806 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433810 */   // (AArch64uaddlv:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v2i64] } 0:{ *:[i64] }, (UADDLVv4i32v:{ *:[i64] } V128:{ *:[v4i32] }:$Rn), dsub:{ *:[i32] })
     /* 433810 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s64,
     /* 433813 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i32v),
     /* 433817 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433822 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433826 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433828 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433831 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433833 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433836 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433839 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 433842 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433847 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433852 */   // GIR_Coverage, 5905,
     /* 433852 */   GIR_EraseRootFromParent_Done,
     /* 433853 */ // Label 8686: @433853
     /* 433853 */ GIM_Try, /*On fail goto*//*Label 8687*/ GIMT_Encode4(433931), // Rule ID 6033 //
     /* 433858 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 433861 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433865 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433869 */   // (AArch64uaddlv:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn)  =>  (INSERT_SUBREG:{ *:[v2i64] } (IMPLICIT_DEF:{ *:[v2i64] }), (UADDLPv2i32_v1i64:{ *:[i64] } V64:{ *:[v2i32] }:$Rn), dsub:{ *:[i32] })
     /* 433869 */   GIR_MakeTempReg, /*TempRegID*/1, /*TypeID*/GILLT_s64,
     /* 433872 */   GIR_BuildMI, /*InsnID*/2, /*Opcode*/GIMT_Encode2(AArch64::UADDLPv2i32_v1i64),
     /* 433876 */   GIR_AddTempRegister, /*InsnID*/2, /*TempRegID*/1, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433881 */   GIR_Copy, /*NewInsnID*/2, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 433885 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/2,
     /* 433887 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_v2s64,
     /* 433890 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(TargetOpcode::IMPLICIT_DEF),
     /* 433894 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433899 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433901 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::INSERT_SUBREG),
     /* 433904 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433906 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 433909 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/1,
     /* 433912 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/3,
     /* 433915 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433920 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/1, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433925 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 433930 */   // GIR_Coverage, 6033,
     /* 433930 */   GIR_EraseRootFromParent_Done,
     /* 433931 */ // Label 8687: @433931
     /* 433931 */ GIM_Reject,
     /* 433932 */ // Label 8682: @433932
     /* 433932 */ GIM_Try, /*On fail goto*//*Label 8688*/ GIMT_Encode4(434014), // Rule ID 5898 //
     /* 433937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 433940 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433944 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 433948 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 433952 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 433955 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 433960 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 433964 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 433969 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 433971 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v8i16] } 732:{ *:[iPTR] }, V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 433971 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 433974 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 433978 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 433983 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 433987 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 433989 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 433992 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 433994 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 433997 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434000 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434003 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434008 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434013 */   // GIR_Coverage, 5898,
     /* 434013 */   GIR_EraseRootFromParent_Done,
     /* 434014 */ // Label 8688: @434014
     /* 434014 */ GIM_Try, /*On fail goto*//*Label 8689*/ GIMT_Encode4(434096), // Rule ID 5900 //
     /* 434019 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434022 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434026 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434030 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_INTRINSIC),
     /* 434034 */   GIM_CheckNumOperands, /*MI*/1, /*Expected*/3,
     /* 434037 */   GIM_CheckIntrinsicID, /*MI*/1, /*Op*/1, GIMT_Encode2(Intrinsic::aarch64_neon_uaddlp),
     /* 434042 */   GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434046 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434051 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434053 */   // (AArch64uaddlv:{ *:[v4i32] } (intrinsic_wo_chain:{ *:[v4i16] } 732:{ *:[iPTR] }, V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 434053 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434056 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434060 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434065 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/2, // op
     /* 434069 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434071 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434074 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434076 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434079 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434082 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434085 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434090 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434095 */   // GIR_Coverage, 5900,
     /* 434095 */   GIR_EraseRootFromParent_Done,
     /* 434096 */ // Label 8689: @434096
     /* 434096 */ GIM_Try, /*On fail goto*//*Label 8690*/ GIMT_Encode4(434170), // Rule ID 5897 //
     /* 434101 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434104 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434108 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434112 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 434116 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434120 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434125 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434127 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v8i16] } V128:{ *:[v16i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$op), hsub:{ *:[i32] })
     /* 434127 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434130 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 434134 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434139 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 434143 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434145 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434148 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434150 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434153 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434156 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434159 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434164 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434169 */   // GIR_Coverage, 5897,
     /* 434169 */   GIR_EraseRootFromParent_Done,
     /* 434170 */ // Label 8690: @434170
     /* 434170 */ GIM_Try, /*On fail goto*//*Label 8691*/ GIMT_Encode4(434244), // Rule ID 5899 //
     /* 434175 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434178 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434182 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 434186 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_UADDLP),
     /* 434190 */   GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434194 */   GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434199 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 434201 */   // (AArch64uaddlv:{ *:[v4i32] } (AArch64uaddlp_n:{ *:[v4i16] } V64:{ *:[v8i8] }:$op))  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$op), hsub:{ *:[i32] })
     /* 434201 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434204 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434208 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434213 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/1, /*OpIdx*/1, // op
     /* 434217 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434219 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434222 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434224 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434227 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434230 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434233 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434238 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434243 */   // GIR_Coverage, 5899,
     /* 434243 */   GIR_EraseRootFromParent_Done,
     /* 434244 */ // Label 8691: @434244
     /* 434244 */ GIM_Try, /*On fail goto*//*Label 8692*/ GIMT_Encode4(434303), // Rule ID 5901 //
     /* 434249 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 434252 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434256 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434260 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v8i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i8v:{ *:[i16] } V64:{ *:[v8i8] }:$Rn), hsub:{ *:[i32] })
     /* 434260 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434263 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i8v),
     /* 434267 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434272 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434276 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434278 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434281 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434283 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434286 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434289 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434292 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434297 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434302 */   // GIR_Coverage, 5901,
     /* 434302 */   GIR_EraseRootFromParent_Done,
     /* 434303 */ // Label 8692: @434303
     /* 434303 */ GIM_Try, /*On fail goto*//*Label 8693*/ GIMT_Encode4(434362), // Rule ID 5902 //
     /* 434308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 434311 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434315 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434319 */   // (AArch64uaddlv:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv4i16v:{ *:[i32] } V64:{ *:[v4i16] }:$Rn), ssub:{ *:[i32] })
     /* 434319 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434322 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv4i16v),
     /* 434326 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434331 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434335 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434337 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434340 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434342 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434345 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434348 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434351 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434356 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434361 */   // GIR_Coverage, 5902,
     /* 434361 */   GIR_EraseRootFromParent_Done,
     /* 434362 */ // Label 8693: @434362
     /* 434362 */ GIM_Try, /*On fail goto*//*Label 8694*/ GIMT_Encode4(434421), // Rule ID 5903 //
     /* 434367 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 434370 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434374 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434378 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v16i8] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv16i8v:{ *:[i16] } V128:{ *:[v16i8] }:$Rn), hsub:{ *:[i32] })
     /* 434378 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s16,
     /* 434381 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv16i8v),
     /* 434385 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434390 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434394 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434396 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434399 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434401 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434404 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434407 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/9,
     /* 434410 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434415 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434420 */   // GIR_Coverage, 5903,
     /* 434420 */   GIR_EraseRootFromParent_Done,
     /* 434421 */ // Label 8694: @434421
     /* 434421 */ GIM_Try, /*On fail goto*//*Label 8695*/ GIMT_Encode4(434480), // Rule ID 5904 //
     /* 434426 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 434429 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434433 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434437 */   // (AArch64uaddlv:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn)  =>  (SUBREG_TO_REG:{ *:[v4i32] } 0:{ *:[i64] }, (UADDLVv8i16v:{ *:[i32] } V128:{ *:[v8i16] }:$Rn), ssub:{ *:[i32] })
     /* 434437 */   GIR_MakeTempReg, /*TempRegID*/0, /*TypeID*/GILLT_s32,
     /* 434440 */   GIR_BuildMI, /*InsnID*/1, /*Opcode*/GIMT_Encode2(AArch64::UADDLVv8i16v),
     /* 434444 */   GIR_AddTempRegister, /*InsnID*/1, /*TempRegID*/0, /*TempRegFlags*/GIMT_Encode2(RegState::Define),
     /* 434449 */   GIR_Copy, /*NewInsnID*/1, /*OldInsnID*/0, /*OpIdx*/1, // Rn
     /* 434453 */   GIR_ConstrainSelectedInstOperands, /*InsnID*/1,
     /* 434455 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(TargetOpcode::SUBREG_TO_REG),
     /* 434458 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434460 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/0,
     /* 434463 */   GIR_AddSimpleTempRegister, /*InsnID*/0, /*TempRegID*/0,
     /* 434466 */   GIR_AddImm8, /*InsnID*/0, /*Imm*/18,
     /* 434469 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/0, GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434474 */   GIR_ConstrainOperandRC, /*InsnID*/0, /*Op*/2, GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434479 */   // GIR_Coverage, 5904,
     /* 434479 */   GIR_EraseRootFromParent_Done,
     /* 434480 */ // Label 8695: @434480
     /* 434480 */ GIM_Reject,
     /* 434481 */ // Label 8683: @434481
     /* 434481 */ GIM_Reject,
     /* 434482 */ // Label 145: @434482
     /* 434482 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(20), /*)*//*default:*//*Label 8700*/ GIMT_Encode4(434851),
     /* 434493 */ /*GILLT_v2s32*//*Label 8696*/ GIMT_Encode4(434553), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434505 */ /*GILLT_v4s32*//*Label 8697*/ GIMT_Encode4(434673), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434537 */ /*GILLT_nxv2s64*//*Label 8698*/ GIMT_Encode4(434793), GIMT_Encode4(0), GIMT_Encode4(0),
     /* 434549 */ /*GILLT_nxv4s32*//*Label 8699*/ GIMT_Encode4(434822),
     /* 434553 */ // Label 8696: @434553
     /* 434553 */ GIM_Try, /*On fail goto*//*Label 8701*/ GIMT_Encode4(434672),
     /* 434558 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434561 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 434564 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v8s8,
     /* 434567 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434571 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434575 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434579 */   GIM_Try, /*On fail goto*//*Label 8702*/ GIMT_Encode4(434652), // Rule ID 28 //
     /* 434584 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434587 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 434591 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 434595 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 434599 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434603 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434607 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434611 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434615 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434620 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434624 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434628 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434632 */     // MIs[3] Operand 1
     /* 434632 */     // No operand predicates
     /* 434632 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434634 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, (bitconvert:{ *:[v8i8] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434634 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev8i8),
     /* 434637 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434639 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 434641 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434643 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434647 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434650 */     GIR_RootConstrainSelectedInstOperands,
     /* 434651 */     // GIR_Coverage, 28,
     /* 434651 */     GIR_EraseRootFromParent_Done,
     /* 434652 */   // Label 8702: @434652
     /* 434652 */   GIM_Try, /*On fail goto*//*Label 8703*/ GIMT_Encode4(434671), // Rule ID 24 //
     /* 434657 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434660 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434664 */     // (AArch64udot:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UDOTv8i8:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rd, V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 434664 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv8i8),
     /* 434669 */     GIR_RootConstrainSelectedInstOperands,
     /* 434670 */     // GIR_Coverage, 24,
     /* 434670 */     GIR_Done,
     /* 434671 */   // Label 8703: @434671
     /* 434671 */   GIM_Reject,
     /* 434672 */ // Label 8701: @434672
     /* 434672 */ GIM_Reject,
     /* 434673 */ // Label 8697: @434673
     /* 434673 */ GIM_Try, /*On fail goto*//*Label 8704*/ GIMT_Encode4(434792),
     /* 434678 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434681 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 434684 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_v16s8,
     /* 434687 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434691 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434695 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434699 */   GIM_Try, /*On fail goto*//*Label 8705*/ GIMT_Encode4(434772), // Rule ID 29 //
     /* 434704 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434707 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/3, // MIs[1]
     /* 434711 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_BITCAST),
     /* 434715 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434719 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 434723 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 434727 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 434731 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 434735 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434740 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 434744 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 434748 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 434752 */     // MIs[3] Operand 1
     /* 434752 */     // No operand predicates
     /* 434752 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 434754 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, (bitconvert:{ *:[v16i8] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx)))  =>  (UDOTlanev16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 434754 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UDOTlanev16i8),
     /* 434757 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[dst]
     /* 434759 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rd
     /* 434761 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 434763 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 434767 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 434770 */     GIR_RootConstrainSelectedInstOperands,
     /* 434771 */     // GIR_Coverage, 29,
     /* 434771 */     GIR_EraseRootFromParent_Done,
     /* 434772 */   // Label 8705: @434772
     /* 434772 */   GIM_Try, /*On fail goto*//*Label 8706*/ GIMT_Encode4(434791), // Rule ID 25 //
     /* 434777 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasDotProd),
     /* 434780 */     GIM_RootCheckRegBankForClass, /*Op*/3, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 434784 */     // (AArch64udot:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UDOTv16i8:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rd, V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 434784 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOTv16i8),
     /* 434789 */     GIR_RootConstrainSelectedInstOperands,
     /* 434790 */     // GIR_Coverage, 25,
     /* 434790 */     GIR_Done,
     /* 434791 */   // Label 8706: @434791
     /* 434791 */   GIM_Reject,
     /* 434792 */ // Label 8704: @434792
     /* 434792 */ GIM_Reject,
     /* 434793 */ // Label 8698: @434793
     /* 434793 */ GIM_Try, /*On fail goto*//*Label 8707*/ GIMT_Encode4(434821), // Rule ID 7703 //
     /* 434798 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434801 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 434804 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 434807 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv8s16,
     /* 434810 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434814 */   // (AArch64udot:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2, nxv8i16:{ *:[nxv8i16] }:$Op3)  =>  (UDOT_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv8i16] }:$Op2, ?:{ *:[nxv8i16] }:$Op3)
     /* 434814 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_D),
     /* 434819 */   GIR_RootConstrainSelectedInstOperands,
     /* 434820 */   // GIR_Coverage, 7703,
     /* 434820 */   GIR_Done,
     /* 434821 */ // Label 8707: @434821
     /* 434821 */ GIM_Reject,
     /* 434822 */ // Label 8699: @434822
     /* 434822 */ GIM_Try, /*On fail goto*//*Label 8708*/ GIMT_Encode4(434850), // Rule ID 7702 //
     /* 434827 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 434830 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 434833 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 434836 */   GIM_RootCheckType, /*Op*/3, /*Type*/GILLT_nxv16s8,
     /* 434839 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 434843 */   // (AArch64udot:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2, nxv16i8:{ *:[nxv16i8] }:$Op3)  =>  (UDOT_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv16i8] }:$Op2, ?:{ *:[nxv16i8] }:$Op3)
     /* 434843 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UDOT_ZZZ_S),
     /* 434848 */   GIR_RootConstrainSelectedInstOperands,
     /* 434849 */   // GIR_Coverage, 7702,
     /* 434849 */   GIR_Done,
     /* 434850 */ // Label 8708: @434850
     /* 434850 */ GIM_Reject,
     /* 434851 */ // Label 8700: @434851
     /* 434851 */ GIM_Reject,
     /* 434852 */ // Label 146: @434852
     /* 434852 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(1), GIMT_Encode2(4), /*)*//*default:*//*Label 8712*/ GIMT_Encode4(434968),
     /* 434863 */ /*GILLT_s16*//*Label 8709*/ GIMT_Encode4(434875),
     /* 434867 */ /*GILLT_s32*//*Label 8710*/ GIMT_Encode4(434906),
     /* 434871 */ /*GILLT_s64*//*Label 8711*/ GIMT_Encode4(434937),
     /* 434875 */ // Label 8709: @434875
     /* 434875 */ GIM_Try, /*On fail goto*//*Label 8713*/ GIMT_Encode4(434905), // Rule ID 1669 //
     /* 434880 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasFullFP16_HasNEONandIsStreamingSafe),
     /* 434883 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s16,
     /* 434886 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434890 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR16RegClassID),
     /* 434894 */   // (AArch64uitof:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)  =>  (UCVTFv1i16:{ *:[f16] } FPR16:{ *:[f16] }:$Rn)
     /* 434894 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i16),
     /* 434899 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434903 */   GIR_RootConstrainSelectedInstOperands,
     /* 434904 */   // GIR_Coverage, 1669,
     /* 434904 */   GIR_Done,
     /* 434905 */ // Label 8713: @434905
     /* 434905 */ GIM_Reject,
     /* 434906 */ // Label 8710: @434906
     /* 434906 */ GIM_Try, /*On fail goto*//*Label 8714*/ GIMT_Encode4(434936), // Rule ID 1668 //
     /* 434911 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 434914 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s32,
     /* 434917 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434921 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR32RegClassID),
     /* 434925 */   // (AArch64uitof:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)  =>  (UCVTFv1i32:{ *:[f32] } FPR32:{ *:[f32] }:$Rn)
     /* 434925 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i32),
     /* 434930 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434934 */   GIR_RootConstrainSelectedInstOperands,
     /* 434935 */   // GIR_Coverage, 1668,
     /* 434935 */   GIR_Done,
     /* 434936 */ // Label 8714: @434936
     /* 434936 */ GIM_Reject,
     /* 434937 */ // Label 8711: @434937
     /* 434937 */ GIM_Try, /*On fail goto*//*Label 8715*/ GIMT_Encode4(434967), // Rule ID 1667 //
     /* 434942 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEONandIsStreamingSafe),
     /* 434945 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 434948 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434952 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 434956 */   // (AArch64uitof:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)  =>  (UCVTFv1i64:{ *:[f64] } FPR64:{ *:[f64] }:$Rn)
     /* 434956 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UCVTFv1i64),
     /* 434961 */   GIR_AddImplicitUse, /*InsnID*/0, GIMT_Encode2(AArch64::FPCR),
     /* 434965 */   GIR_RootConstrainSelectedInstOperands,
     /* 434966 */   // GIR_Coverage, 1667,
     /* 434966 */   GIR_Done,
     /* 434967 */ // Label 8715: @434967
     /* 434967 */ GIM_Reject,
     /* 434968 */ // Label 8712: @434968
     /* 434968 */ GIM_Reject,
     /* 434969 */ // Label 147: @434969
     /* 434969 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(6), GIMT_Encode2(11), /*)*//*default:*//*Label 8719*/ GIMT_Encode4(436201),
     /* 434980 */ /*GILLT_v2s64*//*Label 8716*/ GIMT_Encode4(435000), GIMT_Encode4(0),
     /* 434988 */ /*GILLT_v4s32*//*Label 8717*/ GIMT_Encode4(435561), GIMT_Encode4(0),
     /* 434996 */ /*GILLT_v8s16*//*Label 8718*/ GIMT_Encode4(436122),
     /* 435000 */ // Label 8716: @435000
     /* 435000 */ GIM_Try, /*On fail goto*//*Label 8720*/ GIMT_Encode4(435560),
     /* 435005 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 435008 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 435011 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435015 */   GIM_Try, /*On fail goto*//*Label 8721*/ GIMT_Encode4(435107), // Rule ID 2106 //
     /* 435020 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435023 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435027 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435031 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435035 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435039 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435043 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435047 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435051 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435056 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435060 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435064 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435068 */     // MIs[3] Operand 1
     /* 435068 */     // No operand predicates
     /* 435068 */     // MIs[1] Operand 2
     /* 435068 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 435079 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435081 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435088 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435088 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 435091 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435093 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435098 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435102 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435105 */     GIR_RootConstrainSelectedInstOperands,
     /* 435106 */     // GIR_Coverage, 2106,
     /* 435106 */     GIR_EraseRootFromParent_Done,
     /* 435107 */   // Label 8721: @435107
     /* 435107 */   GIM_Try, /*On fail goto*//*Label 8722*/ GIMT_Encode4(435199), // Rule ID 13616 //
     /* 435112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435115 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435119 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435123 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435127 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435131 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435135 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435139 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435143 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435148 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435152 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435156 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435160 */     // MIs[3] Operand 1
     /* 435160 */     // No operand predicates
     /* 435160 */     // MIs[1] Operand 2
     /* 435160 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(2),
     /* 435171 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435173 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435180 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 2:{ *:[i64] }), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn))  =>  (UMULLv4i32_indexed:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435180 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_indexed),
     /* 435183 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435185 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435190 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435194 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435197 */     GIR_RootConstrainSelectedInstOperands,
     /* 435198 */     // GIR_Coverage, 13616,
     /* 435198 */     GIR_EraseRootFromParent_Done,
     /* 435199 */   // Label 8722: @435199
     /* 435199 */   GIM_Try, /*On fail goto*//*Label 8723*/ GIMT_Encode4(435285), // Rule ID 13614 //
     /* 435204 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435207 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435211 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435215 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435219 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435223 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435227 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435231 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435235 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435240 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435244 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435248 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435252 */     // MIs[3] Operand 1
     /* 435252 */     // No operand predicates
     /* 435252 */     // MIs[1] Operand 2
     /* 435252 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435263 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435267 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435269 */     // (AArch64umull:{ *:[v2i64] } (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435269 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435272 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435274 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435276 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435280 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435283 */     GIR_RootConstrainSelectedInstOperands,
     /* 435284 */     // GIR_Coverage, 13614,
     /* 435284 */     GIR_EraseRootFromParent_Done,
     /* 435285 */   // Label 8723: @435285
     /* 435285 */   GIM_Try, /*On fail goto*//*Label 8724*/ GIMT_Encode4(435371), // Rule ID 2104 //
     /* 435290 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435293 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435297 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435301 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435305 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435309 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435313 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435317 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435321 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435325 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435330 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435334 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435338 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435342 */     // MIs[3] Operand 1
     /* 435342 */     // No operand predicates
     /* 435342 */     // MIs[1] Operand 2
     /* 435342 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435353 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435355 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (extract_subvector:{ *:[v2i32] } (AArch64duplane32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435355 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435358 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435360 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435362 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435366 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435369 */     GIR_RootConstrainSelectedInstOperands,
     /* 435370 */     // GIR_Coverage, 2104,
     /* 435370 */     GIR_EraseRootFromParent_Done,
     /* 435371 */   // Label 8724: @435371
     /* 435371 */   GIM_Try, /*On fail goto*//*Label 8725*/ GIMT_Encode4(435410), // Rule ID 1831 //
     /* 435376 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435379 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435386 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v4i32),
     /* 435393 */     // (AArch64umull:{ *:[v2i64] } (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rn), (extract_high_v4i32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm))  =>  (UMULLv4i32_v2i64:{ *:[v2i64] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 435393 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i32_v2i64),
     /* 435396 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435398 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435403 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435408 */     GIR_RootConstrainSelectedInstOperands,
     /* 435409 */     // GIR_Coverage, 1831,
     /* 435409 */     GIR_EraseRootFromParent_Done,
     /* 435410 */   // Label 8725: @435410
     /* 435410 */   GIM_Try, /*On fail goto*//*Label 8726*/ GIMT_Encode4(435473), // Rule ID 13615 //
     /* 435415 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435418 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435422 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435426 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435430 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435434 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435439 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435443 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435447 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435451 */     // MIs[2] Operand 1
     /* 435451 */     // No operand predicates
     /* 435451 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435455 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435457 */     // (AArch64umull:{ *:[v2i64] } (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx), V64:{ *:[v2i32] }:$Rn)  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435457 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435460 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435462 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435464 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435468 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435471 */     GIR_RootConstrainSelectedInstOperands,
     /* 435472 */     // GIR_Coverage, 13615,
     /* 435472 */     GIR_EraseRootFromParent_Done,
     /* 435473 */   // Label 8726: @435473
     /* 435473 */   GIM_Try, /*On fail goto*//*Label 8727*/ GIMT_Encode4(435536), // Rule ID 2105 //
     /* 435478 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435481 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435485 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435489 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE32),
     /* 435493 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 435497 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435501 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435506 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 435510 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435514 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexS),
     /* 435518 */     // MIs[2] Operand 1
     /* 435518 */     // No operand predicates
     /* 435518 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 435520 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, (AArch64duplane32:{ *:[v2i32] } V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexS>>:$idx))  =>  (UMULLv2i32_indexed:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V128:{ *:[v4i32] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435520 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_indexed),
     /* 435523 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435525 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435527 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 435531 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 435534 */     GIR_RootConstrainSelectedInstOperands,
     /* 435535 */     // GIR_Coverage, 2105,
     /* 435535 */     GIR_EraseRootFromParent_Done,
     /* 435536 */   // Label 8727: @435536
     /* 435536 */   GIM_Try, /*On fail goto*//*Label 8728*/ GIMT_Encode4(435559), // Rule ID 1830 //
     /* 435541 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435544 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435548 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435552 */     // (AArch64umull:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UMULLv2i32_v2i64:{ *:[v2i64] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 435552 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv2i32_v2i64),
     /* 435557 */     GIR_RootConstrainSelectedInstOperands,
     /* 435558 */     // GIR_Coverage, 1830,
     /* 435558 */     GIR_Done,
     /* 435559 */   // Label 8728: @435559
     /* 435559 */   GIM_Reject,
     /* 435560 */ // Label 8720: @435560
     /* 435560 */ GIM_Reject,
     /* 435561 */ // Label 8717: @435561
     /* 435561 */ GIM_Try, /*On fail goto*//*Label 8729*/ GIMT_Encode4(436121),
     /* 435566 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 435569 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 435572 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 435576 */   GIM_Try, /*On fail goto*//*Label 8730*/ GIMT_Encode4(435668), // Rule ID 2103 //
     /* 435581 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435584 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435588 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435592 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435596 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435600 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435604 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435608 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435612 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435617 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435621 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435625 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435629 */     // MIs[3] Operand 1
     /* 435629 */     // No operand predicates
     /* 435629 */     // MIs[1] Operand 2
     /* 435629 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 435640 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435642 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435649 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435649 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 435652 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435654 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435659 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435663 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435666 */     GIR_RootConstrainSelectedInstOperands,
     /* 435667 */     // GIR_Coverage, 2103,
     /* 435667 */     GIR_EraseRootFromParent_Done,
     /* 435668 */   // Label 8730: @435668
     /* 435668 */   GIM_Try, /*On fail goto*//*Label 8731*/ GIMT_Encode4(435760), // Rule ID 13613 //
     /* 435673 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435676 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435680 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435684 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435688 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435692 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435696 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435700 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435704 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435709 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435713 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435717 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435721 */     // MIs[3] Operand 1
     /* 435721 */     // No operand predicates
     /* 435721 */     // MIs[1] Operand 2
     /* 435721 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(4),
     /* 435732 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435734 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435741 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 4:{ *:[i64] }), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn))  =>  (UMULLv8i16_indexed:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435741 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_indexed),
     /* 435744 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435746 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435751 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435755 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435758 */     GIR_RootConstrainSelectedInstOperands,
     /* 435759 */     // GIR_Coverage, 13613,
     /* 435759 */     GIR_EraseRootFromParent_Done,
     /* 435760 */   // Label 8731: @435760
     /* 435760 */   GIM_Try, /*On fail goto*//*Label 8732*/ GIMT_Encode4(435846), // Rule ID 13611 //
     /* 435765 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435768 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435772 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435776 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435780 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435784 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435788 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435792 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435796 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435801 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435805 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435809 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435813 */     // MIs[3] Operand 1
     /* 435813 */     // No operand predicates
     /* 435813 */     // MIs[1] Operand 2
     /* 435813 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435824 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435828 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435830 */     // (AArch64umull:{ *:[v4i32] } (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435830 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435833 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435835 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 435837 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435841 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435844 */     GIR_RootConstrainSelectedInstOperands,
     /* 435845 */     // GIR_Coverage, 13611,
     /* 435845 */     GIR_EraseRootFromParent_Done,
     /* 435846 */   // Label 8732: @435846
     /* 435846 */   GIM_Try, /*On fail goto*//*Label 8733*/ GIMT_Encode4(435932), // Rule ID 2101 //
     /* 435851 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435854 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 435858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 435862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_EXTRACT_SUBVECTOR),
     /* 435866 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435870 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/1, // MIs[2]
     /* 435874 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435878 */     GIM_CheckType, /*MI*/2, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435882 */     GIM_CheckType, /*MI*/2, /*Op*/2, /*Type*/GILLT_s64,
     /* 435886 */     GIM_CheckRegBankForClass, /*MI*/2, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 435891 */     GIM_RecordInsn, /*DefineMI*/3, /*MI*/2, /*OpIdx*/2, // MIs[3]
     /* 435895 */     GIM_CheckOpcode, /*MI*/3, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 435899 */     GIM_CheckI64ImmPredicate, /*MI*/3, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 435903 */     // MIs[3] Operand 1
     /* 435903 */     // No operand predicates
     /* 435903 */     // MIs[1] Operand 2
     /* 435903 */     GIM_CheckLiteralInt, /*MI*/1, /*Op*/2, GIMT_Encode8(0),
     /* 435914 */     GIM_CheckIsSafeToFold, /*NumInsns*/3,
     /* 435916 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (extract_subvector:{ *:[v4i16] } (AArch64duplane16:{ *:[v8i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), 0:{ *:[i64] }))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 435916 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 435919 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435921 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 435923 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/2, /*OpIdx*/1, // Rm
     /* 435927 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/3, // idx
     /* 435930 */     GIR_RootConstrainSelectedInstOperands,
     /* 435931 */     // GIR_Coverage, 2101,
     /* 435931 */     GIR_EraseRootFromParent_Done,
     /* 435932 */   // Label 8733: @435932
     /* 435932 */   GIM_Try, /*On fail goto*//*Label 8734*/ GIMT_Encode4(435971), // Rule ID 1829 //
     /* 435937 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435940 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435947 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v8i16),
     /* 435954 */     // (AArch64umull:{ *:[v4i32] } (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rn), (extract_high_v8i16:{ *:[v4i16] } V128:{ *:[v8i16] }:$Rm))  =>  (UMULLv8i16_v4i32:{ *:[v4i32] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 435954 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i16_v4i32),
     /* 435957 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 435959 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 435964 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 435969 */     GIR_RootConstrainSelectedInstOperands,
     /* 435970 */     // GIR_Coverage, 1829,
     /* 435970 */     GIR_EraseRootFromParent_Done,
     /* 435971 */   // Label 8734: @435971
     /* 435971 */   GIM_Try, /*On fail goto*//*Label 8735*/ GIMT_Encode4(436034), // Rule ID 13612 //
     /* 435976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 435979 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/1, // MIs[1]
     /* 435983 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 435987 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 435991 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 435995 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436000 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436004 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436008 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436012 */     // MIs[2] Operand 1
     /* 436012 */     // No operand predicates
     /* 436012 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436016 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436018 */     // (AArch64umull:{ *:[v4i32] } (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx), V64:{ *:[v4i16] }:$Rn)  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436018 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436021 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436023 */     GIR_RootToRootCopy, /*OpIdx*/2, // Rn
     /* 436025 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436029 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436032 */     GIR_RootConstrainSelectedInstOperands,
     /* 436033 */     // GIR_Coverage, 13612,
     /* 436033 */     GIR_EraseRootFromParent_Done,
     /* 436034 */   // Label 8735: @436034
     /* 436034 */   GIM_Try, /*On fail goto*//*Label 8736*/ GIMT_Encode4(436097), // Rule ID 2102 //
     /* 436039 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436042 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 436050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(AArch64::G_DUPLANE16),
     /* 436054 */     GIM_CheckType, /*MI*/1, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436058 */     GIM_CheckType, /*MI*/1, /*Op*/2, /*Type*/GILLT_s64,
     /* 436062 */     GIM_CheckRegBankForClass, /*MI*/1, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128_loRegClassID),
     /* 436067 */     GIM_RecordInsn, /*DefineMI*/2, /*MI*/1, /*OpIdx*/2, // MIs[2]
     /* 436071 */     GIM_CheckOpcode, /*MI*/2, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 436075 */     GIM_CheckI64ImmPredicate, /*MI*/2, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_VectorIndexH),
     /* 436079 */     // MIs[2] Operand 1
     /* 436079 */     // No operand predicates
     /* 436079 */     GIM_CheckIsSafeToFold, /*NumInsns*/2,
     /* 436081 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, (AArch64duplane16:{ *:[v4i16] } V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] })<<P:Predicate_VectorIndexH>>:$idx))  =>  (UMULLv4i16_indexed:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V128_lo:{ *:[v8i16] }:$Rm, (imm:{ *:[i64] }):$idx)
     /* 436081 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_indexed),
     /* 436084 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436086 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 436088 */     GIR_Copy, /*NewInsnID*/0, /*OldInsnID*/1, /*OpIdx*/1, // Rm
     /* 436092 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/2, // idx
     /* 436095 */     GIR_RootConstrainSelectedInstOperands,
     /* 436096 */     // GIR_Coverage, 2102,
     /* 436096 */     GIR_EraseRootFromParent_Done,
     /* 436097 */   // Label 8736: @436097
     /* 436097 */   GIM_Try, /*On fail goto*//*Label 8737*/ GIMT_Encode4(436120), // Rule ID 1828 //
     /* 436102 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436105 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436109 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436113 */     // (AArch64umull:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UMULLv4i16_v4i32:{ *:[v4i32] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436113 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv4i16_v4i32),
     /* 436118 */     GIR_RootConstrainSelectedInstOperands,
     /* 436119 */     // GIR_Coverage, 1828,
     /* 436119 */     GIR_Done,
     /* 436120 */   // Label 8737: @436120
     /* 436120 */   GIM_Reject,
     /* 436121 */ // Label 8729: @436121
     /* 436121 */ GIM_Reject,
     /* 436122 */ // Label 8718: @436122
     /* 436122 */ GIM_Try, /*On fail goto*//*Label 8738*/ GIMT_Encode4(436200),
     /* 436127 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436130 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436133 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436137 */   GIM_Try, /*On fail goto*//*Label 8739*/ GIMT_Encode4(436176), // Rule ID 1827 //
     /* 436142 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436145 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/1, /*Renderer*/GIMT_Encode2(0), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 436152 */     GIM_CheckComplexPattern, /*MI*/0, /*Op*/2, /*Renderer*/GIMT_Encode2(1), GIMT_Encode2(GICP_gi_extract_high_v16i8),
     /* 436159 */     // (AArch64umull:{ *:[v8i16] } (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rn), (extract_high_v16i8:{ *:[v8i8] } V128:{ *:[v16i8] }:$Rm))  =>  (UMULLv16i8_v8i16:{ *:[v8i16] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436159 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::UMULLv16i8_v8i16),
     /* 436162 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 436164 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(0), /*SubOperand*/0, // Rn
     /* 436169 */     GIR_ComplexSubOperandRenderer, /*InsnID*/0, /*RendererID*/GIMT_Encode2(1), /*SubOperand*/0, // Rm
     /* 436174 */     GIR_RootConstrainSelectedInstOperands,
     /* 436175 */     // GIR_Coverage, 1827,
     /* 436175 */     GIR_EraseRootFromParent_Done,
     /* 436176 */   // Label 8739: @436176
     /* 436176 */   GIM_Try, /*On fail goto*//*Label 8740*/ GIMT_Encode4(436199), // Rule ID 1826 //
     /* 436181 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436184 */     GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436188 */     GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436192 */     // (AArch64umull:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UMULLv8i8_v8i16:{ *:[v8i16] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436192 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UMULLv8i8_v8i16),
     /* 436197 */     GIR_RootConstrainSelectedInstOperands,
     /* 436198 */     // GIR_Coverage, 1826,
     /* 436198 */     GIR_Done,
     /* 436199 */   // Label 8740: @436199
     /* 436199 */   GIM_Reject,
     /* 436200 */ // Label 8738: @436200
     /* 436200 */ GIM_Reject,
     /* 436201 */ // Label 8719: @436201
     /* 436201 */ GIM_Reject,
     /* 436202 */ // Label 148: @436202
     /* 436202 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8759*/ GIMT_Encode4(436981),
     /* 436213 */ /*GILLT_v2s32*//*Label 8741*/ GIMT_Encode4(436289),
     /* 436217 */ /*GILLT_v2s64*//*Label 8742*/ GIMT_Encode4(436344),
     /* 436221 */ /*GILLT_v4s16*//*Label 8743*/ GIMT_Encode4(436399),
     /* 436225 */ /*GILLT_v4s32*//*Label 8744*/ GIMT_Encode4(436454),
     /* 436229 */ /*GILLT_v8s8*//*Label 8745*/ GIMT_Encode4(436509),
     /* 436233 */ /*GILLT_v8s16*//*Label 8746*/ GIMT_Encode4(436543),
     /* 436237 */ /*GILLT_v16s8*//*Label 8747*/ GIMT_Encode4(436598), GIMT_Encode4(0),
     /* 436245 */ /*GILLT_nxv2s1*//*Label 8748*/ GIMT_Encode4(436632),
     /* 436249 */ /*GILLT_nxv2s16*//*Label 8749*/ GIMT_Encode4(436658),
     /* 436253 */ /*GILLT_nxv2s32*//*Label 8750*/ GIMT_Encode4(436684),
     /* 436257 */ /*GILLT_nxv2s64*//*Label 8751*/ GIMT_Encode4(436710),
     /* 436261 */ /*GILLT_nxv4s1*//*Label 8752*/ GIMT_Encode4(436757),
     /* 436265 */ /*GILLT_nxv4s16*//*Label 8753*/ GIMT_Encode4(436783),
     /* 436269 */ /*GILLT_nxv4s32*//*Label 8754*/ GIMT_Encode4(436809),
     /* 436273 */ /*GILLT_nxv8s1*//*Label 8755*/ GIMT_Encode4(436856),
     /* 436277 */ /*GILLT_nxv8s16*//*Label 8756*/ GIMT_Encode4(436882),
     /* 436281 */ /*GILLT_nxv16s1*//*Label 8757*/ GIMT_Encode4(436929),
     /* 436285 */ /*GILLT_nxv16s8*//*Label 8758*/ GIMT_Encode4(436955),
     /* 436289 */ // Label 8741: @436289
     /* 436289 */ GIM_Try, /*On fail goto*//*Label 8760*/ GIMT_Encode4(436343),
     /* 436294 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 436297 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 436300 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436304 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436308 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436312 */   GIM_Try, /*On fail goto*//*Label 8761*/ GIMT_Encode4(436327), // Rule ID 1888 //
     /* 436317 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436320 */     // (AArch64uzp1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 436320 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 436325 */     GIR_RootConstrainSelectedInstOperands,
     /* 436326 */     // GIR_Coverage, 1888,
     /* 436326 */     GIR_Done,
     /* 436327 */   // Label 8761: @436327
     /* 436327 */   GIM_Try, /*On fail goto*//*Label 8762*/ GIMT_Encode4(436342), // Rule ID 5488 //
     /* 436332 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436335 */     // (AArch64uzp1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 436335 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i32),
     /* 436340 */     GIR_RootConstrainSelectedInstOperands,
     /* 436341 */     // GIR_Coverage, 5488,
     /* 436341 */     GIR_Done,
     /* 436342 */   // Label 8762: @436342
     /* 436342 */   GIM_Reject,
     /* 436343 */ // Label 8760: @436343
     /* 436343 */ GIM_Reject,
     /* 436344 */ // Label 8742: @436344
     /* 436344 */ GIM_Try, /*On fail goto*//*Label 8763*/ GIMT_Encode4(436398),
     /* 436349 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 436352 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 436355 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436359 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436363 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436367 */   GIM_Try, /*On fail goto*//*Label 8764*/ GIMT_Encode4(436382), // Rule ID 1890 //
     /* 436372 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436375 */     // (AArch64uzp1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 436375 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 436380 */     GIR_RootConstrainSelectedInstOperands,
     /* 436381 */     // GIR_Coverage, 1890,
     /* 436381 */     GIR_Done,
     /* 436382 */   // Label 8764: @436382
     /* 436382 */   GIM_Try, /*On fail goto*//*Label 8765*/ GIMT_Encode4(436397), // Rule ID 5490 //
     /* 436387 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436390 */     // (AArch64uzp1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 436390 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v2i64),
     /* 436395 */     GIR_RootConstrainSelectedInstOperands,
     /* 436396 */     // GIR_Coverage, 5490,
     /* 436396 */     GIR_Done,
     /* 436397 */   // Label 8765: @436397
     /* 436397 */   GIM_Reject,
     /* 436398 */ // Label 8763: @436398
     /* 436398 */ GIM_Reject,
     /* 436399 */ // Label 8743: @436399
     /* 436399 */ GIM_Try, /*On fail goto*//*Label 8766*/ GIMT_Encode4(436453),
     /* 436404 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 436407 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 436410 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436414 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436418 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436422 */   GIM_Try, /*On fail goto*//*Label 8767*/ GIMT_Encode4(436437), // Rule ID 1886 //
     /* 436427 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436430 */     // (AArch64uzp1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 436430 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 436435 */     GIR_RootConstrainSelectedInstOperands,
     /* 436436 */     // GIR_Coverage, 1886,
     /* 436436 */     GIR_Done,
     /* 436437 */   // Label 8767: @436437
     /* 436437 */   GIM_Try, /*On fail goto*//*Label 8768*/ GIMT_Encode4(436452), // Rule ID 5486 //
     /* 436442 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436445 */     // (AArch64uzp1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 436445 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i16),
     /* 436450 */     GIR_RootConstrainSelectedInstOperands,
     /* 436451 */     // GIR_Coverage, 5486,
     /* 436451 */     GIR_Done,
     /* 436452 */   // Label 8768: @436452
     /* 436452 */   GIM_Reject,
     /* 436453 */ // Label 8766: @436453
     /* 436453 */ GIM_Reject,
     /* 436454 */ // Label 8744: @436454
     /* 436454 */ GIM_Try, /*On fail goto*//*Label 8769*/ GIMT_Encode4(436508),
     /* 436459 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 436462 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 436465 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436469 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436473 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436477 */   GIM_Try, /*On fail goto*//*Label 8770*/ GIMT_Encode4(436492), // Rule ID 1889 //
     /* 436482 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436485 */     // (AArch64uzp1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 436485 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 436490 */     GIR_RootConstrainSelectedInstOperands,
     /* 436491 */     // GIR_Coverage, 1889,
     /* 436491 */     GIR_Done,
     /* 436492 */   // Label 8770: @436492
     /* 436492 */   GIM_Try, /*On fail goto*//*Label 8771*/ GIMT_Encode4(436507), // Rule ID 5489 //
     /* 436497 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436500 */     // (AArch64uzp1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 436500 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v4i32),
     /* 436505 */     GIR_RootConstrainSelectedInstOperands,
     /* 436506 */     // GIR_Coverage, 5489,
     /* 436506 */     GIR_Done,
     /* 436507 */   // Label 8771: @436507
     /* 436507 */   GIM_Reject,
     /* 436508 */ // Label 8769: @436508
     /* 436508 */ GIM_Reject,
     /* 436509 */ // Label 8745: @436509
     /* 436509 */ GIM_Try, /*On fail goto*//*Label 8772*/ GIMT_Encode4(436542), // Rule ID 1884 //
     /* 436514 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436517 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 436520 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 436523 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436527 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436531 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 436535 */   // (AArch64uzp1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 436535 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i8),
     /* 436540 */   GIR_RootConstrainSelectedInstOperands,
     /* 436541 */   // GIR_Coverage, 1884,
     /* 436541 */   GIR_Done,
     /* 436542 */ // Label 8772: @436542
     /* 436542 */ GIM_Reject,
     /* 436543 */ // Label 8746: @436543
     /* 436543 */ GIM_Try, /*On fail goto*//*Label 8773*/ GIMT_Encode4(436597),
     /* 436548 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 436551 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 436554 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436558 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436562 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436566 */   GIM_Try, /*On fail goto*//*Label 8774*/ GIMT_Encode4(436581), // Rule ID 1887 //
     /* 436571 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436574 */     // (AArch64uzp1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 436574 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 436579 */     GIR_RootConstrainSelectedInstOperands,
     /* 436580 */     // GIR_Coverage, 1887,
     /* 436580 */     GIR_Done,
     /* 436581 */   // Label 8774: @436581
     /* 436581 */   GIM_Try, /*On fail goto*//*Label 8775*/ GIMT_Encode4(436596), // Rule ID 5487 //
     /* 436586 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436589 */     // (AArch64uzp1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 436589 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v8i16),
     /* 436594 */     GIR_RootConstrainSelectedInstOperands,
     /* 436595 */     // GIR_Coverage, 5487,
     /* 436595 */     GIR_Done,
     /* 436596 */   // Label 8775: @436596
     /* 436596 */   GIM_Reject,
     /* 436597 */ // Label 8773: @436597
     /* 436597 */ GIM_Reject,
     /* 436598 */ // Label 8747: @436598
     /* 436598 */ GIM_Try, /*On fail goto*//*Label 8776*/ GIMT_Encode4(436631), // Rule ID 1885 //
     /* 436603 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 436606 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 436609 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 436612 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436616 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436620 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 436624 */   // (AArch64uzp1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 436624 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1v16i8),
     /* 436629 */   GIR_RootConstrainSelectedInstOperands,
     /* 436630 */   // GIR_Coverage, 1885,
     /* 436630 */   GIR_Done,
     /* 436631 */ // Label 8776: @436631
     /* 436631 */ GIM_Reject,
     /* 436632 */ // Label 8748: @436632
     /* 436632 */ GIM_Try, /*On fail goto*//*Label 8777*/ GIMT_Encode4(436657), // Rule ID 9011 //
     /* 436637 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436640 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 436643 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 436646 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436650 */   // (AArch64uzp1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 436650 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_D),
     /* 436655 */   GIR_RootConstrainSelectedInstOperands,
     /* 436656 */   // GIR_Coverage, 9011,
     /* 436656 */   GIR_Done,
     /* 436657 */ // Label 8777: @436657
     /* 436657 */ GIM_Reject,
     /* 436658 */ // Label 8749: @436658
     /* 436658 */ GIM_Try, /*On fail goto*//*Label 8778*/ GIMT_Encode4(436683), // Rule ID 8973 //
     /* 436663 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436666 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 436669 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 436672 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436676 */   // (AArch64uzp1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 436676 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436681 */   GIR_RootConstrainSelectedInstOperands,
     /* 436682 */   // GIR_Coverage, 8973,
     /* 436682 */   GIR_Done,
     /* 436683 */ // Label 8778: @436683
     /* 436683 */ GIM_Reject,
     /* 436684 */ // Label 8750: @436684
     /* 436684 */ GIM_Try, /*On fail goto*//*Label 8779*/ GIMT_Encode4(436709), // Rule ID 8974 //
     /* 436689 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436692 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 436695 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 436698 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436702 */   // (AArch64uzp1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 436702 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436707 */   GIR_RootConstrainSelectedInstOperands,
     /* 436708 */   // GIR_Coverage, 8974,
     /* 436708 */   GIR_Done,
     /* 436709 */ // Label 8779: @436709
     /* 436709 */ GIM_Reject,
     /* 436710 */ // Label 8751: @436710
     /* 436710 */ GIM_Try, /*On fail goto*//*Label 8780*/ GIMT_Encode4(436756),
     /* 436715 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 436718 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 436721 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436725 */   GIM_Try, /*On fail goto*//*Label 8781*/ GIMT_Encode4(436740), // Rule ID 8969 //
     /* 436730 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436733 */     // (AArch64uzp1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 436733 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436738 */     GIR_RootConstrainSelectedInstOperands,
     /* 436739 */     // GIR_Coverage, 8969,
     /* 436739 */     GIR_Done,
     /* 436740 */   // Label 8781: @436740
     /* 436740 */   GIM_Try, /*On fail goto*//*Label 8782*/ GIMT_Encode4(436755), // Rule ID 8975 //
     /* 436745 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436748 */     // (AArch64uzp1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 436748 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_D),
     /* 436753 */     GIR_RootConstrainSelectedInstOperands,
     /* 436754 */     // GIR_Coverage, 8975,
     /* 436754 */     GIR_Done,
     /* 436755 */   // Label 8782: @436755
     /* 436755 */   GIM_Reject,
     /* 436756 */ // Label 8780: @436756
     /* 436756 */ GIM_Reject,
     /* 436757 */ // Label 8752: @436757
     /* 436757 */ GIM_Try, /*On fail goto*//*Label 8783*/ GIMT_Encode4(436782), // Rule ID 9010 //
     /* 436762 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436765 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 436768 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 436771 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436775 */   // (AArch64uzp1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 436775 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_S),
     /* 436780 */   GIR_RootConstrainSelectedInstOperands,
     /* 436781 */   // GIR_Coverage, 9010,
     /* 436781 */   GIR_Done,
     /* 436782 */ // Label 8783: @436782
     /* 436782 */ GIM_Reject,
     /* 436783 */ // Label 8753: @436783
     /* 436783 */ GIM_Try, /*On fail goto*//*Label 8784*/ GIMT_Encode4(436808), // Rule ID 8971 //
     /* 436788 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436791 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 436794 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 436797 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436801 */   // (AArch64uzp1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 436801 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436806 */   GIR_RootConstrainSelectedInstOperands,
     /* 436807 */   // GIR_Coverage, 8971,
     /* 436807 */   GIR_Done,
     /* 436808 */ // Label 8784: @436808
     /* 436808 */ GIM_Reject,
     /* 436809 */ // Label 8754: @436809
     /* 436809 */ GIM_Try, /*On fail goto*//*Label 8785*/ GIMT_Encode4(436855),
     /* 436814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 436817 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 436820 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436824 */   GIM_Try, /*On fail goto*//*Label 8786*/ GIMT_Encode4(436839), // Rule ID 8968 //
     /* 436829 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436832 */     // (AArch64uzp1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 436832 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436837 */     GIR_RootConstrainSelectedInstOperands,
     /* 436838 */     // GIR_Coverage, 8968,
     /* 436838 */     GIR_Done,
     /* 436839 */   // Label 8786: @436839
     /* 436839 */   GIM_Try, /*On fail goto*//*Label 8787*/ GIMT_Encode4(436854), // Rule ID 8972 //
     /* 436844 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436847 */     // (AArch64uzp1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 436847 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_S),
     /* 436852 */     GIR_RootConstrainSelectedInstOperands,
     /* 436853 */     // GIR_Coverage, 8972,
     /* 436853 */     GIR_Done,
     /* 436854 */   // Label 8787: @436854
     /* 436854 */   GIM_Reject,
     /* 436855 */ // Label 8785: @436855
     /* 436855 */ GIM_Reject,
     /* 436856 */ // Label 8755: @436856
     /* 436856 */ GIM_Try, /*On fail goto*//*Label 8788*/ GIMT_Encode4(436881), // Rule ID 9009 //
     /* 436861 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436864 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 436867 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 436870 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436874 */   // (AArch64uzp1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 436874 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_H),
     /* 436879 */   GIR_RootConstrainSelectedInstOperands,
     /* 436880 */   // GIR_Coverage, 9009,
     /* 436880 */   GIR_Done,
     /* 436881 */ // Label 8788: @436881
     /* 436881 */ GIM_Reject,
     /* 436882 */ // Label 8756: @436882
     /* 436882 */ GIM_Try, /*On fail goto*//*Label 8789*/ GIMT_Encode4(436928),
     /* 436887 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 436890 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 436893 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436897 */   GIM_Try, /*On fail goto*//*Label 8790*/ GIMT_Encode4(436912), // Rule ID 8967 //
     /* 436902 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436905 */     // (AArch64uzp1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 436905 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 436910 */     GIR_RootConstrainSelectedInstOperands,
     /* 436911 */     // GIR_Coverage, 8967,
     /* 436911 */     GIR_Done,
     /* 436912 */   // Label 8790: @436912
     /* 436912 */   GIM_Try, /*On fail goto*//*Label 8791*/ GIMT_Encode4(436927), // Rule ID 8970 //
     /* 436917 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436920 */     // (AArch64uzp1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 436920 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_H),
     /* 436925 */     GIR_RootConstrainSelectedInstOperands,
     /* 436926 */     // GIR_Coverage, 8970,
     /* 436926 */     GIR_Done,
     /* 436927 */   // Label 8791: @436927
     /* 436927 */   GIM_Reject,
     /* 436928 */ // Label 8789: @436928
     /* 436928 */ GIM_Reject,
     /* 436929 */ // Label 8757: @436929
     /* 436929 */ GIM_Try, /*On fail goto*//*Label 8792*/ GIMT_Encode4(436954), // Rule ID 2406 //
     /* 436934 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436937 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 436940 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 436943 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 436947 */   // (AArch64uzp1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 436947 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_PPP_B),
     /* 436952 */   GIR_RootConstrainSelectedInstOperands,
     /* 436953 */   // GIR_Coverage, 2406,
     /* 436953 */   GIR_Done,
     /* 436954 */ // Label 8792: @436954
     /* 436954 */ GIM_Reject,
     /* 436955 */ // Label 8758: @436955
     /* 436955 */ GIM_Try, /*On fail goto*//*Label 8793*/ GIMT_Encode4(436980), // Rule ID 8966 //
     /* 436960 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 436963 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 436966 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 436969 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 436973 */   // (AArch64uzp1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 436973 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP1_ZZZ_B),
     /* 436978 */   GIR_RootConstrainSelectedInstOperands,
     /* 436979 */   // GIR_Coverage, 8966,
     /* 436979 */   GIR_Done,
     /* 436980 */ // Label 8793: @436980
     /* 436980 */ GIM_Reject,
     /* 436981 */ // Label 8759: @436981
     /* 436981 */ GIM_Reject,
     /* 436982 */ // Label 149: @436982
     /* 436982 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8812*/ GIMT_Encode4(437761),
     /* 436993 */ /*GILLT_v2s32*//*Label 8794*/ GIMT_Encode4(437069),
     /* 436997 */ /*GILLT_v2s64*//*Label 8795*/ GIMT_Encode4(437124),
     /* 437001 */ /*GILLT_v4s16*//*Label 8796*/ GIMT_Encode4(437179),
     /* 437005 */ /*GILLT_v4s32*//*Label 8797*/ GIMT_Encode4(437234),
     /* 437009 */ /*GILLT_v8s8*//*Label 8798*/ GIMT_Encode4(437289),
     /* 437013 */ /*GILLT_v8s16*//*Label 8799*/ GIMT_Encode4(437323),
     /* 437017 */ /*GILLT_v16s8*//*Label 8800*/ GIMT_Encode4(437378), GIMT_Encode4(0),
     /* 437025 */ /*GILLT_nxv2s1*//*Label 8801*/ GIMT_Encode4(437412),
     /* 437029 */ /*GILLT_nxv2s16*//*Label 8802*/ GIMT_Encode4(437438),
     /* 437033 */ /*GILLT_nxv2s32*//*Label 8803*/ GIMT_Encode4(437464),
     /* 437037 */ /*GILLT_nxv2s64*//*Label 8804*/ GIMT_Encode4(437490),
     /* 437041 */ /*GILLT_nxv4s1*//*Label 8805*/ GIMT_Encode4(437537),
     /* 437045 */ /*GILLT_nxv4s16*//*Label 8806*/ GIMT_Encode4(437563),
     /* 437049 */ /*GILLT_nxv4s32*//*Label 8807*/ GIMT_Encode4(437589),
     /* 437053 */ /*GILLT_nxv8s1*//*Label 8808*/ GIMT_Encode4(437636),
     /* 437057 */ /*GILLT_nxv8s16*//*Label 8809*/ GIMT_Encode4(437662),
     /* 437061 */ /*GILLT_nxv16s1*//*Label 8810*/ GIMT_Encode4(437709),
     /* 437065 */ /*GILLT_nxv16s8*//*Label 8811*/ GIMT_Encode4(437735),
     /* 437069 */ // Label 8794: @437069
     /* 437069 */ GIM_Try, /*On fail goto*//*Label 8813*/ GIMT_Encode4(437123),
     /* 437074 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437077 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 437080 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437084 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437088 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437092 */   GIM_Try, /*On fail goto*//*Label 8814*/ GIMT_Encode4(437107), // Rule ID 1895 //
     /* 437097 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437100 */     // (AArch64uzp2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 437100 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 437105 */     GIR_RootConstrainSelectedInstOperands,
     /* 437106 */     // GIR_Coverage, 1895,
     /* 437106 */     GIR_Done,
     /* 437107 */   // Label 8814: @437107
     /* 437107 */   GIM_Try, /*On fail goto*//*Label 8815*/ GIMT_Encode4(437122), // Rule ID 5493 //
     /* 437112 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437115 */     // (AArch64uzp2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (UZP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 437115 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i32),
     /* 437120 */     GIR_RootConstrainSelectedInstOperands,
     /* 437121 */     // GIR_Coverage, 5493,
     /* 437121 */     GIR_Done,
     /* 437122 */   // Label 8815: @437122
     /* 437122 */   GIM_Reject,
     /* 437123 */ // Label 8813: @437123
     /* 437123 */ GIM_Reject,
     /* 437124 */ // Label 8795: @437124
     /* 437124 */ GIM_Try, /*On fail goto*//*Label 8816*/ GIMT_Encode4(437178),
     /* 437129 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 437132 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 437135 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437139 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437143 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437147 */   GIM_Try, /*On fail goto*//*Label 8817*/ GIMT_Encode4(437162), // Rule ID 1897 //
     /* 437152 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437155 */     // (AArch64uzp2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 437155 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 437160 */     GIR_RootConstrainSelectedInstOperands,
     /* 437161 */     // GIR_Coverage, 1897,
     /* 437161 */     GIR_Done,
     /* 437162 */   // Label 8817: @437162
     /* 437162 */   GIM_Try, /*On fail goto*//*Label 8818*/ GIMT_Encode4(437177), // Rule ID 5495 //
     /* 437167 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437170 */     // (AArch64uzp2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (UZP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 437170 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v2i64),
     /* 437175 */     GIR_RootConstrainSelectedInstOperands,
     /* 437176 */     // GIR_Coverage, 5495,
     /* 437176 */     GIR_Done,
     /* 437177 */   // Label 8818: @437177
     /* 437177 */   GIM_Reject,
     /* 437178 */ // Label 8816: @437178
     /* 437178 */ GIM_Reject,
     /* 437179 */ // Label 8796: @437179
     /* 437179 */ GIM_Try, /*On fail goto*//*Label 8819*/ GIMT_Encode4(437233),
     /* 437184 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 437187 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 437190 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437194 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437198 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437202 */   GIM_Try, /*On fail goto*//*Label 8820*/ GIMT_Encode4(437217), // Rule ID 1893 //
     /* 437207 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437210 */     // (AArch64uzp2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 437210 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 437215 */     GIR_RootConstrainSelectedInstOperands,
     /* 437216 */     // GIR_Coverage, 1893,
     /* 437216 */     GIR_Done,
     /* 437217 */   // Label 8820: @437217
     /* 437217 */   GIM_Try, /*On fail goto*//*Label 8821*/ GIMT_Encode4(437232), // Rule ID 5491 //
     /* 437222 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437225 */     // (AArch64uzp2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (UZP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 437225 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i16),
     /* 437230 */     GIR_RootConstrainSelectedInstOperands,
     /* 437231 */     // GIR_Coverage, 5491,
     /* 437231 */     GIR_Done,
     /* 437232 */   // Label 8821: @437232
     /* 437232 */   GIM_Reject,
     /* 437233 */ // Label 8819: @437233
     /* 437233 */ GIM_Reject,
     /* 437234 */ // Label 8797: @437234
     /* 437234 */ GIM_Try, /*On fail goto*//*Label 8822*/ GIMT_Encode4(437288),
     /* 437239 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 437242 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 437245 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437249 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437253 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437257 */   GIM_Try, /*On fail goto*//*Label 8823*/ GIMT_Encode4(437272), // Rule ID 1896 //
     /* 437262 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437265 */     // (AArch64uzp2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 437265 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 437270 */     GIR_RootConstrainSelectedInstOperands,
     /* 437271 */     // GIR_Coverage, 1896,
     /* 437271 */     GIR_Done,
     /* 437272 */   // Label 8823: @437272
     /* 437272 */   GIM_Try, /*On fail goto*//*Label 8824*/ GIMT_Encode4(437287), // Rule ID 5494 //
     /* 437277 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437280 */     // (AArch64uzp2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (UZP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 437280 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v4i32),
     /* 437285 */     GIR_RootConstrainSelectedInstOperands,
     /* 437286 */     // GIR_Coverage, 5494,
     /* 437286 */     GIR_Done,
     /* 437287 */   // Label 8824: @437287
     /* 437287 */   GIM_Reject,
     /* 437288 */ // Label 8822: @437288
     /* 437288 */ GIM_Reject,
     /* 437289 */ // Label 8798: @437289
     /* 437289 */ GIM_Try, /*On fail goto*//*Label 8825*/ GIMT_Encode4(437322), // Rule ID 1891 //
     /* 437294 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437297 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 437300 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 437303 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437307 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437311 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437315 */   // (AArch64uzp2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (UZP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 437315 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i8),
     /* 437320 */   GIR_RootConstrainSelectedInstOperands,
     /* 437321 */   // GIR_Coverage, 1891,
     /* 437321 */   GIR_Done,
     /* 437322 */ // Label 8825: @437322
     /* 437322 */ GIM_Reject,
     /* 437323 */ // Label 8799: @437323
     /* 437323 */ GIM_Try, /*On fail goto*//*Label 8826*/ GIMT_Encode4(437377),
     /* 437328 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 437331 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 437334 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437338 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437342 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437346 */   GIM_Try, /*On fail goto*//*Label 8827*/ GIMT_Encode4(437361), // Rule ID 1894 //
     /* 437351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437354 */     // (AArch64uzp2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 437354 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 437359 */     GIR_RootConstrainSelectedInstOperands,
     /* 437360 */     // GIR_Coverage, 1894,
     /* 437360 */     GIR_Done,
     /* 437361 */   // Label 8827: @437361
     /* 437361 */   GIM_Try, /*On fail goto*//*Label 8828*/ GIMT_Encode4(437376), // Rule ID 5492 //
     /* 437366 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437369 */     // (AArch64uzp2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (UZP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 437369 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v8i16),
     /* 437374 */     GIR_RootConstrainSelectedInstOperands,
     /* 437375 */     // GIR_Coverage, 5492,
     /* 437375 */     GIR_Done,
     /* 437376 */   // Label 8828: @437376
     /* 437376 */   GIM_Reject,
     /* 437377 */ // Label 8826: @437377
     /* 437377 */ GIM_Reject,
     /* 437378 */ // Label 8800: @437378
     /* 437378 */ GIM_Try, /*On fail goto*//*Label 8829*/ GIMT_Encode4(437411), // Rule ID 1892 //
     /* 437383 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437386 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 437389 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 437392 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437396 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437400 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 437404 */   // (AArch64uzp2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (UZP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 437404 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2v16i8),
     /* 437409 */   GIR_RootConstrainSelectedInstOperands,
     /* 437410 */   // GIR_Coverage, 1892,
     /* 437410 */   GIR_Done,
     /* 437411 */ // Label 8829: @437411
     /* 437411 */ GIM_Reject,
     /* 437412 */ // Label 8801: @437412
     /* 437412 */ GIM_Try, /*On fail goto*//*Label 8830*/ GIMT_Encode4(437437), // Rule ID 9014 //
     /* 437417 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437420 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 437423 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 437426 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437430 */   // (AArch64uzp2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (UZP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 437430 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_D),
     /* 437435 */   GIR_RootConstrainSelectedInstOperands,
     /* 437436 */   // GIR_Coverage, 9014,
     /* 437436 */   GIR_Done,
     /* 437437 */ // Label 8830: @437437
     /* 437437 */ GIM_Reject,
     /* 437438 */ // Label 8802: @437438
     /* 437438 */ GIM_Try, /*On fail goto*//*Label 8831*/ GIMT_Encode4(437463), // Rule ID 8983 //
     /* 437443 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437446 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 437449 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 437452 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437456 */   // (AArch64uzp2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 437456 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437461 */   GIR_RootConstrainSelectedInstOperands,
     /* 437462 */   // GIR_Coverage, 8983,
     /* 437462 */   GIR_Done,
     /* 437463 */ // Label 8831: @437463
     /* 437463 */ GIM_Reject,
     /* 437464 */ // Label 8803: @437464
     /* 437464 */ GIM_Try, /*On fail goto*//*Label 8832*/ GIMT_Encode4(437489), // Rule ID 8984 //
     /* 437469 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437472 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 437475 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 437478 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437482 */   // (AArch64uzp2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 437482 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437487 */   GIR_RootConstrainSelectedInstOperands,
     /* 437488 */   // GIR_Coverage, 8984,
     /* 437488 */   GIR_Done,
     /* 437489 */ // Label 8832: @437489
     /* 437489 */ GIM_Reject,
     /* 437490 */ // Label 8804: @437490
     /* 437490 */ GIM_Try, /*On fail goto*//*Label 8833*/ GIMT_Encode4(437536),
     /* 437495 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 437498 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 437501 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437505 */   GIM_Try, /*On fail goto*//*Label 8834*/ GIMT_Encode4(437520), // Rule ID 8979 //
     /* 437510 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437513 */     // (AArch64uzp2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 437513 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437518 */     GIR_RootConstrainSelectedInstOperands,
     /* 437519 */     // GIR_Coverage, 8979,
     /* 437519 */     GIR_Done,
     /* 437520 */   // Label 8834: @437520
     /* 437520 */   GIM_Try, /*On fail goto*//*Label 8835*/ GIMT_Encode4(437535), // Rule ID 8985 //
     /* 437525 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437528 */     // (AArch64uzp2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (UZP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 437528 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_D),
     /* 437533 */     GIR_RootConstrainSelectedInstOperands,
     /* 437534 */     // GIR_Coverage, 8985,
     /* 437534 */     GIR_Done,
     /* 437535 */   // Label 8835: @437535
     /* 437535 */   GIM_Reject,
     /* 437536 */ // Label 8833: @437536
     /* 437536 */ GIM_Reject,
     /* 437537 */ // Label 8805: @437537
     /* 437537 */ GIM_Try, /*On fail goto*//*Label 8836*/ GIMT_Encode4(437562), // Rule ID 9013 //
     /* 437542 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437545 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 437548 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 437551 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437555 */   // (AArch64uzp2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (UZP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 437555 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_S),
     /* 437560 */   GIR_RootConstrainSelectedInstOperands,
     /* 437561 */   // GIR_Coverage, 9013,
     /* 437561 */   GIR_Done,
     /* 437562 */ // Label 8836: @437562
     /* 437562 */ GIM_Reject,
     /* 437563 */ // Label 8806: @437563
     /* 437563 */ GIM_Try, /*On fail goto*//*Label 8837*/ GIMT_Encode4(437588), // Rule ID 8981 //
     /* 437568 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437571 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 437574 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 437577 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437581 */   // (AArch64uzp2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 437581 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437586 */   GIR_RootConstrainSelectedInstOperands,
     /* 437587 */   // GIR_Coverage, 8981,
     /* 437587 */   GIR_Done,
     /* 437588 */ // Label 8837: @437588
     /* 437588 */ GIM_Reject,
     /* 437589 */ // Label 8807: @437589
     /* 437589 */ GIM_Try, /*On fail goto*//*Label 8838*/ GIMT_Encode4(437635),
     /* 437594 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 437597 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 437600 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437604 */   GIM_Try, /*On fail goto*//*Label 8839*/ GIMT_Encode4(437619), // Rule ID 8978 //
     /* 437609 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437612 */     // (AArch64uzp2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 437612 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437617 */     GIR_RootConstrainSelectedInstOperands,
     /* 437618 */     // GIR_Coverage, 8978,
     /* 437618 */     GIR_Done,
     /* 437619 */   // Label 8839: @437619
     /* 437619 */   GIM_Try, /*On fail goto*//*Label 8840*/ GIMT_Encode4(437634), // Rule ID 8982 //
     /* 437624 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437627 */     // (AArch64uzp2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (UZP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 437627 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_S),
     /* 437632 */     GIR_RootConstrainSelectedInstOperands,
     /* 437633 */     // GIR_Coverage, 8982,
     /* 437633 */     GIR_Done,
     /* 437634 */   // Label 8840: @437634
     /* 437634 */   GIM_Reject,
     /* 437635 */ // Label 8838: @437635
     /* 437635 */ GIM_Reject,
     /* 437636 */ // Label 8808: @437636
     /* 437636 */ GIM_Try, /*On fail goto*//*Label 8841*/ GIMT_Encode4(437661), // Rule ID 9012 //
     /* 437641 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437644 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 437647 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 437650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437654 */   // (AArch64uzp2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (UZP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 437654 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_H),
     /* 437659 */   GIR_RootConstrainSelectedInstOperands,
     /* 437660 */   // GIR_Coverage, 9012,
     /* 437660 */   GIR_Done,
     /* 437661 */ // Label 8841: @437661
     /* 437661 */ GIM_Reject,
     /* 437662 */ // Label 8809: @437662
     /* 437662 */ GIM_Try, /*On fail goto*//*Label 8842*/ GIMT_Encode4(437708),
     /* 437667 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 437670 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 437673 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437677 */   GIM_Try, /*On fail goto*//*Label 8843*/ GIMT_Encode4(437692), // Rule ID 8977 //
     /* 437682 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437685 */     // (AArch64uzp2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 437685 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 437690 */     GIR_RootConstrainSelectedInstOperands,
     /* 437691 */     // GIR_Coverage, 8977,
     /* 437691 */     GIR_Done,
     /* 437692 */   // Label 8843: @437692
     /* 437692 */   GIM_Try, /*On fail goto*//*Label 8844*/ GIMT_Encode4(437707), // Rule ID 8980 //
     /* 437697 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437700 */     // (AArch64uzp2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (UZP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 437700 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_H),
     /* 437705 */     GIR_RootConstrainSelectedInstOperands,
     /* 437706 */     // GIR_Coverage, 8980,
     /* 437706 */     GIR_Done,
     /* 437707 */   // Label 8844: @437707
     /* 437707 */   GIM_Reject,
     /* 437708 */ // Label 8842: @437708
     /* 437708 */ GIM_Reject,
     /* 437709 */ // Label 8810: @437709
     /* 437709 */ GIM_Try, /*On fail goto*//*Label 8845*/ GIMT_Encode4(437734), // Rule ID 2410 //
     /* 437714 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437717 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 437720 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 437723 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 437727 */   // (AArch64uzp2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (UZP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 437727 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_PPP_B),
     /* 437732 */   GIR_RootConstrainSelectedInstOperands,
     /* 437733 */   // GIR_Coverage, 2410,
     /* 437733 */   GIR_Done,
     /* 437734 */ // Label 8845: @437734
     /* 437734 */ GIM_Reject,
     /* 437735 */ // Label 8811: @437735
     /* 437735 */ GIM_Try, /*On fail goto*//*Label 8846*/ GIMT_Encode4(437760), // Rule ID 8976 //
     /* 437740 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 437743 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 437746 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 437749 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 437753 */   // (AArch64uzp2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (UZP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 437753 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::UZP2_ZZZ_B),
     /* 437758 */   GIR_RootConstrainSelectedInstOperands,
     /* 437759 */   // GIR_Coverage, 8976,
     /* 437759 */   GIR_Done,
     /* 437760 */ // Label 8846: @437760
     /* 437760 */ GIM_Reject,
     /* 437761 */ // Label 8812: @437761
     /* 437761 */ GIM_Reject,
     /* 437762 */ // Label 150: @437762
     /* 437762 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8855*/ GIMT_Encode4(438459),
     /* 437773 */ /*GILLT_s64*//*Label 8847*/ GIMT_Encode4(437809), GIMT_Encode4(0),
     /* 437781 */ /*GILLT_v2s32*//*Label 8848*/ GIMT_Encode4(437920),
     /* 437785 */ /*GILLT_v2s64*//*Label 8849*/ GIMT_Encode4(437997),
     /* 437789 */ /*GILLT_v4s16*//*Label 8850*/ GIMT_Encode4(438074),
     /* 437793 */ /*GILLT_v4s32*//*Label 8851*/ GIMT_Encode4(438151),
     /* 437797 */ /*GILLT_v8s8*//*Label 8852*/ GIMT_Encode4(438228),
     /* 437801 */ /*GILLT_v8s16*//*Label 8853*/ GIMT_Encode4(438305),
     /* 437805 */ /*GILLT_v16s8*//*Label 8854*/ GIMT_Encode4(438382),
     /* 437809 */ // Label 8847: @437809
     /* 437809 */ GIM_Try, /*On fail goto*//*Label 8856*/ GIMT_Encode4(437919),
     /* 437814 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 437817 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437821 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437825 */   GIM_Try, /*On fail goto*//*Label 8857*/ GIMT_Encode4(437850), // Rule ID 5265 //
     /* 437830 */     // MIs[0] Operand 2
     /* 437830 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 437841 */     // (AArch64vashr:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv1i64rz:{ *:[v1i64] } V64:{ *:[v1i64] }:$Rn)
     /* 437841 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv1i64rz),
     /* 437844 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437846 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437848 */     GIR_RootConstrainSelectedInstOperands,
     /* 437849 */     // GIR_Coverage, 5265,
     /* 437849 */     GIR_EraseRootFromParent_Done,
     /* 437850 */   // Label 8857: @437850
     /* 437850 */   GIM_Try, /*On fail goto*//*Label 8858*/ GIMT_Encode4(437884), // Rule ID 2120 //
     /* 437855 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437858 */     // MIs[0] imm
     /* 437858 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437862 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437866 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437870 */     // MIs[1] Operand 1
     /* 437870 */     // No operand predicates
     /* 437870 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437872 */     // (AArch64vashr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437872 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 437875 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437877 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437879 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437882 */     GIR_RootConstrainSelectedInstOperands,
     /* 437883 */     // GIR_Coverage, 2120,
     /* 437883 */     GIR_EraseRootFromParent_Done,
     /* 437884 */   // Label 8858: @437884
     /* 437884 */   GIM_Try, /*On fail goto*//*Label 8859*/ GIMT_Encode4(437918), // Rule ID 6329 //
     /* 437889 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437892 */     // MIs[0] imm
     /* 437892 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437896 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437900 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 437904 */     // MIs[1] Operand 1
     /* 437904 */     // No operand predicates
     /* 437904 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437906 */     // (AArch64vashr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 437906 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRd),
     /* 437909 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437911 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437913 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437916 */     GIR_RootConstrainSelectedInstOperands,
     /* 437917 */     // GIR_Coverage, 6329,
     /* 437917 */     GIR_EraseRootFromParent_Done,
     /* 437918 */   // Label 8859: @437918
     /* 437918 */   GIM_Reject,
     /* 437919 */ // Label 8856: @437919
     /* 437919 */ GIM_Reject,
     /* 437920 */ // Label 8848: @437920
     /* 437920 */ GIM_Try, /*On fail goto*//*Label 8860*/ GIMT_Encode4(437996),
     /* 437925 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 437928 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437932 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 437936 */   GIM_Try, /*On fail goto*//*Label 8861*/ GIMT_Encode4(437961), // Rule ID 4927 //
     /* 437941 */     // MIs[0] Operand 2
     /* 437941 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 437952 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv2i32rz:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn)
     /* 437952 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i32rz),
     /* 437955 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437957 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437959 */     GIR_RootConstrainSelectedInstOperands,
     /* 437960 */     // GIR_Coverage, 4927,
     /* 437960 */     GIR_EraseRootFromParent_Done,
     /* 437961 */   // Label 8861: @437961
     /* 437961 */   GIM_Try, /*On fail goto*//*Label 8862*/ GIMT_Encode4(437995), // Rule ID 2227 //
     /* 437966 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 437969 */     // MIs[0] imm
     /* 437969 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 437973 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 437977 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 437981 */     // MIs[1] Operand 1
     /* 437981 */     // No operand predicates
     /* 437981 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 437983 */     // (AArch64vashr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 437983 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i32_shift),
     /* 437986 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 437988 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 437990 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 437993 */     GIR_RootConstrainSelectedInstOperands,
     /* 437994 */     // GIR_Coverage, 2227,
     /* 437994 */     GIR_EraseRootFromParent_Done,
     /* 437995 */   // Label 8862: @437995
     /* 437995 */   GIM_Reject,
     /* 437996 */ // Label 8860: @437996
     /* 437996 */ GIM_Reject,
     /* 437997 */ // Label 8849: @437997
     /* 437997 */ GIM_Try, /*On fail goto*//*Label 8863*/ GIMT_Encode4(438073),
     /* 438002 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438005 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438009 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438013 */   GIM_Try, /*On fail goto*//*Label 8864*/ GIMT_Encode4(438038), // Rule ID 4931 //
     /* 438018 */     // MIs[0] Operand 2
     /* 438018 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(63),
     /* 438029 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, 63:{ *:[i32] })  =>  (CMLTv2i64rz:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn)
     /* 438029 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv2i64rz),
     /* 438032 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438034 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438036 */     GIR_RootConstrainSelectedInstOperands,
     /* 438037 */     // GIR_Coverage, 4931,
     /* 438037 */     GIR_EraseRootFromParent_Done,
     /* 438038 */   // Label 8864: @438038
     /* 438038 */   GIM_Try, /*On fail goto*//*Label 8865*/ GIMT_Encode4(438072), // Rule ID 2229 //
     /* 438043 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438046 */     // MIs[0] imm
     /* 438046 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438050 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438054 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438058 */     // MIs[1] Operand 1
     /* 438058 */     // No operand predicates
     /* 438058 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438060 */     // (AArch64vashr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (SSHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438060 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv2i64_shift),
     /* 438063 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438065 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438067 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438070 */     GIR_RootConstrainSelectedInstOperands,
     /* 438071 */     // GIR_Coverage, 2229,
     /* 438071 */     GIR_EraseRootFromParent_Done,
     /* 438072 */   // Label 8865: @438072
     /* 438072 */   GIM_Reject,
     /* 438073 */ // Label 8863: @438073
     /* 438073 */ GIM_Reject,
     /* 438074 */ // Label 8850: @438074
     /* 438074 */ GIM_Try, /*On fail goto*//*Label 8866*/ GIMT_Encode4(438150),
     /* 438079 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438082 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438086 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438090 */   GIM_Try, /*On fail goto*//*Label 8867*/ GIMT_Encode4(438115), // Rule ID 4926 //
     /* 438095 */     // MIs[0] Operand 2
     /* 438095 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 438106 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv4i16rz:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn)
     /* 438106 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i16rz),
     /* 438109 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438111 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438113 */     GIR_RootConstrainSelectedInstOperands,
     /* 438114 */     // GIR_Coverage, 4926,
     /* 438114 */     GIR_EraseRootFromParent_Done,
     /* 438115 */   // Label 8867: @438115
     /* 438115 */   GIM_Try, /*On fail goto*//*Label 8868*/ GIMT_Encode4(438149), // Rule ID 2225 //
     /* 438120 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438123 */     // MIs[0] imm
     /* 438123 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438127 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438131 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438135 */     // MIs[1] Operand 1
     /* 438135 */     // No operand predicates
     /* 438135 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438137 */     // (AArch64vashr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438137 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i16_shift),
     /* 438140 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438142 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438144 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438147 */     GIR_RootConstrainSelectedInstOperands,
     /* 438148 */     // GIR_Coverage, 2225,
     /* 438148 */     GIR_EraseRootFromParent_Done,
     /* 438149 */   // Label 8868: @438149
     /* 438149 */   GIM_Reject,
     /* 438150 */ // Label 8866: @438150
     /* 438150 */ GIM_Reject,
     /* 438151 */ // Label 8851: @438151
     /* 438151 */ GIM_Try, /*On fail goto*//*Label 8869*/ GIMT_Encode4(438227),
     /* 438156 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438159 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438163 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438167 */   GIM_Try, /*On fail goto*//*Label 8870*/ GIMT_Encode4(438192), // Rule ID 4930 //
     /* 438172 */     // MIs[0] Operand 2
     /* 438172 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(31),
     /* 438183 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, 31:{ *:[i32] })  =>  (CMLTv4i32rz:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn)
     /* 438183 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv4i32rz),
     /* 438186 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438188 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438190 */     GIR_RootConstrainSelectedInstOperands,
     /* 438191 */     // GIR_Coverage, 4930,
     /* 438191 */     GIR_EraseRootFromParent_Done,
     /* 438192 */   // Label 8870: @438192
     /* 438192 */   GIM_Try, /*On fail goto*//*Label 8871*/ GIMT_Encode4(438226), // Rule ID 2228 //
     /* 438197 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438200 */     // MIs[0] imm
     /* 438200 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438204 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438208 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438212 */     // MIs[1] Operand 1
     /* 438212 */     // No operand predicates
     /* 438212 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438214 */     // (AArch64vashr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (SSHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438214 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv4i32_shift),
     /* 438217 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438219 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438221 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438224 */     GIR_RootConstrainSelectedInstOperands,
     /* 438225 */     // GIR_Coverage, 2228,
     /* 438225 */     GIR_EraseRootFromParent_Done,
     /* 438226 */   // Label 8871: @438226
     /* 438226 */   GIM_Reject,
     /* 438227 */ // Label 8869: @438227
     /* 438227 */ GIM_Reject,
     /* 438228 */ // Label 8852: @438228
     /* 438228 */ GIM_Try, /*On fail goto*//*Label 8872*/ GIMT_Encode4(438304),
     /* 438233 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438236 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438240 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438244 */   GIM_Try, /*On fail goto*//*Label 8873*/ GIMT_Encode4(438269), // Rule ID 4925 //
     /* 438249 */     // MIs[0] Operand 2
     /* 438249 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 438260 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv8i8rz:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn)
     /* 438260 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i8rz),
     /* 438263 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438265 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438267 */     GIR_RootConstrainSelectedInstOperands,
     /* 438268 */     // GIR_Coverage, 4925,
     /* 438268 */     GIR_EraseRootFromParent_Done,
     /* 438269 */   // Label 8873: @438269
     /* 438269 */   GIM_Try, /*On fail goto*//*Label 8874*/ GIMT_Encode4(438303), // Rule ID 2223 //
     /* 438274 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438277 */     // MIs[0] imm
     /* 438277 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438281 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438285 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438289 */     // MIs[1] Operand 1
     /* 438289 */     // No operand predicates
     /* 438289 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438291 */     // (AArch64vashr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438291 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i8_shift),
     /* 438294 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438296 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438298 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438301 */     GIR_RootConstrainSelectedInstOperands,
     /* 438302 */     // GIR_Coverage, 2223,
     /* 438302 */     GIR_EraseRootFromParent_Done,
     /* 438303 */   // Label 8874: @438303
     /* 438303 */   GIM_Reject,
     /* 438304 */ // Label 8872: @438304
     /* 438304 */ GIM_Reject,
     /* 438305 */ // Label 8853: @438305
     /* 438305 */ GIM_Try, /*On fail goto*//*Label 8875*/ GIMT_Encode4(438381),
     /* 438310 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438313 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438317 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438321 */   GIM_Try, /*On fail goto*//*Label 8876*/ GIMT_Encode4(438346), // Rule ID 4929 //
     /* 438326 */     // MIs[0] Operand 2
     /* 438326 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(15),
     /* 438337 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, 15:{ *:[i32] })  =>  (CMLTv8i16rz:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn)
     /* 438337 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv8i16rz),
     /* 438340 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438342 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438344 */     GIR_RootConstrainSelectedInstOperands,
     /* 438345 */     // GIR_Coverage, 4929,
     /* 438345 */     GIR_EraseRootFromParent_Done,
     /* 438346 */   // Label 8876: @438346
     /* 438346 */   GIM_Try, /*On fail goto*//*Label 8877*/ GIMT_Encode4(438380), // Rule ID 2226 //
     /* 438351 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438354 */     // MIs[0] imm
     /* 438354 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438358 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438362 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438366 */     // MIs[1] Operand 1
     /* 438366 */     // No operand predicates
     /* 438366 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438368 */     // (AArch64vashr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (SSHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438368 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv8i16_shift),
     /* 438371 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438373 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438375 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438378 */     GIR_RootConstrainSelectedInstOperands,
     /* 438379 */     // GIR_Coverage, 2226,
     /* 438379 */     GIR_EraseRootFromParent_Done,
     /* 438380 */   // Label 8877: @438380
     /* 438380 */   GIM_Reject,
     /* 438381 */ // Label 8875: @438381
     /* 438381 */ GIM_Reject,
     /* 438382 */ // Label 8854: @438382
     /* 438382 */ GIM_Try, /*On fail goto*//*Label 8878*/ GIMT_Encode4(438458),
     /* 438387 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438390 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438394 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438398 */   GIM_Try, /*On fail goto*//*Label 8879*/ GIMT_Encode4(438423), // Rule ID 4928 //
     /* 438403 */     // MIs[0] Operand 2
     /* 438403 */     GIM_CheckLiteralInt, /*MI*/0, /*Op*/2, GIMT_Encode8(7),
     /* 438414 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, 7:{ *:[i32] })  =>  (CMLTv16i8rz:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn)
     /* 438414 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::CMLTv16i8rz),
     /* 438417 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438419 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438421 */     GIR_RootConstrainSelectedInstOperands,
     /* 438422 */     // GIR_Coverage, 4928,
     /* 438422 */     GIR_EraseRootFromParent_Done,
     /* 438423 */   // Label 8879: @438423
     /* 438423 */   GIM_Try, /*On fail goto*//*Label 8880*/ GIMT_Encode4(438457), // Rule ID 2224 //
     /* 438428 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438431 */     // MIs[0] imm
     /* 438431 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438435 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438439 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438443 */     // MIs[1] Operand 1
     /* 438443 */     // No operand predicates
     /* 438443 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438445 */     // (AArch64vashr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (SSHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438445 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::SSHRv16i8_shift),
     /* 438448 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438450 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438452 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438455 */     GIR_RootConstrainSelectedInstOperands,
     /* 438456 */     // GIR_Coverage, 2224,
     /* 438456 */     GIR_EraseRootFromParent_Done,
     /* 438457 */   // Label 8880: @438457
     /* 438457 */   GIM_Reject,
     /* 438458 */ // Label 8878: @438458
     /* 438458 */ GIM_Reject,
     /* 438459 */ // Label 8855: @438459
     /* 438459 */ GIM_Reject,
     /* 438460 */ // Label 151: @438460
     /* 438460 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(3), GIMT_Encode2(12), /*)*//*default:*//*Label 8889*/ GIMT_Encode4(438915),
     /* 438471 */ /*GILLT_s64*//*Label 8881*/ GIMT_Encode4(438507), GIMT_Encode4(0),
     /* 438479 */ /*GILLT_v2s32*//*Label 8882*/ GIMT_Encode4(438593),
     /* 438483 */ /*GILLT_v2s64*//*Label 8883*/ GIMT_Encode4(438639),
     /* 438487 */ /*GILLT_v4s16*//*Label 8884*/ GIMT_Encode4(438685),
     /* 438491 */ /*GILLT_v4s32*//*Label 8885*/ GIMT_Encode4(438731),
     /* 438495 */ /*GILLT_v8s8*//*Label 8886*/ GIMT_Encode4(438777),
     /* 438499 */ /*GILLT_v8s16*//*Label 8887*/ GIMT_Encode4(438823),
     /* 438503 */ /*GILLT_v16s8*//*Label 8888*/ GIMT_Encode4(438869),
     /* 438507 */ // Label 8881: @438507
     /* 438507 */ GIM_Try, /*On fail goto*//*Label 8890*/ GIMT_Encode4(438592),
     /* 438512 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_s64,
     /* 438515 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438519 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438523 */   GIM_Try, /*On fail goto*//*Label 8891*/ GIMT_Encode4(438557), // Rule ID 2129 //
     /* 438528 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438531 */     // MIs[0] imm
     /* 438531 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438535 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438539 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438543 */     // MIs[1] Operand 1
     /* 438543 */     // No operand predicates
     /* 438543 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438545 */     // (AArch64vlshr:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[i64] } FPR64:{ *:[i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438545 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 438548 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438550 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438552 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438555 */     GIR_RootConstrainSelectedInstOperands,
     /* 438556 */     // GIR_Coverage, 2129,
     /* 438556 */     GIR_EraseRootFromParent_Done,
     /* 438557 */   // Label 8891: @438557
     /* 438557 */   GIM_Try, /*On fail goto*//*Label 8892*/ GIMT_Encode4(438591), // Rule ID 6332 //
     /* 438562 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438565 */     // MIs[0] imm
     /* 438565 */     GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438569 */     GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438573 */     GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438577 */     // MIs[1] Operand 1
     /* 438577 */     // No operand predicates
     /* 438577 */     GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438579 */     // (AArch64vlshr:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRd:{ *:[v1i64] } FPR64:{ *:[v1i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)
     /* 438579 */     GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRd),
     /* 438582 */     GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438584 */     GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438586 */     GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438589 */     GIR_RootConstrainSelectedInstOperands,
     /* 438590 */     // GIR_Coverage, 6332,
     /* 438590 */     GIR_EraseRootFromParent_Done,
     /* 438591 */   // Label 8892: @438591
     /* 438591 */   GIM_Reject,
     /* 438592 */ // Label 8890: @438592
     /* 438592 */ GIM_Reject,
     /* 438593 */ // Label 8882: @438593
     /* 438593 */ GIM_Try, /*On fail goto*//*Label 8893*/ GIMT_Encode4(438638), // Rule ID 2286 //
     /* 438598 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 438604 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438608 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438612 */   // MIs[0] imm
     /* 438612 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438616 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438620 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438624 */   // MIs[1] Operand 1
     /* 438624 */   // No operand predicates
     /* 438624 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438626 */   // (AArch64vlshr:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv2i32_shift:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438626 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i32_shift),
     /* 438629 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438631 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438633 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438636 */   GIR_RootConstrainSelectedInstOperands,
     /* 438637 */   // GIR_Coverage, 2286,
     /* 438637 */   GIR_EraseRootFromParent_Done,
     /* 438638 */ // Label 8893: @438638
     /* 438638 */ GIM_Reject,
     /* 438639 */ // Label 8883: @438639
     /* 438639 */ GIM_Try, /*On fail goto*//*Label 8894*/ GIMT_Encode4(438684), // Rule ID 2288 //
     /* 438644 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438647 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 438650 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438654 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438658 */   // MIs[0] imm
     /* 438658 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438662 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438666 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR64),
     /* 438670 */   // MIs[1] Operand 1
     /* 438670 */   // No operand predicates
     /* 438670 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438672 */   // (AArch64vlshr:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR64>>:$imm)  =>  (USHRv2i64_shift:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438672 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv2i64_shift),
     /* 438675 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438677 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438679 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438682 */   GIR_RootConstrainSelectedInstOperands,
     /* 438683 */   // GIR_Coverage, 2288,
     /* 438683 */   GIR_EraseRootFromParent_Done,
     /* 438684 */ // Label 8894: @438684
     /* 438684 */ GIM_Reject,
     /* 438685 */ // Label 8884: @438685
     /* 438685 */ GIM_Try, /*On fail goto*//*Label 8895*/ GIMT_Encode4(438730), // Rule ID 2284 //
     /* 438690 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438693 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 438696 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438700 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438704 */   // MIs[0] imm
     /* 438704 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438708 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438712 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438716 */   // MIs[1] Operand 1
     /* 438716 */   // No operand predicates
     /* 438716 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438718 */   // (AArch64vlshr:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv4i16_shift:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438718 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i16_shift),
     /* 438721 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438723 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438725 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438728 */   GIR_RootConstrainSelectedInstOperands,
     /* 438729 */   // GIR_Coverage, 2284,
     /* 438729 */   GIR_EraseRootFromParent_Done,
     /* 438730 */ // Label 8895: @438730
     /* 438730 */ GIM_Reject,
     /* 438731 */ // Label 8885: @438731
     /* 438731 */ GIM_Try, /*On fail goto*//*Label 8896*/ GIMT_Encode4(438776), // Rule ID 2287 //
     /* 438736 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438739 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 438742 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438746 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438750 */   // MIs[0] imm
     /* 438750 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438754 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438758 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR32),
     /* 438762 */   // MIs[1] Operand 1
     /* 438762 */   // No operand predicates
     /* 438762 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438764 */   // (AArch64vlshr:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR32>>:$imm)  =>  (USHRv4i32_shift:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438764 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv4i32_shift),
     /* 438767 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438769 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438771 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438774 */   GIR_RootConstrainSelectedInstOperands,
     /* 438775 */   // GIR_Coverage, 2287,
     /* 438775 */   GIR_EraseRootFromParent_Done,
     /* 438776 */ // Label 8896: @438776
     /* 438776 */ GIM_Reject,
     /* 438777 */ // Label 8886: @438777
     /* 438777 */ GIM_Try, /*On fail goto*//*Label 8897*/ GIMT_Encode4(438822), // Rule ID 2282 //
     /* 438782 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438785 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 438788 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438792 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 438796 */   // MIs[0] imm
     /* 438796 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438800 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438804 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438808 */   // MIs[1] Operand 1
     /* 438808 */   // No operand predicates
     /* 438808 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438810 */   // (AArch64vlshr:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv8i8_shift:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438810 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i8_shift),
     /* 438813 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438815 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438817 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438820 */   GIR_RootConstrainSelectedInstOperands,
     /* 438821 */   // GIR_Coverage, 2282,
     /* 438821 */   GIR_EraseRootFromParent_Done,
     /* 438822 */ // Label 8897: @438822
     /* 438822 */ GIM_Reject,
     /* 438823 */ // Label 8887: @438823
     /* 438823 */ GIM_Try, /*On fail goto*//*Label 8898*/ GIMT_Encode4(438868), // Rule ID 2285 //
     /* 438828 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438831 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 438834 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438838 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438842 */   // MIs[0] imm
     /* 438842 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438846 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438850 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR16),
     /* 438854 */   // MIs[1] Operand 1
     /* 438854 */   // No operand predicates
     /* 438854 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438856 */   // (AArch64vlshr:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR16>>:$imm)  =>  (USHRv8i16_shift:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438856 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv8i16_shift),
     /* 438859 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438861 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438863 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438866 */   GIR_RootConstrainSelectedInstOperands,
     /* 438867 */   // GIR_Coverage, 2285,
     /* 438867 */   GIR_EraseRootFromParent_Done,
     /* 438868 */ // Label 8898: @438868
     /* 438868 */ GIM_Reject,
     /* 438869 */ // Label 8888: @438869
     /* 438869 */ GIM_Try, /*On fail goto*//*Label 8899*/ GIMT_Encode4(438914), // Rule ID 2283 //
     /* 438874 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 438877 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 438880 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438884 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 438888 */   // MIs[0] imm
     /* 438888 */   GIM_RecordInsn, /*DefineMI*/1, /*MI*/0, /*OpIdx*/2, // MIs[1]
     /* 438892 */   GIM_CheckOpcode, /*MI*/1, GIMT_Encode2(TargetOpcode::G_CONSTANT),
     /* 438896 */   GIM_CheckI64ImmPredicate, /*MI*/1, /*Predicate*/GIMT_Encode2(GICXXPred_I64_Predicate_vecshiftR8),
     /* 438900 */   // MIs[1] Operand 1
     /* 438900 */   // No operand predicates
     /* 438900 */   GIM_CheckIsSafeToFold, /*NumInsns*/1,
     /* 438902 */   // (AArch64vlshr:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] })<<P:Predicate_vecshiftR8>>:$imm)  =>  (USHRv16i8_shift:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, (imm:{ *:[i32] }):$imm)
     /* 438902 */   GIR_BuildRootMI, /*Opcode*/GIMT_Encode2(AArch64::USHRv16i8_shift),
     /* 438905 */   GIR_RootToRootCopy, /*OpIdx*/0, // DstI[Rd]
     /* 438907 */   GIR_RootToRootCopy, /*OpIdx*/1, // Rn
     /* 438909 */   GIR_CopyConstantAsSImm, /*NewInsnID*/0, /*OldInsnID*/1, // imm
     /* 438912 */   GIR_RootConstrainSelectedInstOperands,
     /* 438913 */   // GIR_Coverage, 2283,
     /* 438913 */   GIR_EraseRootFromParent_Done,
     /* 438914 */ // Label 8899: @438914
     /* 438914 */ GIM_Reject,
     /* 438915 */ // Label 8889: @438915
     /* 438915 */ GIM_Reject,
     /* 438916 */ // Label 152: @438916
     /* 438916 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8918*/ GIMT_Encode4(439695),
     /* 438927 */ /*GILLT_v2s32*//*Label 8900*/ GIMT_Encode4(439003),
     /* 438931 */ /*GILLT_v2s64*//*Label 8901*/ GIMT_Encode4(439058),
     /* 438935 */ /*GILLT_v4s16*//*Label 8902*/ GIMT_Encode4(439113),
     /* 438939 */ /*GILLT_v4s32*//*Label 8903*/ GIMT_Encode4(439168),
     /* 438943 */ /*GILLT_v8s8*//*Label 8904*/ GIMT_Encode4(439223),
     /* 438947 */ /*GILLT_v8s16*//*Label 8905*/ GIMT_Encode4(439257),
     /* 438951 */ /*GILLT_v16s8*//*Label 8906*/ GIMT_Encode4(439312), GIMT_Encode4(0),
     /* 438959 */ /*GILLT_nxv2s1*//*Label 8907*/ GIMT_Encode4(439346),
     /* 438963 */ /*GILLT_nxv2s16*//*Label 8908*/ GIMT_Encode4(439372),
     /* 438967 */ /*GILLT_nxv2s32*//*Label 8909*/ GIMT_Encode4(439398),
     /* 438971 */ /*GILLT_nxv2s64*//*Label 8910*/ GIMT_Encode4(439424),
     /* 438975 */ /*GILLT_nxv4s1*//*Label 8911*/ GIMT_Encode4(439471),
     /* 438979 */ /*GILLT_nxv4s16*//*Label 8912*/ GIMT_Encode4(439497),
     /* 438983 */ /*GILLT_nxv4s32*//*Label 8913*/ GIMT_Encode4(439523),
     /* 438987 */ /*GILLT_nxv8s1*//*Label 8914*/ GIMT_Encode4(439570),
     /* 438991 */ /*GILLT_nxv8s16*//*Label 8915*/ GIMT_Encode4(439596),
     /* 438995 */ /*GILLT_nxv16s1*//*Label 8916*/ GIMT_Encode4(439643),
     /* 438999 */ /*GILLT_nxv16s8*//*Label 8917*/ GIMT_Encode4(439669),
     /* 439003 */ // Label 8900: @439003
     /* 439003 */ GIM_Try, /*On fail goto*//*Label 8919*/ GIMT_Encode4(439057),
     /* 439008 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439011 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 439014 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439018 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439022 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439026 */   GIM_Try, /*On fail goto*//*Label 8920*/ GIMT_Encode4(439041), // Rule ID 1902 //
     /* 439031 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439034 */     // (AArch64zip1:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 439034 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 439039 */     GIR_RootConstrainSelectedInstOperands,
     /* 439040 */     // GIR_Coverage, 1902,
     /* 439040 */     GIR_Done,
     /* 439041 */   // Label 8920: @439041
     /* 439041 */   GIM_Try, /*On fail goto*//*Label 8921*/ GIMT_Encode4(439056), // Rule ID 5498 //
     /* 439046 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439049 */     // (AArch64zip1:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP1v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 439049 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i32),
     /* 439054 */     GIR_RootConstrainSelectedInstOperands,
     /* 439055 */     // GIR_Coverage, 5498,
     /* 439055 */     GIR_Done,
     /* 439056 */   // Label 8921: @439056
     /* 439056 */   GIM_Reject,
     /* 439057 */ // Label 8919: @439057
     /* 439057 */ GIM_Reject,
     /* 439058 */ // Label 8901: @439058
     /* 439058 */ GIM_Try, /*On fail goto*//*Label 8922*/ GIMT_Encode4(439112),
     /* 439063 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439066 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 439069 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439073 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439077 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439081 */   GIM_Try, /*On fail goto*//*Label 8923*/ GIMT_Encode4(439096), // Rule ID 1904 //
     /* 439086 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439089 */     // (AArch64zip1:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 439089 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 439094 */     GIR_RootConstrainSelectedInstOperands,
     /* 439095 */     // GIR_Coverage, 1904,
     /* 439095 */     GIR_Done,
     /* 439096 */   // Label 8923: @439096
     /* 439096 */   GIM_Try, /*On fail goto*//*Label 8924*/ GIMT_Encode4(439111), // Rule ID 5500 //
     /* 439101 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439104 */     // (AArch64zip1:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP1v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 439104 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v2i64),
     /* 439109 */     GIR_RootConstrainSelectedInstOperands,
     /* 439110 */     // GIR_Coverage, 5500,
     /* 439110 */     GIR_Done,
     /* 439111 */   // Label 8924: @439111
     /* 439111 */   GIM_Reject,
     /* 439112 */ // Label 8922: @439112
     /* 439112 */ GIM_Reject,
     /* 439113 */ // Label 8902: @439113
     /* 439113 */ GIM_Try, /*On fail goto*//*Label 8925*/ GIMT_Encode4(439167),
     /* 439118 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439121 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 439124 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439128 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439132 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439136 */   GIM_Try, /*On fail goto*//*Label 8926*/ GIMT_Encode4(439151), // Rule ID 1900 //
     /* 439141 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439144 */     // (AArch64zip1:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 439144 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 439149 */     GIR_RootConstrainSelectedInstOperands,
     /* 439150 */     // GIR_Coverage, 1900,
     /* 439150 */     GIR_Done,
     /* 439151 */   // Label 8926: @439151
     /* 439151 */   GIM_Try, /*On fail goto*//*Label 8927*/ GIMT_Encode4(439166), // Rule ID 5496 //
     /* 439156 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439159 */     // (AArch64zip1:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP1v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 439159 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i16),
     /* 439164 */     GIR_RootConstrainSelectedInstOperands,
     /* 439165 */     // GIR_Coverage, 5496,
     /* 439165 */     GIR_Done,
     /* 439166 */   // Label 8927: @439166
     /* 439166 */   GIM_Reject,
     /* 439167 */ // Label 8925: @439167
     /* 439167 */ GIM_Reject,
     /* 439168 */ // Label 8903: @439168
     /* 439168 */ GIM_Try, /*On fail goto*//*Label 8928*/ GIMT_Encode4(439222),
     /* 439173 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439176 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 439179 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439183 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439187 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439191 */   GIM_Try, /*On fail goto*//*Label 8929*/ GIMT_Encode4(439206), // Rule ID 1903 //
     /* 439196 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439199 */     // (AArch64zip1:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 439199 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 439204 */     GIR_RootConstrainSelectedInstOperands,
     /* 439205 */     // GIR_Coverage, 1903,
     /* 439205 */     GIR_Done,
     /* 439206 */   // Label 8929: @439206
     /* 439206 */   GIM_Try, /*On fail goto*//*Label 8930*/ GIMT_Encode4(439221), // Rule ID 5499 //
     /* 439211 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439214 */     // (AArch64zip1:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP1v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 439214 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v4i32),
     /* 439219 */     GIR_RootConstrainSelectedInstOperands,
     /* 439220 */     // GIR_Coverage, 5499,
     /* 439220 */     GIR_Done,
     /* 439221 */   // Label 8930: @439221
     /* 439221 */   GIM_Reject,
     /* 439222 */ // Label 8928: @439222
     /* 439222 */ GIM_Reject,
     /* 439223 */ // Label 8904: @439223
     /* 439223 */ GIM_Try, /*On fail goto*//*Label 8931*/ GIMT_Encode4(439256), // Rule ID 1898 //
     /* 439228 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439231 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 439234 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 439237 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439241 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439245 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439249 */   // (AArch64zip1:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP1v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 439249 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i8),
     /* 439254 */   GIR_RootConstrainSelectedInstOperands,
     /* 439255 */   // GIR_Coverage, 1898,
     /* 439255 */   GIR_Done,
     /* 439256 */ // Label 8931: @439256
     /* 439256 */ GIM_Reject,
     /* 439257 */ // Label 8905: @439257
     /* 439257 */ GIM_Try, /*On fail goto*//*Label 8932*/ GIMT_Encode4(439311),
     /* 439262 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 439265 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 439268 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439272 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439276 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439280 */   GIM_Try, /*On fail goto*//*Label 8933*/ GIMT_Encode4(439295), // Rule ID 1901 //
     /* 439285 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439288 */     // (AArch64zip1:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 439288 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 439293 */     GIR_RootConstrainSelectedInstOperands,
     /* 439294 */     // GIR_Coverage, 1901,
     /* 439294 */     GIR_Done,
     /* 439295 */   // Label 8933: @439295
     /* 439295 */   GIM_Try, /*On fail goto*//*Label 8934*/ GIMT_Encode4(439310), // Rule ID 5497 //
     /* 439300 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439303 */     // (AArch64zip1:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP1v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 439303 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v8i16),
     /* 439308 */     GIR_RootConstrainSelectedInstOperands,
     /* 439309 */     // GIR_Coverage, 5497,
     /* 439309 */     GIR_Done,
     /* 439310 */   // Label 8934: @439310
     /* 439310 */   GIM_Reject,
     /* 439311 */ // Label 8932: @439311
     /* 439311 */ GIM_Reject,
     /* 439312 */ // Label 8906: @439312
     /* 439312 */ GIM_Try, /*On fail goto*//*Label 8935*/ GIMT_Encode4(439345), // Rule ID 1899 //
     /* 439317 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439320 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 439323 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 439326 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439330 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439334 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439338 */   // (AArch64zip1:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP1v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 439338 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1v16i8),
     /* 439343 */   GIR_RootConstrainSelectedInstOperands,
     /* 439344 */   // GIR_Coverage, 1899,
     /* 439344 */   GIR_Done,
     /* 439345 */ // Label 8935: @439345
     /* 439345 */ GIM_Reject,
     /* 439346 */ // Label 8907: @439346
     /* 439346 */ GIM_Try, /*On fail goto*//*Label 8936*/ GIMT_Encode4(439371), // Rule ID 3344 //
     /* 439351 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439354 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 439357 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 439360 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439364 */   // (AArch64zip1:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP1_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 439364 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_D),
     /* 439369 */   GIR_RootConstrainSelectedInstOperands,
     /* 439370 */   // GIR_Coverage, 3344,
     /* 439370 */   GIR_Done,
     /* 439371 */ // Label 8936: @439371
     /* 439371 */ GIM_Reject,
     /* 439372 */ // Label 8908: @439372
     /* 439372 */ GIM_Try, /*On fail goto*//*Label 8937*/ GIMT_Encode4(439397), // Rule ID 2875 //
     /* 439377 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439380 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 439383 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 439386 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439390 */   // (AArch64zip1:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 439390 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439395 */   GIR_RootConstrainSelectedInstOperands,
     /* 439396 */   // GIR_Coverage, 2875,
     /* 439396 */   GIR_Done,
     /* 439397 */ // Label 8937: @439397
     /* 439397 */ GIM_Reject,
     /* 439398 */ // Label 8909: @439398
     /* 439398 */ GIM_Try, /*On fail goto*//*Label 8938*/ GIMT_Encode4(439423), // Rule ID 2876 //
     /* 439403 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439406 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 439409 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 439412 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439416 */   // (AArch64zip1:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 439416 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439421 */   GIR_RootConstrainSelectedInstOperands,
     /* 439422 */   // GIR_Coverage, 2876,
     /* 439422 */   GIR_Done,
     /* 439423 */ // Label 8938: @439423
     /* 439423 */ GIM_Reject,
     /* 439424 */ // Label 8910: @439424
     /* 439424 */ GIM_Try, /*On fail goto*//*Label 8939*/ GIMT_Encode4(439470),
     /* 439429 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 439432 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 439435 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439439 */   GIM_Try, /*On fail goto*//*Label 8940*/ GIMT_Encode4(439454), // Rule ID 2871 //
     /* 439444 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439447 */     // (AArch64zip1:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 439447 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439452 */     GIR_RootConstrainSelectedInstOperands,
     /* 439453 */     // GIR_Coverage, 2871,
     /* 439453 */     GIR_Done,
     /* 439454 */   // Label 8940: @439454
     /* 439454 */   GIM_Try, /*On fail goto*//*Label 8941*/ GIMT_Encode4(439469), // Rule ID 2877 //
     /* 439459 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439462 */     // (AArch64zip1:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP1_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 439462 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_D),
     /* 439467 */     GIR_RootConstrainSelectedInstOperands,
     /* 439468 */     // GIR_Coverage, 2877,
     /* 439468 */     GIR_Done,
     /* 439469 */   // Label 8941: @439469
     /* 439469 */   GIM_Reject,
     /* 439470 */ // Label 8939: @439470
     /* 439470 */ GIM_Reject,
     /* 439471 */ // Label 8911: @439471
     /* 439471 */ GIM_Try, /*On fail goto*//*Label 8942*/ GIMT_Encode4(439496), // Rule ID 3343 //
     /* 439476 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439479 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 439482 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 439485 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439489 */   // (AArch64zip1:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP1_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 439489 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_S),
     /* 439494 */   GIR_RootConstrainSelectedInstOperands,
     /* 439495 */   // GIR_Coverage, 3343,
     /* 439495 */   GIR_Done,
     /* 439496 */ // Label 8942: @439496
     /* 439496 */ GIM_Reject,
     /* 439497 */ // Label 8912: @439497
     /* 439497 */ GIM_Try, /*On fail goto*//*Label 8943*/ GIMT_Encode4(439522), // Rule ID 2873 //
     /* 439502 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439505 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 439508 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 439511 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439515 */   // (AArch64zip1:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 439515 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439520 */   GIR_RootConstrainSelectedInstOperands,
     /* 439521 */   // GIR_Coverage, 2873,
     /* 439521 */   GIR_Done,
     /* 439522 */ // Label 8943: @439522
     /* 439522 */ GIM_Reject,
     /* 439523 */ // Label 8913: @439523
     /* 439523 */ GIM_Try, /*On fail goto*//*Label 8944*/ GIMT_Encode4(439569),
     /* 439528 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 439531 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 439534 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439538 */   GIM_Try, /*On fail goto*//*Label 8945*/ GIMT_Encode4(439553), // Rule ID 2870 //
     /* 439543 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439546 */     // (AArch64zip1:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 439546 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439551 */     GIR_RootConstrainSelectedInstOperands,
     /* 439552 */     // GIR_Coverage, 2870,
     /* 439552 */     GIR_Done,
     /* 439553 */   // Label 8945: @439553
     /* 439553 */   GIM_Try, /*On fail goto*//*Label 8946*/ GIMT_Encode4(439568), // Rule ID 2874 //
     /* 439558 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439561 */     // (AArch64zip1:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP1_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 439561 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_S),
     /* 439566 */     GIR_RootConstrainSelectedInstOperands,
     /* 439567 */     // GIR_Coverage, 2874,
     /* 439567 */     GIR_Done,
     /* 439568 */   // Label 8946: @439568
     /* 439568 */   GIM_Reject,
     /* 439569 */ // Label 8944: @439569
     /* 439569 */ GIM_Reject,
     /* 439570 */ // Label 8914: @439570
     /* 439570 */ GIM_Try, /*On fail goto*//*Label 8947*/ GIMT_Encode4(439595), // Rule ID 3342 //
     /* 439575 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439578 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 439581 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 439584 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439588 */   // (AArch64zip1:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP1_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 439588 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_H),
     /* 439593 */   GIR_RootConstrainSelectedInstOperands,
     /* 439594 */   // GIR_Coverage, 3342,
     /* 439594 */   GIR_Done,
     /* 439595 */ // Label 8947: @439595
     /* 439595 */ GIM_Reject,
     /* 439596 */ // Label 8915: @439596
     /* 439596 */ GIM_Try, /*On fail goto*//*Label 8948*/ GIMT_Encode4(439642),
     /* 439601 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 439604 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 439607 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439611 */   GIM_Try, /*On fail goto*//*Label 8949*/ GIMT_Encode4(439626), // Rule ID 2869 //
     /* 439616 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439619 */     // (AArch64zip1:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 439619 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 439624 */     GIR_RootConstrainSelectedInstOperands,
     /* 439625 */     // GIR_Coverage, 2869,
     /* 439625 */     GIR_Done,
     /* 439626 */   // Label 8949: @439626
     /* 439626 */   GIM_Try, /*On fail goto*//*Label 8950*/ GIMT_Encode4(439641), // Rule ID 2872 //
     /* 439631 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439634 */     // (AArch64zip1:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP1_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 439634 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_H),
     /* 439639 */     GIR_RootConstrainSelectedInstOperands,
     /* 439640 */     // GIR_Coverage, 2872,
     /* 439640 */     GIR_Done,
     /* 439641 */   // Label 8950: @439641
     /* 439641 */   GIM_Reject,
     /* 439642 */ // Label 8948: @439642
     /* 439642 */ GIM_Reject,
     /* 439643 */ // Label 8916: @439643
     /* 439643 */ GIM_Try, /*On fail goto*//*Label 8951*/ GIMT_Encode4(439668), // Rule ID 2398 //
     /* 439648 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439651 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 439654 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 439657 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 439661 */   // (AArch64zip1:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP1_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 439661 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_PPP_B),
     /* 439666 */   GIR_RootConstrainSelectedInstOperands,
     /* 439667 */   // GIR_Coverage, 2398,
     /* 439667 */   GIR_Done,
     /* 439668 */ // Label 8951: @439668
     /* 439668 */ GIM_Reject,
     /* 439669 */ // Label 8917: @439669
     /* 439669 */ GIM_Try, /*On fail goto*//*Label 8952*/ GIMT_Encode4(439694), // Rule ID 2868 //
     /* 439674 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 439677 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 439680 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 439683 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 439687 */   // (AArch64zip1:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP1_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 439687 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP1_ZZZ_B),
     /* 439692 */   GIR_RootConstrainSelectedInstOperands,
     /* 439693 */   // GIR_Coverage, 2868,
     /* 439693 */   GIR_Done,
     /* 439694 */ // Label 8952: @439694
     /* 439694 */ GIM_Reject,
     /* 439695 */ // Label 8918: @439695
     /* 439695 */ GIM_Reject,
     /* 439696 */ // Label 153: @439696
     /* 439696 */ GIM_SwitchType, /*MI*/0, /*Op*/0, /*[*/GIMT_Encode2(5), GIMT_Encode2(24), /*)*//*default:*//*Label 8971*/ GIMT_Encode4(440475),
     /* 439707 */ /*GILLT_v2s32*//*Label 8953*/ GIMT_Encode4(439783),
     /* 439711 */ /*GILLT_v2s64*//*Label 8954*/ GIMT_Encode4(439838),
     /* 439715 */ /*GILLT_v4s16*//*Label 8955*/ GIMT_Encode4(439893),
     /* 439719 */ /*GILLT_v4s32*//*Label 8956*/ GIMT_Encode4(439948),
     /* 439723 */ /*GILLT_v8s8*//*Label 8957*/ GIMT_Encode4(440003),
     /* 439727 */ /*GILLT_v8s16*//*Label 8958*/ GIMT_Encode4(440037),
     /* 439731 */ /*GILLT_v16s8*//*Label 8959*/ GIMT_Encode4(440092), GIMT_Encode4(0),
     /* 439739 */ /*GILLT_nxv2s1*//*Label 8960*/ GIMT_Encode4(440126),
     /* 439743 */ /*GILLT_nxv2s16*//*Label 8961*/ GIMT_Encode4(440152),
     /* 439747 */ /*GILLT_nxv2s32*//*Label 8962*/ GIMT_Encode4(440178),
     /* 439751 */ /*GILLT_nxv2s64*//*Label 8963*/ GIMT_Encode4(440204),
     /* 439755 */ /*GILLT_nxv4s1*//*Label 8964*/ GIMT_Encode4(440251),
     /* 439759 */ /*GILLT_nxv4s16*//*Label 8965*/ GIMT_Encode4(440277),
     /* 439763 */ /*GILLT_nxv4s32*//*Label 8966*/ GIMT_Encode4(440303),
     /* 439767 */ /*GILLT_nxv8s1*//*Label 8967*/ GIMT_Encode4(440350),
     /* 439771 */ /*GILLT_nxv8s16*//*Label 8968*/ GIMT_Encode4(440376),
     /* 439775 */ /*GILLT_nxv16s1*//*Label 8969*/ GIMT_Encode4(440423),
     /* 439779 */ /*GILLT_nxv16s8*//*Label 8970*/ GIMT_Encode4(440449),
     /* 439783 */ // Label 8953: @439783
     /* 439783 */ GIM_Try, /*On fail goto*//*Label 8972*/ GIMT_Encode4(439837),
     /* 439788 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s32,
     /* 439791 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s32,
     /* 439794 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439798 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439802 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439806 */   GIM_Try, /*On fail goto*//*Label 8973*/ GIMT_Encode4(439821), // Rule ID 1909 //
     /* 439811 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439814 */     // (AArch64zip2:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2i32] } V64:{ *:[v2i32] }:$Rn, V64:{ *:[v2i32] }:$Rm)
     /* 439814 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 439819 */     GIR_RootConstrainSelectedInstOperands,
     /* 439820 */     // GIR_Coverage, 1909,
     /* 439820 */     GIR_Done,
     /* 439821 */   // Label 8973: @439821
     /* 439821 */   GIM_Try, /*On fail goto*//*Label 8974*/ GIMT_Encode4(439836), // Rule ID 5503 //
     /* 439826 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439829 */     // (AArch64zip2:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)  =>  (ZIP2v2i32:{ *:[v2f32] } V64:{ *:[v2f32] }:$Rn, V64:{ *:[v2f32] }:$Rm)
     /* 439829 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i32),
     /* 439834 */     GIR_RootConstrainSelectedInstOperands,
     /* 439835 */     // GIR_Coverage, 5503,
     /* 439835 */     GIR_Done,
     /* 439836 */   // Label 8974: @439836
     /* 439836 */   GIM_Reject,
     /* 439837 */ // Label 8972: @439837
     /* 439837 */ GIM_Reject,
     /* 439838 */ // Label 8954: @439838
     /* 439838 */ GIM_Try, /*On fail goto*//*Label 8975*/ GIMT_Encode4(439892),
     /* 439843 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v2s64,
     /* 439846 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v2s64,
     /* 439849 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439853 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439857 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439861 */   GIM_Try, /*On fail goto*//*Label 8976*/ GIMT_Encode4(439876), // Rule ID 1911 //
     /* 439866 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439869 */     // (AArch64zip2:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2i64] } V128:{ *:[v2i64] }:$Rn, V128:{ *:[v2i64] }:$Rm)
     /* 439869 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 439874 */     GIR_RootConstrainSelectedInstOperands,
     /* 439875 */     // GIR_Coverage, 1911,
     /* 439875 */     GIR_Done,
     /* 439876 */   // Label 8976: @439876
     /* 439876 */   GIM_Try, /*On fail goto*//*Label 8977*/ GIMT_Encode4(439891), // Rule ID 5505 //
     /* 439881 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439884 */     // (AArch64zip2:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)  =>  (ZIP2v2i64:{ *:[v2f64] } V128:{ *:[v2f64] }:$Rn, V128:{ *:[v2f64] }:$Rm)
     /* 439884 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v2i64),
     /* 439889 */     GIR_RootConstrainSelectedInstOperands,
     /* 439890 */     // GIR_Coverage, 5505,
     /* 439890 */     GIR_Done,
     /* 439891 */   // Label 8977: @439891
     /* 439891 */   GIM_Reject,
     /* 439892 */ // Label 8975: @439892
     /* 439892 */ GIM_Reject,
     /* 439893 */ // Label 8955: @439893
     /* 439893 */ GIM_Try, /*On fail goto*//*Label 8978*/ GIMT_Encode4(439947),
     /* 439898 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s16,
     /* 439901 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s16,
     /* 439904 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439908 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439912 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 439916 */   GIM_Try, /*On fail goto*//*Label 8979*/ GIMT_Encode4(439931), // Rule ID 1907 //
     /* 439921 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439924 */     // (AArch64zip2:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4i16] } V64:{ *:[v4i16] }:$Rn, V64:{ *:[v4i16] }:$Rm)
     /* 439924 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 439929 */     GIR_RootConstrainSelectedInstOperands,
     /* 439930 */     // GIR_Coverage, 1907,
     /* 439930 */     GIR_Done,
     /* 439931 */   // Label 8979: @439931
     /* 439931 */   GIM_Try, /*On fail goto*//*Label 8980*/ GIMT_Encode4(439946), // Rule ID 5501 //
     /* 439936 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439939 */     // (AArch64zip2:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)  =>  (ZIP2v4i16:{ *:[v4f16] } V64:{ *:[v4f16] }:$Rn, V64:{ *:[v4f16] }:$Rm)
     /* 439939 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i16),
     /* 439944 */     GIR_RootConstrainSelectedInstOperands,
     /* 439945 */     // GIR_Coverage, 5501,
     /* 439945 */     GIR_Done,
     /* 439946 */   // Label 8980: @439946
     /* 439946 */   GIM_Reject,
     /* 439947 */ // Label 8978: @439947
     /* 439947 */ GIM_Reject,
     /* 439948 */ // Label 8956: @439948
     /* 439948 */ GIM_Try, /*On fail goto*//*Label 8981*/ GIMT_Encode4(440002),
     /* 439953 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v4s32,
     /* 439956 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v4s32,
     /* 439959 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439963 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439967 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 439971 */   GIM_Try, /*On fail goto*//*Label 8982*/ GIMT_Encode4(439986), // Rule ID 1910 //
     /* 439976 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439979 */     // (AArch64zip2:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4i32] } V128:{ *:[v4i32] }:$Rn, V128:{ *:[v4i32] }:$Rm)
     /* 439979 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 439984 */     GIR_RootConstrainSelectedInstOperands,
     /* 439985 */     // GIR_Coverage, 1910,
     /* 439985 */     GIR_Done,
     /* 439986 */   // Label 8982: @439986
     /* 439986 */   GIM_Try, /*On fail goto*//*Label 8983*/ GIMT_Encode4(440001), // Rule ID 5504 //
     /* 439991 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 439994 */     // (AArch64zip2:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)  =>  (ZIP2v4i32:{ *:[v4f32] } V128:{ *:[v4f32] }:$Rn, V128:{ *:[v4f32] }:$Rm)
     /* 439994 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v4i32),
     /* 439999 */     GIR_RootConstrainSelectedInstOperands,
     /* 440000 */     // GIR_Coverage, 5504,
     /* 440000 */     GIR_Done,
     /* 440001 */   // Label 8983: @440001
     /* 440001 */   GIM_Reject,
     /* 440002 */ // Label 8981: @440002
     /* 440002 */ GIM_Reject,
     /* 440003 */ // Label 8957: @440003
     /* 440003 */ GIM_Try, /*On fail goto*//*Label 8984*/ GIMT_Encode4(440036), // Rule ID 1905 //
     /* 440008 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440011 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s8,
     /* 440014 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s8,
     /* 440017 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440021 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440025 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR64RegClassID),
     /* 440029 */   // (AArch64zip2:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)  =>  (ZIP2v8i8:{ *:[v8i8] } V64:{ *:[v8i8] }:$Rn, V64:{ *:[v8i8] }:$Rm)
     /* 440029 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i8),
     /* 440034 */   GIR_RootConstrainSelectedInstOperands,
     /* 440035 */   // GIR_Coverage, 1905,
     /* 440035 */   GIR_Done,
     /* 440036 */ // Label 8984: @440036
     /* 440036 */ GIM_Reject,
     /* 440037 */ // Label 8958: @440037
     /* 440037 */ GIM_Try, /*On fail goto*//*Label 8985*/ GIMT_Encode4(440091),
     /* 440042 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v8s16,
     /* 440045 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v8s16,
     /* 440048 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440052 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440056 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440060 */   GIM_Try, /*On fail goto*//*Label 8986*/ GIMT_Encode4(440075), // Rule ID 1908 //
     /* 440065 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440068 */     // (AArch64zip2:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8i16] } V128:{ *:[v8i16] }:$Rn, V128:{ *:[v8i16] }:$Rm)
     /* 440068 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 440073 */     GIR_RootConstrainSelectedInstOperands,
     /* 440074 */     // GIR_Coverage, 1908,
     /* 440074 */     GIR_Done,
     /* 440075 */   // Label 8986: @440075
     /* 440075 */   GIM_Try, /*On fail goto*//*Label 8987*/ GIMT_Encode4(440090), // Rule ID 5502 //
     /* 440080 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440083 */     // (AArch64zip2:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)  =>  (ZIP2v8i16:{ *:[v8f16] } V128:{ *:[v8f16] }:$Rn, V128:{ *:[v8f16] }:$Rm)
     /* 440083 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v8i16),
     /* 440088 */     GIR_RootConstrainSelectedInstOperands,
     /* 440089 */     // GIR_Coverage, 5502,
     /* 440089 */     GIR_Done,
     /* 440090 */   // Label 8987: @440090
     /* 440090 */   GIM_Reject,
     /* 440091 */ // Label 8985: @440091
     /* 440091 */ GIM_Reject,
     /* 440092 */ // Label 8959: @440092
     /* 440092 */ GIM_Try, /*On fail goto*//*Label 8988*/ GIMT_Encode4(440125), // Rule ID 1906 //
     /* 440097 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasNEON),
     /* 440100 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_v16s8,
     /* 440103 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_v16s8,
     /* 440106 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440110 */   GIM_RootCheckRegBankForClass, /*Op*/1, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440114 */   GIM_RootCheckRegBankForClass, /*Op*/2, /*RC*/GIMT_Encode2(AArch64::FPR128RegClassID),
     /* 440118 */   // (AArch64zip2:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)  =>  (ZIP2v16i8:{ *:[v16i8] } V128:{ *:[v16i8] }:$Rn, V128:{ *:[v16i8] }:$Rm)
     /* 440118 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2v16i8),
     /* 440123 */   GIR_RootConstrainSelectedInstOperands,
     /* 440124 */   // GIR_Coverage, 1906,
     /* 440124 */   GIR_Done,
     /* 440125 */ // Label 8988: @440125
     /* 440125 */ GIM_Reject,
     /* 440126 */ // Label 8960: @440126
     /* 440126 */ GIM_Try, /*On fail goto*//*Label 8989*/ GIMT_Encode4(440151), // Rule ID 9008 //
     /* 440131 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440134 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s1,
     /* 440137 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s1,
     /* 440140 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440144 */   // (AArch64zip2:{ *:[nxv2i1] } nxv2i1:{ *:[nxv2i1] }:$Op1, nxv2i1:{ *:[nxv2i1] }:$Op2)  =>  (ZIP2_PPP_D:{ *:[nxv2i1] } ?:{ *:[nxv2i1] }:$Op1, ?:{ *:[nxv2i1] }:$Op2)
     /* 440144 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_D),
     /* 440149 */   GIR_RootConstrainSelectedInstOperands,
     /* 440150 */   // GIR_Coverage, 9008,
     /* 440150 */   GIR_Done,
     /* 440151 */ // Label 8989: @440151
     /* 440151 */ GIM_Reject,
     /* 440152 */ // Label 8961: @440152
     /* 440152 */ GIM_Try, /*On fail goto*//*Label 8990*/ GIMT_Encode4(440177), // Rule ID 8963 //
     /* 440157 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440160 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s16,
     /* 440163 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s16,
     /* 440166 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440170 */   // (AArch64zip2:{ *:[nxv2f16] } nxv2f16:{ *:[nxv2f16] }:$Op1, nxv2f16:{ *:[nxv2f16] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f16] } ?:{ *:[nxv2f16] }:$Op1, ?:{ *:[nxv2f16] }:$Op2)
     /* 440170 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440175 */   GIR_RootConstrainSelectedInstOperands,
     /* 440176 */   // GIR_Coverage, 8963,
     /* 440176 */   GIR_Done,
     /* 440177 */ // Label 8990: @440177
     /* 440177 */ GIM_Reject,
     /* 440178 */ // Label 8962: @440178
     /* 440178 */ GIM_Try, /*On fail goto*//*Label 8991*/ GIMT_Encode4(440203), // Rule ID 8964 //
     /* 440183 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440186 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s32,
     /* 440189 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s32,
     /* 440192 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440196 */   // (AArch64zip2:{ *:[nxv2f32] } nxv2f32:{ *:[nxv2f32] }:$Op1, nxv2f32:{ *:[nxv2f32] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f32] } ?:{ *:[nxv2f32] }:$Op1, ?:{ *:[nxv2f32] }:$Op2)
     /* 440196 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440201 */   GIR_RootConstrainSelectedInstOperands,
     /* 440202 */   // GIR_Coverage, 8964,
     /* 440202 */   GIR_Done,
     /* 440203 */ // Label 8991: @440203
     /* 440203 */ GIM_Reject,
     /* 440204 */ // Label 8963: @440204
     /* 440204 */ GIM_Try, /*On fail goto*//*Label 8992*/ GIMT_Encode4(440250),
     /* 440209 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv2s64,
     /* 440212 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv2s64,
     /* 440215 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440219 */   GIM_Try, /*On fail goto*//*Label 8993*/ GIMT_Encode4(440234), // Rule ID 8959 //
     /* 440224 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440227 */     // (AArch64zip2:{ *:[nxv2i64] } nxv2i64:{ *:[nxv2i64] }:$Op1, nxv2i64:{ *:[nxv2i64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2i64] } ?:{ *:[nxv2i64] }:$Op1, ?:{ *:[nxv2i64] }:$Op2)
     /* 440227 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440232 */     GIR_RootConstrainSelectedInstOperands,
     /* 440233 */     // GIR_Coverage, 8959,
     /* 440233 */     GIR_Done,
     /* 440234 */   // Label 8993: @440234
     /* 440234 */   GIM_Try, /*On fail goto*//*Label 8994*/ GIMT_Encode4(440249), // Rule ID 8965 //
     /* 440239 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440242 */     // (AArch64zip2:{ *:[nxv2f64] } nxv2f64:{ *:[nxv2f64] }:$Op1, nxv2f64:{ *:[nxv2f64] }:$Op2)  =>  (ZIP2_ZZZ_D:{ *:[nxv2f64] } ?:{ *:[nxv2f64] }:$Op1, ?:{ *:[nxv2f64] }:$Op2)
     /* 440242 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_D),
     /* 440247 */     GIR_RootConstrainSelectedInstOperands,
     /* 440248 */     // GIR_Coverage, 8965,
     /* 440248 */     GIR_Done,
     /* 440249 */   // Label 8994: @440249
     /* 440249 */   GIM_Reject,
     /* 440250 */ // Label 8992: @440250
     /* 440250 */ GIM_Reject,
     /* 440251 */ // Label 8964: @440251
     /* 440251 */ GIM_Try, /*On fail goto*//*Label 8995*/ GIMT_Encode4(440276), // Rule ID 9007 //
     /* 440256 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440259 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s1,
     /* 440262 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s1,
     /* 440265 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440269 */   // (AArch64zip2:{ *:[nxv4i1] } nxv4i1:{ *:[nxv4i1] }:$Op1, nxv4i1:{ *:[nxv4i1] }:$Op2)  =>  (ZIP2_PPP_S:{ *:[nxv4i1] } ?:{ *:[nxv4i1] }:$Op1, ?:{ *:[nxv4i1] }:$Op2)
     /* 440269 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_S),
     /* 440274 */   GIR_RootConstrainSelectedInstOperands,
     /* 440275 */   // GIR_Coverage, 9007,
     /* 440275 */   GIR_Done,
     /* 440276 */ // Label 8995: @440276
     /* 440276 */ GIM_Reject,
     /* 440277 */ // Label 8965: @440277
     /* 440277 */ GIM_Try, /*On fail goto*//*Label 8996*/ GIMT_Encode4(440302), // Rule ID 8961 //
     /* 440282 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440285 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s16,
     /* 440288 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s16,
     /* 440291 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440295 */   // (AArch64zip2:{ *:[nxv4f16] } nxv4f16:{ *:[nxv4f16] }:$Op1, nxv4f16:{ *:[nxv4f16] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f16] } ?:{ *:[nxv4f16] }:$Op1, ?:{ *:[nxv4f16] }:$Op2)
     /* 440295 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440300 */   GIR_RootConstrainSelectedInstOperands,
     /* 440301 */   // GIR_Coverage, 8961,
     /* 440301 */   GIR_Done,
     /* 440302 */ // Label 8996: @440302
     /* 440302 */ GIM_Reject,
     /* 440303 */ // Label 8966: @440303
     /* 440303 */ GIM_Try, /*On fail goto*//*Label 8997*/ GIMT_Encode4(440349),
     /* 440308 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv4s32,
     /* 440311 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv4s32,
     /* 440314 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440318 */   GIM_Try, /*On fail goto*//*Label 8998*/ GIMT_Encode4(440333), // Rule ID 8958 //
     /* 440323 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440326 */     // (AArch64zip2:{ *:[nxv4i32] } nxv4i32:{ *:[nxv4i32] }:$Op1, nxv4i32:{ *:[nxv4i32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4i32] } ?:{ *:[nxv4i32] }:$Op1, ?:{ *:[nxv4i32] }:$Op2)
     /* 440326 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440331 */     GIR_RootConstrainSelectedInstOperands,
     /* 440332 */     // GIR_Coverage, 8958,
     /* 440332 */     GIR_Done,
     /* 440333 */   // Label 8998: @440333
     /* 440333 */   GIM_Try, /*On fail goto*//*Label 8999*/ GIMT_Encode4(440348), // Rule ID 8962 //
     /* 440338 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440341 */     // (AArch64zip2:{ *:[nxv4f32] } nxv4f32:{ *:[nxv4f32] }:$Op1, nxv4f32:{ *:[nxv4f32] }:$Op2)  =>  (ZIP2_ZZZ_S:{ *:[nxv4f32] } ?:{ *:[nxv4f32] }:$Op1, ?:{ *:[nxv4f32] }:$Op2)
     /* 440341 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_S),
     /* 440346 */     GIR_RootConstrainSelectedInstOperands,
     /* 440347 */     // GIR_Coverage, 8962,
     /* 440347 */     GIR_Done,
     /* 440348 */   // Label 8999: @440348
     /* 440348 */   GIM_Reject,
     /* 440349 */ // Label 8997: @440349
     /* 440349 */ GIM_Reject,
     /* 440350 */ // Label 8967: @440350
     /* 440350 */ GIM_Try, /*On fail goto*//*Label 9000*/ GIMT_Encode4(440375), // Rule ID 9006 //
     /* 440355 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440358 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s1,
     /* 440361 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s1,
     /* 440364 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440368 */   // (AArch64zip2:{ *:[nxv8i1] } nxv8i1:{ *:[nxv8i1] }:$Op1, nxv8i1:{ *:[nxv8i1] }:$Op2)  =>  (ZIP2_PPP_H:{ *:[nxv8i1] } ?:{ *:[nxv8i1] }:$Op1, ?:{ *:[nxv8i1] }:$Op2)
     /* 440368 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_H),
     /* 440373 */   GIR_RootConstrainSelectedInstOperands,
     /* 440374 */   // GIR_Coverage, 9006,
     /* 440374 */   GIR_Done,
     /* 440375 */ // Label 9000: @440375
     /* 440375 */ GIM_Reject,
     /* 440376 */ // Label 8968: @440376
     /* 440376 */ GIM_Try, /*On fail goto*//*Label 9001*/ GIMT_Encode4(440422),
     /* 440381 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv8s16,
     /* 440384 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv8s16,
     /* 440387 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440391 */   GIM_Try, /*On fail goto*//*Label 9002*/ GIMT_Encode4(440406), // Rule ID 8957 //
     /* 440396 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440399 */     // (AArch64zip2:{ *:[nxv8i16] } nxv8i16:{ *:[nxv8i16] }:$Op1, nxv8i16:{ *:[nxv8i16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8i16] } ?:{ *:[nxv8i16] }:$Op1, ?:{ *:[nxv8i16] }:$Op2)
     /* 440399 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 440404 */     GIR_RootConstrainSelectedInstOperands,
     /* 440405 */     // GIR_Coverage, 8957,
     /* 440405 */     GIR_Done,
     /* 440406 */   // Label 9002: @440406
     /* 440406 */   GIM_Try, /*On fail goto*//*Label 9003*/ GIMT_Encode4(440421), // Rule ID 8960 //
     /* 440411 */     GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440414 */     // (AArch64zip2:{ *:[nxv8f16] } nxv8f16:{ *:[nxv8f16] }:$Op1, nxv8f16:{ *:[nxv8f16] }:$Op2)  =>  (ZIP2_ZZZ_H:{ *:[nxv8f16] } ?:{ *:[nxv8f16] }:$Op1, ?:{ *:[nxv8f16] }:$Op2)
     /* 440414 */     GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_H),
     /* 440419 */     GIR_RootConstrainSelectedInstOperands,
     /* 440420 */     // GIR_Coverage, 8960,
     /* 440420 */     GIR_Done,
     /* 440421 */   // Label 9003: @440421
     /* 440421 */   GIM_Reject,
     /* 440422 */ // Label 9001: @440422
     /* 440422 */ GIM_Reject,
     /* 440423 */ // Label 8969: @440423
     /* 440423 */ GIM_Try, /*On fail goto*//*Label 9004*/ GIMT_Encode4(440448), // Rule ID 2402 //
     /* 440428 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440431 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s1,
     /* 440434 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s1,
     /* 440437 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::PPRRegClassID),
     /* 440441 */   // (AArch64zip2:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)  =>  (ZIP2_PPP_B:{ *:[nxv16i1] } nxv16i1:{ *:[nxv16i1] }:$Pn, nxv16i1:{ *:[nxv16i1] }:$Pm)
     /* 440441 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_PPP_B),
     /* 440446 */   GIR_RootConstrainSelectedInstOperands,
     /* 440447 */   // GIR_Coverage, 2402,
     /* 440447 */   GIR_Done,
     /* 440448 */ // Label 9004: @440448
     /* 440448 */ GIM_Reject,
     /* 440449 */ // Label 8970: @440449
     /* 440449 */ GIM_Try, /*On fail goto*//*Label 9005*/ GIMT_Encode4(440474), // Rule ID 8956 //
     /* 440454 */   GIM_CheckFeatures, GIMT_Encode2(GIFBS_HasSVE_or_SME),
     /* 440457 */   GIM_RootCheckType, /*Op*/1, /*Type*/GILLT_nxv16s8,
     /* 440460 */   GIM_RootCheckType, /*Op*/2, /*Type*/GILLT_nxv16s8,
     /* 440463 */   GIM_RootCheckRegBankForClass, /*Op*/0, /*RC*/GIMT_Encode2(AArch64::ZPRRegClassID),
     /* 440467 */   // (AArch64zip2:{ *:[nxv16i8] } nxv16i8:{ *:[nxv16i8] }:$Op1, nxv16i8:{ *:[nxv16i8] }:$Op2)  =>  (ZIP2_ZZZ_B:{ *:[nxv16i8] } ?:{ *:[nxv16i8] }:$Op1, ?:{ *:[nxv16i8] }:$Op2)
     /* 440467 */   GIR_MutateOpcode, /*InsnID*/0, /*RecycleInsnID*/0, /*Opcode*/GIMT_Encode2(AArch64::ZIP2_ZZZ_B),
     /* 440472 */   GIR_RootConstrainSelectedInstOperands,
     /* 440473 */   // GIR_Coverage, 8956,
     /* 440473 */   GIR_Done,
     /* 440474 */ // Label 9005: @440474
     /* 440474 */ GIM_Reject,
     /* 440475 */ // Label 8971: @440475
     /* 440475 */ GIM_Reject,
     /* 440476 */ // Label 154: @440476
     /* 440476 */ GIM_Reject,
     /* 440477 */ }; // Size: 440477 bytes
  return MatchTable0;
}
#undef GIMT_Encode2
#undef GIMT_Encode4
#undef GIMT_Encode8

#endif // ifdef GET_GLOBALISEL_IMPL

#ifdef GET_GLOBALISEL_PREDICATES_DECL
PredicateBitset AvailableModuleFeatures;
mutable PredicateBitset AvailableFunctionFeatures;
PredicateBitset getAvailableFeatures() const {
  return AvailableModuleFeatures | AvailableFunctionFeatures;
}
PredicateBitset
computeAvailableModuleFeatures(const AArch64Subtarget *Subtarget) const;
PredicateBitset
computeAvailableFunctionFeatures(const AArch64Subtarget *Subtarget,
                                 const MachineFunction *MF) const;
void setupGeneratedPerFunctionState(MachineFunction &MF) override;
#endif // ifdef GET_GLOBALISEL_PREDICATES_DECL
#ifdef GET_GLOBALISEL_PREDICATES_INIT
AvailableModuleFeatures(computeAvailableModuleFeatures(&STI)),
AvailableFunctionFeatures()
#endif // ifdef GET_GLOBALISEL_PREDICATES_INIT
